encapsulated package CodegenCppInit
"
  file:        CodegenCppInit.mo
  package:     CodegenCppInit
  description: Generated by Susan.
"

public import Tpl;

public import SimCodeVar;
public import SimCode;
public import SimCodeFunction;
public import SimCodeUtil;
public import BackendDAE;
public import System;
public import Absyn;
public import DAE;
public import ClassInf;
public import Util;
public import List;
public import Expression;
public import Settings;
public import Types;
public import HashTableCrIListArray;
public import FMI;
public import CodegenUtil;
protected import CodegenCppCommon;
protected import CodegenFMUCommon;
protected import CodegenFMU2;

protected function fun_48
  input Tpl.Text in_txt;
  input Boolean in_a_generateFMUModelDescription;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_generateFMUModelDescription)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("ModelDescription"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("fmiModelDescription"));
      then txt;
  end match;
end fun_48;

protected function fun_49
  input Tpl.Text in_txt;
  input Boolean in_a_generateFMUModelDescription;
  input String in_a_FMUGuid;
  input String in_a_FMUType;
  input String in_a_FMUVersion;
  input SimCode.SimCode in_a_simCode;
  input Absyn.Path in_a_modelInfo_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_generateFMUModelDescription, in_a_FMUGuid, in_a_FMUType, in_a_FMUVersion, in_a_simCode, in_a_modelInfo_name)
    local
      Tpl.Text txt;
      String a_FMUGuid;
      String a_FMUType;
      String a_FMUVersion;
      SimCode.SimCode a_simCode;
      Absyn.Path a_modelInfo_name;

    case ( txt,
           false,
           _,
           _,
           _,
           _,
           a_modelInfo_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelName=\""));
        txt = CodegenUtil.dotPath(txt, a_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
      then txt;

    case ( txt,
           _,
           a_FMUGuid,
           a_FMUType,
           a_FMUVersion,
           a_simCode,
           _ )
      equation
        txt = fmiDescriptionAttributes(txt, a_simCode, a_FMUVersion, a_FMUType, a_FMUGuid);
      then txt;
  end match;
end fun_49;

protected function fun_50
  input Tpl.Text in_txt;
  input Boolean in_a_generateFMUModelDescription;
  input String in_a_FMUVersion;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_generateFMUModelDescription, in_a_FMUVersion, in_a_simCode)
    local
      Tpl.Text txt;
      String a_FMUVersion;
      SimCode.SimCode a_simCode;

    case ( txt,
           false,
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_FMUVersion,
           a_simCode )
      equation
        txt = CodegenFMUCommon.fmiTypeDefinitions(txt, a_simCode, a_FMUVersion);
      then txt;
  end match;
end fun_50;

protected function fun_51
  input Tpl.Text in_txt;
  input Boolean in_a_generateFMUModelDescription;
  input Option<SimCode.SimulationSettings> in_a_simulationSettingsOpt;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_generateFMUModelDescription, in_a_simulationSettingsOpt)
    local
      Tpl.Text txt;
      Option<SimCode.SimulationSettings> a_simulationSettingsOpt;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_simulationSettingsOpt )
      equation
        txt = CodegenFMUCommon.DefaultExperiment(txt, a_simulationSettingsOpt);
      then txt;
  end match;
end fun_51;

public function modelInitXMLFile
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input String in_a_numRealVars;
  input String in_a_numIntVars;
  input String in_a_numBoolVars;
  input String in_a_numStringVars;
  input String in_a_FMUVersion;
  input String in_a_FMUType;
  input String in_a_FMUGuid;
  input Boolean in_a_generateFMUModelDescription;
  input String in_a_generatorComments;
  input Tpl.Text in_a_complexStartExpressions;
  input Tpl.Text in_a_stateDerVectorName;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_complexStartExpressions;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_complexStartExpressions, out_a_stateDerVectorName) :=
  match(in_txt, in_a_simCode, in_a_numRealVars, in_a_numIntVars, in_a_numBoolVars, in_a_numStringVars, in_a_FMUVersion, in_a_FMUType, in_a_FMUGuid, in_a_generateFMUModelDescription, in_a_generatorComments, in_a_complexStartExpressions, in_a_stateDerVectorName)
    local
      Tpl.Text txt;
      String a_numRealVars;
      String a_numIntVars;
      String a_numBoolVars;
      String a_numStringVars;
      String a_FMUVersion;
      String a_FMUType;
      String a_FMUGuid;
      Boolean a_generateFMUModelDescription;
      String a_generatorComments;
      Tpl.Text a_complexStartExpressions;
      Tpl.Text a_stateDerVectorName;
      Option<SimCode.SimulationSettings> i_simulationSettingsOpt;
      Absyn.Path i_modelInfo_name;
      HashTableCrIListArray.HashTable i_varToArrayIndexMapping;
      SimCode.ModelInfo i_modelInfo;
      SimCode.SimCode i_simCode;
      Tpl.Text l_fmiDefaultExperiment;
      Tpl.Text l_fmiTypeDefinitions;
      Tpl.Text l_fmiDescriptionAttributes;
      Tpl.Text l_descriptionTag;
      Tpl.Text txt_4;
      Tpl.Text txt_3;
      Tpl.Text txt_2;
      Tpl.Text txt_1;
      Tpl.Text l_variables;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = (i_modelInfo as SimCode.MODELINFO(name = i_modelInfo_name)), varToArrayIndexMapping = i_varToArrayIndexMapping, simulationSettingsOpt = i_simulationSettingsOpt)),
           a_numRealVars,
           a_numIntVars,
           a_numBoolVars,
           a_numStringVars,
           a_FMUVersion,
           a_FMUType,
           a_FMUGuid,
           a_generateFMUModelDescription,
           a_generatorComments,
           a_complexStartExpressions,
           a_stateDerVectorName )
      equation
        txt_1 = Tpl.writeStr(Tpl.emptyTxt, a_numRealVars);
        txt_1 = Tpl.writeTok(txt_1, Tpl.ST_STRING(" - 1"));
        txt_2 = Tpl.writeStr(Tpl.emptyTxt, a_numIntVars);
        txt_2 = Tpl.writeTok(txt_2, Tpl.ST_STRING(" - 1"));
        txt_3 = Tpl.writeStr(Tpl.emptyTxt, a_numBoolVars);
        txt_3 = Tpl.writeTok(txt_3, Tpl.ST_STRING(" - 1"));
        txt_4 = Tpl.writeStr(Tpl.emptyTxt, a_numStringVars);
        txt_4 = Tpl.writeTok(txt_4, Tpl.ST_STRING(" - 1"));
        (l_variables, a_complexStartExpressions, a_stateDerVectorName) = modelVariablesXML(Tpl.emptyTxt, i_simCode, i_modelInfo, i_varToArrayIndexMapping, Tpl.textString(txt_1), Tpl.textString(txt_2), Tpl.textString(txt_3), Tpl.textString(txt_4), a_generateFMUModelDescription, a_complexStartExpressions, a_stateDerVectorName);
        l_descriptionTag = fun_48(Tpl.emptyTxt, a_generateFMUModelDescription);
        l_fmiDescriptionAttributes = fun_49(Tpl.emptyTxt, a_generateFMUModelDescription, a_FMUGuid, a_FMUType, a_FMUVersion, i_simCode, i_modelInfo_name);
        l_fmiTypeDefinitions = fun_50(Tpl.emptyTxt, a_generateFMUModelDescription, a_FMUVersion, i_simCode);
        l_fmiDefaultExperiment = fun_51(Tpl.emptyTxt, a_generateFMUModelDescription, i_simulationSettingsOpt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n",
                                    "<!--Generated with the modifications: "
                                }, false));
        txt = Tpl.writeStr(txt, a_generatorComments);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " -->\n",
                                    "<!--Take care about array indices, they are stored in column major layout.-->\n",
                                    "<"
                                }, false));
        txt = Tpl.writeText(txt, l_descriptionTag);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, l_fmiDescriptionAttributes);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(">\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_fmiTypeDefinitions);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_fmiDefaultExperiment);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("<ModelVariables>\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_variables);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("</ModelVariables>\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("</"));
        txt = Tpl.writeText(txt, l_descriptionTag);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(">"));
      then (txt, a_complexStartExpressions, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           _,
           _,
           _,
           _,
           _,
           _,
           _,
           _,
           a_complexStartExpressions,
           a_stateDerVectorName )
      then (txt, a_complexStartExpressions, a_stateDerVectorName);
  end match;
end modelInitXMLFile;

protected function fun_53
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input SimCode.SimCode in_a_simCode;
  input String in_a_FMUGuid;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_simCode, in_a_FMUGuid)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      String a_FMUGuid;

    case ( txt,
           false,
           a_simCode,
           a_FMUGuid )
      equation
        txt = fmiModelDescriptionAttributes(txt, a_simCode, a_FMUGuid);
      then txt;

    case ( txt,
           _,
           a_simCode,
           a_FMUGuid )
      equation
        txt = CodegenFMU2.fmiModelDescriptionAttributes(txt, a_simCode, a_FMUGuid);
      then txt;
  end match;
end fun_53;

public function fmiDescriptionAttributes
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input String a_FMUVersion;
  input String a_FMUType;
  input String a_FMUGuid;

  output Tpl.Text out_txt;
protected
  Boolean ret_0;
algorithm
  ret_0 := FMI.isFMIVersion20(a_FMUVersion);
  out_txt := fun_53(txt, ret_0, a_simCode, a_FMUGuid);
end fmiDescriptionAttributes;

public function fmiModelDescriptionAttributes
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input String in_a_guid;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode, in_a_guid)
    local
      Tpl.Text txt;
      String a_guid;
      SimCode.SimCode i_simCode;
      Integer i_vi_numStateVars;
      String i_fileNamePrefix;
      Absyn.Path i_modelInfo_name;
      Tpl.Text l_numberOfEventIndicators;
      Tpl.Text l_numberOfContinuousStates;
      Tpl.Text l_variableNamingConvention;
      Util.DateTime ret_12;
      Tpl.Text l_generationDateAndTime;
      String ret_10;
      Tpl.Text l_generationTool;
      Tpl.Text l_version;
      Tpl.Text l_author;
      Tpl.Text l_description;
      String ret_5;
      Tpl.Text l_modelIdentifier;
      String ret_3;
      Tpl.Text txt_2;
      Tpl.Text l_modelName;
      Tpl.Text l_fmiVersion;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(varInfo = SimCode.VARINFO(numStateVars = i_vi_numStateVars), vars = SimCodeVar.SIMVARS(stateVars = _), name = i_modelInfo_name), fileNamePrefix = i_fileNamePrefix)),
           a_guid )
      equation
        l_fmiVersion = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("1.0"));
        txt_2 = CodegenUtil.dotPath(Tpl.emptyTxt, i_modelInfo_name);
        ret_3 = System.stringReplace(Tpl.textString(txt_2), "$", "_D_");
        l_modelName = Tpl.writeStr(Tpl.emptyTxt, ret_3);
        ret_5 = System.stringReplace(i_fileNamePrefix, ".", "_");
        l_modelIdentifier = Tpl.writeStr(Tpl.emptyTxt, ret_5);
        l_description = Tpl.emptyTxt;
        l_author = Tpl.emptyTxt;
        l_version = Tpl.emptyTxt;
        l_generationTool = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("OpenModelica Compiler "));
        ret_10 = Settings.getVersionNr();
        l_generationTool = Tpl.writeStr(l_generationTool, ret_10);
        ret_12 = Util.getCurrentDateTime();
        l_generationDateAndTime = CodegenFMUCommon.xsdateTime(Tpl.emptyTxt, ret_12);
        l_variableNamingConvention = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("structured"));
        l_numberOfContinuousStates = Tpl.writeStr(Tpl.emptyTxt, intString(i_vi_numStateVars));
        l_numberOfEventIndicators = CodegenFMUCommon.getNumberOfEventIndicators(Tpl.emptyTxt, i_simCode);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("fmiVersion=\""));
        txt = Tpl.writeText(txt, l_fmiVersion);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\"\n",
                                    "modelName=\""
                                }, false));
        txt = Tpl.writeText(txt, l_modelName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\"\n",
                                    "modelIdentifier=\""
                                }, false));
        txt = Tpl.writeText(txt, l_modelIdentifier);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\"\n",
                                    "guid=\"{"
                                }, false));
        txt = Tpl.writeStr(txt, a_guid);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\"\n",
                                    "generationTool=\""
                                }, false));
        txt = Tpl.writeText(txt, l_generationTool);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\"\n",
                                    "generationDateAndTime=\""
                                }, false));
        txt = Tpl.writeText(txt, l_generationDateAndTime);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\"\n",
                                    "variableNamingConvention=\""
                                }, false));
        txt = Tpl.writeText(txt, l_variableNamingConvention);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\"\n",
                                    "numberOfContinuousStates=\""
                                }, false));
        txt = Tpl.writeText(txt, l_numberOfContinuousStates);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\"\n",
                                    "numberOfEventIndicators=\""
                                }, false));
        txt = Tpl.writeText(txt, l_numberOfEventIndicators);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fmiModelDescriptionAttributes;

protected function lm_56
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_complexStartExpressions;
  input Boolean in_a_generateFMUModelDescription;
  input String in_a_indexForUndefinedReferencesReal;
  input HashTableCrIListArray.HashTable in_a_varToArrayIndexMapping;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_complexStartExpressions;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_complexStartExpressions) :=
  match(in_txt, in_items, in_a_stateDerVectorName, in_a_complexStartExpressions, in_a_generateFMUModelDescription, in_a_indexForUndefinedReferencesReal, in_a_varToArrayIndexMapping, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_complexStartExpressions;
      Boolean a_generateFMUModelDescription;
      String a_indexForUndefinedReferencesReal;
      HashTableCrIListArray.HashTable a_varToArrayIndexMapping;
      SimCode.SimCode a_simCode;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           a_stateDerVectorName,
           a_complexStartExpressions,
           _,
           _,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_complexStartExpressions);

    case ( txt,
           i_var :: rest,
           a_stateDerVectorName,
           a_complexStartExpressions,
           a_generateFMUModelDescription,
           a_indexForUndefinedReferencesReal,
           a_varToArrayIndexMapping,
           a_simCode )
      equation
        (txt, a_complexStartExpressions, a_stateDerVectorName) = scalarVariableXML(txt, a_simCode, i_var, a_varToArrayIndexMapping, a_indexForUndefinedReferencesReal, a_generateFMUModelDescription, a_complexStartExpressions, a_stateDerVectorName);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_complexStartExpressions) = lm_56(txt, rest, a_stateDerVectorName, a_complexStartExpressions, a_generateFMUModelDescription, a_indexForUndefinedReferencesReal, a_varToArrayIndexMapping, a_simCode);
      then (txt, a_stateDerVectorName, a_complexStartExpressions);
  end match;
end lm_56;

protected function lm_57
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_complexStartExpressions;
  input Boolean in_a_generateFMUModelDescription;
  input String in_a_indexForUndefinedReferencesReal;
  input HashTableCrIListArray.HashTable in_a_varToArrayIndexMapping;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_complexStartExpressions;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_complexStartExpressions) :=
  match(in_txt, in_items, in_a_stateDerVectorName, in_a_complexStartExpressions, in_a_generateFMUModelDescription, in_a_indexForUndefinedReferencesReal, in_a_varToArrayIndexMapping, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_complexStartExpressions;
      Boolean a_generateFMUModelDescription;
      String a_indexForUndefinedReferencesReal;
      HashTableCrIListArray.HashTable a_varToArrayIndexMapping;
      SimCode.SimCode a_simCode;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           a_stateDerVectorName,
           a_complexStartExpressions,
           _,
           _,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_complexStartExpressions);

    case ( txt,
           i_var :: rest,
           a_stateDerVectorName,
           a_complexStartExpressions,
           a_generateFMUModelDescription,
           a_indexForUndefinedReferencesReal,
           a_varToArrayIndexMapping,
           a_simCode )
      equation
        (txt, a_complexStartExpressions, a_stateDerVectorName) = scalarVariableXML(txt, a_simCode, i_var, a_varToArrayIndexMapping, a_indexForUndefinedReferencesReal, a_generateFMUModelDescription, a_complexStartExpressions, a_stateDerVectorName);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_complexStartExpressions) = lm_57(txt, rest, a_stateDerVectorName, a_complexStartExpressions, a_generateFMUModelDescription, a_indexForUndefinedReferencesReal, a_varToArrayIndexMapping, a_simCode);
      then (txt, a_stateDerVectorName, a_complexStartExpressions);
  end match;
end lm_57;

protected function lm_58
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_complexStartExpressions;
  input Boolean in_a_generateFMUModelDescription;
  input String in_a_indexForUndefinedReferencesReal;
  input HashTableCrIListArray.HashTable in_a_varToArrayIndexMapping;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_complexStartExpressions;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_complexStartExpressions) :=
  match(in_txt, in_items, in_a_stateDerVectorName, in_a_complexStartExpressions, in_a_generateFMUModelDescription, in_a_indexForUndefinedReferencesReal, in_a_varToArrayIndexMapping, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_complexStartExpressions;
      Boolean a_generateFMUModelDescription;
      String a_indexForUndefinedReferencesReal;
      HashTableCrIListArray.HashTable a_varToArrayIndexMapping;
      SimCode.SimCode a_simCode;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           a_stateDerVectorName,
           a_complexStartExpressions,
           _,
           _,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_complexStartExpressions);

    case ( txt,
           i_var :: rest,
           a_stateDerVectorName,
           a_complexStartExpressions,
           a_generateFMUModelDescription,
           a_indexForUndefinedReferencesReal,
           a_varToArrayIndexMapping,
           a_simCode )
      equation
        (txt, a_complexStartExpressions, a_stateDerVectorName) = scalarVariableXML(txt, a_simCode, i_var, a_varToArrayIndexMapping, a_indexForUndefinedReferencesReal, a_generateFMUModelDescription, a_complexStartExpressions, a_stateDerVectorName);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_complexStartExpressions) = lm_58(txt, rest, a_stateDerVectorName, a_complexStartExpressions, a_generateFMUModelDescription, a_indexForUndefinedReferencesReal, a_varToArrayIndexMapping, a_simCode);
      then (txt, a_stateDerVectorName, a_complexStartExpressions);
  end match;
end lm_58;

protected function lm_59
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_complexStartExpressions;
  input Boolean in_a_generateFMUModelDescription;
  input String in_a_indexForUndefinedReferencesReal;
  input HashTableCrIListArray.HashTable in_a_varToArrayIndexMapping;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_complexStartExpressions;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_complexStartExpressions) :=
  match(in_txt, in_items, in_a_stateDerVectorName, in_a_complexStartExpressions, in_a_generateFMUModelDescription, in_a_indexForUndefinedReferencesReal, in_a_varToArrayIndexMapping, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_complexStartExpressions;
      Boolean a_generateFMUModelDescription;
      String a_indexForUndefinedReferencesReal;
      HashTableCrIListArray.HashTable a_varToArrayIndexMapping;
      SimCode.SimCode a_simCode;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           a_stateDerVectorName,
           a_complexStartExpressions,
           _,
           _,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_complexStartExpressions);

    case ( txt,
           i_var :: rest,
           a_stateDerVectorName,
           a_complexStartExpressions,
           a_generateFMUModelDescription,
           a_indexForUndefinedReferencesReal,
           a_varToArrayIndexMapping,
           a_simCode )
      equation
        (txt, a_complexStartExpressions, a_stateDerVectorName) = scalarVariableXML(txt, a_simCode, i_var, a_varToArrayIndexMapping, a_indexForUndefinedReferencesReal, a_generateFMUModelDescription, a_complexStartExpressions, a_stateDerVectorName);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_complexStartExpressions) = lm_59(txt, rest, a_stateDerVectorName, a_complexStartExpressions, a_generateFMUModelDescription, a_indexForUndefinedReferencesReal, a_varToArrayIndexMapping, a_simCode);
      then (txt, a_stateDerVectorName, a_complexStartExpressions);
  end match;
end lm_59;

protected function lm_60
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_complexStartExpressions;
  input Boolean in_a_generateFMUModelDescription;
  input String in_a_indexForUndefinedReferencesReal;
  input HashTableCrIListArray.HashTable in_a_varToArrayIndexMapping;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_complexStartExpressions;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_complexStartExpressions) :=
  match(in_txt, in_items, in_a_stateDerVectorName, in_a_complexStartExpressions, in_a_generateFMUModelDescription, in_a_indexForUndefinedReferencesReal, in_a_varToArrayIndexMapping, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_complexStartExpressions;
      Boolean a_generateFMUModelDescription;
      String a_indexForUndefinedReferencesReal;
      HashTableCrIListArray.HashTable a_varToArrayIndexMapping;
      SimCode.SimCode a_simCode;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           a_stateDerVectorName,
           a_complexStartExpressions,
           _,
           _,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_complexStartExpressions);

    case ( txt,
           i_var :: rest,
           a_stateDerVectorName,
           a_complexStartExpressions,
           a_generateFMUModelDescription,
           a_indexForUndefinedReferencesReal,
           a_varToArrayIndexMapping,
           a_simCode )
      equation
        (txt, a_complexStartExpressions, a_stateDerVectorName) = scalarVariableXML(txt, a_simCode, i_var, a_varToArrayIndexMapping, a_indexForUndefinedReferencesReal, a_generateFMUModelDescription, a_complexStartExpressions, a_stateDerVectorName);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_complexStartExpressions) = lm_60(txt, rest, a_stateDerVectorName, a_complexStartExpressions, a_generateFMUModelDescription, a_indexForUndefinedReferencesReal, a_varToArrayIndexMapping, a_simCode);
      then (txt, a_stateDerVectorName, a_complexStartExpressions);
  end match;
end lm_60;

protected function lm_61
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_complexStartExpressions;
  input Boolean in_a_generateFMUModelDescription;
  input String in_a_indexForUndefinedReferencesReal;
  input HashTableCrIListArray.HashTable in_a_varToArrayIndexMapping;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_complexStartExpressions;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_complexStartExpressions) :=
  match(in_txt, in_items, in_a_stateDerVectorName, in_a_complexStartExpressions, in_a_generateFMUModelDescription, in_a_indexForUndefinedReferencesReal, in_a_varToArrayIndexMapping, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_complexStartExpressions;
      Boolean a_generateFMUModelDescription;
      String a_indexForUndefinedReferencesReal;
      HashTableCrIListArray.HashTable a_varToArrayIndexMapping;
      SimCode.SimCode a_simCode;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           a_stateDerVectorName,
           a_complexStartExpressions,
           _,
           _,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_complexStartExpressions);

    case ( txt,
           i_var :: rest,
           a_stateDerVectorName,
           a_complexStartExpressions,
           a_generateFMUModelDescription,
           a_indexForUndefinedReferencesReal,
           a_varToArrayIndexMapping,
           a_simCode )
      equation
        (txt, a_complexStartExpressions, a_stateDerVectorName) = scalarVariableXML(txt, a_simCode, i_var, a_varToArrayIndexMapping, a_indexForUndefinedReferencesReal, a_generateFMUModelDescription, a_complexStartExpressions, a_stateDerVectorName);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_complexStartExpressions) = lm_61(txt, rest, a_stateDerVectorName, a_complexStartExpressions, a_generateFMUModelDescription, a_indexForUndefinedReferencesReal, a_varToArrayIndexMapping, a_simCode);
      then (txt, a_stateDerVectorName, a_complexStartExpressions);
  end match;
end lm_61;

protected function lm_62
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_complexStartExpressions;
  input Boolean in_a_generateFMUModelDescription;
  input String in_a_indexForUndefinedReferencesInt;
  input HashTableCrIListArray.HashTable in_a_varToArrayIndexMapping;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_complexStartExpressions;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_complexStartExpressions) :=
  match(in_txt, in_items, in_a_stateDerVectorName, in_a_complexStartExpressions, in_a_generateFMUModelDescription, in_a_indexForUndefinedReferencesInt, in_a_varToArrayIndexMapping, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_complexStartExpressions;
      Boolean a_generateFMUModelDescription;
      String a_indexForUndefinedReferencesInt;
      HashTableCrIListArray.HashTable a_varToArrayIndexMapping;
      SimCode.SimCode a_simCode;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           a_stateDerVectorName,
           a_complexStartExpressions,
           _,
           _,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_complexStartExpressions);

    case ( txt,
           i_var :: rest,
           a_stateDerVectorName,
           a_complexStartExpressions,
           a_generateFMUModelDescription,
           a_indexForUndefinedReferencesInt,
           a_varToArrayIndexMapping,
           a_simCode )
      equation
        (txt, a_complexStartExpressions, a_stateDerVectorName) = scalarVariableXML(txt, a_simCode, i_var, a_varToArrayIndexMapping, a_indexForUndefinedReferencesInt, a_generateFMUModelDescription, a_complexStartExpressions, a_stateDerVectorName);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_complexStartExpressions) = lm_62(txt, rest, a_stateDerVectorName, a_complexStartExpressions, a_generateFMUModelDescription, a_indexForUndefinedReferencesInt, a_varToArrayIndexMapping, a_simCode);
      then (txt, a_stateDerVectorName, a_complexStartExpressions);
  end match;
end lm_62;

protected function lm_63
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_complexStartExpressions;
  input Boolean in_a_generateFMUModelDescription;
  input String in_a_indexForUndefinedReferencesInt;
  input HashTableCrIListArray.HashTable in_a_varToArrayIndexMapping;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_complexStartExpressions;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_complexStartExpressions) :=
  match(in_txt, in_items, in_a_stateDerVectorName, in_a_complexStartExpressions, in_a_generateFMUModelDescription, in_a_indexForUndefinedReferencesInt, in_a_varToArrayIndexMapping, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_complexStartExpressions;
      Boolean a_generateFMUModelDescription;
      String a_indexForUndefinedReferencesInt;
      HashTableCrIListArray.HashTable a_varToArrayIndexMapping;
      SimCode.SimCode a_simCode;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           a_stateDerVectorName,
           a_complexStartExpressions,
           _,
           _,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_complexStartExpressions);

    case ( txt,
           i_var :: rest,
           a_stateDerVectorName,
           a_complexStartExpressions,
           a_generateFMUModelDescription,
           a_indexForUndefinedReferencesInt,
           a_varToArrayIndexMapping,
           a_simCode )
      equation
        (txt, a_complexStartExpressions, a_stateDerVectorName) = scalarVariableXML(txt, a_simCode, i_var, a_varToArrayIndexMapping, a_indexForUndefinedReferencesInt, a_generateFMUModelDescription, a_complexStartExpressions, a_stateDerVectorName);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_complexStartExpressions) = lm_63(txt, rest, a_stateDerVectorName, a_complexStartExpressions, a_generateFMUModelDescription, a_indexForUndefinedReferencesInt, a_varToArrayIndexMapping, a_simCode);
      then (txt, a_stateDerVectorName, a_complexStartExpressions);
  end match;
end lm_63;

protected function lm_64
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_complexStartExpressions;
  input Boolean in_a_generateFMUModelDescription;
  input String in_a_indexForUndefinedReferencesInt;
  input HashTableCrIListArray.HashTable in_a_varToArrayIndexMapping;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_complexStartExpressions;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_complexStartExpressions) :=
  match(in_txt, in_items, in_a_stateDerVectorName, in_a_complexStartExpressions, in_a_generateFMUModelDescription, in_a_indexForUndefinedReferencesInt, in_a_varToArrayIndexMapping, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_complexStartExpressions;
      Boolean a_generateFMUModelDescription;
      String a_indexForUndefinedReferencesInt;
      HashTableCrIListArray.HashTable a_varToArrayIndexMapping;
      SimCode.SimCode a_simCode;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           a_stateDerVectorName,
           a_complexStartExpressions,
           _,
           _,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_complexStartExpressions);

    case ( txt,
           i_var :: rest,
           a_stateDerVectorName,
           a_complexStartExpressions,
           a_generateFMUModelDescription,
           a_indexForUndefinedReferencesInt,
           a_varToArrayIndexMapping,
           a_simCode )
      equation
        (txt, a_complexStartExpressions, a_stateDerVectorName) = scalarVariableXML(txt, a_simCode, i_var, a_varToArrayIndexMapping, a_indexForUndefinedReferencesInt, a_generateFMUModelDescription, a_complexStartExpressions, a_stateDerVectorName);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_complexStartExpressions) = lm_64(txt, rest, a_stateDerVectorName, a_complexStartExpressions, a_generateFMUModelDescription, a_indexForUndefinedReferencesInt, a_varToArrayIndexMapping, a_simCode);
      then (txt, a_stateDerVectorName, a_complexStartExpressions);
  end match;
end lm_64;

protected function lm_65
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_complexStartExpressions;
  input Boolean in_a_generateFMUModelDescription;
  input String in_a_indexForUndefinedReferencesBool;
  input HashTableCrIListArray.HashTable in_a_varToArrayIndexMapping;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_complexStartExpressions;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_complexStartExpressions) :=
  match(in_txt, in_items, in_a_stateDerVectorName, in_a_complexStartExpressions, in_a_generateFMUModelDescription, in_a_indexForUndefinedReferencesBool, in_a_varToArrayIndexMapping, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_complexStartExpressions;
      Boolean a_generateFMUModelDescription;
      String a_indexForUndefinedReferencesBool;
      HashTableCrIListArray.HashTable a_varToArrayIndexMapping;
      SimCode.SimCode a_simCode;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           a_stateDerVectorName,
           a_complexStartExpressions,
           _,
           _,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_complexStartExpressions);

    case ( txt,
           i_var :: rest,
           a_stateDerVectorName,
           a_complexStartExpressions,
           a_generateFMUModelDescription,
           a_indexForUndefinedReferencesBool,
           a_varToArrayIndexMapping,
           a_simCode )
      equation
        (txt, a_complexStartExpressions, a_stateDerVectorName) = scalarVariableXML(txt, a_simCode, i_var, a_varToArrayIndexMapping, a_indexForUndefinedReferencesBool, a_generateFMUModelDescription, a_complexStartExpressions, a_stateDerVectorName);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_complexStartExpressions) = lm_65(txt, rest, a_stateDerVectorName, a_complexStartExpressions, a_generateFMUModelDescription, a_indexForUndefinedReferencesBool, a_varToArrayIndexMapping, a_simCode);
      then (txt, a_stateDerVectorName, a_complexStartExpressions);
  end match;
end lm_65;

protected function lm_66
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_complexStartExpressions;
  input Boolean in_a_generateFMUModelDescription;
  input String in_a_indexForUndefinedReferencesBool;
  input HashTableCrIListArray.HashTable in_a_varToArrayIndexMapping;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_complexStartExpressions;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_complexStartExpressions) :=
  match(in_txt, in_items, in_a_stateDerVectorName, in_a_complexStartExpressions, in_a_generateFMUModelDescription, in_a_indexForUndefinedReferencesBool, in_a_varToArrayIndexMapping, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_complexStartExpressions;
      Boolean a_generateFMUModelDescription;
      String a_indexForUndefinedReferencesBool;
      HashTableCrIListArray.HashTable a_varToArrayIndexMapping;
      SimCode.SimCode a_simCode;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           a_stateDerVectorName,
           a_complexStartExpressions,
           _,
           _,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_complexStartExpressions);

    case ( txt,
           i_var :: rest,
           a_stateDerVectorName,
           a_complexStartExpressions,
           a_generateFMUModelDescription,
           a_indexForUndefinedReferencesBool,
           a_varToArrayIndexMapping,
           a_simCode )
      equation
        (txt, a_complexStartExpressions, a_stateDerVectorName) = scalarVariableXML(txt, a_simCode, i_var, a_varToArrayIndexMapping, a_indexForUndefinedReferencesBool, a_generateFMUModelDescription, a_complexStartExpressions, a_stateDerVectorName);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_complexStartExpressions) = lm_66(txt, rest, a_stateDerVectorName, a_complexStartExpressions, a_generateFMUModelDescription, a_indexForUndefinedReferencesBool, a_varToArrayIndexMapping, a_simCode);
      then (txt, a_stateDerVectorName, a_complexStartExpressions);
  end match;
end lm_66;

protected function lm_67
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_complexStartExpressions;
  input Boolean in_a_generateFMUModelDescription;
  input String in_a_indexForUndefinedReferencesBool;
  input HashTableCrIListArray.HashTable in_a_varToArrayIndexMapping;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_complexStartExpressions;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_complexStartExpressions) :=
  match(in_txt, in_items, in_a_stateDerVectorName, in_a_complexStartExpressions, in_a_generateFMUModelDescription, in_a_indexForUndefinedReferencesBool, in_a_varToArrayIndexMapping, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_complexStartExpressions;
      Boolean a_generateFMUModelDescription;
      String a_indexForUndefinedReferencesBool;
      HashTableCrIListArray.HashTable a_varToArrayIndexMapping;
      SimCode.SimCode a_simCode;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           a_stateDerVectorName,
           a_complexStartExpressions,
           _,
           _,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_complexStartExpressions);

    case ( txt,
           i_var :: rest,
           a_stateDerVectorName,
           a_complexStartExpressions,
           a_generateFMUModelDescription,
           a_indexForUndefinedReferencesBool,
           a_varToArrayIndexMapping,
           a_simCode )
      equation
        (txt, a_complexStartExpressions, a_stateDerVectorName) = scalarVariableXML(txt, a_simCode, i_var, a_varToArrayIndexMapping, a_indexForUndefinedReferencesBool, a_generateFMUModelDescription, a_complexStartExpressions, a_stateDerVectorName);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_complexStartExpressions) = lm_67(txt, rest, a_stateDerVectorName, a_complexStartExpressions, a_generateFMUModelDescription, a_indexForUndefinedReferencesBool, a_varToArrayIndexMapping, a_simCode);
      then (txt, a_stateDerVectorName, a_complexStartExpressions);
  end match;
end lm_67;

protected function lm_68
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_complexStartExpressions;
  input Boolean in_a_generateFMUModelDescription;
  input String in_a_indexForUndefinedReferencesString;
  input HashTableCrIListArray.HashTable in_a_varToArrayIndexMapping;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_complexStartExpressions;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_complexStartExpressions) :=
  match(in_txt, in_items, in_a_stateDerVectorName, in_a_complexStartExpressions, in_a_generateFMUModelDescription, in_a_indexForUndefinedReferencesString, in_a_varToArrayIndexMapping, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_complexStartExpressions;
      Boolean a_generateFMUModelDescription;
      String a_indexForUndefinedReferencesString;
      HashTableCrIListArray.HashTable a_varToArrayIndexMapping;
      SimCode.SimCode a_simCode;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           a_stateDerVectorName,
           a_complexStartExpressions,
           _,
           _,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_complexStartExpressions);

    case ( txt,
           i_var :: rest,
           a_stateDerVectorName,
           a_complexStartExpressions,
           a_generateFMUModelDescription,
           a_indexForUndefinedReferencesString,
           a_varToArrayIndexMapping,
           a_simCode )
      equation
        (txt, a_complexStartExpressions, a_stateDerVectorName) = scalarVariableXML(txt, a_simCode, i_var, a_varToArrayIndexMapping, a_indexForUndefinedReferencesString, a_generateFMUModelDescription, a_complexStartExpressions, a_stateDerVectorName);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_complexStartExpressions) = lm_68(txt, rest, a_stateDerVectorName, a_complexStartExpressions, a_generateFMUModelDescription, a_indexForUndefinedReferencesString, a_varToArrayIndexMapping, a_simCode);
      then (txt, a_stateDerVectorName, a_complexStartExpressions);
  end match;
end lm_68;

protected function lm_69
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_complexStartExpressions;
  input Boolean in_a_generateFMUModelDescription;
  input String in_a_indexForUndefinedReferencesString;
  input HashTableCrIListArray.HashTable in_a_varToArrayIndexMapping;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_complexStartExpressions;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_complexStartExpressions) :=
  match(in_txt, in_items, in_a_stateDerVectorName, in_a_complexStartExpressions, in_a_generateFMUModelDescription, in_a_indexForUndefinedReferencesString, in_a_varToArrayIndexMapping, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_complexStartExpressions;
      Boolean a_generateFMUModelDescription;
      String a_indexForUndefinedReferencesString;
      HashTableCrIListArray.HashTable a_varToArrayIndexMapping;
      SimCode.SimCode a_simCode;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           a_stateDerVectorName,
           a_complexStartExpressions,
           _,
           _,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_complexStartExpressions);

    case ( txt,
           i_var :: rest,
           a_stateDerVectorName,
           a_complexStartExpressions,
           a_generateFMUModelDescription,
           a_indexForUndefinedReferencesString,
           a_varToArrayIndexMapping,
           a_simCode )
      equation
        (txt, a_complexStartExpressions, a_stateDerVectorName) = scalarVariableXML(txt, a_simCode, i_var, a_varToArrayIndexMapping, a_indexForUndefinedReferencesString, a_generateFMUModelDescription, a_complexStartExpressions, a_stateDerVectorName);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_complexStartExpressions) = lm_69(txt, rest, a_stateDerVectorName, a_complexStartExpressions, a_generateFMUModelDescription, a_indexForUndefinedReferencesString, a_varToArrayIndexMapping, a_simCode);
      then (txt, a_stateDerVectorName, a_complexStartExpressions);
  end match;
end lm_69;

protected function lm_70
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_complexStartExpressions;
  input Boolean in_a_generateFMUModelDescription;
  input String in_a_indexForUndefinedReferencesString;
  input HashTableCrIListArray.HashTable in_a_varToArrayIndexMapping;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_complexStartExpressions;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_complexStartExpressions) :=
  match(in_txt, in_items, in_a_stateDerVectorName, in_a_complexStartExpressions, in_a_generateFMUModelDescription, in_a_indexForUndefinedReferencesString, in_a_varToArrayIndexMapping, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_complexStartExpressions;
      Boolean a_generateFMUModelDescription;
      String a_indexForUndefinedReferencesString;
      HashTableCrIListArray.HashTable a_varToArrayIndexMapping;
      SimCode.SimCode a_simCode;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           a_stateDerVectorName,
           a_complexStartExpressions,
           _,
           _,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_complexStartExpressions);

    case ( txt,
           i_var :: rest,
           a_stateDerVectorName,
           a_complexStartExpressions,
           a_generateFMUModelDescription,
           a_indexForUndefinedReferencesString,
           a_varToArrayIndexMapping,
           a_simCode )
      equation
        (txt, a_complexStartExpressions, a_stateDerVectorName) = scalarVariableXML(txt, a_simCode, i_var, a_varToArrayIndexMapping, a_indexForUndefinedReferencesString, a_generateFMUModelDescription, a_complexStartExpressions, a_stateDerVectorName);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_complexStartExpressions) = lm_70(txt, rest, a_stateDerVectorName, a_complexStartExpressions, a_generateFMUModelDescription, a_indexForUndefinedReferencesString, a_varToArrayIndexMapping, a_simCode);
      then (txt, a_stateDerVectorName, a_complexStartExpressions);
  end match;
end lm_70;

protected function fun_71
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;
  input SimCode.SimCode in_a_simCode;
  input HashTableCrIListArray.HashTable in_a_varToArrayIndexMapping;
  input String in_a_indexForUndefinedReferencesReal;
  input String in_a_indexForUndefinedReferencesInt;
  input String in_a_indexForUndefinedReferencesBool;
  input String in_a_indexForUndefinedReferencesString;
  input Boolean in_a_generateFMUModelDescription;
  input Tpl.Text in_a_complexStartExpressions;
  input Tpl.Text in_a_stateDerVectorName;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_complexStartExpressions;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_complexStartExpressions, out_a_stateDerVectorName) :=
  match(in_txt, in_a_modelInfo, in_a_simCode, in_a_varToArrayIndexMapping, in_a_indexForUndefinedReferencesReal, in_a_indexForUndefinedReferencesInt, in_a_indexForUndefinedReferencesBool, in_a_indexForUndefinedReferencesString, in_a_generateFMUModelDescription, in_a_complexStartExpressions, in_a_stateDerVectorName)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      HashTableCrIListArray.HashTable a_varToArrayIndexMapping;
      String a_indexForUndefinedReferencesReal;
      String a_indexForUndefinedReferencesInt;
      String a_indexForUndefinedReferencesBool;
      String a_indexForUndefinedReferencesString;
      Boolean a_generateFMUModelDescription;
      Tpl.Text a_complexStartExpressions;
      Tpl.Text a_stateDerVectorName;
      list<SimCodeVar.SimVar> i_vars_stringAliasVars;
      list<SimCodeVar.SimVar> i_vars_stringParamVars;
      list<SimCodeVar.SimVar> i_vars_stringAlgVars;
      list<SimCodeVar.SimVar> i_vars_boolAliasVars;
      list<SimCodeVar.SimVar> i_vars_boolParamVars;
      list<SimCodeVar.SimVar> i_vars_boolAlgVars;
      list<SimCodeVar.SimVar> i_vars_intAliasVars;
      list<SimCodeVar.SimVar> i_vars_intParamVars;
      list<SimCodeVar.SimVar> i_vars_intAlgVars;
      list<SimCodeVar.SimVar> i_vars_aliasVars;
      list<SimCodeVar.SimVar> i_vars_paramVars;
      list<SimCodeVar.SimVar> i_vars_discreteAlgVars;
      list<SimCodeVar.SimVar> i_vars_algVars;
      list<SimCodeVar.SimVar> i_vars_derivativeVars;
      list<SimCodeVar.SimVar> i_vars_stateVars;

    case ( txt,
           SimCode.MODELINFO(vars = SimCodeVar.SIMVARS(stateVars = i_vars_stateVars, derivativeVars = i_vars_derivativeVars, algVars = i_vars_algVars, discreteAlgVars = i_vars_discreteAlgVars, paramVars = i_vars_paramVars, aliasVars = i_vars_aliasVars, intAlgVars = i_vars_intAlgVars, intParamVars = i_vars_intParamVars, intAliasVars = i_vars_intAliasVars, boolAlgVars = i_vars_boolAlgVars, boolParamVars = i_vars_boolParamVars, boolAliasVars = i_vars_boolAliasVars, stringAlgVars = i_vars_stringAlgVars, stringParamVars = i_vars_stringParamVars, stringAliasVars = i_vars_stringAliasVars), varInfo = SimCode.VARINFO(numAlgVars = _, numDiscreteReal = _, numOptimizeConstraints = _)),
           a_simCode,
           a_varToArrayIndexMapping,
           a_indexForUndefinedReferencesReal,
           a_indexForUndefinedReferencesInt,
           a_indexForUndefinedReferencesBool,
           a_indexForUndefinedReferencesString,
           a_generateFMUModelDescription,
           a_complexStartExpressions,
           a_stateDerVectorName )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_stateDerVectorName, a_complexStartExpressions) = lm_56(txt, i_vars_stateVars, a_stateDerVectorName, a_complexStartExpressions, a_generateFMUModelDescription, a_indexForUndefinedReferencesReal, a_varToArrayIndexMapping, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_stateDerVectorName, a_complexStartExpressions) = lm_57(txt, i_vars_derivativeVars, a_stateDerVectorName, a_complexStartExpressions, a_generateFMUModelDescription, a_indexForUndefinedReferencesReal, a_varToArrayIndexMapping, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_stateDerVectorName, a_complexStartExpressions) = lm_58(txt, i_vars_algVars, a_stateDerVectorName, a_complexStartExpressions, a_generateFMUModelDescription, a_indexForUndefinedReferencesReal, a_varToArrayIndexMapping, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_stateDerVectorName, a_complexStartExpressions) = lm_59(txt, i_vars_discreteAlgVars, a_stateDerVectorName, a_complexStartExpressions, a_generateFMUModelDescription, a_indexForUndefinedReferencesReal, a_varToArrayIndexMapping, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_stateDerVectorName, a_complexStartExpressions) = lm_60(txt, i_vars_paramVars, a_stateDerVectorName, a_complexStartExpressions, a_generateFMUModelDescription, a_indexForUndefinedReferencesReal, a_varToArrayIndexMapping, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_stateDerVectorName, a_complexStartExpressions) = lm_61(txt, i_vars_aliasVars, a_stateDerVectorName, a_complexStartExpressions, a_generateFMUModelDescription, a_indexForUndefinedReferencesReal, a_varToArrayIndexMapping, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_stateDerVectorName, a_complexStartExpressions) = lm_62(txt, i_vars_intAlgVars, a_stateDerVectorName, a_complexStartExpressions, a_generateFMUModelDescription, a_indexForUndefinedReferencesInt, a_varToArrayIndexMapping, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_stateDerVectorName, a_complexStartExpressions) = lm_63(txt, i_vars_intParamVars, a_stateDerVectorName, a_complexStartExpressions, a_generateFMUModelDescription, a_indexForUndefinedReferencesInt, a_varToArrayIndexMapping, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_stateDerVectorName, a_complexStartExpressions) = lm_64(txt, i_vars_intAliasVars, a_stateDerVectorName, a_complexStartExpressions, a_generateFMUModelDescription, a_indexForUndefinedReferencesInt, a_varToArrayIndexMapping, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_stateDerVectorName, a_complexStartExpressions) = lm_65(txt, i_vars_boolAlgVars, a_stateDerVectorName, a_complexStartExpressions, a_generateFMUModelDescription, a_indexForUndefinedReferencesBool, a_varToArrayIndexMapping, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_stateDerVectorName, a_complexStartExpressions) = lm_66(txt, i_vars_boolParamVars, a_stateDerVectorName, a_complexStartExpressions, a_generateFMUModelDescription, a_indexForUndefinedReferencesBool, a_varToArrayIndexMapping, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_stateDerVectorName, a_complexStartExpressions) = lm_67(txt, i_vars_boolAliasVars, a_stateDerVectorName, a_complexStartExpressions, a_generateFMUModelDescription, a_indexForUndefinedReferencesBool, a_varToArrayIndexMapping, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_stateDerVectorName, a_complexStartExpressions) = lm_68(txt, i_vars_stringAlgVars, a_stateDerVectorName, a_complexStartExpressions, a_generateFMUModelDescription, a_indexForUndefinedReferencesString, a_varToArrayIndexMapping, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_stateDerVectorName, a_complexStartExpressions) = lm_69(txt, i_vars_stringParamVars, a_stateDerVectorName, a_complexStartExpressions, a_generateFMUModelDescription, a_indexForUndefinedReferencesString, a_varToArrayIndexMapping, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_stateDerVectorName, a_complexStartExpressions) = lm_70(txt, i_vars_stringAliasVars, a_stateDerVectorName, a_complexStartExpressions, a_generateFMUModelDescription, a_indexForUndefinedReferencesString, a_varToArrayIndexMapping, a_simCode);
        txt = Tpl.popIter(txt);
      then (txt, a_complexStartExpressions, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           _,
           _,
           _,
           _,
           _,
           _,
           a_complexStartExpressions,
           a_stateDerVectorName )
      then (txt, a_complexStartExpressions, a_stateDerVectorName);
  end match;
end fun_71;

public function modelVariablesXML
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input SimCode.ModelInfo a_modelInfo;
  input HashTableCrIListArray.HashTable a_varToArrayIndexMapping;
  input String a_indexForUndefinedReferencesReal;
  input String a_indexForUndefinedReferencesInt;
  input String a_indexForUndefinedReferencesBool;
  input String a_indexForUndefinedReferencesString;
  input Boolean a_generateFMUModelDescription;
  input Tpl.Text a_complexStartExpressions;
  input Tpl.Text a_stateDerVectorName;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_complexStartExpressions;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_complexStartExpressions, out_a_stateDerVectorName) := fun_71(txt, a_modelInfo, a_simCode, a_varToArrayIndexMapping, a_indexForUndefinedReferencesReal, a_indexForUndefinedReferencesInt, a_indexForUndefinedReferencesBool, a_indexForUndefinedReferencesString, a_generateFMUModelDescription, a_complexStartExpressions, a_stateDerVectorName);
end modelVariablesXML;

protected function fun_73
  input Tpl.Text in_txt;
  input Boolean in_a_generateFMUModelDescription;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_complexStartExpressions;
  input DAE.Type in_a_type__;
  input Boolean in_a_isFixed;
  input Option<DAE.Exp> in_a_nominalValue;
  input Option<DAE.Exp> in_a_initialValue;
  input Option<DAE.Exp> in_a_maxValue;
  input Option<DAE.Exp> in_a_minValue;
  input String in_a_displayUnit;
  input String in_a_unit;
  input SimCodeVar.AliasVariable in_a_aliasvar;
  input DAE.ComponentRef in_a_name;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_complexStartExpressions;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_complexStartExpressions) :=
  match(in_txt, in_a_generateFMUModelDescription, in_a_stateDerVectorName, in_a_complexStartExpressions, in_a_type__, in_a_isFixed, in_a_nominalValue, in_a_initialValue, in_a_maxValue, in_a_minValue, in_a_displayUnit, in_a_unit, in_a_aliasvar, in_a_name, in_a_simCode)
    local
      Tpl.Text txt;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_complexStartExpressions;
      DAE.Type a_type__;
      Boolean a_isFixed;
      Option<DAE.Exp> a_nominalValue;
      Option<DAE.Exp> a_initialValue;
      Option<DAE.Exp> a_maxValue;
      Option<DAE.Exp> a_minValue;
      String a_displayUnit;
      String a_unit;
      SimCodeVar.AliasVariable a_aliasvar;
      DAE.ComponentRef a_name;
      SimCode.SimCode a_simCode;
      DAE.Type ret_0;

    case ( txt,
           false,
           a_stateDerVectorName,
           a_complexStartExpressions,
           a_type__,
           a_isFixed,
           a_nominalValue,
           a_initialValue,
           a_maxValue,
           a_minValue,
           a_displayUnit,
           a_unit,
           a_aliasvar,
           a_name,
           a_simCode )
      equation
        ret_0 = Types.arrayElementType(a_type__);
        (txt, a_complexStartExpressions, a_stateDerVectorName) = ScalarVariableType(txt, a_simCode, a_name, a_aliasvar, a_unit, a_displayUnit, a_minValue, a_maxValue, a_initialValue, a_nominalValue, a_isFixed, ret_0, a_complexStartExpressions, a_stateDerVectorName);
      then (txt, a_stateDerVectorName, a_complexStartExpressions);

    case ( txt,
           _,
           a_stateDerVectorName,
           a_complexStartExpressions,
           _,
           _,
           _,
           _,
           _,
           _,
           _,
           _,
           _,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_complexStartExpressions);
  end match;
end fun_73;

protected function lm_74
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_complexStartExpressionsForScalarsUnused;
  input Boolean in_a_generateFMUModelDescription;
  input String in_a_indexForUndefinedReferences;
  input HashTableCrIListArray.HashTable in_a_varToArrayIndexMapping;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_complexStartExpressionsForScalarsUnused;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_complexStartExpressionsForScalarsUnused) :=
  match(in_txt, in_items, in_a_stateDerVectorName, in_a_complexStartExpressionsForScalarsUnused, in_a_generateFMUModelDescription, in_a_indexForUndefinedReferences, in_a_varToArrayIndexMapping, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_complexStartExpressionsForScalarsUnused;
      Boolean a_generateFMUModelDescription;
      String a_indexForUndefinedReferences;
      HashTableCrIListArray.HashTable a_varToArrayIndexMapping;
      SimCode.SimCode a_simCode;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           a_stateDerVectorName,
           a_complexStartExpressionsForScalarsUnused,
           _,
           _,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_complexStartExpressionsForScalarsUnused);

    case ( txt,
           i_var :: rest,
           a_stateDerVectorName,
           a_complexStartExpressionsForScalarsUnused,
           a_generateFMUModelDescription,
           a_indexForUndefinedReferences,
           a_varToArrayIndexMapping,
           a_simCode )
      equation
        (txt, a_complexStartExpressionsForScalarsUnused, a_stateDerVectorName) = scalarVariableXML(txt, a_simCode, i_var, a_varToArrayIndexMapping, a_indexForUndefinedReferences, a_generateFMUModelDescription, a_complexStartExpressionsForScalarsUnused, a_stateDerVectorName);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_complexStartExpressionsForScalarsUnused) = lm_74(txt, rest, a_stateDerVectorName, a_complexStartExpressionsForScalarsUnused, a_generateFMUModelDescription, a_indexForUndefinedReferences, a_varToArrayIndexMapping, a_simCode);
      then (txt, a_stateDerVectorName, a_complexStartExpressionsForScalarsUnused);
  end match;
end lm_74;

protected function fun_75
  input Tpl.Text in_txt;
  input Boolean in_a_generateFMUModelDescription;
  input SimCodeVar.SimVar in_a_simVar;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_complexStartExpressions;
  input DAE.Type in_a_type__;
  input Boolean in_a_isFixed;
  input Option<DAE.Exp> in_a_nominalValue;
  input Option<DAE.Exp> in_a_initialValue;
  input Option<DAE.Exp> in_a_maxValue;
  input Option<DAE.Exp> in_a_minValue;
  input String in_a_displayUnit;
  input String in_a_unit;
  input SimCodeVar.AliasVariable in_a_aliasvar;
  input DAE.ComponentRef in_a_name;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_complexStartExpressions;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_complexStartExpressions) :=
  match(in_txt, in_a_generateFMUModelDescription, in_a_simVar, in_a_stateDerVectorName, in_a_complexStartExpressions, in_a_type__, in_a_isFixed, in_a_nominalValue, in_a_initialValue, in_a_maxValue, in_a_minValue, in_a_displayUnit, in_a_unit, in_a_aliasvar, in_a_name, in_a_simCode)
    local
      Tpl.Text txt;
      SimCodeVar.SimVar a_simVar;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_complexStartExpressions;
      DAE.Type a_type__;
      Boolean a_isFixed;
      Option<DAE.Exp> a_nominalValue;
      Option<DAE.Exp> a_initialValue;
      Option<DAE.Exp> a_maxValue;
      Option<DAE.Exp> a_minValue;
      String a_displayUnit;
      String a_unit;
      SimCodeVar.AliasVariable a_aliasvar;
      DAE.ComponentRef a_name;
      SimCode.SimCode a_simCode;

    case ( txt,
           false,
           _,
           a_stateDerVectorName,
           a_complexStartExpressions,
           a_type__,
           a_isFixed,
           a_nominalValue,
           a_initialValue,
           a_maxValue,
           a_minValue,
           a_displayUnit,
           a_unit,
           a_aliasvar,
           a_name,
           a_simCode )
      equation
        (txt, a_complexStartExpressions, a_stateDerVectorName) = ScalarVariableType(txt, a_simCode, a_name, a_aliasvar, a_unit, a_displayUnit, a_minValue, a_maxValue, a_initialValue, a_nominalValue, a_isFixed, a_type__, a_complexStartExpressions, a_stateDerVectorName);
      then (txt, a_stateDerVectorName, a_complexStartExpressions);

    case ( txt,
           _,
           a_simVar,
           a_stateDerVectorName,
           a_complexStartExpressions,
           _,
           _,
           _,
           _,
           _,
           _,
           _,
           _,
           _,
           _,
           _ )
      equation
        txt = CodegenFMUCommon.ScalarVariableType(txt, a_simVar);
      then (txt, a_stateDerVectorName, a_complexStartExpressions);
  end match;
end fun_75;

protected function fun_76
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_a_simVar;
  input SimCode.SimCode in_a_simCode;
  input HashTableCrIListArray.HashTable in_a_varToArrayIndexMapping;
  input String in_a_indexForUndefinedReferences;
  input Boolean in_a_generateFMUModelDescription;
  input Tpl.Text in_a_complexStartExpressions;
  input Tpl.Text in_a_stateDerVectorName;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_complexStartExpressions;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_complexStartExpressions, out_a_stateDerVectorName) :=
  match(in_txt, in_a_simVar, in_a_simCode, in_a_varToArrayIndexMapping, in_a_indexForUndefinedReferences, in_a_generateFMUModelDescription, in_a_complexStartExpressions, in_a_stateDerVectorName)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      HashTableCrIListArray.HashTable a_varToArrayIndexMapping;
      String a_indexForUndefinedReferences;
      Boolean a_generateFMUModelDescription;
      Tpl.Text a_complexStartExpressions;
      Tpl.Text a_stateDerVectorName;
      SimCodeVar.SimVar i_simVar;
      DAE.Type i_type__;
      Boolean i_isFixed;
      Option<DAE.Exp> i_nominalValue;
      Option<DAE.Exp> i_initialValue;
      Option<DAE.Exp> i_maxValue;
      Option<DAE.Exp> i_minValue;
      String i_displayUnit;
      String i_unit;
      SimCodeVar.AliasVariable i_aliasvar;
      DAE.ComponentRef i_name;
      Tpl.Text l_variableCode;
      list<SimCodeVar.SimVar> ret_2;
      Tpl.Text l_complexStartExpressionsForScalarsUnused;
      Tpl.Text l_0__;

    case ( txt,
           (i_simVar as SimCodeVar.SIMVAR(type_ = (i_type__ as DAE.T_ARRAY(ty = _)), name = i_name, aliasvar = i_aliasvar, unit = i_unit, displayUnit = i_displayUnit, minValue = i_minValue, maxValue = i_maxValue, initialValue = i_initialValue, nominalValue = i_nominalValue, isFixed = i_isFixed)),
           a_simCode,
           a_varToArrayIndexMapping,
           a_indexForUndefinedReferences,
           a_generateFMUModelDescription,
           a_complexStartExpressions,
           a_stateDerVectorName )
      equation
        (l_0__, a_stateDerVectorName, a_complexStartExpressions) = fun_73(Tpl.emptyTxt, a_generateFMUModelDescription, a_stateDerVectorName, a_complexStartExpressions, i_type__, i_isFixed, i_nominalValue, i_initialValue, i_maxValue, i_minValue, i_displayUnit, i_unit, i_aliasvar, i_name, a_simCode);
        l_complexStartExpressionsForScalarsUnused = Tpl.emptyTxt;
        ret_2 = SimCodeUtil.getScalarElements(i_simVar);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_stateDerVectorName, l_complexStartExpressionsForScalarsUnused) = lm_74(txt, ret_2, a_stateDerVectorName, l_complexStartExpressionsForScalarsUnused, a_generateFMUModelDescription, a_indexForUndefinedReferences, a_varToArrayIndexMapping, a_simCode);
        txt = Tpl.popIter(txt);
      then (txt, a_complexStartExpressions, a_stateDerVectorName);

    case ( txt,
           (i_simVar as SimCodeVar.SIMVAR(name = i_name, aliasvar = i_aliasvar, unit = i_unit, displayUnit = i_displayUnit, minValue = i_minValue, maxValue = i_maxValue, initialValue = i_initialValue, nominalValue = i_nominalValue, isFixed = i_isFixed, type_ = i_type__)),
           a_simCode,
           _,
           a_indexForUndefinedReferences,
           a_generateFMUModelDescription,
           a_complexStartExpressions,
           a_stateDerVectorName )
      equation
        (l_variableCode, a_stateDerVectorName, a_complexStartExpressions) = fun_75(Tpl.emptyTxt, a_generateFMUModelDescription, i_simVar, a_stateDerVectorName, a_complexStartExpressions, i_type__, i_isFixed, i_nominalValue, i_initialValue, i_maxValue, i_minValue, i_displayUnit, i_unit, i_aliasvar, i_name, a_simCode);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<ScalarVariable "));
        txt = scalarVariableAttributeXML(txt, i_simVar, a_simCode, a_indexForUndefinedReferences, a_generateFMUModelDescription);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(">\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_variableCode);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("</ScalarVariable>"));
      then (txt, a_complexStartExpressions, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           _,
           _,
           _,
           a_complexStartExpressions,
           a_stateDerVectorName )
      then (txt, a_complexStartExpressions, a_stateDerVectorName);
  end match;
end fun_76;

public function scalarVariableXML
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input SimCodeVar.SimVar a_simVar;
  input HashTableCrIListArray.HashTable a_varToArrayIndexMapping;
  input String a_indexForUndefinedReferences;
  input Boolean a_generateFMUModelDescription;
  input Tpl.Text a_complexStartExpressions;
  input Tpl.Text a_stateDerVectorName;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_complexStartExpressions;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_complexStartExpressions, out_a_stateDerVectorName) := fun_76(txt, a_simVar, a_simCode, a_varToArrayIndexMapping, a_indexForUndefinedReferences, a_generateFMUModelDescription, a_complexStartExpressions, a_stateDerVectorName);
end scalarVariableXML;

protected function fun_78
  input Tpl.Text in_txt;
  input String in_a_comment;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_comment)
    local
      Tpl.Text txt;
      String i_comment;
      String ret_0;

    case ( txt,
           "" )
      then txt;

    case ( txt,
           i_comment )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("description=\""));
        ret_0 = Util.escapeModelicaStringToXmlString(i_comment);
        txt = Tpl.writeStr(txt, ret_0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
      then txt;
  end match;
end fun_78;

protected function fun_79
  input Tpl.Text in_txt;
  input Boolean in_a_generateFMUModelDescription;
  input Boolean in_a_isValueChangeable;
  input Boolean in_a_isDiscrete;
  input Boolean in_a_hideResult;
  input Boolean in_a_isProtected;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_generateFMUModelDescription, in_a_isValueChangeable, in_a_isDiscrete, in_a_hideResult, in_a_isProtected)
    local
      Tpl.Text txt;
      Boolean a_isValueChangeable;
      Boolean a_isDiscrete;
      Boolean a_hideResult;
      Boolean a_isProtected;

    case ( txt,
           false,
           a_isValueChangeable,
           a_isDiscrete,
           a_hideResult,
           a_isProtected )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("isProtected=\""));
        txt = Tpl.writeStr(txt, Tpl.booleanString(a_isProtected));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\" hideResult=\""));
        txt = Tpl.writeStr(txt, Tpl.booleanString(a_hideResult));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\" isDiscrete=\""));
        txt = Tpl.writeStr(txt, Tpl.booleanString(a_isDiscrete));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\" isValueChangeable=\""));
        txt = Tpl.writeStr(txt, Tpl.booleanString(a_isValueChangeable));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
      then txt;

    case ( txt,
           _,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_79;

protected function fun_80
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_a_simVar;
  input SimCode.SimCode in_a_simCode;
  input Boolean in_a_generateFMUModelDescription;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simVar, in_a_simCode, in_a_generateFMUModelDescription)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      Boolean a_generateFMUModelDescription;
      DAE.ComponentRef i_name;
      Boolean i_isValueChangeable;
      Boolean i_isDiscrete;
      Boolean i_hideResult;
      Boolean i_isProtected;
      String i_comment;
      BackendDAE.VarKind i_varKind;
      Option<SimCodeVar.Causality> i_causality;
      SimCodeVar.AliasVariable i_aliasvar;
      SimCodeVar.SimVar i_simVar;
      String ret_9;
      String ret_8;
      Tpl.Text txt_7;
      Tpl.Text l_additionalAttributes;
      Tpl.Text l_description;
      Tpl.Text l_variability;
      Tpl.Text l_causalityAtt;
      Tpl.Text l_alias;
      String ret_1;
      Tpl.Text l_valueReference;

    case ( txt,
           (i_simVar as SimCodeVar.SIMVAR(source = DAE.SOURCE(info = _), aliasvar = i_aliasvar, causality = i_causality, varKind = i_varKind, comment = i_comment, isProtected = i_isProtected, hideResult = i_hideResult, isDiscrete = i_isDiscrete, isValueChangeable = i_isValueChangeable, name = i_name)),
           a_simCode,
           a_generateFMUModelDescription )
      equation
        ret_1 = SimCodeUtil.getValueReference(i_simVar, a_simCode, true);
        l_valueReference = Tpl.writeStr(Tpl.emptyTxt, ret_1);
        l_alias = getAliasAttribute(Tpl.emptyTxt, i_aliasvar);
        l_causalityAtt = CodegenFMUCommon.getCausality(Tpl.emptyTxt, i_causality);
        l_variability = CodegenUtil.getVariablity(Tpl.emptyTxt, i_varKind);
        l_description = fun_78(Tpl.emptyTxt, i_comment);
        l_additionalAttributes = fun_79(Tpl.emptyTxt, a_generateFMUModelDescription, i_isValueChangeable, i_isDiscrete, i_hideResult, i_isProtected);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("name=\""));
        txt_7 = CodegenUtil.crefStrNoUnderscore(Tpl.emptyTxt, i_name);
        ret_8 = Util.escapeModelicaStringToXmlString(Tpl.textString(txt_7));
        ret_9 = System.stringReplace(ret_8, "$", "_D_");
        txt = Tpl.writeStr(txt, ret_9);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\" valueReference=\""));
        txt = Tpl.writeText(txt, l_valueReference);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\" "));
        txt = Tpl.writeText(txt, l_description);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" variability=\""));
        txt = Tpl.writeText(txt, l_variability);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\" causality=\""));
        txt = Tpl.writeText(txt, l_causalityAtt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\" alias=\""));
        txt = Tpl.writeText(txt, l_alias);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\" "));
        txt = Tpl.writeText(txt, l_additionalAttributes);
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_80;

public function scalarVariableAttributeXML
  input Tpl.Text txt;
  input SimCodeVar.SimVar a_simVar;
  input SimCode.SimCode a_simCode;
  input String a_indexForUndefinedReferences;
  input Boolean a_generateFMUModelDescription;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_80(txt, a_simVar, a_simCode, a_generateFMUModelDescription);
end scalarVariableAttributeXML;

public function getAliasAttribute
  input Tpl.Text in_txt;
  input SimCodeVar.AliasVariable in_a_aliasvar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_aliasvar)
    local
      Tpl.Text txt;

    case ( txt,
           SimCodeVar.NOALIAS() )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("noAlias"));
      then txt;

    case ( txt,
           SimCodeVar.ALIAS(varName = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("alias"));
      then txt;

    case ( txt,
           SimCodeVar.NEGATEDALIAS(varName = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("negatedAlias"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("undefinedAliasType"));
      then txt;
  end match;
end getAliasAttribute;

protected function fun_83
  input Tpl.Text in_txt;
  input DAE.Type in_a_type__;
  input SimCode.SimCode in_a_simCode;
  input DAE.ComponentRef in_a_simVarCref;
  input SimCodeVar.AliasVariable in_a_simVarAlias;
  input String in_a_unit;
  input String in_a_displayUnit;
  input Option<DAE.Exp> in_a_minValue;
  input Option<DAE.Exp> in_a_maxValue;
  input Option<DAE.Exp> in_a_startValue;
  input Option<DAE.Exp> in_a_nominalValue;
  input Boolean in_a_isFixed;
  input Tpl.Text in_a_complexStartExpressions;
  input Tpl.Text in_a_stateDerVectorName;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_complexStartExpressions;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_complexStartExpressions, out_a_stateDerVectorName) :=
  match(in_txt, in_a_type__, in_a_simCode, in_a_simVarCref, in_a_simVarAlias, in_a_unit, in_a_displayUnit, in_a_minValue, in_a_maxValue, in_a_startValue, in_a_nominalValue, in_a_isFixed, in_a_complexStartExpressions, in_a_stateDerVectorName)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      DAE.ComponentRef a_simVarCref;
      SimCodeVar.AliasVariable a_simVarAlias;
      String a_unit;
      String a_displayUnit;
      Option<DAE.Exp> a_minValue;
      Option<DAE.Exp> a_maxValue;
      Option<DAE.Exp> a_startValue;
      Option<DAE.Exp> a_nominalValue;
      Boolean a_isFixed;
      Tpl.Text a_complexStartExpressions;
      Tpl.Text a_stateDerVectorName;
      DAE.Type i_type__;
      Absyn.Path i_ci_path;
      Tpl.Text txt_2;
      String ret_2;
      String ret_1;
      Tpl.Text txt_0;

    case ( txt,
           DAE.T_INTEGER(varLst = _),
           a_simCode,
           a_simVarCref,
           a_simVarAlias,
           a_unit,
           a_displayUnit,
           a_minValue,
           a_maxValue,
           a_startValue,
           _,
           a_isFixed,
           a_complexStartExpressions,
           a_stateDerVectorName )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<Integer "));
        (txt, _, a_complexStartExpressions, a_stateDerVectorName) = ScalarVariableTypeStartAttribute(txt, a_simCode, a_simVarCref, a_simVarAlias, a_startValue, Tpl.strTokText(Tpl.ST_STRING("Int")), a_complexStartExpressions, a_stateDerVectorName);
        txt = CodegenUtil.ScalarVariableTypeFixedAttribute(txt, a_isFixed);
        txt = CodegenUtil.ScalarVariableTypeIntegerMinAttribute(txt, a_minValue);
        txt = CodegenUtil.ScalarVariableTypeIntegerMaxAttribute(txt, a_maxValue);
        txt = CodegenUtil.ScalarVariableTypeUnitAttribute(txt, a_unit);
        txt = CodegenUtil.ScalarVariableTypeDisplayUnitAttribute(txt, a_displayUnit);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" />"));
      then (txt, a_complexStartExpressions, a_stateDerVectorName);

    case ( txt,
           DAE.T_REAL(varLst = _),
           a_simCode,
           a_simVarCref,
           a_simVarAlias,
           a_unit,
           a_displayUnit,
           a_minValue,
           a_maxValue,
           a_startValue,
           a_nominalValue,
           a_isFixed,
           a_complexStartExpressions,
           a_stateDerVectorName )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<Real "));
        (txt, _, a_complexStartExpressions, a_stateDerVectorName) = ScalarVariableTypeStartAttribute(txt, a_simCode, a_simVarCref, a_simVarAlias, a_startValue, Tpl.strTokText(Tpl.ST_STRING("Real")), a_complexStartExpressions, a_stateDerVectorName);
        txt = CodegenUtil.ScalarVariableTypeFixedAttribute(txt, a_isFixed);
        txt = CodegenUtil.ScalarVariableTypeNominalAttribute(txt, a_nominalValue);
        txt = CodegenUtil.ScalarVariableTypeRealMinAttribute(txt, a_minValue);
        txt = CodegenUtil.ScalarVariableTypeRealMaxAttribute(txt, a_maxValue);
        txt = CodegenUtil.ScalarVariableTypeUnitAttribute(txt, a_unit);
        txt = CodegenUtil.ScalarVariableTypeDisplayUnitAttribute(txt, a_displayUnit);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" />"));
      then (txt, a_complexStartExpressions, a_stateDerVectorName);

    case ( txt,
           DAE.T_BOOL(varLst = _),
           a_simCode,
           a_simVarCref,
           a_simVarAlias,
           a_unit,
           a_displayUnit,
           _,
           _,
           a_startValue,
           _,
           a_isFixed,
           a_complexStartExpressions,
           a_stateDerVectorName )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<Boolean "));
        (txt, _, a_complexStartExpressions, a_stateDerVectorName) = ScalarVariableTypeStartAttribute(txt, a_simCode, a_simVarCref, a_simVarAlias, a_startValue, Tpl.strTokText(Tpl.ST_STRING("Bool")), a_complexStartExpressions, a_stateDerVectorName);
        txt = CodegenUtil.ScalarVariableTypeFixedAttribute(txt, a_isFixed);
        txt = CodegenUtil.ScalarVariableTypeUnitAttribute(txt, a_unit);
        txt = CodegenUtil.ScalarVariableTypeDisplayUnitAttribute(txt, a_displayUnit);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" />"));
      then (txt, a_complexStartExpressions, a_stateDerVectorName);

    case ( txt,
           DAE.T_STRING(varLst = _),
           a_simCode,
           a_simVarCref,
           a_simVarAlias,
           a_unit,
           a_displayUnit,
           _,
           _,
           a_startValue,
           _,
           a_isFixed,
           a_complexStartExpressions,
           a_stateDerVectorName )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<String "));
        (txt, _, a_complexStartExpressions, a_stateDerVectorName) = ScalarVariableTypeStartAttribute(txt, a_simCode, a_simVarCref, a_simVarAlias, a_startValue, Tpl.strTokText(Tpl.ST_STRING("String")), a_complexStartExpressions, a_stateDerVectorName);
        txt = CodegenUtil.ScalarVariableTypeFixedAttribute(txt, a_isFixed);
        txt = CodegenUtil.ScalarVariableTypeUnitAttribute(txt, a_unit);
        txt = CodegenUtil.ScalarVariableTypeDisplayUnitAttribute(txt, a_displayUnit);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" />"));
      then (txt, a_complexStartExpressions, a_stateDerVectorName);

    case ( txt,
           DAE.T_ENUMERATION(index = _),
           a_simCode,
           a_simVarCref,
           a_simVarAlias,
           a_unit,
           a_displayUnit,
           _,
           _,
           a_startValue,
           _,
           a_isFixed,
           a_complexStartExpressions,
           a_stateDerVectorName )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<Integer "));
        (txt, _, a_complexStartExpressions, a_stateDerVectorName) = ScalarVariableTypeStartAttribute(txt, a_simCode, a_simVarCref, a_simVarAlias, a_startValue, Tpl.strTokText(Tpl.ST_STRING("Int")), a_complexStartExpressions, a_stateDerVectorName);
        txt = CodegenUtil.ScalarVariableTypeFixedAttribute(txt, a_isFixed);
        txt = CodegenUtil.ScalarVariableTypeUnitAttribute(txt, a_unit);
        txt = CodegenUtil.ScalarVariableTypeDisplayUnitAttribute(txt, a_displayUnit);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" />"));
      then (txt, a_complexStartExpressions, a_stateDerVectorName);

    case ( txt,
           DAE.T_COMPLEX(complexClassType = ClassInf.EXTERNAL_OBJ(path = i_ci_path)),
           _,
           _,
           _,
           _,
           _,
           _,
           _,
           _,
           _,
           _,
           a_complexStartExpressions,
           a_stateDerVectorName )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<ExternalObject path=\""));
        txt_0 = CodegenUtil.dotPath(Tpl.emptyTxt, i_ci_path);
        ret_1 = Util.escapeModelicaStringToXmlString(Tpl.textString(txt_0));
        txt = Tpl.writeStr(txt, ret_1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\" />"));
      then (txt, a_complexStartExpressions, a_stateDerVectorName);

    case ( txt,
           i_type__,
           _,
           _,
           _,
           _,
           _,
           _,
           _,
           _,
           _,
           _,
           a_complexStartExpressions,
           a_stateDerVectorName )
      equation
        txt_2 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("ScalarVariableType: "));
        ret_2 = Types.unparseType(i_type__);
        txt_2 = Tpl.writeStr(txt_2, ret_2);
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCppInit.tpl", 176, 16), Tpl.textString(txt_2));
      then (txt, a_complexStartExpressions, a_stateDerVectorName);
  end match;
end fun_83;

public function ScalarVariableType
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input DAE.ComponentRef a_simVarCref;
  input SimCodeVar.AliasVariable a_simVarAlias;
  input String a_unit;
  input String a_displayUnit;
  input Option<DAE.Exp> a_minValue;
  input Option<DAE.Exp> a_maxValue;
  input Option<DAE.Exp> a_startValue;
  input Option<DAE.Exp> a_nominalValue;
  input Boolean a_isFixed;
  input DAE.Type a_type__;
  input Tpl.Text a_complexStartExpressions;
  input Tpl.Text a_stateDerVectorName;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_complexStartExpressions;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_complexStartExpressions, out_a_stateDerVectorName) := fun_83(txt, a_type__, a_simCode, a_simVarCref, a_simVarAlias, a_unit, a_displayUnit, a_minValue, a_maxValue, a_startValue, a_nominalValue, a_isFixed, a_complexStartExpressions, a_stateDerVectorName);
end ScalarVariableType;

protected function fun_85
  input Tpl.Text in_txt;
  input SimCodeVar.AliasVariable in_a_simVarAlias;
  input Tpl.Text in_a_type;
  input Tpl.Text in_a_complexStartExpressions;
  input DAE.Exp in_a_exp;
  input Tpl.Text in_a_stateDerVectorName;
  input SimCode.SimCode in_a_simCode;
  input DAE.ComponentRef in_a_simVarCref;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_complexStartExpressions;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_complexStartExpressions, out_a_stateDerVectorName) :=
  match(in_txt, in_a_simVarAlias, in_a_type, in_a_complexStartExpressions, in_a_exp, in_a_stateDerVectorName, in_a_simCode, in_a_simVarCref)
    local
      Tpl.Text txt;
      Tpl.Text a_type;
      Tpl.Text a_complexStartExpressions;
      DAE.Exp a_exp;
      Tpl.Text a_stateDerVectorName;
      SimCode.SimCode a_simCode;
      DAE.ComponentRef a_simVarCref;
      Tpl.Text l_expression;
      Tpl.Text l_crefStr;
      Tpl.Text l_extraFuncsDecl;
      Tpl.Text l_extraFuncs;
      Tpl.Text l_varDecls;
      Tpl.Text l_complexPreExpression;

    case ( txt,
           SimCodeVar.NOALIAS(),
           a_type,
           a_complexStartExpressions,
           a_exp,
           a_stateDerVectorName,
           a_simCode,
           a_simVarCref )
      equation
        l_complexPreExpression = Tpl.emptyTxt;
        l_varDecls = Tpl.emptyTxt;
        l_extraFuncs = Tpl.emptyTxt;
        l_extraFuncsDecl = Tpl.emptyTxt;
        (l_crefStr, l_extraFuncs, l_extraFuncsDecl, _, l_varDecls, a_stateDerVectorName) = CodegenCppCommon.cref1(Tpl.emptyTxt, a_simVarCref, a_simCode, l_extraFuncs, l_extraFuncsDecl, Tpl.strTokText(Tpl.ST_STRING("")), SimCodeFunction.contextOther, l_varDecls, a_stateDerVectorName, false);
        (l_expression, l_complexPreExpression, l_varDecls, l_extraFuncs, l_extraFuncsDecl, _, a_stateDerVectorName) = CodegenCppCommon.daeExp(Tpl.emptyTxt, a_exp, SimCodeFunction.contextOther, l_complexPreExpression, l_varDecls, a_simCode, l_extraFuncs, l_extraFuncsDecl, Tpl.strTokText(Tpl.ST_STRING("")), a_stateDerVectorName, false);
        a_complexStartExpressions = Tpl.writeText(a_complexStartExpressions, l_varDecls);
        a_complexStartExpressions = Tpl.writeText(a_complexStartExpressions, l_complexPreExpression);
        a_complexStartExpressions = Tpl.writeTok(a_complexStartExpressions, Tpl.ST_STRING("SystemDefaultImplementation::set"));
        a_complexStartExpressions = Tpl.writeText(a_complexStartExpressions, a_type);
        a_complexStartExpressions = Tpl.writeTok(a_complexStartExpressions, Tpl.ST_STRING("StartValue("));
        a_complexStartExpressions = Tpl.writeText(a_complexStartExpressions, l_crefStr);
        a_complexStartExpressions = Tpl.writeTok(a_complexStartExpressions, Tpl.ST_STRING(","));
        a_complexStartExpressions = Tpl.writeText(a_complexStartExpressions, l_expression);
        a_complexStartExpressions = Tpl.writeTok(a_complexStartExpressions, Tpl.ST_STRING(");"));
        a_complexStartExpressions = Tpl.writeTok(a_complexStartExpressions, Tpl.ST_NEW_LINE());
      then (txt, a_complexStartExpressions, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           a_complexStartExpressions,
           _,
           a_stateDerVectorName,
           _,
           _ )
      then (txt, a_complexStartExpressions, a_stateDerVectorName);
  end match;
end fun_85;

protected function fun_86
  input Tpl.Text in_txt;
  input String in_mArg;
  input Tpl.Text in_a_startString;
  input Tpl.Text in_a_type;
  input Tpl.Text in_a_complexStartExpressions;
  input DAE.Exp in_a_exp;
  input Tpl.Text in_a_stateDerVectorName;
  input SimCode.SimCode in_a_simCode;
  input DAE.ComponentRef in_a_simVarCref;
  input SimCodeVar.AliasVariable in_a_simVarAlias;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_complexStartExpressions;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_complexStartExpressions, out_a_stateDerVectorName) :=
  match(in_txt, in_mArg, in_a_startString, in_a_type, in_a_complexStartExpressions, in_a_exp, in_a_stateDerVectorName, in_a_simCode, in_a_simVarCref, in_a_simVarAlias)
    local
      Tpl.Text txt;
      Tpl.Text a_startString;
      Tpl.Text a_type;
      Tpl.Text a_complexStartExpressions;
      DAE.Exp a_exp;
      Tpl.Text a_stateDerVectorName;
      SimCode.SimCode a_simCode;
      DAE.ComponentRef a_simVarCref;
      SimCodeVar.AliasVariable a_simVarAlias;
      Tpl.Text l_unsued;

    case ( txt,
           "",
           _,
           a_type,
           a_complexStartExpressions,
           a_exp,
           a_stateDerVectorName,
           a_simCode,
           a_simVarCref,
           a_simVarAlias )
      equation
        (l_unsued, a_complexStartExpressions, a_stateDerVectorName) = fun_85(Tpl.emptyTxt, a_simVarAlias, a_type, a_complexStartExpressions, a_exp, a_stateDerVectorName, a_simCode, a_simVarCref);
      then (txt, a_complexStartExpressions, a_stateDerVectorName);

    case ( txt,
           _,
           a_startString,
           _,
           a_complexStartExpressions,
           _,
           a_stateDerVectorName,
           _,
           _,
           _ )
      equation
        txt = Tpl.writeText(txt, a_startString);
      then (txt, a_complexStartExpressions, a_stateDerVectorName);
  end match;
end fun_86;

protected function fun_87
  input Tpl.Text in_txt;
  input Option<DAE.Exp> in_a_startValue;
  input SimCode.SimCode in_a_simCode;
  input DAE.ComponentRef in_a_simVarCref;
  input SimCodeVar.AliasVariable in_a_simVarAlias;
  input Tpl.Text in_a_type;
  input Tpl.Text in_a_complexStartExpressions;
  input Tpl.Text in_a_stateDerVectorName;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_complexStartExpressions;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_complexStartExpressions, out_a_stateDerVectorName) :=
  match(in_txt, in_a_startValue, in_a_simCode, in_a_simVarCref, in_a_simVarAlias, in_a_type, in_a_complexStartExpressions, in_a_stateDerVectorName)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      DAE.ComponentRef a_simVarCref;
      SimCodeVar.AliasVariable a_simVarAlias;
      Tpl.Text a_type;
      Tpl.Text a_complexStartExpressions;
      Tpl.Text a_stateDerVectorName;
      DAE.Exp i_exp;
      String str_1;
      Tpl.Text l_startString;

    case ( txt,
           SOME(i_exp),
           a_simCode,
           a_simVarCref,
           a_simVarAlias,
           a_type,
           a_complexStartExpressions,
           a_stateDerVectorName )
      equation
        l_startString = CodegenUtil.StartString(Tpl.emptyTxt, i_exp);
        str_1 = Tpl.textString(l_startString);
        (txt, a_complexStartExpressions, a_stateDerVectorName) = fun_86(txt, str_1, l_startString, a_type, a_complexStartExpressions, i_exp, a_stateDerVectorName, a_simCode, a_simVarCref, a_simVarAlias);
      then (txt, a_complexStartExpressions, a_stateDerVectorName);

    case ( txt,
           NONE(),
           _,
           _,
           _,
           _,
           a_complexStartExpressions,
           a_stateDerVectorName )
      then (txt, a_complexStartExpressions, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           _,
           _,
           _,
           a_complexStartExpressions,
           a_stateDerVectorName )
      then (txt, a_complexStartExpressions, a_stateDerVectorName);
  end match;
end fun_87;

public function ScalarVariableTypeStartAttribute
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input DAE.ComponentRef a_simVarCref;
  input SimCodeVar.AliasVariable a_simVarAlias;
  input Option<DAE.Exp> a_startValue;
  input Tpl.Text a_type;
  input Tpl.Text a_complexStartExpressions;
  input Tpl.Text a_stateDerVectorName;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_type;
  output Tpl.Text out_a_complexStartExpressions;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_complexStartExpressions, out_a_stateDerVectorName) := fun_87(txt, a_startValue, a_simCode, a_simVarCref, a_simVarAlias, a_type, a_complexStartExpressions, a_stateDerVectorName);
  out_a_type := a_type;
end ScalarVariableTypeStartAttribute;

protected function lm_89
  input Tpl.Text in_txt;
  input list<String> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<String> rest;
      String i_it;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_it :: rest )
      equation
        txt = Tpl.writeStr(txt, i_it);
        txt = lm_89(txt, rest);
      then txt;
  end match;
end lm_89;

protected function lm_90
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input String in_a_indexForUndefinedReferences;
  input HashTableCrIListArray.HashTable in_a_varToArrayIndexMapping;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_indexForUndefinedReferences, in_a_varToArrayIndexMapping)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      String a_indexForUndefinedReferences;
      HashTableCrIListArray.HashTable a_varToArrayIndexMapping;
      DAE.ComponentRef i_v_name;
      list<String> ret_0;

    case ( txt,
           {},
           _,
           _ )
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(name = i_v_name) :: rest,
           a_indexForUndefinedReferences,
           a_varToArrayIndexMapping )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<Var type=\"double\" index=\""));
        ret_0 = SimCodeUtil.getVarIndexListByMapping(a_varToArrayIndexMapping, i_v_name, true, a_indexForUndefinedReferences);
        txt = lm_89(txt, ret_0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\" />"));
        txt = Tpl.nextIter(txt);
        txt = lm_90(txt, rest, a_indexForUndefinedReferences, a_varToArrayIndexMapping);
      then txt;

    case ( txt,
           _ :: rest,
           a_indexForUndefinedReferences,
           a_varToArrayIndexMapping )
      equation
        txt = lm_90(txt, rest, a_indexForUndefinedReferences, a_varToArrayIndexMapping);
      then txt;
  end match;
end lm_90;

protected function lm_91
  input Tpl.Text in_txt;
  input list<String> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<String> rest;
      String i_it;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_it :: rest )
      equation
        txt = Tpl.writeStr(txt, i_it);
        txt = lm_91(txt, rest);
      then txt;
  end match;
end lm_91;

protected function lm_92
  input Tpl.Text in_txt;
  input list<DAE.ComponentRef> in_items;
  input String in_a_indexForUndefinedReferences;
  input HashTableCrIListArray.HashTable in_a_varToArrayIndexMapping;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_indexForUndefinedReferences, in_a_varToArrayIndexMapping)
    local
      Tpl.Text txt;
      list<DAE.ComponentRef> rest;
      String a_indexForUndefinedReferences;
      HashTableCrIListArray.HashTable a_varToArrayIndexMapping;
      DAE.ComponentRef i_name;
      list<String> ret_0;

    case ( txt,
           {},
           _,
           _ )
      then txt;

    case ( txt,
           i_name :: rest,
           a_indexForUndefinedReferences,
           a_varToArrayIndexMapping )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<Var type=\"double\" index=\""));
        ret_0 = SimCodeUtil.getVarIndexListByMapping(a_varToArrayIndexMapping, i_name, true, a_indexForUndefinedReferences);
        txt = lm_91(txt, ret_0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\" />"));
        txt = Tpl.nextIter(txt);
        txt = lm_92(txt, rest, a_indexForUndefinedReferences, a_varToArrayIndexMapping);
      then txt;
  end match;
end lm_92;

protected function fun_93
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eqs;
  input HashTableCrIListArray.HashTable in_a_varToArrayIndexMapping;
  input String in_a_indexForUndefinedReferences;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_eqs, in_a_varToArrayIndexMapping, in_a_indexForUndefinedReferences)
    local
      Tpl.Text txt;
      HashTableCrIListArray.HashTable a_varToArrayIndexMapping;
      String a_indexForUndefinedReferences;
      list<DAE.ComponentRef> i_nls_crefs;
      Integer i_nls_index;
      list<SimCodeVar.SimVar> i_ls_vars;
      Integer i_ls_index;
      Integer ret_1;
      Integer ret_0;

    case ( txt,
           SimCode.SES_LINEAR(lSystem = SimCode.LINEARSYSTEM(index = i_ls_index, vars = i_ls_vars)),
           a_varToArrayIndexMapping,
           a_indexForUndefinedReferences )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<Linear eqIdx=\""));
        txt = Tpl.writeStr(txt, intString(i_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\" sparse=\"true\" size=\""));
        ret_0 = listLength(i_ls_vars);
        txt = Tpl.writeStr(txt, intString(ret_0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\">\n",
                                    "  <Vars>\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_90(txt, i_ls_vars, a_indexForUndefinedReferences, a_varToArrayIndexMapping);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "  </Vars>\n",
                                    "</Linear>"
                                }, false));
      then txt;

    case ( txt,
           SimCode.SES_NONLINEAR(nlSystem = SimCode.NONLINEARSYSTEM(index = i_nls_index, crefs = i_nls_crefs)),
           a_varToArrayIndexMapping,
           a_indexForUndefinedReferences )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<NonLinear eqIdx=\""));
        txt = Tpl.writeStr(txt, intString(i_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\" size=\""));
        ret_1 = listLength(i_nls_crefs);
        txt = Tpl.writeStr(txt, intString(ret_1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\">\n",
                                    "  <Vars>\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_92(txt, i_nls_crefs, a_indexForUndefinedReferences, a_varToArrayIndexMapping);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "  </Vars>\n",
                                    "  <NominalVars>\n",
                                    "  <!-- Maybe Expressions here -->\n",
                                    "  </NominalVars>\n",
                                    "</NonLinear>"
                                }, false));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_93;

public function algLoopXML
  input Tpl.Text txt;
  input SimCode.SimEqSystem a_eqs;
  input SimCode.SimCode a_simCode;
  input HashTableCrIListArray.HashTable a_varToArrayIndexMapping;
  input String a_indexForUndefinedReferences;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_93(txt, a_eqs, a_varToArrayIndexMapping, a_indexForUndefinedReferences);
end algLoopXML;

protected function lm_95
  input Tpl.Text in_txt;
  input list<SimCode.JacobianMatrix> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.JacobianMatrix> rest;
      Integer i_maxColor;
      list<list<Integer>> i_colorList;
      SimCode.SparsityPattern i_sparsepattern;
      String i_name;
      list<SimCodeVar.SimVar> i_vars;
      list<SimCode.JacobianColumn> i_mat;
      Integer i_jacIndex;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           SimCode.JAC_MATRIX(columns = i_mat, seedVars = i_vars, matrixName = i_name, sparsity = i_sparsepattern, coloredCols = i_colorList, maxColorCols = i_maxColor, jacobianIndex = i_jacIndex) :: rest )
      equation
        txt = jacobianMatrixXML(txt, i_jacIndex, i_mat, i_vars, i_name, i_sparsepattern, i_colorList, i_maxColor);
        txt = Tpl.nextIter(txt);
        txt = lm_95(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_95(txt, rest);
      then txt;
  end match;
end lm_95;

public function jacobianMatrixesXML
  input Tpl.Text txt;
  input list<SimCode.JacobianMatrix> a_JacobianMatrixes;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_jacMats;
algorithm
  l_jacMats := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  l_jacMats := lm_95(l_jacMats, a_JacobianMatrixes);
  l_jacMats := Tpl.popIter(l_jacMats);
  out_txt := Tpl.writeText(txt, l_jacMats);
end jacobianMatrixesXML;

protected function lm_97
  input Tpl.Text in_txt;
  input list<SimCode.JacobianColumn> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.JacobianColumn> rest;
      Integer i_nRows;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           SimCode.JAC_COLUMN(numberOfResultVars = i_nRows) :: rest )
      equation
        txt = Tpl.writeStr(txt, intString(i_nRows));
        txt = Tpl.nextIter(txt);
        txt = lm_97(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_97(txt, rest);
      then txt;
  end match;
end lm_97;

protected function fun_98
  input Tpl.Text in_txt;
  input String in_mArg;
  input Integer in_a_i__index;
  input Integer in_a_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_i__index, in_a_index)
    local
      Tpl.Text txt;
      Integer a_i__index;
      Integer a_index;

    case ( txt,
           "1",
           _,
           a_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<Entry indexX=\""));
        txt = Tpl.writeStr(txt, intString(a_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\" indexY=\"0\" valueIndex=\"0\"/>"));
      then txt;

    case ( txt,
           _,
           a_i__index,
           a_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<Entry indexX=\""));
        txt = Tpl.writeStr(txt, intString(a_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\" indexY=\""));
        txt = Tpl.writeStr(txt, intString(a_i__index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\" valueIndex=\""));
        txt = Tpl.writeStr(txt, intString(a_i__index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\"/>"));
      then txt;
  end match;
end fun_98;

protected function lm_99
  input Tpl.Text in_txt;
  input list<Integer> in_items;
  input Integer in_a_index;
  input Tpl.Text in_a_indexColumn;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_index, in_a_indexColumn)
    local
      Tpl.Text txt;
      list<Integer> rest;
      Integer a_index;
      Tpl.Text a_indexColumn;
      Integer i_i__index;
      String str_0;

    case ( txt,
           {},
           _,
           _ )
      then txt;

    case ( txt,
           i_i__index :: rest,
           a_index,
           a_indexColumn )
      equation
        str_0 = Tpl.textString(a_indexColumn);
        txt = fun_98(txt, str_0, i_i__index, a_index);
        txt = Tpl.nextIter(txt);
        txt = lm_99(txt, rest, a_index, a_indexColumn);
      then txt;
  end match;
end lm_99;

protected function lm_100
  input Tpl.Text in_txt;
  input SimCode.SparsityPattern in_items;
  input Tpl.Text in_a_indexColumn;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_indexColumn)
    local
      Tpl.Text txt;
      SimCode.SparsityPattern rest;
      Tpl.Text a_indexColumn;
      Integer i_index;
      list<Integer> i_indexes;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           (i_index, i_indexes) :: rest,
           a_indexColumn )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("<Column>\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(19));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_99(txt, i_indexes, i_index, a_indexColumn);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("</Column>"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.nextIter(txt);
        txt = lm_100(txt, rest, a_indexColumn);
      then txt;
  end match;
end lm_100;

public function jacobianMatrixXML
  input Tpl.Text txt;
  input Integer a_indexJacobian;
  input list<SimCode.JacobianColumn> a_jacobianColumn;
  input list<SimCodeVar.SimVar> a_seedVars;
  input String a_matrixName;
  input SimCode.SparsityPattern a_sparsepattern;
  input list<list<Integer>> a_colorList;
  input Integer a_maxColor;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_jacvals;
  Tpl.Text l_indexColumn;
algorithm
  l_indexColumn := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  l_indexColumn := lm_97(l_indexColumn, a_jacobianColumn);
  l_indexColumn := Tpl.popIter(l_indexColumn);
  l_jacvals := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  l_jacvals := lm_100(l_jacvals, a_sparsepattern, l_indexColumn);
  l_jacvals := Tpl.popIter(l_jacvals);
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING("<Matrix name=\""));
  out_txt := Tpl.writeStr(out_txt, a_matrixName);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\">\n",
                                       "  <Column>\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(4));
  out_txt := Tpl.writeText(out_txt, l_jacvals);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "  </Column>\n",
                                       "</Matrix>"
                                   }, false));
end jacobianMatrixXML;

annotation(__OpenModelica_Interface="backend");
end CodegenCppInit;