encapsulated package CodegenFMU1
"
  file:        CodegenFMU1.mo
  package:     CodegenFMU1
  description: Generated by Susan.
"

public import Tpl;

public import SimCodeVar;
public import SimCode;
public import Absyn;
public import Util;
public import Settings;
public import FMI;
public import CodegenUtil;
public import CodegenUtilSimulation;
public import CodegenFMUCommon;

protected function fun_47
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = CodegenFMUCommon.Implementation(txt);
      then txt;
  end match;
end fun_47;

public function fmiModelDescription
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input String in_a_guid;
  input String in_a_FMUType;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode, in_a_guid, in_a_FMUType)
    local
      Tpl.Text txt;
      String a_guid;
      String a_FMUType;
      Option<SimCode.SimulationSettings> i_simulationSettingsOpt;
      SimCode.SimCode i_simCode;
      Boolean ret_0;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(simulationSettingsOpt = i_simulationSettingsOpt)),
           a_guid,
           a_FMUType )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("<fmiModelDescription\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = fmiModelDescriptionAttributes(txt, i_simCode, a_guid);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(">\n"));
        txt = CodegenFMUCommon.fmiTypeDefinitions(txt, i_simCode, "1.0");
        txt = Tpl.softNewLine(txt);
        txt = CodegenFMUCommon.DefaultExperiment(txt, i_simulationSettingsOpt);
        txt = Tpl.softNewLine(txt);
        txt = CodegenFMUCommon.fmiModelVariables(txt, i_simCode, "1.0");
        txt = Tpl.softNewLine(txt);
        ret_0 = FMI.isFMICSType(a_FMUType);
        txt = fun_47(txt, ret_0);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("</fmiModelDescription>"));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fmiModelDescription;

protected function fun_49
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input list<SimCodeVar.SimVar> in_a_listStates;
  input Integer in_a_vi_numStateVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_listStates, in_a_vi_numStateVars)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> a_listStates;
      Integer a_vi_numStateVars;

    case ( txt,
           false,
           _,
           a_vi_numStateVars )
      equation
        txt = Tpl.writeStr(txt, intString(a_vi_numStateVars));
      then txt;

    case ( txt,
           _,
           a_listStates,
           _ )
      equation
        txt = CodegenFMUCommon.statesnumwithDummy(txt, a_listStates);
      then txt;
  end match;
end fun_49;

public function fmiModelDescriptionAttributes
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input String in_a_guid;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode, in_a_guid)
    local
      Tpl.Text txt;
      String a_guid;
      list<SimCodeVar.SimVar> i_listStates;
      Integer i_vi_numStateVars;
      String i_modelInfo_description;
      SimCode.SimCode i_simCode;
      Absyn.Path i_modelInfo_name;
      String ret_15;
      String ret_14;
      String ret_13;
      String ret_12;
      Tpl.Text l_numberOfEventIndicators;
      Boolean ret_10;
      Tpl.Text l_numberOfContinuousStates;
      Tpl.Text l_variableNamingConvention;
      Util.DateTime ret_7;
      Tpl.Text l_generationDateAndTime;
      String ret_5;
      Tpl.Text l_generationTool;
      Tpl.Text l_description;
      Tpl.Text l_modelIdentifier;
      Tpl.Text l_modelName;
      Tpl.Text l_fmiVersion;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(varInfo = SimCode.VARINFO(numStateVars = i_vi_numStateVars), vars = SimCodeVar.SIMVARS(stateVars = i_listStates), name = i_modelInfo_name, description = i_modelInfo_description))),
           a_guid )
      equation
        l_fmiVersion = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("1.0"));
        l_modelName = CodegenUtil.dotPath(Tpl.emptyTxt, i_modelInfo_name);
        l_modelIdentifier = CodegenUtilSimulation.modelNamePrefix(Tpl.emptyTxt, i_simCode);
        l_description = Tpl.writeStr(Tpl.emptyTxt, i_modelInfo_description);
        l_generationTool = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("OpenModelica Compiler "));
        ret_5 = Settings.getVersionNr();
        l_generationTool = Tpl.writeStr(l_generationTool, ret_5);
        ret_7 = Util.getCurrentDateTime();
        l_generationDateAndTime = CodegenFMUCommon.xsdateTime(Tpl.emptyTxt, ret_7);
        l_variableNamingConvention = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("structured"));
        ret_10 = intEq(i_vi_numStateVars, 1);
        l_numberOfContinuousStates = fun_49(Tpl.emptyTxt, ret_10, i_listStates, i_vi_numStateVars);
        l_numberOfEventIndicators = CodegenFMUCommon.getNumberOfEventIndicators(Tpl.emptyTxt, i_simCode);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("fmiVersion=\""));
        txt = Tpl.writeText(txt, l_fmiVersion);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\"\n",
                                    "modelName=\""
                                }, false));
        ret_12 = Util.escapeModelicaStringToXmlString(Tpl.textString(l_modelName));
        txt = Tpl.writeStr(txt, ret_12);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\"\n",
                                    "modelIdentifier=\""
                                }, false));
        ret_13 = Util.escapeModelicaStringToXmlString(Tpl.textString(l_modelIdentifier));
        txt = Tpl.writeStr(txt, ret_13);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\"\n",
                                    "guid=\"{"
                                }, false));
        txt = Tpl.writeStr(txt, a_guid);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\"\n",
                                    "description=\""
                                }, false));
        ret_14 = Util.escapeModelicaStringToXmlString(Tpl.textString(l_description));
        txt = Tpl.writeStr(txt, ret_14);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\"\n",
                                    "generationTool=\""
                                }, false));
        ret_15 = Util.escapeModelicaStringToXmlString(Tpl.textString(l_generationTool));
        txt = Tpl.writeStr(txt, ret_15);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\"\n",
                                    "generationDateAndTime=\""
                                }, false));
        txt = Tpl.writeText(txt, l_generationDateAndTime);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\"\n",
                                    "variableNamingConvention=\""
                                }, false));
        txt = Tpl.writeText(txt, l_variableNamingConvention);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\"\n",
                                    "numberOfContinuousStates=\""
                                }, false));
        txt = Tpl.writeText(txt, l_numberOfContinuousStates);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\"\n",
                                    "numberOfEventIndicators=\""
                                }, false));
        txt = Tpl.writeText(txt, l_numberOfEventIndicators);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fmiModelDescriptionAttributes;

annotation(__OpenModelica_Interface="backend");
end CodegenFMU1;