encapsulated package CodegenFMU2
"
  file:        CodegenFMU2.mo
  package:     CodegenFMU2
  description: Generated by Susan.
"

public import Tpl;

public import SimCodeVar;
public import SimCode;
public import System;
public import Absyn;
public import Util;
public import Flags;
public import Settings;
public import Error;
public import FMI;
public import CodegenUtil;
public import CodegenUtilSimulation;
public import CodegenFMUCommon;

protected function fun_47
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input list<String> in_a_sourceFiles;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_sourceFiles, in_a_simCode)
    local
      Tpl.Text txt;
      list<String> a_sourceFiles;
      SimCode.SimCode a_simCode;

    case ( txt,
           false,
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_sourceFiles,
           a_simCode )
      equation
        txt = CodegenFMUCommon.ModelExchange(txt, a_simCode, a_sourceFiles);
      then txt;
  end match;
end fun_47;

protected function fun_48
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input list<String> in_a_sourceFiles;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_sourceFiles, in_a_simCode)
    local
      Tpl.Text txt;
      list<String> a_sourceFiles;
      SimCode.SimCode a_simCode;

    case ( txt,
           false,
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_sourceFiles,
           a_simCode )
      equation
        txt = CoSimulation(txt, a_simCode, a_sourceFiles);
      then txt;
  end match;
end fun_48;

protected function fun_49
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "<LogCategories>\n",
                                    "  <Category name=\"logEvents\" />\n",
                                    "  <Category name=\"logSingularLinearSystems\" />\n",
                                    "  <Category name=\"logNonlinearSystems\" />\n",
                                    "  <Category name=\"logDynamicStateSelection\" />\n",
                                    "  <Category name=\"logStatusWarning\" />\n",
                                    "  <Category name=\"logStatusDiscard\" />\n",
                                    "  <Category name=\"logStatusError\" />\n",
                                    "  <Category name=\"logStatusFatal\" />\n",
                                    "  <Category name=\"logStatusPending\" />\n",
                                    "  <Category name=\"logAll\" />\n",
                                    "  <Category name=\"logFmi2Call\" />\n",
                                    "</LogCategories>"
                                }, false));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "<LogCategories>\n",
                                    "  <Category name=\"logEvents\" description=\"logEvents\" />\n",
                                    "  <Category name=\"logSingularLinearSystems\" description=\"logSingularLinearSystems\" />\n",
                                    "  <Category name=\"logNonlinearSystems\" description=\"logNonlinearSystems\" />\n",
                                    "  <Category name=\"logDynamicStateSelection\" description=\"logDynamicStateSelection\" />\n",
                                    "  <Category name=\"logStatusWarning\" description=\"logStatusWarning\" />\n",
                                    "  <Category name=\"logStatusDiscard\" description=\"logStatusDiscard\" />\n",
                                    "  <Category name=\"logStatusError\" description=\"logStatusError\" />\n",
                                    "  <Category name=\"logStatusFatal\" description=\"logStatusFatal\" />\n",
                                    "  <Category name=\"logStatusPending\" description=\"logStatusPending\" />\n",
                                    "  <Category name=\"logAll\" description=\"logAll\" />\n",
                                    "  <Category name=\"logFmi2Call\" description=\"logFmi2Call\" />\n",
                                    "</LogCategories>"
                                }, false));
      then txt;
  end match;
end fun_49;

public function fmiModelDescription
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input String in_a_guid;
  input String in_a_FMUType;
  input list<String> in_a_sourceFiles;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode, in_a_guid, in_a_FMUType, in_a_sourceFiles)
    local
      Tpl.Text txt;
      String a_guid;
      String a_FMUType;
      list<String> a_sourceFiles;
      Option<SimCode.FmiModelStructure> i_modelStructure;
      Option<SimCode.SimulationSettings> i_simulationSettingsOpt;
      SimCode.SimCode i_simCode;
      Boolean ret_2;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(simulationSettingsOpt = i_simulationSettingsOpt, modelStructure = i_modelStructure)),
           a_guid,
           a_FMUType,
           a_sourceFiles )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("<fmiModelDescription\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = fmiModelDescriptionAttributes(txt, i_simCode, a_guid);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(">\n"));
        ret_0 = FMI.isFMIMEType(a_FMUType);
        txt = fun_47(txt, ret_0, a_sourceFiles, i_simCode);
        txt = Tpl.softNewLine(txt);
        ret_1 = FMI.isFMICSType(a_FMUType);
        txt = fun_48(txt, ret_1, a_sourceFiles, i_simCode);
        txt = Tpl.softNewLine(txt);
        txt = CodegenFMUCommon.UnitDefinitions(txt, i_simCode);
        txt = Tpl.softNewLine(txt);
        txt = CodegenFMUCommon.fmiTypeDefinitions(txt, i_simCode, "2.0");
        txt = Tpl.softNewLine(txt);
        ret_2 = Flags.isSet(Flags.FMU_EXPERIMENTAL);
        txt = fun_49(txt, ret_2);
        txt = Tpl.softNewLine(txt);
        txt = CodegenFMUCommon.DefaultExperiment(txt, i_simulationSettingsOpt);
        txt = Tpl.softNewLine(txt);
        txt = CodegenFMUCommon.fmiModelVariables(txt, i_simCode, "2.0");
        txt = Tpl.softNewLine(txt);
        txt = CodegenFMUCommon.ModelStructure(txt, i_modelStructure);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("</fmiModelDescription>"));
      then txt;

    case ( txt,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fmiModelDescription;

public function fmiModelDescriptionAttributes
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input String in_a_guid;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode, in_a_guid)
    local
      Tpl.Text txt;
      String a_guid;
      SimCode.SimCode i_simCode;
      String i_modelInfo_description;
      Absyn.Path i_modelInfo_name;
      String ret_12;
      String ret_11;
      String ret_10;
      String ret_9;
      Tpl.Text l_numberOfEventIndicators;
      Tpl.Text l_variableNamingConvention;
      Util.DateTime ret_6;
      Tpl.Text l_generationDateAndTime;
      String ret_4;
      Tpl.Text l_generationTool;
      Tpl.Text l_description;
      Tpl.Text l_modelName;
      Tpl.Text l_fmiVersion;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(varInfo = SimCode.VARINFO(numZeroCrossings = _), vars = SimCodeVar.SIMVARS(stateVars = _), name = i_modelInfo_name, description = i_modelInfo_description))),
           a_guid )
      equation
        l_fmiVersion = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("2.0"));
        l_modelName = CodegenUtil.dotPath(Tpl.emptyTxt, i_modelInfo_name);
        l_description = Tpl.writeStr(Tpl.emptyTxt, i_modelInfo_description);
        l_generationTool = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("OpenModelica Compiler "));
        ret_4 = Settings.getVersionNr();
        l_generationTool = Tpl.writeStr(l_generationTool, ret_4);
        ret_6 = Util.getCurrentDateTime();
        l_generationDateAndTime = CodegenFMUCommon.xsdateTime(Tpl.emptyTxt, ret_6);
        l_variableNamingConvention = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("structured"));
        l_numberOfEventIndicators = CodegenFMUCommon.getNumberOfEventIndicators(Tpl.emptyTxt, i_simCode);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("fmiVersion=\""));
        txt = Tpl.writeText(txt, l_fmiVersion);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\"\n",
                                    "modelName=\""
                                }, false));
        ret_9 = Util.escapeModelicaStringToXmlString(Tpl.textString(l_modelName));
        txt = Tpl.writeStr(txt, ret_9);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\"\n",
                                    "guid=\"{"
                                }, false));
        txt = Tpl.writeStr(txt, a_guid);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\"\n",
                                    "description=\""
                                }, false));
        ret_10 = Util.escapeModelicaStringToXmlString(Tpl.textString(l_description));
        txt = Tpl.writeStr(txt, ret_10);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\"\n",
                                    "generationTool=\""
                                }, false));
        ret_11 = Util.escapeModelicaStringToXmlString(Tpl.textString(l_generationTool));
        txt = Tpl.writeStr(txt, ret_11);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\"\n",
                                    "generationDateAndTime=\""
                                }, false));
        ret_12 = Util.escapeModelicaStringToXmlString(Tpl.textString(l_generationDateAndTime));
        txt = Tpl.writeStr(txt, ret_12);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\"\n",
                                    "variableNamingConvention=\""
                                }, false));
        txt = Tpl.writeText(txt, l_variableNamingConvention);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\"\n",
                                    "numberOfEventIndicators=\""
                                }, false));
        txt = Tpl.writeText(txt, l_numberOfEventIndicators);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fmiModelDescriptionAttributes;

protected function fun_52
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("providesDirectionalDerivative=\"true\""));
      then txt;
  end match;
end fun_52;

public function CoSimulation
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input list<String> in_a_sourceFiles;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode, in_a_sourceFiles)
    local
      Tpl.Text txt;
      list<String> a_sourceFiles;
      SimCode.SimCode i_simCode;
      Boolean ret_2;
      String ret_1;
      Tpl.Text l_modelIdentifier;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = _)),
           a_sourceFiles )
      equation
        l_modelIdentifier = CodegenUtilSimulation.modelNamePrefix(Tpl.emptyTxt, i_simCode);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("<CoSimulation\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelIdentifier=\""));
        ret_1 = Util.escapeModelicaStringToXmlString(Tpl.textString(l_modelIdentifier));
        txt = Tpl.writeStr(txt, ret_1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\"\n",
                                    "needsExecutionTool=\"false\"\n",
                                    "canHandleVariableCommunicationStepSize=\"true\"\n",
                                    "canInterpolateInputs=\"false\"\n",
                                    "maxOutputDerivativeOrder=\"0\"\n",
                                    "canRunAsynchronuously = \"false\"\n",
                                    "canBeInstantiatedOnlyOncePerProcess=\"false\"\n",
                                    "canNotUseMemoryManagementFunctions=\"false\"\n",
                                    "canGetAndSetFMUstate=\"false\"\n",
                                    "canSerializeFMUstate=\"false\"\n"
                                }, true));
        ret_2 = Flags.isSet(Flags.FMU_EXPERIMENTAL);
        txt = fun_52(txt, ret_2);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(">\n"));
        txt = CodegenFMUCommon.SourceFiles(txt, a_sourceFiles);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("</CoSimulation>"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end CoSimulation;

annotation(__OpenModelica_Interface="backend");
end CodegenFMU2;