encapsulated package CodegenFMUCommon
"
  file:        CodegenFMUCommon.mo
  package:     CodegenFMUCommon
  description: Generated by Susan.
"

public import Tpl;

public import SimCodeVar;
public import SimCode;
public import SimCodeFunction;
public import SimCodeUtil;
public import SimCodeFunctionUtil;
public import BackendDAE;
public import System;
public import Absyn;
public import AbsynUtil;
public import MMath;
public import DAE;
public import Util;
public import List;
public import Config;
public import Settings;
public import Types;
public import FMI;
public import CodegenUtil;
public import CodegenUtilSimulation;
public import CodegenC;
public import CodegenCFunctions;

protected function fun_47
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" providesDirectionalDerivative=\"true\""));
      then txt;
  end match;
end fun_47;

public function ModelExchange
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input list<String> in_a_sourceFiles;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode, in_a_sourceFiles)
    local
      Tpl.Text txt;
      list<String> a_sourceFiles;
      SimCode.SimCode i_simCode;
      Boolean ret_2;
      Tpl.Text l_pdd;
      Tpl.Text l_modelIdentifier;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = _)),
           a_sourceFiles )
      equation
        l_modelIdentifier = CodegenUtilSimulation.modelNamePrefix(Tpl.emptyTxt, i_simCode);
        ret_2 = SimCodeUtil.providesDirectionalDerivative(i_simCode);
        l_pdd = fun_47(Tpl.emptyTxt, ret_2);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("<ModelExchange\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelIdentifier=\""));
        txt = Tpl.writeText(txt, l_modelIdentifier);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        txt = Tpl.writeText(txt, l_pdd);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(">\n"));
        txt = SourceFiles(txt, a_sourceFiles);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("</ModelExchange>"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end ModelExchange;

protected function lm_49
  input Tpl.Text in_txt;
  input list<String> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<String> rest;
      String i_file;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_file :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<File name=\""));
        txt = Tpl.writeStr(txt, i_file);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\" />"));
        txt = Tpl.nextIter(txt);
        txt = lm_49(txt, rest);
      then txt;
  end match;
end lm_49;

public function SourceFiles
  input Tpl.Text in_txt;
  input list<String> in_a_sourceFiles;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_sourceFiles)
    local
      Tpl.Text txt;
      list<String> i_sourceFiles;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_sourceFiles )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("<SourceFiles>\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_49(txt, i_sourceFiles);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("</SourceFiles>"));
      then txt;
  end match;
end SourceFiles;

protected function lm_51
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input String in_a_FMUVersion;
  input list<SimCodeVar.SimVar> in_a_stateVars;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_FMUVersion, in_a_stateVars, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      String a_FMUVersion;
      list<SimCodeVar.SimVar> a_stateVars;
      SimCode.SimCode a_simCode;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _,
           _,
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_FMUVersion,
           a_stateVars,
           a_simCode )
      equation
        txt = ScalarVariable(txt, i_var, a_simCode, a_stateVars, a_FMUVersion);
        txt = Tpl.nextIter(txt);
        txt = lm_51(txt, rest, a_FMUVersion, a_stateVars, a_simCode);
      then txt;
  end match;
end lm_51;

protected function lm_52
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input String in_a_FMUVersion;
  input list<SimCodeVar.SimVar> in_a_stateVars;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_FMUVersion, in_a_stateVars, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      String a_FMUVersion;
      list<SimCodeVar.SimVar> a_stateVars;
      SimCode.SimCode a_simCode;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _,
           _,
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_FMUVersion,
           a_stateVars,
           a_simCode )
      equation
        txt = ScalarVariable(txt, i_var, a_simCode, a_stateVars, a_FMUVersion);
        txt = Tpl.nextIter(txt);
        txt = lm_52(txt, rest, a_FMUVersion, a_stateVars, a_simCode);
      then txt;
  end match;
end lm_52;

protected function lm_53
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input String in_a_FMUVersion;
  input list<SimCodeVar.SimVar> in_a_stateVars;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_FMUVersion, in_a_stateVars, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      String a_FMUVersion;
      list<SimCodeVar.SimVar> a_stateVars;
      SimCode.SimCode a_simCode;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _,
           _,
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_FMUVersion,
           a_stateVars,
           a_simCode )
      equation
        txt = ScalarVariable(txt, i_var, a_simCode, a_stateVars, a_FMUVersion);
        txt = Tpl.nextIter(txt);
        txt = lm_53(txt, rest, a_FMUVersion, a_stateVars, a_simCode);
      then txt;
  end match;
end lm_53;

protected function lm_54
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input String in_a_FMUVersion;
  input list<SimCodeVar.SimVar> in_a_stateVars;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_FMUVersion, in_a_stateVars, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      String a_FMUVersion;
      list<SimCodeVar.SimVar> a_stateVars;
      SimCode.SimCode a_simCode;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _,
           _,
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_FMUVersion,
           a_stateVars,
           a_simCode )
      equation
        txt = ScalarVariable(txt, i_var, a_simCode, a_stateVars, a_FMUVersion);
        txt = Tpl.nextIter(txt);
        txt = lm_54(txt, rest, a_FMUVersion, a_stateVars, a_simCode);
      then txt;
  end match;
end lm_54;

protected function lm_55
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input String in_a_FMUVersion;
  input list<SimCodeVar.SimVar> in_a_stateVars;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_FMUVersion, in_a_stateVars, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      String a_FMUVersion;
      list<SimCodeVar.SimVar> a_stateVars;
      SimCode.SimCode a_simCode;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _,
           _,
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_FMUVersion,
           a_stateVars,
           a_simCode )
      equation
        txt = ScalarVariable(txt, i_var, a_simCode, a_stateVars, a_FMUVersion);
        txt = Tpl.nextIter(txt);
        txt = lm_55(txt, rest, a_FMUVersion, a_stateVars, a_simCode);
      then txt;
  end match;
end lm_55;

protected function lm_56
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input String in_a_FMUVersion;
  input list<SimCodeVar.SimVar> in_a_stateVars;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_FMUVersion, in_a_stateVars, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      String a_FMUVersion;
      list<SimCodeVar.SimVar> a_stateVars;
      SimCode.SimCode a_simCode;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _,
           _,
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_FMUVersion,
           a_stateVars,
           a_simCode )
      equation
        txt = ScalarVariable(txt, i_var, a_simCode, a_stateVars, a_FMUVersion);
        txt = Tpl.nextIter(txt);
        txt = lm_56(txt, rest, a_FMUVersion, a_stateVars, a_simCode);
      then txt;
  end match;
end lm_56;

protected function lm_57
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input String in_a_FMUVersion;
  input list<SimCodeVar.SimVar> in_a_stateVars;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_FMUVersion, in_a_stateVars, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      String a_FMUVersion;
      list<SimCodeVar.SimVar> a_stateVars;
      SimCode.SimCode a_simCode;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _,
           _,
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_FMUVersion,
           a_stateVars,
           a_simCode )
      equation
        txt = ScalarVariable(txt, i_var, a_simCode, a_stateVars, a_FMUVersion);
        txt = Tpl.nextIter(txt);
        txt = lm_57(txt, rest, a_FMUVersion, a_stateVars, a_simCode);
      then txt;
  end match;
end lm_57;

protected function lm_58
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input String in_a_FMUVersion;
  input list<SimCodeVar.SimVar> in_a_stateVars;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_FMUVersion, in_a_stateVars, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      String a_FMUVersion;
      list<SimCodeVar.SimVar> a_stateVars;
      SimCode.SimCode a_simCode;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _,
           _,
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_FMUVersion,
           a_stateVars,
           a_simCode )
      equation
        txt = ScalarVariable(txt, i_var, a_simCode, a_stateVars, a_FMUVersion);
        txt = Tpl.nextIter(txt);
        txt = lm_58(txt, rest, a_FMUVersion, a_stateVars, a_simCode);
      then txt;
  end match;
end lm_58;

protected function lm_59
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input String in_a_FMUVersion;
  input list<SimCodeVar.SimVar> in_a_stateVars;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_FMUVersion, in_a_stateVars, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      String a_FMUVersion;
      list<SimCodeVar.SimVar> a_stateVars;
      SimCode.SimCode a_simCode;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _,
           _,
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_FMUVersion,
           a_stateVars,
           a_simCode )
      equation
        txt = ScalarVariable(txt, i_var, a_simCode, a_stateVars, a_FMUVersion);
        txt = Tpl.nextIter(txt);
        txt = lm_59(txt, rest, a_FMUVersion, a_stateVars, a_simCode);
      then txt;
  end match;
end lm_59;

protected function lm_60
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input String in_a_FMUVersion;
  input list<SimCodeVar.SimVar> in_a_stateVars;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_FMUVersion, in_a_stateVars, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      String a_FMUVersion;
      list<SimCodeVar.SimVar> a_stateVars;
      SimCode.SimCode a_simCode;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _,
           _,
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_FMUVersion,
           a_stateVars,
           a_simCode )
      equation
        txt = ScalarVariable(txt, i_var, a_simCode, a_stateVars, a_FMUVersion);
        txt = Tpl.nextIter(txt);
        txt = lm_60(txt, rest, a_FMUVersion, a_stateVars, a_simCode);
      then txt;
  end match;
end lm_60;

protected function lm_61
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input String in_a_FMUVersion;
  input list<SimCodeVar.SimVar> in_a_stateVars;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_FMUVersion, in_a_stateVars, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      String a_FMUVersion;
      list<SimCodeVar.SimVar> a_stateVars;
      SimCode.SimCode a_simCode;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _,
           _,
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_FMUVersion,
           a_stateVars,
           a_simCode )
      equation
        txt = ScalarVariable(txt, i_var, a_simCode, a_stateVars, a_FMUVersion);
        txt = Tpl.nextIter(txt);
        txt = lm_61(txt, rest, a_FMUVersion, a_stateVars, a_simCode);
      then txt;
  end match;
end lm_61;

protected function lm_62
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input String in_a_FMUVersion;
  input list<SimCodeVar.SimVar> in_a_stateVars;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_FMUVersion, in_a_stateVars, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      String a_FMUVersion;
      list<SimCodeVar.SimVar> a_stateVars;
      SimCode.SimCode a_simCode;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _,
           _,
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_FMUVersion,
           a_stateVars,
           a_simCode )
      equation
        txt = ScalarVariable(txt, i_var, a_simCode, a_stateVars, a_FMUVersion);
        txt = Tpl.nextIter(txt);
        txt = lm_62(txt, rest, a_FMUVersion, a_stateVars, a_simCode);
      then txt;
  end match;
end lm_62;

protected function lm_63
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input String in_a_FMUVersion;
  input list<SimCodeVar.SimVar> in_a_stateVars;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_FMUVersion, in_a_stateVars, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      String a_FMUVersion;
      list<SimCodeVar.SimVar> a_stateVars;
      SimCode.SimCode a_simCode;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _,
           _,
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_FMUVersion,
           a_stateVars,
           a_simCode )
      equation
        txt = ScalarVariable(txt, i_var, a_simCode, a_stateVars, a_FMUVersion);
        txt = Tpl.nextIter(txt);
        txt = lm_63(txt, rest, a_FMUVersion, a_stateVars, a_simCode);
      then txt;
  end match;
end lm_63;

protected function lm_64
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input String in_a_FMUVersion;
  input list<SimCodeVar.SimVar> in_a_stateVars;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_FMUVersion, in_a_stateVars, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      String a_FMUVersion;
      list<SimCodeVar.SimVar> a_stateVars;
      SimCode.SimCode a_simCode;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _,
           _,
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_FMUVersion,
           a_stateVars,
           a_simCode )
      equation
        txt = ScalarVariable(txt, i_var, a_simCode, a_stateVars, a_FMUVersion);
        txt = Tpl.nextIter(txt);
        txt = lm_64(txt, rest, a_FMUVersion, a_stateVars, a_simCode);
      then txt;
  end match;
end lm_64;

protected function lm_65
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input String in_a_FMUVersion;
  input list<SimCodeVar.SimVar> in_a_stateVars;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_FMUVersion, in_a_stateVars, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      String a_FMUVersion;
      list<SimCodeVar.SimVar> a_stateVars;
      SimCode.SimCode a_simCode;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _,
           _,
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_FMUVersion,
           a_stateVars,
           a_simCode )
      equation
        txt = ScalarVariable(txt, i_var, a_simCode, a_stateVars, a_FMUVersion);
        txt = Tpl.nextIter(txt);
        txt = lm_65(txt, rest, a_FMUVersion, a_stateVars, a_simCode);
      then txt;
  end match;
end lm_65;

protected function fun_66
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;
  input String in_a_FMUVersion;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo, in_a_FMUVersion, in_a_simCode)
    local
      Tpl.Text txt;
      String a_FMUVersion;
      SimCode.SimCode a_simCode;
      SimCode.ModelInfo i_modelInfo;
      list<SimCodeVar.SimVar> i_vars_stringAliasVars;
      list<SimCodeVar.SimVar> i_vars_stringParamVars;
      list<SimCodeVar.SimVar> i_vars_stringAlgVars;
      list<SimCodeVar.SimVar> i_vars_boolAliasVars;
      list<SimCodeVar.SimVar> i_vars_boolParamVars;
      list<SimCodeVar.SimVar> i_vars_boolAlgVars;
      list<SimCodeVar.SimVar> i_vars_intAliasVars;
      list<SimCodeVar.SimVar> i_vars_intParamVars;
      list<SimCodeVar.SimVar> i_vars_intAlgVars;
      list<SimCodeVar.SimVar> i_vars_aliasVars;
      list<SimCodeVar.SimVar> i_vars_paramVars;
      list<SimCodeVar.SimVar> i_vars_discreteAlgVars;
      list<SimCodeVar.SimVar> i_vars_algVars;
      list<SimCodeVar.SimVar> i_vars_derivativeVars;
      list<SimCodeVar.SimVar> i_stateVars;
      list<SimCodeVar.SimVar> i_vars_stateVars;

    case ( txt,
           (i_modelInfo as SimCode.MODELINFO(vars = SimCodeVar.SIMVARS(stateVars = (i_vars_stateVars as i_stateVars), derivativeVars = i_vars_derivativeVars, algVars = i_vars_algVars, discreteAlgVars = i_vars_discreteAlgVars, paramVars = i_vars_paramVars, aliasVars = i_vars_aliasVars, intAlgVars = i_vars_intAlgVars, intParamVars = i_vars_intParamVars, intAliasVars = i_vars_intAliasVars, boolAlgVars = i_vars_boolAlgVars, boolParamVars = i_vars_boolParamVars, boolAliasVars = i_vars_boolAliasVars, stringAlgVars = i_vars_stringAlgVars, stringParamVars = i_vars_stringParamVars, stringAliasVars = i_vars_stringAliasVars))),
           a_FMUVersion,
           a_simCode )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("<ModelVariables>\n"));
        System.tmpTickReset(0);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_51(txt, i_vars_stateVars, a_FMUVersion, i_stateVars, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_52(txt, i_vars_derivativeVars, a_FMUVersion, i_stateVars, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_53(txt, i_vars_algVars, a_FMUVersion, i_stateVars, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_54(txt, i_vars_discreteAlgVars, a_FMUVersion, i_stateVars, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_55(txt, i_vars_paramVars, a_FMUVersion, i_stateVars, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_56(txt, i_vars_aliasVars, a_FMUVersion, i_stateVars, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        System.tmpTickReset(0);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_57(txt, i_vars_intAlgVars, a_FMUVersion, i_stateVars, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_58(txt, i_vars_intParamVars, a_FMUVersion, i_stateVars, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_59(txt, i_vars_intAliasVars, a_FMUVersion, i_stateVars, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        System.tmpTickReset(0);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_60(txt, i_vars_boolAlgVars, a_FMUVersion, i_stateVars, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_61(txt, i_vars_boolParamVars, a_FMUVersion, i_stateVars, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_62(txt, i_vars_boolAliasVars, a_FMUVersion, i_stateVars, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        System.tmpTickReset(0);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_63(txt, i_vars_stringAlgVars, a_FMUVersion, i_stateVars, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_64(txt, i_vars_stringParamVars, a_FMUVersion, i_stateVars, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_65(txt, i_vars_stringAliasVars, a_FMUVersion, i_stateVars, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        System.tmpTickReset(0);
        txt = Tpl.softNewLine(txt);
        txt = externalFunctions(txt, i_modelInfo);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("</ModelVariables>"));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_66;

public function fmiModelVariables
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input String in_a_FMUVersion;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode, in_a_FMUVersion)
    local
      Tpl.Text txt;
      String a_FMUVersion;
      SimCode.SimCode i_simCode;
      SimCode.ModelInfo i_modelInfo;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = i_modelInfo)),
           a_FMUVersion )
      equation
        txt = fun_66(txt, i_modelInfo, a_FMUVersion, i_simCode);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fmiModelVariables;

protected function lm_68
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input String in_a_FMUVersion;
  input list<SimCodeVar.SimVar> in_a_stateVars;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_FMUVersion, in_a_stateVars, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      String a_FMUVersion;
      list<SimCodeVar.SimVar> a_stateVars;
      SimCode.SimCode a_simCode;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _,
           _,
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_FMUVersion,
           a_stateVars,
           a_simCode )
      equation
        txt = ScalarVariable(txt, i_var, a_simCode, a_stateVars, a_FMUVersion);
        txt = Tpl.nextIter(txt);
        txt = lm_68(txt, rest, a_FMUVersion, a_stateVars, a_simCode);
      then txt;
  end match;
end lm_68;

protected function fun_69
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input list<SimCodeVar.SimVar> in_a_stateVars;
  input SimCode.SimCode in_a_simCode;
  input SimCodeVar.SimVar in_a_simVar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_stateVars, in_a_simCode, in_a_simVar)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> a_stateVars;
      SimCode.SimCode a_simCode;
      SimCodeVar.SimVar a_simVar;
      Integer ret_0;

    case ( txt,
           false,
           _,
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_stateVars,
           a_simCode,
           a_simVar )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<!-- Index of variable = \""));
        ret_0 = SimCodeUtil.getVariableFMIIndex(a_simVar);
        txt = Tpl.writeStr(txt, intString(ret_0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\" -->\n",
                                    "<ScalarVariable\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = ScalarVariableAttribute2(txt, a_simVar, a_simCode);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(">\n"));
        txt = ScalarVariableType2(txt, a_simVar, a_stateVars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("</ScalarVariable>"));
      then txt;
  end match;
end fun_69;

protected function fun_70
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input list<SimCodeVar.SimVar> in_a_stateVars;
  input SimCode.SimCode in_a_simCode;
  input Option<DAE.ComponentRef> in_a_exportVar;
  input SimCodeVar.SimVar in_a_simVar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_stateVars, in_a_simCode, in_a_exportVar, in_a_simVar)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> a_stateVars;
      SimCode.SimCode a_simCode;
      Option<DAE.ComponentRef> a_exportVar;
      SimCodeVar.SimVar a_simVar;
      Boolean ret_0;

    case ( txt,
           false,
           _,
           _,
           _,
           a_simVar )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("<ScalarVariable\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = ScalarVariableAttribute(txt, a_simVar);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(">\n"));
        txt = ScalarVariableType(txt, a_simVar);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("</ScalarVariable>"));
      then txt;

    case ( txt,
           _,
           a_stateVars,
           a_simCode,
           a_exportVar,
           a_simVar )
      equation
        ret_0 = Util.isSome(a_exportVar);
        txt = fun_69(txt, ret_0, a_stateVars, a_simCode, a_simVar);
      then txt;
  end match;
end fun_70;

protected function fun_71
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input list<SimCodeVar.SimVar> in_a_stateVars;
  input SimCode.SimCode in_a_simCode;
  input Option<DAE.ComponentRef> in_a_exportVar;
  input SimCodeVar.SimVar in_a_simVar;
  input String in_a_FMUVersion;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_stateVars, in_a_simCode, in_a_exportVar, in_a_simVar, in_a_FMUVersion)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> a_stateVars;
      SimCode.SimCode a_simCode;
      Option<DAE.ComponentRef> a_exportVar;
      SimCodeVar.SimVar a_simVar;
      String a_FMUVersion;
      Boolean ret_0;

    case ( txt,
           false,
           a_stateVars,
           a_simCode,
           a_exportVar,
           a_simVar,
           a_FMUVersion )
      equation
        ret_0 = FMI.isFMIVersion20(a_FMUVersion);
        txt = fun_70(txt, ret_0, a_stateVars, a_simCode, a_exportVar, a_simVar);
      then txt;

    case ( txt,
           _,
           _,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_71;

protected function fun_72
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input list<SimCodeVar.SimVar> in_a_stateVars;
  input SimCode.SimCode in_a_simCode;
  input Option<DAE.ComponentRef> in_a_exportVar;
  input SimCodeVar.SimVar in_a_simVar;
  input String in_a_FMUVersion;
  input DAE.ComponentRef in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_stateVars, in_a_simCode, in_a_exportVar, in_a_simVar, in_a_FMUVersion, in_a_name)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> a_stateVars;
      SimCode.SimCode a_simCode;
      Option<DAE.ComponentRef> a_exportVar;
      SimCodeVar.SimVar a_simVar;
      String a_FMUVersion;
      DAE.ComponentRef a_name;
      Boolean ret_1;
      Tpl.Text txt_0;

    case ( txt,
           false,
           a_stateVars,
           a_simCode,
           a_exportVar,
           a_simVar,
           a_FMUVersion,
           a_name )
      equation
        txt_0 = CodegenUtil.crefStr(Tpl.emptyTxt, a_name);
        ret_1 = stringEq(Tpl.textString(txt_0), "der($dummy)");
        txt = fun_71(txt, ret_1, a_stateVars, a_simCode, a_exportVar, a_simVar, a_FMUVersion);
      then txt;

    case ( txt,
           _,
           _,
           _,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_72;

public function ScalarVariable
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_a_simVar;
  input SimCode.SimCode in_a_simCode;
  input list<SimCodeVar.SimVar> in_a_stateVars;
  input String in_a_FMUVersion;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simVar, in_a_simCode, in_a_stateVars, in_a_FMUVersion)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      list<SimCodeVar.SimVar> a_stateVars;
      String a_FMUVersion;
      Option<DAE.ComponentRef> i_exportVar;
      DAE.ComponentRef i_name;
      SimCodeVar.SimVar i_simVar;
      Boolean ret_2;
      Tpl.Text txt_1;
      list<SimCodeVar.SimVar> ret_0;

    case ( txt,
           (i_simVar as SimCodeVar.SIMVAR(type_ = DAE.T_ARRAY(ty = _))),
           a_simCode,
           a_stateVars,
           a_FMUVersion )
      equation
        ret_0 = SimCodeUtil.getScalarElements(i_simVar);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_68(txt, ret_0, a_FMUVersion, a_stateVars, a_simCode);
        txt = Tpl.popIter(txt);
      then txt;

    case ( txt,
           (i_simVar as SimCodeVar.SIMVAR(name = i_name, exportVar = i_exportVar)),
           a_simCode,
           a_stateVars,
           a_FMUVersion )
      equation
        txt_1 = CodegenUtil.crefStr(Tpl.emptyTxt, i_name);
        ret_2 = stringEq(Tpl.textString(txt_1), "$dummy");
        txt = fun_72(txt, ret_2, a_stateVars, a_simCode, i_exportVar, i_simVar, a_FMUVersion, i_name);
      then txt;

    case ( txt,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end ScalarVariable;

protected function fun_74
  input Tpl.Text in_txt;
  input String in_a_comment;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_comment)
    local
      Tpl.Text txt;
      String i_comment;
      String ret_0;

    case ( txt,
           "" )
      then txt;

    case ( txt,
           i_comment )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("description=\""));
        ret_0 = Util.escapeModelicaStringToXmlString(i_comment);
        txt = Tpl.writeStr(txt, ret_0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
      then txt;
  end match;
end fun_74;

public function ScalarVariableAttribute
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_a_simVar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simVar)
    local
      Tpl.Text txt;
      DAE.ComponentRef i_name;
      Option<SimCodeVar.Causality> i_causality;
      SimCodeVar.AliasVariable i_aliasvar;
      String i_comment;
      Option<SimCodeVar.Variability> i_variability;
      String ret_7;
      Tpl.Text txt_6;
      Tpl.Text l_caus;
      Tpl.Text l_alias;
      Tpl.Text l_description;
      Tpl.Text l_variability__;
      Integer ret_1;
      Tpl.Text l_valueReference;

    case ( txt,
           SimCodeVar.SIMVAR(variability = i_variability, comment = i_comment, aliasvar = i_aliasvar, causality = i_causality, name = i_name) )
      equation
        ret_1 = System.tmpTick();
        l_valueReference = Tpl.writeStr(Tpl.emptyTxt, intString(ret_1));
        l_variability__ = getVariability(Tpl.emptyTxt, i_variability);
        l_description = fun_74(Tpl.emptyTxt, i_comment);
        l_alias = getAliasVar(Tpl.emptyTxt, i_aliasvar);
        l_caus = getCausality(Tpl.emptyTxt, i_causality);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("name=\""));
        txt_6 = CodegenUtil.crefStrNoUnderscore(Tpl.emptyTxt, i_name);
        ret_7 = System.stringReplace(Tpl.textString(txt_6), "$", "_D_");
        txt = Tpl.writeStr(txt, ret_7);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\"\n",
                                    "valueReference=\""
                                }, false));
        txt = Tpl.writeText(txt, l_valueReference);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("\"\n"));
        txt = Tpl.writeText(txt, l_description);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("variability=\""));
        txt = Tpl.writeText(txt, l_variability__);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\"\n",
                                    "causality=\""
                                }, false));
        txt = Tpl.writeText(txt, l_caus);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\"\n",
                                    "alias=\""
                                }, false));
        txt = Tpl.writeText(txt, l_alias);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end ScalarVariableAttribute;

public function getCausality
  input Tpl.Text in_txt;
  input Option<SimCodeVar.Causality> in_a_c;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_c)
    local
      Tpl.Text txt;

    case ( txt,
           SOME(SimCodeVar.NONECAUS()) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("none"));
      then txt;

    case ( txt,
           SOME(SimCodeVar.OUTPUT()) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("output"));
      then txt;

    case ( txt,
           SOME(SimCodeVar.INPUT()) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("input"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("internal"));
      then txt;
  end match;
end getCausality;

public function getVariability
  input Tpl.Text in_txt;
  input Option<SimCodeVar.Variability> in_a_variability__;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_variability__)
    local
      Tpl.Text txt;

    case ( txt,
           SOME(SimCodeVar.DISCRETE()) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("discrete"));
      then txt;

    case ( txt,
           SOME(SimCodeVar.FIXED()) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("parameter"));
      then txt;

    case ( txt,
           SOME(SimCodeVar.CONSTANT()) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("constant"));
      then txt;

    case ( txt,
           SOME(SimCodeVar.CONTINUOUS()) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("continuous"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("continuous"));
      then txt;
  end match;
end getVariability;

public function getAliasVar
  input Tpl.Text in_txt;
  input SimCodeVar.AliasVariable in_a_aliasvar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_aliasvar)
    local
      Tpl.Text txt;

    case ( txt,
           SimCodeVar.NOALIAS() )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("noAlias"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("noAlias"));
      then txt;
  end match;
end getAliasVar;

protected function fun_79
  input Tpl.Text in_txt;
  input DAE.Type in_a_type__;
  input SimCodeVar.SimVar in_a_simvar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_type__, in_a_simvar)
    local
      Tpl.Text txt;
      SimCodeVar.SimVar a_simvar;
      Absyn.Path i_path;
      String ret_0;

    case ( txt,
           DAE.T_INTEGER(varLst = _),
           a_simvar )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<Integer"));
        txt = StartString(txt, a_simvar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/>"));
      then txt;

    case ( txt,
           DAE.T_REAL(varLst = _),
           a_simvar )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<Real"));
        txt = StartString(txt, a_simvar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/>"));
      then txt;

    case ( txt,
           DAE.T_BOOL(varLst = _),
           a_simvar )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<Boolean"));
        txt = StartString(txt, a_simvar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/>"));
      then txt;

    case ( txt,
           DAE.T_STRING(varLst = _),
           a_simvar )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<String"));
        txt = StartString(txt, a_simvar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/>"));
      then txt;

    case ( txt,
           DAE.T_ENUMERATION(path = i_path),
           a_simvar )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<Enumeration declaredType=\""));
        ret_0 = AbsynUtil.pathString(i_path, ".", false);
        txt = Tpl.writeStr(txt, ret_0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        txt = StartString(txt, a_simvar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/>"));
      then txt;

    case ( txt,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("UNKOWN_TYPE"));
      then txt;
  end match;
end fun_79;

public function ScalarVariableType
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_a_simvar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simvar)
    local
      Tpl.Text txt;
      SimCodeVar.SimVar i_simvar;
      DAE.Type i_type__;

    case ( txt,
           (i_simvar as SimCodeVar.SIMVAR(type_ = i_type__)) )
      equation
        txt = fun_79(txt, i_type__, i_simvar);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end ScalarVariableType;

protected function fun_81
  input Tpl.Text in_txt;
  input Option<SimCodeVar.Causality> in_a_causality;
  input DAE.Type in_a_type__;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_causality, in_a_type__)
    local
      Tpl.Text txt;
      DAE.Type a_type__;

    case ( txt,
           SOME(SimCodeVar.INPUT()),
           a_type__ )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("start=\""));
        txt = CodegenUtil.initDefaultValXml(txt, a_type__);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_81;

protected function fun_82
  input Tpl.Text in_txt;
  input Option<DAE.Exp> in_a_initialValue;
  input DAE.Type in_a_type__;
  input Option<SimCodeVar.Causality> in_a_causality;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_initialValue, in_a_type__, in_a_causality)
    local
      Tpl.Text txt;
      DAE.Type a_type__;
      Option<SimCodeVar.Causality> a_causality;
      DAE.Exp i_e;

    case ( txt,
           SOME((i_e as DAE.ICONST(integer = _))),
           _,
           _ )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("start=\""));
        txt = CodegenUtil.initValXml(txt, i_e);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           SOME((i_e as DAE.RCONST(real = _))),
           _,
           _ )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("start=\""));
        txt = CodegenUtil.initValXml(txt, i_e);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           SOME((i_e as DAE.SCONST(string = _))),
           _,
           _ )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("start=\""));
        txt = CodegenUtil.initValXml(txt, i_e);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           SOME((i_e as DAE.BCONST(bool = _))),
           _,
           _ )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("start=\""));
        txt = CodegenUtil.initValXml(txt, i_e);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           SOME((i_e as DAE.ENUM_LITERAL(name = _))),
           _,
           _ )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("start=\""));
        txt = CodegenUtil.initValXml(txt, i_e);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           _,
           a_type__,
           a_causality )
      equation
        txt = fun_81(txt, a_causality, a_type__);
      then txt;
  end match;
end fun_82;

public function StartString
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_a_simvar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simvar)
    local
      Tpl.Text txt;
      DAE.Type i_type__;
      Option<SimCodeVar.Causality> i_causality;
      Option<DAE.Exp> i_initialValue;

    case ( txt,
           SimCodeVar.SIMVAR(initialValue = i_initialValue, causality = i_causality, type_ = i_type__) )
      equation
        txt = fun_82(txt, i_initialValue, i_type__, i_causality);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end StartString;

protected function fun_84
  input Tpl.Text in_txt;
  input String in_a_unit;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_unit)
    local
      Tpl.Text txt;
      String i_unit;

    case ( txt,
           "" )
      then txt;

    case ( txt,
           i_unit )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("unit=\""));
        txt = Tpl.writeStr(txt, i_unit);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
      then txt;
  end match;
end fun_84;

protected function fun_85
  input Tpl.Text in_txt;
  input String in_a_displayUnit;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_displayUnit)
    local
      Tpl.Text txt;
      String i_displayUnit;

    case ( txt,
           "" )
      then txt;

    case ( txt,
           i_displayUnit )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("displayUnit=\""));
        txt = Tpl.writeStr(txt, i_displayUnit);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
      then txt;
  end match;
end fun_85;

public function ScalarVariableTypeRealAttribute
  input Tpl.Text txt;
  input String a_unit;
  input String a_displayUnit;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_displayUnit__;
  Tpl.Text l_unit__;
algorithm
  l_unit__ := fun_84(Tpl.emptyTxt, a_unit);
  l_displayUnit__ := fun_85(Tpl.emptyTxt, a_displayUnit);
  out_txt := Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
  out_txt := Tpl.writeText(out_txt, l_unit__);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING(" "));
  out_txt := Tpl.writeText(out_txt, l_displayUnit__);
  out_txt := Tpl.popBlock(out_txt);
end ScalarVariableTypeRealAttribute;

protected function lm_87
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Function> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Function> rest;
      SimCodeFunction.Function i_fn;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_fn :: rest )
      equation
        txt = externalFunction(txt, i_fn);
        txt = Tpl.nextIter(txt);
        txt = lm_87(txt, rest);
      then txt;
  end match;
end lm_87;

public function externalFunctions
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Function> i_functions;

    case ( txt,
           SimCode.MODELINFO(functions = i_functions) )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_87(txt, i_functions);
        txt = Tpl.popIter(txt);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end externalFunctions;

public function externalFunction
  input Tpl.Text in_txt;
  input SimCodeFunction.Function in_a_fn;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fn)
    local
      Tpl.Text txt;
      String i_language;
      String i_extName;
      Integer ret_1;
      Tpl.Text l_fname;

    case ( txt,
           SimCodeFunction.EXTERNAL_FUNCTION(dynamicLoad = true, extName = i_extName, language = i_language) )
      equation
        l_fname = CodegenCFunctions.extFunctionName(Tpl.emptyTxt, i_extName, i_language);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("<ExternalFunction\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("name=\""));
        txt = Tpl.writeText(txt, l_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\"\n",
                                    "valueReference=\""
                                }, false));
        ret_1 = System.tmpTick();
        txt = Tpl.writeStr(txt, intString(ret_1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\"/>"));
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end externalFunction;

public function Implementation
  input Tpl.Text txt;

  output Tpl.Text out_txt;
algorithm
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                   "<Implementation>\n",
                                   "  <CoSimulation_StandAlone>\n",
                                   "    <Capabilities\n",
                                   "      canHandleVariableCommunicationStepSize=\"true\"\n",
                                   "      canHandleEvents=\"true\"\n",
                                   "      canBeInstantiatedOnlyOncePerProcess=\"false\"\n",
                                   "      canInterpolateInputs=\"true\"\n",
                                   "      maxOutputDerivativeOrder=\"0\"/>\n",
                                   "  </CoSimulation_StandAlone>\n",
                                   "</Implementation>"
                               }, false));
end Implementation;

public function ModelStructure
  input Tpl.Text in_txt;
  input Option<SimCode.FmiModelStructure> in_a_fmiModelStructure;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fmiModelStructure)
    local
      Tpl.Text txt;
      SimCode.FmiInitialUnknowns i_fmistruct_fmiInitialUnknowns;
      SimCode.FmiDiscreteStates i_fmistruct_fmiDiscreteStates;
      SimCode.FmiDerivatives i_fmistruct_fmiDerivatives;
      SimCode.FmiOutputs i_fmistruct_fmiOutputs;

    case ( txt,
           SOME(SimCode.FMIMODELSTRUCTURE(fmiOutputs = i_fmistruct_fmiOutputs, fmiDerivatives = i_fmistruct_fmiDerivatives, fmiDiscreteStates = i_fmistruct_fmiDiscreteStates, fmiInitialUnknowns = i_fmistruct_fmiInitialUnknowns)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("<ModelStructure>\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = ModelStructureOutputs(txt, i_fmistruct_fmiOutputs);
        txt = Tpl.softNewLine(txt);
        txt = ModelStructureDerivatives(txt, i_fmistruct_fmiDerivatives);
        txt = Tpl.softNewLine(txt);
        txt = ModelStructureDiscreteStates(txt, i_fmistruct_fmiDiscreteStates);
        txt = Tpl.softNewLine(txt);
        txt = ModelStructureInitialUnknowns(txt, i_fmistruct_fmiInitialUnknowns);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("</ModelStructure>"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "<ModelStructure>\n",
                                    "</ModelStructure>"
                                }, false));
      then txt;
  end match;
end ModelStructure;

protected function fun_92
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_snom;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_snom)
    local
      Tpl.Text txt;
      Integer a_snom;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_snom )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("shiftCounter=\""));
        txt = Tpl.writeStr(txt, intString(a_snom));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
      then txt;
  end match;
end fun_92;

protected function fun_93
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_sres;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_sres)
    local
      Tpl.Text txt;
      Integer a_sres;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_sres )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("resolution=\""));
        txt = Tpl.writeStr(txt, intString(a_sres));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
      then txt;
  end match;
end fun_93;

protected function fun_94
  input Tpl.Text in_txt;
  input SimCode.SubPartition in_a_subPartition;
  input Real in_a_bi;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_subPartition, in_a_bi)
    local
      Tpl.Text txt;
      Real a_bi;
      Integer i_sres;
      Integer i_snom;
      Integer i_fsuper;
      Integer i_fsub;
      Boolean ret_5;
      Boolean ret_4;
      Real ret_3;
      Real ret_2;
      Real ret_1;
      Real ret_0;

    case ( txt,
           SimCode.SUBPARTITION(subClock = BackendDAE.SUBCLOCK(factor = MMath.RATIONAL(nom = i_fsub, denom = i_fsuper), shift = MMath.RATIONAL(nom = i_snom, denom = i_sres))),
           a_bi )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("<Clock><Inferred\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(8));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("interval=\""));
        ret_0 = intReal(i_fsub);
        ret_1 = intReal(i_fsuper);
        ret_2 = realDiv(ret_0, ret_1);
        ret_3 = realMul(a_bi, ret_2);
        txt = Tpl.writeStr(txt, realString(ret_3));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("\"\n"));
        ret_4 = intGt(i_snom, 0);
        txt = fun_92(txt, ret_4, i_snom);
        txt = Tpl.softNewLine(txt);
        ret_5 = intGt(i_sres, 1);
        txt = fun_93(txt, ret_5, i_sres);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/></Clock>"));
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_94;

protected function lm_95
  input Tpl.Text in_txt;
  input list<SimCode.SubPartition> in_items;
  input Real in_a_bi;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_bi)
    local
      Tpl.Text txt;
      list<SimCode.SubPartition> rest;
      Real a_bi;
      SimCode.SubPartition i_subPartition;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_subPartition :: rest,
           a_bi )
      equation
        txt = fun_94(txt, i_subPartition, a_bi);
        txt = Tpl.nextIter(txt);
        txt = lm_95(txt, rest, a_bi);
      then txt;
  end match;
end lm_95;

protected function fun_96
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_fsuper;
  input Integer in_a_resi;
  input Integer in_a_snom;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_fsuper, in_a_resi, in_a_snom)
    local
      Tpl.Text txt;
      Integer a_fsuper;
      Integer a_resi;
      Integer a_snom;
      Integer ret_1;
      Integer ret_0;

    case ( txt,
           false,
           _,
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_fsuper,
           a_resi,
           a_snom )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("shiftCounter=\""));
        ret_0 = intMul(a_snom, a_resi);
        ret_1 = intMul(ret_0, a_fsuper);
        txt = Tpl.writeStr(txt, intString(ret_1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
      then txt;
  end match;
end fun_96;

protected function fun_97
  input Tpl.Text in_txt;
  input SimCode.SubPartition in_a_subPartition;
  input Integer in_a_resi;
  input Integer in_a_bic;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_subPartition, in_a_resi, in_a_bic)
    local
      Tpl.Text txt;
      Integer a_resi;
      Integer a_bic;
      Integer i_fsuper;
      Integer i_snom;
      Integer i_sres;
      Integer i_fsub;
      Integer ret_4;
      Integer ret_3;
      Boolean ret_2;
      Integer ret_1;
      Integer ret_0;

    case ( txt,
           SimCode.SUBPARTITION(subClock = BackendDAE.SUBCLOCK(factor = MMath.RATIONAL(nom = i_fsub, denom = i_fsuper), shift = MMath.RATIONAL(nom = i_snom, denom = i_sres))),
           a_resi,
           a_bic )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("<Clock><Inferred\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(8));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("intervalCounter=\""));
        ret_0 = intMul(a_bic, i_fsub);
        ret_1 = intMul(ret_0, i_sres);
        txt = Tpl.writeStr(txt, intString(ret_1));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("\"\n"));
        ret_2 = intGt(i_snom, 0);
        txt = fun_96(txt, ret_2, i_fsuper, a_resi, i_snom);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("resolution=\""));
        ret_3 = intMul(a_resi, i_sres);
        ret_4 = intMul(ret_3, i_fsuper);
        txt = Tpl.writeStr(txt, intString(ret_4));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\"\n",
                                    "/></Clock>"
                                }, false));
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_97;

protected function lm_98
  input Tpl.Text in_txt;
  input list<SimCode.SubPartition> in_items;
  input Integer in_a_resi;
  input Integer in_a_bic;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_resi, in_a_bic)
    local
      Tpl.Text txt;
      list<SimCode.SubPartition> rest;
      Integer a_resi;
      Integer a_bic;
      SimCode.SubPartition i_subPartition;

    case ( txt,
           {},
           _,
           _ )
      then txt;

    case ( txt,
           i_subPartition :: rest,
           a_resi,
           a_bic )
      equation
        txt = fun_97(txt, i_subPartition, a_resi, a_bic);
        txt = Tpl.nextIter(txt);
        txt = lm_98(txt, rest, a_resi, a_bic);
      then txt;
  end match;
end lm_98;

protected function fun_99
  input Tpl.Text in_txt;
  input DAE.ClockKind in_a_baseClock;
  input list<SimCode.SubPartition> in_a_subPartitions;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_baseClock, in_a_subPartitions)
    local
      Tpl.Text txt;
      list<SimCode.SubPartition> a_subPartitions;
      Integer i_resi;
      Integer i_bic;
      Real i_bi;

    case ( txt,
           DAE.REAL_CLOCK(interval = DAE.RCONST(real = i_bi)),
           a_subPartitions )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_95(txt, a_subPartitions, i_bi);
        txt = Tpl.popIter(txt);
      then txt;

    case ( txt,
           DAE.INTEGER_CLOCK(intervalCounter = DAE.ICONST(integer = i_bic), resolution = DAE.ICONST(integer = i_resi)),
           a_subPartitions )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_98(txt, a_subPartitions, i_resi, i_bic);
        txt = Tpl.popIter(txt);
      then txt;

    case ( txt,
           DAE.REAL_CLOCK(interval = _),
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<Clock><Inferred/></Clock>"));
      then txt;

    case ( txt,
           DAE.INTEGER_CLOCK(intervalCounter = _),
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<Clock><Inferred/></Clock>"));
      then txt;

    case ( txt,
           DAE.INFERRED_CLOCK(),
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<Clock><Inferred/></Clock>"));
      then txt;

    case ( txt,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<Clock><Triggered/></Clock>"));
      then txt;
  end match;
end fun_99;

protected function fun_100
  input Tpl.Text in_txt;
  input SimCode.ClockedPartition in_a_partition;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_partition)
    local
      Tpl.Text txt;
      list<SimCode.SubPartition> i_subPartitions;
      DAE.ClockKind i_baseClock;

    case ( txt,
           SimCode.CLOCKED_PARTITION(baseClock = i_baseClock, subPartitions = i_subPartitions) )
      equation
        txt = fun_99(txt, i_baseClock, i_subPartitions);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_100;

protected function lm_101
  input Tpl.Text in_txt;
  input list<SimCode.ClockedPartition> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.ClockedPartition> rest;
      SimCode.ClockedPartition i_partition;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_partition :: rest )
      equation
        txt = fun_100(txt, i_partition);
        txt = Tpl.nextIter(txt);
        txt = lm_101(txt, rest);
      then txt;
  end match;
end lm_101;

protected function fun_102
  input Tpl.Text in_txt;
  input String in_mArg;
  input Tpl.Text in_a_clocks;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_clocks)
    local
      Tpl.Text txt;
      Tpl.Text a_clocks;

    case ( txt,
           "",
           _ )
      then txt;

    case ( txt,
           _,
           a_clocks )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("<Clocks>\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_clocks);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("</Clocks>"));
      then txt;
  end match;
end fun_102;

public function TypeDefinitionsClocks
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCode.ClockedPartition> i_clockedPartitions;
      String str_1;
      Tpl.Text l_clocks;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = _), clockedPartitions = i_clockedPartitions) )
      equation
        l_clocks = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_clocks = lm_101(l_clocks, i_clockedPartitions);
        l_clocks = Tpl.popIter(l_clocks);
        str_1 = Tpl.textString(l_clocks);
        txt = fun_102(txt, str_1, l_clocks);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end TypeDefinitionsClocks;

public function ModelStructureOutputs
  input Tpl.Text in_txt;
  input SimCode.FmiOutputs in_a_fmiOutputs;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fmiOutputs)
    local
      Tpl.Text txt;
      list<SimCode.FmiUnknown> i_fmiUnknownsList;

    case ( txt,
           SimCode.FMIOUTPUTS(fmiUnknownsList = {}) )
      then txt;

    case ( txt,
           SimCode.FMIOUTPUTS(fmiUnknownsList = i_fmiUnknownsList) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("<Outputs>\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = ModelStructureUnknowns(txt, i_fmiUnknownsList);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("</Outputs>"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end ModelStructureOutputs;

public function ModelStructureDerivatives
  input Tpl.Text in_txt;
  input SimCode.FmiDerivatives in_a_fmiDerivatives;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fmiDerivatives)
    local
      Tpl.Text txt;
      list<SimCode.FmiUnknown> i_fmiUnknownsList;

    case ( txt,
           SimCode.FMIDERIVATIVES(fmiUnknownsList = {}) )
      then txt;

    case ( txt,
           SimCode.FMIDERIVATIVES(fmiUnknownsList = i_fmiUnknownsList) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("<Derivatives>\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = ModelStructureUnknowns(txt, i_fmiUnknownsList);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("</Derivatives>"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end ModelStructureDerivatives;

public function ModelStructureDiscreteStates
  input Tpl.Text in_txt;
  input SimCode.FmiDiscreteStates in_a_fmiDiscreteStates;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fmiDiscreteStates)
    local
      Tpl.Text txt;
      list<SimCode.FmiUnknown> i_fmiUnknownsList;

    case ( txt,
           SimCode.FMIDISCRETESTATES(fmiUnknownsList = {}) )
      then txt;

    case ( txt,
           SimCode.FMIDISCRETESTATES(fmiUnknownsList = i_fmiUnknownsList) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("<DiscreteStates>\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = ModelStructureUnknowns(txt, i_fmiUnknownsList);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("</DiscreteStates>"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end ModelStructureDiscreteStates;

public function ModelStructureInitialUnknowns
  input Tpl.Text in_txt;
  input SimCode.FmiInitialUnknowns in_a_fmiInitialUnknowns;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fmiInitialUnknowns)
    local
      Tpl.Text txt;
      list<SimCode.FmiUnknown> i_fmiUnknownsList;

    case ( txt,
           SimCode.FMIINITIALUNKNOWNS(fmiUnknownsList = {}) )
      then txt;

    case ( txt,
           SimCode.FMIINITIALUNKNOWNS(fmiUnknownsList = i_fmiUnknownsList) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("<InitialUnknowns>\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = ModelStructureUnknowns(txt, i_fmiUnknownsList);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("</InitialUnknowns>"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end ModelStructureInitialUnknowns;

protected function lm_108
  input Tpl.Text in_txt;
  input list<SimCode.FmiUnknown> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.FmiUnknown> rest;
      SimCode.FmiUnknown i_fmiUnknown;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_fmiUnknown :: rest )
      equation
        txt = FmiUnknownAttributes(txt, i_fmiUnknown);
        txt = Tpl.nextIter(txt);
        txt = lm_108(txt, rest);
      then txt;
  end match;
end lm_108;

public function ModelStructureUnknowns
  input Tpl.Text txt;
  input list<SimCode.FmiUnknown> a_fmiUnknownsList;

  output Tpl.Text out_txt;
algorithm
  out_txt := Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_108(out_txt, a_fmiUnknownsList);
  out_txt := Tpl.popIter(out_txt);
end ModelStructureUnknowns;

public function FmiUnknownAttributes
  input Tpl.Text in_txt;
  input SimCode.FmiUnknown in_a_fmiUnknown;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fmiUnknown)
    local
      Tpl.Text txt;
      list<String> i_dependenciesKind;
      list<Integer> i_dependencies;
      Integer i_index;

    case ( txt,
           SimCode.FMIUNKNOWN(index = i_index, dependencies = i_dependencies, dependenciesKind = i_dependenciesKind) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<Unknown index=\""));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        txt = FmiUnknownDependencies(txt, i_dependencies);
        txt = FmiUnknownDependenciesKind(txt, i_dependenciesKind);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" />"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end FmiUnknownAttributes;

protected function lm_111
  input Tpl.Text in_txt;
  input list<Integer> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<Integer> rest;
      Integer i_dependency;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_dependency :: rest )
      equation
        txt = Tpl.writeStr(txt, intString(i_dependency));
        txt = Tpl.nextIter(txt);
        txt = lm_111(txt, rest);
      then txt;
  end match;
end lm_111;

public function FmiUnknownDependencies
  input Tpl.Text txt;
  input list<Integer> a_dependencies;

  output Tpl.Text out_txt;
algorithm
  out_txt := Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("dependencies=\""));
  out_txt := Tpl.pushIter(out_txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(" ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_111(out_txt, a_dependencies);
  out_txt := Tpl.popIter(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("\""));
  out_txt := Tpl.popBlock(out_txt);
end FmiUnknownDependencies;

protected function lm_113
  input Tpl.Text in_txt;
  input list<String> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<String> rest;
      String i_dependencyKind;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_dependencyKind :: rest )
      equation
        txt = Tpl.writeStr(txt, i_dependencyKind);
        txt = Tpl.nextIter(txt);
        txt = lm_113(txt, rest);
      then txt;
  end match;
end lm_113;

public function FmiUnknownDependenciesKind
  input Tpl.Text txt;
  input list<String> a_dependenciesKind;

  output Tpl.Text out_txt;
algorithm
  out_txt := Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("dependenciesKind=\""));
  out_txt := Tpl.pushIter(out_txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(" ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_113(out_txt, a_dependenciesKind);
  out_txt := Tpl.popIter(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("\""));
  out_txt := Tpl.popBlock(out_txt);
end FmiUnknownDependenciesKind;

protected function fun_115
  input Tpl.Text in_txt;
  input String in_a_comment;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_comment)
    local
      Tpl.Text txt;
      String i_comment;
      String ret_0;

    case ( txt,
           "" )
      then txt;

    case ( txt,
           i_comment )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("description=\""));
        ret_0 = Util.escapeModelicaStringToXmlString(i_comment);
        txt = Tpl.writeStr(txt, ret_0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
      then txt;
  end match;
end fun_115;

protected function fun_116
  input Tpl.Text in_txt;
  input Option<Integer> in_mArg;
  input Option<SimCodeVar.Variability> in_a_variability;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_variability)
    local
      Tpl.Text txt;
      Option<SimCodeVar.Variability> a_variability;

    case ( txt,
           NONE(),
           a_variability )
      equation
        txt = getVariability2(txt, a_variability);
      then txt;

    case ( txt,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("discrete"));
      then txt;
  end match;
end fun_116;

protected function fun_117
  input Tpl.Text in_txt;
  input Option<Integer> in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;
      Integer i_val;

    case ( txt,
           SOME(i_val) )
      equation
        txt = Tpl.writeStr(txt, intString(i_val));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_117;

protected function fun_118
  input Tpl.Text in_txt;
  input BackendDAE.VarKind in_a_varKind;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_varKind, in_a_simCode)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      DAE.ComponentRef i_previousName;
      Integer ret_1;
      SimCodeVar.SimVar ret_0;

    case ( txt,
           BackendDAE.CLOCKED_STATE(previousName = i_previousName),
           a_simCode )
      equation
        ret_0 = SimCodeUtil.cref2simvar(i_previousName, a_simCode);
        ret_1 = SimCodeUtil.getVariableIndex(ret_0);
        txt = Tpl.writeStr(txt, intString(ret_1));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_118;

protected function fun_119
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_variability__;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_variability__)
    local
      Tpl.Text txt;
      Tpl.Text a_variability__;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_variability__ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("variability=\""));
        txt = Tpl.writeText(txt, a_variability__);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
      then txt;
  end match;
end fun_119;

protected function fun_120
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_caus;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_caus)
    local
      Tpl.Text txt;
      Tpl.Text a_caus;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_caus )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("causality=\""));
        txt = Tpl.writeText(txt, a_caus);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
      then txt;
  end match;
end fun_120;

protected function fun_121
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_clockIndex;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_clockIndex)
    local
      Tpl.Text txt;
      Tpl.Text a_clockIndex;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_clockIndex )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("clockIndex=\""));
        txt = Tpl.writeText(txt, a_clockIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
      then txt;
  end match;
end fun_121;

protected function fun_122
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_previous;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_previous)
    local
      Tpl.Text txt;
      Tpl.Text a_previous;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_previous )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("previous=\""));
        txt = Tpl.writeText(txt, a_previous);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
      then txt;
  end match;
end fun_122;

protected function fun_123
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_initial;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_initial)
    local
      Tpl.Text txt;
      Tpl.Text a_initial;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_initial )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("initial=\""));
        txt = Tpl.writeText(txt, a_initial);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
      then txt;
  end match;
end fun_123;

public function ScalarVariableAttribute2
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_a_simVar;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simVar, in_a_simCode)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      Option<DAE.ComponentRef> i_exportVar;
      Option<SimCodeVar.Initial> i_initial__;
      Option<SimCodeVar.Causality> i_causality;
      BackendDAE.VarKind i_varKind;
      Option<SimCodeVar.Variability> i_variability;
      String i_comment;
      SimCodeVar.SimVar i_simVar;
      Boolean ret_24;
      Boolean ret_23;
      Boolean ret_22;
      Boolean ret_21;
      Boolean ret_20;
      Boolean ret_19;
      Boolean ret_18;
      Boolean ret_17;
      Boolean ret_16;
      Boolean ret_15;
      String ret_14;
      Tpl.Text txt_13;
      DAE.ComponentRef ret_12;
      Tpl.Text l_initial;
      Tpl.Text l_caus;
      Tpl.Text l_previous;
      Option<Integer> ret_8;
      Tpl.Text l_clockIndex;
      Option<Integer> ret_6;
      Tpl.Text l_variability__;
      Tpl.Text l_description;
      String ret_3;
      Tpl.Text l_valueReference;
      Integer ret_1;
      Tpl.Text l_defaultValueReference;

    case ( txt,
           (i_simVar as SimCodeVar.SIMVAR(comment = i_comment, variability = i_variability, varKind = i_varKind, causality = i_causality, initial_ = i_initial__, exportVar = i_exportVar)),
           a_simCode )
      equation
        ret_1 = System.tmpTick();
        l_defaultValueReference = Tpl.writeStr(Tpl.emptyTxt, intString(ret_1));
        ret_3 = SimCodeUtil.getValueReference(i_simVar, a_simCode, false);
        l_valueReference = Tpl.writeStr(Tpl.emptyTxt, ret_3);
        l_description = fun_115(Tpl.emptyTxt, i_comment);
        ret_6 = SimCodeUtil.getClockIndex(i_simVar, a_simCode);
        l_variability__ = fun_116(Tpl.emptyTxt, ret_6, i_variability);
        ret_8 = SimCodeUtil.getClockIndex(i_simVar, a_simCode);
        l_clockIndex = fun_117(Tpl.emptyTxt, ret_8);
        l_previous = fun_118(Tpl.emptyTxt, i_varKind, a_simCode);
        l_caus = getCausality2(Tpl.emptyTxt, i_causality);
        l_initial = getInitialType2(Tpl.emptyTxt, i_initial__);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("name=\""));
        ret_12 = Util.getOption(i_exportVar);
        txt_13 = CodegenUtil.crefStrNoUnderscore(Tpl.emptyTxt, ret_12);
        ret_14 = System.stringReplace(Tpl.textString(txt_13), "$", "_D_");
        txt = Tpl.writeStr(txt, ret_14);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\"\n",
                                    "valueReference=\""
                                }, false));
        txt = Tpl.writeText(txt, l_valueReference);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("\"\n"));
        txt = Tpl.writeText(txt, l_description);
        txt = Tpl.softNewLine(txt);
        ret_15 = stringEq(Tpl.textString(l_variability__), "");
        ret_16 = boolNot(ret_15);
        txt = fun_119(txt, ret_16, l_variability__);
        txt = Tpl.softNewLine(txt);
        ret_17 = stringEq(Tpl.textString(l_caus), "");
        ret_18 = boolNot(ret_17);
        txt = fun_120(txt, ret_18, l_caus);
        txt = Tpl.softNewLine(txt);
        ret_19 = stringEq(Tpl.textString(l_clockIndex), "");
        ret_20 = boolNot(ret_19);
        txt = fun_121(txt, ret_20, l_clockIndex);
        txt = Tpl.softNewLine(txt);
        ret_21 = stringEq(Tpl.textString(l_previous), "");
        ret_22 = boolNot(ret_21);
        txt = fun_122(txt, ret_22, l_previous);
        txt = Tpl.softNewLine(txt);
        ret_23 = stringEq(Tpl.textString(l_initial), "");
        ret_24 = boolNot(ret_23);
        txt = fun_123(txt, ret_24, l_initial);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end ScalarVariableAttribute2;

public function getVariability2
  input Tpl.Text in_txt;
  input Option<SimCodeVar.Variability> in_a_variability;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_variability)
    local
      Tpl.Text txt;

    case ( txt,
           SOME(SimCodeVar.DISCRETE()) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("discrete"));
      then txt;

    case ( txt,
           SOME(SimCodeVar.FIXED()) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("fixed"));
      then txt;

    case ( txt,
           SOME(SimCodeVar.CONSTANT()) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("constant"));
      then txt;

    case ( txt,
           SOME(SimCodeVar.CONTINUOUS()) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("continuous"));
      then txt;

    case ( txt,
           SOME(SimCodeVar.TUNABLE()) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("tunable"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end getVariability2;

public function getCausality2
  input Tpl.Text in_txt;
  input Option<SimCodeVar.Causality> in_a_c;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_c)
    local
      Tpl.Text txt;

    case ( txt,
           SOME(SimCodeVar.NONECAUS()) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("none"));
      then txt;

    case ( txt,
           SOME(SimCodeVar.OUTPUT()) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("output"));
      then txt;

    case ( txt,
           SOME(SimCodeVar.INPUT()) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("input"));
      then txt;

    case ( txt,
           SOME(SimCodeVar.LOCAL()) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("local"));
      then txt;

    case ( txt,
           SOME(SimCodeVar.PARAMETER()) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("parameter"));
      then txt;

    case ( txt,
           SOME(SimCodeVar.CALCULATED_PARAMETER()) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("calculatedParameter"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end getCausality2;

protected function fun_127
  input Tpl.Text in_txt;
  input String in_mArg;
  input Integer in_a_vi_numZeroCrossings;
  input list<BackendDAE.ZeroCrossing> in_a_zeroCrossings;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_vi_numZeroCrossings, in_a_zeroCrossings)
    local
      Tpl.Text txt;
      Integer a_vi_numZeroCrossings;
      list<BackendDAE.ZeroCrossing> a_zeroCrossings;
      Integer ret_0;

    case ( txt,
           "Cpp",
           _,
           a_zeroCrossings )
      equation
        ret_0 = listLength(a_zeroCrossings);
        txt = Tpl.writeStr(txt, intString(ret_0));
      then txt;

    case ( txt,
           _,
           a_vi_numZeroCrossings,
           _ )
      equation
        txt = Tpl.writeStr(txt, intString(a_vi_numZeroCrossings));
      then txt;
  end match;
end fun_127;

public function getNumberOfEventIndicators
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      Integer i_vi_numZeroCrossings;
      list<BackendDAE.ZeroCrossing> i_zeroCrossings;
      String ret_0;

    case ( txt,
           SimCode.SIMCODE(zeroCrossings = i_zeroCrossings, modelInfo = SimCode.MODELINFO(varInfo = SimCode.VARINFO(numZeroCrossings = i_vi_numZeroCrossings))) )
      equation
        ret_0 = Config.simCodeTarget();
        txt = fun_127(txt, ret_0, i_vi_numZeroCrossings, i_zeroCrossings);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end getNumberOfEventIndicators;

public function getInitialType2
  input Tpl.Text in_txt;
  input Option<SimCodeVar.Initial> in_a_initial__;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_initial__)
    local
      Tpl.Text txt;

    case ( txt,
           SOME(SimCodeVar.EXACT()) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("exact"));
      then txt;

    case ( txt,
           SOME(SimCodeVar.APPROX()) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("approx"));
      then txt;

    case ( txt,
           SOME(SimCodeVar.CALCULATED()) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("calculated"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end getInitialType2;

protected function fun_130
  input Tpl.Text in_txt;
  input DAE.Type in_a_type__;
  input list<SimCodeVar.SimVar> in_a_stateVars;
  input SimCodeVar.SimVar in_a_simvar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_type__, in_a_stateVars, in_a_simvar)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> a_stateVars;
      SimCodeVar.SimVar a_simvar;
      Absyn.Path i_path;
      String ret_0;

    case ( txt,
           DAE.T_REAL(varLst = _),
           a_stateVars,
           a_simvar )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<Real"));
        txt = ScalarVariableTypeCommonAttribute2(txt, a_simvar, a_stateVars);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/>"));
      then txt;

    case ( txt,
           DAE.T_INTEGER(varLst = _),
           a_stateVars,
           a_simvar )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<Integer"));
        txt = ScalarVariableTypeCommonAttribute2(txt, a_simvar, a_stateVars);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/>"));
      then txt;

    case ( txt,
           DAE.T_BOOL(varLst = _),
           a_stateVars,
           a_simvar )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<Boolean"));
        txt = ScalarVariableTypeCommonAttribute2(txt, a_simvar, a_stateVars);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/>"));
      then txt;

    case ( txt,
           DAE.T_STRING(varLst = _),
           a_stateVars,
           a_simvar )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<String"));
        txt = ScalarVariableTypeCommonAttribute2(txt, a_simvar, a_stateVars);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/>"));
      then txt;

    case ( txt,
           DAE.T_ENUMERATION(path = i_path),
           a_stateVars,
           a_simvar )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<Enumeration declaredType=\""));
        ret_0 = AbsynUtil.pathString(i_path, ".", false);
        txt = Tpl.writeStr(txt, ret_0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        txt = ScalarVariableTypeCommonAttribute2(txt, a_simvar, a_stateVars);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/>"));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("UNKOWN_TYPE"));
      then txt;
  end match;
end fun_130;

public function ScalarVariableType2
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_a_simvar;
  input list<SimCodeVar.SimVar> in_a_stateVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simvar, in_a_stateVars)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> a_stateVars;
      SimCodeVar.SimVar i_simvar;
      DAE.Type i_type__;

    case ( txt,
           (i_simvar as SimCodeVar.SIMVAR(type_ = i_type__)),
           a_stateVars )
      equation
        txt = fun_130(txt, i_type__, a_stateVars, i_simvar);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end ScalarVariableType2;

public function ScalarVariableTypeCommonAttribute2
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_a_simvar;
  input list<SimCodeVar.SimVar> in_a_stateVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simvar, in_a_stateVars)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> a_stateVars;
      SimCodeVar.SimVar i_simvar;
      Tpl.Text l_extraAttributes;
      Tpl.Text l_startString;

    case ( txt,
           (i_simvar as SimCodeVar.SIMVAR(name = _)),
           a_stateVars )
      equation
        l_startString = StartString2(Tpl.emptyTxt, i_simvar);
        l_extraAttributes = DerivativeVarIndex(Tpl.emptyTxt, i_simvar, a_stateVars);
        l_extraAttributes = MinString2(l_extraAttributes, i_simvar);
        l_extraAttributes = MaxString2(l_extraAttributes, i_simvar);
        l_extraAttributes = NominalString2(l_extraAttributes, i_simvar);
        l_extraAttributes = UnitString2(l_extraAttributes, i_simvar);
        txt = Tpl.writeText(txt, l_startString);
        txt = Tpl.writeText(txt, l_extraAttributes);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end ScalarVariableTypeCommonAttribute2;

protected function fun_133
  input Tpl.Text in_txt;
  input BackendDAE.VarKind in_a_varKind;
  input Integer in_a_index;
  input list<SimCodeVar.SimVar> in_a_stateVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_varKind, in_a_index, in_a_stateVars)
    local
      Tpl.Text txt;
      Integer a_index;
      list<SimCodeVar.SimVar> a_stateVars;
      Integer ret_0;

    case ( txt,
           BackendDAE.STATE_DER(),
           a_index,
           a_stateVars )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("derivative=\""));
        ret_0 = SimCodeUtil.getStateSimVarIndexFromIndex(a_stateVars, a_index);
        txt = Tpl.writeStr(txt, intString(ret_0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_133;

public function DerivativeVarIndex
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_a_simvar;
  input list<SimCodeVar.SimVar> in_a_stateVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simvar, in_a_stateVars)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> a_stateVars;
      Integer i_index;
      BackendDAE.VarKind i_varKind;

    case ( txt,
           SimCodeVar.SIMVAR(varKind = i_varKind, index = i_index),
           a_stateVars )
      equation
        txt = fun_133(txt, i_varKind, i_index, a_stateVars);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end DerivativeVarIndex;

protected function fun_135
  input Tpl.Text in_txt;
  input Option<DAE.Exp> in_a_initialValue;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_initialValue)
    local
      Tpl.Text txt;
      DAE.Exp i_initialValue;

    case ( txt,
           SOME(i_initialValue) )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("start=\""));
        txt = CodegenUtil.initValXml(txt, i_initialValue);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_135;

public function StartString2
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_a_simvar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simvar)
    local
      Tpl.Text txt;
      Option<DAE.Exp> i_initialValue;

    case ( txt,
           SimCodeVar.SIMVAR(aliasvar = SimCodeVar.ALIAS(varName = _)) )
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(initialValue = i_initialValue) )
      equation
        txt = fun_135(txt, i_initialValue);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end StartString2;

public function startString2Helper
  input Tpl.Text in_txt;
  input Option<DAE.Exp> in_a_exp;
  input DAE.Type in_a_type__;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_exp, in_a_type__)
    local
      Tpl.Text txt;
      DAE.Type a_type__;
      DAE.Exp i_e;

    case ( txt,
           SOME(i_e),
           _ )
      equation
        txt = CodegenUtil.initValXml(txt, i_e);
      then txt;

    case ( txt,
           _,
           a_type__ )
      equation
        txt = CodegenUtil.initDefaultValXml(txt, a_type__);
      then txt;
  end match;
end startString2Helper;

protected function fun_138
  input Tpl.Text in_txt;
  input Option<DAE.Exp> in_a_minValue;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_minValue)
    local
      Tpl.Text txt;
      DAE.Exp i_e;

    case ( txt,
           SOME((i_e as DAE.ICONST(integer = _))) )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("min=\""));
        txt = CodegenUtil.initValXml(txt, i_e);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           SOME((i_e as DAE.RCONST(real = _))) )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("min=\""));
        txt = CodegenUtil.initValXml(txt, i_e);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           SOME((i_e as DAE.SCONST(string = _))) )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("min=\""));
        txt = CodegenUtil.initValXml(txt, i_e);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           SOME((i_e as DAE.BCONST(bool = _))) )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("min=\""));
        txt = CodegenUtil.initValXml(txt, i_e);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           SOME((i_e as DAE.ENUM_LITERAL(name = _))) )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("min=\""));
        txt = CodegenUtil.initValXml(txt, i_e);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_138;

public function MinString2
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_a_simvar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simvar)
    local
      Tpl.Text txt;
      Option<DAE.Exp> i_minValue;

    case ( txt,
           SimCodeVar.SIMVAR(minValue = i_minValue) )
      equation
        txt = fun_138(txt, i_minValue);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end MinString2;

protected function fun_140
  input Tpl.Text in_txt;
  input Option<DAE.Exp> in_a_maxValue;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_maxValue)
    local
      Tpl.Text txt;
      DAE.Exp i_e;

    case ( txt,
           SOME((i_e as DAE.ICONST(integer = _))) )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("max=\""));
        txt = CodegenUtil.initValXml(txt, i_e);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           SOME((i_e as DAE.RCONST(real = _))) )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("max=\""));
        txt = CodegenUtil.initValXml(txt, i_e);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           SOME((i_e as DAE.SCONST(string = _))) )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("max=\""));
        txt = CodegenUtil.initValXml(txt, i_e);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           SOME((i_e as DAE.BCONST(bool = _))) )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("max=\""));
        txt = CodegenUtil.initValXml(txt, i_e);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           SOME((i_e as DAE.ENUM_LITERAL(name = _))) )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("max=\""));
        txt = CodegenUtil.initValXml(txt, i_e);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_140;

public function MaxString2
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_a_simvar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simvar)
    local
      Tpl.Text txt;
      Option<DAE.Exp> i_maxValue;

    case ( txt,
           SimCodeVar.SIMVAR(maxValue = i_maxValue) )
      equation
        txt = fun_140(txt, i_maxValue);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end MaxString2;

protected function fun_142
  input Tpl.Text in_txt;
  input Option<DAE.Exp> in_a_nominalValue;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_nominalValue)
    local
      Tpl.Text txt;
      DAE.Exp i_e;

    case ( txt,
           SOME((i_e as DAE.RCONST(real = _))) )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("nominal=\""));
        txt = CodegenUtil.initValXml(txt, i_e);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_142;

public function NominalString2
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_a_simvar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simvar)
    local
      Tpl.Text txt;
      Option<DAE.Exp> i_nominalValue;

    case ( txt,
           SimCodeVar.SIMVAR(nominalValue = i_nominalValue) )
      equation
        txt = fun_142(txt, i_nominalValue);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end NominalString2;

protected function fun_144
  input Tpl.Text in_txt;
  input String in_a_unit;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_unit)
    local
      Tpl.Text txt;
      String i_unit;

    case ( txt,
           "" )
      then txt;

    case ( txt,
           i_unit )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("unit=\""));
        txt = Tpl.writeStr(txt, i_unit);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        txt = Tpl.popBlock(txt);
      then txt;
  end match;
end fun_144;

protected function fun_145
  input Tpl.Text in_txt;
  input String in_a_displayUnit;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_displayUnit)
    local
      Tpl.Text txt;
      String i_displayUnit;

    case ( txt,
           "" )
      then txt;

    case ( txt,
           i_displayUnit )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("displayUnit=\""));
        txt = Tpl.writeStr(txt, i_displayUnit);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        txt = Tpl.popBlock(txt);
      then txt;
  end match;
end fun_145;

public function UnitString2
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_a_simvar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simvar)
    local
      Tpl.Text txt;
      String i_displayUnit;
      String i_unit;
      Tpl.Text l_displayUnitString;
      Tpl.Text l_unitString;

    case ( txt,
           SimCodeVar.SIMVAR(unit = i_unit, displayUnit = i_displayUnit) )
      equation
        l_unitString = fun_144(Tpl.emptyTxt, i_unit);
        l_displayUnitString = fun_145(Tpl.emptyTxt, i_displayUnit);
        txt = Tpl.writeText(txt, l_unitString);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end UnitString2;

protected function fun_147
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("1"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("0"));
      then txt;
  end match;
end fun_147;

protected function fun_148
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_a_var;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_var)
    local
      Tpl.Text txt;
      DAE.ComponentRef i_name;
      Boolean ret_1;
      Tpl.Text txt_0;

    case ( txt,
           SimCodeVar.SIMVAR(name = i_name) )
      equation
        txt_0 = CodegenUtil.crefStr(Tpl.emptyTxt, i_name);
        ret_1 = stringEq(Tpl.textString(txt_0), "$dummy");
        txt = fun_147(txt, ret_1);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_148;

protected function lm_149
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = fun_148(txt, i_var);
        txt = Tpl.nextIter(txt);
        txt = lm_149(txt, rest);
      then txt;
  end match;
end lm_149;

public function statesnumwithDummy
  input Tpl.Text txt;
  input list<SimCodeVar.SimVar> a_vars;

  output Tpl.Text out_txt;
algorithm
  out_txt := Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_149(out_txt, a_vars);
  out_txt := Tpl.popIter(out_txt);
end statesnumwithDummy;

public function xsdateTime
  input Tpl.Text in_txt;
  input Util.DateTime in_a_dt;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_dt)
    local
      Tpl.Text txt;
      Integer i_sec;
      Integer i_min;
      Integer i_hour;
      Integer i_mday;
      Integer i_mon;
      Integer i_year;
      String ret_4;
      String ret_3;
      String ret_2;
      String ret_1;
      String ret_0;

    case ( txt,
           Util.DATETIME(year = i_year, mon = i_mon, mday = i_mday, hour = i_hour, min = i_min, sec = i_sec) )
      equation
        txt = Tpl.writeStr(txt, intString(i_year));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-"));
        ret_0 = SimCodeFunctionUtil.twodigit(i_mon);
        txt = Tpl.writeStr(txt, ret_0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-"));
        ret_1 = SimCodeFunctionUtil.twodigit(i_mday);
        txt = Tpl.writeStr(txt, ret_1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("T"));
        ret_2 = SimCodeFunctionUtil.twodigit(i_hour);
        txt = Tpl.writeStr(txt, ret_2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(":"));
        ret_3 = SimCodeFunctionUtil.twodigit(i_min);
        txt = Tpl.writeStr(txt, ret_3);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(":"));
        ret_4 = SimCodeFunctionUtil.twodigit(i_sec);
        txt = Tpl.writeStr(txt, ret_4);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Z"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end xsdateTime;

protected function fun_152
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo)
    local
      Tpl.Text txt;
      list<SimCode.UnitDefinition> i_unitDefinitions;

    case ( txt,
           SimCode.MODELINFO(unitDefinitions = i_unitDefinitions) )
      equation
        txt = UnitDefinitionsHelper(txt, i_unitDefinitions);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_152;

public function UnitDefinitions
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      SimCode.ModelInfo i_modelInfo;

    case ( txt,
           SimCode.SIMCODE(modelInfo = i_modelInfo) )
      equation
        txt = fun_152(txt, i_modelInfo);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end UnitDefinitions;

protected function lm_154
  input Tpl.Text in_txt;
  input list<SimCode.UnitDefinition> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.UnitDefinition> rest;
      SimCode.UnitDefinition i_unitDefinition;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_unitDefinition :: rest )
      equation
        txt = UnitDefinitionsHelper1(txt, i_unitDefinition);
        txt = Tpl.nextIter(txt);
        txt = lm_154(txt, rest);
      then txt;
  end match;
end lm_154;

public function UnitDefinitionsHelper
  input Tpl.Text in_txt;
  input list<SimCode.UnitDefinition> in_a_unitDefinitions;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_unitDefinitions)
    local
      Tpl.Text txt;
      list<SimCode.UnitDefinition> i_unitDefinitions;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_unitDefinitions )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("<UnitDefinitions>\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_154(txt, i_unitDefinitions);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("</UnitDefinitions>"));
      then txt;
  end match;
end UnitDefinitionsHelper;

public function UnitDefinitionsHelper1
  input Tpl.Text in_txt;
  input SimCode.UnitDefinition in_a_unitDefinition;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_unitDefinition)
    local
      Tpl.Text txt;
      SimCode.BaseUnit i_baseUnit;
      String i_name;

    case ( txt,
           SimCode.UNITDEFINITION(name = i_name, baseUnit = i_baseUnit) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<Unit "));
        txt = unitDefinitionAttribute(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(">\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = baseUnitAttributes(txt, i_baseUnit);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("</Unit>"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end UnitDefinitionsHelper1;

protected function fun_157
  input Tpl.Text in_txt;
  input String in_a_unitName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_unitName)
    local
      Tpl.Text txt;
      String i_unitName;

    case ( txt,
           "" )
      then txt;

    case ( txt,
           i_unitName )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("name=\""));
        txt = Tpl.writeStr(txt, i_unitName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
      then txt;
  end match;
end fun_157;

public function unitDefinitionAttribute
  input Tpl.Text txt;
  input String a_unitName;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_unitString;
algorithm
  l_unitString := fun_157(Tpl.emptyTxt, a_unitName);
  out_txt := Tpl.writeText(txt, l_unitString);
end unitDefinitionAttribute;

protected function fun_159
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_mol;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_mol)
    local
      Tpl.Text txt;
      Integer a_mol;

    case ( txt,
           false,
           a_mol )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("mol=\""));
        txt = Tpl.writeStr(txt, intString(a_mol));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\" "));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_159;

protected function fun_160
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_cd;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_cd)
    local
      Tpl.Text txt;
      Integer a_cd;

    case ( txt,
           false,
           a_cd )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("cd=\""));
        txt = Tpl.writeStr(txt, intString(a_cd));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\" "));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_160;

protected function fun_161
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_m;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_m)
    local
      Tpl.Text txt;
      Integer a_m;

    case ( txt,
           false,
           a_m )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("m=\""));
        txt = Tpl.writeStr(txt, intString(a_m));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\" "));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_161;

protected function fun_162
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_s;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_s)
    local
      Tpl.Text txt;
      Integer a_s;

    case ( txt,
           false,
           a_s )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("s=\""));
        txt = Tpl.writeStr(txt, intString(a_s));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\" "));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_162;

protected function fun_163
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_A;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_A)
    local
      Tpl.Text txt;
      Integer a_A;

    case ( txt,
           false,
           a_A )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("A=\""));
        txt = Tpl.writeStr(txt, intString(a_A));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\" "));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_163;

protected function fun_164
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_K;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_K)
    local
      Tpl.Text txt;
      Integer a_K;

    case ( txt,
           false,
           a_K )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("K=\""));
        txt = Tpl.writeStr(txt, intString(a_K));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\" "));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_164;

protected function fun_165
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_kg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_kg)
    local
      Tpl.Text txt;
      Integer a_kg;

    case ( txt,
           false,
           a_kg )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("kg=\""));
        txt = Tpl.writeStr(txt, intString(a_kg));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\" "));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_165;

protected function fun_166
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Real in_a_factor;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_factor)
    local
      Tpl.Text txt;
      Real a_factor;

    case ( txt,
           false,
           a_factor )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("factor=\""));
        txt = Tpl.writeStr(txt, realString(a_factor));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\" "));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_166;

protected function fun_167
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Real in_a_offset;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_offset)
    local
      Tpl.Text txt;
      Real a_offset;

    case ( txt,
           false,
           a_offset )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("offset=\""));
        txt = Tpl.writeStr(txt, realString(a_offset));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\" "));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_167;

public function baseUnitAttributes
  input Tpl.Text in_txt;
  input SimCode.BaseUnit in_a_baseUnit;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_baseUnit)
    local
      Tpl.Text txt;
      Real i_offset;
      Real i_factor;
      Integer i_kg;
      Integer i_K;
      Integer i_A;
      Integer i_s;
      Integer i_m;
      Integer i_cd;
      Integer i_mol;
      Boolean ret_17;
      Tpl.Text l_offset__Value;
      Boolean ret_15;
      Tpl.Text l_factor__Value;
      Boolean ret_13;
      Tpl.Text l_kg__Value;
      Boolean ret_11;
      Tpl.Text l_K__Value;
      Boolean ret_9;
      Tpl.Text l_A__Value;
      Boolean ret_7;
      Tpl.Text l_s__Value;
      Boolean ret_5;
      Tpl.Text l_m__Value;
      Boolean ret_3;
      Tpl.Text l_cd__Value;
      Boolean ret_1;
      Tpl.Text l_mol__Value;

    case ( txt,
           SimCode.BASEUNIT(mol = i_mol, cd = i_cd, m = i_m, s = i_s, A = i_A, K = i_K, kg = i_kg, factor = i_factor, offset = i_offset) )
      equation
        ret_1 = intEq(i_mol, 0);
        l_mol__Value = fun_159(Tpl.emptyTxt, ret_1, i_mol);
        ret_3 = intEq(i_cd, 0);
        l_cd__Value = fun_160(Tpl.emptyTxt, ret_3, i_cd);
        ret_5 = intEq(i_m, 0);
        l_m__Value = fun_161(Tpl.emptyTxt, ret_5, i_m);
        ret_7 = intEq(i_s, 0);
        l_s__Value = fun_162(Tpl.emptyTxt, ret_7, i_s);
        ret_9 = intEq(i_A, 0);
        l_A__Value = fun_163(Tpl.emptyTxt, ret_9, i_A);
        ret_11 = intEq(i_K, 0);
        l_K__Value = fun_164(Tpl.emptyTxt, ret_11, i_K);
        ret_13 = intEq(i_kg, 0);
        l_kg__Value = fun_165(Tpl.emptyTxt, ret_13, i_kg);
        ret_15 = realAlmostEq(i_factor, 1.0, 1e-6);
        l_factor__Value = fun_166(Tpl.emptyTxt, ret_15, i_factor);
        ret_17 = realAlmostEq(i_offset, 0.0, 1e-6);
        l_offset__Value = fun_167(Tpl.emptyTxt, ret_17, i_offset);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<BaseUnit "));
        txt = Tpl.writeText(txt, l_mol__Value);
        txt = Tpl.writeText(txt, l_cd__Value);
        txt = Tpl.writeText(txt, l_m__Value);
        txt = Tpl.writeText(txt, l_s__Value);
        txt = Tpl.writeText(txt, l_A__Value);
        txt = Tpl.writeText(txt, l_K__Value);
        txt = Tpl.writeText(txt, l_kg__Value);
        txt = Tpl.writeText(txt, l_factor__Value);
        txt = Tpl.writeText(txt, l_offset__Value);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/>"));
      then txt;

    case ( txt,
           SimCode.NOBASEUNIT() )
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end baseUnitAttributes;

protected function fun_169
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;
  input String in_a_FMUVersion;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo, in_a_FMUVersion, in_a_simCode)
    local
      Tpl.Text txt;
      String a_FMUVersion;
      SimCode.SimCode a_simCode;
      SimCodeVar.SimVars i_vars;
      list<SimCodeVar.SimVar> ret_0;

    case ( txt,
           SimCode.MODELINFO(vars = (i_vars as SimCodeVar.SIMVARS(stateVars = _))),
           a_FMUVersion,
           a_simCode )
      equation
        ret_0 = SimCodeUtil.getEnumerationTypes(i_vars);
        txt = TypeDefinitionsHelper(txt, a_simCode, ret_0, a_FMUVersion);
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_169;

public function fmiTypeDefinitions
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input String in_a_FMUVersion;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode, in_a_FMUVersion)
    local
      Tpl.Text txt;
      String a_FMUVersion;
      SimCode.SimCode i_simCode;
      SimCode.ModelInfo i_modelInfo;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = i_modelInfo)),
           a_FMUVersion )
      equation
        txt = fun_169(txt, i_modelInfo, a_FMUVersion, i_simCode);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fmiTypeDefinitions;

protected function fun_171
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_simCode)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;

    case ( txt,
           false,
           a_simCode )
      equation
        txt = TypeDefinitionsClocks(txt, a_simCode);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_171;

protected function lm_172
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input String in_a_FMUVersion;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_FMUVersion)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      String a_FMUVersion;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_FMUVersion )
      equation
        txt = TypeDefinition(txt, i_var, a_FMUVersion);
        txt = Tpl.nextIter(txt);
        txt = lm_172(txt, rest, a_FMUVersion);
      then txt;
  end match;
end lm_172;

protected function fun_173
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_clocks;
  input String in_a_FMUVersion;
  input list<SimCodeVar.SimVar> in_a_vars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_clocks, in_a_FMUVersion, in_a_vars)
    local
      Tpl.Text txt;
      Tpl.Text a_clocks;
      String a_FMUVersion;
      list<SimCodeVar.SimVar> a_vars;

    case ( txt,
           false,
           _,
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_clocks,
           a_FMUVersion,
           a_vars )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("<TypeDefinitions>\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_172(txt, a_vars, a_FMUVersion);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, a_clocks);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("</TypeDefinitions>"));
      then txt;
  end match;
end fun_173;

public function TypeDefinitionsHelper
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input list<SimCodeVar.SimVar> a_vars;
  input String a_FMUVersion;

  output Tpl.Text out_txt;
protected
  Boolean ret_6;
  Boolean ret_5;
  Boolean ret_4;
  Boolean ret_3;
  Integer ret_2;
  Boolean ret_1;
  Tpl.Text l_clocks;
algorithm
  ret_1 := FMI.isFMIVersion10(a_FMUVersion);
  l_clocks := fun_171(Tpl.emptyTxt, ret_1, a_simCode);
  ret_2 := listLength(a_vars);
  ret_3 := intGt(ret_2, 0);
  ret_4 := stringEq(Tpl.textString(l_clocks), "");
  ret_5 := boolNot(ret_4);
  ret_6 := boolOr(ret_3, ret_5);
  out_txt := fun_173(txt, ret_6, l_clocks, a_FMUVersion, a_vars);
end TypeDefinitionsHelper;

public function TypeDefinition
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_a_simVar;
  input String in_a_FMUVersion;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simVar, in_a_FMUVersion)
    local
      Tpl.Text txt;
      String a_FMUVersion;
      DAE.Type i_type__;

    case ( txt,
           SimCodeVar.SIMVAR(type_ = i_type__),
           a_FMUVersion )
      equation
        txt = TypeDefinitionType(txt, i_type__, a_FMUVersion);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end TypeDefinition;

protected function lm_176
  input Tpl.Text in_txt;
  input list<String> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<String> rest;
      String i_name;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_name :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<Item name=\""));
        txt = Tpl.writeStr(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\"/>"));
        txt = Tpl.nextIter(txt);
        txt = lm_176(txt, rest);
      then txt;
  end match;
end lm_176;

protected function lm_177
  input Tpl.Text in_txt;
  input list<String> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<String> rest;
      Integer x_i0;
      String i_name;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_name :: rest )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<Item name=\""));
        txt = Tpl.writeStr(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\" value=\""));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\"/>"));
        txt = Tpl.nextIter(txt);
        txt = lm_177(txt, rest);
      then txt;
  end match;
end lm_177;

protected function fun_178
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input list<String> in_a_names;
  input Absyn.Path in_a_path;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_names, in_a_path)
    local
      Tpl.Text txt;
      list<String> a_names;
      Absyn.Path a_path;
      String ret_1;
      String ret_0;

    case ( txt,
           false,
           a_names,
           a_path )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<Type name=\""));
        ret_0 = AbsynUtil.pathString(a_path, ".", false);
        txt = Tpl.writeStr(txt, ret_0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\">\n",
                                    "  <EnumerationType>\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_176(txt, a_names);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "  </EnumerationType>\n",
                                    "</Type>"
                                }, false));
      then txt;

    case ( txt,
           _,
           a_names,
           a_path )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<SimpleType name=\""));
        ret_1 = AbsynUtil.pathString(a_path, ".", false);
        txt = Tpl.writeStr(txt, ret_1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\">\n",
                                    "  <Enumeration>\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(1, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_177(txt, a_names);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "  </Enumeration>\n",
                                    "</SimpleType>"
                                }, false));
      then txt;
  end match;
end fun_178;

public function TypeDefinitionType
  input Tpl.Text in_txt;
  input DAE.Type in_a_type__;
  input String in_a_FMUVersion;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_type__, in_a_FMUVersion)
    local
      Tpl.Text txt;
      String a_FMUVersion;
      list<String> i_names;
      Absyn.Path i_path;
      Boolean ret_0;

    case ( txt,
           DAE.T_ENUMERATION(path = i_path, names = i_names),
           a_FMUVersion )
      equation
        ret_0 = FMI.isFMIVersion20(a_FMUVersion);
        txt = fun_178(txt, ret_0, i_names, i_path);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end TypeDefinitionType;

public function DefaultExperiment
  input Tpl.Text in_txt;
  input Option<SimCode.SimulationSettings> in_a_simulationSettingsOpt;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simulationSettingsOpt)
    local
      Tpl.Text txt;
      SimCode.SimulationSettings i_v;

    case ( txt,
           SOME(i_v) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<DefaultExperiment "));
        txt = DefaultExperimentAttribute(txt, i_v);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/>"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end DefaultExperiment;

public function DefaultExperimentAttribute
  input Tpl.Text in_txt;
  input SimCode.SimulationSettings in_a_simulationSettings;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simulationSettings)
    local
      Tpl.Text txt;
      Real i_tolerance;
      Real i_stopTime;
      Real i_startTime;

    case ( txt,
           SimCode.SIMULATION_SETTINGS(startTime = i_startTime, stopTime = i_stopTime, tolerance = i_tolerance) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("startTime=\""));
        txt = Tpl.writeStr(txt, realString(i_startTime));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\" stopTime=\""));
        txt = Tpl.writeStr(txt, realString(i_stopTime));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\" tolerance=\""));
        txt = Tpl.writeStr(txt, realString(i_tolerance));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end DefaultExperimentAttribute;

annotation(__OpenModelica_Interface="backend");
end CodegenFMUCommon;