encapsulated package CodegenFMUCppHpcom
"
  file:        CodegenFMUCppHpcom.mo
  package:     CodegenFMUCppHpcom
  description: Generated by Susan.
"

public import Tpl;

public import HpcOmSimCode;
public import SimCode;
public import SimCodeFunction;
public import System;
public import Absyn;
public import Util;
public import List;
public import Expression;
public import Config;
public import Flags;
public import HashTableCrIListArray;
public import CodegenFMUCpp;
public import CodegenCppHpcom;
protected import CodegenUtil;
protected import CodegenCpp;
protected import CodegenCppInit;

public function translateModel
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input String in_a_FMUVersion;
  input String in_a_FMUType;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode, in_a_FMUVersion, in_a_FMUType)
    local
      Tpl.Text txt;
      String a_FMUVersion;
      String a_FMUType;
      HashTableCrIListArray.HashTable i_varToArrayIndexMapping;
      Option<tuple<HpcOmSimCode.Schedule, HpcOmSimCode.Schedule, HpcOmSimCode.Schedule>> i_hpcomData_schedules;
      list<SimCode.SimEqSystem> i_allEquations;
      String i_fileNamePrefix;
      SimCode.SimCode i_simCode;
      Option<HpcOmSimCode.MemoryMap> i_hpcomData_hpcOmMemory;
      SimCode.ModelInfo i_modelInfo;
      Absyn.Path i_modelInfo_name;
      Tpl.Text txt_46;
      Tpl.Text txt_45;
      Tpl.Text txt_44;
      Boolean ret_43;
      Tpl.Text txt_42;
      Tpl.Text txt_41;
      Tpl.Text txt_40;
      Tpl.Text txt_39;
      Tpl.Text txt_38;
      Tpl.Text txt_37;
      Tpl.Text txt_36;
      Tpl.Text txt_35;
      Tpl.Text txt_34;
      Tpl.Text txt_33;
      Tpl.Text txt_32;
      Tpl.Text txt_31;
      Tpl.Text txt_30;
      Tpl.Text txt_29;
      Tpl.Text txt_28;
      Tpl.Text txt_27;
      Tpl.Text txt_26;
      Tpl.Text txt_25;
      Tpl.Text txt_24;
      Tpl.Text txt_23;
      Tpl.Text txt_22;
      Tpl.Text txt_21;
      Tpl.Text txt_20;
      Tpl.Text txt_19;
      Tpl.Text txt_18;
      Tpl.Text txt_17;
      Tpl.Text txt_16;
      Tpl.Text l_cpp;
      Tpl.Text txt_14;
      Tpl.Text l_numPreVars;
      Tpl.Text l_numStringVars;
      Tpl.Text l_numBoolVars;
      Tpl.Text l_numIntVars;
      Tpl.Text l_numRealVars;
      Tpl.Text l_className;
      Tpl.Text l_complexStartExpressions;
      Tpl.Text l_extraFuncsDecl;
      Tpl.Text l_extraFuncs;
      Tpl.Text l_stateDerVectorName;
      String ret_3;
      Tpl.Text l_target;
      String ret_1;
      Tpl.Text l_guid;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = (i_modelInfo as SimCode.MODELINFO(name = i_modelInfo_name)), makefileParams = SimCodeFunction.MAKEFILE_PARAMS(ccompiler = _), hpcomData = HpcOmSimCode.HPCOMDATA(hpcOmMemory = i_hpcomData_hpcOmMemory, schedules = i_hpcomData_schedules), fileNamePrefix = i_fileNamePrefix, allEquations = i_allEquations, varToArrayIndexMapping = i_varToArrayIndexMapping)),
           a_FMUVersion,
           a_FMUType )
      equation
        ret_1 = System.getUUIDStr();
        l_guid = Tpl.writeStr(Tpl.emptyTxt, ret_1);
        ret_3 = Config.simulationCodeTarget();
        l_target = Tpl.writeStr(Tpl.emptyTxt, ret_3);
        l_stateDerVectorName = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("__zDot"));
        l_extraFuncs = Tpl.emptyTxt;
        l_extraFuncsDecl = Tpl.emptyTxt;
        l_complexStartExpressions = Tpl.emptyTxt;
        l_className = CodegenCpp.lastIdentOfPath(Tpl.emptyTxt, i_modelInfo_name);
        l_numRealVars = CodegenCppHpcom.numRealvarsHpcom(Tpl.emptyTxt, i_modelInfo, i_hpcomData_hpcOmMemory);
        l_numIntVars = CodegenCppHpcom.numIntvarsHpcom(Tpl.emptyTxt, i_modelInfo, i_hpcomData_hpcOmMemory);
        l_numBoolVars = CodegenCppHpcom.numBoolvarsHpcom(Tpl.emptyTxt, i_modelInfo, i_hpcomData_hpcOmMemory);
        l_numStringVars = CodegenCppHpcom.numStringvarsHpcom(Tpl.emptyTxt, i_modelInfo, i_hpcomData_hpcOmMemory);
        l_numPreVars = CodegenCppHpcom.numPreVarsHpcom(Tpl.emptyTxt, i_modelInfo, i_hpcomData_hpcOmMemory);
        (txt_14, l_complexStartExpressions, l_stateDerVectorName) = CodegenCppInit.modelInitXMLFile(Tpl.emptyTxt, i_simCode, Tpl.textString(l_numRealVars), Tpl.textString(l_numIntVars), Tpl.textString(l_numBoolVars), Tpl.textString(l_numStringVars), a_FMUVersion, a_FMUType, Tpl.textString(l_guid), true, "hpcom cpp-runtime", l_complexStartExpressions, l_stateDerVectorName);
        Tpl.textFile(txt_14, "modelDescription.xml");
        l_cpp = CodegenCpp.translateModel(Tpl.emptyTxt, i_simCode);
        (txt_16, l_extraFuncs, l_extraFuncsDecl, _) = CodegenFMUCpp.fmuWriteOutputHeaderFile(Tpl.emptyTxt, i_simCode, l_extraFuncs, l_extraFuncsDecl, Tpl.strTokText(Tpl.ST_STRING("")));
        txt_17 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("OMCpp"));
        txt_17 = Tpl.writeStr(txt_17, i_fileNamePrefix);
        txt_17 = Tpl.writeTok(txt_17, Tpl.ST_STRING("WriteOutput.h"));
        Tpl.textFile(txt_16, Tpl.textString(txt_17));
        (txt_18, l_extraFuncs, l_extraFuncsDecl, _) = CodegenFMUCpp.fmuModelHeaderFile(Tpl.emptyTxt, i_simCode, l_extraFuncs, l_extraFuncsDecl, Tpl.strTokText(Tpl.ST_STRING("")), Tpl.textString(l_guid), a_FMUVersion);
        txt_19 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("OMCpp"));
        txt_19 = Tpl.writeStr(txt_19, i_fileNamePrefix);
        txt_19 = Tpl.writeTok(txt_19, Tpl.ST_STRING("FMU.h"));
        Tpl.textFile(txt_18, Tpl.textString(txt_19));
        (txt_20, l_extraFuncs, l_extraFuncsDecl, _) = CodegenFMUCpp.fmuModelCppFile(Tpl.emptyTxt, i_simCode, l_extraFuncs, l_extraFuncsDecl, Tpl.strTokText(Tpl.ST_STRING("")), Tpl.textString(l_guid), a_FMUVersion);
        txt_21 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("OMCpp"));
        txt_21 = Tpl.writeStr(txt_21, i_fileNamePrefix);
        txt_21 = Tpl.writeTok(txt_21, Tpl.ST_STRING("FMU.cpp"));
        Tpl.textFile(txt_20, Tpl.textString(txt_21));
        (txt_22, l_extraFuncs, l_extraFuncsDecl, _) = fmuMakefile(Tpl.emptyTxt, Tpl.textString(l_target), i_simCode, l_extraFuncs, l_extraFuncsDecl, Tpl.strTokText(Tpl.ST_STRING("")), a_FMUVersion);
        txt_23 = Tpl.writeStr(Tpl.emptyTxt, i_fileNamePrefix);
        txt_23 = Tpl.writeTok(txt_23, Tpl.ST_STRING("_FMU.makefile"));
        Tpl.textFile(txt_22, Tpl.textString(txt_23));
        txt_24 = CodegenFMUCpp.fmuCalcHelperMainfile(Tpl.emptyTxt, i_simCode);
        txt_25 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("OMCpp"));
        txt_25 = Tpl.writeStr(txt_25, i_fileNamePrefix);
        txt_25 = Tpl.writeTok(txt_25, Tpl.ST_STRING("CalcHelperMain.cpp"));
        Tpl.textFile(txt_24, Tpl.textString(txt_25));
        (txt_26, l_extraFuncs, l_extraFuncsDecl, _, l_stateDerVectorName) = CodegenCppHpcom.updateHpcom(Tpl.emptyTxt, i_allEquations, i_simCode, l_extraFuncs, l_extraFuncsDecl, Tpl.strTokText(Tpl.ST_STRING("")), SimCodeFunction.contextOther, l_stateDerVectorName, false);
        txt_27 = Tpl.writeText(Tpl.emptyTxt, l_numRealVars);
        txt_27 = Tpl.writeTok(txt_27, Tpl.ST_STRING("-1"));
        txt_28 = Tpl.writeText(Tpl.emptyTxt, l_numIntVars);
        txt_28 = Tpl.writeTok(txt_28, Tpl.ST_STRING("-1"));
        txt_29 = Tpl.writeText(Tpl.emptyTxt, l_numBoolVars);
        txt_29 = Tpl.writeTok(txt_29, Tpl.ST_STRING("-1"));
        txt_30 = Tpl.writeText(Tpl.emptyTxt, l_numStringVars);
        txt_30 = Tpl.writeTok(txt_30, Tpl.ST_STRING("-1"));
        txt_31 = CodegenCppHpcom.additionalHpcomConstructorDefinitions(Tpl.emptyTxt, i_hpcomData_schedules);
        txt_32 = CodegenUtil.dotPath(Tpl.emptyTxt, i_modelInfo_name);
        txt_33 = CodegenCppHpcom.additionalHpcomConstructorBodyStatements(Tpl.emptyTxt, i_hpcomData_schedules, Tpl.textString(l_className), Tpl.textString(txt_32));
        txt_34 = CodegenCppHpcom.additionalHpcomDestructorBodyStatements(Tpl.emptyTxt, i_hpcomData_schedules);
        (txt_35, txt_26, txt_27, txt_28, txt_29, txt_30, l_extraFuncs, l_extraFuncsDecl, l_className, txt_31, txt_33, txt_34, l_stateDerVectorName) = CodegenCpp.simulationCppFile(Tpl.emptyTxt, i_simCode, SimCodeFunction.contextOther, txt_26, txt_27, txt_28, txt_29, txt_30, l_extraFuncs, l_extraFuncsDecl, l_className, txt_31, txt_33, txt_34, l_stateDerVectorName, false, Tpl.textString(l_numRealVars), Tpl.textString(l_numIntVars), Tpl.textString(l_numBoolVars), Tpl.textString(l_numStringVars), Tpl.textString(l_numPreVars));
        txt_36 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("OMCpp"));
        txt_36 = Tpl.writeStr(txt_36, i_fileNamePrefix);
        txt_36 = Tpl.writeTok(txt_36, Tpl.ST_STRING(".cpp"));
        Tpl.textFile(txt_35, Tpl.textString(txt_36));
        (txt_37, l_extraFuncs, l_extraFuncsDecl, l_className) = CodegenCppHpcom.additionalHpcomIncludes(Tpl.emptyTxt, i_simCode, l_extraFuncs, l_extraFuncsDecl, l_className, false);
        (txt_38, l_extraFuncs, l_extraFuncsDecl, _) = CodegenCppHpcom.additionalHpcomProtectedMemberDeclaration(Tpl.emptyTxt, i_simCode, l_extraFuncs, l_extraFuncsDecl, Tpl.strTokText(Tpl.ST_STRING("")), false);
        txt_39 = Tpl.writeText(Tpl.emptyTxt, l_numRealVars);
        txt_39 = Tpl.writeTok(txt_39, Tpl.ST_STRING("-1"));
        txt_40 = Tpl.writeText(Tpl.emptyTxt, l_numIntVars);
        txt_40 = Tpl.writeTok(txt_40, Tpl.ST_STRING("-1"));
        txt_41 = Tpl.writeText(Tpl.emptyTxt, l_numBoolVars);
        txt_41 = Tpl.writeTok(txt_41, Tpl.ST_STRING("-1"));
        txt_42 = Tpl.writeText(Tpl.emptyTxt, l_numStringVars);
        txt_42 = Tpl.writeTok(txt_42, Tpl.ST_STRING("-1"));
        ret_43 = Flags.isSet(Flags.GEN_DEBUG_SYMBOLS);
        (txt_44, txt_39, txt_40, txt_41, txt_42) = CodegenCpp.memberVariableDefine(Tpl.emptyTxt, i_modelInfo, i_varToArrayIndexMapping, txt_39, txt_40, txt_41, txt_42, ret_43, false);
        (txt_45, l_extraFuncs, l_extraFuncsDecl, _) = CodegenCpp.simulationHeaderFile(Tpl.emptyTxt, i_simCode, SimCodeFunction.contextOther, l_extraFuncs, l_extraFuncsDecl, Tpl.strTokText(Tpl.ST_STRING("")), Tpl.textString(txt_37), "", Tpl.textString(txt_38), Tpl.textString(txt_44), false);
        txt_46 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("OMCpp"));
        txt_46 = Tpl.writeStr(txt_46, i_fileNamePrefix);
        txt_46 = Tpl.writeTok(txt_46, Tpl.ST_STRING(".h"));
        Tpl.textFile(txt_45, Tpl.textString(txt_46));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end translateModel;

protected function fun_49
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" -lboost_thread"));
      then txt;
  end match;
end fun_49;

public function fmuMakefile
  input Tpl.Text txt;
  input String a_target;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input String a_FMUVersion;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
protected
  Boolean ret_8;
  Boolean ret_7;
  Boolean ret_6;
  Tpl.Text l_additionalLinkerFlags__MSVC;
  Tpl.Text l_additionalLinkerFlags__GCC;
  Tpl.Text l_additionalCFlags__MSVC;
  Tpl.Text l_additionalCFlags__GCC;
  String ret_1;
  Tpl.Text l_type;
algorithm
  ret_1 := Flags.getConfigString(Flags.HPCOM_CODE);
  l_type := Tpl.writeStr(Tpl.emptyTxt, ret_1);
  l_additionalCFlags__GCC := Tpl.emptyTxt;
  l_additionalCFlags__MSVC := Tpl.emptyTxt;
  l_additionalLinkerFlags__GCC := Tpl.emptyTxt;
  l_additionalLinkerFlags__MSVC := Tpl.emptyTxt;
  ret_6 := stringEq(Tpl.textString(l_type), "pthreads");
  ret_7 := stringEq(Tpl.textString(l_type), "pthreads_spin");
  ret_8 := boolOr(ret_6, ret_7);
  l_additionalLinkerFlags__GCC := fun_49(l_additionalLinkerFlags__GCC, ret_8);
  (out_txt, l_additionalCFlags__GCC, l_additionalCFlags__MSVC, l_additionalLinkerFlags__GCC, l_additionalLinkerFlags__MSVC) := CodegenCppHpcom.getAdditionalMakefileFlags(txt, l_additionalCFlags__GCC, l_additionalCFlags__MSVC, l_additionalLinkerFlags__GCC, l_additionalLinkerFlags__MSVC);
  out_txt := Tpl.softNewLine(out_txt);
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace) := CodegenFMUCpp.fmuMakefile(out_txt, a_target, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_FMUVersion, Tpl.textString(l_additionalLinkerFlags__GCC), Tpl.textString(l_additionalLinkerFlags__MSVC), Tpl.textString(l_additionalCFlags__GCC), Tpl.textString(l_additionalCFlags__MSVC));
end fmuMakefile;

annotation(__OpenModelica_Interface="backend");
end CodegenFMUCppHpcom;