encapsulated package CodegenFMUCppOld
"
  file:        CodegenFMUCppOld.mo
  package:     CodegenFMUCppOld
  description: Generated by Susan.
"

public import Tpl;

public import SimCodeVar;
public import SimCode;
public import SimCodeFunction;
public import SimCodeUtil;
public import BackendDAE;
public import System;
public import Autoconf;
public import Absyn;
public import DAE;
public import Util;
public import List;
public import Expression;
public import Config;
public import Flags;
public import FlagsUtil;
public import Settings;
public import Error;
public import Values;
public import Types;
public import FMI;
public import CodegenUtil;
public import CodegenCppOld;
public import CodegenCppCommonOld;
public import CodegenFMU;
protected import CodegenCppInit;
protected import CodegenFMUCommon;

protected function fun_50
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_complexStartExpressions;
  input Tpl.Text in_a_numStringVars;
  input Tpl.Text in_a_numBoolVars;
  input Tpl.Text in_a_numIntVars;
  input Tpl.Text in_a_numRealVars;
  input list<String> in_a_sourceFiles;
  input String in_a_FMUType;
  input String in_a_FMUVersion;
  input Tpl.Text in_a_guid;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_complexStartExpressions;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_complexStartExpressions) :=
  match(in_txt, in_mArg, in_a_stateDerVectorName, in_a_complexStartExpressions, in_a_numStringVars, in_a_numBoolVars, in_a_numIntVars, in_a_numRealVars, in_a_sourceFiles, in_a_FMUType, in_a_FMUVersion, in_a_guid, in_a_simCode)
    local
      Tpl.Text txt;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_complexStartExpressions;
      Tpl.Text a_numStringVars;
      Tpl.Text a_numBoolVars;
      Tpl.Text a_numIntVars;
      Tpl.Text a_numRealVars;
      list<String> a_sourceFiles;
      String a_FMUType;
      String a_FMUVersion;
      Tpl.Text a_guid;
      SimCode.SimCode a_simCode;

    case ( txt,
           false,
           a_stateDerVectorName,
           a_complexStartExpressions,
           _,
           _,
           _,
           _,
           a_sourceFiles,
           a_FMUType,
           a_FMUVersion,
           a_guid,
           a_simCode )
      equation
        txt = CodegenFMU.fmuModelDescriptionFile(txt, a_simCode, Tpl.textString(a_guid), a_FMUVersion, a_FMUType, a_sourceFiles);
      then (txt, a_stateDerVectorName, a_complexStartExpressions);

    case ( txt,
           _,
           a_stateDerVectorName,
           a_complexStartExpressions,
           a_numStringVars,
           a_numBoolVars,
           a_numIntVars,
           a_numRealVars,
           _,
           a_FMUType,
           a_FMUVersion,
           a_guid,
           a_simCode )
      equation
        (txt, a_complexStartExpressions, a_stateDerVectorName) = CodegenCppInit.modelInitXMLFile(txt, a_simCode, Tpl.textString(a_numRealVars), Tpl.textString(a_numIntVars), Tpl.textString(a_numBoolVars), Tpl.textString(a_numStringVars), a_FMUVersion, a_FMUType, Tpl.textString(a_guid), true, "cpp-runtime", a_complexStartExpressions, a_stateDerVectorName);
      then (txt, a_stateDerVectorName, a_complexStartExpressions);
  end match;
end fun_50;

public function translateModel
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input String in_a_FMUVersion;
  input String in_a_FMUType;
  input list<String> in_a_sourceFiles;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode, in_a_FMUVersion, in_a_FMUType, in_a_sourceFiles)
    local
      Tpl.Text txt;
      String a_FMUVersion;
      String a_FMUType;
      list<String> a_sourceFiles;
      String i_fileNamePrefix;
      SimCode.SimCode i_simCode;
      SimCode.ModelInfo i_modelInfo;
      Boolean ret_30;
      Tpl.Text l_0___1;
      Tpl.Text txt_28;
      Tpl.Text txt_27;
      Tpl.Text txt_26;
      Tpl.Text txt_25;
      Tpl.Text txt_24;
      Tpl.Text txt_23;
      Tpl.Text txt_21;
      Boolean ret_21;
      Tpl.Text txt_20;
      Tpl.Text txt_19;
      Tpl.Text txt_18;
      Tpl.Text txt_17;
      Tpl.Text txt_16;
      Tpl.Text txt_15;
      Tpl.Text l_cpp;
      Boolean ret_13;
      Tpl.Text l_0__;
      Tpl.Text l_numStringVars;
      Tpl.Text l_numBoolVars;
      Tpl.Text l_numIntVars;
      Tpl.Text l_numRealVars;
      Tpl.Text l_complexStartExpressions;
      Tpl.Text l_extraFuncsDecl;
      Tpl.Text l_extraFuncs;
      Tpl.Text l_stateDerVectorName;
      String ret_3;
      Tpl.Text l_target;
      String ret_1;
      Tpl.Text l_guid;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = (i_modelInfo as SimCode.MODELINFO(name = _)), fileNamePrefix = i_fileNamePrefix)),
           a_FMUVersion,
           a_FMUType,
           a_sourceFiles )
      equation
        ret_1 = System.getUUIDStr();
        l_guid = Tpl.writeStr(Tpl.emptyTxt, ret_1);
        ret_3 = Config.simulationCodeTarget();
        l_target = Tpl.writeStr(Tpl.emptyTxt, ret_3);
        l_stateDerVectorName = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("__zDot"));
        l_extraFuncs = Tpl.emptyTxt;
        l_extraFuncsDecl = Tpl.emptyTxt;
        l_complexStartExpressions = Tpl.emptyTxt;
        l_numRealVars = CodegenCppOld.numRealvars(Tpl.emptyTxt, i_modelInfo);
        l_numIntVars = CodegenCppOld.numIntvars(Tpl.emptyTxt, i_modelInfo);
        l_numBoolVars = CodegenCppOld.numBoolvars(Tpl.emptyTxt, i_modelInfo);
        l_numStringVars = CodegenCppOld.numStringvars(Tpl.emptyTxt, i_modelInfo);
        ret_13 = FlagsUtil.set(Flags.HARDCODED_START_VALUES, true);
        l_0__ = Tpl.writeStr(Tpl.emptyTxt, Tpl.booleanString(ret_13));
        l_cpp = CodegenCppOld.translateModel(Tpl.emptyTxt, i_simCode);
        (txt_15, l_extraFuncs, l_extraFuncsDecl, _) = fmuWriteOutputHeaderFile(Tpl.emptyTxt, i_simCode, l_extraFuncs, l_extraFuncsDecl, Tpl.strTokText(Tpl.ST_STRING("")));
        txt_16 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("OMCpp"));
        txt_16 = Tpl.writeStr(txt_16, i_fileNamePrefix);
        txt_16 = Tpl.writeTok(txt_16, Tpl.ST_STRING("WriteOutput.h"));
        Tpl.textFile(txt_15, Tpl.textString(txt_16));
        (txt_17, l_extraFuncs, l_extraFuncsDecl, _) = fmuModelHeaderFile(Tpl.emptyTxt, i_simCode, l_extraFuncs, l_extraFuncsDecl, Tpl.strTokText(Tpl.ST_STRING("")), Tpl.textString(l_guid), a_FMUVersion);
        txt_18 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("OMCpp"));
        txt_18 = Tpl.writeStr(txt_18, i_fileNamePrefix);
        txt_18 = Tpl.writeTok(txt_18, Tpl.ST_STRING("FMU.h"));
        Tpl.textFile(txt_17, Tpl.textString(txt_18));
        (txt_19, l_extraFuncs, l_extraFuncsDecl, _) = fmuModelCppFile(Tpl.emptyTxt, i_simCode, l_extraFuncs, l_extraFuncsDecl, Tpl.strTokText(Tpl.ST_STRING("")), Tpl.textString(l_guid), a_FMUVersion);
        txt_20 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("OMCpp"));
        txt_20 = Tpl.writeStr(txt_20, i_fileNamePrefix);
        txt_20 = Tpl.writeTok(txt_20, Tpl.ST_STRING("FMU.cpp"));
        Tpl.textFile(txt_19, Tpl.textString(txt_20));
        ret_21 = FMI.isFMIVersion10(a_FMUVersion);
        (txt_21, l_stateDerVectorName, l_complexStartExpressions) = fun_50(Tpl.emptyTxt, ret_21, l_stateDerVectorName, l_complexStartExpressions, l_numStringVars, l_numBoolVars, l_numIntVars, l_numRealVars, a_sourceFiles, a_FMUType, a_FMUVersion, l_guid, i_simCode);
        Tpl.textFile(txt_21, "modelDescription.xml");
        txt_23 = CodegenFMU.fmudeffile(Tpl.emptyTxt, i_simCode, a_FMUVersion);
        txt_24 = Tpl.writeStr(Tpl.emptyTxt, i_fileNamePrefix);
        txt_24 = Tpl.writeTok(txt_24, Tpl.ST_STRING(".def"));
        Tpl.textFile(txt_23, Tpl.textString(txt_24));
        (txt_25, l_extraFuncs, l_extraFuncsDecl, _) = fmuMakefile(Tpl.emptyTxt, Tpl.textString(l_target), i_simCode, l_extraFuncs, l_extraFuncsDecl, Tpl.strTokText(Tpl.ST_STRING("")), a_FMUVersion, "", "", "", "");
        txt_26 = Tpl.writeStr(Tpl.emptyTxt, i_fileNamePrefix);
        txt_26 = Tpl.writeTok(txt_26, Tpl.ST_STRING("_FMU.makefile"));
        Tpl.textFile(txt_25, Tpl.textString(txt_26));
        txt_27 = fmuCalcHelperMainfile(Tpl.emptyTxt, i_simCode);
        txt_28 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("OMCpp"));
        txt_28 = Tpl.writeStr(txt_28, i_fileNamePrefix);
        txt_28 = Tpl.writeTok(txt_28, Tpl.ST_STRING("CalcHelperMain.cpp"));
        Tpl.textFile(txt_27, Tpl.textString(txt_28));
        ret_30 = FlagsUtil.set(Flags.HARDCODED_START_VALUES, false);
        l_0___1 = Tpl.writeStr(Tpl.emptyTxt, Tpl.booleanString(ret_30));
      then txt;

    case ( txt,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end translateModel;

protected function fun_52
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_fileNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_fileNamePrefix)
    local
      Tpl.Text txt;
      String a_fileNamePrefix;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_fileNamePrefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#include \"OMCpp"));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "InitializeParameter.cpp\"\n",
                                    "#include \"OMCpp"
                                }, false));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("InitializeAlgVars.cpp\""));
      then txt;
  end match;
end fun_52;

public function fmuCalcHelperMainfile
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      String i_fileNamePrefix;
      Boolean ret_2;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = _), fileNamePrefix = i_fileNamePrefix) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "/*****************************************************************************\n",
                                    "*\n",
                                    "* Helper file that includes all generated calculation files, except the alg loops.\n",
                                    "* This file is generated by the OpenModelica Compiler and produced to speed-up the compile time.\n",
                                    "*\n",
                                    "*****************************************************************************/\n",
                                    "#include <Core/ModelicaDefine.h>\n",
                                    "#include <Core/Modelica.h>\n",
                                    "#include <Core/System/FactoryExport.h>\n",
                                    "#include <Core/DataExchange/SimData.h>\n",
                                    "#include <Core/System/SimVars.h>\n",
                                    "#include <Core/System/DiscreteEvents.h>\n",
                                    "#include <Core/System/EventHandling.h>\n",
                                    "#include <Core/Utils/extension/logger.hpp>\n",
                                    "\n",
                                    "#include \"OMCpp"
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Types.h\"\n",
                                    "#include \"OMCpp"
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ".h\"\n",
                                    "#include \"OMCpp"
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Functions.h\"\n",
                                    "#include \"OMCpp"
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Jacobian.h\"\n",
                                    "#include \"OMCpp"
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Mixed.h\"\n",
                                    "#include \"OMCpp"
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "StateSelection.h\"\n",
                                    "#include \"OMCpp"
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "WriteOutput.h\"\n",
                                    "#include \"OMCpp"
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Initialize.h\"\n",
                                    "#include \"OMCpp"
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "FMU.h\"\n",
                                    "\n",
                                    "#include \"OMCpp"
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "AlgLoopMain.cpp\"\n",
                                    "#include \"OMCpp"
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Mixed.cpp\"\n",
                                    "#include \"OMCpp"
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("Functions.cpp\"\n"));
        ret_0 = Flags.isSet(Flags.HARDCODED_START_VALUES);
        ret_1 = Flags.isSet(Flags.GEN_DEBUG_SYMBOLS);
        ret_2 = boolOr(ret_0, ret_1);
        txt = fun_52(txt, ret_2, i_fileNamePrefix);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#include \"OMCpp"));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Initialize.cpp\"\n",
                                    "#include \"OMCpp"
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Jacobian.cpp\"\n",
                                    "#include \"OMCpp"
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "StateSelection.cpp\"\n",
                                    "#include \"OMCpp"
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ".cpp\"\n",
                                    "#include \"OMCpp"
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("FMU.cpp\""));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fmuCalcHelperMainfile;

protected function fun_54
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      Absyn.Path i_modelInfo_name;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = i_modelInfo_name), simulationSettingsOpt = SOME(SimCode.SIMULATION_SETTINGS(startTime = _))) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "#pragma once\n",
                                    "\n",
                                    "// Dummy code for FMU that writes no output file\n",
                                    "class "
                                }, false));
        txt = CodegenCppOld.lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("WriteOutput  : public IWriteOutput,public "));
        txt = CodegenCppOld.lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "StateSelection\n",
                                    "{\n",
                                    " public:\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = CodegenCppOld.lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("WriteOutput(IGlobalSettings* globalSettings, shared_ptr<ISimObjects> simObjects): "));
        txt = CodegenCppOld.lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "StateSelection(globalSettings, simObjects) {}\n",
                                    "virtual ~"
                                }, false));
        txt = CodegenCppOld.lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "WriteOutput() {}\n",
                                    "\n",
                                    "virtual void writeOutput(const IWriteOutput::OUTPUT command = IWriteOutput::UNDEF_OUTPUT) {}\n",
                                    "virtual IHistory* getHistory() {return NULL;}\n",
                                    "\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " protected:\n",
                                    "  void initialize() {}\n",
                                    "};"
                                }, false));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_54;

public function fmuWriteOutputHeaderFile
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  out_txt := fun_54(txt, a_simCode);
  out_a_extraFuncs := a_extraFuncs;
  out_a_extraFuncsDecl := a_extraFuncsDecl;
  out_a_extraFuncsNamespace := a_extraFuncsNamespace;
end fmuWriteOutputHeaderFile;

protected function fun_56
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      Absyn.Path i_modelInfo_name;
      Tpl.Text l_modelShortName;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = i_modelInfo_name)) )
      equation
        l_modelShortName = CodegenCppOld.lastIdentOfPath(Tpl.emptyTxt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "// declaration for Cpp FMU target\n",
                                    "\n",
                                    "class "
                                }, false));
        txt = Tpl.writeText(txt, l_modelShortName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("FMU: public "));
        txt = Tpl.writeText(txt, l_modelShortName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Initialize {\n",
                                    " public:\n",
                                    "  // constructor\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_modelShortName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "FMU(IGlobalSettings* globalSettings, shared_ptr<ISimObjects> simObjects);\n",
                                    "\n",
                                    "// initialization\n",
                                    "virtual void initialize();\n",
                                    "\n",
                                    "// getters for given value references\n",
                                    "virtual void getReal(const unsigned int vr[], size_t nvr, double value[]);\n",
                                    "virtual void getInteger(const unsigned int vr[], size_t nvr, int value[]);\n",
                                    "virtual void getBoolean(const unsigned int vr[], size_t nvr, int value[]);\n",
                                    "virtual void getString(const unsigned int vr[], size_t nvr, string value[]);\n",
                                    "\n",
                                    "// setters for given value references\n",
                                    "virtual void setReal(const unsigned int vr[], size_t nvr, const double value[]);\n",
                                    "virtual void setInteger(const unsigned int vr[], size_t nvr, const int value[]);\n",
                                    "virtual void setBoolean(const unsigned int vr[], size_t nvr, const int value[]);\n",
                                    "virtual void setString(const unsigned int vr[], size_t nvr, const string value[]);\n",
                                    "\n",
                                    "// Jacobian\n",
                                    "void getDirectionalDerivative(const unsigned int vrUnknown[], size_t nUnknown,\n",
                                    "                              const unsigned int vrKnown[], size_t nKnown,\n",
                                    "                              const double dvKnown[], double dvUnknown[]);\n",
                                    "\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " protected:\n",
                                    "  static unsigned int _inputRefs[];  ///< Value references of input variables\n",
                                    "  static unsigned int _outputRefs[]; ///< Value references of discrete states and outputs\n",
                                    "};\n",
                                    "\n",
                                    "/// create instance of "
                                }, false));
        txt = Tpl.writeText(txt, l_modelShortName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "FMU\n",
                                    "static "
                                }, false));
        txt = Tpl.writeText(txt, l_modelShortName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("FMU *createSystemFMU(IGlobalSettings *globalSettings);"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_56;

public function fmuModelHeaderFile
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input String a_guid;
  input String a_FMUVersion;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  out_txt := fun_56(txt, a_simCode);
  out_a_extraFuncs := a_extraFuncs;
  out_a_extraFuncsDecl := a_extraFuncsDecl;
  out_a_extraFuncsNamespace := a_extraFuncsNamespace;
end fmuModelHeaderFile;

protected function lm_58
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input Tpl.Text in_a_modelShortName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_modelShortName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      Tpl.Text a_modelShortName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      SimCode.SimEqSystem i_eqs;

    case ( txt,
           {},
           _,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           i_eqs :: rest,
           a_modelShortName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = CodegenCppOld.algloopMainfile2(txt, i_eqs, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, Tpl.textString(a_modelShortName));
        txt = Tpl.nextIter(txt);
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_58(txt, rest, a_modelShortName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_58;

protected function fun_59
  input Tpl.Text in_txt;
  input String in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           "" )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("createStaticAlgLoopSolverFactory(globalSettings, PATH(\"\"), PATH(\"\"))"));
      then txt;
  end match;
end fun_59;

protected function fun_60
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#include \"FMU2/FMU2Wrapper.cpp\""));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#include <FMU/FMUWrapper.h>"));
      then txt;
  end match;
end fun_60;

protected function fun_61
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#include \"FMU2/FMU2Interface.cpp\""));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#include <FMU/FMULibInterface.h>"));
      then txt;
  end match;
end fun_61;

protected function fun_62
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_a_var;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_var, in_a_simCode)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      DAE.ComponentRef i_name;
      Integer ret_2;
      Integer ret_1;
      SimCodeVar.SimVar ret_0;

    case ( txt,
           SimCodeVar.SIMVAR(name = i_name, type_ = DAE.T_REAL(varLst = _)),
           a_simCode )
      equation
        ret_0 = SimCodeUtil.cref2simvar(i_name, a_simCode);
        ret_1 = SimCodeUtil.getVariableIndex(ret_0);
        ret_2 = intSub(ret_1, 1);
        txt = Tpl.writeStr(txt, intString(ret_2));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_62;

protected function lm_63
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCode.SimCode a_simCode;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_simCode )
      equation
        txt = fun_62(txt, i_var, a_simCode);
        txt = Tpl.nextIter(txt);
        txt = lm_63(txt, rest, a_simCode);
      then txt;
  end match;
end lm_63;

protected function fun_64
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_a_var;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_var, in_a_simCode)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      DAE.ComponentRef i_name;
      Integer ret_5;
      Integer ret_4;
      SimCodeVar.SimVar ret_3;
      Integer ret_2;
      Integer ret_1;
      SimCodeVar.SimVar ret_0;

    case ( txt,
           SimCodeVar.SIMVAR(name = i_name, type_ = DAE.T_REAL(varLst = _), varKind = BackendDAE.CLOCKED_STATE(previousName = _)),
           a_simCode )
      equation
        ret_0 = SimCodeUtil.cref2simvar(i_name, a_simCode);
        ret_1 = SimCodeUtil.getVariableIndex(ret_0);
        ret_2 = intSub(ret_1, 1);
        txt = Tpl.writeStr(txt, intString(ret_2));
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(name = i_name, type_ = DAE.T_REAL(varLst = _), causality = SOME(SimCodeVar.OUTPUT())),
           a_simCode )
      equation
        ret_3 = SimCodeUtil.cref2simvar(i_name, a_simCode);
        ret_4 = SimCodeUtil.getVariableIndex(ret_3);
        ret_5 = intSub(ret_4, 1);
        txt = Tpl.writeStr(txt, intString(ret_5));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_64;

protected function lm_65
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCode.SimCode a_simCode;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_simCode )
      equation
        txt = fun_64(txt, i_var, a_simCode);
        txt = Tpl.nextIter(txt);
        txt = lm_65(txt, rest, a_simCode);
      then txt;
  end match;
end lm_65;

public function fmuModelCppFile
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input String in_a_guid;
  input String in_a_FMUVersion;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace) :=
  match(in_txt, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_guid, in_a_FMUVersion)
    local
      Tpl.Text txt;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      String a_guid;
      String a_FMUVersion;
      list<SimCodeVar.SimVar> i_algVars;
      list<SimCodeVar.SimVar> i_inputVars;
      SimCode.ModelInfo i_modelInfo;
      SimCode.SimCode i_simCode;
      list<SimCode.ClockedPartition> i_clockedPartitions;
      list<SimCode.SimEqSystem> i_initialEquations;
      list<SimCode.SimEqSystem> i_allEquations;
      Absyn.Path i_modelInfo_name;
      Boolean ret_12;
      Boolean ret_11;
      String str_10;
      Tpl.Text l_solverFactory;
      list<SimCode.SimEqSystem> ret_8;
      list<SimCode.SimEqSystem> ret_7;
      list<SimCode.SubPartition> ret_6;
      list<SimCode.SimEqSystem> ret_5;
      Tpl.Text l_algloopfiles;
      String ret_3;
      Tpl.Text l_modelLongName;
      Tpl.Text l_modelShortName;
      Tpl.Text l_modelName;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = (i_modelInfo as SimCode.MODELINFO(vars = SimCodeVar.SIMVARS(inputVars = i_inputVars, algVars = i_algVars), name = i_modelInfo_name)), modelStructure = _, allEquations = i_allEquations, initialEquations = i_initialEquations, clockedPartitions = i_clockedPartitions)),
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_guid,
           a_FMUVersion )
      equation
        l_modelName = CodegenUtil.dotPath(Tpl.emptyTxt, i_modelInfo_name);
        l_modelShortName = CodegenCppOld.lastIdentOfPath(Tpl.emptyTxt, i_modelInfo_name);
        ret_3 = System.stringReplace(Tpl.textString(l_modelName), ".", "_");
        l_modelLongName = Tpl.writeStr(Tpl.emptyTxt, ret_3);
        ret_5 = listAppend(i_allEquations, i_initialEquations);
        ret_6 = SimCodeUtil.getSubPartitions(i_clockedPartitions);
        ret_7 = SimCodeUtil.getClockedEquations(ret_6);
        ret_8 = listAppend(ret_5, ret_7);
        l_algloopfiles = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_algloopfiles, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_58(l_algloopfiles, ret_8, l_modelShortName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, i_simCode);
        l_algloopfiles = Tpl.popIter(l_algloopfiles);
        str_10 = Tpl.textString(l_algloopfiles);
        l_solverFactory = fun_59(Tpl.emptyTxt, str_10);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "// define model identifier and unique id\n",
                                    "#define MODEL_IDENTIFIER "
                                }, false));
        txt = Tpl.writeText(txt, l_modelLongName);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#define MODEL_IDENTIFIER_SHORT "));
        txt = Tpl.writeText(txt, l_modelShortName);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#define MODEL_CLASS "));
        txt = Tpl.writeText(txt, l_modelShortName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "FMU\n",
                                    "#define MODEL_GUID \"{"
                                }, false));
        txt = Tpl.writeStr(txt, a_guid);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\"\n",
                                    "\n"
                                }, true));
        txt = ModelDefineData(txt, i_modelInfo);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#define NUMBER_OF_EVENT_INDICATORS "));
        txt = CodegenFMUCommon.getNumberOfEventIndicators(txt, i_simCode);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        ret_11 = FMI.isFMIVersion10(a_FMUVersion);
        txt = fun_60(txt, ret_11);
        txt = Tpl.softNewLine(txt);
        ret_12 = FMI.isFMIVersion10(a_FMUVersion);
        txt = fun_61(txt, ret_12);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "// SimObjects for "
                                }, false));
        txt = Tpl.writeText(txt, l_modelShortName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "FMU\n",
                                    "shared_ptr<IAlgLoopSolverFactory> createStaticAlgLoopSolverFactory(IGlobalSettings*, PATH, PATH);\n",
                                    "\n",
                                    "class "
                                }, false));
        txt = Tpl.writeText(txt, l_modelShortName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "SimObjects : public ISimObjects {\n",
                                    " public:\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_modelShortName);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("SimObjects(IGlobalSettings *globalSettings) {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_algLoopSolverFactory = shared_ptr<IAlgLoopSolverFactory>("));
        txt = Tpl.writeText(txt, l_solverFactory);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(");\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("}\n"));
        txt = Tpl.writeText(txt, l_modelShortName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("SimObjects("));
        txt = Tpl.writeText(txt, l_modelShortName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "SimObjects& instance) {\n",
                                    "  _algLoopSolverFactory = instance._algLoopSolverFactory;\n",
                                    "}\n",
                                    "weak_ptr<ISimData> LoadSimData(string modelKey) {\n",
                                    "  return shared_ptr<ISimData>();\n",
                                    "}\n",
                                    "weak_ptr<ISimVars> LoadSimVars(string modelKey, size_t dim_real, size_t dim_int, size_t dim_bool, size_t dim_string, size_t dim_pre_vars, size_t dim_z, size_t z_i) {\n",
                                    "  _simVars = shared_ptr<ISimVars>(new SimVars(dim_real, dim_int, dim_bool, dim_string, dim_pre_vars, dim_z, z_i));\n",
                                    "  return _simVars;\n",
                                    "}\n",
                                    "weak_ptr<IHistory> LoadWriter(size_t) {\n",
                                    "  return shared_ptr<IHistory>();\n",
                                    "}\n",
                                    "shared_ptr<ISimData> getSimData(string modelKey) {\n",
                                    "  return shared_ptr<ISimData>();\n",
                                    "}\n",
                                    "shared_ptr<ISimVars> getSimVars(string modelKey) {\n",
                                    "  return _simVars;\n",
                                    "}\n",
                                    "void eraseSimData(string modelKey) {}\n",
                                    "void eraseSimVars(string modelKey) {}\n",
                                    "shared_ptr<IAlgLoopSolverFactory> getAlgLoopSolverFactory() {\n",
                                    "  return _algLoopSolverFactory;\n",
                                    "}\n",
                                    "\n",
                                    "ISimObjects* clone() {\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("return new "));
        txt = Tpl.writeText(txt, l_modelShortName);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("SimObjects(*this);\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("}\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " protected:\n",
                                    "  shared_ptr<ISimVars> _simVars;\n",
                                    "  shared_ptr<IAlgLoopSolverFactory> _algLoopSolverFactory;\n",
                                    "};\n",
                                    "\n",
                                    "// create instance of "
                                }, false));
        txt = Tpl.writeText(txt, l_modelShortName);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("FMU\n"));
        txt = Tpl.writeText(txt, l_modelShortName);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("FMU *createSystemFMU(IGlobalSettings *globalSettings) {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("shared_ptr<ISimObjects> simObjects(new "));
        txt = Tpl.writeText(txt, l_modelShortName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "SimObjects(globalSettings));\n",
                                    "simObjects->LoadSimVars(\""
                                }, false));
        txt = Tpl.writeText(txt, l_modelShortName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\", "));
        txt = CodegenCppOld.numRealvars(txt, i_modelInfo);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = CodegenCppOld.numIntvars(txt, i_modelInfo);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = CodegenCppOld.numBoolvars(txt, i_modelInfo);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = CodegenCppOld.numStringvars(txt, i_modelInfo);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = CodegenCppOld.getPreVarsCount(txt, i_modelInfo);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = CodegenCppOld.numStatevars(txt, i_modelInfo);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = CodegenCppOld.numStateVarIndex(txt, i_modelInfo);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ");\n",
                                    "simObjects->LoadSimData(\""
                                }, false));
        txt = Tpl.writeText(txt, l_modelShortName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\");\n",
                                    "globalSettings->setOutputFormat(EMPTY);\n",
                                    "return new "
                                }, false));
        txt = Tpl.writeText(txt, l_modelShortName);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("FMU(globalSettings, simObjects);\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n",
                                    "// value references of real inputs\n",
                                    "unsigned int "
                                }, false));
        txt = Tpl.writeText(txt, l_modelShortName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("FMU::_inputRefs[] = {"));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_63(txt, i_inputVars, i_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "};\n",
                                    "// value references of real discrete states and outputs\n",
                                    "unsigned int "
                                }, false));
        txt = Tpl.writeText(txt, l_modelShortName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("FMU::_outputRefs[] = {"));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_65(txt, i_algVars, i_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "};\n",
                                    "\n",
                                    "// constructor\n"
                                }, true));
        txt = Tpl.writeText(txt, l_modelShortName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("FMU::"));
        txt = Tpl.writeText(txt, l_modelShortName);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("FMU(IGlobalSettings* globalSettings, shared_ptr<ISimObjects> simObjects)\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(": "));
        txt = Tpl.writeText(txt, l_modelShortName);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("Initialize(globalSettings, simObjects) {\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n",
                                    "// initialization\n",
                                    "void "
                                }, false));
        txt = Tpl.writeText(txt, l_modelShortName);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("FMU::initialize() {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_modelShortName);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("WriteOutput::initialize();\n"));
        txt = Tpl.writeText(txt, l_modelShortName);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("Initialize::initializeMemory();\n"));
        txt = Tpl.writeText(txt, l_modelShortName);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("Initialize::initializeFreeVariables();\n"));
        txt = Tpl.writeText(txt, l_modelShortName);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("Jacobian::initialize();\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n",
                                    "// getters\n"
                                }, true));
        txt = accessFunctions(txt, i_simCode, "get", Tpl.textString(l_modelShortName), i_modelInfo);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "// setters\n"
                                }, true));
        txt = accessFunctions(txt, i_simCode, "set", Tpl.textString(l_modelShortName), i_modelInfo);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "// Jacobian\n"
                                }, true));
        txt = directionalDerivativeFunction(txt, i_simCode);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);

    case ( txt,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           _,
           _ )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
  end match;
end fmuModelCppFile;

protected function lm_67
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Function> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Function> rest;
      SimCodeFunction.Function i_fn;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_fn :: rest )
      equation
        txt = defineExternalFunction(txt, i_fn);
        txt = Tpl.nextIter(txt);
        txt = lm_67(txt, rest);
      then txt;
  end match;
end lm_67;

public function ModelDefineData
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Function> i_functions;

    case ( txt,
           SimCode.MODELINFO(varInfo = SimCode.VARINFO(numZeroCrossings = _), vars = SimCodeVar.SIMVARS(stateVars = _), functions = i_functions) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/* TODO: implement external functions in FMU wrapper for c++ target\n"));
        System.tmpTickReset(0);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_67(txt, i_functions);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("*/"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end ModelDefineData;

protected function fun_69
  input Tpl.Text in_txt;
  input String in_a_comment;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_comment)
    local
      Tpl.Text txt;
      String i_comment;

    case ( txt,
           "" )
      then txt;

    case ( txt,
           i_comment )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("// \""));
        txt = Tpl.writeStr(txt, i_comment);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
      then txt;
  end match;
end fun_69;

protected function fun_70
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_description;
  input Boolean in_a_useFlatArrayNotation;
  input DAE.ComponentRef in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_description, in_a_useFlatArrayNotation, in_a_name)
    local
      Tpl.Text txt;
      Tpl.Text a_description;
      Boolean a_useFlatArrayNotation;
      DAE.ComponentRef a_name;
      Integer ret_0;

    case ( txt,
           false,
           a_description,
           a_useFlatArrayNotation,
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#define "));
        txt = CodegenCppCommonOld.cref(txt, a_name, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_ "));
        ret_0 = System.tmpTick();
        txt = Tpl.writeStr(txt, intString(ret_0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, a_description);
      then txt;

    case ( txt,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_70;

protected function fun_71
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_description;
  input Boolean in_a_useFlatArrayNotation;
  input DAE.ComponentRef in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_description, in_a_useFlatArrayNotation, in_a_name)
    local
      Tpl.Text txt;
      Tpl.Text a_description;
      Boolean a_useFlatArrayNotation;
      DAE.ComponentRef a_name;
      Boolean ret_1;
      Tpl.Text txt_0;

    case ( txt,
           false,
           a_description,
           a_useFlatArrayNotation,
           a_name )
      equation
        txt_0 = CodegenUtil.crefStr(Tpl.emptyTxt, a_name);
        ret_1 = stringEq(Tpl.textString(txt_0), "der($dummy)");
        txt = fun_70(txt, ret_1, a_description, a_useFlatArrayNotation, a_name);
      then txt;

    case ( txt,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_71;

public function DefineVariables
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_a_simVar;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simVar, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      DAE.ComponentRef i_name;
      String i_comment;
      Boolean ret_2;
      Tpl.Text txt_1;
      Tpl.Text l_description;

    case ( txt,
           SimCodeVar.SIMVAR(comment = i_comment, name = i_name),
           a_useFlatArrayNotation )
      equation
        l_description = fun_69(Tpl.emptyTxt, i_comment);
        txt_1 = CodegenUtil.crefStr(Tpl.emptyTxt, i_name);
        ret_2 = stringEq(Tpl.textString(txt_1), "$dummy");
        txt = fun_71(txt, ret_2, l_description, a_useFlatArrayNotation, i_name);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end DefineVariables;

public function defineExternalFunction
  input Tpl.Text in_txt;
  input SimCodeFunction.Function in_a_fn;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fn)
    local
      Tpl.Text txt;
      String i_language;
      String i_extName;
      Integer ret_1;
      Tpl.Text l_fname;

    case ( txt,
           SimCodeFunction.EXTERNAL_FUNCTION(dynamicLoad = true, extName = i_extName, language = i_language) )
      equation
        l_fname = CodegenCppOld.extFunctionName(Tpl.emptyTxt, i_extName, i_language);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#define $P"));
        txt = Tpl.writeText(txt, l_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        ret_1 = System.tmpTick();
        txt = Tpl.writeStr(txt, intString(ret_1));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end defineExternalFunction;

protected function lm_74
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = initValsDefault(txt, i_var, "realVars", 0);
        txt = Tpl.nextIter(txt);
        txt = lm_74(txt, rest);
      then txt;
  end match;
end lm_74;

protected function lm_75
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Integer in_a_numStateVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_numStateVars)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Integer a_numStateVars;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_numStateVars )
      equation
        txt = initValsDefault(txt, i_var, "realVars", a_numStateVars);
        txt = Tpl.nextIter(txt);
        txt = lm_75(txt, rest, a_numStateVars);
      then txt;
  end match;
end lm_75;

protected function lm_76
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Integer in_a_numStateVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_numStateVars)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Integer a_numStateVars;
      SimCodeVar.SimVar i_var;
      Integer ret_0;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_numStateVars )
      equation
        ret_0 = intMul(2, a_numStateVars);
        txt = initValsDefault(txt, i_var, "realVars", ret_0);
        txt = Tpl.nextIter(txt);
        txt = lm_76(txt, rest, a_numStateVars);
      then txt;
  end match;
end lm_76;

protected function lm_77
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Integer in_a_numAlgVars;
  input Integer in_a_numStateVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_numAlgVars, in_a_numStateVars)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Integer a_numAlgVars;
      Integer a_numStateVars;
      SimCodeVar.SimVar i_var;
      Integer ret_1;
      Integer ret_0;

    case ( txt,
           {},
           _,
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_numAlgVars,
           a_numStateVars )
      equation
        ret_0 = intMul(2, a_numStateVars);
        ret_1 = intAdd(ret_0, a_numAlgVars);
        txt = initValsDefault(txt, i_var, "realVars", ret_1);
        txt = Tpl.nextIter(txt);
        txt = lm_77(txt, rest, a_numAlgVars, a_numStateVars);
      then txt;
  end match;
end lm_77;

protected function lm_78
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = initValsDefault(txt, i_var, "integerVars", 0);
        txt = Tpl.nextIter(txt);
        txt = lm_78(txt, rest);
      then txt;
  end match;
end lm_78;

protected function lm_79
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = initValsDefault(txt, i_var, "booleanVars", 0);
        txt = Tpl.nextIter(txt);
        txt = lm_79(txt, rest);
      then txt;
  end match;
end lm_79;

protected function lm_80
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = initValsDefault(txt, i_var, "stringVars", 0);
        txt = Tpl.nextIter(txt);
        txt = lm_80(txt, rest);
      then txt;
  end match;
end lm_80;

protected function lm_81
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = initParamsDefault(txt, i_var, "realParameter");
        txt = Tpl.nextIter(txt);
        txt = lm_81(txt, rest);
      then txt;
  end match;
end lm_81;

protected function lm_82
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = initParamsDefault(txt, i_var, "integerParameter");
        txt = Tpl.nextIter(txt);
        txt = lm_82(txt, rest);
      then txt;
  end match;
end lm_82;

protected function lm_83
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = initParamsDefault(txt, i_var, "booleanParameter");
        txt = Tpl.nextIter(txt);
        txt = lm_83(txt, rest);
      then txt;
  end match;
end lm_83;

protected function lm_84
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = initParamsDefault(txt, i_var, "stringParameter");
        txt = Tpl.nextIter(txt);
        txt = lm_84(txt, rest);
      then txt;
  end match;
end lm_84;

public function setDefaultStartValues
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> i_vars_stringParamVars;
      list<SimCodeVar.SimVar> i_vars_boolParamVars;
      list<SimCodeVar.SimVar> i_vars_intParamVars;
      list<SimCodeVar.SimVar> i_vars_paramVars;
      list<SimCodeVar.SimVar> i_vars_stringAlgVars;
      list<SimCodeVar.SimVar> i_vars_boolAlgVars;
      list<SimCodeVar.SimVar> i_vars_intAlgVars;
      Integer i_numAlgVars;
      list<SimCodeVar.SimVar> i_vars_discreteAlgVars;
      list<SimCodeVar.SimVar> i_vars_algVars;
      Integer i_numStateVars;
      list<SimCodeVar.SimVar> i_vars_derivativeVars;
      list<SimCodeVar.SimVar> i_vars_stateVars;

    case ( txt,
           SimCode.MODELINFO(varInfo = SimCode.VARINFO(numStateVars = i_numStateVars, numAlgVars = i_numAlgVars), vars = SimCodeVar.SIMVARS(stateVars = i_vars_stateVars, derivativeVars = i_vars_derivativeVars, algVars = i_vars_algVars, discreteAlgVars = i_vars_discreteAlgVars, intAlgVars = i_vars_intAlgVars, boolAlgVars = i_vars_boolAlgVars, stringAlgVars = i_vars_stringAlgVars, paramVars = i_vars_paramVars, intParamVars = i_vars_intParamVars, boolParamVars = i_vars_boolParamVars, stringParamVars = i_vars_stringParamVars)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "// Set values for all variables that define a start value\n",
                                    "void setDefaultStartValues(ModelInstance *comp) {\n",
                                    "/*\n"
                                }, true));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_74(txt, i_vars_stateVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_75(txt, i_vars_derivativeVars, i_numStateVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_76(txt, i_vars_algVars, i_numStateVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_77(txt, i_vars_discreteAlgVars, i_numAlgVars, i_numStateVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_78(txt, i_vars_intAlgVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_79(txt, i_vars_boolAlgVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_80(txt, i_vars_stringAlgVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_81(txt, i_vars_paramVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_82(txt, i_vars_intParamVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_83(txt, i_vars_boolParamVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_84(txt, i_vars_stringParamVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "*/\n",
                                    "}"
                                }, false));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end setDefaultStartValues;

protected function lm_86
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = initVals(txt, i_var, "realVars", 0);
        txt = Tpl.nextIter(txt);
        txt = lm_86(txt, rest);
      then txt;
  end match;
end lm_86;

protected function lm_87
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Integer in_a_numStateVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_numStateVars)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Integer a_numStateVars;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_numStateVars )
      equation
        txt = initVals(txt, i_var, "realVars", a_numStateVars);
        txt = Tpl.nextIter(txt);
        txt = lm_87(txt, rest, a_numStateVars);
      then txt;
  end match;
end lm_87;

protected function lm_88
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Integer in_a_numStateVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_numStateVars)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Integer a_numStateVars;
      SimCodeVar.SimVar i_var;
      Integer ret_0;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_numStateVars )
      equation
        ret_0 = intMul(2, a_numStateVars);
        txt = initVals(txt, i_var, "realVars", ret_0);
        txt = Tpl.nextIter(txt);
        txt = lm_88(txt, rest, a_numStateVars);
      then txt;
  end match;
end lm_88;

protected function lm_89
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Integer in_a_numAlgVars;
  input Integer in_a_numStateVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_numAlgVars, in_a_numStateVars)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Integer a_numAlgVars;
      Integer a_numStateVars;
      SimCodeVar.SimVar i_var;
      Integer ret_1;
      Integer ret_0;

    case ( txt,
           {},
           _,
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_numAlgVars,
           a_numStateVars )
      equation
        ret_0 = intMul(2, a_numStateVars);
        ret_1 = intAdd(ret_0, a_numAlgVars);
        txt = initVals(txt, i_var, "realVars", ret_1);
        txt = Tpl.nextIter(txt);
        txt = lm_89(txt, rest, a_numAlgVars, a_numStateVars);
      then txt;
  end match;
end lm_89;

protected function lm_90
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = initVals(txt, i_var, "integerVars", 0);
        txt = Tpl.nextIter(txt);
        txt = lm_90(txt, rest);
      then txt;
  end match;
end lm_90;

protected function lm_91
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = initVals(txt, i_var, "booleanVars", 0);
        txt = Tpl.nextIter(txt);
        txt = lm_91(txt, rest);
      then txt;
  end match;
end lm_91;

protected function lm_92
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = initVals(txt, i_var, "stringVars", 0);
        txt = Tpl.nextIter(txt);
        txt = lm_92(txt, rest);
      then txt;
  end match;
end lm_92;

protected function lm_93
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = initParams(txt, i_var, "realParameter");
        txt = Tpl.nextIter(txt);
        txt = lm_93(txt, rest);
      then txt;
  end match;
end lm_93;

protected function lm_94
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = initParams(txt, i_var, "integerParameter");
        txt = Tpl.nextIter(txt);
        txt = lm_94(txt, rest);
      then txt;
  end match;
end lm_94;

protected function lm_95
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = initParams(txt, i_var, "booleanParameter");
        txt = Tpl.nextIter(txt);
        txt = lm_95(txt, rest);
      then txt;
  end match;
end lm_95;

protected function lm_96
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = initParams(txt, i_var, "stringParameter");
        txt = Tpl.nextIter(txt);
        txt = lm_96(txt, rest);
      then txt;
  end match;
end lm_96;

public function setStartValues
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> i_vars_stringParamVars;
      list<SimCodeVar.SimVar> i_vars_boolParamVars;
      list<SimCodeVar.SimVar> i_vars_intParamVars;
      list<SimCodeVar.SimVar> i_vars_paramVars;
      list<SimCodeVar.SimVar> i_vars_stringAlgVars;
      list<SimCodeVar.SimVar> i_vars_boolAlgVars;
      list<SimCodeVar.SimVar> i_vars_intAlgVars;
      Integer i_numAlgVars;
      list<SimCodeVar.SimVar> i_vars_discreteAlgVars;
      list<SimCodeVar.SimVar> i_vars_algVars;
      Integer i_numStateVars;
      list<SimCodeVar.SimVar> i_vars_derivativeVars;
      list<SimCodeVar.SimVar> i_vars_stateVars;

    case ( txt,
           SimCode.MODELINFO(varInfo = SimCode.VARINFO(numStateVars = i_numStateVars, numAlgVars = i_numAlgVars), vars = SimCodeVar.SIMVARS(stateVars = i_vars_stateVars, derivativeVars = i_vars_derivativeVars, algVars = i_vars_algVars, discreteAlgVars = i_vars_discreteAlgVars, intAlgVars = i_vars_intAlgVars, boolAlgVars = i_vars_boolAlgVars, stringAlgVars = i_vars_stringAlgVars, paramVars = i_vars_paramVars, intParamVars = i_vars_intParamVars, boolParamVars = i_vars_boolParamVars, stringParamVars = i_vars_stringParamVars)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "// Set values for all variables that define a start value\n",
                                    "void setStartValues(ModelInstance *comp) {\n",
                                    "/*\n"
                                }, true));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_86(txt, i_vars_stateVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_87(txt, i_vars_derivativeVars, i_numStateVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_88(txt, i_vars_algVars, i_numStateVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_89(txt, i_vars_discreteAlgVars, i_numAlgVars, i_numStateVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_90(txt, i_vars_intAlgVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_91(txt, i_vars_boolAlgVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_92(txt, i_vars_stringAlgVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_93(txt, i_vars_paramVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_94(txt, i_vars_intParamVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_95(txt, i_vars_boolParamVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_96(txt, i_vars_stringParamVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "*/\n",
                                    "}"
                                }, false));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end setStartValues;

protected function fun_98
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_offset;
  input Integer in_a_index;
  input String in_a_arrayName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_offset, in_a_index, in_a_arrayName)
    local
      Tpl.Text txt;
      Integer a_offset;
      Integer a_index;
      String a_arrayName;
      Integer ret_2;
      Integer ret_1;
      Tpl.Text l_str;

    case ( txt,
           false,
           a_offset,
           a_index,
           a_arrayName )
      equation
        l_str = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("comp->fmuData->modelData."));
        l_str = Tpl.writeStr(l_str, a_arrayName);
        l_str = Tpl.writeTok(l_str, Tpl.ST_STRING("Data["));
        ret_1 = intAdd(a_index, a_offset);
        l_str = Tpl.writeStr(l_str, intString(ret_1));
        l_str = Tpl.writeTok(l_str, Tpl.ST_STRING("].attribute.start"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" =  comp->fmuData->localData[0]->"));
        txt = Tpl.writeStr(txt, a_arrayName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("["));
        ret_2 = intAdd(a_index, a_offset);
        txt = Tpl.writeStr(txt, intString(ret_2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("];"));
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_98;

protected function fun_99
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_offset;
  input Integer in_a_index;
  input String in_a_arrayName;
  input DAE.ComponentRef in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_offset, in_a_index, in_a_arrayName, in_a_name)
    local
      Tpl.Text txt;
      Integer a_offset;
      Integer a_index;
      String a_arrayName;
      DAE.ComponentRef a_name;
      Boolean ret_1;
      Tpl.Text txt_0;

    case ( txt,
           false,
           a_offset,
           a_index,
           a_arrayName,
           a_name )
      equation
        txt_0 = CodegenUtil.crefStr(Tpl.emptyTxt, a_name);
        ret_1 = stringEq(Tpl.textString(txt_0), "der($dummy)");
        txt = fun_98(txt, ret_1, a_offset, a_index, a_arrayName);
      then txt;

    case ( txt,
           _,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_99;

public function initVals
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_a_var;
  input String in_a_arrayName;
  input Integer in_a_offset;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_var, in_a_arrayName, in_a_offset)
    local
      Tpl.Text txt;
      String a_arrayName;
      Integer a_offset;
      Integer i_index;
      DAE.ComponentRef i_name;
      Boolean ret_1;
      Tpl.Text txt_0;

    case ( txt,
           SimCodeVar.SIMVAR(name = i_name, index = i_index),
           a_arrayName,
           a_offset )
      equation
        txt_0 = CodegenUtil.crefStr(Tpl.emptyTxt, i_name);
        ret_1 = stringEq(Tpl.textString(txt_0), "$dummy");
        txt = fun_99(txt, ret_1, a_offset, i_index, a_arrayName, i_name);
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end initVals;

public function initParams
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_a_var;
  input String in_a_arrayName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_var, in_a_arrayName)
    local
      Tpl.Text txt;
      String a_arrayName;
      Integer i_index;
      Tpl.Text l_str;

    case ( txt,
           SimCodeVar.SIMVAR(index = i_index),
           a_arrayName )
      equation
        l_str = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("comp->fmuData->modelData."));
        l_str = Tpl.writeStr(l_str, a_arrayName);
        l_str = Tpl.writeTok(l_str, Tpl.ST_STRING("Data["));
        l_str = Tpl.writeStr(l_str, intString(i_index));
        l_str = Tpl.writeTok(l_str, Tpl.ST_STRING("].attribute.start"));
        txt = Tpl.writeText(txt, l_str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = comp->fmuData->simulationInfo."));
        txt = Tpl.writeStr(txt, a_arrayName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("["));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("];"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end initParams;

protected function fun_102
  input Tpl.Text in_txt;
  input DAE.Type in_a_type__;
  input Tpl.Text in_a_str;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_type__, in_a_str)
    local
      Tpl.Text txt;
      Tpl.Text a_str;

    case ( txt,
           DAE.T_INTEGER(varLst = _),
           a_str )
      equation
        txt = Tpl.writeText(txt, a_str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = 0;"));
      then txt;

    case ( txt,
           DAE.T_REAL(varLst = _),
           a_str )
      equation
        txt = Tpl.writeText(txt, a_str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = 0;"));
      then txt;

    case ( txt,
           DAE.T_ENUMERATION(index = _),
           a_str )
      equation
        txt = Tpl.writeText(txt, a_str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = 0;"));
      then txt;

    case ( txt,
           DAE.T_BOOL(varLst = _),
           a_str )
      equation
        txt = Tpl.writeText(txt, a_str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = 0;"));
      then txt;

    case ( txt,
           DAE.T_STRING(varLst = _),
           a_str )
      equation
        txt = Tpl.writeText(txt, a_str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = \"\";"));
      then txt;

    case ( txt,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("UNKOWN_TYPE"));
      then txt;
  end match;
end fun_102;

protected function fun_103
  input Tpl.Text in_txt;
  input Option<DAE.Exp> in_a_initialValue;
  input DAE.Type in_a_type__;
  input Tpl.Text in_a_str;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_initialValue, in_a_type__, in_a_str)
    local
      Tpl.Text txt;
      DAE.Type a_type__;
      Tpl.Text a_str;
      DAE.Exp i_v;

    case ( txt,
           SOME(i_v),
           _,
           a_str )
      equation
        txt = Tpl.writeText(txt, a_str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = initVal(txt, i_v);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           NONE(),
           a_type__,
           a_str )
      equation
        txt = fun_102(txt, a_type__, a_str);
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_103;

public function initValsDefault
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_a_var;
  input String in_a_arrayName;
  input Integer in_a_offset;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_var, in_a_arrayName, in_a_offset)
    local
      Tpl.Text txt;
      String a_arrayName;
      Integer a_offset;
      DAE.Type i_type__;
      Option<DAE.Exp> i_initialValue;
      Integer i_index;
      Integer ret_1;
      Tpl.Text l_str;

    case ( txt,
           SimCodeVar.SIMVAR(index = i_index, type_ = i_type__, initialValue = i_initialValue),
           a_arrayName,
           a_offset )
      equation
        l_str = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("comp->fmuData->modelData."));
        l_str = Tpl.writeStr(l_str, a_arrayName);
        l_str = Tpl.writeTok(l_str, Tpl.ST_STRING("Data["));
        ret_1 = intAdd(i_index, a_offset);
        l_str = Tpl.writeStr(l_str, intString(ret_1));
        l_str = Tpl.writeTok(l_str, Tpl.ST_STRING("].attribute.start"));
        txt = fun_103(txt, i_initialValue, i_type__, l_str);
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end initValsDefault;

protected function fun_105
  input Tpl.Text in_txt;
  input Option<DAE.Exp> in_a_initialValue;
  input Tpl.Text in_a_str;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_initialValue, in_a_str)
    local
      Tpl.Text txt;
      Tpl.Text a_str;
      DAE.Exp i_v;

    case ( txt,
           SOME(i_v),
           a_str )
      equation
        txt = Tpl.writeText(txt, a_str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = initVal(txt, i_v);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_105;

public function initParamsDefault
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_a_var;
  input String in_a_arrayName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_var, in_a_arrayName)
    local
      Tpl.Text txt;
      String a_arrayName;
      Option<DAE.Exp> i_initialValue;
      Integer i_index;
      Tpl.Text l_str;

    case ( txt,
           SimCodeVar.SIMVAR(index = i_index, initialValue = i_initialValue),
           a_arrayName )
      equation
        l_str = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("comp->fmuData->modelData."));
        l_str = Tpl.writeStr(l_str, a_arrayName);
        l_str = Tpl.writeTok(l_str, Tpl.ST_STRING("Data["));
        l_str = Tpl.writeStr(l_str, intString(i_index));
        l_str = Tpl.writeTok(l_str, Tpl.ST_STRING("].attribute.start"));
        txt = fun_105(txt, i_initialValue, l_str);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end initParamsDefault;

protected function fun_107
  input Tpl.Text in_txt;
  input Boolean in_a_bool;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_bool)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("0"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("1"));
      then txt;
  end match;
end fun_107;

public function initVal
  input Tpl.Text in_txt;
  input DAE.Exp in_a_initialValue;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_initialValue)
    local
      Tpl.Text txt;
      Absyn.Path i_name;
      Integer i_index;
      Boolean i_bool;
      String i_string;
      Real i_real;
      Integer i_integer;
      String ret_0;

    case ( txt,
           DAE.ICONST(integer = i_integer) )
      equation
        txt = Tpl.writeStr(txt, intString(i_integer));
      then txt;

    case ( txt,
           DAE.RCONST(real = i_real) )
      equation
        txt = Tpl.writeStr(txt, realString(i_real));
      then txt;

    case ( txt,
           DAE.SCONST(string = i_string) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        ret_0 = Util.escapeModelicaStringToXmlString(i_string);
        txt = Tpl.writeStr(txt, ret_0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
      then txt;

    case ( txt,
           DAE.BCONST(bool = i_bool) )
      equation
        txt = fun_107(txt, i_bool);
      then txt;

    case ( txt,
           DAE.ENUM_LITERAL(index = i_index, name = i_name) )
      equation
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/*ENUM:"));
        txt = CodegenUtil.dotPath(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("*/"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("*ERROR* initial value of unknown type"));
      then txt;
  end match;
end initVal;

public function setExternalFunction
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Function> i_functions;
      Tpl.Text l_externalFuncs;

    case ( txt,
           SimCode.MODELINFO(vars = SimCodeVar.SIMVARS(stateVars = _), functions = i_functions) )
      equation
        l_externalFuncs = setExternalFunctionsSwitch(Tpl.emptyTxt, i_functions);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "fmiStatus setExternalFunction(ModelInstance* c, const fmiValueReference vr, const void* value){\n",
                                    "  switch (vr) {\n",
                                    "  /*\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(6));
        txt = Tpl.writeText(txt, l_externalFuncs);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "  */\n",
                                    "      default:\n",
                                    "          return fmiError;\n",
                                    "  }\n",
                                    "  return fmiOK;\n",
                                    "}\n",
                                    "\n"
                                }, true));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end setExternalFunction;

protected function lm_110
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Function> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Function> rest;
      SimCodeFunction.Function i_fn;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_fn :: rest )
      equation
        txt = setExternalFunctionSwitch(txt, i_fn);
        txt = Tpl.nextIter(txt);
        txt = lm_110(txt, rest);
      then txt;
  end match;
end lm_110;

public function setExternalFunctionsSwitch
  input Tpl.Text txt;
  input list<SimCodeFunction.Function> a_functions;

  output Tpl.Text out_txt;
algorithm
  out_txt := Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_110(out_txt, a_functions);
  out_txt := Tpl.popIter(out_txt);
end setExternalFunctionsSwitch;

public function setExternalFunctionSwitch
  input Tpl.Text in_txt;
  input SimCodeFunction.Function in_a_fn;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fn)
    local
      Tpl.Text txt;
      String i_language;
      String i_extName;
      Tpl.Text l_fname;

    case ( txt,
           SimCodeFunction.EXTERNAL_FUNCTION(dynamicLoad = true, extName = i_extName, language = i_language) )
      equation
        l_fname = CodegenCppOld.extFunctionName(Tpl.emptyTxt, i_extName, i_language);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("case $P"));
        txt = Tpl.writeText(txt, l_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" : ptr_"));
        txt = Tpl.writeText(txt, l_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("=(ptrT_"));
        txt = Tpl.writeText(txt, l_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")value; break;"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end setExternalFunctionSwitch;

protected function fun_113
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;
  input SimCode.SimCode in_a_simCode;
  input String in_a_direction;
  input String in_a_modelShortName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo, in_a_simCode, in_a_direction, in_a_modelShortName)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      String a_direction;
      String a_modelShortName;
      list<SimCodeVar.SimVar> i_vars_stringAliasVars;
      list<SimCodeVar.SimVar> i_vars_stringParamVars;
      list<SimCodeVar.SimVar> i_vars_stringAlgVars;
      list<SimCodeVar.SimVar> i_vars_boolAliasVars;
      list<SimCodeVar.SimVar> i_vars_boolParamVars;
      list<SimCodeVar.SimVar> i_vars_boolAlgVars;
      list<SimCodeVar.SimVar> i_vars_intAliasVars;
      list<SimCodeVar.SimVar> i_vars_intParamVars;
      list<SimCodeVar.SimVar> i_vars_intAlgVars;
      list<SimCodeVar.SimVar> i_vars_aliasVars;
      Integer i_numParams;
      Integer i_numDiscreteReal;
      Integer i_numAlgVars;
      Integer i_numStateVars;
      Integer ret_12;
      Integer ret_11;
      Integer ret_10;
      Integer ret_9;
      Integer ret_8;
      Integer ret_7;
      Integer ret_6;
      Integer ret_5;
      Integer ret_4;
      Integer ret_3;
      Integer ret_2;
      Integer ret_1;
      Integer ret_0;

    case ( txt,
           SimCode.MODELINFO(vars = SimCodeVar.SIMVARS(aliasVars = i_vars_aliasVars, intAlgVars = i_vars_intAlgVars, intParamVars = i_vars_intParamVars, intAliasVars = i_vars_intAliasVars, boolAlgVars = i_vars_boolAlgVars, boolParamVars = i_vars_boolParamVars, boolAliasVars = i_vars_boolAliasVars, stringAlgVars = i_vars_stringAlgVars, stringParamVars = i_vars_stringParamVars, stringAliasVars = i_vars_stringAliasVars), varInfo = SimCode.VARINFO(numStateVars = i_numStateVars, numAlgVars = i_numAlgVars, numDiscreteReal = i_numDiscreteReal, numParams = i_numParams)),
           a_simCode,
           a_direction,
           a_modelShortName )
      equation
        ret_0 = intMul(2, i_numStateVars);
        ret_1 = intAdd(ret_0, i_numAlgVars);
        ret_2 = intAdd(ret_1, i_numDiscreteReal);
        ret_3 = intAdd(ret_2, i_numParams);
        txt = accessVarsFunction(txt, a_simCode, a_direction, a_modelShortName, "Real", "Real", "double", ret_3, i_vars_aliasVars);
        txt = Tpl.softNewLine(txt);
        ret_4 = listLength(i_vars_intAlgVars);
        ret_5 = listLength(i_vars_intParamVars);
        ret_6 = intAdd(ret_4, ret_5);
        txt = accessVarsFunction(txt, a_simCode, a_direction, a_modelShortName, "Integer", "Int", "int", ret_6, i_vars_intAliasVars);
        txt = Tpl.softNewLine(txt);
        ret_7 = listLength(i_vars_boolAlgVars);
        ret_8 = listLength(i_vars_boolParamVars);
        ret_9 = intAdd(ret_7, ret_8);
        txt = accessVarsFunction(txt, a_simCode, a_direction, a_modelShortName, "Boolean", "Bool", "int", ret_9, i_vars_boolAliasVars);
        txt = Tpl.softNewLine(txt);
        ret_10 = listLength(i_vars_stringAlgVars);
        ret_11 = listLength(i_vars_stringParamVars);
        ret_12 = intAdd(ret_10, ret_11);
        txt = accessVarsFunction(txt, a_simCode, a_direction, a_modelShortName, "String", "String", "string", ret_12, i_vars_stringAliasVars);
      then txt;

    case ( txt,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_113;

public function accessFunctions
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input String a_direction;
  input String a_modelShortName;
  input SimCode.ModelInfo a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_113(txt, a_modelInfo, a_simCode, a_direction, a_modelShortName);
end accessFunctions;

protected function fun_115
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("const"));
      then txt;
  end match;
end fun_115;

protected function fun_116
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_pointerName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_pointerName)
    local
      Tpl.Text txt;
      String a_pointerName;

    case ( txt,
           false,
           a_pointerName )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_pointerTo"));
        txt = Tpl.writeStr(txt, a_pointerName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Vars[*vr] = *value;"));
      then txt;

    case ( txt,
           _,
           a_pointerName )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("*value = _pointerTo"));
        txt = Tpl.writeStr(txt, a_pointerName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Vars[*vr];"));
      then txt;
  end match;
end fun_116;

protected function fun_117
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_a_var;
  input Integer in_a_offset;
  input String in_a_direction;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_var, in_a_offset, in_a_direction, in_a_simCode)
    local
      Tpl.Text txt;
      Integer a_offset;
      String a_direction;
      SimCode.SimCode a_simCode;
      SimCodeVar.SimVar i_var;

    case ( txt,
           (i_var as SimCodeVar.SIMVAR(aliasvar = SimCodeVar.NEGATEDALIAS(varName = _))),
           a_offset,
           a_direction,
           a_simCode )
      equation
        txt = accessVar(txt, a_simCode, a_direction, i_var, a_offset);
      then txt;

    case ( txt,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_117;

protected function lm_118
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Integer in_a_offset;
  input String in_a_direction;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_offset, in_a_direction, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Integer a_offset;
      String a_direction;
      SimCode.SimCode a_simCode;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _,
           _,
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_offset,
           a_direction,
           a_simCode )
      equation
        txt = fun_117(txt, i_var, a_offset, a_direction, a_simCode);
        txt = Tpl.nextIter(txt);
        txt = lm_118(txt, rest, a_offset, a_direction, a_simCode);
      then txt;
  end match;
end lm_118;

public function accessVarsFunction
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input String a_direction;
  input String a_modelShortName;
  input String a_typeName;
  input String a_pointerName;
  input String a_typeImpl;
  input Integer a_offset;
  input list<SimCodeVar.SimVar> a_aliasVars;

  output Tpl.Text out_txt;
protected
  Boolean ret_2;
  Boolean ret_1;
  Tpl.Text l_qualifier;
algorithm
  ret_1 := stringEq(a_direction, "set");
  l_qualifier := fun_115(Tpl.emptyTxt, ret_1);
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING("void "));
  out_txt := Tpl.writeStr(out_txt, a_modelShortName);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("FMU::"));
  out_txt := Tpl.writeStr(out_txt, a_direction);
  out_txt := Tpl.writeStr(out_txt, a_typeName);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("(const unsigned int vr[], size_t nvr, "));
  out_txt := Tpl.writeText(out_txt, l_qualifier);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING(" "));
  out_txt := Tpl.writeStr(out_txt, a_typeImpl);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       " value[]) {\n",
                                       "  for (size_t i = 0; i < nvr; i++, vr++, value++) {\n",
                                       "    // access variables and aliases in SimVars memory\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(4));
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("if (*vr < _dim"));
  out_txt := Tpl.writeStr(out_txt, a_typeName);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE(")\n"));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  ret_2 := stringEq(a_direction, "get");
  out_txt := fun_116(out_txt, ret_2, a_pointerName);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "// convert negated aliases\n",
                                       "else switch (*vr) {\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.pushIter(out_txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_118(out_txt, a_aliasVars, a_offset, a_direction, a_simCode);
  out_txt := Tpl.popIter(out_txt);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("default:\n"));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("throw std::invalid_argument(\""));
  out_txt := Tpl.writeStr(out_txt, a_direction);
  out_txt := Tpl.writeStr(out_txt, a_typeName);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE(" with wrong value reference \" + omcpp::to_string(*vr));\n"));
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("}\n"));
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "  }\n",
                                       "}"
                                   }, false));
end accessVarsFunction;

protected function fun_120
  input Tpl.Text in_txt;
  input String in_a_comment;
  input Tpl.Text in_a_descName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_comment, in_a_descName)
    local
      Tpl.Text txt;
      Tpl.Text a_descName;
      String i_comment;

    case ( txt,
           "",
           a_descName )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/* "));
        txt = Tpl.writeText(txt, a_descName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" */"));
      then txt;

    case ( txt,
           i_comment,
           a_descName )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/* "));
        txt = Tpl.writeText(txt, a_descName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" \""));
        txt = Tpl.writeStr(txt, i_comment);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\" */"));
      then txt;
  end match;
end fun_120;

protected function fun_121
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_cppSign;
  input Tpl.Text in_a_cppName;
  input Tpl.Text in_a_description;
  input Integer in_a_index;
  input Integer in_a_offset;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_cppSign, in_a_cppName, in_a_description, in_a_index, in_a_offset)
    local
      Tpl.Text txt;
      Tpl.Text a_cppSign;
      Tpl.Text a_cppName;
      Tpl.Text a_description;
      Integer a_index;
      Integer a_offset;
      Integer ret_1;
      Integer ret_0;

    case ( txt,
           false,
           a_cppSign,
           a_cppName,
           a_description,
           a_index,
           a_offset )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("case "));
        ret_0 = intAdd(a_offset, a_index);
        txt = Tpl.writeStr(txt, intString(ret_0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(": "));
        txt = Tpl.writeText(txt, a_description);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_cppName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, a_cppSign);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("*value; break;"));
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           _,
           a_cppSign,
           a_cppName,
           a_description,
           a_index,
           a_offset )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("case "));
        ret_1 = intAdd(a_offset, a_index);
        txt = Tpl.writeStr(txt, intString(ret_1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(": "));
        txt = Tpl.writeText(txt, a_description);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("*value = "));
        txt = Tpl.writeText(txt, a_cppSign);
        txt = Tpl.writeText(txt, a_cppName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("; break;"));
        txt = Tpl.popBlock(txt);
      then txt;
  end match;
end fun_121;

protected function fun_122
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_a_simVar;
  input SimCode.SimCode in_a_simCode;
  input String in_a_direction;
  input Integer in_a_offset;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simVar, in_a_simCode, in_a_direction, in_a_offset)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      String a_direction;
      Integer a_offset;
      Integer i_index;
      SimCodeVar.SimVar i_simVar;
      String i_comment;
      DAE.ComponentRef i_name;
      Boolean ret_6;
      Tpl.Text l_cppSign;
      Tpl.Text l_cppName;
      Tpl.Text l_description;
      String ret_2;
      Tpl.Text txt_1;
      Tpl.Text l_descName;

    case ( txt,
           (i_simVar as SimCodeVar.SIMVAR(name = i_name, comment = i_comment, index = i_index)),
           a_simCode,
           a_direction,
           a_offset )
      equation
        txt_1 = CodegenUtil.crefStrNoUnderscore(Tpl.emptyTxt, i_name);
        ret_2 = System.stringReplace(Tpl.textString(txt_1), "$", "_D_");
        l_descName = Tpl.writeStr(Tpl.emptyTxt, ret_2);
        l_description = fun_120(Tpl.emptyTxt, i_comment, l_descName);
        l_cppName = getCppName(Tpl.emptyTxt, a_simCode, i_simVar);
        l_cppSign = getCppSign(Tpl.emptyTxt, a_simCode, i_simVar);
        ret_6 = stringEq(a_direction, "get");
        txt = fun_121(txt, ret_6, l_cppSign, l_cppName, l_description, i_index, a_offset);
      then txt;

    case ( txt,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_122;

public function accessVar
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input String a_direction;
  input SimCodeVar.SimVar a_simVar;
  input Integer a_offset;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_122(txt, a_simVar, a_simCode, a_direction, a_offset);
end accessVar;

protected function fun_124
  input Tpl.Text in_txt;
  input SimCodeVar.AliasVariable in_a_aliasvar;
  input Tpl.Text in_a_actualName;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_aliasvar, in_a_actualName, in_a_simCode)
    local
      Tpl.Text txt;
      Tpl.Text a_actualName;
      SimCode.SimCode a_simCode;
      DAE.ComponentRef i_varName;

    case ( txt,
           SimCodeVar.ALIAS(varName = i_varName),
           _,
           a_simCode )
      equation
        (txt, _, _, _, _, _) = CodegenCppCommonOld.cref1(txt, i_varName, a_simCode, Tpl.strTokText(Tpl.ST_STRING("")), Tpl.strTokText(Tpl.ST_STRING("")), Tpl.strTokText(Tpl.ST_STRING("")), SimCodeFunction.contextOther, Tpl.strTokText(Tpl.ST_STRING("")), Tpl.strTokText(Tpl.ST_STRING("")), false);
      then txt;

    case ( txt,
           SimCodeVar.NEGATEDALIAS(varName = i_varName),
           _,
           a_simCode )
      equation
        (txt, _, _, _, _, _) = CodegenCppCommonOld.cref1(txt, i_varName, a_simCode, Tpl.strTokText(Tpl.ST_STRING("")), Tpl.strTokText(Tpl.ST_STRING("")), Tpl.strTokText(Tpl.ST_STRING("")), SimCodeFunction.contextOther, Tpl.strTokText(Tpl.ST_STRING("")), Tpl.strTokText(Tpl.ST_STRING("")), false);
      then txt;

    case ( txt,
           _,
           a_actualName,
           _ )
      equation
        txt = Tpl.writeText(txt, a_actualName);
      then txt;
  end match;
end fun_124;

protected function fun_125
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_a_simVar;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simVar, in_a_simCode)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      SimCodeVar.AliasVariable i_aliasvar;
      DAE.ComponentRef i_name;
      Tpl.Text l_actualName;

    case ( txt,
           SimCodeVar.SIMVAR(name = i_name, aliasvar = i_aliasvar),
           a_simCode )
      equation
        (l_actualName, _, _, _, _, _) = CodegenCppCommonOld.cref1(Tpl.emptyTxt, i_name, a_simCode, Tpl.strTokText(Tpl.ST_STRING("")), Tpl.strTokText(Tpl.ST_STRING("")), Tpl.strTokText(Tpl.ST_STRING("")), SimCodeFunction.contextOther, Tpl.strTokText(Tpl.ST_STRING("")), Tpl.strTokText(Tpl.ST_STRING("")), false);
        txt = fun_124(txt, i_aliasvar, l_actualName, a_simCode);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_125;

public function getCppName
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input SimCodeVar.SimVar a_simVar;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_125(txt, a_simVar, a_simCode);
end getCppName;

protected function fun_127
  input Tpl.Text in_txt;
  input DAE.Type in_a_type__;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_type__)
    local
      Tpl.Text txt;

    case ( txt,
           DAE.T_BOOL(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("!"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-"));
      then txt;
  end match;
end fun_127;

protected function fun_128
  input Tpl.Text in_txt;
  input SimCodeVar.AliasVariable in_a_aliasvar;
  input DAE.Type in_a_type__;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_aliasvar, in_a_type__)
    local
      Tpl.Text txt;
      DAE.Type a_type__;

    case ( txt,
           SimCodeVar.NEGATEDALIAS(varName = _),
           a_type__ )
      equation
        txt = fun_127(txt, a_type__);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_128;

protected function fun_129
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_a_simVar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simVar)
    local
      Tpl.Text txt;
      DAE.Type i_type__;
      SimCodeVar.AliasVariable i_aliasvar;

    case ( txt,
           SimCodeVar.SIMVAR(type_ = i_type__, aliasvar = i_aliasvar) )
      equation
        txt = fun_128(txt, i_aliasvar, i_type__);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_129;

public function getCppSign
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input SimCodeVar.SimVar a_simVar;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_129(txt, a_simVar);
end getCppSign;

protected function fun_131
  input Tpl.Text in_txt;
  input SimCode.FmiDiscreteStates in_a_modelStructure_fmiDiscreteStates;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelStructure_fmiDiscreteStates)
    local
      Tpl.Text txt;
      list<SimCode.FmiUnknown> i_fmiUnknownsList;
      Integer ret_0;

    case ( txt,
           SimCode.FMIDISCRETESTATES(fmiUnknownsList = i_fmiUnknownsList) )
      equation
        ret_0 = listLength(i_fmiUnknownsList);
        txt = Tpl.writeStr(txt, intString(ret_0));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("0"));
      then txt;
  end match;
end fun_131;

protected function fun_132
  input Tpl.Text in_txt;
  input Option<SimCode.FmiModelStructure> in_a_fmiModelStructure;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fmiModelStructure)
    local
      Tpl.Text txt;
      SimCode.FmiDiscreteStates i_modelStructure_fmiDiscreteStates;

    case ( txt,
           SOME(SimCode.FMIMODELSTRUCTURE(fmiDiscreteStates = i_modelStructure_fmiDiscreteStates)) )
      equation
        txt = fun_131(txt, i_modelStructure_fmiDiscreteStates);
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("0"));
      then txt;
  end match;
end fun_132;

protected function fun_133
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_dimDiscreteStates;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_dimDiscreteStates)
    local
      Tpl.Text txt;
      Tpl.Text a_dimDiscreteStates;

    case ( txt,
           false,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("  throw ModelicaSimulationError(MATH_FUNCTION, \"No derivative code, see flag disableDirectionalDerivatives\");"));
      then txt;

    case ( txt,
           _,
           a_dimDiscreteStates )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("  unsigned int idx, *ref_p, ref_1;\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("int dimStates = _dimContinuousStates + "));
        txt = Tpl.writeText(txt, a_dimDiscreteStates);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "\n",
                                    "_FMIDERjac_x.clear();\n",
                                    "ref_p = NULL;\n",
                                    "for (size_t j = 0; j < nKnown; j++) {\n",
                                    "  idx = vrKnown[j];\n",
                                    "  if (idx >= dimStates) {\n",
                                    "    // find input reference\n",
                                    "    if (ref_p == NULL || idx < ref_1)\n",
                                    "      ref_p = _inputRefs; // reset ref_p if vrKnown decreases\n",
                                    "    ref_p = std::find(ref_p, _inputRefs + sizeof(_inputRefs)/sizeof(unsigned int), vrKnown[j]);\n",
                                    "    ref_1 = idx;\n",
                                    "    idx = dimStates + (ref_p - _inputRefs);\n",
                                    "  }\n",
                                    "  if (idx >= _FMIDERjac_x.size())\n",
                                    "    throw std::invalid_argument(\"getDirectionalDerivative with wrong value reference of known \" + omcpp::to_string(vrKnown[j]));\n",
                                    "  _FMIDERjac_x(idx) = dvKnown[j];\n",
                                    "}\n",
                                    "calcFMIDERJacobianColumn();\n",
                                    "ref_p = NULL;\n",
                                    "for (size_t i = 0; i < nUnknown; i++) {\n",
                                    "  idx = vrUnknown[i] - _dimContinuousStates; // derivatives behind states\n",
                                    "  if (idx >= _dimContinuousStates) {\n",
                                    "    // find output reference\n",
                                    "    if (ref_p == NULL || idx < ref_1)\n",
                                    "      ref_p = _outputRefs; // reset ref_p if vrUnknown decreases\n",
                                    "    ref_p = std::find(ref_p, _outputRefs + sizeof(_outputRefs)/sizeof(unsigned int), vrUnknown[i]);\n",
                                    "    ref_1 = idx;\n",
                                    "    idx = _dimContinuousStates + (ref_p - _outputRefs);\n",
                                    "  }\n",
                                    "  if (idx >= _FMIDERjac_y.size())\n",
                                    "    throw std::invalid_argument(\"getDirectionalDerivative with wrong value reference of unknown \" + omcpp::to_string(vrUnknown[i]));\n",
                                    "  dvUnknown[i] = _FMIDERjac_y(idx);\n",
                                    "}"
                                }, false));
        txt = Tpl.popBlock(txt);
      then txt;
  end match;
end fun_133;

public function directionalDerivativeFunction
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      SimCode.SimCode i_simCode;
      Option<SimCode.FmiModelStructure> i_fmiModelStructure;
      Absyn.Path i_modelInfo_name;
      Boolean ret_2;
      Tpl.Text l_dimDiscreteStates;
      Tpl.Text l_modelShortName;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = i_modelInfo_name), modelStructure = i_fmiModelStructure)) )
      equation
        l_modelShortName = CodegenCppOld.lastIdentOfPath(Tpl.emptyTxt, i_modelInfo_name);
        l_dimDiscreteStates = fun_132(Tpl.emptyTxt, i_fmiModelStructure);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = Tpl.writeText(txt, l_modelShortName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "FMU::getDirectionalDerivative(\n",
                                    "    const unsigned int vrUnknown[], size_t nUnknown,\n",
                                    "    const unsigned int vrKnown[], size_t nKnown,\n",
                                    "    const double dvKnown[], double dvUnknown[])\n",
                                    "{\n"
                                }, true));
        ret_2 = SimCodeUtil.providesDirectionalDerivative(i_simCode);
        txt = fun_133(txt, ret_2, l_dimDiscreteStates);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end directionalDerivativeFunction;

protected function fun_135
  input Tpl.Text in_txt;
  input String in_a_modelInfo_directory;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo_directory)
    local
      Tpl.Text txt;
      String i_modelInfo_directory;

    case ( txt,
           "" )
      then txt;

    case ( txt,
           i_modelInfo_directory )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-L\""));
        txt = Tpl.writeStr(txt, i_modelInfo_directory);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
      then txt;
  end match;
end fun_135;

protected function lm_136
  input Tpl.Text in_txt;
  input list<String> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<String> rest;
      String i_lib;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_lib :: rest )
      equation
        txt = Tpl.writeStr(txt, i_lib);
        txt = Tpl.nextIter(txt);
        txt = lm_136(txt, rest);
      then txt;
  end match;
end lm_136;

protected function fun_137
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-lOMOCLRuntime -lOpenCL"));
      then txt;
  end match;
end fun_137;

protected function fun_138
  input Tpl.Text in_txt;
  input String in_a_s_method;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_s_method)
    local
      Tpl.Text txt;

    case ( txt,
           "dassljac" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-D_OMC_JACOBIAN "));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_138;

protected function fun_139
  input Tpl.Text in_txt;
  input Option<SimCode.SimulationSettings> in_a_sopt;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_sopt)
    local
      Tpl.Text txt;
      String i_s_method;

    case ( txt,
           SOME(SimCode.SIMULATION_SETTINGS(method = i_s_method)) )
      equation
        txt = fun_138(txt, i_s_method);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_139;

protected function fun_140
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_makefileParams_omhome;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_makefileParams_omhome)
    local
      Tpl.Text txt;
      String a_makefileParams_omhome;

    case ( txt,
           false,
           a_makefileParams_omhome )
      equation
        txt = Tpl.writeStr(txt, a_makefileParams_omhome);
      then txt;

    case ( txt,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("$(OPENMODELICAHOME)"));
      then txt;
  end match;
end fun_140;

protected function fun_141
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      String i_fmuTargetName;
      String i_fileNamePrefix;
      String i_makefileParams_platform;
      String i_makefileParams_omhome;
      Option<SimCode.SimulationSettings> i_sopt;
      list<String> i_makefileParams_libs;
      String i_modelInfo_directory;
      Boolean ret_7;
      Boolean ret_6;
      Boolean ret_5;
      Tpl.Text l_extraCflags;
      Boolean ret_3;
      Tpl.Text l_ParModelicaLibs;
      Tpl.Text l_libsExtra;
      Tpl.Text l_dirExtra;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(directory = i_modelInfo_directory), makefileParams = SimCodeFunction.MAKEFILE_PARAMS(libs = i_makefileParams_libs, omhome = i_makefileParams_omhome, platform = i_makefileParams_platform), simulationSettingsOpt = i_sopt, fileNamePrefix = i_fileNamePrefix, fmuTargetName = i_fmuTargetName) )
      equation
        l_dirExtra = fun_135(Tpl.emptyTxt, i_modelInfo_directory);
        l_libsExtra = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(" ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_libsExtra = lm_136(l_libsExtra, i_makefileParams_libs);
        l_libsExtra = Tpl.popIter(l_libsExtra);
        ret_3 = Config.acceptParModelicaGrammar();
        l_ParModelicaLibs = fun_137(Tpl.emptyTxt, ret_3);
        l_extraCflags = fun_139(Tpl.emptyTxt, i_sopt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "# Makefile generated by OpenModelica\n",
                                    "# run with nmake from Visual Studio Command Prompt\n",
                                    "# FMU packaging requires PATH to "
                                }, false));
        txt = Tpl.writeStr(txt, i_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "/mingw/bin\n",
                                    "OMHOME="
                                }, false));
        ret_5 = stringEq(i_makefileParams_platform, "win32");
        ret_6 = stringEq(i_makefileParams_platform, "win64");
        ret_7 = boolOr(ret_5, ret_6);
        txt = fun_140(txt, ret_7, i_makefileParams_omhome);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("include "));
        txt = Tpl.writeStr(txt, i_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "/include/omc/cpp/ModelicaConfig_msvc.inc\n",
                                    "include "
                                }, false));
        txt = Tpl.writeStr(txt, i_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "/include/omc/cpp/ModelicaLibraryConfig_msvc.inc\n",
                                    "# Simulations use /Od by default\n",
                                    "SIM_OR_DYNLOAD_OPT_LEVEL=\n",
                                    "MODELICAUSERCFLAGS=\n",
                                    "CXX=cl\n",
                                    "EXEEXT=.exe\n",
                                    "DLLEXT=.dll\n",
                                    "\n",
                                    "# /Od - Optimization disabled\n",
                                    "# /EHa enable C++ EH (w/ SEH exceptions)\n",
                                    "# /fp:except - consider floating-point exceptions when generating code\n",
                                    "# /arch:SSE2 - enable use of instructions available with SSE2 enabled CPUs\n",
                                    "# /I - Include Directories\n",
                                    "# /DNOMINMAX - Define NOMINMAX (does what it says)\n",
                                    "# /TP - Use C++ Compiler\n",
                                    "\n",
                                    "CFLAGS=$(SYSTEM_CFLAGS) /w /I\""
                                }, false));
        txt = Tpl.writeStr(txt, i_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "/include/omc/cpp/\" /I\"$(BOOST_INCLUDE)\" /I\"$(SUITESPARSE_INCLUDE)\" /I. /TP /DNOMINMAX /DNO_INTERACTIVE_DEPENDENCY /DFMU_BUILD /DRUNTIME_STATIC_LINKING\n",
                                    "\n",
                                    "\n",
                                    "# /MD - link with MSVCRT.LIB\n",
                                    "# /link - [linker options and libraries]\n",
                                    "# /LIBPATH: - Directories where libs can be found\n",
                                    "OMCPP_SOLVER_LIBS=OMCppNewton_static.lib OMCppDgesv_static.lib OMCppDgesvSolver_static.lib -lOMCppSolver_static\n",
                                    "MODELICA_UTILITIES_LIB=OMCppModelicaUtilities_static.lib\n",
                                    "EXTRA_LIBS="
                                }, false));
        txt = Tpl.writeText(txt, l_dirExtra);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, l_libsExtra);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "LDFLAGS=/link /DLL /NOENTRY /LIBPATH:\""
                                }, false));
        txt = Tpl.writeStr(txt, i_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/lib/omc/cpp/msvc\" /LIBPATH:\""));
        txt = Tpl.writeStr(txt, i_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "/bin\" OMCppSystem_static.lib OMCppMath_static.lib OMCppExtensionUtilities_static.lib OMCppFMU_static.lib $(OMCPP_SOLVER_LIBS) $(EXTRA_LIBS) $(MODELICA_UTILITIES_LIB)\n",
                                    "\n",
                                    "PLATFORM=\""
                                }, false));
        txt = Tpl.writeStr(txt, i_makefileParams_platform);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\"\n",
                                    "\n",
                                    "MODELICA_SYSTEM_LIB="
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "CALCHELPERMAINFILE=OMCpp$(MODELICA_SYSTEM_LIB)CalcHelperMain.cpp\n",
                                    "\n"
                                }, true));
        txt = Tpl.writeStr(txt, i_fmuTargetName);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(".fmu: $(MODELICA_SYSTEM_LIB)$(DLLEXT)\n"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("rm -rf binaries\n"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("mkdir -p \"binaries/$(PLATFORM)\"\n"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("mv $(MODELICA_SYSTEM_LIB)$(DLLEXT) \"binaries/$(PLATFORM)/\"\n"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("rm -f $(MODELICA_SYSTEM_LIB).fmu\n"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("zip -r \""));
        txt = Tpl.writeStr(txt, i_fmuTargetName);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(".fmu\" modelDescription.xml binaries\n"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "rm -rf binaries\n",
                                    "\n",
                                    "$(MODELICA_SYSTEM_LIB)$(DLLEXT):\n"
                                }, true));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("$(CXX) /Fe$(MODELICA_SYSTEM_LIB)$(DLLEXT) $(CALCHELPERMAINFILE) $(CFLAGS) $(LDFLAGS)"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_141;

protected function fun_142
  input Tpl.Text in_txt;
  input String in_a_modelInfo_directory;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo_directory)
    local
      Tpl.Text txt;
      String i_modelInfo_directory;

    case ( txt,
           "" )
      then txt;

    case ( txt,
           i_modelInfo_directory )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-L\""));
        txt = Tpl.writeStr(txt, i_modelInfo_directory);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
      then txt;
  end match;
end fun_142;

protected function lm_143
  input Tpl.Text in_txt;
  input list<String> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<String> rest;
      String i_lib;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_lib :: rest )
      equation
        txt = Tpl.writeStr(txt, i_lib);
        txt = Tpl.nextIter(txt);
        txt = lm_143(txt, rest);
      then txt;
  end match;
end lm_143;

protected function fun_144
  input Tpl.Text in_txt;
  input Option<SimCode.SimulationSettings> in_a_sopt;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_sopt)
    local
      Tpl.Text txt;

    case ( txt,
           SOME(SimCode.SIMULATION_SETTINGS(startTime = _)) )
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_144;

protected function fun_145
  input Tpl.Text in_txt;
  input String in_a_makefileParams_platform;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_makefileParams_platform)
    local
      Tpl.Text txt;
      String i_makefileParams_platform;

    case ( txt,
           "i386-pc-linux" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("linux32"));
      then txt;

    case ( txt,
           "x86_64-linux" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("linux64"));
      then txt;

    case ( txt,
           i_makefileParams_platform )
      equation
        txt = Tpl.writeStr(txt, i_makefileParams_platform);
      then txt;
  end match;
end fun_145;

protected function fun_146
  input Tpl.Text in_txt;
  input String in_mArg;
  input Tpl.Text in_a_omhome;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_omhome)
    local
      Tpl.Text txt;
      Tpl.Text a_omhome;

    case ( txt,
           "win32",
           a_omhome )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        txt = Tpl.writeText(txt, a_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/bin/libgcc_s_*.dll\" \""));
        txt = Tpl.writeText(txt, a_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/bin/libstdc++-6.dll\" \""));
        txt = Tpl.writeText(txt, a_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/bin/libwinpthread-1.dll\""));
      then txt;

    case ( txt,
           "win64",
           a_omhome )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        txt = Tpl.writeText(txt, a_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/bin/libgcc_s_*.dll\" \""));
        txt = Tpl.writeText(txt, a_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/bin/libstdc++-6.dll\" \""));
        txt = Tpl.writeText(txt, a_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/bin/libwinpthread-1.dll\""));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_146;

protected function fun_147
  input Tpl.Text in_txt;
  input String in_mArg;
  input Tpl.Text in_a_omhome;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_omhome)
    local
      Tpl.Text txt;
      Tpl.Text a_omhome;

    case ( txt,
           "win32",
           a_omhome )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        txt = Tpl.writeText(txt, a_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/bin/libopenblas.dll\""));
      then txt;

    case ( txt,
           "win64",
           a_omhome )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        txt = Tpl.writeText(txt, a_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/bin/libopenblas.dll\""));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_147;

protected function fun_148
  input Tpl.Text in_txt;
  input String in_a_makefileParams_platform;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_makefileParams_platform)
    local
      Tpl.Text txt;

    case ( txt,
           "win32" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\"mkdir.exe\""));
      then txt;

    case ( txt,
           "win64" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\"mkdir.exe\""));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("mkdir"));
      then txt;
  end match;
end fun_148;

protected function fun_149
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_makefileParams_omhome;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_makefileParams_omhome)
    local
      Tpl.Text txt;
      String a_makefileParams_omhome;

    case ( txt,
           false,
           a_makefileParams_omhome )
      equation
        txt = Tpl.writeStr(txt, a_makefileParams_omhome);
      then txt;

    case ( txt,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("$(OPENMODELICAHOME)"));
      then txt;
  end match;
end fun_149;

protected function lm_150
  input Tpl.Text in_txt;
  input list<String> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<String> rest;
      String i_it;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_it :: rest )
      equation
        txt = Tpl.writeStr(txt, i_it);
        txt = Tpl.nextIter(txt);
        txt = lm_150(txt, rest);
      then txt;
  end match;
end lm_150;

protected function fun_151
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input String in_a_additionalLinkerFlags__GCC;
  input String in_a_additionalCFlags__GCC;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode, in_a_additionalLinkerFlags__GCC, in_a_additionalCFlags__GCC)
    local
      Tpl.Text txt;
      String a_additionalLinkerFlags__GCC;
      String a_additionalCFlags__GCC;
      String i_fmuTargetName;
      list<String> i_makefileParams_includes;
      String i_makefileParams_dllext;
      String i_makefileParams_cxxcompiler;
      String i_makefileParams_ccompiler;
      String i_fileNamePrefix;
      String i_makefileParams_omhome;
      String i_makefileParams_platform;
      Option<SimCode.SimulationSettings> i_sopt;
      list<String> i_makefileParams_libs;
      String i_modelInfo_directory;
      Boolean ret_12;
      Boolean ret_11;
      Boolean ret_10;
      Tpl.Text l_mkdir;
      String str_8;
      Tpl.Text l_lapackbins;
      String str_6;
      Tpl.Text l_platformbins;
      Tpl.Text l_omhome;
      Tpl.Text l_platformstr;
      Tpl.Text l_extraCflags;
      Tpl.Text l_libsExtra;
      Tpl.Text l_dirExtra;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(directory = i_modelInfo_directory), makefileParams = SimCodeFunction.MAKEFILE_PARAMS(libs = i_makefileParams_libs, platform = i_makefileParams_platform, omhome = i_makefileParams_omhome, ccompiler = i_makefileParams_ccompiler, cxxcompiler = i_makefileParams_cxxcompiler, dllext = i_makefileParams_dllext, includes = i_makefileParams_includes), simulationSettingsOpt = i_sopt, fileNamePrefix = i_fileNamePrefix, fmuTargetName = i_fmuTargetName),
           a_additionalLinkerFlags__GCC,
           a_additionalCFlags__GCC )
      equation
        l_dirExtra = fun_142(Tpl.emptyTxt, i_modelInfo_directory);
        l_libsExtra = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(" ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_libsExtra = lm_143(l_libsExtra, i_makefileParams_libs);
        l_libsExtra = Tpl.popIter(l_libsExtra);
        l_extraCflags = fun_144(Tpl.emptyTxt, i_sopt);
        l_platformstr = fun_145(Tpl.emptyTxt, i_makefileParams_platform);
        l_omhome = Tpl.writeStr(Tpl.emptyTxt, i_makefileParams_omhome);
        str_6 = Tpl.textString(l_platformstr);
        l_platformbins = fun_146(Tpl.emptyTxt, str_6, l_omhome);
        str_8 = Tpl.textString(l_platformstr);
        l_lapackbins = fun_147(Tpl.emptyTxt, str_8, l_omhome);
        l_mkdir = fun_148(Tpl.emptyTxt, i_makefileParams_platform);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "# Makefile generated by OpenModelica for native and cross compilation\n",
                                    "# How to cross compile:\n",
                                    "#  - build OpenModelica (omc) from source code (see github.com/OpenModelica)\n",
                                    "#  - install a cross compiler, e.g. apt-get install g++-mingw-w64-i686\n",
                                    "#  - fix or work around capitalization of windows.h in MSL, see\n",
                                    "#      https://trac.modelica.org/Modelica/ticket/1962\n",
                                    "#  - add the target triplet, e.g. i686-w64-mingw32, to\n",
                                    "#      OMCompiler/SimulationRuntime/cpp/Makefile\n",
                                    "#  - rebuild omc to add the new platform\n",
                                    "#  - invoke the omc commands\n",
                                    "#      setCommandLineOptions(\"--simCodeTarget=Cpp\");\n",
                                    "#      buildModelFMU(MyModel, platforms={\"i686-w64-mingw32\"});\n",
                                    "#  - alternatively call this Makefile with\n",
                                    "#      make TARGET_TRIPLET=i686-w64-mingw32 -f "
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_FMU.makefile\n",
                                    "\n",
                                    "#TARGET_TRIPLET=\n",
                                    "OMHOME="
                                }, false));
        ret_10 = stringEq(i_makefileParams_platform, "win32");
        ret_11 = stringEq(i_makefileParams_platform, "win64");
        ret_12 = boolOr(ret_10, ret_11);
        txt = fun_149(txt, ret_12, i_makefileParams_omhome);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "include $(OMHOME)/include/omc/cpp/ModelicaConfig_gcc.inc\n",
                                    "include $(OMHOME)/include/omc/cpp/ModelicaLibraryConfig_gcc.inc\n",
                                    "\n",
                                    "# simulations use -O0 by default; can be changed to e.g. -O2 or -Ofast\n",
                                    "SIM_OPT_LEVEL=-O0\n",
                                    "\n",
                                    "# native build or cross compilation\n",
                                    "ifeq ($(TARGET_TRIPLET),)\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("TRIPLET="));
        txt = Tpl.writeStr(txt, Autoconf.triple);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("CC="));
        txt = Tpl.writeStr(txt, i_makefileParams_ccompiler);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("CXX="));
        txt = Tpl.writeStr(txt, i_makefileParams_cxxcompiler);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "ABI_CFLAG=\n",
                                    "DLLEXT="
                                }, false));
        txt = Tpl.writeStr(txt, i_makefileParams_dllext);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("PLATFORM="));
        txt = Tpl.writeText(txt, l_platformstr);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "else\n",
                                    "  TRIPLET=$(TARGET_TRIPLET)\n",
                                    "  CC=$(TRIPLET)-gcc\n",
                                    "  CXX=$(TRIPLET)-g++\n",
                                    "  ABI_CFLAG=-D_GLIBCXX_USE_CXX11_ABI=0\n",
                                    "  DLLEXT=$(if $(findstring mingw,$(TRIPLET)),.dll,.so)\n",
                                    "  WORDSIZE=$(if $(findstring x86_64,$(TRIPLET)),64,32)\n",
                                    "  PLATFORM=$(if $(findstring darwin,$(TRIPLET)),darwin,$(if $(findstring mingw,$(TRIPLET)),win,linux))$(WORDSIZE)\n",
                                    "endif\n",
                                    "\n",
                                    "CFLAGS_BASED_ON_INIT_FILE="
                                }, false));
        txt = Tpl.writeText(txt, l_extraCflags);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "FMU_CFLAGS=$(subst -DUSE_THREAD,,$(subst -O0,$(SIM_OPT_LEVEL),$(SYSTEM_CFLAGS))) $(ABI_CFLAG)\n",
                                    "CFLAGS=$(CFLAGS_BASED_ON_INIT_FILE) -Winvalid-pch $(FMU_CFLAGS) -DFMU_BUILD -DRUNTIME_STATIC_LINKING -I\"$(OMHOME)/include/omc/cpp\" -I\"$(UMFPACK_INCLUDE)\" -I\"$(SUNDIALS_INCLUDE)\" -I\"$(BOOST_INCLUDE)\" "
                                }, false));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(" ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_150(txt, i_makefileParams_includes);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeStr(txt, a_additionalCFlags__GCC);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "ifeq ($(USE_LOGGER),ON)\n",
                                    "  $(eval CFLAGS=$(CFLAGS) -DUSE_LOGGER)\n",
                                    "endif\n",
                                    "\n",
                                    "LDFLAGS=-L\"$(OMHOME)/lib/$(TRIPLET)/omc/cpp\" "
                                }, false));
        txt = Tpl.writeStr(txt, a_additionalLinkerFlags__GCC);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " -Wl,--no-undefined\n",
                                    "\n",
                                    "CALCHELPERMAINFILE=OMCpp"
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "CalcHelperMain.cpp\n",
                                    "\n",
                                    "# CVode can be used for Co-Simulation FMUs, Kinsol is available to handle non linear equation systems\n",
                                    "OMCPP_SOLVER_LIBS=-lOMCppNewton_static -lOMCppDgesvSolver_static -lOMCppSolver_static\n",
                                    "ifeq ($(USE_FMU_SUNDIALS),ON)\n",
                                    "$(eval OMCPP_SOLVER_LIBS=$(OMCPP_SOLVER_LIBS) -lOMCppKinsol_static $(SUNDIALS_LIBRARIES))\n",
                                    "$(eval CFLAGS=-DENABLE_SUNDIALS_STATIC $(CFLAGS))\n",
                                    "endif\n",
                                    "\n",
                                    "CPPFLAGS=$(CFLAGS)\n",
                                    "\n",
                                    "BINARIES="
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "$(DLLEXT)\n",
                                    "\n",
                                    "OMCPP_LIBS=-lOMCppSystem_static -lOMCppMath_static -lOMCppFMU_static $(OMCPP_SOLVER_LIBS) -lOMCppExtensionUtilities_static\n",
                                    "MODELICA_UTILITIES_LIB=-lOMCppModelicaUtilities_static\n",
                                    "EXTRA_LIBS="
                                }, false));
        txt = Tpl.writeText(txt, l_dirExtra);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, l_libsExtra);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "LIBS=$(EXTRA_LIBS) $(OMCPP_LIBS) $(MODELICA_UTILITIES_LIB) $(BASE_LIB)\n",
                                    "\n",
                                    "# link with simple dgesv or full lapack\n",
                                    "ifeq ($(USE_DGESV),ON)\n",
                                    "  $(eval LIBS=$(LIBS) -lOMCppDgesv_static)\n",
                                    "else\n",
                                    "  $(eval LIBS=$(LIBS) -L$(LAPACK_LIBS) $(LAPACK_LIBRARIES))\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("$(eval BINARIES=$(BINARIES) "));
        txt = Tpl.writeText(txt, l_lapackbins);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(")\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "endif\n",
                                    "\n",
                                    "# need boost system lib prior to C++11, forcing also dynamic libs\n",
                                    "ifeq ($(findstring USE_CPP_03,$(CFLAGS)),USE_CPP_03)\n",
                                    "  $(eval LIBS=$(LIBS) -L\"$(BOOST_LIBS)\" -l$(BOOST_SYSTEM_LIB))\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("$(eval BINARIES=$(BINARIES) $(BOOST_LIBS)/lib$(BOOST_SYSTEM_LIB)$(DLLEXT) "));
        txt = Tpl.writeText(txt, l_platformbins);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(")\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "# link static libs to avoid dependencies; can\'t link all static under Linux\n",
                                    "else ifeq ($(findstring gcc,$(CC)),gcc)\n",
                                    "  $(eval LIBS=$(LIBS) $(if $(findstring linux,$(PLATFORM)),-static-libstdc++ -static-libgcc,-static))\n",
                                    "endif\n",
                                    "\n",
                                    "CPPFILES=$(CALCHELPERMAINFILE)\n",
                                    "OFILES=$(CPPFILES:.cpp=.o)\n",
                                    "\n",
                                    ".PHONY: "
                                }, false));
        txt = Tpl.writeStr(txt, i_fmuTargetName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ".fmu $(CPPFILES) clean\n",
                                    "\n"
                                }, true));
        txt = Tpl.writeStr(txt, i_fmuTargetName);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(".fmu: $(OFILES)\n"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("$(CXX) -shared -o "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("$(DLLEXT) $(OFILES) $(LDFLAGS) $(LIBS)\n"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeText(txt, l_mkdir);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" -p \"binaries/$(PLATFORM)\"\n"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("mv $(BINARIES) \"binaries/$(PLATFORM)/\"\n"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("rm -rf sources\n"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeText(txt, l_mkdir);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" -p sources\n"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("install -p OMCpp"));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("*.h OMCpp"));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("*.cpp "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_init.xml "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_FMU.makefile sources/\n",
                                    "ifeq ($(USE_FMU_SUNDIALS),ON)\n"
                                }, true));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("rm -rf documentation\n"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeText(txt, l_mkdir);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" -p \"documentation\"\n"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("cp $(SUNDIALS_LIBRARIES_KINSOL) \"binaries/$(PLATFORM)/\"\n"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "cp \"$(OMHOME)/share/omc/runtime/cpp/licenses/sundials.license\" \"documentation/\"\n",
                                    "endif\n"
                                }, true));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("rm -f "));
        txt = Tpl.writeStr(txt, i_fmuTargetName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ".fmu\n",
                                    "ifeq ($(USE_FMU_SUNDIALS),ON)\n"
                                }, true));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("zip -r \""));
        txt = Tpl.writeStr(txt, i_fmuTargetName);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(".fmu\" modelDescription.xml binaries sources documentation\n"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "rm -rf documentation\n",
                                    "else\n"
                                }, true));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("zip -r \""));
        txt = Tpl.writeStr(txt, i_fmuTargetName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ".fmu\" modelDescription.xml binaries sources\n",
                                    "endif\n",
                                    "\n",
                                    "clean:\n"
                                }, true));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("rm -f OMCpp"));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("* "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_FMU.* "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".def "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".sh "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".bat "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".makefile "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_init.xml\n"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "rm -rf modelDescription.xml binaries sources documentation\n",
                                    "\n"
                                }, true));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_151;

protected function fun_152
  input Tpl.Text in_txt;
  input String in_mArg;
  input SimCode.SimCode in_a_simCode;
  input String in_a_additionalLinkerFlags__GCC;
  input String in_a_additionalCFlags__GCC;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_simCode, in_a_additionalLinkerFlags__GCC, in_a_additionalCFlags__GCC)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      String a_additionalLinkerFlags__GCC;
      String a_additionalCFlags__GCC;

    case ( txt,
           "msvc",
           a_simCode,
           _,
           _ )
      equation
        txt = fun_141(txt, a_simCode);
      then txt;

    case ( txt,
           "gcc",
           a_simCode,
           a_additionalLinkerFlags__GCC,
           a_additionalCFlags__GCC )
      equation
        txt = fun_151(txt, a_simCode, a_additionalLinkerFlags__GCC, a_additionalCFlags__GCC);
      then txt;

    case ( txt,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_152;

public function fmuMakefile
  input Tpl.Text txt;
  input String a_target;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input String a_FMUVersion;
  input String a_additionalLinkerFlags__GCC;
  input String a_additionalLinkerFlags__MSVC;
  input String a_additionalCFlags__GCC;
  input String a_additionalCFlags__MSVC;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
protected
  String str_1;
  Tpl.Text txt_0;
algorithm
  txt_0 := CodegenUtil.getGeneralTarget(Tpl.emptyTxt, a_target);
  str_1 := Tpl.textString(txt_0);
  out_txt := fun_152(txt, str_1, a_simCode, a_additionalLinkerFlags__GCC, a_additionalCFlags__GCC);
  out_a_extraFuncs := a_extraFuncs;
  out_a_extraFuncsDecl := a_extraFuncsDecl;
  out_a_extraFuncsNamespace := a_extraFuncsNamespace;
end fmuMakefile;

annotation(__OpenModelica_Interface="backend");
end CodegenFMUCppOld;