encapsulated package CodegenMidToC
"
  file:        CodegenMidToC.mo
  package:     CodegenMidToC
  description: Generated by Susan.
"

public import Tpl;

public import MidCode;
public import System;
public import Absyn;
public import DAE;
public import ClassInf;
public import Util;
public import List;

protected function lm_39
  input Tpl.Text in_txt;
  input list<MidCode.Function> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<MidCode.Function> rest;
      MidCode.Function i_fn;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_fn :: rest )
      equation
        txt = genFunction(txt, i_fn);
        txt = Tpl.nextIter(txt);
        txt = lm_39(txt, rest);
      then txt;
  end match;
end lm_39;

public function genProgram
  input Tpl.Text in_txt;
  input MidCode.Program in_a_p;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_p)
    local
      Tpl.Text txt;
      String i_name;
      list<MidCode.Function> i_functions;
      Integer ret_0;

    case ( txt,
           MidCode.PROGRAM(functions = i_functions, name = i_name) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("// number of functions: "));
        ret_0 = listLength(i_functions);
        txt = Tpl.writeStr(txt, intString(ret_0));
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#include \""));
        txt = Tpl.writeStr(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ".h\"\n",
                                    "#include \"util/modelica.h\"\n",
                                    "\n",
                                    "#include \""
                                }, false));
        txt = Tpl.writeStr(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_includes.h\"\n",
                                    "\n"
                                }, true));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING_LIST({
                                                                     "\n",
                                                                     "\n"
                                                                 }, true)), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_39(txt, i_functions);
        txt = Tpl.popIter(txt);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end genProgram;

protected function fun_41
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input list<MidCode.Var> in_a_outputs;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_outputs)
    local
      Tpl.Text txt;
      list<MidCode.Var> a_outputs;
      MidCode.Var ret_0;

    case ( txt,
           false,
           a_outputs )
      equation
        ret_0 = listHead(a_outputs);
        txt = genVarType(txt, ret_0);
      then txt;

    case ( txt,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void"));
      then txt;
  end match;
end fun_41;

protected function lm_42
  input Tpl.Text in_txt;
  input list<MidCode.Var> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<MidCode.Var> rest;
      MidCode.Var i_i;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_i :: rest )
      equation
        txt = genVarType(txt, i_i);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = genVarName(txt, i_i);
        txt = Tpl.nextIter(txt);
        txt = lm_42(txt, rest);
      then txt;
  end match;
end lm_42;

protected function lm_43
  input Tpl.Text in_txt;
  input list<MidCode.Var> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<MidCode.Var> rest;
      MidCode.Var i_o;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_o :: rest )
      equation
        txt = genVarType(txt, i_o);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" *outPtr_"));
        txt = genVarName(txt, i_o);
        txt = Tpl.nextIter(txt);
        txt = lm_43(txt, rest);
      then txt;
  end match;
end lm_43;

protected function smf_44
  input Tpl.Text in_txt;
  input Tpl.StringToken in_it;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_it)
    local
      Tpl.Text txt;
      Tpl.StringToken i_it;

    case ( txt,
           i_it )
      equation
        txt = Tpl.writeTok(txt, i_it);
        txt = Tpl.nextIter(txt);
      then txt;
  end match;
end smf_44;

protected function smf_45
  input Tpl.Text in_txt;
  input Tpl.Text in_it;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_it)
    local
      Tpl.Text txt;
      Tpl.Text i_it;

    case ( txt,
           i_it )
      equation
        txt = Tpl.writeText(txt, i_it);
        txt = Tpl.nextIter(txt);
      then txt;
  end match;
end smf_45;

protected function smf_46
  input Tpl.Text in_txt;
  input Tpl.Text in_it;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_it)
    local
      Tpl.Text txt;
      Tpl.Text i_it;

    case ( txt,
           i_it )
      equation
        txt = Tpl.writeText(txt, i_it);
        txt = Tpl.nextIter(txt);
      then txt;
  end match;
end smf_46;

public function genFunction
  input Tpl.Text in_txt;
  input MidCode.Function in_a_fn;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fn)
    local
      Tpl.Text txt;
      list<MidCode.Block> i_body;
      list<MidCode.VarBufPtr> i_localBufPtrs;
      list<MidCode.VarBuf> i_localBufs;
      list<MidCode.Var> i_locals;
      MidCode.Function i_fn;
      Absyn.Path i_name;
      list<MidCode.Var> i_inputs;
      list<MidCode.Var> i_outputs;
      Tpl.Text txt_4;
      list<MidCode.Var> ret_4;
      Tpl.Text txt_3;
      Tpl.Text l_arguments;
      Boolean ret_1;
      Tpl.Text l_returnType;

    case ( txt,
           (i_fn as MidCode.FUNCTION(outputs = i_outputs, inputs = i_inputs, name = i_name, locals = i_locals, localBufs = i_localBufs, localBufPtrs = i_localBufPtrs, body = i_body)) )
      equation
        ret_1 = listEmpty(i_outputs);
        l_returnType = fun_41(Tpl.emptyTxt, ret_1, i_outputs);
        txt_3 = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt_3 = lm_42(txt_3, i_inputs);
        txt_3 = Tpl.popIter(txt_3);
        ret_4 = List.restOrEmpty(i_outputs);
        txt_4 = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt_4 = lm_43(txt_4, ret_4);
        txt_4 = Tpl.popIter(txt_4);
        l_arguments = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING_LIST({
                                                                                      ",\n",
                                                                                      "    "
                                                                                  }, false)), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_arguments = smf_44(l_arguments, Tpl.ST_STRING("threadData_t *threadData"));
        l_arguments = smf_45(l_arguments, txt_3);
        l_arguments = smf_46(l_arguments, txt_4);
        l_arguments = Tpl.popIter(l_arguments);
        txt = Tpl.writeText(txt, l_returnType);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" omc_"));
        txt = underscorePath(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, l_arguments);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ")\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(3));
        txt = genLocalDecls(txt, i_fn, i_locals, i_localBufs, i_localBufPtrs);
        txt = Tpl.softNewLine(txt);
        txt = genEntry(txt, i_fn);
        txt = Tpl.softNewLine(txt);
        txt = genBlocks(txt, i_fn, i_body);
        txt = Tpl.softNewLine(txt);
        txt = genExit(txt, i_fn);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n"
                                }, true));
        txt = genInFunction(txt, i_fn);
        txt = Tpl.softNewLine(txt);
        txt = genBoxPtrFunction(txt, i_fn);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end genFunction;

protected function lm_48
  input Tpl.Text in_txt;
  input list<MidCode.Var> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<MidCode.Var> rest;
      MidCode.Var i_i;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_i :: rest )
      equation
        txt = genVarType(txt, i_i);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = genVarName(txt, i_i);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        txt = lm_48(txt, rest);
      then txt;
  end match;
end lm_48;

protected function lm_49
  input Tpl.Text in_txt;
  input list<MidCode.Var> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<MidCode.Var> rest;
      MidCode.Var i_o;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_o :: rest )
      equation
        txt = genVarType(txt, i_o);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = genVarName(txt, i_o);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        txt = lm_49(txt, rest);
      then txt;
  end match;
end lm_49;

protected function lm_50
  input Tpl.Text in_txt;
  input list<MidCode.Var> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<MidCode.Var> rest;
      MidCode.Var i_i;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_i :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if("));
        txt = varModelicaRead(txt, i_i);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") return 1;"));
        txt = Tpl.nextIter(txt);
        txt = lm_50(txt, rest);
      then txt;
  end match;
end lm_50;

protected function lm_51
  input Tpl.Text in_txt;
  input list<MidCode.Var> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<MidCode.Var> rest;
      MidCode.Var i_o;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_o :: rest )
      equation
        txt = varModelicaWrite(txt, i_o);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        txt = lm_51(txt, rest);
      then txt;
  end match;
end lm_51;

protected function fun_52
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input list<MidCode.Var> in_a_outputs;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_outputs)
    local
      Tpl.Text txt;
      list<MidCode.Var> a_outputs;
      MidCode.Var ret_0;

    case ( txt,
           false,
           a_outputs )
      equation
        ret_0 = listHead(a_outputs);
        txt = genVarName(txt, ret_0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_52;

protected function lm_53
  input Tpl.Text in_txt;
  input list<MidCode.Var> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<MidCode.Var> rest;
      MidCode.Var i_i;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_i :: rest )
      equation
        txt = genVarName(txt, i_i);
        txt = Tpl.nextIter(txt);
        txt = lm_53(txt, rest);
      then txt;
  end match;
end lm_53;

protected function lm_54
  input Tpl.Text in_txt;
  input list<MidCode.Var> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<MidCode.Var> rest;
      MidCode.Var i_o;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_o :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("&"));
        txt = genVarName(txt, i_o);
        txt = Tpl.nextIter(txt);
        txt = lm_54(txt, rest);
      then txt;
  end match;
end lm_54;

protected function smf_55
  input Tpl.Text in_txt;
  input Tpl.StringToken in_it;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_it)
    local
      Tpl.Text txt;
      Tpl.StringToken i_it;

    case ( txt,
           i_it )
      equation
        txt = Tpl.writeTok(txt, i_it);
        txt = Tpl.nextIter(txt);
      then txt;
  end match;
end smf_55;

protected function smf_56
  input Tpl.Text in_txt;
  input Tpl.Text in_it;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_it)
    local
      Tpl.Text txt;
      Tpl.Text i_it;

    case ( txt,
           i_it )
      equation
        txt = Tpl.writeText(txt, i_it);
        txt = Tpl.nextIter(txt);
      then txt;
  end match;
end smf_56;

protected function smf_57
  input Tpl.Text in_txt;
  input Tpl.Text in_it;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_it)
    local
      Tpl.Text txt;
      Tpl.Text i_it;

    case ( txt,
           i_it )
      equation
        txt = Tpl.writeText(txt, i_it);
        txt = Tpl.nextIter(txt);
      then txt;
  end match;
end smf_57;

protected function fun_58
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("write_noretcall(outVar);"));
      then txt;
  end match;
end fun_58;

public function genInFunction
  input Tpl.Text in_txt;
  input MidCode.Function in_a_fn;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fn)
    local
      Tpl.Text txt;
      Absyn.Path i_name;
      list<MidCode.Var> i_outputs;
      list<MidCode.Var> i_inputs;
      Boolean ret_10;
      Tpl.Text txt_8;
      list<MidCode.Var> ret_8;
      Tpl.Text txt_7;
      Tpl.Text l_callargs;
      Boolean ret_5;
      Tpl.Text l_callretval;
      Tpl.Text l_outputLines;
      Tpl.Text l_inputLines;
      Tpl.Text l_outputDefs;
      Tpl.Text l_inputDefs;

    case ( txt,
           MidCode.FUNCTION(inputs = i_inputs, outputs = i_outputs, name = i_name) )
      equation
        l_inputDefs = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_inputDefs = lm_48(l_inputDefs, i_inputs);
        l_inputDefs = Tpl.popIter(l_inputDefs);
        l_outputDefs = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_outputDefs = lm_49(l_outputDefs, i_outputs);
        l_outputDefs = Tpl.popIter(l_outputDefs);
        l_inputLines = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_inputLines = lm_50(l_inputLines, i_inputs);
        l_inputLines = Tpl.popIter(l_inputLines);
        l_outputLines = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_outputLines = lm_51(l_outputLines, i_outputs);
        l_outputLines = Tpl.popIter(l_outputLines);
        ret_5 = listEmpty(i_outputs);
        l_callretval = fun_52(Tpl.emptyTxt, ret_5, i_outputs);
        txt_7 = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt_7 = lm_53(txt_7, i_inputs);
        txt_7 = Tpl.popIter(txt_7);
        ret_8 = List.restOrEmpty(i_outputs);
        txt_8 = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt_8 = lm_54(txt_8, ret_8);
        txt_8 = Tpl.popIter(txt_8);
        l_callargs = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING_LIST({
                                                                                     ",\n",
                                                                                     "    "
                                                                                 }, false)), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_callargs = smf_55(l_callargs, Tpl.ST_STRING("threadData"));
        l_callargs = smf_56(l_callargs, txt_7);
        l_callargs = smf_57(l_callargs, txt_8);
        l_callargs = Tpl.popIter(l_callargs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("int in_"));
        txt = underscorePath(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(threadData_t *threadData, type_description *inArgs, type_description *outVar)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_inputDefs);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_outputDefs);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_inputLines);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("MMC_TRY_TOP_INTERNAL()\n"));
        txt = Tpl.writeText(txt, l_callretval);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("omc_"));
        txt = underscorePath(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, l_callargs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ");\n",
                                    "MMC_CATCH_TOP(return 1)\n"
                                }, true));
        txt = Tpl.writeText(txt, l_outputLines);
        txt = Tpl.softNewLine(txt);
        ret_10 = listEmpty(i_outputs);
        txt = fun_58(txt, ret_10);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "fflush(NULL);\n",
                                    "return 0;\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end genInFunction;

protected function fun_60
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_metatype"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void"));
      then txt;
  end match;
end fun_60;

protected function lm_61
  input Tpl.Text in_txt;
  input list<MidCode.Var> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<MidCode.Var> rest;
      MidCode.Var i_i;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_i :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_metatype "));
        txt = genVarName(txt, i_i);
        txt = Tpl.nextIter(txt);
        txt = lm_61(txt, rest);
      then txt;
  end match;
end lm_61;

protected function lm_62
  input Tpl.Text in_txt;
  input list<MidCode.Var> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<MidCode.Var> rest;
      MidCode.Var i_o;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_o :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_metatype *out_"));
        txt = genVarName(txt, i_o);
        txt = Tpl.nextIter(txt);
        txt = lm_62(txt, rest);
      then txt;
  end match;
end lm_62;

protected function smf_63
  input Tpl.Text in_txt;
  input Tpl.StringToken in_it;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_it)
    local
      Tpl.Text txt;
      Tpl.StringToken i_it;

    case ( txt,
           i_it )
      equation
        txt = Tpl.writeTok(txt, i_it);
        txt = Tpl.nextIter(txt);
      then txt;
  end match;
end smf_63;

protected function smf_64
  input Tpl.Text in_txt;
  input Tpl.Text in_it;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_it)
    local
      Tpl.Text txt;
      Tpl.Text i_it;

    case ( txt,
           i_it )
      equation
        txt = Tpl.writeText(txt, i_it);
        txt = Tpl.nextIter(txt);
      then txt;
  end match;
end smf_64;

protected function smf_65
  input Tpl.Text in_txt;
  input Tpl.Text in_it;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_it)
    local
      Tpl.Text txt;
      Tpl.Text i_it;

    case ( txt,
           i_it )
      equation
        txt = Tpl.writeText(txt, i_it);
        txt = Tpl.nextIter(txt);
      then txt;
  end match;
end smf_65;

protected function fun_66
  input Tpl.Text in_txt;
  input Tpl.Text in_mArg;
  input MidCode.Var in_a_i;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_i)
    local
      Tpl.Text txt;
      MidCode.Var a_i;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           _ )
      then txt;

    case ( txt,
           _,
           a_i )
      equation
        txt = genVarType(txt, a_i);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" unbox_"));
        txt = genVarName(txt, a_i);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_66;

protected function lm_67
  input Tpl.Text in_txt;
  input list<MidCode.Var> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<MidCode.Var> rest;
      MidCode.Var i_i;
      Tpl.Text txt_0;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_i :: rest )
      equation
        txt_0 = varBoxType(Tpl.emptyTxt, i_i);
        txt = fun_66(txt, txt_0, i_i);
        txt = Tpl.nextIter(txt);
        txt = lm_67(txt, rest);
      then txt;
  end match;
end lm_67;

protected function fun_68
  input Tpl.Text in_txt;
  input Tpl.Text in_mArg;
  input MidCode.Var in_a_o;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_o)
    local
      Tpl.Text txt;
      MidCode.Var a_o;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           _ )
      then txt;

    case ( txt,
           _,
           a_o )
      equation
        txt = genVarType(txt, a_o);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = genVarName(txt, a_o);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_68;

protected function lm_69
  input Tpl.Text in_txt;
  input list<MidCode.Var> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<MidCode.Var> rest;
      MidCode.Var i_o;
      Tpl.Text txt_0;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_o :: rest )
      equation
        txt_0 = varBoxType(Tpl.emptyTxt, i_o);
        txt = fun_68(txt, txt_0, i_o);
        txt = Tpl.nextIter(txt);
        txt = lm_69(txt, rest);
      then txt;
  end match;
end lm_69;

protected function fun_70
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input list<MidCode.Var> in_a_outputs;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_outputs)
    local
      Tpl.Text txt;
      list<MidCode.Var> a_outputs;
      MidCode.Var ret_0;

    case ( txt,
           false,
           a_outputs )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_metatype out_"));
        ret_0 = listHead(a_outputs);
        txt = genVarName(txt, ret_0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_70;

protected function fun_71
  input Tpl.Text in_txt;
  input Tpl.Text in_mArg;
  input MidCode.Var in_a_i;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_i)
    local
      Tpl.Text txt;
      MidCode.Var a_i;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           _ )
      then txt;

    case ( txt,
           _,
           a_i )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("unbox_"));
        txt = genVarName(txt, a_i);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = varUnbox2(txt, a_i);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_71;

protected function lm_72
  input Tpl.Text in_txt;
  input list<MidCode.Var> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<MidCode.Var> rest;
      MidCode.Var i_i;
      Tpl.Text txt_0;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_i :: rest )
      equation
        txt_0 = varBoxType(Tpl.emptyTxt, i_i);
        txt = fun_71(txt, txt_0, i_i);
        txt = Tpl.nextIter(txt);
        txt = lm_72(txt, rest);
      then txt;
  end match;
end lm_72;

protected function fun_73
  input Tpl.Text in_txt;
  input Tpl.Text in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("out_"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_73;

protected function fun_74
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input list<MidCode.Var> in_a_outputs;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_outputs)
    local
      Tpl.Text txt;
      list<MidCode.Var> a_outputs;
      MidCode.Var ret_2;
      Tpl.Text txt_1;
      MidCode.Var ret_0;

    case ( txt,
           false,
           a_outputs )
      equation
        ret_0 = listHead(a_outputs);
        txt_1 = varBoxType(Tpl.emptyTxt, ret_0);
        txt = fun_73(txt, txt_1);
        ret_2 = listHead(a_outputs);
        txt = genVarName(txt, ret_2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_74;

protected function fun_75
  input Tpl.Text in_txt;
  input Tpl.Text in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}) )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("unbox_"));
      then txt;
  end match;
end fun_75;

protected function lm_76
  input Tpl.Text in_txt;
  input list<MidCode.Var> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<MidCode.Var> rest;
      MidCode.Var i_i;
      Tpl.Text txt_0;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_i :: rest )
      equation
        txt_0 = varBoxType(Tpl.emptyTxt, i_i);
        txt = fun_75(txt, txt_0);
        txt = genVarName(txt, i_i);
        txt = Tpl.nextIter(txt);
        txt = lm_76(txt, rest);
      then txt;
  end match;
end lm_76;

protected function fun_77
  input Tpl.Text in_txt;
  input Tpl.Text in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("out_"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("&"));
      then txt;
  end match;
end fun_77;

protected function lm_78
  input Tpl.Text in_txt;
  input list<MidCode.Var> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<MidCode.Var> rest;
      MidCode.Var i_o;
      Tpl.Text txt_0;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_o :: rest )
      equation
        txt_0 = varBoxType(Tpl.emptyTxt, i_o);
        txt = fun_77(txt, txt_0);
        txt = genVarName(txt, i_o);
        txt = Tpl.nextIter(txt);
        txt = lm_78(txt, rest);
      then txt;
  end match;
end lm_78;

protected function smf_79
  input Tpl.Text in_txt;
  input Tpl.StringToken in_it;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_it)
    local
      Tpl.Text txt;
      Tpl.StringToken i_it;

    case ( txt,
           i_it )
      equation
        txt = Tpl.writeTok(txt, i_it);
        txt = Tpl.nextIter(txt);
      then txt;
  end match;
end smf_79;

protected function smf_80
  input Tpl.Text in_txt;
  input Tpl.Text in_it;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_it)
    local
      Tpl.Text txt;
      Tpl.Text i_it;

    case ( txt,
           i_it )
      equation
        txt = Tpl.writeText(txt, i_it);
        txt = Tpl.nextIter(txt);
      then txt;
  end match;
end smf_80;

protected function smf_81
  input Tpl.Text in_txt;
  input Tpl.Text in_it;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_it)
    local
      Tpl.Text txt;
      Tpl.Text i_it;

    case ( txt,
           i_it )
      equation
        txt = Tpl.writeText(txt, i_it);
        txt = Tpl.nextIter(txt);
      then txt;
  end match;
end smf_81;

protected function fun_82
  input Tpl.Text in_txt;
  input Tpl.Text in_mArg;
  input list<MidCode.Var> in_a_outputs;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_outputs)
    local
      Tpl.Text txt;
      list<MidCode.Var> a_outputs;
      MidCode.Var ret_1;
      MidCode.Var ret_0;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           _ )
      then txt;

    case ( txt,
           _,
           a_outputs )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("out_"));
        ret_0 = listHead(a_outputs);
        txt = genVarName(txt, ret_0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        ret_1 = listHead(a_outputs);
        txt = varBox(txt, ret_1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_82;

protected function fun_83
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input list<MidCode.Var> in_a_outputs;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_outputs)
    local
      Tpl.Text txt;
      list<MidCode.Var> a_outputs;
      Tpl.Text txt_1;
      MidCode.Var ret_0;

    case ( txt,
           false,
           a_outputs )
      equation
        ret_0 = listHead(a_outputs);
        txt_1 = varBoxType(Tpl.emptyTxt, ret_0);
        txt = fun_82(txt, txt_1, a_outputs);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_83;

protected function fun_84
  input Tpl.Text in_txt;
  input Tpl.Text in_mArg;
  input MidCode.Var in_a_o;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_o)
    local
      Tpl.Text txt;
      MidCode.Var a_o;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           _ )
      then txt;

    case ( txt,
           _,
           a_o )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if(out_"));
        txt = genVarName(txt, a_o);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") *out_"));
        txt = genVarName(txt, a_o);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = varBox(txt, a_o);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_84;

protected function lm_85
  input Tpl.Text in_txt;
  input list<MidCode.Var> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<MidCode.Var> rest;
      MidCode.Var i_o;
      Tpl.Text txt_0;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_o :: rest )
      equation
        txt_0 = varBoxType(Tpl.emptyTxt, i_o);
        txt = fun_84(txt, txt_0, i_o);
        txt = lm_85(txt, rest);
      then txt;
  end match;
end lm_85;

protected function smf_86
  input Tpl.Text in_txt;
  input Tpl.Text in_it;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_it)
    local
      Tpl.Text txt;
      Tpl.Text i_it;

    case ( txt,
           i_it )
      equation
        txt = Tpl.writeText(txt, i_it);
        txt = Tpl.nextIter(txt);
      then txt;
  end match;
end smf_86;

protected function smf_87
  input Tpl.Text in_txt;
  input Tpl.Text in_it;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_it)
    local
      Tpl.Text txt;
      Tpl.Text i_it;

    case ( txt,
           i_it )
      equation
        txt = Tpl.writeText(txt, i_it);
        txt = Tpl.nextIter(txt);
      then txt;
  end match;
end smf_87;

protected function fun_88
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input list<MidCode.Var> in_a_outputs;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_outputs)
    local
      Tpl.Text txt;
      list<MidCode.Var> a_outputs;
      MidCode.Var ret_0;

    case ( txt,
           false,
           a_outputs )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("return out_"));
        ret_0 = listHead(a_outputs);
        txt = genVarName(txt, ret_0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("return;"));
      then txt;
  end match;
end fun_88;

public function genBoxPtrFunction
  input Tpl.Text in_txt;
  input MidCode.Function in_a_fn;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fn)
    local
      Tpl.Text txt;
      Absyn.Path i_name;
      list<MidCode.Var> i_inputs;
      list<MidCode.Var> i_outputs;
      Boolean ret_22;
      Tpl.Text txt_20;
      list<MidCode.Var> ret_20;
      Tpl.Text txt_18;
      Boolean ret_18;
      Tpl.Text l_boxes;
      Tpl.Text txt_15;
      list<MidCode.Var> ret_15;
      Tpl.Text txt_14;
      Tpl.Text l_callvars;
      Boolean ret_12;
      Tpl.Text l_callretval;
      Tpl.Text l_unboxes;
      Boolean ret_9;
      Tpl.Text l_boxDefs;
      Tpl.Text l_callOutDefs;
      Tpl.Text l_unboxDefs;
      Tpl.Text txt_4;
      list<MidCode.Var> ret_4;
      Tpl.Text txt_3;
      Tpl.Text l_arguments;
      Boolean ret_1;
      Tpl.Text l_returnType;

    case ( txt,
           MidCode.FUNCTION(outputs = i_outputs, inputs = i_inputs, name = i_name) )
      equation
        ret_1 = listEmpty(i_outputs);
        l_returnType = fun_60(Tpl.emptyTxt, ret_1);
        txt_3 = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt_3 = lm_61(txt_3, i_inputs);
        txt_3 = Tpl.popIter(txt_3);
        ret_4 = List.restOrEmpty(i_outputs);
        txt_4 = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt_4 = lm_62(txt_4, ret_4);
        txt_4 = Tpl.popIter(txt_4);
        l_arguments = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING_LIST({
                                                                                      ",\n",
                                                                                      "    "
                                                                                  }, false)), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_arguments = smf_63(l_arguments, Tpl.ST_STRING("threadData_t *threadData"));
        l_arguments = smf_64(l_arguments, txt_3);
        l_arguments = smf_65(l_arguments, txt_4);
        l_arguments = Tpl.popIter(l_arguments);
        l_unboxDefs = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_unboxDefs = lm_67(l_unboxDefs, i_inputs);
        l_unboxDefs = Tpl.popIter(l_unboxDefs);
        l_callOutDefs = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_callOutDefs = lm_69(l_callOutDefs, i_outputs);
        l_callOutDefs = Tpl.popIter(l_callOutDefs);
        ret_9 = listEmpty(i_outputs);
        l_boxDefs = fun_70(Tpl.emptyTxt, ret_9, i_outputs);
        l_unboxes = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_unboxes = lm_72(l_unboxes, i_inputs);
        l_unboxes = Tpl.popIter(l_unboxes);
        ret_12 = listEmpty(i_outputs);
        l_callretval = fun_74(Tpl.emptyTxt, ret_12, i_outputs);
        txt_14 = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt_14 = lm_76(txt_14, i_inputs);
        txt_14 = Tpl.popIter(txt_14);
        ret_15 = List.restOrEmpty(i_outputs);
        txt_15 = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt_15 = lm_78(txt_15, ret_15);
        txt_15 = Tpl.popIter(txt_15);
        l_callvars = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING_LIST({
                                                                                     ",\n",
                                                                                     "    "
                                                                                 }, false)), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_callvars = smf_79(l_callvars, Tpl.ST_STRING("threadData"));
        l_callvars = smf_80(l_callvars, txt_14);
        l_callvars = smf_81(l_callvars, txt_15);
        l_callvars = Tpl.popIter(l_callvars);
        ret_18 = listEmpty(i_outputs);
        txt_18 = fun_83(Tpl.emptyTxt, ret_18, i_outputs);
        ret_20 = List.restOrEmpty(i_outputs);
        txt_20 = lm_85(Tpl.emptyTxt, ret_20);
        l_boxes = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_boxes = smf_86(l_boxes, txt_18);
        l_boxes = smf_87(l_boxes, txt_20);
        l_boxes = Tpl.popIter(l_boxes);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#undef boxptr_"));
        txt = underscorePath(txt, i_name);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_returnType);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" boxptr_"));
        txt = underscorePath(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, l_arguments);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ")\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.writeText(txt, l_unboxDefs);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_callOutDefs);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_boxDefs);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_unboxes);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_callretval);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("omc_"));
        txt = underscorePath(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, l_callvars);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(");\n"));
        txt = Tpl.writeText(txt, l_boxes);
        txt = Tpl.softNewLine(txt);
        ret_22 = listEmpty(i_outputs);
        txt = fun_88(txt, ret_22, i_outputs);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end genBoxPtrFunction;

protected function lm_90
  input Tpl.Text in_txt;
  input list<MidCode.Var> in_items;
  input MidCode.Function in_a_fn;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_fn)
    local
      Tpl.Text txt;
      list<MidCode.Var> rest;
      MidCode.Function a_fn;
      MidCode.Var i_local;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_local :: rest,
           a_fn )
      equation
        txt = genLocalDecl(txt, a_fn, i_local);
        txt = Tpl.nextIter(txt);
        txt = lm_90(txt, rest, a_fn);
      then txt;
  end match;
end lm_90;

protected function lm_91
  input Tpl.Text in_txt;
  input list<MidCode.VarBuf> in_items;
  input MidCode.Function in_a_fn;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_fn)
    local
      Tpl.Text txt;
      list<MidCode.VarBuf> rest;
      MidCode.Function a_fn;
      MidCode.VarBuf i_local;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_local :: rest,
           a_fn )
      equation
        txt = genLocalBufDecl(txt, a_fn, i_local);
        txt = Tpl.nextIter(txt);
        txt = lm_91(txt, rest, a_fn);
      then txt;
  end match;
end lm_91;

protected function lm_92
  input Tpl.Text in_txt;
  input list<MidCode.VarBufPtr> in_items;
  input MidCode.Function in_a_fn;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_fn)
    local
      Tpl.Text txt;
      list<MidCode.VarBufPtr> rest;
      MidCode.Function a_fn;
      MidCode.VarBufPtr i_local;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_local :: rest,
           a_fn )
      equation
        txt = genLocalBufPtrDecl(txt, a_fn, i_local);
        txt = Tpl.nextIter(txt);
        txt = lm_92(txt, rest, a_fn);
      then txt;
  end match;
end lm_92;

public function genLocalDecls
  input Tpl.Text txt;
  input MidCode.Function a_fn;
  input list<MidCode.Var> a_locals;
  input list<MidCode.VarBuf> a_localBufs;
  input list<MidCode.VarBufPtr> a_localBufPtrs;

  output Tpl.Text out_txt;
algorithm
  out_txt := Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_90(out_txt, a_locals, a_fn);
  out_txt := Tpl.popIter(out_txt);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.pushIter(out_txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_91(out_txt, a_localBufs, a_fn);
  out_txt := Tpl.popIter(out_txt);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.pushIter(out_txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_92(out_txt, a_localBufPtrs, a_fn);
  out_txt := Tpl.popIter(out_txt);
end genLocalDecls;

protected function fun_94
  input Tpl.Text in_txt;
  input MidCode.Var in_a_var;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_var)
    local
      Tpl.Text txt;

    case ( txt,
           MidCode.VAR(volatile = true) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("volatile "));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_94;

public function genLocalDecl
  input Tpl.Text txt;
  input MidCode.Function a_fn;
  input MidCode.Var a_var;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_94(txt, a_var);
  out_txt := genVarType(out_txt, a_var);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING(" "));
  out_txt := genVarName(out_txt, a_var);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING(";"));
end genLocalDecl;

public function genLocalBufDecl
  input Tpl.Text txt;
  input MidCode.Function a_fn;
  input MidCode.VarBuf a_var;

  output Tpl.Text out_txt;
algorithm
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING("jmp_buf "));
  out_txt := genVarBufName(out_txt, a_var);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING(";"));
end genLocalBufDecl;

public function genLocalBufPtrDecl
  input Tpl.Text txt;
  input MidCode.Function a_fn;
  input MidCode.VarBufPtr a_var;

  output Tpl.Text out_txt;
algorithm
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING("jmp_buf *"));
  out_txt := genVarBufPtrName(out_txt, a_var);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING(";"));
end genLocalBufPtrDecl;

public function genEntry
  input Tpl.Text in_txt;
  input MidCode.Function in_a_fn;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fn)
    local
      Tpl.Text txt;
      Integer i_entryId;

    case ( txt,
           MidCode.FUNCTION(entryId = i_entryId) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("goto "));
        txt = genLabel(txt, i_entryId);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end genEntry;

protected function fun_99
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input list<MidCode.Var> in_a_outputs;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_outputs)
    local
      Tpl.Text txt;
      list<MidCode.Var> a_outputs;
      MidCode.Var ret_0;

    case ( txt,
           false,
           a_outputs )
      equation
        ret_0 = listHead(a_outputs);
        txt = genVarName(txt, ret_0);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_99;

protected function lm_100
  input Tpl.Text in_txt;
  input list<MidCode.Var> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<MidCode.Var> rest;
      MidCode.Var i_v;
      Tpl.Text l_outPtrName;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_v :: rest )
      equation
        l_outPtrName = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("outPtr_"));
        l_outPtrName = genVarName(l_outPtrName, i_v);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if ("));
        txt = Tpl.writeText(txt, l_outPtrName);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" != NULL)\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("*"));
        txt = Tpl.writeText(txt, l_outPtrName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = genVarName(txt, i_v);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.nextIter(txt);
        txt = lm_100(txt, rest);
      then txt;
  end match;
end lm_100;

public function genExit
  input Tpl.Text in_txt;
  input MidCode.Function in_a_fn;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fn)
    local
      Tpl.Text txt;
      Integer i_exitId;
      list<MidCode.Var> i_outputs;
      list<MidCode.Var> ret_2;
      Boolean ret_1;
      Tpl.Text l_returnString;

    case ( txt,
           MidCode.FUNCTION(outputs = i_outputs, exitId = i_exitId) )
      equation
        ret_1 = listEmpty(i_outputs);
        l_returnString = fun_99(Tpl.emptyTxt, ret_1, i_outputs);
        txt = genLabel(txt, i_exitId);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(": // exit block\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        ret_2 = List.restOrEmpty(i_outputs);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_100(txt, ret_2);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("return "));
        txt = Tpl.writeText(txt, l_returnString);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end genExit;

protected function lm_102
  input Tpl.Text in_txt;
  input list<MidCode.Block> in_items;
  input MidCode.Function in_a_fn;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_fn)
    local
      Tpl.Text txt;
      list<MidCode.Block> rest;
      MidCode.Function a_fn;
      MidCode.Block i_block;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_block :: rest,
           a_fn )
      equation
        txt = genBlock(txt, a_fn, i_block);
        txt = Tpl.nextIter(txt);
        txt = lm_102(txt, rest, a_fn);
      then txt;
  end match;
end lm_102;

public function genBlocks
  input Tpl.Text txt;
  input MidCode.Function a_fn;
  input list<MidCode.Block> a_body;

  output Tpl.Text out_txt;
algorithm
  out_txt := Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_102(out_txt, a_body, a_fn);
  out_txt := Tpl.popIter(out_txt);
end genBlocks;

protected function lm_104
  input Tpl.Text in_txt;
  input list<MidCode.Stmt> in_items;
  input MidCode.Function in_a_fn;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_fn)
    local
      Tpl.Text txt;
      list<MidCode.Stmt> rest;
      MidCode.Function a_fn;
      MidCode.Stmt i_stmt;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_stmt :: rest,
           a_fn )
      equation
        txt = genStmt(txt, a_fn, i_stmt);
        txt = Tpl.nextIter(txt);
        txt = lm_104(txt, rest, a_fn);
      then txt;
  end match;
end lm_104;

protected function fun_105
  input Tpl.Text in_txt;
  input MidCode.Block in_a_block;
  input MidCode.Function in_a_fn;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_block, in_a_fn)
    local
      Tpl.Text txt;
      MidCode.Function a_fn;
      MidCode.Terminator i_terminator;
      list<MidCode.Stmt> i_stmts;
      Integer i_id;

    case ( txt,
           MidCode.BLOCK(id = i_id, stmts = i_stmts, terminator = i_terminator),
           a_fn )
      equation
        txt = genLabel(txt, i_id);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(":\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_104(txt, i_stmts, a_fn);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = genTerminator(txt, a_fn, i_terminator);
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_105;

public function genBlock
  input Tpl.Text txt;
  input MidCode.Function a_fn;
  input MidCode.Block a_block;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_105(txt, a_block, a_fn);
end genBlock;

public function genLabel
  input Tpl.Text txt;
  input Integer a_i;

  output Tpl.Text out_txt;
algorithm
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING("label_"));
  out_txt := Tpl.writeStr(out_txt, intString(a_i));
end genLabel;

public function genVarName
  input Tpl.Text in_txt;
  input MidCode.Var in_a_v;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_v)
    local
      Tpl.Text txt;
      String i_name;

    case ( txt,
           MidCode.VAR(name = i_name) )
      equation
        txt = Tpl.writeStr(txt, i_name);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end genVarName;

public function genVarBufName
  input Tpl.Text in_txt;
  input MidCode.VarBuf in_a_v;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_v)
    local
      Tpl.Text txt;
      String i_name;

    case ( txt,
           MidCode.VARBUF(name = i_name) )
      equation
        txt = Tpl.writeStr(txt, i_name);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end genVarBufName;

public function genVarBufPtrName
  input Tpl.Text in_txt;
  input MidCode.VarBufPtr in_a_v;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_v)
    local
      Tpl.Text txt;
      String i_name;

    case ( txt,
           MidCode.VARBUFPTR(name = i_name) )
      equation
        txt = Tpl.writeStr(txt, i_name);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end genVarBufPtrName;

protected function fun_111
  input Tpl.Text in_txt;
  input MidCode.Stmt in_a_stmt;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_stmt)
    local
      Tpl.Text txt;
      MidCode.RValue i_rvalue;
      String i_dest__name;

    case ( txt,
           MidCode.NOP() )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("; // NOP"));
      then txt;

    case ( txt,
           MidCode.ASSIGN(dest = MidCode.VAR(name = i_dest__name, ty = _), src = i_rvalue) )
      equation
        txt = Tpl.writeStr(txt, i_dest__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = genRValue(txt, i_rvalue);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_111;

public function genStmt
  input Tpl.Text txt;
  input MidCode.Function a_fn;
  input MidCode.Stmt a_stmt;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_111(txt, a_stmt);
end genStmt;

protected function fun_113
  input Tpl.Text in_txt;
  input Boolean in_a_value;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_value)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("0"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("1"));
      then txt;
  end match;
end fun_113;

protected function lm_114
  input Tpl.Text in_txt;
  input list<MidCode.Var> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<MidCode.Var> rest;
      MidCode.Var i_element;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_element :: rest )
      equation
        txt = genVarName(txt, i_element);
        txt = Tpl.nextIter(txt);
        txt = lm_114(txt, rest);
      then txt;
  end match;
end lm_114;

protected function smf_115
  input Tpl.Text in_txt;
  input Tpl.Text in_it;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_it)
    local
      Tpl.Text txt;
      Tpl.Text i_it;

    case ( txt,
           i_it )
      equation
        txt = Tpl.writeText(txt, i_it);
        txt = Tpl.nextIter(txt);
      then txt;
  end match;
end smf_115;

protected function smf_116
  input Tpl.Text in_txt;
  input Tpl.Text in_it;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_it)
    local
      Tpl.Text txt;
      Tpl.Text i_it;

    case ( txt,
           i_it )
      equation
        txt = Tpl.writeText(txt, i_it);
        txt = Tpl.nextIter(txt);
      then txt;
  end match;
end smf_116;

protected function smf_117
  input Tpl.Text in_txt;
  input Tpl.Text in_it;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_it)
    local
      Tpl.Text txt;
      Tpl.Text i_it;

    case ( txt,
           i_it )
      equation
        txt = Tpl.writeText(txt, i_it);
        txt = Tpl.nextIter(txt);
      then txt;
  end match;
end smf_117;

protected function smf_118
  input Tpl.Text in_txt;
  input Tpl.Text in_it;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_it)
    local
      Tpl.Text txt;
      Tpl.Text i_it;

    case ( txt,
           i_it )
      equation
        txt = Tpl.writeText(txt, i_it);
        txt = Tpl.nextIter(txt);
      then txt;
  end match;
end smf_118;

protected function smf_119
  input Tpl.Text in_txt;
  input Tpl.Text in_it;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_it)
    local
      Tpl.Text txt;
      Tpl.Text i_it;

    case ( txt,
           i_it )
      equation
        txt = Tpl.writeText(txt, i_it);
        txt = Tpl.nextIter(txt);
      then txt;
  end match;
end smf_119;

protected function smf_120
  input Tpl.Text in_txt;
  input Tpl.Text in_it;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_it)
    local
      Tpl.Text txt;
      Tpl.Text i_it;

    case ( txt,
           i_it )
      equation
        txt = Tpl.writeText(txt, i_it);
        txt = Tpl.nextIter(txt);
      then txt;
  end match;
end smf_120;

protected function smf_121
  input Tpl.Text in_txt;
  input Tpl.Text in_it;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_it)
    local
      Tpl.Text txt;
      Tpl.Text i_it;

    case ( txt,
           i_it )
      equation
        txt = Tpl.writeText(txt, i_it);
        txt = Tpl.nextIter(txt);
      then txt;
  end match;
end smf_121;

protected function fun_122
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;
  input Tpl.Text in_a_elementargs;
  input Tpl.Text in_a_metatypeCtor;
  input Tpl.Text in_a_metatypeSlots;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty, in_a_elementargs, in_a_metatypeCtor, in_a_metatypeSlots)
    local
      Tpl.Text txt;
      Tpl.Text a_elementargs;
      Tpl.Text a_metatypeCtor;
      Tpl.Text a_metatypeSlots;
      DAE.Type i_ty;
      Tpl.Text txt_2;
      Tpl.Text txt_1;
      Tpl.Text l_arguments;

    case ( txt,
           (i_ty as DAE.T_METARECORD(path = _)),
           a_elementargs,
           a_metatypeCtor,
           a_metatypeSlots )
      equation
        txt_1 = Tpl.writeText(Tpl.emptyTxt, a_metatypeSlots);
        txt_1 = Tpl.writeTok(txt_1, Tpl.ST_STRING("+1"));
        txt_2 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("&"));
        txt_2 = genTypeUnderscorePath(txt_2, i_ty);
        txt_2 = Tpl.writeTok(txt_2, Tpl.ST_STRING("__desc"));
        l_arguments = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_arguments = smf_115(l_arguments, txt_1);
        l_arguments = smf_116(l_arguments, a_metatypeCtor);
        l_arguments = smf_117(l_arguments, txt_2);
        l_arguments = smf_118(l_arguments, a_elementargs);
        l_arguments = Tpl.popIter(l_arguments);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("mmc_mk_box("));
        txt = Tpl.writeText(txt, l_arguments);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           _,
           a_elementargs,
           a_metatypeCtor,
           a_metatypeSlots )
      equation
        l_arguments = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_arguments = smf_119(l_arguments, a_metatypeSlots);
        l_arguments = smf_120(l_arguments, a_metatypeCtor);
        l_arguments = smf_121(l_arguments, a_elementargs);
        l_arguments = Tpl.popIter(l_arguments);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("mmc_mk_box("));
        txt = Tpl.writeText(txt, l_arguments);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;
  end match;
end fun_122;

public function genRValue
  input Tpl.Text in_txt;
  input MidCode.RValue in_a_rvalue;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_rvalue)
    local
      Tpl.Text txt;
      Integer i_index;
      DAE.Type i_ty;
      list<MidCode.Var> i_elements;
      String i_value_3;
      Real i_value_2;
      Boolean i_value_1;
      Integer i_value;
      MidCode.UnaryOp i_op_1;
      MidCode.Var i_src;
      String i_rsrc__name;
      String i_lsrc__name;
      MidCode.Var i_rsrc;
      MidCode.Var i_lsrc;
      MidCode.BinaryOp i_op;
      String i_src__name;
      Integer ret_5;
      Tpl.Text l_elementargs;
      Tpl.Text l_metatypeCtor;
      Integer ret_2;
      Tpl.Text l_metatypeSlots;
      String ret_0;

    case ( txt,
           MidCode.VARIABLE(src = MidCode.VAR(name = i_src__name, ty = _)) )
      equation
        txt = Tpl.writeStr(txt, i_src__name);
      then txt;

    case ( txt,
           MidCode.BINARYOP(op = i_op, lsrc = (i_lsrc as MidCode.VAR(name = _, ty = DAE.T_STRING(varLst = _))), rsrc = (i_rsrc as MidCode.VAR(name = _, ty = DAE.T_STRING(varLst = _)))) )
      equation
        txt = genStringBinaryop(txt, i_op, i_lsrc, i_rsrc);
      then txt;

    case ( txt,
           MidCode.BINARYOP(op = MidCode.POW(), lsrc = MidCode.VAR(name = i_lsrc__name, ty = _), rsrc = MidCode.VAR(name = i_rsrc__name, ty = _)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("pow("));
        txt = Tpl.writeStr(txt, i_lsrc__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeStr(txt, i_rsrc__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           MidCode.BINARYOP(op = i_op, lsrc = MidCode.VAR(name = i_lsrc__name, ty = _), rsrc = MidCode.VAR(name = i_rsrc__name, ty = _)) )
      equation
        txt = Tpl.writeStr(txt, i_lsrc__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = binaryopToString(txt, i_op);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeStr(txt, i_rsrc__name);
      then txt;

    case ( txt,
           MidCode.UNARYOP(op = MidCode.BOX(), src = i_src) )
      equation
        txt = varBox(txt, i_src);
      then txt;

    case ( txt,
           MidCode.UNARYOP(op = MidCode.UNBOX(), src = i_src) )
      equation
        txt = varUnbox(txt, i_src);
      then txt;

    case ( txt,
           MidCode.UNARYOP(op = i_op_1, src = i_src) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = genVarType(txt, i_src);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") "));
        txt = unaryopToString(txt, i_op_1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = genVarName(txt, i_src);
      then txt;

    case ( txt,
           MidCode.LITERALINTEGER(value = i_value) )
      equation
        txt = Tpl.writeStr(txt, intString(i_value));
      then txt;

    case ( txt,
           MidCode.LITERALBOOLEAN(value = i_value_1) )
      equation
        txt = fun_113(txt, i_value_1);
      then txt;

    case ( txt,
           MidCode.LITERALREAL(value = i_value_2) )
      equation
        txt = Tpl.writeStr(txt, realString(i_value_2));
      then txt;

    case ( txt,
           MidCode.LITERALSTRING(value = i_value_3) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("mmc_mk_scon(\""));
        ret_0 = Util.escapeModelicaStringToCString(i_value_3);
        txt = Tpl.writeStr(txt, ret_0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\")"));
      then txt;

    case ( txt,
           MidCode.LITERALMETATYPE(elements = i_elements, ty = i_ty) )
      equation
        ret_2 = listLength(i_elements);
        l_metatypeSlots = Tpl.writeStr(Tpl.emptyTxt, intString(ret_2));
        l_metatypeCtor = genTypeCtorIndex(Tpl.emptyTxt, i_elements, i_ty);
        l_elementargs = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_elementargs = lm_114(l_elementargs, i_elements);
        l_elementargs = Tpl.popIter(l_elementargs);
        txt = fun_122(txt, i_ty, l_elementargs, l_metatypeCtor, l_metatypeSlots);
      then txt;

    case ( txt,
           MidCode.METAFIELD(src = i_src, index = i_index, ty = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("MMC_FETCH(MMC_OFFSET(MMC_UNTAGPTR("));
        txt = genVarName(txt, i_src);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("),"));
        ret_5 = intAdd(i_index, 1);
        txt = Tpl.writeStr(txt, intString(ret_5));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("))"));
      then txt;

    case ( txt,
           MidCode.UNIONTYPEVARIANT(src = i_src) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(MMC_HDRCTOR(MMC_GETHDR("));
        txt = genVarName(txt, i_src);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")) - 3)"));
      then txt;

    case ( txt,
           MidCode.ISSOME(src = i_src) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(0==MMC_HDRSLOTS(MMC_GETHDR("));
        txt = genVarName(txt, i_src);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")) ? 0 : 1)"));
      then txt;

    case ( txt,
           MidCode.ISCONS(src = i_src) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(MMC_GETHDR("));
        txt = genVarName(txt, i_src);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") == MMC_CONSHDR)"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("notimplemented"));
      then txt;
  end match;
end genRValue;

public function binaryopToString
  input Tpl.Text in_txt;
  input MidCode.BinaryOp in_a_op;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_op)
    local
      Tpl.Text txt;

    case ( txt,
           MidCode.ADD() )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("+"));
      then txt;

    case ( txt,
           MidCode.SUB() )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-"));
      then txt;

    case ( txt,
           MidCode.MUL() )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("*"));
      then txt;

    case ( txt,
           MidCode.DIV() )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/"));
      then txt;

    case ( txt,
           MidCode.LESS() )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<"));
      then txt;

    case ( txt,
           MidCode.LESSEQ() )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<="));
      then txt;

    case ( txt,
           MidCode.GREATER() )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(">"));
      then txt;

    case ( txt,
           MidCode.GREATEREQ() )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(">="));
      then txt;

    case ( txt,
           MidCode.EQUAL() )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("=="));
      then txt;

    case ( txt,
           MidCode.NEQUAL() )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("!="));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("notimplemented"));
      then txt;
  end match;
end binaryopToString;

public function unaryopToString
  input Tpl.Text in_txt;
  input MidCode.UnaryOp in_a_op;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_op)
    local
      Tpl.Text txt;

    case ( txt,
           MidCode.MOVE() )
      then txt;

    case ( txt,
           MidCode.UMINUS() )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-"));
      then txt;

    case ( txt,
           MidCode.NOT() )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("!"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("notimplemented"));
      then txt;
  end match;
end unaryopToString;

public function genStringBinaryop
  input Tpl.Text in_txt;
  input MidCode.BinaryOp in_a_op;
  input MidCode.Var in_a_lsrc;
  input MidCode.Var in_a_rsrc;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_op, in_a_lsrc, in_a_rsrc)
    local
      Tpl.Text txt;
      MidCode.Var a_lsrc;
      MidCode.Var a_rsrc;
      MidCode.BinaryOp i_op;

    case ( txt,
           MidCode.ADD(),
           a_lsrc,
           a_rsrc )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("stringAppend("));
        txt = genVarName(txt, a_lsrc);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = genVarName(txt, a_rsrc);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           i_op,
           a_lsrc,
           a_rsrc )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("0 "));
        txt = binaryopToString(txt, i_op);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" stringCompare("));
        txt = genVarName(txt, a_lsrc);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = genVarName(txt, a_rsrc);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;
  end match;
end genStringBinaryop;

protected function lm_127
  input Tpl.Text in_txt;
  input list<tuple<Integer, Integer>> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<tuple<Integer, Integer>> rest;
      Integer i_to;
      Integer i_from;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           (i_from, i_to) :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("case "));
        txt = Tpl.writeStr(txt, intString(i_from));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(": goto "));
        txt = genLabel(txt, i_to);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        txt = lm_127(txt, rest);
      then txt;
  end match;
end lm_127;

protected function fun_128
  input Tpl.Text in_txt;
  input list<MidCode.OutVar> in_a_outputs;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_outputs)
    local
      Tpl.Text txt;
      MidCode.Var i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           MidCode.OUT_WILD() :: _ )
      then txt;

    case ( txt,
           MidCode.OUT_VAR(var = i_var) :: _ )
      equation
        txt = genVarName(txt, i_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_128;

protected function fun_129
  input Tpl.Text in_txt;
  input Boolean in_a_builtin;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_builtin)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("threadData"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_129;

protected function lm_130
  input Tpl.Text in_txt;
  input list<MidCode.Var> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<MidCode.Var> rest;
      MidCode.Var i_i;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_i :: rest )
      equation
        txt = genVarName(txt, i_i);
        txt = Tpl.nextIter(txt);
        txt = lm_130(txt, rest);
      then txt;
  end match;
end lm_130;

protected function fun_131
  input Tpl.Text in_txt;
  input MidCode.OutVar in_a_o;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_o)
    local
      Tpl.Text txt;
      MidCode.Var i_var;

    case ( txt,
           MidCode.OUT_VAR(var = i_var) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("&"));
        txt = genVarName(txt, i_var);
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("NULL"));
      then txt;
  end match;
end fun_131;

protected function lm_132
  input Tpl.Text in_txt;
  input list<MidCode.OutVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<MidCode.OutVar> rest;
      MidCode.OutVar i_o;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_o :: rest )
      equation
        txt = fun_131(txt, i_o);
        txt = Tpl.nextIter(txt);
        txt = lm_132(txt, rest);
      then txt;
  end match;
end lm_132;

protected function smf_133
  input Tpl.Text in_txt;
  input Tpl.Text in_it;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_it)
    local
      Tpl.Text txt;
      Tpl.Text i_it;

    case ( txt,
           i_it )
      equation
        txt = Tpl.writeText(txt, i_it);
        txt = Tpl.nextIter(txt);
      then txt;
  end match;
end smf_133;

protected function smf_134
  input Tpl.Text in_txt;
  input Tpl.Text in_it;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_it)
    local
      Tpl.Text txt;
      Tpl.Text i_it;

    case ( txt,
           i_it )
      equation
        txt = Tpl.writeText(txt, i_it);
        txt = Tpl.nextIter(txt);
      then txt;
  end match;
end smf_134;

protected function smf_135
  input Tpl.Text in_txt;
  input Tpl.Text in_it;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_it)
    local
      Tpl.Text txt;
      Tpl.Text i_it;

    case ( txt,
           i_it )
      equation
        txt = Tpl.writeText(txt, i_it);
        txt = Tpl.nextIter(txt);
      then txt;
  end match;
end smf_135;

protected function fun_136
  input Tpl.Text in_txt;
  input Boolean in_a_builtin;
  input Absyn.Path in_a_func;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_builtin, in_a_func)
    local
      Tpl.Text txt;
      Absyn.Path a_func;

    case ( txt,
           false,
           a_func )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("omc_"));
        txt = underscorePath(txt, a_func);
      then txt;

    case ( txt,
           _,
           a_func )
      equation
        txt = identBuiltinCall(txt, a_func);
      then txt;
  end match;
end fun_136;

protected function fun_137
  input Tpl.Text in_txt;
  input MidCode.Terminator in_a_terminator;
  input Integer in_a_exitId;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_terminator, in_a_exitId)
    local
      Tpl.Text txt;
      Integer a_exitId;
      MidCode.VarBuf i_new__buf;
      MidCode.VarBufPtr i_old__buf;
      Integer i_next;
      Absyn.Path i_func;
      list<MidCode.Var> i_inputs;
      Boolean i_builtin;
      list<MidCode.OutVar> i_outputs;
      list<tuple<Integer, Integer>> i_cases;
      Integer i_labelFalse;
      Integer i_labelTrue;
      MidCode.Var i_condition;
      Integer i_label;
      Tpl.Text txt_4;
      list<MidCode.OutVar> ret_4;
      Tpl.Text txt_3;
      Tpl.Text txt_2;
      Tpl.Text l_arguments;
      Tpl.Text l_returnAssignment;

    case ( txt,
           MidCode.RETURN(),
           a_exitId )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("goto "));
        txt = genLabel(txt, a_exitId);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("; // exit label"));
      then txt;

    case ( txt,
           MidCode.GOTO(next = i_label),
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("goto "));
        txt = genLabel(txt, i_label);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           MidCode.BRANCH(condition = i_condition, onTrue = i_labelTrue, onFalse = i_labelFalse),
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if ("));
        txt = genVarName(txt, i_condition);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(")\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("goto "));
        txt = genLabel(txt, i_labelTrue);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("else\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("goto "));
        txt = genLabel(txt, i_labelFalse);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           MidCode.SWITCH(condition = i_condition, cases = i_cases),
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("switch ("));
        txt = genVarName(txt, i_condition);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("){\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_127(txt, i_cases);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;

    case ( txt,
           MidCode.CALL(func = i_func, builtin = i_builtin, inputs = i_inputs, outputs = i_outputs, next = i_next),
           _ )
      equation
        l_returnAssignment = fun_128(Tpl.emptyTxt, i_outputs);
        txt_2 = fun_129(Tpl.emptyTxt, i_builtin);
        txt_3 = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt_3 = lm_130(txt_3, i_inputs);
        txt_3 = Tpl.popIter(txt_3);
        ret_4 = List.restOrEmpty(i_outputs);
        txt_4 = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt_4 = lm_132(txt_4, ret_4);
        txt_4 = Tpl.popIter(txt_4);
        l_arguments = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING_LIST({
                                                                                      ",\n",
                                                                                      "    "
                                                                                  }, false)), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_arguments = smf_133(l_arguments, txt_2);
        l_arguments = smf_134(l_arguments, txt_3);
        l_arguments = smf_135(l_arguments, txt_4);
        l_arguments = Tpl.popIter(l_arguments);
        txt = Tpl.writeText(txt, l_returnAssignment);
        txt = fun_136(txt, i_builtin, i_func);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, l_arguments);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ");\n",
                                    "goto "
                                }, false));
        txt = genLabel(txt, i_next);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           MidCode.LONGJMP(),
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("longjmp(*threadData->mmc_jumper,1);"));
      then txt;

    case ( txt,
           MidCode.PUSHJMP(old_buf = i_old__buf, new_buf = i_new__buf, next = i_next),
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("// PUSHJMP\n"));
        txt = genVarBufPtrName(txt, i_old__buf);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " = threadData->mmc_jumper;\n",
                                    "threadData->mmc_jumper = &"
                                }, false));
        txt = genVarBufName(txt, i_new__buf);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "setjmp(&"
                                }, false));
        txt = genVarBufName(txt, i_new__buf);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ");\n",
                                    "goto "
                                }, false));
        txt = genLabel(txt, i_next);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           MidCode.POPJMP(old_buf = i_old__buf, next = i_next),
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "// POPJMP\n",
                                    "threadData->mmc_jumper = "
                                }, false));
        txt = genVarBufPtrName(txt, i_old__buf);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "goto "
                                }, false));
        txt = genLabel(txt, i_next);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("notimplemented"));
      then txt;
  end match;
end fun_137;

public function genTerminator
  input Tpl.Text in_txt;
  input MidCode.Function in_a_fn;
  input MidCode.Terminator in_a_terminator;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fn, in_a_terminator)
    local
      Tpl.Text txt;
      MidCode.Terminator a_terminator;
      Integer i_exitId;

    case ( txt,
           MidCode.FUNCTION(locals = _, inputs = _, outputs = _, body = _, entryId = _, exitId = i_exitId),
           a_terminator )
      equation
        txt = fun_137(txt, a_terminator, i_exitId);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end genTerminator;

protected function fun_139
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty)
    local
      Tpl.Text txt;

    case ( txt,
           DAE.T_INTEGER(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_integer"));
      then txt;

    case ( txt,
           DAE.T_ENUMERATION(index = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_integer"));
      then txt;

    case ( txt,
           DAE.T_BOOL(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_boolean"));
      then txt;

    case ( txt,
           DAE.T_REAL(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_real"));
      then txt;

    case ( txt,
           DAE.T_STRING(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_string"));
      then txt;

    case ( txt,
           DAE.T_METABOXED(ty = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_metatype"));
      then txt;

    case ( txt,
           DAE.T_METARECORD(path = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_metatype"));
      then txt;

    case ( txt,
           DAE.T_METATYPE(ty = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_metatype"));
      then txt;

    case ( txt,
           DAE.T_METAOPTION(ty = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_metatype"));
      then txt;

    case ( txt,
           DAE.T_METAARRAY(ty = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_metatype"));
      then txt;

    case ( txt,
           DAE.T_METATUPLE(types = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_metatype"));
      then txt;

    case ( txt,
           DAE.T_METAUNIONTYPE(paths = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_metatype"));
      then txt;

    case ( txt,
           DAE.T_METALIST(ty = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_metatype"));
      then txt;

    case ( txt,
           DAE.T_UNKNOWN() )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("unknown"));
      then txt;

    case ( txt,
           DAE.T_METAPOLYMORPHIC(name = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("error_ metapolymorphic"));
      then txt;

    case ( txt,
           DAE.T_METAUNIONTYPE(paths = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("error_ metauniontype"));
      then txt;

    case ( txt,
           DAE.T_ANYTYPE(anyClassType = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("error_anytype"));
      then txt;

    case ( txt,
           DAE.T_TUPLE(types = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("error_tuple"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("notimplemented"));
      then txt;
  end match;
end fun_139;

public function genVarType
  input Tpl.Text in_txt;
  input MidCode.Var in_a_var;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_var)
    local
      Tpl.Text txt;
      DAE.Type i_ty;

    case ( txt,
           MidCode.VAR(name = _, ty = i_ty) )
      equation
        txt = fun_139(txt, i_ty);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end genVarType;

protected function fun_141
  input Tpl.Text in_txt;
  input Integer in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           0 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("0"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("1"));
      then txt;
  end match;
end fun_141;

protected function fun_142
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;
  input list<MidCode.Var> in_a_elements;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty, in_a_elements)
    local
      Tpl.Text txt;
      list<MidCode.Var> a_elements;
      Integer i_index;
      Integer ret_1;
      Integer ret_0;

    case ( txt,
           DAE.T_METARECORD(index = i_index),
           _ )
      equation
        ret_0 = intAdd(i_index, 3);
        txt = Tpl.writeStr(txt, intString(ret_0));
      then txt;

    case ( txt,
           DAE.T_METAARRAY(ty = _),
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("2"));
      then txt;

    case ( txt,
           DAE.T_METATUPLE(types = _),
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("0"));
      then txt;

    case ( txt,
           DAE.T_METAOPTION(ty = _),
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("1"));
      then txt;

    case ( txt,
           DAE.T_METALIST(ty = _),
           a_elements )
      equation
        ret_1 = listLength(a_elements);
        txt = fun_141(txt, ret_1);
      then txt;

    case ( txt,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("0"));
      then txt;
  end match;
end fun_142;

public function genTypeCtorIndex
  input Tpl.Text txt;
  input list<MidCode.Var> a_elements;
  input DAE.Type a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_142(txt, a_ty, a_elements);
end genTypeCtorIndex;

public function genTypeUnderscorePath
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty)
    local
      Tpl.Text txt;
      Absyn.Path i_path;

    case ( txt,
           DAE.T_METARECORD(path = i_path) )
      equation
        txt = underscorePath(txt, i_path);
      then txt;

    case ( txt,
           DAE.T_COMPLEX(complexClassType = ClassInf.RECORD(path = i_path), varLst = _) )
      equation
        txt = underscorePath(txt, i_path);
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("error: genTypeUnderscorePath"));
      then txt;
  end match;
end genTypeUnderscorePath;

protected function fun_145
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty)
    local
      Tpl.Text txt;

    case ( txt,
           DAE.T_INTEGER(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_metatype"));
      then txt;

    case ( txt,
           DAE.T_ENUMERATION(index = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_metatype"));
      then txt;

    case ( txt,
           DAE.T_BOOL(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_metatype"));
      then txt;

    case ( txt,
           DAE.T_REAL(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_metatype"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_145;

public function varBoxType
  input Tpl.Text in_txt;
  input MidCode.Var in_a_var;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_var)
    local
      Tpl.Text txt;
      DAE.Type i_ty;

    case ( txt,
           MidCode.VAR(name = _, ty = i_ty) )
      equation
        txt = fun_145(txt, i_ty);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end varBoxType;

protected function fun_147
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;
  input String in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty, in_a_name)
    local
      Tpl.Text txt;
      String a_name;

    case ( txt,
           DAE.T_INTEGER(varLst = _),
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("mmc_mk_icon("));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.T_ENUMERATION(index = _),
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("mmc_mk_icon("));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.T_BOOL(varLst = _),
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("mmc_mk_icon("));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.T_REAL(varLst = _),
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("mmc_mk_rcon("));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.T_STRING(varLst = _),
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("mmc_mk_string("));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.T_COMPLEX(complexClassType = _),
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("mmc_mk_box("));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           _,
           a_name )
      equation
        txt = Tpl.writeStr(txt, a_name);
      then txt;
  end match;
end fun_147;

public function varBox
  input Tpl.Text in_txt;
  input MidCode.Var in_a_var;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_var)
    local
      Tpl.Text txt;
      String i_name;
      DAE.Type i_ty;

    case ( txt,
           MidCode.VAR(name = i_name, ty = i_ty) )
      equation
        txt = fun_147(txt, i_ty, i_name);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end varBox;

protected function fun_149
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;
  input String in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty, in_a_name)
    local
      Tpl.Text txt;
      String a_name;

    case ( txt,
           DAE.T_METABOXED(ty = DAE.T_INTEGER(varLst = _)),
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("mmc_unbox_integer("));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.T_METABOXED(ty = DAE.T_ENUMERATION(index = _)),
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("mmc_unbox_integer("));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.T_METABOXED(ty = DAE.T_BOOL(varLst = _)),
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("mmc_unbox_integer("));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.T_METABOXED(ty = DAE.T_REAL(varLst = _)),
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("mmc_unbox_real("));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.T_STRING(varLst = _),
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("mmc_unbox_string("));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           _,
           a_name )
      equation
        txt = Tpl.writeStr(txt, a_name);
      then txt;
  end match;
end fun_149;

public function varUnbox
  input Tpl.Text in_txt;
  input MidCode.Var in_a_var;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_var)
    local
      Tpl.Text txt;
      String i_name;
      DAE.Type i_ty;

    case ( txt,
           MidCode.VAR(name = i_name, ty = i_ty) )
      equation
        txt = fun_149(txt, i_ty, i_name);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end varUnbox;

protected function fun_151
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;
  input String in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty, in_a_name)
    local
      Tpl.Text txt;
      String a_name;

    case ( txt,
           DAE.T_INTEGER(varLst = _),
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("mmc_unbox_integer("));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.T_ENUMERATION(index = _),
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("mmc_unbox_integer("));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.T_BOOL(varLst = _),
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("mmc_unbox_integer("));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.T_REAL(varLst = _),
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("mmc_unbox_real("));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.T_STRING(varLst = _),
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("mmc_unbox_string("));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           _,
           a_name )
      equation
        txt = Tpl.writeStr(txt, a_name);
      then txt;
  end match;
end fun_151;

public function varUnbox2
  input Tpl.Text in_txt;
  input MidCode.Var in_a_var;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_var)
    local
      Tpl.Text txt;
      String i_name;
      DAE.Type i_ty;

    case ( txt,
           MidCode.VAR(name = i_name, ty = i_ty) )
      equation
        txt = fun_151(txt, i_ty, i_name);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end varUnbox2;

protected function fun_153
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;
  input String in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty, in_a_name)
    local
      Tpl.Text txt;
      String a_name;

    case ( txt,
           DAE.T_INTEGER(varLst = _),
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("read_modelica_integer(&inArgs, &"));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.T_BOOL(varLst = _),
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("read_modelica_integer(&inArgs, &"));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.T_REAL(varLst = _),
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("read_modelica_real(&inArgs, &"));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.T_STRING(varLst = _),
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("read_modelica_string(&inArgs, &"));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.T_ENUMERATION(index = _),
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("read_modelica_integer(&inArgs, &"));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.T_COMPLEX(complexClassType = _),
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("read_modelica_metatype(&inArgs, &"));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.T_METAUNIONTYPE(paths = _),
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("read_modelica_metatype(&inArgs, &"));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.T_METALIST(ty = _),
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("read_modelica_metatype(&inArgs, &"));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.T_METAARRAY(ty = _),
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("read_modelica_metatype(&inArgs, &"));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.T_METAOPTION(ty = _),
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("read_modelica_metatype(&inArgs, &"));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.T_METATUPLE(types = _),
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("read_modelica_metatype(&inArgs, &"));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_153;

public function varModelicaRead
  input Tpl.Text in_txt;
  input MidCode.Var in_a_var;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_var)
    local
      Tpl.Text txt;
      String i_name;
      DAE.Type i_ty;

    case ( txt,
           MidCode.VAR(name = i_name, ty = i_ty) )
      equation
        txt = fun_153(txt, i_ty, i_name);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end varModelicaRead;

protected function fun_155
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;
  input String in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty, in_a_name)
    local
      Tpl.Text txt;
      String a_name;

    case ( txt,
           DAE.T_INTEGER(varLst = _),
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("write_modelica_integer(outVar, &"));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.T_BOOL(varLst = _),
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("write_modelica_integer(outVar, &"));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.T_REAL(varLst = _),
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("write_modelica_real(outVar, &"));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.T_STRING(varLst = _),
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("write_modelica_string(outVar, &"));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.T_ENUMERATION(index = _),
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("write_modelica_integer(outVar, &"));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.T_COMPLEX(complexClassType = _),
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("write_modelica_metatype(outVar, &"));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.T_METAUNIONTYPE(paths = _),
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("write_modelica_metatype(outVar, &"));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.T_METALIST(ty = _),
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("write_modelica_metatype(outVar, &"));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.T_METAARRAY(ty = _),
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("write_modelica_metatype(outVar, &"));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.T_METAOPTION(ty = _),
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("write_modelica_metatype(outVar, &"));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.T_METATUPLE(types = _),
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("write_modelica_metatype(outVar, &"));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_155;

public function varModelicaWrite
  input Tpl.Text in_txt;
  input MidCode.Var in_a_var;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_var)
    local
      Tpl.Text txt;
      String i_name;
      DAE.Type i_ty;

    case ( txt,
           MidCode.VAR(name = i_name, ty = i_ty) )
      equation
        txt = fun_155(txt, i_ty, i_name);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end varModelicaWrite;

public function identName
  input Tpl.Text in_txt;
  input Absyn.Path in_a_path;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_path)
    local
      Tpl.Text txt;
      String i_name;

    case ( txt,
           Absyn.IDENT(name = i_name) )
      equation
        txt = Tpl.writeStr(txt, i_name);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end identName;

public function identBuiltinCall
  input Tpl.Text in_txt;
  input Absyn.Path in_a_path;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_path)
    local
      Tpl.Text txt;
      String i_name;

    case ( txt,
           Absyn.IDENT(name = "clock") )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("mmc_clock"));
      then txt;

    case ( txt,
           Absyn.IDENT(name = "anyString") )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("mmc_anyString"));
      then txt;

    case ( txt,
           Absyn.IDENT(name = "fail") )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("MMC_THROW_INTERNAL"));
      then txt;

    case ( txt,
           Absyn.IDENT(name = "intMod") )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_mod_integer"));
      then txt;

    case ( txt,
           Absyn.IDENT(name = i_name) )
      equation
        txt = Tpl.writeStr(txt, i_name);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end identBuiltinCall;

public function replaceDotAndUnderscore
  input Tpl.Text in_txt;
  input String in_a_str;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_str)
    local
      Tpl.Text txt;
      String i_name;
      String ret_4;
      String ret_3;
      Tpl.Text l_str__underscores;
      String ret_1;
      Tpl.Text l_str__dots;

    case ( txt,
           i_name )
      equation
        ret_1 = System.stringReplace(i_name, ".", "_");
        l_str__dots = Tpl.writeStr(Tpl.emptyTxt, ret_1);
        ret_3 = System.stringReplace(Tpl.textString(l_str__dots), "_", "__");
        l_str__underscores = Tpl.writeStr(Tpl.emptyTxt, ret_3);
        ret_4 = System.unquoteIdentifier(Tpl.textString(l_str__underscores));
        txt = Tpl.writeStr(txt, ret_4);
      then txt;
  end match;
end replaceDotAndUnderscore;

public function underscorePath
  input Tpl.Text in_txt;
  input Absyn.Path in_a_path;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_path)
    local
      Tpl.Text txt;
      String i_name_1;
      Absyn.Path i_path;
      Absyn.Ident i_name;

    case ( txt,
           Absyn.QUALIFIED(name = i_name, path = i_path) )
      equation
        txt = replaceDotAndUnderscore(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = underscorePath(txt, i_path);
      then txt;

    case ( txt,
           Absyn.IDENT(name = i_name_1) )
      equation
        txt = replaceDotAndUnderscore(txt, i_name_1);
      then txt;

    case ( txt,
           Absyn.FULLYQUALIFIED(path = i_path) )
      equation
        txt = underscorePath(txt, i_path);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end underscorePath;

annotation(__OpenModelica_Interface="backend");
end CodegenMidToC;