encapsulated package CodegenOMSIC
"
  file:        CodegenOMSIC.mo
  package:     CodegenOMSIC
  description: Generated by Susan.
"

public import Tpl;

public import SimCode;
public import SimCodeFunction;
public import BackendDAE;
public import System;
public import Absyn;
public import DAE;
public import Util;
public import Config;
public import Flags;
public import Settings;
public import FMI;
protected import CodegenOMSI_common;
protected import CodegenUtil;
protected import CodegenUtilSimulation;
protected import CodegenFMU;

protected function fun_47
  input Tpl.Text in_txt;
  input Integer in_a_varInfo_numZeroCrossings;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_varInfo_numZeroCrossings)
    local
      Tpl.Text txt;

    case ( txt,
           0 )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#include <omsi_event_helper.h>"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;
  end match;
end fun_47;

protected function fun_48
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_includes;
  input Tpl.Text in_a_functionPrototypes;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_includes;
  output Tpl.Text out_a_functionPrototypes;
algorithm
  (out_txt, out_a_includes, out_a_functionPrototypes) :=
  match(in_txt, in_a_simCode, in_a_includes, in_a_functionPrototypes)
    local
      Tpl.Text txt;
      Tpl.Text a_includes;
      Tpl.Text a_functionPrototypes;
      Absyn.Path i_modelInfo_name;
      list<BackendDAE.TimeEvent> i_timeEvents;
      String i_fullPathPrefix;
      Integer i_varInfo_numZeroCrossings;
      String i_fileNamePrefix;
      SimCode.SimCode i_simCode;
      String ret_5;
      Tpl.Text l_functionInitSampleCode;
      Tpl.Text txt_3;
      Tpl.Text l_headerFileContent;
      Tpl.Text l_headerFileName;
      Tpl.Text l_modelNamePrefixStr;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(fileNamePrefix = i_fileNamePrefix, fullPathPrefix = i_fullPathPrefix, modelInfo = SimCode.MODELINFO(functions = _, varInfo = SimCode.VARINFO(numZeroCrossings = i_varInfo_numZeroCrossings), name = i_modelInfo_name), timeEvents = i_timeEvents)),
           a_includes,
           a_functionPrototypes )
      equation
        l_modelNamePrefixStr = CodegenUtilSimulation.modelNamePrefix(Tpl.emptyTxt, i_simCode);
        a_functionPrototypes = Tpl.writeTok(a_functionPrototypes, Tpl.ST_STRING("void initialize_start_function (omsi_template_callback_functions_t* callback);"));
        a_functionPrototypes = Tpl.writeTok(a_functionPrototypes, Tpl.ST_NEW_LINE());
        a_functionPrototypes = Tpl.writeTok(a_functionPrototypes, Tpl.ST_STRING("void "));
        a_functionPrototypes = Tpl.writeText(a_functionPrototypes, l_modelNamePrefixStr);
        a_functionPrototypes = Tpl.writeTok(a_functionPrototypes, Tpl.ST_STRING("_instantiate_samples(omsi_sample* sample_events);"));
        a_functionPrototypes = Tpl.writeTok(a_functionPrototypes, Tpl.ST_NEW_LINE());
        a_includes = Tpl.writeTok(a_includes, Tpl.ST_STRING("#include \""));
        a_includes = Tpl.writeStr(a_includes, i_fileNamePrefix);
        a_includes = Tpl.writeTok(a_includes, Tpl.ST_STRING("_sim_eqns.h\""));
        a_includes = Tpl.writeTok(a_includes, Tpl.ST_NEW_LINE());
        a_includes = Tpl.writeTok(a_includes, Tpl.ST_STRING("#include \""));
        a_includes = Tpl.writeStr(a_includes, i_fileNamePrefix);
        a_includes = Tpl.writeTok(a_includes, Tpl.ST_STRING("_init_eqns.h\""));
        a_includes = Tpl.writeTok(a_includes, Tpl.ST_NEW_LINE());
        a_includes = fun_47(a_includes, i_varInfo_numZeroCrossings);
        l_headerFileName = Tpl.writeStr(Tpl.emptyTxt, i_fileNamePrefix);
        l_headerFileName = Tpl.writeTok(l_headerFileName, Tpl.ST_STRING("_omsic"));
        (l_headerFileContent, a_includes, a_functionPrototypes) = CodegenOMSI_common.generateCodeHeader(Tpl.emptyTxt, Tpl.textString(l_modelNamePrefixStr), a_includes, Tpl.textString(l_headerFileName), a_functionPrototypes);
        txt_3 = Tpl.writeStr(Tpl.emptyTxt, i_fullPathPrefix);
        txt_3 = Tpl.writeTok(txt_3, Tpl.ST_STRING("/"));
        txt_3 = Tpl.writeText(txt_3, l_headerFileName);
        txt_3 = Tpl.writeTok(txt_3, Tpl.ST_STRING(".h"));
        Tpl.textFile(l_headerFileContent, Tpl.textString(txt_3));
        l_functionInitSampleCode = CodegenOMSI_common.functionInitSample(Tpl.emptyTxt, i_timeEvents, Tpl.textString(l_modelNamePrefixStr));
        txt = CodegenOMSI_common.insertCopyrightOpenModelica(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "#include \""
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_omsic.h\"\n",
                                    "\n",
                                    "/* Simulation code for "
                                }, false));
        txt = CodegenUtil.dotPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" generated by the OpenModelica Compiler "));
        ret_5 = Settings.getVersionNr();
        txt = Tpl.writeStr(txt, ret_5);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ". */\n",
                                    "/* Translated model "
                                }, false));
        txt = Tpl.writeText(txt, l_modelNamePrefixStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " to OMSIC */\n",
                                    "\n",
                                    "/* Set function pointers for initialization in global struct. */\n",
                                    "void initialize_start_function (omsi_template_callback_functions_t* callback) {\n",
                                    "\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("callback->initialize_initialization_problem = "));
        txt = Tpl.writeText(txt, l_modelNamePrefixStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_init_eqns_instantiate_allEqns_OMSIFunc;\n",
                                    "callback->initialize_simulation_problem = "
                                }, false));
        txt = Tpl.writeText(txt, l_modelNamePrefixStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_sim_eqns_instantiate_allEqns_OMSIFunc;\n",
                                    "\n",
                                    "callback->initialize_samples = "
                                }, false));
        txt = Tpl.writeText(txt, l_modelNamePrefixStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_instantiate_samples;\n",
                                    "\n",
                                    "callback->isSet = omsi_true;\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n"
                                }, true));
        txt = Tpl.writeText(txt, l_functionInitSampleCode);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then (txt, a_includes, a_functionPrototypes);

    case ( txt,
           _,
           a_includes,
           a_functionPrototypes )
      then (txt, a_includes, a_functionPrototypes);
  end match;
end fun_48;

public function generateOMSIC
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_includes;
  Tpl.Text l_functionPrototypes;
algorithm
  l_functionPrototypes := Tpl.emptyTxt;
  l_includes := Tpl.emptyTxt;
  (out_txt, l_includes, l_functionPrototypes) := fun_48(txt, a_simCode, l_includes, l_functionPrototypes);
end generateOMSIC;

protected function fun_50
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input Tpl.Text in_a_InitDerMatFiles;
  input String in_a_fileNamePrefix;
  input Tpl.Text in_a_InitAlgSystemFiles;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_InitDerMatFiles;
  output Tpl.Text out_a_InitAlgSystemFiles;
algorithm
  (out_txt, out_a_InitDerMatFiles, out_a_InitAlgSystemFiles) :=
  match(in_txt, in_a_eq, in_a_InitDerMatFiles, in_a_fileNamePrefix, in_a_InitAlgSystemFiles)
    local
      Tpl.Text txt;
      Tpl.Text a_InitDerMatFiles;
      String a_fileNamePrefix;
      Tpl.Text a_InitAlgSystemFiles;
      Integer i_system_algSysIndex;

    case ( txt,
           SimCode.SES_ALGEBRAIC_SYSTEM(matrix = NONE(), algSysIndex = i_system_algSysIndex),
           a_InitDerMatFiles,
           a_fileNamePrefix,
           a_InitAlgSystemFiles )
      equation
        a_InitAlgSystemFiles = Tpl.writeTok(a_InitAlgSystemFiles, Tpl.ST_STRING(" "));
        a_InitAlgSystemFiles = Tpl.writeStr(a_InitAlgSystemFiles, a_fileNamePrefix);
        a_InitAlgSystemFiles = Tpl.writeTok(a_InitAlgSystemFiles, Tpl.ST_STRING("_init_eqns_algSyst_"));
        a_InitAlgSystemFiles = Tpl.writeStr(a_InitAlgSystemFiles, intString(i_system_algSysIndex));
        a_InitAlgSystemFiles = Tpl.writeTok(a_InitAlgSystemFiles, Tpl.ST_STRING(".c"));
      then (txt, a_InitDerMatFiles, a_InitAlgSystemFiles);

    case ( txt,
           SimCode.SES_ALGEBRAIC_SYSTEM(algSysIndex = i_system_algSysIndex),
           a_InitDerMatFiles,
           a_fileNamePrefix,
           a_InitAlgSystemFiles )
      equation
        a_InitAlgSystemFiles = Tpl.writeTok(a_InitAlgSystemFiles, Tpl.ST_STRING(" "));
        a_InitAlgSystemFiles = Tpl.writeStr(a_InitAlgSystemFiles, a_fileNamePrefix);
        a_InitAlgSystemFiles = Tpl.writeTok(a_InitAlgSystemFiles, Tpl.ST_STRING("_init_eqns_algSyst_"));
        a_InitAlgSystemFiles = Tpl.writeStr(a_InitAlgSystemFiles, intString(i_system_algSysIndex));
        a_InitAlgSystemFiles = Tpl.writeTok(a_InitAlgSystemFiles, Tpl.ST_STRING(".c"));
        a_InitDerMatFiles = Tpl.writeTok(a_InitDerMatFiles, Tpl.ST_STRING(" "));
        a_InitDerMatFiles = Tpl.writeStr(a_InitDerMatFiles, a_fileNamePrefix);
        a_InitDerMatFiles = Tpl.writeTok(a_InitDerMatFiles, Tpl.ST_STRING("_init_eqns_derMat_"));
        a_InitDerMatFiles = Tpl.writeStr(a_InitDerMatFiles, intString(i_system_algSysIndex));
        a_InitDerMatFiles = Tpl.writeTok(a_InitDerMatFiles, Tpl.ST_STRING(".c"));
      then (txt, a_InitDerMatFiles, a_InitAlgSystemFiles);

    case ( txt,
           _,
           a_InitDerMatFiles,
           _,
           a_InitAlgSystemFiles )
      then (txt, a_InitDerMatFiles, a_InitAlgSystemFiles);
  end match;
end fun_50;

protected function lm_51
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input Tpl.Text in_a_InitDerMatFiles;
  input String in_a_fileNamePrefix;
  input Tpl.Text in_a_InitAlgSystemFiles;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_InitDerMatFiles;
  output Tpl.Text out_a_InitAlgSystemFiles;
algorithm
  (out_txt, out_a_InitDerMatFiles, out_a_InitAlgSystemFiles) :=
  match(in_txt, in_items, in_a_InitDerMatFiles, in_a_fileNamePrefix, in_a_InitAlgSystemFiles)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      Tpl.Text a_InitDerMatFiles;
      String a_fileNamePrefix;
      Tpl.Text a_InitAlgSystemFiles;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           {},
           a_InitDerMatFiles,
           _,
           a_InitAlgSystemFiles )
      then (txt, a_InitDerMatFiles, a_InitAlgSystemFiles);

    case ( txt,
           i_eq :: rest,
           a_InitDerMatFiles,
           a_fileNamePrefix,
           a_InitAlgSystemFiles )
      equation
        (txt, a_InitDerMatFiles, a_InitAlgSystemFiles) = fun_50(txt, i_eq, a_InitDerMatFiles, a_fileNamePrefix, a_InitAlgSystemFiles);
        (txt, a_InitDerMatFiles, a_InitAlgSystemFiles) = lm_51(txt, rest, a_InitDerMatFiles, a_fileNamePrefix, a_InitAlgSystemFiles);
      then (txt, a_InitDerMatFiles, a_InitAlgSystemFiles);
  end match;
end lm_51;

protected function fun_52
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input Tpl.Text in_a_SimDerMatFiles;
  input String in_a_fileNamePrefix;
  input Tpl.Text in_a_SimAlgSystemFiles;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_SimDerMatFiles;
  output Tpl.Text out_a_SimAlgSystemFiles;
algorithm
  (out_txt, out_a_SimDerMatFiles, out_a_SimAlgSystemFiles) :=
  match(in_txt, in_a_eq, in_a_SimDerMatFiles, in_a_fileNamePrefix, in_a_SimAlgSystemFiles)
    local
      Tpl.Text txt;
      Tpl.Text a_SimDerMatFiles;
      String a_fileNamePrefix;
      Tpl.Text a_SimAlgSystemFiles;
      Integer i_system_algSysIndex;

    case ( txt,
           SimCode.SES_ALGEBRAIC_SYSTEM(matrix = NONE(), algSysIndex = i_system_algSysIndex),
           a_SimDerMatFiles,
           a_fileNamePrefix,
           a_SimAlgSystemFiles )
      equation
        a_SimAlgSystemFiles = Tpl.writeTok(a_SimAlgSystemFiles, Tpl.ST_STRING(" "));
        a_SimAlgSystemFiles = Tpl.writeStr(a_SimAlgSystemFiles, a_fileNamePrefix);
        a_SimAlgSystemFiles = Tpl.writeTok(a_SimAlgSystemFiles, Tpl.ST_STRING("_sim_eqns_algSyst_"));
        a_SimAlgSystemFiles = Tpl.writeStr(a_SimAlgSystemFiles, intString(i_system_algSysIndex));
        a_SimAlgSystemFiles = Tpl.writeTok(a_SimAlgSystemFiles, Tpl.ST_STRING(".c"));
        a_SimDerMatFiles = Tpl.writeTok(a_SimDerMatFiles, Tpl.ST_STRING(" "));
        a_SimDerMatFiles = Tpl.writeStr(a_SimDerMatFiles, a_fileNamePrefix);
        a_SimDerMatFiles = Tpl.writeTok(a_SimDerMatFiles, Tpl.ST_STRING("_sim_eqns_derMat_"));
        a_SimDerMatFiles = Tpl.writeStr(a_SimDerMatFiles, intString(i_system_algSysIndex));
        a_SimDerMatFiles = Tpl.writeTok(a_SimDerMatFiles, Tpl.ST_STRING(".c"));
      then (txt, a_SimDerMatFiles, a_SimAlgSystemFiles);

    case ( txt,
           SimCode.SES_ALGEBRAIC_SYSTEM(algSysIndex = i_system_algSysIndex),
           a_SimDerMatFiles,
           a_fileNamePrefix,
           a_SimAlgSystemFiles )
      equation
        a_SimAlgSystemFiles = Tpl.writeTok(a_SimAlgSystemFiles, Tpl.ST_STRING(" "));
        a_SimAlgSystemFiles = Tpl.writeStr(a_SimAlgSystemFiles, a_fileNamePrefix);
        a_SimAlgSystemFiles = Tpl.writeTok(a_SimAlgSystemFiles, Tpl.ST_STRING("_sim_eqns_algSyst_"));
        a_SimAlgSystemFiles = Tpl.writeStr(a_SimAlgSystemFiles, intString(i_system_algSysIndex));
        a_SimAlgSystemFiles = Tpl.writeTok(a_SimAlgSystemFiles, Tpl.ST_STRING(".c"));
        a_SimDerMatFiles = Tpl.writeTok(a_SimDerMatFiles, Tpl.ST_STRING(" "));
        a_SimDerMatFiles = Tpl.writeStr(a_SimDerMatFiles, a_fileNamePrefix);
        a_SimDerMatFiles = Tpl.writeTok(a_SimDerMatFiles, Tpl.ST_STRING("_sim_eqns_derMat_"));
        a_SimDerMatFiles = Tpl.writeStr(a_SimDerMatFiles, intString(i_system_algSysIndex));
        a_SimDerMatFiles = Tpl.writeTok(a_SimDerMatFiles, Tpl.ST_STRING(".c"));
      then (txt, a_SimDerMatFiles, a_SimAlgSystemFiles);

    case ( txt,
           _,
           a_SimDerMatFiles,
           _,
           a_SimAlgSystemFiles )
      then (txt, a_SimDerMatFiles, a_SimAlgSystemFiles);
  end match;
end fun_52;

protected function lm_53
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input Tpl.Text in_a_SimDerMatFiles;
  input String in_a_fileNamePrefix;
  input Tpl.Text in_a_SimAlgSystemFiles;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_SimDerMatFiles;
  output Tpl.Text out_a_SimAlgSystemFiles;
algorithm
  (out_txt, out_a_SimDerMatFiles, out_a_SimAlgSystemFiles) :=
  match(in_txt, in_items, in_a_SimDerMatFiles, in_a_fileNamePrefix, in_a_SimAlgSystemFiles)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      Tpl.Text a_SimDerMatFiles;
      String a_fileNamePrefix;
      Tpl.Text a_SimAlgSystemFiles;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           {},
           a_SimDerMatFiles,
           _,
           a_SimAlgSystemFiles )
      then (txt, a_SimDerMatFiles, a_SimAlgSystemFiles);

    case ( txt,
           i_eq :: rest,
           a_SimDerMatFiles,
           a_fileNamePrefix,
           a_SimAlgSystemFiles )
      equation
        (txt, a_SimDerMatFiles, a_SimAlgSystemFiles) = fun_52(txt, i_eq, a_SimDerMatFiles, a_fileNamePrefix, a_SimAlgSystemFiles);
        (txt, a_SimDerMatFiles, a_SimAlgSystemFiles) = lm_53(txt, rest, a_SimDerMatFiles, a_fileNamePrefix, a_SimAlgSystemFiles);
      then (txt, a_SimDerMatFiles, a_SimAlgSystemFiles);
  end match;
end lm_53;

protected function fun_54
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_SimDerMatFiles;
  input Tpl.Text in_a_SimAlgSystemFiles;
  input Tpl.Text in_a_InitDerMatFiles;
  input Tpl.Text in_a_InitAlgSystemFiles;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_SimDerMatFiles;
  output Tpl.Text out_a_SimAlgSystemFiles;
  output Tpl.Text out_a_InitDerMatFiles;
  output Tpl.Text out_a_InitAlgSystemFiles;
algorithm
  (out_txt, out_a_SimDerMatFiles, out_a_SimAlgSystemFiles, out_a_InitDerMatFiles, out_a_InitAlgSystemFiles) :=
  match(in_txt, in_a_simCode, in_a_SimDerMatFiles, in_a_SimAlgSystemFiles, in_a_InitDerMatFiles, in_a_InitAlgSystemFiles)
    local
      Tpl.Text txt;
      Tpl.Text a_SimDerMatFiles;
      Tpl.Text a_SimAlgSystemFiles;
      Tpl.Text a_InitDerMatFiles;
      Tpl.Text a_InitAlgSystemFiles;
      list<SimCode.SimEqSystem> i_simulation_equations;
      String i_fileNamePrefix;
      list<SimCode.SimEqSystem> i_initialization_equations;
      Tpl.Text l_0___1;
      Tpl.Text l_0__;

    case ( txt,
           SimCode.SIMCODE(fileNamePrefix = i_fileNamePrefix, omsiData = SOME(SimCode.OMSI_DATA(simulation = SimCode.OMSI_FUNCTION(equations = i_simulation_equations), initialization = SimCode.OMSI_FUNCTION(equations = i_initialization_equations)))),
           a_SimDerMatFiles,
           a_SimAlgSystemFiles,
           a_InitDerMatFiles,
           a_InitAlgSystemFiles )
      equation
        (l_0__, a_InitDerMatFiles, a_InitAlgSystemFiles) = lm_51(Tpl.emptyTxt, i_initialization_equations, a_InitDerMatFiles, i_fileNamePrefix, a_InitAlgSystemFiles);
        (l_0___1, a_SimDerMatFiles, a_SimAlgSystemFiles) = lm_53(Tpl.emptyTxt, i_simulation_equations, a_SimDerMatFiles, i_fileNamePrefix, a_SimAlgSystemFiles);
      then (txt, a_SimDerMatFiles, a_SimAlgSystemFiles, a_InitDerMatFiles, a_InitAlgSystemFiles);

    case ( txt,
           _,
           a_SimDerMatFiles,
           a_SimAlgSystemFiles,
           a_InitDerMatFiles,
           a_InitAlgSystemFiles )
      then (txt, a_SimDerMatFiles, a_SimAlgSystemFiles, a_InitDerMatFiles, a_InitAlgSystemFiles);
  end match;
end fun_54;

protected function fun_55
  input Tpl.Text in_txt;
  input String in_a_makefileParams_platform;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_makefileParams_platform)
    local
      Tpl.Text txt;

    case ( txt,
           "win32" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\"mkdir.exe\""));
      then txt;

    case ( txt,
           "win64" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\"mkdir.exe\""));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("mkdir"));
      then txt;
  end match;
end fun_55;

protected function fun_56
  input Tpl.Text in_txt;
  input String in_a_makefileParams_platform;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_makefileParams_platform)
    local
      Tpl.Text txt;

    case ( txt,
           "win32" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("lib"));
      then txt;

    case ( txt,
           "win64" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("lib"));
      then txt;

    case ( txt,
           "linux64" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("lib/x86_64-linux-gnu"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("lib"));
      then txt;
  end match;
end fun_56;

protected function fun_57
  input Tpl.Text in_txt;
  input String in_a_makefileParams_platform;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_makefileParams_platform)
    local
      Tpl.Text txt;

    case ( txt,
           "win32" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("$(OMDEV)/tools/msys/mingw32/bin"));
      then txt;

    case ( txt,
           "win64" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("$(OMDEV)/tools/msys/mingw64/bin"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_57;

protected function fun_58
  input Tpl.Text in_txt;
  input String in_a_makefileParams_platform;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_makefileParams_platform)
    local
      Tpl.Text txt;

    case ( txt,
           "win32" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("dll"));
      then txt;

    case ( txt,
           "win64" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("dll"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("so"));
      then txt;
  end match;
end fun_58;

protected function fun_59
  input Tpl.Text in_txt;
  input String in_a_makefileParams_platform;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_makefileParams_platform)
    local
      Tpl.Text txt;

    case ( txt,
           "win32" )
      then txt;

    case ( txt,
           "win64" )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\"-Wl,-rpath,\\$$ORIGIN/.\""));
      then txt;
  end match;
end fun_59;

protected function fun_60
  input Tpl.Text in_txt;
  input String in_a_makefileParams_platform;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_makefileParams_platform)
    local
      Tpl.Text txt;

    case ( txt,
           "win32" )
      then txt;

    case ( txt,
           "win64" )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("*"));
      then txt;
  end match;
end fun_60;

protected function fun_61
  input Tpl.Text in_txt;
  input String in_a_makefileParams_platform;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_makefileParams_platform)
    local
      Tpl.Text txt;

    case ( txt,
           "win32" )
      then txt;

    case ( txt,
           "win64" )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-fPIC "));
      then txt;
  end match;
end fun_61;

protected function fun_62
  input Tpl.Text in_txt;
  input String in_a_makefileParams_platform;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_makefileParams_platform)
    local
      Tpl.Text txt;

    case ( txt,
           "win32" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("openblas"));
      then txt;

    case ( txt,
           "win64" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("openblas"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("lapack"));
      then txt;
  end match;
end fun_62;

protected function fun_63
  input Tpl.Text in_txt;
  input String in_a_makefileParams_platform;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_makefileParams_platform)
    local
      Tpl.Text txt;

    case ( txt,
           "win32" )
      then txt;

    case ( txt,
           "win64" )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("blas"));
      then txt;
  end match;
end fun_63;

protected function fun_64
  input Tpl.Text in_txt;
  input String in_a_makefileParams_platform;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_makefileParams_platform)
    local
      Tpl.Text txt;

    case ( txt,
           "win32" )
      then txt;

    case ( txt,
           "win64" )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-l$(BLAS_LIB)"));
      then txt;
  end match;
end fun_64;

protected function fun_65
  input Tpl.Text in_txt;
  input String in_a_makefileParams_platform;
  input Tpl.Text in_a_libEnding;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_makefileParams_platform, in_a_libEnding)
    local
      Tpl.Text txt;
      Tpl.Text a_libEnding;

    case ( txt,
           "win32",
           a_libEnding )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("$(LAPACK_LIBDIR)/lib$(LAPACK_LIB)."));
        txt = Tpl.writeText(txt, a_libEnding);
      then txt;

    case ( txt,
           "win64",
           a_libEnding )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("$(LAPACK_LIBDIR)/lib$(LAPACK_LIB)."));
        txt = Tpl.writeText(txt, a_libEnding);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_65;

protected function fun_66
  input Tpl.Text in_txt;
  input String in_mArg;
  input String in_a_fileNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_fileNamePrefix)
    local
      Tpl.Text txt;
      String a_fileNamePrefix;

    case ( txt,
           "omsicpp",
           a_fileNamePrefix )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("chmod +x ../"));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".sh"));
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_66;

protected function fun_67
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_fileNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_fileNamePrefix)
    local
      Tpl.Text txt;
      String a_fileNamePrefix;
      String ret_0;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_fileNamePrefix )
      equation
        ret_0 = Config.simCodeTarget();
        txt = fun_66(txt, ret_0, a_fileNamePrefix);
      then txt;
  end match;
end fun_67;

protected function fun_68
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_SimDerMatFiles;
  input Tpl.Text in_a_SimAlgSystemFiles;
  input Tpl.Text in_a_InitDerMatFiles;
  input Tpl.Text in_a_InitAlgSystemFiles;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode, in_a_SimDerMatFiles, in_a_SimAlgSystemFiles, in_a_InitDerMatFiles, in_a_InitAlgSystemFiles)
    local
      Tpl.Text txt;
      Tpl.Text a_SimDerMatFiles;
      Tpl.Text a_SimAlgSystemFiles;
      Tpl.Text a_InitDerMatFiles;
      Tpl.Text a_InitAlgSystemFiles;
      String i_makefileParams_dllext;
      String i_makefileParams_exeext;
      String i_fmuTargetName;
      String i_makefileParams_cxxcompiler;
      String i_makefileParams_ccompiler;
      String i_makefileParams_omhome;
      String i_makefileParams_platform;
      String i_fileNamePrefix;
      Boolean ret_11;
      Boolean ret_10;
      Boolean ret_9;
      Boolean ret_8;
      Tpl.Text l_fPIC;
      Tpl.Text l_star;
      Tpl.Text l_rpath;
      Tpl.Text l_libEnding;
      Tpl.Text l_lapackDirWin;
      Tpl.Text l_OMLibs;
      Tpl.Text l_mkdir;
      Tpl.Text l_includedir;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = _), makefileParams = SimCodeFunction.MAKEFILE_PARAMS(platform = i_makefileParams_platform, omhome = i_makefileParams_omhome, ccompiler = i_makefileParams_ccompiler, cxxcompiler = i_makefileParams_cxxcompiler, exeext = i_makefileParams_exeext, dllext = i_makefileParams_dllext), simulationSettingsOpt = _, fileNamePrefix = i_fileNamePrefix, fmuTargetName = i_fmuTargetName),
           a_SimDerMatFiles,
           a_SimAlgSystemFiles,
           a_InitDerMatFiles,
           a_InitAlgSystemFiles )
      equation
        l_includedir = Tpl.writeStr(Tpl.emptyTxt, i_fileNamePrefix);
        l_includedir = Tpl.writeTok(l_includedir, Tpl.ST_STRING(".fmutmp/sources/include/"));
        l_mkdir = fun_55(Tpl.emptyTxt, i_makefileParams_platform);
        l_OMLibs = fun_56(Tpl.emptyTxt, i_makefileParams_platform);
        l_lapackDirWin = fun_57(Tpl.emptyTxt, i_makefileParams_platform);
        l_libEnding = fun_58(Tpl.emptyTxt, i_makefileParams_platform);
        l_rpath = fun_59(Tpl.emptyTxt, i_makefileParams_platform);
        l_star = fun_60(Tpl.emptyTxt, i_makefileParams_platform);
        l_fPIC = fun_61(Tpl.emptyTxt, i_makefileParams_platform);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "# Makefile generated by OpenModelica\n",
                                    "OMHOME=\'"
                                }, false));
        txt = Tpl.writeStr(txt, i_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\'\n",
                                    "OMLIB=\'"
                                }, false));
        txt = Tpl.writeStr(txt, i_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/"));
        txt = Tpl.writeText(txt, l_OMLibs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\'\n",
                                    "\n",
                                    "CC="
                                }, false));
        txt = Tpl.writeStr(txt, i_makefileParams_ccompiler);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("CFLAGS= "));
        txt = Tpl.writeText(txt, l_fPIC);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "-Wall -Wextra -ansi -pedantic -g\n",
                                    "CXX="
                                }, false));
        txt = Tpl.writeStr(txt, i_makefileParams_cxxcompiler);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "LD=$(CC) -shared\n",
                                    "\n",
                                    "RUNTIMEPATH=.\n",
                                    "\n",
                                    "# Files\n",
                                    "MAINFILE="
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_omsic.c\n",
                                    "MAINOBJ="
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_omsic.o\n",
                                    "INIT_FILES="
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_init_eqns.c $(INIT_ALGLOOP_FILES) $(INIT_DERMAT_FILES)\n",
                                    "INIT_ALGLOOP_FILES="
                                }, false));
        txt = Tpl.writeText(txt, a_InitAlgSystemFiles);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("INIT_DERMAT_FILES="));
        txt = Tpl.writeText(txt, a_InitDerMatFiles);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("SIM_FILES="));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_sim_eqns.c $(SIM_ALGLOOP_FILES) $(SIM_DERMAT_FILES)\n",
                                    "SIM_ALGLOOP_FILES="
                                }, false));
        txt = Tpl.writeText(txt, a_SimAlgSystemFiles);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("SIM_DERMAT_FILES="));
        txt = Tpl.writeText(txt, a_SimDerMatFiles);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "CFILES=$(MAINFILE) $(INIT_FILES) $(SIM_FILES)\n",
                                    "OFILES=$(CFILES:.c=.o)\n",
                                    "HFILES=$(CFILES:.c=.h)\n",
                                    "\n",
                                    "RESOURCE_FILES="
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_info.json "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_init.xml\n",
                                    "\n",
                                    "GENERATEDFILES=$(MAINFILE) "
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_FMU.makefile # ...\n",
                                    "\n",
                                    "# Includes\n",
                                    "INCLUDE_DIR_OMSI=$(OMHOME)/include/omc/omsi\n",
                                    "INCLUDE_DIR_OMSI_BASE=$(OMHOME)/include/omc/omsi/base\n",
                                    "INCLUDE_DIR_OMSI_SOLVER=$(OMHOME)/include/omc/omsi/solver\n",
                                    "INCLUDE_DIR_OMSI_FMI2=$(OMHOME)/include/omc/omsi/fmi2\n",
                                    "INCLUDE_DIR_OMSIC=$(OMHOME)/include/omc/omsic\n",
                                    "INCLUDE_DIR_OMSIC_FMI2=$(OMHOME)/include/omc/omsic/fmi2\n",
                                    "\n",
                                    "# Libraries\n",
                                    "EXPAT_LIBDIR=$(OMLIB)/omc/omsi\n",
                                    "EXPAT_LIB=expat\n",
                                    "\n",
                                    "LAPACK_LIBDIR="
                                }, false));
        txt = Tpl.writeText(txt, l_lapackDirWin);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("LAPACK_LIB="));
        txt = fun_62(txt, i_makefileParams_platform);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("BLAS_LIB="));
        txt = fun_63(txt, i_makefileParams_platform);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "KINSOL_LIBDIR=$(OMLIB)/omc\n",
                                    "KINSOL_LIB=sundials_kinsol\n",
                                    "SUNDIALS_NVECSERIAL=sundials_nvecserial\n",
                                    "\n",
                                    "OMSU_STATIC_LIB=-Wl,--whole-archive -lOMSISolver_static -lOMSIBase_static -lOMSIC_static -Wl,--no-whole-archive\n",
                                    "OMSU_STATIC_LIBDIR=-L$(OMLIB)/omc/omsi\n",
                                    "LIBS = $(OMSU_STATIC_LIB) -Wl,-Bdynamic -l$(EXPAT_LIB) -l$(LAPACK_LIB) "
                                }, false));
        txt = fun_64(txt, i_makefileParams_platform);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" $(KINSOL_LIBDIR)/lib$(KINSOL_LIB)."));
        txt = Tpl.writeText(txt, l_libEnding);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" $(KINSOL_LIBDIR)/lib$(SUNDIALS_NVECSERIAL)."));
        txt = Tpl.writeText(txt, l_libEnding);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "LIBSDIR= $(OMSU_STATIC_LIBDIR) -L$(EXPAT_LIBDIR) -L$(LAPACK_LIBDIR) -L$(KINSOL_LIBDIR)\n",
                                    "\n",
                                    "THIRD_PARTY_DYNAMIC_LIBS ="
                                }, false));
        txt = fun_65(txt, i_makefileParams_platform, l_libEnding);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("       \\\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("$(KINSOL_LIBDIR)/lib$(KINSOL_LIB)."));
        txt = Tpl.writeText(txt, l_libEnding);
        txt = Tpl.writeText(txt, l_star);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "                                \\\n",
                                    "$(KINSOL_LIBDIR)/lib$(SUNDIALS_NVECSERIAL)."
                                }, false));
        txt = Tpl.writeText(txt, l_libEnding);
        txt = Tpl.writeText(txt, l_star);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "                       \\\n",
                                    "\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ".PHONY: copyFiles makeStructure compile fmiImport OMSimulation clean\n",
                                    "\n",
                                    "all: "
                                }, false));
        txt = Tpl.writeStr(txt, i_fmuTargetName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ".fmu\n",
                                    "\n"
                                }, true));
        txt = Tpl.writeStr(txt, i_fmuTargetName);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(".fmu: compile\n"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("cd "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(".fmutmp; \\\n"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("zip"));
        txt = Tpl.writeStr(txt, i_makefileParams_exeext);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" -r ../../"));
        txt = Tpl.writeStr(txt, i_fmuTargetName);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(".fmu *;\\\n"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("cd ..;\\\n"));
        ret_8 = stringEq(i_makefileParams_platform, "win32");
        ret_9 = stringEq(i_makefileParams_platform, "win64");
        ret_10 = boolOr(ret_8, ret_9);
        ret_11 = boolNot(ret_10);
        txt = fun_67(txt, ret_11, i_fileNamePrefix);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "\n",
                                    "copyFiles: makeStructure\n"
                                }, true));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("# Basic OMSI and OMSIC files\n"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("cp -a $(OMHOME)/include/omc/omsi/* "));
        txt = Tpl.writeText(txt, l_includedir);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("cp -a $(OMHOME)/include/omc/omsic/* "));
        txt = Tpl.writeText(txt, l_includedir);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("cp -a $(OMLIB)/omc/omsi/libOMSIBase_static.* "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(".fmutmp/sources/libs\n"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("cp -a $(OMLIB)/omc/omsi/libOMSIC_static.* "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(".fmutmp/sources/libs\n"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("cp -a $(OMLIB)/omc/omsi/libOMSISolver_static.* "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(".fmutmp/sources/libs\n"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("# Third party libraries\n"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("cp -f $(EXPAT_LIBDIR)/lib$(EXPAT_LIB).* "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(".fmutmp/sources/libs\n"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("cp -fP $(THIRD_PARTY_DYNAMIC_LIBS) "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".fmutmp/binaries/"));
        txt = Tpl.writeStr(txt, i_makefileParams_platform);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("cp -a modelDescription.xml "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(".fmutmp/\n"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("cp -a $(CFILES) "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(".fmutmp/sources/\n"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("cp -a $(HFILES) "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(".fmutmp/sources/include\n"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("cp -a "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_info.json "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(".fmutmp/resources/\n"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("cp -a "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_init.xml "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ".fmutmp/resources/\n",
                                    "\n",
                                    "makeStructure:\n"
                                }, true));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeText(txt, l_mkdir);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" -p "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".fmutmp/sources "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".fmutmp/sources/include "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(".fmutmp/sources/libs\n"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeText(txt, l_mkdir);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" -p "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(".fmutmp/resources\n"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeText(txt, l_mkdir);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" -p "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".fmutmp/binaries/"));
        txt = Tpl.writeStr(txt, i_makefileParams_platform);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "compile: $(OFILES) copyFiles\n"
                                }, true));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("$(LD) -o "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeStr(txt, i_makefileParams_dllext);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" $(OFILES) $(LIBSDIR) $(LIBS) "));
        txt = Tpl.writeText(txt, l_rpath);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("cp -a "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeStr(txt, i_makefileParams_dllext);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".fmutmp/binaries/"));
        txt = Tpl.writeStr(txt, i_makefileParams_platform);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "/\n",
                                    "\n",
                                    "%.o : %.c copyFiles\n"
                                }, true));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "$(CC) $(CFLAGS) -I$(INCLUDE_DIR_OMSI)  -I$(INCLUDE_DIR_OMSI_BASE) -I$(INCLUDE_DIR_OMSI_SOLVER) -I$(INCLUDE_DIR_OMSI_FMI2) -I$(INCLUDE_DIR_OMSIC) -I$(INCLUDE_DIR_OMSIC_FMI2) -c $<\n",
                                    "\n",
                                    "fmiImport:\n"
                                }, true));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("cd ..; omc "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".fmutmp/"));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_fmiImport.mos\n"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("cd ..; mv "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_me_FMU "));
        txt = Tpl.writeStr(txt, i_fmuTargetName);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "OMSimulation:\n"
                                }, true));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("cd ..; @echo \"#!/bin/bash\\nOMSimulator "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".lua\" > "));
        txt = Tpl.writeStr(txt, i_fmuTargetName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("; chmod +x "));
        txt = Tpl.writeStr(txt, i_fmuTargetName);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "clean:\n"
                                }, true));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("rm -f "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeStr(txt, i_makefileParams_dllext);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("rm -f $(OFILES)\n"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("rm -Rf helloWorld.fmutmp\n"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("rm -f "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_FMU.libs "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_FMU.log\n",
                                    "\n",
                                    "purge: clean\n"
                                }, true));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("rm -f $(CFILES)\n"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("rm -f $(HFILES)\n"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("rm -f modelDescription.xml $(RESOURCE_FILES)\n"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("rm -f "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_FMU.makefile\n",
                                    "\n",
                                    "distclean:\n"
                                }, true));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("rm -f -R "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ".fmutmp\n",
                                    "\n"
                                }, true));
      then txt;

    case ( txt,
           _,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_68;

public function createMakefile
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input String a_target;
  input String a_makeflieName;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_0__;
  Tpl.Text l_SimDerMatFiles;
  Tpl.Text l_SimAlgSystemFiles;
  Tpl.Text l_InitDerMatFiles;
  Tpl.Text l_InitAlgSystemFiles;
  Tpl.Text l_FMUVersion;
algorithm
  l_FMUVersion := Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("2.0"));
  l_InitAlgSystemFiles := Tpl.emptyTxt;
  l_InitDerMatFiles := Tpl.emptyTxt;
  l_SimAlgSystemFiles := Tpl.emptyTxt;
  l_SimDerMatFiles := Tpl.emptyTxt;
  (l_0__, l_SimDerMatFiles, l_SimAlgSystemFiles, l_InitDerMatFiles, l_InitAlgSystemFiles) := fun_54(Tpl.emptyTxt, a_simCode, l_SimDerMatFiles, l_SimAlgSystemFiles, l_InitDerMatFiles, l_InitAlgSystemFiles);
  out_txt := fun_68(txt, a_simCode, l_SimDerMatFiles, l_SimAlgSystemFiles, l_InitDerMatFiles, l_InitAlgSystemFiles);
end createMakefile;

protected function fun_70
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input Tpl.Text in_a_InitDerMatFiles;
  input String in_a_FileNamePrefix;
  input Tpl.Text in_a_InitAlgSystemFiles;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_InitDerMatFiles;
  output Tpl.Text out_a_InitAlgSystemFiles;
algorithm
  (out_txt, out_a_InitDerMatFiles, out_a_InitAlgSystemFiles) :=
  match(in_txt, in_a_eq, in_a_InitDerMatFiles, in_a_FileNamePrefix, in_a_InitAlgSystemFiles)
    local
      Tpl.Text txt;
      Tpl.Text a_InitDerMatFiles;
      String a_FileNamePrefix;
      Tpl.Text a_InitAlgSystemFiles;
      Integer i_system_algSysIndex;

    case ( txt,
           SimCode.SES_ALGEBRAIC_SYSTEM(algSysIndex = i_system_algSysIndex),
           a_InitDerMatFiles,
           a_FileNamePrefix,
           a_InitAlgSystemFiles )
      equation
        a_InitAlgSystemFiles = Tpl.writeTok(a_InitAlgSystemFiles, Tpl.ST_STRING(" "));
        a_InitAlgSystemFiles = Tpl.writeStr(a_InitAlgSystemFiles, a_FileNamePrefix);
        a_InitAlgSystemFiles = Tpl.writeTok(a_InitAlgSystemFiles, Tpl.ST_STRING("_init_eqns_algSyst_"));
        a_InitAlgSystemFiles = Tpl.writeStr(a_InitAlgSystemFiles, intString(i_system_algSysIndex));
        a_InitAlgSystemFiles = Tpl.writeTok(a_InitAlgSystemFiles, Tpl.ST_STRING(".c"));
        a_InitDerMatFiles = Tpl.writeTok(a_InitDerMatFiles, Tpl.ST_STRING(" "));
        a_InitDerMatFiles = Tpl.writeStr(a_InitDerMatFiles, a_FileNamePrefix);
        a_InitDerMatFiles = Tpl.writeTok(a_InitDerMatFiles, Tpl.ST_STRING("_init_eqns_derMat_"));
        a_InitDerMatFiles = Tpl.writeStr(a_InitDerMatFiles, intString(i_system_algSysIndex));
        a_InitDerMatFiles = Tpl.writeTok(a_InitDerMatFiles, Tpl.ST_STRING(".c"));
      then (txt, a_InitDerMatFiles, a_InitAlgSystemFiles);

    case ( txt,
           _,
           a_InitDerMatFiles,
           _,
           a_InitAlgSystemFiles )
      then (txt, a_InitDerMatFiles, a_InitAlgSystemFiles);
  end match;
end fun_70;

protected function lm_71
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input Tpl.Text in_a_InitDerMatFiles;
  input String in_a_FileNamePrefix;
  input Tpl.Text in_a_InitAlgSystemFiles;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_InitDerMatFiles;
  output Tpl.Text out_a_InitAlgSystemFiles;
algorithm
  (out_txt, out_a_InitDerMatFiles, out_a_InitAlgSystemFiles) :=
  match(in_txt, in_items, in_a_InitDerMatFiles, in_a_FileNamePrefix, in_a_InitAlgSystemFiles)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      Tpl.Text a_InitDerMatFiles;
      String a_FileNamePrefix;
      Tpl.Text a_InitAlgSystemFiles;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           {},
           a_InitDerMatFiles,
           _,
           a_InitAlgSystemFiles )
      then (txt, a_InitDerMatFiles, a_InitAlgSystemFiles);

    case ( txt,
           i_eq :: rest,
           a_InitDerMatFiles,
           a_FileNamePrefix,
           a_InitAlgSystemFiles )
      equation
        (txt, a_InitDerMatFiles, a_InitAlgSystemFiles) = fun_70(txt, i_eq, a_InitDerMatFiles, a_FileNamePrefix, a_InitAlgSystemFiles);
        (txt, a_InitDerMatFiles, a_InitAlgSystemFiles) = lm_71(txt, rest, a_InitDerMatFiles, a_FileNamePrefix, a_InitAlgSystemFiles);
      then (txt, a_InitDerMatFiles, a_InitAlgSystemFiles);
  end match;
end lm_71;

protected function fun_72
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input Tpl.Text in_a_SimDerMatFiles;
  input String in_a_FileNamePrefix;
  input Tpl.Text in_a_SimAlgSystemFiles;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_SimDerMatFiles;
  output Tpl.Text out_a_SimAlgSystemFiles;
algorithm
  (out_txt, out_a_SimDerMatFiles, out_a_SimAlgSystemFiles) :=
  match(in_txt, in_a_eq, in_a_SimDerMatFiles, in_a_FileNamePrefix, in_a_SimAlgSystemFiles)
    local
      Tpl.Text txt;
      Tpl.Text a_SimDerMatFiles;
      String a_FileNamePrefix;
      Tpl.Text a_SimAlgSystemFiles;
      Integer i_system_algSysIndex;

    case ( txt,
           SimCode.SES_ALGEBRAIC_SYSTEM(algSysIndex = i_system_algSysIndex),
           a_SimDerMatFiles,
           a_FileNamePrefix,
           a_SimAlgSystemFiles )
      equation
        a_SimAlgSystemFiles = Tpl.writeTok(a_SimAlgSystemFiles, Tpl.ST_STRING(" "));
        a_SimAlgSystemFiles = Tpl.writeStr(a_SimAlgSystemFiles, a_FileNamePrefix);
        a_SimAlgSystemFiles = Tpl.writeTok(a_SimAlgSystemFiles, Tpl.ST_STRING("_sim_eqns_algSyst_"));
        a_SimAlgSystemFiles = Tpl.writeStr(a_SimAlgSystemFiles, intString(i_system_algSysIndex));
        a_SimAlgSystemFiles = Tpl.writeTok(a_SimAlgSystemFiles, Tpl.ST_STRING(".c"));
        a_SimDerMatFiles = Tpl.writeTok(a_SimDerMatFiles, Tpl.ST_STRING(" "));
        a_SimDerMatFiles = Tpl.writeStr(a_SimDerMatFiles, a_FileNamePrefix);
        a_SimDerMatFiles = Tpl.writeTok(a_SimDerMatFiles, Tpl.ST_STRING("_sim_eqns_derMat_"));
        a_SimDerMatFiles = Tpl.writeStr(a_SimDerMatFiles, intString(i_system_algSysIndex));
        a_SimDerMatFiles = Tpl.writeTok(a_SimDerMatFiles, Tpl.ST_STRING(".c"));
      then (txt, a_SimDerMatFiles, a_SimAlgSystemFiles);

    case ( txt,
           _,
           a_SimDerMatFiles,
           _,
           a_SimAlgSystemFiles )
      then (txt, a_SimDerMatFiles, a_SimAlgSystemFiles);
  end match;
end fun_72;

protected function lm_73
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input Tpl.Text in_a_SimDerMatFiles;
  input String in_a_FileNamePrefix;
  input Tpl.Text in_a_SimAlgSystemFiles;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_SimDerMatFiles;
  output Tpl.Text out_a_SimAlgSystemFiles;
algorithm
  (out_txt, out_a_SimDerMatFiles, out_a_SimAlgSystemFiles) :=
  match(in_txt, in_items, in_a_SimDerMatFiles, in_a_FileNamePrefix, in_a_SimAlgSystemFiles)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      Tpl.Text a_SimDerMatFiles;
      String a_FileNamePrefix;
      Tpl.Text a_SimAlgSystemFiles;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           {},
           a_SimDerMatFiles,
           _,
           a_SimAlgSystemFiles )
      then (txt, a_SimDerMatFiles, a_SimAlgSystemFiles);

    case ( txt,
           i_eq :: rest,
           a_SimDerMatFiles,
           a_FileNamePrefix,
           a_SimAlgSystemFiles )
      equation
        (txt, a_SimDerMatFiles, a_SimAlgSystemFiles) = fun_72(txt, i_eq, a_SimDerMatFiles, a_FileNamePrefix, a_SimAlgSystemFiles);
        (txt, a_SimDerMatFiles, a_SimAlgSystemFiles) = lm_73(txt, rest, a_SimDerMatFiles, a_FileNamePrefix, a_SimAlgSystemFiles);
      then (txt, a_SimDerMatFiles, a_SimAlgSystemFiles);
  end match;
end lm_73;

protected function fun_74
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_SimDerMatFiles;
  input Tpl.Text in_a_SimAlgSystemFiles;
  input Tpl.Text in_a_InitDerMatFiles;
  input String in_a_FileNamePrefix;
  input Tpl.Text in_a_InitAlgSystemFiles;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_SimDerMatFiles;
  output Tpl.Text out_a_SimAlgSystemFiles;
  output Tpl.Text out_a_InitDerMatFiles;
  output Tpl.Text out_a_InitAlgSystemFiles;
algorithm
  (out_txt, out_a_SimDerMatFiles, out_a_SimAlgSystemFiles, out_a_InitDerMatFiles, out_a_InitAlgSystemFiles) :=
  match(in_txt, in_a_simCode, in_a_SimDerMatFiles, in_a_SimAlgSystemFiles, in_a_InitDerMatFiles, in_a_FileNamePrefix, in_a_InitAlgSystemFiles)
    local
      Tpl.Text txt;
      Tpl.Text a_SimDerMatFiles;
      Tpl.Text a_SimAlgSystemFiles;
      Tpl.Text a_InitDerMatFiles;
      String a_FileNamePrefix;
      Tpl.Text a_InitAlgSystemFiles;
      list<SimCode.SimEqSystem> i_simulation_equations;
      list<SimCode.SimEqSystem> i_initialization_equations;
      Tpl.Text l_0___1;
      Tpl.Text l_0__;

    case ( txt,
           SimCode.SIMCODE(omsiData = SOME(SimCode.OMSI_DATA(simulation = SimCode.OMSI_FUNCTION(equations = i_simulation_equations), initialization = SimCode.OMSI_FUNCTION(equations = i_initialization_equations)))),
           a_SimDerMatFiles,
           a_SimAlgSystemFiles,
           a_InitDerMatFiles,
           a_FileNamePrefix,
           a_InitAlgSystemFiles )
      equation
        (l_0__, a_InitDerMatFiles, a_InitAlgSystemFiles) = lm_71(Tpl.emptyTxt, i_initialization_equations, a_InitDerMatFiles, a_FileNamePrefix, a_InitAlgSystemFiles);
        (l_0___1, a_SimDerMatFiles, a_SimAlgSystemFiles) = lm_73(Tpl.emptyTxt, i_simulation_equations, a_SimDerMatFiles, a_FileNamePrefix, a_SimAlgSystemFiles);
      then (txt, a_SimDerMatFiles, a_SimAlgSystemFiles, a_InitDerMatFiles, a_InitAlgSystemFiles);

    case ( txt,
           _,
           a_SimDerMatFiles,
           a_SimAlgSystemFiles,
           a_InitDerMatFiles,
           _,
           a_InitAlgSystemFiles )
      then (txt, a_SimDerMatFiles, a_SimAlgSystemFiles, a_InitDerMatFiles, a_InitAlgSystemFiles);
  end match;
end fun_74;

protected function fun_75
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_SimDerMatFiles;
  input Tpl.Text in_a_SimAlgSystemFiles;
  input Tpl.Text in_a_InitDerMatFiles;
  input Tpl.Text in_a_InitAlgSystemFiles;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode, in_a_SimDerMatFiles, in_a_SimAlgSystemFiles, in_a_InitDerMatFiles, in_a_InitAlgSystemFiles)
    local
      Tpl.Text txt;
      Tpl.Text a_SimDerMatFiles;
      Tpl.Text a_SimAlgSystemFiles;
      Tpl.Text a_InitDerMatFiles;
      Tpl.Text a_InitAlgSystemFiles;
      String i_makefileParams_omhome;
      String i_fileNamePrefix;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = _), makefileParams = SimCodeFunction.MAKEFILE_PARAMS(omhome = i_makefileParams_omhome), simulationSettingsOpt = _, fileNamePrefix = i_fileNamePrefix),
           a_SimDerMatFiles,
           a_SimAlgSystemFiles,
           a_InitDerMatFiles,
           a_InitAlgSystemFiles )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("MAINFILE="));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_omsic.c\n",
                                    "MAINOBJ="
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_omsic.o\n",
                                    "INIT_FILES="
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_init_eqns.c $(INIT_ALGLOOP_FILES) $(INIT_DERMAT_FILES)\n",
                                    "INIT_ALGLOOP_FILES="
                                }, false));
        txt = Tpl.writeText(txt, a_InitAlgSystemFiles);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("INIT_DERMAT_FILES="));
        txt = Tpl.writeText(txt, a_InitDerMatFiles);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("SIM_FILES="));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_sim_eqns.c $(SIM_ALGLOOP_FILES) $(SIM_DERMAT_FILES)\n",
                                    "SIM_ALGLOOP_FILES="
                                }, false));
        txt = Tpl.writeText(txt, a_SimAlgSystemFiles);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("SIM_DERMAT_FILES="));
        txt = Tpl.writeText(txt, a_SimDerMatFiles);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "CFILES= $(INIT_FILES) $(SIM_FILES)\n",
                                    "OFILES=$(CFILES:.c=.o)\n",
                                    "GENERATEDFILES=$(MAINFILE) "
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_FMU.makefile # ...\n",
                                    "\n",
                                    "# FIXME: before you push into master...\n",
                                    "RUNTIMEDIR="
                                }, false));
        txt = Tpl.writeStr(txt, i_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "/include/omc/omsic/\n",
                                    "OMC_MINIMAL_RUNTIME=1\n",
                                    "OMC_FMI_RUNTIME=1\n",
                                    "# include $(RUNTIMEDIR)/Makefile.objs\n",
                                    "ifneq ($(NEED_RUNTIME),)\n",
                                    "RUNTIMEFILES=$(FMI_ME_OBJS:%=$(RUNTIMEDIR)/%.o)\n",
                                    "endif"
                                }, false));
      then txt;

    case ( txt,
           _,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_75;

protected function fun_76
  input Tpl.Text in_txt;
  input String in_a_modelInfo_directory;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo_directory)
    local
      Tpl.Text txt;
      String i_modelInfo_directory;

    case ( txt,
           "" )
      then txt;

    case ( txt,
           i_modelInfo_directory )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/LIBPATH:\""));
        txt = Tpl.writeStr(txt, i_modelInfo_directory);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
      then txt;
  end match;
end fun_76;

protected function lm_77
  input Tpl.Text in_txt;
  input list<String> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<String> rest;
      String i_lib;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_lib :: rest )
      equation
        txt = Tpl.writeStr(txt, i_lib);
        txt = Tpl.nextIter(txt);
        txt = lm_77(txt, rest);
      then txt;
  end match;
end lm_77;

protected function fun_78
  input Tpl.Text in_txt;
  input Tpl.Text in_a_dirExtra;
  input Tpl.Text in_a_libsStr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_dirExtra, in_a_libsStr)
    local
      Tpl.Text txt;
      Tpl.Text a_libsStr;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           a_libsStr )
      equation
        txt = Tpl.writeText(txt, a_libsStr);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_78;

protected function fun_79
  input Tpl.Text in_txt;
  input Tpl.Text in_a_dirExtra;
  input Tpl.Text in_a_libsStr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_dirExtra, in_a_libsStr)
    local
      Tpl.Text txt;
      Tpl.Text a_libsStr;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           _ )
      then txt;

    case ( txt,
           _,
           a_libsStr )
      equation
        txt = Tpl.writeText(txt, a_libsStr);
      then txt;
  end match;
end fun_79;

protected function fun_80
  input Tpl.Text in_txt;
  input String in_a_s_method;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_s_method)
    local
      Tpl.Text txt;

    case ( txt,
           "inline-euler" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-D_OMC_INLINE_EULER"));
      then txt;

    case ( txt,
           "inline-rungekutta" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-D_OMC_INLINE_RK"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_80;

protected function fun_81
  input Tpl.Text in_txt;
  input Option<SimCode.SimulationSettings> in_a_sopt;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_sopt)
    local
      Tpl.Text txt;
      String i_s_method;

    case ( txt,
           SOME(SimCode.SIMULATION_SETTINGS(method = i_s_method)) )
      equation
        txt = fun_80(txt, i_s_method);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_81;

protected function fun_82
  input Tpl.Text in_txt;
  input String in_a_makefileParams_platform;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_makefileParams_platform)
    local
      Tpl.Text txt;

    case ( txt,
           "win32" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\"mkdir.exe\""));
      then txt;

    case ( txt,
           "win64" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\"mkdir.exe\""));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("mkdir"));
      then txt;
  end match;
end fun_82;

protected function fun_83
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_makefileParams_omhome;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_makefileParams_omhome)
    local
      Tpl.Text txt;
      String a_makefileParams_omhome;

    case ( txt,
           false,
           a_makefileParams_omhome )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/I\""));
        txt = Tpl.writeStr(txt, a_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/include/omc/c/fmi1\""));
      then txt;

    case ( txt,
           _,
           a_makefileParams_omhome )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/I\""));
        txt = Tpl.writeStr(txt, a_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/include/omc/c/fmi2\""));
      then txt;
  end match;
end fun_83;

protected function fun_84
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/DFMU_EXPERIMENTAL"));
      then txt;
  end match;
end fun_84;

protected function fun_85
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_common;
  input Tpl.Text in_a_FMUVersion;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode, in_a_common, in_a_FMUVersion)
    local
      Tpl.Text txt;
      Tpl.Text a_common;
      Tpl.Text a_FMUVersion;
      String i_makefileParams_omhome;
      String i_fmuTargetName;
      String i_makefileParams_platform;
      SimCode.SimCode i_simCode;
      Option<SimCode.SimulationSettings> i_sopt;
      String i_fileNamePrefix;
      list<String> i_makefileParams_libs;
      String i_modelInfo_directory;
      String ret_14;
      String ret_13;
      String ret_12;
      String ret_11;
      Boolean ret_10;
      Boolean ret_9;
      Tpl.Text l_mkdir;
      Tpl.Text txt_7;
      Tpl.Text l_compilecmds;
      Tpl.Text l_extraCflags;
      Tpl.Text l_fmudirname;
      Tpl.Text l_libsPos2;
      Tpl.Text l_libsPos1;
      Tpl.Text l_libsStr;
      Tpl.Text l_dirExtra;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(directory = i_modelInfo_directory), makefileParams = SimCodeFunction.MAKEFILE_PARAMS(libs = i_makefileParams_libs, platform = i_makefileParams_platform, omhome = i_makefileParams_omhome), simulationSettingsOpt = i_sopt, fileNamePrefix = i_fileNamePrefix, fmuTargetName = i_fmuTargetName)),
           a_common,
           a_FMUVersion )
      equation
        l_dirExtra = fun_76(Tpl.emptyTxt, i_modelInfo_directory);
        l_libsStr = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(" ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_libsStr = lm_77(l_libsStr, i_makefileParams_libs);
        l_libsStr = Tpl.popIter(l_libsStr);
        l_libsPos1 = fun_78(Tpl.emptyTxt, l_dirExtra, l_libsStr);
        l_libsPos2 = fun_79(Tpl.emptyTxt, l_dirExtra, l_libsStr);
        l_fmudirname = Tpl.writeStr(Tpl.emptyTxt, i_fileNamePrefix);
        l_fmudirname = Tpl.writeTok(l_fmudirname, Tpl.ST_STRING(".fmutmp"));
        l_extraCflags = fun_81(Tpl.emptyTxt, i_sopt);
        txt_7 = CodegenUtilSimulation.modelNamePrefix(Tpl.emptyTxt, i_simCode);
        l_compilecmds = CodegenFMU.getPlatformString2(Tpl.emptyTxt, Tpl.textString(txt_7), i_makefileParams_platform, i_fileNamePrefix, i_fmuTargetName, Tpl.textString(l_dirExtra), Tpl.textString(l_libsPos1), Tpl.textString(l_libsPos2), i_makefileParams_omhome, Tpl.textString(a_FMUVersion));
        l_mkdir = fun_82(Tpl.emptyTxt, i_makefileParams_platform);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "# Makefile generated by OpenModelica\n",
                                    "\n",
                                    "# Simulations use -O3 by default\n",
                                    "SIM_OR_DYNLOAD_OPT_LEVEL=\n",
                                    "MODELICAUSERCFLAGS=\n",
                                    "CXX=cl\n",
                                    "EXEEXT=.exe\n",
                                    "DLLEXT=.dll\n",
                                    "FMUEXT=.fmu\n",
                                    "PLATWIN32 = win32\n",
                                    "\n",
                                    "# /Od - Optimization disabled\n",
                                    "# /EHa enable C++ EH (w/ SEH exceptions)\n",
                                    "# /fp:except - consider floating-point exceptions when generating code\n",
                                    "# /arch:SSE2 - enable use of instructions available with SSE2 enabled CPUs\n",
                                    "# /I - Include Directories\n",
                                    "# /DNOMINMAX - Define NOMINMAX (does what it says)\n",
                                    "# /TP - Use C++ Compiler\n",
                                    "CFLAGS=/MP /Od /ZI /EHa /fp:except /I\""
                                }, false));
        txt = Tpl.writeStr(txt, i_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/include/omc/c\" /I\""));
        txt = Tpl.writeStr(txt, i_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/include/omc/msvc/\" "));
        ret_9 = FMI.isFMIVersion20(Tpl.textString(a_FMUVersion));
        txt = fun_83(txt, ret_9, i_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" /I. /DNOMINMAX /TP /DNO_INTERACTIVE_DEPENDENCY  "));
        ret_10 = Flags.isSet(Flags.FMU_EXPERIMENTAL);
        txt = fun_84(txt, ret_10);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "# /ZI enable Edit and Continue debug info\n",
                                    "CDFLAGS=/ZI\n",
                                    "\n",
                                    "# /MD - link with MSVCRT.LIB\n",
                                    "# /link - [linker options and libraries]\n",
                                    "# /LIBPATH: - Directories where libs can be found\n",
                                    "LDFLAGS=/MD /link /dll /debug /pdb:\""
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".pdb\" /LIBPATH:\""));
        txt = Tpl.writeStr(txt, i_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/lib/omc/msvc/\" /LIBPATH:\""));
        txt = Tpl.writeStr(txt, i_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/lib/omc/msvc/release/\" "));
        txt = Tpl.writeText(txt, l_dirExtra);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, l_libsPos1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, l_libsPos2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " f2c.lib initialization.lib libexpat.lib math-support.lib meta.lib results.lib simulation.lib solver.lib sundials_kinsol.lib sundials_nvecserial.lib util.lib lapack_win32_MT.lib lis.lib  omcgc.lib user32.lib pthreadVC2.lib wsock32.lib cminpack.lib umfpack.lib amd.lib\n",
                                    "\n",
                                    "# /MDd link with MSVCRTD.LIB debug lib\n",
                                    "# lib names should not be appended with a d just switch to lib/omc/msvc/debug\n",
                                    "\n",
                                    "\n"
                                }, true));
        txt = Tpl.writeText(txt, a_common);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("$(FMUEXT): "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("$(DLLEXT) modelDescription.xml\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if not exist "));
        txt = Tpl.writeText(txt, l_fmudirname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\\binaries\\$(PLATWIN32) "));
        txt = Tpl.writeText(txt, l_mkdir);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, l_fmudirname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\\binaries\\$(PLATWIN32)\n",
                                    "if not exist "
                                }, false));
        txt = Tpl.writeText(txt, l_fmudirname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\\sources "));
        txt = Tpl.writeText(txt, l_mkdir);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, l_fmudirname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\\sources\n",
                                    "\n",
                                    "copy "
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".dll "));
        txt = Tpl.writeText(txt, l_fmudirname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\\binaries\\$(PLATWIN32)\n",
                                    "copy "
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".lib "));
        txt = Tpl.writeText(txt, l_fmudirname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\\binaries\\$(PLATWIN32)\n",
                                    "copy "
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".pdb "));
        txt = Tpl.writeText(txt, l_fmudirname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\\binaries\\$(PLATWIN32)\n",
                                    "copy "
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".c "));
        txt = Tpl.writeText(txt, l_fmudirname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\\sources\\"));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ".c\n",
                                    "copy "
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_model.h "));
        txt = Tpl.writeText(txt, l_fmudirname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\\sources\\"));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_model.h\n",
                                    "copy "
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_FMU.c "));
        txt = Tpl.writeText(txt, l_fmudirname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\\sources\\"));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_FMU.c\n",
                                    "copy "
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_info.c "));
        txt = Tpl.writeText(txt, l_fmudirname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\\sources\\"));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_info.c\n",
                                    "copy "
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_init_fmu.c "));
        txt = Tpl.writeText(txt, l_fmudirname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\\sources\\"));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_init_fmu.c\n",
                                    "copy "
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_functions.c "));
        txt = Tpl.writeText(txt, l_fmudirname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\\sources\\"));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_functions.c\n",
                                    "copy "
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_functions.h "));
        txt = Tpl.writeText(txt, l_fmudirname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\\sources\\"));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_functions.h\n",
                                    "copy "
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_records.c "));
        txt = Tpl.writeText(txt, l_fmudirname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\\sources\\"));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_records.c\n",
                                    "copy modelDescription.xml "
                                }, false));
        txt = Tpl.writeText(txt, l_fmudirname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\\modelDescription.xml\n",
                                    "copy "
                                }, false));
        ret_11 = System.stringReplace(i_makefileParams_omhome, "/", "\\");
        txt = Tpl.writeStr(txt, ret_11);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\\bin\\SUNDIALS_KINSOL.DLL "));
        txt = Tpl.writeText(txt, l_fmudirname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\\binaries\\$(PLATWIN32)\n",
                                    "copy "
                                }, false));
        ret_12 = System.stringReplace(i_makefileParams_omhome, "/", "\\");
        txt = Tpl.writeStr(txt, ret_12);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\\bin\\SUNDIALS_NVECSERIAL.DLL "));
        txt = Tpl.writeText(txt, l_fmudirname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\\binaries\\$(PLATWIN32)\n",
                                    "copy "
                                }, false));
        ret_13 = System.stringReplace(i_makefileParams_omhome, "/", "\\");
        txt = Tpl.writeStr(txt, ret_13);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\\bin\\LAPACK_WIN32_MT.DLL "));
        txt = Tpl.writeText(txt, l_fmudirname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\\binaries\\$(PLATWIN32)\n",
                                    "copy "
                                }, false));
        ret_14 = System.stringReplace(i_makefileParams_omhome, "/", "\\");
        txt = Tpl.writeStr(txt, ret_14);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\\bin\\pthreadVC2.dll "));
        txt = Tpl.writeText(txt, l_fmudirname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\\binaries\\$(PLATWIN32)\n",
                                    "cd "
                                }, false));
        txt = Tpl.writeText(txt, l_fmudirname);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\"zip.exe\" -r ../"));
        txt = Tpl.writeStr(txt, i_fmuTargetName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ".fmu *\n",
                                    "cd ..\n",
                                    "rm -rf "
                                }, false));
        txt = Tpl.writeText(txt, l_fmudirname);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("$(DLLEXT): $(MAINOBJ) $(CFILES)\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("$(CXX) /Fe"));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("$(DLLEXT) $(MAINFILE) "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_FMU.c $(CFILES) $(CFLAGS) $(LDFLAGS)"));
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_85;

protected function fun_86
  input Tpl.Text in_txt;
  input String in_a_modelInfo_directory;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo_directory)
    local
      Tpl.Text txt;
      String i_modelInfo_directory;

    case ( txt,
           "" )
      then txt;

    case ( txt,
           i_modelInfo_directory )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-L\""));
        txt = Tpl.writeStr(txt, i_modelInfo_directory);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
      then txt;
  end match;
end fun_86;

protected function lm_87
  input Tpl.Text in_txt;
  input list<String> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<String> rest;
      String i_lib;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_lib :: rest )
      equation
        txt = Tpl.writeStr(txt, i_lib);
        txt = Tpl.nextIter(txt);
        txt = lm_87(txt, rest);
      then txt;
  end match;
end lm_87;

protected function fun_88
  input Tpl.Text in_txt;
  input Tpl.Text in_a_dirExtra;
  input Tpl.Text in_a_libsStr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_dirExtra, in_a_libsStr)
    local
      Tpl.Text txt;
      Tpl.Text a_libsStr;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           a_libsStr )
      equation
        txt = Tpl.writeText(txt, a_libsStr);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_88;

protected function fun_89
  input Tpl.Text in_txt;
  input Tpl.Text in_a_dirExtra;
  input Tpl.Text in_a_libsStr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_dirExtra, in_a_libsStr)
    local
      Tpl.Text txt;
      Tpl.Text a_libsStr;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           _ )
      then txt;

    case ( txt,
           _,
           a_libsStr )
      equation
        txt = Tpl.writeText(txt, a_libsStr);
      then txt;
  end match;
end fun_89;

protected function fun_90
  input Tpl.Text in_txt;
  input String in_a_s_method;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_s_method)
    local
      Tpl.Text txt;

    case ( txt,
           "inline-euler" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-D_OMC_INLINE_EULER"));
      then txt;

    case ( txt,
           "inline-rungekutta" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-D_OMC_INLINE_RK"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_90;

protected function fun_91
  input Tpl.Text in_txt;
  input Option<SimCode.SimulationSettings> in_a_sopt;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_sopt)
    local
      Tpl.Text txt;
      String i_s_method;

    case ( txt,
           SOME(SimCode.SIMULATION_SETTINGS(method = i_s_method)) )
      equation
        txt = fun_90(txt, i_s_method);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_91;

protected function fun_92
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("1"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("2"));
      then txt;
  end match;
end fun_92;

protected function lm_93
  input Tpl.Text in_txt;
  input list<String> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<String> rest;
      String i_it;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_it :: rest )
      equation
        txt = Tpl.writeStr(txt, i_it);
        txt = Tpl.nextIter(txt);
        txt = lm_93(txt, rest);
      then txt;
  end match;
end lm_93;

protected function fun_94
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-DFMU_EXPERIMENTAL"));
      then txt;
  end match;
end fun_94;

protected function fun_95
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_common;
  input Tpl.Text in_a_FMUVersion;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode, in_a_common, in_a_FMUVersion)
    local
      Tpl.Text txt;
      Tpl.Text a_common;
      Tpl.Text a_FMUVersion;
      list<String> i_makefileParams_includes;
      Integer i_varInfo_numStringAlgVars;
      Integer i_maxDelayedIndex;
      Integer i_varInfo_numMixedSystems;
      Integer i_varInfo_numNonLinearSystems;
      Integer i_varInfo_numLinearSystems;
      String i_makefileParams_omhome;
      String i_fmuTargetName;
      String i_fileNamePrefix;
      String i_makefileParams_platform;
      SimCode.SimCode i_simCode;
      Option<SimCode.SimulationSettings> i_sopt;
      list<String> i_makefileParams_libs;
      String i_modelInfo_directory;
      Boolean ret_9;
      Boolean ret_8;
      Tpl.Text l_platformstr;
      Tpl.Text txt_6;
      Tpl.Text l_compilecmds;
      Tpl.Text l_extraCflags;
      Tpl.Text l_libsPos2;
      Tpl.Text l_libsPos1;
      Tpl.Text l_libsStr;
      Tpl.Text l_dirExtra;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(varInfo = SimCode.VARINFO(numLinearSystems = i_varInfo_numLinearSystems, numNonLinearSystems = i_varInfo_numNonLinearSystems, numMixedSystems = i_varInfo_numMixedSystems, numStringAlgVars = i_varInfo_numStringAlgVars), directory = i_modelInfo_directory), delayedExps = SimCode.DELAYED_EXPRESSIONS(maxDelayedIndex = i_maxDelayedIndex), makefileParams = SimCodeFunction.MAKEFILE_PARAMS(libs = i_makefileParams_libs, platform = i_makefileParams_platform, omhome = i_makefileParams_omhome, includes = i_makefileParams_includes), simulationSettingsOpt = i_sopt, fileNamePrefix = i_fileNamePrefix, fmuTargetName = i_fmuTargetName)),
           a_common,
           a_FMUVersion )
      equation
        l_dirExtra = fun_86(Tpl.emptyTxt, i_modelInfo_directory);
        l_libsStr = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(" ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_libsStr = lm_87(l_libsStr, i_makefileParams_libs);
        l_libsStr = Tpl.popIter(l_libsStr);
        l_libsPos1 = fun_88(Tpl.emptyTxt, l_dirExtra, l_libsStr);
        l_libsPos2 = fun_89(Tpl.emptyTxt, l_dirExtra, l_libsStr);
        l_extraCflags = fun_91(Tpl.emptyTxt, i_sopt);
        txt_6 = CodegenUtilSimulation.modelNamePrefix(Tpl.emptyTxt, i_simCode);
        l_compilecmds = CodegenFMU.getPlatformString2(Tpl.emptyTxt, Tpl.textString(txt_6), i_makefileParams_platform, i_fileNamePrefix, i_fmuTargetName, Tpl.textString(l_dirExtra), Tpl.textString(l_libsPos1), Tpl.textString(l_libsPos2), i_makefileParams_omhome, Tpl.textString(a_FMUVersion));
        l_platformstr = Tpl.writeStr(Tpl.emptyTxt, i_makefileParams_platform);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "# Makefile generated by OpenModelica\n",
                                    "CC=@CC@\n",
                                    "AR=@AR@\n",
                                    "CFLAGS=@CFLAGS@\n",
                                    "LD=$(CC) -shared\n",
                                    "LDFLAGS=@LDFLAGS@ @LIBS@\n",
                                    "DLLEXT=@DLLEXT@\n",
                                    "NEED_RUNTIME=@NEED_RUNTIME@\n",
                                    "NEED_DGESV=@NEED_DGESV@\n",
                                    "FMIPLATFORM=@FMIPLATFORM@\n",
                                    "# Note: Simulation of the fmu with dymola does not work with -finline-small-functions (enabled by most optimization levels)\n",
                                    "CPPFLAGS=@CPPFLAGS@\n",
                                    "OMC_NUM_LINEAR_SYSTEMS="
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numLinearSystems));
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("OMC_NUM_NONLINEAR_SYSTEMS="));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numNonLinearSystems));
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("OMC_NUM_MIXED_SYSTEMS="));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numMixedSystems));
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("OMC_NDELAY_EXPRESSIONS="));
        txt = Tpl.writeStr(txt, intString(i_maxDelayedIndex));
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("OMC_NVAR_STRING="));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numStringAlgVars));
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "override CPPFLAGS += -Iinclude/ -Iinclude/fmi"
                                }, false));
        ret_8 = FMI.isFMIVersion20(Tpl.textString(a_FMUVersion));
        txt = fun_92(txt, ret_8);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" -I. "));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(" ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_93(txt, i_makefileParams_includes);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        ret_9 = Flags.isSet(Flags.FMU_EXPERIMENTAL);
        txt = fun_94(txt, ret_9);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("  -DOMC_MODEL_PREFIX="));
        txt = CodegenUtilSimulation.modelNamePrefix(txt, i_simCode);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" -DOMC_NUM_MIXED_SYSTEMS="));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numMixedSystems));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" -DOMC_NUM_LINEAR_SYSTEMS="));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numLinearSystems));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" -DOMC_NUM_NONLINEAR_SYSTEMS="));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numNonLinearSystems));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" -DOMC_NDELAY_EXPRESSIONS="));
        txt = Tpl.writeStr(txt, intString(i_maxDelayedIndex));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" -DOMC_NVAR_STRING="));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numStringAlgVars));
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_common);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "PHONY: "
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_FMU\n"));
        txt = Tpl.writeText(txt, l_compilecmds);
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_95;

protected function fun_96
  input Tpl.Text in_txt;
  input String in_mArg;
  input String in_a_target;
  input Tpl.Text in_a_common;
  input Tpl.Text in_a_FMUVersion;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_target, in_a_common, in_a_FMUVersion, in_a_simCode)
    local
      Tpl.Text txt;
      String a_target;
      Tpl.Text a_common;
      Tpl.Text a_FMUVersion;
      SimCode.SimCode a_simCode;
      Tpl.Text txt_0;

    case ( txt,
           "msvc",
           _,
           a_common,
           a_FMUVersion,
           a_simCode )
      equation
        txt = fun_85(txt, a_simCode, a_common, a_FMUVersion);
      then txt;

    case ( txt,
           "gcc",
           _,
           a_common,
           a_FMUVersion,
           a_simCode )
      equation
        txt = fun_95(txt, a_simCode, a_common, a_FMUVersion);
      then txt;

    case ( txt,
           _,
           a_target,
           _,
           _,
           _ )
      equation
        txt_0 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("target "));
        txt_0 = Tpl.writeStr(txt_0, a_target);
        txt_0 = Tpl.writeTok(txt_0, Tpl.ST_STRING(" is not handled!"));
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenOMSIC.tpl", 466, 25), Tpl.textString(txt_0));
      then txt;
  end match;
end fun_96;

public function createMakefileIn
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input String a_target;
  input String a_FileNamePrefix;
  input String a_makeflieName;

  output Tpl.Text out_txt;
protected
  String str_8;
  Tpl.Text txt_7;
  Tpl.Text l_common;
  Tpl.Text l_0__;
  Tpl.Text l_SimDerMatFiles;
  Tpl.Text l_SimAlgSystemFiles;
  Tpl.Text l_InitDerMatFiles;
  Tpl.Text l_InitAlgSystemFiles;
  Tpl.Text l_FMUVersion;
algorithm
  l_FMUVersion := Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("2.0"));
  l_InitAlgSystemFiles := Tpl.emptyTxt;
  l_InitDerMatFiles := Tpl.emptyTxt;
  l_SimAlgSystemFiles := Tpl.emptyTxt;
  l_SimDerMatFiles := Tpl.emptyTxt;
  (l_0__, l_SimDerMatFiles, l_SimAlgSystemFiles, l_InitDerMatFiles, l_InitAlgSystemFiles) := fun_74(Tpl.emptyTxt, a_simCode, l_SimDerMatFiles, l_SimAlgSystemFiles, l_InitDerMatFiles, a_FileNamePrefix, l_InitAlgSystemFiles);
  l_common := fun_75(Tpl.emptyTxt, a_simCode, l_SimDerMatFiles, l_SimAlgSystemFiles, l_InitDerMatFiles, l_InitAlgSystemFiles);
  txt_7 := CodegenUtil.getGeneralTarget(Tpl.emptyTxt, a_target);
  str_8 := Tpl.textString(txt_7);
  out_txt := fun_96(txt, str_8, a_target, l_common, l_FMUVersion, a_simCode);
end createMakefileIn;

annotation(__OpenModelica_Interface="backend");
end CodegenOMSIC;