encapsulated package CodegenOMSIC_Equations
"
  file:        CodegenOMSIC_Equations.mo
  package:     CodegenOMSIC_Equations
  description: Generated by Susan.
"

public import Tpl;

public import SimCode;
public import SimCodeFunction;
public import BackendDAE;
public import System;
public import DAE;
public import Util;
public import List;
public import ComponentReference;
public import Error;
protected import CodegenC;
protected import CodegenCFunctions;
protected import CodegenUtil;
protected import CodegenUtilSimulation;

public function equationFunctionPrototypes
  input Tpl.Text txt;
  input SimCode.SimEqSystem a_eq;
  input String a_modelNamePrefixStr;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_ix;
algorithm
  l_ix := CodegenUtilSimulation.equationIndex(Tpl.emptyTxt, a_eq);
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING("void "));
  out_txt := CodegenUtil.symbolName(out_txt, a_modelNamePrefixStr, "eqFunction");
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("_"));
  out_txt := Tpl.writeText(out_txt, l_ix);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("(Data_Struct_something* data, Data_Struct_something* threadData);"));
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_NEW_LINE());
end equationFunctionPrototypes;

protected function fun_48
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_eq)
    local
      Tpl.Text txt;

    case ( txt,
           SimCode.SES_RESIDUAL(index = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("resFunction"));
      then txt;

    case ( txt,
           SimCode.SES_ALGEBRAIC_SYSTEM(index = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("algSystFunction"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("eqFunction"));
      then txt;
  end match;
end fun_48;

protected function fun_49
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_eq)
    local
      Tpl.Text txt;

    case ( txt,
           SimCode.SES_RESIDUAL(index = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("omsi_function_t* this_function, const omsi_values* model_vars_and_params, omsi_real* res"));
      then txt;

    case ( txt,
           SimCode.SES_ALGEBRAIC_SYSTEM(index = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("omsi_function_t* this_function, const omsi_values* model_vars_and_params"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("omsi_function_t* this_function, const omsi_values* model_vars_and_params"));
      then txt;
  end match;
end fun_49;

protected function fun_50
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_varDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_varDecls;

    case ( txt,
           false,
           a_varDecls )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/* Variables */\n"));
        txt = Tpl.writeText(txt, a_varDecls);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_50;

public function generateEquationFunction
  input Tpl.Text txt;
  input SimCode.SimEqSystem a_eq;
  input String a_modelNamePrefixStr;
  input String a_modelFunctionnamePrefixStr;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_functionPrototypes;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_functionPrototypes;
protected
  Boolean ret_8;
  Tpl.Text l_funcArguments;
  Tpl.Text l_funcName;
  Tpl.Text l_equationCode;
  Tpl.Text l_auxFunction;
  Tpl.Text l_varDecls;
  list<SimCode.SimEqSystem> ret_2;
  Tpl.Text l_equationInfos;
  Tpl.Text l_ix;
algorithm
  l_ix := CodegenUtilSimulation.equationIndex(Tpl.emptyTxt, a_eq);
  ret_2 := List.fill(a_eq, 1);
  l_equationInfos := CodegenUtilSimulation.dumpEqs(Tpl.emptyTxt, ret_2);
  l_varDecls := Tpl.emptyTxt;
  l_auxFunction := Tpl.emptyTxt;
  (l_equationCode, l_varDecls, l_auxFunction) := equationCStr(Tpl.emptyTxt, a_eq, l_varDecls, l_auxFunction, a_context);
  l_funcName := fun_48(Tpl.emptyTxt, a_eq);
  l_funcArguments := fun_49(Tpl.emptyTxt, a_eq);
  out_a_functionPrototypes := Tpl.writeTok(a_functionPrototypes, Tpl.ST_STRING("void "));
  out_a_functionPrototypes := CodegenUtil.symbolName(out_a_functionPrototypes, a_modelNamePrefixStr, Tpl.textString(l_funcName));
  out_a_functionPrototypes := Tpl.writeTok(out_a_functionPrototypes, Tpl.ST_STRING("_"));
  out_a_functionPrototypes := Tpl.writeText(out_a_functionPrototypes, l_ix);
  out_a_functionPrototypes := Tpl.writeTok(out_a_functionPrototypes, Tpl.ST_STRING("("));
  out_a_functionPrototypes := Tpl.writeText(out_a_functionPrototypes, l_funcArguments);
  out_a_functionPrototypes := Tpl.writeTok(out_a_functionPrototypes, Tpl.ST_STRING(");"));
  out_a_functionPrototypes := Tpl.writeTok(out_a_functionPrototypes, Tpl.ST_NEW_LINE());
  out_txt := Tpl.writeTok(txt, Tpl.ST_LINE("/*\n"));
  out_txt := Tpl.writeText(out_txt, l_equationInfos);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("*/\n"));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(1));
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("void "));
  out_txt := CodegenUtil.symbolName(out_txt, a_modelNamePrefixStr, Tpl.textString(l_funcName));
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("_"));
  out_txt := Tpl.writeText(out_txt, l_ix);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("("));
  out_txt := Tpl.writeText(out_txt, l_funcArguments);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "){\n",
                                       "\n",
                                       "\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(1));
  ret_8 := stringEq(Tpl.textString(l_varDecls), "");
  out_txt := fun_50(out_txt, ret_8, l_varDecls);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeText(out_txt, l_auxFunction);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeText(out_txt, l_equationCode);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("}"));
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_NEW_LINE());
end generateEquationFunction;

protected function fun_52
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_a_eq, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      SimCode.SimEqSystem i_eq;
      DAE.Exp i_exp;
      DAE.ComponentRef i_cref;
      Tpl.Text l_whenEq;
      Tpl.Text l_expPart;
      Tpl.Text l_crefStr;

    case ( txt,
           SimCode.SES_SIMPLE_ASSIGN(cref = i_cref, exp = i_exp),
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        l_crefStr = CodegenCFunctions.crefOMSI(Tpl.emptyTxt, i_cref, a_context);
        (l_expPart, a_preExp, a_varDecls, a_auxFunction) = CodegenCFunctions.daeExp(Tpl.emptyTxt, i_exp, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeText(txt, a_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_crefStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, l_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           SimCode.SES_RESIDUAL(exp = i_exp),
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (l_expPart, a_preExp, a_varDecls, a_auxFunction) = CodegenCFunctions.daeExp(Tpl.emptyTxt, i_exp, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeText(txt, a_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("*res = "));
        txt = Tpl.writeText(txt, l_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           (i_eq as SimCode.SES_WHEN(index = _)),
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (l_whenEq, a_varDecls, a_auxFunction) = equationWhen(Tpl.emptyTxt, i_eq, a_context, a_varDecls, a_auxFunction);
        txt = Tpl.writeText(txt, l_whenEq);
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           _,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("NOT IMPLEMENTED YET Error in function equationCStr in template CodegenOMSIC_Equations"));
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end fun_52;

public function equationCStr
  input Tpl.Text txt;
  input SimCode.SimEqSystem a_eq;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_auxFunction;
  input SimCodeFunction.Context a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
protected
  Tpl.Text l_preExp;
algorithm
  l_preExp := Tpl.emptyTxt;
  (out_txt, out_a_auxFunction, out_a_varDecls, l_preExp) := fun_52(txt, a_eq, a_auxFunction, a_varDecls, l_preExp, a_context);
end equationCStr;

protected function fun_54
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input String in_a_modelNamePrefixStr;
  input String in_a_input;
  input String in_a_omsiName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_eq, in_a_modelNamePrefixStr, in_a_input, in_a_omsiName)
    local
      Tpl.Text txt;
      String a_modelNamePrefixStr;
      String a_input;
      String a_omsiName;
      Integer i_algSysIndex;
      Integer i_index;
      Tpl.Text l_i;

    case ( txt,
           SimCode.SES_SIMPLE_ASSIGN(index = i_index),
           a_modelNamePrefixStr,
           a_input,
           _ )
      equation
        l_i = Tpl.writeStr(Tpl.emptyTxt, intString(i_index));
        txt = CodegenUtil.symbolName(txt, a_modelNamePrefixStr, "eqFunction");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeText(txt, l_i);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeStr(txt, a_input);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;

    case ( txt,
           SimCode.SES_WHEN(index = i_index),
           a_modelNamePrefixStr,
           a_input,
           _ )
      equation
        l_i = Tpl.writeStr(Tpl.emptyTxt, intString(i_index));
        txt = CodegenUtil.symbolName(txt, a_modelNamePrefixStr, "eqFunction");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeText(txt, l_i);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeStr(txt, a_input);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;

    case ( txt,
           SimCode.SES_RESIDUAL(index = i_index),
           a_modelNamePrefixStr,
           a_input,
           _ )
      equation
        txt = CodegenUtil.symbolName(txt, a_modelNamePrefixStr, "resFunction");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeStr(txt, a_input);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;

    case ( txt,
           SimCode.SES_ALGEBRAIC_SYSTEM(algSysIndex = i_algSysIndex),
           a_modelNamePrefixStr,
           a_input,
           a_omsiName )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("new_status = "));
        txt = CodegenUtil.symbolName(txt, a_modelNamePrefixStr, a_omsiName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_algSystFunction_"));
        txt = Tpl.writeStr(txt, intString(i_algSysIndex));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeStr(txt, a_input);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ");\n",
                                    "status = (new_status==omsi_ok && status==omsi_ok) ? omsi_ok:new_status;"
                                }, false));
      then txt;

    case ( txt,
           _,
           _,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/* equationCall not implemented yet */"));
      then txt;
  end match;
end fun_54;

public function equationCall
  input Tpl.Text txt;
  input SimCode.SimEqSystem a_eq;
  input String a_modelNamePrefixStr;
  input String a_modelFunctionnamePrefixStr;
  input String a_input;
  input String a_omsiName;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_54(txt, a_eq, a_modelNamePrefixStr, a_input, a_omsiName);
end equationCall;

protected function lm_56
  input Tpl.Text in_txt;
  input list<SimCode.OMSIFunction> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.OMSIFunction> rest;
      SimCode.OMSIFunction i_col;
      Tpl.Text l_columnsString;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_col :: rest )
      equation
        l_columnsString = generateMatrixColumnInitialization(Tpl.emptyTxt, i_col);
        txt = lm_56(txt, rest);
      then txt;
  end match;
end lm_56;

protected function fun_57
  input Tpl.Text in_txt;
  input Option<SimCode.DerivativeMatrix> in_a_matrix;
  input Tpl.Text in_a_columnsString;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_matrix, in_a_columnsString)
    local
      Tpl.Text txt;
      Tpl.Text a_columnsString;
      list<SimCode.OMSIFunction> i_m_columns;
      Tpl.Text l_0__;

    case ( txt,
           SOME(SimCode.DERIVATIVE_MATRIX(columns = i_m_columns)),
           a_columnsString )
      equation
        l_0__ = lm_56(Tpl.emptyTxt, i_m_columns);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_columnsString);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_57;

public function generateMatrixInitialization
  input Tpl.Text txt;
  input Option<SimCode.DerivativeMatrix> a_matrix;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_columnsString;
algorithm
  l_columnsString := Tpl.emptyTxt;
  out_txt := fun_57(txt, a_matrix, l_columnsString);
end generateMatrixInitialization;

protected function lm_59
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input SimCodeFunction.Context in_a_omsiFunction_context;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_body;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_body;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_body) :=
  match(in_txt, in_items, in_a_omsiFunction_context, in_a_auxFunction, in_a_varDecls, in_a_body)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      SimCodeFunction.Context a_omsiFunction_context;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_body;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           {},
           _,
           a_auxFunction,
           a_varDecls,
           a_body )
      then (txt, a_auxFunction, a_varDecls, a_body);

    case ( txt,
           i_eq :: rest,
           a_omsiFunction_context,
           a_auxFunction,
           a_varDecls,
           a_body )
      equation
        (a_body, a_varDecls, a_auxFunction) = equationCStr(a_body, i_eq, a_varDecls, a_auxFunction, a_omsiFunction_context);
        (txt, a_auxFunction, a_varDecls, a_body) = lm_59(txt, rest, a_omsiFunction_context, a_auxFunction, a_varDecls, a_body);
      then (txt, a_auxFunction, a_varDecls, a_body);
  end match;
end lm_59;

protected function fun_60
  input Tpl.Text in_txt;
  input SimCode.OMSIFunction in_a_column;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_body;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_body;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_body) :=
  match(in_txt, in_a_column, in_a_auxFunction, in_a_varDecls, in_a_body)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_body;
      SimCodeFunction.Context i_omsiFunction_context;
      list<SimCode.SimEqSystem> i_equations;
      Tpl.Text l_0__;

    case ( txt,
           SimCode.OMSI_FUNCTION(equations = i_equations, context = i_omsiFunction_context),
           a_auxFunction,
           a_varDecls,
           a_body )
      equation
        (l_0__, a_auxFunction, a_varDecls, a_body) = lm_59(Tpl.emptyTxt, i_equations, i_omsiFunction_context, a_auxFunction, a_varDecls, a_body);
        txt = Tpl.writeText(txt, a_body);
      then (txt, a_auxFunction, a_varDecls, a_body);

    case ( txt,
           _,
           a_auxFunction,
           a_varDecls,
           a_body )
      then (txt, a_auxFunction, a_varDecls, a_body);
  end match;
end fun_60;

public function generateMatrixColumnInitialization
  input Tpl.Text txt;
  input SimCode.OMSIFunction a_column;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_body;
  Tpl.Text l_auxFunction;
  Tpl.Text l_varDecls;
algorithm
  l_varDecls := Tpl.emptyTxt;
  l_auxFunction := Tpl.emptyTxt;
  l_body := Tpl.emptyTxt;
  (out_txt, l_auxFunction, l_varDecls, l_body) := fun_60(txt, a_column, l_auxFunction, l_varDecls, l_body);
end generateMatrixColumnInitialization;

protected function lm_62
  input Tpl.Text in_txt;
  input list<SimCode.OMSIFunction> in_items;
  input String in_a_omsiName;
  input Tpl.Text in_a_functionPrototypes;
  input String in_a_index;
  input String in_a_modelName;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_functionPrototypes;
algorithm
  (out_txt, out_a_functionPrototypes) :=
  match(in_txt, in_items, in_a_omsiName, in_a_functionPrototypes, in_a_index, in_a_modelName)
    local
      Tpl.Text txt;
      list<SimCode.OMSIFunction> rest;
      String a_omsiName;
      Tpl.Text a_functionPrototypes;
      String a_index;
      String a_modelName;
      SimCode.OMSIFunction i_col;

    case ( txt,
           {},
           _,
           a_functionPrototypes,
           _,
           _ )
      then (txt, a_functionPrototypes);

    case ( txt,
           i_col :: rest,
           a_omsiName,
           a_functionPrototypes,
           a_index,
           a_modelName )
      equation
        (txt, a_functionPrototypes) = generateDereivativeMatrixColumnFunction(txt, i_col, a_modelName, a_index, a_functionPrototypes);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        (txt, a_functionPrototypes) = generateDereivativeMatrixColumnCall(txt, i_col, a_modelName, a_index, a_functionPrototypes, a_omsiName);
        txt = Tpl.nextIter(txt);
        (txt, a_functionPrototypes) = lm_62(txt, rest, a_omsiName, a_functionPrototypes, a_index, a_modelName);
      then (txt, a_functionPrototypes);
  end match;
end lm_62;

protected function fun_63
  input Tpl.Text in_txt;
  input Option<SimCode.DerivativeMatrix> in_a_matrix;
  input String in_a_omsiName;
  input Tpl.Text in_a_functionPrototypes;
  input String in_a_index;
  input String in_a_modelName;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_functionPrototypes;
algorithm
  (out_txt, out_a_functionPrototypes) :=
  match(in_txt, in_a_matrix, in_a_omsiName, in_a_functionPrototypes, in_a_index, in_a_modelName)
    local
      Tpl.Text txt;
      String a_omsiName;
      Tpl.Text a_functionPrototypes;
      String a_index;
      String a_modelName;
      list<SimCode.OMSIFunction> i_m_columns;
      Tpl.Text l_columnsString;

    case ( txt,
           SOME(SimCode.DERIVATIVE_MATRIX(columns = i_m_columns)),
           a_omsiName,
           a_functionPrototypes,
           a_index,
           a_modelName )
      equation
        l_columnsString = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING_LIST({
                                                                                          "\n",
                                                                                          "\n"
                                                                                      }, true)), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_columnsString, a_functionPrototypes) = lm_62(l_columnsString, i_m_columns, a_omsiName, a_functionPrototypes, a_index, a_modelName);
        l_columnsString = Tpl.popIter(l_columnsString);
        txt = Tpl.writeText(txt, l_columnsString);
      then (txt, a_functionPrototypes);

    case ( txt,
           _,
           _,
           a_functionPrototypes,
           _,
           _ )
      then (txt, a_functionPrototypes);
  end match;
end fun_63;

public function generateDerivativeMatrix
  input Tpl.Text txt;
  input Option<SimCode.DerivativeMatrix> a_matrix;
  input String a_modelName;
  input String a_index;
  input Tpl.Text a_functionPrototypes;
  input String a_omsiName;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_functionPrototypes;
protected
  Tpl.Text l_columnsString;
algorithm
  l_columnsString := Tpl.emptyTxt;
  (out_txt, out_a_functionPrototypes) := fun_63(txt, a_matrix, a_omsiName, a_functionPrototypes, a_index, a_modelName);
end generateDerivativeMatrix;

protected function lm_65
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input Tpl.Text in_a_functionPrototypes;
  input SimCodeFunction.Context in_a_omsiFunction_context;
  input String in_a_modelName;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_functionPrototypes;
algorithm
  (out_txt, out_a_functionPrototypes) :=
  match(in_txt, in_items, in_a_functionPrototypes, in_a_omsiFunction_context, in_a_modelName)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      Tpl.Text a_functionPrototypes;
      SimCodeFunction.Context a_omsiFunction_context;
      String a_modelName;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           {},
           a_functionPrototypes,
           _,
           _ )
      then (txt, a_functionPrototypes);

    case ( txt,
           i_eq :: rest,
           a_functionPrototypes,
           a_omsiFunction_context,
           a_modelName )
      equation
        (txt, a_functionPrototypes) = generateEquationFunction(txt, i_eq, a_modelName, "", a_omsiFunction_context, a_functionPrototypes);
        txt = Tpl.nextIter(txt);
        (txt, a_functionPrototypes) = lm_65(txt, rest, a_functionPrototypes, a_omsiFunction_context, a_modelName);
      then (txt, a_functionPrototypes);
  end match;
end lm_65;

protected function fun_66
  input Tpl.Text in_txt;
  input SimCode.OMSIFunction in_a_column;
  input Tpl.Text in_a_functionPrototypes;
  input String in_a_modelName;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_functionPrototypes;
algorithm
  (out_txt, out_a_functionPrototypes) :=
  match(in_txt, in_a_column, in_a_functionPrototypes, in_a_modelName)
    local
      Tpl.Text txt;
      Tpl.Text a_functionPrototypes;
      String a_modelName;
      SimCodeFunction.Context i_omsiFunction_context;
      list<SimCode.SimEqSystem> i_equations;
      Tpl.Text l_bodyBuffer;

    case ( txt,
           SimCode.OMSI_FUNCTION(equations = i_equations, context = i_omsiFunction_context),
           a_functionPrototypes,
           a_modelName )
      equation
        l_bodyBuffer = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_bodyBuffer, a_functionPrototypes) = lm_65(l_bodyBuffer, i_equations, a_functionPrototypes, i_omsiFunction_context, a_modelName);
        l_bodyBuffer = Tpl.popIter(l_bodyBuffer);
        txt = Tpl.writeText(txt, l_bodyBuffer);
      then (txt, a_functionPrototypes);

    case ( txt,
           _,
           a_functionPrototypes,
           _ )
      then (txt, a_functionPrototypes);
  end match;
end fun_66;

public function generateDereivativeMatrixColumnFunction
  input Tpl.Text txt;
  input SimCode.OMSIFunction a_column;
  input String a_modelName;
  input String a_index;
  input Tpl.Text a_functionPrototypes;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_functionPrototypes;
protected
  Tpl.Text l_auxFunction;
  Tpl.Text l_varDecls;
  Tpl.Text l_preExp;
  Tpl.Text l_bodyBuffer;
algorithm
  l_bodyBuffer := Tpl.emptyTxt;
  l_preExp := Tpl.emptyTxt;
  l_varDecls := Tpl.emptyTxt;
  l_auxFunction := Tpl.emptyTxt;
  (out_txt, out_a_functionPrototypes) := fun_66(txt, a_column, a_functionPrototypes, a_modelName);
end generateDereivativeMatrixColumnFunction;

protected function lm_68
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input String in_a_omsiName;
  input String in_a_modelName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_omsiName, in_a_modelName)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      String a_omsiName;
      String a_modelName;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           {},
           _,
           _ )
      then txt;

    case ( txt,
           i_eq :: rest,
           a_omsiName,
           a_modelName )
      equation
        txt = equationCall(txt, i_eq, a_modelName, "", "this_function, model_vars_and_params", a_omsiName);
        txt = Tpl.nextIter(txt);
        txt = lm_68(txt, rest, a_omsiName, a_modelName);
      then txt;
  end match;
end lm_68;

protected function fun_69
  input Tpl.Text in_txt;
  input SimCode.OMSIFunction in_a_column;
  input String in_a_index;
  input Tpl.Text in_a_functionPrototypes;
  input String in_a_omsiName;
  input String in_a_modelName;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_functionPrototypes;
algorithm
  (out_txt, out_a_functionPrototypes) :=
  match(in_txt, in_a_column, in_a_index, in_a_functionPrototypes, in_a_omsiName, in_a_modelName)
    local
      Tpl.Text txt;
      String a_index;
      Tpl.Text a_functionPrototypes;
      String a_omsiName;
      String a_modelName;
      list<SimCode.SimEqSystem> i_equations;
      Tpl.Text l_bodyBuffer;

    case ( txt,
           SimCode.OMSI_FUNCTION(equations = i_equations),
           a_index,
           a_functionPrototypes,
           a_omsiName,
           a_modelName )
      equation
        l_bodyBuffer = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_bodyBuffer = lm_68(l_bodyBuffer, i_equations, a_omsiName, a_modelName);
        l_bodyBuffer = Tpl.popIter(l_bodyBuffer);
        a_functionPrototypes = Tpl.writeTok(a_functionPrototypes, Tpl.ST_STRING("omsi_status "));
        a_functionPrototypes = CodegenUtil.symbolName(a_functionPrototypes, a_modelName, a_omsiName);
        a_functionPrototypes = Tpl.writeTok(a_functionPrototypes, Tpl.ST_STRING("_derivativeMatFunc_"));
        a_functionPrototypes = Tpl.writeStr(a_functionPrototypes, a_index);
        a_functionPrototypes = Tpl.writeTok(a_functionPrototypes, Tpl.ST_STRING("(omsi_function_t* this_function, const omsi_values* model_vars_and_params, void* data);"));
        a_functionPrototypes = Tpl.writeTok(a_functionPrototypes, Tpl.ST_NEW_LINE());
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "/*\n",
                                    "Description something\n",
                                    "*/\n",
                                    "omsi_status "
                                }, false));
        txt = CodegenUtil.symbolName(txt, a_modelName, a_omsiName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_derivativeMatFunc_"));
        txt = Tpl.writeStr(txt, a_index);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(omsi_function_t* this_function, const omsi_values* model_vars_and_params, void* data){\n",
                                    "\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_bodyBuffer);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "return omsi_ok;\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then (txt, a_functionPrototypes);

    case ( txt,
           _,
           _,
           a_functionPrototypes,
           _,
           _ )
      then (txt, a_functionPrototypes);
  end match;
end fun_69;

public function generateDereivativeMatrixColumnCall
  input Tpl.Text txt;
  input SimCode.OMSIFunction a_column;
  input String a_modelName;
  input String a_index;
  input Tpl.Text a_functionPrototypes;
  input String a_omsiName;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_functionPrototypes;
protected
  Tpl.Text l_auxFunction;
  Tpl.Text l_varDecls;
  Tpl.Text l_preExp;
  Tpl.Text l_bodyBuffer;
algorithm
  l_bodyBuffer := Tpl.emptyTxt;
  l_preExp := Tpl.emptyTxt;
  l_varDecls := Tpl.emptyTxt;
  l_auxFunction := Tpl.emptyTxt;
  (out_txt, out_a_functionPrototypes) := fun_69(txt, a_column, a_index, a_functionPrototypes, a_omsiName, a_modelName);
end generateDereivativeMatrixColumnCall;

protected function lm_71
  input Tpl.Text in_txt;
  input list<DAE.ComponentRef> in_items;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.ComponentRef> rest;
      SimCodeFunction.Context a_context;
      DAE.ComponentRef i_cr;
      DAE.ComponentRef ret_0;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_cr :: rest,
           a_context )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = CodegenCFunctions.crefOMSI(txt, i_cr, a_context);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" && !"));
        ret_0 = ComponentReference.crefPrefixPre(i_cr);
        txt = CodegenCFunctions.crefOMSI(txt, ret_0, a_context);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" /* edge */)"));
        txt = Tpl.nextIter(txt);
        txt = lm_71(txt, rest, a_context);
      then txt;
  end match;
end lm_71;

protected function fun_72
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input SimCodeFunction.Context in_a_context;
  input list<DAE.ComponentRef> in_a_conditions;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_context, in_a_conditions)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      list<DAE.ComponentRef> a_conditions;

    case ( txt,
           false,
           a_context,
           a_conditions )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(" || ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_71(txt, a_conditions, a_context);
        txt = Tpl.popIter(txt);
      then txt;

    case ( txt,
           _,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("0"));
      then txt;
  end match;
end fun_72;

protected function fun_73
  input Tpl.Text in_txt;
  input DAE.Type in_mArg;
  input Tpl.Text in_a_val;
  input SimCodeFunction.Context in_a_context;
  input DAE.ComponentRef in_a_stateVar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_val, in_a_context, in_a_stateVar)
    local
      Tpl.Text txt;
      Tpl.Text a_val;
      SimCodeFunction.Context a_context;
      DAE.ComponentRef a_stateVar;

    case ( txt,
           DAE.T_ARRAY(ty = _),
           _,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("TODO: Implement for arrays!"));
      then txt;

    case ( txt,
           _,
           a_val,
           a_context,
           a_stateVar )
      equation
        txt = CodegenCFunctions.crefOMSI(txt, a_stateVar, a_context);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, a_val);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_73;

protected function fun_74
  input Tpl.Text in_txt;
  input BackendDAE.WhenOperator in_a_stmt;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_a_stmt, in_a_auxFunction, in_a_varDecls, in_a_context)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      SimCodeFunction.Context a_context;
      DAE.ComponentRef i_stateVar;
      DAE.Exp i_value;
      DAE.Exp i_right;
      DAE.ComponentRef i_left;
      DAE.Type ret_4;
      Tpl.Text l_val;
      Tpl.Text l_rhs;
      Tpl.Text l_lhs;
      Tpl.Text l_preExp;

    case ( txt,
           BackendDAE.ASSIGN(left = DAE.CREF(componentRef = i_left), right = i_right),
           a_auxFunction,
           a_varDecls,
           a_context )
      equation
        l_preExp = Tpl.emptyTxt;
        l_lhs = CodegenCFunctions.crefOMSI(Tpl.emptyTxt, i_left, a_context);
        (l_rhs, l_preExp, a_varDecls, a_auxFunction) = CodegenCFunctions.daeExp(Tpl.emptyTxt, i_right, a_context, l_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_lhs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, l_rhs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.popBlock(txt);
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           BackendDAE.REINIT(stateVar = i_stateVar, value = i_value, source = _),
           a_auxFunction,
           a_varDecls,
           a_context )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_val, l_preExp, a_varDecls, a_auxFunction) = CodegenCFunctions.daeExp(Tpl.emptyTxt, i_value, a_context, l_preExp, a_varDecls, a_auxFunction);
        ret_4 = ComponentReference.crefTypeConsiderSubs(i_stateVar);
        l_lhs = fun_73(Tpl.emptyTxt, ret_4, l_val, a_context, i_stateVar);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_lhs);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/* ToDo: Add some info that variable was reinitialized */"));
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           _,
           a_auxFunction,
           a_varDecls,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("TODO: when expression not supported yet"));
      then (txt, a_auxFunction, a_varDecls);
  end match;
end fun_74;

protected function lm_75
  input Tpl.Text in_txt;
  input list<BackendDAE.WhenOperator> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_context)
    local
      Tpl.Text txt;
      list<BackendDAE.WhenOperator> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      SimCodeFunction.Context a_context;
      BackendDAE.WhenOperator i_stmt;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           _ )
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           i_stmt :: rest,
           a_auxFunction,
           a_varDecls,
           a_context )
      equation
        (txt, a_auxFunction, a_varDecls) = fun_74(txt, i_stmt, a_auxFunction, a_varDecls, a_context);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls) = lm_75(txt, rest, a_auxFunction, a_varDecls, a_context);
      then (txt, a_auxFunction, a_varDecls);
  end match;
end lm_75;

public function equationWhen
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_eq, in_a_context, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      list<BackendDAE.WhenOperator> i_whenStmtLst;
      list<DAE.ComponentRef> i_conditions;
      Tpl.Text l_assign;
      Boolean ret_1;
      Tpl.Text l_helpIf;

    case ( txt,
           SimCode.SES_WHEN(whenStmtLst = i_whenStmtLst, conditions = i_conditions, elseWhen = NONE()),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        ret_1 = listEmpty(i_conditions);
        l_helpIf = fun_72(Tpl.emptyTxt, ret_1, a_context, i_conditions);
        l_assign = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_assign, a_auxFunction, a_varDecls) = lm_75(l_assign, i_whenStmtLst, a_auxFunction, a_varDecls, a_context);
        l_assign = Tpl.popIter(l_assign);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if("));
        txt = Tpl.writeText(txt, l_helpIf);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ")\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_assign);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_varDecls,
           a_auxFunction )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("TODO: Implement elsewhen"));
      then (txt, a_varDecls, a_auxFunction);
  end match;
end equationWhen;

annotation(__OpenModelica_Interface="backend");
end CodegenOMSIC_Equations;