encapsulated package CodegenOMSICpp
"
  file:        CodegenOMSICpp.mo
  package:     CodegenOMSICpp
  description: Generated by Susan.
"

public import Tpl;

public import SimCode;
public import SimCodeFunction;
public import Absyn;
public import Util;
public import Config;
public import Testsuite;
public import Flags;
public import Settings;
public import CodegenUtil;
public import CodegenCpp;

protected function fun_45
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      Absyn.Path i_modelInfo_name;
      SimCode.SimCode i_simCode;
      Tpl.Text txt_3;
      Tpl.Text txt_2;
      Tpl.Text l_extraFuncsDecl;
      Tpl.Text l_extraFuncs;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = i_modelInfo_name))) )
      equation
        l_extraFuncs = Tpl.emptyTxt;
        l_extraFuncsDecl = Tpl.emptyTxt;
        (txt_2, l_extraFuncs, l_extraFuncsDecl, _) = simulationOMSUCPPMainRunScript(Tpl.emptyTxt, i_simCode, l_extraFuncs, l_extraFuncsDecl, Tpl.strTokText(Tpl.ST_STRING("")), "", "", "exec");
        txt_3 = CodegenUtil.dotPath(Tpl.emptyTxt, i_modelInfo_name);
        (txt_3, l_extraFuncs, l_extraFuncsDecl, _) = CodegenCpp.simulationMainRunScriptSuffix(txt_3, i_simCode, l_extraFuncs, l_extraFuncsDecl, Tpl.strTokText(Tpl.ST_STRING("")));
        Tpl.textFile(txt_2, Tpl.textString(txt_3));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_45;

public function translateModel
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input String a_FMUVersion;
  input String a_FMUType;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_45(txt, a_simCode);
end translateModel;

protected function fun_47
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input String in_a_settings_method;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode, in_a_settings_method)
    local
      Tpl.Text txt;
      String a_settings_method;

    case ( txt,
           SimCode.SIMCODE(daeModeData = NONE()),
           a_settings_method )
      equation
        txt = Tpl.writeStr(txt, a_settings_method);
      then txt;

    case ( txt,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("ida"));
      then txt;
  end match;
end fun_47;

protected function fun_48
  input Tpl.Text in_txt;
  input String in_a_makefileParams_platform;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_makefileParams_platform)
    local
      Tpl.Text txt;
      String i_makefileParams_platform;

    case ( txt,
           "i386-pc-linux" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("linux32"));
      then txt;

    case ( txt,
           "x86_64-linux" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("linux64"));
      then txt;

    case ( txt,
           i_makefileParams_platform )
      equation
        txt = Tpl.writeStr(txt, i_makefileParams_platform);
      then txt;
  end match;
end fun_48;

protected function fun_49
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-O none"));
      then txt;
  end match;
end fun_49;

protected function lm_50
  input Tpl.Text in_txt;
  input list<String> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<String> rest;
      String i_path;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_path :: rest )
      equation
        txt = Tpl.writeStr(txt, i_path);
        txt = Tpl.nextIter(txt);
        txt = lm_50(txt, rest);
      then txt;
  end match;
end lm_50;

protected function fun_51
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;
      String ret_4;
      String ret_3;
      String ret_2;
      Integer ret_1;
      Integer ret_0;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-u true -p "));
        ret_0 = Flags.getConfigInt(Flags.ZEROMQ_PUB_PORT);
        txt = Tpl.writeStr(txt, intString(ret_0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" -s "));
        ret_1 = Flags.getConfigInt(Flags.ZEROMQ_SUB_PORT);
        txt = Tpl.writeStr(txt, intString(ret_1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" -v "));
        ret_2 = Flags.getConfigString(Flags.ZEROMQ_SERVER_ID);
        txt = Tpl.writeStr(txt, ret_2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" -c "));
        ret_3 = Flags.getConfigString(Flags.ZEROMQ_CLIENT_ID);
        txt = Tpl.writeStr(txt, ret_3);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" -g "));
        ret_4 = Flags.getConfigString(Flags.ZEROMQ_JOB_ID);
        txt = Tpl.writeStr(txt, ret_4);
      then txt;
  end match;
end fun_51;

protected function fun_52
  input Tpl.Text in_txt;
  input String in_a_makefileParams_platform;
  input Tpl.Text in_a_libPaths;
  input Tpl.Text in_a_libFolder;
  input String in_a_preRunCommandWindows;
  input Tpl.Text in_a_outputParameter;
  input Tpl.Text in_a_zermMQParams;
  input Tpl.Text in_a_execParameters;
  input Tpl.Text in_a_binFolder;
  input String in_a_execCommandLinux;
  input String in_a_preRunCommandLinux;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_makefileParams_platform, in_a_libPaths, in_a_libFolder, in_a_preRunCommandWindows, in_a_outputParameter, in_a_zermMQParams, in_a_execParameters, in_a_binFolder, in_a_execCommandLinux, in_a_preRunCommandLinux)
    local
      Tpl.Text txt;
      Tpl.Text a_libPaths;
      Tpl.Text a_libFolder;
      String a_preRunCommandWindows;
      Tpl.Text a_outputParameter;
      Tpl.Text a_zermMQParams;
      Tpl.Text a_execParameters;
      Tpl.Text a_binFolder;
      String a_execCommandLinux;
      String a_preRunCommandLinux;

    case ( txt,
           "linux32",
           _,
           _,
           _,
           a_outputParameter,
           a_zermMQParams,
           a_execParameters,
           a_binFolder,
           a_execCommandLinux,
           a_preRunCommandLinux )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("#!/bin/sh\n"));
        txt = Tpl.writeStr(txt, a_preRunCommandLinux);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeStr(txt, a_execCommandLinux);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, a_binFolder);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/OMCppOSUSimulation "));
        txt = Tpl.writeText(txt, a_execParameters);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, a_zermMQParams);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, a_outputParameter);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" $*"));
      then txt;

    case ( txt,
           "linux64",
           _,
           _,
           _,
           a_outputParameter,
           a_zermMQParams,
           a_execParameters,
           a_binFolder,
           a_execCommandLinux,
           a_preRunCommandLinux )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("#!/bin/sh\n"));
        txt = Tpl.writeStr(txt, a_preRunCommandLinux);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeStr(txt, a_execCommandLinux);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, a_binFolder);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/OMCppOSUSimulation "));
        txt = Tpl.writeText(txt, a_execParameters);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, a_zermMQParams);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, a_outputParameter);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" $*"));
      then txt;

    case ( txt,
           "win32",
           a_libPaths,
           a_libFolder,
           a_preRunCommandWindows,
           a_outputParameter,
           a_zermMQParams,
           a_execParameters,
           a_binFolder,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("@echo off\n"));
        txt = Tpl.writeStr(txt, a_preRunCommandWindows);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("REM ::export PATH="));
        txt = Tpl.writeText(txt, a_libFolder);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ":$PATH REPLACE C: with /C/\n",
                                    "SET PATH="
                                }, false));
        txt = Tpl.writeText(txt, a_binFolder);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeText(txt, a_libFolder);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeText(txt, a_libPaths);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";%PATH%\n",
                                    "OMCppOSUSimulation.exe "
                                }, false));
        txt = Tpl.writeText(txt, a_execParameters);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, a_zermMQParams);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, a_outputParameter);
      then txt;

    case ( txt,
           "win64",
           a_libPaths,
           a_libFolder,
           a_preRunCommandWindows,
           a_outputParameter,
           a_zermMQParams,
           a_execParameters,
           a_binFolder,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("@echo off\n"));
        txt = Tpl.writeStr(txt, a_preRunCommandWindows);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("REM ::export PATH="));
        txt = Tpl.writeText(txt, a_libFolder);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ":$PATH REPLACE C: with /C/\n",
                                    "SET PATH="
                                }, false));
        txt = Tpl.writeText(txt, a_binFolder);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeText(txt, a_libFolder);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeText(txt, a_libPaths);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";%PATH%\n",
                                    "OMCppOSUSimulation.exe "
                                }, false));
        txt = Tpl.writeText(txt, a_execParameters);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, a_zermMQParams);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, a_outputParameter);
      then txt;

    case ( txt,
           _,
           _,
           _,
           _,
           _,
           _,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_52;

public function simulationOMSUCPPMainRunScript
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input String in_a_preRunCommandLinux;
  input String in_a_preRunCommandWindows;
  input String in_a_execCommandLinux;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace) :=
  match(in_txt, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_preRunCommandLinux, in_a_preRunCommandWindows, in_a_execCommandLinux)
    local
      Tpl.Text txt;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      String a_preRunCommandLinux;
      String a_preRunCommandWindows;
      String a_execCommandLinux;
      list<String> i_makefileParams_libPaths;
      String i_makefileParams_platform;
      String i_fileNamePrefix;
      Absyn.Path i_modelInfo_name;
      String i_settings_outputFormat;
      String i_makefileParams_omhome;
      String i_makefileParams_compileDir;
      String i_settings_method;
      SimCode.SimCode i_simCode;
      Real i_settings_tolerance;
      Integer i_settings_numberOfIntervals;
      Real i_settings_stepSize;
      Real i_settings_stopTime;
      Real i_settings_startTime;
      Boolean ret_23;
      Tpl.Text l_zermMQParams;
      Tpl.Text l_libPaths;
      String ret_20;
      Tpl.Text l_binFolder;
      String ret_18;
      Tpl.Text l_libFolder;
      Boolean ret_16;
      Tpl.Text l_outputParameter;
      Boolean ret_14;
      String ret_13;
      Tpl.Text l_execParameters;
      Tpl.Text l_platformstr;
      Tpl.Text l_fileNamePrefixx;
      Tpl.Text l_modelName;
      Tpl.Text l_outputformat;
      Tpl.Text l_home;
      Tpl.Text l_moLib;
      Tpl.Text l_solver;
      Tpl.Text l_tol;
      Tpl.Text l_intervals;
      Tpl.Text l_stepsize;
      Tpl.Text l_end;
      Tpl.Text l_start;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = i_modelInfo_name), makefileParams = SimCodeFunction.MAKEFILE_PARAMS(compileDir = i_makefileParams_compileDir, omhome = i_makefileParams_omhome, platform = i_makefileParams_platform, libPaths = i_makefileParams_libPaths), simulationSettingsOpt = SOME(SimCode.SIMULATION_SETTINGS(startTime = i_settings_startTime, stopTime = i_settings_stopTime, stepSize = i_settings_stepSize, numberOfIntervals = i_settings_numberOfIntervals, tolerance = i_settings_tolerance, method = i_settings_method, outputFormat = i_settings_outputFormat)), fileNamePrefix = i_fileNamePrefix)),
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_preRunCommandLinux,
           a_preRunCommandWindows,
           a_execCommandLinux )
      equation
        l_start = Tpl.writeStr(Tpl.emptyTxt, realString(i_settings_startTime));
        l_end = Tpl.writeStr(Tpl.emptyTxt, realString(i_settings_stopTime));
        l_stepsize = Tpl.writeStr(Tpl.emptyTxt, realString(i_settings_stepSize));
        l_intervals = Tpl.writeStr(Tpl.emptyTxt, intString(i_settings_numberOfIntervals));
        l_tol = Tpl.writeStr(Tpl.emptyTxt, realString(i_settings_tolerance));
        l_solver = fun_47(Tpl.emptyTxt, i_simCode, i_settings_method);
        l_moLib = Tpl.writeStr(Tpl.emptyTxt, i_makefileParams_compileDir);
        l_home = Tpl.writeStr(Tpl.emptyTxt, i_makefileParams_omhome);
        l_outputformat = Tpl.writeStr(Tpl.emptyTxt, i_settings_outputFormat);
        l_modelName = CodegenUtil.dotPath(Tpl.emptyTxt, i_modelInfo_name);
        l_fileNamePrefixx = Tpl.writeStr(Tpl.emptyTxt, i_fileNamePrefix);
        l_platformstr = fun_48(Tpl.emptyTxt, i_makefileParams_platform);
        l_execParameters = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("-S "));
        l_execParameters = Tpl.writeText(l_execParameters, l_start);
        l_execParameters = Tpl.writeTok(l_execParameters, Tpl.ST_STRING(" -E "));
        l_execParameters = Tpl.writeText(l_execParameters, l_end);
        l_execParameters = Tpl.writeTok(l_execParameters, Tpl.ST_STRING(" -H "));
        l_execParameters = Tpl.writeText(l_execParameters, l_stepsize);
        l_execParameters = Tpl.writeTok(l_execParameters, Tpl.ST_STRING(" -G "));
        l_execParameters = Tpl.writeText(l_execParameters, l_intervals);
        l_execParameters = Tpl.writeTok(l_execParameters, Tpl.ST_STRING(" -P "));
        l_execParameters = Tpl.writeText(l_execParameters, l_outputformat);
        l_execParameters = Tpl.writeTok(l_execParameters, Tpl.ST_STRING(" -T "));
        l_execParameters = Tpl.writeText(l_execParameters, l_tol);
        l_execParameters = Tpl.writeTok(l_execParameters, Tpl.ST_STRING(" -I "));
        l_execParameters = Tpl.writeText(l_execParameters, l_solver);
        l_execParameters = Tpl.writeTok(l_execParameters, Tpl.ST_STRING(" -R "));
        ret_13 = Config.simulationCodeTarget();
        (l_execParameters, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = CodegenCpp.simulationLibDir(l_execParameters, ret_13, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
        l_execParameters = Tpl.writeTok(l_execParameters, Tpl.ST_STRING(" -M "));
        l_execParameters = Tpl.writeText(l_execParameters, l_moLib);
        l_execParameters = Tpl.writeTok(l_execParameters, Tpl.ST_STRING(" -r "));
        ret_14 = Testsuite.isRunning();
        (l_execParameters, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = CodegenCpp.simulationResults(l_execParameters, ret_14, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
        l_execParameters = Tpl.writeTok(l_execParameters, Tpl.ST_STRING(" -a "));
        l_execParameters = Tpl.writeText(l_execParameters, l_moLib);
        l_execParameters = Tpl.writeTok(l_execParameters, Tpl.ST_STRING(" -o "));
        l_execParameters = Tpl.writeText(l_execParameters, l_modelName);
        l_execParameters = Tpl.writeTok(l_execParameters, Tpl.ST_STRING(".fmu"));
        ret_16 = stringEq(i_settings_outputFormat, "empty");
        l_outputParameter = fun_49(Tpl.emptyTxt, ret_16);
        ret_18 = Config.simulationCodeTarget();
        (l_libFolder, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = CodegenCpp.simulationLibDir(Tpl.emptyTxt, ret_18, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
        ret_20 = Config.simulationCodeTarget();
        l_binFolder = CodegenCpp.simulationBinDir(Tpl.emptyTxt, ret_20, i_simCode);
        l_libPaths = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(";")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_libPaths = lm_50(l_libPaths, i_makefileParams_libPaths);
        l_libPaths = Tpl.popIter(l_libPaths);
        ret_23 = Flags.getConfigBool(Flags.USE_ZEROMQ_IN_SIM);
        l_zermMQParams = fun_51(Tpl.emptyTxt, ret_23);
        txt = fun_52(txt, i_makefileParams_platform, l_libPaths, l_libFolder, a_preRunCommandWindows, l_outputParameter, l_zermMQParams, l_execParameters, l_binFolder, a_execCommandLinux, a_preRunCommandLinux);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);

    case ( txt,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           _,
           _,
           _ )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
  end match;
end simulationOMSUCPPMainRunScript;

annotation(__OpenModelica_Interface="backend");
end CodegenOMSICpp;