encapsulated package CodegenOMSI_common
"
  file:        CodegenOMSI_common.mo
  package:     CodegenOMSI_common
  description: Generated by Susan.
"

public import Tpl;

public import SimCodeVar;
public import SimCode;
public import SimCodeFunction;
public import SimCodeUtil;
public import BackendDAE;
public import System;
public import Absyn;
public import DAE;
public import Util;
public import List;
protected import CodegenOMSIC_Equations;
protected import CodegenUtil;
protected import CodegenUtilSimulation;
protected import CodegenCFunctions;
protected import CodegenFMU;

public function generateFMUModelDescriptionFile
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input String a_guid;
  input String a_FMUVersion;
  input String a_FMUType;
  input list<String> a_sourceFiles;
  input String a_fileName;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_content;
algorithm
  l_content := CodegenFMU.fmuModelDescriptionFile(Tpl.emptyTxt, a_simCode, a_guid, a_FMUVersion, a_FMUType, a_sourceFiles);
  Tpl.textFile(l_content, a_fileName);
  out_txt := txt;
end generateFMUModelDescriptionFile;

protected function fun_49
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_modelNameOMSIC;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode, in_a_modelNameOMSIC)
    local
      Tpl.Text txt;
      Tpl.Text a_modelNameOMSIC;
      SimCode.OMSIFunction i_initialization;
      String i_fileNamePrefix;
      String i_fullPathPrefix;
      SimCode.OMSIFunction i_simulation;
      Tpl.Text txt_4;
      Tpl.Text l_content_1;
      Tpl.Text txt_2;
      Tpl.Text l_content;
      Tpl.Text l_modelNamePrefix;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = _), fileNamePrefix = i_fileNamePrefix, fullPathPrefix = i_fullPathPrefix, omsiData = SOME(SimCode.OMSI_DATA(simulation = (i_simulation as SimCode.OMSI_FUNCTION(equations = _)), initialization = (i_initialization as SimCode.OMSI_FUNCTION(equations = _))))),
           a_modelNameOMSIC )
      equation
        l_modelNamePrefix = Tpl.writeText(Tpl.emptyTxt, a_modelNameOMSIC);
        l_content = generateOmsiFunctionCode(Tpl.emptyTxt, i_simulation, Tpl.textString(l_modelNamePrefix), "", "sim_eqns");
        txt_2 = Tpl.writeStr(Tpl.emptyTxt, i_fullPathPrefix);
        txt_2 = Tpl.writeTok(txt_2, Tpl.ST_STRING("/"));
        txt_2 = Tpl.writeStr(txt_2, i_fileNamePrefix);
        txt_2 = Tpl.writeTok(txt_2, Tpl.ST_STRING("_sim_eqns.c"));
        Tpl.textFile(l_content, Tpl.textString(txt_2));
        l_content_1 = generateOmsiFunctionCode(Tpl.emptyTxt, i_initialization, Tpl.textString(l_modelNamePrefix), "", "init_eqns");
        txt_4 = Tpl.writeStr(Tpl.emptyTxt, i_fullPathPrefix);
        txt_4 = Tpl.writeTok(txt_4, Tpl.ST_STRING("/"));
        txt_4 = Tpl.writeStr(txt_4, i_fileNamePrefix);
        txt_4 = Tpl.writeTok(txt_4, Tpl.ST_STRING("_init_eqns.c"));
        Tpl.textFile(l_content_1, Tpl.textString(txt_4));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_49;

public function generateEquationsCode
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input String a_FileNamePrefix;

  output Tpl.Text out_txt;
protected
  String ret_1;
  Tpl.Text l_modelNameOMSIC;
algorithm
  ret_1 := System.makeC89Identifier(a_FileNamePrefix);
  l_modelNameOMSIC := Tpl.writeStr(Tpl.emptyTxt, ret_1);
  out_txt := fun_49(txt, a_simCode, l_modelNameOMSIC);
end generateEquationsCode;

protected function fun_51
  input Tpl.Text in_txt;
  input Integer in_a_nAlgebraicSystems;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_nAlgebraicSystems)
    local
      Tpl.Text txt;

    case ( txt,
           0 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("new_status = omsi_ok;"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_51;

protected function fun_52
  input Tpl.Text in_txt;
  input SimCode.OMSIFunction in_a_omsiFunction;
  input Tpl.Text in_a_functionCall;
  input String in_a_omsiName;
  input String in_a_FileNamePrefix;
  input Tpl.Text in_a_evaluationCode;
  input Tpl.Text in_a_initializationCode;
  input Tpl.Text in_a_headerFileName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_omsiFunction, in_a_functionCall, in_a_omsiName, in_a_FileNamePrefix, in_a_evaluationCode, in_a_initializationCode, in_a_headerFileName)
    local
      Tpl.Text txt;
      Tpl.Text a_functionCall;
      String a_omsiName;
      String a_FileNamePrefix;
      Tpl.Text a_evaluationCode;
      Tpl.Text a_initializationCode;
      Tpl.Text a_headerFileName;
      Integer i_nAlgebraicSystems;

    case ( txt,
           SimCode.OMSI_FUNCTION(nAlgebraicSystems = i_nAlgebraicSystems),
           a_functionCall,
           a_omsiName,
           a_FileNamePrefix,
           a_evaluationCode,
           a_initializationCode,
           a_headerFileName )
      equation
        txt = insertCopyrightOpenModelica(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("  /* All Equations Code */\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#include \""));
        txt = Tpl.writeText(txt, a_headerFileName);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(".h\"\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "#if defined(__cplusplus)\n",
                                    "extern \"C\" {\n",
                                    "#endif\n",
                                    "\n",
                                    "/* Instantiation of omsi_function_t */\n"
                                }, true));
        txt = Tpl.writeText(txt, a_initializationCode);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "/* Evaluation functions for each equation */\n"
                                }, true));
        txt = Tpl.writeText(txt, a_evaluationCode);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "\n",
                                    "/* Equations evaluation */\n",
                                    "omsi_status "
                                }, false));
        txt = Tpl.writeStr(txt, a_FileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeStr(txt, a_omsiName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_allEqns(omsi_function_t* "));
        txt = Tpl.writeStr(txt, a_omsiName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ", omsi_values* model_vars_and_params, void* data){\n",
                                    "\n",
                                    "\n",
                                    "  /* Variables */\n",
                                    "  omsi_status status, new_status;\n",
                                    "\n",
                                    "  status = omsi_ok;\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = fun_51(txt, i_nAlgebraicSystems);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_functionCall);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "return status;\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n",
                                    "#if defined(__cplusplus)\n",
                                    "}\n",
                                    "#endif\n"
                                }, true));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _,
           _,
           _,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_52;

public function generateOmsiFunctionCode
  input Tpl.Text txt;
  input SimCode.OMSIFunction a_omsiFunction;
  input String a_FileNamePrefix;
  input String a_modelFunctionnamePrefixStr;
  input String a_omsiName;

  output Tpl.Text out_txt;
protected
  Tpl.Text txt_12;
  Tpl.Text l_headerFileContent;
  Tpl.Text l_headerFileName;
  Tpl.Text l_0__;
  Tpl.Text l_initializationCode;
  SimCode.SimCode ret_7;
  Tpl.Text l_fullPathPrefix;
  SimCode.SimCode ret_5;
  Tpl.Text l_fileNamePrefix;
  Tpl.Text l_functionPrototypes;
  Tpl.Text l_functionCall;
  Tpl.Text l_evaluationCode;
  Tpl.Text l_includes;
algorithm
  l_includes := Tpl.emptyTxt;
  l_evaluationCode := Tpl.emptyTxt;
  l_functionCall := Tpl.emptyTxt;
  l_functionPrototypes := Tpl.emptyTxt;
  ret_5 := SimCodeUtil.getSimCode();
  l_fileNamePrefix := CodegenUtilSimulation.fileNamePrefix(Tpl.emptyTxt, ret_5);
  ret_7 := SimCodeUtil.getSimCode();
  l_fullPathPrefix := CodegenUtilSimulation.fullPathPrefix(Tpl.emptyTxt, ret_7);
  (l_initializationCode, l_functionPrototypes, l_includes) := generateInitalizationOMSIFunction(Tpl.emptyTxt, a_omsiFunction, "allEqns", a_FileNamePrefix, a_modelFunctionnamePrefixStr, l_functionPrototypes, l_includes, false, a_omsiName);
  (l_0__, l_includes, l_evaluationCode, l_functionCall, _, l_functionPrototypes) := generateOmsiFunctionCode_inner(Tpl.emptyTxt, a_omsiFunction, a_FileNamePrefix, a_modelFunctionnamePrefixStr, a_omsiName, l_includes, l_evaluationCode, l_functionCall, Tpl.strTokText(Tpl.ST_STRING("")), l_functionPrototypes, a_omsiName);
  l_functionPrototypes := Tpl.writeTok(l_functionPrototypes, Tpl.ST_STRING("omsi_status "));
  l_functionPrototypes := Tpl.writeStr(l_functionPrototypes, a_FileNamePrefix);
  l_functionPrototypes := Tpl.writeTok(l_functionPrototypes, Tpl.ST_STRING("_"));
  l_functionPrototypes := Tpl.writeStr(l_functionPrototypes, a_omsiName);
  l_functionPrototypes := Tpl.writeTok(l_functionPrototypes, Tpl.ST_STRING("_allEqns(omsi_function_t* simulation, omsi_values* model_vars_and_params, void* data);"));
  l_functionPrototypes := Tpl.writeTok(l_functionPrototypes, Tpl.ST_NEW_LINE());
  l_headerFileName := Tpl.writeText(Tpl.emptyTxt, l_fileNamePrefix);
  l_headerFileName := Tpl.writeTok(l_headerFileName, Tpl.ST_STRING("_"));
  l_headerFileName := Tpl.writeStr(l_headerFileName, a_omsiName);
  (l_headerFileContent, l_includes, l_functionPrototypes) := generateCodeHeader(Tpl.emptyTxt, a_FileNamePrefix, l_includes, Tpl.textString(l_headerFileName), l_functionPrototypes);
  txt_12 := Tpl.writeText(Tpl.emptyTxt, l_fullPathPrefix);
  txt_12 := Tpl.writeTok(txt_12, Tpl.ST_STRING("/"));
  txt_12 := Tpl.writeText(txt_12, l_headerFileName);
  txt_12 := Tpl.writeTok(txt_12, Tpl.ST_STRING(".h"));
  Tpl.textFile(l_headerFileContent, Tpl.textString(txt_12));
  out_txt := fun_52(txt, a_omsiFunction, l_functionCall, a_omsiName, a_FileNamePrefix, l_evaluationCode, l_initializationCode, l_headerFileName);
end generateOmsiFunctionCode;

public function lastIdentOfPath
  input Tpl.Text in_txt;
  input Absyn.Path in_a_modelName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelName)
    local
      Tpl.Text txt;
      String i_name;
      Absyn.Path i_path;

    case ( txt,
           Absyn.QUALIFIED(path = i_path) )
      equation
        txt = lastIdentOfPath(txt, i_path);
      then txt;

    case ( txt,
           Absyn.IDENT(name = i_name) )
      equation
        txt = Tpl.writeStr(txt, i_name);
      then txt;

    case ( txt,
           Absyn.FULLYQUALIFIED(path = i_path) )
      equation
        txt = lastIdentOfPath(txt, i_path);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end lastIdentOfPath;

protected function fun_55
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eqsystem;
  input Tpl.Text in_a_fullPathPrefix;
  input Tpl.Text in_a_fileNamePrefix;
  input Tpl.Text in_a_includes;
  input Tpl.Text in_a_residualCall;
  input String in_a_omsiName;
  input String in_a_funcCallArgName;
  input Tpl.Text in_a_functionCall;
  input Tpl.Text in_a_functionPrototypes;
  input SimCodeFunction.Context in_a_context;
  input String in_a_modelFunctionnamePrefixStr;
  input String in_a_FileNamePrefix;
  input Tpl.Text in_a_evaluationCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_includes;
  output Tpl.Text out_a_residualCall;
  output Tpl.Text out_a_functionCall;
  output Tpl.Text out_a_functionPrototypes;
  output Tpl.Text out_a_evaluationCode;
algorithm
  (out_txt, out_a_includes, out_a_residualCall, out_a_functionCall, out_a_functionPrototypes, out_a_evaluationCode) :=
  match(in_txt, in_a_eqsystem, in_a_fullPathPrefix, in_a_fileNamePrefix, in_a_includes, in_a_residualCall, in_a_omsiName, in_a_funcCallArgName, in_a_functionCall, in_a_functionPrototypes, in_a_context, in_a_modelFunctionnamePrefixStr, in_a_FileNamePrefix, in_a_evaluationCode)
    local
      Tpl.Text txt;
      Tpl.Text a_fullPathPrefix;
      Tpl.Text a_fileNamePrefix;
      Tpl.Text a_includes;
      Tpl.Text a_residualCall;
      String a_omsiName;
      String a_funcCallArgName;
      Tpl.Text a_functionCall;
      Tpl.Text a_functionPrototypes;
      SimCodeFunction.Context a_context;
      String a_modelFunctionnamePrefixStr;
      String a_FileNamePrefix;
      Tpl.Text a_evaluationCode;
      SimCode.SimEqSystem i_whenEq;
      Integer i_algSystem_algSysIndex;
      SimCode.SimEqSystem i_algSystem;
      Integer i_algSysIndex;
      SimCode.SimEqSystem i_eqsystem;
      Tpl.Text txt_5;
      Tpl.Text txt_4;
      Tpl.Text l_content;
      Tpl.Text txt_2;
      Tpl.Text txt_1;
      Tpl.Text txt_0;

    case ( txt,
           (i_eqsystem as SimCode.SES_SIMPLE_ASSIGN(index = _)),
           _,
           _,
           a_includes,
           a_residualCall,
           a_omsiName,
           a_funcCallArgName,
           a_functionCall,
           a_functionPrototypes,
           a_context,
           a_modelFunctionnamePrefixStr,
           a_FileNamePrefix,
           a_evaluationCode )
      equation
        (a_evaluationCode, a_functionPrototypes) = CodegenOMSIC_Equations.generateEquationFunction(a_evaluationCode, i_eqsystem, a_FileNamePrefix, a_modelFunctionnamePrefixStr, a_context, a_functionPrototypes);
        a_evaluationCode = Tpl.writeTok(a_evaluationCode, Tpl.ST_NEW_LINE());
        txt_0 = Tpl.writeStr(Tpl.emptyTxt, a_funcCallArgName);
        txt_0 = Tpl.writeTok(txt_0, Tpl.ST_STRING(", model_vars_and_params"));
        a_functionCall = CodegenOMSIC_Equations.equationCall(a_functionCall, i_eqsystem, a_FileNamePrefix, a_modelFunctionnamePrefixStr, Tpl.textString(txt_0), a_omsiName);
        a_functionCall = Tpl.writeTok(a_functionCall, Tpl.ST_NEW_LINE());
      then (txt, a_includes, a_residualCall, a_functionCall, a_functionPrototypes, a_evaluationCode);

    case ( txt,
           (i_eqsystem as SimCode.SES_RESIDUAL(index = _)),
           _,
           _,
           a_includes,
           a_residualCall,
           a_omsiName,
           a_funcCallArgName,
           a_functionCall,
           a_functionPrototypes,
           a_context,
           a_modelFunctionnamePrefixStr,
           a_FileNamePrefix,
           a_evaluationCode )
      equation
        (a_evaluationCode, a_functionPrototypes) = CodegenOMSIC_Equations.generateEquationFunction(a_evaluationCode, i_eqsystem, a_FileNamePrefix, a_modelFunctionnamePrefixStr, a_context, a_functionPrototypes);
        a_evaluationCode = Tpl.writeTok(a_evaluationCode, Tpl.ST_NEW_LINE());
        txt_1 = Tpl.writeStr(Tpl.emptyTxt, a_funcCallArgName);
        txt_1 = Tpl.writeTok(txt_1, Tpl.ST_STRING(", model_vars_and_params, &res[i++]"));
        a_residualCall = CodegenOMSIC_Equations.equationCall(a_residualCall, i_eqsystem, a_FileNamePrefix, a_modelFunctionnamePrefixStr, Tpl.textString(txt_1), a_omsiName);
        a_residualCall = Tpl.writeTok(a_residualCall, Tpl.ST_NEW_LINE());
      then (txt, a_includes, a_residualCall, a_functionCall, a_functionPrototypes, a_evaluationCode);

    case ( txt,
           (i_algSystem as SimCode.SES_ALGEBRAIC_SYSTEM(algSysIndex = (i_algSystem_algSysIndex as i_algSysIndex))),
           a_fullPathPrefix,
           a_fileNamePrefix,
           a_includes,
           a_residualCall,
           a_omsiName,
           a_funcCallArgName,
           a_functionCall,
           a_functionPrototypes,
           _,
           a_modelFunctionnamePrefixStr,
           a_FileNamePrefix,
           a_evaluationCode )
      equation
        a_includes = Tpl.writeTok(a_includes, Tpl.ST_STRING("#include \""));
        a_includes = Tpl.writeText(a_includes, a_fileNamePrefix);
        a_includes = Tpl.writeTok(a_includes, Tpl.ST_STRING("_"));
        a_includes = Tpl.writeStr(a_includes, a_omsiName);
        a_includes = Tpl.writeTok(a_includes, Tpl.ST_STRING("_algSyst_"));
        a_includes = Tpl.writeStr(a_includes, intString(i_algSysIndex));
        a_includes = Tpl.writeTok(a_includes, Tpl.ST_STRING(".h\""));
        a_includes = Tpl.writeTok(a_includes, Tpl.ST_NEW_LINE());
        txt_2 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("&"));
        txt_2 = Tpl.writeStr(txt_2, a_funcCallArgName);
        txt_2 = Tpl.writeTok(txt_2, Tpl.ST_STRING("->algebraic_system_t["));
        txt_2 = Tpl.writeStr(txt_2, intString(i_algSysIndex));
        txt_2 = Tpl.writeTok(txt_2, Tpl.ST_STRING("], model_vars_and_params, "));
        txt_2 = Tpl.writeStr(txt_2, a_omsiName);
        txt_2 = Tpl.writeTok(txt_2, Tpl.ST_STRING("->function_vars"));
        a_functionCall = CodegenOMSIC_Equations.equationCall(a_functionCall, i_algSystem, a_FileNamePrefix, a_modelFunctionnamePrefixStr, Tpl.textString(txt_2), a_omsiName);
        a_functionCall = Tpl.writeTok(a_functionCall, Tpl.ST_NEW_LINE());
        l_content = generateOmsiAlgSystemCode(Tpl.emptyTxt, i_algSystem, a_FileNamePrefix, a_omsiName);
        txt_4 = Tpl.writeText(Tpl.emptyTxt, a_fullPathPrefix);
        txt_4 = Tpl.writeTok(txt_4, Tpl.ST_STRING("/"));
        txt_4 = Tpl.writeText(txt_4, a_fileNamePrefix);
        txt_4 = Tpl.writeTok(txt_4, Tpl.ST_STRING("_"));
        txt_4 = Tpl.writeStr(txt_4, a_omsiName);
        txt_4 = Tpl.writeTok(txt_4, Tpl.ST_STRING("_algSyst_"));
        txt_4 = Tpl.writeStr(txt_4, intString(i_algSystem_algSysIndex));
        txt_4 = Tpl.writeTok(txt_4, Tpl.ST_STRING(".c"));
        Tpl.textFile(l_content, Tpl.textString(txt_4));
      then (txt, a_includes, a_residualCall, a_functionCall, a_functionPrototypes, a_evaluationCode);

    case ( txt,
           (i_whenEq as SimCode.SES_WHEN(index = _)),
           _,
           _,
           a_includes,
           a_residualCall,
           a_omsiName,
           a_funcCallArgName,
           a_functionCall,
           a_functionPrototypes,
           a_context,
           a_modelFunctionnamePrefixStr,
           a_FileNamePrefix,
           a_evaluationCode )
      equation
        (a_evaluationCode, a_functionPrototypes) = CodegenOMSIC_Equations.generateEquationFunction(a_evaluationCode, i_whenEq, a_FileNamePrefix, a_modelFunctionnamePrefixStr, a_context, a_functionPrototypes);
        a_evaluationCode = Tpl.writeTok(a_evaluationCode, Tpl.ST_NEW_LINE());
        txt_5 = Tpl.writeStr(Tpl.emptyTxt, a_funcCallArgName);
        txt_5 = Tpl.writeTok(txt_5, Tpl.ST_STRING(", model_vars_and_params"));
        a_functionCall = CodegenOMSIC_Equations.equationCall(a_functionCall, i_whenEq, a_FileNamePrefix, a_modelFunctionnamePrefixStr, Tpl.textString(txt_5), a_omsiName);
        a_functionCall = Tpl.writeTok(a_functionCall, Tpl.ST_NEW_LINE());
      then (txt, a_includes, a_residualCall, a_functionCall, a_functionPrototypes, a_evaluationCode);

    case ( txt,
           _,
           _,
           _,
           a_includes,
           a_residualCall,
           _,
           _,
           a_functionCall,
           a_functionPrototypes,
           _,
           _,
           _,
           a_evaluationCode )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("TODO: Equation not implemented"));
      then (txt, a_includes, a_residualCall, a_functionCall, a_functionPrototypes, a_evaluationCode);
  end match;
end fun_55;

protected function lm_56
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input Tpl.Text in_a_fullPathPrefix;
  input Tpl.Text in_a_fileNamePrefix;
  input Tpl.Text in_a_includes;
  input Tpl.Text in_a_residualCall;
  input String in_a_omsiName;
  input String in_a_funcCallArgName;
  input Tpl.Text in_a_functionCall;
  input Tpl.Text in_a_functionPrototypes;
  input SimCodeFunction.Context in_a_context;
  input String in_a_modelFunctionnamePrefixStr;
  input String in_a_FileNamePrefix;
  input Tpl.Text in_a_evaluationCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_includes;
  output Tpl.Text out_a_residualCall;
  output Tpl.Text out_a_functionCall;
  output Tpl.Text out_a_functionPrototypes;
  output Tpl.Text out_a_evaluationCode;
algorithm
  (out_txt, out_a_includes, out_a_residualCall, out_a_functionCall, out_a_functionPrototypes, out_a_evaluationCode) :=
  match(in_txt, in_items, in_a_fullPathPrefix, in_a_fileNamePrefix, in_a_includes, in_a_residualCall, in_a_omsiName, in_a_funcCallArgName, in_a_functionCall, in_a_functionPrototypes, in_a_context, in_a_modelFunctionnamePrefixStr, in_a_FileNamePrefix, in_a_evaluationCode)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      Tpl.Text a_fullPathPrefix;
      Tpl.Text a_fileNamePrefix;
      Tpl.Text a_includes;
      Tpl.Text a_residualCall;
      String a_omsiName;
      String a_funcCallArgName;
      Tpl.Text a_functionCall;
      Tpl.Text a_functionPrototypes;
      SimCodeFunction.Context a_context;
      String a_modelFunctionnamePrefixStr;
      String a_FileNamePrefix;
      Tpl.Text a_evaluationCode;
      SimCode.SimEqSystem i_eqsystem;

    case ( txt,
           {},
           _,
           _,
           a_includes,
           a_residualCall,
           _,
           _,
           a_functionCall,
           a_functionPrototypes,
           _,
           _,
           _,
           a_evaluationCode )
      then (txt, a_includes, a_residualCall, a_functionCall, a_functionPrototypes, a_evaluationCode);

    case ( txt,
           i_eqsystem :: rest,
           a_fullPathPrefix,
           a_fileNamePrefix,
           a_includes,
           a_residualCall,
           a_omsiName,
           a_funcCallArgName,
           a_functionCall,
           a_functionPrototypes,
           a_context,
           a_modelFunctionnamePrefixStr,
           a_FileNamePrefix,
           a_evaluationCode )
      equation
        (txt, a_includes, a_residualCall, a_functionCall, a_functionPrototypes, a_evaluationCode) = fun_55(txt, i_eqsystem, a_fullPathPrefix, a_fileNamePrefix, a_includes, a_residualCall, a_omsiName, a_funcCallArgName, a_functionCall, a_functionPrototypes, a_context, a_modelFunctionnamePrefixStr, a_FileNamePrefix, a_evaluationCode);
        (txt, a_includes, a_residualCall, a_functionCall, a_functionPrototypes, a_evaluationCode) = lm_56(txt, rest, a_fullPathPrefix, a_fileNamePrefix, a_includes, a_residualCall, a_omsiName, a_funcCallArgName, a_functionCall, a_functionPrototypes, a_context, a_modelFunctionnamePrefixStr, a_FileNamePrefix, a_evaluationCode);
      then (txt, a_includes, a_residualCall, a_functionCall, a_functionPrototypes, a_evaluationCode);
  end match;
end lm_56;

protected function fun_57
  input Tpl.Text in_txt;
  input SimCode.OMSIFunction in_a_omsiFunction;
  input Tpl.Text in_a_fullPathPrefix;
  input Tpl.Text in_a_fileNamePrefix;
  input Tpl.Text in_a_includes;
  input Tpl.Text in_a_residualCall;
  input String in_a_omsiName;
  input String in_a_funcCallArgName;
  input Tpl.Text in_a_functionCall;
  input Tpl.Text in_a_functionPrototypes;
  input String in_a_modelFunctionnamePrefixStr;
  input String in_a_FileNamePrefix;
  input Tpl.Text in_a_evaluationCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_includes;
  output Tpl.Text out_a_residualCall;
  output Tpl.Text out_a_functionCall;
  output Tpl.Text out_a_functionPrototypes;
  output Tpl.Text out_a_evaluationCode;
algorithm
  (out_txt, out_a_includes, out_a_residualCall, out_a_functionCall, out_a_functionPrototypes, out_a_evaluationCode) :=
  match(in_txt, in_a_omsiFunction, in_a_fullPathPrefix, in_a_fileNamePrefix, in_a_includes, in_a_residualCall, in_a_omsiName, in_a_funcCallArgName, in_a_functionCall, in_a_functionPrototypes, in_a_modelFunctionnamePrefixStr, in_a_FileNamePrefix, in_a_evaluationCode)
    local
      Tpl.Text txt;
      Tpl.Text a_fullPathPrefix;
      Tpl.Text a_fileNamePrefix;
      Tpl.Text a_includes;
      Tpl.Text a_residualCall;
      String a_omsiName;
      String a_funcCallArgName;
      Tpl.Text a_functionCall;
      Tpl.Text a_functionPrototypes;
      String a_modelFunctionnamePrefixStr;
      String a_FileNamePrefix;
      Tpl.Text a_evaluationCode;
      SimCodeFunction.Context i_context;
      list<SimCode.SimEqSystem> i_equations;
      Tpl.Text l_0__;

    case ( txt,
           SimCode.OMSI_FUNCTION(context = (i_context as SimCodeFunction.OMSI_CONTEXT(hashTable = _)), equations = i_equations),
           a_fullPathPrefix,
           a_fileNamePrefix,
           a_includes,
           a_residualCall,
           a_omsiName,
           a_funcCallArgName,
           a_functionCall,
           a_functionPrototypes,
           a_modelFunctionnamePrefixStr,
           a_FileNamePrefix,
           a_evaluationCode )
      equation
        (l_0__, a_includes, a_residualCall, a_functionCall, a_functionPrototypes, a_evaluationCode) = lm_56(Tpl.emptyTxt, i_equations, a_fullPathPrefix, a_fileNamePrefix, a_includes, a_residualCall, a_omsiName, a_funcCallArgName, a_functionCall, a_functionPrototypes, i_context, a_modelFunctionnamePrefixStr, a_FileNamePrefix, a_evaluationCode);
      then (txt, a_includes, a_residualCall, a_functionCall, a_functionPrototypes, a_evaluationCode);

    case ( txt,
           _,
           _,
           _,
           a_includes,
           a_residualCall,
           _,
           _,
           a_functionCall,
           a_functionPrototypes,
           _,
           _,
           a_evaluationCode )
      then (txt, a_includes, a_residualCall, a_functionCall, a_functionPrototypes, a_evaluationCode);
  end match;
end fun_57;

public function generateOmsiFunctionCode_inner
  input Tpl.Text txt;
  input SimCode.OMSIFunction a_omsiFunction;
  input String a_FileNamePrefix;
  input String a_modelFunctionnamePrefixStr;
  input String a_funcCallArgName;
  input Tpl.Text a_includes;
  input Tpl.Text a_evaluationCode;
  input Tpl.Text a_functionCall;
  input Tpl.Text a_residualCall;
  input Tpl.Text a_functionPrototypes;
  input String a_omsiName;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_includes;
  output Tpl.Text out_a_evaluationCode;
  output Tpl.Text out_a_functionCall;
  output Tpl.Text out_a_residualCall;
  output Tpl.Text out_a_functionPrototypes;
protected
  SimCode.SimCode ret_3;
  Tpl.Text l_fullPathPrefix;
  SimCode.SimCode ret_1;
  Tpl.Text l_fileNamePrefix;
algorithm
  ret_1 := SimCodeUtil.getSimCode();
  l_fileNamePrefix := CodegenUtilSimulation.fileNamePrefix(Tpl.emptyTxt, ret_1);
  ret_3 := SimCodeUtil.getSimCode();
  l_fullPathPrefix := CodegenUtilSimulation.fullPathPrefix(Tpl.emptyTxt, ret_3);
  (out_txt, out_a_includes, out_a_residualCall, out_a_functionCall, out_a_functionPrototypes, out_a_evaluationCode) := fun_57(txt, a_omsiFunction, l_fullPathPrefix, l_fileNamePrefix, a_includes, a_residualCall, a_omsiName, a_funcCallArgName, a_functionCall, a_functionPrototypes, a_modelFunctionnamePrefixStr, a_FileNamePrefix, a_evaluationCode);
end generateOmsiFunctionCode_inner;

protected function fun_59
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eqsystem;
  input Tpl.Text in_a_functionPrototypes;
  input SimCodeFunction.Context in_a_context;
  input String in_a_FunctionnamePrefix;
  input String in_a_FileNamePrefix;
  input Tpl.Text in_a_evaluationCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_functionPrototypes;
  output Tpl.Text out_a_evaluationCode;
algorithm
  (out_txt, out_a_functionPrototypes, out_a_evaluationCode) :=
  match(in_txt, in_a_eqsystem, in_a_functionPrototypes, in_a_context, in_a_FunctionnamePrefix, in_a_FileNamePrefix, in_a_evaluationCode)
    local
      Tpl.Text txt;
      Tpl.Text a_functionPrototypes;
      SimCodeFunction.Context a_context;
      String a_FunctionnamePrefix;
      String a_FileNamePrefix;
      Tpl.Text a_evaluationCode;
      SimCode.SimEqSystem i_whenEq;
      SimCode.SimEqSystem i_eqsystem;

    case ( txt,
           (i_eqsystem as SimCode.SES_SIMPLE_ASSIGN(index = _)),
           a_functionPrototypes,
           a_context,
           a_FunctionnamePrefix,
           a_FileNamePrefix,
           a_evaluationCode )
      equation
        (a_evaluationCode, a_functionPrototypes) = CodegenOMSIC_Equations.generateEquationFunction(a_evaluationCode, i_eqsystem, a_FileNamePrefix, a_FunctionnamePrefix, a_context, a_functionPrototypes);
        a_evaluationCode = Tpl.writeTok(a_evaluationCode, Tpl.ST_NEW_LINE());
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
      then (txt, a_functionPrototypes, a_evaluationCode);

    case ( txt,
           (i_eqsystem as SimCode.SES_RESIDUAL(index = _)),
           a_functionPrototypes,
           a_context,
           a_FunctionnamePrefix,
           a_FileNamePrefix,
           a_evaluationCode )
      equation
        (a_evaluationCode, a_functionPrototypes) = CodegenOMSIC_Equations.generateEquationFunction(a_evaluationCode, i_eqsystem, a_FileNamePrefix, a_FunctionnamePrefix, a_context, a_functionPrototypes);
        a_evaluationCode = Tpl.writeTok(a_evaluationCode, Tpl.ST_NEW_LINE());
      then (txt, a_functionPrototypes, a_evaluationCode);

    case ( txt,
           SimCode.SES_ALGEBRAIC_SYSTEM(index = _),
           a_functionPrototypes,
           _,
           _,
           _,
           a_evaluationCode )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("TODO: Equation  SES_ALGEBRAIC_SYSTEM not implemented yet"));
      then (txt, a_functionPrototypes, a_evaluationCode);

    case ( txt,
           (i_whenEq as SimCode.SES_WHEN(index = _)),
           a_functionPrototypes,
           a_context,
           a_FunctionnamePrefix,
           a_FileNamePrefix,
           a_evaluationCode )
      equation
        (a_evaluationCode, a_functionPrototypes) = CodegenOMSIC_Equations.generateEquationFunction(a_evaluationCode, i_whenEq, a_FileNamePrefix, a_FunctionnamePrefix, a_context, a_functionPrototypes);
        a_evaluationCode = Tpl.writeTok(a_evaluationCode, Tpl.ST_NEW_LINE());
      then (txt, a_functionPrototypes, a_evaluationCode);

    case ( txt,
           _,
           a_functionPrototypes,
           _,
           _,
           _,
           a_evaluationCode )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("TODO: Equation not implemented"));
      then (txt, a_functionPrototypes, a_evaluationCode);
  end match;
end fun_59;

protected function lm_60
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input Tpl.Text in_a_functionPrototypes;
  input SimCodeFunction.Context in_a_context;
  input String in_a_FunctionnamePrefix;
  input String in_a_FileNamePrefix;
  input Tpl.Text in_a_evaluationCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_functionPrototypes;
  output Tpl.Text out_a_evaluationCode;
algorithm
  (out_txt, out_a_functionPrototypes, out_a_evaluationCode) :=
  match(in_txt, in_items, in_a_functionPrototypes, in_a_context, in_a_FunctionnamePrefix, in_a_FileNamePrefix, in_a_evaluationCode)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      Tpl.Text a_functionPrototypes;
      SimCodeFunction.Context a_context;
      String a_FunctionnamePrefix;
      String a_FileNamePrefix;
      Tpl.Text a_evaluationCode;
      SimCode.SimEqSystem i_eqsystem;

    case ( txt,
           {},
           a_functionPrototypes,
           _,
           _,
           _,
           a_evaluationCode )
      then (txt, a_functionPrototypes, a_evaluationCode);

    case ( txt,
           i_eqsystem :: rest,
           a_functionPrototypes,
           a_context,
           a_FunctionnamePrefix,
           a_FileNamePrefix,
           a_evaluationCode )
      equation
        (txt, a_functionPrototypes, a_evaluationCode) = fun_59(txt, i_eqsystem, a_functionPrototypes, a_context, a_FunctionnamePrefix, a_FileNamePrefix, a_evaluationCode);
        (txt, a_functionPrototypes, a_evaluationCode) = lm_60(txt, rest, a_functionPrototypes, a_context, a_FunctionnamePrefix, a_FileNamePrefix, a_evaluationCode);
      then (txt, a_functionPrototypes, a_evaluationCode);
  end match;
end lm_60;

protected function fun_61
  input Tpl.Text in_txt;
  input SimCode.OMSIFunction in_a_omsiFunction;
  input Tpl.Text in_a_functionPrototypes;
  input String in_a_FunctionnamePrefix;
  input String in_a_FileNamePrefix;
  input Tpl.Text in_a_evaluationCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_functionPrototypes;
  output Tpl.Text out_a_evaluationCode;
algorithm
  (out_txt, out_a_functionPrototypes, out_a_evaluationCode) :=
  match(in_txt, in_a_omsiFunction, in_a_functionPrototypes, in_a_FunctionnamePrefix, in_a_FileNamePrefix, in_a_evaluationCode)
    local
      Tpl.Text txt;
      Tpl.Text a_functionPrototypes;
      String a_FunctionnamePrefix;
      String a_FileNamePrefix;
      Tpl.Text a_evaluationCode;
      SimCodeFunction.Context i_context;
      list<SimCode.SimEqSystem> i_equations;
      Tpl.Text l_0__;

    case ( txt,
           SimCode.OMSI_FUNCTION(context = (i_context as SimCodeFunction.OMSI_CONTEXT(hashTable = _)), equations = i_equations),
           a_functionPrototypes,
           a_FunctionnamePrefix,
           a_FileNamePrefix,
           a_evaluationCode )
      equation
        (l_0__, a_functionPrototypes, a_evaluationCode) = lm_60(Tpl.emptyTxt, i_equations, a_functionPrototypes, i_context, a_FunctionnamePrefix, a_FileNamePrefix, a_evaluationCode);
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("virtual omsi_status initialize_omsi_"));
        txt = Tpl.writeStr(txt, a_FunctionnamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_functions (omsi_function_t* omsi_function);\n",
                                    "virtual omsi_status omsi_"
                                }, false));
        txt = Tpl.writeStr(txt, a_FunctionnamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("All(omsi_function_t* simulation, const omsi_values* model_vars_and_params, void* data);\n"));
        txt = Tpl.writeText(txt, a_functionPrototypes);
        txt = Tpl.popBlock(txt);
      then (txt, a_functionPrototypes, a_evaluationCode);

    case ( txt,
           _,
           a_functionPrototypes,
           _,
           _,
           a_evaluationCode )
      then (txt, a_functionPrototypes, a_evaluationCode);
  end match;
end fun_61;

public function generateOmsiMemberFunction
  input Tpl.Text txt;
  input SimCode.OMSIFunction a_omsiFunction;
  input String a_FileNamePrefix;
  input String a_FunctionnamePrefix;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_functionPrototypes;
  Tpl.Text l_evaluationCode;
algorithm
  l_evaluationCode := Tpl.emptyTxt;
  l_functionPrototypes := Tpl.emptyTxt;
  (out_txt, l_functionPrototypes, l_evaluationCode) := fun_61(txt, a_omsiFunction, l_functionPrototypes, a_FunctionnamePrefix, a_FileNamePrefix, l_evaluationCode);
end generateOmsiMemberFunction;

protected function fun_63
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_equationSystem;
  input Tpl.Text in_a_fullPathPrefix;
  input Tpl.Text in_a_fileNamePrefix;
  input Tpl.Text in_a_residualCall;
  input Tpl.Text in_a_functionCall;
  input Tpl.Text in_a_evaluationCode;
  input String in_a_omsiName;
  input Tpl.Text in_a_functionPrototypes;
  input String in_a_FileNamePrefix;
  input Tpl.Text in_a_includes;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_residualCall;
  output Tpl.Text out_a_functionCall;
  output Tpl.Text out_a_evaluationCode;
  output Tpl.Text out_a_functionPrototypes;
  output Tpl.Text out_a_includes;
algorithm
  (out_txt, out_a_residualCall, out_a_functionCall, out_a_evaluationCode, out_a_functionPrototypes, out_a_includes) :=
  match(in_txt, in_a_equationSystem, in_a_fullPathPrefix, in_a_fileNamePrefix, in_a_residualCall, in_a_functionCall, in_a_evaluationCode, in_a_omsiName, in_a_functionPrototypes, in_a_FileNamePrefix, in_a_includes)
    local
      Tpl.Text txt;
      Tpl.Text a_fullPathPrefix;
      Tpl.Text a_fileNamePrefix;
      Tpl.Text a_residualCall;
      Tpl.Text a_functionCall;
      Tpl.Text a_evaluationCode;
      String a_omsiName;
      Tpl.Text a_functionPrototypes;
      String a_FileNamePrefix;
      Tpl.Text a_includes;
      Option<SimCode.DerivativeMatrix> i_matrix;
      Integer i_algSystem_algSysIndex;
      SimCode.OMSIFunction i_residual;
      SimCode.SimEqSystem i_algSystem;
      Tpl.Text txt_10;
      Tpl.Text l_0___1;
      list<SimCode.SimEqSystem> ret_8;
      Tpl.Text txt_7;
      Tpl.Text l_headerFileContent;
      Tpl.Text l_headerFileName;
      Tpl.Text l_matrixString;
      list<SimCode.SimEqSystem> ret_3;
      Tpl.Text l_equationInfos;
      Tpl.Text l_0__;
      Tpl.Text l_initlaizationFunction;

    case ( txt,
           (i_algSystem as SimCode.SES_ALGEBRAIC_SYSTEM(matrix = NONE(), residual = i_residual, algSysIndex = i_algSystem_algSysIndex)),
           a_fullPathPrefix,
           a_fileNamePrefix,
           a_residualCall,
           a_functionCall,
           a_evaluationCode,
           a_omsiName,
           a_functionPrototypes,
           a_FileNamePrefix,
           a_includes )
      equation
        a_includes = Tpl.writeTok(a_includes, Tpl.ST_STRING("#include <omsi_solve_alg_system.h>"));
        a_includes = Tpl.writeTok(a_includes, Tpl.ST_NEW_LINE());
        (l_initlaizationFunction, a_functionPrototypes, a_includes) = generateInitalizationAlgSystem(Tpl.emptyTxt, i_algSystem, a_FileNamePrefix, a_functionPrototypes, a_includes, a_omsiName);
        (l_0__, a_includes, a_evaluationCode, a_functionCall, a_residualCall, a_functionPrototypes) = generateOmsiFunctionCode_inner(Tpl.emptyTxt, i_residual, a_FileNamePrefix, "", "this_function", a_includes, a_evaluationCode, a_functionCall, a_residualCall, a_functionPrototypes, a_omsiName);
        ret_3 = List.fill(i_algSystem, 1);
        l_equationInfos = CodegenUtilSimulation.dumpEqs(Tpl.emptyTxt, ret_3);
        l_matrixString = Tpl.emptyTxt;
        a_functionPrototypes = Tpl.writeTok(a_functionPrototypes, Tpl.ST_STRING("omsi_status "));
        a_functionPrototypes = Tpl.writeStr(a_functionPrototypes, a_FileNamePrefix);
        a_functionPrototypes = Tpl.writeTok(a_functionPrototypes, Tpl.ST_STRING("_"));
        a_functionPrototypes = Tpl.writeStr(a_functionPrototypes, a_omsiName);
        a_functionPrototypes = Tpl.writeTok(a_functionPrototypes, Tpl.ST_STRING("_resFunction_"));
        a_functionPrototypes = Tpl.writeStr(a_functionPrototypes, intString(i_algSystem_algSysIndex));
        a_functionPrototypes = Tpl.writeTok(a_functionPrototypes, Tpl.ST_STRING_LIST({
                                                                      " (omsi_function_t* this_function, const omsi_values* model_vars_and_params, omsi_real* res);\n",
                                                                      "omsi_status "
                                                                  }, false));
        a_functionPrototypes = Tpl.writeStr(a_functionPrototypes, a_FileNamePrefix);
        a_functionPrototypes = Tpl.writeTok(a_functionPrototypes, Tpl.ST_STRING("_"));
        a_functionPrototypes = Tpl.writeStr(a_functionPrototypes, a_omsiName);
        a_functionPrototypes = Tpl.writeTok(a_functionPrototypes, Tpl.ST_STRING("_algSystFunction_"));
        a_functionPrototypes = Tpl.writeStr(a_functionPrototypes, intString(i_algSystem_algSysIndex));
        a_functionPrototypes = Tpl.writeTok(a_functionPrototypes, Tpl.ST_STRING("(omsi_algebraic_system_t* this_alg_system, const omsi_values* model_vars_and_params, void* data);"));
        l_headerFileName = Tpl.writeText(Tpl.emptyTxt, a_fileNamePrefix);
        l_headerFileName = Tpl.writeTok(l_headerFileName, Tpl.ST_STRING("_"));
        l_headerFileName = Tpl.writeStr(l_headerFileName, a_omsiName);
        l_headerFileName = Tpl.writeTok(l_headerFileName, Tpl.ST_STRING("_algSyst_"));
        l_headerFileName = Tpl.writeStr(l_headerFileName, intString(i_algSystem_algSysIndex));
        (l_headerFileContent, a_includes, a_functionPrototypes) = generateCodeHeader(Tpl.emptyTxt, a_FileNamePrefix, a_includes, Tpl.textString(l_headerFileName), a_functionPrototypes);
        txt_7 = Tpl.writeText(Tpl.emptyTxt, a_fullPathPrefix);
        txt_7 = Tpl.writeTok(txt_7, Tpl.ST_STRING("/"));
        txt_7 = Tpl.writeText(txt_7, l_headerFileName);
        txt_7 = Tpl.writeTok(txt_7, Tpl.ST_STRING(".h"));
        Tpl.textFile(l_headerFileContent, Tpl.textString(txt_7));
        txt = insertCopyrightOpenModelica(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "/* Algebraic system code */\n",
                                    "#include \""
                                }, false));
        txt = Tpl.writeText(txt, l_headerFileName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ".h\"\n",
                                    "\n",
                                    "#if defined(__cplusplus)\n",
                                    "extern \"C\" {\n",
                                    "#endif\n",
                                    "\n",
                                    "/* Instantiation and initialization */\n"
                                }, true));
        txt = Tpl.writeText(txt, l_initlaizationFunction);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_matrixString);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "/* Evaluation functions for "
                                }, false));
        txt = Tpl.writeStr(txt, a_FileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeStr(txt, a_omsiName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_resFunction_"));
        txt = Tpl.writeStr(txt, intString(i_algSystem_algSysIndex));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" */\n"));
        txt = Tpl.writeText(txt, a_evaluationCode);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "omsi_status "
                                }, false));
        txt = Tpl.writeStr(txt, a_FileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeStr(txt, a_omsiName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_resFunction_"));
        txt = Tpl.writeStr(txt, intString(i_algSystem_algSysIndex));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " (omsi_function_t* this_function, const omsi_values* model_vars_and_params, omsi_real* res) {\n",
                                    "  omsi_unsigned_int i=0;\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_functionCall);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, a_residualCall);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "return omsi_ok;\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n",
                                    "/* Algebraic system evaluation */\n",
                                    "/*\n"
                                }, true));
        txt = Tpl.writeText(txt, l_equationInfos);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "*/\n",
                                    "omsi_status "
                                }, false));
        txt = Tpl.writeStr(txt, a_FileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeStr(txt, a_omsiName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_algSystFunction_"));
        txt = Tpl.writeStr(txt, intString(i_algSystem_algSysIndex));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(omsi_algebraic_system_t* this_alg_system,\n",
                                    "                          const omsi_values* model_vars_and_params,\n",
                                    "                          void* data){\n",
                                    "\n",
                                    "  /* Variables */\n",
                                    "  omsi_status status;\n",
                                    "\n",
                                    "  /* Log function call */\n",
                                    "  filtered_base_logger(global_logCategories, log_all, omsi_ok,\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(6));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\"fmi2Evaluate: Solve algebraic system "));
        txt = Tpl.writeStr(txt, intString(i_algSystem_algSysIndex));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ".\");\n",
                                    "\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "  /* call API function something */\n",
                                    "  status = omsi_solve_algebraic_system(this_alg_system, model_vars_and_params);\n",
                                    "\n",
                                    "  return status;\n",
                                    "}\n",
                                    "\n",
                                    "#if defined(__cplusplus)\n",
                                    "}\n",
                                    "#endif\n"
                                }, true));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then (txt, a_residualCall, a_functionCall, a_evaluationCode, a_functionPrototypes, a_includes);

    case ( txt,
           (i_algSystem as SimCode.SES_ALGEBRAIC_SYSTEM(matrix = (i_matrix as SOME(SimCode.DERIVATIVE_MATRIX(columns = _))), residual = i_residual, algSysIndex = i_algSystem_algSysIndex)),
           a_fullPathPrefix,
           a_fileNamePrefix,
           a_residualCall,
           a_functionCall,
           a_evaluationCode,
           a_omsiName,
           a_functionPrototypes,
           a_FileNamePrefix,
           a_includes )
      equation
        a_includes = Tpl.writeTok(a_includes, Tpl.ST_STRING("#include <omsi_solve_alg_system.h>"));
        a_includes = Tpl.writeTok(a_includes, Tpl.ST_NEW_LINE());
        (l_initlaizationFunction, a_functionPrototypes, a_includes) = generateInitalizationAlgSystem(Tpl.emptyTxt, i_algSystem, a_FileNamePrefix, a_functionPrototypes, a_includes, a_omsiName);
        (l_0__, a_includes, a_evaluationCode, a_functionCall, a_residualCall, a_functionPrototypes) = generateOmsiFunctionCode_inner(Tpl.emptyTxt, i_residual, a_FileNamePrefix, "", "this_function", a_includes, a_evaluationCode, a_functionCall, a_residualCall, a_functionPrototypes, a_omsiName);
        ret_8 = List.fill(i_algSystem, 1);
        l_equationInfos = CodegenUtilSimulation.dumpEqs(Tpl.emptyTxt, ret_8);
        l_matrixString = CodegenOMSIC_Equations.generateMatrixInitialization(Tpl.emptyTxt, i_matrix);
        a_includes = Tpl.writeTok(a_includes, Tpl.ST_STRING("#include \""));
        a_includes = Tpl.writeText(a_includes, a_fileNamePrefix);
        a_includes = Tpl.writeTok(a_includes, Tpl.ST_STRING("_"));
        a_includes = Tpl.writeStr(a_includes, a_omsiName);
        a_includes = Tpl.writeTok(a_includes, Tpl.ST_STRING("_derMat_"));
        a_includes = Tpl.writeStr(a_includes, intString(i_algSystem_algSysIndex));
        a_includes = Tpl.writeTok(a_includes, Tpl.ST_STRING(".h\""));
        a_includes = Tpl.writeTok(a_includes, Tpl.ST_NEW_LINE());
        l_0___1 = generateDerivativeFile(Tpl.emptyTxt, i_matrix, a_FileNamePrefix, intString(i_algSystem_algSysIndex), a_omsiName);
        a_functionPrototypes = Tpl.writeTok(a_functionPrototypes, Tpl.ST_STRING("omsi_status "));
        a_functionPrototypes = Tpl.writeStr(a_functionPrototypes, a_FileNamePrefix);
        a_functionPrototypes = Tpl.writeTok(a_functionPrototypes, Tpl.ST_STRING("_"));
        a_functionPrototypes = Tpl.writeStr(a_functionPrototypes, a_omsiName);
        a_functionPrototypes = Tpl.writeTok(a_functionPrototypes, Tpl.ST_STRING("_resFunction_"));
        a_functionPrototypes = Tpl.writeStr(a_functionPrototypes, intString(i_algSystem_algSysIndex));
        a_functionPrototypes = Tpl.writeTok(a_functionPrototypes, Tpl.ST_STRING_LIST({
                                                                      " (omsi_function_t* this_function, const omsi_values* model_vars_and_params, omsi_real* res);\n",
                                                                      "omsi_status "
                                                                  }, false));
        a_functionPrototypes = Tpl.writeStr(a_functionPrototypes, a_FileNamePrefix);
        a_functionPrototypes = Tpl.writeTok(a_functionPrototypes, Tpl.ST_STRING("_"));
        a_functionPrototypes = Tpl.writeStr(a_functionPrototypes, a_omsiName);
        a_functionPrototypes = Tpl.writeTok(a_functionPrototypes, Tpl.ST_STRING("_algSystFunction_"));
        a_functionPrototypes = Tpl.writeStr(a_functionPrototypes, intString(i_algSystem_algSysIndex));
        a_functionPrototypes = Tpl.writeTok(a_functionPrototypes, Tpl.ST_STRING("(omsi_algebraic_system_t* this_alg_system, const omsi_values* model_vars_and_params, void* data);"));
        l_headerFileName = Tpl.writeText(Tpl.emptyTxt, a_fileNamePrefix);
        l_headerFileName = Tpl.writeTok(l_headerFileName, Tpl.ST_STRING("_"));
        l_headerFileName = Tpl.writeStr(l_headerFileName, a_omsiName);
        l_headerFileName = Tpl.writeTok(l_headerFileName, Tpl.ST_STRING("_algSyst_"));
        l_headerFileName = Tpl.writeStr(l_headerFileName, intString(i_algSystem_algSysIndex));
        (l_headerFileContent, a_includes, a_functionPrototypes) = generateCodeHeader(Tpl.emptyTxt, a_FileNamePrefix, a_includes, Tpl.textString(l_headerFileName), a_functionPrototypes);
        txt_10 = Tpl.writeText(Tpl.emptyTxt, a_fullPathPrefix);
        txt_10 = Tpl.writeTok(txt_10, Tpl.ST_STRING("/"));
        txt_10 = Tpl.writeText(txt_10, l_headerFileName);
        txt_10 = Tpl.writeTok(txt_10, Tpl.ST_STRING(".h"));
        Tpl.textFile(l_headerFileContent, Tpl.textString(txt_10));
        txt = insertCopyrightOpenModelica(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "/* Algebraic system code */\n",
                                    "#include \""
                                }, false));
        txt = Tpl.writeText(txt, l_headerFileName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ".h\"\n",
                                    "\n",
                                    "#if defined(__cplusplus)\n",
                                    "extern \"C\" {\n",
                                    "#endif\n",
                                    "\n",
                                    "/* Instantiation and initialization */\n"
                                }, true));
        txt = Tpl.writeText(txt, l_initlaizationFunction);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_matrixString);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "/* Evaluation functions for "
                                }, false));
        txt = Tpl.writeStr(txt, a_FileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeStr(txt, a_omsiName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_resFunction_"));
        txt = Tpl.writeStr(txt, intString(i_algSystem_algSysIndex));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" */\n"));
        txt = Tpl.writeText(txt, a_evaluationCode);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "omsi_status "
                                }, false));
        txt = Tpl.writeStr(txt, a_FileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeStr(txt, a_omsiName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_resFunction_"));
        txt = Tpl.writeStr(txt, intString(i_algSystem_algSysIndex));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " (omsi_function_t* this_function, const omsi_values* model_vars_and_params, omsi_real* res) {\n",
                                    "  omsi_unsigned_int i=0;\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_functionCall);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, a_residualCall);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "return omsi_ok;\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n",
                                    "/* Algebraic system evaluation */\n",
                                    "/*\n"
                                }, true));
        txt = Tpl.writeText(txt, l_equationInfos);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "*/\n",
                                    "omsi_status "
                                }, false));
        txt = Tpl.writeStr(txt, a_FileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeStr(txt, a_omsiName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_algSystFunction_"));
        txt = Tpl.writeStr(txt, intString(i_algSystem_algSysIndex));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(omsi_algebraic_system_t* this_alg_system,\n",
                                    "                          const omsi_values* model_vars_and_params,\n",
                                    "                          void* data){\n",
                                    "\n",
                                    "  /* Variables */\n",
                                    "  omsi_status status;\n",
                                    "\n",
                                    "  /* Log function call */\n",
                                    "  filtered_base_logger(global_logCategories, log_all, omsi_ok,\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(6));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\"fmi2Evaluate: Solve algebraic system "));
        txt = Tpl.writeStr(txt, intString(i_algSystem_algSysIndex));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ".\");\n",
                                    "\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "  /* call API function something */\n",
                                    "  status = omsi_solve_algebraic_system(this_alg_system, model_vars_and_params);\n",
                                    "\n",
                                    "  return status;\n",
                                    "}\n",
                                    "\n",
                                    "#if defined(__cplusplus)\n",
                                    "}\n",
                                    "#endif\n"
                                }, true));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then (txt, a_residualCall, a_functionCall, a_evaluationCode, a_functionPrototypes, a_includes);

    case ( txt,
           _,
           _,
           _,
           a_residualCall,
           a_functionCall,
           a_evaluationCode,
           _,
           a_functionPrototypes,
           _,
           a_includes )
      then (txt, a_residualCall, a_functionCall, a_evaluationCode, a_functionPrototypes, a_includes);
  end match;
end fun_63;

public function generateOmsiAlgSystemCode
  input Tpl.Text txt;
  input SimCode.SimEqSystem a_equationSystem;
  input String a_FileNamePrefix;
  input String a_omsiName;

  output Tpl.Text out_txt;
protected
  SimCode.SimCode ret_9;
  Tpl.Text l_fullPathPrefix;
  SimCode.SimCode ret_7;
  Tpl.Text l_fileNamePrefix;
  Tpl.Text l_functionPrototypes;
  Tpl.Text l_derivativeMatrix;
  Tpl.Text l_residualCall;
  Tpl.Text l_functionCall;
  Tpl.Text l_evaluationCode;
  Tpl.Text l_includes;
algorithm
  l_includes := Tpl.emptyTxt;
  l_evaluationCode := Tpl.emptyTxt;
  l_functionCall := Tpl.emptyTxt;
  l_residualCall := Tpl.emptyTxt;
  l_derivativeMatrix := Tpl.emptyTxt;
  l_functionPrototypes := Tpl.emptyTxt;
  ret_7 := SimCodeUtil.getSimCode();
  l_fileNamePrefix := CodegenUtilSimulation.fileNamePrefix(Tpl.emptyTxt, ret_7);
  ret_9 := SimCodeUtil.getSimCode();
  l_fullPathPrefix := CodegenUtilSimulation.fullPathPrefix(Tpl.emptyTxt, ret_9);
  (out_txt, l_residualCall, l_functionCall, l_evaluationCode, l_functionPrototypes, l_includes) := fun_63(txt, a_equationSystem, l_fullPathPrefix, l_fileNamePrefix, l_residualCall, l_functionCall, l_evaluationCode, a_omsiName, l_functionPrototypes, a_FileNamePrefix, l_includes);
end generateOmsiAlgSystemCode;

public function generateCodeHeader
  input Tpl.Text txt;
  input String a_FileNamePrefix;
  input Tpl.Text a_includes;
  input String a_headerName;
  input Tpl.Text a_functionPrototypes;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_includes;
  output Tpl.Text out_a_functionPrototypes;
protected
  String ret_1;
  Tpl.Text l_macro__name;
algorithm
  ret_1 := System.makeC89Identifier(a_headerName);
  l_macro__name := Tpl.writeStr(Tpl.emptyTxt, ret_1);
  out_txt := insertCopyrightOpenModelica(txt);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "#if !defined("
                                   }, false));
  out_txt := Tpl.writeText(out_txt, l_macro__name);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "_H)\n",
                                       "#define "
                                   }, false));
  out_txt := Tpl.writeText(out_txt, l_macro__name);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "_H\n",
                                       "\n",
                                       "#include <omsi.h>\n",
                                       "#include <omsic.h>\n",
                                       "#include <omsi_callbacks.h>\n",
                                       "#include <omsi_global.h>\n",
                                       "\n",
                                       "#include <stdlib.h>\n",
                                       "#include <math.h>\n",
                                       "\n"
                                   }, true));
  out_txt := Tpl.writeText(out_txt, a_includes);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "#if defined(__cplusplus)\n",
                                       "extern \"C\" {\n",
                                       "#endif\n",
                                       "\n",
                                       "/* Function prototypes */\n"
                                   }, true));
  out_txt := Tpl.writeText(out_txt, a_functionPrototypes);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "#if defined(__cplusplus)\n",
                                       "}\n",
                                       "#endif\n",
                                       "\n",
                                       "#endif\n"
                                   }, true));
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_NEW_LINE());
  out_a_includes := a_includes;
  out_a_functionPrototypes := a_functionPrototypes;
end generateCodeHeader;

protected function lm_66
  input Tpl.Text in_txt;
  input list<SimCode.OMSIFunction> in_items;
  input String in_a_omsiName;
  input Tpl.Text in_a_includes;
  input Tpl.Text in_a_functionPrototypes;
  input String in_a_FileNamePrefix;
  input String in_a_index;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_includes;
  output Tpl.Text out_a_functionPrototypes;
algorithm
  (out_txt, out_a_includes, out_a_functionPrototypes) :=
  match(in_txt, in_items, in_a_omsiName, in_a_includes, in_a_functionPrototypes, in_a_FileNamePrefix, in_a_index)
    local
      Tpl.Text txt;
      list<SimCode.OMSIFunction> rest;
      String a_omsiName;
      Tpl.Text a_includes;
      Tpl.Text a_functionPrototypes;
      String a_FileNamePrefix;
      String a_index;
      SimCode.OMSIFunction i_column;
      Tpl.Text txt_0;

    case ( txt,
           {},
           _,
           a_includes,
           a_functionPrototypes,
           _,
           _ )
      then (txt, a_includes, a_functionPrototypes);

    case ( txt,
           i_column :: rest,
           a_omsiName,
           a_includes,
           a_functionPrototypes,
           a_FileNamePrefix,
           a_index )
      equation
        txt_0 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("derivativeMatFunc_"));
        txt_0 = Tpl.writeStr(txt_0, a_index);
        (txt, a_functionPrototypes, a_includes) = generateInitalizationOMSIFunction(txt, i_column, Tpl.textString(txt_0), a_FileNamePrefix, "", a_functionPrototypes, a_includes, true, a_omsiName);
        txt = Tpl.nextIter(txt);
        (txt, a_includes, a_functionPrototypes) = lm_66(txt, rest, a_omsiName, a_includes, a_functionPrototypes, a_FileNamePrefix, a_index);
      then (txt, a_includes, a_functionPrototypes);
  end match;
end lm_66;

protected function fun_67
  input Tpl.Text in_txt;
  input Option<SimCode.DerivativeMatrix> in_a_matrix;
  input String in_a_omsiName;
  input Tpl.Text in_a_includes;
  input Tpl.Text in_a_functionPrototypes;
  input String in_a_FileNamePrefix;
  input String in_a_index;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_includes;
  output Tpl.Text out_a_functionPrototypes;
algorithm
  (out_txt, out_a_includes, out_a_functionPrototypes) :=
  match(in_txt, in_a_matrix, in_a_omsiName, in_a_includes, in_a_functionPrototypes, in_a_FileNamePrefix, in_a_index)
    local
      Tpl.Text txt;
      String a_omsiName;
      Tpl.Text a_includes;
      Tpl.Text a_functionPrototypes;
      String a_FileNamePrefix;
      String a_index;
      list<SimCode.OMSIFunction> i_derMat_columns;
      Tpl.Text l_initalizationCodeCol;

    case ( txt,
           SOME(SimCode.DERIVATIVE_MATRIX(columns = i_derMat_columns)),
           a_omsiName,
           a_includes,
           a_functionPrototypes,
           a_FileNamePrefix,
           a_index )
      equation
        l_initalizationCodeCol = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING_LIST({
                                                                                                 "\n",
                                                                                                 "\n"
                                                                                             }, true)), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_initalizationCodeCol, a_includes, a_functionPrototypes) = lm_66(l_initalizationCodeCol, i_derMat_columns, a_omsiName, a_includes, a_functionPrototypes, a_FileNamePrefix, a_index);
        l_initalizationCodeCol = Tpl.popIter(l_initalizationCodeCol);
        txt = Tpl.writeText(txt, l_initalizationCodeCol);
      then (txt, a_includes, a_functionPrototypes);

    case ( txt,
           _,
           _,
           a_includes,
           a_functionPrototypes,
           _,
           _ )
      then (txt, a_includes, a_functionPrototypes);
  end match;
end fun_67;

public function generateDerivativeFile
  input Tpl.Text txt;
  input Option<SimCode.DerivativeMatrix> a_matrix;
  input String a_FileNamePrefix;
  input String a_index;
  input String a_omsiName;

  output Tpl.Text out_txt;
protected
  Tpl.Text txt_14;
  Tpl.Text l_headerFileContent;
  Tpl.Text txt_12;
  Tpl.Text l_content;
  SimCode.SimCode ret_10;
  Tpl.Text l_fullPathPrefix;
  SimCode.SimCode ret_8;
  Tpl.Text l_fileNamePrefix;
  SimCode.SimCode ret_6;
  Tpl.Text l_headerFileName;
  Tpl.Text l_body;
  Tpl.Text l_initalizationCode;
  Tpl.Text l_functionPrototypes;
  Tpl.Text l_initalizationCodeCol;
  Tpl.Text l_includes;
algorithm
  l_includes := Tpl.emptyTxt;
  l_initalizationCodeCol := Tpl.emptyTxt;
  l_functionPrototypes := Tpl.emptyTxt;
  (l_initalizationCode, l_includes, l_functionPrototypes) := fun_67(Tpl.emptyTxt, a_matrix, a_omsiName, l_includes, l_functionPrototypes, a_FileNamePrefix, a_index);
  (l_body, l_functionPrototypes) := CodegenOMSIC_Equations.generateDerivativeMatrix(Tpl.emptyTxt, a_matrix, a_FileNamePrefix, a_index, l_functionPrototypes, a_omsiName);
  ret_6 := SimCodeUtil.getSimCode();
  l_headerFileName := CodegenUtilSimulation.fileNamePrefix(Tpl.emptyTxt, ret_6);
  l_headerFileName := Tpl.writeTok(l_headerFileName, Tpl.ST_STRING("_"));
  l_headerFileName := Tpl.writeStr(l_headerFileName, a_omsiName);
  l_headerFileName := Tpl.writeTok(l_headerFileName, Tpl.ST_STRING("_derMat_"));
  l_headerFileName := Tpl.writeStr(l_headerFileName, a_index);
  ret_8 := SimCodeUtil.getSimCode();
  l_fileNamePrefix := CodegenUtilSimulation.fileNamePrefix(Tpl.emptyTxt, ret_8);
  ret_10 := SimCodeUtil.getSimCode();
  l_fullPathPrefix := CodegenUtilSimulation.fullPathPrefix(Tpl.emptyTxt, ret_10);
  l_content := insertCopyrightOpenModelica(Tpl.emptyTxt);
  l_content := Tpl.softNewLine(l_content);
  l_content := Tpl.writeTok(l_content, Tpl.ST_STRING_LIST({
                                           "\n",
                                           "/* derivative matrix code for algebraic system "
                                       }, false));
  l_content := Tpl.writeStr(l_content, a_index);
  l_content := Tpl.writeTok(l_content, Tpl.ST_STRING_LIST({
                                           "*/\n",
                                           "#include \""
                                       }, false));
  l_content := Tpl.writeText(l_content, l_headerFileName);
  l_content := Tpl.writeTok(l_content, Tpl.ST_STRING_LIST({
                                           ".h\"\n",
                                           "\n",
                                           "#if defined(__cplusplus)\n",
                                           "extern \"C\" {\n",
                                           "#endif\n",
                                           "\n",
                                           "/* Instantiation and initalization */\n"
                                       }, true));
  l_content := Tpl.writeText(l_content, l_initalizationCode);
  l_content := Tpl.softNewLine(l_content);
  l_content := Tpl.writeTok(l_content, Tpl.ST_STRING_LIST({
                                           "\n",
                                           "/* derivative matrix evaluation */\n"
                                       }, true));
  l_content := Tpl.writeText(l_content, l_body);
  l_content := Tpl.softNewLine(l_content);
  l_content := Tpl.writeTok(l_content, Tpl.ST_STRING_LIST({
                                           "\n",
                                           "#if defined(__cplusplus)\n",
                                           "}\n",
                                           "#endif\n"
                                       }, true));
  l_content := Tpl.writeTok(l_content, Tpl.ST_NEW_LINE());
  txt_12 := Tpl.writeText(Tpl.emptyTxt, l_fullPathPrefix);
  txt_12 := Tpl.writeTok(txt_12, Tpl.ST_STRING("/"));
  txt_12 := Tpl.writeText(txt_12, l_fileNamePrefix);
  txt_12 := Tpl.writeTok(txt_12, Tpl.ST_STRING("_"));
  txt_12 := Tpl.writeStr(txt_12, a_omsiName);
  txt_12 := Tpl.writeTok(txt_12, Tpl.ST_STRING("_derMat_"));
  txt_12 := Tpl.writeStr(txt_12, a_index);
  txt_12 := Tpl.writeTok(txt_12, Tpl.ST_STRING(".c"));
  Tpl.textFile(l_content, Tpl.textString(txt_12));
  (l_headerFileContent, l_includes, l_functionPrototypes) := generateCodeHeader(Tpl.emptyTxt, a_FileNamePrefix, l_includes, Tpl.textString(l_headerFileName), l_functionPrototypes);
  txt_14 := Tpl.writeText(Tpl.emptyTxt, l_fullPathPrefix);
  txt_14 := Tpl.writeTok(txt_14, Tpl.ST_STRING("/"));
  txt_14 := Tpl.writeText(txt_14, l_headerFileName);
  txt_14 := Tpl.writeTok(txt_14, Tpl.ST_STRING(".h"));
  Tpl.textFile(l_headerFileContent, Tpl.textString(txt_14));
  out_txt := txt;
end generateDerivativeFile;

protected function lm_69
  input Tpl.Text in_txt;
  input list<Integer> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<Integer> rest;
      Integer i_cond;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_cond :: rest )
      equation
        txt = Tpl.writeStr(txt, intString(i_cond));
        txt = Tpl.nextIter(txt);
        txt = lm_69(txt, rest);
      then txt;
  end match;
end lm_69;

protected function fun_70
  input Tpl.Text in_txt;
  input Integer in_mArg;
  input Tpl.Text in_a_zeroCrossingIndices;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_zeroCrossingIndices)
    local
      Tpl.Text txt;
      Tpl.Text a_zeroCrossingIndices;

    case ( txt,
           0,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("algSystem->zerocrossing_indices = NULL;"));
      then txt;

    case ( txt,
           _,
           a_zeroCrossingIndices )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("algSystem->zerocrossing_indices[listLength(zeroCrossingConditions)] = {"));
        txt = Tpl.writeText(txt, a_zeroCrossingIndices);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("};"));
      then txt;
  end match;
end fun_70;

protected function fun_71
  input Tpl.Text in_txt;
  input Boolean in_a_linearSystem;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_linearSystem)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("omsi_false"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("omsi_true"));
      then txt;
  end match;
end fun_71;

protected function fun_72
  input Tpl.Text in_txt;
  input Option<SimCode.DerivativeMatrix> in_a_matrix;
  input Integer in_a_algSysIndex;
  input String in_a_omsiName;
  input String in_a_FileNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_matrix, in_a_algSysIndex, in_a_omsiName, in_a_FileNamePrefix)
    local
      Tpl.Text txt;
      Integer a_algSysIndex;
      String a_omsiName;
      String a_FileNamePrefix;

    case ( txt,
           SOME(_),
           a_algSysIndex,
           a_omsiName,
           a_FileNamePrefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if ("));
        txt = Tpl.writeStr(txt, a_FileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeStr(txt, a_omsiName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_instantiate_derivativeMatFunc_"));
        txt = Tpl.writeStr(txt, intString(a_algSysIndex));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_OMSIFunc(algSystem->jacobian) == omsi_error){\n",
                                    "        return omsi_error;\n",
                                    "      }"
                                }, false));
      then txt;

    case ( txt,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_72;

protected function fun_73
  input Tpl.Text in_txt;
  input Option<SimCode.DerivativeMatrix> in_a_matrix;
  input Integer in_a_algSysIndex;
  input String in_a_omsiName;
  input String in_a_FileNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_matrix, in_a_algSysIndex, in_a_omsiName, in_a_FileNamePrefix)
    local
      Tpl.Text txt;
      Integer a_algSysIndex;
      String a_omsiName;
      String a_FileNamePrefix;

    case ( txt,
           NONE(),
           _,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("NULL;"));
      then txt;

    case ( txt,
           _,
           a_algSysIndex,
           a_omsiName,
           a_FileNamePrefix )
      equation
        txt = Tpl.writeStr(txt, a_FileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeStr(txt, a_omsiName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_derivativeMatFunc_"));
        txt = Tpl.writeStr(txt, intString(a_algSysIndex));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_73;

public function generateInitalizationAlgSystem
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_equationSystem;
  input String in_a_FileNamePrefix;
  input Tpl.Text in_a_functionPrototypes;
  input Tpl.Text in_a_includes;
  input String in_a_omsiName;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_functionPrototypes;
  output Tpl.Text out_a_includes;
algorithm
  (out_txt, out_a_functionPrototypes, out_a_includes) :=
  match(in_txt, in_a_equationSystem, in_a_FileNamePrefix, in_a_functionPrototypes, in_a_includes, in_a_omsiName)
    local
      Tpl.Text txt;
      String a_FileNamePrefix;
      Tpl.Text a_functionPrototypes;
      Tpl.Text a_includes;
      String a_omsiName;
      SimCode.OMSIFunction i_residual;
      Option<SimCode.DerivativeMatrix> i_matrix;
      Boolean i_linearSystem;
      Integer i_dim__n;
      list<Integer> i_zeroCrossingConditions;
      Integer i_algSysIndex;
      Tpl.Text txt_3;
      Integer ret_2;
      Integer ret_1;
      Tpl.Text l_zeroCrossingIndices;

    case ( txt,
           SimCode.SES_ALGEBRAIC_SYSTEM(dim_n = i_dim__n, residual = (i_residual as SimCode.OMSI_FUNCTION(equations = _)), matrix = i_matrix, algSysIndex = i_algSysIndex, zeroCrossingConditions = i_zeroCrossingConditions, linearSystem = i_linearSystem),
           a_FileNamePrefix,
           a_functionPrototypes,
           a_includes,
           a_omsiName )
      equation
        a_functionPrototypes = Tpl.writeTok(a_functionPrototypes, Tpl.ST_STRING("omsi_status "));
        a_functionPrototypes = Tpl.writeStr(a_functionPrototypes, a_FileNamePrefix);
        a_functionPrototypes = Tpl.writeTok(a_functionPrototypes, Tpl.ST_STRING("_"));
        a_functionPrototypes = Tpl.writeStr(a_functionPrototypes, a_omsiName);
        a_functionPrototypes = Tpl.writeTok(a_functionPrototypes, Tpl.ST_STRING("_instantiate_AlgSystem_"));
        a_functionPrototypes = Tpl.writeStr(a_functionPrototypes, intString(i_algSysIndex));
        a_functionPrototypes = Tpl.writeTok(a_functionPrototypes, Tpl.ST_STRING("(omsi_algebraic_system_t* algSystem, omsi_values* function_vars, omsi_values* pre_vars);"));
        a_functionPrototypes = Tpl.writeTok(a_functionPrototypes, Tpl.ST_NEW_LINE());
        l_zeroCrossingIndices = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_zeroCrossingIndices = lm_69(l_zeroCrossingIndices, i_zeroCrossingConditions);
        l_zeroCrossingIndices = Tpl.popIter(l_zeroCrossingIndices);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "/* Function instantiate omsi_algebraic_system_t struct */\n",
                                    "omsi_status "
                                }, false));
        txt = Tpl.writeStr(txt, a_FileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeStr(txt, a_omsiName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_instantiate_AlgSystem_"));
        txt = Tpl.writeStr(txt, intString(i_algSysIndex));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("(omsi_algebraic_system_t* algSystem, omsi_values* function_vars, omsi_values* pre_vars) {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("algSystem->n_iteration_vars = "));
        txt = Tpl.writeStr(txt, intString(i_dim__n));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "\n",
                                    "algSystem->n_conditions = "
                                }, false));
        ret_1 = listLength(i_zeroCrossingConditions);
        txt = Tpl.writeStr(txt, intString(ret_1));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        ret_2 = listLength(i_zeroCrossingConditions);
        txt = fun_70(txt, ret_2, l_zeroCrossingIndices);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "algSystem->isLinear = "
                                }, false));
        txt = fun_71(txt, i_linearSystem);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "\n",
                                    "/* Instantiate omsi_function_t jacobian */\n",
                                    "algSystem->jacobian = omsu_instantiate_omsi_function (function_vars, pre_vars);\n",
                                    "if (!algSystem->jacobian) {\n",
                                    "  return omsi_error;\n",
                                    "}\n"
                                }, true));
        txt = fun_72(txt, i_matrix, i_algSysIndex, a_omsiName, a_FileNamePrefix);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "/* Instantiate omsi_function_t function */\n",
                                    "algSystem->functions = omsu_instantiate_omsi_function (function_vars, pre_vars);\n",
                                    "if (!algSystem->functions) {\n",
                                    "  return omsi_error;\n",
                                    "}\n",
                                    "if ("
                                }, false));
        txt = Tpl.writeStr(txt, a_FileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeStr(txt, a_omsiName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_instantiate_resFunction_"));
        txt = Tpl.writeStr(txt, intString(i_algSysIndex));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_OMSIFunc(algSystem->functions) == omsi_error){\n",
                                    "  return omsi_error;\n",
                                    "}\n",
                                    "\n",
                                    "/* ToDo: put into init functions */\n",
                                    "algSystem->functions->evaluate = "
                                }, false));
        txt = Tpl.writeStr(txt, a_FileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeStr(txt, a_omsiName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_resFunction_"));
        txt = Tpl.writeStr(txt, intString(i_algSysIndex));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "algSystem->jacobian->evaluate = "
                                }, false));
        txt = fun_73(txt, i_matrix, i_algSysIndex, a_omsiName, a_FileNamePrefix);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "algSystem->solver_data = NULL;\n",
                                    "\n",
                                    "return omsi_ok;\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n"
                                }, true));
        txt_3 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("resFunction_"));
        txt_3 = Tpl.writeStr(txt_3, intString(i_algSysIndex));
        (txt, a_functionPrototypes, a_includes) = generateInitalizationOMSIFunction(txt, i_residual, Tpl.textString(txt_3), a_FileNamePrefix, "", a_functionPrototypes, a_includes, false, a_omsiName);
      then (txt, a_functionPrototypes, a_includes);

    case ( txt,
           _,
           _,
           a_functionPrototypes,
           a_includes,
           _ )
      then (txt, a_functionPrototypes, a_includes);
  end match;
end generateInitalizationAlgSystem;

protected function fun_75
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_a_variable;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_variable)
    local
      Tpl.Text txt;

    case ( txt,
           SimCodeVar.SIMVAR(type_ = DAE.T_REAL(varLst = _)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("OMSI_TYPE_REAL"));
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(type_ = DAE.T_INTEGER(varLst = _)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("OMSI_TYPE_INTEGER"));
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(type_ = DAE.T_BOOL(varLst = _)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("OMSI_TYPE_BOOLEAN"));
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(type_ = DAE.T_STRING(varLst = _)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("OMSI_TYPE_STRING"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("OMSI_TYPE_UNKNOWN"));
      then txt;
  end match;
end fun_75;

protected function fun_76
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_a_variable;
  input Tpl.Text in_a_stringVarKind;
  input Tpl.Text in_a_stringIndex;
  input Tpl.Text in_a_stringName;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stringVarKind;
  output Tpl.Text out_a_stringIndex;
  output Tpl.Text out_a_stringName;
algorithm
  (out_txt, out_a_stringVarKind, out_a_stringIndex, out_a_stringName) :=
  match(in_txt, in_a_variable, in_a_stringVarKind, in_a_stringIndex, in_a_stringName)
    local
      Tpl.Text txt;
      Tpl.Text a_stringVarKind;
      Tpl.Text a_stringIndex;
      Tpl.Text a_stringName;
      SimCodeVar.SimVar i_var;
      BackendDAE.VarKind i_var_varKind;
      Integer i_var_index;
      DAE.ComponentRef i_var_name;
      String ret_5;
      SimCode.SimCode ret_4;
      Tpl.Text txt_3;
      Tpl.Text txt_2;
      Tpl.Text txt_1;
      Tpl.Text txt_0;

    case ( txt,
           SimCodeVar.SIMVAR(varKind = (i_var_varKind as BackendDAE.JAC_VAR()), name = i_var_name, index = i_var_index),
           a_stringVarKind,
           a_stringIndex,
           a_stringName )
      equation
        txt_0 = CodegenUtil.crefStrNoUnderscore(Tpl.emptyTxt, i_var_name);
        a_stringName = CodegenUtil.escapeCComments(a_stringName, Tpl.textString(txt_0));
        a_stringIndex = Tpl.writeStr(a_stringIndex, intString(i_var_index));
        a_stringVarKind = CodegenUtil.variabilityString(a_stringVarKind, i_var_varKind);
      then (txt, a_stringVarKind, a_stringIndex, a_stringName);

    case ( txt,
           SimCodeVar.SIMVAR(varKind = (i_var_varKind as BackendDAE.JAC_DIFF_VAR()), name = i_var_name, index = i_var_index),
           a_stringVarKind,
           a_stringIndex,
           a_stringName )
      equation
        txt_1 = CodegenUtil.crefStrNoUnderscore(Tpl.emptyTxt, i_var_name);
        a_stringName = CodegenUtil.escapeCComments(a_stringName, Tpl.textString(txt_1));
        a_stringIndex = Tpl.writeStr(a_stringIndex, intString(i_var_index));
        a_stringVarKind = CodegenUtil.variabilityString(a_stringVarKind, i_var_varKind);
      then (txt, a_stringVarKind, a_stringIndex, a_stringName);

    case ( txt,
           SimCodeVar.SIMVAR(varKind = (i_var_varKind as BackendDAE.SEED_VAR()), name = i_var_name, index = i_var_index),
           a_stringVarKind,
           a_stringIndex,
           a_stringName )
      equation
        txt_2 = CodegenUtil.crefStrNoUnderscore(Tpl.emptyTxt, i_var_name);
        a_stringName = CodegenUtil.escapeCComments(a_stringName, Tpl.textString(txt_2));
        a_stringIndex = Tpl.writeStr(a_stringIndex, intString(i_var_index));
        a_stringVarKind = CodegenUtil.variabilityString(a_stringVarKind, i_var_varKind);
      then (txt, a_stringVarKind, a_stringIndex, a_stringName);

    case ( txt,
           (i_var as SimCodeVar.SIMVAR(name = i_var_name, varKind = i_var_varKind)),
           a_stringVarKind,
           a_stringIndex,
           a_stringName )
      equation
        txt_3 = CodegenUtil.crefStrNoUnderscore(Tpl.emptyTxt, i_var_name);
        a_stringName = CodegenUtil.escapeCComments(a_stringName, Tpl.textString(txt_3));
        ret_4 = SimCodeUtil.getSimCode();
        ret_5 = SimCodeUtil.getValueReference(i_var, ret_4, false);
        a_stringIndex = Tpl.writeStr(a_stringIndex, ret_5);
        a_stringVarKind = CodegenUtil.variabilityString(a_stringVarKind, i_var_varKind);
      then (txt, a_stringVarKind, a_stringIndex, a_stringName);

    case ( txt,
           _,
           a_stringVarKind,
           a_stringIndex,
           a_stringName )
      then (txt, a_stringVarKind, a_stringIndex, a_stringName);
  end match;
end fun_76;

protected function lm_77
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input String in_a_omsiFuncName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_omsiFuncName)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      String a_omsiFuncName;
      Integer x_i0;
      SimCodeVar.SimVar i_variable;
      Tpl.Text l_0__;
      Tpl.Text l_stringVarKind;
      Tpl.Text l_stringIndex;
      Tpl.Text l_stringName;
      Tpl.Text l_stringType;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_variable :: rest,
           a_omsiFuncName )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        l_stringType = fun_75(Tpl.emptyTxt, i_variable);
        l_stringName = Tpl.emptyTxt;
        l_stringIndex = Tpl.emptyTxt;
        l_stringVarKind = Tpl.emptyTxt;
        (l_0__, l_stringVarKind, l_stringIndex, l_stringName) = fun_76(Tpl.emptyTxt, i_variable, l_stringVarKind, l_stringIndex, l_stringName);
        txt = Tpl.writeStr(txt, a_omsiFuncName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("["));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].type  = "));
        txt = Tpl.writeText(txt, l_stringType);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.writeStr(txt, a_omsiFuncName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("["));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].index = "));
        txt = Tpl.writeText(txt, l_stringIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";    /* "));
        txt = Tpl.writeText(txt, l_stringName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, l_stringVarKind);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" */"));
        txt = Tpl.nextIter(txt);
        txt = lm_77(txt, rest, a_omsiFuncName);
      then txt;
  end match;
end lm_77;

protected function fun_78
  input Tpl.Text in_txt;
  input Integer in_mArg;
  input Tpl.Text in_a_stringBuffer;
  input String in_a_targetName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_stringBuffer, in_a_targetName)
    local
      Tpl.Text txt;
      Tpl.Text a_stringBuffer;
      String a_targetName;

    case ( txt,
           0,
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_stringBuffer,
           a_targetName )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/* maps to "));
        txt = Tpl.writeStr(txt, a_targetName);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" */\n"));
        txt = Tpl.writeText(txt, a_stringBuffer);
      then txt;
  end match;
end fun_78;

public function generateOmsiIndexTypeInitialization
  input Tpl.Text txt;
  input list<SimCodeVar.SimVar> a_variables;
  input String a_StrucPrefix;
  input String a_targetName;
  input String a_omsiFuncName;

  output Tpl.Text out_txt;
protected
  Integer ret_1;
  Tpl.Text l_stringBuffer;
algorithm
  l_stringBuffer := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  l_stringBuffer := lm_77(l_stringBuffer, a_variables, a_omsiFuncName);
  l_stringBuffer := Tpl.popIter(l_stringBuffer);
  ret_1 := listLength(a_variables);
  out_txt := fun_78(txt, ret_1, l_stringBuffer, a_targetName);
end generateOmsiIndexTypeInitialization;

protected function fun_80
  input Tpl.Text in_txt;
  input Integer in_a_nAlgebraicSystems;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_nAlgebraicSystems)
    local
      Tpl.Text txt;

    case ( txt,
           0 )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("  #include <solver_api.h>"));
      then txt;
  end match;
end fun_80;

protected function fun_81
  input Tpl.Text in_txt;
  input Integer in_a_nAlgebraicSystems;
  input Tpl.Text in_a_algSystemInit;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_nAlgebraicSystems, in_a_algSystemInit)
    local
      Tpl.Text txt;
      Tpl.Text a_algSystemInit;
      Integer i_nAlgebraicSystems;

    case ( txt,
           0,
           _ )
      then txt;

    case ( txt,
           i_nAlgebraicSystems,
           a_algSystemInit )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "/* Instantiate algebraic system */\n",
                                    "omsi_function->algebraic_system_t = omsu_instantiate_alg_system_array("
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_nAlgebraicSystems));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ");\n",
                                    "if (!omsi_function->algebraic_system_t) {\n",
                                    "  filtered_base_logger(global_logCategories, log_statuserror, omsi_error,\n",
                                    "                \"fmi2Instantiate: Not enough memory.\");\n",
                                    "  return omsi_error;\n",
                                    "}\n"
                                }, true));
        txt = Tpl.writeText(txt, a_algSystemInit);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;
  end match;
end fun_81;

protected function fun_82
  input Tpl.Text in_txt;
  input Boolean in_a_hasLocalVars;
  input Integer in_a_nAllVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_hasLocalVars, in_a_nAllVars)
    local
      Tpl.Text txt;
      Integer a_nAllVars;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_nAllVars )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "/* Allocate memory for local variables */\n",
                                    "omsi_function->local_vars = instantiate_omsi_values("
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_nAllVars));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ", 0, 0, 0);\n",
                                    "\n"
                                }, true));
      then txt;
  end match;
end fun_82;

protected function fun_83
  input Tpl.Text in_txt;
  input Integer in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           0 )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;
  end match;
end fun_83;

protected function fun_84
  input Tpl.Text in_txt;
  input SimCode.OMSIFunction in_a_omsiFunction;
  input String in_a_functionName;
  input String in_a_FileNamePrefix;
  input Tpl.Text in_a_functionPrototypes;
  input Tpl.Text in_a_includes;
  input Boolean in_a_hasLocalVars;
  input String in_a_omsiName;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_functionPrototypes;
  output Tpl.Text out_a_includes;
algorithm
  (out_txt, out_a_functionPrototypes, out_a_includes) :=
  match(in_txt, in_a_omsiFunction, in_a_functionName, in_a_FileNamePrefix, in_a_functionPrototypes, in_a_includes, in_a_hasLocalVars, in_a_omsiName)
    local
      Tpl.Text txt;
      String a_functionName;
      String a_FileNamePrefix;
      Tpl.Text a_functionPrototypes;
      Tpl.Text a_includes;
      Boolean a_hasLocalVars;
      String a_omsiName;
      Integer i_nAllVars;
      list<SimCodeVar.SimVar> i_outputVars;
      list<SimCodeVar.SimVar> i_innerVars;
      list<SimCodeVar.SimVar> i_inputVars;
      list<SimCode.SimEqSystem> i_equations;
      Integer i_nAlgebraicSystems;
      Integer ret_7;
      Integer ret_6;
      Integer ret_5;
      Integer ret_4;
      Integer ret_3;
      Integer ret_2;
      Tpl.Text l_algSystemInit;
      Tpl.Text l_evaluationTarget;

    case ( txt,
           SimCode.OMSI_FUNCTION(nAlgebraicSystems = i_nAlgebraicSystems, equations = i_equations, inputVars = i_inputVars, innerVars = i_innerVars, outputVars = i_outputVars, nAllVars = i_nAllVars),
           a_functionName,
           a_FileNamePrefix,
           a_functionPrototypes,
           a_includes,
           a_hasLocalVars,
           a_omsiName )
      equation
        a_functionPrototypes = Tpl.writeTok(a_functionPrototypes, Tpl.ST_STRING("omsi_status "));
        a_functionPrototypes = Tpl.writeStr(a_functionPrototypes, a_FileNamePrefix);
        a_functionPrototypes = Tpl.writeTok(a_functionPrototypes, Tpl.ST_STRING("_"));
        a_functionPrototypes = Tpl.writeStr(a_functionPrototypes, a_omsiName);
        a_functionPrototypes = Tpl.writeTok(a_functionPrototypes, Tpl.ST_STRING("_instantiate_"));
        a_functionPrototypes = Tpl.writeStr(a_functionPrototypes, a_functionName);
        a_functionPrototypes = Tpl.writeTok(a_functionPrototypes, Tpl.ST_LINE("_OMSIFunc (omsi_function_t* omsi_function);\n"));
        l_evaluationTarget = Tpl.writeStr(Tpl.emptyTxt, a_FileNamePrefix);
        l_evaluationTarget = Tpl.writeTok(l_evaluationTarget, Tpl.ST_STRING("_"));
        l_evaluationTarget = Tpl.writeStr(l_evaluationTarget, a_omsiName);
        l_evaluationTarget = Tpl.writeTok(l_evaluationTarget, Tpl.ST_STRING("_"));
        l_evaluationTarget = Tpl.writeStr(l_evaluationTarget, a_functionName);
        l_algSystemInit = generateAlgebraicSystemInstantiation(Tpl.emptyTxt, a_FileNamePrefix, i_nAlgebraicSystems, i_equations, a_omsiName);
        a_includes = Tpl.writeTok(a_includes, Tpl.ST_LINE("#include <omsu_helper.h>\n"));
        a_includes = fun_80(a_includes, i_nAlgebraicSystems);
        a_includes = Tpl.softNewLine(a_includes);
        a_includes = Tpl.writeTok(a_includes, Tpl.ST_STRING("#include <omsi_input_sim_data.h>"));
        a_includes = Tpl.writeTok(a_includes, Tpl.ST_NEW_LINE());
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "\n",
                                    "omsi_status "
                                }, false));
        txt = Tpl.writeStr(txt, a_FileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeStr(txt, a_omsiName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_instantiate_"));
        txt = Tpl.writeStr(txt, a_functionName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_OMSIFunc (omsi_function_t* omsi_function) {\n",
                                    "\n",
                                    "\n",
                                    "\n",
                                    "  filtered_base_logger(global_logCategories, log_all, omsi_ok,\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(6));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\"fmi2Instantiate: Instantiate omsi_function "));
        txt = Tpl.writeStr(txt, a_functionName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ".\");\n",
                                    "\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("omsi_function->n_algebraic_system = "));
        txt = Tpl.writeStr(txt, intString(i_nAlgebraicSystems));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "\n",
                                    "omsi_function->n_input_vars = "
                                }, false));
        ret_2 = listLength(i_inputVars);
        txt = Tpl.writeStr(txt, intString(ret_2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "omsi_function->n_inner_vars = "
                                }, false));
        ret_3 = listLength(i_innerVars);
        txt = Tpl.writeStr(txt, intString(ret_3));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "omsi_function->n_output_vars = "
                                }, false));
        ret_4 = listLength(i_outputVars);
        txt = Tpl.writeStr(txt, intString(ret_4));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "\n"
                                }, true));
        txt = fun_81(txt, i_nAlgebraicSystems, l_algSystemInit);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "if (instantiate_input_inner_output_indices (omsi_function, "
                                }, false));
        ret_5 = listLength(i_inputVars);
        txt = Tpl.writeStr(txt, intString(ret_5));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        ret_6 = listLength(i_outputVars);
        txt = Tpl.writeStr(txt, intString(ret_6));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ") == omsi_error) {\n",
                                    "  return omsi_error;\n",
                                    "}\n",
                                    "\n"
                                }, true));
        txt = fun_82(txt, a_hasLocalVars, i_nAllVars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/* fill omsi_index_type indices */\n"));
        txt = generateOmsiIndexTypeInitialization(txt, i_inputVars, "omsi_function->input_vars_indices", "sim_data->model_vars_and_params", "omsi_function->input_vars_indices");
        txt = Tpl.softNewLine(txt);
        ret_7 = listLength(i_inputVars);
        txt = fun_83(txt, ret_7);
        txt = Tpl.softNewLine(txt);
        txt = generateOmsiIndexTypeInitialization(txt, i_outputVars, "omsi_function->output_vars_indices", "sim_data->model_vars_and_params", "omsi_function->output_vars_indices");
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "/* Set pointer for evaluation function */\n",
                                    "omsi_function->evaluate = "
                                }, false));
        txt = Tpl.writeText(txt, l_evaluationTarget);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "\n",
                                    "return omsi_ok;\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then (txt, a_functionPrototypes, a_includes);

    case ( txt,
           _,
           _,
           _,
           a_functionPrototypes,
           a_includes,
           _,
           _ )
      then (txt, a_functionPrototypes, a_includes);
  end match;
end fun_84;

public function generateInitalizationOMSIFunction
  input Tpl.Text txt;
  input SimCode.OMSIFunction a_omsiFunction;
  input String a_functionName;
  input String a_FileNamePrefix;
  input String a_modelFunctionnamePrefixStr;
  input Tpl.Text a_functionPrototypes;
  input Tpl.Text a_includes;
  input Boolean a_hasLocalVars;
  input String a_omsiName;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_functionPrototypes;
  output Tpl.Text out_a_includes;
algorithm
  (out_txt, out_a_functionPrototypes, out_a_includes) := fun_84(txt, a_omsiFunction, a_functionName, a_FileNamePrefix, a_functionPrototypes, a_includes, a_hasLocalVars, a_omsiName);
end generateInitalizationOMSIFunction;

protected function fun_86
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_equation;
  input Integer in_a_i0;
  input String in_a_omsiName;
  input String in_a_FileNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_equation, in_a_i0, in_a_omsiName, in_a_FileNamePrefix)
    local
      Tpl.Text txt;
      Integer a_i0;
      String a_omsiName;
      String a_FileNamePrefix;
      Integer i_algSysIndex;

    case ( txt,
           SimCode.SES_ALGEBRAIC_SYSTEM(algSysIndex = i_algSysIndex),
           a_i0,
           a_omsiName,
           a_FileNamePrefix )
      equation
        txt = Tpl.writeStr(txt, a_FileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeStr(txt, a_omsiName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_instantiate_AlgSystem_"));
        txt = Tpl.writeStr(txt, intString(i_algSysIndex));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(&(omsi_function->algebraic_system_t["));
        txt = Tpl.writeStr(txt, intString(a_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "]), omsi_function->function_vars, omsi_function->pre_vars);\n",
                                    "if (!&omsi_function->algebraic_system_t["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "]) {\n",
                                    "  filtered_base_logger(global_logCategories, log_statuserror, omsi_error,\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(6));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\"fmi2Instantiate: Function "));
        txt = Tpl.writeStr(txt, a_FileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeStr(txt, a_omsiName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_instantiate_AlgSystem_"));
        txt = Tpl.writeStr(txt, intString(i_algSysIndex));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" failed.\");\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "  return omsi_error;\n",
                                    "}"
                                }, false));
      then txt;

    case ( txt,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_86;

protected function lm_87
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input String in_a_omsiName;
  input String in_a_FileNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_omsiName, in_a_FileNamePrefix)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      String a_omsiName;
      String a_FileNamePrefix;
      Integer x_i0;
      SimCode.SimEqSystem i_equation;

    case ( txt,
           {},
           _,
           _ )
      then txt;

    case ( txt,
           i_equation :: rest,
           a_omsiName,
           a_FileNamePrefix )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = fun_86(txt, i_equation, x_i0, a_omsiName, a_FileNamePrefix);
        txt = Tpl.nextIter(txt);
        txt = lm_87(txt, rest, a_omsiName, a_FileNamePrefix);
      then txt;
  end match;
end lm_87;

public function generateAlgebraicSystemInstantiation
  input Tpl.Text txt;
  input String a_FileNamePrefix;
  input Integer a_nAlgebraicSystems;
  input list<SimCode.SimEqSystem> a_equations;
  input String a_omsiName;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_initialization;
algorithm
  l_initialization := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  l_initialization := lm_87(l_initialization, a_equations, a_omsiName, a_FileNamePrefix);
  l_initialization := Tpl.popIter(l_initialization);
  out_txt := Tpl.writeText(txt, l_initialization);
end generateAlgebraicSystemInstantiation;

protected function fun_89
  input Tpl.Text in_txt;
  input BackendDAE.TimeEvent in_a_timeEvent;
  input Integer in_a_i0;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_a_timeEvent, in_a_i0, in_a_auxFunction, in_a_varDecls)
    local
      Tpl.Text txt;
      Integer a_i0;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Integer i_index;
      DAE.Exp i_intervalExp;
      DAE.Exp i_startExp;
      Tpl.Text l_e2;
      Tpl.Text l_e1;
      Tpl.Text l_preExp;

    case ( txt,
           BackendDAE.SAMPLE_TIME_EVENT(startExp = i_startExp, intervalExp = i_intervalExp, index = i_index),
           a_i0,
           a_auxFunction,
           a_varDecls )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_e1, l_preExp, a_varDecls, a_auxFunction) = CodegenCFunctions.daeExp(Tpl.emptyTxt, i_startExp, SimCodeFunction.contextOther, l_preExp, a_varDecls, a_auxFunction);
        (l_e2, l_preExp, a_varDecls, a_auxFunction) = CodegenCFunctions.daeExp(Tpl.emptyTxt, i_intervalExp, SimCodeFunction.contextOther, l_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/* sample "));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " */\n",
                                    "sample_events["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].id = "));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "sample_events["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].start_time = "));
        txt = Tpl.writeText(txt, l_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "sample_events["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].interval = "));
        txt = Tpl.writeText(txt, l_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           _,
           _,
           a_auxFunction,
           a_varDecls )
      then (txt, a_auxFunction, a_varDecls);
  end match;
end fun_89;

protected function lm_90
  input Tpl.Text in_txt;
  input list<BackendDAE.TimeEvent> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls)
    local
      Tpl.Text txt;
      list<BackendDAE.TimeEvent> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Integer x_i0;
      BackendDAE.TimeEvent i_timeEvent;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls )
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           i_timeEvent :: rest,
           a_auxFunction,
           a_varDecls )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        (txt, a_auxFunction, a_varDecls) = fun_89(txt, i_timeEvent, x_i0, a_auxFunction, a_varDecls);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls) = lm_90(txt, rest, a_auxFunction, a_varDecls);
      then (txt, a_auxFunction, a_varDecls);
  end match;
end lm_90;

public function functionInitSample
  input Tpl.Text txt;
  input list<BackendDAE.TimeEvent> a_timeEvents;
  input String a_fileNamePrefix;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_body;
  Tpl.Text l_auxFunction;
  Tpl.Text l_varDecls;
algorithm
  l_varDecls := Tpl.emptyTxt;
  l_auxFunction := Tpl.emptyTxt;
  l_body := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), NONE(), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (l_body, l_auxFunction, l_varDecls) := lm_90(l_body, a_timeEvents, l_auxFunction, l_varDecls);
  l_body := Tpl.popIter(l_body);
  out_txt := Tpl.writeText(txt, l_auxFunction);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       " /* Initializes sample time events */\n",
                                       "void "
                                   }, false));
  out_txt := Tpl.writeStr(out_txt, a_fileNamePrefix);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "_instantiate_samples(omsi_sample* sample_events)\n",
                                       "{\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeText(out_txt, l_varDecls);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeText(out_txt, l_body);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("}"));
end functionInitSample;

public function insertCopyrightOpenModelica
  input Tpl.Text txt;

  output Tpl.Text out_txt;
algorithm
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                   "/*\n",
                                   " * This file is part of OpenModelica.\n",
                                   " *\n",
                                   " * Copyright (c) 1998-2014, Open Source Modelica Consortium (OSMC),\n",
                                   " * c/o Linköpings universitet, Department of Computer and Information Science,\n",
                                   " * SE-58183 Linköping, Sweden.\n",
                                   " *\n",
                                   " * All rights reserved.\n",
                                   " *\n",
                                   " * THIS PROGRAM IS PROVIDED UNDER THE TERMS OF GPL VERSION 3 LICENSE OR\n",
                                   " * THIS OSMC PUBLIC LICENSE (OSMC-PL) VERSION 1.2.\n",
                                   " * ANY USE, REPRODUCTION OR DISTRIBUTION OF THIS PROGRAM CONSTITUTES\n",
                                   " * RECIPIENT\'S ACCEPTANCE OF THE OSMC PUBLIC LICENSE OR THE GPL VERSION 3,\n",
                                   " * ACCORDING TO RECIPIENTS CHOICE.\n",
                                   " *\n",
                                   " * The OpenModelica software and the Open Source Modelica\n",
                                   " * Consortium (OSMC) Public License (OSMC-PL) are obtained\n",
                                   " * from OSMC, either from the above address,\n",
                                   " * from the URLs: http://www.ida.liu.se/projects/OpenModelica or\n",
                                   " * http://www.openmodelica.org, and in the OpenModelica distribution.\n",
                                   " * GNU version 3 is obtained from: http://www.gnu.org/copyleft/gpl.html.\n",
                                   " *\n",
                                   " * This program is distributed WITHOUT ANY WARRANTY; without\n",
                                   " * even the implied warranty of  MERCHANTABILITY or FITNESS\n",
                                   " * FOR A PARTICULAR PURPOSE, EXCEPT AS EXPRESSLY SET FORTH\n",
                                   " * IN THE BY RECIPIENT SELECTED SUBSIDIARY LICENSE CONDITIONS OF OSMC-PL.\n",
                                   " *\n",
                                   " * See the full OSMC Public License conditions for more details.\n",
                                   " *\n",
                                   " */"
                               }, false));
end insertCopyrightOpenModelica;

annotation(__OpenModelica_Interface="backend");
end CodegenOMSI_common;