encapsulated package GenerateAPIFunctionsTpl
"
  file:        GenerateAPIFunctionsTpl.mo
  package:     GenerateAPIFunctionsTpl
  description: Generated by Susan.
"

public import Tpl;

public import Absyn;
public import AbsynUtil;
public import DAE;
public import Util;
public import List;
public import Values;
public import ValuesUtil;
public import Types;
public import CodegenUtil;

protected function lm_39
  input Tpl.Text in_txt;
  input list<DAE.Type> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<DAE.Type> rest;
      DAE.Type i_ty_funcResultType;
      list<DAE.FuncArg> i_ty_funcArg;
      Absyn.Path i_path;
      String ret_0;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           DAE.T_FUNCTION(path = i_path, funcArg = i_ty_funcArg, funcResultType = i_ty_funcResultType) :: rest )
      equation
        ret_0 = AbsynUtil.pathLastIdent(i_path);
        txt = getCevalScriptInterfaceFunc(txt, ret_0, i_ty_funcArg, i_ty_funcResultType);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = lm_39(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_39(txt, rest);
      then txt;
  end match;
end lm_39;

public function getCevalScriptInterface
  input Tpl.Text txt;
  input list<DAE.Type> a_tys;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_funcs;
algorithm
  l_funcs := lm_39(Tpl.emptyTxt, a_tys);
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                   "import Absyn;\n",
                                   "import AbsynUtil;\n",
                                   "import CevalScript;\n",
                                   "import Parser;\n",
                                   "\n",
                                   "protected\n",
                                   "\n",
                                   "import Values;\n",
                                   "import ValuesUtil;\n",
                                   "constant Absyn.Msg dummyMsg = Absyn.MSG(SOURCEINFO(\"<interactive>\",false,1,1,1,1,0.0));\n",
                                   "\n",
                                   "public\n",
                                   "\n"
                               }, true));
  out_txt := Tpl.writeText(out_txt, l_funcs);
end getCevalScriptInterface;

public function getInType
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty)
    local
      Tpl.Text txt;
      DAE.Type i_ty;
      DAE.Type i_aty_ty;
      Tpl.Text txt_0;
      String ret_0;

    case ( txt,
           DAE.T_STRING(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("String"));
      then txt;

    case ( txt,
           DAE.T_INTEGER(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Integer"));
      then txt;

    case ( txt,
           DAE.T_BOOL(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Boolean"));
      then txt;

    case ( txt,
           DAE.T_REAL(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Real"));
      then txt;

    case ( txt,
           DAE.T_ARRAY(ty = i_aty_ty) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("list<"));
        txt = getInType(txt, i_aty_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(">"));
      then txt;

    case ( txt,
           DAE.T_CODE(ty = DAE.C_TYPENAME()) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("String"));
      then txt;

    case ( txt,
           i_ty )
      equation
        txt_0 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("getInType failed for "));
        ret_0 = Types.unparseType(i_ty);
        txt_0 = Tpl.writeStr(txt_0, ret_0);
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("GenerateAPIFunctionsTpl.tpl", 36, 16), Tpl.textString(txt_0));
      then txt;
  end match;
end getInType;

protected function fun_42
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;
  input Tpl.Text in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty, in_a_name)
    local
      Tpl.Text txt;
      Tpl.Text a_name;
      DAE.Type i_ty;
      DAE.Type i_aty_ty;
      Tpl.Text txt_1;
      String ret_1;
      Tpl.Text txt_0;

    case ( txt,
           DAE.T_STRING(varLst = _),
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Values.STRING("));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.T_INTEGER(varLst = _),
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Values.INTEGER("));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.T_BOOL(varLst = _),
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Values.BOOL("));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.T_REAL(varLst = _),
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Values.REAL("));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.T_ARRAY(ty = i_aty_ty),
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("ValuesUtil.makeArray(list("));
        txt_0 = Tpl.writeText(Tpl.emptyTxt, a_name);
        txt_0 = Tpl.writeTok(txt_0, Tpl.ST_STRING("_iter"));
        (txt, txt_0) = getInValue(txt, txt_0, i_aty_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" for "));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_iter in "));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("))"));
      then txt;

    case ( txt,
           DAE.T_CODE(ty = DAE.C_TYPENAME()),
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Values.CODE(Absyn.C_TYPENAME(Parser.stringPath("));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")))"));
      then txt;

    case ( txt,
           i_ty,
           _ )
      equation
        txt_1 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("getInValue failed for "));
        ret_1 = Types.unparseType(i_ty);
        txt_1 = Tpl.writeStr(txt_1, ret_1);
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("GenerateAPIFunctionsTpl.tpl", 48, 16), Tpl.textString(txt_1));
      then txt;
  end match;
end fun_42;

public function getInValue
  input Tpl.Text txt;
  input Tpl.Text a_name;
  input DAE.Type a_ty;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_name;
algorithm
  out_txt := fun_42(txt, a_ty, a_name);
  out_a_name := a_name;
end getInValue;

protected function fun_44
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;
  input Tpl.Text in_a_name;
  input Tpl.Text in_a_varDecl;
  input Tpl.Text in_a_postMatch;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecl;
  output Tpl.Text out_a_postMatch;
algorithm
  (out_txt, out_a_varDecl, out_a_postMatch) :=
  match(in_txt, in_a_ty, in_a_name, in_a_varDecl, in_a_postMatch)
    local
      Tpl.Text txt;
      Tpl.Text a_name;
      Tpl.Text a_varDecl;
      Tpl.Text a_postMatch;
      DAE.Type i_ty;
      DAE.Type i_aty;
      Tpl.Text txt_1;
      String ret_1;
      Tpl.Text txt_0;

    case ( txt,
           DAE.T_STRING(varLst = _),
           a_name,
           a_varDecl,
           a_postMatch )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Values.STRING("));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_varDecl, a_postMatch);

    case ( txt,
           DAE.T_INTEGER(varLst = _),
           a_name,
           a_varDecl,
           a_postMatch )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Values.INTEGER("));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_varDecl, a_postMatch);

    case ( txt,
           DAE.T_BOOL(varLst = _),
           a_name,
           a_varDecl,
           a_postMatch )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Values.BOOL("));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_varDecl, a_postMatch);

    case ( txt,
           DAE.T_REAL(varLst = _),
           a_name,
           a_varDecl,
           a_postMatch )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Values.REAL("));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_varDecl, a_postMatch);

    case ( txt,
           (i_aty as DAE.T_ARRAY(ty = _)),
           a_name,
           a_varDecl,
           a_postMatch )
      equation
        a_varDecl = Tpl.writeTok(a_varDecl, Tpl.ST_STRING("Values.Value "));
        a_varDecl = Tpl.writeText(a_varDecl, a_name);
        a_varDecl = Tpl.writeTok(a_varDecl, Tpl.ST_STRING("_arr;"));
        a_varDecl = Tpl.writeTok(a_varDecl, Tpl.ST_NEW_LINE());
        a_postMatch = Tpl.writeText(a_postMatch, a_name);
        a_postMatch = Tpl.writeTok(a_postMatch, Tpl.ST_STRING(" := "));
        txt_0 = Tpl.writeText(Tpl.emptyTxt, a_name);
        txt_0 = Tpl.writeTok(txt_0, Tpl.ST_STRING("_arr"));
        (a_postMatch, txt_0) = getOutValueArray(a_postMatch, txt_0, i_aty);
        a_postMatch = Tpl.writeTok(a_postMatch, Tpl.ST_STRING(";"));
        a_postMatch = Tpl.writeTok(a_postMatch, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_arr"));
      then (txt, a_varDecl, a_postMatch);

    case ( txt,
           DAE.T_CODE(ty = DAE.C_TYPENAME()),
           a_name,
           a_varDecl,
           a_postMatch )
      equation
        a_varDecl = Tpl.writeTok(a_varDecl, Tpl.ST_STRING("Absyn.Path "));
        a_varDecl = Tpl.writeText(a_varDecl, a_name);
        a_varDecl = Tpl.writeTok(a_varDecl, Tpl.ST_STRING("_path;"));
        a_varDecl = Tpl.writeTok(a_varDecl, Tpl.ST_NEW_LINE());
        a_postMatch = Tpl.writeText(a_postMatch, a_name);
        a_postMatch = Tpl.writeTok(a_postMatch, Tpl.ST_STRING(" := AbsynUtil.pathString("));
        a_postMatch = Tpl.writeText(a_postMatch, a_name);
        a_postMatch = Tpl.writeTok(a_postMatch, Tpl.ST_STRING("_path);"));
        a_postMatch = Tpl.writeTok(a_postMatch, Tpl.ST_NEW_LINE());
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Values.CODE(Absyn.C_TYPENAME(path="));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_path))"));
      then (txt, a_varDecl, a_postMatch);

    case ( txt,
           i_ty,
           _,
           a_varDecl,
           a_postMatch )
      equation
        txt_1 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("getOutValue failed for "));
        ret_1 = Types.unparseType(i_ty);
        txt_1 = Tpl.writeStr(txt_1, ret_1);
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("GenerateAPIFunctionsTpl.tpl", 67, 16), Tpl.textString(txt_1));
      then (txt, a_varDecl, a_postMatch);
  end match;
end fun_44;

public function getOutValue
  input Tpl.Text txt;
  input Tpl.Text a_name;
  input DAE.Type a_ty;
  input Tpl.Text a_varDecl;
  input Tpl.Text a_postMatch;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_name;
  output Tpl.Text out_a_varDecl;
  output Tpl.Text out_a_postMatch;
algorithm
  (out_txt, out_a_varDecl, out_a_postMatch) := fun_44(txt, a_ty, a_name, a_varDecl, a_postMatch);
  out_a_name := a_name;
end getOutValue;

protected function fun_46
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;
  input Tpl.Text in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty, in_a_name)
    local
      Tpl.Text txt;
      Tpl.Text a_name;
      DAE.Type i_ty;
      DAE.Type i_aty_ty;
      Tpl.Text txt_1;
      String ret_1;
      Tpl.Text txt_0;

    case ( txt,
           DAE.T_STRING(varLst = _),
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("match "));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" case Values.STRING() then "));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".string; end match"));
      then txt;

    case ( txt,
           DAE.T_INTEGER(varLst = _),
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("match "));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" case Values.INTEGER() then "));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".integer; end match"));
      then txt;

    case ( txt,
           DAE.T_BOOL(varLst = _),
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("match "));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" case Values.BOOL() then "));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".boolean; end match"));
      then txt;

    case ( txt,
           DAE.T_REAL(varLst = _),
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("match "));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" case Values.REAL() then "));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".real; end match"));
      then txt;

    case ( txt,
           DAE.T_ARRAY(ty = i_aty_ty),
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("list("));
        txt_0 = Tpl.writeText(Tpl.emptyTxt, a_name);
        txt_0 = Tpl.writeTok(txt_0, Tpl.ST_STRING("_iter"));
        (txt, txt_0) = getOutValueArray(txt, txt_0, i_aty_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" for "));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_iter in ValuesUtil.arrayValues("));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("))"));
      then txt;

    case ( txt,
           DAE.T_CODE(ty = DAE.C_TYPENAME()),
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("ValuesUtil.valString("));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           i_ty,
           _ )
      equation
        txt_1 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("getOutValueArray failed for "));
        ret_1 = Types.unparseType(i_ty);
        txt_1 = Tpl.writeStr(txt_1, ret_1);
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("GenerateAPIFunctionsTpl.tpl", 81, 16), Tpl.textString(txt_1));
      then txt;
  end match;
end fun_46;

public function getOutValueArray
  input Tpl.Text txt;
  input Tpl.Text a_name;
  input DAE.Type a_ty;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_name;
algorithm
  out_txt := fun_46(txt, a_ty, a_name);
  out_a_name := a_name;
end getOutValueArray;

protected function lm_48
  input Tpl.Text in_txt;
  input list<DAE.FuncArg> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<DAE.FuncArg> rest;
      DAE.Type i_arg_ty;
      String i_arg_name;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           DAE.FUNCARG(name = i_arg_name, ty = i_arg_ty) :: rest )
      equation
        (txt, _) = getInValue(txt, Tpl.stringText(i_arg_name), i_arg_ty);
        txt = Tpl.nextIter(txt);
        txt = lm_48(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_48(txt, rest);
      then txt;
  end match;
end lm_48;

protected function lm_49
  input Tpl.Text in_txt;
  input list<DAE.Type> in_items;
  input Tpl.Text in_a_postMatch;
  input Tpl.Text in_a_varDecl;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_postMatch;
  output Tpl.Text out_a_varDecl;
algorithm
  (out_txt, out_a_postMatch, out_a_varDecl) :=
  match(in_txt, in_items, in_a_postMatch, in_a_varDecl)
    local
      Tpl.Text txt;
      list<DAE.Type> rest;
      Tpl.Text a_postMatch;
      Tpl.Text a_varDecl;
      Integer x_i;
      DAE.Type i_ty;
      Tpl.Text txt_0;

    case ( txt,
           {},
           a_postMatch,
           a_varDecl )
      then (txt, a_postMatch, a_varDecl);

    case ( txt,
           i_ty :: rest,
           a_postMatch,
           a_varDecl )
      equation
        x_i = Tpl.getIteri_i0(txt);
        txt_0 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("res"));
        txt_0 = Tpl.writeStr(txt_0, intString(x_i));
        (txt, txt_0, a_varDecl, a_postMatch) = getOutValue(txt, txt_0, i_ty, a_varDecl, a_postMatch);
        txt = Tpl.nextIter(txt);
        (txt, a_postMatch, a_varDecl) = lm_49(txt, rest, a_postMatch, a_varDecl);
      then (txt, a_postMatch, a_varDecl);
  end match;
end lm_49;

protected function fun_50
  input Tpl.Text in_txt;
  input DAE.Type in_a_res;
  input Tpl.Text in_a_postMatch;
  input Tpl.Text in_a_varDecl;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_postMatch;
  output Tpl.Text out_a_varDecl;
algorithm
  (out_txt, out_a_postMatch, out_a_varDecl) :=
  match(in_txt, in_a_res, in_a_postMatch, in_a_varDecl)
    local
      Tpl.Text txt;
      Tpl.Text a_postMatch;
      Tpl.Text a_varDecl;
      DAE.Type i_res;
      list<DAE.Type> i_types;

    case ( txt,
           DAE.T_TUPLE(types = i_types),
           a_postMatch,
           a_varDecl )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Values.TUPLE({"));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(1, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_postMatch, a_varDecl) = lm_49(txt, i_types, a_postMatch, a_varDecl);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("})"));
      then (txt, a_postMatch, a_varDecl);

    case ( txt,
           DAE.T_NORETCALL(),
           a_postMatch,
           a_varDecl )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Values.NORETCALL()"));
      then (txt, a_postMatch, a_varDecl);

    case ( txt,
           i_res,
           a_postMatch,
           a_varDecl )
      equation
        (txt, _, a_varDecl, a_postMatch) = getOutValue(txt, Tpl.strTokText(Tpl.ST_STRING("res")), i_res, a_varDecl, a_postMatch);
      then (txt, a_postMatch, a_varDecl);
  end match;
end fun_50;

protected function lm_51
  input Tpl.Text in_txt;
  input list<DAE.FuncArg> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<DAE.FuncArg> rest;
      String i_arg_name;
      DAE.Type i_arg_ty;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           DAE.FUNCARG(ty = i_arg_ty, name = i_arg_name) :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("input "));
        txt = getInType(txt, i_arg_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeStr(txt, i_arg_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        txt = lm_51(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_51(txt, rest);
      then txt;
  end match;
end lm_51;

protected function lm_52
  input Tpl.Text in_txt;
  input list<DAE.Type> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<DAE.Type> rest;
      Integer x_i;
      DAE.Type i_ty;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_ty :: rest )
      equation
        x_i = Tpl.getIteri_i0(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("output "));
        txt = getInType(txt, i_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" res"));
        txt = Tpl.writeStr(txt, intString(x_i));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        txt = lm_52(txt, rest);
      then txt;
  end match;
end lm_52;

protected function fun_53
  input Tpl.Text in_txt;
  input DAE.Type in_a_res;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_res)
    local
      Tpl.Text txt;
      DAE.Type i_res;
      list<DAE.Type> i_types;

    case ( txt,
           DAE.T_TUPLE(types = i_types) )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(1, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_52(txt, i_types);
        txt = Tpl.popIter(txt);
      then txt;

    case ( txt,
           DAE.T_NORETCALL() )
      then txt;

    case ( txt,
           i_res )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("output "));
        txt = getInType(txt, i_res);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" res;"));
      then txt;
  end match;
end fun_53;

protected function fun_54
  input Tpl.Text in_txt;
  input Tpl.Text in_a_varDecl;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_varDecl)
    local
      Tpl.Text txt;
      Tpl.Text i_varDecl;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}) )
      then txt;

    case ( txt,
           i_varDecl )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("protected\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, i_varDecl);
        txt = Tpl.popBlock(txt);
      then txt;
  end match;
end fun_54;

public function getCevalScriptInterfaceFunc
  input Tpl.Text txt;
  input String a_name;
  input list<DAE.FuncArg> a_args;
  input DAE.Type a_res;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_outVals;
  Tpl.Text l_inVals;
  Tpl.Text l_postMatch;
  Tpl.Text l_varDecl;
algorithm
  l_varDecl := Tpl.emptyTxt;
  l_postMatch := Tpl.emptyTxt;
  l_inVals := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  l_inVals := lm_48(l_inVals, a_args);
  l_inVals := Tpl.popIter(l_inVals);
  (l_outVals, l_postMatch, l_varDecl) := fun_50(Tpl.emptyTxt, a_res, l_postMatch, l_varDecl);
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING("function "));
  out_txt := Tpl.writeStr(out_txt, a_name);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.pushIter(out_txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_51(out_txt, a_args);
  out_txt := Tpl.popIter(out_txt);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := fun_53(out_txt, a_res);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.popBlock(out_txt);
  out_txt := fun_54(out_txt, l_varDecl);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("algorithm\n"));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("(_,"));
  out_txt := Tpl.writeText(out_txt, l_outVals);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING(") := CevalScript.cevalInteractiveFunctions2(FCore.emptyCache(), FGraph.empty(), \""));
  out_txt := Tpl.writeStr(out_txt, a_name);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("\", {"));
  out_txt := Tpl.writeText(out_txt, l_inVals);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("}, dummyMsg);\n"));
  out_txt := Tpl.writeText(out_txt, l_postMatch);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("end "));
  out_txt := Tpl.writeStr(out_txt, a_name);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING(";"));
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_NEW_LINE());
end getCevalScriptInterfaceFunc;

protected function lm_56
  input Tpl.Text in_txt;
  input list<DAE.Type> in_items;
  input String in_a_classNameWithColons;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_classNameWithColons)
    local
      Tpl.Text txt;
      list<DAE.Type> rest;
      String a_classNameWithColons;
      DAE.Type i_ty_funcResultType;
      list<DAE.FuncArg> i_ty_funcArg;
      Absyn.Path i_path;
      String ret_0;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           DAE.T_FUNCTION(path = i_path, funcArg = i_ty_funcArg, funcResultType = i_ty_funcResultType) :: rest,
           a_classNameWithColons )
      equation
        ret_0 = AbsynUtil.pathLastIdent(i_path);
        txt = getQtInterfaceFunc(txt, ret_0, i_ty_funcArg, i_ty_funcResultType, a_classNameWithColons);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = lm_56(txt, rest, a_classNameWithColons);
      then txt;

    case ( txt,
           _ :: rest,
           a_classNameWithColons )
      equation
        txt = lm_56(txt, rest, a_classNameWithColons);
      then txt;
  end match;
end lm_56;

public function getQtInterface
  input Tpl.Text txt;
  input list<DAE.Type> a_tys;
  input String a_classNameWithColons;
  input String a_className;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_funcs;
algorithm
  l_funcs := lm_56(Tpl.emptyTxt, a_tys, a_classNameWithColons);
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                   "/* generated by OpenModelica */\n",
                                   "#ifndef OpenModelicaScriptingAPIQt__H\n",
                                   "#define OpenModelicaScriptingAPIQt__H\n",
                                   "\n",
                                   "#include <stdexcept>\n",
                                   "#include \"OpenModelicaScriptingAPIQt.h\"\n",
                                   "\n"
                               }, true));
  out_txt := Tpl.writeStr(out_txt, a_classNameWithColons);
  out_txt := Tpl.writeStr(out_txt, a_className);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "(threadData_t *td)\n",
                                       "  : threadData(td)\n",
                                       "{\n",
                                       "}\n"
                                   }, true));
  out_txt := Tpl.writeText(out_txt, l_funcs);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "#endif /* OpenModelicaScriptingAPIQt__H */"
                                   }, false));
end getQtInterface;

protected function lm_58
  input Tpl.Text in_txt;
  input list<DAE.Type> in_items;
  input String in_a_className;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_className)
    local
      Tpl.Text txt;
      list<DAE.Type> rest;
      String a_className;
      DAE.Type i_ty_funcResultType;
      list<DAE.FuncArg> i_ty_funcArg;
      Absyn.Path i_path;
      String ret_0;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           DAE.T_FUNCTION(path = i_path, funcArg = i_ty_funcArg, funcResultType = i_ty_funcResultType) :: rest,
           a_className )
      equation
        ret_0 = AbsynUtil.pathLastIdent(i_path);
        txt = getQtInterfaceHeader(txt, ret_0, "", i_ty_funcArg, i_ty_funcResultType, a_className, true);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = lm_58(txt, rest, a_className);
      then txt;

    case ( txt,
           _ :: rest,
           a_className )
      equation
        txt = lm_58(txt, rest, a_className);
      then txt;
  end match;
end lm_58;

public function getQtInterfaceHeaders
  input Tpl.Text txt;
  input list<DAE.Type> a_tys;
  input String a_className;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_heads;
algorithm
  l_heads := lm_58(Tpl.emptyTxt, a_tys, a_className);
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                   "#include <QtCore>\n",
                                   "#include \"OpenModelicaScriptingAPI.h\"\n",
                                   "\n",
                                   "class "
                               }, false));
  out_txt := Tpl.writeStr(out_txt, a_className);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       " : public QObject\n",
                                       "{\n",
                                       "  Q_OBJECT\n",
                                       "public:\n",
                                       "  threadData_t *threadData;\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeStr(out_txt, a_className);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("(threadData_t *td);\n"));
  out_txt := Tpl.writeText(out_txt, l_heads);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "signals:\n",
                                       "  void logCommand(QString command, QTime *commandTime);\n",
                                       "  void logResponse(QString command, QString response, QTime *responseTime);\n",
                                       "  void throwException(QString exception);\n",
                                       "};"
                                   }, false));
end getQtInterfaceHeaders;

public function getQtType
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty)
    local
      Tpl.Text txt;
      DAE.Type i_ty;
      DAE.Type i_aty_ty;
      Tpl.Text txt_0;
      String ret_0;

    case ( txt,
           DAE.T_STRING(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("QString"));
      then txt;

    case ( txt,
           DAE.T_INTEGER(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_integer"));
      then txt;

    case ( txt,
           DAE.T_BOOL(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_boolean"));
      then txt;

    case ( txt,
           DAE.T_REAL(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_real"));
      then txt;

    case ( txt,
           DAE.T_ARRAY(ty = i_aty_ty) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("QList<"));
        txt = getQtType(txt, i_aty_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" >"));
      then txt;

    case ( txt,
           DAE.T_CODE(ty = DAE.C_TYPENAME()) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("QString"));
      then txt;

    case ( txt,
           i_ty )
      equation
        txt_0 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("getQtType failed for "));
        ret_0 = Types.unparseType(i_ty);
        txt_0 = Tpl.writeStr(txt_0, ret_0);
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("GenerateAPIFunctionsTpl.tpl", 168, 16), Tpl.textString(txt_0));
      then txt;
  end match;
end getQtType;

public function getQtTupleTypeOutputNameHelper
  input Tpl.Text in_txt;
  input Option<list<String>> in_a_names;
  input Integer in_a_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_names, in_a_index)
    local
      Tpl.Text txt;
      Integer a_index;
      list<String> i_lst;
      String ret_0;

    case ( txt,
           SOME(i_lst),
           a_index )
      equation
        ret_0 = listGet(i_lst, a_index);
        txt = Tpl.writeStr(txt, ret_0);
      then txt;

    case ( txt,
           _,
           a_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("res"));
        txt = Tpl.writeStr(txt, intString(a_index));
      then txt;
  end match;
end getQtTupleTypeOutputNameHelper;

public function getQtTupleTypeOutputName
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;
  input Integer in_a_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty, in_a_index)
    local
      Tpl.Text txt;
      Integer a_index;
      Option<list<String>> i_names;

    case ( txt,
           DAE.T_TUPLE(names = i_names),
           a_index )
      equation
        txt = getQtTupleTypeOutputNameHelper(txt, i_names, a_index);
      then txt;

    case ( txt,
           _,
           a_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("res"));
        txt = Tpl.writeStr(txt, intString(a_index));
      then txt;
  end match;
end getQtTupleTypeOutputName;

protected function fun_63
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;
  input DAE.Type in_a_res;
  input Integer in_a_index;
  input Tpl.Text in_a_name;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_name;
algorithm
  (out_txt, out_a_name) :=
  match(in_txt, in_a_ty, in_a_res, in_a_index, in_a_name)
    local
      Tpl.Text txt;
      DAE.Type a_res;
      Integer a_index;
      Tpl.Text a_name;
      DAE.Type i_ty;
      DAE.Type i_aty_ty;
      Tpl.Text txt_3;
      String ret_3;
      Tpl.Text l_counter;
      Tpl.Text l_elt;
      Tpl.Text l_varName;

    case ( txt,
           DAE.T_CODE(ty = DAE.C_TYPENAME()),
           a_res,
           a_index,
           a_name )
      equation
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".append("));
        txt = getQtTupleTypeOutputName(txt, a_res, a_index);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then (txt, a_name);

    case ( txt,
           DAE.T_STRING(varLst = _),
           a_res,
           a_index,
           a_name )
      equation
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".append(\"\\\"\" + "));
        txt = getQtTupleTypeOutputName(txt, a_res, a_index);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" + \"\\\"\");"));
      then (txt, a_name);

    case ( txt,
           DAE.T_INTEGER(varLst = _),
           a_res,
           a_index,
           a_name )
      equation
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".append(QString::number("));
        txt = getQtTupleTypeOutputName(txt, a_res, a_index);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("));"));
      then (txt, a_name);

    case ( txt,
           DAE.T_REAL(varLst = _),
           a_res,
           a_index,
           a_name )
      equation
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".append(QString::number("));
        txt = getQtTupleTypeOutputName(txt, a_res, a_index);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("));"));
      then (txt, a_name);

    case ( txt,
           DAE.T_BOOL(varLst = _),
           a_res,
           a_index,
           a_name )
      equation
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".append("));
        txt = getQtTupleTypeOutputName(txt, a_res, a_index);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" ? \"true\" : \"false\");"));
      then (txt, a_name);

    case ( txt,
           DAE.T_ARRAY(ty = i_aty_ty),
           a_res,
           a_index,
           a_name )
      equation
        l_varName = getQtTupleTypeOutputName(Tpl.emptyTxt, a_res, a_index);
        l_elt = Tpl.writeText(Tpl.emptyTxt, l_varName);
        l_elt = Tpl.writeTok(l_elt, Tpl.ST_STRING("_elt"));
        l_counter = Tpl.writeText(Tpl.emptyTxt, l_varName);
        l_counter = Tpl.writeTok(l_counter, Tpl.ST_STRING("_i"));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ".append(\"{\");\n",
                                    "int "
                                }, false));
        txt = Tpl.writeText(txt, l_counter);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " = 0;\n",
                                    "foreach("
                                }, false));
        txt = getQtType(txt, i_aty_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, l_elt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, l_varName);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(") {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if ("));
        txt = Tpl.writeText(txt, l_counter);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(") {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(".append(\",\");\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("}\n"));
        (txt, l_elt, a_name) = getQtResponseLogText(txt, l_elt, i_aty_ty, a_name);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_counter);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("++;\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("}\n"));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".append(\"}\");"));
      then (txt, a_name);

    case ( txt,
           i_ty,
           _,
           _,
           a_name )
      equation
        txt_3 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("structToString failed for "));
        ret_3 = Types.unparseType(i_ty);
        txt_3 = Tpl.writeStr(txt_3, ret_3);
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("GenerateAPIFunctionsTpl.tpl", 213, 16), Tpl.textString(txt_3));
      then (txt, a_name);
  end match;
end fun_63;

public function structToString
  input Tpl.Text txt;
  input DAE.Type a_res;
  input DAE.Type a_ty;
  input Integer a_index;
  input Tpl.Text a_name;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_name;
algorithm
  (out_txt, out_a_name) := fun_63(txt, a_ty, a_res, a_index, a_name);
end structToString;

protected function lm_65
  input Tpl.Text in_txt;
  input list<DAE.FuncArg> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<DAE.FuncArg> rest;
      String i_arg_name;
      DAE.Type i_arg_ty;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           DAE.FUNCARG(ty = i_arg_ty, name = i_arg_name) :: rest )
      equation
        txt = getQtType(txt, i_arg_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeStr(txt, i_arg_name);
        txt = Tpl.nextIter(txt);
        txt = lm_65(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_65(txt, rest);
      then txt;
  end match;
end lm_65;

protected function lm_66
  input Tpl.Text in_txt;
  input list<DAE.Type> in_items;
  input DAE.Type in_a_res;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_res)
    local
      Tpl.Text txt;
      list<DAE.Type> rest;
      DAE.Type a_res;
      Integer x_i;
      DAE.Type i_ty;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_ty :: rest,
           a_res )
      equation
        x_i = Tpl.getIteri_i0(txt);
        txt = getQtType(txt, i_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = getQtTupleTypeOutputName(txt, a_res, x_i);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        txt = lm_66(txt, rest, a_res);
      then txt;
  end match;
end lm_66;

protected function lm_67
  input Tpl.Text in_txt;
  input list<DAE.Type> in_items;
  input DAE.Type in_a_res;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_res)
    local
      Tpl.Text txt;
      list<DAE.Type> rest;
      DAE.Type a_res;
      Integer x_i;
      DAE.Type i_ty;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_ty :: rest,
           a_res )
      equation
        x_i = Tpl.getIteri_i0(txt);
        (txt, _) = structToString(txt, a_res, i_ty, x_i, Tpl.strTokText(Tpl.ST_STRING("resultBuffer")));
        txt = Tpl.nextIter(txt);
        txt = lm_67(txt, rest, a_res);
      then txt;
  end match;
end lm_67;

protected function fun_68
  input Tpl.Text in_txt;
  input Boolean in_a_addStructs;
  input DAE.Type in_a_res;
  input list<DAE.Type> in_a_types;
  input String in_a_name;
  input String in_a_prefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_addStructs, in_a_res, in_a_types, in_a_name, in_a_prefix)
    local
      Tpl.Text txt;
      DAE.Type a_res;
      list<DAE.Type> a_types;
      String a_name;
      String a_prefix;
      Tpl.StringToken ret_1;
      Tpl.Text txt_0;

    case ( txt,
           false,
           _,
           _,
           a_name,
           a_prefix )
      equation
        txt = Tpl.writeStr(txt, a_prefix);
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_res"));
      then txt;

    case ( txt,
           _,
           a_res,
           a_types,
           a_name,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("typedef struct {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(1, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_66(txt, a_types, a_res);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "QString toString() {\n",
                                    "  QString resultBuffer = \"(\";\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt_0 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_NEW_LINE());
        txt_0 = Tpl.writeTok(txt_0, Tpl.ST_STRING("resultBuffer.append(\",\");"));
        txt_0 = Tpl.writeTok(txt_0, Tpl.ST_NEW_LINE());
        ret_1 = Tpl.textStrTok(txt_0);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(1, NONE(), SOME(ret_1), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_67(txt, a_types, a_res);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "resultBuffer.append(\")\");\n",
                                    "return resultBuffer;\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("}\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("} "));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_res;\n"));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_res"));
      then txt;
  end match;
end fun_68;

protected function fun_69
  input Tpl.Text in_txt;
  input DAE.Type in_a_res;
  input String in_a_name;
  input String in_a_prefix;
  input Boolean in_a_addStructs;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_res, in_a_name, in_a_prefix, in_a_addStructs)
    local
      Tpl.Text txt;
      String a_name;
      String a_prefix;
      Boolean a_addStructs;
      DAE.Type i_res;
      list<DAE.Type> i_types;

    case ( txt,
           (i_res as DAE.T_TUPLE(types = i_types)),
           a_name,
           a_prefix,
           a_addStructs )
      equation
        txt = fun_68(txt, a_addStructs, i_res, i_types, a_name, a_prefix);
      then txt;

    case ( txt,
           DAE.T_NORETCALL(),
           _,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void"));
      then txt;

    case ( txt,
           i_res,
           _,
           _,
           _ )
      equation
        txt = getQtType(txt, i_res);
      then txt;
  end match;
end fun_69;

public function getQtInterfaceHeader
  input Tpl.Text txt;
  input String a_name;
  input String a_prefix;
  input list<DAE.FuncArg> a_args;
  input DAE.Type a_res;
  input String a_className;
  input Boolean a_addStructs;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_outType;
  Tpl.Text l_inTypes;
algorithm
  l_inTypes := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  l_inTypes := lm_65(l_inTypes, a_args);
  l_inTypes := Tpl.popIter(l_inTypes);
  l_outType := fun_69(Tpl.emptyTxt, a_res, a_name, a_prefix, a_addStructs);
  out_txt := Tpl.writeText(txt, l_outType);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING(" "));
  out_txt := Tpl.writeStr(out_txt, a_prefix);
  out_txt := Tpl.writeStr(out_txt, a_name);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("("));
  out_txt := Tpl.writeText(out_txt, l_inTypes);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING(")"));
end getQtInterfaceHeader;

protected function fun_71
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;
  input Tpl.Text in_a_name;
  input Tpl.Text in_a_varDecl;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecl;
algorithm
  (out_txt, out_a_varDecl) :=
  match(in_txt, in_a_ty, in_a_name, in_a_varDecl)
    local
      Tpl.Text txt;
      Tpl.Text a_name;
      Tpl.Text a_varDecl;
      DAE.Type i_ty;
      DAE.Type i_aty_ty;
      Tpl.Text txt_5;
      String ret_5;
      Tpl.Text l_i;
      Tpl.Text txt_3;
      Tpl.Text l_body;
      Tpl.Text l_elt;
      Tpl.Text l_varDecl2;

    case ( txt,
           DAE.T_CODE(ty = DAE.C_TYPENAME()),
           a_name,
           a_varDecl )
      equation
        a_varDecl = Tpl.writeTok(a_varDecl, Tpl.ST_STRING("QByteArray "));
        a_varDecl = Tpl.writeText(a_varDecl, a_name);
        a_varDecl = Tpl.writeTok(a_varDecl, Tpl.ST_STRING("_utf8 = "));
        a_varDecl = Tpl.writeText(a_varDecl, a_name);
        a_varDecl = Tpl.writeTok(a_varDecl, Tpl.ST_STRING(".toUtf8();"));
        a_varDecl = Tpl.writeTok(a_varDecl, Tpl.ST_NEW_LINE());
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("mmc_mk_scon("));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_utf8.constData())"));
      then (txt, a_varDecl);

    case ( txt,
           DAE.T_STRING(varLst = _),
           a_name,
           a_varDecl )
      equation
        a_varDecl = Tpl.writeTok(a_varDecl, Tpl.ST_STRING("QByteArray "));
        a_varDecl = Tpl.writeText(a_varDecl, a_name);
        a_varDecl = Tpl.writeTok(a_varDecl, Tpl.ST_STRING("_utf8 = "));
        a_varDecl = Tpl.writeText(a_varDecl, a_name);
        a_varDecl = Tpl.writeTok(a_varDecl, Tpl.ST_STRING(".toUtf8();"));
        a_varDecl = Tpl.writeTok(a_varDecl, Tpl.ST_NEW_LINE());
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("mmc_mk_scon("));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_utf8.constData())"));
      then (txt, a_varDecl);

    case ( txt,
           DAE.T_INTEGER(varLst = _),
           a_name,
           a_varDecl )
      equation
        txt = Tpl.writeText(txt, a_name);
      then (txt, a_varDecl);

    case ( txt,
           DAE.T_BOOL(varLst = _),
           a_name,
           a_varDecl )
      equation
        txt = Tpl.writeText(txt, a_name);
      then (txt, a_varDecl);

    case ( txt,
           DAE.T_REAL(varLst = _),
           a_name,
           a_varDecl )
      equation
        txt = Tpl.writeText(txt, a_name);
      then (txt, a_varDecl);

    case ( txt,
           DAE.T_ARRAY(ty = i_aty_ty),
           a_name,
           a_varDecl )
      equation
        l_varDecl2 = Tpl.emptyTxt;
        l_elt = Tpl.writeText(Tpl.emptyTxt, a_name);
        l_elt = Tpl.writeTok(l_elt, Tpl.ST_STRING("_elt"));
        (txt_3, l_elt, l_varDecl2) = getQtInArg(Tpl.emptyTxt, l_elt, i_aty_ty, l_varDecl2);
        (l_body, txt_3) = getQtInArgBoxed(Tpl.emptyTxt, txt_3, i_aty_ty);
        l_i = Tpl.writeText(Tpl.emptyTxt, a_name);
        l_i = Tpl.writeTok(l_i, Tpl.ST_STRING("_i"));
        a_varDecl = Tpl.writeTok(a_varDecl, Tpl.ST_STRING("void *"));
        a_varDecl = Tpl.writeText(a_varDecl, a_name);
        a_varDecl = Tpl.writeTok(a_varDecl, Tpl.ST_STRING_LIST({
                                                "_lst = mmc_mk_nil();\n",
                                                "for (int "
                                            }, false));
        a_varDecl = Tpl.writeText(a_varDecl, l_i);
        a_varDecl = Tpl.writeTok(a_varDecl, Tpl.ST_STRING(" = "));
        a_varDecl = Tpl.writeText(a_varDecl, a_name);
        a_varDecl = Tpl.writeTok(a_varDecl, Tpl.ST_STRING(".size()-1; "));
        a_varDecl = Tpl.writeText(a_varDecl, l_i);
        a_varDecl = Tpl.writeTok(a_varDecl, Tpl.ST_STRING(">=0; "));
        a_varDecl = Tpl.writeText(a_varDecl, l_i);
        a_varDecl = Tpl.writeTok(a_varDecl, Tpl.ST_LINE("--) {\n"));
        a_varDecl = Tpl.pushBlock(a_varDecl, Tpl.BT_INDENT(2));
        a_varDecl = getQtType(a_varDecl, i_aty_ty);
        a_varDecl = Tpl.writeTok(a_varDecl, Tpl.ST_STRING(" "));
        a_varDecl = Tpl.writeText(a_varDecl, l_elt);
        a_varDecl = Tpl.writeTok(a_varDecl, Tpl.ST_STRING(" = "));
        a_varDecl = Tpl.writeText(a_varDecl, a_name);
        a_varDecl = Tpl.writeTok(a_varDecl, Tpl.ST_STRING("["));
        a_varDecl = Tpl.writeText(a_varDecl, l_i);
        a_varDecl = Tpl.writeTok(a_varDecl, Tpl.ST_LINE("];\n"));
        a_varDecl = Tpl.writeText(a_varDecl, l_varDecl2);
        a_varDecl = Tpl.softNewLine(a_varDecl);
        a_varDecl = Tpl.writeText(a_varDecl, a_name);
        a_varDecl = Tpl.writeTok(a_varDecl, Tpl.ST_STRING("_lst = mmc_mk_cons("));
        a_varDecl = Tpl.writeText(a_varDecl, l_body);
        a_varDecl = Tpl.writeTok(a_varDecl, Tpl.ST_STRING(", "));
        a_varDecl = Tpl.writeText(a_varDecl, a_name);
        a_varDecl = Tpl.writeTok(a_varDecl, Tpl.ST_LINE("_lst);\n"));
        a_varDecl = Tpl.popBlock(a_varDecl);
        a_varDecl = Tpl.writeTok(a_varDecl, Tpl.ST_STRING("}"));
        a_varDecl = Tpl.writeTok(a_varDecl, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_lst"));
      then (txt, a_varDecl);

    case ( txt,
           i_ty,
           _,
           a_varDecl )
      equation
        txt_5 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("getQtInArg failed for "));
        ret_5 = Types.unparseType(i_ty);
        txt_5 = Tpl.writeStr(txt_5, ret_5);
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("GenerateAPIFunctionsTpl.tpl", 268, 16), Tpl.textString(txt_5));
      then (txt, a_varDecl);
  end match;
end fun_71;

public function getQtInArg
  input Tpl.Text txt;
  input Tpl.Text a_name;
  input DAE.Type a_ty;
  input Tpl.Text a_varDecl;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_name;
  output Tpl.Text out_a_varDecl;
algorithm
  (out_txt, out_a_varDecl) := fun_71(txt, a_ty, a_name, a_varDecl);
  out_a_name := a_name;
end getQtInArg;

protected function fun_73
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;
  input Tpl.Text in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty, in_a_name)
    local
      Tpl.Text txt;
      Tpl.Text a_name;
      DAE.Type i_ty;
      Tpl.Text txt_0;
      String ret_0;

    case ( txt,
           DAE.T_CODE(ty = DAE.C_TYPENAME()),
           a_name )
      equation
        txt = Tpl.writeText(txt, a_name);
      then txt;

    case ( txt,
           DAE.T_STRING(varLst = _),
           a_name )
      equation
        txt = Tpl.writeText(txt, a_name);
      then txt;

    case ( txt,
           DAE.T_ARRAY(ty = _),
           a_name )
      equation
        txt = Tpl.writeText(txt, a_name);
      then txt;

    case ( txt,
           DAE.T_INTEGER(varLst = _),
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("mmc_mk_icon("));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.T_BOOL(varLst = _),
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("mmc_mk_icon("));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.T_REAL(varLst = _),
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("mmc_mk_rcon("));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           i_ty,
           _ )
      equation
        txt_0 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("getQtInArgBoxed failed for "));
        ret_0 = Types.unparseType(i_ty);
        txt_0 = Tpl.writeStr(txt_0, ret_0);
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("GenerateAPIFunctionsTpl.tpl", 280, 16), Tpl.textString(txt_0));
      then txt;
  end match;
end fun_73;

public function getQtInArgBoxed
  input Tpl.Text txt;
  input Tpl.Text a_name;
  input DAE.Type a_ty;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_name;
algorithm
  out_txt := fun_73(txt, a_ty, a_name);
  out_a_name := a_name;
end getQtInArgBoxed;

protected function fun_75
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;
  input Tpl.Text in_a_name;
  input Tpl.Text in_a_commandLog;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_commandLog;
algorithm
  (out_txt, out_a_commandLog) :=
  match(in_txt, in_a_ty, in_a_name, in_a_commandLog)
    local
      Tpl.Text txt;
      Tpl.Text a_name;
      Tpl.Text a_commandLog;
      DAE.Type i_ty;
      DAE.Type i_aty_ty;
      Tpl.Text txt_2;
      String ret_2;
      Tpl.Text l_counter;
      Tpl.Text l_elt;

    case ( txt,
           DAE.T_CODE(ty = DAE.C_TYPENAME()),
           a_name,
           a_commandLog )
      equation
        txt = Tpl.writeText(txt, a_commandLog);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".append("));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then (txt, a_commandLog);

    case ( txt,
           DAE.T_STRING(varLst = _),
           a_name,
           a_commandLog )
      equation
        txt = Tpl.writeText(txt, a_commandLog);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".append(\"\\\"\" + "));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" + \"\\\"\");"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then (txt, a_commandLog);

    case ( txt,
           DAE.T_INTEGER(varLst = _),
           a_name,
           a_commandLog )
      equation
        txt = Tpl.writeText(txt, a_commandLog);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".append(QString::number("));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("));"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then (txt, a_commandLog);

    case ( txt,
           DAE.T_REAL(varLst = _),
           a_name,
           a_commandLog )
      equation
        txt = Tpl.writeText(txt, a_commandLog);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".append(QString::number("));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("));"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then (txt, a_commandLog);

    case ( txt,
           DAE.T_BOOL(varLst = _),
           a_name,
           a_commandLog )
      equation
        txt = Tpl.writeText(txt, a_commandLog);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".append("));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" ? \"true\" : \"false\");"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then (txt, a_commandLog);

    case ( txt,
           DAE.T_ARRAY(ty = i_aty_ty),
           a_name,
           a_commandLog )
      equation
        l_elt = Tpl.writeText(Tpl.emptyTxt, a_name);
        l_elt = Tpl.writeTok(l_elt, Tpl.ST_STRING("_elt"));
        l_counter = Tpl.writeText(Tpl.emptyTxt, a_name);
        l_counter = Tpl.writeTok(l_counter, Tpl.ST_STRING("_i"));
        txt = Tpl.writeText(txt, a_commandLog);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ".append(\"{\");\n",
                                    "int "
                                }, false));
        txt = Tpl.writeText(txt, l_counter);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " = 0;\n",
                                    "foreach("
                                }, false));
        txt = getQtType(txt, i_aty_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, l_elt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(") {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if ("));
        txt = Tpl.writeText(txt, l_counter);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(") {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_commandLog);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(".append(\",\");\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("}\n"));
        (txt, l_elt, a_commandLog) = getQtCommandLogText(txt, l_elt, i_aty_ty, a_commandLog);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_counter);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("++;\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("}\n"));
        txt = Tpl.writeText(txt, a_commandLog);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".append(\"}\");"));
      then (txt, a_commandLog);

    case ( txt,
           i_ty,
           _,
           a_commandLog )
      equation
        txt_2 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("getQtCommandLogText failed for "));
        ret_2 = Types.unparseType(i_ty);
        txt_2 = Tpl.writeStr(txt_2, ret_2);
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("GenerateAPIFunctionsTpl.tpl", 306, 16), Tpl.textString(txt_2));
      then (txt, a_commandLog);
  end match;
end fun_75;

public function getQtCommandLogText
  input Tpl.Text txt;
  input Tpl.Text a_name;
  input DAE.Type a_ty;
  input Tpl.Text a_commandLog;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_name;
  output Tpl.Text out_a_commandLog;
algorithm
  (out_txt, out_a_commandLog) := fun_75(txt, a_ty, a_name, a_commandLog);
  out_a_name := a_name;
end getQtCommandLogText;

protected function fun_77
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;
  input Tpl.Text in_a_name;
  input Tpl.Text in_a_shortName;
  input Tpl.Text in_a_varDecl;
  input Tpl.Text in_a_postCall;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_name;
  output Tpl.Text out_a_shortName;
  output Tpl.Text out_a_varDecl;
  output Tpl.Text out_a_postCall;
algorithm
  (out_txt, out_a_name, out_a_shortName, out_a_varDecl, out_a_postCall) :=
  match(in_txt, in_a_ty, in_a_name, in_a_shortName, in_a_varDecl, in_a_postCall)
    local
      Tpl.Text txt;
      Tpl.Text a_name;
      Tpl.Text a_shortName;
      Tpl.Text a_varDecl;
      Tpl.Text a_postCall;
      DAE.Type i_ty;
      DAE.Type i_aty;
      Tpl.Text txt_1;
      String ret_1;
      Tpl.Text txt_0;

    case ( txt,
           DAE.T_CODE(ty = DAE.C_TYPENAME()),
           a_name,
           a_shortName,
           a_varDecl,
           a_postCall )
      equation
        a_varDecl = Tpl.writeTok(a_varDecl, Tpl.ST_STRING("void *"));
        a_varDecl = Tpl.writeText(a_varDecl, a_shortName);
        a_varDecl = Tpl.writeTok(a_varDecl, Tpl.ST_STRING("_mm = NULL;"));
        a_varDecl = Tpl.writeTok(a_varDecl, Tpl.ST_NEW_LINE());
        a_postCall = Tpl.writeText(a_postCall, a_name);
        a_postCall = Tpl.writeTok(a_postCall, Tpl.ST_STRING(" = QString::fromUtf8(MMC_STRINGDATA("));
        a_postCall = Tpl.writeText(a_postCall, a_shortName);
        a_postCall = Tpl.writeTok(a_postCall, Tpl.ST_STRING("_mm));"));
        a_postCall = Tpl.writeTok(a_postCall, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_shortName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_mm"));
      then (txt, a_name, a_shortName, a_varDecl, a_postCall);

    case ( txt,
           DAE.T_STRING(varLst = _),
           a_name,
           a_shortName,
           a_varDecl,
           a_postCall )
      equation
        a_varDecl = Tpl.writeTok(a_varDecl, Tpl.ST_STRING("void *"));
        a_varDecl = Tpl.writeText(a_varDecl, a_shortName);
        a_varDecl = Tpl.writeTok(a_varDecl, Tpl.ST_STRING("_mm = NULL;"));
        a_varDecl = Tpl.writeTok(a_varDecl, Tpl.ST_NEW_LINE());
        a_postCall = Tpl.writeText(a_postCall, a_name);
        a_postCall = Tpl.writeTok(a_postCall, Tpl.ST_STRING(" = QString::fromUtf8(MMC_STRINGDATA("));
        a_postCall = Tpl.writeText(a_postCall, a_shortName);
        a_postCall = Tpl.writeTok(a_postCall, Tpl.ST_STRING("_mm));"));
        a_postCall = Tpl.writeTok(a_postCall, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_shortName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_mm"));
      then (txt, a_name, a_shortName, a_varDecl, a_postCall);

    case ( txt,
           DAE.T_INTEGER(varLst = _),
           a_name,
           a_shortName,
           a_varDecl,
           a_postCall )
      equation
        txt = Tpl.writeText(txt, a_name);
      then (txt, a_name, a_shortName, a_varDecl, a_postCall);

    case ( txt,
           DAE.T_BOOL(varLst = _),
           a_name,
           a_shortName,
           a_varDecl,
           a_postCall )
      equation
        txt = Tpl.writeText(txt, a_name);
      then (txt, a_name, a_shortName, a_varDecl, a_postCall);

    case ( txt,
           DAE.T_REAL(varLst = _),
           a_name,
           a_shortName,
           a_varDecl,
           a_postCall )
      equation
        txt = Tpl.writeText(txt, a_name);
      then (txt, a_name, a_shortName, a_varDecl, a_postCall);

    case ( txt,
           (i_aty as DAE.T_ARRAY(ty = _)),
           a_name,
           a_shortName,
           a_varDecl,
           a_postCall )
      equation
        a_varDecl = Tpl.writeTok(a_varDecl, Tpl.ST_STRING("void *"));
        a_varDecl = Tpl.writeText(a_varDecl, a_shortName);
        a_varDecl = Tpl.writeTok(a_varDecl, Tpl.ST_STRING("_mm = NULL;"));
        a_varDecl = Tpl.writeTok(a_varDecl, Tpl.ST_NEW_LINE());
        txt_0 = Tpl.writeText(Tpl.emptyTxt, a_shortName);
        txt_0 = Tpl.writeTok(txt_0, Tpl.ST_STRING("_mm"));
        (a_postCall, a_name, a_shortName, txt_0) = getQtOutArgArray(a_postCall, a_name, a_shortName, txt_0, i_aty);
        txt = Tpl.writeText(txt, a_shortName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_mm"));
      then (txt, a_name, a_shortName, a_varDecl, a_postCall);

    case ( txt,
           i_ty,
           a_name,
           a_shortName,
           a_varDecl,
           a_postCall )
      equation
        txt_1 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("getQtOutArg failed for "));
        ret_1 = Types.unparseType(i_ty);
        txt_1 = Tpl.writeStr(txt_1, ret_1);
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("GenerateAPIFunctionsTpl.tpl", 324, 16), Tpl.textString(txt_1));
      then (txt, a_name, a_shortName, a_varDecl, a_postCall);
  end match;
end fun_77;

public function getQtOutArg
  input Tpl.Text txt;
  input Tpl.Text a_name;
  input Tpl.Text a_shortName;
  input DAE.Type a_ty;
  input Tpl.Text a_varDecl;
  input Tpl.Text a_postCall;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_name;
  output Tpl.Text out_a_shortName;
  output Tpl.Text out_a_varDecl;
  output Tpl.Text out_a_postCall;
algorithm
  (out_txt, out_a_name, out_a_shortName, out_a_varDecl, out_a_postCall) := fun_77(txt, a_ty, a_name, a_shortName, a_varDecl, a_postCall);
end getQtOutArg;

protected function fun_79
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;
  input Tpl.Text in_a_name;
  input Tpl.Text in_a_shortName;
  input Tpl.Text in_a_mm;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty, in_a_name, in_a_shortName, in_a_mm)
    local
      Tpl.Text txt;
      Tpl.Text a_name;
      Tpl.Text a_shortName;
      Tpl.Text a_mm;
      DAE.Type i_ty;
      DAE.Type i_aty_ty;
      Tpl.Text txt_2;
      String ret_2;
      Tpl.Text txt_1;
      Tpl.Text l_elt;

    case ( txt,
           DAE.T_CODE(ty = DAE.C_TYPENAME()),
           a_name,
           _,
           a_mm )
      equation
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = MMC_STRINGDATA("));
        txt = Tpl.writeText(txt, a_mm);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           DAE.T_STRING(varLst = _),
           a_name,
           _,
           a_mm )
      equation
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = MMC_STRINGDATA("));
        txt = Tpl.writeText(txt, a_mm);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           DAE.T_INTEGER(varLst = _),
           a_name,
           _,
           a_mm )
      equation
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = mmc_unbox_integer("));
        txt = Tpl.writeText(txt, a_mm);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           DAE.T_BOOL(varLst = _),
           a_name,
           _,
           a_mm )
      equation
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = mmc_unbox_boolean("));
        txt = Tpl.writeText(txt, a_mm);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           DAE.T_REAL(varLst = _),
           a_name,
           _,
           a_mm )
      equation
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = mmc_unbox_real("));
        txt = Tpl.writeText(txt, a_mm);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           DAE.T_ARRAY(ty = i_aty_ty),
           a_name,
           a_shortName,
           a_mm )
      equation
        l_elt = Tpl.writeText(Tpl.emptyTxt, a_shortName);
        l_elt = Tpl.writeTok(l_elt, Tpl.ST_STRING("_elt"));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ".clear();\n",
                                    "while (!listEmpty("
                                }, false));
        txt = Tpl.writeText(txt, a_mm);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(")) {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = getQtType(txt, i_aty_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, l_elt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt_1 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("MMC_CAR("));
        txt_1 = Tpl.writeText(txt_1, a_mm);
        txt_1 = Tpl.writeTok(txt_1, Tpl.ST_STRING(")"));
        (txt, _, l_elt, txt_1) = getQtOutArgArray(txt, l_elt, l_elt, txt_1, i_aty_ty);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".push_back("));
        txt = Tpl.writeText(txt, l_elt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(");\n"));
        txt = Tpl.writeText(txt, a_mm);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = MMC_CDR("));
        txt = Tpl.writeText(txt, a_mm);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(");\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           i_ty,
           _,
           _,
           _ )
      equation
        txt_2 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("getOutValueArray failed for "));
        ret_2 = Types.unparseType(i_ty);
        txt_2 = Tpl.writeStr(txt_2, ret_2);
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("GenerateAPIFunctionsTpl.tpl", 346, 16), Tpl.textString(txt_2));
      then txt;
  end match;
end fun_79;

public function getQtOutArgArray
  input Tpl.Text txt;
  input Tpl.Text a_name;
  input Tpl.Text a_shortName;
  input Tpl.Text a_mm;
  input DAE.Type a_ty;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_name;
  output Tpl.Text out_a_shortName;
  output Tpl.Text out_a_mm;
algorithm
  out_txt := fun_79(txt, a_ty, a_name, a_shortName, a_mm);
  out_a_name := a_name;
  out_a_shortName := a_shortName;
  out_a_mm := a_mm;
end getQtOutArgArray;

protected function fun_81
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;
  input Tpl.Text in_a_name;
  input Tpl.Text in_a_responseLog;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_responseLog;
algorithm
  (out_txt, out_a_responseLog) :=
  match(in_txt, in_a_ty, in_a_name, in_a_responseLog)
    local
      Tpl.Text txt;
      Tpl.Text a_name;
      Tpl.Text a_responseLog;
      DAE.Type i_ty;
      DAE.Type i_aty_ty;
      Tpl.Text txt_2;
      String ret_2;
      Tpl.Text l_counter;
      Tpl.Text l_elt;

    case ( txt,
           DAE.T_CODE(ty = DAE.C_TYPENAME()),
           a_name,
           a_responseLog )
      equation
        txt = Tpl.writeText(txt, a_responseLog);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".append("));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then (txt, a_responseLog);

    case ( txt,
           DAE.T_STRING(varLst = _),
           a_name,
           a_responseLog )
      equation
        txt = Tpl.writeText(txt, a_responseLog);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".append(\"\\\"\" + "));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" + \"\\\"\");"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then (txt, a_responseLog);

    case ( txt,
           DAE.T_INTEGER(varLst = _),
           a_name,
           a_responseLog )
      equation
        txt = Tpl.writeText(txt, a_responseLog);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".append(QString::number("));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("));"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then (txt, a_responseLog);

    case ( txt,
           DAE.T_REAL(varLst = _),
           a_name,
           a_responseLog )
      equation
        txt = Tpl.writeText(txt, a_responseLog);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".append(QString::number("));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("));"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then (txt, a_responseLog);

    case ( txt,
           DAE.T_BOOL(varLst = _),
           a_name,
           a_responseLog )
      equation
        txt = Tpl.writeText(txt, a_responseLog);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".append("));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" ? \"true\" : \"false\");"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then (txt, a_responseLog);

    case ( txt,
           DAE.T_TUPLE(types = _),
           a_name,
           a_responseLog )
      equation
        txt = Tpl.writeText(txt, a_responseLog);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".append("));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".toString());"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then (txt, a_responseLog);

    case ( txt,
           DAE.T_ARRAY(ty = i_aty_ty),
           a_name,
           a_responseLog )
      equation
        l_elt = Tpl.writeText(Tpl.emptyTxt, a_name);
        l_elt = Tpl.writeTok(l_elt, Tpl.ST_STRING("_elt"));
        l_counter = Tpl.writeText(Tpl.emptyTxt, a_name);
        l_counter = Tpl.writeTok(l_counter, Tpl.ST_STRING("_i"));
        txt = Tpl.writeText(txt, a_responseLog);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ".append(\"{\");\n",
                                    "int "
                                }, false));
        txt = Tpl.writeText(txt, l_counter);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " = 0;\n",
                                    "foreach("
                                }, false));
        txt = getQtType(txt, i_aty_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, l_elt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(") {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if ("));
        txt = Tpl.writeText(txt, l_counter);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(") {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_responseLog);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(".append(\",\");\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("}\n"));
        (txt, l_elt, a_responseLog) = getQtResponseLogText(txt, l_elt, i_aty_ty, a_responseLog);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_counter);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("++;\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("}\n"));
        txt = Tpl.writeText(txt, a_responseLog);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".append(\"}\");"));
      then (txt, a_responseLog);

    case ( txt,
           i_ty,
           _,
           a_responseLog )
      equation
        txt_2 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("getQtResponseLogText failed for "));
        ret_2 = Types.unparseType(i_ty);
        txt_2 = Tpl.writeStr(txt_2, ret_2);
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("GenerateAPIFunctionsTpl.tpl", 373, 16), Tpl.textString(txt_2));
      then (txt, a_responseLog);
  end match;
end fun_81;

public function getQtResponseLogText
  input Tpl.Text txt;
  input Tpl.Text a_name;
  input DAE.Type a_ty;
  input Tpl.Text a_responseLog;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_name;
  output Tpl.Text out_a_responseLog;
algorithm
  (out_txt, out_a_responseLog) := fun_81(txt, a_ty, a_name, a_responseLog);
  out_a_name := a_name;
end getQtResponseLogText;

protected function lm_83
  input Tpl.Text in_txt;
  input list<DAE.FuncArg> in_items;
  input Tpl.Text in_a_varDecl;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecl;
algorithm
  (out_txt, out_a_varDecl) :=
  match(in_txt, in_items, in_a_varDecl)
    local
      Tpl.Text txt;
      list<DAE.FuncArg> rest;
      Tpl.Text a_varDecl;
      DAE.Type i_arg_ty;
      String i_arg_name;

    case ( txt,
           {},
           a_varDecl )
      then (txt, a_varDecl);

    case ( txt,
           DAE.FUNCARG(name = i_arg_name, ty = i_arg_ty) :: rest,
           a_varDecl )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        (txt, _, a_varDecl) = getQtInArg(txt, Tpl.stringText(i_arg_name), i_arg_ty, a_varDecl);
        (txt, a_varDecl) = lm_83(txt, rest, a_varDecl);
      then (txt, a_varDecl);

    case ( txt,
           _ :: rest,
           a_varDecl )
      equation
        (txt, a_varDecl) = lm_83(txt, rest, a_varDecl);
      then (txt, a_varDecl);
  end match;
end lm_83;

protected function lm_84
  input Tpl.Text in_txt;
  input list<DAE.FuncArg> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<DAE.FuncArg> rest;
      DAE.Type i_arg_ty;
      String i_arg_name;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           DAE.FUNCARG(name = i_arg_name, ty = i_arg_ty) :: rest )
      equation
        (txt, _, _) = getQtCommandLogText(txt, Tpl.stringText(i_arg_name), i_arg_ty, Tpl.strTokText(Tpl.ST_STRING("commandLog")));
        txt = Tpl.nextIter(txt);
        txt = lm_84(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_84(txt, rest);
      then txt;
  end match;
end lm_84;

protected function lm_85
  input Tpl.Text in_txt;
  input list<DAE.Type> in_items;
  input Tpl.Text in_a_postCall;
  input Tpl.Text in_a_varDecl;
  input DAE.Type in_a_res;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_postCall;
  output Tpl.Text out_a_varDecl;
algorithm
  (out_txt, out_a_postCall, out_a_varDecl) :=
  match(in_txt, in_items, in_a_postCall, in_a_varDecl, in_a_res)
    local
      Tpl.Text txt;
      list<DAE.Type> rest;
      Tpl.Text a_postCall;
      Tpl.Text a_varDecl;
      DAE.Type a_res;
      Integer x_i1;
      DAE.Type i_t;
      Tpl.Text txt_1;
      Tpl.Text txt_0;

    case ( txt,
           {},
           a_postCall,
           a_varDecl,
           _ )
      then (txt, a_postCall, a_varDecl);

    case ( txt,
           i_t :: rest,
           a_postCall,
           a_varDecl,
           a_res )
      equation
        x_i1 = Tpl.getIteri_i0(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", &"));
        txt_0 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("result."));
        txt_0 = getQtTupleTypeOutputName(txt_0, a_res, x_i1);
        txt_1 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("out"));
        txt_1 = Tpl.writeStr(txt_1, intString(x_i1));
        (txt, txt_0, txt_1, a_varDecl, a_postCall) = getQtOutArg(txt, txt_0, txt_1, i_t, a_varDecl, a_postCall);
        txt = Tpl.nextIter(txt);
        (txt, a_postCall, a_varDecl) = lm_85(txt, rest, a_postCall, a_varDecl, a_res);
      then (txt, a_postCall, a_varDecl);
  end match;
end lm_85;

protected function fun_86
  input Tpl.Text in_txt;
  input DAE.Type in_a_res;
  input Tpl.Text in_a_postCall;
  input Tpl.Text in_a_outArg;
  input Tpl.Text in_a_responseLog;
  input String in_a_name;
  input Tpl.Text in_a_varDecl;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_postCall;
  output Tpl.Text out_a_outArg;
  output Tpl.Text out_a_responseLog;
  output Tpl.Text out_a_varDecl;
algorithm
  (out_txt, out_a_postCall, out_a_outArg, out_a_responseLog, out_a_varDecl) :=
  match(in_txt, in_a_res, in_a_postCall, in_a_outArg, in_a_responseLog, in_a_name, in_a_varDecl)
    local
      Tpl.Text txt;
      Tpl.Text a_postCall;
      Tpl.Text a_outArg;
      Tpl.Text a_responseLog;
      String a_name;
      Tpl.Text a_varDecl;
      DAE.Type i_res;
      list<DAE.Type> i_types2;
      DAE.Type i_type1;
      DAE.Type i_t;
      Tpl.Text txt_0;

    case ( txt,
           DAE.T_NORETCALL(),
           a_postCall,
           a_outArg,
           a_responseLog,
           _,
           a_varDecl )
      then (txt, a_postCall, a_outArg, a_responseLog, a_varDecl);

    case ( txt,
           (i_t as DAE.T_TUPLE(types = i_type1 :: i_types2)),
           a_postCall,
           a_outArg,
           a_responseLog,
           a_name,
           a_varDecl )
      equation
        a_varDecl = Tpl.writeStr(a_varDecl, a_name);
        a_varDecl = Tpl.writeTok(a_varDecl, Tpl.ST_STRING("_res result;"));
        a_varDecl = Tpl.writeTok(a_varDecl, Tpl.ST_NEW_LINE());
        (a_responseLog, _, _) = getQtResponseLogText(a_responseLog, Tpl.strTokText(Tpl.ST_STRING("result")), i_t, Tpl.strTokText(Tpl.ST_STRING("responseLog")));
        txt_0 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("result."));
        txt_0 = getQtTupleTypeOutputName(txt_0, i_t, 1);
        (a_outArg, txt_0, _, a_varDecl, a_postCall) = getQtOutArg(a_outArg, txt_0, Tpl.strTokText(Tpl.ST_STRING("out1")), i_type1, a_varDecl, a_postCall);
        a_outArg = Tpl.writeTok(a_outArg, Tpl.ST_STRING(" = "));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(2, NONE(), NONE(), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_postCall, a_varDecl) = lm_85(txt, i_types2, a_postCall, a_varDecl, i_t);
        txt = Tpl.popIter(txt);
      then (txt, a_postCall, a_outArg, a_responseLog, a_varDecl);

    case ( txt,
           i_res,
           a_postCall,
           a_outArg,
           a_responseLog,
           _,
           a_varDecl )
      equation
        a_varDecl = getQtType(a_varDecl, i_res);
        a_varDecl = Tpl.writeTok(a_varDecl, Tpl.ST_STRING(" result;"));
        a_varDecl = Tpl.writeTok(a_varDecl, Tpl.ST_NEW_LINE());
        (a_responseLog, _, _) = getQtResponseLogText(a_responseLog, Tpl.strTokText(Tpl.ST_STRING("result")), i_res, Tpl.strTokText(Tpl.ST_STRING("responseLog")));
        (a_outArg, _, _, a_varDecl, a_postCall) = getQtOutArg(a_outArg, Tpl.strTokText(Tpl.ST_STRING("result")), Tpl.strTokText(Tpl.ST_STRING("result")), i_res, a_varDecl, a_postCall);
        a_outArg = Tpl.writeTok(a_outArg, Tpl.ST_STRING(" = "));
      then (txt, a_postCall, a_outArg, a_responseLog, a_varDecl);
  end match;
end fun_86;

protected function fun_87
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_commandLog;
  input String in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_commandLog, in_a_name)
    local
      Tpl.Text txt;
      Tpl.Text a_commandLog;
      String a_name;

    case ( txt,
           false,
           _,
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("emit logCommand(\""));
        txt = CodegenUtil.replaceDotAndUnderscore(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("()\", &commandTime);"));
      then txt;

    case ( txt,
           _,
           a_commandLog,
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("QString commandLog;\n"));
        txt = Tpl.writeText(txt, a_commandLog);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("emit logCommand(\""));
        txt = CodegenUtil.replaceDotAndUnderscore(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(\"+commandLog+\")\", &commandTime);"));
      then txt;
  end match;
end fun_87;

protected function fun_88
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_name)
    local
      Tpl.Text txt;
      String a_name;

    case ( txt,
           false,
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("emit logResponse(\""));
        txt = CodegenUtil.replaceDotAndUnderscore(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("()\", responseLog, &commandTime);"));
      then txt;

    case ( txt,
           _,
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("emit logResponse(\""));
        txt = CodegenUtil.replaceDotAndUnderscore(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(\"+commandLog+\")\", responseLog, &commandTime);"));
      then txt;
  end match;
end fun_88;

protected function fun_89
  input Tpl.Text in_txt;
  input Tpl.Text in_a_outArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_outArg)
    local
      Tpl.Text txt;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}) )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("return result;"));
      then txt;
  end match;
end fun_89;

public function getQtInterfaceFunc
  input Tpl.Text txt;
  input String a_name;
  input list<DAE.FuncArg> a_args;
  input DAE.Type a_res;
  input String a_className;

  output Tpl.Text out_txt;
protected
  Boolean ret_12;
  Integer ret_11;
  Boolean ret_10;
  Integer ret_9;
  Tpl.Text l_outArgs;
  Tpl.Text l_outArg;
  Tpl.StringToken ret_6;
  Tpl.Text txt_5;
  Tpl.Text l_commandLog;
  Tpl.Text l_inArgs;
  Tpl.Text l_postCall;
  Tpl.Text l_responseLog;
  Tpl.Text l_varDecl;
algorithm
  l_varDecl := Tpl.emptyTxt;
  l_responseLog := Tpl.emptyTxt;
  l_postCall := Tpl.emptyTxt;
  (l_inArgs, l_varDecl) := lm_83(Tpl.emptyTxt, a_args, l_varDecl);
  l_commandLog := Tpl.emptyTxt;
  txt_5 := Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("commandLog.append(\",\");"));
  txt_5 := Tpl.writeTok(txt_5, Tpl.ST_NEW_LINE());
  ret_6 := Tpl.textStrTok(txt_5);
  l_commandLog := Tpl.pushIter(l_commandLog, Tpl.ITER_OPTIONS(0, NONE(), SOME(ret_6), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  l_commandLog := lm_84(l_commandLog, a_args);
  l_commandLog := Tpl.popIter(l_commandLog);
  l_outArg := Tpl.emptyTxt;
  (l_outArgs, l_postCall, l_outArg, l_responseLog, l_varDecl) := fun_86(Tpl.emptyTxt, a_res, l_postCall, l_outArg, l_responseLog, a_name, l_varDecl);
  out_txt := getQtInterfaceHeader(txt, a_name, a_className, a_args, a_res, a_className, false);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "{\n",
                                       "  QTime commandTime;\n",
                                       "  commandTime.start();\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  ret_9 := listLength(a_args);
  ret_10 := intGt(ret_9, 0);
  out_txt := fun_87(out_txt, ret_10, l_commandLog, a_name);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_NEW_LINE());
  out_txt := Tpl.writeText(out_txt, l_varDecl);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "try {\n",
                                       "  MMC_TRY_TOP_INTERNAL()\n",
                                       "\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeText(out_txt, l_outArg);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("omc_OpenModelicaScriptingAPI_"));
  out_txt := CodegenUtil.replaceDotAndUnderscore(out_txt, a_name);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("(threadData"));
  out_txt := Tpl.writeText(out_txt, l_inArgs);
  out_txt := Tpl.writeText(out_txt, l_outArgs);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE(");\n"));
  out_txt := Tpl.writeText(out_txt, l_postCall);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "MMC_CATCH_TOP()\n"
                                   }, true));
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("} catch(std::exception &exception) {\n"));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("emit throwException(QString(\""));
  out_txt := CodegenUtil.replaceDotAndUnderscore(out_txt, a_name);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE(" failed. %1\").arg(exception.what()));\n"));
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "}\n",
                                       "\n",
                                       "QString responseLog;\n"
                                   }, true));
  out_txt := Tpl.writeText(out_txt, l_responseLog);
  out_txt := Tpl.softNewLine(out_txt);
  ret_11 := listLength(a_args);
  ret_12 := intGt(ret_11, 0);
  out_txt := fun_88(out_txt, ret_12, a_name);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_NEW_LINE());
  out_txt := fun_89(out_txt, l_outArg);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("}"));
end getQtInterfaceFunc;

annotation(__OpenModelica_Interface="backend");
end GenerateAPIFunctionsTpl;