encapsulated package SimCodeDump
"
  file:        SimCodeDump.mo
  package:     SimCodeDump
  description: Generated by Susan.
"

public import Tpl;

public import SimCodeVar;
public import SimCode;
public import DAE;
public import Util;
public import Expression;
public import ExpressionDump;
public import CodegenUtil;
protected import ExpressionDumpTpl;

protected function lm_42
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Integer x_index0;
      DAE.ComponentRef i_v_name;
      String ret_1;
      Tpl.Text txt_0;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(name = i_v_name) :: rest )
      equation
        x_index0 = Tpl.getIteri_i0(txt);
        txt = Tpl.writeStr(txt, intString(x_index0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(": "));
        txt_0 = CodegenUtil.crefStrNoUnderscore(Tpl.emptyTxt, i_v_name);
        ret_1 = Util.escapeModelicaStringToXmlString(Tpl.textString(txt_0));
        txt = Tpl.writeStr(txt, ret_1);
        txt = Tpl.nextIter(txt);
        txt = lm_42(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_42(txt, rest);
      then txt;
  end match;
end lm_42;

public function dumpVarsShort
  input Tpl.Text txt;
  input list<SimCodeVar.SimVar> a_vars;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_varsString;
algorithm
  l_varsString := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  l_varsString := lm_42(l_varsString, a_vars);
  l_varsString := Tpl.popIter(l_varsString);
  out_txt := Tpl.writeText(txt, l_varsString);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_NEW_LINE());
end dumpVarsShort;

public function dumpAlias
  input Tpl.Text in_txt;
  input SimCodeVar.AliasVariable in_a_alias;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_alias)
    local
      Tpl.Text txt;
      DAE.ComponentRef i_varName;
      String ret_3;
      Tpl.Text txt_2;
      String ret_1;
      Tpl.Text txt_0;

    case ( txt,
           SimCodeVar.ALIAS(varName = i_varName) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<alias>"));
        txt_0 = CodegenUtil.crefStrNoUnderscore(Tpl.emptyTxt, i_varName);
        ret_1 = Util.escapeModelicaStringToXmlString(Tpl.textString(txt_0));
        txt = Tpl.writeStr(txt, ret_1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("</alias>"));
      then txt;

    case ( txt,
           SimCodeVar.NEGATEDALIAS(varName = i_varName) )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<alias negated=\"true\">"));
        txt_2 = CodegenUtil.crefStrNoUnderscore(Tpl.emptyTxt, i_varName);
        ret_3 = Util.escapeModelicaStringToXmlString(Tpl.textString(txt_2));
        txt = Tpl.writeStr(txt, ret_3);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("</alias>"));
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end dumpAlias;

public function printExpStrEscaped
  input Tpl.Text txt;
  input DAE.Exp a_exp;

  output Tpl.Text out_txt;
protected
  String ret_1;
  Tpl.Text txt_0;
algorithm
  txt_0 := ExpressionDumpTpl.dumpExp(Tpl.emptyTxt, a_exp, "\"");
  ret_1 := Util.escapeModelicaStringToXmlString(Tpl.textString(txt_0));
  out_txt := Tpl.writeStr(txt, ret_1);
end printExpStrEscaped;

annotation(__OpenModelica_Interface="backend");
end SimCodeDump;