#ifndef AdjacencyList__H
#define AdjacencyList__H
#include "meta/meta_modelica.h"
#include "util/modelica.h"
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>

#ifdef __cplusplus
extern "C" {
#endif

extern struct record_description AdjacencyList_ADJACENCY__LIST__desc;


DLLExport
modelica_metatype omc_AdjacencyList_edges(threadData_t *threadData, modelica_metatype _al);
#define boxptr_AdjacencyList_edges omc_AdjacencyList_edges
static const MMC_DEFSTRUCTLIT(boxvar_lit_AdjacencyList_edges,2,0) {(void*) boxptr_AdjacencyList_edges,0}};
#define boxvar_AdjacencyList_edges MMC_REFSTRUCTLIT(boxvar_lit_AdjacencyList_edges)


DLLExport
modelica_metatype omc_AdjacencyList_vertices(threadData_t *threadData, modelica_metatype _al);
#define boxptr_AdjacencyList_vertices omc_AdjacencyList_vertices
static const MMC_DEFSTRUCTLIT(boxvar_lit_AdjacencyList_vertices,2,0) {(void*) boxptr_AdjacencyList_vertices,0}};
#define boxvar_AdjacencyList_vertices MMC_REFSTRUCTLIT(boxvar_lit_AdjacencyList_vertices)


DLLExport
modelica_integer omc_AdjacencyList_edgeCount(threadData_t *threadData, modelica_metatype _al);
DLLExport
modelica_metatype boxptr_AdjacencyList_edgeCount(threadData_t *threadData, modelica_metatype _al);
static const MMC_DEFSTRUCTLIT(boxvar_lit_AdjacencyList_edgeCount,2,0) {(void*) boxptr_AdjacencyList_edgeCount,0}};
#define boxvar_AdjacencyList_edgeCount MMC_REFSTRUCTLIT(boxvar_lit_AdjacencyList_edgeCount)


DLLExport
modelica_integer omc_AdjacencyList_vertexCount(threadData_t *threadData, modelica_metatype _al);
DLLExport
modelica_metatype boxptr_AdjacencyList_vertexCount(threadData_t *threadData, modelica_metatype _al);
static const MMC_DEFSTRUCTLIT(boxvar_lit_AdjacencyList_vertexCount,2,0) {(void*) boxptr_AdjacencyList_vertexCount,0}};
#define boxvar_AdjacencyList_vertexCount MMC_REFSTRUCTLIT(boxvar_lit_AdjacencyList_vertexCount)


DLLExport
modelica_boolean omc_AdjacencyList_isEmpty(threadData_t *threadData, modelica_metatype _al);
DLLExport
modelica_metatype boxptr_AdjacencyList_isEmpty(threadData_t *threadData, modelica_metatype _al);
static const MMC_DEFSTRUCTLIT(boxvar_lit_AdjacencyList_isEmpty,2,0) {(void*) boxptr_AdjacencyList_isEmpty,0}};
#define boxvar_AdjacencyList_isEmpty MMC_REFSTRUCTLIT(boxvar_lit_AdjacencyList_isEmpty)


DLLExport
void omc_AdjacencyList_addEdge(threadData_t *threadData, modelica_metatype _al, modelica_integer _d1, modelica_integer _d2, modelica_metatype _e);
DLLExport
void boxptr_AdjacencyList_addEdge(threadData_t *threadData, modelica_metatype _al, modelica_metatype _d1, modelica_metatype _d2, modelica_metatype _e);
static const MMC_DEFSTRUCTLIT(boxvar_lit_AdjacencyList_addEdge,2,0) {(void*) boxptr_AdjacencyList_addEdge,0}};
#define boxvar_AdjacencyList_addEdge MMC_REFSTRUCTLIT(boxvar_lit_AdjacencyList_addEdge)


DLLExport
modelica_metatype omc_AdjacencyList_getVertex(threadData_t *threadData, modelica_metatype _al, modelica_integer _d);
DLLExport
modelica_metatype boxptr_AdjacencyList_getVertex(threadData_t *threadData, modelica_metatype _al, modelica_metatype _d);
static const MMC_DEFSTRUCTLIT(boxvar_lit_AdjacencyList_getVertex,2,0) {(void*) boxptr_AdjacencyList_getVertex,0}};
#define boxvar_AdjacencyList_getVertex MMC_REFSTRUCTLIT(boxvar_lit_AdjacencyList_getVertex)


DLLExport
modelica_metatype omc_AdjacencyList_findVertex(threadData_t *threadData, modelica_metatype _al, modelica_fnptr _predFn);
#define boxptr_AdjacencyList_findVertex omc_AdjacencyList_findVertex
static const MMC_DEFSTRUCTLIT(boxvar_lit_AdjacencyList_findVertex,2,0) {(void*) boxptr_AdjacencyList_findVertex,0}};
#define boxvar_AdjacencyList_findVertex MMC_REFSTRUCTLIT(boxvar_lit_AdjacencyList_findVertex)


DLLExport
modelica_integer omc_AdjacencyList_addVertex(threadData_t *threadData, modelica_metatype _al, modelica_metatype _v);
DLLExport
modelica_metatype boxptr_AdjacencyList_addVertex(threadData_t *threadData, modelica_metatype _al, modelica_metatype _v);
static const MMC_DEFSTRUCTLIT(boxvar_lit_AdjacencyList_addVertex,2,0) {(void*) boxptr_AdjacencyList_addVertex,0}};
#define boxvar_AdjacencyList_addVertex MMC_REFSTRUCTLIT(boxvar_lit_AdjacencyList_addVertex)


DLLExport
modelica_metatype omc_AdjacencyList_new(threadData_t *threadData, modelica_fnptr _vertexEq, modelica_fnptr _edgeEq);
#define boxptr_AdjacencyList_new omc_AdjacencyList_new
static const MMC_DEFSTRUCTLIT(boxvar_lit_AdjacencyList_new,2,0) {(void*) boxptr_AdjacencyList_new,0}};
#define boxvar_AdjacencyList_new MMC_REFSTRUCTLIT(boxvar_lit_AdjacencyList_new)

#ifdef __cplusplus
}
#endif
#endif
