#ifndef ConnectionGraph__H
#define ConnectionGraph__H
#include "meta/meta_modelica.h"
#include "util/modelica.h"
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>

#ifdef __cplusplus
extern "C" {
#endif

extern struct record_description ConnectionGraph_ConnectionGraph_GRAPH__desc;

extern struct record_description DAE_DAElist_DAE__desc;

extern struct record_description DAE_Exp_ARRAY__desc;

extern struct record_description DAE_Exp_BCONST__desc;

extern struct record_description DAE_Exp_ICONST__desc;

extern struct record_description DAE_Type_T__INTEGER__desc;

extern struct record_description Flags_DebugFlag_DEBUG__FLAG__desc;

extern struct record_description Gettext_TranslatableContent_gettext__desc;

extern struct record_description IOStream_IOStreamType_LIST__desc;


DLLExport
modelica_metatype omc_ConnectionGraph_addBrokenEqualityConstraintEquations(threadData_t *threadData, modelica_metatype _inDAE, modelica_metatype _inBroken);
#define boxptr_ConnectionGraph_addBrokenEqualityConstraintEquations omc_ConnectionGraph_addBrokenEqualityConstraintEquations
static const MMC_DEFSTRUCTLIT(boxvar_lit_ConnectionGraph_addBrokenEqualityConstraintEquations,2,0) {(void*) boxptr_ConnectionGraph_addBrokenEqualityConstraintEquations,0}};
#define boxvar_ConnectionGraph_addBrokenEqualityConstraintEquations MMC_REFSTRUCTLIT(boxvar_lit_ConnectionGraph_addBrokenEqualityConstraintEquations)


#define boxptr_ConnectionGraph_removeFromConnects omc_ConnectionGraph_removeFromConnects


#define boxptr_ConnectionGraph_filterFromSet omc_ConnectionGraph_filterFromSet


#define boxptr_ConnectionGraph_splitSetByAllowed omc_ConnectionGraph_splitSetByAllowed


DLLExport
modelica_metatype omc_ConnectionGraph_removeBrokenConnects(threadData_t *threadData, modelica_metatype _inConnects, modelica_metatype _inConnected, modelica_metatype _inBroken);
#define boxptr_ConnectionGraph_removeBrokenConnects omc_ConnectionGraph_removeBrokenConnects
static const MMC_DEFSTRUCTLIT(boxvar_lit_ConnectionGraph_removeBrokenConnects,2,0) {(void*) boxptr_ConnectionGraph_removeBrokenConnects,0}};
#define boxvar_ConnectionGraph_removeBrokenConnects MMC_REFSTRUCTLIT(boxvar_lit_ConnectionGraph_removeBrokenConnects)


#define boxptr_ConnectionGraph_showGraphViz omc_ConnectionGraph_showGraphViz


#define boxptr_ConnectionGraph_generateGraphViz omc_ConnectionGraph_generateGraphViz


#define boxptr_ConnectionGraph_graphVizPotentialRoot omc_ConnectionGraph_graphVizPotentialRoot


#define boxptr_ConnectionGraph_graphVizDefiniteRoot omc_ConnectionGraph_graphVizDefiniteRoot


#define boxptr_ConnectionGraph_graphVizDaeEdge omc_ConnectionGraph_graphVizDaeEdge


#define boxptr_ConnectionGraph_graphVizEdge omc_ConnectionGraph_graphVizEdge


DLLExport
modelica_metatype omc_ConnectionGraph_merge(threadData_t *threadData, modelica_metatype _inGraph1, modelica_metatype _inGraph2);
#define boxptr_ConnectionGraph_merge omc_ConnectionGraph_merge
static const MMC_DEFSTRUCTLIT(boxvar_lit_ConnectionGraph_merge,2,0) {(void*) boxptr_ConnectionGraph_merge,0}};
#define boxvar_ConnectionGraph_merge MMC_REFSTRUCTLIT(boxvar_lit_ConnectionGraph_merge)


#define boxptr_ConnectionGraph_getConnections omc_ConnectionGraph_getConnections


#define boxptr_ConnectionGraph_getBranches omc_ConnectionGraph_getBranches


#define boxptr_ConnectionGraph_getPotentialRoots omc_ConnectionGraph_getPotentialRoots


#define boxptr_ConnectionGraph_getUniqueRoots omc_ConnectionGraph_getUniqueRoots


#define boxptr_ConnectionGraph_getDefiniteRoots omc_ConnectionGraph_getDefiniteRoots


#define boxptr_ConnectionGraph_printConnectionGraph omc_ConnectionGraph_printConnectionGraph


#define boxptr_ConnectionGraph_printDaeEdges omc_ConnectionGraph_printDaeEdges


#define boxptr_ConnectionGraph_printEdges omc_ConnectionGraph_printEdges


#define boxptr_ConnectionGraph_printConnectionStr omc_ConnectionGraph_printConnectionStr


#define boxptr_ConnectionGraph_getEdge1 omc_ConnectionGraph_getEdge1


#define boxptr_ConnectionGraph_getEdge omc_ConnectionGraph_getEdge


#define boxptr_ConnectionGraph_evalConnectionsOperatorsHelper omc_ConnectionGraph_evalConnectionsOperatorsHelper


#define boxptr_ConnectionGraph_evalConnectionsOperators omc_ConnectionGraph_evalConnectionsOperators


#define boxptr_ConnectionGraph_addConnectionRooted omc_ConnectionGraph_addConnectionRooted


#define boxptr_ConnectionGraph_addConnectionsRooted omc_ConnectionGraph_addConnectionsRooted


#define boxptr_ConnectionGraph_addBranches omc_ConnectionGraph_addBranches


#define boxptr_ConnectionGraph_printPotentialRootTuple omc_ConnectionGraph_printPotentialRootTuple


#define boxptr_ConnectionGraph_makeTuple omc_ConnectionGraph_makeTuple


#define boxptr_ConnectionGraph_printTupleStr omc_ConnectionGraph_printTupleStr


#define boxptr_ConnectionGraph_orderConnectsGuidedByUser omc_ConnectionGraph_orderConnectsGuidedByUser


#define boxptr_ConnectionGraph_findResultGraph omc_ConnectionGraph_findResultGraph


#define boxptr_ConnectionGraph_addConnections omc_ConnectionGraph_addConnections


#define boxptr_ConnectionGraph_addPotentialRootsToTable omc_ConnectionGraph_addPotentialRootsToTable


#define boxptr_ConnectionGraph_addBranchesToTable omc_ConnectionGraph_addBranchesToTable


#define boxptr_ConnectionGraph_resultGraphWithRoots omc_ConnectionGraph_resultGraphWithRoots


#define boxptr_ConnectionGraph_addRootsToTable omc_ConnectionGraph_addRootsToTable


#define boxptr_ConnectionGraph_connectComponents omc_ConnectionGraph_connectComponents


#define boxptr_ConnectionGraph_connectBranchComponents omc_ConnectionGraph_connectBranchComponents


#define boxptr_ConnectionGraph_canonical omc_ConnectionGraph_canonical


DLLExport
modelica_metatype omc_ConnectionGraph_addConnection(threadData_t *threadData, modelica_metatype _inGraph, modelica_metatype _inRef1, modelica_metatype _inRef2, modelica_metatype _inDae);
#define boxptr_ConnectionGraph_addConnection omc_ConnectionGraph_addConnection
static const MMC_DEFSTRUCTLIT(boxvar_lit_ConnectionGraph_addConnection,2,0) {(void*) boxptr_ConnectionGraph_addConnection,0}};
#define boxvar_ConnectionGraph_addConnection MMC_REFSTRUCTLIT(boxvar_lit_ConnectionGraph_addConnection)


DLLExport
modelica_metatype omc_ConnectionGraph_addBranch(threadData_t *threadData, modelica_metatype _inGraph, modelica_metatype _inRef1, modelica_metatype _inRef2);
#define boxptr_ConnectionGraph_addBranch omc_ConnectionGraph_addBranch
static const MMC_DEFSTRUCTLIT(boxvar_lit_ConnectionGraph_addBranch,2,0) {(void*) boxptr_ConnectionGraph_addBranch,0}};
#define boxvar_ConnectionGraph_addBranch MMC_REFSTRUCTLIT(boxvar_lit_ConnectionGraph_addBranch)


DLLExport
modelica_metatype omc_ConnectionGraph_addUniqueRoots(threadData_t *threadData, modelica_metatype _inGraph, modelica_metatype _inRoots, modelica_metatype _inMessage);
#define boxptr_ConnectionGraph_addUniqueRoots omc_ConnectionGraph_addUniqueRoots
static const MMC_DEFSTRUCTLIT(boxvar_lit_ConnectionGraph_addUniqueRoots,2,0) {(void*) boxptr_ConnectionGraph_addUniqueRoots,0}};
#define boxvar_ConnectionGraph_addUniqueRoots MMC_REFSTRUCTLIT(boxvar_lit_ConnectionGraph_addUniqueRoots)


DLLExport
modelica_metatype omc_ConnectionGraph_addPotentialRoot(threadData_t *threadData, modelica_metatype _inGraph, modelica_metatype _inRoot, modelica_real _inPriority);
DLLExport
modelica_metatype boxptr_ConnectionGraph_addPotentialRoot(threadData_t *threadData, modelica_metatype _inGraph, modelica_metatype _inRoot, modelica_metatype _inPriority);
static const MMC_DEFSTRUCTLIT(boxvar_lit_ConnectionGraph_addPotentialRoot,2,0) {(void*) boxptr_ConnectionGraph_addPotentialRoot,0}};
#define boxvar_ConnectionGraph_addPotentialRoot MMC_REFSTRUCTLIT(boxvar_lit_ConnectionGraph_addPotentialRoot)


DLLExport
modelica_metatype omc_ConnectionGraph_addDefiniteRoot(threadData_t *threadData, modelica_metatype _inGraph, modelica_metatype _inRoot);
#define boxptr_ConnectionGraph_addDefiniteRoot omc_ConnectionGraph_addDefiniteRoot
static const MMC_DEFSTRUCTLIT(boxvar_lit_ConnectionGraph_addDefiniteRoot,2,0) {(void*) boxptr_ConnectionGraph_addDefiniteRoot,0}};
#define boxvar_ConnectionGraph_addDefiniteRoot MMC_REFSTRUCTLIT(boxvar_lit_ConnectionGraph_addDefiniteRoot)


DLLExport
modelica_metatype omc_ConnectionGraph_handleOverconstrainedConnections(threadData_t *threadData, modelica_metatype _inGraph, modelica_string _modelNameQualified, modelica_metatype _inDAE, modelica_metatype *out_outConnected, modelica_metatype *out_outBroken);
#define boxptr_ConnectionGraph_handleOverconstrainedConnections omc_ConnectionGraph_handleOverconstrainedConnections
static const MMC_DEFSTRUCTLIT(boxvar_lit_ConnectionGraph_handleOverconstrainedConnections,2,0) {(void*) boxptr_ConnectionGraph_handleOverconstrainedConnections,0}};
#define boxvar_ConnectionGraph_handleOverconstrainedConnections MMC_REFSTRUCTLIT(boxvar_lit_ConnectionGraph_handleOverconstrainedConnections)

#ifdef __cplusplus
}
#endif
#endif
