#ifndef JSON__H
#define JSON__H
#include "meta/meta_modelica.h"
#include "util/modelica.h"
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>

#ifdef __cplusplus
extern "C" {
#endif

extern struct record_description ErrorTypes_Message_MESSAGE__desc;

extern struct record_description ErrorTypes_MessageType_SYNTAX__desc;

extern struct record_description ErrorTypes_MessageType_TRANSLATION__desc;

extern struct record_description ErrorTypes_Severity_ERROR__desc;

extern struct record_description Gettext_TranslatableContent_gettext__desc;

extern struct record_description Gettext_TranslatableContent_notrans__desc;

extern struct record_description JSON_ARRAY__desc;

extern struct record_description JSON_AvlTree_Tree_EMPTY__desc;

extern struct record_description JSON_AvlTree_Tree_LEAF__desc;

extern struct record_description JSON_AvlTree_Tree_NODE__desc;

extern struct record_description JSON_FALSE__desc;

extern struct record_description JSON_INTEGER__desc;

extern struct record_description JSON_NULL__desc;

extern struct record_description JSON_NUMBER__desc;

extern struct record_description JSON_OBJECT__desc;

extern struct record_description JSON_STRING__desc;

extern struct record_description JSON_TRUE__desc;


#define boxptr_JSON_errorExpected omc_JSON_errorExpected


#define boxptr_JSON_check__empty omc_JSON_check__empty


#define boxptr_JSON_not__eof omc_JSON_not__eof


#define boxptr_JSON_reportErrors omc_JSON_reportErrors


DLLExport
modelica_metatype omc_JSON_parse__object(threadData_t *threadData, modelica_metatype _inTokens, modelica_metatype *out_tokens);
#define boxptr_JSON_parse__object omc_JSON_parse__object
static const MMC_DEFSTRUCTLIT(boxvar_lit_JSON_parse__object,2,0) {(void*) boxptr_JSON_parse__object,0}};
#define boxvar_JSON_parse__object MMC_REFSTRUCTLIT(boxvar_lit_JSON_parse__object)


DLLExport
modelica_metatype omc_JSON_parse__array(threadData_t *threadData, modelica_metatype _inTokens, modelica_metatype *out_tokens);
#define boxptr_JSON_parse__array omc_JSON_parse__array
static const MMC_DEFSTRUCTLIT(boxvar_lit_JSON_parse__array,2,0) {(void*) boxptr_JSON_parse__array,0}};
#define boxvar_JSON_parse__array MMC_REFSTRUCTLIT(boxvar_lit_JSON_parse__array)


DLLExport
modelica_metatype omc_JSON_parse__number(threadData_t *threadData, modelica_metatype _inTokens, modelica_metatype *out_tokens);
#define boxptr_JSON_parse__number omc_JSON_parse__number
static const MMC_DEFSTRUCTLIT(boxvar_lit_JSON_parse__number,2,0) {(void*) boxptr_JSON_parse__number,0}};
#define boxvar_JSON_parse__number MMC_REFSTRUCTLIT(boxvar_lit_JSON_parse__number)


DLLExport
modelica_metatype omc_JSON_parse__integer(threadData_t *threadData, modelica_metatype _inTokens, modelica_metatype *out_tokens);
#define boxptr_JSON_parse__integer omc_JSON_parse__integer
static const MMC_DEFSTRUCTLIT(boxvar_lit_JSON_parse__integer,2,0) {(void*) boxptr_JSON_parse__integer,0}};
#define boxvar_JSON_parse__integer MMC_REFSTRUCTLIT(boxvar_lit_JSON_parse__integer)


DLLExport
modelica_metatype omc_JSON_parse__string(threadData_t *threadData, modelica_metatype _inTokens, modelica_metatype *out_tokens);
#define boxptr_JSON_parse__string omc_JSON_parse__string
static const MMC_DEFSTRUCTLIT(boxvar_lit_JSON_parse__string,2,0) {(void*) boxptr_JSON_parse__string,0}};
#define boxvar_JSON_parse__string MMC_REFSTRUCTLIT(boxvar_lit_JSON_parse__string)


DLLExport
modelica_metatype omc_JSON_parse__value(threadData_t *threadData, modelica_metatype _inTokens, modelica_metatype *out_tokens);
#define boxptr_JSON_parse__value omc_JSON_parse__value
static const MMC_DEFSTRUCTLIT(boxvar_lit_JSON_parse__value,2,0) {(void*) boxptr_JSON_parse__value,0}};
#define boxvar_JSON_parse__value MMC_REFSTRUCTLIT(boxvar_lit_JSON_parse__value)


DLLExport
modelica_metatype omc_JSON_parse__value__check__empty(threadData_t *threadData, modelica_metatype _inTokens);
#define boxptr_JSON_parse__value__check__empty omc_JSON_parse__value__check__empty
static const MMC_DEFSTRUCTLIT(boxvar_lit_JSON_parse__value__check__empty,2,0) {(void*) boxptr_JSON_parse__value__check__empty,0}};
#define boxvar_JSON_parse__value__check__empty MMC_REFSTRUCTLIT(boxvar_lit_JSON_parse__value__check__empty)


DLLExport
modelica_metatype omc_JSON_parse(threadData_t *threadData, modelica_string _content, modelica_string _fileName);
#define boxptr_JSON_parse omc_JSON_parse
static const MMC_DEFSTRUCTLIT(boxvar_lit_JSON_parse,2,0) {(void*) boxptr_JSON_parse,0}};
#define boxvar_JSON_parse MMC_REFSTRUCTLIT(boxvar_lit_JSON_parse)


DLLExport
modelica_string omc_JSON_getString(threadData_t *threadData, modelica_metatype _obj);
#define boxptr_JSON_getString omc_JSON_getString
static const MMC_DEFSTRUCTLIT(boxvar_lit_JSON_getString,2,0) {(void*) boxptr_JSON_getString,0}};
#define boxvar_JSON_getString MMC_REFSTRUCTLIT(boxvar_lit_JSON_getString)


DLLExport
modelica_metatype omc_JSON_getOrDefault(threadData_t *threadData, modelica_metatype _obj, modelica_string _str, modelica_metatype _default);
#define boxptr_JSON_getOrDefault omc_JSON_getOrDefault
static const MMC_DEFSTRUCTLIT(boxvar_lit_JSON_getOrDefault,2,0) {(void*) boxptr_JSON_getOrDefault,0}};
#define boxvar_JSON_getOrDefault MMC_REFSTRUCTLIT(boxvar_lit_JSON_getOrDefault)


DLLExport
modelica_metatype omc_JSON_get(threadData_t *threadData, modelica_metatype _obj, modelica_string _str);
#define boxptr_JSON_get omc_JSON_get
static const MMC_DEFSTRUCTLIT(boxvar_lit_JSON_get,2,0) {(void*) boxptr_JSON_get,0}};
#define boxvar_JSON_get MMC_REFSTRUCTLIT(boxvar_lit_JSON_get)


DLLExport
modelica_boolean omc_JSON_hasKey(threadData_t *threadData, modelica_metatype _obj, modelica_string _str);
DLLExport
modelica_metatype boxptr_JSON_hasKey(threadData_t *threadData, modelica_metatype _obj, modelica_metatype _str);
static const MMC_DEFSTRUCTLIT(boxvar_lit_JSON_hasKey,2,0) {(void*) boxptr_JSON_hasKey,0}};
#define boxvar_JSON_hasKey MMC_REFSTRUCTLIT(boxvar_lit_JSON_hasKey)


DLLExport
modelica_metatype omc_JSON_parseFile(threadData_t *threadData, modelica_string _fileName);
#define boxptr_JSON_parseFile omc_JSON_parseFile
static const MMC_DEFSTRUCTLIT(boxvar_lit_JSON_parseFile,2,0) {(void*) boxptr_JSON_parseFile,0}};
#define boxvar_JSON_parseFile MMC_REFSTRUCTLIT(boxvar_lit_JSON_parseFile)


DLLExport
modelica_string omc_JSON_toString(threadData_t *threadData, modelica_metatype _value);
#define boxptr_JSON_toString omc_JSON_toString
static const MMC_DEFSTRUCTLIT(boxvar_lit_JSON_toString,2,0) {(void*) boxptr_JSON_toString,0}};
#define boxvar_JSON_toString MMC_REFSTRUCTLIT(boxvar_lit_JSON_toString)


DLLExport
modelica_metatype omc_JSON_emptyObject(threadData_t *threadData);
#define boxptr_JSON_emptyObject omc_JSON_emptyObject
static const MMC_DEFSTRUCTLIT(boxvar_lit_JSON_emptyObject,2,0) {(void*) boxptr_JSON_emptyObject,0}};
#define boxvar_JSON_emptyObject MMC_REFSTRUCTLIT(boxvar_lit_JSON_emptyObject)


DLLExport
modelica_metatype omc_JSON_AvlTree_add(threadData_t *threadData, modelica_metatype _inTree, modelica_string _inKey, modelica_metatype _inValue, modelica_fnptr _conflictFunc);
#define boxptr_JSON_AvlTree_add omc_JSON_AvlTree_add
static const MMC_DEFSTRUCTLIT(boxvar_lit_JSON_AvlTree_add,2,0) {(void*) boxptr_JSON_AvlTree_add,0}};
#define boxvar_JSON_AvlTree_add MMC_REFSTRUCTLIT(boxvar_lit_JSON_AvlTree_add)


DLLExport
modelica_metatype omc_JSON_AvlTree_addConflictDefault(threadData_t *threadData, modelica_metatype _newValue, modelica_metatype _oldValue, modelica_string _key);
#define boxptr_JSON_AvlTree_addConflictDefault omc_JSON_AvlTree_addConflictDefault
static const MMC_DEFSTRUCTLIT(boxvar_lit_JSON_AvlTree_addConflictDefault,2,0) {(void*) boxptr_JSON_AvlTree_addConflictDefault,0}};
#define boxvar_JSON_AvlTree_addConflictDefault MMC_REFSTRUCTLIT(boxvar_lit_JSON_AvlTree_addConflictDefault)


DLLExport
modelica_metatype omc_JSON_AvlTree_addConflictFail(threadData_t *threadData, modelica_metatype _newValue, modelica_metatype _oldValue, modelica_string _key);
#define boxptr_JSON_AvlTree_addConflictFail omc_JSON_AvlTree_addConflictFail
static const MMC_DEFSTRUCTLIT(boxvar_lit_JSON_AvlTree_addConflictFail,2,0) {(void*) boxptr_JSON_AvlTree_addConflictFail,0}};
#define boxvar_JSON_AvlTree_addConflictFail MMC_REFSTRUCTLIT(boxvar_lit_JSON_AvlTree_addConflictFail)


DLLExport
modelica_metatype omc_JSON_AvlTree_addConflictKeep(threadData_t *threadData, modelica_metatype _newValue, modelica_metatype _oldValue, modelica_string _key);
#define boxptr_JSON_AvlTree_addConflictKeep omc_JSON_AvlTree_addConflictKeep
static const MMC_DEFSTRUCTLIT(boxvar_lit_JSON_AvlTree_addConflictKeep,2,0) {(void*) boxptr_JSON_AvlTree_addConflictKeep,0}};
#define boxvar_JSON_AvlTree_addConflictKeep MMC_REFSTRUCTLIT(boxvar_lit_JSON_AvlTree_addConflictKeep)


DLLExport
modelica_metatype omc_JSON_AvlTree_addConflictReplace(threadData_t *threadData, modelica_metatype _newValue, modelica_metatype _oldValue, modelica_string _key);
#define boxptr_JSON_AvlTree_addConflictReplace omc_JSON_AvlTree_addConflictReplace
static const MMC_DEFSTRUCTLIT(boxvar_lit_JSON_AvlTree_addConflictReplace,2,0) {(void*) boxptr_JSON_AvlTree_addConflictReplace,0}};
#define boxvar_JSON_AvlTree_addConflictReplace MMC_REFSTRUCTLIT(boxvar_lit_JSON_AvlTree_addConflictReplace)


DLLExport
modelica_metatype omc_JSON_AvlTree_addList(threadData_t *threadData, modelica_metatype __omcQ_24in_5Ftree, modelica_metatype _inValues, modelica_fnptr _conflictFunc);
#define boxptr_JSON_AvlTree_addList omc_JSON_AvlTree_addList
static const MMC_DEFSTRUCTLIT(boxvar_lit_JSON_AvlTree_addList,2,0) {(void*) boxptr_JSON_AvlTree_addList,0}};
#define boxvar_JSON_AvlTree_addList MMC_REFSTRUCTLIT(boxvar_lit_JSON_AvlTree_addList)


#define boxptr_JSON_AvlTree_balance omc_JSON_AvlTree_balance


DLLExport
modelica_metatype omc_JSON_AvlTree_fold(threadData_t *threadData, modelica_metatype _inTree, modelica_fnptr _inFunc, modelica_metatype _inStartValue);
#define boxptr_JSON_AvlTree_fold omc_JSON_AvlTree_fold
static const MMC_DEFSTRUCTLIT(boxvar_lit_JSON_AvlTree_fold,2,0) {(void*) boxptr_JSON_AvlTree_fold,0}};
#define boxvar_JSON_AvlTree_fold MMC_REFSTRUCTLIT(boxvar_lit_JSON_AvlTree_fold)


DLLExport
modelica_metatype omc_JSON_AvlTree_foldCond(threadData_t *threadData, modelica_metatype _tree, modelica_fnptr _foldFunc, modelica_metatype __omcQ_24in_5Fvalue);
#define boxptr_JSON_AvlTree_foldCond omc_JSON_AvlTree_foldCond
static const MMC_DEFSTRUCTLIT(boxvar_lit_JSON_AvlTree_foldCond,2,0) {(void*) boxptr_JSON_AvlTree_foldCond,0}};
#define boxvar_JSON_AvlTree_foldCond MMC_REFSTRUCTLIT(boxvar_lit_JSON_AvlTree_foldCond)


DLLExport
modelica_metatype omc_JSON_AvlTree_fold__2(threadData_t *threadData, modelica_metatype _tree, modelica_fnptr _foldFunc, modelica_metatype __omcQ_24in_5FfoldArg1, modelica_metatype __omcQ_24in_5FfoldArg2, modelica_metatype *out_foldArg2);
#define boxptr_JSON_AvlTree_fold__2 omc_JSON_AvlTree_fold__2
static const MMC_DEFSTRUCTLIT(boxvar_lit_JSON_AvlTree_fold__2,2,0) {(void*) boxptr_JSON_AvlTree_fold__2,0}};
#define boxvar_JSON_AvlTree_fold__2 MMC_REFSTRUCTLIT(boxvar_lit_JSON_AvlTree_fold__2)


DLLExport
void omc_JSON_AvlTree_forEach(threadData_t *threadData, modelica_metatype _tree, modelica_fnptr _func);
#define boxptr_JSON_AvlTree_forEach omc_JSON_AvlTree_forEach
static const MMC_DEFSTRUCTLIT(boxvar_lit_JSON_AvlTree_forEach,2,0) {(void*) boxptr_JSON_AvlTree_forEach,0}};
#define boxvar_JSON_AvlTree_forEach MMC_REFSTRUCTLIT(boxvar_lit_JSON_AvlTree_forEach)


DLLExport
modelica_metatype omc_JSON_AvlTree_fromList(threadData_t *threadData, modelica_metatype _inValues, modelica_fnptr _conflictFunc);
#define boxptr_JSON_AvlTree_fromList omc_JSON_AvlTree_fromList
static const MMC_DEFSTRUCTLIT(boxvar_lit_JSON_AvlTree_fromList,2,0) {(void*) boxptr_JSON_AvlTree_fromList,0}};
#define boxvar_JSON_AvlTree_fromList MMC_REFSTRUCTLIT(boxvar_lit_JSON_AvlTree_fromList)


DLLExport
modelica_metatype omc_JSON_AvlTree_get(threadData_t *threadData, modelica_metatype _tree, modelica_string _key);
#define boxptr_JSON_AvlTree_get omc_JSON_AvlTree_get
static const MMC_DEFSTRUCTLIT(boxvar_lit_JSON_AvlTree_get,2,0) {(void*) boxptr_JSON_AvlTree_get,0}};
#define boxvar_JSON_AvlTree_get MMC_REFSTRUCTLIT(boxvar_lit_JSON_AvlTree_get)


DLLExport
modelica_metatype omc_JSON_AvlTree_getOpt(threadData_t *threadData, modelica_metatype _tree, modelica_string _key);
#define boxptr_JSON_AvlTree_getOpt omc_JSON_AvlTree_getOpt
static const MMC_DEFSTRUCTLIT(boxvar_lit_JSON_AvlTree_getOpt,2,0) {(void*) boxptr_JSON_AvlTree_getOpt,0}};
#define boxvar_JSON_AvlTree_getOpt MMC_REFSTRUCTLIT(boxvar_lit_JSON_AvlTree_getOpt)


DLLExport
modelica_boolean omc_JSON_AvlTree_hasKey(threadData_t *threadData, modelica_metatype _inTree, modelica_string _inKey);
DLLExport
modelica_metatype boxptr_JSON_AvlTree_hasKey(threadData_t *threadData, modelica_metatype _inTree, modelica_metatype _inKey);
static const MMC_DEFSTRUCTLIT(boxvar_lit_JSON_AvlTree_hasKey,2,0) {(void*) boxptr_JSON_AvlTree_hasKey,0}};
#define boxvar_JSON_AvlTree_hasKey MMC_REFSTRUCTLIT(boxvar_lit_JSON_AvlTree_hasKey)


DLLExport
void omc_JSON_AvlTree_intersection(threadData_t *threadData);
#define boxptr_JSON_AvlTree_intersection omc_JSON_AvlTree_intersection
static const MMC_DEFSTRUCTLIT(boxvar_lit_JSON_AvlTree_intersection,2,0) {(void*) boxptr_JSON_AvlTree_intersection,0}};
#define boxvar_JSON_AvlTree_intersection MMC_REFSTRUCTLIT(boxvar_lit_JSON_AvlTree_intersection)


DLLExport
modelica_boolean omc_JSON_AvlTree_isEmpty(threadData_t *threadData, modelica_metatype _tree);
DLLExport
modelica_metatype boxptr_JSON_AvlTree_isEmpty(threadData_t *threadData, modelica_metatype _tree);
static const MMC_DEFSTRUCTLIT(boxvar_lit_JSON_AvlTree_isEmpty,2,0) {(void*) boxptr_JSON_AvlTree_isEmpty,0}};
#define boxvar_JSON_AvlTree_isEmpty MMC_REFSTRUCTLIT(boxvar_lit_JSON_AvlTree_isEmpty)


DLLExport
modelica_metatype omc_JSON_AvlTree_join(threadData_t *threadData, modelica_metatype __omcQ_24in_5Ftree, modelica_metatype _treeToJoin, modelica_fnptr _conflictFunc);
#define boxptr_JSON_AvlTree_join omc_JSON_AvlTree_join
static const MMC_DEFSTRUCTLIT(boxvar_lit_JSON_AvlTree_join,2,0) {(void*) boxptr_JSON_AvlTree_join,0}};
#define boxvar_JSON_AvlTree_join MMC_REFSTRUCTLIT(boxvar_lit_JSON_AvlTree_join)


DLLExport
modelica_integer omc_JSON_AvlTree_keyCompare(threadData_t *threadData, modelica_string _inKey1, modelica_string _inKey2);
DLLExport
modelica_metatype boxptr_JSON_AvlTree_keyCompare(threadData_t *threadData, modelica_metatype _inKey1, modelica_metatype _inKey2);
static const MMC_DEFSTRUCTLIT(boxvar_lit_JSON_AvlTree_keyCompare,2,0) {(void*) boxptr_JSON_AvlTree_keyCompare,0}};
#define boxvar_JSON_AvlTree_keyCompare MMC_REFSTRUCTLIT(boxvar_lit_JSON_AvlTree_keyCompare)


DLLExport
modelica_string omc_JSON_AvlTree_keyStr(threadData_t *threadData, modelica_string _inKey);
#define boxptr_JSON_AvlTree_keyStr omc_JSON_AvlTree_keyStr
static const MMC_DEFSTRUCTLIT(boxvar_lit_JSON_AvlTree_keyStr,2,0) {(void*) boxptr_JSON_AvlTree_keyStr,0}};
#define boxvar_JSON_AvlTree_keyStr MMC_REFSTRUCTLIT(boxvar_lit_JSON_AvlTree_keyStr)


DLLExport
modelica_metatype omc_JSON_AvlTree_listKeys(threadData_t *threadData, modelica_metatype _inTree, modelica_metatype __omcQ_24in_5Flst);
#define boxptr_JSON_AvlTree_listKeys omc_JSON_AvlTree_listKeys
static const MMC_DEFSTRUCTLIT(boxvar_lit_JSON_AvlTree_listKeys,2,0) {(void*) boxptr_JSON_AvlTree_listKeys,0}};
#define boxvar_JSON_AvlTree_listKeys MMC_REFSTRUCTLIT(boxvar_lit_JSON_AvlTree_listKeys)


DLLExport
modelica_metatype omc_JSON_AvlTree_listKeysReverse(threadData_t *threadData, modelica_metatype _inTree, modelica_metatype __omcQ_24in_5Flst);
#define boxptr_JSON_AvlTree_listKeysReverse omc_JSON_AvlTree_listKeysReverse
static const MMC_DEFSTRUCTLIT(boxvar_lit_JSON_AvlTree_listKeysReverse,2,0) {(void*) boxptr_JSON_AvlTree_listKeysReverse,0}};
#define boxvar_JSON_AvlTree_listKeysReverse MMC_REFSTRUCTLIT(boxvar_lit_JSON_AvlTree_listKeysReverse)


DLLExport
modelica_metatype omc_JSON_AvlTree_listValues(threadData_t *threadData, modelica_metatype _tree, modelica_metatype __omcQ_24in_5Flst);
#define boxptr_JSON_AvlTree_listValues omc_JSON_AvlTree_listValues
static const MMC_DEFSTRUCTLIT(boxvar_lit_JSON_AvlTree_listValues,2,0) {(void*) boxptr_JSON_AvlTree_listValues,0}};
#define boxvar_JSON_AvlTree_listValues MMC_REFSTRUCTLIT(boxvar_lit_JSON_AvlTree_listValues)


DLLExport
modelica_metatype omc_JSON_AvlTree_map(threadData_t *threadData, modelica_metatype _inTree, modelica_fnptr _inFunc);
#define boxptr_JSON_AvlTree_map omc_JSON_AvlTree_map
static const MMC_DEFSTRUCTLIT(boxvar_lit_JSON_AvlTree_map,2,0) {(void*) boxptr_JSON_AvlTree_map,0}};
#define boxvar_JSON_AvlTree_map MMC_REFSTRUCTLIT(boxvar_lit_JSON_AvlTree_map)


DLLExport
modelica_metatype omc_JSON_AvlTree_mapFold(threadData_t *threadData, modelica_metatype _inTree, modelica_fnptr _inFunc, modelica_metatype _inStartValue, modelica_metatype *out_outResult);
#define boxptr_JSON_AvlTree_mapFold omc_JSON_AvlTree_mapFold
static const MMC_DEFSTRUCTLIT(boxvar_lit_JSON_AvlTree_mapFold,2,0) {(void*) boxptr_JSON_AvlTree_mapFold,0}};
#define boxvar_JSON_AvlTree_mapFold MMC_REFSTRUCTLIT(boxvar_lit_JSON_AvlTree_mapFold)


DLLExport
modelica_metatype omc_JSON_AvlTree_new(threadData_t *threadData);
#define boxptr_JSON_AvlTree_new omc_JSON_AvlTree_new
static const MMC_DEFSTRUCTLIT(boxvar_lit_JSON_AvlTree_new,2,0) {(void*) boxptr_JSON_AvlTree_new,0}};
#define boxvar_JSON_AvlTree_new MMC_REFSTRUCTLIT(boxvar_lit_JSON_AvlTree_new)


DLLExport
modelica_string omc_JSON_AvlTree_printNodeStr(threadData_t *threadData, modelica_metatype _inNode);
#define boxptr_JSON_AvlTree_printNodeStr omc_JSON_AvlTree_printNodeStr
static const MMC_DEFSTRUCTLIT(boxvar_lit_JSON_AvlTree_printNodeStr,2,0) {(void*) boxptr_JSON_AvlTree_printNodeStr,0}};
#define boxvar_JSON_AvlTree_printNodeStr MMC_REFSTRUCTLIT(boxvar_lit_JSON_AvlTree_printNodeStr)


DLLExport
modelica_string omc_JSON_AvlTree_printTreeStr(threadData_t *threadData, modelica_metatype _inTree);
#define boxptr_JSON_AvlTree_printTreeStr omc_JSON_AvlTree_printTreeStr
static const MMC_DEFSTRUCTLIT(boxvar_lit_JSON_AvlTree_printTreeStr,2,0) {(void*) boxptr_JSON_AvlTree_printTreeStr,0}};
#define boxvar_JSON_AvlTree_printTreeStr MMC_REFSTRUCTLIT(boxvar_lit_JSON_AvlTree_printTreeStr)


#define boxptr_JSON_AvlTree_rotateLeft omc_JSON_AvlTree_rotateLeft


#define boxptr_JSON_AvlTree_rotateRight omc_JSON_AvlTree_rotateRight


DLLExport
modelica_metatype omc_JSON_AvlTree_setTreeLeftRight(threadData_t *threadData, modelica_metatype _orig, modelica_metatype _left, modelica_metatype _right);
#define boxptr_JSON_AvlTree_setTreeLeftRight omc_JSON_AvlTree_setTreeLeftRight
static const MMC_DEFSTRUCTLIT(boxvar_lit_JSON_AvlTree_setTreeLeftRight,2,0) {(void*) boxptr_JSON_AvlTree_setTreeLeftRight,0}};
#define boxvar_JSON_AvlTree_setTreeLeftRight MMC_REFSTRUCTLIT(boxvar_lit_JSON_AvlTree_setTreeLeftRight)


DLLExport
modelica_metatype omc_JSON_AvlTree_toList(threadData_t *threadData, modelica_metatype _inTree, modelica_metatype __omcQ_24in_5Flst);
#define boxptr_JSON_AvlTree_toList omc_JSON_AvlTree_toList
static const MMC_DEFSTRUCTLIT(boxvar_lit_JSON_AvlTree_toList,2,0) {(void*) boxptr_JSON_AvlTree_toList,0}};
#define boxvar_JSON_AvlTree_toList MMC_REFSTRUCTLIT(boxvar_lit_JSON_AvlTree_toList)


DLLExport
modelica_metatype omc_JSON_AvlTree_update(threadData_t *threadData, modelica_metatype _tree, modelica_string _key, modelica_metatype _value);
#define boxptr_JSON_AvlTree_update omc_JSON_AvlTree_update
static const MMC_DEFSTRUCTLIT(boxvar_lit_JSON_AvlTree_update,2,0) {(void*) boxptr_JSON_AvlTree_update,0}};
#define boxvar_JSON_AvlTree_update MMC_REFSTRUCTLIT(boxvar_lit_JSON_AvlTree_update)


DLLExport
modelica_string omc_JSON_AvlTree_valueStr(threadData_t *threadData, modelica_metatype _inValue);
#define boxptr_JSON_AvlTree_valueStr omc_JSON_AvlTree_valueStr
static const MMC_DEFSTRUCTLIT(boxvar_lit_JSON_AvlTree_valueStr,2,0) {(void*) boxptr_JSON_AvlTree_valueStr,0}};
#define boxvar_JSON_AvlTree_valueStr MMC_REFSTRUCTLIT(boxvar_lit_JSON_AvlTree_valueStr)

#ifdef __cplusplus
}
#endif
#endif
