#ifndef UnorderedSet__H
#define UnorderedSet__H
#include "meta/meta_modelica.h"
#include "util/modelica.h"
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>

#ifdef __cplusplus
extern "C" {
#endif

extern struct record_description UnorderedSet_UNORDERED__SET__desc;


DLLExport
void omc_UnorderedSet_dump(threadData_t *threadData, modelica_metatype _set, modelica_fnptr _stringFn);
#define boxptr_UnorderedSet_dump omc_UnorderedSet_dump
static const MMC_DEFSTRUCTLIT(boxvar_lit_UnorderedSet_dump,2,0) {(void*) boxptr_UnorderedSet_dump,0}};
#define boxvar_UnorderedSet_dump MMC_REFSTRUCTLIT(boxvar_lit_UnorderedSet_dump)


DLLExport
modelica_string omc_UnorderedSet_toString(threadData_t *threadData, modelica_metatype _set, modelica_fnptr _stringFn, modelica_string _delimiter);
#define boxptr_UnorderedSet_toString omc_UnorderedSet_toString
static const MMC_DEFSTRUCTLIT(boxvar_lit_UnorderedSet_toString,2,0) {(void*) boxptr_UnorderedSet_toString,0}};
#define boxvar_UnorderedSet_toString MMC_REFSTRUCTLIT(boxvar_lit_UnorderedSet_toString)


DLLExport
void omc_UnorderedSet_rehash(threadData_t *threadData, modelica_metatype _set);
#define boxptr_UnorderedSet_rehash omc_UnorderedSet_rehash
static const MMC_DEFSTRUCTLIT(boxvar_lit_UnorderedSet_rehash,2,0) {(void*) boxptr_UnorderedSet_rehash,0}};
#define boxvar_UnorderedSet_rehash MMC_REFSTRUCTLIT(boxvar_lit_UnorderedSet_rehash)


DLLExport
modelica_real omc_UnorderedSet_loadFactor(threadData_t *threadData, modelica_metatype _set);
DLLExport
modelica_metatype boxptr_UnorderedSet_loadFactor(threadData_t *threadData, modelica_metatype _set);
static const MMC_DEFSTRUCTLIT(boxvar_lit_UnorderedSet_loadFactor,2,0) {(void*) boxptr_UnorderedSet_loadFactor,0}};
#define boxvar_UnorderedSet_loadFactor MMC_REFSTRUCTLIT(boxvar_lit_UnorderedSet_loadFactor)


DLLExport
modelica_integer omc_UnorderedSet_bucketCount(threadData_t *threadData, modelica_metatype _set);
DLLExport
modelica_metatype boxptr_UnorderedSet_bucketCount(threadData_t *threadData, modelica_metatype _set);
static const MMC_DEFSTRUCTLIT(boxvar_lit_UnorderedSet_bucketCount,2,0) {(void*) boxptr_UnorderedSet_bucketCount,0}};
#define boxvar_UnorderedSet_bucketCount MMC_REFSTRUCTLIT(boxvar_lit_UnorderedSet_bucketCount)


DLLExport
modelica_boolean omc_UnorderedSet_isEmpty(threadData_t *threadData, modelica_metatype _set);
DLLExport
modelica_metatype boxptr_UnorderedSet_isEmpty(threadData_t *threadData, modelica_metatype _set);
static const MMC_DEFSTRUCTLIT(boxvar_lit_UnorderedSet_isEmpty,2,0) {(void*) boxptr_UnorderedSet_isEmpty,0}};
#define boxvar_UnorderedSet_isEmpty MMC_REFSTRUCTLIT(boxvar_lit_UnorderedSet_isEmpty)


DLLExport
modelica_integer omc_UnorderedSet_size(threadData_t *threadData, modelica_metatype _set);
DLLExport
modelica_metatype boxptr_UnorderedSet_size(threadData_t *threadData, modelica_metatype _set);
static const MMC_DEFSTRUCTLIT(boxvar_lit_UnorderedSet_size,2,0) {(void*) boxptr_UnorderedSet_size,0}};
#define boxvar_UnorderedSet_size MMC_REFSTRUCTLIT(boxvar_lit_UnorderedSet_size)


DLLExport
modelica_boolean omc_UnorderedSet_none(threadData_t *threadData, modelica_metatype _set, modelica_fnptr _fn);
DLLExport
modelica_metatype boxptr_UnorderedSet_none(threadData_t *threadData, modelica_metatype _set, modelica_fnptr _fn);
static const MMC_DEFSTRUCTLIT(boxvar_lit_UnorderedSet_none,2,0) {(void*) boxptr_UnorderedSet_none,0}};
#define boxvar_UnorderedSet_none MMC_REFSTRUCTLIT(boxvar_lit_UnorderedSet_none)


DLLExport
modelica_boolean omc_UnorderedSet_any(threadData_t *threadData, modelica_metatype _set, modelica_fnptr _fn);
DLLExport
modelica_metatype boxptr_UnorderedSet_any(threadData_t *threadData, modelica_metatype _set, modelica_fnptr _fn);
static const MMC_DEFSTRUCTLIT(boxvar_lit_UnorderedSet_any,2,0) {(void*) boxptr_UnorderedSet_any,0}};
#define boxvar_UnorderedSet_any MMC_REFSTRUCTLIT(boxvar_lit_UnorderedSet_any)


DLLExport
modelica_boolean omc_UnorderedSet_all(threadData_t *threadData, modelica_metatype _set, modelica_fnptr _fn);
DLLExport
modelica_metatype boxptr_UnorderedSet_all(threadData_t *threadData, modelica_metatype _set, modelica_fnptr _fn);
static const MMC_DEFSTRUCTLIT(boxvar_lit_UnorderedSet_all,2,0) {(void*) boxptr_UnorderedSet_all,0}};
#define boxvar_UnorderedSet_all MMC_REFSTRUCTLIT(boxvar_lit_UnorderedSet_all)


DLLExport
modelica_metatype omc_UnorderedSet_fold(threadData_t *threadData, modelica_metatype _set, modelica_fnptr _fn, modelica_metatype _startValue);
#define boxptr_UnorderedSet_fold omc_UnorderedSet_fold
static const MMC_DEFSTRUCTLIT(boxvar_lit_UnorderedSet_fold,2,0) {(void*) boxptr_UnorderedSet_fold,0}};
#define boxvar_UnorderedSet_fold MMC_REFSTRUCTLIT(boxvar_lit_UnorderedSet_fold)


DLLExport
modelica_metatype omc_UnorderedSet_toArray(threadData_t *threadData, modelica_metatype _set);
#define boxptr_UnorderedSet_toArray omc_UnorderedSet_toArray
static const MMC_DEFSTRUCTLIT(boxvar_lit_UnorderedSet_toArray,2,0) {(void*) boxptr_UnorderedSet_toArray,0}};
#define boxvar_UnorderedSet_toArray MMC_REFSTRUCTLIT(boxvar_lit_UnorderedSet_toArray)


DLLExport
modelica_metatype omc_UnorderedSet_toList(threadData_t *threadData, modelica_metatype _set);
#define boxptr_UnorderedSet_toList omc_UnorderedSet_toList
static const MMC_DEFSTRUCTLIT(boxvar_lit_UnorderedSet_toList,2,0) {(void*) boxptr_UnorderedSet_toList,0}};
#define boxvar_UnorderedSet_toList MMC_REFSTRUCTLIT(boxvar_lit_UnorderedSet_toList)


DLLExport
modelica_boolean omc_UnorderedSet_isEqual(threadData_t *threadData, modelica_metatype _set1, modelica_metatype _set2);
DLLExport
modelica_metatype boxptr_UnorderedSet_isEqual(threadData_t *threadData, modelica_metatype _set1, modelica_metatype _set2);
static const MMC_DEFSTRUCTLIT(boxvar_lit_UnorderedSet_isEqual,2,0) {(void*) boxptr_UnorderedSet_isEqual,0}};
#define boxvar_UnorderedSet_isEqual MMC_REFSTRUCTLIT(boxvar_lit_UnorderedSet_isEqual)


DLLExport
modelica_metatype omc_UnorderedSet_first(threadData_t *threadData, modelica_metatype _set);
#define boxptr_UnorderedSet_first omc_UnorderedSet_first
static const MMC_DEFSTRUCTLIT(boxvar_lit_UnorderedSet_first,2,0) {(void*) boxptr_UnorderedSet_first,0}};
#define boxvar_UnorderedSet_first MMC_REFSTRUCTLIT(boxvar_lit_UnorderedSet_first)


DLLExport
modelica_boolean omc_UnorderedSet_contains(threadData_t *threadData, modelica_metatype _key, modelica_metatype _set);
DLLExport
modelica_metatype boxptr_UnorderedSet_contains(threadData_t *threadData, modelica_metatype _key, modelica_metatype _set);
static const MMC_DEFSTRUCTLIT(boxvar_lit_UnorderedSet_contains,2,0) {(void*) boxptr_UnorderedSet_contains,0}};
#define boxvar_UnorderedSet_contains MMC_REFSTRUCTLIT(boxvar_lit_UnorderedSet_contains)


DLLExport
modelica_metatype omc_UnorderedSet_get(threadData_t *threadData, modelica_metatype _key, modelica_metatype _set);
#define boxptr_UnorderedSet_get omc_UnorderedSet_get
static const MMC_DEFSTRUCTLIT(boxvar_lit_UnorderedSet_get,2,0) {(void*) boxptr_UnorderedSet_get,0}};
#define boxvar_UnorderedSet_get MMC_REFSTRUCTLIT(boxvar_lit_UnorderedSet_get)


DLLExport
modelica_boolean omc_UnorderedSet_remove(threadData_t *threadData, modelica_metatype _key, modelica_metatype _set);
DLLExport
modelica_metatype boxptr_UnorderedSet_remove(threadData_t *threadData, modelica_metatype _key, modelica_metatype _set);
static const MMC_DEFSTRUCTLIT(boxvar_lit_UnorderedSet_remove,2,0) {(void*) boxptr_UnorderedSet_remove,0}};
#define boxvar_UnorderedSet_remove MMC_REFSTRUCTLIT(boxvar_lit_UnorderedSet_remove)


DLLExport
void omc_UnorderedSet_addUnique(threadData_t *threadData, modelica_metatype _key, modelica_metatype _set);
#define boxptr_UnorderedSet_addUnique omc_UnorderedSet_addUnique
static const MMC_DEFSTRUCTLIT(boxvar_lit_UnorderedSet_addUnique,2,0) {(void*) boxptr_UnorderedSet_addUnique,0}};
#define boxvar_UnorderedSet_addUnique MMC_REFSTRUCTLIT(boxvar_lit_UnorderedSet_addUnique)


DLLExport
void omc_UnorderedSet_addNoUpdCheck(threadData_t *threadData, modelica_metatype _key, modelica_metatype _set);
#define boxptr_UnorderedSet_addNoUpdCheck omc_UnorderedSet_addNoUpdCheck
static const MMC_DEFSTRUCTLIT(boxvar_lit_UnorderedSet_addNoUpdCheck,2,0) {(void*) boxptr_UnorderedSet_addNoUpdCheck,0}};
#define boxvar_UnorderedSet_addNoUpdCheck MMC_REFSTRUCTLIT(boxvar_lit_UnorderedSet_addNoUpdCheck)


DLLExport
void omc_UnorderedSet_add(threadData_t *threadData, modelica_metatype _key, modelica_metatype _set);
#define boxptr_UnorderedSet_add omc_UnorderedSet_add
static const MMC_DEFSTRUCTLIT(boxvar_lit_UnorderedSet_add,2,0) {(void*) boxptr_UnorderedSet_add,0}};
#define boxvar_UnorderedSet_add MMC_REFSTRUCTLIT(boxvar_lit_UnorderedSet_add)


DLLExport
modelica_metatype omc_UnorderedSet_copy(threadData_t *threadData, modelica_metatype _set);
#define boxptr_UnorderedSet_copy omc_UnorderedSet_copy
static const MMC_DEFSTRUCTLIT(boxvar_lit_UnorderedSet_copy,2,0) {(void*) boxptr_UnorderedSet_copy,0}};
#define boxvar_UnorderedSet_copy MMC_REFSTRUCTLIT(boxvar_lit_UnorderedSet_copy)


DLLExport
modelica_metatype omc_UnorderedSet_fromList(threadData_t *threadData, modelica_metatype _elements, modelica_fnptr _hash, modelica_fnptr _keyEq);
#define boxptr_UnorderedSet_fromList omc_UnorderedSet_fromList
static const MMC_DEFSTRUCTLIT(boxvar_lit_UnorderedSet_fromList,2,0) {(void*) boxptr_UnorderedSet_fromList,0}};
#define boxvar_UnorderedSet_fromList MMC_REFSTRUCTLIT(boxvar_lit_UnorderedSet_fromList)


DLLExport
modelica_metatype omc_UnorderedSet_new(threadData_t *threadData, modelica_fnptr _hash, modelica_fnptr _keyEq, modelica_integer _bucketCount);
DLLExport
modelica_metatype boxptr_UnorderedSet_new(threadData_t *threadData, modelica_fnptr _hash, modelica_fnptr _keyEq, modelica_metatype _bucketCount);
static const MMC_DEFSTRUCTLIT(boxvar_lit_UnorderedSet_new,2,0) {(void*) boxptr_UnorderedSet_new,0}};
#define boxvar_UnorderedSet_new MMC_REFSTRUCTLIT(boxvar_lit_UnorderedSet_new)

#ifdef __cplusplus
}
#endif
#endif
