encapsulated package AbsynToJulia
"
  file:        AbsynToJulia.mo
  package:     AbsynToJulia
  description: Generated by Susan.
"

public import Tpl;

public import Static;
public import Absyn;
public import Config;
public import Dump;
public import System;
public import Flags;
public import MMToJuliaUtil;
public import AbsynUtil;
public import Util;
public import AbsynToSCode;
public import SCode;
public import SCodeDump;
protected import AbsynDumpTpl;

protected function lm_17
  input Tpl.Text in_txt;
  input list<Absyn.Class> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<Absyn.Class> rest;
      Absyn.Class i_cls;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_cls :: rest )
      equation
        txt = dumpClass(txt, i_cls, Dump.defaultDumpOptions);
        txt = Tpl.nextIter(txt);
        txt = lm_17(txt, rest);
      then txt;
  end match;
end lm_17;

public function dumpProgram
  input Tpl.Text in_txt;
  input Absyn.Program in_a_program;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_program)
    local
      Tpl.Text txt;
      list<Absyn.Class> i_classes;
      Tpl.Text l_cls__str;

    case ( txt,
           Absyn.PROGRAM(classes = {}) )
      then txt;

    case ( txt,
           Absyn.PROGRAM(classes = i_classes) )
      equation
        l_cls__str = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING_LIST({
                                                                                     "\n",
                                                                                     "\n"
                                                                                 }, true)), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_cls__str = lm_17(l_cls__str, i_classes);
        l_cls__str = Tpl.popIter(l_cls__str);
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_cls__str);
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end dumpProgram;

public function dumpSCodeElements
  input Tpl.Text txt;
  input list<SCode.Element> a_elements;

  output Tpl.Text out_txt;
protected
  list<SCode.Element> ret_0;
algorithm
  ret_0 := SCodeDump.filterElements(a_elements, SCodeDump.defaultOptions);
  out_txt := dumpSCodeElements2(txt, ret_0);
end dumpSCodeElements;

protected function fun_20
  input Tpl.Text in_txt;
  input SCode.Element in_a_el;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_el)
    local
      Tpl.Text txt;
      list<SCode.Element> i_parts_elementLst;
      SCode.Ident i_name;

    case ( txt,
           SCode.CLASS(restriction = SCode.R_UNIONTYPE(), name = i_name) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("@UniontypeDecl "));
        txt = Tpl.writeStr(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           SCode.CLASS(classDef = SCode.PARTS(elementLst = i_parts_elementLst), partialPrefix = SCode.NOT_PARTIAL(), restriction = SCode.R_FUNCTION()) )
      equation
        txt = dumpSCodeElements2(txt, i_parts_elementLst);
      then txt;

    case ( txt,
           SCode.CLASS(partialPrefix = SCode.PARTIAL(), restriction = SCode.R_FUNCTION(), name = i_name) )
      equation
        txt = Tpl.writeStr(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = Function"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_20;

protected function lm_21
  input Tpl.Text in_txt;
  input list<SCode.Element> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SCode.Element> rest;
      SCode.Element i_el;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_el :: rest )
      equation
        txt = fun_20(txt, i_el);
        txt = lm_21(txt, rest);
      then txt;
  end match;
end lm_21;

protected function fun_22
  input Tpl.Text in_txt;
  input Tpl.Text in_a_str;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_str)
    local
      Tpl.Text txt;
      Tpl.Text i_str;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}) )
      then txt;

    case ( txt,
           i_str )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, i_str);
      then txt;
  end match;
end fun_22;

public function dumpSCodeElements2
  input Tpl.Text txt;
  input list<SCode.Element> a_elements;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_str;
algorithm
  l_str := lm_21(Tpl.emptyTxt, a_elements);
  out_txt := fun_22(txt, l_str);
end dumpSCodeElements2;

public function dumpClass
  input Tpl.Text txt;
  input Absyn.Class a_cls;
  input Dump.DumpOptions a_options;

  output Tpl.Text out_txt;
algorithm
  out_txt := dumpClassElement(txt, a_cls, a_options, MMToJuliaUtil.noContext);
end dumpClass;

protected function lm_25
  input Tpl.Text in_txt;
  input list<Absyn.ClassPart> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<Absyn.ClassPart> rest;
      Absyn.ClassPart i_cp;
      list<Absyn.ElementItem> ret_0;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_cp :: rest )
      equation
        ret_0 = AbsynUtil.getElementItemsInClassPart(i_cp);
        txt = dumpReturnTypeJL(txt, ret_0);
        txt = lm_25(txt, rest);
      then txt;
  end match;
end lm_25;

protected function lm_26
  input Tpl.Text in_txt;
  input list<Absyn.ClassPart> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<Absyn.ClassPart> rest;
      Absyn.ClassPart i_cp;
      list<Absyn.ElementItem> ret_0;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_cp :: rest )
      equation
        ret_0 = AbsynUtil.getElementItemsInClassPart(i_cp);
        txt = dumpReturnStrJL(txt, ret_0, MMToJuliaUtil.functionContext);
        txt = lm_26(txt, rest);
      then txt;
  end match;
end lm_26;

protected function lm_27
  input Tpl.Text in_txt;
  input list<Absyn.ClassPart> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<Absyn.ClassPart> rest;
      Absyn.ClassPart i_cp;
      list<Absyn.ElementItem> ret_0;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_cp :: rest )
      equation
        ret_0 = AbsynUtil.getElementItemsInClassPart(i_cp);
        txt = dumpInputsJL(txt, ret_0, MMToJuliaUtil.inputContext);
        txt = lm_27(txt, rest);
      then txt;
  end match;
end lm_27;

protected function fun_28
  input Tpl.Text in_txt;
  input Tpl.Text in_a_header;
  input Tpl.Text in_a_typevar__inputs;
  input Tpl.Text in_a_inputs__str;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_header, in_a_typevar__inputs, in_a_inputs__str)
    local
      Tpl.Text txt;
      Tpl.Text a_typevar__inputs;
      Tpl.Text a_inputs__str;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           _,
           a_inputs__str )
      equation
        txt = Tpl.writeText(txt, a_inputs__str);
      then txt;

    case ( txt,
           _,
           a_typevar__inputs,
           _ )
      equation
        txt = Tpl.writeText(txt, a_typevar__inputs);
      then txt;
  end match;
end fun_28;

protected function fun_29
  input Tpl.Text in_txt;
  input Tpl.Text in_a_header;
  input Tpl.Text in_a_returnType;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_header, in_a_returnType)
    local
      Tpl.Text txt;
      Tpl.Text a_returnType;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           a_returnType )
      equation
        txt = Tpl.writeText(txt, a_returnType);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_29;

protected function fun_30
  input Tpl.Text in_txt;
  input Boolean in_a_encapsulatedPrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_encapsulatedPrefix)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_30;

protected function fun_31
  input Tpl.Text in_txt;
  input Boolean in_a_partialPrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_partialPrefix)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#=TODO: Originally partial =# "));
      then txt;
  end match;
end fun_31;

protected function fun_32
  input Tpl.Text in_txt;
  input Absyn.Restriction in_a_restriction;
  input MMToJuliaUtil.Context in_a_context;
  input Dump.DumpOptions in_a_options;
  input Absyn.ClassDef in_a_parts;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_restriction, in_a_context, in_a_options, in_a_parts)
    local
      Tpl.Text txt;
      MMToJuliaUtil.Context a_context;
      Dump.DumpOptions a_options;
      Absyn.ClassDef a_parts;
      MMToJuliaUtil.Context ret_0;

    case ( txt,
           Absyn.R_PACKAGE(),
           _,
           a_options,
           a_parts )
      equation
        txt = dumpClassDef(txt, a_parts, MMToJuliaUtil.packageContext, a_options);
      then txt;

    case ( txt,
           Absyn.R_RECORD(),
           _,
           a_options,
           a_parts )
      equation
        ret_0 = MMToJuliaUtil.makeUniontypeContext("");
        txt = dumpClassDef(txt, a_parts, ret_0, a_options);
      then txt;

    case ( txt,
           _,
           a_context,
           a_options,
           a_parts )
      equation
        txt = dumpClassDef(txt, a_parts, a_context, a_options);
      then txt;
  end match;
end fun_32;

protected function fun_33
  input Tpl.Text in_txt;
  input Tpl.Text in_a_forwardDeclarations;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_forwardDeclarations)
    local
      Tpl.Text txt;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}) )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#= Necessary to write declarations for your uniontypes until Julia adds support for mutually recursive types =#"));
      then txt;
  end match;
end fun_33;

protected function fun_34
  input Tpl.Text in_txt;
  input Absyn.Restriction in_a_restriction;
  input Tpl.Text in_a_cdef__str1;
  input Tpl.Text in_a_forwardDeclarations;
  input Tpl.Text in_a_inform;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_restriction, in_a_cdef__str1, in_a_forwardDeclarations, in_a_inform)
    local
      Tpl.Text txt;
      Tpl.Text a_cdef__str1;
      Tpl.Text a_forwardDeclarations;
      Tpl.Text a_inform;

    case ( txt,
           Absyn.R_PACKAGE(),
           a_cdef__str1,
           a_forwardDeclarations,
           a_inform )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "using MetaModelica\n",
                                    "#= ExportAll is not good practice but it makes it so that we do not have to write export after each function :( =#\n",
                                    "using ExportAll\n"
                                }, true));
        txt = Tpl.writeText(txt, a_inform);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, a_forwardDeclarations);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_cdef__str1);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "#= So that we can use wildcard imports and named imports when they do occur. Not good Julia practice =#\n",
                                    "@exportAll()"
                                }, false));
      then txt;

    case ( txt,
           _,
           a_cdef__str1,
           _,
           _ )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_cdef__str1);
        txt = Tpl.popBlock(txt);
      then txt;
  end match;
end fun_34;

protected function fun_35
  input Tpl.Text in_txt;
  input Absyn.Restriction in_a_restriction;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_restriction)
    local
      Tpl.Text txt;

    case ( txt,
           Absyn.R_RECORD() )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("begin"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_35;

protected function lm_36
  input Tpl.Text in_txt;
  input list<Absyn.ElementArg> in_items;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_context)
    local
      Tpl.Text txt;
      list<Absyn.ElementArg> rest;
      MMToJuliaUtil.Context a_context;
      Absyn.ElementArg i_earg;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_earg :: rest,
           a_context )
      equation
        txt = dumpElementArg(txt, i_earg, a_context);
        txt = Tpl.nextIter(txt);
        txt = lm_36(txt, rest, a_context);
      then txt;
  end match;
end lm_36;

protected function lm_37
  input Tpl.Text in_txt;
  input list<Absyn.ElementArg> in_items;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_context)
    local
      Tpl.Text txt;
      list<Absyn.ElementArg> rest;
      MMToJuliaUtil.Context a_context;
      Absyn.ElementArg i_earg;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_earg :: rest,
           a_context )
      equation
        txt = dumpElementArg(txt, i_earg, a_context);
        txt = Tpl.nextIter(txt);
        txt = lm_37(txt, rest, a_context);
      then txt;
  end match;
end lm_37;

public function dumpClassElement
  input Tpl.Text in_txt;
  input Absyn.Class in_a_class;
  input Dump.DumpOptions in_a_options;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_class, in_a_options, in_a_context)
    local
      Tpl.Text txt;
      Dump.DumpOptions a_options;
      MMToJuliaUtil.Context a_context;
      Absyn.ElementAttributes i_parts_attributes;
      list<Absyn.ElementArg> i_parts_arguments;
      Absyn.TypeSpec i_parts_typeSpec;
      Option<Absyn.Comment> i_parts_comment_1;
      Boolean i_partialPrefix;
      Boolean i_encapsulatedPrefix;
      Absyn.Restriction i_restriction;
      list<Absyn.ClassPart> i_parts_classParts;
      Absyn.Ident i_name;
      Absyn.ClassDef i_parts;
      Option<String> i_parts_comment;
      Tpl.Text l_name__of__new__function;
      Tpl.Text l_attr;
      Tpl.Text l_args;
      Tpl.Text l_spec;
      Tpl.Text l_comment;
      Tpl.Text l_partial__str__and__class__type;
      Tpl.Text l_footer__str;
      Tpl.Text l_header__str;
      Tpl.Text l_cmt__str;
      Tpl.Text l_cdef__str;
      Tpl.Text l_begin__str;
      Tpl.Text l_cdef__str2;
      Tpl.Text l_inform;
      list<SCode.Element> ret_16;
      Tpl.Text l_forwardDeclarations;
      Tpl.Text l_cdef__str1;
      Tpl.Text l_class__type__str;
      Tpl.Text l_partial__str;
      Tpl.Text l_enc__str;
      MMToJuliaUtil.Context ret_10;
      Tpl.Text l_functionBodyStr;
      Tpl.Text l_header;
      String ret_7;
      Tpl.Text l_typevar__inputs;
      Tpl.Text l_inputs__str;
      Tpl.Text l_return__str;
      Tpl.Text l_returnType;
      MMToJuliaUtil.Context ret_2;
      Tpl.Text l_class__def__str;
      Tpl.Text l_commentStr;

    case ( txt,
           Absyn.CLASS(body = (i_parts as Absyn.PARTS(comment = i_parts_comment)), restriction = Absyn.R_UNIONTYPE(), name = i_name),
           a_options,
           _ )
      equation
        l_commentStr = dumpCommentStrOpt(Tpl.emptyTxt, i_parts_comment);
        ret_2 = MMToJuliaUtil.makeUniontypeContext(i_name);
        l_class__def__str = dumpClassDef(Tpl.emptyTxt, i_parts, ret_2, a_options);
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeText(txt, l_commentStr);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("@Uniontype "));
        txt = Tpl.writeStr(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" begin\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeText(txt, l_class__def__str);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("end"));
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           Absyn.CLASS(partialPrefix = true, restriction = Absyn.R_FUNCTION(functionRestriction = _)),
           _,
           _ )
      then txt;

    case ( txt,
           Absyn.CLASS(partialPrefix = false, body = (i_parts as Absyn.PARTS(comment = i_parts_comment, classParts = i_parts_classParts)), restriction = (i_restriction as Absyn.R_FUNCTION(functionRestriction = _)), name = i_name),
           a_options,
           _ )
      equation
        l_commentStr = dumpCommentStrOpt(Tpl.emptyTxt, i_parts_comment);
        l_returnType = lm_25(Tpl.emptyTxt, i_parts_classParts);
        l_return__str = lm_26(Tpl.emptyTxt, i_parts_classParts);
        l_inputs__str = lm_27(Tpl.emptyTxt, i_parts_classParts);
        ret_7 = System.stringReplace(Tpl.textString(l_inputs__str), "<:", "");
        l_typevar__inputs = Tpl.writeStr(Tpl.emptyTxt, ret_7);
        l_header = dumpClassHeader(Tpl.emptyTxt, i_parts, i_restriction);
        ret_10 = MMToJuliaUtil.makeFunctionContext(Tpl.textString(l_return__str));
        l_functionBodyStr = dumpClassDef(Tpl.emptyTxt, i_parts, ret_10, a_options);
        txt = Tpl.writeText(txt, l_commentStr);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("function "));
        txt = Tpl.writeStr(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = fun_28(txt, l_header, l_typevar__inputs, l_inputs__str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") "));
        txt = fun_29(txt, l_header, l_returnType);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, l_header);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_functionBodyStr);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_return__str);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("end"));
      then txt;

    case ( txt,
           Absyn.CLASS(body = (i_parts as Absyn.PARTS(classParts = i_parts_classParts, comment = i_parts_comment)), encapsulatedPrefix = i_encapsulatedPrefix, partialPrefix = i_partialPrefix, restriction = i_restriction, name = i_name),
           a_options,
           a_context )
      equation
        l_enc__str = fun_30(Tpl.emptyTxt, i_encapsulatedPrefix);
        l_partial__str = fun_31(Tpl.emptyTxt, i_partialPrefix);
        l_class__type__str = dumpClassType(Tpl.emptyTxt, i_restriction);
        l_cdef__str1 = fun_32(Tpl.emptyTxt, i_restriction, a_context, a_options, i_parts);
        ret_16 = AbsynToSCode.translateClassdefElements(i_parts_classParts);
        l_forwardDeclarations = dumpSCodeElements(Tpl.emptyTxt, ret_16);
        l_inform = fun_33(Tpl.emptyTxt, l_forwardDeclarations);
        l_cdef__str2 = fun_34(Tpl.emptyTxt, i_restriction, l_cdef__str1, l_forwardDeclarations, l_inform);
        l_begin__str = fun_35(Tpl.emptyTxt, i_restriction);
        l_cdef__str = Tpl.writeText(Tpl.emptyTxt, l_cdef__str2);
        l_cmt__str = dumpCommentStrOpt(Tpl.emptyTxt, i_parts_comment);
        l_header__str = dumpClassHeader(Tpl.emptyTxt, i_parts, i_restriction);
        l_footer__str = dumpClassFooter(Tpl.emptyTxt, i_parts, Tpl.textString(l_cdef__str), i_name, Tpl.textString(l_cmt__str), "");
        l_partial__str__and__class__type = Tpl.writeText(Tpl.emptyTxt, l_partial__str);
        l_partial__str__and__class__type = Tpl.writeText(l_partial__str__and__class__type, l_class__type__str);
        txt = Tpl.writeText(txt, l_partial__str__and__class__type);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeStr(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, l_begin__str);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_header__str);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeText(txt, l_footer__str);
      then txt;

    case ( txt,
           Absyn.CLASS(body = Absyn.DERIVED(comment = i_parts_comment_1, typeSpec = i_parts_typeSpec, arguments = i_parts_arguments, attributes = i_parts_attributes), restriction = Absyn.R_TYPE(), name = i_name),
           _,
           a_context )
      equation
        l_comment = dumpCommentOpt(Tpl.emptyTxt, i_parts_comment_1, a_context);
        l_spec = dumpTypeSpec(Tpl.emptyTxt, i_parts_typeSpec, a_context);
        l_args = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_args = lm_36(l_args, i_parts_arguments, a_context);
        l_args = Tpl.popIter(l_args);
        l_attr = dumpElementAttr(Tpl.emptyTxt, i_parts_attributes);
        txt = Tpl.writeStr(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, l_spec);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, l_attr);
        txt = Tpl.writeText(txt, l_comment);
      then txt;

    case ( txt,
           Absyn.CLASS(body = Absyn.DERIVED(comment = i_parts_comment_1, typeSpec = i_parts_typeSpec, arguments = i_parts_arguments, attributes = i_parts_attributes), restriction = Absyn.R_FUNCTION(functionRestriction = _), name = i_name),
           _,
           a_context )
      equation
        l_comment = dumpCommentOpt(Tpl.emptyTxt, i_parts_comment_1, a_context);
        l_spec = dumpTypeSpec(Tpl.emptyTxt, i_parts_typeSpec, a_context);
        l_args = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_args = lm_37(l_args, i_parts_arguments, a_context);
        l_args = Tpl.popIter(l_args);
        l_attr = dumpElementAttr(Tpl.emptyTxt, i_parts_attributes);
        l_name__of__new__function = Tpl.writeStr(Tpl.emptyTxt, i_name);
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_comment);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("@ExtendedFunction "));
        txt = Tpl.writeText(txt, l_name__of__new__function);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, l_spec);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, l_args);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end dumpClassElement;

public function dumpClassHeader
  input Tpl.Text in_txt;
  input Absyn.ClassDef in_a_classDef;
  input Absyn.Restriction in_a_restriction;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_classDef, in_a_restriction)
    local
      Tpl.Text txt;
      Absyn.Restriction a_restriction;
      list<String> i_typeVars;

    case ( txt,
           Absyn.CLASS_EXTENDS(baseClassName = _),
           _ )
      equation
        txt = AbsynDumpTpl.errorMsg(txt, "Extend  not supported");
      then txt;

    case ( txt,
           Absyn.PARTS(typeVars = i_typeVars),
           a_restriction )
      equation
        txt = dumpClassTypeTypeVars(txt, a_restriction, i_typeVars);
        txt = dumpClassTypeSuperType(txt, a_restriction);
      then txt;

    case ( txt,
           _,
           _ )
      equation
        txt = AbsynDumpTpl.errorMsg(txt, "AbsynToJulia.dumpClassHeader: <%dumpClassTypeSuperType(classDef)%>");
      then txt;
  end match;
end dumpClassHeader;

public function dumpClassTypeSuperType
  input Tpl.Text in_txt;
  input Absyn.Restriction in_a_r;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_r)
    local
      Tpl.Text txt;
      Absyn.Path i_name;

    case ( txt,
           Absyn.R_METARECORD(name = i_name) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<: "));
        txt = dumpPathJL(txt, i_name);
      then txt;

    case ( txt,
           Absyn.R_FUNCTION(functionRestriction = _) )
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end dumpClassTypeSuperType;

protected function lm_41
  input Tpl.Text in_txt;
  input list<String> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<String> rest;
      String i_tv;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_tv :: rest )
      equation
        txt = Tpl.writeStr(txt, i_tv);
        txt = Tpl.nextIter(txt);
        txt = lm_41(txt, rest);
      then txt;
  end match;
end lm_41;

protected function fun_42
  input Tpl.Text in_txt;
  input list<String> in_a_typeVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_typeVars)
    local
      Tpl.Text txt;
      list<String> i_typeVars;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_typeVars )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("{"));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_41(txt, i_typeVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;
  end match;
end fun_42;

protected function lm_43
  input Tpl.Text in_txt;
  input list<String> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<String> rest;
      String i_tv;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_tv :: rest )
      equation
        txt = Tpl.writeStr(txt, i_tv);
        txt = Tpl.nextIter(txt);
        txt = lm_43(txt, rest);
      then txt;
  end match;
end lm_43;

protected function fun_44
  input Tpl.Text in_txt;
  input list<String> in_a_typeVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_typeVars)
    local
      Tpl.Text txt;
      list<String> i_typeVars;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_typeVars )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("where {"));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_43(txt, i_typeVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;
  end match;
end fun_44;

public function dumpClassTypeTypeVars
  input Tpl.Text in_txt;
  input Absyn.Restriction in_a_restriction;
  input list<String> in_a_typeVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_restriction, in_a_typeVars)
    local
      Tpl.Text txt;
      list<String> a_typeVars;

    case ( txt,
           Absyn.R_UNIONTYPE(),
           a_typeVars )
      equation
        txt = fun_42(txt, a_typeVars);
      then txt;

    case ( txt,
           Absyn.R_FUNCTION(functionRestriction = _),
           a_typeVars )
      equation
        txt = fun_44(txt, a_typeVars);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end dumpClassTypeTypeVars;

protected function fun_46
  input Tpl.Text in_txt;
  input String in_a_ann;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ann)
    local
      Tpl.Text txt;
      String i_ann;

    case ( txt,
           "" )
      then txt;

    case ( txt,
           i_ann )
      equation
        txt = Tpl.writeStr(txt, i_ann);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
      then txt;
  end match;
end fun_46;

protected function fun_47
  input Tpl.Text in_txt;
  input Tpl.Text in_a_annotation__str;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_annotation__str)
    local
      Tpl.Text txt;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}) )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
      then txt;
  end match;
end fun_47;

protected function fun_48
  input Tpl.Text in_txt;
  input String in_a_cdefStr;
  input Tpl.Text in_a_annotation__str;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_cdefStr, in_a_annotation__str)
    local
      Tpl.Text txt;
      Tpl.Text a_annotation__str;
      String i_cdefStr;

    case ( txt,
           "",
           a_annotation__str )
      equation
        txt = Tpl.writeText(txt, a_annotation__str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("end"));
      then txt;

    case ( txt,
           i_cdefStr,
           a_annotation__str )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeStr(txt, i_cdefStr);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = fun_47(txt, a_annotation__str);
        txt = Tpl.writeText(txt, a_annotation__str);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("end"));
      then txt;
  end match;
end fun_48;

protected function fun_49
  input Tpl.Text in_txt;
  input Absyn.ClassDef in_a_classDef;
  input String in_a_cdefStr;
  input String in_a_ann;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_classDef, in_a_cdefStr, in_a_ann)
    local
      Tpl.Text txt;
      String a_cdefStr;
      String a_ann;
      Tpl.Text l_annotation__str;

    case ( txt,
           Absyn.DERIVED(typeSpec = _),
           _,
           _ )
      equation
        txt = AbsynDumpTpl.errorMsg(txt, "AbsynToJulia.dumpClassFooter: Derived not yet supported.");
      then txt;

    case ( txt,
           Absyn.ENUMERATION(enumLiterals = _),
           _,
           _ )
      equation
        txt = AbsynDumpTpl.errorMsg(txt, "AbsynToJulia.dumpClassFooterf: ENUMERATION not yet supported.");
      then txt;

    case ( txt,
           _,
           a_cdefStr,
           a_ann )
      equation
        l_annotation__str = fun_46(Tpl.emptyTxt, a_ann);
        txt = fun_48(txt, a_cdefStr, l_annotation__str);
      then txt;
  end match;
end fun_49;

public function dumpClassFooter
  input Tpl.Text txt;
  input Absyn.ClassDef a_classDef;
  input String a_cdefStr;
  input String a_name;
  input String a_cmt;
  input String a_ann;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_49(txt, a_classDef, a_cdefStr, a_ann);
end dumpClassFooter;

protected function lm_51
  input Tpl.Text in_txt;
  input list<Absyn.ElementItem> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<Absyn.ElementItem> rest;
      Absyn.ElementItem i_ei;
      MMToJuliaUtil.Context ret_3;
      Tpl.Text txt_2;
      Option<Absyn.TypeSpec> ret_1;
      list<Absyn.ComponentItem> ret_0;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_ei :: rest )
      equation
        ret_0 = AbsynUtil.getComponentItemsFromElementItem(i_ei);
        ret_1 = AbsynUtil.getTypeSpecFromElementItemOpt(i_ei);
        txt_2 = dumpTypeSpecOpt(Tpl.emptyTxt, ret_1, MMToJuliaUtil.inputContext);
        ret_3 = MMToJuliaUtil.makeInputContext(Tpl.textString(txt_2));
        txt = dumpComponentItems(txt, ret_0, ret_3);
        txt = Tpl.nextIter(txt);
        txt = lm_51(txt, rest);
      then txt;
  end match;
end lm_51;

public function dumpInputsJL
  input Tpl.Text txt;
  input list<Absyn.ElementItem> a_inputs;
  input MMToJuliaUtil.Context a_context;

  output Tpl.Text out_txt;
protected
  list<Absyn.ElementItem> ret_3;
  list<Absyn.ElementItem> ret_2;
  Absyn.Direction ret_1;
  Tpl.Text l_inputStr;
algorithm
  ret_1 := MMToJuliaUtil.makeInputDirection();
  ret_2 := MMToJuliaUtil.filterOnDirection(a_inputs, ret_1);
  ret_3 := listReverse(ret_2);
  l_inputStr := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  l_inputStr := lm_51(l_inputStr, ret_3);
  l_inputStr := Tpl.popIter(l_inputStr);
  out_txt := Tpl.writeText(txt, l_inputStr);
end dumpInputsJL;

protected function fun_53
  input Tpl.Text in_txt;
  input list<Absyn.ElementItem> in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;
      list<Absyn.ElementItem> i_L;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           (i_L as _ :: {}) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("::"));
        txt = dumpOutputsJL(txt, i_L);
      then txt;

    case ( txt,
           (i_L as _ :: _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("::Tuple{"));
        txt = dumpOutputsJL(txt, i_L);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_53;

public function dumpReturnTypeJL
  input Tpl.Text txt;
  input list<Absyn.ElementItem> a_outputs;

  output Tpl.Text out_txt;
protected
  list<Absyn.ElementItem> ret_1;
  Absyn.Direction ret_0;
algorithm
  ret_0 := MMToJuliaUtil.makeOutputDirection();
  ret_1 := MMToJuliaUtil.filterOnDirection(a_outputs, ret_0);
  out_txt := fun_53(txt, ret_1);
end dumpReturnTypeJL;

protected function lm_55
  input Tpl.Text in_txt;
  input list<Absyn.ElementItem> in_items;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_context)
    local
      Tpl.Text txt;
      list<Absyn.ElementItem> rest;
      MMToJuliaUtil.Context a_context;
      Absyn.ElementItem i_e;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_e :: rest,
           a_context )
      equation
        txt = dumpElementItemRaw(txt, i_e, Dump.defaultDumpOptions, a_context);
        txt = Tpl.nextIter(txt);
        txt = lm_55(txt, rest, a_context);
      then txt;
  end match;
end lm_55;

protected function lm_56
  input Tpl.Text in_txt;
  input list<Absyn.ElementItem> in_items;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_context)
    local
      Tpl.Text txt;
      list<Absyn.ElementItem> rest;
      MMToJuliaUtil.Context a_context;
      Absyn.ElementItem i_e;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_e :: rest,
           a_context )
      equation
        txt = dumpElementItemRaw(txt, i_e, Dump.defaultDumpOptions, a_context);
        txt = Tpl.nextIter(txt);
        txt = lm_56(txt, rest, a_context);
      then txt;
  end match;
end lm_56;

protected function fun_57
  input Tpl.Text in_txt;
  input list<Absyn.ElementItem> in_mArg;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_context)
    local
      Tpl.Text txt;
      MMToJuliaUtil.Context a_context;
      list<Absyn.ElementItem> i_L;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           (i_L as _ :: {}),
           a_context )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_55(txt, i_L, a_context);
        txt = Tpl.popIter(txt);
      then txt;

    case ( txt,
           (i_L as _ :: _),
           a_context )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_56(txt, i_L, a_context);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_57;

public function dumpReturnStrJL
  input Tpl.Text txt;
  input list<Absyn.ElementItem> a_outputs;
  input MMToJuliaUtil.Context a_context;

  output Tpl.Text out_txt;
protected
  list<Absyn.ElementItem> ret_2;
  list<Absyn.ElementItem> ret_1;
  Absyn.Direction ret_0;
algorithm
  ret_0 := MMToJuliaUtil.makeOutputDirection();
  ret_1 := MMToJuliaUtil.filterOnDirection(a_outputs, ret_0);
  ret_2 := listReverse(ret_1);
  out_txt := fun_57(txt, ret_2, a_context);
end dumpReturnStrJL;

protected function lm_59
  input Tpl.Text in_txt;
  input list<Absyn.ClassPart> in_items;
  input Dump.DumpOptions in_a_options;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_options, in_a_context)
    local
      Tpl.Text txt;
      list<Absyn.ClassPart> rest;
      Dump.DumpOptions a_options;
      MMToJuliaUtil.Context a_context;
      Integer x_idx;
      Absyn.ClassPart i_class__part;

    case ( txt,
           {},
           _,
           _ )
      then txt;

    case ( txt,
           i_class__part :: rest,
           a_options,
           a_context )
      equation
        x_idx = Tpl.getIteri_i0(txt);
        txt = dumpClassPart(txt, i_class__part, x_idx, a_context, a_options);
        txt = Tpl.nextIter(txt);
        txt = lm_59(txt, rest, a_options, a_context);
      then txt;
  end match;
end lm_59;

public function dumpClassDef
  input Tpl.Text in_txt;
  input Absyn.ClassDef in_a_cdef;
  input MMToJuliaUtil.Context in_a_context;
  input Dump.DumpOptions in_a_options;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_cdef, in_a_context, in_a_options)
    local
      Tpl.Text txt;
      MMToJuliaUtil.Context a_context;
      Dump.DumpOptions a_options;
      list<Absyn.ClassPart> i_classParts;
      Tpl.Text l_body__str;

    case ( txt,
           Absyn.PARTS(classParts = i_classParts),
           a_context,
           a_options )
      equation
        l_body__str = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_body__str = lm_59(l_body__str, i_classParts, a_options, a_context);
        l_body__str = Tpl.popIter(l_body__str);
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_body__str);
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           Absyn.DERIVED(typeSpec = _),
           _,
           _ )
      equation
        txt = AbsynDumpTpl.errorMsg(txt, "AbsynToJulia.dumpClassDef: Derived not yet supported.");
      then txt;

    case ( txt,
           Absyn.CLASS_EXTENDS(baseClassName = _),
           _,
           _ )
      equation
        txt = AbsynDumpTpl.errorMsg(txt, "AbsynToJulia.dumpClassDef: CLASS_EXETENDS not yet supported.");
      then txt;

    case ( txt,
           Absyn.ENUMERATION(enumLiterals = _),
           _,
           _ )
      equation
        txt = AbsynDumpTpl.errorMsg(txt, "AbsynToJulia.dumpClassDef: CLASS_ENUMERATION not yet supported.");
      then txt;

    case ( txt,
           _,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("TODO Unkown class definition"));
      then txt;
  end match;
end dumpClassDef;

public function dumpClassType
  input Tpl.Text in_txt;
  input Absyn.Restriction in_a_restriction;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_restriction)
    local
      Tpl.Text txt;
      Absyn.Restriction i_restriction;
      Tpl.Text txt_0;

    case ( txt,
           Absyn.R_PACKAGE() )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("module"));
      then txt;

    case ( txt,
           Absyn.R_METARECORD(name = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("struct"));
      then txt;

    case ( txt,
           Absyn.R_RECORD() )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("@Record"));
      then txt;

    case ( txt,
           Absyn.R_UNIONTYPE() )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("uniontype"));
      then txt;

    case ( txt,
           Absyn.R_TYPE() )
      then txt;

    case ( txt,
           Absyn.R_FUNCTION(functionRestriction = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("function"));
      then txt;

    case ( txt,
           i_restriction )
      equation
        txt_0 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("AbsynToJulia.dumpClassType: Unknown restriction for class."));
        txt_0 = AbsynDumpTpl.dumpRestriction(txt_0, i_restriction);
        txt = AbsynDumpTpl.errorMsg(txt, Tpl.textString(txt_0));
      then txt;
  end match;
end dumpClassType;

protected function fun_62
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Dump.DumpOptions in_a_options;
  input MMToJuliaUtil.Context in_a_context;
  input list<Absyn.ElementItem> in_a_contents;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_options, in_a_context, in_a_contents)
    local
      Tpl.Text txt;
      Dump.DumpOptions a_options;
      MMToJuliaUtil.Context a_context;
      list<Absyn.ElementItem> a_contents;
      list<Absyn.ElementItem> ret_1;
      Absyn.Direction ret_0;

    case ( txt,
           false,
           a_options,
           a_context,
           a_contents )
      equation
        txt = dumpElementItems(txt, a_contents, a_context, "", true, a_options);
      then txt;

    case ( txt,
           _,
           a_options,
           a_context,
           a_contents )
      equation
        ret_0 = MMToJuliaUtil.makeOutputDirection();
        ret_1 = MMToJuliaUtil.filterOnDirection(a_contents, ret_0);
        txt = dumpElementItems(txt, ret_1, a_context, "", true, a_options);
      then txt;
  end match;
end fun_62;

protected function lm_63
  input Tpl.Text in_txt;
  input list<Absyn.AlgorithmItem> in_items;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_context)
    local
      Tpl.Text txt;
      list<Absyn.AlgorithmItem> rest;
      MMToJuliaUtil.Context a_context;
      Absyn.AlgorithmItem i_eq;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_eq :: rest,
           a_context )
      equation
        txt = dumpAlgorithmItem(txt, i_eq, a_context);
        txt = Tpl.nextIter(txt);
        txt = lm_63(txt, rest, a_context);
      then txt;
  end match;
end lm_63;

protected function fun_64
  input Tpl.Text in_txt;
  input Option<Absyn.Annotation> in_a_annotation__;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_annotation__, in_a_context)
    local
      Tpl.Text txt;
      MMToJuliaUtil.Context a_context;
      Absyn.Annotation i_ann;

    case ( txt,
           SOME(i_ann),
           a_context )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = dumpAnnotation(txt, i_ann, a_context);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_64;

protected function fun_65
  input Tpl.Text in_txt;
  input Absyn.ExternalDecl in_a_externalDecl;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_externalDecl)
    local
      Tpl.Text txt;

    case ( txt,
           Absyn.EXTERNALDECL(funcName = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#= TODO: Defined in the runtime =#"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_65;

protected function fun_66
  input Tpl.Text in_txt;
  input Absyn.ClassPart in_a_class__part;
  input MMToJuliaUtil.Context in_a_context;
  input Dump.DumpOptions in_a_options;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_class__part, in_a_context, in_a_options)
    local
      Tpl.Text txt;
      MMToJuliaUtil.Context a_context;
      Dump.DumpOptions a_options;
      Absyn.ExternalDecl i_externalDecl;
      Option<Absyn.Annotation> i_annotation__;
      list<Absyn.AlgorithmItem> i_contents_1;
      list<Absyn.ElementItem> i_contents;
      Tpl.Text l_ann__str;
      Boolean ret_1;
      Tpl.Text l_el__str;

    case ( txt,
           Absyn.PUBLIC(contents = i_contents),
           a_context,
           a_options )
      equation
        ret_1 = MMToJuliaUtil.isFunctionContext(a_context);
        l_el__str = fun_62(Tpl.emptyTxt, ret_1, a_options, a_context, i_contents);
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_el__str);
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           Absyn.PROTECTED(contents = i_contents),
           a_context,
           a_options )
      equation
        l_el__str = dumpElementItems(Tpl.emptyTxt, i_contents, a_context, "", true, a_options);
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_el__str);
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           Absyn.CONSTRAINTS(contents = _),
           _,
           _ )
      equation
        txt = AbsynDumpTpl.errorMsg(txt, "AbsynToJulia.dumpClassPart: CONSTRAINTS(__) not supported.");
      then txt;

    case ( txt,
           Absyn.EQUATIONS(contents = _),
           _,
           _ )
      equation
        txt = AbsynDumpTpl.errorMsg(txt, "AbsynToJulia.dumpClassPart: EQUATIONS(__) not supported.");
      then txt;

    case ( txt,
           Absyn.INITIALEQUATIONS(contents = _),
           _,
           _ )
      equation
        txt = AbsynDumpTpl.errorMsg(txt, "AbsynToJulia.dumpClassPart: INITIALEQUATIONS() not supported.");
      then txt;

    case ( txt,
           Absyn.ALGORITHMS(contents = i_contents_1),
           a_context,
           _ )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_63(txt, i_contents_1, a_context);
        txt = Tpl.popIter(txt);
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           Absyn.INITIALALGORITHMS(contents = _),
           _,
           _ )
      equation
        txt = AbsynDumpTpl.errorMsg(txt, "AbsynToJulia.dumpClassPart: INITIALALGORITHMS() not supported.");
      then txt;

    case ( txt,
           Absyn.EXTERNAL(annotation_ = i_annotation__, externalDecl = i_externalDecl),
           a_context,
           _ )
      equation
        l_ann__str = fun_64(Tpl.emptyTxt, i_annotation__, a_context);
        txt = fun_65(txt, i_externalDecl);
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_66;

public function dumpClassPart
  input Tpl.Text txt;
  input Absyn.ClassPart a_class__part;
  input Integer a_idx;
  input MMToJuliaUtil.Context a_context;
  input Dump.DumpOptions a_options;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_66(txt, a_class__part, a_context, a_options);
end dumpClassPart;

protected function fun_68
  input Tpl.Text in_txt;
  input Boolean in_a_first;
  input String in_a_prevSpacing;
  input Tpl.Text in_a_spacing;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_first, in_a_prevSpacing, in_a_spacing)
    local
      Tpl.Text txt;
      String a_prevSpacing;
      Tpl.Text a_spacing;

    case ( txt,
           false,
           a_prevSpacing,
           a_spacing )
      equation
        txt = dumpElementItemPreSpacing(txt, Tpl.textString(a_spacing), a_prevSpacing);
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_68;

protected function fun_69
  input Tpl.Text in_txt;
  input Tpl.Text in_a_rest__str;
  input Tpl.Text in_a_spacing;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_rest__str, in_a_spacing)
    local
      Tpl.Text txt;
      Tpl.Text a_spacing;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           _ )
      then txt;

    case ( txt,
           _,
           a_spacing )
      equation
        txt = Tpl.writeText(txt, a_spacing);
      then txt;
  end match;
end fun_69;

protected function fun_70
  input Tpl.Text in_txt;
  input Tpl.Text in_a_rest__str;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_rest__str)
    local
      Tpl.Text txt;
      Tpl.Text i_rest__str;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}) )
      then txt;

    case ( txt,
           i_rest__str )
      equation
        txt = Tpl.writeText(txt, i_rest__str);
      then txt;
  end match;
end fun_70;

public function dumpElementItems
  input Tpl.Text in_txt;
  input list<Absyn.ElementItem> in_a_items;
  input MMToJuliaUtil.Context in_a_context;
  input String in_a_prevSpacing;
  input Boolean in_a_first;
  input Dump.DumpOptions in_a_options;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_items, in_a_context, in_a_prevSpacing, in_a_first, in_a_options)
    local
      Tpl.Text txt;
      MMToJuliaUtil.Context a_context;
      String a_prevSpacing;
      Boolean a_first;
      Dump.DumpOptions a_options;
      list<Absyn.ElementItem> i_rest__items;
      Absyn.ElementItem i_item;
      Tpl.Text l_post__spacing;
      Tpl.Text l_rest__str;
      Tpl.Text l_item__str;
      Tpl.Text l_pre__spacing;
      Tpl.Text l_spacing;

    case ( txt,
           i_item :: i_rest__items,
           a_context,
           a_prevSpacing,
           a_first,
           a_options )
      equation
        l_spacing = dumpElementItemSpacing(Tpl.emptyTxt, i_item);
        l_pre__spacing = fun_68(Tpl.emptyTxt, a_first, a_prevSpacing, l_spacing);
        l_item__str = dumpElementItem(Tpl.emptyTxt, i_item, a_options, a_context);
        l_rest__str = dumpElementItems(Tpl.emptyTxt, i_rest__items, a_context, Tpl.textString(l_spacing), false, a_options);
        l_post__spacing = fun_69(Tpl.emptyTxt, l_rest__str, l_spacing);
        txt = Tpl.writeText(txt, l_pre__spacing);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_item__str);
        txt = Tpl.writeText(txt, l_post__spacing);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = fun_70(txt, l_rest__str);
      then txt;

    case ( txt,
           _,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end dumpElementItems;

protected function fun_72
  input Tpl.Text in_txt;
  input String in_a_prevSpacing;
  input String in_a_curSpacing;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_prevSpacing, in_a_curSpacing)
    local
      Tpl.Text txt;
      String a_curSpacing;

    case ( txt,
           "",
           a_curSpacing )
      equation
        txt = Tpl.writeStr(txt, a_curSpacing);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_72;

public function dumpElementItemPreSpacing
  input Tpl.Text txt;
  input String a_curSpacing;
  input String a_prevSpacing;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_72(txt, a_prevSpacing, a_curSpacing);
end dumpElementItemPreSpacing;

public function dumpElementItemSpacing
  input Tpl.Text in_txt;
  input Absyn.ElementItem in_a_item;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_item)
    local
      Tpl.Text txt;
      Absyn.ClassDef i_cdef;

    case ( txt,
           Absyn.ELEMENTITEM(element = Absyn.ELEMENT(specification = Absyn.CLASSDEF(class_ = Absyn.CLASS(body = i_cdef)))) )
      equation
        txt = dumpClassDefSpacing(txt, i_cdef);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end dumpElementItemSpacing;

public function dumpClassDefSpacing
  input Tpl.Text in_txt;
  input Absyn.ClassDef in_a_cdef;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_cdef)
    local
      Tpl.Text txt;

    case ( txt,
           Absyn.PARTS(typeVars = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           Absyn.CLASS_EXTENDS(baseClassName = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end dumpClassDefSpacing;

public function dumpElementItem
  input Tpl.Text in_txt;
  input Absyn.ElementItem in_a_eitem;
  input Dump.DumpOptions in_a_options;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_eitem, in_a_options, in_a_context)
    local
      Tpl.Text txt;
      Dump.DumpOptions a_options;
      MMToJuliaUtil.Context a_context;
      String i_comment;
      Absyn.Element i_element;

    case ( txt,
           Absyn.ELEMENTITEM(element = i_element),
           a_options,
           a_context )
      equation
        txt = dumpElement(txt, i_element, a_options, a_context);
      then txt;

    case ( txt,
           Absyn.LEXER_COMMENT(comment = i_comment),
           _,
           _ )
      equation
        txt = dumpCommentStr(txt, i_comment);
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end dumpElementItem;

protected function lm_77
  input Tpl.Text in_txt;
  input list<Absyn.ComponentItem> in_items;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_context)
    local
      Tpl.Text txt;
      list<Absyn.ComponentItem> rest;
      MMToJuliaUtil.Context a_context;
      Absyn.ComponentItem i_comp;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_comp :: rest,
           a_context )
      equation
        txt = dumpComponentItem(txt, i_comp, a_context);
        txt = Tpl.nextIter(txt);
        txt = lm_77(txt, rest, a_context);
      then txt;
  end match;
end lm_77;

protected function fun_78
  input Tpl.Text in_txt;
  input Absyn.ElementSpec in_a_specification;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_specification, in_a_context)
    local
      Tpl.Text txt;
      MMToJuliaUtil.Context a_context;
      list<Absyn.ComponentItem> i_components;
      Tpl.Text l_comps__str;

    case ( txt,
           Absyn.COMPONENTS(components = i_components),
           a_context )
      equation
        l_comps__str = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_comps__str = lm_77(l_comps__str, i_components, a_context);
        l_comps__str = Tpl.popIter(l_comps__str);
        txt = Tpl.writeText(txt, l_comps__str);
      then txt;

    case ( txt,
           _,
           _ )
      equation
        txt = AbsynDumpTpl.errorMsg(txt, "AbsynToJulia.dumpElementItem: on none component type");
      then txt;
  end match;
end fun_78;

protected function fun_79
  input Tpl.Text in_txt;
  input Absyn.Element in_a_element;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_element, in_a_context)
    local
      Tpl.Text txt;
      MMToJuliaUtil.Context a_context;
      Absyn.ElementSpec i_specification;

    case ( txt,
           Absyn.ELEMENT(specification = i_specification),
           a_context )
      equation
        txt = fun_78(txt, i_specification, a_context);
      then txt;

    case ( txt,
           _,
           _ )
      equation
        txt = AbsynDumpTpl.errorMsg(txt, "AbsynToJulia.dumpElementItem: on none component type");
      then txt;
  end match;
end fun_79;

protected function fun_80
  input Tpl.Text in_txt;
  input Absyn.ElementItem in_a_eitem;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_eitem, in_a_context)
    local
      Tpl.Text txt;
      MMToJuliaUtil.Context a_context;
      String i_comment;
      Absyn.Element i_element;

    case ( txt,
           Absyn.ELEMENTITEM(element = i_element),
           a_context )
      equation
        txt = fun_79(txt, i_element, a_context);
      then txt;

    case ( txt,
           Absyn.LEXER_COMMENT(comment = i_comment),
           _ )
      equation
        txt = dumpCommentStr(txt, i_comment);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_80;

public function dumpElementItemRaw
  input Tpl.Text txt;
  input Absyn.ElementItem a_eitem;
  input Dump.DumpOptions a_options;
  input MMToJuliaUtil.Context a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_80(txt, a_eitem, a_context);
end dumpElementItemRaw;

protected function fun_82
  input Tpl.Text in_txt;
  input Option<Absyn.RedeclareKeywords> in_a_redeclareKeywords;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_redeclareKeywords)
    local
      Tpl.Text txt;
      Absyn.RedeclareKeywords i_re;

    case ( txt,
           SOME(i_re) )
      equation
        txt = dumpRedeclare(txt, i_re);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_82;

protected function fun_83
  input Tpl.Text in_txt;
  input Option<Absyn.RedeclareKeywords> in_a_redeclareKeywords;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_redeclareKeywords)
    local
      Tpl.Text txt;
      Absyn.RedeclareKeywords i_re;

    case ( txt,
           SOME(i_re) )
      equation
        txt = dumpReplaceable(txt, i_re);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_83;

protected function fun_84
  input Tpl.Text in_txt;
  input Option<Absyn.ConstrainClass> in_a_constrainClass;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_constrainClass, in_a_context)
    local
      Tpl.Text txt;
      MMToJuliaUtil.Context a_context;
      Absyn.ConstrainClass i_cc;

    case ( txt,
           SOME(i_cc),
           a_context )
      equation
        txt = dumpConstrainClass(txt, i_cc, a_context);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_84;

protected function fun_85
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Option<Absyn.ConstrainClass> in_a_constrainClass;
  input MMToJuliaUtil.Context in_a_context;
  input Dump.DumpOptions in_a_options;
  input Absyn.ElementSpec in_a_specification;
  input Option<Absyn.RedeclareKeywords> in_a_redeclareKeywords;
  input Boolean in_a_finalPrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_constrainClass, in_a_context, in_a_options, in_a_specification, in_a_redeclareKeywords, in_a_finalPrefix)
    local
      Tpl.Text txt;
      Option<Absyn.ConstrainClass> a_constrainClass;
      MMToJuliaUtil.Context a_context;
      Dump.DumpOptions a_options;
      Absyn.ElementSpec a_specification;
      Option<Absyn.RedeclareKeywords> a_redeclareKeywords;
      Boolean a_finalPrefix;
      Tpl.Text l_constrainClass__str;
      Tpl.Text l_elementSpec__str;
      Tpl.Text l_repl__str;
      Tpl.Text l_redecl__str;
      Tpl.Text l_final__str;

    case ( txt,
           false,
           _,
           _,
           _,
           _,
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_constrainClass,
           a_context,
           a_options,
           a_specification,
           a_redeclareKeywords,
           a_finalPrefix )
      equation
        l_final__str = dumpFinal(Tpl.emptyTxt, a_finalPrefix);
        l_redecl__str = fun_82(Tpl.emptyTxt, a_redeclareKeywords);
        l_repl__str = fun_83(Tpl.emptyTxt, a_redeclareKeywords);
        l_elementSpec__str = dumpElementSpec(Tpl.emptyTxt, a_specification, a_options, a_context);
        l_constrainClass__str = fun_84(Tpl.emptyTxt, a_constrainClass, a_context);
        txt = Tpl.writeText(txt, l_elementSpec__str);
        txt = Tpl.writeText(txt, l_constrainClass__str);
      then txt;
  end match;
end fun_85;

protected function fun_86
  input Tpl.Text in_txt;
  input Option<Absyn.Ident> in_a_optName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_optName)
    local
      Tpl.Text txt;
      Absyn.Ident i_name;

    case ( txt,
           SOME(i_name) )
      equation
        txt = Tpl.writeStr(txt, i_name);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_86;

protected function fun_87
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_string;
  input SourceInfo in_a_info;
  input Option<Absyn.Ident> in_a_optName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_string, in_a_info, in_a_optName)
    local
      Tpl.Text txt;
      String a_string;
      SourceInfo a_info;
      Option<Absyn.Ident> a_optName;
      Tpl.Text l_info__str;
      Tpl.Text l_name__str;

    case ( txt,
           false,
           _,
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_string,
           a_info,
           a_optName )
      equation
        l_name__str = fun_86(Tpl.emptyTxt, a_optName);
        l_info__str = dumpInfo(Tpl.emptyTxt, a_info);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/* Absyn.TEXT(SOME(\""));
        txt = Tpl.writeText(txt, l_name__str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\"), \""));
        txt = Tpl.writeStr(txt, a_string);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\", \""));
        txt = Tpl.writeText(txt, l_info__str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\"); */"));
      then txt;
  end match;
end fun_87;

public function dumpElement
  input Tpl.Text in_txt;
  input Absyn.Element in_a_elem;
  input Dump.DumpOptions in_a_options;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_elem, in_a_options, in_a_context)
    local
      Tpl.Text txt;
      Dump.DumpOptions a_options;
      MMToJuliaUtil.Context a_context;
      String i_string;
      Option<Absyn.Ident> i_optName;
      Option<Absyn.ConstrainClass> i_constrainClass;
      Absyn.ElementSpec i_specification;
      Option<Absyn.RedeclareKeywords> i_redeclareKeywords;
      Boolean i_finalPrefix;
      Absyn.Element i_elem;
      SourceInfo i_info;
      Boolean ret_4;
      Boolean ret_3;
      Boolean ret_2;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           (i_elem as Absyn.ELEMENT(info = i_info, finalPrefix = i_finalPrefix, redeclareKeywords = i_redeclareKeywords, specification = i_specification, constrainClass = i_constrainClass)),
           a_options,
           a_context )
      equation
        ret_0 = Dump.boolUnparseFileFromInfo(i_info, a_options);
        ret_1 = AbsynUtil.isClassdef(i_elem);
        ret_2 = boolNot(ret_1);
        ret_3 = boolOr(ret_0, ret_2);
        txt = fun_85(txt, ret_3, i_constrainClass, a_context, a_options, i_specification, i_redeclareKeywords, i_finalPrefix);
      then txt;

    case ( txt,
           Absyn.DEFINEUNIT(name = _),
           _,
           _ )
      equation
        txt = AbsynDumpTpl.errorMsg(txt, "AbsynToJulia.dumpElement: DEFINEUNIT(__) not supported");
      then txt;

    case ( txt,
           Absyn.TEXT(info = i_info, optName = i_optName, string = i_string),
           a_options,
           _ )
      equation
        ret_4 = Dump.boolUnparseFileFromInfo(i_info, a_options);
        txt = fun_87(txt, ret_4, i_string, i_info, i_optName);
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end dumpElement;

protected function fun_89
  input Tpl.Text in_txt;
  input Boolean in_a_isReadOnly;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_isReadOnly)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("writable"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("readonly"));
      then txt;
  end match;
end fun_89;

public function dumpInfo
  input Tpl.Text in_txt;
  input SourceInfo in_a_info;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_info)
    local
      Tpl.Text txt;
      Integer i_columnNumberEnd;
      Integer i_lineNumberEnd;
      Integer i_columnNumberStart;
      Integer i_lineNumberStart;
      String i_fileName;
      Boolean i_isReadOnly;
      Tpl.Text l_rm__str;

    case ( txt,
           SOURCEINFO(isReadOnly = i_isReadOnly, fileName = i_fileName, lineNumberStart = i_lineNumberStart, columnNumberStart = i_columnNumberStart, lineNumberEnd = i_lineNumberEnd, columnNumberEnd = i_columnNumberEnd) )
      equation
        l_rm__str = fun_89(Tpl.emptyTxt, i_isReadOnly);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("SOURCEINFO(\""));
        txt = Tpl.writeStr(txt, i_fileName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\", "));
        txt = Tpl.writeText(txt, l_rm__str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeStr(txt, intString(i_lineNumberStart));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeStr(txt, intString(i_columnNumberStart));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeStr(txt, intString(i_lineNumberEnd));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeStr(txt, intString(i_columnNumberEnd));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")\\n"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end dumpInfo;

protected function lm_91
  input Tpl.Text in_txt;
  input list<Absyn.ElementArg> in_items;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_context)
    local
      Tpl.Text txt;
      list<Absyn.ElementArg> rest;
      MMToJuliaUtil.Context a_context;
      Absyn.ElementArg i_earg;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_earg :: rest,
           a_context )
      equation
        txt = dumpElementArg(txt, i_earg, a_context);
        txt = Tpl.nextIter(txt);
        txt = lm_91(txt, rest, a_context);
      then txt;
  end match;
end lm_91;

public function dumpAnnotation
  input Tpl.Text in_txt;
  input Absyn.Annotation in_a_ann;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ann, in_a_context)
    local
      Tpl.Text txt;
      MMToJuliaUtil.Context a_context;
      list<Absyn.ElementArg> i_elementArgs;
      Tpl.StringToken ret_1;
      Tpl.Text txt_0;

    case ( txt,
           Absyn.ANNOTATION(elementArgs = {}),
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#= annotation() =#"));
      then txt;

    case ( txt,
           Absyn.ANNOTATION(elementArgs = i_elementArgs),
           a_context )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("#= annotation(\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt_0 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING(","));
        txt_0 = Tpl.writeTok(txt_0, Tpl.ST_NEW_LINE());
        ret_1 = Tpl.textStrTok(txt_0);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(ret_1), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_91(txt, i_elementArgs, a_context);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") =#"));
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end dumpAnnotation;

public function dumpAnnotationOpt
  input Tpl.Text in_txt;
  input Option<Absyn.Annotation> in_a_oann;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_oann, in_a_context)
    local
      Tpl.Text txt;
      MMToJuliaUtil.Context a_context;
      Absyn.Annotation i_ann;

    case ( txt,
           SOME(i_ann),
           a_context )
      equation
        txt = dumpAnnotation(txt, i_ann, a_context);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end dumpAnnotationOpt;

public function dumpAnnotationOptSpace
  input Tpl.Text in_txt;
  input Option<Absyn.Annotation> in_a_oann;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_oann, in_a_context)
    local
      Tpl.Text txt;
      MMToJuliaUtil.Context a_context;
      Absyn.Annotation i_ann;

    case ( txt,
           SOME(i_ann),
           a_context )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = dumpAnnotation(txt, i_ann, a_context);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end dumpAnnotationOptSpace;

public function dumpComment
  input Tpl.Text in_txt;
  input Absyn.Comment in_a_cmt;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_cmt, in_a_context)
    local
      Tpl.Text txt;
      MMToJuliaUtil.Context a_context;
      Option<Absyn.Annotation> i_annotation__;
      Option<String> i_comment;

    case ( txt,
           Absyn.COMMENT(comment = i_comment, annotation_ = i_annotation__),
           a_context )
      equation
        txt = dumpCommentStrOpt(txt, i_comment);
        txt = dumpAnnotationOptSpace(txt, i_annotation__, a_context);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end dumpComment;

public function dumpCommentOpt
  input Tpl.Text in_txt;
  input Option<Absyn.Comment> in_a_ocmt;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ocmt, in_a_context)
    local
      Tpl.Text txt;
      MMToJuliaUtil.Context a_context;
      Absyn.Comment i_cmt;

    case ( txt,
           SOME(i_cmt),
           a_context )
      equation
        txt = dumpComment(txt, i_cmt, a_context);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end dumpCommentOpt;

public function dumpCommentStrOpt
  input Tpl.Text in_txt;
  input Option<String> in_a_comment;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_comment)
    local
      Tpl.Text txt;
      String i_cmt;

    case ( txt,
           SOME(i_cmt) )
      equation
        txt = dumpCommentStr(txt, i_cmt);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end dumpCommentStrOpt;

public function dumpCommentStr
  input Tpl.Text txt;
  input String a_comment;

  output Tpl.Text out_txt;
protected
  String ret_2;
  String ret_1;
  Tpl.Text l_replaceAllRegular;
algorithm
  l_replaceAllRegular := Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING(" "));
  l_replaceAllRegular := Tpl.writeTok(l_replaceAllRegular, Tpl.ST_STRING("#= "));
  ret_1 := System.escapedString(a_comment, false);
  ret_2 := System.stringReplace(ret_1, "//", "");
  l_replaceAllRegular := Tpl.writeStr(l_replaceAllRegular, ret_2);
  l_replaceAllRegular := Tpl.writeTok(l_replaceAllRegular, Tpl.ST_STRING(" =#"));
  out_txt := Tpl.writeText(txt, l_replaceAllRegular);
end dumpCommentStr;

protected function fun_99
  input Tpl.Text in_txt;
  input Option<Absyn.Modification> in_a_modification;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modification, in_a_context)
    local
      Tpl.Text txt;
      MMToJuliaUtil.Context a_context;
      Absyn.Modification i_mod;

    case ( txt,
           SOME(i_mod),
           a_context )
      equation
        txt = dumpModification(txt, i_mod, a_context);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_99;

protected function fun_100
  input Tpl.Text in_txt;
  input Option<Absyn.ConstrainClass> in_a_constrainClass;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_constrainClass, in_a_context)
    local
      Tpl.Text txt;
      MMToJuliaUtil.Context a_context;
      Absyn.ConstrainClass i_cc;

    case ( txt,
           SOME(i_cc),
           a_context )
      equation
        txt = dumpConstrainClass(txt, i_cc, a_context);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_100;

public function dumpElementArg
  input Tpl.Text in_txt;
  input Absyn.ElementArg in_a_earg;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_earg, in_a_context)
    local
      Tpl.Text txt;
      MMToJuliaUtil.Context a_context;
      Option<Absyn.ConstrainClass> i_constrainClass;
      Absyn.ElementSpec i_elementSpec;
      Absyn.RedeclareKeywords i_redeclareKeywords;
      Option<String> i_comment;
      Option<Absyn.Modification> i_modification;
      Absyn.Path i_path;
      Boolean i_finalPrefix;
      Absyn.Each i_eachPrefix;
      Tpl.Text l_cc__str;
      Tpl.Text l_elem__str;
      Tpl.Text l_eredecl__str;
      Tpl.Text l_repl__str;
      Tpl.Text l_redecl__str;
      Tpl.Text l_cmt__str;
      Tpl.Text l_mod__str;
      Tpl.Text l_path__str;
      Tpl.Text l_final__str;
      Tpl.Text l_each__str;

    case ( txt,
           Absyn.MODIFICATION(eachPrefix = i_eachPrefix, finalPrefix = i_finalPrefix, path = i_path, modification = i_modification, comment = i_comment),
           a_context )
      equation
        l_each__str = dumpEach(Tpl.emptyTxt, i_eachPrefix);
        l_final__str = dumpFinal(Tpl.emptyTxt, i_finalPrefix);
        l_path__str = dumpPathJL(Tpl.emptyTxt, i_path);
        l_mod__str = fun_99(Tpl.emptyTxt, i_modification, a_context);
        l_cmt__str = dumpCommentStrOpt(Tpl.emptyTxt, i_comment);
        txt = Tpl.writeText(txt, l_each__str);
        txt = Tpl.writeText(txt, l_final__str);
        txt = Tpl.writeText(txt, l_path__str);
        txt = Tpl.writeText(txt, l_mod__str);
        txt = Tpl.writeText(txt, l_cmt__str);
      then txt;

    case ( txt,
           Absyn.REDECLARATION(eachPrefix = i_eachPrefix, finalPrefix = i_finalPrefix, redeclareKeywords = i_redeclareKeywords, elementSpec = i_elementSpec, constrainClass = i_constrainClass),
           a_context )
      equation
        l_each__str = dumpEach(Tpl.emptyTxt, i_eachPrefix);
        l_final__str = dumpFinal(Tpl.emptyTxt, i_finalPrefix);
        l_redecl__str = dumpRedeclare(Tpl.emptyTxt, i_redeclareKeywords);
        l_repl__str = dumpReplaceable(Tpl.emptyTxt, i_redeclareKeywords);
        l_eredecl__str = Tpl.writeText(Tpl.emptyTxt, l_redecl__str);
        l_eredecl__str = Tpl.writeText(l_eredecl__str, l_each__str);
        l_elem__str = dumpElementSpec(Tpl.emptyTxt, i_elementSpec, Dump.defaultDumpOptions, a_context);
        l_cc__str = fun_100(Tpl.emptyTxt, i_constrainClass, a_context);
        txt = Tpl.writeText(txt, l_elem__str);
        txt = Tpl.writeText(txt, l_cc__str);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end dumpElementArg;

public function dumpEach
  input Tpl.Text in_txt;
  input Absyn.Each in_a_each;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_each)
    local
      Tpl.Text txt;

    case ( txt,
           Absyn.EACH() )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("each "));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end dumpEach;

public function dumpFinal
  input Tpl.Text in_txt;
  input Boolean in_a_final;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_final)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("final "));
      then txt;
  end match;
end dumpFinal;

public function dumpRedeclare
  input Tpl.Text in_txt;
  input Absyn.RedeclareKeywords in_a_redecl;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_redecl)
    local
      Tpl.Text txt;

    case ( txt,
           Absyn.REDECLARE() )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("redeclare "));
      then txt;

    case ( txt,
           Absyn.REDECLARE_REPLACEABLE() )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("redeclare "));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end dumpRedeclare;

public function dumpReplaceable
  input Tpl.Text in_txt;
  input Absyn.RedeclareKeywords in_a_repl;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_repl)
    local
      Tpl.Text txt;

    case ( txt,
           Absyn.REPLACEABLE() )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("replaceable "));
      then txt;

    case ( txt,
           Absyn.REDECLARE_REPLACEABLE() )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("replaceable "));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end dumpReplaceable;

protected function lm_106
  input Tpl.Text in_txt;
  input list<Absyn.ElementArg> in_items;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_context)
    local
      Tpl.Text txt;
      list<Absyn.ElementArg> rest;
      MMToJuliaUtil.Context a_context;
      Absyn.ElementArg i_earg;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_earg :: rest,
           a_context )
      equation
        txt = dumpElementArg(txt, i_earg, a_context);
        txt = Tpl.nextIter(txt);
        txt = lm_106(txt, rest, a_context);
      then txt;
  end match;
end lm_106;

protected function fun_107
  input Tpl.Text in_txt;
  input list<Absyn.ElementArg> in_a_elementArgLst;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_elementArgLst, in_a_context)
    local
      Tpl.Text txt;
      MMToJuliaUtil.Context a_context;
      list<Absyn.ElementArg> i_elementArgLst;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_elementArgLst,
           a_context )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_106(txt, i_elementArgLst, a_context);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;
  end match;
end fun_107;

public function dumpModification
  input Tpl.Text in_txt;
  input Absyn.Modification in_a_mod;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_mod, in_a_context)
    local
      Tpl.Text txt;
      MMToJuliaUtil.Context a_context;
      Absyn.EqMod i_eqMod;
      list<Absyn.ElementArg> i_elementArgLst;
      Tpl.Text l_eq__str;
      Tpl.Text l_arg__str;

    case ( txt,
           Absyn.CLASSMOD(elementArgLst = i_elementArgLst, eqMod = i_eqMod),
           a_context )
      equation
        l_arg__str = fun_107(Tpl.emptyTxt, i_elementArgLst, a_context);
        l_eq__str = dumpEqMod(Tpl.emptyTxt, i_eqMod, a_context);
        txt = Tpl.writeText(txt, l_arg__str);
        txt = Tpl.writeText(txt, l_eq__str);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end dumpModification;

public function dumpEqMod
  input Tpl.Text in_txt;
  input Absyn.EqMod in_a_eqmod;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_eqmod, in_a_context)
    local
      Tpl.Text txt;
      MMToJuliaUtil.Context a_context;
      Absyn.Exp i_exp;

    case ( txt,
           Absyn.EQMOD(exp = i_exp),
           a_context )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("= "));
        txt = dumpExp(txt, i_exp, a_context);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end dumpEqMod;

protected function lm_110
  input Tpl.Text in_txt;
  input list<Absyn.ElementArg> in_items;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_context)
    local
      Tpl.Text txt;
      list<Absyn.ElementArg> rest;
      MMToJuliaUtil.Context a_context;
      Absyn.ElementArg i_earg;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_earg :: rest,
           a_context )
      equation
        txt = dumpElementArg(txt, i_earg, a_context);
        txt = Tpl.nextIter(txt);
        txt = lm_110(txt, rest, a_context);
      then txt;
  end match;
end lm_110;

protected function fun_111
  input Tpl.Text in_txt;
  input Tpl.Text in_a_args__str;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_args__str)
    local
      Tpl.Text txt;
      Tpl.Text i_args__str;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}) )
      then txt;

    case ( txt,
           i_args__str )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, i_args__str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;
  end match;
end fun_111;

protected function lm_112
  input Tpl.Text in_txt;
  input list<Absyn.ComponentItem> in_items;
  input Tpl.Text in_a_ty__str;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_ty__str)
    local
      Tpl.Text txt;
      list<Absyn.ComponentItem> rest;
      Tpl.Text a_ty__str;
      Absyn.ComponentItem i_comp;
      MMToJuliaUtil.Context ret_1;
      Tpl.Text l_comp__str;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_comp :: rest,
           a_ty__str )
      equation
        ret_1 = MMToJuliaUtil.makeFunctionReturnContext("", Tpl.textString(a_ty__str));
        l_comp__str = dumpComponentItem(Tpl.emptyTxt, i_comp, ret_1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("local "));
        txt = Tpl.writeText(txt, l_comp__str);
        txt = Tpl.nextIter(txt);
        txt = lm_112(txt, rest, a_ty__str);
      then txt;
  end match;
end lm_112;

protected function fun_113
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_ty__str;
  input list<Absyn.ComponentItem> in_a_components;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_ty__str, in_a_components)
    local
      Tpl.Text txt;
      Tpl.Text a_ty__str;
      list<Absyn.ComponentItem> a_components;

    case ( txt,
           false,
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_ty__str,
           a_components )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_112(txt, a_components, a_ty__str);
        txt = Tpl.popIter(txt);
      then txt;
  end match;
end fun_113;

protected function fun_114
  input Tpl.Text in_txt;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_context)
    local
      Tpl.Text txt;

    case ( txt,
           MMToJuliaUtil.PACKAGE() )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("const "));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_114;

protected function lm_115
  input Tpl.Text in_txt;
  input list<Absyn.ComponentItem> in_items;
  input Tpl.Text in_a_ty__str;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_ty__str, in_a_context)
    local
      Tpl.Text txt;
      list<Absyn.ComponentItem> rest;
      Tpl.Text a_ty__str;
      MMToJuliaUtil.Context a_context;
      Absyn.ComponentItem i_comp;
      Tpl.Text l_comp__str;

    case ( txt,
           {},
           _,
           _ )
      then txt;

    case ( txt,
           i_comp :: rest,
           a_ty__str,
           a_context )
      equation
        l_comp__str = dumpComponentItem(Tpl.emptyTxt, i_comp, MMToJuliaUtil.noContext);
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = fun_114(txt, a_context);
        txt = Tpl.writeText(txt, l_comp__str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("::"));
        txt = Tpl.writeText(txt, a_ty__str);
        txt = Tpl.popBlock(txt);
        txt = Tpl.nextIter(txt);
        txt = lm_115(txt, rest, a_ty__str, a_context);
      then txt;
  end match;
end lm_115;

protected function fun_116
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_ty__str;
  input MMToJuliaUtil.Context in_a_context;
  input list<Absyn.ComponentItem> in_a_components;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_ty__str, in_a_context, in_a_components)
    local
      Tpl.Text txt;
      Tpl.Text a_ty__str;
      MMToJuliaUtil.Context a_context;
      list<Absyn.ComponentItem> a_components;

    case ( txt,
           false,
           _,
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_ty__str,
           a_context,
           a_components )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_115(txt, a_components, a_ty__str, a_context);
        txt = Tpl.popIter(txt);
      then txt;
  end match;
end fun_116;

protected function fun_117
  input Tpl.Text in_txt;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_context)
    local
      Tpl.Text txt;
      String i_retValsStr;

    case ( txt,
           MMToJuliaUtil.FUNCTION(retValsStr = i_retValsStr) )
      equation
        txt = Tpl.writeStr(txt, i_retValsStr);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_117;

protected function fun_118
  input Tpl.Text in_txt;
  input Tpl.Text in_a_comps__str;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_comps__str)
    local
      Tpl.Text txt;
      Tpl.Text i_comps__str;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}) )
      then txt;

    case ( txt,
           i_comps__str )
      equation
        txt = Tpl.writeText(txt, i_comps__str);
      then txt;
  end match;
end fun_118;

protected function fun_119
  input Tpl.Text in_txt;
  input MMToJuliaUtil.Context in_a_context;
  input Tpl.Text in_a_comps__str__no__local;
  input Tpl.Text in_a_comps__str;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_context, in_a_comps__str__no__local, in_a_comps__str)
    local
      Tpl.Text txt;
      Tpl.Text a_comps__str__no__local;
      Tpl.Text a_comps__str;

    case ( txt,
           MMToJuliaUtil.FUNCTION(retValsStr = _),
           _,
           a_comps__str )
      equation
        txt = fun_118(txt, a_comps__str);
      then txt;

    case ( txt,
           MMToJuliaUtil.UNIONTYPE(name = _),
           a_comps__str__no__local,
           _ )
      equation
        txt = Tpl.writeText(txt, a_comps__str__no__local);
      then txt;

    case ( txt,
           MMToJuliaUtil.PACKAGE(),
           a_comps__str__no__local,
           _ )
      equation
        txt = Tpl.writeText(txt, a_comps__str__no__local);
      then txt;

    case ( txt,
           _,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("ERROR"));
      then txt;
  end match;
end fun_119;

public function dumpElementSpec
  input Tpl.Text in_txt;
  input Absyn.ElementSpec in_a_specification;
  input Dump.DumpOptions in_a_options;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_specification, in_a_options, in_a_context)
    local
      Tpl.Text txt;
      Dump.DumpOptions a_options;
      MMToJuliaUtil.Context a_context;
      Absyn.Import i_import__;
      list<Absyn.ComponentItem> i_components;
      Absyn.ElementSpec i_specification;
      Absyn.TypeSpec i_typeSpec;
      Absyn.ElementAttributes i_attributes;
      Option<Absyn.Annotation> i_annotationOpt;
      list<Absyn.ElementArg> i_elementArg;
      Absyn.Path i_path;
      Absyn.Class i_class__;
      Tpl.Text l_imp__str;
      Tpl.Text l_rStr;
      Boolean ret_9;
      Tpl.Text l_comps__str__no__local;
      Boolean ret_7;
      Tpl.Text l_comps__str;
      Tpl.Text l_ty__str;
      Tpl.Text l_attr__str;
      Tpl.Text l_ann__str;
      Tpl.Text l_mod__str;
      Tpl.Text l_args__str;
      Tpl.Text l_bc__str;

    case ( txt,
           Absyn.CLASSDEF(class_ = i_class__),
           a_options,
           a_context )
      equation
        txt = dumpClassElement(txt, i_class__, a_options, a_context);
      then txt;

    case ( txt,
           Absyn.EXTENDS(path = i_path, elementArg = i_elementArg, annotationOpt = i_annotationOpt),
           _,
           a_context )
      equation
        l_bc__str = dumpPathJL(Tpl.emptyTxt, i_path);
        l_args__str = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_args__str = lm_110(l_args__str, i_elementArg, a_context);
        l_args__str = Tpl.popIter(l_args__str);
        l_mod__str = fun_111(Tpl.emptyTxt, l_args__str);
        l_ann__str = dumpAnnotationOptSpace(Tpl.emptyTxt, i_annotationOpt, a_context);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("extends "));
        txt = Tpl.writeText(txt, l_bc__str);
        txt = Tpl.writeText(txt, l_mod__str);
        txt = Tpl.writeText(txt, l_ann__str);
      then txt;

    case ( txt,
           (i_specification as Absyn.COMPONENTS(attributes = i_attributes, typeSpec = i_typeSpec, components = i_components)),
           _,
           a_context )
      equation
        l_attr__str = dumpElementAttr(Tpl.emptyTxt, i_attributes);
        l_ty__str = dumpTypeSpec(Tpl.emptyTxt, i_typeSpec, a_context);
        ret_7 = MMToJuliaUtil.elementSpecIsOUTPUT_OR_BIDIR(i_specification);
        l_comps__str = fun_113(Tpl.emptyTxt, ret_7, l_ty__str, i_components);
        ret_9 = MMToJuliaUtil.elementSpecIsOUTPUT_OR_BIDIR(i_specification);
        l_comps__str__no__local = fun_116(Tpl.emptyTxt, ret_9, l_ty__str, a_context, i_components);
        l_rStr = fun_117(Tpl.emptyTxt, a_context);
        txt = fun_119(txt, a_context, l_comps__str__no__local, l_comps__str);
      then txt;

    case ( txt,
           Absyn.IMPORT(import_ = i_import__),
           _,
           _ )
      equation
        l_imp__str = dumpImport(Tpl.emptyTxt, i_import__);
        txt = Tpl.writeText(txt, l_imp__str);
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end dumpElementSpec;

protected function lm_121
  input Tpl.Text in_txt;
  input list<Absyn.ComponentItem> in_items;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_context)
    local
      Tpl.Text txt;
      list<Absyn.ComponentItem> rest;
      MMToJuliaUtil.Context a_context;
      Absyn.ComponentItem i_comp;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_comp :: rest,
           a_context )
      equation
        txt = dumpComponentItem(txt, i_comp, a_context);
        txt = Tpl.nextIter(txt);
        txt = lm_121(txt, rest, a_context);
      then txt;
  end match;
end lm_121;

protected function fun_122
  input Tpl.Text in_txt;
  input Absyn.ElementSpec in_a_specification;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_specification, in_a_context)
    local
      Tpl.Text txt;
      MMToJuliaUtil.Context a_context;
      list<Absyn.ComponentItem> i_components;
      Tpl.Text l_comps__str;

    case ( txt,
           Absyn.COMPONENTS(components = i_components),
           a_context )
      equation
        l_comps__str = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_comps__str = lm_121(l_comps__str, i_components, a_context);
        l_comps__str = Tpl.popIter(l_comps__str);
        txt = Tpl.writeText(txt, l_comps__str);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_122;

public function dumpElementSpecForComponents
  input Tpl.Text txt;
  input Absyn.ElementSpec a_specification;
  input Dump.DumpOptions a_options;
  input MMToJuliaUtil.Context a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_122(txt, a_specification, a_context);
end dumpElementSpecForComponents;

public function dumpElementAttr
  input Tpl.Text in_txt;
  input Absyn.ElementAttributes in_a_attr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_attr)
    local
      Tpl.Text txt;
      Absyn.Variability i_variability;
      Tpl.Text l_var__str;

    case ( txt,
           Absyn.ATTR(variability = i_variability) )
      equation
        l_var__str = dumpVariability(Tpl.emptyTxt, i_variability);
        txt = Tpl.writeText(txt, l_var__str);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end dumpElementAttr;

public function dumpVariability
  input Tpl.Text in_txt;
  input Absyn.Variability in_a_var;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_var)
    local
      Tpl.Text txt;

    case ( txt,
           Absyn.VAR() )
      then txt;

    case ( txt,
           Absyn.CONST() )
      then txt;

    case ( txt,
           _ )
      equation
        txt = AbsynDumpTpl.errorMsg(txt, "AbsynToJulia.dumpVariability: Only const and var are supported");
      then txt;
  end match;
end dumpVariability;

protected function lm_126
  input Tpl.Text in_txt;
  input list<Absyn.ElementArg> in_items;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_context)
    local
      Tpl.Text txt;
      list<Absyn.ElementArg> rest;
      MMToJuliaUtil.Context a_context;
      Absyn.ElementArg i_e;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_e :: rest,
           a_context )
      equation
        txt = dumpElementArg(txt, i_e, a_context);
        txt = Tpl.nextIter(txt);
        txt = lm_126(txt, rest, a_context);
      then txt;
  end match;
end lm_126;

protected function fun_127
  input Tpl.Text in_txt;
  input list<Absyn.ElementArg> in_a_el;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_el, in_a_context)
    local
      Tpl.Text txt;
      MMToJuliaUtil.Context a_context;
      list<Absyn.ElementArg> i_el;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_el,
           a_context )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_126(txt, i_el, a_context);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;
  end match;
end fun_127;

public function dumpConstrainClass
  input Tpl.Text in_txt;
  input Absyn.ConstrainClass in_a_cc;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_cc, in_a_context)
    local
      Tpl.Text txt;
      MMToJuliaUtil.Context a_context;
      Option<Absyn.Comment> i_comment;
      list<Absyn.ElementArg> i_el;
      Absyn.Path i_p;
      Tpl.Text l_cmt__str;
      Tpl.Text l_el__str;
      Tpl.Text l_path__str;

    case ( txt,
           Absyn.CONSTRAINCLASS(elementSpec = Absyn.EXTENDS(path = i_p, elementArg = i_el), comment = i_comment),
           a_context )
      equation
        l_path__str = dumpPathJL(Tpl.emptyTxt, i_p);
        l_el__str = fun_127(Tpl.emptyTxt, i_el, a_context);
        l_cmt__str = dumpCommentOpt(Tpl.emptyTxt, i_comment, a_context);
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("constrainedby "));
        txt = Tpl.writeText(txt, l_path__str);
        txt = Tpl.writeText(txt, l_el__str);
        txt = Tpl.writeText(txt, l_cmt__str);
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end dumpConstrainClass;

protected function lm_129
  input Tpl.Text in_txt;
  input list<Absyn.ComponentItem> in_items;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_context)
    local
      Tpl.Text txt;
      list<Absyn.ComponentItem> rest;
      MMToJuliaUtil.Context a_context;
      Absyn.ComponentItem i_ci;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_ci :: rest,
           a_context )
      equation
        txt = dumpComponentItemWithoutCondString(txt, i_ci, a_context);
        txt = Tpl.nextIter(txt);
        txt = lm_129(txt, rest, a_context);
      then txt;
  end match;
end lm_129;

public function dumpComponentItems
  input Tpl.Text txt;
  input list<Absyn.ComponentItem> a_componentItems;
  input MMToJuliaUtil.Context a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt := Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_129(out_txt, a_componentItems, a_context);
  out_txt := Tpl.popIter(out_txt);
end dumpComponentItems;

public function dumpComponentItem
  input Tpl.Text in_txt;
  input Absyn.ComponentItem in_a_comp;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_comp, in_a_context)
    local
      Tpl.Text txt;
      MMToJuliaUtil.Context a_context;
      Option<Absyn.Comment> i_comment;
      Option<Absyn.ComponentCondition> i_condition;
      Absyn.Component i_component;
      Tpl.Text l_cmt;
      Tpl.Text l_cond__str;
      Tpl.Text l_comp__str;

    case ( txt,
           Absyn.COMPONENTITEM(component = i_component, condition = i_condition, comment = i_comment),
           a_context )
      equation
        l_comp__str = dumpComponent(Tpl.emptyTxt, i_component, a_context);
        l_cond__str = dumpComponentCondition(Tpl.emptyTxt, i_condition, a_context);
        l_cmt = dumpCommentOpt(Tpl.emptyTxt, i_comment, a_context);
        txt = Tpl.writeText(txt, l_comp__str);
        txt = Tpl.writeText(txt, l_cond__str);
        txt = Tpl.writeText(txt, l_cmt);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end dumpComponentItem;

public function dumpComponentItemWithoutCondString
  input Tpl.Text in_txt;
  input Absyn.ComponentItem in_a_comp;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_comp, in_a_context)
    local
      Tpl.Text txt;
      MMToJuliaUtil.Context a_context;
      Option<Absyn.Comment> i_comment;
      Absyn.Component i_component;
      Tpl.Text l_cmt;
      Tpl.Text l_comp__str;

    case ( txt,
           Absyn.COMPONENTITEM(component = i_component, comment = i_comment),
           a_context )
      equation
        l_comp__str = dumpComponent(Tpl.emptyTxt, i_component, a_context);
        l_cmt = dumpCommentOpt(Tpl.emptyTxt, i_comment, a_context);
        txt = Tpl.writeText(txt, l_comp__str);
        txt = Tpl.writeText(txt, l_cmt);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end dumpComponentItemWithoutCondString;

protected function fun_133
  input Tpl.Text in_txt;
  input Option<Absyn.Modification> in_a_modification;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modification, in_a_context)
    local
      Tpl.Text txt;
      MMToJuliaUtil.Context a_context;
      Absyn.Modification i_mod;

    case ( txt,
           SOME(i_mod),
           a_context )
      equation
        txt = dumpModification(txt, i_mod, a_context);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_133;

protected function fun_134
  input Tpl.Text in_txt;
  input MMToJuliaUtil.Context in_a_context;
  input Tpl.Text in_a_mod__str;
  input Tpl.Text in_a_dim__str;
  input Tpl.Text in_a_component__name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_context, in_a_mod__str, in_a_dim__str, in_a_component__name)
    local
      Tpl.Text txt;
      Tpl.Text a_mod__str;
      Tpl.Text a_dim__str;
      Tpl.Text a_component__name;
      String i_ty__str;

    case ( txt,
           MMToJuliaUtil.FUNCTION_RETURN_CONTEXT(ty_str = i_ty__str),
           a_mod__str,
           a_dim__str,
           a_component__name )
      equation
        txt = Tpl.writeText(txt, a_component__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("::"));
        txt = Tpl.writeStr(txt, i_ty__str);
        txt = Tpl.writeText(txt, a_dim__str);
        txt = Tpl.writeText(txt, a_mod__str);
      then txt;

    case ( txt,
           MMToJuliaUtil.FUNCTION(retValsStr = _),
           _,
           _,
           a_component__name )
      equation
        txt = Tpl.writeText(txt, a_component__name);
      then txt;

    case ( txt,
           MMToJuliaUtil.INPUT_CONTEXT(ty_str = i_ty__str),
           a_mod__str,
           a_dim__str,
           a_component__name )
      equation
        txt = Tpl.writeText(txt, a_component__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("::"));
        txt = Tpl.writeStr(txt, i_ty__str);
        txt = Tpl.writeText(txt, a_dim__str);
        txt = Tpl.writeText(txt, a_mod__str);
      then txt;

    case ( txt,
           _,
           a_mod__str,
           a_dim__str,
           a_component__name )
      equation
        txt = Tpl.writeText(txt, a_component__name);
        txt = Tpl.writeText(txt, a_dim__str);
        txt = Tpl.writeText(txt, a_mod__str);
      then txt;
  end match;
end fun_134;

public function dumpComponent
  input Tpl.Text in_txt;
  input Absyn.Component in_a_comp;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_comp, in_a_context)
    local
      Tpl.Text txt;
      MMToJuliaUtil.Context a_context;
      Absyn.Ident i_name;
      Option<Absyn.Modification> i_modification;
      Absyn.ArrayDim i_arrayDim;
      Tpl.Text l_component__name;
      Tpl.Text l_mod__str;
      Tpl.Text l_dim__str;

    case ( txt,
           Absyn.COMPONENT(arrayDim = i_arrayDim, modification = i_modification, name = i_name),
           a_context )
      equation
        l_dim__str = dumpSubscripts(Tpl.emptyTxt, i_arrayDim, a_context);
        l_mod__str = fun_133(Tpl.emptyTxt, i_modification, a_context);
        l_component__name = Tpl.writeStr(Tpl.emptyTxt, i_name);
        txt = fun_134(txt, a_context, l_mod__str, l_dim__str, l_component__name);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end dumpComponent;

public function dumpComponentCondition
  input Tpl.Text in_txt;
  input Option<Absyn.ComponentCondition> in_a_cond;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_cond, in_a_context)
    local
      Tpl.Text txt;
      MMToJuliaUtil.Context a_context;
      Absyn.ComponentCondition i_cexp;
      Tpl.Text l_exp__str;

    case ( txt,
           SOME(i_cexp),
           a_context )
      equation
        l_exp__str = dumpExp(Tpl.emptyTxt, i_cexp, a_context);
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if "));
        txt = Tpl.writeText(txt, l_exp__str);
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end dumpComponentCondition;

protected function fun_137
  input Tpl.Text in_txt;
  input String in_mArg;
  input Tpl.Text in_a_path__str;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_path__str)
    local
      Tpl.Text txt;
      Tpl.Text a_path__str;

    case ( txt,
           "Array",
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("import ArrayUtil"));
      then txt;

    case ( txt,
           "List",
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("import ListUtil"));
      then txt;

    case ( txt,
           _,
           a_path__str )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("import "));
        txt = Tpl.writeText(txt, a_path__str);
      then txt;
  end match;
end fun_137;

protected function lm_138
  input Tpl.Text in_txt;
  input list<Absyn.GroupImport> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<Absyn.GroupImport> rest;
      Absyn.GroupImport i_group;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_group :: rest )
      equation
        txt = dumpGroupImport(txt, i_group);
        txt = Tpl.nextIter(txt);
        txt = lm_138(txt, rest);
      then txt;
  end match;
end lm_138;

public function dumpImport
  input Tpl.Text in_txt;
  input Absyn.Import in_a_imp;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_imp)
    local
      Tpl.Text txt;
      list<Absyn.GroupImport> i_groups;
      Absyn.Path i_prefix;
      Absyn.Ident i_name;
      Absyn.Path i_path;
      Tpl.Text l_groups__str;
      Tpl.Text l_prefix__str;
      String str_1;
      Tpl.Text l_path__str;

    case ( txt,
           Absyn.NAMED_IMPORT(path = i_path, name = i_name) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("import "));
        txt = dumpPathJL(txt, i_path);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("; "));
        txt = Tpl.writeStr(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("="));
        txt = dumpPathJL(txt, i_path);
      then txt;

    case ( txt,
           Absyn.QUAL_IMPORT(path = i_path) )
      equation
        l_path__str = dumpPathJL(Tpl.emptyTxt, i_path);
        str_1 = Tpl.textString(l_path__str);
        txt = fun_137(txt, str_1, l_path__str);
      then txt;

    case ( txt,
           Absyn.UNQUAL_IMPORT(path = i_path) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("using "));
        txt = dumpPathJL(txt, i_path);
      then txt;

    case ( txt,
           Absyn.GROUP_IMPORT(prefix = i_prefix, groups = i_groups) )
      equation
        l_prefix__str = dumpPathJL(Tpl.emptyTxt, i_prefix);
        l_groups__str = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_groups__str = lm_138(l_groups__str, i_groups);
        l_groups__str = Tpl.popIter(l_groups__str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("using "));
        txt = Tpl.writeText(txt, l_prefix__str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(": "));
        txt = Tpl.writeText(txt, l_groups__str);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end dumpImport;

public function dumpGroupImport
  input Tpl.Text in_txt;
  input Absyn.GroupImport in_a_gimp;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_gimp)
    local
      Tpl.Text txt;
      String i_rename;
      String i_name;

    case ( txt,
           Absyn.GROUP_IMPORT_NAME(name = i_name) )
      equation
        txt = Tpl.writeStr(txt, i_name);
      then txt;

    case ( txt,
           Absyn.GROUP_IMPORT_RENAME(rename = i_rename, name = i_name) )
      equation
        txt = Tpl.writeStr(txt, i_rename);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeStr(txt, i_name);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end dumpGroupImport;

public function dumpEquation
  input Tpl.Text txt;
  input Absyn.Equation a_eq;

  output Tpl.Text out_txt;
algorithm
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING("No equations allowed. Translate them to algorithms"));
end dumpEquation;

protected function lm_142
  input Tpl.Text in_txt;
  input list<Absyn.AlgorithmItem> in_items;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_context)
    local
      Tpl.Text txt;
      list<Absyn.AlgorithmItem> rest;
      MMToJuliaUtil.Context a_context;
      Absyn.AlgorithmItem i_alg;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_alg :: rest,
           a_context )
      equation
        txt = dumpAlgorithmItem(txt, i_alg, a_context);
        txt = Tpl.nextIter(txt);
        txt = lm_142(txt, rest, a_context);
      then txt;
  end match;
end lm_142;

public function dumpAlgorithmItems
  input Tpl.Text txt;
  input list<Absyn.AlgorithmItem> a_algs;
  input MMToJuliaUtil.Context a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt := Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_142(out_txt, a_algs, a_context);
  out_txt := Tpl.popIter(out_txt);
end dumpAlgorithmItems;

public function dumpAlgorithmItem
  input Tpl.Text in_txt;
  input Absyn.AlgorithmItem in_a_alg;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_alg, in_a_context)
    local
      Tpl.Text txt;
      MMToJuliaUtil.Context a_context;
      String i_comment_1;
      Option<Absyn.Comment> i_comment;
      Absyn.Algorithm i_algorithm__;
      Tpl.Text l_cmt__str;
      Tpl.Text l_alg__str;

    case ( txt,
           Absyn.ALGORITHMITEM(algorithm_ = i_algorithm__, comment = i_comment),
           a_context )
      equation
        l_alg__str = dumpAlgorithm(Tpl.emptyTxt, i_algorithm__, a_context);
        l_cmt__str = dumpCommentOpt(Tpl.emptyTxt, i_comment, a_context);
        txt = Tpl.writeText(txt, l_alg__str);
        txt = Tpl.writeText(txt, l_cmt__str);
      then txt;

    case ( txt,
           Absyn.ALGORITHMITEMCOMMENT(comment = i_comment_1),
           _ )
      equation
        txt = dumpCommentStr(txt, i_comment_1);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end dumpAlgorithmItem;

protected function fun_145
  input Tpl.Text in_txt;
  input Absyn.Exp in_a_assignComponent;
  input Tpl.Text in_a_rhs__str;
  input Tpl.Text in_a_lhs__str;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_assignComponent, in_a_rhs__str, in_a_lhs__str)
    local
      Tpl.Text txt;
      Tpl.Text a_rhs__str;
      Tpl.Text a_lhs__str;

    case ( txt,
           Absyn.CONS(head = _),
           a_rhs__str,
           a_lhs__str )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("@match "));
        txt = Tpl.writeText(txt, a_lhs__str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, a_rhs__str);
      then txt;

    case ( txt,
           _,
           a_rhs__str,
           a_lhs__str )
      equation
        txt = Tpl.writeText(txt, a_lhs__str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, a_rhs__str);
      then txt;
  end match;
end fun_145;

protected function fun_146
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Absyn.Exp in_a_assignComponent;
  input Tpl.Text in_a_rhs__str;
  input Tpl.Text in_a_lhs__str;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_assignComponent, in_a_rhs__str, in_a_lhs__str)
    local
      Tpl.Text txt;
      Absyn.Exp a_assignComponent;
      Tpl.Text a_rhs__str;
      Tpl.Text a_lhs__str;

    case ( txt,
           false,
           _,
           a_rhs__str,
           a_lhs__str )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("@match "));
        txt = Tpl.writeText(txt, a_lhs__str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, a_rhs__str);
      then txt;

    case ( txt,
           _,
           a_assignComponent,
           a_rhs__str,
           a_lhs__str )
      equation
        txt = fun_145(txt, a_assignComponent, a_rhs__str, a_lhs__str);
      then txt;
  end match;
end fun_146;

protected function lm_147
  input Tpl.Text in_txt;
  input list<tuple<Absyn.Exp, list<Absyn.AlgorithmItem>>> in_items;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_context)
    local
      Tpl.Text txt;
      list<tuple<Absyn.Exp, list<Absyn.AlgorithmItem>>> rest;
      MMToJuliaUtil.Context a_context;
      list<Absyn.AlgorithmItem> i_b;
      Absyn.Exp i_c;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           (i_c, i_b) :: rest,
           a_context )
      equation
        txt = dumpAlgorithmBranch(txt, i_c, i_b, "elseif", a_context);
        txt = Tpl.nextIter(txt);
        txt = lm_147(txt, rest, a_context);
      then txt;
  end match;
end lm_147;

protected function fun_148
  input Tpl.Text in_txt;
  input Tpl.Text in_a_else__branch__str;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_else__branch__str)
    local
      Tpl.Text txt;
      Tpl.Text i_else__branch__str;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}) )
      then txt;

    case ( txt,
           i_else__branch__str )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("else\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, i_else__branch__str);
        txt = Tpl.popBlock(txt);
      then txt;
  end match;
end fun_148;

protected function fun_149
  input Tpl.Text in_txt;
  input list<Absyn.AlgorithmItem> in_a_equ;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_equ, in_a_context)
    local
      Tpl.Text txt;
      MMToJuliaUtil.Context a_context;
      list<Absyn.AlgorithmItem> i_equ;

    case ( txt,
           {},
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("..."));
      then txt;

    case ( txt,
           i_equ,
           a_context )
      equation
        txt = dumpAlgorithmItems(txt, i_equ, a_context);
      then txt;
  end match;
end fun_149;

public function dumpAlgorithm
  input Tpl.Text in_txt;
  input Absyn.Algorithm in_a_alg;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_alg, in_a_context)
    local
      Tpl.Text txt;
      MMToJuliaUtil.Context a_context;
      list<Absyn.AlgorithmItem> i_elseBody;
      list<Absyn.AlgorithmItem> i_body;
      list<Absyn.AlgorithmItem> i_equ;
      Absyn.FunctionArgs i_functionArgs;
      Absyn.ComponentRef i_functionCall;
      list<Absyn.AlgorithmItem> i_whileBody;
      Absyn.Exp i_boolExpr;
      list<Absyn.AlgorithmItem> i_forBody;
      Absyn.ForIterators i_iterators;
      list<Absyn.AlgorithmItem> i_elseBranch;
      list<tuple<Absyn.Exp, list<Absyn.AlgorithmItem>>> i_elseIfAlgorithmBranch;
      list<Absyn.AlgorithmItem> i_trueBranch;
      Absyn.Exp i_ifExp;
      Absyn.Exp i_value;
      Absyn.Exp i_assignComponent;
      Tpl.Text l_arg2;
      Tpl.Text l_arg1;
      Tpl.Text l_arg__str;
      Tpl.Text l_args__str;
      Tpl.Text l_name__str;
      Tpl.Text l_while__str;
      Tpl.Text l_body__str;
      Tpl.Text l_iter__str;
      Tpl.Text l_else__str;
      Tpl.Text l_else__branch__str;
      Tpl.Text l_elseif__str;
      Tpl.Text l_if__str;
      Boolean ret_3;
      Tpl.Text l_rhs__str;
      MMToJuliaUtil.Context ret_1;
      Tpl.Text l_lhs__str;

    case ( txt,
           Absyn.ALG_ASSIGN(assignComponent = i_assignComponent, value = i_value),
           a_context )
      equation
        ret_1 = MMToJuliaUtil.makeFunctionContext("listMatchAssign");
        l_lhs__str = dumpLhsExp(Tpl.emptyTxt, i_assignComponent, ret_1);
        l_rhs__str = dumpExp(Tpl.emptyTxt, i_value, a_context);
        ret_3 = AbsynUtil.complexIsCref(i_assignComponent);
        txt = fun_146(txt, ret_3, i_assignComponent, l_rhs__str, l_lhs__str);
      then txt;

    case ( txt,
           Absyn.ALG_IF(ifExp = i_ifExp, trueBranch = i_trueBranch, elseIfAlgorithmBranch = i_elseIfAlgorithmBranch, elseBranch = i_elseBranch),
           a_context )
      equation
        l_if__str = dumpAlgorithmBranch(Tpl.emptyTxt, i_ifExp, i_trueBranch, "if", a_context);
        l_elseif__str = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_elseif__str = lm_147(l_elseif__str, i_elseIfAlgorithmBranch, a_context);
        l_elseif__str = Tpl.popIter(l_elseif__str);
        l_else__branch__str = dumpAlgorithmItems(Tpl.emptyTxt, i_elseBranch, a_context);
        l_else__str = fun_148(Tpl.emptyTxt, l_else__branch__str);
        txt = Tpl.writeText(txt, l_if__str);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_elseif__str);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_else__str);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("end"));
      then txt;

    case ( txt,
           Absyn.ALG_FOR(iterators = i_iterators, forBody = i_forBody),
           a_context )
      equation
        l_iter__str = dumpForIterators(Tpl.emptyTxt, i_iterators, a_context);
        l_body__str = dumpAlgorithmItems(Tpl.emptyTxt, i_forBody, a_context);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("for "));
        txt = Tpl.writeText(txt, l_iter__str);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_body__str);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("end"));
      then txt;

    case ( txt,
           Absyn.ALG_WHILE(boolExpr = i_boolExpr, whileBody = i_whileBody),
           a_context )
      equation
        l_while__str = dumpAlgorithmBranch(Tpl.emptyTxt, i_boolExpr, i_whileBody, "while", a_context);
        txt = Tpl.writeText(txt, l_while__str);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("end"));
      then txt;

    case ( txt,
           Absyn.ALG_WHEN_A(boolExpr = _),
           _ )
      equation
        txt = AbsynDumpTpl.errorMsg(txt, "When statements are not allowed!.");
      then txt;

    case ( txt,
           Absyn.ALG_NORETCALL(functionCall = i_functionCall, functionArgs = i_functionArgs),
           a_context )
      equation
        l_name__str = dumpCref(Tpl.emptyTxt, i_functionCall, a_context);
        l_args__str = dumpFunctionArgs(Tpl.emptyTxt, i_functionArgs, a_context);
        txt = Tpl.writeText(txt, l_name__str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, l_args__str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           Absyn.ALG_RETURN(),
           a_context )
      equation
        txt = dumpAlgReturnString(txt, a_context);
      then txt;

    case ( txt,
           Absyn.ALG_BREAK(),
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("break"));
      then txt;

    case ( txt,
           Absyn.ALG_FAILURE(equ = i_equ),
           a_context )
      equation
        l_arg__str = fun_149(Tpl.emptyTxt, i_equ, a_context);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("@shouldFail "));
        txt = Tpl.writeText(txt, l_arg__str);
      then txt;

    case ( txt,
           Absyn.ALG_TRY(body = i_body, elseBody = i_elseBody),
           a_context )
      equation
        l_arg1 = dumpAlgorithmItems(Tpl.emptyTxt, i_body, a_context);
        l_arg2 = dumpAlgorithmItems(Tpl.emptyTxt, i_elseBody, a_context);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("try\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_arg1);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("catch\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_arg2);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("end"));
      then txt;

    case ( txt,
           Absyn.ALG_CONTINUE(),
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("continue"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end dumpAlgorithm;

public function dumpAlgReturnString
  input Tpl.Text in_txt;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_context)
    local
      Tpl.Text txt;
      String i_retValsStr;

    case ( txt,
           MMToJuliaUtil.FUNCTION(retValsStr = i_retValsStr) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("return "));
        txt = Tpl.writeStr(txt, i_retValsStr);
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("return"));
      then txt;
  end match;
end dumpAlgReturnString;

protected function lm_152
  input Tpl.Text in_txt;
  input list<Absyn.AlgorithmItem> in_items;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_context)
    local
      Tpl.Text txt;
      list<Absyn.AlgorithmItem> rest;
      MMToJuliaUtil.Context a_context;
      Absyn.AlgorithmItem i_eq;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_eq :: rest,
           a_context )
      equation
        txt = dumpAlgorithmItem(txt, i_eq, a_context);
        txt = Tpl.nextIter(txt);
        txt = lm_152(txt, rest, a_context);
      then txt;
  end match;
end lm_152;

public function dumpAlgorithmBranch
  input Tpl.Text txt;
  input Absyn.Exp a_cond;
  input list<Absyn.AlgorithmItem> a_body;
  input String a_header;
  input MMToJuliaUtil.Context a_context;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_body__str;
  Tpl.Text l_cond__str;
algorithm
  l_cond__str := dumpExp(Tpl.emptyTxt, a_cond, a_context);
  l_body__str := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  l_body__str := lm_152(l_body__str, a_body, a_context);
  l_body__str := Tpl.popIter(l_body__str);
  out_txt := Tpl.writeStr(txt, a_header);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING(" "));
  out_txt := Tpl.writeText(out_txt, l_cond__str);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeText(out_txt, l_body__str);
  out_txt := Tpl.popBlock(out_txt);
end dumpAlgorithmBranch;

protected function fun_154
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Absyn.Path in_a_path;
  input Absyn.Ident in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_path, in_a_name)
    local
      Tpl.Text txt;
      Absyn.Path a_path;
      Absyn.Ident a_name;

    case ( txt,
           false,
           a_path,
           a_name )
      equation
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("."));
        txt = AbsynDumpTpl.dumpPath(txt, a_path);
      then txt;

    case ( txt,
           _,
           a_path,
           a_name )
      equation
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("__"));
        txt = AbsynDumpTpl.dumpPath(txt, a_path);
      then txt;
  end match;
end fun_154;

protected function fun_155
  input Tpl.Text in_txt;
  input Absyn.Ident in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_name)
    local
      Tpl.Text txt;
      Absyn.Ident i_name;

    case ( txt,
           "Real" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Float"));
      then txt;

    case ( txt,
           "Integer" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Integer"));
      then txt;

    case ( txt,
           "Boolean" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Bool"));
      then txt;

    case ( txt,
           "list" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("List"));
      then txt;

    case ( txt,
           "array" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Array"));
      then txt;

    case ( txt,
           "tuple" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Tuple"));
      then txt;

    case ( txt,
           "polymorphic" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Any"));
      then txt;

    case ( txt,
           "Mutable" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("MutableType"));
      then txt;

    case ( txt,
           i_name )
      equation
        txt = Tpl.writeStr(txt, i_name);
      then txt;
  end match;
end fun_155;

public function dumpPathJL
  input Tpl.Text in_txt;
  input Absyn.Path in_a_path;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_path)
    local
      Tpl.Text txt;
      Absyn.Ident i_name;
      Absyn.Path i_path;
      Boolean ret_0;

    case ( txt,
           Absyn.FULLYQUALIFIED(path = i_path) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("."));
        txt = AbsynDumpTpl.dumpPath(txt, i_path);
      then txt;

    case ( txt,
           Absyn.QUALIFIED(name = i_name, path = i_path) )
      equation
        ret_0 = Flags.getConfigBool(Flags.MODELICA_OUTPUT);
        txt = fun_154(txt, ret_0, i_path, i_name);
      then txt;

    case ( txt,
           Absyn.IDENT(name = i_name) )
      equation
        txt = fun_155(txt, i_name);
      then txt;

    case ( txt,
           _ )
      equation
        txt = AbsynDumpTpl.errorMsg(txt, "AbsynToJulia.dumpPathJL: Unknown path.");
      then txt;
  end match;
end dumpPathJL;

public function dumpPathNoQual
  input Tpl.Text in_txt;
  input Absyn.Path in_a_path;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_path)
    local
      Tpl.Text txt;
      Absyn.Path i_path;

    case ( txt,
           Absyn.FULLYQUALIFIED(path = i_path) )
      equation
        txt = dumpPathJL(txt, i_path);
      then txt;

    case ( txt,
           i_path )
      equation
        txt = dumpPathJL(txt, i_path);
      then txt;
  end match;
end dumpPathNoQual;

public function dumpTypeSpecOpt
  input Tpl.Text in_txt;
  input Option<Absyn.TypeSpec> in_a_typespecOpt;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_typespecOpt, in_a_context)
    local
      Tpl.Text txt;
      MMToJuliaUtil.Context a_context;
      Absyn.TypeSpec i_ts;

    case ( txt,
           SOME(i_ts),
           a_context )
      equation
        txt = dumpTypeSpec(txt, i_ts, a_context);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end dumpTypeSpecOpt;

protected function lm_159
  input Tpl.Text in_txt;
  input list<Absyn.TypeSpec> in_items;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_context)
    local
      Tpl.Text txt;
      list<Absyn.TypeSpec> rest;
      MMToJuliaUtil.Context a_context;
      Absyn.TypeSpec i_ty;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_ty :: rest,
           a_context )
      equation
        txt = dumpTypeSpec(txt, i_ty, a_context);
        txt = Tpl.nextIter(txt);
        txt = lm_159(txt, rest, a_context);
      then txt;
  end match;
end lm_159;

protected function fun_160
  input Tpl.Text in_txt;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_context)
    local
      Tpl.Text txt;

    case ( txt,
           MMToJuliaUtil.INPUT_CONTEXT(ty_str = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("iofunc"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_160;

protected function fun_161
  input Tpl.Text in_txt;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_context)
    local
      Tpl.Text txt;

    case ( txt,
           MMToJuliaUtil.PACKAGE() )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("package"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_161;

protected function fun_162
  input Tpl.Text in_txt;
  input Tpl.Text in_a_isPackage;
  input Tpl.Text in_a_arraydim__str;
  input Tpl.Text in_a_ty__str;
  input Tpl.Text in_a_path__str;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_isPackage, in_a_arraydim__str, in_a_ty__str, in_a_path__str)
    local
      Tpl.Text txt;
      Tpl.Text a_arraydim__str;
      Tpl.Text a_ty__str;
      Tpl.Text a_path__str;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           a_arraydim__str,
           a_ty__str,
           a_path__str )
      equation
        txt = Tpl.writeText(txt, a_path__str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("{"));
        txt = Tpl.writeText(txt, a_ty__str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
        txt = Tpl.writeText(txt, a_arraydim__str);
      then txt;

    case ( txt,
           _,
           _,
           _,
           a_path__str )
      equation
        txt = Tpl.writeText(txt, a_path__str);
      then txt;
  end match;
end fun_162;

protected function fun_163
  input Tpl.Text in_txt;
  input Tpl.Text in_a_isFunc;
  input Tpl.Text in_a_res;
  input Tpl.Text in_a_arraydim__str;
  input Tpl.Text in_a_ty__str;
  input Tpl.Text in_a_path__str;
  input Tpl.Text in_a_isPackage;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_isFunc, in_a_res, in_a_arraydim__str, in_a_ty__str, in_a_path__str, in_a_isPackage)
    local
      Tpl.Text txt;
      Tpl.Text a_res;
      Tpl.Text a_arraydim__str;
      Tpl.Text a_ty__str;
      Tpl.Text a_path__str;
      Tpl.Text a_isPackage;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           _,
           a_arraydim__str,
           a_ty__str,
           a_path__str,
           a_isPackage )
      equation
        txt = fun_162(txt, a_isPackage, a_arraydim__str, a_ty__str, a_path__str);
      then txt;

    case ( txt,
           _,
           a_res,
           _,
           _,
           _,
           _ )
      equation
        txt = Tpl.writeText(txt, a_res);
      then txt;
  end match;
end fun_163;

public function dumpTypeSpec
  input Tpl.Text in_txt;
  input Absyn.TypeSpec in_a_typeSpec;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_typeSpec, in_a_context)
    local
      Tpl.Text txt;
      MMToJuliaUtil.Context a_context;
      list<Absyn.TypeSpec> i_typeSpecs;
      Option<Absyn.ArrayDim> i_arrayDim;
      Absyn.Path i_path;
      Tpl.Text l_res;
      Tpl.Text l_ty__str2;
      Tpl.Text l_isPackage;
      Tpl.Text l_isFunc;
      Tpl.Text l_ty__str;
      Tpl.Text l_arraydim__str;
      Tpl.Text l_path__str;

    case ( txt,
           Absyn.TPATH(path = i_path, arrayDim = i_arrayDim),
           a_context )
      equation
        l_path__str = dumpPathJL(Tpl.emptyTxt, i_path);
        l_arraydim__str = dumpArrayDimOpt(Tpl.emptyTxt, i_arrayDim, a_context);
        txt = Tpl.writeText(txt, l_path__str);
        txt = Tpl.writeText(txt, l_arraydim__str);
      then txt;

    case ( txt,
           Absyn.TCOMPLEX(path = i_path, typeSpecs = i_typeSpecs, arrayDim = i_arrayDim),
           a_context )
      equation
        l_path__str = dumpPathJL(Tpl.emptyTxt, i_path);
        l_ty__str = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_ty__str = lm_159(l_ty__str, i_typeSpecs, a_context);
        l_ty__str = Tpl.popIter(l_ty__str);
        l_arraydim__str = dumpArrayDimOpt(Tpl.emptyTxt, i_arrayDim, a_context);
        l_isFunc = fun_160(Tpl.emptyTxt, a_context);
        l_isPackage = fun_161(Tpl.emptyTxt, a_context);
        l_ty__str2 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("{<:"));
        l_ty__str2 = Tpl.writeText(l_ty__str2, l_ty__str);
        l_ty__str2 = Tpl.writeTok(l_ty__str2, Tpl.ST_STRING("}"));
        l_res = Tpl.writeText(Tpl.emptyTxt, l_path__str);
        l_res = Tpl.writeText(l_res, l_ty__str2);
        l_res = Tpl.writeText(l_res, l_arraydim__str);
        txt = fun_163(txt, l_isFunc, l_res, l_arraydim__str, l_ty__str, l_path__str, l_isPackage);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end dumpTypeSpec;

public function dumpArrayDimOptTypeSpec
  input Tpl.Text in_txt;
  input Option<Absyn.ArrayDim> in_a_arraydim;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_arraydim, in_a_context)
    local
      Tpl.Text txt;
      MMToJuliaUtil.Context a_context;
      Absyn.ArrayDim i_ad;

    case ( txt,
           SOME(i_ad),
           a_context )
      equation
        txt = dumpSubscriptsTypeSpec(txt, i_ad, a_context);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end dumpArrayDimOptTypeSpec;

protected function lm_166
  input Tpl.Text in_txt;
  input list<Absyn.Subscript> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<Absyn.Subscript> rest;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Array"));
        txt = Tpl.nextIter(txt);
        txt = lm_166(txt, rest);
      then txt;
  end match;
end lm_166;

protected function fun_167
  input Tpl.Text in_txt;
  input list<Absyn.Subscript> in_a_subscripts;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_subscripts)
    local
      Tpl.Text txt;
      list<Absyn.Subscript> i_subscripts;
      Tpl.Text l_sub__str;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_subscripts )
      equation
        l_sub__str = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_sub__str = lm_166(l_sub__str, i_subscripts);
        l_sub__str = Tpl.popIter(l_sub__str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Array{"));
        txt = Tpl.writeText(txt, l_sub__str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;
  end match;
end fun_167;

public function dumpSubscriptsTypeSpec
  input Tpl.Text txt;
  input list<Absyn.Subscript> a_subscripts;
  input MMToJuliaUtil.Context a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_167(txt, a_subscripts);
end dumpSubscriptsTypeSpec;

public function dumpArrayDimOpt
  input Tpl.Text in_txt;
  input Option<Absyn.ArrayDim> in_a_arraydim;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_arraydim, in_a_context)
    local
      Tpl.Text txt;
      MMToJuliaUtil.Context a_context;
      Absyn.ArrayDim i_ad;

    case ( txt,
           SOME(i_ad),
           a_context )
      equation
        txt = dumpSubscripts(txt, i_ad, a_context);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end dumpArrayDimOpt;

protected function lm_170
  input Tpl.Text in_txt;
  input list<Absyn.Subscript> in_items;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_context)
    local
      Tpl.Text txt;
      list<Absyn.Subscript> rest;
      MMToJuliaUtil.Context a_context;
      Absyn.Subscript i_s;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_s :: rest,
           a_context )
      equation
        txt = dumpSubscript(txt, i_s, a_context);
        txt = Tpl.nextIter(txt);
        txt = lm_170(txt, rest, a_context);
      then txt;
  end match;
end lm_170;

public function dumpSubscripts
  input Tpl.Text in_txt;
  input list<Absyn.Subscript> in_a_subscripts;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_subscripts, in_a_context)
    local
      Tpl.Text txt;
      MMToJuliaUtil.Context a_context;
      list<Absyn.Subscript> i_subscripts;
      Tpl.Text l_sub__str;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_subscripts,
           a_context )
      equation
        l_sub__str = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_sub__str = lm_170(l_sub__str, i_subscripts, a_context);
        l_sub__str = Tpl.popIter(l_sub__str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("["));
        txt = Tpl.writeText(txt, l_sub__str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("]"));
      then txt;
  end match;
end dumpSubscripts;

public function dumpSubscript
  input Tpl.Text in_txt;
  input Absyn.Subscript in_a_subscript;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_subscript, in_a_context)
    local
      Tpl.Text txt;
      MMToJuliaUtil.Context a_context;
      Absyn.Exp i_subscript;

    case ( txt,
           Absyn.NOSUB(),
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(":"));
      then txt;

    case ( txt,
           Absyn.SUBSCRIPT(subscript = i_subscript),
           a_context )
      equation
        txt = dumpExp(txt, i_subscript, a_context);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end dumpSubscript;

protected function lm_173
  input Tpl.Text in_txt;
  input list<Absyn.NamedArg> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<Absyn.NamedArg> rest;
      Absyn.NamedArg i_na;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_na :: rest )
      equation
        txt = dumpNamedArgPattern3(txt, i_na);
        txt = Tpl.nextIter(txt);
        txt = lm_173(txt, rest);
      then txt;
  end match;
end lm_173;

protected function fun_174
  input Tpl.Text in_txt;
  input Absyn.FunctionArgs in_a_functionArgs;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_functionArgs)
    local
      Tpl.Text txt;
      list<Absyn.NamedArg> i_argNames;

    case ( txt,
           Absyn.FUNCTIONARGS(argNames = i_argNames) )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_173(txt, i_argNames);
        txt = Tpl.popIter(txt);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_174;

protected function lm_175
  input Tpl.Text in_txt;
  input list<Absyn.Exp> in_items;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_context)
    local
      Tpl.Text txt;
      list<Absyn.Exp> rest;
      MMToJuliaUtil.Context a_context;
      Absyn.Exp i_e;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_e :: rest,
           a_context )
      equation
        txt = dumpExp(txt, i_e, a_context);
        txt = Tpl.nextIter(txt);
        txt = lm_175(txt, rest, a_context);
      then txt;
  end match;
end lm_175;

protected function fun_176
  input Tpl.Text in_txt;
  input Tpl.Text in_a_array__str;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_array__str)
    local
      Tpl.Text txt;
      Tpl.Text i_array__str;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("nil"));
      then txt;

    case ( txt,
           i_array__str )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("list("));
        txt = Tpl.writeText(txt, i_array__str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;
  end match;
end fun_176;

protected function lm_177
  input Tpl.Text in_txt;
  input list<Absyn.Exp> in_items;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_context)
    local
      Tpl.Text txt;
      list<Absyn.Exp> rest;
      MMToJuliaUtil.Context a_context;
      Absyn.Exp i_e;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_e :: rest,
           a_context )
      equation
        txt = dumpExp(txt, i_e, a_context);
        txt = Tpl.nextIter(txt);
        txt = lm_177(txt, rest, a_context);
      then txt;
  end match;
end lm_177;

protected function lm_178
  input Tpl.Text in_txt;
  input list<list<Absyn.Exp>> in_items;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_context)
    local
      Tpl.Text txt;
      list<list<Absyn.Exp>> rest;
      MMToJuliaUtil.Context a_context;
      list<Absyn.Exp> i_row;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_row :: rest,
           a_context )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_177(txt, i_row, a_context);
        txt = Tpl.popIter(txt);
        txt = Tpl.nextIter(txt);
        txt = lm_178(txt, rest, a_context);
      then txt;
  end match;
end lm_178;

protected function lm_179
  input Tpl.Text in_txt;
  input list<Absyn.Exp> in_items;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_context)
    local
      Tpl.Text txt;
      list<Absyn.Exp> rest;
      MMToJuliaUtil.Context a_context;
      Absyn.Exp i_e;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_e :: rest,
           a_context )
      equation
        txt = dumpExp(txt, i_e, a_context);
        txt = Tpl.nextIter(txt);
        txt = lm_179(txt, rest, a_context);
      then txt;
  end match;
end lm_179;

protected function fun_180
  input Tpl.Text in_txt;
  input Tpl.Text in_a_tuple__str;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_tuple__str)
    local
      Tpl.Text txt;
      Tpl.Text i_tuple__str;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("()"));
      then txt;

    case ( txt,
           i_tuple__str )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, i_tuple__str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;
  end match;
end fun_180;

protected function lm_181
  input Tpl.Text in_txt;
  input list<Absyn.Exp> in_items;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_context)
    local
      Tpl.Text txt;
      list<Absyn.Exp> rest;
      MMToJuliaUtil.Context a_context;
      Absyn.Exp i_e;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_e :: rest,
           a_context )
      equation
        txt = dumpExp(txt, i_e, a_context);
        txt = Tpl.nextIter(txt);
        txt = lm_181(txt, rest, a_context);
      then txt;
  end match;
end lm_181;

public function dumpExp
  input Tpl.Text in_txt;
  input Absyn.Exp in_a_exp;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_exp, in_a_context)
    local
      Tpl.Text txt;
      MMToJuliaUtil.Context a_context;
      Absyn.Exp i_index;
      list<Absyn.Exp> i_exps;
      Absyn.Exp i_rest;
      Absyn.Exp i_head;
      Absyn.Ident i_id;
      Absyn.CodeNode i_code;
      list<Absyn.Exp> i_expressions;
      Absyn.Exp i_stop;
      Absyn.Exp i_step;
      Absyn.Exp i_start;
      list<list<Absyn.Exp>> i_matrix;
      list<Absyn.Exp> i_arrayExp;
      Absyn.ComponentRef i_function__;
      Absyn.FunctionArgs i_functionArgs;
      Absyn.Exp i_exp;
      Absyn.Operator i_op;
      Absyn.Exp i_exp2;
      Absyn.Exp i_e;
      Absyn.Exp i_exp1;
      Boolean i_value_2;
      Absyn.ComponentRef i_componentRef;
      String i_value_1;
      Integer i_value;
      Tpl.Text l_list__str;
      Tpl.Text l_rest__str;
      Tpl.Text l_head__str;
      Tpl.Text l_tuple__str;
      Tpl.Text l_stop__str;
      Tpl.Text l_step__str;
      Tpl.Text l_start__str;
      Tpl.Text l_matrix__str;
      Tpl.Text l_array__str;
      Tpl.Text l_args2__str;
      Tpl.Text l_func__str;
      Tpl.Text l_args__str;
      Tpl.Text l_exp__str;
      Tpl.Text l_op__str;
      Tpl.Text l_rhs__str;
      Tpl.Text l_lhs__str;
      String ret_0;

    case ( txt,
           Absyn.INTEGER(value = i_value),
           _ )
      equation
        txt = Tpl.writeStr(txt, intString(i_value));
      then txt;

    case ( txt,
           Absyn.REAL(value = i_value_1),
           _ )
      equation
        txt = Tpl.writeStr(txt, i_value_1);
      then txt;

    case ( txt,
           Absyn.CREF(componentRef = i_componentRef),
           a_context )
      equation
        txt = dumpCref(txt, i_componentRef, a_context);
      then txt;

    case ( txt,
           Absyn.STRING(value = i_value_1),
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        ret_0 = Util.escapeModelicaStringToJLString(i_value_1);
        txt = Tpl.writeStr(txt, ret_0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
      then txt;

    case ( txt,
           Absyn.BOOL(value = i_value_2),
           _ )
      equation
        txt = Tpl.writeStr(txt, Tpl.booleanString(i_value_2));
      then txt;

    case ( txt,
           (i_e as Absyn.BINARY(exp1 = i_exp1, exp2 = i_exp2, op = i_op)),
           a_context )
      equation
        l_lhs__str = dumpOperand(Tpl.emptyTxt, i_exp1, i_e, true, a_context);
        l_rhs__str = dumpOperand(Tpl.emptyTxt, i_exp2, i_e, false, a_context);
        l_op__str = dumpOperator(Tpl.emptyTxt, i_op);
        txt = Tpl.writeText(txt, l_lhs__str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, l_op__str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, l_rhs__str);
      then txt;

    case ( txt,
           (i_e as Absyn.UNARY(exp = i_exp, op = i_op)),
           a_context )
      equation
        l_exp__str = dumpOperand(Tpl.emptyTxt, i_exp, i_e, false, a_context);
        l_op__str = dumpOperator(Tpl.emptyTxt, i_op);
        txt = Tpl.writeText(txt, l_op__str);
        txt = Tpl.writeText(txt, l_exp__str);
      then txt;

    case ( txt,
           (i_e as Absyn.LBINARY(exp1 = i_exp1, exp2 = i_exp2, op = i_op)),
           a_context )
      equation
        l_lhs__str = dumpOperand(Tpl.emptyTxt, i_exp1, i_e, true, a_context);
        l_rhs__str = dumpOperand(Tpl.emptyTxt, i_exp2, i_e, false, a_context);
        l_op__str = dumpOperator(Tpl.emptyTxt, i_op);
        txt = Tpl.writeText(txt, l_lhs__str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, l_op__str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, l_rhs__str);
      then txt;

    case ( txt,
           (i_e as Absyn.LUNARY(exp = i_exp, op = i_op)),
           a_context )
      equation
        l_exp__str = dumpOperand(Tpl.emptyTxt, i_exp, i_e, false, a_context);
        l_op__str = dumpOperator(Tpl.emptyTxt, i_op);
        txt = Tpl.writeText(txt, l_op__str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, l_exp__str);
      then txt;

    case ( txt,
           (i_e as Absyn.RELATION(exp1 = i_exp1, exp2 = i_exp2, op = i_op)),
           a_context )
      equation
        l_lhs__str = dumpOperand(Tpl.emptyTxt, i_exp1, i_e, true, a_context);
        l_rhs__str = dumpOperand(Tpl.emptyTxt, i_exp2, i_e, false, a_context);
        l_op__str = dumpOperator(Tpl.emptyTxt, i_op);
        txt = Tpl.writeText(txt, l_lhs__str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, l_op__str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, l_rhs__str);
      then txt;

    case ( txt,
           (i_exp as Absyn.IFEXP(ifExp = _)),
           a_context )
      equation
        txt = dumpIfExp(txt, i_exp, a_context);
      then txt;

    case ( txt,
           Absyn.CALL(function_ = Absyn.CREF_IDENT(name = "$array"), functionArgs = i_functionArgs),
           a_context )
      equation
        l_args__str = dumpFunctionArgs(Tpl.emptyTxt, i_functionArgs, a_context);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("{"));
        txt = Tpl.writeText(txt, l_args__str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;

    case ( txt,
           Absyn.CALL(function_ = i_function__, functionArgs = i_functionArgs),
           a_context )
      equation
        l_func__str = dumpCref(Tpl.emptyTxt, i_function__, a_context);
        l_args__str = dumpFunctionArgs(Tpl.emptyTxt, i_functionArgs, a_context);
        txt = Tpl.writeText(txt, l_func__str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, l_args__str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           Absyn.PARTEVALFUNCTION(function_ = i_function__, functionArgs = i_functionArgs),
           a_context )
      equation
        l_func__str = dumpCref(Tpl.emptyTxt, i_function__, a_context);
        l_args__str = dumpFunctionArgs(Tpl.emptyTxt, i_functionArgs, a_context);
        l_args2__str = fun_174(Tpl.emptyTxt, i_functionArgs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, l_args2__str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") -> "));
        txt = Tpl.writeText(txt, l_func__str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, l_args__str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           Absyn.ARRAY(arrayExp = i_arrayExp),
           a_context )
      equation
        l_array__str = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_array__str = lm_175(l_array__str, i_arrayExp, a_context);
        l_array__str = Tpl.popIter(l_array__str);
        txt = fun_176(txt, l_array__str);
      then txt;

    case ( txt,
           Absyn.MATRIX(matrix = i_matrix),
           a_context )
      equation
        l_matrix__str = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING("; ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_matrix__str = lm_178(l_matrix__str, i_matrix, a_context);
        l_matrix__str = Tpl.popIter(l_matrix__str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("["));
        txt = Tpl.writeText(txt, l_matrix__str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("]"));
      then txt;

    case ( txt,
           (i_e as Absyn.RANGE(step = SOME(i_step), start = i_start, stop = i_stop)),
           a_context )
      equation
        l_start__str = dumpOperand(Tpl.emptyTxt, i_start, i_e, false, a_context);
        l_step__str = dumpOperand(Tpl.emptyTxt, i_step, i_e, false, a_context);
        l_stop__str = dumpOperand(Tpl.emptyTxt, i_stop, i_e, false, a_context);
        txt = Tpl.writeText(txt, l_start__str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(":"));
        txt = Tpl.writeText(txt, l_step__str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(":"));
        txt = Tpl.writeText(txt, l_stop__str);
      then txt;

    case ( txt,
           (i_e as Absyn.RANGE(step = NONE(), start = i_start, stop = i_stop)),
           a_context )
      equation
        l_start__str = dumpOperand(Tpl.emptyTxt, i_start, i_e, false, a_context);
        l_stop__str = dumpOperand(Tpl.emptyTxt, i_stop, i_e, false, a_context);
        txt = Tpl.writeText(txt, l_start__str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(":"));
        txt = Tpl.writeText(txt, l_stop__str);
      then txt;

    case ( txt,
           Absyn.TUPLE(expressions = i_expressions),
           a_context )
      equation
        l_tuple__str = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_tuple__str = lm_179(l_tuple__str, i_expressions, a_context);
        l_tuple__str = Tpl.popIter(l_tuple__str);
        txt = fun_180(txt, l_tuple__str);
      then txt;

    case ( txt,
           Absyn.END(),
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("end"));
      then txt;

    case ( txt,
           Absyn.CODE(code = i_code),
           a_context )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("$Code("));
        txt = dumpCodeNode(txt, i_code, a_context);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           Absyn.AS(exp = i_exp, id = i_id),
           a_context )
      equation
        l_exp__str = dumpExp(Tpl.emptyTxt, i_exp, a_context);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(@match "));
        txt = Tpl.writeText(txt, l_exp__str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeStr(txt, i_id);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           Absyn.CONS(head = i_head, rest = i_rest),
           a_context )
      equation
        l_head__str = dumpExp(Tpl.emptyTxt, i_head, a_context);
        l_rest__str = dumpExp(Tpl.emptyTxt, i_rest, a_context);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_cons("));
        txt = Tpl.writeText(txt, l_head__str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, l_rest__str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           (i_exp as Absyn.MATCHEXP(matchTy = _)),
           _ )
      equation
        txt = dumpMatchExp(txt, i_exp);
      then txt;

    case ( txt,
           Absyn.LIST(exps = i_exps),
           a_context )
      equation
        l_list__str = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_list__str = lm_181(l_list__str, i_exps, a_context);
        l_list__str = Tpl.popIter(l_list__str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("list("));
        txt = Tpl.writeText(txt, l_list__str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           Absyn.DOT(exp = i_exp, index = i_index),
           a_context )
      equation
        txt = dumpExp(txt, i_exp, a_context);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("."));
        txt = dumpExp(txt, i_index, a_context);
      then txt;

    case ( txt,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/* AbsynDumpTpl.dumpExp: UNHANDLED Abyn.Exp */"));
      then txt;
  end match;
end dumpExp;

protected function lm_183
  input Tpl.Text in_txt;
  input list<Absyn.Exp> in_items;
  input Tpl.Text in_a_as__str;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_as__str;
algorithm
  (out_txt, out_a_as__str) :=
  match(in_txt, in_items, in_a_as__str, in_a_context)
    local
      Tpl.Text txt;
      list<Absyn.Exp> rest;
      Tpl.Text a_as__str;
      MMToJuliaUtil.Context a_context;
      Absyn.Exp i_e;

    case ( txt,
           {},
           a_as__str,
           _ )
      then (txt, a_as__str);

    case ( txt,
           i_e :: rest,
           a_as__str,
           a_context )
      equation
        (txt, a_as__str) = dumpPattern(txt, i_e, a_context, a_as__str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" <| "));
        (txt, a_as__str) = lm_183(txt, rest, a_as__str, a_context);
      then (txt, a_as__str);
  end match;
end lm_183;

protected function lm_184
  input Tpl.Text in_txt;
  input list<Absyn.Exp> in_items;
  input Tpl.Text in_a_as__str;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_as__str;
algorithm
  (out_txt, out_a_as__str) :=
  match(in_txt, in_items, in_a_as__str, in_a_context)
    local
      Tpl.Text txt;
      list<Absyn.Exp> rest;
      Tpl.Text a_as__str;
      MMToJuliaUtil.Context a_context;
      Absyn.Exp i_e;

    case ( txt,
           {},
           a_as__str,
           _ )
      then (txt, a_as__str);

    case ( txt,
           i_e :: rest,
           a_as__str,
           a_context )
      equation
        (txt, a_as__str) = dumpPattern(txt, i_e, a_context, a_as__str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" <| "));
        (txt, a_as__str) = lm_184(txt, rest, a_as__str, a_context);
      then (txt, a_as__str);
  end match;
end lm_184;

protected function lm_185
  input Tpl.Text in_txt;
  input list<Absyn.Exp> in_items;
  input Tpl.Text in_a_as__str;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_as__str;
algorithm
  (out_txt, out_a_as__str) :=
  match(in_txt, in_items, in_a_as__str, in_a_context)
    local
      Tpl.Text txt;
      list<Absyn.Exp> rest;
      Tpl.Text a_as__str;
      MMToJuliaUtil.Context a_context;
      Absyn.Exp i_e;

    case ( txt,
           {},
           a_as__str,
           _ )
      then (txt, a_as__str);

    case ( txt,
           i_e :: rest,
           a_as__str,
           a_context )
      equation
        (txt, a_as__str) = dumpPattern(txt, i_e, a_context, a_as__str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" <| "));
        (txt, a_as__str) = lm_185(txt, rest, a_as__str, a_context);
      then (txt, a_as__str);
  end match;
end lm_185;

protected function lm_186
  input Tpl.Text in_txt;
  input list<Absyn.Exp> in_items;
  input Tpl.Text in_a_as__str;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_as__str;
algorithm
  (out_txt, out_a_as__str) :=
  match(in_txt, in_items, in_a_as__str, in_a_context)
    local
      Tpl.Text txt;
      list<Absyn.Exp> rest;
      Tpl.Text a_as__str;
      MMToJuliaUtil.Context a_context;
      Absyn.Exp i_e;

    case ( txt,
           {},
           a_as__str,
           _ )
      then (txt, a_as__str);

    case ( txt,
           i_e :: rest,
           a_as__str,
           a_context )
      equation
        (txt, a_as__str) = dumpPattern(txt, i_e, a_context, a_as__str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" <| "));
        (txt, a_as__str) = lm_186(txt, rest, a_as__str, a_context);
      then (txt, a_as__str);
  end match;
end lm_186;

protected function fun_187
  input Tpl.Text in_txt;
  input Absyn.Ident in_a_id;
  input Absyn.ComponentRef in_a_function__;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_id, in_a_function__)
    local
      Tpl.Text txt;
      Absyn.ComponentRef a_function__;

    case ( txt,
           "list",
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("List"));
      then txt;

    case ( txt,
           _,
           a_function__ )
      equation
        txt = dumpCref(txt, a_function__, MMToJuliaUtil.functionContext);
      then txt;
  end match;
end fun_187;

protected function fun_188
  input Tpl.Text in_txt;
  input String in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           "NONE" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("NONE"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_188;

protected function fun_189
  input Tpl.Text in_txt;
  input Tpl.Text in_a_isNone;
  input Tpl.Text in_a_func__str;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_isNone, in_a_func__str)
    local
      Tpl.Text txt;
      Tpl.Text a_func__str;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           a_func__str )
      equation
        txt = Tpl.writeText(txt, a_func__str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(__)"));
      then txt;

    case ( txt,
           _,
           a_func__str )
      equation
        txt = Tpl.writeText(txt, a_func__str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("()"));
      then txt;
  end match;
end fun_189;

protected function fun_190
  input Tpl.Text in_txt;
  input Tpl.Text in_a_args__str;
  input Tpl.Text in_a_func__str;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_args__str, in_a_func__str)
    local
      Tpl.Text txt;
      Tpl.Text a_func__str;
      Tpl.Text i_args__str;
      String str_1;
      Tpl.Text l_isNone;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           a_func__str )
      equation
        str_1 = Tpl.textString(a_func__str);
        l_isNone = fun_188(Tpl.emptyTxt, str_1);
        txt = fun_189(txt, l_isNone, a_func__str);
      then txt;

    case ( txt,
           i_args__str,
           a_func__str )
      equation
        txt = Tpl.writeText(txt, a_func__str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, i_args__str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;
  end match;
end fun_190;

protected function fun_191
  input Tpl.Text in_txt;
  input Tpl.Text in_a_args__str;
  input Tpl.Text in_a_func__str;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_args__str, in_a_func__str)
    local
      Tpl.Text txt;
      Tpl.Text a_func__str;
      Tpl.Text i_args__str;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           a_func__str )
      equation
        txt = Tpl.writeText(txt, a_func__str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(__)"));
      then txt;

    case ( txt,
           i_args__str,
           a_func__str )
      equation
        txt = Tpl.writeText(txt, a_func__str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, i_args__str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;
  end match;
end fun_191;

protected function lm_192
  input Tpl.Text in_txt;
  input list<Absyn.Exp> in_items;
  input Tpl.Text in_a_as__str;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_as__str;
algorithm
  (out_txt, out_a_as__str) :=
  match(in_txt, in_items, in_a_as__str, in_a_context)
    local
      Tpl.Text txt;
      list<Absyn.Exp> rest;
      Tpl.Text a_as__str;
      MMToJuliaUtil.Context a_context;
      Absyn.Exp i_e;

    case ( txt,
           {},
           a_as__str,
           _ )
      then (txt, a_as__str);

    case ( txt,
           i_e :: rest,
           a_as__str,
           a_context )
      equation
        (txt, a_as__str) = dumpPattern(txt, i_e, a_context, a_as__str);
        txt = Tpl.nextIter(txt);
        (txt, a_as__str) = lm_192(txt, rest, a_as__str, a_context);
      then (txt, a_as__str);
  end match;
end lm_192;

public function dumpPattern
  input Tpl.Text in_txt;
  input Absyn.Exp in_a_exp;
  input MMToJuliaUtil.Context in_a_context;
  input Tpl.Text in_a_as__str;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_as__str;
algorithm
  (out_txt, out_a_as__str) :=
  match(in_txt, in_a_exp, in_a_context, in_a_as__str)
    local
      Tpl.Text txt;
      MMToJuliaUtil.Context a_context;
      Tpl.Text a_as__str;
      Absyn.Exp i_rest;
      Absyn.Exp i_head;
      Absyn.Exp i_exp;
      list<Absyn.Exp> i_expressions;
      Absyn.ComponentRef i_function__;
      Absyn.Ident i_id;
      Absyn.FunctionArgs i_functionArgs;
      list<Absyn.Exp> i_exps;
      Boolean i_value_2;
      Absyn.ComponentRef i_componentRef;
      String i_value_1;
      Integer i_value;
      Tpl.Text txt_8;
      Tpl.Text txt_7;
      Tpl.Text l_consOp;
      Tpl.Text l_id__str;
      Tpl.Text l_exp__str;
      Tpl.Text l_tuple__str;
      Tpl.Text l_func__str;
      Tpl.Text l_args__str;
      String ret_0;

    case ( txt,
           Absyn.INTEGER(value = i_value),
           _,
           a_as__str )
      equation
        txt = Tpl.writeStr(txt, intString(i_value));
      then (txt, a_as__str);

    case ( txt,
           Absyn.REAL(value = i_value_1),
           _,
           a_as__str )
      equation
        txt = Tpl.writeStr(txt, i_value_1);
      then (txt, a_as__str);

    case ( txt,
           Absyn.CREF(componentRef = i_componentRef),
           _,
           a_as__str )
      equation
        txt = dumpCref(txt, i_componentRef, MMToJuliaUtil.functionContext);
      then (txt, a_as__str);

    case ( txt,
           Absyn.STRING(value = i_value_1),
           _,
           a_as__str )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        txt = Tpl.pushBlock(txt, Tpl.BT_ABS_INDENT(0));
        ret_0 = System.stringReplace(i_value_1, "\\$", "\\$");
        txt = Tpl.writeStr(txt, ret_0);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
      then (txt, a_as__str);

    case ( txt,
           Absyn.BOOL(value = i_value_2),
           _,
           a_as__str )
      equation
        txt = Tpl.writeStr(txt, Tpl.booleanString(i_value_2));
      then (txt, a_as__str);

    case ( txt,
           Absyn.ARRAY(arrayExp = i_exps),
           a_context,
           a_as__str )
      equation
        (txt, a_as__str) = lm_183(txt, i_exps, a_as__str, a_context);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" nil()"));
      then (txt, a_as__str);

    case ( txt,
           Absyn.LIST(exps = i_exps),
           a_context,
           a_as__str )
      equation
        (txt, a_as__str) = lm_184(txt, i_exps, a_as__str, a_context);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" nil()"));
      then (txt, a_as__str);

    case ( txt,
           Absyn.CALL(function_ = Absyn.CREF_IDENT(name = "list"), functionArgs = Absyn.FUNCTIONARGS(args = i_exps)),
           a_context,
           a_as__str )
      equation
        (txt, a_as__str) = lm_185(txt, i_exps, a_as__str, a_context);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" nil()"));
      then (txt, a_as__str);

    case ( txt,
           Absyn.CALL(function_ = Absyn.CREF_IDENT(name = "$array"), functionArgs = Absyn.FUNCTIONARGS(args = i_exps)),
           a_context,
           a_as__str )
      equation
        (txt, a_as__str) = lm_186(txt, i_exps, a_as__str, a_context);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" nil()"));
      then (txt, a_as__str);

    case ( txt,
           Absyn.CALL(function_ = (i_function__ as Absyn.CREF_IDENT(name = i_id)), functionArgs = i_functionArgs),
           _,
           a_as__str )
      equation
        l_args__str = dumpFunctionArgsPattern(Tpl.emptyTxt, i_functionArgs);
        l_func__str = fun_187(Tpl.emptyTxt, i_id, i_function__);
        txt = fun_190(txt, l_args__str, l_func__str);
      then (txt, a_as__str);

    case ( txt,
           Absyn.CALL(function_ = i_function__, functionArgs = i_functionArgs),
           _,
           a_as__str )
      equation
        l_func__str = dumpCref(Tpl.emptyTxt, i_function__, MMToJuliaUtil.functionContext);
        l_args__str = dumpFunctionArgsPattern(Tpl.emptyTxt, i_functionArgs);
        txt = fun_191(txt, l_args__str, l_func__str);
      then (txt, a_as__str);

    case ( txt,
           Absyn.TUPLE(expressions = i_expressions),
           a_context,
           a_as__str )
      equation
        l_tuple__str = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_tuple__str, a_as__str) = lm_192(l_tuple__str, i_expressions, a_as__str, a_context);
        l_tuple__str = Tpl.popIter(l_tuple__str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, l_tuple__str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_as__str);

    case ( txt,
           Absyn.AS(exp = i_exp, id = i_id),
           a_context,
           a_as__str )
      equation
        (l_exp__str, a_as__str) = dumpPattern(Tpl.emptyTxt, i_exp, a_context, a_as__str);
        l_id__str = Tpl.writeStr(Tpl.emptyTxt, i_id);
        txt = Tpl.writeText(txt, l_id__str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" && "));
        txt = Tpl.writeText(txt, l_exp__str);
      then (txt, a_as__str);

    case ( txt,
           Absyn.CONS(head = i_head, rest = i_rest),
           a_context,
           a_as__str )
      equation
        (txt_7, a_as__str) = dumpPattern(Tpl.emptyTxt, i_head, a_context, a_as__str);
        (txt_8, a_as__str) = dumpPattern(Tpl.emptyTxt, i_rest, a_context, a_as__str);
        l_consOp = dumpCons(Tpl.emptyTxt, Tpl.textString(txt_7), Tpl.textString(txt_8));
        txt = Tpl.writeText(txt, l_consOp);
      then (txt, a_as__str);

    case ( txt,
           _,
           _,
           a_as__str )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#= AbsynDumpTpl.dumpPattern: UNHANDLED Abyn.Exp  =#"));
      then (txt, a_as__str);
  end match;
end dumpPattern;

public function dumpCons
  input Tpl.Text txt;
  input String a_headString;
  input String a_tailString;

  output Tpl.Text out_txt;
algorithm
  out_txt := Tpl.writeStr(txt, a_headString);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING(" <| "));
  out_txt := Tpl.writeStr(out_txt, a_tailString);
end dumpCons;

protected function lm_195
  input Tpl.Text in_txt;
  input list<Absyn.Exp> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<Absyn.Exp> rest;
      Absyn.Exp i_arg;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_arg :: rest )
      equation
        (txt, _) = dumpPattern(txt, i_arg, MMToJuliaUtil.functionContext, Tpl.emptyTxt);
        txt = Tpl.nextIter(txt);
        txt = lm_195(txt, rest);
      then txt;
  end match;
end lm_195;

protected function lm_196
  input Tpl.Text in_txt;
  input list<Absyn.NamedArg> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<Absyn.NamedArg> rest;
      Absyn.NamedArg i_narg;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_narg :: rest )
      equation
        txt = dumpNamedArgPattern(txt, i_narg);
        txt = Tpl.nextIter(txt);
        txt = lm_196(txt, rest);
      then txt;
  end match;
end lm_196;

protected function fun_197
  input Tpl.Text in_txt;
  input list<Absyn.NamedArg> in_a_argNames;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_argNames)
    local
      Tpl.Text txt;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
      then txt;
  end match;
end fun_197;

protected function fun_198
  input Tpl.Text in_txt;
  input Tpl.Text in_a_args__str;
  input list<Absyn.NamedArg> in_a_argNames;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_args__str, in_a_argNames)
    local
      Tpl.Text txt;
      list<Absyn.NamedArg> a_argNames;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           _ )
      then txt;

    case ( txt,
           _,
           a_argNames )
      equation
        txt = fun_197(txt, a_argNames);
      then txt;
  end match;
end fun_198;

public function dumpFunctionArgsPattern
  input Tpl.Text in_txt;
  input Absyn.FunctionArgs in_a_args;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_args)
    local
      Tpl.Text txt;
      list<Absyn.NamedArg> i_argNames;
      list<Absyn.Exp> i_args;
      Tpl.Text l_separator;
      Tpl.Text l_namedargs__str;
      Tpl.Text l_args__str;

    case ( txt,
           Absyn.FUNCTIONARGS(args = i_args, argNames = i_argNames) )
      equation
        l_args__str = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_args__str = lm_195(l_args__str, i_args);
        l_args__str = Tpl.popIter(l_args__str);
        l_namedargs__str = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_namedargs__str = lm_196(l_namedargs__str, i_argNames);
        l_namedargs__str = Tpl.popIter(l_namedargs__str);
        l_separator = fun_198(Tpl.emptyTxt, l_args__str, i_argNames);
        txt = Tpl.writeText(txt, l_args__str);
        txt = Tpl.writeText(txt, l_separator);
        txt = Tpl.writeText(txt, l_namedargs__str);
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("ERROR FOR_ITER_FARG in pattern"));
      then txt;
  end match;
end dumpFunctionArgsPattern;

public function dumpNamedArgPattern
  input Tpl.Text in_txt;
  input Absyn.NamedArg in_a_narg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_narg)
    local
      Tpl.Text txt;
      Absyn.Exp i_argValue;
      Absyn.Ident i_argName;

    case ( txt,
           Absyn.NAMEDARG(argName = i_argName, argValue = i_argValue) )
      equation
        txt = Tpl.writeStr(txt, i_argName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        (txt, _) = dumpPattern(txt, i_argValue, MMToJuliaUtil.functionContext, Tpl.emptyTxt);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end dumpNamedArgPattern;

public function dumpNamedArgPattern2
  input Tpl.Text in_txt;
  input Absyn.NamedArg in_a_narg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_narg)
    local
      Tpl.Text txt;

    case ( txt,
           Absyn.NAMEDARG(argName = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<%argName%>"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end dumpNamedArgPattern2;

public function dumpNamedArgPattern3
  input Tpl.Text in_txt;
  input Absyn.NamedArg in_a_narg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_narg)
    local
      Tpl.Text txt;
      Absyn.Exp i_argValue;

    case ( txt,
           Absyn.NAMEDARG(argValue = i_argValue) )
      equation
        (txt, _) = dumpPattern(txt, i_argValue, MMToJuliaUtil.functionContext, Tpl.emptyTxt);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end dumpNamedArgPattern3;

public function dumpLhsExp
  input Tpl.Text in_txt;
  input Absyn.Exp in_a_lhs;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_lhs, in_a_context)
    local
      Tpl.Text txt;
      MMToJuliaUtil.Context a_context;
      Absyn.Exp i_lhs;

    case ( txt,
           (i_lhs as Absyn.IFEXP(ifExp = _)),
           a_context )
      equation
        txt = dumpExp(txt, i_lhs, a_context);
      then txt;

    case ( txt,
           i_lhs,
           a_context )
      equation
        txt = dumpExp(txt, i_lhs, a_context);
      then txt;
  end match;
end dumpLhsExp;

protected function fun_204
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_op__str;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_op__str)
    local
      Tpl.Text txt;
      Tpl.Text a_op__str;

    case ( txt,
           false,
           a_op__str )
      equation
        txt = Tpl.writeText(txt, a_op__str);
      then txt;

    case ( txt,
           _,
           a_op__str )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_op__str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;
  end match;
end fun_204;

public function dumpOperand
  input Tpl.Text txt;
  input Absyn.Exp a_operand;
  input Absyn.Exp a_operation;
  input Boolean a_lhs;
  input MMToJuliaUtil.Context a_context;

  output Tpl.Text out_txt;
protected
  Boolean ret_1;
  Tpl.Text l_op__str;
algorithm
  l_op__str := dumpExp(Tpl.emptyTxt, a_operand, a_context);
  ret_1 := Dump.shouldParenthesize(a_operand, a_operation, a_lhs);
  out_txt := fun_204(txt, ret_1, l_op__str);
end dumpOperand;

public function dumpIfExp
  input Tpl.Text in_txt;
  input Absyn.Exp in_a_if__exp;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_if__exp, in_a_context)
    local
      Tpl.Text txt;
      MMToJuliaUtil.Context a_context;
      list<tuple<Absyn.Exp, Absyn.Exp>> i_elseIfBranch;
      Absyn.Exp i_elseBranch;
      Absyn.Exp i_trueBranch;
      Absyn.Exp i_ifExp;
      Tpl.Text l_else__if__str;
      Tpl.Text l_else__branch__str;
      Tpl.Text l_true__branch__str;
      Tpl.Text l_cond__str;

    case ( txt,
           Absyn.IFEXP(ifExp = i_ifExp, trueBranch = i_trueBranch, elseBranch = i_elseBranch, elseIfBranch = i_elseIfBranch),
           a_context )
      equation
        l_cond__str = dumpExp(Tpl.emptyTxt, i_ifExp, a_context);
        l_true__branch__str = dumpExp(Tpl.emptyTxt, i_trueBranch, a_context);
        l_else__branch__str = dumpExp(Tpl.emptyTxt, i_elseBranch, a_context);
        l_else__if__str = dumpElseIfExp(Tpl.emptyTxt, i_elseIfBranch, a_context);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if "));
        txt = Tpl.writeText(txt, l_cond__str);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(6));
        txt = Tpl.writeText(txt, l_true__branch__str);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.writeText(txt, l_else__if__str);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("else\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_else__branch__str);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("end"));
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end dumpIfExp;

protected function lm_207
  input Tpl.Text in_txt;
  input list<tuple<Absyn.Exp, Absyn.Exp>> in_items;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_context)
    local
      Tpl.Text txt;
      list<tuple<Absyn.Exp, Absyn.Exp>> rest;
      MMToJuliaUtil.Context a_context;
      Absyn.Exp i_branch;
      Absyn.Exp i_cond;
      Tpl.Text l_branch__str;
      Tpl.Text l_cond__str;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           (i_cond, i_branch) :: rest,
           a_context )
      equation
        l_cond__str = dumpExp(Tpl.emptyTxt, i_cond, a_context);
        l_branch__str = dumpExp(Tpl.emptyTxt, i_branch, a_context);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("elseif ("));
        txt = Tpl.writeText(txt, l_cond__str);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(")\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(6));
        txt = Tpl.writeText(txt, l_branch__str);
        txt = Tpl.popBlock(txt);
        txt = Tpl.nextIter(txt);
        txt = lm_207(txt, rest, a_context);
      then txt;
  end match;
end lm_207;

public function dumpElseIfExp
  input Tpl.Text txt;
  input list<tuple<Absyn.Exp, Absyn.Exp>> a_else__if;
  input MMToJuliaUtil.Context a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt := Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_207(out_txt, a_else__if, a_context);
  out_txt := Tpl.popIter(out_txt);
end dumpElseIfExp;

public function dumpCodeNode
  input Tpl.Text in_txt;
  input Absyn.CodeNode in_a_code;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_code, in_a_context)
    local
      Tpl.Text txt;
      MMToJuliaUtil.Context a_context;
      Absyn.Modification i_modification;
      Absyn.Exp i_exp;
      Absyn.Element i_element;
      Absyn.ComponentRef i_componentRef;
      Absyn.Path i_path;

    case ( txt,
           Absyn.C_TYPENAME(path = i_path),
           _ )
      equation
        txt = dumpPathJL(txt, i_path);
      then txt;

    case ( txt,
           Absyn.C_VARIABLENAME(componentRef = i_componentRef),
           a_context )
      equation
        txt = dumpCref(txt, i_componentRef, a_context);
      then txt;

    case ( txt,
           Absyn.C_CONSTRAINTSECTION(boolean = _),
           _ )
      equation
        txt = AbsynDumpTpl.errorMsg(txt, "AbsynToJulia.dumpCodeNode: C_CONSTRAINTSECTION not supported");
      then txt;

    case ( txt,
           Absyn.C_EQUATIONSECTION(boolean = _),
           _ )
      equation
        txt = AbsynDumpTpl.errorMsg(txt, "AbsynToJulia.dumpCodeNode: C_CONSTRAINTSECTION not supported");
      then txt;

    case ( txt,
           Absyn.C_ALGORITHMSECTION(boolean = _),
           _ )
      equation
        txt = AbsynDumpTpl.errorMsg(txt, "AbsynToJulia.dumpCodeNode: C_ALGORITHMSECTION not supported");
      then txt;

    case ( txt,
           Absyn.C_ELEMENT(element = i_element),
           a_context )
      equation
        txt = dumpElement(txt, i_element, Dump.defaultDumpOptions, a_context);
      then txt;

    case ( txt,
           Absyn.C_EXPRESSION(exp = i_exp),
           a_context )
      equation
        txt = dumpExp(txt, i_exp, a_context);
      then txt;

    case ( txt,
           Absyn.C_MODIFICATION(modification = i_modification),
           a_context )
      equation
        txt = dumpModification(txt, i_modification, a_context);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end dumpCodeNode;

protected function lm_210
  input Tpl.Text in_txt;
  input list<Absyn.Case> in_items;
  input Absyn.Exp in_a_inputExp;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_inputExp)
    local
      Tpl.Text txt;
      list<Absyn.Case> rest;
      Absyn.Exp a_inputExp;
      Absyn.Case i_c;
      MMToJuliaUtil.Context ret_0;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_c :: rest,
           a_inputExp )
      equation
        ret_0 = MMToJuliaUtil.makeMatchContext(a_inputExp);
        txt = dumpMatchCase(txt, i_c, ret_0);
        txt = Tpl.nextIter(txt);
        txt = lm_210(txt, rest, a_inputExp);
      then txt;
  end match;
end lm_210;

public function dumpMatchExp
  input Tpl.Text in_txt;
  input Absyn.Exp in_a_match__exp;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_match__exp)
    local
      Tpl.Text txt;
      Option<String> i_comment;
      list<Absyn.Case> i_cases;
      list<Absyn.ElementItem> i_localDecls;
      Absyn.Exp i_inputExp;
      Absyn.MatchType i_matchTy;
      Tpl.Text l_cmt__str;
      Tpl.Text l_cases__str;
      Tpl.Text l_locals__str;
      Tpl.Text l_input__str;
      Tpl.Text l_match__ty__str;

    case ( txt,
           Absyn.MATCHEXP(matchTy = i_matchTy, inputExp = i_inputExp, localDecls = i_localDecls, cases = i_cases, comment = i_comment) )
      equation
        l_match__ty__str = dumpMatchType(Tpl.emptyTxt, i_matchTy);
        l_input__str = dumpExp(Tpl.emptyTxt, i_inputExp, MMToJuliaUtil.functionContext);
        l_locals__str = dumpMatchLocals(Tpl.emptyTxt, i_localDecls);
        l_cases__str = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING_LIST({
                                                                                       "\n",
                                                                                       "\n"
                                                                                   }, true)), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_cases__str = lm_210(l_cases__str, i_cases, i_inputExp);
        l_cases__str = Tpl.popIter(l_cases__str);
        l_cmt__str = dumpCommentStrOpt(Tpl.emptyTxt, i_comment);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("begin\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_locals__str);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_match__ty__str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, l_input__str);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" begin\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_cases__str);
        txt = Tpl.writeText(txt, l_cmt__str);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("end\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("end"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end dumpMatchExp;

public function dumpMatchType
  input Tpl.Text in_txt;
  input Absyn.MatchType in_a_match__type;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_match__type)
    local
      Tpl.Text txt;

    case ( txt,
           Absyn.MATCH() )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("@match"));
      then txt;

    case ( txt,
           Absyn.MATCHCONTINUE() )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("@matchcontinue"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end dumpMatchType;

protected function lm_213
  input Tpl.Text in_txt;
  input list<Absyn.AlgorithmItem> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<Absyn.AlgorithmItem> rest;
      Absyn.AlgorithmItem i_alg;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_alg :: rest )
      equation
        txt = dumpAlgorithmItem(txt, i_alg, MMToJuliaUtil.functionContext);
        txt = Tpl.nextIter(txt);
        txt = lm_213(txt, rest);
      then txt;
  end match;
end lm_213;

protected function lm_214
  input Tpl.Text in_txt;
  input list<Absyn.AlgorithmItem> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<Absyn.AlgorithmItem> rest;
      Absyn.AlgorithmItem i_alg;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_alg :: rest )
      equation
        txt = dumpAlgorithmItem(txt, i_alg, MMToJuliaUtil.functionContext);
        txt = Tpl.nextIter(txt);
        txt = lm_214(txt, rest);
      then txt;
  end match;
end lm_214;

public function dumpMatchContents
  input Tpl.Text in_txt;
  input Absyn.ClassPart in_a_cp;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_cp)
    local
      Tpl.Text txt;
      list<Absyn.AlgorithmItem> i_algs;
      Absyn.ClassPart i_cp;
      list<Absyn.AlgorithmItem> ret_0;

    case ( txt,
           Absyn.EQUATIONS(contents = {}) )
      then txt;

    case ( txt,
           (i_cp as Absyn.EQUATIONS(contents = _)) )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        ret_0 = Static.fromEquationsToAlgAssignments(i_cp);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_213(txt, ret_0);
        txt = Tpl.popIter(txt);
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           Absyn.ALGORITHMS(contents = {}) )
      then txt;

    case ( txt,
           Absyn.ALGORITHMS(contents = i_algs) )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_214(txt, i_algs);
        txt = Tpl.popIter(txt);
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end dumpMatchContents;

protected function lm_216
  input Tpl.Text in_txt;
  input list<Absyn.ElementItem> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<Absyn.ElementItem> rest;
      Absyn.ElementItem i_decl;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_decl :: rest )
      equation
        txt = dumpElementItem(txt, i_decl, Dump.defaultDumpOptions, MMToJuliaUtil.functionContext);
        txt = Tpl.nextIter(txt);
        txt = lm_216(txt, rest);
      then txt;
  end match;
end lm_216;

public function dumpMatchLocals
  input Tpl.Text in_txt;
  input list<Absyn.ElementItem> in_a_locals;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_locals)
    local
      Tpl.Text txt;
      list<Absyn.ElementItem> i_locals;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_locals )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_216(txt, i_locals);
        txt = Tpl.popIter(txt);
        txt = Tpl.popBlock(txt);
      then txt;
  end match;
end dumpMatchLocals;

protected function fun_218
  input Tpl.Text in_txt;
  input Option<Absyn.Exp> in_a_patternGuard;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_patternGuard, in_a_context)
    local
      Tpl.Text txt;
      MMToJuliaUtil.Context a_context;
      Absyn.Exp i_g;

    case ( txt,
           SOME(i_g),
           a_context )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("where ("));
        txt = dumpExp(txt, i_g, a_context);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") "));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_218;

protected function fun_219
  input Tpl.Text in_txt;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_context)
    local
      Tpl.Text txt;
      MMToJuliaUtil.Context i_context;
      Absyn.Exp i_inputExp;

    case ( txt,
           (i_context as MMToJuliaUtil.MATCH_CONTEXT(inputExp = i_inputExp)) )
      equation
        txt = dumpExp(txt, i_inputExp, i_context);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_219;

protected function fun_220
  input Tpl.Text in_txt;
  input Tpl.Text in_a_as__str;
  input Tpl.Text in_a_result__str;
  input Tpl.Text in_a_eql__str;
  input Tpl.Text in_a_cmt__str;
  input Tpl.Text in_a_guard__str;
  input Tpl.Text in_a_pattern__str;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_as__str, in_a_result__str, in_a_eql__str, in_a_cmt__str, in_a_guard__str, in_a_pattern__str)
    local
      Tpl.Text txt;
      Tpl.Text a_result__str;
      Tpl.Text a_eql__str;
      Tpl.Text a_cmt__str;
      Tpl.Text a_guard__str;
      Tpl.Text a_pattern__str;
      Tpl.Text i_as__str;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           a_result__str,
           a_eql__str,
           a_cmt__str,
           a_guard__str,
           a_pattern__str )
      equation
        txt = Tpl.writeText(txt, a_pattern__str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, a_guard__str);
        txt = Tpl.writeText(txt, a_cmt__str);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" => begin\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_eql__str);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, a_result__str);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("end"));
      then txt;

    case ( txt,
           i_as__str,
           a_result__str,
           a_eql__str,
           a_cmt__str,
           a_guard__str,
           a_pattern__str )
      equation
        txt = Tpl.writeText(txt, a_pattern__str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, a_guard__str);
        txt = Tpl.writeText(txt, a_cmt__str);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" => begin\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, i_as__str);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, a_eql__str);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, a_result__str);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("end"));
      then txt;
  end match;
end fun_220;

public function dumpMatchCase
  input Tpl.Text in_txt;
  input Absyn.Case in_a_c;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_c, in_a_context)
    local
      Tpl.Text txt;
      MMToJuliaUtil.Context a_context;
      Option<String> i_comment;
      Absyn.Exp i_result;
      Absyn.ClassPart i_classPart;
      Option<Absyn.Exp> i_patternGuard;
      Absyn.Exp i_pattern;
      Tpl.Text l_input__str;
      Tpl.Text l_cmt__str;
      Tpl.Text l_result__str;
      Tpl.Text l_eql__str;
      Tpl.Text l_guard__str;
      Tpl.Text l_pattern__str;
      Tpl.Text l_as__str;

    case ( txt,
           Absyn.CASE(pattern = i_pattern, patternGuard = i_patternGuard, classPart = i_classPart, result = i_result, comment = i_comment),
           a_context )
      equation
        l_as__str = Tpl.emptyTxt;
        (l_pattern__str, l_as__str) = dumpPattern(Tpl.emptyTxt, i_pattern, a_context, l_as__str);
        l_guard__str = fun_218(Tpl.emptyTxt, i_patternGuard, a_context);
        l_eql__str = dumpMatchContents(Tpl.emptyTxt, i_classPart);
        l_result__str = dumpExp(Tpl.emptyTxt, i_result, a_context);
        l_cmt__str = dumpCommentStrOpt(Tpl.emptyTxt, i_comment);
        l_input__str = fun_219(Tpl.emptyTxt, a_context);
        txt = fun_220(txt, l_as__str, l_result__str, l_eql__str, l_cmt__str, l_guard__str, l_pattern__str);
      then txt;

    case ( txt,
           Absyn.ELSE(classPart = i_classPart, result = i_result, comment = i_comment),
           a_context )
      equation
        l_eql__str = dumpMatchContents(Tpl.emptyTxt, i_classPart);
        l_result__str = dumpExp(Tpl.emptyTxt, i_result, a_context);
        l_cmt__str = dumpCommentStrOpt(Tpl.emptyTxt, i_comment);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_ "));
        txt = Tpl.writeText(txt, l_cmt__str);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" => begin\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.writeText(txt, l_eql__str);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_result__str);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("end"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end dumpMatchCase;

public function dumpOperator
  input Tpl.Text in_txt;
  input Absyn.Operator in_a_op;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_op)
    local
      Tpl.Text txt;
      Absyn.Operator i_op;

    case ( txt,
           Absyn.AND() )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("&&"));
      then txt;

    case ( txt,
           Absyn.OR() )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("||"));
      then txt;

    case ( txt,
           Absyn.NOT() )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("!"));
      then txt;

    case ( txt,
           Absyn.NEQUAL() )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("!="));
      then txt;

    case ( txt,
           i_op )
      equation
        txt = AbsynDumpTpl.dumpOperator(txt, i_op);
      then txt;
  end match;
end dumpOperator;

protected function fun_223
  input Tpl.Text in_txt;
  input Absyn.Ident in_a_name;
  input Tpl.Text in_a_c__str;
  input Tpl.Text in_a_ss__str;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_name, in_a_c__str, in_a_ss__str)
    local
      Tpl.Text txt;
      Tpl.Text a_c__str;
      Tpl.Text a_ss__str;
      Absyn.Ident i_name;

    case ( txt,
           "List",
           a_c__str,
           a_ss__str )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("ListUtil"));
        txt = Tpl.writeText(txt, a_ss__str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("."));
        txt = Tpl.writeText(txt, a_c__str);
      then txt;

    case ( txt,
           "Array",
           a_c__str,
           a_ss__str )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("ArrayUtil"));
        txt = Tpl.writeText(txt, a_ss__str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("."));
        txt = Tpl.writeText(txt, a_c__str);
      then txt;

    case ( txt,
           i_name,
           a_c__str,
           _ )
      equation
        txt = Tpl.writeStr(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("."));
        txt = Tpl.writeText(txt, a_c__str);
      then txt;
  end match;
end fun_223;

protected function fun_224
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
      then txt;
  end match;
end fun_224;

public function dumpCref
  input Tpl.Text in_txt;
  input Absyn.ComponentRef in_a_cref;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_cref, in_a_context)
    local
      Tpl.Text txt;
      MMToJuliaUtil.Context a_context;
      Absyn.Ident i_name;
      Absyn.ComponentRef i_componentRef;
      list<Absyn.Subscript> i_subscripts;
      Boolean ret_2;
      Tpl.Text l_c__str;
      Tpl.Text l_ss__str;

    case ( txt,
           Absyn.CREF_QUAL(subscripts = i_subscripts, componentRef = i_componentRef, name = i_name),
           a_context )
      equation
        l_ss__str = dumpSubscripts(Tpl.emptyTxt, i_subscripts, a_context);
        l_c__str = dumpCref(Tpl.emptyTxt, i_componentRef, a_context);
        txt = fun_223(txt, i_name, l_c__str, l_ss__str);
      then txt;

    case ( txt,
           Absyn.CREF_IDENT(name = i_name, subscripts = i_subscripts),
           a_context )
      equation
        txt = Tpl.writeStr(txt, i_name);
        txt = dumpSubscripts(txt, i_subscripts, a_context);
      then txt;

    case ( txt,
           Absyn.CREF_FULLYQUALIFIED(componentRef = i_componentRef),
           a_context )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("."));
        txt = dumpCref(txt, i_componentRef, a_context);
      then txt;

    case ( txt,
           Absyn.WILD(),
           _ )
      equation
        ret_2 = Config.acceptMetaModelicaGrammar();
        txt = fun_224(txt, ret_2);
      then txt;

    case ( txt,
           Absyn.ALLWILD(),
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("__"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end dumpCref;

protected function lm_226
  input Tpl.Text in_txt;
  input list<Absyn.Exp> in_items;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_context)
    local
      Tpl.Text txt;
      list<Absyn.Exp> rest;
      MMToJuliaUtil.Context a_context;
      Absyn.Exp i_arg;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_arg :: rest,
           a_context )
      equation
        txt = dumpExp(txt, i_arg, a_context);
        txt = Tpl.nextIter(txt);
        txt = lm_226(txt, rest, a_context);
      then txt;
  end match;
end lm_226;

protected function lm_227
  input Tpl.Text in_txt;
  input list<Absyn.NamedArg> in_items;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_context)
    local
      Tpl.Text txt;
      list<Absyn.NamedArg> rest;
      MMToJuliaUtil.Context a_context;
      Absyn.NamedArg i_narg;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_narg :: rest,
           a_context )
      equation
        txt = dumpNamedArg(txt, i_narg, a_context);
        txt = Tpl.nextIter(txt);
        txt = lm_227(txt, rest, a_context);
      then txt;
  end match;
end lm_227;

protected function fun_228
  input Tpl.Text in_txt;
  input list<Absyn.NamedArg> in_a_argNames;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_argNames)
    local
      Tpl.Text txt;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
      then txt;
  end match;
end fun_228;

protected function fun_229
  input Tpl.Text in_txt;
  input Tpl.Text in_a_args__str;
  input list<Absyn.NamedArg> in_a_argNames;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_args__str, in_a_argNames)
    local
      Tpl.Text txt;
      list<Absyn.NamedArg> a_argNames;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           _ )
      then txt;

    case ( txt,
           _,
           a_argNames )
      equation
        txt = fun_228(txt, a_argNames);
      then txt;
  end match;
end fun_229;

protected function lm_230
  input Tpl.Text in_txt;
  input Absyn.ForIterators in_items;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_context)
    local
      Tpl.Text txt;
      Absyn.ForIterators rest;
      MMToJuliaUtil.Context a_context;
      Absyn.ForIterator i_i;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_i :: rest,
           a_context )
      equation
        txt = dumpForIterator(txt, i_i, a_context);
        txt = Tpl.nextIter(txt);
        txt = lm_230(txt, rest, a_context);
      then txt;
  end match;
end lm_230;

protected function lm_231
  input Tpl.Text in_txt;
  input Absyn.ForIterators in_items;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_context)
    local
      Tpl.Text txt;
      Absyn.ForIterators rest;
      MMToJuliaUtil.Context a_context;
      Absyn.ForIterator i_i;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_i :: rest,
           a_context )
      equation
        txt = dumpForIteratorName(txt, i_i, a_context);
        txt = Tpl.nextIter(txt);
        txt = lm_231(txt, rest, a_context);
      then txt;
  end match;
end lm_231;

protected function lm_232
  input Tpl.Text in_txt;
  input Absyn.ForIterators in_items;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_context)
    local
      Tpl.Text txt;
      Absyn.ForIterators rest;
      MMToJuliaUtil.Context a_context;
      Absyn.ForIterator i_i;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_i :: rest,
           a_context )
      equation
        txt = dumpForIteratorRanges(txt, i_i, a_context);
        txt = Tpl.nextIter(txt);
        txt = lm_232(txt, rest, a_context);
      then txt;
  end match;
end lm_232;

protected function fun_233
  input Tpl.Text in_txt;
  input Absyn.ReductionIterType in_a_iterType;
  input Tpl.Text in_a_iter__str;
  input Tpl.Text in_a_iter__ranges;
  input Tpl.Text in_a_iter__names;
  input Tpl.Text in_a_exp__str;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_iterType, in_a_iter__str, in_a_iter__ranges, in_a_iter__names, in_a_exp__str)
    local
      Tpl.Text txt;
      Tpl.Text a_iter__str;
      Tpl.Text a_iter__ranges;
      Tpl.Text a_iter__names;
      Tpl.Text a_exp__str;

    case ( txt,
           Absyn.THREAD(),
           _,
           a_iter__ranges,
           a_iter__names,
           a_exp__str )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("@do_threaded_for "));
        txt = Tpl.writeText(txt, a_exp__str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" ("));
        txt = Tpl.writeText(txt, a_iter__names);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") ("));
        txt = Tpl.writeText(txt, a_iter__ranges);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           _,
           a_iter__str,
           _,
           _,
           a_exp__str )
      equation
        txt = Tpl.writeText(txt, a_exp__str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" for "));
        txt = Tpl.writeText(txt, a_iter__str);
      then txt;
  end match;
end fun_233;

public function dumpFunctionArgs
  input Tpl.Text in_txt;
  input Absyn.FunctionArgs in_a_args;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_args, in_a_context)
    local
      Tpl.Text txt;
      MMToJuliaUtil.Context a_context;
      Absyn.ReductionIterType i_iterType;
      Absyn.ForIterators i_iterators;
      Absyn.Exp i_exp;
      list<Absyn.NamedArg> i_argNames;
      list<Absyn.Exp> i_args;
      Tpl.Text l_iter__ranges;
      Tpl.Text l_iter__names;
      Tpl.Text l_iter__str;
      Tpl.Text l_exp__str;
      Tpl.Text l_separator;
      Tpl.Text l_namedargs__str;
      Tpl.Text l_args__str;

    case ( txt,
           Absyn.FUNCTIONARGS(args = i_args, argNames = i_argNames),
           a_context )
      equation
        l_args__str = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_args__str = lm_226(l_args__str, i_args, a_context);
        l_args__str = Tpl.popIter(l_args__str);
        l_namedargs__str = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_namedargs__str = lm_227(l_namedargs__str, i_argNames, a_context);
        l_namedargs__str = Tpl.popIter(l_namedargs__str);
        l_separator = fun_229(Tpl.emptyTxt, l_args__str, i_argNames);
        txt = Tpl.writeText(txt, l_args__str);
        txt = Tpl.writeText(txt, l_separator);
        txt = Tpl.writeText(txt, l_namedargs__str);
      then txt;

    case ( txt,
           Absyn.FOR_ITER_FARG(exp = i_exp, iterators = i_iterators, iterType = i_iterType),
           a_context )
      equation
        l_exp__str = dumpExp(Tpl.emptyTxt, i_exp, a_context);
        l_iter__str = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_iter__str = lm_230(l_iter__str, i_iterators, a_context);
        l_iter__str = Tpl.popIter(l_iter__str);
        l_iter__names = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_iter__names = lm_231(l_iter__names, i_iterators, a_context);
        l_iter__names = Tpl.popIter(l_iter__names);
        l_iter__ranges = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_iter__ranges = lm_232(l_iter__ranges, i_iterators, a_context);
        l_iter__ranges = Tpl.popIter(l_iter__ranges);
        txt = fun_233(txt, i_iterType, l_iter__str, l_iter__ranges, l_iter__names, l_exp__str);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end dumpFunctionArgs;

public function dumpNamedArg
  input Tpl.Text in_txt;
  input Absyn.NamedArg in_a_narg;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_narg, in_a_context)
    local
      Tpl.Text txt;
      MMToJuliaUtil.Context a_context;
      Absyn.Exp i_argValue;
      Absyn.Ident i_argName;

    case ( txt,
           Absyn.NAMEDARG(argName = i_argName, argValue = i_argValue),
           a_context )
      equation
        txt = Tpl.writeStr(txt, i_argName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = dumpExp(txt, i_argValue, a_context);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end dumpNamedArg;

protected function lm_236
  input Tpl.Text in_txt;
  input Absyn.ForIterators in_items;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_context)
    local
      Tpl.Text txt;
      Absyn.ForIterators rest;
      MMToJuliaUtil.Context a_context;
      Absyn.ForIterator i_i;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_i :: rest,
           a_context )
      equation
        txt = dumpForIterator(txt, i_i, a_context);
        txt = Tpl.nextIter(txt);
        txt = lm_236(txt, rest, a_context);
      then txt;
  end match;
end lm_236;

public function dumpForIterators
  input Tpl.Text txt;
  input Absyn.ForIterators a_iters;
  input MMToJuliaUtil.Context a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt := Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_236(out_txt, a_iters, a_context);
  out_txt := Tpl.popIter(out_txt);
end dumpForIterators;

protected function fun_238
  input Tpl.Text in_txt;
  input Option<Absyn.Exp> in_a_range;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_range, in_a_context)
    local
      Tpl.Text txt;
      MMToJuliaUtil.Context a_context;
      Absyn.Exp i_r;

    case ( txt,
           SOME(i_r),
           a_context )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("in "));
        txt = dumpExp(txt, i_r, a_context);
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_238;

protected function fun_239
  input Tpl.Text in_txt;
  input Option<Absyn.Exp> in_a_guardExp;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_guardExp, in_a_context)
    local
      Tpl.Text txt;
      MMToJuliaUtil.Context a_context;
      Absyn.Exp i_g;

    case ( txt,
           SOME(i_g),
           a_context )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if "));
        txt = dumpExp(txt, i_g, a_context);
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_239;

public function dumpForIterator
  input Tpl.Text in_txt;
  input Absyn.ForIterator in_a_iterator;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_iterator, in_a_context)
    local
      Tpl.Text txt;
      MMToJuliaUtil.Context a_context;
      String i_name;
      Option<Absyn.Exp> i_guardExp;
      Option<Absyn.Exp> i_range;
      Tpl.Text l_guard__str;
      Tpl.Text l_range__str;

    case ( txt,
           Absyn.ITERATOR(range = i_range, guardExp = i_guardExp, name = i_name),
           a_context )
      equation
        l_range__str = fun_238(Tpl.emptyTxt, i_range, a_context);
        l_guard__str = fun_239(Tpl.emptyTxt, i_guardExp, a_context);
        txt = Tpl.writeStr(txt, i_name);
        txt = Tpl.writeText(txt, l_range__str);
        txt = Tpl.writeText(txt, l_guard__str);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end dumpForIterator;

protected function fun_241
  input Tpl.Text in_txt;
  input Option<Absyn.Exp> in_a_range;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_range, in_a_context)
    local
      Tpl.Text txt;
      MMToJuliaUtil.Context a_context;
      Absyn.Exp i_r;

    case ( txt,
           SOME(i_r),
           a_context )
      equation
        txt = dumpExp(txt, i_r, a_context);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_241;

protected function fun_242
  input Tpl.Text in_txt;
  input Option<Absyn.Exp> in_a_guardExp;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_guardExp, in_a_context)
    local
      Tpl.Text txt;
      MMToJuliaUtil.Context a_context;
      Absyn.Exp i_g;

    case ( txt,
           SOME(i_g),
           a_context )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if "));
        txt = dumpExp(txt, i_g, a_context);
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_242;

public function dumpForIteratorRanges
  input Tpl.Text in_txt;
  input Absyn.ForIterator in_a_iterator;
  input MMToJuliaUtil.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_iterator, in_a_context)
    local
      Tpl.Text txt;
      MMToJuliaUtil.Context a_context;
      Option<Absyn.Exp> i_guardExp;
      Option<Absyn.Exp> i_range;
      Tpl.Text l_guard__str;
      Tpl.Text l_range__str;

    case ( txt,
           Absyn.ITERATOR(range = i_range, guardExp = i_guardExp),
           a_context )
      equation
        l_range__str = fun_241(Tpl.emptyTxt, i_range, a_context);
        l_guard__str = fun_242(Tpl.emptyTxt, i_guardExp, a_context);
        txt = Tpl.writeText(txt, l_range__str);
        txt = Tpl.writeText(txt, l_guard__str);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end dumpForIteratorRanges;

protected function fun_244
  input Tpl.Text in_txt;
  input Absyn.ForIterator in_a_iterator;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_iterator)
    local
      Tpl.Text txt;
      String i_name;

    case ( txt,
           Absyn.ITERATOR(name = i_name) )
      equation
        txt = Tpl.writeStr(txt, i_name);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_244;

public function dumpForIteratorName
  input Tpl.Text txt;
  input Absyn.ForIterator a_iterator;
  input MMToJuliaUtil.Context a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_244(txt, a_iterator);
end dumpForIteratorName;

protected function lm_246
  input Tpl.Text in_txt;
  input list<Absyn.ElementItem> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<Absyn.ElementItem> rest;
      Absyn.ElementItem i_e;
      Option<Absyn.TypeSpec> ret_0;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_e :: rest )
      equation
        ret_0 = AbsynUtil.getTypeSpecFromElementItemOpt(i_e);
        txt = dumpTypeSpecOpt(txt, ret_0, MMToJuliaUtil.functionContext);
        txt = Tpl.nextIter(txt);
        txt = lm_246(txt, rest);
      then txt;
  end match;
end lm_246;

public function dumpOutputsJL
  input Tpl.Text txt;
  input list<Absyn.ElementItem> a_elements;

  output Tpl.Text out_txt;
protected
  list<Absyn.ElementItem> ret_1;
  Tpl.Text l_outputStr;
algorithm
  ret_1 := listReverse(a_elements);
  l_outputStr := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  l_outputStr := lm_246(l_outputStr, ret_1);
  l_outputStr := Tpl.popIter(l_outputStr);
  out_txt := Tpl.writeText(txt, l_outputStr);
end dumpOutputsJL;

annotation(__OpenModelica_Interface="backend");
end AbsynToJulia;