encapsulated package CodegenC
"
  file:        CodegenC.mo
  package:     CodegenC
  description: Generated by Susan.
"

public import Tpl;

public import SimCodeVar;
public import HashTableCrefSimVar;
public import SimCode;
public import SimCodeFunction;
public import SimCodeUtil;
public import SimCodeFunctionUtil;
public import BackendDAE;
public import System;
public import Autoconf;
public import Absyn;
public import MMath;
public import DAE;
public import ClassInf;
public import Util;
public import List;
public import ComponentReference;
public import Expression;
public import ExpressionDump;
public import Config;
public import Testsuite;
public import Flags;
public import Settings;
public import Error;
public import Values;
public import Algorithm;
public import ElementSource;
public import HpcOmSimCode;
public import HpcOmTaskGraph;
public import FMI;
public import CodegenUtil;
public import CodegenUtilSimulation;
public import CodegenCFunctions;
public import ExpressionDumpTpl;

protected function fun_47
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input list<SimCodeFunction.Function> in_a_modelInfo_functions;
  input String in_a_fileNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_modelInfo_functions, in_a_fileNamePrefix)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Function> a_modelInfo_functions;
      String a_fileNamePrefix;
      Tpl.Text txt_1;
      Tpl.Text l_cl;

    case ( txt,
           false,
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_modelInfo_functions,
           a_fileNamePrefix )
      equation
        l_cl = Tpl.emptyTxt;
        txt_1 = Tpl.writeStr(Tpl.emptyTxt, a_fileNamePrefix);
        txt_1 = Tpl.writeTok(txt_1, Tpl.ST_STRING("_kernels.cl"));
        l_cl = Tpl.redirectToFile(l_cl, Tpl.textString(txt_1));
        l_cl = simulationParModelicaKernelsFile(l_cl, a_fileNamePrefix, a_modelInfo_functions);
        l_cl = Tpl.closeFile(l_cl);
      then txt;
  end match;
end fun_47;

public function translateModel
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      list<String> i_sc_externalFunctionIncludes;
      list<SimCodeFunction.RecordDeclaration> i_recordDecls;
      list<SimCodeFunction.Function> i_modelInfo_functions;
      list<DAE.Exp> i_literals;
      String i_fileNamePrefix;
      Boolean ret_8;
      Tpl.Text txt_7;
      Tpl.Text l_records;
      Tpl.Text txt_5;
      Tpl.Text l_includes;
      Tpl.Text txt_3;
      Tpl.Text l_functionsHeader;
      Tpl.Text txt_1;
      Tpl.Text l_literalsFile;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(functions = i_modelInfo_functions), fileNamePrefix = i_fileNamePrefix, literals = i_literals, recordDecls = i_recordDecls, externalFunctionIncludes = i_sc_externalFunctionIncludes) )
      equation
        System.tmpTickResetIndex(0, 2);
        System.tmpTickResetIndex(0, 20);
        l_literalsFile = Tpl.emptyTxt;
        txt_1 = Tpl.writeStr(Tpl.emptyTxt, i_fileNamePrefix);
        txt_1 = Tpl.writeTok(txt_1, Tpl.ST_STRING("_literals.h"));
        l_literalsFile = Tpl.redirectToFile(l_literalsFile, Tpl.textString(txt_1));
        l_literalsFile = simulationLiteralsFile(l_literalsFile, i_fileNamePrefix, i_literals);
        l_literalsFile = Tpl.closeFile(l_literalsFile);
        l_functionsHeader = Tpl.emptyTxt;
        txt_3 = Tpl.writeStr(Tpl.emptyTxt, i_fileNamePrefix);
        txt_3 = Tpl.writeTok(txt_3, Tpl.ST_STRING("_functions.h"));
        l_functionsHeader = Tpl.redirectToFile(l_functionsHeader, Tpl.textString(txt_3));
        l_functionsHeader = simulationFunctionsHeaderFile(l_functionsHeader, i_fileNamePrefix, i_modelInfo_functions, i_recordDecls);
        l_functionsHeader = Tpl.closeFile(l_functionsHeader);
        l_includes = Tpl.emptyTxt;
        txt_5 = Tpl.writeStr(Tpl.emptyTxt, i_fileNamePrefix);
        txt_5 = Tpl.writeTok(txt_5, Tpl.ST_STRING("_includes.h"));
        l_includes = Tpl.redirectToFile(l_includes, Tpl.textString(txt_5));
        l_includes = CodegenCFunctions.externalFunctionIncludes(l_includes, i_sc_externalFunctionIncludes);
        l_includes = Tpl.closeFile(l_includes);
        l_records = Tpl.emptyTxt;
        txt_7 = Tpl.writeStr(Tpl.emptyTxt, i_fileNamePrefix);
        txt_7 = Tpl.writeTok(txt_7, Tpl.ST_STRING("_records.c"));
        l_records = Tpl.redirectToFile(l_records, Tpl.textString(txt_7));
        l_records = CodegenCFunctions.recordsFile(l_records, i_fileNamePrefix, i_recordDecls, true);
        l_records = Tpl.closeFile(l_records);
        ret_8 = Config.acceptParModelicaGrammar();
        txt = fun_47(txt, ret_8, i_modelInfo_functions, i_fileNamePrefix);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end translateModel;

protected function lm_49
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Function> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Function> rest;
      Integer x_i0;
      SimCodeFunction.Function i_fn;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_fn :: rest )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#define "));
        txt = CodegenCFunctions.functionName(txt, i_fn, false);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_index "));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.nextIter(txt);
        txt = lm_49(txt, rest);
      then txt;
  end match;
end lm_49;

protected function fun_50
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_modelNamePrefixStr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_modelNamePrefixStr)
    local
      Tpl.Text txt;
      Tpl.Text a_modelNamePrefixStr;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_modelNamePrefixStr )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("extern void "));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(a_modelNamePrefixStr), "initialNonLinearSystem");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(int nNonLinearSystems, NONLINEAR_SYSTEM_DATA *data);"));
      then txt;
  end match;
end fun_50;

protected function fun_51
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_modelNamePrefixStr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_modelNamePrefixStr)
    local
      Tpl.Text txt;
      Tpl.Text a_modelNamePrefixStr;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_modelNamePrefixStr )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("extern void "));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(a_modelNamePrefixStr), "initialLinearSystem");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(int nLinearSystems, LINEAR_SYSTEM_DATA *data);"));
      then txt;
  end match;
end fun_51;

protected function fun_52
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_modelNamePrefixStr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_modelNamePrefixStr)
    local
      Tpl.Text txt;
      Tpl.Text a_modelNamePrefixStr;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_modelNamePrefixStr )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("extern void "));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(a_modelNamePrefixStr), "initialMixedSystem");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(int nMixedSystems, MIXED_SYSTEM_DATA *data);"));
      then txt;
  end match;
end fun_52;

protected function fun_53
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#include \"ParModelica/auto/om_pm_interface.hpp\""));
      then txt;
  end match;
end fun_53;

protected function fun_54
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#include \"util/omc_spinlock.h\""));
      then txt;
  end match;
end fun_54;

protected function fun_55
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#define HPCOM"));
      then txt;
  end match;
end fun_55;

protected function fun_56
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_modelNamePrefixStr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode, in_a_modelNamePrefixStr)
    local
      Tpl.Text txt;
      Tpl.Text a_modelNamePrefixStr;
      Integer i_varInfo_numMixedSystems;
      Integer i_varInfo_numLinearSystems;
      Integer i_varInfo_numNonLinearSystems;
      list<SimCodeFunction.Function> i_functions;
      list<BackendDAE.TimeEvent> i_timeEvents;
      SimCode.ModelInfo i_modelInfo;
      String i_fileNamePrefix;
      Absyn.Path i_modelInfo_name;
      Boolean ret_7;
      Boolean ret_6;
      String ret_5;
      Boolean ret_4;
      Boolean ret_3;
      Boolean ret_2;
      Boolean ret_1;
      String ret_0;

    case ( txt,
           SimCode.SIMCODE(modelInfo = (i_modelInfo as SimCode.MODELINFO(functions = i_functions, varInfo = SimCode.VARINFO(numNonLinearSystems = i_varInfo_numNonLinearSystems, numLinearSystems = i_varInfo_numLinearSystems, numMixedSystems = i_varInfo_numMixedSystems), name = i_modelInfo_name)), fileNamePrefix = i_fileNamePrefix, timeEvents = i_timeEvents),
           a_modelNamePrefixStr )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/* Simulation code for "));
        txt = CodegenUtil.dotPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" generated by the OpenModelica Compiler "));
        ret_0 = Settings.getVersionNr();
        txt = Tpl.writeStr(txt, ret_0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ". */\n",
                                    "#if !defined("
                                }, false));
        txt = Tpl.writeText(txt, a_modelNamePrefixStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "__MODEL_H)\n",
                                    "#define "
                                }, false));
        txt = Tpl.writeText(txt, a_modelNamePrefixStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "__MODEL_H\n",
                                    "\n",
                                    "#include \"openmodelica.h\"\n",
                                    "#include \"openmodelica_func.h\"\n",
                                    "#include \"simulation_data.h\"\n",
                                    "#include \"simulation/simulation_info_json.h\"\n",
                                    "#include \"simulation/simulation_runtime.h\"\n",
                                    "#include \"util/omc_error.h\"\n",
                                    "#include \"util/parallel_helper.h\"\n",
                                    "#include \"simulation/solver/model_help.h\"\n",
                                    "#include \"simulation/solver/delay.h\"\n",
                                    "#include \"simulation/solver/linearSystem.h\"\n",
                                    "#include \"simulation/solver/nonlinearSystem.h\"\n",
                                    "#include \"simulation/solver/mixedSystem.h\"\n",
                                    "\n",
                                    "#if defined(__cplusplus)\n",
                                    "extern \"C\" {\n",
                                    "#endif\n",
                                    "\n",
                                    "#include <string.h>\n",
                                    "\n",
                                    "#include \""
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_functions.h\"\n",
                                    "\n"
                                }, true));
        txt = variableDefinitions(txt, i_modelInfo, i_timeEvents);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_49(txt, i_functions);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "extern void "
                                }, false));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(a_modelNamePrefixStr), "callExternalObjectDestructors");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA *_data, threadData_t *threadData);\n",
                                    "#if !defined(OMC_NUM_NONLINEAR_SYSTEMS) || OMC_NUM_NONLINEAR_SYSTEMS>0\n"
                                }, true));
        ret_1 = intGt(i_varInfo_numNonLinearSystems, 0);
        txt = fun_50(txt, ret_1, a_modelNamePrefixStr);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "#endif\n",
                                    "#if !defined(OMC_NUM_LINEAR_SYSTEMS) || OMC_NUM_LINEAR_SYSTEMS>0\n"
                                }, true));
        ret_2 = intGt(i_varInfo_numLinearSystems, 0);
        txt = fun_51(txt, ret_2, a_modelNamePrefixStr);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "#endif\n",
                                    "#if !defined(OMC_NUM_MIXED_SYSTEMS) || OMC_NUM_MIXED_SYSTEMS>0\n"
                                }, true));
        ret_3 = intGt(i_varInfo_numMixedSystems, 0);
        txt = fun_52(txt, ret_3, a_modelNamePrefixStr);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "#endif\n",
                                    "#if !defined(OMC_NO_STATESELECTION)\n",
                                    "extern void "
                                }, false));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(a_modelNamePrefixStr), "initializeStateSets");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(int nStateSets, STATE_SET_DATA* statesetData, DATA *data);\n",
                                    "#endif\n",
                                    "extern int "
                                }, false));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(a_modelNamePrefixStr), "functionAlgebraics");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA *data, threadData_t *threadData);\n",
                                    "extern int "
                                }, false));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(a_modelNamePrefixStr), "function_storeDelayed");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA *data, threadData_t *threadData);\n",
                                    "extern int "
                                }, false));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(a_modelNamePrefixStr), "updateBoundVariableAttributes");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA *data, threadData_t *threadData);\n",
                                    "extern int "
                                }, false));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(a_modelNamePrefixStr), "functionInitialEquations");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA *data, threadData_t *threadData);\n",
                                    "extern int "
                                }, false));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(a_modelNamePrefixStr), "functionInitialEquations_lambda0");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA *data, threadData_t *threadData);\n",
                                    "extern int "
                                }, false));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(a_modelNamePrefixStr), "functionRemovedInitialEquations");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA *data, threadData_t *threadData);\n",
                                    "extern int "
                                }, false));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(a_modelNamePrefixStr), "updateBoundParameters");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA *data, threadData_t *threadData);\n",
                                    "extern int "
                                }, false));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(a_modelNamePrefixStr), "checkForAsserts");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA *data, threadData_t *threadData);\n",
                                    "extern int "
                                }, false));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(a_modelNamePrefixStr), "function_ZeroCrossingsEquations");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA *data, threadData_t *threadData);\n",
                                    "extern int "
                                }, false));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(a_modelNamePrefixStr), "function_ZeroCrossings");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA *data, threadData_t *threadData, double* gout);\n",
                                    "extern int "
                                }, false));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(a_modelNamePrefixStr), "function_updateRelations");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA *data, threadData_t *threadData, int evalZeroCross);\n",
                                    "extern const char* "
                                }, false));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(a_modelNamePrefixStr), "zeroCrossingDescription");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(int i, int **out_EquationIndexes);\n",
                                    "extern const char* "
                                }, false));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(a_modelNamePrefixStr), "relationDescription");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(int i);\n",
                                    "extern void "
                                }, false));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(a_modelNamePrefixStr), "function_initSample");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA *data, threadData_t *threadData);\n",
                                    "extern int "
                                }, false));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(a_modelNamePrefixStr), "initialAnalyticJacobianG");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(void* data, threadData_t *threadData, ANALYTIC_JACOBIAN *jacobian);\n",
                                    "extern int "
                                }, false));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(a_modelNamePrefixStr), "initialAnalyticJacobianA");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(void* data, threadData_t *threadData, ANALYTIC_JACOBIAN *jacobian);\n",
                                    "extern int "
                                }, false));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(a_modelNamePrefixStr), "initialAnalyticJacobianB");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(void* data, threadData_t *threadData, ANALYTIC_JACOBIAN *jacobian);\n",
                                    "extern int "
                                }, false));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(a_modelNamePrefixStr), "initialAnalyticJacobianC");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(void* data, threadData_t *threadData, ANALYTIC_JACOBIAN *jacobian);\n",
                                    "extern int "
                                }, false));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(a_modelNamePrefixStr), "initialAnalyticJacobianD");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(void* data, threadData_t *threadData, ANALYTIC_JACOBIAN *jacobian);\n",
                                    "extern int "
                                }, false));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(a_modelNamePrefixStr), "initialAnalyticJacobianF");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(void* data, threadData_t *threadData, ANALYTIC_JACOBIAN *jacobian);\n",
                                    "extern int "
                                }, false));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(a_modelNamePrefixStr), "functionJacG_column");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(void* data, threadData_t *threadData, ANALYTIC_JACOBIAN *thisJacobian, ANALYTIC_JACOBIAN *parentJacobian);\n",
                                    "extern int "
                                }, false));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(a_modelNamePrefixStr), "functionJacA_column");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(void* data, threadData_t *threadData, ANALYTIC_JACOBIAN *thisJacobian, ANALYTIC_JACOBIAN *parentJacobian);\n",
                                    "extern int "
                                }, false));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(a_modelNamePrefixStr), "functionJacB_column");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(void* data, threadData_t *threadData, ANALYTIC_JACOBIAN *thisJacobian, ANALYTIC_JACOBIAN *parentJacobian);\n",
                                    "extern int "
                                }, false));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(a_modelNamePrefixStr), "functionJacC_column");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(void* data, threadData_t *threadData, ANALYTIC_JACOBIAN *thisJacobian, ANALYTIC_JACOBIAN *parentJacobian);\n",
                                    "extern int "
                                }, false));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(a_modelNamePrefixStr), "functionJacD_column");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(void* data, threadData_t *threadData, ANALYTIC_JACOBIAN *thisJacobian, ANALYTIC_JACOBIAN *parentJacobian);\n",
                                    "extern int "
                                }, false));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(a_modelNamePrefixStr), "functionJacF_column");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(void* data, threadData_t *threadData, ANALYTIC_JACOBIAN *thisJacobian, ANALYTIC_JACOBIAN *parentJacobian);\n",
                                    "extern const char* "
                                }, false));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(a_modelNamePrefixStr), "linear_model_frame");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(void);\n",
                                    "extern const char* "
                                }, false));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(a_modelNamePrefixStr), "linear_model_datarecovery_frame");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(void);\n",
                                    "extern int "
                                }, false));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(a_modelNamePrefixStr), "mayer");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA* data, modelica_real** res, short *);\n",
                                    "extern int "
                                }, false));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(a_modelNamePrefixStr), "lagrange");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA* data, modelica_real** res, short *, short *);\n",
                                    "extern int "
                                }, false));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(a_modelNamePrefixStr), "pickUpBoundsForInputsInOptimization");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA* data, modelica_real* min, modelica_real* max, modelica_real*nominal, modelica_boolean *useNominal, char ** name, modelica_real * start, modelica_real * startTimeOpt);\n",
                                    "extern int "
                                }, false));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(a_modelNamePrefixStr), "setInputData");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA *data, const modelica_boolean file);\n",
                                    "extern int "
                                }, false));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(a_modelNamePrefixStr), "getTimeGrid");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA *data, modelica_integer * nsi, modelica_real**t);\n",
                                    "extern void "
                                }, false));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(a_modelNamePrefixStr), "function_initSynchronous");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA * data, threadData_t *threadData);\n",
                                    "extern void "
                                }, false));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(a_modelNamePrefixStr), "function_updateSynchronous");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA * data, threadData_t *threadData, long i);\n",
                                    "extern int "
                                }, false));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(a_modelNamePrefixStr), "function_equationsSynchronous");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA * data, threadData_t *threadData, long i);\n",
                                    "extern void "
                                }, false));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(a_modelNamePrefixStr), "read_input_fmu");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(MODEL_DATA* modelData, SIMULATION_INFO* simulationData);\n",
                                    "extern void "
                                }, false));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(a_modelNamePrefixStr), "function_savePreSynchronous");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA *data, threadData_t *threadData);\n",
                                    "extern int "
                                }, false));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(a_modelNamePrefixStr), "inputNames");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA* data, char ** names);\n",
                                    "extern int "
                                }, false));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(a_modelNamePrefixStr), "dataReconciliationInputNames");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA* data, char ** names);\n",
                                    "extern int "
                                }, false));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(a_modelNamePrefixStr), "initializeDAEmodeData");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA *data, DAEMODE_DATA*);\n",
                                    "extern int "
                                }, false));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(a_modelNamePrefixStr), "functionLocalKnownVars");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA*, threadData_t*);\n",
                                    "extern int "
                                }, false));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(a_modelNamePrefixStr), "symbolicInlineSystem");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA*, threadData_t*);\n",
                                    "\n",
                                    "#include \""
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_literals.h\"\n",
                                    "\n"
                                }, true));
        ret_4 = Flags.getConfigBool(Flags.PARMODAUTO);
        txt = fun_53(txt, ret_4);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        ret_5 = Flags.getConfigString(Flags.HPCOM_CODE);
        ret_6 = stringEq(ret_5, "pthreads_spin");
        txt = fun_54(txt, ret_6);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        ret_7 = Flags.isSet(Flags.HPCOM);
        txt = fun_55(txt, ret_7);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "#if defined(HPCOM) && !defined(_OPENMP)\n",
                                    "  #error \"HPCOM requires OpenMP or the results are wrong\"\n",
                                    "#endif\n",
                                    "#if defined(_OPENMP)\n",
                                    "  #include <omp.h>\n",
                                    "#else\n",
                                    "  /* dummy omp defines */\n",
                                    "  #define omp_get_max_threads() 1\n",
                                    "#endif\n",
                                    "\n",
                                    "#if defined(__cplusplus)\n",
                                    "}\n",
                                    "#endif\n",
                                    "\n",
                                    "#endif /* !defined("
                                }, false));
        txt = Tpl.writeText(txt, a_modelNamePrefixStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "__MODEL_H) */\n",
                                    "\n"
                                }, true));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_56;

public function simulationHeaderFile
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_modelNamePrefixStr;
algorithm
  l_modelNamePrefixStr := CodegenUtilSimulation.modelNamePrefix(Tpl.emptyTxt, a_simCode);
  out_txt := fun_56(txt, a_simCode, l_modelNamePrefixStr);
end simulationHeaderFile;

public function simulationFile_mixAndHeader
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input String a_modelNamePrefix;

  output Tpl.Text out_txt;
protected
  Tpl.Text txt_3;
  Tpl.Text txt_2;
  Tpl.Text txt_1;
  Tpl.Text l_mixheader;
algorithm
  l_mixheader := Tpl.emptyTxt;
  (txt_1, l_mixheader) := simulationFile_mix(Tpl.emptyTxt, a_simCode, l_mixheader);
  txt_2 := Tpl.writeStr(Tpl.emptyTxt, a_modelNamePrefix);
  txt_2 := Tpl.writeTok(txt_2, Tpl.ST_STRING("_11mix.c"));
  Tpl.textFileConvertLines(txt_1, Tpl.textString(txt_2));
  txt_3 := Tpl.writeStr(Tpl.emptyTxt, a_modelNamePrefix);
  txt_3 := Tpl.writeTok(txt_3, Tpl.ST_STRING("_11mix.h"));
  Tpl.textFile(l_mixheader, Tpl.textString(txt_3));
  out_txt := txt;
end simulationFile_mixAndHeader;

public function simulationFile_syn
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      SimCode.SimCode i_simCode;
      list<SimCode.ClockedPartition> i_clockedPartitions;
      String i_simCode_fileNamePrefix;
      Tpl.Text txt_5;
      list<SimCode.SubPartition> ret_4;
      Tpl.Text txt_3;
      list<SimCode.SubPartition> ret_2;
      Tpl.Text txt_1;
      Tpl.Text txt_0;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(fileNamePrefix = i_simCode_fileNamePrefix, clockedPartitions = i_clockedPartitions)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/* Synchronous systems */\n"));
        txt = simulationFileHeader(txt, i_simCode_fileNamePrefix);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "#if defined(__cplusplus)\n",
                                    "extern \"C\" {\n",
                                    "#endif\n",
                                    "\n"
                                }, true));
        txt_0 = CodegenUtilSimulation.modelNamePrefix(Tpl.emptyTxt, i_simCode);
        txt = functionInitSynchronous(txt, i_clockedPartitions, Tpl.textString(txt_0));
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt_1 = CodegenUtilSimulation.modelNamePrefix(Tpl.emptyTxt, i_simCode);
        txt = functionUpdateSynchronous(txt, i_clockedPartitions, Tpl.textString(txt_1));
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        ret_2 = SimCodeUtil.getSubPartitions(i_clockedPartitions);
        txt_3 = CodegenUtilSimulation.modelNamePrefix(Tpl.emptyTxt, i_simCode);
        txt = functionSystemsSynchronous(txt, ret_2, Tpl.textString(txt_3));
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        ret_4 = SimCodeUtil.getSubPartitions(i_clockedPartitions);
        txt_5 = CodegenUtilSimulation.modelNamePrefix(Tpl.emptyTxt, i_simCode);
        txt = functionSavePreSynchronous(txt, ret_4, Tpl.textString(txt_5));
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "#if defined(__cplusplus)\n",
                                    "}\n",
                                    "#endif\n"
                                }, true));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end simulationFile_syn;

protected function lm_60
  input Tpl.Text in_txt;
  input list<SimCode.SubPartition> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.SubPartition> rest;
      SimCode.SubPartition i_subPartition;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_subPartition :: rest )
      equation
        txt = functionSavePreSynchronous1(txt, i_subPartition);
        txt = Tpl.nextIter(txt);
        txt = lm_60(txt, rest);
      then txt;
  end match;
end lm_60;

public function functionSavePreSynchronous
  input Tpl.Text txt;
  input list<SimCode.SubPartition> a_subPartitions;
  input String a_modelNamePrefix;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_preVars;
algorithm
  l_preVars := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  l_preVars := lm_60(l_preVars, a_subPartitions);
  l_preVars := Tpl.popIter(l_preVars);
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                   "/* pre(%v%) = %v% */\n",
                                   "void "
                               }, false));
  out_txt := CodegenUtil.symbolName(out_txt, a_modelNamePrefix, "function_savePreSynchronous");
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "(DATA *data, threadData_t *threadData)\n",
                                       "{\n",
                                       "  TRACE_PUSH\n",
                                       "\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeText(out_txt, l_preVars);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "TRACE_POP\n"
                                   }, true));
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("}"));
end functionSavePreSynchronous;

public function functionSavePreSynchronous1
  input Tpl.Text in_txt;
  input SimCode.SubPartition in_a_subPartition;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_subPartition)
    local
      Tpl.Text txt;
      list<tuple<SimCodeVar.SimVar, Boolean>> i_vars;

    case ( txt,
           SimCode.SUBPARTITION(vars = i_vars) )
      equation
        txt = functionSavePreSynchronous2(txt, i_vars);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end functionSavePreSynchronous1;

protected function lm_63
  input Tpl.Text in_txt;
  input list<tuple<SimCodeVar.SimVar, Boolean>> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<tuple<SimCodeVar.SimVar, Boolean>> rest;
      tuple<SimCodeVar.SimVar, Boolean> i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = functionSavePreSynchronous3(txt, i_var);
        txt = Tpl.nextIter(txt);
        txt = lm_63(txt, rest);
      then txt;
  end match;
end lm_63;

public function functionSavePreSynchronous2
  input Tpl.Text txt;
  input list<tuple<SimCodeVar.SimVar, Boolean>> a_vars;

  output Tpl.Text out_txt;
algorithm
  out_txt := Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_63(out_txt, a_vars);
  out_txt := Tpl.popIter(out_txt);
end functionSavePreSynchronous2;

protected function fun_65
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_a_simVar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simVar)
    local
      Tpl.Text txt;
      DAE.ComponentRef i_name;
      DAE.ComponentRef i_c;

    case ( txt,
           SimCodeVar.SIMVAR(arrayCref = SOME(i_c), aliasvar = SimCodeVar.NOALIAS()) )
      equation
        txt = CodegenCFunctions.cref(txt, i_c);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = CodegenCFunctions.crefPre(txt, i_c);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(aliasvar = SimCodeVar.NOALIAS(), name = i_name) )
      equation
        txt = CodegenCFunctions.cref(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = CodegenCFunctions.crefPre(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_65;

public function functionSavePreSynchronous3
  input Tpl.Text in_txt;
  input tuple<SimCodeVar.SimVar, Boolean> in_a_var;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_var)
    local
      Tpl.Text txt;
      SimCodeVar.SimVar i_simVar;

    case ( txt,
           (i_simVar, _) )
      equation
        txt = fun_65(txt, i_simVar);
      then txt;
  end match;
end functionSavePreSynchronous3;

public function isBoolClock
  input Tpl.Text in_txt;
  input DAE.ClockKind in_a_clock;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_clock)
    local
      Tpl.Text txt;

    case ( txt,
           DAE.BOOLEAN_CLOCK(condition = _) )
      equation
        txt = CodegenCFunctions.boolStrC(txt, true);
      then txt;

    case ( txt,
           _ )
      equation
        txt = CodegenCFunctions.boolStrC(txt, false);
      then txt;
  end match;
end isBoolClock;

protected function lm_68
  input Tpl.Text in_txt;
  input list<SimCode.SubPartition> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.SubPartition> rest;
      SimCode.SubPartition i_subPartition;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_subPartition :: rest )
      equation
        txt = subPartitionStr(txt, i_subPartition);
        txt = Tpl.nextIter(txt);
        txt = lm_68(txt, rest);
      then txt;
  end match;
end lm_68;

protected function fun_69
  input Tpl.Text in_txt;
  input SimCode.ClockedPartition in_a_partition;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_partition)
    local
      Tpl.Text txt;
      list<SimCode.SubPartition> i_subPartitions;
      DAE.ClockKind i_baseClock;
      Integer ret_2;
      Tpl.Text l_subClocksInfo;
      Tpl.Text l_boolClock;

    case ( txt,
           SimCode.CLOCKED_PARTITION(baseClock = i_baseClock, subPartitions = i_subPartitions) )
      equation
        l_boolClock = isBoolClock(Tpl.emptyTxt, i_baseClock);
        l_subClocksInfo = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_subClocksInfo = lm_68(l_subClocksInfo, i_subPartitions);
        l_subClocksInfo = Tpl.popIter(l_subClocksInfo);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("data->modelData->clocksInfo[i].nSubClocks = "));
        ret_2 = listLength(i_subPartitions);
        txt = Tpl.writeStr(txt, intString(ret_2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "data->modelData->clocksInfo[i].subClocks = data->modelData->subClocksInfo + j;\n",
                                    "data->modelData->clocksInfo[i].isBoolClock = "
                                }, false));
        txt = Tpl.writeText(txt, l_boolClock);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "i++;\n"
                                }, true));
        txt = Tpl.writeText(txt, l_subClocksInfo);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_69;

protected function lm_70
  input Tpl.Text in_txt;
  input list<SimCode.ClockedPartition> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.ClockedPartition> rest;
      SimCode.ClockedPartition i_partition;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_partition :: rest )
      equation
        txt = fun_69(txt, i_partition);
        txt = lm_70(txt, rest);
      then txt;
  end match;
end lm_70;

public function functionInitSynchronous
  input Tpl.Text txt;
  input list<SimCode.ClockedPartition> a_clockedPartitions;
  input String a_modelNamePrefix;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_body;
algorithm
  l_body := lm_70(Tpl.emptyTxt, a_clockedPartitions);
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                   "/* Initializes the clocks of model. */\n",
                                   "void "
                               }, false));
  out_txt := CodegenUtil.symbolName(out_txt, a_modelNamePrefix, "function_initSynchronous");
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "(DATA *data, threadData_t *threadData)\n",
                                       "{\n",
                                       "  TRACE_PUSH\n",
                                       "  long i=0, j=0;\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeText(out_txt, l_body);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("TRACE_POP\n"));
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("}"));
end functionInitSynchronous;

protected function fun_72
  input Tpl.Text in_txt;
  input Option<String> in_a_subClock_solver;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_subClock_solver)
    local
      Tpl.Text txt;

    case ( txt,
           NONE() )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("External"));
      then txt;
  end match;
end fun_72;

public function subPartitionStr
  input Tpl.Text in_txt;
  input SimCode.SubPartition in_a_subPartition;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_subPartition)
    local
      Tpl.Text txt;
      Boolean i_holdEvents;
      MMath.Rational i_subClock_factor;
      MMath.Rational i_subClock_shift;
      Option<String> i_subClock_solver;
      Tpl.Text l_methodStr;

    case ( txt,
           SimCode.SUBPARTITION(subClock = BackendDAE.SUBCLOCK(solver = i_subClock_solver, shift = i_subClock_shift, factor = i_subClock_factor), holdEvents = i_holdEvents) )
      equation
        l_methodStr = fun_72(Tpl.emptyTxt, i_subClock_solver);
        txt = rationalStr(txt, "data->modelData->subClocksInfo[j].shift", i_subClock_shift);
        txt = Tpl.softNewLine(txt);
        txt = rationalStr(txt, "data->modelData->subClocksInfo[j].factor", i_subClock_factor);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("data->modelData->subClocksInfo[j].solverMethod = \""));
        txt = Tpl.writeText(txt, l_methodStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\";\n",
                                    "data->modelData->subClocksInfo[j].holdEvents = "
                                }, false));
        txt = CodegenCFunctions.boolStrC(txt, i_holdEvents);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "j++;"
                                }, false));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end subPartitionStr;

protected function fun_74
  input Tpl.Text in_txt;
  input MMath.Rational in_a_rational;
  input String in_a_prefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_rational, in_a_prefix)
    local
      Tpl.Text txt;
      String a_prefix;
      Integer i_denom;
      Integer i_nom;

    case ( txt,
           MMath.RATIONAL(nom = i_nom, denom = i_denom),
           a_prefix )
      equation
        txt = Tpl.writeStr(txt, a_prefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".m = "));
        txt = Tpl.writeStr(txt, intString(i_nom));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.writeStr(txt, a_prefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".n = "));
        txt = Tpl.writeStr(txt, intString(i_denom));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_74;

public function rationalStr
  input Tpl.Text txt;
  input String a_prefix;
  input MMath.Rational a_rational;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_74(txt, a_rational, a_prefix);
end rationalStr;

protected function fun_76
  input Tpl.Text in_txt;
  input SimCode.ClockedPartition in_a_partition;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Integer in_a_i;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_a_partition, in_a_auxFunction, in_a_varDecls, in_a_i)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Integer a_i;
      DAE.ClockKind i_baseClock;
      Tpl.Text l_caseBody;

    case ( txt,
           SimCode.CLOCKED_PARTITION(baseClock = i_baseClock),
           a_auxFunction,
           a_varDecls,
           a_i )
      equation
        (l_caseBody, a_varDecls, a_auxFunction) = updatePartition(Tpl.emptyTxt, a_i, i_baseClock, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("case "));
        txt = Tpl.writeStr(txt, intString(a_i));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(":\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_caseBody);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("break;"));
        txt = Tpl.popBlock(txt);
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           _,
           a_auxFunction,
           a_varDecls,
           _ )
      then (txt, a_auxFunction, a_varDecls);
  end match;
end fun_76;

protected function lm_77
  input Tpl.Text in_txt;
  input list<SimCode.ClockedPartition> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls)
    local
      Tpl.Text txt;
      list<SimCode.ClockedPartition> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Integer x_i;
      SimCode.ClockedPartition i_partition;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls )
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           i_partition :: rest,
           a_auxFunction,
           a_varDecls )
      equation
        x_i = Tpl.getIteri_i0(txt);
        (txt, a_auxFunction, a_varDecls) = fun_76(txt, i_partition, a_auxFunction, a_varDecls, x_i);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls) = lm_77(txt, rest, a_auxFunction, a_varDecls);
      then (txt, a_auxFunction, a_varDecls);
  end match;
end lm_77;

public function functionUpdateSynchronous
  input Tpl.Text txt;
  input list<SimCode.ClockedPartition> a_clockedPartitions;
  input String a_modelNamePrefix;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_body;
  Tpl.Text l_auxFunction;
  Tpl.Text l_varDecls;
algorithm
  l_varDecls := Tpl.emptyTxt;
  l_auxFunction := Tpl.emptyTxt;
  l_body := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (l_body, l_auxFunction, l_varDecls) := lm_77(l_body, a_clockedPartitions, l_auxFunction, l_varDecls);
  l_body := Tpl.popIter(l_body);
  out_txt := Tpl.writeText(txt, l_auxFunction);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "/* Update the base clock. */\n",
                                       "void "
                                   }, false));
  out_txt := CodegenUtil.symbolName(out_txt, a_modelNamePrefix, "function_updateSynchronous");
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "(DATA *data, threadData_t *threadData, long i)\n",
                                       "{\n",
                                       "  TRACE_PUSH\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeText(out_txt, l_varDecls);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "modelica_boolean ret;\n",
                                       "switch (i) {\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeText(out_txt, l_body);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "default:\n",
                                       "  throwStreamPrint(NULL, \"Internal Error: unknown base partition %ld\", i);\n",
                                       "  break;\n"
                                   }, true));
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "}\n",
                                       "TRACE_POP\n"
                                   }, true));
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("}"));
end functionUpdateSynchronous;

protected function fun_79
  input Tpl.Text in_txt;
  input DAE.ClockKind in_a_baseClock;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_a_baseClock, in_a_auxFunction, in_a_varDecls, in_a_preExp)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      DAE.ClockKind i_baseClock;
      DAE.Exp ret_2;
      DAE.Exp ret_1;
      DAE.Exp ret_0;

    case ( txt,
           (i_baseClock as DAE.REAL_CLOCK(interval = _)),
           a_auxFunction,
           a_varDecls,
           a_preExp )
      equation
        ret_0 = Expression.getClockInterval(i_baseClock);
        (txt, a_preExp, a_varDecls, a_auxFunction) = CodegenCFunctions.daeExp(txt, ret_0, SimCodeFunction.contextOther, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           (i_baseClock as DAE.INTEGER_CLOCK(intervalCounter = _)),
           a_auxFunction,
           a_varDecls,
           a_preExp )
      equation
        ret_1 = Expression.getClockInterval(i_baseClock);
        (txt, a_preExp, a_varDecls, a_auxFunction) = CodegenCFunctions.daeExp(txt, ret_1, SimCodeFunction.contextOther, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           (i_baseClock as DAE.BOOLEAN_CLOCK(condition = _)),
           a_auxFunction,
           a_varDecls,
           a_preExp )
      equation
        ret_2 = Expression.getClockInterval(i_baseClock);
        (txt, a_preExp, a_varDecls, a_auxFunction) = CodegenCFunctions.daeExp(txt, ret_2, SimCodeFunction.contextOther, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           _,
           a_auxFunction,
           a_varDecls,
           a_preExp )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("unspecified"));
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end fun_79;

protected function fun_80
  input Tpl.Text in_txt;
  input String in_mArg;
  input Tpl.Text in_a_intvl;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_intvl)
    local
      Tpl.Text txt;
      Tpl.Text a_intvl;

    case ( txt,
           "unspecified",
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("1.0"));
      then txt;

    case ( txt,
           _,
           a_intvl )
      equation
        txt = Tpl.writeText(txt, a_intvl);
      then txt;
  end match;
end fun_80;

protected function fun_81
  input Tpl.Text in_txt;
  input String in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           "unspecified" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("ModelicaMessage(\"Using default Clock(1.0)!\");"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_81;

protected function fun_82
  input Tpl.Text in_txt;
  input DAE.ClockKind in_a_baseClock;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_baseClock, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.ClockKind i_baseClock;
      DAE.Exp i_startInterval;
      DAE.Exp i_condition;
      String str_8;
      Tpl.Text l_warning;
      String str_6;
      Tpl.Text l_interval;
      Tpl.Text l_intvl;
      Tpl.Text l_si;
      Tpl.Text l_preExp;
      DAE.ComponentRef ret_1;
      Tpl.Text l_cond;

    case ( txt,
           DAE.BOOLEAN_CLOCK(condition = i_condition, startInterval = i_startInterval),
           a_varDecls,
           a_auxFunction )
      equation
        ret_1 = Expression.expCref(i_condition);
        l_cond = CodegenCFunctions.cref(Tpl.emptyTxt, ret_1);
        l_preExp = Tpl.emptyTxt;
        (l_si, l_preExp, a_varDecls, a_auxFunction) = CodegenCFunctions.daeExp(Tpl.emptyTxt, i_startInterval, SimCodeFunction.contextOther, l_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "if (data->simulationInfo->clocksData[i].cnt > 0)\n",
                                    "  data->simulationInfo->clocksData[i].interval = data->localData[0]->timeValue - data->simulationInfo->clocksData[i].timepoint;\n",
                                    "else\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("data->simulationInfo->clocksData[i].interval = "));
        txt = Tpl.writeText(txt, l_si);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.popBlock(txt);
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           i_baseClock,
           a_varDecls,
           a_auxFunction )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_intvl, a_auxFunction, a_varDecls, l_preExp) = fun_79(Tpl.emptyTxt, i_baseClock, a_auxFunction, a_varDecls, l_preExp);
        str_6 = Tpl.textString(l_intvl);
        l_interval = fun_80(Tpl.emptyTxt, str_6, l_intvl);
        str_8 = Tpl.textString(l_intvl);
        l_warning = fun_81(Tpl.emptyTxt, str_8);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("data->simulationInfo->clocksData[i].interval = "));
        txt = Tpl.writeText(txt, l_interval);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.writeText(txt, l_warning);
      then (txt, a_varDecls, a_auxFunction);
  end match;
end fun_82;

public function updatePartition
  input Tpl.Text txt;
  input Integer a_i;
  input DAE.ClockKind a_baseClock;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) := fun_82(txt, a_baseClock, a_varDecls, a_auxFunction);
end updatePartition;

protected function fun_84
  input Tpl.Text in_txt;
  input SimCode.SubPartition in_a_subPartition;
  input String in_a_modelNamePrefix;
  input Integer in_a_clockIndex;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_subPartition, in_a_modelNamePrefix, in_a_clockIndex)
    local
      Tpl.Text txt;
      String a_modelNamePrefix;
      Integer a_clockIndex;
      list<SimCode.SimEqSystem> i_removedEquations;
      list<SimCode.SimEqSystem> i_equations;
      list<tuple<SimCodeVar.SimVar, Boolean>> i_vars;
      list<SimCode.SimEqSystem> ret_0;

    case ( txt,
           SimCode.SUBPARTITION(vars = i_vars, equations = i_equations, removedEquations = i_removedEquations),
           a_modelNamePrefix,
           a_clockIndex )
      equation
        ret_0 = listAppend(i_equations, i_removedEquations);
        txt = functionEquationsSynchronous(txt, a_clockIndex, i_vars, ret_0, a_modelNamePrefix);
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_84;

protected function lm_85
  input Tpl.Text in_txt;
  input list<SimCode.SubPartition> in_items;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      list<SimCode.SubPartition> rest;
      String a_modelNamePrefix;
      Integer x_clockIndex;
      SimCode.SubPartition i_subPartition;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_subPartition :: rest,
           a_modelNamePrefix )
      equation
        x_clockIndex = Tpl.getIteri_i0(txt);
        txt = fun_84(txt, i_subPartition, a_modelNamePrefix, x_clockIndex);
        txt = Tpl.nextIter(txt);
        txt = lm_85(txt, rest, a_modelNamePrefix);
      then txt;
  end match;
end lm_85;

protected function lm_86
  input Tpl.Text in_txt;
  input list<SimCode.SubPartition> in_items;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      list<SimCode.SubPartition> rest;
      String a_modelNamePrefix;
      Integer x_clockIndex;
      Tpl.Text l_name;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           _ :: rest,
           a_modelNamePrefix )
      equation
        x_clockIndex = Tpl.getIteri_i0(txt);
        l_name = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("functionEquationsSynchronous_system"));
        l_name = Tpl.writeStr(l_name, intString(x_clockIndex));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("case "));
        txt = Tpl.writeStr(txt, intString(x_clockIndex));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(":\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("ret = "));
        txt = CodegenUtil.symbolName(txt, a_modelNamePrefix, Tpl.textString(l_name));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(data, threadData);\n",
                                    "break;"
                                }, false));
        txt = Tpl.popBlock(txt);
        txt = Tpl.nextIter(txt);
        txt = lm_86(txt, rest, a_modelNamePrefix);
      then txt;
  end match;
end lm_86;

public function functionSystemsSynchronous
  input Tpl.Text txt;
  input list<SimCode.SubPartition> a_subPartitions;
  input String a_modelNamePrefix;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_cases;
  Tpl.Text l_systs;
algorithm
  l_systs := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  l_systs := lm_85(l_systs, a_subPartitions, a_modelNamePrefix);
  l_systs := Tpl.popIter(l_systs);
  l_cases := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  l_cases := lm_86(l_cases, a_subPartitions, a_modelNamePrefix);
  l_cases := Tpl.popIter(l_cases);
  out_txt := Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
  out_txt := Tpl.writeText(out_txt, l_systs);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "/*Clocked systems equations */\n",
                                       "int "
                                   }, false));
  out_txt := CodegenUtil.symbolName(out_txt, a_modelNamePrefix, "function_equationsSynchronous");
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "(DATA *data, threadData_t *threadData, long i)\n",
                                       "{\n",
                                       "  TRACE_PUSH\n",
                                       "  int ret;\n",
                                       "\n",
                                       "  switch (i) {\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(4));
  out_txt := Tpl.writeText(out_txt, l_cases);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "default:\n",
                                       "  throwStreamPrint(NULL, \"Internal Error: unknown sub partition %ld\", i);\n",
                                       "  ret = 1;\n",
                                       "  break;\n"
                                   }, true));
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "  }\n",
                                       "\n",
                                       "  TRACE_POP\n",
                                       "  return ret;\n",
                                       "}"
                                   }, false));
end functionSystemsSynchronous;

protected function lm_88
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input String in_a_modelNamePrefix;
  input Integer in_a_clockIndex;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefix, in_a_clockIndex)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      String a_modelNamePrefix;
      Integer a_clockIndex;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           {},
           _,
           _ )
      then txt;

    case ( txt,
           i_eq :: rest,
           a_modelNamePrefix,
           a_clockIndex )
      equation
        txt = equation_impl(txt, a_clockIndex, i_eq, SimCodeFunction.contextOther, a_modelNamePrefix, false);
        txt = Tpl.nextIter(txt);
        txt = lm_88(txt, rest, a_modelNamePrefix, a_clockIndex);
      then txt;
  end match;
end lm_88;

protected function lm_89
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      String a_modelNamePrefix;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_eq :: rest,
           a_modelNamePrefix )
      equation
        txt = equation_call(txt, i_eq, a_modelNamePrefix);
        txt = Tpl.nextIter(txt);
        txt = lm_89(txt, rest, a_modelNamePrefix);
      then txt;
  end match;
end lm_89;

public function functionEquationsSynchronous
  input Tpl.Text txt;
  input Integer a_clockIndex;
  input list<tuple<SimCodeVar.SimVar, Boolean>> a_vars;
  input list<SimCode.SimEqSystem> a_equations;
  input String a_modelNamePrefix;

  output Tpl.Text out_txt;
protected
  Tpl.Text txt_0;
algorithm
  out_txt := Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_88(out_txt, a_equations, a_modelNamePrefix, a_clockIndex);
  out_txt := Tpl.popIter(out_txt);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "int "
                                   }, false));
  txt_0 := Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("functionEquationsSynchronous_system"));
  txt_0 := Tpl.writeStr(txt_0, intString(a_clockIndex));
  out_txt := CodegenUtil.symbolName(out_txt, a_modelNamePrefix, Tpl.textString(txt_0));
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "(DATA *data, threadData_t *threadData)\n",
                                       "{\n",
                                       "  TRACE_PUSH\n",
                                       "  int i;\n",
                                       "\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := CodegenCFunctions.addRootsTempArray(out_txt);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_NEW_LINE());
  out_txt := Tpl.pushIter(out_txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_89(out_txt, a_equations, a_modelNamePrefix);
  out_txt := Tpl.popIter(out_txt);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "TRACE_POP\n",
                                       "return 0;\n"
                                   }, true));
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("}"));
end functionEquationsSynchronous;

public function simulationFile_exo
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      SimCode.SimCode i_simCode;
      SimCode.ExtObjInfo i_extObjInfo;
      String i_simCode_fileNamePrefix;
      Tpl.Text txt_0;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(fileNamePrefix = i_simCode_fileNamePrefix, extObjInfo = i_extObjInfo)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/* External objects file */\n"));
        txt = simulationFileHeader(txt, i_simCode_fileNamePrefix);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "#if defined(__cplusplus)\n",
                                    "extern \"C\" {\n",
                                    "#endif\n",
                                    "\n"
                                }, true));
        txt_0 = CodegenUtilSimulation.modelNamePrefix(Tpl.emptyTxt, i_simCode);
        txt = functionCallExternalObjectDestructors(txt, i_extObjInfo, Tpl.textString(txt_0));
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "#if defined(__cplusplus)\n",
                                    "}\n",
                                    "#endif\n"
                                }, true));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end simulationFile_exo;

protected function fun_92
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_modelNamePrefixStr;
  input list<SimCode.SimEqSystem> in_a_nonLinearSystems;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_modelNamePrefixStr, in_a_nonLinearSystems)
    local
      Tpl.Text txt;
      Tpl.Text a_modelNamePrefixStr;
      list<SimCode.SimEqSystem> a_nonLinearSystems;

    case ( txt,
           false,
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_modelNamePrefixStr,
           a_nonLinearSystems )
      equation
        txt = functionInitialNonLinearSystems(txt, a_nonLinearSystems, Tpl.textString(a_modelNamePrefixStr));
      then txt;
  end match;
end fun_92;

public function simulationFile_nls
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      Integer i_varInfo_numNonLinearSystems;
      list<SimCode.SimEqSystem> i_nonLinearSystems;
      String i_simCode_fileNamePrefix;
      SimCode.SimCode i_simCode;
      Boolean ret_1;
      Tpl.Text l_modelNamePrefixStr;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(varInfo = SimCode.VARINFO(numNonLinearSystems = i_varInfo_numNonLinearSystems), nonLinearSystems = i_nonLinearSystems), fileNamePrefix = i_simCode_fileNamePrefix)) )
      equation
        l_modelNamePrefixStr = CodegenUtilSimulation.modelNamePrefix(Tpl.emptyTxt, i_simCode);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/* Non Linear Systems */\n"));
        txt = simulationFileHeader(txt, i_simCode_fileNamePrefix);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#include \""));
        txt = Tpl.writeStr(txt, i_simCode_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_12jac.h\"\n",
                                    "#if defined(__cplusplus)\n",
                                    "extern \"C\" {\n",
                                    "#endif\n"
                                }, true));
        txt = functionNonLinearResiduals(txt, i_nonLinearSystems, Tpl.textString(l_modelNamePrefixStr));
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        ret_1 = intGt(i_varInfo_numNonLinearSystems, 0);
        txt = fun_92(txt, ret_1, l_modelNamePrefixStr, i_nonLinearSystems);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "#if defined(__cplusplus)\n",
                                    "}\n",
                                    "#endif\n"
                                }, true));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end simulationFile_nls;

protected function fun_94
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input SimCode.SimCode in_a_simCode;
  input list<SimCode.SimEqSystem> in_a_linearSystems;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_simCode, in_a_linearSystems)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      list<SimCode.SimEqSystem> a_linearSystems;
      Tpl.Text txt_0;

    case ( txt,
           false,
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_simCode,
           a_linearSystems )
      equation
        txt_0 = CodegenUtilSimulation.modelNamePrefix(Tpl.emptyTxt, a_simCode);
        txt = functionInitialLinearSystems(txt, a_linearSystems, Tpl.textString(txt_0));
      then txt;
  end match;
end fun_94;

public function simulationFile_lsy
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      Integer i_varInfo_numLinearSystems;
      SimCode.SimCode i_simCode;
      list<SimCode.SimEqSystem> i_linearSystems;
      String i_simCode_fileNamePrefix;
      Boolean ret_1;
      Tpl.Text txt_0;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(varInfo = SimCode.VARINFO(numLinearSystems = i_varInfo_numLinearSystems), linearSystems = i_linearSystems), fileNamePrefix = i_simCode_fileNamePrefix)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/* Linear Systems */\n"));
        txt = simulationFileHeader(txt, i_simCode_fileNamePrefix);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#include \""));
        txt = Tpl.writeStr(txt, i_simCode_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_12jac.h\"\n",
                                    "#if defined(__cplusplus)\n",
                                    "extern \"C\" {\n",
                                    "#endif\n",
                                    "\n"
                                }, true));
        txt_0 = CodegenUtilSimulation.modelNamePrefix(Tpl.emptyTxt, i_simCode);
        txt = functionSetupLinearSystems(txt, i_linearSystems, Tpl.textString(txt_0));
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        ret_1 = intGt(i_varInfo_numLinearSystems, 0);
        txt = fun_94(txt, ret_1, i_simCode, i_linearSystems);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "#if defined(__cplusplus)\n",
                                    "}\n",
                                    "#endif\n"
                                }, true));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end simulationFile_lsy;

public function simulationFile_set
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCode.StateSet> i_stateSets;
      SimCode.SimCode i_simCode;
      String i_simCode_fileNamePrefix;
      Tpl.Text txt_0;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(fileNamePrefix = i_simCode_fileNamePrefix, stateSets = i_stateSets)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/* Initial State Set */\n"));
        txt = simulationFileHeader(txt, i_simCode_fileNamePrefix);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#include \""));
        txt = Tpl.writeStr(txt, i_simCode_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_11mix.h\"\n",
                                    "#include \""
                                }, false));
        txt = Tpl.writeStr(txt, i_simCode_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_12jac.h\"\n",
                                    "#if defined(__cplusplus)\n",
                                    "extern \"C\" {\n",
                                    "#endif\n"
                                }, true));
        txt_0 = CodegenUtilSimulation.modelNamePrefix(Tpl.emptyTxt, i_simCode);
        txt = functionInitialStateSets(txt, i_simCode, i_stateSets, Tpl.textString(txt_0));
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "#if defined(__cplusplus)\n",
                                    "}\n",
                                    "#endif\n"
                                }, true));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end simulationFile_set;

public function simulationFile_evt
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      list<BackendDAE.ZeroCrossing> i_relations;
      list<SimCode.SimEqSystem> i_equationsForZeroCrossings;
      list<BackendDAE.ZeroCrossing> i_zeroCrossings;
      SimCode.SimCode i_simCode;
      list<BackendDAE.TimeEvent> i_timeEvents;
      String i_simCode_fileNamePrefix;
      Tpl.Text txt_2;
      Tpl.Text txt_1;
      Tpl.Text txt_0;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(fileNamePrefix = i_simCode_fileNamePrefix, timeEvents = i_timeEvents, zeroCrossings = i_zeroCrossings, equationsForZeroCrossings = i_equationsForZeroCrossings, relations = i_relations)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/* Events: Sample, Zero Crossings, Relations, Discrete Changes */\n"));
        txt = simulationFileHeader(txt, i_simCode_fileNamePrefix);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "#if defined(__cplusplus)\n",
                                    "extern \"C\" {\n",
                                    "#endif\n",
                                    "\n"
                                }, true));
        txt_0 = CodegenUtilSimulation.modelNamePrefix(Tpl.emptyTxt, i_simCode);
        txt = functionInitSample(txt, i_timeEvents, Tpl.textString(txt_0));
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt_1 = CodegenUtilSimulation.modelNamePrefix(Tpl.emptyTxt, i_simCode);
        txt = functionZeroCrossing(txt, i_zeroCrossings, i_equationsForZeroCrossings, Tpl.textString(txt_1));
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt_2 = CodegenUtilSimulation.modelNamePrefix(Tpl.emptyTxt, i_simCode);
        txt = functionRelations(txt, i_relations, Tpl.textString(txt_2));
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "#if defined(__cplusplus)\n",
                                    "}\n",
                                    "#endif\n"
                                }, true));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end simulationFile_evt;

protected function fun_98
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input SimCode.SimCode in_a_simCode;
  input list<SimCode.JacobianMatrix> in_a_jacobianMatrixes;
  input list<SimCode.SimEqSystem> in_a_allEquations;
  input list<SimCode.SimEqSystem> in_a_parameterEquations;
  input list<SimCode.SimEqSystem> in_a_initialEquations__lambda0;
  input list<SimCode.SimEqSystem> in_a_initialEquations;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_simCode, in_a_jacobianMatrixes, in_a_allEquations, in_a_parameterEquations, in_a_initialEquations__lambda0, in_a_initialEquations)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      list<SimCode.JacobianMatrix> a_jacobianMatrixes;
      list<SimCode.SimEqSystem> a_allEquations;
      list<SimCode.SimEqSystem> a_parameterEquations;
      list<SimCode.SimEqSystem> a_initialEquations__lambda0;
      list<SimCode.SimEqSystem> a_initialEquations;
      Tpl.Text txt_0;

    case ( txt,
           false,
           _,
           _,
           _,
           _,
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_simCode,
           a_jacobianMatrixes,
           a_allEquations,
           a_parameterEquations,
           a_initialEquations__lambda0,
           a_initialEquations )
      equation
        txt_0 = CodegenUtilSimulation.modelNamePrefix(Tpl.emptyTxt, a_simCode);
        txt = functionInitialMixedSystems(txt, a_initialEquations, a_initialEquations__lambda0, a_parameterEquations, a_allEquations, a_jacobianMatrixes, Tpl.textString(txt_0));
      then txt;
  end match;
end fun_98;

public function simulationFile_inz
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCode.JacobianMatrix> i_jacobianMatrixes;
      list<SimCode.SimEqSystem> i_allEquations;
      list<SimCode.SimEqSystem> i_parameterEquations;
      Integer i_varInfo_numMixedSystems;
      list<SimCode.SimEqSystem> i_removedInitialEquations;
      list<SimCode.SimEqSystem> i_initialEquations__lambda0;
      SimCode.SimCode i_simCode;
      String i_simCode_fullPathPrefix;
      list<SimCode.SimEqSystem> i_initialEquations;
      String i_simCode_fileNamePrefix;
      Boolean ret_6;
      Tpl.Text txt_5;
      Tpl.Text txt_4;
      Boolean ret_3;
      Integer ret_2;
      Tpl.Text txt_1;
      Integer ret_0;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(varInfo = SimCode.VARINFO(numMixedSystems = i_varInfo_numMixedSystems)), fileNamePrefix = i_simCode_fileNamePrefix, initialEquations = i_initialEquations, fullPathPrefix = i_simCode_fullPathPrefix, initialEquations_lambda0 = i_initialEquations__lambda0, removedInitialEquations = i_removedInitialEquations, parameterEquations = i_parameterEquations, allEquations = i_allEquations, jacobianMatrixes = i_jacobianMatrixes)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/* Initialization */\n"));
        txt = simulationFileHeader(txt, i_simCode_fileNamePrefix);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#include \""));
        txt = Tpl.writeStr(txt, i_simCode_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_11mix.h\"\n",
                                    "#include \""
                                }, false));
        txt = Tpl.writeStr(txt, i_simCode_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_12jac.h\"\n",
                                    "#if defined(__cplusplus)\n",
                                    "extern \"C\" {\n",
                                    "#endif\n",
                                    "\n"
                                }, true));
        ret_0 = listLength(i_initialEquations);
        txt_1 = CodegenUtilSimulation.modelNamePrefix(Tpl.emptyTxt, i_simCode);
        ret_2 = listLength(i_initialEquations__lambda0);
        ret_3 = intEq(ret_2, 0);
        txt = functionInitialEquations(txt, i_initialEquations, ret_0, i_simCode_fileNamePrefix, i_simCode_fullPathPrefix, Tpl.textString(txt_1), ret_3);
        txt = Tpl.softNewLine(txt);
        txt_4 = CodegenUtilSimulation.modelNamePrefix(Tpl.emptyTxt, i_simCode);
        txt = functionInitialEquations_lambda0(txt, i_initialEquations__lambda0, Tpl.textString(txt_4));
        txt = Tpl.softNewLine(txt);
        txt_5 = CodegenUtilSimulation.modelNamePrefix(Tpl.emptyTxt, i_simCode);
        txt = functionRemovedInitialEquations(txt, i_removedInitialEquations, Tpl.textString(txt_5));
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        ret_6 = intGt(i_varInfo_numMixedSystems, 0);
        txt = fun_98(txt, ret_6, i_simCode, i_jacobianMatrixes, i_allEquations, i_parameterEquations, i_initialEquations__lambda0, i_initialEquations);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "#if defined(__cplusplus)\n",
                                    "}\n",
                                    "#endif\n"
                                }, true));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end simulationFile_inz;

public function simulationFile_dly
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      SimCode.SimCode i_simCode;
      SimCode.DelayedExpression i_delayedExps;
      String i_simCode_fileNamePrefix;
      Tpl.Text txt_0;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(fileNamePrefix = i_simCode_fileNamePrefix, delayedExps = i_delayedExps)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/* Delay */\n"));
        txt = simulationFileHeader(txt, i_simCode_fileNamePrefix);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "#if defined(__cplusplus)\n",
                                    "extern \"C\" {\n",
                                    "#endif\n",
                                    "\n"
                                }, true));
        txt_0 = CodegenUtilSimulation.modelNamePrefix(Tpl.emptyTxt, i_simCode);
        txt = functionStoreDelayed(txt, i_delayedExps, Tpl.textString(txt_0));
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "#if defined(__cplusplus)\n",
                                    "}\n",
                                    "#endif\n"
                                }, true));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end simulationFile_dly;

public function simulationFile_bnd
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      String i_simCode_fullPathPrefix;
      list<SimCode.SimEqSystem> i_parameterEquations;
      list<SimCode.SimEqSystem> i_maxValueEquations;
      list<SimCode.SimEqSystem> i_minValueEquations;
      list<SimCode.SimEqSystem> i_nominalValueEquations;
      list<SimCode.SimEqSystem> i_startValueEquations;
      SimCode.SimCode i_simCode;
      String i_simCode_fileNamePrefix;
      Tpl.Text txt_3;
      list<SimCode.SimEqSystem> ret_2;
      list<SimCode.SimEqSystem> ret_1;
      Tpl.Text txt_0;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(fileNamePrefix = i_simCode_fileNamePrefix, startValueEquations = i_startValueEquations, nominalValueEquations = i_nominalValueEquations, minValueEquations = i_minValueEquations, maxValueEquations = i_maxValueEquations, parameterEquations = i_parameterEquations, fullPathPrefix = i_simCode_fullPathPrefix)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/* update bound parameters and variable attributes (start, nominal, min, max) */\n"));
        txt = simulationFileHeader(txt, i_simCode_fileNamePrefix);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "#if defined(__cplusplus)\n",
                                    "extern \"C\" {\n",
                                    "#endif\n",
                                    "\n"
                                }, true));
        txt_0 = CodegenUtilSimulation.modelNamePrefix(Tpl.emptyTxt, i_simCode);
        txt = functionUpdateBoundVariableAttributes(txt, i_simCode, i_startValueEquations, i_nominalValueEquations, i_minValueEquations, i_maxValueEquations, Tpl.textString(txt_0));
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        ret_1 = SimCodeUtil.selectScalarLiteralAssignments(i_parameterEquations);
        ret_2 = SimCodeUtil.filterScalarLiteralAssignments(i_parameterEquations);
        txt_3 = CodegenUtilSimulation.modelNamePrefix(Tpl.emptyTxt, i_simCode);
        txt = functionUpdateBoundParameters(txt, ret_1, ret_2, i_simCode_fileNamePrefix, i_simCode_fullPathPrefix, Tpl.textString(txt_3), i_simCode);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "#if defined(__cplusplus)\n",
                                    "}\n",
                                    "#endif\n"
                                }, true));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end simulationFile_bnd;

public function simulationFile_alg
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      SimCode.SimCode i_simCode;
      list<list<SimCode.SimEqSystem>> i_algebraicEquations;
      String i_simCode_fileNamePrefix;
      Tpl.Text txt_0;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(fileNamePrefix = i_simCode_fileNamePrefix, algebraicEquations = i_algebraicEquations)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/* Algebraic */\n"));
        txt = simulationFileHeader(txt, i_simCode_fileNamePrefix);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "#ifdef __cplusplus\n",
                                    "extern \"C\" {\n",
                                    "#endif\n",
                                    "\n"
                                }, true));
        txt_0 = CodegenUtilSimulation.modelNamePrefix(Tpl.emptyTxt, i_simCode);
        txt = functionAlgebraic(txt, i_algebraicEquations, Tpl.textString(txt_0));
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "#ifdef __cplusplus\n",
                                    "}\n",
                                    "#endif"
                                }, false));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end simulationFile_alg;

public function simulationFile_asr
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      SimCode.SimCode i_simCode;
      list<SimCode.SimEqSystem> i_algorithmAndEquationAsserts;
      String i_simCode_fileNamePrefix;
      Tpl.Text txt_0;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(fileNamePrefix = i_simCode_fileNamePrefix, algorithmAndEquationAsserts = i_algorithmAndEquationAsserts)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/* Asserts */\n"));
        txt = simulationFileHeader(txt, i_simCode_fileNamePrefix);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "#if defined(__cplusplus)\n",
                                    "extern \"C\" {\n",
                                    "#endif\n",
                                    "\n"
                                }, true));
        txt_0 = CodegenUtilSimulation.modelNamePrefix(Tpl.emptyTxt, i_simCode);
        txt = functionAssertsforCheck(txt, i_algorithmAndEquationAsserts, Tpl.textString(txt_0));
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "#if defined(__cplusplus)\n",
                                    "}\n",
                                    "#endif\n"
                                }, true));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end simulationFile_asr;

public function simulationFile_mix
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_header;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_header;
algorithm
  (out_txt, out_a_header) :=
  match(in_txt, in_a_simCode, in_a_header)
    local
      Tpl.Text txt;
      Tpl.Text a_header;
      list<SimCode.JacobianMatrix> i_jacobianMatrixes;
      list<SimCode.SimEqSystem> i_allEquations;
      list<SimCode.SimEqSystem> i_parameterEquations;
      list<SimCode.SimEqSystem> i_initialEquations__lambda0;
      list<SimCode.SimEqSystem> i_initialEquations;
      String i_simCode_fileNamePrefix;
      SimCode.SimCode i_simCode;
      Tpl.Text l_modelNamePrefixStr;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(fileNamePrefix = i_simCode_fileNamePrefix, initialEquations = i_initialEquations, initialEquations_lambda0 = i_initialEquations__lambda0, parameterEquations = i_parameterEquations, allEquations = i_allEquations, jacobianMatrixes = i_jacobianMatrixes)),
           a_header )
      equation
        l_modelNamePrefixStr = CodegenUtilSimulation.modelNamePrefix(Tpl.emptyTxt, i_simCode);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/* Mixed Systems */\n"));
        txt = simulationFileHeader(txt, i_simCode_fileNamePrefix);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#include \""));
        txt = Tpl.writeStr(txt, i_simCode_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_11mix.h\"\n"));
        (txt, a_header) = functionSetupMixedSystems(txt, i_initialEquations, i_initialEquations__lambda0, i_parameterEquations, i_allEquations, i_jacobianMatrixes, a_header, Tpl.textString(l_modelNamePrefixStr));
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then (txt, a_header);

    case ( txt,
           _,
           a_header )
      then (txt, a_header);
  end match;
end simulationFile_mix;

public function simulationFile_jac
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      SimCode.SimCode i_simCode;
      String i_fileNamePrefix;
      String i_simCode_fileNamePrefix;
      list<SimCode.JacobianMatrix> i_jacobianMatrixes;
      Tpl.Text txt_1;
      Integer ret_0;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(jacobianMatrixes = i_jacobianMatrixes, fileNamePrefix = (i_fileNamePrefix as i_simCode_fileNamePrefix))) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/* Jacobians "));
        ret_0 = listLength(i_jacobianMatrixes);
        txt = Tpl.writeStr(txt, intString(ret_0));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" */\n"));
        txt = simulationFileHeader(txt, i_simCode_fileNamePrefix);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#include \""));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_12jac.h\"\n"));
        txt_1 = CodegenUtilSimulation.modelNamePrefix(Tpl.emptyTxt, i_simCode);
        txt = functionAnalyticJacobians(txt, i_jacobianMatrixes, Tpl.textString(txt_1));
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end simulationFile_jac;

public function simulationFile_jac_header
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      SimCode.SimCode i_simCode;
      list<SimCode.JacobianMatrix> i_jacobianMatrixes;
      Tpl.Text txt_0;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(jacobianMatrixes = i_jacobianMatrixes)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "/* Jacobians */\n",
                                    "static const REAL_ATTRIBUTE dummyREAL_ATTRIBUTE = omc_dummyRealAttribute;\n"
                                }, true));
        txt_0 = CodegenUtilSimulation.modelNamePrefix(Tpl.emptyTxt, i_simCode);
        txt = symJacDefinition(txt, i_jacobianMatrixes, Tpl.textString(txt_0));
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end simulationFile_jac_header;

public function simulationFile_opt
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      list<DAE.ClassAttributes> i_classAttributes;
      String i_fileNamePrefix;
      String i_simCode_fileNamePrefix;
      SimCode.SimCode i_simCode;
      Tpl.Text l_modelNamePrefixStr;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(fileNamePrefix = (i_fileNamePrefix as i_simCode_fileNamePrefix), classAttributes = i_classAttributes)) )
      equation
        l_modelNamePrefixStr = CodegenUtilSimulation.modelNamePrefix(Tpl.emptyTxt, i_simCode);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/* Optimization */\n"));
        txt = simulationFileHeader(txt, i_simCode_fileNamePrefix);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#include \""));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_12jac.h\"\n",
                                    "#if defined(__cplusplus)\n",
                                    "extern \"C\" {\n",
                                    "#endif\n"
                                }, true));
        txt = optimizationComponents(txt, i_classAttributes, i_simCode, Tpl.textString(l_modelNamePrefixStr));
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "#if defined(__cplusplus)\n",
                                    "}\n",
                                    "#endif"
                                }, false));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end simulationFile_opt;

public function simulationFile_opt_header
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      SimCode.SimCode i_simCode;
      Tpl.Text l_modelNamePrefixStr;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = _)) )
      equation
        l_modelNamePrefixStr = CodegenUtilSimulation.modelNamePrefix(Tpl.emptyTxt, i_simCode);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "#if defined(__cplusplus)\n",
                                    "  extern \"C\" {\n",
                                    "#endif\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("int "));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "mayer");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA* data, modelica_real** res, short*);\n",
                                    "int "
                                }, false));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "lagrange");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA* data, modelica_real** res, short *, short *);\n",
                                    "int "
                                }, false));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "pickUpBoundsForInputsInOptimization");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA* data, modelica_real* min, modelica_real* max, modelica_real*nominal, modelica_boolean *useNominal, char ** name, modelica_real * start, modelica_real * startTimeOpt);\n",
                                    "int "
                                }, false));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "setInputData");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA *data, const modelica_boolean file);\n",
                                    "int "
                                }, false));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "getTimeGrid");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("(DATA *data, modelica_integer * nsi, modelica_real**t);\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "#if defined(__cplusplus)\n",
                                    "}\n",
                                    "#endif"
                                }, false));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end simulationFile_opt_header;

protected function fun_109
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input SimCode.SimCode in_a_simCode;
  input SimCode.ModelInfo in_a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_simCode, in_a_modelInfo)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      SimCode.ModelInfo a_modelInfo;
      Tpl.Text txt_0;

    case ( txt,
           false,
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_simCode,
           a_modelInfo )
      equation
        txt_0 = CodegenUtilSimulation.modelNamePrefix(Tpl.emptyTxt, a_simCode);
        txt = functionlinearmodelPython(txt, a_modelInfo, Tpl.textString(txt_0));
      then txt;
  end match;
end fun_109;

protected function fun_110
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input SimCode.SimCode in_a_simCode;
  input SimCode.ModelInfo in_a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_simCode, in_a_modelInfo)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      SimCode.ModelInfo a_modelInfo;
      Tpl.Text txt_2;
      Boolean ret_1;
      String ret_0;

    case ( txt,
           false,
           a_simCode,
           a_modelInfo )
      equation
        ret_0 = Flags.getConfigString(Flags.LINEARIZATION_DUMP_LANGUAGE);
        ret_1 = stringEq(ret_0, "python");
        txt = fun_109(txt, ret_1, a_simCode, a_modelInfo);
      then txt;

    case ( txt,
           _,
           a_simCode,
           a_modelInfo )
      equation
        txt_2 = CodegenUtilSimulation.modelNamePrefix(Tpl.emptyTxt, a_simCode);
        txt = functionlinearmodelJulia(txt, a_modelInfo, Tpl.textString(txt_2));
      then txt;
  end match;
end fun_110;

protected function fun_111
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input SimCode.SimCode in_a_simCode;
  input SimCode.ModelInfo in_a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_simCode, in_a_modelInfo)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      SimCode.ModelInfo a_modelInfo;
      Tpl.Text txt_2;
      Boolean ret_1;
      String ret_0;

    case ( txt,
           false,
           a_simCode,
           a_modelInfo )
      equation
        ret_0 = Flags.getConfigString(Flags.LINEARIZATION_DUMP_LANGUAGE);
        ret_1 = stringEq(ret_0, "julia");
        txt = fun_110(txt, ret_1, a_simCode, a_modelInfo);
      then txt;

    case ( txt,
           _,
           a_simCode,
           a_modelInfo )
      equation
        txt_2 = CodegenUtilSimulation.modelNamePrefix(Tpl.emptyTxt, a_simCode);
        txt = functionlinearmodelMatlab(txt, a_modelInfo, Tpl.textString(txt_2));
      then txt;
  end match;
end fun_111;

protected function fun_112
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input SimCode.SimCode in_a_simCode;
  input SimCode.ModelInfo in_a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_simCode, in_a_modelInfo)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      SimCode.ModelInfo a_modelInfo;
      Tpl.Text txt_2;
      Boolean ret_1;
      String ret_0;

    case ( txt,
           false,
           a_simCode,
           a_modelInfo )
      equation
        ret_0 = Flags.getConfigString(Flags.LINEARIZATION_DUMP_LANGUAGE);
        ret_1 = stringEq(ret_0, "matlab");
        txt = fun_111(txt, ret_1, a_simCode, a_modelInfo);
      then txt;

    case ( txt,
           _,
           a_simCode,
           a_modelInfo )
      equation
        txt_2 = CodegenUtilSimulation.modelNamePrefix(Tpl.emptyTxt, a_simCode);
        txt = functionlinearmodel(txt, a_modelInfo, Tpl.textString(txt_2));
      then txt;
  end match;
end fun_112;

public function simulationFile_lnz
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      SimCode.SimCode i_simCode;
      SimCode.ModelInfo i_modelInfo;
      String i_simCode_fileNamePrefix;
      Boolean ret_1;
      String ret_0;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(fileNamePrefix = i_simCode_fileNamePrefix, modelInfo = i_modelInfo)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/* Linearization */\n"));
        txt = simulationFileHeader(txt, i_simCode_fileNamePrefix);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "#if defined(__cplusplus)\n",
                                    "extern \"C\" {\n",
                                    "#endif\n"
                                }, true));
        ret_0 = Flags.getConfigString(Flags.LINEARIZATION_DUMP_LANGUAGE);
        ret_1 = stringEq(ret_0, "modelica");
        txt = fun_112(txt, ret_1, i_simCode, i_modelInfo);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "#if defined(__cplusplus)\n",
                                    "}\n",
                                    "#endif\n"
                                }, true));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end simulationFile_lnz;

public function defineSimVarArray
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_a_simVar;
  input String in_a_arrayName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simVar, in_a_arrayName)
    local
      Tpl.Text txt;
      String a_arrayName;
      DAE.ComponentRef i_name;
      Integer i_index;
      DAE.ComponentRef i_c;

    case ( txt,
           SimCodeVar.SIMVAR(arrayCref = SOME(i_c), aliasvar = SimCodeVar.NOALIAS(), index = i_index, name = i_name),
           a_arrayName )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/* "));
        txt = CodegenUtil.crefStrNoUnderscore(txt, i_c);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " */\n",
                                    "// #define "
                                }, false));
        txt = CodegenCFunctions.cref(txt, i_c);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" data->simulationInfo->daeModeData->"));
        txt = Tpl.writeStr(txt, a_arrayName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("["));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "]\n",
                                    "\n",
                                    "/* "
                                }, false));
        txt = CodegenUtil.crefStrNoUnderscore(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " */\n",
                                    "// #define "
                                }, false));
        txt = CodegenCFunctions.cref(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" data->simulationInfo->daeModeData->"));
        txt = Tpl.writeStr(txt, a_arrayName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("["));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "]\n",
                                    "\n"
                                }, true));
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(aliasvar = SimCodeVar.NOALIAS(), name = i_name, index = i_index),
           a_arrayName )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/* "));
        txt = CodegenUtil.crefStrNoUnderscore(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " */\n",
                                    "// #define "
                                }, false));
        txt = CodegenCFunctions.cref(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" data->simulationInfo->daeModeData->"));
        txt = Tpl.writeStr(txt, a_arrayName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("["));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "]\n",
                                    "\n"
                                }, true));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end defineSimVarArray;

protected function lm_115
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = defineSimVarArray(txt, i_var, "residualVars");
        txt = Tpl.nextIter(txt);
        txt = lm_115(txt, rest);
      then txt;
  end match;
end lm_115;

protected function lm_116
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = defineSimVarArray(txt, i_var, "auxiliaryVars");
        txt = Tpl.nextIter(txt);
        txt = lm_116(txt, rest);
      then txt;
  end match;
end lm_116;

public function simulationFile_dae_header
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      String i_fileNamePrefix;
      list<SimCodeVar.SimVar> i_auxiliaryVars;
      list<SimCodeVar.SimVar> i_residualVars;

    case ( txt,
           SimCode.SIMCODE(daeModeData = SOME(SimCode.DAEMODEDATA(residualVars = i_residualVars, auxiliaryVars = i_auxiliaryVars))) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/* residual variable define for daeMode */\n"));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_115(txt, i_residualVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/* auxiliary variable define for daeMode */\n"));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_116(txt, i_auxiliaryVars);
        txt = Tpl.popIter(txt);
      then txt;

    case ( txt,
           SimCode.SIMCODE(fileNamePrefix = i_fileNamePrefix) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#ifndef "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_16DAE_H\n",
                                    "#define "
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_16DAE_H\n",
                                    "#endif\n"
                                }, true));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end simulationFile_dae_header;

protected function fun_118
  input Tpl.Text in_txt;
  input Option<SimCode.JacobianMatrix> in_a_sparsityPattern;
  input Tpl.Text in_a_modelNamePrefixStr;
  input list<SimCodeVar.SimVar> in_a_auxiliaryVars;
  input list<SimCodeVar.SimVar> in_a_algebraicVars;
  input list<SimCodeVar.SimVar> in_a_residualVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_sparsityPattern, in_a_modelNamePrefixStr, in_a_auxiliaryVars, in_a_algebraicVars, in_a_residualVars)
    local
      Tpl.Text txt;
      Tpl.Text a_modelNamePrefixStr;
      list<SimCodeVar.SimVar> a_auxiliaryVars;
      list<SimCodeVar.SimVar> a_algebraicVars;
      list<SimCodeVar.SimVar> a_residualVars;
      Integer i_maxColor;
      list<list<Integer>> i_colorList;
      SimCode.SparsityPattern i_sparse;
      Integer ret_1;
      Integer ret_0;

    case ( txt,
           SOME(SimCode.JAC_MATRIX(sparsity = i_sparse, coloredCols = i_colorList, maxColorCols = i_maxColor)),
           a_modelNamePrefixStr,
           a_auxiliaryVars,
           a_algebraicVars,
           a_residualVars )
      equation
        ret_0 = listLength(a_residualVars);
        ret_1 = listLength(a_auxiliaryVars);
        txt = initializeDAEmodeData(txt, ret_0, a_algebraicVars, ret_1, i_sparse, i_colorList, i_maxColor, Tpl.textString(a_modelNamePrefixStr));
      then txt;

    case ( txt,
           NONE(),
           a_modelNamePrefixStr,
           _,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("int "));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(a_modelNamePrefixStr), "initializeDAEmodeData");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(DATA *inData, DAEMODE_DATA* daeModeData){ return -1; }"));
      then txt;

    case ( txt,
           _,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_118;

public function simulationFile_dae
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      list<list<SimCode.SimEqSystem>> i_daeEquations;
      String i_fileNamePrefix;
      list<SimCodeVar.SimVar> i_auxiliaryVars;
      list<SimCodeVar.SimVar> i_algebraicVars;
      list<SimCodeVar.SimVar> i_residualVars;
      Option<SimCode.JacobianMatrix> i_sparsityPattern;
      SimCode.SimCode i_simCode;
      Tpl.Text txt_2;
      Tpl.Text l_initDAEmode;
      Tpl.Text l_modelNamePrefixStr;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(vars = SimCodeVar.SIMVARS(stateVars = _)), daeModeData = SOME(SimCode.DAEMODEDATA(daeEquations = i_daeEquations, sparsityPattern = i_sparsityPattern, algebraicVars = i_algebraicVars, residualVars = i_residualVars, auxiliaryVars = i_auxiliaryVars)), fileNamePrefix = i_fileNamePrefix)) )
      equation
        l_modelNamePrefixStr = CodegenUtilSimulation.modelNamePrefix(Tpl.emptyTxt, i_simCode);
        l_initDAEmode = fun_118(Tpl.emptyTxt, i_sparsityPattern, l_modelNamePrefixStr, i_auxiliaryVars, i_algebraicVars, i_residualVars);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/* DAE residuals */\n"));
        txt = simulationFileHeader(txt, i_fileNamePrefix);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "#include \"simulation/solver/dae_mode.h\"\n",
                                    "\n",
                                    "#ifdef __cplusplus\n",
                                    "extern \"C\" {\n",
                                    "#endif\n",
                                    "\n"
                                }, true));
        txt = evaluateDAEResiduals(txt, i_daeEquations, Tpl.textString(l_modelNamePrefixStr));
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_initDAEmode);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "#ifdef __cplusplus\n",
                                    "}\n",
                                    "#endif"
                                }, false));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           i_simCode )
      equation
        l_modelNamePrefixStr = CodegenUtilSimulation.modelNamePrefix(Tpl.emptyTxt, i_simCode);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/* DAE residuals is empty */\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt_2 = CodegenUtilSimulation.fileNamePrefix(Tpl.emptyTxt, i_simCode);
        txt = simulationFileHeader(txt, Tpl.textString(txt_2));
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "#ifdef __cplusplus\n",
                                    "extern \"C\" {\n",
                                    "#endif\n",
                                    "int "
                                }, false));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "initializeDAEmodeData");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA *inData, DAEMODE_DATA* daeModeData){ return -1; }\n",
                                    "#ifdef __cplusplus\n",
                                    "}\n",
                                    "#endif"
                                }, false));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;
  end match;
end simulationFile_dae;

protected function fun_120
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("  return -1;"));
      then txt;
  end match;
end fun_120;

protected function fun_121
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("  return 0;"));
      then txt;
  end match;
end fun_121;

protected function lm_122
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input Tpl.Text in_a_modelNamePrefixStr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefixStr)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      Tpl.Text a_modelNamePrefixStr;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_eq :: rest,
           a_modelNamePrefixStr )
      equation
        txt = equationNames_(txt, i_eq, SimCodeFunction.contextSimulationNonDiscrete, Tpl.textString(a_modelNamePrefixStr));
        txt = Tpl.nextIter(txt);
        txt = lm_122(txt, rest, a_modelNamePrefixStr);
      then txt;
  end match;
end lm_122;

protected function lm_123
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input Tpl.Text in_a_modelNamePrefixStr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefixStr)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      Tpl.Text a_modelNamePrefixStr;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_eq :: rest,
           a_modelNamePrefixStr )
      equation
        txt = equation_impl(txt, -1, i_eq, SimCodeFunction.contextSimulationNonDiscrete, Tpl.textString(a_modelNamePrefixStr), false);
        txt = Tpl.nextIter(txt);
        txt = lm_123(txt, rest, a_modelNamePrefixStr);
      then txt;
  end match;
end lm_123;

public function simulationFile_inl
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> i_inlineEquations;
      SimCode.SimCode i_simCode;
      Tpl.Text txt_7;
      Tpl.Text l_funcNames;
      Boolean ret_5;
      Integer ret_4;
      Boolean ret_3;
      Integer ret_2;
      Tpl.Text txt_1;
      Tpl.Text l_modelNamePrefixStr;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(vars = SimCodeVar.SIMVARS(stateVars = _)), inlineEquations = {})) )
      equation
        l_modelNamePrefixStr = CodegenUtilSimulation.modelNamePrefix(Tpl.emptyTxt, i_simCode);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/* Inline equation file is empty */\n"));
        txt_1 = CodegenUtilSimulation.fileNamePrefix(Tpl.emptyTxt, i_simCode);
        txt = simulationFileHeader(txt, Tpl.textString(txt_1));
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "#ifdef __cplusplus\n",
                                    "extern \"C\" {\n",
                                    "#endif\n",
                                    "int "
                                }, false));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "symbolicInlineSystem");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("(DATA *data, threadData_t *threadData){\n"));
        ret_2 = Flags.getConfigEnum(Flags.SYM_SOLVER);
        ret_3 = intEq(ret_2, 0);
        txt = fun_120(txt, ret_3);
        txt = Tpl.softNewLine(txt);
        ret_4 = Flags.getConfigEnum(Flags.SYM_SOLVER);
        ret_5 = intGt(ret_4, 0);
        txt = fun_121(txt, ret_5);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "#ifdef __cplusplus\n",
                                    "}\n",
                                    "#endif"
                                }, false));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(vars = SimCodeVar.SIMVARS(stateVars = _)), inlineEquations = i_inlineEquations)) )
      equation
        l_modelNamePrefixStr = CodegenUtilSimulation.modelNamePrefix(Tpl.emptyTxt, i_simCode);
        l_funcNames = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_funcNames = lm_122(l_funcNames, i_inlineEquations, l_modelNamePrefixStr);
        l_funcNames = Tpl.popIter(l_funcNames);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/* Inline equation file */\n"));
        txt_7 = CodegenUtilSimulation.fileNamePrefix(Tpl.emptyTxt, i_simCode);
        txt = simulationFileHeader(txt, Tpl.textString(txt_7));
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "#ifdef __cplusplus\n",
                                    "extern \"C\" {\n",
                                    "#endif\n",
                                    "\n"
                                }, true));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_123(txt, i_inlineEquations, l_modelNamePrefixStr);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "/* inline equations*/\n",
                                    "int "
                                }, false));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "symbolicInlineSystem");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA *data, threadData_t *threadData){\n",
                                    "\n",
                                    "  TRACE_PUSH\n",
                                    "\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_funcNames);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "TRACE_POP\n",
                                    "return 0;\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n",
                                    "#ifdef __cplusplus\n",
                                    "}\n",
                                    "#endif"
                                }, false));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end simulationFile_inl;

protected function fun_125
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "MMC_INIT(0);\n",
                                    "omc_alloc_interface.init();"
                                }, false));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "mmc_init_nogc();\n",
                                    "omc_alloc_interface = omc_alloc_interface_pooled;\n",
                                    "omc_alloc_interface.init();"
                                }, false));
      then txt;
  end match;
end fun_125;

protected function fun_126
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;
      Boolean ret_1;
      String ret_0;

    case ( txt,
           false )
      equation
        ret_0 = Config.simCodeTarget();
        ret_1 = stringEq(ret_0, "JavaScript");
        txt = fun_125(txt, ret_1);
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "mmc_init_nogc();\n",
                                    "omc_alloc_interface = omc_alloc_interface_pooled;\n",
                                    "omc_alloc_interface.init();"
                                }, false));
      then txt;
  end match;
end fun_126;

protected function fun_127
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_fileNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_fileNamePrefix)
    local
      Tpl.Text txt;
      String a_fileNamePrefix;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_fileNamePrefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "pm_model = PM_Model_create(\""
                                }, false));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\", &data, threadData, 0 /*num threads*/);\n",
                                    "PM_Model_load_ODE_system(pm_model, functionODE_systems);\n",
                                    "\n"
                                }, true));
      then txt;
  end match;
end fun_127;

protected function fun_128
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_modelNamePrefixStr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_modelNamePrefixStr)
    local
      Tpl.Text txt;
      Tpl.Text a_modelNamePrefixStr;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_modelNamePrefixStr )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#define prefixedName_performSimulation "));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(a_modelNamePrefixStr), "performSimulation");
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#define prefixedName_updateContinuousSystem "));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(a_modelNamePrefixStr), "updateContinuousSystem");
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "#include <simulation/solver/perform_simulation.c.inc>\n",
                                    "\n",
                                    "#define prefixedName_performQSSSimulation "
                                }, false));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(a_modelNamePrefixStr), "performQSSSimulation");
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#include <simulation/solver/perform_qss_simulation.c.inc>"));
      then txt;
  end match;
end fun_128;

protected function fun_129
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void* pm_model = NULL;"));
      then txt;
  end match;
end fun_129;

protected function fun_130
  input Tpl.Text in_txt;
  input Option<SimCode.SimulationSettings> in_a_simulationSettingsOpt;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simulationSettingsOpt)
    local
      Tpl.Text txt;
      String i_settings_method;

    case ( txt,
           SOME(SimCode.SIMULATION_SETTINGS(method = i_settings_method)) )
      equation
        txt = Tpl.writeStr(txt, i_settings_method);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_130;

protected function fun_131
  input Tpl.Text in_txt;
  input String in_a_isModelExchangeFMU;
  input Tpl.Text in_a_modelNamePrefixStr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_isModelExchangeFMU, in_a_modelNamePrefixStr)
    local
      Tpl.Text txt;
      Tpl.Text a_modelNamePrefixStr;

    case ( txt,
           "",
           a_modelNamePrefixStr )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(int (*)(DATA *, threadData_t *, void *)) "));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(a_modelNamePrefixStr), "performSimulation");
      then txt;

    case ( txt,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("NULL"));
      then txt;
  end match;
end fun_131;

protected function fun_132
  input Tpl.Text in_txt;
  input String in_a_isModelExchangeFMU;
  input Tpl.Text in_a_modelNamePrefixStr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_isModelExchangeFMU, in_a_modelNamePrefixStr)
    local
      Tpl.Text txt;
      Tpl.Text a_modelNamePrefixStr;

    case ( txt,
           "",
           a_modelNamePrefixStr )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(int (*)(DATA *, threadData_t *, void *)) "));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(a_modelNamePrefixStr), "performQSSSimulation");
      then txt;

    case ( txt,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("NULL"));
      then txt;
  end match;
end fun_132;

protected function fun_133
  input Tpl.Text in_txt;
  input String in_a_isModelExchangeFMU;
  input Tpl.Text in_a_modelNamePrefixStr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_isModelExchangeFMU, in_a_modelNamePrefixStr)
    local
      Tpl.Text txt;
      Tpl.Text a_modelNamePrefixStr;

    case ( txt,
           "",
           a_modelNamePrefixStr )
      equation
        txt = CodegenUtil.symbolName(txt, Tpl.textString(a_modelNamePrefixStr), "updateContinuousSystem");
      then txt;

    case ( txt,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("NULL"));
      then txt;
  end match;
end fun_133;

protected function fun_134
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_modelNamePrefixStr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_modelNamePrefixStr)
    local
      Tpl.Text txt;
      Tpl.Text a_modelNamePrefixStr;

    case ( txt,
           false,
           a_modelNamePrefixStr )
      equation
        txt = CodegenUtil.symbolName(txt, Tpl.textString(a_modelNamePrefixStr), "initialNonLinearSystem");
      then txt;

    case ( txt,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("NULL"));
      then txt;
  end match;
end fun_134;

protected function fun_135
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_modelNamePrefixStr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_modelNamePrefixStr)
    local
      Tpl.Text txt;
      Tpl.Text a_modelNamePrefixStr;

    case ( txt,
           false,
           a_modelNamePrefixStr )
      equation
        txt = CodegenUtil.symbolName(txt, Tpl.textString(a_modelNamePrefixStr), "initialLinearSystem");
      then txt;

    case ( txt,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("NULL"));
      then txt;
  end match;
end fun_135;

protected function fun_136
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_modelNamePrefixStr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_modelNamePrefixStr)
    local
      Tpl.Text txt;
      Tpl.Text a_modelNamePrefixStr;

    case ( txt,
           false,
           a_modelNamePrefixStr )
      equation
        txt = CodegenUtil.symbolName(txt, Tpl.textString(a_modelNamePrefixStr), "initialMixedSystem");
      then txt;

    case ( txt,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("NULL"));
      then txt;
  end match;
end fun_136;

protected function fun_137
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("0"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("1"));
      then txt;
  end match;
end fun_137;

protected function fun_138
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("3"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("2"));
      then txt;
  end match;
end fun_138;

protected function fun_139
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           false )
      equation
        ret_0 = Config.globalHomotopy();
        txt = fun_137(txt, ret_0);
      then txt;

    case ( txt,
           _ )
      equation
        ret_1 = Config.globalHomotopy();
        txt = fun_138(txt, ret_1);
      then txt;
  end match;
end fun_139;

protected function fun_140
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_modelNamePrefixStr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_modelNamePrefixStr)
    local
      Tpl.Text txt;
      Tpl.Text a_modelNamePrefixStr;

    case ( txt,
           false,
           a_modelNamePrefixStr )
      equation
        txt = CodegenUtil.symbolName(txt, Tpl.textString(a_modelNamePrefixStr), "functionInitialEquations_lambda0");
      then txt;

    case ( txt,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("NULL"));
      then txt;
  end match;
end fun_140;

protected function fun_141
  input Tpl.Text in_txt;
  input String in_a_isModelExchangeFMU;
  input Tpl.Text in_a_modelNamePrefixStr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_isModelExchangeFMU, in_a_modelNamePrefixStr)
    local
      Tpl.Text txt;
      Tpl.Text a_modelNamePrefixStr;

    case ( txt,
           "",
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("NULL"));
      then txt;

    case ( txt,
           _,
           a_modelNamePrefixStr )
      equation
        txt = CodegenUtil.symbolName(txt, Tpl.textString(a_modelNamePrefixStr), "read_input_fmu");
      then txt;
  end match;
end fun_141;

protected function fun_142
  input Tpl.Text in_txt;
  input Option<SimCode.FmiModelStructure> in_a_modelStructure;
  input Tpl.Text in_a_modelNamePrefixStr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelStructure, in_a_modelNamePrefixStr)
    local
      Tpl.Text txt;
      Tpl.Text a_modelNamePrefixStr;

    case ( txt,
           SOME(SimCode.FMIMODELSTRUCTURE(continuousPartialDerivatives = SOME(_))),
           a_modelNamePrefixStr )
      equation
        txt = CodegenUtil.symbolName(txt, Tpl.textString(a_modelNamePrefixStr), "initialAnalyticJacobianFMIDER");
      then txt;

    case ( txt,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("NULL"));
      then txt;
  end match;
end fun_142;

protected function fun_143
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_modelNamePrefixStr;
  input Option<SimCode.FmiModelStructure> in_a_modelStructure;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_modelNamePrefixStr, in_a_modelStructure)
    local
      Tpl.Text txt;
      Tpl.Text a_modelNamePrefixStr;
      Option<SimCode.FmiModelStructure> a_modelStructure;

    case ( txt,
           false,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("NULL"));
      then txt;

    case ( txt,
           _,
           a_modelNamePrefixStr,
           a_modelStructure )
      equation
        txt = fun_142(txt, a_modelStructure, a_modelNamePrefixStr);
      then txt;
  end match;
end fun_143;

protected function fun_144
  input Tpl.Text in_txt;
  input Option<SimCode.FmiModelStructure> in_a_modelStructure;
  input Tpl.Text in_a_modelNamePrefixStr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelStructure, in_a_modelNamePrefixStr)
    local
      Tpl.Text txt;
      Tpl.Text a_modelNamePrefixStr;

    case ( txt,
           SOME(SimCode.FMIMODELSTRUCTURE(continuousPartialDerivatives = SOME(_))),
           a_modelNamePrefixStr )
      equation
        txt = CodegenUtil.symbolName(txt, Tpl.textString(a_modelNamePrefixStr), "functionJacFMIDER_column");
      then txt;

    case ( txt,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("NULL"));
      then txt;
  end match;
end fun_144;

protected function fun_145
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_modelNamePrefixStr;
  input Option<SimCode.FmiModelStructure> in_a_modelStructure;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_modelNamePrefixStr, in_a_modelStructure)
    local
      Tpl.Text txt;
      Tpl.Text a_modelNamePrefixStr;
      Option<SimCode.FmiModelStructure> a_modelStructure;

    case ( txt,
           false,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("NULL"));
      then txt;

    case ( txt,
           _,
           a_modelNamePrefixStr,
           a_modelStructure )
      equation
        txt = fun_144(txt, a_modelStructure, a_modelNamePrefixStr);
      then txt;
  end match;
end fun_145;

protected function fun_146
  input Tpl.Text in_txt;
  input Option<SimCode.FmiModelStructure> in_a_modelStructure;
  input Tpl.Text in_a_modelNamePrefixStr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelStructure, in_a_modelNamePrefixStr)
    local
      Tpl.Text txt;
      Tpl.Text a_modelNamePrefixStr;

    case ( txt,
           SOME(SimCode.FMIMODELSTRUCTURE(continuousPartialDerivatives = SOME(_))),
           a_modelNamePrefixStr )
      equation
        txt = CodegenUtil.symbolName(txt, Tpl.textString(a_modelNamePrefixStr), "INDEX_JAC_FMIDER");
      then txt;

    case ( txt,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-1"));
      then txt;
  end match;
end fun_146;

protected function fun_147
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_modelNamePrefixStr;
  input Option<SimCode.FmiModelStructure> in_a_modelStructure;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_modelNamePrefixStr, in_a_modelStructure)
    local
      Tpl.Text txt;
      Tpl.Text a_modelNamePrefixStr;
      Option<SimCode.FmiModelStructure> a_modelStructure;

    case ( txt,
           false,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-1"));
      then txt;

    case ( txt,
           _,
           a_modelNamePrefixStr,
           a_modelStructure )
      equation
        txt = fun_146(txt, a_modelStructure, a_modelNamePrefixStr);
      then txt;
  end match;
end fun_147;

protected function fun_148
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("0"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("2"));
      then txt;
  end match;
end fun_148;

protected function fun_149
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;
      Boolean ret_0;

    case ( txt,
           false )
      equation
        ret_0 = Config.profileAll();
        txt = fun_148(txt, ret_0);
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("1"));
      then txt;
  end match;
end fun_149;

protected function fun_150
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;
      Boolean ret_0;

    case ( txt,
           false )
      equation
        ret_0 = Config.profileSome();
        txt = fun_149(txt, ret_0);
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("5"));
      then txt;
  end match;
end fun_150;

protected function fun_151
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("0"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("1"));
      then txt;
  end match;
end fun_151;

protected function fun_152
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("terminateHpcOmThreads();"));
      then txt;
  end match;
end fun_152;

protected function fun_153
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("dump_times(pm_model);"));
      then txt;
  end match;
end fun_153;

protected function fun_154
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_mainBody;
  input Tpl.Text in_a_mainInit;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_mainBody;
algorithm
  (out_txt, out_a_mainBody) :=
  match(in_txt, in_mArg, in_a_mainBody, in_a_mainInit)
    local
      Tpl.Text txt;
      Tpl.Text a_mainBody;
      Tpl.Text a_mainInit;
      Boolean ret_5;
      Boolean ret_4;
      Integer ret_3;
      Integer ret_2;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           false,
           a_mainBody,
           _ )
      then (txt, a_mainBody);

    case ( txt,
           _,
           a_mainBody,
           a_mainInit )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "#if defined(threadData)\n",
                                    "#undef threadData\n",
                                    "#endif\n",
                                    "/* call the simulation runtime main from our main! */\n",
                                    "int main(int argc, char**argv)\n",
                                    "{\n",
                                    "  int res;\n",
                                    "  DATA data;\n",
                                    "  MODEL_DATA modelData;\n",
                                    "  SIMULATION_INFO simInfo;\n",
                                    "  data.modelData = &modelData;\n",
                                    "  data.simulationInfo = &simInfo;\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("measure_time_flag = "));
        ret_0 = Config.profileHtml();
        txt = fun_150(txt, ret_0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "compiledInDAEMode = "
                                }, false));
        ret_1 = Flags.getConfigBool(Flags.DAE_MODE);
        txt = fun_151(txt, ret_1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "compiledWithSymSolver = "
                                }, false));
        ret_2 = Flags.getConfigEnum(Flags.SYM_SOLVER);
        ret_3 = intSub(ret_2, 0);
        txt = Tpl.writeStr(txt, intString(ret_3));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.writeText(txt, a_mainInit);
        txt = Tpl.softNewLine(txt);
        (txt, a_mainBody) = CodegenCFunctions.mainTop(txt, a_mainBody, "https://trac.openmodelica.org/OpenModelica/newticket");
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        ret_4 = Flags.isSet(Flags.HPCOM);
        txt = fun_152(txt, ret_4);
        txt = Tpl.softNewLine(txt);
        ret_5 = Flags.getConfigBool(Flags.PARMODAUTO);
        txt = fun_153(txt, ret_5);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "fflush(NULL);\n",
                                    "EXIT(res);\n",
                                    "return res;\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n",
                                    "#ifdef __cplusplus\n",
                                    "}\n",
                                    "#endif\n",
                                    "\n"
                                }, true));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then (txt, a_mainBody);
  end match;
end fun_154;

public function simulationFile
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input String in_a_guid;
  input String in_a_isModelExchangeFMU;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode, in_a_guid, in_a_isModelExchangeFMU)
    local
      Tpl.Text txt;
      String a_guid;
      String a_isModelExchangeFMU;
      SimCode.DelayedExpression i_delayedExps;
      Option<SimCode.FmiModelStructure> i_modelStructure;
      list<SimCode.SimEqSystem> i_initialEquations__lambda0;
      Integer i_varInfo_numMixedSystems;
      Integer i_varInfo_numLinearSystems;
      Integer i_varInfo_numNonLinearSystems;
      Option<tuple<HpcOmSimCode.Schedule, HpcOmSimCode.Schedule, HpcOmSimCode.Schedule>> i_hpcomData_schedules;
      Option<SimCode.SimulationSettings> i_simulationSettingsOpt;
      list<list<SimCode.SimEqSystem>> i_odeEquations;
      list<SimCode.SimEqSystem> i_localKnownVars;
      list<SimCode.SimEqSystem> i_allEquations;
      SimCode.ModelInfo i_modelInfo;
      String i_simCode_fileNamePrefix;
      String i_fileNamePrefix;
      SimCode.SimCode i_simCode;
      Boolean ret_21;
      Boolean ret_20;
      Boolean ret_19;
      Boolean ret_18;
      Boolean ret_17;
      Integer ret_16;
      Boolean ret_15;
      Boolean ret_14;
      Boolean ret_13;
      Boolean ret_12;
      Tpl.Text txt_11;
      Boolean ret_10;
      Boolean ret_9;
      Tpl.Text l_mainBody;
      Boolean ret_7;
      Tpl.Text l_pminit;
      Boolean ret_5;
      Boolean ret_4;
      Boolean ret_3;
      Boolean ret_2;
      Tpl.Text l_mainInit;
      Tpl.Text l_modelNamePrefixStr;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = (i_modelInfo as SimCode.MODELINFO(varInfo = SimCode.VARINFO(numNonLinearSystems = i_varInfo_numNonLinearSystems, numLinearSystems = i_varInfo_numLinearSystems, numMixedSystems = i_varInfo_numMixedSystems))), hpcomData = HpcOmSimCode.HPCOMDATA(schedules = i_hpcomData_schedules), fileNamePrefix = (i_simCode_fileNamePrefix as i_fileNamePrefix), allEquations = i_allEquations, localKnownVars = i_localKnownVars, odeEquations = i_odeEquations, simulationSettingsOpt = i_simulationSettingsOpt, initialEquations_lambda0 = i_initialEquations__lambda0, modelStructure = i_modelStructure, delayedExps = i_delayedExps)),
           a_guid,
           a_isModelExchangeFMU )
      equation
        l_modelNamePrefixStr = CodegenUtilSimulation.modelNamePrefix(Tpl.emptyTxt, i_simCode);
        ret_2 = stringEq("", a_isModelExchangeFMU);
        ret_3 = boolNot(ret_2);
        ret_4 = Flags.isSet(Flags.HPCOM);
        ret_5 = boolOr(ret_3, ret_4);
        l_mainInit = fun_126(Tpl.emptyTxt, ret_5);
        ret_7 = Flags.getConfigBool(Flags.PARMODAUTO);
        l_pminit = fun_127(Tpl.emptyTxt, ret_7, i_fileNamePrefix);
        l_mainBody = CodegenUtil.symbolName(Tpl.emptyTxt, Tpl.textString(l_modelNamePrefixStr), "setupDataStruc");
        l_mainBody = Tpl.writeTok(l_mainBody, Tpl.ST_LINE("(&data, threadData);\n"));
        l_mainBody = Tpl.writeText(l_mainBody, l_pminit);
        l_mainBody = Tpl.softNewLine(l_mainBody);
        l_mainBody = Tpl.writeTok(l_mainBody, Tpl.ST_STRING("res = _main_SimulationRuntime(argc, argv, &data, threadData);"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "/* Main Simulation File */\n",
                                    "\n",
                                    "#if defined(__cplusplus)\n",
                                    "extern \"C\" {\n",
                                    "#endif\n",
                                    "\n"
                                }, true));
        txt = simulationFileHeader(txt, i_simCode_fileNamePrefix);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "#include \"simulation/solver/events.h\"\n",
                                    "\n"
                                }, true));
        ret_9 = stringEq("", a_isModelExchangeFMU);
        txt = fun_128(txt, ret_9, l_modelNamePrefixStr);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        ret_10 = Flags.getConfigBool(Flags.PARMODAUTO);
        txt = fun_129(txt, ret_10);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "/* dummy VARINFO and FILEINFO */\n",
                                    "const FILE_INFO dummyFILE_INFO = omc_dummyFileInfo;\n",
                                    "const VAR_INFO dummyVAR_INFO = omc_dummyVarInfo;\n",
                                    "\n"
                                }, true));
        txt = functionInput(txt, i_simCode, i_modelInfo, Tpl.textString(l_modelNamePrefixStr));
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = functionDataInput(txt, i_simCode, i_modelInfo, Tpl.textString(l_modelNamePrefixStr));
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = functionOutput(txt, i_modelInfo, Tpl.textString(l_modelNamePrefixStr));
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = functionSetC(txt, i_modelInfo, Tpl.textString(l_modelNamePrefixStr));
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = functionDAE(txt, i_allEquations, Tpl.textString(l_modelNamePrefixStr));
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = functionLocalKnownVars(txt, i_localKnownVars, Tpl.textString(l_modelNamePrefixStr));
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt_11 = fun_130(Tpl.emptyTxt, i_simulationSettingsOpt);
        (txt, txt_11) = functionODE(txt, i_odeEquations, txt_11, i_hpcomData_schedules, Tpl.textString(l_modelNamePrefixStr));
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "/* forward the main in the simulation runtime */\n",
                                    "extern int _main_SimulationRuntime(int argc, char**argv, DATA *data, threadData_t *threadData);\n",
                                    "\n",
                                    "#include \""
                                }, false));
        txt = Tpl.writeStr(txt, i_simCode_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_12jac.h\"\n",
                                    "#include \""
                                }, false));
        txt = Tpl.writeStr(txt, i_simCode_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_13opt.h\"\n",
                                    "\n",
                                    "struct OpenModelicaGeneratedFunctionCallbacks "
                                }, false));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "callback");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" = {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(3));
        txt = fun_131(txt, a_isModelExchangeFMU, l_modelNamePrefixStr);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",    /* performSimulation */\n"));
        txt = fun_132(txt, a_isModelExchangeFMU, l_modelNamePrefixStr);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",    /* performQSSSimulation */\n"));
        txt = fun_133(txt, a_isModelExchangeFMU, l_modelNamePrefixStr);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",    /* updateContinuousSystem */\n"));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "callExternalObjectDestructors");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",    /* callExternalObjectDestructors */\n"));
        ret_12 = intEq(i_varInfo_numNonLinearSystems, 0);
        txt = fun_134(txt, ret_12, l_modelNamePrefixStr);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",    /* initialNonLinearSystem */\n"));
        ret_13 = intEq(i_varInfo_numLinearSystems, 0);
        txt = fun_135(txt, ret_13, l_modelNamePrefixStr);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",    /* initialLinearSystem */\n"));
        ret_14 = intEq(i_varInfo_numMixedSystems, 0);
        txt = fun_136(txt, ret_14, l_modelNamePrefixStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ",    /* initialMixedSystem */\n",
                                    "#if !defined(OMC_NO_STATESELECTION)\n"
                                }, true));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "initializeStateSets");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ",\n",
                                    "#else\n",
                                    "NULL,\n",
                                    "#endif    /* initializeStateSets */\n"
                                }, true));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "initializeDAEmodeData");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "functionODE");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "functionAlgebraics");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "functionDAE");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "functionLocalKnownVars");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "input_function");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "input_function_init");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "input_function_updateStartValues");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "data_function");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "output_function");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "setc_function");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "function_storeDelayed");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "updateBoundVariableAttributes");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "functionInitialEquations");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        ret_15 = Config.adaptiveHomotopy();
        txt = fun_139(txt, ret_15);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(", /* useHomotopy - 0: local homotopy (equidistant lambda), 1: global homotopy (equidistant lambda), 2: new global homotopy approach (adaptive lambda), 3: new local homotopy approach (adaptive lambda)*/\n"));
        ret_16 = listLength(i_initialEquations__lambda0);
        ret_17 = intEq(ret_16, 0);
        txt = fun_140(txt, ret_17, l_modelNamePrefixStr);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "functionRemovedInitialEquations");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "updateBoundParameters");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "checkForAsserts");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "function_ZeroCrossingsEquations");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "function_ZeroCrossings");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "function_updateRelations");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "zeroCrossingDescription");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "relationDescription");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "function_initSample");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "INDEX_JAC_A");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "INDEX_JAC_B");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "INDEX_JAC_C");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "INDEX_JAC_D");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "INDEX_JAC_F");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "initialAnalyticJacobianA");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "initialAnalyticJacobianB");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "initialAnalyticJacobianC");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "initialAnalyticJacobianD");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "initialAnalyticJacobianF");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "functionJacA_column");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "functionJacB_column");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "functionJacC_column");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "functionJacD_column");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "functionJacF_column");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "linear_model_frame");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "linear_model_datarecovery_frame");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "mayer");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "lagrange");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "pickUpBoundsForInputsInOptimization");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "setInputData");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "getTimeGrid");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "symbolicInlineSystem");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "function_initSynchronous");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "function_updateSynchronous");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "function_equationsSynchronous");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "inputNames");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = CodegenUtil.symbolName(txt, Tpl.textString(l_modelNamePrefixStr), "dataReconciliationInputNames");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        txt = fun_141(txt, a_isModelExchangeFMU, l_modelNamePrefixStr);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        ret_18 = Util.isSome(i_modelStructure);
        txt = fun_143(txt, ret_18, l_modelNamePrefixStr, i_modelStructure);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        ret_19 = Util.isSome(i_modelStructure);
        txt = fun_145(txt, ret_19, l_modelNamePrefixStr, i_modelStructure);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",\n"));
        ret_20 = Util.isSome(i_modelStructure);
        txt = fun_147(txt, ret_20, l_modelNamePrefixStr, i_modelStructure);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "};\n",
                                    "\n"
                                }, true));
        txt = functionInitializeDataStruc(txt, i_modelInfo, i_fileNamePrefix, a_guid, i_delayedExps, Tpl.textString(l_modelNamePrefixStr), a_isModelExchangeFMU);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "static int rml_execution_failed()\n",
                                    "{\n",
                                    "  fflush(NULL);\n",
                                    "  fprintf(stderr, \"Execution failed!\\n\");\n",
                                    "  fflush(NULL);\n",
                                    "  return 1;\n",
                                    "}\n",
                                    "\n"
                                }, true));
        ret_21 = stringEq("", a_isModelExchangeFMU);
        (txt, l_mainBody) = fun_154(txt, ret_21, l_mainBody, l_mainInit);
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end simulationFile;

protected function fun_156
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_fileNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_fileNamePrefix)
    local
      Tpl.Text txt;
      String a_fileNamePrefix;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_fileNamePrefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#include \""));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_16dae.h\""));
      then txt;
  end match;
end fun_156;

public function simulationFileHeader
  input Tpl.Text txt;
  input String a_fileNamePrefix;

  output Tpl.Text out_txt;
protected
  Boolean ret_1;
  Tpl.Text l_daeHeader;
algorithm
  ret_1 := Flags.getConfigBool(Flags.DAE_MODE);
  l_daeHeader := fun_156(Tpl.emptyTxt, ret_1, a_fileNamePrefix);
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING("#include \""));
  out_txt := Tpl.writeStr(out_txt, a_fileNamePrefix);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("_model.h\"\n"));
  out_txt := Tpl.writeText(out_txt, l_daeHeader);
end simulationFileHeader;

protected function fun_158
  input Tpl.Text in_txt;
  input String in_a_isModelExchangeFMU;
  input String in_a_fileNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_isModelExchangeFMU, in_a_fileNamePrefix)
    local
      Tpl.Text txt;
      String a_fileNamePrefix;

    case ( txt,
           "1.0",
           a_fileNamePrefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "data->modelData->initXMLData = NULL;\n",
                                    "data->modelData->modelDataXml.infoXMLData =\n",
                                    "#if defined(OMC_MINIMAL_METADATA)\n",
                                    "  NULL;\n",
                                    "#else\n",
                                    "#include \""
                                }, false));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_info.c\"\n",
                                    "#endif\n",
                                    ";"
                                }, false));
      then txt;

    case ( txt,
           "",
           a_fileNamePrefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "#if defined(OPENMODELICA_XML_FROM_FILE_AT_RUNTIME)\n",
                                    "data->modelData->initXMLData = NULL;\n",
                                    "data->modelData->modelDataXml.infoXMLData = NULL;\n",
                                    "#else\n",
                                    "#if defined(_MSC_VER) /* handle joke compilers */\n",
                                    "{\n",
                                    "/* for MSVC we encode a string like char x[] = {\'a\', \'b\', \'c\', \'\\0\'} */\n",
                                    "/* because the string constant limit is 65535 bytes */\n",
                                    "static const char contents_init[] =\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#include \""));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_init.c\"\n",
                                    ";\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("static const char contents_info[] =\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#include \""));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_info.c\"\n",
                                    ";\n",
                                    "data->modelData->initXMLData = contents_init;\n",
                                    "data->modelData->modelDataXml.infoXMLData = contents_info;\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "#else /* handle real compilers */\n",
                                    "data->modelData->initXMLData =\n",
                                    "#include \""
                                }, false));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_init.c\"\n",
                                    "  ;\n",
                                    "data->modelData->modelDataXml.infoXMLData =\n",
                                    "#include \""
                                }, false));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_info.c\"\n",
                                    "  ;\n",
                                    "#endif /* defined(_MSC_VER) */\n",
                                    "#endif /* defined(OPENMODELICA_XML_FROM_FILE_AT_RUNTIME) */"
                                }, false));
      then txt;

    case ( txt,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "data->modelData->initXMLData = NULL;\n",
                                    "data->modelData->modelDataXml.infoXMLData = NULL;"
                                }, false));
      then txt;
  end match;
end fun_158;

protected function fun_159
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("0"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("1"));
      then txt;
  end match;
end fun_159;

protected function fun_160
  input Tpl.Text in_txt;
  input String in_a_isModelExchangeFMU;
  input String in_a_fileNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_isModelExchangeFMU, in_a_fileNamePrefix)
    local
      Tpl.Text txt;
      String a_fileNamePrefix;

    case ( txt,
           "1.0",
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("data->modelData->modelDataXml.fileName = NULL;"));
      then txt;

    case ( txt,
           "",
           a_fileNamePrefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("data->modelData->modelDataXml.fileName = \""));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_info.json\";"));
      then txt;

    case ( txt,
           _,
           a_fileNamePrefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("GC_asprintf(&data->modelData->modelDataXml.fileName, \"%s/"));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_info.json\", data->modelData->resourcesDir);"));
      then txt;
  end match;
end fun_160;

protected function fun_161
  input Tpl.Text in_txt;
  input SimCode.DelayedExpression in_a_delayed;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_delayed)
    local
      Tpl.Text txt;
      Integer i_maxDelayedIndex;

    case ( txt,
           SimCode.DELAYED_EXPRESSIONS(maxDelayedIndex = i_maxDelayedIndex) )
      equation
        txt = Tpl.writeStr(txt, intString(i_maxDelayedIndex));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_161;

protected function fun_162
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("OMC_LINEARIZE_DUMP_LANGUAGE_PYTHON"));
      then txt;
  end match;
end fun_162;

protected function fun_163
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;
      Boolean ret_1;
      String ret_0;

    case ( txt,
           false )
      equation
        ret_0 = Flags.getConfigString(Flags.LINEARIZATION_DUMP_LANGUAGE);
        ret_1 = stringEq(ret_0, "python");
        txt = fun_162(txt, ret_1);
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("OMC_LINEARIZE_DUMP_LANGUAGE_JULIA"));
      then txt;
  end match;
end fun_163;

protected function fun_164
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;
      Boolean ret_1;
      String ret_0;

    case ( txt,
           false )
      equation
        ret_0 = Flags.getConfigString(Flags.LINEARIZATION_DUMP_LANGUAGE);
        ret_1 = stringEq(ret_0, "julia");
        txt = fun_163(txt, ret_1);
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("OMC_LINEARIZE_DUMP_LANGUAGE_MATLAB"));
      then txt;
  end match;
end fun_164;

protected function fun_165
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;
      Boolean ret_1;
      String ret_0;

    case ( txt,
           false )
      equation
        ret_0 = Flags.getConfigString(Flags.LINEARIZATION_DUMP_LANGUAGE);
        ret_1 = stringEq(ret_0, "matlab");
        txt = fun_164(txt, ret_1);
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("OMC_LINEARIZE_DUMP_LANGUAGE_MODELICA"));
      then txt;
  end match;
end fun_165;

public function populateModelInfo
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;
  input String in_a_fileNamePrefix;
  input String in_a_guid;
  input SimCode.DelayedExpression in_a_delayed;
  input String in_a_isModelExchangeFMU;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo, in_a_fileNamePrefix, in_a_guid, in_a_delayed, in_a_isModelExchangeFMU)
    local
      Tpl.Text txt;
      String a_fileNamePrefix;
      String a_guid;
      SimCode.DelayedExpression a_delayed;
      String a_isModelExchangeFMU;
      Integer i_varInfo_numDataReconVars;
      Integer i_varInfo_numSetcVars;
      Integer i_varInfo_numSensitivityParameters;
      list<SimCodeVar.SimVar> i_vars_sensitivityVars;
      Integer i_nSubClocks;
      Integer i_nClocks;
      Integer i_varInfo_numOptimizeFinalConstraints;
      Integer i_varInfo_numOptimizeConstraints;
      Integer i_varInfo_numJacobians;
      Integer i_varInfo_numStateSets;
      Integer i_varInfo_numNonLinearSystems;
      Integer i_varInfo_numLinearSystems;
      Integer i_varInfo_numMixedSystems;
      Integer i_varInfo_numEquations;
      list<SimCodeFunction.Function> i_functions;
      Integer i_varInfo_numExternalObjects;
      Integer i_varInfo_numMathEventFunctions;
      Integer i_varInfo_numRelations;
      Integer i_varInfo_numTimeEvents;
      Integer i_varInfo_numZeroCrossings;
      Integer i_varInfo_numStringAliasVars;
      Integer i_varInfo_numBoolAliasVars;
      Integer i_varInfo_numIntAliasVars;
      Integer i_varInfo_numAlgAliasVars;
      Integer i_varInfo_numOutVars;
      Integer i_varInfo_numInVars;
      Integer i_varInfo_numStringParamVars;
      Integer i_varInfo_numBoolParams;
      Integer i_varInfo_numIntParams;
      Integer i_varInfo_numParams;
      Integer i_varInfo_numStringAlgVars;
      Integer i_varInfo_numBoolAlgVars;
      Integer i_varInfo_numIntAlgVars;
      Integer i_varInfo_numDiscreteReal;
      SimCode.VarInfo i_varInfo;
      Integer i_varInfo_numStateVars;
      String i_directory;
      Absyn.Path i_name;
      Boolean ret_5;
      String ret_4;
      Integer ret_3;
      Integer ret_2;
      Integer ret_1;
      Boolean ret_0;

    case ( txt,
           SimCode.MODELINFO(varInfo = (i_varInfo as SimCode.VARINFO(numStateVars = i_varInfo_numStateVars, numDiscreteReal = i_varInfo_numDiscreteReal, numIntAlgVars = i_varInfo_numIntAlgVars, numBoolAlgVars = i_varInfo_numBoolAlgVars, numStringAlgVars = i_varInfo_numStringAlgVars, numParams = i_varInfo_numParams, numIntParams = i_varInfo_numIntParams, numBoolParams = i_varInfo_numBoolParams, numStringParamVars = i_varInfo_numStringParamVars, numInVars = i_varInfo_numInVars, numOutVars = i_varInfo_numOutVars, numAlgAliasVars = i_varInfo_numAlgAliasVars, numIntAliasVars = i_varInfo_numIntAliasVars, numBoolAliasVars = i_varInfo_numBoolAliasVars, numStringAliasVars = i_varInfo_numStringAliasVars, numZeroCrossings = i_varInfo_numZeroCrossings, numTimeEvents = i_varInfo_numTimeEvents, numRelations = i_varInfo_numRelations, numMathEventFunctions = i_varInfo_numMathEventFunctions, numExternalObjects = i_varInfo_numExternalObjects, numEquations = i_varInfo_numEquations, numMixedSystems = i_varInfo_numMixedSystems, numLinearSystems = i_varInfo_numLinearSystems, numNonLinearSystems = i_varInfo_numNonLinearSystems, numStateSets = i_varInfo_numStateSets, numJacobians = i_varInfo_numJacobians, numOptimizeConstraints = i_varInfo_numOptimizeConstraints, numOptimizeFinalConstraints = i_varInfo_numOptimizeFinalConstraints, numSensitivityParameters = i_varInfo_numSensitivityParameters, numSetcVars = i_varInfo_numSetcVars, numDataReconVars = i_varInfo_numDataReconVars)), vars = SimCodeVar.SIMVARS(sensitivityVars = i_vars_sensitivityVars), name = i_name, directory = i_directory, functions = i_functions, nClocks = i_nClocks, nSubClocks = i_nSubClocks),
           a_fileNamePrefix,
           a_guid,
           a_delayed,
           a_isModelExchangeFMU )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "OpenModelica_updateUriMapping(threadData, MMC_REFSTRUCTLIT(_OMC_LIT_RESOURCES));\n",
                                    "data->modelData->modelName = \""
                                }, false));
        txt = CodegenUtil.dotPath(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\";\n",
                                    "data->modelData->modelFilePrefix = \""
                                }, false));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\";\n",
                                    "data->modelData->resultFileName = NULL;\n",
                                    "data->modelData->modelDir = \""
                                }, false));
        txt = Tpl.writeStr(txt, i_directory);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\";\n",
                                    "data->modelData->modelGUID = \"{"
                                }, false));
        txt = Tpl.writeStr(txt, a_guid);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("}\";\n"));
        txt = fun_158(txt, a_isModelExchangeFMU, a_fileNamePrefix);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("data->modelData->runTestsuite = "));
        ret_0 = Testsuite.isRunning();
        txt = fun_159(txt, ret_0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "\n",
                                    "data->modelData->nStates = "
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numStateVars));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "data->modelData->nVariablesReal = "
                                }, false));
        ret_1 = SimCodeUtil.nVariablesReal(i_varInfo);
        txt = Tpl.writeStr(txt, intString(ret_1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "data->modelData->nDiscreteReal = "
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numDiscreteReal));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "data->modelData->nVariablesInteger = "
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numIntAlgVars));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "data->modelData->nVariablesBoolean = "
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numBoolAlgVars));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "data->modelData->nVariablesString = "
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numStringAlgVars));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "data->modelData->nParametersReal = "
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numParams));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "data->modelData->nParametersInteger = "
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numIntParams));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "data->modelData->nParametersBoolean = "
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numBoolParams));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "data->modelData->nParametersString = "
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numStringParamVars));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "data->modelData->nInputVars = "
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numInVars));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "data->modelData->nOutputVars = "
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numOutVars));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "\n",
                                    "data->modelData->nAliasReal = "
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numAlgAliasVars));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "data->modelData->nAliasInteger = "
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numIntAliasVars));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "data->modelData->nAliasBoolean = "
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numBoolAliasVars));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "data->modelData->nAliasString = "
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numStringAliasVars));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "\n",
                                    "data->modelData->nZeroCrossings = "
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numZeroCrossings));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "data->modelData->nSamples = "
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numTimeEvents));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "data->modelData->nRelations = "
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numRelations));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "data->modelData->nMathEvents = "
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numMathEventFunctions));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "data->modelData->nExtObjs = "
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numExternalObjects));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "\n"
                                }, true));
        txt = fun_160(txt, a_isModelExchangeFMU, a_fileNamePrefix);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "data->modelData->modelDataXml.modelInfoXmlLength = 0;\n",
                                    "data->modelData->modelDataXml.nFunctions = "
                                }, false));
        ret_2 = listLength(i_functions);
        txt = Tpl.writeStr(txt, intString(ret_2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "data->modelData->modelDataXml.nProfileBlocks = 0;\n",
                                    "data->modelData->modelDataXml.nEquations = "
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numEquations));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "data->modelData->nMixedSystems = "
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numMixedSystems));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "data->modelData->nLinearSystems = "
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numLinearSystems));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "data->modelData->nNonLinearSystems = "
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numNonLinearSystems));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "data->modelData->nStateSets = "
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numStateSets));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "data->modelData->nJacobians = "
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numJacobians));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "data->modelData->nOptimizeConstraints = "
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numOptimizeConstraints));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "data->modelData->nOptimizeFinalConstraints = "
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numOptimizeFinalConstraints));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "\n",
                                    "data->modelData->nDelayExpressions = "
                                }, false));
        txt = fun_161(txt, a_delayed);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "\n",
                                    "data->modelData->nClocks = "
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_nClocks));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "data->modelData->nSubClocks = "
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_nSubClocks));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "\n",
                                    "data->modelData->nSensitivityVars = "
                                }, false));
        ret_3 = listLength(i_vars_sensitivityVars);
        txt = Tpl.writeStr(txt, intString(ret_3));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "data->modelData->nSensitivityParamVars = "
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numSensitivityParameters));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "data->modelData->nSetcVars = "
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numSetcVars));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "data->modelData->ndataReconVars = "
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numDataReconVars));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "data->modelData->linearizationDumpLanguage =\n"
                                }, true));
        ret_4 = Flags.getConfigString(Flags.LINEARIZATION_DUMP_LANGUAGE);
        ret_5 = stringEq(ret_4, "modelica");
        txt = fun_165(txt, ret_5);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           _,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end populateModelInfo;

protected function lm_167
  input Tpl.Text in_txt;
  input list<Absyn.Class> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<Absyn.Class> rest;
      Integer x_index0;
      String i_fileName;
      Absyn.Ident i_name;
      Integer ret_6;
      Integer ret_5;
      String ret_4;
      String ret_3;
      Tpl.Text l_escDir;
      String ret_1;
      Tpl.Text l_escName;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           Absyn.CLASS(info = SOURCEINFO(fileName = i_fileName), name = i_name) :: rest )
      equation
        x_index0 = Tpl.getIteri_i0(txt);
        ret_1 = Util.escapeModelicaStringToCString(i_name);
        l_escName = Tpl.writeStr(Tpl.emptyTxt, ret_1);
        ret_3 = System.dirname(i_fileName);
        ret_4 = Util.escapeModelicaStringToCString(ret_3);
        l_escDir = Tpl.writeStr(Tpl.emptyTxt, ret_4);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#define _OMC_LIT_RESOURCE_"));
        txt = Tpl.writeStr(txt, intString(x_index0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_name_data \""));
        txt = Tpl.writeText(txt, l_escName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\"\n",
                                    "#define _OMC_LIT_RESOURCE_"
                                }, false));
        txt = Tpl.writeStr(txt, intString(x_index0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_dir_data \""));
        txt = Tpl.writeText(txt, l_escDir);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\"\n",
                                    "static const MMC_DEFSTRINGLIT(_OMC_LIT_RESOURCE_"
                                }, false));
        txt = Tpl.writeStr(txt, intString(x_index0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_name,"));
        ret_5 = System.unescapedStringLength(Tpl.textString(l_escName));
        txt = Tpl.writeStr(txt, intString(ret_5));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(",_OMC_LIT_RESOURCE_"));
        txt = Tpl.writeStr(txt, intString(x_index0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_name_data);\n",
                                    "static const MMC_DEFSTRINGLIT(_OMC_LIT_RESOURCE_"
                                }, false));
        txt = Tpl.writeStr(txt, intString(x_index0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_dir,"));
        ret_6 = System.unescapedStringLength(Tpl.textString(l_escDir));
        txt = Tpl.writeStr(txt, intString(ret_6));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(",_OMC_LIT_RESOURCE_"));
        txt = Tpl.writeStr(txt, intString(x_index0));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_dir_data);\n"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.nextIter(txt);
        txt = lm_167(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_167(txt, rest);
      then txt;
  end match;
end lm_167;

protected function lm_168
  input Tpl.Text in_txt;
  input list<Absyn.Class> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<Absyn.Class> rest;
      Integer x_index0;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           Absyn.CLASS(info = SOURCEINFO(fileName = _)) :: rest )
      equation
        x_index0 = Tpl.getIteri_i0(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("MMC_REFSTRINGLIT(_OMC_LIT_RESOURCE_"));
        txt = Tpl.writeStr(txt, intString(x_index0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_name), MMC_REFSTRINGLIT(_OMC_LIT_RESOURCE_"));
        txt = Tpl.writeStr(txt, intString(x_index0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_dir)"));
        txt = Tpl.nextIter(txt);
        txt = lm_168(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_168(txt, rest);
      then txt;
  end match;
end lm_168;

protected function fun_169
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo)
    local
      Tpl.Text txt;
      list<Absyn.Class> i_sortedClasses;
      Integer ret_1;
      Integer ret_0;

    case ( txt,
           SimCode.MODELINFO(sortedClasses = i_sortedClasses) )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), NONE(), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_167(txt, i_sortedClasses);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("static const MMC_DEFSTRUCTLIT(_OMC_LIT_RESOURCES,"));
        ret_0 = listLength(i_sortedClasses);
        ret_1 = intMul(2, ret_0);
        txt = Tpl.writeStr(txt, intString(ret_1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(",MMC_ARRAY_TAG) {"));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_168(txt, i_sortedClasses);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}};"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_169;

public function functionInitializeDataStruc
  input Tpl.Text txt;
  input SimCode.ModelInfo a_modelInfo;
  input String a_fileNamePrefix;
  input String a_guid;
  input SimCode.DelayedExpression a_delayed;
  input String a_modelNamePrefix;
  input String a_isModelExchangeFMU;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_169(txt, a_modelInfo);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("void "));
  out_txt := CodegenUtil.symbolName(out_txt, a_modelNamePrefix, "setupDataStruc");
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "(DATA *data, threadData_t *threadData)\n",
                                       "{\n",
                                       "  assertStreamPrint(threadData,0!=data, \"Error while initialize Data\");\n",
                                       "  threadData->localRoots[LOCAL_ROOT_SIMULATION_DATA] = data;\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("data->callback = &"));
  out_txt := CodegenUtil.symbolName(out_txt, a_modelNamePrefix, "callback");
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE(";\n"));
  out_txt := populateModelInfo(out_txt, a_modelInfo, a_fileNamePrefix, a_guid, a_delayed, a_isModelExchangeFMU);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("}"));
end functionInitializeDataStruc;

public function functionSimProfDef
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input Integer in_a_value;
  input Tpl.Text in_a_reverseProf;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_reverseProf;
algorithm
  (out_txt, out_a_reverseProf) :=
  match(in_txt, in_a_eq, in_a_value, in_a_reverseProf)
    local
      Tpl.Text txt;
      Integer a_value;
      Tpl.Text a_reverseProf;
      Integer i_at_index;
      Integer i_nls_index;
      Integer i_ls_index;
      Integer i_index;

    case ( txt,
           SimCode.SES_MIXED(index = i_index),
           a_value,
           a_reverseProf )
      equation
        a_reverseProf = Tpl.writeTok(a_reverseProf, Tpl.ST_STRING("data->modelData->equationInfo_reverse_prof_index["));
        a_reverseProf = Tpl.writeStr(a_reverseProf, intString(a_value));
        a_reverseProf = Tpl.writeTok(a_reverseProf, Tpl.ST_STRING("] = "));
        a_reverseProf = Tpl.writeStr(a_reverseProf, intString(i_index));
        a_reverseProf = Tpl.writeTok(a_reverseProf, Tpl.ST_STRING(";"));
        a_reverseProf = Tpl.writeTok(a_reverseProf, Tpl.ST_NEW_LINE());
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#define SIM_PROF_EQ_"));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeStr(txt, intString(a_value));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then (txt, a_reverseProf);

    case ( txt,
           SimCode.SES_LINEAR(lSystem = SimCode.LINEARSYSTEM(index = i_ls_index), alternativeTearing = NONE()),
           a_value,
           a_reverseProf )
      equation
        a_reverseProf = Tpl.writeTok(a_reverseProf, Tpl.ST_STRING("data->modelData->equationInfo_reverse_prof_index["));
        a_reverseProf = Tpl.writeStr(a_reverseProf, intString(a_value));
        a_reverseProf = Tpl.writeTok(a_reverseProf, Tpl.ST_STRING("] = "));
        a_reverseProf = Tpl.writeStr(a_reverseProf, intString(i_ls_index));
        a_reverseProf = Tpl.writeTok(a_reverseProf, Tpl.ST_STRING(";"));
        a_reverseProf = Tpl.writeTok(a_reverseProf, Tpl.ST_NEW_LINE());
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#define SIM_PROF_EQ_"));
        txt = Tpl.writeStr(txt, intString(i_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeStr(txt, intString(a_value));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then (txt, a_reverseProf);

    case ( txt,
           SimCode.SES_NONLINEAR(nlSystem = SimCode.NONLINEARSYSTEM(index = i_nls_index), alternativeTearing = NONE()),
           a_value,
           a_reverseProf )
      equation
        a_reverseProf = Tpl.writeTok(a_reverseProf, Tpl.ST_STRING("data->modelData->equationInfo_reverse_prof_index["));
        a_reverseProf = Tpl.writeStr(a_reverseProf, intString(a_value));
        a_reverseProf = Tpl.writeTok(a_reverseProf, Tpl.ST_STRING("] = "));
        a_reverseProf = Tpl.writeStr(a_reverseProf, intString(i_nls_index));
        a_reverseProf = Tpl.writeTok(a_reverseProf, Tpl.ST_STRING(";"));
        a_reverseProf = Tpl.writeTok(a_reverseProf, Tpl.ST_NEW_LINE());
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#define SIM_PROF_EQ_"));
        txt = Tpl.writeStr(txt, intString(i_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeStr(txt, intString(a_value));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then (txt, a_reverseProf);

    case ( txt,
           SimCode.SES_LINEAR(lSystem = SimCode.LINEARSYSTEM(index = i_ls_index), alternativeTearing = SOME(SimCode.LINEARSYSTEM(index = i_at_index))),
           a_value,
           a_reverseProf )
      equation
        a_reverseProf = Tpl.writeTok(a_reverseProf, Tpl.ST_STRING("data->modelData->equationInfo_reverse_prof_index["));
        a_reverseProf = Tpl.writeStr(a_reverseProf, intString(a_value));
        a_reverseProf = Tpl.writeTok(a_reverseProf, Tpl.ST_STRING("] = "));
        a_reverseProf = Tpl.writeStr(a_reverseProf, intString(i_ls_index));
        a_reverseProf = Tpl.writeTok(a_reverseProf, Tpl.ST_STRING(";"));
        a_reverseProf = Tpl.writeTok(a_reverseProf, Tpl.ST_NEW_LINE());
        a_reverseProf = Tpl.writeTok(a_reverseProf, Tpl.ST_STRING("data->modelData->equationInfo_reverse_prof_index["));
        a_reverseProf = Tpl.writeStr(a_reverseProf, intString(a_value));
        a_reverseProf = Tpl.writeTok(a_reverseProf, Tpl.ST_STRING("] = "));
        a_reverseProf = Tpl.writeStr(a_reverseProf, intString(i_at_index));
        a_reverseProf = Tpl.writeTok(a_reverseProf, Tpl.ST_STRING(";"));
        a_reverseProf = Tpl.writeTok(a_reverseProf, Tpl.ST_NEW_LINE());
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#define SIM_PROF_EQ_"));
        txt = Tpl.writeStr(txt, intString(i_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeStr(txt, intString(a_value));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "#define SIM_PROF_EQ_"
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_at_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeStr(txt, intString(a_value));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then (txt, a_reverseProf);

    case ( txt,
           SimCode.SES_NONLINEAR(nlSystem = SimCode.NONLINEARSYSTEM(index = i_nls_index), alternativeTearing = SOME(SimCode.NONLINEARSYSTEM(index = i_at_index))),
           a_value,
           a_reverseProf )
      equation
        a_reverseProf = Tpl.writeTok(a_reverseProf, Tpl.ST_STRING("data->modelData->equationInfo_reverse_prof_index["));
        a_reverseProf = Tpl.writeStr(a_reverseProf, intString(a_value));
        a_reverseProf = Tpl.writeTok(a_reverseProf, Tpl.ST_STRING("] = "));
        a_reverseProf = Tpl.writeStr(a_reverseProf, intString(i_nls_index));
        a_reverseProf = Tpl.writeTok(a_reverseProf, Tpl.ST_STRING(";"));
        a_reverseProf = Tpl.writeTok(a_reverseProf, Tpl.ST_NEW_LINE());
        a_reverseProf = Tpl.writeTok(a_reverseProf, Tpl.ST_STRING("data->modelData->equationInfo_reverse_prof_index["));
        a_reverseProf = Tpl.writeStr(a_reverseProf, intString(a_value));
        a_reverseProf = Tpl.writeTok(a_reverseProf, Tpl.ST_STRING("] = "));
        a_reverseProf = Tpl.writeStr(a_reverseProf, intString(i_at_index));
        a_reverseProf = Tpl.writeTok(a_reverseProf, Tpl.ST_STRING(";"));
        a_reverseProf = Tpl.writeTok(a_reverseProf, Tpl.ST_NEW_LINE());
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#define SIM_PROF_EQ_"));
        txt = Tpl.writeStr(txt, intString(i_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeStr(txt, intString(a_value));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "#define SIM_PROF_EQ_"
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_at_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeStr(txt, intString(a_value));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then (txt, a_reverseProf);

    case ( txt,
           _,
           _,
           a_reverseProf )
      then (txt, a_reverseProf);
  end match;
end functionSimProfDef;

protected function lm_172
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = globalDataVarDefine(txt, i_var, "realVars");
        txt = Tpl.nextIter(txt);
        txt = lm_172(txt, rest);
      then txt;
  end match;
end lm_172;

protected function lm_173
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = globalDataVarDefine(txt, i_var, "realVars");
        txt = Tpl.nextIter(txt);
        txt = lm_173(txt, rest);
      then txt;
  end match;
end lm_173;

protected function lm_174
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = globalDataVarDefine(txt, i_var, "realVars");
        txt = Tpl.nextIter(txt);
        txt = lm_174(txt, rest);
      then txt;
  end match;
end lm_174;

protected function lm_175
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = globalDataVarDefine(txt, i_var, "realVars");
        txt = Tpl.nextIter(txt);
        txt = lm_175(txt, rest);
      then txt;
  end match;
end lm_175;

protected function lm_176
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = globalDataVarDefine(txt, i_var, "realVars");
        txt = Tpl.nextIter(txt);
        txt = lm_176(txt, rest);
      then txt;
  end match;
end lm_176;

protected function lm_177
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = globalDataVarDefine(txt, i_var, "realVars");
        txt = Tpl.nextIter(txt);
        txt = lm_177(txt, rest);
      then txt;
  end match;
end lm_177;

protected function lm_178
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = globalDataParDefine(txt, i_var, "realParameter");
        txt = Tpl.nextIter(txt);
        txt = lm_178(txt, rest);
      then txt;
  end match;
end lm_178;

protected function lm_179
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = globalDataParDefine(txt, i_var, "extObjs");
        txt = Tpl.nextIter(txt);
        txt = lm_179(txt, rest);
      then txt;
  end match;
end lm_179;

protected function lm_180
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = globalDataVarDefine(txt, i_var, "integerVars");
        txt = Tpl.nextIter(txt);
        txt = lm_180(txt, rest);
      then txt;
  end match;
end lm_180;

protected function lm_181
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = globalDataParDefine(txt, i_var, "integerParameter");
        txt = Tpl.nextIter(txt);
        txt = lm_181(txt, rest);
      then txt;
  end match;
end lm_181;

protected function lm_182
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = globalDataVarDefine(txt, i_var, "booleanVars");
        txt = Tpl.nextIter(txt);
        txt = lm_182(txt, rest);
      then txt;
  end match;
end lm_182;

protected function lm_183
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = globalDataParDefine(txt, i_var, "booleanParameter");
        txt = Tpl.nextIter(txt);
        txt = lm_183(txt, rest);
      then txt;
  end match;
end lm_183;

protected function lm_184
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = globalDataVarDefine(txt, i_var, "stringVars");
        txt = Tpl.nextIter(txt);
        txt = lm_184(txt, rest);
      then txt;
  end match;
end lm_184;

protected function lm_185
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = globalDataParDefine(txt, i_var, "stringParameter");
        txt = Tpl.nextIter(txt);
        txt = lm_185(txt, rest);
      then txt;
  end match;
end lm_185;

protected function fun_186
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> i_vars_stringParamVars;
      list<SimCodeVar.SimVar> i_vars_stringAlgVars;
      list<SimCodeVar.SimVar> i_vars_boolParamVars;
      list<SimCodeVar.SimVar> i_vars_boolAlgVars;
      list<SimCodeVar.SimVar> i_vars_intParamVars;
      list<SimCodeVar.SimVar> i_vars_intAlgVars;
      list<SimCodeVar.SimVar> i_vars_extObjVars;
      list<SimCodeVar.SimVar> i_vars_paramVars;
      list<SimCodeVar.SimVar> i_vars_realOptimizeFinalConstraintsVars;
      list<SimCodeVar.SimVar> i_vars_realOptimizeConstraintsVars;
      list<SimCodeVar.SimVar> i_vars_discreteAlgVars;
      list<SimCodeVar.SimVar> i_vars_algVars;
      list<SimCodeVar.SimVar> i_vars_derivativeVars;
      list<SimCodeVar.SimVar> i_vars_stateVars;

    case ( txt,
           SimCode.MODELINFO(varInfo = SimCode.VARINFO(numStateVars = _, numAlgVars = _, numDiscreteReal = _, numOptimizeConstraints = _, numOptimizeFinalConstraints = _), vars = SimCodeVar.SIMVARS(stateVars = i_vars_stateVars, derivativeVars = i_vars_derivativeVars, algVars = i_vars_algVars, discreteAlgVars = i_vars_discreteAlgVars, realOptimizeConstraintsVars = i_vars_realOptimizeConstraintsVars, realOptimizeFinalConstraintsVars = i_vars_realOptimizeFinalConstraintsVars, paramVars = i_vars_paramVars, extObjVars = i_vars_extObjVars, intAlgVars = i_vars_intAlgVars, intParamVars = i_vars_intParamVars, boolAlgVars = i_vars_boolAlgVars, boolParamVars = i_vars_boolParamVars, stringAlgVars = i_vars_stringAlgVars, stringParamVars = i_vars_stringParamVars)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/* States */\n"));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_172(txt, i_vars_stateVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "/* StatesDerivatives */\n"
                                }, true));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_173(txt, i_vars_derivativeVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "/* Non Discrete Real Algebraic Vars */\n"
                                }, true));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_174(txt, i_vars_algVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "/* Discrete Real Algebraic Vars */\n"
                                }, true));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_175(txt, i_vars_discreteAlgVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "/* Nonlinear Constraints For Dyn. Optimization */\n"
                                }, true));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_176(txt, i_vars_realOptimizeConstraintsVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "/* Nonlinear Final Constraints For Dyn. Optimization */\n"
                                }, true));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_177(txt, i_vars_realOptimizeFinalConstraintsVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "/* Algebraic Parameter */\n"
                                }, true));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_178(txt, i_vars_paramVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "/* External Objects */\n"
                                }, true));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_179(txt, i_vars_extObjVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "/* Algebraic Integer Vars */\n"
                                }, true));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_180(txt, i_vars_intAlgVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "/* Algebraic Integer Parameter */\n"
                                }, true));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_181(txt, i_vars_intParamVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "/* Algebraic Boolean Vars */\n"
                                }, true));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_182(txt, i_vars_boolAlgVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "/* Algebraic Boolean Parameters */\n"
                                }, true));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_183(txt, i_vars_boolParamVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "/* Algebraic String Variables */\n"
                                }, true));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_184(txt, i_vars_stringAlgVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "/* Algebraic String Parameter */\n"
                                }, true));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_185(txt, i_vars_stringParamVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_186;

protected function fun_187
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input SimCode.ModelInfo in_a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_modelInfo)
    local
      Tpl.Text txt;
      SimCode.ModelInfo a_modelInfo;

    case ( txt,
           false,
           a_modelInfo )
      equation
        System.tmpTickReset(1000);
        txt = fun_186(txt, a_modelInfo);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_187;

public function variableDefinitions
  input Tpl.Text txt;
  input SimCode.ModelInfo a_modelInfo;
  input list<BackendDAE.TimeEvent> a_timeEvents;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_187(txt, true, a_modelInfo);
end variableDefinitions;

public function globalDataParDefine
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_a_simVar;
  input String in_a_arrayName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simVar, in_a_arrayName)
    local
      Tpl.Text txt;
      String a_arrayName;
      DAE.ComponentRef i_name;
      Integer i_index;
      DAE.ComponentRef i_c;

    case ( txt,
           SimCodeVar.SIMVAR(arrayCref = SOME(i_c), aliasvar = SimCodeVar.NOALIAS(), index = i_index, name = i_name),
           a_arrayName )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/* "));
        txt = CodegenUtil.crefStrNoUnderscore(txt, i_c);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " */\n",
                                    "#define "
                                }, false));
        txt = CodegenCFunctions.cref(txt, i_c);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" data->simulationInfo->"));
        txt = Tpl.writeStr(txt, a_arrayName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("["));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "]\n",
                                    "\n",
                                    "/* "
                                }, false));
        txt = CodegenUtil.crefStrNoUnderscore(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " */\n",
                                    "#define "
                                }, false));
        txt = CodegenCFunctions.cref(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" data->simulationInfo->"));
        txt = Tpl.writeStr(txt, a_arrayName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("["));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "]\n",
                                    "#define _"
                                }, false));
        txt = CodegenCFunctions.cref(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(i) "));
        txt = CodegenCFunctions.cref(txt, i_name);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(aliasvar = SimCodeVar.NOALIAS(), name = i_name, index = i_index),
           a_arrayName )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/* "));
        txt = CodegenUtil.crefStrNoUnderscore(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " */\n",
                                    "#define "
                                }, false));
        txt = CodegenCFunctions.cref(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" data->simulationInfo->"));
        txt = Tpl.writeStr(txt, a_arrayName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("["));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "]\n",
                                    "#define _"
                                }, false));
        txt = CodegenCFunctions.cref(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(i) "));
        txt = CodegenCFunctions.cref(txt, i_name);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end globalDataParDefine;

public function globalDataVarDefine
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_a_simVar;
  input String in_a_arrayName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simVar, in_a_arrayName)
    local
      Tpl.Text txt;
      String a_arrayName;
      DAE.ComponentRef i_name;
      Integer i_index;
      DAE.ComponentRef i_c;
      DAE.ComponentRef ret_4;
      DAE.ComponentRef ret_3;
      DAE.ComponentRef ret_2;
      DAE.ComponentRef ret_1;
      DAE.ComponentRef ret_0;

    case ( txt,
           SimCodeVar.SIMVAR(arrayCref = SOME(i_c), aliasvar = SimCodeVar.NOALIAS(), index = i_index, name = i_name),
           a_arrayName )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/* "));
        txt = CodegenUtil.crefStrNoUnderscore(txt, i_c);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " */\n",
                                    "#define _"
                                }, false));
        txt = CodegenCFunctions.cref(txt, i_c);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(i) data->localData[i]->"));
        txt = Tpl.writeStr(txt, a_arrayName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("["));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "]\n",
                                    "#define "
                                }, false));
        txt = CodegenCFunctions.cref(txt, i_c);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" _"));
        txt = CodegenCFunctions.cref(txt, i_c);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(0)\n",
                                    "#define "
                                }, false));
        ret_0 = ComponentReference.crefPrefixPre(i_c);
        txt = CodegenCFunctions.cref(txt, ret_0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" data->simulationInfo->"));
        txt = Tpl.writeStr(txt, a_arrayName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Pre["));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "]\n",
                                    "\n",
                                    "/* "
                                }, false));
        txt = CodegenUtil.crefStrNoUnderscore(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " */\n",
                                    "#define _"
                                }, false));
        txt = CodegenCFunctions.cref(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(i) data->localData[i]->"));
        txt = Tpl.writeStr(txt, a_arrayName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("["));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "]\n",
                                    "#define "
                                }, false));
        txt = CodegenCFunctions.cref(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" _"));
        txt = CodegenCFunctions.cref(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(0)\n",
                                    "#define "
                                }, false));
        ret_1 = ComponentReference.crefPrefixPre(i_name);
        txt = CodegenCFunctions.cref(txt, ret_1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" data->simulationInfo->"));
        txt = Tpl.writeStr(txt, a_arrayName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Pre["));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "]\n",
                                    "\n"
                                }, true));
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(aliasvar = SimCodeVar.NOALIAS(), name = i_name, index = i_index),
           a_arrayName )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/* "));
        txt = CodegenUtil.crefStrNoUnderscore(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " */\n",
                                    "#define _"
                                }, false));
        txt = CodegenCFunctions.cref(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(i) data->localData[i]->"));
        txt = Tpl.writeStr(txt, a_arrayName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("["));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "]\n",
                                    "#define "
                                }, false));
        txt = CodegenCFunctions.cref(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" _"));
        txt = CodegenCFunctions.cref(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(0)\n",
                                    "#define "
                                }, false));
        ret_2 = ComponentReference.crefPrefixPre(i_name);
        txt = CodegenCFunctions.cref(txt, ret_2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" data->simulationInfo->"));
        txt = Tpl.writeStr(txt, a_arrayName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Pre["));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "]\n",
                                    "#define _"
                                }, false));
        ret_3 = ComponentReference.crefPrefixPre(i_name);
        txt = CodegenCFunctions.cref(txt, ret_3);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(i) "));
        ret_4 = ComponentReference.crefPrefixPre(i_name);
        txt = CodegenCFunctions.cref(txt, ret_4);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end globalDataVarDefine;

protected function lm_191
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Integer i_index;
      SimCodeVar.AliasVariable i_aliasvar;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(aliasvar = i_aliasvar, index = i_index) :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("{"));
        txt = aliasVarNameType(txt, i_aliasvar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
        txt = Tpl.nextIter(txt);
        txt = lm_191(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_191(txt, rest);
      then txt;
  end match;
end lm_191;

protected function fun_192
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_a_items;
  input String in_a_0__type;
  input String in_a_0__name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_items, in_a_0__type, in_a_0__name)
    local
      Tpl.Text txt;
      String a_0__type;
      String a_0__name;
      list<SimCodeVar.SimVar> i_items;
      Integer ret_0;

    case ( txt,
           {},
           a_0__type,
           a_0__name )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeStr(txt, a_0__type);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeStr(txt, a_0__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("[1] = {{0,0,-1}};"));
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           i_items,
           a_0__type,
           a_0__name )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeStr(txt, a_0__type);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeStr(txt, a_0__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("["));
        ret_0 = listLength(i_items);
        txt = Tpl.writeStr(txt, intString(ret_0));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("] = {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_LINE(",\n")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_191(txt, i_items);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("};"));
        txt = Tpl.popBlock(txt);
      then txt;
  end match;
end fun_192;

public function globalDataAliasVarArray
  input Tpl.Text txt;
  input String a_0__type;
  input String a_0__name;
  input list<SimCodeVar.SimVar> a_items;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_192(txt, a_items, a_0__type, a_0__name);
end globalDataAliasVarArray;

protected function lm_194
  input Tpl.Text in_txt;
  input list<SimCode.JacobianMatrix> in_items;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      list<SimCode.JacobianMatrix> rest;
      String a_modelNamePrefix;
      Integer i_indexJacobian;
      String i_name;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           SimCode.JAC_MATRIX(columns = _, seedVars = _, matrixName = i_name, jacobianIndex = i_indexJacobian) :: rest,
           a_modelNamePrefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "#if defined(__cplusplus)\n",
                                    "extern \"C\" {\n",
                                    "#endif\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#define "));
        txt = CodegenUtil.symbolName(txt, a_modelNamePrefix, "INDEX_JAC_");
        txt = Tpl.writeStr(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeStr(txt, intString(i_indexJacobian));
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("int "));
        txt = CodegenUtil.symbolName(txt, a_modelNamePrefix, "functionJac");
        txt = Tpl.writeStr(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_column(void* data, threadData_t *threadData, ANALYTIC_JACOBIAN *thisJacobian, ANALYTIC_JACOBIAN *parentJacobian);\n",
                                    "int "
                                }, false));
        txt = CodegenUtil.symbolName(txt, a_modelNamePrefix, "initialAnalyticJacobian");
        txt = Tpl.writeStr(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("(void* data, threadData_t *threadData, ANALYTIC_JACOBIAN *jacobian);\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "#if defined(__cplusplus)\n",
                                    "}\n",
                                    "#endif"
                                }, false));
        txt = Tpl.nextIter(txt);
        txt = lm_194(txt, rest, a_modelNamePrefix);
      then txt;

    case ( txt,
           _ :: rest,
           a_modelNamePrefix )
      equation
        txt = lm_194(txt, rest, a_modelNamePrefix);
      then txt;
  end match;
end lm_194;

public function symJacDefinition
  input Tpl.Text txt;
  input list<SimCode.JacobianMatrix> a_JacobianMatrixes;
  input String a_modelNamePrefix;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_symbolicJacsDefine;
algorithm
  l_symbolicJacsDefine := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  l_symbolicJacsDefine := lm_194(l_symbolicJacsDefine, a_JacobianMatrixes, a_modelNamePrefix);
  l_symbolicJacsDefine := Tpl.popIter(l_symbolicJacsDefine);
  out_txt := Tpl.writeTok(txt, Tpl.ST_LINE("/* Jacobian Variables */\n"));
  out_txt := Tpl.writeText(out_txt, l_symbolicJacsDefine);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_NEW_LINE());
end symJacDefinition;

public function aliasVarNameType
  input Tpl.Text in_txt;
  input SimCodeVar.AliasVariable in_a_var;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_var)
    local
      Tpl.Text txt;
      DAE.ComponentRef i_varName;

    case ( txt,
           SimCodeVar.NOALIAS() )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("0,0"));
      then txt;

    case ( txt,
           SimCodeVar.ALIAS(varName = i_varName) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("&"));
        txt = CodegenCFunctions.cref(txt, i_varName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(",0"));
      then txt;

    case ( txt,
           SimCodeVar.NEGATEDALIAS(varName = i_varName) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("&"));
        txt = CodegenCFunctions.cref(txt, i_varName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(",1"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end aliasVarNameType;

protected function lm_197
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      DAE.ComponentRef i_var_name;
      Absyn.Path i_ext_fullClassName;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(varKind = BackendDAE.EXTOBJ(fullClassName = i_ext_fullClassName), name = i_var_name) :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("omc_"));
        txt = CodegenUtil.underscorePath(txt, i_ext_fullClassName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_destructor(threadData,"));
        txt = CodegenCFunctions.cref(txt, i_var_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
        txt = Tpl.nextIter(txt);
        txt = lm_197(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_197(txt, rest);
      then txt;
  end match;
end lm_197;

public function functionCallExternalObjectDestructors
  input Tpl.Text in_txt;
  input SimCode.ExtObjInfo in_a_extObjInfo;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_extObjInfo, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      String a_modelNamePrefix;
      list<SimCodeVar.SimVar> i_extObjInfo_vars;
      list<SimCodeVar.SimVar> ret_0;

    case ( txt,
           SimCode.EXTOBJINFO(vars = i_extObjInfo_vars),
           a_modelNamePrefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = CodegenUtil.symbolName(txt, a_modelNamePrefix, "callExternalObjectDestructors");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA *data, threadData_t *threadData)\n",
                                    "{\n",
                                    "  if(data->simulationInfo->extObjs)\n",
                                    "  {\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        ret_0 = listReverse(i_extObjInfo_vars);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_197(txt, ret_0);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "free(data->simulationInfo->extObjs);\n",
                                    "data->simulationInfo->extObjs = 0;\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "  }\n",
                                    "}"
                                }, false));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end functionCallExternalObjectDestructors;

protected function lm_199
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Integer x_i0;
      DAE.ComponentRef i_name;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(name = i_name, type_ = DAE.T_REAL(varLst = _)) :: rest )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = CodegenCFunctions.cref(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = data->simulationInfo->inputVars["));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("];"));
        txt = Tpl.nextIter(txt);
        txt = lm_199(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_199(txt, rest);
      then txt;
  end match;
end lm_199;

protected function fun_200
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_mArg;
  input DAE.ComponentRef in_a_name;
  input Integer in_a_i0;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_name, in_a_i0)
    local
      Tpl.Text txt;
      DAE.ComponentRef a_name;
      Integer a_i0;
      Integer i_index;
      DAE.Type i_type__;
      Tpl.Text txt_0;

    case ( txt,
           SimCodeVar.SIMVAR(aliasvar = SimCodeVar.NOALIAS(), type_ = i_type__, index = i_index),
           _,
           a_i0 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("data->simulationInfo->inputVars["));
        txt = Tpl.writeStr(txt, intString(a_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = data->modelData->"));
        txt = CodegenCFunctions.expTypeShort(txt, i_type__);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("VarsData["));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].attribute.start;"));
      then txt;

    case ( txt,
           _,
           a_name,
           _ )
      equation
        txt_0 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("Cannot get attributes of alias variable "));
        txt_0 = CodegenUtil.crefStr(txt_0, a_name);
        txt_0 = Tpl.writeTok(txt_0, Tpl.ST_STRING(". Alias variables should have been replaced by the compiler before SimCode"));
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 1674, 20), Tpl.textString(txt_0));
      then txt;
  end match;
end fun_200;

protected function lm_201
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCode.SimCode a_simCode;
      Integer x_i0;
      DAE.ComponentRef i_name;
      SimCodeVar.SimVar ret_0;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(name = i_name, type_ = DAE.T_REAL(varLst = _)) :: rest,
           a_simCode )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        ret_0 = SimCodeUtil.cref2simvar(i_name, a_simCode);
        txt = fun_200(txt, ret_0, i_name, x_i0);
        txt = Tpl.nextIter(txt);
        txt = lm_201(txt, rest, a_simCode);
      then txt;

    case ( txt,
           _ :: rest,
           a_simCode )
      equation
        txt = lm_201(txt, rest, a_simCode);
      then txt;
  end match;
end lm_201;

protected function fun_202
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_mArg;
  input DAE.ComponentRef in_a_name;
  input Integer in_a_i0;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_name, in_a_i0)
    local
      Tpl.Text txt;
      DAE.ComponentRef a_name;
      Integer a_i0;
      Integer i_index;
      DAE.Type i_type__;
      Tpl.Text txt_0;

    case ( txt,
           SimCodeVar.SIMVAR(aliasvar = SimCodeVar.NOALIAS(), type_ = i_type__, index = i_index),
           _,
           a_i0 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("data->modelData->"));
        txt = CodegenCFunctions.expTypeShort(txt, i_type__);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("VarsData["));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].attribute.start = data->simulationInfo->inputVars["));
        txt = Tpl.writeStr(txt, intString(a_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("];"));
      then txt;

    case ( txt,
           _,
           a_name,
           _ )
      equation
        txt_0 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("Cannot get attributes of alias variable "));
        txt_0 = CodegenUtil.crefStr(txt_0, a_name);
        txt_0 = Tpl.writeTok(txt_0, Tpl.ST_STRING(". Alias variables should have been replaced by the compiler before SimCode"));
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 1690, 20), Tpl.textString(txt_0));
      then txt;
  end match;
end fun_202;

protected function lm_203
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCode.SimCode a_simCode;
      Integer x_i0;
      DAE.ComponentRef i_name;
      SimCodeVar.SimVar ret_0;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(name = i_name, type_ = DAE.T_REAL(varLst = _)) :: rest,
           a_simCode )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        ret_0 = SimCodeUtil.cref2simvar(i_name, a_simCode);
        txt = fun_202(txt, ret_0, i_name, x_i0);
        txt = Tpl.nextIter(txt);
        txt = lm_203(txt, rest, a_simCode);
      then txt;

    case ( txt,
           _ :: rest,
           a_simCode )
      equation
        txt = lm_203(txt, rest, a_simCode);
      then txt;
  end match;
end lm_203;

protected function fun_204
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_mArg;
  input DAE.ComponentRef in_a_name;
  input Integer in_a_i0;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_name, in_a_i0)
    local
      Tpl.Text txt;
      DAE.ComponentRef a_name;
      Integer a_i0;
      Integer i_index;
      DAE.Type i_type__;
      Tpl.Text txt_0;

    case ( txt,
           SimCodeVar.SIMVAR(aliasvar = SimCodeVar.NOALIAS(), type_ = i_type__, index = i_index),
           _,
           a_i0 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("names["));
        txt = Tpl.writeStr(txt, intString(a_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = (char *) data->modelData->"));
        txt = CodegenCFunctions.expTypeShort(txt, i_type__);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("VarsData["));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].info.name;"));
      then txt;

    case ( txt,
           _,
           a_name,
           _ )
      equation
        txt_0 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("Cannot get attributes of alias variable "));
        txt_0 = CodegenUtil.crefStr(txt_0, a_name);
        txt_0 = Tpl.writeTok(txt_0, Tpl.ST_STRING(". Alias variables should have been replaced by the compiler before SimCode"));
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 1705, 20), Tpl.textString(txt_0));
      then txt;
  end match;
end fun_204;

protected function lm_205
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCode.SimCode a_simCode;
      Integer x_i0;
      DAE.ComponentRef i_name;
      SimCodeVar.SimVar ret_0;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(name = i_name) :: rest,
           a_simCode )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        ret_0 = SimCodeUtil.cref2simvar(i_name, a_simCode);
        txt = fun_204(txt, ret_0, i_name, x_i0);
        txt = Tpl.nextIter(txt);
        txt = lm_205(txt, rest, a_simCode);
      then txt;

    case ( txt,
           _ :: rest,
           a_simCode )
      equation
        txt = lm_205(txt, rest, a_simCode);
      then txt;
  end match;
end lm_205;

protected function fun_206
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;
  input SimCode.SimCode in_a_simCode;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo, in_a_simCode, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      String a_modelNamePrefix;
      list<SimCodeVar.SimVar> i_vars_inputVars;

    case ( txt,
           SimCode.MODELINFO(vars = SimCodeVar.SIMVARS(inputVars = i_vars_inputVars)),
           a_simCode,
           a_modelNamePrefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("int "));
        txt = CodegenUtil.symbolName(txt, a_modelNamePrefix, "input_function");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA *data, threadData_t *threadData)\n",
                                    "{\n",
                                    "  TRACE_PUSH\n",
                                    "\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_199(txt, i_vars_inputVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "TRACE_POP\n",
                                    "return 0;\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n",
                                    "int "
                                }, false));
        txt = CodegenUtil.symbolName(txt, a_modelNamePrefix, "input_function_init");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA *data, threadData_t *threadData)\n",
                                    "{\n",
                                    "  TRACE_PUSH\n",
                                    "\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_201(txt, i_vars_inputVars, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "TRACE_POP\n",
                                    "return 0;\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n",
                                    "int "
                                }, false));
        txt = CodegenUtil.symbolName(txt, a_modelNamePrefix, "input_function_updateStartValues");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA *data, threadData_t *threadData)\n",
                                    "{\n",
                                    "  TRACE_PUSH\n",
                                    "\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_203(txt, i_vars_inputVars, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "TRACE_POP\n",
                                    "return 0;\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n",
                                    "int "
                                }, false));
        txt = CodegenUtil.symbolName(txt, a_modelNamePrefix, "inputNames");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA *data, char ** names){\n",
                                    "  TRACE_PUSH\n",
                                    "\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_205(txt, i_vars_inputVars, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "TRACE_POP\n",
                                    "return 0;\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_206;

public function functionInput
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input SimCode.ModelInfo a_modelInfo;
  input String a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_206(txt, a_modelInfo, a_simCode, a_modelNamePrefix);
end functionInput;

protected function lm_208
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Integer x_i0;
      DAE.ComponentRef i_name;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(name = i_name, type_ = DAE.T_REAL(varLst = _)) :: rest )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = CodegenCFunctions.cref(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = data->simulationInfo->datainputVars["));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("];"));
        txt = Tpl.nextIter(txt);
        txt = lm_208(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_208(txt, rest);
      then txt;
  end match;
end lm_208;

protected function fun_209
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_mArg;
  input DAE.ComponentRef in_a_name;
  input Integer in_a_i0;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_name, in_a_i0)
    local
      Tpl.Text txt;
      DAE.ComponentRef a_name;
      Integer a_i0;
      Integer i_index;
      DAE.Type i_type__;
      Tpl.Text txt_0;

    case ( txt,
           SimCodeVar.SIMVAR(aliasvar = SimCodeVar.NOALIAS(), type_ = i_type__, index = i_index),
           _,
           a_i0 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("names["));
        txt = Tpl.writeStr(txt, intString(a_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = (char *) data->modelData->"));
        txt = CodegenCFunctions.expTypeShort(txt, i_type__);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("VarsData["));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].info.name;"));
      then txt;

    case ( txt,
           _,
           a_name,
           _ )
      equation
        txt_0 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("Cannot get attributes of alias variable "));
        txt_0 = CodegenUtil.crefStr(txt_0, a_name);
        txt_0 = Tpl.writeTok(txt_0, Tpl.ST_STRING(". Alias variables should have been replaced by the compiler before SimCode"));
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 1741, 20), Tpl.textString(txt_0));
      then txt;
  end match;
end fun_209;

protected function lm_210
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCode.SimCode a_simCode;
      Integer x_i0;
      DAE.ComponentRef i_name;
      SimCodeVar.SimVar ret_0;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(name = i_name) :: rest,
           a_simCode )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        ret_0 = SimCodeUtil.cref2simvar(i_name, a_simCode);
        txt = fun_209(txt, ret_0, i_name, x_i0);
        txt = Tpl.nextIter(txt);
        txt = lm_210(txt, rest, a_simCode);
      then txt;

    case ( txt,
           _ :: rest,
           a_simCode )
      equation
        txt = lm_210(txt, rest, a_simCode);
      then txt;
  end match;
end lm_210;

protected function fun_211
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;
  input SimCode.SimCode in_a_simCode;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo, in_a_simCode, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      String a_modelNamePrefix;
      list<SimCodeVar.SimVar> i_vars_dataReconinputVars;

    case ( txt,
           SimCode.MODELINFO(vars = SimCodeVar.SIMVARS(dataReconinputVars = i_vars_dataReconinputVars)),
           a_simCode,
           a_modelNamePrefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("int "));
        txt = CodegenUtil.symbolName(txt, a_modelNamePrefix, "data_function");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA *data, threadData_t *threadData)\n",
                                    "{\n",
                                    "  TRACE_PUSH\n",
                                    "\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_208(txt, i_vars_dataReconinputVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "TRACE_POP\n",
                                    "return 0;\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n",
                                    "int "
                                }, false));
        txt = CodegenUtil.symbolName(txt, a_modelNamePrefix, "dataReconciliationInputNames");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA *data, char ** names){\n",
                                    "  TRACE_PUSH\n",
                                    "\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_210(txt, i_vars_dataReconinputVars, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "TRACE_POP\n",
                                    "return 0;\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_211;

public function functionDataInput
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input SimCode.ModelInfo a_modelInfo;
  input String a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_211(txt, a_modelInfo, a_simCode, a_modelNamePrefix);
end functionDataInput;

protected function lm_213
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Integer x_i0;
      DAE.ComponentRef i_name;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(name = i_name, type_ = DAE.T_REAL(varLst = _)) :: rest )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("data->simulationInfo->outputVars["));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = "));
        txt = CodegenCFunctions.cref(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        txt = lm_213(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_213(txt, rest);
      then txt;
  end match;
end lm_213;

public function functionOutput
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      String a_modelNamePrefix;
      list<SimCodeVar.SimVar> i_vars_outputVars;

    case ( txt,
           SimCode.MODELINFO(vars = SimCodeVar.SIMVARS(outputVars = i_vars_outputVars)),
           a_modelNamePrefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("int "));
        txt = CodegenUtil.symbolName(txt, a_modelNamePrefix, "output_function");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA *data, threadData_t *threadData)\n",
                                    "{\n",
                                    "  TRACE_PUSH\n",
                                    "\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_213(txt, i_vars_outputVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "TRACE_POP\n",
                                    "return 0;\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end functionOutput;

protected function lm_215
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Integer x_i0;
      DAE.ComponentRef i_name;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(name = i_name, type_ = DAE.T_REAL(varLst = _)) :: rest )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("data->simulationInfo->setcVars["));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = "));
        txt = CodegenCFunctions.cref(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        txt = lm_215(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_215(txt, rest);
      then txt;
  end match;
end lm_215;

public function functionSetC
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      String a_modelNamePrefix;
      list<SimCodeVar.SimVar> i_vars_dataReconSetcVars;

    case ( txt,
           SimCode.MODELINFO(vars = SimCodeVar.SIMVARS(dataReconSetcVars = i_vars_dataReconSetcVars)),
           a_modelNamePrefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("int "));
        txt = CodegenUtil.symbolName(txt, a_modelNamePrefix, "setc_function");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA *data, threadData_t *threadData)\n",
                                    "{\n",
                                    "  TRACE_PUSH\n",
                                    "\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_215(txt, i_vars_dataReconSetcVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "TRACE_POP\n",
                                    "return 0;\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end functionSetC;

protected function fun_217
  input Tpl.Text in_txt;
  input BackendDAE.TimeEvent in_a_timeEvent;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_a_timeEvent, in_a_auxFunction, in_a_varDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Integer i_index;
      DAE.Exp i_intervalExp;
      DAE.Exp i_startExp;
      Tpl.Text l_e2;
      Tpl.Text l_e1;
      Tpl.Text l_preExp;

    case ( txt,
           BackendDAE.SAMPLE_TIME_EVENT(startExp = i_startExp, intervalExp = i_intervalExp, index = i_index),
           a_auxFunction,
           a_varDecls )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_e1, l_preExp, a_varDecls, a_auxFunction) = CodegenCFunctions.daeExp(Tpl.emptyTxt, i_startExp, SimCodeFunction.contextOther, l_preExp, a_varDecls, a_auxFunction);
        (l_e2, l_preExp, a_varDecls, a_auxFunction) = CodegenCFunctions.daeExp(Tpl.emptyTxt, i_intervalExp, SimCodeFunction.contextOther, l_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/* sample "));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " */\n",
                                    "data->modelData->samplesInfo[i].index = "
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "data->modelData->samplesInfo[i].start = "
                                }, false));
        txt = Tpl.writeText(txt, l_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "data->modelData->samplesInfo[i].interval = "
                                }, false));
        txt = Tpl.writeText(txt, l_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "assertStreamPrint(threadData,data->modelData->samplesInfo[i].interval > 0.0, \"sample-interval <= 0.0\");\n",
                                    "i++;"
                                }, false));
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           _,
           a_auxFunction,
           a_varDecls )
      then (txt, a_auxFunction, a_varDecls);
  end match;
end fun_217;

protected function lm_218
  input Tpl.Text in_txt;
  input list<BackendDAE.TimeEvent> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls)
    local
      Tpl.Text txt;
      list<BackendDAE.TimeEvent> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      BackendDAE.TimeEvent i_timeEvent;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls )
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           i_timeEvent :: rest,
           a_auxFunction,
           a_varDecls )
      equation
        (txt, a_auxFunction, a_varDecls) = fun_217(txt, i_timeEvent, a_auxFunction, a_varDecls);
        (txt, a_auxFunction, a_varDecls) = lm_218(txt, rest, a_auxFunction, a_varDecls);
      then (txt, a_auxFunction, a_varDecls);
  end match;
end lm_218;

public function functionInitSample
  input Tpl.Text txt;
  input list<BackendDAE.TimeEvent> a_timeEvents;
  input String a_modelNamePrefix;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_res;
  Tpl.Text l_body;
  Tpl.Text l_auxFunction;
  Tpl.Text l_varDecls;
algorithm
  l_varDecls := Tpl.emptyTxt;
  l_auxFunction := Tpl.emptyTxt;
  (l_body, l_auxFunction, l_varDecls) := lm_218(Tpl.emptyTxt, a_timeEvents, l_auxFunction, l_varDecls);
  l_res := Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING_LIST({
                                          "/* Initializes the raw time events of the simulation using the now\n",
                                          "   calcualted parameters. */\n",
                                          "void "
                                      }, false));
  l_res := CodegenUtil.symbolName(l_res, a_modelNamePrefix, "function_initSample");
  l_res := Tpl.writeTok(l_res, Tpl.ST_STRING_LIST({
                                   "(DATA *data, threadData_t *threadData)\n",
                                   "{\n",
                                   "  long i=0;\n"
                               }, true));
  l_res := Tpl.pushBlock(l_res, Tpl.BT_INDENT(2));
  l_res := Tpl.writeText(l_res, l_varDecls);
  l_res := Tpl.softNewLine(l_res);
  l_res := Tpl.writeText(l_res, l_body);
  l_res := Tpl.softNewLine(l_res);
  l_res := Tpl.popBlock(l_res);
  l_res := Tpl.writeTok(l_res, Tpl.ST_STRING("}"));
  out_txt := Tpl.writeText(txt, l_auxFunction);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeText(out_txt, l_res);
end functionInitSample;

protected function lm_220
  input Tpl.Text in_txt;
  input list<SimCode.JacobianColumn> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.JacobianColumn> rest;
      list<SimCode.SimEqSystem> i_cEqns;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           SimCode.JAC_COLUMN(columnEqns = i_cEqns) :: rest )
      equation
        txt = functionInitialMixedSystemsTemp(txt, i_cEqns);
        txt = Tpl.nextIter(txt);
        txt = lm_220(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_220(txt, rest);
      then txt;
  end match;
end lm_220;

protected function lm_221
  input Tpl.Text in_txt;
  input list<SimCode.JacobianMatrix> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.JacobianMatrix> rest;
      list<SimCode.JacobianColumn> i_clst;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           SimCode.JAC_MATRIX(columns = i_clst) :: rest )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_220(txt, i_clst);
        txt = Tpl.popIter(txt);
        txt = Tpl.nextIter(txt);
        txt = lm_221(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_221(txt, rest);
      then txt;
  end match;
end lm_221;

public function functionInitialMixedSystems
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_initialEquations;
  input list<SimCode.SimEqSystem> a_initialEquations__lambda0;
  input list<SimCode.SimEqSystem> a_parameterEquations;
  input list<SimCode.SimEqSystem> a_allEquations;
  input list<SimCode.JacobianMatrix> a_jacobianMatrixes;
  input String a_modelNamePrefix;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_jacobianbody;
  Tpl.Text l_body;
  Tpl.Text l_parambody;
  Tpl.Text l_initbody__lambda0;
  Tpl.Text l_initbody;
algorithm
  l_initbody := functionInitialMixedSystemsTemp(Tpl.emptyTxt, a_initialEquations);
  l_initbody__lambda0 := functionInitialMixedSystemsTemp(Tpl.emptyTxt, a_initialEquations__lambda0);
  l_parambody := functionInitialMixedSystemsTemp(Tpl.emptyTxt, a_parameterEquations);
  l_body := functionInitialMixedSystemsTemp(Tpl.emptyTxt, a_allEquations);
  l_jacobianbody := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  l_jacobianbody := lm_221(l_jacobianbody, a_jacobianMatrixes);
  l_jacobianbody := Tpl.popIter(l_jacobianbody);
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                   "/* funtion initialize mixed systems */\n",
                                   "void "
                               }, false));
  out_txt := CodegenUtil.symbolName(out_txt, a_modelNamePrefix, "initialMixedSystem");
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "(int nMixedSystems, MIXED_SYSTEM_DATA* mixedSystemData)\n",
                                       "{\n",
                                       "  /* initial mixed systems */\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeText(out_txt, l_initbody);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("/* initial_lambda0 mixed systems */\n"));
  out_txt := Tpl.writeText(out_txt, l_initbody__lambda0);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("/* parameter mixed systems */\n"));
  out_txt := Tpl.writeText(out_txt, l_parambody);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("/* model mixed systems */\n"));
  out_txt := Tpl.writeText(out_txt, l_body);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("/* jacobians mixed systems */\n"));
  out_txt := Tpl.writeText(out_txt, l_jacobianbody);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("}"));
end functionInitialMixedSystems;

protected function fun_223
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eqn;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_eqn)
    local
      Tpl.Text txt;
      Integer i_index;
      Integer i_indexMixedSystem;
      list<SimCodeVar.SimVar> i_discVars;
      Integer ret_1;
      Tpl.Text l_size;

    case ( txt,
           SimCode.SES_MIXED(discVars = i_discVars, indexMixedSystem = i_indexMixedSystem, index = i_index) )
      equation
        ret_1 = listLength(i_discVars);
        l_size = Tpl.writeStr(Tpl.emptyTxt, intString(ret_1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("assertStreamPrint(NULL, nMixedSystems > "));
        txt = Tpl.writeStr(txt, intString(i_indexMixedSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ", \"Internal Error: nMixedSystems mismatch!\");\n",
                                    "mixedSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_indexMixedSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].equationIndex = "));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "mixedSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_indexMixedSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].size = "));
        txt = Tpl.writeText(txt, l_size);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "mixedSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_indexMixedSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].solveContinuousPart = updateContinuousPart"));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "mixedSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_indexMixedSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].updateIterationExps = updateIterationExpMixedSystem"));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_223;

protected function lm_224
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      SimCode.SimEqSystem i_eqn;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_eqn :: rest )
      equation
        txt = fun_223(txt, i_eqn);
        txt = Tpl.nextIter(txt);
        txt = lm_224(txt, rest);
      then txt;
  end match;
end lm_224;

public function functionInitialMixedSystemsTemp
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_allEquations;

  output Tpl.Text out_txt;
algorithm
  out_txt := Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING_LIST({
                                                                    "\n",
                                                                    "\n"
                                                                }, true)), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_224(out_txt, a_allEquations);
  out_txt := Tpl.popIter(out_txt);
end functionInitialMixedSystemsTemp;

protected function lm_226
  input Tpl.Text in_txt;
  input list<SimCode.JacobianColumn> in_items;
  input String in_a_modelNamePrefixStr;
  input Tpl.Text in_a_header;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_header;
algorithm
  (out_txt, out_a_header) :=
  match(in_txt, in_items, in_a_modelNamePrefixStr, in_a_header)
    local
      Tpl.Text txt;
      list<SimCode.JacobianColumn> rest;
      String a_modelNamePrefixStr;
      Tpl.Text a_header;
      list<SimCode.SimEqSystem> i_cEqns;

    case ( txt,
           {},
           _,
           a_header )
      then (txt, a_header);

    case ( txt,
           SimCode.JAC_COLUMN(columnEqns = i_cEqns) :: rest,
           a_modelNamePrefixStr,
           a_header )
      equation
        (txt, a_header) = functionSetupMixedSystemsTemp(txt, i_cEqns, a_header, a_modelNamePrefixStr);
        txt = Tpl.nextIter(txt);
        (txt, a_header) = lm_226(txt, rest, a_modelNamePrefixStr, a_header);
      then (txt, a_header);

    case ( txt,
           _ :: rest,
           a_modelNamePrefixStr,
           a_header )
      equation
        (txt, a_header) = lm_226(txt, rest, a_modelNamePrefixStr, a_header);
      then (txt, a_header);
  end match;
end lm_226;

protected function lm_227
  input Tpl.Text in_txt;
  input list<SimCode.JacobianMatrix> in_items;
  input String in_a_modelNamePrefixStr;
  input Tpl.Text in_a_header;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_header;
algorithm
  (out_txt, out_a_header) :=
  match(in_txt, in_items, in_a_modelNamePrefixStr, in_a_header)
    local
      Tpl.Text txt;
      list<SimCode.JacobianMatrix> rest;
      String a_modelNamePrefixStr;
      Tpl.Text a_header;
      list<SimCode.JacobianColumn> i_clst;

    case ( txt,
           {},
           _,
           a_header )
      then (txt, a_header);

    case ( txt,
           SimCode.JAC_MATRIX(columns = i_clst) :: rest,
           a_modelNamePrefixStr,
           a_header )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_header) = lm_226(txt, i_clst, a_modelNamePrefixStr, a_header);
        txt = Tpl.popIter(txt);
        txt = Tpl.nextIter(txt);
        (txt, a_header) = lm_227(txt, rest, a_modelNamePrefixStr, a_header);
      then (txt, a_header);

    case ( txt,
           _ :: rest,
           a_modelNamePrefixStr,
           a_header )
      equation
        (txt, a_header) = lm_227(txt, rest, a_modelNamePrefixStr, a_header);
      then (txt, a_header);
  end match;
end lm_227;

public function functionSetupMixedSystems
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_initialEquations;
  input list<SimCode.SimEqSystem> a_initialEquations__lambda0;
  input list<SimCode.SimEqSystem> a_parameterEquations;
  input list<SimCode.SimEqSystem> a_allEquations;
  input list<SimCode.JacobianMatrix> a_jacobianMatrixes;
  input Tpl.Text a_header;
  input String a_modelNamePrefixStr;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_header;
protected
  Tpl.Text l_jacobianbody;
  Tpl.Text l_body;
  Tpl.Text l_parambody;
  Tpl.Text l_initbody__lambda0;
  Tpl.Text l_initbody;
algorithm
  (l_initbody, out_a_header) := functionSetupMixedSystemsTemp(Tpl.emptyTxt, a_initialEquations, a_header, a_modelNamePrefixStr);
  (l_initbody__lambda0, out_a_header) := functionSetupMixedSystemsTemp(Tpl.emptyTxt, a_initialEquations__lambda0, out_a_header, a_modelNamePrefixStr);
  (l_parambody, out_a_header) := functionSetupMixedSystemsTemp(Tpl.emptyTxt, a_parameterEquations, out_a_header, a_modelNamePrefixStr);
  (l_body, out_a_header) := functionSetupMixedSystemsTemp(Tpl.emptyTxt, a_allEquations, out_a_header, a_modelNamePrefixStr);
  l_jacobianbody := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (l_jacobianbody, out_a_header) := lm_227(l_jacobianbody, a_jacobianMatrixes, a_modelNamePrefixStr, out_a_header);
  l_jacobianbody := Tpl.popIter(l_jacobianbody);
  out_txt := Tpl.writeTok(txt, Tpl.ST_LINE("/* initial mixed systems */\n"));
  out_txt := Tpl.writeText(out_txt, l_initbody);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("/* initial_lambda0 mixed systems */\n"));
  out_txt := Tpl.writeText(out_txt, l_initbody__lambda0);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("/* parameter mixed systems */\n"));
  out_txt := Tpl.writeText(out_txt, l_parambody);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("/* model mixed systems */\n"));
  out_txt := Tpl.writeText(out_txt, l_body);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("/* jacobians mixed systems */\n"));
  out_txt := Tpl.writeText(out_txt, l_jacobianbody);
end functionSetupMixedSystems;

protected function fun_229
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_cont;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_cont)
    local
      Tpl.Text txt;
      Integer i_at_indexNonLinearSystem;
      Integer i_at_indexLinearSystem;
      Integer i_nls_indexNonLinearSystem;
      Integer i_ls_indexLinearSystem;

    case ( txt,
           SimCode.SES_LINEAR(lSystem = SimCode.LINEARSYSTEM(indexLinearSystem = i_ls_indexLinearSystem), alternativeTearing = NONE()) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("data->simulationInfo->linearSystemData["));
        txt = Tpl.writeStr(txt, intString(i_ls_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].solved"));
      then txt;

    case ( txt,
           SimCode.SES_NONLINEAR(nlSystem = SimCode.NONLINEARSYSTEM(indexNonLinearSystem = i_nls_indexNonLinearSystem), alternativeTearing = NONE()) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("data->simulationInfo->nonlinearSystemData["));
        txt = Tpl.writeStr(txt, intString(i_nls_indexNonLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].solved"));
      then txt;

    case ( txt,
           SimCode.SES_LINEAR(lSystem = SimCode.LINEARSYSTEM(indexLinearSystem = i_ls_indexLinearSystem), alternativeTearing = SOME(SimCode.LINEARSYSTEM(indexLinearSystem = i_at_indexLinearSystem))) )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("data->simulationInfo->linearSystemData["));
        txt = Tpl.writeStr(txt, intString(i_ls_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "].solved\'\n",
                                    "data->simulationInfo->linearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_at_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].solved\'"));
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           SimCode.SES_NONLINEAR(nlSystem = SimCode.NONLINEARSYSTEM(indexNonLinearSystem = i_nls_indexNonLinearSystem), alternativeTearing = SOME(SimCode.NONLINEARSYSTEM(indexNonLinearSystem = i_at_indexNonLinearSystem))) )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("data->simulationInfo->nonlinearSystemData["));
        txt = Tpl.writeStr(txt, intString(i_nls_indexNonLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "].solved\n",
                                    "data->simulationInfo->nonlinearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_at_indexNonLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].solved"));
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_229;

protected function lm_230
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preDisc;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preDisc;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preDisc) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_preDisc)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preDisc;
      DAE.ComponentRef i_cref;
      DAE.Exp i_exp;
      Tpl.Text l_expPart;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_preDisc )
      then (txt, a_auxFunction, a_varDecls, a_preDisc);

    case ( txt,
           SimCode.SES_SIMPLE_ASSIGN(exp = i_exp, cref = i_cref) :: rest,
           a_auxFunction,
           a_varDecls,
           a_preDisc )
      equation
        (l_expPart, a_preDisc, a_varDecls, a_auxFunction) = CodegenCFunctions.daeExp(Tpl.emptyTxt, i_exp, SimCodeFunction.contextSimulationDiscrete, a_preDisc, a_varDecls, a_auxFunction);
        txt = CodegenCFunctions.cref(txt, i_cref);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, l_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_preDisc) = lm_230(txt, rest, a_auxFunction, a_varDecls, a_preDisc);
      then (txt, a_auxFunction, a_varDecls, a_preDisc);

    case ( txt,
           _ :: rest,
           a_auxFunction,
           a_varDecls,
           a_preDisc )
      equation
        (txt, a_auxFunction, a_varDecls, a_preDisc) = lm_230(txt, rest, a_auxFunction, a_varDecls, a_preDisc);
      then (txt, a_auxFunction, a_varDecls, a_preDisc);
  end match;
end lm_230;

protected function fun_231
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eqn;
  input String in_a_modelNamePrefixStr;
  input Tpl.Text in_a_header;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_header;
algorithm
  (out_txt, out_a_header) :=
  match(in_txt, in_a_eqn, in_a_modelNamePrefixStr, in_a_header)
    local
      Tpl.Text txt;
      String a_modelNamePrefixStr;
      Tpl.Text a_header;
      Integer i_indexMixedSystem;
      Integer i_index;
      list<SimCode.SimEqSystem> i_discEqs;
      SimCode.SimEqSystem i_cont;
      Tpl.Text l_discExp;
      Tpl.Text l_auxFunction;
      Tpl.Text l_varDecls;
      Tpl.Text l_preDisc;
      Tpl.Text l_solvedContinuous;
      Tpl.Text l_contEqsIndex;

    case ( txt,
           SimCode.SES_MIXED(cont = i_cont, discEqs = i_discEqs, index = i_index, indexMixedSystem = i_indexMixedSystem),
           a_modelNamePrefixStr,
           a_header )
      equation
        l_contEqsIndex = CodegenUtilSimulation.equationIndex(Tpl.emptyTxt, i_cont);
        l_solvedContinuous = fun_229(Tpl.emptyTxt, i_cont);
        l_preDisc = Tpl.emptyTxt;
        l_varDecls = Tpl.emptyTxt;
        l_auxFunction = Tpl.emptyTxt;
        l_discExp = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_discExp, l_auxFunction, l_varDecls, l_preDisc) = lm_230(l_discExp, i_discEqs, l_auxFunction, l_varDecls, l_preDisc);
        l_discExp = Tpl.popIter(l_discExp);
        a_header = Tpl.writeTok(a_header, Tpl.ST_STRING("void updateContinuousPart"));
        a_header = Tpl.writeStr(a_header, intString(i_index));
        a_header = Tpl.writeTok(a_header, Tpl.ST_STRING("(void *);"));
        a_header = Tpl.writeTok(a_header, Tpl.ST_NEW_LINE());
        a_header = Tpl.writeTok(a_header, Tpl.ST_STRING("void updateIterationExpMixedSystem"));
        a_header = Tpl.writeStr(a_header, intString(i_index));
        a_header = Tpl.writeTok(a_header, Tpl.ST_STRING("(void *);"));
        a_header = Tpl.writeTok(a_header, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_auxFunction);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void updateContinuousPart"));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(void *inData)\n",
                                    "{\n",
                                    "  DATA* data = (DATA*) inData;\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = CodegenUtil.symbolName(txt, a_modelNamePrefixStr, "eqFunction");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeText(txt, l_contEqsIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(data, threadData);\n",
                                    "data->simulationInfo->mixedSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_indexMixedSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].continuous_solution = "));
        txt = Tpl.writeText(txt, l_solvedContinuous);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n",
                                    "void updateIterationExpMixedSystem"
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(void *inData)\n",
                                    "{\n",
                                    "  DATA* data = (DATA*) inData;\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_varDecls);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_preDisc);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_discExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then (txt, a_header);

    case ( txt,
           _,
           _,
           a_header )
      then (txt, a_header);
  end match;
end fun_231;

protected function lm_232
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input String in_a_modelNamePrefixStr;
  input Tpl.Text in_a_header;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_header;
algorithm
  (out_txt, out_a_header) :=
  match(in_txt, in_items, in_a_modelNamePrefixStr, in_a_header)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      String a_modelNamePrefixStr;
      Tpl.Text a_header;
      SimCode.SimEqSystem i_eqn;

    case ( txt,
           {},
           _,
           a_header )
      then (txt, a_header);

    case ( txt,
           i_eqn :: rest,
           a_modelNamePrefixStr,
           a_header )
      equation
        (txt, a_header) = fun_231(txt, i_eqn, a_modelNamePrefixStr, a_header);
        txt = Tpl.nextIter(txt);
        (txt, a_header) = lm_232(txt, rest, a_modelNamePrefixStr, a_header);
      then (txt, a_header);
  end match;
end lm_232;

public function functionSetupMixedSystemsTemp
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_allEquations;
  input Tpl.Text a_header;
  input String a_modelNamePrefixStr;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_header;
algorithm
  out_txt := Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING_LIST({
                                                                    "\n",
                                                                    "\n"
                                                                }, true)), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (out_txt, out_a_header) := lm_232(out_txt, a_allEquations, a_modelNamePrefixStr, a_header);
  out_txt := Tpl.popIter(out_txt);
end functionSetupMixedSystemsTemp;

protected function fun_234
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_eq, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      String a_modelNamePrefix;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           (i_eq as SimCode.SES_LINEAR(alternativeTearing = SOME(_))),
           a_modelNamePrefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("int "));
        txt = CodegenUtil.symbolName(txt, a_modelNamePrefix, "eqFunction");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = CodegenUtilSimulation.equationIndex(txt, i_eq);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(DATA*);"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_234;

protected function lm_235
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      String a_modelNamePrefix;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_eq :: rest,
           a_modelNamePrefix )
      equation
        txt = fun_234(txt, i_eq, a_modelNamePrefix);
        txt = Tpl.nextIter(txt);
        txt = lm_235(txt, rest, a_modelNamePrefix);
      then txt;
  end match;
end lm_235;

public function functionInitialLinearSystems
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_linearSystems;
  input String a_modelNamePrefix;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_linearbody;
  Tpl.Text l_globalConstraintsFunctions;
  Tpl.Text l_tempeqns;
algorithm
  l_tempeqns := Tpl.emptyTxt;
  l_tempeqns := Tpl.pushIter(l_tempeqns, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  l_tempeqns := lm_235(l_tempeqns, a_linearSystems, a_modelNamePrefix);
  l_tempeqns := Tpl.popIter(l_tempeqns);
  l_globalConstraintsFunctions := Tpl.emptyTxt;
  (l_linearbody, l_globalConstraintsFunctions) := functionInitialLinearSystemsTemp(Tpl.emptyTxt, a_linearSystems, a_modelNamePrefix, l_globalConstraintsFunctions);
  out_txt := Tpl.writeTok(txt, Tpl.ST_LINE("/* Prototypes for the strict sets (Dynamic Tearing) */\n"));
  out_txt := Tpl.writeText(out_txt, l_tempeqns);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "/* Global constraints for the casual sets */\n"
                                   }, true));
  out_txt := Tpl.writeText(out_txt, l_globalConstraintsFunctions);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "/* function initialize linear systems */\n",
                                       "void "
                                   }, false));
  out_txt := CodegenUtil.symbolName(out_txt, a_modelNamePrefix, "initialLinearSystem");
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "(int nLinearSystems, LINEAR_SYSTEM_DATA* linearSystemData)\n",
                                       "{\n",
                                       "  /* linear systems */\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeText(out_txt, l_linearbody);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("}"));
end functionInitialLinearSystems;

protected function fun_237
  input Tpl.Text in_txt;
  input Option<SimCode.JacobianMatrix> in_a_ls_jacobianMatrix;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ls_jacobianMatrix, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      String a_modelNamePrefix;
      String i_name;

    case ( txt,
           SOME(SimCode.JAC_MATRIX(matrixName = i_name)),
           a_modelNamePrefix )
      equation
        txt = CodegenUtil.symbolName(txt, a_modelNamePrefix, "functionJac");
        txt = Tpl.writeStr(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_column"));
      then txt;

    case ( txt,
           NONE(),
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("NULL"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_237;

protected function fun_238
  input Tpl.Text in_txt;
  input Option<SimCode.JacobianMatrix> in_a_ls_jacobianMatrix;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ls_jacobianMatrix, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      String a_modelNamePrefix;
      String i_name;

    case ( txt,
           SOME(SimCode.JAC_MATRIX(matrixName = i_name)),
           a_modelNamePrefix )
      equation
        txt = CodegenUtil.symbolName(txt, a_modelNamePrefix, "initialAnalyticJacobian");
        txt = Tpl.writeStr(txt, i_name);
      then txt;

    case ( txt,
           NONE(),
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("NULL"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_238;

protected function fun_239
  input Tpl.Text in_txt;
  input Option<SimCode.JacobianMatrix> in_a_ls_jacobianMatrix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ls_jacobianMatrix)
    local
      Tpl.Text txt;
      Integer i_jacindex;

    case ( txt,
           SOME(SimCode.JAC_MATRIX(matrixName = _, jacobianIndex = i_jacindex)) )
      equation
        txt = Tpl.writeStr(txt, intString(i_jacindex));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" /*jacInx*/"));
      then txt;

    case ( txt,
           NONE() )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-1"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_239;

protected function fun_240
  input Tpl.Text in_txt;
  input Option<SimCode.JacobianMatrix> in_a_ls_jacobianMatrix;
  input String in_a_modelNamePrefix;
  input Integer in_a_ls_index;
  input Integer in_a_ls_indexLinearSystem;
  input list<tuple<Integer, Integer, SimCode.SimEqSystem>> in_a_ls_simJac;
  input list<SimCodeVar.SimVar> in_a_ls_vars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ls_jacobianMatrix, in_a_modelNamePrefix, in_a_ls_index, in_a_ls_indexLinearSystem, in_a_ls_simJac, in_a_ls_vars)
    local
      Tpl.Text txt;
      String a_modelNamePrefix;
      Integer a_ls_index;
      Integer a_ls_indexLinearSystem;
      list<tuple<Integer, Integer, SimCode.SimEqSystem>> a_ls_simJac;
      list<SimCodeVar.SimVar> a_ls_vars;
      Option<SimCode.JacobianMatrix> i_ls_jacobianMatrix;
      Tpl.Text txt_9;
      Tpl.Text l_jacIndex;
      Tpl.Text l_initialJac;
      Tpl.Text l_generatedJac;
      Integer ret_5;
      Integer ret_4;
      Integer ret_3;
      Tpl.Text l_nnz;
      Integer ret_1;
      Tpl.Text l_size;

    case ( txt,
           NONE(),
           _,
           a_ls_index,
           a_ls_indexLinearSystem,
           a_ls_simJac,
           a_ls_vars )
      equation
        ret_1 = listLength(a_ls_vars);
        l_size = Tpl.writeStr(Tpl.emptyTxt, intString(ret_1));
        ret_3 = listLength(a_ls_simJac);
        l_nnz = Tpl.writeStr(Tpl.emptyTxt, intString(ret_3));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("assertStreamPrint(NULL, nLinearSystems > "));
        txt = Tpl.writeStr(txt, intString(a_ls_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ", \"Internal Error: nLinearSystems mismatch!\");\n",
                                    "linearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_ls_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].equationIndex = "));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "linearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_ls_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].size = "));
        txt = Tpl.writeText(txt, l_size);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "linearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_ls_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].nnz = "));
        txt = Tpl.writeText(txt, l_nnz);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "linearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_ls_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "].method = 0;   /* No symbolic Jacobian available */\n",
                                    "linearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_ls_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "].strictTearingFunctionCall = NULL;\n",
                                    "linearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_ls_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].setA = setLinearMatrixA"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "linearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_ls_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].setb = setLinearVectorb"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "linearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_ls_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].initializeStaticLSData = initializeStaticLSData"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           (i_ls_jacobianMatrix as SOME(_)),
           a_modelNamePrefix,
           a_ls_index,
           a_ls_indexLinearSystem,
           a_ls_simJac,
           a_ls_vars )
      equation
        ret_4 = listLength(a_ls_vars);
        l_size = Tpl.writeStr(Tpl.emptyTxt, intString(ret_4));
        ret_5 = listLength(a_ls_simJac);
        l_nnz = Tpl.writeStr(Tpl.emptyTxt, intString(ret_5));
        l_generatedJac = fun_237(Tpl.emptyTxt, i_ls_jacobianMatrix, a_modelNamePrefix);
        l_initialJac = fun_238(Tpl.emptyTxt, i_ls_jacobianMatrix, a_modelNamePrefix);
        l_jacIndex = fun_239(Tpl.emptyTxt, i_ls_jacobianMatrix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("assertStreamPrint(NULL, nLinearSystems > "));
        txt = Tpl.writeStr(txt, intString(a_ls_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ", \"Internal Error: indexlinearSystem mismatch!\");\n",
                                    "linearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_ls_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].equationIndex = "));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "linearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_ls_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].size = "));
        txt = Tpl.writeText(txt, l_size);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "linearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_ls_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].nnz = "));
        txt = Tpl.writeText(txt, l_nnz);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "linearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_ls_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "].method = 1;   /* Symbolic Jacobian available */\n",
                                    "linearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_ls_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].residualFunc = residualFunc"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "linearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_ls_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "].strictTearingFunctionCall = NULL;\n",
                                    "linearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_ls_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].analyticalJacobianColumn = "));
        txt = Tpl.writeText(txt, l_generatedJac);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "linearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_ls_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].initialAnalyticalJacobian = "));
        txt = Tpl.writeText(txt, l_initialJac);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "linearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_ls_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].jacobianIndex = "));
        txt = Tpl.writeText(txt, l_jacIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "linearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_ls_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].setA = NULL;  //setLinearMatrixA"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "linearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_ls_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].setb = NULL;  //setLinearVectorb"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "linearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_ls_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].initializeStaticLSData = initializeStaticLSData"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           _,
           _,
           a_ls_index,
           _,
           _,
           _ )
      equation
        txt_9 = Tpl.pushBlock(Tpl.emptyTxt, Tpl.BT_INDENT(1));
        txt_9 = Tpl.writeTok(txt_9, Tpl.ST_STRING("No jacobian create for linear system "));
        txt_9 = Tpl.writeStr(txt_9, intString(a_ls_index));
        txt_9 = Tpl.writeTok(txt_9, Tpl.ST_STRING("."));
        txt_9 = Tpl.popBlock(txt_9);
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 2027, 16), Tpl.textString(txt_9));
      then txt;
  end match;
end fun_240;

protected function fun_241
  input Tpl.Text in_txt;
  input Option<SimCode.JacobianMatrix> in_a_ls_jacobianMatrix;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ls_jacobianMatrix, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      String a_modelNamePrefix;
      String i_name;

    case ( txt,
           SOME(SimCode.JAC_MATRIX(matrixName = i_name)),
           a_modelNamePrefix )
      equation
        txt = CodegenUtil.symbolName(txt, a_modelNamePrefix, "functionJac");
        txt = Tpl.writeStr(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_column"));
      then txt;

    case ( txt,
           NONE(),
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("NULL"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_241;

protected function fun_242
  input Tpl.Text in_txt;
  input Option<SimCode.JacobianMatrix> in_a_ls_jacobianMatrix;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ls_jacobianMatrix, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      String a_modelNamePrefix;
      String i_name;

    case ( txt,
           SOME(SimCode.JAC_MATRIX(matrixName = i_name)),
           a_modelNamePrefix )
      equation
        txt = CodegenUtil.symbolName(txt, a_modelNamePrefix, "initialAnalyticJacobian");
        txt = Tpl.writeStr(txt, i_name);
      then txt;

    case ( txt,
           NONE(),
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("NULL"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_242;

protected function fun_243
  input Tpl.Text in_txt;
  input Option<SimCode.JacobianMatrix> in_a_ls_jacobianMatrix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ls_jacobianMatrix)
    local
      Tpl.Text txt;
      Integer i_jacindex;

    case ( txt,
           SOME(SimCode.JAC_MATRIX(matrixName = _, jacobianIndex = i_jacindex)) )
      equation
        txt = Tpl.writeStr(txt, intString(i_jacindex));
      then txt;

    case ( txt,
           NONE() )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-1"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_243;

protected function fun_244
  input Tpl.Text in_txt;
  input Option<SimCode.JacobianMatrix> in_a_at_jacobianMatrix;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_at_jacobianMatrix, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      String a_modelNamePrefix;
      String i_name;

    case ( txt,
           SOME(SimCode.JAC_MATRIX(matrixName = i_name)),
           a_modelNamePrefix )
      equation
        txt = CodegenUtil.symbolName(txt, a_modelNamePrefix, "functionJac");
        txt = Tpl.writeStr(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_column"));
      then txt;

    case ( txt,
           NONE(),
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("NULL"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_244;

protected function fun_245
  input Tpl.Text in_txt;
  input Option<SimCode.JacobianMatrix> in_a_at_jacobianMatrix;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_at_jacobianMatrix, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      String a_modelNamePrefix;
      String i_name;

    case ( txt,
           SOME(SimCode.JAC_MATRIX(matrixName = i_name)),
           a_modelNamePrefix )
      equation
        txt = CodegenUtil.symbolName(txt, a_modelNamePrefix, "initialAnalyticJacobian");
        txt = Tpl.writeStr(txt, i_name);
      then txt;

    case ( txt,
           NONE(),
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("NULL"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_245;

protected function fun_246
  input Tpl.Text in_txt;
  input Option<SimCode.JacobianMatrix> in_a_at_jacobianMatrix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_at_jacobianMatrix)
    local
      Tpl.Text txt;
      Integer i_jacindex;

    case ( txt,
           SOME(SimCode.JAC_MATRIX(matrixName = _, jacobianIndex = i_jacindex)) )
      equation
        txt = Tpl.writeStr(txt, intString(i_jacindex));
      then txt;

    case ( txt,
           NONE() )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-1"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_246;

protected function fun_247
  input Tpl.Text in_txt;
  input Option<SimCode.JacobianMatrix> in_a_ls_jacobianMatrix;
  input Option<SimCode.JacobianMatrix> in_a_at_jacobianMatrix;
  input String in_a_modelNamePrefix;
  input Integer in_a_at_index;
  input Integer in_a_at_indexLinearSystem;
  input Integer in_a_ls_index;
  input Integer in_a_ls_indexLinearSystem;
  input SimCode.SimEqSystem in_a_eq;
  input Tpl.Text in_a_globalConstraintsFunctions;
  input list<tuple<Integer, Integer, SimCode.SimEqSystem>> in_a_at_simJac;
  input list<SimCodeVar.SimVar> in_a_at_vars;
  input list<tuple<Integer, Integer, SimCode.SimEqSystem>> in_a_ls_simJac;
  input list<SimCodeVar.SimVar> in_a_ls_vars;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_globalConstraintsFunctions;
algorithm
  (out_txt, out_a_globalConstraintsFunctions) :=
  match(in_txt, in_a_ls_jacobianMatrix, in_a_at_jacobianMatrix, in_a_modelNamePrefix, in_a_at_index, in_a_at_indexLinearSystem, in_a_ls_index, in_a_ls_indexLinearSystem, in_a_eq, in_a_globalConstraintsFunctions, in_a_at_simJac, in_a_at_vars, in_a_ls_simJac, in_a_ls_vars)
    local
      Tpl.Text txt;
      Option<SimCode.JacobianMatrix> a_at_jacobianMatrix;
      String a_modelNamePrefix;
      Integer a_at_index;
      Integer a_at_indexLinearSystem;
      Integer a_ls_index;
      Integer a_ls_indexLinearSystem;
      SimCode.SimEqSystem a_eq;
      Tpl.Text a_globalConstraintsFunctions;
      list<tuple<Integer, Integer, SimCode.SimEqSystem>> a_at_simJac;
      list<SimCodeVar.SimVar> a_at_vars;
      list<tuple<Integer, Integer, SimCode.SimEqSystem>> a_ls_simJac;
      list<SimCodeVar.SimVar> a_ls_vars;
      Option<SimCode.JacobianMatrix> i_ls_jacobianMatrix;
      Tpl.Text txt_18;
      Tpl.Text l_jacIndex2;
      Tpl.Text l_initialJac2;
      Tpl.Text l_generatedJac2;
      Integer ret_14;
      Integer ret_13;
      Tpl.Text l_jacIndex;
      Tpl.Text l_initialJac;
      Tpl.Text l_generatedJac;
      Integer ret_9;
      Integer ret_8;
      Integer ret_7;
      Tpl.Text l_nnz2;
      Integer ret_5;
      Tpl.Text l_size2;
      Integer ret_3;
      Tpl.Text l_nnz;
      Integer ret_1;
      Tpl.Text l_size;

    case ( txt,
           NONE(),
           _,
           a_modelNamePrefix,
           a_at_index,
           a_at_indexLinearSystem,
           a_ls_index,
           a_ls_indexLinearSystem,
           a_eq,
           a_globalConstraintsFunctions,
           a_at_simJac,
           a_at_vars,
           a_ls_simJac,
           a_ls_vars )
      equation
        ret_1 = listLength(a_ls_vars);
        l_size = Tpl.writeStr(Tpl.emptyTxt, intString(ret_1));
        ret_3 = listLength(a_ls_simJac);
        l_nnz = Tpl.writeStr(Tpl.emptyTxt, intString(ret_3));
        ret_5 = listLength(a_at_vars);
        l_size2 = Tpl.writeStr(Tpl.emptyTxt, intString(ret_5));
        ret_7 = listLength(a_at_simJac);
        l_nnz2 = Tpl.writeStr(Tpl.emptyTxt, intString(ret_7));
        a_globalConstraintsFunctions = createGlobalConstraintsFunction(a_globalConstraintsFunctions, a_eq);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("assertStreamPrint(NULL, nLinearSystems > "));
        txt = Tpl.writeStr(txt, intString(a_ls_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ", \"Internal Error: nLinearSystems mismatch!\");\n",
                                    "linearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_ls_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].equationIndex = "));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "linearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_ls_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].size = "));
        txt = Tpl.writeText(txt, l_size);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "linearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_ls_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].nnz = "));
        txt = Tpl.writeText(txt, l_nnz);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "linearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_ls_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "].method = 0;   /* No symbolic Jacobian available */\n",
                                    "linearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_ls_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "].strictTearingFunctionCall = NULL;\n",
                                    "linearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_ls_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].setA = setLinearMatrixA"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "linearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_ls_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].setb = setLinearVectorb"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "linearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_ls_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].initializeStaticLSData = initializeStaticLSData"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "\n",
                                    "assertStreamPrint(NULL, nLinearSystems > "
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_at_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ", \"Internal Error: nLinearSystems mismatch!\");\n",
                                    "linearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_at_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].equationIndex = "));
        txt = Tpl.writeStr(txt, intString(a_at_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "linearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_at_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].size = "));
        txt = Tpl.writeText(txt, l_size2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "linearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_at_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].nnz = "));
        txt = Tpl.writeText(txt, l_nnz2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "linearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_at_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "].method = 0;   /* No symbolic Jacobian available */\n",
                                    "linearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_at_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].strictTearingFunctionCall = "));
        txt = CodegenUtil.symbolName(txt, a_modelNamePrefix, "eqFunction");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "linearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_at_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].setA = setLinearMatrixA"));
        txt = Tpl.writeStr(txt, intString(a_at_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "linearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_at_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].setb = setLinearVectorb"));
        txt = Tpl.writeStr(txt, intString(a_at_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "linearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_at_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].initializeStaticLSData = initializeStaticLSData"));
        txt = Tpl.writeStr(txt, intString(a_at_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "linearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_at_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].checkConstraints = checkConstraints"));
        txt = Tpl.writeStr(txt, intString(a_at_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then (txt, a_globalConstraintsFunctions);

    case ( txt,
           (i_ls_jacobianMatrix as SOME(_)),
           a_at_jacobianMatrix,
           a_modelNamePrefix,
           a_at_index,
           a_at_indexLinearSystem,
           a_ls_index,
           a_ls_indexLinearSystem,
           a_eq,
           a_globalConstraintsFunctions,
           a_at_simJac,
           a_at_vars,
           a_ls_simJac,
           a_ls_vars )
      equation
        ret_8 = listLength(a_ls_vars);
        l_size = Tpl.writeStr(Tpl.emptyTxt, intString(ret_8));
        ret_9 = listLength(a_ls_simJac);
        l_nnz = Tpl.writeStr(Tpl.emptyTxt, intString(ret_9));
        l_generatedJac = fun_241(Tpl.emptyTxt, i_ls_jacobianMatrix, a_modelNamePrefix);
        l_initialJac = fun_242(Tpl.emptyTxt, i_ls_jacobianMatrix, a_modelNamePrefix);
        l_jacIndex = fun_243(Tpl.emptyTxt, i_ls_jacobianMatrix);
        ret_13 = listLength(a_at_vars);
        l_size2 = Tpl.writeStr(Tpl.emptyTxt, intString(ret_13));
        ret_14 = listLength(a_at_simJac);
        l_nnz2 = Tpl.writeStr(Tpl.emptyTxt, intString(ret_14));
        l_generatedJac2 = fun_244(Tpl.emptyTxt, a_at_jacobianMatrix, a_modelNamePrefix);
        l_initialJac2 = fun_245(Tpl.emptyTxt, a_at_jacobianMatrix, a_modelNamePrefix);
        l_jacIndex2 = fun_246(Tpl.emptyTxt, a_at_jacobianMatrix);
        a_globalConstraintsFunctions = createGlobalConstraintsFunction(a_globalConstraintsFunctions, a_eq);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("assertStreamPrint(NULL, nLinearSystems > "));
        txt = Tpl.writeStr(txt, intString(a_ls_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ", \"Internal Error: indexlinearSystem mismatch!\");\n",
                                    "linearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_ls_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].equationIndex = "));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "linearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_ls_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].size = "));
        txt = Tpl.writeText(txt, l_size);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "linearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_ls_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].nnz = "));
        txt = Tpl.writeText(txt, l_nnz);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "linearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_ls_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "].method = 1;   /* Symbolic Jacobian available */\n",
                                    "linearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_ls_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].residualFunc = residualFunc"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "linearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_ls_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "].strictTearingFunctionCall = NULL;\n",
                                    "linearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_ls_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].analyticalJacobianColumn = "));
        txt = Tpl.writeText(txt, l_generatedJac);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "linearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_ls_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].initialAnalyticalJacobian = "));
        txt = Tpl.writeText(txt, l_initialJac);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "linearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_ls_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].jacobianIndex = "));
        txt = Tpl.writeText(txt, l_jacIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "linearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_ls_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].setA = NULL;  //setLinearMatrixA"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "linearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_ls_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].setb = NULL;  //setLinearVectorb"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "linearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_ls_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].initializeStaticLSData = initializeStaticLSData"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "\n",
                                    "assertStreamPrint(NULL, nLinearSystems > "
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_at_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ", \"Internal Error: indexlinearSystem mismatch!\");\n",
                                    "linearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_at_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].equationIndex = "));
        txt = Tpl.writeStr(txt, intString(a_at_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "linearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_at_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].size = "));
        txt = Tpl.writeText(txt, l_size2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "linearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_at_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].nnz = "));
        txt = Tpl.writeText(txt, l_nnz2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "linearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_at_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "].method = 1;   /* Symbolic Jacobian available */\n",
                                    "linearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_at_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].residualFunc = residualFunc"));
        txt = Tpl.writeStr(txt, intString(a_at_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "linearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_at_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].strictTearingFunctionCall = "));
        txt = CodegenUtil.symbolName(txt, a_modelNamePrefix, "eqFunction");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "linearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_at_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].analyticalJacobianColumn = "));
        txt = Tpl.writeText(txt, l_generatedJac2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "linearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_at_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].initialAnalyticalJacobian = "));
        txt = Tpl.writeText(txt, l_initialJac2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "linearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_at_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].jacobianIndex = "));
        txt = Tpl.writeText(txt, l_jacIndex2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "linearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_at_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].setA = NULL;  //setLinearMatrixA"));
        txt = Tpl.writeStr(txt, intString(a_at_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "linearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_at_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].setb = NULL;  //setLinearVectorb"));
        txt = Tpl.writeStr(txt, intString(a_at_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "linearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_at_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].initializeStaticLSData = initializeStaticLSData"));
        txt = Tpl.writeStr(txt, intString(a_at_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "linearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_at_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].checkConstraints = checkConstraints"));
        txt = Tpl.writeStr(txt, intString(a_at_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then (txt, a_globalConstraintsFunctions);

    case ( txt,
           _,
           _,
           _,
           a_at_index,
           _,
           a_ls_index,
           _,
           _,
           a_globalConstraintsFunctions,
           _,
           _,
           _,
           _ )
      equation
        txt_18 = Tpl.pushBlock(Tpl.emptyTxt, Tpl.BT_INDENT(1));
        txt_18 = Tpl.writeTok(txt_18, Tpl.ST_STRING("No jacobian create for linear system "));
        txt_18 = Tpl.writeStr(txt_18, intString(a_ls_index));
        txt_18 = Tpl.writeTok(txt_18, Tpl.ST_STRING(" or "));
        txt_18 = Tpl.writeStr(txt_18, intString(a_at_index));
        txt_18 = Tpl.writeTok(txt_18, Tpl.ST_STRING("."));
        txt_18 = Tpl.popBlock(txt_18);
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 2108, 16), Tpl.textString(txt_18));
      then (txt, a_globalConstraintsFunctions);
  end match;
end fun_247;

protected function fun_248
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eqn;
  input Tpl.Text in_a_globalConstraintsFunctions;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_globalConstraintsFunctions;
algorithm
  (out_txt, out_a_globalConstraintsFunctions) :=
  match(in_txt, in_a_eqn, in_a_globalConstraintsFunctions, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      Tpl.Text a_globalConstraintsFunctions;
      String a_modelNamePrefix;
      Option<SimCode.JacobianMatrix> i_at_jacobianMatrix;
      Integer i_at_index;
      Integer i_at_indexLinearSystem;
      SimCode.SimEqSystem i_eq;
      list<tuple<Integer, Integer, SimCode.SimEqSystem>> i_at_simJac;
      list<SimCodeVar.SimVar> i_at_vars;
      Integer i_ls_index;
      Integer i_ls_indexLinearSystem;
      list<tuple<Integer, Integer, SimCode.SimEqSystem>> i_ls_simJac;
      list<SimCodeVar.SimVar> i_ls_vars;
      Option<SimCode.JacobianMatrix> i_ls_jacobianMatrix;
      SimCode.SimEqSystem i_eq_cont;
      list<SimCode.SimEqSystem> ret_0;

    case ( txt,
           SimCode.SES_MIXED(cont = i_eq_cont),
           a_globalConstraintsFunctions,
           a_modelNamePrefix )
      equation
        ret_0 = List.fill(i_eq_cont, 1);
        (txt, _) = functionInitialLinearSystemsTemp(txt, ret_0, a_modelNamePrefix, Tpl.strTokText(Tpl.ST_STRING("")));
      then (txt, a_globalConstraintsFunctions);

    case ( txt,
           SimCode.SES_LINEAR(lSystem = SimCode.LINEARSYSTEM(jacobianMatrix = i_ls_jacobianMatrix, vars = i_ls_vars, simJac = i_ls_simJac, indexLinearSystem = i_ls_indexLinearSystem, index = i_ls_index), alternativeTearing = NONE()),
           a_globalConstraintsFunctions,
           a_modelNamePrefix )
      equation
        txt = fun_240(txt, i_ls_jacobianMatrix, a_modelNamePrefix, i_ls_index, i_ls_indexLinearSystem, i_ls_simJac, i_ls_vars);
      then (txt, a_globalConstraintsFunctions);

    case ( txt,
           (i_eq as SimCode.SES_LINEAR(lSystem = SimCode.LINEARSYSTEM(jacobianMatrix = i_ls_jacobianMatrix, vars = i_ls_vars, simJac = i_ls_simJac, indexLinearSystem = i_ls_indexLinearSystem, index = i_ls_index), alternativeTearing = SOME(SimCode.LINEARSYSTEM(vars = i_at_vars, simJac = i_at_simJac, indexLinearSystem = i_at_indexLinearSystem, index = i_at_index, jacobianMatrix = i_at_jacobianMatrix)))),
           a_globalConstraintsFunctions,
           a_modelNamePrefix )
      equation
        (txt, a_globalConstraintsFunctions) = fun_247(txt, i_ls_jacobianMatrix, i_at_jacobianMatrix, a_modelNamePrefix, i_at_index, i_at_indexLinearSystem, i_ls_index, i_ls_indexLinearSystem, i_eq, a_globalConstraintsFunctions, i_at_simJac, i_at_vars, i_ls_simJac, i_ls_vars);
      then (txt, a_globalConstraintsFunctions);

    case ( txt,
           _,
           a_globalConstraintsFunctions,
           _ )
      then (txt, a_globalConstraintsFunctions);
  end match;
end fun_248;

protected function lm_249
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input Tpl.Text in_a_globalConstraintsFunctions;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_globalConstraintsFunctions;
algorithm
  (out_txt, out_a_globalConstraintsFunctions) :=
  match(in_txt, in_items, in_a_globalConstraintsFunctions, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      Tpl.Text a_globalConstraintsFunctions;
      String a_modelNamePrefix;
      SimCode.SimEqSystem i_eqn;

    case ( txt,
           {},
           a_globalConstraintsFunctions,
           _ )
      then (txt, a_globalConstraintsFunctions);

    case ( txt,
           i_eqn :: rest,
           a_globalConstraintsFunctions,
           a_modelNamePrefix )
      equation
        (txt, a_globalConstraintsFunctions) = fun_248(txt, i_eqn, a_globalConstraintsFunctions, a_modelNamePrefix);
        txt = Tpl.nextIter(txt);
        (txt, a_globalConstraintsFunctions) = lm_249(txt, rest, a_globalConstraintsFunctions, a_modelNamePrefix);
      then (txt, a_globalConstraintsFunctions);
  end match;
end lm_249;

public function functionInitialLinearSystemsTemp
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_linearSystems;
  input String a_modelNamePrefix;
  input Tpl.Text a_globalConstraintsFunctions;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_globalConstraintsFunctions;
algorithm
  out_txt := Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING_LIST({
                                                                    "\n",
                                                                    "\n"
                                                                }, true)), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (out_txt, out_a_globalConstraintsFunctions) := lm_249(out_txt, a_linearSystems, a_globalConstraintsFunctions, a_modelNamePrefix);
  out_txt := Tpl.popIter(out_txt);
end functionInitialLinearSystemsTemp;

public function functionSetupLinearSystems
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_linearSystems;
  input String a_modelNamePrefix;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_linearbody;
algorithm
  l_linearbody := functionSetupLinearSystemsTemp(Tpl.emptyTxt, a_linearSystems, a_modelNamePrefix);
  out_txt := Tpl.writeTok(txt, Tpl.ST_LINE("/* linear systems */\n"));
  out_txt := Tpl.writeText(out_txt, l_linearbody);
end functionSetupLinearSystems;

protected function lm_252
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Integer x_i0;
      SimCodeVar.SimVar i_var;
      DAE.ComponentRef ret_0;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        ret_0 = SimCodeFunctionUtil.varName(i_var);
        txt = CodegenCFunctions.cref(txt, ret_0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = xloc["));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("];"));
        txt = Tpl.nextIter(txt);
        txt = lm_252(txt, rest);
      then txt;
  end match;
end lm_252;

protected function lm_253
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input String in_a_modelNamePrefix;
  input Tpl.Text in_a_tmp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_tmp;
algorithm
  (out_txt, out_a_tmp) :=
  match(in_txt, in_items, in_a_modelNamePrefix, in_a_tmp)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      String a_modelNamePrefix;
      Tpl.Text a_tmp;
      SimCode.SimEqSystem i_eq2;

    case ( txt,
           {},
           _,
           a_tmp )
      then (txt, a_tmp);

    case ( txt,
           i_eq2 :: rest,
           a_modelNamePrefix,
           a_tmp )
      equation
        (txt, a_tmp) = functionExtraResidualsPreBodyJacobian(txt, i_eq2, a_tmp, a_modelNamePrefix);
        txt = Tpl.nextIter(txt);
        (txt, a_tmp) = lm_253(txt, rest, a_modelNamePrefix, a_tmp);
      then (txt, a_tmp);
  end match;
end lm_253;

protected function lm_254
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input String in_a_modelNamePrefix;
  input Tpl.Text in_a_tmp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_tmp;
algorithm
  (out_txt, out_a_tmp) :=
  match(in_txt, in_items, in_a_modelNamePrefix, in_a_tmp)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      String a_modelNamePrefix;
      Tpl.Text a_tmp;
      SimCode.SimEqSystem i_eq2;

    case ( txt,
           {},
           _,
           a_tmp )
      then (txt, a_tmp);

    case ( txt,
           i_eq2 :: rest,
           a_modelNamePrefix,
           a_tmp )
      equation
        (txt, a_tmp) = functionExtraResidualsPreBody(txt, i_eq2, a_tmp, a_modelNamePrefix);
        txt = Tpl.nextIter(txt);
        (txt, a_tmp) = lm_254(txt, rest, a_modelNamePrefix, a_tmp);
      then (txt, a_tmp);
  end match;
end lm_254;

protected function fun_255
  input Tpl.Text in_txt;
  input Boolean in_a_ls_partOfJac;
  input String in_a_modelNamePrefix;
  input Tpl.Text in_a_tmp;
  input list<SimCode.SimEqSystem> in_a_ls_residual;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_tmp;
algorithm
  (out_txt, out_a_tmp) :=
  match(in_txt, in_a_ls_partOfJac, in_a_modelNamePrefix, in_a_tmp, in_a_ls_residual)
    local
      Tpl.Text txt;
      String a_modelNamePrefix;
      Tpl.Text a_tmp;
      list<SimCode.SimEqSystem> a_ls_residual;

    case ( txt,
           true,
           a_modelNamePrefix,
           a_tmp,
           a_ls_residual )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_tmp) = lm_253(txt, a_ls_residual, a_modelNamePrefix, a_tmp);
        txt = Tpl.popIter(txt);
      then (txt, a_tmp);

    case ( txt,
           false,
           a_modelNamePrefix,
           a_tmp,
           a_ls_residual )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_tmp) = lm_254(txt, a_ls_residual, a_modelNamePrefix, a_tmp);
        txt = Tpl.popIter(txt);
      then (txt, a_tmp);

    case ( txt,
           _,
           _,
           a_tmp,
           _ )
      then (txt, a_tmp);
  end match;
end fun_255;

protected function fun_256
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_eq2_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_eq2_index)
    local
      Tpl.Text txt;
      Integer a_eq2_index;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_eq2_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("SIM_PROF_TICK_EQ("));
        txt = Tpl.writeStr(txt, intString(a_eq2_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;
  end match;
end fun_256;

protected function fun_257
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_eq2_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_eq2_index)
    local
      Tpl.Text txt;
      Integer a_eq2_index;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_eq2_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("SIM_PROF_ACC_EQ("));
        txt = Tpl.writeStr(txt, intString(a_eq2_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;
  end match;
end fun_257;

protected function lm_258
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDeclsRes;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDeclsRes;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDeclsRes) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDeclsRes)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDeclsRes;
      Integer x_i0;
      Integer i_eq2_index;
      DAE.Exp i_eq2_exp;
      Boolean ret_3;
      Boolean ret_2;
      Tpl.Text l_expPart;
      Tpl.Text l_preExp;

    case ( txt,
           {},
           a_auxFunction,
           a_varDeclsRes )
      then (txt, a_auxFunction, a_varDeclsRes);

    case ( txt,
           SimCode.SES_RESIDUAL(exp = i_eq2_exp, index = i_eq2_index) :: rest,
           a_auxFunction,
           a_varDeclsRes )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        l_preExp = Tpl.emptyTxt;
        (l_expPart, l_preExp, a_varDeclsRes, a_auxFunction) = CodegenCFunctions.daeExp(Tpl.emptyTxt, i_eq2_exp, SimCodeFunction.contextSimulationDiscrete, l_preExp, a_varDeclsRes, a_auxFunction);
        ret_2 = Config.profileAll();
        txt = fun_256(txt, ret_2, i_eq2_index);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("res["));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = "));
        txt = Tpl.writeText(txt, l_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        ret_3 = Config.profileAll();
        txt = fun_257(txt, ret_3, i_eq2_index);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDeclsRes) = lm_258(txt, rest, a_auxFunction, a_varDeclsRes);
      then (txt, a_auxFunction, a_varDeclsRes);

    case ( txt,
           _ :: rest,
           a_auxFunction,
           a_varDeclsRes )
      equation
        (txt, a_auxFunction, a_varDeclsRes) = lm_258(txt, rest, a_auxFunction, a_varDeclsRes);
      then (txt, a_auxFunction, a_varDeclsRes);
  end match;
end lm_258;

protected function lm_259
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCodeVar.SimVar i_var;
      DAE.ComponentRef ret_0;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/* static ls data for "));
        ret_0 = SimCodeFunctionUtil.varName(i_var);
        txt = CodegenUtil.crefStrNoUnderscore(txt, ret_0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " */\n",
                                    "linearSystemData->nominal[i] = "
                                }, false));
        txt = CodegenCFunctions.varAttributes(txt, i_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ".nominal;\n",
                                    "linearSystemData->min[i]     = "
                                }, false));
        txt = CodegenCFunctions.varAttributes(txt, i_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ".min;\n",
                                    "linearSystemData->max[i++]   = "
                                }, false));
        txt = CodegenCFunctions.varAttributes(txt, i_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".max;"));
        txt = Tpl.nextIter(txt);
        txt = lm_259(txt, rest);
      then txt;
  end match;
end lm_259;

protected function fun_260
  input Tpl.Text in_txt;
  input Boolean in_a_ls_partOfJac;
  input Integer in_a_ls_indexLinearSystem;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ls_partOfJac, in_a_ls_indexLinearSystem)
    local
      Tpl.Text txt;
      Integer a_ls_indexLinearSystem;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_ls_indexLinearSystem )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("ANALYTIC_JACOBIAN* parentJacobian = data->simulationInfo->linearSystemData["));
        txt = Tpl.writeStr(txt, intString(a_ls_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].parDynamicData[omc_get_thread_num()].parentJacobian;"));
      then txt;
  end match;
end fun_260;

protected function fun_261
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_ls_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_ls_index)
    local
      Tpl.Text txt;
      Integer a_ls_index;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_ls_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("SIM_PROF_TICK_EQ("));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;
  end match;
end fun_261;

protected function fun_262
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_ls_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_ls_index)
    local
      Tpl.Text txt;
      Integer a_ls_index;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_ls_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("SIM_PROF_ADD_NCALL_EQ(modelInfoGetEquation(&data->modelData->modelDataXml,"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(").profileBlockIndex,1);"));
      then txt;
  end match;
end fun_262;

protected function fun_263
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_ls_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_ls_index)
    local
      Tpl.Text txt;
      Integer a_ls_index;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_ls_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("SIM_PROF_ACC_EQ("));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;
  end match;
end fun_263;

protected function lm_264
  input Tpl.Text in_txt;
  input list<tuple<Integer, Integer, SimCode.SimEqSystem>> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls)
    local
      Tpl.Text txt;
      list<tuple<Integer, Integer, SimCode.SimEqSystem>> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Integer x_i0;
      Integer i_col;
      Integer i_row;
      DAE.Exp i_eq_exp;
      Tpl.Text l_expPart;
      Tpl.Text l_preExp;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls )
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           (i_row, i_col, SimCode.SES_RESIDUAL(exp = i_eq_exp)) :: rest,
           a_auxFunction,
           a_varDecls )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        l_preExp = Tpl.emptyTxt;
        (l_expPart, l_preExp, a_varDecls, a_auxFunction) = CodegenCFunctions.daeExp(Tpl.emptyTxt, i_eq_exp, SimCodeFunction.contextSimulationDiscrete, l_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("linearSystemData->setAElement("));
        txt = Tpl.writeStr(txt, intString(i_row));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeStr(txt, intString(i_col));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, l_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", linearSystemData, threadData);"));
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls) = lm_264(txt, rest, a_auxFunction, a_varDecls);
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           _ :: rest,
           a_auxFunction,
           a_varDecls )
      equation
        (txt, a_auxFunction, a_varDecls) = lm_264(txt, rest, a_auxFunction, a_varDecls);
      then (txt, a_auxFunction, a_varDecls);
  end match;
end lm_264;

protected function lm_265
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls2;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls2;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls2) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls2)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls2;
      Integer x_i0;
      DAE.Exp i_exp;
      Tpl.Text l_expPart;
      Tpl.Text l_preExp;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls2 )
      then (txt, a_auxFunction, a_varDecls2);

    case ( txt,
           i_exp :: rest,
           a_auxFunction,
           a_varDecls2 )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        l_preExp = Tpl.emptyTxt;
        (l_expPart, l_preExp, a_varDecls2, a_auxFunction) = CodegenCFunctions.daeExp(Tpl.emptyTxt, i_exp, SimCodeFunction.contextSimulationDiscrete, l_preExp, a_varDecls2, a_auxFunction);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("linearSystemData->setBElement("));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, l_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", linearSystemData, threadData);"));
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls2) = lm_265(txt, rest, a_auxFunction, a_varDecls2);
      then (txt, a_auxFunction, a_varDecls2);
  end match;
end lm_265;

protected function lm_266
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCodeVar.SimVar i_var;
      DAE.ComponentRef ret_0;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/* static ls data for "));
        ret_0 = SimCodeFunctionUtil.varName(i_var);
        txt = CodegenUtil.crefStrNoUnderscore(txt, ret_0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " */\n",
                                    "linearSystemData->nominal[i] = "
                                }, false));
        txt = CodegenCFunctions.varAttributes(txt, i_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ".nominal;\n",
                                    "linearSystemData->min[i]     = "
                                }, false));
        txt = CodegenCFunctions.varAttributes(txt, i_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ".min;\n",
                                    "linearSystemData->max[i++]   = "
                                }, false));
        txt = CodegenCFunctions.varAttributes(txt, i_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".max;"));
        txt = Tpl.nextIter(txt);
        txt = lm_266(txt, rest);
      then txt;
  end match;
end lm_266;

protected function fun_267
  input Tpl.Text in_txt;
  input Boolean in_a_ls_partOfJac;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ls_partOfJac)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("ANALYTIC_JACOBIAN* parentJacobian = linearSystemData->parDynamicData[omc_get_thread_num()].parentJacobian;"));
      then txt;
  end match;
end fun_267;

protected function fun_268
  input Tpl.Text in_txt;
  input Boolean in_a_ls_partOfJac;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ls_partOfJac)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("ANALYTIC_JACOBIAN* parentJacobian = linearSystemData->parDynamicData[omc_get_thread_num()].parentJacobian;"));
      then txt;
  end match;
end fun_268;

protected function fun_269
  input Tpl.Text in_txt;
  input Option<SimCode.JacobianMatrix> in_a_ls_jacobianMatrix;
  input list<DAE.Exp> in_a_ls_beqs;
  input list<tuple<Integer, Integer, SimCode.SimEqSystem>> in_a_ls_simJac;
  input Integer in_a_ls_indexLinearSystem;
  input Integer in_a_ls_index;
  input String in_a_modelNamePrefix;
  input list<SimCode.SimEqSystem> in_a_ls_residual;
  input Boolean in_a_ls_partOfJac;
  input list<SimCodeVar.SimVar> in_a_ls_vars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ls_jacobianMatrix, in_a_ls_beqs, in_a_ls_simJac, in_a_ls_indexLinearSystem, in_a_ls_index, in_a_modelNamePrefix, in_a_ls_residual, in_a_ls_partOfJac, in_a_ls_vars)
    local
      Tpl.Text txt;
      list<DAE.Exp> a_ls_beqs;
      list<tuple<Integer, Integer, SimCode.SimEqSystem>> a_ls_simJac;
      Integer a_ls_indexLinearSystem;
      Integer a_ls_index;
      String a_modelNamePrefix;
      list<SimCode.SimEqSystem> a_ls_residual;
      Boolean a_ls_partOfJac;
      list<SimCodeVar.SimVar> a_ls_vars;
      Tpl.Text l_vectorb;
      Tpl.Text l_varDecls2;
      Tpl.Text l_MatrixA;
      Tpl.Text l_varDecls;
      Boolean ret_9;
      Boolean ret_8;
      Boolean ret_7;
      Tpl.Text l_body__initializeStaticLSData;
      Tpl.Text l_body;
      Tpl.Text l_prebody;
      Tpl.Text l_xlocs;
      Tpl.Text l_tmp;
      Tpl.Text l_auxFunction;
      Tpl.Text l_varDeclsRes;

    case ( txt,
           SOME(_),
           _,
           _,
           a_ls_indexLinearSystem,
           a_ls_index,
           a_modelNamePrefix,
           a_ls_residual,
           a_ls_partOfJac,
           a_ls_vars )
      equation
        l_varDeclsRes = Tpl.emptyTxt;
        l_auxFunction = Tpl.emptyTxt;
        l_tmp = Tpl.emptyTxt;
        l_xlocs = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_xlocs = lm_252(l_xlocs, a_ls_vars);
        l_xlocs = Tpl.popIter(l_xlocs);
        (l_prebody, l_tmp) = fun_255(Tpl.emptyTxt, a_ls_partOfJac, a_modelNamePrefix, l_tmp, a_ls_residual);
        l_body = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_body, l_auxFunction, l_varDeclsRes) = lm_258(l_body, a_ls_residual, l_auxFunction, l_varDeclsRes);
        l_body = Tpl.popIter(l_body);
        l_body__initializeStaticLSData = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_body__initializeStaticLSData = lm_259(l_body__initializeStaticLSData, a_ls_vars);
        l_body__initializeStaticLSData = Tpl.popIter(l_body__initializeStaticLSData);
        txt = Tpl.writeText(txt, l_auxFunction);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_tmp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "void residualFunc"
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(void** dataIn, const double* xloc, double* res, const int* iflag)\n",
                                    "{\n",
                                    "  TRACE_PUSH\n",
                                    "  DATA *data = (DATA*) ((void**)dataIn[0]);\n",
                                    "  threadData_t *threadData = (threadData_t*) ((void**)dataIn[1]);\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("const int equationIndexes[2] = {1,"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("};\n"));
        txt = fun_260(txt, a_ls_partOfJac, a_ls_indexLinearSystem);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("ANALYTIC_JACOBIAN* jacobian = NULL;\n"));
        txt = Tpl.writeText(txt, l_varDeclsRes);
        txt = Tpl.softNewLine(txt);
        ret_7 = Config.profileAll();
        txt = fun_261(txt, ret_7, a_ls_index);
        txt = Tpl.softNewLine(txt);
        ret_8 = Config.profileSome();
        txt = fun_262(txt, ret_8, a_ls_index);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_xlocs);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_prebody);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_body);
        txt = Tpl.softNewLine(txt);
        ret_9 = Config.profileAll();
        txt = fun_263(txt, ret_9, a_ls_index);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("TRACE_POP\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "OMC_DISABLE_OPT\n",
                                    "void initializeStaticLSData"
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(void *inData, threadData_t *threadData, void *systemData)\n",
                                    "{\n",
                                    "  DATA* data = (DATA*) inData;\n",
                                    "  LINEAR_SYSTEM_DATA* linearSystemData = (LINEAR_SYSTEM_DATA*) systemData;\n",
                                    "  int i=0;\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_body__initializeStaticLSData);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;

    case ( txt,
           _,
           a_ls_beqs,
           a_ls_simJac,
           _,
           a_ls_index,
           _,
           _,
           a_ls_partOfJac,
           a_ls_vars )
      equation
        l_varDecls = Tpl.emptyTxt;
        l_auxFunction = Tpl.emptyTxt;
        l_MatrixA = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_MatrixA, l_auxFunction, l_varDecls) = lm_264(l_MatrixA, a_ls_simJac, l_auxFunction, l_varDecls);
        l_MatrixA = Tpl.popIter(l_MatrixA);
        l_varDecls2 = Tpl.emptyTxt;
        l_vectorb = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_vectorb, l_auxFunction, l_varDecls2) = lm_265(l_vectorb, a_ls_beqs, l_auxFunction, l_varDecls2);
        l_vectorb = Tpl.popIter(l_vectorb);
        l_body__initializeStaticLSData = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_body__initializeStaticLSData = lm_266(l_body__initializeStaticLSData, a_ls_vars);
        l_body__initializeStaticLSData = Tpl.popIter(l_body__initializeStaticLSData);
        txt = Tpl.writeText(txt, l_auxFunction);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "OMC_DISABLE_OPT\n",
                                    "void setLinearMatrixA"
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(void *inData, threadData_t *threadData, void *systemData)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("const int equationIndexes[2] = {1,"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "};\n",
                                    "DATA* data = (DATA*) inData;\n",
                                    "LINEAR_SYSTEM_DATA* linearSystemData = (LINEAR_SYSTEM_DATA*) systemData;\n"
                                }, true));
        txt = fun_267(txt, a_ls_partOfJac);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_varDecls);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_MatrixA);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "OMC_DISABLE_OPT\n",
                                    "void setLinearVectorb"
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(void *inData, threadData_t *threadData, void *systemData)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("const int equationIndexes[2] = {1,"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "};\n",
                                    "DATA* data = (DATA*) inData;\n",
                                    "LINEAR_SYSTEM_DATA* linearSystemData = (LINEAR_SYSTEM_DATA*) systemData;\n"
                                }, true));
        txt = fun_268(txt, a_ls_partOfJac);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_varDecls2);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_vectorb);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "OMC_DISABLE_OPT\n",
                                    "void initializeStaticLSData"
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(void *inData, threadData_t *threadData, void *systemData)\n",
                                    "{\n",
                                    "  DATA* data = (DATA*) inData;\n",
                                    "  LINEAR_SYSTEM_DATA* linearSystemData = (LINEAR_SYSTEM_DATA*) systemData;\n",
                                    "  int i=0;\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_body__initializeStaticLSData);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;
  end match;
end fun_269;

protected function lm_270
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Integer x_i0;
      SimCodeVar.SimVar i_var;
      DAE.ComponentRef ret_0;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        ret_0 = SimCodeFunctionUtil.varName(i_var);
        txt = CodegenCFunctions.cref(txt, ret_0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = xloc["));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("];"));
        txt = Tpl.nextIter(txt);
        txt = lm_270(txt, rest);
      then txt;
  end match;
end lm_270;

protected function lm_271
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input String in_a_modelNamePrefix;
  input Tpl.Text in_a_tmp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_tmp;
algorithm
  (out_txt, out_a_tmp) :=
  match(in_txt, in_items, in_a_modelNamePrefix, in_a_tmp)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      String a_modelNamePrefix;
      Tpl.Text a_tmp;
      SimCode.SimEqSystem i_eq2;

    case ( txt,
           {},
           _,
           a_tmp )
      then (txt, a_tmp);

    case ( txt,
           i_eq2 :: rest,
           a_modelNamePrefix,
           a_tmp )
      equation
        (txt, a_tmp) = functionExtraResidualsPreBody(txt, i_eq2, a_tmp, a_modelNamePrefix);
        txt = Tpl.nextIter(txt);
        (txt, a_tmp) = lm_271(txt, rest, a_modelNamePrefix, a_tmp);
      then (txt, a_tmp);
  end match;
end lm_271;

protected function fun_272
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_eq2_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_eq2_index)
    local
      Tpl.Text txt;
      Integer a_eq2_index;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_eq2_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("SIM_PROF_TICK_EQ("));
        txt = Tpl.writeStr(txt, intString(a_eq2_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;
  end match;
end fun_272;

protected function fun_273
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_eq2_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_eq2_index)
    local
      Tpl.Text txt;
      Integer a_eq2_index;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_eq2_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("SIM_PROF_ACC_EQ("));
        txt = Tpl.writeStr(txt, intString(a_eq2_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;
  end match;
end fun_273;

protected function lm_274
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDeclsRes;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDeclsRes;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDeclsRes) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDeclsRes)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDeclsRes;
      Integer x_i0;
      Integer i_eq2_index;
      DAE.Exp i_eq2_exp;
      Boolean ret_3;
      Boolean ret_2;
      Tpl.Text l_expPart;
      Tpl.Text l_preExp;

    case ( txt,
           {},
           a_auxFunction,
           a_varDeclsRes )
      then (txt, a_auxFunction, a_varDeclsRes);

    case ( txt,
           SimCode.SES_RESIDUAL(exp = i_eq2_exp, index = i_eq2_index) :: rest,
           a_auxFunction,
           a_varDeclsRes )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        l_preExp = Tpl.emptyTxt;
        (l_expPart, l_preExp, a_varDeclsRes, a_auxFunction) = CodegenCFunctions.daeExp(Tpl.emptyTxt, i_eq2_exp, SimCodeFunction.contextSimulationDiscrete, l_preExp, a_varDeclsRes, a_auxFunction);
        ret_2 = Config.profileAll();
        txt = fun_272(txt, ret_2, i_eq2_index);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("res["));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = "));
        txt = Tpl.writeText(txt, l_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        ret_3 = Config.profileAll();
        txt = fun_273(txt, ret_3, i_eq2_index);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDeclsRes) = lm_274(txt, rest, a_auxFunction, a_varDeclsRes);
      then (txt, a_auxFunction, a_varDeclsRes);

    case ( txt,
           _ :: rest,
           a_auxFunction,
           a_varDeclsRes )
      equation
        (txt, a_auxFunction, a_varDeclsRes) = lm_274(txt, rest, a_auxFunction, a_varDeclsRes);
      then (txt, a_auxFunction, a_varDeclsRes);
  end match;
end lm_274;

protected function lm_275
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCodeVar.SimVar i_var;
      DAE.ComponentRef ret_0;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/* static ls data for "));
        ret_0 = SimCodeFunctionUtil.varName(i_var);
        txt = CodegenUtil.crefStrNoUnderscore(txt, ret_0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " */\n",
                                    "linearSystemData->nominal[i] = "
                                }, false));
        txt = CodegenCFunctions.varAttributes(txt, i_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ".nominal;\n",
                                    "linearSystemData->min[i]     = "
                                }, false));
        txt = CodegenCFunctions.varAttributes(txt, i_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ".min;\n",
                                    "linearSystemData->max[i++]   = "
                                }, false));
        txt = CodegenCFunctions.varAttributes(txt, i_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".max;"));
        txt = Tpl.nextIter(txt);
        txt = lm_275(txt, rest);
      then txt;
  end match;
end lm_275;

protected function lm_276
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Integer x_i0;
      SimCodeVar.SimVar i_var;
      DAE.ComponentRef ret_0;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        ret_0 = SimCodeFunctionUtil.varName(i_var);
        txt = CodegenCFunctions.cref(txt, ret_0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = xloc["));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("];"));
        txt = Tpl.nextIter(txt);
        txt = lm_276(txt, rest);
      then txt;
  end match;
end lm_276;

protected function lm_277
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input String in_a_modelNamePrefix;
  input Tpl.Text in_a_tmp2;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_tmp2;
algorithm
  (out_txt, out_a_tmp2) :=
  match(in_txt, in_items, in_a_modelNamePrefix, in_a_tmp2)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      String a_modelNamePrefix;
      Tpl.Text a_tmp2;
      SimCode.SimEqSystem i_eq2;

    case ( txt,
           {},
           _,
           a_tmp2 )
      then (txt, a_tmp2);

    case ( txt,
           i_eq2 :: rest,
           a_modelNamePrefix,
           a_tmp2 )
      equation
        (txt, a_tmp2) = functionExtraResidualsPreBody(txt, i_eq2, a_tmp2, a_modelNamePrefix);
        txt = Tpl.nextIter(txt);
        (txt, a_tmp2) = lm_277(txt, rest, a_modelNamePrefix, a_tmp2);
      then (txt, a_tmp2);
  end match;
end lm_277;

protected function fun_278
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_eq2_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_eq2_index)
    local
      Tpl.Text txt;
      Integer a_eq2_index;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_eq2_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("SIM_PROF_TICK_EQ("));
        txt = Tpl.writeStr(txt, intString(a_eq2_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;
  end match;
end fun_278;

protected function fun_279
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_eq2_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_eq2_index)
    local
      Tpl.Text txt;
      Integer a_eq2_index;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_eq2_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("SIM_PROF_ACC_EQ("));
        txt = Tpl.writeStr(txt, intString(a_eq2_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;
  end match;
end fun_279;

protected function lm_280
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input Tpl.Text in_a_auxFunction2;
  input Tpl.Text in_a_varDeclsRes2;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction2;
  output Tpl.Text out_a_varDeclsRes2;
algorithm
  (out_txt, out_a_auxFunction2, out_a_varDeclsRes2) :=
  match(in_txt, in_items, in_a_auxFunction2, in_a_varDeclsRes2)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      Tpl.Text a_auxFunction2;
      Tpl.Text a_varDeclsRes2;
      Integer x_i0;
      Integer i_eq2_index;
      DAE.Exp i_eq2_exp;
      Boolean ret_3;
      Boolean ret_2;
      Tpl.Text l_expPart2;
      Tpl.Text l_preExp2;

    case ( txt,
           {},
           a_auxFunction2,
           a_varDeclsRes2 )
      then (txt, a_auxFunction2, a_varDeclsRes2);

    case ( txt,
           SimCode.SES_RESIDUAL(exp = i_eq2_exp, index = i_eq2_index) :: rest,
           a_auxFunction2,
           a_varDeclsRes2 )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        l_preExp2 = Tpl.emptyTxt;
        (l_expPart2, l_preExp2, a_varDeclsRes2, a_auxFunction2) = CodegenCFunctions.daeExp(Tpl.emptyTxt, i_eq2_exp, SimCodeFunction.contextSimulationDiscrete, l_preExp2, a_varDeclsRes2, a_auxFunction2);
        ret_2 = Config.profileAll();
        txt = fun_278(txt, ret_2, i_eq2_index);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_preExp2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("res["));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = "));
        txt = Tpl.writeText(txt, l_expPart2);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        ret_3 = Config.profileAll();
        txt = fun_279(txt, ret_3, i_eq2_index);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction2, a_varDeclsRes2) = lm_280(txt, rest, a_auxFunction2, a_varDeclsRes2);
      then (txt, a_auxFunction2, a_varDeclsRes2);

    case ( txt,
           _ :: rest,
           a_auxFunction2,
           a_varDeclsRes2 )
      equation
        (txt, a_auxFunction2, a_varDeclsRes2) = lm_280(txt, rest, a_auxFunction2, a_varDeclsRes2);
      then (txt, a_auxFunction2, a_varDeclsRes2);
  end match;
end lm_280;

protected function lm_281
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCodeVar.SimVar i_var;
      DAE.ComponentRef ret_0;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/* static at data for "));
        ret_0 = SimCodeFunctionUtil.varName(i_var);
        txt = CodegenUtil.crefStrNoUnderscore(txt, ret_0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " */\n",
                                    "linearSystemData->nominal[i] = "
                                }, false));
        txt = CodegenCFunctions.varAttributes(txt, i_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ".nominal;\n",
                                    "linearSystemData->min[i]     = "
                                }, false));
        txt = CodegenCFunctions.varAttributes(txt, i_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ".min;\n",
                                    "linearSystemData->max[i++]   = "
                                }, false));
        txt = CodegenCFunctions.varAttributes(txt, i_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".max;"));
        txt = Tpl.nextIter(txt);
        txt = lm_281(txt, rest);
      then txt;
  end match;
end lm_281;

protected function fun_282
  input Tpl.Text in_txt;
  input Boolean in_a_ls_partOfJac;
  input Integer in_a_ls_indexLinearSystem;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ls_partOfJac, in_a_ls_indexLinearSystem)
    local
      Tpl.Text txt;
      Integer a_ls_indexLinearSystem;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_ls_indexLinearSystem )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("ANALYTIC_JACOBIAN* parentJacobian = data->simulationInfo->linearSystemData["));
        txt = Tpl.writeStr(txt, intString(a_ls_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].parDynamicData[omc_get_thread_num()].parentJacobian;"));
      then txt;
  end match;
end fun_282;

protected function fun_283
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_ls_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_ls_index)
    local
      Tpl.Text txt;
      Integer a_ls_index;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_ls_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("SIM_PROF_TICK_EQ("));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;
  end match;
end fun_283;

protected function fun_284
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_ls_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_ls_index)
    local
      Tpl.Text txt;
      Integer a_ls_index;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_ls_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("SIM_PROF_ADD_NCALL_EQ(modelInfoGetEquation(&data->modelData->modelDataXml,"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(").profileBlockIndex,1);"));
      then txt;
  end match;
end fun_284;

protected function fun_285
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_ls_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_ls_index)
    local
      Tpl.Text txt;
      Integer a_ls_index;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_ls_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("SIM_PROF_ACC_EQ("));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;
  end match;
end fun_285;

protected function fun_286
  input Tpl.Text in_txt;
  input Boolean in_a_ls_partOfJac;
  input Integer in_a_ls_indexLinearSystem;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ls_partOfJac, in_a_ls_indexLinearSystem)
    local
      Tpl.Text txt;
      Integer a_ls_indexLinearSystem;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_ls_indexLinearSystem )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("ANALYTIC_JACOBIAN* parentJacobian = data->simulationInfo->linearSystemData["));
        txt = Tpl.writeStr(txt, intString(a_ls_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].parDynamicData[omc_get_thread_num()].parentJacobian;"));
      then txt;
  end match;
end fun_286;

protected function fun_287
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_at_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_at_index)
    local
      Tpl.Text txt;
      Integer a_at_index;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_at_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("SIM_PROF_TICK_EQ("));
        txt = Tpl.writeStr(txt, intString(a_at_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;
  end match;
end fun_287;

protected function fun_288
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_at_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_at_index)
    local
      Tpl.Text txt;
      Integer a_at_index;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_at_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("SIM_PROF_ADD_NCALL_EQ(modelInfoGetEquation(&data->modelData->modelDataXml,"));
        txt = Tpl.writeStr(txt, intString(a_at_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(").profileBlockIndex,1);"));
      then txt;
  end match;
end fun_288;

protected function fun_289
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_at_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_at_index)
    local
      Tpl.Text txt;
      Integer a_at_index;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_at_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("SIM_PROF_ACC_EQ("));
        txt = Tpl.writeStr(txt, intString(a_at_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;
  end match;
end fun_289;

protected function lm_290
  input Tpl.Text in_txt;
  input list<tuple<Integer, Integer, SimCode.SimEqSystem>> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls)
    local
      Tpl.Text txt;
      list<tuple<Integer, Integer, SimCode.SimEqSystem>> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Integer x_i0;
      Integer i_col;
      Integer i_row;
      DAE.Exp i_eq_exp;
      Tpl.Text l_expPart;
      Tpl.Text l_preExp;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls )
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           (i_row, i_col, SimCode.SES_RESIDUAL(exp = i_eq_exp)) :: rest,
           a_auxFunction,
           a_varDecls )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        l_preExp = Tpl.emptyTxt;
        (l_expPart, l_preExp, a_varDecls, a_auxFunction) = CodegenCFunctions.daeExp(Tpl.emptyTxt, i_eq_exp, SimCodeFunction.contextSimulationDiscrete, l_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("linearSystemData->setAElement("));
        txt = Tpl.writeStr(txt, intString(i_row));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeStr(txt, intString(i_col));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, l_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", linearSystemData, threadData);"));
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls) = lm_290(txt, rest, a_auxFunction, a_varDecls);
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           _ :: rest,
           a_auxFunction,
           a_varDecls )
      equation
        (txt, a_auxFunction, a_varDecls) = lm_290(txt, rest, a_auxFunction, a_varDecls);
      then (txt, a_auxFunction, a_varDecls);
  end match;
end lm_290;

protected function lm_291
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls2;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls2;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls2) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls2)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls2;
      Integer x_i0;
      DAE.Exp i_exp;
      Tpl.Text l_expPart;
      Tpl.Text l_preExp;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls2 )
      then (txt, a_auxFunction, a_varDecls2);

    case ( txt,
           i_exp :: rest,
           a_auxFunction,
           a_varDecls2 )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        l_preExp = Tpl.emptyTxt;
        (l_expPart, l_preExp, a_varDecls2, a_auxFunction) = CodegenCFunctions.daeExp(Tpl.emptyTxt, i_exp, SimCodeFunction.contextSimulationDiscrete, l_preExp, a_varDecls2, a_auxFunction);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("linearSystemData->setBElement("));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, l_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", linearSystemData, threadData);"));
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls2) = lm_291(txt, rest, a_auxFunction, a_varDecls2);
      then (txt, a_auxFunction, a_varDecls2);
  end match;
end lm_291;

protected function lm_292
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCodeVar.SimVar i_var;
      DAE.ComponentRef ret_0;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/* static ls data for "));
        ret_0 = SimCodeFunctionUtil.varName(i_var);
        txt = CodegenUtil.crefStrNoUnderscore(txt, ret_0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " */\n",
                                    "linearSystemData->nominal[i] = "
                                }, false));
        txt = CodegenCFunctions.varAttributes(txt, i_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ".nominal;\n",
                                    "linearSystemData->min[i]     = "
                                }, false));
        txt = CodegenCFunctions.varAttributes(txt, i_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ".min;\n",
                                    "linearSystemData->max[i++]   = "
                                }, false));
        txt = CodegenCFunctions.varAttributes(txt, i_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".max;"));
        txt = Tpl.nextIter(txt);
        txt = lm_292(txt, rest);
      then txt;
  end match;
end lm_292;

protected function lm_293
  input Tpl.Text in_txt;
  input list<tuple<Integer, Integer, SimCode.SimEqSystem>> in_items;
  input Tpl.Text in_a_auxFunction2;
  input Tpl.Text in_a_varDecls3;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction2;
  output Tpl.Text out_a_varDecls3;
algorithm
  (out_txt, out_a_auxFunction2, out_a_varDecls3) :=
  match(in_txt, in_items, in_a_auxFunction2, in_a_varDecls3)
    local
      Tpl.Text txt;
      list<tuple<Integer, Integer, SimCode.SimEqSystem>> rest;
      Tpl.Text a_auxFunction2;
      Tpl.Text a_varDecls3;
      Integer x_i0;
      Integer i_col;
      Integer i_row;
      DAE.Exp i_eq_exp;
      Tpl.Text l_expPart3;
      Tpl.Text l_preExp3;

    case ( txt,
           {},
           a_auxFunction2,
           a_varDecls3 )
      then (txt, a_auxFunction2, a_varDecls3);

    case ( txt,
           (i_row, i_col, SimCode.SES_RESIDUAL(exp = i_eq_exp)) :: rest,
           a_auxFunction2,
           a_varDecls3 )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        l_preExp3 = Tpl.emptyTxt;
        (l_expPart3, l_preExp3, a_varDecls3, a_auxFunction2) = CodegenCFunctions.daeExp(Tpl.emptyTxt, i_eq_exp, SimCodeFunction.contextSimulationDiscrete, l_preExp3, a_varDecls3, a_auxFunction2);
        txt = Tpl.writeText(txt, l_preExp3);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("linearSystemData->setAElement("));
        txt = Tpl.writeStr(txt, intString(i_row));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeStr(txt, intString(i_col));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, l_expPart3);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", linearSystemData, threadData);"));
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction2, a_varDecls3) = lm_293(txt, rest, a_auxFunction2, a_varDecls3);
      then (txt, a_auxFunction2, a_varDecls3);

    case ( txt,
           _ :: rest,
           a_auxFunction2,
           a_varDecls3 )
      equation
        (txt, a_auxFunction2, a_varDecls3) = lm_293(txt, rest, a_auxFunction2, a_varDecls3);
      then (txt, a_auxFunction2, a_varDecls3);
  end match;
end lm_293;

protected function lm_294
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Tpl.Text in_a_auxFunction2;
  input Tpl.Text in_a_varDecls4;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction2;
  output Tpl.Text out_a_varDecls4;
algorithm
  (out_txt, out_a_auxFunction2, out_a_varDecls4) :=
  match(in_txt, in_items, in_a_auxFunction2, in_a_varDecls4)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Tpl.Text a_auxFunction2;
      Tpl.Text a_varDecls4;
      Integer x_i0;
      DAE.Exp i_exp;
      Tpl.Text l_expPart4;
      Tpl.Text l_preExp4;

    case ( txt,
           {},
           a_auxFunction2,
           a_varDecls4 )
      then (txt, a_auxFunction2, a_varDecls4);

    case ( txt,
           i_exp :: rest,
           a_auxFunction2,
           a_varDecls4 )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        l_preExp4 = Tpl.emptyTxt;
        (l_expPart4, l_preExp4, a_varDecls4, a_auxFunction2) = CodegenCFunctions.daeExp(Tpl.emptyTxt, i_exp, SimCodeFunction.contextSimulationDiscrete, l_preExp4, a_varDecls4, a_auxFunction2);
        txt = Tpl.writeText(txt, l_preExp4);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("linearSystemData->setBElement("));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, l_expPart4);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", linearSystemData, threadData);"));
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction2, a_varDecls4) = lm_294(txt, rest, a_auxFunction2, a_varDecls4);
      then (txt, a_auxFunction2, a_varDecls4);
  end match;
end lm_294;

protected function lm_295
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCodeVar.SimVar i_var;
      DAE.ComponentRef ret_0;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/* static at data for "));
        ret_0 = SimCodeFunctionUtil.varName(i_var);
        txt = CodegenUtil.crefStrNoUnderscore(txt, ret_0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " */\n",
                                    "linearSystemData->nominal[i] = "
                                }, false));
        txt = CodegenCFunctions.varAttributes(txt, i_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ".nominal;\n",
                                    "linearSystemData->min[i]     = "
                                }, false));
        txt = CodegenCFunctions.varAttributes(txt, i_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ".min;\n",
                                    "linearSystemData->max[i++]   = "
                                }, false));
        txt = CodegenCFunctions.varAttributes(txt, i_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".max;"));
        txt = Tpl.nextIter(txt);
        txt = lm_295(txt, rest);
      then txt;
  end match;
end lm_295;

protected function fun_296
  input Tpl.Text in_txt;
  input Boolean in_a_ls_partOfJac;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ls_partOfJac)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("ANALYTIC_JACOBIAN* parentJacobian = linearSystemData->parDynamicData[omc_get_thread_num()].parentJacobian;"));
      then txt;
  end match;
end fun_296;

protected function fun_297
  input Tpl.Text in_txt;
  input Boolean in_a_ls_partOfJac;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ls_partOfJac)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("ANALYTIC_JACOBIAN* parentJacobian = linearSystemData->parDynamicData[omc_get_thread_num()].parentJacobian;"));
      then txt;
  end match;
end fun_297;

protected function fun_298
  input Tpl.Text in_txt;
  input Boolean in_a_ls_partOfJac;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ls_partOfJac)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("ANALYTIC_JACOBIAN* parentJacobian = linearSystemData->parDynamicData[omc_get_thread_num()].parentJacobian;"));
      then txt;
  end match;
end fun_298;

protected function fun_299
  input Tpl.Text in_txt;
  input Boolean in_a_ls_partOfJac;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ls_partOfJac)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("ANALYTIC_JACOBIAN* parentJacobian = linearSystemData->parDynamicData[omc_get_thread_num()].parentJacobian;"));
      then txt;
  end match;
end fun_299;

protected function fun_300
  input Tpl.Text in_txt;
  input Option<SimCode.JacobianMatrix> in_a_ls_jacobianMatrix;
  input list<DAE.Exp> in_a_at_beqs;
  input list<tuple<Integer, Integer, SimCode.SimEqSystem>> in_a_at_simJac;
  input list<DAE.Exp> in_a_ls_beqs;
  input list<tuple<Integer, Integer, SimCode.SimEqSystem>> in_a_ls_simJac;
  input Integer in_a_at_index;
  input Integer in_a_ls_indexLinearSystem;
  input Boolean in_a_ls_partOfJac;
  input Integer in_a_ls_index;
  input list<SimCode.SimEqSystem> in_a_at_residual;
  input list<SimCodeVar.SimVar> in_a_at_vars;
  input String in_a_modelNamePrefix;
  input list<SimCode.SimEqSystem> in_a_ls_residual;
  input list<SimCodeVar.SimVar> in_a_ls_vars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ls_jacobianMatrix, in_a_at_beqs, in_a_at_simJac, in_a_ls_beqs, in_a_ls_simJac, in_a_at_index, in_a_ls_indexLinearSystem, in_a_ls_partOfJac, in_a_ls_index, in_a_at_residual, in_a_at_vars, in_a_modelNamePrefix, in_a_ls_residual, in_a_ls_vars)
    local
      Tpl.Text txt;
      list<DAE.Exp> a_at_beqs;
      list<tuple<Integer, Integer, SimCode.SimEqSystem>> a_at_simJac;
      list<DAE.Exp> a_ls_beqs;
      list<tuple<Integer, Integer, SimCode.SimEqSystem>> a_ls_simJac;
      Integer a_at_index;
      Integer a_ls_indexLinearSystem;
      Boolean a_ls_partOfJac;
      Integer a_ls_index;
      list<SimCode.SimEqSystem> a_at_residual;
      list<SimCodeVar.SimVar> a_at_vars;
      String a_modelNamePrefix;
      list<SimCode.SimEqSystem> a_ls_residual;
      list<SimCodeVar.SimVar> a_ls_vars;
      Tpl.Text l_vectorb2;
      Tpl.Text l_varDecls4;
      Tpl.Text l_MatrixA2;
      Tpl.Text l_varDecls3;
      Tpl.Text l_vectorb;
      Tpl.Text l_varDecls2;
      Tpl.Text l_MatrixA;
      Tpl.Text l_varDecls;
      Boolean ret_19;
      Boolean ret_18;
      Boolean ret_17;
      Boolean ret_16;
      Boolean ret_15;
      Boolean ret_14;
      Tpl.Text l_body__initializeStaticLSData2;
      Tpl.Text l_body2;
      Tpl.Text l_prebody2;
      Tpl.Text l_xlocs2;
      Tpl.Text l_tmp2;
      Tpl.Text l_auxFunction2;
      Tpl.Text l_varDeclsRes2;
      Tpl.Text l_body__initializeStaticLSData;
      Tpl.Text l_body;
      Tpl.Text l_prebody;
      Tpl.Text l_xlocs;
      Tpl.Text l_tmp;
      Tpl.Text l_auxFunction;
      Tpl.Text l_varDeclsRes;

    case ( txt,
           SOME(_),
           _,
           _,
           _,
           _,
           a_at_index,
           a_ls_indexLinearSystem,
           a_ls_partOfJac,
           a_ls_index,
           a_at_residual,
           a_at_vars,
           a_modelNamePrefix,
           a_ls_residual,
           a_ls_vars )
      equation
        l_varDeclsRes = Tpl.emptyTxt;
        l_auxFunction = Tpl.emptyTxt;
        l_tmp = Tpl.emptyTxt;
        l_xlocs = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_xlocs = lm_270(l_xlocs, a_ls_vars);
        l_xlocs = Tpl.popIter(l_xlocs);
        l_prebody = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_prebody, l_tmp) = lm_271(l_prebody, a_ls_residual, a_modelNamePrefix, l_tmp);
        l_prebody = Tpl.popIter(l_prebody);
        l_body = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_body, l_auxFunction, l_varDeclsRes) = lm_274(l_body, a_ls_residual, l_auxFunction, l_varDeclsRes);
        l_body = Tpl.popIter(l_body);
        l_body__initializeStaticLSData = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_body__initializeStaticLSData = lm_275(l_body__initializeStaticLSData, a_ls_vars);
        l_body__initializeStaticLSData = Tpl.popIter(l_body__initializeStaticLSData);
        l_varDeclsRes2 = Tpl.emptyTxt;
        l_auxFunction2 = Tpl.emptyTxt;
        l_tmp2 = Tpl.emptyTxt;
        l_xlocs2 = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_xlocs2 = lm_276(l_xlocs2, a_at_vars);
        l_xlocs2 = Tpl.popIter(l_xlocs2);
        l_prebody2 = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_prebody2, l_tmp2) = lm_277(l_prebody2, a_at_residual, a_modelNamePrefix, l_tmp2);
        l_prebody2 = Tpl.popIter(l_prebody2);
        l_body2 = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_body2, l_auxFunction2, l_varDeclsRes2) = lm_280(l_body2, a_at_residual, l_auxFunction2, l_varDeclsRes2);
        l_body2 = Tpl.popIter(l_body2);
        l_body__initializeStaticLSData2 = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_body__initializeStaticLSData2 = lm_281(l_body__initializeStaticLSData2, a_at_vars);
        l_body__initializeStaticLSData2 = Tpl.popIter(l_body__initializeStaticLSData2);
        txt = Tpl.writeText(txt, l_auxFunction);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_tmp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "void residualFunc"
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(void** dataIn, const double* xloc, double* res, const int* iflag)\n",
                                    "{\n",
                                    "  TRACE_PUSH\n",
                                    "  DATA *data = (DATA*) ((void**)dataIn[0]);\n",
                                    "  threadData_t *threadData = (threadData_t*) ((void**)dataIn[1]);\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("const int equationIndexes[2] = {1,"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("};\n"));
        txt = fun_282(txt, a_ls_partOfJac, a_ls_indexLinearSystem);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("ANALYTIC_JACOBIAN* jacobian = NULL;\n"));
        txt = Tpl.writeText(txt, l_varDeclsRes);
        txt = Tpl.softNewLine(txt);
        ret_14 = Config.profileAll();
        txt = fun_283(txt, ret_14, a_ls_index);
        txt = Tpl.softNewLine(txt);
        ret_15 = Config.profileSome();
        txt = fun_284(txt, ret_15, a_ls_index);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_xlocs);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_prebody);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_body);
        txt = Tpl.softNewLine(txt);
        ret_16 = Config.profileAll();
        txt = fun_285(txt, ret_16, a_ls_index);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("TRACE_POP\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "OMC_DISABLE_OPT\n",
                                    "void initializeStaticLSData"
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(void *inData, threadData_t *threadData, void *systemData)\n",
                                    "{\n",
                                    "  DATA* data = (DATA*) inData;\n",
                                    "  LINEAR_SYSTEM_DATA* linearSystemData = (LINEAR_SYSTEM_DATA*) systemData;\n",
                                    "  int i=0;\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_body__initializeStaticLSData);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n"
                                }, true));
        txt = Tpl.writeText(txt, l_auxFunction2);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_tmp2);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "void residualFunc"
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_at_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(void** dataIn, const double* xloc, double* res, const int* iflag)\n",
                                    "{\n",
                                    "  TRACE_PUSH\n",
                                    "  DATA *data = (DATA*) ((void**)dataIn[0]);\n",
                                    "  threadData_t *threadData = (threadData_t*) ((void**)dataIn[1]);\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("const int equationIndexes[2] = {1,"));
        txt = Tpl.writeStr(txt, intString(a_at_index));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("};\n"));
        txt = fun_286(txt, a_ls_partOfJac, a_ls_indexLinearSystem);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("ANALYTIC_JACOBIAN* jacobian = NULL;\n"));
        txt = Tpl.writeText(txt, l_varDeclsRes2);
        txt = Tpl.softNewLine(txt);
        ret_17 = Config.profileAll();
        txt = fun_287(txt, ret_17, a_at_index);
        txt = Tpl.softNewLine(txt);
        ret_18 = Config.profileSome();
        txt = fun_288(txt, ret_18, a_at_index);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_xlocs2);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_prebody2);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_body2);
        txt = Tpl.softNewLine(txt);
        ret_19 = Config.profileAll();
        txt = fun_289(txt, ret_19, a_at_index);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("TRACE_POP\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "OMC_DISABLE_OPT\n",
                                    "void initializeStaticLSData"
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_at_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(void *inData, threadData_t *threadData, void *systemData)\n",
                                    "{\n",
                                    "  DATA* data = (DATA*) inData;\n",
                                    "  LINEAR_SYSTEM_DATA* linearSystemData = (LINEAR_SYSTEM_DATA*) systemData;\n",
                                    "  int i=0;\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_body__initializeStaticLSData2);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;

    case ( txt,
           _,
           a_at_beqs,
           a_at_simJac,
           a_ls_beqs,
           a_ls_simJac,
           a_at_index,
           _,
           a_ls_partOfJac,
           a_ls_index,
           _,
           a_at_vars,
           _,
           _,
           a_ls_vars )
      equation
        l_varDecls = Tpl.emptyTxt;
        l_auxFunction = Tpl.emptyTxt;
        l_MatrixA = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_MatrixA, l_auxFunction, l_varDecls) = lm_290(l_MatrixA, a_ls_simJac, l_auxFunction, l_varDecls);
        l_MatrixA = Tpl.popIter(l_MatrixA);
        l_varDecls2 = Tpl.emptyTxt;
        l_vectorb = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_vectorb, l_auxFunction, l_varDecls2) = lm_291(l_vectorb, a_ls_beqs, l_auxFunction, l_varDecls2);
        l_vectorb = Tpl.popIter(l_vectorb);
        l_body__initializeStaticLSData = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_body__initializeStaticLSData = lm_292(l_body__initializeStaticLSData, a_ls_vars);
        l_body__initializeStaticLSData = Tpl.popIter(l_body__initializeStaticLSData);
        l_varDecls3 = Tpl.emptyTxt;
        l_auxFunction2 = Tpl.emptyTxt;
        l_MatrixA2 = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_MatrixA2, l_auxFunction2, l_varDecls3) = lm_293(l_MatrixA2, a_at_simJac, l_auxFunction2, l_varDecls3);
        l_MatrixA2 = Tpl.popIter(l_MatrixA2);
        l_varDecls4 = Tpl.emptyTxt;
        l_vectorb2 = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_vectorb2, l_auxFunction2, l_varDecls4) = lm_294(l_vectorb2, a_at_beqs, l_auxFunction2, l_varDecls4);
        l_vectorb2 = Tpl.popIter(l_vectorb2);
        l_body__initializeStaticLSData2 = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_body__initializeStaticLSData2 = lm_295(l_body__initializeStaticLSData2, a_at_vars);
        l_body__initializeStaticLSData2 = Tpl.popIter(l_body__initializeStaticLSData2);
        txt = Tpl.writeText(txt, l_auxFunction);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "OMC_DISABLE_OPT\n",
                                    "void setLinearMatrixA"
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(void *inData, void *systemData)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("const int equationIndexes[2] = {1,"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "};\n",
                                    "DATA* data = (DATA*) inData;\n",
                                    "LINEAR_SYSTEM_DATA* linearSystemData = (LINEAR_SYSTEM_DATA*) systemData;\n"
                                }, true));
        txt = fun_296(txt, a_ls_partOfJac);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_varDecls);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_MatrixA);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "OMC_DISABLE_OPT\n",
                                    "void setLinearVectorb"
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(void *inData, void *systemData)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("const int equationIndexes[2] = {1,"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "};\n",
                                    "DATA* data = (DATA*) inData;\n",
                                    "LINEAR_SYSTEM_DATA* linearSystemData = (LINEAR_SYSTEM_DATA*) systemData;\n"
                                }, true));
        txt = fun_297(txt, a_ls_partOfJac);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_varDecls2);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_vectorb);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "OMC_DISABLE_OPT\n",
                                    "void initializeStaticLSData"
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(void *inData, threadData_t *threadData, void *systemData)\n",
                                    "{\n",
                                    "  DATA* data = (DATA*) inData;\n",
                                    "  LINEAR_SYSTEM_DATA* linearSystemData = (LINEAR_SYSTEM_DATA*) systemData;\n",
                                    "  int i=0;\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_body__initializeStaticLSData);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n"
                                }, true));
        txt = Tpl.writeText(txt, l_auxFunction2);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "OMC_DISABLE_OPT\n",
                                    "void setLinearMatrixA"
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_at_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(void *inData, void *systemData)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("const int equationIndexes[2] = {1,"));
        txt = Tpl.writeStr(txt, intString(a_at_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "};\n",
                                    "DATA* data = (DATA*) inData;\n",
                                    "LINEAR_SYSTEM_DATA* linearSystemData = (LINEAR_SYSTEM_DATA*) systemData;\n"
                                }, true));
        txt = fun_298(txt, a_ls_partOfJac);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_varDecls3);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_MatrixA2);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "OMC_DISABLE_OPT\n",
                                    "void setLinearVectorb"
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_at_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(void *inData, void *systemData)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("const int equationIndexes[2] = {1,"));
        txt = Tpl.writeStr(txt, intString(a_at_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "};\n",
                                    "DATA* data = (DATA*) inData;\n",
                                    "LINEAR_SYSTEM_DATA* linearSystemData = (LINEAR_SYSTEM_DATA*) systemData;\n"
                                }, true));
        txt = fun_299(txt, a_ls_partOfJac);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_varDecls4);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_vectorb2);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "OMC_DISABLE_OPT\n",
                                    "void initializeStaticLSData"
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_at_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(void *inData, threadData_t *threadData, void *systemData)\n",
                                    "{\n",
                                    "  DATA* data = (DATA*) inData;\n",
                                    "  LINEAR_SYSTEM_DATA* linearSystemData = (LINEAR_SYSTEM_DATA*) systemData;\n",
                                    "  int i=0;\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_body__initializeStaticLSData2);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;
  end match;
end fun_300;

protected function fun_301
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eqn;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_eqn, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      String a_modelNamePrefix;
      list<DAE.Exp> i_at_beqs;
      list<tuple<Integer, Integer, SimCode.SimEqSystem>> i_at_simJac;
      Integer i_at_index;
      list<SimCode.SimEqSystem> i_at_residual;
      list<SimCodeVar.SimVar> i_at_vars;
      list<DAE.Exp> i_ls_beqs;
      list<tuple<Integer, Integer, SimCode.SimEqSystem>> i_ls_simJac;
      Integer i_ls_indexLinearSystem;
      Integer i_ls_index;
      list<SimCode.SimEqSystem> i_ls_residual;
      Boolean i_ls_partOfJac;
      list<SimCodeVar.SimVar> i_ls_vars;
      Option<SimCode.JacobianMatrix> i_ls_jacobianMatrix;
      SimCode.SimEqSystem i_eq_cont;
      list<SimCode.SimEqSystem> ret_0;

    case ( txt,
           SimCode.SES_MIXED(cont = i_eq_cont),
           a_modelNamePrefix )
      equation
        ret_0 = List.fill(i_eq_cont, 1);
        txt = functionSetupLinearSystemsTemp(txt, ret_0, a_modelNamePrefix);
      then txt;

    case ( txt,
           SimCode.SES_LINEAR(lSystem = SimCode.LINEARSYSTEM(jacobianMatrix = i_ls_jacobianMatrix, vars = i_ls_vars, partOfJac = i_ls_partOfJac, residual = i_ls_residual, index = i_ls_index, indexLinearSystem = i_ls_indexLinearSystem, simJac = i_ls_simJac, beqs = i_ls_beqs), alternativeTearing = NONE()),
           a_modelNamePrefix )
      equation
        txt = fun_269(txt, i_ls_jacobianMatrix, i_ls_beqs, i_ls_simJac, i_ls_indexLinearSystem, i_ls_index, a_modelNamePrefix, i_ls_residual, i_ls_partOfJac, i_ls_vars);
      then txt;

    case ( txt,
           SimCode.SES_LINEAR(lSystem = SimCode.LINEARSYSTEM(jacobianMatrix = i_ls_jacobianMatrix, vars = i_ls_vars, residual = i_ls_residual, index = i_ls_index, partOfJac = i_ls_partOfJac, indexLinearSystem = i_ls_indexLinearSystem, simJac = i_ls_simJac, beqs = i_ls_beqs), alternativeTearing = SOME(SimCode.LINEARSYSTEM(vars = i_at_vars, residual = i_at_residual, index = i_at_index, simJac = i_at_simJac, beqs = i_at_beqs))),
           a_modelNamePrefix )
      equation
        txt = fun_300(txt, i_ls_jacobianMatrix, i_at_beqs, i_at_simJac, i_ls_beqs, i_ls_simJac, i_at_index, i_ls_indexLinearSystem, i_ls_partOfJac, i_ls_index, i_at_residual, i_at_vars, a_modelNamePrefix, i_ls_residual, i_ls_vars);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_301;

protected function lm_302
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      String a_modelNamePrefix;
      SimCode.SimEqSystem i_eqn;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_eqn :: rest,
           a_modelNamePrefix )
      equation
        txt = fun_301(txt, i_eqn, a_modelNamePrefix);
        txt = Tpl.nextIter(txt);
        txt = lm_302(txt, rest, a_modelNamePrefix);
      then txt;
  end match;
end lm_302;

public function functionSetupLinearSystemsTemp
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_linearSystems;
  input String a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt := Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING_LIST({
                                                                    "\n",
                                                                    "\n"
                                                                }, true)), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_302(out_txt, a_linearSystems, a_modelNamePrefix);
  out_txt := Tpl.popIter(out_txt);
end functionSetupLinearSystemsTemp;

protected function fun_304
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_eq, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      String a_modelNamePrefix;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           (i_eq as SimCode.SES_NONLINEAR(alternativeTearing = SOME(_))),
           a_modelNamePrefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("int "));
        txt = CodegenUtil.symbolName(txt, a_modelNamePrefix, "eqFunction");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = CodegenUtilSimulation.equationIndex(txt, i_eq);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(DATA*, threadData_t*);"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_304;

protected function lm_305
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      String a_modelNamePrefix;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_eq :: rest,
           a_modelNamePrefix )
      equation
        txt = fun_304(txt, i_eq, a_modelNamePrefix);
        txt = Tpl.nextIter(txt);
        txt = lm_305(txt, rest, a_modelNamePrefix);
      then txt;
  end match;
end lm_305;

public function functionInitialNonLinearSystems
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_nonlinearSystems;
  input String a_modelNamePrefix;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_nlsbody;
  Tpl.Text l_globalConstraintsFunctions;
  Tpl.Text l_tempeqns;
algorithm
  l_tempeqns := Tpl.emptyTxt;
  l_tempeqns := Tpl.pushIter(l_tempeqns, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  l_tempeqns := lm_305(l_tempeqns, a_nonlinearSystems, a_modelNamePrefix);
  l_tempeqns := Tpl.popIter(l_tempeqns);
  l_globalConstraintsFunctions := Tpl.emptyTxt;
  (l_nlsbody, l_globalConstraintsFunctions) := functionInitialNonLinearSystemsTemp(Tpl.emptyTxt, a_nonlinearSystems, a_modelNamePrefix, l_globalConstraintsFunctions);
  out_txt := Tpl.writeTok(txt, Tpl.ST_LINE("/* Prototypes for the strict sets (Dynamic Tearing) */\n"));
  out_txt := Tpl.writeText(out_txt, l_tempeqns);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "/* Global constraints for the casual sets */\n"
                                   }, true));
  out_txt := Tpl.writeText(out_txt, l_globalConstraintsFunctions);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "/* function initialize non-linear systems */\n",
                                       "void "
                                   }, false));
  out_txt := CodegenUtil.symbolName(out_txt, a_modelNamePrefix, "initialNonLinearSystem");
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "(int nNonLinearSystems, NONLINEAR_SYSTEM_DATA* nonLinearSystemData)\n",
                                       "{\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeText(out_txt, l_nlsbody);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("}"));
end functionInitialNonLinearSystems;

protected function fun_307
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eqn;
  input Tpl.Text in_a_globalConstraintsFunctions;
  input String in_a_modelPrefixName;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_globalConstraintsFunctions;
algorithm
  (out_txt, out_a_globalConstraintsFunctions) :=
  match(in_txt, in_a_eqn, in_a_globalConstraintsFunctions, in_a_modelPrefixName)
    local
      Tpl.Text txt;
      Tpl.Text a_globalConstraintsFunctions;
      String a_modelPrefixName;
      SimCode.SimEqSystem i_eq;
      Integer i_nls_index;
      SimCode.NonlinearSystem i_at;
      SimCode.NonlinearSystem i_nls;
      SimCode.SimEqSystem i_eq_cont;
      Tpl.Text l_systemCasual;
      Tpl.Text l_system;
      list<SimCode.SimEqSystem> ret_0;

    case ( txt,
           SimCode.SES_MIXED(cont = i_eq_cont),
           a_globalConstraintsFunctions,
           a_modelPrefixName )
      equation
        ret_0 = List.fill(i_eq_cont, 1);
        (txt, a_globalConstraintsFunctions) = functionInitialNonLinearSystemsTemp(txt, ret_0, a_modelPrefixName, a_globalConstraintsFunctions);
      then (txt, a_globalConstraintsFunctions);

    case ( txt,
           SimCode.SES_NONLINEAR(nlSystem = (i_nls as SimCode.NONLINEARSYSTEM(index = _)), alternativeTearing = NONE()),
           a_globalConstraintsFunctions,
           a_modelPrefixName )
      equation
        l_system = generateNonLinearSystemData(Tpl.emptyTxt, i_nls, 0, a_modelPrefixName);
        txt = Tpl.writeText(txt, l_system);
      then (txt, a_globalConstraintsFunctions);

    case ( txt,
           (i_eq as SimCode.SES_NONLINEAR(nlSystem = (i_nls as SimCode.NONLINEARSYSTEM(index = i_nls_index)), alternativeTearing = SOME((i_at as SimCode.NONLINEARSYSTEM(index = _))))),
           a_globalConstraintsFunctions,
           a_modelPrefixName )
      equation
        l_system = generateNonLinearSystemData(Tpl.emptyTxt, i_nls, 0, a_modelPrefixName);
        l_systemCasual = generateNonLinearSystemData(Tpl.emptyTxt, i_at, i_nls_index, a_modelPrefixName);
        a_globalConstraintsFunctions = createGlobalConstraintsFunction(a_globalConstraintsFunctions, i_eq);
        txt = Tpl.writeText(txt, l_system);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_systemCasual);
      then (txt, a_globalConstraintsFunctions);

    case ( txt,
           _,
           a_globalConstraintsFunctions,
           _ )
      then (txt, a_globalConstraintsFunctions);
  end match;
end fun_307;

protected function lm_308
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input Tpl.Text in_a_globalConstraintsFunctions;
  input String in_a_modelPrefixName;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_globalConstraintsFunctions;
algorithm
  (out_txt, out_a_globalConstraintsFunctions) :=
  match(in_txt, in_items, in_a_globalConstraintsFunctions, in_a_modelPrefixName)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      Tpl.Text a_globalConstraintsFunctions;
      String a_modelPrefixName;
      SimCode.SimEqSystem i_eqn;

    case ( txt,
           {},
           a_globalConstraintsFunctions,
           _ )
      then (txt, a_globalConstraintsFunctions);

    case ( txt,
           i_eqn :: rest,
           a_globalConstraintsFunctions,
           a_modelPrefixName )
      equation
        (txt, a_globalConstraintsFunctions) = fun_307(txt, i_eqn, a_globalConstraintsFunctions, a_modelPrefixName);
        txt = Tpl.nextIter(txt);
        (txt, a_globalConstraintsFunctions) = lm_308(txt, rest, a_globalConstraintsFunctions, a_modelPrefixName);
      then (txt, a_globalConstraintsFunctions);
  end match;
end lm_308;

public function functionInitialNonLinearSystemsTemp
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_nonlinearSystems;
  input String a_modelPrefixName;
  input Tpl.Text a_globalConstraintsFunctions;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_globalConstraintsFunctions;
algorithm
  out_txt := Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING_LIST({
                                                                    "\n",
                                                                    "\n"
                                                                }, true)), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (out_txt, out_a_globalConstraintsFunctions) := lm_308(out_txt, a_nonlinearSystems, a_globalConstraintsFunctions, a_modelPrefixName);
  out_txt := Tpl.popIter(out_txt);
end functionInitialNonLinearSystemsTemp;

protected function fun_310
  input Tpl.Text in_txt;
  input Option<SimCode.JacobianMatrix> in_a_nls_jacobianMatrix;
  input String in_a_modelPrefixName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_nls_jacobianMatrix, in_a_modelPrefixName)
    local
      Tpl.Text txt;
      String a_modelPrefixName;
      String i_name;

    case ( txt,
           SOME(SimCode.JAC_MATRIX(columns = {}, matrixName = _)),
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("NULL"));
      then txt;

    case ( txt,
           SOME(SimCode.JAC_MATRIX(matrixName = i_name)),
           a_modelPrefixName )
      equation
        txt = CodegenUtil.symbolName(txt, a_modelPrefixName, "functionJac");
        txt = Tpl.writeStr(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_column"));
      then txt;

    case ( txt,
           NONE(),
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("NULL"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_310;

protected function fun_311
  input Tpl.Text in_txt;
  input Option<SimCode.JacobianMatrix> in_a_nls_jacobianMatrix;
  input String in_a_modelPrefixName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_nls_jacobianMatrix, in_a_modelPrefixName)
    local
      Tpl.Text txt;
      String a_modelPrefixName;
      String i_name;

    case ( txt,
           SOME(SimCode.JAC_MATRIX(columns = {}, matrixName = _)),
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("NULL"));
      then txt;

    case ( txt,
           SOME(SimCode.JAC_MATRIX(matrixName = i_name)),
           a_modelPrefixName )
      equation
        txt = CodegenUtil.symbolName(txt, a_modelPrefixName, "initialAnalyticJacobian");
        txt = Tpl.writeStr(txt, i_name);
      then txt;

    case ( txt,
           NONE(),
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("NULL"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_311;

protected function fun_312
  input Tpl.Text in_txt;
  input Option<SimCode.JacobianMatrix> in_a_nls_jacobianMatrix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_nls_jacobianMatrix)
    local
      Tpl.Text txt;
      Integer i_jacindex;

    case ( txt,
           SOME(SimCode.JAC_MATRIX(columns = {}, matrixName = _)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-1"));
      then txt;

    case ( txt,
           SOME(SimCode.JAC_MATRIX(matrixName = _, jacobianIndex = i_jacindex)) )
      equation
        txt = Tpl.writeStr(txt, intString(i_jacindex));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" /*jacInx*/"));
      then txt;

    case ( txt,
           NONE() )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-1"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_312;

protected function fun_313
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_indexStrict;
  input String in_a_modelPrefixName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_indexStrict, in_a_modelPrefixName)
    local
      Tpl.Text txt;
      Integer a_indexStrict;
      String a_modelPrefixName;

    case ( txt,
           false,
           a_indexStrict,
           a_modelPrefixName )
      equation
        txt = CodegenUtil.symbolName(txt, a_modelPrefixName, "eqFunction");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeStr(txt, intString(a_indexStrict));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("NULL"));
      then txt;
  end match;
end fun_313;

protected function fun_314
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_nls_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_nls_index)
    local
      Tpl.Text txt;
      Integer a_nls_index;

    case ( txt,
           false,
           a_nls_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("checkConstraints"));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
      then txt;

    case ( txt,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("NULL"));
      then txt;
  end match;
end fun_314;

protected function fun_315
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_nls_index;
  input Integer in_a_nls_indexNonLinearSystem;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_nls_index, in_a_nls_indexNonLinearSystem)
    local
      Tpl.Text txt;
      Integer a_nls_index;
      Integer a_nls_indexNonLinearSystem;

    case ( txt,
           false,
           a_nls_index,
           a_nls_indexNonLinearSystem )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("nonLinearSystemData["));
        txt = Tpl.writeStr(txt, intString(a_nls_indexNonLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].residualFuncConstraints = residualFuncConstraints"));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           _,
           a_nls_index,
           a_nls_indexNonLinearSystem )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("nonLinearSystemData["));
        txt = Tpl.writeStr(txt, intString(a_nls_indexNonLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].residualFunc = residualFunc"));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_315;

public function generateNonLinearSystemData
  input Tpl.Text in_txt;
  input SimCode.NonlinearSystem in_a_system;
  input Integer in_a_indexStrict;
  input String in_a_modelPrefixName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_system, in_a_indexStrict, in_a_modelPrefixName)
    local
      Tpl.Text txt;
      Integer a_indexStrict;
      String a_modelPrefixName;
      Boolean i_nls_mixedSystem;
      Boolean i_nls_homotopySupport;
      Integer i_nls_indexNonLinearSystem;
      Integer i_nls_index;
      list<SimCode.SimEqSystem> i_nls_eqs;
      Option<SimCode.JacobianMatrix> i_nls_jacobianMatrix;
      list<DAE.ComponentRef> i_nls_crefs;
      Boolean ret_11;
      Tpl.Text l_residualCall;
      Boolean ret_9;
      Tpl.Text l_constraintsCall;
      Boolean ret_7;
      Tpl.Text l_casualCall;
      Tpl.Text l_innerSystems;
      Tpl.Text l_jacIndex;
      Tpl.Text l_initialJac;
      Tpl.Text l_generatedJac;
      Integer ret_1;
      Tpl.Text l_size;

    case ( txt,
           SimCode.NONLINEARSYSTEM(crefs = i_nls_crefs, jacobianMatrix = i_nls_jacobianMatrix, eqs = i_nls_eqs, index = i_nls_index, indexNonLinearSystem = i_nls_indexNonLinearSystem, homotopySupport = i_nls_homotopySupport, mixedSystem = i_nls_mixedSystem),
           a_indexStrict,
           a_modelPrefixName )
      equation
        ret_1 = listLength(i_nls_crefs);
        l_size = Tpl.writeStr(Tpl.emptyTxt, intString(ret_1));
        l_generatedJac = fun_310(Tpl.emptyTxt, i_nls_jacobianMatrix, a_modelPrefixName);
        l_initialJac = fun_311(Tpl.emptyTxt, i_nls_jacobianMatrix, a_modelPrefixName);
        l_jacIndex = fun_312(Tpl.emptyTxt, i_nls_jacobianMatrix);
        (l_innerSystems, _) = functionInitialNonLinearSystemsTemp(Tpl.emptyTxt, i_nls_eqs, a_modelPrefixName, Tpl.strTokText(Tpl.ST_STRING("")));
        ret_7 = intEq(a_indexStrict, 0);
        l_casualCall = fun_313(Tpl.emptyTxt, ret_7, a_indexStrict, a_modelPrefixName);
        ret_9 = intEq(a_indexStrict, 0);
        l_constraintsCall = fun_314(Tpl.emptyTxt, ret_9, i_nls_index);
        ret_11 = intEq(a_indexStrict, 0);
        l_residualCall = fun_315(Tpl.emptyTxt, ret_11, i_nls_index, i_nls_indexNonLinearSystem);
        txt = Tpl.writeText(txt, l_innerSystems);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "nonLinearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_nls_indexNonLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].equationIndex = "));
        txt = Tpl.writeStr(txt, intString(i_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "nonLinearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_nls_indexNonLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].size = "));
        txt = Tpl.writeText(txt, l_size);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "nonLinearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_nls_indexNonLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].homotopySupport = "));
        txt = CodegenCFunctions.boolStrC(txt, i_nls_homotopySupport);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "nonLinearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_nls_indexNonLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].mixedSystem = "));
        txt = CodegenCFunctions.boolStrC(txt, i_nls_mixedSystem);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.writeText(txt, l_residualCall);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("nonLinearSystemData["));
        txt = Tpl.writeStr(txt, intString(i_nls_indexNonLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].strictTearingFunctionCall = "));
        txt = Tpl.writeText(txt, l_casualCall);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "nonLinearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_nls_indexNonLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].analyticalJacobianColumn = "));
        txt = Tpl.writeText(txt, l_generatedJac);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "nonLinearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_nls_indexNonLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].initialAnalyticalJacobian = "));
        txt = Tpl.writeText(txt, l_initialJac);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "nonLinearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_nls_indexNonLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].jacobianIndex = "));
        txt = Tpl.writeText(txt, l_jacIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "nonLinearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_nls_indexNonLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].initializeStaticNLSData = initializeStaticDataNLS"));
        txt = Tpl.writeStr(txt, intString(i_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "nonLinearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_nls_indexNonLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].getIterationVars = getIterationVarsNLS"));
        txt = Tpl.writeStr(txt, intString(i_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "nonLinearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_nls_indexNonLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].checkConstraints = "));
        txt = Tpl.writeText(txt, l_constraintsCall);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end generateNonLinearSystemData;

public function createGlobalConstraintsFunction
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_system;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_system)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> i_at_residual;
      Integer i_at_index;
      list<SimCode.SimEqSystem> i_at_eqs;
      Tpl.Text l_constraints;

    case ( txt,
           SimCode.SES_NONLINEAR(alternativeTearing = SOME(SimCode.NONLINEARSYSTEM(eqs = i_at_eqs, index = i_at_index))) )
      equation
        l_constraints = createGlobalConstraints(Tpl.emptyTxt, i_at_eqs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("int checkConstraints"));
        txt = Tpl.writeStr(txt, intString(i_at_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA *data, threadData_t *threadData)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("const int equationIndexes[2] = {1,"));
        txt = Tpl.writeStr(txt, intString(i_at_index));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("};\n"));
        txt = Tpl.writeText(txt, l_constraints);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("return 1;\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n"
                                }, true));
      then txt;

    case ( txt,
           SimCode.SES_LINEAR(alternativeTearing = SOME(SimCode.LINEARSYSTEM(residual = i_at_residual, index = i_at_index))) )
      equation
        l_constraints = createGlobalConstraints(Tpl.emptyTxt, i_at_residual);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("int checkConstraints"));
        txt = Tpl.writeStr(txt, intString(i_at_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA *data, threadData_t *threadData)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("const int equationIndexes[2] = {1,"));
        txt = Tpl.writeStr(txt, intString(i_at_index));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("};\n"));
        txt = Tpl.writeText(txt, l_constraints);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("return 1;\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n"
                                }, true));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end createGlobalConstraintsFunction;

protected function fun_318
  input Tpl.Text in_txt;
  input Boolean in_a_localCon;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_localCon)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("global"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("local"));
      then txt;
  end match;
end fun_318;

protected function fun_319
  input Tpl.Text in_txt;
  input DAE.Constraint in_a_con;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_con)
    local
      Tpl.Text txt;
      Boolean i_localCon;
      DAE.Exp i_c;
      Tpl.Text l_condition;
      Tpl.Text l_auxFunction;
      Tpl.Text l_varDecls;
      Tpl.Text l_preExp;

    case ( txt,
           DAE.CONSTRAINT_DT(constraint = i_c, localCon = i_localCon) )
      equation
        l_preExp = Tpl.emptyTxt;
        l_varDecls = Tpl.emptyTxt;
        l_auxFunction = Tpl.emptyTxt;
        (l_condition, l_preExp, l_varDecls, l_auxFunction) = CodegenCFunctions.daeExp(Tpl.emptyTxt, i_c, SimCodeFunction.contextSimulationDiscrete, l_preExp, l_varDecls, l_auxFunction);
        txt = Tpl.writeText(txt, l_varDecls);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_auxFunction);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if (!"));
        txt = Tpl.writeText(txt, l_condition);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("){\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("debugString(LOG_DT_CONS, \"The following "));
        txt = fun_318(txt, i_localCon);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" constraint is violated:\\n"));
        txt = ExpressionDumpTpl.dumpExp(txt, i_c, "\"");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\");\n",
                                    "return 0;\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_319;

protected function lm_320
  input Tpl.Text in_txt;
  input BackendDAE.Constraints in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      BackendDAE.Constraints rest;
      DAE.Constraint i_con;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_con :: rest )
      equation
        txt = fun_319(txt, i_con);
        txt = Tpl.nextIter(txt);
        txt = lm_320(txt, rest);
      then txt;
  end match;
end lm_320;

protected function fun_321
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_innerEqn;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_innerEqn)
    local
      Tpl.Text txt;
      BackendDAE.Constraints i_innerEqn_cons;

    case ( txt,
           SimCode.SES_SIMPLE_ASSIGN_CONSTRAINTS(cons = i_innerEqn_cons) )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_320(txt, i_innerEqn_cons);
        txt = Tpl.popIter(txt);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_321;

protected function lm_322
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      SimCode.SimEqSystem i_innerEqn;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_innerEqn :: rest )
      equation
        txt = fun_321(txt, i_innerEqn);
        txt = Tpl.nextIter(txt);
        txt = lm_322(txt, rest);
      then txt;
  end match;
end lm_322;

public function createGlobalConstraints
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_innerEqns;

  output Tpl.Text out_txt;
algorithm
  out_txt := Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_322(out_txt, a_innerEqns);
  out_txt := Tpl.popIter(out_txt);
end createGlobalConstraints;

protected function fun_324
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input Tpl.Text in_a_eqs;
  input String in_a_modelNamePrefixStr;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_eqs;
algorithm
  (out_txt, out_a_eqs) :=
  match(in_txt, in_a_eq, in_a_eqs, in_a_modelNamePrefixStr)
    local
      Tpl.Text txt;
      Tpl.Text a_eqs;
      String a_modelNamePrefixStr;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           SimCode.SES_RESIDUAL(index = _),
           a_eqs,
           _ )
      then (txt, a_eqs);

    case ( txt,
           i_eq,
           a_eqs,
           a_modelNamePrefixStr )
      equation
        a_eqs = equation_impl(a_eqs, -1, i_eq, SimCodeFunction.contextSimulationDiscrete, a_modelNamePrefixStr, false);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/* local constraints */\n"));
        txt = createLocalConstraints(txt, i_eq);
        txt = Tpl.softNewLine(txt);
        txt = equation_call(txt, i_eq, a_modelNamePrefixStr);
      then (txt, a_eqs);
  end match;
end fun_324;

public function functionExtraResidualsPreBody
  input Tpl.Text txt;
  input SimCode.SimEqSystem a_eq;
  input Tpl.Text a_eqs;
  input String a_modelNamePrefixStr;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_eqs;
algorithm
  System.tmpTickReset(0);
  (out_txt, out_a_eqs) := fun_324(txt, a_eq, a_eqs, a_modelNamePrefixStr);
end functionExtraResidualsPreBody;

protected function fun_326
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input Tpl.Text in_a_eqs;
  input String in_a_modelNamePrefixStr;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_eqs;
algorithm
  (out_txt, out_a_eqs) :=
  match(in_txt, in_a_eq, in_a_eqs, in_a_modelNamePrefixStr)
    local
      Tpl.Text txt;
      Tpl.Text a_eqs;
      String a_modelNamePrefixStr;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           SimCode.SES_RESIDUAL(index = _),
           a_eqs,
           _ )
      then (txt, a_eqs);

    case ( txt,
           i_eq,
           a_eqs,
           a_modelNamePrefixStr )
      equation
        a_eqs = equation_impl(a_eqs, -1, i_eq, SimCodeFunction.contextJacobian, a_modelNamePrefixStr, false);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/* local constraints */\n"));
        txt = createLocalConstraints(txt, i_eq);
        txt = Tpl.softNewLine(txt);
        txt = equation_callJacobian(txt, i_eq, a_modelNamePrefixStr);
      then (txt, a_eqs);
  end match;
end fun_326;

public function functionExtraResidualsPreBodyJacobian
  input Tpl.Text txt;
  input SimCode.SimEqSystem a_eq;
  input Tpl.Text a_eqs;
  input String a_modelNamePrefixStr;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_eqs;
algorithm
  System.tmpTickReset(0);
  (out_txt, out_a_eqs) := fun_326(txt, a_eq, a_eqs, a_modelNamePrefixStr);
end functionExtraResidualsPreBodyJacobian;

protected function fun_328
  input Tpl.Text in_txt;
  input DAE.Constraint in_a_con;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_con)
    local
      Tpl.Text txt;
      DAE.Exp i_c;
      Tpl.Text l_condition;
      Tpl.Text l_auxFunction;
      Tpl.Text l_varDecls;
      Tpl.Text l_preExp;

    case ( txt,
           DAE.CONSTRAINT_DT(constraint = i_c, localCon = true) )
      equation
        l_preExp = Tpl.emptyTxt;
        l_varDecls = Tpl.emptyTxt;
        l_auxFunction = Tpl.emptyTxt;
        (l_condition, l_preExp, l_varDecls, l_auxFunction) = CodegenCFunctions.daeExp(Tpl.emptyTxt, i_c, SimCodeFunction.contextSimulationDiscrete, l_preExp, l_varDecls, l_auxFunction);
        txt = Tpl.writeText(txt, l_varDecls);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_auxFunction);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if (!"));
        txt = Tpl.writeText(txt, l_condition);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("){\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("debugString(LOG_DT_CONS, \"The following local constraint is violated:\\n"));
        txt = ExpressionDumpTpl.dumpExp(txt, i_c, "\"");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\");\n",
                                    "debugString(LOG_DT, \"Local constraints of the casual tearing set are violated! Let\'s fail...\");\n",
                                    "return 1;\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_328;

protected function lm_329
  input Tpl.Text in_txt;
  input BackendDAE.Constraints in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      BackendDAE.Constraints rest;
      DAE.Constraint i_con;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_con :: rest )
      equation
        txt = fun_328(txt, i_con);
        txt = Tpl.nextIter(txt);
        txt = lm_329(txt, rest);
      then txt;
  end match;
end lm_329;

public function createLocalConstraints
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_eq)
    local
      Tpl.Text txt;
      BackendDAE.Constraints i_e_cons;

    case ( txt,
           SimCode.SES_SIMPLE_ASSIGN_CONSTRAINTS(cons = i_e_cons) )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_329(txt, i_e_cons);
        txt = Tpl.popIter(txt);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end createLocalConstraints;

protected function fun_331
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eqn;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_eqn, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      String a_modelNamePrefix;
      list<DAE.ComponentRef> i_at_crefs;
      Integer i_at_index;
      SimCode.NonlinearSystem i_at;
      list<DAE.ComponentRef> i_nls_crefs;
      Integer i_maxColor;
      list<list<Integer>> i_colorList;
      SimCode.SparsityPattern i_sparsePattern;
      Integer i_nls_index;
      SimCode.NonlinearSystem i_nls;
      SimCode.SimEqSystem i_eq_cont;
      Tpl.Text l_updateIterationVarsCasual;
      Tpl.Text l_bodyStaticDataCasual;
      Tpl.Text l_sparseDataCasual;
      Tpl.Text l_indexName_1;
      Tpl.Text l_residualFunctionCasual;
      Tpl.Text l_updateIterationVars;
      Tpl.Text l_bodyStaticData;
      Tpl.Text l_sparseData;
      Tpl.Text l_indexName;
      Tpl.Text l_residualFunction;
      list<SimCode.SimEqSystem> ret_0;

    case ( txt,
           SimCode.SES_MIXED(cont = i_eq_cont),
           a_modelNamePrefix )
      equation
        ret_0 = List.fill(i_eq_cont, 1);
        txt = functionNonLinearResiduals(txt, ret_0, a_modelNamePrefix);
      then txt;

    case ( txt,
           SimCode.SES_NONLINEAR(nlSystem = (i_nls as SimCode.NONLINEARSYSTEM(jacobianMatrix = SOME(SimCode.JAC_MATRIX(sparsity = i_sparsePattern, coloredCols = i_colorList, maxColorCols = i_maxColor)), index = i_nls_index, crefs = i_nls_crefs)), alternativeTearing = NONE()),
           a_modelNamePrefix )
      equation
        l_residualFunction = generateNonLinearResidualFunction(Tpl.emptyTxt, i_nls, a_modelNamePrefix, 0);
        l_indexName = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("NLS"));
        l_indexName = Tpl.writeStr(l_indexName, intString(i_nls_index));
        l_sparseData = generateStaticSparseData(Tpl.emptyTxt, Tpl.textString(l_indexName), "NONLINEAR_SYSTEM_DATA", i_sparsePattern, i_colorList, i_maxColor);
        l_bodyStaticData = generateStaticInitialData(Tpl.emptyTxt, i_nls_crefs, Tpl.textString(l_indexName), "NONLINEAR_SYSTEM_DATA");
        l_updateIterationVars = getIterationVars(Tpl.emptyTxt, i_nls_crefs, Tpl.textString(l_indexName));
        txt = Tpl.writeText(txt, l_residualFunction);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_sparseData);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_bodyStaticData);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_updateIterationVars);
      then txt;

    case ( txt,
           SimCode.SES_NONLINEAR(nlSystem = (i_nls as SimCode.NONLINEARSYSTEM(index = i_nls_index, crefs = i_nls_crefs)), alternativeTearing = NONE()),
           a_modelNamePrefix )
      equation
        l_residualFunction = generateNonLinearResidualFunction(Tpl.emptyTxt, i_nls, a_modelNamePrefix, 0);
        l_indexName = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("NLS"));
        l_indexName = Tpl.writeStr(l_indexName, intString(i_nls_index));
        l_sparseData = generateStaticEmptySparseData(Tpl.emptyTxt, Tpl.textString(l_indexName), "NONLINEAR_SYSTEM_DATA");
        l_bodyStaticData = generateStaticInitialData(Tpl.emptyTxt, i_nls_crefs, Tpl.textString(l_indexName), "NONLINEAR_SYSTEM_DATA");
        l_updateIterationVars = getIterationVars(Tpl.emptyTxt, i_nls_crefs, Tpl.textString(l_indexName));
        txt = Tpl.writeText(txt, l_residualFunction);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_sparseData);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_bodyStaticData);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_updateIterationVars);
      then txt;

    case ( txt,
           SimCode.SES_NONLINEAR(nlSystem = (i_nls as SimCode.NONLINEARSYSTEM(jacobianMatrix = SOME(SimCode.JAC_MATRIX(sparsity = i_sparsePattern, coloredCols = i_colorList, maxColorCols = i_maxColor)), index = i_nls_index, crefs = i_nls_crefs)), alternativeTearing = SOME((i_at as SimCode.NONLINEARSYSTEM(jacobianMatrix = SOME(SimCode.JAC_MATRIX(sparsity = _, coloredCols = _, maxColorCols = _)), index = i_at_index, crefs = i_at_crefs)))),
           a_modelNamePrefix )
      equation
        l_residualFunction = generateNonLinearResidualFunction(Tpl.emptyTxt, i_nls, a_modelNamePrefix, 0);
        l_indexName = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("NLS"));
        l_indexName = Tpl.writeStr(l_indexName, intString(i_nls_index));
        l_sparseData = generateStaticSparseData(Tpl.emptyTxt, Tpl.textString(l_indexName), "NONLINEAR_SYSTEM_DATA", i_sparsePattern, i_colorList, i_maxColor);
        l_bodyStaticData = generateStaticInitialData(Tpl.emptyTxt, i_nls_crefs, Tpl.textString(l_indexName), "NONLINEAR_SYSTEM_DATA");
        l_updateIterationVars = getIterationVars(Tpl.emptyTxt, i_nls_crefs, Tpl.textString(l_indexName));
        l_residualFunctionCasual = generateNonLinearResidualFunction(Tpl.emptyTxt, i_at, a_modelNamePrefix, 1);
        l_indexName_1 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("NLS"));
        l_indexName_1 = Tpl.writeStr(l_indexName_1, intString(i_at_index));
        l_sparseDataCasual = generateStaticSparseData(Tpl.emptyTxt, Tpl.textString(l_indexName_1), "NONLINEAR_SYSTEM_DATA", i_sparsePattern, i_colorList, i_maxColor);
        l_bodyStaticDataCasual = generateStaticInitialData(Tpl.emptyTxt, i_at_crefs, Tpl.textString(l_indexName_1), "NONLINEAR_SYSTEM_DATA");
        l_updateIterationVarsCasual = getIterationVars(Tpl.emptyTxt, i_at_crefs, Tpl.textString(l_indexName_1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "/* start residuals for dynamic tearing sets */\n",
                                    "/* strict tearing set */\n"
                                }, true));
        txt = Tpl.writeText(txt, l_residualFunction);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_sparseData);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_bodyStaticData);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_updateIterationVars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/* casual tearing set */\n"));
        txt = Tpl.writeText(txt, l_residualFunctionCasual);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_sparseDataCasual);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_bodyStaticDataCasual);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_updateIterationVarsCasual);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/* end residuals for dynamic tearing sets */"));
      then txt;

    case ( txt,
           SimCode.SES_NONLINEAR(nlSystem = (i_nls as SimCode.NONLINEARSYSTEM(index = i_nls_index, crefs = i_nls_crefs)), alternativeTearing = SOME((i_at as SimCode.NONLINEARSYSTEM(index = i_at_index, crefs = i_at_crefs)))),
           a_modelNamePrefix )
      equation
        l_residualFunction = generateNonLinearResidualFunction(Tpl.emptyTxt, i_nls, a_modelNamePrefix, 0);
        l_indexName = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("NLS"));
        l_indexName = Tpl.writeStr(l_indexName, intString(i_nls_index));
        l_sparseData = generateStaticEmptySparseData(Tpl.emptyTxt, Tpl.textString(l_indexName), "NONLINEAR_SYSTEM_DATA");
        l_bodyStaticData = generateStaticInitialData(Tpl.emptyTxt, i_nls_crefs, Tpl.textString(l_indexName), "NONLINEAR_SYSTEM_DATA");
        l_updateIterationVars = getIterationVars(Tpl.emptyTxt, i_nls_crefs, Tpl.textString(l_indexName));
        l_residualFunctionCasual = generateNonLinearResidualFunction(Tpl.emptyTxt, i_at, a_modelNamePrefix, 1);
        l_indexName_1 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("NLS"));
        l_indexName_1 = Tpl.writeStr(l_indexName_1, intString(i_at_index));
        l_sparseDataCasual = generateStaticEmptySparseData(Tpl.emptyTxt, Tpl.textString(l_indexName_1), "NONLINEAR_SYSTEM_DATA");
        l_bodyStaticDataCasual = generateStaticInitialData(Tpl.emptyTxt, i_at_crefs, Tpl.textString(l_indexName_1), "NONLINEAR_SYSTEM_DATA");
        l_updateIterationVarsCasual = getIterationVars(Tpl.emptyTxt, i_at_crefs, Tpl.textString(l_indexName_1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "/* start residuals for dynamic tearing sets */\n",
                                    "/* strict tearing set */\n"
                                }, true));
        txt = Tpl.writeText(txt, l_residualFunction);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_sparseData);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_bodyStaticData);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_updateIterationVars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/* casual tearing set */\n"));
        txt = Tpl.writeText(txt, l_residualFunctionCasual);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_sparseDataCasual);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_bodyStaticDataCasual);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_updateIterationVarsCasual);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/* end residuals for dynamic tearing sets */"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_331;

protected function lm_332
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      String a_modelNamePrefix;
      SimCode.SimEqSystem i_eqn;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_eqn :: rest,
           a_modelNamePrefix )
      equation
        System.tmpTickReset(0);
        txt = fun_331(txt, i_eqn, a_modelNamePrefix);
        txt = Tpl.nextIter(txt);
        txt = lm_332(txt, rest, a_modelNamePrefix);
      then txt;
  end match;
end lm_332;

public function functionNonLinearResiduals
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_nonlinearSystems;
  input String a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt := Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING_LIST({
                                                                    "\n",
                                                                    "\n"
                                                                }, true)), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_332(out_txt, a_nonlinearSystems, a_modelNamePrefix);
  out_txt := Tpl.popIter(out_txt);
end functionNonLinearResiduals;

protected function lm_334
  input Tpl.Text in_txt;
  input list<DAE.ComponentRef> in_items;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_varDecls) :=
  match(in_txt, in_items, in_a_varDecls)
    local
      Tpl.Text txt;
      list<DAE.ComponentRef> rest;
      Tpl.Text a_varDecls;
      Integer x_i0;
      DAE.ComponentRef i_cr;

    case ( txt,
           {},
           a_varDecls )
      then (txt, a_varDecls);

    case ( txt,
           i_cr :: rest,
           a_varDecls )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        a_varDecls = crefType(a_varDecls, i_cr);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(" OLD_"));
        a_varDecls = Tpl.writeStr(a_varDecls, intString(x_i0));
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(";"));
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_NEW_LINE());
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("OLD_"));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = CodegenCFunctions.cref(txt, i_cr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        (txt, a_varDecls) = lm_334(txt, rest, a_varDecls);
      then (txt, a_varDecls);
  end match;
end lm_334;

protected function fun_335
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_a_nls_eqs;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_varDecls) :=
  match(in_txt, in_a_nls_eqs, in_a_varDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_varDecls;
      list<DAE.ComponentRef> i_alg_knownOutputCrefs;
      Tpl.Text l_body;

    case ( txt,
           SimCode.SES_INVERSE_ALGORITHM(knownOutputCrefs = i_alg_knownOutputCrefs) :: {},
           a_varDecls )
      equation
        l_body = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_body, a_varDecls) = lm_334(l_body, i_alg_knownOutputCrefs, a_varDecls);
        l_body = Tpl.popIter(l_body);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/* backup outputs of the algorithm */\n"));
        txt = Tpl.writeText(txt, l_body);
      then (txt, a_varDecls);

    case ( txt,
           _,
           a_varDecls )
      then (txt, a_varDecls);
  end match;
end fun_335;

protected function lm_336
  input Tpl.Text in_txt;
  input list<DAE.ComponentRef> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<DAE.ComponentRef> rest;
      Integer x_i0;
      DAE.ComponentRef i_cr;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_cr :: rest )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = CodegenCFunctions.cref(txt, i_cr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = OLD_"));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        txt = lm_336(txt, rest);
      then txt;
  end match;
end lm_336;

protected function fun_337
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_a_nls_eqs;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_nls_eqs)
    local
      Tpl.Text txt;
      list<DAE.ComponentRef> i_alg_knownOutputCrefs;
      Tpl.Text l_body;

    case ( txt,
           SimCode.SES_INVERSE_ALGORITHM(knownOutputCrefs = i_alg_knownOutputCrefs) :: {} )
      equation
        l_body = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_body = lm_336(l_body, i_alg_knownOutputCrefs);
        l_body = Tpl.popIter(l_body);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/* restore previously known outputs of the algorithm */\n"));
        txt = Tpl.writeText(txt, l_body);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_337;

protected function lm_338
  input Tpl.Text in_txt;
  input list<DAE.ComponentRef> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<DAE.ComponentRef> rest;
      Integer x_i0;
      DAE.ComponentRef i_cr;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_cr :: rest )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = CodegenCFunctions.cref(txt, i_cr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = xloc["));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("];"));
        txt = Tpl.nextIter(txt);
        txt = lm_338(txt, rest);
      then txt;
  end match;
end lm_338;

protected function lm_339
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input String in_a_modelNamePrefix;
  input Tpl.Text in_a_innerEqns;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_innerEqns;
algorithm
  (out_txt, out_a_innerEqns) :=
  match(in_txt, in_items, in_a_modelNamePrefix, in_a_innerEqns)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      String a_modelNamePrefix;
      Tpl.Text a_innerEqns;
      SimCode.SimEqSystem i_eq2;

    case ( txt,
           {},
           _,
           a_innerEqns )
      then (txt, a_innerEqns);

    case ( txt,
           i_eq2 :: rest,
           a_modelNamePrefix,
           a_innerEqns )
      equation
        (txt, a_innerEqns) = functionExtraResidualsPreBody(txt, i_eq2, a_innerEqns, a_modelNamePrefix);
        txt = Tpl.nextIter(txt);
        (txt, a_innerEqns) = lm_339(txt, rest, a_modelNamePrefix, a_innerEqns);
      then (txt, a_innerEqns);
  end match;
end lm_339;

protected function lm_340
  input Tpl.Text in_txt;
  input list<DAE.ComponentRef> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<DAE.ComponentRef> rest;
      Integer x_i0;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           _ :: rest )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("res["));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = 0;"));
        txt = Tpl.nextIter(txt);
        txt = lm_340(txt, rest);
      then txt;
  end match;
end lm_340;

protected function lm_341
  input Tpl.Text in_txt;
  input list<DAE.ComponentRef> in_items;
  input list<DAE.ComponentRef> in_a_nls_crefs;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_nls_crefs)
    local
      Tpl.Text txt;
      list<DAE.ComponentRef> rest;
      list<DAE.ComponentRef> a_nls_crefs;
      Integer x_i0;
      DAE.ComponentRef i_cr;
      Integer ret_0;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_cr :: rest,
           a_nls_crefs )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("res[(int)fmod("));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        ret_0 = listLength(a_nls_crefs);
        txt = Tpl.writeStr(txt, intString(ret_0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")] += pow(OLD_"));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" - "));
        txt = CodegenCFunctions.cref(txt, i_cr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", 2);"));
        txt = Tpl.nextIter(txt);
        txt = lm_341(txt, rest, a_nls_crefs);
      then txt;
  end match;
end lm_341;

protected function fun_342
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_eq2_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_eq2_index)
    local
      Tpl.Text txt;
      Integer a_eq2_index;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_eq2_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("SIM_PROF_TICK_EQ("));
        txt = Tpl.writeStr(txt, intString(a_eq2_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;
  end match;
end fun_342;

protected function fun_343
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_eq2_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_eq2_index)
    local
      Tpl.Text txt;
      Integer a_eq2_index;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_eq2_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("SIM_PROF_ACC_EQ("));
        txt = Tpl.writeStr(txt, intString(a_eq2_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;
  end match;
end fun_343;

protected function lm_344
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input Tpl.Text in_a_innerEqns;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_innerEqns;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_innerEqns, out_a_varDecls) :=
  match(in_txt, in_items, in_a_innerEqns, in_a_varDecls)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      Tpl.Text a_innerEqns;
      Tpl.Text a_varDecls;
      Integer x_i0;
      Integer i_eq2_index;
      DAE.Exp i_eq2_exp;
      Boolean ret_3;
      Boolean ret_2;
      Tpl.Text l_expPart;
      Tpl.Text l_preExp;

    case ( txt,
           {},
           a_innerEqns,
           a_varDecls )
      then (txt, a_innerEqns, a_varDecls);

    case ( txt,
           SimCode.SES_RESIDUAL(exp = i_eq2_exp, index = i_eq2_index) :: rest,
           a_innerEqns,
           a_varDecls )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        l_preExp = Tpl.emptyTxt;
        (l_expPart, l_preExp, a_varDecls, a_innerEqns) = CodegenCFunctions.daeExp(Tpl.emptyTxt, i_eq2_exp, SimCodeFunction.contextSimulationDiscrete, l_preExp, a_varDecls, a_innerEqns);
        ret_2 = Config.profileAll();
        txt = fun_342(txt, ret_2, i_eq2_index);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("res["));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = "));
        txt = Tpl.writeText(txt, l_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        ret_3 = Config.profileAll();
        txt = fun_343(txt, ret_3, i_eq2_index);
        txt = Tpl.nextIter(txt);
        (txt, a_innerEqns, a_varDecls) = lm_344(txt, rest, a_innerEqns, a_varDecls);
      then (txt, a_innerEqns, a_varDecls);

    case ( txt,
           _ :: rest,
           a_innerEqns,
           a_varDecls )
      equation
        (txt, a_innerEqns, a_varDecls) = lm_344(txt, rest, a_innerEqns, a_varDecls);
      then (txt, a_innerEqns, a_varDecls);
  end match;
end lm_344;

protected function fun_345
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_a_nls_eqs;
  input Tpl.Text in_a_innerEqns;
  input Tpl.Text in_a_varDecls;
  input list<DAE.ComponentRef> in_a_nls_crefs;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_innerEqns;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_innerEqns, out_a_varDecls) :=
  match(in_txt, in_a_nls_eqs, in_a_innerEqns, in_a_varDecls, in_a_nls_crefs)
    local
      Tpl.Text txt;
      Tpl.Text a_innerEqns;
      Tpl.Text a_varDecls;
      list<DAE.ComponentRef> a_nls_crefs;
      list<SimCode.SimEqSystem> i_nls_eqs;
      list<DAE.ComponentRef> i_alg_knownOutputCrefs;
      Tpl.Text l_known;
      Tpl.Text l_init;

    case ( txt,
           SimCode.SES_INVERSE_ALGORITHM(knownOutputCrefs = i_alg_knownOutputCrefs) :: {},
           a_innerEqns,
           a_varDecls,
           a_nls_crefs )
      equation
        l_init = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_init = lm_340(l_init, a_nls_crefs);
        l_init = Tpl.popIter(l_init);
        l_known = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_known = lm_341(l_known, i_alg_knownOutputCrefs, a_nls_crefs);
        l_known = Tpl.popIter(l_known);
        txt = Tpl.writeText(txt, l_init);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_known);
      then (txt, a_innerEqns, a_varDecls);

    case ( txt,
           i_nls_eqs,
           a_innerEqns,
           a_varDecls,
           _ )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_innerEqns, a_varDecls) = lm_344(txt, i_nls_eqs, a_innerEqns, a_varDecls);
        txt = Tpl.popIter(txt);
      then (txt, a_innerEqns, a_varDecls);
  end match;
end fun_345;

protected function fun_346
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_nls_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_nls_index)
    local
      Tpl.Text txt;
      Integer a_nls_index;

    case ( txt,
           false,
           a_nls_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("int residualFuncConstraints"));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(void** dataIn, const double* xloc, double* res, const int* iflag)"));
      then txt;

    case ( txt,
           _,
           a_nls_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void residualFunc"));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(void** dataIn, const double* xloc, double* res, const int* iflag)"));
      then txt;
  end match;
end fun_346;

protected function fun_347
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("return 0;"));
      then txt;
  end match;
end fun_347;

protected function fun_348
  input Tpl.Text in_txt;
  input Option<Integer> in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;
      Integer i_val;

    case ( txt,
           SOME(i_val) )
      equation
        txt = Tpl.writeStr(txt, intString(i_val));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_348;

protected function fun_349
  input Tpl.Text in_txt;
  input Option<Integer> in_a_clockIndex;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_clockIndex)
    local
      Tpl.Text txt;
      Option<Integer> i_clockIndex;

    case ( txt,
           NONE() )
      then txt;

    case ( txt,
           i_clockIndex )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("const int clockIndex = "));
        txt = fun_348(txt, i_clockIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_349;

protected function fun_350
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_nls_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_nls_index)
    local
      Tpl.Text txt;
      Integer a_nls_index;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_nls_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("SIM_PROF_TICK_EQ("));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;
  end match;
end fun_350;

protected function fun_351
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_nls_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_nls_index)
    local
      Tpl.Text txt;
      Integer a_nls_index;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_nls_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("SIM_PROF_ADD_NCALL_EQ(modelInfoGetEquation(&data->modelData->modelDataXml,"));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(").profileBlockIndex,1);"));
      then txt;
  end match;
end fun_351;

protected function fun_352
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("return 1;"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("return;"));
      then txt;
  end match;
end fun_352;

protected function fun_353
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_nls_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_nls_index)
    local
      Tpl.Text txt;
      Integer a_nls_index;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_nls_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("SIM_PROF_ACC_EQ("));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;
  end match;
end fun_353;

protected function fun_354
  input Tpl.Text in_txt;
  input SimCode.NonlinearSystem in_a_system;
  input String in_a_modelNamePrefix;
  input Integer in_a_whichSet;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_system, in_a_modelNamePrefix, in_a_whichSet)
    local
      Tpl.Text txt;
      String a_modelNamePrefix;
      Integer a_whichSet;
      Option<Integer> i_clockIndex;
      Integer i_nls_index;
      list<DAE.ComponentRef> i_nls_crefs;
      list<SimCode.SimEqSystem> i_nls_eqs;
      Boolean ret_17;
      Boolean ret_16;
      Integer ret_15;
      Integer ret_14;
      Boolean ret_13;
      Boolean ret_12;
      Boolean ret_11;
      Tpl.Text l_returnValue;
      Boolean ret_9;
      Tpl.Text l_residualFunctionHeader;
      Tpl.Text l_body;
      Tpl.Text l_prebody;
      Tpl.Text l_xlocs;
      Tpl.Text l_restoreKnownOutputs;
      Tpl.Text l_backupOutputs;
      Tpl.Text l_innerNLSSystems;
      Tpl.Text l_innerEqns;
      Tpl.Text l_varDecls;

    case ( txt,
           SimCode.NONLINEARSYSTEM(eqs = i_nls_eqs, crefs = i_nls_crefs, index = i_nls_index, clockIndex = i_clockIndex),
           a_modelNamePrefix,
           a_whichSet )
      equation
        l_varDecls = Tpl.emptyTxt;
        l_innerEqns = Tpl.emptyTxt;
        l_innerNLSSystems = functionNonLinearResiduals(Tpl.emptyTxt, i_nls_eqs, a_modelNamePrefix);
        (l_backupOutputs, l_varDecls) = fun_335(Tpl.emptyTxt, i_nls_eqs, l_varDecls);
        l_restoreKnownOutputs = fun_337(Tpl.emptyTxt, i_nls_eqs);
        l_xlocs = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_xlocs = lm_338(l_xlocs, i_nls_crefs);
        l_xlocs = Tpl.popIter(l_xlocs);
        l_prebody = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_prebody, l_innerEqns) = lm_339(l_prebody, i_nls_eqs, a_modelNamePrefix, l_innerEqns);
        l_prebody = Tpl.popIter(l_prebody);
        (l_body, l_innerEqns, l_varDecls) = fun_345(Tpl.emptyTxt, i_nls_eqs, l_innerEqns, l_varDecls, i_nls_crefs);
        ret_9 = intEq(a_whichSet, 0);
        l_residualFunctionHeader = fun_346(Tpl.emptyTxt, ret_9, i_nls_index);
        ret_11 = intEq(a_whichSet, 1);
        l_returnValue = fun_347(Tpl.emptyTxt, ret_11);
        txt = Tpl.writeText(txt, l_innerNLSSystems);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "/* inner equations */\n"
                                }, true));
        txt = Tpl.writeText(txt, l_innerEqns);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_residualFunctionHeader);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "{\n",
                                    "  TRACE_PUSH\n",
                                    "  DATA *data = (DATA*) ((void**)dataIn[0]);\n",
                                    "  threadData_t *threadData = (threadData_t*) ((void**)dataIn[1]);\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("const int equationIndexes[2] = {1,"));
        txt = Tpl.writeStr(txt, intString(i_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "};\n",
                                    "int i;"
                                }, false));
        txt = fun_349(txt, i_clockIndex);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_varDecls);
        txt = Tpl.softNewLine(txt);
        ret_12 = Config.profileAll();
        txt = fun_350(txt, ret_12, i_nls_index);
        txt = Tpl.softNewLine(txt);
        ret_13 = Config.profileSome();
        txt = fun_351(txt, ret_13, i_nls_index);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "/* iteration variables */\n",
                                    "for (i=0; i<"
                                }, false));
        ret_14 = listLength(i_nls_crefs);
        txt = Tpl.writeStr(txt, intString(ret_14));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "; i++) {\n",
                                    "  if (isinf(xloc[i]) || isnan(xloc[i])) {\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("for (i=0; i<"));
        ret_15 = listLength(i_nls_crefs);
        txt = Tpl.writeStr(txt, intString(ret_15));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "; i++) {\n",
                                    "  res[i] = NAN;\n",
                                    "}\n"
                                }, true));
        ret_16 = intEq(a_whichSet, 0);
        txt = fun_352(txt, ret_16);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "  }\n",
                                    "}\n"
                                }, true));
        txt = Tpl.writeText(txt, l_xlocs);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/* backup outputs */\n"));
        txt = Tpl.writeText(txt, l_backupOutputs);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/* pre body */\n"));
        txt = Tpl.writeText(txt, l_prebody);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/* body */\n"));
        txt = Tpl.writeText(txt, l_body);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/* restore known outputs */\n"));
        txt = Tpl.writeText(txt, l_restoreKnownOutputs);
        txt = Tpl.softNewLine(txt);
        ret_17 = Config.profileAll();
        txt = fun_353(txt, ret_17, i_nls_index);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("TRACE_POP\n"));
        txt = Tpl.writeText(txt, l_returnValue);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_354;

public function generateNonLinearResidualFunction
  input Tpl.Text txt;
  input SimCode.NonlinearSystem a_system;
  input String a_modelNamePrefix;
  input Integer a_whichSet;

  output Tpl.Text out_txt;
algorithm
  System.tmpTickReset(0);
  out_txt := fun_354(txt, a_system, a_modelNamePrefix, a_whichSet);
end generateNonLinearResidualFunction;

public function generateStaticEmptySparseData
  input Tpl.Text txt;
  input String a_indexName;
  input String a_systemType;

  output Tpl.Text out_txt;
algorithm
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING("void initializeSparsePattern"));
  out_txt := Tpl.writeStr(out_txt, a_indexName);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("("));
  out_txt := Tpl.writeStr(out_txt, a_systemType);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "* inSysData)\n",
                                       "{\n",
                                       "  /* no sparsity pattern available */\n",
                                       "  inSysData->isPatternAvailable = 0;\n",
                                       "}"
                                   }, false));
end generateStaticEmptySparseData;

protected function fun_357
  input Tpl.Text in_txt;
  input SimCode.SparsityPattern in_a_sparsepattern;
  input String in_a_indexName;
  input String in_a_systemType;
  input list<list<Integer>> in_a_colorList;
  input Integer in_a_maxColor;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_sparsepattern, in_a_indexName, in_a_systemType, in_a_colorList, in_a_maxColor)
    local
      Tpl.Text txt;
      String a_indexName;
      String a_systemType;
      list<list<Integer>> a_colorList;
      Integer a_maxColor;
      SimCode.SparsityPattern i_sparsepattern;
      Tpl.Text l_colorString;
      Integer ret_9;
      list<list<Integer>> ret_8;
      Tpl.Text l_rowIndex;
      Integer ret_6;
      Tpl.Text l_colPtr;
      Integer ret_4;
      Tpl.Text l_sizeleadindex;
      Integer ret_2;
      list<list<Integer>> ret_1;
      Tpl.Text l_sp__size__index;

    case ( txt,
           {},
           a_indexName,
           a_systemType,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void initializeSparsePattern"));
        txt = Tpl.writeStr(txt, a_indexName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeStr(txt, a_systemType);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "* inSysData)\n",
                                    "{\n",
                                    "  /* no sparsity pattern available */\n",
                                    "  inSysData->isPatternAvailable = 0;\n",
                                    "}"
                                }, false));
      then txt;

    case ( txt,
           i_sparsepattern,
           a_indexName,
           a_systemType,
           a_colorList,
           a_maxColor )
      equation
        ret_1 = List.unzipSecond(i_sparsepattern);
        ret_2 = List.lengthListElements(ret_1);
        l_sp__size__index = Tpl.writeStr(Tpl.emptyTxt, intString(ret_2));
        ret_4 = listLength(i_sparsepattern);
        l_sizeleadindex = Tpl.writeStr(Tpl.emptyTxt, intString(ret_4));
        ret_6 = listLength(i_sparsepattern);
        l_colPtr = genSPCRSPtr(Tpl.emptyTxt, ret_6, i_sparsepattern, "colPtrIndex");
        ret_8 = List.unzipSecond(i_sparsepattern);
        ret_9 = List.lengthListElements(ret_8);
        l_rowIndex = genSPCRSRows(Tpl.emptyTxt, ret_9, i_sparsepattern, "rowIndex");
        l_colorString = genSPColors(Tpl.emptyTxt, a_colorList, "inSysData->sparsePattern->colorCols");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void initializeSparsePattern"));
        txt = Tpl.writeStr(txt, a_indexName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeStr(txt, a_systemType);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "* inSysData)\n",
                                    "{\n",
                                    "  int i=0;\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_colPtr);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_rowIndex);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "/* sparsity pattern available */\n",
                                    "inSysData->isPatternAvailable = \'T\';\n",
                                    "inSysData->sparsePattern = (SPARSE_PATTERN*) malloc(sizeof(SPARSE_PATTERN));\n",
                                    "inSysData->sparsePattern->leadindex = (unsigned int*) malloc(("
                                }, false));
        txt = Tpl.writeText(txt, l_sizeleadindex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "+1)*sizeof(unsigned int));\n",
                                    "inSysData->sparsePattern->index = (unsigned int*) malloc("
                                }, false));
        txt = Tpl.writeText(txt, l_sp__size__index);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "*sizeof(unsigned int));\n",
                                    "inSysData->sparsePattern->numberOfNoneZeros = "
                                }, false));
        txt = Tpl.writeText(txt, l_sp__size__index);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "inSysData->sparsePattern->colorCols = (unsigned int*) malloc("
                                }, false));
        txt = Tpl.writeText(txt, l_sizeleadindex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "*sizeof(unsigned int));\n",
                                    "inSysData->sparsePattern->maxColors = "
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_maxColor));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "\n",
                                    "/* write lead index of compressed sparse column */\n",
                                    "memcpy(inSysData->sparsePattern->leadindex, colPtrIndex, ("
                                }, false));
        txt = Tpl.writeText(txt, l_sizeleadindex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "+1)*sizeof(unsigned int));\n",
                                    "\n",
                                    "for(i=2;i<"
                                }, false));
        txt = Tpl.writeText(txt, l_sizeleadindex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "+1;++i)\n",
                                    "  inSysData->sparsePattern->leadindex[i] += inSysData->sparsePattern->leadindex[i-1];\n",
                                    "\n",
                                    "/* call sparse index */\n",
                                    "memcpy(inSysData->sparsePattern->index, rowIndex, "
                                }, false));
        txt = Tpl.writeText(txt, l_sp__size__index);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "*sizeof(unsigned int));\n",
                                    "\n",
                                    "/* write color array */\n"
                                }, true));
        txt = Tpl.writeText(txt, l_colorString);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;
  end match;
end fun_357;

public function generateStaticSparseData
  input Tpl.Text txt;
  input String a_indexName;
  input String a_systemType;
  input SimCode.SparsityPattern a_sparsepattern;
  input list<list<Integer>> a_colorList;
  input Integer a_maxColor;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_357(txt, a_sparsepattern, a_indexName, a_systemType, a_colorList, a_maxColor);
end generateStaticSparseData;

protected function lm_359
  input Tpl.Text in_txt;
  input list<DAE.ComponentRef> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<DAE.ComponentRef> rest;
      DAE.ComponentRef i_cr;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_cr :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/* static nls data for "));
        txt = CodegenUtil.crefStrNoUnderscore(txt, i_cr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " */\n",
                                    "sysData->nominal[i] = "
                                }, false));
        txt = CodegenCFunctions.crefAttributes(txt, i_cr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ".nominal;\n",
                                    "sysData->min[i]     = "
                                }, false));
        txt = CodegenCFunctions.crefAttributes(txt, i_cr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ".min;\n",
                                    "sysData->max[i++]   = "
                                }, false));
        txt = CodegenCFunctions.crefAttributes(txt, i_cr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".max;"));
        txt = Tpl.nextIter(txt);
        txt = lm_359(txt, rest);
      then txt;
  end match;
end lm_359;

public function generateStaticInitialData
  input Tpl.Text txt;
  input list<DAE.ComponentRef> a_crefs;
  input String a_indexName;
  input String a_systemType;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_bodyStaticData;
algorithm
  l_bodyStaticData := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  l_bodyStaticData := lm_359(l_bodyStaticData, a_crefs);
  l_bodyStaticData := Tpl.popIter(l_bodyStaticData);
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING("void initializeStaticData"));
  out_txt := Tpl.writeStr(out_txt, a_indexName);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "(void *inData, threadData_t *threadData, void *inSystemData)\n",
                                       "{\n",
                                       "  DATA* data = (DATA*) inData;\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeStr(out_txt, a_systemType);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("* sysData = ("));
  out_txt := Tpl.writeStr(out_txt, a_systemType);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "*) inSystemData;\n",
                                       "int i=0;\n"
                                   }, true));
  out_txt := Tpl.writeText(out_txt, l_bodyStaticData);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "/* initial sparse pattern */\n",
                                       "initializeSparsePattern"
                                   }, false));
  out_txt := Tpl.writeStr(out_txt, a_indexName);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("(sysData);\n"));
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("}"));
end generateStaticInitialData;

protected function lm_361
  input Tpl.Text in_txt;
  input list<DAE.ComponentRef> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<DAE.ComponentRef> rest;
      Integer x_i0;
      DAE.ComponentRef i_cr;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_cr :: rest )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("array["));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = "));
        txt = CodegenCFunctions.cref(txt, i_cr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        txt = lm_361(txt, rest);
      then txt;
  end match;
end lm_361;

public function getIterationVars
  input Tpl.Text txt;
  input list<DAE.ComponentRef> a_crefs;
  input String a_indexName;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_vars;
algorithm
  l_vars := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  l_vars := lm_361(l_vars, a_crefs);
  l_vars := Tpl.popIter(l_vars);
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                   "\n",
                                   "void getIterationVars"
                               }, false));
  out_txt := Tpl.writeStr(out_txt, a_indexName);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "(struct DATA *inData, double *array)\n",
                                       "{\n",
                                       "  DATA* data = (DATA*) inData;\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeText(out_txt, l_vars);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("}"));
end getIterationVars;

protected function fun_363
  input Tpl.Text in_txt;
  input SimCode.JacobianMatrix in_a_jacobianMatrix;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_jacobianMatrix, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      String a_modelNamePrefix;
      String i_name;

    case ( txt,
           SimCode.JAC_MATRIX(matrixName = i_name),
           a_modelNamePrefix )
      equation
        txt = CodegenUtil.symbolName(txt, a_modelNamePrefix, "functionJac");
        txt = Tpl.writeStr(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_column"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_363;

protected function fun_364
  input Tpl.Text in_txt;
  input SimCode.JacobianMatrix in_a_jacobianMatrix;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_jacobianMatrix, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      String a_modelNamePrefix;
      String i_name;

    case ( txt,
           SimCode.JAC_MATRIX(matrixName = i_name),
           a_modelNamePrefix )
      equation
        txt = CodegenUtil.symbolName(txt, a_modelNamePrefix, "initialAnalyticJacobian");
        txt = Tpl.writeStr(txt, i_name);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_364;

protected function fun_365
  input Tpl.Text in_txt;
  input SimCode.JacobianMatrix in_a_jacobianMatrix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_jacobianMatrix)
    local
      Tpl.Text txt;
      Integer i_jacindex;

    case ( txt,
           SimCode.JAC_MATRIX(jacobianIndex = i_jacindex) )
      equation
        txt = Tpl.writeStr(txt, intString(i_jacindex));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_365;

protected function lm_366
  input Tpl.Text in_txt;
  input list<DAE.ComponentRef> in_items;
  input Integer in_a_i1;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_i1)
    local
      Tpl.Text txt;
      list<DAE.ComponentRef> rest;
      Integer a_i1;
      Integer x_i2;
      DAE.ComponentRef i_s;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_s :: rest,
           a_i1 )
      equation
        x_i2 = Tpl.getIteri_i0(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("statesetData["));
        txt = Tpl.writeStr(txt, intString(a_i1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].states["));
        txt = Tpl.writeStr(txt, intString(x_i2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = &"));
        txt = CodegenCFunctions.crefVarInfo(txt, i_s);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        txt = lm_366(txt, rest, a_i1);
      then txt;
  end match;
end lm_366;

protected function lm_367
  input Tpl.Text in_txt;
  input list<DAE.ComponentRef> in_items;
  input Integer in_a_i1;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_i1)
    local
      Tpl.Text txt;
      list<DAE.ComponentRef> rest;
      Integer a_i1;
      Integer x_i2;
      DAE.ComponentRef i_cstate;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_cstate :: rest,
           a_i1 )
      equation
        x_i2 = Tpl.getIteri_i0(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("statesetData["));
        txt = Tpl.writeStr(txt, intString(a_i1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].statescandidates["));
        txt = Tpl.writeStr(txt, intString(x_i2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = &"));
        txt = CodegenCFunctions.crefVarInfo(txt, i_cstate);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        txt = lm_367(txt, rest, a_i1);
      then txt;
  end match;
end lm_367;

protected function fun_368
  input Tpl.Text in_txt;
  input SimCode.StateSet in_a_set;
  input Integer in_a_i1;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_set, in_a_i1, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      Integer a_i1;
      String a_modelNamePrefix;
      DAE.ComponentRef i_crA;
      Integer i_nStates;
      Integer i_nCandidates;
      list<DAE.ComponentRef> i_statescandidates;
      list<DAE.ComponentRef> i_states;
      SimCode.JacobianMatrix i_jacobianMatrix;
      Tpl.Text l_statescandidatesvars;
      Tpl.Text l_statesvars;
      Tpl.Text l_jacIndex;
      Tpl.Text l_initialJac;
      Tpl.Text l_generatedJac;

    case ( txt,
           SimCode.SES_STATESET(jacobianMatrix = i_jacobianMatrix, states = i_states, statescandidates = i_statescandidates, nCandidates = i_nCandidates, nStates = i_nStates, crA = i_crA),
           a_i1,
           a_modelNamePrefix )
      equation
        l_generatedJac = fun_363(Tpl.emptyTxt, i_jacobianMatrix, a_modelNamePrefix);
        l_initialJac = fun_364(Tpl.emptyTxt, i_jacobianMatrix, a_modelNamePrefix);
        l_jacIndex = fun_365(Tpl.emptyTxt, i_jacobianMatrix);
        l_statesvars = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_statesvars = lm_366(l_statesvars, i_states, a_i1);
        l_statesvars = Tpl.popIter(l_statesvars);
        l_statescandidatesvars = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_statescandidatesvars = lm_367(l_statescandidatesvars, i_statescandidates, a_i1);
        l_statescandidatesvars = Tpl.popIter(l_statescandidatesvars);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("assertStreamPrint(NULL, nStateSets > "));
        txt = Tpl.writeStr(txt, intString(a_i1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ", \"Internal Error: nStateSets mismatch!\");\n",
                                    "statesetData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_i1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].nCandidates = "));
        txt = Tpl.writeStr(txt, intString(i_nCandidates));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "statesetData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_i1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].nStates = "));
        txt = Tpl.writeStr(txt, intString(i_nStates));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "statesetData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_i1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].nDummyStates = "));
        txt = Tpl.writeStr(txt, intString(i_nCandidates));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-"));
        txt = Tpl.writeStr(txt, intString(i_nStates));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "statesetData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_i1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].states = (VAR_INFO**) calloc("));
        txt = Tpl.writeStr(txt, intString(i_nStates));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",sizeof(VAR_INFO));\n"));
        txt = Tpl.writeText(txt, l_statesvars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("statesetData["));
        txt = Tpl.writeStr(txt, intString(a_i1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].statescandidates = (VAR_INFO**) calloc("));
        txt = Tpl.writeStr(txt, intString(i_nCandidates));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",sizeof(VAR_INFO));\n"));
        txt = Tpl.writeText(txt, l_statescandidatesvars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("statesetData["));
        txt = Tpl.writeStr(txt, intString(a_i1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].A = &"));
        txt = CodegenCFunctions.crefVarInfo(txt, i_crA);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "statesetData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_i1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].rowPivot = (modelica_integer*) calloc("));
        txt = Tpl.writeStr(txt, intString(i_nCandidates));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-"));
        txt = Tpl.writeStr(txt, intString(i_nStates));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ",sizeof(modelica_integer));\n",
                                    "statesetData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_i1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].colPivot = (modelica_integer*) calloc("));
        txt = Tpl.writeStr(txt, intString(i_nCandidates));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ",sizeof(modelica_integer));\n",
                                    "statesetData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_i1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].J = (modelica_real*) calloc("));
        txt = Tpl.writeStr(txt, intString(i_nCandidates));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("*("));
        txt = Tpl.writeStr(txt, intString(i_nCandidates));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-"));
        txt = Tpl.writeStr(txt, intString(i_nStates));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "),sizeof(modelica_real));\n",
                                    "statesetData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_i1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].analyticalJacobianColumn = "));
        txt = Tpl.writeText(txt, l_generatedJac);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "statesetData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_i1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].initialAnalyticalJacobian = "));
        txt = Tpl.writeText(txt, l_initialJac);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "statesetData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_i1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].jacobianIndex = "));
        txt = Tpl.writeText(txt, l_jacIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "\n"
                                }, true));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_368;

protected function lm_369
  input Tpl.Text in_txt;
  input list<SimCode.StateSet> in_items;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      list<SimCode.StateSet> rest;
      String a_modelNamePrefix;
      Integer x_i1;
      SimCode.StateSet i_set;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_set :: rest,
           a_modelNamePrefix )
      equation
        x_i1 = Tpl.getIteri_i0(txt);
        txt = fun_368(txt, i_set, x_i1, a_modelNamePrefix);
        txt = Tpl.nextIter(txt);
        txt = lm_369(txt, rest, a_modelNamePrefix);
      then txt;
  end match;
end lm_369;

public function functionInitialStateSets
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input list<SimCode.StateSet> a_stateSets;
  input String a_modelNamePrefix;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_body;
algorithm
  l_body := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING_LIST({
                                                                            "\n",
                                                                            "\n"
                                                                        }, true)), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  l_body := lm_369(l_body, a_stateSets, a_modelNamePrefix);
  l_body := Tpl.popIter(l_body);
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                   "/* funtion initialize state sets */\n",
                                   "void "
                               }, false));
  out_txt := CodegenUtil.symbolName(out_txt, a_modelNamePrefix, "initializeStateSets");
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "(int nStateSets, STATE_SET_DATA* statesetData, DATA *data)\n",
                                       "{\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeText(out_txt, l_body);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("}"));
end functionInitialStateSets;

protected function lm_371
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      String a_modelNamePrefix;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           (i_eq as SimCode.SES_SIMPLE_ASSIGN(index = _)) :: rest,
           a_modelNamePrefix )
      equation
        txt = equation_impl_options(txt, -1, i_eq, SimCodeFunction.contextOther, a_modelNamePrefix, true, true, true);
        txt = Tpl.nextIter(txt);
        txt = lm_371(txt, rest, a_modelNamePrefix);
      then txt;

    case ( txt,
           _ :: rest,
           a_modelNamePrefix )
      equation
        txt = lm_371(txt, rest, a_modelNamePrefix);
      then txt;
  end match;
end lm_371;

protected function lm_372
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      String a_modelNamePrefix;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           (i_eq as SimCode.SES_SIMPLE_ASSIGN(index = _)) :: rest,
           a_modelNamePrefix )
      equation
        txt = equation_impl_options(txt, -1, i_eq, SimCodeFunction.contextOther, a_modelNamePrefix, true, true, true);
        txt = Tpl.nextIter(txt);
        txt = lm_372(txt, rest, a_modelNamePrefix);
      then txt;

    case ( txt,
           _ :: rest,
           a_modelNamePrefix )
      equation
        txt = lm_372(txt, rest, a_modelNamePrefix);
      then txt;
  end match;
end lm_372;

protected function lm_373
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      String a_modelNamePrefix;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           (i_eq as SimCode.SES_SIMPLE_ASSIGN(index = _)) :: rest,
           a_modelNamePrefix )
      equation
        txt = equation_impl_options(txt, -1, i_eq, SimCodeFunction.contextOther, a_modelNamePrefix, true, true, true);
        txt = Tpl.nextIter(txt);
        txt = lm_373(txt, rest, a_modelNamePrefix);
      then txt;

    case ( txt,
           _ :: rest,
           a_modelNamePrefix )
      equation
        txt = lm_373(txt, rest, a_modelNamePrefix);
      then txt;
  end match;
end lm_373;

protected function lm_374
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      String a_modelNamePrefix;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           (i_eq as SimCode.SES_SIMPLE_ASSIGN(index = _)) :: rest,
           a_modelNamePrefix )
      equation
        txt = equation_impl_options(txt, -1, i_eq, SimCodeFunction.contextOther, a_modelNamePrefix, true, true, true);
        txt = Tpl.nextIter(txt);
        txt = lm_374(txt, rest, a_modelNamePrefix);
      then txt;

    case ( txt,
           _ :: rest,
           a_modelNamePrefix )
      equation
        txt = lm_374(txt, rest, a_modelNamePrefix);
      then txt;
  end match;
end lm_374;

protected function lm_375
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      String a_modelNamePrefix;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           (i_eq as SimCode.SES_SIMPLE_ASSIGN(index = _)) :: rest,
           a_modelNamePrefix )
      equation
        txt = equation_call(txt, i_eq, a_modelNamePrefix);
        txt = Tpl.nextIter(txt);
        txt = lm_375(txt, rest, a_modelNamePrefix);
      then txt;

    case ( txt,
           _ :: rest,
           a_modelNamePrefix )
      equation
        txt = lm_375(txt, rest, a_modelNamePrefix);
      then txt;
  end match;
end lm_375;

protected function lm_376
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      DAE.ComponentRef i_cref;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           SimCode.SES_SIMPLE_ASSIGN(cref = i_cref) :: rest )
      equation
        txt = CodegenCFunctions.crefAttributes(txt, i_cref);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".min = "));
        txt = CodegenCFunctions.cref(txt, i_cref);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("infoStreamPrint(LOG_INIT_V, 0, \"%s(min="));
        txt = crefToPrintfArg(txt, i_cref);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")\", "));
        txt = CodegenCFunctions.crefVarInfo(txt, i_cref);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".name, ("));
        txt = crefType(txt, i_cref);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") "));
        txt = CodegenCFunctions.crefAttributes(txt, i_cref);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(".min);\n"));
        txt = Tpl.popBlock(txt);
        txt = CodegenCFunctions.cref(txt, i_cref);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = CodegenCFunctions.crefAttributes(txt, i_cref);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".start;"));
        txt = Tpl.nextIter(txt);
        txt = lm_376(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_376(txt, rest);
      then txt;
  end match;
end lm_376;

protected function lm_377
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      String a_modelNamePrefix;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           (i_eq as SimCode.SES_SIMPLE_ASSIGN(index = _)) :: rest,
           a_modelNamePrefix )
      equation
        txt = equation_call(txt, i_eq, a_modelNamePrefix);
        txt = Tpl.nextIter(txt);
        txt = lm_377(txt, rest, a_modelNamePrefix);
      then txt;

    case ( txt,
           _ :: rest,
           a_modelNamePrefix )
      equation
        txt = lm_377(txt, rest, a_modelNamePrefix);
      then txt;
  end match;
end lm_377;

protected function lm_378
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      DAE.ComponentRef i_cref;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           SimCode.SES_SIMPLE_ASSIGN(cref = i_cref) :: rest )
      equation
        txt = CodegenCFunctions.crefAttributes(txt, i_cref);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".max = "));
        txt = CodegenCFunctions.cref(txt, i_cref);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("infoStreamPrint(LOG_INIT_V, 0, \"%s(max="));
        txt = crefToPrintfArg(txt, i_cref);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")\", "));
        txt = CodegenCFunctions.crefVarInfo(txt, i_cref);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".name, ("));
        txt = crefType(txt, i_cref);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") "));
        txt = CodegenCFunctions.crefAttributes(txt, i_cref);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(".max);\n"));
        txt = Tpl.popBlock(txt);
        txt = CodegenCFunctions.cref(txt, i_cref);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = CodegenCFunctions.crefAttributes(txt, i_cref);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".start;"));
        txt = Tpl.nextIter(txt);
        txt = lm_378(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_378(txt, rest);
      then txt;
  end match;
end lm_378;

protected function lm_379
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      String a_modelNamePrefix;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           (i_eq as SimCode.SES_SIMPLE_ASSIGN(index = _)) :: rest,
           a_modelNamePrefix )
      equation
        txt = equation_call(txt, i_eq, a_modelNamePrefix);
        txt = Tpl.nextIter(txt);
        txt = lm_379(txt, rest, a_modelNamePrefix);
      then txt;

    case ( txt,
           _ :: rest,
           a_modelNamePrefix )
      equation
        txt = lm_379(txt, rest, a_modelNamePrefix);
      then txt;
  end match;
end lm_379;

protected function lm_380
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      DAE.ComponentRef i_cref;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           SimCode.SES_SIMPLE_ASSIGN(cref = i_cref) :: rest )
      equation
        txt = CodegenCFunctions.crefAttributes(txt, i_cref);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".nominal = "));
        txt = CodegenCFunctions.cref(txt, i_cref);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("infoStreamPrint(LOG_INIT_V, 0, \"%s(nominal="));
        txt = crefToPrintfArg(txt, i_cref);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")\", "));
        txt = CodegenCFunctions.crefVarInfo(txt, i_cref);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".name, ("));
        txt = crefType(txt, i_cref);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") "));
        txt = CodegenCFunctions.crefAttributes(txt, i_cref);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(".nominal);\n"));
        txt = Tpl.popBlock(txt);
        txt = CodegenCFunctions.cref(txt, i_cref);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = CodegenCFunctions.crefAttributes(txt, i_cref);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".start;"));
        txt = Tpl.nextIter(txt);
        txt = lm_380(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_380(txt, rest);
      then txt;
  end match;
end lm_380;

protected function lm_381
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      String a_modelNamePrefix;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           (i_eq as SimCode.SES_SIMPLE_ASSIGN(index = _)) :: rest,
           a_modelNamePrefix )
      equation
        txt = equation_call(txt, i_eq, a_modelNamePrefix);
        txt = Tpl.nextIter(txt);
        txt = lm_381(txt, rest, a_modelNamePrefix);
      then txt;

    case ( txt,
           _ :: rest,
           a_modelNamePrefix )
      equation
        txt = lm_381(txt, rest, a_modelNamePrefix);
      then txt;
  end match;
end lm_381;

public function functionUpdateBoundVariableAttributes
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input list<SimCode.SimEqSystem> a_startValueEquations;
  input list<SimCode.SimEqSystem> a_nominalValueEquations;
  input list<SimCode.SimEqSystem> a_minValueEquations;
  input list<SimCode.SimEqSystem> a_maxValueEquations;
  input String a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt := Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_371(out_txt, a_startValueEquations, a_modelNamePrefix);
  out_txt := Tpl.popIter(out_txt);
  out_txt := Tpl.pushIter(out_txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_372(out_txt, a_nominalValueEquations, a_modelNamePrefix);
  out_txt := Tpl.popIter(out_txt);
  out_txt := Tpl.pushIter(out_txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_373(out_txt, a_minValueEquations, a_modelNamePrefix);
  out_txt := Tpl.popIter(out_txt);
  out_txt := Tpl.pushIter(out_txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_374(out_txt, a_maxValueEquations, a_modelNamePrefix);
  out_txt := Tpl.popIter(out_txt);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "OMC_DISABLE_OPT\n",
                                       "int "
                                   }, false));
  out_txt := CodegenUtil.symbolName(out_txt, a_modelNamePrefix, "updateBoundVariableAttributes");
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "(DATA *data, threadData_t *threadData)\n",
                                       "{\n",
                                       "  TRACE_PUSH\n",
                                       "  /* min ******************************************************** */\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.pushIter(out_txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_375(out_txt, a_minValueEquations, a_modelNamePrefix);
  out_txt := Tpl.popIter(out_txt);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "infoStreamPrint(LOG_INIT, 1, \"updating min-values\");\n"
                                   }, true));
  out_txt := Tpl.pushIter(out_txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_376(out_txt, a_minValueEquations);
  out_txt := Tpl.popIter(out_txt);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "if (ACTIVE_STREAM(LOG_INIT)) messageClose(LOG_INIT);\n",
                                       "\n",
                                       "/* max ******************************************************** */\n"
                                   }, true));
  out_txt := Tpl.pushIter(out_txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_377(out_txt, a_maxValueEquations, a_modelNamePrefix);
  out_txt := Tpl.popIter(out_txt);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "infoStreamPrint(LOG_INIT, 1, \"updating max-values\");\n"
                                   }, true));
  out_txt := Tpl.pushIter(out_txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_378(out_txt, a_maxValueEquations);
  out_txt := Tpl.popIter(out_txt);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "if (ACTIVE_STREAM(LOG_INIT)) messageClose(LOG_INIT);\n",
                                       "\n",
                                       "/* nominal **************************************************** */\n"
                                   }, true));
  out_txt := Tpl.pushIter(out_txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_379(out_txt, a_nominalValueEquations, a_modelNamePrefix);
  out_txt := Tpl.popIter(out_txt);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "infoStreamPrint(LOG_INIT, 1, \"updating nominal-values\");\n"
                                   }, true));
  out_txt := Tpl.pushIter(out_txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_380(out_txt, a_nominalValueEquations);
  out_txt := Tpl.popIter(out_txt);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "if (ACTIVE_STREAM(LOG_INIT)) messageClose(LOG_INIT);\n",
                                       "\n",
                                       "/* start ****************************************************** */\n",
                                       "infoStreamPrint(LOG_INIT, 1, \"updating primary start-values\");\n"
                                   }, true));
  out_txt := Tpl.pushIter(out_txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_381(out_txt, a_startValueEquations, a_modelNamePrefix);
  out_txt := Tpl.popIter(out_txt);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "if (ACTIVE_STREAM(LOG_INIT)) messageClose(LOG_INIT);\n",
                                       "\n",
                                       "TRACE_POP\n",
                                       "return 0;\n"
                                   }, true));
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("}"));
end functionUpdateBoundVariableAttributes;

protected function fun_383
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_mArg;
  input DAE.ComponentRef in_a_cref;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_cref)
    local
      Tpl.Text txt;
      DAE.ComponentRef a_cref;
      Integer i_index;
      DAE.Type i_type__;
      Tpl.Text txt_0;

    case ( txt,
           SimCodeVar.SIMVAR(aliasvar = SimCodeVar.NOALIAS(), varKind = BackendDAE.PARAM(), type_ = i_type__, index = i_index),
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("data->modelData->"));
        txt = CodegenCFunctions.expTypeShort(txt, i_type__);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("ParameterData["));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].time_unvarying = 1;"));
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(aliasvar = SimCodeVar.NOALIAS(), type_ = i_type__, index = i_index),
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("data->modelData->"));
        txt = CodegenCFunctions.expTypeShort(txt, i_type__);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("VarsData["));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].time_unvarying = 1;"));
      then txt;

    case ( txt,
           _,
           a_cref )
      equation
        txt_0 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("Cannot get attributes of alias variable "));
        txt_0 = CodegenUtil.crefStr(txt_0, a_cref);
        txt_0 = Tpl.writeTok(txt_0, Tpl.ST_STRING(". Alias variables should have been replaced by the compiler before SimCode"));
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 3119, 20), Tpl.textString(txt_0));
      then txt;
  end match;
end fun_383;

protected function lm_384
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      SimCode.SimCode a_simCode;
      DAE.Exp i_exp;
      DAE.ComponentRef i_cref;
      SimCodeVar.SimVar ret_0;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           SimCode.SES_SIMPLE_ASSIGN(cref = i_cref, exp = i_exp) :: rest,
           a_simCode )
      equation
        txt = CodegenCFunctions.cref(txt, i_cref);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = CodegenCFunctions.daeExpSimpleLiteral(txt, i_exp);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        ret_0 = SimCodeUtil.cref2simvar(i_cref, a_simCode);
        txt = fun_383(txt, ret_0, i_cref);
        txt = Tpl.nextIter(txt);
        txt = lm_384(txt, rest, a_simCode);
      then txt;

    case ( txt,
           _ :: rest,
           a_simCode )
      equation
        txt = lm_384(txt, rest, a_simCode);
      then txt;
  end match;
end lm_384;

public function functionUpdateBoundParameters
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_simpleParameterEquations;
  input list<SimCode.SimEqSystem> a_parameterEquations;
  input String a_fileNamePrefix;
  input String a_fullPathPrefix;
  input String a_modelNamePrefix;
  input SimCode.SimCode a_simCode;

  output Tpl.Text out_txt;
protected
  list<SimCode.SimEqSystem> ret_5;
  Integer ret_4;
  Integer ret_3;
  Tpl.Text l_fncalls;
  Tpl.Text l_auxFunction;
  Tpl.Text l_eqFuncs;
algorithm
  l_eqFuncs := Tpl.emptyTxt;
  l_auxFunction := Tpl.emptyTxt;
  ret_3 := listLength(a_parameterEquations);
  ret_4 := Flags.getConfigInt(Flags.EQUATIONS_PER_FILE);
  (l_fncalls, l_eqFuncs) := functionEquationsMultiFiles(Tpl.emptyTxt, a_parameterEquations, ret_3, ret_4, a_fileNamePrefix, a_fullPathPrefix, a_modelNamePrefix, "updateBoundParameters", "08bnd", l_eqFuncs, true, true, false);
  out_txt := Tpl.writeText(txt, l_eqFuncs);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "OMC_DISABLE_OPT\n",
                                       "int "
                                   }, false));
  out_txt := CodegenUtil.symbolName(out_txt, a_modelNamePrefix, "updateBoundParameters");
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "(DATA *data, threadData_t *threadData)\n",
                                       "{\n",
                                       "  TRACE_PUSH\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  ret_5 := SimCodeUtil.sortSimpleAssignmentBasedOnLhs(a_simpleParameterEquations);
  out_txt := Tpl.pushIter(out_txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_384(out_txt, ret_5, a_simCode);
  out_txt := Tpl.popIter(out_txt);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeText(out_txt, l_fncalls);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "TRACE_POP\n",
                                       "return 0;\n"
                                   }, true));
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("}"));
end functionUpdateBoundParameters;

protected function fun_386
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("x"));
      then txt;
  end match;
end fun_386;

protected function fun_387
  input Tpl.Text in_txt;
  input Tpl.Text in_a_multiFile;
  input String in_a_fullPathPrefix;
  input String in_a_partName;
  input String in_a_fileNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_multiFile, in_a_fullPathPrefix, in_a_partName, in_a_fileNamePrefix)
    local
      Tpl.Text txt;
      String a_fullPathPrefix;
      String a_partName;
      String a_fileNamePrefix;
      Tpl.Text txt_3;
      String ret_2;
      Tpl.Text txt_1;
      Tpl.Text l_fileName;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           _,
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_fullPathPrefix,
           a_partName,
           a_fileNamePrefix )
      equation
        txt_1 = Tpl.writeStr(Tpl.emptyTxt, a_fileNamePrefix);
        txt_1 = Tpl.writeTok(txt_1, Tpl.ST_STRING("_"));
        txt_1 = Tpl.writeStr(txt_1, a_partName);
        txt_1 = Tpl.writeTok(txt_1, Tpl.ST_STRING("_part"));
        ret_2 = SimCodeUtil.addFunctionIndex(Tpl.textString(txt_1), ".c");
        l_fileName = Tpl.writeStr(Tpl.emptyTxt, ret_2);
        txt_3 = Tpl.writeStr(Tpl.emptyTxt, a_fullPathPrefix);
        txt_3 = Tpl.writeText(txt_3, l_fileName);
        txt = Tpl.redirectToFile(txt, Tpl.textString(txt_3));
        txt = simulationFileHeader(txt, a_fileNamePrefix);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "#if defined(__cplusplus)\n",
                                    "extern \"C\" {\n",
                                    "#endif"
                                }, false));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;
  end match;
end fun_387;

protected function lm_388
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input Boolean in_a_init;
  input Boolean in_a_noOpt;
  input Boolean in_a_static;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_init, in_a_noOpt, in_a_static, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      Boolean a_init;
      Boolean a_noOpt;
      Boolean a_static;
      String a_modelNamePrefix;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           {},
           _,
           _,
           _,
           _ )
      then txt;

    case ( txt,
           i_eq :: rest,
           a_init,
           a_noOpt,
           a_static,
           a_modelNamePrefix )
      equation
        txt = equation_impl_options(txt, -1, i_eq, SimCodeFunction.contextSimulationDiscrete, a_modelNamePrefix, a_static, a_noOpt, a_init);
        txt = Tpl.nextIter(txt);
        txt = lm_388(txt, rest, a_init, a_noOpt, a_static, a_modelNamePrefix);
      then txt;
  end match;
end lm_388;

protected function lm_389
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      String a_modelNamePrefix;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_eq :: rest,
           a_modelNamePrefix )
      equation
        txt = equation_call(txt, i_eq, a_modelNamePrefix);
        txt = lm_389(txt, rest, a_modelNamePrefix);
      then txt;
  end match;
end lm_389;

protected function fun_390
  input Tpl.Text in_txt;
  input Tpl.Text in_a_multiFile;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_multiFile)
    local
      Tpl.Text txt;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}) )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "#if defined(__cplusplus)\n",
                                    "}\n",
                                    "#endif"
                                }, false));
        txt = Tpl.closeFile(txt);
      then txt;
  end match;
end fun_390;

protected function lm_391
  input Tpl.Text in_txt;
  input list<list<SimCode.SimEqSystem>> in_items;
  input Boolean in_a_init;
  input Boolean in_a_noOpt;
  input Boolean in_a_static;
  input String in_a_fullPathPrefix;
  input String in_a_partName;
  input String in_a_fileNamePrefix;
  input Tpl.Text in_a_multiFile;
  input Tpl.Text in_a_file;
  input Tpl.Text in_a_eqFuncs;
  input String in_a_funcName;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_file;
  output Tpl.Text out_a_eqFuncs;
algorithm
  (out_txt, out_a_file, out_a_eqFuncs) :=
  match(in_txt, in_items, in_a_init, in_a_noOpt, in_a_static, in_a_fullPathPrefix, in_a_partName, in_a_fileNamePrefix, in_a_multiFile, in_a_file, in_a_eqFuncs, in_a_funcName, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      list<list<SimCode.SimEqSystem>> rest;
      Boolean a_init;
      Boolean a_noOpt;
      Boolean a_static;
      String a_fullPathPrefix;
      String a_partName;
      String a_fileNamePrefix;
      Tpl.Text a_multiFile;
      Tpl.Text a_file;
      Tpl.Text a_eqFuncs;
      String a_funcName;
      String a_modelNamePrefix;
      Integer x_i0;
      list<SimCode.SimEqSystem> i_eqs;
      Tpl.Text txt_1;
      Tpl.Text l_name;

    case ( txt,
           {},
           _,
           _,
           _,
           _,
           _,
           _,
           _,
           a_file,
           a_eqFuncs,
           _,
           _ )
      then (txt, a_file, a_eqFuncs);

    case ( txt,
           i_eqs :: rest,
           a_init,
           a_noOpt,
           a_static,
           a_fullPathPrefix,
           a_partName,
           a_fileNamePrefix,
           a_multiFile,
           a_file,
           a_eqFuncs,
           a_funcName,
           a_modelNamePrefix )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt_1 = Tpl.writeStr(Tpl.emptyTxt, a_funcName);
        txt_1 = Tpl.writeTok(txt_1, Tpl.ST_STRING("_"));
        txt_1 = Tpl.writeStr(txt_1, intString(x_i0));
        l_name = CodegenUtil.symbolName(Tpl.emptyTxt, a_modelNamePrefix, Tpl.textString(txt_1));
        a_eqFuncs = Tpl.writeTok(a_eqFuncs, Tpl.ST_STRING("void "));
        a_eqFuncs = Tpl.writeText(a_eqFuncs, l_name);
        a_eqFuncs = Tpl.writeTok(a_eqFuncs, Tpl.ST_STRING("(DATA *data, threadData_t *threadData);"));
        a_eqFuncs = Tpl.writeTok(a_eqFuncs, Tpl.ST_NEW_LINE());
        a_file = fun_387(a_file, a_multiFile, a_fullPathPrefix, a_partName, a_fileNamePrefix);
        a_file = Tpl.pushIter(a_file, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        a_file = lm_388(a_file, i_eqs, a_init, a_noOpt, a_static, a_modelNamePrefix);
        a_file = Tpl.popIter(a_file);
        a_file = Tpl.writeTok(a_file, Tpl.ST_STRING_LIST({
                                          "\n",
                                          "OMC_DISABLE_OPT\n",
                                          "void "
                                      }, false));
        a_file = Tpl.writeText(a_file, l_name);
        a_file = Tpl.writeTok(a_file, Tpl.ST_STRING_LIST({
                                          "(DATA *data, threadData_t *threadData)\n",
                                          "{\n",
                                          "  TRACE_PUSH\n"
                                      }, true));
        a_file = Tpl.pushBlock(a_file, Tpl.BT_INDENT(2));
        a_file = lm_389(a_file, i_eqs, a_modelNamePrefix);
        a_file = Tpl.softNewLine(a_file);
        a_file = Tpl.writeTok(a_file, Tpl.ST_LINE("TRACE_POP\n"));
        a_file = Tpl.popBlock(a_file);
        a_file = Tpl.writeTok(a_file, Tpl.ST_STRING("}"));
        a_file = fun_390(a_file, a_multiFile);
        txt = Tpl.writeText(txt, l_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(data, threadData);"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.nextIter(txt);
        (txt, a_file, a_eqFuncs) = lm_391(txt, rest, a_init, a_noOpt, a_static, a_fullPathPrefix, a_partName, a_fileNamePrefix, a_multiFile, a_file, a_eqFuncs, a_funcName, a_modelNamePrefix);
      then (txt, a_file, a_eqFuncs);
  end match;
end lm_391;

public function functionEquationsMultiFiles
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_inEqs;
  input Integer a_numEqs;
  input Integer a_equationsPerFile;
  input String a_fileNamePrefix;
  input String a_fullPathPrefix;
  input String a_modelNamePrefix;
  input String a_funcName;
  input String a_partName;
  input Tpl.Text a_eqFuncs;
  input Boolean a_static;
  input Boolean a_noOpt;
  input Boolean a_init;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_eqFuncs;
protected
  list<list<SimCode.SimEqSystem>> ret_4;
  Tpl.Text l_fncalls;
  Boolean ret_2;
  Tpl.Text l_multiFile;
  Tpl.Text l_file;
algorithm
  System.tmpTickReset(0);
  l_file := Tpl.emptyTxt;
  ret_2 := intGt(a_numEqs, a_equationsPerFile);
  l_multiFile := fun_386(Tpl.emptyTxt, ret_2);
  ret_4 := List.balancedPartition(a_inEqs, a_equationsPerFile);
  l_fncalls := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), NONE(), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (l_fncalls, l_file, out_a_eqFuncs) := lm_391(l_fncalls, ret_4, a_init, a_noOpt, a_static, a_fullPathPrefix, a_partName, a_fileNamePrefix, l_multiFile, l_file, a_eqFuncs, a_funcName, a_modelNamePrefix);
  l_fncalls := Tpl.popIter(l_fncalls);
  out_a_eqFuncs := Tpl.writeText(out_a_eqFuncs, l_file);
  out_txt := Tpl.writeText(txt, l_fncalls);
end functionEquationsMultiFiles;

public function functionInitialEquations
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_initalEquations;
  input Integer a_numInitialEquations;
  input String a_fileNamePrefix;
  input String a_fullPathPrefix;
  input String a_modelNamePrefix;
  input Boolean a_init;

  output Tpl.Text out_txt;
protected
  Integer ret_2;
  Tpl.Text l_fncalls;
  Tpl.Text l_eqfuncs;
algorithm
  System.tmpTickReset(0);
  l_eqfuncs := Tpl.emptyTxt;
  ret_2 := Flags.getConfigInt(Flags.EQUATIONS_PER_FILE);
  (l_fncalls, l_eqfuncs) := functionEquationsMultiFiles(Tpl.emptyTxt, a_initalEquations, a_numInitialEquations, ret_2, a_fileNamePrefix, a_fullPathPrefix, a_modelNamePrefix, "functionInitialEquations", "06inz", l_eqfuncs, false, false, a_init);
  out_txt := Tpl.writeText(txt, l_eqfuncs);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "int "
                                   }, false));
  out_txt := CodegenUtil.symbolName(out_txt, a_modelNamePrefix, "functionInitialEquations");
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "(DATA *data, threadData_t *threadData)\n",
                                       "{\n",
                                       "  TRACE_PUSH\n",
                                       "\n",
                                       "  data->simulationInfo->discreteCall = 1;\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeText(out_txt, l_fncalls);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "data->simulationInfo->discreteCall = 0;\n",
                                       "\n",
                                       "TRACE_POP\n",
                                       "return 0;\n"
                                   }, true));
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("}"));
end functionInitialEquations;

protected function lm_394
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      String a_modelNamePrefix;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_eq :: rest,
           a_modelNamePrefix )
      equation
        txt = equation_impl(txt, -1, i_eq, SimCodeFunction.contextSimulationDiscrete, a_modelNamePrefix, true);
        txt = Tpl.nextIter(txt);
        txt = lm_394(txt, rest, a_modelNamePrefix);
      then txt;
  end match;
end lm_394;

protected function lm_395
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      String a_modelNamePrefix;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_eq :: rest,
           a_modelNamePrefix )
      equation
        txt = equation_call(txt, i_eq, a_modelNamePrefix);
        txt = Tpl.nextIter(txt);
        txt = lm_395(txt, rest, a_modelNamePrefix);
      then txt;
  end match;
end lm_395;

public function functionInitialEquations_lambda0
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_a_initalEquations__lambda0;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_initalEquations__lambda0, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      String a_modelNamePrefix;
      list<SimCode.SimEqSystem> i_initalEquations__lambda0;
      Tpl.Text l_fncalls;
      Tpl.Text l_eqfuncs;
      Integer ret_1;
      Tpl.Text l_nrfuncs;

    case ( txt,
           {},
           a_modelNamePrefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "/* No "
                                }, false));
        txt = CodegenUtil.symbolName(txt, a_modelNamePrefix, "functionInitialEquations_lambda0");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " function */\n",
                                    "\n"
                                }, true));
      then txt;

    case ( txt,
           i_initalEquations__lambda0,
           a_modelNamePrefix )
      equation
        System.tmpTickReset(0);
        ret_1 = listLength(i_initalEquations__lambda0);
        l_nrfuncs = Tpl.writeStr(Tpl.emptyTxt, intString(ret_1));
        l_eqfuncs = Tpl.emptyTxt;
        l_eqfuncs = Tpl.pushIter(l_eqfuncs, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_eqfuncs = lm_394(l_eqfuncs, i_initalEquations__lambda0, a_modelNamePrefix);
        l_eqfuncs = Tpl.popIter(l_eqfuncs);
        l_fncalls = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_fncalls = lm_395(l_fncalls, i_initalEquations__lambda0, a_modelNamePrefix);
        l_fncalls = Tpl.popIter(l_fncalls);
        txt = Tpl.writeText(txt, l_eqfuncs);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "int "
                                }, false));
        txt = CodegenUtil.symbolName(txt, a_modelNamePrefix, "functionInitialEquations_lambda0");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA *data, threadData_t *threadData)\n",
                                    "{\n",
                                    "  TRACE_PUSH\n",
                                    "\n",
                                    "  data->simulationInfo->discreteCall = 1;\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_fncalls);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "data->simulationInfo->discreteCall = 0;\n",
                                    "\n",
                                    "TRACE_POP\n",
                                    "return 0;\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;
  end match;
end functionInitialEquations_lambda0;

protected function fun_397
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_e_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_e_index)
    local
      Tpl.Text txt;
      Integer a_e_index;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_e_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("SIM_PROF_TICK_EQ("));
        txt = Tpl.writeStr(txt, intString(a_e_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;
  end match;
end fun_397;

protected function fun_398
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_e_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_e_index)
    local
      Tpl.Text txt;
      Integer a_e_index;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_e_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("SIM_PROF_ACC_EQ("));
        txt = Tpl.writeStr(txt, intString(a_e_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;
  end match;
end fun_398;

protected function fun_399
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input Integer in_a_e_index;
  input Tpl.Text in_a_eqs;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_eqs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_eqs, out_a_varDecls) :=
  match(in_txt, in_a_exp, in_a_e_index, in_a_eqs, in_a_varDecls)
    local
      Tpl.Text txt;
      Integer a_e_index;
      Tpl.Text a_eqs;
      Tpl.Text a_varDecls;
      DAE.Exp i_exp;
      Boolean ret_3;
      Boolean ret_2;
      Tpl.Text l_expPart;
      Tpl.Text l_preExp;

    case ( txt,
           DAE.SCONST(string = _),
           _,
           a_eqs,
           a_varDecls )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("res = 0;"));
      then (txt, a_eqs, a_varDecls);

    case ( txt,
           i_exp,
           a_e_index,
           a_eqs,
           a_varDecls )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_expPart, l_preExp, a_varDecls, a_eqs) = CodegenCFunctions.daeExp(Tpl.emptyTxt, i_exp, SimCodeFunction.contextOther, l_preExp, a_varDecls, a_eqs);
        ret_2 = Config.profileAll();
        txt = fun_397(txt, ret_2, a_e_index);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("res = "));
        txt = Tpl.writeText(txt, l_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        ret_3 = Config.profileAll();
        txt = fun_398(txt, ret_3, a_e_index);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "if(fabs(res) > 1e-5)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("errorStreamPrint(LOG_INIT, 0, \"The initialization problem is inconsistent due to the following equation: 0 != %g = "));
        txt = ExpressionDumpTpl.dumpExp(txt, i_exp, "\"");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\", res);\n",
                                    "return 1;\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then (txt, a_eqs, a_varDecls);
  end match;
end fun_399;

public function functionRemovedInitialEquationsBody
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_eqs;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_eqs;
algorithm
  (out_txt, out_a_varDecls, out_a_eqs) :=
  match(in_txt, in_a_eq, in_a_varDecls, in_a_eqs, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      Tpl.Text a_varDecls;
      Tpl.Text a_eqs;
      String a_modelNamePrefix;
      SimCode.SimEqSystem i_eq;
      Integer i_e_index;
      DAE.Exp i_exp;

    case ( txt,
           SimCode.SES_RESIDUAL(exp = i_exp, index = i_e_index),
           a_varDecls,
           a_eqs,
           _ )
      equation
        (txt, a_eqs, a_varDecls) = fun_399(txt, i_exp, i_e_index, a_eqs, a_varDecls);
      then (txt, a_varDecls, a_eqs);

    case ( txt,
           i_eq,
           a_varDecls,
           a_eqs,
           a_modelNamePrefix )
      equation
        a_eqs = equation_impl(a_eqs, -1, i_eq, SimCodeFunction.contextSimulationDiscrete, a_modelNamePrefix, true);
        txt = equation_call(txt, i_eq, a_modelNamePrefix);
      then (txt, a_varDecls, a_eqs);
  end match;
end functionRemovedInitialEquationsBody;

protected function lm_401
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input String in_a_modelNamePrefix;
  input Tpl.Text in_a_tmp;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_tmp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_tmp, out_a_varDecls) :=
  match(in_txt, in_items, in_a_modelNamePrefix, in_a_tmp, in_a_varDecls)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      String a_modelNamePrefix;
      Tpl.Text a_tmp;
      Tpl.Text a_varDecls;
      SimCode.SimEqSystem i_eq2;

    case ( txt,
           {},
           _,
           a_tmp,
           a_varDecls )
      then (txt, a_tmp, a_varDecls);

    case ( txt,
           i_eq2 :: rest,
           a_modelNamePrefix,
           a_tmp,
           a_varDecls )
      equation
        (txt, a_varDecls, a_tmp) = functionRemovedInitialEquationsBody(txt, i_eq2, a_varDecls, a_tmp, a_modelNamePrefix);
        txt = Tpl.nextIter(txt);
        (txt, a_tmp, a_varDecls) = lm_401(txt, rest, a_modelNamePrefix, a_tmp, a_varDecls);
      then (txt, a_tmp, a_varDecls);
  end match;
end lm_401;

public function functionRemovedInitialEquations
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_removedInitalEquations;
  input String a_modelNamePrefix;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_body;
  Tpl.Text l_tmp;
  Tpl.Text l_varDecls;
algorithm
  l_varDecls := Tpl.emptyTxt;
  l_tmp := Tpl.emptyTxt;
  l_body := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (l_body, l_tmp, l_varDecls) := lm_401(l_body, a_removedInitalEquations, a_modelNamePrefix, l_tmp, l_varDecls);
  l_body := Tpl.popIter(l_body);
  out_txt := Tpl.writeText(txt, l_tmp);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("int "));
  out_txt := CodegenUtil.symbolName(out_txt, a_modelNamePrefix, "functionRemovedInitialEquations");
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "(DATA *data, threadData_t *threadData)\n",
                                       "{\n",
                                       "  TRACE_PUSH\n",
                                       "  const int *equationIndexes = NULL;\n",
                                       "  double res = 0.0;\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeText(out_txt, l_varDecls);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_NEW_LINE());
  out_txt := Tpl.writeText(out_txt, l_body);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "TRACE_POP\n",
                                       "return 0;\n"
                                   }, true));
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("}"));
end functionRemovedInitialEquations;

protected function lm_403
  input Tpl.Text in_txt;
  input list<tuple<Integer, tuple<DAE.Exp, DAE.Exp, DAE.Exp>>> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls)
    local
      Tpl.Text txt;
      list<tuple<Integer, tuple<DAE.Exp, DAE.Exp, DAE.Exp>>> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Integer i_id;
      DAE.Exp i_delayMax;
      DAE.Exp i_d;
      DAE.Exp i_e;
      Tpl.Text l_delayExpMax;
      Tpl.Text l_delayExp;
      Tpl.Text l_eRes;
      Tpl.Text l_preExp;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls )
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           (i_id, (i_e, i_d, i_delayMax)) :: rest,
           a_auxFunction,
           a_varDecls )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_eRes, l_preExp, a_varDecls, a_auxFunction) = CodegenCFunctions.daeExp(Tpl.emptyTxt, i_e, SimCodeFunction.contextSimulationNonDiscrete, l_preExp, a_varDecls, a_auxFunction);
        (l_delayExp, l_preExp, a_varDecls, a_auxFunction) = CodegenCFunctions.daeExp(Tpl.emptyTxt, i_d, SimCodeFunction.contextSimulationNonDiscrete, l_preExp, a_varDecls, a_auxFunction);
        (l_delayExpMax, l_preExp, a_varDecls, a_auxFunction) = CodegenCFunctions.daeExp(Tpl.emptyTxt, i_delayMax, SimCodeFunction.contextSimulationNonDiscrete, l_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("storeDelayedExpression(data, threadData, "));
        txt = Tpl.writeStr(txt, intString(i_id));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, l_eRes);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", data->localData[0]->timeValue, "));
        txt = Tpl.writeText(txt, l_delayExp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, l_delayExpMax);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        (txt, a_auxFunction, a_varDecls) = lm_403(txt, rest, a_auxFunction, a_varDecls);
      then (txt, a_auxFunction, a_varDecls);
  end match;
end lm_403;

protected function fun_404
  input Tpl.Text in_txt;
  input SimCode.DelayedExpression in_a_delayed;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_a_delayed, in_a_auxFunction, in_a_varDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      list<tuple<Integer, tuple<DAE.Exp, DAE.Exp, DAE.Exp>>> i_delayedExps;

    case ( txt,
           SimCode.DELAYED_EXPRESSIONS(delayedExps = i_delayedExps),
           a_auxFunction,
           a_varDecls )
      equation
        (txt, a_auxFunction, a_varDecls) = lm_403(txt, i_delayedExps, a_auxFunction, a_varDecls);
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           _,
           a_auxFunction,
           a_varDecls )
      then (txt, a_auxFunction, a_varDecls);
  end match;
end fun_404;

public function functionStoreDelayed
  input Tpl.Text txt;
  input SimCode.DelayedExpression a_delayed;
  input String a_modelNamePrefix;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_storePart;
  Tpl.Text l_auxFunction;
  Tpl.Text l_varDecls;
algorithm
  l_varDecls := Tpl.emptyTxt;
  l_auxFunction := Tpl.emptyTxt;
  (l_storePart, l_auxFunction, l_varDecls) := fun_404(Tpl.emptyTxt, a_delayed, l_auxFunction, l_varDecls);
  out_txt := Tpl.writeText(txt, l_auxFunction);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("int "));
  out_txt := CodegenUtil.symbolName(out_txt, a_modelNamePrefix, "function_storeDelayed");
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "(DATA *data, threadData_t *threadData)\n",
                                       "{\n",
                                       "  TRACE_PUSH\n",
                                       "\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeText(out_txt, l_varDecls);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeText(out_txt, l_storePart);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "TRACE_POP\n",
                                       "return 0;\n"
                                   }, true));
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("}"));
end functionStoreDelayed;

protected function lm_406
  input Tpl.Text in_txt;
  input list<list<SimCode.SimEqSystem>> in_items;
  input String in_a_modelNamePrefixStr;
  input Option<tuple<HpcOmSimCode.Schedule, HpcOmSimCode.Schedule, HpcOmSimCode.Schedule>> in_a_hpcOmSchedulesOpt;
  input String in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefixStr, in_a_hpcOmSchedulesOpt, in_a_name)
    local
      Tpl.Text txt;
      list<list<SimCode.SimEqSystem>> rest;
      String a_modelNamePrefixStr;
      Option<tuple<HpcOmSimCode.Schedule, HpcOmSimCode.Schedule, HpcOmSimCode.Schedule>> a_hpcOmSchedulesOpt;
      String a_name;
      Integer x_i0;
      list<SimCode.SimEqSystem> i_eq;

    case ( txt,
           {},
           _,
           _,
           _ )
      then txt;

    case ( txt,
           i_eq :: rest,
           a_modelNamePrefixStr,
           a_hpcOmSchedulesOpt,
           a_name )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = functionXXX_system_HPCOM(txt, i_eq, a_name, x_i0, a_hpcOmSchedulesOpt, a_modelNamePrefixStr);
        txt = Tpl.nextIter(txt);
        txt = lm_406(txt, rest, a_modelNamePrefixStr, a_hpcOmSchedulesOpt, a_name);
      then txt;
  end match;
end lm_406;

protected function lm_407
  input Tpl.Text in_txt;
  input list<list<SimCode.SimEqSystem>> in_items;
  input String in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_name)
    local
      Tpl.Text txt;
      list<list<SimCode.SimEqSystem>> rest;
      String a_name;
      Integer x_i0;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           _ :: rest,
           a_name )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("function"));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_system"));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.nextIter(txt);
        txt = lm_407(txt, rest, a_name);
      then txt;
  end match;
end lm_407;

protected function fun_408
  input Tpl.Text in_txt;
  input Integer in_mArg;
  input Tpl.Text in_a_varDecls;
  input list<list<SimCode.SimEqSystem>> in_a_eqs;
  input Tpl.Text in_a_funcs;
  input String in_a_name;
  input Tpl.Text in_a_loop;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_loop;
algorithm
  (out_txt, out_a_varDecls, out_a_loop) :=
  match(in_txt, in_mArg, in_a_varDecls, in_a_eqs, in_a_funcs, in_a_name, in_a_loop)
    local
      Tpl.Text txt;
      Tpl.Text a_varDecls;
      list<list<SimCode.SimEqSystem>> a_eqs;
      Tpl.Text a_funcs;
      String a_name;
      Tpl.Text a_loop;
      Integer i_nFuncs;
      Tpl.Text l_funcNames;

    case ( txt,
           0,
           a_varDecls,
           _,
           _,
           a_name,
           a_loop )
      equation
        a_loop = Tpl.writeTok(a_loop, Tpl.ST_STRING("/* no "));
        a_loop = Tpl.writeStr(a_loop, a_name);
        a_loop = Tpl.writeTok(a_loop, Tpl.ST_STRING(" systems */"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "void terminateHpcOmThreads()\n",
                                    "{\n",
                                    "\n",
                                    "}"
                                }, false));
      then (txt, a_varDecls, a_loop);

    case ( txt,
           1,
           a_varDecls,
           _,
           a_funcs,
           a_name,
           a_loop )
      equation
        a_loop = Tpl.writeTok(a_loop, Tpl.ST_STRING("function"));
        a_loop = Tpl.writeStr(a_loop, a_name);
        a_loop = Tpl.writeTok(a_loop, Tpl.ST_STRING("_system0(data, threadData);"));
        txt = Tpl.writeText(txt, a_funcs);
      then (txt, a_varDecls, a_loop);

    case ( txt,
           i_nFuncs,
           a_varDecls,
           a_eqs,
           a_funcs,
           a_name,
           a_loop )
      equation
        l_funcNames = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_LINE(",\n")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_funcNames = lm_407(l_funcNames, a_eqs, a_name);
        l_funcNames = Tpl.popIter(l_funcNames);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING("int id;"));
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_NEW_LINE());
        a_loop = Tpl.writeTok(a_loop, Tpl.ST_STRING("for(id=0; id<"));
        a_loop = Tpl.writeStr(a_loop, intString(i_nFuncs));
        a_loop = Tpl.writeTok(a_loop, Tpl.ST_LINE("; id++) {\n"));
        a_loop = Tpl.pushBlock(a_loop, Tpl.BT_INDENT(2));
        a_loop = Tpl.writeTok(a_loop, Tpl.ST_STRING("function"));
        a_loop = Tpl.writeStr(a_loop, a_name);
        a_loop = Tpl.writeTok(a_loop, Tpl.ST_LINE("_systems[id](data, threadData);\n"));
        a_loop = Tpl.popBlock(a_loop);
        a_loop = Tpl.writeTok(a_loop, Tpl.ST_STRING("}"));
        txt = Tpl.writeText(txt, a_funcs);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("static void (*function"));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_systems["));
        txt = Tpl.writeStr(txt, intString(i_nFuncs));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("])(DATA *, threadData_t *) = {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_funcNames);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("};"));
      then (txt, a_varDecls, a_loop);
  end match;
end fun_408;

public function functionXXX_systems_HPCOM
  input Tpl.Text txt;
  input list<list<SimCode.SimEqSystem>> a_eqs;
  input String a_name;
  input Tpl.Text a_loop;
  input Tpl.Text a_varDecls;
  input Option<tuple<HpcOmSimCode.Schedule, HpcOmSimCode.Schedule, HpcOmSimCode.Schedule>> a_hpcOmSchedulesOpt;
  input String a_modelNamePrefixStr;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_loop;
  output Tpl.Text out_a_varDecls;
protected
  Integer ret_1;
  Tpl.Text l_funcs;
algorithm
  l_funcs := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  l_funcs := lm_406(l_funcs, a_eqs, a_modelNamePrefixStr, a_hpcOmSchedulesOpt, a_name);
  l_funcs := Tpl.popIter(l_funcs);
  ret_1 := listLength(a_eqs);
  (out_txt, out_a_varDecls, out_a_loop) := fun_408(txt, ret_1, a_varDecls, a_eqs, l_funcs, a_name, a_loop);
end functionXXX_systems_HPCOM;

protected function lm_410
  input Tpl.Text in_txt;
  input list<HpcOmSimCode.TaskList> in_items;
  input String in_a_modelNamePrefixStr;
  input Tpl.Text in_a_type;
  input String in_a_name;
  input list<SimCode.SimEqSystem> in_a_derivativEquations;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefixStr, in_a_type, in_a_name, in_a_derivativEquations)
    local
      Tpl.Text txt;
      list<HpcOmSimCode.TaskList> rest;
      String a_modelNamePrefixStr;
      Tpl.Text a_type;
      String a_name;
      list<SimCode.SimEqSystem> a_derivativEquations;
      HpcOmSimCode.TaskList i_tasks;

    case ( txt,
           {},
           _,
           _,
           _,
           _ )
      then txt;

    case ( txt,
           i_tasks :: rest,
           a_modelNamePrefixStr,
           a_type,
           a_name,
           a_derivativEquations )
      equation
        txt = functionXXX_system0_HPCOM_Level(txt, a_derivativEquations, a_name, i_tasks, Tpl.textString(a_type), a_modelNamePrefixStr);
        txt = Tpl.nextIter(txt);
        txt = lm_410(txt, rest, a_modelNamePrefixStr, a_type, a_name, a_derivativEquations);
      then txt;
  end match;
end lm_410;

protected function lm_411
  input Tpl.Text in_txt;
  input list<HpcOmSimCode.Task> in_items;
  input Tpl.Text in_a_type;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_type)
    local
      Tpl.Text txt;
      list<HpcOmSimCode.Task> rest;
      Tpl.Text a_type;
      HpcOmSimCode.Task i_task;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_task :: rest,
           a_type )
      equation
        txt = function_HPCOM_createLockByDepTask(txt, i_task, "lock", Tpl.textString(a_type));
        txt = Tpl.nextIter(txt);
        txt = lm_411(txt, rest, a_type);
      then txt;
  end match;
end lm_411;

protected function lm_412
  input Tpl.Text in_txt;
  input list<HpcOmSimCode.Task> in_items;
  input Tpl.Text in_a_type;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_type)
    local
      Tpl.Text txt;
      list<HpcOmSimCode.Task> rest;
      Tpl.Text a_type;
      HpcOmSimCode.Task i_task;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_task :: rest,
           a_type )
      equation
        txt = function_HPCOM_initializeLockByDepTask(txt, i_task, "lock", Tpl.textString(a_type));
        txt = Tpl.nextIter(txt);
        txt = lm_412(txt, rest, a_type);
      then txt;
  end match;
end lm_412;

protected function lm_413
  input Tpl.Text in_txt;
  input list<HpcOmSimCode.Task> in_items;
  input Tpl.Text in_a_type;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_type)
    local
      Tpl.Text txt;
      list<HpcOmSimCode.Task> rest;
      Tpl.Text a_type;
      HpcOmSimCode.Task i_task;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_task :: rest,
           a_type )
      equation
        txt = function_HPCOM_assignLockByDepTask(txt, i_task, "lock", Tpl.textString(a_type));
        txt = Tpl.nextIter(txt);
        txt = lm_413(txt, rest, a_type);
      then txt;
  end match;
end lm_413;

protected function lm_414
  input Tpl.Text in_txt;
  input list<list<HpcOmSimCode.Task>> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<list<HpcOmSimCode.Task>> rest;
      Integer x_i0;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           _ :: rest )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = functionXXX_system0_HPCOM_PThread_decl(txt, x_i0);
        txt = Tpl.nextIter(txt);
        txt = lm_414(txt, rest);
      then txt;
  end match;
end lm_414;

protected function lm_415
  input Tpl.Text in_txt;
  input list<list<HpcOmSimCode.Task>> in_items;
  input String in_a_modelNamePrefixStr;
  input Tpl.Text in_a_type;
  input array<list<HpcOmSimCode.Task>> in_a_hpcOmSchedule_threadTasks;
  input Integer in_a_n;
  input String in_a_name;
  input list<SimCode.SimEqSystem> in_a_derivativEquations;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefixStr, in_a_type, in_a_hpcOmSchedule_threadTasks, in_a_n, in_a_name, in_a_derivativEquations)
    local
      Tpl.Text txt;
      list<list<HpcOmSimCode.Task>> rest;
      String a_modelNamePrefixStr;
      Tpl.Text a_type;
      array<list<HpcOmSimCode.Task>> a_hpcOmSchedule_threadTasks;
      Integer a_n;
      String a_name;
      list<SimCode.SimEqSystem> a_derivativEquations;
      Integer x_i0;

    case ( txt,
           {},
           _,
           _,
           _,
           _,
           _,
           _ )
      then txt;

    case ( txt,
           _ :: rest,
           a_modelNamePrefixStr,
           a_type,
           a_hpcOmSchedule_threadTasks,
           a_n,
           a_name,
           a_derivativEquations )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = functionXXX_system0_HPCOM_PThread_func(txt, a_derivativEquations, a_name, a_n, a_hpcOmSchedule_threadTasks, Tpl.textString(a_type), x_i0, a_modelNamePrefixStr);
        txt = Tpl.nextIter(txt);
        txt = lm_415(txt, rest, a_modelNamePrefixStr, a_type, a_hpcOmSchedule_threadTasks, a_n, a_name, a_derivativEquations);
      then txt;
  end match;
end lm_415;

protected function lm_416
  input Tpl.Text in_txt;
  input list<list<HpcOmSimCode.Task>> in_items;
  input Integer in_a_n;
  input String in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_n, in_a_name)
    local
      Tpl.Text txt;
      list<list<HpcOmSimCode.Task>> rest;
      Integer a_n;
      String a_name;
      Integer x_i0;

    case ( txt,
           {},
           _,
           _ )
      then txt;

    case ( txt,
           _ :: rest,
           a_n,
           a_name )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = functionXXX_system0_HPCOM_PThread_call(txt, a_name, a_n, x_i0);
        txt = Tpl.nextIter(txt);
        txt = lm_416(txt, rest, a_n, a_name);
      then txt;
  end match;
end lm_416;

protected function lm_417
  input Tpl.Text in_txt;
  input list<list<HpcOmSimCode.Task>> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<list<HpcOmSimCode.Task>> rest;
      Integer x_i0;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           _ :: rest )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = functionXXX_system0_HPCOM_PThread_start(txt, x_i0);
        txt = Tpl.nextIter(txt);
        txt = lm_417(txt, rest);
      then txt;
  end match;
end lm_417;

protected function lm_418
  input Tpl.Text in_txt;
  input list<list<HpcOmSimCode.Task>> in_items;
  input Tpl.Text in_a_type;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_type)
    local
      Tpl.Text txt;
      list<list<HpcOmSimCode.Task>> rest;
      Tpl.Text a_type;
      Integer x_i0;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           _ :: rest,
           a_type )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = function_HPCOM_createLockByLockName(txt, intString(x_i0), "th_lock", Tpl.textString(a_type));
        txt = Tpl.nextIter(txt);
        txt = lm_418(txt, rest, a_type);
      then txt;
  end match;
end lm_418;

protected function lm_419
  input Tpl.Text in_txt;
  input list<list<HpcOmSimCode.Task>> in_items;
  input Tpl.Text in_a_type;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_type)
    local
      Tpl.Text txt;
      list<list<HpcOmSimCode.Task>> rest;
      Tpl.Text a_type;
      Integer x_i0;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           _ :: rest,
           a_type )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = function_HPCOM_createLockByLockName(txt, intString(x_i0), "th_lock1", Tpl.textString(a_type));
        txt = Tpl.nextIter(txt);
        txt = lm_419(txt, rest, a_type);
      then txt;
  end match;
end lm_419;

protected function lm_420
  input Tpl.Text in_txt;
  input list<list<HpcOmSimCode.Task>> in_items;
  input Tpl.Text in_a_type;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_type)
    local
      Tpl.Text txt;
      list<list<HpcOmSimCode.Task>> rest;
      Tpl.Text a_type;
      Integer x_i0;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           _ :: rest,
           a_type )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = function_HPCOM_initializeLockByLockName(txt, intString(x_i0), "th_lock", Tpl.textString(a_type));
        txt = Tpl.nextIter(txt);
        txt = lm_420(txt, rest, a_type);
      then txt;
  end match;
end lm_420;

protected function lm_421
  input Tpl.Text in_txt;
  input list<list<HpcOmSimCode.Task>> in_items;
  input Tpl.Text in_a_type;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_type)
    local
      Tpl.Text txt;
      list<list<HpcOmSimCode.Task>> rest;
      Tpl.Text a_type;
      Integer x_i0;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           _ :: rest,
           a_type )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = function_HPCOM_initializeLockByLockName(txt, intString(x_i0), "th_lock1", Tpl.textString(a_type));
        txt = Tpl.nextIter(txt);
        txt = lm_421(txt, rest, a_type);
      then txt;
  end match;
end lm_421;

protected function lm_422
  input Tpl.Text in_txt;
  input list<list<HpcOmSimCode.Task>> in_items;
  input Tpl.Text in_a_type;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_type)
    local
      Tpl.Text txt;
      list<list<HpcOmSimCode.Task>> rest;
      Tpl.Text a_type;
      Integer x_i0;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           _ :: rest,
           a_type )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = function_HPCOM_assignLockByLockName(txt, intString(x_i0), "th_lock", Tpl.textString(a_type));
        txt = Tpl.nextIter(txt);
        txt = lm_422(txt, rest, a_type);
      then txt;
  end match;
end lm_422;

protected function lm_423
  input Tpl.Text in_txt;
  input list<list<HpcOmSimCode.Task>> in_items;
  input Tpl.Text in_a_type;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_type)
    local
      Tpl.Text txt;
      list<list<HpcOmSimCode.Task>> rest;
      Tpl.Text a_type;
      Integer x_i0;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           _ :: rest,
           a_type )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = function_HPCOM_assignLockByLockName(txt, intString(x_i0), "th_lock1", Tpl.textString(a_type));
        txt = Tpl.nextIter(txt);
        txt = lm_423(txt, rest, a_type);
      then txt;
  end match;
end lm_423;

protected function lm_424
  input Tpl.Text in_txt;
  input list<list<HpcOmSimCode.Task>> in_items;
  input Tpl.Text in_a_type;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_type)
    local
      Tpl.Text txt;
      list<list<HpcOmSimCode.Task>> rest;
      Tpl.Text a_type;
      Integer x_i0;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           _ :: rest,
           a_type )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = function_HPCOM_releaseLockByLockName(txt, intString(x_i0), "th_lock", Tpl.textString(a_type));
        txt = Tpl.nextIter(txt);
        txt = lm_424(txt, rest, a_type);
      then txt;
  end match;
end lm_424;

protected function lm_425
  input Tpl.Text in_txt;
  input list<list<HpcOmSimCode.Task>> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<list<HpcOmSimCode.Task>> rest;
      Integer x_i0;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           _ :: rest )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = functionXXX_system0_HPCOM_PThread_decl(txt, x_i0);
        txt = Tpl.nextIter(txt);
        txt = lm_425(txt, rest);
      then txt;
  end match;
end lm_425;

protected function lm_426
  input Tpl.Text in_txt;
  input list<list<HpcOmSimCode.Task>> in_items;
  input String in_a_modelNamePrefixStr;
  input Tpl.Text in_a_type;
  input array<list<HpcOmSimCode.Task>> in_a_hpcOmSchedule_threadTasks;
  input Integer in_a_n;
  input String in_a_name;
  input list<SimCode.SimEqSystem> in_a_derivativEquations;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefixStr, in_a_type, in_a_hpcOmSchedule_threadTasks, in_a_n, in_a_name, in_a_derivativEquations)
    local
      Tpl.Text txt;
      list<list<HpcOmSimCode.Task>> rest;
      String a_modelNamePrefixStr;
      Tpl.Text a_type;
      array<list<HpcOmSimCode.Task>> a_hpcOmSchedule_threadTasks;
      Integer a_n;
      String a_name;
      list<SimCode.SimEqSystem> a_derivativEquations;
      Integer x_i0;

    case ( txt,
           {},
           _,
           _,
           _,
           _,
           _,
           _ )
      then txt;

    case ( txt,
           _ :: rest,
           a_modelNamePrefixStr,
           a_type,
           a_hpcOmSchedule_threadTasks,
           a_n,
           a_name,
           a_derivativEquations )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = functionXXX_system0_HPCOM_PThread_func(txt, a_derivativEquations, a_name, a_n, a_hpcOmSchedule_threadTasks, Tpl.textString(a_type), x_i0, a_modelNamePrefixStr);
        txt = Tpl.nextIter(txt);
        txt = lm_426(txt, rest, a_modelNamePrefixStr, a_type, a_hpcOmSchedule_threadTasks, a_n, a_name, a_derivativEquations);
      then txt;
  end match;
end lm_426;

protected function lm_427
  input Tpl.Text in_txt;
  input list<list<HpcOmSimCode.Task>> in_items;
  input Integer in_a_n;
  input String in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_n, in_a_name)
    local
      Tpl.Text txt;
      list<list<HpcOmSimCode.Task>> rest;
      Integer a_n;
      String a_name;
      Integer x_i0;

    case ( txt,
           {},
           _,
           _ )
      then txt;

    case ( txt,
           _ :: rest,
           a_n,
           a_name )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = functionXXX_system0_HPCOM_PThread_call(txt, a_name, a_n, x_i0);
        txt = Tpl.nextIter(txt);
        txt = lm_427(txt, rest, a_n, a_name);
      then txt;
  end match;
end lm_427;

protected function lm_428
  input Tpl.Text in_txt;
  input list<list<HpcOmSimCode.Task>> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<list<HpcOmSimCode.Task>> rest;
      Integer x_i0;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           _ :: rest )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = functionXXX_system0_HPCOM_PThread_start(txt, x_i0);
        txt = Tpl.nextIter(txt);
        txt = lm_428(txt, rest);
      then txt;
  end match;
end lm_428;

protected function lm_429
  input Tpl.Text in_txt;
  input list<list<HpcOmSimCode.Task>> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<list<HpcOmSimCode.Task>> rest;
      Integer x_i0;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           _ :: rest )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = function_HPCOM_createLockByLockName(txt, intString(x_i0), "th_lock", "pthreads");
        txt = Tpl.nextIter(txt);
        txt = lm_429(txt, rest);
      then txt;
  end match;
end lm_429;

protected function lm_430
  input Tpl.Text in_txt;
  input list<list<HpcOmSimCode.Task>> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<list<HpcOmSimCode.Task>> rest;
      Integer x_i0;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           _ :: rest )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = function_HPCOM_createLockByLockName(txt, intString(x_i0), "th_lock1", "pthreads");
        txt = Tpl.nextIter(txt);
        txt = lm_430(txt, rest);
      then txt;
  end match;
end lm_430;

protected function lm_431
  input Tpl.Text in_txt;
  input list<list<HpcOmSimCode.Task>> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<list<HpcOmSimCode.Task>> rest;
      Integer x_i0;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           _ :: rest )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = function_HPCOM_initializeLockByLockName(txt, intString(x_i0), "th_lock", "pthreads");
        txt = Tpl.nextIter(txt);
        txt = lm_431(txt, rest);
      then txt;
  end match;
end lm_431;

protected function lm_432
  input Tpl.Text in_txt;
  input list<list<HpcOmSimCode.Task>> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<list<HpcOmSimCode.Task>> rest;
      Integer x_i0;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           _ :: rest )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = function_HPCOM_initializeLockByLockName(txt, intString(x_i0), "th_lock1", "pthreads");
        txt = Tpl.nextIter(txt);
        txt = lm_432(txt, rest);
      then txt;
  end match;
end lm_432;

protected function lm_433
  input Tpl.Text in_txt;
  input list<list<HpcOmSimCode.Task>> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<list<HpcOmSimCode.Task>> rest;
      Integer x_i0;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           _ :: rest )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = function_HPCOM_assignLockByLockName(txt, intString(x_i0), "th_lock", "pthreads");
        txt = Tpl.nextIter(txt);
        txt = lm_433(txt, rest);
      then txt;
  end match;
end lm_433;

protected function lm_434
  input Tpl.Text in_txt;
  input list<list<HpcOmSimCode.Task>> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<list<HpcOmSimCode.Task>> rest;
      Integer x_i0;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           _ :: rest )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = function_HPCOM_assignLockByLockName(txt, intString(x_i0), "th_lock1", "pthreads");
        txt = Tpl.nextIter(txt);
        txt = lm_434(txt, rest);
      then txt;
  end match;
end lm_434;

protected function lm_435
  input Tpl.Text in_txt;
  input list<list<HpcOmSimCode.Task>> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<list<HpcOmSimCode.Task>> rest;
      Integer x_i0;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           _ :: rest )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = function_HPCOM_releaseLockByLockName(txt, intString(x_i0), "th_lock", "pthreads");
        txt = Tpl.nextIter(txt);
        txt = lm_435(txt, rest);
      then txt;
  end match;
end lm_435;

protected function fun_436
  input Tpl.Text in_txt;
  input String in_mArg;
  input Tpl.Text in_a_assignLocks;
  input Tpl.Text in_a_initlocks;
  input Tpl.Text in_a_locks;
  input Integer in_a_n;
  input String in_a_modelNamePrefixStr;
  input Tpl.Text in_a_type;
  input array<list<HpcOmSimCode.Task>> in_a_hpcOmSchedule_threadTasks;
  input String in_a_name;
  input list<SimCode.SimEqSystem> in_a_derivativEquations;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_assignLocks, in_a_initlocks, in_a_locks, in_a_n, in_a_modelNamePrefixStr, in_a_type, in_a_hpcOmSchedule_threadTasks, in_a_name, in_a_derivativEquations)
    local
      Tpl.Text txt;
      Tpl.Text a_assignLocks;
      Tpl.Text a_initlocks;
      Tpl.Text a_locks;
      Integer a_n;
      String a_modelNamePrefixStr;
      Tpl.Text a_type;
      array<list<HpcOmSimCode.Task>> a_hpcOmSchedule_threadTasks;
      String a_name;
      list<SimCode.SimEqSystem> a_derivativEquations;
      list<list<HpcOmSimCode.Task>> ret_34;
      list<list<HpcOmSimCode.Task>> ret_33;
      list<list<HpcOmSimCode.Task>> ret_32;
      list<list<HpcOmSimCode.Task>> ret_31;
      list<list<HpcOmSimCode.Task>> ret_30;
      list<list<HpcOmSimCode.Task>> ret_29;
      list<list<HpcOmSimCode.Task>> ret_28;
      list<list<HpcOmSimCode.Task>> ret_27;
      list<list<HpcOmSimCode.Task>> ret_26;
      list<list<HpcOmSimCode.Task>> ret_25;
      list<list<HpcOmSimCode.Task>> ret_24;
      Integer ret_23;
      list<list<HpcOmSimCode.Task>> ret_22;
      Tpl.Text l_threadReleaseLocks;
      list<list<HpcOmSimCode.Task>> ret_20;
      Tpl.Text l_threadAssignLocks1;
      list<list<HpcOmSimCode.Task>> ret_18;
      Tpl.Text l_threadAssignLocks;
      list<list<HpcOmSimCode.Task>> ret_16;
      Tpl.Text l_threadLocksInit1;
      list<list<HpcOmSimCode.Task>> ret_14;
      Tpl.Text l_threadLocksInit;
      list<list<HpcOmSimCode.Task>> ret_12;
      Tpl.Text l_threadLocks1;
      list<list<HpcOmSimCode.Task>> ret_10;
      Tpl.Text l_threadLocks;
      list<list<HpcOmSimCode.Task>> ret_8;
      Tpl.Text l_threadStart;
      list<list<HpcOmSimCode.Task>> ret_6;
      Tpl.Text l_threadFuncCalls;
      list<list<HpcOmSimCode.Task>> ret_4;
      Tpl.Text l_threadFuncs;
      list<list<HpcOmSimCode.Task>> ret_2;
      Tpl.Text l_threadDecl;
      Tpl.Text l_taskEqs;

    case ( txt,
           "openmp",
           a_assignLocks,
           a_initlocks,
           a_locks,
           a_n,
           a_modelNamePrefixStr,
           a_type,
           a_hpcOmSchedule_threadTasks,
           a_name,
           a_derivativEquations )
      equation
        l_taskEqs = functionXXX_system0_HPCOM_Thread(Tpl.emptyTxt, a_derivativEquations, a_name, a_hpcOmSchedule_threadTasks, Tpl.textString(a_type), a_modelNamePrefixStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "void terminateHpcOmThreads()\n",
                                    "{\n",
                                    "}\n",
                                    "\n",
                                    "/* using type: "
                                }, false));
        txt = Tpl.writeText(txt, a_type);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " */\n",
                                    "static int initialized = 0;\n",
                                    "void function"
                                }, false));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_system"));
        txt = Tpl.writeStr(txt, intString(a_n));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA *data, threadData_t *threadData)\n",
                                    "{\n",
                                    "  omp_set_dynamic(0);\n",
                                    "  //create locks\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_locks);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "if(!initialized)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.writeText(txt, a_initlocks);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "//set locks\n"
                                }, true));
        txt = Tpl.writeText(txt, a_assignLocks);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "initialized = 1;\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n"
                                }, true));
        txt = Tpl.writeText(txt, l_taskEqs);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;

    case ( txt,
           "pthreads",
           a_assignLocks,
           a_initlocks,
           a_locks,
           a_n,
           a_modelNamePrefixStr,
           a_type,
           a_hpcOmSchedule_threadTasks,
           a_name,
           a_derivativEquations )
      equation
        ret_2 = arrayList(a_hpcOmSchedule_threadTasks);
        l_threadDecl = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_threadDecl = lm_414(l_threadDecl, ret_2);
        l_threadDecl = Tpl.popIter(l_threadDecl);
        ret_4 = arrayList(a_hpcOmSchedule_threadTasks);
        l_threadFuncs = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_threadFuncs = lm_415(l_threadFuncs, ret_4, a_modelNamePrefixStr, a_type, a_hpcOmSchedule_threadTasks, a_n, a_name, a_derivativEquations);
        l_threadFuncs = Tpl.popIter(l_threadFuncs);
        ret_6 = arrayList(a_hpcOmSchedule_threadTasks);
        l_threadFuncCalls = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_threadFuncCalls = lm_416(l_threadFuncCalls, ret_6, a_n, a_name);
        l_threadFuncCalls = Tpl.popIter(l_threadFuncCalls);
        ret_8 = arrayList(a_hpcOmSchedule_threadTasks);
        l_threadStart = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_threadStart = lm_417(l_threadStart, ret_8);
        l_threadStart = Tpl.popIter(l_threadStart);
        ret_10 = arrayList(a_hpcOmSchedule_threadTasks);
        l_threadLocks = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_threadLocks = lm_418(l_threadLocks, ret_10, a_type);
        l_threadLocks = Tpl.popIter(l_threadLocks);
        ret_12 = arrayList(a_hpcOmSchedule_threadTasks);
        l_threadLocks1 = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_threadLocks1 = lm_419(l_threadLocks1, ret_12, a_type);
        l_threadLocks1 = Tpl.popIter(l_threadLocks1);
        ret_14 = arrayList(a_hpcOmSchedule_threadTasks);
        l_threadLocksInit = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_threadLocksInit = lm_420(l_threadLocksInit, ret_14, a_type);
        l_threadLocksInit = Tpl.popIter(l_threadLocksInit);
        ret_16 = arrayList(a_hpcOmSchedule_threadTasks);
        l_threadLocksInit1 = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_threadLocksInit1 = lm_421(l_threadLocksInit1, ret_16, a_type);
        l_threadLocksInit1 = Tpl.popIter(l_threadLocksInit1);
        ret_18 = arrayList(a_hpcOmSchedule_threadTasks);
        l_threadAssignLocks = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_threadAssignLocks = lm_422(l_threadAssignLocks, ret_18, a_type);
        l_threadAssignLocks = Tpl.popIter(l_threadAssignLocks);
        ret_20 = arrayList(a_hpcOmSchedule_threadTasks);
        l_threadAssignLocks1 = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_threadAssignLocks1 = lm_423(l_threadAssignLocks1, ret_20, a_type);
        l_threadAssignLocks1 = Tpl.popIter(l_threadAssignLocks1);
        ret_22 = arrayList(a_hpcOmSchedule_threadTasks);
        l_threadReleaseLocks = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_threadReleaseLocks = lm_424(l_threadReleaseLocks, ret_22, a_type);
        l_threadReleaseLocks = Tpl.popIter(l_threadReleaseLocks);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("// number of threads: "));
        ret_23 = arrayLength(a_hpcOmSchedule_threadTasks);
        txt = Tpl.writeStr(txt, intString(ret_23));
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "static int finished; //set to 1 if the hpcom-threads should be destroyed\n",
                                    "\n"
                                }, true));
        txt = Tpl.writeText(txt, l_threadDecl);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_locks);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_threadLocks);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_threadLocks1);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "void terminateHpcOmThreads()\n",
                                    "{\n",
                                    "  finished = 1;\n",
                                    "\n",
                                    "  //Start the threads one last time\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_threadReleaseLocks);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n"
                                }, true));
        txt = Tpl.writeText(txt, l_threadFuncs);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "/* using type: "
                                }, false));
        txt = Tpl.writeText(txt, a_type);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " */\n",
                                    "static int initialized = 0;\n",
                                    "void function"
                                }, false));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_system"));
        txt = Tpl.writeStr(txt, intString(a_n));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA *data, threadData_t *threadData)\n",
                                    "{\n",
                                    "  if(!initialized)\n",
                                    "  {\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(6));
        txt = Tpl.writeText(txt, a_initlocks);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_threadLocksInit);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_threadLocksInit1);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "//set locks\n"
                                }, true));
        txt = Tpl.writeText(txt, a_assignLocks);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_threadAssignLocks);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_threadAssignLocks1);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_threadFuncCalls);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("initialized = 1;\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "  }\n",
                                    "\n",
                                    "  //Start the threads\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_threadReleaseLocks);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "//\"join\"\n"
                                }, true));
        txt = Tpl.writeText(txt, l_threadAssignLocks1);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;

    case ( txt,
           "pthreads_spin",
           a_assignLocks,
           a_initlocks,
           a_locks,
           a_n,
           a_modelNamePrefixStr,
           a_type,
           a_hpcOmSchedule_threadTasks,
           a_name,
           a_derivativEquations )
      equation
        ret_24 = arrayList(a_hpcOmSchedule_threadTasks);
        l_threadDecl = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_threadDecl = lm_425(l_threadDecl, ret_24);
        l_threadDecl = Tpl.popIter(l_threadDecl);
        ret_25 = arrayList(a_hpcOmSchedule_threadTasks);
        l_threadFuncs = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_threadFuncs = lm_426(l_threadFuncs, ret_25, a_modelNamePrefixStr, a_type, a_hpcOmSchedule_threadTasks, a_n, a_name, a_derivativEquations);
        l_threadFuncs = Tpl.popIter(l_threadFuncs);
        ret_26 = arrayList(a_hpcOmSchedule_threadTasks);
        l_threadFuncCalls = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_threadFuncCalls = lm_427(l_threadFuncCalls, ret_26, a_n, a_name);
        l_threadFuncCalls = Tpl.popIter(l_threadFuncCalls);
        ret_27 = arrayList(a_hpcOmSchedule_threadTasks);
        l_threadStart = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_threadStart = lm_428(l_threadStart, ret_27);
        l_threadStart = Tpl.popIter(l_threadStart);
        ret_28 = arrayList(a_hpcOmSchedule_threadTasks);
        l_threadLocks = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_threadLocks = lm_429(l_threadLocks, ret_28);
        l_threadLocks = Tpl.popIter(l_threadLocks);
        ret_29 = arrayList(a_hpcOmSchedule_threadTasks);
        l_threadLocks1 = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_threadLocks1 = lm_430(l_threadLocks1, ret_29);
        l_threadLocks1 = Tpl.popIter(l_threadLocks1);
        ret_30 = arrayList(a_hpcOmSchedule_threadTasks);
        l_threadLocksInit = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_threadLocksInit = lm_431(l_threadLocksInit, ret_30);
        l_threadLocksInit = Tpl.popIter(l_threadLocksInit);
        ret_31 = arrayList(a_hpcOmSchedule_threadTasks);
        l_threadLocksInit1 = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_threadLocksInit1 = lm_432(l_threadLocksInit1, ret_31);
        l_threadLocksInit1 = Tpl.popIter(l_threadLocksInit1);
        ret_32 = arrayList(a_hpcOmSchedule_threadTasks);
        l_threadAssignLocks = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_threadAssignLocks = lm_433(l_threadAssignLocks, ret_32);
        l_threadAssignLocks = Tpl.popIter(l_threadAssignLocks);
        ret_33 = arrayList(a_hpcOmSchedule_threadTasks);
        l_threadAssignLocks1 = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_threadAssignLocks1 = lm_434(l_threadAssignLocks1, ret_33);
        l_threadAssignLocks1 = Tpl.popIter(l_threadAssignLocks1);
        ret_34 = arrayList(a_hpcOmSchedule_threadTasks);
        l_threadReleaseLocks = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_threadReleaseLocks = lm_435(l_threadReleaseLocks, ret_34);
        l_threadReleaseLocks = Tpl.popIter(l_threadReleaseLocks);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "static int finished; //set to 1 if the hpcom-threads should be destroyed\n",
                                    "\n"
                                }, true));
        txt = Tpl.writeText(txt, l_threadDecl);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_locks);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_threadLocks);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_threadLocks1);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "void terminateHpcOmThreads()\n",
                                    "{\n",
                                    "  finished = 1;\n",
                                    "\n",
                                    "  //Start the threads one last time\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_threadReleaseLocks);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n"
                                }, true));
        txt = Tpl.writeText(txt, l_threadFuncs);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "/* using type: "
                                }, false));
        txt = Tpl.writeText(txt, a_type);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " */\n",
                                    "static int initialized = 0;\n",
                                    "void function"
                                }, false));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_system"));
        txt = Tpl.writeStr(txt, intString(a_n));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA *data, threadData_t *threadData)\n",
                                    "{\n",
                                    "  if(!initialized)\n",
                                    "  {\n",
                                    "      finished = 0;\n",
                                    "\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(6));
        txt = Tpl.writeText(txt, a_initlocks);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_threadLocksInit);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_threadLocksInit1);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "//set locks\n"
                                }, true));
        txt = Tpl.writeText(txt, a_assignLocks);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_threadAssignLocks);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_threadAssignLocks1);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_threadFuncCalls);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("initialized = 1;\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "  }\n",
                                    "\n",
                                    "  //Start the threads\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_threadReleaseLocks);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "//\"join\"\n"
                                }, true));
        txt = Tpl.writeText(txt, l_threadAssignLocks1);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;

    case ( txt,
           _,
           _,
           _,
           _,
           _,
           _,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_436;

protected function fun_437
  input Tpl.Text in_txt;
  input Option<tuple<HpcOmSimCode.Schedule, HpcOmSimCode.Schedule, HpcOmSimCode.Schedule>> in_a_hpcOmSchedulesOpt;
  input Tpl.Text in_a_type;
  input String in_a_modelNamePrefixStr;
  input Integer in_a_n;
  input String in_a_name;
  input list<SimCode.SimEqSystem> in_a_derivativEquations;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_hpcOmSchedulesOpt, in_a_type, in_a_modelNamePrefixStr, in_a_n, in_a_name, in_a_derivativEquations)
    local
      Tpl.Text txt;
      Tpl.Text a_type;
      String a_modelNamePrefixStr;
      Integer a_n;
      String a_name;
      list<SimCode.SimEqSystem> a_derivativEquations;
      array<list<HpcOmSimCode.Task>> i_hpcOmSchedule_threadTasks;
      list<HpcOmSimCode.Task> i_hpcOmSchedule_outgoingDepTasks;
      list<HpcOmSimCode.TaskList> i_hpcOmSchedule_tasksOfLevels;
      list<tuple<HpcOmSimCode.Task, list<Integer>>> i_hpcOmSchedule_tasks;
      String str_6;
      Tpl.Text l_assignLocks;
      Tpl.Text l_initlocks;
      Tpl.Text l_locks;
      Integer ret_2;
      Tpl.Text l_odeEqs;
      Tpl.Text l_taskEqs;

    case ( txt,
           SOME((HpcOmSimCode.EMPTYSCHEDULE(tasks = _), _, _)),
           _,
           a_modelNamePrefixStr,
           a_n,
           a_name,
           a_derivativEquations )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "void terminateHpcOmThreads()\n",
                                    "{\n",
                                    "}\n",
                                    "\n"
                                }, true));
        txt = functionXXX_system(txt, a_derivativEquations, a_name, a_n, a_modelNamePrefixStr);
      then txt;

    case ( txt,
           SOME((HpcOmSimCode.TASKDEPSCHEDULE(tasks = i_hpcOmSchedule_tasks), _, _)),
           a_type,
           a_modelNamePrefixStr,
           a_n,
           a_name,
           a_derivativEquations )
      equation
        l_taskEqs = functionXXX_system0_HPCOM_TaskDep(Tpl.emptyTxt, i_hpcOmSchedule_tasks, a_derivativEquations, Tpl.textString(a_type), a_name, a_modelNamePrefixStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "void terminateHpcOmThreads()\n",
                                    "{\n",
                                    "}\n",
                                    "\n",
                                    "/* using type: "
                                }, false));
        txt = Tpl.writeText(txt, a_type);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " */\n",
                                    "void function"
                                }, false));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_system"));
        txt = Tpl.writeStr(txt, intString(a_n));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA *data, threadData_t *threadData)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_taskEqs);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;

    case ( txt,
           SOME((HpcOmSimCode.LEVELSCHEDULE(tasksOfLevels = i_hpcOmSchedule_tasksOfLevels), _, _)),
           a_type,
           a_modelNamePrefixStr,
           a_n,
           a_name,
           a_derivativEquations )
      equation
        l_odeEqs = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_odeEqs = lm_410(l_odeEqs, i_hpcOmSchedule_tasksOfLevels, a_modelNamePrefixStr, a_type, a_name, a_derivativEquations);
        l_odeEqs = Tpl.popIter(l_odeEqs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "void terminateHpcOmThreads()\n",
                                    "{\n",
                                    "}\n",
                                    "\n",
                                    "/* using type: "
                                }, false));
        txt = Tpl.writeText(txt, a_type);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " */\n",
                                    "void function"
                                }, false));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_system"));
        txt = Tpl.writeStr(txt, intString(a_n));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA *data, threadData_t *threadData)\n",
                                    "{\n",
                                    "  int fail=0;\n",
                                    "  omp_set_dynamic(0);\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#pragma omp parallel num_threads("));
        ret_2 = Flags.getConfigInt(Flags.NUM_PROC);
        txt = Tpl.writeStr(txt, intString(ret_2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ")\n",
                                    "{\n",
                                    "    MMC_TRY_TOP()\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.writeText(txt, l_odeEqs);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("MMC_CATCH_TOP(fail=1)\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "if (fail) {\n",
                                    "  MMC_THROW_INTERNAL()\n",
                                    "}\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;

    case ( txt,
           SOME((HpcOmSimCode.THREADSCHEDULE(outgoingDepTasks = i_hpcOmSchedule_outgoingDepTasks, threadTasks = i_hpcOmSchedule_threadTasks), _, _)),
           a_type,
           a_modelNamePrefixStr,
           a_n,
           a_name,
           a_derivativEquations )
      equation
        l_locks = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_locks = lm_411(l_locks, i_hpcOmSchedule_outgoingDepTasks, a_type);
        l_locks = Tpl.popIter(l_locks);
        l_initlocks = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_initlocks = lm_412(l_initlocks, i_hpcOmSchedule_outgoingDepTasks, a_type);
        l_initlocks = Tpl.popIter(l_initlocks);
        l_assignLocks = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_assignLocks = lm_413(l_assignLocks, i_hpcOmSchedule_outgoingDepTasks, a_type);
        l_assignLocks = Tpl.popIter(l_assignLocks);
        str_6 = Tpl.textString(a_type);
        txt = fun_436(txt, str_6, l_assignLocks, l_initlocks, l_locks, a_n, a_modelNamePrefixStr, a_type, i_hpcOmSchedule_threadTasks, a_name, a_derivativEquations);
      then txt;

    case ( txt,
           _,
           _,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_437;

public function functionXXX_system_HPCOM
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_derivativEquations;
  input String a_name;
  input Integer a_n;
  input Option<tuple<HpcOmSimCode.Schedule, HpcOmSimCode.Schedule, HpcOmSimCode.Schedule>> a_hpcOmSchedulesOpt;
  input String a_modelNamePrefixStr;

  output Tpl.Text out_txt;
protected
  String ret_1;
  Tpl.Text l_type;
algorithm
  ret_1 := Flags.getConfigString(Flags.HPCOM_CODE);
  l_type := Tpl.writeStr(Tpl.emptyTxt, ret_1);
  out_txt := fun_437(txt, a_hpcOmSchedulesOpt, l_type, a_modelNamePrefixStr, a_n, a_name, a_derivativEquations);
end functionXXX_system_HPCOM;

protected function lm_439
  input Tpl.Text in_txt;
  input list<HpcOmSimCode.Task> in_items;
  input String in_a_modelNamePrefixStr;
  input String in_a_iType;
  input String in_a_name;
  input list<SimCode.SimEqSystem> in_a_derivativEquations;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefixStr, in_a_iType, in_a_name, in_a_derivativEquations)
    local
      Tpl.Text txt;
      list<HpcOmSimCode.Task> rest;
      String a_modelNamePrefixStr;
      String a_iType;
      String a_name;
      list<SimCode.SimEqSystem> a_derivativEquations;
      HpcOmSimCode.Task i_task;

    case ( txt,
           {},
           _,
           _,
           _,
           _ )
      then txt;

    case ( txt,
           i_task :: rest,
           a_modelNamePrefixStr,
           a_iType,
           a_name,
           a_derivativEquations )
      equation
        txt = functionXXX_system0_HPCOM_Level0Section(txt, a_derivativEquations, a_name, i_task, a_iType, a_modelNamePrefixStr);
        txt = Tpl.nextIter(txt);
        txt = lm_439(txt, rest, a_modelNamePrefixStr, a_iType, a_name, a_derivativEquations);
      then txt;
  end match;
end lm_439;

protected function lm_440
  input Tpl.Text in_txt;
  input list<HpcOmSimCode.Task> in_items;
  input String in_a_modelNamePrefixStr;
  input String in_a_iType;
  input String in_a_name;
  input list<SimCode.SimEqSystem> in_a_derivativEquations;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefixStr, in_a_iType, in_a_name, in_a_derivativEquations)
    local
      Tpl.Text txt;
      list<HpcOmSimCode.Task> rest;
      String a_modelNamePrefixStr;
      String a_iType;
      String a_name;
      list<SimCode.SimEqSystem> a_derivativEquations;
      HpcOmSimCode.Task i_task;

    case ( txt,
           {},
           _,
           _,
           _,
           _ )
      then txt;

    case ( txt,
           i_task :: rest,
           a_modelNamePrefixStr,
           a_iType,
           a_name,
           a_derivativEquations )
      equation
        txt = functionXXX_system0_HPCOM_Level0(txt, a_derivativEquations, a_name, i_task, a_iType, a_modelNamePrefixStr);
        txt = Tpl.nextIter(txt);
        txt = lm_440(txt, rest, a_modelNamePrefixStr, a_iType, a_name, a_derivativEquations);
      then txt;
  end match;
end lm_440;

protected function fun_441
  input Tpl.Text in_txt;
  input HpcOmSimCode.TaskList in_a_tasksOfLevel;
  input list<SimCode.SimEqSystem> in_a_derivativEquations;
  input String in_a_name;
  input String in_a_iType;
  input String in_a_modelNamePrefixStr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_tasksOfLevel, in_a_derivativEquations, in_a_name, in_a_iType, in_a_modelNamePrefixStr)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> a_derivativEquations;
      String a_name;
      String a_iType;
      String a_modelNamePrefixStr;
      list<HpcOmSimCode.Task> i_tasks;
      Tpl.Text l_odeEqs;

    case ( txt,
           HpcOmSimCode.PARALLELTASKLIST(tasks = i_tasks),
           a_derivativEquations,
           a_name,
           a_iType,
           a_modelNamePrefixStr )
      equation
        l_odeEqs = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_odeEqs = lm_439(l_odeEqs, i_tasks, a_modelNamePrefixStr, a_iType, a_name, a_derivativEquations);
        l_odeEqs = Tpl.popIter(l_odeEqs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "#pragma omp sections\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(3));
        txt = Tpl.writeText(txt, l_odeEqs);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;

    case ( txt,
           HpcOmSimCode.SERIALTASKLIST(tasks = i_tasks),
           a_derivativEquations,
           a_name,
           a_iType,
           a_modelNamePrefixStr )
      equation
        l_odeEqs = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_odeEqs = lm_440(l_odeEqs, i_tasks, a_modelNamePrefixStr, a_iType, a_name, a_derivativEquations);
        l_odeEqs = Tpl.popIter(l_odeEqs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "#pragma omp master\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(3));
        txt = Tpl.writeText(txt, l_odeEqs);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "#pragma omp barrier"
                                }, false));
      then txt;

    case ( txt,
           _,
           _,
           _,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;
  end match;
end fun_441;

public function functionXXX_system0_HPCOM_Level
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_derivativEquations;
  input String a_name;
  input HpcOmSimCode.TaskList a_tasksOfLevel;
  input String a_iType;
  input String a_modelNamePrefixStr;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_441(txt, a_tasksOfLevel, a_derivativEquations, a_name, a_iType, a_modelNamePrefixStr);
end functionXXX_system0_HPCOM_Level;

public function functionXXX_system0_HPCOM_Level0
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_derivativEquations;
  input String a_name;
  input HpcOmSimCode.Task a_iTask;
  input String a_iType;
  input String a_modelNamePrefixStr;

  output Tpl.Text out_txt;
algorithm
  out_txt := Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
  out_txt := function_HPCOM_Task(out_txt, a_derivativEquations, a_name, a_iTask, a_iType, a_modelNamePrefixStr);
  out_txt := Tpl.popBlock(out_txt);
end functionXXX_system0_HPCOM_Level0;

public function functionXXX_system0_HPCOM_Level0Section
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_derivativEquations;
  input String a_name;
  input HpcOmSimCode.Task a_iTask;
  input String a_iType;
  input String a_modelNamePrefixStr;

  output Tpl.Text out_txt;
algorithm
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                   "#pragma omp section\n",
                                   "{\n",
                                   "  int fail=0;\n",
                                   "  MMC_TRY_TOP()\n"
                               }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := function_HPCOM_Task(out_txt, a_derivativEquations, a_name, a_iTask, a_iType, a_modelNamePrefixStr);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "MMC_CATCH_TOP(fail=1)\n",
                                       "if (fail) {\n",
                                       "  MMC_THROW_INTERNAL()\n",
                                       "}\n"
                                   }, true));
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("}"));
end functionXXX_system0_HPCOM_Level0Section;

protected function lm_445
  input Tpl.Text in_txt;
  input list<tuple<HpcOmSimCode.Task, list<Integer>>> in_items;
  input String in_a_modelNamePrefixStr;
  input String in_a_name;
  input String in_a_iType;
  input list<SimCode.SimEqSystem> in_a_derivativEquations;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefixStr, in_a_name, in_a_iType, in_a_derivativEquations)
    local
      Tpl.Text txt;
      list<tuple<HpcOmSimCode.Task, list<Integer>>> rest;
      String a_modelNamePrefixStr;
      String a_name;
      String a_iType;
      list<SimCode.SimEqSystem> a_derivativEquations;
      tuple<HpcOmSimCode.Task, list<Integer>> i_t;

    case ( txt,
           {},
           _,
           _,
           _,
           _ )
      then txt;

    case ( txt,
           i_t :: rest,
           a_modelNamePrefixStr,
           a_name,
           a_iType,
           a_derivativEquations )
      equation
        txt = functionXXX_system0_HPCOM_TaskDep0(txt, i_t, a_derivativEquations, a_iType, a_name, a_modelNamePrefixStr);
        txt = Tpl.nextIter(txt);
        txt = lm_445(txt, rest, a_modelNamePrefixStr, a_name, a_iType, a_derivativEquations);
      then txt;
  end match;
end lm_445;

public function functionXXX_system0_HPCOM_TaskDep
  input Tpl.Text txt;
  input list<tuple<HpcOmSimCode.Task, list<Integer>>> a_tasks;
  input list<SimCode.SimEqSystem> a_derivativEquations;
  input String a_iType;
  input String a_name;
  input String a_modelNamePrefixStr;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_odeEqs;
algorithm
  l_odeEqs := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  l_odeEqs := lm_445(l_odeEqs, a_tasks, a_modelNamePrefixStr, a_name, a_iType, a_derivativEquations);
  l_odeEqs := Tpl.popIter(l_odeEqs);
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                   "\n",
                                   "int t[0];\n",
                                   "#pragma omp parallel\n",
                                   "{\n",
                                   "  #pragma omp master\n",
                                   "  {\n"
                               }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(6));
  out_txt := Tpl.writeText(out_txt, l_odeEqs);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "  }\n",
                                       "}"
                                   }, false));
end functionXXX_system0_HPCOM_TaskDep;

protected function lm_447
  input Tpl.Text in_txt;
  input list<Integer> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<Integer> rest;
      Integer i_p;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_p :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("t["));
        txt = Tpl.writeStr(txt, intString(i_p));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("]"));
        txt = Tpl.nextIter(txt);
        txt = lm_447(txt, rest);
      then txt;
  end match;
end lm_447;

protected function fun_448
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_parentDependencies;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_parentDependencies)
    local
      Tpl.Text txt;
      Tpl.Text a_parentDependencies;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_parentDependencies )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("depend(in:"));
        txt = Tpl.writeText(txt, a_parentDependencies);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;
  end match;
end fun_448;

public function functionXXX_system0_HPCOM_TaskDep0
  input Tpl.Text in_txt;
  input tuple<HpcOmSimCode.Task, list<Integer>> in_a_taskIn;
  input list<SimCode.SimEqSystem> in_a_derivativEquations;
  input String in_a_iType;
  input String in_a_name;
  input String in_a_modelNamePrefixStr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_taskIn, in_a_derivativEquations, in_a_iType, in_a_name, in_a_modelNamePrefixStr)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> a_derivativEquations;
      String a_iType;
      String a_name;
      String a_modelNamePrefixStr;
      Integer i_task_index;
      list<Integer> i_parents;
      HpcOmSimCode.Task i_task;
      Boolean ret_4;
      Integer ret_3;
      Tpl.Text l_depIn;
      Tpl.Text l_parentDependencies;
      Tpl.Text l_taskEqs;

    case ( txt,
           ((i_task as HpcOmSimCode.CALCTASK(index = i_task_index)), i_parents),
           a_derivativEquations,
           a_iType,
           a_name,
           a_modelNamePrefixStr )
      equation
        l_taskEqs = function_HPCOM_Task(Tpl.emptyTxt, a_derivativEquations, a_name, i_task, a_iType, a_modelNamePrefixStr);
        l_parentDependencies = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_parentDependencies = lm_447(l_parentDependencies, i_parents);
        l_parentDependencies = Tpl.popIter(l_parentDependencies);
        ret_3 = listLength(i_parents);
        ret_4 = intGt(ret_3, 0);
        l_depIn = fun_448(Tpl.emptyTxt, ret_4, l_parentDependencies);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#pragma omp task "));
        txt = Tpl.writeText(txt, l_depIn);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" depend(out:t["));
        txt = Tpl.writeStr(txt, intString(i_task_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "])\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.writeText(txt, l_taskEqs);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;

    case ( txt,
           _,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end functionXXX_system0_HPCOM_TaskDep0;

protected function lm_450
  input Tpl.Text in_txt;
  input list<list<HpcOmSimCode.Task>> in_items;
  input String in_a_modelNamePrefixStr;
  input String in_a_iType;
  input String in_a_name;
  input list<SimCode.SimEqSystem> in_a_derivativEquations;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefixStr, in_a_iType, in_a_name, in_a_derivativEquations)
    local
      Tpl.Text txt;
      list<list<HpcOmSimCode.Task>> rest;
      String a_modelNamePrefixStr;
      String a_iType;
      String a_name;
      list<SimCode.SimEqSystem> a_derivativEquations;
      list<HpcOmSimCode.Task> i_tt;

    case ( txt,
           {},
           _,
           _,
           _,
           _ )
      then txt;

    case ( txt,
           i_tt :: rest,
           a_modelNamePrefixStr,
           a_iType,
           a_name,
           a_derivativEquations )
      equation
        txt = functionXXX_system0_HPCOM_Thread0(txt, a_derivativEquations, a_name, i_tt, a_iType, a_modelNamePrefixStr);
        txt = Tpl.nextIter(txt);
        txt = lm_450(txt, rest, a_modelNamePrefixStr, a_iType, a_name, a_derivativEquations);
      then txt;
  end match;
end lm_450;

protected function fun_451
  input Tpl.Text in_txt;
  input String in_a_iType;
  input Tpl.Text in_a_odeEqs;
  input array<list<HpcOmSimCode.Task>> in_a_threadTasks;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_iType, in_a_odeEqs, in_a_threadTasks)
    local
      Tpl.Text txt;
      Tpl.Text a_odeEqs;
      array<list<HpcOmSimCode.Task>> a_threadTasks;
      Integer ret_0;

    case ( txt,
           "openmp",
           a_odeEqs,
           a_threadTasks )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "if (omp_get_dynamic())\n",
                                    "  omp_set_dynamic(0);\n",
                                    "#pragma omp parallel sections num_threads("
                                }, false));
        ret_0 = arrayLength(a_threadTasks);
        txt = Tpl.writeStr(txt, intString(ret_0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ")\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(3));
        txt = Tpl.writeText(txt, a_odeEqs);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;

    case ( txt,
           "pthreads",
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("//not implemented"));
      then txt;

    case ( txt,
           "pthreads_spin",
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("//not implemented"));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_451;

public function functionXXX_system0_HPCOM_Thread
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_derivativEquations;
  input String a_name;
  input array<list<HpcOmSimCode.Task>> a_threadTasks;
  input String a_iType;
  input String a_modelNamePrefixStr;

  output Tpl.Text out_txt;
protected
  list<list<HpcOmSimCode.Task>> ret_1;
  Tpl.Text l_odeEqs;
algorithm
  ret_1 := arrayList(a_threadTasks);
  l_odeEqs := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  l_odeEqs := lm_450(l_odeEqs, ret_1, a_modelNamePrefixStr, a_iType, a_name, a_derivativEquations);
  l_odeEqs := Tpl.popIter(l_odeEqs);
  out_txt := fun_451(txt, a_iType, l_odeEqs, a_threadTasks);
end functionXXX_system0_HPCOM_Thread;

protected function lm_453
  input Tpl.Text in_txt;
  input list<HpcOmSimCode.Task> in_items;
  input String in_a_modelNamePrefixStr;
  input String in_a_iType;
  input String in_a_name;
  input list<SimCode.SimEqSystem> in_a_derivativEquations;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefixStr, in_a_iType, in_a_name, in_a_derivativEquations)
    local
      Tpl.Text txt;
      list<HpcOmSimCode.Task> rest;
      String a_modelNamePrefixStr;
      String a_iType;
      String a_name;
      list<SimCode.SimEqSystem> a_derivativEquations;
      HpcOmSimCode.Task i_tt;

    case ( txt,
           {},
           _,
           _,
           _,
           _ )
      then txt;

    case ( txt,
           i_tt :: rest,
           a_modelNamePrefixStr,
           a_iType,
           a_name,
           a_derivativEquations )
      equation
        txt = function_HPCOM_Task(txt, a_derivativEquations, a_name, i_tt, a_iType, a_modelNamePrefixStr);
        txt = Tpl.nextIter(txt);
        txt = lm_453(txt, rest, a_modelNamePrefixStr, a_iType, a_name, a_derivativEquations);
      then txt;
  end match;
end lm_453;

protected function fun_454
  input Tpl.Text in_txt;
  input String in_a_iType;
  input Tpl.Text in_a_threadTasks;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_iType, in_a_threadTasks)
    local
      Tpl.Text txt;
      Tpl.Text a_threadTasks;

    case ( txt,
           "openmp",
           a_threadTasks )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "#pragma omp section\n",
                                    "{\n",
                                    "  int fail=0;\n",
                                    "  MMC_TRY_TOP()\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_threadTasks);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "MMC_CATCH_TOP(fail=1)\n",
                                    "if (fail) {\n",
                                    "  MMC_THROW_INTERNAL()\n",
                                    "}\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;

    case ( txt,
           "pthreads",
           a_threadTasks )
      equation
        txt = Tpl.writeText(txt, a_threadTasks);
      then txt;

    case ( txt,
           "pthreads_spin",
           a_threadTasks )
      equation
        txt = Tpl.writeText(txt, a_threadTasks);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_454;

public function functionXXX_system0_HPCOM_Thread0
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_derivativEquations;
  input String a_name;
  input list<HpcOmSimCode.Task> a_threadTaskList;
  input String a_iType;
  input String a_modelNamePrefixStr;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_threadTasks;
algorithm
  l_threadTasks := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  l_threadTasks := lm_453(l_threadTasks, a_threadTaskList, a_modelNamePrefixStr, a_iType, a_name, a_derivativEquations);
  l_threadTasks := Tpl.popIter(l_threadTasks);
  out_txt := fun_454(txt, a_iType, l_threadTasks);
end functionXXX_system0_HPCOM_Thread0;

protected function lm_456
  input Tpl.Text in_txt;
  input list<Integer> in_items;
  input String in_a_modelNamePrefixStr;
  input list<SimCode.SimEqSystem> in_a_derivativEquations;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefixStr, in_a_derivativEquations)
    local
      Tpl.Text txt;
      list<Integer> rest;
      String a_modelNamePrefixStr;
      list<SimCode.SimEqSystem> a_derivativEquations;
      Integer i_eq;

    case ( txt,
           {},
           _,
           _ )
      then txt;

    case ( txt,
           i_eq :: rest,
           a_modelNamePrefixStr,
           a_derivativEquations )
      equation
        txt = equationNamesHPCOM_Thread_(txt, i_eq, a_derivativEquations, SimCodeFunction.contextSimulationNonDiscrete, a_modelNamePrefixStr);
        txt = Tpl.nextIter(txt);
        txt = lm_456(txt, rest, a_modelNamePrefixStr, a_derivativEquations);
      then txt;
  end match;
end lm_456;

protected function lm_457
  input Tpl.Text in_txt;
  input list<Integer> in_items;
  input String in_a_modelNamePrefixStr;
  input list<SimCode.SimEqSystem> in_a_derivativEquations;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefixStr, in_a_derivativEquations)
    local
      Tpl.Text txt;
      list<Integer> rest;
      String a_modelNamePrefixStr;
      list<SimCode.SimEqSystem> a_derivativEquations;
      Integer i_eq;

    case ( txt,
           {},
           _,
           _ )
      then txt;

    case ( txt,
           i_eq :: rest,
           a_modelNamePrefixStr,
           a_derivativEquations )
      equation
        txt = equationNamesHPCOM_Thread_(txt, i_eq, a_derivativEquations, SimCodeFunction.contextSimulationNonDiscrete, a_modelNamePrefixStr);
        txt = Tpl.nextIter(txt);
        txt = lm_457(txt, rest, a_modelNamePrefixStr, a_derivativEquations);
      then txt;
  end match;
end lm_457;

protected function fun_458
  input Tpl.Text in_txt;
  input HpcOmSimCode.Task in_a_iTask;
  input list<SimCode.SimEqSystem> in_a_derivativEquations;
  input String in_a_iType;
  input String in_a_modelNamePrefixStr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_iTask, in_a_derivativEquations, in_a_iType, in_a_modelNamePrefixStr)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> a_derivativEquations;
      String a_iType;
      String a_modelNamePrefixStr;
      HpcOmSimCode.Task i_task;
      Integer i_task_index;
      list<Integer> i_task_eqIdc;
      Tpl.Text l_relLck;
      Tpl.Text l_assLck;
      Tpl.Text l_odeEqs;

    case ( txt,
           HpcOmSimCode.CALCTASK(eqIdc = i_task_eqIdc, index = i_task_index),
           a_derivativEquations,
           _,
           a_modelNamePrefixStr )
      equation
        l_odeEqs = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_odeEqs = lm_456(l_odeEqs, i_task_eqIdc, a_modelNamePrefixStr, a_derivativEquations);
        l_odeEqs = Tpl.popIter(l_odeEqs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("// Task "));
        txt = Tpl.writeStr(txt, intString(i_task_index));
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_odeEqs);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("// End Task "));
        txt = Tpl.writeStr(txt, intString(i_task_index));
      then txt;

    case ( txt,
           HpcOmSimCode.CALCTASK_LEVEL(eqIdc = i_task_eqIdc),
           a_derivativEquations,
           _,
           a_modelNamePrefixStr )
      equation
        l_odeEqs = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_odeEqs = lm_457(l_odeEqs, i_task_eqIdc, a_modelNamePrefixStr, a_derivativEquations);
        l_odeEqs = Tpl.popIter(l_odeEqs);
        txt = Tpl.writeText(txt, l_odeEqs);
      then txt;

    case ( txt,
           (i_task as HpcOmSimCode.DEPTASK(outgoing = false)),
           _,
           a_iType,
           _ )
      equation
        l_assLck = function_HPCOM_assignLockByDepTask(Tpl.emptyTxt, i_task, "lock", a_iType);
        txt = Tpl.writeText(txt, l_assLck);
      then txt;

    case ( txt,
           (i_task as HpcOmSimCode.DEPTASK(outgoing = true)),
           _,
           a_iType,
           _ )
      equation
        l_relLck = function_HPCOM_releaseLockByDepTask(Tpl.emptyTxt, i_task, "lock", a_iType);
        txt = Tpl.writeText(txt, l_relLck);
      then txt;

    case ( txt,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_458;

public function function_HPCOM_Task
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_derivativEquations;
  input String a_name;
  input HpcOmSimCode.Task a_iTask;
  input String a_iType;
  input String a_modelNamePrefixStr;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_458(txt, a_iTask, a_derivativEquations, a_iType, a_modelNamePrefixStr);
end function_HPCOM_Task;

public function function_HPCOM_getLockNameByDepTask
  input Tpl.Text in_txt;
  input HpcOmSimCode.Task in_a_depTask;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_depTask)
    local
      Tpl.Text txt;
      Integer i_targetIdx;
      Integer i_sourceIdx;

    case ( txt,
           HpcOmSimCode.DEPTASK(sourceTask = HpcOmSimCode.CALCTASK(index = i_sourceIdx), targetTask = HpcOmSimCode.CALCTASK(index = i_targetIdx)) )
      equation
        txt = Tpl.writeStr(txt, intString(i_sourceIdx));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeStr(txt, intString(i_targetIdx));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("invalidLockTask"));
      then txt;
  end match;
end function_HPCOM_getLockNameByDepTask;

public function function_HPCOM_initializeLockByDepTask
  input Tpl.Text txt;
  input HpcOmSimCode.Task a_depTask;
  input String a_lockPrefix;
  input String a_iType;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_lockName;
algorithm
  l_lockName := function_HPCOM_getLockNameByDepTask(Tpl.emptyTxt, a_depTask);
  out_txt := function_HPCOM_initializeLockByLockName(txt, Tpl.textString(l_lockName), a_lockPrefix, a_iType);
end function_HPCOM_initializeLockByDepTask;

protected function fun_462
  input Tpl.Text in_txt;
  input String in_a_iType;
  input String in_a_lockName;
  input String in_a_lockPrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_iType, in_a_lockName, in_a_lockPrefix)
    local
      Tpl.Text txt;
      String a_lockName;
      String a_lockPrefix;

    case ( txt,
           "openmp",
           a_lockName,
           a_lockPrefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("omp_init_lock(&"));
        txt = Tpl.writeStr(txt, a_lockPrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeStr(txt, a_lockName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;

    case ( txt,
           "pthreads",
           a_lockName,
           a_lockPrefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("pthread_mutex_init(&"));
        txt = Tpl.writeStr(txt, a_lockPrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeStr(txt, a_lockName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", NULL);"));
      then txt;

    case ( txt,
           "pthreads_spin",
           a_lockName,
           a_lockPrefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("pthread_spin_init(&"));
        txt = Tpl.writeStr(txt, a_lockPrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeStr(txt, a_lockName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", 0);"));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_462;

public function function_HPCOM_initializeLockByLockName
  input Tpl.Text txt;
  input String a_lockName;
  input String a_lockPrefix;
  input String a_iType;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_462(txt, a_iType, a_lockName, a_lockPrefix);
end function_HPCOM_initializeLockByLockName;

public function function_HPCOM_createLockByDepTask
  input Tpl.Text txt;
  input HpcOmSimCode.Task a_depTask;
  input String a_lockPrefix;
  input String a_iType;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_lockName;
algorithm
  l_lockName := function_HPCOM_getLockNameByDepTask(Tpl.emptyTxt, a_depTask);
  out_txt := function_HPCOM_createLockByLockName(txt, Tpl.textString(l_lockName), a_lockPrefix, a_iType);
end function_HPCOM_createLockByDepTask;

protected function fun_465
  input Tpl.Text in_txt;
  input String in_a_iType;
  input String in_a_lockName;
  input String in_a_lockPrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_iType, in_a_lockName, in_a_lockPrefix)
    local
      Tpl.Text txt;
      String a_lockName;
      String a_lockPrefix;

    case ( txt,
           "openmp",
           a_lockName,
           a_lockPrefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("static omp_lock_t "));
        txt = Tpl.writeStr(txt, a_lockPrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeStr(txt, a_lockName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           "pthreads",
           a_lockName,
           a_lockPrefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("static pthread_mutex_t "));
        txt = Tpl.writeStr(txt, a_lockPrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeStr(txt, a_lockName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           "pthreads_spin",
           a_lockName,
           a_lockPrefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("static pthread_spinlock_t "));
        txt = Tpl.writeStr(txt, a_lockPrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeStr(txt, a_lockName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_465;

public function function_HPCOM_createLockByLockName
  input Tpl.Text txt;
  input String a_lockName;
  input String a_lockPrefix;
  input String a_iType;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_465(txt, a_iType, a_lockName, a_lockPrefix);
end function_HPCOM_createLockByLockName;

public function function_HPCOM_assignLockByDepTask
  input Tpl.Text txt;
  input HpcOmSimCode.Task a_depTask;
  input String a_lockPrefix;
  input String a_iType;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_lockName;
algorithm
  l_lockName := function_HPCOM_getLockNameByDepTask(Tpl.emptyTxt, a_depTask);
  out_txt := function_HPCOM_assignLockByLockName(txt, Tpl.textString(l_lockName), a_lockPrefix, a_iType);
end function_HPCOM_assignLockByDepTask;

protected function fun_468
  input Tpl.Text in_txt;
  input String in_a_iType;
  input String in_a_lockName;
  input String in_a_lockPrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_iType, in_a_lockName, in_a_lockPrefix)
    local
      Tpl.Text txt;
      String a_lockName;
      String a_lockPrefix;

    case ( txt,
           "openmp",
           a_lockName,
           a_lockPrefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("omp_set_lock(&"));
        txt = Tpl.writeStr(txt, a_lockPrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeStr(txt, a_lockName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;

    case ( txt,
           "pthreads",
           a_lockName,
           a_lockPrefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("pthread_mutex_lock(&"));
        txt = Tpl.writeStr(txt, a_lockPrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeStr(txt, a_lockName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;

    case ( txt,
           "pthreads_spin",
           a_lockName,
           a_lockPrefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("pthread_spin_lock(&"));
        txt = Tpl.writeStr(txt, a_lockPrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeStr(txt, a_lockName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_468;

public function function_HPCOM_assignLockByLockName
  input Tpl.Text txt;
  input String a_lockName;
  input String a_lockPrefix;
  input String a_iType;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_468(txt, a_iType, a_lockName, a_lockPrefix);
end function_HPCOM_assignLockByLockName;

public function function_HPCOM_releaseLockByDepTask
  input Tpl.Text txt;
  input HpcOmSimCode.Task a_depTask;
  input String a_lockPrefix;
  input String a_iType;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_lockName;
algorithm
  l_lockName := function_HPCOM_getLockNameByDepTask(Tpl.emptyTxt, a_depTask);
  out_txt := function_HPCOM_releaseLockByLockName(txt, Tpl.textString(l_lockName), a_lockPrefix, a_iType);
end function_HPCOM_releaseLockByDepTask;

protected function fun_471
  input Tpl.Text in_txt;
  input String in_a_iType;
  input String in_a_lockName;
  input String in_a_lockPrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_iType, in_a_lockName, in_a_lockPrefix)
    local
      Tpl.Text txt;
      String a_lockName;
      String a_lockPrefix;

    case ( txt,
           "openmp",
           a_lockName,
           a_lockPrefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("omp_unset_lock(&"));
        txt = Tpl.writeStr(txt, a_lockPrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeStr(txt, a_lockName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;

    case ( txt,
           "pthreads",
           a_lockName,
           a_lockPrefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("pthread_mutex_unlock(&"));
        txt = Tpl.writeStr(txt, a_lockPrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeStr(txt, a_lockName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;

    case ( txt,
           "pthreads_spin",
           a_lockName,
           a_lockPrefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("pthread_spin_unlock(&"));
        txt = Tpl.writeStr(txt, a_lockPrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeStr(txt, a_lockName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_471;

public function function_HPCOM_releaseLockByLockName
  input Tpl.Text txt;
  input String a_lockName;
  input String a_lockPrefix;
  input String a_iType;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_471(txt, a_iType, a_lockName, a_lockPrefix);
end function_HPCOM_releaseLockByLockName;

public function functionXXX_system0_HPCOM_PThread_func
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_derivativEquations;
  input String a_name;
  input Integer a_n;
  input array<list<HpcOmSimCode.Task>> a_threadTasks;
  input String a_iType;
  input Integer a_idx;
  input String a_modelNamePrefixStr;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_relLock;
  Tpl.Text l_assLock;
  list<HpcOmSimCode.Task> ret_2;
  Integer ret_1;
  Tpl.Text l_taskEqs;
algorithm
  ret_1 := intAdd(a_idx, 1);
  ret_2 := arrayGet(a_threadTasks, ret_1);
  l_taskEqs := functionXXX_system0_HPCOM_Thread0(Tpl.emptyTxt, a_derivativEquations, a_name, ret_2, a_iType, a_modelNamePrefixStr);
  l_assLock := function_HPCOM_assignLockByLockName(Tpl.emptyTxt, intString(a_idx), "th_lock", "pthreads");
  l_relLock := function_HPCOM_releaseLockByLockName(Tpl.emptyTxt, intString(a_idx), "th_lock1", "pthreads");
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING("void function"));
  out_txt := Tpl.writeStr(out_txt, a_name);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("_system"));
  out_txt := Tpl.writeStr(out_txt, intString(a_n));
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("_thread_"));
  out_txt := Tpl.writeStr(out_txt, intString(a_idx));
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "(DATA *data, threadData_t *threadData)\n",
                                       "{\n",
                                       "  MMC_TRY_TOP()\n",
                                       "  while(1)\n",
                                       "  {\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(4));
  out_txt := Tpl.writeText(out_txt, l_assLock);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "if(finished)\n",
                                       "   return;\n",
                                       "\n"
                                   }, true));
  out_txt := Tpl.writeText(out_txt, l_taskEqs);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeText(out_txt, l_relLock);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "  }\n",
                                       "  MMC_CATCH_TOP(return;) /* No exit status?? */\n",
                                       "}"
                                   }, false));
end functionXXX_system0_HPCOM_PThread_func;

public function functionXXX_system0_HPCOM_PThread_call
  input Tpl.Text txt;
  input String a_name;
  input Integer a_n;
  input Integer a_idx;

  output Tpl.Text out_txt;
algorithm
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING("GC_pthread_create(&odeThread_"));
  out_txt := Tpl.writeStr(out_txt, intString(a_idx));
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING(", NULL, function"));
  out_txt := Tpl.writeStr(out_txt, a_name);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("_system"));
  out_txt := Tpl.writeStr(out_txt, intString(a_n));
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("_thread_"));
  out_txt := Tpl.writeStr(out_txt, intString(a_idx));
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING(", data);"));
end functionXXX_system0_HPCOM_PThread_call;

public function functionXXX_system0_HPCOM_PThread_decl
  input Tpl.Text txt;
  input Integer a_idx;

  output Tpl.Text out_txt;
algorithm
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING("static pthread_t odeThread_"));
  out_txt := Tpl.writeStr(out_txt, intString(a_idx));
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING(";"));
end functionXXX_system0_HPCOM_PThread_decl;

public function functionXXX_system0_HPCOM_PThread_start
  input Tpl.Text txt;
  input Integer a_idx;

  output Tpl.Text out_txt;
algorithm
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING("pthread_mutex_lock(&th_unlock_"));
  out_txt := Tpl.writeStr(out_txt, intString(a_idx));
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING(");"));
end functionXXX_system0_HPCOM_PThread_start;

protected function fun_477
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_mArg;
  input String in_a_modelNamePrefixStr;
  input Integer in_a_idx;
  input list<SimCode.SimEqSystem> in_a_derivativEquations;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_modelNamePrefixStr, in_a_idx, in_a_derivativEquations)
    local
      Tpl.Text txt;
      String a_modelNamePrefixStr;
      Integer a_idx;
      list<SimCode.SimEqSystem> a_derivativEquations;
      SimCode.SimEqSystem ret_1;
      Tpl.Text l_ix;

    case ( txt,
           SimCode.SES_ALGORITHM(statements = {}),
           _,
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_modelNamePrefixStr,
           a_idx,
           a_derivativEquations )
      equation
        ret_1 = HpcOmTaskGraph.getSimCodeEqByIndex(a_derivativEquations, a_idx);
        l_ix = CodegenUtilSimulation.equationIndex(Tpl.emptyTxt, ret_1);
        txt = CodegenUtil.symbolName(txt, a_modelNamePrefixStr, "eqFunction");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeText(txt, l_ix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(data, threadData);"));
      then txt;
  end match;
end fun_477;

protected function fun_478
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_mArg;
  input String in_a_modelNamePrefixStr;
  input Integer in_a_idx;
  input list<SimCode.SimEqSystem> in_a_derivativEquations;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_modelNamePrefixStr, in_a_idx, in_a_derivativEquations)
    local
      Tpl.Text txt;
      String a_modelNamePrefixStr;
      Integer a_idx;
      list<SimCode.SimEqSystem> a_derivativEquations;
      SimCode.SimEqSystem ret_1;
      Tpl.Text l_ix;

    case ( txt,
           SimCode.SES_ALGORITHM(statements = {}),
           _,
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_modelNamePrefixStr,
           a_idx,
           a_derivativEquations )
      equation
        ret_1 = HpcOmTaskGraph.getSimCodeEqByIndex(a_derivativEquations, a_idx);
        l_ix = CodegenUtilSimulation.equationIndex(Tpl.emptyTxt, ret_1);
        txt = CodegenUtil.symbolName(txt, a_modelNamePrefixStr, "eqFunction");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeText(txt, l_ix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(data, threadData);"));
      then txt;
  end match;
end fun_478;

protected function fun_479
  input Tpl.Text in_txt;
  input SimCodeFunction.Context in_a_context;
  input Integer in_a_idx;
  input list<SimCode.SimEqSystem> in_a_derivativEquations;
  input String in_a_modelNamePrefixStr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_context, in_a_idx, in_a_derivativEquations, in_a_modelNamePrefixStr)
    local
      Tpl.Text txt;
      Integer a_idx;
      list<SimCode.SimEqSystem> a_derivativEquations;
      String a_modelNamePrefixStr;
      SimCode.SimEqSystem ret_1;
      SimCode.SimEqSystem ret_0;

    case ( txt,
           SimCodeFunction.SIMULATION_CONTEXT(genDiscrete = true),
           a_idx,
           a_derivativEquations,
           a_modelNamePrefixStr )
      equation
        ret_0 = HpcOmTaskGraph.getSimCodeEqByIndex(a_derivativEquations, a_idx);
        txt = fun_477(txt, ret_0, a_modelNamePrefixStr, a_idx, a_derivativEquations);
      then txt;

    case ( txt,
           _,
           a_idx,
           a_derivativEquations,
           a_modelNamePrefixStr )
      equation
        ret_1 = HpcOmTaskGraph.getSimCodeEqByIndex(a_derivativEquations, a_idx);
        txt = fun_478(txt, ret_1, a_modelNamePrefixStr, a_idx, a_derivativEquations);
      then txt;
  end match;
end fun_479;

public function equationNamesHPCOM_Thread_
  input Tpl.Text txt;
  input Integer a_idx;
  input list<SimCode.SimEqSystem> a_derivativEquations;
  input SimCodeFunction.Context a_context;
  input String a_modelNamePrefixStr;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_479(txt, a_context, a_idx, a_derivativEquations, a_modelNamePrefixStr);
end equationNamesHPCOM_Thread_;

protected function lm_481
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input String in_a_modelNamePrefixStr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefixStr)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      String a_modelNamePrefixStr;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_eq :: rest,
           a_modelNamePrefixStr )
      equation
        txt = equationNames_(txt, i_eq, SimCodeFunction.contextSimulationNonDiscrete, a_modelNamePrefixStr);
        txt = Tpl.nextIter(txt);
        txt = lm_481(txt, rest, a_modelNamePrefixStr);
      then txt;
  end match;
end lm_481;

protected function lm_482
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input String in_a_modelNamePrefixStr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefixStr)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      String a_modelNamePrefixStr;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_eq :: rest,
           a_modelNamePrefixStr )
      equation
        txt = equationForward_(txt, i_eq, SimCodeFunction.contextSimulationNonDiscrete, a_modelNamePrefixStr);
        txt = Tpl.nextIter(txt);
        txt = lm_482(txt, rest, a_modelNamePrefixStr);
      then txt;
  end match;
end lm_482;

public function functionXXX_system
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_derivativEquations;
  input String a_name;
  input Integer a_n;
  input String a_modelNamePrefixStr;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_forwardEqs;
  Tpl.Text l_odeEqs;
algorithm
  l_odeEqs := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  l_odeEqs := lm_481(l_odeEqs, a_derivativEquations, a_modelNamePrefixStr);
  l_odeEqs := Tpl.popIter(l_odeEqs);
  l_forwardEqs := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  l_forwardEqs := lm_482(l_forwardEqs, a_derivativEquations, a_modelNamePrefixStr);
  l_forwardEqs := Tpl.popIter(l_forwardEqs);
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                   "\n",
                                   "/* forwarded equations */\n"
                               }, true));
  out_txt := Tpl.writeText(out_txt, l_forwardEqs);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "static void function"
                                   }, false));
  out_txt := Tpl.writeStr(out_txt, a_name);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("_system"));
  out_txt := Tpl.writeStr(out_txt, intString(a_n));
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "(DATA *data, threadData_t *threadData)\n",
                                       "{\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeText(out_txt, l_odeEqs);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("}"));
end functionXXX_system;

protected function lm_484
  input Tpl.Text in_txt;
  input list<list<SimCode.SimEqSystem>> in_items;
  input String in_a_modelNamePrefixStr;
  input String in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefixStr, in_a_name)
    local
      Tpl.Text txt;
      list<list<SimCode.SimEqSystem>> rest;
      String a_modelNamePrefixStr;
      String a_name;
      Integer x_i0;
      list<SimCode.SimEqSystem> i_eq;

    case ( txt,
           {},
           _,
           _ )
      then txt;

    case ( txt,
           i_eq :: rest,
           a_modelNamePrefixStr,
           a_name )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = functionXXX_system(txt, i_eq, a_name, x_i0, a_modelNamePrefixStr);
        txt = Tpl.nextIter(txt);
        txt = lm_484(txt, rest, a_modelNamePrefixStr, a_name);
      then txt;
  end match;
end lm_484;

protected function lm_485
  input Tpl.Text in_txt;
  input list<list<SimCode.SimEqSystem>> in_items;
  input String in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_name)
    local
      Tpl.Text txt;
      list<list<SimCode.SimEqSystem>> rest;
      String a_name;
      Integer x_i0;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           _ :: rest,
           a_name )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("function"));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_system"));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.nextIter(txt);
        txt = lm_485(txt, rest, a_name);
      then txt;
  end match;
end lm_485;

protected function fun_486
  input Tpl.Text in_txt;
  input Integer in_mArg;
  input Tpl.Text in_a_varDecls;
  input list<list<SimCode.SimEqSystem>> in_a_eqs;
  input Tpl.Text in_a_funcs;
  input String in_a_name;
  input Tpl.Text in_a_loop;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_loop;
algorithm
  (out_txt, out_a_varDecls, out_a_loop) :=
  match(in_txt, in_mArg, in_a_varDecls, in_a_eqs, in_a_funcs, in_a_name, in_a_loop)
    local
      Tpl.Text txt;
      Tpl.Text a_varDecls;
      list<list<SimCode.SimEqSystem>> a_eqs;
      Tpl.Text a_funcs;
      String a_name;
      Tpl.Text a_loop;
      Integer i_nFuncs;
      Tpl.Text l_funcNames;

    case ( txt,
           0,
           a_varDecls,
           _,
           _,
           a_name,
           a_loop )
      equation
        a_loop = Tpl.writeTok(a_loop, Tpl.ST_STRING("/* no "));
        a_loop = Tpl.writeStr(a_loop, a_name);
        a_loop = Tpl.writeTok(a_loop, Tpl.ST_STRING(" systems */"));
      then (txt, a_varDecls, a_loop);

    case ( txt,
           1,
           a_varDecls,
           _,
           a_funcs,
           a_name,
           a_loop )
      equation
        a_loop = Tpl.writeTok(a_loop, Tpl.ST_STRING("function"));
        a_loop = Tpl.writeStr(a_loop, a_name);
        a_loop = Tpl.writeTok(a_loop, Tpl.ST_STRING("_system0(data, threadData);"));
        txt = Tpl.writeText(txt, a_funcs);
      then (txt, a_varDecls, a_loop);

    case ( txt,
           i_nFuncs,
           a_varDecls,
           a_eqs,
           a_funcs,
           a_name,
           a_loop )
      equation
        l_funcNames = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_LINE(",\n")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_funcNames = lm_485(l_funcNames, a_eqs, a_name);
        l_funcNames = Tpl.popIter(l_funcNames);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING("int id;"));
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_NEW_LINE());
        a_loop = Tpl.writeTok(a_loop, Tpl.ST_STRING("for(id=0; id<"));
        a_loop = Tpl.writeStr(a_loop, intString(i_nFuncs));
        a_loop = Tpl.writeTok(a_loop, Tpl.ST_LINE("; id++) {\n"));
        a_loop = Tpl.pushBlock(a_loop, Tpl.BT_INDENT(2));
        a_loop = Tpl.writeTok(a_loop, Tpl.ST_STRING("function"));
        a_loop = Tpl.writeStr(a_loop, a_name);
        a_loop = Tpl.writeTok(a_loop, Tpl.ST_LINE("_systems[id](data, threadData);\n"));
        a_loop = Tpl.popBlock(a_loop);
        a_loop = Tpl.writeTok(a_loop, Tpl.ST_STRING("}"));
        txt = Tpl.writeText(txt, a_funcs);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "OMC_DISABLE_OPT\n",
                                    "static void (*function"
                                }, false));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_systems["));
        txt = Tpl.writeStr(txt, intString(i_nFuncs));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("])(DATA *, threadData_t *threadData) = {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_funcNames);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("};"));
      then (txt, a_varDecls, a_loop);
  end match;
end fun_486;

public function functionXXX_systems
  input Tpl.Text txt;
  input list<list<SimCode.SimEqSystem>> a_eqs;
  input String a_name;
  input Tpl.Text a_loop;
  input Tpl.Text a_varDecls;
  input String a_modelNamePrefixStr;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_loop;
  output Tpl.Text out_a_varDecls;
protected
  Integer ret_1;
  Tpl.Text l_funcs;
algorithm
  l_funcs := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  l_funcs := lm_484(l_funcs, a_eqs, a_modelNamePrefixStr, a_name);
  l_funcs := Tpl.popIter(l_funcs);
  ret_1 := listLength(a_eqs);
  (out_txt, out_a_varDecls, out_a_loop) := fun_486(txt, ret_1, a_varDecls, a_eqs, l_funcs, a_name, a_loop);
end functionXXX_systems;

protected function lm_488
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input Tpl.Text in_a_eqCalls;
  input String in_a_modelNamePrefixStr;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_eqFuncs;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_eqCalls;
  output Tpl.Text out_a_eqFuncs;
algorithm
  (out_txt, out_a_eqCalls, out_a_eqFuncs) :=
  match(in_txt, in_items, in_a_eqCalls, in_a_modelNamePrefixStr, in_a_context, in_a_eqFuncs)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      Tpl.Text a_eqCalls;
      String a_modelNamePrefixStr;
      SimCodeFunction.Context a_context;
      Tpl.Text a_eqFuncs;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           {},
           a_eqCalls,
           _,
           _,
           a_eqFuncs )
      then (txt, a_eqCalls, a_eqFuncs);

    case ( txt,
           i_eq :: rest,
           a_eqCalls,
           a_modelNamePrefixStr,
           a_context,
           a_eqFuncs )
      equation
        a_eqFuncs = equation_impl(a_eqFuncs, -1, i_eq, a_context, a_modelNamePrefixStr, false);
        a_eqCalls = equationNames_(a_eqCalls, i_eq, a_context, a_modelNamePrefixStr);
        (txt, a_eqCalls, a_eqFuncs) = lm_488(txt, rest, a_eqCalls, a_modelNamePrefixStr, a_context, a_eqFuncs);
      then (txt, a_eqCalls, a_eqFuncs);
  end match;
end lm_488;

protected function lm_489
  input Tpl.Text in_txt;
  input list<list<SimCode.SimEqSystem>> in_items;
  input Tpl.Text in_a_eqCalls;
  input String in_a_modelNamePrefixStr;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_eqFuncs;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_eqCalls;
  output Tpl.Text out_a_eqFuncs;
algorithm
  (out_txt, out_a_eqCalls, out_a_eqFuncs) :=
  match(in_txt, in_items, in_a_eqCalls, in_a_modelNamePrefixStr, in_a_context, in_a_eqFuncs)
    local
      Tpl.Text txt;
      list<list<SimCode.SimEqSystem>> rest;
      Tpl.Text a_eqCalls;
      String a_modelNamePrefixStr;
      SimCodeFunction.Context a_context;
      Tpl.Text a_eqFuncs;
      list<SimCode.SimEqSystem> i_equations;

    case ( txt,
           {},
           a_eqCalls,
           _,
           _,
           a_eqFuncs )
      then (txt, a_eqCalls, a_eqFuncs);

    case ( txt,
           i_equations :: rest,
           a_eqCalls,
           a_modelNamePrefixStr,
           a_context,
           a_eqFuncs )
      equation
        (txt, a_eqCalls, a_eqFuncs) = lm_488(txt, i_equations, a_eqCalls, a_modelNamePrefixStr, a_context, a_eqFuncs);
        (txt, a_eqCalls, a_eqFuncs) = lm_489(txt, rest, a_eqCalls, a_modelNamePrefixStr, a_context, a_eqFuncs);
      then (txt, a_eqCalls, a_eqFuncs);
  end match;
end lm_489;

public function createEquationsAndCalls
  input Tpl.Text txt;
  input list<list<SimCode.SimEqSystem>> a_systems;
  input String a_name;
  input SimCodeFunction.Context a_context;
  input String a_modelNamePrefixStr;
  input Tpl.Text a_eqCalls;
  input Tpl.Text a_eqFuncs;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_eqCalls;
  output Tpl.Text out_a_eqFuncs;
protected
  Tpl.Text l_0__;
algorithm
  (l_0__, out_a_eqCalls, out_a_eqFuncs) := lm_489(Tpl.emptyTxt, a_systems, a_eqCalls, a_modelNamePrefixStr, a_context, a_eqFuncs);
  out_txt := txt;
end createEquationsAndCalls;

protected function fun_491
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_ix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_ix)
    local
      Tpl.Text txt;
      Tpl.Text a_ix;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_ix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("SIM_PROF_TICK_EQ("));
        txt = Tpl.writeText(txt, a_ix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;
  end match;
end fun_491;

protected function fun_492
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_ix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_ix)
    local
      Tpl.Text txt;
      Tpl.Text a_ix;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_ix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("SIM_PROF_ACC_EQ("));
        txt = Tpl.writeText(txt, a_ix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;
  end match;
end fun_492;

protected function fun_493
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input Integer in_a_arrayIndex;
  input String in_a_name;
  input Tpl.Text in_a_forwardEqs;
  input String in_a_modelNamePrefixStr;
  input Tpl.Text in_a_arrayEqs;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_forwardEqs;
  output Tpl.Text out_a_arrayEqs;
algorithm
  (out_txt, out_a_forwardEqs, out_a_arrayEqs) :=
  match(in_txt, in_a_eq, in_a_arrayIndex, in_a_name, in_a_forwardEqs, in_a_modelNamePrefixStr, in_a_arrayEqs)
    local
      Tpl.Text txt;
      Integer a_arrayIndex;
      String a_name;
      Tpl.Text a_forwardEqs;
      String a_modelNamePrefixStr;
      Tpl.Text a_arrayEqs;
      SimCode.SimEqSystem i_eq;
      Boolean ret_2;
      Boolean ret_1;
      Tpl.Text l_ix;

    case ( txt,
           SimCode.SES_ALGORITHM(statements = {}),
           _,
           _,
           a_forwardEqs,
           _,
           a_arrayEqs )
      then (txt, a_forwardEqs, a_arrayEqs);

    case ( txt,
           i_eq,
           a_arrayIndex,
           a_name,
           a_forwardEqs,
           a_modelNamePrefixStr,
           a_arrayEqs )
      equation
        l_ix = CodegenUtilSimulation.equationIndex(Tpl.emptyTxt, i_eq);
        a_arrayEqs = CodegenUtil.symbolName(a_arrayEqs, a_modelNamePrefixStr, "eqFunction");
        a_arrayEqs = Tpl.writeTok(a_arrayEqs, Tpl.ST_STRING("_"));
        a_arrayEqs = Tpl.writeText(a_arrayEqs, l_ix);
        a_arrayEqs = Tpl.writeTok(a_arrayEqs, Tpl.ST_STRING(","));
        a_arrayEqs = Tpl.writeTok(a_arrayEqs, Tpl.ST_NEW_LINE());
        a_forwardEqs = Tpl.writeTok(a_forwardEqs, Tpl.ST_STRING("extern void "));
        a_forwardEqs = CodegenUtil.symbolName(a_forwardEqs, a_modelNamePrefixStr, "eqFunction");
        a_forwardEqs = Tpl.writeTok(a_forwardEqs, Tpl.ST_STRING("_"));
        a_forwardEqs = Tpl.writeText(a_forwardEqs, l_ix);
        a_forwardEqs = Tpl.writeTok(a_forwardEqs, Tpl.ST_STRING("(DATA* data, threadData_t *threadData);"));
        a_forwardEqs = Tpl.writeTok(a_forwardEqs, Tpl.ST_NEW_LINE());
        ret_1 = Config.profileAll();
        txt = fun_491(txt, ret_1, l_ix);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("function"));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_systems["));
        txt = Tpl.writeStr(txt, intString(a_arrayIndex));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("](data);\n"));
        ret_2 = Config.profileAll();
        txt = fun_492(txt, ret_2, l_ix);
      then (txt, a_forwardEqs, a_arrayEqs);
  end match;
end fun_493;

protected function fun_494
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_ix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_ix)
    local
      Tpl.Text txt;
      Tpl.Text a_ix;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_ix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("SIM_PROF_TICK_EQ("));
        txt = Tpl.writeText(txt, a_ix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;
  end match;
end fun_494;

protected function fun_495
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_ix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_ix)
    local
      Tpl.Text txt;
      Tpl.Text a_ix;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_ix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("SIM_PROF_ACC_EQ("));
        txt = Tpl.writeText(txt, a_ix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;
  end match;
end fun_495;

protected function fun_496
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input Integer in_a_arrayIndex;
  input String in_a_name;
  input Tpl.Text in_a_forwardEqs;
  input String in_a_modelNamePrefixStr;
  input Tpl.Text in_a_arrayEqs;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_forwardEqs;
  output Tpl.Text out_a_arrayEqs;
algorithm
  (out_txt, out_a_forwardEqs, out_a_arrayEqs) :=
  match(in_txt, in_a_eq, in_a_arrayIndex, in_a_name, in_a_forwardEqs, in_a_modelNamePrefixStr, in_a_arrayEqs)
    local
      Tpl.Text txt;
      Integer a_arrayIndex;
      String a_name;
      Tpl.Text a_forwardEqs;
      String a_modelNamePrefixStr;
      Tpl.Text a_arrayEqs;
      SimCode.SimEqSystem i_eq;
      Boolean ret_2;
      Boolean ret_1;
      Tpl.Text l_ix;

    case ( txt,
           SimCode.SES_ALGORITHM(statements = {}),
           _,
           _,
           a_forwardEqs,
           _,
           a_arrayEqs )
      then (txt, a_forwardEqs, a_arrayEqs);

    case ( txt,
           i_eq,
           a_arrayIndex,
           a_name,
           a_forwardEqs,
           a_modelNamePrefixStr,
           a_arrayEqs )
      equation
        l_ix = CodegenUtilSimulation.equationIndex(Tpl.emptyTxt, i_eq);
        a_arrayEqs = CodegenUtil.symbolName(a_arrayEqs, a_modelNamePrefixStr, "eqFunction");
        a_arrayEqs = Tpl.writeTok(a_arrayEqs, Tpl.ST_STRING("_"));
        a_arrayEqs = Tpl.writeText(a_arrayEqs, l_ix);
        a_arrayEqs = Tpl.writeTok(a_arrayEqs, Tpl.ST_STRING(","));
        a_arrayEqs = Tpl.writeTok(a_arrayEqs, Tpl.ST_NEW_LINE());
        a_forwardEqs = Tpl.writeTok(a_forwardEqs, Tpl.ST_STRING("extern void "));
        a_forwardEqs = CodegenUtil.symbolName(a_forwardEqs, a_modelNamePrefixStr, "eqFunction");
        a_forwardEqs = Tpl.writeTok(a_forwardEqs, Tpl.ST_STRING("_"));
        a_forwardEqs = Tpl.writeText(a_forwardEqs, l_ix);
        a_forwardEqs = Tpl.writeTok(a_forwardEqs, Tpl.ST_STRING("(DATA* data, threadData_t *threadData);"));
        a_forwardEqs = Tpl.writeTok(a_forwardEqs, Tpl.ST_NEW_LINE());
        ret_1 = Config.profileAll();
        txt = fun_494(txt, ret_1, l_ix);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("// "));
        txt = CodegenUtil.symbolName(txt, a_modelNamePrefixStr, "eqFunction");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeText(txt, l_ix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(data, threadData);\n",
                                    "function"
                                }, false));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_systems["));
        txt = Tpl.writeStr(txt, intString(a_arrayIndex));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("](data);\n"));
        ret_2 = Config.profileAll();
        txt = fun_495(txt, ret_2, l_ix);
      then (txt, a_forwardEqs, a_arrayEqs);
  end match;
end fun_496;

protected function fun_497
  input Tpl.Text in_txt;
  input SimCodeFunction.Context in_a_context;
  input SimCode.SimEqSystem in_a_eq;
  input String in_a_name;
  input Integer in_a_arrayIndex;
  input Tpl.Text in_a_arrayEqs;
  input Tpl.Text in_a_forwardEqs;
  input String in_a_modelNamePrefixStr;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_arrayEqs;
  output Tpl.Text out_a_forwardEqs;
algorithm
  (out_txt, out_a_arrayEqs, out_a_forwardEqs) :=
  match(in_txt, in_a_context, in_a_eq, in_a_name, in_a_arrayIndex, in_a_arrayEqs, in_a_forwardEqs, in_a_modelNamePrefixStr)
    local
      Tpl.Text txt;
      SimCode.SimEqSystem a_eq;
      String a_name;
      Integer a_arrayIndex;
      Tpl.Text a_arrayEqs;
      Tpl.Text a_forwardEqs;
      String a_modelNamePrefixStr;

    case ( txt,
           SimCodeFunction.SIMULATION_CONTEXT(genDiscrete = true),
           a_eq,
           a_name,
           a_arrayIndex,
           a_arrayEqs,
           a_forwardEqs,
           a_modelNamePrefixStr )
      equation
        (txt, a_forwardEqs, a_arrayEqs) = fun_493(txt, a_eq, a_arrayIndex, a_name, a_forwardEqs, a_modelNamePrefixStr, a_arrayEqs);
      then (txt, a_arrayEqs, a_forwardEqs);

    case ( txt,
           _,
           a_eq,
           a_name,
           a_arrayIndex,
           a_arrayEqs,
           a_forwardEqs,
           a_modelNamePrefixStr )
      equation
        (txt, a_forwardEqs, a_arrayEqs) = fun_496(txt, a_eq, a_arrayIndex, a_name, a_forwardEqs, a_modelNamePrefixStr, a_arrayEqs);
      then (txt, a_arrayEqs, a_forwardEqs);
  end match;
end fun_497;

public function equationNamesArrayFormat
  input Tpl.Text txt;
  input SimCode.SimEqSystem a_eq;
  input SimCodeFunction.Context a_context;
  input String a_name;
  input Integer a_arrayIndex;
  input Tpl.Text a_arrayEqs;
  input Tpl.Text a_forwardEqs;
  input String a_modelNamePrefixStr;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_arrayEqs;
  output Tpl.Text out_a_forwardEqs;
algorithm
  (out_txt, out_a_arrayEqs, out_a_forwardEqs) := fun_497(txt, a_context, a_eq, a_name, a_arrayIndex, a_arrayEqs, a_forwardEqs, a_modelNamePrefixStr);
end equationNamesArrayFormat;

protected function lm_499
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input String in_a_modelNamePrefixStr;
  input Tpl.Text in_a_forwardEqs;
  input Tpl.Text in_a_arrayEqs;
  input String in_a_name;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_forwardEqs;
  output Tpl.Text out_a_arrayEqs;
algorithm
  (out_txt, out_a_forwardEqs, out_a_arrayEqs) :=
  match(in_txt, in_items, in_a_modelNamePrefixStr, in_a_forwardEqs, in_a_arrayEqs, in_a_name)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      String a_modelNamePrefixStr;
      Tpl.Text a_forwardEqs;
      Tpl.Text a_arrayEqs;
      String a_name;
      Integer x_i0;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           {},
           _,
           a_forwardEqs,
           a_arrayEqs,
           _ )
      then (txt, a_forwardEqs, a_arrayEqs);

    case ( txt,
           i_eq :: rest,
           a_modelNamePrefixStr,
           a_forwardEqs,
           a_arrayEqs,
           a_name )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        (txt, a_arrayEqs, a_forwardEqs) = equationNamesArrayFormat(txt, i_eq, SimCodeFunction.contextSimulationNonDiscrete, a_name, x_i0, a_arrayEqs, a_forwardEqs, a_modelNamePrefixStr);
        txt = Tpl.nextIter(txt);
        (txt, a_forwardEqs, a_arrayEqs) = lm_499(txt, rest, a_modelNamePrefixStr, a_forwardEqs, a_arrayEqs, a_name);
      then (txt, a_forwardEqs, a_arrayEqs);
  end match;
end lm_499;

protected function fun_500
  input Tpl.Text in_txt;
  input list<list<SimCode.SimEqSystem>> in_a_eqlstlst;
  input String in_a_name;
  input Tpl.Text in_a_fncalls;
  input Tpl.Text in_a_nrfuncs;
  input String in_a_modelNamePrefixStr;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_fncalls;
  output Tpl.Text out_a_nrfuncs;
algorithm
  (out_txt, out_a_fncalls, out_a_nrfuncs) :=
  match(in_txt, in_a_eqlstlst, in_a_name, in_a_fncalls, in_a_nrfuncs, in_a_modelNamePrefixStr)
    local
      Tpl.Text txt;
      String a_name;
      Tpl.Text a_fncalls;
      Tpl.Text a_nrfuncs;
      String a_modelNamePrefixStr;
      list<SimCode.SimEqSystem> i_eqlst;
      Tpl.Text txt_3;
      Tpl.Text l_forwardEqs;
      Tpl.Text l_arrayEqs;
      Integer ret_0;

    case ( txt,
           {},
           a_name,
           a_fncalls,
           a_nrfuncs,
           _ )
      equation
        a_nrfuncs = Tpl.writeTok(a_nrfuncs, Tpl.ST_STRING("0"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/* no "));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " systems */\n",
                                    "static void (**function"
                                }, false));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_systems)(DATA *) = NULL;"));
      then (txt, a_fncalls, a_nrfuncs);

    case ( txt,
           {{}},
           a_name,
           a_fncalls,
           a_nrfuncs,
           _ )
      equation
        a_nrfuncs = Tpl.writeTok(a_nrfuncs, Tpl.ST_STRING("0"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/* no "));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " systems */\n",
                                    "static void (**function"
                                }, false));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_systems)(DATA *) = NULL;"));
      then (txt, a_fncalls, a_nrfuncs);

    case ( txt,
           {i_eqlst},
           a_name,
           a_fncalls,
           a_nrfuncs,
           a_modelNamePrefixStr )
      equation
        ret_0 = listLength(i_eqlst);
        a_nrfuncs = Tpl.writeStr(a_nrfuncs, intString(ret_0));
        l_arrayEqs = Tpl.emptyTxt;
        l_forwardEqs = Tpl.emptyTxt;
        a_fncalls = Tpl.pushIter(a_fncalls, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (a_fncalls, l_forwardEqs, l_arrayEqs) = lm_499(a_fncalls, i_eqlst, a_modelNamePrefixStr, l_forwardEqs, l_arrayEqs, a_name);
        a_fncalls = Tpl.popIter(a_fncalls);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/* forwarded equations */\n"));
        txt = Tpl.writeText(txt, l_forwardEqs);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "static void (*function"
                                }, false));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_systems["));
        txt = Tpl.writeText(txt, a_nrfuncs);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("])(DATA *,  threadData_t *) = {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_arrayEqs);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "};\n",
                                    "\n"
                                }, true));
      then (txt, a_fncalls, a_nrfuncs);

    case ( txt,
           {_ :: _},
           a_name,
           a_fncalls,
           a_nrfuncs,
           _ )
      equation
        txt_3 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("TODO more than ODE list in "));
        txt_3 = Tpl.writeStr(txt_3, a_name);
        txt_3 = Tpl.writeTok(txt_3, Tpl.ST_STRING(" systems"));
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 4047, 9), Tpl.textString(txt_3));
      then (txt, a_fncalls, a_nrfuncs);

    case ( txt,
           _,
           _,
           a_fncalls,
           a_nrfuncs,
           _ )
      then (txt, a_fncalls, a_nrfuncs);
  end match;
end fun_500;

public function functionXXX_systems_arrayFormat
  input Tpl.Text txt;
  input list<list<SimCode.SimEqSystem>> a_eqlstlst;
  input String a_name;
  input Tpl.Text a_fncalls;
  input Tpl.Text a_nrfuncs;
  input Tpl.Text a_varDecls;
  input String a_modelNamePrefixStr;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_fncalls;
  output Tpl.Text out_a_nrfuncs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_fncalls, out_a_nrfuncs) := fun_500(txt, a_eqlstlst, a_name, a_fncalls, a_nrfuncs, a_modelNamePrefixStr);
  out_a_varDecls := a_varDecls;
end functionXXX_systems_arrayFormat;

protected function fun_502
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_nrfuncs;
  input String in_a_modelNamePrefix;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_fncalls;
  input list<list<SimCode.SimEqSystem>> in_a_derivativEquations;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_nrfuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_fncalls;
algorithm
  (out_txt, out_a_nrfuncs, out_a_varDecls, out_a_fncalls) :=
  match(in_txt, in_mArg, in_a_nrfuncs, in_a_modelNamePrefix, in_a_varDecls, in_a_fncalls, in_a_derivativEquations)
    local
      Tpl.Text txt;
      Tpl.Text a_nrfuncs;
      String a_modelNamePrefix;
      Tpl.Text a_varDecls;
      Tpl.Text a_fncalls;
      list<list<SimCode.SimEqSystem>> a_derivativEquations;

    case ( txt,
           false,
           a_nrfuncs,
           a_modelNamePrefix,
           a_varDecls,
           a_fncalls,
           a_derivativEquations )
      equation
        (txt, a_fncalls, a_varDecls) = functionXXX_systems(txt, a_derivativEquations, "ODE", a_fncalls, a_varDecls, a_modelNamePrefix);
      then (txt, a_nrfuncs, a_varDecls, a_fncalls);

    case ( txt,
           _,
           a_nrfuncs,
           a_modelNamePrefix,
           a_varDecls,
           a_fncalls,
           a_derivativEquations )
      equation
        (txt, a_fncalls, a_nrfuncs, a_varDecls) = functionXXX_systems_arrayFormat(txt, a_derivativEquations, "ODE", a_fncalls, a_nrfuncs, a_varDecls, a_modelNamePrefix);
      then (txt, a_nrfuncs, a_varDecls, a_fncalls);
  end match;
end fun_502;

protected function fun_503
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Option<tuple<HpcOmSimCode.Schedule, HpcOmSimCode.Schedule, HpcOmSimCode.Schedule>> in_a_hpcOmSchedules;
  input Tpl.Text in_a_nrfuncs;
  input String in_a_modelNamePrefix;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_fncalls;
  input list<list<SimCode.SimEqSystem>> in_a_derivativEquations;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_nrfuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_fncalls;
algorithm
  (out_txt, out_a_nrfuncs, out_a_varDecls, out_a_fncalls) :=
  match(in_txt, in_mArg, in_a_hpcOmSchedules, in_a_nrfuncs, in_a_modelNamePrefix, in_a_varDecls, in_a_fncalls, in_a_derivativEquations)
    local
      Tpl.Text txt;
      Option<tuple<HpcOmSimCode.Schedule, HpcOmSimCode.Schedule, HpcOmSimCode.Schedule>> a_hpcOmSchedules;
      Tpl.Text a_nrfuncs;
      String a_modelNamePrefix;
      Tpl.Text a_varDecls;
      Tpl.Text a_fncalls;
      list<list<SimCode.SimEqSystem>> a_derivativEquations;
      Boolean ret_0;

    case ( txt,
           false,
           _,
           a_nrfuncs,
           a_modelNamePrefix,
           a_varDecls,
           a_fncalls,
           a_derivativEquations )
      equation
        ret_0 = Flags.getConfigBool(Flags.PARMODAUTO);
        (txt, a_nrfuncs, a_varDecls, a_fncalls) = fun_502(txt, ret_0, a_nrfuncs, a_modelNamePrefix, a_varDecls, a_fncalls, a_derivativEquations);
      then (txt, a_nrfuncs, a_varDecls, a_fncalls);

    case ( txt,
           _,
           a_hpcOmSchedules,
           a_nrfuncs,
           a_modelNamePrefix,
           a_varDecls,
           a_fncalls,
           a_derivativEquations )
      equation
        (txt, a_fncalls, a_varDecls) = functionXXX_systems_HPCOM(txt, a_derivativEquations, "ODE", a_fncalls, a_varDecls, a_hpcOmSchedules, a_modelNamePrefix);
      then (txt, a_nrfuncs, a_varDecls, a_fncalls);
  end match;
end fun_503;

protected function fun_504
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if (measure_time_flag) "));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_504;

protected function fun_505
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_fncalls;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_fncalls)
    local
      Tpl.Text txt;
      Tpl.Text a_fncalls;

    case ( txt,
           false,
           a_fncalls )
      equation
        txt = Tpl.writeText(txt, a_fncalls);
      then txt;

    case ( txt,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("PM_evaluate_ODE_system(pm_model);"));
      then txt;
  end match;
end fun_505;

protected function fun_506
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if (measure_time_flag) "));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_506;

public function functionODE
  input Tpl.Text txt;
  input list<list<SimCode.SimEqSystem>> a_derivativEquations;
  input Tpl.Text a_method;
  input Option<tuple<HpcOmSimCode.Schedule, HpcOmSimCode.Schedule, HpcOmSimCode.Schedule>> a_hpcOmSchedules;
  input String a_modelNamePrefix;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_method;
protected
  Boolean ret_9;
  Boolean ret_8;
  Boolean ret_7;
  Tpl.Text l_tmp;
  Boolean ret_5;
  Tpl.Text l_systems;
  Tpl.Text l_fncalls;
  Tpl.Text l_varDecls;
  Tpl.Text l_varDecls2;
  Tpl.Text l_nrfuncs;
algorithm
  System.tmpTickReset(0);
  l_nrfuncs := Tpl.emptyTxt;
  l_varDecls2 := Tpl.emptyTxt;
  l_varDecls := Tpl.emptyTxt;
  l_fncalls := Tpl.emptyTxt;
  ret_5 := Flags.isSet(Flags.HPCOM);
  (l_systems, l_nrfuncs, l_varDecls, l_fncalls) := fun_503(Tpl.emptyTxt, ret_5, a_hpcOmSchedules, l_nrfuncs, a_modelNamePrefix, l_varDecls, l_fncalls, a_derivativEquations);
  l_tmp := Tpl.emptyTxt;
  out_txt := Tpl.writeText(txt, l_tmp);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeText(out_txt, l_systems);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "int "
                                   }, false));
  out_txt := CodegenUtil.symbolName(out_txt, a_modelNamePrefix, "functionODE");
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "(DATA *data, threadData_t *threadData)\n",
                                       "{\n",
                                       "  TRACE_PUSH\n",
                                       "#if !defined(OMC_MINIMAL_RUNTIME)\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  ret_7 := Config.profileFunctions();
  out_txt := fun_504(out_txt, ret_7);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("rt_tick(SIM_TIMER_FUNCTION_ODE);\n"));
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "#endif\n",
                                       "\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeText(out_txt, l_varDecls);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "data->simulationInfo->callStatistics.functionODE++;\n",
                                       "\n"
                                   }, true));
  out_txt := CodegenUtil.symbolName(out_txt, a_modelNamePrefix, "functionLocalKnownVars");
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("(data, threadData);\n"));
  ret_8 := Flags.getConfigBool(Flags.PARMODAUTO);
  out_txt := fun_505(out_txt, ret_8, l_fncalls);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_NEW_LINE());
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("#if !defined(OMC_MINIMAL_RUNTIME)\n"));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  ret_9 := Config.profileFunctions();
  out_txt := fun_506(out_txt, ret_9);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("rt_accumulate(SIM_TIMER_FUNCTION_ODE);\n"));
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "#endif\n",
                                       "\n",
                                       "  TRACE_POP\n",
                                       "  return 0;\n",
                                       "}"
                                   }, false));
  out_a_method := a_method;
end functionODE;

protected function fun_508
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if (measure_time_flag) "));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_508;

protected function fun_509
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if (measure_time_flag) "));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_509;

public function functionAlgebraic
  input Tpl.Text txt;
  input list<list<SimCode.SimEqSystem>> a_algebraicEquations;
  input String a_modelNamePrefix;

  output Tpl.Text out_txt;
protected
  Boolean ret_4;
  Boolean ret_3;
  Tpl.Text l_systems;
  Tpl.Text l_fncalls;
  Tpl.Text l_varDecls;
algorithm
  l_varDecls := Tpl.emptyTxt;
  l_fncalls := Tpl.emptyTxt;
  (l_systems, l_fncalls, l_varDecls) := functionXXX_systems(Tpl.emptyTxt, a_algebraicEquations, "Alg", l_fncalls, l_varDecls, a_modelNamePrefix);
  out_txt := Tpl.writeText(txt, l_systems);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "/* for continuous time variables */\n",
                                       "int "
                                   }, false));
  out_txt := CodegenUtil.symbolName(out_txt, a_modelNamePrefix, "functionAlgebraics");
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "(DATA *data, threadData_t *threadData)\n",
                                       "{\n",
                                       "  TRACE_PUSH\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeText(out_txt, l_varDecls);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_NEW_LINE());
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("#if !defined(OMC_MINIMAL_RUNTIME)\n"));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  ret_3 := Config.profileFunctions();
  out_txt := fun_508(out_txt, ret_3);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("rt_tick(SIM_TIMER_ALGEBRAICS);\n"));
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "#endif\n",
                                       "  data->simulationInfo->callStatistics.functionAlgebraics++;\n",
                                       "\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeText(out_txt, l_fncalls);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_NEW_LINE());
  out_txt := CodegenUtil.symbolName(out_txt, a_modelNamePrefix, "function_savePreSynchronous");
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "(data, threadData);\n",
                                       "\n"
                                   }, true));
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("#if !defined(OMC_MINIMAL_RUNTIME)\n"));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  ret_4 := Config.profileFunctions();
  out_txt := fun_509(out_txt, ret_4);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("rt_accumulate(SIM_TIMER_ALGEBRAICS);\n"));
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "#endif\n",
                                       "\n",
                                       "  TRACE_POP\n",
                                       "  return 0;\n",
                                       "}"
                                   }, false));
end functionAlgebraic;

protected function fun_511
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if (measure_time_flag) "));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_511;

protected function fun_512
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if (measure_time_flag) "));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_512;

public function evaluateDAEResiduals
  input Tpl.Text txt;
  input list<list<SimCode.SimEqSystem>> a_resEquations;
  input String a_modelNamePrefix;

  output Tpl.Text out_txt;
protected
  Boolean ret_4;
  Boolean ret_3;
  Tpl.Text l_systems;
  Tpl.Text l_eqCalls;
  Tpl.Text l_eqFuncs;
algorithm
  l_eqFuncs := Tpl.emptyTxt;
  l_eqCalls := Tpl.emptyTxt;
  (l_systems, l_eqCalls, l_eqFuncs) := createEquationsAndCalls(Tpl.emptyTxt, a_resEquations, "DAERes", SimCodeFunction.contextDAEmode, a_modelNamePrefix, l_eqCalls, l_eqFuncs);
  out_txt := Tpl.writeTok(txt, Tpl.ST_LINE("/*residual equations*/\n"));
  out_txt := Tpl.writeText(out_txt, l_eqFuncs);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "/* for residuals DAE variables */\n",
                                       "OMC_DISABLE_OPT\n",
                                       "int "
                                   }, false));
  out_txt := CodegenUtil.symbolName(out_txt, a_modelNamePrefix, "evaluateDAEResiduals");
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "(DATA *data, threadData_t *threadData, int currentEvalStage)\n",
                                       "{\n",
                                       "  TRACE_PUSH\n",
                                       "  int evalStages;\n",
                                       "  data->simulationInfo->callStatistics.functionEvalDAE++;\n",
                                       "\n",
                                       "#if !defined(OMC_MINIMAL_RUNTIME)\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  ret_3 := Config.profileFunctions();
  out_txt := fun_511(out_txt, ret_3);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("rt_tick(SIM_TIMER_DAE);\n"));
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "#endif\n",
                                       "\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeText(out_txt, l_eqCalls);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_NEW_LINE());
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("#if !defined(OMC_MINIMAL_RUNTIME)\n"));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  ret_4 := Config.profileFunctions();
  out_txt := fun_512(out_txt, ret_4);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("rt_accumulate(SIM_TIMER_DAE);\n"));
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "#endif\n",
                                       "\n",
                                       "  TRACE_POP\n",
                                       "  return 0;\n",
                                       "}"
                                   }, false));
end evaluateDAEResiduals;

protected function fun_514
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_a_var;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_var)
    local
      Tpl.Text txt;
      DAE.ComponentRef i_name;

    case ( txt,
           SimCodeVar.SIMVAR(name = i_name) )
      equation
        txt = CodegenCFunctions.crefToIndex(txt, i_name);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_514;

protected function lm_515
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = fun_514(txt, i_var);
        txt = Tpl.nextIter(txt);
        txt = lm_515(txt, rest);
      then txt;
  end match;
end lm_515;

public function genVarIndexes
  input Tpl.Text txt;
  input list<SimCodeVar.SimVar> a_vars;
  input String a_arrayName;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_varIndexes;
  Integer ret_1;
  Tpl.Text l_size;
algorithm
  ret_1 := listLength(a_vars);
  l_size := Tpl.writeStr(Tpl.emptyTxt, intString(ret_1));
  l_varIndexes := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  l_varIndexes := lm_515(l_varIndexes, a_vars);
  l_varIndexes := Tpl.popIter(l_varIndexes);
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING("const int "));
  out_txt := Tpl.writeStr(out_txt, a_arrayName);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("["));
  out_txt := Tpl.writeText(out_txt, l_size);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("] = {"));
  out_txt := Tpl.writeText(out_txt, l_varIndexes);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("};"));
end genVarIndexes;

public function initializeDAEmodeData
  input Tpl.Text txt;
  input Integer a_nResVars;
  input list<SimCodeVar.SimVar> a_algVars;
  input Integer a_nAuxVars;
  input SimCode.SparsityPattern a_sparsepattern;
  input list<list<Integer>> a_colorList;
  input Integer a_maxColor;
  input String a_modelNamePrefix;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_algIndexes;
  Tpl.Text l_maxColorStr;
  Tpl.Text l_colorString;
  Integer ret_11;
  list<list<Integer>> ret_10;
  Tpl.Text l_rowIndex;
  Integer ret_8;
  Tpl.Text l_colPtr;
  Integer ret_6;
  list<list<Integer>> ret_5;
  Tpl.Text l_sizeNNZ;
  Integer ret_3;
  Tpl.Text l_sizeCols;
  Integer ret_1;
  Tpl.Text l_nAlgVars;
algorithm
  ret_1 := listLength(a_algVars);
  l_nAlgVars := Tpl.writeStr(Tpl.emptyTxt, intString(ret_1));
  ret_3 := listLength(a_sparsepattern);
  l_sizeCols := Tpl.writeStr(Tpl.emptyTxt, intString(ret_3));
  ret_5 := List.unzipSecond(a_sparsepattern);
  ret_6 := List.lengthListElements(ret_5);
  l_sizeNNZ := Tpl.writeStr(Tpl.emptyTxt, intString(ret_6));
  ret_8 := listLength(a_sparsepattern);
  l_colPtr := genSPCRSPtr(Tpl.emptyTxt, ret_8, a_sparsepattern, "colPtrIndex");
  ret_10 := List.unzipSecond(a_sparsepattern);
  ret_11 := List.lengthListElements(ret_10);
  l_rowIndex := genSPCRSRows(Tpl.emptyTxt, ret_11, a_sparsepattern, "rowIndex");
  l_colorString := genSPColors(Tpl.emptyTxt, a_colorList, "daeModeData->sparsePattern->colorCols");
  l_maxColorStr := Tpl.writeStr(Tpl.emptyTxt, intString(a_maxColor));
  l_algIndexes := genVarIndexes(Tpl.emptyTxt, a_algVars, "algIndexes");
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                   "/* initialize the daeMode variables */\n",
                                   "OMC_DISABLE_OPT\n",
                                   "int "
                               }, false));
  out_txt := CodegenUtil.symbolName(out_txt, a_modelNamePrefix, "initializeDAEmodeData");
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "(DATA *inData, DAEMODE_DATA* daeModeData)\n",
                                       "{\n",
                                       "  TRACE_PUSH\n",
                                       "  DATA* data = ((DATA*)inData);\n",
                                       "  /* sparse patterns */\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeText(out_txt, l_colPtr);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeText(out_txt, l_rowIndex);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeText(out_txt, l_algIndexes);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "int i = 0;\n",
                                       "\n",
                                       "daeModeData->nResidualVars = "
                                   }, false));
  out_txt := Tpl.writeStr(out_txt, intString(a_nResVars));
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       ";\n",
                                       "daeModeData->nAlgebraicDAEVars = "
                                   }, false));
  out_txt := Tpl.writeText(out_txt, l_nAlgVars);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       ";\n",
                                       "daeModeData->nAuxiliaryVars = "
                                   }, false));
  out_txt := Tpl.writeStr(out_txt, intString(a_nAuxVars));
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       ";\n",
                                       "\n",
                                       "daeModeData->residualVars = (double*) malloc(sizeof(double)*"
                                   }, false));
  out_txt := Tpl.writeStr(out_txt, intString(a_nResVars));
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       ");\n",
                                       "daeModeData->auxiliaryVars = (double*) malloc(sizeof(double)*"
                                   }, false));
  out_txt := Tpl.writeStr(out_txt, intString(a_nAuxVars));
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       ");\n",
                                       "\n",
                                       "/* set the function pointer */\n",
                                       "daeModeData->evaluateDAEResiduals = "
                                   }, false));
  out_txt := CodegenUtil.symbolName(out_txt, a_modelNamePrefix, "evaluateDAEResiduals");
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       ";\n",
                                       "\n",
                                       "/* prepare algebraic indexes */\n",
                                       "daeModeData->algIndexes = (int*) malloc(sizeof(int)*"
                                   }, false));
  out_txt := Tpl.writeText(out_txt, l_nAlgVars);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       ");\n",
                                       "memcpy(daeModeData->algIndexes, algIndexes, "
                                   }, false));
  out_txt := Tpl.writeText(out_txt, l_nAlgVars);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "*sizeof(int));\n",
                                       "/* intialize sparse pattern */\n",
                                       "daeModeData->sparsePattern = (SPARSE_PATTERN*) malloc(sizeof(SPARSE_PATTERN));\n",
                                       "\n",
                                       "daeModeData->sparsePattern->leadindex = (unsigned int*) malloc(("
                                   }, false));
  out_txt := Tpl.writeText(out_txt, l_sizeCols);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "+1)*sizeof(int));\n",
                                       "daeModeData->sparsePattern->index = (unsigned int*) malloc("
                                   }, false));
  out_txt := Tpl.writeText(out_txt, l_sizeNNZ);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "*sizeof(int));\n",
                                       "daeModeData->sparsePattern->numberOfNoneZeros = "
                                   }, false));
  out_txt := Tpl.writeText(out_txt, l_sizeNNZ);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       ";\n",
                                       "daeModeData->sparsePattern->colorCols = (unsigned int*) malloc("
                                   }, false));
  out_txt := Tpl.writeText(out_txt, l_sizeCols);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "*sizeof(int));\n",
                                       "daeModeData->sparsePattern->maxColors = "
                                   }, false));
  out_txt := Tpl.writeText(out_txt, l_maxColorStr);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       ";\n",
                                       "\n",
                                       "/* write lead index of compressed sparse column */\n",
                                       "memcpy(daeModeData->sparsePattern->leadindex, colPtrIndex, (1+"
                                   }, false));
  out_txt := Tpl.writeText(out_txt, l_sizeCols);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       ")*sizeof(int));\n",
                                       "/* makek CRS compatible */\n",
                                       "for(i=2;i<"
                                   }, false));
  out_txt := Tpl.writeText(out_txt, l_sizeCols);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "+1;++i)\n",
                                       "  daeModeData->sparsePattern->leadindex[i] += daeModeData->sparsePattern->leadindex[i-1];\n",
                                       "/* call sparse index */\n",
                                       "memcpy(daeModeData->sparsePattern->index, rowIndex, "
                                   }, false));
  out_txt := Tpl.writeText(out_txt, l_sizeNNZ);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "*sizeof(int));\n",
                                       "\n",
                                       "/* write color array */\n"
                                   }, true));
  out_txt := Tpl.writeText(out_txt, l_colorString);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "TRACE_POP\n",
                                       "return 0;\n"
                                   }, true));
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("}"));
end initializeDAEmodeData;

protected function lm_518
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input String in_a_modelNamePrefix;
  input Tpl.Text in_a_eqfuncs;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_eqfuncs;
algorithm
  (out_txt, out_a_eqfuncs) :=
  match(in_txt, in_items, in_a_modelNamePrefix, in_a_eqfuncs)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      String a_modelNamePrefix;
      Tpl.Text a_eqfuncs;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           {},
           _,
           a_eqfuncs )
      then (txt, a_eqfuncs);

    case ( txt,
           i_eq :: rest,
           a_modelNamePrefix,
           a_eqfuncs )
      equation
        a_eqfuncs = equation_impl(a_eqfuncs, -1, i_eq, SimCodeFunction.contextSimulationDiscrete, a_modelNamePrefix, false);
        txt = equation_call(txt, i_eq, a_modelNamePrefix);
        txt = Tpl.nextIter(txt);
        (txt, a_eqfuncs) = lm_518(txt, rest, a_modelNamePrefix, a_eqfuncs);
      then (txt, a_eqfuncs);
  end match;
end lm_518;

protected function fun_519
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if (measure_time_flag) "));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_519;

protected function fun_520
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if (measure_time_flag) "));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_520;

public function functionDAE
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_allEquationsPlusWhen;
  input String a_modelNamePrefix;

  output Tpl.Text out_txt;
protected
  Boolean ret_7;
  Boolean ret_6;
  Tpl.Text l_fncalls;
  Tpl.Text l_eqArray;
  Tpl.Text l_eqfuncs;
  Integer ret_2;
  Tpl.Text l_nrfuncs;
  Tpl.Text l_auxFunction;
algorithm
  l_auxFunction := Tpl.emptyTxt;
  ret_2 := listLength(a_allEquationsPlusWhen);
  l_nrfuncs := Tpl.writeStr(Tpl.emptyTxt, intString(ret_2));
  l_eqfuncs := Tpl.emptyTxt;
  l_eqArray := Tpl.emptyTxt;
  l_fncalls := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (l_fncalls, l_eqfuncs) := lm_518(l_fncalls, a_allEquationsPlusWhen, a_modelNamePrefix, l_eqfuncs);
  l_fncalls := Tpl.popIter(l_fncalls);
  out_txt := Tpl.writeText(txt, l_auxFunction);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeText(out_txt, l_eqfuncs);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "OMC_DISABLE_OPT\n",
                                       "int "
                                   }, false));
  out_txt := CodegenUtil.symbolName(out_txt, a_modelNamePrefix, "functionDAE");
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "(DATA *data, threadData_t *threadData)\n",
                                       "{\n",
                                       "  TRACE_PUSH\n",
                                       "  int equationIndexes[1] = {0};\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := CodegenCFunctions.addRootsTempArray(out_txt);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("#if !defined(OMC_MINIMAL_RUNTIME)\n"));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  ret_6 := Config.profileFunctions();
  out_txt := fun_519(out_txt, ret_6);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("rt_tick(SIM_TIMER_DAE);\n"));
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "#endif\n",
                                       "\n",
                                       "  data->simulationInfo->needToIterate = 0;\n",
                                       "  data->simulationInfo->discreteCall = 1;\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := CodegenUtil.symbolName(out_txt, a_modelNamePrefix, "functionLocalKnownVars");
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("(data, threadData);\n"));
  out_txt := Tpl.writeText(out_txt, l_fncalls);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "data->simulationInfo->discreteCall = 0;\n",
                                       "\n"
                                   }, true));
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("#if !defined(OMC_MINIMAL_RUNTIME)\n"));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  ret_7 := Config.profileFunctions();
  out_txt := fun_520(out_txt, ret_7);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("rt_accumulate(SIM_TIMER_DAE);\n"));
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "#endif\n",
                                       "  TRACE_POP\n",
                                       "  return 0;\n",
                                       "}"
                                   }, false));
end functionDAE;

protected function lm_522
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      String a_modelNamePrefix;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_eq :: rest,
           a_modelNamePrefix )
      equation
        txt = equation_impl(txt, -1, i_eq, SimCodeFunction.contextSimulationDiscrete, a_modelNamePrefix, false);
        txt = Tpl.nextIter(txt);
        txt = lm_522(txt, rest, a_modelNamePrefix);
      then txt;
  end match;
end lm_522;

protected function lm_523
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      String a_modelNamePrefix;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_eq :: rest,
           a_modelNamePrefix )
      equation
        txt = equation_call(txt, i_eq, a_modelNamePrefix);
        txt = Tpl.nextIter(txt);
        txt = lm_523(txt, rest, a_modelNamePrefix);
      then txt;
  end match;
end lm_523;

public function functionLocalKnownVars
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_localKnownVars;
  input String a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt := Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_522(out_txt, a_localKnownVars, a_modelNamePrefix);
  out_txt := Tpl.popIter(out_txt);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "int "
                                   }, false));
  out_txt := CodegenUtil.symbolName(out_txt, a_modelNamePrefix, "functionLocalKnownVars");
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "(DATA *data, threadData_t *threadData)\n",
                                       "{\n",
                                       "  TRACE_PUSH\n",
                                       "\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.pushIter(out_txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_523(out_txt, a_localKnownVars, a_modelNamePrefix);
  out_txt := Tpl.popIter(out_txt);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "TRACE_POP\n",
                                       "return 0;\n"
                                   }, true));
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("}"));
end functionLocalKnownVars;

protected function lm_525
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      String a_modelNamePrefix;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_eq :: rest,
           a_modelNamePrefix )
      equation
        txt = equationForward_(txt, i_eq, SimCodeFunction.contextSimulationNonDiscrete, a_modelNamePrefix);
        txt = Tpl.nextIter(txt);
        txt = lm_525(txt, rest, a_modelNamePrefix);
      then txt;
  end match;
end lm_525;

protected function lm_526
  input Tpl.Text in_txt;
  input list<BackendDAE.ZeroCrossing> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<BackendDAE.ZeroCrossing> rest;
      DAE.Exp i_relation__;
      String ret_1;
      Tpl.Text txt_0;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           BackendDAE.ZERO_CROSSING(relation_ = i_relation__) :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        txt_0 = ExpressionDumpTpl.dumpExp(Tpl.emptyTxt, i_relation__, "\"");
        ret_1 = Util.escapeModelicaStringToCString(Tpl.textString(txt_0));
        txt = Tpl.writeStr(txt, ret_1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        txt = Tpl.nextIter(txt);
        txt = lm_526(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_526(txt, rest);
      then txt;
  end match;
end lm_526;

protected function lm_527
  input Tpl.Text in_txt;
  input list<Integer> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<Integer> rest;
      Integer i_i;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_i :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeStr(txt, intString(i_i));
        txt = lm_527(txt, rest);
      then txt;
  end match;
end lm_527;

protected function lm_528
  input Tpl.Text in_txt;
  input list<BackendDAE.ZeroCrossing> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<BackendDAE.ZeroCrossing> rest;
      Integer x_i0;
      list<Integer> i_occurEquLst;
      Integer ret_0;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           BackendDAE.ZERO_CROSSING(occurEquLst = i_occurEquLst) :: rest )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("static const int occurEqs"));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("[] = {"));
        ret_0 = listLength(i_occurEquLst);
        txt = Tpl.writeStr(txt, intString(ret_0));
        txt = lm_527(txt, i_occurEquLst);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("};"));
        txt = Tpl.nextIter(txt);
        txt = lm_528(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_528(txt, rest);
      then txt;
  end match;
end lm_528;

protected function lm_529
  input Tpl.Text in_txt;
  input list<BackendDAE.ZeroCrossing> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<BackendDAE.ZeroCrossing> rest;
      Integer x_i0;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           BackendDAE.ZERO_CROSSING(relation_ = _) :: rest )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("occurEqs"));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.nextIter(txt);
        txt = lm_529(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_529(txt, rest);
      then txt;
  end match;
end lm_529;

protected function fun_530
  input Tpl.Text in_txt;
  input list<BackendDAE.ZeroCrossing> in_a_zeroCrossings;
  input Tpl.Text in_a_resDesc;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_zeroCrossings, in_a_resDesc, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      Tpl.Text a_resDesc;
      String a_modelNamePrefix;
      list<BackendDAE.ZeroCrossing> i_zeroCrossings;

    case ( txt,
           {},
           _,
           a_modelNamePrefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("const char *"));
        txt = CodegenUtil.symbolName(txt, a_modelNamePrefix, "zeroCrossingDescription");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(int i, int **out_EquationIndexes)\n",
                                    "{\n",
                                    "  *out_EquationIndexes = NULL;\n",
                                    "  return \"empty\";\n",
                                    "}"
                                }, false));
      then txt;

    case ( txt,
           i_zeroCrossings,
           a_resDesc,
           a_modelNamePrefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("const char *"));
        txt = CodegenUtil.symbolName(txt, a_modelNamePrefix, "zeroCrossingDescription");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(int i, int **out_EquationIndexes)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("static const char *res[] = {"));
        txt = Tpl.writeText(txt, a_resDesc);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("};\n"));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_528(txt, i_zeroCrossings);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("static const int *occurEqs[] = {"));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_529(txt, i_zeroCrossings);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "};\n",
                                    "*out_EquationIndexes = (int*) occurEqs[i];\n",
                                    "return res[i];\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;
  end match;
end fun_530;

protected function lm_531
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      String a_modelNamePrefix;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_eq :: rest,
           a_modelNamePrefix )
      equation
        txt = equation_call(txt, i_eq, a_modelNamePrefix);
        txt = Tpl.nextIter(txt);
        txt = lm_531(txt, rest, a_modelNamePrefix);
      then txt;
  end match;
end lm_531;

protected function fun_532
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if (measure_time_flag) "));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_532;

protected function fun_533
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if (measure_time_flag) "));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_533;

public function functionZeroCrossing
  input Tpl.Text txt;
  input list<BackendDAE.ZeroCrossing> a_zeroCrossings;
  input list<SimCode.SimEqSystem> a_equationsForZeroCrossings;
  input String a_modelNamePrefix;

  output Tpl.Text out_txt;
protected
  Boolean ret_7;
  Boolean ret_6;
  Tpl.Text l_desc;
  Tpl.Text l_resDesc;
  Tpl.Text l_zeroCrossingsCode;
  Tpl.Text l_varDecls2;
  Tpl.Text l_forwardEqs;
  Tpl.Text l_auxFunction;
algorithm
  l_auxFunction := Tpl.emptyTxt;
  l_forwardEqs := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  l_forwardEqs := lm_525(l_forwardEqs, a_equationsForZeroCrossings, a_modelNamePrefix);
  l_forwardEqs := Tpl.popIter(l_forwardEqs);
  l_varDecls2 := Tpl.emptyTxt;
  (l_zeroCrossingsCode, l_varDecls2, l_auxFunction) := zeroCrossingsTpl(Tpl.emptyTxt, a_zeroCrossings, l_varDecls2, l_auxFunction);
  l_resDesc := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_LINE(",\n")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  l_resDesc := lm_526(l_resDesc, a_zeroCrossings);
  l_resDesc := Tpl.popIter(l_resDesc);
  l_desc := fun_530(Tpl.emptyTxt, a_zeroCrossings, l_resDesc, a_modelNamePrefix);
  out_txt := Tpl.writeText(txt, l_desc);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "/* forwarded equations */\n"
                                   }, true));
  out_txt := Tpl.writeText(out_txt, l_forwardEqs);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "int "
                                   }, false));
  out_txt := CodegenUtil.symbolName(out_txt, a_modelNamePrefix, "function_ZeroCrossingsEquations");
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "(DATA *data, threadData_t *threadData)\n",
                                       "{\n",
                                       "  TRACE_PUSH\n",
                                       "\n",
                                       "  data->simulationInfo->callStatistics.functionZeroCrossingsEquations++;\n",
                                       "\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.pushIter(out_txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_531(out_txt, a_equationsForZeroCrossings, a_modelNamePrefix);
  out_txt := Tpl.popIter(out_txt);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "TRACE_POP\n",
                                       "return 0;\n"
                                   }, true));
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "}\n",
                                       "\n",
                                       "int "
                                   }, false));
  out_txt := CodegenUtil.symbolName(out_txt, a_modelNamePrefix, "function_ZeroCrossings");
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "(DATA *data, threadData_t *threadData, double *gout)\n",
                                       "{\n",
                                       "  TRACE_PUSH\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeText(out_txt, l_varDecls2);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_NEW_LINE());
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("#if !defined(OMC_MINIMAL_RUNTIME)\n"));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  ret_6 := Config.profileFunctions();
  out_txt := fun_532(out_txt, ret_6);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("rt_tick(SIM_TIMER_ZC);\n"));
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "#endif\n",
                                       "  data->simulationInfo->callStatistics.functionZeroCrossings++;\n",
                                       "\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeText(out_txt, l_zeroCrossingsCode);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_NEW_LINE());
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("#if !defined(OMC_MINIMAL_RUNTIME)\n"));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  ret_7 := Config.profileFunctions();
  out_txt := fun_533(out_txt, ret_7);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("rt_accumulate(SIM_TIMER_ZC);\n"));
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "#endif\n",
                                       "\n",
                                       "  TRACE_POP\n",
                                       "  return 0;\n",
                                       "}"
                                   }, false));
end functionZeroCrossing;

protected function lm_535
  input Tpl.Text in_txt;
  input list<BackendDAE.ZeroCrossing> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls)
    local
      Tpl.Text txt;
      list<BackendDAE.ZeroCrossing> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Integer x_i0;
      DAE.Exp i_relation__;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls )
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           BackendDAE.ZERO_CROSSING(relation_ = i_relation__) :: rest,
           a_auxFunction,
           a_varDecls )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        (txt, a_varDecls, a_auxFunction) = zeroCrossingTpl(txt, x_i0, i_relation__, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls) = lm_535(txt, rest, a_auxFunction, a_varDecls);
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           _ :: rest,
           a_auxFunction,
           a_varDecls )
      equation
        (txt, a_auxFunction, a_varDecls) = lm_535(txt, rest, a_auxFunction, a_varDecls);
      then (txt, a_auxFunction, a_varDecls);
  end match;
end lm_535;

public function zeroCrossingsTpl
  input Tpl.Text txt;
  input list<BackendDAE.ZeroCrossing> a_zeroCrossings;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  out_txt := Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (out_txt, out_a_auxFunction, out_a_varDecls) := lm_535(out_txt, a_zeroCrossings, a_auxFunction, a_varDecls);
  out_txt := Tpl.popIter(out_txt);
end zeroCrossingsTpl;

protected function fun_537
  input Tpl.Text in_txt;
  input DAE.Exp in_a_relation;
  input Integer in_a_index1;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_relation, in_a_index1, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      Integer a_index1;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Exp i_exp2;
      DAE.Exp i_idx;
      DAE.Exp i_exp1;
      DAE.Exp i_exp;
      Tpl.Text txt_6;
      Tpl.Text l_tvar2;
      Tpl.Text l_tvar1;
      Tpl.Text l_e2;
      Tpl.Text l_indx;
      Tpl.Text l_e1;
      Tpl.Text l_preExp;

    case ( txt,
           (i_exp as DAE.RELATION(exp1 = _)),
           a_index1,
           a_varDecls,
           a_auxFunction )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_e1, l_preExp, a_varDecls, a_auxFunction) = CodegenCFunctions.daeExp(Tpl.emptyTxt, i_exp, SimCodeFunction.contextZeroCross, l_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("gout["));
        txt = Tpl.writeStr(txt, intString(a_index1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = ("));
        txt = Tpl.writeText(txt, l_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") ? 1 : -1;"));
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           (i_exp1 as DAE.LBINARY(exp1 = _)),
           a_index1,
           a_varDecls,
           a_auxFunction )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_e1, l_preExp, a_varDecls, a_auxFunction) = CodegenCFunctions.daeExp(Tpl.emptyTxt, i_exp1, SimCodeFunction.contextZeroCross, l_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("gout["));
        txt = Tpl.writeStr(txt, intString(a_index1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = ("));
        txt = Tpl.writeText(txt, l_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") ? 1 : -1;"));
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           (i_exp1 as DAE.LUNARY(operator = _)),
           a_index1,
           a_varDecls,
           a_auxFunction )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_e1, l_preExp, a_varDecls, a_auxFunction) = CodegenCFunctions.daeExp(Tpl.emptyTxt, i_exp1, SimCodeFunction.contextZeroCross, l_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("gout["));
        txt = Tpl.writeStr(txt, intString(a_index1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = ("));
        txt = Tpl.writeText(txt, l_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") ? 1 : -1;"));
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "sample"), expLst = {_, _, _}),
           _,
           a_varDecls,
           a_auxFunction )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "integer"), expLst = {i_exp1, i_idx}),
           a_index1,
           a_varDecls,
           a_auxFunction )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_e1, l_preExp, a_varDecls, a_auxFunction) = CodegenCFunctions.daeExp(Tpl.emptyTxt, i_exp1, SimCodeFunction.contextZeroCross, l_preExp, a_varDecls, a_auxFunction);
        (l_indx, l_preExp, a_varDecls, a_auxFunction) = CodegenCFunctions.daeExp(Tpl.emptyTxt, i_idx, SimCodeFunction.contextZeroCross, l_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("gout["));
        txt = Tpl.writeStr(txt, intString(a_index1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = (floor("));
        txt = Tpl.writeText(txt, l_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") != floor(data->simulationInfo->mathEventsValuePre["));
        txt = Tpl.writeText(txt, l_indx);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("])) ? 1 : -1;"));
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "floor"), expLst = {i_exp1, i_idx}),
           a_index1,
           a_varDecls,
           a_auxFunction )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_e1, l_preExp, a_varDecls, a_auxFunction) = CodegenCFunctions.daeExp(Tpl.emptyTxt, i_exp1, SimCodeFunction.contextZeroCross, l_preExp, a_varDecls, a_auxFunction);
        (l_indx, l_preExp, a_varDecls, a_auxFunction) = CodegenCFunctions.daeExp(Tpl.emptyTxt, i_idx, SimCodeFunction.contextZeroCross, l_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("gout["));
        txt = Tpl.writeStr(txt, intString(a_index1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = (floor("));
        txt = Tpl.writeText(txt, l_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") != floor(data->simulationInfo->mathEventsValuePre["));
        txt = Tpl.writeText(txt, l_indx);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("])) ? 1 : -1;"));
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "ceil"), expLst = {i_exp1, i_idx}),
           a_index1,
           a_varDecls,
           a_auxFunction )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_e1, l_preExp, a_varDecls, a_auxFunction) = CodegenCFunctions.daeExp(Tpl.emptyTxt, i_exp1, SimCodeFunction.contextZeroCross, l_preExp, a_varDecls, a_auxFunction);
        (l_indx, l_preExp, a_varDecls, a_auxFunction) = CodegenCFunctions.daeExp(Tpl.emptyTxt, i_idx, SimCodeFunction.contextZeroCross, l_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("gout["));
        txt = Tpl.writeStr(txt, intString(a_index1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = (ceil("));
        txt = Tpl.writeText(txt, l_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") != ceil(data->simulationInfo->mathEventsValuePre["));
        txt = Tpl.writeText(txt, l_indx);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("])) ? 1 : -1;"));
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "mod"), expLst = {i_exp1, i_exp2, i_idx}),
           a_index1,
           a_varDecls,
           a_auxFunction )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_e1, l_preExp, a_varDecls, a_auxFunction) = CodegenCFunctions.daeExp(Tpl.emptyTxt, i_exp1, SimCodeFunction.contextZeroCross, l_preExp, a_varDecls, a_auxFunction);
        (l_e2, l_preExp, a_varDecls, a_auxFunction) = CodegenCFunctions.daeExp(Tpl.emptyTxt, i_exp2, SimCodeFunction.contextZeroCross, l_preExp, a_varDecls, a_auxFunction);
        (l_indx, l_preExp, a_varDecls, a_auxFunction) = CodegenCFunctions.daeExp(Tpl.emptyTxt, i_idx, SimCodeFunction.contextZeroCross, l_preExp, a_varDecls, a_auxFunction);
        (l_tvar1, a_varDecls) = CodegenCFunctions.tempDecl(Tpl.emptyTxt, "modelica_real", a_varDecls);
        (l_tvar2, a_varDecls) = CodegenCFunctions.tempDecl(Tpl.emptyTxt, "modelica_real", a_varDecls);
        l_preExp = Tpl.writeText(l_preExp, l_tvar1);
        l_preExp = Tpl.writeTok(l_preExp, Tpl.ST_STRING(" = floor(("));
        l_preExp = Tpl.writeText(l_preExp, l_e1);
        l_preExp = Tpl.writeTok(l_preExp, Tpl.ST_STRING(") / ("));
        l_preExp = Tpl.writeText(l_preExp, l_e2);
        l_preExp = Tpl.writeTok(l_preExp, Tpl.ST_STRING("));"));
        l_preExp = Tpl.writeTok(l_preExp, Tpl.ST_NEW_LINE());
        l_preExp = Tpl.writeText(l_preExp, l_tvar2);
        l_preExp = Tpl.writeTok(l_preExp, Tpl.ST_STRING(" = floor((data->simulationInfo->mathEventsValuePre["));
        l_preExp = Tpl.writeText(l_preExp, l_indx);
        l_preExp = Tpl.writeTok(l_preExp, Tpl.ST_STRING("]) / (data->simulationInfo->mathEventsValuePre["));
        l_preExp = Tpl.writeText(l_preExp, l_indx);
        l_preExp = Tpl.writeTok(l_preExp, Tpl.ST_STRING("+1]));"));
        l_preExp = Tpl.writeTok(l_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("gout["));
        txt = Tpl.writeStr(txt, intString(a_index1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = "));
        txt = Tpl.writeText(txt, l_tvar1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" != "));
        txt = Tpl.writeText(txt, l_tvar2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" ? 1 : -1;"));
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "div"), expLst = {i_exp1, i_exp2, i_idx}),
           a_index1,
           a_varDecls,
           a_auxFunction )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_e1, l_preExp, a_varDecls, a_auxFunction) = CodegenCFunctions.daeExp(Tpl.emptyTxt, i_exp1, SimCodeFunction.contextZeroCross, l_preExp, a_varDecls, a_auxFunction);
        (l_e2, l_preExp, a_varDecls, a_auxFunction) = CodegenCFunctions.daeExp(Tpl.emptyTxt, i_exp2, SimCodeFunction.contextZeroCross, l_preExp, a_varDecls, a_auxFunction);
        (l_indx, l_preExp, a_varDecls, a_auxFunction) = CodegenCFunctions.daeExp(Tpl.emptyTxt, i_idx, SimCodeFunction.contextZeroCross, l_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("gout["));
        txt = Tpl.writeStr(txt, intString(a_index1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = (trunc(("));
        txt = Tpl.writeText(txt, l_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")/("));
        txt = Tpl.writeText(txt, l_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")) != trunc(data->simulationInfo->mathEventsValuePre["));
        txt = Tpl.writeText(txt, l_indx);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("]/data->simulationInfo->mathEventsValuePre["));
        txt = Tpl.writeText(txt, l_indx);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("+1])) ? 1 : -1;"));
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           a_index1,
           a_varDecls,
           a_auxFunction )
      equation
        txt_6 = Tpl.pushBlock(Tpl.emptyTxt, Tpl.BT_INDENT(1));
        txt_6 = Tpl.writeTok(txt_6, Tpl.ST_STRING("UNKNOWN ZERO CROSSING for "));
        txt_6 = Tpl.writeStr(txt_6, intString(a_index1));
        txt_6 = Tpl.popBlock(txt_6);
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 4468, 11), Tpl.textString(txt_6));
      then (txt, a_varDecls, a_auxFunction);
  end match;
end fun_537;

public function zeroCrossingTpl
  input Tpl.Text txt;
  input Integer a_index1;
  input DAE.Exp a_relation;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) := fun_537(txt, a_relation, a_index1, a_varDecls, a_auxFunction);
end zeroCrossingTpl;

protected function lm_539
  input Tpl.Text in_txt;
  input list<BackendDAE.ZeroCrossing> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<BackendDAE.ZeroCrossing> rest;
      DAE.Exp i_relation__;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           BackendDAE.ZERO_CROSSING(relation_ = i_relation__) :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        txt = ExpressionDumpTpl.dumpExp(txt, i_relation__, "\"");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        txt = Tpl.nextIter(txt);
        txt = lm_539(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_539(txt, rest);
      then txt;
  end match;
end lm_539;

protected function fun_540
  input Tpl.Text in_txt;
  input list<BackendDAE.ZeroCrossing> in_a_relations;
  input Tpl.Text in_a_resDesc;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_relations, in_a_resDesc, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      Tpl.Text a_resDesc;
      String a_modelNamePrefix;

    case ( txt,
           {},
           _,
           a_modelNamePrefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("const char *"));
        txt = CodegenUtil.symbolName(txt, a_modelNamePrefix, "relationDescription");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(int i)\n",
                                    "{\n",
                                    "  return \"empty\";\n",
                                    "}"
                                }, false));
      then txt;

    case ( txt,
           _,
           a_resDesc,
           a_modelNamePrefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("const char *"));
        txt = CodegenUtil.symbolName(txt, a_modelNamePrefix, "relationDescription");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(int i)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("const char *res[] = {"));
        txt = Tpl.writeText(txt, a_resDesc);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "};\n",
                                    "return res[i];\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;
  end match;
end fun_540;

public function functionRelations
  input Tpl.Text txt;
  input list<BackendDAE.ZeroCrossing> a_relations;
  input String a_modelNamePrefix;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_desc;
  Tpl.Text l_resDesc;
  Tpl.Text l_relationsCodeElse;
  Tpl.Text l_relationsCode;
  Tpl.Text l_varDecls;
  Tpl.Text l_auxFunction;
algorithm
  l_auxFunction := Tpl.emptyTxt;
  l_varDecls := Tpl.emptyTxt;
  (l_relationsCode, l_varDecls, l_auxFunction) := relationsTpl(Tpl.emptyTxt, a_relations, SimCodeFunction.contextZeroCross, l_varDecls, l_auxFunction);
  (l_relationsCodeElse, l_varDecls, l_auxFunction) := relationsTpl(Tpl.emptyTxt, a_relations, SimCodeFunction.contextOther, l_varDecls, l_auxFunction);
  l_resDesc := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_LINE(",\n")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  l_resDesc := lm_539(l_resDesc, a_relations);
  l_resDesc := Tpl.popIter(l_resDesc);
  l_desc := fun_540(Tpl.emptyTxt, a_relations, l_resDesc, a_modelNamePrefix);
  out_txt := Tpl.writeText(txt, l_auxFunction);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeText(out_txt, l_desc);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "int "
                                   }, false));
  out_txt := CodegenUtil.symbolName(out_txt, a_modelNamePrefix, "function_updateRelations");
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "(DATA *data, threadData_t *threadData, int evalforZeroCross)\n",
                                       "{\n",
                                       "  TRACE_PUSH\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeText(out_txt, l_varDecls);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "if(evalforZeroCross) {\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeText(out_txt, l_relationsCode);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("} else {\n"));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeText(out_txt, l_relationsCodeElse);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "}\n",
                                       "\n",
                                       "TRACE_POP\n",
                                       "return 0;\n"
                                   }, true));
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("}"));
end functionRelations;

protected function lm_542
  input Tpl.Text in_txt;
  input list<BackendDAE.ZeroCrossing> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_context)
    local
      Tpl.Text txt;
      list<BackendDAE.ZeroCrossing> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      SimCodeFunction.Context a_context;
      Integer x_i0;
      DAE.Exp i_relation__;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           _ )
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           BackendDAE.ZERO_CROSSING(relation_ = i_relation__) :: rest,
           a_auxFunction,
           a_varDecls,
           a_context )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        (txt, a_varDecls, a_auxFunction) = relationTpl(txt, x_i0, i_relation__, a_context, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls) = lm_542(txt, rest, a_auxFunction, a_varDecls, a_context);
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           _ :: rest,
           a_auxFunction,
           a_varDecls,
           a_context )
      equation
        (txt, a_auxFunction, a_varDecls) = lm_542(txt, rest, a_auxFunction, a_varDecls, a_context);
      then (txt, a_auxFunction, a_varDecls);
  end match;
end lm_542;

public function relationsTpl
  input Tpl.Text txt;
  input list<BackendDAE.ZeroCrossing> a_relations;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  out_txt := Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (out_txt, out_a_auxFunction, out_a_varDecls) := lm_542(out_txt, a_relations, a_auxFunction, a_varDecls, a_context);
  out_txt := Tpl.popIter(out_txt);
end relationsTpl;

protected function fun_544
  input Tpl.Text in_txt;
  input DAE.Exp in_a_relation;
  input Integer in_a_index1;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_relation, in_a_index1, in_a_context, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      Integer a_index1;
      SimCodeFunction.Context a_context;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Exp i_exp;
      Tpl.Text l_res;
      Tpl.Text l_preExp;

    case ( txt,
           (i_exp as DAE.RELATION(exp1 = _)),
           a_index1,
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_res, l_preExp, a_varDecls, a_auxFunction) = CodegenCFunctions.daeExp(Tpl.emptyTxt, i_exp, a_context, l_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("data->simulationInfo->relations["));
        txt = Tpl.writeStr(txt, intString(a_index1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = "));
        txt = Tpl.writeText(txt, l_res);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           a_index1,
           _,
           a_varDecls,
           a_auxFunction )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/* UNKNOWN Relation for "));
        txt = Tpl.writeStr(txt, intString(a_index1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" */"));
      then (txt, a_varDecls, a_auxFunction);
  end match;
end fun_544;

public function relationTpl
  input Tpl.Text txt;
  input Integer a_index1;
  input DAE.Exp a_relation;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) := fun_544(txt, a_relation, a_index1, a_context, a_varDecls, a_auxFunction);
end relationTpl;

protected function fun_546
  input Tpl.Text in_txt;
  input String in_mArg;
  input DAE.ComponentRef in_a_cr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_cr)
    local
      Tpl.Text txt;
      DAE.ComponentRef a_cr;
      Tpl.Text txt_0;

    case ( txt,
           "modelica_real",
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("%g"));
      then txt;

    case ( txt,
           "modelica_integer",
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("%ld"));
      then txt;

    case ( txt,
           "modelica_boolean",
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("%d"));
      then txt;

    case ( txt,
           "modelica_string",
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("%s"));
      then txt;

    case ( txt,
           _,
           a_cr )
      equation
        txt_0 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("Do not know what printf argument to give "));
        txt_0 = CodegenUtil.crefStr(txt_0, a_cr);
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 4554, 14), Tpl.textString(txt_0));
      then txt;
  end match;
end fun_546;

public function crefToPrintfArg
  input Tpl.Text txt;
  input DAE.ComponentRef a_cr;

  output Tpl.Text out_txt;
protected
  String str_1;
  Tpl.Text txt_0;
algorithm
  txt_0 := crefType(Tpl.emptyTxt, a_cr);
  str_1 := Tpl.textString(txt_0);
  out_txt := fun_546(txt, str_1, a_cr);
end crefToPrintfArg;

public function crefType
  input Tpl.Text in_txt;
  input DAE.ComponentRef in_a_cr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_cr)
    local
      Tpl.Text txt;
      DAE.ComponentRef i_componentRef;
      DAE.Type i_identType;

    case ( txt,
           DAE.CREF_IDENT(identType = i_identType) )
      equation
        txt = CodegenCFunctions.expTypeModelica(txt, i_identType);
      then txt;

    case ( txt,
           DAE.CREF_QUAL(componentRef = i_componentRef) )
      equation
        txt = crefType(txt, i_componentRef);
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("crefType:ERROR"));
      then txt;
  end match;
end crefType;

public function crefShortType
  input Tpl.Text in_txt;
  input DAE.ComponentRef in_a_cr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_cr)
    local
      Tpl.Text txt;
      DAE.ComponentRef i_componentRef;
      DAE.Type i_identType;

    case ( txt,
           DAE.CREF_IDENT(identType = i_identType) )
      equation
        txt = CodegenCFunctions.expTypeShort(txt, i_identType);
      then txt;

    case ( txt,
           DAE.CREF_QUAL(componentRef = i_componentRef) )
      equation
        txt = crefShortType(txt, i_componentRef);
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("crefType:ERROR"));
      then txt;
  end match;
end crefShortType;

protected function lm_550
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      String a_modelNamePrefix;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_eq :: rest,
           a_modelNamePrefix )
      equation
        txt = equation_impl(txt, -1, i_eq, SimCodeFunction.contextSimulationDiscrete, a_modelNamePrefix, false);
        txt = Tpl.nextIter(txt);
        txt = lm_550(txt, rest, a_modelNamePrefix);
      then txt;
  end match;
end lm_550;

protected function lm_551
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      String a_modelNamePrefix;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_eq :: rest,
           a_modelNamePrefix )
      equation
        txt = equation_call(txt, i_eq, a_modelNamePrefix);
        txt = Tpl.nextIter(txt);
        txt = lm_551(txt, rest, a_modelNamePrefix);
      then txt;
  end match;
end lm_551;

public function functionAssertsforCheck
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_algAndEqAssertsEquations;
  input String a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt := Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_550(out_txt, a_algAndEqAssertsEquations, a_modelNamePrefix);
  out_txt := Tpl.popIter(out_txt);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "/* function to check assert after a step is done */\n",
                                       "OMC_DISABLE_OPT\n",
                                       "int "
                                   }, false));
  out_txt := CodegenUtil.symbolName(out_txt, a_modelNamePrefix, "checkForAsserts");
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "(DATA *data, threadData_t *threadData)\n",
                                       "{\n",
                                       "  TRACE_PUSH\n",
                                       "\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.pushIter(out_txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_551(out_txt, a_algAndEqAssertsEquations, a_modelNamePrefix);
  out_txt := Tpl.popIter(out_txt);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "TRACE_POP\n",
                                       "return 0;\n"
                                   }, true));
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("}"));
end functionAssertsforCheck;

public function functionlinearmodel
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      String a_modelNamePrefix;
      list<SimCodeVar.SimVar> i_vars_algVars;
      list<SimCodeVar.SimVar> i_vars_outputVars;
      list<SimCodeVar.SimVar> i_vars_inputVars;
      list<SimCodeVar.SimVar> i_vars_stateVars;
      Integer i_varInfo_numAlgVars;
      Integer i_varInfo_numOutVars;
      Integer i_varInfo_numInVars;
      Integer i_varInfo_numStateVars;
      Tpl.Text l_vectorZ;
      Tpl.Text l_vectorY;
      Tpl.Text l_vectorU;
      Tpl.Text l_vectorX;
      Tpl.Text l_matrixDz;
      Tpl.Text l_matrixCz;
      Tpl.Text l_matrixD;
      Tpl.Text l_matrixC;
      Tpl.Text l_matrixB;
      Tpl.Text l_matrixA;

    case ( txt,
           SimCode.MODELINFO(varInfo = SimCode.VARINFO(numStateVars = i_varInfo_numStateVars, numInVars = i_varInfo_numInVars, numOutVars = i_varInfo_numOutVars, numAlgVars = i_varInfo_numAlgVars), vars = SimCodeVar.SIMVARS(stateVars = i_vars_stateVars, inputVars = i_vars_inputVars, outputVars = i_vars_outputVars, algVars = i_vars_algVars)),
           a_modelNamePrefix )
      equation
        l_matrixA = genMatrix(Tpl.emptyTxt, "A", "n", "n", i_varInfo_numStateVars, i_varInfo_numStateVars);
        l_matrixB = genMatrix(Tpl.emptyTxt, "B", "n", "m", i_varInfo_numStateVars, i_varInfo_numInVars);
        l_matrixC = genMatrix(Tpl.emptyTxt, "C", "p", "n", i_varInfo_numOutVars, i_varInfo_numStateVars);
        l_matrixD = genMatrix(Tpl.emptyTxt, "D", "p", "m", i_varInfo_numOutVars, i_varInfo_numInVars);
        l_matrixCz = genMatrix(Tpl.emptyTxt, "Cz", "nz", "n", i_varInfo_numAlgVars, i_varInfo_numStateVars);
        l_matrixDz = genMatrix(Tpl.emptyTxt, "Dz", "nz", "m", i_varInfo_numAlgVars, i_varInfo_numInVars);
        l_vectorX = genVector(Tpl.emptyTxt, "x", "n", i_varInfo_numStateVars, 0);
        l_vectorU = genVector(Tpl.emptyTxt, "u", "m", i_varInfo_numInVars, 1);
        l_vectorY = genVector(Tpl.emptyTxt, "y", "p", i_varInfo_numOutVars, 2);
        l_vectorZ = genVector(Tpl.emptyTxt, "z", "nz", i_varInfo_numAlgVars, 2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("const char *"));
        txt = CodegenUtil.symbolName(txt, a_modelNamePrefix, "linear_model_frame");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "()\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("return \"model linearized_model \\\""));
        txt = Tpl.writeStr(txt, a_modelNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\\\" \\n  parameter Integer n = "));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numStateVars));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" \\\"number of states\\\";\\n  parameter Integer m = "));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numInVars));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" \\\"number of inputs\\\";\\n  parameter Integer p = "));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numOutVars));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " \\\"number of outputs\\\";\\n\"\n",
                                    "\"  parameter Real x0[n] = %s;\\n\"\n",
                                    "\"  parameter Real u0[m] = %s;\\n\"\n",
                                    "\"\\n\"\n"
                                }, true));
        txt = Tpl.writeText(txt, l_matrixA);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_matrixB);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_matrixC);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_matrixD);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("\"\\n\"\n"));
        txt = Tpl.writeText(txt, l_vectorX);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_vectorU);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_vectorY);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("\"\\n\"\n"));
        txt = getVarName(txt, i_vars_stateVars, "x");
        txt = Tpl.softNewLine(txt);
        txt = getVarName(txt, i_vars_inputVars, "u");
        txt = Tpl.softNewLine(txt);
        txt = getVarName(txt, i_vars_outputVars, "y");
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("\"equation\\n  der(x) = A * x + B * u;\\n  y = C * x + D * u;\\nend linearized_model;\\n\";\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "const char *"
                                }, false));
        txt = CodegenUtil.symbolName(txt, a_modelNamePrefix, "linear_model_datarecovery_frame");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "()\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("return \"model linearized_model \\\""));
        txt = Tpl.writeStr(txt, a_modelNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\\\" \\n parameter Integer n = "));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numStateVars));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" \\\"number of states\\\";\\n  parameter Integer m = "));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numInVars));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" \\\"number of inputs\\\";\\n  parameter Integer p = "));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numOutVars));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" \\\"number of outputs\\\";\\n  parameter Integer nz = "));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numAlgVars));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " \\\"data recovery variables\\\";\\n\"\n",
                                    "\"  parameter Real x0["
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numStateVars));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "] = %s;\\n\"\n",
                                    "\"  parameter Real u0["
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numInVars));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "] = %s;\\n\"\n",
                                    "\"  parameter Real z0["
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numAlgVars));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "] = %s;\\n\"\n",
                                    "\"\\n\"\n"
                                }, true));
        txt = Tpl.writeText(txt, l_matrixA);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_matrixB);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_matrixC);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_matrixD);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_matrixCz);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_matrixDz);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("\"\\n\"\n"));
        txt = Tpl.writeText(txt, l_vectorX);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_vectorU);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_vectorY);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_vectorZ);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("\"\\n\"\n"));
        txt = getVarName(txt, i_vars_stateVars, "x");
        txt = Tpl.softNewLine(txt);
        txt = getVarName(txt, i_vars_inputVars, "u");
        txt = Tpl.softNewLine(txt);
        txt = getVarName(txt, i_vars_outputVars, "y");
        txt = Tpl.softNewLine(txt);
        txt = getVarName(txt, i_vars_algVars, "z");
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("\"equation\\n  der(x) = A * x + B * u;\\n  y = C * x + D * u;\\n  z = Cz * x + Dz * u;\\nend linearized_model;\\n\";\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end functionlinearmodel;

public function functionlinearmodelMatlab
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      String a_modelNamePrefix;
      list<SimCodeVar.SimVar> i_vars_outputVars;
      list<SimCodeVar.SimVar> i_vars_inputVars;
      list<SimCodeVar.SimVar> i_vars_stateVars;
      Integer i_varInfo_numOutVars;
      Integer i_varInfo_numInVars;
      Integer i_varInfo_numStateVars;
      Tpl.Text l_matrixD;
      Tpl.Text l_matrixC;
      Tpl.Text l_matrixB;
      Tpl.Text l_matrixA;

    case ( txt,
           SimCode.MODELINFO(varInfo = SimCode.VARINFO(numStateVars = i_varInfo_numStateVars, numInVars = i_varInfo_numInVars, numOutVars = i_varInfo_numOutVars), vars = SimCodeVar.SIMVARS(stateVars = i_vars_stateVars, inputVars = i_vars_inputVars, outputVars = i_vars_outputVars)),
           a_modelNamePrefix )
      equation
        l_matrixA = genMatrixMatlab(Tpl.emptyTxt, "A", "n", "n", i_varInfo_numStateVars, i_varInfo_numStateVars);
        l_matrixB = genMatrixMatlab(Tpl.emptyTxt, "B", "n", "m", i_varInfo_numStateVars, i_varInfo_numInVars);
        l_matrixC = genMatrixMatlab(Tpl.emptyTxt, "C", "p", "n", i_varInfo_numOutVars, i_varInfo_numStateVars);
        l_matrixD = genMatrixMatlab(Tpl.emptyTxt, "D", "p", "m", i_varInfo_numOutVars, i_varInfo_numInVars);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("const char *"));
        txt = CodegenUtil.symbolName(txt, a_modelNamePrefix, "linear_model_frame");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "()\n",
                                    "{\n",
                                    "  return \"function [sys, x0, u0, n, m, p, Ts] = linearized_model()\\n\"\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\"%% "));
        txt = Tpl.writeStr(txt, a_modelNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\\n\"\n",
                                    "\"%% der(x) = A * x + B * u\\n%% y = C * x + D * u\\n\"\n",
                                    "\"  n = "
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numStateVars));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("; %% number of states\\n  m = "));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numInVars));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("; %% number of inputs\\n  p = "));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numOutVars));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "; %% number of outputs\\n\"\n",
                                    "\"\\n\"\n",
                                    "\"  x0 = %s;\\n\"\n",
                                    "\"  u0 = %s;\\n\"\n",
                                    "\"\\n\"\n"
                                }, true));
        txt = Tpl.writeText(txt, l_matrixA);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_matrixB);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_matrixC);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_matrixD);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\"  Ts = %g; %% stop time\\n\\n\"\n",
                                    "\"  %% The Control System Toolbox is required for this. Alternatively just return the matrices A,B,C,D instead.\\n\"\n",
                                    "\"  sys = ss(A,B,C,D,\'StateName\',{"
                                }, false));
        txt = getVarNameMatlab(txt, i_vars_stateVars, "x");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}, \'InputName\',{"));
        txt = getVarNameMatlab(txt, i_vars_inputVars, "u");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}, \'OutputName\', {"));
        txt = getVarNameMatlab(txt, i_vars_outputVars, "y");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "});\\n\"\n",
                                    "\"end\";\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "const char *"
                                }, false));
        txt = CodegenUtil.symbolName(txt, a_modelNamePrefix, "linear_model_datarecovery_frame");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "()\n",
                                    "{\n",
                                    "}"
                                }, false));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end functionlinearmodelMatlab;

public function functionlinearmodelJulia
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      String a_modelNamePrefix;
      list<SimCodeVar.SimVar> i_vars_outputVars;
      list<SimCodeVar.SimVar> i_vars_inputVars;
      list<SimCodeVar.SimVar> i_vars_stateVars;
      Integer i_varInfo_numAlgVars;
      Integer i_varInfo_numOutVars;
      Integer i_varInfo_numInVars;
      Integer i_varInfo_numStateVars;
      Tpl.Text l_matrixDz;
      Tpl.Text l_matrixCz;
      Tpl.Text l_matrixD;
      Tpl.Text l_matrixC;
      Tpl.Text l_matrixB;
      Tpl.Text l_matrixA;

    case ( txt,
           SimCode.MODELINFO(varInfo = SimCode.VARINFO(numStateVars = i_varInfo_numStateVars, numInVars = i_varInfo_numInVars, numOutVars = i_varInfo_numOutVars, numAlgVars = i_varInfo_numAlgVars), vars = SimCodeVar.SIMVARS(stateVars = i_vars_stateVars, inputVars = i_vars_inputVars, outputVars = i_vars_outputVars)),
           a_modelNamePrefix )
      equation
        l_matrixA = genMatrixJulia(Tpl.emptyTxt, "A", "n", "n", i_varInfo_numStateVars, i_varInfo_numStateVars);
        l_matrixB = genMatrixJulia(Tpl.emptyTxt, "B", "n", "m", i_varInfo_numStateVars, i_varInfo_numInVars);
        l_matrixC = genMatrixJulia(Tpl.emptyTxt, "C", "p", "n", i_varInfo_numOutVars, i_varInfo_numStateVars);
        l_matrixD = genMatrixJulia(Tpl.emptyTxt, "D", "p", "m", i_varInfo_numOutVars, i_varInfo_numInVars);
        l_matrixCz = genMatrixJulia(Tpl.emptyTxt, "Cz", "nz", "n", i_varInfo_numAlgVars, i_varInfo_numStateVars);
        l_matrixDz = genMatrixJulia(Tpl.emptyTxt, "Dz", "nz", "m", i_varInfo_numAlgVars, i_varInfo_numInVars);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("const char *"));
        txt = CodegenUtil.symbolName(txt, a_modelNamePrefix, "linear_model_frame");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "()\n",
                                    "{\n",
                                    "  return \"function linearized_model()\\n\"\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\"#= "));
        txt = Tpl.writeStr(txt, a_modelNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " =#\\n\"\n",
                                    "\"#= der(x) = A * x + B * u =#\\n#= y = C * x + D * u =#\\n\"\n",
                                    "\"  local n = "
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numStateVars));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" #= number of states =#\\n  local m = "));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numInVars));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" #= number of inputs =#\\n  local p = "));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numOutVars));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " #= number of outputs =#\\n\"\n",
                                    "\"\\n\"\n",
                                    "\"  local x0 = %s\\n\"\n",
                                    "\"  local u0 = %s\\n\"\n",
                                    "\"\\n\"\n"
                                }, true));
        txt = Tpl.writeText(txt, l_matrixA);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_matrixB);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_matrixC);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_matrixD);
        txt = Tpl.softNewLine(txt);
        txt = getVarNameJulia(txt, i_vars_stateVars, "x");
        txt = Tpl.softNewLine(txt);
        txt = getVarNameJulia(txt, i_vars_inputVars, "u");
        txt = Tpl.softNewLine(txt);
        txt = getVarNameJulia(txt, i_vars_outputVars, "y");
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\"\\n\"\n",
                                    "\"  (n, m, p, x0, u0, A, B, C, D)\\n\"\n",
                                    "\"end\";\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "const char *"
                                }, false));
        txt = CodegenUtil.symbolName(txt, a_modelNamePrefix, "linear_model_datarecovery_frame");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "()\n",
                                    "{\n",
                                    "}"
                                }, false));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end functionlinearmodelJulia;

public function functionlinearmodelPython
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      String a_modelNamePrefix;
      list<SimCodeVar.SimVar> i_vars_outputVars;
      list<SimCodeVar.SimVar> i_vars_inputVars;
      list<SimCodeVar.SimVar> i_vars_stateVars;
      Integer i_varInfo_numAlgVars;
      Integer i_varInfo_numOutVars;
      Integer i_varInfo_numInVars;
      Integer i_varInfo_numStateVars;
      Tpl.Text l_matrixDz;
      Tpl.Text l_matrixCz;
      Tpl.Text l_matrixD;
      Tpl.Text l_matrixC;
      Tpl.Text l_matrixB;
      Tpl.Text l_matrixA;

    case ( txt,
           SimCode.MODELINFO(varInfo = SimCode.VARINFO(numStateVars = i_varInfo_numStateVars, numInVars = i_varInfo_numInVars, numOutVars = i_varInfo_numOutVars, numAlgVars = i_varInfo_numAlgVars), vars = SimCodeVar.SIMVARS(stateVars = i_vars_stateVars, inputVars = i_vars_inputVars, outputVars = i_vars_outputVars)),
           a_modelNamePrefix )
      equation
        l_matrixA = genMatrixMatlab(Tpl.emptyTxt, "A", "n", "n", i_varInfo_numStateVars, i_varInfo_numStateVars);
        l_matrixB = genMatrixMatlab(Tpl.emptyTxt, "B", "n", "m", i_varInfo_numStateVars, i_varInfo_numInVars);
        l_matrixC = genMatrixMatlab(Tpl.emptyTxt, "C", "p", "n", i_varInfo_numOutVars, i_varInfo_numStateVars);
        l_matrixD = genMatrixMatlab(Tpl.emptyTxt, "D", "p", "m", i_varInfo_numOutVars, i_varInfo_numInVars);
        l_matrixCz = genMatrixMatlab(Tpl.emptyTxt, "Cz", "nz", "n", i_varInfo_numAlgVars, i_varInfo_numStateVars);
        l_matrixDz = genMatrixMatlab(Tpl.emptyTxt, "Dz", "nz", "m", i_varInfo_numAlgVars, i_varInfo_numInVars);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("const char *"));
        txt = CodegenUtil.symbolName(txt, a_modelNamePrefix, "linear_model_frame");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "()\n",
                                    "{\n",
                                    "  return \"def linearized_model()\\n\"\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\"# "));
        txt = Tpl.writeStr(txt, a_modelNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\\n\"\n",
                                    "\"# der(x) = A * x + B * u \\n# y = C * x + D * u \\n\"\n",
                                    "\"  n = "
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numStateVars));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" # number of states\\n  m = "));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numInVars));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" # number of inputs\\n  p = "));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numOutVars));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " # number of outputs\\n\"\n",
                                    "\"\\n\"\n",
                                    "\"  x0 = %s\\n\"\n",
                                    "\"  u0 = %s\\n\"\n",
                                    "\"\\n\"\n"
                                }, true));
        txt = Tpl.writeText(txt, l_matrixA);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_matrixB);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_matrixC);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_matrixD);
        txt = Tpl.softNewLine(txt);
        txt = getVarNameJulia(txt, i_vars_stateVars, "x");
        txt = Tpl.softNewLine(txt);
        txt = getVarNameJulia(txt, i_vars_inputVars, "u");
        txt = Tpl.softNewLine(txt);
        txt = getVarNameJulia(txt, i_vars_outputVars, "y");
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\"\\n\"\n",
                                    "\"  return (n, m, p, x0, u0, A, B, C, D)\\n\"\n",
                                    "\"end\";\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "const char *"
                                }, false));
        txt = CodegenUtil.symbolName(txt, a_modelNamePrefix, "linear_model_datarecovery_frame");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "()\n",
                                    "{\n",
                                    "}"
                                }, false));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end functionlinearmodelPython;

protected function fun_557
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_a_var;
  input Integer in_a_arrindex;
  input String in_a_arrayName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_var, in_a_arrindex, in_a_arrayName)
    local
      Tpl.Text txt;
      Integer a_arrindex;
      String a_arrayName;
      DAE.ComponentRef i_name;

    case ( txt,
           SimCodeVar.SIMVAR(name = i_name),
           a_arrindex,
           a_arrayName )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\"  Real \'"));
        txt = Tpl.writeStr(txt, a_arrayName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = CodegenUtil.crefStrNoUnderscore(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\' = "));
        txt = Tpl.writeStr(txt, a_arrayName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("["));
        txt = Tpl.writeStr(txt, intString(a_arrindex));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("];\\n\""));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_557;

protected function lm_558
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input String in_a_arrayName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_arrayName)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      String a_arrayName;
      Integer x_arrindex;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_arrayName )
      equation
        x_arrindex = Tpl.getIteri_i0(txt);
        txt = fun_557(txt, i_var, x_arrindex, a_arrayName);
        txt = Tpl.nextIter(txt);
        txt = lm_558(txt, rest, a_arrayName);
      then txt;
  end match;
end lm_558;

public function getVarName
  input Tpl.Text txt;
  input list<SimCodeVar.SimVar> a_simVars;
  input String a_arrayName;

  output Tpl.Text out_txt;
algorithm
  out_txt := Tpl.pushIter(txt, Tpl.ITER_OPTIONS(1, SOME(Tpl.ST_STRING("")), NONE(), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_558(out_txt, a_simVars, a_arrayName);
  out_txt := Tpl.popIter(out_txt);
end getVarName;

protected function fun_560
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_a_var;
  input String in_a_arrayName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_var, in_a_arrayName)
    local
      Tpl.Text txt;
      String a_arrayName;
      DAE.ComponentRef i_name;

    case ( txt,
           SimCodeVar.SIMVAR(name = i_name),
           a_arrayName )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\'"));
        txt = Tpl.writeStr(txt, a_arrayName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = CodegenUtil.crefStrMatlabSafe(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\'"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_560;

protected function lm_561
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input String in_a_arrayName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_arrayName)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      String a_arrayName;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_arrayName )
      equation
        txt = fun_560(txt, i_var, a_arrayName);
        txt = Tpl.nextIter(txt);
        txt = lm_561(txt, rest, a_arrayName);
      then txt;
  end match;
end lm_561;

public function getVarNameMatlab
  input Tpl.Text txt;
  input list<SimCodeVar.SimVar> a_simVars;
  input String a_arrayName;

  output Tpl.Text out_txt;
algorithm
  out_txt := Tpl.pushIter(txt, Tpl.ITER_OPTIONS(1, NONE(), SOME(Tpl.ST_STRING(",")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_561(out_txt, a_simVars, a_arrayName);
  out_txt := Tpl.popIter(out_txt);
end getVarNameMatlab;

protected function fun_563
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_a_var;
  input Integer in_a_arrindex;
  input String in_a_arrayName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_var, in_a_arrindex, in_a_arrayName)
    local
      Tpl.Text txt;
      Integer a_arrindex;
      String a_arrayName;
      DAE.ComponentRef i_name;

    case ( txt,
           SimCodeVar.SIMVAR(name = i_name),
           a_arrindex,
           a_arrayName )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\"  # "));
        txt = Tpl.writeStr(txt, a_arrayName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = CodegenUtil.crefStrMatlabSafe(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeStr(txt, a_arrayName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeStr(txt, intString(a_arrindex));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");\\n\""));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_563;

protected function lm_564
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input String in_a_arrayName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_arrayName)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      String a_arrayName;
      Integer x_arrindex;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_arrayName )
      equation
        x_arrindex = Tpl.getIteri_i0(txt);
        txt = fun_563(txt, i_var, x_arrindex, a_arrayName);
        txt = Tpl.nextIter(txt);
        txt = lm_564(txt, rest, a_arrayName);
      then txt;
  end match;
end lm_564;

public function getVarNameJulia
  input Tpl.Text txt;
  input list<SimCodeVar.SimVar> a_simVars;
  input String a_arrayName;

  output Tpl.Text out_txt;
algorithm
  out_txt := Tpl.pushIter(txt, Tpl.ITER_OPTIONS(1, SOME(Tpl.ST_STRING("")), NONE(), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_564(out_txt, a_simVars, a_arrayName);
  out_txt := Tpl.popIter(out_txt);
end getVarNameJulia;

protected function fun_566
  input Tpl.Text in_txt;
  input Integer in_a_colI;
  input String in_a_col;
  input String in_a_row;
  input String in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_colI, in_a_col, in_a_row, in_a_name)
    local
      Tpl.Text txt;
      String a_col;
      String a_row;
      String a_name;

    case ( txt,
           0,
           a_col,
           a_row,
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\"  parameter Real "));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("["));
        txt = Tpl.writeStr(txt, a_row);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeStr(txt, a_col);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = zeros("));
        txt = Tpl.writeStr(txt, a_row);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeStr(txt, a_col);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");%s\\n\\n\""));
      then txt;

    case ( txt,
           _,
           a_col,
           a_row,
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\"  parameter Real "));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("["));
        txt = Tpl.writeStr(txt, a_row);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeStr(txt, a_col);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] =\\n\\t[%s];\\n\\n\""));
      then txt;
  end match;
end fun_566;

protected function fun_567
  input Tpl.Text in_txt;
  input Integer in_a_rowI;
  input String in_a_name;
  input String in_a_row;
  input String in_a_col;
  input Integer in_a_colI;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_rowI, in_a_name, in_a_row, in_a_col, in_a_colI)
    local
      Tpl.Text txt;
      String a_name;
      String a_row;
      String a_col;
      Integer a_colI;

    case ( txt,
           0,
           a_name,
           a_row,
           a_col,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\"  parameter Real "));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("["));
        txt = Tpl.writeStr(txt, a_row);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeStr(txt, a_col);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = zeros("));
        txt = Tpl.writeStr(txt, a_row);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeStr(txt, a_col);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");%s\\n\\n\""));
      then txt;

    case ( txt,
           _,
           a_name,
           a_row,
           a_col,
           a_colI )
      equation
        txt = fun_566(txt, a_colI, a_col, a_row, a_name);
      then txt;
  end match;
end fun_567;

public function genMatrix
  input Tpl.Text txt;
  input String a_name;
  input String a_row;
  input String a_col;
  input Integer a_rowI;
  input Integer a_colI;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_567(txt, a_rowI, a_name, a_row, a_col, a_colI);
end genMatrix;

protected function fun_569
  input Tpl.Text in_txt;
  input Integer in_a_colI;
  input String in_a_col;
  input String in_a_row;
  input String in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_colI, in_a_col, in_a_row, in_a_name)
    local
      Tpl.Text txt;
      String a_col;
      String a_row;
      String a_name;

    case ( txt,
           0,
           a_col,
           a_row,
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\"  "));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = zeros("));
        txt = Tpl.writeStr(txt, a_row);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeStr(txt, a_col);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");%s\\n\\n\""));
      then txt;

    case ( txt,
           _,
           _,
           _,
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\"  "));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" =\\t[%s];\\n\\n\""));
      then txt;
  end match;
end fun_569;

protected function fun_570
  input Tpl.Text in_txt;
  input Integer in_a_rowI;
  input String in_a_name;
  input String in_a_row;
  input String in_a_col;
  input Integer in_a_colI;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_rowI, in_a_name, in_a_row, in_a_col, in_a_colI)
    local
      Tpl.Text txt;
      String a_name;
      String a_row;
      String a_col;
      Integer a_colI;

    case ( txt,
           0,
           a_name,
           a_row,
           a_col,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\"  "));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = zeros("));
        txt = Tpl.writeStr(txt, a_row);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeStr(txt, a_col);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");%s\\n\\n\""));
      then txt;

    case ( txt,
           _,
           a_name,
           a_row,
           a_col,
           a_colI )
      equation
        txt = fun_569(txt, a_colI, a_col, a_row, a_name);
      then txt;
  end match;
end fun_570;

public function genMatrixMatlab
  input Tpl.Text txt;
  input String a_name;
  input String a_row;
  input String a_col;
  input Integer a_rowI;
  input Integer a_colI;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_570(txt, a_rowI, a_name, a_row, a_col, a_colI);
end genMatrixMatlab;

protected function fun_572
  input Tpl.Text in_txt;
  input Integer in_a_colI;
  input String in_a_col;
  input String in_a_row;
  input String in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_colI, in_a_col, in_a_row, in_a_name)
    local
      Tpl.Text txt;
      String a_col;
      String a_row;
      String a_name;

    case ( txt,
           0,
           a_col,
           a_row,
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\"  local "));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = zeros("));
        txt = Tpl.writeStr(txt, a_row);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeStr(txt, a_col);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")%s\\n\""));
      then txt;

    case ( txt,
           _,
           _,
           _,
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\"  local "));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" =\\t[%s]\\n\\n\""));
      then txt;
  end match;
end fun_572;

protected function fun_573
  input Tpl.Text in_txt;
  input Integer in_a_rowI;
  input String in_a_name;
  input String in_a_row;
  input String in_a_col;
  input Integer in_a_colI;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_rowI, in_a_name, in_a_row, in_a_col, in_a_colI)
    local
      Tpl.Text txt;
      String a_name;
      String a_row;
      String a_col;
      Integer a_colI;

    case ( txt,
           0,
           a_name,
           a_row,
           a_col,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\"  local "));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = zeros("));
        txt = Tpl.writeStr(txt, a_row);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeStr(txt, a_col);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")%s\\n\""));
      then txt;

    case ( txt,
           _,
           a_name,
           a_row,
           a_col,
           a_colI )
      equation
        txt = fun_572(txt, a_colI, a_col, a_row, a_name);
      then txt;
  end match;
end fun_573;

public function genMatrixJulia
  input Tpl.Text txt;
  input String a_name;
  input String a_row;
  input String a_col;
  input Integer a_rowI;
  input Integer a_colI;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_573(txt, a_rowI, a_name, a_row, a_col, a_colI);
end genMatrixJulia;

protected function fun_575
  input Tpl.Text in_txt;
  input Integer in_a_numI;
  input String in_a_num;
  input String in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_numI, in_a_num, in_a_name)
    local
      Tpl.Text txt;
      String a_num;
      String a_name;

    case ( txt,
           0,
           a_num,
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\"  Real "));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("["));
        txt = Tpl.writeStr(txt, a_num);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("];\\n\""));
      then txt;

    case ( txt,
           _,
           a_num,
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\"  Real "));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("["));
        txt = Tpl.writeStr(txt, a_num);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("](start="));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("0);\\n\""));
      then txt;
  end match;
end fun_575;

protected function fun_576
  input Tpl.Text in_txt;
  input Integer in_a_numI;
  input String in_a_num;
  input String in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_numI, in_a_num, in_a_name)
    local
      Tpl.Text txt;
      String a_num;
      String a_name;

    case ( txt,
           0,
           a_num,
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\"  input Real "));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("["));
        txt = Tpl.writeStr(txt, a_num);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("];\\n\""));
      then txt;

    case ( txt,
           _,
           a_num,
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\"  input Real "));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("["));
        txt = Tpl.writeStr(txt, a_num);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("](start="));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("0);\\n\""));
      then txt;
  end match;
end fun_576;

protected function fun_577
  input Tpl.Text in_txt;
  input Integer in_a_numI;
  input String in_a_num;
  input String in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_numI, in_a_num, in_a_name)
    local
      Tpl.Text txt;
      String a_num;
      String a_name;

    case ( txt,
           0,
           a_num,
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\"  output Real "));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("["));
        txt = Tpl.writeStr(txt, a_num);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("];\\n\""));
      then txt;

    case ( txt,
           _,
           a_num,
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\"  output Real "));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("["));
        txt = Tpl.writeStr(txt, a_num);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("];\\n\""));
      then txt;
  end match;
end fun_577;

protected function fun_578
  input Tpl.Text in_txt;
  input Integer in_a_flag;
  input String in_a_name;
  input String in_a_num;
  input Integer in_a_numI;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_flag, in_a_name, in_a_num, in_a_numI)
    local
      Tpl.Text txt;
      String a_name;
      String a_num;
      Integer a_numI;

    case ( txt,
           0,
           a_name,
           a_num,
           a_numI )
      equation
        txt = fun_575(txt, a_numI, a_num, a_name);
      then txt;

    case ( txt,
           1,
           a_name,
           a_num,
           a_numI )
      equation
        txt = fun_576(txt, a_numI, a_num, a_name);
      then txt;

    case ( txt,
           2,
           a_name,
           a_num,
           a_numI )
      equation
        txt = fun_577(txt, a_numI, a_num, a_name);
      then txt;

    case ( txt,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_578;

public function genVector
  input Tpl.Text txt;
  input String a_name;
  input String a_num;
  input Integer a_numI;
  input Integer a_flag;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_578(txt, a_flag, a_name, a_num, a_numI);
end genVector;

protected function lm_580
  input Tpl.Text in_txt;
  input list<SimCode.JacobianMatrix> in_items;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      list<SimCode.JacobianMatrix> rest;
      String a_modelNamePrefix;
      Integer i_maxColor;
      list<list<Integer>> i_colorList;
      SimCode.SparsityPattern i_sparsepattern;
      String i_name;
      list<SimCodeVar.SimVar> i_vars;
      list<SimCode.JacobianColumn> i_mat;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           SimCode.JAC_MATRIX(columns = i_mat, seedVars = i_vars, matrixName = i_name, sparsity = i_sparsepattern, coloredCols = i_colorList, maxColorCols = i_maxColor, jacobianIndex = _) :: rest,
           a_modelNamePrefix )
      equation
        txt = initialAnalyticJacobians(txt, i_mat, i_vars, i_name, i_sparsepattern, i_colorList, i_maxColor, a_modelNamePrefix);
        txt = Tpl.nextIter(txt);
        txt = lm_580(txt, rest, a_modelNamePrefix);
      then txt;

    case ( txt,
           _ :: rest,
           a_modelNamePrefix )
      equation
        txt = lm_580(txt, rest, a_modelNamePrefix);
      then txt;
  end match;
end lm_580;

protected function lm_581
  input Tpl.Text in_txt;
  input list<SimCode.JacobianMatrix> in_items;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      list<SimCode.JacobianMatrix> rest;
      String a_modelNamePrefix;
      Option<HashTableCrefSimVar.HashTable> i_crefsHT;
      Integer i_partIdx;
      String i_name;
      list<SimCodeVar.SimVar> i_vars;
      list<SimCode.JacobianColumn> i_mat;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           SimCode.JAC_MATRIX(columns = i_mat, seedVars = i_vars, matrixName = i_name, partitionIndex = i_partIdx, crefsHT = i_crefsHT) :: rest,
           a_modelNamePrefix )
      equation
        txt = generateMatrix(txt, i_mat, i_vars, i_name, i_partIdx, i_crefsHT, a_modelNamePrefix);
        txt = Tpl.nextIter(txt);
        txt = lm_581(txt, rest, a_modelNamePrefix);
      then txt;

    case ( txt,
           _ :: rest,
           a_modelNamePrefix )
      equation
        txt = lm_581(txt, rest, a_modelNamePrefix);
      then txt;
  end match;
end lm_581;

public function functionAnalyticJacobians
  input Tpl.Text txt;
  input list<SimCode.JacobianMatrix> a_JacobianMatrixes;
  input String a_modelNamePrefix;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_jacMats;
  Tpl.Text l_initialjacMats;
algorithm
  l_initialjacMats := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  l_initialjacMats := lm_580(l_initialjacMats, a_JacobianMatrixes, a_modelNamePrefix);
  l_initialjacMats := Tpl.popIter(l_initialjacMats);
  l_jacMats := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  l_jacMats := lm_581(l_jacMats, a_JacobianMatrixes, a_modelNamePrefix);
  l_jacMats := Tpl.popIter(l_jacMats);
  out_txt := Tpl.writeText(txt, l_jacMats);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_NEW_LINE());
  out_txt := Tpl.writeText(out_txt, l_initialjacMats);
end functionAnalyticJacobians;

protected function lm_583
  input Tpl.Text in_txt;
  input list<SimCode.JacobianColumn> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.JacobianColumn> rest;
      Integer i_n;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           SimCode.JAC_COLUMN(numberOfResultVars = i_n) :: rest )
      equation
        txt = Tpl.writeStr(txt, intString(i_n));
        txt = Tpl.nextIter(txt);
        txt = lm_583(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_583(txt, rest);
      then txt;
  end match;
end lm_583;

protected function lm_584
  input Tpl.Text in_txt;
  input list<SimCode.JacobianColumn> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.JacobianColumn> rest;
      list<SimCodeVar.SimVar> i_vars;
      Integer ret_0;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           SimCode.JAC_COLUMN(columnVars = i_vars) :: rest )
      equation
        ret_0 = listLength(i_vars);
        txt = Tpl.writeStr(txt, intString(ret_0));
        txt = Tpl.nextIter(txt);
        txt = lm_584(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_584(txt, rest);
      then txt;
  end match;
end lm_584;

protected function fun_585
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_a_constantEqns;
  input String in_a_matrixname;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_constantEqns, in_a_matrixname, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      String a_matrixname;
      String a_modelNamePrefix;

    case ( txt,
           {},
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("NULL"));
      then txt;

    case ( txt,
           _,
           a_matrixname,
           a_modelNamePrefix )
      equation
        txt = CodegenUtil.symbolName(txt, a_modelNamePrefix, "functionJac");
        txt = Tpl.writeStr(txt, a_matrixname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_constantEqns"));
      then txt;
  end match;
end fun_585;

protected function lm_586
  input Tpl.Text in_txt;
  input list<SimCode.JacobianColumn> in_items;
  input String in_a_matrixname;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_matrixname, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      list<SimCode.JacobianColumn> rest;
      String a_matrixname;
      String a_modelNamePrefix;
      list<SimCode.SimEqSystem> i_constantEqns;

    case ( txt,
           {},
           _,
           _ )
      then txt;

    case ( txt,
           SimCode.JAC_COLUMN(constantEqns = i_constantEqns) :: rest,
           a_matrixname,
           a_modelNamePrefix )
      equation
        txt = fun_585(txt, i_constantEqns, a_matrixname, a_modelNamePrefix);
        txt = Tpl.nextIter(txt);
        txt = lm_586(txt, rest, a_matrixname, a_modelNamePrefix);
      then txt;

    case ( txt,
           _ :: rest,
           a_matrixname,
           a_modelNamePrefix )
      equation
        txt = lm_586(txt, rest, a_matrixname, a_modelNamePrefix);
      then txt;
  end match;
end lm_586;

protected function fun_587
  input Tpl.Text in_txt;
  input SimCode.SparsityPattern in_a_sparsepattern;
  input list<SimCode.JacobianColumn> in_a_jacobianColumn;
  input list<SimCodeVar.SimVar> in_a_seedVars;
  input String in_a_matrixname;
  input list<list<Integer>> in_a_colorList;
  input Integer in_a_maxColor;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_sparsepattern, in_a_jacobianColumn, in_a_seedVars, in_a_matrixname, in_a_colorList, in_a_maxColor, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      list<SimCode.JacobianColumn> a_jacobianColumn;
      list<SimCodeVar.SimVar> a_seedVars;
      String a_matrixname;
      list<list<Integer>> a_colorList;
      Integer a_maxColor;
      String a_modelNamePrefix;
      SimCode.SparsityPattern i_sparsepattern;
      Integer ret_16;
      Tpl.Text l_index__;
      Tpl.Text l_constantEqns;
      Tpl.Text l_tmpvarsSize;
      Tpl.Text l_indexColumn;
      Tpl.Text l_colorString;
      Integer ret_10;
      list<list<Integer>> ret_9;
      Tpl.Text l_rowIndex;
      Integer ret_7;
      Tpl.Text l_colPtr;
      Integer ret_5;
      Tpl.Text l_sizeleadindex;
      Integer ret_3;
      list<list<Integer>> ret_2;
      Tpl.Text l_sp__size__index;
      Tpl.Text l_eachCrefParts;

    case ( txt,
           {},
           _,
           _,
           a_matrixname,
           _,
           _,
           a_modelNamePrefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("int "));
        txt = CodegenUtil.symbolName(txt, a_modelNamePrefix, "initialAnalyticJacobian");
        txt = Tpl.writeStr(txt, a_matrixname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(void* inData, threadData_t *threadData, ANALYTIC_JACOBIAN *jacobian)\n",
                                    "{\n",
                                    "  TRACE_PUSH\n",
                                    "  TRACE_POP\n",
                                    "  return 1;\n",
                                    "}"
                                }, false));
      then txt;

    case ( txt,
           i_sparsepattern,
           a_jacobianColumn,
           a_seedVars,
           a_matrixname,
           a_colorList,
           a_maxColor,
           a_modelNamePrefix )
      equation
        l_eachCrefParts = Tpl.emptyTxt;
        ret_2 = List.unzipSecond(i_sparsepattern);
        ret_3 = List.lengthListElements(ret_2);
        l_sp__size__index = Tpl.writeStr(Tpl.emptyTxt, intString(ret_3));
        ret_5 = listLength(i_sparsepattern);
        l_sizeleadindex = Tpl.writeStr(Tpl.emptyTxt, intString(ret_5));
        ret_7 = listLength(i_sparsepattern);
        l_colPtr = genSPCRSPtr(Tpl.emptyTxt, ret_7, i_sparsepattern, "colPtrIndex");
        ret_9 = List.unzipSecond(i_sparsepattern);
        ret_10 = List.lengthListElements(ret_9);
        l_rowIndex = genSPCRSRows(Tpl.emptyTxt, ret_10, i_sparsepattern, "rowIndex");
        l_colorString = genSPColors(Tpl.emptyTxt, a_colorList, "jacobian->sparsePattern->colorCols");
        l_indexColumn = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_indexColumn = lm_583(l_indexColumn, a_jacobianColumn);
        l_indexColumn = Tpl.popIter(l_indexColumn);
        l_tmpvarsSize = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_tmpvarsSize = lm_584(l_tmpvarsSize, a_jacobianColumn);
        l_tmpvarsSize = Tpl.popIter(l_tmpvarsSize);
        l_constantEqns = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING("")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_constantEqns = lm_586(l_constantEqns, a_jacobianColumn, a_matrixname, a_modelNamePrefix);
        l_constantEqns = Tpl.popIter(l_constantEqns);
        ret_16 = listLength(a_seedVars);
        l_index__ = Tpl.writeStr(Tpl.emptyTxt, intString(ret_16));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "OMC_DISABLE_OPT\n",
                                    "int "
                                }, false));
        txt = CodegenUtil.symbolName(txt, a_modelNamePrefix, "initialAnalyticJacobian");
        txt = Tpl.writeStr(txt, a_matrixname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(void* inData, threadData_t *threadData, ANALYTIC_JACOBIAN *jacobian)\n",
                                    "{\n",
                                    "  TRACE_PUSH\n",
                                    "  DATA* data = ((DATA*)inData);\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_colPtr);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_rowIndex);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "int i = 0;\n",
                                    "\n",
                                    "jacobian->sizeCols = "
                                }, false));
        txt = Tpl.writeText(txt, l_index__);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "jacobian->sizeRows = "
                                }, false));
        txt = Tpl.writeText(txt, l_indexColumn);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "jacobian->sizeTmpVars = "
                                }, false));
        txt = Tpl.writeText(txt, l_tmpvarsSize);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "jacobian->seedVars = (modelica_real*) calloc("
                                }, false));
        txt = Tpl.writeText(txt, l_index__);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ",sizeof(modelica_real));\n",
                                    "jacobian->resultVars = (modelica_real*) calloc("
                                }, false));
        txt = Tpl.writeText(txt, l_indexColumn);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ",sizeof(modelica_real));\n",
                                    "jacobian->tmpVars = (modelica_real*) calloc("
                                }, false));
        txt = Tpl.writeText(txt, l_tmpvarsSize);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ",sizeof(modelica_real));\n",
                                    "jacobian->sparsePattern = (SPARSE_PATTERN*) malloc(sizeof(SPARSE_PATTERN));\n",
                                    "jacobian->sparsePattern->leadindex = (unsigned int*) malloc(("
                                }, false));
        txt = Tpl.writeText(txt, l_sizeleadindex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "+1)*sizeof(unsigned int));\n",
                                    "jacobian->sparsePattern->index = (unsigned int*) malloc("
                                }, false));
        txt = Tpl.writeText(txt, l_sp__size__index);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "*sizeof(unsigned int));\n",
                                    "jacobian->sparsePattern->numberOfNoneZeros = "
                                }, false));
        txt = Tpl.writeText(txt, l_sp__size__index);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "jacobian->sparsePattern->colorCols = (unsigned int*) malloc("
                                }, false));
        txt = Tpl.writeText(txt, l_index__);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "*sizeof(unsigned int));\n",
                                    "jacobian->sparsePattern->maxColors = "
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_maxColor));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "jacobian->constantEqns = "
                                }, false));
        txt = Tpl.writeText(txt, l_constantEqns);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "\n",
                                    "/* write lead index of compressed sparse column */\n",
                                    "memcpy(jacobian->sparsePattern->leadindex, colPtrIndex, ("
                                }, false));
        txt = Tpl.writeText(txt, l_sizeleadindex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "+1)*sizeof(unsigned int));\n",
                                    "\n",
                                    "for(i=2;i<"
                                }, false));
        txt = Tpl.writeText(txt, l_sizeleadindex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "+1;++i)\n",
                                    "  jacobian->sparsePattern->leadindex[i] += jacobian->sparsePattern->leadindex[i-1];\n",
                                    "\n",
                                    "/* call sparse index */\n",
                                    "memcpy(jacobian->sparsePattern->index, rowIndex, "
                                }, false));
        txt = Tpl.writeText(txt, l_sp__size__index);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "*sizeof(unsigned int));\n",
                                    "\n",
                                    "/* write color array */\n"
                                }, true));
        txt = Tpl.writeText(txt, l_colorString);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "TRACE_POP\n",
                                    "return 0;\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;
  end match;
end fun_587;

public function initialAnalyticJacobians
  input Tpl.Text txt;
  input list<SimCode.JacobianColumn> a_jacobianColumn;
  input list<SimCodeVar.SimVar> a_seedVars;
  input String a_matrixname;
  input SimCode.SparsityPattern a_sparsepattern;
  input list<list<Integer>> a_colorList;
  input Integer a_maxColor;
  input String a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_587(txt, a_sparsepattern, a_jacobianColumn, a_seedVars, a_matrixname, a_colorList, a_maxColor, a_modelNamePrefix);
end initialAnalyticJacobians;

protected function lm_589
  input Tpl.Text in_txt;
  input list<SimCode.JacobianColumn> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.JacobianColumn> rest;
      Integer i_nRows;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           SimCode.JAC_COLUMN(numberOfResultVars = i_nRows) :: rest )
      equation
        txt = Tpl.writeStr(txt, intString(i_nRows));
        txt = lm_589(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_589(txt, rest);
      then txt;
  end match;
end lm_589;

protected function lm_590
  input Tpl.Text in_txt;
  input list<SimCode.JacobianColumn> in_items;
  input String in_a_modelNamePrefix;
  input Option<HashTableCrefSimVar.HashTable> in_a_jacHT;
  input String in_a_matrixname;
  input Integer in_a_partIdx;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefix, in_a_jacHT, in_a_matrixname, in_a_partIdx)
    local
      Tpl.Text txt;
      list<SimCode.JacobianColumn> rest;
      String a_modelNamePrefix;
      Option<HashTableCrefSimVar.HashTable> a_jacHT;
      String a_matrixname;
      Integer a_partIdx;
      list<SimCode.SimEqSystem> i_constantEqns;
      list<SimCode.SimEqSystem> i_eqs;

    case ( txt,
           {},
           _,
           _,
           _,
           _ )
      then txt;

    case ( txt,
           SimCode.JAC_COLUMN(columnEqns = i_eqs, constantEqns = i_constantEqns) :: rest,
           a_modelNamePrefix,
           a_jacHT,
           a_matrixname,
           a_partIdx )
      equation
        txt = functionJac(txt, i_eqs, i_constantEqns, a_partIdx, a_matrixname, a_jacHT, a_modelNamePrefix);
        txt = Tpl.nextIter(txt);
        txt = lm_590(txt, rest, a_modelNamePrefix, a_jacHT, a_matrixname, a_partIdx);
      then txt;

    case ( txt,
           _ :: rest,
           a_modelNamePrefix,
           a_jacHT,
           a_matrixname,
           a_partIdx )
      equation
        txt = lm_590(txt, rest, a_modelNamePrefix, a_jacHT, a_matrixname, a_partIdx);
      then txt;
  end match;
end lm_590;

protected function lm_591
  input Tpl.Text in_txt;
  input list<SimCode.JacobianColumn> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.JacobianColumn> rest;
      Integer i_nRows;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           SimCode.JAC_COLUMN(numberOfResultVars = i_nRows) :: rest )
      equation
        txt = Tpl.writeStr(txt, intString(i_nRows));
        txt = Tpl.nextIter(txt);
        txt = lm_591(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_591(txt, rest);
      then txt;
  end match;
end lm_591;

protected function fun_592
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_a_seedVars;
  input Option<HashTableCrefSimVar.HashTable> in_a_jacHT;
  input Integer in_a_partIdx;
  input list<SimCode.JacobianColumn> in_a_jacobianColumn;
  input String in_a_matrixname;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_seedVars, in_a_jacHT, in_a_partIdx, in_a_jacobianColumn, in_a_matrixname, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      Option<HashTableCrefSimVar.HashTable> a_jacHT;
      Integer a_partIdx;
      list<SimCode.JacobianColumn> a_jacobianColumn;
      String a_matrixname;
      String a_modelNamePrefix;
      Tpl.Text l_indexColumn;
      Tpl.Text l_jacMats;

    case ( txt,
           {},
           _,
           _,
           _,
           a_matrixname,
           a_modelNamePrefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("int "));
        txt = CodegenUtil.symbolName(txt, a_modelNamePrefix, "functionJac");
        txt = Tpl.writeStr(txt, a_matrixname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_column(void* data, threadData_t *threadData, ANALYTIC_JACOBIAN *jacobian, ANALYTIC_JACOBIAN *parentJacobian)\n",
                                    "{\n",
                                    "  TRACE_PUSH\n",
                                    "  TRACE_POP\n",
                                    "  return 0;\n",
                                    "}"
                                }, false));
      then txt;

    case ( txt,
           _,
           a_jacHT,
           a_partIdx,
           a_jacobianColumn,
           a_matrixname,
           a_modelNamePrefix )
      equation
        l_jacMats = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_jacMats = lm_590(l_jacMats, a_jacobianColumn, a_modelNamePrefix, a_jacHT, a_matrixname, a_partIdx);
        l_jacMats = Tpl.popIter(l_jacMats);
        l_indexColumn = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_indexColumn = lm_591(l_indexColumn, a_jacobianColumn);
        l_indexColumn = Tpl.popIter(l_indexColumn);
        txt = Tpl.writeText(txt, l_jacMats);
      then txt;
  end match;
end fun_592;

protected function fun_593
  input Tpl.Text in_txt;
  input String in_mArg;
  input Option<HashTableCrefSimVar.HashTable> in_a_jacHT;
  input Integer in_a_partIdx;
  input list<SimCode.JacobianColumn> in_a_jacobianColumn;
  input list<SimCodeVar.SimVar> in_a_seedVars;
  input String in_a_matrixname;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_jacHT, in_a_partIdx, in_a_jacobianColumn, in_a_seedVars, in_a_matrixname, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      Option<HashTableCrefSimVar.HashTable> a_jacHT;
      Integer a_partIdx;
      list<SimCode.JacobianColumn> a_jacobianColumn;
      list<SimCodeVar.SimVar> a_seedVars;
      String a_matrixname;
      String a_modelNamePrefix;

    case ( txt,
           "0",
           _,
           _,
           _,
           _,
           a_matrixname,
           a_modelNamePrefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("int "));
        txt = CodegenUtil.symbolName(txt, a_modelNamePrefix, "functionJac");
        txt = Tpl.writeStr(txt, a_matrixname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_column(void* data, threadData_t *threadData, ANALYTIC_JACOBIAN *jacobian, ANALYTIC_JACOBIAN *parentJacobian)\n",
                                    "{\n",
                                    "  TRACE_PUSH\n",
                                    "  TRACE_POP\n",
                                    "  return 0;\n",
                                    "}"
                                }, false));
      then txt;

    case ( txt,
           _,
           a_jacHT,
           a_partIdx,
           a_jacobianColumn,
           a_seedVars,
           a_matrixname,
           a_modelNamePrefix )
      equation
        txt = fun_592(txt, a_seedVars, a_jacHT, a_partIdx, a_jacobianColumn, a_matrixname, a_modelNamePrefix);
      then txt;
  end match;
end fun_593;

public function generateMatrix
  input Tpl.Text txt;
  input list<SimCode.JacobianColumn> a_jacobianColumn;
  input list<SimCodeVar.SimVar> a_seedVars;
  input String a_matrixname;
  input Integer a_partIdx;
  input Option<HashTableCrefSimVar.HashTable> a_jacHT;
  input String a_modelNamePrefix;

  output Tpl.Text out_txt;
protected
  String str_1;
  Tpl.Text l_nRows;
algorithm
  l_nRows := lm_589(Tpl.emptyTxt, a_jacobianColumn);
  str_1 := Tpl.textString(l_nRows);
  out_txt := fun_593(txt, str_1, a_jacHT, a_partIdx, a_jacobianColumn, a_seedVars, a_matrixname, a_modelNamePrefix);
end generateMatrix;

protected function lm_595
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      String a_modelNamePrefix;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_eq :: rest,
           a_modelNamePrefix )
      equation
        txt = equation_callJacobian(txt, i_eq, a_modelNamePrefix);
        txt = Tpl.nextIter(txt);
        txt = lm_595(txt, rest, a_modelNamePrefix);
      then txt;
  end match;
end lm_595;

public function generateConstantEqns
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_constantEqns;
  input String a_matrixName;
  input String a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                   "OMC_DISABLE_OPT\n",
                                   "int "
                               }, false));
  out_txt := CodegenUtil.symbolName(out_txt, a_modelNamePrefix, "functionJac");
  out_txt := Tpl.writeStr(out_txt, a_matrixName);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "_constantEqns(void* inData, threadData_t *threadData, ANALYTIC_JACOBIAN *jacobian, ANALYTIC_JACOBIAN *parentJacobian)\n",
                                       "{\n",
                                       "  TRACE_PUSH\n",
                                       "\n",
                                       "  DATA* data = ((DATA*)inData);\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("int index = "));
  out_txt := CodegenUtil.symbolName(out_txt, a_modelNamePrefix, "INDEX_JAC_");
  out_txt := Tpl.writeStr(out_txt, a_matrixName);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       ";\n",
                                       "\n"
                                   }, true));
  out_txt := Tpl.pushIter(out_txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING("")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_595(out_txt, a_constantEqns, a_modelNamePrefix);
  out_txt := Tpl.popIter(out_txt);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "TRACE_POP\n",
                                       "return 0;\n"
                                   }, true));
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("}"));
end generateConstantEqns;

protected function lm_597
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input String in_a_modelNamePrefix;
  input Option<HashTableCrefSimVar.HashTable> in_a_jacHT;
  input Integer in_a_partIdx;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefix, in_a_jacHT, in_a_partIdx)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      String a_modelNamePrefix;
      Option<HashTableCrefSimVar.HashTable> a_jacHT;
      Integer a_partIdx;
      SimCode.SimEqSystem i_eq;
      SimCodeFunction.Context ret_0;

    case ( txt,
           {},
           _,
           _,
           _ )
      then txt;

    case ( txt,
           i_eq :: rest,
           a_modelNamePrefix,
           a_jacHT,
           a_partIdx )
      equation
        ret_0 = SimCodeUtil.createJacContext(a_jacHT);
        txt = equation_impl(txt, a_partIdx, i_eq, ret_0, a_modelNamePrefix, false);
        txt = Tpl.nextIter(txt);
        txt = lm_597(txt, rest, a_modelNamePrefix, a_jacHT, a_partIdx);
      then txt;
  end match;
end lm_597;

protected function lm_598
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input String in_a_modelNamePrefix;
  input Option<HashTableCrefSimVar.HashTable> in_a_jacHT;
  input Integer in_a_partIdx;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefix, in_a_jacHT, in_a_partIdx)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      String a_modelNamePrefix;
      Option<HashTableCrefSimVar.HashTable> a_jacHT;
      Integer a_partIdx;
      SimCode.SimEqSystem i_eq;
      SimCodeFunction.Context ret_0;

    case ( txt,
           {},
           _,
           _,
           _ )
      then txt;

    case ( txt,
           i_eq :: rest,
           a_modelNamePrefix,
           a_jacHT,
           a_partIdx )
      equation
        ret_0 = SimCodeUtil.createJacContext(a_jacHT);
        txt = equation_impl(txt, a_partIdx, i_eq, ret_0, a_modelNamePrefix, false);
        txt = Tpl.nextIter(txt);
        txt = lm_598(txt, rest, a_modelNamePrefix, a_jacHT, a_partIdx);
      then txt;
  end match;
end lm_598;

protected function lm_599
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      String a_modelNamePrefix;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_eq :: rest,
           a_modelNamePrefix )
      equation
        txt = equation_callJacobian(txt, i_eq, a_modelNamePrefix);
        txt = Tpl.nextIter(txt);
        txt = lm_599(txt, rest, a_modelNamePrefix);
      then txt;
  end match;
end lm_599;

public function functionJac
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_jacEquations;
  input list<SimCode.SimEqSystem> a_constantEqns;
  input Integer a_partIdx;
  input String a_matrixName;
  input Option<HashTableCrefSimVar.HashTable> a_jacHT;
  input String a_modelNamePrefix;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_constantEqns2;
algorithm
  l_constantEqns2 := generateConstantEqns(Tpl.emptyTxt, a_constantEqns, a_matrixName, a_modelNamePrefix);
  out_txt := Tpl.writeTok(txt, Tpl.ST_LINE("/* constant equations */\n"));
  out_txt := Tpl.pushIter(out_txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_597(out_txt, a_constantEqns, a_modelNamePrefix, a_jacHT, a_partIdx);
  out_txt := Tpl.popIter(out_txt);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("/* dynamic equations */\n"));
  out_txt := Tpl.pushIter(out_txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_598(out_txt, a_jacEquations, a_modelNamePrefix, a_jacHT, a_partIdx);
  out_txt := Tpl.popIter(out_txt);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_NEW_LINE());
  out_txt := Tpl.writeText(out_txt, l_constantEqns2);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "int "
                                   }, false));
  out_txt := CodegenUtil.symbolName(out_txt, a_modelNamePrefix, "functionJac");
  out_txt := Tpl.writeStr(out_txt, a_matrixName);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "_column(void* inData, threadData_t *threadData, ANALYTIC_JACOBIAN *jacobian, ANALYTIC_JACOBIAN *parentJacobian)\n",
                                       "{\n",
                                       "  TRACE_PUSH\n",
                                       "\n",
                                       "  DATA* data = ((DATA*)inData);\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("int index = "));
  out_txt := CodegenUtil.symbolName(out_txt, a_modelNamePrefix, "INDEX_JAC_");
  out_txt := Tpl.writeStr(out_txt, a_matrixName);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE(";\n"));
  out_txt := Tpl.pushIter(out_txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING("")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_599(out_txt, a_jacEquations, a_modelNamePrefix);
  out_txt := Tpl.popIter(out_txt);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "TRACE_POP\n",
                                       "return 0;\n"
                                   }, true));
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("}"));
end functionJac;

protected function lm_601
  input Tpl.Text in_txt;
  input SimCode.SparsityPattern in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      SimCode.SparsityPattern rest;
      list<Integer> i_indexes;
      Integer ret_0;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           (_, i_indexes) :: rest )
      equation
        ret_0 = listLength(i_indexes);
        txt = Tpl.writeStr(txt, intString(ret_0));
        txt = Tpl.nextIter(txt);
        txt = lm_601(txt, rest);
      then txt;
  end match;
end lm_601;

public function genSPCRSPtr
  input Tpl.Text txt;
  input Integer a_sizeColPtr;
  input SimCode.SparsityPattern a_sparsepattern;
  input String a_constArrayName;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_colPtrindex;
algorithm
  l_colPtrindex := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  l_colPtrindex := lm_601(l_colPtrindex, a_sparsepattern);
  l_colPtrindex := Tpl.popIter(l_colPtrindex);
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING("const int "));
  out_txt := Tpl.writeStr(out_txt, a_constArrayName);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("[1+"));
  out_txt := Tpl.writeStr(out_txt, intString(a_sizeColPtr));
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("] = {0,"));
  out_txt := Tpl.writeText(out_txt, l_colPtrindex);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("};"));
end genSPCRSPtr;

protected function lm_603
  input Tpl.Text in_txt;
  input list<Integer> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<Integer> rest;
      Integer i_indexrow;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_indexrow :: rest )
      equation
        txt = Tpl.writeStr(txt, intString(i_indexrow));
        txt = Tpl.nextIter(txt);
        txt = lm_603(txt, rest);
      then txt;
  end match;
end lm_603;

protected function lm_604
  input Tpl.Text in_txt;
  input SimCode.SparsityPattern in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      SimCode.SparsityPattern rest;
      list<Integer> i_indexes;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           (_, i_indexes) :: rest )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_603(txt, i_indexes);
        txt = Tpl.popIter(txt);
        txt = Tpl.nextIter(txt);
        txt = lm_604(txt, rest);
      then txt;
  end match;
end lm_604;

public function genSPCRSRows
  input Tpl.Text txt;
  input Integer a_nonZeroElems;
  input SimCode.SparsityPattern a_sparsepattern;
  input String a_constArrayName;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_rowsIndex;
algorithm
  l_rowsIndex := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  l_rowsIndex := lm_604(l_rowsIndex, a_sparsepattern);
  l_rowsIndex := Tpl.popIter(l_rowsIndex);
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING("const int "));
  out_txt := Tpl.writeStr(out_txt, a_constArrayName);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("["));
  out_txt := Tpl.writeStr(out_txt, intString(a_nonZeroElems));
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("] = {"));
  out_txt := Tpl.writeText(out_txt, l_rowsIndex);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("};"));
end genSPCRSRows;

protected function lm_606
  input Tpl.Text in_txt;
  input list<Integer> in_items;
  input Integer in_a_index0;
  input String in_a_arrayName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_index0, in_a_arrayName)
    local
      Tpl.Text txt;
      list<Integer> rest;
      Integer a_index0;
      String a_arrayName;
      Integer i_i__index;
      Integer ret_0;

    case ( txt,
           {},
           _,
           _ )
      then txt;

    case ( txt,
           i_i__index :: rest,
           a_index0,
           a_arrayName )
      equation
        txt = Tpl.writeStr(txt, a_arrayName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("["));
        txt = Tpl.writeStr(txt, intString(i_i__index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = "));
        ret_0 = intAdd(a_index0, 1);
        txt = Tpl.writeStr(txt, intString(ret_0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        txt = lm_606(txt, rest, a_index0, a_arrayName);
      then txt;
  end match;
end lm_606;

protected function lm_607
  input Tpl.Text in_txt;
  input list<list<Integer>> in_items;
  input String in_a_arrayName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_arrayName)
    local
      Tpl.Text txt;
      list<list<Integer>> rest;
      String a_arrayName;
      Integer x_index0;
      list<Integer> i_indexes;
      Tpl.Text l_colorCol;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_indexes :: rest,
           a_arrayName )
      equation
        x_index0 = Tpl.getIteri_i0(txt);
        l_colorCol = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_colorCol = lm_606(l_colorCol, i_indexes, x_index0, a_arrayName);
        l_colorCol = Tpl.popIter(l_colorCol);
        txt = Tpl.writeText(txt, l_colorCol);
        txt = Tpl.nextIter(txt);
        txt = lm_607(txt, rest, a_arrayName);
      then txt;
  end match;
end lm_607;

public function genSPColors
  input Tpl.Text txt;
  input list<list<Integer>> a_colorList;
  input String a_arrayName;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_colorArray;
algorithm
  l_colorArray := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  l_colorArray := lm_607(l_colorArray, a_colorList, a_arrayName);
  l_colorArray := Tpl.popIter(l_colorArray);
  out_txt := Tpl.writeText(txt, l_colorArray);
end genSPColors;

protected function fun_609
  input Tpl.Text in_txt;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_context)
    local
      Tpl.Text txt;

    case ( txt,
           SimCodeFunction.SIMULATION_CONTEXT(genDiscrete = true) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("1"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("0"));
      then txt;
  end match;
end fun_609;

protected function lm_610
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      String a_modelNamePrefix;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_eq :: rest,
           a_modelNamePrefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = CodegenUtil.symbolName(txt, a_modelNamePrefix, "eqFunction");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = CodegenUtilSimulation.equationIndex(txt, i_eq);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(DATA*,threadData_t*);"));
        txt = Tpl.nextIter(txt);
        txt = lm_610(txt, rest, a_modelNamePrefix);
      then txt;
  end match;
end lm_610;

protected function lm_611
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      String a_modelNamePrefix;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_eq :: rest,
           a_modelNamePrefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = CodegenUtil.symbolName(txt, a_modelNamePrefix, "eqFunction");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = CodegenUtilSimulation.equationIndex(txt, i_eq);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(DATA*,threadData_t*);"));
        txt = Tpl.nextIter(txt);
        txt = lm_611(txt, rest, a_modelNamePrefix);
      then txt;
  end match;
end lm_611;

protected function lm_612
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      String a_modelNamePrefix;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_eq :: rest,
           a_modelNamePrefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = CodegenUtil.symbolName(txt, a_modelNamePrefix, "eqFunction");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = CodegenUtilSimulation.equationIndex(txt, i_eq);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(DATA*,threadData_t*);"));
        txt = Tpl.nextIter(txt);
        txt = lm_612(txt, rest, a_modelNamePrefix);
      then txt;
  end match;
end lm_612;

protected function fun_613
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input Tpl.Text in_a_eqfuncs;
  input Tpl.Text in_a_OMC__DISABLE__OPT;
  input Boolean in_a_init;
  input String in_a_modelNamePrefix;
  input Tpl.Text in_a_tempeqns;
  input Tpl.Text in_a_varD;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_eqfuncs;
  output Tpl.Text out_a_OMC__DISABLE__OPT;
  output Tpl.Text out_a_tempeqns;
  output Tpl.Text out_a_varD;
algorithm
  (out_txt, out_a_eqfuncs, out_a_OMC__DISABLE__OPT, out_a_tempeqns, out_a_varD) :=
  match(in_txt, in_a_eq, in_a_eqfuncs, in_a_OMC__DISABLE__OPT, in_a_init, in_a_modelNamePrefix, in_a_tempeqns, in_a_varD, in_a_context)
    local
      Tpl.Text txt;
      Tpl.Text a_eqfuncs;
      Tpl.Text a_OMC__DISABLE__OPT;
      Boolean a_init;
      String a_modelNamePrefix;
      Tpl.Text a_tempeqns;
      Tpl.Text a_varD;
      SimCodeFunction.Context a_context;
      list<SimCode.SimEqSystem> i_at_eqs;
      list<SimCode.SimEqSystem> i_nls_eqs;
      SimCode.SimEqSystem i_e;

    case ( txt,
           (i_e as SimCode.SES_SIMPLE_ASSIGN(index = _)),
           a_eqfuncs,
           a_OMC__DISABLE__OPT,
           _,
           _,
           a_tempeqns,
           a_varD,
           a_context )
      equation
        (txt, a_varD, a_tempeqns) = equationSimpleAssign(txt, i_e, a_context, a_varD, a_tempeqns);
      then (txt, a_eqfuncs, a_OMC__DISABLE__OPT, a_tempeqns, a_varD);

    case ( txt,
           (i_e as SimCode.SES_SIMPLE_ASSIGN_CONSTRAINTS(index = _)),
           a_eqfuncs,
           a_OMC__DISABLE__OPT,
           _,
           _,
           a_tempeqns,
           a_varD,
           a_context )
      equation
        (txt, a_varD, a_tempeqns) = equationSimpleAssign(txt, i_e, a_context, a_varD, a_tempeqns);
      then (txt, a_eqfuncs, a_OMC__DISABLE__OPT, a_tempeqns, a_varD);

    case ( txt,
           (i_e as SimCode.SES_ARRAY_CALL_ASSIGN(index = _)),
           a_eqfuncs,
           a_OMC__DISABLE__OPT,
           _,
           _,
           a_tempeqns,
           a_varD,
           a_context )
      equation
        (txt, a_varD, a_tempeqns) = equationArrayCallAssign(txt, i_e, a_context, a_varD, a_tempeqns);
      then (txt, a_eqfuncs, a_OMC__DISABLE__OPT, a_tempeqns, a_varD);

    case ( txt,
           (i_e as SimCode.SES_IFEQUATION(index = _)),
           a_eqfuncs,
           a_OMC__DISABLE__OPT,
           a_init,
           a_modelNamePrefix,
           a_tempeqns,
           a_varD,
           a_context )
      equation
        (txt, a_varD, a_tempeqns) = equationIfEquationAssign(txt, i_e, a_context, a_varD, a_tempeqns, a_modelNamePrefix, a_init);
      then (txt, a_eqfuncs, a_OMC__DISABLE__OPT, a_tempeqns, a_varD);

    case ( txt,
           (i_e as SimCode.SES_ALGORITHM(index = _)),
           a_eqfuncs,
           a_OMC__DISABLE__OPT,
           _,
           _,
           a_tempeqns,
           a_varD,
           a_context )
      equation
        (txt, a_varD, a_tempeqns) = equationAlgorithm(txt, i_e, a_context, a_varD, a_tempeqns);
      then (txt, a_eqfuncs, a_OMC__DISABLE__OPT, a_tempeqns, a_varD);

    case ( txt,
           (i_e as SimCode.SES_INVERSE_ALGORITHM(index = _)),
           a_eqfuncs,
           a_OMC__DISABLE__OPT,
           _,
           _,
           a_tempeqns,
           a_varD,
           a_context )
      equation
        (txt, a_varD, a_tempeqns) = equationAlgorithm(txt, i_e, a_context, a_varD, a_tempeqns);
      then (txt, a_eqfuncs, a_OMC__DISABLE__OPT, a_tempeqns, a_varD);

    case ( txt,
           (i_e as SimCode.SES_LINEAR(lSystem = _)),
           a_eqfuncs,
           a_OMC__DISABLE__OPT,
           _,
           _,
           a_tempeqns,
           a_varD,
           a_context )
      equation
        a_OMC__DISABLE__OPT = Tpl.writeTok(a_OMC__DISABLE__OPT, Tpl.ST_STRING("OMC_DISABLE_OPT"));
        a_OMC__DISABLE__OPT = Tpl.writeTok(a_OMC__DISABLE__OPT, Tpl.ST_NEW_LINE());
        (txt, a_varD) = equationLinear(txt, i_e, a_context, a_varD);
      then (txt, a_eqfuncs, a_OMC__DISABLE__OPT, a_tempeqns, a_varD);

    case ( txt,
           (i_e as SimCode.SES_NONLINEAR(nlSystem = SimCode.NONLINEARSYSTEM(eqs = i_nls_eqs), alternativeTearing = NONE())),
           a_eqfuncs,
           a_OMC__DISABLE__OPT,
           a_init,
           a_modelNamePrefix,
           a_tempeqns,
           a_varD,
           a_context )
      equation
        a_tempeqns = Tpl.pushIter(a_tempeqns, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        a_tempeqns = lm_610(a_tempeqns, i_nls_eqs, a_modelNamePrefix);
        a_tempeqns = Tpl.popIter(a_tempeqns);
        txt = equationNonlinear(txt, i_e, a_context, a_modelNamePrefix, a_init);
      then (txt, a_eqfuncs, a_OMC__DISABLE__OPT, a_tempeqns, a_varD);

    case ( txt,
           (i_e as SimCode.SES_NONLINEAR(nlSystem = SimCode.NONLINEARSYSTEM(eqs = i_nls_eqs), alternativeTearing = SOME(SimCode.NONLINEARSYSTEM(eqs = i_at_eqs)))),
           a_eqfuncs,
           a_OMC__DISABLE__OPT,
           a_init,
           a_modelNamePrefix,
           a_tempeqns,
           a_varD,
           a_context )
      equation
        a_tempeqns = Tpl.pushIter(a_tempeqns, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        a_tempeqns = lm_611(a_tempeqns, i_nls_eqs, a_modelNamePrefix);
        a_tempeqns = Tpl.popIter(a_tempeqns);
        a_tempeqns = Tpl.writeTok(a_tempeqns, Tpl.ST_NEW_LINE());
        a_tempeqns = Tpl.pushIter(a_tempeqns, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        a_tempeqns = lm_612(a_tempeqns, i_at_eqs, a_modelNamePrefix);
        a_tempeqns = Tpl.popIter(a_tempeqns);
        txt = equationNonlinear(txt, i_e, a_context, a_modelNamePrefix, a_init);
      then (txt, a_eqfuncs, a_OMC__DISABLE__OPT, a_tempeqns, a_varD);

    case ( txt,
           (i_e as SimCode.SES_WHEN(index = _)),
           a_eqfuncs,
           a_OMC__DISABLE__OPT,
           _,
           _,
           a_tempeqns,
           a_varD,
           a_context )
      equation
        (txt, a_varD, a_tempeqns) = equationWhen(txt, i_e, a_context, a_varD, a_tempeqns);
      then (txt, a_eqfuncs, a_OMC__DISABLE__OPT, a_tempeqns, a_varD);

    case ( txt,
           SimCode.SES_RESIDUAL(index = _),
           a_eqfuncs,
           a_OMC__DISABLE__OPT,
           _,
           _,
           a_tempeqns,
           a_varD,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("NOT IMPLEMENTED EQUATION SES_RESIDUAL"));
      then (txt, a_eqfuncs, a_OMC__DISABLE__OPT, a_tempeqns, a_varD);

    case ( txt,
           (i_e as SimCode.SES_MIXED(index = _)),
           a_eqfuncs,
           a_OMC__DISABLE__OPT,
           a_init,
           a_modelNamePrefix,
           a_tempeqns,
           a_varD,
           a_context )
      equation
        (txt, a_eqfuncs) = equationMixed(txt, i_e, a_context, a_eqfuncs, a_modelNamePrefix, a_init);
      then (txt, a_eqfuncs, a_OMC__DISABLE__OPT, a_tempeqns, a_varD);

    case ( txt,
           _,
           a_eqfuncs,
           a_OMC__DISABLE__OPT,
           _,
           _,
           a_tempeqns,
           a_varD,
           _ )
      equation
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 5163, 11), "NOT IMPLEMENTED EQUATION equation_");
      then (txt, a_eqfuncs, a_OMC__DISABLE__OPT, a_tempeqns, a_varD);
  end match;
end fun_613;

public function equation_arrayFormat
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input String in_a_name;
  input SimCodeFunction.Context in_a_context;
  input Integer in_a_arrayIndex;
  input Tpl.Text in_a_eqArray;
  input Tpl.Text in_a_eqfuncs;
  input String in_a_modelNamePrefix;
  input Boolean in_a_init;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_eqArray;
  output Tpl.Text out_a_eqfuncs;
algorithm
  (out_txt, out_a_eqArray, out_a_eqfuncs) :=
  match(in_txt, in_a_eq, in_a_name, in_a_context, in_a_arrayIndex, in_a_eqArray, in_a_eqfuncs, in_a_modelNamePrefix, in_a_init)
    local
      Tpl.Text txt;
      String a_name;
      SimCodeFunction.Context a_context;
      Integer a_arrayIndex;
      Tpl.Text a_eqArray;
      Tpl.Text a_eqfuncs;
      String a_modelNamePrefix;
      Boolean a_init;
      SimCode.SimEqSystem i_eq;
      list<SimCode.SimEqSystem> ret_7;
      Tpl.Text l_x;
      Tpl.Text l_disc;
      Tpl.Text l_OMC__DISABLE__OPT;
      Tpl.Text l_tempeqns;
      Tpl.Text l_varD;
      Tpl.Text l_tmp;
      Tpl.Text l_ix;

    case ( txt,
           SimCode.SES_ALGORITHM(statements = {}),
           _,
           _,
           _,
           a_eqArray,
           a_eqfuncs,
           _,
           _ )
      then (txt, a_eqArray, a_eqfuncs);

    case ( txt,
           i_eq,
           a_name,
           a_context,
           a_arrayIndex,
           a_eqArray,
           a_eqfuncs,
           a_modelNamePrefix,
           a_init )
      equation
        l_ix = CodegenUtilSimulation.equationIndex(Tpl.emptyTxt, i_eq);
        l_tmp = Tpl.emptyTxt;
        l_varD = Tpl.emptyTxt;
        l_tempeqns = Tpl.emptyTxt;
        l_OMC__DISABLE__OPT = Tpl.emptyTxt;
        System.tmpTickResetIndex(0, 1);
        l_disc = fun_609(Tpl.emptyTxt, a_context);
        (l_x, a_eqfuncs, l_OMC__DISABLE__OPT, l_tempeqns, l_varD) = fun_613(Tpl.emptyTxt, i_eq, a_eqfuncs, l_OMC__DISABLE__OPT, a_init, a_modelNamePrefix, l_tempeqns, l_varD, a_context);
        a_eqArray = CodegenUtil.symbolName(a_eqArray, a_modelNamePrefix, "eqFunction");
        a_eqArray = Tpl.writeTok(a_eqArray, Tpl.ST_STRING("_"));
        a_eqArray = Tpl.writeText(a_eqArray, l_ix);
        a_eqArray = Tpl.writeTok(a_eqArray, Tpl.ST_STRING(", "));
        a_eqArray = Tpl.writeTok(a_eqArray, Tpl.ST_NEW_LINE());
        l_varD = CodegenCFunctions.addRootsTempArray(l_varD);
        a_eqfuncs = Tpl.writeTok(a_eqfuncs, Tpl.ST_NEW_LINE());
        a_eqfuncs = Tpl.writeText(a_eqfuncs, l_tempeqns);
        a_eqfuncs = Tpl.softNewLine(a_eqfuncs);
        a_eqfuncs = Tpl.writeTok(a_eqfuncs, Tpl.ST_LINE("/*\n"));
        a_eqfuncs = Tpl.pushBlock(a_eqfuncs, Tpl.BT_INDENT(1));
        ret_7 = List.fill(i_eq, 1);
        a_eqfuncs = CodegenUtilSimulation.dumpEqs(a_eqfuncs, ret_7);
        a_eqfuncs = Tpl.softNewLine(a_eqfuncs);
        a_eqfuncs = Tpl.writeTok(a_eqfuncs, Tpl.ST_LINE("*/\n"));
        a_eqfuncs = Tpl.popBlock(a_eqfuncs);
        a_eqfuncs = Tpl.writeText(a_eqfuncs, l_OMC__DISABLE__OPT);
        a_eqfuncs = Tpl.writeTok(a_eqfuncs, Tpl.ST_STRING("void "));
        a_eqfuncs = CodegenUtil.symbolName(a_eqfuncs, a_modelNamePrefix, "eqFunction");
        a_eqfuncs = Tpl.writeTok(a_eqfuncs, Tpl.ST_STRING("_"));
        a_eqfuncs = Tpl.writeText(a_eqfuncs, l_ix);
        a_eqfuncs = Tpl.writeTok(a_eqfuncs, Tpl.ST_STRING_LIST({
                                                "(DATA *data, threadData_t *threadData)\n",
                                                "{\n",
                                                "  TRACE_PUSH\n"
                                            }, true));
        a_eqfuncs = Tpl.pushBlock(a_eqfuncs, Tpl.BT_INDENT(2));
        a_eqfuncs = Tpl.writeTok(a_eqfuncs, Tpl.ST_STRING("const int equationIndexes[2] = {1,"));
        a_eqfuncs = Tpl.writeText(a_eqfuncs, l_ix);
        a_eqfuncs = Tpl.writeTok(a_eqfuncs, Tpl.ST_LINE("};\n"));
        a_eqfuncs = Tpl.writeText(a_eqfuncs, l_varD);
        a_eqfuncs = Tpl.softNewLine(a_eqfuncs);
        a_eqfuncs = Tpl.writeText(a_eqfuncs, l_x);
        a_eqfuncs = Tpl.softNewLine(a_eqfuncs);
        a_eqfuncs = Tpl.writeTok(a_eqfuncs, Tpl.ST_LINE("TRACE_POP\n"));
        a_eqfuncs = Tpl.popBlock(a_eqfuncs);
        a_eqfuncs = Tpl.writeTok(a_eqfuncs, Tpl.ST_STRING("}"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("// "));
        txt = CodegenUtil.symbolName(txt, a_modelNamePrefix, "eqFunction");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeText(txt, l_ix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(data, threadData);\n",
                                    "function"
                                }, false));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_systems["));
        txt = Tpl.writeStr(txt, intString(a_arrayIndex));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("](data, threadData);"));
      then (txt, a_eqArray, a_eqfuncs);
  end match;
end equation_arrayFormat;

public function equation_impl
  input Tpl.Text txt;
  input Integer a_clockIndex;
  input SimCode.SimEqSystem a_eq;
  input SimCodeFunction.Context a_context;
  input String a_modelNamePrefix;
  input Boolean a_init;

  output Tpl.Text out_txt;
algorithm
  out_txt := equation_impl2(txt, a_clockIndex, a_eq, a_context, a_modelNamePrefix, false, false, a_init);
end equation_impl;

public function equation_impl_options
  input Tpl.Text txt;
  input Integer a_clockIndex;
  input SimCode.SimEqSystem a_eq;
  input SimCodeFunction.Context a_context;
  input String a_modelNamePrefix;
  input Boolean a_static;
  input Boolean a_noOpt;
  input Boolean a_init;

  output Tpl.Text out_txt;
algorithm
  out_txt := equation_impl2(txt, a_clockIndex, a_eq, a_context, a_modelNamePrefix, a_static, a_noOpt, a_init);
end equation_impl_options;

protected function fun_617
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_eq)
    local
      Tpl.Text txt;

    case ( txt,
           SimCode.SES_LINEAR(lSystem = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("OMC_DISABLE_OPT"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_617;

protected function fun_618
  input Tpl.Text in_txt;
  input Boolean in_a_noOpt;
  input SimCode.SimEqSystem in_a_eq;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_noOpt, in_a_eq)
    local
      Tpl.Text txt;
      SimCode.SimEqSystem a_eq;

    case ( txt,
           false,
           a_eq )
      equation
        txt = fun_617(txt, a_eq);
      then txt;

    case ( txt,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("OMC_DISABLE_OPT"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;
  end match;
end fun_618;

protected function fun_619
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_eq)
    local
      Tpl.Text txt;
      SimCode.SimEqSystem i_e;

    case ( txt,
           (i_e as SimCode.SES_LINEAR(lSystem = SimCode.LINEARSYSTEM(index = _), alternativeTearing = SOME(SimCode.LINEARSYSTEM(index = _)))) )
      equation
        txt = CodegenUtilSimulation.equationIndexAlternativeTearing(txt, i_e);
      then txt;

    case ( txt,
           (i_e as SimCode.SES_NONLINEAR(nlSystem = SimCode.NONLINEARSYSTEM(index = _), alternativeTearing = SOME(SimCode.NONLINEARSYSTEM(index = _)))) )
      equation
        txt = CodegenUtilSimulation.equationIndexAlternativeTearing(txt, i_e);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_619;

protected function fun_620
  input Tpl.Text in_txt;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_context)
    local
      Tpl.Text txt;

    case ( txt,
           SimCodeFunction.SIMULATION_CONTEXT(genDiscrete = true) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("1"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("0"));
      then txt;
  end match;
end fun_620;

protected function lm_621
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      String a_modelNamePrefix;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_eq :: rest,
           a_modelNamePrefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = CodegenUtil.symbolName(txt, a_modelNamePrefix, "eqFunction");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = CodegenUtilSimulation.equationIndex(txt, i_eq);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(DATA*, threadData_t*);"));
        txt = Tpl.nextIter(txt);
        txt = lm_621(txt, rest, a_modelNamePrefix);
      then txt;
  end match;
end lm_621;

protected function fun_622
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input Boolean in_a_init;
  input String in_a_modelNamePrefix;
  input Tpl.Text in_a_tempeqns;
  input Tpl.Text in_a_varD;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_tempeqns;
  output Tpl.Text out_a_varD;
algorithm
  (out_txt, out_a_tempeqns, out_a_varD) :=
  match(in_txt, in_a_eq, in_a_init, in_a_modelNamePrefix, in_a_tempeqns, in_a_varD, in_a_context)
    local
      Tpl.Text txt;
      Boolean a_init;
      String a_modelNamePrefix;
      Tpl.Text a_tempeqns;
      Tpl.Text a_varD;
      SimCodeFunction.Context a_context;
      list<SimCode.SimEqSystem> i_nls_eqs;
      SimCode.SimEqSystem i_e;
      Tpl.Text l_res;
      Tpl.Text l_eqs;

    case ( txt,
           (i_e as SimCode.SES_SIMPLE_ASSIGN(index = _)),
           _,
           _,
           a_tempeqns,
           a_varD,
           a_context )
      equation
        (txt, a_varD, a_tempeqns) = equationSimpleAssign(txt, i_e, a_context, a_varD, a_tempeqns);
      then (txt, a_tempeqns, a_varD);

    case ( txt,
           (i_e as SimCode.SES_SIMPLE_ASSIGN_CONSTRAINTS(index = _)),
           _,
           _,
           a_tempeqns,
           a_varD,
           a_context )
      equation
        (txt, a_varD, a_tempeqns) = equationSimpleAssign(txt, i_e, a_context, a_varD, a_tempeqns);
      then (txt, a_tempeqns, a_varD);

    case ( txt,
           (i_e as SimCode.SES_ARRAY_CALL_ASSIGN(index = _)),
           _,
           _,
           a_tempeqns,
           a_varD,
           a_context )
      equation
        (txt, a_varD, a_tempeqns) = equationArrayCallAssign(txt, i_e, a_context, a_varD, a_tempeqns);
      then (txt, a_tempeqns, a_varD);

    case ( txt,
           (i_e as SimCode.SES_IFEQUATION(index = _)),
           a_init,
           a_modelNamePrefix,
           a_tempeqns,
           a_varD,
           a_context )
      equation
        (txt, a_varD, a_tempeqns) = equationIfEquationAssign(txt, i_e, a_context, a_varD, a_tempeqns, a_modelNamePrefix, a_init);
      then (txt, a_tempeqns, a_varD);

    case ( txt,
           (i_e as SimCode.SES_ALGORITHM(index = _)),
           _,
           _,
           a_tempeqns,
           a_varD,
           a_context )
      equation
        (txt, a_varD, a_tempeqns) = equationAlgorithm(txt, i_e, a_context, a_varD, a_tempeqns);
      then (txt, a_tempeqns, a_varD);

    case ( txt,
           (i_e as SimCode.SES_INVERSE_ALGORITHM(index = _)),
           _,
           _,
           a_tempeqns,
           a_varD,
           a_context )
      equation
        (txt, a_varD, a_tempeqns) = equationAlgorithm(txt, i_e, a_context, a_varD, a_tempeqns);
      then (txt, a_tempeqns, a_varD);

    case ( txt,
           (i_e as SimCode.SES_LINEAR(lSystem = _)),
           _,
           _,
           a_tempeqns,
           a_varD,
           a_context )
      equation
        (txt, a_varD) = equationLinear(txt, i_e, a_context, a_varD);
      then (txt, a_tempeqns, a_varD);

    case ( txt,
           (i_e as SimCode.SES_NONLINEAR(nlSystem = SimCode.NONLINEARSYSTEM(eqs = i_nls_eqs))),
           a_init,
           a_modelNamePrefix,
           a_tempeqns,
           a_varD,
           a_context )
      equation
        a_tempeqns = Tpl.pushIter(a_tempeqns, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        a_tempeqns = lm_621(a_tempeqns, i_nls_eqs, a_modelNamePrefix);
        a_tempeqns = Tpl.popIter(a_tempeqns);
        txt = equationNonlinear(txt, i_e, a_context, a_modelNamePrefix, a_init);
      then (txt, a_tempeqns, a_varD);

    case ( txt,
           (i_e as SimCode.SES_WHEN(index = _)),
           _,
           _,
           a_tempeqns,
           a_varD,
           a_context )
      equation
        (txt, a_varD, a_tempeqns) = equationWhen(txt, i_e, a_context, a_varD, a_tempeqns);
      then (txt, a_tempeqns, a_varD);

    case ( txt,
           SimCode.SES_RESIDUAL(index = _),
           _,
           _,
           a_tempeqns,
           a_varD,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("NOT IMPLEMENTED EQUATION SES_RESIDUAL"));
      then (txt, a_tempeqns, a_varD);

    case ( txt,
           (i_e as SimCode.SES_MIXED(index = _)),
           a_init,
           a_modelNamePrefix,
           a_tempeqns,
           a_varD,
           a_context )
      equation
        l_eqs = Tpl.emptyTxt;
        (l_res, l_eqs) = equationMixed(Tpl.emptyTxt, i_e, a_context, l_eqs, a_modelNamePrefix, a_init);
        txt = Tpl.writeText(txt, l_eqs);
        txt = Tpl.writeText(txt, l_res);
      then (txt, a_tempeqns, a_varD);

    case ( txt,
           (i_e as SimCode.SES_FOR_LOOP(index = _)),
           _,
           _,
           a_tempeqns,
           a_varD,
           a_context )
      equation
        (txt, a_varD, a_tempeqns) = equationForLoop(txt, i_e, a_context, a_varD, a_tempeqns);
      then (txt, a_tempeqns, a_varD);

    case ( txt,
           _,
           _,
           _,
           a_tempeqns,
           a_varD,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("NOT IMPLEMENTED EQUATION equation_"));
      then (txt, a_tempeqns, a_varD);
  end match;
end fun_622;

protected function lm_623
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      String a_modelNamePrefix;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_eq :: rest,
           a_modelNamePrefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = CodegenUtil.symbolName(txt, a_modelNamePrefix, "eqFunction");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = CodegenUtilSimulation.equationIndex(txt, i_eq);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(DATA*,threadData_t*);"));
        txt = Tpl.nextIter(txt);
        txt = lm_623(txt, rest, a_modelNamePrefix);
      then txt;
  end match;
end lm_623;

protected function fun_624
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input Boolean in_a_init;
  input String in_a_modelNamePrefix;
  input Tpl.Text in_a_tempeqns2;
  input Tpl.Text in_a_varD;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_tempeqns2;
  output Tpl.Text out_a_varD;
algorithm
  (out_txt, out_a_tempeqns2, out_a_varD) :=
  match(in_txt, in_a_eq, in_a_init, in_a_modelNamePrefix, in_a_tempeqns2, in_a_varD, in_a_context)
    local
      Tpl.Text txt;
      Boolean a_init;
      String a_modelNamePrefix;
      Tpl.Text a_tempeqns2;
      Tpl.Text a_varD;
      SimCodeFunction.Context a_context;
      list<SimCode.SimEqSystem> i_at_eqs;
      SimCode.SimEqSystem i_e;

    case ( txt,
           (i_e as SimCode.SES_LINEAR(lSystem = SimCode.LINEARSYSTEM(index = _), alternativeTearing = SOME(SimCode.LINEARSYSTEM(index = _)))),
           _,
           _,
           a_tempeqns2,
           a_varD,
           a_context )
      equation
        (txt, a_varD) = equationLinearAlternativeTearing(txt, i_e, a_context, a_varD);
      then (txt, a_tempeqns2, a_varD);

    case ( txt,
           (i_e as SimCode.SES_NONLINEAR(nlSystem = SimCode.NONLINEARSYSTEM(index = _), alternativeTearing = SOME(SimCode.NONLINEARSYSTEM(eqs = i_at_eqs)))),
           a_init,
           a_modelNamePrefix,
           a_tempeqns2,
           a_varD,
           a_context )
      equation
        a_tempeqns2 = Tpl.pushIter(a_tempeqns2, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        a_tempeqns2 = lm_623(a_tempeqns2, i_at_eqs, a_modelNamePrefix);
        a_tempeqns2 = Tpl.popIter(a_tempeqns2);
        txt = equationNonlinearAlternativeTearing(txt, i_e, a_context, a_modelNamePrefix, a_init);
      then (txt, a_tempeqns2, a_varD);

    case ( txt,
           _,
           _,
           _,
           a_tempeqns2,
           a_varD,
           _ )
      then (txt, a_tempeqns2, a_varD);
  end match;
end fun_624;

protected function fun_625
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_clockIndex;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_clockIndex)
    local
      Tpl.Text txt;
      Integer a_clockIndex;

    case ( txt,
           false,
           a_clockIndex )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("const int clockIndex = "));
        txt = Tpl.writeStr(txt, intString(a_clockIndex));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_625;

protected function fun_626
  input Tpl.Text in_txt;
  input Boolean in_a_static;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_static)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("static "));
      then txt;
  end match;
end fun_626;

protected function fun_627
  input Tpl.Text in_txt;
  input Boolean in_a_static;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_static)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("static "));
      then txt;
  end match;
end fun_627;

protected function fun_628
  input Tpl.Text in_txt;
  input Boolean in_a_static;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_static)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("static "));
      then txt;
  end match;
end fun_628;

protected function fun_629
  input Tpl.Text in_txt;
  input Boolean in_a_static;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_static)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("static "));
      then txt;
  end match;
end fun_629;

protected function fun_630
  input Tpl.Text in_txt;
  input Boolean in_a_static;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_static)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("static "));
      then txt;
  end match;
end fun_630;

protected function fun_631
  input Tpl.Text in_txt;
  input Boolean in_a_static;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_static)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("static "));
      then txt;
  end match;
end fun_631;

protected function fun_632
  input Tpl.Text in_txt;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_x;
  input Tpl.Text in_a_varD;
  input Tpl.Text in_a_clockIndex__;
  input Tpl.Text in_a_ix;
  input String in_a_modelNamePrefix;
  input Boolean in_a_static;
  input Tpl.Text in_a_OMC__NO__OPT;
  input SimCode.SimEqSystem in_a_eq;
  input Tpl.Text in_a_tempeqns;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_context, in_a_x, in_a_varD, in_a_clockIndex__, in_a_ix, in_a_modelNamePrefix, in_a_static, in_a_OMC__NO__OPT, in_a_eq, in_a_tempeqns)
    local
      Tpl.Text txt;
      Tpl.Text a_x;
      Tpl.Text a_varD;
      Tpl.Text a_clockIndex__;
      Tpl.Text a_ix;
      String a_modelNamePrefix;
      Boolean a_static;
      Tpl.Text a_OMC__NO__OPT;
      SimCode.SimEqSystem a_eq;
      Tpl.Text a_tempeqns;
      list<SimCode.SimEqSystem> ret_1;
      list<SimCode.SimEqSystem> ret_0;

    case ( txt,
           SimCodeFunction.JACOBIAN_CONTEXT(jacHT = _),
           a_x,
           a_varD,
           a_clockIndex__,
           a_ix,
           a_modelNamePrefix,
           a_static,
           a_OMC__NO__OPT,
           a_eq,
           a_tempeqns )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_tempeqns);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/*\n"));
        ret_0 = List.fill(a_eq, 1);
        txt = CodegenUtilSimulation.dumpEqs(txt, ret_0);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("*/\n"));
        txt = Tpl.writeText(txt, a_OMC__NO__OPT);
        txt = fun_630(txt, a_static);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = CodegenUtil.symbolName(txt, a_modelNamePrefix, "eqFunction");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeText(txt, a_ix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA *data, threadData_t *threadData, ANALYTIC_JACOBIAN *jacobian, ANALYTIC_JACOBIAN *parentJacobian)\n",
                                    "{\n",
                                    "  TRACE_PUSH\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_clockIndex__);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("const int equationIndexes[2] = {1,"));
        txt = Tpl.writeText(txt, a_ix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("};\n"));
        txt = Tpl.writeText(txt, a_varD);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, a_x);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("TRACE_POP\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;

    case ( txt,
           _,
           a_x,
           a_varD,
           a_clockIndex__,
           a_ix,
           a_modelNamePrefix,
           a_static,
           a_OMC__NO__OPT,
           a_eq,
           a_tempeqns )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_tempeqns);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/*\n"));
        ret_1 = List.fill(a_eq, 1);
        txt = CodegenUtilSimulation.dumpEqs(txt, ret_1);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("*/\n"));
        txt = Tpl.writeText(txt, a_OMC__NO__OPT);
        txt = fun_631(txt, a_static);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = CodegenUtil.symbolName(txt, a_modelNamePrefix, "eqFunction");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeText(txt, a_ix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA *data, threadData_t *threadData)\n",
                                    "{\n",
                                    "  TRACE_PUSH\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_clockIndex__);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("const int equationIndexes[2] = {1,"));
        txt = Tpl.writeText(txt, a_ix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("};\n"));
        txt = Tpl.writeText(txt, a_varD);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, a_x);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("TRACE_POP\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;
  end match;
end fun_632;

protected function fun_633
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_x2;
  input Tpl.Text in_a_ix2;
  input Tpl.Text in_a_tempeqns2;
  input Tpl.Text in_a_x;
  input Tpl.Text in_a_varD;
  input Tpl.Text in_a_clockIndex__;
  input Tpl.Text in_a_ix;
  input String in_a_modelNamePrefix;
  input Boolean in_a_static;
  input Tpl.Text in_a_OMC__NO__OPT;
  input Tpl.Text in_a_tempeqns;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_eq, in_a_context, in_a_x2, in_a_ix2, in_a_tempeqns2, in_a_x, in_a_varD, in_a_clockIndex__, in_a_ix, in_a_modelNamePrefix, in_a_static, in_a_OMC__NO__OPT, in_a_tempeqns)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_x2;
      Tpl.Text a_ix2;
      Tpl.Text a_tempeqns2;
      Tpl.Text a_x;
      Tpl.Text a_varD;
      Tpl.Text a_clockIndex__;
      Tpl.Text a_ix;
      String a_modelNamePrefix;
      Boolean a_static;
      Tpl.Text a_OMC__NO__OPT;
      Tpl.Text a_tempeqns;
      SimCode.SimEqSystem i_eq;
      SimCode.SimEqSystem i_e;
      list<SimCode.SimEqSystem> ret_3;
      list<SimCode.SimEqSystem> ret_2;
      list<SimCode.SimEqSystem> ret_1;
      list<SimCode.SimEqSystem> ret_0;

    case ( txt,
           (i_e as SimCode.SES_LINEAR(lSystem = SimCode.LINEARSYSTEM(index = _), alternativeTearing = SOME(SimCode.LINEARSYSTEM(index = _)))),
           _,
           a_x2,
           a_ix2,
           a_tempeqns2,
           a_x,
           a_varD,
           a_clockIndex__,
           a_ix,
           a_modelNamePrefix,
           a_static,
           a_OMC__NO__OPT,
           a_tempeqns )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_tempeqns);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/*\n"));
        ret_0 = List.fill(i_e, 1);
        txt = CodegenUtilSimulation.dumpEqs(txt, ret_0);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("*/\n"));
        txt = Tpl.writeText(txt, a_OMC__NO__OPT);
        txt = fun_626(txt, a_static);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("int "));
        txt = CodegenUtil.symbolName(txt, a_modelNamePrefix, "eqFunction");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeText(txt, a_ix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA *data, threadData_t *threadData)\n",
                                    "{\n",
                                    "  TRACE_PUSH\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_clockIndex__);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("const int equationIndexes[2] = {1,"));
        txt = Tpl.writeText(txt, a_ix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("};\n"));
        txt = Tpl.writeText(txt, a_varD);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, a_x);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("TRACE_POP\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n"
                                }, true));
        txt = Tpl.writeText(txt, a_tempeqns2);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/*\n"));
        ret_1 = List.fill(i_e, 1);
        txt = CodegenUtilSimulation.dumpEqsAlternativeTearing(txt, ret_1);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("*/\n"));
        txt = Tpl.writeText(txt, a_OMC__NO__OPT);
        txt = fun_627(txt, a_static);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = CodegenUtil.symbolName(txt, a_modelNamePrefix, "eqFunction");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeText(txt, a_ix2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA *data, threadData_t *threadData)\n",
                                    "{\n",
                                    "  TRACE_PUSH\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_clockIndex__);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("const int equationIndexes[2] = {1,"));
        txt = Tpl.writeText(txt, a_ix2);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("};\n"));
        txt = Tpl.writeText(txt, a_varD);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, a_x2);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("TRACE_POP\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;

    case ( txt,
           (i_e as SimCode.SES_NONLINEAR(nlSystem = SimCode.NONLINEARSYSTEM(index = _), alternativeTearing = SOME(SimCode.NONLINEARSYSTEM(index = _)))),
           _,
           a_x2,
           a_ix2,
           a_tempeqns2,
           a_x,
           a_varD,
           a_clockIndex__,
           a_ix,
           a_modelNamePrefix,
           a_static,
           a_OMC__NO__OPT,
           a_tempeqns )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_tempeqns);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/*\n"));
        ret_2 = List.fill(i_e, 1);
        txt = CodegenUtilSimulation.dumpEqs(txt, ret_2);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("*/\n"));
        txt = Tpl.writeText(txt, a_OMC__NO__OPT);
        txt = fun_628(txt, a_static);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("int "));
        txt = CodegenUtil.symbolName(txt, a_modelNamePrefix, "eqFunction");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeText(txt, a_ix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA *data, threadData_t *threadData)\n",
                                    "{\n",
                                    "  TRACE_PUSH\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_clockIndex__);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("const int equationIndexes[2] = {1,"));
        txt = Tpl.writeText(txt, a_ix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("};\n"));
        txt = Tpl.writeText(txt, a_varD);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, a_x);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("TRACE_POP\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n"
                                }, true));
        txt = Tpl.writeText(txt, a_tempeqns2);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/*\n"));
        ret_3 = List.fill(i_e, 1);
        txt = CodegenUtilSimulation.dumpEqsAlternativeTearing(txt, ret_3);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("*/\n"));
        txt = Tpl.writeText(txt, a_OMC__NO__OPT);
        txt = fun_629(txt, a_static);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = CodegenUtil.symbolName(txt, a_modelNamePrefix, "eqFunction");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeText(txt, a_ix2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA *data, threadData_t *threadData)\n",
                                    "{\n",
                                    "  TRACE_PUSH\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_clockIndex__);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("const int equationIndexes[2] = {1,"));
        txt = Tpl.writeText(txt, a_ix2);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("};\n"));
        txt = Tpl.writeText(txt, a_varD);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, a_x2);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("TRACE_POP\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;

    case ( txt,
           i_eq,
           a_context,
           _,
           _,
           _,
           a_x,
           a_varD,
           a_clockIndex__,
           a_ix,
           a_modelNamePrefix,
           a_static,
           a_OMC__NO__OPT,
           a_tempeqns )
      equation
        txt = fun_632(txt, a_context, a_x, a_varD, a_clockIndex__, a_ix, a_modelNamePrefix, a_static, a_OMC__NO__OPT, i_eq, a_tempeqns);
      then txt;
  end match;
end fun_633;

protected function fun_634
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input Boolean in_a_static;
  input Tpl.Text in_a_OMC__NO__OPT;
  input Integer in_a_clockIndex;
  input Boolean in_a_init;
  input SimCodeFunction.Context in_a_context;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_eq, in_a_static, in_a_OMC__NO__OPT, in_a_clockIndex, in_a_init, in_a_context, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      Boolean a_static;
      Tpl.Text a_OMC__NO__OPT;
      Integer a_clockIndex;
      Boolean a_init;
      SimCodeFunction.Context a_context;
      String a_modelNamePrefix;
      SimCode.SimEqSystem i_eq;
      Integer i_aliasOf;
      Boolean ret_10;
      Tpl.Text l_clockIndex__;
      Tpl.Text l_x2;
      Tpl.Text l_x;
      Tpl.Text l_disc;
      Tpl.Text l_tempeqns2;
      Tpl.Text l_tempeqns;
      Tpl.Text l_varD;
      Tpl.Text l_tmp;
      Tpl.Text l_ix2;
      Tpl.Text l_ix;

    case ( txt,
           SimCode.SES_ALIAS(aliasOf = i_aliasOf),
           _,
           _,
           _,
           _,
           _,
           a_modelNamePrefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("extern void "));
        txt = CodegenUtil.symbolName(txt, a_modelNamePrefix, "eqFunction");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeStr(txt, intString(i_aliasOf));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(DATA *data, threadData_t *threadData);"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           SimCode.SES_ALGORITHM(statements = {}),
           _,
           _,
           _,
           _,
           _,
           _ )
      then txt;

    case ( txt,
           i_eq,
           a_static,
           a_OMC__NO__OPT,
           a_clockIndex,
           a_init,
           a_context,
           a_modelNamePrefix )
      equation
        l_ix = CodegenUtilSimulation.equationIndex(Tpl.emptyTxt, i_eq);
        l_ix2 = fun_619(Tpl.emptyTxt, i_eq);
        l_tmp = Tpl.emptyTxt;
        l_varD = Tpl.emptyTxt;
        l_tempeqns = Tpl.emptyTxt;
        l_tempeqns2 = Tpl.emptyTxt;
        System.tmpTickResetIndex(0, 1);
        l_disc = fun_620(Tpl.emptyTxt, a_context);
        (l_x, l_tempeqns, l_varD) = fun_622(Tpl.emptyTxt, i_eq, a_init, a_modelNamePrefix, l_tempeqns, l_varD, a_context);
        (l_x2, l_tempeqns2, l_varD) = fun_624(Tpl.emptyTxt, i_eq, a_init, a_modelNamePrefix, l_tempeqns2, l_varD, a_context);
        l_varD = CodegenCFunctions.addRootsTempArray(l_varD);
        ret_10 = intLt(a_clockIndex, 0);
        l_clockIndex__ = fun_625(Tpl.emptyTxt, ret_10, a_clockIndex);
        txt = fun_633(txt, i_eq, a_context, l_x2, l_ix2, l_tempeqns2, l_x, l_varD, l_clockIndex__, l_ix, a_modelNamePrefix, a_static, a_OMC__NO__OPT, l_tempeqns);
      then txt;
  end match;
end fun_634;

public function equation_impl2
  input Tpl.Text txt;
  input Integer a_clockIndex;
  input SimCode.SimEqSystem a_eq;
  input SimCodeFunction.Context a_context;
  input String a_modelNamePrefix;
  input Boolean a_static;
  input Boolean a_noOpt;
  input Boolean a_init;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_OMC__NO__OPT;
algorithm
  l_OMC__NO__OPT := fun_618(Tpl.emptyTxt, a_noOpt, a_eq);
  out_txt := fun_634(txt, a_eq, a_static, l_OMC__NO__OPT, a_clockIndex, a_init, a_context, a_modelNamePrefix);
end equation_impl2;

protected function fun_636
  input Tpl.Text in_txt;
  input SimCodeFunction.Context in_a_context;
  input SimCode.SimEqSystem in_a_eq;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_context, in_a_eq, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      SimCode.SimEqSystem a_eq;
      String a_modelNamePrefix;

    case ( txt,
           SimCodeFunction.JACOBIAN_CONTEXT(jacHT = _),
           a_eq,
           a_modelNamePrefix )
      equation
        txt = equation_callJacobian(txt, a_eq, a_modelNamePrefix);
      then txt;

    case ( txt,
           _,
           a_eq,
           a_modelNamePrefix )
      equation
        txt = equation_call(txt, a_eq, a_modelNamePrefix);
      then txt;
  end match;
end fun_636;

public function equation_call_context
  input Tpl.Text txt;
  input SimCode.SimEqSystem a_eq;
  input String a_modelNamePrefix;
  input SimCodeFunction.Context a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_636(txt, a_context, a_eq, a_modelNamePrefix);
end equation_call_context;

protected function fun_638
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_eq)
    local
      Tpl.Text txt;
      SimCode.SimEqSystem i_eq;
      SimCode.SimEqSystem i_e;

    case ( txt,
           (i_e as SimCode.SES_LINEAR(alternativeTearing = SOME(_))) )
      equation
        txt = CodegenUtilSimulation.equationIndexAlternativeTearing(txt, i_e);
      then txt;

    case ( txt,
           (i_e as SimCode.SES_NONLINEAR(alternativeTearing = SOME(_))) )
      equation
        txt = CodegenUtilSimulation.equationIndexAlternativeTearing(txt, i_e);
      then txt;

    case ( txt,
           i_eq )
      equation
        txt = CodegenUtilSimulation.equationIndex(txt, i_eq);
      then txt;
  end match;
end fun_638;

protected function fun_639
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_ix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_ix)
    local
      Tpl.Text txt;
      Tpl.Text a_ix;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_ix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("SIM_PROF_TICK_EQ("));
        txt = Tpl.writeText(txt, a_ix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;
  end match;
end fun_639;

protected function fun_640
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_ix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_ix)
    local
      Tpl.Text txt;
      Tpl.Text a_ix;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_ix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("SIM_PROF_ACC_EQ("));
        txt = Tpl.writeText(txt, a_ix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;
  end match;
end fun_640;

public function equation_call
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_eq, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      String a_modelNamePrefix;
      SimCode.SimEqSystem i_eq;
      Boolean ret_2;
      Boolean ret_1;
      Tpl.Text l_ix;

    case ( txt,
           SimCode.SES_ALGORITHM(statements = {}),
           _ )
      then txt;

    case ( txt,
           i_eq,
           a_modelNamePrefix )
      equation
        l_ix = fun_638(Tpl.emptyTxt, i_eq);
        ret_1 = Config.profileAll();
        txt = fun_639(txt, ret_1, l_ix);
        txt = Tpl.softNewLine(txt);
        txt = CodegenUtil.symbolName(txt, a_modelNamePrefix, "eqFunction");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeText(txt, l_ix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("(data, threadData);\n"));
        ret_2 = Config.profileAll();
        txt = fun_640(txt, ret_2, l_ix);
      then txt;
  end match;
end equation_call;

protected function fun_642
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_eq)
    local
      Tpl.Text txt;
      SimCode.SimEqSystem i_eq;
      SimCode.SimEqSystem i_e;

    case ( txt,
           (i_e as SimCode.SES_LINEAR(alternativeTearing = SOME(_))) )
      equation
        txt = CodegenUtilSimulation.equationIndexAlternativeTearing(txt, i_e);
      then txt;

    case ( txt,
           (i_e as SimCode.SES_NONLINEAR(alternativeTearing = SOME(_))) )
      equation
        txt = CodegenUtilSimulation.equationIndexAlternativeTearing(txt, i_e);
      then txt;

    case ( txt,
           i_eq )
      equation
        txt = CodegenUtilSimulation.equationIndex(txt, i_eq);
      then txt;
  end match;
end fun_642;

protected function fun_643
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_ix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_ix)
    local
      Tpl.Text txt;
      Tpl.Text a_ix;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_ix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("SIM_PROF_TICK_EQ("));
        txt = Tpl.writeText(txt, a_ix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;
  end match;
end fun_643;

protected function fun_644
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_ix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_ix)
    local
      Tpl.Text txt;
      Tpl.Text a_ix;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_ix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("SIM_PROF_ACC_EQ("));
        txt = Tpl.writeText(txt, a_ix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;
  end match;
end fun_644;

public function equation_callJacobian
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_eq, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      String a_modelNamePrefix;
      SimCode.SimEqSystem i_eq;
      Boolean ret_2;
      Boolean ret_1;
      Tpl.Text l_ix;

    case ( txt,
           SimCode.SES_ALGORITHM(statements = {}),
           _ )
      then txt;

    case ( txt,
           i_eq,
           a_modelNamePrefix )
      equation
        l_ix = fun_642(Tpl.emptyTxt, i_eq);
        ret_1 = Config.profileAll();
        txt = fun_643(txt, ret_1, l_ix);
        txt = Tpl.softNewLine(txt);
        txt = CodegenUtil.symbolName(txt, a_modelNamePrefix, "eqFunction");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeText(txt, l_ix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("(data, threadData, jacobian, parentJacobian);\n"));
        ret_2 = Config.profileAll();
        txt = fun_644(txt, ret_2, l_ix);
      then txt;
  end match;
end equation_callJacobian;

protected function fun_646
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_eq)
    local
      Tpl.Text txt;
      SimCode.SimEqSystem i_eq;
      SimCode.SimEqSystem i_e;

    case ( txt,
           (i_e as SimCode.SES_LINEAR(alternativeTearing = SOME(_))) )
      equation
        txt = CodegenUtilSimulation.equationIndexAlternativeTearing(txt, i_e);
      then txt;

    case ( txt,
           (i_e as SimCode.SES_NONLINEAR(alternativeTearing = SOME(_))) )
      equation
        txt = CodegenUtilSimulation.equationIndexAlternativeTearing(txt, i_e);
      then txt;

    case ( txt,
           i_eq )
      equation
        txt = CodegenUtilSimulation.equationIndex(txt, i_eq);
      then txt;
  end match;
end fun_646;

protected function fun_647
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input String in_a_modelNamePrefixStr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_eq, in_a_modelNamePrefixStr)
    local
      Tpl.Text txt;
      String a_modelNamePrefixStr;
      SimCode.SimEqSystem i_eq;
      Tpl.Text l_ix;

    case ( txt,
           SimCode.SES_ALGORITHM(statements = {}),
           _ )
      then txt;

    case ( txt,
           i_eq,
           a_modelNamePrefixStr )
      equation
        l_ix = fun_646(Tpl.emptyTxt, i_eq);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("extern void "));
        txt = CodegenUtil.symbolName(txt, a_modelNamePrefixStr, "eqFunction");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeText(txt, l_ix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(DATA* data, threadData_t *threadData);"));
      then txt;
  end match;
end fun_647;

public function equationForward_
  input Tpl.Text txt;
  input SimCode.SimEqSystem a_eq;
  input SimCodeFunction.Context a_context;
  input String a_modelNamePrefixStr;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_647(txt, a_eq, a_modelNamePrefixStr);
end equationForward_;

protected function fun_649
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_eq)
    local
      Tpl.Text txt;
      SimCode.SimEqSystem i_eq;
      SimCode.SimEqSystem i_e;

    case ( txt,
           (i_e as SimCode.SES_LINEAR(alternativeTearing = SOME(_))) )
      equation
        txt = CodegenUtilSimulation.equationIndexAlternativeTearing(txt, i_e);
      then txt;

    case ( txt,
           (i_e as SimCode.SES_NONLINEAR(alternativeTearing = SOME(_))) )
      equation
        txt = CodegenUtilSimulation.equationIndexAlternativeTearing(txt, i_e);
      then txt;

    case ( txt,
           i_eq )
      equation
        txt = CodegenUtilSimulation.equationIndex(txt, i_eq);
      then txt;
  end match;
end fun_649;

protected function fun_650
  input Tpl.Text in_txt;
  input SimCodeFunction.Context in_a_context;
  input SimCode.SimEqSystem in_a_eq;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_context, in_a_eq)
    local
      Tpl.Text txt;
      SimCode.SimEqSystem a_eq;

    case ( txt,
           SimCodeFunction.DAE_MODE_CONTEXT(),
           a_eq )
      equation
        txt = simEqAttrEval(txt, a_eq);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_650;

protected function fun_651
  input Tpl.Text in_txt;
  input SimCodeFunction.Context in_a_context;
  input SimCode.SimEqSystem in_a_eq;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_context, in_a_eq)
    local
      Tpl.Text txt;
      SimCode.SimEqSystem a_eq;

    case ( txt,
           SimCodeFunction.DAE_MODE_CONTEXT(),
           a_eq )
      equation
        txt = simEqAttrIsDiscreteKind(txt, a_eq);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_651;

protected function fun_652
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_ix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_ix)
    local
      Tpl.Text txt;
      Tpl.Text a_ix;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_ix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("SIM_PROF_TICK_EQ("));
        txt = Tpl.writeText(txt, a_ix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;
  end match;
end fun_652;

protected function fun_653
  input Tpl.Text in_txt;
  input String in_mArg;
  input Tpl.Text in_a_simEqAttrEval;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_simEqAttrEval)
    local
      Tpl.Text txt;
      Tpl.Text a_simEqAttrEval;

    case ( txt,
           "",
           _ )
      then txt;

    case ( txt,
           _,
           a_simEqAttrEval )
      equation
        txt = Tpl.writeText(txt, a_simEqAttrEval);
      then txt;
  end match;
end fun_653;

protected function fun_654
  input Tpl.Text in_txt;
  input String in_mArg;
  input Tpl.Text in_a_simEqAttrIsDiscreteKind;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_simEqAttrIsDiscreteKind)
    local
      Tpl.Text txt;
      Tpl.Text a_simEqAttrIsDiscreteKind;

    case ( txt,
           "",
           _ )
      then txt;

    case ( txt,
           _,
           a_simEqAttrIsDiscreteKind )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if ((evalStages & currentEvalStage) && !((currentEvalStage!=EVAL_DISCRETE)?("));
        txt = Tpl.writeText(txt, a_simEqAttrIsDiscreteKind);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("):0))"));
      then txt;
  end match;
end fun_654;

protected function fun_655
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_ix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_ix)
    local
      Tpl.Text txt;
      Tpl.Text a_ix;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_ix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("SIM_PROF_ACC_EQ("));
        txt = Tpl.writeText(txt, a_ix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;
  end match;
end fun_655;

public function equationNames_
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input SimCodeFunction.Context in_a_context;
  input String in_a_modelNamePrefixStr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_eq, in_a_context, in_a_modelNamePrefixStr)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      String a_modelNamePrefixStr;
      SimCode.SimEqSystem i_eq;
      Boolean ret_6;
      String str_5;
      String str_4;
      Boolean ret_3;
      Tpl.Text l_simEqAttrIsDiscreteKind;
      Tpl.Text l_simEqAttrEval;
      Tpl.Text l_ix;

    case ( txt,
           SimCode.SES_ALGORITHM(statements = {}),
           _,
           _ )
      then txt;

    case ( txt,
           i_eq,
           a_context,
           a_modelNamePrefixStr )
      equation
        l_ix = fun_649(Tpl.emptyTxt, i_eq);
        l_simEqAttrEval = fun_650(Tpl.emptyTxt, a_context, i_eq);
        l_simEqAttrIsDiscreteKind = fun_651(Tpl.emptyTxt, a_context, i_eq);
        ret_3 = Config.profileAll();
        txt = fun_652(txt, ret_3, l_ix);
        txt = Tpl.softNewLine(txt);
        str_4 = Tpl.textString(l_simEqAttrEval);
        txt = fun_653(txt, str_4, l_simEqAttrEval);
        txt = Tpl.softNewLine(txt);
        str_5 = Tpl.textString(l_simEqAttrEval);
        txt = fun_654(txt, str_5, l_simEqAttrIsDiscreteKind);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = CodegenUtil.symbolName(txt, a_modelNamePrefixStr, "eqFunction");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeText(txt, l_ix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("(data, threadData);\n"));
        txt = Tpl.popBlock(txt);
        ret_6 = Config.profileAll();
        txt = fun_655(txt, ret_6, l_ix);
      then txt;
  end match;
end equationNames_;

protected function fun_657
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input DAE.ComponentRef in_a_cref;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_cref)
    local
      Tpl.Text txt;
      DAE.ComponentRef a_cref;
      DAE.ComponentRef ret_4;
      DAE.ComponentRef ret_3;
      DAE.ComponentRef ret_2;
      DAE.ComponentRef ret_1;
      DAE.ComponentRef ret_0;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_cref )
      equation
        ret_0 = ComponentReference.popCref(a_cref);
        txt = CodegenCFunctions.cref(txt, ret_0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = CodegenCFunctions.cref(txt, a_cref);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "infoStreamPrint(LOG_INIT_V, 0, \"updated start value: %s(start="
                                }, false));
        ret_1 = ComponentReference.popCref(a_cref);
        txt = crefToPrintfArg(txt, ret_1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")\", "));
        ret_2 = ComponentReference.popCref(a_cref);
        txt = CodegenCFunctions.crefVarInfo(txt, ret_2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".name, ("));
        ret_3 = ComponentReference.popCref(a_cref);
        txt = crefType(txt, ret_3);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") "));
        ret_4 = ComponentReference.popCref(a_cref);
        txt = CodegenCFunctions.cref(txt, ret_4);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;
  end match;
end fun_657;

protected function fun_658
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input DAE.ComponentRef in_a_cref;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_cref)
    local
      Tpl.Text txt;
      DAE.ComponentRef a_cref;
      DAE.ComponentRef ret_4;
      DAE.ComponentRef ret_3;
      DAE.ComponentRef ret_2;
      DAE.ComponentRef ret_1;
      DAE.ComponentRef ret_0;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_cref )
      equation
        ret_0 = ComponentReference.popCref(a_cref);
        txt = CodegenCFunctions.cref(txt, ret_0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = CodegenCFunctions.cref(txt, a_cref);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "infoStreamPrint(LOG_INIT_V, 0, \"updated start value: %s(start="
                                }, false));
        ret_1 = ComponentReference.popCref(a_cref);
        txt = crefToPrintfArg(txt, ret_1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")\", "));
        ret_2 = ComponentReference.popCref(a_cref);
        txt = CodegenCFunctions.crefVarInfo(txt, ret_2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".name, ("));
        ret_3 = ComponentReference.popCref(a_cref);
        txt = crefType(txt, ret_3);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") "));
        ret_4 = ComponentReference.popCref(a_cref);
        txt = CodegenCFunctions.cref(txt, ret_4);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;
  end match;
end fun_658;

public function equationSimpleAssign
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_eq, in_a_context, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      SimCode.SimEqSystem i_eq;
      DAE.ComponentRef i_cref;
      DAE.Exp i_exp;
      SourceInfo ret_6;
      Boolean ret_5;
      SourceInfo ret_4;
      Boolean ret_3;
      Tpl.Text l_postExp;
      Tpl.Text l_expPart;
      Tpl.Text l_preExp;

    case ( txt,
           SimCode.SES_SIMPLE_ASSIGN(exp = DAE.CALL(path = Absyn.IDENT(name = "fail"))),
           _,
           a_varDecls,
           a_auxFunction )
      equation
        txt = CodegenCFunctions.generateThrow(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           SimCode.SES_SIMPLE_ASSIGN_CONSTRAINTS(exp = DAE.CALL(path = Absyn.IDENT(name = "fail"))),
           _,
           a_varDecls,
           a_auxFunction )
      equation
        txt = CodegenCFunctions.generateThrow(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           (i_eq as SimCode.SES_SIMPLE_ASSIGN(exp = i_exp, cref = i_cref)),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_expPart, l_preExp, a_varDecls, a_auxFunction) = CodegenCFunctions.daeExp(Tpl.emptyTxt, i_exp, a_context, l_preExp, a_varDecls, a_auxFunction);
        ret_3 = ComponentReference.isStartCref(i_cref);
        l_postExp = fun_657(Tpl.emptyTxt, ret_3, i_cref);
        ret_4 = SimCodeUtil.eqInfo(i_eq);
        txt = CodegenCFunctions.modelicaLine(txt, ret_4);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        (txt, l_preExp, a_varDecls, a_auxFunction) = CodegenCFunctions.contextCref(txt, i_cref, a_context, l_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, l_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_postExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = CodegenCFunctions.endModelicaLine(txt);
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           (i_eq as SimCode.SES_SIMPLE_ASSIGN_CONSTRAINTS(exp = i_exp, cref = i_cref)),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_expPart, l_preExp, a_varDecls, a_auxFunction) = CodegenCFunctions.daeExp(Tpl.emptyTxt, i_exp, a_context, l_preExp, a_varDecls, a_auxFunction);
        ret_5 = ComponentReference.isStartCref(i_cref);
        l_postExp = fun_658(Tpl.emptyTxt, ret_5, i_cref);
        ret_6 = SimCodeUtil.eqInfo(i_eq);
        txt = CodegenCFunctions.modelicaLine(txt, ret_6);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        (txt, l_preExp, a_varDecls, a_auxFunction) = CodegenCFunctions.contextCref(txt, i_cref, a_context, l_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, l_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_postExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = CodegenCFunctions.endModelicaLine(txt);
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_varDecls,
           a_auxFunction )
      then (txt, a_varDecls, a_auxFunction);
  end match;
end equationSimpleAssign;

public function equationForLoop
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_eq, in_a_context, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      SimCode.SimEqSystem i_eq;
      DAE.Exp i_iter;
      DAE.Exp i_endIt;
      DAE.Exp i_startIt;
      DAE.ComponentRef i_cref;
      DAE.Exp i_exp;
      SourceInfo ret_7;
      Tpl.Text l_iterVar;
      Tpl.Text l_stop;
      Tpl.Text l_start;
      DAE.Exp ret_3;
      Tpl.Text l_crefPart;
      Tpl.Text l_expPart;
      Tpl.Text l_preExp;

    case ( txt,
           (i_eq as SimCode.SES_FOR_LOOP(exp = i_exp, cref = i_cref, startIt = i_startIt, endIt = i_endIt, iter = i_iter)),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_expPart, l_preExp, a_varDecls, a_auxFunction) = CodegenCFunctions.daeExp(Tpl.emptyTxt, i_exp, a_context, l_preExp, a_varDecls, a_auxFunction);
        ret_3 = Expression.crefExp(i_cref);
        (l_crefPart, l_preExp, a_varDecls, a_auxFunction) = CodegenCFunctions.daeExp(Tpl.emptyTxt, ret_3, a_context, l_preExp, a_varDecls, a_auxFunction);
        l_start = ExpressionDumpTpl.dumpExp(Tpl.emptyTxt, i_startIt, "\"");
        l_stop = ExpressionDumpTpl.dumpExp(Tpl.emptyTxt, i_endIt, "\"");
        (l_iterVar, l_preExp, a_varDecls, a_auxFunction) = CodegenCFunctions.daeExp(Tpl.emptyTxt, i_iter, a_context, l_preExp, a_varDecls, a_auxFunction);
        ret_7 = SimCodeUtil.eqInfo(i_eq);
        txt = CodegenCFunctions.modelicaLine(txt, ret_7);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_integer  $P"));
        txt = ExpressionDumpTpl.dumpExp(txt, i_iter, "\"");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " = 0; // the iterator\n",
                                    "// the for-equation\n",
                                    "for($P"
                                }, false));
        txt = ExpressionDumpTpl.dumpExp(txt, i_iter, "\"");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, l_start);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("; $P"));
        txt = ExpressionDumpTpl.dumpExp(txt, i_iter, "\"");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" != "));
        txt = Tpl.writeText(txt, l_stop);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("+1; $P"));
        txt = ExpressionDumpTpl.dumpExp(txt, i_iter, "\"");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "++)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_crefPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" += "));
        txt = Tpl.writeText(txt, l_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("}\n"));
        txt = CodegenCFunctions.endModelicaLine(txt);
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_varDecls,
           a_auxFunction )
      then (txt, a_varDecls, a_auxFunction);
  end match;
end equationForLoop;

protected function fun_661
  input Tpl.Text in_txt;
  input String in_mArg;
  input DAE.Exp in_a_eqn_exp;
  input Tpl.Text in_a_lhsstr;
  input Tpl.Text in_a_expPart;
  input Tpl.Text in_a_preExp;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_eqn_exp, in_a_lhsstr, in_a_expPart, in_a_preExp)
    local
      Tpl.Text txt;
      DAE.Exp a_eqn_exp;
      Tpl.Text a_lhsstr;
      Tpl.Text a_expPart;
      Tpl.Text a_preExp;
      Tpl.Text txt_0;

    case ( txt,
           "boolean",
           _,
           a_lhsstr,
           a_expPart,
           a_preExp )
      equation
        txt = Tpl.writeText(txt, a_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("boolean_array_copy_data("));
        txt = Tpl.writeText(txt, a_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_lhsstr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;

    case ( txt,
           "integer",
           _,
           a_lhsstr,
           a_expPart,
           a_preExp )
      equation
        txt = Tpl.writeText(txt, a_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("integer_array_copy_data("));
        txt = Tpl.writeText(txt, a_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_lhsstr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;

    case ( txt,
           "real",
           _,
           a_lhsstr,
           a_expPart,
           a_preExp )
      equation
        txt = Tpl.writeText(txt, a_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("real_array_copy_data("));
        txt = Tpl.writeText(txt, a_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_lhsstr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;

    case ( txt,
           "string",
           _,
           a_lhsstr,
           a_expPart,
           a_preExp )
      equation
        txt = Tpl.writeText(txt, a_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("string_array_copy_data("));
        txt = Tpl.writeText(txt, a_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_lhsstr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;

    case ( txt,
           _,
           a_eqn_exp,
           _,
           _,
           _ )
      equation
        txt_0 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("No runtime support for this sort of array call: "));
        txt_0 = ExpressionDumpTpl.dumpExp(txt_0, a_eqn_exp, "\"");
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 5553, 14), Tpl.textString(txt_0));
      then txt;
  end match;
end fun_661;

protected function fun_662
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_eq, in_a_context, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Exp i_eqn_exp;
      DAE.Exp i_lhs;
      DAE.Exp i_exp;
      String str_4;
      Tpl.Text txt_3;
      Tpl.Text l_lhsstr;
      Tpl.Text l_expPart;
      Tpl.Text l_preExp;

    case ( txt,
           SimCode.SES_ARRAY_CALL_ASSIGN(lhs = (i_lhs as DAE.CREF(componentRef = _)), exp = (i_eqn_exp as i_exp)),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_expPart, l_preExp, a_varDecls, a_auxFunction) = CodegenCFunctions.daeExp(Tpl.emptyTxt, i_exp, a_context, l_preExp, a_varDecls, a_auxFunction);
        (l_lhsstr, l_preExp, a_varDecls, a_auxFunction) = CodegenCFunctions.daeExpCrefLhs(Tpl.emptyTxt, i_lhs, a_context, l_preExp, a_varDecls, a_auxFunction, false);
        txt_3 = CodegenCFunctions.expTypeFromExpShort(Tpl.emptyTxt, i_eqn_exp);
        str_4 = Tpl.textString(txt_3);
        txt = fun_661(txt, str_4, i_eqn_exp, l_lhsstr, l_expPart, l_preExp);
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_varDecls,
           a_auxFunction )
      then (txt, a_varDecls, a_auxFunction);
  end match;
end fun_662;

public function equationArrayCallAssign
  input Tpl.Text txt;
  input SimCode.SimEqSystem a_eq;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
protected
  SourceInfo ret_0;
algorithm
  ret_0 := SimCodeUtil.eqInfo(a_eq);
  out_txt := CodegenCFunctions.modelicaLine(txt, ret_0);
  out_txt := Tpl.softNewLine(out_txt);
  (out_txt, out_a_varDecls, out_a_auxFunction) := fun_662(out_txt, a_eq, a_context, a_varDecls, a_auxFunction);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := CodegenCFunctions.endModelicaLine(out_txt);
end equationArrayCallAssign;

protected function lm_664
  input Tpl.Text in_txt;
  input list<DAE.Statement> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Statement> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      SimCodeFunction.Context a_context;
      DAE.Statement i_stmt;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           _ )
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           i_stmt :: rest,
           a_auxFunction,
           a_varDecls,
           a_context )
      equation
        (txt, a_varDecls, a_auxFunction) = CodegenCFunctions.algStatement(txt, i_stmt, a_context, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls) = lm_664(txt, rest, a_auxFunction, a_varDecls, a_context);
      then (txt, a_auxFunction, a_varDecls);
  end match;
end lm_664;

protected function lm_665
  input Tpl.Text in_txt;
  input list<DAE.Statement> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Statement> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      SimCodeFunction.Context a_context;
      DAE.Statement i_stmt;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           _ )
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           i_stmt :: rest,
           a_auxFunction,
           a_varDecls,
           a_context )
      equation
        (txt, a_varDecls, a_auxFunction) = CodegenCFunctions.algStatement(txt, i_stmt, a_context, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls) = lm_665(txt, rest, a_auxFunction, a_varDecls, a_context);
      then (txt, a_auxFunction, a_varDecls);
  end match;
end lm_665;

protected function lm_666
  input Tpl.Text in_txt;
  input list<DAE.ComponentRef> in_items;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_varDecls) :=
  match(in_txt, in_items, in_a_varDecls)
    local
      Tpl.Text txt;
      list<DAE.ComponentRef> rest;
      Tpl.Text a_varDecls;
      Integer x_i0;
      DAE.ComponentRef i_cr;

    case ( txt,
           {},
           a_varDecls )
      then (txt, a_varDecls);

    case ( txt,
           i_cr :: rest,
           a_varDecls )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        a_varDecls = crefType(a_varDecls, i_cr);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(" OLD_"));
        a_varDecls = Tpl.writeStr(a_varDecls, intString(x_i0));
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(";"));
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_NEW_LINE());
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("OLD_"));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = CodegenCFunctions.cref(txt, i_cr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        (txt, a_varDecls) = lm_666(txt, rest, a_varDecls);
      then (txt, a_varDecls);
  end match;
end lm_666;

protected function lm_667
  input Tpl.Text in_txt;
  input list<DAE.Statement> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Statement> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      SimCodeFunction.Context a_context;
      DAE.Statement i_stmt;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           _ )
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           i_stmt :: rest,
           a_auxFunction,
           a_varDecls,
           a_context )
      equation
        (txt, a_varDecls, a_auxFunction) = CodegenCFunctions.algStatement(txt, i_stmt, a_context, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls) = lm_667(txt, rest, a_auxFunction, a_varDecls, a_context);
      then (txt, a_auxFunction, a_varDecls);
  end match;
end lm_667;

protected function lm_668
  input Tpl.Text in_txt;
  input list<DAE.ComponentRef> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<DAE.ComponentRef> rest;
      Integer x_i0;
      DAE.ComponentRef i_cr;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_cr :: rest )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = CodegenCFunctions.cref(txt, i_cr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = OLD_"));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        txt = lm_668(txt, rest);
      then txt;
  end match;
end lm_668;

public function equationAlgorithm
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_eq, in_a_context, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      list<DAE.ComponentRef> i_alg_knownOutputCrefs;
      list<DAE.Statement> i_statements;
      Tpl.Text l_restoreKnownVars;
      Tpl.Text l_stmts;
      Tpl.Text l_backupKnown;

    case ( txt,
           SimCode.SES_INVERSE_ALGORITHM(insideNonLinearSystem = true, statements = i_statements),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_auxFunction, a_varDecls) = lm_664(txt, i_statements, a_auxFunction, a_varDecls, a_context);
        txt = Tpl.popIter(txt);
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           SimCode.SES_ALGORITHM(statements = i_statements),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_auxFunction, a_varDecls) = lm_665(txt, i_statements, a_auxFunction, a_varDecls, a_context);
        txt = Tpl.popIter(txt);
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           SimCode.SES_INVERSE_ALGORITHM(knownOutputCrefs = i_alg_knownOutputCrefs, statements = i_statements),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        l_backupKnown = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_backupKnown, a_varDecls) = lm_666(l_backupKnown, i_alg_knownOutputCrefs, a_varDecls);
        l_backupKnown = Tpl.popIter(l_backupKnown);
        l_stmts = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_stmts, a_auxFunction, a_varDecls) = lm_667(l_stmts, i_statements, a_auxFunction, a_varDecls, a_context);
        l_stmts = Tpl.popIter(l_stmts);
        l_restoreKnownVars = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_restoreKnownVars = lm_668(l_restoreKnownVars, i_alg_knownOutputCrefs);
        l_restoreKnownVars = Tpl.popIter(l_restoreKnownVars);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/* backup outputs of the algorithm */\n"));
        txt = Tpl.writeText(txt, l_backupKnown);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/* algrithm it self */\n"));
        txt = Tpl.writeText(txt, l_stmts);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/* restore outputs of the algorithm */\n"));
        txt = Tpl.writeText(txt, l_restoreKnownVars);
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_varDecls,
           a_auxFunction )
      then (txt, a_varDecls, a_auxFunction);
  end match;
end equationAlgorithm;

protected function fun_670
  input Tpl.Text in_txt;
  input Option<SimCode.LinearSystem> in_a_at;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_at)
    local
      Tpl.Text txt;

    case ( txt,
           SOME(_) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("return 1;"));
      then txt;

    case ( txt,
           NONE() )
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_670;

protected function fun_671
  input Tpl.Text in_txt;
  input Option<SimCode.LinearSystem> in_a_at;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_at)
    local
      Tpl.Text txt;

    case ( txt,
           SOME(_) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("return 0;"));
      then txt;

    case ( txt,
           NONE() )
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_671;

protected function lm_672
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Tpl.Text in_a_auxFunctions;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunctions;
algorithm
  (out_txt, out_a_auxFunctions) :=
  match(in_txt, in_items, in_a_auxFunctions, in_a_context)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Tpl.Text a_auxFunctions;
      SimCodeFunction.Context a_context;
      DAE.ComponentRef i_name;

    case ( txt,
           {},
           a_auxFunctions,
           _ )
      then (txt, a_auxFunctions);

    case ( txt,
           SimCodeVar.SIMVAR(name = i_name) :: rest,
           a_auxFunctions,
           a_context )
      equation
        (txt, a_auxFunctions) = CodegenCFunctions.contextCrefOld(txt, i_name, a_context, a_auxFunctions, 1);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunctions) = lm_672(txt, rest, a_auxFunctions, a_context);
      then (txt, a_auxFunctions);

    case ( txt,
           _ :: rest,
           a_auxFunctions,
           a_context )
      equation
        (txt, a_auxFunctions) = lm_672(txt, rest, a_auxFunctions, a_context);
      then (txt, a_auxFunctions);
  end match;
end lm_672;

protected function fun_673
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_ls_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_ls_index)
    local
      Tpl.Text txt;
      Integer a_ls_index;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_ls_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("SIM_PROF_TICK_EQ(modelInfoGetEquation(&data->modelData->modelDataXml,"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(").profileBlockIndex);"));
      then txt;
  end match;
end fun_673;

protected function fun_674
  input Tpl.Text in_txt;
  input Boolean in_a_ls_partOfJac;
  input Integer in_a_ls_indexLinearSystem;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ls_partOfJac, in_a_ls_indexLinearSystem)
    local
      Tpl.Text txt;
      Integer a_ls_indexLinearSystem;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_ls_indexLinearSystem )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("data->simulationInfo->linearSystemData["));
        txt = Tpl.writeStr(txt, intString(a_ls_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].parDynamicData[omc_get_thread_num()].parentJacobian = jacobian;"));
      then txt;
  end match;
end fun_674;

protected function lm_675
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Tpl.Text in_a_auxFunctions;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunctions;
algorithm
  (out_txt, out_a_auxFunctions) :=
  match(in_txt, in_items, in_a_auxFunctions, in_a_context)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Tpl.Text a_auxFunctions;
      SimCodeFunction.Context a_context;
      Integer x_i0;
      DAE.ComponentRef i_name;

    case ( txt,
           {},
           a_auxFunctions,
           _ )
      then (txt, a_auxFunctions);

    case ( txt,
           SimCodeVar.SIMVAR(name = i_name) :: rest,
           a_auxFunctions,
           a_context )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        (txt, a_auxFunctions) = CodegenCFunctions.contextCrefNoPrevExp(txt, i_name, a_context, a_auxFunctions);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = aux_x["));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("];"));
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunctions) = lm_675(txt, rest, a_auxFunctions, a_context);
      then (txt, a_auxFunctions);

    case ( txt,
           _ :: rest,
           a_auxFunctions,
           a_context )
      equation
        (txt, a_auxFunctions) = lm_675(txt, rest, a_auxFunctions, a_context);
      then (txt, a_auxFunctions);
  end match;
end lm_675;

protected function fun_676
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_ls_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_ls_index)
    local
      Tpl.Text txt;
      Integer a_ls_index;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_ls_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("SIM_PROF_ACC_EQ(modelInfoGetEquation(&data->modelData->modelDataXml,"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(").profileBlockIndex);"));
      then txt;
  end match;
end fun_676;

protected function fun_677
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_eq, in_a_context)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Integer i_ls_indexLinearSystem;
      Boolean i_ls_partOfJac;
      Integer i_ls_index;
      list<SimCodeVar.SimVar> i_ls_vars;
      Option<SimCode.LinearSystem> i_at;
      Boolean ret_5;
      Boolean ret_4;
      Integer ret_3;
      Tpl.Text l_auxFunctions;
      Tpl.Text l_returnval2;
      Tpl.Text l_returnval;

    case ( txt,
           SimCode.SES_LINEAR(lSystem = SimCode.LINEARSYSTEM(vars = i_ls_vars, index = i_ls_index, partOfJac = i_ls_partOfJac, indexLinearSystem = i_ls_indexLinearSystem), alternativeTearing = i_at),
           a_context )
      equation
        l_returnval = fun_670(Tpl.emptyTxt, i_at);
        l_returnval2 = fun_671(Tpl.emptyTxt, i_at);
        l_auxFunctions = Tpl.emptyTxt;
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "/* Linear equation system */\n",
                                    "int retValue;\n",
                                    "double aux_x["
                                }, false));
        ret_3 = listLength(i_ls_vars);
        txt = Tpl.writeStr(txt, intString(ret_3));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = { "));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, l_auxFunctions) = lm_672(txt, i_ls_vars, l_auxFunctions, a_context);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " };\n",
                                    "if(ACTIVE_STREAM(LOG_DT))\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("infoStreamPrint(LOG_DT, 1, \"Solving linear system "));
        txt = Tpl.writeStr(txt, intString(i_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " (STRICT TEARING SET if tearing enabled) at time = %18.10e\", data->localData[0]->timeValue);\n",
                                    "messageClose(LOG_DT);\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("}\n"));
        ret_4 = Config.profileSome();
        txt = fun_673(txt, ret_4, i_ls_index);
        txt = Tpl.softNewLine(txt);
        txt = fun_674(txt, i_ls_partOfJac, i_ls_indexLinearSystem);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "retValue = solve_linear_system(data, threadData, "
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_ls_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ", &aux_x[0]);\n",
                                    "\n",
                                    "/* check if solution process was successful */\n",
                                    "if (retValue > 0){\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("const int indexes[2] = {1,"));
        txt = Tpl.writeStr(txt, intString(i_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "};\n",
                                    "throwStreamPrintWithEquationIndexes(threadData, indexes, \"Solving linear system "
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" failed at time=%.15g.\\nFor more information please use -lv LOG_LS.\", data->localData[0]->timeValue);\n"));
        txt = Tpl.writeText(txt, l_returnval2);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "/* write solution */\n"
                                }, true));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, l_auxFunctions) = lm_675(txt, i_ls_vars, l_auxFunctions, a_context);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        ret_5 = Config.profileSome();
        txt = fun_676(txt, ret_5, i_ls_index);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_returnval);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_677;

public function equationLinear
  input Tpl.Text txt;
  input SimCode.SimEqSystem a_eq;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
algorithm
  out_txt := fun_677(txt, a_eq, a_context);
  out_a_varDecls := a_varDecls;
end equationLinear;

protected function fun_679
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_at_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_at_index)
    local
      Tpl.Text txt;
      Integer a_at_index;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_at_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("SIM_PROF_TICK_EQ(modelInfoGetEquation(&data->modelData->modelDataXml,"));
        txt = Tpl.writeStr(txt, intString(a_at_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(").profileBlockIndex);"));
      then txt;
  end match;
end fun_679;

protected function lm_680
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Tpl.Text in_a_auxFunctions;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunctions;
algorithm
  (out_txt, out_a_auxFunctions) :=
  match(in_txt, in_items, in_a_auxFunctions, in_a_context)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Tpl.Text a_auxFunctions;
      SimCodeFunction.Context a_context;
      DAE.ComponentRef i_name;

    case ( txt,
           {},
           a_auxFunctions,
           _ )
      then (txt, a_auxFunctions);

    case ( txt,
           SimCodeVar.SIMVAR(name = i_name) :: rest,
           a_auxFunctions,
           a_context )
      equation
        (txt, a_auxFunctions) = CodegenCFunctions.contextCrefNoPrevExp(txt, i_name, a_context, a_auxFunctions);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunctions) = lm_680(txt, rest, a_auxFunctions, a_context);
      then (txt, a_auxFunctions);

    case ( txt,
           _ :: rest,
           a_auxFunctions,
           a_context )
      equation
        (txt, a_auxFunctions) = lm_680(txt, rest, a_auxFunctions, a_context);
      then (txt, a_auxFunctions);
  end match;
end lm_680;

protected function lm_681
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Tpl.Text in_a_auxFunctions;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunctions;
algorithm
  (out_txt, out_a_auxFunctions) :=
  match(in_txt, in_items, in_a_auxFunctions, in_a_context)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Tpl.Text a_auxFunctions;
      SimCodeFunction.Context a_context;
      Integer x_i0;
      DAE.ComponentRef i_name;

    case ( txt,
           {},
           a_auxFunctions,
           _ )
      then (txt, a_auxFunctions);

    case ( txt,
           SimCodeVar.SIMVAR(name = i_name) :: rest,
           a_auxFunctions,
           a_context )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        (txt, a_auxFunctions) = CodegenCFunctions.contextCrefNoPrevExp(txt, i_name, a_context, a_auxFunctions);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = aux_x["));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("];"));
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunctions) = lm_681(txt, rest, a_auxFunctions, a_context);
      then (txt, a_auxFunctions);

    case ( txt,
           _ :: rest,
           a_auxFunctions,
           a_context )
      equation
        (txt, a_auxFunctions) = lm_681(txt, rest, a_auxFunctions, a_context);
      then (txt, a_auxFunctions);
  end match;
end lm_681;

protected function fun_682
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_at_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_at_index)
    local
      Tpl.Text txt;
      Integer a_at_index;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_at_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("SIM_PROF_ACC_EQ(modelInfoGetEquation(&data->modelData->modelDataXml,"));
        txt = Tpl.writeStr(txt, intString(a_at_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(").profileBlockIndex);"));
      then txt;
  end match;
end fun_682;

protected function fun_683
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_eq, in_a_context)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      list<SimCodeVar.SimVar> i_at_vars;
      Integer i_at_indexLinearSystem;
      Integer i_ls_index;
      Integer i_at_index;
      Boolean ret_3;
      Integer ret_2;
      Boolean ret_1;
      Tpl.Text l_auxFunctions;

    case ( txt,
           SimCode.SES_LINEAR(lSystem = SimCode.LINEARSYSTEM(index = i_ls_index), alternativeTearing = SOME(SimCode.LINEARSYSTEM(index = i_at_index, indexLinearSystem = i_at_indexLinearSystem, vars = i_at_vars))),
           a_context )
      equation
        l_auxFunctions = Tpl.emptyTxt;
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "/* Linear equation system */\n",
                                    "int retValue;\n",
                                    "\n",
                                    "if(ACTIVE_STREAM(LOG_DT))\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("infoStreamPrint(LOG_DT, 1, \"Solving linear system "));
        txt = Tpl.writeStr(txt, intString(i_at_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" (CASUAL TEARING SET, strict: "));
        txt = Tpl.writeStr(txt, intString(i_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ") at time = %18.10e\", data->localData[0]->timeValue);\n",
                                    "messageClose(LOG_DT);\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("}\n"));
        ret_1 = Config.profileSome();
        txt = fun_679(txt, ret_1, i_at_index);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if (data->simulationInfo->linearSystemData["));
        txt = Tpl.writeStr(txt, intString(i_at_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "].checkConstraints(data, threadData) == 1)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("double aux_x["));
        ret_2 = listLength(i_at_vars);
        txt = Tpl.writeStr(txt, intString(ret_2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = { "));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, l_auxFunctions) = lm_680(txt, i_at_vars, l_auxFunctions, a_context);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " };\n",
                                    "retValue = solve_linear_system(data, threadData, "
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_at_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ", &aux_x[0]);\n",
                                    "/* The casual tearing set found a solution */\n",
                                    "if (retValue == 0){\n",
                                    "  /* write solution */\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, l_auxFunctions) = lm_681(txt, i_at_vars, l_auxFunctions, a_context);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        ret_3 = Config.profileSome();
        txt = fun_682(txt, ret_3, i_at_index);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("}\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "else\n",
                                    "{\n",
                                    "  if(ACTIVE_STREAM(LOG_DT))\n",
                                    "  {\n",
                                    "    infoStreamPrint(LOG_DT, 1, \"Constraints of the casual tearing set are violated! Now the strict tearing set is used.\");\n",
                                    "    messageClose(LOG_DT);\n",
                                    "  }\n",
                                    "  /* Global constraints are violated. Use the strict tearing set now. */\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("data->simulationInfo->linearSystemData["));
        txt = Tpl.writeStr(txt, intString(i_at_indexLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("].strictTearingFunctionCall(data, threadData);\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_683;

public function equationLinearAlternativeTearing
  input Tpl.Text txt;
  input SimCode.SimEqSystem a_eq;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
algorithm
  out_txt := fun_683(txt, a_eq, a_context);
  out_a_varDecls := a_varDecls;
end equationLinearAlternativeTearing;

protected function fun_685
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_index)
    local
      Tpl.Text txt;
      Integer a_index;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("SIM_PROF_TICK_EQ(modelInfoGetEquation(&data->modelData->modelDataXml,"));
        txt = Tpl.writeStr(txt, intString(a_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(").profileBlockIndex);"));
      then txt;
  end match;
end fun_685;

protected function lm_686
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Integer in_a_eqn_indexMixedSystem;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_eqn_indexMixedSystem)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Integer a_eqn_indexMixedSystem;
      Integer x_i0;
      DAE.ComponentRef i_name;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(name = i_name) :: rest,
           a_eqn_indexMixedSystem )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("data->simulationInfo->mixedSystemData["));
        txt = Tpl.writeStr(txt, intString(a_eqn_indexMixedSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].iterationVarsPtr["));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = (modelica_boolean*)&"));
        txt = CodegenCFunctions.cref(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        txt = lm_686(txt, rest, a_eqn_indexMixedSystem);
      then txt;

    case ( txt,
           _ :: rest,
           a_eqn_indexMixedSystem )
      equation
        txt = lm_686(txt, rest, a_eqn_indexMixedSystem);
      then txt;
  end match;
end lm_686;

protected function lm_687
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Integer in_a_eqn_indexMixedSystem;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_eqn_indexMixedSystem)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Integer a_eqn_indexMixedSystem;
      Integer x_i0;
      DAE.ComponentRef i_name;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(name = i_name) :: rest,
           a_eqn_indexMixedSystem )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("data->simulationInfo->mixedSystemData["));
        txt = Tpl.writeStr(txt, intString(a_eqn_indexMixedSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].iterationPreVarsPtr["));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = (modelica_boolean*)&"));
        txt = CodegenCFunctions.crefPre(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        txt = lm_687(txt, rest, a_eqn_indexMixedSystem);
      then txt;

    case ( txt,
           _ :: rest,
           a_eqn_indexMixedSystem )
      equation
        txt = lm_687(txt, rest, a_eqn_indexMixedSystem);
      then txt;
  end match;
end lm_687;

protected function fun_688
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_index)
    local
      Tpl.Text txt;
      Integer a_index;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("SIM_PROF_ACC_EQ(modelInfoGetEquation(&data->modelData->modelDataXml,"));
        txt = Tpl.writeStr(txt, intString(a_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(").profileBlockIndex);"));
      then txt;
  end match;
end fun_688;

public function equationMixed
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_tmp;
  input String in_a_modelNamePrefixStr;
  input Boolean in_a_init;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_tmp;
algorithm
  (out_txt, out_a_tmp) :=
  match(in_txt, in_a_eq, in_a_context, in_a_tmp, in_a_modelNamePrefixStr, in_a_init)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_tmp;
      String a_modelNamePrefixStr;
      Boolean a_init;
      Integer i_indexMixedSystem;
      Integer i_eqn_indexMixedSystem;
      Integer i_index;
      list<SimCodeVar.SimVar> i_discVars;
      SimCode.SimEqSystem i_cont;
      Boolean ret_3;
      Boolean ret_2;
      Integer ret_1;
      Tpl.Text l_numDiscVarsStr;

    case ( txt,
           SimCode.SES_MIXED(cont = i_cont, discVars = i_discVars, index = i_index, indexMixedSystem = (i_indexMixedSystem as i_eqn_indexMixedSystem)),
           a_context,
           a_tmp,
           a_modelNamePrefixStr,
           a_init )
      equation
        a_tmp = equation_impl(a_tmp, -1, i_cont, a_context, a_modelNamePrefixStr, a_init);
        ret_1 = listLength(i_discVars);
        l_numDiscVarsStr = Tpl.writeStr(Tpl.emptyTxt, intString(ret_1));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/* Continuous equation part */\n"));
        ret_2 = Config.profileSome();
        txt = fun_685(txt, ret_2, i_index);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_686(txt, i_discVars, i_eqn_indexMixedSystem);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_687(txt, i_discVars, i_eqn_indexMixedSystem);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "solve_mixed_system(data, "
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_indexMixedSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(");\n"));
        ret_3 = Config.profileSome();
        txt = fun_688(txt, ret_3, i_index);
      then (txt, a_tmp);

    case ( txt,
           _,
           _,
           a_tmp,
           _,
           _ )
      then (txt, a_tmp);
  end match;
end equationMixed;

protected function lm_690
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input String in_a_modelNamePrefix;
  input Tpl.Text in_a_tmp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_tmp;
algorithm
  (out_txt, out_a_tmp) :=
  match(in_txt, in_items, in_a_modelNamePrefix, in_a_tmp)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      String a_modelNamePrefix;
      Tpl.Text a_tmp;
      SimCode.SimEqSystem i_eq2;

    case ( txt,
           {},
           _,
           a_tmp )
      then (txt, a_tmp);

    case ( txt,
           i_eq2 :: rest,
           a_modelNamePrefix,
           a_tmp )
      equation
        (txt, a_tmp) = functionExtraResidualsPreBody(txt, i_eq2, a_tmp, a_modelNamePrefix);
        txt = Tpl.nextIter(txt);
        (txt, a_tmp) = lm_690(txt, rest, a_modelNamePrefix, a_tmp);
      then (txt, a_tmp);
  end match;
end lm_690;

protected function fun_691
  input Tpl.Text in_txt;
  input Option<SimCode.NonlinearSystem> in_a_at;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_at)
    local
      Tpl.Text txt;

    case ( txt,
           SOME(_) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("return 1;"));
      then txt;

    case ( txt,
           NONE() )
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_691;

protected function fun_692
  input Tpl.Text in_txt;
  input Option<SimCode.NonlinearSystem> in_a_at;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_at)
    local
      Tpl.Text txt;

    case ( txt,
           SOME(_) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("return 0;"));
      then txt;

    case ( txt,
           NONE() )
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_692;

protected function fun_693
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_nls_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_nls_index)
    local
      Tpl.Text txt;
      Integer a_nls_index;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_nls_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("SIM_PROF_TICK_EQ(modelInfoGetEquation(&data->modelData->modelDataXml,"));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ").profileBlockIndex);\n",
                                    "SIM_PROF_ADD_NCALL_EQ(modelInfoGetEquation(&data->modelData->modelDataXml,"
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(").profileBlockIndex,-1);"));
      then txt;
  end match;
end fun_693;

protected function fun_694
  input Tpl.Text in_txt;
  input Boolean in_a_init;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;
  input DAE.ComponentRef in_a_name;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_a_init, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context, in_a_name)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.ComponentRef a_name;

    case ( txt,
           false,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _,
           a_name )
      equation
        txt = CodegenCFunctions.cref(txt, a_name);
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           _,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context,
           a_name )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = CodegenCFunctions.crefOrStartCref(txt, a_name, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end fun_694;

protected function fun_695
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_preExp;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_preExp)
    local
      Tpl.Text txt;
      Tpl.Text a_preExp;

    case ( txt,
           false,
           a_preExp )
      equation
        txt = Tpl.writeText(txt, a_preExp);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_695;

protected function fun_696
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_varDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_varDecls;

    case ( txt,
           false,
           a_varDecls )
      equation
        txt = Tpl.writeText(txt, a_varDecls);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_696;

protected function fun_697
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_auxFunction)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;

    case ( txt,
           false,
           a_auxFunction )
      equation
        txt = Tpl.writeText(txt, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_697;

protected function lm_698
  input Tpl.Text in_txt;
  input list<DAE.ComponentRef> in_items;
  input Integer in_a_nls_indexNonLinearSystem;
  input SimCodeFunction.Context in_a_context;
  input Boolean in_a_init;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_nls_indexNonLinearSystem, in_a_context, in_a_init)
    local
      Tpl.Text txt;
      list<DAE.ComponentRef> rest;
      Integer a_nls_indexNonLinearSystem;
      SimCodeFunction.Context a_context;
      Boolean a_init;
      Integer x_i0;
      DAE.ComponentRef i_name;
      Boolean ret_9;
      Tpl.Text l_AUX;
      Boolean ret_7;
      Tpl.Text l_DECL;
      Boolean ret_5;
      Tpl.Text l_PREV;
      Tpl.Text l_START;
      Tpl.Text l_auxFunction;
      Tpl.Text l_varDecls;
      Tpl.Text l_preExp;

    case ( txt,
           {},
           _,
           _,
           _ )
      then txt;

    case ( txt,
           i_name :: rest,
           a_nls_indexNonLinearSystem,
           a_context,
           a_init )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        l_preExp = Tpl.emptyTxt;
        l_varDecls = Tpl.emptyTxt;
        l_auxFunction = Tpl.emptyTxt;
        (l_START, l_auxFunction, l_varDecls, l_preExp) = fun_694(Tpl.emptyTxt, a_init, l_auxFunction, l_varDecls, l_preExp, a_context, i_name);
        ret_5 = stringEq(Tpl.textString(l_preExp), "");
        l_PREV = fun_695(Tpl.emptyTxt, ret_5, l_preExp);
        ret_7 = stringEq(Tpl.textString(l_varDecls), "");
        l_DECL = fun_696(Tpl.emptyTxt, ret_7, l_varDecls);
        ret_9 = stringEq(Tpl.textString(l_auxFunction), "");
        l_AUX = fun_697(Tpl.emptyTxt, ret_9, l_auxFunction);
        txt = Tpl.writeText(txt, l_DECL);
        txt = Tpl.writeText(txt, l_PREV);
        txt = Tpl.writeText(txt, l_AUX);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("data->simulationInfo->nonlinearSystemData["));
        txt = Tpl.writeStr(txt, intString(a_nls_indexNonLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].nlsxOld["));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = "));
        txt = Tpl.writeText(txt, l_START);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        txt = lm_698(txt, rest, a_nls_indexNonLinearSystem, a_context, a_init);
      then txt;
  end match;
end lm_698;

protected function lm_699
  input Tpl.Text in_txt;
  input list<DAE.ComponentRef> in_items;
  input Integer in_a_nls_indexNonLinearSystem;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_nls_indexNonLinearSystem)
    local
      Tpl.Text txt;
      list<DAE.ComponentRef> rest;
      Integer a_nls_indexNonLinearSystem;
      Integer x_i0;
      DAE.ComponentRef i_name;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_name :: rest,
           a_nls_indexNonLinearSystem )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = CodegenCFunctions.cref(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = data->simulationInfo->nonlinearSystemData["));
        txt = Tpl.writeStr(txt, intString(a_nls_indexNonLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].nlsx["));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("];"));
        txt = Tpl.nextIter(txt);
        txt = lm_699(txt, rest, a_nls_indexNonLinearSystem);
      then txt;
  end match;
end lm_699;

protected function fun_700
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_nls_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_nls_index)
    local
      Tpl.Text txt;
      Integer a_nls_index;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_nls_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("SIM_PROF_ACC_EQ(modelInfoGetEquation(&data->modelData->modelDataXml,"));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(").profileBlockIndex);"));
      then txt;
  end match;
end fun_700;

public function equationNonlinear
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input SimCodeFunction.Context in_a_context;
  input String in_a_modelNamePrefix;
  input Boolean in_a_init;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_eq, in_a_context, in_a_modelNamePrefix, in_a_init)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      String a_modelNamePrefix;
      Boolean a_init;
      Integer i_nls_index;
      Option<SimCode.NonlinearSystem> i_at;
      Integer i_nls_indexNonLinearSystem;
      list<SimCode.SimEqSystem> i_nls_eqs;
      list<DAE.ComponentRef> i_nls_crefs;
      Boolean ret_8;
      Boolean ret_7;
      Tpl.Text l_returnval2;
      Tpl.Text l_returnval;
      Tpl.Text l_nonlinindx;
      Tpl.Text l_innerBody;
      Tpl.Text l_tmp;
      Integer ret_1;
      Tpl.Text l_size;

    case ( txt,
           SimCode.SES_NONLINEAR(nlSystem = SimCode.NONLINEARSYSTEM(crefs = i_nls_crefs, eqs = i_nls_eqs, indexNonLinearSystem = i_nls_indexNonLinearSystem, index = i_nls_index), alternativeTearing = i_at),
           a_context,
           a_modelNamePrefix,
           a_init )
      equation
        ret_1 = listLength(i_nls_crefs);
        l_size = Tpl.writeStr(Tpl.emptyTxt, intString(ret_1));
        l_tmp = Tpl.emptyTxt;
        l_innerBody = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_innerBody, l_tmp) = lm_690(l_innerBody, i_nls_eqs, a_modelNamePrefix, l_tmp);
        l_innerBody = Tpl.popIter(l_innerBody);
        l_nonlinindx = Tpl.writeStr(Tpl.emptyTxt, intString(i_nls_indexNonLinearSystem));
        l_returnval = fun_691(Tpl.emptyTxt, i_at);
        l_returnval2 = fun_692(Tpl.emptyTxt, i_at);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "int retValue;\n",
                                    "if(ACTIVE_STREAM(LOG_DT))\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("infoStreamPrint(LOG_DT, 1, \"Solving nonlinear system "));
        txt = Tpl.writeStr(txt, intString(i_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " (STRICT TEARING SET if tearing enabled) at time = %18.10e\", data->localData[0]->timeValue);\n",
                                    "messageClose(LOG_DT);\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("}\n"));
        ret_7 = Config.profileSome();
        txt = fun_693(txt, ret_7, i_nls_index);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/* get old value */\n"));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_698(txt, i_nls_crefs, i_nls_indexNonLinearSystem, a_context, a_init);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("retValue = solve_nonlinear_system(data, threadData, "));
        txt = Tpl.writeStr(txt, intString(i_nls_indexNonLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ");\n",
                                    "/* check if solution process was successful */\n",
                                    "if (retValue > 0){\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("const int indexes[2] = {1,"));
        txt = Tpl.writeStr(txt, intString(i_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "};\n",
                                    "throwStreamPrintWithEquationIndexes(threadData, indexes, \"Solving non-linear system "
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" failed at time=%.15g.\\nFor more information please use -lv LOG_NLS.\", data->localData[0]->timeValue);\n"));
        txt = Tpl.writeText(txt, l_returnval2);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "/* write solution */\n"
                                }, true));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_699(txt, i_nls_crefs, i_nls_indexNonLinearSystem);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        ret_8 = Config.profileSome();
        txt = fun_700(txt, ret_8, i_nls_index);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_returnval);
      then txt;

    case ( txt,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end equationNonlinear;

protected function lm_702
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input String in_a_modelNamePrefix;
  input Tpl.Text in_a_tmp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_tmp;
algorithm
  (out_txt, out_a_tmp) :=
  match(in_txt, in_items, in_a_modelNamePrefix, in_a_tmp)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      String a_modelNamePrefix;
      Tpl.Text a_tmp;
      SimCode.SimEqSystem i_eq2;

    case ( txt,
           {},
           _,
           a_tmp )
      then (txt, a_tmp);

    case ( txt,
           i_eq2 :: rest,
           a_modelNamePrefix,
           a_tmp )
      equation
        (txt, a_tmp) = functionExtraResidualsPreBody(txt, i_eq2, a_tmp, a_modelNamePrefix);
        txt = Tpl.nextIter(txt);
        (txt, a_tmp) = lm_702(txt, rest, a_modelNamePrefix, a_tmp);
      then (txt, a_tmp);
  end match;
end lm_702;

protected function fun_703
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_at_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_at_index)
    local
      Tpl.Text txt;
      Integer a_at_index;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_at_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("SIM_PROF_TICK_EQ(modelInfoGetEquation(&data->modelData->modelDataXml,"));
        txt = Tpl.writeStr(txt, intString(a_at_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ").profileBlockIndex);\n",
                                    "SIM_PROF_ADD_NCALL_EQ(modelInfoGetEquation(&data->modelData->modelDataXml,"
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_at_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(").profileBlockIndex,-1);"));
      then txt;
  end match;
end fun_703;

protected function fun_704
  input Tpl.Text in_txt;
  input Boolean in_a_init;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;
  input DAE.ComponentRef in_a_name;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_a_init, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context, in_a_name)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.ComponentRef a_name;

    case ( txt,
           false,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _,
           a_name )
      equation
        txt = CodegenCFunctions.cref(txt, a_name);
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           _,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context,
           a_name )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = CodegenCFunctions.crefOrStartCref(txt, a_name, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end fun_704;

protected function fun_705
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_preExp;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_preExp)
    local
      Tpl.Text txt;
      Tpl.Text a_preExp;

    case ( txt,
           false,
           a_preExp )
      equation
        txt = Tpl.writeText(txt, a_preExp);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_705;

protected function fun_706
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_varDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_varDecls;

    case ( txt,
           false,
           a_varDecls )
      equation
        txt = Tpl.writeText(txt, a_varDecls);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_706;

protected function fun_707
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_auxFunction)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;

    case ( txt,
           false,
           a_auxFunction )
      equation
        txt = Tpl.writeText(txt, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_707;

protected function lm_708
  input Tpl.Text in_txt;
  input list<DAE.ComponentRef> in_items;
  input Integer in_a_nls_indexNonLinearSystem;
  input SimCodeFunction.Context in_a_context;
  input Boolean in_a_init;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_nls_indexNonLinearSystem, in_a_context, in_a_init)
    local
      Tpl.Text txt;
      list<DAE.ComponentRef> rest;
      Integer a_nls_indexNonLinearSystem;
      SimCodeFunction.Context a_context;
      Boolean a_init;
      Integer x_i0;
      DAE.ComponentRef i_name;
      Boolean ret_9;
      Tpl.Text l_AUX;
      Boolean ret_7;
      Tpl.Text l_DECL;
      Boolean ret_5;
      Tpl.Text l_PREV;
      Tpl.Text l_START;
      Tpl.Text l_auxFunction;
      Tpl.Text l_varDecls;
      Tpl.Text l_preExp;

    case ( txt,
           {},
           _,
           _,
           _ )
      then txt;

    case ( txt,
           i_name :: rest,
           a_nls_indexNonLinearSystem,
           a_context,
           a_init )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        l_preExp = Tpl.emptyTxt;
        l_varDecls = Tpl.emptyTxt;
        l_auxFunction = Tpl.emptyTxt;
        (l_START, l_auxFunction, l_varDecls, l_preExp) = fun_704(Tpl.emptyTxt, a_init, l_auxFunction, l_varDecls, l_preExp, a_context, i_name);
        ret_5 = stringEq(Tpl.textString(l_preExp), "");
        l_PREV = fun_705(Tpl.emptyTxt, ret_5, l_preExp);
        ret_7 = stringEq(Tpl.textString(l_varDecls), "");
        l_DECL = fun_706(Tpl.emptyTxt, ret_7, l_varDecls);
        ret_9 = stringEq(Tpl.textString(l_auxFunction), "");
        l_AUX = fun_707(Tpl.emptyTxt, ret_9, l_auxFunction);
        txt = Tpl.writeText(txt, l_DECL);
        txt = Tpl.writeText(txt, l_PREV);
        txt = Tpl.writeText(txt, l_AUX);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("data->simulationInfo->nonlinearSystemData["));
        txt = Tpl.writeStr(txt, intString(a_nls_indexNonLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].nlsxOld["));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = "));
        txt = Tpl.writeText(txt, l_START);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        txt = lm_708(txt, rest, a_nls_indexNonLinearSystem, a_context, a_init);
      then txt;
  end match;
end lm_708;

protected function lm_709
  input Tpl.Text in_txt;
  input list<DAE.ComponentRef> in_items;
  input Integer in_a_at_indexNonLinearSystem;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_at_indexNonLinearSystem)
    local
      Tpl.Text txt;
      list<DAE.ComponentRef> rest;
      Integer a_at_indexNonLinearSystem;
      Integer x_i0;
      DAE.ComponentRef i_name;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_name :: rest,
           a_at_indexNonLinearSystem )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = CodegenCFunctions.cref(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = data->simulationInfo->nonlinearSystemData["));
        txt = Tpl.writeStr(txt, intString(a_at_indexNonLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].nlsx["));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("];"));
        txt = Tpl.nextIter(txt);
        txt = lm_709(txt, rest, a_at_indexNonLinearSystem);
      then txt;
  end match;
end lm_709;

protected function fun_710
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_at_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_at_index)
    local
      Tpl.Text txt;
      Integer a_at_index;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_at_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("SIM_PROF_ACC_EQ(modelInfoGetEquation(&data->modelData->modelDataXml,"));
        txt = Tpl.writeStr(txt, intString(a_at_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(").profileBlockIndex);"));
      then txt;
  end match;
end fun_710;

public function equationNonlinearAlternativeTearing
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input SimCodeFunction.Context in_a_context;
  input String in_a_modelNamePrefix;
  input Boolean in_a_init;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_eq, in_a_context, in_a_modelNamePrefix, in_a_init)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      String a_modelNamePrefix;
      Boolean a_init;
      Integer i_nls_indexNonLinearSystem;
      Integer i_nls_index;
      Integer i_at_index;
      Integer i_at_indexNonLinearSystem;
      list<SimCode.SimEqSystem> i_at_eqs;
      list<DAE.ComponentRef> i_at_crefs;
      Boolean ret_6;
      Boolean ret_5;
      Tpl.Text l_nonlinindx;
      Tpl.Text l_innerBody;
      Tpl.Text l_tmp;
      Integer ret_1;
      Tpl.Text l_size;

    case ( txt,
           SimCode.SES_NONLINEAR(nlSystem = SimCode.NONLINEARSYSTEM(index = i_nls_index, indexNonLinearSystem = i_nls_indexNonLinearSystem), alternativeTearing = SOME(SimCode.NONLINEARSYSTEM(crefs = i_at_crefs, eqs = i_at_eqs, indexNonLinearSystem = i_at_indexNonLinearSystem, index = i_at_index))),
           a_context,
           a_modelNamePrefix,
           a_init )
      equation
        ret_1 = listLength(i_at_crefs);
        l_size = Tpl.writeStr(Tpl.emptyTxt, intString(ret_1));
        l_tmp = Tpl.emptyTxt;
        l_innerBody = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_innerBody, l_tmp) = lm_702(l_innerBody, i_at_eqs, a_modelNamePrefix, l_tmp);
        l_innerBody = Tpl.popIter(l_innerBody);
        l_nonlinindx = Tpl.writeStr(Tpl.emptyTxt, intString(i_at_indexNonLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "int retValue;\n",
                                    "if(ACTIVE_STREAM(LOG_DT))\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("infoStreamPrint(LOG_DT, 1, \"Solving nonlinear system "));
        txt = Tpl.writeStr(txt, intString(i_at_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" (CASUAL TEARING SET, strict: "));
        txt = Tpl.writeStr(txt, intString(i_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ") at time = %18.10e\", data->localData[0]->timeValue);\n",
                                    "messageClose(LOG_DT);\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("}\n"));
        ret_5 = Config.profileSome();
        txt = fun_703(txt, ret_5, i_at_index);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "if (data->simulationInfo->nonlinearSystemData["
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_at_indexNonLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "].checkConstraints(data, threadData) == 1)\n",
                                    "{\n",
                                    "  /* get old value */\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_708(txt, i_at_crefs, i_nls_indexNonLinearSystem, a_context, a_init);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("retValue = solve_nonlinear_system(data, threadData, "));
        txt = Tpl.writeStr(txt, intString(i_at_indexNonLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ");\n",
                                    "/* The casual tearing set found a solution */\n",
                                    "if (retValue == 0){\n",
                                    "  /* write solution */\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_709(txt, i_at_crefs, i_at_indexNonLinearSystem);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        ret_6 = Config.profileSome();
        txt = fun_710(txt, ret_6, i_at_index);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("}\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "else\n",
                                    "{\n",
                                    "  if(ACTIVE_STREAM(LOG_DT))\n",
                                    "  {\n",
                                    "    infoStreamPrint(LOG_DT, 1, \"Constraints of the casual tearing set are violated! Now the strict tearing set is used.\");\n",
                                    "    messageClose(LOG_DT);\n",
                                    "  }\n",
                                    "  /* Global constraints are violated. Use the strict tearing set now. */\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("data->simulationInfo->nonlinearSystemData["));
        txt = Tpl.writeStr(txt, intString(i_at_indexNonLinearSystem));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("].strictTearingFunctionCall(data, threadData);\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;

    case ( txt,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end equationNonlinearAlternativeTearing;

protected function lm_712
  input Tpl.Text in_txt;
  input list<DAE.ComponentRef> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<DAE.ComponentRef> rest;
      DAE.ComponentRef i_e;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_e :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = CodegenCFunctions.cref(txt, i_e);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" && !"));
        txt = CodegenCFunctions.crefPre(txt, i_e);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" /* edge */)"));
        txt = Tpl.nextIter(txt);
        txt = lm_712(txt, rest);
      then txt;
  end match;
end lm_712;

protected function fun_713
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input list<DAE.ComponentRef> in_a_conditions;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_conditions)
    local
      Tpl.Text txt;
      list<DAE.ComponentRef> a_conditions;

    case ( txt,
           false,
           a_conditions )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(" || ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_712(txt, a_conditions);
        txt = Tpl.popIter(txt);
      then txt;

    case ( txt,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("0"));
      then txt;
  end match;
end fun_713;

protected function lm_714
  input Tpl.Text in_txt;
  input list<DAE.ComponentRef> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<DAE.ComponentRef> rest;
      DAE.ComponentRef i_e;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_e :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = CodegenCFunctions.cref(txt, i_e);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" && !"));
        txt = CodegenCFunctions.crefPre(txt, i_e);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" /* edge */)"));
        txt = Tpl.nextIter(txt);
        txt = lm_714(txt, rest);
      then txt;
  end match;
end lm_714;

protected function fun_715
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input list<DAE.ComponentRef> in_a_conditions;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_conditions)
    local
      Tpl.Text txt;
      list<DAE.ComponentRef> a_conditions;

    case ( txt,
           false,
           a_conditions )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(" || ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_714(txt, a_conditions);
        txt = Tpl.popIter(txt);
      then txt;

    case ( txt,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("0"));
      then txt;
  end match;
end fun_715;

public function equationWhen
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_eq, in_a_context, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      SimCode.SimEqSystem i_elseWhenEq;
      list<BackendDAE.WhenOperator> i_whenStmtLst;
      list<DAE.ComponentRef> i_conditions;
      Tpl.Text l_elseWhen;
      Boolean ret_3;
      Tpl.Text l_assign;
      Boolean ret_1;
      Tpl.Text l_helpIf;

    case ( txt,
           SimCode.SES_WHEN(whenStmtLst = i_whenStmtLst, conditions = i_conditions, elseWhen = NONE()),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        ret_1 = listEmpty(i_conditions);
        l_helpIf = fun_713(Tpl.emptyTxt, ret_1, i_conditions);
        (l_assign, a_varDecls, a_auxFunction) = whenOperators(Tpl.emptyTxt, i_whenStmtLst, a_context, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if("));
        txt = Tpl.writeText(txt, l_helpIf);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ")\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_assign);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           SimCode.SES_WHEN(whenStmtLst = i_whenStmtLst, conditions = i_conditions, elseWhen = SOME(i_elseWhenEq)),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        ret_3 = listEmpty(i_conditions);
        l_helpIf = fun_715(Tpl.emptyTxt, ret_3, i_conditions);
        (l_assign, a_varDecls, a_auxFunction) = whenOperators(Tpl.emptyTxt, i_whenStmtLst, a_context, a_varDecls, a_auxFunction);
        (l_elseWhen, a_varDecls, a_auxFunction) = equationElseWhen(Tpl.emptyTxt, i_elseWhenEq, a_context, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if("));
        txt = Tpl.writeText(txt, l_helpIf);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ")\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_assign);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("}\n"));
        txt = Tpl.writeText(txt, l_elseWhen);
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_varDecls,
           a_auxFunction )
      then (txt, a_varDecls, a_auxFunction);
  end match;
end equationWhen;

protected function lm_717
  input Tpl.Text in_txt;
  input list<DAE.ComponentRef> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<DAE.ComponentRef> rest;
      DAE.ComponentRef i_e;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_e :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = CodegenCFunctions.cref(txt, i_e);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" && !"));
        txt = CodegenCFunctions.crefPre(txt, i_e);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" /* edge */)"));
        txt = Tpl.nextIter(txt);
        txt = lm_717(txt, rest);
      then txt;
  end match;
end lm_717;

protected function fun_718
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_assign;
  input Tpl.Text in_a_helpIf;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_assign, in_a_helpIf)
    local
      Tpl.Text txt;
      Tpl.Text a_assign;
      Tpl.Text a_helpIf;

    case ( txt,
           false,
           a_assign,
           a_helpIf )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("else if("));
        txt = Tpl.writeText(txt, a_helpIf);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ")\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_assign);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_718;

protected function lm_719
  input Tpl.Text in_txt;
  input list<DAE.ComponentRef> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<DAE.ComponentRef> rest;
      DAE.ComponentRef i_e;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_e :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = CodegenCFunctions.cref(txt, i_e);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" && !"));
        txt = CodegenCFunctions.crefPre(txt, i_e);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" /* edge */)"));
        txt = Tpl.nextIter(txt);
        txt = lm_719(txt, rest);
      then txt;
  end match;
end lm_719;

protected function fun_720
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_assign;
  input Tpl.Text in_a_helpIf;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_assign, in_a_helpIf)
    local
      Tpl.Text txt;
      Tpl.Text a_assign;
      Tpl.Text a_helpIf;

    case ( txt,
           false,
           a_assign,
           a_helpIf )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("else if("));
        txt = Tpl.writeText(txt, a_helpIf);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ")\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_assign);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_720;

public function equationElseWhen
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_eq, in_a_context, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      SimCode.SimEqSystem i_elseWhenEq;
      list<BackendDAE.WhenOperator> i_whenStmtLst;
      list<DAE.ComponentRef> i_conditions;
      Boolean ret_5;
      Tpl.Text l_body;
      Tpl.Text l_elseWhen;
      Boolean ret_2;
      Tpl.Text l_assign;
      Tpl.Text l_helpIf;

    case ( txt,
           SimCode.SES_WHEN(whenStmtLst = i_whenStmtLst, conditions = i_conditions, elseWhen = NONE()),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        l_helpIf = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(" || ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_helpIf = lm_717(l_helpIf, i_conditions);
        l_helpIf = Tpl.popIter(l_helpIf);
        (l_assign, a_varDecls, a_auxFunction) = whenOperators(Tpl.emptyTxt, i_whenStmtLst, a_context, a_varDecls, a_auxFunction);
        ret_2 = listEmpty(i_conditions);
        txt = fun_718(txt, ret_2, l_assign, l_helpIf);
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           SimCode.SES_WHEN(whenStmtLst = i_whenStmtLst, conditions = i_conditions, elseWhen = SOME(i_elseWhenEq)),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        l_helpIf = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(" || ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_helpIf = lm_719(l_helpIf, i_conditions);
        l_helpIf = Tpl.popIter(l_helpIf);
        (l_assign, a_varDecls, a_auxFunction) = whenOperators(Tpl.emptyTxt, i_whenStmtLst, a_context, a_varDecls, a_auxFunction);
        (l_elseWhen, a_varDecls, a_auxFunction) = equationElseWhen(Tpl.emptyTxt, i_elseWhenEq, a_context, a_varDecls, a_auxFunction);
        ret_5 = listEmpty(i_conditions);
        l_body = fun_720(Tpl.emptyTxt, ret_5, l_assign, l_helpIf);
        txt = Tpl.writeText(txt, l_body);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_elseWhen);
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_varDecls,
           a_auxFunction )
      then (txt, a_varDecls, a_auxFunction);
  end match;
end equationElseWhen;

protected function lm_722
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_postExp;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_postExp;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_postExp, out_a_preExp, out_a_varDecls) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_postExp, in_a_preExp, in_a_varDecls, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_postExp;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      SimCodeFunction.Context a_context;
      DAE.Exp i_e;

    case ( txt,
           {},
           a_auxFunction,
           a_postExp,
           a_preExp,
           a_varDecls,
           _ )
      then (txt, a_auxFunction, a_postExp, a_preExp, a_varDecls);

    case ( txt,
           i_e :: rest,
           a_auxFunction,
           a_postExp,
           a_preExp,
           a_varDecls,
           a_context )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" ,"));
        (txt, a_varDecls, a_preExp, a_postExp, a_auxFunction) = CodegenCFunctions.tupleReturnVariableUpdates(txt, i_e, a_context, a_varDecls, a_preExp, a_postExp, a_auxFunction);
        (txt, a_auxFunction, a_postExp, a_preExp, a_varDecls) = lm_722(txt, rest, a_auxFunction, a_postExp, a_preExp, a_varDecls, a_context);
      then (txt, a_auxFunction, a_postExp, a_preExp, a_varDecls);
  end match;
end lm_722;

protected function lm_723
  input Tpl.Text in_txt;
  input list<String> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<String> rest;
      String i_it;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_it :: rest )
      equation
        txt = Tpl.writeStr(txt, i_it);
        txt = lm_723(txt, rest);
      then txt;
  end match;
end lm_723;

protected function fun_724
  input Tpl.Text in_txt;
  input DAE.Type in_mArg;
  input DAE.ComponentRef in_a_stateVar;
  input Tpl.Text in_a_val;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_stateVar, in_a_val)
    local
      Tpl.Text txt;
      DAE.ComponentRef a_stateVar;
      Tpl.Text a_val;

    case ( txt,
           DAE.T_ARRAY(ty = _),
           a_stateVar,
           a_val )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("copy_real_array_data_mem("));
        txt = Tpl.writeText(txt, a_val);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", &"));
        txt = CodegenCFunctions.cref(txt, a_stateVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;

    case ( txt,
           _,
           a_stateVar,
           a_val )
      equation
        txt = CodegenCFunctions.cref(txt, a_stateVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, a_val);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_724;

protected function fun_725
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_expPart;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_expPart)
    local
      Tpl.Text txt;
      Tpl.Text a_expPart;

    case ( txt,
           false,
           a_expPart )
      equation
        txt = Tpl.writeText(txt, a_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_725;

protected function fun_726
  input Tpl.Text in_txt;
  input BackendDAE.WhenOperator in_a_whenOp;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_a_whenOp, in_a_auxFunction, in_a_varDecls, in_a_context)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      SimCodeFunction.Context a_context;
      DAE.Exp i_exp;
      SourceInfo i_info;
      DAE.Exp i_level;
      DAE.Exp i_condition;
      DAE.ElementSource i_source;
      DAE.Exp i_message;
      DAE.ComponentRef i_stateVar;
      DAE.Exp i_value;
      DAE.Exp i_firstexp;
      list<DAE.Type> i_ntys;
      list<DAE.Exp> i_expLst;
      DAE.Exp i_right;
      DAE.ComponentRef i_left;
      Boolean ret_20;
      Tpl.Text l_expPart;
      list<DAE.Exp> ret_18;
      SourceInfo ret_17;
      Tpl.Text l_msgVar;
      DAE.Type ret_15;
      Tpl.Text l_lhs;
      Tpl.Text l_val;
      Tpl.Text l_callassign;
      Tpl.Text l_call;
      list<String> ret_10;
      Integer ret_9;
      Integer ret_8;
      Integer ret_7;
      Integer ret_6;
      Tpl.Text l_lhsCrefs2;
      list<DAE.Exp> ret_4;
      Tpl.Text l_lhsCrefs;
      Tpl.Text l_postExp;
      Tpl.Text l_preExp;
      DAE.Type ret_0;

    case ( txt,
           BackendDAE.ASSIGN(left = DAE.CREF(componentRef = i_left), right = i_right),
           a_auxFunction,
           a_varDecls,
           a_context )
      equation
        ret_0 = Expression.typeof(i_right);
        (txt, a_varDecls, a_auxFunction) = whenAssign(txt, i_left, ret_0, i_right, a_context, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           BackendDAE.ASSIGN(left = DAE.TUPLE(PR = (i_expLst as i_firstexp :: _)), right = (i_right as DAE.CALL(attr = DAE.CALL_ATTR(ty = DAE.T_TUPLE(types = i_ntys))))),
           a_auxFunction,
           a_varDecls,
           a_context )
      equation
        l_preExp = Tpl.emptyTxt;
        l_postExp = Tpl.emptyTxt;
        ret_4 = List.rest(i_expLst);
        (l_lhsCrefs, a_auxFunction, l_postExp, l_preExp, a_varDecls) = lm_722(Tpl.emptyTxt, ret_4, a_auxFunction, l_postExp, l_preExp, a_varDecls, a_context);
        l_lhsCrefs2 = Tpl.writeText(Tpl.emptyTxt, l_lhsCrefs);
        ret_6 = listLength(i_ntys);
        ret_7 = listLength(i_expLst);
        ret_8 = intSub(ret_6, ret_7);
        ret_9 = intMax(0, ret_8);
        ret_10 = List.fill(", NULL", ret_9);
        l_lhsCrefs2 = lm_723(l_lhsCrefs2, ret_10);
        (l_call, l_lhsCrefs2, l_preExp, a_varDecls, a_auxFunction) = CodegenCFunctions.daeExpCallTuple(Tpl.emptyTxt, i_right, l_lhsCrefs2, a_context, l_preExp, a_varDecls, a_auxFunction);
        (l_callassign, l_call, l_preExp, l_postExp, a_varDecls, a_auxFunction) = CodegenCFunctions.algStmtAssignWithRhsExpStr(Tpl.emptyTxt, i_firstexp, l_call, a_context, l_preExp, l_postExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_callassign);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_postExp);
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           BackendDAE.REINIT(value = i_value, stateVar = i_stateVar),
           a_auxFunction,
           a_varDecls,
           _ )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_val, l_preExp, a_varDecls, a_auxFunction) = CodegenCFunctions.daeExp(Tpl.emptyTxt, i_value, SimCodeFunction.contextSimulationDiscrete, l_preExp, a_varDecls, a_auxFunction);
        ret_15 = ComponentReference.crefTypeConsiderSubs(i_stateVar);
        l_lhs = fun_724(Tpl.emptyTxt, ret_15, i_stateVar, l_val);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_lhs);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("infoStreamPrint(LOG_EVENTS, 0, \"reinit "));
        txt = CodegenUtil.crefStrNoUnderscore(txt, i_stateVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = crefToPrintfArg(txt, i_stateVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\", "));
        txt = CodegenCFunctions.cref(txt, i_stateVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ");\n",
                                    "data->simulationInfo->needToIterate = 1;"
                                }, false));
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           BackendDAE.TERMINATE(message = i_message, source = i_source),
           a_auxFunction,
           a_varDecls,
           _ )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_msgVar, l_preExp, a_varDecls, a_auxFunction) = CodegenCFunctions.daeExp(Tpl.emptyTxt, i_message, SimCodeFunction.contextSimulationDiscrete, l_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("FILE_INFO info = {"));
        ret_17 = ElementSource.getElementSourceFileInfo(i_source);
        txt = CodegenCFunctions.infoArgs(txt, ret_17);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "};\n",
                                    "omc_terminate(info, MMC_STRINGDATA("
                                }, false));
        txt = Tpl.writeText(txt, l_msgVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("));"));
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           BackendDAE.ASSERT(source = DAE.SOURCE(info = i_info), condition = i_condition, message = i_message, level = i_level),
           a_auxFunction,
           a_varDecls,
           _ )
      equation
        ret_18 = List.fill(i_message, 1);
        (txt, a_varDecls, a_auxFunction) = CodegenCFunctions.assertCommon(txt, i_condition, ret_18, i_level, SimCodeFunction.contextSimulationDiscrete, a_varDecls, a_auxFunction, i_info);
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           BackendDAE.NORETCALL(exp = i_exp),
           a_auxFunction,
           a_varDecls,
           _ )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_expPart, l_preExp, a_varDecls, a_auxFunction) = CodegenCFunctions.daeExp(Tpl.emptyTxt, i_exp, SimCodeFunction.contextSimulationDiscrete, l_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        ret_20 = Util.isCIdentifier(Tpl.textString(l_expPart));
        txt = fun_725(txt, ret_20, l_expPart);
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           _,
           a_auxFunction,
           a_varDecls,
           _ )
      then (txt, a_auxFunction, a_varDecls);
  end match;
end fun_726;

protected function lm_727
  input Tpl.Text in_txt;
  input list<BackendDAE.WhenOperator> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_context)
    local
      Tpl.Text txt;
      list<BackendDAE.WhenOperator> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      SimCodeFunction.Context a_context;
      BackendDAE.WhenOperator i_whenOp;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           _ )
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           i_whenOp :: rest,
           a_auxFunction,
           a_varDecls,
           a_context )
      equation
        (txt, a_auxFunction, a_varDecls) = fun_726(txt, i_whenOp, a_auxFunction, a_varDecls, a_context);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls) = lm_727(txt, rest, a_auxFunction, a_varDecls, a_context);
      then (txt, a_auxFunction, a_varDecls);
  end match;
end lm_727;

public function whenOperators
  input Tpl.Text txt;
  input list<BackendDAE.WhenOperator> a_whenOps;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
protected
  Tpl.Text l_body;
algorithm
  l_body := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (l_body, out_a_auxFunction, out_a_varDecls) := lm_727(l_body, a_whenOps, a_auxFunction, a_varDecls, a_context);
  l_body := Tpl.popIter(l_body);
  out_txt := Tpl.writeText(txt, l_body);
end whenOperators;

protected function fun_729
  input Tpl.Text in_txt;
  input String in_mArg;
  input DAE.Exp in_a_right;
  input DAE.ComponentRef in_a_left;
  input Tpl.Text in_a_expPart;
  input Tpl.Text in_a_preExp;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_right, in_a_left, in_a_expPart, in_a_preExp)
    local
      Tpl.Text txt;
      DAE.Exp a_right;
      DAE.ComponentRef a_left;
      Tpl.Text a_expPart;
      Tpl.Text a_preExp;
      Tpl.Text txt_0;

    case ( txt,
           "boolean",
           _,
           a_left,
           a_expPart,
           a_preExp )
      equation
        txt = Tpl.writeText(txt, a_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("copy_boolean_array_data_mem("));
        txt = Tpl.writeText(txt, a_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", &"));
        txt = CodegenCFunctions.cref(txt, a_left);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;

    case ( txt,
           "integer",
           _,
           a_left,
           a_expPart,
           a_preExp )
      equation
        txt = Tpl.writeText(txt, a_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("copy_integer_array_data_mem("));
        txt = Tpl.writeText(txt, a_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", &"));
        txt = CodegenCFunctions.cref(txt, a_left);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;

    case ( txt,
           "real",
           _,
           a_left,
           a_expPart,
           a_preExp )
      equation
        txt = Tpl.writeText(txt, a_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("copy_real_array_data_mem("));
        txt = Tpl.writeText(txt, a_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", &"));
        txt = CodegenCFunctions.cref(txt, a_left);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;

    case ( txt,
           "string",
           _,
           a_left,
           a_expPart,
           a_preExp )
      equation
        txt = Tpl.writeText(txt, a_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("copy_string_array_data_mem("));
        txt = Tpl.writeText(txt, a_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", &"));
        txt = CodegenCFunctions.cref(txt, a_left);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;

    case ( txt,
           _,
           a_right,
           a_left,
           _,
           _ )
      equation
        txt_0 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("No runtime support for this sort of array call: "));
        txt_0 = CodegenCFunctions.cref(txt_0, a_left);
        txt_0 = Tpl.writeTok(txt_0, Tpl.ST_STRING(" = "));
        txt_0 = ExpressionDumpTpl.dumpExp(txt_0, a_right, "\"");
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 5943, 13), Tpl.textString(txt_0));
      then txt;
  end match;
end fun_729;

protected function fun_730
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;
  input DAE.ComponentRef in_a_left;
  input DAE.Exp in_a_right;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_ty, in_a_left, in_a_right, in_a_context, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      DAE.ComponentRef a_left;
      DAE.Exp a_right;
      SimCodeFunction.Context a_context;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      Tpl.Text l_exp;
      Tpl.Text txt_4;
      String str_3;
      Tpl.Text txt_2;
      Tpl.Text l_expPart;
      Tpl.Text l_preExp;

    case ( txt,
           DAE.T_ARRAY(ty = _),
           a_left,
           a_right,
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_expPart, l_preExp, a_varDecls, a_auxFunction) = CodegenCFunctions.daeExp(Tpl.emptyTxt, a_right, a_context, l_preExp, a_varDecls, a_auxFunction);
        txt_2 = CodegenCFunctions.expTypeFromExpShort(Tpl.emptyTxt, a_right);
        str_3 = Tpl.textString(txt_2);
        txt = fun_729(txt, str_3, a_right, a_left, l_expPart, l_preExp);
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.T_COMPLEX(varLst = _, complexClassType = ClassInf.RECORD(path = _)),
           a_left,
           a_right,
           _,
           a_varDecls,
           a_auxFunction )
      equation
        txt_4 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("No runtime support for this record assignment: "));
        txt_4 = CodegenCFunctions.cref(txt_4, a_left);
        txt_4 = Tpl.writeTok(txt_4, Tpl.ST_STRING(" = "));
        txt_4 = ExpressionDumpTpl.dumpExp(txt_4, a_right, "\"");
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 5946, 11), Tpl.textString(txt_4));
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           a_left,
           a_right,
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_exp, l_preExp, a_varDecls, a_auxFunction) = CodegenCFunctions.daeExp(Tpl.emptyTxt, a_right, a_context, l_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = CodegenCFunctions.cref(txt, a_left);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, l_exp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then (txt, a_varDecls, a_auxFunction);
  end match;
end fun_730;

public function whenAssign
  input Tpl.Text txt;
  input DAE.ComponentRef a_left;
  input DAE.Type a_ty;
  input DAE.Exp a_right;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) := fun_730(txt, a_ty, a_left, a_right, a_context, a_varDecls, a_auxFunction);
end whenAssign;

protected function lm_732
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input Boolean in_a_init;
  input String in_a_modelNamePrefixStr;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_init, in_a_modelNamePrefixStr, in_a_context)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      Boolean a_init;
      String a_modelNamePrefixStr;
      SimCodeFunction.Context a_context;
      SimCode.SimEqSystem i_eqn;

    case ( txt,
           {},
           _,
           _,
           _ )
      then txt;

    case ( txt,
           i_eqn :: rest,
           a_init,
           a_modelNamePrefixStr,
           a_context )
      equation
        txt = equation_impl(txt, -1, i_eqn, a_context, a_modelNamePrefixStr, a_init);
        txt = Tpl.nextIter(txt);
        txt = lm_732(txt, rest, a_init, a_modelNamePrefixStr, a_context);
      then txt;
  end match;
end lm_732;

protected function fun_733
  input Tpl.Text in_txt;
  input Integer in_a_index0;
  input Tpl.Text in_a_condition;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_index0, in_a_condition)
    local
      Tpl.Text txt;
      Tpl.Text a_condition;

    case ( txt,
           0,
           a_condition )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if("));
        txt = Tpl.writeText(txt, a_condition);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           _,
           a_condition )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("else if("));
        txt = Tpl.writeText(txt, a_condition);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;
  end match;
end fun_733;

protected function lm_734
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input SimCodeFunction.Context in_a_context;
  input String in_a_modelNamePrefixStr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_context, in_a_modelNamePrefixStr)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      SimCodeFunction.Context a_context;
      String a_modelNamePrefixStr;
      SimCode.SimEqSystem i_eqn;

    case ( txt,
           {},
           _,
           _ )
      then txt;

    case ( txt,
           i_eqn :: rest,
           a_context,
           a_modelNamePrefixStr )
      equation
        txt = equation_call_context(txt, i_eqn, a_modelNamePrefixStr, a_context);
        txt = Tpl.nextIter(txt);
        txt = lm_734(txt, rest, a_context, a_modelNamePrefixStr);
      then txt;
  end match;
end lm_734;

protected function lm_735
  input Tpl.Text in_txt;
  input list<tuple<DAE.Exp, list<SimCode.SimEqSystem>>> in_items;
  input Boolean in_a_init;
  input String in_a_modelNamePrefixStr;
  input Tpl.Text in_a_eqnsDecls;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_eqnsDecls;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_eqnsDecls, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_init, in_a_modelNamePrefixStr, in_a_eqnsDecls, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<tuple<DAE.Exp, list<SimCode.SimEqSystem>>> rest;
      Boolean a_init;
      String a_modelNamePrefixStr;
      Tpl.Text a_eqnsDecls;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      Integer x_index0;
      list<SimCode.SimEqSystem> i_eqns;
      DAE.Exp i_e;
      Tpl.Text l_conditionline;
      Tpl.Text l_condition;

    case ( txt,
           {},
           _,
           _,
           a_eqnsDecls,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_eqnsDecls, a_varDecls, a_preExp);

    case ( txt,
           (i_e, i_eqns) :: rest,
           a_init,
           a_modelNamePrefixStr,
           a_eqnsDecls,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        x_index0 = Tpl.getIteri_i0(txt);
        (l_condition, a_preExp, a_varDecls, a_eqnsDecls) = CodegenCFunctions.daeExp(Tpl.emptyTxt, i_e, a_context, a_preExp, a_varDecls, a_eqnsDecls);
        a_eqnsDecls = Tpl.pushIter(a_eqnsDecls, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        a_eqnsDecls = lm_732(a_eqnsDecls, i_eqns, a_init, a_modelNamePrefixStr, a_context);
        a_eqnsDecls = Tpl.popIter(a_eqnsDecls);
        l_conditionline = fun_733(Tpl.emptyTxt, x_index0, l_condition);
        txt = Tpl.writeText(txt, l_conditionline);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("{\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_734(txt, i_eqns, a_context, a_modelNamePrefixStr);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
        txt = Tpl.nextIter(txt);
        (txt, a_eqnsDecls, a_varDecls, a_preExp) = lm_735(txt, rest, a_init, a_modelNamePrefixStr, a_eqnsDecls, a_varDecls, a_preExp, a_context);
      then (txt, a_eqnsDecls, a_varDecls, a_preExp);
  end match;
end lm_735;

protected function lm_736
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input Boolean in_a_init;
  input String in_a_modelNamePrefixStr;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_init, in_a_modelNamePrefixStr, in_a_context)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      Boolean a_init;
      String a_modelNamePrefixStr;
      SimCodeFunction.Context a_context;
      SimCode.SimEqSystem i_eqn;

    case ( txt,
           {},
           _,
           _,
           _ )
      then txt;

    case ( txt,
           i_eqn :: rest,
           a_init,
           a_modelNamePrefixStr,
           a_context )
      equation
        txt = equation_impl(txt, -1, i_eqn, a_context, a_modelNamePrefixStr, a_init);
        txt = Tpl.nextIter(txt);
        txt = lm_736(txt, rest, a_init, a_modelNamePrefixStr, a_context);
      then txt;
  end match;
end lm_736;

protected function lm_737
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input SimCodeFunction.Context in_a_context;
  input String in_a_modelNamePrefixStr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_context, in_a_modelNamePrefixStr)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      SimCodeFunction.Context a_context;
      String a_modelNamePrefixStr;
      SimCode.SimEqSystem i_eqn;

    case ( txt,
           {},
           _,
           _ )
      then txt;

    case ( txt,
           i_eqn :: rest,
           a_context,
           a_modelNamePrefixStr )
      equation
        txt = equation_call_context(txt, i_eqn, a_modelNamePrefixStr, a_context);
        txt = lm_737(txt, rest, a_context, a_modelNamePrefixStr);
      then txt;
  end match;
end lm_737;

public function equationIfEquationAssign
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_eqnsDecls;
  input String in_a_modelNamePrefixStr;
  input Boolean in_a_init;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_eqnsDecls;
algorithm
  (out_txt, out_a_varDecls, out_a_eqnsDecls) :=
  match(in_txt, in_a_eq, in_a_context, in_a_varDecls, in_a_eqnsDecls, in_a_modelNamePrefixStr, in_a_init)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_varDecls;
      Tpl.Text a_eqnsDecls;
      String a_modelNamePrefixStr;
      Boolean a_init;
      list<SimCode.SimEqSystem> i_elsebranch;
      list<tuple<DAE.Exp, list<SimCode.SimEqSystem>>> i_ifbranches;
      Tpl.Text l_IfEquation;
      Tpl.Text l_preExp;

    case ( txt,
           SimCode.SES_IFEQUATION(ifbranches = i_ifbranches, elsebranch = i_elsebranch),
           a_context,
           a_varDecls,
           a_eqnsDecls,
           a_modelNamePrefixStr,
           a_init )
      equation
        l_preExp = Tpl.emptyTxt;
        l_IfEquation = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_IfEquation, a_eqnsDecls, a_varDecls, l_preExp) = lm_735(l_IfEquation, i_ifbranches, a_init, a_modelNamePrefixStr, a_eqnsDecls, a_varDecls, l_preExp, a_context);
        l_IfEquation = Tpl.popIter(l_IfEquation);
        a_eqnsDecls = Tpl.pushIter(a_eqnsDecls, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        a_eqnsDecls = lm_736(a_eqnsDecls, i_elsebranch, a_init, a_modelNamePrefixStr, a_context);
        a_eqnsDecls = Tpl.popIter(a_eqnsDecls);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_IfEquation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "else\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = lm_737(txt, i_elsebranch, a_context, a_modelNamePrefixStr);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then (txt, a_varDecls, a_eqnsDecls);

    case ( txt,
           _,
           _,
           a_varDecls,
           a_eqnsDecls,
           _,
           _ )
      then (txt, a_varDecls, a_eqnsDecls);
  end match;
end equationIfEquationAssign;

protected function fun_739
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input DAE.Exp in_a_literal;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_literal)
    local
      Tpl.Text txt;
      DAE.Exp a_literal;
      String ret_1;
      Tpl.Text txt_0;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_literal )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/* "));
        txt_0 = ExpressionDumpTpl.dumpExp(Tpl.emptyTxt, a_literal, "\"");
        ret_1 = Util.escapeModelicaStringToCString(Tpl.textString(txt_0));
        txt = Tpl.writeStr(txt, ret_1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" */"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;
  end match;
end fun_739;

protected function lm_740
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Integer x_i0;
      DAE.Exp i_literal;
      Boolean ret_0;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_literal :: rest )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        ret_0 = Config.typeinfo();
        txt = fun_739(txt, ret_0, i_literal);
        txt = CodegenCFunctions.literalExpConst(txt, i_literal, x_i0);
        txt = Tpl.nextIter(txt);
        txt = lm_740(txt, rest);
      then txt;
  end match;
end lm_740;

public function simulationLiteralsFile
  input Tpl.Text txt;
  input String a_filePrefix;
  input list<DAE.Exp> a_literals;

  output Tpl.Text out_txt;
algorithm
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                   "#ifdef __cplusplus\n",
                                   "extern \"C\" {\n",
                                   "#endif\n",
                                   "\n"
                               }, true));
  out_txt := Tpl.pushIter(out_txt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_740(out_txt, a_literals);
  out_txt := Tpl.popIter(out_txt);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "#ifdef __cplusplus\n",
                                       "}\n",
                                       "#endif"
                                   }, false));
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_NEW_LINE());
end simulationLiteralsFile;

protected function fun_742
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_filePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_filePrefix)
    local
      Tpl.Text txt;
      String a_filePrefix;
      Integer ret_0;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_filePrefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "/* the OpenCL Kernels file name needed in libParModelicaExpl.a */\n",
                                    "const char* omc_ocl_kernels_source = \""
                                }, false));
        txt = Tpl.writeStr(txt, a_filePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_kernels.cl\";\n",
                                    "/* the OpenCL program. Made global to avoid repeated builds */\n",
                                    "extern cl_program omc_ocl_program;\n",
                                    "/* The default OpenCL device. If not set (=0) show the selection option.*/\n",
                                    "unsigned int default_ocl_device = "
                                }, false));
        ret_0 = Config.getDefaultOpenCLDevice();
        txt = Tpl.writeStr(txt, intString(ret_0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_742;

public function simulationFunctionsFile
  input Tpl.Text txt;
  input String a_filePrefix;
  input list<SimCodeFunction.Function> a_functions;

  output Tpl.Text out_txt;
protected
  Boolean ret_0;
algorithm
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                   "#include \"omc_simulation_settings.h\"\n",
                                   "#include \""
                               }, false));
  out_txt := Tpl.writeStr(out_txt, a_filePrefix);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "_functions.h\"\n",
                                       "#ifdef __cplusplus\n",
                                       "extern \"C\" {\n",
                                       "#endif\n",
                                       "\n",
                                       "#include \""
                                   }, false));
  out_txt := Tpl.writeStr(out_txt, a_filePrefix);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "_includes.h\"\n",
                                       "\n"
                                   }, true));
  ret_0 := Config.acceptParModelicaGrammar();
  out_txt := fun_742(out_txt, ret_0, a_filePrefix);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_NEW_LINE());
  out_txt := CodegenCFunctions.functionBodies(out_txt, a_functions, true);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "#ifdef __cplusplus\n",
                                       "}\n",
                                       "#endif"
                                   }, false));
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_NEW_LINE());
end simulationFunctionsFile;

public function simulationParModelicaKernelsFile
  input Tpl.Text txt;
  input String a_filePrefix;
  input list<SimCodeFunction.Function> a_functions;

  output Tpl.Text out_txt;
algorithm
  System.tmpTickResetIndex(0, 20);
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                   "#include <ParModelica/explicit/openclrt/OCLRuntimeUtil.cl>\n",
                                   "\n",
                                   "// ParModelica Parallel Function headers.\n"
                               }, true));
  out_txt := CodegenCFunctions.functionHeadersParModelica(out_txt, a_filePrefix, a_functions);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "// Headers finish here.\n",
                                       "\n"
                                   }, true));
  out_txt := CodegenCFunctions.functionBodiesParModelica(out_txt, a_functions);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "\n"
                                   }, true));
end simulationParModelicaKernelsFile;

protected function lm_745
  input Tpl.Text in_txt;
  input list<SimCodeFunction.RecordDeclaration> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeFunction.RecordDeclaration> rest;
      SimCodeFunction.RecordDeclaration i_rd;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_rd :: rest )
      equation
        txt = CodegenCFunctions.recordDeclarationHeader(txt, i_rd);
        txt = Tpl.nextIter(txt);
        txt = lm_745(txt, rest);
      then txt;
  end match;
end lm_745;

protected function fun_746
  input Tpl.Text in_txt;
  input Tpl.Text in_a_staticPrototypes;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_staticPrototypes)
    local
      Tpl.Text txt;
      Tpl.Text i_staticPrototypes;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}) )
      then txt;

    case ( txt,
           i_staticPrototypes )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "/* default, do not make protected functions static */\n",
                                    "#if !defined(PROTECTED_FUNCTION_STATIC)\n",
                                    "#define PROTECTED_FUNCTION_STATIC\n",
                                    "#endif\n"
                                }, true));
        txt = Tpl.writeText(txt, i_staticPrototypes);
      then txt;
  end match;
end fun_746;

public function simulationFunctionsHeaderFile
  input Tpl.Text txt;
  input String a_filePrefix;
  input list<SimCodeFunction.Function> a_functions;
  input list<SimCodeFunction.RecordDeclaration> a_recordDecls;

  output Tpl.Text out_txt;
protected
  String ret_2;
  String ret_1;
  Tpl.Text l_staticPrototypes;
algorithm
  l_staticPrototypes := Tpl.emptyTxt;
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING("#ifndef "));
  ret_1 := System.makeC89Identifier(a_filePrefix);
  out_txt := Tpl.writeStr(out_txt, ret_1);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "__H\n",
                                       "#define "
                                   }, false));
  ret_2 := System.makeC89Identifier(a_filePrefix);
  out_txt := Tpl.writeStr(out_txt, ret_2);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("__H\n"));
  out_txt := CodegenCFunctions.commonHeader(out_txt, a_filePrefix);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "#include \"simulation/simulation_runtime.h\"\n",
                                       "#ifdef __cplusplus\n",
                                       "extern \"C\" {\n",
                                       "#endif\n"
                                   }, true));
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_NEW_LINE());
  out_txt := Tpl.pushIter(out_txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING_LIST({
                                                                        "\n",
                                                                        "\n"
                                                                    }, true)), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_745(out_txt, a_recordDecls);
  out_txt := Tpl.popIter(out_txt);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_NEW_LINE());
  (out_txt, l_staticPrototypes) := CodegenCFunctions.functionHeaders(out_txt, a_functions, true, l_staticPrototypes);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("#include \""));
  out_txt := Tpl.writeStr(out_txt, a_filePrefix);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("_model.h\"\n"));
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_NEW_LINE());
  out_txt := fun_746(out_txt, l_staticPrototypes);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "#ifdef __cplusplus\n",
                                       "}\n",
                                       "#endif\n",
                                       "#endif"
                                   }, false));
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_NEW_LINE());
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_NEW_LINE());
end simulationFunctionsHeaderFile;

protected function fun_748
  input Tpl.Text in_txt;
  input String in_a_modelInfo_directory;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo_directory)
    local
      Tpl.Text txt;
      String i_modelInfo_directory;

    case ( txt,
           "" )
      then txt;

    case ( txt,
           i_modelInfo_directory )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/LIBPATH:\""));
        txt = Tpl.writeStr(txt, i_modelInfo_directory);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
      then txt;
  end match;
end fun_748;

protected function lm_749
  input Tpl.Text in_txt;
  input list<String> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<String> rest;
      String i_lib;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_lib :: rest )
      equation
        txt = Tpl.writeStr(txt, i_lib);
        txt = Tpl.nextIter(txt);
        txt = lm_749(txt, rest);
      then txt;
  end match;
end lm_749;

protected function fun_750
  input Tpl.Text in_txt;
  input Tpl.Text in_a_dirExtra;
  input Tpl.Text in_a_libsStr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_dirExtra, in_a_libsStr)
    local
      Tpl.Text txt;
      Tpl.Text a_libsStr;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           a_libsStr )
      equation
        txt = Tpl.writeText(txt, a_libsStr);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_750;

protected function fun_751
  input Tpl.Text in_txt;
  input Tpl.Text in_a_dirExtra;
  input Tpl.Text in_a_libsStr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_dirExtra, in_a_libsStr)
    local
      Tpl.Text txt;
      Tpl.Text a_libsStr;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           _ )
      then txt;

    case ( txt,
           _,
           a_libsStr )
      equation
        txt = Tpl.writeText(txt, a_libsStr);
      then txt;
  end match;
end fun_751;

protected function fun_752
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("ParModelicaExpl.lib OpenCL.lib"));
      then txt;
  end match;
end fun_752;

protected function fun_753
  input Tpl.Text in_txt;
  input String in_a_s_method;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_s_method)
    local
      Tpl.Text txt;

    case ( txt,
           "dassljac" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-D_OMC_JACOBIAN "));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_753;

protected function fun_754
  input Tpl.Text in_txt;
  input Option<SimCode.SimulationSettings> in_a_sopt;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_sopt)
    local
      Tpl.Text txt;
      String i_s_method;

    case ( txt,
           SOME(SimCode.SIMULATION_SETTINGS(method = i_s_method)) )
      equation
        txt = fun_753(txt, i_s_method);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_754;

protected function fun_755
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/openmp"));
      then txt;
  end match;
end fun_755;

protected function lm_756
  input Tpl.Text in_txt;
  input list<String> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<String> rest;
      String i_extraFile;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_extraFile :: rest )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeStr(txt, i_extraFile);
        txt = Tpl.popBlock(txt);
        txt = lm_756(txt, rest);
      then txt;
  end match;
end lm_756;

protected function fun_757
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input list<String> in_a_extraFiles;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode, in_a_extraFiles)
    local
      Tpl.Text txt;
      list<String> a_extraFiles;
      String i_fileNamePrefix;
      String i_makefileParams_omhome;
      Option<SimCode.SimulationSettings> i_sopt;
      list<String> i_makefileParams_libs;
      String i_modelInfo_directory;
      Boolean ret_7;
      Tpl.Text l_extraCflags;
      Boolean ret_5;
      Tpl.Text l_ParModelicaExpLibs;
      Tpl.Text l_libsPos2;
      Tpl.Text l_libsPos1;
      Tpl.Text l_libsStr;
      Tpl.Text l_dirExtra;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(directory = i_modelInfo_directory), makefileParams = SimCodeFunction.MAKEFILE_PARAMS(libs = i_makefileParams_libs, omhome = i_makefileParams_omhome), simulationSettingsOpt = i_sopt, fileNamePrefix = i_fileNamePrefix),
           a_extraFiles )
      equation
        l_dirExtra = fun_748(Tpl.emptyTxt, i_modelInfo_directory);
        l_libsStr = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(" ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_libsStr = lm_749(l_libsStr, i_makefileParams_libs);
        l_libsStr = Tpl.popIter(l_libsStr);
        l_libsPos1 = fun_750(Tpl.emptyTxt, l_dirExtra, l_libsStr);
        l_libsPos2 = fun_751(Tpl.emptyTxt, l_dirExtra, l_libsStr);
        ret_5 = Config.acceptParModelicaGrammar();
        l_ParModelicaExpLibs = fun_752(Tpl.emptyTxt, ret_5);
        l_extraCflags = fun_754(Tpl.emptyTxt, i_sopt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "# Makefile generated by OpenModelica\n",
                                    "\n",
                                    "MODELICAUSERCFLAGS=\n",
                                    "CC=cl\n",
                                    "CXX=cl\n",
                                    "EXEEXT=.exe\n",
                                    "DLLEXT=.dll\n",
                                    "\n",
                                    "# /Od - Optimization disabled\n",
                                    "# /EHa enable C++ EH (w/ SEH exceptions)\n",
                                    "# /fp:except - consider floating-point exceptions when generating code\n",
                                    "# /arch:SSE2 - enable use of instructions available with SSE2 enabled CPUs\n",
                                    "# /I - Include Directories\n",
                                    "# /DNOMINMAX - Define NOMINMAX (does what it says)\n",
                                    "# /TP - Use C++ Compiler\n",
                                    "CFLAGS=/MP /Od /ZI /EHa /fp:except /I\""
                                }, false));
        txt = Tpl.writeStr(txt, i_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/include/omc/c\" /I\""));
        txt = Tpl.writeStr(txt, i_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/include/omc/msvc/\" /I. /DNOMINMAX /TP /DNO_INTERACTIVE_DEPENDENCY /DOPENMODELICA_XML_FROM_FILE_AT_RUNTIME "));
        ret_7 = Flags.isSet(Flags.HPCOM);
        txt = fun_755(txt, ret_7);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "# /ZI enable Edit and Continue debug info\n",
                                    "CDFLAGS=/ZI\n",
                                    "\n",
                                    "# /MD - link with MSVCRT.LIB\n",
                                    "# /link - [linker options and libraries]\n",
                                    "# /LIBPATH: - Directories where libs can be found\n",
                                    "LDFLAGS=/MD /link /NODEFAULTLIB:libcmt /STACK:0x2000000 /pdb:\""
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".pdb\" /LIBPATH:\""));
        txt = Tpl.writeStr(txt, i_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/lib/"));
        txt = Tpl.writeStr(txt, Autoconf.triple);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/omc/msvc/\" /LIBPATH:\""));
        txt = Tpl.writeStr(txt, i_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/lib/"));
        txt = Tpl.writeStr(txt, Autoconf.triple);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/omc/msvc/release/\" /LIBPATH:\""));
        txt = Tpl.writeStr(txt, i_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/lib/"));
        txt = Tpl.writeStr(txt, Autoconf.triple);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/omc/cpp/msvc/\" "));
        txt = Tpl.writeText(txt, l_dirExtra);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, l_libsPos1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, l_libsPos2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " f2c.lib initialization.lib libexpat.lib math-support.lib meta.lib results.lib simulation.lib solver.lib sundials_kinsol.lib sundials_nvecserial.lib util.lib lapack_win32_MT.lib lis.lib  omcgc.lib user32.lib pthreadVC2.lib wsock32.lib cminpack.lib umfpack.lib amd.lib\n",
                                    "\n",
                                    "# /MDd link with MSVCRTD.LIB debug lib\n",
                                    "# lib names should not be appended with a d just switch to lib/omc/msvc/debug\n",
                                    "\n",
                                    "\n",
                                    "FILEPREFIX="
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "MAINFILE=$(FILEPREFIX).c\n",
                                    "MAINOBJ=$(FILEPREFIX).obj\n",
                                    "CFILES="
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_functions.c "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_records.c \\\n"));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_01exo.c "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_02nls.c "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_03lsy.c "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_04set.c "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_05evt.c "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_06inz.c "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_07dly.c \\\n"));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_08bnd.c "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_09alg.c "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_10asr.c "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_11mix.c "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_12jac.c "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_13opt.c "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_14lnz.c \\\n"));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_15syn.c "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_16dae.c "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_17inl.c "));
        txt = lm_756(txt, a_extraFiles);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "OFILES=$(CFILES:.c=.obj)\n",
                                    "GENERATEDFILES=$(MAINFILE) $(FILEPREFIX)_functions.h $(FILEPREFIX).makefile $(CFILES)\n",
                                    "\n",
                                    ".PHONY: $(FILEPREFIX)$(EXEEXT)\n",
                                    "\n",
                                    "# This is to make sure that "
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_*.c are always compiled.\n",
                                    ".PHONY: $(CFILES)\n",
                                    "\n",
                                    "$(FILEPREFIX)$(EXEEXT): $(MAINFILE) $(FILEPREFIX)_functions.h $(CFILES)\n"
                                }, true));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "$(CXX) /Fe$(FILEPREFIX)$(EXEEXT) $(MAINFILE) $(CFILES) $(CFLAGS) $(LDFLAGS)\n",
                                    "\n",
                                    "clean:\n"
                                }, true));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("rm -f *.obj *.lib *.exp *.c *.h *.xml *.libs *.log *.makefile *.pdb *.idb *.exe"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_757;

protected function fun_758
  input Tpl.Text in_txt;
  input String in_a_modelInfo_directory;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo_directory)
    local
      Tpl.Text txt;
      String i_modelInfo_directory;

    case ( txt,
           "" )
      then txt;

    case ( txt,
           i_modelInfo_directory )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-L\""));
        txt = Tpl.writeStr(txt, i_modelInfo_directory);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
      then txt;
  end match;
end fun_758;

protected function lm_759
  input Tpl.Text in_txt;
  input list<String> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<String> rest;
      String i_lib;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_lib :: rest )
      equation
        txt = Tpl.writeStr(txt, i_lib);
        txt = Tpl.nextIter(txt);
        txt = lm_759(txt, rest);
      then txt;
  end match;
end lm_759;

protected function fun_760
  input Tpl.Text in_txt;
  input Tpl.Text in_a_dirExtra;
  input Tpl.Text in_a_libsStr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_dirExtra, in_a_libsStr)
    local
      Tpl.Text txt;
      Tpl.Text a_libsStr;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           a_libsStr )
      equation
        txt = Tpl.writeText(txt, a_libsStr);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_760;

protected function fun_761
  input Tpl.Text in_txt;
  input Tpl.Text in_a_dirExtra;
  input Tpl.Text in_a_libsStr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_dirExtra, in_a_libsStr)
    local
      Tpl.Text txt;
      Tpl.Text a_libsStr;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           _ )
      then txt;

    case ( txt,
           _,
           a_libsStr )
      equation
        txt = Tpl.writeText(txt, a_libsStr);
      then txt;
  end match;
end fun_761;

protected function fun_762
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-lParModelicaExpl -lOpenCL"));
      then txt;
  end match;
end fun_762;

protected function fun_763
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("--stack,16777216,"));
      then txt;
  end match;
end fun_763;

protected function fun_764
  input Tpl.Text in_txt;
  input String in_a_s_method;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_s_method)
    local
      Tpl.Text txt;

    case ( txt,
           "dassljac" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-D_OMC_JACOBIAN "));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_764;

protected function fun_765
  input Tpl.Text in_txt;
  input Option<SimCode.SimulationSettings> in_a_sopt;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_sopt)
    local
      Tpl.Text txt;
      String i_s_method;

    case ( txt,
           SOME(SimCode.SIMULATION_SETTINGS(method = i_s_method)) )
      equation
        txt = fun_764(txt, i_s_method);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_765;

protected function fun_766
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_makefileParams_ccompiler;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_makefileParams_ccompiler)
    local
      Tpl.Text txt;
      String a_makefileParams_ccompiler;

    case ( txt,
           false,
           a_makefileParams_ccompiler )
      equation
        txt = Tpl.writeStr(txt, a_makefileParams_ccompiler);
      then txt;

    case ( txt,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("g++"));
      then txt;
  end match;
end fun_766;

protected function fun_767
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("$(OMC_CFLAGS_OPTIMIZATION)"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-O0"));
      then txt;
  end match;
end fun_767;

protected function fun_768
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" -g"));
      then txt;
  end match;
end fun_768;

protected function fun_769
  input Tpl.Text in_txt;
  input Option<SimCode.SimulationSettings> in_a_sopt;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_sopt)
    local
      Tpl.Text txt;
      String i_s_cflags;

    case ( txt,
           SOME(SimCode.SIMULATION_SETTINGS(cflags = i_s_cflags)) )
      equation
        txt = Tpl.writeStr(txt, i_s_cflags);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_769;

protected function fun_770
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_makefileParams_omhome;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_makefileParams_omhome)
    local
      Tpl.Text txt;
      String a_makefileParams_omhome;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_makefileParams_omhome )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("OMC_EMCC_PRE_JS="));
        txt = Tpl.writeStr(txt, a_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/lib/"));
        txt = Tpl.writeStr(txt, Autoconf.triple);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/omc/emcc/pre.js"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;
  end match;
end fun_770;

protected function lm_771
  input Tpl.Text in_txt;
  input list<String> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<String> rest;
      String i_it;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_it :: rest )
      equation
        txt = Tpl.writeStr(txt, i_it);
        txt = Tpl.nextIter(txt);
        txt = lm_771(txt, rest);
      then txt;
  end match;
end lm_771;

protected function fun_772
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" -DOMC_EMCC"));
      then txt;
  end match;
end fun_772;

protected function fun_773
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" -DOMC_GENERATE_RELOCATABLE_CODE"));
      then txt;
  end match;
end fun_773;

protected function fun_774
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_makefileParams_ldflags;
  input Tpl.Text in_a_ParModelicaExpLibs;
  input Tpl.Text in_a_ExtraStack;
  input String in_a_makefileParams_omhome;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_makefileParams_ldflags, in_a_ParModelicaExpLibs, in_a_ExtraStack, in_a_makefileParams_omhome)
    local
      Tpl.Text txt;
      String a_makefileParams_ldflags;
      Tpl.Text a_ParModelicaExpLibs;
      Tpl.Text a_ExtraStack;
      String a_makefileParams_omhome;

    case ( txt,
           false,
           a_makefileParams_ldflags,
           a_ParModelicaExpLibs,
           a_ExtraStack,
           a_makefileParams_omhome )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-L\""));
        txt = Tpl.writeStr(txt, a_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/lib/"));
        txt = Tpl.writeStr(txt, Autoconf.triple);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/omc\" -L\""));
        txt = Tpl.writeStr(txt, a_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/lib\" -Wl,"));
        txt = Tpl.writeText(txt, a_ExtraStack);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-rpath,\""));
        txt = Tpl.writeStr(txt, a_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/lib/"));
        txt = Tpl.writeStr(txt, Autoconf.triple);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/omc\" -Wl,-rpath,\""));
        txt = Tpl.writeStr(txt, a_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/lib\" "));
        txt = Tpl.writeText(txt, a_ParModelicaExpLibs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeStr(txt, a_makefileParams_ldflags);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" $(RUNTIME_LIBS) "));
      then txt;

    case ( txt,
           _,
           _,
           _,
           _,
           a_makefileParams_omhome )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-L\'"));
        txt = Tpl.writeStr(txt, a_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/lib/"));
        txt = Tpl.writeStr(txt, Autoconf.triple);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/omc/emcc\' -lblas -llapack -lexpat -lSimulationRuntimeC -s TOTAL_MEMORY=805306368 -s OUTLINING_LIMIT=20000 --pre-js $(OMC_EMCC_PRE_JS)"));
      then txt;
  end match;
end fun_774;

protected function lm_775
  input Tpl.Text in_txt;
  input list<String> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<String> rest;
      String i_extraFile;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_extraFile :: rest )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\\"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("  "));
        txt = Tpl.writeStr(txt, i_extraFile);
        txt = Tpl.popBlock(txt);
        txt = lm_775(txt, rest);
      then txt;
  end match;
end lm_775;

protected function fun_776
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("$(CC)"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("$(CXX)"));
      then txt;
  end match;
end fun_776;

protected function fun_777
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_fileNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_fileNamePrefix)
    local
      Tpl.Text txt;
      String a_fileNamePrefix;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_fileNamePrefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("rm -f "));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
      then txt;
  end match;
end fun_777;

protected function fun_778
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_fileNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_fileNamePrefix)
    local
      Tpl.Text txt;
      String a_fileNamePrefix;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_fileNamePrefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("ln -s "));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_node.js "));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
      then txt;
  end match;
end fun_778;

protected function fun_779
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_fileNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_fileNamePrefix)
    local
      Tpl.Text txt;
      String a_fileNamePrefix;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_fileNamePrefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("chmod +x "));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_node.js"));
      then txt;
  end match;
end fun_779;

protected function fun_780
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input list<String> in_a_extraFiles;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode, in_a_extraFiles)
    local
      Tpl.Text txt;
      list<String> a_extraFiles;
      String i_fileNamePrefix;
      String i_makefileParams_ldflags;
      String i_makefileParams_runtimelibs;
      Integer i_varInfo_numStringAlgVars;
      Integer i_maxDelayedIndex;
      Integer i_varInfo_numNonLinearSystems;
      Integer i_varInfo_numLinearSystems;
      Integer i_varInfo_numMixedSystems;
      SimCode.SimCode i_simCode;
      list<String> i_makefileParams_includes;
      String i_makefileParams_omhome;
      String i_makefileParams_cflags;
      String i_makefileParams_dllext;
      String i_makefileParams_exeext;
      String i_makefileParams_linker;
      String i_makefileParams_cxxcompiler;
      String i_makefileParams_ccompiler;
      Option<SimCode.SimulationSettings> i_sopt;
      String i_makefileParams_platform;
      list<String> i_makefileParams_libs;
      String i_modelInfo_directory;
      Boolean ret_32;
      String ret_31;
      Boolean ret_30;
      String ret_29;
      Boolean ret_28;
      String ret_27;
      Boolean ret_26;
      String ret_25;
      Boolean ret_24;
      String ret_23;
      Boolean ret_22;
      Boolean ret_21;
      String ret_20;
      Boolean ret_19;
      String ret_18;
      Boolean ret_17;
      Boolean ret_16;
      Boolean ret_15;
      Boolean ret_14;
      Boolean ret_13;
      Boolean ret_12;
      Boolean ret_11;
      Tpl.Text l_extraCflags;
      Boolean ret_9;
      Boolean ret_8;
      Boolean ret_7;
      Tpl.Text l_ExtraStack;
      Boolean ret_5;
      Tpl.Text l_ParModelicaExpLibs;
      Tpl.Text l_libsPos2;
      Tpl.Text l_libsPos1;
      Tpl.Text l_libsStr;
      Tpl.Text l_dirExtra;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(varInfo = SimCode.VARINFO(numMixedSystems = i_varInfo_numMixedSystems, numLinearSystems = i_varInfo_numLinearSystems, numNonLinearSystems = i_varInfo_numNonLinearSystems, numStringAlgVars = i_varInfo_numStringAlgVars), directory = i_modelInfo_directory), delayedExps = SimCode.DELAYED_EXPRESSIONS(maxDelayedIndex = i_maxDelayedIndex), makefileParams = SimCodeFunction.MAKEFILE_PARAMS(libs = i_makefileParams_libs, platform = i_makefileParams_platform, ccompiler = i_makefileParams_ccompiler, cxxcompiler = i_makefileParams_cxxcompiler, linker = i_makefileParams_linker, exeext = i_makefileParams_exeext, dllext = i_makefileParams_dllext, cflags = i_makefileParams_cflags, omhome = i_makefileParams_omhome, includes = i_makefileParams_includes, runtimelibs = i_makefileParams_runtimelibs, ldflags = i_makefileParams_ldflags), simulationSettingsOpt = i_sopt, fileNamePrefix = i_fileNamePrefix)),
           a_extraFiles )
      equation
        l_dirExtra = fun_758(Tpl.emptyTxt, i_modelInfo_directory);
        l_libsStr = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(" ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_libsStr = lm_759(l_libsStr, i_makefileParams_libs);
        l_libsStr = Tpl.popIter(l_libsStr);
        l_libsPos1 = fun_760(Tpl.emptyTxt, l_dirExtra, l_libsStr);
        l_libsPos2 = fun_761(Tpl.emptyTxt, l_dirExtra, l_libsStr);
        ret_5 = Config.acceptParModelicaGrammar();
        l_ParModelicaExpLibs = fun_762(Tpl.emptyTxt, ret_5);
        ret_7 = stringEq(i_makefileParams_platform, "win32");
        ret_8 = stringEq(i_makefileParams_platform, "win64");
        ret_9 = boolOr(ret_7, ret_8);
        l_ExtraStack = fun_763(Tpl.emptyTxt, ret_9);
        l_extraCflags = fun_765(Tpl.emptyTxt, i_sopt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "# Makefile generated by OpenModelica\n",
                                    "# Platform: "
                                }, false));
        txt = Tpl.writeStr(txt, i_makefileParams_platform);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "# Simulations use -O3 by default\n",
                                    "CC="
                                }, false));
        ret_11 = Config.acceptParModelicaGrammar();
        txt = fun_766(txt, ret_11, i_makefileParams_ccompiler);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("CXX="));
        txt = Tpl.writeStr(txt, i_makefileParams_cxxcompiler);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("LINK="));
        txt = Tpl.writeStr(txt, i_makefileParams_linker);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("EXEEXT="));
        txt = Tpl.writeStr(txt, i_makefileParams_exeext);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("DLLEXT="));
        txt = Tpl.writeStr(txt, i_makefileParams_dllext);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("CFLAGS_BASED_ON_INIT_FILE="));
        txt = Tpl.writeText(txt, l_extraCflags);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "# define OMC_CFLAGS_OPTIMIZATION env variable to your desired optimization level to override this\n",
                                    "OMC_CFLAGS_OPTIMIZATION=-Os\n",
                                    "DEBUG_FLAGS="
                                }, false));
        ret_12 = Testsuite.isRunning();
        ret_13 = Config.acceptMetaModelicaGrammar();
        ret_14 = Flags.isSet(Flags.GEN_DEBUG_SYMBOLS);
        ret_15 = boolOr(ret_13, ret_14);
        ret_16 = boolOr(ret_12, ret_15);
        txt = fun_767(txt, ret_16);
        ret_17 = Flags.isSet(Flags.GEN_DEBUG_SYMBOLS);
        txt = fun_768(txt, ret_17);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("CFLAGS=$(CFLAGS_BASED_ON_INIT_FILE) $(DEBUG_FLAGS) "));
        txt = Tpl.writeStr(txt, i_makefileParams_cflags);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = fun_769(txt, i_sopt);
        txt = Tpl.softNewLine(txt);
        ret_18 = Config.simCodeTarget();
        ret_19 = stringEq(ret_18, "JavaScript");
        txt = fun_770(txt, ret_19, i_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("CPPFLAGS="));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(" ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_771(txt, i_makefileParams_includes);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" -I\""));
        txt = Tpl.writeStr(txt, i_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/include/omc/c\" -I. -DOPENMODELICA_XML_FROM_FILE_AT_RUNTIME"));
        ret_20 = Config.simCodeTarget();
        ret_21 = stringEq(ret_20, "JavaScript");
        txt = fun_772(txt, ret_21);
        ret_22 = Flags.isSet(Flags.OMC_RELOCATABLE_FUNCTIONS);
        txt = fun_773(txt, ret_22);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" -DOMC_MODEL_PREFIX="));
        txt = CodegenUtilSimulation.modelNamePrefix(txt, i_simCode);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" -DOMC_NUM_MIXED_SYSTEMS="));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numMixedSystems));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" -DOMC_NUM_LINEAR_SYSTEMS="));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numLinearSystems));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" -DOMC_NUM_NONLINEAR_SYSTEMS="));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numNonLinearSystems));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" -DOMC_NDELAY_EXPRESSIONS="));
        txt = Tpl.writeStr(txt, intString(i_maxDelayedIndex));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" -DOMC_NVAR_STRING="));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numStringAlgVars));
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "# define OMC_LDFLAGS_LINK_TYPE env variable to \"static\" to override this\n",
                                    "OMC_LDFLAGS_LINK_TYPE=dynamic\n",
                                    "RUNTIME_LIBS="
                                }, false));
        txt = Tpl.writeStr(txt, i_makefileParams_runtimelibs);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("LDFLAGS="));
        ret_23 = Config.simCodeTarget();
        ret_24 = stringEq(ret_23, "JavaScript");
        txt = fun_774(txt, ret_24, i_makefileParams_ldflags, l_ParModelicaExpLibs, l_ExtraStack, i_makefileParams_omhome);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("DIREXTRA="));
        ret_25 = System.stringReplace(Tpl.textString(l_dirExtra), "#", "\\#");
        txt = Tpl.writeStr(txt, ret_25);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("MAINFILE="));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ".c\n",
                                    "MAINOBJ="
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ".o\n",
                                    "CFILES="
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_functions.c "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_records.c \\\n"));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_01exo.c "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_02nls.c "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_03lsy.c "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_04set.c "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_05evt.c "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_06inz.c "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_07dly.c \\\n"));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_08bnd.c "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_09alg.c "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_10asr.c "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_11mix.c "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_12jac.c "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_13opt.c "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_14lnz.c \\\n"));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_15syn.c "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_16dae.c "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_17inl.c "));
        txt = lm_775(txt, a_extraFiles);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "OFILES=$(CFILES:.c=.o)\n",
                                    "GENERATEDFILES=$(MAINFILE) "
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".makefile "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_literals.h "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_functions.h $(CFILES)\n",
                                    "\n",
                                    ".PHONY: omc_main_target clean bundle\n",
                                    "\n",
                                    "# This is to make sure that "
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_*.c are always compiled.\n",
                                    ".PHONY: $(CFILES)\n",
                                    "\n",
                                    "omc_main_target: $(MAINOBJ) "
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_functions.h "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_literals.h $(OFILES)\n"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        ret_26 = Flags.getConfigBool(Flags.PARMODAUTO);
        txt = fun_776(txt, ret_26);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" -I. -o "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("$(EXEEXT) $(MAINOBJ) $(OFILES) $(CPPFLAGS) $(DIREXTRA) "));
        txt = Tpl.writeText(txt, l_libsPos1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, l_libsPos2);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" $(CFLAGS) $(CPPFLAGS) $(LDFLAGS)\n"));
        ret_27 = Config.simCodeTarget();
        ret_28 = stringEq(ret_27, "JavaScript");
        txt = fun_777(txt, ret_28, i_fileNamePrefix);
        txt = Tpl.softNewLine(txt);
        ret_29 = Config.simCodeTarget();
        ret_30 = stringEq(ret_29, "JavaScript");
        txt = fun_778(txt, ret_30, i_fileNamePrefix);
        txt = Tpl.softNewLine(txt);
        ret_31 = Config.simCodeTarget();
        ret_32 = stringEq(ret_31, "JavaScript");
        txt = fun_779(txt, ret_32, i_fileNamePrefix);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("clean:\n"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("@rm -f "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_records.o $(MAINOBJ)\n",
                                    "\n",
                                    "bundle:\n"
                                }, true));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("@tar -cvf "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_Files.tar $(GENERATEDFILES)"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_780;

protected function fun_781
  input Tpl.Text in_txt;
  input String in_mArg;
  input String in_a_target;
  input SimCode.SimCode in_a_simCode;
  input list<String> in_a_extraFiles;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_target, in_a_simCode, in_a_extraFiles)
    local
      Tpl.Text txt;
      String a_target;
      SimCode.SimCode a_simCode;
      list<String> a_extraFiles;
      Tpl.Text txt_0;

    case ( txt,
           "msvc",
           _,
           a_simCode,
           a_extraFiles )
      equation
        txt = fun_757(txt, a_simCode, a_extraFiles);
      then txt;

    case ( txt,
           "gcc",
           _,
           a_simCode,
           a_extraFiles )
      equation
        txt = fun_780(txt, a_simCode, a_extraFiles);
      then txt;

    case ( txt,
           _,
           a_target,
           _,
           _ )
      equation
        txt_0 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("Target "));
        txt_0 = Tpl.writeStr(txt_0, a_target);
        txt_0 = Tpl.writeTok(txt_0, Tpl.ST_STRING(" is not handled!"));
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 6244, 9), Tpl.textString(txt_0));
      then txt;
  end match;
end fun_781;

public function simulationMakefile
  input Tpl.Text txt;
  input String a_target;
  input SimCode.SimCode a_simCode;
  input list<String> a_extraFiles;

  output Tpl.Text out_txt;
protected
  String str_1;
  Tpl.Text txt_0;
algorithm
  txt_0 := CodegenUtil.getGeneralTarget(Tpl.emptyTxt, a_target);
  str_1 := Tpl.textString(txt_0);
  out_txt := fun_781(txt, str_1, a_target, a_simCode, a_extraFiles);
end simulationMakefile;

public function crefM
  input Tpl.Text in_txt;
  input DAE.ComponentRef in_a_cr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_cr)
    local
      Tpl.Text txt;
      DAE.ComponentRef i_cr;

    case ( txt,
           (i_cr as DAE.CREF_IDENT(ident = "xloc")) )
      equation
        txt = CodegenUtil.crefStr(txt, i_cr);
      then txt;

    case ( txt,
           DAE.CREF_IDENT(ident = "time") )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("time"));
      then txt;

    case ( txt,
           i_cr )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("P"));
        txt = CodegenCFunctions.crefToMStr(txt, i_cr);
      then txt;
  end match;
end crefM;

public function simEqAttrIsDiscreteKind
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_eq)
    local
      Tpl.Text txt;
      BackendDAE.EquationAttributes i_eqAttr;

    case ( txt,
           SimCode.SES_RESIDUAL(eqAttr = i_eqAttr) )
      equation
        txt = eqAttributeIsDiscreteKind(txt, i_eqAttr);
      then txt;

    case ( txt,
           SimCode.SES_SIMPLE_ASSIGN(eqAttr = i_eqAttr) )
      equation
        txt = eqAttributeIsDiscreteKind(txt, i_eqAttr);
      then txt;

    case ( txt,
           SimCode.SES_SIMPLE_ASSIGN_CONSTRAINTS(eqAttr = i_eqAttr) )
      equation
        txt = eqAttributeIsDiscreteKind(txt, i_eqAttr);
      then txt;

    case ( txt,
           SimCode.SES_ARRAY_CALL_ASSIGN(eqAttr = i_eqAttr) )
      equation
        txt = eqAttributeIsDiscreteKind(txt, i_eqAttr);
      then txt;

    case ( txt,
           SimCode.SES_IFEQUATION(eqAttr = i_eqAttr) )
      equation
        txt = eqAttributeIsDiscreteKind(txt, i_eqAttr);
      then txt;

    case ( txt,
           SimCode.SES_ALGORITHM(eqAttr = i_eqAttr) )
      equation
        txt = eqAttributeIsDiscreteKind(txt, i_eqAttr);
      then txt;

    case ( txt,
           SimCode.SES_LINEAR(eqAttr = i_eqAttr) )
      equation
        txt = eqAttributeIsDiscreteKind(txt, i_eqAttr);
      then txt;

    case ( txt,
           SimCode.SES_NONLINEAR(eqAttr = i_eqAttr) )
      equation
        txt = eqAttributeIsDiscreteKind(txt, i_eqAttr);
      then txt;

    case ( txt,
           SimCode.SES_MIXED(eqAttr = i_eqAttr) )
      equation
        txt = eqAttributeIsDiscreteKind(txt, i_eqAttr);
      then txt;

    case ( txt,
           SimCode.SES_WHEN(eqAttr = i_eqAttr) )
      equation
        txt = eqAttributeIsDiscreteKind(txt, i_eqAttr);
      then txt;

    case ( txt,
           SimCode.SES_FOR_LOOP(eqAttr = i_eqAttr) )
      equation
        txt = eqAttributeIsDiscreteKind(txt, i_eqAttr);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end simEqAttrIsDiscreteKind;

public function eqAttributeIsDiscreteKind
  input Tpl.Text in_txt;
  input BackendDAE.EquationAttributes in_a_eqAtt;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_eqAtt)
    local
      Tpl.Text txt;
      BackendDAE.EquationKind i_kind;

    case ( txt,
           BackendDAE.EQUATION_ATTRIBUTES(kind = i_kind) )
      equation
        txt = eqIsDiscreteKind(txt, i_kind);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end eqAttributeIsDiscreteKind;

public function eqIsDiscreteKind
  input Tpl.Text in_txt;
  input BackendDAE.EquationKind in_a_eqKind;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_eqKind)
    local
      Tpl.Text txt;

    case ( txt,
           BackendDAE.DISCRETE_EQUATION() )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("1"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("0"));
      then txt;
  end match;
end eqIsDiscreteKind;

public function simEqAttrEval
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_eq)
    local
      Tpl.Text txt;
      BackendDAE.EquationAttributes i_eqAttr;

    case ( txt,
           SimCode.SES_RESIDUAL(eqAttr = i_eqAttr) )
      equation
        txt = eqAttributesEval(txt, i_eqAttr);
      then txt;

    case ( txt,
           SimCode.SES_SIMPLE_ASSIGN(eqAttr = i_eqAttr) )
      equation
        txt = eqAttributesEval(txt, i_eqAttr);
      then txt;

    case ( txt,
           SimCode.SES_SIMPLE_ASSIGN_CONSTRAINTS(eqAttr = i_eqAttr) )
      equation
        txt = eqAttributesEval(txt, i_eqAttr);
      then txt;

    case ( txt,
           SimCode.SES_ARRAY_CALL_ASSIGN(eqAttr = i_eqAttr) )
      equation
        txt = eqAttributesEval(txt, i_eqAttr);
      then txt;

    case ( txt,
           SimCode.SES_IFEQUATION(eqAttr = i_eqAttr) )
      equation
        txt = eqAttributesEval(txt, i_eqAttr);
      then txt;

    case ( txt,
           SimCode.SES_ALGORITHM(eqAttr = i_eqAttr) )
      equation
        txt = eqAttributesEval(txt, i_eqAttr);
      then txt;

    case ( txt,
           SimCode.SES_LINEAR(eqAttr = i_eqAttr) )
      equation
        txt = eqAttributesEval(txt, i_eqAttr);
      then txt;

    case ( txt,
           SimCode.SES_NONLINEAR(eqAttr = i_eqAttr) )
      equation
        txt = eqAttributesEval(txt, i_eqAttr);
      then txt;

    case ( txt,
           SimCode.SES_MIXED(eqAttr = i_eqAttr) )
      equation
        txt = eqAttributesEval(txt, i_eqAttr);
      then txt;

    case ( txt,
           SimCode.SES_WHEN(eqAttr = i_eqAttr) )
      equation
        txt = eqAttributesEval(txt, i_eqAttr);
      then txt;

    case ( txt,
           SimCode.SES_FOR_LOOP(eqAttr = i_eqAttr) )
      equation
        txt = eqAttributesEval(txt, i_eqAttr);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end simEqAttrEval;

public function eqAttributesEval
  input Tpl.Text in_txt;
  input BackendDAE.EquationAttributes in_a_eqAtt;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_eqAtt)
    local
      Tpl.Text txt;
      BackendDAE.EvaluationStages i_evalStages;

    case ( txt,
           BackendDAE.EQUATION_ATTRIBUTES(evalStages = i_evalStages) )
      equation
        txt = eqEval(txt, i_evalStages);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end eqAttributesEval;

protected function fun_789
  input Tpl.Text in_txt;
  input Boolean in_a_dynamicEval;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_dynamicEval)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("+1"));
      then txt;
  end match;
end fun_789;

protected function fun_790
  input Tpl.Text in_txt;
  input Boolean in_a_algebraicEval;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_algebraicEval)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("+2"));
      then txt;
  end match;
end fun_790;

protected function fun_791
  input Tpl.Text in_txt;
  input Boolean in_a_zerocrossEval;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_zerocrossEval)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("+4"));
      then txt;
  end match;
end fun_791;

protected function fun_792
  input Tpl.Text in_txt;
  input Boolean in_a_discreteEval;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_discreteEval)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("+8"));
      then txt;
  end match;
end fun_792;

public function eqEval
  input Tpl.Text in_txt;
  input BackendDAE.EvaluationStages in_a_eqEval;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_eqEval)
    local
      Tpl.Text txt;
      Boolean i_discreteEval;
      Boolean i_zerocrossEval;
      Boolean i_algebraicEval;
      Boolean i_dynamicEval;
      Tpl.Text l_di;
      Tpl.Text l_zc;
      Tpl.Text l_al;
      Tpl.Text l_dy;

    case ( txt,
           BackendDAE.EVALUATION_STAGES(dynamicEval = i_dynamicEval, algebraicEval = i_algebraicEval, zerocrossEval = i_zerocrossEval, discreteEval = i_discreteEval) )
      equation
        l_dy = fun_789(Tpl.emptyTxt, i_dynamicEval);
        l_al = fun_790(Tpl.emptyTxt, i_algebraicEval);
        l_zc = fun_791(Tpl.emptyTxt, i_zerocrossEval);
        l_di = fun_792(Tpl.emptyTxt, i_discreteEval);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("evalStages = 0"));
        txt = Tpl.writeText(txt, l_dy);
        txt = Tpl.writeText(txt, l_al);
        txt = Tpl.writeText(txt, l_zc);
        txt = Tpl.writeText(txt, l_di);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end eqEval;

protected function lm_794
  input Tpl.Text in_txt;
  input list<DAE.ClassAttributes> in_items;
  input String in_a_modelNamePrefixStr;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefixStr, in_a_simCode)
    local
      Tpl.Text txt;
      list<DAE.ClassAttributes> rest;
      String a_modelNamePrefixStr;
      SimCode.SimCode a_simCode;
      DAE.ClassAttributes i_classAttribute;

    case ( txt,
           {},
           _,
           _ )
      then txt;

    case ( txt,
           i_classAttribute :: rest,
           a_modelNamePrefixStr,
           a_simCode )
      equation
        txt = optimizationComponents1(txt, i_classAttribute, a_simCode, a_modelNamePrefixStr);
        txt = Tpl.nextIter(txt);
        txt = lm_794(txt, rest, a_modelNamePrefixStr, a_simCode);
      then txt;
  end match;
end lm_794;

public function optimizationComponents
  input Tpl.Text in_txt;
  input list<DAE.ClassAttributes> in_a_classAttributes;
  input SimCode.SimCode in_a_simCode;
  input String in_a_modelNamePrefixStr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_classAttributes, in_a_simCode, in_a_modelNamePrefixStr)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      String a_modelNamePrefixStr;
      list<DAE.ClassAttributes> i_classAttributes;
      Tpl.Text l_fail;

    case ( txt,
           {},
           _,
           a_modelNamePrefixStr )
      equation
        l_fail = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("throwStreamPrint(NULL, \"The model was not compiled with -g=Optimica and the corresponding goal function. The optimization solver cannot be used.\");"));
        l_fail = Tpl.writeTok(l_fail, Tpl.ST_NEW_LINE());
        l_fail = Tpl.writeTok(l_fail, Tpl.ST_STRING("return 0;"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("int "));
        txt = CodegenUtil.symbolName(txt, a_modelNamePrefixStr, "mayer");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("(DATA* data, modelica_real** res,short *i) {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_fail);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "int "
                                }, false));
        txt = CodegenUtil.symbolName(txt, a_modelNamePrefixStr, "lagrange");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("(DATA* data, modelica_real** res, short * i1, short*i2) {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_fail);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "int "
                                }, false));
        txt = CodegenUtil.symbolName(txt, a_modelNamePrefixStr, "pickUpBoundsForInputsInOptimization");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("(DATA* data, modelica_real* min, modelica_real* max, modelica_real*nominal, modelica_boolean *useNominal, char ** name, modelica_real * start, modelica_real * startTimeOpt) {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_fail);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "int "
                                }, false));
        txt = CodegenUtil.symbolName(txt, a_modelNamePrefixStr, "setInputData");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("(DATA *data, const modelica_boolean file) {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_fail);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "int "
                                }, false));
        txt = CodegenUtil.symbolName(txt, a_modelNamePrefixStr, "getTimeGrid");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("(DATA *data, modelica_integer * nsi, modelica_real**t) {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_fail);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;

    case ( txt,
           i_classAttributes,
           a_simCode,
           a_modelNamePrefixStr )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_794(txt, i_classAttributes, a_modelNamePrefixStr, a_simCode);
        txt = Tpl.popIter(txt);
      then txt;
  end match;
end optimizationComponents;

protected function fun_796
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;
      DAE.ComponentRef ret_2;
      DAE.ComponentRef ret_1;
      DAE.ComponentRef ret_0;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("*index_Dres = "));
        ret_0 = ComponentReference.makeUntypedCrefIdent(BackendDAE.optimizationMayerTermName);
        ret_1 = ComponentReference.makeUntypedCrefIdent("dummyVarC");
        ret_2 = ComponentReference.createDifferentiatedCrefName(ret_0, ret_1, "C");
        txt = CodegenCFunctions.crefToIndex(txt, ret_2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "return 0;"
                                }, false));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_796;

protected function fun_797
  input Tpl.Text in_txt;
  input Option<DAE.Exp> in_a_objetiveE;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_objetiveE)
    local
      Tpl.Text txt;
      DAE.ComponentRef ret_6;
      Boolean ret_5;
      Tpl.Text txt_4;
      DAE.ComponentRef ret_3;
      DAE.ComponentRef ret_2;
      DAE.ComponentRef ret_1;
      Tpl.Text l_setMayerIndex;

    case ( txt,
           SOME(_) )
      equation
        ret_1 = ComponentReference.makeUntypedCrefIdent(BackendDAE.optimizationMayerTermName);
        ret_2 = ComponentReference.makeUntypedCrefIdent("dummyVarC");
        ret_3 = ComponentReference.createDifferentiatedCrefName(ret_1, ret_2, "C");
        txt_4 = CodegenCFunctions.crefToIndex(Tpl.emptyTxt, ret_3);
        ret_5 = stringEq(Tpl.textString(txt_4), "-2");
        l_setMayerIndex = fun_796(Tpl.emptyTxt, ret_5);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("*res =  &"));
        ret_6 = ComponentReference.makeUntypedCrefIdent(BackendDAE.optimizationMayerTermName);
        txt = CodegenCFunctions.cref(txt, ret_6);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.writeText(txt, l_setMayerIndex);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_797;

protected function fun_798
  input Tpl.Text in_txt;
  input Option<DAE.Exp> in_a_startTimeE;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_a_startTimeE, in_a_auxFunction, in_a_varDecls, in_a_preExp)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      DAE.Exp i_exp;
      Tpl.Text l_startTimeOptExp;

    case ( txt,
           SOME(i_exp),
           a_auxFunction,
           a_varDecls,
           a_preExp )
      equation
        (l_startTimeOptExp, a_preExp, a_varDecls, a_auxFunction) = CodegenCFunctions.daeExp(Tpl.emptyTxt, i_exp, SimCodeFunction.contextOther, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("*startTimeOpt = "));
        txt = Tpl.writeText(txt, l_startTimeOptExp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           _,
           a_auxFunction,
           a_varDecls,
           a_preExp )
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end fun_798;

protected function fun_799
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;
      DAE.ComponentRef ret_5;
      DAE.ComponentRef ret_4;
      DAE.ComponentRef ret_3;
      DAE.ComponentRef ret_2;
      DAE.ComponentRef ret_1;
      DAE.ComponentRef ret_0;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("*index_DresB = "));
        ret_0 = ComponentReference.makeUntypedCrefIdent(BackendDAE.optimizationLagrangeTermName);
        ret_1 = ComponentReference.makeUntypedCrefIdent("dummyVarB");
        ret_2 = ComponentReference.createDifferentiatedCrefName(ret_0, ret_1, "B");
        txt = CodegenCFunctions.crefToIndex(txt, ret_2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "*index_DresC = "
                                }, false));
        ret_3 = ComponentReference.makeUntypedCrefIdent(BackendDAE.optimizationLagrangeTermName);
        ret_4 = ComponentReference.makeUntypedCrefIdent("dummyVarC");
        ret_5 = ComponentReference.createDifferentiatedCrefName(ret_3, ret_4, "C");
        txt = CodegenCFunctions.crefToIndex(txt, ret_5);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "return 0;"
                                }, false));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_799;

protected function fun_800
  input Tpl.Text in_txt;
  input Option<DAE.Exp> in_a_objectiveIntegrandE;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_objectiveIntegrandE)
    local
      Tpl.Text txt;
      DAE.ComponentRef ret_6;
      Boolean ret_5;
      Tpl.Text txt_4;
      DAE.ComponentRef ret_3;
      DAE.ComponentRef ret_2;
      DAE.ComponentRef ret_1;
      Tpl.Text l_setLagrangeIndex;

    case ( txt,
           SOME(_) )
      equation
        ret_1 = ComponentReference.makeUntypedCrefIdent(BackendDAE.optimizationLagrangeTermName);
        ret_2 = ComponentReference.makeUntypedCrefIdent("dummyVarB");
        ret_3 = ComponentReference.createDifferentiatedCrefName(ret_1, ret_2, "B");
        txt_4 = CodegenCFunctions.crefToIndex(Tpl.emptyTxt, ret_3);
        ret_5 = stringEq(Tpl.textString(txt_4), "-2");
        l_setLagrangeIndex = fun_799(Tpl.emptyTxt, ret_5);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("*res =  &"));
        ret_6 = ComponentReference.makeUntypedCrefIdent(BackendDAE.optimizationLagrangeTermName);
        txt = CodegenCFunctions.cref(txt, ret_6);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.writeText(txt, l_setLagrangeIndex);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_800;

protected function lm_801
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      DAE.ComponentRef i_cr;
      DAE.ComponentRef i_name;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(varKind = BackendDAE.OPT_LOOP_INPUT(replaceExp = i_cr), name = i_name) :: rest )
      equation
        txt = CodegenCFunctions.cref(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = CodegenCFunctions.cref(txt, i_cr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" ;"));
        txt = Tpl.nextIter(txt);
        txt = lm_801(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_801(txt, rest);
      then txt;
  end match;
end lm_801;

protected function lm_802
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Integer x_i0;
      DAE.ComponentRef i_name;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(name = i_name) :: rest )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("data->simulationInfo->inputVars["));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = "));
        txt = CodegenCFunctions.cref(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        txt = lm_802(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_802(txt, rest);
      then txt;
  end match;
end lm_802;

protected function fun_803
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> i_vars_inputVars;

    case ( txt,
           SimCode.MODELINFO(vars = SimCodeVar.SIMVARS(inputVars = i_vars_inputVars)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("  if(file){\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_801(txt, i_vars_inputVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("}\n"));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_802(txt, i_vars_inputVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_803;

protected function fun_804
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      SimCode.ModelInfo i_modelInfo;

    case ( txt,
           SimCode.SIMCODE(modelInfo = i_modelInfo) )
      equation
        txt = fun_803(txt, i_modelInfo);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_804;

protected function lm_805
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(varKind = BackendDAE.OPT_TGRID()) :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("+1"));
        txt = Tpl.nextIter(txt);
        txt = lm_805(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_805(txt, rest);
      then txt;
  end match;
end lm_805;

protected function lm_806
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Integer x_i0;
      DAE.ComponentRef i_name;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(varKind = BackendDAE.OPT_TGRID(), name = i_name) :: rest )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(*t)["));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = "));
        txt = CodegenCFunctions.cref(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        txt = lm_806(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_806(txt, rest);
      then txt;
  end match;
end lm_806;

protected function fun_807
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> i_vars_paramVars;

    case ( txt,
           SimCode.MODELINFO(vars = SimCodeVar.SIMVARS(paramVars = i_vars_paramVars)) )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("*nsi=(-1 "));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(" ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_805(txt, i_vars_paramVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ");\n",
                                    "*t = (modelica_real*) malloc((*nsi+1)*sizeof(modelica_real));\n"
                                }, true));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_806(txt, i_vars_paramVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_807;

protected function fun_808
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      SimCode.ModelInfo i_modelInfo;

    case ( txt,
           SimCode.SIMCODE(modelInfo = i_modelInfo) )
      equation
        txt = fun_807(txt, i_modelInfo);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_808;

protected function lm_809
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Integer x_i0;
      DAE.ComponentRef i_name;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(name = i_name) :: rest )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("min["));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = "));
        txt = CodegenCFunctions.crefAttributes(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".min;"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("max["));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = "));
        txt = CodegenCFunctions.crefAttributes(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".max;"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("nominal["));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = "));
        txt = CodegenCFunctions.crefAttributes(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".nominal;"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("useNominal["));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = "));
        txt = CodegenCFunctions.crefAttributes(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".useNominal;"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("name["));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] =(char *) "));
        txt = CodegenCFunctions.crefVarInfo(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".name;"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("start["));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = "));
        txt = CodegenCFunctions.crefAttributes(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".start;"));
        txt = Tpl.nextIter(txt);
        txt = lm_809(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_809(txt, rest);
      then txt;
  end match;
end lm_809;

protected function fun_810
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> i_vars_inputVars;

    case ( txt,
           SimCode.MODELINFO(vars = SimCodeVar.SIMVARS(inputVars = i_vars_inputVars)) )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_809(txt, i_vars_inputVars);
        txt = Tpl.popIter(txt);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_810;

protected function fun_811
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      SimCode.ModelInfo i_modelInfo;

    case ( txt,
           SimCode.SIMCODE(modelInfo = i_modelInfo) )
      equation
        txt = fun_810(txt, i_modelInfo);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_811;

public function optimizationComponents1
  input Tpl.Text in_txt;
  input DAE.ClassAttributes in_a_classAttribute;
  input SimCode.SimCode in_a_simCode;
  input String in_a_modelNamePrefixStr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_classAttribute, in_a_simCode, in_a_modelNamePrefixStr)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      String a_modelNamePrefixStr;
      Option<DAE.Exp> i_objectiveIntegrandE;
      Option<DAE.Exp> i_startTimeE;
      Option<DAE.Exp> i_objetiveE;
      Tpl.Text l_inputBounds;
      Tpl.Text l_getTG;
      Tpl.Text l_setInput;
      Tpl.Text l_objectiveIntegrand;
      Tpl.Text l_startTimeOpt;
      Tpl.Text l_objectiveFunction;
      Tpl.Text l_auxFunction;
      Tpl.Text l_preExp1;
      Tpl.Text l_varDecls1;
      Tpl.Text l_preExp;
      Tpl.Text l_varDecls;

    case ( txt,
           DAE.OPTIMIZATION_ATTRS(objetiveE = i_objetiveE, startTimeE = i_startTimeE, objectiveIntegrandE = i_objectiveIntegrandE),
           a_simCode,
           a_modelNamePrefixStr )
      equation
        l_varDecls = Tpl.emptyTxt;
        l_preExp = Tpl.emptyTxt;
        l_varDecls1 = Tpl.emptyTxt;
        l_preExp1 = Tpl.emptyTxt;
        l_auxFunction = Tpl.emptyTxt;
        l_objectiveFunction = fun_797(Tpl.emptyTxt, i_objetiveE);
        (l_startTimeOpt, l_auxFunction, l_varDecls, l_preExp) = fun_798(Tpl.emptyTxt, i_startTimeE, l_auxFunction, l_varDecls, l_preExp);
        l_objectiveIntegrand = fun_800(Tpl.emptyTxt, i_objectiveIntegrandE);
        l_setInput = fun_804(Tpl.emptyTxt, a_simCode);
        l_getTG = fun_808(Tpl.emptyTxt, a_simCode);
        l_inputBounds = fun_811(Tpl.emptyTxt, a_simCode);
        txt = Tpl.writeText(txt, l_auxFunction);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "/* objectiveFunction */\n",
                                    "int "
                                }, false));
        txt = CodegenUtil.symbolName(txt, a_modelNamePrefixStr, "mayer");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA* data, modelica_real** res, short * index_Dres)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_varDecls);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_objectiveFunction);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("return  -1;\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "/* objectiveIntegrand */\n",
                                    "int "
                                }, false));
        txt = CodegenUtil.symbolName(txt, a_modelNamePrefixStr, "lagrange");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA* data, modelica_real** res, short * index_DresB, short *index_DresC)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_varDecls1);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_preExp1);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_objectiveIntegrand);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("return -1;\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n",
                                    "/* opt vars  */\n",
                                    "int "
                                }, false));
        txt = CodegenUtil.symbolName(txt, a_modelNamePrefixStr, "pickUpBoundsForInputsInOptimization");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA* data, modelica_real* min, modelica_real* max, modelica_real*nominal, modelica_boolean *useNominal, char ** name, modelica_real * start, modelica_real* startTimeOpt)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_inputBounds);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("*startTimeOpt = data->simulationInfo->startTime - 1.0;\n"));
        txt = Tpl.writeText(txt, l_startTimeOpt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("return 0;\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n",
                                    "int "
                                }, false));
        txt = CodegenUtil.symbolName(txt, a_modelNamePrefixStr, "setInputData");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA *data, const modelica_boolean file)\n",
                                    "{\n",
                                    " TRACE_PUSH\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeText(txt, l_setInput);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "TRACE_POP\n",
                                    "return 0;\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "int "
                                }, false));
        txt = CodegenUtil.symbolName(txt, a_modelNamePrefixStr, "getTimeGrid");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("(DATA *data, modelica_integer * nsi, modelica_real**t){\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeText(txt, l_getTG);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("return 0;\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      equation
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenC.tpl", 6476, 16), "Unknown Constraint List");
      then txt;
  end match;
end optimizationComponents1;

protected function lm_813
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input String in_a_modelNamePrefixStr;
  input list<SimCode.SimEqSystem> in_a_derivativEquations;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefixStr, in_a_derivativEquations)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      String a_modelNamePrefixStr;
      list<SimCode.SimEqSystem> a_derivativEquations;
      Integer x_i0;
      DAE.ComponentRef i_name;
      Tpl.Text txt_1;
      list<SimCode.SimEqSystem> ret_0;

    case ( txt,
           {},
           _,
           _ )
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(name = i_name) :: rest,
           a_modelNamePrefixStr,
           a_derivativEquations )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        ret_0 = SimCodeUtil.computeDependencies(a_derivativEquations, i_name);
        txt_1 = CodegenUtil.crefStr(Tpl.emptyTxt, i_name);
        txt = equationNames_Partial(txt, ret_0, a_modelNamePrefixStr, x_i0, Tpl.textString(txt_1));
        txt = Tpl.nextIter(txt);
        txt = lm_813(txt, rest, a_modelNamePrefixStr, a_derivativEquations);
      then txt;

    case ( txt,
           _ :: rest,
           a_modelNamePrefixStr,
           a_derivativEquations )
      equation
        txt = lm_813(txt, rest, a_modelNamePrefixStr, a_derivativEquations);
      then txt;
  end match;
end lm_813;

protected function fun_814
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;
  input String in_a_modelNamePrefixStr;
  input list<SimCode.SimEqSystem> in_a_derivativEquations;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo, in_a_modelNamePrefixStr, in_a_derivativEquations)
    local
      Tpl.Text txt;
      String a_modelNamePrefixStr;
      list<SimCode.SimEqSystem> a_derivativEquations;
      list<SimCodeVar.SimVar> i_ders;

    case ( txt,
           SimCode.MODELINFO(vars = SimCodeVar.SIMVARS(derivativeVars = i_ders)),
           a_modelNamePrefixStr,
           a_derivativEquations )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_813(txt, i_ders, a_modelNamePrefixStr, a_derivativEquations);
        txt = Tpl.popIter(txt);
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_814;

public function functionXXX_systemPartial
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_derivativEquations;
  input String a_name;
  input Integer a_n;
  input String a_modelNamePrefixStr;
  input SimCode.ModelInfo a_modelInfo;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_code;
algorithm
  l_code := fun_814(Tpl.emptyTxt, a_modelInfo, a_modelNamePrefixStr, a_derivativEquations);
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING("static void "));
  out_txt := Tpl.writeStr(out_txt, a_modelNamePrefixStr);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("_function"));
  out_txt := Tpl.writeStr(out_txt, a_name);
  out_txt := Tpl.writeStr(out_txt, intString(a_n));
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "(DATA *data, threadData_t *threadData, int i)\n",
                                       "{\n",
                                       "  switch (i) {\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeText(out_txt, l_code);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("}\n"));
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("}"));
end functionXXX_systemPartial;

protected function lm_816
  input Tpl.Text in_txt;
  input list<list<SimCode.SimEqSystem>> in_items;
  input SimCode.ModelInfo in_a_modelInfo;
  input String in_a_modelNamePrefixStr;
  input String in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelInfo, in_a_modelNamePrefixStr, in_a_name)
    local
      Tpl.Text txt;
      list<list<SimCode.SimEqSystem>> rest;
      SimCode.ModelInfo a_modelInfo;
      String a_modelNamePrefixStr;
      String a_name;
      Integer x_i0;
      list<SimCode.SimEqSystem> i_eq;

    case ( txt,
           {},
           _,
           _,
           _ )
      then txt;

    case ( txt,
           i_eq :: rest,
           a_modelInfo,
           a_modelNamePrefixStr,
           a_name )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = functionXXX_systemPartial(txt, i_eq, a_name, x_i0, a_modelNamePrefixStr, a_modelInfo);
        txt = Tpl.nextIter(txt);
        txt = lm_816(txt, rest, a_modelInfo, a_modelNamePrefixStr, a_name);
      then txt;
  end match;
end lm_816;

protected function lm_817
  input Tpl.Text in_txt;
  input list<list<SimCode.SimEqSystem>> in_items;
  input String in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_name)
    local
      Tpl.Text txt;
      list<list<SimCode.SimEqSystem>> rest;
      String a_name;
      Integer x_i0;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           _ :: rest,
           a_name )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("function"));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_system"));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.nextIter(txt);
        txt = lm_817(txt, rest, a_name);
      then txt;
  end match;
end lm_817;

protected function fun_818
  input Tpl.Text in_txt;
  input Integer in_mArg;
  input Tpl.Text in_a_varDecls;
  input list<list<SimCode.SimEqSystem>> in_a_eqs;
  input Tpl.Text in_a_funcs;
  input String in_a_modelNamePrefixStr;
  input String in_a_name;
  input Tpl.Text in_a_loop;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_loop;
algorithm
  (out_txt, out_a_varDecls, out_a_loop) :=
  match(in_txt, in_mArg, in_a_varDecls, in_a_eqs, in_a_funcs, in_a_modelNamePrefixStr, in_a_name, in_a_loop)
    local
      Tpl.Text txt;
      Tpl.Text a_varDecls;
      list<list<SimCode.SimEqSystem>> a_eqs;
      Tpl.Text a_funcs;
      String a_modelNamePrefixStr;
      String a_name;
      Tpl.Text a_loop;
      Integer i_nFuncs;
      Tpl.Text l_funcNames;

    case ( txt,
           0,
           a_varDecls,
           _,
           _,
           _,
           a_name,
           a_loop )
      equation
        a_loop = Tpl.writeTok(a_loop, Tpl.ST_STRING("/* no "));
        a_loop = Tpl.writeStr(a_loop, a_name);
        a_loop = Tpl.writeTok(a_loop, Tpl.ST_STRING(" systems */"));
      then (txt, a_varDecls, a_loop);

    case ( txt,
           1,
           a_varDecls,
           _,
           a_funcs,
           a_modelNamePrefixStr,
           a_name,
           a_loop )
      equation
        a_loop = Tpl.writeStr(a_loop, a_modelNamePrefixStr);
        a_loop = Tpl.writeTok(a_loop, Tpl.ST_STRING("_function"));
        a_loop = Tpl.writeStr(a_loop, a_name);
        a_loop = Tpl.writeTok(a_loop, Tpl.ST_STRING("0(data, threadData,i);"));
        txt = Tpl.writeText(txt, a_funcs);
      then (txt, a_varDecls, a_loop);

    case ( txt,
           i_nFuncs,
           a_varDecls,
           a_eqs,
           a_funcs,
           _,
           a_name,
           a_loop )
      equation
        l_funcNames = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_LINE(",\n")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_funcNames = lm_817(l_funcNames, a_eqs, a_name);
        l_funcNames = Tpl.popIter(l_funcNames);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING("int id;"));
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_NEW_LINE());
        a_loop = Tpl.writeTok(a_loop, Tpl.ST_STRING("for(id=0; id<"));
        a_loop = Tpl.writeStr(a_loop, intString(i_nFuncs));
        a_loop = Tpl.writeTok(a_loop, Tpl.ST_LINE("; id++) {\n"));
        a_loop = Tpl.pushBlock(a_loop, Tpl.BT_INDENT(2));
        a_loop = Tpl.writeTok(a_loop, Tpl.ST_STRING("function"));
        a_loop = Tpl.writeStr(a_loop, a_name);
        a_loop = Tpl.writeTok(a_loop, Tpl.ST_LINE("_systems[id](data, threadData);\n"));
        a_loop = Tpl.popBlock(a_loop);
        a_loop = Tpl.writeTok(a_loop, Tpl.ST_STRING("}"));
        txt = Tpl.writeText(txt, a_funcs);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("static void (*function"));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_systems["));
        txt = Tpl.writeStr(txt, intString(i_nFuncs));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("])(DATA *, threadData_t *threadData) = {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_funcNames);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("};"));
      then (txt, a_varDecls, a_loop);
  end match;
end fun_818;

public function functionXXX_systemsPartial
  input Tpl.Text txt;
  input list<list<SimCode.SimEqSystem>> a_eqs;
  input String a_name;
  input Tpl.Text a_loop;
  input Tpl.Text a_varDecls;
  input String a_modelNamePrefixStr;
  input SimCode.ModelInfo a_modelInfo;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_loop;
  output Tpl.Text out_a_varDecls;
protected
  Integer ret_1;
  Tpl.Text l_funcs;
algorithm
  l_funcs := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  l_funcs := lm_816(l_funcs, a_eqs, a_modelInfo, a_modelNamePrefixStr, a_name);
  l_funcs := Tpl.popIter(l_funcs);
  ret_1 := listLength(a_eqs);
  (out_txt, out_a_varDecls, out_a_loop) := fun_818(txt, ret_1, a_varDecls, a_eqs, l_funcs, a_modelNamePrefixStr, a_name, a_loop);
end functionXXX_systemsPartial;

protected function lm_820
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input String in_a_modelNamePrefixStr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefixStr)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      String a_modelNamePrefixStr;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_eq :: rest,
           a_modelNamePrefixStr )
      equation
        txt = equationNames_(txt, i_eq, SimCodeFunction.contextSimulationNonDiscrete, a_modelNamePrefixStr);
        txt = Tpl.nextIter(txt);
        txt = lm_820(txt, rest, a_modelNamePrefixStr);
      then txt;
  end match;
end lm_820;

public function equationNames_Partial
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_eqs;
  input String a_modelNamePrefixStr;
  input Integer a_i0;
  input String a_cref__der;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_odeEqs;
algorithm
  l_odeEqs := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  l_odeEqs := lm_820(l_odeEqs, a_eqs, a_modelNamePrefixStr);
  l_odeEqs := Tpl.popIter(l_odeEqs);
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING("case "));
  out_txt := Tpl.writeStr(out_txt, intString(a_i0));
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE(":\n"));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("// Assigning "));
  out_txt := Tpl.writeStr(out_txt, a_cref__der);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeText(out_txt, l_odeEqs);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("break;"));
  out_txt := Tpl.popBlock(out_txt);
end equationNames_Partial;

annotation(__OpenModelica_Interface="backend");
end CodegenC;