encapsulated package CodegenCFunctions
"
  file:        CodegenCFunctions.mo
  package:     CodegenCFunctions
  description: Generated by Susan.
"

public import Tpl;

public import SimCodeVar;
public import HashTableCrefSimVar;
public import SimCode;
public import SimCodeFunction;
public import SimCodeUtil;
public import SimCodeFunctionUtil;
public import BackendDAE;
public import System;
public import Autoconf;
public import Absyn;
public import AbsynUtil;
public import DAE;
public import ClassInf;
public import SCode;
public import Util;
public import List;
public import ComponentReference;
public import Expression;
public import ExpressionDump;
public import Config;
public import Testsuite;
public import Flags;
public import Settings;
public import Patternm;
public import Error;
public import Values;
public import ValuesUtil;
public import Algorithm;
public import ElementSource;
public import DAEUtil;
public import Types;
public import CodegenUtil;
protected import ExpressionDumpTpl;

protected function fun_40
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("terminateHpcOmThreads();"));
      then txt;
  end match;
end fun_40;

public function generateEntryPoint
  input Tpl.Text txt;
  input Absyn.Path a_entryPoint;
  input String a_url;

  output Tpl.Text out_txt;
protected
  Boolean ret_2;
  Tpl.Text txt_1;
  Tpl.Text l_name;
algorithm
  l_name := Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("omc_"));
  l_name := CodegenUtil.underscorePath(l_name, a_entryPoint);
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                   "/* This is an automatically generated entry point to a MetaModelica function */\n",
                                   "\n",
                                   "#if defined(__cplusplus)\n",
                                   "extern \"C\" {\n",
                                   "#endif\n",
                                   "\n",
                                   "#if defined(OMC_ENTRYPOINT_STATIC)\n",
                                   "\n",
                                   "#include <stdio.h>\n",
                                   "#include <openmodelica.h>\n",
                                   "\n",
                                   "DLLImport extern int __omc_main(int argc, char **argv);\n",
                                   "\n",
                                   "int main(int argc, char **argv)\n",
                                   "{\n",
                                   "  return __omc_main(argc, argv);\n",
                                   "}\n",
                                   "\n",
                                   "#else\n",
                                   "\n",
                                   "#include <meta/meta_modelica.h>\n",
                                   "#include <stdio.h>\n",
                                   "extern void\n",
                                   "#if defined(OMC_GENERATE_RELOCATABLE_CODE)\n",
                                   "(*"
                               }, false));
  out_txt := Tpl.writeText(out_txt, l_name);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       ")\n",
                                       "#else\n"
                                   }, true));
  out_txt := Tpl.writeText(out_txt, l_name);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "#endif\n",
                                       "(threadData_t*,modelica_metatype);\n",
                                       "\n",
                                       "void (*omc_assert)(threadData_t*,FILE_INFO info,const char *msg,...) __attribute__((noreturn)) = omc_assert_function;\n",
                                       "void (*omc_assert_warning)(FILE_INFO info,const char *msg,...) = omc_assert_warning_function;\n",
                                       "void (*omc_terminate)(FILE_INFO info,const char *msg,...) = omc_terminate_function;\n",
                                       "void (*omc_throw)(threadData_t*) __attribute__ ((noreturn)) = omc_throw_function;\n",
                                       "\n",
                                       "#ifdef _OPENMP\n",
                                       "#include<omp.h>\n",
                                       "/* Hack to make gcc-4.8 link in the OpenMP runtime if -fopenmp is given */\n",
                                       "int (*force_link_omp)(void) = omp_get_num_threads;\n",
                                       "#endif\n",
                                       "\n",
                                       "static int rml_execution_failed()\n",
                                       "{\n",
                                       "  fflush(NULL);\n",
                                       "  fprintf(stderr, \"Execution failed!\\n\");\n",
                                       "  fflush(NULL);\n",
                                       "  return 1;\n",
                                       "}\n",
                                       "\n",
                                       "DLLExport int __omc_main(int argc, char **argv)\n",
                                       "{\n",
                                       "  MMC_INIT(0);\n",
                                       "  {\n",
                                       "  void *lst = mmc_mk_nil();\n",
                                       "  int i = 0;\n",
                                       "\n",
                                       "  for (i=argc-1; i>0; i--) {\n",
                                       "    lst = mmc_mk_cons(mmc_mk_scon(argv[i]), lst);\n",
                                       "  }\n",
                                       "\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  txt_1 := Tpl.writeText(Tpl.emptyTxt, l_name);
  txt_1 := Tpl.writeTok(txt_1, Tpl.ST_STRING("(threadData, lst);"));
  (out_txt, txt_1) := mainTop(out_txt, txt_1, a_url);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "}\n",
                                       "\n"
                                   }, true));
  ret_2 := Flags.isSet(Flags.HPCOM);
  out_txt := fun_40(out_txt, ret_2);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "fflush(NULL);\n",
                                       "EXIT(0);\n",
                                       "return 0;\n"
                                   }, true));
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "}\n",
                                       "\n",
                                       "#endif\n",
                                       "\n",
                                       "#if defined(__cplusplus)\n",
                                       "} /* end extern \"C\" */\n",
                                       "#endif\n",
                                       "\n"
                                   }, true));
end generateEntryPoint;

public function mainTop
  input Tpl.Text txt;
  input Tpl.Text a_mainBody;
  input String a_url;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_mainBody;
algorithm
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                   "{\n",
                                   "  MMC_TRY_TOP()\n",
                                   "\n",
                                   "  MMC_TRY_STACK()\n",
                                   "\n"
                               }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeText(out_txt, a_mainBody);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "MMC_ELSE()\n",
                                       "rml_execution_failed();\n",
                                       "fprintf(stderr, \"Stack overflow detected and was not caught.\\nSend us a bug report at "
                                   }, false));
  out_txt := Tpl.writeStr(out_txt, a_url);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\\n    Include the following trace:\\n\");\n",
                                       "printStacktraceMessages();\n",
                                       "fflush(NULL);\n",
                                       "return 1;\n",
                                       "MMC_CATCH_STACK()\n",
                                       "\n",
                                       "MMC_CATCH_TOP(return rml_execution_failed());\n"
                                   }, true));
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("}"));
  out_a_mainBody := a_mainBody;
end mainTop;

protected function fun_43
  input Tpl.Text in_txt;
  input Option<SimCodeFunction.Function> in_a_mainFunction;
  input Tpl.Text in_a_filePrefix;
  input SimCodeFunction.FunctionCode in_a_functionCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_mainFunction, in_a_filePrefix, in_a_functionCode)
    local
      Tpl.Text txt;
      Tpl.Text a_filePrefix;
      SimCodeFunction.FunctionCode a_functionCode;
      Tpl.Text txt_1;
      Tpl.Text txt_0;

    case ( txt,
           NONE(),
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_filePrefix,
           a_functionCode )
      equation
        txt_0 = functionsMakefile(Tpl.emptyTxt, a_functionCode);
        txt_1 = Tpl.writeText(Tpl.emptyTxt, a_filePrefix);
        txt_1 = Tpl.writeTok(txt_1, Tpl.ST_STRING(".makefile"));
        Tpl.textFile(txt_0, Tpl.textString(txt_1));
      then txt;
  end match;
end fun_43;

protected function fun_44
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input list<SimCodeFunction.Function> in_a_functions;
  input Option<SimCodeFunction.Function> in_a_mainFunction;
  input Tpl.Text in_a_filePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_functions, in_a_mainFunction, in_a_filePrefix)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Function> a_functions;
      Option<SimCodeFunction.Function> a_mainFunction;
      Tpl.Text a_filePrefix;
      Tpl.Text txt_1;
      Tpl.Text txt_0;

    case ( txt,
           false,
           _,
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_functions,
           a_mainFunction,
           a_filePrefix )
      equation
        txt_0 = functionsParModelicaKernelsFile(Tpl.emptyTxt, Tpl.textString(a_filePrefix), a_mainFunction, a_functions);
        txt_1 = Tpl.writeText(Tpl.emptyTxt, a_filePrefix);
        txt_1 = Tpl.writeTok(txt_1, Tpl.ST_STRING("_kernels.cl"));
        Tpl.textFile(txt_0, Tpl.textString(txt_1));
      then txt;
  end match;
end fun_44;

public function translateFunctions
  input Tpl.Text in_txt;
  input SimCodeFunction.FunctionCode in_a_functionCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_functionCode)
    local
      Tpl.Text txt;
      list<String> i_fc_externalFunctionIncludes;
      list<DAE.Exp> i_literals;
      list<SimCodeFunction.RecordDeclaration> i_extraRecordDecls;
      list<SimCodeFunction.Function> i_functions;
      SimCodeFunction.FunctionCode i_fc;
      Option<SimCodeFunction.Function> i_mainFunction;
      String i_name;
      Boolean ret_11;
      Tpl.Text txt_10;
      Tpl.Text txt_9;
      Tpl.Text txt_8;
      Tpl.Text txt_7;
      Tpl.Text txt_6;
      Tpl.Text txt_5;
      Tpl.Text txt_4;
      Tpl.Text txt_3;
      Tpl.Text l_0__;
      Tpl.Text l_filePrefix;
      Tpl.Text l_staticPrototypes;

    case ( txt,
           (i_fc as SimCodeFunction.FUNCTIONCODE(name = i_name, mainFunction = i_mainFunction, functions = i_functions, extraRecordDecls = i_extraRecordDecls, literals = i_literals, externalFunctionIncludes = i_fc_externalFunctionIncludes)) )
      equation
        System.tmpTickResetIndex(0, 2);
        System.tmpTickResetIndex(0, 20);
        l_staticPrototypes = Tpl.emptyTxt;
        l_filePrefix = Tpl.writeStr(Tpl.emptyTxt, i_name);
        l_0__ = fun_43(Tpl.emptyTxt, i_mainFunction, l_filePrefix, i_fc);
        (txt_3, l_staticPrototypes) = functionsHeaderFile(Tpl.emptyTxt, Tpl.textString(l_filePrefix), i_mainFunction, i_functions, i_extraRecordDecls, l_staticPrototypes);
        txt_4 = Tpl.writeText(Tpl.emptyTxt, l_filePrefix);
        txt_4 = Tpl.writeTok(txt_4, Tpl.ST_STRING(".h"));
        Tpl.textFile(txt_3, Tpl.textString(txt_4));
        (txt_5, l_staticPrototypes) = functionsFile(Tpl.emptyTxt, Tpl.textString(l_filePrefix), i_mainFunction, i_functions, i_literals, l_staticPrototypes);
        txt_6 = Tpl.writeText(Tpl.emptyTxt, l_filePrefix);
        txt_6 = Tpl.writeTok(txt_6, Tpl.ST_STRING(".c"));
        Tpl.textFileConvertLines(txt_5, Tpl.textString(txt_6));
        txt_7 = externalFunctionIncludes(Tpl.emptyTxt, i_fc_externalFunctionIncludes);
        txt_8 = Tpl.writeText(Tpl.emptyTxt, l_filePrefix);
        txt_8 = Tpl.writeTok(txt_8, Tpl.ST_STRING("_includes.h"));
        Tpl.textFile(txt_7, Tpl.textString(txt_8));
        txt_9 = recordsFile(Tpl.emptyTxt, Tpl.textString(l_filePrefix), i_extraRecordDecls, false);
        txt_10 = Tpl.writeText(Tpl.emptyTxt, l_filePrefix);
        txt_10 = Tpl.writeTok(txt_10, Tpl.ST_STRING("_records.c"));
        Tpl.textFile(txt_9, Tpl.textString(txt_10));
        ret_11 = Config.acceptParModelicaGrammar();
        txt = fun_44(txt, ret_11, i_functions, i_mainFunction, l_filePrefix);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end translateFunctions;

protected function fun_46
  input Tpl.Text in_txt;
  input Option<SimCodeFunction.Function> in_a_mainFunction;
  input Tpl.Text in_a_filePrefix;
  input SimCodeFunction.FunctionCode in_a_functionCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_mainFunction, in_a_filePrefix, in_a_functionCode)
    local
      Tpl.Text txt;
      Tpl.Text a_filePrefix;
      SimCodeFunction.FunctionCode a_functionCode;
      Tpl.Text txt_1;
      Tpl.Text txt_0;

    case ( txt,
           NONE(),
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_filePrefix,
           a_functionCode )
      equation
        txt_0 = functionsMakefile(Tpl.emptyTxt, a_functionCode);
        txt_1 = Tpl.writeText(Tpl.emptyTxt, a_filePrefix);
        txt_1 = Tpl.writeTok(txt_1, Tpl.ST_STRING(".makefile"));
        Tpl.textFile(txt_0, Tpl.textString(txt_1));
      then txt;
  end match;
end fun_46;

public function translateFunctionHeaderFiles
  input Tpl.Text in_txt;
  input SimCodeFunction.FunctionCode in_a_functionCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_functionCode)
    local
      Tpl.Text txt;
      list<String> i_fc_externalFunctionIncludes;
      list<SimCodeFunction.RecordDeclaration> i_extraRecordDecls;
      list<SimCodeFunction.Function> i_functions;
      SimCodeFunction.FunctionCode i_fc;
      Option<SimCodeFunction.Function> i_mainFunction;
      String i_name;
      Tpl.Text txt_8;
      Tpl.Text txt_7;
      Tpl.Text txt_6;
      Tpl.Text txt_5;
      Tpl.Text txt_4;
      Tpl.Text txt_3;
      Tpl.Text l_0__;
      Tpl.Text l_filePrefix;
      Tpl.Text l_staticPrototypes;

    case ( txt,
           (i_fc as SimCodeFunction.FUNCTIONCODE(name = i_name, mainFunction = i_mainFunction, functions = i_functions, extraRecordDecls = i_extraRecordDecls, externalFunctionIncludes = i_fc_externalFunctionIncludes)) )
      equation
        System.tmpTickResetIndex(0, 2);
        System.tmpTickResetIndex(0, 20);
        l_staticPrototypes = Tpl.emptyTxt;
        l_filePrefix = Tpl.writeStr(Tpl.emptyTxt, i_name);
        l_0__ = fun_46(Tpl.emptyTxt, i_mainFunction, l_filePrefix, i_fc);
        (txt_3, l_staticPrototypes) = functionsHeaderFile(Tpl.emptyTxt, Tpl.textString(l_filePrefix), i_mainFunction, i_functions, i_extraRecordDecls, l_staticPrototypes);
        txt_4 = Tpl.writeText(Tpl.emptyTxt, l_filePrefix);
        txt_4 = Tpl.writeTok(txt_4, Tpl.ST_STRING(".h"));
        Tpl.textFile(txt_3, Tpl.textString(txt_4));
        txt_5 = externalFunctionIncludes(Tpl.emptyTxt, i_fc_externalFunctionIncludes);
        txt_6 = Tpl.writeText(Tpl.emptyTxt, l_filePrefix);
        txt_6 = Tpl.writeTok(txt_6, Tpl.ST_STRING("_includes.h"));
        Tpl.textFile(txt_5, Tpl.textString(txt_6));
        txt_7 = recordsFile(Tpl.emptyTxt, Tpl.textString(l_filePrefix), i_extraRecordDecls, false);
        txt_8 = Tpl.writeText(Tpl.emptyTxt, l_filePrefix);
        txt_8 = Tpl.writeTok(txt_8, Tpl.ST_STRING("_records.c"));
        Tpl.textFile(txt_7, Tpl.textString(txt_8));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end translateFunctionHeaderFiles;

protected function lm_48
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Integer x_i0;
      DAE.Exp i_literal;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_literal :: rest )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = literalExpConst(txt, i_literal, x_i0);
        txt = Tpl.nextIter(txt);
        txt = lm_48(txt, rest);
      then txt;
  end match;
end lm_48;

protected function fun_49
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_filePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_filePrefix)
    local
      Tpl.Text txt;
      String a_filePrefix;
      Integer ret_0;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_filePrefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "/* the OpenCL Kernels file name needed in libParModelicaExpl.a */\n",
                                    "const char* omc_ocl_kernels_source = \""
                                }, false));
        txt = Tpl.writeStr(txt, a_filePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_kernels.cl\";\n",
                                    "/* the OpenCL program. Made global to avoid repeated builds */\n",
                                    "extern cl_program omc_ocl_program;\n",
                                    "/* The default OpenCL device. If not set (=0) show the selection option.*/\n",
                                    "unsigned int default_ocl_device = "
                                }, false));
        ret_0 = Config.getDefaultOpenCLDevice();
        txt = Tpl.writeStr(txt, intString(ret_0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_49;

protected function fun_50
  input Tpl.Text in_txt;
  input Tpl.Text in_a_staticPrototypes;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_staticPrototypes)
    local
      Tpl.Text txt;
      Tpl.Text i_staticPrototypes;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}) )
      then txt;

    case ( txt,
           i_staticPrototypes )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "/* default, do not make protected functions static */\n",
                                    "#if !defined(PROTECTED_FUNCTION_STATIC)\n",
                                    "#define PROTECTED_FUNCTION_STATIC\n",
                                    "#endif\n"
                                }, true));
        txt = Tpl.writeText(txt, i_staticPrototypes);
      then txt;
  end match;
end fun_50;

protected function fun_51
  input Tpl.Text in_txt;
  input Option<SimCodeFunction.Function> in_a_mainFunction;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_mainFunction)
    local
      Tpl.Text txt;
      SimCodeFunction.Function i_fn;

    case ( txt,
           SOME(i_fn) )
      equation
        txt = functionBody(txt, i_fn, true, false);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_51;

public function functionsFile
  input Tpl.Text txt;
  input String a_filePrefix;
  input Option<SimCodeFunction.Function> a_mainFunction;
  input list<SimCodeFunction.Function> a_functions;
  input list<DAE.Exp> a_literals;
  input Tpl.Text a_staticPrototypes;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_staticPrototypes;
protected
  Boolean ret_0;
algorithm
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                   "#include \"omc_simulation_settings.h\"\n",
                                   "#include \""
                               }, false));
  out_txt := Tpl.writeStr(out_txt, a_filePrefix);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE(".h\"\n"));
  out_txt := Tpl.pushIter(out_txt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_48(out_txt, a_literals);
  out_txt := Tpl.popIter(out_txt);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "#include \"util/modelica.h\"\n",
                                       "\n",
                                       "#include \""
                                   }, false));
  out_txt := Tpl.writeStr(out_txt, a_filePrefix);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "_includes.h\"\n",
                                       "\n"
                                   }, true));
  ret_0 := Config.acceptParModelicaGrammar();
  out_txt := fun_49(out_txt, ret_0, a_filePrefix);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_NEW_LINE());
  out_txt := fun_50(out_txt, a_staticPrototypes);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_NEW_LINE());
  out_txt := fun_51(out_txt, a_mainFunction);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := functionBodies(out_txt, a_functions, false);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_NEW_LINE());
  out_a_staticPrototypes := a_staticPrototypes;
end functionsFile;

protected function lm_53
  input Tpl.Text in_txt;
  input list<SimCodeFunction.RecordDeclaration> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeFunction.RecordDeclaration> rest;
      SimCodeFunction.RecordDeclaration i_rd;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_rd :: rest )
      equation
        txt = recordDeclarationHeader(txt, i_rd);
        txt = Tpl.nextIter(txt);
        txt = lm_53(txt, rest);
      then txt;
  end match;
end lm_53;

protected function fun_54
  input Tpl.Text in_txt;
  input Option<SimCodeFunction.Function> in_a_mainFunction;
  input Tpl.Text in_a_staticPrototypes;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_staticPrototypes;
algorithm
  (out_txt, out_a_staticPrototypes) :=
  match(in_txt, in_a_mainFunction, in_a_staticPrototypes)
    local
      Tpl.Text txt;
      Tpl.Text a_staticPrototypes;
      SimCodeFunction.Function i_fn;

    case ( txt,
           SOME(i_fn),
           a_staticPrototypes )
      equation
        (txt, a_staticPrototypes) = functionHeader(txt, i_fn, true, false, a_staticPrototypes);
      then (txt, a_staticPrototypes);

    case ( txt,
           _,
           a_staticPrototypes )
      then (txt, a_staticPrototypes);
  end match;
end fun_54;

public function functionsHeaderFile
  input Tpl.Text txt;
  input String a_filePrefix;
  input Option<SimCodeFunction.Function> a_mainFunction;
  input list<SimCodeFunction.Function> a_functions;
  input list<SimCodeFunction.RecordDeclaration> a_extraRecordDecls;
  input Tpl.Text a_staticPrototypes;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_staticPrototypes;
protected
  String ret_1;
  String ret_0;
algorithm
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING("#ifndef "));
  ret_0 := System.makeC89Identifier(a_filePrefix);
  out_txt := Tpl.writeStr(out_txt, ret_0);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "__H\n",
                                       "#define "
                                   }, false));
  ret_1 := System.makeC89Identifier(a_filePrefix);
  out_txt := Tpl.writeStr(out_txt, ret_1);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("__H\n"));
  out_txt := commonHeader(out_txt, a_filePrefix);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "#ifdef __cplusplus\n",
                                       "extern \"C\" {\n",
                                       "#endif\n",
                                       "\n"
                                   }, true));
  out_txt := Tpl.pushIter(out_txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_53(out_txt, a_extraRecordDecls);
  out_txt := Tpl.popIter(out_txt);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_NEW_LINE());
  (out_txt, out_a_staticPrototypes) := fun_54(out_txt, a_mainFunction, a_staticPrototypes);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_NEW_LINE());
  (out_txt, out_a_staticPrototypes) := functionHeaders(out_txt, a_functions, false, out_a_staticPrototypes);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "#ifdef __cplusplus\n",
                                       "}\n",
                                       "#endif\n",
                                       "#endif"
                                   }, false));
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_NEW_LINE());
end functionsHeaderFile;

protected function lm_56
  input Tpl.Text in_txt;
  input list<String> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<String> rest;
      String i_it;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_it :: rest )
      equation
        txt = Tpl.writeStr(txt, i_it);
        txt = Tpl.nextIter(txt);
        txt = lm_56(txt, rest);
      then txt;
  end match;
end lm_56;

protected function fun_57
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-lParModelicaExpl -lOpenCL"));
      then txt;
  end match;
end fun_57;

protected function fun_58
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("--stack,16777216,"));
      then txt;
  end match;
end fun_58;

protected function fun_59
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-lOpenModelicaCompiler"));
      then txt;
  end match;
end fun_59;

protected function fun_60
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_makefileParams_ccompiler;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_makefileParams_ccompiler)
    local
      Tpl.Text txt;
      String a_makefileParams_ccompiler;

    case ( txt,
           false,
           a_makefileParams_ccompiler )
      equation
        txt = Tpl.writeStr(txt, a_makefileParams_ccompiler);
      then txt;

    case ( txt,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("g++"));
      then txt;
  end match;
end fun_60;

protected function fun_61
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("$(SIM_OR_DYNLOAD_OPT_LEVEL)"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" -g"));
      then txt;
  end match;
end fun_61;

protected function lm_62
  input Tpl.Text in_txt;
  input list<String> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<String> rest;
      String i_it;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_it :: rest )
      equation
        txt = Tpl.writeStr(txt, i_it);
        txt = Tpl.nextIter(txt);
        txt = lm_62(txt, rest);
      then txt;
  end match;
end lm_62;

protected function fun_63
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" -DOMC_GENERATE_RELOCATABLE_CODE"));
      then txt;
  end match;
end fun_63;

public function functionsMakefile
  input Tpl.Text in_txt;
  input SimCodeFunction.FunctionCode in_a_fnCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fnCode)
    local
      Tpl.Text txt;
      String i_name;
      String i_makefileParams_ldflags;
      String i_makefileParams_runtimelibs;
      list<String> i_makefileParams_includes;
      String i_makefileParams_omhome;
      String i_makefileParams_cflags;
      String i_makefileParams_dllext;
      String i_makefileParams_exeext;
      String i_makefileParams_linker;
      String i_makefileParams_cxxcompiler;
      String i_makefileParams_ccompiler;
      String i_makefileParams_platform;
      list<String> i_makefileParams_libs;
      Boolean ret_17;
      Boolean ret_16;
      Boolean ret_15;
      Boolean ret_14;
      Boolean ret_13;
      Boolean ret_12;
      Boolean ret_11;
      Boolean ret_10;
      Boolean ret_9;
      Boolean ret_8;
      Tpl.Text l_WinMingwExtraLibs;
      Boolean ret_6;
      Boolean ret_5;
      Boolean ret_4;
      Tpl.Text l_ExtraStack;
      Boolean ret_2;
      Tpl.Text l_ParModelicaExpLibs;
      Tpl.Text l_libsStr;

    case ( txt,
           SimCodeFunction.FUNCTIONCODE(makefileParams = SimCodeFunction.MAKEFILE_PARAMS(libs = i_makefileParams_libs, platform = i_makefileParams_platform, ccompiler = i_makefileParams_ccompiler, cxxcompiler = i_makefileParams_cxxcompiler, linker = i_makefileParams_linker, exeext = i_makefileParams_exeext, dllext = i_makefileParams_dllext, cflags = i_makefileParams_cflags, omhome = i_makefileParams_omhome, includes = i_makefileParams_includes, runtimelibs = i_makefileParams_runtimelibs, ldflags = i_makefileParams_ldflags), name = i_name) )
      equation
        l_libsStr = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(" ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_libsStr = lm_56(l_libsStr, i_makefileParams_libs);
        l_libsStr = Tpl.popIter(l_libsStr);
        ret_2 = Config.acceptParModelicaGrammar();
        l_ParModelicaExpLibs = fun_57(Tpl.emptyTxt, ret_2);
        ret_4 = stringEq(i_makefileParams_platform, "win32");
        ret_5 = stringEq(i_makefileParams_platform, "win64");
        ret_6 = boolOr(ret_4, ret_5);
        l_ExtraStack = fun_58(Tpl.emptyTxt, ret_6);
        ret_8 = Config.acceptMetaModelicaGrammar();
        ret_9 = stringEq(i_makefileParams_platform, "win32");
        ret_10 = stringEq(i_makefileParams_platform, "win64");
        ret_11 = boolOr(ret_9, ret_10);
        ret_12 = boolAnd(ret_8, ret_11);
        l_WinMingwExtraLibs = fun_59(Tpl.emptyTxt, ret_12);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "# Makefile generated by OpenModelica\n",
                                    "# Platform: "
                                }, false));
        txt = Tpl.writeStr(txt, i_makefileParams_platform);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "# Dynamic loading uses -O0 by default\n",
                                    "# define OMC_CFLAGS_OPTIMIZATION env variable to your desired optimization level to override this\n",
                                    "OMC_CFLAGS_OPTIMIZATION=-O0\n",
                                    "SIM_OR_DYNLOAD_OPT_LEVEL=$(OMC_CFLAGS_OPTIMIZATION)\n",
                                    "CC="
                                }, false));
        ret_13 = Config.acceptParModelicaGrammar();
        txt = fun_60(txt, ret_13, i_makefileParams_ccompiler);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("CXX="));
        txt = Tpl.writeStr(txt, i_makefileParams_cxxcompiler);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("LINK="));
        txt = Tpl.writeStr(txt, i_makefileParams_linker);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("EXEEXT="));
        txt = Tpl.writeStr(txt, i_makefileParams_exeext);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("DLLEXT="));
        txt = Tpl.writeStr(txt, i_makefileParams_dllext);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("DEBUG_FLAGS="));
        ret_14 = Config.acceptMetaModelicaGrammar();
        ret_15 = Flags.isSet(Flags.GEN_DEBUG_SYMBOLS);
        ret_16 = boolOr(ret_14, ret_15);
        txt = fun_61(txt, ret_16);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("CFLAGS= $(DEBUG_FLAGS) "));
        txt = Tpl.writeStr(txt, i_makefileParams_cflags);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("CPPFLAGS= -I\""));
        txt = Tpl.writeStr(txt, i_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/include/omc/c\" "));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(" ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_62(txt, i_makefileParams_includes);
        txt = Tpl.popIter(txt);
        ret_17 = Flags.isSet(Flags.OMC_RELOCATABLE_FUNCTIONS);
        txt = fun_63(txt, ret_17);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "# define OMC_LDFLAGS_LINK_TYPE env variable to \"static\" to override this\n",
                                    "OMC_LDFLAGS_LINK_TYPE=dynamic\n",
                                    "RUNTIME_LIBS="
                                }, false));
        txt = Tpl.writeStr(txt, i_makefileParams_runtimelibs);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("LDFLAGS= -L\""));
        txt = Tpl.writeStr(txt, i_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/lib/"));
        txt = Tpl.writeStr(txt, Autoconf.triple);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/omc\" -Wl,"));
        txt = Tpl.writeText(txt, l_ExtraStack);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-rpath,\'"));
        txt = Tpl.writeStr(txt, i_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/lib/"));
        txt = Tpl.writeStr(txt, Autoconf.triple);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/omc\' "));
        txt = Tpl.writeText(txt, l_ParModelicaExpLibs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, l_WinMingwExtraLibs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeStr(txt, i_makefileParams_ldflags);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " $(RUNTIME_LIBS)\n",
                                    "PERL=perl\n",
                                    "MAINFILE="
                                }, false));
        txt = Tpl.writeStr(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ".c\n",
                                    "\n",
                                    ".PHONY: "
                                }, false));
        txt = Tpl.writeStr(txt, i_name);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeStr(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(": $(MAINFILE) "));
        txt = Tpl.writeStr(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".h "));
        txt = Tpl.writeStr(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_records.c\n"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" $(CC) $(CFLAGS) $(CPPFLAGS) -c -o "));
        txt = Tpl.writeStr(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(".o $(MAINFILE)\n"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" $(CC) $(CFLAGS) $(CPPFLAGS) -c -o "));
        txt = Tpl.writeStr(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_records.o "));
        txt = Tpl.writeStr(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_records.c\n"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" $(LINK) -o "));
        txt = Tpl.writeStr(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("$(DLLEXT) "));
        txt = Tpl.writeStr(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".o "));
        txt = Tpl.writeStr(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_records.o "));
        txt = Tpl.writeText(txt, l_libsStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" $(CFLAGS) $(CPPFLAGS) $(LDFLAGS) -lm"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end functionsMakefile;

protected function fun_65
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#include <ParModelica/explicit/openclrt/omc_ocl_interface.h>"));
      then txt;
  end match;
end fun_65;

public function commonHeader
  input Tpl.Text txt;
  input String a_filePrefix;

  output Tpl.Text out_txt;
protected
  Boolean ret_0;
algorithm
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                   "#include \"meta/meta_modelica.h\"\n",
                                   "#include \"util/modelica.h\"\n",
                                   "#include <stdio.h>\n",
                                   "#include <stdlib.h>\n",
                                   "#include <errno.h>\n"
                               }, true));
  ret_0 := Config.acceptParModelicaGrammar();
  out_txt := fun_65(out_txt, ret_0);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_NEW_LINE());
end commonHeader;

protected function lm_67
  input Tpl.Text in_txt;
  input list<String> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<String> rest;
      String i_it;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_it :: rest )
      equation
        txt = Tpl.writeStr(txt, i_it);
        txt = Tpl.nextIter(txt);
        txt = lm_67(txt, rest);
      then txt;
  end match;
end lm_67;

public function externalFunctionIncludes
  input Tpl.Text in_txt;
  input list<String> in_a_includes;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_includes)
    local
      Tpl.Text txt;
      list<String> i_includes;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_includes )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "#ifdef __cplusplus\n",
                                    "extern \"C\" {\n",
                                    "#endif\n"
                                }, true));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_67(txt, i_includes);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "#ifdef __cplusplus\n",
                                    "}\n",
                                    "#endif"
                                }, false));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;
  end match;
end externalFunctionIncludes;

protected function lm_69
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Function> in_items;
  input Tpl.Text in_a_staticPrototypes;
  input Boolean in_a_isSimulation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_staticPrototypes;
algorithm
  (out_txt, out_a_staticPrototypes) :=
  match(in_txt, in_items, in_a_staticPrototypes, in_a_isSimulation)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Function> rest;
      Tpl.Text a_staticPrototypes;
      Boolean a_isSimulation;
      SimCodeFunction.Function i_fn;

    case ( txt,
           {},
           a_staticPrototypes,
           _ )
      then (txt, a_staticPrototypes);

    case ( txt,
           i_fn :: rest,
           a_staticPrototypes,
           a_isSimulation )
      equation
        (txt, a_staticPrototypes) = functionHeader(txt, i_fn, false, a_isSimulation, a_staticPrototypes);
        txt = Tpl.nextIter(txt);
        (txt, a_staticPrototypes) = lm_69(txt, rest, a_staticPrototypes, a_isSimulation);
      then (txt, a_staticPrototypes);
  end match;
end lm_69;

public function functionHeaders
  input Tpl.Text txt;
  input list<SimCodeFunction.Function> a_functions;
  input Boolean a_isSimulation;
  input Tpl.Text a_staticPrototypes;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_staticPrototypes;
algorithm
  out_txt := Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING_LIST({
                                                                    "\n",
                                                                    "\n"
                                                                }, true)), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (out_txt, out_a_staticPrototypes) := lm_69(out_txt, a_functions, a_staticPrototypes, a_isSimulation);
  out_txt := Tpl.popIter(out_txt);
end functionHeaders;

public function functionHeadersParModelica
  input Tpl.Text txt;
  input String a_filePrefix;
  input list<SimCodeFunction.Function> a_functions;

  output Tpl.Text out_txt;
protected
  String ret_1;
  String ret_0;
algorithm
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING("#ifndef "));
  ret_0 := System.makeC89Identifier(a_filePrefix);
  out_txt := Tpl.writeStr(out_txt, ret_0);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "__H\n",
                                       "#define "
                                   }, false));
  ret_1 := System.makeC89Identifier(a_filePrefix);
  out_txt := Tpl.writeStr(out_txt, ret_1);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "__H\n",
                                       "//#include \"helper.cl\"\n",
                                       "\n"
                                   }, true));
  out_txt := parallelFunctionHeadersImpl(out_txt, a_functions);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "#endif\n",
                                       "\n"
                                   }, true));
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_NEW_LINE());
end functionHeadersParModelica;

protected function lm_72
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Function> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Function> rest;
      SimCodeFunction.Function i_fn;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_fn :: rest )
      equation
        txt = parallelFunctionHeader(txt, i_fn, false);
        txt = Tpl.nextIter(txt);
        txt = lm_72(txt, rest);
      then txt;
  end match;
end lm_72;

public function parallelFunctionHeadersImpl
  input Tpl.Text txt;
  input list<SimCodeFunction.Function> a_functions;

  output Tpl.Text out_txt;
algorithm
  out_txt := Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING_LIST({
                                                                    "\n",
                                                                    "\n"
                                                                }, true)), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_72(out_txt, a_functions);
  out_txt := Tpl.popIter(out_txt);
end parallelFunctionHeadersImpl;

protected function fun_74
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_staticPrototypes;
  input Boolean in_a_isSimulation;
  input SCode.Visibility in_a_visibility;
  input SimCodeFunction.Function in_a_fn;
  input Boolean in_a_inFunc;
  input list<SimCodeFunction.Variable> in_a_outVars;
  input list<SimCodeFunction.Variable> in_a_functionArguments;
  input Absyn.Path in_a_name;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_staticPrototypes;
algorithm
  (out_txt, out_a_staticPrototypes) :=
  match(in_txt, in_mArg, in_a_staticPrototypes, in_a_isSimulation, in_a_visibility, in_a_fn, in_a_inFunc, in_a_outVars, in_a_functionArguments, in_a_name)
    local
      Tpl.Text txt;
      Tpl.Text a_staticPrototypes;
      Boolean a_isSimulation;
      SCode.Visibility a_visibility;
      SimCodeFunction.Function a_fn;
      Boolean a_inFunc;
      list<SimCodeFunction.Variable> a_outVars;
      list<SimCodeFunction.Variable> a_functionArguments;
      Absyn.Path a_name;
      Boolean ret_1;
      Tpl.Text txt_0;

    case ( txt,
           false,
           a_staticPrototypes,
           a_isSimulation,
           a_visibility,
           a_fn,
           a_inFunc,
           a_outVars,
           a_functionArguments,
           a_name )
      equation
        txt_0 = CodegenUtil.underscorePath(Tpl.emptyTxt, a_name);
        ret_1 = SimCodeFunctionUtil.isBoxedFunction(a_fn);
        (txt, a_staticPrototypes) = functionHeaderBoxed(txt, Tpl.textString(txt_0), a_functionArguments, a_outVars, a_inFunc, ret_1, a_visibility, false, a_isSimulation, a_staticPrototypes);
      then (txt, a_staticPrototypes);

    case ( txt,
           _,
           a_staticPrototypes,
           _,
           _,
           _,
           _,
           _,
           _,
           _ )
      then (txt, a_staticPrototypes);
  end match;
end fun_74;

protected function lm_75
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      DAE.ComponentRef i_name;
      SimCodeFunction.Variable i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           (i_var as SimCodeFunction.VARIABLE(name = i_name)) :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = varType(txt, i_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" omc_"));
        txt = CodegenUtil.crefStr(txt, i_name);
        txt = lm_75(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_75(txt, rest);
      then txt;
  end match;
end lm_75;

protected function fun_76
  input Tpl.Text in_txt;
  input SCode.Visibility in_a_visibility;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_visibility)
    local
      Tpl.Text txt;

    case ( txt,
           SCode.PUBLIC() )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("DLLExport"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_76;

protected function fun_77
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_funArgsStr;
  input Tpl.Text in_a_fname;
  input Tpl.Text in_a_vis;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_funArgsStr, in_a_fname, in_a_vis)
    local
      Tpl.Text txt;
      Tpl.Text a_funArgsStr;
      Tpl.Text a_fname;
      Tpl.Text a_vis;

    case ( txt,
           false,
           a_funArgsStr,
           a_fname,
           a_vis )
      equation
        txt = Tpl.writeText(txt, a_vis);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, a_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" omc_"));
        txt = Tpl.writeText(txt, a_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" (threadData_t *threadData"));
        txt = Tpl.writeText(txt, a_funArgsStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;

    case ( txt,
           _,
           a_funArgsStr,
           a_fname,
           a_vis )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("typedef "));
        txt = Tpl.writeText(txt, a_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" (*omctd_"));
        txt = Tpl.writeText(txt, a_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")(threadData_t *threadData"));
        txt = Tpl.writeText(txt, a_funArgsStr);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(");\n"));
        txt = Tpl.writeText(txt, a_vis);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("omctd_"));
        txt = Tpl.writeText(txt, a_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" omc_"));
        txt = Tpl.writeText(txt, a_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_77;

public function functionHeader
  input Tpl.Text in_txt;
  input SimCodeFunction.Function in_a_fn;
  input Boolean in_a_inFunc;
  input Boolean in_a_isSimulation;
  input Tpl.Text in_a_staticPrototypes;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_staticPrototypes;
algorithm
  (out_txt, out_a_staticPrototypes) :=
  match(in_txt, in_a_fn, in_a_inFunc, in_a_isSimulation, in_a_staticPrototypes)
    local
      Tpl.Text txt;
      Boolean a_inFunc;
      Boolean a_isSimulation;
      Tpl.Text a_staticPrototypes;
      list<SimCodeFunction.Variable> i_funArgs;
      SimCodeFunction.Function i_fn;
      SCode.Visibility i_visibility;
      list<SimCodeFunction.Variable> i_outVars;
      list<SimCodeFunction.Variable> i_functionArguments;
      Absyn.Path i_name;
      Boolean ret_12;
      Tpl.Text l_vis;
      Tpl.Text l_funArgsStr;
      Tpl.Text l_fname;
      Boolean ret_8;
      Tpl.Text txt_7;
      Tpl.Text txt_6;
      Boolean ret_5;
      Tpl.Text txt_4;
      Tpl.Text txt_3;
      Tpl.Text txt_2;
      Boolean ret_1;
      Tpl.Text txt_0;

    case ( txt,
           (i_fn as SimCodeFunction.FUNCTION(name = i_name, functionArguments = i_functionArguments, outVars = i_outVars, visibility = i_visibility)),
           a_inFunc,
           a_isSimulation,
           a_staticPrototypes )
      equation
        txt_0 = CodegenUtil.underscorePath(Tpl.emptyTxt, i_name);
        (txt, a_staticPrototypes) = functionHeaderNormal(txt, Tpl.textString(txt_0), i_functionArguments, i_outVars, a_inFunc, i_visibility, false, a_isSimulation, a_staticPrototypes);
        txt = Tpl.softNewLine(txt);
        ret_1 = SimCodeFunctionUtil.funcHasParallelInOutArrays(i_fn);
        (txt, a_staticPrototypes) = fun_74(txt, ret_1, a_staticPrototypes, a_isSimulation, i_visibility, i_fn, a_inFunc, i_outVars, i_functionArguments, i_name);
      then (txt, a_staticPrototypes);

    case ( txt,
           SimCodeFunction.KERNEL_FUNCTION(name = i_name, functionArguments = i_functionArguments, outVars = i_outVars),
           _,
           _,
           a_staticPrototypes )
      equation
        txt_2 = CodegenUtil.underscorePath(Tpl.emptyTxt, i_name);
        txt = functionHeaderKernelFunctionInterface(txt, Tpl.textString(txt_2), i_functionArguments, i_outVars);
      then (txt, a_staticPrototypes);

    case ( txt,
           (i_fn as SimCodeFunction.EXTERNAL_FUNCTION(dynamicLoad = true, name = i_name, funArgs = i_funArgs, outVars = i_outVars, visibility = i_visibility)),
           a_inFunc,
           a_isSimulation,
           a_staticPrototypes )
      equation
        txt_3 = CodegenUtil.underscorePath(Tpl.emptyTxt, i_name);
        (txt, a_staticPrototypes) = functionHeaderNormal(txt, Tpl.textString(txt_3), i_funArgs, i_outVars, a_inFunc, i_visibility, true, a_isSimulation, a_staticPrototypes);
        txt = Tpl.softNewLine(txt);
        txt_4 = CodegenUtil.underscorePath(Tpl.emptyTxt, i_name);
        ret_5 = SimCodeFunctionUtil.isBoxedFunction(i_fn);
        (txt, a_staticPrototypes) = functionHeaderBoxed(txt, Tpl.textString(txt_4), i_funArgs, i_outVars, a_inFunc, ret_5, i_visibility, true, a_isSimulation, a_staticPrototypes);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = extFunDefDynamic(txt, i_fn);
      then (txt, a_staticPrototypes);

    case ( txt,
           (i_fn as SimCodeFunction.EXTERNAL_FUNCTION(name = i_name, funArgs = i_funArgs, outVars = i_outVars, visibility = i_visibility)),
           a_inFunc,
           a_isSimulation,
           a_staticPrototypes )
      equation
        txt_6 = CodegenUtil.underscorePath(Tpl.emptyTxt, i_name);
        (txt, a_staticPrototypes) = functionHeaderNormal(txt, Tpl.textString(txt_6), i_funArgs, i_outVars, a_inFunc, i_visibility, false, a_isSimulation, a_staticPrototypes);
        txt = Tpl.softNewLine(txt);
        txt_7 = CodegenUtil.underscorePath(Tpl.emptyTxt, i_name);
        ret_8 = SimCodeFunctionUtil.isBoxedFunction(i_fn);
        (txt, a_staticPrototypes) = functionHeaderBoxed(txt, Tpl.textString(txt_7), i_funArgs, i_outVars, a_inFunc, ret_8, i_visibility, false, a_isSimulation, a_staticPrototypes);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = extFunDef(txt, i_fn);
      then (txt, a_staticPrototypes);

    case ( txt,
           SimCodeFunction.RECORD_CONSTRUCTOR(name = i_name, funArgs = i_funArgs, visibility = i_visibility),
           a_inFunc,
           a_isSimulation,
           a_staticPrototypes )
      equation
        l_fname = CodegenUtil.underscorePath(Tpl.emptyTxt, i_name);
        l_funArgsStr = lm_75(Tpl.emptyTxt, i_funArgs);
        l_vis = fun_76(Tpl.emptyTxt, i_visibility);
        ret_12 = Flags.isSet(Flags.OMC_RELOCATABLE_FUNCTIONS);
        txt = fun_77(txt, ret_12, l_funArgsStr, l_fname, l_vis);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        (txt, a_staticPrototypes) = functionHeaderBoxed(txt, Tpl.textString(l_fname), i_funArgs, SimCodeFunction.boxedRecordOutVars, a_inFunc, false, i_visibility, false, a_isSimulation, a_staticPrototypes);
      then (txt, a_staticPrototypes);

    case ( txt,
           _,
           _,
           _,
           a_staticPrototypes )
      then (txt, a_staticPrototypes);
  end match;
end functionHeader;

public function parallelFunctionHeader
  input Tpl.Text in_txt;
  input SimCodeFunction.Function in_a_fn;
  input Boolean in_a_inFunc;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fn, in_a_inFunc)
    local
      Tpl.Text txt;
      Boolean a_inFunc;
      list<SimCodeFunction.Variable> i_outVars;
      list<SimCodeFunction.Variable> i_functionArguments;
      Absyn.Path i_name;
      Tpl.Text txt_0;

    case ( txt,
           SimCodeFunction.PARALLEL_FUNCTION(name = i_name, functionArguments = i_functionArguments, outVars = i_outVars),
           a_inFunc )
      equation
        txt_0 = CodegenUtil.underscorePath(Tpl.emptyTxt, i_name);
        txt = functionHeaderParallelImpl(txt, Tpl.textString(txt_0), i_functionArguments, i_outVars, a_inFunc, false);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end parallelFunctionHeader;

protected function lm_80
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      SimCodeFunction.Variable i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = funArgDefinitionKernelFunctionInterface(txt, i_var);
        txt = Tpl.nextIter(txt);
        txt = lm_80(txt, rest);
      then txt;
  end match;
end lm_80;

protected function lm_81
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      SimCodeFunction.Variable i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = tupleOutfunArgDefinitionKernelFunctionInterface(txt, i_var);
        txt = Tpl.nextIter(txt);
        txt = lm_81(txt, rest);
      then txt;
  end match;
end lm_81;

protected function fun_82
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_a_rest;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_rest)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> i_rest;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_81(txt, i_rest);
        txt = Tpl.popIter(txt);
      then txt;
  end match;
end fun_82;

protected function fun_83
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_a_outVars;
  input Tpl.Text in_a_fargsStr;
  input String in_a_fname;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_fargsStr;
algorithm
  (out_txt, out_a_fargsStr) :=
  match(in_txt, in_a_outVars, in_a_fargsStr, in_a_fname)
    local
      Tpl.Text txt;
      Tpl.Text a_fargsStr;
      String a_fname;
      list<SimCodeFunction.Variable> i_rest;
      SimCodeFunction.Variable i_fvar;
      Tpl.Text l_rettype;

    case ( txt,
           {},
           a_fargsStr,
           a_fname )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void omc_"));
        txt = Tpl.writeStr(txt, a_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_fargsStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_fargsStr);

    case ( txt,
           i_fvar :: i_rest,
           a_fargsStr,
           a_fname )
      equation
        l_rettype = varType(Tpl.emptyTxt, i_fvar);
        a_fargsStr = fun_82(a_fargsStr, i_rest);
        txt = Tpl.writeText(txt, l_rettype);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" omc_"));
        txt = Tpl.writeStr(txt, a_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_fargsStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_fargsStr);

    case ( txt,
           _,
           a_fargsStr,
           _ )
      equation
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 417, 13), "functionHeaderParallelImpl failed");
      then (txt, a_fargsStr);
  end match;
end fun_83;

public function functionHeaderParallelImpl
  input Tpl.Text txt;
  input String a_fname;
  input list<SimCodeFunction.Variable> a_fargs;
  input list<SimCodeFunction.Variable> a_outVars;
  input Boolean a_inFunc;
  input Boolean a_boxed;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_fargsStr;
algorithm
  l_fargsStr := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  l_fargsStr := lm_80(l_fargsStr, a_fargs);
  l_fargsStr := Tpl.popIter(l_fargsStr);
  (out_txt, l_fargsStr) := fun_83(txt, a_outVars, l_fargsStr, a_fname);
end functionHeaderParallelImpl;

protected function lm_85
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      DAE.ComponentRef i_name;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           SimCodeFunction.VARIABLE(name = i_name) :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        txt = CodegenUtil.crefStr(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        txt = Tpl.nextIter(txt);
        txt = lm_85(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_85(txt, rest);
      then txt;
  end match;
end lm_85;

protected function lm_86
  input Tpl.Text in_txt;
  input list<String> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<String> rest;
      String i_fname;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_fname :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        txt = Tpl.writeStr(txt, i_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        txt = Tpl.nextIter(txt);
        txt = lm_86(txt, rest);
      then txt;
  end match;
end lm_86;

public function recordDeclaration
  input Tpl.Text in_txt;
  input SimCodeFunction.RecordDeclaration in_a_recDecl;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_recDecl)
    local
      Tpl.Text txt;
      list<String> i_r_fieldNames;
      Absyn.Path i_r_path;
      String i_r_ctor__name;
      list<SimCodeFunction.Variable> i_r_variables;
      String i_r_name;
      list<SimCodeFunction.Variable> i_variables;
      Absyn.Path i_defPath;
      Integer ret_7;
      Tpl.Text txt_6;
      Tpl.Text txt_5;
      Tpl.Text txt_4;
      Integer ret_3;
      Tpl.Text txt_2;
      Tpl.Text txt_1;
      Tpl.Text txt_0;

    case ( txt,
           SimCodeFunction.RECORD_DECL_FULL(defPath = i_defPath, variables = (i_r_variables as i_variables), name = i_r_name) )
      equation
        txt_0 = CodegenUtil.dotPath(Tpl.emptyTxt, i_defPath);
        txt_1 = CodegenUtil.underscorePath(Tpl.emptyTxt, i_defPath);
        txt_2 = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt_2 = lm_85(txt_2, i_variables);
        txt_2 = Tpl.popIter(txt_2);
        ret_3 = listLength(i_variables);
        txt = recordDefinition(txt, Tpl.textString(txt_0), Tpl.textString(txt_1), Tpl.textString(txt_2), ret_3);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = recordConstructorDef(txt, i_r_name, i_r_name, i_r_variables);
        txt = Tpl.softNewLine(txt);
        txt = recordModelicaCallConstrctor(txt, i_r_name, i_r_variables);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = recordCopyDef(txt, i_r_name, i_r_variables);
      then txt;

    case ( txt,
           SimCodeFunction.RECORD_DECL_ADD_CONSTRCTOR(ctor_name = i_r_ctor__name, name = i_r_name, variables = i_r_variables) )
      equation
        txt = recordConstructorDef(txt, i_r_ctor__name, i_r_name, i_r_variables);
      then txt;

    case ( txt,
           SimCodeFunction.RECORD_DECL_DEF(path = i_r_path, fieldNames = i_r_fieldNames) )
      equation
        txt_4 = CodegenUtil.dotPath(Tpl.emptyTxt, i_r_path);
        txt_5 = CodegenUtil.underscorePath(Tpl.emptyTxt, i_r_path);
        txt_6 = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt_6 = lm_86(txt_6, i_r_fieldNames);
        txt_6 = Tpl.popIter(txt_6);
        ret_7 = listLength(i_r_fieldNames);
        txt = recordDefinition(txt, Tpl.textString(txt_4), Tpl.textString(txt_5), Tpl.textString(txt_6), ret_7);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end recordDeclaration;

public function recordDeclarationHeader
  input Tpl.Text in_txt;
  input SimCodeFunction.RecordDeclaration in_a_recDecl;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_recDecl)
    local
      Tpl.Text txt;
      Absyn.Path i_r_path;
      SimCodeFunction.RecordDeclaration i_r;

    case ( txt,
           (i_r as SimCodeFunction.RECORD_DECL_FULL(name = _)) )
      equation
        txt = recordDeclarationFullHeader(txt, i_r);
      then txt;

    case ( txt,
           (i_r as SimCodeFunction.RECORD_DECL_ADD_CONSTRCTOR(ctor_name = _)) )
      equation
        txt = recordDeclarationExtraCtor(txt, i_r);
      then txt;

    case ( txt,
           SimCodeFunction.RECORD_DECL_DEF(path = i_r_path) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("extern struct record_description "));
        txt = CodegenUtil.underscorePath(txt, i_r_path);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("__desc;"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end recordDeclarationHeader;

protected function fun_89
  input Tpl.Text in_txt;
  input Boolean in_a_var_bind__from__outside;
  input DAE.ComponentRef in_a_var_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_var_bind__from__outside, in_a_var_name)
    local
      Tpl.Text txt;
      DAE.ComponentRef a_var_name;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_var_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("in_"));
        txt = CodegenUtil.crefStr(txt, a_var_name);
      then txt;
  end match;
end fun_89;

protected function lm_90
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      DAE.ComponentRef i_var_name;
      Boolean i_var_bind__from__outside;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           SimCodeFunction.VARIABLE(bind_from_outside = i_var_bind__from__outside, name = i_var_name) :: rest )
      equation
        txt = fun_89(txt, i_var_bind__from__outside, i_var_name);
        txt = lm_90(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_90(txt, rest);
      then txt;
  end match;
end lm_90;

protected function fun_91
  input Tpl.Text in_txt;
  input Boolean in_a_var_bind__from__outside;
  input DAE.ComponentRef in_a_var_name;
  input SimCodeFunction.Variable in_a_var;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_var_bind__from__outside, in_a_var_name, in_a_var)
    local
      Tpl.Text txt;
      DAE.ComponentRef a_var_name;
      SimCodeFunction.Variable a_var;

    case ( txt,
           false,
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_var_name,
           a_var )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = varType(txt, a_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" in_"));
        txt = CodegenUtil.crefStr(txt, a_var_name);
      then txt;
  end match;
end fun_91;

protected function lm_92
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      DAE.ComponentRef i_var_name;
      SimCodeFunction.Variable i_var;
      Boolean i_var_bind__from__outside;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           (i_var as SimCodeFunction.VARIABLE(bind_from_outside = i_var_bind__from__outside, name = i_var_name)) :: rest )
      equation
        txt = fun_91(txt, i_var_bind__from__outside, i_var_name, i_var);
        txt = lm_92(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_92(txt, rest);
      then txt;
  end match;
end lm_92;

public function recordDeclarationExtraCtor
  input Tpl.Text in_txt;
  input SimCodeFunction.RecordDeclaration in_a_recDecl;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_recDecl)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> i_r_variables;
      String i_r_name;
      String i_r_ctor__name;
      Tpl.Text l_ctor__additional__inputs;
      Tpl.Text l_ctor__func__name;
      Tpl.Text l_ctor__macro__additional__inputs;
      Tpl.Text l_ctor__macro__name;
      Tpl.Text l_rec__name;
      Tpl.Text l_ctor__name;

    case ( txt,
           SimCodeFunction.RECORD_DECL_ADD_CONSTRCTOR(ctor_name = i_r_ctor__name, name = i_r_name, variables = i_r_variables) )
      equation
        l_ctor__name = Tpl.writeStr(Tpl.emptyTxt, i_r_ctor__name);
        l_rec__name = Tpl.writeStr(Tpl.emptyTxt, i_r_name);
        l_ctor__macro__name = Tpl.writeText(Tpl.emptyTxt, l_ctor__name);
        l_ctor__macro__name = Tpl.writeTok(l_ctor__macro__name, Tpl.ST_STRING("_construct"));
        l_ctor__macro__additional__inputs = lm_90(Tpl.emptyTxt, i_r_variables);
        l_ctor__func__name = Tpl.writeText(Tpl.emptyTxt, l_ctor__macro__name);
        l_ctor__func__name = Tpl.writeTok(l_ctor__func__name, Tpl.ST_STRING("_p"));
        l_ctor__additional__inputs = lm_92(Tpl.emptyTxt, i_r_variables);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = Tpl.writeText(txt, l_ctor__func__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(threadData_t *threadData, void* v_ths "));
        txt = Tpl.writeText(txt, l_ctor__additional__inputs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ");\n",
                                    "#define "
                                }, false));
        txt = Tpl.writeText(txt, l_ctor__macro__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(td, ths "));
        txt = Tpl.writeText(txt, l_ctor__macro__additional__inputs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") "));
        txt = Tpl.writeText(txt, l_ctor__func__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(td, &ths "));
        txt = Tpl.writeText(txt, l_ctor__macro__additional__inputs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ")\n",
                                    "\n",
                                    "#define alloc_"
                                }, false));
        txt = Tpl.writeText(txt, l_ctor__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_array(dst,ndims,...) generic_array_create(NULL, dst, "));
        txt = Tpl.writeText(txt, l_ctor__func__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", ndims, sizeof("));
        txt = Tpl.writeText(txt, l_rec__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("), __VA_ARGS__)"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end recordDeclarationExtraCtor;

protected function fun_94
  input Tpl.Text in_txt;
  input Boolean in_a_var_bind__from__outside;
  input DAE.ComponentRef in_a_var_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_var_bind__from__outside, in_a_var_name)
    local
      Tpl.Text txt;
      DAE.ComponentRef a_var_name;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_var_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("in_"));
        txt = CodegenUtil.crefStr(txt, a_var_name);
      then txt;
  end match;
end fun_94;

protected function lm_95
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      DAE.ComponentRef i_var_name;
      Boolean i_var_bind__from__outside;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           SimCodeFunction.VARIABLE(bind_from_outside = i_var_bind__from__outside, name = i_var_name) :: rest )
      equation
        txt = fun_94(txt, i_var_bind__from__outside, i_var_name);
        txt = lm_95(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_95(txt, rest);
      then txt;
  end match;
end lm_95;

protected function fun_96
  input Tpl.Text in_txt;
  input Boolean in_a_var_bind__from__outside;
  input DAE.ComponentRef in_a_var_name;
  input SimCodeFunction.Variable in_a_var;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_var_bind__from__outside, in_a_var_name, in_a_var)
    local
      Tpl.Text txt;
      DAE.ComponentRef a_var_name;
      SimCodeFunction.Variable a_var;

    case ( txt,
           false,
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_var_name,
           a_var )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = varType(txt, a_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" in_"));
        txt = CodegenUtil.crefStr(txt, a_var_name);
      then txt;
  end match;
end fun_96;

protected function lm_97
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      DAE.ComponentRef i_var_name;
      SimCodeFunction.Variable i_var;
      Boolean i_var_bind__from__outside;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           (i_var as SimCodeFunction.VARIABLE(bind_from_outside = i_var_bind__from__outside, name = i_var_name)) :: rest )
      equation
        txt = fun_96(txt, i_var_bind__from__outside, i_var_name, i_var);
        txt = lm_97(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_97(txt, rest);
      then txt;
  end match;
end lm_97;

protected function lm_98
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      DAE.ComponentRef i_var_name;
      SimCodeFunction.Variable i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           (i_var as SimCodeFunction.VARIABLE(name = i_var_name)) :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = varType(txt, i_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("* in_"));
        txt = CodegenUtil.crefStr(txt, i_var_name);
        txt = lm_98(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_98(txt, rest);
      then txt;
  end match;
end lm_98;

protected function lm_99
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      DAE.ComponentRef i_var_name;
      SimCodeFunction.Variable i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           (i_var as SimCodeFunction.VARIABLE(name = i_var_name)) :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = varType(txt, i_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" in_"));
        txt = CodegenUtil.crefStr(txt, i_var_name);
        txt = lm_99(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_99(txt, rest);
      then txt;
  end match;
end lm_99;

protected function lm_100
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      DAE.ComponentRef i_var_name;
      SimCodeFunction.Variable i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           (i_var as SimCodeFunction.VARIABLE(name = i_var_name)) :: rest )
      equation
        txt = varType(txt, i_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" _"));
        txt = CodegenUtil.crefStr(txt, i_var_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        txt = lm_100(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_100(txt, rest);
      then txt;
  end match;
end lm_100;

protected function fun_101
  input Tpl.Text in_txt;
  input Option<String> in_a_aliasName;
  input list<SimCodeFunction.Variable> in_a_r_variables;
  input Tpl.Text in_a_rec__name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_aliasName, in_a_r_variables, in_a_rec__name)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> a_r_variables;
      Tpl.Text a_rec__name;
      String i_str;

    case ( txt,
           SOME(i_str),
           _,
           a_rec__name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("typedef "));
        txt = Tpl.writeStr(txt, i_str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, a_rec__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           _,
           a_r_variables,
           a_rec__name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("typedef struct {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_100(txt, a_r_variables);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("} "));
        txt = Tpl.writeText(txt, a_rec__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_101;

public function recordDeclarationFullHeader
  input Tpl.Text in_txt;
  input SimCodeFunction.RecordDeclaration in_a_recDecl;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_recDecl)
    local
      Tpl.Text txt;
      Absyn.Path i_r_defPath;
      Option<String> i_aliasName;
      list<SimCodeFunction.Variable> i_r_variables;
      String i_r_name;
      Tpl.Text l_modelica__ctor__inputs;
      Tpl.Text l_modelica__ctor__name;
      Tpl.Text l_copy__to__vars__inputs;
      Tpl.Text l_copy__to__vars__name__p;
      Tpl.Text l_copy__to__vars__name;
      Tpl.Text l_cpy__func__name;
      Tpl.Text l_cpy__macro__name;
      Tpl.Text l_ctor__additional__inputs;
      Tpl.Text l_ctor__func__name;
      Tpl.Text l_ctor__macro__additional__inputs;
      Tpl.Text l_ctor__macro__name;
      Tpl.Text l_rec__name;

    case ( txt,
           SimCodeFunction.RECORD_DECL_FULL(name = i_r_name, variables = i_r_variables, aliasName = i_aliasName, defPath = i_r_defPath) )
      equation
        l_rec__name = Tpl.writeStr(Tpl.emptyTxt, i_r_name);
        l_ctor__macro__name = Tpl.writeText(Tpl.emptyTxt, l_rec__name);
        l_ctor__macro__name = Tpl.writeTok(l_ctor__macro__name, Tpl.ST_STRING("_construct"));
        l_ctor__macro__additional__inputs = lm_95(Tpl.emptyTxt, i_r_variables);
        l_ctor__func__name = Tpl.writeText(Tpl.emptyTxt, l_ctor__macro__name);
        l_ctor__func__name = Tpl.writeTok(l_ctor__func__name, Tpl.ST_STRING("_p"));
        l_ctor__additional__inputs = lm_97(Tpl.emptyTxt, i_r_variables);
        l_cpy__macro__name = Tpl.writeText(Tpl.emptyTxt, l_rec__name);
        l_cpy__macro__name = Tpl.writeTok(l_cpy__macro__name, Tpl.ST_STRING("_copy"));
        l_cpy__func__name = Tpl.writeText(Tpl.emptyTxt, l_cpy__macro__name);
        l_cpy__func__name = Tpl.writeTok(l_cpy__func__name, Tpl.ST_STRING("_p"));
        l_copy__to__vars__name = Tpl.writeText(Tpl.emptyTxt, l_rec__name);
        l_copy__to__vars__name = Tpl.writeTok(l_copy__to__vars__name, Tpl.ST_STRING("_copy_to_vars"));
        l_copy__to__vars__name__p = Tpl.writeText(Tpl.emptyTxt, l_copy__to__vars__name);
        l_copy__to__vars__name__p = Tpl.writeTok(l_copy__to__vars__name__p, Tpl.ST_STRING("_p"));
        l_copy__to__vars__inputs = lm_98(Tpl.emptyTxt, i_r_variables);
        l_modelica__ctor__name = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("omc_"));
        l_modelica__ctor__name = Tpl.writeText(l_modelica__ctor__name, l_rec__name);
        l_modelica__ctor__inputs = lm_99(Tpl.emptyTxt, i_r_variables);
        txt = fun_101(txt, i_aliasName, i_r_variables, l_rec__name);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("extern struct record_description "));
        txt = CodegenUtil.underscorePath(txt, i_r_defPath);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "__desc;\n",
                                    "\n",
                                    "void "
                                }, false));
        txt = Tpl.writeText(txt, l_ctor__func__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(threadData_t *threadData, void* v_ths "));
        txt = Tpl.writeText(txt, l_ctor__additional__inputs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ");\n",
                                    "#define "
                                }, false));
        txt = Tpl.writeText(txt, l_ctor__macro__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(td, ths "));
        txt = Tpl.writeText(txt, l_ctor__macro__additional__inputs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") "));
        txt = Tpl.writeText(txt, l_ctor__func__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(td, &ths "));
        txt = Tpl.writeText(txt, l_ctor__macro__additional__inputs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ")\n",
                                    "void "
                                }, false));
        txt = Tpl.writeText(txt, l_cpy__func__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(void* v_src, void* v_dst);\n",
                                    "#define "
                                }, false));
        txt = Tpl.writeText(txt, l_cpy__macro__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(src,dst) "));
        txt = Tpl.writeText(txt, l_cpy__func__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(&src, &dst)\n",
                                    "\n",
                                    "// This function should eventualy replace the default \'modelica\' record constructor funcition\n",
                                    "// that omc used to generate, i.e., replace functionBodyRecordConstructor template.\n",
                                    "// "
                                }, false));
        txt = Tpl.writeText(txt, l_rec__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, l_modelica__ctor__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(threadData_t *threadData "));
        txt = Tpl.writeText(txt, l_modelica__ctor__inputs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ");\n",
                                    "\n",
                                    "// This function is not needed anymore. If you want to know how a record\n",
                                    "// is \'assigned to\' in simulation context see assignRhsExpToRecordCrefSimContext and\n",
                                    "// splitRecordAssignmentToMemberAssignments (simCode). Basically the record is\n",
                                    "// split up assignments generated for each memeber individualy.\n",
                                    "// void "
                                }, false));
        txt = Tpl.writeText(txt, l_copy__to__vars__name__p);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(void* v_src "));
        txt = Tpl.writeText(txt, l_copy__to__vars__inputs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ");\n",
                                    "// #define "
                                }, false));
        txt = Tpl.writeText(txt, l_copy__to__vars__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(src,...) "));
        txt = Tpl.writeText(txt, l_copy__to__vars__name__p);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(&src, __VA_ARGS__)\n",
                                    "\n",
                                    "typedef base_array_t "
                                }, false));
        txt = Tpl.writeText(txt, l_rec__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_array;\n",
                                    "#define alloc_"
                                }, false));
        txt = Tpl.writeText(txt, l_rec__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_array(dst,ndims,...) generic_array_create(NULL, dst, "));
        txt = Tpl.writeText(txt, l_ctor__func__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", ndims, sizeof("));
        txt = Tpl.writeText(txt, l_rec__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "), __VA_ARGS__)\n",
                                    "#define "
                                }, false));
        txt = Tpl.writeText(txt, l_rec__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_array_copy_data(src,dst)   generic_array_copy_data(src, &dst, "));
        txt = Tpl.writeText(txt, l_cpy__func__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", sizeof("));
        txt = Tpl.writeText(txt, l_rec__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "))\n",
                                    "#define "
                                }, false));
        txt = Tpl.writeText(txt, l_rec__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_array_alloc_copy(src,dst)  generic_array_alloc_copy(src, &dst, "));
        txt = Tpl.writeText(txt, l_cpy__func__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", sizeof("));
        txt = Tpl.writeText(txt, l_rec__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "))\n",
                                    "#define "
                                }, false));
        txt = Tpl.writeText(txt, l_rec__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_array_get(src,ndims,...)   (*("));
        txt = Tpl.writeText(txt, l_rec__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("*)(generic_array_get(&src, sizeof("));
        txt = Tpl.writeText(txt, l_rec__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "), __VA_ARGS__)))\n",
                                    "#define "
                                }, false));
        txt = Tpl.writeText(txt, l_rec__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_set(dst,val,...)           generic_array_set(&dst, &val, "));
        txt = Tpl.writeText(txt, l_cpy__func__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", sizeof("));
        txt = Tpl.writeText(txt, l_rec__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("), __VA_ARGS__)"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end recordDeclarationFullHeader;

protected function lm_103
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varCopies;
  input Tpl.Text in_a_dst__pref;
  input Tpl.Text in_a_src__pref;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varCopies;
algorithm
  (out_txt, out_a_auxFunction, out_a_varCopies) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varCopies, in_a_dst__pref, in_a_src__pref)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varCopies;
      Tpl.Text a_dst__pref;
      Tpl.Text a_src__pref;
      SimCodeFunction.Variable i_var;

    case ( txt,
           {},
           a_auxFunction,
           a_varCopies,
           _,
           _ )
      then (txt, a_auxFunction, a_varCopies);

    case ( txt,
           i_var :: rest,
           a_auxFunction,
           a_varCopies,
           a_dst__pref,
           a_src__pref )
      equation
        (txt, a_varCopies, a_auxFunction) = recordMemberCopy(txt, i_var, Tpl.textString(a_src__pref), Tpl.textString(a_dst__pref), a_varCopies, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varCopies) = lm_103(txt, rest, a_auxFunction, a_varCopies, a_dst__pref, a_src__pref);
      then (txt, a_auxFunction, a_varCopies);
  end match;
end lm_103;

public function recordCopyDef
  input Tpl.Text txt;
  input String a_rec__name;
  input list<SimCodeFunction.Variable> a_variables;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_0__;
  Tpl.Text l_src__pref;
  Tpl.Text l_dst__pref;
  Tpl.Text l_auxFunction;
  Tpl.Text l_varCopies;
algorithm
  l_varCopies := Tpl.emptyTxt;
  l_auxFunction := Tpl.emptyTxt;
  l_dst__pref := Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("dst->"));
  l_src__pref := Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("src->"));
  l_0__ := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (l_0__, l_auxFunction, l_varCopies) := lm_103(l_0__, a_variables, l_auxFunction, l_varCopies, l_dst__pref, l_src__pref);
  l_0__ := Tpl.popIter(l_0__);
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING("void "));
  out_txt := Tpl.writeStr(out_txt, a_rec__name);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("_copy_p(void* v_src, void* v_dst) {\n"));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeStr(out_txt, a_rec__name);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("* src = ("));
  out_txt := Tpl.writeStr(out_txt, a_rec__name);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("*)(v_src);\n"));
  out_txt := Tpl.writeStr(out_txt, a_rec__name);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("* dst = ("));
  out_txt := Tpl.writeStr(out_txt, a_rec__name);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("*)(v_dst);\n"));
  out_txt := Tpl.writeText(out_txt, l_varCopies);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("}"));
end recordCopyDef;

protected function lm_105
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varCopies;
  input Tpl.Text in_a_dst__pref;
  input Tpl.Text in_a_src__pref;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varCopies;
algorithm
  (out_txt, out_a_auxFunction, out_a_varCopies) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varCopies, in_a_dst__pref, in_a_src__pref)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varCopies;
      Tpl.Text a_dst__pref;
      Tpl.Text a_src__pref;
      SimCodeFunction.Variable i_var;

    case ( txt,
           {},
           a_auxFunction,
           a_varCopies,
           _,
           _ )
      then (txt, a_auxFunction, a_varCopies);

    case ( txt,
           i_var :: rest,
           a_auxFunction,
           a_varCopies,
           a_dst__pref,
           a_src__pref )
      equation
        (txt, a_varCopies, a_auxFunction) = recordMemberCopy(txt, i_var, Tpl.textString(a_src__pref), Tpl.textString(a_dst__pref), a_varCopies, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varCopies) = lm_105(txt, rest, a_auxFunction, a_varCopies, a_dst__pref, a_src__pref);
      then (txt, a_auxFunction, a_varCopies);
  end match;
end lm_105;

protected function lm_106
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_src__pref;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_auxFunction) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_src__pref)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_src__pref;
      DAE.ComponentRef i_var_name;
      SimCodeFunction.Variable i_var;

    case ( txt,
           {},
           a_auxFunction,
           _ )
      then (txt, a_auxFunction);

    case ( txt,
           (i_var as SimCodeFunction.VARIABLE(name = i_var_name)) :: rest,
           a_auxFunction,
           a_src__pref )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = varType(txt, i_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, a_src__pref);
        (txt, a_auxFunction) = contextCrefNoPrevExp(txt, i_var_name, SimCodeFunction.contextFunction, a_auxFunction);
        (txt, a_auxFunction) = lm_106(txt, rest, a_auxFunction, a_src__pref);
      then (txt, a_auxFunction);

    case ( txt,
           _ :: rest,
           a_auxFunction,
           a_src__pref )
      equation
        (txt, a_auxFunction) = lm_106(txt, rest, a_auxFunction, a_src__pref);
      then (txt, a_auxFunction);
  end match;
end lm_106;

public function recordModelicaCallConstrctor
  input Tpl.Text txt;
  input String a_rec__name;
  input list<SimCodeFunction.Variable> a_variables;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_inputs;
  Tpl.Text l_0__;
  Tpl.Text l_src__pref;
  Tpl.Text l_dst__pref;
  Tpl.Text l_auxFunction;
  Tpl.Text l_varCopies;
algorithm
  l_varCopies := Tpl.emptyTxt;
  l_auxFunction := Tpl.emptyTxt;
  l_dst__pref := Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("dst."));
  l_src__pref := Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING(" in"));
  l_0__ := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (l_0__, l_auxFunction, l_varCopies) := lm_105(l_0__, a_variables, l_auxFunction, l_varCopies, l_dst__pref, l_src__pref);
  l_0__ := Tpl.popIter(l_0__);
  (l_inputs, l_auxFunction) := lm_106(Tpl.emptyTxt, a_variables, l_auxFunction, l_src__pref);
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                   "// This function should eventualy replace the default \'modelica\' record constructor funcition\n",
                                   "// that omc used to generate, i.e., replace functionBodyRecordConstructor template.\n",
                                   "/*\n"
                               }, true));
  out_txt := Tpl.writeStr(out_txt, a_rec__name);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING(" omc_"));
  out_txt := Tpl.writeStr(out_txt, a_rec__name);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("(threadData_t *threadData "));
  out_txt := Tpl.writeText(out_txt, l_inputs);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE(") {\n"));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeStr(out_txt, a_rec__name);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       " dst;\n",
                                       "// TODO Improve me. No need to initalize the record memebers with defaults in "
                                   }, false));
  out_txt := Tpl.writeStr(out_txt, a_rec__name);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "_construct\n",
                                       "// We should just do the allocs here and then copy the input parameters as default values instead.\n"
                                   }, true));
  out_txt := Tpl.writeStr(out_txt, a_rec__name);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("_construct(threadData, dst);\n"));
  out_txt := Tpl.writeText(out_txt, l_varCopies);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("return dst;\n"));
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "}\n",
                                       "*/"
                                   }, false));
end recordModelicaCallConstrctor;

protected function fun_108
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;
  input Tpl.Text in_a_dstName;
  input Tpl.Text in_a_srcName;
  input Tpl.Text in_a_varCopies;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varCopies;
algorithm
  (out_txt, out_a_varCopies) :=
  match(in_txt, in_a_ty, in_a_dstName, in_a_srcName, in_a_varCopies)
    local
      Tpl.Text txt;
      Tpl.Text a_dstName;
      Tpl.Text a_srcName;
      Tpl.Text a_varCopies;
      DAE.Type i_ty;
      Tpl.Text l_recType;
      Tpl.Text l_varType;

    case ( txt,
           (i_ty as DAE.T_ARRAY(ty = _)),
           a_dstName,
           a_srcName,
           a_varCopies )
      equation
        l_varType = expTypeShort(Tpl.emptyTxt, i_ty);
        a_varCopies = Tpl.writeText(a_varCopies, l_varType);
        a_varCopies = Tpl.writeTok(a_varCopies, Tpl.ST_STRING("_array_copy_data("));
        a_varCopies = Tpl.writeText(a_varCopies, a_srcName);
        a_varCopies = Tpl.writeTok(a_varCopies, Tpl.ST_STRING(", "));
        a_varCopies = Tpl.writeText(a_varCopies, a_dstName);
        a_varCopies = Tpl.writeTok(a_varCopies, Tpl.ST_STRING(");"));
        a_varCopies = Tpl.writeTok(a_varCopies, Tpl.ST_NEW_LINE());
      then (txt, a_varCopies);

    case ( txt,
           (i_ty as DAE.T_COMPLEX(complexClassType = ClassInf.RECORD(path = _))),
           a_dstName,
           a_srcName,
           a_varCopies )
      equation
        l_recType = expTypeShort(Tpl.emptyTxt, i_ty);
        a_varCopies = Tpl.writeText(a_varCopies, l_recType);
        a_varCopies = Tpl.writeTok(a_varCopies, Tpl.ST_STRING("_copy("));
        a_varCopies = Tpl.writeText(a_varCopies, a_srcName);
        a_varCopies = Tpl.writeTok(a_varCopies, Tpl.ST_STRING(", "));
        a_varCopies = Tpl.writeText(a_varCopies, a_dstName);
        a_varCopies = Tpl.writeTok(a_varCopies, Tpl.ST_STRING(");"));
        a_varCopies = Tpl.writeTok(a_varCopies, Tpl.ST_NEW_LINE());
      then (txt, a_varCopies);

    case ( txt,
           _,
           a_dstName,
           a_srcName,
           a_varCopies )
      equation
        a_varCopies = Tpl.writeText(a_varCopies, a_dstName);
        a_varCopies = Tpl.writeTok(a_varCopies, Tpl.ST_STRING(" = "));
        a_varCopies = Tpl.writeText(a_varCopies, a_srcName);
        a_varCopies = Tpl.writeTok(a_varCopies, Tpl.ST_STRING(";"));
        a_varCopies = Tpl.writeTok(a_varCopies, Tpl.ST_NEW_LINE());
      then (txt, a_varCopies);
  end match;
end fun_108;

public function recordMemberCopy
  input Tpl.Text in_txt;
  input SimCodeFunction.Variable in_a_var;
  input String in_a_src__pref;
  input String in_a_dst__pref;
  input Tpl.Text in_a_varCopies;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varCopies;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varCopies, out_a_auxFunction) :=
  match(in_txt, in_a_var, in_a_src__pref, in_a_dst__pref, in_a_varCopies, in_a_auxFunction)
    local
      Tpl.Text txt;
      String a_src__pref;
      String a_dst__pref;
      Tpl.Text a_varCopies;
      Tpl.Text a_auxFunction;
      DAE.Type i_ty;
      DAE.ComponentRef i_var_name;
      Tpl.Text l_srcName;
      Tpl.Text l_dstName;

    case ( txt,
           SimCodeFunction.VARIABLE(name = i_var_name, ty = i_ty),
           a_src__pref,
           a_dst__pref,
           a_varCopies,
           a_auxFunction )
      equation
        l_dstName = Tpl.writeStr(Tpl.emptyTxt, a_dst__pref);
        (l_dstName, a_auxFunction) = contextCrefNoPrevExp(l_dstName, i_var_name, SimCodeFunction.contextFunction, a_auxFunction);
        l_srcName = Tpl.writeStr(Tpl.emptyTxt, a_src__pref);
        (l_srcName, a_auxFunction) = contextCrefNoPrevExp(l_srcName, i_var_name, SimCodeFunction.contextFunction, a_auxFunction);
        (txt, a_varCopies) = fun_108(txt, i_ty, l_dstName, l_srcName, a_varCopies);
      then (txt, a_varCopies, a_auxFunction);

    case ( txt,
           _,
           _,
           _,
           a_varCopies,
           a_auxFunction )
      then (txt, a_varCopies, a_auxFunction);
  end match;
end recordMemberCopy;

protected function fun_110
  input Tpl.Text in_txt;
  input Boolean in_a_var_bind__from__outside;
  input Tpl.Text in_a_auxFunction;
  input DAE.ComponentRef in_a_var_name;
  input SimCodeFunction.Variable in_a_var;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_auxFunction) :=
  match(in_txt, in_a_var_bind__from__outside, in_a_auxFunction, in_a_var_name, in_a_var)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      DAE.ComponentRef a_var_name;
      SimCodeFunction.Variable a_var;

    case ( txt,
           false,
           a_auxFunction,
           _,
           _ )
      then (txt, a_auxFunction);

    case ( txt,
           _,
           a_auxFunction,
           a_var_name,
           a_var )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = varType(txt, a_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" in"));
        (txt, a_auxFunction) = contextCrefNoPrevExp(txt, a_var_name, SimCodeFunction.contextFunction, a_auxFunction);
      then (txt, a_auxFunction);
  end match;
end fun_110;

protected function lm_111
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_auxFunction) :=
  match(in_txt, in_items, in_a_auxFunction)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      Tpl.Text a_auxFunction;
      DAE.ComponentRef i_var_name;
      SimCodeFunction.Variable i_var;
      Boolean i_var_bind__from__outside;

    case ( txt,
           {},
           a_auxFunction )
      then (txt, a_auxFunction);

    case ( txt,
           (i_var as SimCodeFunction.VARIABLE(bind_from_outside = i_var_bind__from__outside, name = i_var_name)) :: rest,
           a_auxFunction )
      equation
        (txt, a_auxFunction) = fun_110(txt, i_var_bind__from__outside, a_auxFunction, i_var_name, i_var);
        (txt, a_auxFunction) = lm_111(txt, rest, a_auxFunction);
      then (txt, a_auxFunction);

    case ( txt,
           _ :: rest,
           a_auxFunction )
      equation
        (txt, a_auxFunction) = lm_111(txt, rest, a_auxFunction);
      then (txt, a_auxFunction);
  end match;
end lm_111;

protected function lm_112
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      SimCodeFunction.Variable i_var;
      SimCodeFunction.Context ret_0;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls )
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           i_var :: rest,
           a_auxFunction,
           a_varDecls )
      equation
        ret_0 = SimCodeFunctionUtil.appendCurrentCrefPrefix(SimCodeFunction.contextFunction, "ths->");
        (txt, a_varDecls, a_auxFunction) = recordMemberAllocInit(txt, i_var, ret_0, a_varDecls, a_auxFunction);
        (txt, a_auxFunction, a_varDecls) = lm_112(txt, rest, a_auxFunction, a_varDecls);
      then (txt, a_auxFunction, a_varDecls);
  end match;
end lm_112;

public function recordConstructorDef
  input Tpl.Text txt;
  input String a_ctor__name;
  input String a_rec__name;
  input list<SimCodeFunction.Variable> a_variables;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_varInits;
  Tpl.Text l_ctor__additional__inputs;
  Tpl.Text l_auxFunction;
  Tpl.Text l_varDecls;
algorithm
  l_varDecls := Tpl.emptyTxt;
  l_auxFunction := Tpl.emptyTxt;
  (l_ctor__additional__inputs, l_auxFunction) := lm_111(Tpl.emptyTxt, a_variables, l_auxFunction);
  (l_varInits, l_auxFunction, l_varDecls) := lm_112(Tpl.emptyTxt, a_variables, l_auxFunction, l_varDecls);
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING("void "));
  out_txt := Tpl.writeStr(out_txt, a_ctor__name);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("_construct_p(threadData_t *threadData, void* v_ths "));
  out_txt := Tpl.writeText(out_txt, l_ctor__additional__inputs);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE(") {\n"));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeStr(out_txt, a_rec__name);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("* ths = ("));
  out_txt := Tpl.writeStr(out_txt, a_rec__name);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("*)(v_ths);\n"));
  out_txt := Tpl.writeText(out_txt, l_varDecls);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeText(out_txt, l_varInits);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("}"));
end recordConstructorDef;

protected function fun_114
  input Tpl.Text in_txt;
  input DAE.Type in_a_var_ty;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input SimCodeFunction.Context in_a_context;
  input Boolean in_a_var_bind__from__outside;
  input Option<DAE.Exp> in_a_var_value;
  input DAE.ComponentRef in_a_var_name;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_a_var_ty, in_a_auxFunction, in_a_varDecls, in_a_context, in_a_var_bind__from__outside, in_a_var_value, in_a_var_name)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      SimCodeFunction.Context a_context;
      Boolean a_var_bind__from__outside;
      Option<DAE.Exp> a_var_value;
      DAE.ComponentRef a_var_name;
      DAE.Dimensions i_ty_dims;
      DAE.Type i_ty;

    case ( txt,
           (i_ty as DAE.T_ARRAY(dims = i_ty_dims)),
           a_auxFunction,
           a_varDecls,
           a_context,
           a_var_bind__from__outside,
           a_var_value,
           a_var_name )
      equation
        (txt, a_varDecls, a_auxFunction) = arrayVarAllocInit(txt, a_var_name, i_ty, i_ty_dims, a_var_value, a_var_bind__from__outside, a_context, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           (i_ty as DAE.T_COMPLEX(complexClassType = ClassInf.RECORD(path = _))),
           a_auxFunction,
           a_varDecls,
           a_context,
           a_var_bind__from__outside,
           a_var_value,
           a_var_name )
      equation
        (txt, a_varDecls, a_auxFunction) = recordVarAllocInit(txt, a_var_value, a_var_name, a_var_bind__from__outside, i_ty, a_context, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           _,
           a_auxFunction,
           a_varDecls,
           a_context,
           a_var_bind__from__outside,
           a_var_value,
           a_var_name )
      equation
        (txt, a_varDecls, a_auxFunction) = simpleVarInit(txt, a_var_value, a_var_name, a_var_bind__from__outside, a_context, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls);
  end match;
end fun_114;

public function recordMemberAllocInit
  input Tpl.Text in_txt;
  input SimCodeFunction.Variable in_a_var;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_var, in_a_context, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      Boolean i_var_bind__from__outside;
      Option<DAE.Exp> i_var_value;
      DAE.ComponentRef i_var_name;
      DAE.Type i_var_ty;

    case ( txt,
           SimCodeFunction.VARIABLE(ty = i_var_ty, name = i_var_name, value = i_var_value, bind_from_outside = i_var_bind__from__outside),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_auxFunction, a_varDecls) = fun_114(txt, i_var_ty, a_auxFunction, a_varDecls, a_context, i_var_bind__from__outside, i_var_value, i_var_name);
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_varDecls,
           a_auxFunction )
      then (txt, a_varDecls, a_auxFunction);
  end match;
end recordMemberAllocInit;

protected function fun_116
  input Tpl.Text in_txt;
  input Boolean in_a_bind__outside;
  input DAE.ComponentRef in_a_var__cref;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;
  input DAE.Exp in_a_rhs__exp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_a_bind__outside, in_a_var__cref, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context, in_a_rhs__exp)
    local
      Tpl.Text txt;
      DAE.ComponentRef a_var__cref;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Exp a_rhs__exp;

    case ( txt,
           false,
           _,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context,
           a_rhs__exp )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExp(txt, a_rhs__exp, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           _,
           a_var__cref,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("in"));
        (txt, a_auxFunction) = contextCrefNoPrevExp(txt, a_var__cref, SimCodeFunction.contextFunction, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end fun_116;

protected function fun_117
  input Tpl.Text in_txt;
  input Option<DAE.Exp> in_a_value;
  input Tpl.Text in_a_var__name;
  input DAE.ComponentRef in_a_var__cref;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input SimCodeFunction.Context in_a_context;
  input Boolean in_a_bind__outside;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_a_value, in_a_var__name, in_a_var__cref, in_a_auxFunction, in_a_varDecls, in_a_context, in_a_bind__outside)
    local
      Tpl.Text txt;
      Tpl.Text a_var__name;
      DAE.ComponentRef a_var__cref;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      SimCodeFunction.Context a_context;
      Boolean a_bind__outside;
      DAE.Exp i_rhs__exp;
      Tpl.Text l_rhs;
      Tpl.Text l_preExp;

    case ( txt,
           SOME(i_rhs__exp),
           a_var__name,
           a_var__cref,
           a_auxFunction,
           a_varDecls,
           a_context,
           a_bind__outside )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_rhs, a_auxFunction, a_varDecls, l_preExp) = fun_116(Tpl.emptyTxt, a_bind__outside, a_var__cref, a_auxFunction, a_varDecls, l_preExp, a_context, i_rhs__exp);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, a_var__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, l_rhs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           NONE(),
           a_var__name,
           _,
           a_auxFunction,
           a_varDecls,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("// "));
        txt = Tpl.writeText(txt, a_var__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" has no default value."));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           _,
           _,
           _,
           a_auxFunction,
           a_varDecls,
           _,
           _ )
      then (txt, a_auxFunction, a_varDecls);
  end match;
end fun_117;

public function simpleVarInit
  input Tpl.Text txt;
  input Option<DAE.Exp> a_value;
  input DAE.ComponentRef a_var__cref;
  input Boolean a_bind__outside;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
protected
  Tpl.Text l_var__name;
algorithm
  (l_var__name, out_a_auxFunction) := contextCrefNoPrevExp(Tpl.emptyTxt, a_var__cref, a_context, a_auxFunction);
  (out_txt, out_a_auxFunction, out_a_varDecls) := fun_117(txt, a_value, l_var__name, a_var__cref, out_a_auxFunction, a_varDecls, a_context, a_bind__outside);
end simpleVarInit;

protected function lm_119
  input Tpl.Text in_txt;
  input list<DAE.Var> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_ctor__suffix;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_ctor__suffix;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp, out_a_ctor__suffix) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context, in_a_ctor__suffix)
    local
      Tpl.Text txt;
      list<DAE.Var> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      Tpl.Text a_ctor__suffix;
      Integer x_i1;
      DAE.Var i_sv;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _,
           a_ctor__suffix )
      then (txt, a_auxFunction, a_varDecls, a_preExp, a_ctor__suffix);

    case ( txt,
           i_sv :: rest,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context,
           a_ctor__suffix )
      equation
        x_i1 = Tpl.getIteri_i0(txt);
        (txt, a_ctor__suffix, a_preExp, a_varDecls, a_auxFunction) = recordInitOutsideBindings(txt, i_sv, x_i1, a_ctor__suffix, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_preExp, a_ctor__suffix) = lm_119(txt, rest, a_auxFunction, a_varDecls, a_preExp, a_context, a_ctor__suffix);
      then (txt, a_auxFunction, a_varDecls, a_preExp, a_ctor__suffix);
  end match;
end lm_119;

protected function fun_120
  input Tpl.Text in_txt;
  input DAE.Type in_a_var__type;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_ctor__suffix;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_ctor__suffix;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp, out_a_ctor__suffix) :=
  match(in_txt, in_a_var__type, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context, in_a_ctor__suffix)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      Tpl.Text a_ctor__suffix;
      list<DAE.Var> i_ty_varLst;

    case ( txt,
           DAE.T_COMPLEX(varLst = i_ty_varLst),
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context,
           a_ctor__suffix )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(1, SOME(Tpl.ST_STRING("")), NONE(), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_auxFunction, a_varDecls, a_preExp, a_ctor__suffix) = lm_119(txt, i_ty_varLst, a_auxFunction, a_varDecls, a_preExp, a_context, a_ctor__suffix);
        txt = Tpl.popIter(txt);
      then (txt, a_auxFunction, a_varDecls, a_preExp, a_ctor__suffix);

    case ( txt,
           _,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _,
           a_ctor__suffix )
      then (txt, a_auxFunction, a_varDecls, a_preExp, a_ctor__suffix);
  end match;
end fun_120;

protected function fun_121
  input Tpl.Text in_txt;
  input Boolean in_a_bind__outside;
  input Tpl.Text in_a_var__name;
  input Tpl.Text in_a_type__name;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp1;
  input SimCodeFunction.Context in_a_context;
  input DAE.Type in_a_var__type;
  input DAE.Exp in_a_rhs__exp;
  input DAE.ComponentRef in_a_var__cref;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp1;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp1) :=
  match(in_txt, in_a_bind__outside, in_a_var__name, in_a_type__name, in_a_auxFunction, in_a_varDecls, in_a_preExp1, in_a_context, in_a_var__type, in_a_rhs__exp, in_a_var__cref)
    local
      Tpl.Text txt;
      Tpl.Text a_var__name;
      Tpl.Text a_type__name;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp1;
      SimCodeFunction.Context a_context;
      DAE.Type a_var__type;
      DAE.Exp a_rhs__exp;
      DAE.ComponentRef a_var__cref;
      Tpl.Text l_in__var__name;

    case ( txt,
           false,
           _,
           _,
           a_auxFunction,
           a_varDecls,
           a_preExp1,
           a_context,
           a_var__type,
           a_rhs__exp,
           a_var__cref )
      equation
        (txt, a_preExp1, a_varDecls, a_auxFunction) = assignRhsExpToRecordCref(txt, a_var__cref, a_rhs__exp, a_var__type, a_context, a_preExp1, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls, a_preExp1);

    case ( txt,
           _,
           a_var__name,
           a_type__name,
           a_auxFunction,
           a_varDecls,
           a_preExp1,
           _,
           _,
           _,
           a_var__cref )
      equation
        l_in__var__name = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("in"));
        (l_in__var__name, a_auxFunction) = contextCrefNoPrevExp(l_in__var__name, a_var__cref, SimCodeFunction.contextFunction, a_auxFunction);
        txt = Tpl.writeText(txt, a_type__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_copy("));
        txt = Tpl.writeText(txt, l_in__var__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_var__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then (txt, a_auxFunction, a_varDecls, a_preExp1);
  end match;
end fun_121;

protected function fun_122
  input Tpl.Text in_txt;
  input Option<DAE.Exp> in_a_value;
  input Tpl.Text in_a_allocation;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_var__name;
  input Tpl.Text in_a_type__name;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input SimCodeFunction.Context in_a_context;
  input DAE.Type in_a_var__type;
  input DAE.ComponentRef in_a_var__cref;
  input Boolean in_a_bind__outside;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_a_value, in_a_allocation, in_a_preExp, in_a_var__name, in_a_type__name, in_a_auxFunction, in_a_varDecls, in_a_context, in_a_var__type, in_a_var__cref, in_a_bind__outside)
    local
      Tpl.Text txt;
      Tpl.Text a_allocation;
      Tpl.Text a_preExp;
      Tpl.Text a_var__name;
      Tpl.Text a_type__name;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      SimCodeFunction.Context a_context;
      DAE.Type a_var__type;
      DAE.ComponentRef a_var__cref;
      Boolean a_bind__outside;
      DAE.Exp i_rhs__exp;
      Tpl.Text l_copy__stmt;
      Tpl.Text l_preExp1;

    case ( txt,
           SOME(i_rhs__exp),
           a_allocation,
           a_preExp,
           a_var__name,
           a_type__name,
           a_auxFunction,
           a_varDecls,
           a_context,
           a_var__type,
           a_var__cref,
           a_bind__outside )
      equation
        l_preExp1 = Tpl.emptyTxt;
        (l_copy__stmt, a_auxFunction, a_varDecls, l_preExp1) = fun_121(Tpl.emptyTxt, a_bind__outside, a_var__name, a_type__name, a_auxFunction, a_varDecls, l_preExp1, a_context, a_var__type, i_rhs__exp, a_var__cref);
        txt = Tpl.writeText(txt, a_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, a_allocation);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_preExp1);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_copy__stmt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "\n"
                                }, true));
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           NONE(),
           a_allocation,
           a_preExp,
           a_var__name,
           _,
           a_auxFunction,
           a_varDecls,
           _,
           _,
           _,
           _ )
      equation
        txt = Tpl.writeText(txt, a_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, a_allocation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" // "));
        txt = Tpl.writeText(txt, a_var__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" has no default value."));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           _,
           _,
           _,
           _,
           _,
           a_auxFunction,
           a_varDecls,
           _,
           _,
           _,
           _ )
      then (txt, a_auxFunction, a_varDecls);
  end match;
end fun_122;

public function recordVarAllocInit
  input Tpl.Text txt;
  input Option<DAE.Exp> a_value;
  input DAE.ComponentRef a_var__cref;
  input Boolean a_bind__outside;
  input DAE.Type a_var__type;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
protected
  Tpl.Text l_allocation;
  Tpl.Text l_ctor__additional__inputs;
  Tpl.Text l_var__name;
  Tpl.Text l_type__name;
  Tpl.Text l_ctor__suffix;
  Tpl.Text l_preExp;
algorithm
  l_preExp := Tpl.emptyTxt;
  l_ctor__suffix := Tpl.emptyTxt;
  l_type__name := expTypeShort(Tpl.emptyTxt, a_var__type);
  (l_var__name, out_a_auxFunction) := contextCrefNoPrevExp(Tpl.emptyTxt, a_var__cref, a_context, a_auxFunction);
  (l_ctor__additional__inputs, out_a_auxFunction, out_a_varDecls, l_preExp, l_ctor__suffix) := fun_120(Tpl.emptyTxt, a_var__type, out_a_auxFunction, a_varDecls, l_preExp, a_context, l_ctor__suffix);
  l_allocation := Tpl.writeText(Tpl.emptyTxt, l_type__name);
  l_allocation := Tpl.writeText(l_allocation, l_ctor__suffix);
  l_allocation := Tpl.writeTok(l_allocation, Tpl.ST_STRING("_construct(threadData, "));
  l_allocation := Tpl.writeText(l_allocation, l_var__name);
  l_allocation := Tpl.writeText(l_allocation, l_ctor__additional__inputs);
  l_allocation := Tpl.writeTok(l_allocation, Tpl.ST_STRING(");"));
  (out_txt, out_a_auxFunction, out_a_varDecls) := fun_122(txt, a_value, l_allocation, l_preExp, l_var__name, l_type__name, out_a_auxFunction, out_a_varDecls, a_context, a_var__type, a_var__cref, a_bind__outside);
end recordVarAllocInit;

public function recordInitOutsideBindings
  input Tpl.Text in_txt;
  input DAE.Var in_a_subvar;
  input Integer in_a_ix;
  input Tpl.Text in_a_ctor__suffix;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_ctor__suffix;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_ctor__suffix, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_subvar, in_a_ix, in_a_ctor__suffix, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      Integer a_ix;
      Tpl.Text a_ctor__suffix;
      SimCodeFunction.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Exp i_exp;

    case ( txt,
           DAE.TYPES_VAR(binding = DAE.EQBOUND(exp = i_exp), bind_from_outside = true),
           a_ix,
           a_ctor__suffix,
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        a_ctor__suffix = Tpl.writeTok(a_ctor__suffix, Tpl.ST_STRING("_"));
        a_ctor__suffix = Tpl.writeStr(a_ctor__suffix, intString(a_ix));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExp(txt, i_exp, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_ctor__suffix, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.TYPES_VAR(bind_from_outside = true),
           _,
           a_ctor__suffix,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 761, 11), "Record has binding from outside but found a non EQBOUND binding. Implement me.");
      then (txt, a_ctor__suffix, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_ctor__suffix,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      then (txt, a_ctor__suffix, a_preExp, a_varDecls, a_auxFunction);
  end match;
end recordInitOutsideBindings;

protected function fun_125
  input Tpl.Text in_txt;
  input Boolean in_a_bind__outside;
  input DAE.ComponentRef in_a_var__cref;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExpBind;
  input SimCodeFunction.Context in_a_context;
  input DAE.Exp in_a_rhs__exp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExpBind;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExpBind) :=
  match(in_txt, in_a_bind__outside, in_a_var__cref, in_a_auxFunction, in_a_varDecls, in_a_preExpBind, in_a_context, in_a_rhs__exp)
    local
      Tpl.Text txt;
      DAE.ComponentRef a_var__cref;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExpBind;
      SimCodeFunction.Context a_context;
      DAE.Exp a_rhs__exp;

    case ( txt,
           false,
           _,
           a_auxFunction,
           a_varDecls,
           a_preExpBind,
           a_context,
           a_rhs__exp )
      equation
        (txt, a_preExpBind, a_varDecls, a_auxFunction) = daeExp(txt, a_rhs__exp, a_context, a_preExpBind, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls, a_preExpBind);

    case ( txt,
           _,
           a_var__cref,
           a_auxFunction,
           a_varDecls,
           a_preExpBind,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("in"));
        (txt, a_auxFunction) = contextCrefNoPrevExp(txt, a_var__cref, SimCodeFunction.contextFunction, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls, a_preExpBind);
  end match;
end fun_125;

protected function lm_126
  input Tpl.Text in_txt;
  input list<DAE.Dimension> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExpAlloc;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExpAlloc;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExpAlloc) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_preExpAlloc, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Dimension> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExpAlloc;
      SimCodeFunction.Context a_context;
      DAE.Dimension i_dim;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_preExpAlloc,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExpAlloc);

    case ( txt,
           i_dim :: rest,
           a_auxFunction,
           a_varDecls,
           a_preExpAlloc,
           a_context )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(_index_t)"));
        (txt, a_preExpAlloc, a_varDecls, a_auxFunction) = dimension(txt, i_dim, a_context, a_preExpAlloc, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_preExpAlloc) = lm_126(txt, rest, a_auxFunction, a_varDecls, a_preExpAlloc, a_context);
      then (txt, a_auxFunction, a_varDecls, a_preExpAlloc);
  end match;
end lm_126;

protected function fun_127
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_rhs;
  input Tpl.Text in_a_preExpBind;
  input Tpl.Text in_a_var__name;
  input Tpl.Text in_a_type__name;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input SimCodeFunction.Context in_a_context;
  input list<DAE.Dimension> in_a_var__dims;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_mArg, in_a_rhs, in_a_preExpBind, in_a_var__name, in_a_type__name, in_a_auxFunction, in_a_varDecls, in_a_context, in_a_var__dims)
    local
      Tpl.Text txt;
      Tpl.Text a_rhs;
      Tpl.Text a_preExpBind;
      Tpl.Text a_var__name;
      Tpl.Text a_type__name;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      SimCodeFunction.Context a_context;
      list<DAE.Dimension> a_var__dims;
      Integer ret_2;
      Tpl.Text l_dims__str;
      Tpl.Text l_preExpAlloc;

    case ( txt,
           false,
           a_rhs,
           a_preExpBind,
           a_var__name,
           a_type__name,
           a_auxFunction,
           a_varDecls,
           a_context,
           a_var__dims )
      equation
        l_preExpAlloc = Tpl.emptyTxt;
        l_dims__str = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_dims__str, a_auxFunction, a_varDecls, l_preExpAlloc) = lm_126(l_dims__str, a_var__dims, a_auxFunction, a_varDecls, l_preExpAlloc, a_context);
        l_dims__str = Tpl.popIter(l_dims__str);
        txt = Tpl.writeText(txt, l_preExpAlloc);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("alloc_"));
        txt = Tpl.writeText(txt, a_type__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_array(&("));
        txt = Tpl.writeText(txt, a_var__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("), "));
        ret_2 = listLength(a_var__dims);
        txt = Tpl.writeStr(txt, intString(ret_2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, l_dims__str);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(");\n"));
        txt = Tpl.writeText(txt, a_preExpBind);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, a_type__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_array_copy_data("));
        txt = Tpl.writeText(txt, a_rhs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_var__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ");\n",
                                    "\n"
                                }, true));
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           _,
           a_rhs,
           a_preExpBind,
           a_var__name,
           a_type__name,
           a_auxFunction,
           a_varDecls,
           _,
           _ )
      equation
        txt = Tpl.writeText(txt, a_preExpBind);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, a_type__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_array_alloc_copy("));
        txt = Tpl.writeText(txt, a_rhs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_var__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ");\n",
                                    "\n"
                                }, true));
      then (txt, a_auxFunction, a_varDecls);
  end match;
end fun_127;

protected function lm_128
  input Tpl.Text in_txt;
  input list<DAE.Dimension> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExpAlloc;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExpAlloc;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExpAlloc) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_preExpAlloc, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Dimension> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExpAlloc;
      SimCodeFunction.Context a_context;
      DAE.Dimension i_dim;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_preExpAlloc,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExpAlloc);

    case ( txt,
           i_dim :: rest,
           a_auxFunction,
           a_varDecls,
           a_preExpAlloc,
           a_context )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(_index_t)"));
        (txt, a_preExpAlloc, a_varDecls, a_auxFunction) = dimension(txt, i_dim, a_context, a_preExpAlloc, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_preExpAlloc) = lm_128(txt, rest, a_auxFunction, a_varDecls, a_preExpAlloc, a_context);
      then (txt, a_auxFunction, a_varDecls, a_preExpAlloc);
  end match;
end lm_128;

protected function fun_129
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_var__name;
  input Tpl.Text in_a_type__name;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input SimCodeFunction.Context in_a_context;
  input list<DAE.Dimension> in_a_var__dims;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_mArg, in_a_var__name, in_a_type__name, in_a_auxFunction, in_a_varDecls, in_a_context, in_a_var__dims)
    local
      Tpl.Text txt;
      Tpl.Text a_var__name;
      Tpl.Text a_type__name;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      SimCodeFunction.Context a_context;
      list<DAE.Dimension> a_var__dims;
      Integer ret_3;
      Integer ret_2;
      Tpl.Text l_dims__str;
      Tpl.Text l_preExpAlloc;

    case ( txt,
           false,
           a_var__name,
           a_type__name,
           a_auxFunction,
           a_varDecls,
           a_context,
           a_var__dims )
      equation
        l_preExpAlloc = Tpl.emptyTxt;
        l_dims__str = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_dims__str, a_auxFunction, a_varDecls, l_preExpAlloc) = lm_128(l_dims__str, a_var__dims, a_auxFunction, a_varDecls, l_preExpAlloc, a_context);
        l_dims__str = Tpl.popIter(l_dims__str);
        txt = Tpl.writeText(txt, l_preExpAlloc);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("alloc_"));
        txt = Tpl.writeText(txt, a_type__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_array(&("));
        txt = Tpl.writeText(txt, a_var__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("), "));
        ret_2 = listLength(a_var__dims);
        txt = Tpl.writeStr(txt, intString(ret_2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, l_dims__str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("); // "));
        txt = Tpl.writeText(txt, a_var__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" has no default value."));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           _,
           a_var__name,
           _,
           a_auxFunction,
           a_varDecls,
           _,
           a_var__dims )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("generic_array_create_flexible(&"));
        txt = Tpl.writeText(txt, a_var__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        ret_3 = listLength(a_var__dims);
        txt = Tpl.writeStr(txt, intString(ret_3));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("); // "));
        txt = Tpl.writeText(txt, a_var__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" has unknown size and no default value. It is flexible."));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then (txt, a_auxFunction, a_varDecls);
  end match;
end fun_129;

protected function fun_130
  input Tpl.Text in_txt;
  input Option<DAE.Exp> in_a_value;
  input Tpl.Text in_a_var__name;
  input Tpl.Text in_a_type__name;
  input list<DAE.Dimension> in_a_var__dims;
  input DAE.ComponentRef in_a_var__cref;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input SimCodeFunction.Context in_a_context;
  input Boolean in_a_bind__outside;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_a_value, in_a_var__name, in_a_type__name, in_a_var__dims, in_a_var__cref, in_a_auxFunction, in_a_varDecls, in_a_context, in_a_bind__outside)
    local
      Tpl.Text txt;
      Tpl.Text a_var__name;
      Tpl.Text a_type__name;
      list<DAE.Dimension> a_var__dims;
      DAE.ComponentRef a_var__cref;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      SimCodeFunction.Context a_context;
      Boolean a_bind__outside;
      DAE.Exp i_rhs__exp;
      Boolean ret_3;
      Boolean ret_2;
      Tpl.Text l_rhs;
      Tpl.Text l_preExpBind;

    case ( txt,
           SOME(i_rhs__exp),
           a_var__name,
           a_type__name,
           a_var__dims,
           a_var__cref,
           a_auxFunction,
           a_varDecls,
           a_context,
           a_bind__outside )
      equation
        l_preExpBind = Tpl.emptyTxt;
        (l_rhs, a_auxFunction, a_varDecls, l_preExpBind) = fun_125(Tpl.emptyTxt, a_bind__outside, a_var__cref, a_auxFunction, a_varDecls, l_preExpBind, a_context, i_rhs__exp);
        ret_2 = Expression.hasUnknownDims(a_var__dims);
        (txt, a_auxFunction, a_varDecls) = fun_127(txt, ret_2, l_rhs, l_preExpBind, a_var__name, a_type__name, a_auxFunction, a_varDecls, a_context, a_var__dims);
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           NONE(),
           a_var__name,
           a_type__name,
           a_var__dims,
           _,
           a_auxFunction,
           a_varDecls,
           a_context,
           _ )
      equation
        ret_3 = Expression.hasUnknownDims(a_var__dims);
        (txt, a_auxFunction, a_varDecls) = fun_129(txt, ret_3, a_var__name, a_type__name, a_auxFunction, a_varDecls, a_context, a_var__dims);
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           _,
           _,
           _,
           _,
           _,
           a_auxFunction,
           a_varDecls,
           _,
           _ )
      then (txt, a_auxFunction, a_varDecls);
  end match;
end fun_130;

public function arrayVarAllocInit
  input Tpl.Text txt;
  input DAE.ComponentRef a_var__cref;
  input DAE.Type a_var__type;
  input list<DAE.Dimension> a_var__dims;
  input Option<DAE.Exp> a_value;
  input Boolean a_bind__outside;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
protected
  Tpl.Text l_var__name;
  Tpl.Text l_type__name;
algorithm
  l_type__name := expTypeShort(Tpl.emptyTxt, a_var__type);
  (l_var__name, out_a_auxFunction) := contextCrefNoPrevExp(Tpl.emptyTxt, a_var__cref, a_context, a_auxFunction);
  (out_txt, out_a_auxFunction, out_a_varDecls) := fun_130(txt, a_value, l_var__name, l_type__name, a_var__dims, a_var__cref, out_a_auxFunction, a_varDecls, a_context, a_bind__outside);
end arrayVarAllocInit;

protected function fun_132
  input Tpl.Text in_txt;
  input Integer in_a_numFields;
  input String in_a_fieldNames;
  input String in_a_encName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_numFields, in_a_fieldNames, in_a_encName)
    local
      Tpl.Text txt;
      String a_fieldNames;
      String a_encName;
      Integer i_numFields;

    case ( txt,
           0,
           _,
           a_encName )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("const char* "));
        txt = Tpl.writeStr(txt, a_encName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("__desc__fields[1] = {\"no fields\"};"));
      then txt;

    case ( txt,
           i_numFields,
           a_fieldNames,
           a_encName )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("const char* "));
        txt = Tpl.writeStr(txt, a_encName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("__desc__fields["));
        txt = Tpl.writeStr(txt, intString(i_numFields));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = {"));
        txt = Tpl.writeStr(txt, a_fieldNames);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("};"));
      then txt;
  end match;
end fun_132;

protected function fun_133
  input Tpl.Text in_txt;
  input String in_a_encName;
  input String in_a_origName;
  input String in_a_fieldNames;
  input Integer in_a_numFields;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_encName, in_a_origName, in_a_fieldNames, in_a_numFields)
    local
      Tpl.Text txt;
      String a_origName;
      String a_fieldNames;
      Integer a_numFields;
      String i_encName;
      Tpl.Text l_fieldsDescription;

    case ( txt,
           "SourceInfo_SOURCEINFO",
           _,
           _,
           _ )
      then txt;

    case ( txt,
           i_encName,
           a_origName,
           a_fieldNames,
           a_numFields )
      equation
        l_fieldsDescription = fun_132(Tpl.emptyTxt, a_numFields, a_fieldNames, i_encName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#define "));
        txt = Tpl.writeStr(txt, i_encName);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("__desc_added 1\n"));
        txt = Tpl.writeText(txt, l_fieldsDescription);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("struct record_description "));
        txt = Tpl.writeStr(txt, i_encName);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("__desc = {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        txt = Tpl.writeStr(txt, i_encName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\", /* package_record__X */\n",
                                    "\""
                                }, false));
        txt = Tpl.writeStr(txt, a_origName);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("\", /* package.record_X */\n"));
        txt = Tpl.writeStr(txt, i_encName);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("__desc__fields\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("};"));
      then txt;
  end match;
end fun_133;

public function recordDefinition
  input Tpl.Text txt;
  input String a_origName;
  input String a_encName;
  input String a_fieldNames;
  input Integer a_numFields;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_133(txt, a_encName, a_origName, a_fieldNames, a_numFields);
end recordDefinition;

public function recordDefinitionHeader
  input Tpl.Text txt;
  input String a_origName;
  input String a_encName;
  input Integer a_numFields;

  output Tpl.Text out_txt;
algorithm
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING("extern struct record_description "));
  out_txt := Tpl.writeStr(out_txt, a_encName);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("__desc;"));
end recordDefinitionHeader;

public function functionHeaderNormal
  input Tpl.Text txt;
  input String a_fname;
  input list<SimCodeFunction.Variable> a_fargs;
  input list<SimCodeFunction.Variable> a_outVars;
  input Boolean a_inFunc;
  input SCode.Visibility a_visibility;
  input Boolean a_dynLoad;
  input Boolean a_isSimulation;
  input Tpl.Text a_staticPrototypes;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_staticPrototypes;
algorithm
  (out_txt, out_a_staticPrototypes) := functionHeaderImpl(txt, a_fname, a_fargs, a_outVars, a_inFunc, false, a_visibility, a_dynLoad, a_isSimulation, a_staticPrototypes);
end functionHeaderNormal;

protected function fun_137
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("&"));
      then txt;
  end match;
end fun_137;

protected function fun_138
  input Tpl.Text in_txt;
  input Boolean in_a_isBoxed;
  input Tpl.Text in_a_staticPrototypes;
  input Boolean in_a_isSimulation;
  input Boolean in_a_dynLoad;
  input SCode.Visibility in_a_visibility;
  input Boolean in_a_inFunc;
  input list<SimCodeFunction.Variable> in_a_outVars;
  input list<SimCodeFunction.Variable> in_a_fargs;
  input String in_a_fname;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_staticPrototypes;
algorithm
  (out_txt, out_a_staticPrototypes) :=
  match(in_txt, in_a_isBoxed, in_a_staticPrototypes, in_a_isSimulation, in_a_dynLoad, in_a_visibility, in_a_inFunc, in_a_outVars, in_a_fargs, in_a_fname)
    local
      Tpl.Text txt;
      Tpl.Text a_staticPrototypes;
      Boolean a_isSimulation;
      Boolean a_dynLoad;
      SCode.Visibility a_visibility;
      Boolean a_inFunc;
      list<SimCodeFunction.Variable> a_outVars;
      list<SimCodeFunction.Variable> a_fargs;
      String a_fname;

    case ( txt,
           false,
           a_staticPrototypes,
           a_isSimulation,
           a_dynLoad,
           a_visibility,
           a_inFunc,
           a_outVars,
           a_fargs,
           a_fname )
      equation
        (txt, a_staticPrototypes) = functionHeaderImpl(txt, a_fname, a_fargs, a_outVars, a_inFunc, true, a_visibility, a_dynLoad, a_isSimulation, a_staticPrototypes);
      then (txt, a_staticPrototypes);

    case ( txt,
           _,
           a_staticPrototypes,
           _,
           _,
           _,
           _,
           _,
           _,
           a_fname )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#define boxptr_"));
        txt = Tpl.writeStr(txt, a_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" omc_"));
        txt = Tpl.writeStr(txt, a_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then (txt, a_staticPrototypes);
  end match;
end fun_138;

protected function fun_139
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_boxvar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_boxvar)
    local
      Tpl.Text txt;
      Tpl.Text a_boxvar;

    case ( txt,
           false,
           a_boxvar )
      equation
        txt = Tpl.writeText(txt, a_boxvar);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_139;

protected function fun_140
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_boxvar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_boxvar)
    local
      Tpl.Text txt;
      Tpl.Text a_boxvar;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_boxvar )
      equation
        txt = Tpl.writeText(txt, a_boxvar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" /* boxvar early */"));
      then txt;
  end match;
end fun_140;

protected function fun_141
  input Tpl.Text in_txt;
  input SCode.Visibility in_a_visibility;
  input Tpl.Text in_a_boxvar;
  input Boolean in_a_isSimulation;
  input Tpl.Text in_a_staticPrototypes;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_staticPrototypes;
algorithm
  (out_txt, out_a_staticPrototypes) :=
  match(in_txt, in_a_visibility, in_a_boxvar, in_a_isSimulation, in_a_staticPrototypes)
    local
      Tpl.Text txt;
      Tpl.Text a_boxvar;
      Boolean a_isSimulation;
      Tpl.Text a_staticPrototypes;
      Boolean ret_3;
      Boolean ret_2;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           SCode.PROTECTED(),
           a_boxvar,
           a_isSimulation,
           a_staticPrototypes )
      equation
        ret_0 = Flags.isSet(Flags.OMC_RELOCATABLE_FUNCTIONS);
        ret_1 = boolOr(a_isSimulation, ret_0);
        a_staticPrototypes = fun_139(a_staticPrototypes, ret_1, a_boxvar);
        ret_2 = Flags.isSet(Flags.OMC_RELOCATABLE_FUNCTIONS);
        ret_3 = boolOr(a_isSimulation, ret_2);
        txt = fun_140(txt, ret_3, a_boxvar);
      then (txt, a_staticPrototypes);

    case ( txt,
           _,
           a_boxvar,
           _,
           a_staticPrototypes )
      equation
        txt = Tpl.writeText(txt, a_boxvar);
      then (txt, a_staticPrototypes);
  end match;
end fun_141;

public function functionHeaderBoxed
  input Tpl.Text txt;
  input String a_fname;
  input list<SimCodeFunction.Variable> a_fargs;
  input list<SimCodeFunction.Variable> a_outVars;
  input Boolean a_inFunc;
  input Boolean a_isBoxed;
  input SCode.Visibility a_visibility;
  input Boolean a_dynLoad;
  input Boolean a_isSimulation;
  input Tpl.Text a_staticPrototypes;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_staticPrototypes;
protected
  Boolean ret_1;
  Tpl.Text l_boxvar;
algorithm
  l_boxvar := Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("static const MMC_DEFSTRUCTLIT(boxvar_lit_"));
  l_boxvar := Tpl.writeStr(l_boxvar, a_fname);
  l_boxvar := Tpl.writeTok(l_boxvar, Tpl.ST_STRING(",2,0) {(void*) "));
  ret_1 := Flags.isSet(Flags.OMC_RELOCATABLE_FUNCTIONS);
  l_boxvar := fun_137(l_boxvar, ret_1);
  l_boxvar := Tpl.writeTok(l_boxvar, Tpl.ST_STRING("boxptr_"));
  l_boxvar := Tpl.writeStr(l_boxvar, a_fname);
  l_boxvar := Tpl.writeTok(l_boxvar, Tpl.ST_STRING_LIST({
                                         ",0}};\n",
                                         "#define boxvar_"
                                     }, false));
  l_boxvar := Tpl.writeStr(l_boxvar, a_fname);
  l_boxvar := Tpl.writeTok(l_boxvar, Tpl.ST_STRING(" MMC_REFSTRUCTLIT(boxvar_lit_"));
  l_boxvar := Tpl.writeStr(l_boxvar, a_fname);
  l_boxvar := Tpl.writeTok(l_boxvar, Tpl.ST_STRING(")"));
  l_boxvar := Tpl.writeTok(l_boxvar, Tpl.ST_NEW_LINE());
  (out_txt, out_a_staticPrototypes) := fun_138(txt, a_isBoxed, a_staticPrototypes, a_isSimulation, a_dynLoad, a_visibility, a_inFunc, a_outVars, a_fargs, a_fname);
  out_txt := Tpl.softNewLine(out_txt);
  (out_txt, out_a_staticPrototypes) := fun_141(out_txt, a_visibility, l_boxvar, a_isSimulation, out_a_staticPrototypes);
end functionHeaderBoxed;

protected function fun_143
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_fname;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_fname)
    local
      Tpl.Text txt;
      String a_fname;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_fname )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "DLLExport\n",
                                    "int in_"
                                }, false));
        txt = Tpl.writeStr(txt, a_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(threadData_t *threadData, type_description * inArgs, type_description * outVar);"));
      then txt;
  end match;
end fun_143;

protected function fun_144
  input Tpl.Text in_txt;
  input Boolean in_a_dynamicLoad;
  input Tpl.Text in_a_prototype;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_dynamicLoad, in_a_prototype)
    local
      Tpl.Text txt;
      Tpl.Text a_prototype;

    case ( txt,
           false,
           a_prototype )
      equation
        txt = Tpl.writeText(txt, a_prototype);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_144;

protected function fun_145
  input Tpl.Text in_txt;
  input Boolean in_a_dynamicLoad;
  input Tpl.Text in_a_prototype;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_dynamicLoad, in_a_prototype)
    local
      Tpl.Text txt;
      Tpl.Text a_prototype;

    case ( txt,
           false,
           a_prototype )
      equation
        txt = Tpl.writeText(txt, a_prototype);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_145;

protected function fun_146
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_inFnStr;
  input Tpl.Text in_a_prototype;
  input Boolean in_a_dynamicLoad;
  input Tpl.Text in_a_staticPrototypes;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_staticPrototypes;
algorithm
  (out_txt, out_a_staticPrototypes) :=
  match(in_txt, in_mArg, in_a_inFnStr, in_a_prototype, in_a_dynamicLoad, in_a_staticPrototypes)
    local
      Tpl.Text txt;
      Tpl.Text a_inFnStr;
      Tpl.Text a_prototype;
      Boolean a_dynamicLoad;
      Tpl.Text a_staticPrototypes;

    case ( txt,
           false,
           a_inFnStr,
           a_prototype,
           a_dynamicLoad,
           a_staticPrototypes )
      equation
        a_staticPrototypes = fun_144(a_staticPrototypes, a_dynamicLoad, a_prototype);
        txt = Tpl.writeText(txt, a_inFnStr);
      then (txt, a_staticPrototypes);

    case ( txt,
           _,
           _,
           a_prototype,
           a_dynamicLoad,
           a_staticPrototypes )
      equation
        txt = fun_145(txt, a_dynamicLoad, a_prototype);
      then (txt, a_staticPrototypes);
  end match;
end fun_146;

protected function fun_147
  input Tpl.Text in_txt;
  input Boolean in_a_dynamicLoad;
  input Tpl.Text in_a_prototype;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_dynamicLoad, in_a_prototype)
    local
      Tpl.Text txt;
      Tpl.Text a_prototype;

    case ( txt,
           false,
           a_prototype )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("DLLExport"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_prototype);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_147;

protected function fun_148
  input Tpl.Text in_txt;
  input SCode.Visibility in_a_visibility;
  input Tpl.Text in_a_inFnStr;
  input Tpl.Text in_a_prototype;
  input Boolean in_a_dynamicLoad;
  input Tpl.Text in_a_staticPrototypes;
  input Boolean in_a_isSimulation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_staticPrototypes;
algorithm
  (out_txt, out_a_staticPrototypes) :=
  match(in_txt, in_a_visibility, in_a_inFnStr, in_a_prototype, in_a_dynamicLoad, in_a_staticPrototypes, in_a_isSimulation)
    local
      Tpl.Text txt;
      Tpl.Text a_inFnStr;
      Tpl.Text a_prototype;
      Boolean a_dynamicLoad;
      Tpl.Text a_staticPrototypes;
      Boolean a_isSimulation;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           SCode.PROTECTED(),
           a_inFnStr,
           a_prototype,
           a_dynamicLoad,
           a_staticPrototypes,
           a_isSimulation )
      equation
        ret_0 = Flags.isSet(Flags.OMC_RELOCATABLE_FUNCTIONS);
        ret_1 = boolOr(a_isSimulation, ret_0);
        (txt, a_staticPrototypes) = fun_146(txt, ret_1, a_inFnStr, a_prototype, a_dynamicLoad, a_staticPrototypes);
      then (txt, a_staticPrototypes);

    case ( txt,
           _,
           a_inFnStr,
           a_prototype,
           a_dynamicLoad,
           a_staticPrototypes,
           _ )
      equation
        txt = Tpl.writeText(txt, a_inFnStr);
        txt = Tpl.softNewLine(txt);
        txt = fun_147(txt, a_dynamicLoad, a_prototype);
      then (txt, a_staticPrototypes);
  end match;
end fun_148;

public function functionHeaderImpl
  input Tpl.Text txt;
  input String a_fname;
  input list<SimCodeFunction.Variable> a_fargs;
  input list<SimCodeFunction.Variable> a_outVars;
  input Boolean a_inFunc;
  input Boolean a_boxed;
  input SCode.Visibility a_visibility;
  input Boolean a_dynamicLoad;
  input Boolean a_isSimulation;
  input Tpl.Text a_staticPrototypes;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_staticPrototypes;
protected
  Boolean ret_3;
  Tpl.Text l_inFnStr;
  Tpl.Text l_prototype;
  Tpl.Text l_dummy;
algorithm
  l_dummy := Tpl.emptyTxt;
  (l_prototype, l_dummy) := functionPrototype(Tpl.emptyTxt, a_fname, a_fargs, a_outVars, a_boxed, a_visibility, a_isSimulation, true, l_dummy);
  ret_3 := boolAnd(a_boxed, a_inFunc);
  l_inFnStr := fun_143(Tpl.emptyTxt, ret_3, a_fname);
  (out_txt, out_a_staticPrototypes) := fun_148(txt, a_visibility, l_inFnStr, l_prototype, a_dynamicLoad, a_staticPrototypes, a_isSimulation);
end functionHeaderImpl;

protected function fun_150
  input Tpl.Text in_txt;
  input SCode.Visibility in_a_visibility;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_visibility)
    local
      Tpl.Text txt;

    case ( txt,
           SCode.PROTECTED() )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("PROTECTED_FUNCTION_STATIC "));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_150;

protected function fun_151
  input Tpl.Text in_txt;
  input Boolean in_a_isSimulation;
  input SCode.Visibility in_a_visibility;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_isSimulation, in_a_visibility)
    local
      Tpl.Text txt;
      SCode.Visibility a_visibility;

    case ( txt,
           false,
           a_visibility )
      equation
        txt = fun_150(txt, a_visibility);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_151;

protected function lm_152
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      SimCodeFunction.Variable i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = funArgDefinition(txt, i_var);
        txt = lm_152(txt, rest);
      then txt;
  end match;
end lm_152;

protected function lm_153
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      SimCodeFunction.Variable i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = funArgBoxedDefinition(txt, i_var);
        txt = lm_153(txt, rest);
      then txt;
  end match;
end lm_153;

protected function fun_154
  input Tpl.Text in_txt;
  input Boolean in_a_boxed;
  input list<SimCodeFunction.Variable> in_a_fargs;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_boxed, in_a_fargs)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> a_fargs;

    case ( txt,
           false,
           a_fargs )
      equation
        txt = lm_152(txt, a_fargs);
      then txt;

    case ( txt,
           _,
           a_fargs )
      equation
        txt = lm_153(txt, a_fargs);
      then txt;
  end match;
end fun_154;

protected function fun_155
  input Tpl.Text in_txt;
  input Boolean in_a_boxed;
  input SimCodeFunction.Variable in_a_var;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_boxed, in_a_var)
    local
      Tpl.Text txt;
      SimCodeFunction.Variable a_var;

    case ( txt,
           false,
           a_var )
      equation
        txt = varType(txt, a_var);
      then txt;

    case ( txt,
           _,
           a_var )
      equation
        txt = varTypeBoxed(txt, a_var);
      then txt;
  end match;
end fun_155;

protected function fun_156
  input Tpl.Text in_txt;
  input SimCodeFunction.Variable in_a_var;
  input Boolean in_a_boxed;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_var, in_a_boxed)
    local
      Tpl.Text txt;
      Boolean a_boxed;
      SimCodeFunction.Variable i_var;

    case ( txt,
           (i_var as SimCodeFunction.VARIABLE(name = _)),
           a_boxed )
      equation
        txt = fun_155(txt, a_boxed, i_var);
      then txt;

    case ( txt,
           SimCodeFunction.FUNCTION_PTR(name = _),
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_fnptr"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_156;

protected function fun_157
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_a_outVars;
  input Boolean in_a_boxed;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_outVars, in_a_boxed)
    local
      Tpl.Text txt;
      Boolean a_boxed;
      SimCodeFunction.Variable i_var;

    case ( txt,
           i_var :: _,
           a_boxed )
      equation
        txt = fun_156(txt, i_var, a_boxed);
      then txt;

    case ( txt,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void"));
      then txt;
  end match;
end fun_157;

protected function fun_158
  input Tpl.Text in_txt;
  input Boolean in_a_boxed;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_boxed)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("omc"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("boxptr"));
      then txt;
  end match;
end fun_158;

protected function fun_159
  input Tpl.Text in_txt;
  input Boolean in_a_isPrototype;
  input Tpl.Text in_a_fn__name;
  input String in_a_fname;
  input Tpl.Text in_a_boxPtrStr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_isPrototype, in_a_fn__name, in_a_fname, in_a_boxPtrStr)
    local
      Tpl.Text txt;
      Tpl.Text a_fn__name;
      String a_fname;
      Tpl.Text a_boxPtrStr;

    case ( txt,
           false,
           _,
           a_fname,
           a_boxPtrStr )
      equation
        txt = Tpl.writeText(txt, a_boxPtrStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("impl_"));
        txt = Tpl.writeStr(txt, a_fname);
      then txt;

    case ( txt,
           _,
           a_fn__name,
           _,
           _ )
      equation
        txt = Tpl.writeText(txt, a_fn__name);
      then txt;
  end match;
end fun_159;

protected function fun_160
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_fname;
  input Tpl.Text in_a_boxPtrStr;
  input Tpl.Text in_a_fn__name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_fname, in_a_boxPtrStr, in_a_fn__name)
    local
      Tpl.Text txt;
      String a_fname;
      Tpl.Text a_boxPtrStr;
      Tpl.Text a_fn__name;

    case ( txt,
           false,
           _,
           _,
           a_fn__name )
      equation
        txt = Tpl.writeText(txt, a_fn__name);
      then txt;

    case ( txt,
           _,
           a_fname,
           a_boxPtrStr,
           _ )
      equation
        txt = Tpl.writeText(txt, a_boxPtrStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("td_"));
        txt = Tpl.writeStr(txt, a_fname);
      then txt;
  end match;
end fun_160;

protected function fun_161
  input Tpl.Text in_txt;
  input Boolean in_a_isPrototype;
  input Tpl.Text in_a_fn__name__typedef;
  input Tpl.Text in_a_fn__name__impl;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_isPrototype, in_a_fn__name__typedef, in_a_fn__name__impl)
    local
      Tpl.Text txt;
      Tpl.Text a_fn__name__typedef;
      Tpl.Text a_fn__name__impl;

    case ( txt,
           false,
           _,
           a_fn__name__impl )
      equation
        txt = Tpl.writeText(txt, a_fn__name__impl);
      then txt;

    case ( txt,
           _,
           a_fn__name__typedef,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(*"));
        txt = Tpl.writeText(txt, a_fn__name__typedef);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;
  end match;
end fun_161;

protected function fun_162
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_fn__name__typedef;
  input Tpl.Text in_a_fn__name__impl;
  input Boolean in_a_isPrototype;
  input Tpl.Text in_a_fn__name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_fn__name__typedef, in_a_fn__name__impl, in_a_isPrototype, in_a_fn__name)
    local
      Tpl.Text txt;
      Tpl.Text a_fn__name__typedef;
      Tpl.Text a_fn__name__impl;
      Boolean a_isPrototype;
      Tpl.Text a_fn__name;

    case ( txt,
           false,
           _,
           _,
           _,
           a_fn__name )
      equation
        txt = Tpl.writeText(txt, a_fn__name);
      then txt;

    case ( txt,
           _,
           a_fn__name__typedef,
           a_fn__name__impl,
           a_isPrototype,
           _ )
      equation
        txt = fun_161(txt, a_isPrototype, a_fn__name__typedef, a_fn__name__impl);
      then txt;
  end match;
end fun_162;

protected function fun_163
  input Tpl.Text in_txt;
  input Boolean in_a_boxed;
  input SimCodeFunction.Variable in_a_var;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_boxed, in_a_var)
    local
      Tpl.Text txt;
      SimCodeFunction.Variable a_var;

    case ( txt,
           false,
           a_var )
      equation
        txt = varType(txt, a_var);
      then txt;

    case ( txt,
           _,
           a_var )
      equation
        txt = varTypeBoxed(txt, a_var);
      then txt;
  end match;
end fun_163;

protected function fun_164
  input Tpl.Text in_txt;
  input SimCodeFunction.Variable in_a_var;
  input Boolean in_a_boxed;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_var, in_a_boxed)
    local
      Tpl.Text txt;
      Boolean a_boxed;
      SimCodeFunction.Variable i_var;

    case ( txt,
           (i_var as SimCodeFunction.VARIABLE(name = _)),
           a_boxed )
      equation
        txt = fun_163(txt, a_boxed, i_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" *out"));
        txt = funArgName(txt, i_var);
      then txt;

    case ( txt,
           (i_var as SimCodeFunction.FUNCTION_PTR(name = _)),
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_fnptr *out"));
        txt = funArgName(txt, i_var);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_164;

protected function lm_165
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;
  input Boolean in_a_boxed;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_boxed)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      Boolean a_boxed;
      SimCodeFunction.Variable i_var;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_boxed )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = fun_164(txt, i_var, a_boxed);
        txt = lm_165(txt, rest, a_boxed);
      then txt;
  end match;
end lm_165;

protected function fun_166
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_a_outVars;
  input Tpl.Text in_a_outarg;
  input Boolean in_a_boxed;
  input Tpl.Text in_a_fargsStr;
  input Tpl.Text in_a_fn__name__ptr__typedef;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_outVars, in_a_outarg, in_a_boxed, in_a_fargsStr, in_a_fn__name__ptr__typedef)
    local
      Tpl.Text txt;
      Tpl.Text a_outarg;
      Boolean a_boxed;
      Tpl.Text a_fargsStr;
      Tpl.Text a_fn__name__ptr__typedef;
      list<SimCodeFunction.Variable> i_outVars;
      list<SimCodeFunction.Variable> ret_1;
      Tpl.Text l_outargs;

    case ( txt,
           {},
           _,
           _,
           a_fargsStr,
           a_fn__name__ptr__typedef )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = Tpl.writeText(txt, a_fn__name__ptr__typedef);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(threadData_t *threadData"));
        txt = Tpl.writeText(txt, a_fargsStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           i_outVars,
           a_outarg,
           a_boxed,
           a_fargsStr,
           a_fn__name__ptr__typedef )
      equation
        ret_1 = List.rest(i_outVars);
        l_outargs = lm_165(Tpl.emptyTxt, ret_1, a_boxed);
        txt = Tpl.writeText(txt, a_outarg);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, a_fn__name__ptr__typedef);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(threadData_t *threadData"));
        txt = Tpl.writeText(txt, a_fargsStr);
        txt = Tpl.writeText(txt, l_outargs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;
  end match;
end fun_166;

protected function fun_167
  input Tpl.Text in_txt;
  input Boolean in_a_isPrototype;
  input Tpl.Text in_a_res;
  input Tpl.Text in_a_fn__name__impl;
  input Tpl.Text in_a_fn__name;
  input Tpl.Text in_a_fn__name__typedef;
  input Tpl.Text in_a_afterBody;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_afterBody;
algorithm
  (out_txt, out_a_afterBody) :=
  match(in_txt, in_a_isPrototype, in_a_res, in_a_fn__name__impl, in_a_fn__name, in_a_fn__name__typedef, in_a_afterBody)
    local
      Tpl.Text txt;
      Tpl.Text a_res;
      Tpl.Text a_fn__name__impl;
      Tpl.Text a_fn__name;
      Tpl.Text a_fn__name__typedef;
      Tpl.Text a_afterBody;

    case ( txt,
           false,
           a_res,
           a_fn__name__impl,
           a_fn__name,
           a_fn__name__typedef,
           a_afterBody )
      equation
        a_afterBody = Tpl.writeText(a_afterBody, a_fn__name__typedef);
        a_afterBody = Tpl.writeTok(a_afterBody, Tpl.ST_STRING(" "));
        a_afterBody = Tpl.writeText(a_afterBody, a_fn__name);
        a_afterBody = Tpl.writeTok(a_afterBody, Tpl.ST_STRING(" = "));
        a_afterBody = Tpl.writeText(a_afterBody, a_fn__name__impl);
        a_afterBody = Tpl.writeTok(a_afterBody, Tpl.ST_STRING(";"));
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_afterBody);

    case ( txt,
           _,
           a_res,
           _,
           a_fn__name,
           a_fn__name__typedef,
           a_afterBody )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("typedef "));
        txt = Tpl.writeText(txt, a_res);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.writeText(txt, a_fn__name__typedef);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, a_fn__name);
      then (txt, a_afterBody);
  end match;
end fun_167;

protected function fun_168
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_fn__name__impl;
  input Tpl.Text in_a_fn__name;
  input Tpl.Text in_a_fn__name__typedef;
  input Tpl.Text in_a_afterBody;
  input Boolean in_a_isPrototype;
  input Tpl.Text in_a_res;
  input Tpl.Text in_a_static;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_afterBody;
algorithm
  (out_txt, out_a_afterBody) :=
  match(in_txt, in_mArg, in_a_fn__name__impl, in_a_fn__name, in_a_fn__name__typedef, in_a_afterBody, in_a_isPrototype, in_a_res, in_a_static)
    local
      Tpl.Text txt;
      Tpl.Text a_fn__name__impl;
      Tpl.Text a_fn__name;
      Tpl.Text a_fn__name__typedef;
      Tpl.Text a_afterBody;
      Boolean a_isPrototype;
      Tpl.Text a_res;
      Tpl.Text a_static;

    case ( txt,
           false,
           _,
           _,
           _,
           a_afterBody,
           _,
           a_res,
           a_static )
      equation
        txt = Tpl.writeText(txt, a_static);
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_afterBody);

    case ( txt,
           _,
           a_fn__name__impl,
           a_fn__name,
           a_fn__name__typedef,
           a_afterBody,
           a_isPrototype,
           a_res,
           _ )
      equation
        (txt, a_afterBody) = fun_167(txt, a_isPrototype, a_res, a_fn__name__impl, a_fn__name, a_fn__name__typedef, a_afterBody);
      then (txt, a_afterBody);
  end match;
end fun_168;

public function functionPrototype
  input Tpl.Text txt;
  input String a_fname;
  input list<SimCodeFunction.Variable> a_fargs;
  input list<SimCodeFunction.Variable> a_outVars;
  input Boolean a_boxed;
  input SCode.Visibility a_visibility;
  input Boolean a_isSimulation;
  input Boolean a_isPrototype;
  input Tpl.Text a_afterBody;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_afterBody;
protected
  Boolean ret_11;
  Tpl.Text l_res;
  Boolean ret_9;
  Tpl.Text l_fn__name__ptr__typedef;
  Boolean ret_7;
  Tpl.Text l_fn__name__typedef;
  Tpl.Text l_fn__name__impl;
  Tpl.Text l_fn__name;
  Tpl.Text l_boxPtrStr;
  Tpl.Text l_outarg;
  Tpl.Text l_fargsStr;
  Tpl.Text l_static;
algorithm
  l_static := fun_151(Tpl.emptyTxt, a_isSimulation, a_visibility);
  l_fargsStr := fun_154(Tpl.emptyTxt, a_boxed, a_fargs);
  l_outarg := fun_157(Tpl.emptyTxt, a_outVars, a_boxed);
  l_boxPtrStr := fun_158(Tpl.emptyTxt, a_boxed);
  l_fn__name := Tpl.writeText(Tpl.emptyTxt, l_boxPtrStr);
  l_fn__name := Tpl.writeTok(l_fn__name, Tpl.ST_STRING("_"));
  l_fn__name := Tpl.writeStr(l_fn__name, a_fname);
  l_fn__name__impl := fun_159(Tpl.emptyTxt, a_isPrototype, l_fn__name, a_fname, l_boxPtrStr);
  ret_7 := Flags.isSet(Flags.OMC_RELOCATABLE_FUNCTIONS);
  l_fn__name__typedef := fun_160(Tpl.emptyTxt, ret_7, a_fname, l_boxPtrStr, l_fn__name);
  ret_9 := Flags.isSet(Flags.OMC_RELOCATABLE_FUNCTIONS);
  l_fn__name__ptr__typedef := fun_162(Tpl.emptyTxt, ret_9, l_fn__name__typedef, l_fn__name__impl, a_isPrototype, l_fn__name);
  l_res := fun_166(Tpl.emptyTxt, a_outVars, l_outarg, a_boxed, l_fargsStr, l_fn__name__ptr__typedef);
  ret_11 := Flags.isSet(Flags.OMC_RELOCATABLE_FUNCTIONS);
  (out_txt, out_a_afterBody) := fun_168(txt, ret_11, l_fn__name__impl, l_fn__name, l_fn__name__typedef, a_afterBody, a_isPrototype, l_res, l_static);
end functionPrototype;

public function functionHeaderKernelFunctionInterface
  input Tpl.Text txt;
  input String a_fname;
  input list<SimCodeFunction.Variable> a_fargs;
  input list<SimCodeFunction.Variable> a_outVars;

  output Tpl.Text out_txt;
algorithm
  out_txt := functionHeaderKernelFunctionInterfacePrototype(txt, a_fname, a_fargs, a_outVars);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING(";"));
end functionHeaderKernelFunctionInterface;

protected function lm_171
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      SimCodeFunction.Variable i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = funArgDefinitionKernelFunctionInterface(txt, i_var);
        txt = Tpl.nextIter(txt);
        txt = lm_171(txt, rest);
      then txt;
  end match;
end lm_171;

protected function fun_172
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_a_fargs;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fargs)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> i_fargs;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_fargs )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_171(txt, i_fargs);
        txt = Tpl.popIter(txt);
      then txt;
  end match;
end fun_172;

protected function lm_173
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      SimCodeFunction.Variable i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = tupleOutfunArgDefinitionKernelFunctionInterface(txt, i_var);
        txt = Tpl.nextIter(txt);
        txt = lm_173(txt, rest);
      then txt;
  end match;
end lm_173;

protected function fun_174
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_a_rest;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_rest)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> i_rest;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_173(txt, i_rest);
        txt = Tpl.popIter(txt);
      then txt;
  end match;
end fun_174;

protected function fun_175
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_a_outVars;
  input Tpl.Text in_a_fargsStr;
  input String in_a_fname;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_fargsStr;
algorithm
  (out_txt, out_a_fargsStr) :=
  match(in_txt, in_a_outVars, in_a_fargsStr, in_a_fname)
    local
      Tpl.Text txt;
      Tpl.Text a_fargsStr;
      String a_fname;
      list<SimCodeFunction.Variable> i_rest;
      SimCodeFunction.Variable i_fvar;
      Tpl.Text l_rettype;

    case ( txt,
           {},
           a_fargsStr,
           a_fname )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void omc_"));
        txt = Tpl.writeStr(txt, a_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_fargsStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_fargsStr);

    case ( txt,
           i_fvar :: i_rest,
           a_fargsStr,
           a_fname )
      equation
        l_rettype = varType(Tpl.emptyTxt, i_fvar);
        a_fargsStr = fun_174(a_fargsStr, i_rest);
        txt = Tpl.writeText(txt, l_rettype);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" omc_"));
        txt = Tpl.writeStr(txt, a_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_fargsStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_fargsStr);

    case ( txt,
           _,
           a_fargsStr,
           _ )
      equation
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 954, 13), "functionHeaderKernelFunctionInterfacePrototype failed");
      then (txt, a_fargsStr);
  end match;
end fun_175;

public function functionHeaderKernelFunctionInterfacePrototype
  input Tpl.Text txt;
  input String a_fname;
  input list<SimCodeFunction.Variable> a_fargs;
  input list<SimCodeFunction.Variable> a_outVars;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_fargsStr;
algorithm
  l_fargsStr := Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("threadData_t *threadData"));
  l_fargsStr := fun_172(l_fargsStr, a_fargs);
  (out_txt, l_fargsStr) := fun_175(txt, a_outVars, l_fargsStr, a_fname);
end functionHeaderKernelFunctionInterfacePrototype;

protected function fun_177
  input Tpl.Text in_txt;
  input SimCodeFunction.Variable in_a_var;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_auxFunction) :=
  match(in_txt, in_a_var, in_a_auxFunction)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      String i_name_1;
      DAE.ComponentRef i_name;
      String ret_0;

    case ( txt,
           SimCodeFunction.VARIABLE(name = i_name),
           a_auxFunction )
      equation
        (txt, a_auxFunction) = contextCrefNoPrevExp(txt, i_name, SimCodeFunction.contextFunction, a_auxFunction);
      then (txt, a_auxFunction);

    case ( txt,
           SimCodeFunction.FUNCTION_PTR(name = i_name_1),
           a_auxFunction )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        ret_0 = System.unquoteIdentifier(i_name_1);
        txt = Tpl.writeStr(txt, ret_0);
      then (txt, a_auxFunction);

    case ( txt,
           _,
           a_auxFunction )
      then (txt, a_auxFunction);
  end match;
end fun_177;

public function funArgName
  input Tpl.Text txt;
  input SimCodeFunction.Variable a_var;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_auxFunction;
algorithm
  l_auxFunction := Tpl.emptyTxt;
  (out_txt, l_auxFunction) := fun_177(txt, a_var, l_auxFunction);
end funArgName;

protected function fun_179
  input Tpl.Text in_txt;
  input list<DAE.Dimension> in_a_var_instDims;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_var_instDims)
    local
      Tpl.Text txt;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = {0}"));
      then txt;
  end match;
end fun_179;

protected function fun_180
  input Tpl.Text in_txt;
  input SimCodeFunction.Variable in_a_var;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_auxFunction) :=
  match(in_txt, in_a_var, in_a_auxFunction)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      String i_name_1;
      list<DAE.Dimension> i_var_instDims;
      DAE.ComponentRef i_name;
      SimCodeFunction.Variable i_var;
      String ret_0;

    case ( txt,
           (i_var as SimCodeFunction.VARIABLE(name = i_name, instDims = i_var_instDims)),
           a_auxFunction )
      equation
        txt = varType(txt, i_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        (txt, a_auxFunction) = contextCrefNoPrevExp(txt, i_name, SimCodeFunction.contextFunction, a_auxFunction);
        txt = fun_179(txt, i_var_instDims);
      then (txt, a_auxFunction);

    case ( txt,
           SimCodeFunction.FUNCTION_PTR(name = i_name_1),
           a_auxFunction )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_fnptr _"));
        ret_0 = System.unquoteIdentifier(i_name_1);
        txt = Tpl.writeStr(txt, ret_0);
      then (txt, a_auxFunction);

    case ( txt,
           _,
           a_auxFunction )
      then (txt, a_auxFunction);
  end match;
end fun_180;

public function funArgDefinition
  input Tpl.Text txt;
  input SimCodeFunction.Variable a_var;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_auxFunction;
algorithm
  l_auxFunction := Tpl.emptyTxt;
  (out_txt, l_auxFunction) := fun_180(txt, a_var, l_auxFunction);
end funArgDefinition;

protected function fun_182
  input Tpl.Text in_txt;
  input SimCodeFunction.Variable in_a_var;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_var)
    local
      Tpl.Text txt;
      SimCodeFunction.Variable i_var;

    case ( txt,
           (i_var as SimCodeFunction.VARIABLE(name = _)) )
      equation
        txt = varType(txt, i_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = funArgName(txt, i_var);
      then txt;

    case ( txt,
           _ )
      equation
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 979, 14), "funArgDefinitionKernelFunctionInterface : unsupported function argument type");
      then txt;
  end match;
end fun_182;

public function funArgDefinitionKernelFunctionInterface
  input Tpl.Text txt;
  input SimCodeFunction.Variable a_var;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_auxFunction;
algorithm
  l_auxFunction := Tpl.emptyTxt;
  out_txt := fun_182(txt, a_var);
end funArgDefinitionKernelFunctionInterface;

protected function fun_184
  input Tpl.Text in_txt;
  input SimCodeFunction.Variable in_a_var;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_var)
    local
      Tpl.Text txt;
      SimCodeFunction.Variable i_var;

    case ( txt,
           (i_var as SimCodeFunction.VARIABLE(name = _)) )
      equation
        txt = varType(txt, i_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" *out"));
        txt = funArgName(txt, i_var);
      then txt;

    case ( txt,
           _ )
      equation
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 988, 14), "tupleOutfunArgDefinitionKernelFunctionInterface : unsupported function argument type");
      then txt;
  end match;
end fun_184;

public function tupleOutfunArgDefinitionKernelFunctionInterface
  input Tpl.Text txt;
  input SimCodeFunction.Variable a_var;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_auxFunction;
algorithm
  l_auxFunction := Tpl.emptyTxt;
  out_txt := fun_184(txt, a_var);
end tupleOutfunArgDefinitionKernelFunctionInterface;

protected function fun_186
  input Tpl.Text in_txt;
  input DAE.VarParallelism in_a_parallelism;
  input Tpl.Text in_a_varName;
  input DAE.Type in_a_var_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_parallelism, in_a_varName, in_a_var_ty)
    local
      Tpl.Text txt;
      Tpl.Text a_varName;
      DAE.Type a_var_ty;

    case ( txt,
           DAE.PARGLOBAL(),
           a_varName,
           a_var_ty )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("__global modelica_"));
        txt = expTypeShort(txt, a_var_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("* data_"));
        txt = Tpl.writeText(txt, a_varName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("    __global modelica_integer* info_"));
        txt = Tpl.writeText(txt, a_varName);
      then txt;

    case ( txt,
           DAE.PARLOCAL(),
           a_varName,
           a_var_ty )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("__local modelica_"));
        txt = expTypeShort(txt, a_var_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("* data_"));
        txt = Tpl.writeText(txt, a_varName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("    __local modelica_integer* info_"));
        txt = Tpl.writeText(txt, a_varName);
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_186;

protected function fun_187
  input Tpl.Text in_txt;
  input list<DAE.Dimension> in_a_instDims;
  input DAE.VarParallelism in_a_parallelism;
  input Tpl.Text in_a_varName;
  input DAE.Type in_a_var_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_instDims, in_a_parallelism, in_a_varName, in_a_var_ty)
    local
      Tpl.Text txt;
      DAE.VarParallelism a_parallelism;
      Tpl.Text a_varName;
      DAE.Type a_var_ty;

    case ( txt,
           {},
           _,
           a_varName,
           a_var_ty )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_"));
        txt = expTypeShort(txt, a_var_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, a_varName);
      then txt;

    case ( txt,
           _,
           a_parallelism,
           a_varName,
           a_var_ty )
      equation
        txt = fun_186(txt, a_parallelism, a_varName, a_var_ty);
      then txt;
  end match;
end fun_187;

protected function fun_188
  input Tpl.Text in_txt;
  input SimCodeFunction.Variable in_a_var;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_auxFunction) :=
  match(in_txt, in_a_var, in_a_auxFunction)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      DAE.VarParallelism i_parallelism;
      list<DAE.Dimension> i_instDims;
      DAE.Type i_var_ty;
      DAE.ComponentRef i_var_name;
      Tpl.Text l_varName;

    case ( txt,
           SimCodeFunction.VARIABLE(ty = (i_var_ty as DAE.T_ARRAY(ty = _)), parallelism = DAE.PARGLOBAL(), name = i_var_name),
           a_auxFunction )
      equation
        (l_varName, a_auxFunction) = contextCrefNoPrevExp(Tpl.emptyTxt, i_var_name, SimCodeFunction.contextParallelFunction, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("__global modelica_"));
        txt = expTypeShort(txt, i_var_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("* data_"));
        txt = Tpl.writeText(txt, l_varName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("    __global modelica_integer* info_"));
        txt = Tpl.writeText(txt, l_varName);
      then (txt, a_auxFunction);

    case ( txt,
           SimCodeFunction.VARIABLE(ty = (i_var_ty as DAE.T_ARRAY(ty = _)), parallelism = DAE.PARLOCAL(), name = i_var_name),
           a_auxFunction )
      equation
        (l_varName, a_auxFunction) = contextCrefNoPrevExp(Tpl.emptyTxt, i_var_name, SimCodeFunction.contextParallelFunction, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("__local modelica_"));
        txt = expTypeShort(txt, i_var_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("* data_"));
        txt = Tpl.writeText(txt, l_varName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("    __local modelica_integer* info_"));
        txt = Tpl.writeText(txt, l_varName);
      then (txt, a_auxFunction);

    case ( txt,
           SimCodeFunction.VARIABLE(name = i_var_name, instDims = i_instDims, ty = i_var_ty, parallelism = i_parallelism),
           a_auxFunction )
      equation
        (l_varName, a_auxFunction) = contextCrefNoPrevExp(Tpl.emptyTxt, i_var_name, SimCodeFunction.contextParallelFunction, a_auxFunction);
        txt = fun_187(txt, i_instDims, i_parallelism, l_varName, i_var_ty);
      then (txt, a_auxFunction);

    case ( txt,
           _,
           a_auxFunction )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#error Unknown variable type in as function argument funArgDefinitionKernelFunctionBody"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then (txt, a_auxFunction);
  end match;
end fun_188;

public function funArgDefinitionKernelFunctionBody
  input Tpl.Text txt;
  input SimCodeFunction.Variable a_var;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_auxFunction;
algorithm
  l_auxFunction := Tpl.emptyTxt;
  (out_txt, l_auxFunction) := fun_188(txt, a_var, l_auxFunction);
end funArgDefinitionKernelFunctionBody;

protected function fun_190
  input Tpl.Text in_txt;
  input list<DAE.Dimension> in_a_instDims;
  input Tpl.Text in_a_varName;
  input DAE.Type in_a_var_ty;
  input Tpl.Text in_a_parArgList;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_parArgList;
algorithm
  (out_txt, out_a_parArgList) :=
  match(in_txt, in_a_instDims, in_a_varName, in_a_var_ty, in_a_parArgList)
    local
      Tpl.Text txt;
      Tpl.Text a_varName;
      DAE.Type a_var_ty;
      Tpl.Text a_parArgList;

    case ( txt,
           {},
           a_varName,
           a_var_ty,
           a_parArgList )
      equation
        a_parArgList = Tpl.writeTok(a_parArgList, Tpl.ST_STRING(","));
        a_parArgList = Tpl.writeTok(a_parArgList, Tpl.ST_NEW_LINE());
        a_parArgList = Tpl.writeTok(a_parArgList, Tpl.ST_STRING("    modelica_"));
        a_parArgList = expTypeShort(a_parArgList, a_var_ty);
        a_parArgList = Tpl.writeTok(a_parArgList, Tpl.ST_STRING(" "));
        a_parArgList = Tpl.writeText(a_parArgList, a_varName);
      then (txt, a_parArgList);

    case ( txt,
           _,
           a_varName,
           a_var_ty,
           a_parArgList )
      equation
        a_parArgList = Tpl.writeTok(a_parArgList, Tpl.ST_STRING(","));
        a_parArgList = Tpl.writeTok(a_parArgList, Tpl.ST_NEW_LINE());
        a_parArgList = Tpl.writeTok(a_parArgList, Tpl.ST_STRING("    __global modelica_"));
        a_parArgList = expTypeShort(a_parArgList, a_var_ty);
        a_parArgList = Tpl.writeTok(a_parArgList, Tpl.ST_STRING("* data_"));
        a_parArgList = Tpl.writeText(a_parArgList, a_varName);
        a_parArgList = Tpl.writeTok(a_parArgList, Tpl.ST_STRING(","));
        a_parArgList = Tpl.writeTok(a_parArgList, Tpl.ST_NEW_LINE());
        a_parArgList = Tpl.writeTok(a_parArgList, Tpl.ST_STRING("    __global modelica_integer* info_"));
        a_parArgList = Tpl.writeText(a_parArgList, a_varName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
      then (txt, a_parArgList);
  end match;
end fun_190;

protected function fun_191
  input Tpl.Text in_txt;
  input SimCodeFunction.Variable in_a_var;
  input Tpl.Text in_a_parArgList;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_parArgList;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_parArgList, out_a_auxFunction) :=
  match(in_txt, in_a_var, in_a_parArgList, in_a_auxFunction)
    local
      Tpl.Text txt;
      Tpl.Text a_parArgList;
      Tpl.Text a_auxFunction;
      list<DAE.Dimension> i_instDims;
      DAE.Type i_var_ty;
      DAE.ComponentRef i_var_name;
      Tpl.Text l_varName;

    case ( txt,
           SimCodeFunction.VARIABLE(ty = (i_var_ty as DAE.T_ARRAY(ty = _)), name = i_var_name),
           a_parArgList,
           a_auxFunction )
      equation
        (l_varName, a_auxFunction) = contextCrefNoPrevExp(Tpl.emptyTxt, i_var_name, SimCodeFunction.contextParallelFunction, a_auxFunction);
        a_parArgList = Tpl.writeTok(a_parArgList, Tpl.ST_STRING(","));
        a_parArgList = Tpl.writeTok(a_parArgList, Tpl.ST_NEW_LINE());
        a_parArgList = Tpl.writeTok(a_parArgList, Tpl.ST_STRING("    __global modelica_"));
        a_parArgList = expTypeShort(a_parArgList, i_var_ty);
        a_parArgList = Tpl.writeTok(a_parArgList, Tpl.ST_STRING("* data_"));
        a_parArgList = Tpl.writeText(a_parArgList, l_varName);
        a_parArgList = Tpl.writeTok(a_parArgList, Tpl.ST_STRING(","));
        a_parArgList = Tpl.writeTok(a_parArgList, Tpl.ST_NEW_LINE());
        a_parArgList = Tpl.writeTok(a_parArgList, Tpl.ST_STRING("    __global modelica_integer* info_"));
        a_parArgList = Tpl.writeText(a_parArgList, l_varName);
      then (txt, a_parArgList, a_auxFunction);

    case ( txt,
           SimCodeFunction.VARIABLE(name = i_var_name, instDims = i_instDims, ty = i_var_ty),
           a_parArgList,
           a_auxFunction )
      equation
        (l_varName, a_auxFunction) = contextCrefNoPrevExp(Tpl.emptyTxt, i_var_name, SimCodeFunction.contextParallelFunction, a_auxFunction);
        (txt, a_parArgList) = fun_190(txt, i_instDims, l_varName, i_var_ty, a_parArgList);
      then (txt, a_parArgList, a_auxFunction);

    case ( txt,
           _,
           a_parArgList,
           a_auxFunction )
      equation
        a_parArgList = Tpl.pushBlock(a_parArgList, Tpl.BT_INDENT(4));
        a_parArgList = Tpl.writeTok(a_parArgList, Tpl.ST_STRING("#error Unknown variable type in as function argument funArgDefinitionKernelFunctionBody2"));
        a_parArgList = Tpl.writeTok(a_parArgList, Tpl.ST_NEW_LINE());
        a_parArgList = Tpl.popBlock(a_parArgList);
      then (txt, a_parArgList, a_auxFunction);
  end match;
end fun_191;

public function funArgDefinitionKernelFunctionBody2
  input Tpl.Text txt;
  input SimCodeFunction.Variable a_var;
  input Tpl.Text a_parArgList;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_parArgList;
protected
  Tpl.Text l_auxFunction;
algorithm
  l_auxFunction := Tpl.emptyTxt;
  (out_txt, out_a_parArgList, l_auxFunction) := fun_191(txt, a_var, a_parArgList, l_auxFunction);
end funArgDefinitionKernelFunctionBody2;

protected function fun_193
  input Tpl.Text in_txt;
  input DAE.Type in_a_cref_identType;
  input Tpl.Text in_a_varName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_cref_identType, in_a_varName)
    local
      Tpl.Text txt;
      Tpl.Text a_varName;

    case ( txt,
           DAE.T_ARRAY(ty = DAE.T_INTEGER(varLst = _)),
           a_varName )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("__global modelica_integer* data_"));
        txt = Tpl.writeText(txt, a_varName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("__global modelica_integer* info_"));
        txt = Tpl.writeText(txt, a_varName);
      then txt;

    case ( txt,
           DAE.T_ARRAY(ty = DAE.T_REAL(varLst = _)),
           a_varName )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("__global modelica_real* data_"));
        txt = Tpl.writeText(txt, a_varName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("__global modelica_integer* info_"));
        txt = Tpl.writeText(txt, a_varName);
      then txt;

    case ( txt,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Template error in parFunArgDefinitionFromLooptupleVar"));
      then txt;
  end match;
end fun_193;

protected function fun_194
  input Tpl.Text in_txt;
  input DAE.Type in_a_cref_identType;
  input Tpl.Text in_a_varName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_cref_identType, in_a_varName)
    local
      Tpl.Text txt;
      Tpl.Text a_varName;

    case ( txt,
           DAE.T_INTEGER(varLst = _),
           a_varName )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_integer "));
        txt = Tpl.writeText(txt, a_varName);
      then txt;

    case ( txt,
           DAE.T_REAL(varLst = _),
           a_varName )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_real "));
        txt = Tpl.writeText(txt, a_varName);
      then txt;

    case ( txt,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Tempalte error in parFunArgDefinitionFromLooptupleVar"));
      then txt;
  end match;
end fun_194;

public function parFunArgDefinitionFromLooptupleVar
  input Tpl.Text in_txt;
  input tuple<DAE.ComponentRef, SourceInfo> in_a_tupleVar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_tupleVar)
    local
      Tpl.Text txt;
      DAE.Type i_cref_identType;
      DAE.ComponentRef i_cref;
      Tpl.Text l_varName;

    case ( txt,
           ((i_cref as DAE.CREF_IDENT(identType = (i_cref_identType as DAE.T_ARRAY(ty = _)))), _) )
      equation
        l_varName = contextArrayCref(Tpl.emptyTxt, i_cref, SimCodeFunction.contextParallelFunction);
        txt = fun_193(txt, i_cref_identType, l_varName);
      then txt;

    case ( txt,
           ((i_cref as DAE.CREF_IDENT(identType = i_cref_identType)), _) )
      equation
        l_varName = contextArrayCref(Tpl.emptyTxt, i_cref, SimCodeFunction.contextParallelFunction);
        txt = fun_194(txt, i_cref_identType, l_varName);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end parFunArgDefinitionFromLooptupleVar;

protected function fun_196
  input Tpl.Text in_txt;
  input DAE.Type in_a_cref_identType;
  input Tpl.Text in_a_varName;
  input Tpl.Text in_a_reconstructedArrs;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_reconstructedArrs;
algorithm
  (out_txt, out_a_reconstructedArrs) :=
  match(in_txt, in_a_cref_identType, in_a_varName, in_a_reconstructedArrs)
    local
      Tpl.Text txt;
      Tpl.Text a_varName;
      Tpl.Text a_reconstructedArrs;

    case ( txt,
           DAE.T_ARRAY(ty = DAE.T_INTEGER(varLst = _)),
           a_varName,
           a_reconstructedArrs )
      equation
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_STRING("integer_array "));
        a_reconstructedArrs = Tpl.writeText(a_reconstructedArrs, a_varName);
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_STRING("; "));
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_NEW_LINE());
        a_reconstructedArrs = Tpl.writeText(a_reconstructedArrs, a_varName);
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_STRING(".data = data_"));
        a_reconstructedArrs = Tpl.writeText(a_reconstructedArrs, a_varName);
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_STRING("; "));
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_NEW_LINE());
        a_reconstructedArrs = Tpl.writeText(a_reconstructedArrs, a_varName);
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_STRING(".ndims = info_"));
        a_reconstructedArrs = Tpl.writeText(a_reconstructedArrs, a_varName);
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_STRING("[0]; "));
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_NEW_LINE());
        a_reconstructedArrs = Tpl.writeText(a_reconstructedArrs, a_varName);
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_STRING(".dim_size = info_"));
        a_reconstructedArrs = Tpl.writeText(a_reconstructedArrs, a_varName);
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_STRING(" + 1; "));
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_NEW_LINE());
      then (txt, a_reconstructedArrs);

    case ( txt,
           DAE.T_ARRAY(ty = DAE.T_REAL(varLst = _)),
           a_varName,
           a_reconstructedArrs )
      equation
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_STRING("real_array "));
        a_reconstructedArrs = Tpl.writeText(a_reconstructedArrs, a_varName);
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_STRING("; "));
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_NEW_LINE());
        a_reconstructedArrs = Tpl.writeText(a_reconstructedArrs, a_varName);
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_STRING(".data = data_"));
        a_reconstructedArrs = Tpl.writeText(a_reconstructedArrs, a_varName);
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_STRING("; "));
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_NEW_LINE());
        a_reconstructedArrs = Tpl.writeText(a_reconstructedArrs, a_varName);
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_STRING(".ndims = info_"));
        a_reconstructedArrs = Tpl.writeText(a_reconstructedArrs, a_varName);
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_STRING("[0]; "));
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_NEW_LINE());
        a_reconstructedArrs = Tpl.writeText(a_reconstructedArrs, a_varName);
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_STRING(".dim_size = info_"));
        a_reconstructedArrs = Tpl.writeText(a_reconstructedArrs, a_varName);
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_STRING(" + 1; "));
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_NEW_LINE());
      then (txt, a_reconstructedArrs);

    case ( txt,
           _,
           _,
           a_reconstructedArrs )
      equation
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_STRING("#wiered variable in kerenl reconstruction of arrays"));
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_NEW_LINE());
      then (txt, a_reconstructedArrs);
  end match;
end fun_196;

public function reconstructKernelArraysFromLooptupleVars
  input Tpl.Text in_txt;
  input tuple<DAE.ComponentRef, SourceInfo> in_a_tupleVar;
  input Tpl.Text in_a_reconstructedArrs;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_reconstructedArrs;
algorithm
  (out_txt, out_a_reconstructedArrs) :=
  match(in_txt, in_a_tupleVar, in_a_reconstructedArrs)
    local
      Tpl.Text txt;
      Tpl.Text a_reconstructedArrs;
      DAE.Type i_cref_identType;
      DAE.ComponentRef i_cref;
      Tpl.Text l_varName;

    case ( txt,
           ((i_cref as DAE.CREF_IDENT(identType = (i_cref_identType as DAE.T_ARRAY(ty = _)))), _),
           a_reconstructedArrs )
      equation
        l_varName = contextArrayCref(Tpl.emptyTxt, i_cref, SimCodeFunction.contextParallelFunction);
        (txt, a_reconstructedArrs) = fun_196(txt, i_cref_identType, l_varName, a_reconstructedArrs);
      then (txt, a_reconstructedArrs);

    case ( txt,
           _,
           a_reconstructedArrs )
      then (txt, a_reconstructedArrs);
  end match;
end reconstructKernelArraysFromLooptupleVars;

protected function fun_198
  input Tpl.Text in_txt;
  input list<DAE.Dimension> in_a_instDims;
  input Tpl.Text in_a_varName;
  input DAE.Type in_a_var_ty;
  input Tpl.Text in_a_reconstructedArrs;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_reconstructedArrs;
algorithm
  (out_txt, out_a_reconstructedArrs) :=
  match(in_txt, in_a_instDims, in_a_varName, in_a_var_ty, in_a_reconstructedArrs)
    local
      Tpl.Text txt;
      Tpl.Text a_varName;
      DAE.Type a_var_ty;
      Tpl.Text a_reconstructedArrs;

    case ( txt,
           {},
           _,
           _,
           a_reconstructedArrs )
      then (txt, a_reconstructedArrs);

    case ( txt,
           _,
           a_varName,
           a_var_ty,
           a_reconstructedArrs )
      equation
        a_reconstructedArrs = expTypeShort(a_reconstructedArrs, a_var_ty);
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_STRING("_array "));
        a_reconstructedArrs = Tpl.writeText(a_reconstructedArrs, a_varName);
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_STRING("; "));
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_NEW_LINE());
        a_reconstructedArrs = Tpl.writeText(a_reconstructedArrs, a_varName);
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_STRING(".data = data_"));
        a_reconstructedArrs = Tpl.writeText(a_reconstructedArrs, a_varName);
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_STRING("; "));
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_NEW_LINE());
        a_reconstructedArrs = Tpl.writeText(a_reconstructedArrs, a_varName);
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_STRING(".ndims = info_"));
        a_reconstructedArrs = Tpl.writeText(a_reconstructedArrs, a_varName);
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_STRING("[0]; "));
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_NEW_LINE());
        a_reconstructedArrs = Tpl.writeText(a_reconstructedArrs, a_varName);
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_STRING(".dim_size = info_"));
        a_reconstructedArrs = Tpl.writeText(a_reconstructedArrs, a_varName);
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_STRING(" + 1; "));
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_NEW_LINE());
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
      then (txt, a_reconstructedArrs);
  end match;
end fun_198;

protected function fun_199
  input Tpl.Text in_txt;
  input SimCodeFunction.Variable in_a_var;
  input Tpl.Text in_a_reconstructedArrs;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_reconstructedArrs;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_reconstructedArrs, out_a_auxFunction) :=
  match(in_txt, in_a_var, in_a_reconstructedArrs, in_a_auxFunction)
    local
      Tpl.Text txt;
      Tpl.Text a_reconstructedArrs;
      Tpl.Text a_auxFunction;
      list<DAE.Dimension> i_instDims;
      DAE.Type i_var_ty;
      DAE.ComponentRef i_var_name;
      Tpl.Text l_varName;

    case ( txt,
           SimCodeFunction.VARIABLE(ty = (i_var_ty as DAE.T_ARRAY(ty = _)), parallelism = DAE.PARGLOBAL(), name = i_var_name),
           a_reconstructedArrs,
           a_auxFunction )
      equation
        (l_varName, a_auxFunction) = contextCrefNoPrevExp(Tpl.emptyTxt, i_var_name, SimCodeFunction.contextParallelFunction, a_auxFunction);
        a_reconstructedArrs = expTypeShort(a_reconstructedArrs, i_var_ty);
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_STRING("_array "));
        a_reconstructedArrs = Tpl.writeText(a_reconstructedArrs, l_varName);
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_STRING("; "));
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_NEW_LINE());
        a_reconstructedArrs = Tpl.writeText(a_reconstructedArrs, l_varName);
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_STRING(".data = data_"));
        a_reconstructedArrs = Tpl.writeText(a_reconstructedArrs, l_varName);
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_STRING("; "));
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_NEW_LINE());
        a_reconstructedArrs = Tpl.writeText(a_reconstructedArrs, l_varName);
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_STRING(".ndims = info_"));
        a_reconstructedArrs = Tpl.writeText(a_reconstructedArrs, l_varName);
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_STRING("[0]; "));
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_NEW_LINE());
        a_reconstructedArrs = Tpl.writeText(a_reconstructedArrs, l_varName);
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_STRING(".dim_size = info_"));
        a_reconstructedArrs = Tpl.writeText(a_reconstructedArrs, l_varName);
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_STRING(" + 1; "));
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_NEW_LINE());
      then (txt, a_reconstructedArrs, a_auxFunction);

    case ( txt,
           SimCodeFunction.VARIABLE(ty = (i_var_ty as DAE.T_ARRAY(ty = _)), parallelism = DAE.PARLOCAL(), name = i_var_name),
           a_reconstructedArrs,
           a_auxFunction )
      equation
        (l_varName, a_auxFunction) = contextCrefNoPrevExp(Tpl.emptyTxt, i_var_name, SimCodeFunction.contextParallelFunction, a_auxFunction);
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_STRING("local_"));
        a_reconstructedArrs = expTypeShort(a_reconstructedArrs, i_var_ty);
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_STRING("_array "));
        a_reconstructedArrs = Tpl.writeText(a_reconstructedArrs, l_varName);
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_STRING("; "));
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_NEW_LINE());
        a_reconstructedArrs = Tpl.writeText(a_reconstructedArrs, l_varName);
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_STRING(".data = data_"));
        a_reconstructedArrs = Tpl.writeText(a_reconstructedArrs, l_varName);
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_STRING("; "));
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_NEW_LINE());
        a_reconstructedArrs = Tpl.writeText(a_reconstructedArrs, l_varName);
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_STRING(".ndims = info_"));
        a_reconstructedArrs = Tpl.writeText(a_reconstructedArrs, l_varName);
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_STRING("[0]; "));
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_NEW_LINE());
        a_reconstructedArrs = Tpl.writeText(a_reconstructedArrs, l_varName);
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_STRING(".dim_size = info_"));
        a_reconstructedArrs = Tpl.writeText(a_reconstructedArrs, l_varName);
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_STRING(" + 1; "));
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_NEW_LINE());
      then (txt, a_reconstructedArrs, a_auxFunction);

    case ( txt,
           SimCodeFunction.VARIABLE(name = i_var_name, instDims = i_instDims, ty = i_var_ty),
           a_reconstructedArrs,
           a_auxFunction )
      equation
        (l_varName, a_auxFunction) = contextCrefNoPrevExp(Tpl.emptyTxt, i_var_name, SimCodeFunction.contextParallelFunction, a_auxFunction);
        (txt, a_reconstructedArrs) = fun_198(txt, i_instDims, l_varName, i_var_ty, a_reconstructedArrs);
      then (txt, a_reconstructedArrs, a_auxFunction);

    case ( txt,
           _,
           a_reconstructedArrs,
           a_auxFunction )
      equation
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_STRING("#wiered variable in kerenl reconstruction of arrays"));
        a_reconstructedArrs = Tpl.writeTok(a_reconstructedArrs, Tpl.ST_NEW_LINE());
      then (txt, a_reconstructedArrs, a_auxFunction);
  end match;
end fun_199;

public function reconstructKernelArrays
  input Tpl.Text txt;
  input SimCodeFunction.Variable a_var;
  input Tpl.Text a_reconstructedArrs;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_reconstructedArrs;
protected
  Tpl.Text l_auxFunction;
algorithm
  l_auxFunction := Tpl.emptyTxt;
  (out_txt, out_a_reconstructedArrs, l_auxFunction) := fun_199(txt, a_var, a_reconstructedArrs, l_auxFunction);
end reconstructKernelArrays;

protected function fun_201
  input Tpl.Text in_txt;
  input SimCodeFunction.Variable in_a_var;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_auxFunction) :=
  match(in_txt, in_a_var, in_a_auxFunction)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      String i_name_1;
      DAE.ComponentRef i_name;
      String ret_0;

    case ( txt,
           SimCodeFunction.VARIABLE(name = i_name),
           a_auxFunction )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_metatype "));
        (txt, a_auxFunction) = contextCrefNoPrevExp(txt, i_name, SimCodeFunction.contextFunction, a_auxFunction);
      then (txt, a_auxFunction);

    case ( txt,
           SimCodeFunction.FUNCTION_PTR(name = i_name_1),
           a_auxFunction )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_fnptr _"));
        ret_0 = System.unquoteIdentifier(i_name_1);
        txt = Tpl.writeStr(txt, ret_0);
      then (txt, a_auxFunction);

    case ( txt,
           _,
           a_auxFunction )
      then (txt, a_auxFunction);
  end match;
end fun_201;

public function funArgBoxedDefinition
  input Tpl.Text txt;
  input SimCodeFunction.Variable a_var;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_auxFunction;
algorithm
  l_auxFunction := Tpl.emptyTxt;
  (out_txt, l_auxFunction) := fun_201(txt, a_var, l_auxFunction);
end funArgBoxedDefinition;

protected function fun_203
  input Tpl.Text in_txt;
  input String in_a_language;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_language)
    local
      Tpl.Text txt;

    case ( txt,
           "BUILTIN" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("true"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_203;

protected function fun_204
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_fargsStrEscaped;
  input Tpl.Text in_a_fargsStr;
  input Tpl.Text in_a_fn__name;
  input SimCodeFunction.SimExtArg in_a_extReturn;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_fargsStrEscaped, in_a_fargsStr, in_a_fn__name, in_a_extReturn)
    local
      Tpl.Text txt;
      Tpl.Text a_fargsStrEscaped;
      Tpl.Text a_fargsStr;
      Tpl.Text a_fn__name;
      SimCodeFunction.SimExtArg a_extReturn;

    case ( txt,
           false,
           _,
           a_fargsStr,
           a_fn__name,
           a_extReturn )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("extern "));
        txt = extReturnType(txt, a_extReturn);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, a_fn__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_fargsStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;

    case ( txt,
           _,
           a_fargsStrEscaped,
           _,
           a_fn__name,
           a_extReturn )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "/*\n",
                                    " * The function has annotation(Include=...>) or is builtin\n",
                                    " * the external function definition should be present\n",
                                    " * in one of these files and have this prototype:\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("* extern "));
        txt = extReturnType(txt, a_extReturn);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, a_fn__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_fargsStrEscaped);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ");\n",
                                    "*/"
                                }, false));
        txt = Tpl.popBlock(txt);
      then txt;
  end match;
end fun_204;

public function extFunDef
  input Tpl.Text in_txt;
  input SimCodeFunction.Function in_a_fn;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fn)
    local
      Tpl.Text txt;
      SimCodeFunction.SimExtArg i_extReturn;
      list<String> i_includes;
      list<SimCodeFunction.SimExtArg> i_extArgs;
      String i_language;
      String i_extName;
      Boolean ret_8;
      Boolean ret_7;
      Boolean ret_6;
      Boolean ret_5;
      Boolean ret_4;
      Tpl.Text l_isBuiltin;
      Tpl.Text l_fargsStrEscaped;
      Tpl.Text l_fargsStr;
      Tpl.Text l_fn__name;

    case ( txt,
           SimCodeFunction.EXTERNAL_FUNCTION(extName = i_extName, language = i_language, extArgs = i_extArgs, includes = i_includes, extReturn = i_extReturn) )
      equation
        l_fn__name = extFunctionName(Tpl.emptyTxt, i_extName, i_language);
        l_fargsStr = extFunDefArgs(Tpl.emptyTxt, i_extArgs, i_language);
        l_fargsStrEscaped = CodegenUtil.escapeCComments(Tpl.emptyTxt, Tpl.textString(l_fargsStr));
        l_isBuiltin = fun_203(Tpl.emptyTxt, i_language);
        ret_4 = listEmpty(i_includes);
        ret_5 = boolNot(ret_4);
        ret_6 = stringEq(Tpl.textString(l_isBuiltin), "");
        ret_7 = boolNot(ret_6);
        ret_8 = boolOr(ret_5, ret_7);
        txt = fun_204(txt, ret_8, l_fargsStrEscaped, l_fargsStr, l_fn__name, i_extReturn);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end extFunDef;

public function extFunDefDynamic
  input Tpl.Text in_txt;
  input SimCodeFunction.Function in_a_fn;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fn)
    local
      Tpl.Text txt;
      SimCodeFunction.SimExtArg i_extReturn;
      list<SimCodeFunction.SimExtArg> i_extArgs;
      String i_language;
      String i_extName;
      Tpl.Text l_fargsStr;
      Tpl.Text l_fn__name;

    case ( txt,
           SimCodeFunction.EXTERNAL_FUNCTION(extName = i_extName, language = i_language, extArgs = i_extArgs, extReturn = i_extReturn) )
      equation
        l_fn__name = extFunctionName(Tpl.emptyTxt, i_extName, i_language);
        l_fargsStr = extFunDefArgs(Tpl.emptyTxt, i_extArgs, i_language);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("typedef "));
        txt = extReturnType(txt, i_extReturn);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" (*ptrT_"));
        txt = Tpl.writeText(txt, l_fn__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")("));
        txt = Tpl.writeText(txt, l_fargsStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ");\n",
                                    "extern ptrT_"
                                }, false));
        txt = Tpl.writeText(txt, l_fn__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" ptr_"));
        txt = Tpl.writeText(txt, l_fn__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end extFunDefDynamic;

protected function fun_207
  input Tpl.Text in_txt;
  input String in_a_language;
  input String in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_language, in_a_name)
    local
      Tpl.Text txt;
      String a_name;
      String i_language;
      Tpl.Text txt_0;

    case ( txt,
           "BUILTIN",
           a_name )
      equation
        txt = Tpl.writeStr(txt, a_name);
      then txt;

    case ( txt,
           "C",
           a_name )
      equation
        txt = Tpl.writeStr(txt, a_name);
      then txt;

    case ( txt,
           "FORTRAN 77",
           a_name )
      equation
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
      then txt;

    case ( txt,
           i_language,
           _ )
      equation
        txt_0 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("Unsupported external language: "));
        txt_0 = Tpl.writeStr(txt_0, i_language);
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 1184, 14), Tpl.textString(txt_0));
      then txt;
  end match;
end fun_207;

public function extFunctionName
  input Tpl.Text txt;
  input String a_name;
  input String a_language;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_207(txt, a_language, a_name);
end extFunctionName;

protected function lm_209
  input Tpl.Text in_txt;
  input list<SimCodeFunction.SimExtArg> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeFunction.SimExtArg> rest;
      SimCodeFunction.SimExtArg i_arg;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_arg :: rest )
      equation
        txt = extFunDefArg(txt, i_arg);
        txt = Tpl.nextIter(txt);
        txt = lm_209(txt, rest);
      then txt;
  end match;
end lm_209;

protected function lm_210
  input Tpl.Text in_txt;
  input list<SimCodeFunction.SimExtArg> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeFunction.SimExtArg> rest;
      SimCodeFunction.SimExtArg i_arg;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_arg :: rest )
      equation
        txt = extFunDefArg(txt, i_arg);
        txt = Tpl.nextIter(txt);
        txt = lm_210(txt, rest);
      then txt;
  end match;
end lm_210;

protected function lm_211
  input Tpl.Text in_txt;
  input list<SimCodeFunction.SimExtArg> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeFunction.SimExtArg> rest;
      SimCodeFunction.SimExtArg i_arg;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_arg :: rest )
      equation
        txt = extFunDefArgF77(txt, i_arg);
        txt = Tpl.nextIter(txt);
        txt = lm_211(txt, rest);
      then txt;
  end match;
end lm_211;

protected function fun_212
  input Tpl.Text in_txt;
  input String in_a_language;
  input list<SimCodeFunction.SimExtArg> in_a_args;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_language, in_a_args)
    local
      Tpl.Text txt;
      list<SimCodeFunction.SimExtArg> a_args;
      String i_language;
      Tpl.Text txt_0;

    case ( txt,
           "BUILTIN",
           a_args )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_209(txt, a_args);
        txt = Tpl.popIter(txt);
      then txt;

    case ( txt,
           "C",
           a_args )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_210(txt, a_args);
        txt = Tpl.popIter(txt);
      then txt;

    case ( txt,
           "FORTRAN 77",
           a_args )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_211(txt, a_args);
        txt = Tpl.popIter(txt);
      then txt;

    case ( txt,
           i_language,
           _ )
      equation
        txt_0 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("Unsupported external language: "));
        txt_0 = Tpl.writeStr(txt_0, i_language);
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 1193, 14), Tpl.textString(txt_0));
      then txt;
  end match;
end fun_212;

public function extFunDefArgs
  input Tpl.Text txt;
  input list<SimCodeFunction.SimExtArg> a_args;
  input String a_language;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_212(txt, a_language, a_args);
end extFunDefArgs;

public function extReturnType
  input Tpl.Text in_txt;
  input SimCodeFunction.SimExtArg in_a_extArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_extArg)
    local
      Tpl.Text txt;
      DAE.Exp i_exp;
      DAE.Type i_type__;
      Tpl.Text txt_0;

    case ( txt,
           SimCodeFunction.SIMEXTARG(type_ = i_type__) )
      equation
        txt = extType(txt, i_type__, true, false, true);
      then txt;

    case ( txt,
           SimCodeFunction.SIMNOEXTARG() )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void"));
      then txt;

    case ( txt,
           SimCodeFunction.SIMEXTARGEXP(exp = i_exp) )
      equation
        txt_0 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("Expression types are unsupported as return arguments "));
        txt_0 = ExpressionDumpTpl.dumpExp(txt_0, i_exp, "\"");
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 1202, 36), Tpl.textString(txt_0));
      then txt;

    case ( txt,
           _ )
      equation
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 1203, 14), "Unsupported return argument");
      then txt;
  end match;
end extReturnType;

protected function fun_215
  input Tpl.Text in_txt;
  input Boolean in_a_returnType;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_returnType)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("*"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_215;

protected function fun_216
  input Tpl.Text in_txt;
  input DAE.Type in_a_type;
  input Boolean in_a_returnType;
  input Boolean in_a_isInput;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_type, in_a_returnType, in_a_isInput)
    local
      Tpl.Text txt;
      Boolean a_returnType;
      Boolean a_isInput;
      DAE.Type i_type;
      Absyn.Path i_rname;
      DAE.Type i_ty;
      Tpl.Text txt_0;
      String ret_0;

    case ( txt,
           DAE.T_INTEGER(varLst = _),
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("int"));
      then txt;

    case ( txt,
           DAE.T_REAL(varLst = _),
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("double"));
      then txt;

    case ( txt,
           DAE.T_STRING(varLst = _),
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("const char*"));
      then txt;

    case ( txt,
           DAE.T_BOOL(varLst = _),
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("int"));
      then txt;

    case ( txt,
           DAE.T_ENUMERATION(index = _),
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("int"));
      then txt;

    case ( txt,
           DAE.T_ARRAY(ty = i_ty),
           a_returnType,
           a_isInput )
      equation
        txt = extType(txt, i_ty, a_isInput, true, a_returnType);
      then txt;

    case ( txt,
           DAE.T_COMPLEX(complexClassType = ClassInf.EXTERNAL_OBJ(path = _)),
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void *"));
      then txt;

    case ( txt,
           DAE.T_COMPLEX(complexClassType = ClassInf.RECORD(path = i_rname)),
           a_returnType,
           _ )
      equation
        txt = CodegenUtil.underscorePath(txt, i_rname);
        txt = fun_215(txt, a_returnType);
      then txt;

    case ( txt,
           DAE.T_METATYPE(ty = _),
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_metatype"));
      then txt;

    case ( txt,
           DAE.T_METABOXED(ty = _),
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_metatype"));
      then txt;

    case ( txt,
           DAE.T_FUNCTION_REFERENCE_VAR(functionType = _),
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_fnptr"));
      then txt;

    case ( txt,
           i_type,
           _,
           _ )
      equation
        txt_0 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("Unknown external C type "));
        ret_0 = Types.unparseType(i_type);
        txt_0 = Tpl.writeStr(txt_0, ret_0);
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 1225, 14), Tpl.textString(txt_0));
      then txt;
  end match;
end fun_216;

protected function fun_217
  input Tpl.Text in_txt;
  input String in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           "const char*" )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("const "));
      then txt;
  end match;
end fun_217;

protected function fun_218
  input Tpl.Text in_txt;
  input Boolean in_a_isArray;
  input Tpl.Text in_a_s;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_isArray, in_a_s)
    local
      Tpl.Text txt;
      Tpl.Text a_s;
      String str_0;

    case ( txt,
           false,
           a_s )
      equation
        txt = Tpl.writeText(txt, a_s);
      then txt;

    case ( txt,
           _,
           a_s )
      equation
        str_0 = Tpl.textString(a_s);
        txt = fun_217(txt, str_0);
        txt = Tpl.writeText(txt, a_s);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("*"));
      then txt;
  end match;
end fun_218;

protected function fun_219
  input Tpl.Text in_txt;
  input Boolean in_a_isInput;
  input Boolean in_a_isArray;
  input Tpl.Text in_a_s;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_isInput, in_a_isArray, in_a_s)
    local
      Tpl.Text txt;
      Boolean a_isArray;
      Tpl.Text a_s;

    case ( txt,
           false,
           _,
           a_s )
      equation
        txt = Tpl.writeText(txt, a_s);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("*"));
      then txt;

    case ( txt,
           _,
           a_isArray,
           a_s )
      equation
        txt = fun_218(txt, a_isArray, a_s);
      then txt;
  end match;
end fun_219;

protected function fun_220
  input Tpl.Text in_txt;
  input DAE.Type in_a_type;
  input Boolean in_a_isArray;
  input Boolean in_a_isInput;
  input Tpl.Text in_a_s;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_type, in_a_isArray, in_a_isInput, in_a_s)
    local
      Tpl.Text txt;
      Boolean a_isArray;
      Boolean a_isInput;
      Tpl.Text a_s;

    case ( txt,
           DAE.T_ARRAY(ty = _),
           _,
           _,
           a_s )
      equation
        txt = Tpl.writeText(txt, a_s);
      then txt;

    case ( txt,
           _,
           a_isArray,
           a_isInput,
           a_s )
      equation
        txt = fun_219(txt, a_isInput, a_isArray, a_s);
      then txt;
  end match;
end fun_220;

public function extType
  input Tpl.Text txt;
  input DAE.Type a_type;
  input Boolean a_isInput;
  input Boolean a_isArray;
  input Boolean a_returnType;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_s;
algorithm
  l_s := fun_216(Tpl.emptyTxt, a_type, a_returnType, a_isInput);
  out_txt := fun_220(txt, a_type, a_isArray, a_isInput, l_s);
end extType;

protected function fun_222
  input Tpl.Text in_txt;
  input DAE.Type in_a_type;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_type)
    local
      Tpl.Text txt;
      DAE.Type i_type;
      Absyn.Path i_rname;
      DAE.Type i_ty;
      Tpl.Text txt_0;
      String ret_0;

    case ( txt,
           DAE.T_INTEGER(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("int"));
      then txt;

    case ( txt,
           DAE.T_REAL(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("double"));
      then txt;

    case ( txt,
           DAE.T_STRING(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("char"));
      then txt;

    case ( txt,
           DAE.T_BOOL(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("int"));
      then txt;

    case ( txt,
           DAE.T_ENUMERATION(index = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("int"));
      then txt;

    case ( txt,
           DAE.T_ARRAY(ty = i_ty) )
      equation
        txt = extTypeF77(txt, i_ty, true);
      then txt;

    case ( txt,
           DAE.T_COMPLEX(complexClassType = ClassInf.EXTERNAL_OBJ(path = _)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void*"));
      then txt;

    case ( txt,
           DAE.T_COMPLEX(complexClassType = ClassInf.RECORD(path = i_rname)) )
      equation
        txt = CodegenUtil.underscorePath(txt, i_rname);
      then txt;

    case ( txt,
           DAE.T_METATYPE(ty = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void*"));
      then txt;

    case ( txt,
           DAE.T_METABOXED(ty = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void*"));
      then txt;

    case ( txt,
           i_type )
      equation
        txt_0 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("Unknown external F77 type "));
        ret_0 = Types.unparseType(i_type);
        txt_0 = Tpl.writeStr(txt_0, ret_0);
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 1244, 14), Tpl.textString(txt_0));
      then txt;
  end match;
end fun_222;

protected function fun_223
  input Tpl.Text in_txt;
  input Boolean in_a_isReference;
  input Tpl.Text in_a_s;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_isReference, in_a_s)
    local
      Tpl.Text txt;
      Tpl.Text a_s;

    case ( txt,
           false,
           a_s )
      equation
        txt = Tpl.writeText(txt, a_s);
      then txt;

    case ( txt,
           _,
           a_s )
      equation
        txt = Tpl.writeText(txt, a_s);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("*"));
      then txt;
  end match;
end fun_223;

protected function fun_224
  input Tpl.Text in_txt;
  input DAE.Type in_a_type;
  input Boolean in_a_isReference;
  input Tpl.Text in_a_s;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_type, in_a_isReference, in_a_s)
    local
      Tpl.Text txt;
      Boolean a_isReference;
      Tpl.Text a_s;

    case ( txt,
           DAE.T_ARRAY(ty = _),
           _,
           a_s )
      equation
        txt = Tpl.writeText(txt, a_s);
      then txt;

    case ( txt,
           _,
           a_isReference,
           a_s )
      equation
        txt = fun_223(txt, a_isReference, a_s);
      then txt;
  end match;
end fun_224;

public function extTypeF77
  input Tpl.Text txt;
  input DAE.Type a_type;
  input Boolean a_isReference;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_s;
algorithm
  l_s := fun_222(Tpl.emptyTxt, a_type);
  out_txt := fun_224(txt, a_type, a_isReference, l_s);
end extTypeF77;

protected function fun_226
  input Tpl.Text in_txt;
  input SimCodeFunction.SimExtArg in_a_extArg;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_auxFunction) :=
  match(in_txt, in_a_extArg, in_a_auxFunction)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      DAE.Type i_type__;
      Boolean i_ia;
      Boolean i_ii;
      DAE.Type i_t;
      DAE.ComponentRef i_c;
      Tpl.Text l_typeStr;
      Tpl.Text l_name;

    case ( txt,
           SimCodeFunction.SIMEXTARG(cref = i_c, isInput = i_ii, isArray = i_ia, type_ = i_t),
           a_auxFunction )
      equation
        (l_name, a_auxFunction) = contextCrefNoPrevExp(Tpl.emptyTxt, i_c, SimCodeFunction.contextFunction, a_auxFunction);
        l_typeStr = extType(Tpl.emptyTxt, i_t, i_ii, i_ia, false);
        txt = Tpl.writeText(txt, l_typeStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" /*"));
        txt = Tpl.writeText(txt, l_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("*/"));
      then (txt, a_auxFunction);

    case ( txt,
           SimCodeFunction.SIMEXTARGEXP(type_ = i_type__),
           a_auxFunction )
      equation
        l_typeStr = extType(Tpl.emptyTxt, i_type__, true, false, false);
        txt = Tpl.writeText(txt, l_typeStr);
      then (txt, a_auxFunction);

    case ( txt,
           SimCodeFunction.SIMEXTARGSIZE(cref = _),
           a_auxFunction )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("size_t"));
      then (txt, a_auxFunction);

    case ( txt,
           _,
           a_auxFunction )
      then (txt, a_auxFunction);
  end match;
end fun_226;

public function extFunDefArg
  input Tpl.Text txt;
  input SimCodeFunction.SimExtArg a_extArg;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_auxFunction;
algorithm
  l_auxFunction := Tpl.emptyTxt;
  (out_txt, l_auxFunction) := fun_226(txt, a_extArg, l_auxFunction);
end extFunDefArg;

protected function fun_228
  input Tpl.Text in_txt;
  input SimCodeFunction.SimExtArg in_a_extArg;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_auxFunction) :=
  match(in_txt, in_a_extArg, in_a_auxFunction)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      DAE.Type i_type__;
      DAE.Type i_t;
      DAE.ComponentRef i_c;
      Tpl.Text l_typeStr;
      Tpl.Text l_name;

    case ( txt,
           SimCodeFunction.SIMEXTARG(cref = i_c, isInput = _, type_ = i_t),
           a_auxFunction )
      equation
        (l_name, a_auxFunction) = contextCrefNoPrevExp(Tpl.emptyTxt, i_c, SimCodeFunction.contextFunction, a_auxFunction);
        l_typeStr = extTypeF77(Tpl.emptyTxt, i_t, true);
        txt = Tpl.writeText(txt, l_typeStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" /*"));
        txt = Tpl.writeText(txt, l_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("*/"));
      then (txt, a_auxFunction);

    case ( txt,
           SimCodeFunction.SIMEXTARGEXP(type_ = i_type__),
           a_auxFunction )
      equation
        txt = extTypeF77(txt, i_type__, true);
      then (txt, a_auxFunction);

    case ( txt,
           SimCodeFunction.SIMEXTARGSIZE(cref = _),
           a_auxFunction )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("int *"));
      then (txt, a_auxFunction);

    case ( txt,
           _,
           a_auxFunction )
      then (txt, a_auxFunction);
  end match;
end fun_228;

public function extFunDefArgF77
  input Tpl.Text txt;
  input SimCodeFunction.SimExtArg a_extArg;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_auxFunction;
algorithm
  l_auxFunction := Tpl.emptyTxt;
  (out_txt, l_auxFunction) := fun_228(txt, a_extArg, l_auxFunction);
end extFunDefArgF77;

protected function fun_230
  input Tpl.Text in_txt;
  input Boolean in_a_dotPath;
  input Absyn.Path in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_dotPath, in_a_name)
    local
      Tpl.Text txt;
      Absyn.Path a_name;

    case ( txt,
           false,
           a_name )
      equation
        txt = CodegenUtil.underscorePath(txt, a_name);
      then txt;

    case ( txt,
           _,
           a_name )
      equation
        txt = CodegenUtil.dotPath(txt, a_name);
      then txt;
  end match;
end fun_230;

protected function fun_231
  input Tpl.Text in_txt;
  input Boolean in_a_dotPath;
  input Absyn.Path in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_dotPath, in_a_name)
    local
      Tpl.Text txt;
      Absyn.Path a_name;

    case ( txt,
           false,
           a_name )
      equation
        txt = CodegenUtil.underscorePath(txt, a_name);
      then txt;

    case ( txt,
           _,
           a_name )
      equation
        txt = CodegenUtil.dotPath(txt, a_name);
      then txt;
  end match;
end fun_231;

protected function fun_232
  input Tpl.Text in_txt;
  input Boolean in_a_dotPath;
  input Absyn.Path in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_dotPath, in_a_name)
    local
      Tpl.Text txt;
      Absyn.Path a_name;

    case ( txt,
           false,
           a_name )
      equation
        txt = CodegenUtil.underscorePath(txt, a_name);
      then txt;

    case ( txt,
           _,
           a_name )
      equation
        txt = CodegenUtil.dotPath(txt, a_name);
      then txt;
  end match;
end fun_232;

public function functionName
  input Tpl.Text in_txt;
  input SimCodeFunction.Function in_a_fn;
  input Boolean in_a_dotPath;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fn, in_a_dotPath)
    local
      Tpl.Text txt;
      Boolean a_dotPath;
      Absyn.Path i_name;

    case ( txt,
           SimCodeFunction.FUNCTION(name = i_name),
           a_dotPath )
      equation
        txt = fun_230(txt, a_dotPath, i_name);
      then txt;

    case ( txt,
           SimCodeFunction.EXTERNAL_FUNCTION(name = i_name),
           a_dotPath )
      equation
        txt = fun_231(txt, a_dotPath, i_name);
      then txt;

    case ( txt,
           SimCodeFunction.RECORD_CONSTRUCTOR(name = i_name),
           a_dotPath )
      equation
        txt = fun_232(txt, a_dotPath, i_name);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end functionName;

protected function lm_234
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Function> in_items;
  input Boolean in_a_isSimulation;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_isSimulation)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Function> rest;
      Boolean a_isSimulation;
      SimCodeFunction.Function i_fn;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_fn :: rest,
           a_isSimulation )
      equation
        txt = functionBody(txt, i_fn, false, a_isSimulation);
        txt = Tpl.nextIter(txt);
        txt = lm_234(txt, rest, a_isSimulation);
      then txt;
  end match;
end lm_234;

public function functionBodies
  input Tpl.Text txt;
  input list<SimCodeFunction.Function> a_functions;
  input Boolean a_isSimulation;

  output Tpl.Text out_txt;
algorithm
  out_txt := Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_234(out_txt, a_functions, a_isSimulation);
  out_txt := Tpl.popIter(out_txt);
end functionBodies;

protected function lm_236
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Function> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Function> rest;
      SimCodeFunction.Function i_fn;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_fn :: rest )
      equation
        txt = functionBodyParModelica(txt, i_fn, false);
        txt = Tpl.nextIter(txt);
        txt = lm_236(txt, rest);
      then txt;
  end match;
end lm_236;

public function functionBodiesParModelica
  input Tpl.Text txt;
  input list<SimCodeFunction.Function> a_functions;

  output Tpl.Text out_txt;
algorithm
  out_txt := Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_236(out_txt, a_functions);
  out_txt := Tpl.popIter(out_txt);
end functionBodiesParModelica;

public function functionBody
  input Tpl.Text in_txt;
  input SimCodeFunction.Function in_a_fn;
  input Boolean in_a_inFunc;
  input Boolean in_a_isSimulation;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fn, in_a_inFunc, in_a_isSimulation)
    local
      Tpl.Text txt;
      Boolean a_inFunc;
      Boolean a_isSimulation;
      SimCodeFunction.Function i_fn;

    case ( txt,
           (i_fn as SimCodeFunction.FUNCTION(name = _)),
           a_inFunc,
           a_isSimulation )
      equation
        txt = functionBodyRegularFunction(txt, i_fn, a_inFunc, a_isSimulation);
      then txt;

    case ( txt,
           (i_fn as SimCodeFunction.KERNEL_FUNCTION(name = _)),
           a_inFunc,
           _ )
      equation
        txt = functionBodyKernelFunctionInterface(txt, i_fn, a_inFunc);
      then txt;

    case ( txt,
           (i_fn as SimCodeFunction.EXTERNAL_FUNCTION(name = _)),
           a_inFunc,
           a_isSimulation )
      equation
        txt = functionBodyExternalFunction(txt, i_fn, a_inFunc, a_isSimulation);
      then txt;

    case ( txt,
           (i_fn as SimCodeFunction.RECORD_CONSTRUCTOR(name = _)),
           _,
           a_isSimulation )
      equation
        txt = functionBodyRecordConstructor(txt, i_fn, a_isSimulation);
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end functionBody;

public function functionBodyParModelica
  input Tpl.Text in_txt;
  input SimCodeFunction.Function in_a_fn;
  input Boolean in_a_inFunc;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fn, in_a_inFunc)
    local
      Tpl.Text txt;
      Boolean a_inFunc;
      SimCodeFunction.Function i_fn;

    case ( txt,
           (i_fn as SimCodeFunction.FUNCTION(name = _)),
           a_inFunc )
      equation
        txt = extractParforBodies(txt, i_fn, a_inFunc);
      then txt;

    case ( txt,
           (i_fn as SimCodeFunction.KERNEL_FUNCTION(name = _)),
           a_inFunc )
      equation
        txt = functionBodyKernelFunction(txt, i_fn, a_inFunc);
      then txt;

    case ( txt,
           (i_fn as SimCodeFunction.PARALLEL_FUNCTION(name = _)),
           a_inFunc )
      equation
        txt = functionBodyParallelFunction(txt, i_fn, a_inFunc);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end functionBodyParModelica;

protected function fun_240
  input Tpl.Text in_txt;
  input SimCodeFunction.Function in_a_fn;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fn)
    local
      Tpl.Text txt;
      list<DAE.Statement> i_body;
      Tpl.Text l_bodyPart;
      Tpl.Text l_auxFunction;
      Tpl.Text l_varDecls;

    case ( txt,
           SimCodeFunction.FUNCTION(body = i_body) )
      equation
        System.tmpTickResetIndex(0, 1);
        l_varDecls = Tpl.emptyTxt;
        l_auxFunction = Tpl.emptyTxt;
        (l_bodyPart, l_varDecls, l_auxFunction) = extractParFors(Tpl.emptyTxt, i_body, l_varDecls, l_auxFunction);
        txt = Tpl.writeText(txt, l_auxFunction);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_bodyPart);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_240;

public function extractParforBodies
  input Tpl.Text txt;
  input SimCodeFunction.Function a_fn;
  input Boolean a_inFunc;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_240(txt, a_fn);
end extractParforBodies;

protected function fun_242
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_varDecls) :=
  match(in_txt, in_mArg, in_a_varDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_varDecls;

    case ( txt,
           false,
           a_varDecls )
      then (txt, a_varDecls);

    case ( txt,
           _,
           a_varDecls )
      equation
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING("jmp_buf *old_mmc_jumper = threadData->mmc_jumper;"));
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_NEW_LINE());
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("threadData->mmc_jumper = old_mmc_jumper;"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then (txt, a_varDecls);
  end match;
end fun_242;

protected function fun_243
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_varDecls;
  input list<DAE.Statement> in_a_body;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_varDecls) :=
  match(in_txt, in_mArg, in_a_varDecls, in_a_body)
    local
      Tpl.Text txt;
      Tpl.Text a_varDecls;
      list<DAE.Statement> a_body;
      Boolean ret_0;

    case ( txt,
           false,
           a_varDecls,
           _ )
      then (txt, a_varDecls);

    case ( txt,
           _,
           a_varDecls,
           a_body )
      equation
        ret_0 = DAEUtil.statementsContainTryBlock(a_body);
        (txt, a_varDecls) = fun_242(txt, ret_0, a_varDecls);
      then (txt, a_varDecls);
  end match;
end fun_243;

protected function lm_244
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varFrees;
  input Tpl.Text in_a_varInits;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varFrees;
  output Tpl.Text out_a_varInits;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varFrees, out_a_varInits, out_a_varDecls) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varFrees, in_a_varInits, in_a_varDecls)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varFrees;
      Tpl.Text a_varInits;
      Tpl.Text a_varDecls;
      SimCodeFunction.Variable i_var;

    case ( txt,
           {},
           a_auxFunction,
           a_varFrees,
           a_varInits,
           a_varDecls )
      then (txt, a_auxFunction, a_varFrees, a_varInits, a_varDecls);

    case ( txt,
           i_var :: rest,
           a_auxFunction,
           a_varFrees,
           a_varInits,
           a_varDecls )
      equation
        (txt, a_varDecls, a_varInits, a_varFrees, a_auxFunction) = varInit(txt, i_var, "", a_varDecls, a_varInits, a_varFrees, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varFrees, a_varInits, a_varDecls) = lm_244(txt, rest, a_auxFunction, a_varFrees, a_varInits, a_varDecls);
      then (txt, a_auxFunction, a_varFrees, a_varInits, a_varDecls);
  end match;
end lm_244;

protected function lm_245
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      SimCodeFunction.Variable i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = varOutput(txt, i_var);
        txt = lm_245(txt, rest);
      then txt;
  end match;
end lm_245;

protected function lm_246
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_auxFunction) :=
  match(in_txt, in_items, in_a_auxFunction)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      Tpl.Text a_auxFunction;
      DAE.ComponentRef i_var_name;
      Absyn.Path i_path__ext;

    case ( txt,
           {},
           a_auxFunction )
      then (txt, a_auxFunction);

    case ( txt,
           SimCodeFunction.VARIABLE(ty = DAE.T_COMPLEX(complexClassType = ClassInf.EXTERNAL_OBJ(path = i_path__ext)), name = i_var_name) :: rest,
           a_auxFunction )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("omc_"));
        txt = CodegenUtil.underscorePath(txt, i_path__ext);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_destructor(threadData,"));
        (txt, a_auxFunction) = contextCrefNoPrevExp(txt, i_var_name, SimCodeFunction.contextFunction, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction) = lm_246(txt, rest, a_auxFunction);
      then (txt, a_auxFunction);

    case ( txt,
           _ :: rest,
           a_auxFunction )
      equation
        (txt, a_auxFunction) = lm_246(txt, rest, a_auxFunction);
      then (txt, a_auxFunction);
  end match;
end lm_246;

protected function fun_247
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Boolean in_a_isSimulation;
  input SimCodeFunction.Function in_a_fn;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_isSimulation, in_a_fn)
    local
      Tpl.Text txt;
      Boolean a_isSimulation;
      SimCodeFunction.Function a_fn;

    case ( txt,
           false,
           a_isSimulation,
           a_fn )
      equation
        txt = functionBodyBoxed(txt, a_fn, a_isSimulation);
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_247;

protected function fun_248
  input Tpl.Text in_txt;
  input SCode.Visibility in_a_visibility;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_visibility)
    local
      Tpl.Text txt;

    case ( txt,
           SCode.PUBLIC() )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("DLLExport"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_248;

protected function fun_249
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("MMC_SO();"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;
  end match;
end fun_249;

protected function fun_250
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_varFrees;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_varFrees)
    local
      Tpl.Text txt;
      Tpl.Text a_varFrees;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_varFrees )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/* Free GPU/OpenCL CPU memory */"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_varFrees);
      then txt;
  end match;
end fun_250;

protected function fun_251
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_a_outVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_outVars)
    local
      Tpl.Text txt;
      SimCodeFunction.Variable i_v;

    case ( txt,
           i_v :: _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("return "));
        txt = funArgName(txt, i_v);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("return;"));
      then txt;
  end match;
end fun_251;

protected function fun_252
  input Tpl.Text in_txt;
  input Boolean in_a_inFunc;
  input list<SimCodeFunction.Variable> in_a_outVars;
  input list<SimCodeFunction.Variable> in_a_functionArguments;
  input Tpl.Text in_a_fname;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_fname;
algorithm
  (out_txt, out_a_fname) :=
  match(in_txt, in_a_inFunc, in_a_outVars, in_a_functionArguments, in_a_fname)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> a_outVars;
      list<SimCodeFunction.Variable> a_functionArguments;
      Tpl.Text a_fname;

    case ( txt,
           false,
           _,
           _,
           a_fname )
      then (txt, a_fname);

    case ( txt,
           _,
           a_outVars,
           a_functionArguments,
           a_fname )
      equation
        (txt, a_fname) = generateInFunc(txt, a_fname, a_functionArguments, a_outVars);
      then (txt, a_fname);
  end match;
end fun_252;

public function functionBodyRegularFunction
  input Tpl.Text in_txt;
  input SimCodeFunction.Function in_a_fn;
  input Boolean in_a_inFunc;
  input Boolean in_a_isSimulation;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fn, in_a_inFunc, in_a_isSimulation)
    local
      Tpl.Text txt;
      Boolean a_inFunc;
      Boolean a_isSimulation;
      SCode.Visibility i_visibility;
      list<SimCodeFunction.Variable> i_functionArguments;
      SimCodeFunction.Function i_fn;
      list<SimCodeFunction.Variable> i_outVars;
      list<SimCodeFunction.Variable> i_variableDeclarations;
      list<DAE.Statement> i_body;
      Absyn.Path i_name;
      Boolean ret_17;
      Boolean ret_16;
      Tpl.Text l_prototype;
      Tpl.Text l_afterBody;
      Boolean ret_13;
      Tpl.Text l_boxedFn;
      Tpl.Text l_freeConstructedExternalObjects;
      list<SimCodeFunction.Variable> ret_10;
      Tpl.Text l_outVarAssign;
      Tpl.Text l_bodyPart;
      Tpl.Text l_0__;
      Boolean ret_6;
      Tpl.Text l_restoreJmpbuf;
      Tpl.Text l_auxFunction;
      Tpl.Text l_varFrees;
      Tpl.Text l_varInits;
      Tpl.Text l_varDecls;
      Tpl.Text l_fname;

    case ( txt,
           (i_fn as SimCodeFunction.FUNCTION(name = i_name, body = i_body, variableDeclarations = i_variableDeclarations, outVars = i_outVars, functionArguments = i_functionArguments, visibility = i_visibility)),
           a_inFunc,
           a_isSimulation )
      equation
        SimCodeFunctionUtil.codegenResetTryThrowIndex();
        System.tmpTickReset(1);
        System.tmpTickResetIndex(0, 1);
        l_fname = CodegenUtil.underscorePath(Tpl.emptyTxt, i_name);
        l_varDecls = Tpl.emptyTxt;
        l_varInits = Tpl.emptyTxt;
        l_varFrees = Tpl.emptyTxt;
        l_auxFunction = Tpl.emptyTxt;
        ret_6 = DAEUtil.statementsContainReturn(i_body);
        (l_restoreJmpbuf, l_varDecls) = fun_243(Tpl.emptyTxt, ret_6, l_varDecls, i_body);
        l_0__ = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(1, SOME(Tpl.ST_STRING("")), NONE(), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_0__, l_auxFunction, l_varFrees, l_varInits, l_varDecls) = lm_244(l_0__, i_variableDeclarations, l_auxFunction, l_varFrees, l_varInits, l_varDecls);
        l_0__ = Tpl.popIter(l_0__);
        (l_bodyPart, l_varDecls, l_auxFunction) = funStatement(Tpl.emptyTxt, i_body, l_varDecls, l_auxFunction);
        ret_10 = List.restOrEmpty(i_outVars);
        l_outVarAssign = lm_245(Tpl.emptyTxt, ret_10);
        l_freeConstructedExternalObjects = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_freeConstructedExternalObjects, l_auxFunction) = lm_246(l_freeConstructedExternalObjects, i_variableDeclarations, l_auxFunction);
        l_freeConstructedExternalObjects = Tpl.popIter(l_freeConstructedExternalObjects);
        l_varDecls = addRootsTempArray(l_varDecls);
        ret_13 = SimCodeFunctionUtil.funcHasParallelInOutArrays(i_fn);
        l_boxedFn = fun_247(Tpl.emptyTxt, ret_13, a_isSimulation, i_fn);
        l_afterBody = Tpl.emptyTxt;
        (l_prototype, l_afterBody) = functionPrototype(Tpl.emptyTxt, Tpl.textString(l_fname), i_functionArguments, i_outVars, false, i_visibility, a_isSimulation, false, l_afterBody);
        txt = Tpl.writeText(txt, l_auxFunction);
        txt = Tpl.softNewLine(txt);
        txt = fun_248(txt, i_visibility);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_prototype);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("{\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_varDecls);
        txt = Tpl.softNewLine(txt);
        ret_16 = boolNot(a_isSimulation);
        txt = fun_249(txt, ret_16);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_tailrecursive: OMC_LABEL_UNUSED\n"));
        txt = Tpl.writeText(txt, l_varInits);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_bodyPart);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_return: OMC_LABEL_UNUSED\n"));
        txt = Tpl.writeText(txt, l_outVarAssign);
        txt = Tpl.writeText(txt, l_restoreJmpbuf);
        txt = Tpl.softNewLine(txt);
        ret_17 = Config.acceptParModelicaGrammar();
        txt = fun_250(txt, ret_17, l_varFrees);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_freeConstructedExternalObjects);
        txt = Tpl.softNewLine(txt);
        txt = fun_251(txt, i_outVars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("}\n"));
        txt = Tpl.writeText(txt, l_afterBody);
        txt = Tpl.softNewLine(txt);
        (txt, l_fname) = fun_252(txt, a_inFunc, i_outVars, i_functionArguments, l_fname);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_boxedFn);
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end functionBodyRegularFunction;

protected function lm_254
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      SimCodeFunction.Variable i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = funArgDefinition(txt, i_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        txt = lm_254(txt, rest);
      then txt;
  end match;
end lm_254;

protected function lm_255
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      SimCodeFunction.Variable i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = funArgDefinition(txt, i_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        txt = lm_255(txt, rest);
      then txt;
  end match;
end lm_255;

protected function lm_256
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      SimCodeFunction.Variable i_arg;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_arg :: rest )
      equation
        txt = readInVar(txt, i_arg);
        txt = Tpl.nextIter(txt);
        txt = lm_256(txt, rest);
      then txt;
  end match;
end lm_256;

protected function fun_257
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_a_outVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_outVars)
    local
      Tpl.Text txt;
      SimCodeFunction.Variable i_v;

    case ( txt,
           i_v :: _ )
      equation
        txt = funArgName(txt, i_v);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_257;

protected function lm_258
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      SimCodeFunction.Variable i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = funArgName(txt, i_var);
        txt = lm_258(txt, rest);
      then txt;
  end match;
end lm_258;

protected function lm_259
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      SimCodeFunction.Variable i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", &"));
        txt = funArgName(txt, i_var);
        txt = lm_259(txt, rest);
      then txt;
  end match;
end lm_259;

protected function fun_260
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_a_outVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_outVars)
    local
      Tpl.Text txt;
      SimCodeFunction.Variable i_first;

    case ( txt,
           i_first :: _ )
      equation
        txt = writeOutVar(txt, i_first);
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("write_noretcall(outVar);"));
      then txt;
  end match;
end fun_260;

protected function lm_261
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      SimCodeFunction.Variable i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = writeOutVar(txt, i_var);
        txt = Tpl.nextIter(txt);
        txt = lm_261(txt, rest);
      then txt;
  end match;
end lm_261;

protected function fun_262
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("terminateHpcOmThreads();"));
      then txt;
  end match;
end fun_262;

public function generateInFunc
  input Tpl.Text txt;
  input Tpl.Text a_fname;
  input list<SimCodeFunction.Variable> a_functionArguments;
  input list<SimCodeFunction.Variable> a_outVars;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_fname;
protected
  Boolean ret_3;
  Tpl.Text txt_2;
  list<SimCodeFunction.Variable> ret_1;
  list<SimCodeFunction.Variable> ret_0;
algorithm
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                   "DLLExport\n",
                                   "int in_"
                               }, false));
  out_txt := Tpl.writeText(out_txt, a_fname);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "(threadData_t *threadData, type_description * inArgs, type_description * outVar)\n",
                                       "{\n",
                                       "  //if (!mmc_GC_state) mmc_GC_init();\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.pushIter(out_txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_254(out_txt, a_functionArguments);
  out_txt := Tpl.popIter(out_txt);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.pushIter(out_txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_255(out_txt, a_outVars);
  out_txt := Tpl.popIter(out_txt);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.pushIter(out_txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_256(out_txt, a_functionArguments);
  out_txt := Tpl.popIter(out_txt);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("MMC_TRY_TOP_INTERNAL()\n"));
  out_txt := fun_257(out_txt, a_outVars);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("omc_"));
  out_txt := Tpl.writeText(out_txt, a_fname);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("(threadData"));
  out_txt := lm_258(out_txt, a_functionArguments);
  ret_0 := List.restOrEmpty(a_outVars);
  out_txt := lm_259(out_txt, ret_0);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       ");\n",
                                       "MMC_CATCH_TOP(return 1)\n"
                                   }, true));
  out_txt := fun_260(out_txt, a_outVars);
  out_txt := Tpl.softNewLine(out_txt);
  ret_1 := List.restOrEmpty(a_outVars);
  out_txt := Tpl.pushIter(out_txt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_261(out_txt, ret_1);
  out_txt := Tpl.popIter(out_txt);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "fflush(NULL);\n",
                                       "return 0;\n"
                                   }, true));
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "}\n",
                                       "#ifdef GENERATE_MAIN_EXECUTABLE\n",
                                       "static int rml_execution_failed()\n",
                                       "{\n",
                                       "  fflush(NULL);\n",
                                       "  fprintf(stderr, \"Execution failed!\\n\");\n",
                                       "  fflush(NULL);\n",
                                       "  return 1;\n",
                                       "}\n",
                                       "\n",
                                       "void (*omc_assert)(threadData_t*,FILE_INFO info,const char *msg,...) __attribute__((noreturn)) = omc_assert_function;\n",
                                       "void (*omc_assert_warning)(FILE_INFO info,const char *msg,...) = omc_assert_warning_function;\n",
                                       "void (*omc_terminate)(FILE_INFO info,const char *msg,...) = omc_terminate_function;\n",
                                       "void (*omc_throw)(threadData_t*) __attribute__ ((noreturn)) = omc_throw_function;\n",
                                       "\n",
                                       "int main(int argc, char **argv) {\n",
                                       "  MMC_INIT(0);\n",
                                       "  {\n",
                                       "  void *lst = mmc_mk_nil();\n",
                                       "  int i = 0;\n",
                                       "\n",
                                       "  for (i=argc-1; i>0; i--) {\n",
                                       "    lst = mmc_mk_cons(mmc_mk_scon(argv[i]), lst);\n",
                                       "  }\n",
                                       "\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  txt_2 := Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("omc_"));
  txt_2 := Tpl.writeText(txt_2, a_fname);
  txt_2 := Tpl.writeTok(txt_2, Tpl.ST_STRING("(threadData, lst);"));
  (out_txt, txt_2) := mainTop(out_txt, txt_2, "https://trac.openmodelica.org/OpenModelica/newticket");
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "}\n",
                                       "\n"
                                   }, true));
  ret_3 := Flags.isSet(Flags.HPCOM);
  out_txt := fun_262(out_txt, ret_3);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "fflush(NULL);\n",
                                       "EXIT(0);\n",
                                       "return 0;\n"
                                   }, true));
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "}\n",
                                       "#endif"
                                   }, false));
  out_a_fname := a_fname;
end generateInFunc;

protected function lm_264
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varFrees;
  input Tpl.Text in_a_varInits;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varFrees;
  output Tpl.Text out_a_varInits;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varFrees, out_a_varInits, out_a_varDecls) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varFrees, in_a_varInits, in_a_varDecls)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varFrees;
      Tpl.Text a_varInits;
      Tpl.Text a_varDecls;
      SimCodeFunction.Variable i_var;

    case ( txt,
           {},
           a_auxFunction,
           a_varFrees,
           a_varInits,
           a_varDecls )
      then (txt, a_auxFunction, a_varFrees, a_varInits, a_varDecls);

    case ( txt,
           i_var :: rest,
           a_auxFunction,
           a_varFrees,
           a_varInits,
           a_varDecls )
      equation
        (txt, a_varDecls, a_varInits, a_varFrees, a_auxFunction) = varInit(txt, i_var, "", a_varDecls, a_varInits, a_varFrees, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varFrees, a_varInits, a_varDecls) = lm_264(txt, rest, a_auxFunction, a_varFrees, a_varInits, a_varDecls);
      then (txt, a_auxFunction, a_varFrees, a_varInits, a_varDecls);
  end match;
end lm_264;

protected function lm_265
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      SimCodeFunction.Variable i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = funArgDefinitionKernelFunctionBody(txt, i_var);
        txt = Tpl.nextIter(txt);
        txt = lm_265(txt, rest);
      then txt;
  end match;
end lm_265;

protected function lm_266
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;
  input Tpl.Text in_a_argStr;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_argStr;
algorithm
  (out_txt, out_a_argStr) :=
  match(in_txt, in_items, in_a_argStr)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      Tpl.Text a_argStr;
      SimCodeFunction.Variable i_var;

    case ( txt,
           {},
           a_argStr )
      then (txt, a_argStr);

    case ( txt,
           i_var :: rest,
           a_argStr )
      equation
        (txt, a_argStr) = funArgDefinitionKernelFunctionBody2(txt, i_var, a_argStr);
        txt = Tpl.nextIter(txt);
        (txt, a_argStr) = lm_266(txt, rest, a_argStr);
      then (txt, a_argStr);
  end match;
end lm_266;

protected function lm_267
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;
  input Tpl.Text in_a_reconstrucedArrays;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_reconstrucedArrays;
algorithm
  (out_txt, out_a_reconstrucedArrays) :=
  match(in_txt, in_items, in_a_reconstrucedArrays)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      Tpl.Text a_reconstrucedArrays;
      SimCodeFunction.Variable i_var;

    case ( txt,
           {},
           a_reconstrucedArrays )
      then (txt, a_reconstrucedArrays);

    case ( txt,
           i_var :: rest,
           a_reconstrucedArrays )
      equation
        (txt, a_reconstrucedArrays) = reconstructKernelArrays(txt, i_var, a_reconstrucedArrays);
        (txt, a_reconstrucedArrays) = lm_267(txt, rest, a_reconstrucedArrays);
      then (txt, a_reconstrucedArrays);
  end match;
end lm_267;

protected function lm_268
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;
  input Tpl.Text in_a_reconstrucedArrays;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_reconstrucedArrays;
algorithm
  (out_txt, out_a_reconstrucedArrays) :=
  match(in_txt, in_items, in_a_reconstrucedArrays)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      Tpl.Text a_reconstrucedArrays;
      SimCodeFunction.Variable i_var;

    case ( txt,
           {},
           a_reconstrucedArrays )
      then (txt, a_reconstrucedArrays);

    case ( txt,
           i_var :: rest,
           a_reconstrucedArrays )
      equation
        (txt, a_reconstrucedArrays) = reconstructKernelArrays(txt, i_var, a_reconstrucedArrays);
        (txt, a_reconstrucedArrays) = lm_268(txt, rest, a_reconstrucedArrays);
      then (txt, a_reconstrucedArrays);
  end match;
end lm_268;

protected function fun_269
  input Tpl.Text in_txt;
  input SimCodeFunction.Function in_a_fn;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fn)
    local
      Tpl.Text txt;
      list<DAE.Statement> i_body;
      list<SimCodeFunction.Variable> i_outVars;
      list<SimCodeFunction.Variable> i_functionArguments;
      list<SimCodeFunction.Variable> i_variableDeclarations;
      Absyn.Path i_name;
      Tpl.Text l_bodyPart;
      Tpl.Text l_0___3;
      Tpl.Text l_0___2;
      Tpl.Text l_reconstrucedArrays;
      Tpl.Text l_0___1;
      Tpl.Text l_argStr;
      Tpl.Text l_0__;
      Tpl.Text l_auxFunction;
      Tpl.Text l_varFrees;
      Tpl.Text l_varInits;
      Tpl.Text l_varDecls;
      Tpl.Text l_fname;

    case ( txt,
           SimCodeFunction.KERNEL_FUNCTION(name = i_name, variableDeclarations = i_variableDeclarations, functionArguments = i_functionArguments, outVars = i_outVars, body = i_body) )
      equation
        System.tmpTickReset(1);
        System.tmpTickResetIndex(0, 1);
        l_fname = CodegenUtil.underscorePath(Tpl.emptyTxt, i_name);
        l_varDecls = Tpl.emptyTxt;
        l_varInits = Tpl.emptyTxt;
        l_varFrees = Tpl.emptyTxt;
        l_auxFunction = Tpl.emptyTxt;
        l_0__ = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), NONE(), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_0__, l_auxFunction, l_varFrees, l_varInits, l_varDecls) = lm_264(l_0__, i_variableDeclarations, l_auxFunction, l_varFrees, l_varInits, l_varDecls);
        l_0__ = Tpl.popIter(l_0__);
        l_argStr = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING_LIST({
                                                                                   ", \n",
                                                                                   "    "
                                                                               }, false)), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_argStr = lm_265(l_argStr, i_functionArguments);
        l_argStr = Tpl.popIter(l_argStr);
        l_0___1 = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_LINE(",\n")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_0___1, l_argStr) = lm_266(l_0___1, i_outVars, l_argStr);
        l_0___1 = Tpl.popIter(l_0___1);
        l_reconstrucedArrays = Tpl.emptyTxt;
        (l_0___2, l_reconstrucedArrays) = lm_267(Tpl.emptyTxt, i_functionArguments, l_reconstrucedArrays);
        (l_0___3, l_reconstrucedArrays) = lm_268(Tpl.emptyTxt, i_outVars, l_reconstrucedArrays);
        (l_bodyPart, l_varDecls, l_auxFunction) = parModelicafunStatement(Tpl.emptyTxt, i_body, l_varDecls, l_auxFunction);
        l_varDecls = addRootsTempArray(l_varDecls);
        txt = Tpl.writeText(txt, l_auxFunction);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "__kernel void omc_"
                                }, false));
        txt = Tpl.writeText(txt, l_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("(\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeText(txt, l_argStr);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(")\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "{\n",
                                    "  /* functionBodyKernelFunction: Reconstruct Arrays */\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_reconstrucedArrays);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "/* functionBodyKernelFunction: locals */\n"
                                }, true));
        txt = Tpl.writeText(txt, l_varDecls);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "/* functionBodyKernelFunction: var inits */\n"
                                }, true));
        txt = Tpl.writeText(txt, l_varInits);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/* functionBodyKernelFunction: body */\n"));
        txt = Tpl.writeText(txt, l_bodyPart);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "/* Free GPU/OpenCL CPU memory */\n"
                                }, true));
        txt = Tpl.writeText(txt, l_varFrees);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n"
                                }, true));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_269;

public function functionBodyKernelFunction
  input Tpl.Text txt;
  input SimCodeFunction.Function a_fn;
  input Boolean a_inFunc;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_269(txt, a_fn);
end functionBodyKernelFunction;

protected function lm_271
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varFrees;
  input Tpl.Text in_a_varInits;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varFrees;
  output Tpl.Text out_a_varInits;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varFrees, out_a_varInits, out_a_varDecls) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varFrees, in_a_varInits, in_a_varDecls)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varFrees;
      Tpl.Text a_varInits;
      Tpl.Text a_varDecls;
      SimCodeFunction.Variable i_var;

    case ( txt,
           {},
           a_auxFunction,
           a_varFrees,
           a_varInits,
           a_varDecls )
      then (txt, a_auxFunction, a_varFrees, a_varInits, a_varDecls);

    case ( txt,
           i_var :: rest,
           a_auxFunction,
           a_varFrees,
           a_varInits,
           a_varDecls )
      equation
        (txt, a_varDecls, a_varInits, a_varFrees, a_auxFunction) = varInit(txt, i_var, "", a_varDecls, a_varInits, a_varFrees, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varFrees, a_varInits, a_varDecls) = lm_271(txt, rest, a_auxFunction, a_varFrees, a_varInits, a_varDecls);
      then (txt, a_auxFunction, a_varFrees, a_varInits, a_varDecls);
  end match;
end lm_271;

protected function lm_272
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      SimCodeFunction.Variable i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = varOutput(txt, i_var);
        txt = lm_272(txt, rest);
      then txt;
  end match;
end lm_272;

protected function fun_273
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_a_outVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_outVars)
    local
      Tpl.Text txt;
      SimCodeFunction.Variable i_v;

    case ( txt,
           i_v :: _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("return "));
        txt = funArgName(txt, i_v);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("return;"));
      then txt;
  end match;
end fun_273;

protected function fun_274
  input Tpl.Text in_txt;
  input SimCodeFunction.Function in_a_fn;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fn)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> i_functionArguments;
      list<SimCodeFunction.Variable> i_outVars;
      list<DAE.Statement> i_body;
      list<SimCodeFunction.Variable> i_variableDeclarations;
      Absyn.Path i_name;
      list<SimCodeFunction.Variable> ret_10;
      Tpl.Text l_outVarAssign;
      Tpl.Text l_bodyPart;
      Tpl.Text l_0__;
      Tpl.Text l_auxFunction_1;
      Tpl.Text l_outVarFrees;
      Tpl.Text l_varFrees;
      Tpl.Text l_varInits;
      Tpl.Text l_varDecls;
      Tpl.Text l_fname;
      Tpl.Text l_auxFunction;

    case ( txt,
           SimCodeFunction.PARALLEL_FUNCTION(name = i_name, variableDeclarations = i_variableDeclarations, body = i_body, outVars = i_outVars, functionArguments = i_functionArguments) )
      equation
        l_auxFunction = Tpl.emptyTxt;
        SimCodeFunctionUtil.codegenResetTryThrowIndex();
        System.tmpTickReset(1);
        System.tmpTickResetIndex(0, 1);
        l_fname = CodegenUtil.underscorePath(Tpl.emptyTxt, i_name);
        l_varDecls = Tpl.emptyTxt;
        l_varInits = Tpl.emptyTxt;
        l_varFrees = Tpl.emptyTxt;
        l_outVarFrees = Tpl.emptyTxt;
        l_auxFunction_1 = Tpl.emptyTxt;
        l_0__ = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), NONE(), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_0__, l_auxFunction_1, l_varFrees, l_varInits, l_varDecls) = lm_271(l_0__, i_variableDeclarations, l_auxFunction_1, l_varFrees, l_varInits, l_varDecls);
        l_0__ = Tpl.popIter(l_0__);
        (l_bodyPart, l_varDecls, l_auxFunction_1) = parModelicafunStatement(Tpl.emptyTxt, i_body, l_varDecls, l_auxFunction_1);
        ret_10 = List.restOrEmpty(i_outVars);
        l_outVarAssign = lm_272(Tpl.emptyTxt, ret_10);
        l_varDecls = addRootsTempArray(l_varDecls);
        txt = Tpl.writeText(txt, l_auxFunction_1);
        txt = Tpl.softNewLine(txt);
        txt = functionHeaderParallelImpl(txt, Tpl.textString(l_fname), i_functionArguments, i_outVars, false, false);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("{\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_varDecls);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_varInits);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_bodyPart);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_outVarAssign);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = fun_273(txt, i_outVars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" }"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_274;

public function functionBodyParallelFunction
  input Tpl.Text txt;
  input SimCodeFunction.Function a_fn;
  input Boolean a_inFunc;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_274(txt, a_fn);
end functionBodyParallelFunction;

protected function lm_276
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varFrees;
  input Tpl.Text in_a_varInits;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varFrees;
  output Tpl.Text out_a_varInits;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varFrees, out_a_varInits, out_a_varDecls) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varFrees, in_a_varInits, in_a_varDecls)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varFrees;
      Tpl.Text a_varInits;
      Tpl.Text a_varDecls;
      SimCodeFunction.Variable i_var;

    case ( txt,
           {},
           a_auxFunction,
           a_varFrees,
           a_varInits,
           a_varDecls )
      then (txt, a_auxFunction, a_varFrees, a_varInits, a_varDecls);

    case ( txt,
           i_var :: rest,
           a_auxFunction,
           a_varFrees,
           a_varInits,
           a_varDecls )
      equation
        (txt, a_varDecls, a_varInits, a_varFrees, a_auxFunction) = varInit(txt, i_var, "", a_varDecls, a_varInits, a_varFrees, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varFrees, a_varInits, a_varDecls) = lm_276(txt, rest, a_auxFunction, a_varFrees, a_varInits, a_varDecls);
      then (txt, a_auxFunction, a_varFrees, a_varInits, a_varDecls);
  end match;
end lm_276;

protected function lm_277
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varFrees;
  input Tpl.Text in_a_varInits;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varFrees;
  output Tpl.Text out_a_varInits;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varFrees, out_a_varInits, out_a_varDecls) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varFrees, in_a_varInits, in_a_varDecls)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varFrees;
      Tpl.Text a_varInits;
      Tpl.Text a_varDecls;
      SimCodeFunction.Variable i_var;

    case ( txt,
           {},
           a_auxFunction,
           a_varFrees,
           a_varInits,
           a_varDecls )
      then (txt, a_auxFunction, a_varFrees, a_varInits, a_varDecls);

    case ( txt,
           i_var :: rest,
           a_auxFunction,
           a_varFrees,
           a_varInits,
           a_varDecls )
      equation
        (txt, a_varDecls, a_varInits, a_varFrees, a_auxFunction) = varInit(txt, i_var, "", a_varDecls, a_varInits, a_varFrees, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varFrees, a_varInits, a_varDecls) = lm_277(txt, rest, a_auxFunction, a_varFrees, a_varInits, a_varDecls);
      then (txt, a_auxFunction, a_varFrees, a_varInits, a_varDecls);
  end match;
end lm_277;

protected function lm_278
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      SimCodeFunction.Variable i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = varOutput(txt, i_var);
        txt = lm_278(txt, rest);
      then txt;
  end match;
end lm_278;

protected function lm_279
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;
  input Tpl.Text in_a_kernelArgSets;
  input Tpl.Text in_a_kernel__arg__number;
  input Tpl.Text in_a_cl__kernelVar;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_kernelArgSets;
  output Tpl.Text out_a_kernel__arg__number;
  output Tpl.Text out_a_cl__kernelVar;
algorithm
  (out_txt, out_a_kernelArgSets, out_a_kernel__arg__number, out_a_cl__kernelVar) :=
  match(in_txt, in_items, in_a_kernelArgSets, in_a_kernel__arg__number, in_a_cl__kernelVar)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      Tpl.Text a_kernelArgSets;
      Tpl.Text a_kernel__arg__number;
      Tpl.Text a_cl__kernelVar;
      SimCodeFunction.Variable i_var;

    case ( txt,
           {},
           a_kernelArgSets,
           a_kernel__arg__number,
           a_cl__kernelVar )
      then (txt, a_kernelArgSets, a_kernel__arg__number, a_cl__kernelVar);

    case ( txt,
           i_var :: rest,
           a_kernelArgSets,
           a_kernel__arg__number,
           a_cl__kernelVar )
      equation
        (txt, a_cl__kernelVar, a_kernel__arg__number, a_kernelArgSets) = setKernelArg_ith(txt, i_var, a_cl__kernelVar, a_kernel__arg__number, a_kernelArgSets);
        (txt, a_kernelArgSets, a_kernel__arg__number, a_cl__kernelVar) = lm_279(txt, rest, a_kernelArgSets, a_kernel__arg__number, a_cl__kernelVar);
      then (txt, a_kernelArgSets, a_kernel__arg__number, a_cl__kernelVar);
  end match;
end lm_279;

protected function lm_280
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;
  input Tpl.Text in_a_kernelArgSets;
  input Tpl.Text in_a_kernel__arg__number;
  input Tpl.Text in_a_cl__kernelVar;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_kernelArgSets;
  output Tpl.Text out_a_kernel__arg__number;
  output Tpl.Text out_a_cl__kernelVar;
algorithm
  (out_txt, out_a_kernelArgSets, out_a_kernel__arg__number, out_a_cl__kernelVar) :=
  match(in_txt, in_items, in_a_kernelArgSets, in_a_kernel__arg__number, in_a_cl__kernelVar)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      Tpl.Text a_kernelArgSets;
      Tpl.Text a_kernel__arg__number;
      Tpl.Text a_cl__kernelVar;
      SimCodeFunction.Variable i_var;

    case ( txt,
           {},
           a_kernelArgSets,
           a_kernel__arg__number,
           a_cl__kernelVar )
      then (txt, a_kernelArgSets, a_kernel__arg__number, a_cl__kernelVar);

    case ( txt,
           i_var :: rest,
           a_kernelArgSets,
           a_kernel__arg__number,
           a_cl__kernelVar )
      equation
        (txt, a_cl__kernelVar, a_kernel__arg__number, a_kernelArgSets) = setKernelArg_ith(txt, i_var, a_cl__kernelVar, a_kernel__arg__number, a_kernelArgSets);
        (txt, a_kernelArgSets, a_kernel__arg__number, a_cl__kernelVar) = lm_280(txt, rest, a_kernelArgSets, a_kernel__arg__number, a_cl__kernelVar);
      then (txt, a_kernelArgSets, a_kernel__arg__number, a_cl__kernelVar);
  end match;
end lm_280;

protected function fun_281
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_a_outVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_outVars)
    local
      Tpl.Text txt;
      SimCodeFunction.Variable i_var;

    case ( txt,
           i_var :: _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("return "));
        txt = funArgName(txt, i_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("return;"));
      then txt;
  end match;
end fun_281;

protected function fun_282
  input Tpl.Text in_txt;
  input SimCodeFunction.Function in_a_fn;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fn)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> i_functionArguments;
      list<SimCodeFunction.Variable> i_outVars;
      list<SimCodeFunction.Variable> i_variableDeclarations;
      Absyn.Path i_name;
      Tpl.Text l_0___3;
      Tpl.Text l_0___2;
      Tpl.Text l_kernelArgSets;
      Tpl.Text l_kernel__arg__number;
      Tpl.Text l_cl__kernelVar;
      list<SimCodeFunction.Variable> ret_8;
      Tpl.Text l_outVarAssign;
      Tpl.Text l_0___1;
      Tpl.Text l_0__;
      Tpl.Text l_auxFunction;
      Tpl.Text l_varFrees;
      Tpl.Text l_varInits;
      Tpl.Text l_varDecls;
      Tpl.Text l_fname;

    case ( txt,
           SimCodeFunction.KERNEL_FUNCTION(name = i_name, variableDeclarations = i_variableDeclarations, outVars = i_outVars, functionArguments = i_functionArguments) )
      equation
        SimCodeFunctionUtil.codegenResetTryThrowIndex();
        System.tmpTickReset(1);
        System.tmpTickResetIndex(0, 1);
        l_fname = CodegenUtil.underscorePath(Tpl.emptyTxt, i_name);
        l_varDecls = Tpl.emptyTxt;
        l_varInits = Tpl.emptyTxt;
        l_varFrees = Tpl.emptyTxt;
        l_auxFunction = Tpl.emptyTxt;
        l_0__ = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(1, SOME(Tpl.ST_STRING("")), NONE(), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_0__, l_auxFunction, l_varFrees, l_varInits, l_varDecls) = lm_276(l_0__, i_variableDeclarations, l_auxFunction, l_varFrees, l_varInits, l_varDecls);
        l_0__ = Tpl.popIter(l_0__);
        l_0___1 = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(1, SOME(Tpl.ST_STRING("")), NONE(), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_0___1, l_auxFunction, l_varFrees, l_varInits, l_varDecls) = lm_277(l_0___1, i_outVars, l_auxFunction, l_varFrees, l_varInits, l_varDecls);
        l_0___1 = Tpl.popIter(l_0___1);
        ret_8 = List.restOrEmpty(i_outVars);
        l_outVarAssign = lm_278(Tpl.emptyTxt, ret_8);
        (l_cl__kernelVar, l_varDecls) = tempDecl(Tpl.emptyTxt, "cl_kernel", l_varDecls);
        l_kernel__arg__number = Tpl.writeText(Tpl.emptyTxt, l_fname);
        l_kernel__arg__number = Tpl.writeTok(l_kernel__arg__number, Tpl.ST_STRING("_arg_nr"));
        l_kernelArgSets = Tpl.emptyTxt;
        (l_0___2, l_kernelArgSets, l_kernel__arg__number, l_cl__kernelVar) = lm_279(Tpl.emptyTxt, i_functionArguments, l_kernelArgSets, l_kernel__arg__number, l_cl__kernelVar);
        (l_0___3, l_kernelArgSets, l_kernel__arg__number, l_cl__kernelVar) = lm_280(Tpl.emptyTxt, i_outVars, l_kernelArgSets, l_kernel__arg__number, l_cl__kernelVar);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = functionHeaderKernelFunctionInterfacePrototype(txt, Tpl.textString(l_fname), i_functionArguments, i_outVars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "{\n",
                                    "  // declerations\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_varDecls);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("// inits\n"));
        txt = Tpl.writeText(txt, l_varInits);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "/* functionBodyKernelFunctionInterface : "
                                }, false));
        txt = Tpl.writeText(txt, l_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " Kernel creation and execution */\n",
                                    "int "
                                }, false));
        txt = Tpl.writeText(txt, l_kernel__arg__number);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" = 0;\n"));
        txt = Tpl.writeText(txt, l_cl__kernelVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = ocl_create_kernel(omc_ocl_program, \"omc_"));
        txt = Tpl.writeText(txt, l_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("\");\n"));
        txt = Tpl.writeText(txt, l_kernelArgSets);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("ocl_execute_kernel("));
        txt = Tpl.writeText(txt, l_cl__kernelVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ");\n",
                                    "clReleaseKernel("
                                }, false));
        txt = Tpl.writeText(txt, l_cl__kernelVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ");\n",
                                    "/*functionBodyKernelFunctionInterface : "
                                }, false));
        txt = Tpl.writeText(txt, l_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " kernel execution ends here.*/\n",
                                    "\n",
                                    "// outvar assign\n"
                                }, true));
        txt = Tpl.writeText(txt, l_outVarAssign);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "//varfree\n",
                                    "/*\n"
                                }, true));
        txt = Tpl.writeText(txt, l_varFrees);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "*/\n",
                                    "\n",
                                    "// return\n"
                                }, true));
        txt = fun_281(txt, i_outVars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n"
                                }, true));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_282;

public function functionBodyKernelFunctionInterface
  input Tpl.Text txt;
  input SimCodeFunction.Function a_fn;
  input Boolean a_inFunc;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_282(txt, a_fn);
end functionBodyKernelFunctionInterface;

protected function fun_284
  input Tpl.Text in_txt;
  input list<DAE.Dimension> in_a_instDims;
  input Tpl.Text in_a_varName;
  input Tpl.Text in_a_argNr;
  input Tpl.Text in_a_KernelName;
  input Tpl.Text in_a_parVarList;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_parVarList;
algorithm
  (out_txt, out_a_parVarList) :=
  match(in_txt, in_a_instDims, in_a_varName, in_a_argNr, in_a_KernelName, in_a_parVarList)
    local
      Tpl.Text txt;
      Tpl.Text a_varName;
      Tpl.Text a_argNr;
      Tpl.Text a_KernelName;
      Tpl.Text a_parVarList;

    case ( txt,
           {},
           a_varName,
           a_argNr,
           a_KernelName,
           a_parVarList )
      equation
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING("ocl_set_kernel_arg("));
        a_parVarList = Tpl.writeText(a_parVarList, a_KernelName);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING(", "));
        a_parVarList = Tpl.writeText(a_parVarList, a_argNr);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING(", "));
        a_parVarList = Tpl.writeText(a_parVarList, a_varName);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING("); ++"));
        a_parVarList = Tpl.writeText(a_parVarList, a_argNr);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING("; "));
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_NEW_LINE());
      then (txt, a_parVarList);

    case ( txt,
           _,
           a_varName,
           a_argNr,
           a_KernelName,
           a_parVarList )
      equation
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING("ocl_set_kernel_arg("));
        a_parVarList = Tpl.writeText(a_parVarList, a_KernelName);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING(", "));
        a_parVarList = Tpl.writeText(a_parVarList, a_argNr);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING(", "));
        a_parVarList = Tpl.writeText(a_parVarList, a_varName);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING(".data); ++"));
        a_parVarList = Tpl.writeText(a_parVarList, a_argNr);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING("; "));
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_NEW_LINE());
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING("ocl_set_kernel_arg("));
        a_parVarList = Tpl.writeText(a_parVarList, a_KernelName);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING(", "));
        a_parVarList = Tpl.writeText(a_parVarList, a_argNr);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING(", "));
        a_parVarList = Tpl.writeText(a_parVarList, a_varName);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING(".info_dev); ++"));
        a_parVarList = Tpl.writeText(a_parVarList, a_argNr);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING("; "));
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_NEW_LINE());
      then (txt, a_parVarList);
  end match;
end fun_284;

protected function fun_285
  input Tpl.Text in_txt;
  input SimCodeFunction.Variable in_a_var;
  input Tpl.Text in_a_argNr;
  input Tpl.Text in_a_KernelName;
  input Tpl.Text in_a_parVarList;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_parVarList;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_parVarList, out_a_auxFunction) :=
  match(in_txt, in_a_var, in_a_argNr, in_a_KernelName, in_a_parVarList, in_a_auxFunction)
    local
      Tpl.Text txt;
      Tpl.Text a_argNr;
      Tpl.Text a_KernelName;
      Tpl.Text a_parVarList;
      Tpl.Text a_auxFunction;
      list<DAE.Dimension> i_instDims;
      DAE.Type i_var_ty;
      DAE.ComponentRef i_var_name;
      Tpl.Text l_varName;

    case ( txt,
           SimCodeFunction.VARIABLE(ty = DAE.T_ARRAY(ty = _), parallelism = DAE.PARGLOBAL(), name = i_var_name),
           a_argNr,
           a_KernelName,
           a_parVarList,
           a_auxFunction )
      equation
        (l_varName, a_auxFunction) = contextCrefNoPrevExp(Tpl.emptyTxt, i_var_name, SimCodeFunction.contextFunction, a_auxFunction);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING("ocl_set_kernel_arg("));
        a_parVarList = Tpl.writeText(a_parVarList, a_KernelName);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING(", "));
        a_parVarList = Tpl.writeText(a_parVarList, a_argNr);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING(", "));
        a_parVarList = Tpl.writeText(a_parVarList, l_varName);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING(".data); ++"));
        a_parVarList = Tpl.writeText(a_parVarList, a_argNr);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING("; "));
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_NEW_LINE());
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING("ocl_set_kernel_arg("));
        a_parVarList = Tpl.writeText(a_parVarList, a_KernelName);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING(", "));
        a_parVarList = Tpl.writeText(a_parVarList, a_argNr);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING(", "));
        a_parVarList = Tpl.writeText(a_parVarList, l_varName);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING(".info_dev); ++"));
        a_parVarList = Tpl.writeText(a_parVarList, a_argNr);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING("; "));
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_NEW_LINE());
      then (txt, a_parVarList, a_auxFunction);

    case ( txt,
           SimCodeFunction.VARIABLE(ty = (i_var_ty as DAE.T_ARRAY(ty = _)), parallelism = DAE.PARLOCAL(), name = i_var_name),
           a_argNr,
           a_KernelName,
           a_parVarList,
           a_auxFunction )
      equation
        (l_varName, a_auxFunction) = contextCrefNoPrevExp(Tpl.emptyTxt, i_var_name, SimCodeFunction.contextFunction, a_auxFunction);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING("ocl_set_local_kernel_arg("));
        a_parVarList = Tpl.writeText(a_parVarList, a_KernelName);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING(", "));
        a_parVarList = Tpl.writeText(a_parVarList, a_argNr);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING(", sizeof(modelica_"));
        a_parVarList = expTypeShort(a_parVarList, i_var_ty);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING(") * device_array_nr_of_elements(&"));
        a_parVarList = Tpl.writeText(a_parVarList, l_varName);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING(")); ++"));
        a_parVarList = Tpl.writeText(a_parVarList, a_argNr);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING("; "));
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_NEW_LINE());
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING("ocl_set_local_kernel_arg("));
        a_parVarList = Tpl.writeText(a_parVarList, a_KernelName);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING(", "));
        a_parVarList = Tpl.writeText(a_parVarList, a_argNr);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING(", sizeof(modelica_integer) * ("));
        a_parVarList = Tpl.writeText(a_parVarList, l_varName);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING(".info[0]+1)*sizeof(modelica_integer)); ++"));
        a_parVarList = Tpl.writeText(a_parVarList, a_argNr);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING("; "));
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_NEW_LINE());
      then (txt, a_parVarList, a_auxFunction);

    case ( txt,
           SimCodeFunction.VARIABLE(name = i_var_name, instDims = i_instDims),
           a_argNr,
           a_KernelName,
           a_parVarList,
           a_auxFunction )
      equation
        (l_varName, a_auxFunction) = contextCrefNoPrevExp(Tpl.emptyTxt, i_var_name, SimCodeFunction.contextFunction, a_auxFunction);
        (txt, a_parVarList) = fun_284(txt, i_instDims, l_varName, a_argNr, a_KernelName, a_parVarList);
      then (txt, a_parVarList, a_auxFunction);

    case ( txt,
           _,
           _,
           _,
           a_parVarList,
           a_auxFunction )
      then (txt, a_parVarList, a_auxFunction);
  end match;
end fun_285;

public function setKernelArg_ith
  input Tpl.Text txt;
  input SimCodeFunction.Variable a_var;
  input Tpl.Text a_KernelName;
  input Tpl.Text a_argNr;
  input Tpl.Text a_parVarList;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_KernelName;
  output Tpl.Text out_a_argNr;
  output Tpl.Text out_a_parVarList;
protected
  Tpl.Text l_auxFunction;
algorithm
  l_auxFunction := Tpl.emptyTxt;
  (out_txt, out_a_parVarList, l_auxFunction) := fun_285(txt, a_var, a_argNr, a_KernelName, a_parVarList, l_auxFunction);
  out_a_KernelName := a_KernelName;
  out_a_argNr := a_argNr;
end setKernelArg_ith;

protected function fun_287
  input Tpl.Text in_txt;
  input tuple<DAE.ComponentRef, SourceInfo> in_a_tupleVar;
  input Tpl.Text in_a_KernelName;
  input Tpl.Text in_a_argNr;
  input Tpl.Text in_a_parVarList;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_parVarList;
algorithm
  (out_txt, out_a_parVarList) :=
  match(in_txt, in_a_tupleVar, in_a_KernelName, in_a_argNr, in_a_parVarList, in_a_context)
    local
      Tpl.Text txt;
      Tpl.Text a_KernelName;
      Tpl.Text a_argNr;
      Tpl.Text a_parVarList;
      SimCodeFunction.Context a_context;
      DAE.ComponentRef i_cref;
      Tpl.Text l_varName;

    case ( txt,
           ((i_cref as DAE.CREF_IDENT(identType = DAE.T_ARRAY(ty = _))), _),
           a_KernelName,
           a_argNr,
           a_parVarList,
           a_context )
      equation
        l_varName = contextArrayCref(Tpl.emptyTxt, i_cref, a_context);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING("ocl_set_kernel_arg("));
        a_parVarList = Tpl.writeText(a_parVarList, a_KernelName);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING(", "));
        a_parVarList = Tpl.writeText(a_parVarList, a_argNr);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING(", "));
        a_parVarList = Tpl.writeText(a_parVarList, l_varName);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING(".data); ++"));
        a_parVarList = Tpl.writeText(a_parVarList, a_argNr);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING("; "));
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_NEW_LINE());
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING("ocl_set_kernel_arg("));
        a_parVarList = Tpl.writeText(a_parVarList, a_KernelName);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING(", "));
        a_parVarList = Tpl.writeText(a_parVarList, a_argNr);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING(", "));
        a_parVarList = Tpl.writeText(a_parVarList, l_varName);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING(".info_dev); ++"));
        a_parVarList = Tpl.writeText(a_parVarList, a_argNr);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING("; "));
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_NEW_LINE());
      then (txt, a_parVarList);

    case ( txt,
           ((i_cref as DAE.CREF_IDENT(ident = _)), _),
           a_KernelName,
           a_argNr,
           a_parVarList,
           a_context )
      equation
        l_varName = contextArrayCref(Tpl.emptyTxt, i_cref, a_context);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING("ocl_set_kernel_arg("));
        a_parVarList = Tpl.writeText(a_parVarList, a_KernelName);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING(", "));
        a_parVarList = Tpl.writeText(a_parVarList, a_argNr);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING(", "));
        a_parVarList = Tpl.writeText(a_parVarList, l_varName);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING("); ++"));
        a_parVarList = Tpl.writeText(a_parVarList, a_argNr);
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_STRING("; "));
        a_parVarList = Tpl.writeTok(a_parVarList, Tpl.ST_NEW_LINE());
      then (txt, a_parVarList);

    case ( txt,
           _,
           _,
           _,
           a_parVarList,
           _ )
      then (txt, a_parVarList);
  end match;
end fun_287;

public function setKernelArgFormTupleLoopVars_ith
  input Tpl.Text txt;
  input tuple<DAE.ComponentRef, SourceInfo> a_tupleVar;
  input Tpl.Text a_KernelName;
  input Tpl.Text a_argNr;
  input Tpl.Text a_parVarList;
  input SimCodeFunction.Context a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_KernelName;
  output Tpl.Text out_a_argNr;
  output Tpl.Text out_a_parVarList;
algorithm
  (out_txt, out_a_parVarList) := fun_287(txt, a_tupleVar, a_KernelName, a_argNr, a_parVarList, a_context);
  out_a_KernelName := a_KernelName;
  out_a_argNr := a_argNr;
end setKernelArgFormTupleLoopVars_ith;

protected function fun_289
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_a_outVars;
  input Tpl.Text in_a_fname;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_outVars, in_a_fname)
    local
      Tpl.Text txt;
      Tpl.Text a_fname;

    case ( txt,
           {},
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void"));
      then txt;

    case ( txt,
           _,
           a_fname )
      equation
        txt = Tpl.writeText(txt, a_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_rettype"));
      then txt;
  end match;
end fun_289;

protected function lm_290
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varFrees;
  input Tpl.Text in_a_outputAlloc;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varFrees;
  output Tpl.Text out_a_outputAlloc;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varFrees, out_a_outputAlloc, out_a_varDecls) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varFrees, in_a_outputAlloc, in_a_varDecls)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varFrees;
      Tpl.Text a_outputAlloc;
      Tpl.Text a_varDecls;
      SimCodeFunction.Variable i_var;

    case ( txt,
           {},
           a_auxFunction,
           a_varFrees,
           a_outputAlloc,
           a_varDecls )
      then (txt, a_auxFunction, a_varFrees, a_outputAlloc, a_varDecls);

    case ( txt,
           i_var :: rest,
           a_auxFunction,
           a_varFrees,
           a_outputAlloc,
           a_varDecls )
      equation
        (txt, a_varDecls, a_outputAlloc, a_varFrees, a_auxFunction) = varInit(txt, i_var, "", a_varDecls, a_outputAlloc, a_varFrees, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varFrees, a_outputAlloc, a_varDecls) = lm_290(txt, rest, a_auxFunction, a_varFrees, a_outputAlloc, a_varDecls);
      then (txt, a_auxFunction, a_varFrees, a_outputAlloc, a_varDecls);
  end match;
end lm_290;

protected function lm_291
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      SimCodeFunction.Variable i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = varOutput(txt, i_var);
        txt = lm_291(txt, rest);
      then txt;
  end match;
end lm_291;

protected function fun_292
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_a_outVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_outVars)
    local
      Tpl.Text txt;
      SimCodeFunction.Variable i_v;

    case ( txt,
           i_v :: _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("return "));
        txt = funArgName(txt, i_v);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("return;"));
      then txt;
  end match;
end fun_292;

protected function fun_293
  input Tpl.Text in_txt;
  input Boolean in_a_dynamicLoad;
  input String in_a_language;
  input String in_a_extName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_dynamicLoad, in_a_language, in_a_extName)
    local
      Tpl.Text txt;
      String a_language;
      String a_extName;

    case ( txt,
           false,
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_language,
           a_extName )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("ptrT_"));
        txt = extFunctionName(txt, a_extName, a_language);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" ptr_"));
        txt = extFunctionName(txt, a_extName, a_language);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("=NULL;"));
      then txt;
  end match;
end fun_293;

protected function fun_294
  input Tpl.Text in_txt;
  input Boolean in_a_inFunc;
  input list<SimCodeFunction.Variable> in_a_outVars;
  input list<SimCodeFunction.Variable> in_a_funArgs;
  input Tpl.Text in_a_fname;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_fname;
algorithm
  (out_txt, out_a_fname) :=
  match(in_txt, in_a_inFunc, in_a_outVars, in_a_funArgs, in_a_fname)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> a_outVars;
      list<SimCodeFunction.Variable> a_funArgs;
      Tpl.Text a_fname;

    case ( txt,
           false,
           _,
           _,
           a_fname )
      then (txt, a_fname);

    case ( txt,
           _,
           a_outVars,
           a_funArgs,
           a_fname )
      equation
        (txt, a_fname) = generateInFunc(txt, a_fname, a_funArgs, a_outVars);
      then (txt, a_fname);
  end match;
end fun_294;

public function functionBodyExternalFunction
  input Tpl.Text in_txt;
  input SimCodeFunction.Function in_a_fn;
  input Boolean in_a_inFunc;
  input Boolean in_a_isSimulation;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fn, in_a_inFunc, in_a_isSimulation)
    local
      Tpl.Text txt;
      Boolean a_inFunc;
      Boolean a_isSimulation;
      String i_language;
      String i_extName;
      Boolean i_dynamicLoad;
      SourceInfo i_info;
      SCode.Visibility i_visibility;
      list<SimCodeFunction.Variable> i_funArgs;
      SimCodeFunction.Function i_efn;
      list<SimCodeFunction.Variable> i_outVars;
      Absyn.Path i_name;
      Tpl.Text l_fnBody;
      Tpl.Text l_prototype;
      Tpl.Text l_afterBody;
      Tpl.Text l_boxedFn;
      list<SimCodeFunction.Variable> ret_10;
      Tpl.Text l_outVarAssign;
      Tpl.Text l_0__;
      Tpl.Text l_callPart;
      Tpl.Text l_auxFunction;
      Tpl.Text l_outputAlloc;
      Tpl.Text l_varFrees;
      Tpl.Text l_varDecls;
      Tpl.Text l_preExp;
      Tpl.Text l_retType;
      Tpl.Text l_fname;

    case ( txt,
           (i_efn as SimCodeFunction.EXTERNAL_FUNCTION(name = i_name, outVars = i_outVars, funArgs = i_funArgs, visibility = i_visibility, info = i_info, dynamicLoad = i_dynamicLoad, extName = i_extName, language = i_language)),
           a_inFunc,
           a_isSimulation )
      equation
        System.tmpTickReset(1);
        System.tmpTickResetIndex(0, 1);
        l_fname = CodegenUtil.underscorePath(Tpl.emptyTxt, i_name);
        l_retType = fun_289(Tpl.emptyTxt, i_outVars, l_fname);
        l_preExp = Tpl.emptyTxt;
        l_varDecls = Tpl.emptyTxt;
        l_varFrees = Tpl.emptyTxt;
        l_outputAlloc = Tpl.emptyTxt;
        l_auxFunction = Tpl.emptyTxt;
        (l_callPart, l_preExp, l_varDecls, l_outputAlloc, l_auxFunction) = extFunCall(Tpl.emptyTxt, i_efn, l_preExp, l_varDecls, l_outputAlloc, l_auxFunction);
        l_0__ = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), NONE(), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_0__, l_auxFunction, l_varFrees, l_outputAlloc, l_varDecls) = lm_290(l_0__, i_outVars, l_auxFunction, l_varFrees, l_outputAlloc, l_varDecls);
        l_0__ = Tpl.popIter(l_0__);
        ret_10 = List.restOrEmpty(i_outVars);
        l_outVarAssign = lm_291(Tpl.emptyTxt, ret_10);
        l_varDecls = addRootsTempArray(l_varDecls);
        l_boxedFn = functionBodyBoxed(Tpl.emptyTxt, i_efn, a_isSimulation);
        l_afterBody = Tpl.emptyTxt;
        (l_prototype, l_afterBody) = functionPrototype(Tpl.emptyTxt, Tpl.textString(l_fname), i_funArgs, i_outVars, false, i_visibility, a_isSimulation, false, l_afterBody);
        l_fnBody = Tpl.writeText(Tpl.emptyTxt, l_auxFunction);
        l_fnBody = Tpl.softNewLine(l_fnBody);
        l_fnBody = Tpl.writeText(l_fnBody, l_prototype);
        l_fnBody = Tpl.softNewLine(l_fnBody);
        l_fnBody = Tpl.writeTok(l_fnBody, Tpl.ST_LINE("{\n"));
        l_fnBody = Tpl.pushBlock(l_fnBody, Tpl.BT_INDENT(2));
        l_fnBody = Tpl.writeText(l_fnBody, l_varDecls);
        l_fnBody = Tpl.softNewLine(l_fnBody);
        l_fnBody = modelicaLine(l_fnBody, i_info);
        l_fnBody = Tpl.softNewLine(l_fnBody);
        l_fnBody = Tpl.writeText(l_fnBody, l_outputAlloc);
        l_fnBody = Tpl.softNewLine(l_fnBody);
        l_fnBody = Tpl.writeText(l_fnBody, l_preExp);
        l_fnBody = Tpl.softNewLine(l_fnBody);
        l_fnBody = Tpl.writeText(l_fnBody, l_callPart);
        l_fnBody = Tpl.softNewLine(l_fnBody);
        l_fnBody = Tpl.writeText(l_fnBody, l_outVarAssign);
        l_fnBody = Tpl.softNewLine(l_fnBody);
        l_fnBody = fun_292(l_fnBody, i_outVars);
        l_fnBody = Tpl.softNewLine(l_fnBody);
        l_fnBody = Tpl.popBlock(l_fnBody);
        l_fnBody = Tpl.writeTok(l_fnBody, Tpl.ST_LINE("}\n"));
        l_fnBody = Tpl.writeText(l_fnBody, l_afterBody);
        txt = fun_293(txt, i_dynamicLoad, i_language, i_extName);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_fnBody);
        txt = Tpl.softNewLine(txt);
        (txt, l_fname) = fun_294(txt, a_inFunc, i_outVars, i_funArgs, l_fname);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_boxedFn);
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end functionBodyExternalFunction;

protected function lm_296
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varInits;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_structVar;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varInits;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varInits, out_a_varDecls) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varInits, in_a_varDecls, in_a_structVar)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varInits;
      Tpl.Text a_varDecls;
      Tpl.Text a_structVar;
      SimCodeFunction.Variable i_var;

    case ( txt,
           {},
           a_auxFunction,
           a_varInits,
           a_varDecls,
           _ )
      then (txt, a_auxFunction, a_varInits, a_varDecls);

    case ( txt,
           i_var :: rest,
           a_auxFunction,
           a_varInits,
           a_varDecls,
           a_structVar )
      equation
        (txt, a_varDecls, a_varInits, a_auxFunction) = varInitRecord(txt, i_var, Tpl.textString(a_structVar), a_varDecls, a_varInits, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varInits, a_varDecls) = lm_296(txt, rest, a_auxFunction, a_varInits, a_varDecls, a_structVar);
      then (txt, a_auxFunction, a_varInits, a_varDecls);
  end match;
end lm_296;

protected function fun_297
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("impl"));
      then txt;
  end match;
end fun_297;

protected function lm_298
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      DAE.ComponentRef i_name;
      DAE.Type i_ty;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           SimCodeFunction.VARIABLE(ty = i_ty, name = i_name) :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = expTypeArrayIf(txt, i_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" omc_"));
        txt = CodegenUtil.crefStr(txt, i_name);
        txt = lm_298(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_298(txt, rest);
      then txt;
  end match;
end lm_298;

protected function lm_299
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;
  input Tpl.Text in_a_structVar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_structVar)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      Tpl.Text a_structVar;
      DAE.ComponentRef i_name;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           SimCodeFunction.VARIABLE(name = i_name) :: rest,
           a_structVar )
      equation
        txt = Tpl.writeText(txt, a_structVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("._"));
        txt = CodegenUtil.crefStr(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = omc_"));
        txt = CodegenUtil.crefStr(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        txt = lm_299(txt, rest, a_structVar);
      then txt;

    case ( txt,
           _ :: rest,
           a_structVar )
      equation
        txt = lm_299(txt, rest, a_structVar);
      then txt;
  end match;
end lm_299;

protected function fun_300
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_fname;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_fname)
    local
      Tpl.Text txt;
      Tpl.Text a_fname;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_fname )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("omctd_"));
        txt = Tpl.writeText(txt, a_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" omc_"));
        txt = Tpl.writeText(txt, a_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = omcimpl_"));
        txt = Tpl.writeText(txt, a_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_300;

public function functionBodyRecordConstructor
  input Tpl.Text in_txt;
  input SimCodeFunction.Function in_a_fn;
  input Boolean in_a_isSimulation;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fn, in_a_isSimulation)
    local
      Tpl.Text txt;
      Boolean a_isSimulation;
      list<SimCodeFunction.Variable> i_funArgs;
      SimCodeFunction.Function i_fn;
      list<SimCodeFunction.Variable> i_locals;
      Absyn.Path i_name;
      Boolean ret_10;
      Boolean ret_9;
      Tpl.Text l_boxedFn;
      Tpl.Text l_0__;
      Tpl.Text l_structVar;
      Tpl.Text l_structType;
      Tpl.Text l_fname;
      Tpl.Text l_auxFunction;
      Tpl.Text l_varFrees;
      Tpl.Text l_varInits;
      Tpl.Text l_varDecls;

    case ( txt,
           (i_fn as SimCodeFunction.RECORD_CONSTRUCTOR(name = i_name, locals = i_locals, funArgs = i_funArgs)),
           a_isSimulation )
      equation
        System.tmpTickReset(1);
        l_varDecls = Tpl.emptyTxt;
        l_varInits = Tpl.emptyTxt;
        l_varFrees = Tpl.emptyTxt;
        l_auxFunction = Tpl.emptyTxt;
        l_fname = CodegenUtil.underscorePath(Tpl.emptyTxt, i_name);
        l_structType = Tpl.writeText(Tpl.emptyTxt, l_fname);
        (l_structVar, l_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(l_structType), l_varDecls);
        l_0__ = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), NONE(), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_0__, l_auxFunction, l_varInits, l_varDecls) = lm_296(l_0__, i_locals, l_auxFunction, l_varInits, l_varDecls, l_structVar);
        l_0__ = Tpl.popIter(l_0__);
        l_boxedFn = functionBodyBoxed(Tpl.emptyTxt, i_fn, a_isSimulation);
        txt = Tpl.writeText(txt, l_auxFunction);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" omc"));
        ret_9 = Flags.isSet(Flags.OMC_RELOCATABLE_FUNCTIONS);
        txt = fun_297(txt, ret_9);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeText(txt, l_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(threadData_t *threadData"));
        txt = lm_298(txt, i_funArgs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ")\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_varDecls);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_varInits);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_299(txt, i_funArgs, l_structVar);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("return "));
        txt = Tpl.writeText(txt, l_structVar);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("}\n"));
        ret_10 = Flags.isSet(Flags.OMC_RELOCATABLE_FUNCTIONS);
        txt = fun_300(txt, ret_10, l_fname);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_boxedFn);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end functionBodyRecordConstructor;

protected function lm_302
  input Tpl.Text in_txt;
  input list<DAE.Dimension> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_varInits;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varInits;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_varInits) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_varInits)
    local
      Tpl.Text txt;
      list<DAE.Dimension> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_varInits;
      DAE.Dimension i_dim;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_varInits )
      then (txt, a_auxFunction, a_varDecls, a_varInits);

    case ( txt,
           i_dim :: rest,
           a_auxFunction,
           a_varDecls,
           a_varInits )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(_index_t)"));
        (txt, a_varInits, a_varDecls, a_auxFunction) = dimension(txt, i_dim, SimCodeFunction.contextFunction, a_varInits, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_varInits) = lm_302(txt, rest, a_auxFunction, a_varDecls, a_varInits);
      then (txt, a_auxFunction, a_varDecls, a_varInits);
  end match;
end lm_302;

protected function fun_303
  input Tpl.Text in_txt;
  input Option<DAE.Exp> in_a_var_value;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_varInits;
  input Tpl.Text in_a_varName;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varInits;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_varInits) :=
  match(in_txt, in_a_var_value, in_a_auxFunction, in_a_varDecls, in_a_varInits, in_a_varName)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_varInits;
      Tpl.Text a_varName;
      DAE.Exp i_exp;
      Tpl.Text l_defaultValue;

    case ( txt,
           SOME(i_exp),
           a_auxFunction,
           a_varDecls,
           a_varInits,
           a_varName )
      equation
        l_defaultValue = Tpl.writeText(Tpl.emptyTxt, a_varName);
        l_defaultValue = Tpl.writeTok(l_defaultValue, Tpl.ST_STRING(" = "));
        (l_defaultValue, a_varInits, a_varDecls, a_auxFunction) = daeExp(l_defaultValue, i_exp, SimCodeFunction.contextFunction, a_varInits, a_varDecls, a_auxFunction);
        l_defaultValue = Tpl.writeTok(l_defaultValue, Tpl.ST_STRING(";"));
        l_defaultValue = Tpl.writeTok(l_defaultValue, Tpl.ST_NEW_LINE());
        a_varInits = Tpl.writeText(a_varInits, l_defaultValue);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
      then (txt, a_auxFunction, a_varDecls, a_varInits);

    case ( txt,
           _,
           a_auxFunction,
           a_varDecls,
           a_varInits,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_varInits);
  end match;
end fun_303;

protected function fun_304
  input Tpl.Text in_txt;
  input list<DAE.Dimension> in_a_instDims;
  input SimCodeFunction.Variable in_a_var;
  input Tpl.Text in_a_instDimsInit;
  input DAE.Type in_a_var_ty;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_varInits;
  input Tpl.Text in_a_varName;
  input Option<DAE.Exp> in_a_var_value;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varInits;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_varInits) :=
  match(in_txt, in_a_instDims, in_a_var, in_a_instDimsInit, in_a_var_ty, in_a_auxFunction, in_a_varDecls, in_a_varInits, in_a_varName, in_a_var_value)
    local
      Tpl.Text txt;
      SimCodeFunction.Variable a_var;
      Tpl.Text a_instDimsInit;
      DAE.Type a_var_ty;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_varInits;
      Tpl.Text a_varName;
      Option<DAE.Exp> a_var_value;
      list<DAE.Dimension> i_instDims;
      Tpl.Text l_defaultValue;
      Integer ret_1;
      Tpl.Text l_defaultAlloc;

    case ( txt,
           {},
           _,
           _,
           _,
           a_auxFunction,
           a_varDecls,
           a_varInits,
           a_varName,
           a_var_value )
      equation
        (txt, a_auxFunction, a_varDecls, a_varInits) = fun_303(txt, a_var_value, a_auxFunction, a_varDecls, a_varInits, a_varName);
      then (txt, a_auxFunction, a_varDecls, a_varInits);

    case ( txt,
           i_instDims,
           a_var,
           a_instDimsInit,
           a_var_ty,
           a_auxFunction,
           a_varDecls,
           a_varInits,
           a_varName,
           _ )
      equation
        l_defaultAlloc = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("alloc_"));
        l_defaultAlloc = expTypeShort(l_defaultAlloc, a_var_ty);
        l_defaultAlloc = Tpl.writeTok(l_defaultAlloc, Tpl.ST_STRING("_array(&"));
        l_defaultAlloc = Tpl.writeText(l_defaultAlloc, a_varName);
        l_defaultAlloc = Tpl.writeTok(l_defaultAlloc, Tpl.ST_STRING(", "));
        ret_1 = listLength(i_instDims);
        l_defaultAlloc = Tpl.writeStr(l_defaultAlloc, intString(ret_1));
        l_defaultAlloc = Tpl.writeTok(l_defaultAlloc, Tpl.ST_STRING(", "));
        l_defaultAlloc = Tpl.writeText(l_defaultAlloc, a_instDimsInit);
        l_defaultAlloc = Tpl.writeTok(l_defaultAlloc, Tpl.ST_STRING(");"));
        l_defaultAlloc = Tpl.writeTok(l_defaultAlloc, Tpl.ST_NEW_LINE());
        (l_defaultValue, l_defaultAlloc, a_varDecls, a_varInits, a_auxFunction) = varAllocDefaultValue(Tpl.emptyTxt, a_var, "", Tpl.textString(a_varName), l_defaultAlloc, a_varDecls, a_varInits, a_auxFunction);
        a_varInits = Tpl.writeText(a_varInits, l_defaultValue);
      then (txt, a_auxFunction, a_varDecls, a_varInits);
  end match;
end fun_304;

public function varInitRecord
  input Tpl.Text in_txt;
  input SimCodeFunction.Variable in_a_var;
  input String in_a_prefix;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_varInits;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varInits;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_varInits, out_a_auxFunction) :=
  match(in_txt, in_a_var, in_a_prefix, in_a_varDecls, in_a_varInits, in_a_auxFunction)
    local
      Tpl.Text txt;
      String a_prefix;
      Tpl.Text a_varDecls;
      Tpl.Text a_varInits;
      Tpl.Text a_auxFunction;
      DAE.Type i_var_ty;
      Option<DAE.Exp> i_var_value;
      list<DAE.Dimension> i_instDims;
      SimCodeFunction.Variable i_var;
      DAE.ComponentRef i_var_name;
      Tpl.Text l_instDimsInit;
      Tpl.Text l_initRecords;
      Tpl.Text l_varName;

    case ( txt,
           (i_var as SimCodeFunction.VARIABLE(parallelism = DAE.NON_PARALLEL(), name = i_var_name, instDims = i_instDims, value = i_var_value, ty = i_var_ty)),
           a_prefix,
           a_varDecls,
           a_varInits,
           a_auxFunction )
      equation
        l_varName = Tpl.writeStr(Tpl.emptyTxt, a_prefix);
        l_varName = Tpl.writeTok(l_varName, Tpl.ST_STRING("._"));
        l_varName = CodegenUtil.crefStr(l_varName, i_var_name);
        (l_initRecords, a_varDecls, a_varInits, a_auxFunction) = initRecordMembers(Tpl.emptyTxt, i_var, a_varDecls, a_varInits, a_auxFunction);
        a_varInits = Tpl.writeText(a_varInits, l_initRecords);
        l_instDimsInit = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_instDimsInit, a_auxFunction, a_varDecls, a_varInits) = lm_302(l_instDimsInit, i_instDims, a_auxFunction, a_varDecls, a_varInits);
        l_instDimsInit = Tpl.popIter(l_instDimsInit);
        (txt, a_auxFunction, a_varDecls, a_varInits) = fun_304(txt, i_instDims, i_var, l_instDimsInit, i_var_ty, a_auxFunction, a_varDecls, a_varInits, l_varName, i_var_value);
      then (txt, a_varDecls, a_varInits, a_auxFunction);

    case ( txt,
           SimCodeFunction.FUNCTION_PTR(name = _),
           _,
           a_varDecls,
           a_varInits,
           a_auxFunction )
      then (txt, a_varDecls, a_varInits, a_auxFunction);

    case ( txt,
           _,
           _,
           a_varDecls,
           a_varInits,
           a_auxFunction )
      equation
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 1806, 12), "Unknown local variable type in record");
      then (txt, a_varDecls, a_varInits, a_auxFunction);
  end match;
end varInitRecord;

protected function fun_306
  input Tpl.Text in_txt;
  input SimCodeFunction.Function in_a_fn;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fn)
    local
      Tpl.Text txt;
      Absyn.Path i_name;

    case ( txt,
           SimCodeFunction.FUNCTION(name = i_name) )
      equation
        txt = CodegenUtil.underscorePath(txt, i_name);
      then txt;

    case ( txt,
           SimCodeFunction.EXTERNAL_FUNCTION(name = i_name) )
      equation
        txt = CodegenUtil.underscorePath(txt, i_name);
      then txt;

    case ( txt,
           SimCodeFunction.RECORD_CONSTRUCTOR(name = i_name) )
      equation
        txt = CodegenUtil.underscorePath(txt, i_name);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_306;

protected function fun_307
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Boolean in_a_isSimulation;
  input SCode.Visibility in_a_visibility;
  input list<SimCodeFunction.Variable> in_a_outVars;
  input list<SimCodeFunction.Variable> in_a_functionArguments;
  input Absyn.Path in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_isSimulation, in_a_visibility, in_a_outVars, in_a_functionArguments, in_a_name)
    local
      Tpl.Text txt;
      Boolean a_isSimulation;
      SCode.Visibility a_visibility;
      list<SimCodeFunction.Variable> a_outVars;
      list<SimCodeFunction.Variable> a_functionArguments;
      Absyn.Path a_name;

    case ( txt,
           false,
           a_isSimulation,
           a_visibility,
           a_outVars,
           a_functionArguments,
           a_name )
      equation
        txt = functionBodyBoxedImpl(txt, a_name, a_functionArguments, a_outVars, a_visibility, a_isSimulation);
      then txt;

    case ( txt,
           _,
           _,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_307;

protected function fun_308
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Boolean in_a_isSimulation;
  input SCode.Visibility in_a_visibility;
  input list<SimCodeFunction.Variable> in_a_outVars;
  input list<SimCodeFunction.Variable> in_a_funArgs;
  input Absyn.Path in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_isSimulation, in_a_visibility, in_a_outVars, in_a_funArgs, in_a_name)
    local
      Tpl.Text txt;
      Boolean a_isSimulation;
      SCode.Visibility a_visibility;
      list<SimCodeFunction.Variable> a_outVars;
      list<SimCodeFunction.Variable> a_funArgs;
      Absyn.Path a_name;

    case ( txt,
           false,
           a_isSimulation,
           a_visibility,
           a_outVars,
           a_funArgs,
           a_name )
      equation
        txt = functionBodyBoxedImpl(txt, a_name, a_funArgs, a_outVars, a_visibility, a_isSimulation);
      then txt;

    case ( txt,
           _,
           _,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_308;

protected function fun_309
  input Tpl.Text in_txt;
  input SimCodeFunction.Function in_a_fn;
  input Boolean in_a_isSimulation;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fn, in_a_isSimulation)
    local
      Tpl.Text txt;
      Boolean a_isSimulation;
      list<SimCodeFunction.Variable> i_funArgs;
      SCode.Visibility i_visibility;
      list<SimCodeFunction.Variable> i_outVars;
      list<SimCodeFunction.Variable> i_functionArguments;
      Absyn.Path i_name;
      SimCodeFunction.Function i_fn;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           (i_fn as SimCodeFunction.FUNCTION(name = i_name, functionArguments = i_functionArguments, outVars = i_outVars, visibility = i_visibility)),
           a_isSimulation )
      equation
        ret_0 = SimCodeFunctionUtil.isBoxedFunction(i_fn);
        txt = fun_307(txt, ret_0, a_isSimulation, i_visibility, i_outVars, i_functionArguments, i_name);
      then txt;

    case ( txt,
           (i_fn as SimCodeFunction.EXTERNAL_FUNCTION(name = i_name, funArgs = i_funArgs, outVars = i_outVars, visibility = i_visibility)),
           a_isSimulation )
      equation
        ret_1 = SimCodeFunctionUtil.isBoxedFunction(i_fn);
        txt = fun_308(txt, ret_1, a_isSimulation, i_visibility, i_outVars, i_funArgs, i_name);
      then txt;

    case ( txt,
           (i_fn as SimCodeFunction.RECORD_CONSTRUCTOR(name = _)),
           a_isSimulation )
      equation
        txt = boxRecordConstructor(txt, i_fn, a_isSimulation);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_309;

public function functionBodyBoxed
  input Tpl.Text txt;
  input SimCodeFunction.Function a_fn;
  input Boolean a_isSimulation;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_fname;
algorithm
  l_fname := fun_306(Tpl.emptyTxt, a_fn);
  out_txt := fun_309(txt, a_fn, a_isSimulation);
end functionBodyBoxed;

protected function fun_311
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_a_outvars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_outvars)
    local
      Tpl.Text txt;

    case ( txt,
           {} )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_metatype"));
      then txt;
  end match;
end fun_311;

protected function lm_312
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varBox;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varBox;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varBox, out_a_varDecls) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varBox, in_a_varDecls)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varBox;
      Tpl.Text a_varDecls;
      SimCodeFunction.Variable i_arg;

    case ( txt,
           {},
           a_auxFunction,
           a_varBox,
           a_varDecls )
      then (txt, a_auxFunction, a_varBox, a_varDecls);

    case ( txt,
           i_arg :: rest,
           a_auxFunction,
           a_varBox,
           a_varDecls )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        (txt, a_varDecls, a_varBox, a_auxFunction) = funArgUnbox(txt, i_arg, a_varDecls, a_varBox, a_auxFunction);
        (txt, a_auxFunction, a_varBox, a_varDecls) = lm_312(txt, rest, a_auxFunction, a_varBox, a_varDecls);
      then (txt, a_auxFunction, a_varBox, a_varDecls);
  end match;
end lm_312;

protected function fun_313
  input Tpl.Text in_txt;
  input Tpl.Text in_mArg;
  input Tpl.Text in_a_auxFunctionIgnore;
  input Tpl.Text in_a_varFreesIgnore;
  input Tpl.Text in_a_outputAllocIgnore;
  input Tpl.Text in_a_varDecls;
  input SimCodeFunction.Variable in_a_var;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunctionIgnore;
  output Tpl.Text out_a_varFreesIgnore;
  output Tpl.Text out_a_outputAllocIgnore;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunctionIgnore, out_a_varFreesIgnore, out_a_outputAllocIgnore, out_a_varDecls) :=
  match(in_txt, in_mArg, in_a_auxFunctionIgnore, in_a_varFreesIgnore, in_a_outputAllocIgnore, in_a_varDecls, in_a_var)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunctionIgnore;
      Tpl.Text a_varFreesIgnore;
      Tpl.Text a_outputAllocIgnore;
      Tpl.Text a_varDecls;
      SimCodeFunction.Variable a_var;
      Tpl.Text l_0__;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           a_auxFunctionIgnore,
           a_varFreesIgnore,
           a_outputAllocIgnore,
           a_varDecls,
           a_var )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", out"));
        txt = funArgName(txt, a_var);
      then (txt, a_auxFunctionIgnore, a_varFreesIgnore, a_outputAllocIgnore, a_varDecls);

    case ( txt,
           _,
           a_auxFunctionIgnore,
           a_varFreesIgnore,
           a_outputAllocIgnore,
           a_varDecls,
           a_var )
      equation
        (l_0__, a_varDecls, a_outputAllocIgnore, a_varFreesIgnore, a_auxFunctionIgnore) = varInit(Tpl.emptyTxt, a_var, "", a_varDecls, a_outputAllocIgnore, a_varFreesIgnore, a_auxFunctionIgnore);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", &"));
        txt = funArgName(txt, a_var);
      then (txt, a_auxFunctionIgnore, a_varFreesIgnore, a_outputAllocIgnore, a_varDecls);
  end match;
end fun_313;

protected function fun_314
  input Tpl.Text in_txt;
  input SimCodeFunction.Variable in_a_var;
  input Tpl.Text in_a_auxFunctionIgnore;
  input Tpl.Text in_a_varFreesIgnore;
  input Tpl.Text in_a_outputAllocIgnore;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunctionIgnore;
  output Tpl.Text out_a_varFreesIgnore;
  output Tpl.Text out_a_outputAllocIgnore;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunctionIgnore, out_a_varFreesIgnore, out_a_outputAllocIgnore, out_a_varDecls) :=
  match(in_txt, in_a_var, in_a_auxFunctionIgnore, in_a_varFreesIgnore, in_a_outputAllocIgnore, in_a_varDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunctionIgnore;
      Tpl.Text a_varFreesIgnore;
      Tpl.Text a_outputAllocIgnore;
      Tpl.Text a_varDecls;
      SimCodeFunction.Variable i_var;
      SimCodeFunction.Variable i_v;
      list<DAE.Dimension> i_v_instDims;
      DAE.Type i_v_ty;
      Tpl.Text txt_1;
      DAE.Type ret_0;

    case ( txt,
           (i_v as SimCodeFunction.VARIABLE(ty = i_v_ty, instDims = i_v_instDims)),
           a_auxFunctionIgnore,
           a_varFreesIgnore,
           a_outputAllocIgnore,
           a_varDecls )
      equation
        ret_0 = Types.liftTypeWithDims(i_v_ty, i_v_instDims);
        txt_1 = mmcConstructorType(Tpl.emptyTxt, ret_0);
        (txt, a_auxFunctionIgnore, a_varFreesIgnore, a_outputAllocIgnore, a_varDecls) = fun_313(txt, txt_1, a_auxFunctionIgnore, a_varFreesIgnore, a_outputAllocIgnore, a_varDecls, i_v);
      then (txt, a_auxFunctionIgnore, a_varFreesIgnore, a_outputAllocIgnore, a_varDecls);

    case ( txt,
           (i_var as SimCodeFunction.FUNCTION_PTR(name = _)),
           a_auxFunctionIgnore,
           a_varFreesIgnore,
           a_outputAllocIgnore,
           a_varDecls )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", out"));
        txt = funArgName(txt, i_var);
      then (txt, a_auxFunctionIgnore, a_varFreesIgnore, a_outputAllocIgnore, a_varDecls);

    case ( txt,
           _,
           a_auxFunctionIgnore,
           a_varFreesIgnore,
           a_outputAllocIgnore,
           a_varDecls )
      then (txt, a_auxFunctionIgnore, a_varFreesIgnore, a_outputAllocIgnore, a_varDecls);
  end match;
end fun_314;

protected function lm_315
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;
  input Tpl.Text in_a_auxFunctionIgnore;
  input Tpl.Text in_a_varFreesIgnore;
  input Tpl.Text in_a_outputAllocIgnore;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunctionIgnore;
  output Tpl.Text out_a_varFreesIgnore;
  output Tpl.Text out_a_outputAllocIgnore;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunctionIgnore, out_a_varFreesIgnore, out_a_outputAllocIgnore, out_a_varDecls) :=
  match(in_txt, in_items, in_a_auxFunctionIgnore, in_a_varFreesIgnore, in_a_outputAllocIgnore, in_a_varDecls)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      Tpl.Text a_auxFunctionIgnore;
      Tpl.Text a_varFreesIgnore;
      Tpl.Text a_outputAllocIgnore;
      Tpl.Text a_varDecls;
      SimCodeFunction.Variable i_var;

    case ( txt,
           {},
           a_auxFunctionIgnore,
           a_varFreesIgnore,
           a_outputAllocIgnore,
           a_varDecls )
      then (txt, a_auxFunctionIgnore, a_varFreesIgnore, a_outputAllocIgnore, a_varDecls);

    case ( txt,
           i_var :: rest,
           a_auxFunctionIgnore,
           a_varFreesIgnore,
           a_outputAllocIgnore,
           a_varDecls )
      equation
        (txt, a_auxFunctionIgnore, a_varFreesIgnore, a_outputAllocIgnore, a_varDecls) = fun_314(txt, i_var, a_auxFunctionIgnore, a_varFreesIgnore, a_outputAllocIgnore, a_varDecls);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunctionIgnore, a_varFreesIgnore, a_outputAllocIgnore, a_varDecls) = lm_315(txt, rest, a_auxFunctionIgnore, a_varFreesIgnore, a_outputAllocIgnore, a_varDecls);
      then (txt, a_auxFunctionIgnore, a_varFreesIgnore, a_outputAllocIgnore, a_varDecls);
  end match;
end lm_315;

protected function fun_316
  input Tpl.Text in_txt;
  input Tpl.Text in_mArg;
  input Tpl.Text in_a_out;
  input Tpl.Text in_a_varDecls;
  input SimCodeFunction.Variable in_a_v;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_varDecls) :=
  match(in_txt, in_mArg, in_a_out, in_a_varDecls, in_a_v)
    local
      Tpl.Text txt;
      Tpl.Text a_out;
      Tpl.Text a_varDecls;
      SimCodeFunction.Variable a_v;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           _,
           a_varDecls,
           a_v )
      equation
        txt = funArgName(txt, a_v);
      then (txt, a_varDecls);

    case ( txt,
           _,
           a_out,
           a_varDecls,
           _ )
      equation
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING("modelica_metatype "));
        a_varDecls = Tpl.writeText(a_varDecls, a_out);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(";"));
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_out);
      then (txt, a_varDecls);
  end match;
end fun_316;

protected function fun_317
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_a_outvars;
  input Tpl.Text in_a_varUnbox;
  input Tpl.Text in_a_auxFunctionIgnore;
  input Tpl.Text in_a_varFreesIgnore;
  input Tpl.Text in_a_outputAllocIgnore;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varUnbox;
  output Tpl.Text out_a_auxFunctionIgnore;
  output Tpl.Text out_a_varFreesIgnore;
  output Tpl.Text out_a_outputAllocIgnore;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_varUnbox, out_a_auxFunctionIgnore, out_a_varFreesIgnore, out_a_outputAllocIgnore, out_a_varDecls) :=
  match(in_txt, in_a_outvars, in_a_varUnbox, in_a_auxFunctionIgnore, in_a_varFreesIgnore, in_a_outputAllocIgnore, in_a_varDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_varUnbox;
      Tpl.Text a_auxFunctionIgnore;
      Tpl.Text a_varFreesIgnore;
      Tpl.Text a_outputAllocIgnore;
      Tpl.Text a_varDecls;
      list<DAE.Dimension> i_v_instDims;
      DAE.Type i_v_ty;
      SimCodeFunction.Variable i_v;
      Tpl.Text txt_6;
      DAE.Type ret_5;
      DAE.Type ret_4;
      Tpl.Text txt_3;
      Tpl.Text l_0___1;
      Tpl.Text l_out;
      Tpl.Text l_0__;

    case ( txt,
           {},
           a_varUnbox,
           a_auxFunctionIgnore,
           a_varFreesIgnore,
           a_outputAllocIgnore,
           a_varDecls )
      then (txt, a_varUnbox, a_auxFunctionIgnore, a_varFreesIgnore, a_outputAllocIgnore, a_varDecls);

    case ( txt,
           (i_v as SimCodeFunction.VARIABLE(ty = i_v_ty, instDims = i_v_instDims)) :: _,
           a_varUnbox,
           a_auxFunctionIgnore,
           a_varFreesIgnore,
           a_outputAllocIgnore,
           a_varDecls )
      equation
        (l_0__, a_varDecls, a_outputAllocIgnore, a_varFreesIgnore, a_auxFunctionIgnore) = varInit(Tpl.emptyTxt, i_v, "", a_varDecls, a_outputAllocIgnore, a_varFreesIgnore, a_auxFunctionIgnore);
        l_out = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("out"));
        l_out = funArgName(l_out, i_v);
        txt_3 = funArgName(Tpl.emptyTxt, i_v);
        ret_4 = Types.liftTypeWithDims(i_v_ty, i_v_instDims);
        (l_0___1, a_varUnbox, a_varDecls) = funArgBox(Tpl.emptyTxt, Tpl.textString(l_out), Tpl.textString(txt_3), "", ret_4, a_varUnbox, a_varDecls);
        ret_5 = Types.liftTypeWithDims(i_v_ty, i_v_instDims);
        txt_6 = mmcConstructorType(Tpl.emptyTxt, ret_5);
        (txt, a_varDecls) = fun_316(txt, txt_6, l_out, a_varDecls, i_v);
      then (txt, a_varUnbox, a_auxFunctionIgnore, a_varFreesIgnore, a_outputAllocIgnore, a_varDecls);

    case ( txt,
           i_v :: _,
           a_varUnbox,
           a_auxFunctionIgnore,
           a_varFreesIgnore,
           a_outputAllocIgnore,
           a_varDecls )
      equation
        (l_0__, a_varDecls, a_outputAllocIgnore, a_varFreesIgnore, a_auxFunctionIgnore) = varInit(Tpl.emptyTxt, i_v, "", a_varDecls, a_outputAllocIgnore, a_varFreesIgnore, a_auxFunctionIgnore);
        txt = funArgName(txt, i_v);
      then (txt, a_varUnbox, a_auxFunctionIgnore, a_varFreesIgnore, a_outputAllocIgnore, a_varDecls);

    case ( txt,
           _,
           a_varUnbox,
           a_auxFunctionIgnore,
           a_varFreesIgnore,
           a_outputAllocIgnore,
           a_varDecls )
      then (txt, a_varUnbox, a_auxFunctionIgnore, a_varFreesIgnore, a_outputAllocIgnore, a_varDecls);
  end match;
end fun_317;

protected function lm_318
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_varUnbox;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varUnbox;
algorithm
  (out_txt, out_a_varDecls, out_a_varUnbox) :=
  match(in_txt, in_items, in_a_varDecls, in_a_varUnbox)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      Tpl.Text a_varDecls;
      Tpl.Text a_varUnbox;
      list<DAE.Dimension> i_var_instDims;
      DAE.Type i_var_ty;
      SimCodeFunction.Variable i_var;
      DAE.Type ret_3;
      Tpl.Text txt_2;
      Tpl.Text txt_1;
      Tpl.Text l_arg;

    case ( txt,
           {},
           a_varDecls,
           a_varUnbox )
      then (txt, a_varDecls, a_varUnbox);

    case ( txt,
           (i_var as SimCodeFunction.VARIABLE(ty = i_var_ty, instDims = i_var_instDims)) :: rest,
           a_varDecls,
           a_varUnbox )
      equation
        l_arg = funArgName(Tpl.emptyTxt, i_var);
        txt_1 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("*out"));
        txt_1 = Tpl.writeText(txt_1, l_arg);
        txt_2 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("out"));
        txt_2 = Tpl.writeText(txt_2, l_arg);
        ret_3 = Types.liftTypeWithDims(i_var_ty, i_var_instDims);
        (txt, a_varUnbox, a_varDecls) = funArgBox(txt, Tpl.textString(txt_1), Tpl.textString(l_arg), Tpl.textString(txt_2), ret_3, a_varUnbox, a_varDecls);
        txt = Tpl.nextIter(txt);
        (txt, a_varDecls, a_varUnbox) = lm_318(txt, rest, a_varDecls, a_varUnbox);
      then (txt, a_varDecls, a_varUnbox);

    case ( txt,
           _ :: rest,
           a_varDecls,
           a_varUnbox )
      equation
        (txt, a_varDecls, a_varUnbox) = lm_318(txt, rest, a_varDecls, a_varUnbox);
      then (txt, a_varDecls, a_varUnbox);
  end match;
end lm_318;

protected function fun_319
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_a_outvars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_outvars)
    local
      Tpl.Text txt;
      SimCodeFunction.Variable i_v;

    case ( txt,
           i_v :: _ )
      equation
        txt = funArgName(txt, i_v);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_319;

protected function fun_320
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_a_outvars;
  input Tpl.Text in_a_retvar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_outvars, in_a_retvar)
    local
      Tpl.Text txt;
      Tpl.Text a_retvar;

    case ( txt,
           _ :: _,
           a_retvar )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("return "));
        txt = Tpl.writeText(txt, a_retvar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("return;"));
      then txt;
  end match;
end fun_320;

public function functionBodyBoxedImpl
  input Tpl.Text txt;
  input Absyn.Path a_name;
  input list<SimCodeFunction.Variable> a_funargs;
  input list<SimCodeFunction.Variable> a_outvars;
  input SCode.Visibility a_visibility;
  input Boolean a_isSimulation;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_prototype;
  Tpl.Text l_afterBody;
  list<SimCodeFunction.Variable> ret_15;
  Tpl.Text l_0__;
  Tpl.Text l_retvar;
  list<SimCodeFunction.Variable> ret_12;
  Tpl.Text l_outputs;
  Tpl.Text l_auxFunctionIgnore;
  Tpl.Text l_varFreesIgnore;
  Tpl.Text l_outputAllocIgnore;
  Tpl.Text l_varBoxIgnore;
  Tpl.Text l_args;
  Tpl.Text l_auxFunction;
  Tpl.Text l_varUnbox;
  Tpl.Text l_varBox;
  Tpl.Text l_varDecls;
  Tpl.Text l_retTypeBoxed;
  Tpl.Text l_fname;
algorithm
  System.tmpTickReset(1);
  System.tmpTickResetIndex(0, 1);
  l_fname := CodegenUtil.underscorePath(Tpl.emptyTxt, a_name);
  l_retTypeBoxed := fun_311(Tpl.emptyTxt, a_outvars);
  l_varDecls := Tpl.emptyTxt;
  l_varBox := Tpl.emptyTxt;
  l_varUnbox := Tpl.emptyTxt;
  l_auxFunction := Tpl.emptyTxt;
  (l_args, l_auxFunction, l_varBox, l_varDecls) := lm_312(Tpl.emptyTxt, a_funargs, l_auxFunction, l_varBox, l_varDecls);
  l_varBoxIgnore := Tpl.emptyTxt;
  l_outputAllocIgnore := Tpl.emptyTxt;
  l_varFreesIgnore := Tpl.emptyTxt;
  l_auxFunctionIgnore := Tpl.emptyTxt;
  ret_12 := List.restOrEmpty(a_outvars);
  l_outputs := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(1, SOME(Tpl.ST_STRING("")), NONE(), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (l_outputs, l_auxFunctionIgnore, l_varFreesIgnore, l_outputAllocIgnore, l_varDecls) := lm_315(l_outputs, ret_12, l_auxFunctionIgnore, l_varFreesIgnore, l_outputAllocIgnore, l_varDecls);
  l_outputs := Tpl.popIter(l_outputs);
  (l_retvar, l_varUnbox, l_auxFunctionIgnore, l_varFreesIgnore, l_outputAllocIgnore, l_varDecls) := fun_317(Tpl.emptyTxt, a_outvars, l_varUnbox, l_auxFunctionIgnore, l_varFreesIgnore, l_outputAllocIgnore, l_varDecls);
  ret_15 := List.restOrEmpty(a_outvars);
  l_0__ := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (l_0__, l_varDecls, l_varUnbox) := lm_318(l_0__, ret_15, l_varDecls, l_varUnbox);
  l_0__ := Tpl.popIter(l_0__);
  l_afterBody := Tpl.emptyTxt;
  (l_prototype, l_afterBody) := functionPrototype(Tpl.emptyTxt, Tpl.textString(l_fname), a_funargs, a_outvars, true, a_visibility, a_isSimulation, false, l_afterBody);
  out_txt := Tpl.writeText(txt, l_auxFunction);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeText(out_txt, l_prototype);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("{\n"));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeText(out_txt, l_varDecls);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := addRootsTempArray(out_txt);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeText(out_txt, l_varBox);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := fun_319(out_txt, a_outvars);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("omc_"));
  out_txt := Tpl.writeText(out_txt, l_fname);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("(threadData"));
  out_txt := Tpl.writeText(out_txt, l_args);
  out_txt := Tpl.writeText(out_txt, l_outputs);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE(");\n"));
  out_txt := Tpl.writeText(out_txt, l_varUnbox);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := fun_320(out_txt, a_outvars, l_retvar);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("}\n"));
  out_txt := Tpl.writeText(out_txt, l_afterBody);
end functionBodyBoxedImpl;

protected function fun_322
  input Tpl.Text in_txt;
  input SimCodeFunction.Variable in_a_var;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_auxFunction) :=
  match(in_txt, in_a_var, in_a_auxFunction)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      String i_name_1;
      DAE.ComponentRef i_name;

    case ( txt,
           SimCodeFunction.VARIABLE(name = i_name),
           a_auxFunction )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        (txt, a_auxFunction) = contextCrefNoPrevExp(txt, i_name, SimCodeFunction.contextFunction, a_auxFunction);
      then (txt, a_auxFunction);

    case ( txt,
           SimCodeFunction.FUNCTION_PTR(name = i_name_1),
           a_auxFunction )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeStr(txt, i_name_1);
      then (txt, a_auxFunction);

    case ( txt,
           _,
           a_auxFunction )
      equation
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 1902, 17), "boxRecordConstructor:Unknown variable");
      then (txt, a_auxFunction);
  end match;
end fun_322;

protected function lm_323
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_auxFunction) :=
  match(in_txt, in_items, in_a_auxFunction)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      Tpl.Text a_auxFunction;
      SimCodeFunction.Variable i_var;

    case ( txt,
           {},
           a_auxFunction )
      then (txt, a_auxFunction);

    case ( txt,
           i_var :: rest,
           a_auxFunction )
      equation
        (txt, a_auxFunction) = fun_322(txt, i_var, a_auxFunction);
        (txt, a_auxFunction) = lm_323(txt, rest, a_auxFunction);
      then (txt, a_auxFunction);
  end match;
end lm_323;

protected function fun_324
  input Tpl.Text in_txt;
  input SCode.Visibility in_a_visibility;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_visibility)
    local
      Tpl.Text txt;

    case ( txt,
           SCode.PROTECTED() )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("PROTECTED_FUNCTION_STATIC "));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_324;

protected function fun_325
  input Tpl.Text in_txt;
  input Boolean in_a_isSimulation;
  input SCode.Visibility in_a_visibility;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_isSimulation, in_a_visibility)
    local
      Tpl.Text txt;
      SCode.Visibility a_visibility;

    case ( txt,
           false,
           a_visibility )
      equation
        txt = fun_324(txt, a_visibility);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_325;

protected function fun_326
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("impl"));
      then txt;
  end match;
end fun_326;

protected function lm_327
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      SimCodeFunction.Variable i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = funArgBoxedDefinition(txt, i_var);
        txt = lm_327(txt, rest);
      then txt;
  end match;
end lm_327;

protected function fun_328
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_fname;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_fname)
    local
      Tpl.Text txt;
      Tpl.Text a_fname;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_fname )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("boxptrtd_"));
        txt = Tpl.writeText(txt, a_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" boxptr_"));
        txt = Tpl.writeText(txt, a_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = boxptrimpl_"));
        txt = Tpl.writeText(txt, a_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_328;

protected function fun_329
  input Tpl.Text in_txt;
  input SimCodeFunction.Function in_a_fn;
  input Boolean in_a_isSimulation;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_auxFunction) :=
  match(in_txt, in_a_fn, in_a_isSimulation, in_a_auxFunction)
    local
      Tpl.Text txt;
      Boolean a_isSimulation;
      Tpl.Text a_auxFunction;
      SCode.Visibility i_visibility;
      list<SimCodeFunction.Variable> i_funArgs;
      Absyn.Path i_name;
      Boolean ret_7;
      Boolean ret_6;
      Integer ret_5;
      Integer ret_4;
      Tpl.Text l_start;
      Tpl.Text l_funArgsStr;
      Tpl.Text l_retType;
      Tpl.Text l_fname;

    case ( txt,
           SimCodeFunction.RECORD_CONSTRUCTOR(name = i_name, funArgs = i_funArgs, visibility = i_visibility),
           a_isSimulation,
           a_auxFunction )
      equation
        System.tmpTickReset(1);
        l_fname = CodegenUtil.underscorePath(Tpl.emptyTxt, i_name);
        l_retType = Tpl.writeText(Tpl.emptyTxt, l_fname);
        l_retType = Tpl.writeTok(l_retType, Tpl.ST_STRING("_rettypeboxed"));
        (l_funArgsStr, a_auxFunction) = lm_323(Tpl.emptyTxt, i_funArgs, a_auxFunction);
        ret_4 = listLength(i_funArgs);
        ret_5 = SimCodeFunctionUtil.incrementInt(ret_4, 1);
        l_start = daeExpMetaHelperBoxStart(Tpl.emptyTxt, ret_5);
        txt = fun_325(txt, a_isSimulation, i_visibility);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_metatype boxptr"));
        ret_6 = Flags.isSet(Flags.OMC_RELOCATABLE_FUNCTIONS);
        txt = fun_326(txt, ret_6);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeText(txt, l_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(threadData_t *threadData"));
        txt = lm_327(txt, i_funArgs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ")\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("return mmc_mk_box"));
        txt = Tpl.writeText(txt, l_start);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("3, &"));
        txt = Tpl.writeText(txt, l_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("__desc"));
        txt = Tpl.writeText(txt, l_funArgsStr);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(");\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("}\n"));
        ret_7 = Flags.isSet(Flags.OMC_RELOCATABLE_FUNCTIONS);
        txt = fun_328(txt, ret_7, l_fname);
      then (txt, a_auxFunction);

    case ( txt,
           _,
           _,
           a_auxFunction )
      then (txt, a_auxFunction);
  end match;
end fun_329;

public function boxRecordConstructor
  input Tpl.Text txt;
  input SimCodeFunction.Function a_fn;
  input Boolean a_isSimulation;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_auxFunction;
algorithm
  l_auxFunction := Tpl.emptyTxt;
  (out_txt, l_auxFunction) := fun_329(txt, a_fn, a_isSimulation, l_auxFunction);
end boxRecordConstructor;

public function funArgUnbox
  input Tpl.Text in_txt;
  input SimCodeFunction.Variable in_a_var;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_varBox;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varBox;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_varBox, out_a_auxFunction) :=
  match(in_txt, in_a_var, in_a_varDecls, in_a_varBox, in_a_auxFunction)
    local
      Tpl.Text txt;
      Tpl.Text a_varDecls;
      Tpl.Text a_varBox;
      Tpl.Text a_auxFunction;
      String i_name_1;
      DAE.Type i_ty;
      DAE.ComponentRef i_name;
      Tpl.Text l_varName;

    case ( txt,
           SimCodeFunction.VARIABLE(ty = DAE.T_ARRAY(ty = _), parallelism = DAE.PARGLOBAL()),
           a_varDecls,
           a_varBox,
           a_auxFunction )
      equation
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 1917, 9), "Trying to generate a boxed function with non protected parglobal array.");
      then (txt, a_varDecls, a_varBox, a_auxFunction);

    case ( txt,
           SimCodeFunction.VARIABLE(ty = DAE.T_ARRAY(ty = _), parallelism = DAE.PARLOCAL()),
           a_varDecls,
           a_varBox,
           a_auxFunction )
      equation
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 1919, 10), "Trying to generate a boxed function with non protected parlocal array.");
      then (txt, a_varDecls, a_varBox, a_auxFunction);

    case ( txt,
           SimCodeFunction.VARIABLE(name = i_name, ty = i_ty),
           a_varDecls,
           a_varBox,
           a_auxFunction )
      equation
        (l_varName, a_auxFunction) = contextCrefNoPrevExp(Tpl.emptyTxt, i_name, SimCodeFunction.contextFunction, a_auxFunction);
        (txt, a_varBox, a_varDecls) = unboxVariable(txt, Tpl.textString(l_varName), i_ty, a_varBox, a_varDecls);
      then (txt, a_varDecls, a_varBox, a_auxFunction);

    case ( txt,
           SimCodeFunction.FUNCTION_PTR(name = i_name_1),
           a_varDecls,
           a_varBox,
           a_auxFunction )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeStr(txt, i_name_1);
      then (txt, a_varDecls, a_varBox, a_auxFunction);

    case ( txt,
           _,
           a_varDecls,
           a_varBox,
           a_auxFunction )
      then (txt, a_varDecls, a_varBox, a_auxFunction);
  end match;
end funArgUnbox;

protected function fun_332
  input Tpl.Text in_txt;
  input DAE.Type in_a_varType;
  input String in_a_varName;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls) :=
  match(in_txt, in_a_varType, in_a_varName, in_a_preExp, in_a_varDecls)
    local
      Tpl.Text txt;
      String a_varName;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      DAE.Type i_varType;
      Tpl.Text l_tmpVar;
      Tpl.Text l_ty;
      Tpl.Text l_shortType;

    case ( txt,
           DAE.T_COMPLEX(complexClassType = ClassInf.EXTERNAL_OBJ(path = _)),
           a_varName,
           a_preExp,
           a_varDecls )
      equation
        txt = Tpl.writeStr(txt, a_varName);
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.T_STRING(varLst = _),
           a_varName,
           a_preExp,
           a_varDecls )
      equation
        txt = Tpl.writeStr(txt, a_varName);
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.T_METATYPE(ty = _),
           a_varName,
           a_preExp,
           a_varDecls )
      equation
        txt = Tpl.writeStr(txt, a_varName);
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.T_METARECORD(path = _),
           a_varName,
           a_preExp,
           a_varDecls )
      equation
        txt = Tpl.writeStr(txt, a_varName);
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.T_METAUNIONTYPE(paths = _),
           a_varName,
           a_preExp,
           a_varDecls )
      equation
        txt = Tpl.writeStr(txt, a_varName);
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.T_METALIST(ty = _),
           a_varName,
           a_preExp,
           a_varDecls )
      equation
        txt = Tpl.writeStr(txt, a_varName);
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.T_METAARRAY(ty = _),
           a_varName,
           a_preExp,
           a_varDecls )
      equation
        txt = Tpl.writeStr(txt, a_varName);
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.T_METAPOLYMORPHIC(name = _),
           a_varName,
           a_preExp,
           a_varDecls )
      equation
        txt = Tpl.writeStr(txt, a_varName);
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.T_METAOPTION(ty = _),
           a_varName,
           a_preExp,
           a_varDecls )
      equation
        txt = Tpl.writeStr(txt, a_varName);
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.T_METATUPLE(types = _),
           a_varName,
           a_preExp,
           a_varDecls )
      equation
        txt = Tpl.writeStr(txt, a_varName);
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.T_METABOXED(ty = _),
           a_varName,
           a_preExp,
           a_varDecls )
      equation
        txt = Tpl.writeStr(txt, a_varName);
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           (i_varType as DAE.T_COMPLEX(complexClassType = ClassInf.RECORD(path = _))),
           a_varName,
           a_preExp,
           a_varDecls )
      equation
        (txt, a_preExp, a_varDecls) = unboxRecord(txt, a_varName, i_varType, a_preExp, a_varDecls);
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.T_ARRAY(ty = _),
           a_varName,
           a_preExp,
           a_varDecls )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("*((base_array_t*)"));
        txt = Tpl.writeStr(txt, a_varName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           i_varType,
           a_varName,
           a_preExp,
           a_varDecls )
      equation
        l_shortType = mmcTypeShort(Tpl.emptyTxt, i_varType);
        l_ty = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("modelica_"));
        l_ty = Tpl.writeText(l_ty, l_shortType);
        (l_tmpVar, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(l_ty), a_varDecls);
        a_preExp = Tpl.writeText(a_preExp, l_tmpVar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = mmc_unbox_"));
        a_preExp = Tpl.writeText(a_preExp, l_shortType);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("("));
        a_preExp = Tpl.writeStr(a_preExp, a_varName);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tmpVar);
      then (txt, a_preExp, a_varDecls);
  end match;
end fun_332;

public function unboxVariable
  input Tpl.Text txt;
  input String a_varName;
  input DAE.Type a_varType;
  input Tpl.Text a_preExp;
  input Tpl.Text a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls) := fun_332(txt, a_varType, a_varName, a_preExp, a_varDecls);
end unboxVariable;

protected function lm_334
  input Tpl.Text in_txt;
  input list<DAE.Var> in_items;
  input Tpl.Text in_a_tmpVar;
  input String in_a_recordVar;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_varDecls) :=
  match(in_txt, in_items, in_a_tmpVar, in_a_recordVar, in_a_varDecls)
    local
      Tpl.Text txt;
      list<DAE.Var> rest;
      Tpl.Text a_tmpVar;
      String a_recordVar;
      Tpl.Text a_varDecls;
      Integer x_offset;
      DAE.Ident i_compname;
      DAE.Type i_ty;
      Tpl.Text l_unboxStr;
      Tpl.Text l_unboxBuf;
      Tpl.Text l_untagTmp;
      Tpl.Text l_varType;

    case ( txt,
           {},
           _,
           _,
           a_varDecls )
      then (txt, a_varDecls);

    case ( txt,
           DAE.TYPES_VAR(name = i_compname, ty = i_ty) :: rest,
           a_tmpVar,
           a_recordVar,
           a_varDecls )
      equation
        x_offset = Tpl.getIteri_i0(txt);
        l_varType = mmcTypeShort(Tpl.emptyTxt, i_ty);
        (l_untagTmp, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_metatype", a_varDecls);
        l_unboxBuf = Tpl.emptyTxt;
        (l_unboxStr, l_unboxBuf, a_varDecls) = unboxVariable(Tpl.emptyTxt, Tpl.textString(l_untagTmp), i_ty, l_unboxBuf, a_varDecls);
        txt = Tpl.writeText(txt, l_untagTmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = (MMC_FETCH(MMC_OFFSET(MMC_UNTAGPTR("));
        txt = Tpl.writeStr(txt, a_recordVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("), "));
        txt = Tpl.writeStr(txt, intString(x_offset));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(")));\n"));
        txt = Tpl.writeText(txt, l_unboxBuf);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, a_tmpVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("._"));
        txt = Tpl.writeStr(txt, i_compname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, l_unboxStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        (txt, a_varDecls) = lm_334(txt, rest, a_tmpVar, a_recordVar, a_varDecls);
      then (txt, a_varDecls);

    case ( txt,
           _ :: rest,
           a_tmpVar,
           a_recordVar,
           a_varDecls )
      equation
        (txt, a_varDecls) = lm_334(txt, rest, a_tmpVar, a_recordVar, a_varDecls);
      then (txt, a_varDecls);
  end match;
end lm_334;

protected function fun_335
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;
  input String in_a_recordVar;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls) :=
  match(in_txt, in_a_ty, in_a_recordVar, in_a_preExp, in_a_varDecls)
    local
      Tpl.Text txt;
      String a_recordVar;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      list<DAE.Var> i_vars;
      Absyn.Path i_path;
      Tpl.Text txt_1;
      Tpl.Text l_tmpVar;

    case ( txt,
           DAE.T_COMPLEX(complexClassType = ClassInf.RECORD(path = i_path), varLst = i_vars),
           a_recordVar,
           a_preExp,
           a_varDecls )
      equation
        txt_1 = CodegenUtil.underscorePath(Tpl.emptyTxt, i_path);
        (l_tmpVar, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(txt_1), a_varDecls);
        a_preExp = Tpl.pushIter(a_preExp, Tpl.ITER_OPTIONS(2, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (a_preExp, a_varDecls) = lm_334(a_preExp, i_vars, l_tmpVar, a_recordVar, a_varDecls);
        a_preExp = Tpl.popIter(a_preExp);
        txt = Tpl.writeText(txt, l_tmpVar);
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           _,
           _,
           a_preExp,
           a_varDecls )
      then (txt, a_preExp, a_varDecls);
  end match;
end fun_335;

public function unboxRecord
  input Tpl.Text txt;
  input String a_recordVar;
  input DAE.Type a_ty;
  input Tpl.Text a_preExp;
  input Tpl.Text a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls) := fun_335(txt, a_ty, a_recordVar, a_preExp, a_varDecls);
end unboxRecord;

protected function fun_337
  input Tpl.Text in_txt;
  input String in_a_condition;
  input Tpl.Text in_a_constructor;
  input String in_a_outName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_condition, in_a_constructor, in_a_outName)
    local
      Tpl.Text txt;
      Tpl.Text a_constructor;
      String a_outName;
      String i_condition;

    case ( txt,
           "",
           a_constructor,
           a_outName )
      equation
        txt = Tpl.writeStr(txt, a_outName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, a_constructor);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           i_condition,
           a_constructor,
           a_outName )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if ("));
        txt = Tpl.writeStr(txt, i_condition);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") { "));
        txt = Tpl.writeStr(txt, a_outName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, a_constructor);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("; }"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;
  end match;
end fun_337;

protected function fun_338
  input Tpl.Text in_txt;
  input Tpl.Text in_a_constructorType;
  input String in_a_outName;
  input String in_a_condition;
  input Tpl.Text in_a_varDecls;
  input DAE.Type in_a_ty;
  input String in_a_varName;
  input Tpl.Text in_a_varUnbox;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varUnbox;
algorithm
  (out_txt, out_a_varDecls, out_a_varUnbox) :=
  match(in_txt, in_a_constructorType, in_a_outName, in_a_condition, in_a_varDecls, in_a_ty, in_a_varName, in_a_varUnbox)
    local
      Tpl.Text txt;
      String a_outName;
      String a_condition;
      Tpl.Text a_varDecls;
      DAE.Type a_ty;
      String a_varName;
      Tpl.Text a_varUnbox;
      Tpl.Text l_constructor;
      String ret_0;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           _,
           _,
           a_varDecls,
           a_ty,
           a_varName,
           a_varUnbox )
      equation
        a_varUnbox = Tpl.writeTok(a_varUnbox, Tpl.ST_STRING("/* skip box "));
        a_varUnbox = Tpl.writeStr(a_varUnbox, a_varName);
        a_varUnbox = Tpl.writeTok(a_varUnbox, Tpl.ST_STRING("; "));
        ret_0 = Types.unparseType(a_ty);
        a_varUnbox = Tpl.writeStr(a_varUnbox, ret_0);
        a_varUnbox = Tpl.writeTok(a_varUnbox, Tpl.ST_STRING(" */"));
        a_varUnbox = Tpl.writeTok(a_varUnbox, Tpl.ST_NEW_LINE());
        txt = Tpl.writeStr(txt, a_varName);
      then (txt, a_varDecls, a_varUnbox);

    case ( txt,
           _,
           a_outName,
           a_condition,
           a_varDecls,
           a_ty,
           a_varName,
           a_varUnbox )
      equation
        (l_constructor, a_varUnbox, a_varDecls) = mmcConstructor(Tpl.emptyTxt, a_ty, a_varName, a_varUnbox, a_varDecls);
        a_varUnbox = fun_337(a_varUnbox, a_condition, l_constructor, a_outName);
        txt = Tpl.writeStr(txt, a_outName);
      then (txt, a_varDecls, a_varUnbox);
  end match;
end fun_338;

public function funArgBox
  input Tpl.Text txt;
  input String a_outName;
  input String a_varName;
  input String a_condition;
  input DAE.Type a_ty;
  input Tpl.Text a_varUnbox;
  input Tpl.Text a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varUnbox;
  output Tpl.Text out_a_varDecls;
protected
  Tpl.Text l_constructorType;
algorithm
  l_constructorType := mmcConstructorType(Tpl.emptyTxt, a_ty);
  (out_txt, out_a_varDecls, out_a_varUnbox) := fun_338(txt, l_constructorType, a_outName, a_condition, a_varDecls, a_ty, a_varName, a_varUnbox);
end funArgBox;

public function mmcConstructorType
  input Tpl.Text in_txt;
  input DAE.Type in_a_type;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_type)
    local
      Tpl.Text txt;

    case ( txt,
           DAE.T_INTEGER(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_metatype"));
      then txt;

    case ( txt,
           DAE.T_BOOL(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_metatype"));
      then txt;

    case ( txt,
           DAE.T_REAL(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_metatype"));
      then txt;

    case ( txt,
           DAE.T_ENUMERATION(index = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_metatype"));
      then txt;

    case ( txt,
           DAE.T_ARRAY(ty = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_metatype"));
      then txt;

    case ( txt,
           DAE.T_COMPLEX(complexClassType = ClassInf.RECORD(path = _)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_metatype"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end mmcConstructorType;

protected function lm_341
  input Tpl.Text in_txt;
  input list<DAE.Var> in_items;
  input Tpl.Text in_a_preExp;
  input String in_a_varName;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls) :=
  match(in_txt, in_items, in_a_preExp, in_a_varName, in_a_varDecls)
    local
      Tpl.Text txt;
      list<DAE.Var> rest;
      Tpl.Text a_preExp;
      String a_varName;
      Tpl.Text a_varDecls;
      DAE.Type i_ty;
      DAE.Ident i_name;
      Tpl.Text l_varname;
      Tpl.Text l_tmp;

    case ( txt,
           {},
           a_preExp,
           _,
           a_varDecls )
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.TYPES_VAR(name = i_name, ty = i_ty) :: rest,
           a_preExp,
           a_varName,
           a_varDecls )
      equation
        (l_tmp, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_metatype", a_varDecls);
        l_varname = Tpl.writeStr(Tpl.emptyTxt, a_varName);
        l_varname = Tpl.writeTok(l_varname, Tpl.ST_STRING("._"));
        l_varname = Tpl.writeStr(l_varname, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        (txt, a_preExp, a_varDecls) = funArgBox(txt, Tpl.textString(l_tmp), Tpl.textString(l_varname), "", i_ty, a_preExp, a_varDecls);
        (txt, a_preExp, a_varDecls) = lm_341(txt, rest, a_preExp, a_varName, a_varDecls);
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           _ :: rest,
           a_preExp,
           a_varName,
           a_varDecls )
      equation
        (txt, a_preExp, a_varDecls) = lm_341(txt, rest, a_preExp, a_varName, a_varDecls);
      then (txt, a_preExp, a_varDecls);
  end match;
end lm_341;

public function mmcConstructor
  input Tpl.Text in_txt;
  input DAE.Type in_a_type;
  input String in_a_varName;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls) :=
  match(in_txt, in_a_type, in_a_varName, in_a_preExp, in_a_varDecls)
    local
      Tpl.Text txt;
      String a_varName;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Absyn.Path i_path;
      list<DAE.Var> i_vars;
      Tpl.Text l_varsStr;
      Integer ret_2;
      Integer ret_1;
      Tpl.Text l_varCount;

    case ( txt,
           DAE.T_INTEGER(varLst = _),
           a_varName,
           a_preExp,
           a_varDecls )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("mmc_mk_icon("));
        txt = Tpl.writeStr(txt, a_varName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.T_BOOL(varLst = _),
           a_varName,
           a_preExp,
           a_varDecls )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("mmc_mk_icon("));
        txt = Tpl.writeStr(txt, a_varName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.T_REAL(varLst = _),
           a_varName,
           a_preExp,
           a_varDecls )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("mmc_mk_rcon("));
        txt = Tpl.writeStr(txt, a_varName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.T_STRING(varLst = _),
           a_varName,
           a_preExp,
           a_varDecls )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("mmc_mk_string("));
        txt = Tpl.writeStr(txt, a_varName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.T_ENUMERATION(index = _),
           a_varName,
           a_preExp,
           a_varDecls )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("mmc_mk_icon("));
        txt = Tpl.writeStr(txt, a_varName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.T_ARRAY(ty = _),
           a_varName,
           a_preExp,
           a_varDecls )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("mmc_mk_modelica_array("));
        txt = Tpl.writeStr(txt, a_varName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.T_COMPLEX(complexClassType = ClassInf.RECORD(path = i_path), varLst = i_vars),
           a_varName,
           a_preExp,
           a_varDecls )
      equation
        ret_1 = listLength(i_vars);
        ret_2 = SimCodeFunctionUtil.incrementInt(ret_1, 1);
        l_varCount = daeExpMetaHelperBoxStart(Tpl.emptyTxt, ret_2);
        (l_varsStr, a_preExp, a_varDecls) = lm_341(Tpl.emptyTxt, i_vars, a_preExp, a_varName, a_varDecls);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("mmc_mk_box"));
        txt = Tpl.writeText(txt, l_varCount);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("3, &"));
        txt = CodegenUtil.underscorePath(txt, i_path);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("__desc"));
        txt = Tpl.writeText(txt, l_varsStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.T_COMPLEX(complexClassType = _),
           a_varName,
           a_preExp,
           a_varDecls )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("mmc_mk_box("));
        txt = Tpl.writeStr(txt, a_varName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           _,
           _,
           a_preExp,
           a_varDecls )
      then (txt, a_preExp, a_varDecls);
  end match;
end mmcConstructor;

protected function fun_343
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(char**)"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_343;

protected function fun_344
  input Tpl.Text in_txt;
  input SimCodeFunction.Variable in_a_var;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_auxFunction) :=
  match(in_txt, in_a_var, in_a_auxFunction)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      DAE.ComponentRef i_name;
      DAE.ComponentRef i_cr;
      DAE.Type i_ty;
      Boolean ret_1;
      Tpl.Text txt_0;

    case ( txt,
           SimCodeFunction.VARIABLE(name = i_cr, ty = (i_ty as DAE.T_COMPLEX(complexClassType = ClassInf.RECORD(path = _)))),
           a_auxFunction )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if (read_modelica_record(&inArgs, "));
        (txt_0, a_auxFunction) = contextCrefNoPrevExp(Tpl.emptyTxt, i_cr, SimCodeFunction.contextFunction, a_auxFunction);
        txt = readInVarRecordMembers(txt, i_ty, Tpl.textString(txt_0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")) return 1;"));
      then (txt, a_auxFunction);

    case ( txt,
           SimCodeFunction.VARIABLE(name = i_name, ty = (i_ty as DAE.T_STRING(varLst = _))),
           a_auxFunction )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if (read_"));
        txt = expTypeArrayIf(txt, i_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(&inArgs, "));
        ret_1 = Config.acceptMetaModelicaGrammar();
        txt = fun_343(txt, ret_1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" &"));
        (txt, a_auxFunction) = contextCrefNoPrevExp(txt, i_name, SimCodeFunction.contextFunction, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")) return 1;"));
      then (txt, a_auxFunction);

    case ( txt,
           SimCodeFunction.VARIABLE(ty = i_ty, name = i_name),
           a_auxFunction )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if (read_"));
        txt = expTypeArrayIf(txt, i_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(&inArgs, &"));
        (txt, a_auxFunction) = contextCrefNoPrevExp(txt, i_name, SimCodeFunction.contextFunction, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")) return 1;"));
      then (txt, a_auxFunction);

    case ( txt,
           _,
           a_auxFunction )
      then (txt, a_auxFunction);
  end match;
end fun_344;

public function readInVar
  input Tpl.Text txt;
  input SimCodeFunction.Variable a_var;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_auxFunction;
algorithm
  l_auxFunction := Tpl.emptyTxt;
  (out_txt, l_auxFunction) := fun_344(txt, a_var, l_auxFunction);
end readInVar;

protected function fun_346
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;
  input DAE.Ident in_a_subvar_name;
  input String in_a_prefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty, in_a_subvar_name, in_a_prefix)
    local
      Tpl.Text txt;
      DAE.Ident a_subvar_name;
      String a_prefix;
      DAE.Type i_ty;
      Tpl.Text l_newPrefix;

    case ( txt,
           (i_ty as DAE.T_COMPLEX(complexClassType = _)),
           a_subvar_name,
           a_prefix )
      equation
        l_newPrefix = Tpl.writeStr(Tpl.emptyTxt, a_prefix);
        l_newPrefix = Tpl.writeTok(l_newPrefix, Tpl.ST_STRING("._"));
        l_newPrefix = Tpl.writeStr(l_newPrefix, a_subvar_name);
        txt = readInVarRecordMembers(txt, i_ty, Tpl.textString(l_newPrefix));
      then txt;

    case ( txt,
           _,
           a_subvar_name,
           a_prefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("&("));
        txt = Tpl.writeStr(txt, a_prefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("._"));
        txt = Tpl.writeStr(txt, a_subvar_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;
  end match;
end fun_346;

protected function lm_347
  input Tpl.Text in_txt;
  input list<DAE.Var> in_items;
  input String in_a_prefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_prefix)
    local
      Tpl.Text txt;
      list<DAE.Var> rest;
      String a_prefix;
      DAE.Ident i_subvar_name;
      DAE.Type i_ty;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           DAE.TYPES_VAR(ty = i_ty, name = i_subvar_name) :: rest,
           a_prefix )
      equation
        txt = fun_346(txt, i_ty, i_subvar_name, a_prefix);
        txt = Tpl.nextIter(txt);
        txt = lm_347(txt, rest, a_prefix);
      then txt;

    case ( txt,
           _ :: rest,
           a_prefix )
      equation
        txt = lm_347(txt, rest, a_prefix);
      then txt;
  end match;
end lm_347;

public function readInVarRecordMembers
  input Tpl.Text in_txt;
  input DAE.Type in_a_type;
  input String in_a_prefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_type, in_a_prefix)
    local
      Tpl.Text txt;
      String a_prefix;
      list<DAE.Var> i_vl;

    case ( txt,
           DAE.T_COMPLEX(varLst = i_vl),
           a_prefix )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_347(txt, i_vl, a_prefix);
        txt = Tpl.popIter(txt);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end readInVarRecordMembers;

public function writeOutVar
  input Tpl.Text in_txt;
  input SimCodeFunction.Variable in_a_var;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_var)
    local
      Tpl.Text txt;
      SimCodeFunction.Variable i_var;
      DAE.Type i_ty;
      Tpl.Text txt_0;

    case ( txt,
           (i_var as SimCodeFunction.VARIABLE(ty = (i_ty as DAE.T_COMPLEX(complexClassType = ClassInf.RECORD(path = _))))) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("write_modelica_record(outVar, "));
        txt_0 = funArgName(Tpl.emptyTxt, i_var);
        txt = writeOutVarRecordMembers(txt, i_ty, Tpl.textString(txt_0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;

    case ( txt,
           (i_var as SimCodeFunction.VARIABLE(name = _)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("write_"));
        txt = varType(txt, i_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(outVar, &"));
        txt = funArgName(txt, i_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end writeOutVar;

protected function fun_350
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;
  input DAE.Ident in_a_subvar_name;
  input String in_a_prefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty, in_a_subvar_name, in_a_prefix)
    local
      Tpl.Text txt;
      DAE.Ident a_subvar_name;
      String a_prefix;
      DAE.Type i_ty;
      Tpl.Text l_newPrefix;

    case ( txt,
           (i_ty as DAE.T_COMPLEX(complexClassType = _)),
           a_subvar_name,
           a_prefix )
      equation
        l_newPrefix = Tpl.writeStr(Tpl.emptyTxt, a_prefix);
        l_newPrefix = Tpl.writeTok(l_newPrefix, Tpl.ST_STRING("._"));
        l_newPrefix = Tpl.writeStr(l_newPrefix, a_subvar_name);
        txt = expTypeRW(txt, i_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = writeOutVarRecordMembers(txt, i_ty, Tpl.textString(l_newPrefix));
      then txt;

    case ( txt,
           i_ty,
           a_subvar_name,
           a_prefix )
      equation
        txt = expTypeRW(txt, i_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", &("));
        txt = Tpl.writeStr(txt, a_prefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("._"));
        txt = Tpl.writeStr(txt, a_subvar_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;
  end match;
end fun_350;

protected function lm_351
  input Tpl.Text in_txt;
  input list<DAE.Var> in_items;
  input String in_a_prefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_prefix)
    local
      Tpl.Text txt;
      list<DAE.Var> rest;
      String a_prefix;
      DAE.Ident i_subvar_name;
      DAE.Type i_ty;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           DAE.TYPES_VAR(ty = i_ty, name = i_subvar_name) :: rest,
           a_prefix )
      equation
        txt = fun_350(txt, i_ty, i_subvar_name, a_prefix);
        txt = Tpl.nextIter(txt);
        txt = lm_351(txt, rest, a_prefix);
      then txt;

    case ( txt,
           _ :: rest,
           a_prefix )
      equation
        txt = lm_351(txt, rest, a_prefix);
      then txt;
  end match;
end lm_351;

protected function fun_352
  input Tpl.Text in_txt;
  input Tpl.Text in_a_args;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_args)
    local
      Tpl.Text txt;
      Tpl.Text i_args;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}) )
      then txt;

    case ( txt,
           i_args )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, i_args);
      then txt;
  end match;
end fun_352;

public function writeOutVarRecordMembers
  input Tpl.Text in_txt;
  input DAE.Type in_a_type;
  input String in_a_prefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_type, in_a_prefix)
    local
      Tpl.Text txt;
      String a_prefix;
      list<DAE.Var> i_vl;
      ClassInf.State i_n;
      Tpl.Text l_args;
      Absyn.Path ret_1;
      Tpl.Text l_basename;

    case ( txt,
           DAE.T_COMPLEX(varLst = i_vl, complexClassType = i_n),
           a_prefix )
      equation
        ret_1 = ClassInf.getStateName(i_n);
        l_basename = CodegenUtil.underscorePath(Tpl.emptyTxt, ret_1);
        l_args = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_args = lm_351(l_args, i_vl, a_prefix);
        l_args = Tpl.popIter(l_args);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("&"));
        txt = Tpl.writeText(txt, l_basename);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("__desc"));
        txt = fun_352(txt, l_args);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", TYPE_DESC_NONE"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end writeOutVarRecordMembers;

protected function fun_354
  input Tpl.Text in_txt;
  input String in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           "modelica_metatype" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = NULL"));
      then txt;

    case ( txt,
           "modelica_string" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = NULL"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_354;

protected function fun_355
  input Tpl.Text in_txt;
  input String in_a_outStruct;
  input Tpl.Text in_a_initVar;
  input Tpl.Text in_a_varName;
  input Tpl.Text in_a_typeNameFull;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_outStruct, in_a_initVar, in_a_varName, in_a_typeNameFull)
    local
      Tpl.Text txt;
      Tpl.Text a_initVar;
      Tpl.Text a_varName;
      Tpl.Text a_typeNameFull;

    case ( txt,
           "",
           a_initVar,
           a_varName,
           a_typeNameFull )
      equation
        txt = Tpl.writeText(txt, a_typeNameFull);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, a_varName);
        txt = Tpl.writeText(txt, a_initVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_355;

protected function fun_356
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input DAE.Type in_a_var_ty;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Boolean in_a_var_bind__from__outside;
  input DAE.ComponentRef in_a_var_name;
  input Option<DAE.Exp> in_a_var_value;
  input Tpl.Text in_a_varInits;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varInits;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_varInits) :=
  match(in_txt, in_mArg, in_a_var_ty, in_a_auxFunction, in_a_varDecls, in_a_var_bind__from__outside, in_a_var_name, in_a_var_value, in_a_varInits)
    local
      Tpl.Text txt;
      DAE.Type a_var_ty;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Boolean a_var_bind__from__outside;
      DAE.ComponentRef a_var_name;
      Option<DAE.Exp> a_var_value;
      Tpl.Text a_varInits;

    case ( txt,
           false,
           _,
           a_auxFunction,
           a_varDecls,
           a_var_bind__from__outside,
           a_var_name,
           a_var_value,
           a_varInits )
      equation
        (a_varInits, a_varDecls, a_auxFunction) = simpleVarInit(a_varInits, a_var_value, a_var_name, a_var_bind__from__outside, SimCodeFunction.contextFunction, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls, a_varInits);

    case ( txt,
           _,
           a_var_ty,
           a_auxFunction,
           a_varDecls,
           a_var_bind__from__outside,
           a_var_name,
           a_var_value,
           a_varInits )
      equation
        (a_varInits, a_varDecls, a_auxFunction) = recordVarAllocInit(a_varInits, a_var_value, a_var_name, a_var_bind__from__outside, a_var_ty, SimCodeFunction.contextFunction, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls, a_varInits);
  end match;
end fun_356;

protected function fun_357
  input Tpl.Text in_txt;
  input list<DAE.Dimension> in_a_instDims;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Boolean in_a_var_bind__from__outside;
  input DAE.ComponentRef in_a_var_name;
  input Option<DAE.Exp> in_a_var_value;
  input Tpl.Text in_a_varInits;
  input DAE.Type in_a_var_ty;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varInits;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_varInits) :=
  match(in_txt, in_a_instDims, in_a_auxFunction, in_a_varDecls, in_a_var_bind__from__outside, in_a_var_name, in_a_var_value, in_a_varInits, in_a_var_ty)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Boolean a_var_bind__from__outside;
      DAE.ComponentRef a_var_name;
      Option<DAE.Exp> a_var_value;
      Tpl.Text a_varInits;
      DAE.Type a_var_ty;
      list<DAE.Dimension> i_instDims;
      Boolean ret_0;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_var_bind__from__outside,
           a_var_name,
           a_var_value,
           a_varInits,
           a_var_ty )
      equation
        ret_0 = Expression.isRecordType(a_var_ty);
        (txt, a_auxFunction, a_varDecls, a_varInits) = fun_356(txt, ret_0, a_var_ty, a_auxFunction, a_varDecls, a_var_bind__from__outside, a_var_name, a_var_value, a_varInits);
      then (txt, a_auxFunction, a_varDecls, a_varInits);

    case ( txt,
           i_instDims,
           a_auxFunction,
           a_varDecls,
           a_var_bind__from__outside,
           a_var_name,
           a_var_value,
           a_varInits,
           a_var_ty )
      equation
        (a_varInits, a_varDecls, a_auxFunction) = arrayVarAllocInit(a_varInits, a_var_name, a_var_ty, i_instDims, a_var_value, a_var_bind__from__outside, SimCodeFunction.contextFunction, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls, a_varInits);
  end match;
end fun_357;

protected function fun_358
  input Tpl.Text in_txt;
  input Option<DAE.Exp> in_a_defaultValue;
  input String in_a_name;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_varInits;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varInits;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_varInits) :=
  match(in_txt, in_a_defaultValue, in_a_name, in_a_auxFunction, in_a_varDecls, in_a_varInits)
    local
      Tpl.Text txt;
      String a_name;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_varInits;
      DAE.Exp i_exp;
      Tpl.Text l_v;

    case ( txt,
           SOME(i_exp),
           a_name,
           a_auxFunction,
           a_varDecls,
           a_varInits )
      equation
        (l_v, a_varInits, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_exp, SimCodeFunction.contextFunction, a_varInits, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, l_v);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then (txt, a_auxFunction, a_varDecls, a_varInits);

    case ( txt,
           _,
           _,
           a_auxFunction,
           a_varDecls,
           a_varInits )
      then (txt, a_auxFunction, a_varDecls, a_varInits);
  end match;
end fun_358;

public function varInit
  input Tpl.Text in_txt;
  input SimCodeFunction.Variable in_a_var;
  input String in_a_outStruct;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_varInits;
  input Tpl.Text in_a_varFrees;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varInits;
  output Tpl.Text out_a_varFrees;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_varInits, out_a_varFrees, out_a_auxFunction) :=
  match(in_txt, in_a_var, in_a_outStruct, in_a_varDecls, in_a_varInits, in_a_varFrees, in_a_auxFunction)
    local
      Tpl.Text txt;
      String a_outStruct;
      Tpl.Text a_varDecls;
      Tpl.Text a_varInits;
      Tpl.Text a_varFrees;
      Tpl.Text a_auxFunction;
      Option<DAE.Exp> i_defaultValue;
      String i_name;
      Boolean i_var_bind__from__outside;
      Option<DAE.Exp> i_var_value;
      DAE.Type i_var_ty;
      list<DAE.Dimension> i_instDims;
      SimCodeFunction.Variable i_var;
      DAE.ComponentRef i_var_name;
      Tpl.Text l_varInitText;
      String str_3;
      Tpl.Text l_initVar;
      Tpl.Text l_typeNameFull;
      Tpl.Text l_varName;

    case ( txt,
           (i_var as SimCodeFunction.VARIABLE(parallelism = DAE.NON_PARALLEL(), name = i_var_name, instDims = i_instDims, ty = i_var_ty, value = i_var_value, bind_from_outside = i_var_bind__from__outside)),
           a_outStruct,
           a_varDecls,
           a_varInits,
           a_varFrees,
           a_auxFunction )
      equation
        (l_varName, a_auxFunction) = contextCrefNoPrevExp(Tpl.emptyTxt, i_var_name, SimCodeFunction.contextFunction, a_auxFunction);
        l_typeNameFull = varType(Tpl.emptyTxt, i_var);
        str_3 = Tpl.textString(l_typeNameFull);
        l_initVar = fun_354(Tpl.emptyTxt, str_3);
        a_varDecls = fun_355(a_varDecls, a_outStruct, l_initVar, l_varName, l_typeNameFull);
        (txt, a_auxFunction, a_varDecls, a_varInits) = fun_357(txt, i_instDims, a_auxFunction, a_varDecls, i_var_bind__from__outside, i_var_name, i_var_value, a_varInits, i_var_ty);
      then (txt, a_varDecls, a_varInits, a_varFrees, a_auxFunction);

    case ( txt,
           (i_var as SimCodeFunction.VARIABLE(name = _)),
           a_outStruct,
           a_varDecls,
           a_varInits,
           a_varFrees,
           a_auxFunction )
      equation
        (txt, a_varDecls, a_varInits, a_varFrees, a_auxFunction) = parVarInit(txt, i_var, a_outStruct, a_varDecls, a_varInits, a_varFrees, a_auxFunction);
      then (txt, a_varDecls, a_varInits, a_varFrees, a_auxFunction);

    case ( txt,
           SimCodeFunction.FUNCTION_PTR(name = i_name, defaultValue = i_defaultValue),
           _,
           a_varDecls,
           a_varInits,
           a_varFrees,
           a_auxFunction )
      equation
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING("modelica_fnptr _"));
        a_varDecls = Tpl.writeStr(a_varDecls, i_name);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(";"));
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_NEW_LINE());
        (l_varInitText, a_auxFunction, a_varDecls, a_varInits) = fun_358(Tpl.emptyTxt, i_defaultValue, i_name, a_auxFunction, a_varDecls, a_varInits);
        a_varInits = Tpl.writeText(a_varInits, l_varInitText);
      then (txt, a_varDecls, a_varInits, a_varFrees, a_auxFunction);

    case ( txt,
           _,
           _,
           a_varDecls,
           a_varInits,
           a_varFrees,
           a_auxFunction )
      equation
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 2122, 12), "Unknown local variable type");
      then (txt, a_varDecls, a_varInits, a_varFrees, a_auxFunction);
  end match;
end varInit;

protected function lm_360
  input Tpl.Text in_txt;
  input list<DAE.Dimension> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_varInits;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varInits;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_varInits) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_varInits)
    local
      Tpl.Text txt;
      list<DAE.Dimension> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_varInits;
      DAE.Dimension i_dim;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_varInits )
      then (txt, a_auxFunction, a_varDecls, a_varInits);

    case ( txt,
           i_dim :: rest,
           a_auxFunction,
           a_varDecls,
           a_varInits )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(_index_t)"));
        (txt, a_varInits, a_varDecls, a_auxFunction) = dimension(txt, i_dim, SimCodeFunction.contextFunction, a_varInits, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_varInits) = lm_360(txt, rest, a_auxFunction, a_varDecls, a_varInits);
      then (txt, a_auxFunction, a_varDecls, a_varInits);
  end match;
end lm_360;

protected function fun_361
  input Tpl.Text in_txt;
  input Option<DAE.Exp> in_a_var_value;
  input Tpl.Text in_a_varInits;
  input Tpl.Text in_a_auxFunction;
  input DAE.ComponentRef in_a_var_name;
  input Tpl.Text in_a_varName;
  input SimCodeFunction.Variable in_a_var;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varInits;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_varInits, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_a_var_value, in_a_varInits, in_a_auxFunction, in_a_var_name, in_a_varName, in_a_var, in_a_varDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_varInits;
      Tpl.Text a_auxFunction;
      DAE.ComponentRef a_var_name;
      Tpl.Text a_varName;
      SimCodeFunction.Variable a_var;
      Tpl.Text a_varDecls;
      DAE.Exp i_exp;
      Tpl.Text l_defaultValue;

    case ( txt,
           SOME(i_exp),
           a_varInits,
           a_auxFunction,
           a_var_name,
           a_varName,
           a_var,
           a_varDecls )
      equation
        a_varDecls = varType(a_varDecls, a_var);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(" "));
        a_varDecls = Tpl.writeText(a_varDecls, a_varName);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(";"));
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_NEW_LINE());
        (l_defaultValue, a_auxFunction) = contextCrefNoPrevExp(Tpl.emptyTxt, a_var_name, SimCodeFunction.contextFunction, a_auxFunction);
        l_defaultValue = Tpl.writeTok(l_defaultValue, Tpl.ST_STRING(" = "));
        (l_defaultValue, a_varInits, a_varDecls, a_auxFunction) = daeExp(l_defaultValue, i_exp, SimCodeFunction.contextFunction, a_varInits, a_varDecls, a_auxFunction);
        l_defaultValue = Tpl.writeTok(l_defaultValue, Tpl.ST_STRING(";"));
        l_defaultValue = Tpl.writeTok(l_defaultValue, Tpl.ST_NEW_LINE());
        a_varInits = Tpl.writeText(a_varInits, l_defaultValue);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
      then (txt, a_varInits, a_auxFunction, a_varDecls);

    case ( txt,
           _,
           a_varInits,
           a_auxFunction,
           _,
           a_varName,
           a_var,
           a_varDecls )
      equation
        a_varDecls = varType(a_varDecls, a_var);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(" "));
        a_varDecls = Tpl.writeText(a_varDecls, a_varName);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(";"));
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_NEW_LINE());
      then (txt, a_varInits, a_auxFunction, a_varDecls);
  end match;
end fun_361;

protected function fun_362
  input Tpl.Text in_txt;
  input list<DAE.Dimension> in_a_instDims;
  input String in_a_outStruct;
  input Tpl.Text in_a_instDimsInit;
  input DAE.Type in_a_var_ty;
  input Tpl.Text in_a_varInits;
  input Tpl.Text in_a_auxFunction;
  input DAE.ComponentRef in_a_var_name;
  input Tpl.Text in_a_varName;
  input SimCodeFunction.Variable in_a_var;
  input Tpl.Text in_a_varDecls;
  input Option<DAE.Exp> in_a_var_value;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varInits;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_varInits, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_a_instDims, in_a_outStruct, in_a_instDimsInit, in_a_var_ty, in_a_varInits, in_a_auxFunction, in_a_var_name, in_a_varName, in_a_var, in_a_varDecls, in_a_var_value)
    local
      Tpl.Text txt;
      String a_outStruct;
      Tpl.Text a_instDimsInit;
      DAE.Type a_var_ty;
      Tpl.Text a_varInits;
      Tpl.Text a_auxFunction;
      DAE.ComponentRef a_var_name;
      Tpl.Text a_varName;
      SimCodeFunction.Variable a_var;
      Tpl.Text a_varDecls;
      Option<DAE.Exp> a_var_value;
      list<DAE.Dimension> i_instDims;
      Tpl.Text l_defaultValue;
      Integer ret_1;
      Tpl.Text l_defaultAlloc;

    case ( txt,
           {},
           _,
           _,
           _,
           a_varInits,
           a_auxFunction,
           a_var_name,
           a_varName,
           a_var,
           a_varDecls,
           a_var_value )
      equation
        (txt, a_varInits, a_auxFunction, a_varDecls) = fun_361(txt, a_var_value, a_varInits, a_auxFunction, a_var_name, a_varName, a_var, a_varDecls);
      then (txt, a_varInits, a_auxFunction, a_varDecls);

    case ( txt,
           i_instDims,
           a_outStruct,
           a_instDimsInit,
           a_var_ty,
           a_varInits,
           a_auxFunction,
           _,
           a_varName,
           a_var,
           a_varDecls,
           _ )
      equation
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING("device_"));
        a_varDecls = expTypeShort(a_varDecls, a_var_ty);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING("_array "));
        a_varDecls = Tpl.writeText(a_varDecls, a_varName);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(";"));
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_NEW_LINE());
        l_defaultAlloc = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("alloc_"));
        l_defaultAlloc = expTypeShort(l_defaultAlloc, a_var_ty);
        l_defaultAlloc = Tpl.writeTok(l_defaultAlloc, Tpl.ST_STRING("_array(&"));
        l_defaultAlloc = Tpl.writeText(l_defaultAlloc, a_varName);
        l_defaultAlloc = Tpl.writeTok(l_defaultAlloc, Tpl.ST_STRING(", "));
        ret_1 = listLength(i_instDims);
        l_defaultAlloc = Tpl.writeStr(l_defaultAlloc, intString(ret_1));
        l_defaultAlloc = Tpl.writeTok(l_defaultAlloc, Tpl.ST_STRING(", "));
        l_defaultAlloc = Tpl.writeText(l_defaultAlloc, a_instDimsInit);
        l_defaultAlloc = Tpl.writeTok(l_defaultAlloc, Tpl.ST_STRING(");"));
        l_defaultAlloc = Tpl.writeTok(l_defaultAlloc, Tpl.ST_NEW_LINE());
        (l_defaultValue, l_defaultAlloc, a_varDecls, a_varInits, a_auxFunction) = varAllocDefaultValue(Tpl.emptyTxt, a_var, a_outStruct, Tpl.textString(a_varName), l_defaultAlloc, a_varDecls, a_varInits, a_auxFunction);
        a_varInits = Tpl.writeText(a_varInits, l_defaultValue);
      then (txt, a_varInits, a_auxFunction, a_varDecls);
  end match;
end fun_362;

protected function lm_363
  input Tpl.Text in_txt;
  input list<DAE.Dimension> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_varInits;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varInits;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_varInits) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_varInits)
    local
      Tpl.Text txt;
      list<DAE.Dimension> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_varInits;
      DAE.Dimension i_dim;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_varInits )
      then (txt, a_auxFunction, a_varDecls, a_varInits);

    case ( txt,
           i_dim :: rest,
           a_auxFunction,
           a_varDecls,
           a_varInits )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(_index_t)"));
        (txt, a_varInits, a_varDecls, a_auxFunction) = dimension(txt, i_dim, SimCodeFunction.contextFunction, a_varInits, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_varInits) = lm_363(txt, rest, a_auxFunction, a_varDecls, a_varInits);
      then (txt, a_auxFunction, a_varDecls, a_varInits);
  end match;
end lm_363;

protected function fun_364
  input Tpl.Text in_txt;
  input Option<DAE.Exp> in_a_var_value;
  input Tpl.Text in_a_varInits;
  input Tpl.Text in_a_auxFunction;
  input DAE.ComponentRef in_a_var_name;
  input Tpl.Text in_a_varName;
  input SimCodeFunction.Variable in_a_var;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varInits;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_varInits, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_a_var_value, in_a_varInits, in_a_auxFunction, in_a_var_name, in_a_varName, in_a_var, in_a_varDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_varInits;
      Tpl.Text a_auxFunction;
      DAE.ComponentRef a_var_name;
      Tpl.Text a_varName;
      SimCodeFunction.Variable a_var;
      Tpl.Text a_varDecls;
      DAE.Exp i_exp;
      Tpl.Text l_defaultValue;

    case ( txt,
           SOME(i_exp),
           a_varInits,
           a_auxFunction,
           a_var_name,
           a_varName,
           a_var,
           a_varDecls )
      equation
        a_varDecls = varType(a_varDecls, a_var);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(" "));
        a_varDecls = Tpl.writeText(a_varDecls, a_varName);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(";"));
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_NEW_LINE());
        (l_defaultValue, a_auxFunction) = contextCrefNoPrevExp(Tpl.emptyTxt, a_var_name, SimCodeFunction.contextFunction, a_auxFunction);
        l_defaultValue = Tpl.writeTok(l_defaultValue, Tpl.ST_STRING(" = "));
        (l_defaultValue, a_varInits, a_varDecls, a_auxFunction) = daeExp(l_defaultValue, i_exp, SimCodeFunction.contextFunction, a_varInits, a_varDecls, a_auxFunction);
        l_defaultValue = Tpl.writeTok(l_defaultValue, Tpl.ST_STRING(";"));
        l_defaultValue = Tpl.writeTok(l_defaultValue, Tpl.ST_NEW_LINE());
        a_varInits = Tpl.writeText(a_varInits, l_defaultValue);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
      then (txt, a_varInits, a_auxFunction, a_varDecls);

    case ( txt,
           _,
           a_varInits,
           a_auxFunction,
           _,
           a_varName,
           a_var,
           a_varDecls )
      equation
        a_varDecls = varType(a_varDecls, a_var);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(" "));
        a_varDecls = Tpl.writeText(a_varDecls, a_varName);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(";"));
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_NEW_LINE());
      then (txt, a_varInits, a_auxFunction, a_varDecls);
  end match;
end fun_364;

protected function fun_365
  input Tpl.Text in_txt;
  input list<DAE.Dimension> in_a_instDims;
  input String in_a_outStruct;
  input Tpl.Text in_a_instDimsInit;
  input DAE.Type in_a_var_ty;
  input Tpl.Text in_a_varInits;
  input Tpl.Text in_a_auxFunction;
  input DAE.ComponentRef in_a_var_name;
  input Tpl.Text in_a_varName;
  input SimCodeFunction.Variable in_a_var;
  input Tpl.Text in_a_varDecls;
  input Option<DAE.Exp> in_a_var_value;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varInits;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_varInits, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_a_instDims, in_a_outStruct, in_a_instDimsInit, in_a_var_ty, in_a_varInits, in_a_auxFunction, in_a_var_name, in_a_varName, in_a_var, in_a_varDecls, in_a_var_value)
    local
      Tpl.Text txt;
      String a_outStruct;
      Tpl.Text a_instDimsInit;
      DAE.Type a_var_ty;
      Tpl.Text a_varInits;
      Tpl.Text a_auxFunction;
      DAE.ComponentRef a_var_name;
      Tpl.Text a_varName;
      SimCodeFunction.Variable a_var;
      Tpl.Text a_varDecls;
      Option<DAE.Exp> a_var_value;
      list<DAE.Dimension> i_instDims;
      Tpl.Text l_defaultValue;
      Integer ret_1;
      Tpl.Text l_defaultAlloc;

    case ( txt,
           {},
           _,
           _,
           _,
           a_varInits,
           a_auxFunction,
           a_var_name,
           a_varName,
           a_var,
           a_varDecls,
           a_var_value )
      equation
        (txt, a_varInits, a_auxFunction, a_varDecls) = fun_364(txt, a_var_value, a_varInits, a_auxFunction, a_var_name, a_varName, a_var, a_varDecls);
      then (txt, a_varInits, a_auxFunction, a_varDecls);

    case ( txt,
           i_instDims,
           a_outStruct,
           a_instDimsInit,
           a_var_ty,
           a_varInits,
           a_auxFunction,
           _,
           a_varName,
           a_var,
           a_varDecls,
           _ )
      equation
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING("device_local_"));
        a_varDecls = expTypeShort(a_varDecls, a_var_ty);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING("_array "));
        a_varDecls = Tpl.writeText(a_varDecls, a_varName);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(";"));
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_NEW_LINE());
        l_defaultAlloc = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("alloc_device_local_"));
        l_defaultAlloc = expTypeShort(l_defaultAlloc, a_var_ty);
        l_defaultAlloc = Tpl.writeTok(l_defaultAlloc, Tpl.ST_STRING("_array(&"));
        l_defaultAlloc = Tpl.writeText(l_defaultAlloc, a_varName);
        l_defaultAlloc = Tpl.writeTok(l_defaultAlloc, Tpl.ST_STRING(", "));
        ret_1 = listLength(i_instDims);
        l_defaultAlloc = Tpl.writeStr(l_defaultAlloc, intString(ret_1));
        l_defaultAlloc = Tpl.writeTok(l_defaultAlloc, Tpl.ST_STRING(", "));
        l_defaultAlloc = Tpl.writeText(l_defaultAlloc, a_instDimsInit);
        l_defaultAlloc = Tpl.writeTok(l_defaultAlloc, Tpl.ST_STRING(");"));
        l_defaultAlloc = Tpl.writeTok(l_defaultAlloc, Tpl.ST_NEW_LINE());
        (l_defaultValue, l_defaultAlloc, a_varDecls, a_varInits, a_auxFunction) = varAllocDefaultValue(Tpl.emptyTxt, a_var, a_outStruct, Tpl.textString(a_varName), l_defaultAlloc, a_varDecls, a_varInits, a_auxFunction);
        a_varInits = Tpl.writeText(a_varInits, l_defaultValue);
      then (txt, a_varInits, a_auxFunction, a_varDecls);
  end match;
end fun_365;

protected function fun_366
  input Tpl.Text in_txt;
  input SimCodeFunction.Variable in_a_var;
  input String in_a_outStruct;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_varInits;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varInits;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_varInits, out_a_auxFunction) :=
  match(in_txt, in_a_var, in_a_outStruct, in_a_varDecls, in_a_varInits, in_a_auxFunction)
    local
      Tpl.Text txt;
      String a_outStruct;
      Tpl.Text a_varDecls;
      Tpl.Text a_varInits;
      Tpl.Text a_auxFunction;
      DAE.Type i_var_ty;
      SimCodeFunction.Variable i_var;
      Option<DAE.Exp> i_var_value;
      list<DAE.Dimension> i_instDims;
      DAE.ComponentRef i_var_name;
      Tpl.Text l_instDimsInit;
      Tpl.Text l_varName;

    case ( txt,
           (i_var as SimCodeFunction.VARIABLE(parallelism = DAE.PARGLOBAL(), name = i_var_name, instDims = i_instDims, value = i_var_value, ty = i_var_ty)),
           a_outStruct,
           a_varDecls,
           a_varInits,
           a_auxFunction )
      equation
        (l_varName, a_auxFunction) = contextCrefNoPrevExp(Tpl.emptyTxt, i_var_name, SimCodeFunction.contextFunction, a_auxFunction);
        l_instDimsInit = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_instDimsInit, a_auxFunction, a_varDecls, a_varInits) = lm_360(l_instDimsInit, i_instDims, a_auxFunction, a_varDecls, a_varInits);
        l_instDimsInit = Tpl.popIter(l_instDimsInit);
        (txt, a_varInits, a_auxFunction, a_varDecls) = fun_362(txt, i_instDims, a_outStruct, l_instDimsInit, i_var_ty, a_varInits, a_auxFunction, i_var_name, l_varName, i_var, a_varDecls, i_var_value);
      then (txt, a_varDecls, a_varInits, a_auxFunction);

    case ( txt,
           (i_var as SimCodeFunction.VARIABLE(parallelism = DAE.PARLOCAL(), name = i_var_name, instDims = i_instDims, value = i_var_value, ty = i_var_ty)),
           a_outStruct,
           a_varDecls,
           a_varInits,
           a_auxFunction )
      equation
        (l_varName, a_auxFunction) = contextCrefNoPrevExp(Tpl.emptyTxt, i_var_name, SimCodeFunction.contextFunction, a_auxFunction);
        l_instDimsInit = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_instDimsInit, a_auxFunction, a_varDecls, a_varInits) = lm_363(l_instDimsInit, i_instDims, a_auxFunction, a_varDecls, a_varInits);
        l_instDimsInit = Tpl.popIter(l_instDimsInit);
        (txt, a_varInits, a_auxFunction, a_varDecls) = fun_365(txt, i_instDims, a_outStruct, l_instDimsInit, i_var_ty, a_varInits, a_auxFunction, i_var_name, l_varName, i_var, a_varDecls, i_var_value);
      then (txt, a_varDecls, a_varInits, a_auxFunction);

    case ( txt,
           _,
           _,
           a_varDecls,
           a_varInits,
           a_auxFunction )
      equation
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING("#error Unknown parallel variable type"));
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_NEW_LINE());
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 2182, 9), "parVarInit:error Unknown parallel variable type");
      then (txt, a_varDecls, a_varInits, a_auxFunction);
  end match;
end fun_366;

public function parVarInit
  input Tpl.Text txt;
  input SimCodeFunction.Variable a_var;
  input String a_outStruct;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_varInits;
  input Tpl.Text a_varFrees;
  input Tpl.Text a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varInits;
  output Tpl.Text out_a_varFrees;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_varInits, out_a_auxFunction) := fun_366(txt, a_var, a_outStruct, a_varDecls, a_varInits, a_auxFunction);
  out_a_varFrees := a_varFrees;
end parVarInit;

protected function fun_368
  input Tpl.Text in_txt;
  input String in_a_outStruct;
  input Tpl.Text in_a_auxFunction;
  input DAE.ComponentRef in_a_var_name;
  input SimCodeFunction.Variable in_a_var;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_auxFunction) :=
  match(in_txt, in_a_outStruct, in_a_auxFunction, in_a_var_name, in_a_var)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      DAE.ComponentRef a_var_name;
      SimCodeFunction.Variable a_var;

    case ( txt,
           "",
           a_auxFunction,
           a_var_name,
           a_var )
      equation
        txt = varType(txt, a_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        (txt, a_auxFunction) = contextCrefNoPrevExp(txt, a_var_name, SimCodeFunction.contextFunction, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then (txt, a_auxFunction);

    case ( txt,
           _,
           a_auxFunction,
           _,
           _ )
      then (txt, a_auxFunction);
  end match;
end fun_368;

protected function fun_369
  input Tpl.Text in_txt;
  input String in_a_outStruct;
  input Integer in_a_i;
  input Tpl.Text in_a_auxFunction;
  input DAE.ComponentRef in_a_var_name;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_auxFunction) :=
  match(in_txt, in_a_outStruct, in_a_i, in_a_auxFunction, in_a_var_name)
    local
      Tpl.Text txt;
      Integer a_i;
      Tpl.Text a_auxFunction;
      DAE.ComponentRef a_var_name;
      String i_outStruct;

    case ( txt,
           "",
           _,
           a_auxFunction,
           a_var_name )
      equation
        (txt, a_auxFunction) = contextCrefNoPrevExp(txt, a_var_name, SimCodeFunction.contextFunction, a_auxFunction);
      then (txt, a_auxFunction);

    case ( txt,
           i_outStruct,
           a_i,
           a_auxFunction,
           _ )
      equation
        txt = Tpl.writeStr(txt, i_outStruct);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".targ"));
        txt = Tpl.writeStr(txt, intString(a_i));
      then (txt, a_auxFunction);
  end match;
end fun_369;

protected function lm_370
  input Tpl.Text in_txt;
  input list<DAE.Dimension> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_varInits;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varInits;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_varInits) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_varInits)
    local
      Tpl.Text txt;
      list<DAE.Dimension> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_varInits;
      DAE.Dimension i_dim;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_varInits )
      then (txt, a_auxFunction, a_varDecls, a_varInits);

    case ( txt,
           i_dim :: rest,
           a_auxFunction,
           a_varDecls,
           a_varInits )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(_index_t)"));
        (txt, a_varInits, a_varDecls, a_auxFunction) = dimension(txt, i_dim, SimCodeFunction.contextFunction, a_varInits, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_varInits) = lm_370(txt, rest, a_auxFunction, a_varDecls, a_varInits);
      then (txt, a_auxFunction, a_varDecls, a_varInits);
  end match;
end lm_370;

protected function fun_371
  input Tpl.Text in_txt;
  input Option<DAE.Exp> in_a_var_value;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_varInits;
  input Tpl.Text in_a_auxFunction;
  input DAE.ComponentRef in_a_var_name;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varInits;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_varInits, out_a_auxFunction) :=
  match(in_txt, in_a_var_value, in_a_varDecls, in_a_varInits, in_a_auxFunction, in_a_var_name)
    local
      Tpl.Text txt;
      Tpl.Text a_varDecls;
      Tpl.Text a_varInits;
      Tpl.Text a_auxFunction;
      DAE.ComponentRef a_var_name;
      DAE.Exp i_exp;
      Tpl.Text l_defaultValue;

    case ( txt,
           SOME(i_exp),
           a_varDecls,
           a_varInits,
           a_auxFunction,
           a_var_name )
      equation
        (l_defaultValue, a_auxFunction) = contextCrefNoPrevExp(Tpl.emptyTxt, a_var_name, SimCodeFunction.contextFunction, a_auxFunction);
        l_defaultValue = Tpl.writeTok(l_defaultValue, Tpl.ST_STRING(" = "));
        (l_defaultValue, a_varInits, a_varDecls, a_auxFunction) = daeExp(l_defaultValue, i_exp, SimCodeFunction.contextFunction, a_varInits, a_varDecls, a_auxFunction);
        l_defaultValue = Tpl.writeTok(l_defaultValue, Tpl.ST_STRING(";"));
        l_defaultValue = Tpl.writeTok(l_defaultValue, Tpl.ST_NEW_LINE());
        a_varInits = Tpl.writeText(a_varInits, l_defaultValue);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
      then (txt, a_varDecls, a_varInits, a_auxFunction);

    case ( txt,
           _,
           a_varDecls,
           a_varInits,
           a_auxFunction,
           _ )
      then (txt, a_varDecls, a_varInits, a_auxFunction);
  end match;
end fun_371;

protected function fun_372
  input Tpl.Text in_txt;
  input list<DAE.Dimension> in_a_instDims;
  input String in_a_outStruct;
  input SimCodeFunction.Variable in_a_var;
  input Tpl.Text in_a_instDimsInit;
  input Tpl.Text in_a_varName;
  input DAE.Type in_a_var_ty;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_varInits;
  input Tpl.Text in_a_auxFunction;
  input DAE.ComponentRef in_a_var_name;
  input Option<DAE.Exp> in_a_var_value;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varInits;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_varInits, out_a_auxFunction) :=
  match(in_txt, in_a_instDims, in_a_outStruct, in_a_var, in_a_instDimsInit, in_a_varName, in_a_var_ty, in_a_varDecls, in_a_varInits, in_a_auxFunction, in_a_var_name, in_a_var_value)
    local
      Tpl.Text txt;
      String a_outStruct;
      SimCodeFunction.Variable a_var;
      Tpl.Text a_instDimsInit;
      Tpl.Text a_varName;
      DAE.Type a_var_ty;
      Tpl.Text a_varDecls;
      Tpl.Text a_varInits;
      Tpl.Text a_auxFunction;
      DAE.ComponentRef a_var_name;
      Option<DAE.Exp> a_var_value;
      list<DAE.Dimension> i_instDims;
      Tpl.Text l_defaultValue;
      Integer ret_2;
      Integer ret_1;
      Tpl.Text l_defaultAlloc;

    case ( txt,
           {},
           _,
           _,
           _,
           _,
           _,
           a_varDecls,
           a_varInits,
           a_auxFunction,
           a_var_name,
           a_var_value )
      equation
        (txt, a_varDecls, a_varInits, a_auxFunction) = fun_371(txt, a_var_value, a_varDecls, a_varInits, a_auxFunction, a_var_name);
      then (txt, a_varDecls, a_varInits, a_auxFunction);

    case ( txt,
           i_instDims,
           a_outStruct,
           a_var,
           a_instDimsInit,
           a_varName,
           a_var_ty,
           a_varDecls,
           a_varInits,
           a_auxFunction,
           _,
           _ )
      equation
        l_defaultAlloc = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("alloc_"));
        l_defaultAlloc = expTypeShort(l_defaultAlloc, a_var_ty);
        l_defaultAlloc = Tpl.writeTok(l_defaultAlloc, Tpl.ST_STRING("_array_c99_"));
        ret_1 = listLength(i_instDims);
        l_defaultAlloc = Tpl.writeStr(l_defaultAlloc, intString(ret_1));
        l_defaultAlloc = Tpl.writeTok(l_defaultAlloc, Tpl.ST_STRING("(&"));
        l_defaultAlloc = Tpl.writeText(l_defaultAlloc, a_varName);
        l_defaultAlloc = Tpl.writeTok(l_defaultAlloc, Tpl.ST_STRING(", "));
        ret_2 = listLength(i_instDims);
        l_defaultAlloc = Tpl.writeStr(l_defaultAlloc, intString(ret_2));
        l_defaultAlloc = Tpl.writeTok(l_defaultAlloc, Tpl.ST_STRING(", "));
        l_defaultAlloc = Tpl.writeText(l_defaultAlloc, a_instDimsInit);
        l_defaultAlloc = Tpl.writeTok(l_defaultAlloc, Tpl.ST_STRING(", memory_state);"));
        l_defaultAlloc = Tpl.writeTok(l_defaultAlloc, Tpl.ST_NEW_LINE());
        (l_defaultValue, l_defaultAlloc, a_varDecls, a_varInits, a_auxFunction) = varAllocDefaultValue(Tpl.emptyTxt, a_var, a_outStruct, Tpl.textString(a_varName), l_defaultAlloc, a_varDecls, a_varInits, a_auxFunction);
        a_varInits = Tpl.writeText(a_varInits, l_defaultValue);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
      then (txt, a_varDecls, a_varInits, a_auxFunction);
  end match;
end fun_372;

protected function fun_373
  input Tpl.Text in_txt;
  input SimCodeFunction.Variable in_a_var;
  input String in_a_outStruct;
  input Integer in_a_i;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_varInits;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varInits;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_varInits, out_a_auxFunction) :=
  match(in_txt, in_a_var, in_a_outStruct, in_a_i, in_a_varDecls, in_a_varInits, in_a_auxFunction)
    local
      Tpl.Text txt;
      String a_outStruct;
      Integer a_i;
      Tpl.Text a_varDecls;
      Tpl.Text a_varInits;
      Tpl.Text a_auxFunction;
      DAE.Type i_var_ty;
      Option<DAE.Exp> i_var_value;
      list<DAE.Dimension> i_instDims;
      DAE.ComponentRef i_var_name;
      SimCodeFunction.Variable i_var;
      Tpl.Text l_instDimsInit;
      Tpl.Text l_varName;

    case ( txt,
           (i_var as SimCodeFunction.VARIABLE(name = i_var_name, instDims = i_instDims, value = i_var_value, ty = i_var_ty)),
           a_outStruct,
           a_i,
           a_varDecls,
           a_varInits,
           a_auxFunction )
      equation
        (a_varDecls, a_auxFunction) = fun_368(a_varDecls, a_outStruct, a_auxFunction, i_var_name, i_var);
        (l_varName, a_auxFunction) = fun_369(Tpl.emptyTxt, a_outStruct, a_i, a_auxFunction, i_var_name);
        l_instDimsInit = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_instDimsInit, a_auxFunction, a_varDecls, a_varInits) = lm_370(l_instDimsInit, i_instDims, a_auxFunction, a_varDecls, a_varInits);
        l_instDimsInit = Tpl.popIter(l_instDimsInit);
        (txt, a_varDecls, a_varInits, a_auxFunction) = fun_372(txt, i_instDims, a_outStruct, i_var, l_instDimsInit, l_varName, i_var_ty, a_varDecls, a_varInits, a_auxFunction, i_var_name, i_var_value);
      then (txt, a_varDecls, a_varInits, a_auxFunction);

    case ( txt,
           SimCodeFunction.FUNCTION_PTR(name = _),
           _,
           _,
           a_varDecls,
           a_varInits,
           a_auxFunction )
      then (txt, a_varDecls, a_varInits, a_auxFunction);

    case ( txt,
           _,
           _,
           _,
           a_varDecls,
           a_varInits,
           a_auxFunction )
      equation
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING("#error Unknown local variable type"));
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_NEW_LINE());
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 2212, 9), "varInitParallel:error Unknown local variable type");
      then (txt, a_varDecls, a_varInits, a_auxFunction);
  end match;
end fun_373;

public function varInitParallel
  input Tpl.Text txt;
  input SimCodeFunction.Variable a_var;
  input String a_outStruct;
  input Integer a_i;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_varInits;
  input Tpl.Text a_varFrees;
  input Tpl.Text a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varInits;
  output Tpl.Text out_a_varFrees;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_varInits, out_a_auxFunction) := fun_373(txt, a_var, a_outStruct, a_i, a_varDecls, a_varInits, a_auxFunction);
  out_a_varFrees := a_varFrees;
end varInitParallel;

protected function fun_375
  input Tpl.Text in_txt;
  input Boolean in_a_arr_scalar;
  input DAE.Exp in_a_e;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_arr_scalar, in_a_e)
    local
      Tpl.Text txt;
      DAE.Exp a_e;

    case ( txt,
           false,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("&"));
      then txt;

    case ( txt,
           _,
           a_e )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = expTypeFromExpModelica(txt, a_e);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;
  end match;
end fun_375;

protected function lm_376
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varName;
  input Tpl.Text in_a_rec__name;
  input Boolean in_a_arr_scalar;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_varName, in_a_rec__name, in_a_arr_scalar)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      Tpl.Text a_varName;
      Tpl.Text a_rec__name;
      Boolean a_arr_scalar;
      Integer x_i1;
      DAE.Exp i_e;
      Tpl.Text l_prefix;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _,
           _,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           i_e :: rest,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_varName,
           a_rec__name,
           a_arr_scalar )
      equation
        x_i1 = Tpl.getIteri_i0(txt);
        l_prefix = fun_375(Tpl.emptyTxt, a_arr_scalar, i_e);
        txt = Tpl.writeText(txt, a_rec__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_array_get("));
        txt = Tpl.writeText(txt, a_varName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", 1, "));
        txt = Tpl.writeStr(txt, intString(x_i1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") = "));
        txt = Tpl.writeText(txt, l_prefix);
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExp(txt, i_e, SimCodeFunction.contextFunction, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_376(txt, rest, a_auxFunction, a_varDecls, a_preExp, a_varName, a_rec__name, a_arr_scalar);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end lm_376;

protected function fun_377
  input Tpl.Text in_txt;
  input Option<DAE.Exp> in_a_value;
  input DAE.ComponentRef in_a_var_name;
  input Tpl.Text in_a_allocNoDefault;
  input String in_a_lhsVarName;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_varInits;
  input DAE.Type in_a_var_ty;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varInits;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_varInits) :=
  match(in_txt, in_a_value, in_a_var_name, in_a_allocNoDefault, in_a_lhsVarName, in_a_auxFunction, in_a_varDecls, in_a_varInits, in_a_var_ty)
    local
      Tpl.Text txt;
      DAE.ComponentRef a_var_name;
      Tpl.Text a_allocNoDefault;
      String a_lhsVarName;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_varInits;
      DAE.Type a_var_ty;
      DAE.Exp i_exp;
      DAE.Exp i_arr;
      Boolean i_arr_scalar;
      list<DAE.Exp> i_arr_array;
      ClassInf.State i_record__state;
      DAE.ComponentRef i_cr;
      Tpl.Text l_arrayExp;
      Tpl.Text l_params;
      Tpl.Text l_preExp;
      Absyn.Path ret_2;
      Tpl.Text l_rec__name;
      Tpl.Text l_varName;

    case ( txt,
           SOME(DAE.CREF(componentRef = i_cr)),
           _,
           _,
           a_lhsVarName,
           a_auxFunction,
           a_varDecls,
           a_varInits,
           a_var_ty )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("copy_"));
        txt = expTypeShort(txt, a_var_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_array("));
        (txt, a_varInits, a_varDecls, a_auxFunction) = contextCref(txt, i_cr, SimCodeFunction.contextFunction, a_varInits, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", &"));
        txt = Tpl.writeStr(txt, a_lhsVarName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then (txt, a_auxFunction, a_varDecls, a_varInits);

    case ( txt,
           SOME(DAE.ARRAY(ty = DAE.T_ARRAY(ty = DAE.T_COMPLEX(complexClassType = i_record__state)), array = i_arr_array, scalar = i_arr_scalar)),
           a_var_name,
           a_allocNoDefault,
           _,
           a_auxFunction,
           a_varDecls,
           a_varInits,
           _ )
      equation
        a_varInits = Tpl.writeText(a_varInits, a_allocNoDefault);
        (l_varName, a_auxFunction) = contextCrefNoPrevExp(Tpl.emptyTxt, a_var_name, SimCodeFunction.contextFunction, a_auxFunction);
        ret_2 = ClassInf.getStateName(i_record__state);
        l_rec__name = CodegenUtil.underscorePath(Tpl.emptyTxt, ret_2);
        l_preExp = Tpl.emptyTxt;
        l_params = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(1, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_params, a_auxFunction, a_varDecls, l_preExp) = lm_376(l_params, i_arr_array, a_auxFunction, a_varDecls, l_preExp, l_varName, l_rec__name, i_arr_scalar);
        l_params = Tpl.popIter(l_params);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_params);
      then (txt, a_auxFunction, a_varDecls, a_varInits);

    case ( txt,
           SOME((i_arr as DAE.SHARED_LITERAL(index = _))),
           _,
           _,
           a_lhsVarName,
           a_auxFunction,
           a_varDecls,
           a_varInits,
           a_var_ty )
      equation
        (l_arrayExp, a_varInits, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_arr, SimCodeFunction.contextFunction, a_varInits, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("copy_"));
        txt = expTypeShort(txt, a_var_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_array("));
        txt = Tpl.writeText(txt, l_arrayExp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", &"));
        txt = Tpl.writeStr(txt, a_lhsVarName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then (txt, a_auxFunction, a_varDecls, a_varInits);

    case ( txt,
           SOME((i_arr as DAE.ARRAY(ty = _))),
           _,
           _,
           a_lhsVarName,
           a_auxFunction,
           a_varDecls,
           a_varInits,
           a_var_ty )
      equation
        (l_arrayExp, a_varInits, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_arr, SimCodeFunction.contextFunction, a_varInits, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("copy_"));
        txt = expTypeShort(txt, a_var_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_array("));
        txt = Tpl.writeText(txt, l_arrayExp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", &"));
        txt = Tpl.writeStr(txt, a_lhsVarName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then (txt, a_auxFunction, a_varDecls, a_varInits);

    case ( txt,
           SOME(i_exp),
           _,
           _,
           a_lhsVarName,
           a_auxFunction,
           a_varDecls,
           a_varInits,
           _ )
      equation
        txt = Tpl.writeStr(txt, a_lhsVarName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        (txt, a_varInits, a_varDecls, a_auxFunction) = daeExp(txt, i_exp, SimCodeFunction.contextFunction, a_varInits, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then (txt, a_auxFunction, a_varDecls, a_varInits);

    case ( txt,
           _,
           _,
           a_allocNoDefault,
           _,
           a_auxFunction,
           a_varDecls,
           a_varInits,
           _ )
      equation
        a_varInits = Tpl.writeText(a_varInits, a_allocNoDefault);
      then (txt, a_auxFunction, a_varDecls, a_varInits);
  end match;
end fun_377;

protected function fun_378
  input Tpl.Text in_txt;
  input SimCodeFunction.Variable in_a_var;
  input String in_a_lhsVarName;
  input Tpl.Text in_a_allocNoDefault;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_varInits;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varInits;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_varInits, out_a_auxFunction) :=
  match(in_txt, in_a_var, in_a_lhsVarName, in_a_allocNoDefault, in_a_varDecls, in_a_varInits, in_a_auxFunction)
    local
      Tpl.Text txt;
      String a_lhsVarName;
      Tpl.Text a_allocNoDefault;
      Tpl.Text a_varDecls;
      Tpl.Text a_varInits;
      Tpl.Text a_auxFunction;
      DAE.ComponentRef i_var_name;
      DAE.Type i_var_ty;
      Option<DAE.Exp> i_value;

    case ( txt,
           SimCodeFunction.VARIABLE(value = i_value, ty = i_var_ty, name = i_var_name),
           a_lhsVarName,
           a_allocNoDefault,
           a_varDecls,
           a_varInits,
           a_auxFunction )
      equation
        (txt, a_auxFunction, a_varDecls, a_varInits) = fun_377(txt, i_value, i_var_name, a_allocNoDefault, a_lhsVarName, a_auxFunction, a_varDecls, a_varInits, i_var_ty);
      then (txt, a_varDecls, a_varInits, a_auxFunction);

    case ( txt,
           _,
           _,
           _,
           a_varDecls,
           a_varInits,
           a_auxFunction )
      then (txt, a_varDecls, a_varInits, a_auxFunction);
  end match;
end fun_378;

public function varAllocDefaultValue
  input Tpl.Text txt;
  input SimCodeFunction.Variable a_var;
  input String a_outStruct;
  input String a_lhsVarName;
  input Tpl.Text a_allocNoDefault;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_varInits;
  input Tpl.Text a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_allocNoDefault;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varInits;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_varInits, out_a_auxFunction) := fun_378(txt, a_var, a_lhsVarName, a_allocNoDefault, a_varDecls, a_varInits, a_auxFunction);
  out_a_allocNoDefault := a_allocNoDefault;
end varAllocDefaultValue;

protected function fun_380
  input Tpl.Text in_txt;
  input list<DAE.Dimension> in_a_instDims;
  input DAE.Type in_a_var_ty;
  input SimCodeFunction.Variable in_a_var;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_instDims, in_a_var_ty, in_a_var)
    local
      Tpl.Text txt;
      DAE.Type a_var_ty;
      SimCodeFunction.Variable a_var;

    case ( txt,
           {},
           _,
           a_var )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if (out"));
        txt = funArgName(txt, a_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") { *out"));
        txt = funArgName(txt, a_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = funArgName(txt, a_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("; }"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _,
           a_var_ty,
           a_var )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if (out"));
        txt = funArgName(txt, a_var);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(") {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if (out"));
        txt = funArgName(txt, a_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "->info == NULL) {\n",
                                    "  FILE_INFO info = omc_dummyFileInfo;\n",
                                    "  omc_assert(threadData, info, \"Unknown size parallel array.\");\n",
                                    "}\n",
                                    "else {\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = expTypeShort(txt, a_var_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_array_copy_data("));
        txt = funArgName(txt, a_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", *out"));
        txt = funArgName(txt, a_var);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(");\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("}\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;
  end match;
end fun_380;

protected function fun_381
  input Tpl.Text in_txt;
  input list<DAE.Dimension> in_a_instDims;
  input DAE.Type in_a_var_ty;
  input SimCodeFunction.Variable in_a_var;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_instDims, in_a_var_ty, in_a_var)
    local
      Tpl.Text txt;
      DAE.Type a_var_ty;
      SimCodeFunction.Variable a_var;

    case ( txt,
           {},
           _,
           a_var )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if (out"));
        txt = funArgName(txt, a_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") { *out"));
        txt = funArgName(txt, a_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = funArgName(txt, a_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("; }"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _,
           a_var_ty,
           a_var )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if (out"));
        txt = funArgName(txt, a_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") { if (out"));
        txt = funArgName(txt, a_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("->dim_size == NULL) {copy_"));
        txt = expTypeShort(txt, a_var_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_array("));
        txt = funArgName(txt, a_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", out"));
        txt = funArgName(txt, a_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");} else {"));
        txt = expTypeShort(txt, a_var_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_array_copy_data("));
        txt = funArgName(txt, a_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", *out"));
        txt = funArgName(txt, a_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");} }"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;
  end match;
end fun_381;

public function varOutput
  input Tpl.Text in_txt;
  input SimCodeFunction.Variable in_a_var;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_var)
    local
      Tpl.Text txt;
      list<DAE.Dimension> i_instDims;
      DAE.Type i_var_ty;
      SimCodeFunction.Variable i_var;

    case ( txt,
           (i_var as SimCodeFunction.FUNCTION_PTR(name = _)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if (out"));
        txt = funArgName(txt, i_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") { *out"));
        txt = funArgName(txt, i_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = (modelica_fnptr)"));
        txt = funArgName(txt, i_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("; }"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           (i_var as SimCodeFunction.VARIABLE(ty = (i_var_ty as DAE.T_ARRAY(ty = _)), parallelism = DAE.PARGLOBAL())) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if (out"));
        txt = funArgName(txt, i_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") { if (out"));
        txt = funArgName(txt, i_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("->info == NULL) {copy_"));
        txt = expTypeShort(txt, i_var_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_array("));
        txt = funArgName(txt, i_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", out"));
        txt = funArgName(txt, i_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");} else {"));
        txt = expTypeShort(txt, i_var_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_array_copy_data("));
        txt = funArgName(txt, i_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", *out"));
        txt = funArgName(txt, i_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");} }"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           (i_var as SimCodeFunction.VARIABLE(ty = (i_var_ty as DAE.T_ARRAY(ty = _)))) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if (out"));
        txt = funArgName(txt, i_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") { if (out"));
        txt = funArgName(txt, i_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("->dim_size == NULL) {copy_"));
        txt = expTypeShort(txt, i_var_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_array("));
        txt = funArgName(txt, i_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", out"));
        txt = funArgName(txt, i_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");} else {"));
        txt = expTypeShort(txt, i_var_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_array_copy_data("));
        txt = funArgName(txt, i_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", *out"));
        txt = funArgName(txt, i_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");} }"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           (i_var as SimCodeFunction.VARIABLE(parallelism = DAE.PARGLOBAL(), instDims = i_instDims, ty = i_var_ty)) )
      equation
        txt = fun_380(txt, i_instDims, i_var_ty, i_var);
      then txt;

    case ( txt,
           (i_var as SimCodeFunction.VARIABLE(instDims = i_instDims, ty = i_var_ty)) )
      equation
        txt = fun_381(txt, i_instDims, i_var_ty, i_var);
      then txt;

    case ( txt,
           _ )
      equation
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 2284, 14), "varOutput:error Unknown variable type as output");
      then txt;
  end match;
end varOutput;

protected function lm_383
  input Tpl.Text in_txt;
  input list<DAE.Dimension> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_varInits;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varInits;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_varInits) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_varInits)
    local
      Tpl.Text txt;
      list<DAE.Dimension> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_varInits;
      DAE.Dimension i_dim;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_varInits )
      then (txt, a_auxFunction, a_varDecls, a_varInits);

    case ( txt,
           i_dim :: rest,
           a_auxFunction,
           a_varDecls,
           a_varInits )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(_index_t)"));
        (txt, a_varInits, a_varDecls, a_auxFunction) = dimension(txt, i_dim, SimCodeFunction.contextFunction, a_varInits, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_varInits) = lm_383(txt, rest, a_auxFunction, a_varDecls, a_varInits);
      then (txt, a_auxFunction, a_varDecls, a_varInits);
  end match;
end lm_383;

protected function fun_384
  input Tpl.Text in_txt;
  input list<DAE.Dimension> in_a_instDims;
  input Tpl.Text in_a_instDimsInit;
  input Integer in_a_ix;
  input String in_a_dest;
  input Tpl.Text in_a_varAssign;
  input DAE.Type in_a_var_ty;
  input Tpl.Text in_a_varName;
  input Tpl.Text in_a_varInits;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varAssign;
  output Tpl.Text out_a_varInits;
algorithm
  (out_txt, out_a_varAssign, out_a_varInits) :=
  match(in_txt, in_a_instDims, in_a_instDimsInit, in_a_ix, in_a_dest, in_a_varAssign, in_a_var_ty, in_a_varName, in_a_varInits)
    local
      Tpl.Text txt;
      Tpl.Text a_instDimsInit;
      Integer a_ix;
      String a_dest;
      Tpl.Text a_varAssign;
      DAE.Type a_var_ty;
      Tpl.Text a_varName;
      Tpl.Text a_varInits;
      list<DAE.Dimension> i_instDims;
      Integer ret_0;

    case ( txt,
           {},
           _,
           a_ix,
           a_dest,
           a_varAssign,
           a_var_ty,
           a_varName,
           a_varInits )
      equation
        a_varInits = Tpl.writeText(a_varInits, a_varName);
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING(" = ocl_device_alloc(sizeof(modelica_"));
        a_varInits = expTypeShort(a_varInits, a_var_ty);
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING("));"));
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_NEW_LINE());
        a_varAssign = Tpl.writeStr(a_varAssign, a_dest);
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING(".c"));
        a_varAssign = Tpl.writeStr(a_varAssign, intString(a_ix));
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING(" = "));
        a_varAssign = Tpl.writeText(a_varAssign, a_varName);
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING(";"));
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_NEW_LINE());
      then (txt, a_varAssign, a_varInits);

    case ( txt,
           i_instDims,
           a_instDimsInit,
           a_ix,
           a_dest,
           a_varAssign,
           a_var_ty,
           a_varName,
           a_varInits )
      equation
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING("alloc_"));
        a_varInits = expTypeShort(a_varInits, a_var_ty);
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING("_array(&"));
        a_varInits = Tpl.writeText(a_varInits, a_varName);
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING(", "));
        ret_0 = listLength(i_instDims);
        a_varInits = Tpl.writeStr(a_varInits, intString(ret_0));
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING(", "));
        a_varInits = Tpl.writeText(a_varInits, a_instDimsInit);
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING(");"));
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_NEW_LINE());
        a_varAssign = Tpl.writeStr(a_varAssign, a_dest);
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING(".c"));
        a_varAssign = Tpl.writeStr(a_varAssign, intString(a_ix));
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING(" = "));
        a_varAssign = Tpl.writeText(a_varAssign, a_varName);
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING(";"));
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_NEW_LINE());
      then (txt, a_varAssign, a_varInits);
  end match;
end fun_384;

protected function lm_385
  input Tpl.Text in_txt;
  input list<DAE.Dimension> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_varInits;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varInits;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_varInits) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_varInits)
    local
      Tpl.Text txt;
      list<DAE.Dimension> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_varInits;
      DAE.Dimension i_dim;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_varInits )
      then (txt, a_auxFunction, a_varDecls, a_varInits);

    case ( txt,
           i_dim :: rest,
           a_auxFunction,
           a_varDecls,
           a_varInits )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(_index_t)"));
        (txt, a_varInits, a_varDecls, a_auxFunction) = dimension(txt, i_dim, SimCodeFunction.contextFunction, a_varInits, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_varInits) = lm_385(txt, rest, a_auxFunction, a_varDecls, a_varInits);
      then (txt, a_auxFunction, a_varDecls, a_varInits);
  end match;
end lm_385;

protected function fun_386
  input Tpl.Text in_txt;
  input list<DAE.Dimension> in_a_instDims;
  input Tpl.Text in_a_instDimsInit;
  input Integer in_a_ix;
  input String in_a_dest;
  input Tpl.Text in_a_varAssign;
  input DAE.Type in_a_var_ty;
  input Tpl.Text in_a_varName;
  input Tpl.Text in_a_varInits;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varAssign;
  output Tpl.Text out_a_varInits;
algorithm
  (out_txt, out_a_varAssign, out_a_varInits) :=
  match(in_txt, in_a_instDims, in_a_instDimsInit, in_a_ix, in_a_dest, in_a_varAssign, in_a_var_ty, in_a_varName, in_a_varInits)
    local
      Tpl.Text txt;
      Tpl.Text a_instDimsInit;
      Integer a_ix;
      String a_dest;
      Tpl.Text a_varAssign;
      DAE.Type a_var_ty;
      Tpl.Text a_varName;
      Tpl.Text a_varInits;
      list<DAE.Dimension> i_instDims;
      Integer ret_0;

    case ( txt,
           {},
           _,
           a_ix,
           a_dest,
           a_varAssign,
           a_var_ty,
           a_varName,
           a_varInits )
      equation
        a_varInits = Tpl.writeText(a_varInits, a_varName);
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING(" = ocl_device_alloc(sizeof(modelica_"));
        a_varInits = expTypeShort(a_varInits, a_var_ty);
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING("));"));
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_NEW_LINE());
        a_varAssign = Tpl.writeStr(a_varAssign, a_dest);
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING(".c"));
        a_varAssign = Tpl.writeStr(a_varAssign, intString(a_ix));
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING(" = "));
        a_varAssign = Tpl.writeText(a_varAssign, a_varName);
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING(";"));
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_NEW_LINE());
      then (txt, a_varAssign, a_varInits);

    case ( txt,
           i_instDims,
           a_instDimsInit,
           a_ix,
           a_dest,
           a_varAssign,
           a_var_ty,
           a_varName,
           a_varInits )
      equation
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING("alloc_"));
        a_varInits = expTypeShort(a_varInits, a_var_ty);
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING("_array(&"));
        a_varInits = Tpl.writeText(a_varInits, a_varName);
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING(", "));
        ret_0 = listLength(i_instDims);
        a_varInits = Tpl.writeStr(a_varInits, intString(ret_0));
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING(", "));
        a_varInits = Tpl.writeText(a_varInits, a_instDimsInit);
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING(");"));
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_NEW_LINE());
        a_varAssign = Tpl.writeStr(a_varAssign, a_dest);
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING(".c"));
        a_varAssign = Tpl.writeStr(a_varAssign, intString(a_ix));
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING(" = "));
        a_varAssign = Tpl.writeText(a_varAssign, a_varName);
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING(";"));
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_NEW_LINE());
      then (txt, a_varAssign, a_varInits);
  end match;
end fun_386;

protected function lm_387
  input Tpl.Text in_txt;
  input list<DAE.Dimension> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_varInits;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varInits;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_varInits) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_varInits)
    local
      Tpl.Text txt;
      list<DAE.Dimension> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_varInits;
      DAE.Dimension i_dim;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_varInits )
      then (txt, a_auxFunction, a_varDecls, a_varInits);

    case ( txt,
           i_dim :: rest,
           a_auxFunction,
           a_varDecls,
           a_varInits )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(_index_t)"));
        (txt, a_varInits, a_varDecls, a_auxFunction) = dimension(txt, i_dim, SimCodeFunction.contextFunction, a_varInits, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_varInits) = lm_387(txt, rest, a_auxFunction, a_varDecls, a_varInits);
      then (txt, a_auxFunction, a_varDecls, a_varInits);
  end match;
end lm_387;

protected function fun_388
  input Tpl.Text in_txt;
  input list<DAE.Dimension> in_a_instDims;
  input Tpl.Text in_a_instDimsInit;
  input DAE.Type in_a_var_ty;
  input Tpl.Text in_a_varName;
  input Integer in_a_ix;
  input String in_a_dest;
  input Tpl.Text in_a_varAssign;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varInits;
  input Tpl.Text in_a_varDecls;
  input SimCodeFunction.Variable in_a_var;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varAssign;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varInits;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_varAssign, out_a_auxFunction, out_a_varInits, out_a_varDecls) :=
  match(in_txt, in_a_instDims, in_a_instDimsInit, in_a_var_ty, in_a_varName, in_a_ix, in_a_dest, in_a_varAssign, in_a_auxFunction, in_a_varInits, in_a_varDecls, in_a_var)
    local
      Tpl.Text txt;
      Tpl.Text a_instDimsInit;
      DAE.Type a_var_ty;
      Tpl.Text a_varName;
      Integer a_ix;
      String a_dest;
      Tpl.Text a_varAssign;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varInits;
      Tpl.Text a_varDecls;
      SimCodeFunction.Variable a_var;
      list<DAE.Dimension> i_instDims;
      Integer ret_1;
      Tpl.Text l_initRecords;

    case ( txt,
           {},
           _,
           _,
           a_varName,
           a_ix,
           a_dest,
           a_varAssign,
           a_auxFunction,
           a_varInits,
           a_varDecls,
           a_var )
      equation
        (l_initRecords, a_varDecls, a_varInits, a_auxFunction) = initRecordMembers(Tpl.emptyTxt, a_var, a_varDecls, a_varInits, a_auxFunction);
        a_varInits = Tpl.writeText(a_varInits, l_initRecords);
        a_varAssign = Tpl.writeStr(a_varAssign, a_dest);
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING(".c"));
        a_varAssign = Tpl.writeStr(a_varAssign, intString(a_ix));
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING(" = "));
        a_varAssign = Tpl.writeText(a_varAssign, a_varName);
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING(";"));
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_NEW_LINE());
      then (txt, a_varAssign, a_auxFunction, a_varInits, a_varDecls);

    case ( txt,
           i_instDims,
           a_instDimsInit,
           a_var_ty,
           a_varName,
           a_ix,
           a_dest,
           a_varAssign,
           a_auxFunction,
           a_varInits,
           a_varDecls,
           _ )
      equation
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING("alloc_"));
        a_varInits = expTypeShort(a_varInits, a_var_ty);
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING("_array(&"));
        a_varInits = Tpl.writeText(a_varInits, a_varName);
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING(", "));
        ret_1 = listLength(i_instDims);
        a_varInits = Tpl.writeStr(a_varInits, intString(ret_1));
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING(", "));
        a_varInits = Tpl.writeText(a_varInits, a_instDimsInit);
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING(");"));
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_NEW_LINE());
        a_varAssign = Tpl.writeStr(a_varAssign, a_dest);
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING(".c"));
        a_varAssign = Tpl.writeStr(a_varAssign, intString(a_ix));
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING(" = "));
        a_varAssign = Tpl.writeText(a_varAssign, a_varName);
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING(";"));
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_NEW_LINE());
      then (txt, a_varAssign, a_auxFunction, a_varInits, a_varDecls);
  end match;
end fun_388;

protected function fun_389
  input Tpl.Text in_txt;
  input SimCodeFunction.Variable in_a_var;
  input String in_a_dest;
  input Integer in_a_ix;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_varInits;
  input Tpl.Text in_a_varAssign;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varInits;
  output Tpl.Text out_a_varAssign;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_varInits, out_a_varAssign, out_a_auxFunction) :=
  match(in_txt, in_a_var, in_a_dest, in_a_ix, in_a_varDecls, in_a_varInits, in_a_varAssign, in_a_auxFunction)
    local
      Tpl.Text txt;
      String a_dest;
      Integer a_ix;
      Tpl.Text a_varDecls;
      Tpl.Text a_varInits;
      Tpl.Text a_varAssign;
      Tpl.Text a_auxFunction;
      String i_var_name_1;
      DAE.Type i_var_ty;
      list<DAE.Dimension> i_instDims;
      SimCodeFunction.Variable i_var;
      DAE.ComponentRef i_var_name;
      Tpl.Text l_instDimsInit;
      Tpl.Text l_varName;

    case ( txt,
           (i_var as SimCodeFunction.VARIABLE(parallelism = DAE.PARGLOBAL(), name = i_var_name, instDims = i_instDims, ty = i_var_ty)),
           a_dest,
           a_ix,
           a_varDecls,
           a_varInits,
           a_varAssign,
           a_auxFunction )
      equation
        (l_varName, a_auxFunction) = contextCrefNoPrevExp(Tpl.emptyTxt, i_var_name, SimCodeFunction.contextFunction, a_auxFunction);
        a_varDecls = varType(a_varDecls, i_var);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(" "));
        a_varDecls = Tpl.writeText(a_varDecls, l_varName);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(";"));
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_NEW_LINE());
        l_instDimsInit = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_instDimsInit, a_auxFunction, a_varDecls, a_varInits) = lm_383(l_instDimsInit, i_instDims, a_auxFunction, a_varDecls, a_varInits);
        l_instDimsInit = Tpl.popIter(l_instDimsInit);
        (txt, a_varAssign, a_varInits) = fun_384(txt, i_instDims, l_instDimsInit, a_ix, a_dest, a_varAssign, i_var_ty, l_varName, a_varInits);
      then (txt, a_varDecls, a_varInits, a_varAssign, a_auxFunction);

    case ( txt,
           (i_var as SimCodeFunction.VARIABLE(parallelism = DAE.PARLOCAL(), name = i_var_name, instDims = i_instDims, ty = i_var_ty)),
           a_dest,
           a_ix,
           a_varDecls,
           a_varInits,
           a_varAssign,
           a_auxFunction )
      equation
        (l_varName, a_auxFunction) = contextCrefNoPrevExp(Tpl.emptyTxt, i_var_name, SimCodeFunction.contextFunction, a_auxFunction);
        a_varDecls = varType(a_varDecls, i_var);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(" "));
        a_varDecls = Tpl.writeText(a_varDecls, l_varName);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(";"));
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_NEW_LINE());
        l_instDimsInit = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_instDimsInit, a_auxFunction, a_varDecls, a_varInits) = lm_385(l_instDimsInit, i_instDims, a_auxFunction, a_varDecls, a_varInits);
        l_instDimsInit = Tpl.popIter(l_instDimsInit);
        (txt, a_varAssign, a_varInits) = fun_386(txt, i_instDims, l_instDimsInit, a_ix, a_dest, a_varAssign, i_var_ty, l_varName, a_varInits);
      then (txt, a_varDecls, a_varInits, a_varAssign, a_auxFunction);

    case ( txt,
           (i_var as SimCodeFunction.VARIABLE(name = i_var_name, instDims = i_instDims, ty = i_var_ty)),
           a_dest,
           a_ix,
           a_varDecls,
           a_varInits,
           a_varAssign,
           a_auxFunction )
      equation
        (l_varName, a_auxFunction) = contextCrefNoPrevExp(Tpl.emptyTxt, i_var_name, SimCodeFunction.contextFunction, a_auxFunction);
        a_varDecls = varType(a_varDecls, i_var);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(" "));
        a_varDecls = Tpl.writeText(a_varDecls, l_varName);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(";"));
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_NEW_LINE());
        l_instDimsInit = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_instDimsInit, a_auxFunction, a_varDecls, a_varInits) = lm_387(l_instDimsInit, i_instDims, a_auxFunction, a_varDecls, a_varInits);
        l_instDimsInit = Tpl.popIter(l_instDimsInit);
        (txt, a_varAssign, a_auxFunction, a_varInits, a_varDecls) = fun_388(txt, i_instDims, l_instDimsInit, i_var_ty, l_varName, a_ix, a_dest, a_varAssign, a_auxFunction, a_varInits, a_varDecls, i_var);
      then (txt, a_varDecls, a_varInits, a_varAssign, a_auxFunction);

    case ( txt,
           SimCodeFunction.FUNCTION_PTR(name = i_var_name_1),
           a_dest,
           a_ix,
           a_varDecls,
           a_varInits,
           a_varAssign,
           a_auxFunction )
      equation
        a_varAssign = Tpl.writeStr(a_varAssign, a_dest);
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING(".c"));
        a_varAssign = Tpl.writeStr(a_varAssign, intString(a_ix));
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING(" = (modelica_fnptr) _"));
        a_varAssign = Tpl.writeStr(a_varAssign, i_var_name_1);
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING(";"));
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_NEW_LINE());
      then (txt, a_varDecls, a_varInits, a_varAssign, a_auxFunction);

    case ( txt,
           _,
           _,
           _,
           a_varDecls,
           a_varInits,
           a_varAssign,
           a_auxFunction )
      then (txt, a_varDecls, a_varInits, a_varAssign, a_auxFunction);
  end match;
end fun_389;

public function varOutputKernelInterface
  input Tpl.Text txt;
  input SimCodeFunction.Variable a_var;
  input String a_dest;
  input Integer a_ix;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_varInits;
  input Tpl.Text a_varCopy;
  input Tpl.Text a_varAssign;
  input Tpl.Text a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varInits;
  output Tpl.Text out_a_varCopy;
  output Tpl.Text out_a_varAssign;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_varInits, out_a_varAssign, out_a_auxFunction) := fun_389(txt, a_var, a_dest, a_ix, a_varDecls, a_varInits, a_varAssign, a_auxFunction);
  out_a_varCopy := a_varCopy;
end varOutputKernelInterface;

protected function lm_391
  input Tpl.Text in_txt;
  input list<DAE.Var> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_ctor__suffix;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_ctor__suffix;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp, out_a_ctor__suffix) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_ctor__suffix)
    local
      Tpl.Text txt;
      list<DAE.Var> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      Tpl.Text a_ctor__suffix;
      Integer x_i1;
      DAE.Var i_sv;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_ctor__suffix )
      then (txt, a_auxFunction, a_varDecls, a_preExp, a_ctor__suffix);

    case ( txt,
           i_sv :: rest,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_ctor__suffix )
      equation
        x_i1 = Tpl.getIteri_i0(txt);
        (txt, a_ctor__suffix, a_preExp, a_varDecls, a_auxFunction) = recordInitOutsideBindings(txt, i_sv, x_i1, a_ctor__suffix, SimCodeFunction.contextFunction, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_preExp, a_ctor__suffix) = lm_391(txt, rest, a_auxFunction, a_varDecls, a_preExp, a_ctor__suffix);
      then (txt, a_auxFunction, a_varDecls, a_preExp, a_ctor__suffix);
  end match;
end lm_391;

protected function fun_392
  input Tpl.Text in_txt;
  input SimCodeFunction.Variable in_a_var;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_var, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      list<DAE.Var> i_ty_varLst;
      SimCodeFunction.Variable i_var;
      DAE.ComponentRef i_name;
      Tpl.Text l_ctor__additional__inputs;
      Tpl.Text l_typeName;
      Tpl.Text l_varName;
      Tpl.Text l_ctor__suffix;
      Tpl.Text l_preExp;

    case ( txt,
           (i_var as SimCodeFunction.VARIABLE(ty = DAE.T_COMPLEX(complexClassType = ClassInf.RECORD(path = _), varLst = i_ty_varLst), name = i_name)),
           a_varDecls,
           a_auxFunction )
      equation
        l_preExp = Tpl.emptyTxt;
        l_ctor__suffix = Tpl.emptyTxt;
        (l_varName, a_auxFunction) = contextCrefNoPrevExp(Tpl.emptyTxt, i_name, SimCodeFunction.contextFunction, a_auxFunction);
        l_typeName = varType(Tpl.emptyTxt, i_var);
        l_ctor__additional__inputs = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(1, SOME(Tpl.ST_STRING("")), NONE(), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_ctor__additional__inputs, a_auxFunction, a_varDecls, l_preExp, l_ctor__suffix) = lm_391(l_ctor__additional__inputs, i_ty_varLst, a_auxFunction, a_varDecls, l_preExp, l_ctor__suffix);
        l_ctor__additional__inputs = Tpl.popIter(l_ctor__additional__inputs);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_typeName);
        txt = Tpl.writeText(txt, l_ctor__suffix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_construct(threadData, "));
        txt = Tpl.writeText(txt, l_varName);
        txt = Tpl.writeText(txt, l_ctor__additional__inputs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           a_varDecls,
           a_auxFunction )
      then (txt, a_varDecls, a_auxFunction);
  end match;
end fun_392;

public function initRecordMembers
  input Tpl.Text txt;
  input SimCodeFunction.Variable a_var;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_varInits;
  input Tpl.Text a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varInits;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) := fun_392(txt, a_var, a_varDecls, a_auxFunction);
  out_a_varInits := a_varInits;
end initRecordMembers;

public function extVarName
  input Tpl.Text txt;
  input DAE.ComponentRef a_cr;

  output Tpl.Text out_txt;
protected
  DAE.ComponentRef ret_0;
algorithm
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING("_"));
  ret_0 := ComponentReference.appendStringFirstIdent("_ext", a_cr);
  out_txt := crefToMStr(out_txt, ret_0);
end extVarName;

protected function fun_395
  input Tpl.Text in_txt;
  input String in_a_language;
  input Tpl.Text in_a_varInit;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Function in_a_fun;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varInit;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_varInit, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_a_language, in_a_varInit, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_fun)
    local
      Tpl.Text txt;
      Tpl.Text a_varInit;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Function a_fun;
      String i_language;
      Tpl.Text txt_0;

    case ( txt,
           "BUILTIN",
           a_varInit,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_fun )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = extFunCallC(txt, a_fun, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_varInit, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           "C",
           a_varInit,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_fun )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = extFunCallC(txt, a_fun, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_varInit, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           "FORTRAN 77",
           a_varInit,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_fun )
      equation
        (txt, a_preExp, a_varDecls, a_varInit, a_auxFunction) = extFunCallF77(txt, a_fun, a_preExp, a_varDecls, a_varInit, a_auxFunction);
      then (txt, a_varInit, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           i_language,
           a_varInit,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _ )
      equation
        txt_0 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("Unsupported external language: "));
        txt_0 = Tpl.writeStr(txt_0, i_language);
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 2367, 14), Tpl.textString(txt_0));
      then (txt, a_varInit, a_auxFunction, a_varDecls, a_preExp);
  end match;
end fun_395;

public function extFunCall
  input Tpl.Text in_txt;
  input SimCodeFunction.Function in_a_fun;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_varInit;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varInit;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_varInit, out_a_auxFunction) :=
  match(in_txt, in_a_fun, in_a_preExp, in_a_varDecls, in_a_varInit, in_a_auxFunction)
    local
      Tpl.Text txt;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_varInit;
      Tpl.Text a_auxFunction;
      SimCodeFunction.Function i_fun;
      String i_language;

    case ( txt,
           (i_fun as SimCodeFunction.EXTERNAL_FUNCTION(language = i_language)),
           a_preExp,
           a_varDecls,
           a_varInit,
           a_auxFunction )
      equation
        (txt, a_varInit, a_auxFunction, a_varDecls, a_preExp) = fun_395(txt, i_language, a_varInit, a_auxFunction, a_varDecls, a_preExp, i_fun);
      then (txt, a_preExp, a_varDecls, a_varInit, a_auxFunction);

    case ( txt,
           _,
           a_preExp,
           a_varDecls,
           a_varInit,
           a_auxFunction )
      then (txt, a_preExp, a_varDecls, a_varInit, a_auxFunction);
  end match;
end extFunCall;

protected function lm_397
  input Tpl.Text in_txt;
  input list<SimCodeFunction.SimExtArg> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls)
    local
      Tpl.Text txt;
      list<SimCodeFunction.SimExtArg> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      SimCodeFunction.SimExtArg i_arg;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls )
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           i_arg :: rest,
           a_auxFunction,
           a_varDecls )
      equation
        (txt, a_varDecls, a_auxFunction) = extFunCallVardecl(txt, i_arg, a_varDecls, a_auxFunction, false);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls) = lm_397(txt, rest, a_auxFunction, a_varDecls);
      then (txt, a_auxFunction, a_varDecls);
  end match;
end lm_397;

protected function lm_398
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_preExp)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Variable i_bivar;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_preExp )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           i_bivar :: rest,
           a_auxFunction,
           a_varDecls,
           a_preExp )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = extFunCallBiVar(txt, i_bivar, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_398(txt, rest, a_auxFunction, a_varDecls, a_preExp);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end lm_398;

protected function fun_399
  input Tpl.Text in_txt;
  input Boolean in_a_dynamicLoad;
  input String in_a_language;
  input String in_a_extName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_dynamicLoad, in_a_language, in_a_extName)
    local
      Tpl.Text txt;
      String a_language;
      String a_extName;

    case ( txt,
           false,
           _,
           a_extName )
      equation
        txt = Tpl.writeStr(txt, a_extName);
      then txt;

    case ( txt,
           _,
           a_language,
           a_extName )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("ptr_"));
        txt = extFunctionName(txt, a_extName, a_language);
      then txt;
  end match;
end fun_399;

protected function fun_400
  input Tpl.Text in_txt;
  input Boolean in_a_dynamicLoad;
  input String in_a_language;
  input String in_a_extName;
  input SourceInfo in_a_info;
  input Tpl.Text in_a_fname;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_dynamicLoad, in_a_language, in_a_extName, in_a_info, in_a_fname)
    local
      Tpl.Text txt;
      String a_language;
      String a_extName;
      SourceInfo a_info;
      Tpl.Text a_fname;

    case ( txt,
           false,
           _,
           _,
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_language,
           a_extName,
           a_info,
           a_fname )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if("));
        txt = Tpl.writeText(txt, a_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "==NULL)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("FILE_INFO info = {"));
        txt = infoArgs(txt, a_info);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "};\n",
                                    "omc_terminate(info, \"dynamic external function "
                                }, false));
        txt = extFunctionName(txt, a_extName, a_language);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" not set!\");\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("} else"));
      then txt;
  end match;
end fun_400;

protected function lm_401
  input Tpl.Text in_txt;
  input list<SimCodeFunction.SimExtArg> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_preExp)
    local
      Tpl.Text txt;
      list<SimCodeFunction.SimExtArg> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.SimExtArg i_arg;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_preExp )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           i_arg :: rest,
           a_auxFunction,
           a_varDecls,
           a_preExp )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = extArg(txt, i_arg, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_401(txt, rest, a_auxFunction, a_varDecls, a_preExp);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end lm_401;

protected function fun_402
  input Tpl.Text in_txt;
  input SimCodeFunction.SimExtArg in_a_extReturn;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_extReturn)
    local
      Tpl.Text txt;
      DAE.ComponentRef i_c;

    case ( txt,
           SimCodeFunction.SIMEXTARG(cref = i_c) )
      equation
        txt = extVarName(txt, i_c);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_402;

protected function fun_403
  input Tpl.Text in_txt;
  input SimCodeFunction.SimExtArg in_a_extReturn;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_a_extReturn, in_a_auxFunction, in_a_varDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      SimCodeFunction.SimExtArg i_extReturn;

    case ( txt,
           (i_extReturn as SimCodeFunction.SIMEXTARG(cref = _)),
           a_auxFunction,
           a_varDecls )
      equation
        (txt, a_varDecls, a_auxFunction) = extFunCallVardecl(txt, i_extReturn, a_varDecls, a_auxFunction, true);
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           _,
           a_auxFunction,
           a_varDecls )
      then (txt, a_auxFunction, a_varDecls);
  end match;
end fun_403;

protected function lm_404
  input Tpl.Text in_txt;
  input list<SimCodeFunction.SimExtArg> in_items;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_auxFunction) :=
  match(in_txt, in_items, in_a_auxFunction)
    local
      Tpl.Text txt;
      list<SimCodeFunction.SimExtArg> rest;
      Tpl.Text a_auxFunction;
      SimCodeFunction.SimExtArg i_arg;

    case ( txt,
           {},
           a_auxFunction )
      then (txt, a_auxFunction);

    case ( txt,
           i_arg :: rest,
           a_auxFunction )
      equation
        (txt, a_auxFunction) = extFunCallVarcopy(txt, i_arg, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction) = lm_404(txt, rest, a_auxFunction);
      then (txt, a_auxFunction);
  end match;
end lm_404;

protected function fun_405
  input Tpl.Text in_txt;
  input SimCodeFunction.SimExtArg in_a_extReturn;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_auxFunction) :=
  match(in_txt, in_a_extReturn, in_a_auxFunction)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      SimCodeFunction.SimExtArg i_extReturn;

    case ( txt,
           (i_extReturn as SimCodeFunction.SIMEXTARG(cref = _)),
           a_auxFunction )
      equation
        (txt, a_auxFunction) = extFunCallVarcopy(txt, i_extReturn, a_auxFunction);
      then (txt, a_auxFunction);

    case ( txt,
           _,
           a_auxFunction )
      then (txt, a_auxFunction);
  end match;
end fun_405;

public function extFunCallC
  input Tpl.Text in_txt;
  input SimCodeFunction.Function in_a_fun;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_fun, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      SimCodeFunction.SimExtArg i_extReturn;
      SourceInfo i_info;
      String i_language;
      String i_extName;
      Boolean i_dynamicLoad;
      list<SimCodeFunction.Variable> i_biVars;
      list<SimCodeFunction.SimExtArg> i_extArgs;
      Tpl.Text l_returnAssign;
      Tpl.Text l_args;
      Tpl.Text l_dynamicCheck;
      Tpl.Text l_fname;
      Tpl.Text l_0__;
      list<SimCodeFunction.SimExtArg> ret_0;

    case ( txt,
           SimCodeFunction.EXTERNAL_FUNCTION(extArgs = i_extArgs, biVars = i_biVars, dynamicLoad = i_dynamicLoad, extName = i_extName, language = i_language, info = i_info, extReturn = i_extReturn),
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        ret_0 = List.union(i_extArgs, i_extArgs);
        a_preExp = Tpl.pushIter(a_preExp, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (a_preExp, a_auxFunction, a_varDecls) = lm_397(a_preExp, ret_0, a_auxFunction, a_varDecls);
        a_preExp = Tpl.popIter(a_preExp);
        l_0__ = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_0__, a_auxFunction, a_varDecls, a_preExp) = lm_398(l_0__, i_biVars, a_auxFunction, a_varDecls, a_preExp);
        l_0__ = Tpl.popIter(l_0__);
        l_fname = fun_399(Tpl.emptyTxt, i_dynamicLoad, i_language, i_extName);
        l_dynamicCheck = fun_400(Tpl.emptyTxt, i_dynamicLoad, i_language, i_extName, i_info, l_fname);
        l_args = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_args, a_auxFunction, a_varDecls, a_preExp) = lm_401(l_args, i_extArgs, a_auxFunction, a_varDecls, a_preExp);
        l_args = Tpl.popIter(l_args);
        l_returnAssign = fun_402(Tpl.emptyTxt, i_extReturn);
        (txt, a_auxFunction, a_varDecls) = fun_403(txt, i_extReturn, a_auxFunction, a_varDecls);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_dynamicCheck);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_returnAssign);
        txt = Tpl.writeText(txt, l_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, l_args);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(");\n"));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_auxFunction) = lm_404(txt, i_extArgs, a_auxFunction);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        (txt, a_auxFunction) = fun_405(txt, i_extReturn, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end extFunCallC;

protected function lm_407
  input Tpl.Text in_txt;
  input list<SimCodeFunction.SimExtArg> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls)
    local
      Tpl.Text txt;
      list<SimCodeFunction.SimExtArg> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      SimCodeFunction.SimExtArg i_arg;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls )
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           i_arg :: rest,
           a_auxFunction,
           a_varDecls )
      equation
        (txt, a_varDecls, a_auxFunction) = extFunCallVardeclF77(txt, i_arg, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls) = lm_407(txt, rest, a_auxFunction, a_varDecls);
      then (txt, a_auxFunction, a_varDecls);
  end match;
end lm_407;

protected function lm_408
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_varInit;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varInit;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_varInit) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_varInit)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_varInit;
      SimCodeFunction.Variable i_arg;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_varInit )
      then (txt, a_auxFunction, a_varDecls, a_varInit);

    case ( txt,
           i_arg :: rest,
           a_auxFunction,
           a_varDecls,
           a_varInit )
      equation
        (txt, a_varInit, a_varDecls, a_auxFunction) = extFunCallBiVarF77(txt, i_arg, a_varInit, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_varInit) = lm_408(txt, rest, a_auxFunction, a_varDecls, a_varInit);
      then (txt, a_auxFunction, a_varDecls, a_varInit);
  end match;
end lm_408;

protected function lm_409
  input Tpl.Text in_txt;
  input list<SimCodeFunction.SimExtArg> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_preExp)
    local
      Tpl.Text txt;
      list<SimCodeFunction.SimExtArg> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.SimExtArg i_arg;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_preExp )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           i_arg :: rest,
           a_auxFunction,
           a_varDecls,
           a_preExp )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = extArgF77(txt, i_arg, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_409(txt, rest, a_auxFunction, a_varDecls, a_preExp);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end lm_409;

protected function fun_410
  input Tpl.Text in_txt;
  input SimCodeFunction.SimExtArg in_a_extReturn;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_extReturn)
    local
      Tpl.Text txt;
      DAE.ComponentRef i_c;

    case ( txt,
           SimCodeFunction.SIMEXTARG(cref = i_c) )
      equation
        txt = extVarName(txt, i_c);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_410;

protected function fun_411
  input Tpl.Text in_txt;
  input SimCodeFunction.SimExtArg in_a_extReturn;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_a_extReturn, in_a_auxFunction, in_a_varDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      SimCodeFunction.SimExtArg i_extReturn;

    case ( txt,
           (i_extReturn as SimCodeFunction.SIMEXTARG(cref = _)),
           a_auxFunction,
           a_varDecls )
      equation
        (txt, a_varDecls, a_auxFunction) = extFunCallVardeclF77(txt, i_extReturn, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           _,
           a_auxFunction,
           a_varDecls )
      then (txt, a_auxFunction, a_varDecls);
  end match;
end fun_411;

protected function lm_412
  input Tpl.Text in_txt;
  input list<SimCodeFunction.SimExtArg> in_items;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_auxFunction) :=
  match(in_txt, in_items, in_a_auxFunction)
    local
      Tpl.Text txt;
      list<SimCodeFunction.SimExtArg> rest;
      Tpl.Text a_auxFunction;
      SimCodeFunction.SimExtArg i_arg;

    case ( txt,
           {},
           a_auxFunction )
      then (txt, a_auxFunction);

    case ( txt,
           i_arg :: rest,
           a_auxFunction )
      equation
        (txt, a_auxFunction) = extFunCallVarcopyF77(txt, i_arg, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction) = lm_412(txt, rest, a_auxFunction);
      then (txt, a_auxFunction);
  end match;
end lm_412;

protected function fun_413
  input Tpl.Text in_txt;
  input SimCodeFunction.SimExtArg in_a_extReturn;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_auxFunction) :=
  match(in_txt, in_a_extReturn, in_a_auxFunction)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      SimCodeFunction.SimExtArg i_extReturn;

    case ( txt,
           (i_extReturn as SimCodeFunction.SIMEXTARG(cref = _)),
           a_auxFunction )
      equation
        (txt, a_auxFunction) = extFunCallVarcopyF77(txt, i_extReturn, a_auxFunction);
      then (txt, a_auxFunction);

    case ( txt,
           _,
           a_auxFunction )
      then (txt, a_auxFunction);
  end match;
end fun_413;

public function extFunCallF77
  input Tpl.Text in_txt;
  input SimCodeFunction.Function in_a_fun;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_varInit;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varInit;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_varInit, out_a_auxFunction) :=
  match(in_txt, in_a_fun, in_a_preExp, in_a_varDecls, in_a_varInit, in_a_auxFunction)
    local
      Tpl.Text txt;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_varInit;
      Tpl.Text a_auxFunction;
      String i_extName;
      SimCodeFunction.SimExtArg i_extReturn;
      list<SimCodeFunction.Variable> i_biVars;
      list<SimCodeFunction.SimExtArg> i_extArgs;
      list<SimCodeFunction.SimExtArg> ret_5;
      Tpl.Text l_returnAssign;
      Tpl.Text l_args;
      Tpl.Text l_biVarDecs;
      list<SimCodeFunction.SimExtArg> ret_1;
      Tpl.Text l_varDecs;

    case ( txt,
           SimCodeFunction.EXTERNAL_FUNCTION(extArgs = i_extArgs, biVars = i_biVars, extReturn = i_extReturn, extName = i_extName),
           a_preExp,
           a_varDecls,
           a_varInit,
           a_auxFunction )
      equation
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING("/* extFunCallF77: varDecs */"));
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_NEW_LINE());
        ret_1 = List.union(i_extArgs, i_extArgs);
        l_varDecs = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_varDecs, a_auxFunction, a_varDecls) = lm_407(l_varDecs, ret_1, a_auxFunction, a_varDecls);
        l_varDecs = Tpl.popIter(l_varDecs);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING("/* extFunCallF77: biVarDecs */"));
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_NEW_LINE());
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("/* extFunCallF77: biVarDecs */"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        l_biVarDecs = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_biVarDecs, a_auxFunction, a_varDecls, a_varInit) = lm_408(l_biVarDecs, i_biVars, a_auxFunction, a_varDecls, a_varInit);
        l_biVarDecs = Tpl.popIter(l_biVarDecs);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING("/* extFunCallF77: args */"));
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_NEW_LINE());
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("/* extFunCallF77: args */"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        l_args = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_args, a_auxFunction, a_varDecls, a_preExp) = lm_409(l_args, i_extArgs, a_auxFunction, a_varDecls, a_preExp);
        l_args = Tpl.popIter(l_args);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("/* extFunCallF77: end args */"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        l_returnAssign = fun_410(Tpl.emptyTxt, i_extReturn);
        txt = Tpl.writeText(txt, l_varDecs);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_biVarDecs);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/* extFunCallF77: extReturn */\n"));
        (txt, a_auxFunction, a_varDecls) = fun_411(txt, i_extReturn, a_auxFunction, a_varDecls);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/* extFunCallF77: CALL */\n"));
        txt = Tpl.writeText(txt, l_returnAssign);
        txt = Tpl.writeStr(txt, i_extName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_("));
        txt = Tpl.writeText(txt, l_args);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ");\n",
                                    "/* extFunCallF77: copy args */\n"
                                }, true));
        ret_5 = List.union(i_extArgs, i_extArgs);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_auxFunction) = lm_412(txt, ret_5, a_auxFunction);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/* extFunCallF77: copy return */\n"));
        (txt, a_auxFunction) = fun_413(txt, i_extReturn, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_varInit, a_auxFunction);

    case ( txt,
           _,
           a_preExp,
           a_varDecls,
           a_varInit,
           a_auxFunction )
      then (txt, a_preExp, a_varDecls, a_varInit, a_auxFunction);
  end match;
end extFunCallF77;

protected function fun_415
  input Tpl.Text in_txt;
  input String in_mArg;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;
  input DAE.ComponentRef in_a_c;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_mArg, in_a_varDecls, in_a_auxFunction, in_a_c)
    local
      Tpl.Text txt;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.ComponentRef a_c;
      Tpl.Text l_var__name;

    case ( txt,
           "integer",
           a_varDecls,
           a_auxFunction,
           a_c )
      equation
        (l_var__name, a_auxFunction) = contextCrefNoPrevExp(Tpl.emptyTxt, a_c, SimCodeFunction.contextFunction, a_auxFunction);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING("integer_array "));
        a_varDecls = Tpl.writeText(a_varDecls, l_var__name);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING("_packed;"));
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_NEW_LINE());
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("pack_alloc_integer_array(&"));
        txt = Tpl.writeText(txt, l_var__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", &"));
        txt = Tpl.writeText(txt, l_var__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_packed);"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           a_varDecls,
           a_auxFunction,
           _ )
      then (txt, a_varDecls, a_auxFunction);
  end match;
end fun_415;

protected function fun_416
  input Tpl.Text in_txt;
  input String in_mArg;
  input Tpl.Text in_a_auxFunction;
  input DAE.ComponentRef in_a_c;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_auxFunction) :=
  match(in_txt, in_mArg, in_a_auxFunction, in_a_c)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      DAE.ComponentRef a_c;

    case ( txt,
           "string",
           a_auxFunction,
           a_c )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("fill_string_array(&"));
        (txt, a_auxFunction) = contextCrefNoPrevExp(txt, a_c, SimCodeFunction.contextFunction, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", mmc_string_uninitialized);"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then (txt, a_auxFunction);

    case ( txt,
           _,
           a_auxFunction,
           _ )
      then (txt, a_auxFunction);
  end match;
end fun_416;

protected function fun_417
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("*(void**)"));
      then txt;
  end match;
end fun_417;

protected function fun_418
  input Tpl.Text in_txt;
  input DAE.ComponentRef in_a_c;
  input DAE.Type in_a_ty;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_varDecls) :=
  match(in_txt, in_a_c, in_a_ty, in_a_varDecls)
    local
      Tpl.Text txt;
      DAE.Type a_ty;
      Tpl.Text a_varDecls;
      DAE.Ident i_ident;
      DAE.ComponentRef i_c;
      Tpl.Text txt_1;
      String ret_1;
      Boolean ret_0;

    case ( txt,
           (i_c as DAE.CREF_IDENT(ident = i_ident)),
           _,
           a_varDecls )
      equation
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING("modelica_fnptr "));
        a_varDecls = extVarName(a_varDecls, i_c);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(";"));
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_NEW_LINE());
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if (MMC_FETCH(MMC_OFFSET(MMC_UNTAGPTR(_"));
        txt = Tpl.writeStr(txt, i_ident);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("), 2))) {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = generateThrow(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" /* The FFI does not allow closures */\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("}\n"));
        txt = extVarName(txt, i_c);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        ret_0 = Flags.isSet(Flags.OMC_RELOCATABLE_FUNCTIONS);
        txt = fun_417(txt, ret_0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("MMC_FETCH(MMC_OFFSET(MMC_UNTAGPTR(_"));
        txt = Tpl.writeStr(txt, i_ident);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("), 1));"));
      then (txt, a_varDecls);

    case ( txt,
           i_c,
           a_ty,
           a_varDecls )
      equation
        txt_1 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("Got function pointer that is not a CREF_IDENT: "));
        txt_1 = CodegenUtil.crefStr(txt_1, i_c);
        txt_1 = Tpl.writeTok(txt_1, Tpl.ST_STRING(", "));
        ret_1 = Types.unparseType(a_ty);
        txt_1 = Tpl.writeStr(txt_1, ret_1);
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 2467, 15), Tpl.textString(txt_1));
      then (txt, a_varDecls);
  end match;
end fun_418;

protected function fun_419
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty)
    local
      Tpl.Text txt;

    case ( txt,
           DAE.T_COMPLEX(complexClassType = ClassInf.RECORD(path = _)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("&"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_419;

protected function fun_420
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input DAE.ComponentRef in_a_c;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_a_ty, in_a_auxFunction, in_a_varDecls, in_a_c)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      DAE.ComponentRef a_c;
      DAE.Type i_ty;

    case ( txt,
           DAE.T_STRING(varLst = _),
           a_auxFunction,
           a_varDecls,
           _ )
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           (i_ty as DAE.T_FUNCTION_REFERENCE_VAR(functionType = _)),
           a_auxFunction,
           a_varDecls,
           a_c )
      equation
        (txt, a_varDecls) = fun_418(txt, a_c, i_ty, a_varDecls);
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           i_ty,
           a_auxFunction,
           a_varDecls,
           a_c )
      equation
        a_varDecls = extType(a_varDecls, i_ty, true, false, false);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(" "));
        a_varDecls = extVarName(a_varDecls, a_c);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(";"));
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_NEW_LINE());
        txt = extVarName(txt, a_c);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = ("));
        txt = extType(txt, i_ty, true, false, false);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
        txt = fun_419(txt, i_ty);
        (txt, a_auxFunction) = contextCrefNoPrevExp(txt, a_c, SimCodeFunction.contextFunction, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then (txt, a_auxFunction, a_varDecls);
  end match;
end fun_420;

protected function fun_421
  input Tpl.Text in_txt;
  input Integer in_a_oi;
  input DAE.ComponentRef in_a_c;
  input DAE.Type in_a_ty;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_varDecls) :=
  match(in_txt, in_a_oi, in_a_c, in_a_ty, in_a_varDecls)
    local
      Tpl.Text txt;
      DAE.ComponentRef a_c;
      DAE.Type a_ty;
      Tpl.Text a_varDecls;

    case ( txt,
           0,
           _,
           _,
           a_varDecls )
      then (txt, a_varDecls);

    case ( txt,
           _,
           a_c,
           a_ty,
           a_varDecls )
      equation
        a_varDecls = extType(a_varDecls, a_ty, true, false, true);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(" "));
        a_varDecls = extVarName(a_varDecls, a_c);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(";"));
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_NEW_LINE());
      then (txt, a_varDecls);
  end match;
end fun_421;

protected function fun_422
  input Tpl.Text in_txt;
  input SimCodeFunction.SimExtArg in_a_arg;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_arg, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      Integer i_oi;
      DAE.ComponentRef i_c;
      DAE.Type i_ty;
      String str_3;
      Tpl.Text txt_2;
      String str_1;
      Tpl.Text txt_0;

    case ( txt,
           SimCodeFunction.SIMEXTARG(isInput = true, isArray = true, type_ = i_ty, cref = i_c),
           a_varDecls,
           a_auxFunction )
      equation
        txt_0 = expTypeShort(Tpl.emptyTxt, i_ty);
        str_1 = Tpl.textString(txt_0);
        (txt, a_varDecls, a_auxFunction) = fun_415(txt, str_1, a_varDecls, a_auxFunction, i_c);
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           SimCodeFunction.SIMEXTARG(isInput = false, isArray = true, type_ = i_ty, cref = i_c),
           a_varDecls,
           a_auxFunction )
      equation
        txt_2 = expTypeShort(Tpl.emptyTxt, i_ty);
        str_3 = Tpl.textString(txt_2);
        (txt, a_auxFunction) = fun_416(txt, str_3, a_auxFunction, i_c);
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           SimCodeFunction.SIMEXTARG(isInput = true, isArray = false, type_ = i_ty, cref = i_c),
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_auxFunction, a_varDecls) = fun_420(txt, i_ty, a_auxFunction, a_varDecls, i_c);
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           SimCodeFunction.SIMEXTARG(outputIndex = i_oi, isArray = false, type_ = i_ty, cref = i_c),
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_varDecls) = fun_421(txt, i_oi, i_c, i_ty, a_varDecls);
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           a_varDecls,
           a_auxFunction )
      then (txt, a_varDecls, a_auxFunction);
  end match;
end fun_422;

public function extFunCallVardecl
  input Tpl.Text txt;
  input SimCodeFunction.SimExtArg a_arg;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_auxFunction;
  input Boolean a_isReturn;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) := fun_422(txt, a_arg, a_varDecls, a_auxFunction);
end extFunCallVardecl;

protected function fun_424
  input Tpl.Text in_txt;
  input String in_mArg;
  input Tpl.Text in_a_default__val;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_default__val)
    local
      Tpl.Text txt;
      Tpl.Text a_default__val;

    case ( txt,
           "",
           _ )
      then txt;

    case ( txt,
           _,
           a_default__val )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("= "));
        txt = Tpl.writeText(txt, a_default__val);
        txt = Tpl.popBlock(txt);
      then txt;
  end match;
end fun_424;

protected function fun_425
  input Tpl.Text in_txt;
  input Boolean in_a_ea_hasBinding;
  input Tpl.Text in_a_default__val;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ea_hasBinding, in_a_default__val)
    local
      Tpl.Text txt;
      Tpl.Text a_default__val;
      String str_0;

    case ( txt,
           false,
           a_default__val )
      equation
        str_0 = Tpl.textString(a_default__val);
        txt = fun_424(txt, str_0, a_default__val);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_425;

protected function fun_426
  input Tpl.Text in_txt;
  input Boolean in_a_ia;
  input Tpl.Text in_a_auxFunction;
  input DAE.ComponentRef in_a_c;
  input Tpl.Text in_a_varDecls;
  input Boolean in_a_ea_hasBinding;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_a_ia, in_a_auxFunction, in_a_c, in_a_varDecls, in_a_ea_hasBinding, in_a_ty)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      DAE.ComponentRef a_c;
      Tpl.Text a_varDecls;
      Boolean a_ea_hasBinding;
      DAE.Type a_ty;
      Tpl.Text l_default__exp;
      Tpl.Text l_default__val;

    case ( txt,
           false,
           a_auxFunction,
           a_c,
           a_varDecls,
           a_ea_hasBinding,
           a_ty )
      equation
        l_default__val = typeDefaultValue(Tpl.emptyTxt, a_ty);
        l_default__exp = fun_425(Tpl.emptyTxt, a_ea_hasBinding, l_default__val);
        a_varDecls = extTypeF77(a_varDecls, a_ty, false);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(" "));
        a_varDecls = extVarName(a_varDecls, a_c);
        a_varDecls = Tpl.writeText(a_varDecls, l_default__exp);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(";"));
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_NEW_LINE());
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           _,
           a_auxFunction,
           a_c,
           a_varDecls,
           _,
           a_ty )
      equation
        a_varDecls = expTypeArrayIf(a_varDecls, a_ty);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(" "));
        a_varDecls = extVarName(a_varDecls, a_c);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(";"));
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_NEW_LINE());
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("convert_alloc_"));
        txt = expTypeArray(txt, a_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_to_f77(&"));
        (txt, a_auxFunction) = contextCrefNoPrevExp(txt, a_c, SimCodeFunction.contextFunction, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", &"));
        txt = extVarName(txt, a_c);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then (txt, a_auxFunction, a_varDecls);
  end match;
end fun_426;

protected function fun_427
  input Tpl.Text in_txt;
  input Integer in_a_oi;
  input Tpl.Text in_a_auxFunction;
  input DAE.ComponentRef in_a_c;
  input Tpl.Text in_a_varDecls;
  input Boolean in_a_ea_hasBinding;
  input DAE.Type in_a_ty;
  input Boolean in_a_ia;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_a_oi, in_a_auxFunction, in_a_c, in_a_varDecls, in_a_ea_hasBinding, in_a_ty, in_a_ia)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      DAE.ComponentRef a_c;
      Tpl.Text a_varDecls;
      Boolean a_ea_hasBinding;
      DAE.Type a_ty;
      Boolean a_ia;

    case ( txt,
           0,
           a_auxFunction,
           _,
           a_varDecls,
           _,
           _,
           _ )
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           _,
           a_auxFunction,
           a_c,
           a_varDecls,
           a_ea_hasBinding,
           a_ty,
           a_ia )
      equation
        (txt, a_auxFunction, a_varDecls) = fun_426(txt, a_ia, a_auxFunction, a_c, a_varDecls, a_ea_hasBinding, a_ty);
      then (txt, a_auxFunction, a_varDecls);
  end match;
end fun_427;

public function extFunCallVardeclF77
  input Tpl.Text in_txt;
  input SimCodeFunction.SimExtArg in_a_arg;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_arg, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      Boolean i_ea_hasBinding;
      Boolean i_ia;
      Integer i_oi;
      DAE.ComponentRef i_c;
      DAE.Type i_ty;

    case ( txt,
           SimCodeFunction.SIMEXTARG(isInput = true, isArray = true, type_ = i_ty, cref = i_c),
           a_varDecls,
           a_auxFunction )
      equation
        a_varDecls = expTypeArrayIf(a_varDecls, i_ty);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(" "));
        a_varDecls = extVarName(a_varDecls, i_c);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(";"));
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_NEW_LINE());
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("convert_alloc_"));
        txt = expTypeArray(txt, i_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_to_f77(&"));
        (txt, a_auxFunction) = contextCrefNoPrevExp(txt, i_c, SimCodeFunction.contextFunction, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", &"));
        txt = extVarName(txt, i_c);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           SimCodeFunction.SIMEXTARG(outputIndex = i_oi, isArray = i_ia, type_ = i_ty, cref = i_c, hasBinding = i_ea_hasBinding),
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_auxFunction, a_varDecls) = fun_427(txt, i_oi, a_auxFunction, i_c, a_varDecls, i_ea_hasBinding, i_ty, i_ia);
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           SimCodeFunction.SIMEXTARG(type_ = i_ty, cref = i_c),
           a_varDecls,
           a_auxFunction )
      equation
        a_varDecls = extTypeF77(a_varDecls, i_ty, false);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(" "));
        a_varDecls = extVarName(a_varDecls, i_c);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(";"));
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_NEW_LINE());
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           a_varDecls,
           a_auxFunction )
      then (txt, a_varDecls, a_auxFunction);
  end match;
end extFunCallVardeclF77;

public function boolStrC
  input Tpl.Text in_txt;
  input Boolean in_a_v;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_v)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("0"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("1"));
      then txt;
  end match;
end boolStrC;

public function typeDefaultValue
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty)
    local
      Tpl.Text txt;

    case ( txt,
           DAE.T_INTEGER(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("0"));
      then txt;

    case ( txt,
           DAE.T_REAL(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("0.0"));
      then txt;

    case ( txt,
           DAE.T_BOOL(varLst = _) )
      equation
        txt = boolStrC(txt, false);
      then txt;

    case ( txt,
           DAE.T_STRING(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("0"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end typeDefaultValue;

protected function fun_431
  input Tpl.Text in_txt;
  input Option<DAE.Exp> in_a_value;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_a_value, in_a_auxFunction, in_a_varDecls, in_a_preExp)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      DAE.Exp i_v;

    case ( txt,
           SOME(i_v),
           a_auxFunction,
           a_varDecls,
           a_preExp )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExp(txt, i_v, SimCodeFunction.contextFunction, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           _,
           a_auxFunction,
           a_varDecls,
           a_preExp )
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end fun_431;

protected function lm_432
  input Tpl.Text in_txt;
  input list<DAE.Dimension> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_preExp)
    local
      Tpl.Text txt;
      list<DAE.Dimension> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      DAE.Dimension i_dim;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_preExp )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           i_dim :: rest,
           a_auxFunction,
           a_varDecls,
           a_preExp )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(_index_t)"));
        (txt, a_preExp, a_varDecls, a_auxFunction) = dimension(txt, i_dim, SimCodeFunction.contextFunction, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_432(txt, rest, a_auxFunction, a_varDecls, a_preExp);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end lm_432;

protected function fun_433
  input Tpl.Text in_txt;
  input Tpl.Text in_a_defaultValue;
  input Tpl.Text in_a_var__name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_defaultValue, in_a_var__name)
    local
      Tpl.Text txt;
      Tpl.Text a_var__name;
      Tpl.Text i_defaultValue;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           _ )
      then txt;

    case ( txt,
           i_defaultValue,
           a_var__name )
      equation
        txt = Tpl.writeText(txt, a_var__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, i_defaultValue);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;
  end match;
end fun_433;

protected function fun_434
  input Tpl.Text in_txt;
  input Tpl.Text in_a_defaultValue;
  input Tpl.Text in_a_var__name;
  input Tpl.Text in_a_type;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_defaultValue, in_a_var__name, in_a_type)
    local
      Tpl.Text txt;
      Tpl.Text a_var__name;
      Tpl.Text a_type;
      Tpl.Text i_defaultValue;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           _,
           _ )
      then txt;

    case ( txt,
           i_defaultValue,
           a_var__name,
           a_type )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("copy_"));
        txt = Tpl.writeText(txt, a_type);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, i_defaultValue);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", &"));
        txt = Tpl.writeText(txt, a_var__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;
  end match;
end fun_434;

protected function fun_435
  input Tpl.Text in_txt;
  input list<DAE.Dimension> in_a_instDims;
  input Tpl.Text in_a_instDimsInit;
  input DAE.Type in_a_var_ty;
  input Tpl.Text in_a_var__name;
  input Tpl.Text in_a_defaultValue;
  input Tpl.Text in_a_preExp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_preExp) :=
  match(in_txt, in_a_instDims, in_a_instDimsInit, in_a_var_ty, in_a_var__name, in_a_defaultValue, in_a_preExp)
    local
      Tpl.Text txt;
      Tpl.Text a_instDimsInit;
      DAE.Type a_var_ty;
      Tpl.Text a_var__name;
      Tpl.Text a_defaultValue;
      Tpl.Text a_preExp;
      list<DAE.Dimension> i_instDims;
      Integer ret_1;
      Tpl.Text l_type;

    case ( txt,
           {},
           _,
           _,
           a_var__name,
           a_defaultValue,
           a_preExp )
      equation
        a_preExp = fun_433(a_preExp, a_defaultValue, a_var__name);
      then (txt, a_preExp);

    case ( txt,
           i_instDims,
           a_instDimsInit,
           a_var_ty,
           a_var__name,
           a_defaultValue,
           a_preExp )
      equation
        l_type = expTypeArray(Tpl.emptyTxt, a_var_ty);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("alloc_"));
        a_preExp = Tpl.writeText(a_preExp, l_type);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("(&"));
        a_preExp = Tpl.writeText(a_preExp, a_var__name);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        ret_1 = listLength(i_instDims);
        a_preExp = Tpl.writeStr(a_preExp, intString(ret_1));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, a_instDimsInit);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        a_preExp = fun_434(a_preExp, a_defaultValue, a_var__name, l_type);
      then (txt, a_preExp);
  end match;
end fun_435;

public function extFunCallBiVar
  input Tpl.Text in_txt;
  input SimCodeFunction.Variable in_a_var;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_var, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Type i_var_ty;
      list<DAE.Dimension> i_instDims;
      Option<DAE.Exp> i_value;
      SimCodeFunction.Variable i_var;
      DAE.ComponentRef i_name;
      Tpl.Text l_instDimsInit;
      Tpl.Text l_defaultValue;
      Tpl.Text l_var__name;

    case ( txt,
           (i_var as SimCodeFunction.VARIABLE(name = i_name, value = i_value, instDims = i_instDims, ty = i_var_ty)),
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_var__name, a_auxFunction) = contextCrefNoPrevExp(Tpl.emptyTxt, i_name, SimCodeFunction.contextFunction, a_auxFunction);
        a_varDecls = varType(a_varDecls, i_var);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(" "));
        a_varDecls = Tpl.writeText(a_varDecls, l_var__name);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(";"));
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_NEW_LINE());
        (l_defaultValue, a_auxFunction, a_varDecls, a_preExp) = fun_431(Tpl.emptyTxt, i_value, a_auxFunction, a_varDecls, a_preExp);
        l_instDimsInit = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_instDimsInit, a_auxFunction, a_varDecls, a_preExp) = lm_432(l_instDimsInit, i_instDims, a_auxFunction, a_varDecls, a_preExp);
        l_instDimsInit = Tpl.popIter(l_instDimsInit);
        (txt, a_preExp) = fun_435(txt, i_instDims, l_instDimsInit, i_var_ty, l_var__name, l_defaultValue, a_preExp);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end extFunCallBiVar;

protected function fun_437
  input Tpl.Text in_txt;
  input Option<DAE.Exp> in_a_value;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_a_value, in_a_auxFunction, in_a_varDecls, in_a_preExp)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      DAE.Exp i_v;

    case ( txt,
           SOME(i_v),
           a_auxFunction,
           a_varDecls,
           a_preExp )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExp(txt, i_v, SimCodeFunction.contextFunction, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           _,
           a_auxFunction,
           a_varDecls,
           a_preExp )
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end fun_437;

protected function lm_438
  input Tpl.Text in_txt;
  input list<DAE.Dimension> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_preExp)
    local
      Tpl.Text txt;
      list<DAE.Dimension> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      DAE.Dimension i_dim;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_preExp )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           i_dim :: rest,
           a_auxFunction,
           a_varDecls,
           a_preExp )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(_index_t)"));
        (txt, a_preExp, a_varDecls, a_auxFunction) = dimension(txt, i_dim, SimCodeFunction.contextFunction, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_438(txt, rest, a_auxFunction, a_varDecls, a_preExp);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end lm_438;

protected function fun_439
  input Tpl.Text in_txt;
  input Tpl.Text in_a_defaultValue;
  input Tpl.Text in_a_var__name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_defaultValue, in_a_var__name)
    local
      Tpl.Text txt;
      Tpl.Text a_var__name;
      Tpl.Text i_defaultValue;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           _ )
      then txt;

    case ( txt,
           i_defaultValue,
           a_var__name )
      equation
        txt = Tpl.writeText(txt, a_var__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, i_defaultValue);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;
  end match;
end fun_439;

protected function fun_440
  input Tpl.Text in_txt;
  input Tpl.Text in_a_defaultValue;
  input Tpl.Text in_a_var__name;
  input Tpl.Text in_a_type;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_defaultValue, in_a_var__name, in_a_type)
    local
      Tpl.Text txt;
      Tpl.Text a_var__name;
      Tpl.Text a_type;
      Tpl.Text i_defaultValue;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           _,
           _ )
      then txt;

    case ( txt,
           i_defaultValue,
           a_var__name,
           a_type )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("copy_"));
        txt = Tpl.writeText(txt, a_type);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, i_defaultValue);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", &"));
        txt = Tpl.writeText(txt, a_var__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;
  end match;
end fun_440;

protected function fun_441
  input Tpl.Text in_txt;
  input list<DAE.Dimension> in_a_instDims;
  input DAE.ComponentRef in_a_name;
  input Tpl.Text in_a_instDimsInit;
  input DAE.Type in_a_var_ty;
  input Tpl.Text in_a_var__name;
  input Tpl.Text in_a_defaultValue;
  input Tpl.Text in_a_preExp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_preExp) :=
  match(in_txt, in_a_instDims, in_a_name, in_a_instDimsInit, in_a_var_ty, in_a_var__name, in_a_defaultValue, in_a_preExp)
    local
      Tpl.Text txt;
      DAE.ComponentRef a_name;
      Tpl.Text a_instDimsInit;
      DAE.Type a_var_ty;
      Tpl.Text a_var__name;
      Tpl.Text a_defaultValue;
      Tpl.Text a_preExp;
      list<DAE.Dimension> i_instDims;
      Integer ret_1;
      Tpl.Text l_type;

    case ( txt,
           {},
           _,
           _,
           _,
           a_var__name,
           a_defaultValue,
           a_preExp )
      equation
        a_preExp = fun_439(a_preExp, a_defaultValue, a_var__name);
      then (txt, a_preExp);

    case ( txt,
           i_instDims,
           a_name,
           a_instDimsInit,
           a_var_ty,
           a_var__name,
           a_defaultValue,
           a_preExp )
      equation
        l_type = expTypeArray(Tpl.emptyTxt, a_var_ty);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("alloc_"));
        a_preExp = Tpl.writeText(a_preExp, l_type);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("(&"));
        a_preExp = Tpl.writeText(a_preExp, a_var__name);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        ret_1 = listLength(i_instDims);
        a_preExp = Tpl.writeStr(a_preExp, intString(ret_1));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, a_instDimsInit);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        a_preExp = fun_440(a_preExp, a_defaultValue, a_var__name, l_type);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("convert_alloc_"));
        a_preExp = Tpl.writeText(a_preExp, l_type);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("_to_f77(&"));
        a_preExp = Tpl.writeText(a_preExp, a_var__name);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", &"));
        a_preExp = extVarName(a_preExp, a_name);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
      then (txt, a_preExp);
  end match;
end fun_441;

public function extFunCallBiVarF77
  input Tpl.Text in_txt;
  input SimCodeFunction.Variable in_a_var;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_var, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Type i_var_ty;
      list<DAE.Dimension> i_instDims;
      Option<DAE.Exp> i_value;
      SimCodeFunction.Variable i_var;
      DAE.ComponentRef i_name;
      Tpl.Text l_instDimsInit;
      Tpl.Text l_defaultValue;
      Tpl.Text l_var__name;

    case ( txt,
           (i_var as SimCodeFunction.VARIABLE(name = i_name, value = i_value, instDims = i_instDims, ty = i_var_ty)),
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_var__name, a_auxFunction) = contextCrefNoPrevExp(Tpl.emptyTxt, i_name, SimCodeFunction.contextFunction, a_auxFunction);
        a_varDecls = varType(a_varDecls, i_var);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(" "));
        a_varDecls = Tpl.writeText(a_varDecls, l_var__name);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(";"));
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_NEW_LINE());
        a_varDecls = varType(a_varDecls, i_var);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(" "));
        a_varDecls = extVarName(a_varDecls, i_name);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(";"));
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_NEW_LINE());
        (l_defaultValue, a_auxFunction, a_varDecls, a_preExp) = fun_437(Tpl.emptyTxt, i_value, a_auxFunction, a_varDecls, a_preExp);
        l_instDimsInit = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_instDimsInit, a_auxFunction, a_varDecls, a_preExp) = lm_438(l_instDimsInit, i_instDims, a_auxFunction, a_varDecls, a_preExp);
        l_instDimsInit = Tpl.popIter(l_instDimsInit);
        (txt, a_preExp) = fun_441(txt, i_instDims, i_name, l_instDimsInit, i_var_ty, l_var__name, l_defaultValue, a_preExp);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end extFunCallBiVarF77;

protected function fun_443
  input Tpl.Text in_txt;
  input Boolean in_a_isInput;
  input Tpl.Text in_a_var__name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_isInput, in_a_var__name)
    local
      Tpl.Text txt;
      Tpl.Text a_var__name;

    case ( txt,
           false,
           a_var__name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("unpack_integer_array(&"));
        txt = Tpl.writeText(txt, a_var__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;

    case ( txt,
           _,
           a_var__name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("unpack_copy_integer_array(&"));
        txt = Tpl.writeText(txt, a_var__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_packed, &"));
        txt = Tpl.writeText(txt, a_var__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;
  end match;
end fun_443;

protected function fun_444
  input Tpl.Text in_txt;
  input String in_mArg;
  input Tpl.Text in_a_var__name;
  input Boolean in_a_isInput;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_var__name, in_a_isInput)
    local
      Tpl.Text txt;
      Tpl.Text a_var__name;
      Boolean a_isInput;

    case ( txt,
           "integer",
           a_var__name,
           a_isInput )
      equation
        txt = fun_443(txt, a_isInput, a_var__name);
      then txt;

    case ( txt,
           "string",
           a_var__name,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("unpack_string_array(&"));
        txt = Tpl.writeText(txt, a_var__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_var__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_c89);"));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_444;

protected function fun_445
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;
  input Tpl.Text in_a_cr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty, in_a_cr)
    local
      Tpl.Text txt;
      Tpl.Text a_cr;

    case ( txt,
           DAE.T_STRING(varLst = _),
           a_cr )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("mmc_mk_scon("));
        txt = Tpl.writeText(txt, a_cr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           _,
           a_cr )
      equation
        txt = Tpl.writeText(txt, a_cr);
      then txt;
  end match;
end fun_445;

public function extFunCallVarcopy
  input Tpl.Text in_txt;
  input SimCodeFunction.SimExtArg in_a_arg;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_auxFunction) :=
  match(in_txt, in_a_arg, in_a_auxFunction)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Boolean i_isInput;
      DAE.Type i_ty;
      DAE.ComponentRef i_c;
      Tpl.Text l_cr;
      String str_2;
      Tpl.Text txt_1;
      Tpl.Text l_var__name;

    case ( txt,
           SimCodeFunction.SIMEXTARG(outputIndex = 0),
           a_auxFunction )
      then (txt, a_auxFunction);

    case ( txt,
           SimCodeFunction.SIMEXTARG(outputIndex = _, isInput = i_isInput, isArray = true, cref = i_c, type_ = i_ty),
           a_auxFunction )
      equation
        (l_var__name, a_auxFunction) = contextCrefNoPrevExp(Tpl.emptyTxt, i_c, SimCodeFunction.contextFunction, a_auxFunction);
        txt_1 = expTypeShort(Tpl.emptyTxt, i_ty);
        str_2 = Tpl.textString(txt_1);
        txt = fun_444(txt, str_2, l_var__name, i_isInput);
      then (txt, a_auxFunction);

    case ( txt,
           SimCodeFunction.SIMEXTARG(outputIndex = _, isArray = false, type_ = i_ty, cref = i_c),
           a_auxFunction )
      equation
        l_cr = extVarName(Tpl.emptyTxt, i_c);
        (txt, a_auxFunction) = contextCrefNoPrevExp(txt, i_c, SimCodeFunction.contextFunction, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = ("));
        txt = expTypeModelica(txt, i_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
        txt = fun_445(txt, i_ty, l_cr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then (txt, a_auxFunction);

    case ( txt,
           _,
           a_auxFunction )
      then (txt, a_auxFunction);
  end match;
end extFunCallVarcopy;

protected function fun_447
  input Tpl.Text in_txt;
  input Boolean in_a_ai;
  input Tpl.Text in_a_ext__name;
  input DAE.Type in_a_ty;
  input Tpl.Text in_a_outarg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ai, in_a_ext__name, in_a_ty, in_a_outarg)
    local
      Tpl.Text txt;
      Tpl.Text a_ext__name;
      DAE.Type a_ty;
      Tpl.Text a_outarg;

    case ( txt,
           false,
           a_ext__name,
           a_ty,
           a_outarg )
      equation
        txt = Tpl.writeText(txt, a_outarg);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = ("));
        txt = expTypeModelica(txt, a_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
        txt = Tpl.writeText(txt, a_ext__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           true,
           a_ext__name,
           a_ty,
           a_outarg )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("convert_alloc_"));
        txt = expTypeArray(txt, a_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_from_f77(&"));
        txt = Tpl.writeText(txt, a_ext__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", &"));
        txt = Tpl.writeText(txt, a_outarg);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;

    case ( txt,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_447;

protected function fun_448
  input Tpl.Text in_txt;
  input Integer in_a_oi;
  input DAE.Type in_a_ty;
  input Boolean in_a_ai;
  input Tpl.Text in_a_auxFunction;
  input DAE.ComponentRef in_a_c;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_auxFunction) :=
  match(in_txt, in_a_oi, in_a_ty, in_a_ai, in_a_auxFunction, in_a_c)
    local
      Tpl.Text txt;
      DAE.Type a_ty;
      Boolean a_ai;
      Tpl.Text a_auxFunction;
      DAE.ComponentRef a_c;
      Tpl.Text l_ext__name;
      Tpl.Text l_outarg;

    case ( txt,
           0,
           _,
           _,
           a_auxFunction,
           _ )
      then (txt, a_auxFunction);

    case ( txt,
           _,
           a_ty,
           a_ai,
           a_auxFunction,
           a_c )
      equation
        (l_outarg, a_auxFunction) = contextCrefNoPrevExp(Tpl.emptyTxt, a_c, SimCodeFunction.contextFunction, a_auxFunction);
        l_ext__name = extVarName(Tpl.emptyTxt, a_c);
        txt = fun_447(txt, a_ai, l_ext__name, a_ty, l_outarg);
      then (txt, a_auxFunction);
  end match;
end fun_448;

public function extFunCallVarcopyF77
  input Tpl.Text in_txt;
  input SimCodeFunction.SimExtArg in_a_arg;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_auxFunction) :=
  match(in_txt, in_a_arg, in_a_auxFunction)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      DAE.Type i_ty;
      Boolean i_ai;
      DAE.ComponentRef i_c;
      Integer i_oi;

    case ( txt,
           SimCodeFunction.SIMEXTARG(outputIndex = i_oi, isArray = i_ai, type_ = i_ty, cref = i_c),
           a_auxFunction )
      equation
        (txt, a_auxFunction) = fun_448(txt, i_oi, i_ty, i_ai, a_auxFunction, i_c);
      then (txt, a_auxFunction);

    case ( txt,
           _,
           a_auxFunction )
      then (txt, a_auxFunction);
  end match;
end extFunCallVarcopyF77;

protected function fun_450
  input Tpl.Text in_txt;
  input String in_mArg;
  input Tpl.Text in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_name)
    local
      Tpl.Text txt;
      Tpl.Text a_name;

    case ( txt,
           "integer",
           a_name )
      equation
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_packed"));
      then txt;

    case ( txt,
           _,
           a_name )
      equation
        txt = Tpl.writeText(txt, a_name);
      then txt;
  end match;
end fun_450;

protected function fun_451
  input Tpl.Text in_txt;
  input Boolean in_a_isInput;
  input Tpl.Text in_a_shortTypeStr;
  input Tpl.Text in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_isInput, in_a_shortTypeStr, in_a_name)
    local
      Tpl.Text txt;
      Tpl.Text a_shortTypeStr;
      Tpl.Text a_name;
      String str_0;

    case ( txt,
           false,
           _,
           a_name )
      equation
        txt = Tpl.writeText(txt, a_name);
      then txt;

    case ( txt,
           _,
           a_shortTypeStr,
           a_name )
      equation
        str_0 = Tpl.textString(a_shortTypeStr);
        txt = fun_450(txt, str_0, a_name);
      then txt;
  end match;
end fun_451;

protected function fun_452
  input Tpl.Text in_txt;
  input DAE.Type in_a_t;
  input Tpl.Text in_a_auxFunction;
  input DAE.ComponentRef in_a_c;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_auxFunction) :=
  match(in_txt, in_a_t, in_a_auxFunction, in_a_c)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      DAE.ComponentRef a_c;

    case ( txt,
           DAE.T_STRING(varLst = _),
           a_auxFunction,
           a_c )
      equation
        (txt, a_auxFunction) = contextCrefNoPrevExp(txt, a_c, SimCodeFunction.contextFunction, a_auxFunction);
      then (txt, a_auxFunction);

    case ( txt,
           _,
           a_auxFunction,
           a_c )
      equation
        txt = extVarName(txt, a_c);
      then (txt, a_auxFunction);
  end match;
end fun_452;

protected function fun_453
  input Tpl.Text in_txt;
  input DAE.Type in_a_t;
  input Tpl.Text in_a_cr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_t, in_a_cr)
    local
      Tpl.Text txt;
      Tpl.Text a_cr;

    case ( txt,
           DAE.T_STRING(varLst = _),
           a_cr )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("MMC_STRINGDATA("));
        txt = Tpl.writeText(txt, a_cr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           _,
           a_cr )
      equation
        txt = Tpl.writeText(txt, a_cr);
      then txt;
  end match;
end fun_453;

public function extArg
  input Tpl.Text in_txt;
  input SimCodeFunction.SimExtArg in_a_extArg;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_extArg, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Type i_type__;
      DAE.Exp i_exp;
      Boolean i_isInput;
      DAE.Type i_t;
      DAE.ComponentRef i_c;
      Tpl.Text l_dim;
      Tpl.Text l_typeStr;
      Tpl.Text l_cr;
      Tpl.Text l_arg__name;
      Tpl.Text l_shortTypeStr;
      Tpl.Text l_name;

    case ( txt,
           SimCodeFunction.SIMEXTARG(cref = i_c, outputIndex = _, isArray = true, type_ = i_t, isInput = i_isInput),
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_name, a_auxFunction) = contextCrefNoPrevExp(Tpl.emptyTxt, i_c, SimCodeFunction.contextFunction, a_auxFunction);
        l_shortTypeStr = expTypeShort(Tpl.emptyTxt, i_t);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING("void *"));
        a_varDecls = Tpl.writeText(a_varDecls, l_name);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING("_c89;"));
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_NEW_LINE());
        l_arg__name = fun_451(Tpl.emptyTxt, i_isInput, l_shortTypeStr, l_name);
        a_preExp = Tpl.writeText(a_preExp, l_name);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("_c89 = (void*) data_of_"));
        a_preExp = Tpl.writeText(a_preExp, l_shortTypeStr);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("_c89_array(&("));
        a_preExp = Tpl.writeText(a_preExp, l_arg__name);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("));"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = extType(txt, i_t, i_isInput, true, false);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") "));
        txt = Tpl.writeText(txt, l_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_c89"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           SimCodeFunction.SIMEXTARG(cref = i_c, isInput = _, outputIndex = 0, type_ = i_t),
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_cr, a_auxFunction) = fun_452(Tpl.emptyTxt, i_t, a_auxFunction, i_c);
        txt = fun_453(txt, i_t, l_cr);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           SimCodeFunction.SIMEXTARG(cref = i_c, isInput = _, outputIndex = _, type_ = _),
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("&"));
        txt = extVarName(txt, i_c);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           SimCodeFunction.SIMEXTARGEXP(exp = i_exp),
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExternalCExp(txt, i_exp, SimCodeFunction.contextFunction, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           SimCodeFunction.SIMEXTARGSIZE(cref = i_c, type_ = i_type__, exp = i_exp),
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        l_typeStr = expTypeShort(Tpl.emptyTxt, i_type__);
        (l_name, a_auxFunction) = contextCrefNoPrevExp(Tpl.emptyTxt, i_c, SimCodeFunction.contextFunction, a_auxFunction);
        (l_dim, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_exp, SimCodeFunction.contextFunction, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("size_of_dimension_base_array("));
        txt = Tpl.writeText(txt, l_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, l_dim);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end extArg;

protected function fun_455
  input Tpl.Text in_txt;
  input Integer in_a_oi;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_oi)
    local
      Tpl.Text txt;

    case ( txt,
           0 )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_ext"));
      then txt;
  end match;
end fun_455;

protected function fun_456
  input Tpl.Text in_txt;
  input Integer in_a_oi;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_oi)
    local
      Tpl.Text txt;

    case ( txt,
           0 )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_ext"));
      then txt;
  end match;
end fun_456;

public function extArgF77
  input Tpl.Text in_txt;
  input SimCodeFunction.SimExtArg in_a_extArg;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_extArg, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Exp i_exp;
      Integer i_oi;
      DAE.ComponentRef i_c;
      DAE.Type i_t;
      Tpl.Text l_dim;
      Tpl.Text l_sizeVar;
      Tpl.Text l_sizeVarName;
      Tpl.Text txt_5;
      Tpl.Text l_tvar;
      Tpl.Text l_texp;
      DAE.ComponentRef ret_2;
      DAE.ComponentRef ret_1;
      Tpl.Text l_suffix;

    case ( txt,
           SimCodeFunction.SIMEXTARG(cref = i_c, isArray = true, type_ = i_t),
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("data_of_"));
        txt = expTypeShort(txt, i_t);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_f77_array(&("));
        txt = extVarName(txt, i_c);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("))"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           SimCodeFunction.SIMEXTARG(cref = i_c, outputIndex = i_oi, type_ = DAE.T_INTEGER(varLst = _)),
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        l_suffix = fun_455(Tpl.emptyTxt, i_oi);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(int*) &"));
        ret_1 = ComponentReference.appendStringFirstIdent(Tpl.textString(l_suffix), i_c);
        (txt, a_auxFunction) = contextCrefNoPrevExp(txt, ret_1, SimCodeFunction.contextFunction, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           SimCodeFunction.SIMEXTARG(cref = i_c, outputIndex = _, type_ = DAE.T_STRING(varLst = _)),
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(char*)MMC_STRINGDATA("));
        (txt, a_auxFunction) = contextCrefNoPrevExp(txt, i_c, SimCodeFunction.contextFunction, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           SimCodeFunction.SIMEXTARG(cref = i_c, outputIndex = i_oi, type_ = _),
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        l_suffix = fun_456(Tpl.emptyTxt, i_oi);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("&"));
        ret_2 = ComponentReference.appendStringFirstIdent(Tpl.textString(l_suffix), i_c);
        (txt, a_auxFunction) = contextCrefNoPrevExp(txt, ret_2, SimCodeFunction.contextFunction, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           SimCodeFunction.SIMEXTARGEXP(exp = i_exp, type_ = DAE.T_STRING(varLst = _)),
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_texp, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_exp, SimCodeFunction.contextFunction, a_preExp, a_varDecls, a_auxFunction);
        txt_5 = expTypeFromExpFlag(Tpl.emptyTxt, i_exp, 8);
        (l_tvar, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(txt_5), a_varDecls);
        a_preExp = Tpl.writeText(a_preExp, l_tvar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = "));
        a_preExp = Tpl.writeText(a_preExp, l_texp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(";"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(char*)MMC_STRINGDATA("));
        txt = Tpl.writeText(txt, l_tvar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           SimCodeFunction.SIMEXTARGEXP(exp = i_exp),
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExternalF77Exp(txt, i_exp, SimCodeFunction.contextFunction, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           SimCodeFunction.SIMEXTARGSIZE(cref = i_c, exp = i_exp),
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_sizeVarName, a_auxFunction) = tempSizeVarName(Tpl.emptyTxt, i_c, i_exp, a_auxFunction);
        (l_sizeVar, a_varDecls) = tempDecl(Tpl.emptyTxt, "int", a_varDecls);
        (l_dim, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_exp, SimCodeFunction.contextFunction, a_preExp, a_varDecls, a_auxFunction);
        a_preExp = Tpl.writeText(a_preExp, l_sizeVar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = size_of_dimension_base_array("));
        (a_preExp, a_auxFunction) = contextCrefNoPrevExp(a_preExp, i_c, SimCodeFunction.contextFunction, a_auxFunction);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, l_dim);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("&"));
        txt = Tpl.writeText(txt, l_sizeVar);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end extArgF77;

protected function fun_458
  input Tpl.Text in_txt;
  input DAE.Exp in_a_indices;
  input DAE.ComponentRef in_a_c;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_auxFunction) :=
  match(in_txt, in_a_indices, in_a_c, in_a_auxFunction)
    local
      Tpl.Text txt;
      DAE.ComponentRef a_c;
      Tpl.Text a_auxFunction;
      Integer i_integer;

    case ( txt,
           DAE.ICONST(integer = i_integer),
           a_c,
           a_auxFunction )
      equation
        (txt, a_auxFunction) = contextCrefNoPrevExp(txt, a_c, SimCodeFunction.contextFunction, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_size_"));
        txt = Tpl.writeStr(txt, intString(i_integer));
      then (txt, a_auxFunction);

    case ( txt,
           _,
           _,
           a_auxFunction )
      equation
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 2670, 14), "tempSizeVarName:UNHANDLED_EXPRESSION");
      then (txt, a_auxFunction);
  end match;
end fun_458;

public function tempSizeVarName
  input Tpl.Text txt;
  input DAE.ComponentRef a_c;
  input DAE.Exp a_indices;
  input Tpl.Text a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_auxFunction) := fun_458(txt, a_indices, a_c, a_auxFunction);
end tempSizeVarName;

protected function lm_460
  input Tpl.Text in_txt;
  input list<DAE.Statement> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls)
    local
      Tpl.Text txt;
      list<DAE.Statement> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      DAE.Statement i_stmt;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls )
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           i_stmt :: rest,
           a_auxFunction,
           a_varDecls )
      equation
        (txt, a_varDecls, a_auxFunction) = algStatement(txt, i_stmt, SimCodeFunction.contextFunction, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls) = lm_460(txt, rest, a_auxFunction, a_varDecls);
      then (txt, a_auxFunction, a_varDecls);
  end match;
end lm_460;

public function funStatement
  input Tpl.Text txt;
  input list<DAE.Statement> a_statementLst;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  out_txt := Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (out_txt, out_a_auxFunction, out_a_varDecls) := lm_460(out_txt, a_statementLst, a_auxFunction, a_varDecls);
  out_txt := Tpl.popIter(out_txt);
end funStatement;

protected function lm_462
  input Tpl.Text in_txt;
  input list<DAE.Statement> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls)
    local
      Tpl.Text txt;
      list<DAE.Statement> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      DAE.Statement i_stmt;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls )
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           i_stmt :: rest,
           a_auxFunction,
           a_varDecls )
      equation
        (txt, a_varDecls, a_auxFunction) = algStatement(txt, i_stmt, SimCodeFunction.contextParallelFunction, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls) = lm_462(txt, rest, a_auxFunction, a_varDecls);
      then (txt, a_auxFunction, a_varDecls);
  end match;
end lm_462;

public function parModelicafunStatement
  input Tpl.Text txt;
  input list<DAE.Statement> a_statementLst;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  out_txt := Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (out_txt, out_a_auxFunction, out_a_varDecls) := lm_462(out_txt, a_statementLst, a_auxFunction, a_varDecls);
  out_txt := Tpl.popIter(out_txt);
end parModelicafunStatement;

protected function lm_464
  input Tpl.Text in_txt;
  input list<DAE.Statement> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls)
    local
      Tpl.Text txt;
      list<DAE.Statement> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      DAE.Statement i_stmt;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls )
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           i_stmt :: rest,
           a_auxFunction,
           a_varDecls )
      equation
        (txt, a_varDecls, a_auxFunction) = extractParFors_impl(txt, i_stmt, SimCodeFunction.contextParallelFunction, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls) = lm_464(txt, rest, a_auxFunction, a_varDecls);
      then (txt, a_auxFunction, a_varDecls);
  end match;
end lm_464;

public function extractParFors
  input Tpl.Text txt;
  input list<DAE.Statement> a_statementLst;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  out_txt := Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (out_txt, out_a_auxFunction, out_a_varDecls) := lm_464(out_txt, a_statementLst, a_auxFunction, a_varDecls);
  out_txt := Tpl.popIter(out_txt);
end extractParFors;

protected function fun_466
  input Tpl.Text in_txt;
  input DAE.Statement in_a_stmt;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_stmt, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Statement i_s;

    case ( txt,
           (i_s as DAE.STMT_PARFOR(type_ = _)),
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_varDecls, a_auxFunction) = algStmtParForBody(txt, i_s, SimCodeFunction.contextParallelFunction, a_varDecls, a_auxFunction);
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           a_varDecls,
           a_auxFunction )
      then (txt, a_varDecls, a_auxFunction);
  end match;
end fun_466;

public function extractParFors_impl
  input Tpl.Text txt;
  input DAE.Statement a_stmt;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) := fun_466(txt, a_stmt, a_varDecls, a_auxFunction);
end extractParFors_impl;

protected function fun_468
  input Tpl.Text in_txt;
  input DAE.Statement in_a_stmt;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_a_stmt, in_a_auxFunction, in_a_varDecls, in_a_context)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      SimCodeFunction.Context a_context;
      DAE.Statement i_s;

    case ( txt,
           (i_s as DAE.STMT_ASSIGN(exp1 = DAE.PATTERN(pattern = _))),
           a_auxFunction,
           a_varDecls,
           a_context )
      equation
        (txt, a_varDecls, a_auxFunction) = algStmtAssignPattern(txt, i_s, a_context, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           (i_s as DAE.STMT_ASSIGN(type_ = _)),
           a_auxFunction,
           a_varDecls,
           a_context )
      equation
        (txt, a_varDecls, a_auxFunction) = algStmtAssign(txt, i_s, a_context, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           (i_s as DAE.STMT_ASSIGN_ARR(type_ = _)),
           a_auxFunction,
           a_varDecls,
           a_context )
      equation
        (txt, a_varDecls, a_auxFunction) = algStmtAssignArr(txt, i_s, a_context, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           (i_s as DAE.STMT_TUPLE_ASSIGN(type_ = _)),
           a_auxFunction,
           a_varDecls,
           a_context )
      equation
        (txt, a_varDecls, a_auxFunction) = algStmtTupleAssign(txt, i_s, a_context, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           (i_s as DAE.STMT_IF(exp = _)),
           a_auxFunction,
           a_varDecls,
           a_context )
      equation
        (txt, a_varDecls, a_auxFunction) = algStmtIf(txt, i_s, a_context, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           (i_s as DAE.STMT_FOR(type_ = _)),
           a_auxFunction,
           a_varDecls,
           a_context )
      equation
        (txt, a_varDecls, a_auxFunction) = algStmtFor(txt, i_s, a_context, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           (i_s as DAE.STMT_PARFOR(type_ = _)),
           a_auxFunction,
           a_varDecls,
           a_context )
      equation
        (txt, a_varDecls, a_auxFunction) = algStmtParForInterface(txt, i_s, a_context, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           (i_s as DAE.STMT_WHILE(exp = _)),
           a_auxFunction,
           a_varDecls,
           a_context )
      equation
        (txt, a_varDecls, a_auxFunction) = algStmtWhile(txt, i_s, a_context, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           (i_s as DAE.STMT_ASSERT(cond = _)),
           a_auxFunction,
           a_varDecls,
           a_context )
      equation
        (txt, a_varDecls, a_auxFunction) = algStmtAssert(txt, i_s, a_context, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           (i_s as DAE.STMT_TERMINATE(msg = _)),
           a_auxFunction,
           a_varDecls,
           a_context )
      equation
        (txt, a_varDecls, a_auxFunction) = algStmtTerminate(txt, i_s, a_context, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           (i_s as DAE.STMT_WHEN(exp = _)),
           a_auxFunction,
           a_varDecls,
           a_context )
      equation
        (txt, a_varDecls, a_auxFunction) = algStmtWhen(txt, i_s, a_context, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           DAE.STMT_BREAK(source = _),
           a_auxFunction,
           a_varDecls,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("break;"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           DAE.STMT_CONTINUE(source = _),
           a_auxFunction,
           a_varDecls,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("continue;"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           (i_s as DAE.STMT_FAILURE(body = _)),
           a_auxFunction,
           a_varDecls,
           a_context )
      equation
        (txt, a_varDecls, a_auxFunction) = algStmtFailure(txt, i_s, a_context, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           DAE.STMT_RETURN(source = _),
           a_auxFunction,
           a_varDecls,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("goto _return;"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           (i_s as DAE.STMT_NORETCALL(exp = _)),
           a_auxFunction,
           a_varDecls,
           a_context )
      equation
        (txt, a_varDecls, a_auxFunction) = algStmtNoretcall(txt, i_s, a_context, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           (i_s as DAE.STMT_REINIT(var = _)),
           a_auxFunction,
           a_varDecls,
           a_context )
      equation
        (txt, a_varDecls, a_auxFunction) = algStmtReinit(txt, i_s, a_context, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           _,
           a_auxFunction,
           a_varDecls,
           _ )
      equation
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 2727, 14), "ALG_STATEMENT NYI");
      then (txt, a_auxFunction, a_varDecls);
  end match;
end fun_468;

protected function fun_469
  input Tpl.Text in_txt;
  input Integer in_mArg;
  input DAE.Statement in_a_stmt;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_mArg, in_a_stmt, in_a_context, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      DAE.Statement a_stmt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      Integer i_oldIndex;
      SourceInfo ret_2;
      DAE.ElementSource ret_1;
      Tpl.Text l_res;

    case ( txt,
           i_oldIndex,
           a_stmt,
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        (l_res, a_auxFunction, a_varDecls) = fun_468(Tpl.emptyTxt, a_stmt, a_auxFunction, a_varDecls, a_context);
        System.tmpTickSetIndex(i_oldIndex, 1);
        ret_1 = Algorithm.getStatementSource(a_stmt);
        ret_2 = ElementSource.getElementSourceFileInfo(ret_1);
        txt = modelicaLine(txt, ret_2);
        txt = Tpl.writeText(txt, l_res);
        txt = Tpl.softNewLine(txt);
        txt = endModelicaLine(txt);
      then (txt, a_varDecls, a_auxFunction);
  end match;
end fun_469;

public function algStatement
  input Tpl.Text txt;
  input DAE.Statement a_stmt;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
protected
  Integer ret_0;
algorithm
  ret_0 := System.tmpTickIndexReserve(1, 0);
  (out_txt, out_a_varDecls, out_a_auxFunction) := fun_469(txt, ret_0, a_stmt, a_context, a_varDecls, a_auxFunction);
end algStatement;

protected function fun_471
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp1;
  input DAE.Exp in_a_val;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_a_exp1, in_a_val, in_a_auxFunction, in_a_varDecls, in_a_context)
    local
      Tpl.Text txt;
      DAE.Exp a_val;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      SimCodeFunction.Context a_context;
      DAE.Exp i_idx;
      DAE.Exp i_arr;
      Tpl.Text l_val1;
      Tpl.Text l_idx1;
      Tpl.Text l_arr1;
      Tpl.Text l_preExp;

    case ( txt,
           DAE.ASUB(exp = i_arr, sub = {i_idx}),
           a_val,
           a_auxFunction,
           a_varDecls,
           a_context )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_arr1, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_arr, a_context, l_preExp, a_varDecls, a_auxFunction);
        (l_idx1, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_idx, a_context, l_preExp, a_varDecls, a_auxFunction);
        (l_val1, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, a_val, a_context, l_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("arrayUpdate("));
        txt = Tpl.writeText(txt, l_arr1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, l_idx1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, l_val1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           _,
           _,
           a_auxFunction,
           a_varDecls,
           _ )
      then (txt, a_auxFunction, a_varDecls);
  end match;
end fun_471;

protected function fun_472
  input Tpl.Text in_txt;
  input String in_mArg;
  input DAE.Exp in_a_val;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input SimCodeFunction.Context in_a_context;
  input DAE.Exp in_a_exp1;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_mArg, in_a_val, in_a_auxFunction, in_a_varDecls, in_a_context, in_a_exp1)
    local
      Tpl.Text txt;
      DAE.Exp a_val;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      SimCodeFunction.Context a_context;
      DAE.Exp a_exp1;
      Tpl.Text l_expPart;
      Tpl.Text l_varPart;
      Tpl.Text l_preExp;

    case ( txt,
           "metatype",
           a_val,
           a_auxFunction,
           a_varDecls,
           a_context,
           a_exp1 )
      equation
        (txt, a_auxFunction, a_varDecls) = fun_471(txt, a_exp1, a_val, a_auxFunction, a_varDecls, a_context);
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           _,
           a_val,
           a_auxFunction,
           a_varDecls,
           a_context,
           a_exp1 )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_varPart, l_preExp, a_varDecls, a_auxFunction) = daeExpAsub(Tpl.emptyTxt, a_exp1, a_context, l_preExp, a_varDecls, a_auxFunction);
        (l_expPart, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, a_val, a_context, l_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_varPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, l_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then (txt, a_auxFunction, a_varDecls);
  end match;
end fun_472;

public function algStmtAssign
  input Tpl.Text in_txt;
  input DAE.Statement in_a_stmt;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_stmt, in_a_context, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Statement i_stmt;
      DAE.Exp i_val;
      DAE.Exp i_exp1;
      DAE.Ident i_fieldName_1;
      String i_fieldName;
      DAE.Type i_t1;
      DAE.Exp i_exp;
      DAE.Exp i_explhs;
      DAE.Exp i_e;
      Tpl.Text l_expPart2;
      Tpl.Text l_expPart1;
      Tpl.Text l_copy__stmt;
      String str_32;
      Tpl.Text txt_31;
      Tpl.Text txt_30;
      Integer ret_29;
      Integer ret_28;
      list<DAE.Var> ret_27;
      Integer ret_26;
      Integer ret_25;
      list<DAE.Var> ret_24;
      Integer ret_23;
      Integer ret_22;
      list<DAE.Var> ret_21;
      Integer ret_20;
      Integer ret_19;
      list<DAE.Var> ret_18;
      Integer ret_17;
      Integer ret_16;
      list<DAE.Var> ret_15;
      Integer ret_14;
      Integer ret_13;
      list<DAE.Var> ret_12;
      Integer ret_11;
      Integer ret_10;
      list<DAE.Var> ret_9;
      Tpl.Text l_len;
      Integer ret_7;
      Integer ret_6;
      list<DAE.Var> ret_5;
      Tpl.Text l_indexInRecord;
      Tpl.Text l_varPart;
      Tpl.Text l_tmp;
      Tpl.Text l_expPart;
      Tpl.Text l_preExp;

    case ( txt,
           DAE.STMT_ASSIGN(exp = DAE.CALL(path = Absyn.IDENT(name = "fail"))),
           _,
           a_varDecls,
           a_auxFunction )
      equation
        txt = generateThrow(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.STMT_ASSIGN(exp1 = DAE.CREF(componentRef = DAE.WILD()), exp = i_e),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_expPart, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e, a_context, l_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeText(txt, l_preExp);
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.STMT_ASSIGN(exp1 = DAE.RSUB(exp = (i_explhs as DAE.CREF(ty = (i_t1 as DAE.T_METARECORD(path = _)))), fieldName = i_fieldName), exp = i_exp),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_tmp, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_metatype", a_varDecls);
        (l_varPart, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_explhs, a_context, l_preExp, a_varDecls, a_auxFunction);
        (l_expPart, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_exp, a_context, l_preExp, a_varDecls, a_auxFunction);
        ret_5 = Types.getMetaRecordFields(i_t1);
        ret_6 = Types.lookupIndexInMetaRecord(ret_5, i_fieldName);
        ret_7 = intAdd(1, ret_6);
        l_indexInRecord = Tpl.writeStr(Tpl.emptyTxt, intString(ret_7));
        ret_9 = Types.getMetaRecordFields(i_t1);
        ret_10 = listLength(ret_9);
        ret_11 = intAdd(2, ret_10);
        l_len = Tpl.writeStr(Tpl.emptyTxt, intString(ret_11));
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = MMC_TAGPTR(mmc_alloc_words("));
        txt = Tpl.writeText(txt, l_len);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "));\n",
                                    "memcpy(MMC_UNTAGPTR("
                                }, false));
        txt = Tpl.writeText(txt, l_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("), MMC_UNTAGPTR("));
        txt = Tpl.writeText(txt, l_varPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("), "));
        txt = Tpl.writeText(txt, l_len);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "*sizeof(modelica_metatype));\n",
                                    "((modelica_metatype*)MMC_UNTAGPTR("
                                }, false));
        txt = Tpl.writeText(txt, l_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("))["));
        txt = Tpl.writeText(txt, l_indexInRecord);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = "));
        txt = Tpl.writeText(txt, l_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.writeText(txt, l_varPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, l_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.STMT_ASSIGN(exp1 = DAE.RSUB(exp = (i_explhs as DAE.CREF(ty = (i_t1 as DAE.T_METAUNIONTYPE(paths = _)))), fieldName = i_fieldName), exp = i_exp),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_tmp, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_metatype", a_varDecls);
        (l_varPart, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_explhs, a_context, l_preExp, a_varDecls, a_auxFunction);
        (l_expPart, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_exp, a_context, l_preExp, a_varDecls, a_auxFunction);
        ret_12 = Types.getMetaRecordFields(i_t1);
        ret_13 = Types.lookupIndexInMetaRecord(ret_12, i_fieldName);
        ret_14 = intAdd(1, ret_13);
        l_indexInRecord = Tpl.writeStr(Tpl.emptyTxt, intString(ret_14));
        ret_15 = Types.getMetaRecordFields(i_t1);
        ret_16 = listLength(ret_15);
        ret_17 = intAdd(2, ret_16);
        l_len = Tpl.writeStr(Tpl.emptyTxt, intString(ret_17));
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = MMC_TAGPTR(mmc_alloc_words("));
        txt = Tpl.writeText(txt, l_len);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "));\n",
                                    "memcpy(MMC_UNTAGPTR("
                                }, false));
        txt = Tpl.writeText(txt, l_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("), MMC_UNTAGPTR("));
        txt = Tpl.writeText(txt, l_varPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("), "));
        txt = Tpl.writeText(txt, l_len);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "*sizeof(modelica_metatype));\n",
                                    "((modelica_metatype*)MMC_UNTAGPTR("
                                }, false));
        txt = Tpl.writeText(txt, l_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("))["));
        txt = Tpl.writeText(txt, l_indexInRecord);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = "));
        txt = Tpl.writeText(txt, l_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.writeText(txt, l_varPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, l_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.STMT_ASSIGN(exp1 = (i_explhs as DAE.CREF(componentRef = DAE.CREF_QUAL(identType = DAE.T_METATYPE(ty = (i_t1 as DAE.T_METAUNIONTYPE(paths = _))), componentRef = DAE.CREF_IDENT(ident = i_fieldName_1)), ty = _)), exp = i_exp),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_tmp, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_metatype", a_varDecls);
        (l_varPart, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_explhs, a_context, l_preExp, a_varDecls, a_auxFunction);
        (l_expPart, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_exp, a_context, l_preExp, a_varDecls, a_auxFunction);
        ret_18 = Types.getMetaRecordFields(i_t1);
        ret_19 = Types.lookupIndexInMetaRecord(ret_18, i_fieldName_1);
        ret_20 = intAdd(1, ret_19);
        l_indexInRecord = Tpl.writeStr(Tpl.emptyTxt, intString(ret_20));
        ret_21 = Types.getMetaRecordFields(i_t1);
        ret_22 = listLength(ret_21);
        ret_23 = intAdd(2, ret_22);
        l_len = Tpl.writeStr(Tpl.emptyTxt, intString(ret_23));
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = MMC_TAGPTR(mmc_alloc_words("));
        txt = Tpl.writeText(txt, l_len);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "));\n",
                                    "memcpy(MMC_UNTAGPTR("
                                }, false));
        txt = Tpl.writeText(txt, l_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("), MMC_UNTAGPTR("));
        txt = Tpl.writeText(txt, l_varPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("), "));
        txt = Tpl.writeText(txt, l_len);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "*sizeof(modelica_metatype));\n",
                                    "((modelica_metatype*)MMC_UNTAGPTR("
                                }, false));
        txt = Tpl.writeText(txt, l_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("))["));
        txt = Tpl.writeText(txt, l_indexInRecord);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = "));
        txt = Tpl.writeText(txt, l_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.writeText(txt, l_varPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, l_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.STMT_ASSIGN(exp1 = (i_explhs as DAE.CREF(componentRef = DAE.CREF_QUAL(identType = DAE.T_METATYPE(ty = (i_t1 as DAE.T_METARECORD(path = _))), componentRef = DAE.CREF_IDENT(ident = i_fieldName_1)), ty = _)), exp = i_exp),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_tmp, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_metatype", a_varDecls);
        (l_varPart, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_explhs, a_context, l_preExp, a_varDecls, a_auxFunction);
        (l_expPart, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_exp, a_context, l_preExp, a_varDecls, a_auxFunction);
        ret_24 = Types.getMetaRecordFields(i_t1);
        ret_25 = Types.lookupIndexInMetaRecord(ret_24, i_fieldName_1);
        ret_26 = intAdd(1, ret_25);
        l_indexInRecord = Tpl.writeStr(Tpl.emptyTxt, intString(ret_26));
        ret_27 = Types.getMetaRecordFields(i_t1);
        ret_28 = listLength(ret_27);
        ret_29 = intAdd(2, ret_28);
        l_len = Tpl.writeStr(Tpl.emptyTxt, intString(ret_29));
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = MMC_TAGPTR(mmc_alloc_words("));
        txt = Tpl.writeText(txt, l_len);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "));\n",
                                    "memcpy(MMC_UNTAGPTR("
                                }, false));
        txt = Tpl.writeText(txt, l_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("), MMC_UNTAGPTR("));
        txt = Tpl.writeText(txt, l_varPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("), "));
        txt = Tpl.writeText(txt, l_len);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "*sizeof(modelica_metatype));\n",
                                    "((modelica_metatype*)MMC_UNTAGPTR("
                                }, false));
        txt = Tpl.writeText(txt, l_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("))["));
        txt = Tpl.writeText(txt, l_indexInRecord);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = "));
        txt = Tpl.writeText(txt, l_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.writeText(txt, l_varPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, l_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.STMT_ASSIGN(exp1 = (i_exp1 as DAE.RSUB(exp = _))),
           _,
           a_varDecls,
           a_auxFunction )
      equation
        txt_30 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("Code generation not implemented for lhs assignment "));
        txt_30 = ExpressionDumpTpl.dumpExp(txt_30, i_exp1, "\"");
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 2767, 11), Tpl.textString(txt_30));
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.STMT_ASSIGN(exp1 = (i_exp1 as DAE.CREF(ty = DAE.T_FUNCTION_REFERENCE_VAR(functionType = _))), exp = i_exp),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_varPart, l_preExp, a_varDecls, a_auxFunction) = daeExpCrefLhs(Tpl.emptyTxt, i_exp1, a_context, l_preExp, a_varDecls, a_auxFunction, false);
        (l_expPart, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_exp, a_context, l_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_varPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = (modelica_fnptr) "));
        txt = Tpl.writeText(txt, l_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.STMT_ASSIGN(exp1 = (i_exp1 as DAE.CREF(ty = DAE.T_FUNCTION_REFERENCE_FUNC(builtin = _))), exp = i_exp),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_varPart, l_preExp, a_varDecls, a_auxFunction) = daeExpCrefLhs(Tpl.emptyTxt, i_exp1, a_context, l_preExp, a_varDecls, a_auxFunction, false);
        (l_expPart, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_exp, a_context, l_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_varPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = (modelica_fnptr) "));
        txt = Tpl.writeText(txt, l_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.STMT_ASSIGN(exp1 = (i_exp1 as DAE.ASUB(exp = _)), exp = (i_exp as i_val)),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        txt_31 = expTypeFromExpShort(Tpl.emptyTxt, i_exp);
        str_32 = Tpl.textString(txt_31);
        (txt, a_auxFunction, a_varDecls) = fun_472(txt, str_32, i_val, a_auxFunction, a_varDecls, a_context, i_exp1);
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           (i_stmt as DAE.STMT_ASSIGN(type_ = DAE.T_COMPLEX(complexClassType = ClassInf.RECORD(path = _)))),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_copy__stmt, l_preExp, a_varDecls, a_auxFunction) = algStmtAssignRecord(Tpl.emptyTxt, i_stmt, a_context, l_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_copy__stmt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.STMT_ASSIGN(exp1 = (i_exp1 as DAE.CREF(componentRef = _)), exp = i_exp),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_varPart, l_preExp, a_varDecls, a_auxFunction) = daeExpCrefLhs(Tpl.emptyTxt, i_exp1, a_context, l_preExp, a_varDecls, a_auxFunction, false);
        (l_expPart, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_exp, a_context, l_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_varPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, l_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.STMT_ASSIGN(exp1 = i_exp1, exp = i_exp),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_expPart1, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_exp1, a_context, l_preExp, a_varDecls, a_auxFunction);
        (l_expPart2, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_exp, a_context, l_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_expPart1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, l_expPart2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_varDecls,
           a_auxFunction )
      then (txt, a_varDecls, a_auxFunction);
  end match;
end algStmtAssign;

public function algStmtAssignRecord
  input Tpl.Text in_txt;
  input DAE.Statement in_a_stmt;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_stmt, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Exp i_exp;
      DAE.Exp i_exp1;
      DAE.Type i_ty;
      DAE.Exp i_rhs__exp;
      DAE.ComponentRef i_exp1_componentRef;
      Tpl.Text txt_3;
      Tpl.Text txt_2;
      Tpl.Text txt_1;
      Tpl.Text l_rec__typename;

    case ( txt,
           DAE.STMT_ASSIGN(exp1 = DAE.CREF(componentRef = i_exp1_componentRef), exp = i_rhs__exp, type_ = i_ty),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = assignRhsExpToRecordCref(txt, i_exp1_componentRef, i_rhs__exp, i_ty, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.STMT_ASSIGN(exp1 = (i_exp1 as DAE.CALL(expLst = _)), exp = i_exp, type_ = (i_ty as DAE.T_COMPLEX(complexClassType = ClassInf.RECORD(path = _)))),
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        l_rec__typename = expTypeShort(Tpl.emptyTxt, i_ty);
        txt_1 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("Left hand side of an assignment is a call expression. "));
        txt_1 = ExpressionDumpTpl.dumpExp(txt_1, i_exp1, "\"");
        txt_1 = Tpl.writeTok(txt_1, Tpl.ST_STRING(" = "));
        txt_1 = ExpressionDumpTpl.dumpExp(txt_1, i_exp, "\"");
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 2861, 11), Tpl.textString(txt_1));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.STMT_ASSIGN(exp1 = (i_exp1 as DAE.RECORD(path = _)), type_ = DAE.T_COMPLEX(complexClassType = ClassInf.RECORD(path = _))),
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt_2 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("Left hand side of an assignment is a record expression. "));
        txt_2 = ExpressionDumpTpl.dumpExp(txt_2, i_exp1, "\"");
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 2863, 11), Tpl.textString(txt_2));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.STMT_ASSIGN(exp1 = i_exp1),
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt_3 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("Unhandled record assignment. "));
        txt_3 = ExpressionDumpTpl.dumpExp(txt_3, i_exp1, "\"");
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 2865, 11), Tpl.textString(txt_3));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end algStmtAssignRecord;

protected function fun_475
  input Tpl.Text in_txt;
  input SimCodeFunction.Context in_a_context;
  input DAE.ComponentRef in_a_lhs__cref;
  input DAE.Exp in_a_rhs__exp;
  input DAE.Type in_a_rec__type;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_context, in_a_lhs__cref, in_a_rhs__exp, in_a_rec__type, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      DAE.ComponentRef a_lhs__cref;
      DAE.Exp a_rhs__exp;
      DAE.Type a_rec__type;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      SimCodeFunction.Context i_context;

    case ( txt,
           (i_context as SimCodeFunction.FUNCTION_CONTEXT(cref_prefix = _)),
           a_lhs__cref,
           a_rhs__exp,
           a_rec__type,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = assignRhsExpToRecordCrefFunctionContext(txt, a_lhs__cref, a_rhs__exp, a_rec__type, i_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           i_context,
           a_lhs__cref,
           a_rhs__exp,
           a_rec__type,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = assignRhsExpToRecordCrefSimContext(txt, a_lhs__cref, a_rhs__exp, a_rec__type, i_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end fun_475;

public function assignRhsExpToRecordCref
  input Tpl.Text txt;
  input DAE.ComponentRef a_lhs__cref;
  input DAE.Exp a_rhs__exp;
  input DAE.Type a_rec__type;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_preExp;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) := fun_475(txt, a_context, a_lhs__cref, a_rhs__exp, a_rec__type, a_preExp, a_varDecls, a_auxFunction);
end assignRhsExpToRecordCref;

protected function lm_477
  input Tpl.Text in_txt;
  input list<DAE.Statement> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Statement> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      SimCodeFunction.Context a_context;
      DAE.Statement i_stmt;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           _ )
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           i_stmt :: rest,
           a_auxFunction,
           a_varDecls,
           a_context )
      equation
        (txt, a_varDecls, a_auxFunction) = algStatement(txt, i_stmt, a_context, a_varDecls, a_auxFunction);
        (txt, a_auxFunction, a_varDecls) = lm_477(txt, rest, a_auxFunction, a_varDecls, a_context);
      then (txt, a_auxFunction, a_varDecls);
  end match;
end lm_477;

protected function lm_478
  input Tpl.Text in_txt;
  input list<DAE.Statement> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Statement> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      SimCodeFunction.Context a_context;
      DAE.Statement i_stmt;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           _ )
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           i_stmt :: rest,
           a_auxFunction,
           a_varDecls,
           a_context )
      equation
        (txt, a_varDecls, a_auxFunction) = algStatement(txt, i_stmt, a_context, a_varDecls, a_auxFunction);
        (txt, a_auxFunction, a_varDecls) = lm_478(txt, rest, a_auxFunction, a_varDecls, a_context);
      then (txt, a_auxFunction, a_varDecls);
  end match;
end lm_478;

protected function fun_479
  input Tpl.Text in_txt;
  input DAE.Exp in_a_rhs__exp;
  input Tpl.Text in_a_rec__typename;
  input DAE.Type in_a_rec__type;
  input DAE.ComponentRef in_a_lhs__cref;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_a_rhs__exp, in_a_rec__typename, in_a_rec__type, in_a_lhs__cref, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      Tpl.Text a_rec__typename;
      DAE.Type a_rec__type;
      DAE.ComponentRef a_lhs__cref;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Exp i_rhs__exp;
      DAE.ComponentRef i_cr;
      list<DAE.Statement> ret_4;
      Tpl.Text l_tmp__rec;
      list<DAE.Statement> ret_2;
      Tpl.Text l_assigns;
      Tpl.Text l_rhs__exp__str;

    case ( txt,
           DAE.CREF(componentRef = i_cr),
           _,
           a_rec__type,
           a_lhs__cref,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (l_rhs__exp__str, a_preExp, a_varDecls, a_auxFunction) = contextCref(Tpl.emptyTxt, i_cr, a_context, a_preExp, a_varDecls, a_auxFunction);
        ret_2 = SimCodeFunctionUtil.splitRecordAssignmentToMemberAssignments(a_lhs__cref, a_rec__type, Tpl.textString(l_rhs__exp__str));
        (l_assigns, a_auxFunction, a_varDecls) = lm_477(Tpl.emptyTxt, ret_2, a_auxFunction, a_varDecls, a_context);
        txt = Tpl.writeText(txt, l_assigns);
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           i_rhs__exp,
           a_rec__typename,
           a_rec__type,
           a_lhs__cref,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (l_rhs__exp__str, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_rhs__exp, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_tmp__rec, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(a_rec__typename), a_varDecls);
        ret_4 = SimCodeFunctionUtil.splitRecordAssignmentToMemberAssignments(a_lhs__cref, a_rec__type, Tpl.textString(l_tmp__rec));
        (l_assigns, a_auxFunction, a_varDecls) = lm_478(Tpl.emptyTxt, ret_4, a_auxFunction, a_varDecls, a_context);
        txt = Tpl.writeText(txt, l_tmp__rec);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, l_rhs__exp__str);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.writeText(txt, l_assigns);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end fun_479;

public function assignRhsExpToRecordCrefSimContext
  input Tpl.Text txt;
  input DAE.ComponentRef a_lhs__cref;
  input DAE.Exp a_rhs__exp;
  input DAE.Type a_rec__type;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_preExp;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
protected
  Tpl.Text l_rec__typename;
  Tpl.Text l_lhs;
algorithm
  (l_lhs, out_a_preExp, out_a_varDecls, out_a_auxFunction) := contextCref(Tpl.emptyTxt, a_lhs__cref, a_context, a_preExp, a_varDecls, a_auxFunction);
  l_rec__typename := expTypeShort(Tpl.emptyTxt, a_rec__type);
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) := fun_479(txt, a_rhs__exp, l_rec__typename, a_rec__type, a_lhs__cref, out_a_auxFunction, out_a_varDecls, out_a_preExp, a_context);
end assignRhsExpToRecordCrefSimContext;

protected function fun_481
  input Tpl.Text in_txt;
  input DAE.Exp in_a_rhs__exp;
  input Tpl.Text in_a_lhs;
  input Tpl.Text in_a_rec__typename;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_a_rhs__exp, in_a_lhs, in_a_rec__typename, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      Tpl.Text a_lhs;
      Tpl.Text a_rec__typename;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Exp i_rhs__exp;
      DAE.ComponentRef i_rhs__exp_componentRef;
      Tpl.Text l_tmp__rec;
      Tpl.Text l_rhs;

    case ( txt,
           DAE.CREF(componentRef = i_rhs__exp_componentRef),
           a_lhs,
           a_rec__typename,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (l_rhs, a_preExp, a_varDecls, a_auxFunction) = contextCref(Tpl.emptyTxt, i_rhs__exp_componentRef, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeText(txt, a_rec__typename);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_copy("));
        txt = Tpl.writeText(txt, l_rhs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_lhs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           i_rhs__exp,
           a_lhs,
           a_rec__typename,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (l_tmp__rec, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(a_rec__typename), a_varDecls);
        (l_rhs, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_rhs__exp, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeText(txt, l_tmp__rec);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, l_rhs);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.writeText(txt, a_rec__typename);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_copy("));
        txt = Tpl.writeText(txt, l_tmp__rec);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_lhs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end fun_481;

public function assignRhsExpToRecordCrefFunctionContext
  input Tpl.Text txt;
  input DAE.ComponentRef a_lhs__cref;
  input DAE.Exp a_rhs__exp;
  input DAE.Type a_rec__type;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_preExp;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
protected
  Tpl.Text l_rec__typename_1;
  Tpl.Text l_rec__typename;
  Tpl.Text l_lhs;
algorithm
  (l_lhs, out_a_preExp, out_a_varDecls, out_a_auxFunction) := contextCref(Tpl.emptyTxt, a_lhs__cref, a_context, a_preExp, a_varDecls, a_auxFunction);
  l_rec__typename := expTypeShort(Tpl.emptyTxt, a_rec__type);
  l_rec__typename_1 := expTypeShort(Tpl.emptyTxt, a_rec__type);
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) := fun_481(txt, a_rhs__exp, l_lhs, l_rec__typename_1, out_a_auxFunction, out_a_varDecls, out_a_preExp, a_context);
end assignRhsExpToRecordCrefFunctionContext;

public function algStmtAssignArr
  input Tpl.Text in_txt;
  input DAE.Statement in_a_stmt;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_stmt, in_a_context, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Exp i_lhsexp;
      DAE.Exp i_e;
      DAE.ComponentRef i_cr;
      DAE.Exp i_exp;
      DAE.Type i_t;
      Tpl.Text l_assign;
      Tpl.Text l_expPart;
      Tpl.Text l_preExp;

    case ( txt,
           DAE.STMT_ASSIGN_ARR(lhs = DAE.CREF(componentRef = i_cr), exp = (i_exp as DAE.RANGE(ty = _)), type_ = i_t),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_varDecls, a_auxFunction) = fillArrayFromRange(txt, i_t, i_exp, i_cr, a_context, a_varDecls, a_auxFunction);
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.STMT_ASSIGN_ARR(lhs = (i_lhsexp as DAE.CREF(componentRef = _)), exp = i_e, type_ = _),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_expPart, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e, a_context, l_preExp, a_varDecls, a_auxFunction);
        (l_assign, l_expPart, l_preExp, a_varDecls, a_auxFunction) = algStmtAssignArrWithRhsExpStr(Tpl.emptyTxt, i_lhsexp, l_expPart, a_context, l_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_assign);
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_varDecls,
           a_auxFunction )
      then (txt, a_varDecls, a_auxFunction);
  end match;
end algStmtAssignArr;

protected function lm_484
  input Tpl.Text in_txt;
  input list<DAE.Var> in_items;
  input Tpl.Text in_a_tmp;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;
  input list<DAE.Exp> in_a_expLst;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_tmp, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context, in_a_expLst)
    local
      Tpl.Text txt;
      list<DAE.Var> rest;
      Tpl.Text a_tmp;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      list<DAE.Exp> a_expLst;
      Integer x_i1;
      DAE.Ident i_var_name;
      DAE.Exp ret_1;
      Tpl.Text l_re;

    case ( txt,
           {},
           _,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           DAE.TYPES_VAR(name = i_var_name) :: rest,
           a_tmp,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context,
           a_expLst )
      equation
        x_i1 = Tpl.getIteri_i0(txt);
        ret_1 = listGet(a_expLst, x_i1);
        (l_re, a_preExp, a_varDecls, a_auxFunction) = daeExpCrefLhs(Tpl.emptyTxt, ret_1, a_context, a_preExp, a_varDecls, a_auxFunction, false);
        txt = Tpl.writeText(txt, l_re);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, a_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("._"));
        txt = Tpl.writeStr(txt, i_var_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_484(txt, rest, a_tmp, a_auxFunction, a_varDecls, a_preExp, a_context, a_expLst);
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           _ :: rest,
           a_tmp,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context,
           a_expLst )
      equation
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_484(txt, rest, a_tmp, a_auxFunction, a_varDecls, a_preExp, a_context, a_expLst);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end lm_484;

protected function fun_485
  input Tpl.Text in_txt;
  input DAE.Exp in_a_lhsexp;
  input Tpl.Text in_a_rhsExpStr;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_rhsExpStr;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_rhsExpStr, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_lhsexp, in_a_rhsExpStr, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      Tpl.Text a_rhsExpStr;
      SimCodeFunction.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      list<DAE.Exp> i_expLst;
      list<DAE.Var> i_varLst;
      DAE.Type i_ty;
      DAE.Exp i_lhsexp;
      Tpl.Text txt_3;
      Tpl.Text txt_2;
      Tpl.Text l_tmp;
      Tpl.Text l_lhsStr;

    case ( txt,
           DAE.CREF(componentRef = DAE.WILD()),
           a_rhsExpStr,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt = Tpl.writeText(txt, a_rhsExpStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then (txt, a_rhsExpStr, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_lhsexp as DAE.CREF(componentRef = _, ty = DAE.T_ARRAY(ty = _, dims = _))),
           a_rhsExpStr,
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_rhsExpStr, a_preExp, a_varDecls, a_auxFunction) = algStmtAssignArrWithRhsExpStr(txt, i_lhsexp, a_rhsExpStr, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_rhsExpStr, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_lhsexp as DAE.CREF(componentRef = _, ty = DAE.T_COMPLEX(complexClassType = ClassInf.RECORD(path = _)))),
           a_rhsExpStr,
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_rhsExpStr, a_preExp, a_varDecls, a_auxFunction) = algStmtAssignRecordWithRhsExpStr(txt, i_lhsexp, a_rhsExpStr, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_rhsExpStr, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_lhsexp as DAE.CREF(componentRef = _)),
           a_rhsExpStr,
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_lhsStr, a_preExp, a_varDecls, a_auxFunction) = daeExpCrefLhs(Tpl.emptyTxt, i_lhsexp, a_context, a_preExp, a_varDecls, a_auxFunction, false);
        txt = Tpl.writeText(txt, l_lhsStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, a_rhsExpStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then (txt, a_rhsExpStr, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = _, expLst = i_expLst, attr = DAE.CALL_ATTR(ty = (i_ty as DAE.T_COMPLEX(varLst = i_varLst, complexClassType = ClassInf.RECORD(path = _))))),
           a_rhsExpStr,
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt_2 = expTypeModelica(Tpl.emptyTxt, i_ty);
        (l_tmp, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(txt_2), a_varDecls);
        txt = Tpl.writeText(txt, a_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, a_rhsExpStr);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(1, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_484(txt, i_varLst, l_tmp, a_auxFunction, a_varDecls, a_preExp, a_context, i_expLst);
        txt = Tpl.popIter(txt);
      then (txt, a_rhsExpStr, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           i_lhsexp,
           a_rhsExpStr,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt_3 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("algStmtAssignWithRhsExpStr: Unhandled lhs expression. "));
        txt_3 = ExpressionDumpTpl.dumpExp(txt_3, i_lhsexp, "\"");
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 2981, 11), Tpl.textString(txt_3));
      then (txt, a_rhsExpStr, a_preExp, a_varDecls, a_auxFunction);
  end match;
end fun_485;

public function algStmtAssignWithRhsExpStr
  input Tpl.Text txt;
  input DAE.Exp a_lhsexp;
  input Tpl.Text a_rhsExpStr;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_preExp;
  input Tpl.Text a_postExp;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_rhsExpStr;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_postExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_rhsExpStr, out_a_preExp, out_a_varDecls, out_a_auxFunction) := fun_485(txt, a_lhsexp, a_rhsExpStr, a_context, a_preExp, a_varDecls, a_auxFunction);
  out_a_postExp := a_postExp;
end algStmtAssignWithRhsExpStr;

protected function lm_487
  input Tpl.Text in_txt;
  input list<DAE.Var> in_items;
  input Tpl.Text in_a_tmp;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;
  input DAE.ComponentRef in_a_cr;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_tmp, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context, in_a_cr)
    local
      Tpl.Text txt;
      list<DAE.Var> rest;
      Tpl.Text a_tmp;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.ComponentRef a_cr;
      DAE.Ident i_var_name;
      DAE.ComponentRef ret_0;

    case ( txt,
           {},
           _,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           DAE.TYPES_VAR(name = i_var_name) :: rest,
           a_tmp,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context,
           a_cr )
      equation
        ret_0 = ComponentReference.appendStringCref(i_var_name, a_cr);
        (txt, a_preExp, a_varDecls, a_auxFunction) = contextCref(txt, ret_0, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, a_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("._"));
        txt = Tpl.writeStr(txt, i_var_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_487(txt, rest, a_tmp, a_auxFunction, a_varDecls, a_preExp, a_context, a_cr);
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           _ :: rest,
           a_tmp,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context,
           a_cr )
      equation
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_487(txt, rest, a_tmp, a_auxFunction, a_varDecls, a_preExp, a_context, a_cr);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end lm_487;

protected function fun_488
  input Tpl.Text in_txt;
  input DAE.Exp in_a_lhsexp;
  input Tpl.Text in_a_rhsExpStr;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_lhsexp, in_a_rhsExpStr, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      Tpl.Text a_rhsExpStr;
      SimCodeFunction.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.ComponentRef i_cr;
      list<DAE.Var> i_varLst;
      DAE.Type i_ty;
      Tpl.Text txt_1;
      Tpl.Text l_tmp;

    case ( txt,
           DAE.CREF(componentRef = i_cr, ty = (i_ty as DAE.T_COMPLEX(varLst = i_varLst, complexClassType = ClassInf.RECORD(path = _)))),
           a_rhsExpStr,
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt_1 = expTypeModelica(Tpl.emptyTxt, i_ty);
        (l_tmp, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(txt_1), a_varDecls);
        txt = Tpl.writeText(txt, a_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, a_rhsExpStr);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_487(txt, i_varLst, l_tmp, a_auxFunction, a_varDecls, a_preExp, a_context, i_cr);
        txt = Tpl.popIter(txt);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end fun_488;

public function algStmtAssignRecordWithRhsExpStr
  input Tpl.Text txt;
  input DAE.Exp a_lhsexp;
  input Tpl.Text a_rhsExpStr;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_preExp;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_rhsExpStr;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) := fun_488(txt, a_lhsexp, a_rhsExpStr, a_context, a_preExp, a_varDecls, a_auxFunction);
  out_a_rhsExpStr := a_rhsExpStr;
end algStmtAssignRecordWithRhsExpStr;

protected function fun_490
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_type;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_rhsExpStr;
  input DAE.Exp in_a_lhsexp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_mArg, in_a_type, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context, in_a_rhsExpStr, in_a_lhsexp)
    local
      Tpl.Text txt;
      Tpl.Text a_type;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      Tpl.Text a_rhsExpStr;
      DAE.Exp a_lhsexp;
      Tpl.Text l_lhsStr;

    case ( txt,
           false,
           _,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context,
           a_rhsExpStr,
           a_lhsexp )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = indexedAssign(txt, a_lhsexp, Tpl.textString(a_rhsExpStr), a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           _,
           a_type,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context,
           a_rhsExpStr,
           a_lhsexp )
      equation
        (l_lhsStr, a_preExp, a_varDecls, a_auxFunction) = daeExpCrefLhs(Tpl.emptyTxt, a_lhsexp, a_context, a_preExp, a_varDecls, a_auxFunction, false);
        txt = Tpl.writeText(txt, a_type);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_copy_data("));
        txt = Tpl.writeText(txt, a_rhsExpStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, l_lhsStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end fun_490;

protected function fun_491
  input Tpl.Text in_txt;
  input DAE.Exp in_a_lhsexp;
  input Tpl.Text in_a_rhsExpStr;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_lhsexp, in_a_rhsExpStr, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      Tpl.Text a_rhsExpStr;
      SimCodeFunction.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Exp i_lhsexp;
      DAE.ComponentRef i_cr;
      DAE.Type i_ty;
      Boolean ret_1;
      Tpl.Text l_type;

    case ( txt,
           (i_lhsexp as DAE.CREF(componentRef = i_cr, ty = (i_ty as DAE.T_ARRAY(ty = _, dims = _)))),
           a_rhsExpStr,
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        l_type = expTypeArray(Tpl.emptyTxt, i_ty);
        ret_1 = SimCodeFunctionUtil.crefSubIsScalar(i_cr);
        (txt, a_auxFunction, a_varDecls, a_preExp) = fun_490(txt, ret_1, l_type, a_auxFunction, a_varDecls, a_preExp, a_context, a_rhsExpStr, i_lhsexp);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end fun_491;

public function algStmtAssignArrWithRhsExpStr
  input Tpl.Text txt;
  input DAE.Exp a_lhsexp;
  input Tpl.Text a_rhsExpStr;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_preExp;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_rhsExpStr;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) := fun_491(txt, a_lhsexp, a_rhsExpStr, a_context, a_preExp, a_varDecls, a_auxFunction);
  out_a_rhsExpStr := a_rhsExpStr;
end algStmtAssignArrWithRhsExpStr;

protected function fun_493
  input Tpl.Text in_txt;
  input Option<DAE.Exp> in_a_step;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_a_step, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Exp i_stepExp;

    case ( txt,
           SOME(i_stepExp),
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExp(txt, i_stepExp, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           _,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("1"));
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end fun_493;

protected function fun_494
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input DAE.ComponentRef in_a_cr;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_exp, in_a_cr, in_a_context, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      DAE.ComponentRef a_cr;
      SimCodeFunction.Context a_context;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      Option<DAE.Exp> i_step;
      DAE.Exp i_stop;
      DAE.Exp i_start;
      DAE.Type i_ty;
      Tpl.Text l_step__exp;
      Tpl.Text l_stop__exp;
      Tpl.Text l_start__exp;
      Tpl.Text l_ty__str;
      Tpl.Text l_cref;
      Tpl.Text l_preExp;

    case ( txt,
           DAE.RANGE(ty = i_ty, start = i_start, stop = i_stop, step = i_step),
           a_cr,
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        l_preExp = Tpl.emptyTxt;
        l_cref = contextArrayCref(Tpl.emptyTxt, a_cr, a_context);
        l_ty__str = expTypeArray(Tpl.emptyTxt, i_ty);
        (l_start__exp, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_start, a_context, l_preExp, a_varDecls, a_auxFunction);
        (l_stop__exp, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_stop, a_context, l_preExp, a_varDecls, a_auxFunction);
        (l_step__exp, a_auxFunction, a_varDecls, l_preExp) = fun_493(Tpl.emptyTxt, i_step, a_auxFunction, a_varDecls, l_preExp, a_context);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("fill_"));
        txt = Tpl.writeText(txt, l_ty__str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_from_range(&"));
        txt = Tpl.writeText(txt, l_cref);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, l_start__exp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, l_step__exp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, l_stop__exp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           _,
           a_varDecls,
           a_auxFunction )
      then (txt, a_varDecls, a_auxFunction);
  end match;
end fun_494;

public function fillArrayFromRange
  input Tpl.Text txt;
  input DAE.Type a_ty;
  input DAE.Exp a_exp;
  input DAE.ComponentRef a_cr;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) := fun_494(txt, a_exp, a_cr, a_context, a_varDecls, a_auxFunction);
end fillArrayFromRange;

protected function lm_496
  input Tpl.Text in_txt;
  input list<DAE.Dimension> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Dimension> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Dimension i_dim;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           i_dim :: rest,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(_index_t)"));
        (txt, a_preExp, a_varDecls, a_auxFunction) = dimension(txt, i_dim, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_496(txt, rest, a_auxFunction, a_varDecls, a_preExp, a_context);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end lm_496;

protected function fun_497
  input Tpl.Text in_txt;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input DAE.Type in_a_aty;
  input Tpl.Text in_a_ispec;
  input String in_a_exp;
  input Tpl.Text in_a_arrayType;
  input DAE.ComponentRef in_a_cr;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_preExp, out_a_varDecls) :=
  match(in_txt, in_a_context, in_a_auxFunction, in_a_preExp, in_a_varDecls, in_a_aty, in_a_ispec, in_a_exp, in_a_arrayType, in_a_cr)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      DAE.Type a_aty;
      Tpl.Text a_ispec;
      String a_exp;
      Tpl.Text a_arrayType;
      DAE.ComponentRef a_cr;
      SimCodeFunction.Context i_context;
      DAE.ComponentRef ret_9;
      Tpl.Text l_arrName;
      list<DAE.Dimension> ret_7;
      Tpl.Text l_dimsValuesStr;
      Integer ret_5;
      list<DAE.Dimension> ret_4;
      Tpl.Text l_dimsLenStr;
      Tpl.Text l_wrapperArray;
      Tpl.Text l_type;
      Tpl.Text l_cref;

    case ( txt,
           (i_context as SimCodeFunction.FUNCTION_CONTEXT(cref_prefix = _)),
           a_auxFunction,
           a_preExp,
           a_varDecls,
           _,
           a_ispec,
           a_exp,
           a_arrayType,
           a_cr )
      equation
        l_cref = contextArrayCref(Tpl.emptyTxt, a_cr, i_context);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("indexed_assign_"));
        txt = Tpl.writeText(txt, a_arrayType);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeStr(txt, a_exp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", &"));
        txt = Tpl.writeText(txt, l_cref);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", &"));
        txt = Tpl.writeText(txt, a_ispec);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then (txt, a_auxFunction, a_preExp, a_varDecls);

    case ( txt,
           i_context,
           a_auxFunction,
           a_preExp,
           a_varDecls,
           a_aty,
           a_ispec,
           a_exp,
           a_arrayType,
           a_cr )
      equation
        l_type = expTypeShort(Tpl.emptyTxt, a_aty);
        (l_wrapperArray, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(a_arrayType), a_varDecls);
        ret_4 = ComponentReference.crefDims(a_cr);
        ret_5 = listLength(ret_4);
        l_dimsLenStr = Tpl.writeStr(Tpl.emptyTxt, intString(ret_5));
        ret_7 = ComponentReference.crefDims(a_cr);
        l_dimsValuesStr = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_dimsValuesStr, a_auxFunction, a_varDecls, a_preExp) = lm_496(l_dimsValuesStr, ret_7, a_auxFunction, a_varDecls, a_preExp, i_context);
        l_dimsValuesStr = Tpl.popIter(l_dimsValuesStr);
        ret_9 = ComponentReference.crefStripSubs(a_cr);
        (l_arrName, a_preExp, a_varDecls, a_auxFunction) = contextCref(Tpl.emptyTxt, ret_9, i_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeText(txt, l_type);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_array_create(&"));
        txt = Tpl.writeText(txt, l_wrapperArray);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", (modelica_"));
        txt = Tpl.writeText(txt, l_type);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("*)&"));
        txt = Tpl.writeText(txt, l_arrName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, l_dimsLenStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, l_dimsValuesStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "indexed_assign_"
                                }, false));
        txt = Tpl.writeText(txt, a_arrayType);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeStr(txt, a_exp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", &"));
        txt = Tpl.writeText(txt, l_wrapperArray);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", &"));
        txt = Tpl.writeText(txt, a_ispec);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then (txt, a_auxFunction, a_preExp, a_varDecls);
  end match;
end fun_497;

public function indexedAssign
  input Tpl.Text in_txt;
  input DAE.Exp in_a_lhs;
  input String in_a_exp;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_lhs, in_a_exp, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      String a_exp;
      SimCodeFunction.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Type i_aty;
      DAE.ComponentRef i_cr;
      DAE.Type i_ty;
      list<DAE.Subscript> ret_2;
      Tpl.Text l_ispec;
      Tpl.Text l_arrayType;

    case ( txt,
           DAE.CREF(componentRef = i_cr, ty = (i_ty as DAE.T_ARRAY(ty = i_aty, dims = _))),
           a_exp,
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        l_arrayType = expTypeArray(Tpl.emptyTxt, i_ty);
        ret_2 = ComponentReference.crefSubs(i_cr);
        (l_ispec, a_preExp, a_varDecls, a_auxFunction) = daeExpCrefIndexSpec(Tpl.emptyTxt, ret_2, a_context, a_preExp, a_varDecls, a_auxFunction);
        (txt, a_auxFunction, a_preExp, a_varDecls) = fun_497(txt, a_context, a_auxFunction, a_preExp, a_varDecls, i_aty, l_ispec, a_exp, l_arrayType, i_cr);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 3057, 11), "indexedAssign simulationContext failed");
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end indexedAssign;

protected function lm_499
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_postExp;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_postExp;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_postExp, out_a_preExp, out_a_varDecls) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_postExp, in_a_preExp, in_a_varDecls, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_postExp;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      SimCodeFunction.Context a_context;
      DAE.Exp i_e;

    case ( txt,
           {},
           a_auxFunction,
           a_postExp,
           a_preExp,
           a_varDecls,
           _ )
      then (txt, a_auxFunction, a_postExp, a_preExp, a_varDecls);

    case ( txt,
           i_e :: rest,
           a_auxFunction,
           a_postExp,
           a_preExp,
           a_varDecls,
           a_context )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" ,"));
        (txt, a_varDecls, a_preExp, a_postExp, a_auxFunction) = tupleReturnVariableUpdates(txt, i_e, a_context, a_varDecls, a_preExp, a_postExp, a_auxFunction);
        (txt, a_auxFunction, a_postExp, a_preExp, a_varDecls) = lm_499(txt, rest, a_auxFunction, a_postExp, a_preExp, a_varDecls, a_context);
      then (txt, a_auxFunction, a_postExp, a_preExp, a_varDecls);
  end match;
end lm_499;

protected function lm_500
  input Tpl.Text in_txt;
  input list<String> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<String> rest;
      String i_it;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_it :: rest )
      equation
        txt = Tpl.writeStr(txt, i_it);
        txt = lm_500(txt, rest);
      then txt;
  end match;
end lm_500;

protected function lm_501
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_startIndexOutputs;
  input Tpl.Text in_a_prefix;
  input list<DAE.Exp> in_a_expExpLst;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context, in_a_startIndexOutputs, in_a_prefix, in_a_expExpLst)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      Tpl.Text a_startIndexOutputs;
      Tpl.Text a_prefix;
      list<DAE.Exp> a_expExpLst;
      Integer x_i0;
      DAE.ComponentRef i_cr;
      Tpl.Text l_lhsStr;
      Tpl.Text l_rhsStr;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _,
           _,
           _,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           DAE.CREF(componentRef = i_cr) :: rest,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context,
           a_startIndexOutputs,
           a_prefix,
           a_expExpLst )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        l_rhsStr = getTempDeclMatchOutputName(Tpl.emptyTxt, a_expExpLst, Tpl.textString(a_prefix), Tpl.textString(a_startIndexOutputs), x_i0);
        (l_lhsStr, a_preExp, a_varDecls, a_auxFunction) = contextCref(Tpl.emptyTxt, i_cr, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeText(txt, l_lhsStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, l_rhsStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_501(txt, rest, a_auxFunction, a_varDecls, a_preExp, a_context, a_startIndexOutputs, a_prefix, a_expExpLst);
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           _ :: rest,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context,
           a_startIndexOutputs,
           a_prefix,
           a_expExpLst )
      equation
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_501(txt, rest, a_auxFunction, a_varDecls, a_preExp, a_context, a_startIndexOutputs, a_prefix, a_expExpLst);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end lm_501;

protected function lm_502
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_startIndexOutputs;
  input Tpl.Text in_a_prefix;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_varDecls) :=
  match(in_txt, in_items, in_a_varDecls, in_a_startIndexOutputs, in_a_prefix)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Tpl.Text a_varDecls;
      Tpl.Text a_startIndexOutputs;
      Tpl.Text a_prefix;
      Integer x_i0;
      DAE.Exp i_crefexp;
      Tpl.Text l_decl;
      Tpl.Text l_typ;

    case ( txt,
           {},
           a_varDecls,
           _,
           _ )
      then (txt, a_varDecls);

    case ( txt,
           i_crefexp :: rest,
           a_varDecls,
           a_startIndexOutputs,
           a_prefix )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        l_typ = expTypeFromExpModelica(Tpl.emptyTxt, i_crefexp);
        (l_decl, a_varDecls) = tempDeclMatchOutput(Tpl.emptyTxt, Tpl.textString(l_typ), Tpl.textString(a_prefix), Tpl.textString(a_startIndexOutputs), intString(x_i0), a_varDecls);
        txt = Tpl.nextIter(txt);
        (txt, a_varDecls) = lm_502(txt, rest, a_varDecls, a_startIndexOutputs, a_prefix);
      then (txt, a_varDecls);
  end match;
end lm_502;

public function algStmtTupleAssign
  input Tpl.Text in_txt;
  input DAE.Statement in_a_stmt;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_stmt, in_a_context, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Exp i_firstexp;
      DAE.Exp i_exp;
      list<DAE.Type> i_ntys;
      list<DAE.Exp> i_expExpLst;
      Tpl.Text l_0__;
      Integer ret_16;
      Integer ret_15;
      Tpl.Text l_startIndexOutputs;
      Integer ret_13;
      Tpl.Text l_prefix;
      Tpl.Text l_callassign;
      Tpl.Text l_call;
      list<String> ret_9;
      Integer ret_8;
      Integer ret_7;
      Integer ret_6;
      Integer ret_5;
      Tpl.Text l_lhsCrefs2;
      list<DAE.Exp> ret_3;
      Tpl.Text l_lhsCrefs;
      Tpl.Text l_postExp;
      Tpl.Text l_preExp;

    case ( txt,
           DAE.STMT_TUPLE_ASSIGN(expExpLst = {_}),
           _,
           a_varDecls,
           a_auxFunction )
      equation
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 3065, 11), "A tuple assignment of only one variable is a regular assignment");
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.STMT_TUPLE_ASSIGN(expExpLst = (i_expExpLst as i_firstexp :: _), exp = (i_exp as DAE.CALL(attr = DAE.CALL_ATTR(ty = DAE.T_TUPLE(types = i_ntys))))),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        l_preExp = Tpl.emptyTxt;
        l_postExp = Tpl.emptyTxt;
        ret_3 = List.rest(i_expExpLst);
        (l_lhsCrefs, a_auxFunction, l_postExp, l_preExp, a_varDecls) = lm_499(Tpl.emptyTxt, ret_3, a_auxFunction, l_postExp, l_preExp, a_varDecls, a_context);
        l_lhsCrefs2 = Tpl.writeText(Tpl.emptyTxt, l_lhsCrefs);
        ret_5 = listLength(i_ntys);
        ret_6 = listLength(i_expExpLst);
        ret_7 = intSub(ret_5, ret_6);
        ret_8 = intMax(0, ret_7);
        ret_9 = List.fill(", NULL", ret_8);
        l_lhsCrefs2 = lm_500(l_lhsCrefs2, ret_9);
        (l_call, l_lhsCrefs2, l_preExp, a_varDecls, a_auxFunction) = daeExpCallTuple(Tpl.emptyTxt, i_exp, l_lhsCrefs2, a_context, l_preExp, a_varDecls, a_auxFunction);
        (l_callassign, l_call, l_preExp, l_postExp, a_varDecls, a_auxFunction) = algStmtAssignWithRhsExpStr(Tpl.emptyTxt, i_firstexp, l_call, a_context, l_preExp, l_postExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_callassign);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_postExp);
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.STMT_TUPLE_ASSIGN(exp = (i_exp as DAE.MATCHEXPRESSION(matchType = _)), expExpLst = i_expExpLst),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        l_preExp = Tpl.emptyTxt;
        l_prefix = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("tmp"));
        ret_13 = System.tmpTick();
        l_prefix = Tpl.writeStr(l_prefix, intString(ret_13));
        ret_15 = listLength(i_expExpLst);
        ret_16 = System.tmpTickIndexReserve(1, ret_15);
        l_startIndexOutputs = Tpl.writeStr(Tpl.emptyTxt, intString(ret_16));
        (l_0__, l_prefix, l_startIndexOutputs, l_preExp, a_varDecls, a_auxFunction) = daeExpMatch2(Tpl.emptyTxt, i_exp, i_expExpLst, l_prefix, l_startIndexOutputs, a_context, l_preExp, a_varDecls, a_auxFunction);
        l_lhsCrefs = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(1, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_lhsCrefs, a_auxFunction, a_varDecls, l_preExp) = lm_501(l_lhsCrefs, i_expExpLst, a_auxFunction, a_varDecls, l_preExp, a_context, l_startIndexOutputs, l_prefix, i_expExpLst);
        l_lhsCrefs = Tpl.popIter(l_lhsCrefs);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_varDecls) = lm_502(txt, i_expExpLst, a_varDecls, l_startIndexOutputs, l_prefix);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_lhsCrefs);
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_varDecls,
           a_auxFunction )
      equation
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 3105, 14), "algStmtTupleAssign failed");
      then (txt, a_varDecls, a_auxFunction);
  end match;
end algStmtTupleAssign;

protected function lm_504
  input Tpl.Text in_txt;
  input list<DAE.Var> in_items;
  input Tpl.Text in_a_rhsStr;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;
  input DAE.ComponentRef in_a_cr;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_rhsStr, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context, in_a_cr)
    local
      Tpl.Text txt;
      list<DAE.Var> rest;
      Tpl.Text a_rhsStr;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.ComponentRef a_cr;
      DAE.Ident i_var_name;
      DAE.ComponentRef ret_0;

    case ( txt,
           {},
           _,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           DAE.TYPES_VAR(name = i_var_name) :: rest,
           a_rhsStr,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context,
           a_cr )
      equation
        ret_0 = ComponentReference.appendStringCref(i_var_name, a_cr);
        (txt, a_preExp, a_varDecls, a_auxFunction) = contextCref(txt, ret_0, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, a_rhsStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("._"));
        txt = Tpl.writeStr(txt, i_var_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_504(txt, rest, a_rhsStr, a_auxFunction, a_varDecls, a_preExp, a_context, a_cr);
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           _ :: rest,
           a_rhsStr,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context,
           a_cr )
      equation
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_504(txt, rest, a_rhsStr, a_auxFunction, a_varDecls, a_preExp, a_context, a_cr);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end lm_504;

protected function lm_505
  input Tpl.Text in_txt;
  input list<DAE.Var> in_items;
  input Tpl.Text in_a_rhsStr;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;
  input list<DAE.Exp> in_a_expLst;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_rhsStr, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context, in_a_expLst)
    local
      Tpl.Text txt;
      list<DAE.Var> rest;
      Tpl.Text a_rhsStr;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      list<DAE.Exp> a_expLst;
      Integer x_i1;
      DAE.Ident i_var_name;
      DAE.Exp ret_1;
      Tpl.Text l_re;

    case ( txt,
           {},
           _,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           DAE.TYPES_VAR(name = i_var_name) :: rest,
           a_rhsStr,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context,
           a_expLst )
      equation
        x_i1 = Tpl.getIteri_i0(txt);
        ret_1 = listGet(a_expLst, x_i1);
        (l_re, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, ret_1, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeText(txt, l_re);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, a_rhsStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("._"));
        txt = Tpl.writeStr(txt, i_var_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_505(txt, rest, a_rhsStr, a_auxFunction, a_varDecls, a_preExp, a_context, a_expLst);
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           _ :: rest,
           a_rhsStr,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context,
           a_expLst )
      equation
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_505(txt, rest, a_rhsStr, a_auxFunction, a_varDecls, a_preExp, a_context, a_expLst);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end lm_505;

protected function fun_506
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_res;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_preExp) :=
  match(in_txt, in_mArg, in_a_preExp, in_a_res)
    local
      Tpl.Text txt;
      Tpl.Text a_preExp;
      Tpl.Text a_res;

    case ( txt,
           false,
           a_preExp,
           a_res )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("&"));
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           _,
           a_preExp,
           a_res )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(".dim_size = NULL;"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("&"));
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);
  end match;
end fun_506;

public function tupleReturnVariableUpdates
  input Tpl.Text in_txt;
  input DAE.Exp in_a_inExp;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varCopy;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varCopy;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_preExp, out_a_varCopy, out_a_auxFunction) :=
  match(in_txt, in_a_inExp, in_a_context, in_a_varDecls, in_a_preExp, in_a_varCopy, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      Tpl.Text a_varCopy;
      Tpl.Text a_auxFunction;
      DAE.Exp i_inExp;
      list<DAE.Exp> i_expLst;
      DAE.ComponentRef i_cr;
      list<DAE.Var> i_varLst;
      DAE.Type i_ty;
      Tpl.Text txt_8;
      Boolean ret_7;
      Tpl.Text l_res;
      Tpl.Text txt_5;
      Tpl.Text l_tmp;
      Tpl.Text txt_3;
      Tpl.Text l_preExp;
      Tpl.Text txt_1;
      Tpl.Text l_rhsStr;

    case ( txt,
           DAE.CREF(componentRef = DAE.WILD()),
           _,
           a_varDecls,
           a_preExp,
           a_varCopy,
           a_auxFunction )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("NULL"));
      then (txt, a_varDecls, a_preExp, a_varCopy, a_auxFunction);

    case ( txt,
           DAE.CREF(componentRef = i_cr, ty = (i_ty as DAE.T_COMPLEX(varLst = i_varLst, complexClassType = ClassInf.RECORD(path = _)))),
           a_context,
           a_varDecls,
           a_preExp,
           a_varCopy,
           a_auxFunction )
      equation
        txt_1 = expTypeArrayIf(Tpl.emptyTxt, i_ty);
        (l_rhsStr, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(txt_1), a_varDecls);
        a_varCopy = Tpl.writeText(a_varCopy, a_preExp);
        a_varCopy = Tpl.softNewLine(a_varCopy);
        a_varCopy = Tpl.pushIter(a_varCopy, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (a_varCopy, a_auxFunction, a_varDecls, a_preExp) = lm_504(a_varCopy, i_varLst, l_rhsStr, a_auxFunction, a_varDecls, a_preExp, a_context, i_cr);
        a_varCopy = Tpl.popIter(a_varCopy);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("&"));
        txt = Tpl.writeText(txt, l_rhsStr);
      then (txt, a_varDecls, a_preExp, a_varCopy, a_auxFunction);

    case ( txt,
           DAE.CALL(path = _, expLst = i_expLst, attr = DAE.CALL_ATTR(ty = (i_ty as DAE.T_COMPLEX(varLst = i_varLst, complexClassType = ClassInf.RECORD(path = _))))),
           a_context,
           a_varDecls,
           a_preExp,
           a_varCopy,
           a_auxFunction )
      equation
        l_preExp = Tpl.emptyTxt;
        txt_3 = expTypeArrayIf(Tpl.emptyTxt, i_ty);
        (l_rhsStr, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(txt_3), a_varDecls);
        txt_5 = expTypeModelica(Tpl.emptyTxt, i_ty);
        (l_tmp, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(txt_5), a_varDecls);
        a_varCopy = Tpl.writeText(a_varCopy, l_preExp);
        a_varCopy = Tpl.softNewLine(a_varCopy);
        a_varCopy = Tpl.pushIter(a_varCopy, Tpl.ITER_OPTIONS(1, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (a_varCopy, a_auxFunction, a_varDecls, l_preExp) = lm_505(a_varCopy, i_varLst, l_rhsStr, a_auxFunction, a_varDecls, l_preExp, a_context, i_expLst);
        a_varCopy = Tpl.popIter(a_varCopy);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("&"));
        txt = Tpl.writeText(txt, l_rhsStr);
      then (txt, a_varDecls, a_preExp, a_varCopy, a_auxFunction);

    case ( txt,
           (i_inExp as DAE.CREF(ty = i_ty)),
           a_context,
           a_varDecls,
           a_preExp,
           a_varCopy,
           a_auxFunction )
      equation
        (l_res, a_preExp, a_varDecls, a_auxFunction) = daeExpCrefLhs(Tpl.emptyTxt, i_inExp, a_context, a_preExp, a_varDecls, a_auxFunction, false);
        ret_7 = Types.isArrayWithUnknownDimension(i_ty);
        (txt, a_preExp) = fun_506(txt, ret_7, a_preExp, l_res);
      then (txt, a_varDecls, a_preExp, a_varCopy, a_auxFunction);

    case ( txt,
           i_inExp,
           _,
           a_varDecls,
           a_preExp,
           a_varCopy,
           a_auxFunction )
      equation
        txt_8 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("tupleReturnVariableUpdates: Unhandled expression. "));
        txt_8 = ExpressionDumpTpl.dumpExp(txt_8, i_inExp, "\"");
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 3154, 11), Tpl.textString(txt_8));
      then (txt, a_varDecls, a_preExp, a_varCopy, a_auxFunction);
  end match;
end tupleReturnVariableUpdates;

protected function lm_508
  input Tpl.Text in_txt;
  input list<DAE.Statement> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Statement> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      SimCodeFunction.Context a_context;
      DAE.Statement i_stmt;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           _ )
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           i_stmt :: rest,
           a_auxFunction,
           a_varDecls,
           a_context )
      equation
        (txt, a_varDecls, a_auxFunction) = algStatement(txt, i_stmt, a_context, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls) = lm_508(txt, rest, a_auxFunction, a_varDecls, a_context);
      then (txt, a_auxFunction, a_varDecls);
  end match;
end lm_508;

public function algStmtIf
  input Tpl.Text in_txt;
  input DAE.Statement in_a_stmt;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_stmt, in_a_context, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Else i_else__;
      list<DAE.Statement> i_statementLst;
      DAE.Exp i_exp;
      Tpl.Text l_condExp;
      Tpl.Text l_preExp;

    case ( txt,
           DAE.STMT_IF(exp = i_exp, statementLst = i_statementLst, else_ = i_else__),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_condExp, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_exp, a_context, l_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if("));
        txt = Tpl.writeText(txt, l_condExp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ")\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_auxFunction, a_varDecls) = lm_508(txt, i_statementLst, a_auxFunction, a_varDecls, a_context);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("}\n"));
        (txt, a_varDecls, a_auxFunction) = elseExpr(txt, i_else__, a_context, a_varDecls, a_auxFunction);
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_varDecls,
           a_auxFunction )
      then (txt, a_varDecls, a_auxFunction);
  end match;
end algStmtIf;

public function algStmtParForBody
  input Tpl.Text in_txt;
  input DAE.Statement in_a_stmt;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_stmt, in_a_context, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Statement i_s;

    case ( txt,
           (i_s as DAE.STMT_PARFOR(range = DAE.RANGE(ty = _))),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_varDecls, a_auxFunction) = algStmtParForRangeBody(txt, i_s, a_context, a_varDecls, a_auxFunction);
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           (i_s as DAE.STMT_PARFOR(type_ = _)),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_varDecls, a_auxFunction) = algStmtForGeneric(txt, i_s, a_context, a_varDecls, a_auxFunction);
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_varDecls,
           a_auxFunction )
      then (txt, a_varDecls, a_auxFunction);
  end match;
end algStmtParForBody;

protected function lm_511
  input Tpl.Text in_txt;
  input list<DAE.Statement> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_loopVarDecls;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_loopVarDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_loopVarDecls) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_loopVarDecls, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Statement> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_loopVarDecls;
      SimCodeFunction.Context a_context;
      DAE.Statement i_stmt;

    case ( txt,
           {},
           a_auxFunction,
           a_loopVarDecls,
           _ )
      then (txt, a_auxFunction, a_loopVarDecls);

    case ( txt,
           i_stmt :: rest,
           a_auxFunction,
           a_loopVarDecls,
           a_context )
      equation
        (txt, a_loopVarDecls, a_auxFunction) = algStatement(txt, i_stmt, a_context, a_loopVarDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_loopVarDecls) = lm_511(txt, rest, a_auxFunction, a_loopVarDecls, a_context);
      then (txt, a_auxFunction, a_loopVarDecls);
  end match;
end lm_511;

protected function lm_512
  input Tpl.Text in_txt;
  input list<tuple<DAE.ComponentRef, SourceInfo>> in_items;
  input Tpl.Text in_a_reconstrucedArrays;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_reconstrucedArrays;
algorithm
  (out_txt, out_a_reconstrucedArrays) :=
  match(in_txt, in_items, in_a_reconstrucedArrays)
    local
      Tpl.Text txt;
      list<tuple<DAE.ComponentRef, SourceInfo>> rest;
      Tpl.Text a_reconstrucedArrays;
      tuple<DAE.ComponentRef, SourceInfo> i_var;

    case ( txt,
           {},
           a_reconstrucedArrays )
      then (txt, a_reconstrucedArrays);

    case ( txt,
           i_var :: rest,
           a_reconstrucedArrays )
      equation
        (txt, a_reconstrucedArrays) = reconstructKernelArraysFromLooptupleVars(txt, i_var, a_reconstrucedArrays);
        (txt, a_reconstrucedArrays) = lm_512(txt, rest, a_reconstrucedArrays);
      then (txt, a_reconstrucedArrays);
  end match;
end lm_512;

protected function lm_513
  input Tpl.Text in_txt;
  input list<tuple<DAE.ComponentRef, SourceInfo>> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<tuple<DAE.ComponentRef, SourceInfo>> rest;
      tuple<DAE.ComponentRef, SourceInfo> i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = parFunArgDefinitionFromLooptupleVar(txt, i_var);
        txt = Tpl.nextIter(txt);
        txt = lm_513(txt, rest);
      then txt;
  end match;
end lm_513;

protected function fun_514
  input Tpl.Text in_txt;
  input DAE.Statement in_a_stmt;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_auxFunction) :=
  match(in_txt, in_a_stmt, in_a_context, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_auxFunction;
      list<tuple<DAE.ComponentRef, SourceInfo>> i_loopPrlVars;
      list<DAE.Statement> i_statementLst;
      Boolean i_iterIsArray;
      DAE.Type i_type__;
      DAE.Ident i_iter;
      Tpl.Text l_argStr;
      Tpl.Text l_0__;
      Tpl.Text l_reconstrucedArrays;
      Tpl.Text l_body;
      Tpl.Text l_loopVarDecls;
      Integer ret_4;
      Tpl.Text l_parforKernelName;
      Tpl.Text l_identTypeShort;
      Tpl.Text l_identType;
      Tpl.Text l_iterName;

    case ( txt,
           DAE.STMT_PARFOR(range = DAE.RANGE(ty = _), iter = i_iter, type_ = i_type__, iterIsArray = i_iterIsArray, statementLst = i_statementLst, loopPrlVars = i_loopPrlVars),
           a_context,
           a_auxFunction )
      equation
        l_iterName = contextIteratorName(Tpl.emptyTxt, i_iter, a_context);
        l_identType = expType(Tpl.emptyTxt, i_type__, i_iterIsArray);
        l_identTypeShort = expTypeShort(Tpl.emptyTxt, i_type__);
        l_parforKernelName = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("parfor_"));
        ret_4 = System.tmpTickIndex(20);
        l_parforKernelName = Tpl.writeStr(l_parforKernelName, intString(ret_4));
        l_loopVarDecls = Tpl.emptyTxt;
        l_body = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_body, a_auxFunction, l_loopVarDecls) = lm_511(l_body, i_statementLst, a_auxFunction, l_loopVarDecls, a_context);
        l_body = Tpl.popIter(l_body);
        l_reconstrucedArrays = Tpl.emptyTxt;
        (l_0__, l_reconstrucedArrays) = lm_512(Tpl.emptyTxt, i_loopPrlVars, l_reconstrucedArrays);
        l_argStr = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_LINE(", \n")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_argStr = lm_513(l_argStr, i_loopPrlVars);
        l_argStr = Tpl.popIter(l_argStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "__kernel void "
                                }, false));
        txt = Tpl.writeText(txt, l_parforKernelName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(\n",
                                    "      modelica_integer loop_start,\n",
                                    "      modelica_integer loop_step,\n",
                                    "      modelica_integer loop_end,\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(6));
        txt = Tpl.writeText(txt, l_argStr);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(")\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "{\n",
                                    "  /* algStmtParForRangeBody : Thread managment for parfor loops */\n",
                                    "  modelica_integer inner_start = (get_global_id(0) * loop_step) + (loop_start);\n",
                                    "  modelica_integer stride = get_global_size(0) * loop_step;\n",
                                    "\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("for(modelica_integer "));
        txt = Tpl.writeText(txt, l_iterName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = (modelica_integer) inner_start; in_range_integer("));
        txt = Tpl.writeText(txt, l_iterName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", loop_start, loop_end); "));
        txt = Tpl.writeText(txt, l_iterName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " += stride)\n",
                                    "{\n",
                                    "  /* algStmtParForRangeBody : Reconstruct Arrays */\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_reconstrucedArrays);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "/* algStmtParForRangeBody : locals */\n"
                                }, true));
        txt = Tpl.writeText(txt, l_loopVarDecls);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_body);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("}\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then (txt, a_auxFunction);

    case ( txt,
           _,
           _,
           a_auxFunction )
      then (txt, a_auxFunction);
  end match;
end fun_514;

public function algStmtParForRangeBody
  input Tpl.Text txt;
  input DAE.Statement a_stmt;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_auxFunction) := fun_514(txt, a_stmt, a_context, a_auxFunction);
  out_a_varDecls := a_varDecls;
end algStmtParForRangeBody;

public function algStmtParForInterface
  input Tpl.Text in_txt;
  input DAE.Statement in_a_stmt;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_stmt, in_a_context, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Statement i_s;

    case ( txt,
           (i_s as DAE.STMT_PARFOR(range = DAE.RANGE(ty = _))),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_varDecls, a_auxFunction) = algStmtParForRangeInterface(txt, i_s, a_context, a_varDecls, a_auxFunction);
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           (i_s as DAE.STMT_PARFOR(type_ = _)),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_varDecls, a_auxFunction) = algStmtForGeneric(txt, i_s, a_context, a_varDecls, a_auxFunction);
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_varDecls,
           a_auxFunction )
      then (txt, a_varDecls, a_auxFunction);
  end match;
end algStmtParForInterface;

protected function lm_517
  input Tpl.Text in_txt;
  input list<DAE.Statement> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Statement> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      SimCodeFunction.Context a_context;
      DAE.Statement i_stmt;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           _ )
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           i_stmt :: rest,
           a_auxFunction,
           a_varDecls,
           a_context )
      equation
        (txt, a_varDecls, a_auxFunction) = algStatement(txt, i_stmt, a_context, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls) = lm_517(txt, rest, a_auxFunction, a_varDecls, a_context);
      then (txt, a_auxFunction, a_varDecls);
  end match;
end lm_517;

public function algStmtParForRangeInterface
  input Tpl.Text in_txt;
  input DAE.Statement in_a_stmt;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_stmt, in_a_context, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      list<tuple<DAE.ComponentRef, SourceInfo>> i_loopPrlVars;
      DAE.Ident i_iter;
      DAE.Exp i_rng;
      list<DAE.Statement> i_statementLst;
      Boolean i_iterIsArray;
      DAE.Type i_type__;
      Tpl.Text l_stmtStr;
      Tpl.Text l_identTypeShort;
      Tpl.Text l_identType;

    case ( txt,
           DAE.STMT_PARFOR(range = (i_rng as DAE.RANGE(ty = _)), type_ = i_type__, iterIsArray = i_iterIsArray, statementLst = i_statementLst, iter = i_iter, loopPrlVars = i_loopPrlVars),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        l_identType = expType(Tpl.emptyTxt, i_type__, i_iterIsArray);
        l_identTypeShort = expTypeShort(Tpl.emptyTxt, i_type__);
        l_stmtStr = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_stmtStr, a_auxFunction, a_varDecls) = lm_517(l_stmtStr, i_statementLst, a_auxFunction, a_varDecls, a_context);
        l_stmtStr = Tpl.popIter(l_stmtStr);
        (txt, l_stmtStr, a_varDecls, a_auxFunction) = algStmtParForRangeInterface_impl(txt, i_rng, i_iter, Tpl.textString(l_identType), Tpl.textString(l_identTypeShort), i_loopPrlVars, l_stmtStr, a_context, a_varDecls, a_auxFunction);
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_varDecls,
           a_auxFunction )
      then (txt, a_varDecls, a_auxFunction);
  end match;
end algStmtParForRangeInterface;

protected function fun_519
  input Tpl.Text in_txt;
  input Option<DAE.Exp> in_a_step;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_a_step, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Exp i_eo;

    case ( txt,
           SOME(i_eo),
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExp(txt, i_eo, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           _,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(modelica_integer)1"));
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end fun_519;

protected function lm_520
  input Tpl.Text in_txt;
  input list<tuple<DAE.ComponentRef, SourceInfo>> in_items;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_kernelArgSets;
  input Tpl.Text in_a_kerArgNr;
  input Tpl.Text in_a_cl__kernelVar;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_kernelArgSets;
  output Tpl.Text out_a_kerArgNr;
  output Tpl.Text out_a_cl__kernelVar;
algorithm
  (out_txt, out_a_kernelArgSets, out_a_kerArgNr, out_a_cl__kernelVar) :=
  match(in_txt, in_items, in_a_context, in_a_kernelArgSets, in_a_kerArgNr, in_a_cl__kernelVar)
    local
      Tpl.Text txt;
      list<tuple<DAE.ComponentRef, SourceInfo>> rest;
      SimCodeFunction.Context a_context;
      Tpl.Text a_kernelArgSets;
      Tpl.Text a_kerArgNr;
      Tpl.Text a_cl__kernelVar;
      tuple<DAE.ComponentRef, SourceInfo> i_varTuple;

    case ( txt,
           {},
           _,
           a_kernelArgSets,
           a_kerArgNr,
           a_cl__kernelVar )
      then (txt, a_kernelArgSets, a_kerArgNr, a_cl__kernelVar);

    case ( txt,
           i_varTuple :: rest,
           a_context,
           a_kernelArgSets,
           a_kerArgNr,
           a_cl__kernelVar )
      equation
        (txt, a_cl__kernelVar, a_kerArgNr, a_kernelArgSets) = setKernelArgFormTupleLoopVars_ith(txt, i_varTuple, a_cl__kernelVar, a_kerArgNr, a_kernelArgSets, a_context);
        (txt, a_kernelArgSets, a_kerArgNr, a_cl__kernelVar) = lm_520(txt, rest, a_context, a_kernelArgSets, a_kerArgNr, a_cl__kernelVar);
      then (txt, a_kernelArgSets, a_kerArgNr, a_cl__kernelVar);
  end match;
end lm_520;

protected function fun_521
  input Tpl.Text in_txt;
  input DAE.Exp in_a_range;
  input Absyn.Ident in_a_iterator;
  input String in_a_type;
  input list<tuple<DAE.ComponentRef, SourceInfo>> in_a_loopPrlVars;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_range, in_a_iterator, in_a_type, in_a_loopPrlVars, in_a_context, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      Absyn.Ident a_iterator;
      String a_type;
      list<tuple<DAE.ComponentRef, SourceInfo>> a_loopPrlVars;
      SimCodeFunction.Context a_context;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Exp i_stop;
      Option<DAE.Exp> i_step;
      DAE.Exp i_start;
      Tpl.Text l_0__;
      Tpl.Text l_kernelArgSets;
      Tpl.Text l_kerArgNr;
      Integer ret_10;
      Tpl.Text l_parforKernelName;
      Tpl.Text l_cl__kernelVar;
      Tpl.Text l_stopValue;
      Tpl.Text l_stepValue;
      Tpl.Text l_startValue;
      Tpl.Text l_preExp;
      Tpl.Text l_stopVar;
      Tpl.Text l_stepVar;
      Tpl.Text l_startVar;
      Tpl.Text l_iterName;

    case ( txt,
           DAE.RANGE(start = i_start, step = i_step, stop = i_stop),
           a_iterator,
           a_type,
           a_loopPrlVars,
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        l_iterName = contextIteratorName(Tpl.emptyTxt, a_iterator, a_context);
        (l_startVar, a_varDecls) = tempDecl(Tpl.emptyTxt, a_type, a_varDecls);
        (l_stepVar, a_varDecls) = tempDecl(Tpl.emptyTxt, a_type, a_varDecls);
        (l_stopVar, a_varDecls) = tempDecl(Tpl.emptyTxt, a_type, a_varDecls);
        l_preExp = Tpl.emptyTxt;
        (l_startValue, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_start, a_context, l_preExp, a_varDecls, a_auxFunction);
        (l_stepValue, a_auxFunction, a_varDecls, l_preExp) = fun_519(Tpl.emptyTxt, i_step, a_auxFunction, a_varDecls, l_preExp, a_context);
        (l_stopValue, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_stop, a_context, l_preExp, a_varDecls, a_auxFunction);
        (l_cl__kernelVar, a_varDecls) = tempDecl(Tpl.emptyTxt, "cl_kernel", a_varDecls);
        l_parforKernelName = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("parfor_"));
        ret_10 = System.tmpTickIndex(20);
        l_parforKernelName = Tpl.writeStr(l_parforKernelName, intString(ret_10));
        l_kerArgNr = Tpl.writeText(Tpl.emptyTxt, l_parforKernelName);
        l_kerArgNr = Tpl.writeTok(l_kerArgNr, Tpl.ST_STRING("_arg_nr"));
        l_kernelArgSets = Tpl.emptyTxt;
        (l_0__, l_kernelArgSets, l_kerArgNr, l_cl__kernelVar) = lm_520(Tpl.emptyTxt, a_loopPrlVars, a_context, l_kernelArgSets, l_kerArgNr, l_cl__kernelVar);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_startVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, l_startValue);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("; "));
        txt = Tpl.writeText(txt, l_stepVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, l_stepValue);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("; "));
        txt = Tpl.writeText(txt, l_stopVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, l_stopValue);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.writeText(txt, l_cl__kernelVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = ocl_create_kernel(omc_ocl_program, \""));
        txt = Tpl.writeText(txt, l_parforKernelName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\");\n",
                                    "int "
                                }, false));
        txt = Tpl.writeText(txt, l_kerArgNr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " = 0;\n",
                                    "\n",
                                    "ocl_set_kernel_arg("
                                }, false));
        txt = Tpl.writeText(txt, l_cl__kernelVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, l_kerArgNr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, l_startVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("); ++"));
        txt = Tpl.writeText(txt, l_kerArgNr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("; "));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "ocl_set_kernel_arg("
                                }, false));
        txt = Tpl.writeText(txt, l_cl__kernelVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, l_kerArgNr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, l_stepVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("); ++"));
        txt = Tpl.writeText(txt, l_kerArgNr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("; "));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "ocl_set_kernel_arg("
                                }, false));
        txt = Tpl.writeText(txt, l_cl__kernelVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, l_kerArgNr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, l_stopVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("); ++"));
        txt = Tpl.writeText(txt, l_kerArgNr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("; "));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "\n"
                                }, true));
        txt = Tpl.writeText(txt, l_kernelArgSets);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "ocl_execute_kernel("
                                }, false));
        txt = Tpl.writeText(txt, l_cl__kernelVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ");\n",
                                    "clReleaseKernel("
                                }, false));
        txt = Tpl.writeText(txt, l_cl__kernelVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ");\n",
                                    "\n",
                                    "\n"
                                }, true));
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           _,
           _,
           _,
           a_varDecls,
           a_auxFunction )
      then (txt, a_varDecls, a_auxFunction);
  end match;
end fun_521;

public function algStmtParForRangeInterface_impl
  input Tpl.Text txt;
  input DAE.Exp a_range;
  input Absyn.Ident a_iterator;
  input String a_type;
  input String a_shortType;
  input list<tuple<DAE.ComponentRef, SourceInfo>> a_loopPrlVars;
  input Tpl.Text a_body;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_body;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) := fun_521(txt, a_range, a_iterator, a_type, a_loopPrlVars, a_context, a_varDecls, a_auxFunction);
  out_a_body := a_body;
end algStmtParForRangeInterface_impl;

public function algStmtFor
  input Tpl.Text in_txt;
  input DAE.Statement in_a_stmt;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_stmt, in_a_context, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Statement i_s;

    case ( txt,
           (i_s as DAE.STMT_FOR(range = DAE.RANGE(ty = _))),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_varDecls, a_auxFunction) = algStmtForRange(txt, i_s, a_context, a_varDecls, a_auxFunction);
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           (i_s as DAE.STMT_FOR(type_ = _)),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_varDecls, a_auxFunction) = algStmtForGeneric(txt, i_s, a_context, a_varDecls, a_auxFunction);
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_varDecls,
           a_auxFunction )
      then (txt, a_varDecls, a_auxFunction);
  end match;
end algStmtFor;

protected function lm_524
  input Tpl.Text in_txt;
  input list<DAE.Statement> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Statement> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      SimCodeFunction.Context a_context;
      DAE.Statement i_stmt;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           _ )
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           i_stmt :: rest,
           a_auxFunction,
           a_varDecls,
           a_context )
      equation
        (txt, a_varDecls, a_auxFunction) = algStatement(txt, i_stmt, a_context, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls) = lm_524(txt, rest, a_auxFunction, a_varDecls, a_context);
      then (txt, a_auxFunction, a_varDecls);
  end match;
end lm_524;

public function algStmtForRange
  input Tpl.Text in_txt;
  input DAE.Statement in_a_stmt;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_stmt, in_a_context, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Ident i_iter;
      DAE.Exp i_rng;
      list<DAE.Statement> i_statementLst;
      Boolean i_iterIsArray;
      DAE.Type i_type__;
      Tpl.Text l_stmtStr;
      Tpl.Text l_identTypeShort;
      Tpl.Text l_identType;

    case ( txt,
           DAE.STMT_FOR(range = (i_rng as DAE.RANGE(ty = _)), type_ = i_type__, iterIsArray = i_iterIsArray, statementLst = i_statementLst, iter = i_iter),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        l_identType = expType(Tpl.emptyTxt, i_type__, i_iterIsArray);
        l_identTypeShort = expTypeShort(Tpl.emptyTxt, i_type__);
        l_stmtStr = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_stmtStr, a_auxFunction, a_varDecls) = lm_524(l_stmtStr, i_statementLst, a_auxFunction, a_varDecls, a_context);
        l_stmtStr = Tpl.popIter(l_stmtStr);
        (txt, l_stmtStr, a_varDecls, a_auxFunction) = algStmtForRange_impl(txt, i_rng, i_iter, Tpl.textString(l_identType), Tpl.textString(l_identTypeShort), l_stmtStr, a_context, a_varDecls, a_auxFunction);
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_varDecls,
           a_auxFunction )
      then (txt, a_varDecls, a_auxFunction);
  end match;
end algStmtForRange;

protected function fun_526
  input Tpl.Text in_txt;
  input Option<DAE.Exp> in_a_step;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_a_step, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Exp i_eo;

    case ( txt,
           SOME(i_eo),
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExp(txt, i_eo, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           _,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("1"));
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end fun_526;

protected function fun_527
  input Tpl.Text in_txt;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_context)
    local
      Tpl.Text txt;

    case ( txt,
           SimCodeFunction.FUNCTION_CONTEXT(cref_prefix = _) )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("equationIndexes, "));
      then txt;
  end match;
end fun_527;

protected function fun_528
  input Tpl.Text in_txt;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_context)
    local
      Tpl.Text txt;

    case ( txt,
           SimCodeFunction.FUNCTION_CONTEXT(cref_prefix = _) )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_withEquationIndexes"));
      then txt;
  end match;
end fun_528;

protected function fun_529
  input Tpl.Text in_txt;
  input String in_mArg;
  input Tpl.Text in_a_eqnsindx;
  input Tpl.Text in_a_AddionalFuncName;
  input Tpl.Text in_a_stepVar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_eqnsindx, in_a_AddionalFuncName, in_a_stepVar)
    local
      Tpl.Text txt;
      Tpl.Text a_eqnsindx;
      Tpl.Text a_AddionalFuncName;
      Tpl.Text a_stepVar;

    case ( txt,
           "1",
           _,
           _,
           _ )
      then txt;

    case ( txt,
           "((modelica_integer) 1)",
           _,
           _,
           _ )
      then txt;

    case ( txt,
           "((modelica_integer) -1)",
           _,
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_eqnsindx,
           a_AddionalFuncName,
           a_stepVar )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if(!"));
        txt = Tpl.writeText(txt, a_stepVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") {"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("  FILE_INFO info = omc_dummyFileInfo;"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("  omc_assert"));
        txt = Tpl.writeText(txt, a_AddionalFuncName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(threadData, info, "));
        txt = Tpl.writeText(txt, a_eqnsindx);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\"assertion range step != 0 failed\");"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("} else "));
      then txt;
  end match;
end fun_529;

protected function fun_530
  input Tpl.Text in_txt;
  input DAE.Exp in_a_range;
  input Absyn.Ident in_a_iterator;
  input String in_a_type;
  input String in_a_shortType;
  input Tpl.Text in_a_body;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_range, in_a_iterator, in_a_type, in_a_shortType, in_a_body, in_a_context, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      Absyn.Ident a_iterator;
      String a_type;
      String a_shortType;
      Tpl.Text a_body;
      SimCodeFunction.Context a_context;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Exp i_stop;
      Option<DAE.Exp> i_step;
      DAE.Exp i_start;
      String str_11;
      Tpl.Text l_stepCheck;
      Tpl.Text l_AddionalFuncName;
      Tpl.Text l_eqnsindx;
      Tpl.Text l_stopValue;
      Tpl.Text l_stepValue;
      Tpl.Text l_startValue;
      Tpl.Text l_preExp;
      Tpl.Text l_stopVar;
      Tpl.Text l_stepVar;
      Tpl.Text l_startVar;
      Tpl.Text l_iterName;

    case ( txt,
           DAE.RANGE(start = i_start, step = i_step, stop = i_stop),
           a_iterator,
           a_type,
           a_shortType,
           a_body,
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        l_iterName = contextIteratorName(Tpl.emptyTxt, a_iterator, a_context);
        (l_startVar, a_varDecls) = tempDecl(Tpl.emptyTxt, a_type, a_varDecls);
        (l_stepVar, a_varDecls) = tempDecl(Tpl.emptyTxt, a_type, a_varDecls);
        (l_stopVar, a_varDecls) = tempDecl(Tpl.emptyTxt, a_type, a_varDecls);
        l_preExp = Tpl.emptyTxt;
        (l_startValue, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_start, a_context, l_preExp, a_varDecls, a_auxFunction);
        (l_stepValue, a_auxFunction, a_varDecls, l_preExp) = fun_526(Tpl.emptyTxt, i_step, a_auxFunction, a_varDecls, l_preExp, a_context);
        (l_stopValue, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_stop, a_context, l_preExp, a_varDecls, a_auxFunction);
        l_eqnsindx = fun_527(Tpl.emptyTxt, a_context);
        l_AddionalFuncName = fun_528(Tpl.emptyTxt, a_context);
        str_11 = Tpl.textString(l_stepValue);
        l_stepCheck = fun_529(Tpl.emptyTxt, str_11, l_eqnsindx, l_AddionalFuncName, l_stepVar);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_startVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, l_startValue);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("; "));
        txt = Tpl.writeText(txt, l_stepVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, l_stepValue);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("; "));
        txt = Tpl.writeText(txt, l_stopVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, l_stopValue);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.writeText(txt, l_stepCheck);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if(!((("));
        txt = Tpl.writeText(txt, l_stepVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" > 0) && ("));
        txt = Tpl.writeText(txt, l_startVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" > "));
        txt = Tpl.writeText(txt, l_stopVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")) || (("));
        txt = Tpl.writeText(txt, l_stepVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" < 0) && ("));
        txt = Tpl.writeText(txt, l_startVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" < "));
        txt = Tpl.writeText(txt, l_stopVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "))))\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeStr(txt, a_type);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, l_iterName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "for("
                                }, false));
        txt = Tpl.writeText(txt, l_iterName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, l_startValue);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("; in_range_"));
        txt = Tpl.writeStr(txt, a_shortType);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, l_iterName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, l_startVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, l_stopVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("); "));
        txt = Tpl.writeText(txt, l_iterName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" += "));
        txt = Tpl.writeText(txt, l_stepVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ")\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_body);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("}\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           _,
           _,
           _,
           _,
           a_varDecls,
           a_auxFunction )
      then (txt, a_varDecls, a_auxFunction);
  end match;
end fun_530;

public function algStmtForRange_impl
  input Tpl.Text txt;
  input DAE.Exp a_range;
  input Absyn.Ident a_iterator;
  input String a_type;
  input String a_shortType;
  input Tpl.Text a_body;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_body;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) := fun_530(txt, a_range, a_iterator, a_type, a_shortType, a_body, a_context, a_varDecls, a_auxFunction);
  out_a_body := a_body;
end algStmtForRange_impl;

protected function fun_532
  input Tpl.Text in_txt;
  input String in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;
      String i_s;

    case ( txt,
           "modelica_string" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_metatype"));
      then txt;

    case ( txt,
           "modelica_fnptr" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_metatype"));
      then txt;

    case ( txt,
           i_s )
      equation
        txt = Tpl.writeStr(txt, i_s);
      then txt;
  end match;
end fun_532;

protected function fun_533
  input Tpl.Text in_txt;
  input String in_mArg;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_varDecls) :=
  match(in_txt, in_mArg, in_a_varDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_varDecls;

    case ( txt,
           "modelica_metatype",
           a_varDecls )
      equation
        (txt, a_varDecls) = tempDecl(txt, "modelica_metatype", a_varDecls);
      then (txt, a_varDecls);

    case ( txt,
           _,
           a_varDecls )
      equation
        (txt, a_varDecls) = tempDecl(txt, "int", a_varDecls);
      then (txt, a_varDecls);
  end match;
end fun_533;

protected function lm_534
  input Tpl.Text in_txt;
  input list<DAE.Statement> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Statement> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      SimCodeFunction.Context a_context;
      DAE.Statement i_stmt;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           _ )
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           i_stmt :: rest,
           a_auxFunction,
           a_varDecls,
           a_context )
      equation
        (txt, a_varDecls, a_auxFunction) = algStatement(txt, i_stmt, a_context, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls) = lm_534(txt, rest, a_auxFunction, a_varDecls, a_context);
      then (txt, a_auxFunction, a_varDecls);
  end match;
end lm_534;

public function algStmtForGeneric
  input Tpl.Text in_txt;
  input DAE.Statement in_a_stmt;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_stmt, in_a_context, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Ident i_iter;
      DAE.Exp i_range;
      list<DAE.Statement> i_statementLst;
      Boolean i_iterIsArray;
      DAE.Type i_type__;
      Tpl.Text l_stmtStr;
      String str_5;
      Tpl.Text l_tvar;
      Tpl.Text l_arrayType;
      String str_2;
      Tpl.Text txt_1;
      Tpl.Text l_iterType;

    case ( txt,
           DAE.STMT_FOR(type_ = i_type__, iterIsArray = i_iterIsArray, statementLst = i_statementLst, range = i_range, iter = i_iter),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        txt_1 = expType(Tpl.emptyTxt, i_type__, i_iterIsArray);
        str_2 = Tpl.textString(txt_1);
        l_iterType = fun_532(Tpl.emptyTxt, str_2);
        l_arrayType = expTypeArray(Tpl.emptyTxt, i_type__);
        str_5 = Tpl.textString(l_iterType);
        (l_tvar, a_varDecls) = fun_533(Tpl.emptyTxt, str_5, a_varDecls);
        l_stmtStr = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_stmtStr, a_auxFunction, a_varDecls) = lm_534(l_stmtStr, i_statementLst, a_auxFunction, a_varDecls, a_context);
        l_stmtStr = Tpl.popIter(l_stmtStr);
        (txt, l_stmtStr, l_tvar, a_varDecls, a_auxFunction) = algStmtForGeneric_impl(txt, i_range, i_iter, Tpl.textString(l_iterType), Tpl.textString(l_arrayType), i_iterIsArray, l_stmtStr, l_tvar, a_context, a_varDecls, a_auxFunction);
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_varDecls,
           a_auxFunction )
      then (txt, a_varDecls, a_auxFunction);
  end match;
end algStmtForGeneric;

protected function fun_536
  input Tpl.Text in_txt;
  input DAE.Type in_mArg;
  input Tpl.Text in_a_body;
  input Tpl.Text in_a_iterName;
  input Tpl.Text in_a_evar;
  input Tpl.Text in_a_tvar;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_varDecls) :=
  match(in_txt, in_mArg, in_a_body, in_a_iterName, in_a_evar, in_a_tvar, in_a_varDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_body;
      Tpl.Text a_iterName;
      Tpl.Text a_evar;
      Tpl.Text a_tvar;
      Tpl.Text a_varDecls;
      DAE.Type i_ty;
      Tpl.Text txt_2;
      String ret_2;
      Tpl.Text l_len;
      Tpl.Text l_tmp;

    case ( txt,
           DAE.T_METAARRAY(ty = _),
           a_body,
           a_iterName,
           a_evar,
           a_tvar,
           a_varDecls )
      equation
        (l_tmp, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_integer", a_varDecls);
        (l_len, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_integer", a_varDecls);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("for ("));
        txt = Tpl.writeText(txt, a_tvar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, a_evar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, l_len);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = arrayLength("));
        txt = Tpl.writeText(txt, a_tvar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("), "));
        txt = Tpl.writeText(txt, l_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = 1; "));
        txt = Tpl.writeText(txt, l_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" <= "));
        txt = Tpl.writeText(txt, l_len);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("; "));
        txt = Tpl.writeText(txt, l_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "++)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_iterName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = arrayGet("));
        txt = Tpl.writeText(txt, a_tvar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, l_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(");\n"));
        txt = Tpl.writeText(txt, a_body);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then (txt, a_varDecls);

    case ( txt,
           DAE.T_METATYPE(ty = DAE.T_METAARRAY(ty = _)),
           a_body,
           a_iterName,
           a_evar,
           a_tvar,
           a_varDecls )
      equation
        (l_tmp, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_integer", a_varDecls);
        (l_len, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_integer", a_varDecls);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("for ("));
        txt = Tpl.writeText(txt, a_tvar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, a_evar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, l_len);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = arrayLength("));
        txt = Tpl.writeText(txt, a_tvar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("), "));
        txt = Tpl.writeText(txt, l_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = 1; "));
        txt = Tpl.writeText(txt, l_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" <= "));
        txt = Tpl.writeText(txt, l_len);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("; "));
        txt = Tpl.writeText(txt, l_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "++)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_iterName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = arrayGet("));
        txt = Tpl.writeText(txt, a_tvar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, l_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(");\n"));
        txt = Tpl.writeText(txt, a_body);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then (txt, a_varDecls);

    case ( txt,
           DAE.T_METALIST(ty = _),
           a_body,
           a_iterName,
           a_evar,
           a_tvar,
           a_varDecls )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("for ("));
        txt = Tpl.writeText(txt, a_tvar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, a_evar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("; !listEmpty("));
        txt = Tpl.writeText(txt, a_tvar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("); "));
        txt = Tpl.writeText(txt, a_tvar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("=MMC_CDR("));
        txt = Tpl.writeText(txt, a_tvar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "))\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_iterName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = MMC_CAR("));
        txt = Tpl.writeText(txt, a_tvar);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(");\n"));
        txt = Tpl.writeText(txt, a_body);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then (txt, a_varDecls);

    case ( txt,
           DAE.T_METATYPE(ty = DAE.T_METALIST(ty = _)),
           a_body,
           a_iterName,
           a_evar,
           a_tvar,
           a_varDecls )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("for ("));
        txt = Tpl.writeText(txt, a_tvar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, a_evar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("; !listEmpty("));
        txt = Tpl.writeText(txt, a_tvar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("); "));
        txt = Tpl.writeText(txt, a_tvar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("=MMC_CDR("));
        txt = Tpl.writeText(txt, a_tvar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "))\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_iterName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = MMC_CAR("));
        txt = Tpl.writeText(txt, a_tvar);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(");\n"));
        txt = Tpl.writeText(txt, a_body);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then (txt, a_varDecls);

    case ( txt,
           i_ty,
           _,
           _,
           _,
           _,
           a_varDecls )
      equation
        ret_2 = Types.unparseType(i_ty);
        txt_2 = Tpl.writeStr(Tpl.emptyTxt, ret_2);
        txt_2 = Tpl.writeTok(txt_2, Tpl.ST_STRING(" iterator is not supported"));
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 3419, 26), Tpl.textString(txt_2));
      then (txt, a_varDecls);
  end match;
end fun_536;

protected function fun_537
  input Tpl.Text in_txt;
  input Boolean in_a_iterIsArray;
  input Tpl.Text in_a_ivar;
  input String in_a_type;
  input Tpl.Text in_a_tvar;
  input Tpl.Text in_a_evar;
  input String in_a_arrayType;
  input Tpl.Text in_a_iterName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_iterIsArray, in_a_ivar, in_a_type, in_a_tvar, in_a_evar, in_a_arrayType, in_a_iterName)
    local
      Tpl.Text txt;
      Tpl.Text a_ivar;
      String a_type;
      Tpl.Text a_tvar;
      Tpl.Text a_evar;
      String a_arrayType;
      Tpl.Text a_iterName;

    case ( txt,
           false,
           _,
           _,
           a_tvar,
           a_evar,
           a_arrayType,
           a_iterName )
      equation
        txt = Tpl.writeText(txt, a_iterName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeStr(txt, a_arrayType);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_get1("));
        txt = Tpl.writeText(txt, a_evar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", 1, "));
        txt = Tpl.writeText(txt, a_tvar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;

    case ( txt,
           _,
           a_ivar,
           a_type,
           a_tvar,
           a_evar,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("simple_index_alloc_"));
        txt = Tpl.writeStr(txt, a_type);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("1(&"));
        txt = Tpl.writeText(txt, a_evar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_tvar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", &"));
        txt = Tpl.writeText(txt, a_ivar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;
  end match;
end fun_537;

protected function fun_538
  input Tpl.Text in_txt;
  input String in_a_type;
  input Tpl.Text in_a_ivar;
  input String in_a_arrayType;
  input Boolean in_a_iterIsArray;
  input Tpl.Text in_a_body;
  input Tpl.Text in_a_iterName;
  input Tpl.Text in_a_evar;
  input Tpl.Text in_a_tvar;
  input Tpl.Text in_a_varDecls;
  input DAE.Exp in_a_exp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_varDecls) :=
  match(in_txt, in_a_type, in_a_ivar, in_a_arrayType, in_a_iterIsArray, in_a_body, in_a_iterName, in_a_evar, in_a_tvar, in_a_varDecls, in_a_exp)
    local
      Tpl.Text txt;
      Tpl.Text a_ivar;
      String a_arrayType;
      Boolean a_iterIsArray;
      Tpl.Text a_body;
      Tpl.Text a_iterName;
      Tpl.Text a_evar;
      Tpl.Text a_tvar;
      Tpl.Text a_varDecls;
      DAE.Exp a_exp;
      String i_type;
      Tpl.Text l_stmtStuff;
      DAE.Type ret_0;

    case ( txt,
           "modelica_metatype",
           _,
           _,
           _,
           a_body,
           a_iterName,
           a_evar,
           a_tvar,
           a_varDecls,
           a_exp )
      equation
        ret_0 = Expression.typeof(a_exp);
        (txt, a_varDecls) = fun_536(txt, ret_0, a_body, a_iterName, a_evar, a_tvar, a_varDecls);
      then (txt, a_varDecls);

    case ( txt,
           i_type,
           a_ivar,
           a_arrayType,
           a_iterIsArray,
           a_body,
           a_iterName,
           a_evar,
           a_tvar,
           a_varDecls,
           _ )
      equation
        l_stmtStuff = fun_537(Tpl.emptyTxt, a_iterIsArray, a_ivar, i_type, a_tvar, a_evar, a_arrayType, a_iterName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("for("));
        txt = Tpl.writeText(txt, a_tvar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = 1; "));
        txt = Tpl.writeText(txt, a_tvar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" <= size_of_dimension_base_array("));
        txt = Tpl.writeText(txt, a_evar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", 1); ++"));
        txt = Tpl.writeText(txt, a_tvar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ")\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_stmtStuff);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, a_body);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then (txt, a_varDecls);
  end match;
end fun_538;

public function algStmtForGeneric_impl
  input Tpl.Text txt;
  input DAE.Exp a_exp;
  input Absyn.Ident a_iterator;
  input String a_type;
  input String a_arrayType;
  input Boolean a_iterIsArray;
  input Tpl.Text a_body;
  input Tpl.Text a_tvar;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_body;
  output Tpl.Text out_a_tvar;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
protected
  Tpl.Text l_evar;
  Tpl.Text l_preExp;
  Tpl.Text l_ivar;
  Tpl.Text l_iterName;
algorithm
  l_iterName := contextIteratorName(Tpl.emptyTxt, a_iterator, a_context);
  (l_ivar, out_a_varDecls) := tempDecl(Tpl.emptyTxt, a_type, a_varDecls);
  l_preExp := Tpl.emptyTxt;
  (l_evar, l_preExp, out_a_varDecls, out_a_auxFunction) := daeExp(Tpl.emptyTxt, a_exp, a_context, l_preExp, out_a_varDecls, a_auxFunction);
  out_txt := Tpl.writeText(txt, l_preExp);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("{\n"));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeStr(out_txt, a_type);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING(" "));
  out_txt := Tpl.writeText(out_txt, l_iterName);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE(";\n"));
  (out_txt, out_a_varDecls) := fun_538(out_txt, a_type, l_ivar, a_arrayType, a_iterIsArray, a_body, l_iterName, l_evar, a_tvar, out_a_varDecls, a_exp);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("}"));
  out_a_body := a_body;
  out_a_tvar := a_tvar;
end algStmtForGeneric_impl;

protected function lm_540
  input Tpl.Text in_txt;
  input list<DAE.Statement> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Statement> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      SimCodeFunction.Context a_context;
      DAE.Statement i_stmt;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           _ )
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           i_stmt :: rest,
           a_auxFunction,
           a_varDecls,
           a_context )
      equation
        (txt, a_varDecls, a_auxFunction) = algStatement(txt, i_stmt, a_context, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls) = lm_540(txt, rest, a_auxFunction, a_varDecls, a_context);
      then (txt, a_auxFunction, a_varDecls);
  end match;
end lm_540;

public function algStmtWhile
  input Tpl.Text in_txt;
  input DAE.Statement in_a_stmt;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_stmt, in_a_context, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      list<DAE.Statement> i_statementLst;
      DAE.Exp i_exp;
      Tpl.Text l_var;
      Tpl.Text l_preExp;

    case ( txt,
           DAE.STMT_WHILE(exp = i_exp, statementLst = i_statementLst),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_var, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_exp, a_context, l_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "while(1)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if(!"));
        txt = Tpl.writeText(txt, l_var);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(") break;\n"));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_auxFunction, a_varDecls) = lm_540(txt, i_statementLst, a_auxFunction, a_varDecls, a_context);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_varDecls,
           a_auxFunction )
      then (txt, a_varDecls, a_auxFunction);
  end match;
end algStmtWhile;

public function algStmtAssert
  input Tpl.Text in_txt;
  input DAE.Statement in_a_stmt;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_stmt, in_a_context, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      SourceInfo i_info;
      DAE.Exp i_level;
      DAE.Exp i_msg;
      DAE.Exp i_cond;
      list<DAE.Exp> ret_0;

    case ( txt,
           DAE.STMT_ASSERT(source = DAE.SOURCE(info = i_info), cond = i_cond, msg = i_msg, level = i_level),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        ret_0 = List.fill(i_msg, 1);
        (txt, a_varDecls, a_auxFunction) = assertCommon(txt, i_cond, ret_0, i_level, a_context, a_varDecls, a_auxFunction, i_info);
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_varDecls,
           a_auxFunction )
      then (txt, a_varDecls, a_auxFunction);
  end match;
end algStmtAssert;

public function algStmtTerminate
  input Tpl.Text in_txt;
  input DAE.Statement in_a_stmt;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_stmt, in_a_context, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.ElementSource i_source;
      DAE.Exp i_msg;
      SourceInfo ret_2;
      Tpl.Text l_msgVar;
      Tpl.Text l_preExp;

    case ( txt,
           DAE.STMT_TERMINATE(msg = i_msg, source = i_source),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_msgVar, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_msg, a_context, l_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("{\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("FILE_INFO info = {"));
        ret_2 = ElementSource.getElementSourceFileInfo(i_source);
        txt = infoArgs(txt, ret_2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "};\n",
                                    "omc_terminate(info, MMC_STRINGDATA("
                                }, false));
        txt = Tpl.writeText(txt, l_msgVar);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("));\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_varDecls,
           a_auxFunction )
      then (txt, a_varDecls, a_auxFunction);
  end match;
end algStmtTerminate;

protected function lm_544
  input Tpl.Text in_txt;
  input list<DAE.Statement> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Statement> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      SimCodeFunction.Context a_context;
      DAE.Statement i_stmt;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           _ )
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           i_stmt :: rest,
           a_auxFunction,
           a_varDecls,
           a_context )
      equation
        (txt, a_varDecls, a_auxFunction) = algStatement(txt, i_stmt, a_context, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls) = lm_544(txt, rest, a_auxFunction, a_varDecls, a_context);
      then (txt, a_auxFunction, a_varDecls);
  end match;
end lm_544;

public function algStmtFailure
  input Tpl.Text in_txt;
  input DAE.Statement in_a_stmt;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_stmt, in_a_context, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      list<DAE.Statement> i_body;
      Tpl.Text l_stmtBody;
      Integer ret_3;
      Tpl.Text l_goto;
      Integer ret_1;
      Tpl.Text l_tmp;

    case ( txt,
           DAE.STMT_FAILURE(body = i_body),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        (l_tmp, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_boolean", a_varDecls);
        ret_1 = System.tmpTick();
        SimCodeFunctionUtil.codegenPushTryThrowIndex(ret_1);
        l_goto = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("goto_"));
        ret_3 = SimCodeFunctionUtil.codegenPeekTryThrowIndex();
        l_goto = Tpl.writeStr(l_goto, intString(ret_3));
        l_stmtBody = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_stmtBody, a_auxFunction, a_varDecls) = lm_544(l_stmtBody, i_body, a_auxFunction, a_varDecls, a_context);
        l_stmtBody = Tpl.popIter(l_stmtBody);
        txt = Tpl.writeText(txt, l_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " = 0; /* begin failure */\n",
                                    "MMC_TRY_INTERNAL(mmc_jumper)\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_stmtBody);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" = 1;\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("goto "));
        txt = Tpl.writeText(txt, l_goto);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.writeText(txt, l_goto);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ":;\n",
                                    "MMC_CATCH_INTERNAL(mmc_jumper)"
                                }, false));
        SimCodeFunctionUtil.codegenPopTryThrowIndex();
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if ("));
        txt = Tpl.writeText(txt, l_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") {"));
        txt = generateThrow(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";} /* end failure */"));
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_varDecls,
           a_auxFunction )
      then (txt, a_varDecls, a_auxFunction);
  end match;
end algStmtFailure;

protected function fun_546
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_expPart;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_expPart)
    local
      Tpl.Text txt;
      Tpl.Text a_expPart;

    case ( txt,
           false,
           a_expPart )
      equation
        txt = Tpl.writeText(txt, a_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_546;

public function algStmtNoretcall
  input Tpl.Text in_txt;
  input DAE.Statement in_a_stmt;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_stmt, in_a_context, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Exp i_exp;
      Boolean ret_2;
      Tpl.Text l_expPart;
      Tpl.Text l_preExp;

    case ( txt,
           DAE.STMT_NORETCALL(exp = (i_exp as DAE.MATCHEXPRESSION(matchType = _))),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_expPart, _, _, l_preExp, a_varDecls, a_auxFunction) = daeExpMatch2(Tpl.emptyTxt, i_exp, SimCodeFunction.listExpLength1, Tpl.strTokText(Tpl.ST_STRING("")), Tpl.strTokText(Tpl.ST_STRING("")), a_context, l_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.STMT_NORETCALL(exp = i_exp),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_expPart, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_exp, a_context, l_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        ret_2 = Util.isCIdentifier(Tpl.textString(l_expPart));
        txt = fun_546(txt, ret_2, l_expPart);
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_varDecls,
           a_auxFunction )
      then (txt, a_varDecls, a_auxFunction);
  end match;
end algStmtNoretcall;

protected function lm_548
  input Tpl.Text in_txt;
  input list<DAE.ComponentRef> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<DAE.ComponentRef> rest;
      DAE.ComponentRef i_e;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_e :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = cref(txt, i_e);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" && !"));
        txt = crefPre(txt, i_e);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" /* edge */)"));
        txt = Tpl.nextIter(txt);
        txt = lm_548(txt, rest);
      then txt;
  end match;
end lm_548;

protected function fun_549
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input list<DAE.ComponentRef> in_a_conditions;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_conditions)
    local
      Tpl.Text txt;
      list<DAE.ComponentRef> a_conditions;

    case ( txt,
           false,
           a_conditions )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(" || ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_548(txt, a_conditions);
        txt = Tpl.popIter(txt);
      then txt;

    case ( txt,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("0"));
      then txt;
  end match;
end fun_549;

protected function lm_550
  input Tpl.Text in_txt;
  input list<DAE.Statement> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Statement> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      SimCodeFunction.Context a_context;
      DAE.Statement i_stmt;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           _ )
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           i_stmt :: rest,
           a_auxFunction,
           a_varDecls,
           a_context )
      equation
        (txt, a_varDecls, a_auxFunction) = algStatement(txt, i_stmt, a_context, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls) = lm_550(txt, rest, a_auxFunction, a_varDecls, a_context);
      then (txt, a_auxFunction, a_varDecls);
  end match;
end lm_550;

protected function fun_551
  input Tpl.Text in_txt;
  input DAE.Statement in_a_when;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_a_when, in_a_auxFunction, in_a_varDecls, in_a_context)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      SimCodeFunction.Context a_context;
      Option<DAE.Statement> i_elseWhen;
      list<DAE.Statement> i_statementLst;
      list<DAE.ComponentRef> i_conditions;
      Tpl.Text l_else__clause;
      Tpl.Text l_statements;
      Boolean ret_1;
      Tpl.Text l_if__conditions;

    case ( txt,
           DAE.STMT_WHEN(conditions = i_conditions, statementLst = i_statementLst, elseWhen = i_elseWhen),
           a_auxFunction,
           a_varDecls,
           a_context )
      equation
        ret_1 = listEmpty(i_conditions);
        l_if__conditions = fun_549(Tpl.emptyTxt, ret_1, i_conditions);
        l_statements = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_statements, a_auxFunction, a_varDecls) = lm_550(l_statements, i_statementLst, a_auxFunction, a_varDecls, a_context);
        l_statements = Tpl.popIter(l_statements);
        (l_else__clause, a_varDecls, a_auxFunction) = algStatementWhenElse(Tpl.emptyTxt, i_elseWhen, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "if(data->simulationInfo->discreteCall == 1)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if("));
        txt = Tpl.writeText(txt, l_if__conditions);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ")\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_statements);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("}\n"));
        txt = Tpl.writeText(txt, l_else__clause);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           _,
           a_auxFunction,
           a_varDecls,
           _ )
      then (txt, a_auxFunction, a_varDecls);
  end match;
end fun_551;

protected function lm_552
  input Tpl.Text in_txt;
  input list<DAE.ComponentRef> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<DAE.ComponentRef> rest;
      DAE.ComponentRef i_e;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_e :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = cref(txt, i_e);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" && !"));
        txt = crefPre(txt, i_e);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" /* edge */)"));
        txt = Tpl.nextIter(txt);
        txt = lm_552(txt, rest);
      then txt;
  end match;
end lm_552;

protected function fun_553
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input list<DAE.ComponentRef> in_a_conditions;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_conditions)
    local
      Tpl.Text txt;
      list<DAE.ComponentRef> a_conditions;

    case ( txt,
           false,
           a_conditions )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(" || ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_552(txt, a_conditions);
        txt = Tpl.popIter(txt);
      then txt;

    case ( txt,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("0"));
      then txt;
  end match;
end fun_553;

protected function lm_554
  input Tpl.Text in_txt;
  input list<DAE.Statement> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Statement> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      SimCodeFunction.Context a_context;
      DAE.Statement i_stmt;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           _ )
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           i_stmt :: rest,
           a_auxFunction,
           a_varDecls,
           a_context )
      equation
        (txt, a_varDecls, a_auxFunction) = algStatement(txt, i_stmt, a_context, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls) = lm_554(txt, rest, a_auxFunction, a_varDecls, a_context);
      then (txt, a_auxFunction, a_varDecls);
  end match;
end lm_554;

protected function fun_555
  input Tpl.Text in_txt;
  input DAE.Statement in_a_when;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_a_when, in_a_auxFunction, in_a_varDecls, in_a_context)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      SimCodeFunction.Context a_context;
      Option<DAE.Statement> i_elseWhen;
      list<DAE.Statement> i_statementLst;
      list<DAE.ComponentRef> i_conditions;
      Tpl.Text l_else__clause;
      Tpl.Text l_statements;
      Boolean ret_1;
      Tpl.Text l_if__conditions;

    case ( txt,
           DAE.STMT_WHEN(conditions = i_conditions, statementLst = i_statementLst, elseWhen = i_elseWhen),
           a_auxFunction,
           a_varDecls,
           a_context )
      equation
        ret_1 = listEmpty(i_conditions);
        l_if__conditions = fun_553(Tpl.emptyTxt, ret_1, i_conditions);
        l_statements = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_statements, a_auxFunction, a_varDecls) = lm_554(l_statements, i_statementLst, a_auxFunction, a_varDecls, a_context);
        l_statements = Tpl.popIter(l_statements);
        (l_else__clause, a_varDecls, a_auxFunction) = algStatementWhenElse(Tpl.emptyTxt, i_elseWhen, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "if(data->simulationInfo->discreteCall == 1)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if("));
        txt = Tpl.writeText(txt, l_if__conditions);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ")\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_statements);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("}\n"));
        txt = Tpl.writeText(txt, l_else__clause);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           _,
           a_auxFunction,
           a_varDecls,
           _ )
      then (txt, a_auxFunction, a_varDecls);
  end match;
end fun_555;

protected function fun_556
  input Tpl.Text in_txt;
  input SimCodeFunction.Context in_a_context;
  input DAE.Statement in_a_when;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_context, in_a_when, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      DAE.Statement a_when;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      SimCodeFunction.Context i_context;

    case ( txt,
           (i_context as SimCodeFunction.DAE_MODE_CONTEXT()),
           a_when,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_auxFunction, a_varDecls) = fun_551(txt, a_when, a_auxFunction, a_varDecls, i_context);
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           (i_context as SimCodeFunction.SIMULATION_CONTEXT(genDiscrete = _)),
           a_when,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_auxFunction, a_varDecls) = fun_555(txt, a_when, a_auxFunction, a_varDecls, i_context);
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_varDecls,
           a_auxFunction )
      then (txt, a_varDecls, a_auxFunction);
  end match;
end fun_556;

public function algStmtWhen
  input Tpl.Text txt;
  input DAE.Statement a_when;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) := fun_556(txt, a_context, a_when, a_varDecls, a_auxFunction);
end algStmtWhen;

protected function lm_558
  input Tpl.Text in_txt;
  input list<DAE.ComponentRef> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<DAE.ComponentRef> rest;
      DAE.ComponentRef i_e;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_e :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = cref(txt, i_e);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" && !"));
        txt = crefPre(txt, i_e);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" /* edge */)"));
        txt = Tpl.nextIter(txt);
        txt = lm_558(txt, rest);
      then txt;
  end match;
end lm_558;

protected function fun_559
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input list<DAE.ComponentRef> in_a_when_conditions;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_when_conditions)
    local
      Tpl.Text txt;
      list<DAE.ComponentRef> a_when_conditions;

    case ( txt,
           false,
           a_when_conditions )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(" || ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_558(txt, a_when_conditions);
        txt = Tpl.popIter(txt);
      then txt;

    case ( txt,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("0"));
      then txt;
  end match;
end fun_559;

protected function lm_560
  input Tpl.Text in_txt;
  input list<DAE.Statement> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls)
    local
      Tpl.Text txt;
      list<DAE.Statement> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      DAE.Statement i_stmt;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls )
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           i_stmt :: rest,
           a_auxFunction,
           a_varDecls )
      equation
        (txt, a_varDecls, a_auxFunction) = algStatement(txt, i_stmt, SimCodeFunction.contextSimulationDiscrete, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls) = lm_560(txt, rest, a_auxFunction, a_varDecls);
      then (txt, a_auxFunction, a_varDecls);
  end match;
end lm_560;

public function algStatementWhenElse
  input Tpl.Text in_txt;
  input Option<DAE.Statement> in_a_stmt;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_stmt, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      Option<DAE.Statement> i_when_elseWhen;
      list<DAE.Statement> i_when_statementLst;
      list<DAE.ComponentRef> i_when_conditions;
      Tpl.Text l_else;
      Tpl.Text l_statements;
      Boolean ret_1;
      Tpl.Text l_else__conditions;

    case ( txt,
           SOME(DAE.STMT_WHEN(conditions = i_when_conditions, statementLst = i_when_statementLst, elseWhen = i_when_elseWhen)),
           a_varDecls,
           a_auxFunction )
      equation
        ret_1 = listEmpty(i_when_conditions);
        l_else__conditions = fun_559(Tpl.emptyTxt, ret_1, i_when_conditions);
        l_statements = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_statements, a_auxFunction, a_varDecls) = lm_560(l_statements, i_when_statementLst, a_auxFunction, a_varDecls);
        l_statements = Tpl.popIter(l_statements);
        (l_else, a_varDecls, a_auxFunction) = algStatementWhenElse(Tpl.emptyTxt, i_when_elseWhen, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("else if("));
        txt = Tpl.writeText(txt, l_else__conditions);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ")\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_statements);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("}\n"));
        txt = Tpl.writeText(txt, l_else);
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           a_varDecls,
           a_auxFunction )
      then (txt, a_varDecls, a_auxFunction);
  end match;
end algStatementWhenElse;

public function algStmtReinit
  input Tpl.Text in_txt;
  input DAE.Statement in_a_stmt;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_stmt, in_a_context, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Exp i_value;
      DAE.Exp i_var;
      Tpl.Text l_expPart2;
      Tpl.Text l_expPart1;
      Tpl.Text l_preExp;

    case ( txt,
           DAE.STMT_REINIT(var = i_var, value = i_value),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_expPart1, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_var, a_context, l_preExp, a_varDecls, a_auxFunction);
        (l_expPart2, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_value, a_context, l_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_expPart1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, l_expPart2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "infoStreamPrint(LOG_EVENTS, 0, \"reinit "
                                }, false));
        txt = Tpl.writeText(txt, l_expPart1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = %f\", "));
        txt = Tpl.writeText(txt, l_expPart1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ");\n",
                                    "data->simulationInfo->needToIterate = 1;"
                                }, false));
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_varDecls,
           a_auxFunction )
      then (txt, a_varDecls, a_auxFunction);
  end match;
end algStmtReinit;

protected function lm_563
  input Tpl.Text in_txt;
  input list<DAE.Statement> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Statement> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      SimCodeFunction.Context a_context;
      DAE.Statement i_stmt;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           _ )
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           i_stmt :: rest,
           a_auxFunction,
           a_varDecls,
           a_context )
      equation
        (txt, a_varDecls, a_auxFunction) = algStatement(txt, i_stmt, a_context, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls) = lm_563(txt, rest, a_auxFunction, a_varDecls, a_context);
      then (txt, a_auxFunction, a_varDecls);
  end match;
end lm_563;

protected function lm_564
  input Tpl.Text in_txt;
  input list<DAE.Statement> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Statement> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      SimCodeFunction.Context a_context;
      DAE.Statement i_stmt;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           _ )
      then (txt, a_auxFunction, a_varDecls);

    case ( txt,
           i_stmt :: rest,
           a_auxFunction,
           a_varDecls,
           a_context )
      equation
        (txt, a_varDecls, a_auxFunction) = algStatement(txt, i_stmt, a_context, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls) = lm_564(txt, rest, a_auxFunction, a_varDecls, a_context);
      then (txt, a_auxFunction, a_varDecls);
  end match;
end lm_564;

public function elseExpr
  input Tpl.Text in_txt;
  input DAE.Else in_a_else__;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_else__, in_a_context, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Else i_else__;
      list<DAE.Statement> i_statementLst;
      DAE.Exp i_exp;
      Tpl.Text l_condExp;
      Tpl.Text l_preExp;

    case ( txt,
           DAE.NOELSE(),
           _,
           a_varDecls,
           a_auxFunction )
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.ELSEIF(exp = i_exp, statementLst = i_statementLst, else_ = i_else__),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_condExp, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_exp, a_context, l_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "else\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if("));
        txt = Tpl.writeText(txt, l_condExp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ")\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_auxFunction, a_varDecls) = lm_563(txt, i_statementLst, a_auxFunction, a_varDecls, a_context);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("}\n"));
        (txt, a_varDecls, a_auxFunction) = elseExpr(txt, i_else__, a_context, a_varDecls, a_auxFunction);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.ELSE(statementLst = i_statementLst),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "else\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_auxFunction, a_varDecls) = lm_564(txt, i_statementLst, a_auxFunction, a_varDecls, a_context);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_varDecls,
           a_auxFunction )
      then (txt, a_varDecls, a_auxFunction);
  end match;
end elseExpr;

protected function fun_566
  input Tpl.Text in_txt;
  input Option<SimCodeFunction.Function> in_a_mainFunction;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_mainFunction)
    local
      Tpl.Text txt;
      SimCodeFunction.Function i_fn;

    case ( txt,
           SOME(i_fn) )
      equation
        txt = functionBodyParModelica(txt, i_fn, true);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_566;

public function functionsParModelicaKernelsFile
  input Tpl.Text txt;
  input String a_filePrefix;
  input Option<SimCodeFunction.Function> a_mainFunction;
  input list<SimCodeFunction.Function> a_functions;

  output Tpl.Text out_txt;
algorithm
  System.tmpTickResetIndex(0, 20);
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                   "#include <ParModelica/explicit/openclrt/OCLRuntimeUtil.cl>\n",
                                   "\n",
                                   "// ParModelica Parallel Function headers.\n"
                               }, true));
  out_txt := functionHeadersParModelica(out_txt, a_filePrefix, a_functions);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "// Headers finish here.\n",
                                       "\n"
                                   }, true));
  out_txt := fun_566(out_txt, a_mainFunction);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := functionBodiesParModelica(out_txt, a_functions);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "\n"
                                   }, true));
end functionsParModelicaKernelsFile;

protected function fun_568
  input Tpl.Text in_txt;
  input Boolean in_a_isSimulation;
  input String in_a_filePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_isSimulation, in_a_filePrefix)
    local
      Tpl.Text txt;
      String a_filePrefix;

    case ( txt,
           false,
           a_filePrefix )
      equation
        txt = Tpl.writeStr(txt, a_filePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".h"));
      then txt;

    case ( txt,
           _,
           a_filePrefix )
      equation
        txt = Tpl.writeStr(txt, a_filePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_functions.h"));
      then txt;
  end match;
end fun_568;

protected function lm_569
  input Tpl.Text in_txt;
  input list<SimCodeFunction.RecordDeclaration> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeFunction.RecordDeclaration> rest;
      SimCodeFunction.RecordDeclaration i_rd;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_rd :: rest )
      equation
        txt = recordDeclaration(txt, i_rd);
        txt = Tpl.nextIter(txt);
        txt = lm_569(txt, rest);
      then txt;
  end match;
end lm_569;

public function recordsFile
  input Tpl.Text txt;
  input String a_filePrefix;
  input list<SimCodeFunction.RecordDeclaration> a_recordDecls;
  input Boolean a_isSimulation;

  output Tpl.Text out_txt;
protected
  String ret_1;
  Tpl.Text l_recDeclsFile;
algorithm
  l_recDeclsFile := fun_568(Tpl.emptyTxt, a_isSimulation, a_filePrefix);
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING("/* Additional record code for "));
  out_txt := Tpl.writeStr(out_txt, a_filePrefix);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING(" generated by the OpenModelica Compiler "));
  ret_1 := Settings.getVersionNr();
  out_txt := Tpl.writeStr(out_txt, ret_1);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       ". */\n",
                                       "\n",
                                       "#include \"omc_simulation_settings.h\"\n",
                                       "#include \"meta/meta_modelica.h\"\n",
                                       "#include \""
                                   }, false));
  out_txt := Tpl.writeText(out_txt, l_recDeclsFile);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\"\n",
                                       "\n",
                                       "#ifdef __cplusplus\n",
                                       "extern \"C\" {\n",
                                       "#endif\n",
                                       "\n"
                                   }, true));
  out_txt := Tpl.pushIter(out_txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING_LIST({
                                                                        "\n",
                                                                        "\n"
                                                                    }, true)), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_569(out_txt, a_recordDecls);
  out_txt := Tpl.popIter(out_txt);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "#ifdef __cplusplus\n",
                                       "}\n",
                                       "#endif\n",
                                       "\n"
                                   }, true));
end recordsFile;

protected function lm_571
  input Tpl.Text in_txt;
  input list<Integer> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<Integer> rest;
      Integer i_dim;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_dim :: rest )
      equation
        txt = Tpl.writeStr(txt, intString(i_dim));
        txt = Tpl.nextIter(txt);
        txt = lm_571(txt, rest);
      then txt;
  end match;
end lm_571;

protected function lm_572
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      DAE.Exp i_exp;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_exp :: rest )
      equation
        txt = literalExpConstArrayVal(txt, i_exp);
        txt = Tpl.nextIter(txt);
        txt = lm_572(txt, rest);
      then txt;
  end match;
end lm_572;

protected function fun_573
  input Tpl.Text in_txt;
  input String in_mArg;
  input Tpl.Text in_a_data;
  input Tpl.Text in_a_sty;
  input Tpl.Text in_a_ndim;
  input Tpl.Text in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_data, in_a_sty, in_a_ndim, in_a_name)
    local
      Tpl.Text txt;
      Tpl.Text a_data;
      Tpl.Text a_sty;
      Tpl.Text a_ndim;
      Tpl.Text a_name;

    case ( txt,
           "",
           _,
           _,
           a_ndim,
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("static base_array_t const "));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" = {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_ndim);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_dims, (void*) 0, (modelica_boolean) 0\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("};"));
      then txt;

    case ( txt,
           _,
           a_data,
           a_sty,
           a_ndim,
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("static const modelica_"));
        txt = Tpl.writeText(txt, a_sty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_data[] = {"));
        txt = Tpl.writeText(txt, a_data);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "};\n",
                                    "static "
                                }, false));
        txt = Tpl.writeText(txt, a_sty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_array const "));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" = {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_ndim);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_dims, (void*) "));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_data, (modelica_boolean) 0\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("};"));
      then txt;
  end match;
end fun_573;

protected function lm_574
  input Tpl.Text in_txt;
  input list<Integer> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<Integer> rest;
      Integer i_dim;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_dim :: rest )
      equation
        txt = Tpl.writeStr(txt, intString(i_dim));
        txt = Tpl.nextIter(txt);
        txt = lm_574(txt, rest);
      then txt;
  end match;
end lm_574;

protected function lm_575
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      DAE.Exp i_exp;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_exp :: rest )
      equation
        txt = literalExpConstArrayVal(txt, i_exp);
        txt = Tpl.nextIter(txt);
        txt = lm_575(txt, rest);
      then txt;
  end match;
end lm_575;

protected function fun_576
  input Tpl.Text in_txt;
  input String in_mArg;
  input Tpl.Text in_a_data;
  input Tpl.Text in_a_sty;
  input Tpl.Text in_a_ndim;
  input Tpl.Text in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_data, in_a_sty, in_a_ndim, in_a_name)
    local
      Tpl.Text txt;
      Tpl.Text a_data;
      Tpl.Text a_sty;
      Tpl.Text a_ndim;
      Tpl.Text a_name;

    case ( txt,
           "",
           _,
           _,
           a_ndim,
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("static base_array_t const "));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" = {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_ndim);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_dims, (void*) 0, (modelica_boolean) 0\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("};"));
      then txt;

    case ( txt,
           _,
           a_data,
           a_sty,
           a_ndim,
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("static const modelica_"));
        txt = Tpl.writeText(txt, a_sty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_data[] = {"));
        txt = Tpl.writeText(txt, a_data);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "};\n",
                                    "static "
                                }, false));
        txt = Tpl.writeText(txt, a_sty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_array const "));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" = {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_ndim);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_dims, (void*) "));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_data, (modelica_boolean) 0\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("};"));
      then txt;
  end match;
end fun_576;

protected function fun_577
  input Tpl.Text in_txt;
  input Integer in_a_i;
  input Tpl.Text in_a_tmp;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_i, in_a_tmp)
    local
      Tpl.Text txt;
      Tpl.Text a_tmp;
      Integer i_i;
      Integer ret_0;

    case ( txt,
           1,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("mmc_nil"));
      then txt;

    case ( txt,
           i_i,
           a_tmp )
      equation
        txt = Tpl.writeText(txt, a_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_cons_"));
        ret_0 = intSub(i_i, 1);
        txt = Tpl.writeStr(txt, intString(ret_0));
      then txt;
  end match;
end fun_577;

protected function lm_578
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Tpl.Text in_a_tmp;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_tmp)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Tpl.Text a_tmp;
      Integer x_i;
      DAE.Exp i_v;
      Tpl.Text txt_1;
      Tpl.Text txt_0;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_v :: rest,
           a_tmp )
      equation
        x_i = Tpl.getIteri_i0(txt);
        txt_0 = Tpl.writeText(Tpl.emptyTxt, a_tmp);
        txt_0 = Tpl.writeTok(txt_0, Tpl.ST_STRING("_elt_"));
        txt_0 = Tpl.writeStr(txt_0, intString(x_i));
        (txt, txt_0) = literalExpConstBoxedValPreLit(txt, i_v, txt_0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("static const MMC_DEFSTRUCTLIT("));
        txt = Tpl.writeText(txt, a_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_cons_"));
        txt = Tpl.writeStr(txt, intString(x_i));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(",2,1) {"));
        txt_1 = Tpl.writeText(Tpl.emptyTxt, a_tmp);
        txt_1 = Tpl.writeTok(txt_1, Tpl.ST_STRING("_elt_"));
        txt_1 = Tpl.writeStr(txt_1, intString(x_i));
        (txt, txt_1) = literalExpConstBoxedVal(txt, i_v, txt_1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(",MMC_REFSTRUCTLIT("));
        txt = fun_577(txt, x_i, a_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")}};"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.nextIter(txt);
        txt = lm_578(txt, rest, a_tmp);
      then txt;
  end match;
end lm_578;

protected function lm_579
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Integer in_a_litindex;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_litindex)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Integer a_litindex;
      Integer x_i0;
      DAE.Exp i_exp;
      Tpl.Text txt_0;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_exp :: rest,
           a_litindex )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt_0 = Tpl.writeStr(Tpl.emptyTxt, intString(a_litindex));
        txt_0 = Tpl.writeTok(txt_0, Tpl.ST_STRING("_"));
        txt_0 = Tpl.writeStr(txt_0, intString(x_i0));
        (txt, txt_0) = literalExpConstBoxedValPreLit(txt, i_exp, txt_0);
        txt = Tpl.nextIter(txt);
        txt = lm_579(txt, rest, a_litindex);
      then txt;
  end match;
end lm_579;

protected function fun_580
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input list<DAE.Exp> in_a_listExp;
  input Tpl.Text in_a_tmp;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_listExp, in_a_tmp)
    local
      Tpl.Text txt;
      list<DAE.Exp> a_listExp;
      Tpl.Text a_tmp;
      Integer ret_0;

    case ( txt,
           false,
           a_listExp,
           a_tmp )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("MMC_DEFSTRUCTLIT("));
        txt = Tpl.writeText(txt, a_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        ret_0 = listLength(a_listExp);
        txt = Tpl.writeStr(txt, intString(ret_0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(",0)"));
      then txt;

    case ( txt,
           _,
           _,
           a_tmp )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("MMC_DEFSTRUCT0LIT("));
        txt = Tpl.writeText(txt, a_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(",0)"));
      then txt;
  end match;
end fun_580;

protected function lm_581
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Integer in_a_litindex;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_litindex)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Integer a_litindex;
      Integer x_i0;
      DAE.Exp i_exp;
      Tpl.Text txt_0;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_exp :: rest,
           a_litindex )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt_0 = Tpl.writeStr(Tpl.emptyTxt, intString(a_litindex));
        txt_0 = Tpl.writeTok(txt_0, Tpl.ST_STRING("_"));
        txt_0 = Tpl.writeStr(txt_0, intString(x_i0));
        (txt, txt_0) = literalExpConstBoxedVal(txt, i_exp, txt_0);
        txt = Tpl.nextIter(txt);
        txt = lm_581(txt, rest, a_litindex);
      then txt;
  end match;
end lm_581;

protected function lm_582
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Integer in_a_litindex;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_litindex)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Integer a_litindex;
      Integer x_i0;
      DAE.Exp i_exp;
      Tpl.Text txt_0;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_exp :: rest,
           a_litindex )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt_0 = Tpl.writeStr(Tpl.emptyTxt, intString(a_litindex));
        txt_0 = Tpl.writeTok(txt_0, Tpl.ST_STRING("_"));
        txt_0 = Tpl.writeStr(txt_0, intString(x_i0));
        (txt, txt_0) = literalExpConstBoxedValPreLit(txt, i_exp, txt_0);
        txt = Tpl.nextIter(txt);
        txt = lm_582(txt, rest, a_litindex);
      then txt;
  end match;
end lm_582;

protected function lm_583
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Integer in_a_litindex;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_litindex)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Integer a_litindex;
      Integer x_i0;
      DAE.Exp i_exp;
      Tpl.Text txt_0;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_exp :: rest,
           a_litindex )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt_0 = Tpl.writeStr(Tpl.emptyTxt, intString(a_litindex));
        txt_0 = Tpl.writeTok(txt_0, Tpl.ST_STRING("_"));
        txt_0 = Tpl.writeStr(txt_0, intString(x_i0));
        (txt, txt_0) = literalExpConstBoxedVal(txt, i_exp, txt_0);
        txt = Tpl.nextIter(txt);
        txt = lm_583(txt, rest, a_litindex);
      then txt;
  end match;
end lm_583;

protected function lm_584
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Integer in_a_litindex;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_litindex)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Integer a_litindex;
      Integer x_i0;
      DAE.Exp i_exp;
      Tpl.Text txt_0;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_exp :: rest,
           a_litindex )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt_0 = Tpl.writeStr(Tpl.emptyTxt, intString(a_litindex));
        txt_0 = Tpl.writeTok(txt_0, Tpl.ST_STRING("_"));
        txt_0 = Tpl.writeStr(txt_0, intString(x_i0));
        (txt, txt_0) = literalExpConstBoxedValPreLit(txt, i_exp, txt_0);
        txt = Tpl.nextIter(txt);
        txt = lm_584(txt, rest, a_litindex);
      then txt;
  end match;
end lm_584;

protected function lm_585
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Integer in_a_litindex;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_litindex)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Integer a_litindex;
      Integer x_i0;
      DAE.Exp i_exp;
      Tpl.Text txt_0;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_exp :: rest,
           a_litindex )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt_0 = Tpl.writeStr(Tpl.emptyTxt, intString(a_litindex));
        txt_0 = Tpl.writeTok(txt_0, Tpl.ST_STRING("_"));
        txt_0 = Tpl.writeStr(txt_0, intString(x_i0));
        (txt, txt_0) = literalExpConstBoxedVal(txt, i_exp, txt_0);
        txt = Tpl.nextIter(txt);
        txt = lm_585(txt, rest, a_litindex);
      then txt;
  end match;
end lm_585;

protected function fun_586
  input Tpl.Text in_txt;
  input DAE.Exp in_mArg;
  input DAE.Exp in_a_e;
  input Tpl.Text in_a_name;
  input Tpl.Text in_a_tmp;
  input Integer in_a_litindex;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_e, in_a_name, in_a_tmp, in_a_litindex)
    local
      Tpl.Text txt;
      DAE.Exp a_e;
      Tpl.Text a_name;
      Tpl.Text a_tmp;
      Integer a_litindex;
      list<DAE.Exp> i_args;
      Tpl.Text txt_1;
      Integer ret_0;

    case ( txt,
           DAE.LIST(valList = i_args),
           _,
           a_name,
           a_tmp,
           a_litindex )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), NONE(), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_584(txt, i_args, a_litindex);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("static const MMC_DEFSTRUCTLIT("));
        txt = Tpl.writeText(txt, a_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        ret_0 = listLength(i_args);
        txt = Tpl.writeStr(txt, intString(ret_0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(",MMC_ARRAY_TAG) {"));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_585(txt, i_args, a_litindex);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}};\n",
                                    "#define "
                                }, false));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" MMC_REFSTRUCTLIT("));
        txt = Tpl.writeText(txt, a_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           _,
           a_e,
           _,
           _,
           _ )
      equation
        txt_1 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("literalExpConst failed; listArrayLiteral requires a list or cons-cells: "));
        txt_1 = ExpressionDumpTpl.dumpExp(txt_1, a_e, "\"");
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 3769, 16), Tpl.textString(txt_1));
      then txt;
  end match;
end fun_586;

protected function fun_587
  input Tpl.Text in_txt;
  input DAE.Exp in_a_lit;
  input Integer in_a_litindex;
  input Tpl.Text in_a_meta;
  input Tpl.Text in_a_tmp;
  input Tpl.Text in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_lit, in_a_litindex, in_a_meta, in_a_tmp, in_a_name)
    local
      Tpl.Text txt;
      Integer a_litindex;
      Tpl.Text a_meta;
      Tpl.Text a_tmp;
      Tpl.Text a_name;
      DAE.Exp i_e;
      Absyn.Path i_path;
      list<DAE.Exp> i_args;
      Integer i_index;
      DAE.Exp i_exp;
      list<DAE.Exp> i_listExp;
      list<DAE.Exp> i_valList;
      DAE.Exp i_cdr;
      DAE.Exp i_car;
      Real i_exp_real;
      Boolean i_exp_bool;
      Integer i_exp_integer;
      DAE.Exp i_lit;
      DAE.Type i_ty;
      String i_string;
      Tpl.Text txt_32;
      DAE.Exp ret_31;
      Integer ret_30;
      Integer ret_29;
      Integer ret_28;
      Tpl.Text l_newIndex;
      Tpl.Text txt_26;
      Tpl.Text txt_25;
      Boolean ret_24;
      Integer ret_23;
      list<DAE.Exp> ret_22;
      Tpl.Text l_x;
      Tpl.Text txt_20;
      Tpl.Text txt_19;
      Tpl.Text txt_18;
      Tpl.Text txt_17;
      String str_16;
      list<DAE.Exp> ret_15;
      list<Integer> ret_14;
      Integer ret_13;
      list<Integer> ret_12;
      String str_11;
      list<DAE.Exp> ret_10;
      Tpl.Text l_data;
      list<Integer> ret_8;
      Tpl.Text l_dims;
      Tpl.Text l_sty;
      Integer ret_5;
      list<Integer> ret_4;
      Tpl.Text l_ndim;
      Integer ret_2;
      String ret_1;
      Tpl.Text l_escstr;

    case ( txt,
           DAE.SCONST(string = i_string),
           _,
           _,
           a_tmp,
           a_name )
      equation
        ret_1 = Util.escapeModelicaStringToCString(i_string);
        l_escstr = Tpl.writeStr(Tpl.emptyTxt, ret_1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#define "));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_data \""));
        txt = Tpl.writeText(txt, l_escstr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\"\n",
                                    "static const MMC_DEFSTRINGLIT("
                                }, false));
        txt = Tpl.writeText(txt, a_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        ret_2 = System.unescapedStringLength(Tpl.textString(l_escstr));
        txt = Tpl.writeStr(txt, intString(ret_2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_data);\n",
                                    "#define "
                                }, false));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" MMC_REFSTRINGLIT("));
        txt = Tpl.writeText(txt, a_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           (i_lit as DAE.MATRIX(ty = (i_ty as DAE.T_ARRAY(ty = _)))),
           _,
           _,
           _,
           a_name )
      equation
        ret_4 = Types.getDimensionSizes(i_ty);
        ret_5 = listLength(ret_4);
        l_ndim = Tpl.writeStr(Tpl.emptyTxt, intString(ret_5));
        l_sty = expTypeShort(Tpl.emptyTxt, i_ty);
        ret_8 = Types.getDimensionSizes(i_ty);
        l_dims = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_dims = lm_571(l_dims, ret_8);
        l_dims = Tpl.popIter(l_dims);
        ret_10 = Expression.flattenArrayExpToList(i_lit);
        l_data = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_data = lm_572(l_data, ret_10);
        l_data = Tpl.popIter(l_data);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("static _index_t "));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_dims["));
        txt = Tpl.writeText(txt, l_ndim);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = {"));
        txt = Tpl.writeText(txt, l_dims);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("};\n"));
        str_11 = Tpl.textString(l_data);
        txt = fun_573(txt, str_11, l_data, l_sty, l_ndim, a_name);
      then txt;

    case ( txt,
           (i_lit as DAE.ARRAY(ty = (i_ty as DAE.T_ARRAY(ty = _)))),
           _,
           _,
           _,
           a_name )
      equation
        ret_12 = Types.getDimensionSizes(i_ty);
        ret_13 = listLength(ret_12);
        l_ndim = Tpl.writeStr(Tpl.emptyTxt, intString(ret_13));
        l_sty = expTypeShort(Tpl.emptyTxt, i_ty);
        ret_14 = Types.getDimensionSizes(i_ty);
        l_dims = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_dims = lm_574(l_dims, ret_14);
        l_dims = Tpl.popIter(l_dims);
        ret_15 = Expression.flattenArrayExpToList(i_lit);
        l_data = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_data = lm_575(l_data, ret_15);
        l_data = Tpl.popIter(l_data);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("static _index_t "));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_dims["));
        txt = Tpl.writeText(txt, l_ndim);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = {"));
        txt = Tpl.writeText(txt, l_dims);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("};\n"));
        str_16 = Tpl.textString(l_data);
        txt = fun_576(txt, str_16, l_data, l_sty, l_ndim, a_name);
      then txt;

    case ( txt,
           DAE.BOX(exp = DAE.ICONST(integer = i_exp_integer)),
           _,
           a_meta,
           _,
           _ )
      equation
        txt = Tpl.writeText(txt, a_meta);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = MMC_IMMEDIATE(MMC_TAGFIXNUM("));
        txt = Tpl.writeStr(txt, intString(i_exp_integer));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("));"));
      then txt;

    case ( txt,
           DAE.BOX(exp = DAE.BCONST(bool = i_exp_bool)),
           _,
           a_meta,
           _,
           _ )
      equation
        txt = Tpl.writeText(txt, a_meta);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = MMC_IMMEDIATE(MMC_TAGFIXNUM("));
        txt = boolStrC(txt, i_exp_bool);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("));"));
      then txt;

    case ( txt,
           DAE.BOX(exp = DAE.RCONST(real = i_exp_real)),
           _,
           _,
           a_tmp,
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("static const MMC_DEFREALLIT("));
        txt = Tpl.writeText(txt, a_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeStr(txt, realString(i_exp_real));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ");\n",
                                    "#define "
                                }, false));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" MMC_REFREALLIT("));
        txt = Tpl.writeText(txt, a_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.CONS(car = i_car, cdr = i_cdr),
           a_litindex,
           _,
           a_tmp,
           a_name )
      equation
        txt_17 = Tpl.writeStr(Tpl.emptyTxt, intString(a_litindex));
        txt_17 = Tpl.writeTok(txt_17, Tpl.ST_STRING("_car"));
        (txt, txt_17) = literalExpConstBoxedValPreLit(txt, i_car, txt_17);
        txt_18 = Tpl.writeStr(Tpl.emptyTxt, intString(a_litindex));
        txt_18 = Tpl.writeTok(txt_18, Tpl.ST_STRING("_cdr"));
        (txt, txt_18) = literalExpConstBoxedValPreLit(txt, i_cdr, txt_18);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("static const MMC_DEFSTRUCTLIT("));
        txt = Tpl.writeText(txt, a_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(",2,1) {"));
        txt_19 = Tpl.writeStr(Tpl.emptyTxt, intString(a_litindex));
        txt_19 = Tpl.writeTok(txt_19, Tpl.ST_STRING("_car"));
        (txt, txt_19) = literalExpConstBoxedVal(txt, i_car, txt_19);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt_20 = Tpl.writeStr(Tpl.emptyTxt, intString(a_litindex));
        txt_20 = Tpl.writeTok(txt_20, Tpl.ST_STRING("_cdr"));
        (txt, txt_20) = literalExpConstBoxedVal(txt, i_cdr, txt_20);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}};\n",
                                    "#define "
                                }, false));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" MMC_REFSTRUCTLIT("));
        txt = Tpl.writeText(txt, a_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.LIST(valList = i_valList),
           _,
           _,
           a_tmp,
           a_name )
      equation
        ret_22 = listReverse(i_valList);
        l_x = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(1, NONE(), NONE(), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_x = lm_578(l_x, ret_22, a_tmp);
        l_x = Tpl.popIter(l_x);
        txt = Tpl.writeText(txt, l_x);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#define "));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" MMC_REFSTRUCTLIT("));
        txt = Tpl.writeText(txt, a_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_cons_"));
        ret_23 = listLength(i_valList);
        txt = Tpl.writeStr(txt, intString(ret_23));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.META_TUPLE(listExp = i_listExp),
           a_litindex,
           _,
           a_tmp,
           a_name )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), NONE(), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_579(txt, i_listExp, a_litindex);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("static const "));
        ret_24 = listEmpty(i_listExp);
        txt = fun_580(txt, ret_24, i_listExp, a_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" {"));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_581(txt, i_listExp, a_litindex);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}};\n",
                                    "#define "
                                }, false));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" MMC_REFSTRUCTLIT("));
        txt = Tpl.writeText(txt, a_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.META_OPTION(exp = SOME(i_exp)),
           a_litindex,
           _,
           a_tmp,
           a_name )
      equation
        txt_25 = Tpl.writeStr(Tpl.emptyTxt, intString(a_litindex));
        txt_25 = Tpl.writeTok(txt_25, Tpl.ST_STRING("_1"));
        (txt, txt_25) = literalExpConstBoxedValPreLit(txt, i_exp, txt_25);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("static const MMC_DEFSTRUCTLIT("));
        txt = Tpl.writeText(txt, a_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(",1,1) {"));
        txt_26 = Tpl.writeStr(Tpl.emptyTxt, intString(a_litindex));
        txt_26 = Tpl.writeTok(txt_26, Tpl.ST_STRING("_1"));
        (txt, txt_26) = literalExpConstBoxedVal(txt, i_exp, txt_26);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}};\n",
                                    "#define "
                                }, false));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" MMC_REFSTRUCTLIT("));
        txt = Tpl.writeText(txt, a_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.METARECORDCALL(index = i_index, args = i_args, path = i_path),
           a_litindex,
           _,
           a_tmp,
           a_name )
      equation
        ret_28 = Patternm.getValueCtor(i_index);
        l_newIndex = Tpl.writeStr(Tpl.emptyTxt, intString(ret_28));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), NONE(), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_582(txt, i_args, a_litindex);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("static const MMC_DEFSTRUCTLIT("));
        txt = Tpl.writeText(txt, a_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        ret_29 = listLength(i_args);
        ret_30 = intAdd(1, ret_29);
        txt = Tpl.writeStr(txt, intString(ret_30));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, l_newIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") {&"));
        txt = CodegenUtil.underscorePath(txt, i_path);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("__desc,"));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_583(txt, i_args, a_litindex);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}};\n",
                                    "#define "
                                }, false));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" MMC_REFSTRUCTLIT("));
        txt = Tpl.writeText(txt, a_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "listArrayLiteral"), expLst = {i_e}),
           a_litindex,
           _,
           a_tmp,
           a_name )
      equation
        ret_31 = Expression.consToListIgnoreSharedLiteral(i_e);
        txt = fun_586(txt, ret_31, i_e, a_name, a_tmp, a_litindex);
      then txt;

    case ( txt,
           i_lit,
           _,
           _,
           _,
           _ )
      equation
        txt_32 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("literalExpConst failed: "));
        txt_32 = ExpressionDumpTpl.dumpExp(txt_32, i_lit, "\"");
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 3770, 14), Tpl.textString(txt_32));
      then txt;
  end match;
end fun_587;

public function literalExpConst
  input Tpl.Text txt;
  input DAE.Exp a_lit;
  input Integer a_litindex;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_meta;
  Tpl.Text l_tmp;
  Tpl.Text l_name;
algorithm
  l_name := Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("_OMC_LIT"));
  l_name := Tpl.writeStr(l_name, intString(a_litindex));
  l_tmp := Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("_OMC_LIT_STRUCT"));
  l_tmp := Tpl.writeStr(l_tmp, intString(a_litindex));
  l_meta := Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("static modelica_metatype const "));
  l_meta := Tpl.writeText(l_meta, l_name);
  out_txt := fun_587(txt, a_lit, a_litindex, l_meta, l_tmp, l_name);
end literalExpConst;

protected function fun_589
  input Tpl.Text in_txt;
  input DAE.Exp in_a_lit;
  input Tpl.Text in_a_index;
  input Tpl.Text in_a_name;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_index;
algorithm
  (out_txt, out_a_index) :=
  match(in_txt, in_a_lit, in_a_index, in_a_name)
    local
      Tpl.Text txt;
      Tpl.Text a_index;
      Tpl.Text a_name;
      DAE.Exp i_lit;
      Integer i_lit_index;
      DAE.Exp i_lit_exp;
      Boolean i_lit_bool;
      Integer i_index;
      Integer i_integer;
      Tpl.Text txt_0;

    case ( txt,
           DAE.ICONST(integer = i_integer),
           a_index,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("MMC_IMMEDIATE(MMC_TAGFIXNUM("));
        txt = Tpl.writeStr(txt, intString(i_integer));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("))"));
      then (txt, a_index);

    case ( txt,
           DAE.ENUM_LITERAL(index = i_index),
           a_index,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("MMC_IMMEDIATE(MMC_TAGFIXNUM("));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("))"));
      then (txt, a_index);

    case ( txt,
           DAE.BCONST(bool = i_lit_bool),
           a_index,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("MMC_IMMEDIATE(MMC_TAGFIXNUM("));
        txt = boolStrC(txt, i_lit_bool);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("))"));
      then (txt, a_index);

    case ( txt,
           DAE.RCONST(real = _),
           a_index,
           a_name )
      equation
        txt = Tpl.writeText(txt, a_name);
      then (txt, a_index);

    case ( txt,
           DAE.LIST(valList = {}),
           a_index,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("MMC_REFSTRUCTLIT(mmc_nil)"));
      then (txt, a_index);

    case ( txt,
           DAE.META_OPTION(exp = NONE()),
           a_index,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("MMC_REFSTRUCTLIT(mmc_none)"));
      then (txt, a_index);

    case ( txt,
           DAE.BOX(exp = i_lit_exp),
           a_index,
           _ )
      equation
        (txt, a_index) = literalExpConstBoxedVal(txt, i_lit_exp, a_index);
      then (txt, a_index);

    case ( txt,
           DAE.SHARED_LITERAL(index = i_lit_index),
           a_index,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_OMC_LIT"));
        txt = Tpl.writeStr(txt, intString(i_lit_index));
      then (txt, a_index);

    case ( txt,
           i_lit,
           a_index,
           _ )
      equation
        txt_0 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("literalExpConstBoxedVal failed: "));
        txt_0 = ExpressionDumpTpl.dumpExp(txt_0, i_lit, "\"");
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 3791, 14), Tpl.textString(txt_0));
      then (txt, a_index);
  end match;
end fun_589;

public function literalExpConstBoxedVal
  input Tpl.Text txt;
  input DAE.Exp a_lit;
  input Tpl.Text a_index;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_index;
protected
  Tpl.Text l_name;
algorithm
  l_name := Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("_OMC_LIT"));
  l_name := Tpl.writeText(l_name, a_index);
  (out_txt, out_a_index) := fun_589(txt, a_lit, a_index, l_name);
end literalExpConstBoxedVal;

public function literalExpConstBoxedValPreLit
  input Tpl.Text in_txt;
  input DAE.Exp in_a_lit;
  input Tpl.Text in_a_index;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_index;
algorithm
  (out_txt, out_a_index) :=
  match(in_txt, in_a_lit, in_a_index)
    local
      Tpl.Text txt;
      Tpl.Text a_index;
      DAE.Exp i_lit_exp;
      Real i_lit_real;
      Tpl.Text l_name;
      Tpl.Text l_tmp;

    case ( txt,
           DAE.RCONST(real = i_lit_real),
           a_index )
      equation
        l_tmp = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("_OMC_LIT_STRUCT"));
        l_tmp = Tpl.writeText(l_tmp, a_index);
        l_name = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("_OMC_LIT"));
        l_name = Tpl.writeText(l_name, a_index);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("static const MMC_DEFREALLIT("));
        txt = Tpl.writeText(txt, l_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeStr(txt, realString(i_lit_real));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ");\n",
                                    "#define "
                                }, false));
        txt = Tpl.writeText(txt, l_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" MMC_REFREALLIT("));
        txt = Tpl.writeText(txt, l_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then (txt, a_index);

    case ( txt,
           DAE.BOX(exp = i_lit_exp),
           a_index )
      equation
        (txt, a_index) = literalExpConstBoxedValPreLit(txt, i_lit_exp, a_index);
      then (txt, a_index);

    case ( txt,
           _,
           a_index )
      then (txt, a_index);
  end match;
end literalExpConstBoxedValPreLit;

public function literalExpConstArrayVal
  input Tpl.Text in_txt;
  input DAE.Exp in_a_lit;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_lit)
    local
      Tpl.Text txt;
      DAE.Exp i_lit;
      Integer i_lit_index;
      Integer i_index;
      Real i_real;
      Boolean i_lit_bool;
      Integer i_integer;
      Tpl.Text txt_0;

    case ( txt,
           DAE.ICONST(integer = i_integer) )
      equation
        txt = Tpl.writeStr(txt, intString(i_integer));
      then txt;

    case ( txt,
           DAE.BCONST(bool = i_lit_bool) )
      equation
        txt = boolStrC(txt, i_lit_bool);
      then txt;

    case ( txt,
           DAE.RCONST(real = i_real) )
      equation
        txt = Tpl.writeStr(txt, realString(i_real));
      then txt;

    case ( txt,
           DAE.ENUM_LITERAL(index = i_index) )
      equation
        txt = Tpl.writeStr(txt, intString(i_index));
      then txt;

    case ( txt,
           DAE.SHARED_LITERAL(index = i_lit_index) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_OMC_LIT"));
        txt = Tpl.writeStr(txt, intString(i_lit_index));
      then txt;

    case ( txt,
           i_lit )
      equation
        txt_0 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("literalExpConstArrayVal failed: "));
        txt_0 = ExpressionDumpTpl.dumpExp(txt_0, i_lit, "\"");
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 3815, 16), Tpl.textString(txt_0));
      then txt;
  end match;
end literalExpConstArrayVal;

protected function fun_593
  input Tpl.Text in_txt;
  input list<DAE.Dimension> in_a_instDims;
  input DAE.Type in_a_var_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_instDims, in_a_var_ty)
    local
      Tpl.Text txt;
      DAE.Type a_var_ty;

    case ( txt,
           {},
           a_var_ty )
      equation
        txt = expTypeArrayIf(txt, a_var_ty);
      then txt;

    case ( txt,
           _,
           a_var_ty )
      equation
        txt = expTypeArray(txt, a_var_ty);
      then txt;
  end match;
end fun_593;

protected function fun_594
  input Tpl.Text in_txt;
  input list<DAE.Dimension> in_a_instDims;
  input DAE.Type in_a_var_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_instDims, in_a_var_ty)
    local
      Tpl.Text txt;
      DAE.Type a_var_ty;

    case ( txt,
           {},
           a_var_ty )
      equation
        txt = expTypeArrayIf(txt, a_var_ty);
      then txt;

    case ( txt,
           _,
           a_var_ty )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("device_"));
        txt = expTypeArray(txt, a_var_ty);
      then txt;
  end match;
end fun_594;

protected function fun_595
  input Tpl.Text in_txt;
  input list<DAE.Dimension> in_a_instDims;
  input DAE.Type in_a_var_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_instDims, in_a_var_ty)
    local
      Tpl.Text txt;
      DAE.Type a_var_ty;

    case ( txt,
           {},
           a_var_ty )
      equation
        txt = expTypeArrayIf(txt, a_var_ty);
      then txt;

    case ( txt,
           _,
           a_var_ty )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("device_local_"));
        txt = expTypeArray(txt, a_var_ty);
      then txt;
  end match;
end fun_595;

public function varType
  input Tpl.Text in_txt;
  input SimCodeFunction.Variable in_a_var;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_var)
    local
      Tpl.Text txt;
      DAE.Type i_var_ty;
      list<DAE.Dimension> i_instDims;

    case ( txt,
           SimCodeFunction.VARIABLE(parallelism = DAE.NON_PARALLEL(), instDims = i_instDims, ty = i_var_ty) )
      equation
        txt = fun_593(txt, i_instDims, i_var_ty);
      then txt;

    case ( txt,
           SimCodeFunction.VARIABLE(ty = (i_var_ty as DAE.T_ARRAY(ty = _)), parallelism = DAE.PARGLOBAL()) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("device_"));
        txt = expTypeArray(txt, i_var_ty);
      then txt;

    case ( txt,
           SimCodeFunction.VARIABLE(parallelism = DAE.PARGLOBAL(), instDims = i_instDims, ty = i_var_ty) )
      equation
        txt = fun_594(txt, i_instDims, i_var_ty);
      then txt;

    case ( txt,
           SimCodeFunction.VARIABLE(ty = (i_var_ty as DAE.T_ARRAY(ty = _)), parallelism = DAE.PARLOCAL()) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("device_local_"));
        txt = expTypeArray(txt, i_var_ty);
      then txt;

    case ( txt,
           SimCodeFunction.VARIABLE(parallelism = DAE.PARLOCAL(), instDims = i_instDims, ty = i_var_ty) )
      equation
        txt = fun_595(txt, i_instDims, i_var_ty);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end varType;

public function varTypeBoxed
  input Tpl.Text in_txt;
  input SimCodeFunction.Variable in_a_var;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_var)
    local
      Tpl.Text txt;

    case ( txt,
           SimCodeFunction.VARIABLE(name = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_metatype"));
      then txt;

    case ( txt,
           SimCodeFunction.FUNCTION_PTR(name = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_fnptr"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end varTypeBoxed;

protected function fun_598
  input Tpl.Text in_txt;
  input SimCodeFunction.Context in_a_context;
  input DAE.ComponentRef in_a_cref;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_context, in_a_cref)
    local
      Tpl.Text txt;
      DAE.ComponentRef a_cref;
      HashTableCrefSimVar.HashTable i_hashTable;

    case ( txt,
           SimCodeFunction.OMSI_CONTEXT(hashTable = SOME(i_hashTable)),
           a_cref )
      equation
        txt = crefToOMSICStr(txt, a_cref, i_hashTable);
      then txt;

    case ( txt,
           SimCodeFunction.JACOBIAN_CONTEXT(jacHT = SOME(i_hashTable)),
           a_cref )
      equation
        txt = crefToOMSICStr(txt, a_cref, i_hashTable);
      then txt;

    case ( txt,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("ERROR in crefOMSI: No valid SimCodeFunction.Context"));
      then txt;
  end match;
end fun_598;

public function crefOMSI
  input Tpl.Text in_txt;
  input DAE.ComponentRef in_a_cref;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_cref, in_a_context)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      DAE.ComponentRef i_cref;

    case ( txt,
           DAE.CREF_IDENT(ident = "time"),
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("this_function->function_vars->time_value"));
      then txt;

    case ( txt,
           i_cref,
           a_context )
      equation
        txt = fun_598(txt, a_context, i_cref);
      then txt;
  end match;
end crefOMSI;

protected function fun_600
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;
      DAE.ComponentRef i_name;
      SimCodeVar.SimVar i_v;
      BackendDAE.VarKind i_v_varKind;
      DAE.ComponentRef i_v_name;
      Tpl.Text txt_5;
      String ret_4;
      SimCode.SimCode ret_3;
      Tpl.Text l_index;
      Tpl.Text txt_1;
      Tpl.Text l_c__comment;

    case ( txt,
           (i_v as SimCodeVar.SIMVAR(name = (i_name as i_v_name), varKind = i_v_varKind)) )
      equation
        l_c__comment = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("/* "));
        txt_1 = CodegenUtil.crefStrNoUnderscore(Tpl.emptyTxt, i_v_name);
        l_c__comment = CodegenUtil.escapeCComments(l_c__comment, Tpl.textString(txt_1));
        l_c__comment = Tpl.writeTok(l_c__comment, Tpl.ST_STRING(" "));
        l_c__comment = CodegenUtil.variabilityString(l_c__comment, i_v_varKind);
        l_c__comment = Tpl.writeTok(l_c__comment, Tpl.ST_STRING(" */"));
        ret_3 = SimCodeUtil.getSimCode();
        ret_4 = SimCodeUtil.getValueReference(i_v, ret_3, false);
        l_index = Tpl.writeStr(Tpl.emptyTxt, ret_4);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("this_function->pre_vars->"));
        txt = crefTypeOMSIC(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("["));
        txt = Tpl.writeText(txt, l_index);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] "));
        txt = Tpl.writeText(txt, l_c__comment);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" /* TODO: Check why pre variable  "));
        txt_5 = CodegenUtil.crefStrNoUnderscore(Tpl.emptyTxt, i_v_name);
        txt = CodegenUtil.escapeCComments(txt, Tpl.textString(txt_5));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" is not in local hash table! */"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_600;

protected function fun_601
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_mArg;
  input DAE.ComponentRef in_a_componentRef;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_componentRef)
    local
      Tpl.Text txt;
      DAE.ComponentRef a_componentRef;
      DAE.ComponentRef i_name;
      SimCodeVar.SimVar i_v;
      BackendDAE.VarKind i_v_varKind;
      DAE.ComponentRef i_v_name;
      String ret_6;
      SimCode.SimCode ret_5;
      Tpl.Text l_index;
      Tpl.Text txt_3;
      Tpl.Text l_c__comment;
      SimCodeVar.SimVar ret_1;
      SimCode.SimCode ret_0;

    case ( txt,
           SimCodeVar.SIMVAR(index = -2),
           a_componentRef )
      equation
        ret_0 = SimCodeUtil.getSimCode();
        ret_1 = SimCodeUtil.cref2simvar(a_componentRef, ret_0);
        txt = fun_600(txt, ret_1);
      then txt;

    case ( txt,
           (i_v as SimCodeVar.SIMVAR(name = (i_name as i_v_name), varKind = i_v_varKind)),
           _ )
      equation
        l_c__comment = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("/* "));
        txt_3 = CodegenUtil.crefStrNoUnderscore(Tpl.emptyTxt, i_v_name);
        l_c__comment = CodegenUtil.escapeCComments(l_c__comment, Tpl.textString(txt_3));
        l_c__comment = Tpl.writeTok(l_c__comment, Tpl.ST_STRING(" "));
        l_c__comment = CodegenUtil.variabilityString(l_c__comment, i_v_varKind);
        l_c__comment = Tpl.writeTok(l_c__comment, Tpl.ST_STRING(" */"));
        ret_5 = SimCodeUtil.getSimCode();
        ret_6 = SimCodeUtil.getValueReference(i_v, ret_5, false);
        l_index = Tpl.writeStr(Tpl.emptyTxt, ret_6);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("this_function->pre_vars->"));
        txt = crefTypeOMSIC(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("["));
        txt = Tpl.writeText(txt, l_index);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] "));
        txt = Tpl.writeText(txt, l_c__comment);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_601;

protected function fun_602
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;
      DAE.ComponentRef i_name;
      BackendDAE.VarKind i_varKind;
      DAE.ComponentRef i_v_name;
      SimCodeVar.SimVar i_v;
      Tpl.Text txt_4;
      Tpl.Text l_c__comment;
      String ret_2;
      SimCode.SimCode ret_1;
      Tpl.Text l_index;

    case ( txt,
           (i_v as SimCodeVar.SIMVAR(name = (i_name as i_v_name), varKind = i_varKind)) )
      equation
        ret_1 = SimCodeUtil.getSimCode();
        ret_2 = SimCodeUtil.getValueReference(i_v, ret_1, false);
        l_index = Tpl.writeStr(Tpl.emptyTxt, ret_2);
        l_c__comment = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("/* "));
        txt_4 = CodegenUtil.crefStrNoUnderscore(Tpl.emptyTxt, i_v_name);
        l_c__comment = CodegenUtil.escapeCComments(l_c__comment, Tpl.textString(txt_4));
        l_c__comment = Tpl.writeTok(l_c__comment, Tpl.ST_STRING(" "));
        l_c__comment = CodegenUtil.variabilityString(l_c__comment, i_varKind);
        l_c__comment = Tpl.writeTok(l_c__comment, Tpl.ST_STRING(" */"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("model_vars_and_params->"));
        txt = crefTypeOMSIC(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("["));
        txt = Tpl.writeText(txt, l_index);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] "));
        txt = Tpl.writeText(txt, l_c__comment);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_602;

protected function fun_603
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_mArg;
  input DAE.ComponentRef in_a_cref;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_cref)
    local
      Tpl.Text txt;
      DAE.ComponentRef a_cref;
      SimCodeVar.SimVar i_v;
      Integer i_v_index;
      DAE.ComponentRef i_name;
      BackendDAE.VarKind i_v_varKind;
      DAE.ComponentRef i_v_name;
      String ret_9;
      SimCode.SimCode ret_8;
      Tpl.Text l_index;
      Tpl.Text txt_6;
      Tpl.Text txt_5;
      Tpl.Text txt_4;
      Tpl.Text txt_3;
      Tpl.Text l_c__comment;
      SimCodeVar.SimVar ret_1;
      SimCode.SimCode ret_0;

    case ( txt,
           SimCodeVar.SIMVAR(index = -2),
           a_cref )
      equation
        ret_0 = SimCodeUtil.getSimCode();
        ret_1 = SimCodeUtil.cref2simvar(a_cref, ret_0);
        txt = fun_602(txt, ret_1);
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(varKind = (i_v_varKind as BackendDAE.JAC_VAR()), name = (i_name as i_v_name), index = i_v_index),
           _ )
      equation
        l_c__comment = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("/* "));
        txt_3 = CodegenUtil.crefStrNoUnderscore(Tpl.emptyTxt, i_v_name);
        l_c__comment = CodegenUtil.escapeCComments(l_c__comment, Tpl.textString(txt_3));
        l_c__comment = Tpl.writeTok(l_c__comment, Tpl.ST_STRING(" "));
        l_c__comment = CodegenUtil.variabilityString(l_c__comment, i_v_varKind);
        l_c__comment = Tpl.writeTok(l_c__comment, Tpl.ST_STRING(" */"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("this_function->local_vars->"));
        txt = crefTypeOMSIC(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("["));
        txt = Tpl.writeStr(txt, intString(i_v_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] "));
        txt = Tpl.writeText(txt, l_c__comment);
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(varKind = (i_v_varKind as BackendDAE.JAC_DIFF_VAR()), name = (i_name as i_v_name), index = i_v_index),
           _ )
      equation
        l_c__comment = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("/* "));
        txt_4 = CodegenUtil.crefStrNoUnderscore(Tpl.emptyTxt, i_v_name);
        l_c__comment = CodegenUtil.escapeCComments(l_c__comment, Tpl.textString(txt_4));
        l_c__comment = Tpl.writeTok(l_c__comment, Tpl.ST_STRING(" "));
        l_c__comment = CodegenUtil.variabilityString(l_c__comment, i_v_varKind);
        l_c__comment = Tpl.writeTok(l_c__comment, Tpl.ST_STRING(" */"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("this_function->local_vars->"));
        txt = crefTypeOMSIC(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("["));
        txt = Tpl.writeStr(txt, intString(i_v_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] "));
        txt = Tpl.writeText(txt, l_c__comment);
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(varKind = (i_v_varKind as BackendDAE.SEED_VAR()), name = (i_name as i_v_name), index = i_v_index),
           _ )
      equation
        l_c__comment = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("/* "));
        txt_5 = CodegenUtil.crefStrNoUnderscore(Tpl.emptyTxt, i_v_name);
        l_c__comment = CodegenUtil.escapeCComments(l_c__comment, Tpl.textString(txt_5));
        l_c__comment = Tpl.writeTok(l_c__comment, Tpl.ST_STRING(" "));
        l_c__comment = CodegenUtil.variabilityString(l_c__comment, i_v_varKind);
        l_c__comment = Tpl.writeTok(l_c__comment, Tpl.ST_STRING(" */"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("this_function->local_vars->"));
        txt = crefTypeOMSIC(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("["));
        txt = Tpl.writeStr(txt, intString(i_v_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] "));
        txt = Tpl.writeText(txt, l_c__comment);
      then txt;

    case ( txt,
           (i_v as SimCodeVar.SIMVAR(name = (i_name as i_v_name), varKind = i_v_varKind)),
           _ )
      equation
        l_c__comment = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("/* "));
        txt_6 = CodegenUtil.crefStrNoUnderscore(Tpl.emptyTxt, i_v_name);
        l_c__comment = CodegenUtil.escapeCComments(l_c__comment, Tpl.textString(txt_6));
        l_c__comment = Tpl.writeTok(l_c__comment, Tpl.ST_STRING(" "));
        l_c__comment = CodegenUtil.variabilityString(l_c__comment, i_v_varKind);
        l_c__comment = Tpl.writeTok(l_c__comment, Tpl.ST_STRING(" */"));
        ret_8 = SimCodeUtil.getSimCode();
        ret_9 = SimCodeUtil.getValueReference(i_v, ret_8, false);
        l_index = Tpl.writeStr(Tpl.emptyTxt, ret_9);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("this_function->function_vars->"));
        txt = crefTypeOMSIC(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("["));
        txt = Tpl.writeText(txt, l_index);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] "));
        txt = Tpl.writeText(txt, l_c__comment);
      then txt;

    case ( txt,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("CREF_NOT_FOUND"));
      then txt;
  end match;
end fun_603;

public function crefToOMSICStr
  input Tpl.Text in_txt;
  input DAE.ComponentRef in_a_cref;
  input HashTableCrefSimVar.HashTable in_a_hashTable;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_cref, in_a_hashTable)
    local
      Tpl.Text txt;
      HashTableCrefSimVar.HashTable a_hashTable;
      DAE.ComponentRef i_cref;
      DAE.ComponentRef i_componentRef;
      SimCodeVar.SimVar ret_1;
      SimCodeVar.SimVar ret_0;

    case ( txt,
           DAE.CREF_QUAL(ident = "$START", componentRef = i_componentRef),
           a_hashTable )
      equation
        txt = crefToOMSICStr(txt, i_componentRef, a_hashTable);
      then txt;

    case ( txt,
           DAE.CREF_QUAL(ident = "$PRE", componentRef = i_componentRef),
           a_hashTable )
      equation
        ret_0 = SimCodeUtil.localCref2SimVar(i_componentRef, a_hashTable);
        txt = fun_601(txt, ret_0, i_componentRef);
      then txt;

    case ( txt,
           i_cref,
           a_hashTable )
      equation
        ret_1 = SimCodeUtil.localCref2SimVar(i_cref, a_hashTable);
        txt = fun_603(txt, ret_1, i_cref);
      then txt;
  end match;
end crefToOMSICStr;

public function expTypeRW
  input Tpl.Text in_txt;
  input DAE.Type in_a_type;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_type)
    local
      Tpl.Text txt;
      DAE.Type i_ty;

    case ( txt,
           DAE.T_INTEGER(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("TYPE_DESC_INT"));
      then txt;

    case ( txt,
           DAE.T_REAL(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("TYPE_DESC_REAL"));
      then txt;

    case ( txt,
           DAE.T_STRING(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("TYPE_DESC_STRING"));
      then txt;

    case ( txt,
           DAE.T_BOOL(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("TYPE_DESC_BOOL"));
      then txt;

    case ( txt,
           DAE.T_ENUMERATION(index = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("TYPE_DESC_INT"));
      then txt;

    case ( txt,
           DAE.T_ARRAY(ty = i_ty) )
      equation
        txt = expTypeRW(txt, i_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_ARRAY"));
      then txt;

    case ( txt,
           DAE.T_COMPLEX(complexClassType = ClassInf.RECORD(path = _)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("TYPE_DESC_RECORD"));
      then txt;

    case ( txt,
           DAE.T_METATYPE(ty = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("TYPE_DESC_MMC"));
      then txt;

    case ( txt,
           DAE.T_METABOXED(ty = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("TYPE_DESC_MMC"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end expTypeRW;

protected function fun_606
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("real /* assuming real for unknown type! */"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("complex /* assuming void* for unknown type! when -g=MetaModelica */ "));
      then txt;
  end match;
end fun_606;

public function expTypeShort
  input Tpl.Text in_txt;
  input DAE.Type in_a_type;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_type)
    local
      Tpl.Text txt;
      DAE.Type i_type;
      ClassInf.State i_complexClassType;
      DAE.Type i_ty;
      DAE.Type i_complexType;
      Tpl.Text txt_2;
      String ret_2;
      Boolean ret_1;
      Absyn.Path ret_0;

    case ( txt,
           DAE.T_INTEGER(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("integer"));
      then txt;

    case ( txt,
           DAE.T_REAL(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("real"));
      then txt;

    case ( txt,
           DAE.T_STRING(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("string"));
      then txt;

    case ( txt,
           DAE.T_BOOL(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("boolean"));
      then txt;

    case ( txt,
           DAE.T_ENUMERATION(index = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("integer"));
      then txt;

    case ( txt,
           DAE.T_SUBTYPE_BASIC(complexType = i_complexType) )
      equation
        txt = expTypeShort(txt, i_complexType);
      then txt;

    case ( txt,
           DAE.T_ARRAY(ty = i_ty) )
      equation
        txt = expTypeShort(txt, i_ty);
      then txt;

    case ( txt,
           DAE.T_COMPLEX(complexClassType = ClassInf.EXTERNAL_OBJ(path = _)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("complex"));
      then txt;

    case ( txt,
           DAE.T_COMPLEX(complexClassType = i_complexClassType) )
      equation
        ret_0 = ClassInf.getStateName(i_complexClassType);
        txt = CodegenUtil.underscorePath(txt, ret_0);
      then txt;

    case ( txt,
           DAE.T_METAUNIONTYPE(paths = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("metatype"));
      then txt;

    case ( txt,
           DAE.T_METAARRAY(ty = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("metatype"));
      then txt;

    case ( txt,
           DAE.T_METALIST(ty = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("metatype"));
      then txt;

    case ( txt,
           DAE.T_METATUPLE(types = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("metatype"));
      then txt;

    case ( txt,
           DAE.T_METAOPTION(ty = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("metatype"));
      then txt;

    case ( txt,
           DAE.T_METAPOLYMORPHIC(name = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("metatype"));
      then txt;

    case ( txt,
           DAE.T_METATYPE(ty = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("metatype"));
      then txt;

    case ( txt,
           DAE.T_METABOXED(ty = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("metatype"));
      then txt;

    case ( txt,
           DAE.T_FUNCTION(funcArg = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("fnptr"));
      then txt;

    case ( txt,
           DAE.T_FUNCTION_REFERENCE_FUNC(builtin = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("fnptr"));
      then txt;

    case ( txt,
           DAE.T_FUNCTION_REFERENCE_VAR(functionType = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("fnptr"));
      then txt;

    case ( txt,
           DAE.T_UNKNOWN() )
      equation
        ret_1 = Config.acceptMetaModelicaGrammar();
        txt = fun_606(txt, ret_1);
      then txt;

    case ( txt,
           DAE.T_ANYTYPE(anyClassType = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("complex"));
      then txt;

    case ( txt,
           i_type )
      equation
        txt_2 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("expTypeShort: "));
        ret_2 = Types.unparseType(i_type);
        txt_2 = Tpl.writeStr(txt_2, ret_2);
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 3981, 14), Tpl.textString(txt_2));
      then txt;
  end match;
end expTypeShort;

public function mmcTypeShort
  input Tpl.Text in_txt;
  input DAE.Type in_a_type;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_type)
    local
      Tpl.Text txt;
      DAE.Type i_type;
      Tpl.Text txt_0;
      String ret_0;

    case ( txt,
           DAE.T_INTEGER(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("integer"));
      then txt;

    case ( txt,
           DAE.T_REAL(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("real"));
      then txt;

    case ( txt,
           DAE.T_STRING(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("string"));
      then txt;

    case ( txt,
           DAE.T_BOOL(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("integer"));
      then txt;

    case ( txt,
           DAE.T_ENUMERATION(index = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("integer"));
      then txt;

    case ( txt,
           DAE.T_ARRAY(ty = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("array"));
      then txt;

    case ( txt,
           DAE.T_METAUNIONTYPE(paths = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("metatype"));
      then txt;

    case ( txt,
           DAE.T_METATYPE(ty = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("metatype"));
      then txt;

    case ( txt,
           DAE.T_METALIST(ty = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("metatype"));
      then txt;

    case ( txt,
           DAE.T_METAARRAY(ty = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("metatype"));
      then txt;

    case ( txt,
           DAE.T_METAPOLYMORPHIC(name = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("metatype"));
      then txt;

    case ( txt,
           DAE.T_METAOPTION(ty = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("metatype"));
      then txt;

    case ( txt,
           DAE.T_METATUPLE(types = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("metatype"));
      then txt;

    case ( txt,
           DAE.T_METABOXED(ty = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("metatype"));
      then txt;

    case ( txt,
           DAE.T_FUNCTION_REFERENCE_VAR(functionType = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("fnptr"));
      then txt;

    case ( txt,
           DAE.T_COMPLEX(complexClassType = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("metatype"));
      then txt;

    case ( txt,
           i_type )
      equation
        txt_0 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("mmcTypeShort:ERROR "));
        ret_0 = Types.unparseType(i_type);
        txt_0 = Tpl.writeStr(txt_0, ret_0);
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 4004, 14), Tpl.textString(txt_0));
      then txt;
  end match;
end mmcTypeShort;

protected function fun_609
  input Tpl.Text in_txt;
  input Boolean in_a_array;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_array, in_a_ty)
    local
      Tpl.Text txt;
      DAE.Type a_ty;

    case ( txt,
           true,
           a_ty )
      equation
        txt = expTypeArray(txt, a_ty);
      then txt;

    case ( txt,
           false,
           a_ty )
      equation
        txt = expTypeModelica(txt, a_ty);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_609;

public function expType
  input Tpl.Text txt;
  input DAE.Type a_ty;
  input Boolean a_array;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_609(txt, a_array, a_ty);
end expType;

public function expTypeModelica
  input Tpl.Text txt;
  input DAE.Type a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt := expTypeFlag(txt, a_ty, 2);
end expTypeModelica;

public function expTypeArray
  input Tpl.Text txt;
  input DAE.Type a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt := expTypeFlag(txt, a_ty, 3);
end expTypeArray;

public function expTypeArrayIf
  input Tpl.Text txt;
  input DAE.Type a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt := expTypeFlag(txt, a_ty, 4);
end expTypeArrayIf;

public function expTypeFromExpShort
  input Tpl.Text txt;
  input DAE.Exp a_exp;

  output Tpl.Text out_txt;
algorithm
  out_txt := expTypeFromExpFlag(txt, a_exp, 1);
end expTypeFromExpShort;

public function expTypeFromExpModelica
  input Tpl.Text txt;
  input DAE.Exp a_exp;

  output Tpl.Text out_txt;
algorithm
  out_txt := expTypeFromExpFlag(txt, a_exp, 2);
end expTypeFromExpModelica;

public function expTypeFromExpArray
  input Tpl.Text txt;
  input DAE.Exp a_exp;

  output Tpl.Text out_txt;
algorithm
  out_txt := expTypeFromExpFlag(txt, a_exp, 3);
end expTypeFromExpArray;

public function expTypeFromExpArrayIf
  input Tpl.Text txt;
  input DAE.Exp a_exp;

  output Tpl.Text out_txt;
algorithm
  out_txt := expTypeFromExpFlag(txt, a_exp, 4);
end expTypeFromExpArrayIf;

protected function fun_618
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty)
    local
      Tpl.Text txt;
      DAE.Type i_ty;
      DAE.Type i_t;

    case ( txt,
           DAE.T_ARRAY(ty = (i_t as DAE.T_COMPLEX(complexClassType = _))) )
      equation
        txt = expTypeShort(txt, i_t);
      then txt;

    case ( txt,
           i_ty )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_"));
        txt = expTypeShort(txt, i_ty);
      then txt;
  end match;
end fun_618;

protected function fun_619
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty)
    local
      Tpl.Text txt;
      DAE.Type i_ty;
      ClassInf.State i_complexClassType;
      Absyn.Path ret_0;

    case ( txt,
           DAE.T_COMPLEX(complexClassType = i_complexClassType) )
      equation
        ret_0 = ClassInf.getStateName(i_complexClassType);
        txt = CodegenUtil.underscorePath(txt, ret_0);
      then txt;

    case ( txt,
           i_ty )
      equation
        txt = fun_618(txt, i_ty);
      then txt;
  end match;
end fun_619;

protected function fun_620
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty)
    local
      Tpl.Text txt;
      DAE.Type i_ty;

    case ( txt,
           (i_ty as DAE.T_COMPLEX(complexClassType = ClassInf.EXTERNAL_OBJ(path = _))) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_"));
        txt = expTypeShort(txt, i_ty);
      then txt;

    case ( txt,
           i_ty )
      equation
        txt = fun_619(txt, i_ty);
      then txt;
  end match;
end fun_620;

protected function fun_621
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty)
    local
      Tpl.Text txt;
      DAE.Type i_ty;

    case ( txt,
           DAE.T_ARRAY(ty = i_ty) )
      equation
        txt = expTypeShort(txt, i_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_array"));
      then txt;

    case ( txt,
           i_ty )
      equation
        txt = expTypeFlag(txt, i_ty, 2);
      then txt;
  end match;
end fun_621;

protected function fun_622
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty)
    local
      Tpl.Text txt;
      DAE.Type i_complexType;
      DAE.Type i_ty;
      Tpl.Text txt_0;
      String ret_0;

    case ( txt,
           DAE.T_ARRAY(ty = i_ty) )
      equation
        txt = expTypeFlag(txt, i_ty, 8);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("*"));
      then txt;

    case ( txt,
           DAE.T_INTEGER(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("int"));
      then txt;

    case ( txt,
           DAE.T_BOOL(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("int"));
      then txt;

    case ( txt,
           DAE.T_REAL(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("double"));
      then txt;

    case ( txt,
           DAE.T_STRING(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("const char*"));
      then txt;

    case ( txt,
           DAE.T_SUBTYPE_BASIC(complexType = i_complexType) )
      equation
        txt = expTypeFlag(txt, i_complexType, 8);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("*"));
      then txt;

    case ( txt,
           i_ty )
      equation
        txt_0 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("I do not know the external type of "));
        ret_0 = Types.unparseType(i_ty);
        txt_0 = Tpl.writeStr(txt_0, ret_0);
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 4097, 16), Tpl.textString(txt_0));
      then txt;
  end match;
end fun_622;

protected function fun_623
  input Tpl.Text in_txt;
  input Integer in_a_flag;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_flag, in_a_ty)
    local
      Tpl.Text txt;
      DAE.Type a_ty;

    case ( txt,
           1,
           a_ty )
      equation
        txt = expTypeShort(txt, a_ty);
      then txt;

    case ( txt,
           2,
           a_ty )
      equation
        txt = fun_620(txt, a_ty);
      then txt;

    case ( txt,
           3,
           a_ty )
      equation
        txt = expTypeShort(txt, a_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_array"));
      then txt;

    case ( txt,
           4,
           a_ty )
      equation
        txt = fun_621(txt, a_ty);
      then txt;

    case ( txt,
           8,
           a_ty )
      equation
        txt = fun_622(txt, a_ty);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_623;

public function expTypeFlag
  input Tpl.Text txt;
  input DAE.Type a_ty;
  input Integer a_flag;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_623(txt, a_flag, a_ty);
end expTypeFlag;

protected function fun_625
  input Tpl.Text in_txt;
  input Integer in_a_flag;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_flag)
    local
      Tpl.Text txt;

    case ( txt,
           8 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("int"));
      then txt;

    case ( txt,
           1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("integer"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_integer"));
      then txt;
  end match;
end fun_625;

protected function fun_626
  input Tpl.Text in_txt;
  input Integer in_a_flag;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_flag)
    local
      Tpl.Text txt;

    case ( txt,
           1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("real"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_real"));
      then txt;
  end match;
end fun_626;

protected function fun_627
  input Tpl.Text in_txt;
  input Integer in_a_flag;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_flag)
    local
      Tpl.Text txt;

    case ( txt,
           1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("string"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_string"));
      then txt;
  end match;
end fun_627;

protected function fun_628
  input Tpl.Text in_txt;
  input Integer in_a_flag;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_flag)
    local
      Tpl.Text txt;

    case ( txt,
           1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("boolean"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_boolean"));
      then txt;
  end match;
end fun_628;

protected function fun_629
  input Tpl.Text in_txt;
  input Integer in_a_flag;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_flag)
    local
      Tpl.Text txt;

    case ( txt,
           8 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("int"));
      then txt;

    case ( txt,
           1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("integer"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_integer"));
      then txt;
  end match;
end fun_629;

protected function fun_630
  input Tpl.Text in_txt;
  input Integer in_a_flag;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_flag)
    local
      Tpl.Text txt;

    case ( txt,
           1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("boolean"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_boolean"));
      then txt;
  end match;
end fun_630;

protected function fun_631
  input Tpl.Text in_txt;
  input Integer in_a_flag;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_flag)
    local
      Tpl.Text txt;

    case ( txt,
           1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("metatype"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_metatype"));
      then txt;
  end match;
end fun_631;

protected function fun_632
  input Tpl.Text in_txt;
  input Integer in_a_flag;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_flag)
    local
      Tpl.Text txt;

    case ( txt,
           1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("metatype"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_metatype"));
      then txt;
  end match;
end fun_632;

protected function fun_633
  input Tpl.Text in_txt;
  input Integer in_a_flag;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_flag)
    local
      Tpl.Text txt;

    case ( txt,
           1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("metatype"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_metatype"));
      then txt;
  end match;
end fun_633;

protected function fun_634
  input Tpl.Text in_txt;
  input Integer in_a_flag;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_flag)
    local
      Tpl.Text txt;

    case ( txt,
           1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("metatype"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_metatype"));
      then txt;
  end match;
end fun_634;

protected function fun_635
  input Tpl.Text in_txt;
  input Integer in_a_flag;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_flag)
    local
      Tpl.Text txt;

    case ( txt,
           1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("metatype"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_metatype"));
      then txt;
  end match;
end fun_635;

protected function fun_636
  input Tpl.Text in_txt;
  input Integer in_a_flag;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_flag)
    local
      Tpl.Text txt;

    case ( txt,
           1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("metatype"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_metatype"));
      then txt;
  end match;
end fun_636;

public function expTypeFromExpFlag
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input Integer in_a_flag;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_exp, in_a_flag)
    local
      Tpl.Text txt;
      Integer a_flag;
      DAE.Exp i_c_exp;
      DAE.Exp i_e;
      DAE.Exp i_exp;
      DAE.Exp i_c;
      DAE.Type i_c_ty;
      DAE.Type i_attr_ty;
      DAE.Exp i_expThen;
      DAE.Operator i_e_operator;
      Tpl.Text txt_5;
      DAE.Type ret_4;
      DAE.Type ret_3;
      DAE.Type ret_2;
      DAE.Type ret_1;
      DAE.Type ret_0;

    case ( txt,
           DAE.ICONST(integer = _),
           a_flag )
      equation
        txt = fun_625(txt, a_flag);
      then txt;

    case ( txt,
           DAE.RCONST(real = _),
           a_flag )
      equation
        txt = fun_626(txt, a_flag);
      then txt;

    case ( txt,
           DAE.SCONST(string = _),
           a_flag )
      equation
        txt = fun_627(txt, a_flag);
      then txt;

    case ( txt,
           DAE.BCONST(bool = _),
           a_flag )
      equation
        txt = fun_628(txt, a_flag);
      then txt;

    case ( txt,
           DAE.ENUM_LITERAL(name = _),
           a_flag )
      equation
        txt = fun_629(txt, a_flag);
      then txt;

    case ( txt,
           DAE.BINARY(operator = i_e_operator),
           a_flag )
      equation
        txt = expTypeFromOpFlag(txt, i_e_operator, a_flag);
      then txt;

    case ( txt,
           DAE.UNARY(operator = i_e_operator),
           a_flag )
      equation
        txt = expTypeFromOpFlag(txt, i_e_operator, a_flag);
      then txt;

    case ( txt,
           DAE.LBINARY(operator = i_e_operator),
           a_flag )
      equation
        txt = expTypeFromOpFlag(txt, i_e_operator, a_flag);
      then txt;

    case ( txt,
           DAE.LUNARY(operator = i_e_operator),
           a_flag )
      equation
        txt = expTypeFromOpFlag(txt, i_e_operator, a_flag);
      then txt;

    case ( txt,
           DAE.RELATION(exp1 = _),
           a_flag )
      equation
        txt = fun_630(txt, a_flag);
      then txt;

    case ( txt,
           DAE.IFEXP(expThen = i_expThen),
           a_flag )
      equation
        txt = expTypeFromExpFlag(txt, i_expThen, a_flag);
      then txt;

    case ( txt,
           DAE.CALL(attr = DAE.CALL_ATTR(ty = i_attr_ty)),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_attr_ty, a_flag);
      then txt;

    case ( txt,
           DAE.RECORD(ty = i_c_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_c_ty, a_flag);
      then txt;

    case ( txt,
           DAE.ARRAY(ty = i_c_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_c_ty, a_flag);
      then txt;

    case ( txt,
           DAE.MATRIX(ty = i_c_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_c_ty, a_flag);
      then txt;

    case ( txt,
           DAE.RANGE(ty = i_c_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_c_ty, a_flag);
      then txt;

    case ( txt,
           DAE.CAST(ty = i_c_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_c_ty, a_flag);
      then txt;

    case ( txt,
           DAE.TSUB(ty = i_c_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_c_ty, a_flag);
      then txt;

    case ( txt,
           DAE.CREF(ty = i_c_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_c_ty, a_flag);
      then txt;

    case ( txt,
           DAE.CODE(ty = i_c_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_c_ty, a_flag);
      then txt;

    case ( txt,
           (i_c as DAE.ASUB(exp = _)),
           a_flag )
      equation
        ret_0 = Expression.typeof(i_c);
        txt = expTypeFlag(txt, ret_0, a_flag);
      then txt;

    case ( txt,
           (i_exp as DAE.REDUCTION(reductionInfo = _)),
           a_flag )
      equation
        ret_1 = Expression.typeof(i_exp);
        txt = expTypeFlag(txt, ret_1, a_flag);
      then txt;

    case ( txt,
           (i_e as DAE.CONS(car = _)),
           a_flag )
      equation
        ret_2 = Expression.typeof(i_e);
        txt = expTypeFlag(txt, ret_2, a_flag);
      then txt;

    case ( txt,
           (i_e as DAE.LIST(valList = _)),
           a_flag )
      equation
        ret_3 = Expression.typeof(i_e);
        txt = expTypeFlag(txt, ret_3, a_flag);
      then txt;

    case ( txt,
           (i_e as DAE.SIZE(exp = _)),
           a_flag )
      equation
        ret_4 = Expression.typeof(i_e);
        txt = expTypeFlag(txt, ret_4, a_flag);
      then txt;

    case ( txt,
           DAE.RSUB(ix = -1, ty = i_c_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_c_ty, a_flag);
      then txt;

    case ( txt,
           DAE.META_TUPLE(listExp = _),
           a_flag )
      equation
        txt = fun_631(txt, a_flag);
      then txt;

    case ( txt,
           DAE.META_OPTION(exp = _),
           a_flag )
      equation
        txt = fun_632(txt, a_flag);
      then txt;

    case ( txt,
           DAE.MATCHEXPRESSION(matchType = _),
           a_flag )
      equation
        txt = fun_633(txt, a_flag);
      then txt;

    case ( txt,
           DAE.METARECORDCALL(path = _),
           a_flag )
      equation
        txt = fun_634(txt, a_flag);
      then txt;

    case ( txt,
           DAE.RSUB(exp = _),
           a_flag )
      equation
        txt = fun_635(txt, a_flag);
      then txt;

    case ( txt,
           DAE.BOX(exp = _),
           a_flag )
      equation
        txt = fun_636(txt, a_flag);
      then txt;

    case ( txt,
           DAE.UNBOX(ty = i_c_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_c_ty, a_flag);
      then txt;

    case ( txt,
           DAE.SHARED_LITERAL(exp = i_c_exp),
           a_flag )
      equation
        txt = expTypeFromExpFlag(txt, i_c_exp, a_flag);
      then txt;

    case ( txt,
           i_exp,
           a_flag )
      equation
        txt_5 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("expTypeFromExpFlag(flag="));
        txt_5 = Tpl.writeStr(txt_5, intString(a_flag));
        txt_5 = Tpl.writeTok(txt_5, Tpl.ST_STRING("):"));
        txt_5 = ExpressionDumpTpl.dumpExp(txt_5, i_exp, "\"");
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 4139, 14), Tpl.textString(txt_5));
      then txt;
  end match;
end expTypeFromExpFlag;

protected function fun_638
  input Tpl.Text in_txt;
  input Integer in_a_flag;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_flag)
    local
      Tpl.Text txt;

    case ( txt,
           1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("boolean"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_boolean"));
      then txt;
  end match;
end fun_638;

protected function fun_639
  input Tpl.Text in_txt;
  input Integer in_a_flag;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_flag)
    local
      Tpl.Text txt;

    case ( txt,
           1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("boolean"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_boolean"));
      then txt;
  end match;
end fun_639;

protected function fun_640
  input Tpl.Text in_txt;
  input Integer in_a_flag;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_flag)
    local
      Tpl.Text txt;

    case ( txt,
           1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("boolean"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_boolean"));
      then txt;
  end match;
end fun_640;

public function expTypeFromOpFlag
  input Tpl.Text in_txt;
  input DAE.Operator in_a_op;
  input Integer in_a_flag;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_op, in_a_flag)
    local
      Tpl.Text txt;
      Integer a_flag;
      DAE.Type i_o_ty;

    case ( txt,
           DAE.ADD(ty = i_o_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_o_ty, a_flag);
      then txt;

    case ( txt,
           DAE.SUB(ty = i_o_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_o_ty, a_flag);
      then txt;

    case ( txt,
           DAE.MUL(ty = i_o_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_o_ty, a_flag);
      then txt;

    case ( txt,
           DAE.DIV(ty = i_o_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_o_ty, a_flag);
      then txt;

    case ( txt,
           DAE.POW(ty = i_o_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_o_ty, a_flag);
      then txt;

    case ( txt,
           DAE.UMINUS(ty = i_o_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_o_ty, a_flag);
      then txt;

    case ( txt,
           DAE.UMINUS_ARR(ty = i_o_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_o_ty, a_flag);
      then txt;

    case ( txt,
           DAE.ADD_ARR(ty = i_o_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_o_ty, a_flag);
      then txt;

    case ( txt,
           DAE.SUB_ARR(ty = i_o_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_o_ty, a_flag);
      then txt;

    case ( txt,
           DAE.MUL_ARR(ty = i_o_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_o_ty, a_flag);
      then txt;

    case ( txt,
           DAE.DIV_ARR(ty = i_o_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_o_ty, a_flag);
      then txt;

    case ( txt,
           DAE.MUL_ARRAY_SCALAR(ty = i_o_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_o_ty, a_flag);
      then txt;

    case ( txt,
           DAE.ADD_ARRAY_SCALAR(ty = i_o_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_o_ty, a_flag);
      then txt;

    case ( txt,
           DAE.SUB_SCALAR_ARRAY(ty = i_o_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_o_ty, a_flag);
      then txt;

    case ( txt,
           DAE.MUL_SCALAR_PRODUCT(ty = i_o_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_o_ty, a_flag);
      then txt;

    case ( txt,
           DAE.MUL_MATRIX_PRODUCT(ty = i_o_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_o_ty, a_flag);
      then txt;

    case ( txt,
           DAE.DIV_ARRAY_SCALAR(ty = i_o_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_o_ty, a_flag);
      then txt;

    case ( txt,
           DAE.DIV_SCALAR_ARRAY(ty = i_o_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_o_ty, a_flag);
      then txt;

    case ( txt,
           DAE.POW_ARRAY_SCALAR(ty = i_o_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_o_ty, a_flag);
      then txt;

    case ( txt,
           DAE.POW_SCALAR_ARRAY(ty = i_o_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_o_ty, a_flag);
      then txt;

    case ( txt,
           DAE.POW_ARR(ty = i_o_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_o_ty, a_flag);
      then txt;

    case ( txt,
           DAE.POW_ARR2(ty = i_o_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_o_ty, a_flag);
      then txt;

    case ( txt,
           DAE.LESS(ty = i_o_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_o_ty, a_flag);
      then txt;

    case ( txt,
           DAE.LESSEQ(ty = i_o_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_o_ty, a_flag);
      then txt;

    case ( txt,
           DAE.GREATER(ty = i_o_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_o_ty, a_flag);
      then txt;

    case ( txt,
           DAE.GREATEREQ(ty = i_o_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_o_ty, a_flag);
      then txt;

    case ( txt,
           DAE.EQUAL(ty = i_o_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_o_ty, a_flag);
      then txt;

    case ( txt,
           DAE.NEQUAL(ty = i_o_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_o_ty, a_flag);
      then txt;

    case ( txt,
           DAE.AND(ty = _),
           a_flag )
      equation
        txt = fun_638(txt, a_flag);
      then txt;

    case ( txt,
           DAE.OR(ty = _),
           a_flag )
      equation
        txt = fun_639(txt, a_flag);
      then txt;

    case ( txt,
           DAE.NOT(ty = _),
           a_flag )
      equation
        txt = fun_640(txt, a_flag);
      then txt;

    case ( txt,
           _,
           _ )
      equation
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 4181, 14), "expTypeFromOpFlag:ERROR");
      then txt;
  end match;
end expTypeFromOpFlag;

protected function fun_642
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_integer;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_integer)
    local
      Tpl.Text txt;
      Integer a_integer;

    case ( txt,
           false,
           a_integer )
      equation
        txt = Tpl.writeStr(txt, intString(a_integer));
      then txt;

    case ( txt,
           _,
           _ )
      equation
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 4192, 13), "Negeative dimension(unknown dimensions) may not be part of generated code. This is most likely an error on the part of OpenModelica. Please submit a detailed bug-report.");
      then txt;
  end match;
end fun_642;

public function dimension
  input Tpl.Text in_txt;
  input DAE.Dimension in_a_d;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_d, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      Integer i_integer;
      DAE.Exp i_e;
      Integer i_size;
      Boolean ret_0;

    case ( txt,
           DAE.DIM_BOOLEAN(),
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("2"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.DIM_ENUM(size = i_size),
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt = Tpl.writeStr(txt, intString(i_size));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.DIM_EXP(exp = i_e),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExp(txt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.DIM_INTEGER(integer = i_integer),
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        ret_0 = intEq(i_integer, -1);
        txt = fun_642(txt, ret_0, i_integer);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.DIM_UNKNOWN(),
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 4195, 39), "Unknown dimensions may not be part of generated code. This is most likely an error on the part of OpenModelica. Please submit a detailed bug-report.");
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 4196, 14), "dimension: INVALID_DIMENSION");
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end dimension;

protected function fun_644
  input Tpl.Text in_txt;
  input DAE.Pattern in_a_pat;
  input Tpl.Text in_a_assignments;
  input Tpl.Text in_a_matchPhase;
  input Tpl.Text in_a_varDecls;
  input DAE.Type in_a_ty;
  input Tpl.Text in_a_additionalOutputs;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_assignments;
  output Tpl.Text out_a_matchPhase;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_additionalOutputs;
algorithm
  (out_txt, out_a_assignments, out_a_matchPhase, out_a_varDecls, out_a_additionalOutputs) :=
  match(in_txt, in_a_pat, in_a_assignments, in_a_matchPhase, in_a_varDecls, in_a_ty, in_a_additionalOutputs)
    local
      Tpl.Text txt;
      Tpl.Text a_assignments;
      Tpl.Text a_matchPhase;
      Tpl.Text a_varDecls;
      DAE.Type a_ty;
      Tpl.Text a_additionalOutputs;
      DAE.Pattern i_pat;
      Tpl.Text txt_2;
      Tpl.Text txt_1;
      Tpl.Text l_v;

    case ( txt,
           DAE.PAT_WILD(),
           a_assignments,
           a_matchPhase,
           a_varDecls,
           _,
           a_additionalOutputs )
      equation
        a_additionalOutputs = Tpl.writeTok(a_additionalOutputs, Tpl.ST_STRING(", NULL"));
      then (txt, a_assignments, a_matchPhase, a_varDecls, a_additionalOutputs);

    case ( txt,
           i_pat,
           a_assignments,
           a_matchPhase,
           a_varDecls,
           a_ty,
           a_additionalOutputs )
      equation
        txt_1 = expTypeArrayIf(Tpl.emptyTxt, a_ty);
        (l_v, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(txt_1), a_varDecls);
        a_additionalOutputs = Tpl.writeTok(a_additionalOutputs, Tpl.ST_STRING(", &"));
        a_additionalOutputs = Tpl.writeText(a_additionalOutputs, l_v);
        txt_2 = generateThrow(Tpl.emptyTxt);
        (a_matchPhase, l_v, txt_2, a_varDecls, a_assignments) = patternMatch(a_matchPhase, i_pat, l_v, txt_2, a_varDecls, a_assignments);
      then (txt, a_assignments, a_matchPhase, a_varDecls, a_additionalOutputs);
  end match;
end fun_644;

protected function lm_645
  input Tpl.Text in_txt;
  input list<tuple<DAE.Pattern, DAE.Type>> in_items;
  input Tpl.Text in_a_assignments;
  input Tpl.Text in_a_matchPhase;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_additionalOutputs;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_assignments;
  output Tpl.Text out_a_matchPhase;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_additionalOutputs;
algorithm
  (out_txt, out_a_assignments, out_a_matchPhase, out_a_varDecls, out_a_additionalOutputs) :=
  match(in_txt, in_items, in_a_assignments, in_a_matchPhase, in_a_varDecls, in_a_additionalOutputs)
    local
      Tpl.Text txt;
      list<tuple<DAE.Pattern, DAE.Type>> rest;
      Tpl.Text a_assignments;
      Tpl.Text a_matchPhase;
      Tpl.Text a_varDecls;
      Tpl.Text a_additionalOutputs;
      DAE.Type i_ty;
      DAE.Pattern i_pat;

    case ( txt,
           {},
           a_assignments,
           a_matchPhase,
           a_varDecls,
           a_additionalOutputs )
      then (txt, a_assignments, a_matchPhase, a_varDecls, a_additionalOutputs);

    case ( txt,
           (i_pat, i_ty) :: rest,
           a_assignments,
           a_matchPhase,
           a_varDecls,
           a_additionalOutputs )
      equation
        (txt, a_assignments, a_matchPhase, a_varDecls, a_additionalOutputs) = fun_644(txt, i_pat, a_assignments, a_matchPhase, a_varDecls, i_ty, a_additionalOutputs);
        (txt, a_assignments, a_matchPhase, a_varDecls, a_additionalOutputs) = lm_645(txt, rest, a_assignments, a_matchPhase, a_varDecls, a_additionalOutputs);
      then (txt, a_assignments, a_matchPhase, a_varDecls, a_additionalOutputs);
  end match;
end lm_645;

protected function fun_646
  input Tpl.Text in_txt;
  input DAE.Pattern in_a_pat;
  input Tpl.Text in_a_assignments1;
  input Tpl.Text in_a_varDecls;
  input DAE.Type in_a_ty;
  input Tpl.Text in_a_assignments;
  input Tpl.Text in_a_matchPhase;
  input Tpl.Text in_a_expPart;
  input Tpl.Text in_a_preExp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_assignments1;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_assignments1, out_a_varDecls) :=
  match(in_txt, in_a_pat, in_a_assignments1, in_a_varDecls, in_a_ty, in_a_assignments, in_a_matchPhase, in_a_expPart, in_a_preExp)
    local
      Tpl.Text txt;
      Tpl.Text a_assignments1;
      Tpl.Text a_varDecls;
      DAE.Type a_ty;
      Tpl.Text a_assignments;
      Tpl.Text a_matchPhase;
      Tpl.Text a_expPart;
      Tpl.Text a_preExp;
      DAE.Pattern i_pat;
      Tpl.Text txt_3;
      Tpl.Text l_res;
      Tpl.Text txt_1;
      Tpl.Text l_v;

    case ( txt,
           DAE.PAT_WILD(),
           a_assignments1,
           a_varDecls,
           _,
           a_assignments,
           a_matchPhase,
           a_expPart,
           a_preExp )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/* Pattern-matching tuple assignment, wild first pattern */"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_preExp);
        txt = Tpl.writeText(txt, a_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_matchPhase);
        txt = Tpl.writeText(txt, a_assignments);
      then (txt, a_assignments1, a_varDecls);

    case ( txt,
           i_pat,
           a_assignments1,
           a_varDecls,
           a_ty,
           a_assignments,
           a_matchPhase,
           a_expPart,
           a_preExp )
      equation
        txt_1 = expTypeArrayIf(Tpl.emptyTxt, a_ty);
        (l_v, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(txt_1), a_varDecls);
        txt_3 = generateThrow(Tpl.emptyTxt);
        (l_res, l_v, txt_3, a_varDecls, a_assignments1) = patternMatch(Tpl.emptyTxt, i_pat, l_v, txt_3, a_varDecls, a_assignments1);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/* Pattern-matching tuple assignment */\n"));
        txt = Tpl.writeText(txt, a_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_v);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, a_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.writeText(txt, l_res);
        txt = Tpl.writeText(txt, a_assignments1);
        txt = Tpl.writeText(txt, a_matchPhase);
        txt = Tpl.writeText(txt, a_assignments);
      then (txt, a_assignments1, a_varDecls);
  end match;
end fun_646;

public function algStmtAssignPattern
  input Tpl.Text in_txt;
  input DAE.Statement in_a_stmt;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_stmt, in_a_context, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Pattern i_lhs_pattern;
      DAE.Exp i_exp;
      DAE.Type i_ty;
      DAE.Pattern i_pat;
      DAE.Exp i_s_exp;
      list<DAE.Type> i_tys;
      list<DAE.Pattern> i_patterns;
      Tpl.Text txt_11;
      Tpl.Text txt_10;
      Tpl.Text l_v;
      Tpl.Text txt_8;
      Tpl.Text l_expPart;
      list<tuple<DAE.Pattern, DAE.Type>> ret_6;
      Tpl.Text l_0__;
      Tpl.Text l_matchPhase;
      Tpl.Text l_additionalOutputs;
      Tpl.Text l_assignments;
      Tpl.Text l_assignments1;
      Tpl.Text l_preExp;

    case ( txt,
           DAE.STMT_ASSIGN(exp1 = DAE.PATTERN(pattern = DAE.PAT_CALL_TUPLE(patterns = i_pat :: i_patterns)), exp = (i_s_exp as DAE.CALL(attr = DAE.CALL_ATTR(ty = DAE.T_TUPLE(types = i_ty :: i_tys))))),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        l_preExp = Tpl.emptyTxt;
        l_assignments1 = Tpl.emptyTxt;
        l_assignments = Tpl.emptyTxt;
        l_additionalOutputs = Tpl.emptyTxt;
        l_matchPhase = Tpl.emptyTxt;
        ret_6 = List.zip(i_patterns, i_tys);
        (l_0__, l_assignments, l_matchPhase, a_varDecls, l_additionalOutputs) = lm_645(Tpl.emptyTxt, ret_6, l_assignments, l_matchPhase, a_varDecls, l_additionalOutputs);
        (l_expPart, l_additionalOutputs, l_preExp, a_varDecls, a_auxFunction) = daeExpCallTuple(Tpl.emptyTxt, i_s_exp, l_additionalOutputs, a_context, l_preExp, a_varDecls, a_auxFunction);
        (txt, l_assignments1, a_varDecls) = fun_646(txt, i_pat, l_assignments1, a_varDecls, i_ty, l_assignments, l_matchPhase, l_expPart, l_preExp);
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.STMT_ASSIGN(exp1 = DAE.PATTERN(pattern = DAE.PAT_WILD()), exp = i_exp),
           _,
           a_varDecls,
           a_auxFunction )
      equation
        txt_8 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("Improve simplifcation, got pattern assignment _ = "));
        txt_8 = ExpressionDumpTpl.dumpExp(txt_8, i_exp, "\"");
        txt_8 = Tpl.writeTok(txt_8, Tpl.ST_STRING(", expected NORETCALL"));
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 4231, 11), Tpl.textString(txt_8));
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.STMT_ASSIGN(exp1 = DAE.PATTERN(pattern = i_lhs_pattern), exp = i_s_exp),
           a_context,
           a_varDecls,
           a_auxFunction )
      equation
        l_preExp = Tpl.emptyTxt;
        l_assignments = Tpl.emptyTxt;
        (l_expPart, l_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_s_exp, a_context, l_preExp, a_varDecls, a_auxFunction);
        txt_10 = expTypeFromExpModelica(Tpl.emptyTxt, i_s_exp);
        (l_v, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(txt_10), a_varDecls);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/* Pattern-matching assignment */\n"));
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_v);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, l_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt_11 = generateThrow(Tpl.emptyTxt);
        (txt, l_v, txt_11, a_varDecls, l_assignments) = patternMatch(txt, i_lhs_pattern, l_v, txt_11, a_varDecls, l_assignments);
        txt = Tpl.writeText(txt, l_assignments);
      then (txt, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_varDecls,
           a_auxFunction )
      then (txt, a_varDecls, a_auxFunction);
  end match;
end algStmtAssignPattern;

protected function fun_648
  input Tpl.Text in_txt;
  input Option<DAE.Type> in_a_p_ty;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_unboxBuf;
  input Tpl.Text in_a_rhs;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_unboxBuf;
algorithm
  (out_txt, out_a_varDecls, out_a_unboxBuf) :=
  match(in_txt, in_a_p_ty, in_a_varDecls, in_a_unboxBuf, in_a_rhs)
    local
      Tpl.Text txt;
      Tpl.Text a_varDecls;
      Tpl.Text a_unboxBuf;
      Tpl.Text a_rhs;
      DAE.Type i_et;

    case ( txt,
           SOME(i_et),
           a_varDecls,
           a_unboxBuf,
           a_rhs )
      equation
        (txt, a_unboxBuf, a_varDecls) = unboxVariable(txt, Tpl.textString(a_rhs), i_et, a_unboxBuf, a_varDecls);
      then (txt, a_varDecls, a_unboxBuf);

    case ( txt,
           _,
           a_varDecls,
           a_unboxBuf,
           a_rhs )
      equation
        txt = Tpl.writeText(txt, a_rhs);
      then (txt, a_varDecls, a_unboxBuf);
  end match;
end fun_648;

protected function fun_649
  input Tpl.Text in_txt;
  input DAE.Exp in_a_p_exp;
  input Tpl.Text in_a_onPatternFail;
  input Tpl.Text in_a_urhs;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_p_exp, in_a_onPatternFail, in_a_urhs)
    local
      Tpl.Text txt;
      Tpl.Text a_onPatternFail;
      Tpl.Text a_urhs;
      DAE.Exp i_p_exp;
      Boolean i_c_bool;
      Integer i_c_index;
      String i_d_string;
      String i_c_string;
      Real i_c_real;
      Integer i_c_integer;
      Tpl.Text txt_5;
      Integer ret_4;
      String ret_3;
      Integer ret_2;
      String ret_1;
      Tpl.Text l_escstr;

    case ( txt,
           DAE.ICONST(integer = i_c_integer),
           a_onPatternFail,
           a_urhs )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if ("));
        txt = Tpl.writeStr(txt, intString(i_c_integer));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" != "));
        txt = Tpl.writeText(txt, a_urhs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") "));
        txt = Tpl.writeText(txt, a_onPatternFail);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           DAE.RCONST(real = i_c_real),
           a_onPatternFail,
           a_urhs )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if ("));
        txt = Tpl.writeStr(txt, realString(i_c_real));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" != "));
        txt = Tpl.writeText(txt, a_urhs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") "));
        txt = Tpl.writeText(txt, a_onPatternFail);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           DAE.SCONST(string = i_c_string),
           a_onPatternFail,
           a_urhs )
      equation
        ret_1 = Util.escapeModelicaStringToCString(i_c_string);
        l_escstr = Tpl.writeStr(Tpl.emptyTxt, ret_1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if ("));
        ret_2 = System.unescapedStringLength(Tpl.textString(l_escstr));
        txt = Tpl.writeStr(txt, intString(ret_2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" != MMC_STRLEN("));
        txt = Tpl.writeText(txt, a_urhs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") || strcmp(\""));
        txt = Tpl.writeText(txt, l_escstr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\", MMC_STRINGDATA("));
        txt = Tpl.writeText(txt, a_urhs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")) != 0) "));
        txt = Tpl.writeText(txt, a_onPatternFail);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           DAE.SHARED_LITERAL(exp = DAE.SCONST(string = i_d_string), index = i_c_index),
           a_onPatternFail,
           a_urhs )
      equation
        ret_3 = Util.escapeModelicaStringToCString(i_d_string);
        l_escstr = Tpl.writeStr(Tpl.emptyTxt, ret_3);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if ("));
        ret_4 = System.unescapedStringLength(Tpl.textString(l_escstr));
        txt = Tpl.writeStr(txt, intString(ret_4));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" != MMC_STRLEN("));
        txt = Tpl.writeText(txt, a_urhs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") || strcmp(MMC_STRINGDATA(_OMC_LIT"));
        txt = Tpl.writeStr(txt, intString(i_c_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("), MMC_STRINGDATA("));
        txt = Tpl.writeText(txt, a_urhs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")) != 0) "));
        txt = Tpl.writeText(txt, a_onPatternFail);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           DAE.BCONST(bool = i_c_bool),
           a_onPatternFail,
           a_urhs )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if ("));
        txt = boolStrC(txt, i_c_bool);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" != "));
        txt = Tpl.writeText(txt, a_urhs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") "));
        txt = Tpl.writeText(txt, a_onPatternFail);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           DAE.LIST(valList = {}),
           a_onPatternFail,
           a_urhs )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if (!listEmpty("));
        txt = Tpl.writeText(txt, a_urhs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")) "));
        txt = Tpl.writeText(txt, a_onPatternFail);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           DAE.META_OPTION(exp = NONE()),
           a_onPatternFail,
           a_urhs )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if (!optionNone("));
        txt = Tpl.writeText(txt, a_urhs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")) "));
        txt = Tpl.writeText(txt, a_onPatternFail);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           DAE.ENUM_LITERAL(index = i_c_index),
           a_onPatternFail,
           a_urhs )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if ("));
        txt = Tpl.writeStr(txt, intString(i_c_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" != "));
        txt = Tpl.writeText(txt, a_urhs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") "));
        txt = Tpl.writeText(txt, a_onPatternFail);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           DAE.SHARED_LITERAL(index = i_c_index),
           a_onPatternFail,
           a_urhs )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if (!valueEq(_OMC_LIT"));
        txt = Tpl.writeStr(txt, intString(i_c_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_urhs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")) "));
        txt = Tpl.writeText(txt, a_onPatternFail);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           i_p_exp,
           _,
           _ )
      equation
        txt_5 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("UNKNOWN_CONSTANT_PATTERN "));
        txt_5 = ExpressionDumpTpl.dumpExp(txt_5, i_p_exp, "\"");
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 4270, 20), Tpl.textString(txt_5));
      then txt;
  end match;
end fun_649;

protected function fun_650
  input Tpl.Text in_txt;
  input DAE.Pattern in_a_p;
  input Tpl.Text in_a_assignments;
  input Tpl.Text in_a_onPatternFail;
  input Integer in_a_i1;
  input Tpl.Text in_a_rhs;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_assignments;
  output Tpl.Text out_a_onPatternFail;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_assignments, out_a_onPatternFail, out_a_varDecls) :=
  match(in_txt, in_a_p, in_a_assignments, in_a_onPatternFail, in_a_i1, in_a_rhs, in_a_varDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_assignments;
      Tpl.Text a_onPatternFail;
      Integer a_i1;
      Tpl.Text a_rhs;
      Tpl.Text a_varDecls;
      DAE.Pattern i_p;
      Tpl.Text l_tvar;

    case ( txt,
           DAE.PAT_WILD(),
           a_assignments,
           a_onPatternFail,
           _,
           _,
           a_varDecls )
      then (txt, a_assignments, a_onPatternFail, a_varDecls);

    case ( txt,
           i_p,
           a_assignments,
           a_onPatternFail,
           a_i1,
           a_rhs,
           a_varDecls )
      equation
        (l_tvar, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_metatype", a_varDecls);
        txt = Tpl.writeText(txt, l_tvar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = MMC_FETCH(MMC_OFFSET(MMC_UNTAGPTR("));
        txt = Tpl.writeText(txt, a_rhs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("), "));
        txt = Tpl.writeStr(txt, intString(a_i1));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("));\n"));
        (txt, l_tvar, a_onPatternFail, a_varDecls, a_assignments) = patternMatch(txt, i_p, l_tvar, a_onPatternFail, a_varDecls, a_assignments);
      then (txt, a_assignments, a_onPatternFail, a_varDecls);
  end match;
end fun_650;

protected function lm_651
  input Tpl.Text in_txt;
  input list<DAE.Pattern> in_items;
  input Tpl.Text in_a_assignments;
  input Tpl.Text in_a_onPatternFail;
  input Tpl.Text in_a_rhs;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_assignments;
  output Tpl.Text out_a_onPatternFail;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_assignments, out_a_onPatternFail, out_a_varDecls) :=
  match(in_txt, in_items, in_a_assignments, in_a_onPatternFail, in_a_rhs, in_a_varDecls)
    local
      Tpl.Text txt;
      list<DAE.Pattern> rest;
      Tpl.Text a_assignments;
      Tpl.Text a_onPatternFail;
      Tpl.Text a_rhs;
      Tpl.Text a_varDecls;
      Integer x_i1;
      DAE.Pattern i_p;

    case ( txt,
           {},
           a_assignments,
           a_onPatternFail,
           _,
           a_varDecls )
      then (txt, a_assignments, a_onPatternFail, a_varDecls);

    case ( txt,
           i_p :: rest,
           a_assignments,
           a_onPatternFail,
           a_rhs,
           a_varDecls )
      equation
        x_i1 = Tpl.getIteri_i0(txt);
        (txt, a_assignments, a_onPatternFail, a_varDecls) = fun_650(txt, i_p, a_assignments, a_onPatternFail, x_i1, a_rhs, a_varDecls);
        txt = Tpl.nextIter(txt);
        (txt, a_assignments, a_onPatternFail, a_varDecls) = lm_651(txt, rest, a_assignments, a_onPatternFail, a_rhs, a_varDecls);
      then (txt, a_assignments, a_onPatternFail, a_varDecls);
  end match;
end lm_651;

protected function fun_652
  input Tpl.Text in_txt;
  input DAE.Pattern in_a_p;
  input Tpl.Text in_a_assignments;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_onPatternFail;
  input Integer in_a_i1;
  input Tpl.Text in_a_rhs;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_assignments;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_onPatternFail;
algorithm
  (out_txt, out_a_assignments, out_a_varDecls, out_a_onPatternFail) :=
  match(in_txt, in_a_p, in_a_assignments, in_a_varDecls, in_a_onPatternFail, in_a_i1, in_a_rhs)
    local
      Tpl.Text txt;
      Tpl.Text a_assignments;
      Tpl.Text a_varDecls;
      Tpl.Text a_onPatternFail;
      Integer a_i1;
      Tpl.Text a_rhs;
      DAE.Pattern i_p;
      Tpl.Text l_nrhs;

    case ( txt,
           DAE.PAT_WILD(),
           a_assignments,
           a_varDecls,
           a_onPatternFail,
           _,
           _ )
      then (txt, a_assignments, a_varDecls, a_onPatternFail);

    case ( txt,
           i_p,
           a_assignments,
           a_varDecls,
           a_onPatternFail,
           a_i1,
           a_rhs )
      equation
        l_nrhs = Tpl.writeText(Tpl.emptyTxt, a_rhs);
        l_nrhs = Tpl.writeTok(l_nrhs, Tpl.ST_STRING(".c"));
        l_nrhs = Tpl.writeStr(l_nrhs, intString(a_i1));
        (txt, l_nrhs, a_onPatternFail, a_varDecls, a_assignments) = patternMatch(txt, i_p, l_nrhs, a_onPatternFail, a_varDecls, a_assignments);
      then (txt, a_assignments, a_varDecls, a_onPatternFail);
  end match;
end fun_652;

protected function lm_653
  input Tpl.Text in_txt;
  input list<DAE.Pattern> in_items;
  input Tpl.Text in_a_assignments;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_onPatternFail;
  input Tpl.Text in_a_rhs;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_assignments;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_onPatternFail;
algorithm
  (out_txt, out_a_assignments, out_a_varDecls, out_a_onPatternFail) :=
  match(in_txt, in_items, in_a_assignments, in_a_varDecls, in_a_onPatternFail, in_a_rhs)
    local
      Tpl.Text txt;
      list<DAE.Pattern> rest;
      Tpl.Text a_assignments;
      Tpl.Text a_varDecls;
      Tpl.Text a_onPatternFail;
      Tpl.Text a_rhs;
      Integer x_i1;
      DAE.Pattern i_p;

    case ( txt,
           {},
           a_assignments,
           a_varDecls,
           a_onPatternFail,
           _ )
      then (txt, a_assignments, a_varDecls, a_onPatternFail);

    case ( txt,
           i_p :: rest,
           a_assignments,
           a_varDecls,
           a_onPatternFail,
           a_rhs )
      equation
        x_i1 = Tpl.getIteri_i0(txt);
        (txt, a_assignments, a_varDecls, a_onPatternFail) = fun_652(txt, i_p, a_assignments, a_varDecls, a_onPatternFail, x_i1, a_rhs);
        txt = Tpl.nextIter(txt);
        (txt, a_assignments, a_varDecls, a_onPatternFail) = lm_653(txt, rest, a_assignments, a_varDecls, a_onPatternFail, a_rhs);
      then (txt, a_assignments, a_varDecls, a_onPatternFail);
  end match;
end lm_653;

protected function fun_654
  input Tpl.Text in_txt;
  input DAE.Pattern in_a_p;
  input Tpl.Text in_a_assignments;
  input Tpl.Text in_a_onPatternFail;
  input String in_a_n;
  input Tpl.Text in_a_rhs;
  input Tpl.Text in_a_varDecls;
  input DAE.Type in_a_t;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_assignments;
  output Tpl.Text out_a_onPatternFail;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_assignments, out_a_onPatternFail, out_a_varDecls) :=
  match(in_txt, in_a_p, in_a_assignments, in_a_onPatternFail, in_a_n, in_a_rhs, in_a_varDecls, in_a_t)
    local
      Tpl.Text txt;
      Tpl.Text a_assignments;
      Tpl.Text a_onPatternFail;
      String a_n;
      Tpl.Text a_rhs;
      Tpl.Text a_varDecls;
      DAE.Type a_t;
      DAE.Pattern i_p;
      Tpl.Text txt_1;
      Tpl.Text l_tvar;

    case ( txt,
           DAE.PAT_WILD(),
           a_assignments,
           a_onPatternFail,
           _,
           _,
           a_varDecls,
           _ )
      then (txt, a_assignments, a_onPatternFail, a_varDecls);

    case ( txt,
           i_p,
           a_assignments,
           a_onPatternFail,
           a_n,
           a_rhs,
           a_varDecls,
           a_t )
      equation
        txt_1 = expTypeArrayIf(Tpl.emptyTxt, a_t);
        (l_tvar, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(txt_1), a_varDecls);
        txt = Tpl.writeText(txt, l_tvar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, a_rhs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("._"));
        txt = Tpl.writeStr(txt, a_n);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        (txt, l_tvar, a_onPatternFail, a_varDecls, a_assignments) = patternMatch(txt, i_p, l_tvar, a_onPatternFail, a_varDecls, a_assignments);
      then (txt, a_assignments, a_onPatternFail, a_varDecls);
  end match;
end fun_654;

protected function lm_655
  input Tpl.Text in_txt;
  input list<tuple<DAE.Pattern, String, DAE.Type>> in_items;
  input Tpl.Text in_a_assignments;
  input Tpl.Text in_a_onPatternFail;
  input Tpl.Text in_a_rhs;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_assignments;
  output Tpl.Text out_a_onPatternFail;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_assignments, out_a_onPatternFail, out_a_varDecls) :=
  match(in_txt, in_items, in_a_assignments, in_a_onPatternFail, in_a_rhs, in_a_varDecls)
    local
      Tpl.Text txt;
      list<tuple<DAE.Pattern, String, DAE.Type>> rest;
      Tpl.Text a_assignments;
      Tpl.Text a_onPatternFail;
      Tpl.Text a_rhs;
      Tpl.Text a_varDecls;
      String i_n;
      DAE.Type i_t;
      DAE.Pattern i_p;

    case ( txt,
           {},
           a_assignments,
           a_onPatternFail,
           _,
           a_varDecls )
      then (txt, a_assignments, a_onPatternFail, a_varDecls);

    case ( txt,
           (i_p, i_n, i_t) :: rest,
           a_assignments,
           a_onPatternFail,
           a_rhs,
           a_varDecls )
      equation
        (txt, a_assignments, a_onPatternFail, a_varDecls) = fun_654(txt, i_p, a_assignments, a_onPatternFail, i_n, a_rhs, a_varDecls, i_t);
        (txt, a_assignments, a_onPatternFail, a_varDecls) = lm_655(txt, rest, a_assignments, a_onPatternFail, a_rhs, a_varDecls);
      then (txt, a_assignments, a_onPatternFail, a_varDecls);
  end match;
end lm_655;

protected function fun_656
  input Tpl.Text in_txt;
  input Boolean in_a_knownSingleton;
  input Tpl.Text in_a_onPatternFail;
  input list<DAE.Pattern> in_a_patterns;
  input Integer in_a_index;
  input Tpl.Text in_a_rhs;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_knownSingleton, in_a_onPatternFail, in_a_patterns, in_a_index, in_a_rhs)
    local
      Tpl.Text txt;
      Tpl.Text a_onPatternFail;
      list<DAE.Pattern> a_patterns;
      Integer a_index;
      Tpl.Text a_rhs;
      Integer ret_0;

    case ( txt,
           false,
           a_onPatternFail,
           a_patterns,
           a_index,
           a_rhs )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if (mmc__uniontype__metarecord__typedef__equal("));
        txt = Tpl.writeText(txt, a_rhs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeStr(txt, intString(a_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        ret_0 = listLength(a_patterns);
        txt = Tpl.writeStr(txt, intString(ret_0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") == 0) "));
        txt = Tpl.writeText(txt, a_onPatternFail);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_656;

protected function fun_657
  input Tpl.Text in_txt;
  input DAE.Pattern in_a_p;
  input Tpl.Text in_a_assignments;
  input Tpl.Text in_a_onPatternFail;
  input Integer in_a_i2;
  input Tpl.Text in_a_rhs;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_assignments;
  output Tpl.Text out_a_onPatternFail;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_assignments, out_a_onPatternFail, out_a_varDecls) :=
  match(in_txt, in_a_p, in_a_assignments, in_a_onPatternFail, in_a_i2, in_a_rhs, in_a_varDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_assignments;
      Tpl.Text a_onPatternFail;
      Integer a_i2;
      Tpl.Text a_rhs;
      Tpl.Text a_varDecls;
      DAE.Pattern i_p;
      Tpl.Text l_tvar;

    case ( txt,
           DAE.PAT_WILD(),
           a_assignments,
           a_onPatternFail,
           _,
           _,
           a_varDecls )
      then (txt, a_assignments, a_onPatternFail, a_varDecls);

    case ( txt,
           i_p,
           a_assignments,
           a_onPatternFail,
           a_i2,
           a_rhs,
           a_varDecls )
      equation
        (l_tvar, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_metatype", a_varDecls);
        txt = Tpl.writeText(txt, l_tvar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = MMC_FETCH(MMC_OFFSET(MMC_UNTAGPTR("));
        txt = Tpl.writeText(txt, a_rhs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("), "));
        txt = Tpl.writeStr(txt, intString(a_i2));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("));\n"));
        (txt, l_tvar, a_onPatternFail, a_varDecls, a_assignments) = patternMatch(txt, i_p, l_tvar, a_onPatternFail, a_varDecls, a_assignments);
      then (txt, a_assignments, a_onPatternFail, a_varDecls);
  end match;
end fun_657;

protected function lm_658
  input Tpl.Text in_txt;
  input list<DAE.Pattern> in_items;
  input Tpl.Text in_a_assignments;
  input Tpl.Text in_a_onPatternFail;
  input Tpl.Text in_a_rhs;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_assignments;
  output Tpl.Text out_a_onPatternFail;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_assignments, out_a_onPatternFail, out_a_varDecls) :=
  match(in_txt, in_items, in_a_assignments, in_a_onPatternFail, in_a_rhs, in_a_varDecls)
    local
      Tpl.Text txt;
      list<DAE.Pattern> rest;
      Tpl.Text a_assignments;
      Tpl.Text a_onPatternFail;
      Tpl.Text a_rhs;
      Tpl.Text a_varDecls;
      Integer x_i2;
      DAE.Pattern i_p;

    case ( txt,
           {},
           a_assignments,
           a_onPatternFail,
           _,
           a_varDecls )
      then (txt, a_assignments, a_onPatternFail, a_varDecls);

    case ( txt,
           i_p :: rest,
           a_assignments,
           a_onPatternFail,
           a_rhs,
           a_varDecls )
      equation
        x_i2 = Tpl.getIteri_i0(txt);
        (txt, a_assignments, a_onPatternFail, a_varDecls) = fun_657(txt, i_p, a_assignments, a_onPatternFail, x_i2, a_rhs, a_varDecls);
        txt = Tpl.nextIter(txt);
        (txt, a_assignments, a_onPatternFail, a_varDecls) = lm_658(txt, rest, a_assignments, a_onPatternFail, a_rhs, a_varDecls);
      then (txt, a_assignments, a_onPatternFail, a_varDecls);
  end match;
end lm_658;

public function patternMatch
  input Tpl.Text in_txt;
  input DAE.Pattern in_a_pat;
  input Tpl.Text in_a_rhs;
  input Tpl.Text in_a_onPatternFail;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_assignments;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_rhs;
  output Tpl.Text out_a_onPatternFail;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_assignments;
algorithm
  (out_txt, out_a_rhs, out_a_onPatternFail, out_a_varDecls, out_a_assignments) :=
  match(in_txt, in_a_pat, in_a_rhs, in_a_onPatternFail, in_a_varDecls, in_a_assignments)
    local
      Tpl.Text txt;
      Tpl.Text a_rhs;
      Tpl.Text a_onPatternFail;
      Tpl.Text a_varDecls;
      Tpl.Text a_assignments;
      DAE.Type i_et;
      String i_p_id;
      Integer i_index;
      Boolean i_knownSingleton;
      list<tuple<DAE.Pattern, String, DAE.Type>> i_patterns_1;
      list<DAE.Pattern> i_patterns;
      DAE.Pattern i_tail;
      DAE.Pattern i_head;
      DAE.Pattern i_p_pat;
      DAE.Exp i_p_exp;
      Option<DAE.Type> i_p_ty;
      Tpl.Text txt_6;
      String ret_5;
      Tpl.Text l_tvarTail;
      Tpl.Text l_tvarHead;
      Tpl.Text l_tvar;
      Tpl.Text l_urhs;
      Tpl.Text l_unboxBuf;

    case ( txt,
           DAE.PAT_WILD(),
           a_rhs,
           a_onPatternFail,
           a_varDecls,
           a_assignments )
      then (txt, a_rhs, a_onPatternFail, a_varDecls, a_assignments);

    case ( txt,
           DAE.PAT_CONSTANT(ty = i_p_ty, exp = i_p_exp),
           a_rhs,
           a_onPatternFail,
           a_varDecls,
           a_assignments )
      equation
        l_unboxBuf = Tpl.emptyTxt;
        (l_urhs, a_varDecls, l_unboxBuf) = fun_648(Tpl.emptyTxt, i_p_ty, a_varDecls, l_unboxBuf, a_rhs);
        txt = Tpl.writeText(txt, l_unboxBuf);
        txt = fun_649(txt, i_p_exp, a_onPatternFail, l_urhs);
      then (txt, a_rhs, a_onPatternFail, a_varDecls, a_assignments);

    case ( txt,
           DAE.PAT_SOME(pat = i_p_pat),
           a_rhs,
           a_onPatternFail,
           a_varDecls,
           a_assignments )
      equation
        (l_tvar, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_metatype", a_varDecls);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if (optionNone("));
        txt = Tpl.writeText(txt, a_rhs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")) "));
        txt = Tpl.writeText(txt, a_onPatternFail);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.writeText(txt, l_tvar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = MMC_FETCH(MMC_OFFSET(MMC_UNTAGPTR("));
        txt = Tpl.writeText(txt, a_rhs);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("), 1));\n"));
        (txt, l_tvar, a_onPatternFail, a_varDecls, a_assignments) = patternMatch(txt, i_p_pat, l_tvar, a_onPatternFail, a_varDecls, a_assignments);
      then (txt, a_rhs, a_onPatternFail, a_varDecls, a_assignments);

    case ( txt,
           DAE.PAT_CONS(head = i_head, tail = i_tail),
           a_rhs,
           a_onPatternFail,
           a_varDecls,
           a_assignments )
      equation
        (l_tvarHead, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_metatype", a_varDecls);
        (l_tvarTail, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_metatype", a_varDecls);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if (listEmpty("));
        txt = Tpl.writeText(txt, a_rhs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")) "));
        txt = Tpl.writeText(txt, a_onPatternFail);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.writeText(txt, l_tvarHead);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = MMC_CAR("));
        txt = Tpl.writeText(txt, a_rhs);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(");\n"));
        txt = Tpl.writeText(txt, l_tvarTail);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = MMC_CDR("));
        txt = Tpl.writeText(txt, a_rhs);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(");\n"));
        (txt, l_tvarHead, a_onPatternFail, a_varDecls, a_assignments) = patternMatch(txt, i_head, l_tvarHead, a_onPatternFail, a_varDecls, a_assignments);
        (txt, l_tvarTail, a_onPatternFail, a_varDecls, a_assignments) = patternMatch(txt, i_tail, l_tvarTail, a_onPatternFail, a_varDecls, a_assignments);
      then (txt, a_rhs, a_onPatternFail, a_varDecls, a_assignments);

    case ( txt,
           DAE.PAT_META_TUPLE(patterns = i_patterns),
           a_rhs,
           a_onPatternFail,
           a_varDecls,
           a_assignments )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(1, SOME(Tpl.ST_STRING("")), NONE(), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_assignments, a_onPatternFail, a_varDecls) = lm_651(txt, i_patterns, a_assignments, a_onPatternFail, a_rhs, a_varDecls);
        txt = Tpl.popIter(txt);
      then (txt, a_rhs, a_onPatternFail, a_varDecls, a_assignments);

    case ( txt,
           DAE.PAT_CALL_TUPLE(patterns = i_patterns),
           a_rhs,
           a_onPatternFail,
           a_varDecls,
           a_assignments )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(1, SOME(Tpl.ST_STRING("")), NONE(), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_assignments, a_varDecls, a_onPatternFail) = lm_653(txt, i_patterns, a_assignments, a_varDecls, a_onPatternFail, a_rhs);
        txt = Tpl.popIter(txt);
      then (txt, a_rhs, a_onPatternFail, a_varDecls, a_assignments);

    case ( txt,
           DAE.PAT_CALL_NAMED(patterns = i_patterns_1),
           a_rhs,
           a_onPatternFail,
           a_varDecls,
           a_assignments )
      equation
        (txt, a_assignments, a_onPatternFail, a_varDecls) = lm_655(txt, i_patterns_1, a_assignments, a_onPatternFail, a_rhs, a_varDecls);
      then (txt, a_rhs, a_onPatternFail, a_varDecls, a_assignments);

    case ( txt,
           DAE.PAT_CALL(knownSingleton = i_knownSingleton, index = i_index, patterns = i_patterns),
           a_rhs,
           a_onPatternFail,
           a_varDecls,
           a_assignments )
      equation
        txt = fun_656(txt, i_knownSingleton, a_onPatternFail, i_patterns, i_index, a_rhs);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(2, SOME(Tpl.ST_STRING("")), NONE(), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_assignments, a_onPatternFail, a_varDecls) = lm_658(txt, i_patterns, a_assignments, a_onPatternFail, a_rhs, a_varDecls);
        txt = Tpl.popIter(txt);
      then (txt, a_rhs, a_onPatternFail, a_varDecls, a_assignments);

    case ( txt,
           DAE.PAT_AS_FUNC_PTR(id = i_p_id, pat = i_p_pat),
           a_rhs,
           a_onPatternFail,
           a_varDecls,
           a_assignments )
      equation
        a_assignments = Tpl.writeTok(a_assignments, Tpl.ST_STRING("_"));
        a_assignments = Tpl.writeStr(a_assignments, i_p_id);
        a_assignments = Tpl.writeTok(a_assignments, Tpl.ST_STRING(" = "));
        a_assignments = Tpl.writeText(a_assignments, a_rhs);
        a_assignments = Tpl.writeTok(a_assignments, Tpl.ST_STRING(";"));
        a_assignments = Tpl.writeTok(a_assignments, Tpl.ST_NEW_LINE());
        (txt, a_rhs, a_onPatternFail, a_varDecls, a_assignments) = patternMatch(txt, i_p_pat, a_rhs, a_onPatternFail, a_varDecls, a_assignments);
      then (txt, a_rhs, a_onPatternFail, a_varDecls, a_assignments);

    case ( txt,
           DAE.PAT_AS(ty = NONE(), id = i_p_id, pat = i_p_pat),
           a_rhs,
           a_onPatternFail,
           a_varDecls,
           a_assignments )
      equation
        a_assignments = Tpl.writeTok(a_assignments, Tpl.ST_STRING("_"));
        a_assignments = Tpl.writeStr(a_assignments, i_p_id);
        a_assignments = Tpl.writeTok(a_assignments, Tpl.ST_STRING(" = "));
        a_assignments = Tpl.writeText(a_assignments, a_rhs);
        a_assignments = Tpl.writeTok(a_assignments, Tpl.ST_STRING(";"));
        a_assignments = Tpl.writeTok(a_assignments, Tpl.ST_NEW_LINE());
        (txt, a_rhs, a_onPatternFail, a_varDecls, a_assignments) = patternMatch(txt, i_p_pat, a_rhs, a_onPatternFail, a_varDecls, a_assignments);
      then (txt, a_rhs, a_onPatternFail, a_varDecls, a_assignments);

    case ( txt,
           DAE.PAT_AS(ty = SOME(i_et), id = i_p_id, pat = i_p_pat),
           a_rhs,
           a_onPatternFail,
           a_varDecls,
           a_assignments )
      equation
        l_unboxBuf = Tpl.emptyTxt;
        a_assignments = Tpl.writeTok(a_assignments, Tpl.ST_STRING("_"));
        a_assignments = Tpl.writeStr(a_assignments, i_p_id);
        a_assignments = Tpl.writeTok(a_assignments, Tpl.ST_STRING(" = "));
        (a_assignments, l_unboxBuf, a_varDecls) = unboxVariable(a_assignments, Tpl.textString(a_rhs), i_et, l_unboxBuf, a_varDecls);
        a_assignments = Tpl.writeTok(a_assignments, Tpl.ST_STRING("  /* pattern as ty="));
        ret_5 = Types.unparseType(i_et);
        a_assignments = Tpl.writeStr(a_assignments, ret_5);
        a_assignments = Tpl.writeTok(a_assignments, Tpl.ST_STRING(" */;"));
        a_assignments = Tpl.writeTok(a_assignments, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_unboxBuf);
        txt = Tpl.softNewLine(txt);
        (txt, a_rhs, a_onPatternFail, a_varDecls, a_assignments) = patternMatch(txt, i_p_pat, a_rhs, a_onPatternFail, a_varDecls, a_assignments);
      then (txt, a_rhs, a_onPatternFail, a_varDecls, a_assignments);

    case ( txt,
           _,
           a_rhs,
           a_onPatternFail,
           a_varDecls,
           a_assignments )
      equation
        txt_6 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("UNKNOWN_PATTERN /* rhs: "));
        txt_6 = Tpl.writeText(txt_6, a_rhs);
        txt_6 = Tpl.writeTok(txt_6, Tpl.ST_STRING(" */"));
        txt_6 = Tpl.writeTok(txt_6, Tpl.ST_NEW_LINE());
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 4343, 14), Tpl.textString(txt_6));
      then (txt, a_rhs, a_onPatternFail, a_varDecls, a_assignments);
  end match;
end patternMatch;

protected function fun_660
  input Tpl.Text in_txt;
  input Boolean in_a_isReadOnly;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_isReadOnly)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("0"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("1"));
      then txt;
  end match;
end fun_660;

public function infoArgs
  input Tpl.Text in_txt;
  input SourceInfo in_a_info;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_info)
    local
      Tpl.Text txt;
      Boolean i_isReadOnly;
      Integer i_columnNumberEnd;
      Integer i_lineNumberEnd;
      Integer i_columnNumberStart;
      Integer i_lineNumberStart;
      String i_fileName;
      String ret_1;
      String ret_0;

    case ( txt,
           SOURCEINFO(fileName = i_fileName, lineNumberStart = i_lineNumberStart, columnNumberStart = i_columnNumberStart, lineNumberEnd = i_lineNumberEnd, columnNumberEnd = i_columnNumberEnd, isReadOnly = i_isReadOnly) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        ret_0 = Testsuite.friendly(i_fileName);
        ret_1 = Util.escapeModelicaStringToCString(ret_0);
        txt = Tpl.writeStr(txt, ret_1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\","));
        txt = Tpl.writeStr(txt, intString(i_lineNumberStart));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeStr(txt, intString(i_columnNumberStart));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeStr(txt, intString(i_lineNumberEnd));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeStr(txt, intString(i_columnNumberEnd));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = fun_660(txt, i_isReadOnly);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end infoArgs;

protected function lm_662
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExpMsg;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExpMsg;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExpMsg) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_preExpMsg, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExpMsg;
      SimCodeFunction.Context a_context;
      DAE.Exp i_message;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_preExpMsg,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExpMsg);

    case ( txt,
           i_message :: rest,
           a_auxFunction,
           a_varDecls,
           a_preExpMsg,
           a_context )
      equation
        (txt, a_preExpMsg, a_varDecls, a_auxFunction) = expToFormatString(txt, i_message, a_context, a_preExpMsg, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_preExpMsg) = lm_662(txt, rest, a_auxFunction, a_varDecls, a_preExpMsg, a_context);
      then (txt, a_auxFunction, a_varDecls, a_preExpMsg);
  end match;
end lm_662;

protected function fun_663
  input Tpl.Text in_txt;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_context)
    local
      Tpl.Text txt;

    case ( txt,
           SimCodeFunction.FUNCTION_CONTEXT(cref_prefix = _) )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("equationIndexes, "));
      then txt;
  end match;
end fun_663;

protected function fun_664
  input Tpl.Text in_txt;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_context)
    local
      Tpl.Text txt;

    case ( txt,
           SimCodeFunction.FUNCTION_CONTEXT(cref_prefix = _) )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_withEquationIndexes"));
      then txt;
  end match;
end fun_664;

protected function fun_665
  input Tpl.Text in_txt;
  input SimCodeFunction.Context in_a_context;
  input DAE.Exp in_a_condition;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_context, in_a_condition)
    local
      Tpl.Text txt;
      DAE.Exp a_condition;
      String ret_1;
      Tpl.Text txt_0;

    case ( txt,
           SimCodeFunction.FUNCTION_CONTEXT(cref_prefix = _),
           _ )
      then txt;

    case ( txt,
           _,
           a_condition )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("omc_assert_warning(info, \"The following assertion has been violated %sat time %f\\n"));
        txt_0 = ExpressionDumpTpl.dumpExp(Tpl.emptyTxt, a_condition, "\"");
        ret_1 = Util.escapeModelicaStringToCString(Tpl.textString(txt_0));
        txt = Tpl.writeStr(txt, ret_1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\", initial() ? \"during initialization \" : \"\", data->localData[0]->timeValue);"));
      then txt;
  end match;
end fun_665;

protected function fun_666
  input Tpl.Text in_txt;
  input DAE.Exp in_a_level;
  input Tpl.Text in_a_AddionalFuncName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_level, in_a_AddionalFuncName)
    local
      Tpl.Text txt;
      Tpl.Text a_AddionalFuncName;

    case ( txt,
           DAE.ENUM_LITERAL(index = 2),
           a_AddionalFuncName )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("omc_assert_warning"));
        txt = Tpl.writeText(txt, a_AddionalFuncName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
      then txt;

    case ( txt,
           _,
           a_AddionalFuncName )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("omc_assert"));
        txt = Tpl.writeText(txt, a_AddionalFuncName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(threadData, "));
      then txt;
  end match;
end fun_666;

protected function fun_667
  input Tpl.Text in_txt;
  input DAE.Exp in_a_level;
  input Tpl.Text in_a_warningTriggered;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_level, in_a_warningTriggered)
    local
      Tpl.Text txt;
      Tpl.Text a_warningTriggered;

    case ( txt,
           DAE.ENUM_LITERAL(index = 2),
           a_warningTriggered )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if(!"));
        txt = Tpl.writeText(txt, a_warningTriggered);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_667;

protected function fun_668
  input Tpl.Text in_txt;
  input DAE.Exp in_a_level;
  input Tpl.Text in_a_warningTriggered;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_level, in_a_warningTriggered)
    local
      Tpl.Text txt;
      Tpl.Text a_warningTriggered;

    case ( txt,
           DAE.ENUM_LITERAL(index = 2),
           a_warningTriggered )
      equation
        txt = Tpl.writeText(txt, a_warningTriggered);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = 1;"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_668;

public function assertCommon
  input Tpl.Text txt;
  input DAE.Exp a_condition;
  input list<DAE.Exp> a_messages;
  input DAE.Exp a_level;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_auxFunction;
  input SourceInfo a_info;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
protected
  Tpl.Text l_TriggerVarSet;
  Tpl.Text l_TriggerIf;
  Tpl.Text l_warningTriggered;
  Tpl.Text l_omcAssertFunc;
  Tpl.Text l_addInfoTextContext;
  Tpl.Text l_AddionalFuncName;
  Tpl.Text l_eqnsindx;
  Tpl.Text l_msgVar;
  Tpl.Text l_preExpMsg;
  Tpl.Text l_condVar;
  Tpl.Text l_preExpCond;
algorithm
  l_preExpCond := Tpl.emptyTxt;
  (l_condVar, l_preExpCond, out_a_varDecls, out_a_auxFunction) := daeExp(Tpl.emptyTxt, a_condition, a_context, l_preExpCond, a_varDecls, a_auxFunction);
  l_preExpMsg := Tpl.emptyTxt;
  l_msgVar := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (l_msgVar, out_a_auxFunction, out_a_varDecls, l_preExpMsg) := lm_662(l_msgVar, a_messages, out_a_auxFunction, out_a_varDecls, l_preExpMsg, a_context);
  l_msgVar := Tpl.popIter(l_msgVar);
  l_eqnsindx := fun_663(Tpl.emptyTxt, a_context);
  l_AddionalFuncName := fun_664(Tpl.emptyTxt, a_context);
  l_addInfoTextContext := fun_665(Tpl.emptyTxt, a_context, a_condition);
  l_omcAssertFunc := fun_666(Tpl.emptyTxt, a_level, l_AddionalFuncName);
  (l_warningTriggered, out_a_varDecls) := tempDeclZero(Tpl.emptyTxt, "static int", out_a_varDecls);
  l_TriggerIf := fun_667(Tpl.emptyTxt, a_level, l_warningTriggered);
  l_TriggerVarSet := fun_668(Tpl.emptyTxt, a_level, l_warningTriggered);
  out_txt := Tpl.writeText(txt, l_TriggerIf);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("{\n"));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeText(out_txt, l_preExpCond);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("if(!"));
  out_txt := Tpl.writeText(out_txt, l_condVar);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       ")\n",
                                       "{\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeText(out_txt, l_preExpMsg);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("{\n"));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("FILE_INFO info = {"));
  out_txt := infoArgs(out_txt, a_info);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("};"));
  out_txt := Tpl.writeText(out_txt, l_addInfoTextContext);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeText(out_txt, l_omcAssertFunc);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("info, "));
  out_txt := Tpl.writeText(out_txt, l_eqnsindx);
  out_txt := Tpl.writeText(out_txt, l_msgVar);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE(");\n"));
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("}\n"));
  out_txt := Tpl.writeText(out_txt, l_TriggerVarSet);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("}\n"));
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("}"));
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_NEW_LINE());
end assertCommon;

public function expToFormatString
  input Tpl.Text txt;
  input DAE.Exp a_exp;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_preExp;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING("MMC_STRINGDATA("));
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) := daeExp(out_txt, a_exp, a_context, a_preExp, a_varDecls, a_auxFunction);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING(")"));
end expToFormatString;

protected function fun_671
  input Tpl.Text in_txt;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_condVar;
  input Tpl.Text in_a_msgVar;
  input SourceInfo in_a_info;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_context, in_a_condVar, in_a_msgVar, in_a_info)
    local
      Tpl.Text txt;
      Tpl.Text a_condVar;
      Tpl.Text a_msgVar;
      SourceInfo a_info;

    case ( txt,
           SimCodeFunction.FUNCTION_CONTEXT(is_parallel = true),
           a_condVar,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if(!("));
        txt = Tpl.writeText(txt, a_condVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "))\n",
                                    "{\n",
                                    "  FILE_INFO info = omc_dummyFileInfo;\n",
                                    "  omc_assert(threadData, info, \"Common assertion failed\");\n",
                                    "}"
                                }, false));
      then txt;

    case ( txt,
           SimCodeFunction.FUNCTION_CONTEXT(cref_prefix = _),
           a_condVar,
           a_msgVar,
           a_info )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if(!("));
        txt = Tpl.writeText(txt, a_condVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "))\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("FILE_INFO info = {"));
        txt = infoArgs(txt, a_info);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "};\n",
                                    "omc_assert(threadData, info, "
                                }, false));
        txt = Tpl.writeText(txt, a_msgVar);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(");\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;

    case ( txt,
           SimCodeFunction.OMSI_CONTEXT(hashTable = _),
           a_condVar,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if(!("));
        txt = Tpl.writeText(txt, a_condVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "))\n",
                                    "{\n",
                                    "  /* TODO: Add assert */\n",
                                    "}"
                                }, false));
      then txt;

    case ( txt,
           _,
           a_condVar,
           a_msgVar,
           a_info )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if(!("));
        txt = Tpl.writeText(txt, a_condVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "))\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("FILE_INFO info = {"));
        txt = infoArgs(txt, a_info);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "};\n",
                                    "omc_assert_warning(info, \"The following assertion has been violated %sat time %f\", initial() ? \"during initialization \" : \"\", data->localData[0]->timeValue);\n",
                                    "throwStreamPrintWithEquationIndexes(threadData, equationIndexes, "
                                }, false));
        txt = Tpl.writeText(txt, a_msgVar);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(");\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;
  end match;
end fun_671;

public function assertCommonVar
  input Tpl.Text txt;
  input Tpl.Text a_condVar;
  input Tpl.Text a_msgVar;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_varDecls;
  input SourceInfo a_info;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_condVar;
  output Tpl.Text out_a_msgVar;
  output Tpl.Text out_a_varDecls;
algorithm
  out_txt := fun_671(txt, a_context, a_condVar, a_msgVar, a_info);
  out_a_condVar := a_condVar;
  out_a_msgVar := a_msgVar;
  out_a_varDecls := a_varDecls;
end assertCommonVar;

public function contextCrefNoPrevExp
  input Tpl.Text txt;
  input DAE.ComponentRef a_cr;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
protected
  Tpl.Text l_varDecls;
  Tpl.Text l_preExp;
algorithm
  l_preExp := Tpl.emptyTxt;
  l_varDecls := Tpl.emptyTxt;
  (out_txt, l_preExp, l_varDecls, out_a_auxFunction) := contextCref(txt, a_cr, a_context, l_preExp, l_varDecls, a_auxFunction);
end contextCrefNoPrevExp;

protected function fun_674
  input Tpl.Text in_txt;
  input String in_mArg;
  input SimCodeFunction.Context in_a_context;
  input DAE.ComponentRef in_a_cr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_context, in_a_cr)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      DAE.ComponentRef a_cr;

    case ( txt,
           "omsic",
           a_context,
           a_cr )
      equation
        txt = crefOMSI(txt, a_cr, a_context);
      then txt;

    case ( txt,
           _,
           a_context,
           a_cr )
      equation
        txt = jacCrefs(txt, a_cr, a_context, 0);
      then txt;
  end match;
end fun_674;

protected function fun_675
  input Tpl.Text in_txt;
  input SimCodeFunction.Context in_a_context;
  input DAE.ComponentRef in_a_cr;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_context, in_a_cr, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      DAE.ComponentRef a_cr;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      SimCodeFunction.Context i_context;
      String ret_2;
      String ret_1;
      Tpl.Text l_cur__pref;

    case ( txt,
           (i_context as SimCodeFunction.FUNCTION_CONTEXT(cref_prefix = _)),
           a_cr,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        ret_1 = SimCodeFunctionUtil.getCurrentCrefPrefix(i_context);
        l_cur__pref = Tpl.writeStr(Tpl.emptyTxt, ret_1);
        (txt, l_cur__pref, a_preExp, a_varDecls, a_auxFunction) = functionContextCref(txt, a_cr, i_context, l_cur__pref, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_context as SimCodeFunction.JACOBIAN_CONTEXT(jacHT = SOME(_))),
           a_cr,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        ret_2 = Config.simCodeTarget();
        txt = fun_674(txt, ret_2, i_context, a_cr);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_context as SimCodeFunction.OMSI_CONTEXT(hashTable = _)),
           a_cr,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt = crefOMSI(txt, a_cr, i_context);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           a_cr,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt = cref(txt, a_cr);
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end fun_675;

public function contextCref
  input Tpl.Text txt;
  input DAE.ComponentRef a_cr;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_preExp;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) := fun_675(txt, a_context, a_cr, a_preExp, a_varDecls, a_auxFunction);
end contextCref;

protected function lm_677
  input Tpl.Text in_txt;
  input list<DAE.Subscript> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Subscript> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Subscript i_sub;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           i_sub :: rest,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeSubscript(txt, i_sub, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_677(txt, rest, a_auxFunction, a_varDecls, a_preExp, a_context);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end lm_677;

protected function lm_678
  input Tpl.Text in_txt;
  input list<DAE.Subscript> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Subscript> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Subscript i_sub;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           i_sub :: rest,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeSubscript(txt, i_sub, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_678(txt, rest, a_auxFunction, a_varDecls, a_preExp, a_context);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end lm_678;

protected function fun_679
  input Tpl.Text in_txt;
  input DAE.ComponentRef in_a_cr;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_pref;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_cr, in_a_context, in_a_pref, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_pref;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.ComponentRef i_cr;
      DAE.ComponentRef i_cr_componentRef;
      DAE.Ident i_cr_ident;
      list<DAE.Subscript> i_cr_subscriptLst;
      DAE.Type i_identType;
      Tpl.Text txt_12;
      String ret_11;
      String ret_10;
      Integer ret_9;
      String ret_8;
      Tpl.Text l_newpref;
      Tpl.Text l_fullname__i;
      String ret_5;
      Tpl.Text l_fullname;
      Tpl.Text l_dimsValuesStr;
      Integer ret_2;
      Tpl.Text l_dimsLenStr;
      Tpl.Text l_typeName;

    case ( txt,
           DAE.CREF_QUAL(identType = (i_identType as DAE.T_ARRAY(ty = _)), subscriptLst = (i_cr_subscriptLst as _ :: _), ident = i_cr_ident, componentRef = i_cr_componentRef),
           a_context,
           a_pref,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        l_typeName = expTypeShort(Tpl.emptyTxt, i_identType);
        ret_2 = listLength(i_cr_subscriptLst);
        l_dimsLenStr = Tpl.writeStr(Tpl.emptyTxt, intString(ret_2));
        l_dimsValuesStr = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_dimsValuesStr, a_auxFunction, a_varDecls, a_preExp) = lm_677(l_dimsValuesStr, i_cr_subscriptLst, a_auxFunction, a_varDecls, a_preExp, a_context);
        l_dimsValuesStr = Tpl.popIter(l_dimsValuesStr);
        l_fullname = Tpl.writeText(Tpl.emptyTxt, a_pref);
        l_fullname = Tpl.writeTok(l_fullname, Tpl.ST_STRING("_"));
        ret_5 = System.unquoteIdentifier(i_cr_ident);
        l_fullname = Tpl.writeStr(l_fullname, ret_5);
        l_fullname__i = Tpl.writeText(Tpl.emptyTxt, l_typeName);
        l_fullname__i = Tpl.writeTok(l_fullname__i, Tpl.ST_STRING("_array_get("));
        l_fullname__i = Tpl.writeText(l_fullname__i, l_fullname);
        l_fullname__i = Tpl.writeTok(l_fullname__i, Tpl.ST_STRING(", "));
        l_fullname__i = Tpl.writeText(l_fullname__i, l_dimsLenStr);
        l_fullname__i = Tpl.writeTok(l_fullname__i, Tpl.ST_STRING(", "));
        l_fullname__i = Tpl.writeText(l_fullname__i, l_dimsValuesStr);
        l_fullname__i = Tpl.writeTok(l_fullname__i, Tpl.ST_STRING(")"));
        l_newpref = Tpl.writeText(Tpl.emptyTxt, l_fullname__i);
        l_newpref = Tpl.writeTok(l_newpref, Tpl.ST_STRING("."));
        (txt, l_newpref, a_preExp, a_varDecls, a_auxFunction) = functionContextCref(txt, i_cr_componentRef, a_context, l_newpref, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CREF_QUAL(ident = i_cr_ident, componentRef = i_cr_componentRef),
           a_context,
           a_pref,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        l_fullname = Tpl.writeText(Tpl.emptyTxt, a_pref);
        l_fullname = Tpl.writeTok(l_fullname, Tpl.ST_STRING("_"));
        ret_8 = System.unquoteIdentifier(i_cr_ident);
        l_fullname = Tpl.writeStr(l_fullname, ret_8);
        l_newpref = Tpl.writeText(Tpl.emptyTxt, l_fullname);
        l_newpref = Tpl.writeTok(l_newpref, Tpl.ST_STRING("."));
        (txt, l_newpref, a_preExp, a_varDecls, a_auxFunction) = functionContextCref(txt, i_cr_componentRef, a_context, l_newpref, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CREF_IDENT(identType = (i_identType as DAE.T_ARRAY(ty = _)), subscriptLst = (i_cr_subscriptLst as _ :: _), ident = i_cr_ident),
           a_context,
           a_pref,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        l_typeName = expTypeShort(Tpl.emptyTxt, i_identType);
        ret_9 = listLength(i_cr_subscriptLst);
        l_dimsLenStr = Tpl.writeStr(Tpl.emptyTxt, intString(ret_9));
        l_dimsValuesStr = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_dimsValuesStr, a_auxFunction, a_varDecls, a_preExp) = lm_678(l_dimsValuesStr, i_cr_subscriptLst, a_auxFunction, a_varDecls, a_preExp, a_context);
        l_dimsValuesStr = Tpl.popIter(l_dimsValuesStr);
        l_fullname = Tpl.writeText(Tpl.emptyTxt, a_pref);
        l_fullname = Tpl.writeTok(l_fullname, Tpl.ST_STRING("_"));
        ret_10 = System.unquoteIdentifier(i_cr_ident);
        l_fullname = Tpl.writeStr(l_fullname, ret_10);
        l_fullname__i = Tpl.writeText(Tpl.emptyTxt, l_typeName);
        l_fullname__i = Tpl.writeTok(l_fullname__i, Tpl.ST_STRING("_array_get("));
        l_fullname__i = Tpl.writeText(l_fullname__i, l_fullname);
        l_fullname__i = Tpl.writeTok(l_fullname__i, Tpl.ST_STRING(", "));
        l_fullname__i = Tpl.writeText(l_fullname__i, l_dimsLenStr);
        l_fullname__i = Tpl.writeTok(l_fullname__i, Tpl.ST_STRING(", "));
        l_fullname__i = Tpl.writeText(l_fullname__i, l_dimsValuesStr);
        l_fullname__i = Tpl.writeTok(l_fullname__i, Tpl.ST_STRING(")"));
        txt = Tpl.writeText(txt, l_fullname__i);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CREF_IDENT(ident = i_cr_ident),
           _,
           a_pref,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        l_fullname = Tpl.writeText(Tpl.emptyTxt, a_pref);
        l_fullname = Tpl.writeTok(l_fullname, Tpl.ST_STRING("_"));
        ret_11 = System.unquoteIdentifier(i_cr_ident);
        l_fullname = Tpl.writeStr(l_fullname, ret_11);
        txt = Tpl.writeText(txt, l_fullname);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           i_cr,
           _,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt_12 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("crefNonSimVar got a cref it does not know how to handle "));
        txt_12 = CodegenUtil.crefStrNoUnderscore(txt_12, i_cr);
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 4494, 11), Tpl.textString(txt_12));
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end fun_679;

public function functionContextCref
  input Tpl.Text txt;
  input DAE.ComponentRef a_cr;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_pref;
  input Tpl.Text a_preExp;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_pref;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) := fun_679(txt, a_cr, a_context, a_pref, a_preExp, a_varDecls, a_auxFunction);
  out_a_pref := a_pref;
end functionContextCref;

protected function lm_681
  input Tpl.Text in_txt;
  input list<DAE.Subscript> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Subscript> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Subscript i_sub;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           i_sub :: rest,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeSubscript(txt, i_sub, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_681(txt, rest, a_auxFunction, a_varDecls, a_preExp, a_context);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end lm_681;

protected function lm_682
  input Tpl.Text in_txt;
  input list<DAE.Subscript> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Subscript> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Subscript i_sub;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           i_sub :: rest,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeSubscript(txt, i_sub, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_682(txt, rest, a_auxFunction, a_varDecls, a_preExp, a_context);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end lm_682;

protected function fun_683
  input Tpl.Text in_txt;
  input DAE.ComponentRef in_a_cr;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_pref;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_cr, in_a_context, in_a_pref, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_pref;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.ComponentRef i_cr;
      DAE.ComponentRef i_cr_componentRef;
      DAE.Ident i_cr_ident;
      list<DAE.Subscript> i_cr_subscriptLst;
      DAE.Type i_identType;
      Tpl.Text txt_12;
      String ret_11;
      String ret_10;
      Integer ret_9;
      String ret_8;
      Tpl.Text l_newpref;
      Tpl.Text l_fullname__i;
      String ret_5;
      Tpl.Text l_fullname;
      Tpl.Text l_dimsValuesStr;
      Integer ret_2;
      Tpl.Text l_dimsLenStr;
      Tpl.Text l_typeName;

    case ( txt,
           DAE.CREF_QUAL(identType = (i_identType as DAE.T_ARRAY(ty = _)), subscriptLst = (i_cr_subscriptLst as _ :: _), ident = i_cr_ident, componentRef = i_cr_componentRef),
           a_context,
           a_pref,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        l_typeName = expTypeShort(Tpl.emptyTxt, i_identType);
        ret_2 = listLength(i_cr_subscriptLst);
        l_dimsLenStr = Tpl.writeStr(Tpl.emptyTxt, intString(ret_2));
        l_dimsValuesStr = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_dimsValuesStr, a_auxFunction, a_varDecls, a_preExp) = lm_681(l_dimsValuesStr, i_cr_subscriptLst, a_auxFunction, a_varDecls, a_preExp, a_context);
        l_dimsValuesStr = Tpl.popIter(l_dimsValuesStr);
        l_fullname = Tpl.writeText(Tpl.emptyTxt, a_pref);
        ret_5 = System.unquoteIdentifier(i_cr_ident);
        l_fullname = Tpl.writeStr(l_fullname, ret_5);
        l_fullname__i = Tpl.writeText(Tpl.emptyTxt, l_typeName);
        l_fullname__i = Tpl.writeTok(l_fullname__i, Tpl.ST_STRING("_array_get("));
        l_fullname__i = Tpl.writeText(l_fullname__i, l_fullname);
        l_fullname__i = Tpl.writeTok(l_fullname__i, Tpl.ST_STRING(", "));
        l_fullname__i = Tpl.writeText(l_fullname__i, l_dimsLenStr);
        l_fullname__i = Tpl.writeTok(l_fullname__i, Tpl.ST_STRING(", "));
        l_fullname__i = Tpl.writeText(l_fullname__i, l_dimsValuesStr);
        l_fullname__i = Tpl.writeTok(l_fullname__i, Tpl.ST_STRING(")"));
        l_newpref = Tpl.writeText(Tpl.emptyTxt, l_fullname__i);
        l_newpref = Tpl.writeTok(l_newpref, Tpl.ST_STRING("."));
        (txt, l_newpref, a_preExp, a_varDecls, a_auxFunction) = functionContextCref(txt, i_cr_componentRef, a_context, l_newpref, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CREF_QUAL(ident = i_cr_ident, componentRef = i_cr_componentRef),
           a_context,
           a_pref,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        l_fullname = Tpl.writeText(Tpl.emptyTxt, a_pref);
        ret_8 = System.unquoteIdentifier(i_cr_ident);
        l_fullname = Tpl.writeStr(l_fullname, ret_8);
        l_newpref = Tpl.writeText(Tpl.emptyTxt, l_fullname);
        l_newpref = Tpl.writeTok(l_newpref, Tpl.ST_STRING("."));
        (txt, l_newpref, a_preExp, a_varDecls, a_auxFunction) = functionContextCref(txt, i_cr_componentRef, a_context, l_newpref, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CREF_IDENT(identType = (i_identType as DAE.T_ARRAY(ty = _)), subscriptLst = (i_cr_subscriptLst as _ :: _), ident = i_cr_ident),
           a_context,
           a_pref,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        l_typeName = expTypeShort(Tpl.emptyTxt, i_identType);
        ret_9 = listLength(i_cr_subscriptLst);
        l_dimsLenStr = Tpl.writeStr(Tpl.emptyTxt, intString(ret_9));
        l_dimsValuesStr = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_dimsValuesStr, a_auxFunction, a_varDecls, a_preExp) = lm_682(l_dimsValuesStr, i_cr_subscriptLst, a_auxFunction, a_varDecls, a_preExp, a_context);
        l_dimsValuesStr = Tpl.popIter(l_dimsValuesStr);
        l_fullname = Tpl.writeText(Tpl.emptyTxt, a_pref);
        ret_10 = System.unquoteIdentifier(i_cr_ident);
        l_fullname = Tpl.writeStr(l_fullname, ret_10);
        l_fullname__i = Tpl.writeText(Tpl.emptyTxt, l_typeName);
        l_fullname__i = Tpl.writeTok(l_fullname__i, Tpl.ST_STRING("_array_get("));
        l_fullname__i = Tpl.writeText(l_fullname__i, l_fullname);
        l_fullname__i = Tpl.writeTok(l_fullname__i, Tpl.ST_STRING(", "));
        l_fullname__i = Tpl.writeText(l_fullname__i, l_dimsLenStr);
        l_fullname__i = Tpl.writeTok(l_fullname__i, Tpl.ST_STRING(", "));
        l_fullname__i = Tpl.writeText(l_fullname__i, l_dimsValuesStr);
        l_fullname__i = Tpl.writeTok(l_fullname__i, Tpl.ST_STRING(")"));
        txt = Tpl.writeText(txt, l_fullname__i);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CREF_IDENT(ident = i_cr_ident),
           _,
           a_pref,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        l_fullname = Tpl.writeText(Tpl.emptyTxt, a_pref);
        ret_11 = System.unquoteIdentifier(i_cr_ident);
        l_fullname = Tpl.writeStr(l_fullname, ret_11);
        txt = Tpl.writeText(txt, l_fullname);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           i_cr,
           _,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt_12 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("crefNonSimVar got a cref it does not know how to handle "));
        txt_12 = CodegenUtil.crefStrNoUnderscore(txt_12, i_cr);
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 4534, 11), Tpl.textString(txt_12));
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end fun_683;

public function functionContextCrefFirstIdentNoUnderscore
  input Tpl.Text txt;
  input DAE.ComponentRef a_cr;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_pref;
  input Tpl.Text a_preExp;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_pref;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) := fun_683(txt, a_cr, a_context, a_pref, a_preExp, a_varDecls, a_auxFunction);
  out_a_pref := a_pref;
end functionContextCrefFirstIdentNoUnderscore;

protected function lm_685
  input Tpl.Text in_txt;
  input list<DAE.Subscript> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Subscript> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Exp i_exp;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           DAE.INDEX(exp = i_exp) :: rest,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeSubscriptExp(txt, i_exp, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_685(txt, rest, a_auxFunction, a_varDecls, a_preExp, a_context);
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           _ :: rest,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_685(txt, rest, a_auxFunction, a_varDecls, a_preExp, a_context);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end lm_685;

protected function fun_686
  input Tpl.Text in_txt;
  input DAE.ComponentRef in_a_cr;
  input Tpl.Text in_a_auxFunction;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_auxFunction) :=
  match(in_txt, in_a_cr, in_a_auxFunction, in_a_context)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      SimCodeFunction.Context a_context;
      DAE.ComponentRef i_componentRef;
      DAE.Ident i_ident;
      DAE.ComponentRef i_cr;
      ClassInf.State i_record__state;
      String ret_12;
      Tpl.Text txt_11;
      list<DAE.Subscript> ret_10;
      Tpl.Text l_dimsValuesStr;
      Integer ret_8;
      list<DAE.Subscript> ret_7;
      Tpl.Text l_dimsLenStr;
      Tpl.Text txt_5;
      Tpl.Text l_recPtr;
      Absyn.Path ret_3;
      Tpl.Text l_rec__name;
      Tpl.Text l_varDecls;
      Tpl.Text l_preExp;

    case ( txt,
           (i_cr as DAE.CREF_QUAL(identType = DAE.T_ARRAY(ty = DAE.T_COMPLEX(complexClassType = i_record__state)), ident = i_ident, componentRef = i_componentRef)),
           a_auxFunction,
           a_context )
      equation
        l_preExp = Tpl.emptyTxt;
        l_varDecls = Tpl.emptyTxt;
        ret_3 = ClassInf.getStateName(i_record__state);
        l_rec__name = CodegenUtil.underscorePath(Tpl.emptyTxt, ret_3);
        txt_5 = Tpl.writeText(Tpl.emptyTxt, l_rec__name);
        txt_5 = Tpl.writeTok(txt_5, Tpl.ST_STRING("*"));
        (l_recPtr, l_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(txt_5), l_varDecls);
        ret_7 = ComponentReference.crefSubs(i_cr);
        ret_8 = listLength(ret_7);
        l_dimsLenStr = Tpl.writeStr(Tpl.emptyTxt, intString(ret_8));
        ret_10 = ComponentReference.crefSubs(i_cr);
        l_dimsValuesStr = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_dimsValuesStr, a_auxFunction, l_varDecls, l_preExp) = lm_685(l_dimsValuesStr, ret_10, a_auxFunction, l_varDecls, l_preExp, a_context);
        l_dimsValuesStr = Tpl.popIter(l_dimsValuesStr);
        txt = Tpl.writeText(txt, l_rec__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_array_get(_"));
        txt = Tpl.writeStr(txt, i_ident);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, l_dimsLenStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, l_dimsValuesStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")->"));
        (txt, a_auxFunction) = contextCrefNoPrevExp(txt, i_componentRef, a_context, a_auxFunction);
      then (txt, a_auxFunction);

    case ( txt,
           i_cr,
           a_auxFunction,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt_11 = CodegenUtil.crefStr(Tpl.emptyTxt, i_cr);
        ret_12 = System.unquoteIdentifier(Tpl.textString(txt_11));
        txt = Tpl.writeStr(txt, ret_12);
      then (txt, a_auxFunction);
  end match;
end fun_686;

protected function fun_687
  input Tpl.Text in_txt;
  input SimCodeFunction.Context in_a_context;
  input DAE.ComponentRef in_a_cr;
  input Tpl.Text in_a_auxFunction;
  input Integer in_a_ix;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_auxFunction) :=
  match(in_txt, in_a_context, in_a_cr, in_a_auxFunction, in_a_ix)
    local
      Tpl.Text txt;
      DAE.ComponentRef a_cr;
      Tpl.Text a_auxFunction;
      Integer a_ix;
      SimCodeFunction.Context i_context;

    case ( txt,
           (i_context as SimCodeFunction.FUNCTION_CONTEXT(cref_prefix = _)),
           a_cr,
           a_auxFunction,
           _ )
      equation
        (txt, a_auxFunction) = fun_686(txt, a_cr, a_auxFunction, i_context);
      then (txt, a_auxFunction);

    case ( txt,
           (i_context as SimCodeFunction.JACOBIAN_CONTEXT(jacHT = SOME(_))),
           a_cr,
           a_auxFunction,
           a_ix )
      equation
        txt = jacCrefs(txt, a_cr, i_context, a_ix);
      then (txt, a_auxFunction);

    case ( txt,
           _,
           a_cr,
           a_auxFunction,
           a_ix )
      equation
        txt = crefOld(txt, a_cr, a_ix);
      then (txt, a_auxFunction);
  end match;
end fun_687;

public function contextCrefOld
  input Tpl.Text txt;
  input DAE.ComponentRef a_cr;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_auxFunction;
  input Integer a_ix;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_auxFunction) := fun_687(txt, a_context, a_cr, a_auxFunction, a_ix);
end contextCrefOld;

protected function fun_689
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_mArg;
  input Integer in_a_ix;
  input DAE.ComponentRef in_a_cr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_ix, in_a_cr)
    local
      Tpl.Text txt;
      Integer a_ix;
      DAE.ComponentRef a_cr;
      BackendDAE.VarKind i_varKind;
      DAE.ComponentRef i_name;
      Integer i_index;
      Tpl.Text txt_2;
      Tpl.Text txt_1;
      Tpl.Text txt_0;

    case ( txt,
           SimCodeVar.SIMVAR(varKind = (i_varKind as BackendDAE.JAC_VAR()), index = i_index, name = i_name),
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("jacobian->resultVars["));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] /* "));
        txt_0 = CodegenUtil.crefStrNoUnderscore(Tpl.emptyTxt, i_name);
        txt = CodegenUtil.escapeCComments(txt, Tpl.textString(txt_0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = CodegenUtil.variabilityString(txt, i_varKind);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" */"));
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(varKind = (i_varKind as BackendDAE.JAC_DIFF_VAR()), index = i_index, name = i_name),
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("jacobian->tmpVars["));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] /* "));
        txt_1 = CodegenUtil.crefStrNoUnderscore(Tpl.emptyTxt, i_name);
        txt = CodegenUtil.escapeCComments(txt, Tpl.textString(txt_1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = CodegenUtil.variabilityString(txt, i_varKind);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" */"));
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(varKind = (i_varKind as BackendDAE.SEED_VAR()), index = i_index, name = i_name),
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("jacobian->seedVars["));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] /* "));
        txt_2 = CodegenUtil.crefStrNoUnderscore(Tpl.emptyTxt, i_name);
        txt = CodegenUtil.escapeCComments(txt, Tpl.textString(txt_2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = CodegenUtil.variabilityString(txt, i_varKind);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" */"));
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(index = -2),
           a_ix,
           a_cr )
      equation
        txt = crefOld(txt, a_cr, a_ix);
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_689;

protected function fun_690
  input Tpl.Text in_txt;
  input SimCodeFunction.Context in_a_context;
  input DAE.ComponentRef in_a_cr;
  input Integer in_a_ix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_context, in_a_cr, in_a_ix)
    local
      Tpl.Text txt;
      DAE.ComponentRef a_cr;
      Integer a_ix;
      HashTableCrefSimVar.HashTable i_jacHT;
      SimCodeVar.SimVar ret_0;

    case ( txt,
           SimCodeFunction.JACOBIAN_CONTEXT(jacHT = SOME(i_jacHT)),
           a_cr,
           a_ix )
      equation
        ret_0 = SimCodeUtil.simVarFromHT(a_cr, i_jacHT);
        txt = fun_689(txt, ret_0, a_ix, a_cr);
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_690;

public function jacCrefs
  input Tpl.Text txt;
  input DAE.ComponentRef a_cr;
  input SimCodeFunction.Context a_context;
  input Integer a_ix;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_690(txt, a_context, a_cr, a_ix);
end jacCrefs;

protected function fun_692
  input Tpl.Text in_txt;
  input Boolean in_a_isPre;
  input DAE.ComponentRef in_a_cr;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_auxFunction) :=
  match(in_txt, in_a_isPre, in_a_cr, in_a_context, in_a_auxFunction)
    local
      Tpl.Text txt;
      DAE.ComponentRef a_cr;
      SimCodeFunction.Context a_context;
      Tpl.Text a_auxFunction;

    case ( txt,
           false,
           a_cr,
           a_context,
           a_auxFunction )
      equation
        (txt, a_auxFunction) = contextCrefNoPrevExp(txt, a_cr, a_context, a_auxFunction);
      then (txt, a_auxFunction);

    case ( txt,
           _,
           a_cr,
           _,
           a_auxFunction )
      equation
        txt = crefPre(txt, a_cr);
      then (txt, a_auxFunction);
  end match;
end fun_692;

public function contextCrefIsPre
  input Tpl.Text txt;
  input DAE.ComponentRef a_cr;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_auxFunction;
  input Boolean a_isPre;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_auxFunction) := fun_692(txt, a_isPre, a_cr, a_context, a_auxFunction);
end contextCrefIsPre;

protected function fun_694
  input Tpl.Text in_txt;
  input SimCodeFunction.Context in_a_context;
  input Absyn.Ident in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_context, in_a_name)
    local
      Tpl.Text txt;
      Absyn.Ident a_name;
      String ret_1;
      String ret_0;

    case ( txt,
           SimCodeFunction.FUNCTION_CONTEXT(cref_prefix = _),
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        ret_0 = System.unquoteIdentifier(a_name);
        txt = Tpl.writeStr(txt, ret_0);
      then txt;

    case ( txt,
           _,
           a_name )
      equation
        ret_1 = System.unquoteIdentifier(a_name);
        txt = Tpl.writeStr(txt, ret_1);
      then txt;
  end match;
end fun_694;

public function contextIteratorName
  input Tpl.Text txt;
  input Absyn.Ident a_name;
  input SimCodeFunction.Context a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_694(txt, a_context, a_name);
end contextIteratorName;

public function cref
  input Tpl.Text in_txt;
  input DAE.ComponentRef in_a_cr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_cr)
    local
      Tpl.Text txt;
      DAE.ComponentRef i_cr;

    case ( txt,
           (i_cr as DAE.CREF_IDENT(ident = "xloc")) )
      equation
        txt = CodegenUtil.crefStr(txt, i_cr);
      then txt;

    case ( txt,
           DAE.CREF_IDENT(ident = "time") )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("data->localData[0]->timeValue"));
      then txt;

    case ( txt,
           DAE.CREF_IDENT(ident = "__OMC_DT") )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("data->simulationInfo->inlineData->dt"));
      then txt;

    case ( txt,
           DAE.CREF_IDENT(ident = "__HOM_LAMBDA") )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("data->simulationInfo->lambda"));
      then txt;

    case ( txt,
           DAE.WILD() )
      then txt;

    case ( txt,
           i_cr )
      equation
        txt = crefToCStr(txt, i_cr, 0, false, false);
      then txt;
  end match;
end cref;

protected function fun_697
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;
  input DAE.Exp in_a_startExp;
  input DAE.ComponentRef in_a_cr;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_mArg, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context, in_a_startExp, in_a_cr)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Exp a_startExp;
      DAE.ComponentRef a_cr;

    case ( txt,
           false,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _,
           _,
           a_cr )
      equation
        txt = cref(txt, a_cr);
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           _,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context,
           a_startExp,
           _ )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExp(txt, a_startExp, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end fun_697;

protected function fun_698
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_mArg;
  input DAE.ComponentRef in_a_cr;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_mArg, in_a_cr, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      DAE.ComponentRef a_cr;
      SimCodeFunction.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Exp i_startExp;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           SimCodeVar.SIMVAR(initialValue = SOME(i_startExp)),
           a_cr,
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        ret_0 = Expression.isConst(i_startExp);
        ret_1 = boolNot(ret_0);
        (txt, a_auxFunction, a_varDecls, a_preExp) = fun_697(txt, ret_1, a_auxFunction, a_varDecls, a_preExp, a_context, i_startExp, a_cr);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           a_cr,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt = cref(txt, a_cr);
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end fun_698;

public function crefOrStartCref
  input Tpl.Text txt;
  input DAE.ComponentRef a_cr;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_preExp;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
protected
  SimCodeVar.SimVar ret_1;
  SimCode.SimCode ret_0;
algorithm
  ret_0 := SimCodeUtil.getSimCode();
  ret_1 := SimCodeUtil.cref2simvar(a_cr, ret_0);
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) := fun_698(txt, ret_1, a_cr, a_context, a_preExp, a_varDecls, a_auxFunction);
end crefOrStartCref;

public function crefOld
  input Tpl.Text in_txt;
  input DAE.ComponentRef in_a_cr;
  input Integer in_a_ix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_cr, in_a_ix)
    local
      Tpl.Text txt;
      Integer a_ix;
      DAE.ComponentRef i_cr;

    case ( txt,
           (i_cr as DAE.CREF_IDENT(ident = "xloc")),
           _ )
      equation
        txt = CodegenUtil.crefStr(txt, i_cr);
      then txt;

    case ( txt,
           DAE.CREF_IDENT(ident = "time"),
           a_ix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("data->localData["));
        txt = Tpl.writeStr(txt, intString(a_ix));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("]->timeValue"));
      then txt;

    case ( txt,
           DAE.CREF_IDENT(ident = "__OMC_DT"),
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("data->simulationInfo->inlineData->dt"));
      then txt;

    case ( txt,
           DAE.CREF_IDENT(ident = "__HOM_LAMBDA"),
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("data->simulationInfo->lambda"));
      then txt;

    case ( txt,
           DAE.WILD(),
           _ )
      then txt;

    case ( txt,
           i_cr,
           a_ix )
      equation
        txt = crefToCStr(txt, i_cr, a_ix, false, false);
      then txt;
  end match;
end crefOld;

public function crefPre
  input Tpl.Text in_txt;
  input DAE.ComponentRef in_a_cr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_cr)
    local
      Tpl.Text txt;
      DAE.ComponentRef i_cr;

    case ( txt,
           DAE.CREF_IDENT(ident = "time") )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("data->localData[0]->timeValueOld"));
      then txt;

    case ( txt,
           i_cr )
      equation
        txt = crefToCStr(txt, i_cr, 0, true, false);
      then txt;
  end match;
end crefPre;

public function crefDefine
  input Tpl.Text in_txt;
  input DAE.ComponentRef in_a_cr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_cr)
    local
      Tpl.Text txt;
      DAE.ComponentRef i_cr;
      String ret_1;
      Tpl.Text txt_0;

    case ( txt,
           (i_cr as DAE.CREF_IDENT(ident = "xloc")) )
      equation
        txt = CodegenUtil.crefStr(txt, i_cr);
      then txt;

    case ( txt,
           DAE.CREF_IDENT(ident = "time") )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("data->localData[0]->timeValue"));
      then txt;

    case ( txt,
           DAE.WILD() )
      then txt;

    case ( txt,
           i_cr )
      equation
        txt_0 = CodegenUtil.crefStrNoUnderscore(Tpl.emptyTxt, i_cr);
        ret_1 = System.unquoteIdentifier(Tpl.textString(txt_0));
        txt = Tpl.writeStr(txt, ret_1);
      then txt;
  end match;
end crefDefine;

public function crefNonSimVar
  input Tpl.Text txt;
  input DAE.ComponentRef a_cr;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_auxFunction;
  Tpl.Text l_varDecls;
  Tpl.Text l_preExp;
algorithm
  l_preExp := Tpl.emptyTxt;
  l_varDecls := Tpl.emptyTxt;
  l_auxFunction := Tpl.emptyTxt;
  (out_txt, _, l_preExp, l_varDecls, l_auxFunction) := functionContextCrefFirstIdentNoUnderscore(txt, a_cr, SimCodeFunction.contextFunction, Tpl.strTokText(Tpl.ST_STRING("")), l_preExp, l_varDecls, l_auxFunction);
end crefNonSimVar;

protected function fun_704
  input Tpl.Text in_txt;
  input Boolean in_a_isPre;
  input DAE.ComponentRef in_a_cr;
  input Boolean in_a_isStart;
  input Integer in_a_ix;
  input DAE.ComponentRef in_a_componentRef;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_isPre, in_a_cr, in_a_isStart, in_a_ix, in_a_componentRef)
    local
      Tpl.Text txt;
      DAE.ComponentRef a_cr;
      Boolean a_isStart;
      Integer a_ix;
      DAE.ComponentRef a_componentRef;
      Tpl.Text txt_0;

    case ( txt,
           false,
           _,
           a_isStart,
           a_ix,
           a_componentRef )
      equation
        txt = crefToCStr(txt, a_componentRef, a_ix, true, a_isStart);
      then txt;

    case ( txt,
           _,
           a_cr,
           _,
           _,
           _ )
      equation
        txt_0 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("Got $PRE for something that is already pre: "));
        txt_0 = CodegenUtil.crefStrNoUnderscore(txt_0, a_cr);
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 4670, 26), Tpl.textString(txt_0));
      then txt;
  end match;
end fun_704;

protected function fun_705
  input Tpl.Text in_txt;
  input Boolean in_a_isPre;
  input DAE.ComponentRef in_a_cr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_isPre, in_a_cr)
    local
      Tpl.Text txt;
      DAE.ComponentRef a_cr;
      DAE.ComponentRef ret_0;

    case ( txt,
           false,
           a_cr )
      equation
        txt = crefNonSimVar(txt, a_cr);
      then txt;

    case ( txt,
           _,
           a_cr )
      equation
        ret_0 = ComponentReference.crefPrefixPre(a_cr);
        txt = crefNonSimVar(txt, ret_0);
      then txt;
  end match;
end fun_705;

protected function fun_706
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_ix;
  input Tpl.Text in_a_s;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_ix, in_a_s)
    local
      Tpl.Text txt;
      Integer a_ix;
      Tpl.Text a_s;

    case ( txt,
           false,
           a_ix,
           a_s )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeText(txt, a_s);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeStr(txt, intString(a_ix));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           _,
           _,
           a_s )
      equation
        txt = Tpl.writeText(txt, a_s);
      then txt;
  end match;
end fun_706;

protected function fun_707
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_mArg;
  input DAE.ComponentRef in_a_cr;
  input Boolean in_a_isStart;
  input Boolean in_a_isPre;
  input Integer in_a_ix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_cr, in_a_isStart, in_a_isPre, in_a_ix)
    local
      Tpl.Text txt;
      DAE.ComponentRef a_cr;
      Boolean a_isStart;
      Boolean a_isPre;
      Integer a_ix;
      SimCodeVar.SimVar i_var;
      BackendDAE.VarKind i_varKind;
      DAE.ComponentRef i_name;
      DAE.ComponentRef i_varName;
      Integer i_index;
      Tpl.Text txt_7;
      Boolean ret_6;
      Tpl.Text l_s;
      Tpl.Text txt_4;
      Tpl.Text txt_3;
      Tpl.Text txt_2;
      Tpl.Text txt_1;
      Tpl.Text txt_0;

    case ( txt,
           SimCodeVar.SIMVAR(varKind = BackendDAE.ALG_STATE_OLD(), index = i_index),
           _,
           _,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("data->simulationInfo->inlineData->algOldVars["));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("]"));
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(aliasvar = SimCodeVar.ALIAS(varName = i_varName)),
           _,
           a_isStart,
           a_isPre,
           a_ix )
      equation
        txt = crefToCStr(txt, i_varName, a_ix, a_isPre, a_isStart);
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(aliasvar = SimCodeVar.NEGATEDALIAS(varName = i_varName), type_ = DAE.T_BOOL(varLst = _)),
           _,
           a_isStart,
           a_isPre,
           a_ix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("!("));
        txt = crefToCStr(txt, i_varName, a_ix, a_isPre, a_isStart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(aliasvar = SimCodeVar.NEGATEDALIAS(varName = i_varName)),
           _,
           a_isStart,
           a_isPre,
           a_ix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-("));
        txt = crefToCStr(txt, i_varName, a_ix, a_isPre, a_isStart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(varKind = (i_varKind as BackendDAE.JAC_VAR()), index = i_index, name = i_name),
           _,
           _,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("parentJacobian->resultVars["));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] /* "));
        txt_0 = CodegenUtil.crefStrNoUnderscore(Tpl.emptyTxt, i_name);
        txt = CodegenUtil.escapeCComments(txt, Tpl.textString(txt_0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = CodegenUtil.variabilityString(txt, i_varKind);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" */"));
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(varKind = (i_varKind as BackendDAE.JAC_DIFF_VAR()), index = i_index, name = i_name),
           _,
           _,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("parentJacobian->tmpVars["));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] /* "));
        txt_1 = CodegenUtil.crefStrNoUnderscore(Tpl.emptyTxt, i_name);
        txt = CodegenUtil.escapeCComments(txt, Tpl.textString(txt_1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = CodegenUtil.variabilityString(txt, i_varKind);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" */"));
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(varKind = (i_varKind as BackendDAE.SEED_VAR()), index = i_index, name = i_name),
           _,
           _,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("parentJacobian->seedVars["));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] /* "));
        txt_2 = CodegenUtil.crefStrNoUnderscore(Tpl.emptyTxt, i_name);
        txt = CodegenUtil.escapeCComments(txt, Tpl.textString(txt_2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = CodegenUtil.variabilityString(txt, i_varKind);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" */"));
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(varKind = (i_varKind as BackendDAE.DAE_RESIDUAL_VAR()), index = i_index, name = i_name),
           _,
           _,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("data->simulationInfo->daeModeData->residualVars["));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] /* "));
        txt_3 = CodegenUtil.crefStrNoUnderscore(Tpl.emptyTxt, i_name);
        txt = CodegenUtil.escapeCComments(txt, Tpl.textString(txt_3));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = CodegenUtil.variabilityString(txt, i_varKind);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" */"));
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(varKind = (i_varKind as BackendDAE.DAE_AUX_VAR()), index = i_index, name = i_name),
           _,
           _,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("data->simulationInfo->daeModeData->auxiliaryVars["));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] /* "));
        txt_4 = CodegenUtil.crefStrNoUnderscore(Tpl.emptyTxt, i_name);
        txt = CodegenUtil.escapeCComments(txt, Tpl.textString(txt_4));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = CodegenUtil.variabilityString(txt, i_varKind);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" */"));
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(index = -2),
           a_cr,
           _,
           a_isPre,
           a_ix )
      equation
        l_s = fun_705(Tpl.emptyTxt, a_isPre, a_cr);
        ret_6 = intEq(a_ix, 0);
        txt = fun_706(txt, ret_6, a_ix, l_s);
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(index = -1, varKind = i_varKind, name = i_name),
           _,
           _,
           _,
           _ )
      equation
        txt_7 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("crefToCStr got index=-1 for "));
        txt_7 = CodegenUtil.variabilityString(txt_7, i_varKind);
        txt_7 = Tpl.writeTok(txt_7, Tpl.ST_STRING(" "));
        txt_7 = CodegenUtil.crefStrNoUnderscore(txt_7, i_name);
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 4688, 45), Tpl.textString(txt_7));
      then txt;

    case ( txt,
           (i_var as SimCodeVar.SIMVAR(name = _)),
           _,
           a_isStart,
           a_isPre,
           a_ix )
      equation
        txt = varArrayNameValues(txt, i_var, a_ix, a_isPre, a_isStart);
      then txt;

    case ( txt,
           _,
           _,
           _,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("CREF_NOT_IDENT_OR_QUAL"));
      then txt;
  end match;
end fun_707;

public function crefToCStr
  input Tpl.Text in_txt;
  input DAE.ComponentRef in_a_cr;
  input Integer in_a_ix;
  input Boolean in_a_isPre;
  input Boolean in_a_isStart;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_cr, in_a_ix, in_a_isPre, in_a_isStart)
    local
      Tpl.Text txt;
      Integer a_ix;
      Boolean a_isPre;
      Boolean a_isStart;
      DAE.ComponentRef i_cr;
      DAE.ComponentRef i_componentRef;
      SimCodeVar.SimVar ret_1;
      SimCode.SimCode ret_0;

    case ( txt,
           DAE.CREF_IDENT(ident = "time"),
           _,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("data->localData[0]->timeValue"));
      then txt;

    case ( txt,
           (i_cr as DAE.CREF_QUAL(ident = "$PRE", subscriptLst = {}, componentRef = i_componentRef)),
           a_ix,
           a_isPre,
           a_isStart )
      equation
        txt = fun_704(txt, a_isPre, i_cr, a_isStart, a_ix, i_componentRef);
      then txt;

    case ( txt,
           DAE.CREF_QUAL(ident = "$START", componentRef = i_componentRef),
           a_ix,
           a_isPre,
           _ )
      equation
        txt = crefToCStr(txt, i_componentRef, a_ix, a_isPre, true);
      then txt;

    case ( txt,
           i_cr,
           a_ix,
           a_isPre,
           a_isStart )
      equation
        ret_0 = SimCodeUtil.getSimCode();
        ret_1 = SimCodeUtil.cref2simvar(i_cr, ret_0);
        txt = fun_707(txt, ret_1, i_cr, a_isStart, a_isPre, a_ix);
      then txt;
  end match;
end crefToCStr;

protected function fun_709
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;
      Integer i_index;

    case ( txt,
           SimCodeVar.SIMVAR(index = i_index) )
      equation
        txt = Tpl.writeStr(txt, intString(i_index));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("CREF_NOT_FOUND"));
      then txt;
  end match;
end fun_709;

public function crefToIndex
  input Tpl.Text txt;
  input DAE.ComponentRef a_cr;

  output Tpl.Text out_txt;
protected
  SimCodeVar.SimVar ret_1;
  SimCode.SimCode ret_0;
algorithm
  ret_0 := SimCodeUtil.getSimCode();
  ret_1 := SimCodeUtil.cref2simvar(a_cr, ret_0);
  out_txt := fun_709(txt, ret_1);
end crefToIndex;

public function crefTypeOMSIC
  input Tpl.Text in_txt;
  input DAE.ComponentRef in_a_cr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_cr)
    local
      Tpl.Text txt;
      DAE.ComponentRef i_componentRef;
      DAE.Type i_identType;

    case ( txt,
           DAE.CREF_IDENT(identType = i_identType) )
      equation
        txt = crefTypeNameOMSIC(txt, i_identType);
      then txt;

    case ( txt,
           DAE.CREF_QUAL(componentRef = i_componentRef) )
      equation
        txt = crefTypeOMSIC(txt, i_componentRef);
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("crefType:ERROR"));
      then txt;
  end match;
end crefTypeOMSIC;

public function crefTypeNameOMSIC
  input Tpl.Text in_txt;
  input DAE.Type in_a_type;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_type)
    local
      Tpl.Text txt;
      DAE.Type i_type;
      ClassInf.State i_complexClassType;
      DAE.Type i_ty;
      DAE.Type i_complexType;
      Tpl.Text txt_1;
      String ret_1;
      Absyn.Path ret_0;

    case ( txt,
           DAE.T_INTEGER(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("ints"));
      then txt;

    case ( txt,
           DAE.T_REAL(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("reals"));
      then txt;

    case ( txt,
           DAE.T_STRING(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("strings"));
      then txt;

    case ( txt,
           DAE.T_BOOL(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("bools"));
      then txt;

    case ( txt,
           DAE.T_ENUMERATION(index = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("ints"));
      then txt;

    case ( txt,
           DAE.T_SUBTYPE_BASIC(complexType = i_complexType) )
      equation
        txt = crefTypeNameOMSIC(txt, i_complexType);
      then txt;

    case ( txt,
           DAE.T_ARRAY(ty = i_ty) )
      equation
        txt = crefTypeNameOMSIC(txt, i_ty);
      then txt;

    case ( txt,
           DAE.T_COMPLEX(complexClassType = ClassInf.EXTERNAL_OBJ(path = _)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("complex"));
      then txt;

    case ( txt,
           DAE.T_COMPLEX(complexClassType = i_complexClassType) )
      equation
        ret_0 = ClassInf.getStateName(i_complexClassType);
        txt = CodegenUtil.underscorePath(txt, ret_0);
      then txt;

    case ( txt,
           i_type )
      equation
        txt_1 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("crefTypeNameOMSIC: "));
        ret_1 = Types.unparseType(i_type);
        txt_1 = Tpl.writeStr(txt_1, ret_1);
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 4727, 26), Tpl.textString(txt_1));
      then txt;
  end match;
end crefTypeNameOMSIC;

protected function fun_713
  input Tpl.Text in_txt;
  input SimCodeFunction.Context in_a_context;
  input DAE.ComponentRef in_a_cr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_context, in_a_cr)
    local
      Tpl.Text txt;
      DAE.ComponentRef a_cr;

    case ( txt,
           SimCodeFunction.FUNCTION_CONTEXT(cref_prefix = _),
           a_cr )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = arrayCrefStr(txt, a_cr);
      then txt;

    case ( txt,
           _,
           a_cr )
      equation
        txt = crefToCStr(txt, a_cr, 0, false, false);
      then txt;
  end match;
end fun_713;

public function contextArrayCref
  input Tpl.Text txt;
  input DAE.ComponentRef a_cr;
  input SimCodeFunction.Context a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_713(txt, a_context, a_cr);
end contextArrayCref;

public function arrayCrefStr
  input Tpl.Text in_txt;
  input DAE.ComponentRef in_a_cr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_cr)
    local
      Tpl.Text txt;
      DAE.ComponentRef i_componentRef;
      DAE.Ident i_ident;
      String ret_1;
      String ret_0;

    case ( txt,
           DAE.CREF_IDENT(ident = i_ident) )
      equation
        ret_0 = System.unquoteIdentifier(i_ident);
        txt = Tpl.writeStr(txt, ret_0);
      then txt;

    case ( txt,
           DAE.CREF_QUAL(ident = i_ident, componentRef = i_componentRef) )
      equation
        ret_1 = System.unquoteIdentifier(i_ident);
        txt = Tpl.writeStr(txt, ret_1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("._"));
        txt = arrayCrefStr(txt, i_componentRef);
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("CREF_NOT_IDENT_OR_QUAL"));
      then txt;
  end match;
end arrayCrefStr;

public function crefFunctionName
  input Tpl.Text in_txt;
  input DAE.ComponentRef in_a_cr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_cr)
    local
      Tpl.Text txt;
      DAE.ComponentRef i_componentRef;
      DAE.Ident i_ident;
      String ret_3;
      String ret_2;
      String ret_1;
      String ret_0;

    case ( txt,
           DAE.CREF_IDENT(ident = i_ident) )
      equation
        ret_0 = System.unquoteIdentifier(i_ident);
        ret_1 = System.stringReplace(ret_0, "_", "__");
        txt = Tpl.writeStr(txt, ret_1);
      then txt;

    case ( txt,
           DAE.CREF_QUAL(ident = i_ident, componentRef = i_componentRef) )
      equation
        ret_2 = System.unquoteIdentifier(i_ident);
        ret_3 = System.stringReplace(ret_2, "_", "__");
        txt = Tpl.writeStr(txt, ret_3);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = crefFunctionName(txt, i_componentRef);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end crefFunctionName;

protected function fun_717
  input Tpl.Text in_txt;
  input Integer in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;
      Integer i_i;

    case ( txt,
           0 )
      then txt;

    case ( txt,
           i_i )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_metatype tmpMeta["));
        txt = Tpl.writeStr(txt, intString(i_i));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] __attribute__((unused)) = {0};"));
      then txt;
  end match;
end fun_717;

public function addRootsTempArray
  input Tpl.Text txt;

  output Tpl.Text out_txt;
protected
  Integer ret_0;
algorithm
  ret_0 := System.tmpTickMaximum(1);
  out_txt := fun_717(txt, ret_0);
end addRootsTempArray;

protected function fun_719
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input SourceInfo in_a_info;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_info)
    local
      Tpl.Text txt;
      SourceInfo a_info;
      String ret_0;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_info )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("mmc_set_current_pos(\""));
        ret_0 = Error.infoStr(a_info);
        txt = Tpl.writeStr(txt, ret_0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\");"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;
  end match;
end fun_719;

protected function fun_720
  input Tpl.Text in_txt;
  input SourceInfo in_a_info;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_info)
    local
      Tpl.Text txt;
      SourceInfo i_info;
      String i_fileName;
      Boolean ret_1;
      Integer ret_0;

    case ( txt,
           (i_info as SOURCEINFO(fileName = i_fileName)) )
      equation
        ret_0 = System.stringFind(i_fileName, ".interface.mo");
        ret_1 = intEq(-1, ret_0);
        txt = fun_719(txt, ret_1, i_info);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_720;

protected function fun_721
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input SourceInfo in_a_info;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_info)
    local
      Tpl.Text txt;
      SourceInfo a_info;
      String ret_1;
      String ret_0;

    case ( txt,
           false,
           a_info )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/*#modelicaLine "));
        ret_0 = Error.infoStr(a_info);
        txt = Tpl.writeStr(txt, ret_0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("*/"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _,
           a_info )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/*#modelicaLine "));
        ret_1 = Error.infoStr(a_info);
        txt = Tpl.writeStr(txt, ret_1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("*/"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = fun_720(txt, a_info);
      then txt;
  end match;
end fun_721;

protected function fun_722
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input SourceInfo in_a_info;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_info)
    local
      Tpl.Text txt;
      SourceInfo a_info;
      Boolean ret_0;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_info )
      equation
        ret_0 = Flags.isSet(Flags.OMC_RECORD_ALLOC_WORDS);
        txt = fun_721(txt, ret_0, a_info);
      then txt;
  end match;
end fun_722;

public function modelicaLine
  input Tpl.Text txt;
  input SourceInfo a_info;

  output Tpl.Text out_txt;
protected
  Boolean ret_2;
  Boolean ret_1;
  Boolean ret_0;
algorithm
  ret_0 := Config.acceptMetaModelicaGrammar();
  ret_1 := Flags.isSet(Flags.GEN_DEBUG_SYMBOLS);
  ret_2 := boolOr(ret_0, ret_1);
  out_txt := fun_722(txt, ret_2, a_info);
end modelicaLine;

protected function fun_724
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/*#endModelicaLine*/"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;
  end match;
end fun_724;

public function endModelicaLine
  input Tpl.Text txt;

  output Tpl.Text out_txt;
protected
  Boolean ret_2;
  Boolean ret_1;
  Boolean ret_0;
algorithm
  ret_0 := Config.acceptMetaModelicaGrammar();
  ret_1 := Flags.isSet(Flags.GEN_DEBUG_SYMBOLS);
  ret_2 := boolOr(ret_0, ret_1);
  out_txt := fun_724(txt, ret_2);
end endModelicaLine;

protected function fun_726
  input Tpl.Text in_txt;
  input String in_a_ty;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_varDecls) :=
  match(in_txt, in_a_ty, in_a_varDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_varDecls;
      String i_ty;
      Integer ret_4;
      Tpl.Text l_newVarIx;
      Integer ret_2;
      Integer ret_1;
      Integer ret_0;

    case ( txt,
           "modelica_metatype",
           a_varDecls )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("tmpMeta["));
        ret_0 = System.tmpTickIndex(1);
        txt = Tpl.writeStr(txt, intString(ret_0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("]"));
      then (txt, a_varDecls);

    case ( txt,
           "metamodelica_string",
           a_varDecls )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("tmpMeta["));
        ret_1 = System.tmpTickIndex(1);
        txt = Tpl.writeStr(txt, intString(ret_1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("]"));
      then (txt, a_varDecls);

    case ( txt,
           "metamodelica_string_const",
           a_varDecls )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("tmpMeta["));
        ret_2 = System.tmpTickIndex(1);
        txt = Tpl.writeStr(txt, intString(ret_2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("]"));
      then (txt, a_varDecls);

    case ( txt,
           i_ty,
           a_varDecls )
      equation
        l_newVarIx = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("tmp"));
        ret_4 = System.tmpTick();
        l_newVarIx = Tpl.writeStr(l_newVarIx, intString(ret_4));
        a_varDecls = Tpl.writeStr(a_varDecls, i_ty);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(" "));
        a_varDecls = Tpl.writeText(a_varDecls, l_newVarIx);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(";"));
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_newVarIx);
      then (txt, a_varDecls);
  end match;
end fun_726;

public function tempDecl
  input Tpl.Text txt;
  input String a_ty;
  input Tpl.Text a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
protected
  Tpl.Text l_newVar;
algorithm
  (l_newVar, out_a_varDecls) := fun_726(Tpl.emptyTxt, a_ty, a_varDecls);
  out_txt := Tpl.writeText(txt, l_newVar);
end tempDecl;

public function tempDeclArray
  input Tpl.Text txt;
  input String a_ty;
  input Tpl.Text a_len;
  input Tpl.Text a_elts;
  input Tpl.Text a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_len;
  output Tpl.Text out_a_elts;
  output Tpl.Text out_a_varDecls;
protected
  Integer ret_1;
  Tpl.Text l_newVarIx;
algorithm
  l_newVarIx := Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("tmp"));
  ret_1 := System.tmpTick();
  l_newVarIx := Tpl.writeStr(l_newVarIx, intString(ret_1));
  out_a_varDecls := Tpl.writeStr(a_varDecls, a_ty);
  out_a_varDecls := Tpl.writeTok(out_a_varDecls, Tpl.ST_STRING(" "));
  out_a_varDecls := Tpl.writeText(out_a_varDecls, l_newVarIx);
  out_a_varDecls := Tpl.writeTok(out_a_varDecls, Tpl.ST_STRING("["));
  out_a_varDecls := Tpl.writeText(out_a_varDecls, a_len);
  out_a_varDecls := Tpl.writeTok(out_a_varDecls, Tpl.ST_STRING("] = {"));
  out_a_varDecls := Tpl.writeText(out_a_varDecls, a_elts);
  out_a_varDecls := Tpl.writeTok(out_a_varDecls, Tpl.ST_STRING("};"));
  out_a_varDecls := Tpl.writeTok(out_a_varDecls, Tpl.ST_NEW_LINE());
  out_txt := Tpl.writeText(txt, l_newVarIx);
  out_a_len := a_len;
  out_a_elts := a_elts;
end tempDeclArray;

protected function fun_729
  input Tpl.Text in_txt;
  input String in_a_ty;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_varDecls) :=
  match(in_txt, in_a_ty, in_a_varDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_varDecls;
      String i_ty;
      Integer ret_4;
      Tpl.Text l_newVarIx;
      Integer ret_2;
      Integer ret_1;
      Integer ret_0;

    case ( txt,
           "modelica_metatype",
           a_varDecls )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("tmpMeta["));
        ret_0 = System.tmpTickIndex(1);
        txt = Tpl.writeStr(txt, intString(ret_0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("]"));
      then (txt, a_varDecls);

    case ( txt,
           "metamodelica_string",
           a_varDecls )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("tmpMeta["));
        ret_1 = System.tmpTickIndex(1);
        txt = Tpl.writeStr(txt, intString(ret_1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("]"));
      then (txt, a_varDecls);

    case ( txt,
           "metamodelica_string_const",
           a_varDecls )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("tmpMeta["));
        ret_2 = System.tmpTickIndex(1);
        txt = Tpl.writeStr(txt, intString(ret_2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("]"));
      then (txt, a_varDecls);

    case ( txt,
           i_ty,
           a_varDecls )
      equation
        l_newVarIx = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("tmp"));
        ret_4 = System.tmpTick();
        l_newVarIx = Tpl.writeStr(l_newVarIx, intString(ret_4));
        a_varDecls = Tpl.writeStr(a_varDecls, i_ty);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(" "));
        a_varDecls = Tpl.writeText(a_varDecls, l_newVarIx);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(" = 0;"));
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_newVarIx);
      then (txt, a_varDecls);
  end match;
end fun_729;

public function tempDeclZero
  input Tpl.Text txt;
  input String a_ty;
  input Tpl.Text a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
protected
  Tpl.Text l_newVar;
algorithm
  (l_newVar, out_a_varDecls) := fun_729(Tpl.emptyTxt, a_ty, a_varDecls);
  out_txt := Tpl.writeText(txt, l_newVar);
end tempDeclZero;

protected function fun_731
  input Tpl.Text in_txt;
  input DAE.MatchType in_a_matchTy;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_matchTy)
    local
      Tpl.Text txt;

    case ( txt,
           DAE.MATCHCONTINUE() )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("volatile "));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_731;

public function tempDeclMatchInput
  input Tpl.Text txt;
  input DAE.MatchType a_matchTy;
  input String a_ty;
  input String a_startIndex;
  input String a_index;
  input Tpl.Text a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
protected
  Tpl.Text l_ix;
algorithm
  l_ix := Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("tmp"));
  l_ix := Tpl.writeStr(l_ix, a_startIndex);
  l_ix := Tpl.writeTok(l_ix, Tpl.ST_STRING("_"));
  l_ix := Tpl.writeStr(l_ix, a_index);
  out_a_varDecls := fun_731(a_varDecls, a_matchTy);
  out_a_varDecls := Tpl.writeStr(out_a_varDecls, a_ty);
  out_a_varDecls := Tpl.writeTok(out_a_varDecls, Tpl.ST_STRING(" "));
  out_a_varDecls := Tpl.writeText(out_a_varDecls, l_ix);
  out_a_varDecls := Tpl.writeTok(out_a_varDecls, Tpl.ST_STRING(";"));
  out_txt := Tpl.writeText(txt, l_ix);
end tempDeclMatchInput;

public function getTempDeclMatchInputName
  input Tpl.Text txt;
  input String a_startIndex;
  input Integer a_index;

  output Tpl.Text out_txt;
algorithm
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING("tmp"));
  out_txt := Tpl.writeStr(out_txt, a_startIndex);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("_"));
  out_txt := Tpl.writeStr(out_txt, intString(a_index));
end getTempDeclMatchInputName;

protected function fun_734
  input Tpl.Text in_txt;
  input String in_a_ty;
  input Tpl.Text in_a_varDecls;
  input String in_a_prefix;
  input String in_a_index;
  input String in_a_startIndex;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_varDecls) :=
  match(in_txt, in_a_ty, in_a_varDecls, in_a_prefix, in_a_index, in_a_startIndex)
    local
      Tpl.Text txt;
      Tpl.Text a_varDecls;
      String a_prefix;
      String a_index;
      String a_startIndex;
      String i_ty;
      Tpl.Text l_newVarIx;

    case ( txt,
           "modelica_metatype",
           a_varDecls,
           _,
           a_index,
           a_startIndex )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("tmpMeta["));
        txt = Tpl.writeStr(txt, a_startIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("+"));
        txt = Tpl.writeStr(txt, a_index);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("]"));
      then (txt, a_varDecls);

    case ( txt,
           "metamodelica_string",
           a_varDecls,
           _,
           a_index,
           a_startIndex )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("tmpMeta["));
        txt = Tpl.writeStr(txt, a_startIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("+"));
        txt = Tpl.writeStr(txt, a_index);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("]"));
      then (txt, a_varDecls);

    case ( txt,
           "metamodelica_string_const",
           a_varDecls,
           _,
           a_index,
           a_startIndex )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("tmpMeta["));
        txt = Tpl.writeStr(txt, a_startIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("+"));
        txt = Tpl.writeStr(txt, a_index);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("]"));
      then (txt, a_varDecls);

    case ( txt,
           i_ty,
           a_varDecls,
           a_prefix,
           a_index,
           _ )
      equation
        l_newVarIx = Tpl.writeStr(Tpl.emptyTxt, a_prefix);
        l_newVarIx = Tpl.writeTok(l_newVarIx, Tpl.ST_STRING("_c"));
        l_newVarIx = Tpl.writeStr(l_newVarIx, a_index);
        a_varDecls = Tpl.writeStr(a_varDecls, i_ty);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(" "));
        a_varDecls = Tpl.writeText(a_varDecls, l_newVarIx);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(" __attribute__((unused)) = 0;"));
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_newVarIx);
      then (txt, a_varDecls);
  end match;
end fun_734;

public function tempDeclMatchOutput
  input Tpl.Text txt;
  input String a_ty;
  input String a_prefix;
  input String a_startIndex;
  input String a_index;
  input Tpl.Text a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
protected
  Tpl.Text l_newVar;
algorithm
  (l_newVar, out_a_varDecls) := fun_734(Tpl.emptyTxt, a_ty, a_varDecls, a_prefix, a_index, a_startIndex);
  out_txt := Tpl.writeText(txt, l_newVar);
end tempDeclMatchOutput;

protected function fun_736
  input Tpl.Text in_txt;
  input String in_mArg;
  input String in_a_prefix;
  input Integer in_a_index;
  input String in_a_startIndex;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_prefix, in_a_index, in_a_startIndex)
    local
      Tpl.Text txt;
      String a_prefix;
      Integer a_index;
      String a_startIndex;
      Integer ret_4;
      Tpl.Text l_newVarIx;
      Integer ret_2;
      Integer ret_1;
      Integer ret_0;

    case ( txt,
           "modelica_metatype",
           _,
           a_index,
           a_startIndex )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("tmpMeta["));
        txt = Tpl.writeStr(txt, a_startIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("+"));
        ret_0 = intSub(a_index, 1);
        txt = Tpl.writeStr(txt, intString(ret_0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("]"));
      then txt;

    case ( txt,
           "metamodelica_string",
           _,
           a_index,
           a_startIndex )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("tmpMeta["));
        txt = Tpl.writeStr(txt, a_startIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("+"));
        ret_1 = intSub(a_index, 1);
        txt = Tpl.writeStr(txt, intString(ret_1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("]"));
      then txt;

    case ( txt,
           "metamodelica_string_const",
           _,
           a_index,
           a_startIndex )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("tmpMeta["));
        txt = Tpl.writeStr(txt, a_startIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("+"));
        ret_2 = intSub(a_index, 1);
        txt = Tpl.writeStr(txt, intString(ret_2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("]"));
      then txt;

    case ( txt,
           _,
           a_prefix,
           a_index,
           _ )
      equation
        l_newVarIx = Tpl.writeStr(Tpl.emptyTxt, a_prefix);
        l_newVarIx = Tpl.writeTok(l_newVarIx, Tpl.ST_STRING("_c"));
        ret_4 = intSub(a_index, 1);
        l_newVarIx = Tpl.writeStr(l_newVarIx, intString(ret_4));
        txt = Tpl.writeText(txt, l_newVarIx);
      then txt;
  end match;
end fun_736;

public function getTempDeclMatchOutputName
  input Tpl.Text txt;
  input list<DAE.Exp> a_outputs;
  input String a_prefix;
  input String a_startIndex;
  input Integer a_index;

  output Tpl.Text out_txt;
protected
  String str_3;
  Tpl.Text l_newVar;
  DAE.Exp ret_1;
  Tpl.Text l_typ;
algorithm
  ret_1 := listGet(a_outputs, a_index);
  l_typ := expTypeFromExpModelica(Tpl.emptyTxt, ret_1);
  str_3 := Tpl.textString(l_typ);
  l_newVar := fun_736(Tpl.emptyTxt, str_3, a_prefix, a_index, a_startIndex);
  out_txt := Tpl.writeText(txt, l_newVar);
end getTempDeclMatchOutputName;

protected function fun_738
  input Tpl.Text in_txt;
  input DAE.Exp in_mArg;
  input DAE.Exp in_a_exp;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_mArg, in_a_exp, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      DAE.Exp a_exp;
      SimCodeFunction.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Exp i_e;
      String i_string;
      Tpl.Text txt_0;

    case ( txt,
           DAE.ICONST(integer = _),
           a_exp,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt = daeExpSimpleLiteral(txt, a_exp);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.RCONST(real = _),
           a_exp,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt = daeExpSimpleLiteral(txt, a_exp);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.BCONST(bool = _),
           a_exp,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt = daeExpSimpleLiteral(txt, a_exp);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.ENUM_LITERAL(name = _),
           a_exp,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt = daeExpSimpleLiteral(txt, a_exp);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.SCONST(string = i_string),
           _,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_preExp, a_varDecls) = daeExpSconst(txt, i_string, a_preExp, a_varDecls);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_e as DAE.CREF(componentRef = _)),
           _,
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExpCrefRhs(txt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_e as DAE.BINARY(exp1 = _)),
           _,
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExpBinary(txt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_e as DAE.UNARY(operator = _)),
           _,
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExpUnary(txt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_e as DAE.LBINARY(exp1 = _)),
           _,
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExpLbinary(txt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_e as DAE.LUNARY(operator = _)),
           _,
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExpLunary(txt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_e as DAE.RELATION(exp1 = _)),
           _,
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExpRelation(txt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_e as DAE.IFEXP(expCond = _)),
           _,
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExpIf(txt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_e as DAE.CALL(path = _)),
           _,
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExpCall(txt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_e as DAE.RECORD(path = _)),
           _,
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExpRecord(txt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_e as DAE.PARTEVALFUNCTION(path = _)),
           _,
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExpPartEvalFunction(txt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_e as DAE.ARRAY(ty = _)),
           _,
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExpArray(txt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_e as DAE.MATRIX(ty = _)),
           _,
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExpMatrix(txt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_e as DAE.RANGE(ty = _)),
           _,
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExpRange(txt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_e as DAE.CAST(ty = _)),
           _,
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExpCast(txt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_e as DAE.ASUB(exp = _)),
           _,
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExpAsub(txt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_e as DAE.TSUB(exp = _)),
           _,
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExpTsub(txt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_e as DAE.RSUB(exp = _)),
           _,
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExpRsub(txt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_e as DAE.SIZE(exp = _)),
           _,
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExpSize(txt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_e as DAE.REDUCTION(reductionInfo = _)),
           _,
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExpReduction(txt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_e as DAE.TUPLE(PR = _)),
           _,
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExpTuple(txt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_e as DAE.LIST(valList = _)),
           _,
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExpList(txt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_e as DAE.CONS(car = _)),
           _,
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExpCons(txt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_e as DAE.META_TUPLE(listExp = _)),
           _,
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExpMetaTuple(txt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_e as DAE.META_OPTION(exp = _)),
           _,
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExpMetaOption(txt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_e as DAE.METARECORDCALL(path = _)),
           _,
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExpMetarecordcall(txt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_e as DAE.MATCHEXPRESSION(matchType = _)),
           _,
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExpMatch(txt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_e as DAE.BOX(exp = _)),
           _,
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExpBox(txt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_e as DAE.UNBOX(exp = _)),
           _,
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExpUnbox(txt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_e as DAE.SHARED_LITERAL(index = _)),
           _,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt = daeExpSharedLiteral(txt, i_e);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_e as DAE.CLKCONST(clk = _)),
           _,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#error \""));
        txt = ExpressionDumpTpl.dumpExp(txt, i_e, "\"");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           a_exp,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt_0 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("Unknown expression: "));
        txt_0 = ExpressionDumpTpl.dumpExp(txt_0, a_exp, "\"");
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 4909, 14), Tpl.textString(txt_0));
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end fun_738;

public function daeExp
  input Tpl.Text txt;
  input DAE.Exp a_exp;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_preExp;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
protected
  DAE.Exp ret_0;
algorithm
  ret_0 := SimCodeUtil.codegenExpSanityCheck(a_exp, a_context);
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) := fun_738(txt, ret_0, a_exp, a_context, a_preExp, a_varDecls, a_auxFunction);
end daeExp;

protected function fun_740
  input Tpl.Text in_txt;
  input String in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           "omsic" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("omsi_int"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_integer"));
      then txt;
  end match;
end fun_740;

public function daeExpSimpleLiteral
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_exp)
    local
      Tpl.Text txt;
      DAE.Exp i_exp;
      Integer i_index;
      Boolean i_bool;
      Real i_real;
      Integer i_integer;
      Tpl.Text txt_2;
      String ret_1;
      Tpl.Text l_int__type;

    case ( txt,
           DAE.ICONST(integer = i_integer) )
      equation
        ret_1 = Config.simCodeTarget();
        l_int__type = fun_740(Tpl.emptyTxt, ret_1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(("));
        txt = Tpl.writeText(txt, l_int__type);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") "));
        txt = Tpl.writeStr(txt, intString(i_integer));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.RCONST(real = i_real) )
      equation
        txt = Tpl.writeStr(txt, realString(i_real));
      then txt;

    case ( txt,
           DAE.BCONST(bool = i_bool) )
      equation
        txt = boolStrC(txt, i_bool);
      then txt;

    case ( txt,
           DAE.ENUM_LITERAL(index = i_index) )
      equation
        txt = Tpl.writeStr(txt, intString(i_index));
      then txt;

    case ( txt,
           i_exp )
      equation
        txt_2 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("Not a simple literal expression: "));
        txt_2 = ExpressionDumpTpl.dumpExp(txt_2, i_exp, "\"");
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 4926, 14), Tpl.textString(txt_2));
      then txt;
  end match;
end daeExpSimpleLiteral;

protected function fun_742
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_res1;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input DAE.Exp in_a_exp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls) :=
  match(in_txt, in_mArg, in_a_res1, in_a_preExp, in_a_varDecls, in_a_exp)
    local
      Tpl.Text txt;
      Tpl.Text a_res1;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      DAE.Exp a_exp;
      Tpl.Text txt_1;
      Tpl.Text l_tmp;

    case ( txt,
           false,
           a_res1,
           a_preExp,
           a_varDecls,
           a_exp )
      equation
        txt_1 = expTypeFromExpArrayIf(Tpl.emptyTxt, a_exp);
        (l_tmp, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(txt_1), a_varDecls);
        a_preExp = Tpl.writeText(a_preExp, l_tmp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = "));
        a_preExp = Tpl.writeText(a_preExp, a_res1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(";"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tmp);
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           _,
           a_res1,
           a_preExp,
           a_varDecls,
           _ )
      equation
        txt = Tpl.writeText(txt, a_res1);
      then (txt, a_preExp, a_varDecls);
  end match;
end fun_742;

public function daeExpAsLValue
  input Tpl.Text txt;
  input DAE.Exp a_exp;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_preExp;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
protected
  Boolean ret_1;
  Tpl.Text l_res1;
algorithm
  (l_res1, out_a_preExp, out_a_varDecls, out_a_auxFunction) := daeExp(Tpl.emptyTxt, a_exp, a_context, a_preExp, a_varDecls, a_auxFunction);
  ret_1 := Util.isCIdentifier(Tpl.textString(l_res1));
  (out_txt, out_a_preExp, out_a_varDecls) := fun_742(txt, ret_1, l_res1, out_a_preExp, out_a_varDecls, a_exp);
end daeExpAsLValue;

protected function fun_744
  input Tpl.Text in_txt;
  input DAE.Type in_mArg;
  input DAE.Exp in_a_exp;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_mArg, in_a_exp, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      DAE.Exp a_exp;
      SimCodeFunction.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      Tpl.Text l_mstr;
      DAE.Type ret_2;
      DAE.Type ret_1;
      Tpl.Text l_shortTypeStr;

    case ( txt,
           DAE.T_ARRAY(ty = _),
           a_exp,
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        ret_1 = Expression.typeof(a_exp);
        l_shortTypeStr = expTypeShort(Tpl.emptyTxt, ret_1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        ret_2 = Expression.typeof(a_exp);
        txt = extType(txt, ret_2, true, true, false);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") data_of_"));
        txt = Tpl.writeText(txt, l_shortTypeStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_array(&"));
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExp(txt, a_exp, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.T_STRING(varLst = _),
           a_exp,
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_mstr, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, a_exp, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("MMC_STRINGDATA("));
        txt = Tpl.writeText(txt, l_mstr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           a_exp,
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExp(txt, a_exp, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end fun_744;

public function daeExternalCExp
  input Tpl.Text txt;
  input DAE.Exp a_exp;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_preExp;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
protected
  DAE.Type ret_0;
algorithm
  ret_0 := Expression.typeof(a_exp);
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) := fun_744(txt, ret_0, a_exp, a_context, a_preExp, a_varDecls, a_auxFunction);
end daeExternalCExp;

protected function fun_746
  input Tpl.Text in_txt;
  input DAE.Type in_mArg;
  input DAE.Exp in_a_exp;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_mArg, in_a_exp, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      DAE.Exp a_exp;
      SimCodeFunction.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      Tpl.Text txt_6;
      Tpl.Text txt_5;
      Tpl.Text l_tvar;
      Tpl.Text l_texp;
      DAE.Type ret_2;
      DAE.Type ret_1;
      Tpl.Text l_shortTypeStr;

    case ( txt,
           DAE.T_ARRAY(ty = _),
           a_exp,
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        ret_1 = Expression.typeof(a_exp);
        l_shortTypeStr = expTypeShort(Tpl.emptyTxt, ret_1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        ret_2 = Expression.typeof(a_exp);
        txt = extType(txt, ret_2, true, true, false);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") data_of_"));
        txt = Tpl.writeText(txt, l_shortTypeStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_array(&"));
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExp(txt, a_exp, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.T_STRING(varLst = _),
           a_exp,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_texp, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, a_exp, SimCodeFunction.contextFunction, a_preExp, a_varDecls, a_auxFunction);
        txt_5 = expTypeFromExpFlag(Tpl.emptyTxt, a_exp, 8);
        (l_tvar, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(txt_5), a_varDecls);
        a_preExp = Tpl.writeText(a_preExp, l_tvar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = MMC_STRINGDATA("));
        a_preExp = Tpl.writeText(a_preExp, l_texp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("&"));
        txt = Tpl.writeText(txt, l_tvar);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           a_exp,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_texp, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, a_exp, SimCodeFunction.contextFunction, a_preExp, a_varDecls, a_auxFunction);
        txt_6 = expTypeFromExpFlag(Tpl.emptyTxt, a_exp, 8);
        (l_tvar, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(txt_6), a_varDecls);
        a_preExp = Tpl.writeText(a_preExp, l_tvar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = "));
        a_preExp = Tpl.writeText(a_preExp, l_texp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(";"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("&"));
        txt = Tpl.writeText(txt, l_tvar);
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end fun_746;

public function daeExternalF77Exp
  input Tpl.Text txt;
  input DAE.Exp a_exp;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_preExp;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
protected
  DAE.Type ret_0;
algorithm
  ret_0 := Expression.typeof(a_exp);
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) := fun_746(txt, ret_0, a_exp, a_context, a_preExp, a_varDecls, a_auxFunction);
end daeExternalF77Exp;

protected function fun_748
  input Tpl.Text in_txt;
  input Integer in_mArg;
  input Tpl.Text in_a_escstr;
  input Tpl.Text in_a_varDecls;
  input String in_a_string;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_varDecls) :=
  match(in_txt, in_mArg, in_a_escstr, in_a_varDecls, in_a_string)
    local
      Tpl.Text txt;
      Tpl.Text a_escstr;
      Tpl.Text a_varDecls;
      String a_string;
      Integer ret_3;
      Integer ret_2;
      Tpl.Text l_tmp;
      Integer ret_0;

    case ( txt,
           0,
           _,
           a_varDecls,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(modelica_string) mmc_emptystring"));
      then (txt, a_varDecls);

    case ( txt,
           1,
           _,
           a_varDecls,
           a_string )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(modelica_string) mmc_strings_len1["));
        ret_0 = stringGet(a_string, 1);
        txt = Tpl.writeStr(txt, intString(ret_0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("]"));
      then (txt, a_varDecls);

    case ( txt,
           _,
           a_escstr,
           a_varDecls,
           _ )
      equation
        l_tmp = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("tmp"));
        ret_2 = System.tmpTick();
        l_tmp = Tpl.writeStr(l_tmp, intString(ret_2));
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING("static const MMC_DEFSTRINGLIT("));
        a_varDecls = Tpl.writeText(a_varDecls, l_tmp);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(","));
        ret_3 = System.unescapedStringLength(Tpl.textString(a_escstr));
        a_varDecls = Tpl.writeStr(a_varDecls, intString(ret_3));
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(",\""));
        a_varDecls = Tpl.writeText(a_varDecls, a_escstr);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING("\");"));
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_NEW_LINE());
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("MMC_REFSTRINGLIT("));
        txt = Tpl.writeText(txt, l_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_varDecls);
  end match;
end fun_748;

public function daeExpSconst
  input Tpl.Text txt;
  input String a_string;
  input Tpl.Text a_preExp;
  input Tpl.Text a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
protected
  Integer ret_2;
  String ret_1;
  Tpl.Text l_escstr;
algorithm
  ret_1 := Util.escapeModelicaStringToCString(a_string);
  l_escstr := Tpl.writeStr(Tpl.emptyTxt, ret_1);
  ret_2 := stringLength(a_string);
  (out_txt, out_a_varDecls) := fun_748(txt, ret_2, l_escstr, a_varDecls, a_string);
  out_a_preExp := a_preExp;
end daeExpSconst;

public function daeExpList
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_exp, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      list<DAE.Exp> i_valList;
      Tpl.Text l_expPart;
      Tpl.Text l_tmp;

    case ( txt,
           DAE.LIST(valList = i_valList),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_tmp, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_metatype", a_varDecls);
        (l_expPart, a_preExp, a_varDecls, a_auxFunction) = daeExpListToCons(Tpl.emptyTxt, i_valList, a_context, a_preExp, a_varDecls, a_auxFunction);
        a_preExp = Tpl.writeText(a_preExp, l_tmp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = "));
        a_preExp = Tpl.writeText(a_preExp, l_expPart);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(";"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tmp);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end daeExpList;

public function daeExpListToCons
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_a_listItems;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_listItems, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      list<DAE.Exp> i_rest;
      DAE.Exp i_e;
      Tpl.Text l_restList;
      Tpl.Text l_expPart;

    case ( txt,
           i_e :: i_rest,
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_expPart, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_restList, a_preExp, a_varDecls, a_auxFunction) = daeExpListToCons(Tpl.emptyTxt, i_rest, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("mmc_mk_cons("));
        txt = Tpl.writeText(txt, l_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, l_restList);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("MMC_REFSTRUCTLIT(mmc_nil)"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end daeExpListToCons;

public function daeExpCons
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_exp, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Exp i_cdr;
      DAE.Exp i_car;
      Tpl.Text l_cdrExp;
      Tpl.Text l_carExp;
      Tpl.Text l_tmp;

    case ( txt,
           DAE.CONS(car = i_car, cdr = i_cdr),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_tmp, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_metatype", a_varDecls);
        (l_carExp, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_car, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_cdrExp, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_cdr, a_context, a_preExp, a_varDecls, a_auxFunction);
        a_preExp = Tpl.writeText(a_preExp, l_tmp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = mmc_mk_cons("));
        a_preExp = Tpl.writeText(a_preExp, l_carExp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, l_cdrExp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tmp);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end daeExpCons;

protected function lm_753
  input Tpl.Text in_txt;
  input list<DAE.Type> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<DAE.Type> rest;
      Integer x_i1;
      DAE.Type i_ty;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_ty :: rest )
      equation
        x_i1 = Tpl.getIteri_i0(txt);
        txt = expTypeModelica(txt, i_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" c"));
        txt = Tpl.writeStr(txt, intString(x_i1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.nextIter(txt);
        txt = lm_753(txt, rest);
      then txt;
  end match;
end lm_753;

public function tempDeclTuple
  input Tpl.Text in_txt;
  input DAE.Type in_a_inType;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_varDecls) :=
  match(in_txt, in_a_inType, in_a_varDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_varDecls;
      DAE.Type i_inType;
      list<DAE.Type> i_types;
      Tpl.Text txt_2;
      Integer ret_1;
      Tpl.Text l_tmpVar;

    case ( txt,
           DAE.T_TUPLE(types = i_types),
           a_varDecls )
      equation
        l_tmpVar = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("tmp"));
        ret_1 = System.tmpTick();
        l_tmpVar = Tpl.writeStr(l_tmpVar, intString(ret_1));
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_LINE("struct {\n"));
        a_varDecls = Tpl.pushBlock(a_varDecls, Tpl.BT_INDENT(2));
        a_varDecls = Tpl.pushIter(a_varDecls, Tpl.ITER_OPTIONS(1, NONE(), NONE(), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        a_varDecls = lm_753(a_varDecls, i_types);
        a_varDecls = Tpl.popIter(a_varDecls);
        a_varDecls = Tpl.softNewLine(a_varDecls);
        a_varDecls = Tpl.popBlock(a_varDecls);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING("} "));
        a_varDecls = Tpl.writeText(a_varDecls, l_tmpVar);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(";"));
        txt = Tpl.writeText(txt, l_tmpVar);
      then (txt, a_varDecls);

    case ( txt,
           i_inType,
           a_varDecls )
      equation
        txt_2 = expTypeArrayIf(Tpl.emptyTxt, i_inType);
        (txt, a_varDecls) = tempDecl(txt, Tpl.textString(txt_2), a_varDecls);
      then (txt, a_varDecls);
  end match;
end tempDeclTuple;

protected function lm_755
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_tmpVar;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context, in_a_tmpVar)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      Tpl.Text a_tmpVar;
      Integer x_i1;
      DAE.Exp i_e;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           i_e :: rest,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context,
           a_tmpVar )
      equation
        x_i1 = Tpl.getIteri_i0(txt);
        txt = Tpl.writeText(txt, a_tmpVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".c"));
        txt = Tpl.writeStr(txt, intString(x_i1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExp(txt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_755(txt, rest, a_auxFunction, a_varDecls, a_preExp, a_context, a_tmpVar);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end lm_755;

public function daeExpTuple
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_exp, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      list<DAE.Exp> i_PR;
      DAE.Exp i_exp;
      Tpl.Text l_tmp;
      DAE.Type ret_1;
      Tpl.Text l_tmpVar;

    case ( txt,
           (i_exp as DAE.TUPLE(PR = i_PR)),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        ret_1 = Expression.typeof(i_exp);
        (l_tmpVar, a_varDecls) = tempDeclTuple(Tpl.emptyTxt, ret_1, a_varDecls);
        l_tmp = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(1, NONE(), NONE(), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_tmp, a_auxFunction, a_varDecls, a_preExp) = lm_755(l_tmp, i_PR, a_auxFunction, a_varDecls, a_preExp, a_context, l_tmpVar);
        l_tmp = Tpl.popIter(l_tmp);
        a_preExp = Tpl.writeText(a_preExp, l_tmp);
        txt = Tpl.writeText(txt, l_tmpVar);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end daeExpTuple;

protected function lm_757
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Exp i_e;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           i_e :: rest,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExp(txt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_757(txt, rest, a_auxFunction, a_varDecls, a_preExp, a_context);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end lm_757;

protected function fun_758
  input Tpl.Text in_txt;
  input Tpl.Text in_a_args;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_args)
    local
      Tpl.Text txt;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}) )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
      then txt;
  end match;
end fun_758;

public function daeExpMetaTuple
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_exp, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      list<DAE.Exp> i_listExp;
      Tpl.Text l_tmp;
      Tpl.Text l_args;
      Integer ret_1;
      Tpl.Text l_start;

    case ( txt,
           DAE.META_TUPLE(listExp = i_listExp),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        ret_1 = listLength(i_listExp);
        l_start = daeExpMetaHelperBoxStart(Tpl.emptyTxt, ret_1);
        l_args = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_args, a_auxFunction, a_varDecls, a_preExp) = lm_757(l_args, i_listExp, a_auxFunction, a_varDecls, a_preExp, a_context);
        l_args = Tpl.popIter(l_args);
        (l_tmp, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_metatype", a_varDecls);
        a_preExp = Tpl.writeText(a_preExp, l_tmp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = mmc_mk_box"));
        a_preExp = Tpl.writeText(a_preExp, l_start);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("0"));
        a_preExp = fun_758(a_preExp, l_args);
        a_preExp = Tpl.writeText(a_preExp, l_args);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tmp);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end daeExpMetaTuple;

public function daeExpMetaOption
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_exp, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Exp i_e;
      Tpl.Text l_expPart;

    case ( txt,
           DAE.META_OPTION(exp = NONE()),
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("mmc_mk_none()"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.META_OPTION(exp = SOME(i_e)),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_expPart, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("mmc_mk_some("));
        txt = Tpl.writeText(txt, l_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end daeExpMetaOption;

protected function lm_761
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Exp i_exp;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           i_exp :: rest,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExp(txt, i_exp, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_761(txt, rest, a_auxFunction, a_varDecls, a_preExp, a_context);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end lm_761;

protected function fun_762
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_a_args;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_a_args, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      list<DAE.Exp> i_args;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           i_args,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_761(txt, i_args, a_auxFunction, a_varDecls, a_preExp, a_context);
        txt = Tpl.popIter(txt);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end fun_762;

public function daeExpMetarecordcall
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_exp, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      Absyn.Path i_path;
      list<DAE.Exp> i_args;
      Integer i_index;
      Tpl.Text l_tmp;
      Integer ret_5;
      Integer ret_4;
      Tpl.Text l_box;
      Tpl.Text l_argsStr;
      Integer ret_1;
      Tpl.Text l_newIndex;

    case ( txt,
           DAE.METARECORDCALL(index = i_index, args = i_args, path = i_path),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        ret_1 = Patternm.getValueCtor(i_index);
        l_newIndex = Tpl.writeStr(Tpl.emptyTxt, intString(ret_1));
        (l_argsStr, a_auxFunction, a_varDecls, a_preExp) = fun_762(Tpl.emptyTxt, i_args, a_auxFunction, a_varDecls, a_preExp, a_context);
        l_box = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("mmc_mk_box"));
        ret_4 = listLength(i_args);
        ret_5 = SimCodeFunctionUtil.incrementInt(ret_4, 1);
        l_box = daeExpMetaHelperBoxStart(l_box, ret_5);
        l_box = Tpl.writeText(l_box, l_newIndex);
        l_box = Tpl.writeTok(l_box, Tpl.ST_STRING(", &"));
        l_box = CodegenUtil.underscorePath(l_box, i_path);
        l_box = Tpl.writeTok(l_box, Tpl.ST_STRING("__desc"));
        l_box = Tpl.writeText(l_box, l_argsStr);
        l_box = Tpl.writeTok(l_box, Tpl.ST_STRING(")"));
        (l_tmp, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_metatype", a_varDecls);
        a_preExp = Tpl.writeText(a_preExp, l_tmp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = "));
        a_preExp = Tpl.writeText(a_preExp, l_box);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(";"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tmp);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end daeExpMetarecordcall;

protected function fun_764
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_numVariables;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_numVariables)
    local
      Tpl.Text txt;
      Integer a_numVariables;

    case ( txt,
           false,
           a_numVariables )
      equation
        txt = Tpl.writeStr(txt, intString(a_numVariables));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
      then txt;

    case ( txt,
           _,
           a_numVariables )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeStr(txt, intString(a_numVariables));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
      then txt;
  end match;
end fun_764;

public function daeExpMetaHelperBoxStart
  input Tpl.Text txt;
  input Integer a_numVariables;

  output Tpl.Text out_txt;
protected
  Boolean ret_0;
algorithm
  ret_0 := intGt(a_numVariables, 20);
  out_txt := fun_764(txt, ret_0, a_numVariables);
end daeExpMetaHelperBoxStart;

public function crefToMStr
  input Tpl.Text in_txt;
  input DAE.ComponentRef in_a_cr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_cr)
    local
      Tpl.Text txt;
      DAE.ComponentRef i_componentRef;
      list<DAE.Subscript> i_subscriptLst;
      DAE.Ident i_ident;
      String ret_1;
      String ret_0;

    case ( txt,
           DAE.CREF_IDENT(ident = i_ident, subscriptLst = i_subscriptLst) )
      equation
        ret_0 = System.unquoteIdentifier(i_ident);
        txt = Tpl.writeStr(txt, ret_0);
        txt = subscriptsToMStr(txt, i_subscriptLst);
      then txt;

    case ( txt,
           DAE.CREF_QUAL(ident = i_ident, subscriptLst = i_subscriptLst, componentRef = i_componentRef) )
      equation
        ret_1 = System.unquoteIdentifier(i_ident);
        txt = Tpl.writeStr(txt, ret_1);
        txt = subscriptsToMStr(txt, i_subscriptLst);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("P"));
        txt = crefToMStr(txt, i_componentRef);
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("CREF_NOT_IDENT_OR_QUAL"));
      then txt;
  end match;
end crefToMStr;

protected function lm_767
  input Tpl.Text in_txt;
  input list<DAE.Subscript> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<DAE.Subscript> rest;
      DAE.Subscript i_s;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_s :: rest )
      equation
        txt = subscriptToMStr(txt, i_s);
        txt = Tpl.nextIter(txt);
        txt = lm_767(txt, rest);
      then txt;
  end match;
end lm_767;

public function subscriptsToMStr
  input Tpl.Text in_txt;
  input list<DAE.Subscript> in_a_subscripts;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_subscripts)
    local
      Tpl.Text txt;
      list<DAE.Subscript> i_subscripts;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_subscripts )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("lB"));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING("c")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_767(txt, i_subscripts);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("rB"));
      then txt;
  end match;
end subscriptsToMStr;

protected function fun_769
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_exp)
    local
      Tpl.Text txt;
      DAE.Exp i_exp;
      Integer i_i;
      Tpl.Text l_auxFunction;
      Tpl.Text l_preExp;
      Tpl.Text l_varDecls;

    case ( txt,
           DAE.ICONST(integer = i_i) )
      equation
        txt = Tpl.writeStr(txt, intString(i_i));
      then txt;

    case ( txt,
           DAE.ENUM_LITERAL(index = i_i) )
      equation
        txt = Tpl.writeStr(txt, intString(i_i));
      then txt;

    case ( txt,
           i_exp )
      equation
        l_varDecls = Tpl.emptyTxt;
        l_preExp = Tpl.emptyTxt;
        l_auxFunction = Tpl.emptyTxt;
        (txt, l_preExp, l_varDecls, l_auxFunction) = daeExp(txt, i_exp, SimCodeFunction.contextOther, l_preExp, l_varDecls, l_auxFunction);
      then txt;
  end match;
end fun_769;

public function subscriptToMStr
  input Tpl.Text in_txt;
  input DAE.Subscript in_a_subscript;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_subscript)
    local
      Tpl.Text txt;
      DAE.Exp i_exp;
      Integer i_i;
      Tpl.Text txt_0;

    case ( txt,
           DAE.SLICE(exp = DAE.ICONST(integer = i_i)) )
      equation
        txt = Tpl.writeStr(txt, intString(i_i));
      then txt;

    case ( txt,
           DAE.SLICE(exp = i_exp) )
      equation
        txt_0 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("Unknown slice "));
        txt_0 = ExpressionDumpTpl.dumpExp(txt_0, i_exp, "\"");
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 5125, 29), Tpl.textString(txt_0));
      then txt;

    case ( txt,
           DAE.WHOLEDIM() )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("WHOLEDIM"));
      then txt;

    case ( txt,
           DAE.WHOLE_NONEXP() )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("WHOLE_NONEXP"));
      then txt;

    case ( txt,
           DAE.INDEX(exp = i_exp) )
      equation
        txt = fun_769(txt, i_exp);
      then txt;

    case ( txt,
           _ )
      equation
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 5138, 14), "UNKNOWN_SUBSCRIPT");
      then txt;
  end match;
end subscriptToMStr;

protected function fun_771
  input Tpl.Text in_txt;
  input Integer in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;
      Integer i_i;

    case ( txt,
           -1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("MMC_THROW_INTERNAL()"));
      then txt;

    case ( txt,
           i_i )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("goto goto_"));
        txt = Tpl.writeStr(txt, intString(i_i));
      then txt;
  end match;
end fun_771;

public function generateThrow
  input Tpl.Text txt;

  output Tpl.Text out_txt;
protected
  Integer ret_0;
algorithm
  ret_0 := SimCodeFunctionUtil.codegenPeekTryThrowIndex();
  out_txt := fun_771(txt, ret_0);
end generateThrow;

protected function fun_773
  input Tpl.Text in_txt;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input DAE.Exp in_a_exp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_a_context, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_exp)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      DAE.Exp a_exp;
      SimCodeFunction.Context i_context;

    case ( txt,
           (i_context as SimCodeFunction.FUNCTION_CONTEXT(cref_prefix = _)),
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_exp )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExpCrefRhsFunContext(txt, a_exp, i_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           i_context,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_exp )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExpCrefRhsSimContext(txt, a_exp, i_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end fun_773;

public function daeExpCrefRhs
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_exp, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Exp i_exp;
      DAE.Ident i_cr_ident;
      DAE.Type i_ty;
      DAE.Ident i_cri_ident;
      DAE.ComponentRef i_cr;
      Integer ret_6;
      Integer ret_5;
      list<DAE.Var> ret_4;
      Integer ret_3;
      Integer ret_2;
      list<DAE.Var> ret_1;
      Tpl.Text l_offset;

    case ( txt,
           DAE.CREF(componentRef = i_cr, ty = DAE.T_FUNCTION_REFERENCE_FUNC(builtin = _)),
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("boxvar_"));
        txt = crefFunctionName(txt, i_cr);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CREF(componentRef = i_cr, ty = DAE.T_FUNCTION_REFERENCE_VAR(functionType = _)),
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("((modelica_fnptr) _"));
        txt = CodegenUtil.crefStr(txt, i_cr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CREF(componentRef = DAE.CREF_QUAL(subscriptLst = {}, identType = DAE.T_METATYPE(ty = (i_ty as DAE.T_METAUNIONTYPE(paths = _))), componentRef = DAE.CREF_IDENT(ident = i_cri_ident), ident = i_cr_ident)),
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        ret_1 = Types.getMetaRecordFields(i_ty);
        ret_2 = Types.findVarIndex(i_cri_ident, ret_1);
        ret_3 = intAdd(ret_2, 2);
        l_offset = Tpl.writeStr(Tpl.emptyTxt, intString(ret_3));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(MMC_FETCH(MMC_OFFSET(MMC_UNTAGPTR(_"));
        txt = Tpl.writeStr(txt, i_cr_ident);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("), "));
        txt = Tpl.writeText(txt, l_offset);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")))"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CREF(componentRef = DAE.CREF_QUAL(subscriptLst = {}, identType = DAE.T_METATYPE(ty = (i_ty as DAE.T_METARECORD(path = _))), componentRef = DAE.CREF_IDENT(ident = i_cri_ident), ident = i_cr_ident)),
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        ret_4 = Types.getMetaRecordFields(i_ty);
        ret_5 = Types.findVarIndex(i_cri_ident, ret_4);
        ret_6 = intAdd(ret_5, 2);
        l_offset = Tpl.writeStr(Tpl.emptyTxt, intString(ret_6));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(MMC_FETCH(MMC_OFFSET(MMC_UNTAGPTR(_"));
        txt = Tpl.writeStr(txt, i_cr_ident);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("), "));
        txt = Tpl.writeText(txt, l_offset);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")))"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           i_exp,
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_auxFunction, a_varDecls, a_preExp) = fun_773(txt, a_context, a_auxFunction, a_varDecls, a_preExp, i_exp);
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end daeExpCrefRhs;

protected function lm_775
  input Tpl.Text in_txt;
  input list<DAE.Var> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;
  input DAE.ComponentRef in_a_cr;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context, in_a_cr)
    local
      Tpl.Text txt;
      list<DAE.Var> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.ComponentRef a_cr;
      DAE.Var i_v;
      DAE.Exp ret_0;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           i_v :: rest,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context,
           a_cr )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        ret_0 = SimCodeFunctionUtil.makeCrefRecordExp(a_cr, i_v);
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExp(txt, ret_0, a_context, a_preExp, a_varDecls, a_auxFunction);
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_775(txt, rest, a_auxFunction, a_varDecls, a_preExp, a_context, a_cr);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end lm_775;

protected function lm_776
  input Tpl.Text in_txt;
  input list<DAE.Dimension> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Dimension> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Dimension i_dim;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           i_dim :: rest,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(_index_t)"));
        (txt, a_preExp, a_varDecls, a_auxFunction) = dimension(txt, i_dim, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_776(txt, rest, a_auxFunction, a_varDecls, a_preExp, a_context);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end lm_776;

protected function lm_777
  input Tpl.Text in_txt;
  input DAE.Dimensions in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      DAE.Dimensions rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Dimension i_dim;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           i_dim :: rest,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(_index_t)"));
        (txt, a_preExp, a_varDecls, a_auxFunction) = dimension(txt, i_dim, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_777(txt, rest, a_auxFunction, a_varDecls, a_preExp, a_context);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end lm_777;

protected function fun_778
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input DAE.Dimensions in_a_dims;
  input Tpl.Text in_a_arrayType;
  input Tpl.Text in_a_wrapperArray;
  input Tpl.Text in_a_type;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;
  input DAE.ComponentRef in_a_cr;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_mArg, in_a_dims, in_a_arrayType, in_a_wrapperArray, in_a_type, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context, in_a_cr)
    local
      Tpl.Text txt;
      DAE.Dimensions a_dims;
      Tpl.Text a_arrayType;
      Tpl.Text a_wrapperArray;
      Tpl.Text a_type;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.ComponentRef a_cr;
      list<DAE.Subscript> ret_16;
      DAE.ComponentRef ret_15;
      list<DAE.Dimension> ret_14;
      Tpl.Text l_t;
      DAE.ComponentRef ret_12;
      Tpl.Text l_nosubname;
      Integer ret_10;
      list<DAE.Subscript> ret_9;
      Tpl.Text l_spec1;
      Tpl.Text l_slicedArray;
      DAE.ComponentRef ret_6;
      Tpl.Text l_arrName;
      list<DAE.Dimension> ret_4;
      Tpl.Text l_dimsValuesStr;
      Integer ret_2;
      list<DAE.Dimension> ret_1;
      Tpl.Text l_dimsLenStr;

    case ( txt,
           false,
           _,
           a_arrayType,
           a_wrapperArray,
           a_type,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context,
           a_cr )
      equation
        ret_1 = ComponentReference.crefDims(a_cr);
        ret_2 = listLength(ret_1);
        l_dimsLenStr = Tpl.writeStr(Tpl.emptyTxt, intString(ret_2));
        ret_4 = ComponentReference.crefDims(a_cr);
        l_dimsValuesStr = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_dimsValuesStr, a_auxFunction, a_varDecls, a_preExp) = lm_776(l_dimsValuesStr, ret_4, a_auxFunction, a_varDecls, a_preExp, a_context);
        l_dimsValuesStr = Tpl.popIter(l_dimsValuesStr);
        ret_6 = ComponentReference.crefStripSubs(a_cr);
        (l_arrName, a_preExp, a_varDecls, a_auxFunction) = contextCref(Tpl.emptyTxt, ret_6, a_context, a_preExp, a_varDecls, a_auxFunction);
        a_preExp = Tpl.writeText(a_preExp, a_type);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("_array_create(&"));
        a_preExp = Tpl.writeText(a_preExp, a_wrapperArray);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", (modelica_"));
        a_preExp = Tpl.writeText(a_preExp, a_type);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("*)&"));
        a_preExp = Tpl.writeText(a_preExp, l_arrName);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, l_dimsLenStr);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, l_dimsValuesStr);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        (l_slicedArray, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(a_arrayType), a_varDecls);
        ret_9 = ComponentReference.crefSubs(a_cr);
        (l_spec1, a_preExp, a_varDecls, a_auxFunction) = daeExpCrefIndexSpec(Tpl.emptyTxt, ret_9, a_context, a_preExp, a_varDecls, a_auxFunction);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("index_alloc_"));
        a_preExp = Tpl.writeText(a_preExp, a_type);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("_array(&"));
        a_preExp = Tpl.writeText(a_preExp, a_wrapperArray);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", &"));
        a_preExp = Tpl.writeText(a_preExp, l_spec1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", &"));
        a_preExp = Tpl.writeText(a_preExp, l_slicedArray);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_slicedArray);
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           _,
           a_dims,
           _,
           a_wrapperArray,
           a_type,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context,
           a_cr )
      equation
        ret_10 = listLength(a_dims);
        l_dimsLenStr = Tpl.writeStr(Tpl.emptyTxt, intString(ret_10));
        l_dimsValuesStr = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_dimsValuesStr, a_auxFunction, a_varDecls, a_preExp) = lm_777(l_dimsValuesStr, a_dims, a_auxFunction, a_varDecls, a_preExp, a_context);
        l_dimsValuesStr = Tpl.popIter(l_dimsValuesStr);
        ret_12 = ComponentReference.crefStripSubs(a_cr);
        (l_nosubname, a_preExp, a_varDecls, a_auxFunction) = contextCref(Tpl.emptyTxt, ret_12, a_context, a_preExp, a_varDecls, a_auxFunction);
        l_t = Tpl.writeText(Tpl.emptyTxt, a_type);
        l_t = Tpl.writeTok(l_t, Tpl.ST_STRING("_array_create(&"));
        l_t = Tpl.writeText(l_t, a_wrapperArray);
        l_t = Tpl.writeTok(l_t, Tpl.ST_STRING(", ((modelica_"));
        l_t = Tpl.writeText(l_t, a_type);
        l_t = Tpl.writeTok(l_t, Tpl.ST_STRING("*)&((&"));
        l_t = Tpl.writeText(l_t, l_nosubname);
        l_t = Tpl.writeTok(l_t, Tpl.ST_STRING(")"));
        ret_14 = ComponentReference.crefDims(a_cr);
        ret_15 = ComponentReference.crefArrayGetFirstCref(a_cr);
        ret_16 = ComponentReference.crefSubs(ret_15);
        (l_t, a_preExp, a_varDecls, a_auxFunction) = indexSubs(l_t, ret_14, ret_16, a_context, a_preExp, a_varDecls, a_auxFunction);
        l_t = Tpl.writeTok(l_t, Tpl.ST_STRING(")), "));
        l_t = Tpl.writeText(l_t, l_dimsLenStr);
        l_t = Tpl.writeTok(l_t, Tpl.ST_STRING(", "));
        l_t = Tpl.writeText(l_t, l_dimsValuesStr);
        l_t = Tpl.writeTok(l_t, Tpl.ST_STRING(");"));
        l_t = Tpl.writeTok(l_t, Tpl.ST_NEW_LINE());
        a_preExp = Tpl.writeText(a_preExp, l_t);
        txt = Tpl.writeText(txt, a_wrapperArray);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end fun_778;

protected function fun_779
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;
  input DAE.ComponentRef in_a_cr;
  input DAE.Exp in_a_ecr;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_mArg, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context, in_a_cr, in_a_ecr)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.ComponentRef a_cr;
      DAE.Exp a_ecr;
      list<DAE.Subscript> ret_5;
      DAE.ComponentRef ret_4;
      list<DAE.Dimension> ret_3;
      DAE.ComponentRef ret_2;
      Tpl.Text l_nosubname;
      Tpl.Text txt_0;

    case ( txt,
           false,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _,
           _,
           a_ecr )
      equation
        txt_0 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("daeExpCrefRhsSimContext: UNHANDLED CREF: "));
        txt_0 = ExpressionDumpTpl.dumpExp(txt_0, a_ecr, "\"");
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 5211, 13), Tpl.textString(txt_0));
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           _,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context,
           a_cr,
           _ )
      equation
        ret_2 = ComponentReference.crefStripSubs(a_cr);
        (l_nosubname, a_preExp, a_varDecls, a_auxFunction) = contextCref(Tpl.emptyTxt, ret_2, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(&"));
        txt = Tpl.writeText(txt, l_nosubname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
        ret_3 = ComponentReference.crefDims(a_cr);
        ret_4 = ComponentReference.crefArrayGetFirstCref(a_cr);
        ret_5 = ComponentReference.crefSubs(ret_4);
        (txt, a_preExp, a_varDecls, a_auxFunction) = indexSubs(txt, ret_3, ret_5, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end fun_779;

protected function fun_780
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;
  input DAE.Exp in_a_ecr;
  input DAE.ComponentRef in_a_cr;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_mArg, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context, in_a_ecr, in_a_cr)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Exp a_ecr;
      DAE.ComponentRef a_cr;
      Boolean ret_0;

    case ( txt,
           false,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context,
           a_ecr,
           a_cr )
      equation
        ret_0 = ComponentReference.crefIsScalarWithVariableSubs(a_cr);
        (txt, a_auxFunction, a_varDecls, a_preExp) = fun_779(txt, ret_0, a_auxFunction, a_varDecls, a_preExp, a_context, a_cr, a_ecr);
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           _,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context,
           _,
           a_cr )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = contextCref(txt, a_cr, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end fun_780;

public function daeExpCrefRhsSimContext
  input Tpl.Text in_txt;
  input DAE.Exp in_a_ecr;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_ecr, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Exp i_ecr;
      DAE.Dimensions i_dims;
      DAE.Type i_aty;
      ClassInf.State i_record__state;
      list<DAE.Var> i_var__lst;
      DAE.ComponentRef i_cr;
      Boolean ret_7;
      Boolean ret_6;
      Tpl.Text l_wrapperArray;
      Tpl.Text l_arrayType;
      Tpl.Text l_type;
      Absyn.Path ret_2;
      Tpl.Text l_record__type__name;
      Tpl.Text l_vars;

    case ( txt,
           DAE.CREF(componentRef = i_cr, ty = DAE.T_COMPLEX(complexClassType = ClassInf.EXTERNAL_OBJ(path = _))),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = contextCref(txt, i_cr, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CREF(componentRef = i_cr, ty = DAE.T_COMPLEX(complexClassType = i_record__state, varLst = i_var__lst)),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_vars, a_auxFunction, a_varDecls, a_preExp) = lm_775(Tpl.emptyTxt, i_var__lst, a_auxFunction, a_varDecls, a_preExp, a_context, i_cr);
        ret_2 = ClassInf.getStateName(i_record__state);
        l_record__type__name = CodegenUtil.underscorePath(Tpl.emptyTxt, ret_2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("omc_"));
        txt = Tpl.writeText(txt, l_record__type__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(threadData"));
        txt = Tpl.writeText(txt, l_vars);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CREF(componentRef = i_cr, ty = DAE.T_ARRAY(ty = i_aty, dims = i_dims)),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        l_type = expTypeShort(Tpl.emptyTxt, i_aty);
        l_arrayType = Tpl.writeText(Tpl.emptyTxt, l_type);
        l_arrayType = Tpl.writeTok(l_arrayType, Tpl.ST_STRING("_array"));
        (l_wrapperArray, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(l_arrayType), a_varDecls);
        ret_6 = SimCodeFunctionUtil.crefSubIsScalar(i_cr);
        (txt, a_auxFunction, a_varDecls, a_preExp) = fun_778(txt, ret_6, i_dims, l_arrayType, l_wrapperArray, l_type, a_auxFunction, a_varDecls, a_preExp, a_context, i_cr);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_ecr as DAE.CREF(componentRef = i_cr, ty = _)),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        ret_7 = ComponentReference.crefIsScalarWithAllConstSubs(i_cr);
        (txt, a_auxFunction, a_varDecls, a_preExp) = fun_780(txt, ret_7, a_auxFunction, a_varDecls, a_preExp, a_context, i_ecr, i_cr);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end daeExpCrefRhsSimContext;

protected function fun_782
  input Tpl.Text in_txt;
  input SimCodeFunction.Context in_a_context;
  input DAE.Exp in_a_ecr;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input DAE.Type in_a_ty;
  input DAE.ComponentRef in_a_cr;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_preExp, out_a_varDecls) :=
  match(in_txt, in_a_context, in_a_ecr, in_a_auxFunction, in_a_preExp, in_a_varDecls, in_a_ty, in_a_cr)
    local
      Tpl.Text txt;
      DAE.Exp a_ecr;
      Tpl.Text a_auxFunction;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      DAE.Type a_ty;
      DAE.ComponentRef a_cr;
      SimCodeFunction.Context i_context;
      Tpl.Text txt_5;
      list<DAE.Subscript> ret_4;
      Tpl.Text l_spec1;
      Tpl.Text l_tmp;
      Tpl.Text l_arrayType;
      Tpl.Text l_arrName;

    case ( txt,
           (i_context as SimCodeFunction.FUNCTION_CONTEXT(cref_prefix = _)),
           _,
           a_auxFunction,
           a_preExp,
           a_varDecls,
           a_ty,
           a_cr )
      equation
        l_arrName = contextArrayCref(Tpl.emptyTxt, a_cr, i_context);
        l_arrayType = expTypeArray(Tpl.emptyTxt, a_ty);
        (l_tmp, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(l_arrayType), a_varDecls);
        ret_4 = ComponentReference.crefSubs(a_cr);
        (l_spec1, a_preExp, a_varDecls, a_auxFunction) = daeExpCrefIndexSpec(Tpl.emptyTxt, ret_4, i_context, a_preExp, a_varDecls, a_auxFunction);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("index_alloc_"));
        a_preExp = Tpl.writeText(a_preExp, l_arrayType);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("(&"));
        a_preExp = Tpl.writeText(a_preExp, l_arrName);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", &"));
        a_preExp = Tpl.writeText(a_preExp, l_spec1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", &"));
        a_preExp = Tpl.writeText(a_preExp, l_tmp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tmp);
      then (txt, a_auxFunction, a_preExp, a_varDecls);

    case ( txt,
           _,
           a_ecr,
           a_auxFunction,
           a_preExp,
           a_varDecls,
           _,
           _ )
      equation
        txt_5 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("daeExpCrefRhsFunContext: Slice in simulation context: "));
        txt_5 = ExpressionDumpTpl.dumpExp(txt_5, a_ecr, "\"");
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 5267, 17), Tpl.textString(txt_5));
      then (txt, a_auxFunction, a_preExp, a_varDecls);
  end match;
end fun_782;

protected function lm_783
  input Tpl.Text in_txt;
  input list<DAE.Subscript> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Subscript> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Exp i_exp;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           DAE.INDEX(exp = i_exp) :: rest,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeSubscriptExp(txt, i_exp, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_783(txt, rest, a_auxFunction, a_varDecls, a_preExp, a_context);
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           _ :: rest,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_783(txt, rest, a_auxFunction, a_varDecls, a_preExp, a_context);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end lm_783;

protected function fun_784
  input Tpl.Text in_txt;
  input Integer in_mArg;
  input Tpl.Text in_a_subsLenStr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_subsLenStr)
    local
      Tpl.Text txt;
      Tpl.Text a_subsLenStr;

    case ( txt,
           1,
           a_subsLenStr )
      equation
        txt = Tpl.writeText(txt, a_subsLenStr);
      then txt;

    case ( txt,
           2,
           a_subsLenStr )
      equation
        txt = Tpl.writeText(txt, a_subsLenStr);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_784;

protected function fun_785
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;
  input DAE.ComponentRef in_a_cr;
  input Tpl.Text in_a_subsValuesStr;
  input Tpl.Text in_a_subsLenStr;
  input Tpl.Text in_a_arrName;
  input Tpl.Text in_a_arrayType;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty, in_a_cr, in_a_subsValuesStr, in_a_subsLenStr, in_a_arrName, in_a_arrayType)
    local
      Tpl.Text txt;
      DAE.ComponentRef a_cr;
      Tpl.Text a_subsValuesStr;
      Tpl.Text a_subsLenStr;
      Tpl.Text a_arrName;
      Tpl.Text a_arrayType;
      Integer ret_1;
      list<DAE.Subscript> ret_0;

    case ( txt,
           DAE.T_ARRAY(ty = DAE.T_COMPLEX(complexClassType = _)),
           _,
           a_subsValuesStr,
           a_subsLenStr,
           a_arrName,
           a_arrayType )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeText(txt, a_arrayType);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_get("));
        txt = Tpl.writeText(txt, a_arrName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_subsLenStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_subsValuesStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           DAE.T_COMPLEX(complexClassType = _),
           _,
           a_subsValuesStr,
           a_subsLenStr,
           a_arrName,
           a_arrayType )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeText(txt, a_arrayType);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_get("));
        txt = Tpl.writeText(txt, a_arrName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_subsLenStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_subsValuesStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           _,
           a_cr,
           a_subsValuesStr,
           a_subsLenStr,
           a_arrName,
           a_arrayType )
      equation
        txt = Tpl.writeText(txt, a_arrayType);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_get"));
        ret_0 = ComponentReference.crefSubs(a_cr);
        ret_1 = listLength(ret_0);
        txt = fun_784(txt, ret_1, a_subsLenStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_arrName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_subsLenStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_subsValuesStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;
  end match;
end fun_785;

protected function fun_786
  input Tpl.Text in_txt;
  input SimCodeFunction.Context in_a_context;
  input DAE.Exp in_a_ecr;
  input DAE.ComponentRef in_a_cr;
  input Tpl.Text in_a_subsValuesStr;
  input Tpl.Text in_a_subsLenStr;
  input Tpl.Text in_a_arrName;
  input Tpl.Text in_a_arrayType;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_context, in_a_ecr, in_a_cr, in_a_subsValuesStr, in_a_subsLenStr, in_a_arrName, in_a_arrayType, in_a_ty)
    local
      Tpl.Text txt;
      DAE.Exp a_ecr;
      DAE.ComponentRef a_cr;
      Tpl.Text a_subsValuesStr;
      Tpl.Text a_subsLenStr;
      Tpl.Text a_arrName;
      Tpl.Text a_arrayType;
      DAE.Type a_ty;
      Tpl.Text txt_0;

    case ( txt,
           SimCodeFunction.FUNCTION_CONTEXT(is_parallel = false),
           _,
           a_cr,
           a_subsValuesStr,
           a_subsLenStr,
           a_arrName,
           a_arrayType,
           a_ty )
      equation
        txt = fun_785(txt, a_ty, a_cr, a_subsValuesStr, a_subsLenStr, a_arrName, a_arrayType);
      then txt;

    case ( txt,
           SimCodeFunction.FUNCTION_CONTEXT(cref_prefix = _),
           _,
           _,
           a_subsValuesStr,
           a_subsLenStr,
           a_arrName,
           a_arrayType,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(*"));
        txt = Tpl.writeText(txt, a_arrayType);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_element_addr_c99_"));
        txt = Tpl.writeText(txt, a_subsLenStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(&"));
        txt = Tpl.writeText(txt, a_arrName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_subsLenStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_subsValuesStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("))"));
      then txt;

    case ( txt,
           _,
           a_ecr,
           _,
           _,
           _,
           _,
           _,
           _ )
      equation
        txt_0 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("This should have been handled in the new daeExpCrefRhsSimContext function. "));
        txt_0 = ExpressionDumpTpl.dumpExp(txt_0, a_ecr, "\"");
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 5254, 23), Tpl.textString(txt_0));
      then txt;
  end match;
end fun_786;

protected function fun_787
  input Tpl.Text in_txt;
  input DAE.ComponentRef in_a_cr;
  input DAE.Exp in_a_ecr;
  input Tpl.Text in_a_subsLenStr;
  input Tpl.Text in_a_arrayType;
  input DAE.Type in_a_ty;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_subsValuesStr;
  input Tpl.Text in_a_arrName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_cr, in_a_ecr, in_a_subsLenStr, in_a_arrayType, in_a_ty, in_a_context, in_a_subsValuesStr, in_a_arrName)
    local
      Tpl.Text txt;
      DAE.Exp a_ecr;
      Tpl.Text a_subsLenStr;
      Tpl.Text a_arrayType;
      DAE.Type a_ty;
      SimCodeFunction.Context a_context;
      Tpl.Text a_subsValuesStr;
      Tpl.Text a_arrName;
      DAE.ComponentRef i_cr;

    case ( txt,
           DAE.CREF_IDENT(identType = DAE.T_METATYPE(ty = DAE.T_METAARRAY(ty = _))),
           _,
           _,
           _,
           _,
           _,
           a_subsValuesStr,
           a_arrName )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("arrayGet("));
        txt = Tpl.writeText(txt, a_arrName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_subsValuesStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.CREF_IDENT(identType = DAE.T_METAARRAY(ty = _)),
           _,
           _,
           _,
           _,
           _,
           a_subsValuesStr,
           a_arrName )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("arrayGet("));
        txt = Tpl.writeText(txt, a_arrName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_subsValuesStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           i_cr,
           a_ecr,
           a_subsLenStr,
           a_arrayType,
           a_ty,
           a_context,
           a_subsValuesStr,
           a_arrName )
      equation
        txt = fun_786(txt, a_context, a_ecr, i_cr, a_subsValuesStr, a_subsLenStr, a_arrName, a_arrayType, a_ty);
      then txt;
  end match;
end fun_787;

protected function fun_788
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input DAE.Exp in_a_ecr;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input DAE.Type in_a_ty;
  input DAE.ComponentRef in_a_cr;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_preExp, out_a_varDecls) :=
  match(in_txt, in_mArg, in_a_ecr, in_a_auxFunction, in_a_preExp, in_a_varDecls, in_a_ty, in_a_cr, in_a_context)
    local
      Tpl.Text txt;
      DAE.Exp a_ecr;
      Tpl.Text a_auxFunction;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      DAE.Type a_ty;
      DAE.ComponentRef a_cr;
      SimCodeFunction.Context a_context;
      list<DAE.Subscript> ret_7;
      Tpl.Text l_subsValuesStr;
      Integer ret_5;
      list<DAE.Subscript> ret_4;
      Tpl.Text l_subsLenStr;
      Tpl.Text l_arrayType;
      DAE.ComponentRef ret_1;
      Tpl.Text l_arrName;

    case ( txt,
           false,
           a_ecr,
           a_auxFunction,
           a_preExp,
           a_varDecls,
           a_ty,
           a_cr,
           a_context )
      equation
        (txt, a_auxFunction, a_preExp, a_varDecls) = fun_782(txt, a_context, a_ecr, a_auxFunction, a_preExp, a_varDecls, a_ty, a_cr);
      then (txt, a_auxFunction, a_preExp, a_varDecls);

    case ( txt,
           _,
           a_ecr,
           a_auxFunction,
           a_preExp,
           a_varDecls,
           a_ty,
           a_cr,
           a_context )
      equation
        ret_1 = ComponentReference.crefStripLastSubs(a_cr);
        (l_arrName, a_preExp, a_varDecls, a_auxFunction) = contextCref(Tpl.emptyTxt, ret_1, a_context, a_preExp, a_varDecls, a_auxFunction);
        l_arrayType = expTypeArray(Tpl.emptyTxt, a_ty);
        ret_4 = ComponentReference.crefSubs(a_cr);
        ret_5 = listLength(ret_4);
        l_subsLenStr = Tpl.writeStr(Tpl.emptyTxt, intString(ret_5));
        ret_7 = ComponentReference.crefSubs(a_cr);
        l_subsValuesStr = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_subsValuesStr, a_auxFunction, a_varDecls, a_preExp) = lm_783(l_subsValuesStr, ret_7, a_auxFunction, a_varDecls, a_preExp, a_context);
        l_subsValuesStr = Tpl.popIter(l_subsValuesStr);
        txt = fun_787(txt, a_cr, a_ecr, l_subsLenStr, l_arrayType, a_ty, a_context, l_subsValuesStr, l_arrName);
      then (txt, a_auxFunction, a_preExp, a_varDecls);
  end match;
end fun_788;

protected function fun_789
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input DAE.Exp in_a_ecr;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input DAE.Type in_a_ty;
  input SimCodeFunction.Context in_a_context;
  input DAE.ComponentRef in_a_cr;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_preExp, out_a_varDecls) :=
  match(in_txt, in_mArg, in_a_ecr, in_a_auxFunction, in_a_preExp, in_a_varDecls, in_a_ty, in_a_context, in_a_cr)
    local
      Tpl.Text txt;
      DAE.Exp a_ecr;
      Tpl.Text a_auxFunction;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      DAE.Type a_ty;
      SimCodeFunction.Context a_context;
      DAE.ComponentRef a_cr;
      Tpl.Text l_cast;
      Boolean ret_0;

    case ( txt,
           false,
           a_ecr,
           a_auxFunction,
           a_preExp,
           a_varDecls,
           a_ty,
           a_context,
           a_cr )
      equation
        ret_0 = SimCodeFunctionUtil.crefSubIsScalar(a_cr);
        (txt, a_auxFunction, a_preExp, a_varDecls) = fun_788(txt, ret_0, a_ecr, a_auxFunction, a_preExp, a_varDecls, a_ty, a_cr, a_context);
      then (txt, a_auxFunction, a_preExp, a_varDecls);

    case ( txt,
           _,
           _,
           a_auxFunction,
           a_preExp,
           a_varDecls,
           a_ty,
           a_context,
           a_cr )
      equation
        l_cast = typeCastContextInt(Tpl.emptyTxt, a_context, a_ty);
        txt = Tpl.writeText(txt, l_cast);
        (txt, a_preExp, a_varDecls, a_auxFunction) = contextCref(txt, a_cr, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_preExp, a_varDecls);
  end match;
end fun_789;

public function daeExpCrefRhsFunContext
  input Tpl.Text in_txt;
  input DAE.Exp in_a_ecr;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_ecr, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Exp i_ecr;
      DAE.Type i_ty;
      DAE.ComponentRef i_cr;
      Tpl.Text txt_1;
      Boolean ret_0;

    case ( txt,
           (i_ecr as DAE.CREF(componentRef = i_cr, ty = i_ty)),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        ret_0 = SimCodeFunctionUtil.crefIsScalar(i_cr, a_context);
        (txt, a_auxFunction, a_preExp, a_varDecls) = fun_789(txt, ret_0, i_ecr, a_auxFunction, a_preExp, a_varDecls, i_ty, a_context, i_cr);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           i_ecr,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt_1 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("daeExpCrefRhsFunContext: UNHANDLED EXPRESSION: "));
        txt_1 = ExpressionDumpTpl.dumpExp(txt_1, i_ecr, "\"");
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 5269, 11), Tpl.textString(txt_1));
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end daeExpCrefRhsFunContext;

protected function lm_791
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Exp i_exp;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           i_exp :: rest,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeSubscriptExp(txt, i_exp, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_791(txt, rest, a_auxFunction, a_varDecls, a_preExp, a_context);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end lm_791;

protected function fun_792
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input list<DAE.Exp> in_a_subs;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_subs)
    local
      Tpl.Text txt;
      list<DAE.Exp> a_subs;
      Integer ret_0;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_subs )
      equation
        ret_0 = listLength(a_subs);
        txt = Tpl.writeStr(txt, intString(ret_0));
      then txt;
  end match;
end fun_792;

protected function fun_793
  input Tpl.Text in_txt;
  input SimCodeFunction.Context in_a_context;
  input list<DAE.Exp> in_a_subs;
  input Tpl.Text in_a_subsValuesStr;
  input String in_a_arrName;
  input Tpl.Text in_a_subsLenStr;
  input Tpl.Text in_a_arrayType;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_context, in_a_subs, in_a_subsValuesStr, in_a_arrName, in_a_subsLenStr, in_a_arrayType)
    local
      Tpl.Text txt;
      list<DAE.Exp> a_subs;
      Tpl.Text a_subsValuesStr;
      String a_arrName;
      Tpl.Text a_subsLenStr;
      Tpl.Text a_arrayType;
      Boolean ret_1;
      Integer ret_0;

    case ( txt,
           SimCodeFunction.FUNCTION_CONTEXT(is_parallel = true),
           _,
           a_subsValuesStr,
           a_arrName,
           a_subsLenStr,
           a_arrayType )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(*"));
        txt = Tpl.writeText(txt, a_arrayType);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_element_addr_c99_"));
        txt = Tpl.writeText(txt, a_subsLenStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(&"));
        txt = Tpl.writeStr(txt, a_arrName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_subsLenStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_subsValuesStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("))"));
      then txt;

    case ( txt,
           _,
           a_subs,
           a_subsValuesStr,
           a_arrName,
           a_subsLenStr,
           a_arrayType )
      equation
        txt = Tpl.writeText(txt, a_arrayType);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_get"));
        ret_0 = listLength(a_subs);
        ret_1 = intLt(ret_0, 3);
        txt = fun_792(txt, ret_1, a_subs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeStr(txt, a_arrName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_subsLenStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_subsValuesStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;
  end match;
end fun_793;

protected function fun_794
  input Tpl.Text in_txt;
  input String in_mArg;
  input list<DAE.Exp> in_a_subs;
  input Tpl.Text in_a_subsLenStr;
  input Tpl.Text in_a_arrayType;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_subsValuesStr;
  input String in_a_arrName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_subs, in_a_subsLenStr, in_a_arrayType, in_a_context, in_a_subsValuesStr, in_a_arrName)
    local
      Tpl.Text txt;
      list<DAE.Exp> a_subs;
      Tpl.Text a_subsLenStr;
      Tpl.Text a_arrayType;
      SimCodeFunction.Context a_context;
      Tpl.Text a_subsValuesStr;
      String a_arrName;

    case ( txt,
           "metatype_array",
           _,
           _,
           _,
           _,
           a_subsValuesStr,
           a_arrName )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("arrayGet("));
        txt = Tpl.writeStr(txt, a_arrName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, a_subsValuesStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") /*arrayScalarRhs*/"));
      then txt;

    case ( txt,
           _,
           a_subs,
           a_subsLenStr,
           a_arrayType,
           a_context,
           a_subsValuesStr,
           a_arrName )
      equation
        txt = fun_793(txt, a_context, a_subs, a_subsValuesStr, a_arrName, a_subsLenStr, a_arrayType);
      then txt;
  end match;
end fun_794;

public function arrayScalarRhs
  input Tpl.Text txt;
  input DAE.Type a_ty;
  input list<DAE.Exp> a_subs;
  input String a_arrName;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_preExp;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
protected
  String str_4;
  Tpl.Text l_subsValuesStr;
  Integer ret_2;
  Tpl.Text l_subsLenStr;
  Tpl.Text l_arrayType;
algorithm
  l_arrayType := expTypeArray(Tpl.emptyTxt, a_ty);
  ret_2 := listLength(a_subs);
  l_subsLenStr := Tpl.writeStr(Tpl.emptyTxt, intString(ret_2));
  l_subsValuesStr := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (l_subsValuesStr, out_a_auxFunction, out_a_varDecls, out_a_preExp) := lm_791(l_subsValuesStr, a_subs, a_auxFunction, a_varDecls, a_preExp, a_context);
  l_subsValuesStr := Tpl.popIter(l_subsValuesStr);
  str_4 := Tpl.textString(l_arrayType);
  out_txt := fun_794(txt, str_4, a_subs, l_subsLenStr, l_arrayType, a_context, l_subsValuesStr, a_arrName);
end arrayScalarRhs;

protected function fun_796
  input Tpl.Text in_txt;
  input SimCodeFunction.Context in_a_context;
  input Boolean in_a_isPre;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input DAE.Exp in_a_exp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_a_context, in_a_isPre, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_exp)
    local
      Tpl.Text txt;
      Boolean a_isPre;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      DAE.Exp a_exp;
      SimCodeFunction.Context i_context;

    case ( txt,
           (i_context as SimCodeFunction.FUNCTION_CONTEXT(cref_prefix = _)),
           _,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_exp )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExpCrefLhsFunContext(txt, a_exp, i_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           i_context,
           a_isPre,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_exp )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExpCrefLhsSimContext(txt, a_exp, i_context, a_preExp, a_varDecls, a_auxFunction, a_isPre);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end fun_796;

public function daeExpCrefLhs
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;
  input Boolean in_a_isPre;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_exp, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction, in_a_isPre)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      Boolean a_isPre;
      DAE.Exp i_exp;
      DAE.ComponentRef i_cr;

    case ( txt,
           DAE.CREF(componentRef = i_cr, ty = DAE.T_FUNCTION_REFERENCE_FUNC(builtin = _)),
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("((modelica_fnptr)boxptr_"));
        txt = crefFunctionName(txt, i_cr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CREF(componentRef = i_cr, ty = DAE.T_FUNCTION_REFERENCE_VAR(functionType = _)),
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = CodegenUtil.crefStr(txt, i_cr);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           i_exp,
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction,
           a_isPre )
      equation
        (txt, a_auxFunction, a_varDecls, a_preExp) = fun_796(txt, a_context, a_isPre, a_auxFunction, a_varDecls, a_preExp, i_exp);
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end daeExpCrefLhs;

protected function lm_798
  input Tpl.Text in_txt;
  input DAE.Dimensions in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      DAE.Dimensions rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Dimension i_dim;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           i_dim :: rest,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(_index_t)"));
        (txt, a_preExp, a_varDecls, a_auxFunction) = dimension(txt, i_dim, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_798(txt, rest, a_auxFunction, a_varDecls, a_preExp, a_context);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end lm_798;

protected function fun_799
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_wrapperArray;
  input Tpl.Text in_a_type;
  input Boolean in_a_isPre;
  input DAE.ComponentRef in_a_cr;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;
  input DAE.Dimensions in_a_dims;
  input DAE.Exp in_a_ecr;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_mArg, in_a_wrapperArray, in_a_type, in_a_isPre, in_a_cr, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context, in_a_dims, in_a_ecr)
    local
      Tpl.Text txt;
      Tpl.Text a_wrapperArray;
      Tpl.Text a_type;
      Boolean a_isPre;
      DAE.ComponentRef a_cr;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Dimensions a_dims;
      DAE.Exp a_ecr;
      list<DAE.Subscript> ret_9;
      DAE.ComponentRef ret_8;
      list<DAE.Dimension> ret_7;
      Tpl.Text l_t;
      DAE.ComponentRef ret_5;
      Tpl.Text l_nosubname;
      Tpl.Text l_dimsValuesStr;
      Integer ret_2;
      Tpl.Text l_dimsLenStr;
      Tpl.Text txt_0;

    case ( txt,
           false,
           _,
           _,
           _,
           _,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _,
           _,
           a_ecr )
      equation
        txt_0 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("daeExpCrefLhsSimContext: This should have been handled in indexed assign and should not have gotten here "));
        txt_0 = ExpressionDumpTpl.dumpExp(txt_0, a_ecr, "\"");
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 5344, 15), Tpl.textString(txt_0));
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           _,
           a_wrapperArray,
           a_type,
           a_isPre,
           a_cr,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context,
           a_dims,
           _ )
      equation
        ret_2 = listLength(a_dims);
        l_dimsLenStr = Tpl.writeStr(Tpl.emptyTxt, intString(ret_2));
        l_dimsValuesStr = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_dimsValuesStr, a_auxFunction, a_varDecls, a_preExp) = lm_798(l_dimsValuesStr, a_dims, a_auxFunction, a_varDecls, a_preExp, a_context);
        l_dimsValuesStr = Tpl.popIter(l_dimsValuesStr);
        ret_5 = ComponentReference.crefStripSubs(a_cr);
        (l_nosubname, a_auxFunction) = contextCrefIsPre(Tpl.emptyTxt, ret_5, a_context, a_auxFunction, a_isPre);
        l_t = Tpl.writeText(Tpl.emptyTxt, a_type);
        l_t = Tpl.writeTok(l_t, Tpl.ST_STRING("_array_create(&"));
        l_t = Tpl.writeText(l_t, a_wrapperArray);
        l_t = Tpl.writeTok(l_t, Tpl.ST_STRING(", ((modelica_"));
        l_t = Tpl.writeText(l_t, a_type);
        l_t = Tpl.writeTok(l_t, Tpl.ST_STRING("*)&((&"));
        l_t = Tpl.writeText(l_t, l_nosubname);
        l_t = Tpl.writeTok(l_t, Tpl.ST_STRING(")"));
        ret_7 = ComponentReference.crefDims(a_cr);
        ret_8 = ComponentReference.crefArrayGetFirstCref(a_cr);
        ret_9 = ComponentReference.crefSubs(ret_8);
        (l_t, a_preExp, a_varDecls, a_auxFunction) = indexSubs(l_t, ret_7, ret_9, a_context, a_preExp, a_varDecls, a_auxFunction);
        l_t = Tpl.writeTok(l_t, Tpl.ST_STRING(")), "));
        l_t = Tpl.writeText(l_t, l_dimsLenStr);
        l_t = Tpl.writeTok(l_t, Tpl.ST_STRING(", "));
        l_t = Tpl.writeText(l_t, l_dimsValuesStr);
        l_t = Tpl.writeTok(l_t, Tpl.ST_STRING(");"));
        l_t = Tpl.writeTok(l_t, Tpl.ST_NEW_LINE());
        a_preExp = Tpl.writeText(a_preExp, l_t);
        txt = Tpl.writeText(txt, a_wrapperArray);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end fun_799;

protected function fun_800
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input Boolean in_a_isPre;
  input Tpl.Text in_a_auxFunction;
  input SimCodeFunction.Context in_a_context;
  input DAE.ComponentRef in_a_cr;
  input DAE.Exp in_a_ecr;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_preExp, out_a_auxFunction) :=
  match(in_txt, in_mArg, in_a_varDecls, in_a_preExp, in_a_isPre, in_a_auxFunction, in_a_context, in_a_cr, in_a_ecr)
    local
      Tpl.Text txt;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      Boolean a_isPre;
      Tpl.Text a_auxFunction;
      SimCodeFunction.Context a_context;
      DAE.ComponentRef a_cr;
      DAE.Exp a_ecr;
      list<DAE.Subscript> ret_4;
      DAE.ComponentRef ret_3;
      list<DAE.Dimension> ret_2;
      DAE.ComponentRef ret_1;
      Tpl.Text txt_0;

    case ( txt,
           false,
           a_varDecls,
           a_preExp,
           _,
           a_auxFunction,
           _,
           _,
           a_ecr )
      equation
        txt_0 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("daeExpCrefLhsSimContext: UNHANDLED CREF: "));
        txt_0 = ExpressionDumpTpl.dumpExp(txt_0, a_ecr, "\"");
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 5353, 13), Tpl.textString(txt_0));
      then (txt, a_varDecls, a_preExp, a_auxFunction);

    case ( txt,
           _,
           a_varDecls,
           a_preExp,
           a_isPre,
           a_auxFunction,
           a_context,
           a_cr,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(&"));
        ret_1 = ComponentReference.crefStripSubs(a_cr);
        (txt, a_auxFunction) = contextCrefIsPre(txt, ret_1, a_context, a_auxFunction, a_isPre);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
        ret_2 = ComponentReference.crefDims(a_cr);
        ret_3 = ComponentReference.crefArrayGetFirstCref(a_cr);
        ret_4 = ComponentReference.crefSubs(ret_3);
        (txt, a_preExp, a_varDecls, a_auxFunction) = indexSubs(txt, ret_2, ret_4, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_varDecls, a_preExp, a_auxFunction);
  end match;
end fun_800;

protected function fun_801
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input Boolean in_a_isPre;
  input Tpl.Text in_a_auxFunction;
  input SimCodeFunction.Context in_a_context;
  input DAE.Exp in_a_ecr;
  input DAE.ComponentRef in_a_cr;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_preExp, out_a_auxFunction) :=
  match(in_txt, in_mArg, in_a_varDecls, in_a_preExp, in_a_isPre, in_a_auxFunction, in_a_context, in_a_ecr, in_a_cr)
    local
      Tpl.Text txt;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      Boolean a_isPre;
      Tpl.Text a_auxFunction;
      SimCodeFunction.Context a_context;
      DAE.Exp a_ecr;
      DAE.ComponentRef a_cr;
      Boolean ret_0;

    case ( txt,
           false,
           a_varDecls,
           a_preExp,
           a_isPre,
           a_auxFunction,
           a_context,
           a_ecr,
           a_cr )
      equation
        ret_0 = ComponentReference.crefIsScalarWithVariableSubs(a_cr);
        (txt, a_varDecls, a_preExp, a_auxFunction) = fun_800(txt, ret_0, a_varDecls, a_preExp, a_isPre, a_auxFunction, a_context, a_cr, a_ecr);
      then (txt, a_varDecls, a_preExp, a_auxFunction);

    case ( txt,
           _,
           a_varDecls,
           a_preExp,
           a_isPre,
           a_auxFunction,
           a_context,
           _,
           a_cr )
      equation
        (txt, a_auxFunction) = contextCrefIsPre(txt, a_cr, a_context, a_auxFunction, a_isPre);
      then (txt, a_varDecls, a_preExp, a_auxFunction);
  end match;
end fun_801;

public function daeExpCrefLhsSimContext
  input Tpl.Text in_txt;
  input DAE.Exp in_a_ecr;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;
  input Boolean in_a_isPre;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_ecr, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction, in_a_isPre)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      Boolean a_isPre;
      DAE.Dimensions i_dims;
      DAE.Exp i_ecr;
      DAE.Type i_aty;
      DAE.ComponentRef i_cr;
      Boolean ret_5;
      Boolean ret_4;
      Tpl.Text l_wrapperArray;
      Tpl.Text l_arrayType;
      Tpl.Text l_type;
      Tpl.Text txt_0;

    case ( txt,
           DAE.CREF(componentRef = i_cr, ty = DAE.T_COMPLEX(complexClassType = ClassInf.EXTERNAL_OBJ(path = _))),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction,
           a_isPre )
      equation
        (txt, a_auxFunction) = contextCrefIsPre(txt, i_cr, a_context, a_auxFunction, a_isPre);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CREF(componentRef = i_cr, ty = DAE.T_COMPLEX(complexClassType = _, varLst = _)),
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction,
           _ )
      equation
        txt_0 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("daeExpCrefLhsSimContext got record "));
        txt_0 = CodegenUtil.crefStrNoUnderscore(txt_0, i_cr);
        txt_0 = Tpl.writeTok(txt_0, Tpl.ST_STRING(". This does not make sense. Assigning to records is handled in a different way in the code generator, and reaching here is probably an error..."));
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 5330, 11), Tpl.textString(txt_0));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_ecr as DAE.CREF(componentRef = i_cr, ty = DAE.T_ARRAY(ty = i_aty, dims = i_dims))),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction,
           a_isPre )
      equation
        l_type = expTypeShort(Tpl.emptyTxt, i_aty);
        l_arrayType = Tpl.writeText(Tpl.emptyTxt, l_type);
        l_arrayType = Tpl.writeTok(l_arrayType, Tpl.ST_STRING("_array"));
        (l_wrapperArray, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(l_arrayType), a_varDecls);
        ret_4 = SimCodeFunctionUtil.crefSubIsScalar(i_cr);
        (txt, a_auxFunction, a_varDecls, a_preExp) = fun_799(txt, ret_4, l_wrapperArray, l_type, a_isPre, i_cr, a_auxFunction, a_varDecls, a_preExp, a_context, i_dims, i_ecr);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_ecr as DAE.CREF(componentRef = i_cr, ty = _)),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction,
           a_isPre )
      equation
        ret_5 = ComponentReference.crefIsScalarWithAllConstSubs(i_cr);
        (txt, a_varDecls, a_preExp, a_auxFunction) = fun_801(txt, ret_5, a_varDecls, a_preExp, a_isPre, a_auxFunction, a_context, i_ecr, i_cr);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction,
           _ )
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end daeExpCrefLhsSimContext;

protected function lm_803
  input Tpl.Text in_txt;
  input list<DAE.Dimension> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Dimension> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Dimension i_dim;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           i_dim :: rest,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", (_index_t)"));
        (txt, a_preExp, a_varDecls, a_auxFunction) = dimension(txt, i_dim, a_context, a_preExp, a_varDecls, a_auxFunction);
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_803(txt, rest, a_auxFunction, a_varDecls, a_preExp, a_context);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end lm_803;

protected function lm_804
  input Tpl.Text in_txt;
  input list<DAE.Subscript> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Subscript> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Exp i_exp;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           DAE.INDEX(exp = i_exp) :: rest,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeSubscriptExp(txt, i_exp, a_context, a_preExp, a_varDecls, a_auxFunction);
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_804(txt, rest, a_auxFunction, a_varDecls, a_preExp, a_context);
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           _ :: rest,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_804(txt, rest, a_auxFunction, a_varDecls, a_preExp, a_context);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end lm_804;

protected function fun_805
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input list<DAE.Dimension> in_a_dims;
  input list<DAE.Subscript> in_a_subs;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_mArg, in_a_dims, in_a_subs, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      list<DAE.Dimension> a_dims;
      list<DAE.Subscript> a_subs;
      SimCodeFunction.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      Integer ret_0;

    case ( txt,
           false,
           a_dims,
           a_subs,
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("[calc_base_index_dims_subs("));
        ret_0 = listLength(a_dims);
        txt = Tpl.writeStr(txt, intString(ret_0));
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_803(txt, a_dims, a_auxFunction, a_varDecls, a_preExp, a_context);
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_804(txt, a_subs, a_auxFunction, a_varDecls, a_preExp, a_context);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")]"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           _,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 5359, 11), "indexSubs got different number of dimensions and subscripts");
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end fun_805;

public function indexSubs
  input Tpl.Text txt;
  input list<DAE.Dimension> a_dims;
  input list<DAE.Subscript> a_subs;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_preExp;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
protected
  Boolean ret_2;
  Integer ret_1;
  Integer ret_0;
algorithm
  ret_0 := listLength(a_dims);
  ret_1 := listLength(a_subs);
  ret_2 := intNe(ret_0, ret_1);
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) := fun_805(txt, ret_2, a_dims, a_subs, a_context, a_preExp, a_varDecls, a_auxFunction);
end indexSubs;

protected function fun_807
  input Tpl.Text in_txt;
  input SimCodeFunction.Context in_a_context;
  input DAE.Exp in_a_ecr;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_context, in_a_ecr, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      DAE.Exp a_ecr;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      SimCodeFunction.Context i_context;
      Tpl.Text txt_0;

    case ( txt,
           (i_context as SimCodeFunction.FUNCTION_CONTEXT(is_parallel = true)),
           a_ecr,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExpCrefLhsFunContextParModExpl(txt, a_ecr, i_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_context as SimCodeFunction.FUNCTION_CONTEXT(cref_prefix = _)),
           a_ecr,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExpCrefLhsFunContextNormal(txt, a_ecr, i_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           a_ecr,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt_0 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("This should have been handled in the new daeExpCrefLhsSimContext function. "));
        txt_0 = ExpressionDumpTpl.dumpExp(txt_0, a_ecr, "\"");
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 5374, 11), Tpl.textString(txt_0));
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end fun_807;

public function daeExpCrefLhsFunContext
  input Tpl.Text txt;
  input DAE.Exp a_ecr;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_preExp;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) := fun_807(txt, a_context, a_ecr, a_preExp, a_varDecls, a_auxFunction);
end daeExpCrefLhsFunContext;

protected function fun_809
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;
  input DAE.ComponentRef in_a_cr;
  input DAE.Exp in_a_ecr;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_mArg, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context, in_a_cr, in_a_ecr)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.ComponentRef a_cr;
      DAE.Exp a_ecr;
      Tpl.Text txt_0;

    case ( txt,
           false,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _,
           _,
           a_ecr )
      equation
        txt_0 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("This should have been handled in indexed assign and should not have gotten here. "));
        txt_0 = ExpressionDumpTpl.dumpExp(txt_0, a_ecr, "\"");
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 5389, 13), Tpl.textString(txt_0));
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           _,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context,
           a_cr,
           _ )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = contextCref(txt, a_cr, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end fun_809;

protected function fun_810
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;
  input DAE.Exp in_a_ecr;
  input DAE.ComponentRef in_a_cr;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_mArg, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context, in_a_ecr, in_a_cr)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Exp a_ecr;
      DAE.ComponentRef a_cr;
      Boolean ret_0;

    case ( txt,
           false,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context,
           a_ecr,
           a_cr )
      equation
        ret_0 = SimCodeFunctionUtil.crefSubIsScalar(a_cr);
        (txt, a_auxFunction, a_varDecls, a_preExp) = fun_809(txt, ret_0, a_auxFunction, a_varDecls, a_preExp, a_context, a_cr, a_ecr);
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           _,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context,
           _,
           a_cr )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = contextCref(txt, a_cr, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end fun_810;

public function daeExpCrefLhsFunContextNormal
  input Tpl.Text in_txt;
  input DAE.Exp in_a_ecr;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_ecr, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Exp i_ecr;
      DAE.ComponentRef i_cr;
      Tpl.Text txt_1;
      Boolean ret_0;

    case ( txt,
           (i_ecr as DAE.CREF(componentRef = i_cr, ty = _)),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        ret_0 = SimCodeFunctionUtil.crefIsScalar(i_cr, a_context);
        (txt, a_auxFunction, a_varDecls, a_preExp) = fun_810(txt, ret_0, a_auxFunction, a_varDecls, a_preExp, a_context, i_ecr, i_cr);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           i_ecr,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt_1 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("SimCodeC.tpl template: daeExpCrefLhsFunContextNormal: UNHANDLED EXPRESSION:  "));
        txt_1 = ExpressionDumpTpl.dumpExp(txt_1, i_ecr, "\"");
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 5392, 11), Tpl.textString(txt_1));
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end daeExpCrefLhsFunContextNormal;

protected function lm_812
  input Tpl.Text in_txt;
  input list<DAE.Subscript> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Subscript> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Exp i_exp;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           DAE.INDEX(exp = i_exp) :: rest,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeSubscriptExp(txt, i_exp, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_812(txt, rest, a_auxFunction, a_varDecls, a_preExp, a_context);
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           _ :: rest,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_812(txt, rest, a_auxFunction, a_varDecls, a_preExp, a_context);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end lm_812;

protected function fun_813
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input DAE.Type in_a_ty;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;
  input DAE.ComponentRef in_a_cr;
  input DAE.Exp in_a_ecr;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_mArg, in_a_ty, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context, in_a_cr, in_a_ecr)
    local
      Tpl.Text txt;
      DAE.Type a_ty;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.ComponentRef a_cr;
      DAE.Exp a_ecr;
      list<DAE.Subscript> ret_8;
      Tpl.Text l_subsValuesStr;
      Integer ret_6;
      list<DAE.Subscript> ret_5;
      Tpl.Text l_subsLenStr;
      Tpl.Text l_arrayType;
      DAE.ComponentRef ret_2;
      Tpl.Text l_arrName;
      Tpl.Text txt_0;

    case ( txt,
           false,
           _,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _,
           _,
           a_ecr )
      equation
        txt_0 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("This should have been handled in indexed assign and should not have gotten here. "));
        txt_0 = ExpressionDumpTpl.dumpExp(txt_0, a_ecr, "\"");
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 5418, 15), Tpl.textString(txt_0));
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           _,
           a_ty,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context,
           a_cr,
           _ )
      equation
        ret_2 = ComponentReference.crefStripLastSubs(a_cr);
        (l_arrName, a_preExp, a_varDecls, a_auxFunction) = contextCref(Tpl.emptyTxt, ret_2, a_context, a_preExp, a_varDecls, a_auxFunction);
        l_arrayType = expTypeArray(Tpl.emptyTxt, a_ty);
        ret_5 = ComponentReference.crefSubs(a_cr);
        ret_6 = listLength(ret_5);
        l_subsLenStr = Tpl.writeStr(Tpl.emptyTxt, intString(ret_6));
        ret_8 = ComponentReference.crefSubs(a_cr);
        l_subsValuesStr = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_subsValuesStr, a_auxFunction, a_varDecls, a_preExp) = lm_812(l_subsValuesStr, ret_8, a_auxFunction, a_varDecls, a_preExp, a_context);
        l_subsValuesStr = Tpl.popIter(l_subsValuesStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(*"));
        txt = Tpl.writeText(txt, l_arrayType);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_element_addr_c99_"));
        txt = Tpl.writeText(txt, l_subsLenStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(&"));
        txt = Tpl.writeText(txt, l_arrName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, l_subsLenStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, l_subsValuesStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("))"));
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end fun_813;

protected function fun_814
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input DAE.Type in_a_ty;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;
  input DAE.Exp in_a_ecr;
  input DAE.ComponentRef in_a_cr;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_mArg, in_a_ty, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context, in_a_ecr, in_a_cr)
    local
      Tpl.Text txt;
      DAE.Type a_ty;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Exp a_ecr;
      DAE.ComponentRef a_cr;
      Boolean ret_0;

    case ( txt,
           false,
           a_ty,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context,
           a_ecr,
           a_cr )
      equation
        ret_0 = SimCodeFunctionUtil.crefSubIsScalar(a_cr);
        (txt, a_auxFunction, a_varDecls, a_preExp) = fun_813(txt, ret_0, a_ty, a_auxFunction, a_varDecls, a_preExp, a_context, a_cr, a_ecr);
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           _,
           _,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context,
           _,
           a_cr )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = contextCref(txt, a_cr, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end fun_814;

public function daeExpCrefLhsFunContextParModExpl
  input Tpl.Text in_txt;
  input DAE.Exp in_a_ecr;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_ecr, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Type i_ty;
      DAE.Exp i_ecr;
      DAE.ComponentRef i_cr;
      Tpl.Text txt_1;
      Boolean ret_0;

    case ( txt,
           (i_ecr as DAE.CREF(componentRef = i_cr, ty = i_ty)),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        ret_0 = SimCodeFunctionUtil.crefIsScalar(i_cr, a_context);
        (txt, a_auxFunction, a_varDecls, a_preExp) = fun_814(txt, ret_0, i_ty, a_auxFunction, a_varDecls, a_preExp, a_context, i_ecr, i_cr);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           i_ecr,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt_1 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("SimCodeC.tpl template: daeExpCrefLhsFunContextParModExpl: UNHANDLED EXPRESSION:  "));
        txt_1 = ExpressionDumpTpl.dumpExp(txt_1, i_ecr, "\"");
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 5421, 11), Tpl.textString(txt_1));
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end daeExpCrefLhsFunContextParModExpl;

protected function fun_816
  input Tpl.Text in_txt;
  input DAE.Subscript in_a_sub;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_a_sub, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Exp i_exp;
      Tpl.Text l_tmp;
      Tpl.Text l_str;
      Tpl.Text l_expPart;

    case ( txt,
           DAE.INDEX(exp = i_exp),
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (l_expPart, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_exp, a_context, a_preExp, a_varDecls, a_auxFunction);
        l_str = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("(modelica_integer)(0), make_index_array(1, (modelica_integer) "));
        l_str = Tpl.writeText(l_str, l_expPart);
        l_str = Tpl.writeTok(l_str, Tpl.ST_STRING("), \'S\'"));
        txt = Tpl.writeText(txt, l_str);
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           DAE.WHOLEDIM(),
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _ )
      equation
        l_str = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("(modelica_integer)(1), (int*)0, \'W\'"));
        txt = Tpl.writeText(txt, l_str);
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           DAE.SLICE(exp = i_exp),
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (l_expPart, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_exp, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_tmp, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_integer", a_varDecls);
        a_preExp = Tpl.writeText(a_preExp, l_tmp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = size_of_dimension_base_array("));
        a_preExp = Tpl.writeText(a_preExp, l_expPart);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", 1);"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        l_str = Tpl.writeText(Tpl.emptyTxt, l_tmp);
        l_str = Tpl.writeTok(l_str, Tpl.ST_STRING(", integer_array_make_index_array("));
        l_str = Tpl.writeText(l_str, l_expPart);
        l_str = Tpl.writeTok(l_str, Tpl.ST_STRING("), \'A\'"));
        txt = Tpl.writeText(txt, l_str);
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           _,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end fun_816;

protected function lm_817
  input Tpl.Text in_txt;
  input list<DAE.Subscript> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Subscript> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Subscript i_sub;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           i_sub :: rest,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (txt, a_auxFunction, a_varDecls, a_preExp) = fun_816(txt, i_sub, a_auxFunction, a_varDecls, a_preExp, a_context);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_817(txt, rest, a_auxFunction, a_varDecls, a_preExp, a_context);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end lm_817;

public function daeExpCrefIndexSpec
  input Tpl.Text txt;
  input list<DAE.Subscript> a_subs;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_preExp;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
protected
  Tpl.Text l_tmp;
  Tpl.Text l_idx__str;
  Integer ret_1;
  Tpl.Text l_nridx__str;
algorithm
  ret_1 := listLength(a_subs);
  l_nridx__str := Tpl.writeStr(Tpl.emptyTxt, intString(ret_1));
  l_idx__str := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (l_idx__str, out_a_auxFunction, out_a_varDecls, out_a_preExp) := lm_817(l_idx__str, a_subs, a_auxFunction, a_varDecls, a_preExp, a_context);
  l_idx__str := Tpl.popIter(l_idx__str);
  (l_tmp, out_a_varDecls) := tempDecl(Tpl.emptyTxt, "index_spec_t", out_a_varDecls);
  out_a_preExp := Tpl.writeTok(out_a_preExp, Tpl.ST_STRING("create_index_spec(&"));
  out_a_preExp := Tpl.writeText(out_a_preExp, l_tmp);
  out_a_preExp := Tpl.writeTok(out_a_preExp, Tpl.ST_STRING(", "));
  out_a_preExp := Tpl.writeText(out_a_preExp, l_nridx__str);
  out_a_preExp := Tpl.writeTok(out_a_preExp, Tpl.ST_STRING(", "));
  out_a_preExp := Tpl.writeText(out_a_preExp, l_idx__str);
  out_a_preExp := Tpl.writeTok(out_a_preExp, Tpl.ST_STRING(");"));
  out_a_preExp := Tpl.writeTok(out_a_preExp, Tpl.ST_NEW_LINE());
  out_txt := Tpl.writeText(txt, l_tmp);
end daeExpCrefIndexSpec;

protected function fun_819
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_e2;
  input Tpl.Text in_a_e1;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_e2, in_a_e1)
    local
      Tpl.Text txt;
      Tpl.Text a_e2;
      Tpl.Text a_e1;

    case ( txt,
           false,
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" - ("));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           _,
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" - "));
        txt = Tpl.writeText(txt, a_e2);
      then txt;
  end match;
end fun_819;

protected function fun_820
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input DAE.Exp in_a_exp;
  input Tpl.Text in_a_tvar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_exp, in_a_tvar)
    local
      Tpl.Text txt;
      DAE.Exp a_exp;
      Tpl.Text a_tvar;
      String ret_1;
      Tpl.Text txt_0;

    case ( txt,
           false,
           a_exp,
           a_tvar )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if ("));
        txt = Tpl.writeText(txt, a_tvar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" == 0) {throwStreamPrint(threadData, \"Division by zero %s\", \""));
        txt_0 = ExpressionDumpTpl.dumpExp(Tpl.emptyTxt, a_exp, "\"");
        ret_1 = Util.escapeModelicaStringToCString(Tpl.textString(txt_0));
        txt = Tpl.writeStr(txt, ret_1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\");}"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _,
           _,
           a_tvar )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if ("));
        txt = Tpl.writeText(txt, a_tvar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" == 0) {"));
        txt = generateThrow(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";}"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;
  end match;
end fun_820;

protected function fun_821
  input Tpl.Text in_txt;
  input SimCodeFunction.Context in_a_context;
  input DAE.Exp in_a_exp2;
  input Tpl.Text in_a_e1;
  input DAE.Exp in_a_exp;
  input Tpl.Text in_a_e2;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls) :=
  match(in_txt, in_a_context, in_a_exp2, in_a_e1, in_a_exp, in_a_e2, in_a_preExp, in_a_varDecls, in_a_ty)
    local
      Tpl.Text txt;
      DAE.Exp a_exp2;
      Tpl.Text a_e1;
      DAE.Exp a_exp;
      Tpl.Text a_e2;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      DAE.Type a_ty;
      String ret_7;
      Tpl.Text txt_6;
      String ret_5;
      Tpl.Text txt_4;
      Tpl.Text l_e2str;
      Boolean ret_2;
      Tpl.Text txt_1;
      Tpl.Text l_tvar;

    case ( txt,
           SimCodeFunction.FUNCTION_CONTEXT(cref_prefix = _),
           _,
           a_e1,
           a_exp,
           a_e2,
           a_preExp,
           a_varDecls,
           a_ty )
      equation
        txt_1 = expTypeModelica(Tpl.emptyTxt, a_ty);
        (l_tvar, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(txt_1), a_varDecls);
        a_preExp = Tpl.writeText(a_preExp, l_tvar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = "));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(";"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        ret_2 = Config.acceptMetaModelicaGrammar();
        a_preExp = fun_820(a_preExp, ret_2, a_exp, l_tvar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") / "));
        txt = Tpl.writeText(txt, l_tvar);
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           SimCodeFunction.SIMULATION_CONTEXT(genDiscrete = _),
           a_exp2,
           a_e1,
           _,
           a_e2,
           a_preExp,
           a_varDecls,
           _ )
      equation
        txt_4 = ExpressionDumpTpl.dumpExp(Tpl.emptyTxt, a_exp2, "\"");
        ret_5 = Util.escapeModelicaStringToCString(Tpl.textString(txt_4));
        l_e2str = Tpl.writeStr(Tpl.emptyTxt, ret_5);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("DIVISION_SIM("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(",\""));
        txt = Tpl.writeText(txt, l_e2str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\",equationIndexes)"));
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           _,
           a_exp2,
           a_e1,
           _,
           a_e2,
           a_preExp,
           a_varDecls,
           _ )
      equation
        txt_6 = ExpressionDumpTpl.dumpExp(Tpl.emptyTxt, a_exp2, "\"");
        ret_7 = Util.escapeModelicaStringToCString(Tpl.textString(txt_6));
        l_e2str = Tpl.writeStr(Tpl.emptyTxt, ret_7);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("DIVISION("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(",\""));
        txt = Tpl.writeText(txt, l_e2str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\")"));
      then (txt, a_preExp, a_varDecls);
  end match;
end fun_821;

protected function fun_822
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_tmp2;
  input Tpl.Text in_a_tmp1;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_tmp2, in_a_tmp1)
    local
      Tpl.Text txt;
      Tpl.Text a_tmp2;
      Tpl.Text a_tmp1;

    case ( txt,
           false,
           a_tmp2,
           a_tmp1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("throwStreamPrint(threadData, \"%s:%d: Invalid root: (%g)^(%g)\", __FILE__, __LINE__, "));
        txt = Tpl.writeText(txt, a_tmp1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_tmp2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _,
           _,
           _ )
      equation
        txt = generateThrow(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;
  end match;
end fun_822;

protected function fun_823
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_tmp2;
  input Tpl.Text in_a_tmp1;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_tmp2, in_a_tmp1)
    local
      Tpl.Text txt;
      Tpl.Text a_tmp2;
      Tpl.Text a_tmp1;

    case ( txt,
           false,
           a_tmp2,
           a_tmp1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("throwStreamPrint(threadData, \"%s:%d: Invalid root: (%g)^(%g)\", __FILE__, __LINE__, "));
        txt = Tpl.writeText(txt, a_tmp1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_tmp2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _,
           _,
           _ )
      equation
        txt = generateThrow(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;
  end match;
end fun_823;

protected function fun_824
  input Tpl.Text in_txt;
  input Option<Integer> in_mArg;
  input Tpl.Text in_a_e2;
  input Tpl.Text in_a_e1;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls) :=
  match(in_txt, in_mArg, in_a_e2, in_a_e1, in_a_preExp, in_a_varDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_e2;
      Tpl.Text a_e1;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Integer i_i;
      Boolean ret_9;
      Boolean ret_8;
      Tpl.Text l_tmp7;
      Tpl.Text l_tmp6;
      Tpl.Text l_tmp5;
      Tpl.Text l_tmp4;
      Tpl.Text l_tmp3;
      Tpl.Text l_tmp2;
      Tpl.Text l_tmp1;
      Tpl.Text l_tmp;

    case ( txt,
           SOME(2),
           _,
           a_e1,
           a_preExp,
           a_varDecls )
      equation
        (l_tmp, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_real", a_varDecls);
        a_preExp = Tpl.writeText(a_preExp, l_tmp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = "));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(";"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, l_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" * "));
        txt = Tpl.writeText(txt, l_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           SOME(3),
           _,
           a_e1,
           a_preExp,
           a_varDecls )
      equation
        (l_tmp, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_real", a_varDecls);
        a_preExp = Tpl.writeText(a_preExp, l_tmp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = "));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(";"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, l_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" * "));
        txt = Tpl.writeText(txt, l_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" * "));
        txt = Tpl.writeText(txt, l_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           SOME(4),
           _,
           a_e1,
           a_preExp,
           a_varDecls )
      equation
        (l_tmp, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_real", a_varDecls);
        a_preExp = Tpl.writeText(a_preExp, l_tmp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = "));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(";"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        a_preExp = Tpl.writeText(a_preExp, l_tmp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" *= "));
        a_preExp = Tpl.writeText(a_preExp, l_tmp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, l_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" * "));
        txt = Tpl.writeText(txt, l_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           SOME(i_i),
           _,
           a_e1,
           a_preExp,
           a_varDecls )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("real_int_pow(threadData, "));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeStr(txt, intString(i_i));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           _,
           a_e2,
           a_e1,
           a_preExp,
           a_varDecls )
      equation
        (l_tmp1, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_real", a_varDecls);
        (l_tmp2, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_real", a_varDecls);
        (l_tmp3, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_real", a_varDecls);
        (l_tmp4, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_real", a_varDecls);
        (l_tmp5, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_real", a_varDecls);
        (l_tmp6, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_real", a_varDecls);
        (l_tmp7, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_real", a_varDecls);
        a_preExp = Tpl.writeText(a_preExp, l_tmp1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = "));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_LINE(";\n"));
        a_preExp = Tpl.writeText(a_preExp, l_tmp2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = "));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING_LIST({
                                              ";\n",
                                              "if("
                                          }, false));
        a_preExp = Tpl.writeText(a_preExp, l_tmp1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" < 0.0 && "));
        a_preExp = Tpl.writeText(a_preExp, l_tmp2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING_LIST({
                                              " != 0.0)\n",
                                              "{\n"
                                          }, true));
        a_preExp = Tpl.pushBlock(a_preExp, Tpl.BT_INDENT(2));
        a_preExp = Tpl.writeText(a_preExp, l_tmp4);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = modf("));
        a_preExp = Tpl.writeText(a_preExp, l_tmp2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", &"));
        a_preExp = Tpl.writeText(a_preExp, l_tmp5);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING_LIST({
                                              ");\n",
                                              "\n",
                                              "if("
                                          }, false));
        a_preExp = Tpl.writeText(a_preExp, l_tmp4);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING_LIST({
                                              " > 0.5)\n",
                                              "{\n"
                                          }, true));
        a_preExp = Tpl.pushBlock(a_preExp, Tpl.BT_INDENT(2));
        a_preExp = Tpl.writeText(a_preExp, l_tmp4);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_LINE(" -= 1.0;\n"));
        a_preExp = Tpl.writeText(a_preExp, l_tmp5);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_LINE(" += 1.0;\n"));
        a_preExp = Tpl.popBlock(a_preExp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING_LIST({
                                              "}\n",
                                              "else if("
                                          }, false));
        a_preExp = Tpl.writeText(a_preExp, l_tmp4);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING_LIST({
                                              " < -0.5)\n",
                                              "{\n"
                                          }, true));
        a_preExp = Tpl.pushBlock(a_preExp, Tpl.BT_INDENT(2));
        a_preExp = Tpl.writeText(a_preExp, l_tmp4);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_LINE(" += 1.0;\n"));
        a_preExp = Tpl.writeText(a_preExp, l_tmp5);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_LINE(" -= 1.0;\n"));
        a_preExp = Tpl.popBlock(a_preExp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING_LIST({
                                              "}\n",
                                              "\n",
                                              "if(fabs("
                                          }, false));
        a_preExp = Tpl.writeText(a_preExp, l_tmp4);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_LINE(") < 1e-10)\n"));
        a_preExp = Tpl.pushBlock(a_preExp, Tpl.BT_INDENT(2));
        a_preExp = Tpl.writeText(a_preExp, l_tmp3);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = pow("));
        a_preExp = Tpl.writeText(a_preExp, l_tmp1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, l_tmp5);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_LINE(");\n"));
        a_preExp = Tpl.popBlock(a_preExp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING_LIST({
                                              "else\n",
                                              "{\n"
                                          }, true));
        a_preExp = Tpl.pushBlock(a_preExp, Tpl.BT_INDENT(2));
        a_preExp = Tpl.writeText(a_preExp, l_tmp7);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = modf(1.0/"));
        a_preExp = Tpl.writeText(a_preExp, l_tmp2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", &"));
        a_preExp = Tpl.writeText(a_preExp, l_tmp6);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING_LIST({
                                              ");\n",
                                              "if("
                                          }, false));
        a_preExp = Tpl.writeText(a_preExp, l_tmp7);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING_LIST({
                                              " > 0.5)\n",
                                              "{\n"
                                          }, true));
        a_preExp = Tpl.pushBlock(a_preExp, Tpl.BT_INDENT(2));
        a_preExp = Tpl.writeText(a_preExp, l_tmp7);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_LINE(" -= 1.0;\n"));
        a_preExp = Tpl.writeText(a_preExp, l_tmp6);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_LINE(" += 1.0;\n"));
        a_preExp = Tpl.popBlock(a_preExp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING_LIST({
                                              "}\n",
                                              "else if("
                                          }, false));
        a_preExp = Tpl.writeText(a_preExp, l_tmp7);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING_LIST({
                                              " < -0.5)\n",
                                              "{\n"
                                          }, true));
        a_preExp = Tpl.pushBlock(a_preExp, Tpl.BT_INDENT(2));
        a_preExp = Tpl.writeText(a_preExp, l_tmp7);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_LINE(" += 1.0;\n"));
        a_preExp = Tpl.writeText(a_preExp, l_tmp6);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_LINE(" -= 1.0;\n"));
        a_preExp = Tpl.popBlock(a_preExp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING_LIST({
                                              "}\n",
                                              "if(fabs("
                                          }, false));
        a_preExp = Tpl.writeText(a_preExp, l_tmp7);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(") < 1e-10 && ((unsigned long)"));
        a_preExp = Tpl.writeText(a_preExp, l_tmp6);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING_LIST({
                                              " & 1))\n",
                                              "{\n"
                                          }, true));
        a_preExp = Tpl.pushBlock(a_preExp, Tpl.BT_INDENT(2));
        a_preExp = Tpl.writeText(a_preExp, l_tmp3);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = -pow(-"));
        a_preExp = Tpl.writeText(a_preExp, l_tmp1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, l_tmp4);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(")*pow("));
        a_preExp = Tpl.writeText(a_preExp, l_tmp1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, l_tmp5);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_LINE(");\n"));
        a_preExp = Tpl.popBlock(a_preExp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING_LIST({
                                              "}\n",
                                              "else\n",
                                              "{\n"
                                          }, true));
        a_preExp = Tpl.pushBlock(a_preExp, Tpl.BT_INDENT(2));
        ret_8 = Config.acceptMetaModelicaGrammar();
        a_preExp = fun_822(a_preExp, ret_8, l_tmp2, l_tmp1);
        a_preExp = Tpl.softNewLine(a_preExp);
        a_preExp = Tpl.popBlock(a_preExp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_LINE("}\n"));
        a_preExp = Tpl.popBlock(a_preExp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_LINE("}\n"));
        a_preExp = Tpl.popBlock(a_preExp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING_LIST({
                                              "}\n",
                                              "else\n",
                                              "{\n"
                                          }, true));
        a_preExp = Tpl.pushBlock(a_preExp, Tpl.BT_INDENT(2));
        a_preExp = Tpl.writeText(a_preExp, l_tmp3);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = pow("));
        a_preExp = Tpl.writeText(a_preExp, l_tmp1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, l_tmp2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_LINE(");\n"));
        a_preExp = Tpl.popBlock(a_preExp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING_LIST({
                                              "}\n",
                                              "if(isnan("
                                          }, false));
        a_preExp = Tpl.writeText(a_preExp, l_tmp3);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(") || isinf("));
        a_preExp = Tpl.writeText(a_preExp, l_tmp3);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING_LIST({
                                              "))\n",
                                              "{\n"
                                          }, true));
        a_preExp = Tpl.pushBlock(a_preExp, Tpl.BT_INDENT(2));
        ret_9 = Config.acceptMetaModelicaGrammar();
        a_preExp = fun_823(a_preExp, ret_9, l_tmp2, l_tmp1);
        a_preExp = Tpl.softNewLine(a_preExp);
        a_preExp = Tpl.popBlock(a_preExp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("}"));
        txt = Tpl.writeText(txt, l_tmp3);
      then (txt, a_preExp, a_varDecls);
  end match;
end fun_824;

protected function fun_825
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input SimCodeFunction.Context in_a_context;
  input DAE.Exp in_a_exp1;
  input Tpl.Text in_a_e2;
  input Tpl.Text in_a_e1;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input DAE.Exp in_a_exp2;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls) :=
  match(in_txt, in_mArg, in_a_context, in_a_exp1, in_a_e2, in_a_e1, in_a_preExp, in_a_varDecls, in_a_exp2)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      DAE.Exp a_exp1;
      Tpl.Text a_e2;
      Tpl.Text a_e1;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      DAE.Exp a_exp2;
      Tpl.Text txt_5;
      String ret_5;
      Tpl.Text txt_4;
      Tpl.Text l_cstr;
      Tpl.Text txt_2;
      Tpl.Text l_tmp;
      Option<Integer> ret_0;

    case ( txt,
           false,
           _,
           _,
           a_e2,
           a_e1,
           a_preExp,
           a_varDecls,
           a_exp2 )
      equation
        ret_0 = Expression.realExpIntLit(a_exp2);
        (txt, a_preExp, a_varDecls) = fun_824(txt, ret_0, a_e2, a_e1, a_preExp, a_varDecls);
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           _,
           a_context,
           a_exp1,
           _,
           a_e1,
           a_preExp,
           a_varDecls,
           _ )
      equation
        txt_2 = expTypeFromExpModelica(Tpl.emptyTxt, a_exp1);
        (l_tmp, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(txt_2), a_varDecls);
        l_cstr = ExpressionDumpTpl.dumpExp(Tpl.emptyTxt, a_exp1, "\"");
        a_preExp = Tpl.writeText(a_preExp, l_tmp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = "));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_LINE(";\n"));
        txt_4 = Tpl.writeText(Tpl.emptyTxt, l_tmp);
        txt_4 = Tpl.writeTok(txt_4, Tpl.ST_STRING(" >= 0.0"));
        txt_5 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("\"Model error: Argument of sqrt("));
        ret_5 = Util.escapeModelicaStringToCString(Tpl.textString(l_cstr));
        txt_5 = Tpl.writeStr(txt_5, ret_5);
        txt_5 = Tpl.writeTok(txt_5, Tpl.ST_STRING(") was %g should be >= 0\", "));
        txt_5 = Tpl.writeText(txt_5, l_tmp);
        (a_preExp, txt_4, txt_5, a_varDecls) = assertCommonVar(a_preExp, txt_4, txt_5, a_context, a_varDecls, AbsynUtil.dummyInfo);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("sqrt("));
        txt = Tpl.writeText(txt, l_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls);
  end match;
end fun_825;

protected function fun_826
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty)
    local
      Tpl.Text txt;

    case ( txt,
           DAE.T_ARRAY(ty = DAE.T_INTEGER(varLst = _)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("integer_array"));
      then txt;

    case ( txt,
           DAE.T_ARRAY(ty = DAE.T_ENUMERATION(index = _)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("integer_array"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("real_array"));
      then txt;
  end match;
end fun_826;

protected function fun_827
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty)
    local
      Tpl.Text txt;

    case ( txt,
           DAE.T_ARRAY(ty = DAE.T_INTEGER(varLst = _)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("integer_array"));
      then txt;

    case ( txt,
           DAE.T_ARRAY(ty = DAE.T_ENUMERATION(index = _)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("integer_array"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("real_array"));
      then txt;
  end match;
end fun_827;

protected function fun_828
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty)
    local
      Tpl.Text txt;

    case ( txt,
           DAE.T_ARRAY(ty = DAE.T_INTEGER(varLst = _)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("integer_array"));
      then txt;

    case ( txt,
           DAE.T_ARRAY(ty = DAE.T_ENUMERATION(index = _)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("integer_array"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("real_array"));
      then txt;
  end match;
end fun_828;

protected function fun_829
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty)
    local
      Tpl.Text txt;

    case ( txt,
           DAE.T_ARRAY(ty = DAE.T_INTEGER(varLst = _)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("integer_array"));
      then txt;

    case ( txt,
           DAE.T_ARRAY(ty = DAE.T_ENUMERATION(index = _)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("integer_array"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("real_array"));
      then txt;
  end match;
end fun_829;

protected function fun_830
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty)
    local
      Tpl.Text txt;

    case ( txt,
           DAE.T_ARRAY(ty = DAE.T_INTEGER(varLst = _)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("integer_array"));
      then txt;

    case ( txt,
           DAE.T_ARRAY(ty = DAE.T_ENUMERATION(index = _)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("integer_array"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("real_array"));
      then txt;
  end match;
end fun_830;

protected function fun_831
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_e1;
  input Tpl.Text in_a_e2;
  input Tpl.Text in_a_type;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_e1, in_a_e2, in_a_type)
    local
      Tpl.Text txt;
      Tpl.Text a_e1;
      Tpl.Text a_e2;
      Tpl.Text a_type;

    case ( txt,
           false,
           a_e1,
           a_e2,
           a_type )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("mul_alloc_"));
        txt = Tpl.writeText(txt, a_type);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_scalar("));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           _,
           a_e1,
           a_e2,
           a_type )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("mul_alloc_"));
        txt = Tpl.writeText(txt, a_type);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_scalar("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;
  end match;
end fun_831;

protected function fun_832
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty)
    local
      Tpl.Text txt;

    case ( txt,
           DAE.T_ARRAY(ty = DAE.T_INTEGER(varLst = _)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("integer_array"));
      then txt;

    case ( txt,
           DAE.T_ARRAY(ty = DAE.T_ENUMERATION(index = _)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("integer_array"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("real_array"));
      then txt;
  end match;
end fun_832;

protected function fun_833
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_e1;
  input Tpl.Text in_a_e2;
  input Tpl.Text in_a_type;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_e1, in_a_e2, in_a_type)
    local
      Tpl.Text txt;
      Tpl.Text a_e1;
      Tpl.Text a_e2;
      Tpl.Text a_type;

    case ( txt,
           false,
           a_e1,
           a_e2,
           a_type )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("add_alloc_"));
        txt = Tpl.writeText(txt, a_type);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_scalar("));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           _,
           a_e1,
           a_e2,
           a_type )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("add_alloc_"));
        txt = Tpl.writeText(txt, a_type);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_scalar("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;
  end match;
end fun_833;

protected function fun_834
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty)
    local
      Tpl.Text txt;

    case ( txt,
           DAE.T_ARRAY(ty = DAE.T_INTEGER(varLst = _)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("integer_array"));
      then txt;

    case ( txt,
           DAE.T_ARRAY(ty = DAE.T_ENUMERATION(index = _)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("integer_array"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("real_array"));
      then txt;
  end match;
end fun_834;

protected function fun_835
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty)
    local
      Tpl.Text txt;

    case ( txt,
           DAE.T_ARRAY(ty = DAE.T_INTEGER(varLst = _)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("integer_scalar"));
      then txt;

    case ( txt,
           DAE.T_ARRAY(ty = DAE.T_ENUMERATION(index = _)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("integer_scalar"));
      then txt;

    case ( txt,
           DAE.T_INTEGER(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("integer_scalar"));
      then txt;

    case ( txt,
           DAE.T_ENUMERATION(index = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("integer_scalar"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("real_scalar"));
      then txt;
  end match;
end fun_835;

protected function fun_836
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty)
    local
      Tpl.Text txt;

    case ( txt,
           DAE.T_ARRAY(ty = DAE.T_INTEGER(varLst = _)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("integer"));
      then txt;

    case ( txt,
           DAE.T_ARRAY(ty = DAE.T_ENUMERATION(index = _)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("integer"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("real"));
      then txt;
  end match;
end fun_836;

protected function fun_837
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty)
    local
      Tpl.Text txt;

    case ( txt,
           DAE.T_ARRAY(ty = DAE.T_INTEGER(varLst = _)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("integer_array"));
      then txt;

    case ( txt,
           DAE.T_ARRAY(ty = DAE.T_ENUMERATION(index = _)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("integer_array"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("real_array"));
      then txt;
  end match;
end fun_837;

protected function fun_838
  input Tpl.Text in_txt;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_e2str;
  input Tpl.Text in_a_e2;
  input Tpl.Text in_a_e1;
  input Tpl.Text in_a_type;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_context, in_a_e2str, in_a_e2, in_a_e1, in_a_type)
    local
      Tpl.Text txt;
      Tpl.Text a_e2str;
      Tpl.Text a_e2;
      Tpl.Text a_e1;
      Tpl.Text a_type;

    case ( txt,
           SimCodeFunction.FUNCTION_CONTEXT(cref_prefix = _),
           _,
           a_e2,
           a_e1,
           a_type )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("div_alloc_"));
        txt = Tpl.writeText(txt, a_type);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_scalar("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           _,
           a_e2str,
           a_e2,
           a_e1,
           a_type )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("division_alloc_"));
        txt = Tpl.writeText(txt, a_type);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_scalar(threadData,"));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(",\""));
        txt = Tpl.writeText(txt, a_e2str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\")"));
      then txt;
  end match;
end fun_838;

protected function fun_839
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty)
    local
      Tpl.Text txt;

    case ( txt,
           DAE.T_ARRAY(ty = DAE.T_INTEGER(varLst = _)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("integer_array"));
      then txt;

    case ( txt,
           DAE.T_ARRAY(ty = DAE.T_ENUMERATION(index = _)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("integer_array"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("real_array"));
      then txt;
  end match;
end fun_839;

protected function fun_840
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty)
    local
      Tpl.Text txt;

    case ( txt,
           DAE.T_ARRAY(ty = DAE.T_INTEGER(varLst = _)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("integer_array"));
      then txt;

    case ( txt,
           DAE.T_ARRAY(ty = DAE.T_ENUMERATION(index = _)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("integer_array"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("real_array"));
      then txt;
  end match;
end fun_840;

protected function fun_841
  input Tpl.Text in_txt;
  input DAE.Operator in_a_operator;
  input Tpl.Text in_a_auxFunction;
  input DAE.Exp in_a_exp1;
  input DAE.Exp in_a_exp;
  input SimCodeFunction.Context in_a_context;
  input DAE.Exp in_a_exp2;
  input Tpl.Text in_a_e2;
  input Tpl.Text in_a_e1;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_preExp, out_a_varDecls) :=
  match(in_txt, in_a_operator, in_a_auxFunction, in_a_exp1, in_a_exp, in_a_context, in_a_exp2, in_a_e2, in_a_e1, in_a_preExp, in_a_varDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      DAE.Exp a_exp1;
      DAE.Exp a_exp;
      SimCodeFunction.Context a_context;
      DAE.Exp a_exp2;
      Tpl.Text a_e2;
      Tpl.Text a_e1;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      DAE.Type i_ty;
      String ret_11;
      Tpl.Text txt_10;
      Tpl.Text l_e2str;
      Tpl.Text l_typeShort;
      Boolean ret_7;
      DAE.Type ret_6;
      Boolean ret_5;
      DAE.Type ret_4;
      Tpl.Text l_type;
      Boolean ret_2;
      Boolean ret_1;
      Tpl.Text l_tmpStr;

    case ( txt,
           DAE.ADD(ty = DAE.T_STRING(varLst = _)),
           a_auxFunction,
           _,
           _,
           _,
           _,
           a_e2,
           a_e1,
           a_preExp,
           a_varDecls )
      equation
        (l_tmpStr, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_metatype", a_varDecls);
        a_preExp = Tpl.writeText(a_preExp, l_tmpStr);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = stringAppend("));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(","));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tmpStr);
      then (txt, a_auxFunction, a_preExp, a_varDecls);

    case ( txt,
           DAE.ADD(ty = _),
           a_auxFunction,
           _,
           _,
           _,
           _,
           a_e2,
           a_e1,
           a_preExp,
           a_varDecls )
      equation
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" + "));
        txt = Tpl.writeText(txt, a_e2);
      then (txt, a_auxFunction, a_preExp, a_varDecls);

    case ( txt,
           DAE.SUB(ty = _),
           a_auxFunction,
           _,
           _,
           _,
           a_exp2,
           a_e2,
           a_e1,
           a_preExp,
           a_varDecls )
      equation
        ret_1 = Expression.isAtomic(a_exp2);
        txt = fun_819(txt, ret_1, a_e2, a_e1);
      then (txt, a_auxFunction, a_preExp, a_varDecls);

    case ( txt,
           DAE.MUL(ty = _),
           a_auxFunction,
           _,
           _,
           _,
           _,
           a_e2,
           a_e1,
           a_preExp,
           a_varDecls )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") * ("));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_auxFunction, a_preExp, a_varDecls);

    case ( txt,
           DAE.DIV(ty = i_ty),
           a_auxFunction,
           _,
           a_exp,
           a_context,
           a_exp2,
           a_e2,
           a_e1,
           a_preExp,
           a_varDecls )
      equation
        (txt, a_preExp, a_varDecls) = fun_821(txt, a_context, a_exp2, a_e1, a_exp, a_e2, a_preExp, a_varDecls, i_ty);
      then (txt, a_auxFunction, a_preExp, a_varDecls);

    case ( txt,
           DAE.POW(ty = _),
           a_auxFunction,
           a_exp1,
           _,
           a_context,
           a_exp2,
           a_e2,
           a_e1,
           a_preExp,
           a_varDecls )
      equation
        ret_2 = Expression.isHalf(a_exp2);
        (txt, a_preExp, a_varDecls) = fun_825(txt, ret_2, a_context, a_exp1, a_e2, a_e1, a_preExp, a_varDecls, a_exp2);
      then (txt, a_auxFunction, a_preExp, a_varDecls);

    case ( txt,
           DAE.UMINUS(ty = _),
           a_auxFunction,
           _,
           a_exp,
           a_context,
           _,
           _,
           _,
           a_preExp,
           a_varDecls )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExpUnary(txt, a_exp, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_preExp, a_varDecls);

    case ( txt,
           DAE.ADD_ARR(ty = i_ty),
           a_auxFunction,
           _,
           _,
           _,
           _,
           a_e2,
           a_e1,
           a_preExp,
           a_varDecls )
      equation
        l_type = fun_826(Tpl.emptyTxt, i_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("add_alloc_"));
        txt = Tpl.writeText(txt, l_type);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_auxFunction, a_preExp, a_varDecls);

    case ( txt,
           DAE.SUB_ARR(ty = i_ty),
           a_auxFunction,
           _,
           _,
           _,
           _,
           a_e2,
           a_e1,
           a_preExp,
           a_varDecls )
      equation
        l_type = fun_827(Tpl.emptyTxt, i_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("sub_alloc_"));
        txt = Tpl.writeText(txt, l_type);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_auxFunction, a_preExp, a_varDecls);

    case ( txt,
           DAE.MUL_ARR(ty = i_ty),
           a_auxFunction,
           _,
           _,
           _,
           _,
           a_e2,
           a_e1,
           a_preExp,
           a_varDecls )
      equation
        l_type = fun_828(Tpl.emptyTxt, i_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("mul_alloc_"));
        txt = Tpl.writeText(txt, l_type);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_auxFunction, a_preExp, a_varDecls);

    case ( txt,
           DAE.DIV_ARR(ty = i_ty),
           a_auxFunction,
           _,
           _,
           _,
           _,
           a_e2,
           a_e1,
           a_preExp,
           a_varDecls )
      equation
        l_type = fun_829(Tpl.emptyTxt, i_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("div_alloc_"));
        txt = Tpl.writeText(txt, l_type);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_auxFunction, a_preExp, a_varDecls);

    case ( txt,
           DAE.MUL_ARRAY_SCALAR(ty = i_ty),
           a_auxFunction,
           a_exp1,
           _,
           _,
           _,
           a_e2,
           a_e1,
           a_preExp,
           a_varDecls )
      equation
        l_type = fun_830(Tpl.emptyTxt, i_ty);
        ret_4 = Expression.typeof(a_exp1);
        ret_5 = Expression.isArrayType(ret_4);
        txt = fun_831(txt, ret_5, a_e1, a_e2, l_type);
      then (txt, a_auxFunction, a_preExp, a_varDecls);

    case ( txt,
           DAE.ADD_ARRAY_SCALAR(ty = i_ty),
           a_auxFunction,
           a_exp1,
           _,
           _,
           _,
           a_e2,
           a_e1,
           a_preExp,
           a_varDecls )
      equation
        l_type = fun_832(Tpl.emptyTxt, i_ty);
        ret_6 = Expression.typeof(a_exp1);
        ret_7 = Expression.isArrayType(ret_6);
        txt = fun_833(txt, ret_7, a_e1, a_e2, l_type);
      then (txt, a_auxFunction, a_preExp, a_varDecls);

    case ( txt,
           DAE.SUB_SCALAR_ARRAY(ty = i_ty),
           a_auxFunction,
           _,
           _,
           _,
           _,
           a_e2,
           a_e1,
           a_preExp,
           a_varDecls )
      equation
        l_type = fun_834(Tpl.emptyTxt, i_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("sub_alloc_scalar_"));
        txt = Tpl.writeText(txt, l_type);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_auxFunction, a_preExp, a_varDecls);

    case ( txt,
           DAE.MUL_SCALAR_PRODUCT(ty = i_ty),
           a_auxFunction,
           _,
           _,
           _,
           _,
           a_e2,
           a_e1,
           a_preExp,
           a_varDecls )
      equation
        l_type = fun_835(Tpl.emptyTxt, i_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("mul_"));
        txt = Tpl.writeText(txt, l_type);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_product("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_auxFunction, a_preExp, a_varDecls);

    case ( txt,
           DAE.MUL_MATRIX_PRODUCT(ty = i_ty),
           a_auxFunction,
           _,
           _,
           _,
           _,
           a_e2,
           a_e1,
           a_preExp,
           a_varDecls )
      equation
        l_typeShort = fun_836(Tpl.emptyTxt, i_ty);
        l_type = Tpl.writeText(Tpl.emptyTxt, l_typeShort);
        l_type = Tpl.writeTok(l_type, Tpl.ST_STRING("_array"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("mul_alloc_"));
        txt = Tpl.writeText(txt, l_typeShort);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_matrix_product_smart("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_auxFunction, a_preExp, a_varDecls);

    case ( txt,
           DAE.DIV_ARRAY_SCALAR(ty = i_ty),
           a_auxFunction,
           _,
           _,
           a_context,
           a_exp2,
           a_e2,
           a_e1,
           a_preExp,
           a_varDecls )
      equation
        l_type = fun_837(Tpl.emptyTxt, i_ty);
        txt_10 = ExpressionDumpTpl.dumpExp(Tpl.emptyTxt, a_exp2, "\"");
        ret_11 = Util.escapeModelicaStringToCString(Tpl.textString(txt_10));
        l_e2str = Tpl.writeStr(Tpl.emptyTxt, ret_11);
        txt = fun_838(txt, a_context, l_e2str, a_e2, a_e1, l_type);
      then (txt, a_auxFunction, a_preExp, a_varDecls);

    case ( txt,
           DAE.DIV_SCALAR_ARRAY(ty = i_ty),
           a_auxFunction,
           _,
           _,
           _,
           _,
           a_e2,
           a_e1,
           a_preExp,
           a_varDecls )
      equation
        l_type = fun_839(Tpl.emptyTxt, i_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("div_alloc_scalar_"));
        txt = Tpl.writeText(txt, l_type);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_auxFunction, a_preExp, a_varDecls);

    case ( txt,
           DAE.POW_ARRAY_SCALAR(ty = i_ty),
           a_auxFunction,
           _,
           _,
           _,
           _,
           a_e2,
           a_e1,
           a_preExp,
           a_varDecls )
      equation
        l_type = fun_840(Tpl.emptyTxt, i_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("pow_alloc_"));
        txt = Tpl.writeText(txt, l_type);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_scalar("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_auxFunction, a_preExp, a_varDecls);

    case ( txt,
           DAE.POW_ARRAY_SCALAR(ty = _),
           a_auxFunction,
           _,
           _,
           _,
           _,
           _,
           _,
           a_preExp,
           a_varDecls )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("daeExpBinary:ERR for POW_ARRAY_SCALAR"));
      then (txt, a_auxFunction, a_preExp, a_varDecls);

    case ( txt,
           DAE.POW_SCALAR_ARRAY(ty = _),
           a_auxFunction,
           _,
           _,
           _,
           _,
           _,
           _,
           a_preExp,
           a_varDecls )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("daeExpBinary:ERR for POW_SCALAR_ARRAY"));
      then (txt, a_auxFunction, a_preExp, a_varDecls);

    case ( txt,
           DAE.POW_ARR(ty = _),
           a_auxFunction,
           _,
           _,
           _,
           _,
           _,
           _,
           a_preExp,
           a_varDecls )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("daeExpBinary:ERR for POW_ARR"));
      then (txt, a_auxFunction, a_preExp, a_varDecls);

    case ( txt,
           DAE.POW_ARR2(ty = _),
           a_auxFunction,
           _,
           _,
           _,
           _,
           _,
           _,
           a_preExp,
           a_varDecls )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("daeExpBinary:ERR for POW_ARR2"));
      then (txt, a_auxFunction, a_preExp, a_varDecls);

    case ( txt,
           _,
           a_auxFunction,
           _,
           _,
           _,
           _,
           _,
           _,
           a_preExp,
           a_varDecls )
      equation
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 5663, 14), "daeExpBinary:ERR");
      then (txt, a_auxFunction, a_preExp, a_varDecls);
  end match;
end fun_841;

public function daeExpBinary
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_exp, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Exp i_exp;
      DAE.Operator i_operator;
      DAE.Exp i_exp2;
      DAE.Exp i_exp1;
      Tpl.Text l_e2;
      Tpl.Text l_e1;

    case ( txt,
           (i_exp as DAE.BINARY(exp1 = i_exp1, exp2 = i_exp2, operator = i_operator)),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_e1, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_exp1, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_e2, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_exp2, a_context, a_preExp, a_varDecls, a_auxFunction);
        (txt, a_auxFunction, a_preExp, a_varDecls) = fun_841(txt, i_operator, a_auxFunction, i_exp1, i_exp, a_context, i_exp2, l_e2, l_e1, a_preExp, a_varDecls);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end daeExpBinary;

protected function fun_843
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_e;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_e)
    local
      Tpl.Text txt;
      Tpl.Text a_e;

    case ( txt,
           false,
           a_e )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(-("));
        txt = Tpl.writeText(txt, a_e);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("))"));
      then txt;

    case ( txt,
           _,
           a_e )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(-"));
        txt = Tpl.writeText(txt, a_e);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;
  end match;
end fun_843;

protected function fun_844
  input Tpl.Text in_txt;
  input DAE.Operator in_a_operator;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_e;
  input DAE.Exp in_a_exp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls) :=
  match(in_txt, in_a_operator, in_a_preExp, in_a_varDecls, in_a_e, in_a_exp)
    local
      Tpl.Text txt;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_e;
      DAE.Exp a_exp;
      Tpl.Text l_var;
      Boolean ret_0;

    case ( txt,
           DAE.UMINUS(ty = _),
           a_preExp,
           a_varDecls,
           a_e,
           a_exp )
      equation
        ret_0 = Expression.isAtomic(a_exp);
        txt = fun_843(txt, ret_0, a_e);
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.UMINUS_ARR(ty = DAE.T_ARRAY(ty = DAE.T_REAL(varLst = _))),
           a_preExp,
           a_varDecls,
           a_e,
           _ )
      equation
        (l_var, a_varDecls) = tempDecl(Tpl.emptyTxt, "real_array", a_varDecls);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("usub_alloc_real_array("));
        a_preExp = Tpl.writeText(a_preExp, a_e);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(",&"));
        a_preExp = Tpl.writeText(a_preExp, l_var);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_var);
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.UMINUS_ARR(ty = DAE.T_ARRAY(ty = DAE.T_INTEGER(varLst = _))),
           a_preExp,
           a_varDecls,
           a_e,
           _ )
      equation
        (l_var, a_varDecls) = tempDecl(Tpl.emptyTxt, "integer_array", a_varDecls);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("usub_alloc_integer_array("));
        a_preExp = Tpl.writeText(a_preExp, a_e);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(",&"));
        a_preExp = Tpl.writeText(a_preExp, l_var);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_var);
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.UMINUS_ARR(ty = _),
           a_preExp,
           a_varDecls,
           _,
           _ )
      equation
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 5687, 34), "unary minus for non-real arrays not implemented");
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           _,
           a_preExp,
           a_varDecls,
           _,
           _ )
      equation
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 5688, 14), "daeExpUnary:ERR");
      then (txt, a_preExp, a_varDecls);
  end match;
end fun_844;

public function daeExpUnary
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_exp, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Operator i_operator;
      DAE.Exp i_exp;
      Tpl.Text l_e;

    case ( txt,
           DAE.UNARY(exp = i_exp, operator = i_operator),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_e, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_exp, a_context, a_preExp, a_varDecls, a_auxFunction);
        (txt, a_preExp, a_varDecls) = fun_844(txt, i_operator, a_preExp, a_varDecls, l_e, i_exp);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end daeExpUnary;

protected function fun_846
  input Tpl.Text in_txt;
  input DAE.Operator in_a_operator;
  input Tpl.Text in_a_e2;
  input Tpl.Text in_a_e1;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls) :=
  match(in_txt, in_a_operator, in_a_e2, in_a_e1, in_a_preExp, in_a_varDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_e2;
      Tpl.Text a_e1;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text l_var;

    case ( txt,
           DAE.AND(ty = DAE.T_ARRAY(ty = _)),
           a_e2,
           a_e1,
           a_preExp,
           a_varDecls )
      equation
        (l_var, a_varDecls) = tempDecl(Tpl.emptyTxt, "boolean_array", a_varDecls);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("and_boolean_array(&"));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(",&"));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(",&"));
        a_preExp = Tpl.writeText(a_preExp, l_var);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_var);
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.AND(ty = _),
           a_e2,
           a_e1,
           a_preExp,
           a_varDecls )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" && "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.OR(ty = DAE.T_ARRAY(ty = _)),
           a_e2,
           a_e1,
           a_preExp,
           a_varDecls )
      equation
        (l_var, a_varDecls) = tempDecl(Tpl.emptyTxt, "boolean_array", a_varDecls);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("or_boolean_array(&"));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(",&"));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(",&"));
        a_preExp = Tpl.writeText(a_preExp, l_var);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_var);
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.OR(ty = _),
           a_e2,
           a_e1,
           a_preExp,
           a_varDecls )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" || "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           _,
           _,
           _,
           a_preExp,
           a_varDecls )
      equation
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 5713, 14), "daeExpLbinary:ERR");
      then (txt, a_preExp, a_varDecls);
  end match;
end fun_846;

public function daeExpLbinary
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_exp, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Operator i_operator;
      DAE.Exp i_exp2;
      DAE.Exp i_exp1;
      Tpl.Text l_e2;
      Tpl.Text l_e1;

    case ( txt,
           DAE.LBINARY(exp1 = i_exp1, exp2 = i_exp2, operator = i_operator),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_e1, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_exp1, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_e2, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_exp2, a_context, a_preExp, a_varDecls, a_auxFunction);
        (txt, a_preExp, a_varDecls) = fun_846(txt, i_operator, l_e2, l_e1, a_preExp, a_varDecls);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end daeExpLbinary;

protected function fun_848
  input Tpl.Text in_txt;
  input DAE.Operator in_a_operator;
  input Tpl.Text in_a_e;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls) :=
  match(in_txt, in_a_operator, in_a_e, in_a_preExp, in_a_varDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_e;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text l_var;

    case ( txt,
           DAE.NOT(ty = DAE.T_ARRAY(ty = _)),
           a_e,
           a_preExp,
           a_varDecls )
      equation
        (l_var, a_varDecls) = tempDecl(Tpl.emptyTxt, "boolean_array", a_varDecls);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("not_boolean_array("));
        a_preExp = Tpl.writeText(a_preExp, a_e);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(",&"));
        a_preExp = Tpl.writeText(a_preExp, l_var);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_var);
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           _,
           a_e,
           a_preExp,
           a_varDecls )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(!"));
        txt = Tpl.writeText(txt, a_e);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls);
  end match;
end fun_848;

public function daeExpLunary
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_exp, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Operator i_operator;
      DAE.Exp i_exp;
      Tpl.Text l_e;

    case ( txt,
           DAE.LUNARY(exp = i_exp, operator = i_operator),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_e, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_exp, a_context, a_preExp, a_varDecls, a_auxFunction);
        (txt, a_preExp, a_varDecls) = fun_848(txt, i_operator, l_e, a_preExp, a_varDecls);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end daeExpLunary;

protected function fun_850
  input Tpl.Text in_txt;
  input DAE.Operator in_a_rel_operator;
  input DAE.Exp in_a_exp;
  input Tpl.Text in_a_e2;
  input Tpl.Text in_a_e1;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_rel_operator, in_a_exp, in_a_e2, in_a_e1)
    local
      Tpl.Text txt;
      DAE.Exp a_exp;
      Tpl.Text a_e2;
      Tpl.Text a_e1;
      Tpl.Text txt_0;

    case ( txt,
           DAE.LESS(ty = DAE.T_BOOL(varLst = _)),
           _,
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(!"));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" && "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.LESS(ty = DAE.T_STRING(varLst = _)),
           _,
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(stringCompare("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") < 0)"));
      then txt;

    case ( txt,
           DAE.LESS(ty = DAE.T_INTEGER(varLst = _)),
           _,
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" < "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.LESS(ty = DAE.T_REAL(varLst = _)),
           _,
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" < "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.LESS(ty = DAE.T_ENUMERATION(index = _)),
           _,
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" < "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.GREATER(ty = DAE.T_BOOL(varLst = _)),
           _,
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" && !"));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.GREATER(ty = DAE.T_STRING(varLst = _)),
           _,
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(stringCompare("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") > 0)"));
      then txt;

    case ( txt,
           DAE.GREATER(ty = DAE.T_INTEGER(varLst = _)),
           _,
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" > "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.GREATER(ty = DAE.T_REAL(varLst = _)),
           _,
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" > "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.GREATER(ty = DAE.T_ENUMERATION(index = _)),
           _,
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" > "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.LESSEQ(ty = DAE.T_BOOL(varLst = _)),
           _,
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(!"));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" || "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.LESSEQ(ty = DAE.T_STRING(varLst = _)),
           _,
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(stringCompare("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") <= 0)"));
      then txt;

    case ( txt,
           DAE.LESSEQ(ty = DAE.T_INTEGER(varLst = _)),
           _,
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" <= "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.LESSEQ(ty = DAE.T_REAL(varLst = _)),
           _,
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" <= "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.LESSEQ(ty = DAE.T_ENUMERATION(index = _)),
           _,
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" <= "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.GREATEREQ(ty = DAE.T_BOOL(varLst = _)),
           _,
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" || !"));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.GREATEREQ(ty = DAE.T_STRING(varLst = _)),
           _,
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(stringCompare("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") >= 0)"));
      then txt;

    case ( txt,
           DAE.GREATEREQ(ty = DAE.T_INTEGER(varLst = _)),
           _,
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" >= "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.GREATEREQ(ty = DAE.T_REAL(varLst = _)),
           _,
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" >= "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.GREATEREQ(ty = DAE.T_ENUMERATION(index = _)),
           _,
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" >= "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.EQUAL(ty = DAE.T_BOOL(varLst = _)),
           _,
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("((!"));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" && !"));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") || ("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" && "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("))"));
      then txt;

    case ( txt,
           DAE.EQUAL(ty = DAE.T_STRING(varLst = _)),
           _,
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(stringEqual("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("))"));
      then txt;

    case ( txt,
           DAE.EQUAL(ty = DAE.T_INTEGER(varLst = _)),
           _,
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" == "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.EQUAL(ty = DAE.T_REAL(varLst = _)),
           _,
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" == "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.EQUAL(ty = DAE.T_ENUMERATION(index = _)),
           _,
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" == "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.EQUAL(ty = DAE.T_ARRAY(ty = _)),
           _,
           a_e2,
           _ )
      equation
        txt = Tpl.writeText(txt, a_e2);
      then txt;

    case ( txt,
           DAE.NEQUAL(ty = DAE.T_BOOL(varLst = _)),
           _,
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("((!"));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" && "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") || ("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" && !"));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("))"));
      then txt;

    case ( txt,
           DAE.NEQUAL(ty = DAE.T_STRING(varLst = _)),
           _,
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(!stringEqual("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("))"));
      then txt;

    case ( txt,
           DAE.NEQUAL(ty = DAE.T_INTEGER(varLst = _)),
           _,
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" != "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.NEQUAL(ty = DAE.T_REAL(varLst = _)),
           _,
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" != "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.NEQUAL(ty = DAE.T_ENUMERATION(index = _)),
           _,
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" != "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           _,
           a_exp,
           _,
           _ )
      equation
        txt_0 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("daeExpRelation "));
        txt_0 = ExpressionDumpTpl.dumpExp(txt_0, a_exp, "\"");
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 5790, 16), Tpl.textString(txt_0));
      then txt;
  end match;
end fun_850;

protected function fun_851
  input Tpl.Text in_txt;
  input Tpl.Text in_a_simRel;
  input Tpl.Text in_a_preExp2;
  input Tpl.Text in_a_varDecls2;
  input DAE.Exp in_a_exp;
  input DAE.Operator in_a_rel_operator;
  input DAE.Exp in_a_rel_exp2;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;
  input DAE.Exp in_a_rel_exp1;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_a_simRel, in_a_preExp2, in_a_varDecls2, in_a_exp, in_a_rel_operator, in_a_rel_exp2, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context, in_a_rel_exp1)
    local
      Tpl.Text txt;
      Tpl.Text a_preExp2;
      Tpl.Text a_varDecls2;
      DAE.Exp a_exp;
      DAE.Operator a_rel_operator;
      DAE.Exp a_rel_exp2;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Exp a_rel_exp1;
      Tpl.Text i_simRel;
      Tpl.Text l_e2;
      Tpl.Text l_e1;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           _,
           _,
           a_exp,
           a_rel_operator,
           a_rel_exp2,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context,
           a_rel_exp1 )
      equation
        (l_e1, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, a_rel_exp1, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_e2, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, a_rel_exp2, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = fun_850(txt, a_rel_operator, a_exp, l_e2, l_e1);
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           i_simRel,
           a_preExp2,
           a_varDecls2,
           _,
           _,
           _,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _,
           _ )
      equation
        a_varDecls = Tpl.writeText(a_varDecls, a_varDecls2);
        a_preExp = Tpl.writeText(a_preExp, a_preExp2);
        txt = Tpl.writeText(txt, i_simRel);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end fun_851;

public function daeExpRelation
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_exp, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Operator i_rel_operator;
      DAE.Exp i_rel_exp2;
      DAE.Exp i_rel_exp1;
      DAE.Exp i_rel;
      Tpl.Text l_simRel;
      Tpl.Text l_preExp2;
      Tpl.Text l_varDecls2;

    case ( txt,
           (i_rel as DAE.RELATION(exp1 = i_rel_exp1, exp2 = i_rel_exp2, operator = i_rel_operator)),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        l_varDecls2 = Tpl.emptyTxt;
        l_preExp2 = Tpl.emptyTxt;
        (l_simRel, l_preExp2, l_varDecls2, a_auxFunction) = daeExpRelationSim(Tpl.emptyTxt, i_rel, a_context, l_preExp2, l_varDecls2, a_auxFunction);
        (txt, a_auxFunction, a_varDecls, a_preExp) = fun_851(txt, l_simRel, l_preExp2, l_varDecls2, i_rel, i_rel_operator, i_rel_exp2, a_auxFunction, a_varDecls, a_preExp, a_context, i_rel_exp1);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end daeExpRelation;

protected function fun_853
  input Tpl.Text in_txt;
  input DAE.Operator in_a_rel_operator;
  input Tpl.Text in_a_e2;
  input Tpl.Text in_a_e1;
  input Tpl.Text in_a_res;
  input Tpl.Text in_a_preExp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_preExp) :=
  match(in_txt, in_a_rel_operator, in_a_e2, in_a_e1, in_a_res, in_a_preExp)
    local
      Tpl.Text txt;
      Tpl.Text a_e2;
      Tpl.Text a_e1;
      Tpl.Text a_res;
      Tpl.Text a_preExp;

    case ( txt,
           DAE.LESS(ty = _),
           a_e2,
           a_e1,
           a_res,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = "));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" < "));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(";"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
      then (txt, a_preExp);

    case ( txt,
           DAE.LESSEQ(ty = _),
           a_e2,
           a_e1,
           a_res,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = "));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" <= "));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(";"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
      then (txt, a_preExp);

    case ( txt,
           DAE.GREATER(ty = _),
           a_e2,
           a_e1,
           a_res,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = "));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" > "));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(";"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
      then (txt, a_preExp);

    case ( txt,
           DAE.GREATEREQ(ty = _),
           a_e2,
           a_e1,
           a_res,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = "));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" >= "));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(";"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
      then (txt, a_preExp);

    case ( txt,
           _,
           _,
           _,
           _,
           a_preExp )
      then (txt, a_preExp);
  end match;
end fun_853;

protected function fun_854
  input Tpl.Text in_txt;
  input String in_mArg;
  input Integer in_a_rel_index;
  input Tpl.Text in_a_res;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_rel_index, in_a_res)
    local
      Tpl.Text txt;
      Integer a_rel_index;
      Tpl.Text a_res;

    case ( txt,
           "omsic",
           a_rel_index,
           a_res )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("omsi_function_zero_crossings(this_function, "));
        txt = Tpl.writeText(txt, a_res);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeStr(txt, intString(a_rel_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", omsic_get_model_state())"));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_854;

protected function fun_855
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_rel_index;
  input Tpl.Text in_a_res;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_rel_index, in_a_res)
    local
      Tpl.Text txt;
      Integer a_rel_index;
      Tpl.Text a_res;
      String ret_0;

    case ( txt,
           false,
           a_rel_index,
           a_res )
      equation
        ret_0 = Config.simCodeTarget();
        txt = fun_854(txt, ret_0, a_rel_index, a_res);
      then txt;

    case ( txt,
           _,
           _,
           a_res )
      equation
        txt = Tpl.writeText(txt, a_res);
      then txt;
  end match;
end fun_855;

protected function fun_856
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("true"));
      then txt;
  end match;
end fun_856;

protected function fun_857
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input DAE.Exp in_a_rel_exp2;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_rel_exp2)
    local
      Tpl.Text txt;
      DAE.Exp a_rel_exp2;
      Boolean ret_1;
      DAE.Type ret_0;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_rel_exp2 )
      equation
        ret_0 = Expression.typeof(a_rel_exp2);
        ret_1 = Expression.isRealType(ret_0);
        txt = fun_856(txt, ret_1);
      then txt;
  end match;
end fun_857;

protected function fun_858
  input Tpl.Text in_txt;
  input Tpl.Text in_a_isReal;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_isReal)
    local
      Tpl.Text txt;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("RELATION"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("RELATIONHYSTERESIS"));
      then txt;
  end match;
end fun_858;

protected function fun_859
  input Tpl.Text in_txt;
  input DAE.Operator in_a_rel_operator;
  input Integer in_a_rel_index;
  input Tpl.Text in_a_e2;
  input Tpl.Text in_a_e1;
  input Tpl.Text in_a_res;
  input Tpl.Text in_a_hysteresisfunction;
  input Tpl.Text in_a_preExp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_preExp) :=
  match(in_txt, in_a_rel_operator, in_a_rel_index, in_a_e2, in_a_e1, in_a_res, in_a_hysteresisfunction, in_a_preExp)
    local
      Tpl.Text txt;
      Integer a_rel_index;
      Tpl.Text a_e2;
      Tpl.Text a_e1;
      Tpl.Text a_res;
      Tpl.Text a_hysteresisfunction;
      Tpl.Text a_preExp;

    case ( txt,
           DAE.LESS(ty = _),
           a_rel_index,
           a_e2,
           a_e1,
           a_res,
           a_hysteresisfunction,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_hysteresisfunction);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("("));
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeStr(a_preExp, intString(a_rel_index));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", Less);"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           DAE.LESSEQ(ty = _),
           a_rel_index,
           a_e2,
           a_e1,
           a_res,
           a_hysteresisfunction,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_hysteresisfunction);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("("));
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeStr(a_preExp, intString(a_rel_index));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", LessEq);"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           DAE.GREATER(ty = _),
           a_rel_index,
           a_e2,
           a_e1,
           a_res,
           a_hysteresisfunction,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_hysteresisfunction);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("("));
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeStr(a_preExp, intString(a_rel_index));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", Greater);"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           DAE.GREATEREQ(ty = _),
           a_rel_index,
           a_e2,
           a_e1,
           a_res,
           a_hysteresisfunction,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_hysteresisfunction);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("("));
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeStr(a_preExp, intString(a_rel_index));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", GreaterEq);"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           _,
           _,
           _,
           _,
           _,
           _,
           a_preExp )
      then (txt, a_preExp);
  end match;
end fun_859;

protected function fun_860
  input Tpl.Text in_txt;
  input DAE.Operator in_a_rel_operator;
  input Tpl.Text in_a_e2;
  input Tpl.Text in_a_e1;
  input Tpl.Text in_a_res;
  input Tpl.Text in_a_preExp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_preExp) :=
  match(in_txt, in_a_rel_operator, in_a_e2, in_a_e1, in_a_res, in_a_preExp)
    local
      Tpl.Text txt;
      Tpl.Text a_e2;
      Tpl.Text a_e1;
      Tpl.Text a_res;
      Tpl.Text a_preExp;

    case ( txt,
           DAE.LESS(ty = _),
           a_e2,
           a_e1,
           a_res,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = Less("));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(","));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           DAE.LESSEQ(ty = _),
           a_e2,
           a_e1,
           a_res,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = LessEq("));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(","));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           DAE.GREATER(ty = _),
           a_e2,
           a_e1,
           a_res,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = Greater("));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(","));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           DAE.GREATEREQ(ty = _),
           a_e2,
           a_e1,
           a_res,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = GreaterEq("));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(","));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           _,
           _,
           _,
           _,
           a_preExp )
      then (txt, a_preExp);
  end match;
end fun_860;

protected function fun_861
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_rel_index;
  input Tpl.Text in_a_e2;
  input Tpl.Text in_a_e1;
  input Tpl.Text in_a_res;
  input Tpl.Text in_a_preExp;
  input DAE.Operator in_a_rel_operator;
  input DAE.Exp in_a_rel_exp2;
  input DAE.Exp in_a_rel_exp1;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_preExp) :=
  match(in_txt, in_mArg, in_a_rel_index, in_a_e2, in_a_e1, in_a_res, in_a_preExp, in_a_rel_operator, in_a_rel_exp2, in_a_rel_exp1)
    local
      Tpl.Text txt;
      Integer a_rel_index;
      Tpl.Text a_e2;
      Tpl.Text a_e1;
      Tpl.Text a_res;
      Tpl.Text a_preExp;
      DAE.Operator a_rel_operator;
      DAE.Exp a_rel_exp2;
      DAE.Exp a_rel_exp1;
      Tpl.Text l_hysteresisfunction;
      Boolean ret_2;
      DAE.Type ret_1;
      Tpl.Text l_isReal;

    case ( txt,
           false,
           a_rel_index,
           a_e2,
           a_e1,
           a_res,
           a_preExp,
           a_rel_operator,
           a_rel_exp2,
           a_rel_exp1 )
      equation
        ret_1 = Expression.typeof(a_rel_exp1);
        ret_2 = Expression.isRealType(ret_1);
        l_isReal = fun_857(Tpl.emptyTxt, ret_2, a_rel_exp2);
        l_hysteresisfunction = fun_858(Tpl.emptyTxt, l_isReal);
        (txt, a_preExp) = fun_859(txt, a_rel_operator, a_rel_index, a_e2, a_e1, a_res, l_hysteresisfunction, a_preExp);
      then (txt, a_preExp);

    case ( txt,
           _,
           _,
           a_e2,
           a_e1,
           a_res,
           a_preExp,
           a_rel_operator,
           _,
           _ )
      equation
        (txt, a_preExp) = fun_860(txt, a_rel_operator, a_e2, a_e1, a_res, a_preExp);
      then (txt, a_preExp);
  end match;
end fun_861;

protected function fun_862
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("true"));
      then txt;
  end match;
end fun_862;

protected function fun_863
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input DAE.Exp in_a_rel_exp2;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_rel_exp2)
    local
      Tpl.Text txt;
      DAE.Exp a_rel_exp2;
      Boolean ret_1;
      DAE.Type ret_0;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_rel_exp2 )
      equation
        ret_0 = Expression.typeof(a_rel_exp2);
        ret_1 = Expression.isRealType(ret_0);
        txt = fun_862(txt, ret_1);
      then txt;
  end match;
end fun_863;

protected function fun_864
  input Tpl.Text in_txt;
  input Tpl.Text in_a_isReal;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_isReal)
    local
      Tpl.Text txt;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("RELATION"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("RELATIONHYSTERESIS"));
      then txt;
  end match;
end fun_864;

protected function fun_865
  input Tpl.Text in_txt;
  input DAE.Operator in_a_rel_operator;
  input Integer in_a_j;
  input Integer in_a_i;
  input Tpl.Text in_a_iterator;
  input Integer in_a_rel_index;
  input Tpl.Text in_a_e2;
  input Tpl.Text in_a_e1;
  input Tpl.Text in_a_res;
  input Tpl.Text in_a_hysteresisfunction;
  input Tpl.Text in_a_preExp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_preExp) :=
  match(in_txt, in_a_rel_operator, in_a_j, in_a_i, in_a_iterator, in_a_rel_index, in_a_e2, in_a_e1, in_a_res, in_a_hysteresisfunction, in_a_preExp)
    local
      Tpl.Text txt;
      Integer a_j;
      Integer a_i;
      Tpl.Text a_iterator;
      Integer a_rel_index;
      Tpl.Text a_e2;
      Tpl.Text a_e1;
      Tpl.Text a_res;
      Tpl.Text a_hysteresisfunction;
      Tpl.Text a_preExp;

    case ( txt,
           DAE.LESS(ty = _),
           a_j,
           a_i,
           a_iterator,
           a_rel_index,
           a_e2,
           a_e1,
           a_res,
           a_hysteresisfunction,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_hysteresisfunction);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("("));
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeStr(a_preExp, intString(a_rel_index));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" + ("));
        a_preExp = Tpl.writeText(a_preExp, a_iterator);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" - "));
        a_preExp = Tpl.writeStr(a_preExp, intString(a_i));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(")/"));
        a_preExp = Tpl.writeStr(a_preExp, intString(a_j));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", Less);"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           DAE.LESSEQ(ty = _),
           a_j,
           a_i,
           a_iterator,
           a_rel_index,
           a_e2,
           a_e1,
           a_res,
           a_hysteresisfunction,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_hysteresisfunction);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("("));
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeStr(a_preExp, intString(a_rel_index));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" + ("));
        a_preExp = Tpl.writeText(a_preExp, a_iterator);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" - "));
        a_preExp = Tpl.writeStr(a_preExp, intString(a_i));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(")/"));
        a_preExp = Tpl.writeStr(a_preExp, intString(a_j));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", LessEq);"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           DAE.GREATER(ty = _),
           a_j,
           a_i,
           a_iterator,
           a_rel_index,
           a_e2,
           a_e1,
           a_res,
           a_hysteresisfunction,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_hysteresisfunction);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("("));
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeStr(a_preExp, intString(a_rel_index));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" + ("));
        a_preExp = Tpl.writeText(a_preExp, a_iterator);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" - "));
        a_preExp = Tpl.writeStr(a_preExp, intString(a_i));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(")/"));
        a_preExp = Tpl.writeStr(a_preExp, intString(a_j));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", Greater);"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           DAE.GREATEREQ(ty = _),
           a_j,
           a_i,
           a_iterator,
           a_rel_index,
           a_e2,
           a_e1,
           a_res,
           a_hysteresisfunction,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_hysteresisfunction);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("("));
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeStr(a_preExp, intString(a_rel_index));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" + ("));
        a_preExp = Tpl.writeText(a_preExp, a_iterator);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" - "));
        a_preExp = Tpl.writeStr(a_preExp, intString(a_i));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(")/"));
        a_preExp = Tpl.writeStr(a_preExp, intString(a_j));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", GreaterEq);"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           _,
           _,
           _,
           _,
           _,
           _,
           _,
           _,
           _,
           a_preExp )
      then (txt, a_preExp);
  end match;
end fun_865;

protected function fun_866
  input Tpl.Text in_txt;
  input DAE.Operator in_a_rel_operator;
  input Tpl.Text in_a_e2;
  input Tpl.Text in_a_e1;
  input Tpl.Text in_a_res;
  input Tpl.Text in_a_preExp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_preExp) :=
  match(in_txt, in_a_rel_operator, in_a_e2, in_a_e1, in_a_res, in_a_preExp)
    local
      Tpl.Text txt;
      Tpl.Text a_e2;
      Tpl.Text a_e1;
      Tpl.Text a_res;
      Tpl.Text a_preExp;

    case ( txt,
           DAE.LESS(ty = _),
           a_e2,
           a_e1,
           a_res,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = Less("));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(","));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           DAE.LESSEQ(ty = _),
           a_e2,
           a_e1,
           a_res,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = LessEq("));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(","));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           DAE.GREATER(ty = _),
           a_e2,
           a_e1,
           a_res,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = Greater("));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(","));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           DAE.GREATEREQ(ty = _),
           a_e2,
           a_e1,
           a_res,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = GreaterEq("));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(","));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           _,
           _,
           _,
           _,
           a_preExp )
      then (txt, a_preExp);
  end match;
end fun_866;

protected function fun_867
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_j;
  input Integer in_a_i;
  input Tpl.Text in_a_iterator;
  input Integer in_a_rel_index;
  input Tpl.Text in_a_e2;
  input Tpl.Text in_a_e1;
  input Tpl.Text in_a_res;
  input Tpl.Text in_a_preExp;
  input DAE.Operator in_a_rel_operator;
  input DAE.Exp in_a_rel_exp2;
  input DAE.Exp in_a_rel_exp1;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_preExp) :=
  match(in_txt, in_mArg, in_a_j, in_a_i, in_a_iterator, in_a_rel_index, in_a_e2, in_a_e1, in_a_res, in_a_preExp, in_a_rel_operator, in_a_rel_exp2, in_a_rel_exp1)
    local
      Tpl.Text txt;
      Integer a_j;
      Integer a_i;
      Tpl.Text a_iterator;
      Integer a_rel_index;
      Tpl.Text a_e2;
      Tpl.Text a_e1;
      Tpl.Text a_res;
      Tpl.Text a_preExp;
      DAE.Operator a_rel_operator;
      DAE.Exp a_rel_exp2;
      DAE.Exp a_rel_exp1;
      Tpl.Text l_hysteresisfunction;
      Boolean ret_2;
      DAE.Type ret_1;
      Tpl.Text l_isReal;

    case ( txt,
           false,
           a_j,
           a_i,
           a_iterator,
           a_rel_index,
           a_e2,
           a_e1,
           a_res,
           a_preExp,
           a_rel_operator,
           a_rel_exp2,
           a_rel_exp1 )
      equation
        ret_1 = Expression.typeof(a_rel_exp1);
        ret_2 = Expression.isRealType(ret_1);
        l_isReal = fun_863(Tpl.emptyTxt, ret_2, a_rel_exp2);
        l_hysteresisfunction = fun_864(Tpl.emptyTxt, l_isReal);
        (txt, a_preExp) = fun_865(txt, a_rel_operator, a_j, a_i, a_iterator, a_rel_index, a_e2, a_e1, a_res, l_hysteresisfunction, a_preExp);
      then (txt, a_preExp);

    case ( txt,
           _,
           _,
           _,
           _,
           _,
           a_e2,
           a_e1,
           a_res,
           a_preExp,
           a_rel_operator,
           _,
           _ )
      equation
        (txt, a_preExp) = fun_866(txt, a_rel_operator, a_e2, a_e1, a_res, a_preExp);
      then (txt, a_preExp);
  end match;
end fun_867;

protected function fun_868
  input Tpl.Text in_txt;
  input Option<tuple<DAE.Exp, Integer, Integer>> in_a_rel_optionExpisASUB;
  input DAE.Operator in_a_rel_operator;
  input Integer in_a_rel_index;
  input DAE.Exp in_a_rel_exp2;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;
  input DAE.Exp in_a_rel_exp1;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_a_rel_optionExpisASUB, in_a_rel_operator, in_a_rel_index, in_a_rel_exp2, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context, in_a_rel_exp1)
    local
      Tpl.Text txt;
      DAE.Operator a_rel_operator;
      Integer a_rel_index;
      DAE.Exp a_rel_exp2;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Exp a_rel_exp1;
      Integer i_j;
      Integer i_i;
      DAE.Exp i_exp;
      Boolean ret_5;
      Tpl.Text l_iterator;
      Boolean ret_3;
      Tpl.Text l_res;
      Tpl.Text l_e2;
      Tpl.Text l_e1;

    case ( txt,
           NONE(),
           a_rel_operator,
           a_rel_index,
           a_rel_exp2,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context,
           a_rel_exp1 )
      equation
        (l_e1, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, a_rel_exp1, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_e2, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, a_rel_exp2, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_res, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_boolean", a_varDecls);
        ret_3 = intEq(a_rel_index, -1);
        (txt, a_preExp) = fun_861(txt, ret_3, a_rel_index, l_e2, l_e1, l_res, a_preExp, a_rel_operator, a_rel_exp2, a_rel_exp1);
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           SOME((i_exp, i_i, i_j)),
           a_rel_operator,
           a_rel_index,
           a_rel_exp2,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context,
           a_rel_exp1 )
      equation
        (l_e1, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, a_rel_exp1, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_e2, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, a_rel_exp2, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_iterator, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_exp, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_res, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_boolean", a_varDecls);
        ret_5 = intEq(a_rel_index, -1);
        (txt, a_preExp) = fun_867(txt, ret_5, i_j, i_i, l_iterator, a_rel_index, l_e2, l_e1, l_res, a_preExp, a_rel_operator, a_rel_exp2, a_rel_exp1);
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           _,
           _,
           _,
           _,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end fun_868;

protected function fun_869
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("true"));
      then txt;
  end match;
end fun_869;

protected function fun_870
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input DAE.Exp in_a_rel_exp2;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_rel_exp2)
    local
      Tpl.Text txt;
      DAE.Exp a_rel_exp2;
      Boolean ret_1;
      DAE.Type ret_0;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_rel_exp2 )
      equation
        ret_0 = Expression.typeof(a_rel_exp2);
        ret_1 = Expression.isRealType(ret_0);
        txt = fun_869(txt, ret_1);
      then txt;
  end match;
end fun_870;

protected function fun_871
  input Tpl.Text in_txt;
  input Tpl.Text in_a_isReal;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_isReal)
    local
      Tpl.Text txt;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("RELATION"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("RELATIONHYSTERESIS"));
      then txt;
  end match;
end fun_871;

protected function fun_872
  input Tpl.Text in_txt;
  input DAE.Operator in_a_rel_operator;
  input Integer in_a_rel_index;
  input Tpl.Text in_a_e2;
  input Tpl.Text in_a_e1;
  input Tpl.Text in_a_res;
  input Tpl.Text in_a_hysteresisfunction;
  input Tpl.Text in_a_preExp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_preExp) :=
  match(in_txt, in_a_rel_operator, in_a_rel_index, in_a_e2, in_a_e1, in_a_res, in_a_hysteresisfunction, in_a_preExp)
    local
      Tpl.Text txt;
      Integer a_rel_index;
      Tpl.Text a_e2;
      Tpl.Text a_e1;
      Tpl.Text a_res;
      Tpl.Text a_hysteresisfunction;
      Tpl.Text a_preExp;

    case ( txt,
           DAE.LESS(ty = _),
           a_rel_index,
           a_e2,
           a_e1,
           a_res,
           a_hysteresisfunction,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_hysteresisfunction);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("("));
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeStr(a_preExp, intString(a_rel_index));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", Less);"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           DAE.LESSEQ(ty = _),
           a_rel_index,
           a_e2,
           a_e1,
           a_res,
           a_hysteresisfunction,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_hysteresisfunction);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("("));
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeStr(a_preExp, intString(a_rel_index));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", LessEq);"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           DAE.GREATER(ty = _),
           a_rel_index,
           a_e2,
           a_e1,
           a_res,
           a_hysteresisfunction,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_hysteresisfunction);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("("));
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeStr(a_preExp, intString(a_rel_index));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", Greater);"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           DAE.GREATEREQ(ty = _),
           a_rel_index,
           a_e2,
           a_e1,
           a_res,
           a_hysteresisfunction,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_hysteresisfunction);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("("));
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeStr(a_preExp, intString(a_rel_index));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", GreaterEq);"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           _,
           _,
           _,
           _,
           _,
           _,
           a_preExp )
      then (txt, a_preExp);
  end match;
end fun_872;

protected function fun_873
  input Tpl.Text in_txt;
  input DAE.Operator in_a_rel_operator;
  input Tpl.Text in_a_e2;
  input Tpl.Text in_a_e1;
  input Tpl.Text in_a_res;
  input Tpl.Text in_a_preExp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_preExp) :=
  match(in_txt, in_a_rel_operator, in_a_e2, in_a_e1, in_a_res, in_a_preExp)
    local
      Tpl.Text txt;
      Tpl.Text a_e2;
      Tpl.Text a_e1;
      Tpl.Text a_res;
      Tpl.Text a_preExp;

    case ( txt,
           DAE.LESS(ty = _),
           a_e2,
           a_e1,
           a_res,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = Less("));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(","));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           DAE.LESSEQ(ty = _),
           a_e2,
           a_e1,
           a_res,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = LessEq("));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(","));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           DAE.GREATER(ty = _),
           a_e2,
           a_e1,
           a_res,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = Greater("));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(","));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           DAE.GREATEREQ(ty = _),
           a_e2,
           a_e1,
           a_res,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = GreaterEq("));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(","));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           _,
           _,
           _,
           _,
           a_preExp )
      then (txt, a_preExp);
  end match;
end fun_873;

protected function fun_874
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_rel_index;
  input Tpl.Text in_a_e2;
  input Tpl.Text in_a_e1;
  input Tpl.Text in_a_res;
  input Tpl.Text in_a_preExp;
  input DAE.Operator in_a_rel_operator;
  input DAE.Exp in_a_rel_exp2;
  input DAE.Exp in_a_rel_exp1;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_preExp) :=
  match(in_txt, in_mArg, in_a_rel_index, in_a_e2, in_a_e1, in_a_res, in_a_preExp, in_a_rel_operator, in_a_rel_exp2, in_a_rel_exp1)
    local
      Tpl.Text txt;
      Integer a_rel_index;
      Tpl.Text a_e2;
      Tpl.Text a_e1;
      Tpl.Text a_res;
      Tpl.Text a_preExp;
      DAE.Operator a_rel_operator;
      DAE.Exp a_rel_exp2;
      DAE.Exp a_rel_exp1;
      Tpl.Text l_hysteresisfunction;
      Boolean ret_2;
      DAE.Type ret_1;
      Tpl.Text l_isReal;

    case ( txt,
           false,
           a_rel_index,
           a_e2,
           a_e1,
           a_res,
           a_preExp,
           a_rel_operator,
           a_rel_exp2,
           a_rel_exp1 )
      equation
        ret_1 = Expression.typeof(a_rel_exp1);
        ret_2 = Expression.isRealType(ret_1);
        l_isReal = fun_870(Tpl.emptyTxt, ret_2, a_rel_exp2);
        l_hysteresisfunction = fun_871(Tpl.emptyTxt, l_isReal);
        (txt, a_preExp) = fun_872(txt, a_rel_operator, a_rel_index, a_e2, a_e1, a_res, l_hysteresisfunction, a_preExp);
      then (txt, a_preExp);

    case ( txt,
           _,
           _,
           a_e2,
           a_e1,
           a_res,
           a_preExp,
           a_rel_operator,
           _,
           _ )
      equation
        (txt, a_preExp) = fun_873(txt, a_rel_operator, a_e2, a_e1, a_res, a_preExp);
      then (txt, a_preExp);
  end match;
end fun_874;

protected function fun_875
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("true"));
      then txt;
  end match;
end fun_875;

protected function fun_876
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input DAE.Exp in_a_rel_exp2;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_rel_exp2)
    local
      Tpl.Text txt;
      DAE.Exp a_rel_exp2;
      Boolean ret_1;
      DAE.Type ret_0;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_rel_exp2 )
      equation
        ret_0 = Expression.typeof(a_rel_exp2);
        ret_1 = Expression.isRealType(ret_0);
        txt = fun_875(txt, ret_1);
      then txt;
  end match;
end fun_876;

protected function fun_877
  input Tpl.Text in_txt;
  input Tpl.Text in_a_isReal;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_isReal)
    local
      Tpl.Text txt;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("RELATION"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("RELATIONHYSTERESIS"));
      then txt;
  end match;
end fun_877;

protected function fun_878
  input Tpl.Text in_txt;
  input DAE.Operator in_a_rel_operator;
  input Integer in_a_j;
  input Integer in_a_i;
  input Tpl.Text in_a_iterator;
  input Integer in_a_rel_index;
  input Tpl.Text in_a_e2;
  input Tpl.Text in_a_e1;
  input Tpl.Text in_a_res;
  input Tpl.Text in_a_hysteresisfunction;
  input Tpl.Text in_a_preExp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_preExp) :=
  match(in_txt, in_a_rel_operator, in_a_j, in_a_i, in_a_iterator, in_a_rel_index, in_a_e2, in_a_e1, in_a_res, in_a_hysteresisfunction, in_a_preExp)
    local
      Tpl.Text txt;
      Integer a_j;
      Integer a_i;
      Tpl.Text a_iterator;
      Integer a_rel_index;
      Tpl.Text a_e2;
      Tpl.Text a_e1;
      Tpl.Text a_res;
      Tpl.Text a_hysteresisfunction;
      Tpl.Text a_preExp;

    case ( txt,
           DAE.LESS(ty = _),
           a_j,
           a_i,
           a_iterator,
           a_rel_index,
           a_e2,
           a_e1,
           a_res,
           a_hysteresisfunction,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_hysteresisfunction);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("("));
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeStr(a_preExp, intString(a_rel_index));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" + ("));
        a_preExp = Tpl.writeText(a_preExp, a_iterator);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" - "));
        a_preExp = Tpl.writeStr(a_preExp, intString(a_i));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(")/"));
        a_preExp = Tpl.writeStr(a_preExp, intString(a_j));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", Less);"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           DAE.LESSEQ(ty = _),
           a_j,
           a_i,
           a_iterator,
           a_rel_index,
           a_e2,
           a_e1,
           a_res,
           a_hysteresisfunction,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_hysteresisfunction);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("("));
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeStr(a_preExp, intString(a_rel_index));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" + ("));
        a_preExp = Tpl.writeText(a_preExp, a_iterator);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" - "));
        a_preExp = Tpl.writeStr(a_preExp, intString(a_i));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(")/"));
        a_preExp = Tpl.writeStr(a_preExp, intString(a_j));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", LessEq);"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           DAE.GREATER(ty = _),
           a_j,
           a_i,
           a_iterator,
           a_rel_index,
           a_e2,
           a_e1,
           a_res,
           a_hysteresisfunction,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_hysteresisfunction);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("("));
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeStr(a_preExp, intString(a_rel_index));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" + ("));
        a_preExp = Tpl.writeText(a_preExp, a_iterator);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" - "));
        a_preExp = Tpl.writeStr(a_preExp, intString(a_i));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(")/"));
        a_preExp = Tpl.writeStr(a_preExp, intString(a_j));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", Greater);"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           DAE.GREATEREQ(ty = _),
           a_j,
           a_i,
           a_iterator,
           a_rel_index,
           a_e2,
           a_e1,
           a_res,
           a_hysteresisfunction,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_hysteresisfunction);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("("));
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeStr(a_preExp, intString(a_rel_index));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" + ("));
        a_preExp = Tpl.writeText(a_preExp, a_iterator);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" - "));
        a_preExp = Tpl.writeStr(a_preExp, intString(a_i));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(")/"));
        a_preExp = Tpl.writeStr(a_preExp, intString(a_j));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", GreaterEq);"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           _,
           _,
           _,
           _,
           _,
           _,
           _,
           _,
           _,
           a_preExp )
      then (txt, a_preExp);
  end match;
end fun_878;

protected function fun_879
  input Tpl.Text in_txt;
  input DAE.Operator in_a_rel_operator;
  input Tpl.Text in_a_e2;
  input Tpl.Text in_a_e1;
  input Tpl.Text in_a_res;
  input Tpl.Text in_a_preExp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_preExp) :=
  match(in_txt, in_a_rel_operator, in_a_e2, in_a_e1, in_a_res, in_a_preExp)
    local
      Tpl.Text txt;
      Tpl.Text a_e2;
      Tpl.Text a_e1;
      Tpl.Text a_res;
      Tpl.Text a_preExp;

    case ( txt,
           DAE.LESS(ty = _),
           a_e2,
           a_e1,
           a_res,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = Less("));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(","));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           DAE.LESSEQ(ty = _),
           a_e2,
           a_e1,
           a_res,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = LessEq("));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(","));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           DAE.GREATER(ty = _),
           a_e2,
           a_e1,
           a_res,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = Greater("));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(","));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           DAE.GREATEREQ(ty = _),
           a_e2,
           a_e1,
           a_res,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = GreaterEq("));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(","));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           _,
           _,
           _,
           _,
           a_preExp )
      then (txt, a_preExp);
  end match;
end fun_879;

protected function fun_880
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_j;
  input Integer in_a_i;
  input Tpl.Text in_a_iterator;
  input Integer in_a_rel_index;
  input Tpl.Text in_a_e2;
  input Tpl.Text in_a_e1;
  input Tpl.Text in_a_res;
  input Tpl.Text in_a_preExp;
  input DAE.Operator in_a_rel_operator;
  input DAE.Exp in_a_rel_exp2;
  input DAE.Exp in_a_rel_exp1;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_preExp) :=
  match(in_txt, in_mArg, in_a_j, in_a_i, in_a_iterator, in_a_rel_index, in_a_e2, in_a_e1, in_a_res, in_a_preExp, in_a_rel_operator, in_a_rel_exp2, in_a_rel_exp1)
    local
      Tpl.Text txt;
      Integer a_j;
      Integer a_i;
      Tpl.Text a_iterator;
      Integer a_rel_index;
      Tpl.Text a_e2;
      Tpl.Text a_e1;
      Tpl.Text a_res;
      Tpl.Text a_preExp;
      DAE.Operator a_rel_operator;
      DAE.Exp a_rel_exp2;
      DAE.Exp a_rel_exp1;
      Tpl.Text l_hysteresisfunction;
      Boolean ret_2;
      DAE.Type ret_1;
      Tpl.Text l_isReal;

    case ( txt,
           false,
           a_j,
           a_i,
           a_iterator,
           a_rel_index,
           a_e2,
           a_e1,
           a_res,
           a_preExp,
           a_rel_operator,
           a_rel_exp2,
           a_rel_exp1 )
      equation
        ret_1 = Expression.typeof(a_rel_exp1);
        ret_2 = Expression.isRealType(ret_1);
        l_isReal = fun_876(Tpl.emptyTxt, ret_2, a_rel_exp2);
        l_hysteresisfunction = fun_877(Tpl.emptyTxt, l_isReal);
        (txt, a_preExp) = fun_878(txt, a_rel_operator, a_j, a_i, a_iterator, a_rel_index, a_e2, a_e1, a_res, l_hysteresisfunction, a_preExp);
      then (txt, a_preExp);

    case ( txt,
           _,
           _,
           _,
           _,
           _,
           a_e2,
           a_e1,
           a_res,
           a_preExp,
           a_rel_operator,
           _,
           _ )
      equation
        (txt, a_preExp) = fun_879(txt, a_rel_operator, a_e2, a_e1, a_res, a_preExp);
      then (txt, a_preExp);
  end match;
end fun_880;

protected function fun_881
  input Tpl.Text in_txt;
  input Option<tuple<DAE.Exp, Integer, Integer>> in_a_rel_optionExpisASUB;
  input DAE.Operator in_a_rel_operator;
  input Integer in_a_rel_index;
  input DAE.Exp in_a_rel_exp2;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;
  input DAE.Exp in_a_rel_exp1;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_a_rel_optionExpisASUB, in_a_rel_operator, in_a_rel_index, in_a_rel_exp2, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context, in_a_rel_exp1)
    local
      Tpl.Text txt;
      DAE.Operator a_rel_operator;
      Integer a_rel_index;
      DAE.Exp a_rel_exp2;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Exp a_rel_exp1;
      Integer i_j;
      Integer i_i;
      DAE.Exp i_exp;
      Boolean ret_5;
      Tpl.Text l_iterator;
      Boolean ret_3;
      Tpl.Text l_res;
      Tpl.Text l_e2;
      Tpl.Text l_e1;

    case ( txt,
           NONE(),
           a_rel_operator,
           a_rel_index,
           a_rel_exp2,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context,
           a_rel_exp1 )
      equation
        (l_e1, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, a_rel_exp1, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_e2, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, a_rel_exp2, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_res, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_boolean", a_varDecls);
        ret_3 = intEq(a_rel_index, -1);
        (txt, a_preExp) = fun_874(txt, ret_3, a_rel_index, l_e2, l_e1, l_res, a_preExp, a_rel_operator, a_rel_exp2, a_rel_exp1);
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           SOME((i_exp, i_i, i_j)),
           a_rel_operator,
           a_rel_index,
           a_rel_exp2,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context,
           a_rel_exp1 )
      equation
        (l_e1, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, a_rel_exp1, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_e2, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, a_rel_exp2, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_iterator, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_exp, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_res, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_boolean", a_varDecls);
        ret_5 = intEq(a_rel_index, -1);
        (txt, a_preExp) = fun_880(txt, ret_5, i_j, i_i, l_iterator, a_rel_index, l_e2, l_e1, l_res, a_preExp, a_rel_operator, a_rel_exp2, a_rel_exp1);
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           _,
           _,
           _,
           _,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end fun_881;

protected function fun_882
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("true"));
      then txt;
  end match;
end fun_882;

protected function fun_883
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input DAE.Exp in_a_rel_exp2;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_rel_exp2)
    local
      Tpl.Text txt;
      DAE.Exp a_rel_exp2;
      Boolean ret_1;
      DAE.Type ret_0;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_rel_exp2 )
      equation
        ret_0 = Expression.typeof(a_rel_exp2);
        ret_1 = Expression.isRealType(ret_0);
        txt = fun_882(txt, ret_1);
      then txt;
  end match;
end fun_883;

protected function fun_884
  input Tpl.Text in_txt;
  input Tpl.Text in_a_isReal;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_isReal)
    local
      Tpl.Text txt;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("RELATION"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("RELATIONHYSTERESIS"));
      then txt;
  end match;
end fun_884;

protected function fun_885
  input Tpl.Text in_txt;
  input DAE.Operator in_a_rel_operator;
  input Integer in_a_rel_index;
  input Tpl.Text in_a_e2;
  input Tpl.Text in_a_e1;
  input Tpl.Text in_a_res;
  input Tpl.Text in_a_hysteresisfunction;
  input Tpl.Text in_a_preExp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_preExp) :=
  match(in_txt, in_a_rel_operator, in_a_rel_index, in_a_e2, in_a_e1, in_a_res, in_a_hysteresisfunction, in_a_preExp)
    local
      Tpl.Text txt;
      Integer a_rel_index;
      Tpl.Text a_e2;
      Tpl.Text a_e1;
      Tpl.Text a_res;
      Tpl.Text a_hysteresisfunction;
      Tpl.Text a_preExp;

    case ( txt,
           DAE.LESS(ty = _),
           a_rel_index,
           a_e2,
           a_e1,
           a_res,
           a_hysteresisfunction,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_hysteresisfunction);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("("));
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeStr(a_preExp, intString(a_rel_index));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", Less);"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           DAE.LESSEQ(ty = _),
           a_rel_index,
           a_e2,
           a_e1,
           a_res,
           a_hysteresisfunction,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_hysteresisfunction);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("("));
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeStr(a_preExp, intString(a_rel_index));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", LessEq);"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           DAE.GREATER(ty = _),
           a_rel_index,
           a_e2,
           a_e1,
           a_res,
           a_hysteresisfunction,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_hysteresisfunction);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("("));
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeStr(a_preExp, intString(a_rel_index));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", Greater);"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           DAE.GREATEREQ(ty = _),
           a_rel_index,
           a_e2,
           a_e1,
           a_res,
           a_hysteresisfunction,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_hysteresisfunction);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("("));
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeStr(a_preExp, intString(a_rel_index));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", GreaterEq);"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           _,
           _,
           _,
           _,
           _,
           _,
           a_preExp )
      then (txt, a_preExp);
  end match;
end fun_885;

protected function fun_886
  input Tpl.Text in_txt;
  input DAE.Operator in_a_rel_operator;
  input Tpl.Text in_a_e2;
  input Tpl.Text in_a_e1;
  input Tpl.Text in_a_res;
  input Tpl.Text in_a_preExp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_preExp) :=
  match(in_txt, in_a_rel_operator, in_a_e2, in_a_e1, in_a_res, in_a_preExp)
    local
      Tpl.Text txt;
      Tpl.Text a_e2;
      Tpl.Text a_e1;
      Tpl.Text a_res;
      Tpl.Text a_preExp;

    case ( txt,
           DAE.LESS(ty = _),
           a_e2,
           a_e1,
           a_res,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = Less("));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(","));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           DAE.LESSEQ(ty = _),
           a_e2,
           a_e1,
           a_res,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = LessEq("));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(","));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           DAE.GREATER(ty = _),
           a_e2,
           a_e1,
           a_res,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = Greater("));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(","));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           DAE.GREATEREQ(ty = _),
           a_e2,
           a_e1,
           a_res,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = GreaterEq("));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(","));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           _,
           _,
           _,
           _,
           a_preExp )
      then (txt, a_preExp);
  end match;
end fun_886;

protected function fun_887
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_rel_index;
  input Tpl.Text in_a_e2;
  input Tpl.Text in_a_e1;
  input Tpl.Text in_a_res;
  input Tpl.Text in_a_preExp;
  input DAE.Operator in_a_rel_operator;
  input DAE.Exp in_a_rel_exp2;
  input DAE.Exp in_a_rel_exp1;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_preExp) :=
  match(in_txt, in_mArg, in_a_rel_index, in_a_e2, in_a_e1, in_a_res, in_a_preExp, in_a_rel_operator, in_a_rel_exp2, in_a_rel_exp1)
    local
      Tpl.Text txt;
      Integer a_rel_index;
      Tpl.Text a_e2;
      Tpl.Text a_e1;
      Tpl.Text a_res;
      Tpl.Text a_preExp;
      DAE.Operator a_rel_operator;
      DAE.Exp a_rel_exp2;
      DAE.Exp a_rel_exp1;
      Tpl.Text l_hysteresisfunction;
      Boolean ret_2;
      DAE.Type ret_1;
      Tpl.Text l_isReal;

    case ( txt,
           false,
           a_rel_index,
           a_e2,
           a_e1,
           a_res,
           a_preExp,
           a_rel_operator,
           a_rel_exp2,
           a_rel_exp1 )
      equation
        ret_1 = Expression.typeof(a_rel_exp1);
        ret_2 = Expression.isRealType(ret_1);
        l_isReal = fun_883(Tpl.emptyTxt, ret_2, a_rel_exp2);
        l_hysteresisfunction = fun_884(Tpl.emptyTxt, l_isReal);
        (txt, a_preExp) = fun_885(txt, a_rel_operator, a_rel_index, a_e2, a_e1, a_res, l_hysteresisfunction, a_preExp);
      then (txt, a_preExp);

    case ( txt,
           _,
           _,
           a_e2,
           a_e1,
           a_res,
           a_preExp,
           a_rel_operator,
           _,
           _ )
      equation
        (txt, a_preExp) = fun_886(txt, a_rel_operator, a_e2, a_e1, a_res, a_preExp);
      then (txt, a_preExp);
  end match;
end fun_887;

protected function fun_888
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("true"));
      then txt;
  end match;
end fun_888;

protected function fun_889
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input DAE.Exp in_a_rel_exp2;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_rel_exp2)
    local
      Tpl.Text txt;
      DAE.Exp a_rel_exp2;
      Boolean ret_1;
      DAE.Type ret_0;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_rel_exp2 )
      equation
        ret_0 = Expression.typeof(a_rel_exp2);
        ret_1 = Expression.isRealType(ret_0);
        txt = fun_888(txt, ret_1);
      then txt;
  end match;
end fun_889;

protected function fun_890
  input Tpl.Text in_txt;
  input Tpl.Text in_a_isReal;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_isReal)
    local
      Tpl.Text txt;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("RELATION"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("RELATIONHYSTERESIS"));
      then txt;
  end match;
end fun_890;

protected function fun_891
  input Tpl.Text in_txt;
  input DAE.Operator in_a_rel_operator;
  input Integer in_a_j;
  input Integer in_a_i;
  input Tpl.Text in_a_iterator;
  input Integer in_a_rel_index;
  input Tpl.Text in_a_e2;
  input Tpl.Text in_a_e1;
  input Tpl.Text in_a_res;
  input Tpl.Text in_a_hysteresisfunction;
  input Tpl.Text in_a_preExp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_preExp) :=
  match(in_txt, in_a_rel_operator, in_a_j, in_a_i, in_a_iterator, in_a_rel_index, in_a_e2, in_a_e1, in_a_res, in_a_hysteresisfunction, in_a_preExp)
    local
      Tpl.Text txt;
      Integer a_j;
      Integer a_i;
      Tpl.Text a_iterator;
      Integer a_rel_index;
      Tpl.Text a_e2;
      Tpl.Text a_e1;
      Tpl.Text a_res;
      Tpl.Text a_hysteresisfunction;
      Tpl.Text a_preExp;

    case ( txt,
           DAE.LESS(ty = _),
           a_j,
           a_i,
           a_iterator,
           a_rel_index,
           a_e2,
           a_e1,
           a_res,
           a_hysteresisfunction,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_hysteresisfunction);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("("));
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeStr(a_preExp, intString(a_rel_index));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" + ("));
        a_preExp = Tpl.writeText(a_preExp, a_iterator);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" - "));
        a_preExp = Tpl.writeStr(a_preExp, intString(a_i));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(")/"));
        a_preExp = Tpl.writeStr(a_preExp, intString(a_j));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", Less);"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           DAE.LESSEQ(ty = _),
           a_j,
           a_i,
           a_iterator,
           a_rel_index,
           a_e2,
           a_e1,
           a_res,
           a_hysteresisfunction,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_hysteresisfunction);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("("));
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeStr(a_preExp, intString(a_rel_index));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" + ("));
        a_preExp = Tpl.writeText(a_preExp, a_iterator);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" - "));
        a_preExp = Tpl.writeStr(a_preExp, intString(a_i));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(")/"));
        a_preExp = Tpl.writeStr(a_preExp, intString(a_j));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", LessEq);"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           DAE.GREATER(ty = _),
           a_j,
           a_i,
           a_iterator,
           a_rel_index,
           a_e2,
           a_e1,
           a_res,
           a_hysteresisfunction,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_hysteresisfunction);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("("));
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeStr(a_preExp, intString(a_rel_index));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" + ("));
        a_preExp = Tpl.writeText(a_preExp, a_iterator);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" - "));
        a_preExp = Tpl.writeStr(a_preExp, intString(a_i));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(")/"));
        a_preExp = Tpl.writeStr(a_preExp, intString(a_j));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", Greater);"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           DAE.GREATEREQ(ty = _),
           a_j,
           a_i,
           a_iterator,
           a_rel_index,
           a_e2,
           a_e1,
           a_res,
           a_hysteresisfunction,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_hysteresisfunction);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("("));
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeStr(a_preExp, intString(a_rel_index));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" + ("));
        a_preExp = Tpl.writeText(a_preExp, a_iterator);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" - "));
        a_preExp = Tpl.writeStr(a_preExp, intString(a_i));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(")/"));
        a_preExp = Tpl.writeStr(a_preExp, intString(a_j));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", GreaterEq);"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           _,
           _,
           _,
           _,
           _,
           _,
           _,
           _,
           _,
           a_preExp )
      then (txt, a_preExp);
  end match;
end fun_891;

protected function fun_892
  input Tpl.Text in_txt;
  input DAE.Operator in_a_rel_operator;
  input Tpl.Text in_a_e2;
  input Tpl.Text in_a_e1;
  input Tpl.Text in_a_res;
  input Tpl.Text in_a_preExp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_preExp) :=
  match(in_txt, in_a_rel_operator, in_a_e2, in_a_e1, in_a_res, in_a_preExp)
    local
      Tpl.Text txt;
      Tpl.Text a_e2;
      Tpl.Text a_e1;
      Tpl.Text a_res;
      Tpl.Text a_preExp;

    case ( txt,
           DAE.LESS(ty = _),
           a_e2,
           a_e1,
           a_res,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = Less("));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(","));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           DAE.LESSEQ(ty = _),
           a_e2,
           a_e1,
           a_res,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = LessEq("));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(","));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           DAE.GREATER(ty = _),
           a_e2,
           a_e1,
           a_res,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = Greater("));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(","));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           DAE.GREATEREQ(ty = _),
           a_e2,
           a_e1,
           a_res,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = GreaterEq("));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(","));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           _,
           _,
           _,
           _,
           a_preExp )
      then (txt, a_preExp);
  end match;
end fun_892;

protected function fun_893
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_j;
  input Integer in_a_i;
  input Tpl.Text in_a_iterator;
  input Integer in_a_rel_index;
  input Tpl.Text in_a_e2;
  input Tpl.Text in_a_e1;
  input Tpl.Text in_a_res;
  input Tpl.Text in_a_preExp;
  input DAE.Operator in_a_rel_operator;
  input DAE.Exp in_a_rel_exp2;
  input DAE.Exp in_a_rel_exp1;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_preExp) :=
  match(in_txt, in_mArg, in_a_j, in_a_i, in_a_iterator, in_a_rel_index, in_a_e2, in_a_e1, in_a_res, in_a_preExp, in_a_rel_operator, in_a_rel_exp2, in_a_rel_exp1)
    local
      Tpl.Text txt;
      Integer a_j;
      Integer a_i;
      Tpl.Text a_iterator;
      Integer a_rel_index;
      Tpl.Text a_e2;
      Tpl.Text a_e1;
      Tpl.Text a_res;
      Tpl.Text a_preExp;
      DAE.Operator a_rel_operator;
      DAE.Exp a_rel_exp2;
      DAE.Exp a_rel_exp1;
      Tpl.Text l_hysteresisfunction;
      Boolean ret_2;
      DAE.Type ret_1;
      Tpl.Text l_isReal;

    case ( txt,
           false,
           a_j,
           a_i,
           a_iterator,
           a_rel_index,
           a_e2,
           a_e1,
           a_res,
           a_preExp,
           a_rel_operator,
           a_rel_exp2,
           a_rel_exp1 )
      equation
        ret_1 = Expression.typeof(a_rel_exp1);
        ret_2 = Expression.isRealType(ret_1);
        l_isReal = fun_889(Tpl.emptyTxt, ret_2, a_rel_exp2);
        l_hysteresisfunction = fun_890(Tpl.emptyTxt, l_isReal);
        (txt, a_preExp) = fun_891(txt, a_rel_operator, a_j, a_i, a_iterator, a_rel_index, a_e2, a_e1, a_res, l_hysteresisfunction, a_preExp);
      then (txt, a_preExp);

    case ( txt,
           _,
           _,
           _,
           _,
           _,
           a_e2,
           a_e1,
           a_res,
           a_preExp,
           a_rel_operator,
           _,
           _ )
      equation
        (txt, a_preExp) = fun_892(txt, a_rel_operator, a_e2, a_e1, a_res, a_preExp);
      then (txt, a_preExp);
  end match;
end fun_893;

protected function fun_894
  input Tpl.Text in_txt;
  input Option<tuple<DAE.Exp, Integer, Integer>> in_a_rel_optionExpisASUB;
  input DAE.Operator in_a_rel_operator;
  input Integer in_a_rel_index;
  input DAE.Exp in_a_rel_exp2;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;
  input DAE.Exp in_a_rel_exp1;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_a_rel_optionExpisASUB, in_a_rel_operator, in_a_rel_index, in_a_rel_exp2, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context, in_a_rel_exp1)
    local
      Tpl.Text txt;
      DAE.Operator a_rel_operator;
      Integer a_rel_index;
      DAE.Exp a_rel_exp2;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Exp a_rel_exp1;
      Integer i_j;
      Integer i_i;
      DAE.Exp i_exp;
      Boolean ret_5;
      Tpl.Text l_iterator;
      Boolean ret_3;
      Tpl.Text l_res;
      Tpl.Text l_e2;
      Tpl.Text l_e1;

    case ( txt,
           NONE(),
           a_rel_operator,
           a_rel_index,
           a_rel_exp2,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context,
           a_rel_exp1 )
      equation
        (l_e1, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, a_rel_exp1, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_e2, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, a_rel_exp2, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_res, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_boolean", a_varDecls);
        ret_3 = intEq(a_rel_index, -1);
        (txt, a_preExp) = fun_887(txt, ret_3, a_rel_index, l_e2, l_e1, l_res, a_preExp, a_rel_operator, a_rel_exp2, a_rel_exp1);
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           SOME((i_exp, i_i, i_j)),
           a_rel_operator,
           a_rel_index,
           a_rel_exp2,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context,
           a_rel_exp1 )
      equation
        (l_e1, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, a_rel_exp1, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_e2, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, a_rel_exp2, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_iterator, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_exp, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_res, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_boolean", a_varDecls);
        ret_5 = intEq(a_rel_index, -1);
        (txt, a_preExp) = fun_893(txt, ret_5, i_j, i_i, l_iterator, a_rel_index, l_e2, l_e1, l_res, a_preExp, a_rel_operator, a_rel_exp2, a_rel_exp1);
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           _,
           _,
           _,
           _,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end fun_894;

protected function fun_895
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("true"));
      then txt;
  end match;
end fun_895;

protected function fun_896
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input DAE.Exp in_a_rel_exp2;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_rel_exp2)
    local
      Tpl.Text txt;
      DAE.Exp a_rel_exp2;
      Boolean ret_1;
      DAE.Type ret_0;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_rel_exp2 )
      equation
        ret_0 = Expression.typeof(a_rel_exp2);
        ret_1 = Expression.isRealType(ret_0);
        txt = fun_895(txt, ret_1);
      then txt;
  end match;
end fun_896;

protected function fun_897
  input Tpl.Text in_txt;
  input Tpl.Text in_a_isReal;
  input Integer in_a_rel_index;
  input Tpl.Text in_a_e2;
  input Tpl.Text in_a_e1;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_isReal, in_a_rel_index, in_a_e2, in_a_e1)
    local
      Tpl.Text txt;
      Integer a_rel_index;
      Tpl.Text a_e2;
      Tpl.Text a_e1;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           _,
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Less("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           _,
           a_rel_index,
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("LessZC("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", data->simulationInfo->storedRelations["));
        txt = Tpl.writeStr(txt, intString(a_rel_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("])"));
      then txt;
  end match;
end fun_897;

protected function fun_898
  input Tpl.Text in_txt;
  input Tpl.Text in_a_isReal;
  input Integer in_a_rel_index;
  input Tpl.Text in_a_e2;
  input Tpl.Text in_a_e1;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_isReal, in_a_rel_index, in_a_e2, in_a_e1)
    local
      Tpl.Text txt;
      Integer a_rel_index;
      Tpl.Text a_e2;
      Tpl.Text a_e1;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           _,
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("LessEq("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           _,
           a_rel_index,
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("LessEqZC("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", data->simulationInfo->storedRelations["));
        txt = Tpl.writeStr(txt, intString(a_rel_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("])"));
      then txt;
  end match;
end fun_898;

protected function fun_899
  input Tpl.Text in_txt;
  input Tpl.Text in_a_isReal;
  input Integer in_a_rel_index;
  input Tpl.Text in_a_e2;
  input Tpl.Text in_a_e1;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_isReal, in_a_rel_index, in_a_e2, in_a_e1)
    local
      Tpl.Text txt;
      Integer a_rel_index;
      Tpl.Text a_e2;
      Tpl.Text a_e1;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           _,
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Greater("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           _,
           a_rel_index,
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("GreaterZC("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", data->simulationInfo->storedRelations["));
        txt = Tpl.writeStr(txt, intString(a_rel_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("])"));
      then txt;
  end match;
end fun_899;

protected function fun_900
  input Tpl.Text in_txt;
  input Tpl.Text in_a_isReal;
  input Integer in_a_rel_index;
  input Tpl.Text in_a_e2;
  input Tpl.Text in_a_e1;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_isReal, in_a_rel_index, in_a_e2, in_a_e1)
    local
      Tpl.Text txt;
      Integer a_rel_index;
      Tpl.Text a_e2;
      Tpl.Text a_e1;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           _,
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("GreaterEq("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           _,
           a_rel_index,
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("GreaterEqZC("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", data->simulationInfo->storedRelations["));
        txt = Tpl.writeStr(txt, intString(a_rel_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("])"));
      then txt;
  end match;
end fun_900;

protected function fun_901
  input Tpl.Text in_txt;
  input DAE.Operator in_a_rel_operator;
  input Tpl.Text in_a_res;
  input Tpl.Text in_a_preExp;
  input Integer in_a_rel_index;
  input Tpl.Text in_a_e2;
  input Tpl.Text in_a_e1;
  input Tpl.Text in_a_isReal;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_preExp) :=
  match(in_txt, in_a_rel_operator, in_a_res, in_a_preExp, in_a_rel_index, in_a_e2, in_a_e1, in_a_isReal)
    local
      Tpl.Text txt;
      Tpl.Text a_res;
      Tpl.Text a_preExp;
      Integer a_rel_index;
      Tpl.Text a_e2;
      Tpl.Text a_e1;
      Tpl.Text a_isReal;
      Tpl.Text l_hysteresisfunction;

    case ( txt,
           DAE.LESS(ty = _),
           a_res,
           a_preExp,
           a_rel_index,
           a_e2,
           a_e1,
           a_isReal )
      equation
        l_hysteresisfunction = fun_897(Tpl.emptyTxt, a_isReal, a_rel_index, a_e2, a_e1);
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = "));
        a_preExp = Tpl.writeText(a_preExp, l_hysteresisfunction);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(";"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           DAE.LESSEQ(ty = _),
           a_res,
           a_preExp,
           a_rel_index,
           a_e2,
           a_e1,
           a_isReal )
      equation
        l_hysteresisfunction = fun_898(Tpl.emptyTxt, a_isReal, a_rel_index, a_e2, a_e1);
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = "));
        a_preExp = Tpl.writeText(a_preExp, l_hysteresisfunction);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(";"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           DAE.GREATER(ty = _),
           a_res,
           a_preExp,
           a_rel_index,
           a_e2,
           a_e1,
           a_isReal )
      equation
        l_hysteresisfunction = fun_899(Tpl.emptyTxt, a_isReal, a_rel_index, a_e2, a_e1);
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = "));
        a_preExp = Tpl.writeText(a_preExp, l_hysteresisfunction);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(";"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           DAE.GREATEREQ(ty = _),
           a_res,
           a_preExp,
           a_rel_index,
           a_e2,
           a_e1,
           a_isReal )
      equation
        l_hysteresisfunction = fun_900(Tpl.emptyTxt, a_isReal, a_rel_index, a_e2, a_e1);
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = "));
        a_preExp = Tpl.writeText(a_preExp, l_hysteresisfunction);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(";"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           _,
           _,
           a_preExp,
           _,
           _,
           _,
           _ )
      then (txt, a_preExp);
  end match;
end fun_901;

protected function fun_902
  input Tpl.Text in_txt;
  input DAE.Operator in_a_rel_operator;
  input Tpl.Text in_a_e2;
  input Tpl.Text in_a_e1;
  input Tpl.Text in_a_res;
  input Tpl.Text in_a_preExp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_preExp) :=
  match(in_txt, in_a_rel_operator, in_a_e2, in_a_e1, in_a_res, in_a_preExp)
    local
      Tpl.Text txt;
      Tpl.Text a_e2;
      Tpl.Text a_e1;
      Tpl.Text a_res;
      Tpl.Text a_preExp;

    case ( txt,
           DAE.LESS(ty = _),
           a_e2,
           a_e1,
           a_res,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = Less("));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(","));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           DAE.LESSEQ(ty = _),
           a_e2,
           a_e1,
           a_res,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = LessEq("));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(","));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           DAE.GREATER(ty = _),
           a_e2,
           a_e1,
           a_res,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = Greater("));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(","));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           DAE.GREATEREQ(ty = _),
           a_e2,
           a_e1,
           a_res,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = GreaterEq("));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(","));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           _,
           _,
           _,
           _,
           a_preExp )
      then (txt, a_preExp);
  end match;
end fun_902;

protected function fun_903
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_res;
  input Tpl.Text in_a_preExp;
  input Integer in_a_rel_index;
  input Tpl.Text in_a_e2;
  input Tpl.Text in_a_e1;
  input DAE.Operator in_a_rel_operator;
  input DAE.Exp in_a_rel_exp2;
  input DAE.Exp in_a_rel_exp1;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_preExp) :=
  match(in_txt, in_mArg, in_a_res, in_a_preExp, in_a_rel_index, in_a_e2, in_a_e1, in_a_rel_operator, in_a_rel_exp2, in_a_rel_exp1)
    local
      Tpl.Text txt;
      Tpl.Text a_res;
      Tpl.Text a_preExp;
      Integer a_rel_index;
      Tpl.Text a_e2;
      Tpl.Text a_e1;
      DAE.Operator a_rel_operator;
      DAE.Exp a_rel_exp2;
      DAE.Exp a_rel_exp1;
      Boolean ret_2;
      DAE.Type ret_1;
      Tpl.Text l_isReal;

    case ( txt,
           false,
           a_res,
           a_preExp,
           a_rel_index,
           a_e2,
           a_e1,
           a_rel_operator,
           a_rel_exp2,
           a_rel_exp1 )
      equation
        ret_1 = Expression.typeof(a_rel_exp1);
        ret_2 = Expression.isRealType(ret_1);
        l_isReal = fun_896(Tpl.emptyTxt, ret_2, a_rel_exp2);
        (txt, a_preExp) = fun_901(txt, a_rel_operator, a_res, a_preExp, a_rel_index, a_e2, a_e1, l_isReal);
      then (txt, a_preExp);

    case ( txt,
           _,
           a_res,
           a_preExp,
           _,
           a_e2,
           a_e1,
           a_rel_operator,
           _,
           _ )
      equation
        (txt, a_preExp) = fun_902(txt, a_rel_operator, a_e2, a_e1, a_res, a_preExp);
      then (txt, a_preExp);
  end match;
end fun_903;

protected function fun_904
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("true"));
      then txt;
  end match;
end fun_904;

protected function fun_905
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input DAE.Exp in_a_rel_exp2;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_rel_exp2)
    local
      Tpl.Text txt;
      DAE.Exp a_rel_exp2;
      Boolean ret_1;
      DAE.Type ret_0;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_rel_exp2 )
      equation
        ret_0 = Expression.typeof(a_rel_exp2);
        ret_1 = Expression.isRealType(ret_0);
        txt = fun_904(txt, ret_1);
      then txt;
  end match;
end fun_905;

protected function fun_906
  input Tpl.Text in_txt;
  input Tpl.Text in_a_isReal;
  input Integer in_a_rel_index;
  input Tpl.Text in_a_e2;
  input Tpl.Text in_a_e1;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_isReal, in_a_rel_index, in_a_e2, in_a_e1)
    local
      Tpl.Text txt;
      Integer a_rel_index;
      Tpl.Text a_e2;
      Tpl.Text a_e1;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           _,
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Less("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           _,
           a_rel_index,
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("LessZC("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", data->simulationInfo->storedRelations["));
        txt = Tpl.writeStr(txt, intString(a_rel_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("])"));
      then txt;
  end match;
end fun_906;

protected function fun_907
  input Tpl.Text in_txt;
  input Tpl.Text in_a_isReal;
  input Integer in_a_rel_index;
  input Tpl.Text in_a_e2;
  input Tpl.Text in_a_e1;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_isReal, in_a_rel_index, in_a_e2, in_a_e1)
    local
      Tpl.Text txt;
      Integer a_rel_index;
      Tpl.Text a_e2;
      Tpl.Text a_e1;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           _,
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("LessEq("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           _,
           a_rel_index,
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("LessEqZC("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", data->simulationInfo->storedRelations["));
        txt = Tpl.writeStr(txt, intString(a_rel_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("])"));
      then txt;
  end match;
end fun_907;

protected function fun_908
  input Tpl.Text in_txt;
  input Tpl.Text in_a_isReal;
  input Integer in_a_rel_index;
  input Tpl.Text in_a_e2;
  input Tpl.Text in_a_e1;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_isReal, in_a_rel_index, in_a_e2, in_a_e1)
    local
      Tpl.Text txt;
      Integer a_rel_index;
      Tpl.Text a_e2;
      Tpl.Text a_e1;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           _,
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Greater("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           _,
           a_rel_index,
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("GreaterZC("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", data->simulationInfo->storedRelations["));
        txt = Tpl.writeStr(txt, intString(a_rel_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("])"));
      then txt;
  end match;
end fun_908;

protected function fun_909
  input Tpl.Text in_txt;
  input Tpl.Text in_a_isReal;
  input Integer in_a_rel_index;
  input Tpl.Text in_a_e2;
  input Tpl.Text in_a_e1;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_isReal, in_a_rel_index, in_a_e2, in_a_e1)
    local
      Tpl.Text txt;
      Integer a_rel_index;
      Tpl.Text a_e2;
      Tpl.Text a_e1;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           _,
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("GreaterEq("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           _,
           a_rel_index,
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("GreaterEqZC("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", data->simulationInfo->storedRelations["));
        txt = Tpl.writeStr(txt, intString(a_rel_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("])"));
      then txt;
  end match;
end fun_909;

protected function fun_910
  input Tpl.Text in_txt;
  input DAE.Operator in_a_rel_operator;
  input Tpl.Text in_a_res;
  input Tpl.Text in_a_preExp;
  input Integer in_a_rel_index;
  input Tpl.Text in_a_e2;
  input Tpl.Text in_a_e1;
  input Tpl.Text in_a_isReal;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_preExp) :=
  match(in_txt, in_a_rel_operator, in_a_res, in_a_preExp, in_a_rel_index, in_a_e2, in_a_e1, in_a_isReal)
    local
      Tpl.Text txt;
      Tpl.Text a_res;
      Tpl.Text a_preExp;
      Integer a_rel_index;
      Tpl.Text a_e2;
      Tpl.Text a_e1;
      Tpl.Text a_isReal;
      Tpl.Text l_hysteresisfunction;

    case ( txt,
           DAE.LESS(ty = _),
           a_res,
           a_preExp,
           a_rel_index,
           a_e2,
           a_e1,
           a_isReal )
      equation
        l_hysteresisfunction = fun_906(Tpl.emptyTxt, a_isReal, a_rel_index, a_e2, a_e1);
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = "));
        a_preExp = Tpl.writeText(a_preExp, l_hysteresisfunction);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(";"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           DAE.LESSEQ(ty = _),
           a_res,
           a_preExp,
           a_rel_index,
           a_e2,
           a_e1,
           a_isReal )
      equation
        l_hysteresisfunction = fun_907(Tpl.emptyTxt, a_isReal, a_rel_index, a_e2, a_e1);
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = "));
        a_preExp = Tpl.writeText(a_preExp, l_hysteresisfunction);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(";"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           DAE.GREATER(ty = _),
           a_res,
           a_preExp,
           a_rel_index,
           a_e2,
           a_e1,
           a_isReal )
      equation
        l_hysteresisfunction = fun_908(Tpl.emptyTxt, a_isReal, a_rel_index, a_e2, a_e1);
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = "));
        a_preExp = Tpl.writeText(a_preExp, l_hysteresisfunction);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(";"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           DAE.GREATEREQ(ty = _),
           a_res,
           a_preExp,
           a_rel_index,
           a_e2,
           a_e1,
           a_isReal )
      equation
        l_hysteresisfunction = fun_909(Tpl.emptyTxt, a_isReal, a_rel_index, a_e2, a_e1);
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = "));
        a_preExp = Tpl.writeText(a_preExp, l_hysteresisfunction);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(";"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           _,
           _,
           a_preExp,
           _,
           _,
           _,
           _ )
      then (txt, a_preExp);
  end match;
end fun_910;

protected function fun_911
  input Tpl.Text in_txt;
  input DAE.Operator in_a_rel_operator;
  input Tpl.Text in_a_e2;
  input Tpl.Text in_a_e1;
  input Tpl.Text in_a_res;
  input Tpl.Text in_a_preExp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_preExp) :=
  match(in_txt, in_a_rel_operator, in_a_e2, in_a_e1, in_a_res, in_a_preExp)
    local
      Tpl.Text txt;
      Tpl.Text a_e2;
      Tpl.Text a_e1;
      Tpl.Text a_res;
      Tpl.Text a_preExp;

    case ( txt,
           DAE.LESS(ty = _),
           a_e2,
           a_e1,
           a_res,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = Less("));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(","));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           DAE.LESSEQ(ty = _),
           a_e2,
           a_e1,
           a_res,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = LessEq("));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(","));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           DAE.GREATER(ty = _),
           a_e2,
           a_e1,
           a_res,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = Greater("));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(","));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           DAE.GREATEREQ(ty = _),
           a_e2,
           a_e1,
           a_res,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = GreaterEq("));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(","));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp);

    case ( txt,
           _,
           _,
           _,
           _,
           a_preExp )
      then (txt, a_preExp);
  end match;
end fun_911;

protected function fun_912
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_res;
  input Tpl.Text in_a_preExp;
  input Integer in_a_rel_index;
  input Tpl.Text in_a_e2;
  input Tpl.Text in_a_e1;
  input DAE.Operator in_a_rel_operator;
  input DAE.Exp in_a_rel_exp2;
  input DAE.Exp in_a_rel_exp1;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_preExp) :=
  match(in_txt, in_mArg, in_a_res, in_a_preExp, in_a_rel_index, in_a_e2, in_a_e1, in_a_rel_operator, in_a_rel_exp2, in_a_rel_exp1)
    local
      Tpl.Text txt;
      Tpl.Text a_res;
      Tpl.Text a_preExp;
      Integer a_rel_index;
      Tpl.Text a_e2;
      Tpl.Text a_e1;
      DAE.Operator a_rel_operator;
      DAE.Exp a_rel_exp2;
      DAE.Exp a_rel_exp1;
      Boolean ret_2;
      DAE.Type ret_1;
      Tpl.Text l_isReal;

    case ( txt,
           false,
           a_res,
           a_preExp,
           a_rel_index,
           a_e2,
           a_e1,
           a_rel_operator,
           a_rel_exp2,
           a_rel_exp1 )
      equation
        ret_1 = Expression.typeof(a_rel_exp1);
        ret_2 = Expression.isRealType(ret_1);
        l_isReal = fun_905(Tpl.emptyTxt, ret_2, a_rel_exp2);
        (txt, a_preExp) = fun_910(txt, a_rel_operator, a_res, a_preExp, a_rel_index, a_e2, a_e1, l_isReal);
      then (txt, a_preExp);

    case ( txt,
           _,
           a_res,
           a_preExp,
           _,
           a_e2,
           a_e1,
           a_rel_operator,
           _,
           _ )
      equation
        (txt, a_preExp) = fun_911(txt, a_rel_operator, a_e2, a_e1, a_res, a_preExp);
      then (txt, a_preExp);
  end match;
end fun_912;

protected function fun_913
  input Tpl.Text in_txt;
  input Option<tuple<DAE.Exp, Integer, Integer>> in_a_rel_optionExpisASUB;
  input DAE.Operator in_a_rel_operator;
  input Integer in_a_rel_index;
  input DAE.Exp in_a_rel_exp2;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;
  input DAE.Exp in_a_rel_exp1;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_a_rel_optionExpisASUB, in_a_rel_operator, in_a_rel_index, in_a_rel_exp2, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context, in_a_rel_exp1)
    local
      Tpl.Text txt;
      DAE.Operator a_rel_operator;
      Integer a_rel_index;
      DAE.Exp a_rel_exp2;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Exp a_rel_exp1;
      Boolean ret_4;
      Boolean ret_3;
      Tpl.Text l_res;
      Tpl.Text l_e2;
      Tpl.Text l_e1;

    case ( txt,
           NONE(),
           a_rel_operator,
           a_rel_index,
           a_rel_exp2,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context,
           a_rel_exp1 )
      equation
        (l_e1, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, a_rel_exp1, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_e2, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, a_rel_exp2, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_res, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_boolean", a_varDecls);
        ret_3 = intEq(a_rel_index, -1);
        (txt, a_preExp) = fun_903(txt, ret_3, l_res, a_preExp, a_rel_index, l_e2, l_e1, a_rel_operator, a_rel_exp2, a_rel_exp1);
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           SOME((_, _, _)),
           a_rel_operator,
           a_rel_index,
           a_rel_exp2,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context,
           a_rel_exp1 )
      equation
        (l_e1, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, a_rel_exp1, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_e2, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, a_rel_exp2, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_res, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_boolean", a_varDecls);
        ret_4 = intEq(a_rel_index, -1);
        (txt, a_preExp) = fun_912(txt, ret_4, l_res, a_preExp, a_rel_index, l_e2, l_e1, a_rel_operator, a_rel_exp2, a_rel_exp1);
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           _,
           _,
           _,
           _,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end fun_913;

protected function fun_914
  input Tpl.Text in_txt;
  input SimCodeFunction.Context in_a_context;
  input Option<tuple<DAE.Exp, Integer, Integer>> in_a_rel_optionExpisASUB;
  input Integer in_a_rel_index;
  input DAE.Operator in_a_rel_operator;
  input DAE.Exp in_a_rel_exp2;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input DAE.Exp in_a_rel_exp1;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_a_context, in_a_rel_optionExpisASUB, in_a_rel_index, in_a_rel_operator, in_a_rel_exp2, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_rel_exp1)
    local
      Tpl.Text txt;
      Option<tuple<DAE.Exp, Integer, Integer>> a_rel_optionExpisASUB;
      Integer a_rel_index;
      DAE.Operator a_rel_operator;
      DAE.Exp a_rel_exp2;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      DAE.Exp a_rel_exp1;
      SimCodeFunction.Context i_context;
      Boolean ret_4;
      Tpl.Text l_0__;
      Tpl.Text l_res;
      Tpl.Text l_e2;
      Tpl.Text l_e1;

    case ( txt,
           (i_context as SimCodeFunction.OMSI_CONTEXT(hashTable = _)),
           _,
           a_rel_index,
           a_rel_operator,
           a_rel_exp2,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_rel_exp1 )
      equation
        (l_e1, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, a_rel_exp1, i_context, a_preExp, a_varDecls, a_auxFunction);
        (l_e2, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, a_rel_exp2, i_context, a_preExp, a_varDecls, a_auxFunction);
        (l_res, a_varDecls) = tempDecl(Tpl.emptyTxt, "omsi_bool", a_varDecls);
        (l_0__, a_preExp) = fun_853(Tpl.emptyTxt, a_rel_operator, l_e2, l_e1, l_res, a_preExp);
        ret_4 = intEq(a_rel_index, -1);
        txt = fun_855(txt, ret_4, a_rel_index, l_res);
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           (i_context as SimCodeFunction.JACOBIAN_CONTEXT(jacHT = _)),
           a_rel_optionExpisASUB,
           a_rel_index,
           a_rel_operator,
           a_rel_exp2,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_rel_exp1 )
      equation
        (txt, a_auxFunction, a_varDecls, a_preExp) = fun_868(txt, a_rel_optionExpisASUB, a_rel_operator, a_rel_index, a_rel_exp2, a_auxFunction, a_varDecls, a_preExp, i_context, a_rel_exp1);
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           (i_context as SimCodeFunction.DAE_MODE_CONTEXT()),
           a_rel_optionExpisASUB,
           a_rel_index,
           a_rel_operator,
           a_rel_exp2,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_rel_exp1 )
      equation
        (txt, a_auxFunction, a_varDecls, a_preExp) = fun_881(txt, a_rel_optionExpisASUB, a_rel_operator, a_rel_index, a_rel_exp2, a_auxFunction, a_varDecls, a_preExp, i_context, a_rel_exp1);
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           (i_context as SimCodeFunction.SIMULATION_CONTEXT(genDiscrete = _)),
           a_rel_optionExpisASUB,
           a_rel_index,
           a_rel_operator,
           a_rel_exp2,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_rel_exp1 )
      equation
        (txt, a_auxFunction, a_varDecls, a_preExp) = fun_894(txt, a_rel_optionExpisASUB, a_rel_operator, a_rel_index, a_rel_exp2, a_auxFunction, a_varDecls, a_preExp, i_context, a_rel_exp1);
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           (i_context as SimCodeFunction.ZEROCROSSINGS_CONTEXT()),
           a_rel_optionExpisASUB,
           a_rel_index,
           a_rel_operator,
           a_rel_exp2,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_rel_exp1 )
      equation
        (txt, a_auxFunction, a_varDecls, a_preExp) = fun_913(txt, a_rel_optionExpisASUB, a_rel_operator, a_rel_index, a_rel_exp2, a_auxFunction, a_varDecls, a_preExp, i_context, a_rel_exp1);
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           _,
           _,
           _,
           _,
           _,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end fun_914;

public function daeExpRelationSim
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_exp, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      Option<tuple<DAE.Exp, Integer, Integer>> i_rel_optionExpisASUB;
      Integer i_rel_index;
      DAE.Operator i_rel_operator;
      DAE.Exp i_rel_exp2;
      DAE.Exp i_rel_exp1;

    case ( txt,
           DAE.RELATION(exp1 = i_rel_exp1, exp2 = i_rel_exp2, operator = i_rel_operator, index = i_rel_index, optionExpisASUB = i_rel_optionExpisASUB),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_auxFunction, a_varDecls, a_preExp) = fun_914(txt, a_context, i_rel_optionExpisASUB, i_rel_index, i_rel_operator, i_rel_exp2, a_auxFunction, a_varDecls, a_preExp, i_rel_exp1);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end daeExpRelationSim;

protected function fun_916
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("x"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_916;

protected function fun_917
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input DAE.Exp in_a_exp;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_exp)
    local
      Tpl.Text txt;
      DAE.Exp a_exp;
      Boolean ret_1;
      DAE.Type ret_0;

    case ( txt,
           false,
           a_exp )
      equation
        ret_0 = Expression.typeof(a_exp);
        ret_1 = Expression.isRecordType(ret_0);
        txt = fun_916(txt, ret_1);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_917;

protected function fun_918
  input Tpl.Text in_txt;
  input Tpl.Text in_a_preExpElse;
  input DAE.Exp in_a_exp;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_preExpElse, in_a_exp)
    local
      Tpl.Text txt;
      DAE.Exp a_exp;
      Boolean ret_1;
      DAE.Type ret_0;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           a_exp )
      equation
        ret_0 = Expression.typeof(a_exp);
        ret_1 = Expression.isArrayType(ret_0);
        txt = fun_917(txt, ret_1, a_exp);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_918;

protected function fun_919
  input Tpl.Text in_txt;
  input Tpl.Text in_a_preExpThen;
  input DAE.Exp in_a_exp;
  input Tpl.Text in_a_preExpElse;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_preExpThen, in_a_exp, in_a_preExpElse)
    local
      Tpl.Text txt;
      DAE.Exp a_exp;
      Tpl.Text a_preExpElse;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           a_exp,
           a_preExpElse )
      equation
        txt = fun_918(txt, a_preExpElse, a_exp);
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_919;

protected function fun_920
  input Tpl.Text in_txt;
  input Tpl.Text in_a_eThen;
  input Tpl.Text in_a_resVar;
  input DAE.Exp in_a_exp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_resVar;
algorithm
  (out_txt, out_a_resVar) :=
  match(in_txt, in_a_eThen, in_a_resVar, in_a_exp)
    local
      Tpl.Text txt;
      Tpl.Text a_resVar;
      DAE.Exp a_exp;
      Tpl.Text i_eThen;
      DAE.Type ret_0;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           a_resVar,
           _ )
      then (txt, a_resVar);

    case ( txt,
           i_eThen,
           a_resVar,
           a_exp )
      equation
        ret_0 = Expression.typeof(a_exp);
        (txt, a_resVar, i_eThen) = resultVarAssignment(txt, ret_0, a_resVar, i_eThen);
      then (txt, a_resVar);
  end match;
end fun_920;

protected function fun_921
  input Tpl.Text in_txt;
  input Tpl.Text in_a_eElse;
  input Tpl.Text in_a_resVar;
  input DAE.Exp in_a_exp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_resVar;
algorithm
  (out_txt, out_a_resVar) :=
  match(in_txt, in_a_eElse, in_a_resVar, in_a_exp)
    local
      Tpl.Text txt;
      Tpl.Text a_resVar;
      DAE.Exp a_exp;
      Tpl.Text i_eElse;
      DAE.Type ret_0;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           a_resVar,
           _ )
      then (txt, a_resVar);

    case ( txt,
           i_eElse,
           a_resVar,
           a_exp )
      equation
        ret_0 = Expression.typeof(a_exp);
        (txt, a_resVar, i_eElse) = resultVarAssignment(txt, ret_0, a_resVar, i_eElse);
      then (txt, a_resVar);
  end match;
end fun_921;

protected function fun_922
  input Tpl.Text in_txt;
  input Tpl.Text in_a_shortIfExp;
  input Tpl.Text in_a_eElse;
  input Tpl.Text in_a_preExpElse;
  input Tpl.Text in_a_eThen;
  input Tpl.Text in_a_preExpThen;
  input Tpl.Text in_a_condExp;
  input Tpl.Text in_a_preExp;
  input DAE.Exp in_a_exp;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls) :=
  match(in_txt, in_a_shortIfExp, in_a_eElse, in_a_preExpElse, in_a_eThen, in_a_preExpThen, in_a_condExp, in_a_preExp, in_a_exp, in_a_varDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_eElse;
      Tpl.Text a_preExpElse;
      Tpl.Text a_eThen;
      Tpl.Text a_preExpThen;
      Tpl.Text a_condExp;
      Tpl.Text a_preExp;
      DAE.Exp a_exp;
      Tpl.Text a_varDecls;
      DAE.Type ret_2;
      Tpl.Text l_resVar;
      Tpl.Text l_condVar;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           a_eElse,
           a_preExpElse,
           a_eThen,
           a_preExpThen,
           a_condExp,
           a_preExp,
           a_exp,
           a_varDecls )
      equation
        (l_condVar, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_boolean", a_varDecls);
        ret_2 = Expression.typeof(a_exp);
        (l_resVar, a_varDecls) = tempDeclTuple(Tpl.emptyTxt, ret_2, a_varDecls);
        a_preExp = Tpl.writeText(a_preExp, l_condVar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = (modelica_boolean)"));
        a_preExp = Tpl.writeText(a_preExp, a_condExp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING_LIST({
                                              ";\n",
                                              "if("
                                          }, false));
        a_preExp = Tpl.writeText(a_preExp, l_condVar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING_LIST({
                                              ")\n",
                                              "{\n"
                                          }, true));
        a_preExp = Tpl.pushBlock(a_preExp, Tpl.BT_INDENT(2));
        a_preExp = Tpl.writeText(a_preExp, a_preExpThen);
        a_preExp = Tpl.softNewLine(a_preExp);
        (a_preExp, l_resVar) = fun_920(a_preExp, a_eThen, l_resVar, a_exp);
        a_preExp = Tpl.softNewLine(a_preExp);
        a_preExp = Tpl.popBlock(a_preExp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING_LIST({
                                              "}\n",
                                              "else\n",
                                              "{\n"
                                          }, true));
        a_preExp = Tpl.pushBlock(a_preExp, Tpl.BT_INDENT(2));
        a_preExp = Tpl.writeText(a_preExp, a_preExpElse);
        a_preExp = Tpl.softNewLine(a_preExp);
        (a_preExp, l_resVar) = fun_921(a_preExp, a_eElse, l_resVar, a_exp);
        a_preExp = Tpl.softNewLine(a_preExp);
        a_preExp = Tpl.popBlock(a_preExp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("}"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_resVar);
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           _,
           a_eElse,
           _,
           a_eThen,
           _,
           a_condExp,
           a_preExp,
           _,
           a_varDecls )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_condExp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("?"));
        txt = Tpl.writeText(txt, a_eThen);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(":"));
        txt = Tpl.writeText(txt, a_eElse);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls);
  end match;
end fun_922;

public function daeExpIf
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_exp, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Exp i_exp;
      DAE.Exp i_expElse;
      DAE.Exp i_expThen;
      DAE.Exp i_expCond;
      Tpl.Text l_shortIfExp;
      Tpl.Text l_eElse;
      Tpl.Text l_preExpElse;
      Tpl.Text l_eThen;
      Tpl.Text l_preExpThen;
      Tpl.Text l_condExp;

    case ( txt,
           (i_exp as DAE.IFEXP(expCond = i_expCond, expThen = i_expThen, expElse = i_expElse)),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_condExp, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_expCond, a_context, a_preExp, a_varDecls, a_auxFunction);
        l_preExpThen = Tpl.emptyTxt;
        (l_eThen, l_preExpThen, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_expThen, a_context, l_preExpThen, a_varDecls, a_auxFunction);
        l_preExpElse = Tpl.emptyTxt;
        (l_eElse, l_preExpElse, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_expElse, a_context, l_preExpElse, a_varDecls, a_auxFunction);
        l_shortIfExp = fun_919(Tpl.emptyTxt, l_preExpThen, i_exp, l_preExpElse);
        (txt, a_preExp, a_varDecls) = fun_922(txt, l_shortIfExp, l_eElse, l_preExpElse, l_eThen, l_preExpThen, l_condExp, a_preExp, i_exp, a_varDecls);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end daeExpIf;

public function iteratedCrefStr
  input Tpl.Text txt;
  input DAE.ComponentRef a_cref;

  output Tpl.Text out_txt;
protected
  String ret_1;
  Tpl.Text txt_0;
algorithm
  txt_0 := CodegenUtil.crefStrNoUnderscore(Tpl.emptyTxt, a_cref);
  ret_1 := System.unquoteIdentifier(Tpl.textString(txt_0));
  out_txt := Tpl.writeStr(txt, ret_1);
end iteratedCrefStr;

protected function lm_925
  input Tpl.Text in_txt;
  input list<DAE.Type> in_items;
  input Tpl.Text in_a_rhs;
  input Tpl.Text in_a_lhs;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_rhs, in_a_lhs)
    local
      Tpl.Text txt;
      list<DAE.Type> rest;
      Tpl.Text a_rhs;
      Tpl.Text a_lhs;
      Integer x_i1;

    case ( txt,
           {},
           _,
           _ )
      then txt;

    case ( txt,
           _ :: rest,
           a_rhs,
           a_lhs )
      equation
        x_i1 = Tpl.getIteri_i0(txt);
        txt = Tpl.writeText(txt, a_lhs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".c"));
        txt = Tpl.writeStr(txt, intString(x_i1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, a_rhs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".c"));
        txt = Tpl.writeStr(txt, intString(x_i1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        txt = lm_925(txt, rest, a_rhs, a_lhs);
      then txt;
  end match;
end lm_925;

protected function fun_926
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;
  input Tpl.Text in_a_lhs;
  input Tpl.Text in_a_rhs;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty, in_a_lhs, in_a_rhs)
    local
      Tpl.Text txt;
      Tpl.Text a_lhs;
      Tpl.Text a_rhs;
      list<DAE.Type> i_types;

    case ( txt,
           DAE.T_TUPLE(types = i_types),
           a_lhs,
           a_rhs )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(1, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_925(txt, i_types, a_rhs, a_lhs);
        txt = Tpl.popIter(txt);
      then txt;

    case ( txt,
           _,
           a_lhs,
           a_rhs )
      equation
        txt = Tpl.writeText(txt, a_lhs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, a_rhs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_926;

public function resultVarAssignment
  input Tpl.Text txt;
  input DAE.Type a_ty;
  input Tpl.Text a_lhs;
  input Tpl.Text a_rhs;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_lhs;
  output Tpl.Text out_a_rhs;
algorithm
  out_txt := fun_926(txt, a_ty, a_lhs, a_rhs);
  out_a_lhs := a_lhs;
  out_a_rhs := a_rhs;
end resultVarAssignment;

protected function lm_928
  input Tpl.Text in_txt;
  input list<tuple<DAE.Exp, String>> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_name;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context, in_a_name)
    local
      Tpl.Text txt;
      list<tuple<DAE.Exp, String>> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      Tpl.Text a_name;
      DAE.Exp i_exp;
      String i_compn;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           (i_exp, i_compn) :: rest,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context,
           a_name )
      equation
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("._"));
        txt = Tpl.writeStr(txt, i_compn);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExp(txt, i_exp, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_928(txt, rest, a_auxFunction, a_varDecls, a_preExp, a_context, a_name);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end lm_928;

public function daeExpRecord
  input Tpl.Text in_txt;
  input DAE.Exp in_a_rec;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_rec, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      list<String> i_comp;
      list<DAE.Exp> i_exps;
      Absyn.Path i_path;
      list<tuple<DAE.Exp, String>> ret_3;
      Tpl.Text l_ass;
      Tpl.Text txt_1;
      Tpl.Text l_name;

    case ( txt,
           DAE.RECORD(path = i_path, exps = i_exps, comp = i_comp),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt_1 = CodegenUtil.underscorePath(Tpl.emptyTxt, i_path);
        (l_name, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(txt_1), a_varDecls);
        ret_3 = List.zip(i_exps, i_comp);
        (l_ass, a_auxFunction, a_varDecls, a_preExp) = lm_928(Tpl.emptyTxt, ret_3, a_auxFunction, a_varDecls, a_preExp, a_context, l_name);
        a_preExp = Tpl.writeText(a_preExp, l_ass);
        txt = Tpl.writeText(txt, l_name);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end daeExpRecord;

protected function lm_930
  input Tpl.Text in_txt;
  input list<DAE.Type> in_items;
  input Tpl.Text in_a_ret;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_ret;
algorithm
  (out_txt, out_a_ret) :=
  match(in_txt, in_items, in_a_ret)
    local
      Tpl.Text txt;
      list<DAE.Type> rest;
      Tpl.Text a_ret;
      DAE.Type i_ty;
      Integer ret_1;
      Tpl.Text l_name;

    case ( txt,
           {},
           a_ret )
      then (txt, a_ret);

    case ( txt,
           i_ty :: rest,
           a_ret )
      equation
        l_name = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("tmp"));
        ret_1 = System.tmpTick();
        l_name = Tpl.writeStr(l_name, intString(ret_1));
        a_ret = Tpl.writeTok(a_ret, Tpl.ST_STRING(", "));
        a_ret = Tpl.writeText(a_ret, l_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = expTypeArrayIf(txt, i_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, l_name);
        (txt, a_ret) = lm_930(txt, rest, a_ret);
      then (txt, a_ret);
  end match;
end lm_930;

protected function fun_931
  input Tpl.Text in_txt;
  input DAE.Type in_a_t_funcResultType;
  input Tpl.Text in_a_ret;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_ret;
algorithm
  (out_txt, out_a_ret) :=
  match(in_txt, in_a_t_funcResultType, in_a_ret)
    local
      Tpl.Text txt;
      Tpl.Text a_ret;
      list<DAE.Type> i_tys;

    case ( txt,
           DAE.T_TUPLE(types = _ :: i_tys),
           a_ret )
      equation
        (txt, a_ret) = lm_930(txt, i_tys, a_ret);
      then (txt, a_ret);

    case ( txt,
           _,
           a_ret )
      then (txt, a_ret);
  end match;
end fun_931;

protected function fun_932
  input Tpl.Text in_txt;
  input DAE.Type in_a_t_funcResultType;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_t_funcResultType)
    local
      Tpl.Text txt;

    case ( txt,
           DAE.T_NORETCALL() )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("return "));
      then txt;
  end match;
end fun_932;

protected function lm_933
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Exp i_e;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           i_e :: rest,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExp(txt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_933(txt, rest, a_auxFunction, a_varDecls, a_preExp, a_context);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end lm_933;

protected function fun_934
  input Tpl.Text in_txt;
  input Boolean in_a_attr_isFunctionPointer;
  input Absyn.Path in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_attr_isFunctionPointer, in_a_name)
    local
      Tpl.Text txt;
      Absyn.Path a_name;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", _"));
        txt = CodegenUtil.underscorePath(txt, a_name);
      then txt;
  end match;
end fun_934;

protected function fun_935
  input Tpl.Text in_txt;
  input Boolean in_a_attr_isFunctionPointer;
  input list<DAE.Exp> in_a_expList;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_attr_isFunctionPointer, in_a_expList)
    local
      Tpl.Text txt;
      list<DAE.Exp> a_expList;
      Integer ret_2;
      Integer ret_1;
      Integer ret_0;

    case ( txt,
           false,
           a_expList )
      equation
        ret_0 = listLength(a_expList);
        txt = daeExpMetaHelperBoxStart(txt, ret_0);
      then txt;

    case ( txt,
           _,
           a_expList )
      equation
        ret_1 = listLength(a_expList);
        ret_2 = SimCodeFunctionUtil.incrementInt(ret_1, 1);
        txt = daeExpMetaHelperBoxStart(txt, ret_2);
      then txt;
  end match;
end fun_935;

protected function fun_936
  input Tpl.Text in_txt;
  input DAE.Type in_a_t_funcResultType;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_t_funcResultType)
    local
      Tpl.Text txt;

    case ( txt,
           DAE.T_NORETCALL() )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_metatype"));
      then txt;
  end match;
end fun_936;

protected function lm_937
  input Tpl.Text in_txt;
  input list<DAE.FuncArg> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<DAE.FuncArg> rest;
      String i_a_name;
      DAE.Type i_a_ty;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           DAE.FUNCARG(ty = i_a_ty, name = i_a_name) :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = expTypeArrayIf(txt, i_a_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeStr(txt, i_a_name);
        txt = lm_937(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_937(txt, rest);
      then txt;
  end match;
end lm_937;

protected function lm_938
  input Tpl.Text in_txt;
  input list<DAE.FuncArg> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<DAE.FuncArg> rest;
      Integer x_i1;
      String i_a_name;
      DAE.Type i_a_ty;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           DAE.FUNCARG(ty = i_a_ty, name = i_a_name) :: rest )
      equation
        x_i1 = Tpl.getIteri_i0(txt);
        txt = expTypeArrayIf(txt, i_a_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeStr(txt, i_a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = MMC_FETCH(MMC_OFFSET(MMC_UNTAGPTR(closure),"));
        txt = Tpl.writeStr(txt, intString(x_i1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("));"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.nextIter(txt);
        txt = lm_938(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_938(txt, rest);
      then txt;
  end match;
end lm_938;

protected function lm_939
  input Tpl.Text in_txt;
  input list<DAE.FuncArg> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<DAE.FuncArg> rest;
      String i_a_name;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           DAE.FUNCARG(name = i_a_name) :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeStr(txt, i_a_name);
        txt = lm_939(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_939(txt, rest);
      then txt;
  end match;
end lm_939;

protected function lm_940
  input Tpl.Text in_txt;
  input list<DAE.FuncArg> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<DAE.FuncArg> rest;
      String i_a_name;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           DAE.FUNCARG(name = i_a_name) :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeStr(txt, i_a_name);
        txt = lm_940(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_940(txt, rest);
      then txt;
  end match;
end lm_940;

protected function lm_941
  input Tpl.Text in_txt;
  input list<DAE.FuncArg> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<DAE.FuncArg> rest;
      String i_a_name;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           DAE.FUNCARG(name = i_a_name) :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeStr(txt, i_a_name);
        txt = lm_941(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_941(txt, rest);
      then txt;
  end match;
end lm_941;

protected function fun_942
  input Tpl.Text in_txt;
  input Boolean in_a_attr_isFunctionPointer;
  input list<DAE.FuncArg> in_a_t_funcArg;
  input DAE.Type in_a_orig;
  input Tpl.Text in_a_ret;
  input list<DAE.FuncArg> in_a_orig_funcArg;
  input Absyn.Path in_a_name;
  input Tpl.Text in_a_return;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_attr_isFunctionPointer, in_a_t_funcArg, in_a_orig, in_a_ret, in_a_orig_funcArg, in_a_name, in_a_return)
    local
      Tpl.Text txt;
      list<DAE.FuncArg> a_t_funcArg;
      DAE.Type a_orig;
      Tpl.Text a_ret;
      list<DAE.FuncArg> a_orig_funcArg;
      Absyn.Path a_name;
      Tpl.Text a_return;
      Integer ret_6;
      Integer ret_5;
      list<DAE.FuncArg> ret_4;
      Tpl.Text l_typeCast2;
      Tpl.Text l_typeCast1;
      Tpl.Text l_func;
      Tpl.Text l_fname;

    case ( txt,
           false,
           _,
           _,
           a_ret,
           a_orig_funcArg,
           a_name,
           a_return )
      equation
        txt = Tpl.writeText(txt, a_return);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("boxptr_"));
        txt = CodegenUtil.underscorePath(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(thData"));
        txt = lm_939(txt, a_orig_funcArg);
        txt = Tpl.writeText(txt, a_ret);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;

    case ( txt,
           _,
           a_t_funcArg,
           a_orig,
           a_ret,
           a_orig_funcArg,
           a_name,
           a_return )
      equation
        l_fname = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("_"));
        l_fname = CodegenUtil.underscorePath(l_fname, a_name);
        l_func = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("(MMC_FETCH(MMC_OFFSET(MMC_UNTAGPTR("));
        l_func = Tpl.writeText(l_func, l_fname);
        l_func = Tpl.writeTok(l_func, Tpl.ST_STRING("), 1)))"));
        l_typeCast1 = generateTypeCastFromType(Tpl.emptyTxt, a_orig, true);
        l_typeCast2 = generateTypeCastFromType(Tpl.emptyTxt, a_orig, false);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_fnptr "));
        txt = Tpl.writeText(txt, l_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = MMC_FETCH(MMC_OFFSET(MMC_UNTAGPTR(closure),"));
        ret_4 = List.setDifference(a_orig_funcArg, a_t_funcArg);
        ret_5 = listLength(ret_4);
        ret_6 = SimCodeFunctionUtil.incrementInt(ret_5, 1);
        txt = Tpl.writeStr(txt, intString(ret_6));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "));\n",
                                    "if (MMC_FETCH(MMC_OFFSET(MMC_UNTAGPTR("
                                }, false));
        txt = Tpl.writeText(txt, l_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("),2))) {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_return);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" ("));
        txt = Tpl.writeText(txt, l_typeCast1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, l_func);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") (thData, MMC_FETCH(MMC_OFFSET(MMC_UNTAGPTR("));
        txt = Tpl.writeText(txt, l_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("),2))"));
        txt = lm_940(txt, a_orig_funcArg);
        txt = Tpl.writeText(txt, a_ret);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(");\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("} else { /* No closure in the called variable */\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_return);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" ("));
        txt = Tpl.writeText(txt, l_typeCast2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, l_func);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") (thData"));
        txt = lm_941(txt, a_orig_funcArg);
        txt = Tpl.writeText(txt, a_ret);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(");\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;
  end match;
end fun_942;

protected function fun_943
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("&"));
      then txt;
  end match;
end fun_943;

public function daeExpPartEvalFunction
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_exp, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Type i_origType;
      DAE.Type i_ty;
      DAE.Exp i_exp;
      DAE.Type i_orig;
      list<DAE.FuncArg> i_orig_funcArg;
      list<DAE.FuncArg> i_t_funcArg;
      Boolean i_attr_isFunctionPointer;
      list<DAE.Exp> i_expList;
      Absyn.Path i_name;
      DAE.Type i_t_funcResultType;
      Tpl.Text txt_10;
      String ret_11;
      String ret_10;
      Boolean ret_9;
      list<DAE.FuncArg> ret_8;
      Tpl.Text l_createClosure;
      Tpl.Text l_closure;
      Tpl.Text l_return;
      Integer ret_4;
      Tpl.Text l_func;
      Tpl.Text l_retInput;
      Tpl.Text l_ret;
      Tpl.Text l_varDeclInner;

    case ( txt,
           DAE.PARTEVALFUNCTION(ty = DAE.T_FUNCTION_REFERENCE_VAR(functionType = DAE.T_FUNCTION(funcResultType = i_t_funcResultType, funcArg = i_t_funcArg)), origType = DAE.T_FUNCTION_REFERENCE_VAR(functionType = (i_orig as DAE.T_FUNCTION(functionAttributes = DAE.FUNCTION_ATTRIBUTES(isFunctionPointer = i_attr_isFunctionPointer), path = i_name, funcArg = i_orig_funcArg))), expList = i_expList),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        l_varDeclInner = Tpl.emptyTxt;
        l_ret = Tpl.emptyTxt;
        (l_retInput, l_ret) = fun_931(Tpl.emptyTxt, i_t_funcResultType, l_ret);
        l_func = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("closure"));
        ret_4 = System.tmpTickIndex(2);
        l_func = Tpl.writeStr(l_func, intString(ret_4));
        l_func = Tpl.writeTok(l_func, Tpl.ST_STRING("_"));
        l_func = CodegenUtil.underscorePath(l_func, i_name);
        l_return = fun_932(Tpl.emptyTxt, i_t_funcResultType);
        (l_closure, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_metatype", a_varDecls);
        (l_createClosure, a_auxFunction, a_varDecls, a_preExp) = lm_933(Tpl.emptyTxt, i_expList, a_auxFunction, a_varDecls, a_preExp, a_context);
        l_createClosure = fun_934(l_createClosure, i_attr_isFunctionPointer, i_name);
        a_preExp = Tpl.writeText(a_preExp, l_closure);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = mmc_mk_box"));
        a_preExp = fun_935(a_preExp, i_attr_isFunctionPointer, i_expList);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("0"));
        a_preExp = Tpl.writeText(a_preExp, l_createClosure);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        a_auxFunction = Tpl.writeTok(a_auxFunction, Tpl.ST_STRING("static "));
        a_auxFunction = fun_936(a_auxFunction, i_t_funcResultType);
        a_auxFunction = Tpl.writeTok(a_auxFunction, Tpl.ST_STRING(" "));
        a_auxFunction = Tpl.writeText(a_auxFunction, l_func);
        a_auxFunction = Tpl.writeTok(a_auxFunction, Tpl.ST_STRING("(threadData_t *thData, modelica_metatype closure"));
        a_auxFunction = lm_937(a_auxFunction, i_t_funcArg);
        a_auxFunction = Tpl.writeText(a_auxFunction, l_retInput);
        a_auxFunction = Tpl.writeTok(a_auxFunction, Tpl.ST_STRING_LIST({
                                                        ")\n",
                                                        "{\n"
                                                    }, true));
        a_auxFunction = Tpl.pushBlock(a_auxFunction, Tpl.BT_INDENT(2));
        a_auxFunction = Tpl.writeText(a_auxFunction, l_varDeclInner);
        a_auxFunction = Tpl.softNewLine(a_auxFunction);
        ret_8 = List.setDifference(i_orig_funcArg, i_t_funcArg);
        a_auxFunction = Tpl.pushIter(a_auxFunction, Tpl.ITER_OPTIONS(1, NONE(), NONE(), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        a_auxFunction = lm_938(a_auxFunction, ret_8);
        a_auxFunction = Tpl.popIter(a_auxFunction);
        a_auxFunction = Tpl.softNewLine(a_auxFunction);
        a_auxFunction = fun_942(a_auxFunction, i_attr_isFunctionPointer, i_t_funcArg, i_orig, l_ret, i_orig_funcArg, i_name, l_return);
        a_auxFunction = Tpl.softNewLine(a_auxFunction);
        a_auxFunction = Tpl.popBlock(a_auxFunction);
        a_auxFunction = Tpl.writeTok(a_auxFunction, Tpl.ST_STRING("}"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(modelica_fnptr) mmc_mk_box2(0,"));
        ret_9 = Flags.isSet(Flags.OMC_RELOCATABLE_FUNCTIONS);
        txt = fun_943(txt, ret_9);
        txt = Tpl.writeText(txt, l_func);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, l_closure);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_exp as DAE.PARTEVALFUNCTION(ty = i_ty, origType = i_origType)),
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt_10 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("PARTEVALFUNCTION: "));
        txt_10 = ExpressionDumpTpl.dumpExp(txt_10, i_exp, "\"");
        txt_10 = Tpl.writeTok(txt_10, Tpl.ST_STRING(", ty="));
        ret_10 = Types.unparseType(i_ty);
        txt_10 = Tpl.writeStr(txt_10, ret_10);
        txt_10 = Tpl.writeTok(txt_10, Tpl.ST_STRING(", origType="));
        ret_11 = Types.unparseType(i_origType);
        txt_10 = Tpl.writeStr(txt_10, ret_11);
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 6097, 13), Tpl.textString(txt_10));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end daeExpPartEvalFunction;

protected function fun_945
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_argStr;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input DAE.Exp in_a_e1;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls) :=
  match(in_txt, in_mArg, in_a_context, in_a_argStr, in_a_preExp, in_a_varDecls, in_a_e1)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_argStr;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      DAE.Exp a_e1;
      Tpl.Text txt_4;
      String ret_4;
      Tpl.Text txt_3;
      Tpl.Text l_cstr;
      Tpl.Text txt_1;
      Tpl.Text l_tmp;

    case ( txt,
           false,
           a_context,
           a_argStr,
           a_preExp,
           a_varDecls,
           a_e1 )
      equation
        txt_1 = expTypeFromExpModelica(Tpl.emptyTxt, a_e1);
        (l_tmp, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(txt_1), a_varDecls);
        l_cstr = ExpressionDumpTpl.dumpExp(Tpl.emptyTxt, a_e1, "\"");
        a_preExp = Tpl.writeText(a_preExp, l_tmp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = "));
        a_preExp = Tpl.writeText(a_preExp, a_argStr);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_LINE(";\n"));
        txt_3 = Tpl.writeText(Tpl.emptyTxt, l_tmp);
        txt_3 = Tpl.writeTok(txt_3, Tpl.ST_STRING(" >= 0.0"));
        txt_4 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("\"Model error: Argument of sqrt("));
        ret_4 = Util.escapeModelicaStringToCString(Tpl.textString(l_cstr));
        txt_4 = Tpl.writeStr(txt_4, ret_4);
        txt_4 = Tpl.writeTok(txt_4, Tpl.ST_STRING(") was %g should be >= 0\", "));
        txt_4 = Tpl.writeText(txt_4, l_tmp);
        (a_preExp, txt_3, txt_4, a_varDecls) = assertCommonVar(a_preExp, txt_3, txt_4, a_context, a_varDecls, AbsynUtil.dummyInfo);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("sqrt("));
        txt = Tpl.writeText(txt, l_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           _,
           _,
           a_argStr,
           a_preExp,
           a_varDecls,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("sqrt("));
        txt = Tpl.writeText(txt, a_argStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls);
  end match;
end fun_945;

protected function fun_946
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_var2;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_tp__str;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_varDecls) :=
  match(in_txt, in_mArg, in_a_var2, in_a_varDecls, in_a_tp__str)
    local
      Tpl.Text txt;
      Tpl.Text a_var2;
      Tpl.Text a_varDecls;
      Tpl.Text a_tp__str;

    case ( txt,
           false,
           _,
           a_varDecls,
           a_tp__str )
      equation
        (txt, a_varDecls) = tempDecl(txt, Tpl.textString(a_tp__str), a_varDecls);
      then (txt, a_varDecls);

    case ( txt,
           _,
           a_var2,
           a_varDecls,
           _ )
      equation
        txt = Tpl.writeText(txt, a_var2);
      then (txt, a_varDecls);
  end match;
end fun_946;

protected function fun_947
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_var2;
  input Tpl.Text in_a_tvar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_var2, in_a_tvar)
    local
      Tpl.Text txt;
      Tpl.Text a_var2;
      Tpl.Text a_tvar;

    case ( txt,
           false,
           a_var2,
           a_tvar )
      equation
        txt = Tpl.writeText(txt, a_tvar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, a_var2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_947;

protected function fun_948
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_cstr;
  input Tpl.Text in_a_tvar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_cstr, in_a_tvar)
    local
      Tpl.Text txt;
      Tpl.Text a_cstr;
      Tpl.Text a_tvar;
      String ret_0;

    case ( txt,
           false,
           a_cstr,
           a_tvar )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if ("));
        txt = Tpl.writeText(txt, a_tvar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" == 0) {throwStreamPrint(threadData, \"Division by zero %s\", \""));
        ret_0 = Util.escapeModelicaStringToCString(Tpl.textString(a_cstr));
        txt = Tpl.writeStr(txt, ret_0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\");}"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_948;

protected function fun_949
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_cstr;
  input Tpl.Text in_a_tvar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_cstr, in_a_tvar)
    local
      Tpl.Text txt;
      Tpl.Text a_cstr;
      Tpl.Text a_tvar;
      String ret_0;

    case ( txt,
           false,
           a_cstr,
           a_tvar )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if ("));
        txt = Tpl.writeText(txt, a_tvar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" == 0) {throwStreamPrint(threadData, \"Division by zero %s\", \""));
        ret_0 = Util.escapeModelicaStringToCString(Tpl.textString(a_cstr));
        txt = Tpl.writeStr(txt, ret_0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\");}"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _,
           _,
           a_tvar )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if ("));
        txt = Tpl.writeText(txt, a_tvar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" == 0) {"));
        txt = generateThrow(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";}"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;
  end match;
end fun_949;

protected function fun_950
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_cstr;
  input Tpl.Text in_a_tvar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_cstr, in_a_tvar)
    local
      Tpl.Text txt;
      Tpl.Text a_cstr;
      Tpl.Text a_tvar;
      String ret_0;

    case ( txt,
           false,
           a_cstr,
           a_tvar )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if ("));
        txt = Tpl.writeText(txt, a_tvar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" == 0) {throwStreamPrint(threadData, \"Division by zero %s\", \""));
        ret_0 = Util.escapeModelicaStringToCString(Tpl.textString(a_cstr));
        txt = Tpl.writeStr(txt, ret_0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\");}"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _,
           _,
           a_tvar )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if ("));
        txt = Tpl.writeText(txt, a_tvar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" == 0) {"));
        txt = generateThrow(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";}"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;
  end match;
end fun_950;

protected function fun_951
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_tvar;
  input Tpl.Text in_a_var1;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_tvar, in_a_var1)
    local
      Tpl.Text txt;
      Tpl.Text a_tvar;
      Tpl.Text a_var1;

    case ( txt,
           false,
           a_tvar,
           a_var1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("ldiv("));
        txt = Tpl.writeText(txt, a_var1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, a_tvar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(").quot"));
      then txt;

    case ( txt,
           _,
           a_tvar,
           a_var1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(modelica_integer)(("));
        txt = Tpl.writeText(txt, a_var1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") / "));
        txt = Tpl.writeText(txt, a_tvar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;
  end match;
end fun_951;

protected function fun_952
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_cstr;
  input Tpl.Text in_a_tvar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_cstr, in_a_tvar)
    local
      Tpl.Text txt;
      Tpl.Text a_cstr;
      Tpl.Text a_tvar;
      String ret_0;

    case ( txt,
           false,
           a_cstr,
           a_tvar )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if ("));
        txt = Tpl.writeText(txt, a_tvar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" == 0.0) {throwStreamPrint(threadData, \"Division by zero %s\", \""));
        ret_0 = Util.escapeModelicaStringToCString(Tpl.textString(a_cstr));
        txt = Tpl.writeStr(txt, ret_0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\");}"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _,
           _,
           a_tvar )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if ("));
        txt = Tpl.writeText(txt, a_tvar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" == 0.0) {"));
        txt = generateThrow(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";}"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;
  end match;
end fun_952;

protected function lm_953
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Exp i_dim;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           i_dim :: rest,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExp(txt, i_dim, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_953(txt, rest, a_auxFunction, a_varDecls, a_preExp, a_context);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end lm_953;

protected function fun_954
  input Tpl.Text in_txt;
  input Integer in_a_sz;
  input Tpl.Text in_a_tvarc;
  input Integer in_a_ix;
  input Tpl.Text in_a_val;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_sz, in_a_tvarc, in_a_ix, in_a_val)
    local
      Tpl.Text txt;
      Tpl.Text a_tvarc;
      Integer a_ix;
      Tpl.Text a_val;

    case ( txt,
           0,
           a_tvarc,
           a_ix,
           a_val )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if (size_of_dimension_base_array("));
        txt = Tpl.writeText(txt, a_val);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeStr(txt, intString(a_ix));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")>1) "));
        txt = Tpl.writeText(txt, a_tvarc);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("++;"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           1,
           _,
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_tvarc,
           _,
           _ )
      equation
        txt = Tpl.writeText(txt, a_tvarc);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("++;"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;
  end match;
end fun_954;

protected function lm_955
  input Tpl.Text in_txt;
  input list<Integer> in_items;
  input Tpl.Text in_a_tvarc;
  input Tpl.Text in_a_val;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_tvarc, in_a_val)
    local
      Tpl.Text txt;
      list<Integer> rest;
      Tpl.Text a_tvarc;
      Tpl.Text a_val;
      Integer x_ix;
      Integer i_sz;

    case ( txt,
           {},
           _,
           _ )
      then txt;

    case ( txt,
           i_sz :: rest,
           a_tvarc,
           a_val )
      equation
        x_ix = Tpl.getIteri_i0(txt);
        txt = fun_954(txt, i_sz, a_tvarc, x_ix, a_val);
        txt = Tpl.nextIter(txt);
        txt = lm_955(txt, rest, a_tvarc, a_val);
      then txt;
  end match;
end lm_955;

protected function lm_956
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Exp i_array;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           i_array :: rest,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExpAsLValue(txt, i_array, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_956(txt, rest, a_auxFunction, a_varDecls, a_preExp, a_context);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end lm_956;

protected function lm_957
  input Tpl.Text in_txt;
  input list<String> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<String> rest;
      String i_s;
      String ret_0;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_s :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        ret_0 = Util.escapeModelicaStringToCString(i_s);
        txt = Tpl.writeStr(txt, ret_0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        txt = Tpl.nextIter(txt);
        txt = lm_957(txt, rest);
      then txt;
  end match;
end lm_957;

protected function fun_958
  input Tpl.Text in_txt;
  input DAE.Type in_mArg;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_varDecls) :=
  match(in_txt, in_mArg, in_a_varDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_varDecls;
      list<String> i_names;
      Integer ret_1;
      Tpl.Text l_strs;

    case ( txt,
           DAE.T_ENUMERATION(names = i_names),
           a_varDecls )
      equation
        l_strs = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_strs = lm_957(l_strs, i_names);
        l_strs = Tpl.popIter(l_strs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        ret_1 = listLength(i_names);
        (txt, _, l_strs, a_varDecls) = tempDeclArray(txt, "const char*", Tpl.stringText(intString(ret_1)), l_strs, a_varDecls);
      then (txt, a_varDecls);

    case ( txt,
           _,
           a_varDecls )
      then (txt, a_varDecls);
  end match;
end fun_958;

protected function fun_959
  input Tpl.Text in_txt;
  input Tpl.Text in_a_enumStr;
  input DAE.Exp in_a_s;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_enumStr, in_a_s)
    local
      Tpl.Text txt;
      DAE.Exp a_s;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           a_s )
      equation
        txt = expTypeFromExpModelica(txt, a_s);
      then txt;

    case ( txt,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("enum"));
      then txt;
  end match;
end fun_959;

protected function fun_960
  input Tpl.Text in_txt;
  input String in_mArg;
  input Tpl.Text in_a_enumStr;
  input Tpl.Text in_a_leftjustExp;
  input Tpl.Text in_a_minlenExp;
  input Tpl.Text in_a_sExp;
  input Tpl.Text in_a_typeStr;
  input Tpl.Text in_a_tvar;
  input Tpl.Text in_a_preExp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_preExp) :=
  match(in_txt, in_mArg, in_a_enumStr, in_a_leftjustExp, in_a_minlenExp, in_a_sExp, in_a_typeStr, in_a_tvar, in_a_preExp)
    local
      Tpl.Text txt;
      Tpl.Text a_enumStr;
      Tpl.Text a_leftjustExp;
      Tpl.Text a_minlenExp;
      Tpl.Text a_sExp;
      Tpl.Text a_typeStr;
      Tpl.Text a_tvar;
      Tpl.Text a_preExp;

    case ( txt,
           "modelica_real",
           _,
           a_leftjustExp,
           a_minlenExp,
           a_sExp,
           a_typeStr,
           a_tvar,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_tvar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = "));
        a_preExp = Tpl.writeText(a_preExp, a_typeStr);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("_to_modelica_string("));
        a_preExp = Tpl.writeText(a_preExp, a_sExp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, a_minlenExp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, a_leftjustExp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", 6);"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_tvar);
      then (txt, a_preExp);

    case ( txt,
           "modelica_string",
           _,
           _,
           _,
           a_sExp,
           _,
           a_tvar,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_tvar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = "));
        a_preExp = Tpl.writeText(a_preExp, a_sExp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(";"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_tvar);
      then (txt, a_preExp);

    case ( txt,
           _,
           a_enumStr,
           a_leftjustExp,
           a_minlenExp,
           a_sExp,
           a_typeStr,
           a_tvar,
           a_preExp )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_tvar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = "));
        a_preExp = Tpl.writeText(a_preExp, a_typeStr);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("_to_modelica_string("));
        a_preExp = Tpl.writeText(a_preExp, a_sExp);
        a_preExp = Tpl.writeText(a_preExp, a_enumStr);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, a_minlenExp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, a_leftjustExp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_tvar);
      then (txt, a_preExp);
  end match;
end fun_960;

protected function fun_961
  input Tpl.Text in_txt;
  input String in_mArg;
  input Integer in_a_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_index)
    local
      Tpl.Text txt;
      Integer a_index;
      Integer ret_1;
      Integer ret_0;

    case ( txt,
           "omsic",
           a_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("omsi_on_sample_event(this_function, "));
        ret_0 = intSub(a_index, 1);
        txt = Tpl.writeStr(txt, intString(ret_0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", omsic_get_model_state())"));
      then txt;

    case ( txt,
           _,
           a_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("data->simulationInfo->samples["));
        ret_1 = intSub(a_index, 1);
        txt = Tpl.writeStr(txt, intString(ret_1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("]"));
      then txt;
  end match;
end fun_961;

protected function fun_962
  input Tpl.Text in_txt;
  input String in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_name)
    local
      Tpl.Text txt;

    case ( txt,
           "intBitAnd" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("&"));
      then txt;

    case ( txt,
           "intBitOr" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("|"));
      then txt;

    case ( txt,
           "intBitXor" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("^"));
      then txt;

    case ( txt,
           "intBitLShift" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<<"));
      then txt;

    case ( txt,
           "intBitRShift" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(">>"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_962;

protected function fun_963
  input Tpl.Text in_txt;
  input String in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_name)
    local
      Tpl.Text txt;

    case ( txt,
           "intBitAnd" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("&"));
      then txt;

    case ( txt,
           "intBitOr" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("|"));
      then txt;

    case ( txt,
           "intBitXor" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("^"));
      then txt;

    case ( txt,
           "intBitLShift" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<<"));
      then txt;

    case ( txt,
           "intBitRShift" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(">>"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_963;

protected function fun_964
  input Tpl.Text in_txt;
  input String in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_name)
    local
      Tpl.Text txt;

    case ( txt,
           "intBitAnd" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("&"));
      then txt;

    case ( txt,
           "intBitOr" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("|"));
      then txt;

    case ( txt,
           "intBitXor" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("^"));
      then txt;

    case ( txt,
           "intBitLShift" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<<"));
      then txt;

    case ( txt,
           "intBitRShift" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(">>"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_964;

protected function fun_965
  input Tpl.Text in_txt;
  input String in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_name)
    local
      Tpl.Text txt;

    case ( txt,
           "intBitAnd" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("&"));
      then txt;

    case ( txt,
           "intBitOr" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("|"));
      then txt;

    case ( txt,
           "intBitXor" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("^"));
      then txt;

    case ( txt,
           "intBitLShift" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<<"));
      then txt;

    case ( txt,
           "intBitRShift" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(">>"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_965;

protected function fun_966
  input Tpl.Text in_txt;
  input String in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_name)
    local
      Tpl.Text txt;

    case ( txt,
           "intBitAnd" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("&"));
      then txt;

    case ( txt,
           "intBitOr" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("|"));
      then txt;

    case ( txt,
           "intBitXor" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("^"));
      then txt;

    case ( txt,
           "intBitLShift" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<<"));
      then txt;

    case ( txt,
           "intBitRShift" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(">>"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_966;

protected function fun_967
  input Tpl.Text in_txt;
  input String in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_name)
    local
      Tpl.Text txt;

    case ( txt,
           "intBitAnd" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("&"));
      then txt;

    case ( txt,
           "intBitOr" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("|"));
      then txt;

    case ( txt,
           "intBitXor" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("^"));
      then txt;

    case ( txt,
           "intBitLShift" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<<"));
      then txt;

    case ( txt,
           "intBitRShift" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(">>"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_967;

protected function lm_968
  input Tpl.Text in_txt;
  input list<String> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<String> rest;
      String i_it;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_it :: rest )
      equation
        txt = Tpl.writeStr(txt, i_it);
        txt = lm_968(txt, rest);
      then txt;
  end match;
end lm_968;

protected function fun_969
  input Tpl.Text in_txt;
  input DAE.Type in_a_attr_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_attr_ty)
    local
      Tpl.Text txt;
      list<DAE.Type> i_ts;
      list<String> ret_1;
      Integer ret_0;

    case ( txt,
           DAE.T_TUPLE(types = _ :: i_ts) )
      equation
        ret_0 = listLength(i_ts);
        ret_1 = List.fill(", NULL", ret_0);
        txt = lm_968(txt, ret_1);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_969;

protected function fun_970
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_tvar2;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_tvar2)
    local
      Tpl.Text txt;
      Tpl.Text a_tvar2;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_tvar2 )
      equation
        txt = Tpl.writeText(txt, a_tvar2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".dim_size = 0;"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;
  end match;
end fun_970;

protected function fun_971
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_tvar2;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_tvar2)
    local
      Tpl.Text txt;
      Tpl.Text a_tvar2;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_tvar2 )
      equation
        txt = Tpl.writeText(txt, a_tvar2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".dim_size = 0;"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;
  end match;
end fun_971;

protected function fun_972
  input Tpl.Text in_txt;
  input DAE.Type in_a_attr_ty;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls) :=
  match(in_txt, in_a_attr_ty, in_a_preExp, in_a_varDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      DAE.Type i_t;
      Boolean ret_4;
      Tpl.Text txt_3;
      Boolean ret_2;
      Tpl.Text txt_1;
      Tpl.Text l_tvar2;

    case ( txt,
           DAE.T_NORETCALL(),
           a_preExp,
           a_varDecls )
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.T_TUPLE(types = i_t :: _),
           a_preExp,
           a_varDecls )
      equation
        txt_1 = expTypeArrayIf(Tpl.emptyTxt, i_t);
        (l_tvar2, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(txt_1), a_varDecls);
        ret_2 = Expression.isArrayType(i_t);
        a_preExp = fun_970(a_preExp, ret_2, l_tvar2);
        txt = Tpl.writeText(txt, l_tvar2);
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           i_t,
           a_preExp,
           a_varDecls )
      equation
        txt_3 = expTypeArrayIf(Tpl.emptyTxt, i_t);
        (l_tvar2, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(txt_3), a_varDecls);
        ret_4 = Expression.isArrayType(i_t);
        a_preExp = fun_971(a_preExp, ret_4, l_tvar2);
        txt = Tpl.writeText(txt, l_tvar2);
      then (txt, a_preExp, a_varDecls);
  end match;
end fun_972;

protected function fun_973
  input Tpl.Text in_txt;
  input Tpl.Text in_a_tvar;
  input Tpl.Text in_a_res;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_tvar, in_a_res)
    local
      Tpl.Text txt;
      Tpl.Text a_res;
      Tpl.Text i_tvar;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           a_res )
      equation
        txt = Tpl.writeText(txt, a_res);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           i_tvar,
           a_res )
      equation
        txt = Tpl.writeText(txt, i_tvar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, a_res);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;
  end match;
end fun_973;

protected function fun_974
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input DAE.Type in_a_attr_ty;
  input Absyn.Path in_a_exp_path;
  input Tpl.Text in_a_res;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls) :=
  match(in_txt, in_mArg, in_a_preExp, in_a_varDecls, in_a_attr_ty, in_a_exp_path, in_a_res)
    local
      Tpl.Text txt;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      DAE.Type a_attr_ty;
      Absyn.Path a_exp_path;
      Tpl.Text a_res;
      Tpl.Text l_tvar;
      Tpl.Text l_funName;

    case ( txt,
           false,
           a_preExp,
           a_varDecls,
           _,
           _,
           a_res )
      equation
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           _,
           a_preExp,
           a_varDecls,
           a_attr_ty,
           a_exp_path,
           a_res )
      equation
        l_funName = CodegenUtil.underscorePath(Tpl.emptyTxt, a_exp_path);
        (l_tvar, a_preExp, a_varDecls) = fun_972(Tpl.emptyTxt, a_attr_ty, a_preExp, a_varDecls);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("SIM_PROF_TICK_FN("));
        a_preExp = Tpl.writeText(a_preExp, l_funName);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("_index);"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        a_preExp = fun_973(a_preExp, l_tvar, a_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("SIM_PROF_ACC_FN("));
        a_preExp = Tpl.writeText(a_preExp, l_funName);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("_index);"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tvar);
      then (txt, a_preExp, a_varDecls);
  end match;
end fun_974;

protected function fun_975
  input Tpl.Text in_txt;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input DAE.Type in_a_attr_ty;
  input Absyn.Path in_a_exp_path;
  input Boolean in_a_attr_builtin;
  input Tpl.Text in_a_res;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls) :=
  match(in_txt, in_a_context, in_a_preExp, in_a_varDecls, in_a_attr_ty, in_a_exp_path, in_a_attr_builtin, in_a_res)
    local
      Tpl.Text txt;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      DAE.Type a_attr_ty;
      Absyn.Path a_exp_path;
      Boolean a_attr_builtin;
      Tpl.Text a_res;
      Boolean ret_2;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           SimCodeFunction.FUNCTION_CONTEXT(cref_prefix = _),
           a_preExp,
           a_varDecls,
           _,
           _,
           _,
           a_res )
      equation
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           _,
           a_preExp,
           a_varDecls,
           a_attr_ty,
           a_exp_path,
           a_attr_builtin,
           a_res )
      equation
        ret_0 = Config.profileFunctions();
        ret_1 = boolNot(a_attr_builtin);
        ret_2 = boolAnd(ret_0, ret_1);
        (txt, a_preExp, a_varDecls) = fun_974(txt, ret_2, a_preExp, a_varDecls, a_attr_ty, a_exp_path, a_res);
      then (txt, a_preExp, a_varDecls);
  end match;
end fun_975;

public function daeExpCall
  input Tpl.Text in_txt;
  input DAE.Exp in_a_call;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_call, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      Absyn.Path i_exp_path;
      Boolean i_attr_builtin;
      DAE.Type i_attr_ty;
      list<String> i_tail_vars;
      list<DAE.Exp> i_expLst;
      String i_name;
      Integer i_i;
      DAE.Exp i_s1;
      Integer i_setIndex;
      DAE.Exp i_toBeCasted;
      Integer i_index_1;
      DAE.Exp i_delayMax;
      DAE.Exp i_d;
      DAE.Exp i_signdig;
      DAE.Exp i_leftjust;
      DAE.Exp i_minlen;
      DAE.Exp i_format;
      DAE.Exp i_s;
      DAE.Exp i_v2;
      DAE.Exp i_v1;
      DAE.Exp i_n;
      DAE.Exp i_A;
      list<DAE.Exp> i_arrays;
      DAE.Exp i_dim;
      list<DAE.Exp> i_dims;
      DAE.Exp i_val;
      DAE.Exp i_array;
      DAE.Exp i_inExp;
      DAE.Exp i_index;
      DAE.Exp i_call;
      DAE.Type i_ty;
      DAE.Exp i_e;
      Integer i_arg_integer;
      DAE.Exp i_arg;
      DAE.Exp i_exp;
      DAE.ComponentRef i_arg_componentRef;
      DAE.Exp i_e2;
      DAE.Exp i_e1;
      Tpl.Text l_additionalOutputs;
      Tpl.Text l_res;
      Tpl.Text l_tail;
      Tpl.Text l_postExp;
      Tpl.Text l_op;
      Tpl.Text l_i2;
      Tpl.Text l_i1;
      Tpl.Text l_e1;
      Tpl.Text l_expPart;
      String ret_80;
      Tpl.Text l_castedVar;
      Tpl.Text l_var3;
      Tpl.Text l_signdigExp;
      String str_76;
      DAE.Type ret_75;
      Tpl.Text l_enumStr;
      Tpl.Text l_leftjustExp;
      Tpl.Text l_minlenExp;
      Tpl.Text l_typeStr;
      Tpl.Text l_formatExp;
      Tpl.Text l_sExp;
      Integer ret_68;
      Tpl.Text l_arrays__exp;
      Tpl.Text l_dim__exp;
      String ret_65;
      Tpl.Text txt_64;
      list<Integer> ret_63;
      DAE.Type ret_62;
      Tpl.Text l_dims;
      Tpl.Text l_szElt;
      Tpl.Text l_val;
      Tpl.Text l_nElts;
      Tpl.Text l_tvardata;
      Tpl.Text l_tvarc;
      Integer ret_55;
      list<Integer> ret_54;
      DAE.Type ret_53;
      Tpl.Text l_ndim;
      Integer ret_51;
      Tpl.Text l_dimsExp;
      Tpl.Text l_valExp;
      Tpl.Text txt_48;
      Tpl.Text txt_47;
      Tpl.Text l_arr__tp__str;
      Tpl.Text l_expVar;
      Boolean ret_44;
      Boolean ret_43;
      Boolean ret_42;
      Boolean ret_41;
      Boolean ret_40;
      Boolean ret_39;
      Boolean ret_38;
      Tpl.Text l_tvar;
      Tpl.Text l_tp__str;
      Tpl.Text l_exp;
      Tpl.Text l_constIndex;
      Tpl.Text txt_32;
      String ret_32;
      Tpl.Text txt_31;
      Tpl.Text txt_29;
      String ret_29;
      Tpl.Text txt_28;
      Tpl.Text txt_26;
      String ret_26;
      Tpl.Text txt_25;
      Tpl.Text txt_24;
      Tpl.Text txt_22;
      String ret_22;
      Tpl.Text txt_21;
      Tpl.Text l_cstr;
      Tpl.Text txt_19;
      Tpl.Text l_tmp;
      Boolean ret_17;
      Tpl.Text l_argStr;
      Tpl.Text l_ty__str;
      Tpl.Text l_arr;
      Tpl.Text txt_13;
      Tpl.Text txt_12;
      Tpl.Text txt_11;
      Tpl.Text l_dt;
      Tpl.Text l_nameold1;
      Tpl.Text l_nameold0;
      DAE.ComponentRef ret_7;
      Tpl.Text l_derstr;
      Integer ret_5;
      DAE.ComponentRef ret_4;
      Tpl.Text txt_3;
      DAE.ComponentRef ret_2;
      Tpl.Text l_var2;
      Tpl.Text l_var1;

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "smooth"), expLst = {i_e1, i_e2}),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_var1, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e1, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_var2, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e2, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeText(txt, l_var2);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "der"), expLst = {DAE.CREF(componentRef = i_arg_componentRef)}),
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        ret_2 = ComponentReference.crefPrefixDer(i_arg_componentRef);
        txt = cref(txt, ret_2);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "der"), expLst = {i_exp}),
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt_3 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("Code generation does not support der("));
        txt_3 = ExpressionDumpTpl.dumpExp(txt_3, i_exp, "\"");
        txt_3 = Tpl.writeTok(txt_3, Tpl.ST_STRING(")"));
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 6114, 11), Tpl.textString(txt_3));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "pre"), expLst = {i_arg}),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExpCallPre(txt, i_arg, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "interval")),
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("data->simulationInfo->clocksData[clockIndex].interval"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "previous"), expLst = {DAE.CREF(componentRef = i_arg_componentRef)}),
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        ret_4 = ComponentReference.crefPrefixPrevious(i_arg_componentRef);
        txt = cref(txt, ret_4);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "firstTick")),
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(data->simulationInfo->clocksData[clockIndex].cnt == 0)"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "$_clkfire"), expLst = {DAE.ICONST(integer = i_arg_integer)}),
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("fireClock(data, threadData, "));
        ret_5 = intSub(i_arg_integer, 1);
        txt = Tpl.writeStr(txt, intString(ret_5));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", data->localData[0]->timeValue)"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "$_signNoNull"), expLst = {i_e1}),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_var1, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e1, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, l_var1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" >= 0.0 ? 1.0:-1.0)"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "$_DF$DER"), expLst = {DAE.CREF(componentRef = i_arg_componentRef)}),
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        ret_7 = ComponentReference.crefPrefixDer(i_arg_componentRef);
        l_derstr = cref(Tpl.emptyTxt, ret_7);
        l_nameold0 = crefOld(Tpl.emptyTxt, i_arg_componentRef, 0);
        l_nameold1 = crefOld(Tpl.emptyTxt, i_arg_componentRef, 1);
        l_dt = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("data->simulationInfo->inlineData->dt"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, l_dt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" == 0.0 ? "));
        txt = Tpl.writeText(txt, l_derstr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" : ("));
        txt = Tpl.writeText(txt, l_nameold0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" - "));
        txt = Tpl.writeText(txt, l_nameold1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")/"));
        txt = Tpl.writeText(txt, l_dt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "$_round"), expLst = {i_e1}),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_var1, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e1, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("((modelica_integer)round((modelica_real)("));
        txt = Tpl.writeText(txt, l_var1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")))"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "edge"), expLst = {DAE.CREF(componentRef = i_arg_componentRef)}),
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = cref(txt, i_arg_componentRef);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" && !"));
        txt = crefPre(txt, i_arg_componentRef);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "edge"), expLst = {DAE.LUNARY(exp = DAE.CREF(componentRef = i_arg_componentRef))}),
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(!"));
        txt = cref(txt, i_arg_componentRef);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" && "));
        txt = crefPre(txt, i_arg_componentRef);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "edge"), expLst = {i_exp}),
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt_11 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("Code generation does not support edge("));
        txt_11 = ExpressionDumpTpl.dumpExp(txt_11, i_exp, "\"");
        txt_11 = Tpl.writeTok(txt_11, Tpl.ST_STRING(")"));
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 6145, 11), Tpl.textString(txt_11));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "change"), expLst = {DAE.CREF(componentRef = i_arg_componentRef)}),
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = cref(txt, i_arg_componentRef);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" != "));
        txt = crefPre(txt, i_arg_componentRef);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "change"), expLst = {i_exp}),
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt_12 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("Code generation does not support change("));
        txt_12 = ExpressionDumpTpl.dumpExp(txt_12, i_exp, "\"");
        txt_12 = Tpl.writeTok(txt_12, Tpl.ST_STRING(")"));
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 6149, 11), Tpl.textString(txt_12));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "cardinality"), expLst = {i_exp}),
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt_13 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("Code generation does not support cardinality("));
        txt_13 = ExpressionDumpTpl.dumpExp(txt_13, i_exp, "\"");
        txt_13 = Tpl.writeTok(txt_13, Tpl.ST_STRING("). It should have been handled somewhere else in the compiler."));
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 6151, 11), Tpl.textString(txt_13));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "print"), expLst = {i_e1}),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_var1, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e1, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("fputs(MMC_STRINGDATA("));
        txt = Tpl.writeText(txt, l_var1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("),stdout)"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "max"), attr = DAE.CALL_ATTR(ty = DAE.T_REAL(varLst = _)), expLst = {i_e1, i_e2}),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_var1, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e1, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_var2, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e2, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("fmax("));
        txt = Tpl.writeText(txt, l_var1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, l_var2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "max"), expLst = {i_e1, i_e2}),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_var1, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e1, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_var2, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e2, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_integer_max((modelica_integer)("));
        txt = Tpl.writeText(txt, l_var1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("),(modelica_integer)("));
        txt = Tpl.writeText(txt, l_var2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("))"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "sum"), attr = DAE.CALL_ATTR(ty = i_ty), expLst = {i_e}),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_arr, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
        l_ty__str = expTypeArray(Tpl.emptyTxt, i_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("sum_"));
        txt = Tpl.writeText(txt, l_ty__str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, l_arr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "product"), attr = DAE.CALL_ATTR(ty = i_ty), expLst = {i_e}),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_arr, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
        l_ty__str = expTypeArray(Tpl.emptyTxt, i_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("product_"));
        txt = Tpl.writeText(txt, l_ty__str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, l_arr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "min"), attr = DAE.CALL_ATTR(ty = DAE.T_REAL(varLst = _)), expLst = {i_e1, i_e2}),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_var1, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e1, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_var2, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e2, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("fmin("));
        txt = Tpl.writeText(txt, l_var1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, l_var2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "min"), expLst = {i_e1, i_e2}),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_var1, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e1, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_var2, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e2, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_integer_min((modelica_integer)("));
        txt = Tpl.writeText(txt, l_var1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("),(modelica_integer)("));
        txt = Tpl.writeText(txt, l_var2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("))"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "abs"), expLst = {i_e1}, attr = DAE.CALL_ATTR(ty = DAE.T_INTEGER(varLst = _))),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_var1, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e1, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("labs("));
        txt = Tpl.writeText(txt, l_var1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "abs"), expLst = {i_e1}),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_var1, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e1, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("fabs("));
        txt = Tpl.writeText(txt, l_var1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "sqrt"), expLst = {i_e1}, attr = DAE.CALL_ATTR(ty = _)),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_argStr, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e1, a_context, a_preExp, a_varDecls, a_auxFunction);
        ret_17 = Expression.isPositiveOrZero(i_e1);
        (txt, a_preExp, a_varDecls) = fun_945(txt, ret_17, a_context, l_argStr, a_preExp, a_varDecls, i_e1);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "log"), expLst = {i_e1}, attr = DAE.CALL_ATTR(ty = _)),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_argStr, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e1, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt_19 = expTypeFromExpModelica(Tpl.emptyTxt, i_e1);
        (l_tmp, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(txt_19), a_varDecls);
        l_cstr = ExpressionDumpTpl.dumpExp(Tpl.emptyTxt, i_e1, "\"");
        a_preExp = Tpl.writeText(a_preExp, l_tmp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = "));
        a_preExp = Tpl.writeText(a_preExp, l_argStr);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_LINE(";\n"));
        txt_21 = Tpl.writeText(Tpl.emptyTxt, l_tmp);
        txt_21 = Tpl.writeTok(txt_21, Tpl.ST_STRING(" > 0.0"));
        txt_22 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("\"Model error: Argument of log("));
        ret_22 = Util.escapeModelicaStringToCString(Tpl.textString(l_cstr));
        txt_22 = Tpl.writeStr(txt_22, ret_22);
        txt_22 = Tpl.writeTok(txt_22, Tpl.ST_STRING(") was %g should be > 0\", "));
        txt_22 = Tpl.writeText(txt_22, l_tmp);
        (a_preExp, txt_21, txt_22, a_varDecls) = assertCommonVar(a_preExp, txt_21, txt_22, a_context, a_varDecls, AbsynUtil.dummyInfo);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("log("));
        txt = Tpl.writeText(txt, l_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "log10"), expLst = {i_e1}, attr = DAE.CALL_ATTR(ty = _)),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_argStr, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e1, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt_24 = expTypeFromExpModelica(Tpl.emptyTxt, i_e1);
        (l_tmp, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(txt_24), a_varDecls);
        l_cstr = ExpressionDumpTpl.dumpExp(Tpl.emptyTxt, i_e1, "\"");
        a_preExp = Tpl.writeText(a_preExp, l_tmp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = "));
        a_preExp = Tpl.writeText(a_preExp, l_argStr);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_LINE(";\n"));
        txt_25 = Tpl.writeText(Tpl.emptyTxt, l_tmp);
        txt_25 = Tpl.writeTok(txt_25, Tpl.ST_STRING(" > 0.0"));
        txt_26 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("\"Model error: Argument of log10("));
        ret_26 = Util.escapeModelicaStringToCString(Tpl.textString(l_cstr));
        txt_26 = Tpl.writeStr(txt_26, ret_26);
        txt_26 = Tpl.writeTok(txt_26, Tpl.ST_STRING(") was %g should be > 0\", "));
        txt_26 = Tpl.writeText(txt_26, l_tmp);
        (a_preExp, txt_25, txt_26, a_varDecls) = assertCommonVar(a_preExp, txt_25, txt_26, a_context, a_varDecls, AbsynUtil.dummyInfo);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("log10("));
        txt = Tpl.writeText(txt, l_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_call as DAE.CALL(path = Absyn.IDENT(name = "acos"), expLst = {i_e1}, attr = DAE.CALL_ATTR(ty = _))),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_argStr, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e1, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_tmp, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_real", a_varDecls);
        l_cstr = ExpressionDumpTpl.dumpExp(Tpl.emptyTxt, i_call, "\"");
        a_preExp = Tpl.writeText(a_preExp, l_tmp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = "));
        a_preExp = Tpl.writeText(a_preExp, l_argStr);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_LINE(";\n"));
        txt_28 = Tpl.writeText(Tpl.emptyTxt, l_tmp);
        txt_28 = Tpl.writeTok(txt_28, Tpl.ST_STRING(" >= -1.0 && "));
        txt_28 = Tpl.writeText(txt_28, l_tmp);
        txt_28 = Tpl.writeTok(txt_28, Tpl.ST_STRING(" <= 1.0"));
        txt_29 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("\"Model error: Argument of "));
        ret_29 = Util.escapeModelicaStringToCString(Tpl.textString(l_cstr));
        txt_29 = Tpl.writeStr(txt_29, ret_29);
        txt_29 = Tpl.writeTok(txt_29, Tpl.ST_STRING(" outside the domain -1.0 <= %g <= 1.0\", "));
        txt_29 = Tpl.writeText(txt_29, l_tmp);
        (a_preExp, txt_28, txt_29, a_varDecls) = assertCommonVar(a_preExp, txt_28, txt_29, a_context, a_varDecls, AbsynUtil.dummyInfo);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("acos("));
        txt = Tpl.writeText(txt, l_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_call as DAE.CALL(path = Absyn.IDENT(name = "asin"), expLst = {i_e1}, attr = DAE.CALL_ATTR(ty = _))),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_argStr, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e1, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_tmp, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_real", a_varDecls);
        l_cstr = ExpressionDumpTpl.dumpExp(Tpl.emptyTxt, i_call, "\"");
        a_preExp = Tpl.writeText(a_preExp, l_tmp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = "));
        a_preExp = Tpl.writeText(a_preExp, l_argStr);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_LINE(";\n"));
        txt_31 = Tpl.writeText(Tpl.emptyTxt, l_tmp);
        txt_31 = Tpl.writeTok(txt_31, Tpl.ST_STRING(" >= -1.0 && "));
        txt_31 = Tpl.writeText(txt_31, l_tmp);
        txt_31 = Tpl.writeTok(txt_31, Tpl.ST_STRING(" <= 1.0"));
        txt_32 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("\"Model error: Argument of "));
        ret_32 = Util.escapeModelicaStringToCString(Tpl.textString(l_cstr));
        txt_32 = Tpl.writeStr(txt_32, ret_32);
        txt_32 = Tpl.writeTok(txt_32, Tpl.ST_STRING(" outside the domain -1.0 <= %g <= 1.0\", "));
        txt_32 = Tpl.writeText(txt_32, l_tmp);
        (a_preExp, txt_31, txt_32, a_varDecls) = assertCommonVar(a_preExp, txt_31, txt_32, a_context, a_varDecls, AbsynUtil.dummyInfo);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("asin("));
        txt = Tpl.writeText(txt, l_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "mod"), expLst = {i_e1, i_e2, i_index}, attr = DAE.CALL_ATTR(ty = i_ty)),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_var1, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e1, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_var2, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e2, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_constIndex, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_index, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_event_mod_"));
        txt = expTypeShort(txt, i_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, l_var1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, l_var2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, l_constIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", data, threadData)"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "div"), expLst = {i_e1, i_e2, i_index}, attr = DAE.CALL_ATTR(ty = i_ty)),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_var1, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e1, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_var2, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e2, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_constIndex, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_index, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_event_div_"));
        txt = expTypeShort(txt, i_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, l_var1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, l_var2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, l_constIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", data, threadData)"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "integer"), expLst = {i_inExp, i_index}),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_exp, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_inExp, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_constIndex, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_index, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(_event_integer("));
        txt = Tpl.writeText(txt, l_exp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, l_constIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", data))"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "floor"), expLst = {i_inExp, i_index}, attr = DAE.CALL_ATTR(ty = i_ty)),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_exp, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_inExp, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_constIndex, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_index, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("((modelica_"));
        txt = expTypeShort(txt, i_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")_event_floor("));
        txt = Tpl.writeText(txt, l_exp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, l_constIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", data))"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "ceil"), expLst = {i_inExp, i_index}, attr = DAE.CALL_ATTR(ty = i_ty)),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_exp, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_inExp, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_constIndex, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_index, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("((modelica_"));
        txt = expTypeShort(txt, i_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")_event_ceil("));
        txt = Tpl.writeText(txt, l_exp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, l_constIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", data))"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "integer"), expLst = {i_inExp}),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_exp, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_inExp, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("((modelica_integer)floor("));
        txt = Tpl.writeText(txt, l_exp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("))"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_call as DAE.CALL(path = Absyn.IDENT(name = "mod"), expLst = {i_e1, i_e2}, attr = DAE.CALL_ATTR(ty = i_ty))),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        l_tp__str = expTypeModelica(Tpl.emptyTxt, i_ty);
        (l_var1, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e1, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_var2, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e2, a_context, a_preExp, a_varDecls, a_auxFunction);
        ret_38 = Config.acceptMetaModelicaGrammar();
        (l_tvar, a_varDecls) = fun_946(Tpl.emptyTxt, ret_38, l_var2, a_varDecls, l_tp__str);
        l_cstr = ExpressionDumpTpl.dumpExp(Tpl.emptyTxt, i_call, "\"");
        ret_39 = Config.acceptMetaModelicaGrammar();
        a_preExp = fun_947(a_preExp, ret_39, l_var2, l_tvar);
        ret_40 = Config.acceptMetaModelicaGrammar();
        a_preExp = fun_948(a_preExp, ret_40, l_cstr, l_tvar);
        txt = Tpl.writeText(txt, l_tp__str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_mod("));
        txt = Tpl.writeText(txt, l_var1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, l_tvar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_call as DAE.CALL(path = Absyn.IDENT(name = "mod"), expLst = {i_e1, i_e2})),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_var1, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e1, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_var2, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e2, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_tvar, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_real", a_varDecls);
        l_cstr = ExpressionDumpTpl.dumpExp(Tpl.emptyTxt, i_call, "\"");
        a_preExp = Tpl.writeText(a_preExp, l_tvar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = "));
        a_preExp = Tpl.writeText(a_preExp, l_var2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(";"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        ret_41 = Config.acceptMetaModelicaGrammar();
        a_preExp = fun_949(a_preExp, ret_41, l_cstr, l_tvar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(("));
        txt = Tpl.writeText(txt, l_var1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") - floor(("));
        txt = Tpl.writeText(txt, l_var1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") / ("));
        txt = Tpl.writeText(txt, l_tvar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")) * ("));
        txt = Tpl.writeText(txt, l_tvar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("))"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_call as DAE.CALL(path = Absyn.IDENT(name = "div"), expLst = {i_e1, i_e2}, attr = DAE.CALL_ATTR(ty = DAE.T_INTEGER(varLst = _)))),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_var1, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e1, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_var2, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e2, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_tvar, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_integer", a_varDecls);
        l_cstr = ExpressionDumpTpl.dumpExp(Tpl.emptyTxt, i_call, "\"");
        a_preExp = Tpl.writeText(a_preExp, l_tvar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = "));
        a_preExp = Tpl.writeText(a_preExp, l_var2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(";"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        ret_42 = Config.acceptMetaModelicaGrammar();
        a_preExp = fun_950(a_preExp, ret_42, l_cstr, l_tvar);
        ret_43 = SimCodeFunctionUtil.isParallelFunctionContext(a_context);
        txt = fun_951(txt, ret_43, l_tvar, l_var1);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_call as DAE.CALL(path = Absyn.IDENT(name = "div"), expLst = {i_e1, i_e2})),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_var1, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e1, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_var2, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e2, a_context, a_preExp, a_varDecls, a_auxFunction);
        l_cstr = ExpressionDumpTpl.dumpExp(Tpl.emptyTxt, i_call, "\"");
        (l_tvar, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_real", a_varDecls);
        a_preExp = Tpl.writeText(a_preExp, l_tvar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = "));
        a_preExp = Tpl.writeText(a_preExp, l_var2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(";"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        ret_44 = Config.acceptMetaModelicaGrammar();
        a_preExp = fun_952(a_preExp, ret_44, l_cstr, l_tvar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("trunc(("));
        txt = Tpl.writeText(txt, l_var1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") / ("));
        txt = Tpl.writeText(txt, l_tvar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("))"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "mod"), expLst = {i_e1, i_e2}, attr = DAE.CALL_ATTR(ty = i_ty)),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_var1, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e1, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_var2, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e2, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_mod_"));
        txt = expTypeShort(txt, i_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, l_var1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, l_var2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "max"), attr = DAE.CALL_ATTR(ty = i_ty), expLst = {i_array}),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_expVar, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_array, a_context, a_preExp, a_varDecls, a_auxFunction);
        l_arr__tp__str = expTypeArray(Tpl.emptyTxt, i_ty);
        txt_47 = expTypeModelica(Tpl.emptyTxt, i_ty);
        (l_tvar, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(txt_47), a_varDecls);
        a_preExp = Tpl.writeText(a_preExp, l_tvar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = max_"));
        a_preExp = Tpl.writeText(a_preExp, l_arr__tp__str);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("("));
        a_preExp = Tpl.writeText(a_preExp, l_expVar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tvar);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "min"), attr = DAE.CALL_ATTR(ty = i_ty), expLst = {i_array}),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_expVar, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_array, a_context, a_preExp, a_varDecls, a_auxFunction);
        l_arr__tp__str = expTypeArray(Tpl.emptyTxt, i_ty);
        txt_48 = expTypeModelica(Tpl.emptyTxt, i_ty);
        (l_tvar, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(txt_48), a_varDecls);
        a_preExp = Tpl.writeText(a_preExp, l_tvar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = min_"));
        a_preExp = Tpl.writeText(a_preExp, l_arr__tp__str);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("("));
        a_preExp = Tpl.writeText(a_preExp, l_expVar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tvar);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "fill"), expLst = i_val :: i_dims, attr = DAE.CALL_ATTR(ty = i_ty)),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_valExp, a_preExp, a_varDecls, a_auxFunction) = daeExpAsLValue(Tpl.emptyTxt, i_val, a_context, a_preExp, a_varDecls, a_auxFunction);
        l_dimsExp = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_dimsExp, a_auxFunction, a_varDecls, a_preExp) = lm_953(l_dimsExp, i_dims, a_auxFunction, a_varDecls, a_preExp, a_context);
        l_dimsExp = Tpl.popIter(l_dimsExp);
        l_ty__str = expTypeArray(Tpl.emptyTxt, i_ty);
        (l_tvar, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(l_ty__str), a_varDecls);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("fill_alloc_"));
        a_preExp = Tpl.writeText(a_preExp, l_ty__str);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("(&"));
        a_preExp = Tpl.writeText(a_preExp, l_tvar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, l_valExp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        ret_51 = listLength(i_dims);
        a_preExp = Tpl.writeStr(a_preExp, intString(ret_51));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, l_dimsExp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tvar);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "vector"), expLst = {i_exp}, attr = DAE.CALL_ATTR(ty = i_ty)),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        ret_53 = Expression.typeof(i_exp);
        ret_54 = Types.getDimensionSizes(ret_53);
        ret_55 = listLength(ret_54);
        l_ndim = Tpl.writeStr(Tpl.emptyTxt, intString(ret_55));
        (l_tvarc, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_integer", a_varDecls);
        (l_tvardata, a_varDecls) = tempDecl(Tpl.emptyTxt, "void *", a_varDecls);
        (l_nElts, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_integer", a_varDecls);
        (l_val, a_preExp, a_varDecls, a_auxFunction) = daeExpAsLValue(Tpl.emptyTxt, i_exp, a_context, a_preExp, a_varDecls, a_auxFunction);
        l_szElt = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("sizeof("));
        l_szElt = expTypeModelica(l_szElt, i_ty);
        l_szElt = Tpl.writeTok(l_szElt, Tpl.ST_STRING(")"));
        ret_62 = Expression.typeof(i_exp);
        ret_63 = Types.getDimensionSizes(ret_62);
        l_dims = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(1, SOME(Tpl.ST_STRING("")), NONE(), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_dims = lm_955(l_dims, ret_63, l_tvarc, l_val);
        l_dims = Tpl.popIter(l_dims);
        l_ty__str = expTypeArray(Tpl.emptyTxt, i_ty);
        (l_tvar, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(l_ty__str), a_varDecls);
        a_preExp = Tpl.pushBlock(a_preExp, Tpl.BT_INDENT(2));
        a_preExp = Tpl.writeText(a_preExp, l_tvarc);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_LINE("=0;\n"));
        a_preExp = Tpl.popBlock(a_preExp);
        a_preExp = Tpl.writeText(a_preExp, l_dims);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("if ("));
        a_preExp = Tpl.writeText(a_preExp, l_tvarc);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_LINE(" > 1) {\n"));
        a_preExp = Tpl.pushBlock(a_preExp, Tpl.BT_INDENT(2));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("throwStreamPrint(threadData, \"Called vector with >1 dimensions with size >1: "));
        txt_64 = ExpressionDumpTpl.dumpExp(Tpl.emptyTxt, i_exp, "\"");
        ret_65 = Util.escapeModelicaStringToCString(Tpl.textString(txt_64));
        a_preExp = Tpl.writeStr(a_preExp, ret_65);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_LINE("\");\n"));
        a_preExp = Tpl.popBlock(a_preExp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_LINE("}\n"));
        a_preExp = Tpl.writeText(a_preExp, l_nElts);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = base_array_nr_of_elements("));
        a_preExp = Tpl.writeText(a_preExp, l_val);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_LINE(");\n"));
        a_preExp = Tpl.writeText(a_preExp, l_tvardata);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = omc_alloc_interface.malloc("));
        a_preExp = Tpl.writeText(a_preExp, l_szElt);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("*"));
        a_preExp = Tpl.writeText(a_preExp, l_nElts);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING_LIST({
                                              ");\n",
                                              "memcpy("
                                          }, false));
        a_preExp = Tpl.writeText(a_preExp, l_tvardata);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, l_val);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(".data, "));
        a_preExp = Tpl.writeText(a_preExp, l_szElt);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("*"));
        a_preExp = Tpl.writeText(a_preExp, l_nElts);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING_LIST({
                                              ");\n",
                                              "simple_alloc_1d_base_array(&"
                                          }, false));
        a_preExp = Tpl.writeText(a_preExp, l_tvar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, l_nElts);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, l_tvardata);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        txt = Tpl.writeText(txt, l_tvar);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "cat"), expLst = i_dim :: i_arrays, attr = DAE.CALL_ATTR(ty = i_ty)),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_dim__exp, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_dim, a_context, a_preExp, a_varDecls, a_auxFunction);
        l_arrays__exp = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", &")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_arrays__exp, a_auxFunction, a_varDecls, a_preExp) = lm_956(l_arrays__exp, i_arrays, a_auxFunction, a_varDecls, a_preExp, a_context);
        l_arrays__exp = Tpl.popIter(l_arrays__exp);
        l_ty__str = expTypeArray(Tpl.emptyTxt, i_ty);
        (l_tvar, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(l_ty__str), a_varDecls);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("cat_alloc_"));
        a_preExp = Tpl.writeText(a_preExp, l_ty__str);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("("));
        a_preExp = Tpl.writeText(a_preExp, l_dim__exp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", &"));
        a_preExp = Tpl.writeText(a_preExp, l_tvar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        ret_68 = listLength(i_arrays);
        a_preExp = Tpl.writeStr(a_preExp, intString(ret_68));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", &"));
        a_preExp = Tpl.writeText(a_preExp, l_arrays__exp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tvar);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "promote"), expLst = {i_A, i_n}),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_var1, a_preExp, a_varDecls, a_auxFunction) = daeExpAsLValue(Tpl.emptyTxt, i_A, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_var2, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_n, a_context, a_preExp, a_varDecls, a_auxFunction);
        l_arr__tp__str = expTypeFromExpArray(Tpl.emptyTxt, i_A);
        (l_tvar, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(l_arr__tp__str), a_varDecls);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("promote_alloc_"));
        a_preExp = Tpl.writeText(a_preExp, l_arr__tp__str);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("(&"));
        a_preExp = Tpl.writeText(a_preExp, l_var1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, l_var2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" - ndims_base_array(&"));
        a_preExp = Tpl.writeText(a_preExp, l_var1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("), &"));
        a_preExp = Tpl.writeText(a_preExp, l_tvar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tvar);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "transpose"), expLst = {i_A}),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_var1, a_preExp, a_varDecls, a_auxFunction) = daeExpAsLValue(Tpl.emptyTxt, i_A, a_context, a_preExp, a_varDecls, a_auxFunction);
        l_arr__tp__str = expTypeFromExpArray(Tpl.emptyTxt, i_A);
        (l_tvar, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(l_arr__tp__str), a_varDecls);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("transpose_alloc_"));
        a_preExp = Tpl.writeText(a_preExp, l_arr__tp__str);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("(&"));
        a_preExp = Tpl.writeText(a_preExp, l_var1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", &"));
        a_preExp = Tpl.writeText(a_preExp, l_tvar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tvar);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "symmetric"), expLst = {i_A}),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_var1, a_preExp, a_varDecls, a_auxFunction) = daeExpAsLValue(Tpl.emptyTxt, i_A, a_context, a_preExp, a_varDecls, a_auxFunction);
        l_arr__tp__str = expTypeFromExpArray(Tpl.emptyTxt, i_A);
        (l_tvar, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(l_arr__tp__str), a_varDecls);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("symmetric_"));
        a_preExp = Tpl.writeText(a_preExp, l_arr__tp__str);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("(&"));
        a_preExp = Tpl.writeText(a_preExp, l_var1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", &"));
        a_preExp = Tpl.writeText(a_preExp, l_tvar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tvar);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "skew"), expLst = {i_A}),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_var1, a_preExp, a_varDecls, a_auxFunction) = daeExpAsLValue(Tpl.emptyTxt, i_A, a_context, a_preExp, a_varDecls, a_auxFunction);
        l_arr__tp__str = expTypeFromExpArray(Tpl.emptyTxt, i_A);
        (l_tvar, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(l_arr__tp__str), a_varDecls);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("skew_"));
        a_preExp = Tpl.writeText(a_preExp, l_arr__tp__str);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("(&"));
        a_preExp = Tpl.writeText(a_preExp, l_var1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", &"));
        a_preExp = Tpl.writeText(a_preExp, l_tvar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tvar);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "cross"), expLst = {i_v1, i_v2}),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_var1, a_preExp, a_varDecls, a_auxFunction) = daeExpAsLValue(Tpl.emptyTxt, i_v1, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_var2, a_preExp, a_varDecls, a_auxFunction) = daeExpAsLValue(Tpl.emptyTxt, i_v2, a_context, a_preExp, a_varDecls, a_auxFunction);
        l_arr__tp__str = expTypeFromExpArray(Tpl.emptyTxt, i_v1);
        (l_tvar, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(l_arr__tp__str), a_varDecls);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("cross_alloc_"));
        a_preExp = Tpl.writeText(a_preExp, l_arr__tp__str);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("(&"));
        a_preExp = Tpl.writeText(a_preExp, l_var1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", &"));
        a_preExp = Tpl.writeText(a_preExp, l_var2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", &"));
        a_preExp = Tpl.writeText(a_preExp, l_tvar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tvar);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "identity"), expLst = {i_A}),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_var1, a_preExp, a_varDecls, a_auxFunction) = daeExpAsLValue(Tpl.emptyTxt, i_A, a_context, a_preExp, a_varDecls, a_auxFunction);
        l_arr__tp__str = expTypeFromExpArray(Tpl.emptyTxt, i_A);
        (l_tvar, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(l_arr__tp__str), a_varDecls);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("identity_alloc_"));
        a_preExp = Tpl.writeText(a_preExp, l_arr__tp__str);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("("));
        a_preExp = Tpl.writeText(a_preExp, l_var1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", &"));
        a_preExp = Tpl.writeText(a_preExp, l_tvar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tvar);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "diagonal"), expLst = {i_A}),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_var1, a_preExp, a_varDecls, a_auxFunction) = daeExpAsLValue(Tpl.emptyTxt, i_A, a_context, a_preExp, a_varDecls, a_auxFunction);
        l_arr__tp__str = expTypeFromExpArray(Tpl.emptyTxt, i_A);
        (l_tvar, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(l_arr__tp__str), a_varDecls);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("diagonal_alloc_"));
        a_preExp = Tpl.writeText(a_preExp, l_arr__tp__str);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("(&"));
        a_preExp = Tpl.writeText(a_preExp, l_var1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", &"));
        a_preExp = Tpl.writeText(a_preExp, l_tvar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tvar);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "String"), expLst = {i_s, i_format}),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_tvar, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_string", a_varDecls);
        (l_sExp, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_s, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_formatExp, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_format, a_context, a_preExp, a_varDecls, a_auxFunction);
        l_typeStr = expTypeFromExpModelica(Tpl.emptyTxt, i_s);
        a_preExp = Tpl.writeText(a_preExp, l_tvar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = "));
        a_preExp = Tpl.writeText(a_preExp, l_typeStr);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("_to_modelica_string_format("));
        a_preExp = Tpl.writeText(a_preExp, l_sExp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, l_formatExp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tvar);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "String"), expLst = {i_s, i_minlen, i_leftjust}),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_tvar, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_string", a_varDecls);
        (l_sExp, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_s, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_minlenExp, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_minlen, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_leftjustExp, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_leftjust, a_context, a_preExp, a_varDecls, a_auxFunction);
        ret_75 = Expression.typeof(i_s);
        (l_enumStr, a_varDecls) = fun_958(Tpl.emptyTxt, ret_75, a_varDecls);
        l_typeStr = fun_959(Tpl.emptyTxt, l_enumStr, i_s);
        str_76 = Tpl.textString(l_typeStr);
        (txt, a_preExp) = fun_960(txt, str_76, l_enumStr, l_leftjustExp, l_minlenExp, l_sExp, l_typeStr, l_tvar, a_preExp);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "String"), expLst = {i_s, i_signdig, i_minlen, i_leftjust}),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_tvar, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_string", a_varDecls);
        (l_sExp, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_s, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_minlenExp, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_minlen, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_leftjustExp, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_leftjust, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_signdigExp, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_signdig, a_context, a_preExp, a_varDecls, a_auxFunction);
        a_preExp = Tpl.writeText(a_preExp, l_tvar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = modelica_real_to_modelica_string("));
        a_preExp = Tpl.writeText(a_preExp, l_sExp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, l_signdigExp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, l_minlenExp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, l_leftjustExp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tvar);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "delay"), expLst = {DAE.ICONST(integer = i_index_1), i_e, i_d, i_delayMax}),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_tvar, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_real", a_varDecls);
        (l_var1, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_var2, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_d, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_var3, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_delayMax, a_context, a_preExp, a_varDecls, a_auxFunction);
        a_preExp = Tpl.writeText(a_preExp, l_tvar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = delayImpl(data, threadData, "));
        a_preExp = Tpl.writeStr(a_preExp, intString(i_index_1));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, l_var1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", data->localData[0]->timeValue, "));
        a_preExp = Tpl.writeText(a_preExp, l_var2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, l_var3);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tvar);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "Integer"), expLst = {i_toBeCasted}),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_castedVar, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_toBeCasted, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("((modelica_integer)("));
        txt = Tpl.writeText(txt, l_castedVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("))"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "clock"), expLst = {}),
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("mmc_clock()"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "noEvent"), expLst = {i_e1}),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExp(txt, i_e1, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "$getPart"), expLst = {i_e1}),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExp(txt, i_e1, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "$stateSelectionSet"), expLst = DAE.ICONST(integer = i_setIndex) :: _),
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("stateSelectionSet(data, threadData, 1, 1, "));
        txt = Tpl.writeStr(txt, intString(i_setIndex));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", 0)"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "$initialStateSelection"), expLst = DAE.ICONST(integer = i_setIndex) :: _),
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("initialStateSelection(data, threadData, 1, 1, "));
        txt = Tpl.writeStr(txt, intString(i_setIndex));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", 0)"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "sample"), expLst = {DAE.ICONST(integer = i_index_1), _, _}),
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        ret_80 = Config.simCodeTarget();
        txt = fun_961(txt, ret_80, i_index_1);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "anyString"), expLst = {i_e1}),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("mmc_anyString("));
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExp(txt, i_e1, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "fail"), attr = DAE.CALL_ATTR(builtin = true)),
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt = generateThrow(txt);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "mmc_get_field"), expLst = {i_s1, DAE.ICONST(integer = i_i)}),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_tvar, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_metatype", a_varDecls);
        (l_expPart, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_s1, a_context, a_preExp, a_varDecls, a_auxFunction);
        a_preExp = Tpl.writeText(a_preExp, l_tvar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = MMC_FETCH(MMC_OFFSET(MMC_UNTAGPTR("));
        a_preExp = Tpl.writeText(a_preExp, l_expPart);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("), "));
        a_preExp = Tpl.writeStr(a_preExp, intString(i_i));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("));"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tvar);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "mmc_unbox_record"), expLst = {i_s1}, attr = DAE.CALL_ATTR(ty = i_ty)),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_argStr, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_s1, a_context, a_preExp, a_varDecls, a_auxFunction);
        (txt, a_preExp, a_varDecls) = unboxRecord(txt, Tpl.textString(l_argStr), i_ty, a_preExp, a_varDecls);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "threadData")),
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("threadData"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "intBitNot"), expLst = {i_e}),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_e1, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(~"));
        txt = Tpl.writeText(txt, l_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = (i_name as "intBitNot")), expLst = {i_e1, i_e2}),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_i1, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e1, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_i2, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e2, a_context, a_preExp, a_varDecls, a_auxFunction);
        l_op = fun_962(Tpl.emptyTxt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(("));
        txt = Tpl.writeText(txt, l_i1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") "));
        txt = Tpl.writeText(txt, l_op);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" ("));
        txt = Tpl.writeText(txt, l_i2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("))"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = (i_name as "intBitAnd")), expLst = {i_e1, i_e2}),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_i1, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e1, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_i2, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e2, a_context, a_preExp, a_varDecls, a_auxFunction);
        l_op = fun_963(Tpl.emptyTxt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(("));
        txt = Tpl.writeText(txt, l_i1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") "));
        txt = Tpl.writeText(txt, l_op);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" ("));
        txt = Tpl.writeText(txt, l_i2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("))"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = (i_name as "intBitOr")), expLst = {i_e1, i_e2}),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_i1, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e1, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_i2, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e2, a_context, a_preExp, a_varDecls, a_auxFunction);
        l_op = fun_964(Tpl.emptyTxt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(("));
        txt = Tpl.writeText(txt, l_i1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") "));
        txt = Tpl.writeText(txt, l_op);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" ("));
        txt = Tpl.writeText(txt, l_i2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("))"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = (i_name as "intBitXor")), expLst = {i_e1, i_e2}),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_i1, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e1, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_i2, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e2, a_context, a_preExp, a_varDecls, a_auxFunction);
        l_op = fun_965(Tpl.emptyTxt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(("));
        txt = Tpl.writeText(txt, l_i1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") "));
        txt = Tpl.writeText(txt, l_op);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" ("));
        txt = Tpl.writeText(txt, l_i2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("))"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = (i_name as "intBitLShift")), expLst = {i_e1, i_e2}),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_i1, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e1, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_i2, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e2, a_context, a_preExp, a_varDecls, a_auxFunction);
        l_op = fun_966(Tpl.emptyTxt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(("));
        txt = Tpl.writeText(txt, l_i1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") "));
        txt = Tpl.writeText(txt, l_op);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" ("));
        txt = Tpl.writeText(txt, l_i2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("))"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = (i_name as "intBitRShift")), expLst = {i_e1, i_e2}),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_i1, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e1, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_i2, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e2, a_context, a_preExp, a_varDecls, a_auxFunction);
        l_op = fun_967(Tpl.emptyTxt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(("));
        txt = Tpl.writeText(txt, l_i1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") "));
        txt = Tpl.writeText(txt, l_op);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" ("));
        txt = Tpl.writeText(txt, l_i2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("))"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.CALL(attr = DAE.CALL_ATTR(tailCall = DAE.TAIL(vars = i_tail_vars)), expLst = i_expLst),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        l_postExp = Tpl.emptyTxt;
        (l_tail, a_preExp, l_postExp, a_varDecls, a_auxFunction) = daeExpTailCall(Tpl.emptyTxt, i_expLst, i_tail_vars, a_context, a_preExp, l_postExp, a_varDecls, a_auxFunction);
        l_res = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_LINE("/* Tail recursive call */\n"));
        l_res = Tpl.writeText(l_res, l_tail);
        l_res = Tpl.writeText(l_res, l_postExp);
        l_res = Tpl.writeTok(l_res, Tpl.ST_STRING_LIST({
                                        "goto _tailrecursive;\n",
                                        "/* TODO: Make sure any eventual dead code below is never generated */"
                                    }, false));
        a_preExp = Tpl.writeText(a_preExp, l_res);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_exp as DAE.CALL(attr = DAE.CALL_ATTR(ty = i_attr_ty, builtin = i_attr_builtin), path = i_exp_path)),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        l_additionalOutputs = fun_969(Tpl.emptyTxt, i_attr_ty);
        (l_res, l_additionalOutputs, a_preExp, a_varDecls, a_auxFunction) = daeExpCallTuple(Tpl.emptyTxt, i_exp, l_additionalOutputs, a_context, a_preExp, a_varDecls, a_auxFunction);
        (txt, a_preExp, a_varDecls) = fun_975(txt, a_context, a_preExp, a_varDecls, i_attr_ty, i_exp_path, i_attr_builtin, l_res);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end daeExpCall;

protected function lm_977
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Exp i_exp;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           i_exp :: rest,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExp(txt, i_exp, a_context, a_preExp, a_varDecls, a_auxFunction);
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_977(txt, rest, a_auxFunction, a_varDecls, a_preExp, a_context);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end lm_977;

protected function lm_978
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Exp i_exp;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           i_exp :: rest,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExp(txt, i_exp, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_978(txt, rest, a_auxFunction, a_varDecls, a_preExp, a_context);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end lm_978;

protected function fun_979
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;
  input list<DAE.Exp> in_a_expLst;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_mArg, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context, in_a_expLst)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      list<DAE.Exp> a_expLst;

    case ( txt,
           false,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context,
           a_expLst )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("threadData"));
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_977(txt, a_expLst, a_auxFunction, a_varDecls, a_preExp, a_context);
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           _,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context,
           a_expLst )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_978(txt, a_expLst, a_auxFunction, a_varDecls, a_preExp, a_context);
        txt = Tpl.popIter(txt);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end fun_979;

protected function fun_980
  input Tpl.Text in_txt;
  input Boolean in_a_attr_builtin;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_attr_builtin)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("omc_"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_980;

protected function fun_981
  input Tpl.Text in_txt;
  input Absyn.Path in_a_path;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_a_path, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      Absyn.Path i_path;
      String i_name;
      Tpl.Text txt_1;
      DAE.ComponentRef ret_0;

    case ( txt,
           Absyn.IDENT(name = i_name),
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        ret_0 = ComponentReference.makeUntypedCrefIdent(i_name);
        (txt, a_preExp, a_varDecls, a_auxFunction) = contextCref(txt, ret_0, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           i_path,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _ )
      equation
        txt_1 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("We only support function pointer calls where the pointer is a local variable (not inside any record). Got: "));
        txt_1 = CodegenUtil.underscorePath(txt_1, i_path);
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 6622, 22), Tpl.textString(txt_1));
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end fun_981;

protected function lm_982
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Exp i_exp;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           i_exp :: rest,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExp(txt, i_exp, a_context, a_preExp, a_varDecls, a_auxFunction);
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_982(txt, rest, a_auxFunction, a_varDecls, a_preExp, a_context);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end lm_982;

protected function fun_983
  input Tpl.Text in_txt;
  input Boolean in_a_attr_isFunctionPointerCall;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;
  input list<DAE.Exp> in_a_expLst;
  input DAE.Type in_a_attr_ty;
  input Tpl.Text in_a_additionalOutputs;
  input Tpl.Text in_a_argStr;
  input Absyn.Path in_a_path;
  input Boolean in_a_attr_builtin;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_a_attr_isFunctionPointerCall, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context, in_a_expLst, in_a_attr_ty, in_a_additionalOutputs, in_a_argStr, in_a_path, in_a_attr_builtin)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      list<DAE.Exp> a_expLst;
      DAE.Type a_attr_ty;
      Tpl.Text a_additionalOutputs;
      Tpl.Text a_argStr;
      Absyn.Path a_path;
      Boolean a_attr_builtin;
      Tpl.Text l_argStrPointer;
      Tpl.Text l_closure;
      Tpl.Text l_func;
      Tpl.Text l_n;
      Tpl.Text l_typeCast2;
      Tpl.Text l_typeCast1;
      Tpl.Text l_name;

    case ( txt,
           false,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _,
           _,
           _,
           a_additionalOutputs,
           a_argStr,
           a_path,
           a_attr_builtin )
      equation
        l_name = fun_980(Tpl.emptyTxt, a_attr_builtin);
        l_name = CodegenUtil.underscorePath(l_name, a_path);
        txt = Tpl.writeText(txt, l_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_argStr);
        txt = Tpl.writeText(txt, a_additionalOutputs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           _,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context,
           a_expLst,
           a_attr_ty,
           a_additionalOutputs,
           a_argStr,
           a_path,
           _ )
      equation
        l_typeCast1 = generateTypeCast(Tpl.emptyTxt, a_attr_ty, a_expLst, true);
        l_typeCast2 = generateTypeCast(Tpl.emptyTxt, a_attr_ty, a_expLst, false);
        (l_n, a_auxFunction, a_varDecls, a_preExp) = fun_981(Tpl.emptyTxt, a_path, a_auxFunction, a_varDecls, a_preExp, a_context);
        l_func = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("(MMC_FETCH(MMC_OFFSET(MMC_UNTAGPTR("));
        l_func = Tpl.writeText(l_func, l_n);
        l_func = Tpl.writeTok(l_func, Tpl.ST_STRING("), 1)))"));
        l_closure = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("(MMC_FETCH(MMC_OFFSET(MMC_UNTAGPTR("));
        l_closure = Tpl.writeText(l_closure, l_n);
        l_closure = Tpl.writeTok(l_closure, Tpl.ST_STRING("), 2)))"));
        l_argStrPointer = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("threadData, "));
        l_argStrPointer = Tpl.writeText(l_argStrPointer, l_closure);
        (l_argStrPointer, a_auxFunction, a_varDecls, a_preExp) = lm_982(l_argStrPointer, a_expLst, a_auxFunction, a_varDecls, a_preExp, a_context);
        txt = Tpl.writeText(txt, l_closure);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" ? ("));
        txt = Tpl.writeText(txt, l_typeCast1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, l_func);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") ("));
        txt = Tpl.writeText(txt, l_argStrPointer);
        txt = Tpl.writeText(txt, a_additionalOutputs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") : ("));
        txt = Tpl.writeText(txt, l_typeCast2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, l_func);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") ("));
        txt = Tpl.writeText(txt, a_argStr);
        txt = Tpl.writeText(txt, a_additionalOutputs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end fun_983;

protected function fun_984
  input Tpl.Text in_txt;
  input DAE.Exp in_a_call;
  input Tpl.Text in_a_additionalOutputs;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_call, in_a_additionalOutputs, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      Tpl.Text a_additionalOutputs;
      SimCodeFunction.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Type i_attr_ty;
      Absyn.Path i_path;
      Boolean i_attr_isFunctionPointerCall;
      list<DAE.Exp> i_expLst;
      Boolean i_attr_builtin;
      Boolean ret_2;
      Boolean ret_1;
      Tpl.Text l_argStr;

    case ( txt,
           DAE.CALL(attr = DAE.CALL_ATTR(builtin = i_attr_builtin, isFunctionPointerCall = i_attr_isFunctionPointerCall, ty = i_attr_ty), expLst = i_expLst, path = i_path),
           a_additionalOutputs,
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        ret_1 = SimCodeFunctionUtil.isParallelFunctionContext(a_context);
        ret_2 = boolOr(i_attr_builtin, ret_1);
        (l_argStr, a_auxFunction, a_varDecls, a_preExp) = fun_979(Tpl.emptyTxt, ret_2, a_auxFunction, a_varDecls, a_preExp, a_context, i_expLst);
        (txt, a_auxFunction, a_varDecls, a_preExp) = fun_983(txt, i_attr_isFunctionPointerCall, a_auxFunction, a_varDecls, a_preExp, a_context, i_expLst, i_attr_ty, a_additionalOutputs, l_argStr, i_path, i_attr_builtin);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end fun_984;

public function daeExpCallTuple
  input Tpl.Text txt;
  input DAE.Exp a_call;
  input Tpl.Text a_additionalOutputs;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_preExp;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_additionalOutputs;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) := fun_984(txt, a_call, a_additionalOutputs, a_context, a_preExp, a_varDecls, a_auxFunction);
  out_a_additionalOutputs := a_additionalOutputs;
end daeExpCallTuple;

protected function fun_986
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty)
    local
      Tpl.Text txt;

    case ( txt,
           DAE.T_NORETCALL() )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_metatype"));
      then txt;
  end match;
end fun_986;

protected function lm_987
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      DAE.Exp i_e;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_e :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = expTypeFromExpArrayIf(txt, i_e);
        txt = lm_987(txt, rest);
      then txt;
  end match;
end lm_987;

protected function lm_988
  input Tpl.Text in_txt;
  input list<DAE.Type> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<DAE.Type> rest;
      DAE.Type i_t;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_t :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = expTypeArrayIf(txt, i_t);
        txt = lm_988(txt, rest);
      then txt;
  end match;
end lm_988;

protected function fun_989
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty)
    local
      Tpl.Text txt;
      list<DAE.Type> i_tys;

    case ( txt,
           DAE.T_TUPLE(types = _ :: i_tys) )
      equation
        txt = lm_988(txt, i_tys);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_989;

protected function fun_990
  input Tpl.Text in_txt;
  input Boolean in_a_isClosure;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_isClosure)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", modelica_metatype"));
      then txt;
  end match;
end fun_990;

protected function fun_991
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("*(void**)"));
      then txt;
  end match;
end fun_991;

public function generateTypeCast
  input Tpl.Text txt;
  input DAE.Type a_ty;
  input list<DAE.Exp> a_es;
  input Boolean a_isClosure;

  output Tpl.Text out_txt;
protected
  Boolean ret_5;
  Boolean ret_4;
  Boolean ret_3;
  Tpl.Text l_outputs;
  Tpl.Text l_inputs;
  Tpl.Text l_ret;
algorithm
  l_ret := fun_986(Tpl.emptyTxt, a_ty);
  l_inputs := lm_987(Tpl.emptyTxt, a_es);
  l_outputs := fun_989(Tpl.emptyTxt, a_ty);
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING("("));
  out_txt := Tpl.writeText(out_txt, l_ret);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("(*)(threadData_t*"));
  out_txt := fun_990(out_txt, a_isClosure);
  out_txt := Tpl.writeText(out_txt, l_inputs);
  out_txt := Tpl.writeText(out_txt, l_outputs);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("))"));
  ret_3 := boolNot(a_isClosure);
  ret_4 := Flags.isSet(Flags.OMC_RELOCATABLE_FUNCTIONS);
  ret_5 := boolAnd(ret_3, ret_4);
  out_txt := fun_991(out_txt, ret_5);
end generateTypeCast;

protected function fun_993
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty)
    local
      Tpl.Text txt;

    case ( txt,
           DAE.T_FUNCTION(funcResultType = DAE.T_NORETCALL()) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_metatype"));
      then txt;
  end match;
end fun_993;

protected function lm_994
  input Tpl.Text in_txt;
  input list<DAE.FuncArg> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<DAE.FuncArg> rest;
      DAE.Type i_fa_ty;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           DAE.FUNCARG(ty = i_fa_ty) :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = expTypeArrayIf(txt, i_fa_ty);
        txt = lm_994(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_994(txt, rest);
      then txt;
  end match;
end lm_994;

protected function fun_995
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty)
    local
      Tpl.Text txt;
      list<DAE.FuncArg> i_funcArg;

    case ( txt,
           DAE.T_FUNCTION(funcArg = i_funcArg) )
      equation
        txt = lm_994(txt, i_funcArg);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_995;

protected function lm_996
  input Tpl.Text in_txt;
  input list<DAE.Type> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<DAE.Type> rest;
      DAE.Type i_t;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_t :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = expTypeArrayIf(txt, i_t);
        txt = lm_996(txt, rest);
      then txt;
  end match;
end lm_996;

protected function fun_997
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty)
    local
      Tpl.Text txt;
      list<DAE.Type> i_tys;

    case ( txt,
           DAE.T_FUNCTION(funcResultType = DAE.T_TUPLE(types = _ :: i_tys)) )
      equation
        txt = lm_996(txt, i_tys);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_997;

protected function fun_998
  input Tpl.Text in_txt;
  input Boolean in_a_isClosure;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_isClosure)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", modelica_metatype"));
      then txt;
  end match;
end fun_998;

protected function fun_999
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("*(void**)"));
      then txt;
  end match;
end fun_999;

public function generateTypeCastFromType
  input Tpl.Text txt;
  input DAE.Type a_ty;
  input Boolean a_isClosure;

  output Tpl.Text out_txt;
protected
  Boolean ret_5;
  Boolean ret_4;
  Boolean ret_3;
  Tpl.Text l_outputs;
  Tpl.Text l_inputs;
  Tpl.Text l_ret;
algorithm
  l_ret := fun_993(Tpl.emptyTxt, a_ty);
  l_inputs := fun_995(Tpl.emptyTxt, a_ty);
  l_outputs := fun_997(Tpl.emptyTxt, a_ty);
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING("("));
  out_txt := Tpl.writeText(out_txt, l_ret);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("(*)(threadData_t*"));
  out_txt := fun_998(out_txt, a_isClosure);
  out_txt := Tpl.writeText(out_txt, l_inputs);
  out_txt := Tpl.writeText(out_txt, l_outputs);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("))"));
  ret_3 := boolNot(a_isClosure);
  ret_4 := Flags.isSet(Flags.OMC_RELOCATABLE_FUNCTIONS);
  ret_5 := boolAnd(ret_3, ret_4);
  out_txt := fun_999(out_txt, ret_5);
end generateTypeCastFromType;

protected function fun_1001
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_postExp;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;
  input list<String> in_a_vrest;
  input list<DAE.Exp> in_a_erest;
  input Tpl.Text in_a_exp;
  input String in_a_v;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_postExp;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_postExp, out_a_preExp) :=
  match(in_txt, in_mArg, in_a_auxFunction, in_a_varDecls, in_a_postExp, in_a_preExp, in_a_context, in_a_vrest, in_a_erest, in_a_exp, in_a_v)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_postExp;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      list<String> a_vrest;
      list<DAE.Exp> a_erest;
      Tpl.Text a_exp;
      String a_v;
      String ret_0;

    case ( txt,
           false,
           a_auxFunction,
           a_varDecls,
           a_postExp,
           a_preExp,
           a_context,
           a_vrest,
           a_erest,
           a_exp,
           a_v )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        ret_0 = System.unquoteIdentifier(a_v);
        txt = Tpl.writeStr(txt, ret_0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, a_exp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        (txt, a_preExp, a_postExp, a_varDecls, a_auxFunction) = daeExpTailCall(txt, a_erest, a_vrest, a_context, a_preExp, a_postExp, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls, a_postExp, a_preExp);

    case ( txt,
           _,
           a_auxFunction,
           a_varDecls,
           a_postExp,
           a_preExp,
           a_context,
           a_vrest,
           a_erest,
           _,
           _ )
      equation
        (txt, a_preExp, a_postExp, a_varDecls, a_auxFunction) = daeExpTailCall(txt, a_erest, a_vrest, a_context, a_preExp, a_postExp, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls, a_postExp, a_preExp);
  end match;
end fun_1001;

protected function fun_1002
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_restText;
  input Tpl.Text in_a_exp;
  input Tpl.Text in_a_v2;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_restText, in_a_exp, in_a_v2)
    local
      Tpl.Text txt;
      Tpl.Text a_restText;
      Tpl.Text a_exp;
      Tpl.Text a_v2;

    case ( txt,
           false,
           a_restText,
           a_exp,
           a_v2 )
      equation
        txt = Tpl.writeText(txt, a_v2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, a_exp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_restText);
      then txt;

    case ( txt,
           _,
           a_restText,
           _,
           _ )
      equation
        txt = Tpl.writeText(txt, a_restText);
      then txt;
  end match;
end fun_1002;

protected function fun_1003
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input DAE.Exp in_a_e;
  input Tpl.Text in_a_exp;
  input String in_a_v;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_postExp;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;
  input list<String> in_a_vrest;
  input list<DAE.Exp> in_a_erest;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_postExp;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_postExp, out_a_preExp) :=
  match(in_txt, in_mArg, in_a_e, in_a_exp, in_a_v, in_a_auxFunction, in_a_varDecls, in_a_postExp, in_a_preExp, in_a_context, in_a_vrest, in_a_erest)
    local
      Tpl.Text txt;
      DAE.Exp a_e;
      Tpl.Text a_exp;
      String a_v;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_postExp;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      list<String> a_vrest;
      list<DAE.Exp> a_erest;
      String ret_6;
      Tpl.Text txt_5;
      Tpl.Text l_tmp;
      Boolean ret_3;
      String ret_2;
      Tpl.Text l_v2;
      Tpl.Text l_restText;

    case ( txt,
           false,
           _,
           a_exp,
           a_v,
           a_auxFunction,
           a_varDecls,
           a_postExp,
           a_preExp,
           a_context,
           a_vrest,
           a_erest )
      equation
        (l_restText, a_preExp, a_postExp, a_varDecls, a_auxFunction) = daeExpTailCall(Tpl.emptyTxt, a_erest, a_vrest, a_context, a_preExp, a_postExp, a_varDecls, a_auxFunction);
        l_v2 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("_"));
        ret_2 = System.unquoteIdentifier(a_v);
        l_v2 = Tpl.writeStr(l_v2, ret_2);
        ret_3 = stringEq(Tpl.textString(l_v2), Tpl.textString(a_exp));
        txt = fun_1002(txt, ret_3, l_restText, a_exp, l_v2);
      then (txt, a_auxFunction, a_varDecls, a_postExp, a_preExp);

    case ( txt,
           _,
           a_e,
           a_exp,
           a_v,
           a_auxFunction,
           a_varDecls,
           a_postExp,
           a_preExp,
           a_context,
           a_vrest,
           a_erest )
      equation
        txt_5 = expTypeFromExpModelica(Tpl.emptyTxt, a_e);
        (l_tmp, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(txt_5), a_varDecls);
        a_postExp = Tpl.writeTok(a_postExp, Tpl.ST_STRING("_"));
        ret_6 = System.unquoteIdentifier(a_v);
        a_postExp = Tpl.writeStr(a_postExp, ret_6);
        a_postExp = Tpl.writeTok(a_postExp, Tpl.ST_STRING(" = "));
        a_postExp = Tpl.writeText(a_postExp, l_tmp);
        a_postExp = Tpl.writeTok(a_postExp, Tpl.ST_STRING(";"));
        a_postExp = Tpl.writeTok(a_postExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, a_exp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        (txt, a_preExp, a_postExp, a_varDecls, a_auxFunction) = daeExpTailCall(txt, a_erest, a_vrest, a_context, a_preExp, a_postExp, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls, a_postExp, a_preExp);
  end match;
end fun_1003;

protected function fun_1004
  input Tpl.Text in_txt;
  input DAE.Exp in_a_e;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_postExp;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;
  input list<String> in_a_vrest;
  input list<DAE.Exp> in_a_erest;
  input Tpl.Text in_a_exp;
  input String in_a_v;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_postExp;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_postExp, out_a_preExp) :=
  match(in_txt, in_a_e, in_a_auxFunction, in_a_varDecls, in_a_postExp, in_a_preExp, in_a_context, in_a_vrest, in_a_erest, in_a_exp, in_a_v)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_postExp;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      list<String> a_vrest;
      list<DAE.Exp> a_erest;
      Tpl.Text a_exp;
      String a_v;
      DAE.Exp i_e;
      DAE.ComponentRef i_cr;
      Boolean ret_2;
      Boolean ret_1;
      Tpl.Text txt_0;

    case ( txt,
           DAE.CREF(componentRef = i_cr, ty = DAE.T_FUNCTION_REFERENCE_VAR(functionType = _)),
           a_auxFunction,
           a_varDecls,
           a_postExp,
           a_preExp,
           a_context,
           a_vrest,
           a_erest,
           a_exp,
           a_v )
      equation
        txt_0 = CodegenUtil.crefStr(Tpl.emptyTxt, i_cr);
        ret_1 = stringEq(a_v, Tpl.textString(txt_0));
        (txt, a_auxFunction, a_varDecls, a_postExp, a_preExp) = fun_1001(txt, ret_1, a_auxFunction, a_varDecls, a_postExp, a_preExp, a_context, a_vrest, a_erest, a_exp, a_v);
      then (txt, a_auxFunction, a_varDecls, a_postExp, a_preExp);

    case ( txt,
           i_e,
           a_auxFunction,
           a_varDecls,
           a_postExp,
           a_preExp,
           a_context,
           a_vrest,
           a_erest,
           a_exp,
           a_v )
      equation
        ret_2 = Expression.anyExpHasCrefName(a_erest, a_v);
        (txt, a_auxFunction, a_varDecls, a_postExp, a_preExp) = fun_1003(txt, ret_2, i_e, a_exp, a_v, a_auxFunction, a_varDecls, a_postExp, a_preExp, a_context, a_vrest, a_erest);
      then (txt, a_auxFunction, a_varDecls, a_postExp, a_preExp);
  end match;
end fun_1004;

protected function fun_1005
  input Tpl.Text in_txt;
  input list<String> in_a_vs;
  input Tpl.Text in_a_postExp;
  input list<DAE.Exp> in_a_erest;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;
  input DAE.Exp in_a_e;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_postExp;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_postExp, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_a_vs, in_a_postExp, in_a_erest, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context, in_a_e)
    local
      Tpl.Text txt;
      Tpl.Text a_postExp;
      list<DAE.Exp> a_erest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Exp a_e;
      list<String> i_vrest;
      String i_v;
      Tpl.Text l_exp;

    case ( txt,
           i_v :: i_vrest,
           a_postExp,
           a_erest,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context,
           a_e )
      equation
        (l_exp, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, a_e, a_context, a_preExp, a_varDecls, a_auxFunction);
        (txt, a_auxFunction, a_varDecls, a_postExp, a_preExp) = fun_1004(txt, a_e, a_auxFunction, a_varDecls, a_postExp, a_preExp, a_context, i_vrest, a_erest, l_exp, i_v);
      then (txt, a_postExp, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           _,
           a_postExp,
           _,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _,
           _ )
      then (txt, a_postExp, a_auxFunction, a_varDecls, a_preExp);
  end match;
end fun_1005;

public function daeExpTailCall
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_a_es;
  input list<String> in_a_vs;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_postExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_postExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_postExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_es, in_a_vs, in_a_context, in_a_preExp, in_a_postExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      list<String> a_vs;
      SimCodeFunction.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_postExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      list<DAE.Exp> i_erest;
      DAE.Exp i_e;

    case ( txt,
           i_e :: i_erest,
           a_vs,
           a_context,
           a_preExp,
           a_postExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_postExp, a_auxFunction, a_varDecls, a_preExp) = fun_1005(txt, a_vs, a_postExp, i_erest, a_auxFunction, a_varDecls, a_preExp, a_context, i_e);
      then (txt, a_preExp, a_postExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           _,
           a_preExp,
           a_postExp,
           a_varDecls,
           a_auxFunction )
      then (txt, a_preExp, a_postExp, a_varDecls, a_auxFunction);
  end match;
end daeExpTailCall;

protected function fun_1007
  input Tpl.Text in_txt;
  input Boolean in_a_scalar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_scalar)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 6695, 49), "what is this suppsoed to do?");
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_1007;

protected function lm_1008
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Tpl.Text in_a_arrayVar;
  input Tpl.Text in_a_rec__name;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;
  input Boolean in_a_scalar;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_arrayVar, in_a_rec__name, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context, in_a_scalar)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Tpl.Text a_arrayVar;
      Tpl.Text a_rec__name;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      Boolean a_scalar;
      Integer x_i1;
      DAE.Exp i_e;
      Tpl.Text l_src;
      Tpl.Text l_prefix;

    case ( txt,
           {},
           _,
           _,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           i_e :: rest,
           a_arrayVar,
           a_rec__name,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context,
           a_scalar )
      equation
        x_i1 = Tpl.getIteri_i0(txt);
        l_prefix = fun_1007(Tpl.emptyTxt, a_scalar);
        (l_src, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "// We dont actually need to deep copy the record here. The temp variables are not used anywhere else.\n",
                                    "// "
                                }, false));
        txt = Tpl.writeText(txt, a_rec__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_copy("));
        txt = Tpl.writeText(txt, l_src);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_rec__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_array_get("));
        txt = Tpl.writeText(txt, a_arrayVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", 1, "));
        txt = Tpl.writeStr(txt, intString(x_i1));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("));\n"));
        txt = Tpl.writeText(txt, a_rec__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_array_get("));
        txt = Tpl.writeText(txt, a_arrayVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", 1, "));
        txt = Tpl.writeStr(txt, intString(x_i1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") = "));
        txt = Tpl.writeText(txt, l_src);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_1008(txt, rest, a_arrayVar, a_rec__name, a_auxFunction, a_varDecls, a_preExp, a_context, a_scalar);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end lm_1008;

protected function fun_1009
  input Tpl.Text in_txt;
  input Boolean in_a_scalar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_scalar)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("scalar_"));
      then txt;
  end match;
end fun_1009;

protected function fun_1010
  input Tpl.Text in_txt;
  input Boolean in_a_scalar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_scalar)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("&"));
      then txt;
  end match;
end fun_1010;

protected function fun_1011
  input Tpl.Text in_txt;
  input Boolean in_a_scalar;
  input DAE.Exp in_a_e;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_scalar, in_a_e)
    local
      Tpl.Text txt;
      DAE.Exp a_e;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_e )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = expTypeFromExpModelica(txt, a_e);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;
  end match;
end fun_1011;

protected function lm_1012
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;
  input Boolean in_a_scalar;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context, in_a_scalar)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      Boolean a_scalar;
      DAE.Exp i_e;
      Tpl.Text l_prefix;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           i_e :: rest,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context,
           a_scalar )
      equation
        l_prefix = fun_1011(Tpl.emptyTxt, a_scalar, i_e);
        txt = Tpl.writeText(txt, l_prefix);
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExp(txt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_1012(txt, rest, a_auxFunction, a_varDecls, a_preExp, a_context, a_scalar);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end lm_1012;

protected function fun_1013
  input Tpl.Text in_txt;
  input Tpl.Text in_a_params;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_params)
    local
      Tpl.Text txt;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}) )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
      then txt;
  end match;
end fun_1013;

public function daeExpArray
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_exp, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      Boolean i_scalar;
      list<DAE.Exp> i_array;
      DAE.Type i_t;
      DAE.Type i_ty;
      Integer ret_7;
      Tpl.Text l_scalarRef;
      Tpl.Text l_scalarPrefix;
      Tpl.Text l_params;
      Integer ret_3;
      Tpl.Text l_rec__name;
      Tpl.Text l_arrayVar;
      Tpl.Text l_arrayTypeStr;

    case ( txt,
           DAE.ARRAY(array = i_array, scalar = i_scalar, ty = (i_ty as DAE.T_ARRAY(ty = (i_t as DAE.T_COMPLEX(complexClassType = _))))),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        l_arrayTypeStr = expTypeArray(Tpl.emptyTxt, i_ty);
        (l_arrayVar, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(l_arrayTypeStr), a_varDecls);
        l_rec__name = expTypeShort(Tpl.emptyTxt, i_t);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("alloc_"));
        a_preExp = Tpl.writeText(a_preExp, l_rec__name);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("_array(&"));
        a_preExp = Tpl.writeText(a_preExp, l_arrayVar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", 1, (_index_t)"));
        ret_3 = listLength(i_array);
        a_preExp = Tpl.writeStr(a_preExp, intString(ret_3));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        l_params = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(1, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_params, a_auxFunction, a_varDecls, a_preExp) = lm_1008(l_params, i_array, l_arrayVar, l_rec__name, a_auxFunction, a_varDecls, a_preExp, a_context, i_scalar);
        l_params = Tpl.popIter(l_params);
        a_preExp = Tpl.writeText(a_preExp, l_params);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_arrayVar);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.ARRAY(array = {}),
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_arrayVar, a_varDecls) = tempDecl(Tpl.emptyTxt, "base_array_t", a_varDecls);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("simple_alloc_1d_base_array(&"));
        a_preExp = Tpl.writeText(a_preExp, l_arrayVar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", 0, NULL);"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_arrayVar);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.ARRAY(ty = i_ty, scalar = i_scalar, array = i_array),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        l_arrayTypeStr = expTypeArray(Tpl.emptyTxt, i_ty);
        (l_arrayVar, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(l_arrayTypeStr), a_varDecls);
        l_scalarPrefix = fun_1009(Tpl.emptyTxt, i_scalar);
        l_scalarRef = fun_1010(Tpl.emptyTxt, i_scalar);
        l_params = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_params, a_auxFunction, a_varDecls, a_preExp) = lm_1012(l_params, i_array, a_auxFunction, a_varDecls, a_preExp, a_context, i_scalar);
        l_params = Tpl.popIter(l_params);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("array_alloc_"));
        a_preExp = Tpl.writeText(a_preExp, l_scalarPrefix);
        a_preExp = Tpl.writeText(a_preExp, l_arrayTypeStr);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("(&"));
        a_preExp = Tpl.writeText(a_preExp, l_arrayVar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        ret_7 = listLength(i_array);
        a_preExp = Tpl.writeStr(a_preExp, intString(ret_7));
        a_preExp = fun_1013(a_preExp, l_params);
        a_preExp = Tpl.writeText(a_preExp, l_params);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_arrayVar);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end daeExpArray;

protected function lm_1015
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Tpl.Text in_a_tmp;
  input Integer in_a_i0;
  input Tpl.Text in_a_typeStr;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_tmp, in_a_i0, in_a_typeStr, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Tpl.Text a_tmp;
      Integer a_i0;
      Tpl.Text a_typeStr;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      Integer x_j0;
      DAE.Exp i_e;
      Tpl.Text l_expVar;

    case ( txt,
           {},
           _,
           _,
           _,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           i_e :: rest,
           a_tmp,
           a_i0,
           a_typeStr,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        x_j0 = Tpl.getIteri_i0(txt);
        (l_expVar, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("put_"));
        txt = Tpl.writeText(txt, a_typeStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_matrix_element("));
        txt = Tpl.writeText(txt, l_expVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeStr(txt, intString(a_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeStr(txt, intString(x_j0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", &"));
        txt = Tpl.writeText(txt, a_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_1015(txt, rest, a_tmp, a_i0, a_typeStr, a_auxFunction, a_varDecls, a_preExp, a_context);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end lm_1015;

protected function lm_1016
  input Tpl.Text in_txt;
  input list<list<DAE.Exp>> in_items;
  input Tpl.Text in_a_tmp;
  input Tpl.Text in_a_typeStr;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_tmp, in_a_typeStr, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<list<DAE.Exp>> rest;
      Tpl.Text a_tmp;
      Tpl.Text a_typeStr;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      Integer x_i0;
      list<DAE.Exp> i_row;
      Tpl.Text l_els;

    case ( txt,
           {},
           _,
           _,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           i_row :: rest,
           a_tmp,
           a_typeStr,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        l_els = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_els, a_auxFunction, a_varDecls, a_preExp) = lm_1015(l_els, i_row, a_tmp, x_i0, a_typeStr, a_auxFunction, a_varDecls, a_preExp, a_context);
        l_els = Tpl.popIter(l_els);
        txt = Tpl.writeText(txt, l_els);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_1016(txt, rest, a_tmp, a_typeStr, a_auxFunction, a_varDecls, a_preExp, a_context);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end lm_1016;

protected function lm_1017
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Tpl.Text in_a_tmp;
  input Integer in_a_i0;
  input Tpl.Text in_a_typeStr;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_tmp, in_a_i0, in_a_typeStr, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Tpl.Text a_tmp;
      Integer a_i0;
      Tpl.Text a_typeStr;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      Integer x_j0;
      DAE.Exp i_e;
      Tpl.Text l_expVar;

    case ( txt,
           {},
           _,
           _,
           _,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           i_e :: rest,
           a_tmp,
           a_i0,
           a_typeStr,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        x_j0 = Tpl.getIteri_i0(txt);
        (l_expVar, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("put_"));
        txt = Tpl.writeText(txt, a_typeStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_matrix_element("));
        txt = Tpl.writeText(txt, l_expVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeStr(txt, intString(a_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeStr(txt, intString(x_j0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", &"));
        txt = Tpl.writeText(txt, a_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_1017(txt, rest, a_tmp, a_i0, a_typeStr, a_auxFunction, a_varDecls, a_preExp, a_context);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end lm_1017;

protected function lm_1018
  input Tpl.Text in_txt;
  input list<list<DAE.Exp>> in_items;
  input Tpl.Text in_a_tmp;
  input Tpl.Text in_a_typeStr;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_tmp, in_a_typeStr, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<list<DAE.Exp>> rest;
      Tpl.Text a_tmp;
      Tpl.Text a_typeStr;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      Integer x_i0;
      list<DAE.Exp> i_row;
      Tpl.Text l_els;

    case ( txt,
           {},
           _,
           _,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           i_row :: rest,
           a_tmp,
           a_typeStr,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        l_els = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_els, a_auxFunction, a_varDecls, a_preExp) = lm_1017(l_els, i_row, a_tmp, x_i0, a_typeStr, a_auxFunction, a_varDecls, a_preExp, a_context);
        l_els = Tpl.popIter(l_els);
        txt = Tpl.writeText(txt, l_els);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_1018(txt, rest, a_tmp, a_typeStr, a_auxFunction, a_varDecls, a_preExp, a_context);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end lm_1018;

protected function lm_1019
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Tpl.Text in_a_tmp;
  input Integer in_a_i0;
  input Tpl.Text in_a_typeStr;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_tmp, in_a_i0, in_a_typeStr, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Tpl.Text a_tmp;
      Integer a_i0;
      Tpl.Text a_typeStr;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      Integer x_j0;
      DAE.Exp i_e;
      Tpl.Text l_expVar;

    case ( txt,
           {},
           _,
           _,
           _,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           i_e :: rest,
           a_tmp,
           a_i0,
           a_typeStr,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        x_j0 = Tpl.getIteri_i0(txt);
        (l_expVar, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("put_"));
        txt = Tpl.writeText(txt, a_typeStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_matrix_element("));
        txt = Tpl.writeText(txt, l_expVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeStr(txt, intString(a_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeStr(txt, intString(x_j0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", &"));
        txt = Tpl.writeText(txt, a_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_1019(txt, rest, a_tmp, a_i0, a_typeStr, a_auxFunction, a_varDecls, a_preExp, a_context);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end lm_1019;

protected function lm_1020
  input Tpl.Text in_txt;
  input list<list<DAE.Exp>> in_items;
  input Tpl.Text in_a_tmp;
  input Tpl.Text in_a_typeStr;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_tmp, in_a_typeStr, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<list<DAE.Exp>> rest;
      Tpl.Text a_tmp;
      Tpl.Text a_typeStr;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      Integer x_i0;
      list<DAE.Exp> i_row;
      Tpl.Text l_els;

    case ( txt,
           {},
           _,
           _,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           i_row :: rest,
           a_tmp,
           a_typeStr,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        l_els = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_els, a_auxFunction, a_varDecls, a_preExp) = lm_1019(l_els, i_row, a_tmp, x_i0, a_typeStr, a_auxFunction, a_varDecls, a_preExp, a_context);
        l_els = Tpl.popIter(l_els);
        txt = Tpl.writeText(txt, l_els);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_1020(txt, rest, a_tmp, a_typeStr, a_auxFunction, a_varDecls, a_preExp, a_context);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end lm_1020;

protected function lm_1021
  input Tpl.Text in_txt;
  input list<list<DAE.Exp>> in_items;
  input Tpl.Text in_a_vars2;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_promote;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_arrayTypeStr;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_vars2;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_promote;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_vars2, out_a_auxFunction, out_a_promote, out_a_varDecls) :=
  match(in_txt, in_items, in_a_vars2, in_a_auxFunction, in_a_promote, in_a_context, in_a_varDecls, in_a_arrayTypeStr)
    local
      Tpl.Text txt;
      list<list<DAE.Exp>> rest;
      Tpl.Text a_vars2;
      Tpl.Text a_auxFunction;
      Tpl.Text a_promote;
      SimCodeFunction.Context a_context;
      Tpl.Text a_varDecls;
      Tpl.Text a_arrayTypeStr;
      list<DAE.Exp> i_row;
      Integer ret_2;
      Tpl.Text l_vars;
      Tpl.Text l_tmp;

    case ( txt,
           {},
           a_vars2,
           a_auxFunction,
           a_promote,
           _,
           a_varDecls,
           _ )
      then (txt, a_vars2, a_auxFunction, a_promote, a_varDecls);

    case ( txt,
           i_row :: rest,
           a_vars2,
           a_auxFunction,
           a_promote,
           a_context,
           a_varDecls,
           a_arrayTypeStr )
      equation
        (l_tmp, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(a_arrayTypeStr), a_varDecls);
        (l_vars, a_promote, a_varDecls, a_auxFunction) = daeExpMatrixRow(Tpl.emptyTxt, i_row, Tpl.textString(a_arrayTypeStr), a_context, a_promote, a_varDecls, a_auxFunction);
        a_vars2 = Tpl.writeTok(a_vars2, Tpl.ST_STRING(", &"));
        a_vars2 = Tpl.writeText(a_vars2, l_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("cat_alloc_"));
        txt = Tpl.writeText(txt, a_arrayTypeStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(2, &"));
        txt = Tpl.writeText(txt, l_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        ret_2 = listLength(i_row);
        txt = Tpl.writeStr(txt, intString(ret_2));
        txt = Tpl.writeText(txt, l_vars);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
        txt = Tpl.nextIter(txt);
        (txt, a_vars2, a_auxFunction, a_promote, a_varDecls) = lm_1021(txt, rest, a_vars2, a_auxFunction, a_promote, a_context, a_varDecls, a_arrayTypeStr);
      then (txt, a_vars2, a_auxFunction, a_promote, a_varDecls);
  end match;
end lm_1021;

protected function fun_1022
  input Tpl.Text in_txt;
  input String in_mArg;
  input Tpl.Text in_a_typeStr;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;
  input list<list<DAE.Exp>> in_a_m_matrix;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_arrayTypeStr;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_preExp, out_a_varDecls) :=
  match(in_txt, in_mArg, in_a_typeStr, in_a_auxFunction, in_a_preExp, in_a_context, in_a_m_matrix, in_a_varDecls, in_a_arrayTypeStr)
    local
      Tpl.Text txt;
      Tpl.Text a_typeStr;
      Tpl.Text a_auxFunction;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      list<list<DAE.Exp>> a_m_matrix;
      Tpl.Text a_varDecls;
      Tpl.Text a_arrayTypeStr;
      Integer ret_16;
      Tpl.Text l_catAlloc;
      Tpl.Text l_promote;
      Tpl.Text l_vars2;
      Integer ret_12;
      list<DAE.Exp> ret_11;
      Integer ret_10;
      Integer ret_9;
      list<DAE.Exp> ret_8;
      Integer ret_7;
      Tpl.Text l_matrix;
      Integer ret_5;
      list<DAE.Exp> ret_4;
      Tpl.Text l_cols;
      Integer ret_2;
      Tpl.Text l_rows;
      Tpl.Text l_tmp;

    case ( txt,
           "real",
           a_typeStr,
           a_auxFunction,
           a_preExp,
           a_context,
           a_m_matrix,
           a_varDecls,
           a_arrayTypeStr )
      equation
        (l_tmp, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(a_arrayTypeStr), a_varDecls);
        ret_2 = listLength(a_m_matrix);
        l_rows = Tpl.writeStr(Tpl.emptyTxt, intString(ret_2));
        ret_4 = listGet(a_m_matrix, 1);
        ret_5 = listLength(ret_4);
        l_cols = Tpl.writeStr(Tpl.emptyTxt, intString(ret_5));
        l_matrix = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_matrix, a_auxFunction, a_varDecls, a_preExp) = lm_1016(l_matrix, a_m_matrix, l_tmp, a_typeStr, a_auxFunction, a_varDecls, a_preExp, a_context);
        l_matrix = Tpl.popIter(l_matrix);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("/* -- start: matrix["));
        a_preExp = Tpl.writeText(a_preExp, l_rows);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(","));
        a_preExp = Tpl.writeText(a_preExp, l_cols);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("] -- */"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("alloc_"));
        a_preExp = Tpl.writeText(a_preExp, a_typeStr);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("_array(&"));
        a_preExp = Tpl.writeText(a_preExp, l_tmp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", 2, (_index_t)"));
        a_preExp = Tpl.writeText(a_preExp, l_rows);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", (_index_t)"));
        a_preExp = Tpl.writeText(a_preExp, l_cols);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        a_preExp = Tpl.writeText(a_preExp, l_matrix);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("/* -- end: matrix["));
        a_preExp = Tpl.writeText(a_preExp, l_rows);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(","));
        a_preExp = Tpl.writeText(a_preExp, l_cols);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("] -- */"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tmp);
      then (txt, a_auxFunction, a_preExp, a_varDecls);

    case ( txt,
           "integer",
           a_typeStr,
           a_auxFunction,
           a_preExp,
           a_context,
           a_m_matrix,
           a_varDecls,
           a_arrayTypeStr )
      equation
        (l_tmp, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(a_arrayTypeStr), a_varDecls);
        ret_7 = listLength(a_m_matrix);
        l_rows = Tpl.writeStr(Tpl.emptyTxt, intString(ret_7));
        ret_8 = listGet(a_m_matrix, 1);
        ret_9 = listLength(ret_8);
        l_cols = Tpl.writeStr(Tpl.emptyTxt, intString(ret_9));
        l_matrix = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_matrix, a_auxFunction, a_varDecls, a_preExp) = lm_1018(l_matrix, a_m_matrix, l_tmp, a_typeStr, a_auxFunction, a_varDecls, a_preExp, a_context);
        l_matrix = Tpl.popIter(l_matrix);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("/* -- start: matrix["));
        a_preExp = Tpl.writeText(a_preExp, l_rows);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(","));
        a_preExp = Tpl.writeText(a_preExp, l_cols);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("] -- */"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("alloc_"));
        a_preExp = Tpl.writeText(a_preExp, a_typeStr);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("_array(&"));
        a_preExp = Tpl.writeText(a_preExp, l_tmp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", 2, (_index_t)"));
        a_preExp = Tpl.writeText(a_preExp, l_rows);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", (_index_t)"));
        a_preExp = Tpl.writeText(a_preExp, l_cols);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        a_preExp = Tpl.writeText(a_preExp, l_matrix);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("/* -- end: matrix["));
        a_preExp = Tpl.writeText(a_preExp, l_rows);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(","));
        a_preExp = Tpl.writeText(a_preExp, l_cols);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("] -- */"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tmp);
      then (txt, a_auxFunction, a_preExp, a_varDecls);

    case ( txt,
           "boolean",
           a_typeStr,
           a_auxFunction,
           a_preExp,
           a_context,
           a_m_matrix,
           a_varDecls,
           a_arrayTypeStr )
      equation
        (l_tmp, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(a_arrayTypeStr), a_varDecls);
        ret_10 = listLength(a_m_matrix);
        l_rows = Tpl.writeStr(Tpl.emptyTxt, intString(ret_10));
        ret_11 = listGet(a_m_matrix, 1);
        ret_12 = listLength(ret_11);
        l_cols = Tpl.writeStr(Tpl.emptyTxt, intString(ret_12));
        l_matrix = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_matrix, a_auxFunction, a_varDecls, a_preExp) = lm_1020(l_matrix, a_m_matrix, l_tmp, a_typeStr, a_auxFunction, a_varDecls, a_preExp, a_context);
        l_matrix = Tpl.popIter(l_matrix);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("/* -- start: matrix["));
        a_preExp = Tpl.writeText(a_preExp, l_rows);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(","));
        a_preExp = Tpl.writeText(a_preExp, l_cols);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("] -- */"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("alloc_"));
        a_preExp = Tpl.writeText(a_preExp, a_typeStr);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("_array(&"));
        a_preExp = Tpl.writeText(a_preExp, l_tmp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", 2, (_index_t)"));
        a_preExp = Tpl.writeText(a_preExp, l_rows);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", (_index_t)"));
        a_preExp = Tpl.writeText(a_preExp, l_cols);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        a_preExp = Tpl.writeText(a_preExp, l_matrix);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("/* -- end: matrix["));
        a_preExp = Tpl.writeText(a_preExp, l_rows);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(","));
        a_preExp = Tpl.writeText(a_preExp, l_cols);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("] -- */"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tmp);
      then (txt, a_auxFunction, a_preExp, a_varDecls);

    case ( txt,
           _,
           _,
           a_auxFunction,
           a_preExp,
           a_context,
           a_m_matrix,
           a_varDecls,
           a_arrayTypeStr )
      equation
        l_vars2 = Tpl.emptyTxt;
        l_promote = Tpl.emptyTxt;
        l_catAlloc = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_catAlloc, l_vars2, a_auxFunction, l_promote, a_varDecls) = lm_1021(l_catAlloc, a_m_matrix, l_vars2, a_auxFunction, l_promote, a_context, a_varDecls, a_arrayTypeStr);
        l_catAlloc = Tpl.popIter(l_catAlloc);
        a_preExp = Tpl.writeText(a_preExp, l_promote);
        a_preExp = Tpl.writeText(a_preExp, l_catAlloc);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        (l_tmp, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(a_arrayTypeStr), a_varDecls);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("cat_alloc_"));
        a_preExp = Tpl.writeText(a_preExp, a_arrayTypeStr);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("(1, &"));
        a_preExp = Tpl.writeText(a_preExp, l_tmp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        ret_16 = listLength(a_m_matrix);
        a_preExp = Tpl.writeStr(a_preExp, intString(ret_16));
        a_preExp = Tpl.writeText(a_preExp, l_vars2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tmp);
      then (txt, a_auxFunction, a_preExp, a_varDecls);
  end match;
end fun_1022;

public function daeExpMatrix
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_exp, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      list<list<DAE.Exp>> i_m_matrix;
      DAE.Type i_m_ty;
      DAE.Type i_ty;
      String str_3;
      Tpl.Text l_typeStr;
      Tpl.Text l_tmp;
      Tpl.Text l_arrayTypeStr;

    case ( txt,
           DAE.MATRIX(matrix = {{}}, ty = i_ty),
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        l_arrayTypeStr = expTypeArray(Tpl.emptyTxt, i_ty);
        (l_tmp, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(l_arrayTypeStr), a_varDecls);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("alloc_"));
        a_preExp = Tpl.writeText(a_preExp, l_arrayTypeStr);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("(&"));
        a_preExp = Tpl.writeText(a_preExp, l_tmp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", 2, (_index_t)0, (_index_t)1);"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tmp);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.MATRIX(matrix = {}, ty = i_ty),
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        l_arrayTypeStr = expTypeArray(Tpl.emptyTxt, i_ty);
        (l_tmp, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(l_arrayTypeStr), a_varDecls);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("alloc_"));
        a_preExp = Tpl.writeText(a_preExp, l_arrayTypeStr);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("(&"));
        a_preExp = Tpl.writeText(a_preExp, l_tmp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", 2, (_index_t)0, (_index_t)1);"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tmp);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.MATRIX(ty = i_m_ty, matrix = i_m_matrix),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        l_typeStr = expTypeShort(Tpl.emptyTxt, i_m_ty);
        l_arrayTypeStr = expTypeArray(Tpl.emptyTxt, i_m_ty);
        str_3 = Tpl.textString(l_typeStr);
        (txt, a_auxFunction, a_preExp, a_varDecls) = fun_1022(txt, str_3, l_typeStr, a_auxFunction, a_preExp, a_context, i_m_matrix, a_varDecls, l_arrayTypeStr);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end daeExpMatrix;

protected function lm_1024
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Tpl.Text in_a_varLstStr;
  input String in_a_arrayTypeStr;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varLstStr;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_varLstStr, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_varLstStr, in_a_arrayTypeStr, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Tpl.Text a_varLstStr;
      String a_arrayTypeStr;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Exp i_e;
      Tpl.Text l_tmp;
      Tpl.Text l_expVar;

    case ( txt,
           {},
           a_varLstStr,
           _,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_varLstStr, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           i_e :: rest,
           a_varLstStr,
           a_arrayTypeStr,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (l_expVar, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_tmp, a_varDecls) = tempDecl(Tpl.emptyTxt, a_arrayTypeStr, a_varDecls);
        a_varLstStr = Tpl.writeTok(a_varLstStr, Tpl.ST_STRING(", &"));
        a_varLstStr = Tpl.writeText(a_varLstStr, l_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("promote_scalar_"));
        txt = Tpl.writeStr(txt, a_arrayTypeStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, l_expVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", 2, &"));
        txt = Tpl.writeText(txt, l_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
        txt = Tpl.nextIter(txt);
        (txt, a_varLstStr, a_auxFunction, a_varDecls, a_preExp) = lm_1024(txt, rest, a_varLstStr, a_arrayTypeStr, a_auxFunction, a_varDecls, a_preExp, a_context);
      then (txt, a_varLstStr, a_auxFunction, a_varDecls, a_preExp);
  end match;
end lm_1024;

public function daeExpMatrixRow
  input Tpl.Text txt;
  input list<DAE.Exp> a_row;
  input String a_arrayTypeStr;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_preExp;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
protected
  Tpl.Text l_preExp2;
  Tpl.Text l_varLstStr;
algorithm
  l_varLstStr := Tpl.emptyTxt;
  l_preExp2 := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (l_preExp2, l_varLstStr, out_a_auxFunction, out_a_varDecls, out_a_preExp) := lm_1024(l_preExp2, a_row, l_varLstStr, a_arrayTypeStr, a_auxFunction, a_varDecls, a_preExp, a_context);
  l_preExp2 := Tpl.popIter(l_preExp2);
  l_preExp2 := Tpl.writeTok(l_preExp2, Tpl.ST_NEW_LINE());
  out_a_preExp := Tpl.writeText(out_a_preExp, l_preExp2);
  out_txt := Tpl.writeText(txt, l_varLstStr);
end daeExpMatrixRow;

protected function fun_1026
  input Tpl.Text in_txt;
  input Option<DAE.Exp> in_a_step;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_a_step, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Exp i_stepExp;

    case ( txt,
           SOME(i_stepExp),
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExp(txt, i_stepExp, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           _,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("1"));
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end fun_1026;

public function daeExpRange
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_exp, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      Option<DAE.Exp> i_step;
      DAE.Exp i_stop;
      DAE.Exp i_start;
      DAE.Type i_ty;
      Tpl.Text l_step__exp;
      Tpl.Text l_tmp;
      Tpl.Text l_stop__exp;
      Tpl.Text l_start__exp;
      Tpl.Text l_ty__str;

    case ( txt,
           DAE.RANGE(ty = i_ty, start = i_start, stop = i_stop, step = i_step),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        l_ty__str = expTypeArray(Tpl.emptyTxt, i_ty);
        (l_start__exp, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_start, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_stop__exp, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_stop, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_tmp, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(l_ty__str), a_varDecls);
        (l_step__exp, a_auxFunction, a_varDecls, a_preExp) = fun_1026(Tpl.emptyTxt, i_step, a_auxFunction, a_varDecls, a_preExp, a_context);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("create_"));
        a_preExp = Tpl.writeText(a_preExp, l_ty__str);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("_from_range(&"));
        a_preExp = Tpl.writeText(a_preExp, l_tmp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, l_start__exp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, l_step__exp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, l_stop__exp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tmp);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end daeExpRange;

protected function fun_1028
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_expVar;
  input DAE.Exp in_a_exp;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_expVar, in_a_exp)
    local
      Tpl.Text txt;
      Tpl.Text a_expVar;
      DAE.Exp a_exp;
      Tpl.Text txt_0;

    case ( txt,
           false,
           _,
           a_exp )
      equation
        txt_0 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("Cast on record. Revise me. "));
        txt_0 = ExpressionDumpTpl.dumpExp(txt_0, a_exp, "\"");
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 6836, 17), Tpl.textString(txt_0));
      then txt;

    case ( txt,
           _,
           a_expVar,
           _ )
      equation
        txt = Tpl.writeText(txt, a_expVar);
      then txt;
  end match;
end fun_1028;

protected function fun_1029
  input Tpl.Text in_txt;
  input DAE.Type in_mArg;
  input Tpl.Text in_a_expVar;
  input DAE.Exp in_a_exp;
  input list<DAE.Var> in_a_ty1_varLst;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_expVar, in_a_exp, in_a_ty1_varLst)
    local
      Tpl.Text txt;
      Tpl.Text a_expVar;
      DAE.Exp a_exp;
      list<DAE.Var> a_ty1_varLst;
      list<DAE.Var> i_ty2_varLst;
      Boolean ret_2;
      Integer ret_1;
      Integer ret_0;

    case ( txt,
           DAE.T_COMPLEX(varLst = i_ty2_varLst),
           a_expVar,
           a_exp,
           a_ty1_varLst )
      equation
        ret_0 = listLength(a_ty1_varLst);
        ret_1 = listLength(i_ty2_varLst);
        ret_2 = intEq(ret_0, ret_1);
        txt = fun_1028(txt, ret_2, a_expVar, a_exp);
      then txt;

    case ( txt,
           _,
           a_expVar,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_expVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") /* could not cast, using the variable as it is */"));
      then txt;
  end match;
end fun_1029;

protected function fun_1030
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;
  input Tpl.Text in_a_preExp;
  input DAE.Exp in_a_exp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_expVar;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls) :=
  match(in_txt, in_a_ty, in_a_preExp, in_a_exp, in_a_varDecls, in_a_expVar, in_a_context)
    local
      Tpl.Text txt;
      Tpl.Text a_preExp;
      DAE.Exp a_exp;
      Tpl.Text a_varDecls;
      Tpl.Text a_expVar;
      SimCodeFunction.Context a_context;
      list<DAE.Var> i_ty1_varLst;
      DAE.Type i_ty;
      DAE.Type ret_5;
      Tpl.Text l_from;
      Tpl.Text l_to;
      Tpl.Text l_tevar;
      Tpl.Text l_tvar;
      Tpl.Text l_arrayTypeStr;

    case ( txt,
           (i_ty as DAE.T_INTEGER(varLst = _)),
           a_preExp,
           _,
           a_varDecls,
           a_expVar,
           a_context )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = typeCastContext(txt, a_context, i_ty);
        txt = Tpl.writeText(txt, a_expVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           (i_ty as DAE.T_REAL(varLst = _)),
           a_preExp,
           _,
           a_varDecls,
           a_expVar,
           a_context )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = typeCastContext(txt, a_context, i_ty);
        txt = Tpl.writeText(txt, a_expVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           (i_ty as DAE.T_ENUMERATION(index = _)),
           a_preExp,
           _,
           a_varDecls,
           a_expVar,
           a_context )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = typeCastContext(txt, a_context, i_ty);
        txt = Tpl.writeText(txt, a_expVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           (i_ty as DAE.T_BOOL(varLst = _)),
           a_preExp,
           _,
           a_varDecls,
           a_expVar,
           a_context )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = typeCastContext(txt, a_context, i_ty);
        txt = Tpl.writeText(txt, a_expVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.T_ARRAY(ty = i_ty),
           a_preExp,
           a_exp,
           a_varDecls,
           a_expVar,
           _ )
      equation
        l_arrayTypeStr = expTypeArray(Tpl.emptyTxt, i_ty);
        (l_tvar, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(l_arrayTypeStr), a_varDecls);
        (l_tevar, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(l_arrayTypeStr), a_varDecls);
        l_to = expTypeShort(Tpl.emptyTxt, i_ty);
        l_from = expTypeFromExpShort(Tpl.emptyTxt, a_exp);
        a_preExp = Tpl.writeText(a_preExp, l_tevar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = "));
        a_preExp = Tpl.writeText(a_preExp, a_expVar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(";"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("cast_"));
        a_preExp = Tpl.writeText(a_preExp, l_from);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("_array_to_"));
        a_preExp = Tpl.writeText(a_preExp, l_to);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("(&"));
        a_preExp = Tpl.writeText(a_preExp, l_tevar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", &"));
        a_preExp = Tpl.writeText(a_preExp, l_tvar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tvar);
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.T_COMPLEX(complexClassType = ClassInf.RECORD(path = _), varLst = i_ty1_varLst),
           a_preExp,
           a_exp,
           a_varDecls,
           a_expVar,
           _ )
      equation
        ret_5 = Expression.typeof(a_exp);
        txt = fun_1029(txt, ret_5, a_expVar, a_exp, i_ty1_varLst);
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           _,
           a_preExp,
           _,
           a_varDecls,
           _,
           _ )
      then (txt, a_preExp, a_varDecls);
  end match;
end fun_1030;

public function daeExpCast
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_exp, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Type i_ty;
      DAE.Exp i_exp;
      Tpl.Text l_expVar;

    case ( txt,
           DAE.CAST(exp = i_exp, ty = i_ty),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_expVar, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_exp, a_context, a_preExp, a_varDecls, a_auxFunction);
        (txt, a_preExp, a_varDecls) = fun_1030(txt, i_ty, a_preExp, i_exp, a_varDecls, l_expVar, a_context);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end daeExpCast;

protected function fun_1032
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_v;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_v)
    local
      Tpl.Text txt;
      Tpl.Text a_v;

    case ( txt,
           false,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", NULL"));
      then txt;

    case ( txt,
           _,
           a_v )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", &"));
        txt = Tpl.writeText(txt, a_v);
      then txt;
  end match;
end fun_1032;

protected function lm_1033
  input Tpl.Text in_txt;
  input list<DAE.Type> in_items;
  input Tpl.Text in_a_v;
  input Integer in_a_ix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_v, in_a_ix)
    local
      Tpl.Text txt;
      list<DAE.Type> rest;
      Tpl.Text a_v;
      Integer a_ix;
      Integer x_i1;
      Boolean ret_0;

    case ( txt,
           {},
           _,
           _ )
      then txt;

    case ( txt,
           _ :: rest,
           a_v,
           a_ix )
      equation
        x_i1 = Tpl.getIteri_i0(txt);
        ret_0 = intEq(x_i1, a_ix);
        txt = fun_1032(txt, ret_0, a_v);
        txt = Tpl.nextIter(txt);
        txt = lm_1033(txt, rest, a_v, a_ix);
      then txt;
  end match;
end lm_1033;

protected function fun_1034
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_v;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_v)
    local
      Tpl.Text txt;
      Tpl.Text a_v;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_v )
      equation
        txt = Tpl.writeText(txt, a_v);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".dim_size = 0;"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;
  end match;
end fun_1034;

public function daeExpTsub
  input Tpl.Text in_txt;
  input DAE.Exp in_a_inExp;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_inExp, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Exp i_inExp;
      Integer i_ix;
      list<DAE.Type> i_tys;
      DAE.Exp i_exp;
      Tpl.Text txt_8;
      Tpl.Text l_res;
      Boolean ret_6;
      DAE.Type ret_5;
      list<DAE.Type> ret_4;
      Tpl.Text l_additionalOutputs;
      Tpl.Text txt_2;
      DAE.Type ret_1;
      Tpl.Text l_v;

    case ( txt,
           DAE.TSUB(ix = 1, exp = i_exp),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExp(txt, i_exp, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.TSUB(exp = (i_exp as DAE.CALL(attr = DAE.CALL_ATTR(ty = DAE.T_TUPLE(types = i_tys)))), ix = i_ix),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        ret_1 = listGet(i_tys, i_ix);
        txt_2 = expTypeArrayIf(Tpl.emptyTxt, ret_1);
        (l_v, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(txt_2), a_varDecls);
        ret_4 = List.restOrEmpty(i_tys);
        l_additionalOutputs = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(2, NONE(), NONE(), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_additionalOutputs = lm_1033(l_additionalOutputs, ret_4, l_v, i_ix);
        l_additionalOutputs = Tpl.popIter(l_additionalOutputs);
        ret_5 = listGet(i_tys, i_ix);
        ret_6 = Expression.isArrayType(ret_5);
        a_preExp = fun_1034(a_preExp, ret_6, l_v);
        (l_res, l_additionalOutputs, a_preExp, a_varDecls, a_auxFunction) = daeExpCallTuple(Tpl.emptyTxt, i_exp, l_additionalOutputs, a_context, a_preExp, a_varDecls, a_auxFunction);
        a_preExp = Tpl.writeText(a_preExp, l_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(";"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_v);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_inExp as DAE.TSUB(exp = _)),
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt_8 = ExpressionDumpTpl.dumpExp(Tpl.emptyTxt, i_inExp, "\"");
        txt_8 = Tpl.writeTok(txt_8, Tpl.ST_STRING(": TSUB only makes sense if the subscripted expression is a function call of tuple type"));
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 6863, 11), Tpl.textString(txt_8));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end daeExpTsub;

public function daeExpRsub
  input Tpl.Text in_txt;
  input DAE.Exp in_a_inExp;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_inExp, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Exp i_inExp;
      Integer i_ix;
      String i_fieldName;
      DAE.Exp i_exp;
      Tpl.Text txt_3;
      Integer ret_2;
      Tpl.Text l_offset;
      Tpl.Text l_res;

    case ( txt,
           DAE.RSUB(ix = -1, exp = i_exp, fieldName = i_fieldName),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_res, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_exp, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeText(txt, l_res);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("._"));
        txt = Tpl.writeStr(txt, i_fieldName);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.RSUB(exp = i_exp, ix = i_ix),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_res, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_exp, a_context, a_preExp, a_varDecls, a_auxFunction);
        ret_2 = intAdd(i_ix, 1);
        l_offset = Tpl.writeStr(Tpl.emptyTxt, intString(ret_2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(MMC_FETCH(MMC_OFFSET(MMC_UNTAGPTR("));
        txt = Tpl.writeText(txt, l_res);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("), "));
        txt = Tpl.writeText(txt, l_offset);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")))"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_inExp as DAE.RSUB(exp = _)),
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt_3 = ExpressionDumpTpl.dumpExp(Tpl.emptyTxt, i_inExp, "\"");
        txt_3 = Tpl.writeTok(txt_3, Tpl.ST_STRING(": failed"));
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 6879, 11), Tpl.textString(txt_3));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end daeExpRsub;

protected function fun_1037
  input Tpl.Text in_txt;
  input DAE.Exp in_a_inExp;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_a_inExp, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Exp i_idx;
      DAE.Exp i_e;
      Tpl.Text l_idx1;
      Tpl.Text l_e1;

    case ( txt,
           DAE.ASUB(exp = i_e, sub = {i_idx}),
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (l_e1, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_idx1, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_idx, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("arrayGet("));
        txt = Tpl.writeText(txt, l_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, l_idx1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") /* DAE.ASUB */"));
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           _,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end fun_1037;

protected function lm_1038
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Tpl.Text in_a_res;
  input Tpl.Text in_a_auxFunction;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_auxFunction) :=
  match(in_txt, in_items, in_a_res, in_a_auxFunction, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Tpl.Text a_res;
      Tpl.Text a_auxFunction;
      SimCodeFunction.Context a_context;
      Integer x_i1;
      DAE.Exp i_e;
      Tpl.Text l_v;
      Tpl.Text l_casePreExp;
      Tpl.Text l_caseVarDecls;

    case ( txt,
           {},
           _,
           a_auxFunction,
           _ )
      then (txt, a_auxFunction);

    case ( txt,
           i_e :: rest,
           a_res,
           a_auxFunction,
           a_context )
      equation
        x_i1 = Tpl.getIteri_i0(txt);
        l_caseVarDecls = Tpl.emptyTxt;
        l_casePreExp = Tpl.emptyTxt;
        (l_v, l_casePreExp, l_caseVarDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e, a_context, l_casePreExp, l_caseVarDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("case "));
        txt = Tpl.writeStr(txt, intString(x_i1));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(": {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_caseVarDecls);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_casePreExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, a_res);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, l_v);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "break;\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction) = lm_1038(txt, rest, a_res, a_auxFunction, a_context);
      then (txt, a_auxFunction);
  end match;
end lm_1038;

protected function fun_1039
  input Tpl.Text in_txt;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input list<DAE.Exp> in_a_subs;
  input DAE.Type in_a_ecr_ty;
  input Tpl.Text in_a_arrName;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_a_context, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_subs, in_a_ecr_ty, in_a_arrName)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      list<DAE.Exp> a_subs;
      DAE.Type a_ecr_ty;
      Tpl.Text a_arrName;
      SimCodeFunction.Context i_context;

    case ( txt,
           SimCodeFunction.FUNCTION_CONTEXT(cref_prefix = _),
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _,
           _,
           a_arrName )
      equation
        txt = Tpl.writeText(txt, a_arrName);
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           i_context,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_subs,
           a_ecr_ty,
           a_arrName )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = arrayScalarRhs(txt, a_ecr_ty, a_subs, Tpl.textString(a_arrName), i_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end fun_1039;

protected function lm_1040
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Exp i_index;

    case ( txt,
           {},
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           i_index :: rest,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExpASubIndex(txt, i_index, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDecls, a_preExp) = lm_1040(txt, rest, a_auxFunction, a_varDecls, a_preExp, a_context);
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end lm_1040;

protected function fun_1041
  input Tpl.Text in_txt;
  input Integer in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;
      Integer i_i;

    case ( txt,
           1 )
      then txt;

    case ( txt,
           i_i )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeStr(txt, intString(i_i));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("D"));
      then txt;
  end match;
end fun_1041;

protected function fun_1042
  input Tpl.Text in_txt;
  input DAE.Type in_mArg;
  input Tpl.Text in_a_exp;
  input Tpl.Text in_a_typeShort;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;
  input list<DAE.Exp> in_a_indexes;
  input DAE.Exp in_a_e;
  input DAE.Exp in_a_inExp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_mArg, in_a_exp, in_a_typeShort, in_a_auxFunction, in_a_varDecls, in_a_preExp, in_a_context, in_a_indexes, in_a_e, in_a_inExp)
    local
      Tpl.Text txt;
      Tpl.Text a_exp;
      Tpl.Text a_typeShort;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      list<DAE.Exp> a_indexes;
      DAE.Exp a_e;
      DAE.Exp a_inExp;
      Integer ret_6;
      Tpl.Text l_expIndexes;
      Tpl.Text txt_0;
      String ret_3;
      DAE.Type ret_2;
      String ret_1;
      DAE.Type ret_0;

    case ( txt,
           DAE.T_ARRAY(ty = _),
           _,
           _,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           _,
           _,
           a_e,
           a_inExp )
      equation
        txt_0 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("ASUB non-scalar "));
        txt_0 = ExpressionDumpTpl.dumpExp(txt_0, a_inExp, "\"");
        txt_0 = Tpl.writeTok(txt_0, Tpl.ST_STRING(". The inner exp has type: "));
        ret_0 = Expression.typeof(a_e);
        ret_1 = Types.unparseType(ret_0);
        txt_0 = Tpl.writeStr(txt_0, ret_1);
        txt_0 = Tpl.writeTok(txt_0, Tpl.ST_STRING(". After ASUB it is still an array: "));
        ret_2 = Expression.typeof(a_inExp);
        ret_3 = Types.unparseType(ret_2);
        txt_0 = Tpl.writeStr(txt_0, ret_3);
        txt_0 = Tpl.writeTok(txt_0, Tpl.ST_STRING("."));
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 6957, 13), Tpl.textString(txt_0));
      then (txt, a_auxFunction, a_varDecls, a_preExp);

    case ( txt,
           _,
           a_exp,
           a_typeShort,
           a_auxFunction,
           a_varDecls,
           a_preExp,
           a_context,
           a_indexes,
           _,
           _ )
      equation
        l_expIndexes = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_expIndexes, a_auxFunction, a_varDecls, a_preExp) = lm_1040(l_expIndexes, a_indexes, a_auxFunction, a_varDecls, a_preExp, a_context);
        l_expIndexes = Tpl.popIter(l_expIndexes);
        txt = Tpl.writeText(txt, a_typeShort);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_get"));
        ret_6 = listLength(a_indexes);
        txt = fun_1041(txt, ret_6);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_exp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, l_expIndexes);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_auxFunction, a_varDecls, a_preExp);
  end match;
end fun_1042;

protected function fun_1043
  input Tpl.Text in_txt;
  input DAE.Exp in_a_inExp;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_preExp, out_a_varDecls) :=
  match(in_txt, in_a_inExp, in_a_auxFunction, in_a_preExp, in_a_context, in_a_varDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      Tpl.Text a_varDecls;
      list<DAE.Exp> i_indexes;
      DAE.Exp i_inExp;
      DAE.Exp i_e;
      DAE.Type i_ecr_ty;
      list<DAE.Exp> i_subs;
      DAE.Exp i_ecr;
      DAE.Type i_t;
      DAE.Exp i_range;
      DAE.Exp i_range_stop;
      DAE.Exp i_range_start;
      list<DAE.Exp> i_exp_array;
      DAE.Exp i_idx;
      DAE.Exp i_exp;
      Tpl.Text txt_19;
      DAE.Type ret_18;
      Tpl.Text l_typeShort;
      Tpl.Text l_exp;
      DAE.Exp ret_15;
      Tpl.Text l_arrName;
      Tpl.Text txt_12;
      String ret_12;
      String ret_11;
      Tpl.Text txt_10;
      Tpl.Text l_stop;
      Tpl.Text l_start;
      String ret_7;
      Tpl.Text txt_6;
      Integer ret_5;
      Tpl.Text l_expl;
      Tpl.Text l_idx1;
      Tpl.Text txt_2;
      Tpl.Text l_res;
      Tpl.Text txt_0;

    case ( txt,
           DAE.ASUB(exp = (i_exp as DAE.ASUB(exp = _))),
           a_auxFunction,
           a_preExp,
           _,
           a_varDecls )
      equation
        txt_0 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("Nested array subscripting *should* have been handled by the routine creating the asub, but for some reason it was not: "));
        txt_0 = ExpressionDumpTpl.dumpExp(txt_0, i_exp, "\"");
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 6897, 11), Tpl.textString(txt_0));
      then (txt, a_auxFunction, a_preExp, a_varDecls);

    case ( txt,
           DAE.ASUB(exp = (i_exp as DAE.ARRAY(scalar = true, array = i_exp_array)), sub = {i_idx}),
           a_auxFunction,
           a_preExp,
           a_context,
           a_varDecls )
      equation
        txt_2 = expTypeFromExpModelica(Tpl.emptyTxt, i_exp);
        (l_res, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(txt_2), a_varDecls);
        (l_idx1, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_idx, a_context, a_preExp, a_varDecls, a_auxFunction);
        l_expl = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(1, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_expl, a_auxFunction) = lm_1038(l_expl, i_exp_array, l_res, a_auxFunction, a_context);
        l_expl = Tpl.popIter(l_expl);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("switch("));
        a_preExp = Tpl.writeText(a_preExp, l_idx1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING_LIST({
                                              ")\n",
                                              "{ /* ASUB */\n"
                                          }, true));
        a_preExp = Tpl.writeText(a_preExp, l_expl);
        a_preExp = Tpl.softNewLine(a_preExp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_LINE("default:\n"));
        a_preExp = Tpl.pushBlock(a_preExp, Tpl.BT_INDENT(2));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("throwStreamPrint(threadData, \"Index %ld out of bounds [1.."));
        ret_5 = listLength(i_exp_array);
        a_preExp = Tpl.writeStr(a_preExp, intString(ret_5));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("] for array "));
        txt_6 = ExpressionDumpTpl.dumpExp(Tpl.emptyTxt, i_exp, "\"");
        ret_7 = Util.escapeModelicaStringToCString(Tpl.textString(txt_6));
        a_preExp = Tpl.writeStr(a_preExp, ret_7);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("\", (long) "));
        a_preExp = Tpl.writeText(a_preExp, l_idx1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_LINE(");\n"));
        a_preExp = Tpl.popBlock(a_preExp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_LINE("}\n"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_res);
      then (txt, a_auxFunction, a_preExp, a_varDecls);

    case ( txt,
           DAE.ASUB(exp = (i_range as DAE.RANGE(ty = DAE.T_ARRAY(ty = DAE.T_INTEGER(varLst = _)), step = NONE(), start = i_range_start, stop = i_range_stop)), sub = {i_idx}),
           a_auxFunction,
           a_preExp,
           a_context,
           a_varDecls )
      equation
        (l_res, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_integer", a_varDecls);
        (l_idx1, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_idx, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_start, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_range_start, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_stop, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_range_stop, a_context, a_preExp, a_varDecls, a_auxFunction);
        a_preExp = Tpl.writeText(a_preExp, l_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = "));
        a_preExp = Tpl.writeText(a_preExp, l_idx1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" + "));
        a_preExp = Tpl.writeText(a_preExp, l_start);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING_LIST({
                                              " - 1;\n",
                                              "if ("
                                          }, false));
        a_preExp = Tpl.writeText(a_preExp, l_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" > "));
        a_preExp = Tpl.writeText(a_preExp, l_stop);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_LINE(") {\n"));
        a_preExp = Tpl.pushBlock(a_preExp, Tpl.BT_INDENT(2));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("throwStreamPrint(threadData, \"Value %ld out of bounds for range "));
        txt_10 = ExpressionDumpTpl.dumpExp(Tpl.emptyTxt, i_range, "\"");
        ret_11 = Util.escapeModelicaStringToCString(Tpl.textString(txt_10));
        a_preExp = Tpl.writeStr(a_preExp, ret_11);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("\", (long) "));
        a_preExp = Tpl.writeText(a_preExp, l_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_LINE(");\n"));
        a_preExp = Tpl.popBlock(a_preExp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("}"));
        txt = Tpl.writeText(txt, l_res);
      then (txt, a_auxFunction, a_preExp, a_varDecls);

    case ( txt,
           DAE.ASUB(exp = (i_exp as DAE.RANGE(ty = i_t)), sub = {i_idx}),
           a_auxFunction,
           a_preExp,
           _,
           a_varDecls )
      equation
        txt_12 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("ASUB_EASY_CASE type:"));
        ret_12 = Types.unparseType(i_t);
        txt_12 = Tpl.writeStr(txt_12, ret_12);
        txt_12 = Tpl.writeTok(txt_12, Tpl.ST_STRING(" range:"));
        txt_12 = ExpressionDumpTpl.dumpExp(txt_12, i_exp, "\"");
        txt_12 = Tpl.writeTok(txt_12, Tpl.ST_STRING(" index:"));
        txt_12 = ExpressionDumpTpl.dumpExp(txt_12, i_idx, "\"");
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 6941, 11), Tpl.textString(txt_12));
      then (txt, a_auxFunction, a_preExp, a_varDecls);

    case ( txt,
           DAE.ASUB(exp = (i_ecr as DAE.CREF(ty = i_ecr_ty)), sub = i_subs),
           a_auxFunction,
           a_preExp,
           a_context,
           a_varDecls )
      equation
        ret_15 = SimCodeFunctionUtil.buildCrefExpFromAsub(i_ecr, i_subs);
        (l_arrName, a_preExp, a_varDecls, a_auxFunction) = daeExpCrefRhs(Tpl.emptyTxt, ret_15, a_context, a_preExp, a_varDecls, a_auxFunction);
        (txt, a_auxFunction, a_varDecls, a_preExp) = fun_1039(txt, a_context, a_auxFunction, a_varDecls, a_preExp, i_subs, i_ecr_ty, l_arrName);
      then (txt, a_auxFunction, a_preExp, a_varDecls);

    case ( txt,
           (i_inExp as DAE.ASUB(exp = i_e, sub = i_indexes)),
           a_auxFunction,
           a_preExp,
           a_context,
           a_varDecls )
      equation
        (l_exp, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_e, a_context, a_preExp, a_varDecls, a_auxFunction);
        l_typeShort = expTypeFromExpShort(Tpl.emptyTxt, i_e);
        ret_18 = Expression.typeof(i_inExp);
        (txt, a_auxFunction, a_varDecls, a_preExp) = fun_1042(txt, ret_18, l_exp, l_typeShort, a_auxFunction, a_varDecls, a_preExp, a_context, i_indexes, i_e, i_inExp);
      then (txt, a_auxFunction, a_preExp, a_varDecls);

    case ( txt,
           i_inExp,
           a_auxFunction,
           a_preExp,
           _,
           a_varDecls )
      equation
        txt_19 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("OTHER_ASUB "));
        txt_19 = ExpressionDumpTpl.dumpExp(txt_19, i_inExp, "\"");
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 6963, 11), Tpl.textString(txt_19));
      then (txt, a_auxFunction, a_preExp, a_varDecls);
  end match;
end fun_1043;

protected function fun_1044
  input Tpl.Text in_txt;
  input String in_mArg;
  input DAE.Exp in_a_inExp;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_mArg, in_a_inExp, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      DAE.Exp a_inExp;
      SimCodeFunction.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;

    case ( txt,
           "metatype",
           a_inExp,
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_auxFunction, a_varDecls, a_preExp) = fun_1037(txt, a_inExp, a_auxFunction, a_varDecls, a_preExp, a_context);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           a_inExp,
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_auxFunction, a_preExp, a_varDecls) = fun_1043(txt, a_inExp, a_auxFunction, a_preExp, a_context, a_varDecls);
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end fun_1044;

public function daeExpAsub
  input Tpl.Text txt;
  input DAE.Exp a_inExp;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_preExp;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
protected
  String str_1;
  Tpl.Text txt_0;
algorithm
  txt_0 := expTypeFromExpShort(Tpl.emptyTxt, a_inExp);
  str_1 := Tpl.textString(txt_0);
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) := fun_1044(txt, str_1, a_inExp, a_context, a_preExp, a_varDecls, a_auxFunction);
end daeExpAsub;

public function daeExpASubIndex
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_exp, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Exp i_exp;
      Integer i_index;
      Integer i_integer;
      Integer ret_1;
      Integer ret_0;

    case ( txt,
           DAE.ICONST(integer = i_integer),
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        ret_0 = SimCodeFunctionUtil.incrementInt(i_integer, -1);
        txt = Tpl.writeStr(txt, intString(ret_0));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.ENUM_LITERAL(index = i_index),
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        ret_1 = SimCodeFunctionUtil.incrementInt(i_index, -1);
        txt = Tpl.writeStr(txt, intString(ret_1));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           i_exp,
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExp(txt, i_exp, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")-1"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end daeExpASubIndex;

public function daeExpCallPre
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_exp, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Exp i_exp;
      DAE.Exp i_cr;
      Tpl.Text txt_0;

    case ( txt,
           (i_cr as DAE.CREF(componentRef = _)),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeExpCrefLhs(txt, i_cr, a_context, a_preExp, a_varDecls, a_auxFunction, true);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           i_exp,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt_0 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("Code generation does not support pre("));
        txt_0 = ExpressionDumpTpl.dumpExp(txt_0, i_exp, "\"");
        txt_0 = Tpl.writeTok(txt_0, Tpl.ST_STRING(")"));
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 6985, 11), Tpl.textString(txt_0));
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end daeExpCallPre;

public function daeExpSize
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_exp, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Exp i_dim;
      DAE.Exp i_exp;
      Tpl.Text txt_3;
      Tpl.Text l_resVar;
      Tpl.Text l_dimPart;
      Tpl.Text l_expPart;

    case ( txt,
           DAE.SIZE(sz = SOME(i_dim), exp = i_exp),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_expPart, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_exp, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_dimPart, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_dim, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_resVar, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_integer", a_varDecls);
        a_preExp = Tpl.writeText(a_preExp, l_resVar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = size_of_dimension_base_array("));
        a_preExp = Tpl.writeText(a_preExp, l_expPart);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, l_dimPart);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_resVar);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           DAE.SIZE(sz = NONE(), exp = i_exp),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_expPart, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_exp, a_context, a_preExp, a_varDecls, a_auxFunction);
        (l_resVar, a_varDecls) = tempDecl(Tpl.emptyTxt, "integer_array", a_varDecls);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("sizes_of_dimensions_base_array(&"));
        a_preExp = Tpl.writeText(a_preExp, l_expPart);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", &"));
        a_preExp = Tpl.writeText(a_preExp, l_resVar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_resVar);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           i_exp,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt_3 = ExpressionDumpTpl.dumpExp(Tpl.emptyTxt, i_exp, "\"");
        txt_3 = Tpl.writeTok(txt_3, Tpl.ST_STRING(" not implemented"));
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 7004, 14), Tpl.textString(txt_3));
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end daeExpSize;

protected function fun_1049
  input Tpl.Text in_txt;
  input Absyn.Path in_a_ri_path;
  input Tpl.Text in_a_tmpVarDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_tmpVarDecls;
algorithm
  (out_txt, out_a_tmpVarDecls) :=
  match(in_txt, in_a_ri_path, in_a_tmpVarDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_tmpVarDecls;

    case ( txt,
           Absyn.IDENT(name = "array"),
           a_tmpVarDecls )
      equation
        (txt, a_tmpVarDecls) = tempDecl(txt, "modelica_integer", a_tmpVarDecls);
      then (txt, a_tmpVarDecls);

    case ( txt,
           _,
           a_tmpVarDecls )
      then (txt, a_tmpVarDecls);
  end match;
end fun_1049;

protected function fun_1050
  input Tpl.Text in_txt;
  input Option<Values.Value> in_a_ri_defaultValue;
  input Tpl.Text in_a_tmpVarDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_tmpVarDecls;
algorithm
  (out_txt, out_a_tmpVarDecls) :=
  match(in_txt, in_a_ri_defaultValue, in_a_tmpVarDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_tmpVarDecls;

    case ( txt,
           NONE(),
           a_tmpVarDecls )
      equation
        (txt, a_tmpVarDecls) = tempDecl(txt, "modelica_integer", a_tmpVarDecls);
      then (txt, a_tmpVarDecls);

    case ( txt,
           _,
           a_tmpVarDecls )
      then (txt, a_tmpVarDecls);
  end match;
end fun_1050;

protected function fun_1051
  input Tpl.Text in_txt;
  input Absyn.Path in_a_ri_path;
  input Tpl.Text in_a_tmpVarDecls;
  input Option<Values.Value> in_a_ri_defaultValue;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_tmpVarDecls;
algorithm
  (out_txt, out_a_tmpVarDecls) :=
  match(in_txt, in_a_ri_path, in_a_tmpVarDecls, in_a_ri_defaultValue)
    local
      Tpl.Text txt;
      Tpl.Text a_tmpVarDecls;
      Option<Values.Value> a_ri_defaultValue;

    case ( txt,
           Absyn.IDENT(name = "array"),
           a_tmpVarDecls,
           _ )
      then (txt, a_tmpVarDecls);

    case ( txt,
           _,
           a_tmpVarDecls,
           a_ri_defaultValue )
      equation
        (txt, a_tmpVarDecls) = fun_1050(txt, a_ri_defaultValue, a_tmpVarDecls);
      then (txt, a_tmpVarDecls);
  end match;
end fun_1051;

protected function fun_1052
  input Tpl.Text in_txt;
  input Absyn.Path in_a_ri_path;
  input Tpl.Text in_a_tmpVarDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_tmpVarDecls;
algorithm
  (out_txt, out_a_tmpVarDecls) :=
  match(in_txt, in_a_ri_path, in_a_tmpVarDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_tmpVarDecls;

    case ( txt,
           Absyn.IDENT(name = "list"),
           a_tmpVarDecls )
      equation
        (txt, a_tmpVarDecls) = tempDecl(txt, "modelica_metatype*", a_tmpVarDecls);
      then (txt, a_tmpVarDecls);

    case ( txt,
           _,
           a_tmpVarDecls )
      then (txt, a_tmpVarDecls);
  end match;
end fun_1052;

protected function fun_1053
  input Tpl.Text in_txt;
  input Option<Values.Value> in_a_ri_defaultValue;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_tmpVarDecls;
  input Tpl.Text in_a_preDefault;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_tmpVarDecls;
  output Tpl.Text out_a_preDefault;
algorithm
  (out_txt, out_a_auxFunction, out_a_tmpVarDecls, out_a_preDefault) :=
  match(in_txt, in_a_ri_defaultValue, in_a_auxFunction, in_a_tmpVarDecls, in_a_preDefault, in_a_context)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_tmpVarDecls;
      Tpl.Text a_preDefault;
      SimCodeFunction.Context a_context;
      Values.Value i_v;
      DAE.Exp ret_0;

    case ( txt,
           SOME(i_v),
           a_auxFunction,
           a_tmpVarDecls,
           a_preDefault,
           a_context )
      equation
        ret_0 = ValuesUtil.valueExp(i_v);
        (txt, a_preDefault, a_tmpVarDecls, a_auxFunction) = daeExp(txt, ret_0, a_context, a_preDefault, a_tmpVarDecls, a_auxFunction);
      then (txt, a_auxFunction, a_tmpVarDecls, a_preDefault);

    case ( txt,
           _,
           a_auxFunction,
           a_tmpVarDecls,
           a_preDefault,
           _ )
      then (txt, a_auxFunction, a_tmpVarDecls, a_preDefault);
  end match;
end fun_1053;

protected function fun_1054
  input Tpl.Text in_txt;
  input Absyn.Path in_a_ri_path;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_tmpVarDecls;
  input Tpl.Text in_a_preDefault;
  input SimCodeFunction.Context in_a_context;
  input Option<Values.Value> in_a_ri_defaultValue;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_tmpVarDecls;
  output Tpl.Text out_a_preDefault;
algorithm
  (out_txt, out_a_auxFunction, out_a_tmpVarDecls, out_a_preDefault) :=
  match(in_txt, in_a_ri_path, in_a_auxFunction, in_a_tmpVarDecls, in_a_preDefault, in_a_context, in_a_ri_defaultValue)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_tmpVarDecls;
      Tpl.Text a_preDefault;
      SimCodeFunction.Context a_context;
      Option<Values.Value> a_ri_defaultValue;

    case ( txt,
           Absyn.IDENT(name = "array"),
           a_auxFunction,
           a_tmpVarDecls,
           a_preDefault,
           _,
           _ )
      then (txt, a_auxFunction, a_tmpVarDecls, a_preDefault);

    case ( txt,
           _,
           a_auxFunction,
           a_tmpVarDecls,
           a_preDefault,
           a_context,
           a_ri_defaultValue )
      equation
        (txt, a_auxFunction, a_tmpVarDecls, a_preDefault) = fun_1053(txt, a_ri_defaultValue, a_auxFunction, a_tmpVarDecls, a_preDefault, a_context);
      then (txt, a_auxFunction, a_tmpVarDecls, a_preDefault);
  end match;
end fun_1054;

protected function lm_1055
  input Tpl.Text in_txt;
  input DAE.Dimensions in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      DAE.Dimensions rest;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", (modelica_integer)(1), (int*)0, \'W\'"));
        txt = lm_1055(txt, rest);
      then txt;
  end match;
end lm_1055;

protected function fun_1056
  input Tpl.Text in_txt;
  input DAE.Type in_mArg;
  input Tpl.Text in_a_arrayTypeResult;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_reductionBodyExpr;
  input Tpl.Text in_a_arrIndex;
  input Tpl.Text in_a_res;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_varDecls) :=
  match(in_txt, in_mArg, in_a_arrayTypeResult, in_a_varDecls, in_a_reductionBodyExpr, in_a_arrIndex, in_a_res)
    local
      Tpl.Text txt;
      Tpl.Text a_arrayTypeResult;
      Tpl.Text a_varDecls;
      Tpl.Text a_reductionBodyExpr;
      Tpl.Text a_arrIndex;
      Tpl.Text a_res;
      DAE.Type i_ty;
      DAE.Dimensions i_dims;
      ClassInf.State i_record__state;
      Tpl.Text l_idx__str;
      Integer ret_5;
      Integer ret_4;
      Tpl.Text l_nridx__str;
      Tpl.Text l_tmp;
      Absyn.Path ret_1;
      Tpl.Text l_rec__name;

    case ( txt,
           DAE.T_COMPLEX(complexClassType = i_record__state),
           _,
           a_varDecls,
           a_reductionBodyExpr,
           a_arrIndex,
           a_res )
      equation
        ret_1 = ClassInf.getStateName(i_record__state);
        l_rec__name = CodegenUtil.underscorePath(Tpl.emptyTxt, ret_1);
        txt = Tpl.writeText(txt, l_rec__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_array_get("));
        txt = Tpl.writeText(txt, a_res);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", 1, "));
        txt = Tpl.writeText(txt, a_arrIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("++) = "));
        txt = Tpl.writeText(txt, a_reductionBodyExpr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then (txt, a_varDecls);

    case ( txt,
           DAE.T_ARRAY(dims = i_dims, ty = i_ty),
           _,
           a_varDecls,
           a_reductionBodyExpr,
           a_arrIndex,
           a_res )
      equation
        (l_tmp, a_varDecls) = tempDecl(Tpl.emptyTxt, "index_spec_t", a_varDecls);
        ret_4 = listLength(i_dims);
        ret_5 = intAdd(1, ret_4);
        l_nridx__str = Tpl.writeStr(Tpl.emptyTxt, intString(ret_5));
        l_idx__str = lm_1055(Tpl.emptyTxt, i_dims);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("create_index_spec(&"));
        txt = Tpl.writeText(txt, l_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, l_nridx__str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", (modelica_integer)(0), make_index_array(1, (modelica_integer) "));
        txt = Tpl.writeText(txt, a_arrIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("++), \'S\'"));
        txt = Tpl.writeText(txt, l_idx__str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ");\n",
                                    "indexed_assign_"
                                }, false));
        txt = expTypeArray(txt, i_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_reductionBodyExpr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", &"));
        txt = Tpl.writeText(txt, a_res);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", &"));
        txt = Tpl.writeText(txt, l_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then (txt, a_varDecls);

    case ( txt,
           _,
           a_arrayTypeResult,
           a_varDecls,
           a_reductionBodyExpr,
           a_arrIndex,
           a_res )
      equation
        txt = Tpl.writeText(txt, a_arrayTypeResult);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_get1("));
        txt = Tpl.writeText(txt, a_res);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", 1, "));
        txt = Tpl.writeText(txt, a_arrIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("++) = "));
        txt = Tpl.writeText(txt, a_reductionBodyExpr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then (txt, a_varDecls);
  end match;
end fun_1056;

protected function fun_1057
  input Tpl.Text in_txt;
  input Tpl.Text in_a_foundFirst;
  input Tpl.Text in_a_reductionBodyExpr;
  input Tpl.Text in_a_fExpStr;
  input Tpl.Text in_a_res;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_foundFirst, in_a_reductionBodyExpr, in_a_fExpStr, in_a_res)
    local
      Tpl.Text txt;
      Tpl.Text a_reductionBodyExpr;
      Tpl.Text a_fExpStr;
      Tpl.Text a_res;
      Tpl.Text i_foundFirst;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           _,
           a_fExpStr,
           a_res )
      equation
        txt = Tpl.writeText(txt, a_res);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, a_fExpStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           i_foundFirst,
           a_reductionBodyExpr,
           a_fExpStr,
           a_res )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if("));
        txt = Tpl.writeText(txt, i_foundFirst);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ")\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_res);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, a_fExpStr);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "else\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_res);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, a_reductionBodyExpr);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.writeText(txt, i_foundFirst);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" = 1;\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;
  end match;
end fun_1057;

protected function fun_1058
  input Tpl.Text in_txt;
  input Option<DAE.Exp> in_a_ri_foldExp;
  input Tpl.Text in_a_reductionBodyExpr;
  input Tpl.Text in_a_res;
  input Tpl.Text in_a_foundFirst;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_tmpVarDecls;
  input Tpl.Text in_a_bodyExpPre;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_tmpVarDecls;
  output Tpl.Text out_a_bodyExpPre;
algorithm
  (out_txt, out_a_auxFunction, out_a_tmpVarDecls, out_a_bodyExpPre) :=
  match(in_txt, in_a_ri_foldExp, in_a_reductionBodyExpr, in_a_res, in_a_foundFirst, in_a_auxFunction, in_a_tmpVarDecls, in_a_bodyExpPre, in_a_context)
    local
      Tpl.Text txt;
      Tpl.Text a_reductionBodyExpr;
      Tpl.Text a_res;
      Tpl.Text a_foundFirst;
      Tpl.Text a_auxFunction;
      Tpl.Text a_tmpVarDecls;
      Tpl.Text a_bodyExpPre;
      SimCodeFunction.Context a_context;
      DAE.Exp i_fExp;
      Tpl.Text l_fExpStr;
      Tpl.Text l_foldExpPre;

    case ( txt,
           SOME(i_fExp),
           a_reductionBodyExpr,
           a_res,
           a_foundFirst,
           a_auxFunction,
           a_tmpVarDecls,
           a_bodyExpPre,
           a_context )
      equation
        l_foldExpPre = Tpl.emptyTxt;
        (l_fExpStr, a_bodyExpPre, a_tmpVarDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_fExp, a_context, a_bodyExpPre, a_tmpVarDecls, a_auxFunction);
        txt = fun_1057(txt, a_foundFirst, a_reductionBodyExpr, l_fExpStr, a_res);
      then (txt, a_auxFunction, a_tmpVarDecls, a_bodyExpPre);

    case ( txt,
           _,
           _,
           _,
           _,
           a_auxFunction,
           a_tmpVarDecls,
           a_bodyExpPre,
           _ )
      then (txt, a_auxFunction, a_tmpVarDecls, a_bodyExpPre);
  end match;
end fun_1058;

protected function fun_1059
  input Tpl.Text in_txt;
  input Absyn.Path in_a_ri_path;
  input Tpl.Text in_a_foundFirst;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_tmpVarDecls;
  input Tpl.Text in_a_bodyExpPre;
  input SimCodeFunction.Context in_a_context;
  input Option<DAE.Exp> in_a_ri_foldExp;
  input Tpl.Text in_a_arrayTypeResult;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_arrIndex;
  input DAE.Exp in_a_r_expr;
  input Tpl.Text in_a_res;
  input Tpl.Text in_a_reductionBodyExpr;
  input Tpl.Text in_a_resTail;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_tmpVarDecls;
  output Tpl.Text out_a_bodyExpPre;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_tmpVarDecls, out_a_bodyExpPre, out_a_varDecls) :=
  match(in_txt, in_a_ri_path, in_a_foundFirst, in_a_auxFunction, in_a_tmpVarDecls, in_a_bodyExpPre, in_a_context, in_a_ri_foldExp, in_a_arrayTypeResult, in_a_varDecls, in_a_arrIndex, in_a_r_expr, in_a_res, in_a_reductionBodyExpr, in_a_resTail)
    local
      Tpl.Text txt;
      Tpl.Text a_foundFirst;
      Tpl.Text a_auxFunction;
      Tpl.Text a_tmpVarDecls;
      Tpl.Text a_bodyExpPre;
      SimCodeFunction.Context a_context;
      Option<DAE.Exp> a_ri_foldExp;
      Tpl.Text a_arrayTypeResult;
      Tpl.Text a_varDecls;
      Tpl.Text a_arrIndex;
      DAE.Exp a_r_expr;
      Tpl.Text a_res;
      Tpl.Text a_reductionBodyExpr;
      Tpl.Text a_resTail;
      DAE.Type ret_0;

    case ( txt,
           Absyn.IDENT(name = "list"),
           _,
           a_auxFunction,
           a_tmpVarDecls,
           a_bodyExpPre,
           _,
           _,
           _,
           a_varDecls,
           _,
           _,
           _,
           a_reductionBodyExpr,
           a_resTail )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("*"));
        txt = Tpl.writeText(txt, a_resTail);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = mmc_mk_cons("));
        txt = Tpl.writeText(txt, a_reductionBodyExpr);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",0);\n"));
        txt = Tpl.writeText(txt, a_resTail);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = &MMC_CDR(*"));
        txt = Tpl.writeText(txt, a_resTail);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then (txt, a_auxFunction, a_tmpVarDecls, a_bodyExpPre, a_varDecls);

    case ( txt,
           Absyn.IDENT(name = "listReverse"),
           _,
           a_auxFunction,
           a_tmpVarDecls,
           a_bodyExpPre,
           _,
           _,
           _,
           a_varDecls,
           _,
           _,
           a_res,
           a_reductionBodyExpr,
           _ )
      equation
        txt = Tpl.writeText(txt, a_res);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = mmc_mk_cons("));
        txt = Tpl.writeText(txt, a_reductionBodyExpr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, a_res);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then (txt, a_auxFunction, a_tmpVarDecls, a_bodyExpPre, a_varDecls);

    case ( txt,
           Absyn.IDENT(name = "array"),
           _,
           a_auxFunction,
           a_tmpVarDecls,
           a_bodyExpPre,
           _,
           _,
           a_arrayTypeResult,
           a_varDecls,
           a_arrIndex,
           a_r_expr,
           a_res,
           a_reductionBodyExpr,
           _ )
      equation
        ret_0 = Expression.typeof(a_r_expr);
        (txt, a_varDecls) = fun_1056(txt, ret_0, a_arrayTypeResult, a_varDecls, a_reductionBodyExpr, a_arrIndex, a_res);
      then (txt, a_auxFunction, a_tmpVarDecls, a_bodyExpPre, a_varDecls);

    case ( txt,
           _,
           a_foundFirst,
           a_auxFunction,
           a_tmpVarDecls,
           a_bodyExpPre,
           a_context,
           a_ri_foldExp,
           _,
           a_varDecls,
           _,
           _,
           a_res,
           a_reductionBodyExpr,
           _ )
      equation
        (txt, a_auxFunction, a_tmpVarDecls, a_bodyExpPre) = fun_1058(txt, a_ri_foldExp, a_reductionBodyExpr, a_res, a_foundFirst, a_auxFunction, a_tmpVarDecls, a_bodyExpPre, a_context);
      then (txt, a_auxFunction, a_tmpVarDecls, a_bodyExpPre, a_varDecls);
  end match;
end fun_1059;

protected function fun_1060
  input Tpl.Text in_txt;
  input DAE.Exp in_a_iter_exp;
  input Tpl.Text in_a_iteratorName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_iter_exp, in_a_iteratorName)
    local
      Tpl.Text txt;
      Tpl.Text a_iteratorName;

    case ( txt,
           DAE.RANGE(ty = _),
           a_iteratorName )
      equation
        txt = Tpl.writeText(txt, a_iteratorName);
      then txt;

    case ( txt,
           _,
           a_iteratorName )
      equation
        txt = Tpl.writeText(txt, a_iteratorName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_loopVar"));
      then txt;
  end match;
end fun_1060;

protected function fun_1061
  input Tpl.Text in_txt;
  input DAE.Exp in_a_iter_exp;
  input Tpl.Text in_a_tmpVarDecls;
  input Tpl.Text in_a_identType;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_tmpVarDecls;
algorithm
  (out_txt, out_a_tmpVarDecls) :=
  match(in_txt, in_a_iter_exp, in_a_tmpVarDecls, in_a_identType)
    local
      Tpl.Text txt;
      Tpl.Text a_tmpVarDecls;
      Tpl.Text a_identType;

    case ( txt,
           DAE.RANGE(ty = _),
           a_tmpVarDecls,
           a_identType )
      equation
        (txt, a_tmpVarDecls) = tempDecl(txt, Tpl.textString(a_identType), a_tmpVarDecls);
      then (txt, a_tmpVarDecls);

    case ( txt,
           _,
           a_tmpVarDecls,
           _ )
      then (txt, a_tmpVarDecls);
  end match;
end fun_1061;

protected function fun_1062
  input Tpl.Text in_txt;
  input DAE.Exp in_a_iter_exp;
  input Tpl.Text in_a_tmpVarDecls;
  input Tpl.Text in_a_identType;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_tmpVarDecls;
algorithm
  (out_txt, out_a_tmpVarDecls) :=
  match(in_txt, in_a_iter_exp, in_a_tmpVarDecls, in_a_identType)
    local
      Tpl.Text txt;
      Tpl.Text a_tmpVarDecls;
      Tpl.Text a_identType;

    case ( txt,
           DAE.RANGE(ty = _),
           a_tmpVarDecls,
           a_identType )
      equation
        (txt, a_tmpVarDecls) = tempDecl(txt, Tpl.textString(a_identType), a_tmpVarDecls);
      then (txt, a_tmpVarDecls);

    case ( txt,
           _,
           a_tmpVarDecls,
           _ )
      then (txt, a_tmpVarDecls);
  end match;
end fun_1062;

protected function fun_1063
  input Tpl.Text in_txt;
  input DAE.Exp in_a_iter_exp;
  input Tpl.Text in_a_loopVar;
  input Tpl.Text in_a_arrayType;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_iter_exp, in_a_loopVar, in_a_arrayType)
    local
      Tpl.Text txt;
      Tpl.Text a_loopVar;
      Tpl.Text a_arrayType;

    case ( txt,
           DAE.RANGE(ty = _),
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_loopVar,
           a_arrayType )
      equation
        txt = Tpl.writeText(txt, a_arrayType);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, a_loopVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;
  end match;
end fun_1063;

protected function fun_1064
  input Tpl.Text in_txt;
  input String in_mArg;
  input Tpl.Text in_a_arrayType;
  input DAE.Exp in_a_iter_exp;
  input Tpl.Text in_a_loopVar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_arrayType, in_a_iter_exp, in_a_loopVar)
    local
      Tpl.Text txt;
      Tpl.Text a_arrayType;
      DAE.Exp a_iter_exp;
      Tpl.Text a_loopVar;

    case ( txt,
           "modelica_metatype",
           _,
           _,
           a_loopVar )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_metatype "));
        txt = Tpl.writeText(txt, a_loopVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = 0;"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _,
           a_arrayType,
           a_iter_exp,
           a_loopVar )
      equation
        txt = fun_1063(txt, a_iter_exp, a_loopVar, a_arrayType);
      then txt;
  end match;
end fun_1064;

protected function fun_1065
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_tmpVarDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_tmpVarDecls;
algorithm
  (out_txt, out_a_tmpVarDecls) :=
  match(in_txt, in_mArg, in_a_tmpVarDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_tmpVarDecls;

    case ( txt,
           false,
           a_tmpVarDecls )
      then (txt, a_tmpVarDecls);

    case ( txt,
           _,
           a_tmpVarDecls )
      equation
        (txt, a_tmpVarDecls) = tempDecl(txt, "modelica_integer", a_tmpVarDecls);
      then (txt, a_tmpVarDecls);
  end match;
end fun_1065;

protected function fun_1066
  input Tpl.Text in_txt;
  input String in_mArg;
  input Tpl.Text in_a_tmpVarDecls;
  input DAE.Exp in_a_iter_exp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_tmpVarDecls;
algorithm
  (out_txt, out_a_tmpVarDecls) :=
  match(in_txt, in_mArg, in_a_tmpVarDecls, in_a_iter_exp)
    local
      Tpl.Text txt;
      Tpl.Text a_tmpVarDecls;
      DAE.Exp a_iter_exp;
      Boolean ret_0;

    case ( txt,
           "modelica_metatype",
           a_tmpVarDecls,
           a_iter_exp )
      equation
        ret_0 = Expression.isMetaArray(a_iter_exp);
        (txt, a_tmpVarDecls) = fun_1065(txt, ret_0, a_tmpVarDecls);
      then (txt, a_tmpVarDecls);

    case ( txt,
           _,
           a_tmpVarDecls,
           _ )
      equation
        (txt, a_tmpVarDecls) = tempDecl(txt, "modelica_integer", a_tmpVarDecls);
      then (txt, a_tmpVarDecls);
  end match;
end fun_1066;

protected function fun_1067
  input Tpl.Text in_txt;
  input DAE.Exp in_a_iter_exp;
  input Tpl.Text in_a_tmpVarDecls;
  input Tpl.Text in_a_identType;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_tmpVarDecls;
algorithm
  (out_txt, out_a_tmpVarDecls) :=
  match(in_txt, in_a_iter_exp, in_a_tmpVarDecls, in_a_identType)
    local
      Tpl.Text txt;
      Tpl.Text a_tmpVarDecls;
      Tpl.Text a_identType;
      DAE.Exp i_iter_exp;
      String str_0;

    case ( txt,
           DAE.RANGE(ty = _),
           a_tmpVarDecls,
           _ )
      then (txt, a_tmpVarDecls);

    case ( txt,
           i_iter_exp,
           a_tmpVarDecls,
           a_identType )
      equation
        str_0 = Tpl.textString(a_identType);
        (txt, a_tmpVarDecls) = fun_1066(txt, str_0, a_tmpVarDecls, i_iter_exp);
      then (txt, a_tmpVarDecls);
  end match;
end fun_1067;

protected function fun_1068
  input Tpl.Text in_txt;
  input DAE.Exp in_a_iter_exp;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_tmpVarDecls;
  input Tpl.Text in_a_rangeExpPre;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_tmpVarDecls;
  output Tpl.Text out_a_rangeExpPre;
algorithm
  (out_txt, out_a_auxFunction, out_a_tmpVarDecls, out_a_rangeExpPre) :=
  match(in_txt, in_a_iter_exp, in_a_auxFunction, in_a_tmpVarDecls, in_a_rangeExpPre, in_a_context)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_tmpVarDecls;
      Tpl.Text a_rangeExpPre;
      SimCodeFunction.Context a_context;
      DAE.Exp i_step;

    case ( txt,
           DAE.RANGE(step = NONE()),
           a_auxFunction,
           a_tmpVarDecls,
           a_rangeExpPre,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("1 /* Range step-value */"));
      then (txt, a_auxFunction, a_tmpVarDecls, a_rangeExpPre);

    case ( txt,
           DAE.RANGE(step = SOME(i_step)),
           a_auxFunction,
           a_tmpVarDecls,
           a_rangeExpPre,
           a_context )
      equation
        (txt, a_rangeExpPre, a_tmpVarDecls, a_auxFunction) = daeExp(txt, i_step, a_context, a_rangeExpPre, a_tmpVarDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" /* Range step-value */"));
      then (txt, a_auxFunction, a_tmpVarDecls, a_rangeExpPre);

    case ( txt,
           _,
           a_auxFunction,
           a_tmpVarDecls,
           a_rangeExpPre,
           _ )
      then (txt, a_auxFunction, a_tmpVarDecls, a_rangeExpPre);
  end match;
end fun_1068;

protected function fun_1069
  input Tpl.Text in_txt;
  input DAE.Exp in_a_iter_exp;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_tmpVarDecls;
  input Tpl.Text in_a_rangeExpPre;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_tmpVarDecls;
  output Tpl.Text out_a_rangeExpPre;
algorithm
  (out_txt, out_a_auxFunction, out_a_tmpVarDecls, out_a_rangeExpPre) :=
  match(in_txt, in_a_iter_exp, in_a_auxFunction, in_a_tmpVarDecls, in_a_rangeExpPre, in_a_context)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_tmpVarDecls;
      Tpl.Text a_rangeExpPre;
      SimCodeFunction.Context a_context;
      DAE.Exp i_stop;

    case ( txt,
           DAE.RANGE(stop = i_stop),
           a_auxFunction,
           a_tmpVarDecls,
           a_rangeExpPre,
           a_context )
      equation
        (txt, a_rangeExpPre, a_tmpVarDecls, a_auxFunction) = daeExp(txt, i_stop, a_context, a_rangeExpPre, a_tmpVarDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" /* Range stop-value */"));
      then (txt, a_auxFunction, a_tmpVarDecls, a_rangeExpPre);

    case ( txt,
           _,
           a_auxFunction,
           a_tmpVarDecls,
           a_rangeExpPre,
           _ )
      then (txt, a_auxFunction, a_tmpVarDecls, a_rangeExpPre);
  end match;
end fun_1069;

protected function fun_1070
  input Tpl.Text in_txt;
  input DAE.Exp in_a_iter_exp;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_tmpVarDecls;
  input Tpl.Text in_a_rangeExpPre;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_tmpVarDecls;
  output Tpl.Text out_a_rangeExpPre;
algorithm
  (out_txt, out_a_auxFunction, out_a_tmpVarDecls, out_a_rangeExpPre) :=
  match(in_txt, in_a_iter_exp, in_a_auxFunction, in_a_tmpVarDecls, in_a_rangeExpPre, in_a_context)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_tmpVarDecls;
      Tpl.Text a_rangeExpPre;
      SimCodeFunction.Context a_context;
      DAE.Exp i_iter_exp;
      DAE.Exp i_start;

    case ( txt,
           DAE.RANGE(start = i_start),
           a_auxFunction,
           a_tmpVarDecls,
           a_rangeExpPre,
           a_context )
      equation
        (txt, a_rangeExpPre, a_tmpVarDecls, a_auxFunction) = daeExp(txt, i_start, a_context, a_rangeExpPre, a_tmpVarDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" /* Range start-value */"));
      then (txt, a_auxFunction, a_tmpVarDecls, a_rangeExpPre);

    case ( txt,
           i_iter_exp,
           a_auxFunction,
           a_tmpVarDecls,
           a_rangeExpPre,
           a_context )
      equation
        (txt, a_rangeExpPre, a_tmpVarDecls, a_auxFunction) = daeExp(txt, i_iter_exp, a_context, a_rangeExpPre, a_tmpVarDecls, a_auxFunction);
      then (txt, a_auxFunction, a_tmpVarDecls, a_rangeExpPre);
  end match;
end fun_1070;

protected function fun_1071
  input Tpl.Text in_txt;
  input Tpl.Text in_a_rangeExpStep;
  input Tpl.Text in_a_stepVar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_rangeExpStep, in_a_stepVar)
    local
      Tpl.Text txt;
      Tpl.Text a_stepVar;
      Tpl.Text i_rangeExpStep;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           _ )
      then txt;

    case ( txt,
           i_rangeExpStep,
           a_stepVar )
      equation
        txt = Tpl.writeText(txt, a_stepVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, i_rangeExpStep);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;
  end match;
end fun_1071;

protected function fun_1072
  input Tpl.Text in_txt;
  input Tpl.Text in_a_rangeExpStop;
  input Tpl.Text in_a_stopVar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_rangeExpStop, in_a_stopVar)
    local
      Tpl.Text txt;
      Tpl.Text a_stopVar;
      Tpl.Text i_rangeExpStop;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           _ )
      then txt;

    case ( txt,
           i_rangeExpStop,
           a_stopVar )
      equation
        txt = Tpl.writeText(txt, a_stopVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, i_rangeExpStop);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;
  end match;
end fun_1072;

protected function fun_1073
  input Tpl.Text in_txt;
  input DAE.Exp in_a_iter_exp;
  input Tpl.Text in_a_check;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_iter_exp, in_a_check)
    local
      Tpl.Text txt;
      Tpl.Text a_check;

    case ( txt,
           DAE.RANGE(step = SOME(DAE.ICONST(integer = 0))),
           a_check )
      equation
        txt = Tpl.writeText(txt, a_check);
      then txt;

    case ( txt,
           DAE.RANGE(step = NONE()),
           _ )
      then txt;

    case ( txt,
           DAE.RANGE(step = SOME(DAE.ICONST(integer = _))),
           _ )
      then txt;

    case ( txt,
           _,
           a_check )
      equation
        txt = Tpl.writeText(txt, a_check);
      then txt;
  end match;
end fun_1073;

protected function fun_1074
  input Tpl.Text in_txt;
  input Tpl.Text in_a_rangeExpStop;
  input DAE.Exp in_a_iter_exp;
  input Tpl.Text in_a_stepVar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_rangeExpStop, in_a_iter_exp, in_a_stepVar)
    local
      Tpl.Text txt;
      DAE.Exp a_iter_exp;
      Tpl.Text a_stepVar;
      Tpl.Text l_check;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_iter_exp,
           a_stepVar )
      equation
        l_check = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("if ("));
        l_check = Tpl.writeText(l_check, a_stepVar);
        l_check = Tpl.writeTok(l_check, Tpl.ST_STRING_LIST({
                                            " == 0) {\n",
                                            "  FILE_INFO info = omc_dummyFileInfo;\n",
                                            "  omc_assert(threadData, info, \"Range with a step of zero.\");\n",
                                            "}"
                                        }, false));
        l_check = Tpl.writeTok(l_check, Tpl.ST_NEW_LINE());
        txt = fun_1073(txt, a_iter_exp, l_check);
      then txt;
  end match;
end fun_1074;

protected function fun_1075
  input Tpl.Text in_txt;
  input Absyn.Path in_a_ri_path;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ri_path)
    local
      Tpl.Text txt;

    case ( txt,
           Absyn.IDENT(name = "array") )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("1"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_1075;

protected function fun_1076
  input Tpl.Text in_txt;
  input Tpl.Text in_a_rangeExpStop;
  input Absyn.Path in_a_ri_path;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_rangeExpStop, in_a_ri_path)
    local
      Tpl.Text txt;
      Absyn.Path a_ri_path;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           _ )
      then txt;

    case ( txt,
           _,
           a_ri_path )
      equation
        txt = fun_1075(txt, a_ri_path);
      then txt;
  end match;
end fun_1076;

protected function fun_1077
  input Tpl.Text in_txt;
  input Tpl.Text in_a_isArrayWithLength;
  input Tpl.Text in_a_iteratorName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_isArrayWithLength, in_a_iteratorName)
    local
      Tpl.Text txt;
      Tpl.Text a_iteratorName;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           _ )
      then txt;

    case ( txt,
           _,
           a_iteratorName )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_integer "));
        txt = Tpl.writeText(txt, a_iteratorName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_length;"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;
  end match;
end fun_1077;

protected function fun_1078
  input Tpl.Text in_txt;
  input Tpl.Text in_a_firstIndex;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_firstIndex)
    local
      Tpl.Text txt;
      Tpl.Text i_firstIndex;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}) )
      then txt;

    case ( txt,
           i_firstIndex )
      equation
        txt = Tpl.writeText(txt, i_firstIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = 1;"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;
  end match;
end fun_1078;

protected function fun_1079
  input Tpl.Text in_txt;
  input DAE.Exp in_a_iter_exp;
  input Tpl.Text in_a_firstIndex;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_iter_exp, in_a_firstIndex)
    local
      Tpl.Text txt;
      Tpl.Text a_firstIndex;

    case ( txt,
           DAE.RANGE(ty = _),
           _ )
      then txt;

    case ( txt,
           _,
           a_firstIndex )
      equation
        txt = fun_1078(txt, a_firstIndex);
      then txt;
  end match;
end fun_1079;

protected function fun_1080
  input Tpl.Text in_txt;
  input Option<DAE.Exp> in_a_iter_guardExp;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_tmpVarDecls;
  input Tpl.Text in_a_guardExpPre;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_tmpVarDecls;
  output Tpl.Text out_a_guardExpPre;
algorithm
  (out_txt, out_a_auxFunction, out_a_tmpVarDecls, out_a_guardExpPre) :=
  match(in_txt, in_a_iter_guardExp, in_a_auxFunction, in_a_tmpVarDecls, in_a_guardExpPre, in_a_context)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_tmpVarDecls;
      Tpl.Text a_guardExpPre;
      SimCodeFunction.Context a_context;
      DAE.Exp i_grd;

    case ( txt,
           SOME(i_grd),
           a_auxFunction,
           a_tmpVarDecls,
           a_guardExpPre,
           a_context )
      equation
        (txt, a_guardExpPre, a_tmpVarDecls, a_auxFunction) = daeExp(txt, i_grd, a_context, a_guardExpPre, a_tmpVarDecls, a_auxFunction);
      then (txt, a_auxFunction, a_tmpVarDecls, a_guardExpPre);

    case ( txt,
           _,
           a_auxFunction,
           a_tmpVarDecls,
           a_guardExpPre,
           _ )
      then (txt, a_auxFunction, a_tmpVarDecls, a_guardExpPre);
  end match;
end fun_1080;

protected function fun_1081
  input Tpl.Text in_txt;
  input Tpl.Text in_a_firstIndex;
  input Tpl.Text in_a_iteratorName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_firstIndex, in_a_iteratorName)
    local
      Tpl.Text txt;
      Tpl.Text a_iteratorName;
      Tpl.Text i_firstIndex;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           a_iteratorName )
      equation
        txt = Tpl.writeText(txt, a_iteratorName);
      then txt;

    case ( txt,
           i_firstIndex,
           _ )
      equation
        txt = Tpl.writeText(txt, i_firstIndex);
      then txt;
  end match;
end fun_1081;

protected function fun_1082
  input Tpl.Text in_txt;
  input Tpl.Text in_a_isArrayWithLength;
  input Tpl.Text in_a_stepVar;
  input Tpl.Text in_a_firstIndex;
  input Tpl.Text in_a_stopVar;
  input Tpl.Text in_a_iteratorName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_isArrayWithLength, in_a_stepVar, in_a_firstIndex, in_a_stopVar, in_a_iteratorName)
    local
      Tpl.Text txt;
      Tpl.Text a_stepVar;
      Tpl.Text a_firstIndex;
      Tpl.Text a_stopVar;
      Tpl.Text a_iteratorName;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           _,
           _,
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_stepVar,
           a_firstIndex,
           a_stopVar,
           a_iteratorName )
      equation
        txt = Tpl.writeText(txt, a_iteratorName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_length = (("));
        txt = Tpl.writeText(txt, a_stopVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-"));
        txt = fun_1081(txt, a_firstIndex, a_iteratorName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")/"));
        txt = Tpl.writeText(txt, a_stepVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")+1;"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;
  end match;
end fun_1082;

protected function fun_1083
  input Tpl.Text in_txt;
  input DAE.Exp in_a_iter_exp;
  input Tpl.Text in_a_stepVar;
  input Tpl.Text in_a_rangeExp;
  input Tpl.Text in_a_iteratorName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_iter_exp, in_a_stepVar, in_a_rangeExp, in_a_iteratorName)
    local
      Tpl.Text txt;
      Tpl.Text a_stepVar;
      Tpl.Text a_rangeExp;
      Tpl.Text a_iteratorName;

    case ( txt,
           DAE.RANGE(ty = _),
           a_stepVar,
           a_rangeExp,
           a_iteratorName )
      equation
        txt = Tpl.writeText(txt, a_iteratorName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = ("));
        txt = Tpl.writeText(txt, a_rangeExp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")-"));
        txt = Tpl.writeText(txt, a_stepVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_1083;

protected function fun_1084
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_endLoop;
  input Tpl.Text in_a_guardExp;
  input Tpl.Text in_a_iteratorName;
  input Tpl.Text in_a_loopVar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_endLoop, in_a_guardExp, in_a_iteratorName, in_a_loopVar)
    local
      Tpl.Text txt;
      Tpl.Text a_endLoop;
      Tpl.Text a_guardExp;
      Tpl.Text a_iteratorName;
      Tpl.Text a_loopVar;

    case ( txt,
           false,
           _,
           a_guardExp,
           a_iteratorName,
           a_loopVar )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("while (!listEmpty("));
        txt = Tpl.writeText(txt, a_loopVar);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(")) {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_iteratorName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = MMC_CAR("));
        txt = Tpl.writeText(txt, a_loopVar);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(");\n"));
        txt = Tpl.writeText(txt, a_loopVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = MMC_CDR("));
        txt = Tpl.writeText(txt, a_loopVar);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(");\n"));
        txt = Tpl.writeText(txt, a_guardExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;

    case ( txt,
           _,
           a_endLoop,
           _,
           a_iteratorName,
           a_loopVar )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if (!listEmpty("));
        txt = Tpl.writeText(txt, a_loopVar);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(")) {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_iteratorName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = MMC_CAR("));
        txt = Tpl.writeText(txt, a_loopVar);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(");\n"));
        txt = Tpl.writeText(txt, a_loopVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = MMC_CDR("));
        txt = Tpl.writeText(txt, a_loopVar);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(");\n"));
        txt = Tpl.writeText(txt, a_endLoop);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("--;\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;
  end match;
end fun_1084;

protected function fun_1085
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_endLoop;
  input Tpl.Text in_a_guardExp;
  input Tpl.Text in_a_iteratorName;
  input Tpl.Text in_a_loopVar;
  input Tpl.Text in_a_firstIndex;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_endLoop, in_a_guardExp, in_a_iteratorName, in_a_loopVar, in_a_firstIndex)
    local
      Tpl.Text txt;
      Tpl.Text a_endLoop;
      Tpl.Text a_guardExp;
      Tpl.Text a_iteratorName;
      Tpl.Text a_loopVar;
      Tpl.Text a_firstIndex;

    case ( txt,
           false,
           _,
           a_guardExp,
           a_iteratorName,
           a_loopVar,
           a_firstIndex )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("while ("));
        txt = Tpl.writeText(txt, a_firstIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" <= arrayLength("));
        txt = Tpl.writeText(txt, a_loopVar);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(")) {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_iteratorName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = arrayGet("));
        txt = Tpl.writeText(txt, a_loopVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_firstIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("++);\n"));
        txt = Tpl.writeText(txt, a_guardExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;

    case ( txt,
           _,
           a_endLoop,
           _,
           a_iteratorName,
           a_loopVar,
           a_firstIndex )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if ("));
        txt = Tpl.writeText(txt, a_firstIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" <= arrayLength("));
        txt = Tpl.writeText(txt, a_loopVar);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(")) {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_iteratorName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = arrayGet("));
        txt = Tpl.writeText(txt, a_loopVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_firstIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("++);\n"));
        txt = Tpl.writeText(txt, a_endLoop);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("--;\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;
  end match;
end fun_1085;

protected function fun_1086
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_firstIndex;
  input Tpl.Text in_a_endLoop;
  input Tpl.Text in_a_guardExp;
  input Tpl.Text in_a_iteratorName;
  input Tpl.Text in_a_loopVar;
  input Tpl.Text in_a_guardCond;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_firstIndex, in_a_endLoop, in_a_guardExp, in_a_iteratorName, in_a_loopVar, in_a_guardCond)
    local
      Tpl.Text txt;
      Tpl.Text a_firstIndex;
      Tpl.Text a_endLoop;
      Tpl.Text a_guardExp;
      Tpl.Text a_iteratorName;
      Tpl.Text a_loopVar;
      Tpl.Text a_guardCond;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           false,
           _,
           a_endLoop,
           a_guardExp,
           a_iteratorName,
           a_loopVar,
           a_guardCond )
      equation
        ret_0 = stringEq(Tpl.textString(a_guardCond), "");
        txt = fun_1084(txt, ret_0, a_endLoop, a_guardExp, a_iteratorName, a_loopVar);
      then txt;

    case ( txt,
           _,
           a_firstIndex,
           a_endLoop,
           a_guardExp,
           a_iteratorName,
           a_loopVar,
           a_guardCond )
      equation
        ret_1 = stringEq(Tpl.textString(a_guardCond), "");
        txt = fun_1085(txt, ret_1, a_endLoop, a_guardExp, a_iteratorName, a_loopVar, a_firstIndex);
      then txt;
  end match;
end fun_1086;

protected function fun_1087
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("while"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if"));
      then txt;
  end match;
end fun_1087;

protected function fun_1088
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_endLoop;
  input Tpl.Text in_a_guardExp;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_endLoop, in_a_guardExp)
    local
      Tpl.Text txt;
      Tpl.Text a_endLoop;
      Tpl.Text a_guardExp;

    case ( txt,
           false,
           _,
           a_guardExp )
      equation
        txt = Tpl.writeText(txt, a_guardExp);
      then txt;

    case ( txt,
           _,
           a_endLoop,
           _ )
      equation
        txt = Tpl.writeText(txt, a_endLoop);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("--;"));
      then txt;
  end match;
end fun_1088;

protected function fun_1089
  input Tpl.Text in_txt;
  input DAE.Type in_a_iter_ty;
  input Tpl.Text in_a_arrayType;
  input Tpl.Text in_a_firstIndex;
  input Tpl.Text in_a_loopVar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_iter_ty, in_a_arrayType, in_a_firstIndex, in_a_loopVar)
    local
      Tpl.Text txt;
      Tpl.Text a_arrayType;
      Tpl.Text a_firstIndex;
      Tpl.Text a_loopVar;
      ClassInf.State i_record__state;
      Absyn.Path ret_1;
      Tpl.Text l_rec__name;

    case ( txt,
           DAE.T_ARRAY(ty = DAE.T_COMPLEX(complexClassType = i_record__state)),
           _,
           a_firstIndex,
           a_loopVar )
      equation
        ret_1 = ClassInf.getStateName(i_record__state);
        l_rec__name = CodegenUtil.underscorePath(Tpl.emptyTxt, ret_1);
        txt = Tpl.writeText(txt, l_rec__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_array_get("));
        txt = Tpl.writeText(txt, a_loopVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", 1, "));
        txt = Tpl.writeText(txt, a_firstIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("++)"));
      then txt;

    case ( txt,
           _,
           a_arrayType,
           a_firstIndex,
           a_loopVar )
      equation
        txt = Tpl.writeText(txt, a_arrayType);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_get1("));
        txt = Tpl.writeText(txt, a_loopVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", 1, "));
        txt = Tpl.writeText(txt, a_firstIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("++)"));
      then txt;
  end match;
end fun_1089;

protected function fun_1090
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_endLoop;
  input Tpl.Text in_a_guardExp;
  input Tpl.Text in_a_addr;
  input Tpl.Text in_a_iteratorName;
  input Tpl.Text in_a_loopVar;
  input Tpl.Text in_a_firstIndex;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_endLoop, in_a_guardExp, in_a_addr, in_a_iteratorName, in_a_loopVar, in_a_firstIndex)
    local
      Tpl.Text txt;
      Tpl.Text a_endLoop;
      Tpl.Text a_guardExp;
      Tpl.Text a_addr;
      Tpl.Text a_iteratorName;
      Tpl.Text a_loopVar;
      Tpl.Text a_firstIndex;

    case ( txt,
           false,
           _,
           a_guardExp,
           a_addr,
           a_iteratorName,
           a_loopVar,
           a_firstIndex )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("while("));
        txt = Tpl.writeText(txt, a_firstIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" <= size_of_dimension_base_array("));
        txt = Tpl.writeText(txt, a_loopVar);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(", 1)) {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_iteratorName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, a_addr);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.writeText(txt, a_guardExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;

    case ( txt,
           _,
           a_endLoop,
           _,
           a_addr,
           a_iteratorName,
           a_loopVar,
           a_firstIndex )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if("));
        txt = Tpl.writeText(txt, a_firstIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" <= size_of_dimension_base_array("));
        txt = Tpl.writeText(txt, a_loopVar);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(", 1)) {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_iteratorName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, a_addr);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.writeText(txt, a_endLoop);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("--;\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;
  end match;
end fun_1090;

protected function fun_1091
  input Tpl.Text in_txt;
  input DAE.Exp in_a_iter_exp;
  input Tpl.Text in_a_arrayType;
  input Tpl.Text in_a_firstIndex;
  input Tpl.Text in_a_loopVar;
  input DAE.Type in_a_iter_ty;
  input Tpl.Text in_a_endLoop;
  input Tpl.Text in_a_guardExp;
  input Tpl.Text in_a_stopVar;
  input Tpl.Text in_a_iteratorName;
  input Tpl.Text in_a_stepVar;
  input Tpl.Text in_a_guardCond;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_iter_exp, in_a_arrayType, in_a_firstIndex, in_a_loopVar, in_a_iter_ty, in_a_endLoop, in_a_guardExp, in_a_stopVar, in_a_iteratorName, in_a_stepVar, in_a_guardCond)
    local
      Tpl.Text txt;
      Tpl.Text a_arrayType;
      Tpl.Text a_firstIndex;
      Tpl.Text a_loopVar;
      DAE.Type a_iter_ty;
      Tpl.Text a_endLoop;
      Tpl.Text a_guardExp;
      Tpl.Text a_stopVar;
      Tpl.Text a_iteratorName;
      Tpl.Text a_stepVar;
      Tpl.Text a_guardCond;
      Boolean ret_3;
      Tpl.Text l_addr;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           DAE.RANGE(ty = _),
           _,
           _,
           _,
           _,
           a_endLoop,
           a_guardExp,
           a_stopVar,
           a_iteratorName,
           a_stepVar,
           a_guardCond )
      equation
        ret_0 = stringEq(Tpl.textString(a_guardCond), "");
        txt = fun_1087(txt, ret_0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" ("));
        txt = Tpl.writeText(txt, a_stepVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" > 0 ? "));
        txt = Tpl.writeText(txt, a_iteratorName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("+"));
        txt = Tpl.writeText(txt, a_stepVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" <= "));
        txt = Tpl.writeText(txt, a_stopVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" : "));
        txt = Tpl.writeText(txt, a_iteratorName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("+"));
        txt = Tpl.writeText(txt, a_stepVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" >= "));
        txt = Tpl.writeText(txt, a_stopVar);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(") {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_iteratorName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" += "));
        txt = Tpl.writeText(txt, a_stepVar);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        ret_1 = stringEq(Tpl.textString(a_guardCond), "");
        txt = fun_1088(txt, ret_1, a_endLoop, a_guardExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;

    case ( txt,
           _,
           a_arrayType,
           a_firstIndex,
           a_loopVar,
           a_iter_ty,
           a_endLoop,
           a_guardExp,
           _,
           a_iteratorName,
           _,
           a_guardCond )
      equation
        l_addr = fun_1089(Tpl.emptyTxt, a_iter_ty, a_arrayType, a_firstIndex, a_loopVar);
        ret_3 = stringEq(Tpl.textString(a_guardCond), "");
        txt = fun_1090(txt, ret_3, a_endLoop, a_guardExp, l_addr, a_iteratorName, a_loopVar, a_firstIndex);
      then txt;
  end match;
end fun_1091;

protected function fun_1092
  input Tpl.Text in_txt;
  input String in_mArg;
  input Tpl.Text in_a_arrayType;
  input DAE.Type in_a_iter_ty;
  input Tpl.Text in_a_stopVar;
  input Tpl.Text in_a_stepVar;
  input Tpl.Text in_a_firstIndex;
  input Tpl.Text in_a_endLoop;
  input Tpl.Text in_a_guardExp;
  input Tpl.Text in_a_iteratorName;
  input Tpl.Text in_a_loopVar;
  input Tpl.Text in_a_guardCond;
  input DAE.Exp in_a_iter_exp;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_arrayType, in_a_iter_ty, in_a_stopVar, in_a_stepVar, in_a_firstIndex, in_a_endLoop, in_a_guardExp, in_a_iteratorName, in_a_loopVar, in_a_guardCond, in_a_iter_exp)
    local
      Tpl.Text txt;
      Tpl.Text a_arrayType;
      DAE.Type a_iter_ty;
      Tpl.Text a_stopVar;
      Tpl.Text a_stepVar;
      Tpl.Text a_firstIndex;
      Tpl.Text a_endLoop;
      Tpl.Text a_guardExp;
      Tpl.Text a_iteratorName;
      Tpl.Text a_loopVar;
      Tpl.Text a_guardCond;
      DAE.Exp a_iter_exp;
      Boolean ret_0;

    case ( txt,
           "modelica_metatype",
           _,
           _,
           _,
           _,
           a_firstIndex,
           a_endLoop,
           a_guardExp,
           a_iteratorName,
           a_loopVar,
           a_guardCond,
           a_iter_exp )
      equation
        ret_0 = Expression.isMetaArray(a_iter_exp);
        txt = fun_1086(txt, ret_0, a_firstIndex, a_endLoop, a_guardExp, a_iteratorName, a_loopVar, a_guardCond);
      then txt;

    case ( txt,
           _,
           a_arrayType,
           a_iter_ty,
           a_stopVar,
           a_stepVar,
           a_firstIndex,
           a_endLoop,
           a_guardExp,
           a_iteratorName,
           a_loopVar,
           a_guardCond,
           a_iter_exp )
      equation
        txt = fun_1091(txt, a_iter_exp, a_arrayType, a_firstIndex, a_loopVar, a_iter_ty, a_endLoop, a_guardExp, a_stopVar, a_iteratorName, a_stepVar, a_guardCond);
      then txt;
  end match;
end fun_1092;

protected function lm_1093
  input Tpl.Text in_txt;
  input DAE.ReductionIterators in_items;
  input Tpl.Text in_a_endLoop;
  input Absyn.Path in_a_ri_path;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_rangeExpPre;
  input Tpl.Text in_a_tmpVarDecls;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_rangeExpPre;
  output Tpl.Text out_a_tmpVarDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_rangeExpPre, out_a_tmpVarDecls) :=
  match(in_txt, in_items, in_a_endLoop, in_a_ri_path, in_a_auxFunction, in_a_rangeExpPre, in_a_tmpVarDecls, in_a_context)
    local
      Tpl.Text txt;
      DAE.ReductionIterators rest;
      Tpl.Text a_endLoop;
      Absyn.Path a_ri_path;
      Tpl.Text a_auxFunction;
      Tpl.Text a_rangeExpPre;
      Tpl.Text a_tmpVarDecls;
      SimCodeFunction.Context a_context;
      DAE.Type i_iter_ty;
      Option<DAE.Exp> i_iter_guardExp;
      String i_iter_id;
      DAE.Exp i_iter_exp;
      String str_15;
      Tpl.Text l_guardExp;
      Tpl.Text l_guardCond;
      Tpl.Text l_isArrayWithLength;
      Tpl.Text l_rangeExp;
      Tpl.Text l_rangeExpStop;
      Tpl.Text l_rangeExpStep;
      Tpl.Text l_firstIndex;
      String str_7;
      Tpl.Text l_guardExpPre;
      Tpl.Text l_stopVar;
      Tpl.Text l_stepVar;
      Tpl.Text l_loopVar;
      Tpl.Text l_iteratorName;
      Tpl.Text l_arrayType;
      Tpl.Text l_identType;

    case ( txt,
           {},
           _,
           _,
           a_auxFunction,
           a_rangeExpPre,
           a_tmpVarDecls,
           _ )
      then (txt, a_auxFunction, a_rangeExpPre, a_tmpVarDecls);

    case ( txt,
           DAE.REDUCTIONITER(exp = i_iter_exp, id = i_iter_id, guardExp = i_iter_guardExp, ty = i_iter_ty) :: rest,
           a_endLoop,
           a_ri_path,
           a_auxFunction,
           a_rangeExpPre,
           a_tmpVarDecls,
           a_context )
      equation
        l_identType = expTypeFromExpModelica(Tpl.emptyTxt, i_iter_exp);
        l_arrayType = expTypeFromExpArray(Tpl.emptyTxt, i_iter_exp);
        l_iteratorName = contextIteratorName(Tpl.emptyTxt, i_iter_id, a_context);
        l_loopVar = fun_1060(Tpl.emptyTxt, i_iter_exp, l_iteratorName);
        (l_stepVar, a_tmpVarDecls) = fun_1061(Tpl.emptyTxt, i_iter_exp, a_tmpVarDecls, l_identType);
        (l_stopVar, a_tmpVarDecls) = fun_1062(Tpl.emptyTxt, i_iter_exp, a_tmpVarDecls, l_identType);
        l_guardExpPre = Tpl.emptyTxt;
        str_7 = Tpl.textString(l_identType);
        a_tmpVarDecls = fun_1064(a_tmpVarDecls, str_7, l_arrayType, i_iter_exp, l_loopVar);
        (l_firstIndex, a_tmpVarDecls) = fun_1067(Tpl.emptyTxt, i_iter_exp, a_tmpVarDecls, l_identType);
        (l_rangeExpStep, a_auxFunction, a_tmpVarDecls, a_rangeExpPre) = fun_1068(Tpl.emptyTxt, i_iter_exp, a_auxFunction, a_tmpVarDecls, a_rangeExpPre, a_context);
        (l_rangeExpStop, a_auxFunction, a_tmpVarDecls, a_rangeExpPre) = fun_1069(Tpl.emptyTxt, i_iter_exp, a_auxFunction, a_tmpVarDecls, a_rangeExpPre, a_context);
        (l_rangeExp, a_auxFunction, a_tmpVarDecls, a_rangeExpPre) = fun_1070(Tpl.emptyTxt, i_iter_exp, a_auxFunction, a_tmpVarDecls, a_rangeExpPre, a_context);
        a_rangeExpPre = fun_1071(a_rangeExpPre, l_rangeExpStep, l_stepVar);
        a_rangeExpPre = fun_1072(a_rangeExpPre, l_rangeExpStop, l_stopVar);
        a_rangeExpPre = Tpl.writeText(a_rangeExpPre, l_loopVar);
        a_rangeExpPre = Tpl.writeTok(a_rangeExpPre, Tpl.ST_STRING(" = "));
        a_rangeExpPre = Tpl.writeText(a_rangeExpPre, l_rangeExp);
        a_rangeExpPre = Tpl.writeTok(a_rangeExpPre, Tpl.ST_STRING(";"));
        a_rangeExpPre = Tpl.writeTok(a_rangeExpPre, Tpl.ST_NEW_LINE());
        a_rangeExpPre = fun_1074(a_rangeExpPre, l_rangeExpStop, i_iter_exp, l_stepVar);
        l_isArrayWithLength = fun_1076(Tpl.emptyTxt, l_rangeExpStop, a_ri_path);
        a_tmpVarDecls = fun_1077(a_tmpVarDecls, l_isArrayWithLength, l_iteratorName);
        a_rangeExpPre = fun_1079(a_rangeExpPre, i_iter_exp, l_firstIndex);
        (l_guardCond, a_auxFunction, a_tmpVarDecls, l_guardExpPre) = fun_1080(Tpl.emptyTxt, i_iter_guardExp, a_auxFunction, a_tmpVarDecls, l_guardExpPre, a_context);
        a_tmpVarDecls = Tpl.writeText(a_tmpVarDecls, l_identType);
        a_tmpVarDecls = Tpl.writeTok(a_tmpVarDecls, Tpl.ST_STRING(" "));
        a_tmpVarDecls = Tpl.writeText(a_tmpVarDecls, l_iteratorName);
        a_tmpVarDecls = Tpl.writeTok(a_tmpVarDecls, Tpl.ST_STRING(";"));
        a_tmpVarDecls = Tpl.writeTok(a_tmpVarDecls, Tpl.ST_NEW_LINE());
        a_rangeExpPre = fun_1082(a_rangeExpPre, l_isArrayWithLength, l_stepVar, l_firstIndex, l_stopVar, l_iteratorName);
        a_rangeExpPre = fun_1083(a_rangeExpPre, i_iter_exp, l_stepVar, l_rangeExp, l_iteratorName);
        l_guardExp = Tpl.writeText(Tpl.emptyTxt, l_guardExpPre);
        l_guardExp = Tpl.softNewLine(l_guardExp);
        l_guardExp = Tpl.writeTok(l_guardExp, Tpl.ST_STRING("if ("));
        l_guardExp = Tpl.writeText(l_guardExp, l_guardCond);
        l_guardExp = Tpl.writeTok(l_guardExp, Tpl.ST_LINE(") {\n"));
        l_guardExp = Tpl.pushBlock(l_guardExp, Tpl.BT_INDENT(2));
        l_guardExp = Tpl.writeText(l_guardExp, a_endLoop);
        l_guardExp = Tpl.writeTok(l_guardExp, Tpl.ST_STRING_LIST({
                                                  "--;\n",
                                                  "break;\n"
                                              }, true));
        l_guardExp = Tpl.popBlock(l_guardExp);
        l_guardExp = Tpl.writeTok(l_guardExp, Tpl.ST_STRING("}"));
        str_15 = Tpl.textString(l_identType);
        txt = fun_1092(txt, str_15, l_arrayType, i_iter_ty, l_stopVar, l_stepVar, l_firstIndex, a_endLoop, l_guardExp, l_iteratorName, l_loopVar, l_guardCond, i_iter_exp);
        (txt, a_auxFunction, a_rangeExpPre, a_tmpVarDecls) = lm_1093(txt, rest, a_endLoop, a_ri_path, a_auxFunction, a_rangeExpPre, a_tmpVarDecls, a_context);
      then (txt, a_auxFunction, a_rangeExpPre, a_tmpVarDecls);

    case ( txt,
           _ :: rest,
           a_endLoop,
           a_ri_path,
           a_auxFunction,
           a_rangeExpPre,
           a_tmpVarDecls,
           a_context )
      equation
        (txt, a_auxFunction, a_rangeExpPre, a_tmpVarDecls) = lm_1093(txt, rest, a_endLoop, a_ri_path, a_auxFunction, a_rangeExpPre, a_tmpVarDecls, a_context);
      then (txt, a_auxFunction, a_rangeExpPre, a_tmpVarDecls);
  end match;
end lm_1093;

protected function fun_1094
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_loopVar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_loopVar)
    local
      Tpl.Text txt;
      Tpl.Text a_loopVar;

    case ( txt,
           false,
           a_loopVar )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("listLength("));
        txt = Tpl.writeText(txt, a_loopVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           _,
           a_loopVar )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("arrayLength("));
        txt = Tpl.writeText(txt, a_loopVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;
  end match;
end fun_1094;

protected function fun_1095
  input Tpl.Text in_txt;
  input DAE.Exp in_a_iter_exp;
  input Tpl.Text in_a_loopVar;
  input Tpl.Text in_a_iteratorName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_iter_exp, in_a_loopVar, in_a_iteratorName)
    local
      Tpl.Text txt;
      Tpl.Text a_loopVar;
      Tpl.Text a_iteratorName;

    case ( txt,
           DAE.RANGE(ty = _),
           _,
           a_iteratorName )
      equation
        txt = Tpl.writeText(txt, a_iteratorName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_length"));
      then txt;

    case ( txt,
           _,
           a_loopVar,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("size_of_dimension_base_array("));
        txt = Tpl.writeText(txt, a_loopVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", 1)"));
      then txt;
  end match;
end fun_1095;

protected function fun_1096
  input Tpl.Text in_txt;
  input String in_mArg;
  input Tpl.Text in_a_iteratorName;
  input Tpl.Text in_a_loopVar;
  input DAE.Exp in_a_iter_exp;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_iteratorName, in_a_loopVar, in_a_iter_exp)
    local
      Tpl.Text txt;
      Tpl.Text a_iteratorName;
      Tpl.Text a_loopVar;
      DAE.Exp a_iter_exp;
      Boolean ret_0;

    case ( txt,
           "modelica_metatype",
           _,
           a_loopVar,
           a_iter_exp )
      equation
        ret_0 = Expression.isMetaArray(a_iter_exp);
        txt = fun_1094(txt, ret_0, a_loopVar);
      then txt;

    case ( txt,
           _,
           a_iteratorName,
           a_loopVar,
           a_iter_exp )
      equation
        txt = fun_1095(txt, a_iter_exp, a_loopVar, a_iteratorName);
      then txt;
  end match;
end fun_1096;

protected function lm_1097
  input Tpl.Text in_txt;
  input DAE.ReductionIterators in_items;
  input Tpl.Text in_a_length;
  input Tpl.Text in_a_rangeExpPre;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_rangeExpPre;
algorithm
  (out_txt, out_a_rangeExpPre) :=
  match(in_txt, in_items, in_a_length, in_a_rangeExpPre, in_a_context)
    local
      Tpl.Text txt;
      DAE.ReductionIterators rest;
      Tpl.Text a_length;
      Tpl.Text a_rangeExpPre;
      SimCodeFunction.Context a_context;
      DAE.Exp i_iter_exp;
      String i_iter_id;
      String str_3;
      Tpl.Text l_identType;
      Tpl.Text l_loopVar;
      Tpl.Text l_iteratorName;

    case ( txt,
           {},
           _,
           a_rangeExpPre,
           _ )
      then (txt, a_rangeExpPre);

    case ( txt,
           DAE.REDUCTIONITER(id = i_iter_id, exp = i_iter_exp) :: rest,
           a_length,
           a_rangeExpPre,
           a_context )
      equation
        l_iteratorName = contextIteratorName(Tpl.emptyTxt, i_iter_id, a_context);
        l_loopVar = Tpl.writeText(Tpl.emptyTxt, l_iteratorName);
        l_loopVar = Tpl.writeTok(l_loopVar, Tpl.ST_STRING("_loopVar"));
        l_identType = expTypeFromExpModelica(Tpl.emptyTxt, i_iter_exp);
        a_rangeExpPre = Tpl.writeText(a_rangeExpPre, a_length);
        a_rangeExpPre = Tpl.writeTok(a_rangeExpPre, Tpl.ST_STRING(" = modelica_integer_max("));
        a_rangeExpPre = Tpl.writeText(a_rangeExpPre, a_length);
        a_rangeExpPre = Tpl.writeTok(a_rangeExpPre, Tpl.ST_STRING(","));
        str_3 = Tpl.textString(l_identType);
        a_rangeExpPre = fun_1096(a_rangeExpPre, str_3, l_iteratorName, l_loopVar, i_iter_exp);
        a_rangeExpPre = Tpl.writeTok(a_rangeExpPre, Tpl.ST_STRING(");"));
        a_rangeExpPre = Tpl.writeTok(a_rangeExpPre, Tpl.ST_NEW_LINE());
        (txt, a_rangeExpPre) = lm_1097(txt, rest, a_length, a_rangeExpPre, a_context);
      then (txt, a_rangeExpPre);

    case ( txt,
           _ :: rest,
           a_length,
           a_rangeExpPre,
           a_context )
      equation
        (txt, a_rangeExpPre) = lm_1097(txt, rest, a_length, a_rangeExpPre, a_context);
      then (txt, a_rangeExpPre);
  end match;
end lm_1097;

protected function fun_1098
  input Tpl.Text in_txt;
  input DAE.Dimension in_a_dim;
  input DAE.Exp in_a_r_expr;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_tmpVarDecls;
  input Tpl.Text in_a_rangeExpPre;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_tmpVarDecls;
  output Tpl.Text out_a_rangeExpPre;
algorithm
  (out_txt, out_a_auxFunction, out_a_tmpVarDecls, out_a_rangeExpPre) :=
  match(in_txt, in_a_dim, in_a_r_expr, in_a_auxFunction, in_a_tmpVarDecls, in_a_rangeExpPre, in_a_context)
    local
      Tpl.Text txt;
      DAE.Exp a_r_expr;
      Tpl.Text a_auxFunction;
      Tpl.Text a_tmpVarDecls;
      Tpl.Text a_rangeExpPre;
      SimCodeFunction.Context a_context;
      DAE.Exp i_e;
      Integer i_size;
      Integer i_integer;
      Tpl.Text txt_0;
      String ret_1;
      DAE.Type ret_0;

    case ( txt,
           DAE.DIM_INTEGER(integer = i_integer),
           _,
           a_auxFunction,
           a_tmpVarDecls,
           a_rangeExpPre,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", (_index_t)"));
        txt = Tpl.writeStr(txt, intString(i_integer));
      then (txt, a_auxFunction, a_tmpVarDecls, a_rangeExpPre);

    case ( txt,
           DAE.DIM_BOOLEAN(),
           _,
           a_auxFunction,
           a_tmpVarDecls,
           a_rangeExpPre,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", (_index_t)2"));
      then (txt, a_auxFunction, a_tmpVarDecls, a_rangeExpPre);

    case ( txt,
           DAE.DIM_ENUM(size = i_size),
           _,
           a_auxFunction,
           a_tmpVarDecls,
           a_rangeExpPre,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", (_index_t)"));
        txt = Tpl.writeStr(txt, intString(i_size));
      then (txt, a_auxFunction, a_tmpVarDecls, a_rangeExpPre);

    case ( txt,
           DAE.DIM_EXP(exp = i_e),
           _,
           a_auxFunction,
           a_tmpVarDecls,
           a_rangeExpPre,
           a_context )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", (_index_t)"));
        (txt, a_rangeExpPre, a_tmpVarDecls, a_auxFunction) = daeExp(txt, i_e, a_context, a_rangeExpPre, a_tmpVarDecls, a_auxFunction);
      then (txt, a_auxFunction, a_tmpVarDecls, a_rangeExpPre);

    case ( txt,
           _,
           a_r_expr,
           a_auxFunction,
           a_tmpVarDecls,
           a_rangeExpPre,
           _ )
      equation
        txt_0 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("array reduction unable to generate code for element of unknown dimension sizes; type "));
        ret_0 = Expression.typeof(a_r_expr);
        ret_1 = Types.unparseType(ret_0);
        txt_0 = Tpl.writeStr(txt_0, ret_1);
        txt_0 = Tpl.writeTok(txt_0, Tpl.ST_STRING(": "));
        txt_0 = ExpressionDumpTpl.dumpExp(txt_0, a_r_expr, "\"");
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 7218, 24), Tpl.textString(txt_0));
      then (txt, a_auxFunction, a_tmpVarDecls, a_rangeExpPre);
  end match;
end fun_1098;

protected function lm_1099
  input Tpl.Text in_txt;
  input DAE.Dimensions in_items;
  input DAE.Exp in_a_r_expr;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_tmpVarDecls;
  input Tpl.Text in_a_rangeExpPre;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_tmpVarDecls;
  output Tpl.Text out_a_rangeExpPre;
algorithm
  (out_txt, out_a_auxFunction, out_a_tmpVarDecls, out_a_rangeExpPre) :=
  match(in_txt, in_items, in_a_r_expr, in_a_auxFunction, in_a_tmpVarDecls, in_a_rangeExpPre, in_a_context)
    local
      Tpl.Text txt;
      DAE.Dimensions rest;
      DAE.Exp a_r_expr;
      Tpl.Text a_auxFunction;
      Tpl.Text a_tmpVarDecls;
      Tpl.Text a_rangeExpPre;
      SimCodeFunction.Context a_context;
      DAE.Dimension i_dim;

    case ( txt,
           {},
           _,
           a_auxFunction,
           a_tmpVarDecls,
           a_rangeExpPre,
           _ )
      then (txt, a_auxFunction, a_tmpVarDecls, a_rangeExpPre);

    case ( txt,
           i_dim :: rest,
           a_r_expr,
           a_auxFunction,
           a_tmpVarDecls,
           a_rangeExpPre,
           a_context )
      equation
        (txt, a_auxFunction, a_tmpVarDecls, a_rangeExpPre) = fun_1098(txt, i_dim, a_r_expr, a_auxFunction, a_tmpVarDecls, a_rangeExpPre, a_context);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_tmpVarDecls, a_rangeExpPre) = lm_1099(txt, rest, a_r_expr, a_auxFunction, a_tmpVarDecls, a_rangeExpPre, a_context);
      then (txt, a_auxFunction, a_tmpVarDecls, a_rangeExpPre);
  end match;
end lm_1099;

protected function fun_1100
  input Tpl.Text in_txt;
  input DAE.Type in_mArg;
  input Tpl.Text in_a_arrayTypeResult;
  input DAE.Exp in_a_r_expr;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_tmpVarDecls;
  input Tpl.Text in_a_rangeExpPre;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_length;
  input Tpl.Text in_a_res;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_tmpVarDecls;
  output Tpl.Text out_a_rangeExpPre;
algorithm
  (out_txt, out_a_auxFunction, out_a_tmpVarDecls, out_a_rangeExpPre) :=
  match(in_txt, in_mArg, in_a_arrayTypeResult, in_a_r_expr, in_a_auxFunction, in_a_tmpVarDecls, in_a_rangeExpPre, in_a_context, in_a_length, in_a_res)
    local
      Tpl.Text txt;
      Tpl.Text a_arrayTypeResult;
      DAE.Exp a_r_expr;
      Tpl.Text a_auxFunction;
      Tpl.Text a_tmpVarDecls;
      Tpl.Text a_rangeExpPre;
      SimCodeFunction.Context a_context;
      Tpl.Text a_length;
      Tpl.Text a_res;
      DAE.Dimensions i_dims;
      ClassInf.State i_record__state;
      Integer ret_4;
      Integer ret_3;
      Tpl.Text l_dimSizes;
      Absyn.Path ret_1;
      Tpl.Text l_rec__name;

    case ( txt,
           DAE.T_COMPLEX(complexClassType = i_record__state),
           _,
           _,
           a_auxFunction,
           a_tmpVarDecls,
           a_rangeExpPre,
           _,
           a_length,
           a_res )
      equation
        ret_1 = ClassInf.getStateName(i_record__state);
        l_rec__name = CodegenUtil.underscorePath(Tpl.emptyTxt, ret_1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("alloc_generic_array(&"));
        txt = Tpl.writeText(txt, a_res);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", sizeof("));
        txt = Tpl.writeText(txt, l_rec__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("), 1, (_index_t)"));
        txt = Tpl.writeText(txt, a_length);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then (txt, a_auxFunction, a_tmpVarDecls, a_rangeExpPre);

    case ( txt,
           DAE.T_ARRAY(dims = i_dims),
           a_arrayTypeResult,
           a_r_expr,
           a_auxFunction,
           a_tmpVarDecls,
           a_rangeExpPre,
           a_context,
           a_length,
           a_res )
      equation
        l_dimSizes = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_dimSizes, a_auxFunction, a_tmpVarDecls, a_rangeExpPre) = lm_1099(l_dimSizes, i_dims, a_r_expr, a_auxFunction, a_tmpVarDecls, a_rangeExpPre, a_context);
        l_dimSizes = Tpl.popIter(l_dimSizes);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("alloc_"));
        txt = Tpl.writeText(txt, a_arrayTypeResult);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(&"));
        txt = Tpl.writeText(txt, a_res);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        ret_3 = listLength(i_dims);
        ret_4 = intAdd(1, ret_3);
        txt = Tpl.writeStr(txt, intString(ret_4));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_length);
        txt = Tpl.writeText(txt, l_dimSizes);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then (txt, a_auxFunction, a_tmpVarDecls, a_rangeExpPre);

    case ( txt,
           _,
           a_arrayTypeResult,
           _,
           a_auxFunction,
           a_tmpVarDecls,
           a_rangeExpPre,
           _,
           a_length,
           a_res )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("simple_alloc_1d_"));
        txt = Tpl.writeText(txt, a_arrayTypeResult);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(&"));
        txt = Tpl.writeText(txt, a_res);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, a_length);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then (txt, a_auxFunction, a_tmpVarDecls, a_rangeExpPre);
  end match;
end fun_1100;

protected function fun_1101
  input Tpl.Text in_txt;
  input Tpl.Text in_a_foundFirst;
  input Absyn.Path in_a_ri_path;
  input Tpl.Text in_a_defaultValue;
  input Tpl.Text in_a_res;
  input Tpl.Text in_a_preDefault;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_foundFirst, in_a_ri_path, in_a_defaultValue, in_a_res, in_a_preDefault)
    local
      Tpl.Text txt;
      Absyn.Path a_ri_path;
      Tpl.Text a_defaultValue;
      Tpl.Text a_res;
      Tpl.Text a_preDefault;
      Tpl.Text i_foundFirst;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           _,
           a_defaultValue,
           a_res,
           a_preDefault )
      equation
        txt = Tpl.writeText(txt, a_preDefault);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, a_res);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, a_defaultValue);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("; /* defaultValue */"));
      then txt;

    case ( txt,
           i_foundFirst,
           a_ri_path,
           _,
           _,
           _ )
      equation
        txt = Tpl.writeText(txt, i_foundFirst);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = 0; /* "));
        txt = CodegenUtil.dotPath(txt, a_ri_path);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" lacks default-value */"));
      then txt;
  end match;
end fun_1101;

protected function fun_1102
  input Tpl.Text in_txt;
  input Absyn.Path in_a_ri_path;
  input Tpl.Text in_a_defaultValue;
  input Tpl.Text in_a_preDefault;
  input Tpl.Text in_a_foundFirst;
  input Tpl.Text in_a_arrayTypeResult;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_res;
  input DAE.Exp in_a_r_expr;
  input Tpl.Text in_a_arrIndex;
  input SimCodeFunction.Context in_a_context;
  input DAE.ReductionIterators in_a_iterators;
  input Tpl.Text in_a_rangeExpPre;
  input Tpl.Text in_a_tmpVarDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_rangeExpPre;
  output Tpl.Text out_a_tmpVarDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_rangeExpPre, out_a_tmpVarDecls) :=
  match(in_txt, in_a_ri_path, in_a_defaultValue, in_a_preDefault, in_a_foundFirst, in_a_arrayTypeResult, in_a_auxFunction, in_a_res, in_a_r_expr, in_a_arrIndex, in_a_context, in_a_iterators, in_a_rangeExpPre, in_a_tmpVarDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_defaultValue;
      Tpl.Text a_preDefault;
      Tpl.Text a_foundFirst;
      Tpl.Text a_arrayTypeResult;
      Tpl.Text a_auxFunction;
      Tpl.Text a_res;
      DAE.Exp a_r_expr;
      Tpl.Text a_arrIndex;
      SimCodeFunction.Context a_context;
      DAE.ReductionIterators a_iterators;
      Tpl.Text a_rangeExpPre;
      Tpl.Text a_tmpVarDecls;
      Absyn.Path i_ri_path;
      DAE.Type ret_2;
      Tpl.Text l_0__;
      Tpl.Text l_length;

    case ( txt,
           Absyn.IDENT(name = "array"),
           _,
           _,
           _,
           a_arrayTypeResult,
           a_auxFunction,
           a_res,
           a_r_expr,
           a_arrIndex,
           a_context,
           a_iterators,
           a_rangeExpPre,
           a_tmpVarDecls )
      equation
        (l_length, a_tmpVarDecls) = tempDecl(Tpl.emptyTxt, "modelica_integer", a_tmpVarDecls);
        a_rangeExpPre = Tpl.writeText(a_rangeExpPre, l_length);
        a_rangeExpPre = Tpl.writeTok(a_rangeExpPre, Tpl.ST_STRING(" = 0;"));
        a_rangeExpPre = Tpl.writeTok(a_rangeExpPre, Tpl.ST_NEW_LINE());
        (l_0__, a_rangeExpPre) = lm_1097(Tpl.emptyTxt, a_iterators, l_length, a_rangeExpPre, a_context);
        txt = Tpl.writeText(txt, a_arrIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" = 1;\n"));
        ret_2 = Expression.typeof(a_r_expr);
        (txt, a_auxFunction, a_tmpVarDecls, a_rangeExpPre) = fun_1100(txt, ret_2, a_arrayTypeResult, a_r_expr, a_auxFunction, a_tmpVarDecls, a_rangeExpPre, a_context, l_length, a_res);
      then (txt, a_auxFunction, a_rangeExpPre, a_tmpVarDecls);

    case ( txt,
           i_ri_path,
           a_defaultValue,
           a_preDefault,
           a_foundFirst,
           _,
           a_auxFunction,
           a_res,
           _,
           _,
           _,
           _,
           a_rangeExpPre,
           a_tmpVarDecls )
      equation
        txt = fun_1101(txt, a_foundFirst, i_ri_path, a_defaultValue, a_res, a_preDefault);
      then (txt, a_auxFunction, a_rangeExpPre, a_tmpVarDecls);
  end match;
end fun_1102;

protected function fun_1103
  input Tpl.Text in_txt;
  input DAE.ReductionIterators in_a_iterators;
  input Tpl.Text in_a_endLoop;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_iterators, in_a_endLoop)
    local
      Tpl.Text txt;
      Tpl.Text a_endLoop;
      DAE.ReductionIterators i_iterators;
      Integer ret_0;

    case ( txt,
           (i_iterators as _ :: _),
           a_endLoop )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("else if ("));
        txt = Tpl.writeText(txt, a_endLoop);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" == "));
        ret_0 = listLength(i_iterators);
        txt = Tpl.writeStr(txt, intString(ret_0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ") {\n",
                                    "  break;\n",
                                    "} else {\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = generateThrow(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_1103;

protected function fun_1104
  input Tpl.Text in_txt;
  input Tpl.Text in_a_resTail;
  input Tpl.Text in_a_res;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_resTail, in_a_res)
    local
      Tpl.Text txt;
      Tpl.Text a_res;
      Tpl.Text i_resTail;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           _ )
      then txt;

    case ( txt,
           i_resTail,
           a_res )
      equation
        txt = Tpl.writeText(txt, i_resTail);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = &"));
        txt = Tpl.writeText(txt, a_res);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_1104;

protected function fun_1105
  input Tpl.Text in_txt;
  input Tpl.Text in_a_foundFirst;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_foundFirst)
    local
      Tpl.Text txt;
      Tpl.Text i_foundFirst;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}) )
      then txt;

    case ( txt,
           i_foundFirst )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if (!"));
        txt = Tpl.writeText(txt, i_foundFirst);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") "));
        txt = generateThrow(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_1105;

protected function fun_1106
  input Tpl.Text in_txt;
  input Tpl.Text in_a_resTail;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_resTail)
    local
      Tpl.Text txt;
      Tpl.Text i_resTail;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}) )
      then txt;

    case ( txt,
           i_resTail )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("*"));
        txt = Tpl.writeText(txt, i_resTail);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = mmc_mk_nil();"));
      then txt;
  end match;
end fun_1106;

protected function fun_1107
  input Tpl.Text in_txt;
  input Absyn.Path in_a_ri_path;
  input Tpl.Text in_a_tmpVarDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_tmpVarDecls;
algorithm
  (out_txt, out_a_tmpVarDecls) :=
  match(in_txt, in_a_ri_path, in_a_tmpVarDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_tmpVarDecls;

    case ( txt,
           Absyn.IDENT(name = "array"),
           a_tmpVarDecls )
      equation
        (txt, a_tmpVarDecls) = tempDecl(txt, "modelica_integer", a_tmpVarDecls);
      then (txt, a_tmpVarDecls);

    case ( txt,
           _,
           a_tmpVarDecls )
      then (txt, a_tmpVarDecls);
  end match;
end fun_1107;

protected function fun_1108
  input Tpl.Text in_txt;
  input Option<Values.Value> in_a_ri_defaultValue;
  input Tpl.Text in_a_tmpVarDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_tmpVarDecls;
algorithm
  (out_txt, out_a_tmpVarDecls) :=
  match(in_txt, in_a_ri_defaultValue, in_a_tmpVarDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_tmpVarDecls;

    case ( txt,
           NONE(),
           a_tmpVarDecls )
      equation
        (txt, a_tmpVarDecls) = tempDecl(txt, "modelica_integer", a_tmpVarDecls);
      then (txt, a_tmpVarDecls);

    case ( txt,
           _,
           a_tmpVarDecls )
      then (txt, a_tmpVarDecls);
  end match;
end fun_1108;

protected function fun_1109
  input Tpl.Text in_txt;
  input Absyn.Path in_a_ri_path;
  input Tpl.Text in_a_tmpVarDecls;
  input Option<Values.Value> in_a_ri_defaultValue;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_tmpVarDecls;
algorithm
  (out_txt, out_a_tmpVarDecls) :=
  match(in_txt, in_a_ri_path, in_a_tmpVarDecls, in_a_ri_defaultValue)
    local
      Tpl.Text txt;
      Tpl.Text a_tmpVarDecls;
      Option<Values.Value> a_ri_defaultValue;

    case ( txt,
           Absyn.IDENT(name = "array"),
           a_tmpVarDecls,
           _ )
      then (txt, a_tmpVarDecls);

    case ( txt,
           _,
           a_tmpVarDecls,
           a_ri_defaultValue )
      equation
        (txt, a_tmpVarDecls) = fun_1108(txt, a_ri_defaultValue, a_tmpVarDecls);
      then (txt, a_tmpVarDecls);
  end match;
end fun_1109;

protected function fun_1110
  input Tpl.Text in_txt;
  input Absyn.Path in_a_ri_path;
  input Tpl.Text in_a_tmpVarDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_tmpVarDecls;
algorithm
  (out_txt, out_a_tmpVarDecls) :=
  match(in_txt, in_a_ri_path, in_a_tmpVarDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_tmpVarDecls;

    case ( txt,
           Absyn.IDENT(name = "list"),
           a_tmpVarDecls )
      equation
        (txt, a_tmpVarDecls) = tempDecl(txt, "modelica_metatype*", a_tmpVarDecls);
      then (txt, a_tmpVarDecls);

    case ( txt,
           _,
           a_tmpVarDecls )
      then (txt, a_tmpVarDecls);
  end match;
end fun_1110;

protected function fun_1111
  input Tpl.Text in_txt;
  input Option<Values.Value> in_a_ri_defaultValue;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_tmpVarDecls;
  input Tpl.Text in_a_preDefault;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_tmpVarDecls;
  output Tpl.Text out_a_preDefault;
algorithm
  (out_txt, out_a_auxFunction, out_a_tmpVarDecls, out_a_preDefault) :=
  match(in_txt, in_a_ri_defaultValue, in_a_auxFunction, in_a_tmpVarDecls, in_a_preDefault, in_a_context)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_tmpVarDecls;
      Tpl.Text a_preDefault;
      SimCodeFunction.Context a_context;
      Values.Value i_v;
      DAE.Exp ret_0;

    case ( txt,
           SOME(i_v),
           a_auxFunction,
           a_tmpVarDecls,
           a_preDefault,
           a_context )
      equation
        ret_0 = ValuesUtil.valueExp(i_v);
        (txt, a_preDefault, a_tmpVarDecls, a_auxFunction) = daeExp(txt, ret_0, a_context, a_preDefault, a_tmpVarDecls, a_auxFunction);
      then (txt, a_auxFunction, a_tmpVarDecls, a_preDefault);

    case ( txt,
           _,
           a_auxFunction,
           a_tmpVarDecls,
           a_preDefault,
           _ )
      then (txt, a_auxFunction, a_tmpVarDecls, a_preDefault);
  end match;
end fun_1111;

protected function fun_1112
  input Tpl.Text in_txt;
  input Absyn.Path in_a_ri_path;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_tmpVarDecls;
  input Tpl.Text in_a_preDefault;
  input SimCodeFunction.Context in_a_context;
  input Option<Values.Value> in_a_ri_defaultValue;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_tmpVarDecls;
  output Tpl.Text out_a_preDefault;
algorithm
  (out_txt, out_a_auxFunction, out_a_tmpVarDecls, out_a_preDefault) :=
  match(in_txt, in_a_ri_path, in_a_auxFunction, in_a_tmpVarDecls, in_a_preDefault, in_a_context, in_a_ri_defaultValue)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_tmpVarDecls;
      Tpl.Text a_preDefault;
      SimCodeFunction.Context a_context;
      Option<Values.Value> a_ri_defaultValue;

    case ( txt,
           Absyn.IDENT(name = "array"),
           a_auxFunction,
           a_tmpVarDecls,
           a_preDefault,
           _,
           _ )
      then (txt, a_auxFunction, a_tmpVarDecls, a_preDefault);

    case ( txt,
           _,
           a_auxFunction,
           a_tmpVarDecls,
           a_preDefault,
           a_context,
           a_ri_defaultValue )
      equation
        (txt, a_auxFunction, a_tmpVarDecls, a_preDefault) = fun_1111(txt, a_ri_defaultValue, a_auxFunction, a_tmpVarDecls, a_preDefault, a_context);
      then (txt, a_auxFunction, a_tmpVarDecls, a_preDefault);
  end match;
end fun_1112;

protected function lm_1113
  input Tpl.Text in_txt;
  input DAE.Dimensions in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      DAE.Dimensions rest;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", (modelica_integer)(1), (int*)0, \'W\'"));
        txt = lm_1113(txt, rest);
      then txt;
  end match;
end lm_1113;

protected function fun_1114
  input Tpl.Text in_txt;
  input DAE.Type in_mArg;
  input Tpl.Text in_a_arrayTypeResult;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_reductionBodyExpr;
  input Tpl.Text in_a_arrIndex;
  input Tpl.Text in_a_res;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_varDecls) :=
  match(in_txt, in_mArg, in_a_arrayTypeResult, in_a_varDecls, in_a_reductionBodyExpr, in_a_arrIndex, in_a_res)
    local
      Tpl.Text txt;
      Tpl.Text a_arrayTypeResult;
      Tpl.Text a_varDecls;
      Tpl.Text a_reductionBodyExpr;
      Tpl.Text a_arrIndex;
      Tpl.Text a_res;
      DAE.Type i_ty;
      DAE.Dimensions i_dims;
      ClassInf.State i_record__state;
      Tpl.Text l_idx__str;
      Integer ret_5;
      Integer ret_4;
      Tpl.Text l_nridx__str;
      Tpl.Text l_tmp;
      Absyn.Path ret_1;
      Tpl.Text l_rec__name;

    case ( txt,
           DAE.T_COMPLEX(complexClassType = i_record__state),
           _,
           a_varDecls,
           a_reductionBodyExpr,
           a_arrIndex,
           a_res )
      equation
        ret_1 = ClassInf.getStateName(i_record__state);
        l_rec__name = CodegenUtil.underscorePath(Tpl.emptyTxt, ret_1);
        txt = Tpl.writeText(txt, l_rec__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_array_get("));
        txt = Tpl.writeText(txt, a_res);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", 1, "));
        txt = Tpl.writeText(txt, a_arrIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("++) = "));
        txt = Tpl.writeText(txt, a_reductionBodyExpr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then (txt, a_varDecls);

    case ( txt,
           DAE.T_ARRAY(dims = i_dims, ty = i_ty),
           _,
           a_varDecls,
           a_reductionBodyExpr,
           a_arrIndex,
           a_res )
      equation
        (l_tmp, a_varDecls) = tempDecl(Tpl.emptyTxt, "index_spec_t", a_varDecls);
        ret_4 = listLength(i_dims);
        ret_5 = intAdd(1, ret_4);
        l_nridx__str = Tpl.writeStr(Tpl.emptyTxt, intString(ret_5));
        l_idx__str = lm_1113(Tpl.emptyTxt, i_dims);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("create_index_spec(&"));
        txt = Tpl.writeText(txt, l_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, l_nridx__str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", (modelica_integer)(0), make_index_array(1, (modelica_integer) "));
        txt = Tpl.writeText(txt, a_arrIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("++), \'S\'"));
        txt = Tpl.writeText(txt, l_idx__str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ");\n",
                                    "indexed_assign_"
                                }, false));
        txt = expTypeArray(txt, i_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_reductionBodyExpr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", &"));
        txt = Tpl.writeText(txt, a_res);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", &"));
        txt = Tpl.writeText(txt, l_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then (txt, a_varDecls);

    case ( txt,
           _,
           a_arrayTypeResult,
           a_varDecls,
           a_reductionBodyExpr,
           a_arrIndex,
           a_res )
      equation
        txt = Tpl.writeText(txt, a_arrayTypeResult);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_get1("));
        txt = Tpl.writeText(txt, a_res);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", 1, "));
        txt = Tpl.writeText(txt, a_arrIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("++) = "));
        txt = Tpl.writeText(txt, a_reductionBodyExpr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then (txt, a_varDecls);
  end match;
end fun_1114;

protected function fun_1115
  input Tpl.Text in_txt;
  input Tpl.Text in_a_foundFirst;
  input Tpl.Text in_a_reductionBodyExpr;
  input Tpl.Text in_a_fExpStr;
  input Tpl.Text in_a_res;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_foundFirst, in_a_reductionBodyExpr, in_a_fExpStr, in_a_res)
    local
      Tpl.Text txt;
      Tpl.Text a_reductionBodyExpr;
      Tpl.Text a_fExpStr;
      Tpl.Text a_res;
      Tpl.Text i_foundFirst;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           _,
           a_fExpStr,
           a_res )
      equation
        txt = Tpl.writeText(txt, a_res);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, a_fExpStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           i_foundFirst,
           a_reductionBodyExpr,
           a_fExpStr,
           a_res )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if("));
        txt = Tpl.writeText(txt, i_foundFirst);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ")\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_res);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, a_fExpStr);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "else\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_res);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, a_reductionBodyExpr);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.writeText(txt, i_foundFirst);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" = 1;\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;
  end match;
end fun_1115;

protected function fun_1116
  input Tpl.Text in_txt;
  input Option<DAE.Exp> in_a_ri_foldExp;
  input Tpl.Text in_a_reductionBodyExpr;
  input Tpl.Text in_a_res;
  input Tpl.Text in_a_foundFirst;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_tmpVarDecls;
  input Tpl.Text in_a_bodyExpPre;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_tmpVarDecls;
  output Tpl.Text out_a_bodyExpPre;
algorithm
  (out_txt, out_a_auxFunction, out_a_tmpVarDecls, out_a_bodyExpPre) :=
  match(in_txt, in_a_ri_foldExp, in_a_reductionBodyExpr, in_a_res, in_a_foundFirst, in_a_auxFunction, in_a_tmpVarDecls, in_a_bodyExpPre, in_a_context)
    local
      Tpl.Text txt;
      Tpl.Text a_reductionBodyExpr;
      Tpl.Text a_res;
      Tpl.Text a_foundFirst;
      Tpl.Text a_auxFunction;
      Tpl.Text a_tmpVarDecls;
      Tpl.Text a_bodyExpPre;
      SimCodeFunction.Context a_context;
      DAE.Exp i_fExp;
      Tpl.Text l_fExpStr;
      Tpl.Text l_foldExpPre;

    case ( txt,
           SOME(i_fExp),
           a_reductionBodyExpr,
           a_res,
           a_foundFirst,
           a_auxFunction,
           a_tmpVarDecls,
           a_bodyExpPre,
           a_context )
      equation
        l_foldExpPre = Tpl.emptyTxt;
        (l_fExpStr, a_bodyExpPre, a_tmpVarDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_fExp, a_context, a_bodyExpPre, a_tmpVarDecls, a_auxFunction);
        txt = fun_1115(txt, a_foundFirst, a_reductionBodyExpr, l_fExpStr, a_res);
      then (txt, a_auxFunction, a_tmpVarDecls, a_bodyExpPre);

    case ( txt,
           _,
           _,
           _,
           _,
           a_auxFunction,
           a_tmpVarDecls,
           a_bodyExpPre,
           _ )
      then (txt, a_auxFunction, a_tmpVarDecls, a_bodyExpPre);
  end match;
end fun_1116;

protected function fun_1117
  input Tpl.Text in_txt;
  input Absyn.Path in_a_ri_path;
  input Tpl.Text in_a_foundFirst;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_tmpVarDecls;
  input Tpl.Text in_a_bodyExpPre;
  input SimCodeFunction.Context in_a_context;
  input Option<DAE.Exp> in_a_ri_foldExp;
  input Tpl.Text in_a_arrayTypeResult;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_arrIndex;
  input DAE.Exp in_a_r_expr;
  input Tpl.Text in_a_res;
  input Tpl.Text in_a_reductionBodyExpr;
  input Tpl.Text in_a_resTail;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_tmpVarDecls;
  output Tpl.Text out_a_bodyExpPre;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_tmpVarDecls, out_a_bodyExpPre, out_a_varDecls) :=
  match(in_txt, in_a_ri_path, in_a_foundFirst, in_a_auxFunction, in_a_tmpVarDecls, in_a_bodyExpPre, in_a_context, in_a_ri_foldExp, in_a_arrayTypeResult, in_a_varDecls, in_a_arrIndex, in_a_r_expr, in_a_res, in_a_reductionBodyExpr, in_a_resTail)
    local
      Tpl.Text txt;
      Tpl.Text a_foundFirst;
      Tpl.Text a_auxFunction;
      Tpl.Text a_tmpVarDecls;
      Tpl.Text a_bodyExpPre;
      SimCodeFunction.Context a_context;
      Option<DAE.Exp> a_ri_foldExp;
      Tpl.Text a_arrayTypeResult;
      Tpl.Text a_varDecls;
      Tpl.Text a_arrIndex;
      DAE.Exp a_r_expr;
      Tpl.Text a_res;
      Tpl.Text a_reductionBodyExpr;
      Tpl.Text a_resTail;
      DAE.Type ret_0;

    case ( txt,
           Absyn.IDENT(name = "list"),
           _,
           a_auxFunction,
           a_tmpVarDecls,
           a_bodyExpPre,
           _,
           _,
           _,
           a_varDecls,
           _,
           _,
           _,
           a_reductionBodyExpr,
           a_resTail )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("*"));
        txt = Tpl.writeText(txt, a_resTail);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = mmc_mk_cons("));
        txt = Tpl.writeText(txt, a_reductionBodyExpr);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",0);\n"));
        txt = Tpl.writeText(txt, a_resTail);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = &MMC_CDR(*"));
        txt = Tpl.writeText(txt, a_resTail);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then (txt, a_auxFunction, a_tmpVarDecls, a_bodyExpPre, a_varDecls);

    case ( txt,
           Absyn.IDENT(name = "listReverse"),
           _,
           a_auxFunction,
           a_tmpVarDecls,
           a_bodyExpPre,
           _,
           _,
           _,
           a_varDecls,
           _,
           _,
           a_res,
           a_reductionBodyExpr,
           _ )
      equation
        txt = Tpl.writeText(txt, a_res);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = mmc_mk_cons("));
        txt = Tpl.writeText(txt, a_reductionBodyExpr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, a_res);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then (txt, a_auxFunction, a_tmpVarDecls, a_bodyExpPre, a_varDecls);

    case ( txt,
           Absyn.IDENT(name = "array"),
           _,
           a_auxFunction,
           a_tmpVarDecls,
           a_bodyExpPre,
           _,
           _,
           a_arrayTypeResult,
           a_varDecls,
           a_arrIndex,
           a_r_expr,
           a_res,
           a_reductionBodyExpr,
           _ )
      equation
        ret_0 = Expression.typeof(a_r_expr);
        (txt, a_varDecls) = fun_1114(txt, ret_0, a_arrayTypeResult, a_varDecls, a_reductionBodyExpr, a_arrIndex, a_res);
      then (txt, a_auxFunction, a_tmpVarDecls, a_bodyExpPre, a_varDecls);

    case ( txt,
           _,
           a_foundFirst,
           a_auxFunction,
           a_tmpVarDecls,
           a_bodyExpPre,
           a_context,
           a_ri_foldExp,
           _,
           a_varDecls,
           _,
           _,
           a_res,
           a_reductionBodyExpr,
           _ )
      equation
        (txt, a_auxFunction, a_tmpVarDecls, a_bodyExpPre) = fun_1116(txt, a_ri_foldExp, a_reductionBodyExpr, a_res, a_foundFirst, a_auxFunction, a_tmpVarDecls, a_bodyExpPre, a_context);
      then (txt, a_auxFunction, a_tmpVarDecls, a_bodyExpPre, a_varDecls);
  end match;
end fun_1117;

protected function fun_1118
  input Tpl.Text in_txt;
  input DAE.Exp in_a_iter_exp;
  input Tpl.Text in_a_iteratorName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_iter_exp, in_a_iteratorName)
    local
      Tpl.Text txt;
      Tpl.Text a_iteratorName;

    case ( txt,
           DAE.RANGE(ty = _),
           a_iteratorName )
      equation
        txt = Tpl.writeText(txt, a_iteratorName);
      then txt;

    case ( txt,
           _,
           a_iteratorName )
      equation
        txt = Tpl.writeText(txt, a_iteratorName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_loopVar"));
      then txt;
  end match;
end fun_1118;

protected function fun_1119
  input Tpl.Text in_txt;
  input DAE.Exp in_a_iter_exp;
  input Tpl.Text in_a_tmpVarDecls;
  input Tpl.Text in_a_identType;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_tmpVarDecls;
algorithm
  (out_txt, out_a_tmpVarDecls) :=
  match(in_txt, in_a_iter_exp, in_a_tmpVarDecls, in_a_identType)
    local
      Tpl.Text txt;
      Tpl.Text a_tmpVarDecls;
      Tpl.Text a_identType;

    case ( txt,
           DAE.RANGE(ty = _),
           a_tmpVarDecls,
           a_identType )
      equation
        (txt, a_tmpVarDecls) = tempDecl(txt, Tpl.textString(a_identType), a_tmpVarDecls);
      then (txt, a_tmpVarDecls);

    case ( txt,
           _,
           a_tmpVarDecls,
           _ )
      then (txt, a_tmpVarDecls);
  end match;
end fun_1119;

protected function fun_1120
  input Tpl.Text in_txt;
  input DAE.Exp in_a_iter_exp;
  input Tpl.Text in_a_tmpVarDecls;
  input Tpl.Text in_a_identType;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_tmpVarDecls;
algorithm
  (out_txt, out_a_tmpVarDecls) :=
  match(in_txt, in_a_iter_exp, in_a_tmpVarDecls, in_a_identType)
    local
      Tpl.Text txt;
      Tpl.Text a_tmpVarDecls;
      Tpl.Text a_identType;

    case ( txt,
           DAE.RANGE(ty = _),
           a_tmpVarDecls,
           a_identType )
      equation
        (txt, a_tmpVarDecls) = tempDecl(txt, Tpl.textString(a_identType), a_tmpVarDecls);
      then (txt, a_tmpVarDecls);

    case ( txt,
           _,
           a_tmpVarDecls,
           _ )
      then (txt, a_tmpVarDecls);
  end match;
end fun_1120;

protected function fun_1121
  input Tpl.Text in_txt;
  input DAE.Exp in_a_iter_exp;
  input Tpl.Text in_a_loopVar;
  input Tpl.Text in_a_arrayType;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_iter_exp, in_a_loopVar, in_a_arrayType)
    local
      Tpl.Text txt;
      Tpl.Text a_loopVar;
      Tpl.Text a_arrayType;

    case ( txt,
           DAE.RANGE(ty = _),
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_loopVar,
           a_arrayType )
      equation
        txt = Tpl.writeText(txt, a_arrayType);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, a_loopVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;
  end match;
end fun_1121;

protected function fun_1122
  input Tpl.Text in_txt;
  input String in_mArg;
  input Tpl.Text in_a_arrayType;
  input DAE.Exp in_a_iter_exp;
  input Tpl.Text in_a_loopVar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_arrayType, in_a_iter_exp, in_a_loopVar)
    local
      Tpl.Text txt;
      Tpl.Text a_arrayType;
      DAE.Exp a_iter_exp;
      Tpl.Text a_loopVar;

    case ( txt,
           "modelica_metatype",
           _,
           _,
           a_loopVar )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_metatype "));
        txt = Tpl.writeText(txt, a_loopVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = 0;"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _,
           a_arrayType,
           a_iter_exp,
           a_loopVar )
      equation
        txt = fun_1121(txt, a_iter_exp, a_loopVar, a_arrayType);
      then txt;
  end match;
end fun_1122;

protected function fun_1123
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_tmpVarDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_tmpVarDecls;
algorithm
  (out_txt, out_a_tmpVarDecls) :=
  match(in_txt, in_mArg, in_a_tmpVarDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_tmpVarDecls;

    case ( txt,
           false,
           a_tmpVarDecls )
      then (txt, a_tmpVarDecls);

    case ( txt,
           _,
           a_tmpVarDecls )
      equation
        (txt, a_tmpVarDecls) = tempDecl(txt, "modelica_integer", a_tmpVarDecls);
      then (txt, a_tmpVarDecls);
  end match;
end fun_1123;

protected function fun_1124
  input Tpl.Text in_txt;
  input String in_mArg;
  input Tpl.Text in_a_tmpVarDecls;
  input DAE.Exp in_a_iter_exp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_tmpVarDecls;
algorithm
  (out_txt, out_a_tmpVarDecls) :=
  match(in_txt, in_mArg, in_a_tmpVarDecls, in_a_iter_exp)
    local
      Tpl.Text txt;
      Tpl.Text a_tmpVarDecls;
      DAE.Exp a_iter_exp;
      Boolean ret_0;

    case ( txt,
           "modelica_metatype",
           a_tmpVarDecls,
           a_iter_exp )
      equation
        ret_0 = Expression.isMetaArray(a_iter_exp);
        (txt, a_tmpVarDecls) = fun_1123(txt, ret_0, a_tmpVarDecls);
      then (txt, a_tmpVarDecls);

    case ( txt,
           _,
           a_tmpVarDecls,
           _ )
      equation
        (txt, a_tmpVarDecls) = tempDecl(txt, "modelica_integer", a_tmpVarDecls);
      then (txt, a_tmpVarDecls);
  end match;
end fun_1124;

protected function fun_1125
  input Tpl.Text in_txt;
  input DAE.Exp in_a_iter_exp;
  input Tpl.Text in_a_tmpVarDecls;
  input Tpl.Text in_a_identType;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_tmpVarDecls;
algorithm
  (out_txt, out_a_tmpVarDecls) :=
  match(in_txt, in_a_iter_exp, in_a_tmpVarDecls, in_a_identType)
    local
      Tpl.Text txt;
      Tpl.Text a_tmpVarDecls;
      Tpl.Text a_identType;
      DAE.Exp i_iter_exp;
      String str_0;

    case ( txt,
           DAE.RANGE(ty = _),
           a_tmpVarDecls,
           _ )
      then (txt, a_tmpVarDecls);

    case ( txt,
           i_iter_exp,
           a_tmpVarDecls,
           a_identType )
      equation
        str_0 = Tpl.textString(a_identType);
        (txt, a_tmpVarDecls) = fun_1124(txt, str_0, a_tmpVarDecls, i_iter_exp);
      then (txt, a_tmpVarDecls);
  end match;
end fun_1125;

protected function fun_1126
  input Tpl.Text in_txt;
  input DAE.Exp in_a_iter_exp;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_tmpVarDecls;
  input Tpl.Text in_a_rangeExpPre;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_tmpVarDecls;
  output Tpl.Text out_a_rangeExpPre;
algorithm
  (out_txt, out_a_auxFunction, out_a_tmpVarDecls, out_a_rangeExpPre) :=
  match(in_txt, in_a_iter_exp, in_a_auxFunction, in_a_tmpVarDecls, in_a_rangeExpPre, in_a_context)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_tmpVarDecls;
      Tpl.Text a_rangeExpPre;
      SimCodeFunction.Context a_context;
      DAE.Exp i_step;

    case ( txt,
           DAE.RANGE(step = NONE()),
           a_auxFunction,
           a_tmpVarDecls,
           a_rangeExpPre,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("1 /* Range step-value */"));
      then (txt, a_auxFunction, a_tmpVarDecls, a_rangeExpPre);

    case ( txt,
           DAE.RANGE(step = SOME(i_step)),
           a_auxFunction,
           a_tmpVarDecls,
           a_rangeExpPre,
           a_context )
      equation
        (txt, a_rangeExpPre, a_tmpVarDecls, a_auxFunction) = daeExp(txt, i_step, a_context, a_rangeExpPre, a_tmpVarDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" /* Range step-value */"));
      then (txt, a_auxFunction, a_tmpVarDecls, a_rangeExpPre);

    case ( txt,
           _,
           a_auxFunction,
           a_tmpVarDecls,
           a_rangeExpPre,
           _ )
      then (txt, a_auxFunction, a_tmpVarDecls, a_rangeExpPre);
  end match;
end fun_1126;

protected function fun_1127
  input Tpl.Text in_txt;
  input DAE.Exp in_a_iter_exp;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_tmpVarDecls;
  input Tpl.Text in_a_rangeExpPre;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_tmpVarDecls;
  output Tpl.Text out_a_rangeExpPre;
algorithm
  (out_txt, out_a_auxFunction, out_a_tmpVarDecls, out_a_rangeExpPre) :=
  match(in_txt, in_a_iter_exp, in_a_auxFunction, in_a_tmpVarDecls, in_a_rangeExpPre, in_a_context)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_tmpVarDecls;
      Tpl.Text a_rangeExpPre;
      SimCodeFunction.Context a_context;
      DAE.Exp i_stop;

    case ( txt,
           DAE.RANGE(stop = i_stop),
           a_auxFunction,
           a_tmpVarDecls,
           a_rangeExpPre,
           a_context )
      equation
        (txt, a_rangeExpPre, a_tmpVarDecls, a_auxFunction) = daeExp(txt, i_stop, a_context, a_rangeExpPre, a_tmpVarDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" /* Range stop-value */"));
      then (txt, a_auxFunction, a_tmpVarDecls, a_rangeExpPre);

    case ( txt,
           _,
           a_auxFunction,
           a_tmpVarDecls,
           a_rangeExpPre,
           _ )
      then (txt, a_auxFunction, a_tmpVarDecls, a_rangeExpPre);
  end match;
end fun_1127;

protected function fun_1128
  input Tpl.Text in_txt;
  input DAE.Exp in_a_iter_exp;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_tmpVarDecls;
  input Tpl.Text in_a_rangeExpPre;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_tmpVarDecls;
  output Tpl.Text out_a_rangeExpPre;
algorithm
  (out_txt, out_a_auxFunction, out_a_tmpVarDecls, out_a_rangeExpPre) :=
  match(in_txt, in_a_iter_exp, in_a_auxFunction, in_a_tmpVarDecls, in_a_rangeExpPre, in_a_context)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_tmpVarDecls;
      Tpl.Text a_rangeExpPre;
      SimCodeFunction.Context a_context;
      DAE.Exp i_iter_exp;
      DAE.Exp i_start;

    case ( txt,
           DAE.RANGE(start = i_start),
           a_auxFunction,
           a_tmpVarDecls,
           a_rangeExpPre,
           a_context )
      equation
        (txt, a_rangeExpPre, a_tmpVarDecls, a_auxFunction) = daeExp(txt, i_start, a_context, a_rangeExpPre, a_tmpVarDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" /* Range start-value */"));
      then (txt, a_auxFunction, a_tmpVarDecls, a_rangeExpPre);

    case ( txt,
           i_iter_exp,
           a_auxFunction,
           a_tmpVarDecls,
           a_rangeExpPre,
           a_context )
      equation
        (txt, a_rangeExpPre, a_tmpVarDecls, a_auxFunction) = daeExp(txt, i_iter_exp, a_context, a_rangeExpPre, a_tmpVarDecls, a_auxFunction);
      then (txt, a_auxFunction, a_tmpVarDecls, a_rangeExpPre);
  end match;
end fun_1128;

protected function fun_1129
  input Tpl.Text in_txt;
  input Tpl.Text in_a_rangeExpStep;
  input Tpl.Text in_a_stepVar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_rangeExpStep, in_a_stepVar)
    local
      Tpl.Text txt;
      Tpl.Text a_stepVar;
      Tpl.Text i_rangeExpStep;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           _ )
      then txt;

    case ( txt,
           i_rangeExpStep,
           a_stepVar )
      equation
        txt = Tpl.writeText(txt, a_stepVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, i_rangeExpStep);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;
  end match;
end fun_1129;

protected function fun_1130
  input Tpl.Text in_txt;
  input Tpl.Text in_a_rangeExpStop;
  input Tpl.Text in_a_stopVar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_rangeExpStop, in_a_stopVar)
    local
      Tpl.Text txt;
      Tpl.Text a_stopVar;
      Tpl.Text i_rangeExpStop;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           _ )
      then txt;

    case ( txt,
           i_rangeExpStop,
           a_stopVar )
      equation
        txt = Tpl.writeText(txt, a_stopVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, i_rangeExpStop);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;
  end match;
end fun_1130;

protected function fun_1131
  input Tpl.Text in_txt;
  input DAE.Exp in_a_iter_exp;
  input Tpl.Text in_a_check;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_iter_exp, in_a_check)
    local
      Tpl.Text txt;
      Tpl.Text a_check;

    case ( txt,
           DAE.RANGE(step = SOME(DAE.ICONST(integer = 0))),
           a_check )
      equation
        txt = Tpl.writeText(txt, a_check);
      then txt;

    case ( txt,
           DAE.RANGE(step = NONE()),
           _ )
      then txt;

    case ( txt,
           DAE.RANGE(step = SOME(DAE.ICONST(integer = _))),
           _ )
      then txt;

    case ( txt,
           _,
           a_check )
      equation
        txt = Tpl.writeText(txt, a_check);
      then txt;
  end match;
end fun_1131;

protected function fun_1132
  input Tpl.Text in_txt;
  input Tpl.Text in_a_rangeExpStop;
  input DAE.Exp in_a_iter_exp;
  input Tpl.Text in_a_stepVar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_rangeExpStop, in_a_iter_exp, in_a_stepVar)
    local
      Tpl.Text txt;
      DAE.Exp a_iter_exp;
      Tpl.Text a_stepVar;
      Tpl.Text l_check;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_iter_exp,
           a_stepVar )
      equation
        l_check = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("if ("));
        l_check = Tpl.writeText(l_check, a_stepVar);
        l_check = Tpl.writeTok(l_check, Tpl.ST_STRING_LIST({
                                            " == 0) {\n",
                                            "  FILE_INFO info = omc_dummyFileInfo;\n",
                                            "  omc_assert(threadData, info, \"Range with a step of zero.\");\n",
                                            "}"
                                        }, false));
        l_check = Tpl.writeTok(l_check, Tpl.ST_NEW_LINE());
        txt = fun_1131(txt, a_iter_exp, l_check);
      then txt;
  end match;
end fun_1132;

protected function fun_1133
  input Tpl.Text in_txt;
  input Absyn.Path in_a_ri_path;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ri_path)
    local
      Tpl.Text txt;

    case ( txt,
           Absyn.IDENT(name = "array") )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("1"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_1133;

protected function fun_1134
  input Tpl.Text in_txt;
  input Tpl.Text in_a_rangeExpStop;
  input Absyn.Path in_a_ri_path;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_rangeExpStop, in_a_ri_path)
    local
      Tpl.Text txt;
      Absyn.Path a_ri_path;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           _ )
      then txt;

    case ( txt,
           _,
           a_ri_path )
      equation
        txt = fun_1133(txt, a_ri_path);
      then txt;
  end match;
end fun_1134;

protected function fun_1135
  input Tpl.Text in_txt;
  input Tpl.Text in_a_isArrayWithLength;
  input Tpl.Text in_a_iteratorName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_isArrayWithLength, in_a_iteratorName)
    local
      Tpl.Text txt;
      Tpl.Text a_iteratorName;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           _ )
      then txt;

    case ( txt,
           _,
           a_iteratorName )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_integer "));
        txt = Tpl.writeText(txt, a_iteratorName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_length;"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;
  end match;
end fun_1135;

protected function fun_1136
  input Tpl.Text in_txt;
  input Tpl.Text in_a_firstIndex;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_firstIndex)
    local
      Tpl.Text txt;
      Tpl.Text i_firstIndex;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}) )
      then txt;

    case ( txt,
           i_firstIndex )
      equation
        txt = Tpl.writeText(txt, i_firstIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = 1;"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;
  end match;
end fun_1136;

protected function fun_1137
  input Tpl.Text in_txt;
  input DAE.Exp in_a_iter_exp;
  input Tpl.Text in_a_firstIndex;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_iter_exp, in_a_firstIndex)
    local
      Tpl.Text txt;
      Tpl.Text a_firstIndex;

    case ( txt,
           DAE.RANGE(ty = _),
           _ )
      then txt;

    case ( txt,
           _,
           a_firstIndex )
      equation
        txt = fun_1136(txt, a_firstIndex);
      then txt;
  end match;
end fun_1137;

protected function fun_1138
  input Tpl.Text in_txt;
  input Option<DAE.Exp> in_a_iter_guardExp;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_tmpVarDecls;
  input Tpl.Text in_a_guardExpPre;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_tmpVarDecls;
  output Tpl.Text out_a_guardExpPre;
algorithm
  (out_txt, out_a_auxFunction, out_a_tmpVarDecls, out_a_guardExpPre) :=
  match(in_txt, in_a_iter_guardExp, in_a_auxFunction, in_a_tmpVarDecls, in_a_guardExpPre, in_a_context)
    local
      Tpl.Text txt;
      Tpl.Text a_auxFunction;
      Tpl.Text a_tmpVarDecls;
      Tpl.Text a_guardExpPre;
      SimCodeFunction.Context a_context;
      DAE.Exp i_grd;

    case ( txt,
           SOME(i_grd),
           a_auxFunction,
           a_tmpVarDecls,
           a_guardExpPre,
           a_context )
      equation
        (txt, a_guardExpPre, a_tmpVarDecls, a_auxFunction) = daeExp(txt, i_grd, a_context, a_guardExpPre, a_tmpVarDecls, a_auxFunction);
      then (txt, a_auxFunction, a_tmpVarDecls, a_guardExpPre);

    case ( txt,
           _,
           a_auxFunction,
           a_tmpVarDecls,
           a_guardExpPre,
           _ )
      then (txt, a_auxFunction, a_tmpVarDecls, a_guardExpPre);
  end match;
end fun_1138;

protected function fun_1139
  input Tpl.Text in_txt;
  input Tpl.Text in_a_firstIndex;
  input Tpl.Text in_a_iteratorName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_firstIndex, in_a_iteratorName)
    local
      Tpl.Text txt;
      Tpl.Text a_iteratorName;
      Tpl.Text i_firstIndex;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           a_iteratorName )
      equation
        txt = Tpl.writeText(txt, a_iteratorName);
      then txt;

    case ( txt,
           i_firstIndex,
           _ )
      equation
        txt = Tpl.writeText(txt, i_firstIndex);
      then txt;
  end match;
end fun_1139;

protected function fun_1140
  input Tpl.Text in_txt;
  input Tpl.Text in_a_isArrayWithLength;
  input Tpl.Text in_a_stepVar;
  input Tpl.Text in_a_firstIndex;
  input Tpl.Text in_a_stopVar;
  input Tpl.Text in_a_iteratorName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_isArrayWithLength, in_a_stepVar, in_a_firstIndex, in_a_stopVar, in_a_iteratorName)
    local
      Tpl.Text txt;
      Tpl.Text a_stepVar;
      Tpl.Text a_firstIndex;
      Tpl.Text a_stopVar;
      Tpl.Text a_iteratorName;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           _,
           _,
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_stepVar,
           a_firstIndex,
           a_stopVar,
           a_iteratorName )
      equation
        txt = Tpl.writeText(txt, a_iteratorName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_length = (("));
        txt = Tpl.writeText(txt, a_stopVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-"));
        txt = fun_1139(txt, a_firstIndex, a_iteratorName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")/"));
        txt = Tpl.writeText(txt, a_stepVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")+1;"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;
  end match;
end fun_1140;

protected function fun_1141
  input Tpl.Text in_txt;
  input DAE.Exp in_a_iter_exp;
  input Tpl.Text in_a_stepVar;
  input Tpl.Text in_a_rangeExp;
  input Tpl.Text in_a_iteratorName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_iter_exp, in_a_stepVar, in_a_rangeExp, in_a_iteratorName)
    local
      Tpl.Text txt;
      Tpl.Text a_stepVar;
      Tpl.Text a_rangeExp;
      Tpl.Text a_iteratorName;

    case ( txt,
           DAE.RANGE(ty = _),
           a_stepVar,
           a_rangeExp,
           a_iteratorName )
      equation
        txt = Tpl.writeText(txt, a_iteratorName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = ("));
        txt = Tpl.writeText(txt, a_rangeExp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")-"));
        txt = Tpl.writeText(txt, a_stepVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_1141;

protected function fun_1142
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_endLoop;
  input Tpl.Text in_a_guardExp;
  input Tpl.Text in_a_iteratorName;
  input Tpl.Text in_a_loopVar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_endLoop, in_a_guardExp, in_a_iteratorName, in_a_loopVar)
    local
      Tpl.Text txt;
      Tpl.Text a_endLoop;
      Tpl.Text a_guardExp;
      Tpl.Text a_iteratorName;
      Tpl.Text a_loopVar;

    case ( txt,
           false,
           _,
           a_guardExp,
           a_iteratorName,
           a_loopVar )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("while (!listEmpty("));
        txt = Tpl.writeText(txt, a_loopVar);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(")) {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_iteratorName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = MMC_CAR("));
        txt = Tpl.writeText(txt, a_loopVar);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(");\n"));
        txt = Tpl.writeText(txt, a_loopVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = MMC_CDR("));
        txt = Tpl.writeText(txt, a_loopVar);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(");\n"));
        txt = Tpl.writeText(txt, a_guardExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;

    case ( txt,
           _,
           a_endLoop,
           _,
           a_iteratorName,
           a_loopVar )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if (!listEmpty("));
        txt = Tpl.writeText(txt, a_loopVar);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(")) {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_iteratorName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = MMC_CAR("));
        txt = Tpl.writeText(txt, a_loopVar);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(");\n"));
        txt = Tpl.writeText(txt, a_loopVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = MMC_CDR("));
        txt = Tpl.writeText(txt, a_loopVar);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(");\n"));
        txt = Tpl.writeText(txt, a_endLoop);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("--;\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;
  end match;
end fun_1142;

protected function fun_1143
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_endLoop;
  input Tpl.Text in_a_guardExp;
  input Tpl.Text in_a_iteratorName;
  input Tpl.Text in_a_loopVar;
  input Tpl.Text in_a_firstIndex;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_endLoop, in_a_guardExp, in_a_iteratorName, in_a_loopVar, in_a_firstIndex)
    local
      Tpl.Text txt;
      Tpl.Text a_endLoop;
      Tpl.Text a_guardExp;
      Tpl.Text a_iteratorName;
      Tpl.Text a_loopVar;
      Tpl.Text a_firstIndex;

    case ( txt,
           false,
           _,
           a_guardExp,
           a_iteratorName,
           a_loopVar,
           a_firstIndex )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("while ("));
        txt = Tpl.writeText(txt, a_firstIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" <= arrayLength("));
        txt = Tpl.writeText(txt, a_loopVar);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(")) {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_iteratorName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = arrayGet("));
        txt = Tpl.writeText(txt, a_loopVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_firstIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("++);\n"));
        txt = Tpl.writeText(txt, a_guardExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;

    case ( txt,
           _,
           a_endLoop,
           _,
           a_iteratorName,
           a_loopVar,
           a_firstIndex )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if ("));
        txt = Tpl.writeText(txt, a_firstIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" <= arrayLength("));
        txt = Tpl.writeText(txt, a_loopVar);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(")) {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_iteratorName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = arrayGet("));
        txt = Tpl.writeText(txt, a_loopVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_firstIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("++);\n"));
        txt = Tpl.writeText(txt, a_endLoop);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("--;\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;
  end match;
end fun_1143;

protected function fun_1144
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_firstIndex;
  input Tpl.Text in_a_endLoop;
  input Tpl.Text in_a_guardExp;
  input Tpl.Text in_a_iteratorName;
  input Tpl.Text in_a_loopVar;
  input Tpl.Text in_a_guardCond;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_firstIndex, in_a_endLoop, in_a_guardExp, in_a_iteratorName, in_a_loopVar, in_a_guardCond)
    local
      Tpl.Text txt;
      Tpl.Text a_firstIndex;
      Tpl.Text a_endLoop;
      Tpl.Text a_guardExp;
      Tpl.Text a_iteratorName;
      Tpl.Text a_loopVar;
      Tpl.Text a_guardCond;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           false,
           _,
           a_endLoop,
           a_guardExp,
           a_iteratorName,
           a_loopVar,
           a_guardCond )
      equation
        ret_0 = stringEq(Tpl.textString(a_guardCond), "");
        txt = fun_1142(txt, ret_0, a_endLoop, a_guardExp, a_iteratorName, a_loopVar);
      then txt;

    case ( txt,
           _,
           a_firstIndex,
           a_endLoop,
           a_guardExp,
           a_iteratorName,
           a_loopVar,
           a_guardCond )
      equation
        ret_1 = stringEq(Tpl.textString(a_guardCond), "");
        txt = fun_1143(txt, ret_1, a_endLoop, a_guardExp, a_iteratorName, a_loopVar, a_firstIndex);
      then txt;
  end match;
end fun_1144;

protected function fun_1145
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("while"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if"));
      then txt;
  end match;
end fun_1145;

protected function fun_1146
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_endLoop;
  input Tpl.Text in_a_guardExp;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_endLoop, in_a_guardExp)
    local
      Tpl.Text txt;
      Tpl.Text a_endLoop;
      Tpl.Text a_guardExp;

    case ( txt,
           false,
           _,
           a_guardExp )
      equation
        txt = Tpl.writeText(txt, a_guardExp);
      then txt;

    case ( txt,
           _,
           a_endLoop,
           _ )
      equation
        txt = Tpl.writeText(txt, a_endLoop);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("--;"));
      then txt;
  end match;
end fun_1146;

protected function fun_1147
  input Tpl.Text in_txt;
  input DAE.Type in_a_iter_ty;
  input Tpl.Text in_a_arrayType;
  input Tpl.Text in_a_firstIndex;
  input Tpl.Text in_a_loopVar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_iter_ty, in_a_arrayType, in_a_firstIndex, in_a_loopVar)
    local
      Tpl.Text txt;
      Tpl.Text a_arrayType;
      Tpl.Text a_firstIndex;
      Tpl.Text a_loopVar;
      ClassInf.State i_record__state;
      Absyn.Path ret_1;
      Tpl.Text l_rec__name;

    case ( txt,
           DAE.T_ARRAY(ty = DAE.T_COMPLEX(complexClassType = i_record__state)),
           _,
           a_firstIndex,
           a_loopVar )
      equation
        ret_1 = ClassInf.getStateName(i_record__state);
        l_rec__name = CodegenUtil.underscorePath(Tpl.emptyTxt, ret_1);
        txt = Tpl.writeText(txt, l_rec__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_array_get("));
        txt = Tpl.writeText(txt, a_loopVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", 1, "));
        txt = Tpl.writeText(txt, a_firstIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("++)"));
      then txt;

    case ( txt,
           _,
           a_arrayType,
           a_firstIndex,
           a_loopVar )
      equation
        txt = Tpl.writeText(txt, a_arrayType);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_get1("));
        txt = Tpl.writeText(txt, a_loopVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", 1, "));
        txt = Tpl.writeText(txt, a_firstIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("++)"));
      then txt;
  end match;
end fun_1147;

protected function fun_1148
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_endLoop;
  input Tpl.Text in_a_guardExp;
  input Tpl.Text in_a_addr;
  input Tpl.Text in_a_iteratorName;
  input Tpl.Text in_a_loopVar;
  input Tpl.Text in_a_firstIndex;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_endLoop, in_a_guardExp, in_a_addr, in_a_iteratorName, in_a_loopVar, in_a_firstIndex)
    local
      Tpl.Text txt;
      Tpl.Text a_endLoop;
      Tpl.Text a_guardExp;
      Tpl.Text a_addr;
      Tpl.Text a_iteratorName;
      Tpl.Text a_loopVar;
      Tpl.Text a_firstIndex;

    case ( txt,
           false,
           _,
           a_guardExp,
           a_addr,
           a_iteratorName,
           a_loopVar,
           a_firstIndex )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("while("));
        txt = Tpl.writeText(txt, a_firstIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" <= size_of_dimension_base_array("));
        txt = Tpl.writeText(txt, a_loopVar);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(", 1)) {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_iteratorName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, a_addr);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.writeText(txt, a_guardExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;

    case ( txt,
           _,
           a_endLoop,
           _,
           a_addr,
           a_iteratorName,
           a_loopVar,
           a_firstIndex )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if("));
        txt = Tpl.writeText(txt, a_firstIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" <= size_of_dimension_base_array("));
        txt = Tpl.writeText(txt, a_loopVar);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(", 1)) {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_iteratorName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, a_addr);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.writeText(txt, a_endLoop);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("--;\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;
  end match;
end fun_1148;

protected function fun_1149
  input Tpl.Text in_txt;
  input DAE.Exp in_a_iter_exp;
  input Tpl.Text in_a_arrayType;
  input Tpl.Text in_a_firstIndex;
  input Tpl.Text in_a_loopVar;
  input DAE.Type in_a_iter_ty;
  input Tpl.Text in_a_endLoop;
  input Tpl.Text in_a_guardExp;
  input Tpl.Text in_a_stopVar;
  input Tpl.Text in_a_iteratorName;
  input Tpl.Text in_a_stepVar;
  input Tpl.Text in_a_guardCond;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_iter_exp, in_a_arrayType, in_a_firstIndex, in_a_loopVar, in_a_iter_ty, in_a_endLoop, in_a_guardExp, in_a_stopVar, in_a_iteratorName, in_a_stepVar, in_a_guardCond)
    local
      Tpl.Text txt;
      Tpl.Text a_arrayType;
      Tpl.Text a_firstIndex;
      Tpl.Text a_loopVar;
      DAE.Type a_iter_ty;
      Tpl.Text a_endLoop;
      Tpl.Text a_guardExp;
      Tpl.Text a_stopVar;
      Tpl.Text a_iteratorName;
      Tpl.Text a_stepVar;
      Tpl.Text a_guardCond;
      Boolean ret_3;
      Tpl.Text l_addr;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           DAE.RANGE(ty = _),
           _,
           _,
           _,
           _,
           a_endLoop,
           a_guardExp,
           a_stopVar,
           a_iteratorName,
           a_stepVar,
           a_guardCond )
      equation
        ret_0 = stringEq(Tpl.textString(a_guardCond), "");
        txt = fun_1145(txt, ret_0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" ("));
        txt = Tpl.writeText(txt, a_stepVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" > 0 ? "));
        txt = Tpl.writeText(txt, a_iteratorName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("+"));
        txt = Tpl.writeText(txt, a_stepVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" <= "));
        txt = Tpl.writeText(txt, a_stopVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" : "));
        txt = Tpl.writeText(txt, a_iteratorName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("+"));
        txt = Tpl.writeText(txt, a_stepVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" >= "));
        txt = Tpl.writeText(txt, a_stopVar);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(") {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_iteratorName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" += "));
        txt = Tpl.writeText(txt, a_stepVar);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        ret_1 = stringEq(Tpl.textString(a_guardCond), "");
        txt = fun_1146(txt, ret_1, a_endLoop, a_guardExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;

    case ( txt,
           _,
           a_arrayType,
           a_firstIndex,
           a_loopVar,
           a_iter_ty,
           a_endLoop,
           a_guardExp,
           _,
           a_iteratorName,
           _,
           a_guardCond )
      equation
        l_addr = fun_1147(Tpl.emptyTxt, a_iter_ty, a_arrayType, a_firstIndex, a_loopVar);
        ret_3 = stringEq(Tpl.textString(a_guardCond), "");
        txt = fun_1148(txt, ret_3, a_endLoop, a_guardExp, l_addr, a_iteratorName, a_loopVar, a_firstIndex);
      then txt;
  end match;
end fun_1149;

protected function fun_1150
  input Tpl.Text in_txt;
  input String in_mArg;
  input Tpl.Text in_a_arrayType;
  input DAE.Type in_a_iter_ty;
  input Tpl.Text in_a_stopVar;
  input Tpl.Text in_a_stepVar;
  input Tpl.Text in_a_firstIndex;
  input Tpl.Text in_a_endLoop;
  input Tpl.Text in_a_guardExp;
  input Tpl.Text in_a_iteratorName;
  input Tpl.Text in_a_loopVar;
  input Tpl.Text in_a_guardCond;
  input DAE.Exp in_a_iter_exp;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_arrayType, in_a_iter_ty, in_a_stopVar, in_a_stepVar, in_a_firstIndex, in_a_endLoop, in_a_guardExp, in_a_iteratorName, in_a_loopVar, in_a_guardCond, in_a_iter_exp)
    local
      Tpl.Text txt;
      Tpl.Text a_arrayType;
      DAE.Type a_iter_ty;
      Tpl.Text a_stopVar;
      Tpl.Text a_stepVar;
      Tpl.Text a_firstIndex;
      Tpl.Text a_endLoop;
      Tpl.Text a_guardExp;
      Tpl.Text a_iteratorName;
      Tpl.Text a_loopVar;
      Tpl.Text a_guardCond;
      DAE.Exp a_iter_exp;
      Boolean ret_0;

    case ( txt,
           "modelica_metatype",
           _,
           _,
           _,
           _,
           a_firstIndex,
           a_endLoop,
           a_guardExp,
           a_iteratorName,
           a_loopVar,
           a_guardCond,
           a_iter_exp )
      equation
        ret_0 = Expression.isMetaArray(a_iter_exp);
        txt = fun_1144(txt, ret_0, a_firstIndex, a_endLoop, a_guardExp, a_iteratorName, a_loopVar, a_guardCond);
      then txt;

    case ( txt,
           _,
           a_arrayType,
           a_iter_ty,
           a_stopVar,
           a_stepVar,
           a_firstIndex,
           a_endLoop,
           a_guardExp,
           a_iteratorName,
           a_loopVar,
           a_guardCond,
           a_iter_exp )
      equation
        txt = fun_1149(txt, a_iter_exp, a_arrayType, a_firstIndex, a_loopVar, a_iter_ty, a_endLoop, a_guardExp, a_stopVar, a_iteratorName, a_stepVar, a_guardCond);
      then txt;
  end match;
end fun_1150;

protected function lm_1151
  input Tpl.Text in_txt;
  input DAE.ReductionIterators in_items;
  input Tpl.Text in_a_endLoop;
  input Absyn.Path in_a_ri_path;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_rangeExpPre;
  input Tpl.Text in_a_tmpVarDecls;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_rangeExpPre;
  output Tpl.Text out_a_tmpVarDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_rangeExpPre, out_a_tmpVarDecls) :=
  match(in_txt, in_items, in_a_endLoop, in_a_ri_path, in_a_auxFunction, in_a_rangeExpPre, in_a_tmpVarDecls, in_a_context)
    local
      Tpl.Text txt;
      DAE.ReductionIterators rest;
      Tpl.Text a_endLoop;
      Absyn.Path a_ri_path;
      Tpl.Text a_auxFunction;
      Tpl.Text a_rangeExpPre;
      Tpl.Text a_tmpVarDecls;
      SimCodeFunction.Context a_context;
      DAE.Type i_iter_ty;
      Option<DAE.Exp> i_iter_guardExp;
      String i_iter_id;
      DAE.Exp i_iter_exp;
      String str_15;
      Tpl.Text l_guardExp;
      Tpl.Text l_guardCond;
      Tpl.Text l_isArrayWithLength;
      Tpl.Text l_rangeExp;
      Tpl.Text l_rangeExpStop;
      Tpl.Text l_rangeExpStep;
      Tpl.Text l_firstIndex;
      String str_7;
      Tpl.Text l_guardExpPre;
      Tpl.Text l_stopVar;
      Tpl.Text l_stepVar;
      Tpl.Text l_loopVar;
      Tpl.Text l_iteratorName;
      Tpl.Text l_arrayType;
      Tpl.Text l_identType;

    case ( txt,
           {},
           _,
           _,
           a_auxFunction,
           a_rangeExpPre,
           a_tmpVarDecls,
           _ )
      then (txt, a_auxFunction, a_rangeExpPre, a_tmpVarDecls);

    case ( txt,
           DAE.REDUCTIONITER(exp = i_iter_exp, id = i_iter_id, guardExp = i_iter_guardExp, ty = i_iter_ty) :: rest,
           a_endLoop,
           a_ri_path,
           a_auxFunction,
           a_rangeExpPre,
           a_tmpVarDecls,
           a_context )
      equation
        l_identType = expTypeFromExpModelica(Tpl.emptyTxt, i_iter_exp);
        l_arrayType = expTypeFromExpArray(Tpl.emptyTxt, i_iter_exp);
        l_iteratorName = contextIteratorName(Tpl.emptyTxt, i_iter_id, a_context);
        l_loopVar = fun_1118(Tpl.emptyTxt, i_iter_exp, l_iteratorName);
        (l_stepVar, a_tmpVarDecls) = fun_1119(Tpl.emptyTxt, i_iter_exp, a_tmpVarDecls, l_identType);
        (l_stopVar, a_tmpVarDecls) = fun_1120(Tpl.emptyTxt, i_iter_exp, a_tmpVarDecls, l_identType);
        l_guardExpPre = Tpl.emptyTxt;
        str_7 = Tpl.textString(l_identType);
        a_tmpVarDecls = fun_1122(a_tmpVarDecls, str_7, l_arrayType, i_iter_exp, l_loopVar);
        (l_firstIndex, a_tmpVarDecls) = fun_1125(Tpl.emptyTxt, i_iter_exp, a_tmpVarDecls, l_identType);
        (l_rangeExpStep, a_auxFunction, a_tmpVarDecls, a_rangeExpPre) = fun_1126(Tpl.emptyTxt, i_iter_exp, a_auxFunction, a_tmpVarDecls, a_rangeExpPre, a_context);
        (l_rangeExpStop, a_auxFunction, a_tmpVarDecls, a_rangeExpPre) = fun_1127(Tpl.emptyTxt, i_iter_exp, a_auxFunction, a_tmpVarDecls, a_rangeExpPre, a_context);
        (l_rangeExp, a_auxFunction, a_tmpVarDecls, a_rangeExpPre) = fun_1128(Tpl.emptyTxt, i_iter_exp, a_auxFunction, a_tmpVarDecls, a_rangeExpPre, a_context);
        a_rangeExpPre = fun_1129(a_rangeExpPre, l_rangeExpStep, l_stepVar);
        a_rangeExpPre = fun_1130(a_rangeExpPre, l_rangeExpStop, l_stopVar);
        a_rangeExpPre = Tpl.writeText(a_rangeExpPre, l_loopVar);
        a_rangeExpPre = Tpl.writeTok(a_rangeExpPre, Tpl.ST_STRING(" = "));
        a_rangeExpPre = Tpl.writeText(a_rangeExpPre, l_rangeExp);
        a_rangeExpPre = Tpl.writeTok(a_rangeExpPre, Tpl.ST_STRING(";"));
        a_rangeExpPre = Tpl.writeTok(a_rangeExpPre, Tpl.ST_NEW_LINE());
        a_rangeExpPre = fun_1132(a_rangeExpPre, l_rangeExpStop, i_iter_exp, l_stepVar);
        l_isArrayWithLength = fun_1134(Tpl.emptyTxt, l_rangeExpStop, a_ri_path);
        a_tmpVarDecls = fun_1135(a_tmpVarDecls, l_isArrayWithLength, l_iteratorName);
        a_rangeExpPre = fun_1137(a_rangeExpPre, i_iter_exp, l_firstIndex);
        (l_guardCond, a_auxFunction, a_tmpVarDecls, l_guardExpPre) = fun_1138(Tpl.emptyTxt, i_iter_guardExp, a_auxFunction, a_tmpVarDecls, l_guardExpPre, a_context);
        a_tmpVarDecls = Tpl.writeText(a_tmpVarDecls, l_identType);
        a_tmpVarDecls = Tpl.writeTok(a_tmpVarDecls, Tpl.ST_STRING(" "));
        a_tmpVarDecls = Tpl.writeText(a_tmpVarDecls, l_iteratorName);
        a_tmpVarDecls = Tpl.writeTok(a_tmpVarDecls, Tpl.ST_STRING(";"));
        a_tmpVarDecls = Tpl.writeTok(a_tmpVarDecls, Tpl.ST_NEW_LINE());
        a_rangeExpPre = fun_1140(a_rangeExpPre, l_isArrayWithLength, l_stepVar, l_firstIndex, l_stopVar, l_iteratorName);
        a_rangeExpPre = fun_1141(a_rangeExpPre, i_iter_exp, l_stepVar, l_rangeExp, l_iteratorName);
        l_guardExp = Tpl.writeText(Tpl.emptyTxt, l_guardExpPre);
        l_guardExp = Tpl.softNewLine(l_guardExp);
        l_guardExp = Tpl.writeTok(l_guardExp, Tpl.ST_STRING("if ("));
        l_guardExp = Tpl.writeText(l_guardExp, l_guardCond);
        l_guardExp = Tpl.writeTok(l_guardExp, Tpl.ST_LINE(") {\n"));
        l_guardExp = Tpl.pushBlock(l_guardExp, Tpl.BT_INDENT(2));
        l_guardExp = Tpl.writeText(l_guardExp, a_endLoop);
        l_guardExp = Tpl.writeTok(l_guardExp, Tpl.ST_STRING_LIST({
                                                  "--;\n",
                                                  "break;\n"
                                              }, true));
        l_guardExp = Tpl.popBlock(l_guardExp);
        l_guardExp = Tpl.writeTok(l_guardExp, Tpl.ST_STRING("}"));
        str_15 = Tpl.textString(l_identType);
        txt = fun_1150(txt, str_15, l_arrayType, i_iter_ty, l_stopVar, l_stepVar, l_firstIndex, a_endLoop, l_guardExp, l_iteratorName, l_loopVar, l_guardCond, i_iter_exp);
        (txt, a_auxFunction, a_rangeExpPre, a_tmpVarDecls) = lm_1151(txt, rest, a_endLoop, a_ri_path, a_auxFunction, a_rangeExpPre, a_tmpVarDecls, a_context);
      then (txt, a_auxFunction, a_rangeExpPre, a_tmpVarDecls);

    case ( txt,
           _ :: rest,
           a_endLoop,
           a_ri_path,
           a_auxFunction,
           a_rangeExpPre,
           a_tmpVarDecls,
           a_context )
      equation
        (txt, a_auxFunction, a_rangeExpPre, a_tmpVarDecls) = lm_1151(txt, rest, a_endLoop, a_ri_path, a_auxFunction, a_rangeExpPre, a_tmpVarDecls, a_context);
      then (txt, a_auxFunction, a_rangeExpPre, a_tmpVarDecls);
  end match;
end lm_1151;

protected function fun_1152
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_loopVar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_loopVar)
    local
      Tpl.Text txt;
      Tpl.Text a_loopVar;

    case ( txt,
           false,
           a_loopVar )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("listLength("));
        txt = Tpl.writeText(txt, a_loopVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           _,
           a_loopVar )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("arrayLength("));
        txt = Tpl.writeText(txt, a_loopVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;
  end match;
end fun_1152;

protected function fun_1153
  input Tpl.Text in_txt;
  input DAE.Exp in_a_iter_exp;
  input Tpl.Text in_a_loopVar;
  input Tpl.Text in_a_iteratorName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_iter_exp, in_a_loopVar, in_a_iteratorName)
    local
      Tpl.Text txt;
      Tpl.Text a_loopVar;
      Tpl.Text a_iteratorName;

    case ( txt,
           DAE.RANGE(ty = _),
           _,
           a_iteratorName )
      equation
        txt = Tpl.writeText(txt, a_iteratorName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_length"));
      then txt;

    case ( txt,
           _,
           a_loopVar,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("size_of_dimension_base_array("));
        txt = Tpl.writeText(txt, a_loopVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", 1)"));
      then txt;
  end match;
end fun_1153;

protected function fun_1154
  input Tpl.Text in_txt;
  input String in_mArg;
  input Tpl.Text in_a_iteratorName;
  input Tpl.Text in_a_loopVar;
  input DAE.Exp in_a_iter_exp;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_iteratorName, in_a_loopVar, in_a_iter_exp)
    local
      Tpl.Text txt;
      Tpl.Text a_iteratorName;
      Tpl.Text a_loopVar;
      DAE.Exp a_iter_exp;
      Boolean ret_0;

    case ( txt,
           "modelica_metatype",
           _,
           a_loopVar,
           a_iter_exp )
      equation
        ret_0 = Expression.isMetaArray(a_iter_exp);
        txt = fun_1152(txt, ret_0, a_loopVar);
      then txt;

    case ( txt,
           _,
           a_iteratorName,
           a_loopVar,
           a_iter_exp )
      equation
        txt = fun_1153(txt, a_iter_exp, a_loopVar, a_iteratorName);
      then txt;
  end match;
end fun_1154;

protected function lm_1155
  input Tpl.Text in_txt;
  input DAE.ReductionIterators in_items;
  input Tpl.Text in_a_length;
  input Tpl.Text in_a_rangeExpPre;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_rangeExpPre;
algorithm
  (out_txt, out_a_rangeExpPre) :=
  match(in_txt, in_items, in_a_length, in_a_rangeExpPre, in_a_context)
    local
      Tpl.Text txt;
      DAE.ReductionIterators rest;
      Tpl.Text a_length;
      Tpl.Text a_rangeExpPre;
      SimCodeFunction.Context a_context;
      DAE.Exp i_iter_exp;
      String i_iter_id;
      String str_3;
      Tpl.Text l_identType;
      Tpl.Text l_loopVar;
      Tpl.Text l_iteratorName;

    case ( txt,
           {},
           _,
           a_rangeExpPre,
           _ )
      then (txt, a_rangeExpPre);

    case ( txt,
           DAE.REDUCTIONITER(id = i_iter_id, exp = i_iter_exp) :: rest,
           a_length,
           a_rangeExpPre,
           a_context )
      equation
        l_iteratorName = contextIteratorName(Tpl.emptyTxt, i_iter_id, a_context);
        l_loopVar = Tpl.writeText(Tpl.emptyTxt, l_iteratorName);
        l_loopVar = Tpl.writeTok(l_loopVar, Tpl.ST_STRING("_loopVar"));
        l_identType = expTypeFromExpModelica(Tpl.emptyTxt, i_iter_exp);
        a_rangeExpPre = Tpl.writeText(a_rangeExpPre, a_length);
        a_rangeExpPre = Tpl.writeTok(a_rangeExpPre, Tpl.ST_STRING(" = modelica_integer_max("));
        a_rangeExpPre = Tpl.writeText(a_rangeExpPre, a_length);
        a_rangeExpPre = Tpl.writeTok(a_rangeExpPre, Tpl.ST_STRING(","));
        str_3 = Tpl.textString(l_identType);
        a_rangeExpPre = fun_1154(a_rangeExpPre, str_3, l_iteratorName, l_loopVar, i_iter_exp);
        a_rangeExpPre = Tpl.writeTok(a_rangeExpPre, Tpl.ST_STRING(");"));
        a_rangeExpPre = Tpl.writeTok(a_rangeExpPre, Tpl.ST_NEW_LINE());
        (txt, a_rangeExpPre) = lm_1155(txt, rest, a_length, a_rangeExpPre, a_context);
      then (txt, a_rangeExpPre);

    case ( txt,
           _ :: rest,
           a_length,
           a_rangeExpPre,
           a_context )
      equation
        (txt, a_rangeExpPre) = lm_1155(txt, rest, a_length, a_rangeExpPre, a_context);
      then (txt, a_rangeExpPre);
  end match;
end lm_1155;

protected function fun_1156
  input Tpl.Text in_txt;
  input DAE.Dimension in_a_dim;
  input DAE.Exp in_a_r_expr;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_tmpVarDecls;
  input Tpl.Text in_a_rangeExpPre;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_tmpVarDecls;
  output Tpl.Text out_a_rangeExpPre;
algorithm
  (out_txt, out_a_auxFunction, out_a_tmpVarDecls, out_a_rangeExpPre) :=
  match(in_txt, in_a_dim, in_a_r_expr, in_a_auxFunction, in_a_tmpVarDecls, in_a_rangeExpPre, in_a_context)
    local
      Tpl.Text txt;
      DAE.Exp a_r_expr;
      Tpl.Text a_auxFunction;
      Tpl.Text a_tmpVarDecls;
      Tpl.Text a_rangeExpPre;
      SimCodeFunction.Context a_context;
      DAE.Exp i_e;
      Integer i_size;
      Integer i_integer;
      Tpl.Text txt_0;
      String ret_1;
      DAE.Type ret_0;

    case ( txt,
           DAE.DIM_INTEGER(integer = i_integer),
           _,
           a_auxFunction,
           a_tmpVarDecls,
           a_rangeExpPre,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", (_index_t)"));
        txt = Tpl.writeStr(txt, intString(i_integer));
      then (txt, a_auxFunction, a_tmpVarDecls, a_rangeExpPre);

    case ( txt,
           DAE.DIM_BOOLEAN(),
           _,
           a_auxFunction,
           a_tmpVarDecls,
           a_rangeExpPre,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", (_index_t)2"));
      then (txt, a_auxFunction, a_tmpVarDecls, a_rangeExpPre);

    case ( txt,
           DAE.DIM_ENUM(size = i_size),
           _,
           a_auxFunction,
           a_tmpVarDecls,
           a_rangeExpPre,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", (_index_t)"));
        txt = Tpl.writeStr(txt, intString(i_size));
      then (txt, a_auxFunction, a_tmpVarDecls, a_rangeExpPre);

    case ( txt,
           DAE.DIM_EXP(exp = i_e),
           _,
           a_auxFunction,
           a_tmpVarDecls,
           a_rangeExpPre,
           a_context )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", (_index_t)"));
        (txt, a_rangeExpPre, a_tmpVarDecls, a_auxFunction) = daeExp(txt, i_e, a_context, a_rangeExpPre, a_tmpVarDecls, a_auxFunction);
      then (txt, a_auxFunction, a_tmpVarDecls, a_rangeExpPre);

    case ( txt,
           _,
           a_r_expr,
           a_auxFunction,
           a_tmpVarDecls,
           a_rangeExpPre,
           _ )
      equation
        txt_0 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("array reduction unable to generate code for element of unknown dimension sizes; type "));
        ret_0 = Expression.typeof(a_r_expr);
        ret_1 = Types.unparseType(ret_0);
        txt_0 = Tpl.writeStr(txt_0, ret_1);
        txt_0 = Tpl.writeTok(txt_0, Tpl.ST_STRING(": "));
        txt_0 = ExpressionDumpTpl.dumpExp(txt_0, a_r_expr, "\"");
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 7218, 24), Tpl.textString(txt_0));
      then (txt, a_auxFunction, a_tmpVarDecls, a_rangeExpPre);
  end match;
end fun_1156;

protected function lm_1157
  input Tpl.Text in_txt;
  input DAE.Dimensions in_items;
  input DAE.Exp in_a_r_expr;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_tmpVarDecls;
  input Tpl.Text in_a_rangeExpPre;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_tmpVarDecls;
  output Tpl.Text out_a_rangeExpPre;
algorithm
  (out_txt, out_a_auxFunction, out_a_tmpVarDecls, out_a_rangeExpPre) :=
  match(in_txt, in_items, in_a_r_expr, in_a_auxFunction, in_a_tmpVarDecls, in_a_rangeExpPre, in_a_context)
    local
      Tpl.Text txt;
      DAE.Dimensions rest;
      DAE.Exp a_r_expr;
      Tpl.Text a_auxFunction;
      Tpl.Text a_tmpVarDecls;
      Tpl.Text a_rangeExpPre;
      SimCodeFunction.Context a_context;
      DAE.Dimension i_dim;

    case ( txt,
           {},
           _,
           a_auxFunction,
           a_tmpVarDecls,
           a_rangeExpPre,
           _ )
      then (txt, a_auxFunction, a_tmpVarDecls, a_rangeExpPre);

    case ( txt,
           i_dim :: rest,
           a_r_expr,
           a_auxFunction,
           a_tmpVarDecls,
           a_rangeExpPre,
           a_context )
      equation
        (txt, a_auxFunction, a_tmpVarDecls, a_rangeExpPre) = fun_1156(txt, i_dim, a_r_expr, a_auxFunction, a_tmpVarDecls, a_rangeExpPre, a_context);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_tmpVarDecls, a_rangeExpPre) = lm_1157(txt, rest, a_r_expr, a_auxFunction, a_tmpVarDecls, a_rangeExpPre, a_context);
      then (txt, a_auxFunction, a_tmpVarDecls, a_rangeExpPre);
  end match;
end lm_1157;

protected function fun_1158
  input Tpl.Text in_txt;
  input DAE.Type in_mArg;
  input Tpl.Text in_a_arrayTypeResult;
  input DAE.Exp in_a_r_expr;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_tmpVarDecls;
  input Tpl.Text in_a_rangeExpPre;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_length;
  input Tpl.Text in_a_res;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_tmpVarDecls;
  output Tpl.Text out_a_rangeExpPre;
algorithm
  (out_txt, out_a_auxFunction, out_a_tmpVarDecls, out_a_rangeExpPre) :=
  match(in_txt, in_mArg, in_a_arrayTypeResult, in_a_r_expr, in_a_auxFunction, in_a_tmpVarDecls, in_a_rangeExpPre, in_a_context, in_a_length, in_a_res)
    local
      Tpl.Text txt;
      Tpl.Text a_arrayTypeResult;
      DAE.Exp a_r_expr;
      Tpl.Text a_auxFunction;
      Tpl.Text a_tmpVarDecls;
      Tpl.Text a_rangeExpPre;
      SimCodeFunction.Context a_context;
      Tpl.Text a_length;
      Tpl.Text a_res;
      DAE.Dimensions i_dims;
      ClassInf.State i_record__state;
      Integer ret_4;
      Integer ret_3;
      Tpl.Text l_dimSizes;
      Absyn.Path ret_1;
      Tpl.Text l_rec__name;

    case ( txt,
           DAE.T_COMPLEX(complexClassType = i_record__state),
           _,
           _,
           a_auxFunction,
           a_tmpVarDecls,
           a_rangeExpPre,
           _,
           a_length,
           a_res )
      equation
        ret_1 = ClassInf.getStateName(i_record__state);
        l_rec__name = CodegenUtil.underscorePath(Tpl.emptyTxt, ret_1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("alloc_generic_array(&"));
        txt = Tpl.writeText(txt, a_res);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", sizeof("));
        txt = Tpl.writeText(txt, l_rec__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("), 1, (_index_t)"));
        txt = Tpl.writeText(txt, a_length);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then (txt, a_auxFunction, a_tmpVarDecls, a_rangeExpPre);

    case ( txt,
           DAE.T_ARRAY(dims = i_dims),
           a_arrayTypeResult,
           a_r_expr,
           a_auxFunction,
           a_tmpVarDecls,
           a_rangeExpPre,
           a_context,
           a_length,
           a_res )
      equation
        l_dimSizes = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_dimSizes, a_auxFunction, a_tmpVarDecls, a_rangeExpPre) = lm_1157(l_dimSizes, i_dims, a_r_expr, a_auxFunction, a_tmpVarDecls, a_rangeExpPre, a_context);
        l_dimSizes = Tpl.popIter(l_dimSizes);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("alloc_"));
        txt = Tpl.writeText(txt, a_arrayTypeResult);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(&"));
        txt = Tpl.writeText(txt, a_res);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        ret_3 = listLength(i_dims);
        ret_4 = intAdd(1, ret_3);
        txt = Tpl.writeStr(txt, intString(ret_4));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_length);
        txt = Tpl.writeText(txt, l_dimSizes);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then (txt, a_auxFunction, a_tmpVarDecls, a_rangeExpPre);

    case ( txt,
           _,
           a_arrayTypeResult,
           _,
           a_auxFunction,
           a_tmpVarDecls,
           a_rangeExpPre,
           _,
           a_length,
           a_res )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("simple_alloc_1d_"));
        txt = Tpl.writeText(txt, a_arrayTypeResult);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(&"));
        txt = Tpl.writeText(txt, a_res);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, a_length);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then (txt, a_auxFunction, a_tmpVarDecls, a_rangeExpPre);
  end match;
end fun_1158;

protected function fun_1159
  input Tpl.Text in_txt;
  input Tpl.Text in_a_foundFirst;
  input Absyn.Path in_a_ri_path;
  input Tpl.Text in_a_defaultValue;
  input Tpl.Text in_a_res;
  input Tpl.Text in_a_preDefault;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_foundFirst, in_a_ri_path, in_a_defaultValue, in_a_res, in_a_preDefault)
    local
      Tpl.Text txt;
      Absyn.Path a_ri_path;
      Tpl.Text a_defaultValue;
      Tpl.Text a_res;
      Tpl.Text a_preDefault;
      Tpl.Text i_foundFirst;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           _,
           a_defaultValue,
           a_res,
           a_preDefault )
      equation
        txt = Tpl.writeText(txt, a_preDefault);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, a_res);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, a_defaultValue);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("; /* defaultValue */"));
      then txt;

    case ( txt,
           i_foundFirst,
           a_ri_path,
           _,
           _,
           _ )
      equation
        txt = Tpl.writeText(txt, i_foundFirst);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = 0; /* "));
        txt = CodegenUtil.dotPath(txt, a_ri_path);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" lacks default-value */"));
      then txt;
  end match;
end fun_1159;

protected function fun_1160
  input Tpl.Text in_txt;
  input Absyn.Path in_a_ri_path;
  input Tpl.Text in_a_defaultValue;
  input Tpl.Text in_a_preDefault;
  input Tpl.Text in_a_foundFirst;
  input Tpl.Text in_a_arrayTypeResult;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_res;
  input DAE.Exp in_a_r_expr;
  input Tpl.Text in_a_arrIndex;
  input SimCodeFunction.Context in_a_context;
  input DAE.ReductionIterators in_a_iterators;
  input Tpl.Text in_a_rangeExpPre;
  input Tpl.Text in_a_tmpVarDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_rangeExpPre;
  output Tpl.Text out_a_tmpVarDecls;
algorithm
  (out_txt, out_a_auxFunction, out_a_rangeExpPre, out_a_tmpVarDecls) :=
  match(in_txt, in_a_ri_path, in_a_defaultValue, in_a_preDefault, in_a_foundFirst, in_a_arrayTypeResult, in_a_auxFunction, in_a_res, in_a_r_expr, in_a_arrIndex, in_a_context, in_a_iterators, in_a_rangeExpPre, in_a_tmpVarDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_defaultValue;
      Tpl.Text a_preDefault;
      Tpl.Text a_foundFirst;
      Tpl.Text a_arrayTypeResult;
      Tpl.Text a_auxFunction;
      Tpl.Text a_res;
      DAE.Exp a_r_expr;
      Tpl.Text a_arrIndex;
      SimCodeFunction.Context a_context;
      DAE.ReductionIterators a_iterators;
      Tpl.Text a_rangeExpPre;
      Tpl.Text a_tmpVarDecls;
      Absyn.Path i_ri_path;
      DAE.Type ret_2;
      Tpl.Text l_0__;
      Tpl.Text l_length;

    case ( txt,
           Absyn.IDENT(name = "array"),
           _,
           _,
           _,
           a_arrayTypeResult,
           a_auxFunction,
           a_res,
           a_r_expr,
           a_arrIndex,
           a_context,
           a_iterators,
           a_rangeExpPre,
           a_tmpVarDecls )
      equation
        (l_length, a_tmpVarDecls) = tempDecl(Tpl.emptyTxt, "modelica_integer", a_tmpVarDecls);
        a_rangeExpPre = Tpl.writeText(a_rangeExpPre, l_length);
        a_rangeExpPre = Tpl.writeTok(a_rangeExpPre, Tpl.ST_STRING(" = 0;"));
        a_rangeExpPre = Tpl.writeTok(a_rangeExpPre, Tpl.ST_NEW_LINE());
        (l_0__, a_rangeExpPre) = lm_1155(Tpl.emptyTxt, a_iterators, l_length, a_rangeExpPre, a_context);
        txt = Tpl.writeText(txt, a_arrIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" = 1;\n"));
        ret_2 = Expression.typeof(a_r_expr);
        (txt, a_auxFunction, a_tmpVarDecls, a_rangeExpPre) = fun_1158(txt, ret_2, a_arrayTypeResult, a_r_expr, a_auxFunction, a_tmpVarDecls, a_rangeExpPre, a_context, l_length, a_res);
      then (txt, a_auxFunction, a_rangeExpPre, a_tmpVarDecls);

    case ( txt,
           i_ri_path,
           a_defaultValue,
           a_preDefault,
           a_foundFirst,
           _,
           a_auxFunction,
           a_res,
           _,
           _,
           _,
           _,
           a_rangeExpPre,
           a_tmpVarDecls )
      equation
        txt = fun_1159(txt, a_foundFirst, i_ri_path, a_defaultValue, a_res, a_preDefault);
      then (txt, a_auxFunction, a_rangeExpPre, a_tmpVarDecls);
  end match;
end fun_1160;

protected function fun_1161
  input Tpl.Text in_txt;
  input DAE.ReductionIterators in_a_iterators;
  input Tpl.Text in_a_endLoop;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_iterators, in_a_endLoop)
    local
      Tpl.Text txt;
      Tpl.Text a_endLoop;
      DAE.ReductionIterators i_iterators;
      Integer ret_0;

    case ( txt,
           (i_iterators as _ :: _),
           a_endLoop )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("else if ("));
        txt = Tpl.writeText(txt, a_endLoop);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" == "));
        ret_0 = listLength(i_iterators);
        txt = Tpl.writeStr(txt, intString(ret_0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ") {\n",
                                    "  break;\n",
                                    "} else {\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = generateThrow(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_1161;

protected function fun_1162
  input Tpl.Text in_txt;
  input Tpl.Text in_a_resTail;
  input Tpl.Text in_a_res;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_resTail, in_a_res)
    local
      Tpl.Text txt;
      Tpl.Text a_res;
      Tpl.Text i_resTail;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           _ )
      then txt;

    case ( txt,
           i_resTail,
           a_res )
      equation
        txt = Tpl.writeText(txt, i_resTail);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = &"));
        txt = Tpl.writeText(txt, a_res);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_1162;

protected function fun_1163
  input Tpl.Text in_txt;
  input Tpl.Text in_a_foundFirst;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_foundFirst)
    local
      Tpl.Text txt;
      Tpl.Text i_foundFirst;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}) )
      then txt;

    case ( txt,
           i_foundFirst )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if (!"));
        txt = Tpl.writeText(txt, i_foundFirst);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") "));
        txt = generateThrow(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_1163;

protected function fun_1164
  input Tpl.Text in_txt;
  input Tpl.Text in_a_resTail;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_resTail)
    local
      Tpl.Text txt;
      Tpl.Text i_resTail;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}) )
      then txt;

    case ( txt,
           i_resTail )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("*"));
        txt = Tpl.writeText(txt, i_resTail);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = mmc_mk_nil();"));
      then txt;
  end match;
end fun_1164;

public function daeExpReduction
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_exp, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Exp i_exp;
      DAE.ReductionIterators i_iterators;
      Option<DAE.Exp> i_ri_foldExp;
      DAE.Exp i_r_expr;
      String i_ri_foldName;
      String i_ri_resultName;
      Option<Values.Value> i_ri_defaultValue;
      Absyn.Path i_ri_path;
      DAE.Exp i_r;
      Tpl.Text txt_31;
      Integer ret_30;
      DAE.Type ret_29;
      DAE.ComponentRef ret_28;
      DAE.ComponentRef ret_27;
      DAE.Type ret_26;
      Integer ret_25;
      Tpl.Text l_loop;
      Tpl.Text l_firstValue;
      Tpl.Text l_loopHeadIter;
      Tpl.Text l_endLoop;
      Tpl.Text l_foldExp;
      Tpl.Text l_reductionBodyExprWork;
      DAE.Type ret_18;
      Tpl.Text l_bodyExprType;
      DAE.ComponentRef ret_16;
      Tpl.Text l_reductionBodyExpr;
      Tpl.Text l_defaultValue;
      Tpl.Text l_resTail;
      Tpl.Text l_preDefault;
      Tpl.Text l_resTmp;
      DAE.ComponentRef ret_10;
      Tpl.Text l_res;
      DAE.Type ret_8;
      Tpl.Text l_resType;
      Tpl.Text l_foundFirst;
      Tpl.Text l_arrIndex;
      Tpl.Text l_arrayTypeResult;
      Tpl.Text l_rangeExpPre;
      Tpl.Text l_bodyExpPre;
      Tpl.Text l_tmpExpPre;
      Tpl.Text l_tmpVarDecls;

    case ( txt,
           (i_r as DAE.REDUCTION(reductionInfo = DAE.REDUCTIONINFO(iterType = Absyn.THREAD(), path = i_ri_path, defaultValue = i_ri_defaultValue, resultName = i_ri_resultName, foldName = i_ri_foldName, foldExp = i_ri_foldExp), iterators = i_iterators, expr = i_r_expr)),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        l_tmpVarDecls = Tpl.emptyTxt;
        l_tmpExpPre = Tpl.emptyTxt;
        l_bodyExpPre = Tpl.emptyTxt;
        l_rangeExpPre = Tpl.emptyTxt;
        l_arrayTypeResult = expTypeFromExpArray(Tpl.emptyTxt, i_r);
        (l_arrIndex, l_tmpVarDecls) = fun_1049(Tpl.emptyTxt, i_ri_path, l_tmpVarDecls);
        (l_foundFirst, l_tmpVarDecls) = fun_1051(Tpl.emptyTxt, i_ri_path, l_tmpVarDecls, i_ri_defaultValue);
        ret_8 = Expression.typeof(i_r);
        l_resType = expTypeArrayIf(Tpl.emptyTxt, ret_8);
        ret_10 = ComponentReference.makeUntypedCrefIdent(i_ri_resultName);
        (l_res, a_preExp, a_varDecls, a_auxFunction) = contextCref(Tpl.emptyTxt, ret_10, a_context, a_preExp, a_varDecls, a_auxFunction);
        l_tmpVarDecls = Tpl.writeText(l_tmpVarDecls, l_resType);
        l_tmpVarDecls = Tpl.writeTok(l_tmpVarDecls, Tpl.ST_STRING(" "));
        l_tmpVarDecls = Tpl.writeText(l_tmpVarDecls, l_res);
        l_tmpVarDecls = Tpl.writeTok(l_tmpVarDecls, Tpl.ST_STRING(";"));
        l_tmpVarDecls = Tpl.writeTok(l_tmpVarDecls, Tpl.ST_NEW_LINE());
        (l_resTmp, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(l_resType), a_varDecls);
        l_preDefault = Tpl.emptyTxt;
        (l_resTail, l_tmpVarDecls) = fun_1052(Tpl.emptyTxt, i_ri_path, l_tmpVarDecls);
        (l_defaultValue, a_auxFunction, l_tmpVarDecls, l_preDefault) = fun_1054(Tpl.emptyTxt, i_ri_path, a_auxFunction, l_tmpVarDecls, l_preDefault, a_context, i_ri_defaultValue);
        ret_16 = ComponentReference.makeUntypedCrefIdent(i_ri_foldName);
        (l_reductionBodyExpr, a_preExp, a_varDecls, a_auxFunction) = contextCref(Tpl.emptyTxt, ret_16, a_context, a_preExp, a_varDecls, a_auxFunction);
        ret_18 = Expression.typeof(i_r_expr);
        l_bodyExprType = expTypeArrayIf(Tpl.emptyTxt, ret_18);
        (l_reductionBodyExprWork, l_bodyExpPre, l_tmpVarDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_r_expr, a_context, l_bodyExpPre, l_tmpVarDecls, a_auxFunction);
        l_tmpVarDecls = Tpl.writeText(l_tmpVarDecls, l_bodyExprType);
        l_tmpVarDecls = Tpl.writeTok(l_tmpVarDecls, Tpl.ST_STRING(" "));
        l_tmpVarDecls = Tpl.writeText(l_tmpVarDecls, l_reductionBodyExpr);
        l_tmpVarDecls = Tpl.writeTok(l_tmpVarDecls, Tpl.ST_STRING(";"));
        l_tmpVarDecls = Tpl.writeTok(l_tmpVarDecls, Tpl.ST_NEW_LINE());
        l_bodyExpPre = Tpl.writeText(l_bodyExpPre, l_reductionBodyExpr);
        l_bodyExpPre = Tpl.writeTok(l_bodyExpPre, Tpl.ST_STRING(" = "));
        l_bodyExpPre = Tpl.writeText(l_bodyExpPre, l_reductionBodyExprWork);
        l_bodyExpPre = Tpl.writeTok(l_bodyExpPre, Tpl.ST_STRING(";"));
        l_bodyExpPre = Tpl.writeTok(l_bodyExpPre, Tpl.ST_NEW_LINE());
        (l_foldExp, a_auxFunction, l_tmpVarDecls, l_bodyExpPre, a_varDecls) = fun_1059(Tpl.emptyTxt, i_ri_path, l_foundFirst, a_auxFunction, l_tmpVarDecls, l_bodyExpPre, a_context, i_ri_foldExp, l_arrayTypeResult, a_varDecls, l_arrIndex, i_r_expr, l_res, l_reductionBodyExpr, l_resTail);
        (l_endLoop, l_tmpVarDecls) = tempDecl(Tpl.emptyTxt, "modelica_integer", l_tmpVarDecls);
        (l_loopHeadIter, a_auxFunction, l_rangeExpPre, l_tmpVarDecls) = lm_1093(Tpl.emptyTxt, i_iterators, l_endLoop, i_ri_path, a_auxFunction, l_rangeExpPre, l_tmpVarDecls, a_context);
        (l_firstValue, a_auxFunction, l_rangeExpPre, l_tmpVarDecls) = fun_1102(Tpl.emptyTxt, i_ri_path, l_defaultValue, l_preDefault, l_foundFirst, l_arrayTypeResult, a_auxFunction, l_res, i_r_expr, l_arrIndex, a_context, i_iterators, l_rangeExpPre, l_tmpVarDecls);
        l_loop = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_LINE("while(1) {\n"));
        l_loop = Tpl.pushBlock(l_loop, Tpl.BT_INDENT(2));
        l_loop = Tpl.writeText(l_loop, l_endLoop);
        l_loop = Tpl.writeTok(l_loop, Tpl.ST_STRING(" = "));
        ret_25 = listLength(i_iterators);
        l_loop = Tpl.writeStr(l_loop, intString(ret_25));
        l_loop = Tpl.writeTok(l_loop, Tpl.ST_LINE(";\n"));
        l_loop = Tpl.writeText(l_loop, l_loopHeadIter);
        l_loop = Tpl.softNewLine(l_loop);
        l_loop = Tpl.writeTok(l_loop, Tpl.ST_STRING("if ("));
        l_loop = Tpl.writeText(l_loop, l_endLoop);
        l_loop = Tpl.writeTok(l_loop, Tpl.ST_LINE(" == 0) {\n"));
        l_loop = Tpl.pushBlock(l_loop, Tpl.BT_INDENT(2));
        l_loop = Tpl.writeText(l_loop, l_bodyExpPre);
        l_loop = Tpl.softNewLine(l_loop);
        l_loop = Tpl.writeText(l_loop, l_foldExp);
        l_loop = Tpl.softNewLine(l_loop);
        l_loop = Tpl.popBlock(l_loop);
        l_loop = Tpl.writeTok(l_loop, Tpl.ST_STRING("} "));
        l_loop = fun_1103(l_loop, i_iterators, l_endLoop);
        l_loop = Tpl.softNewLine(l_loop);
        l_loop = Tpl.popBlock(l_loop);
        l_loop = Tpl.writeTok(l_loop, Tpl.ST_STRING("}"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_LINE("{\n"));
        a_preExp = Tpl.pushBlock(a_preExp, Tpl.BT_INDENT(2));
        a_preExp = Tpl.writeText(a_preExp, l_tmpVarDecls);
        a_preExp = Tpl.softNewLine(a_preExp);
        a_preExp = Tpl.writeText(a_preExp, l_rangeExpPre);
        a_preExp = Tpl.softNewLine(a_preExp);
        a_preExp = Tpl.writeText(a_preExp, l_firstValue);
        a_preExp = Tpl.softNewLine(a_preExp);
        a_preExp = fun_1104(a_preExp, l_resTail, l_res);
        a_preExp = Tpl.softNewLine(a_preExp);
        a_preExp = Tpl.writeText(a_preExp, l_loop);
        a_preExp = Tpl.softNewLine(a_preExp);
        a_preExp = fun_1105(a_preExp, l_foundFirst);
        a_preExp = Tpl.softNewLine(a_preExp);
        a_preExp = fun_1106(a_preExp, l_resTail);
        a_preExp = Tpl.softNewLine(a_preExp);
        a_preExp = Tpl.writeText(a_preExp, l_resTmp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = "));
        a_preExp = Tpl.writeText(a_preExp, l_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_LINE(";\n"));
        a_preExp = Tpl.popBlock(a_preExp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("}"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_resTmp);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           (i_r as DAE.REDUCTION(reductionInfo = DAE.REDUCTIONINFO(iterType = Absyn.COMBINE(), path = i_ri_path, defaultValue = i_ri_defaultValue, resultName = i_ri_resultName, foldName = i_ri_foldName, foldExp = i_ri_foldExp), iterators = (i_iterators as {_}), expr = i_r_expr)),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        l_tmpVarDecls = Tpl.emptyTxt;
        l_tmpExpPre = Tpl.emptyTxt;
        l_bodyExpPre = Tpl.emptyTxt;
        l_rangeExpPre = Tpl.emptyTxt;
        l_arrayTypeResult = expTypeFromExpArray(Tpl.emptyTxt, i_r);
        (l_arrIndex, l_tmpVarDecls) = fun_1107(Tpl.emptyTxt, i_ri_path, l_tmpVarDecls);
        (l_foundFirst, l_tmpVarDecls) = fun_1109(Tpl.emptyTxt, i_ri_path, l_tmpVarDecls, i_ri_defaultValue);
        ret_26 = Expression.typeof(i_r);
        l_resType = expTypeArrayIf(Tpl.emptyTxt, ret_26);
        ret_27 = ComponentReference.makeUntypedCrefIdent(i_ri_resultName);
        (l_res, a_preExp, a_varDecls, a_auxFunction) = contextCref(Tpl.emptyTxt, ret_27, a_context, a_preExp, a_varDecls, a_auxFunction);
        l_tmpVarDecls = Tpl.writeText(l_tmpVarDecls, l_resType);
        l_tmpVarDecls = Tpl.writeTok(l_tmpVarDecls, Tpl.ST_STRING(" "));
        l_tmpVarDecls = Tpl.writeText(l_tmpVarDecls, l_res);
        l_tmpVarDecls = Tpl.writeTok(l_tmpVarDecls, Tpl.ST_STRING(";"));
        l_tmpVarDecls = Tpl.writeTok(l_tmpVarDecls, Tpl.ST_NEW_LINE());
        (l_resTmp, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(l_resType), a_varDecls);
        l_preDefault = Tpl.emptyTxt;
        (l_resTail, l_tmpVarDecls) = fun_1110(Tpl.emptyTxt, i_ri_path, l_tmpVarDecls);
        (l_defaultValue, a_auxFunction, l_tmpVarDecls, l_preDefault) = fun_1112(Tpl.emptyTxt, i_ri_path, a_auxFunction, l_tmpVarDecls, l_preDefault, a_context, i_ri_defaultValue);
        ret_28 = ComponentReference.makeUntypedCrefIdent(i_ri_foldName);
        (l_reductionBodyExpr, a_preExp, a_varDecls, a_auxFunction) = contextCref(Tpl.emptyTxt, ret_28, a_context, a_preExp, a_varDecls, a_auxFunction);
        ret_29 = Expression.typeof(i_r_expr);
        l_bodyExprType = expTypeArrayIf(Tpl.emptyTxt, ret_29);
        (l_reductionBodyExprWork, l_bodyExpPre, l_tmpVarDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_r_expr, a_context, l_bodyExpPre, l_tmpVarDecls, a_auxFunction);
        l_tmpVarDecls = Tpl.writeText(l_tmpVarDecls, l_bodyExprType);
        l_tmpVarDecls = Tpl.writeTok(l_tmpVarDecls, Tpl.ST_STRING(" "));
        l_tmpVarDecls = Tpl.writeText(l_tmpVarDecls, l_reductionBodyExpr);
        l_tmpVarDecls = Tpl.writeTok(l_tmpVarDecls, Tpl.ST_STRING(";"));
        l_tmpVarDecls = Tpl.writeTok(l_tmpVarDecls, Tpl.ST_NEW_LINE());
        l_bodyExpPre = Tpl.writeText(l_bodyExpPre, l_reductionBodyExpr);
        l_bodyExpPre = Tpl.writeTok(l_bodyExpPre, Tpl.ST_STRING(" = "));
        l_bodyExpPre = Tpl.writeText(l_bodyExpPre, l_reductionBodyExprWork);
        l_bodyExpPre = Tpl.writeTok(l_bodyExpPre, Tpl.ST_STRING(";"));
        l_bodyExpPre = Tpl.writeTok(l_bodyExpPre, Tpl.ST_NEW_LINE());
        (l_foldExp, a_auxFunction, l_tmpVarDecls, l_bodyExpPre, a_varDecls) = fun_1117(Tpl.emptyTxt, i_ri_path, l_foundFirst, a_auxFunction, l_tmpVarDecls, l_bodyExpPre, a_context, i_ri_foldExp, l_arrayTypeResult, a_varDecls, l_arrIndex, i_r_expr, l_res, l_reductionBodyExpr, l_resTail);
        (l_endLoop, l_tmpVarDecls) = tempDecl(Tpl.emptyTxt, "modelica_integer", l_tmpVarDecls);
        (l_loopHeadIter, a_auxFunction, l_rangeExpPre, l_tmpVarDecls) = lm_1151(Tpl.emptyTxt, i_iterators, l_endLoop, i_ri_path, a_auxFunction, l_rangeExpPre, l_tmpVarDecls, a_context);
        (l_firstValue, a_auxFunction, l_rangeExpPre, l_tmpVarDecls) = fun_1160(Tpl.emptyTxt, i_ri_path, l_defaultValue, l_preDefault, l_foundFirst, l_arrayTypeResult, a_auxFunction, l_res, i_r_expr, l_arrIndex, a_context, i_iterators, l_rangeExpPre, l_tmpVarDecls);
        l_loop = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_LINE("while(1) {\n"));
        l_loop = Tpl.pushBlock(l_loop, Tpl.BT_INDENT(2));
        l_loop = Tpl.writeText(l_loop, l_endLoop);
        l_loop = Tpl.writeTok(l_loop, Tpl.ST_STRING(" = "));
        ret_30 = listLength(i_iterators);
        l_loop = Tpl.writeStr(l_loop, intString(ret_30));
        l_loop = Tpl.writeTok(l_loop, Tpl.ST_LINE(";\n"));
        l_loop = Tpl.writeText(l_loop, l_loopHeadIter);
        l_loop = Tpl.softNewLine(l_loop);
        l_loop = Tpl.writeTok(l_loop, Tpl.ST_STRING("if ("));
        l_loop = Tpl.writeText(l_loop, l_endLoop);
        l_loop = Tpl.writeTok(l_loop, Tpl.ST_LINE(" == 0) {\n"));
        l_loop = Tpl.pushBlock(l_loop, Tpl.BT_INDENT(2));
        l_loop = Tpl.writeText(l_loop, l_bodyExpPre);
        l_loop = Tpl.softNewLine(l_loop);
        l_loop = Tpl.writeText(l_loop, l_foldExp);
        l_loop = Tpl.softNewLine(l_loop);
        l_loop = Tpl.popBlock(l_loop);
        l_loop = Tpl.writeTok(l_loop, Tpl.ST_STRING("} "));
        l_loop = fun_1161(l_loop, i_iterators, l_endLoop);
        l_loop = Tpl.softNewLine(l_loop);
        l_loop = Tpl.popBlock(l_loop);
        l_loop = Tpl.writeTok(l_loop, Tpl.ST_STRING("}"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_LINE("{\n"));
        a_preExp = Tpl.pushBlock(a_preExp, Tpl.BT_INDENT(2));
        a_preExp = Tpl.writeText(a_preExp, l_tmpVarDecls);
        a_preExp = Tpl.softNewLine(a_preExp);
        a_preExp = Tpl.writeText(a_preExp, l_rangeExpPre);
        a_preExp = Tpl.softNewLine(a_preExp);
        a_preExp = Tpl.writeText(a_preExp, l_firstValue);
        a_preExp = Tpl.softNewLine(a_preExp);
        a_preExp = fun_1162(a_preExp, l_resTail, l_res);
        a_preExp = Tpl.softNewLine(a_preExp);
        a_preExp = Tpl.writeText(a_preExp, l_loop);
        a_preExp = Tpl.softNewLine(a_preExp);
        a_preExp = fun_1163(a_preExp, l_foundFirst);
        a_preExp = Tpl.softNewLine(a_preExp);
        a_preExp = fun_1164(a_preExp, l_resTail);
        a_preExp = Tpl.softNewLine(a_preExp);
        a_preExp = Tpl.writeText(a_preExp, l_resTmp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = "));
        a_preExp = Tpl.writeText(a_preExp, l_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_LINE(";\n"));
        a_preExp = Tpl.popBlock(a_preExp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("}"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_resTmp);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           i_exp,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt_31 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("Code generation does not support multiple iterators: "));
        txt_31 = ExpressionDumpTpl.dumpExp(txt_31, i_exp, "\"");
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 7266, 14), Tpl.textString(txt_31));
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end daeExpReduction;

protected function fun_1166
  input Tpl.Text in_txt;
  input DAE.Type in_a_et;
  input Tpl.Text in_a_varDecls;
  input DAE.Exp in_a_exp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_varDecls) :=
  match(in_txt, in_a_et, in_a_varDecls, in_a_exp)
    local
      Tpl.Text txt;
      Tpl.Text a_varDecls;
      DAE.Exp a_exp;
      DAE.Type i_et;
      Tpl.Text txt_2;
      Tpl.Text txt_1;
      Tpl.Text txt_0;

    case ( txt,
           DAE.T_NORETCALL(),
           a_varDecls,
           a_exp )
      equation
        txt_0 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("match expression not returning anything should be caught in a noretcall statement and not reach this code: "));
        txt_0 = ExpressionDumpTpl.dumpExp(txt_0, a_exp, "\"");
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 7275, 37), Tpl.textString(txt_0));
      then (txt, a_varDecls);

    case ( txt,
           DAE.T_TUPLE(types = {}),
           a_varDecls,
           a_exp )
      equation
        txt_1 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("match expression returning an empty tuple should be caught in a noretcall statement and not reach this code: "));
        txt_1 = ExpressionDumpTpl.dumpExp(txt_1, a_exp, "\"");
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 7276, 39), Tpl.textString(txt_1));
      then (txt, a_varDecls);

    case ( txt,
           i_et,
           a_varDecls,
           _ )
      equation
        txt_2 = expTypeModelica(Tpl.emptyTxt, i_et);
        (txt, a_varDecls) = tempDeclZero(txt, Tpl.textString(txt_2), a_varDecls);
      then (txt, a_varDecls);
  end match;
end fun_1166;

public function daeExpMatch
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_exp, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Exp i_exp;
      DAE.Type i_et;
      Tpl.Text l_startIndexOutputs;
      Tpl.Text l_res;

    case ( txt,
           (i_exp as DAE.MATCHEXPRESSION(et = i_et)),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (l_res, a_varDecls) = fun_1166(Tpl.emptyTxt, i_et, a_varDecls, i_exp);
        l_startIndexOutputs = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("ERROR_INDEX"));
        (txt, l_res, l_startIndexOutputs, a_preExp, a_varDecls, a_auxFunction) = daeExpMatch2(txt, i_exp, SimCodeFunction.listExpLength1, l_res, l_startIndexOutputs, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end daeExpMatch;

protected function fun_1168
  input Tpl.Text in_txt;
  input DAE.MatchType in_a_exp_matchType;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_exp_matchType)
    local
      Tpl.Text txt;
      Integer ret_0;

    case ( txt,
           DAE.TRY_STACKOVERFLOW() )
      then txt;

    case ( txt,
           _ )
      equation
        ret_0 = System.tmpTick();
        SimCodeFunctionUtil.codegenPushTryThrowIndex(ret_0);
      then txt;
  end match;
end fun_1168;

protected function lm_1169
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varFrees;
  input Tpl.Text in_a_preExpInner;
  input Tpl.Text in_a_varDeclsInner;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varFrees;
  output Tpl.Text out_a_preExpInner;
  output Tpl.Text out_a_varDeclsInner;
algorithm
  (out_txt, out_a_auxFunction, out_a_varFrees, out_a_preExpInner, out_a_varDeclsInner) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varFrees, in_a_preExpInner, in_a_varDeclsInner)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varFrees;
      Tpl.Text a_preExpInner;
      Tpl.Text a_varDeclsInner;
      SimCodeFunction.Variable i_var;

    case ( txt,
           {},
           a_auxFunction,
           a_varFrees,
           a_preExpInner,
           a_varDeclsInner )
      then (txt, a_auxFunction, a_varFrees, a_preExpInner, a_varDeclsInner);

    case ( txt,
           i_var :: rest,
           a_auxFunction,
           a_varFrees,
           a_preExpInner,
           a_varDeclsInner )
      equation
        (txt, a_varDeclsInner, a_preExpInner, a_varFrees, a_auxFunction) = varInit(txt, i_var, "", a_varDeclsInner, a_preExpInner, a_varFrees, a_auxFunction);
        (txt, a_auxFunction, a_varFrees, a_preExpInner, a_varDeclsInner) = lm_1169(txt, rest, a_auxFunction, a_varFrees, a_preExpInner, a_varDeclsInner);
      then (txt, a_auxFunction, a_varFrees, a_preExpInner, a_varDeclsInner);
  end match;
end lm_1169;

protected function lm_1170
  input Tpl.Text in_txt;
  input list<String> in_items;
  input Tpl.Text in_a_decl;
  input Tpl.Text in_a_typ;
  input Tpl.Text in_a_varDeclsInput;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDeclsInput;
algorithm
  (out_txt, out_a_varDeclsInput) :=
  match(in_txt, in_items, in_a_decl, in_a_typ, in_a_varDeclsInput)
    local
      Tpl.Text txt;
      list<String> rest;
      Tpl.Text a_decl;
      Tpl.Text a_typ;
      Tpl.Text a_varDeclsInput;
      String i_a;

    case ( txt,
           {},
           _,
           _,
           a_varDeclsInput )
      then (txt, a_varDeclsInput);

    case ( txt,
           i_a :: rest,
           a_decl,
           a_typ,
           a_varDeclsInput )
      equation
        a_varDeclsInput = Tpl.writeText(a_varDeclsInput, a_typ);
        a_varDeclsInput = Tpl.writeTok(a_varDeclsInput, Tpl.ST_STRING(" _"));
        a_varDeclsInput = Tpl.writeStr(a_varDeclsInput, i_a);
        a_varDeclsInput = Tpl.writeTok(a_varDeclsInput, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeStr(txt, i_a);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, a_decl);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        (txt, a_varDeclsInput) = lm_1170(txt, rest, a_decl, a_typ, a_varDeclsInput);
      then (txt, a_varDeclsInput);
  end match;
end lm_1170;

protected function lm_1171
  input Tpl.Text in_txt;
  input list<tuple<DAE.Exp, list<String>>> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_preExpInput;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_expInput;
  input Tpl.Text in_a_varDeclsInput;
  input Tpl.Text in_a_startIndexInputs;
  input DAE.MatchType in_a_exp_matchType;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_preExpInput;
  output Tpl.Text out_a_expInput;
  output Tpl.Text out_a_varDeclsInput;
algorithm
  (out_txt, out_a_auxFunction, out_a_preExpInput, out_a_expInput, out_a_varDeclsInput) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_preExpInput, in_a_context, in_a_expInput, in_a_varDeclsInput, in_a_startIndexInputs, in_a_exp_matchType)
    local
      Tpl.Text txt;
      list<tuple<DAE.Exp, list<String>>> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_preExpInput;
      SimCodeFunction.Context a_context;
      Tpl.Text a_expInput;
      Tpl.Text a_varDeclsInput;
      Tpl.Text a_startIndexInputs;
      DAE.MatchType a_exp_matchType;
      Integer x_i1;
      list<String> i_alias;
      DAE.Exp i_e1;
      Tpl.Text l_decl;
      Tpl.Text l_typ;

    case ( txt,
           {},
           a_auxFunction,
           a_preExpInput,
           _,
           a_expInput,
           a_varDeclsInput,
           _,
           _ )
      then (txt, a_auxFunction, a_preExpInput, a_expInput, a_varDeclsInput);

    case ( txt,
           (i_e1, i_alias) :: rest,
           a_auxFunction,
           a_preExpInput,
           a_context,
           a_expInput,
           a_varDeclsInput,
           a_startIndexInputs,
           a_exp_matchType )
      equation
        x_i1 = Tpl.getIteri_i0(txt);
        l_typ = expTypeFromExpModelica(Tpl.emptyTxt, i_e1);
        (l_decl, a_varDeclsInput) = tempDeclMatchInput(Tpl.emptyTxt, a_exp_matchType, Tpl.textString(l_typ), Tpl.textString(a_startIndexInputs), intString(x_i1), a_varDeclsInput);
        a_expInput = Tpl.writeText(a_expInput, l_decl);
        a_expInput = Tpl.writeTok(a_expInput, Tpl.ST_STRING(" = "));
        (a_expInput, a_preExpInput, a_varDeclsInput, a_auxFunction) = daeExp(a_expInput, i_e1, a_context, a_preExpInput, a_varDeclsInput, a_auxFunction);
        a_expInput = Tpl.writeTok(a_expInput, Tpl.ST_STRING(";"));
        a_expInput = Tpl.writeTok(a_expInput, Tpl.ST_NEW_LINE());
        a_expInput = Tpl.pushIter(a_expInput, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (a_expInput, a_varDeclsInput) = lm_1170(a_expInput, i_alias, l_decl, l_typ, a_varDeclsInput);
        a_expInput = Tpl.popIter(a_expInput);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_preExpInput, a_expInput, a_varDeclsInput) = lm_1171(txt, rest, a_auxFunction, a_preExpInput, a_context, a_expInput, a_varDeclsInput, a_startIndexInputs, a_exp_matchType);
      then (txt, a_auxFunction, a_preExpInput, a_expInput, a_varDeclsInput);
  end match;
end lm_1171;

protected function fun_1172
  input Tpl.Text in_txt;
  input DAE.MatchType in_a_exp_matchType;
  input Tpl.Text in_a_varDeclsInner;
  input DAE.Exp in_a_exp;
  input Tpl.Text in_a_startIndexInputs;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDeclsInner;
algorithm
  (out_txt, out_a_varDeclsInner) :=
  match(in_txt, in_a_exp_matchType, in_a_varDeclsInner, in_a_exp, in_a_startIndexInputs)
    local
      Tpl.Text txt;
      Tpl.Text a_varDeclsInner;
      DAE.Exp a_exp;
      Tpl.Text a_startIndexInputs;
      Integer i_div;
      Integer i_switchIndex;
      Tpl.Text txt_1;
      Tpl.Text l_matchInputVar;

    case ( txt,
           DAE.MATCH(switch = SOME((i_switchIndex, DAE.T_STRING(varLst = _), i_div))),
           a_varDeclsInner,
           _,
           a_startIndexInputs )
      equation
        l_matchInputVar = getTempDeclMatchInputName(Tpl.emptyTxt, Tpl.textString(a_startIndexInputs), i_switchIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("stringHashDjb2Mod("));
        txt = Tpl.writeText(txt, l_matchInputVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeStr(txt, intString(i_div));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_varDeclsInner);

    case ( txt,
           DAE.MATCH(switch = SOME((i_switchIndex, DAE.T_METATYPE(ty = _), _))),
           a_varDeclsInner,
           _,
           a_startIndexInputs )
      equation
        l_matchInputVar = getTempDeclMatchInputName(Tpl.emptyTxt, Tpl.textString(a_startIndexInputs), i_switchIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("valueConstructor("));
        txt = Tpl.writeText(txt, l_matchInputVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_varDeclsInner);

    case ( txt,
           DAE.MATCH(switch = SOME((i_switchIndex, DAE.T_INTEGER(varLst = _), _))),
           a_varDeclsInner,
           _,
           a_startIndexInputs )
      equation
        l_matchInputVar = getTempDeclMatchInputName(Tpl.emptyTxt, Tpl.textString(a_startIndexInputs), i_switchIndex);
        txt = Tpl.writeText(txt, l_matchInputVar);
      then (txt, a_varDeclsInner);

    case ( txt,
           DAE.MATCH(switch = SOME(_)),
           a_varDeclsInner,
           a_exp,
           _ )
      equation
        txt_1 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("Unknown switch: "));
        txt_1 = ExpressionDumpTpl.dumpExp(txt_1, a_exp, "\"");
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 7322, 13), Tpl.textString(txt_1));
      then (txt, a_varDeclsInner);

    case ( txt,
           _,
           a_varDeclsInner,
           _,
           _ )
      equation
        (txt, a_varDeclsInner) = tempDecl(txt, "volatile mmc_switch_type", a_varDeclsInner);
      then (txt, a_varDeclsInner);
  end match;
end fun_1172;

protected function lm_1173
  input Tpl.Text in_txt;
  input list<DAE.Statement> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDeclsInner;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDeclsInner;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDeclsInner) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDeclsInner, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Statement> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDeclsInner;
      SimCodeFunction.Context a_context;
      DAE.Statement i_stmt;

    case ( txt,
           {},
           a_auxFunction,
           a_varDeclsInner,
           _ )
      then (txt, a_auxFunction, a_varDeclsInner);

    case ( txt,
           i_stmt :: rest,
           a_auxFunction,
           a_varDeclsInner,
           a_context )
      equation
        (txt, a_varDeclsInner, a_auxFunction) = algStatement(txt, i_stmt, a_context, a_varDeclsInner, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDeclsInner) = lm_1173(txt, rest, a_auxFunction, a_varDeclsInner, a_context);
      then (txt, a_auxFunction, a_varDeclsInner);
  end match;
end lm_1173;

protected function lm_1174
  input Tpl.Text in_txt;
  input list<DAE.Statement> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDeclsInner;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDeclsInner;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDeclsInner) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDeclsInner, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Statement> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDeclsInner;
      SimCodeFunction.Context a_context;
      DAE.Statement i_stmt;

    case ( txt,
           {},
           a_auxFunction,
           a_varDeclsInner,
           _ )
      then (txt, a_auxFunction, a_varDeclsInner);

    case ( txt,
           i_stmt :: rest,
           a_auxFunction,
           a_varDeclsInner,
           a_context )
      equation
        (txt, a_varDeclsInner, a_auxFunction) = algStatement(txt, i_stmt, a_context, a_varDeclsInner, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDeclsInner) = lm_1174(txt, rest, a_auxFunction, a_varDeclsInner, a_context);
      then (txt, a_auxFunction, a_varDeclsInner);
  end match;
end lm_1174;

protected function fun_1175
  input Tpl.Text in_txt;
  input list<DAE.MatchCase> in_a_exp_cases;
  input Tpl.Text in_a_preExpInner;
  input Tpl.Text in_a_expInput;
  input Tpl.Text in_a_preExpInput;
  input Tpl.Text in_a_varDeclsInput;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDeclsInner;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDeclsInner;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDeclsInner) :=
  match(in_txt, in_a_exp_cases, in_a_preExpInner, in_a_expInput, in_a_preExpInput, in_a_varDeclsInput, in_a_auxFunction, in_a_varDeclsInner, in_a_context)
    local
      Tpl.Text txt;
      Tpl.Text a_preExpInner;
      Tpl.Text a_expInput;
      Tpl.Text a_preExpInput;
      Tpl.Text a_varDeclsInput;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDeclsInner;
      SimCodeFunction.Context a_context;
      list<DAE.Statement> i_else_body;
      list<DAE.Statement> i_try_body;
      Tpl.Text l_elseb;
      Tpl.Text l_tryb;

    case ( txt,
           {DAE.CASE(body = i_try_body), DAE.CASE(body = i_else_body)},
           a_preExpInner,
           a_expInput,
           a_preExpInput,
           a_varDeclsInput,
           a_auxFunction,
           a_varDeclsInner,
           a_context )
      equation
        l_tryb = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_tryb, a_auxFunction, a_varDeclsInner) = lm_1173(l_tryb, i_try_body, a_auxFunction, a_varDeclsInner, a_context);
        l_tryb = Tpl.popIter(l_tryb);
        l_elseb = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_elseb, a_auxFunction, a_varDeclsInner) = lm_1174(l_elseb, i_else_body, a_auxFunction, a_varDeclsInner, a_context);
        l_elseb = Tpl.popIter(l_elseb);
        txt = endModelicaLine(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("{ /* stack overflow check */\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_varDeclsInput);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, a_preExpInput);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, a_expInput);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("{\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_varDeclsInner);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, a_preExpInner);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("MMC_TRY_STACK()\n"));
        txt = Tpl.writeText(txt, l_tryb);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("MMC_ELSE_STACK()\n"));
        txt = Tpl.writeText(txt, l_elseb);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("MMC_CATCH_STACK()\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("}\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then (txt, a_auxFunction, a_varDeclsInner);

    case ( txt,
           _,
           _,
           _,
           _,
           _,
           a_auxFunction,
           a_varDeclsInner,
           _ )
      equation
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 7350, 18), "Got stack overflow block with more than 2 cases");
      then (txt, a_auxFunction, a_varDeclsInner);
  end match;
end fun_1175;

protected function fun_1176
  input Tpl.Text in_txt;
  input DAE.MatchType in_a_exp_matchType;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_exp_matchType)
    local
      Tpl.Text txt;

    case ( txt,
           DAE.MATCHCONTINUE() )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("matchcontinue expression"));
      then txt;

    case ( txt,
           DAE.MATCH(switch = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("match expression"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_1176;

protected function fun_1177
  input Tpl.Text in_txt;
  input DAE.MatchType in_a_exp_matchType;
  input Tpl.Text in_a_prefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_exp_matchType, in_a_prefix)
    local
      Tpl.Text txt;
      Tpl.Text a_prefix;

    case ( txt,
           DAE.MATCHCONTINUE(),
           a_prefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("MMC_TRY_INTERNAL(mmc_jumper)\n"));
        txt = Tpl.writeText(txt, a_prefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_top:\n",
                                    "threadData->mmc_jumper = &new_mmc_jumper;"
                                }, false));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_1177;

protected function fun_1178
  input Tpl.Text in_txt;
  input DAE.MatchType in_a_exp_matchType;
  input list<DAE.MatchCase> in_a_exp_cases;
  input Tpl.Text in_a_prefix;
  input Tpl.Text in_a_ix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_exp_matchType, in_a_exp_cases, in_a_prefix, in_a_ix)
    local
      Tpl.Text txt;
      list<DAE.MatchCase> a_exp_cases;
      Tpl.Text a_prefix;
      Tpl.Text a_ix;
      DAE.MatchType i_exp_matchType;
      Integer ret_0;

    case ( txt,
           DAE.MATCH(switch = SOME(_)),
           _,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("{"));
      then txt;

    case ( txt,
           i_exp_matchType,
           a_exp_cases,
           a_prefix,
           a_ix )
      equation
        txt = Tpl.writeText(txt, a_ix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" = 0;\n"));
        txt = fun_1177(txt, i_exp_matchType, a_prefix);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("for (; "));
        txt = Tpl.writeText(txt, a_ix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" < "));
        ret_0 = listLength(a_exp_cases);
        txt = Tpl.writeStr(txt, intString(ret_0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("; "));
        txt = Tpl.writeText(txt, a_ix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("++) {"));
      then txt;
  end match;
end fun_1178;

protected function fun_1179
  input Tpl.Text in_txt;
  input DAE.MatchType in_a_exp_matchType;
  input list<DAE.MatchCase> in_a_exp_cases;
  input Tpl.Text in_a_ix;
  input Tpl.Text in_a_prefix;
  input Tpl.Text in_a_goto;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_exp_matchType, in_a_exp_cases, in_a_ix, in_a_prefix, in_a_goto)
    local
      Tpl.Text txt;
      list<DAE.MatchCase> a_exp_cases;
      Tpl.Text a_ix;
      Tpl.Text a_prefix;
      Tpl.Text a_goto;
      Integer ret_0;

    case ( txt,
           DAE.MATCHCONTINUE(),
           a_exp_cases,
           a_ix,
           a_prefix,
           a_goto )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("goto "));
        txt = Tpl.writeText(txt, a_goto);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.writeText(txt, a_prefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_done:\n",
                                    "(void)"
                                }, false));
        txt = Tpl.writeText(txt, a_ix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "MMC_RESTORE_INTERNAL(mmc_jumper);\n",
                                    "goto "
                                }, false));
        txt = Tpl.writeText(txt, a_prefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_done2;\n"));
        txt = Tpl.writeText(txt, a_goto);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ":;\n",
                                    "MMC_CATCH_INTERNAL(mmc_jumper);\n",
                                    "if (++"
                                }, false));
        txt = Tpl.writeText(txt, a_ix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" < "));
        ret_0 = listLength(a_exp_cases);
        txt = Tpl.writeStr(txt, intString(ret_0));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(") {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("goto "));
        txt = Tpl.writeText(txt, a_prefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_top;\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("}\n"));
        txt = generateThrow(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.writeText(txt, a_prefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_done2:;"));
      then txt;

    case ( txt,
           _,
           _,
           _,
           a_prefix,
           a_goto )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("goto "));
        txt = Tpl.writeText(txt, a_goto);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.writeText(txt, a_goto);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(":;\n"));
        txt = generateThrow(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "goto "
                                }, false));
        txt = Tpl.writeText(txt, a_prefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_done;\n"));
        txt = Tpl.writeText(txt, a_prefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_done:;"));
      then txt;
  end match;
end fun_1179;

protected function fun_1180
  input Tpl.Text in_txt;
  input DAE.MatchType in_a_exp_matchType;
  input Tpl.Text in_a_goto;
  input Tpl.Text in_a_varDecls;
  input list<DAE.Exp> in_a_exp_inputs;
  input Tpl.Text in_a_startIndexInputs;
  input Tpl.Text in_a_startIndexOutputs;
  input Tpl.Text in_a_res;
  input list<DAE.Exp> in_a_tupleAssignExps;
  input Tpl.Text in_a_prefix;
  input Tpl.Text in_a_ix;
  input Tpl.Text in_a_varDeclsInner;
  input Tpl.Text in_a_preExpInner;
  input Tpl.Text in_a_expInput;
  input Tpl.Text in_a_preExpInput;
  input Tpl.Text in_a_varDeclsInput;
  input Tpl.Text in_a_auxFunction;
  input SimCodeFunction.Context in_a_context;
  input list<DAE.MatchCase> in_a_exp_cases;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_startIndexInputs;
  output Tpl.Text out_a_startIndexOutputs;
  output Tpl.Text out_a_res;
  output Tpl.Text out_a_prefix;
  output Tpl.Text out_a_ix;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_varDecls, out_a_startIndexInputs, out_a_startIndexOutputs, out_a_res, out_a_prefix, out_a_ix, out_a_auxFunction) :=
  match(in_txt, in_a_exp_matchType, in_a_goto, in_a_varDecls, in_a_exp_inputs, in_a_startIndexInputs, in_a_startIndexOutputs, in_a_res, in_a_tupleAssignExps, in_a_prefix, in_a_ix, in_a_varDeclsInner, in_a_preExpInner, in_a_expInput, in_a_preExpInput, in_a_varDeclsInput, in_a_auxFunction, in_a_context, in_a_exp_cases)
    local
      Tpl.Text txt;
      Tpl.Text a_goto;
      Tpl.Text a_varDecls;
      list<DAE.Exp> a_exp_inputs;
      Tpl.Text a_startIndexInputs;
      Tpl.Text a_startIndexOutputs;
      Tpl.Text a_res;
      list<DAE.Exp> a_tupleAssignExps;
      Tpl.Text a_prefix;
      Tpl.Text a_ix;
      Tpl.Text a_varDeclsInner;
      Tpl.Text a_preExpInner;
      Tpl.Text a_expInput;
      Tpl.Text a_preExpInput;
      Tpl.Text a_varDeclsInput;
      Tpl.Text a_auxFunction;
      SimCodeFunction.Context a_context;
      list<DAE.MatchCase> a_exp_cases;
      DAE.MatchType i_exp_matchType;
      Integer ret_1;
      Tpl.Text l_varDeclsInner;

    case ( txt,
           DAE.TRY_STACKOVERFLOW(),
           _,
           a_varDecls,
           _,
           a_startIndexInputs,
           a_startIndexOutputs,
           a_res,
           _,
           a_prefix,
           a_ix,
           _,
           a_preExpInner,
           a_expInput,
           a_preExpInput,
           a_varDeclsInput,
           a_auxFunction,
           a_context,
           a_exp_cases )
      equation
        l_varDeclsInner = Tpl.emptyTxt;
        (txt, a_auxFunction, l_varDeclsInner) = fun_1175(txt, a_exp_cases, a_preExpInner, a_expInput, a_preExpInput, a_varDeclsInput, a_auxFunction, l_varDeclsInner, a_context);
      then (txt, a_varDecls, a_startIndexInputs, a_startIndexOutputs, a_res, a_prefix, a_ix, a_auxFunction);

    case ( txt,
           i_exp_matchType,
           a_goto,
           a_varDecls,
           a_exp_inputs,
           a_startIndexInputs,
           a_startIndexOutputs,
           a_res,
           a_tupleAssignExps,
           a_prefix,
           a_ix,
           a_varDeclsInner,
           a_preExpInner,
           a_expInput,
           a_preExpInput,
           a_varDeclsInput,
           a_auxFunction,
           a_context,
           a_exp_cases )
      equation
        txt = endModelicaLine(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("{ /* "));
        txt = fun_1176(txt, i_exp_matchType);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" */\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_varDeclsInput);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, a_preExpInput);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, a_expInput);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("{\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_varDeclsInner);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, a_preExpInner);
        txt = Tpl.softNewLine(txt);
        txt = fun_1178(txt, i_exp_matchType, a_exp_cases, a_prefix, a_ix);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("switch (MMC_SWITCH_CAST("));
        txt = Tpl.writeText(txt, a_ix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(")) {\n"));
        ret_1 = System.tmpTickIndexReserve(1, 0);
        (txt, a_ix, a_res, a_startIndexOutputs, a_prefix, a_startIndexInputs, a_varDecls, a_auxFunction) = daeExpMatchCases(txt, a_exp_cases, a_tupleAssignExps, i_exp_matchType, a_ix, a_res, a_startIndexOutputs, a_prefix, a_startIndexInputs, a_exp_inputs, a_context, a_varDecls, a_auxFunction, ret_1);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "goto "
                                }, false));
        txt = Tpl.writeText(txt, a_prefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_end;\n"));
        txt = Tpl.writeText(txt, a_prefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_end: ;\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
        SimCodeFunctionUtil.codegenPopTryThrowIndex();
        txt = Tpl.softNewLine(txt);
        txt = fun_1179(txt, i_exp_matchType, a_exp_cases, a_ix, a_prefix, a_goto);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("}\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then (txt, a_varDecls, a_startIndexInputs, a_startIndexOutputs, a_res, a_prefix, a_ix, a_auxFunction);
  end match;
end fun_1180;

public function daeExpMatch2
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input list<DAE.Exp> in_a_tupleAssignExps;
  input Tpl.Text in_a_res;
  input Tpl.Text in_a_startIndexOutputs;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_res;
  output Tpl.Text out_a_startIndexOutputs;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_res, out_a_startIndexOutputs, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_exp, in_a_tupleAssignExps, in_a_res, in_a_startIndexOutputs, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      list<DAE.Exp> a_tupleAssignExps;
      Tpl.Text a_res;
      Tpl.Text a_startIndexOutputs;
      SimCodeFunction.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      list<DAE.Exp> i_exp_inputs;
      list<DAE.MatchCase> i_exp_cases;
      DAE.Exp i_exp;
      list<list<String>> i_aliases;
      list<DAE.Exp> i_inputs;
      list<DAE.Element> i_localDecls;
      DAE.MatchType i_exp_matchType;
      Tpl.Text l_done;
      Tpl.Text l_ix;
      list<tuple<DAE.Exp, list<String>>> ret_18;
      Tpl.Text l_ignore3;
      Integer ret_16;
      Tpl.Text l_startIndexInputs;
      Tpl.Text l_expInput;
      Tpl.Text l_preExpInput;
      Integer ret_12;
      Tpl.Text l_prefix;
      list<SimCodeFunction.Variable> ret_10;
      Tpl.Text l_ignore2;
      Tpl.Text l_ignore;
      Tpl.Text l_varFrees;
      Tpl.Text l_varDeclsInner;
      Tpl.Text l_varDeclsInput;
      Tpl.Text l_preExpRes;
      Tpl.Text l_preExpInner;
      Integer ret_2;
      Tpl.Text l_goto;
      Tpl.Text l_mydummy;

    case ( txt,
           (i_exp as DAE.MATCHEXPRESSION(matchType = i_exp_matchType, localDecls = i_localDecls, inputs = (i_exp_inputs as i_inputs), aliases = i_aliases, cases = i_exp_cases)),
           a_tupleAssignExps,
           a_res,
           a_startIndexOutputs,
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        l_mydummy = fun_1168(Tpl.emptyTxt, i_exp_matchType);
        l_goto = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("goto_"));
        ret_2 = SimCodeFunctionUtil.codegenPeekTryThrowIndex();
        l_goto = Tpl.writeStr(l_goto, intString(ret_2));
        l_preExpInner = Tpl.emptyTxt;
        l_preExpRes = Tpl.emptyTxt;
        l_varDeclsInput = Tpl.emptyTxt;
        l_varDeclsInner = Tpl.emptyTxt;
        l_varFrees = Tpl.emptyTxt;
        l_ignore = Tpl.emptyTxt;
        ret_10 = SimCodeFunctionUtil.elementVars(i_localDecls);
        (l_ignore2, a_auxFunction, l_varFrees, l_preExpInner, l_varDeclsInner) = lm_1169(Tpl.emptyTxt, ret_10, a_auxFunction, l_varFrees, l_preExpInner, l_varDeclsInner);
        l_prefix = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("tmp"));
        ret_12 = System.tmpTick();
        l_prefix = Tpl.writeStr(l_prefix, intString(ret_12));
        l_preExpInput = Tpl.emptyTxt;
        l_expInput = Tpl.emptyTxt;
        ret_16 = System.tmpTickIndexReserve(0, 0);
        l_startIndexInputs = Tpl.writeStr(Tpl.emptyTxt, intString(ret_16));
        ret_18 = List.zip(i_inputs, i_aliases);
        l_ignore3 = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(1, SOME(Tpl.ST_STRING("")), NONE(), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_ignore3, a_auxFunction, l_preExpInput, l_expInput, l_varDeclsInput) = lm_1171(l_ignore3, ret_18, a_auxFunction, l_preExpInput, a_context, l_expInput, l_varDeclsInput, l_startIndexInputs, i_exp_matchType);
        l_ignore3 = Tpl.popIter(l_ignore3);
        (l_ix, l_varDeclsInner) = fun_1172(Tpl.emptyTxt, i_exp_matchType, l_varDeclsInner, i_exp, l_startIndexInputs);
        (l_done, l_varDeclsInner) = tempDecl(Tpl.emptyTxt, "int", l_varDeclsInner);
        (a_preExp, a_varDecls, l_startIndexInputs, a_startIndexOutputs, a_res, l_prefix, l_ix, a_auxFunction) = fun_1180(a_preExp, i_exp_matchType, l_goto, a_varDecls, i_exp_inputs, l_startIndexInputs, a_startIndexOutputs, a_res, a_tupleAssignExps, l_prefix, l_ix, l_varDeclsInner, l_preExpInner, l_expInput, l_preExpInput, l_varDeclsInput, a_auxFunction, a_context, i_exp_cases);
        txt = Tpl.writeText(txt, a_res);
      then (txt, a_res, a_startIndexOutputs, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_res,
           a_startIndexOutputs,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      then (txt, a_res, a_startIndexOutputs, a_preExp, a_varDecls, a_auxFunction);
  end match;
end daeExpMatch2;

protected function fun_1182
  input Tpl.Text in_txt;
  input String in_mArg;
  input Tpl.Text in_a_prefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_prefix)
    local
      Tpl.Text txt;
      Tpl.Text a_prefix;

    case ( txt,
           "default",
           a_prefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("goto "));
        txt = Tpl.writeText(txt, a_prefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_default"));
      then txt;

    case ( txt,
           _,
           a_prefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("goto "));
        txt = Tpl.writeText(txt, a_prefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_end"));
      then txt;
  end match;
end fun_1182;

protected function fun_1183
  input Tpl.Text in_txt;
  input DAE.MatchCase in_mArg;
  input Tpl.Text in_a_prefix;
  input Integer in_a_div;
  input Integer in_a_n;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_prefix, in_a_div, in_a_n)
    local
      Tpl.Text txt;
      Tpl.Text a_prefix;
      Integer a_div;
      Integer a_n;
      list<DAE.Pattern> i_last_patterns;
      String str_2;
      Tpl.Text txt_1;
      DAE.Pattern ret_0;

    case ( txt,
           DAE.CASE(patterns = i_last_patterns),
           a_prefix,
           a_div,
           a_n )
      equation
        ret_0 = listGet(i_last_patterns, a_n);
        txt_1 = switchIndex(Tpl.emptyTxt, ret_0, a_div);
        str_2 = Tpl.textString(txt_1);
        txt = fun_1182(txt, str_2, a_prefix);
      then txt;

    case ( txt,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_1183;

protected function fun_1184
  input Tpl.Text in_txt;
  input DAE.MatchType in_a_ty;
  input Tpl.Text in_a_prefix;
  input list<DAE.MatchCase> in_a_cases;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty, in_a_prefix, in_a_cases)
    local
      Tpl.Text txt;
      Tpl.Text a_prefix;
      list<DAE.MatchCase> a_cases;
      Integer i_div;
      Integer i_n;
      DAE.MatchCase ret_0;

    case ( txt,
           DAE.MATCH(switch = SOME((i_n, DAE.T_STRING(varLst = _), i_div))),
           a_prefix,
           a_cases )
      equation
        ret_0 = List.last(a_cases);
        txt = fun_1183(txt, ret_0, a_prefix, i_div, i_n);
      then txt;

    case ( txt,
           _,
           a_prefix,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("goto "));
        txt = Tpl.writeText(txt, a_prefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_end"));
      then txt;
  end match;
end fun_1184;

protected function fun_1185
  input Tpl.Text in_txt;
  input DAE.MatchType in_a_ty;
  input Tpl.Text in_a_prefix;
  input Tpl.Text in_a_lastSwitchIndex;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty, in_a_prefix, in_a_lastSwitchIndex)
    local
      Tpl.Text txt;
      Tpl.Text a_prefix;
      Tpl.Text a_lastSwitchIndex;

    case ( txt,
           DAE.MATCH(switch = SOME((_, DAE.T_STRING(varLst = _), _))),
           _,
           a_lastSwitchIndex )
      equation
        txt = Tpl.writeText(txt, a_lastSwitchIndex);
      then txt;

    case ( txt,
           _,
           a_prefix,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("goto "));
        txt = Tpl.writeText(txt, a_prefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_end"));
      then txt;
  end match;
end fun_1185;

protected function lm_1186
  input Tpl.Text in_txt;
  input list<tuple<DAE.Pattern, Integer>> in_items;
  input Tpl.Text in_a_assignments;
  input Tpl.Text in_a_varDeclsCaseInner;
  input Tpl.Text in_a_onPatternFail;
  input Tpl.Text in_a_startIndexInputs;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_assignments;
  output Tpl.Text out_a_varDeclsCaseInner;
  output Tpl.Text out_a_onPatternFail;
algorithm
  (out_txt, out_a_assignments, out_a_varDeclsCaseInner, out_a_onPatternFail) :=
  match(in_txt, in_items, in_a_assignments, in_a_varDeclsCaseInner, in_a_onPatternFail, in_a_startIndexInputs)
    local
      Tpl.Text txt;
      list<tuple<DAE.Pattern, Integer>> rest;
      Tpl.Text a_assignments;
      Tpl.Text a_varDeclsCaseInner;
      Tpl.Text a_onPatternFail;
      Tpl.Text a_startIndexInputs;
      Integer i_i0;
      DAE.Pattern i_lhs;
      Tpl.Text txt_0;

    case ( txt,
           {},
           a_assignments,
           a_varDeclsCaseInner,
           a_onPatternFail,
           _ )
      then (txt, a_assignments, a_varDeclsCaseInner, a_onPatternFail);

    case ( txt,
           (i_lhs, i_i0) :: rest,
           a_assignments,
           a_varDeclsCaseInner,
           a_onPatternFail,
           a_startIndexInputs )
      equation
        txt_0 = getTempDeclMatchInputName(Tpl.emptyTxt, Tpl.textString(a_startIndexInputs), i_i0);
        (txt, txt_0, a_onPatternFail, a_varDeclsCaseInner, a_assignments) = patternMatch(txt, i_lhs, txt_0, a_onPatternFail, a_varDeclsCaseInner, a_assignments);
        txt = Tpl.nextIter(txt);
        (txt, a_assignments, a_varDeclsCaseInner, a_onPatternFail) = lm_1186(txt, rest, a_assignments, a_varDeclsCaseInner, a_onPatternFail, a_startIndexInputs);
      then (txt, a_assignments, a_varDeclsCaseInner, a_onPatternFail);
  end match;
end lm_1186;

protected function lm_1187
  input Tpl.Text in_txt;
  input list<DAE.Statement> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDeclsCaseInner;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDeclsCaseInner;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDeclsCaseInner) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDeclsCaseInner, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Statement> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDeclsCaseInner;
      SimCodeFunction.Context a_context;
      DAE.Statement i_stmt;

    case ( txt,
           {},
           a_auxFunction,
           a_varDeclsCaseInner,
           _ )
      then (txt, a_auxFunction, a_varDeclsCaseInner);

    case ( txt,
           i_stmt :: rest,
           a_auxFunction,
           a_varDeclsCaseInner,
           a_context )
      equation
        (txt, a_varDeclsCaseInner, a_auxFunction) = algStatement(txt, i_stmt, a_context, a_varDeclsCaseInner, a_auxFunction);
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDeclsCaseInner) = lm_1187(txt, rest, a_auxFunction, a_varDeclsCaseInner, a_context);
      then (txt, a_auxFunction, a_varDeclsCaseInner);
  end match;
end lm_1187;

protected function fun_1188
  input Tpl.Text in_txt;
  input Option<DAE.Exp> in_a_c_patternGuard;
  input Tpl.Text in_a_onPatternFail;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDeclsCaseInner;
  input Tpl.Text in_a_preGuardCheck;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDeclsCaseInner;
  output Tpl.Text out_a_preGuardCheck;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDeclsCaseInner, out_a_preGuardCheck) :=
  match(in_txt, in_a_c_patternGuard, in_a_onPatternFail, in_a_auxFunction, in_a_varDeclsCaseInner, in_a_preGuardCheck, in_a_context)
    local
      Tpl.Text txt;
      Tpl.Text a_onPatternFail;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDeclsCaseInner;
      Tpl.Text a_preGuardCheck;
      SimCodeFunction.Context a_context;
      DAE.Exp i_exp;

    case ( txt,
           SOME(i_exp),
           a_onPatternFail,
           a_auxFunction,
           a_varDeclsCaseInner,
           a_preGuardCheck,
           a_context )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "/* Check guard condition after assignments */\n",
                                    "if (!"
                                }, false));
        (txt, a_preGuardCheck, a_varDeclsCaseInner, a_auxFunction) = daeExp(txt, i_exp, a_context, a_preGuardCheck, a_varDeclsCaseInner, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") "));
        txt = Tpl.writeText(txt, a_onPatternFail);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then (txt, a_auxFunction, a_varDeclsCaseInner, a_preGuardCheck);

    case ( txt,
           _,
           _,
           a_auxFunction,
           a_varDeclsCaseInner,
           a_preGuardCheck,
           _ )
      then (txt, a_auxFunction, a_varDeclsCaseInner, a_preGuardCheck);
  end match;
end fun_1188;

protected function lm_1189
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDeclsCaseInner;
  input Tpl.Text in_a_preRes;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_startIndexOutputs;
  input Tpl.Text in_a_res;
  input list<DAE.Exp> in_a_exps;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDeclsCaseInner;
  output Tpl.Text out_a_preRes;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDeclsCaseInner, out_a_preRes) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varDeclsCaseInner, in_a_preRes, in_a_context, in_a_startIndexOutputs, in_a_res, in_a_exps)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDeclsCaseInner;
      Tpl.Text a_preRes;
      SimCodeFunction.Context a_context;
      Tpl.Text a_startIndexOutputs;
      Tpl.Text a_res;
      list<DAE.Exp> a_exps;
      Integer x_i1;
      DAE.Exp i_e;

    case ( txt,
           {},
           a_auxFunction,
           a_varDeclsCaseInner,
           a_preRes,
           _,
           _,
           _,
           _ )
      then (txt, a_auxFunction, a_varDeclsCaseInner, a_preRes);

    case ( txt,
           i_e :: rest,
           a_auxFunction,
           a_varDeclsCaseInner,
           a_preRes,
           a_context,
           a_startIndexOutputs,
           a_res,
           a_exps )
      equation
        x_i1 = Tpl.getIteri_i0(txt);
        txt = getTempDeclMatchOutputName(txt, a_exps, Tpl.textString(a_res), Tpl.textString(a_startIndexOutputs), x_i1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        (txt, a_preRes, a_varDeclsCaseInner, a_auxFunction) = daeExp(txt, i_e, a_context, a_preRes, a_varDeclsCaseInner, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction, a_varDeclsCaseInner, a_preRes) = lm_1189(txt, rest, a_auxFunction, a_varDeclsCaseInner, a_preRes, a_context, a_startIndexOutputs, a_res, a_exps);
      then (txt, a_auxFunction, a_varDeclsCaseInner, a_preRes);
  end match;
end lm_1189;

protected function lm_1190
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Tpl.Text in_a_startIndexOutputs;
  input Tpl.Text in_a_res;
  input list<DAE.Exp> in_a_tupleAssignExps;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_startIndexOutputs, in_a_res, in_a_tupleAssignExps)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Tpl.Text a_startIndexOutputs;
      Tpl.Text a_res;
      list<DAE.Exp> a_tupleAssignExps;
      Integer x_i0;

    case ( txt,
           {},
           _,
           _,
           _ )
      then txt;

    case ( txt,
           _ :: rest,
           a_startIndexOutputs,
           a_res,
           a_tupleAssignExps )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", &"));
        txt = getTempDeclMatchOutputName(txt, a_tupleAssignExps, Tpl.textString(a_res), Tpl.textString(a_startIndexOutputs), x_i0);
        txt = Tpl.nextIter(txt);
        txt = lm_1190(txt, rest, a_startIndexOutputs, a_res, a_tupleAssignExps);
      then txt;
  end match;
end lm_1190;

protected function fun_1191
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_a_tupleAssignExps;
  input Tpl.Text in_a_startIndexOutputs;
  input Tpl.Text in_a_res;
  input Tpl.Text in_a_retStruct;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_tupleAssignExps, in_a_startIndexOutputs, in_a_res, in_a_retStruct)
    local
      Tpl.Text txt;
      Tpl.Text a_startIndexOutputs;
      Tpl.Text a_res;
      Tpl.Text a_retStruct;
      list<DAE.Exp> i_tupleAssignExps;

    case ( txt,
           {},
           _,
           _,
           a_retStruct )
      equation
        txt = Tpl.writeText(txt, a_retStruct);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           (i_tupleAssignExps as _ :: _),
           a_startIndexOutputs,
           a_res,
           a_retStruct )
      equation
        txt = getTempDeclMatchOutputName(txt, i_tupleAssignExps, Tpl.textString(a_res), Tpl.textString(a_startIndexOutputs), 1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, a_retStruct);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_1191;

protected function fun_1192
  input Tpl.Text in_txt;
  input Option<DAE.Exp> in_a_c_result;
  input list<DAE.Exp> in_a_tupleAssignExps;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDeclsCaseInner;
  input Tpl.Text in_a_preRes;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_startIndexOutputs;
  input Tpl.Text in_a_res;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDeclsCaseInner;
  output Tpl.Text out_a_preRes;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDeclsCaseInner, out_a_preRes) :=
  match(in_txt, in_a_c_result, in_a_tupleAssignExps, in_a_auxFunction, in_a_varDeclsCaseInner, in_a_preRes, in_a_context, in_a_startIndexOutputs, in_a_res)
    local
      Tpl.Text txt;
      list<DAE.Exp> a_tupleAssignExps;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDeclsCaseInner;
      Tpl.Text a_preRes;
      SimCodeFunction.Context a_context;
      Tpl.Text a_startIndexOutputs;
      Tpl.Text a_res;
      DAE.Exp i_e;
      DAE.Exp i_exp;
      list<DAE.Exp> i_exps;
      Tpl.Text l_callRet;
      Tpl.Text l_retStruct;
      list<DAE.Exp> ret_1;
      Tpl.Text l_additionalOutputs;

    case ( txt,
           SOME(DAE.TUPLE(PR = i_exps)),
           _,
           a_auxFunction,
           a_varDeclsCaseInner,
           a_preRes,
           a_context,
           a_startIndexOutputs,
           a_res )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(1, NONE(), NONE(), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_auxFunction, a_varDeclsCaseInner, a_preRes) = lm_1189(txt, i_exps, a_auxFunction, a_varDeclsCaseInner, a_preRes, a_context, a_startIndexOutputs, a_res, i_exps);
        txt = Tpl.popIter(txt);
      then (txt, a_auxFunction, a_varDeclsCaseInner, a_preRes);

    case ( txt,
           SOME((i_exp as DAE.CALL(attr = DAE.CALL_ATTR(tailCall = DAE.TAIL(vars = _))))),
           _,
           a_auxFunction,
           a_varDeclsCaseInner,
           a_preRes,
           a_context,
           _,
           _ )
      equation
        (txt, a_preRes, a_varDeclsCaseInner, a_auxFunction) = daeExp(txt, i_exp, a_context, a_preRes, a_varDeclsCaseInner, a_auxFunction);
      then (txt, a_auxFunction, a_varDeclsCaseInner, a_preRes);

    case ( txt,
           SOME((i_exp as DAE.CALL(attr = DAE.CALL_ATTR(tuple_ = true)))),
           a_tupleAssignExps,
           a_auxFunction,
           a_varDeclsCaseInner,
           a_preRes,
           a_context,
           a_startIndexOutputs,
           a_res )
      equation
        ret_1 = List.restOrEmpty(a_tupleAssignExps);
        l_additionalOutputs = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(2, NONE(), NONE(), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_additionalOutputs = lm_1190(l_additionalOutputs, ret_1, a_startIndexOutputs, a_res, a_tupleAssignExps);
        l_additionalOutputs = Tpl.popIter(l_additionalOutputs);
        (l_retStruct, l_additionalOutputs, a_preRes, a_varDeclsCaseInner, a_auxFunction) = daeExpCallTuple(Tpl.emptyTxt, i_exp, l_additionalOutputs, a_context, a_preRes, a_varDeclsCaseInner, a_auxFunction);
        l_callRet = fun_1191(Tpl.emptyTxt, a_tupleAssignExps, a_startIndexOutputs, a_res, l_retStruct);
        txt = Tpl.writeText(txt, l_callRet);
      then (txt, a_auxFunction, a_varDeclsCaseInner, a_preRes);

    case ( txt,
           SOME(i_e),
           _,
           a_auxFunction,
           a_varDeclsCaseInner,
           a_preRes,
           a_context,
           _,
           a_res )
      equation
        txt = Tpl.writeText(txt, a_res);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        (txt, a_preRes, a_varDeclsCaseInner, a_auxFunction) = daeExp(txt, i_e, a_context, a_preRes, a_varDeclsCaseInner, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then (txt, a_auxFunction, a_varDeclsCaseInner, a_preRes);

    case ( txt,
           _,
           _,
           a_auxFunction,
           a_varDeclsCaseInner,
           a_preRes,
           _,
           _,
           _ )
      then (txt, a_auxFunction, a_varDeclsCaseInner, a_preRes);
  end match;
end fun_1192;

protected function fun_1193
  input Tpl.Text in_txt;
  input String in_mArg;
  input list<DAE.Exp> in_a_tupleAssignExps;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varDeclsCaseInner;
  input Tpl.Text in_a_preRes;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_startIndexOutputs;
  input Tpl.Text in_a_res;
  input Option<DAE.Exp> in_a_c_result;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varDeclsCaseInner;
  output Tpl.Text out_a_preRes;
algorithm
  (out_txt, out_a_auxFunction, out_a_varDeclsCaseInner, out_a_preRes) :=
  match(in_txt, in_mArg, in_a_tupleAssignExps, in_a_auxFunction, in_a_varDeclsCaseInner, in_a_preRes, in_a_context, in_a_startIndexOutputs, in_a_res, in_a_c_result)
    local
      Tpl.Text txt;
      list<DAE.Exp> a_tupleAssignExps;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varDeclsCaseInner;
      Tpl.Text a_preRes;
      SimCodeFunction.Context a_context;
      Tpl.Text a_startIndexOutputs;
      Tpl.Text a_res;
      Option<DAE.Exp> a_c_result;

    case ( txt,
           "",
           _,
           a_auxFunction,
           a_varDeclsCaseInner,
           a_preRes,
           _,
           _,
           _,
           _ )
      then (txt, a_auxFunction, a_varDeclsCaseInner, a_preRes);

    case ( txt,
           _,
           a_tupleAssignExps,
           a_auxFunction,
           a_varDeclsCaseInner,
           a_preRes,
           a_context,
           a_startIndexOutputs,
           a_res,
           a_c_result )
      equation
        (txt, a_auxFunction, a_varDeclsCaseInner, a_preRes) = fun_1192(txt, a_c_result, a_tupleAssignExps, a_auxFunction, a_varDeclsCaseInner, a_preRes, a_context, a_startIndexOutputs, a_res);
      then (txt, a_auxFunction, a_varDeclsCaseInner, a_preRes);
  end match;
end fun_1193;

protected function lm_1194
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;
  input Tpl.Text in_a_auxFunction;
  input Tpl.Text in_a_varFrees;
  input Tpl.Text in_a_preExpCaseInner;
  input Tpl.Text in_a_varDeclsCaseInner;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
  output Tpl.Text out_a_varFrees;
  output Tpl.Text out_a_preExpCaseInner;
  output Tpl.Text out_a_varDeclsCaseInner;
algorithm
  (out_txt, out_a_auxFunction, out_a_varFrees, out_a_preExpCaseInner, out_a_varDeclsCaseInner) :=
  match(in_txt, in_items, in_a_auxFunction, in_a_varFrees, in_a_preExpCaseInner, in_a_varDeclsCaseInner)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      Tpl.Text a_auxFunction;
      Tpl.Text a_varFrees;
      Tpl.Text a_preExpCaseInner;
      Tpl.Text a_varDeclsCaseInner;
      SimCodeFunction.Variable i_var;

    case ( txt,
           {},
           a_auxFunction,
           a_varFrees,
           a_preExpCaseInner,
           a_varDeclsCaseInner )
      then (txt, a_auxFunction, a_varFrees, a_preExpCaseInner, a_varDeclsCaseInner);

    case ( txt,
           i_var :: rest,
           a_auxFunction,
           a_varFrees,
           a_preExpCaseInner,
           a_varDeclsCaseInner )
      equation
        (txt, a_varDeclsCaseInner, a_preExpCaseInner, a_varFrees, a_auxFunction) = varInit(txt, i_var, "", a_varDeclsCaseInner, a_preExpCaseInner, a_varFrees, a_auxFunction);
        (txt, a_auxFunction, a_varFrees, a_preExpCaseInner, a_varDeclsCaseInner) = lm_1194(txt, rest, a_auxFunction, a_varFrees, a_preExpCaseInner, a_varDeclsCaseInner);
      then (txt, a_auxFunction, a_varFrees, a_preExpCaseInner, a_varDeclsCaseInner);
  end match;
end lm_1194;

protected function fun_1195
  input Tpl.Text in_txt;
  input String in_mArg;
  input Tpl.Text in_a_prefix;
  input Tpl.Text in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_prefix, in_a_name)
    local
      Tpl.Text txt;
      Tpl.Text a_prefix;
      Tpl.Text a_name;

    case ( txt,
           "default",
           a_prefix,
           a_name )
      equation
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(":\n"));
        txt = Tpl.writeText(txt, a_prefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_default: OMC_LABEL_UNUSED; {"));
      then txt;

    case ( txt,
           _,
           _,
           a_name )
      equation
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(": {"));
      then txt;
  end match;
end fun_1195;

protected function fun_1196
  input Tpl.Text in_txt;
  input DAE.MatchType in_a_ty;
  input Integer in_a_i0;
  input Tpl.Text in_a_prefix;
  input list<DAE.Pattern> in_a_c_patterns;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty, in_a_i0, in_a_prefix, in_a_c_patterns)
    local
      Tpl.Text txt;
      Integer a_i0;
      Tpl.Text a_prefix;
      list<DAE.Pattern> a_c_patterns;
      Integer i_ea;
      Integer i_n;
      String str_2;
      DAE.Pattern ret_1;
      Tpl.Text l_name;

    case ( txt,
           DAE.MATCH(switch = SOME((i_n, _, i_ea))),
           _,
           a_prefix,
           a_c_patterns )
      equation
        ret_1 = listGet(a_c_patterns, i_n);
        l_name = switchIndex(Tpl.emptyTxt, ret_1, i_ea);
        str_2 = Tpl.textString(l_name);
        txt = fun_1195(txt, str_2, a_prefix, l_name);
      then txt;

    case ( txt,
           _,
           a_i0,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("case "));
        txt = Tpl.writeStr(txt, intString(a_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(": {"));
      then txt;
  end match;
end fun_1196;

protected function fun_1197
  input Tpl.Text in_txt;
  input Integer in_a_c_jump;
  input Tpl.Text in_a_ix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_c_jump, in_a_ix)
    local
      Tpl.Text txt;
      Tpl.Text a_ix;
      Integer i_c_jump;

    case ( txt,
           0,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/* Pattern matching succeeded */"));
      then txt;

    case ( txt,
           i_c_jump,
           a_ix )
      equation
        txt = Tpl.writeText(txt, a_ix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" += "));
        txt = Tpl.writeStr(txt, intString(i_c_jump));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("; /* Pattern matching succeeded; we may skip some cases if we fail */"));
      then txt;
  end match;
end fun_1197;

protected function fun_1198
  input Tpl.Text in_txt;
  input Option<DAE.Exp> in_a_c_result;
  input Tpl.Text in_a_caseRes;
  input Tpl.Text in_a_preRes;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_c_result, in_a_caseRes, in_a_preRes)
    local
      Tpl.Text txt;
      Tpl.Text a_caseRes;
      Tpl.Text a_preRes;

    case ( txt,
           NONE(),
           _,
           _ )
      equation
        txt = generateThrow(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _,
           a_caseRes,
           a_preRes )
      equation
        txt = Tpl.writeText(txt, a_preRes);
        txt = Tpl.writeText(txt, a_caseRes);
      then txt;
  end match;
end fun_1198;

protected function lm_1199
  input Tpl.Text in_txt;
  input list<DAE.MatchCase> in_items;
  input Tpl.Text in_a_ix;
  input list<DAE.Exp> in_a_tupleAssignExps;
  input Tpl.Text in_a_startIndexOutputs;
  input Tpl.Text in_a_res;
  input Tpl.Text in_a_auxFunction;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_startIndexInputs;
  input Tpl.Text in_a_prefix;
  input list<DAE.MatchCase> in_a_cases;
  input DAE.MatchType in_a_ty;
  input Integer in_a_startTmpTickIndex;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_auxFunction) :=
  match(in_txt, in_items, in_a_ix, in_a_tupleAssignExps, in_a_startIndexOutputs, in_a_res, in_a_auxFunction, in_a_context, in_a_startIndexInputs, in_a_prefix, in_a_cases, in_a_ty, in_a_startTmpTickIndex)
    local
      Tpl.Text txt;
      list<DAE.MatchCase> rest;
      Tpl.Text a_ix;
      list<DAE.Exp> a_tupleAssignExps;
      Tpl.Text a_startIndexOutputs;
      Tpl.Text a_res;
      Tpl.Text a_auxFunction;
      SimCodeFunction.Context a_context;
      Tpl.Text a_startIndexInputs;
      Tpl.Text a_prefix;
      list<DAE.MatchCase> a_cases;
      DAE.MatchType a_ty;
      Integer a_startTmpTickIndex;
      Integer x_i0;
      SourceInfo i_c_resultInfo;
      Integer i_c_jump;
      list<DAE.Element> i_c_localDecls;
      Option<DAE.Exp> i_c_result;
      Option<DAE.Exp> i_c_patternGuard;
      list<DAE.Statement> i_c_body;
      list<DAE.Pattern> i_c_patterns;
      list<SimCodeFunction.Variable> ret_15;
      Tpl.Text l_0__;
      String str_13;
      Tpl.Text l_caseRes;
      Tpl.Text l_guardCheck;
      Tpl.Text l_preGuardCheck;
      Tpl.Text l_stmts;
      list<tuple<DAE.Pattern, Integer>> ret_8;
      Tpl.Text l_patternMatching;
      Tpl.Text l_varFrees;
      Tpl.Text l_preRes;
      Tpl.Text l_assignments;
      Tpl.Text l_preExpCaseInner;
      Tpl.Text l_varDeclsCaseInner;
      Tpl.Text l_onPatternFail;
      Tpl.Text l_lastSwitchIndex;

    case ( txt,
           {},
           _,
           _,
           _,
           _,
           a_auxFunction,
           _,
           _,
           _,
           _,
           _,
           _ )
      then (txt, a_auxFunction);

    case ( txt,
           DAE.CASE(patterns = i_c_patterns, body = i_c_body, patternGuard = i_c_patternGuard, result = i_c_result, localDecls = i_c_localDecls, jump = i_c_jump, resultInfo = i_c_resultInfo) :: rest,
           a_ix,
           a_tupleAssignExps,
           a_startIndexOutputs,
           a_res,
           a_auxFunction,
           a_context,
           a_startIndexInputs,
           a_prefix,
           a_cases,
           a_ty,
           a_startTmpTickIndex )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        System.tmpTickSetIndex(a_startTmpTickIndex, 1);
        l_lastSwitchIndex = fun_1184(Tpl.emptyTxt, a_ty, a_prefix, a_cases);
        l_onPatternFail = fun_1185(Tpl.emptyTxt, a_ty, a_prefix, l_lastSwitchIndex);
        l_varDeclsCaseInner = Tpl.emptyTxt;
        l_preExpCaseInner = Tpl.emptyTxt;
        l_assignments = Tpl.emptyTxt;
        l_preRes = Tpl.emptyTxt;
        l_varFrees = Tpl.emptyTxt;
        ret_8 = Patternm.sortPatternsByComplexity(i_c_patterns);
        l_patternMatching = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), NONE(), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_patternMatching, l_assignments, l_varDeclsCaseInner, l_onPatternFail) = lm_1186(l_patternMatching, ret_8, l_assignments, l_varDeclsCaseInner, l_onPatternFail, a_startIndexInputs);
        l_patternMatching = Tpl.popIter(l_patternMatching);
        System.tmpTickSetIndex(a_startTmpTickIndex, 1);
        l_stmts = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_stmts, a_auxFunction, l_varDeclsCaseInner) = lm_1187(l_stmts, i_c_body, a_auxFunction, l_varDeclsCaseInner, a_context);
        l_stmts = Tpl.popIter(l_stmts);
        l_preGuardCheck = Tpl.emptyTxt;
        (l_guardCheck, a_auxFunction, l_varDeclsCaseInner, l_preGuardCheck) = fun_1188(Tpl.emptyTxt, i_c_patternGuard, l_onPatternFail, a_auxFunction, l_varDeclsCaseInner, l_preGuardCheck, a_context);
        str_13 = Tpl.textString(a_res);
        (l_caseRes, a_auxFunction, l_varDeclsCaseInner, l_preRes) = fun_1193(Tpl.emptyTxt, str_13, a_tupleAssignExps, a_auxFunction, l_varDeclsCaseInner, l_preRes, a_context, a_startIndexOutputs, a_res, i_c_result);
        ret_15 = SimCodeFunctionUtil.elementVars(i_c_localDecls);
        (l_0__, a_auxFunction, l_varFrees, l_preExpCaseInner, l_varDeclsCaseInner) = lm_1194(Tpl.emptyTxt, ret_15, a_auxFunction, l_varFrees, l_preExpCaseInner, l_varDeclsCaseInner);
        txt = fun_1196(txt, a_ty, x_i0, a_prefix, i_c_patterns);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_varDeclsCaseInner);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_preExpCaseInner);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_patternMatching);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_assignments);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_preGuardCheck);
        txt = Tpl.softNewLine(txt);
        txt = fun_1197(txt, i_c_jump, a_ix);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_guardCheck);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_stmts);
        txt = Tpl.softNewLine(txt);
        txt = modelicaLine(txt, i_c_resultInfo);
        txt = Tpl.softNewLine(txt);
        txt = fun_1198(txt, i_c_result, l_caseRes, l_preRes);
        txt = Tpl.softNewLine(txt);
        txt = endModelicaLine(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("goto "));
        txt = Tpl.writeText(txt, a_prefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_done;\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.nextIter(txt);
        (txt, a_auxFunction) = lm_1199(txt, rest, a_ix, a_tupleAssignExps, a_startIndexOutputs, a_res, a_auxFunction, a_context, a_startIndexInputs, a_prefix, a_cases, a_ty, a_startTmpTickIndex);
      then (txt, a_auxFunction);

    case ( txt,
           _ :: rest,
           a_ix,
           a_tupleAssignExps,
           a_startIndexOutputs,
           a_res,
           a_auxFunction,
           a_context,
           a_startIndexInputs,
           a_prefix,
           a_cases,
           a_ty,
           a_startTmpTickIndex )
      equation
        (txt, a_auxFunction) = lm_1199(txt, rest, a_ix, a_tupleAssignExps, a_startIndexOutputs, a_res, a_auxFunction, a_context, a_startIndexInputs, a_prefix, a_cases, a_ty, a_startTmpTickIndex);
      then (txt, a_auxFunction);
  end match;
end lm_1199;

public function daeExpMatchCases
  input Tpl.Text txt;
  input list<DAE.MatchCase> a_cases;
  input list<DAE.Exp> a_tupleAssignExps;
  input DAE.MatchType a_ty;
  input Tpl.Text a_ix;
  input Tpl.Text a_res;
  input Tpl.Text a_startIndexOutputs;
  input Tpl.Text a_prefix;
  input Tpl.Text a_startIndexInputs;
  input list<DAE.Exp> a_inputs;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_auxFunction;
  input Integer a_startTmpTickIndex;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_ix;
  output Tpl.Text out_a_res;
  output Tpl.Text out_a_startIndexOutputs;
  output Tpl.Text out_a_prefix;
  output Tpl.Text out_a_startIndexInputs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  out_txt := Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), NONE(), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (out_txt, out_a_auxFunction) := lm_1199(out_txt, a_cases, a_ix, a_tupleAssignExps, a_startIndexOutputs, a_res, a_auxFunction, a_context, a_startIndexInputs, a_prefix, a_cases, a_ty, a_startTmpTickIndex);
  out_txt := Tpl.popIter(out_txt);
  out_a_ix := a_ix;
  out_a_res := a_res;
  out_a_startIndexOutputs := a_startIndexOutputs;
  out_a_prefix := a_prefix;
  out_a_startIndexInputs := a_startIndexInputs;
  out_a_varDecls := a_varDecls;
end daeExpMatchCases;

public function switchIndex
  input Tpl.Text in_txt;
  input DAE.Pattern in_a_pattern;
  input Integer in_a_extraArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_pattern, in_a_extraArg)
    local
      Tpl.Text txt;
      Integer a_extraArg;
      Integer i_e_integer;
      String i_e_string;
      Integer i_index;
      Integer ret_2;
      Integer ret_1;
      Integer ret_0;

    case ( txt,
           DAE.PAT_CALL(index = i_index),
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("case "));
        ret_0 = Patternm.getValueCtor(i_index);
        txt = Tpl.writeStr(txt, intString(ret_0));
      then txt;

    case ( txt,
           DAE.PAT_CONSTANT(exp = DAE.SCONST(string = i_e_string)),
           a_extraArg )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("case "));
        ret_1 = stringHashDjb2Mod(i_e_string, a_extraArg);
        txt = Tpl.writeStr(txt, intString(ret_1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" /* "));
        txt = Tpl.writeStr(txt, i_e_string);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" */"));
      then txt;

    case ( txt,
           DAE.PAT_CONSTANT(exp = DAE.SHARED_LITERAL(exp = DAE.SCONST(string = i_e_string))),
           a_extraArg )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("case "));
        ret_2 = stringHashDjb2Mod(i_e_string, a_extraArg);
        txt = Tpl.writeStr(txt, intString(ret_2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" /* "));
        txt = Tpl.writeStr(txt, i_e_string);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" */"));
      then txt;

    case ( txt,
           DAE.PAT_CONSTANT(exp = DAE.ICONST(integer = i_e_integer)),
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("case "));
        txt = Tpl.writeStr(txt, intString(i_e_integer));
      then txt;

    case ( txt,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("default"));
      then txt;
  end match;
end switchIndex;

protected function fun_1202
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input DAE.Exp in_a_exp;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_exp)
    local
      Tpl.Text txt;
      DAE.Exp a_exp;

    case ( txt,
           false,
           a_exp )
      equation
        txt = expTypeFromExpShort(txt, a_exp);
      then txt;

    case ( txt,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_array"));
      then txt;
  end match;
end fun_1202;

public function daeExpBox
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_exp, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Exp i_exp;
      Tpl.Text l_res;
      Boolean ret_2;
      DAE.Type ret_1;
      Tpl.Text l_ty;

    case ( txt,
           DAE.BOX(exp = i_exp),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        ret_1 = Expression.typeof(i_exp);
        ret_2 = Expression.isArrayType(ret_1);
        l_ty = fun_1202(Tpl.emptyTxt, ret_2, i_exp);
        (l_res, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_exp, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("mmc_mk_"));
        txt = Tpl.writeText(txt, l_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, l_res);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end daeExpBox;

public function daeExpUnbox
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_exp, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Exp i_exp_exp;
      DAE.Type i_exp_ty;
      Tpl.Text l_res;
      Tpl.Text l_ty;

    case ( txt,
           DAE.UNBOX(ty = i_exp_ty, exp = i_exp_exp),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        l_ty = expTypeShort(Tpl.emptyTxt, i_exp_ty);
        (l_res, a_preExp, a_varDecls, a_auxFunction) = daeExp(Tpl.emptyTxt, i_exp_exp, a_context, a_preExp, a_varDecls, a_auxFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("mmc_unbox_"));
        txt = Tpl.writeText(txt, l_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, l_res);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end daeExpUnbox;

public function daeExpSharedLiteral
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_exp)
    local
      Tpl.Text txt;
      Integer i_exp_index;

    case ( txt,
           DAE.SHARED_LITERAL(index = i_exp_index) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_OMC_LIT"));
        txt = Tpl.writeStr(txt, intString(i_exp_index));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end daeExpSharedLiteral;

public function daeSubscript
  input Tpl.Text in_txt;
  input DAE.Subscript in_a_sub;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_auxFunction) :=
  match(in_txt, in_a_sub, in_a_context, in_a_preExp, in_a_varDecls, in_a_auxFunction)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_auxFunction;
      DAE.Exp i_sub_exp;

    case ( txt,
           DAE.INDEX(exp = i_sub_exp),
           a_context,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        (txt, a_preExp, a_varDecls, a_auxFunction) = daeSubscriptExp(txt, i_sub_exp, a_context, a_preExp, a_varDecls, a_auxFunction);
      then (txt, a_preExp, a_varDecls, a_auxFunction);

    case ( txt,
           _,
           _,
           a_preExp,
           a_varDecls,
           a_auxFunction )
      equation
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 7542, 14), "non INDEX(_) (i.e., slice) subscripts probably should not reach here. Check indexedAssign template.");
      then (txt, a_preExp, a_varDecls, a_auxFunction);
  end match;
end daeSubscript;

protected function fun_1207
  input Tpl.Text in_txt;
  input String in_mArg;
  input Tpl.Text in_a_res;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_res)
    local
      Tpl.Text txt;
      Tpl.Text a_res;

    case ( txt,
           "modelica_boolean",
           a_res )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_res);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("+1)"));
      then txt;

    case ( txt,
           _,
           a_res )
      equation
        txt = Tpl.writeText(txt, a_res);
      then txt;
  end match;
end fun_1207;

public function daeSubscriptExp
  input Tpl.Text txt;
  input DAE.Exp a_exp;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_preExp;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_auxFunction;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_auxFunction;
protected
  String str_2;
  Tpl.Text txt_1;
  Tpl.Text l_res;
algorithm
  (l_res, out_a_preExp, out_a_varDecls, out_a_auxFunction) := daeExp(Tpl.emptyTxt, a_exp, a_context, a_preExp, a_varDecls, a_auxFunction);
  txt_1 := expTypeFromExpModelica(Tpl.emptyTxt, a_exp);
  str_2 := Tpl.textString(txt_1);
  out_txt := fun_1207(txt, str_2, l_res);
end daeSubscriptExp;

public function crefShortType
  input Tpl.Text in_txt;
  input DAE.ComponentRef in_a_cr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_cr)
    local
      Tpl.Text txt;
      DAE.ComponentRef i_componentRef;
      DAE.Type i_identType;

    case ( txt,
           DAE.CREF_IDENT(identType = i_identType) )
      equation
        txt = expTypeShort(txt, i_identType);
      then txt;

    case ( txt,
           DAE.CREF_QUAL(componentRef = i_componentRef) )
      equation
        txt = crefShortType(txt, i_componentRef);
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("crefType:ERROR"));
      then txt;
  end match;
end crefShortType;

protected function fun_1210
  input Tpl.Text in_txt;
  input Boolean in_a_isPre;
  input BackendDAE.VarKind in_a_varKind;
  input Tpl.Text in_a_c__comment;
  input Integer in_a_index;
  input DAE.ComponentRef in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_isPre, in_a_varKind, in_a_c__comment, in_a_index, in_a_name)
    local
      Tpl.Text txt;
      BackendDAE.VarKind a_varKind;
      Tpl.Text a_c__comment;
      Integer a_index;
      DAE.ComponentRef a_name;

    case ( txt,
           false,
           a_varKind,
           a_c__comment,
           a_index,
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("this_function->function_vars->"));
        txt = crefTypeOMSIC(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("["));
        txt = Tpl.writeStr(txt, intString(a_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] /* "));
        txt = Tpl.writeText(txt, a_c__comment);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = CodegenUtil.variabilityString(txt, a_varKind);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" */"));
      then txt;

    case ( txt,
           _,
           a_varKind,
           a_c__comment,
           a_index,
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("this_function->pre_vars->"));
        txt = crefTypeOMSIC(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("["));
        txt = Tpl.writeStr(txt, intString(a_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] /* "));
        txt = Tpl.writeText(txt, a_c__comment);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = CodegenUtil.variabilityString(txt, a_varKind);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" */"));
      then txt;
  end match;
end fun_1210;

protected function fun_1211
  input Tpl.Text in_txt;
  input Boolean in_a_isStart;
  input SimCodeVar.SimVar in_a_var;
  input BackendDAE.VarKind in_a_varKind;
  input Tpl.Text in_a_c__comment;
  input Integer in_a_index;
  input DAE.ComponentRef in_a_name;
  input Boolean in_a_isPre;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_isStart, in_a_var, in_a_varKind, in_a_c__comment, in_a_index, in_a_name, in_a_isPre)
    local
      Tpl.Text txt;
      SimCodeVar.SimVar a_var;
      BackendDAE.VarKind a_varKind;
      Tpl.Text a_c__comment;
      Integer a_index;
      DAE.ComponentRef a_name;
      Boolean a_isPre;

    case ( txt,
           false,
           _,
           a_varKind,
           a_c__comment,
           a_index,
           a_name,
           a_isPre )
      equation
        txt = fun_1210(txt, a_isPre, a_varKind, a_c__comment, a_index, a_name);
      then txt;

    case ( txt,
           _,
           a_var,
           _,
           _,
           _,
           _,
           _ )
      equation
        txt = varAttributes(txt, a_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".start"));
      then txt;
  end match;
end fun_1211;

protected function fun_1212
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_a_var;
  input Boolean in_a_isPre;
  input Boolean in_a_isStart;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_var, in_a_isPre, in_a_isStart)
    local
      Tpl.Text txt;
      Boolean a_isPre;
      Boolean a_isStart;
      SimCodeVar.SimVar i_var;
      BackendDAE.VarKind i_varKind;
      Integer i_index;
      DAE.ComponentRef i_name;
      Tpl.Text txt_1;
      Tpl.Text l_c__comment;

    case ( txt,
           SimCodeVar.SIMVAR(varKind = BackendDAE.PARAM()),
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("ERROR: Not implemented in varArrayNameValues"));
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(varKind = BackendDAE.OPT_TGRID()),
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("ERROR: Not implemented in varArrayNameValues"));
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(varKind = BackendDAE.EXTOBJ(fullClassName = _)),
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("ERROR: Not implemented in varArrayNameValues"));
      then txt;

    case ( txt,
           (i_var as SimCodeVar.SIMVAR(name = i_name, index = i_index, varKind = i_varKind)),
           a_isPre,
           a_isStart )
      equation
        txt_1 = CodegenUtil.crefStrNoUnderscore(Tpl.emptyTxt, i_name);
        l_c__comment = CodegenUtil.escapeCComments(Tpl.emptyTxt, Tpl.textString(txt_1));
        txt = fun_1211(txt, a_isStart, i_var, i_varKind, l_c__comment, i_index, i_name, a_isPre);
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_1212;

protected function fun_1213
  input Tpl.Text in_txt;
  input Boolean in_a_isPre;
  input BackendDAE.VarKind in_a_varKind;
  input Integer in_a_index;
  input DAE.ComponentRef in_a_name;
  input Integer in_a_ix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_isPre, in_a_varKind, in_a_index, in_a_name, in_a_ix)
    local
      Tpl.Text txt;
      BackendDAE.VarKind a_varKind;
      Integer a_index;
      DAE.ComponentRef a_name;
      Integer a_ix;
      Tpl.Text txt_1;
      Tpl.Text txt_0;

    case ( txt,
           false,
           a_varKind,
           a_index,
           a_name,
           a_ix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("data->localData["));
        txt = Tpl.writeStr(txt, intString(a_ix));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("]->"));
        txt = crefShortType(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Vars["));
        txt = Tpl.writeStr(txt, intString(a_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] /* "));
        txt_0 = CodegenUtil.crefStrNoUnderscore(Tpl.emptyTxt, a_name);
        txt = CodegenUtil.escapeCComments(txt, Tpl.textString(txt_0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = CodegenUtil.variabilityString(txt, a_varKind);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" */"));
      then txt;

    case ( txt,
           _,
           a_varKind,
           a_index,
           a_name,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("data->simulationInfo->"));
        txt = crefShortType(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("VarsPre["));
        txt = Tpl.writeStr(txt, intString(a_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] /* "));
        txt_1 = CodegenUtil.crefStrNoUnderscore(Tpl.emptyTxt, a_name);
        txt = CodegenUtil.escapeCComments(txt, Tpl.textString(txt_1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = CodegenUtil.variabilityString(txt, a_varKind);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" */"));
      then txt;
  end match;
end fun_1213;

protected function fun_1214
  input Tpl.Text in_txt;
  input Boolean in_a_isStart;
  input SimCodeVar.SimVar in_a_var;
  input BackendDAE.VarKind in_a_varKind;
  input Integer in_a_index;
  input DAE.ComponentRef in_a_name;
  input Integer in_a_ix;
  input Boolean in_a_isPre;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_isStart, in_a_var, in_a_varKind, in_a_index, in_a_name, in_a_ix, in_a_isPre)
    local
      Tpl.Text txt;
      SimCodeVar.SimVar a_var;
      BackendDAE.VarKind a_varKind;
      Integer a_index;
      DAE.ComponentRef a_name;
      Integer a_ix;
      Boolean a_isPre;

    case ( txt,
           false,
           _,
           a_varKind,
           a_index,
           a_name,
           a_ix,
           a_isPre )
      equation
        txt = fun_1213(txt, a_isPre, a_varKind, a_index, a_name, a_ix);
      then txt;

    case ( txt,
           _,
           a_var,
           _,
           _,
           _,
           _,
           _ )
      equation
        txt = varAttributes(txt, a_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".start"));
      then txt;
  end match;
end fun_1214;

protected function fun_1215
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_a_var;
  input Integer in_a_ix;
  input Boolean in_a_isPre;
  input Boolean in_a_isStart;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_var, in_a_ix, in_a_isPre, in_a_isStart)
    local
      Tpl.Text txt;
      Integer a_ix;
      Boolean a_isPre;
      Boolean a_isStart;
      SimCodeVar.SimVar i_var;
      BackendDAE.VarKind i_varKind;
      Integer i_index;
      DAE.ComponentRef i_name;
      Tpl.Text txt_1;
      Tpl.Text txt_0;

    case ( txt,
           SimCodeVar.SIMVAR(varKind = (i_varKind as BackendDAE.PARAM()), name = i_name, index = i_index),
           _,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("data->simulationInfo->"));
        txt = crefShortType(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Parameter["));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] /* "));
        txt_0 = CodegenUtil.crefStrNoUnderscore(Tpl.emptyTxt, i_name);
        txt = CodegenUtil.escapeCComments(txt, Tpl.textString(txt_0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = CodegenUtil.variabilityString(txt, i_varKind);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" */"));
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(varKind = (i_varKind as BackendDAE.OPT_TGRID()), name = i_name, index = i_index),
           _,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("data->simulationInfo->"));
        txt = crefShortType(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Parameter["));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] /* "));
        txt_1 = CodegenUtil.crefStrNoUnderscore(Tpl.emptyTxt, i_name);
        txt = CodegenUtil.escapeCComments(txt, Tpl.textString(txt_1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = CodegenUtil.variabilityString(txt, i_varKind);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" */"));
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(varKind = BackendDAE.EXTOBJ(fullClassName = _), index = i_index),
           _,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("data->simulationInfo->extObjs["));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("]"));
      then txt;

    case ( txt,
           (i_var as SimCodeVar.SIMVAR(name = i_name, index = i_index, varKind = i_varKind)),
           a_ix,
           a_isPre,
           a_isStart )
      equation
        txt = fun_1214(txt, a_isStart, i_var, i_varKind, i_index, i_name, a_ix, a_isPre);
      then txt;

    case ( txt,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_1215;

protected function fun_1216
  input Tpl.Text in_txt;
  input String in_mArg;
  input SimCodeVar.SimVar in_a_var;
  input Integer in_a_ix;
  input Boolean in_a_isPre;
  input Boolean in_a_isStart;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_var, in_a_ix, in_a_isPre, in_a_isStart)
    local
      Tpl.Text txt;
      SimCodeVar.SimVar a_var;
      Integer a_ix;
      Boolean a_isPre;
      Boolean a_isStart;

    case ( txt,
           "omsic",
           a_var,
           _,
           a_isPre,
           a_isStart )
      equation
        txt = fun_1212(txt, a_var, a_isPre, a_isStart);
      then txt;

    case ( txt,
           _,
           a_var,
           a_ix,
           a_isPre,
           a_isStart )
      equation
        txt = fun_1215(txt, a_var, a_ix, a_isPre, a_isStart);
      then txt;
  end match;
end fun_1216;

public function varArrayNameValues
  input Tpl.Text txt;
  input SimCodeVar.SimVar a_var;
  input Integer a_ix;
  input Boolean a_isPre;
  input Boolean a_isStart;

  output Tpl.Text out_txt;
protected
  String ret_0;
algorithm
  ret_0 := Config.simCodeTarget();
  out_txt := fun_1216(txt, ret_0, a_var, a_ix, a_isPre, a_isStart);
end varArrayNameValues;

public function varArrayName
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_a_var;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_var)
    local
      Tpl.Text txt;
      DAE.ComponentRef i_name;

    case ( txt,
           SimCodeVar.SIMVAR(varKind = BackendDAE.PARAM(), name = i_name) )
      equation
        txt = crefShortType(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Parameter"));
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(name = i_name) )
      equation
        txt = crefShortType(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Vars"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end varArrayName;

protected function fun_1219
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;
      DAE.ComponentRef i_name;
      Integer i_index;
      SimCodeVar.SimVar i_var;
      Tpl.Text txt_0;

    case ( txt,
           (i_var as SimCodeVar.SIMVAR(index = i_index, name = i_name)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("data->modelData->"));
        txt = varArrayName(txt, i_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Data["));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].info /* "));
        txt_0 = CodegenUtil.crefStrNoUnderscore(Tpl.emptyTxt, i_name);
        txt = CodegenUtil.escapeCComments(txt, Tpl.textString(txt_0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" */"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_1219;

public function crefVarInfo
  input Tpl.Text txt;
  input DAE.ComponentRef a_cr;

  output Tpl.Text out_txt;
protected
  SimCodeVar.SimVar ret_1;
  SimCode.SimCode ret_0;
algorithm
  ret_0 := SimCodeUtil.getSimCode();
  ret_1 := SimCodeUtil.cref2simvar(a_cr, ret_0);
  out_txt := fun_1219(txt, ret_1);
end crefVarInfo;

public function varAttributes
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_a_var;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_var)
    local
      Tpl.Text txt;
      BackendDAE.VarKind i_varKind;
      Integer i_index;
      SimCodeVar.SimVar i_var;
      DAE.ComponentRef i_name;
      Tpl.Text txt_0;

    case ( txt,
           SimCodeVar.SIMVAR(index = -1, name = i_name) )
      equation
        txt = crefAttributes(txt, i_name);
      then txt;

    case ( txt,
           (i_var as SimCodeVar.SIMVAR(index = i_index, name = i_name, varKind = i_varKind)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("data->modelData->"));
        txt = varArrayName(txt, i_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Data["));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].attribute /* "));
        txt_0 = CodegenUtil.crefStrNoUnderscore(Tpl.emptyTxt, i_name);
        txt = CodegenUtil.escapeCComments(txt, Tpl.textString(txt_0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = CodegenUtil.variabilityString(txt, i_varKind);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" */"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end varAttributes;

protected function fun_1222
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input DAE.ComponentRef in_a_name;
  input Integer in_a_index;
  input SimCodeVar.SimVar in_a_var;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_name, in_a_index, in_a_var)
    local
      Tpl.Text txt;
      DAE.ComponentRef a_name;
      Integer a_index;
      SimCodeVar.SimVar a_var;
      Tpl.Text txt_1;
      Tpl.Text txt_0;

    case ( txt,
           false,
           a_name,
           a_index,
           a_var )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("data->modelData->"));
        txt = varArrayName(txt, a_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Data["));
        txt = Tpl.writeStr(txt, intString(a_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("].attribute /* "));
        txt_0 = CodegenUtil.crefStrNoUnderscore(Tpl.emptyTxt, a_name);
        txt = CodegenUtil.escapeCComments(txt, Tpl.textString(txt_0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" */"));
      then txt;

    case ( txt,
           _,
           a_name,
           a_index,
           _ )
      equation
        txt_1 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("varAttributes got negative index="));
        txt_1 = Tpl.writeStr(txt_1, intString(a_index));
        txt_1 = Tpl.writeTok(txt_1, Tpl.ST_STRING(" for "));
        txt_1 = CodegenUtil.crefStr(txt_1, a_name);
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenCFunctions.tpl", 7628, 34), Tpl.textString(txt_1));
      then txt;
  end match;
end fun_1222;

protected function fun_1223
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;
      DAE.ComponentRef i_name;
      SimCodeVar.SimVar i_var;
      Integer i_index;
      Boolean ret_0;

    case ( txt,
           SimCodeVar.SIMVAR(index = -1, varKind = BackendDAE.JAC_VAR()) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("dummyREAL_ATTRIBUTE"));
      then txt;

    case ( txt,
           (i_var as SimCodeVar.SIMVAR(index = i_index, name = i_name)) )
      equation
        ret_0 = intLt(i_index, 0);
        txt = fun_1222(txt, ret_0, i_name, i_index, i_var);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_1223;

public function crefAttributes
  input Tpl.Text txt;
  input DAE.ComponentRef a_cr;

  output Tpl.Text out_txt;
protected
  SimCodeVar.SimVar ret_2;
  SimCode.SimCode ret_1;
  DAE.ComponentRef ret_0;
algorithm
  ret_0 := ComponentReference.crefRemovePrePrefix(a_cr);
  ret_1 := SimCodeUtil.getSimCode();
  ret_2 := SimCodeUtil.cref2simvar(ret_0, ret_1);
  out_txt := fun_1223(txt, ret_2);
end crefAttributes;

protected function fun_1225
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty)
    local
      Tpl.Text txt;

    case ( txt,
           DAE.T_INTEGER(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(omsi_int)"));
      then txt;

    case ( txt,
           DAE.T_ENUMERATION(index = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(omsi_int)"));
      then txt;

    case ( txt,
           DAE.T_REAL(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(omsi_real)"));
      then txt;

    case ( txt,
           DAE.T_BOOL(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(omsi_bool)"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_1225;

protected function fun_1226
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty)
    local
      Tpl.Text txt;

    case ( txt,
           DAE.T_INTEGER(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(modelica_integer)"));
      then txt;

    case ( txt,
           DAE.T_ENUMERATION(index = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(modelica_integer)"));
      then txt;

    case ( txt,
           DAE.T_REAL(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(modelica_real)"));
      then txt;

    case ( txt,
           DAE.T_BOOL(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(modelica_boolean)"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_1226;

public function typeCastContext
  input Tpl.Text in_txt;
  input SimCodeFunction.Context in_a_context;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_context, in_a_ty)
    local
      Tpl.Text txt;
      DAE.Type a_ty;

    case ( txt,
           SimCodeFunction.OMSI_CONTEXT(hashTable = _),
           a_ty )
      equation
        txt = fun_1225(txt, a_ty);
      then txt;

    case ( txt,
           _,
           a_ty )
      equation
        txt = fun_1226(txt, a_ty);
      then txt;
  end match;
end typeCastContext;

protected function fun_1228
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty)
    local
      Tpl.Text txt;

    case ( txt,
           DAE.T_INTEGER(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(omsi_int)"));
      then txt;

    case ( txt,
           DAE.T_ENUMERATION(index = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(omsi_int)"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_1228;

protected function fun_1229
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty)
    local
      Tpl.Text txt;

    case ( txt,
           DAE.T_ENUMERATION(index = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(modelica_integer)"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_1229;

public function typeCastContextInt
  input Tpl.Text in_txt;
  input SimCodeFunction.Context in_a_context;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_context, in_a_ty)
    local
      Tpl.Text txt;
      DAE.Type a_ty;

    case ( txt,
           SimCodeFunction.OMSI_CONTEXT(hashTable = _),
           a_ty )
      equation
        txt = fun_1228(txt, a_ty);
      then txt;

    case ( txt,
           _,
           a_ty )
      equation
        txt = fun_1229(txt, a_ty);
      then txt;
  end match;
end typeCastContextInt;

annotation(__OpenModelica_Interface="backend");
end CodegenCFunctions;