encapsulated package CodegenCppCommon
"
  file:        CodegenCppCommon.mo
  package:     CodegenCppCommon
  description: Generated by Susan.
"

public import Tpl;

public import SimCodeVar;
public import SimCode;
public import SimCodeFunction;
public import SimCodeUtil;
public import SimCodeFunctionUtil;
public import BackendDAE;
public import System;
public import Absyn;
public import AbsynUtil;
public import DAE;
public import ClassInf;
public import Util;
public import List;
public import ComponentReference;
public import Expression;
public import ExpressionDump;
public import Config;
public import Flags;
public import Error;
public import Values;
public import ValuesUtil;
public import Types;
public import CodegenUtil;
protected import ExpressionDumpTpl;

public function cref
  input Tpl.Text in_txt;
  input DAE.ComponentRef in_a_cr;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_cr, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      DAE.ComponentRef i_cr;

    case ( txt,
           DAE.CREF_IDENT(ident = "time"),
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_simTime"));
      then txt;

    case ( txt,
           DAE.WILD(),
           _ )
      then txt;

    case ( txt,
           i_cr,
           a_useFlatArrayNotation )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = crefToCStr(txt, i_cr, a_useFlatArrayNotation);
      then txt;
  end match;
end cref;

public function localCref
  input Tpl.Text in_txt;
  input DAE.ComponentRef in_a_cr;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_cr, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      DAE.ComponentRef i_cr;

    case ( txt,
           DAE.CREF_IDENT(ident = "time"),
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_simTime"));
      then txt;

    case ( txt,
           DAE.WILD(),
           _ )
      then txt;

    case ( txt,
           i_cr,
           a_useFlatArrayNotation )
      equation
        txt = crefToCStr(txt, i_cr, a_useFlatArrayNotation);
      then txt;
  end match;
end localCref;

protected function lm_42
  input Tpl.Text in_txt;
  input list<DAE.Subscript> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<DAE.Subscript> rest;
      DAE.Subscript i_s;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_s :: rest )
      equation
        txt = subscriptToCStr(txt, i_s);
        txt = Tpl.nextIter(txt);
        txt = lm_42(txt, rest);
      then txt;
  end match;
end lm_42;

protected function lm_43
  input Tpl.Text in_txt;
  input list<DAE.Subscript> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<DAE.Subscript> rest;
      DAE.Subscript i_s;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_s :: rest )
      equation
        txt = subscriptToCStr(txt, i_s);
        txt = Tpl.nextIter(txt);
        txt = lm_43(txt, rest);
      then txt;
  end match;
end lm_43;

protected function fun_44
  input Tpl.Text in_txt;
  input Boolean in_a_useFlatArrayNotation;
  input list<DAE.Subscript> in_a_subscripts;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_useFlatArrayNotation, in_a_subscripts)
    local
      Tpl.Text txt;
      list<DAE.Subscript> a_subscripts;

    case ( txt,
           false,
           a_subscripts )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_42(txt, a_subscripts);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           _,
           a_subscripts )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING("_")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_43(txt, a_subscripts);
        txt = Tpl.popIter(txt);
      then txt;
  end match;
end fun_44;

public function subscriptsToCStr
  input Tpl.Text in_txt;
  input list<DAE.Subscript> in_a_subscripts;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_subscripts, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      list<DAE.Subscript> i_subscripts;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_subscripts,
           a_useFlatArrayNotation )
      equation
        txt = fun_44(txt, a_useFlatArrayNotation, i_subscripts);
      then txt;
  end match;
end subscriptsToCStr;

protected function fun_46
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_exp)
    local
      Tpl.Text txt;
      DAE.ComponentRef i_cr;
      Integer i_i;

    case ( txt,
           DAE.ICONST(integer = i_i) )
      equation
        txt = Tpl.writeStr(txt, intString(i_i));
      then txt;

    case ( txt,
           DAE.ENUM_LITERAL(index = i_i) )
      equation
        txt = Tpl.writeStr(txt, intString(i_i));
      then txt;

    case ( txt,
           DAE.CREF(componentRef = i_cr) )
      equation
        txt = crefToCStr(txt, i_cr, false);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_46;

public function subscriptToCStr
  input Tpl.Text in_txt;
  input DAE.Subscript in_a_subscript;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_subscript)
    local
      Tpl.Text txt;
      DAE.Exp i_exp;
      Integer i_i;

    case ( txt,
           DAE.SLICE(exp = DAE.ICONST(integer = i_i)) )
      equation
        txt = Tpl.writeStr(txt, intString(i_i));
      then txt;

    case ( txt,
           DAE.WHOLEDIM() )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("WHOLEDIM"));
      then txt;

    case ( txt,
           DAE.INDEX(exp = i_exp) )
      equation
        txt = fun_46(txt, i_exp);
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("UNKNOWN_SUBSCRIPT"));
      then txt;
  end match;
end subscriptToCStr;

protected function fun_48
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input list<DAE.Subscript> in_a_subscriptLst;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_subscriptLst)
    local
      Tpl.Text txt;
      list<DAE.Subscript> a_subscriptLst;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_subscriptLst )
      equation
        txt = subscriptsToCStrForArray(txt, a_subscriptLst);
      then txt;
  end match;
end fun_48;

public function crefToCStrForArray
  input Tpl.Text in_txt;
  input DAE.ComponentRef in_a_cr;
  input Tpl.Text in_a_dims;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_dims;
algorithm
  (out_txt, out_a_dims) :=
  match(in_txt, in_a_cr, in_a_dims)
    local
      Tpl.Text txt;
      Tpl.Text a_dims;
      DAE.ComponentRef i_componentRef;
      DAE.Ident i_ident;
      list<DAE.Subscript> i_subscriptLst;
      Boolean ret_2;
      Tpl.Text l_subs;
      Integer ret_0;

    case ( txt,
           DAE.CREF_IDENT(subscriptLst = i_subscriptLst, ident = i_ident),
           a_dims )
      equation
        ret_0 = listLength(i_subscriptLst);
        a_dims = Tpl.writeStr(a_dims, intString(ret_0));
        txt = Tpl.writeStr(txt, i_ident);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
      then (txt, a_dims);

    case ( txt,
           DAE.CREF_QUAL(subscriptLst = i_subscriptLst, ident = i_ident, componentRef = i_componentRef),
           a_dims )
      equation
        ret_2 = Flags.isSet(Flags.NF_SCALARIZE);
        l_subs = fun_48(Tpl.emptyTxt, ret_2, i_subscriptLst);
        txt = Tpl.writeStr(txt, i_ident);
        txt = Tpl.writeText(txt, l_subs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_P_"));
        (txt, a_dims) = crefToCStrForArray(txt, i_componentRef, a_dims);
      then (txt, a_dims);

    case ( txt,
           DAE.WILD(),
           a_dims )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
      then (txt, a_dims);

    case ( txt,
           _,
           a_dims )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("CREF_NOT_IDENT_OR_QUAL"));
      then (txt, a_dims);
  end match;
end crefToCStrForArray;

public function crefToCStr1
  input Tpl.Text in_txt;
  input DAE.ComponentRef in_a_cr;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_cr, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      DAE.ComponentRef i_componentRef;
      list<DAE.Subscript> i_subscriptLst;
      DAE.Ident i_ident;

    case ( txt,
           DAE.CREF_IDENT(ident = i_ident),
           _ )
      equation
        txt = Tpl.writeStr(txt, i_ident);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
      then txt;

    case ( txt,
           DAE.CREF_QUAL(ident = i_ident, subscriptLst = i_subscriptLst, componentRef = i_componentRef),
           a_useFlatArrayNotation )
      equation
        txt = Tpl.writeStr(txt, i_ident);
        txt = subscriptsToCStrForArray(txt, i_subscriptLst);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_P_"));
        txt = crefToCStr1(txt, i_componentRef, a_useFlatArrayNotation);
      then txt;

    case ( txt,
           DAE.WILD(),
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
      then txt;

    case ( txt,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("CREF_NOT_IDENT_OR_QUAL"));
      then txt;
  end match;
end crefToCStr1;

protected function lm_51
  input Tpl.Text in_txt;
  input list<DAE.Subscript> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<DAE.Subscript> rest;
      DAE.Subscript i_s;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_s :: rest )
      equation
        txt = subscriptToCStr(txt, i_s);
        txt = Tpl.nextIter(txt);
        txt = lm_51(txt, rest);
      then txt;
  end match;
end lm_51;

public function subscriptsToCStrForArray
  input Tpl.Text in_txt;
  input list<DAE.Subscript> in_a_subscripts;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_subscripts)
    local
      Tpl.Text txt;
      list<DAE.Subscript> i_subscripts;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_subscripts )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING("$c")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_51(txt, i_subscripts);
        txt = Tpl.popIter(txt);
      then txt;
  end match;
end subscriptsToCStrForArray;

public function crefStrForWriteOutput
  input Tpl.Text in_txt;
  input DAE.ComponentRef in_a_cr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_cr)
    local
      Tpl.Text txt;
      DAE.ComponentRef i_componentRef;
      DAE.Ident i_ident;
      list<DAE.Subscript> i_subscriptLst;

    case ( txt,
           DAE.CREF_IDENT(ident = "xloc", subscriptLst = i_subscriptLst) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("__xd"));
        txt = subscriptsStrForWriteOutput(txt, i_subscriptLst);
      then txt;

    case ( txt,
           DAE.CREF_IDENT(ident = "time") )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_simTime"));
      then txt;

    case ( txt,
           DAE.CREF_IDENT(ident = i_ident, subscriptLst = i_subscriptLst) )
      equation
        txt = Tpl.writeStr(txt, i_ident);
        txt = subscriptsStrForWriteOutput(txt, i_subscriptLst);
      then txt;

    case ( txt,
           DAE.CREF_QUAL(ident = "$DER", componentRef = i_componentRef) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("der("));
        txt = crefStrForWriteOutput(txt, i_componentRef);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.CREF_QUAL(ident = "$CLKPRE", componentRef = i_componentRef) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("previous("));
        txt = crefStrForWriteOutput(txt, i_componentRef);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.CREF_QUAL(ident = i_ident, subscriptLst = i_subscriptLst, componentRef = i_componentRef) )
      equation
        txt = Tpl.writeStr(txt, i_ident);
        txt = subscriptsStrForWriteOutput(txt, i_subscriptLst);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("."));
        txt = crefStrForWriteOutput(txt, i_componentRef);
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("CREF_NOT_IDENT_OR_QUAL"));
      then txt;
  end match;
end crefStrForWriteOutput;

public function crefStrForSetVariables
  input Tpl.Text in_txt;
  input DAE.ComponentRef in_a_cr;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_cr, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      DAE.ComponentRef i_cr;

    case ( txt,
           DAE.CREF_QUAL(ident = "$DER"),
           _ )
      then txt;

    case ( txt,
           i_cr,
           a_useFlatArrayNotation )
      equation
        txt = cref(txt, i_cr, a_useFlatArrayNotation);
      then txt;
  end match;
end crefStrForSetVariables;

protected function lm_55
  input Tpl.Text in_txt;
  input list<DAE.Subscript> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<DAE.Subscript> rest;
      DAE.Subscript i_s;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_s :: rest )
      equation
        txt = subscriptStr(txt, i_s);
        txt = Tpl.nextIter(txt);
        txt = lm_55(txt, rest);
      then txt;
  end match;
end lm_55;

public function subscriptsStrForWriteOutput
  input Tpl.Text in_txt;
  input list<DAE.Subscript> in_a_subscripts;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_subscripts)
    local
      Tpl.Text txt;
      list<DAE.Subscript> i_subscripts;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_subscripts )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("["));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_55(txt, i_subscripts);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("]"));
      then txt;
  end match;
end subscriptsStrForWriteOutput;

public function crefStr
  input Tpl.Text in_txt;
  input DAE.ComponentRef in_a_cr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_cr)
    local
      Tpl.Text txt;
      DAE.ComponentRef i_componentRef;
      DAE.Ident i_ident;
      list<DAE.Subscript> i_subscriptLst;
      String ret_1;
      String ret_0;

    case ( txt,
           DAE.CREF_IDENT(ident = "xloc", subscriptLst = i_subscriptLst) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("__xd"));
        txt = subscriptsStr(txt, i_subscriptLst);
      then txt;

    case ( txt,
           DAE.CREF_IDENT(ident = "time") )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_simTime"));
      then txt;

    case ( txt,
           DAE.CREF_IDENT(ident = i_ident, subscriptLst = i_subscriptLst) )
      equation
        ret_0 = System.unquoteIdentifier(i_ident);
        txt = Tpl.writeStr(txt, ret_0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = subscriptsStr(txt, i_subscriptLst);
      then txt;

    case ( txt,
           DAE.CREF_QUAL(ident = i_ident, subscriptLst = i_subscriptLst, componentRef = i_componentRef) )
      equation
        ret_1 = System.unquoteIdentifier(i_ident);
        txt = Tpl.writeStr(txt, ret_1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = subscriptsStr(txt, i_subscriptLst);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("."));
        txt = crefStr(txt, i_componentRef);
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("CREF_NOT_IDENT_OR_QUAL"));
      then txt;
  end match;
end crefStr;

protected function lm_58
  input Tpl.Text in_txt;
  input list<DAE.Subscript> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<DAE.Subscript> rest;
      DAE.Subscript i_s;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_s :: rest )
      equation
        txt = subscriptStr(txt, i_s);
        txt = Tpl.nextIter(txt);
        txt = lm_58(txt, rest);
      then txt;
  end match;
end lm_58;

public function subscriptsStr
  input Tpl.Text in_txt;
  input list<DAE.Subscript> in_a_subscripts;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_subscripts)
    local
      Tpl.Text txt;
      list<DAE.Subscript> i_subscripts;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_subscripts )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_58(txt, i_subscripts);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;
  end match;
end subscriptsStr;

public function subscriptStr
  input Tpl.Text in_txt;
  input DAE.Subscript in_a_subscript;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_subscript)
    local
      Tpl.Text txt;
      Integer i_i;

    case ( txt,
           DAE.INDEX(exp = DAE.ICONST(integer = i_i)) )
      equation
        txt = Tpl.writeStr(txt, intString(i_i));
      then txt;

    case ( txt,
           DAE.SLICE(exp = DAE.ICONST(integer = i_i)) )
      equation
        txt = Tpl.writeStr(txt, intString(i_i));
      then txt;

    case ( txt,
           DAE.WHOLEDIM() )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("WHOLEDIM"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("UNKNOWN_SUBSCRIPT"));
      then txt;
  end match;
end subscriptStr;

protected function fun_61
  input Tpl.Text in_txt;
  input SimCodeFunction.Context in_a_context;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_varDeclsCref;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input DAE.ComponentRef in_a_cr;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_varDeclsCref;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_varDeclsCref, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_a_context, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_varDeclsCref, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_cr)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_varDeclsCref;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      DAE.ComponentRef a_cr;
      SimCodeFunction.Context i_context;

    case ( txt,
           SimCodeFunction.FUNCTION_CONTEXT(cref_prefix = _),
           _,
           a_stateDerVectorName,
           a_varDeclsCref,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_cr )
      equation
        txt = crefStr(txt, a_cr);
      then (txt, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           i_context,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_varDeclsCref,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_cr )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_varDeclsCref, a_stateDerVectorName) = cref1(txt, a_cr, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, i_context, a_varDeclsCref, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_61;

public function contextCref
  input Tpl.Text in_txt;
  input DAE.ComponentRef in_a_cr;
  input SimCodeFunction.Context in_a_context;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_cr, in_a_context, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      DAE.ComponentRef i_cr;
      DAE.ComponentRef i_componentRef;
      Tpl.Text l_varDeclsCref;

    case ( txt,
           DAE.CREF_QUAL(ident = "$PRE", componentRef = i_componentRef),
           a_context,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_discrete_events->pre("));
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = contextCref(txt, i_componentRef, a_context, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           i_cr,
           a_context,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_varDeclsCref = Tpl.emptyTxt;
        (txt, a_stateDerVectorName, l_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_61(txt, a_context, a_useFlatArrayNotation, a_stateDerVectorName, l_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, i_cr);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end contextCref;

protected function fun_63
  input Tpl.Text in_txt;
  input SimCodeFunction.Context in_a_context;
  input DAE.ComponentRef in_a_cr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_context, in_a_cr)
    local
      Tpl.Text txt;
      DAE.ComponentRef a_cr;

    case ( txt,
           SimCodeFunction.FUNCTION_CONTEXT(cref_prefix = _),
           a_cr )
      equation
        txt = crefStr(txt, a_cr);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_63;

public function contextCref2
  input Tpl.Text txt;
  input DAE.ComponentRef a_cr;
  input SimCodeFunction.Context a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_63(txt, a_context, a_cr);
end contextCref2;

protected function fun_65
  input Tpl.Text in_txt;
  input SimCodeFunction.Context in_a_context;
  input String in_a_funName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_context, in_a_funName)
    local
      Tpl.Text txt;
      String a_funName;

    case ( txt,
           SimCodeFunction.FUNCTION_CONTEXT(cref_prefix = _),
           a_funName )
      equation
        txt = Tpl.writeStr(txt, a_funName);
      then txt;

    case ( txt,
           _,
           a_funName )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_functions->"));
        txt = Tpl.writeStr(txt, a_funName);
      then txt;
  end match;
end fun_65;

public function contextFunName
  input Tpl.Text txt;
  input String a_funName;
  input SimCodeFunction.Context a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_65(txt, a_context, a_funName);
end contextFunName;

public function contextIteratorName
  input Tpl.Text txt;
  input Absyn.Ident a_name;
  input SimCodeFunction.Context a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt := Tpl.writeStr(txt, a_name);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("_"));
end contextIteratorName;

public function crefWithIndex
  input Tpl.Text in_txt;
  input DAE.ComponentRef in_a_cr;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_cr, in_a_context, in_a_varDecls, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_varDecls;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      DAE.ComponentRef i_cr;

    case ( txt,
           (i_cr as DAE.CREF_QUAL(ident = _)),
           a_context,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = crefToCStrWithIndex(txt, i_cr, a_context, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end crefWithIndex;

protected function fun_69
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input list<DAE.Subscript> in_a_subscriptLst;
  input Tpl.Text in_a_identTmp;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_a_exp, in_a_subscriptLst, in_a_identTmp, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Subscript> a_subscriptLst;
      Tpl.Text a_identTmp;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.ComponentRef i_componentRef;
      DAE.Exp i_e;
      Tpl.Text l_tmp;

    case ( txt,
           (i_e as DAE.CREF(componentRef = i_componentRef)),
           a_subscriptLst,
           a_identTmp,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (l_tmp, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExpCrefRhs(Tpl.emptyTxt, i_e, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeText(txt, a_identTmp);
        txt = Tpl.writeText(txt, l_tmp);
        txt = subscriptsToCStrForArray(txt, a_subscriptLst);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_P_"));
        txt = crefToCStr(txt, i_componentRef, a_useFlatArrayNotation);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);

    case ( txt,
           _,
           _,
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);
  end match;
end fun_69;

protected function fun_70
  input Tpl.Text in_txt;
  input DAE.Subscript in_mArg;
  input list<DAE.Subscript> in_a_subscriptLst;
  input Tpl.Text in_a_identTmp;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_mArg, in_a_subscriptLst, in_a_identTmp, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Subscript> a_subscriptLst;
      Tpl.Text a_identTmp;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Exp i_exp;

    case ( txt,
           DAE.INDEX(exp = i_exp),
           a_subscriptLst,
           a_identTmp,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = fun_69(txt, i_exp, a_subscriptLst, a_identTmp, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);

    case ( txt,
           _,
           _,
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);
  end match;
end fun_70;

protected function fun_71
  input Tpl.Text in_txt;
  input DAE.ComponentRef in_a_cr;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_a_cr, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      list<DAE.Subscript> i_subscriptLst;
      DAE.Ident i_ident;
      DAE.Subscript ret_1;
      Tpl.Text l_identTmp;

    case ( txt,
           DAE.CREF_QUAL(ident = i_ident, subscriptLst = i_subscriptLst),
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        l_identTmp = Tpl.writeStr(Tpl.emptyTxt, i_ident);
        ret_1 = listHead(i_subscriptLst);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = fun_70(txt, ret_1, i_subscriptLst, l_identTmp, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);

    case ( txt,
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           a_preExp,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("CREF_NOT_IDENT_OR_QUAL"));
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);
  end match;
end fun_71;

public function crefToCStrWithIndex
  input Tpl.Text txt;
  input DAE.ComponentRef a_cr;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_varDecls;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
protected
  Tpl.Text l_tmp;
  Tpl.Text l_preExp;
algorithm
  l_preExp := Tpl.emptyTxt;
  l_tmp := Tpl.emptyTxt;
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, l_preExp) := fun_71(txt, a_cr, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, l_preExp, a_context);
end crefToCStrWithIndex;

protected function fun_73
  input Tpl.Text in_txt;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_context)
    local
      Tpl.Text txt;

    case ( txt,
           SimCodeFunction.ALGLOOP_CONTEXT(genInitialisation = false) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_system->_simTime"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_simTime"));
      then txt;
  end match;
end fun_73;

public function cref1
  input Tpl.Text in_txt;
  input DAE.ComponentRef in_a_cr;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_varDecls, out_a_stateDerVectorName) :=
  match(in_txt, in_a_cr, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_context, in_a_varDecls, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      SimCodeFunction.Context a_context;
      Tpl.Text a_varDecls;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      DAE.ComponentRef i_componentRef;
      DAE.ComponentRef i_cr;

    case ( txt,
           (i_cr as DAE.CREF_IDENT(ident = "xloc")),
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_context,
           a_varDecls,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_varDecls, a_stateDerVectorName) = representationCref(txt, i_cr, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_context, a_varDecls, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_varDecls, a_stateDerVectorName);

    case ( txt,
           DAE.CREF_IDENT(ident = "time"),
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_context,
           a_varDecls,
           a_stateDerVectorName,
           _ )
      equation
        txt = fun_73(txt, a_context);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_varDecls, a_stateDerVectorName);

    case ( txt,
           DAE.CREF_QUAL(ident = "$START", componentRef = i_componentRef),
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_context,
           a_varDecls,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_varDecls, a_stateDerVectorName) = representationCref(txt, i_componentRef, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_context, a_varDecls, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_varDecls, a_stateDerVectorName);

    case ( txt,
           i_cr,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_context,
           a_varDecls,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_varDecls, a_stateDerVectorName) = representationCref(txt, i_cr, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_context, a_varDecls, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_varDecls, a_stateDerVectorName);
  end match;
end cref1;

protected function fun_75
  input Tpl.Text in_txt;
  input SimCodeFunction.Context in_a_context;
  input Boolean in_a_useFlatArrayNotation;
  input DAE.ComponentRef in_a_inCref;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_context, in_a_useFlatArrayNotation, in_a_inCref)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      DAE.ComponentRef a_inCref;

    case ( txt,
           SimCodeFunction.ALGLOOP_CONTEXT(genInitialisation = false, genJacobian = false),
           a_useFlatArrayNotation,
           a_inCref )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_system->"));
        txt = cref(txt, a_inCref, a_useFlatArrayNotation);
      then txt;

    case ( txt,
           SimCodeFunction.ALGLOOP_CONTEXT(genInitialisation = false, genJacobian = true),
           _,
           a_inCref )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_system->_"));
        txt = crefToCStr(txt, a_inCref, false);
      then txt;

    case ( txt,
           SimCodeFunction.JACOBIAN_CONTEXT(jacHT = _),
           _,
           a_inCref )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = crefToCStr(txt, a_inCref, false);
      then txt;

    case ( txt,
           _,
           a_useFlatArrayNotation,
           a_inCref )
      equation
        txt = cref(txt, a_inCref, a_useFlatArrayNotation);
      then txt;
  end match;
end fun_75;

protected function fun_76
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_a_var;
  input SimCodeFunction.Context in_a_context;
  input Boolean in_a_useFlatArrayNotation;
  input DAE.ComponentRef in_a_inCref;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_var, in_a_context, in_a_useFlatArrayNotation, in_a_inCref)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Boolean a_useFlatArrayNotation;
      DAE.ComponentRef a_inCref;

    case ( txt,
           SimCodeVar.SIMVAR(index = -2),
           _,
           a_useFlatArrayNotation,
           a_inCref )
      equation
        txt = localCref(txt, a_inCref, a_useFlatArrayNotation);
      then txt;

    case ( txt,
           _,
           a_context,
           a_useFlatArrayNotation,
           a_inCref )
      equation
        txt = fun_75(txt, a_context, a_useFlatArrayNotation, a_inCref);
      then txt;
  end match;
end fun_76;

protected function fun_77
  input Tpl.Text in_txt;
  input BackendDAE.VarKind in_a_varKind;
  input Boolean in_a_useFlatArrayNotation;
  input DAE.ComponentRef in_a_inCref;
  input SimCodeVar.SimVar in_a_var;
  input Option<String> in_a_matrixName;
  input SimCodeFunction.Context in_a_context;
  input Integer in_a_i;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_varKind, in_a_useFlatArrayNotation, in_a_inCref, in_a_var, in_a_matrixName, in_a_context, in_a_i)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      DAE.ComponentRef a_inCref;
      SimCodeVar.SimVar a_var;
      Option<String> a_matrixName;
      SimCodeFunction.Context a_context;
      Integer a_i;
      String ret_2;
      String ret_1;
      String ret_0;

    case ( txt,
           BackendDAE.STATE(index = _),
           _,
           _,
           _,
           _,
           _,
           a_i )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("__z["));
        txt = Tpl.writeStr(txt, intString(a_i));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("]"));
      then txt;

    case ( txt,
           BackendDAE.STATE_DER(),
           _,
           _,
           _,
           _,
           _,
           a_i )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("__zDot["));
        txt = Tpl.writeStr(txt, intString(a_i));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("]"));
      then txt;

    case ( txt,
           BackendDAE.DAE_RESIDUAL_VAR(),
           _,
           _,
           _,
           _,
           _,
           a_i )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("__daeResidual["));
        txt = Tpl.writeStr(txt, intString(a_i));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("]"));
      then txt;

    case ( txt,
           BackendDAE.JAC_VAR(),
           _,
           _,
           _,
           a_matrixName,
           a_context,
           a_i )
      equation
        txt = contextSystem(txt, a_context);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        ret_0 = Util.getOption(a_matrixName);
        txt = Tpl.writeStr(txt, ret_0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("jac_y("));
        txt = Tpl.writeStr(txt, intString(a_i));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           BackendDAE.JAC_DIFF_VAR(),
           _,
           _,
           _,
           a_matrixName,
           a_context,
           a_i )
      equation
        txt = contextSystem(txt, a_context);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        ret_1 = Util.getOption(a_matrixName);
        txt = Tpl.writeStr(txt, ret_1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("jac_tmp("));
        txt = Tpl.writeStr(txt, intString(a_i));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           BackendDAE.SEED_VAR(),
           _,
           _,
           _,
           a_matrixName,
           a_context,
           a_i )
      equation
        txt = contextSystem(txt, a_context);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        ret_2 = Util.getOption(a_matrixName);
        txt = Tpl.writeStr(txt, ret_2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("jac_x("));
        txt = Tpl.writeStr(txt, intString(a_i));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           BackendDAE.VARIABLE(),
           a_useFlatArrayNotation,
           a_inCref,
           a_var,
           _,
           a_context,
           _ )
      equation
        txt = fun_76(txt, a_var, a_context, a_useFlatArrayNotation, a_inCref);
      then txt;

    case ( txt,
           _,
           a_useFlatArrayNotation,
           a_inCref,
           _,
           _,
           a_context,
           _ )
      equation
        txt = contextSystem(txt, a_context);
        txt = cref(txt, a_inCref, a_useFlatArrayNotation);
      then txt;
  end match;
end fun_77;

protected function smf_78
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_it;
  input Boolean in_a_useFlatArrayNotation;
  input DAE.ComponentRef in_a_inCref;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_it, in_a_useFlatArrayNotation, in_a_inCref, in_a_context)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      DAE.ComponentRef a_inCref;
      SimCodeFunction.Context a_context;
      SimCodeVar.SimVar i_var;
      Option<String> i_matrixName;
      Integer i_i;
      BackendDAE.VarKind i_varKind;

    case ( txt,
           (i_var as SimCodeVar.SIMVAR(varKind = i_varKind, index = i_i, matrixName = i_matrixName)),
           a_useFlatArrayNotation,
           a_inCref,
           a_context )
      equation
        txt = fun_77(txt, i_varKind, a_useFlatArrayNotation, a_inCref, i_var, i_matrixName, a_context, i_i);
      then txt;

    case ( txt,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end smf_78;

public function representationCref
  input Tpl.Text txt;
  input DAE.ComponentRef a_inCref;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_stateDerVectorName;
protected
  SimCodeVar.SimVar ret_0;
algorithm
  ret_0 := SimCodeUtil.cref2simvar(a_inCref, a_simCode);
  out_txt := smf_78(txt, ret_0, a_useFlatArrayNotation, a_inCref, a_context);
  out_a_extraFuncs := a_extraFuncs;
  out_a_extraFuncsDecl := a_extraFuncsDecl;
  out_a_extraFuncsNamespace := a_extraFuncsNamespace;
  out_a_varDecls := a_varDecls;
  out_a_stateDerVectorName := a_stateDerVectorName;
end representationCref;

public function crefToCStrWithoutIndexOperator
  input Tpl.Text in_txt;
  input DAE.ComponentRef in_a_cr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_cr)
    local
      Tpl.Text txt;
      DAE.ComponentRef i_componentRef;
      list<DAE.Subscript> i_subscriptLst;
      DAE.Ident i_ident;
      String ret_1;
      String ret_0;

    case ( txt,
           DAE.CREF_IDENT(ident = i_ident, subscriptLst = i_subscriptLst) )
      equation
        ret_0 = System.unquoteIdentifier(i_ident);
        txt = Tpl.writeStr(txt, ret_0);
        txt = subscriptsToCStrWithoutIndexOperator(txt, i_subscriptLst);
      then txt;

    case ( txt,
           DAE.CREF_QUAL(ident = i_ident, subscriptLst = i_subscriptLst, componentRef = i_componentRef) )
      equation
        ret_1 = System.unquoteIdentifier(i_ident);
        txt = Tpl.writeStr(txt, ret_1);
        txt = subscriptsToCStrWithoutIndexOperator(txt, i_subscriptLst);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("$P"));
        txt = crefToCStrWithoutIndexOperator(txt, i_componentRef);
      then txt;

    case ( txt,
           DAE.WILD() )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("CREF_NOT_IDENT_OR_QUAL"));
      then txt;
  end match;
end crefToCStrWithoutIndexOperator;

protected function lm_81
  input Tpl.Text in_txt;
  input list<DAE.Subscript> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<DAE.Subscript> rest;
      DAE.Subscript i_s;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_s :: rest )
      equation
        txt = subscriptToCStrWithoutIndexOperator(txt, i_s);
        txt = Tpl.nextIter(txt);
        txt = lm_81(txt, rest);
      then txt;
  end match;
end lm_81;

public function subscriptsToCStrWithoutIndexOperator
  input Tpl.Text in_txt;
  input list<DAE.Subscript> in_a_subscripts;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_subscripts)
    local
      Tpl.Text txt;
      list<DAE.Subscript> i_subscripts;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_subscripts )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("$lB"));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING("$c")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_81(txt, i_subscripts);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("$rB"));
      then txt;
  end match;
end subscriptsToCStrWithoutIndexOperator;

protected function fun_83
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_exp)
    local
      Tpl.Text txt;
      Integer i_i;

    case ( txt,
           DAE.ICONST(integer = i_i) )
      equation
        txt = Tpl.writeStr(txt, intString(i_i));
      then txt;

    case ( txt,
           DAE.ENUM_LITERAL(index = i_i) )
      equation
        txt = Tpl.writeStr(txt, intString(i_i));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_83;

public function subscriptToCStrWithoutIndexOperator
  input Tpl.Text in_txt;
  input DAE.Subscript in_a_subscript;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_subscript)
    local
      Tpl.Text txt;
      DAE.Exp i_exp;
      Integer i_i;

    case ( txt,
           DAE.SLICE(exp = DAE.ICONST(integer = i_i)) )
      equation
        txt = Tpl.writeStr(txt, intString(i_i));
      then txt;

    case ( txt,
           DAE.WHOLEDIM() )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("WHOLEDIM"));
      then txt;

    case ( txt,
           DAE.INDEX(exp = i_exp) )
      equation
        txt = fun_83(txt, i_exp);
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("UNKNOWN_SUBSCRIPT"));
      then txt;
  end match;
end subscriptToCStrWithoutIndexOperator;

public function arraycref
  input Tpl.Text in_txt;
  input DAE.ComponentRef in_a_cr;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_cr, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      DAE.ComponentRef i_cr;

    case ( txt,
           (i_cr as DAE.CREF_IDENT(ident = "xloc")),
           _ )
      equation
        txt = crefStr(txt, i_cr);
      then txt;

    case ( txt,
           DAE.CREF_IDENT(ident = "time"),
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_simTime"));
      then txt;

    case ( txt,
           DAE.WILD(),
           _ )
      then txt;

    case ( txt,
           i_cr,
           a_useFlatArrayNotation )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = crefToCStr1(txt, i_cr, a_useFlatArrayNotation);
      then txt;
  end match;
end arraycref;

public function arraycref2
  input Tpl.Text in_txt;
  input DAE.ComponentRef in_a_cr;
  input Tpl.Text in_a_dims;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_dims;
algorithm
  (out_txt, out_a_dims) :=
  match(in_txt, in_a_cr, in_a_dims)
    local
      Tpl.Text txt;
      Tpl.Text a_dims;
      DAE.ComponentRef i_cr;

    case ( txt,
           (i_cr as DAE.CREF_IDENT(ident = "xloc")),
           a_dims )
      equation
        txt = crefStr(txt, i_cr);
      then (txt, a_dims);

    case ( txt,
           DAE.CREF_IDENT(ident = "time"),
           a_dims )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_simTime"));
      then (txt, a_dims);

    case ( txt,
           DAE.WILD(),
           a_dims )
      then (txt, a_dims);

    case ( txt,
           i_cr,
           a_dims )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        (txt, a_dims) = crefToCStrForArray(txt, i_cr, a_dims);
      then (txt, a_dims);
  end match;
end arraycref2;

public function cref2
  input Tpl.Text in_txt;
  input DAE.ComponentRef in_a_cr;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_cr, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      DAE.ComponentRef i_cr;

    case ( txt,
           (i_cr as DAE.CREF_IDENT(ident = "xloc")),
           _ )
      equation
        txt = crefStr(txt, i_cr);
      then txt;

    case ( txt,
           DAE.CREF_IDENT(ident = "time"),
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_simTime"));
      then txt;

    case ( txt,
           DAE.WILD(),
           _ )
      then txt;

    case ( txt,
           i_cr,
           a_useFlatArrayNotation )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = crefToCStr(txt, i_cr, a_useFlatArrayNotation);
      then txt;
  end match;
end cref2;

protected function fun_88
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Boolean in_a_useFlatArrayNotation;
  input list<DAE.Subscript> in_a_subscriptLst;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_useFlatArrayNotation, in_a_subscriptLst)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      list<DAE.Subscript> a_subscriptLst;

    case ( txt,
           false,
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_useFlatArrayNotation,
           a_subscriptLst )
      equation
        txt = subscriptsToCStr(txt, a_subscriptLst, a_useFlatArrayNotation);
      then txt;
  end match;
end fun_88;

protected function fun_89
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input list<DAE.Subscript> in_a_subscriptLst;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_subscriptLst)
    local
      Tpl.Text txt;
      list<DAE.Subscript> a_subscriptLst;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_subscriptLst )
      equation
        txt = subscriptsToCStrForArray(txt, a_subscriptLst);
      then txt;
  end match;
end fun_89;

public function crefToCStr
  input Tpl.Text in_txt;
  input DAE.ComponentRef in_a_cr;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_cr, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      DAE.ComponentRef i_componentRef;
      DAE.Ident i_ident;
      list<DAE.Subscript> i_subscriptLst;
      Boolean ret_2;
      Boolean ret_1;
      Tpl.Text l_subs;

    case ( txt,
           DAE.CREF_IDENT(subscriptLst = i_subscriptLst, ident = i_ident),
           a_useFlatArrayNotation )
      equation
        ret_1 = Flags.isSet(Flags.NF_SCALARIZE);
        l_subs = fun_88(Tpl.emptyTxt, ret_1, a_useFlatArrayNotation, i_subscriptLst);
        txt = Tpl.writeStr(txt, i_ident);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeText(txt, l_subs);
      then txt;

    case ( txt,
           DAE.CREF_QUAL(subscriptLst = i_subscriptLst, ident = i_ident, componentRef = i_componentRef),
           a_useFlatArrayNotation )
      equation
        ret_2 = Flags.isSet(Flags.NF_SCALARIZE);
        l_subs = fun_89(Tpl.emptyTxt, ret_2, i_subscriptLst);
        txt = Tpl.writeStr(txt, i_ident);
        txt = Tpl.writeText(txt, l_subs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_P_"));
        txt = crefToCStr(txt, i_componentRef, a_useFlatArrayNotation);
      then txt;

    case ( txt,
           DAE.WILD(),
           _ )
      then txt;

    case ( txt,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("CREF_NOT_IDENT_OR_QUAL"));
      then txt;
  end match;
end crefToCStr;

public function contextSystem
  input Tpl.Text in_txt;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_context)
    local
      Tpl.Text txt;

    case ( txt,
           SimCodeFunction.ALGLOOP_CONTEXT(genInitialisation = false) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_system->"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end contextSystem;

protected function fun_92
  input Tpl.Text in_txt;
  input SimCodeFunction.Context in_a_context;
  input DAE.ComponentRef in_a_cr;
  input DAE.Type in_a_t;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input DAE.Exp in_a_exp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_a_context, in_a_cr, in_a_t, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_preExp, in_a_exp)
    local
      Tpl.Text txt;
      DAE.ComponentRef a_cr;
      DAE.Type a_t;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      DAE.Exp a_exp;
      SimCodeFunction.Context i_context;

    case ( txt,
           (i_context as SimCodeFunction.FUNCTION_CONTEXT(cref_prefix = _)),
           _,
           _,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp,
           a_exp )
      equation
        (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExpCrefRhs2(txt, a_exp, i_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);

    case ( txt,
           i_context,
           a_cr,
           a_t,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp,
           _ )
      equation
        (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExpRecordCrefRhs(txt, a_t, a_cr, i_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);
  end match;
end fun_92;

public function daeExpCrefRhs
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_exp, in_a_context, in_a_preExp, in_a_varDecls, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      DAE.Ident i_ident;
      DAE.ComponentRef i_componentRef;
      DAE.ComponentRef i_cr;
      DAE.Type i_t;
      DAE.Exp i_exp;
      Tpl.Text txt_1;
      Absyn.Path ret_0;

    case ( txt,
           (i_exp as DAE.CREF(componentRef = i_cr, ty = (i_t as DAE.T_COMPLEX(complexClassType = ClassInf.RECORD(path = _))))),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = fun_92(txt, a_context, i_cr, i_t, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, i_exp);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.CREF(ty = DAE.T_FUNCTION_REFERENCE_FUNC(functionType = i_t), componentRef = i_componentRef),
           a_context,
           a_preExp,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      equation
        ret_0 = ComponentReference.crefToPathIgnoreSubs(i_componentRef);
        txt_1 = CodegenUtil.underscorePath(Tpl.emptyTxt, ret_0);
        (txt, a_extraFuncsDecl) = functionClosure(txt, Tpl.textString(txt_1), "", i_t, i_t, a_context, a_extraFuncsDecl);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.CREF(componentRef = DAE.CREF_IDENT(ident = i_ident), ty = DAE.T_FUNCTION_REFERENCE_VAR(functionType = _)),
           a_context,
           a_preExp,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      equation
        txt = contextFunName(txt, i_ident, a_context);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           i_exp,
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExpCrefRhs2(txt, i_exp, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end daeExpCrefRhs;

protected function lm_94
  input Tpl.Text in_txt;
  input list<DAE.Subscript> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Subscript> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Exp i_exp;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);

    case ( txt,
           DAE.INDEX(exp = i_exp) :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(txt, i_exp, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = lm_94(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);

    case ( txt,
           _ :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = lm_94(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);
  end match;
end lm_94;

protected function fun_95
  input Tpl.Text in_txt;
  input String in_mArg;
  input Tpl.Text in_a_dimsValuesStr;
  input Tpl.Text in_a_arrName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_dimsValuesStr, in_a_arrName)
    local
      Tpl.Text txt;
      Tpl.Text a_dimsValuesStr;
      Tpl.Text a_arrName;

    case ( txt,
           "metatype_array",
           a_dimsValuesStr,
           a_arrName )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("arrayGet("));
        txt = Tpl.writeText(txt, a_arrName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, a_dimsValuesStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") /* DAE.CREF */"));
      then txt;

    case ( txt,
           _,
           a_dimsValuesStr,
           a_arrName )
      equation
        txt = Tpl.writeText(txt, a_arrName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_dimsValuesStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;
  end match;
end fun_95;

protected function fun_96
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input DAE.Type in_a_ty;
  input SimCodeFunction.Context in_a_context;
  input DAE.ComponentRef in_a_cr;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_mArg, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_preExp, in_a_ty, in_a_context, in_a_cr)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      DAE.Type a_ty;
      SimCodeFunction.Context a_context;
      DAE.ComponentRef a_cr;
      String str_8;
      list<DAE.Subscript> ret_7;
      Tpl.Text l_dimsValuesStr;
      Tpl.Text l_arrayType;
      DAE.ComponentRef ret_4;
      list<DAE.Subscript> ret_3;
      Tpl.Text l_slice;
      Tpl.Text l_typeStr;
      Tpl.Text l_arrName;

    case ( txt,
           false,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp,
           a_ty,
           a_context,
           a_cr )
      equation
        l_arrName = contextArrayCref(Tpl.emptyTxt, a_cr, a_context);
        l_typeStr = expTypeShort(Tpl.emptyTxt, a_ty);
        ret_3 = ComponentReference.crefSubs(a_cr);
        (l_slice, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExpCrefIndexSpec(Tpl.emptyTxt, ret_3, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("ArraySlice<"));
        a_preExp = Tpl.writeText(a_preExp, l_typeStr);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("> "));
        a_preExp = Tpl.writeText(a_preExp, l_slice);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("_as("));
        a_preExp = Tpl.writeText(a_preExp, l_arrName);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, l_slice);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_slice);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_as"));
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);

    case ( txt,
           _,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp,
           a_ty,
           a_context,
           a_cr )
      equation
        ret_4 = ComponentReference.crefStripLastSubs(a_cr);
        (l_arrName, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = contextCref(Tpl.emptyTxt, ret_4, a_context, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        l_arrayType = expTypeShort(Tpl.emptyTxt, a_ty);
        ret_7 = ComponentReference.crefSubs(a_cr);
        l_dimsValuesStr = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_dimsValuesStr, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = lm_94(l_dimsValuesStr, ret_7, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context);
        l_dimsValuesStr = Tpl.popIter(l_dimsValuesStr);
        str_8 = Tpl.textString(l_arrayType);
        txt = fun_95(txt, str_8, l_dimsValuesStr, l_arrName);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);
  end match;
end fun_96;

protected function fun_97
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input DAE.Type in_a_ty;
  input SimCodeFunction.Context in_a_context;
  input DAE.ComponentRef in_a_cr;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_mArg, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_preExp, in_a_ty, in_a_context, in_a_cr)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      DAE.Type a_ty;
      SimCodeFunction.Context a_context;
      DAE.ComponentRef a_cr;
      Boolean ret_6;
      Boolean ret_5;
      Boolean ret_4;
      Integer ret_3;
      list<DAE.Dimension> ret_2;
      Integer ret_1;
      list<DAE.Subscript> ret_0;

    case ( txt,
           false,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp,
           a_ty,
           a_context,
           a_cr )
      equation
        ret_0 = ComponentReference.crefSubs(a_cr);
        ret_1 = listLength(ret_0);
        ret_2 = ComponentReference.crefDims(a_cr);
        ret_3 = listLength(ret_2);
        ret_4 = intEq(ret_1, ret_3);
        ret_5 = SimCodeFunctionUtil.crefSubIsScalar(a_cr);
        ret_6 = boolAnd(ret_4, ret_5);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = fun_96(txt, ret_6, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_ty, a_context, a_cr);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);

    case ( txt,
           _,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp,
           _,
           a_context,
           a_cr )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = contextCref(txt, a_cr, a_context, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);
  end match;
end fun_97;

protected function fun_98
  input Tpl.Text in_txt;
  input Tpl.Text in_a_box;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input DAE.Type in_a_ty;
  input SimCodeFunction.Context in_a_context;
  input DAE.ComponentRef in_a_cr;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_a_box, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_preExp, in_a_ty, in_a_context, in_a_cr)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      DAE.Type a_ty;
      SimCodeFunction.Context a_context;
      DAE.ComponentRef a_cr;
      Tpl.Text i_box;
      Boolean ret_0;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp,
           a_ty,
           a_context,
           a_cr )
      equation
        ret_0 = SimCodeFunctionUtil.crefIsScalar(a_cr, a_context);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = fun_97(txt, ret_0, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_ty, a_context, a_cr);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);

    case ( txt,
           i_box,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           a_preExp,
           _,
           _,
           _ )
      equation
        txt = Tpl.writeText(txt, i_box);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);
  end match;
end fun_98;

public function daeExpCrefRhs2
  input Tpl.Text in_txt;
  input DAE.Exp in_a_ecr;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_ecr, in_a_context, in_a_preExp, in_a_varDecls, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      DAE.Type i_ty;
      DAE.ComponentRef i_cr;
      Tpl.Text l_box;

    case ( txt,
           DAE.CREF(componentRef = i_cr, ty = i_ty),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (l_box, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExpCrefRhsArrayBox(Tpl.emptyTxt, i_cr, i_ty, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = fun_98(txt, l_box, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, i_ty, a_context, i_cr);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           a_preExp,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end daeExpCrefRhs2;

protected function fun_100
  input Tpl.Text in_txt;
  input Option<DAE.Exp> in_a_step;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_a_step, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Exp i_stepExp;

    case ( txt,
           SOME(i_stepExp),
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(txt, i_stepExp, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);

    case ( txt,
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           a_preExp,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("1"));
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);
  end match;
end fun_100;

protected function fun_101
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input Tpl.Text in_a_tmp__slice;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_a_exp, in_a_tmp__slice, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      Tpl.Text a_tmp__slice;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Exp i_exp;
      Option<DAE.Exp> i_step;
      DAE.Exp i_stop;
      DAE.Exp i_start;
      Tpl.Text l_expPart;
      Tpl.Text l_step__exp;
      Tpl.Text l_stop__exp;
      Tpl.Text l_start__exp;

    case ( txt,
           DAE.RANGE(start = i_start, stop = i_stop, step = i_step),
           a_tmp__slice,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (l_start__exp, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_start, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        (l_stop__exp, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_stop, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        (l_step__exp, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = fun_100(Tpl.emptyTxt, i_step, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context);
        a_preExp = Tpl.writeText(a_preExp, a_tmp__slice);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(".push_back(Slice("));
        a_preExp = Tpl.writeText(a_preExp, l_start__exp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, l_step__exp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, l_stop__exp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("));"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);

    case ( txt,
           i_exp,
           a_tmp__slice,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (l_expPart, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_exp, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        a_preExp = Tpl.writeText(a_preExp, a_tmp__slice);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(".push_back(Slice("));
        a_preExp = Tpl.writeText(a_preExp, l_expPart);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("));"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);
  end match;
end fun_101;

protected function fun_102
  input Tpl.Text in_txt;
  input DAE.Subscript in_a_sub;
  input Tpl.Text in_a_tmp__slice;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_a_sub, in_a_tmp__slice, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      Tpl.Text a_tmp__slice;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Exp i_exp;
      Tpl.Text l_expPart;

    case ( txt,
           DAE.INDEX(exp = i_exp),
           a_tmp__slice,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (l_expPart, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_exp, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        a_preExp = Tpl.writeText(a_preExp, a_tmp__slice);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(".push_back(Slice("));
        a_preExp = Tpl.writeText(a_preExp, l_expPart);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("));"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);

    case ( txt,
           DAE.WHOLEDIM(),
           a_tmp__slice,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           a_preExp,
           _ )
      equation
        a_preExp = Tpl.writeText(a_preExp, a_tmp__slice);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(".push_back(Slice());"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);

    case ( txt,
           DAE.SLICE(exp = i_exp),
           a_tmp__slice,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = fun_101(txt, i_exp, a_tmp__slice, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);

    case ( txt,
           _,
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);
  end match;
end fun_102;

protected function lm_103
  input Tpl.Text in_txt;
  input list<DAE.Subscript> in_items;
  input Tpl.Text in_a_tmp__slice;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_tmp__slice, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Subscript> rest;
      Tpl.Text a_tmp__slice;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Subscript i_sub;

    case ( txt,
           {},
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);

    case ( txt,
           i_sub :: rest,
           a_tmp__slice,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = fun_102(txt, i_sub, a_tmp__slice, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = lm_103(txt, rest, a_tmp__slice, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);
  end match;
end lm_103;

public function daeExpCrefIndexSpec
  input Tpl.Text txt;
  input list<DAE.Subscript> a_subs;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_preExp;
  input Tpl.Text a_varDecls;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
protected
  Tpl.Text l_0__;
  Tpl.Text l_tmp__slice;
algorithm
  (l_tmp__slice, out_a_varDecls) := tempDecl(Tpl.emptyTxt, "vector<Slice>", a_varDecls);
  out_a_preExp := Tpl.writeText(a_preExp, l_tmp__slice);
  out_a_preExp := Tpl.writeTok(out_a_preExp, Tpl.ST_STRING(".clear();"));
  out_a_preExp := Tpl.writeTok(out_a_preExp, Tpl.ST_NEW_LINE());
  l_0__ := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING_LIST({
                                                                           "\n",
                                                                           " "
                                                                       }, false)), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (l_0__, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp) := lm_103(l_0__, a_subs, l_tmp__slice, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, out_a_varDecls, out_a_preExp, a_context);
  l_0__ := Tpl.popIter(l_0__);
  out_txt := Tpl.writeText(txt, l_tmp__slice);
end daeExpCrefIndexSpec;

protected function fun_105
  input Tpl.Text in_txt;
  input DAE.ComponentRef in_a_cr;
  input Tpl.Text in_a_preExp;
  input DAE.Type in_a_aty;
  input DAE.Dimensions in_a_dims;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_preExp) :=
  match(in_txt, in_a_cr, in_a_preExp, in_a_aty, in_a_dims, in_a_context)
    local
      Tpl.Text txt;
      Tpl.Text a_preExp;
      DAE.Type a_aty;
      DAE.Dimensions a_dims;
      SimCodeFunction.Context a_context;
      DAE.ComponentRef i_componentRef;
      Tpl.Text l_T;
      Tpl.Text l_dimstr;
      Integer ret_2;
      Tpl.Text l_ndims;
      Tpl.Text l_arr;

    case ( txt,
           DAE.CREF_QUAL(ident = "$PRE", componentRef = i_componentRef),
           a_preExp,
           a_aty,
           a_dims,
           a_context )
      equation
        l_arr = arrayCrefCStr(Tpl.emptyTxt, i_componentRef, a_context);
        ret_2 = listLength(a_dims);
        l_ndims = Tpl.writeStr(Tpl.emptyTxt, intString(ret_2));
        l_dimstr = checkDimension(Tpl.emptyTxt, a_dims);
        l_T = expTypeShort(Tpl.emptyTxt, a_aty);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("StatArrayDim"));
        a_preExp = Tpl.writeText(a_preExp, l_ndims);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("<"));
        a_preExp = Tpl.writeText(a_preExp, l_T);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, l_dimstr);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("> "));
        a_preExp = Tpl.writeText(a_preExp, l_arr);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING_LIST({
                                              "_pre;\n",
                                              "std::transform("
                                          }, false));
        a_preExp = Tpl.writeText(a_preExp, l_arr);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_LINE(".getData(),\n"));
        a_preExp = Tpl.pushBlock(a_preExp, Tpl.BT_INDENT(15));
        a_preExp = Tpl.writeText(a_preExp, l_arr);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(".getData() + "));
        a_preExp = Tpl.writeText(a_preExp, l_arr);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_LINE(".getNumElems(),\n"));
        a_preExp = Tpl.writeText(a_preExp, l_arr);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING_LIST({
                                              "_pre.getData(),\n",
                                              "PreArray2CArray<"
                                          }, false));
        a_preExp = Tpl.writeText(a_preExp, l_T);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(">(_discrete_events));"));
        a_preExp = Tpl.popBlock(a_preExp);
        txt = Tpl.writeText(txt, l_arr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_pre"));
      then (txt, a_preExp);

    case ( txt,
           _,
           a_preExp,
           _,
           _,
           _ )
      then (txt, a_preExp);
  end match;
end fun_105;

protected function fun_106
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;
  input DAE.ComponentRef in_a_cr;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_preExp) :=
  match(in_txt, in_a_ty, in_a_preExp, in_a_context, in_a_cr)
    local
      Tpl.Text txt;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.ComponentRef a_cr;
      DAE.Type i_aty;
      DAE.Dimensions i_dims;

    case ( txt,
           DAE.T_ARRAY(ty = i_aty, dims = i_dims),
           a_preExp,
           a_context,
           a_cr )
      equation
        (txt, a_preExp) = fun_105(txt, a_cr, a_preExp, i_aty, i_dims, a_context);
      then (txt, a_preExp);

    case ( txt,
           _,
           a_preExp,
           _,
           _ )
      then (txt, a_preExp);
  end match;
end fun_106;

protected function fun_107
  input Tpl.Text in_txt;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input DAE.ComponentRef in_a_cr;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_preExp) :=
  match(in_txt, in_a_context, in_a_preExp, in_a_cr, in_a_ty)
    local
      Tpl.Text txt;
      Tpl.Text a_preExp;
      DAE.ComponentRef a_cr;
      DAE.Type a_ty;
      SimCodeFunction.Context i_context;

    case ( txt,
           SimCodeFunction.FUNCTION_CONTEXT(cref_prefix = _),
           a_preExp,
           _,
           _ )
      then (txt, a_preExp);

    case ( txt,
           i_context,
           a_preExp,
           a_cr,
           a_ty )
      equation
        (txt, a_preExp) = fun_106(txt, a_ty, a_preExp, i_context, a_cr);
      then (txt, a_preExp);
  end match;
end fun_107;

protected function fun_108
  input Tpl.Text in_txt;
  input BackendDAE.VarKind in_a_varKind;
  input Tpl.Text in_a_preExp;
  input DAE.Type in_a_ty;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_varDecls;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input DAE.ComponentRef in_a_cr;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_preExp, out_a_stateDerVectorName, out_a_varDecls, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_a_varKind, in_a_preExp, in_a_ty, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_varDecls, in_a_context, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_cr)
    local
      Tpl.Text txt;
      Tpl.Text a_preExp;
      DAE.Type a_ty;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_varDecls;
      SimCodeFunction.Context a_context;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      DAE.ComponentRef a_cr;
      Tpl.Text l_arrdata;

    case ( txt,
           BackendDAE.STATE(index = _),
           a_preExp,
           a_ty,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_varDecls,
           a_context,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_cr )
      equation
        (l_arrdata, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_varDecls, a_stateDerVectorName) = representationCref(Tpl.emptyTxt, a_cr, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_context, a_varDecls, a_stateDerVectorName, a_useFlatArrayNotation);
        (txt, l_arrdata, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = daeExpCrefRhsArrayBox2(txt, l_arrdata, a_ty, false, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
      then (txt, a_preExp, a_stateDerVectorName, a_varDecls, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           BackendDAE.STATE_DER(),
           a_preExp,
           a_ty,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_varDecls,
           a_context,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_cr )
      equation
        (l_arrdata, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_varDecls, a_stateDerVectorName) = representationCref(Tpl.emptyTxt, a_cr, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_context, a_varDecls, a_stateDerVectorName, a_useFlatArrayNotation);
        (txt, l_arrdata, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = daeExpCrefRhsArrayBox2(txt, l_arrdata, a_ty, false, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
      then (txt, a_preExp, a_stateDerVectorName, a_varDecls, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           BackendDAE.DAE_RESIDUAL_VAR(),
           a_preExp,
           a_ty,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_varDecls,
           a_context,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_cr )
      equation
        (l_arrdata, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_varDecls, a_stateDerVectorName) = representationCref(Tpl.emptyTxt, a_cr, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_context, a_varDecls, a_stateDerVectorName, a_useFlatArrayNotation);
        (txt, l_arrdata, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = daeExpCrefRhsArrayBox2(txt, l_arrdata, a_ty, false, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
      then (txt, a_preExp, a_stateDerVectorName, a_varDecls, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           BackendDAE.JAC_VAR(),
           a_preExp,
           a_ty,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_varDecls,
           a_context,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_cr )
      equation
        (l_arrdata, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_varDecls, a_stateDerVectorName) = representationCref(Tpl.emptyTxt, a_cr, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_context, a_varDecls, a_stateDerVectorName, a_useFlatArrayNotation);
        (txt, l_arrdata, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = daeExpCrefRhsArrayBox2(txt, l_arrdata, a_ty, true, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
      then (txt, a_preExp, a_stateDerVectorName, a_varDecls, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           BackendDAE.JAC_DIFF_VAR(),
           a_preExp,
           a_ty,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_varDecls,
           a_context,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_cr )
      equation
        (l_arrdata, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_varDecls, a_stateDerVectorName) = representationCref(Tpl.emptyTxt, a_cr, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_context, a_varDecls, a_stateDerVectorName, a_useFlatArrayNotation);
        (txt, l_arrdata, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = daeExpCrefRhsArrayBox2(txt, l_arrdata, a_ty, true, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
      then (txt, a_preExp, a_stateDerVectorName, a_varDecls, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           BackendDAE.SEED_VAR(),
           a_preExp,
           a_ty,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_varDecls,
           a_context,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_cr )
      equation
        (l_arrdata, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_varDecls, a_stateDerVectorName) = representationCref(Tpl.emptyTxt, a_cr, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_context, a_varDecls, a_stateDerVectorName, a_useFlatArrayNotation);
        (txt, l_arrdata, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = daeExpCrefRhsArrayBox2(txt, l_arrdata, a_ty, true, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
      then (txt, a_preExp, a_stateDerVectorName, a_varDecls, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           a_preExp,
           a_ty,
           _,
           a_stateDerVectorName,
           a_varDecls,
           a_context,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_cr )
      equation
        (txt, a_preExp) = fun_107(txt, a_context, a_preExp, a_cr, a_ty);
      then (txt, a_preExp, a_stateDerVectorName, a_varDecls, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_108;

protected function smf_109
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_it;
  input Tpl.Text in_a_preExp;
  input DAE.Type in_a_ty;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_varDecls;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input DAE.ComponentRef in_a_cr;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_preExp, out_a_stateDerVectorName, out_a_varDecls, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_it, in_a_preExp, in_a_ty, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_varDecls, in_a_context, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_cr)
    local
      Tpl.Text txt;
      Tpl.Text a_preExp;
      DAE.Type a_ty;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_varDecls;
      SimCodeFunction.Context a_context;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      DAE.ComponentRef a_cr;
      BackendDAE.VarKind i_varKind;

    case ( txt,
           SimCodeVar.SIMVAR(index = _, matrixName = _, varKind = i_varKind),
           a_preExp,
           a_ty,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_varDecls,
           a_context,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_cr )
      equation
        (txt, a_preExp, a_stateDerVectorName, a_varDecls, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_108(txt, i_varKind, a_preExp, a_ty, a_useFlatArrayNotation, a_stateDerVectorName, a_varDecls, a_context, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_cr);
      then (txt, a_preExp, a_stateDerVectorName, a_varDecls, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           a_preExp,
           _,
           _,
           a_stateDerVectorName,
           a_varDecls,
           _,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_preExp, a_stateDerVectorName, a_varDecls, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end smf_109;

public function daeExpCrefRhsArrayBox
  input Tpl.Text txt;
  input DAE.ComponentRef a_cr;
  input DAE.Type a_ty;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_preExp;
  input Tpl.Text a_varDecls;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
protected
  SimCodeVar.SimVar ret_0;
algorithm
  ret_0 := SimCodeUtil.cref2simvar(a_cr, a_simCode);
  (out_txt, out_a_preExp, out_a_stateDerVectorName, out_a_varDecls, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) := smf_109(txt, ret_0, a_preExp, a_ty, a_useFlatArrayNotation, a_stateDerVectorName, a_varDecls, a_context, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_cr);
end daeExpCrefRhsArrayBox;

protected function fun_111
  input Tpl.Text in_txt;
  input String in_mArg;
  input Tpl.Text in_a_dimstr;
  input DAE.Type in_a_ty;
  input DAE.Dimensions in_a_dims;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_dimstr, in_a_ty, in_a_dims)
    local
      Tpl.Text txt;
      Tpl.Text a_dimstr;
      DAE.Type a_ty;
      DAE.Dimensions a_dims;
      Integer ret_1;
      Integer ret_0;

    case ( txt,
           "",
           _,
           a_ty,
           a_dims )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("DynArrayDim"));
        ret_0 = listLength(a_dims);
        txt = Tpl.writeStr(txt, intString(ret_0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<"));
        txt = expTypeShort(txt, a_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(">"));
      then txt;

    case ( txt,
           _,
           a_dimstr,
           a_ty,
           a_dims )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("StatArrayDim"));
        ret_1 = listLength(a_dims);
        txt = Tpl.writeStr(txt, intString(ret_1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<"));
        txt = expTypeShort(txt, a_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, a_dimstr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(">"));
      then txt;
  end match;
end fun_111;

protected function fun_112
  input Tpl.Text in_txt;
  input Boolean in_a_isRowMajorData;
  input Tpl.Text in_a_arrayData;
  input Tpl.Text in_a_arrayVar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_isRowMajorData, in_a_arrayData, in_a_arrayVar)
    local
      Tpl.Text txt;
      Tpl.Text a_arrayData;
      Tpl.Text a_arrayVar;

    case ( txt,
           false,
           a_arrayData,
           a_arrayVar )
      equation
        txt = Tpl.writeText(txt, a_arrayVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".assign(&"));
        txt = Tpl.writeText(txt, a_arrayData);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           _,
           a_arrayData,
           a_arrayVar )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("assignRowMajorData(&"));
        txt = Tpl.writeText(txt, a_arrayData);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_arrayVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;
  end match;
end fun_112;

protected function fun_113
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;
  input Tpl.Text in_a_arrayData;
  input Boolean in_a_isRowMajorData;
  input Tpl.Text in_a_preExp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_preExp) :=
  match(in_txt, in_a_ty, in_a_arrayData, in_a_isRowMajorData, in_a_preExp)
    local
      Tpl.Text txt;
      Tpl.Text a_arrayData;
      Boolean a_isRowMajorData;
      Tpl.Text a_preExp;
      DAE.Type i_t;
      DAE.Dimensions i_dims;
      Tpl.Text l_arrayAssign;
      Tpl.Text l_arrayVar;
      Tpl.Text l_tmpdecl;
      String str_2;
      Tpl.Text l_arrayType;
      Tpl.Text l_dimstr;

    case ( txt,
           (i_t as DAE.T_ARRAY(ty = _, dims = i_dims)),
           a_arrayData,
           a_isRowMajorData,
           a_preExp )
      equation
        l_dimstr = checkDimension(Tpl.emptyTxt, i_dims);
        str_2 = Tpl.textString(l_dimstr);
        l_arrayType = fun_111(Tpl.emptyTxt, str_2, l_dimstr, i_t, i_dims);
        l_tmpdecl = Tpl.emptyTxt;
        (l_arrayVar, l_tmpdecl) = tempDecl(Tpl.emptyTxt, Tpl.textString(l_arrayType), l_tmpdecl);
        l_arrayAssign = fun_112(Tpl.emptyTxt, a_isRowMajorData, a_arrayData, l_arrayVar);
        a_preExp = Tpl.writeText(a_preExp, l_arrayType);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" "));
        a_preExp = Tpl.writeText(a_preExp, l_arrayVar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_LINE(";\n"));
        a_preExp = Tpl.writeText(a_preExp, l_arrayAssign);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(";"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_arrayVar);
      then (txt, a_preExp);

    case ( txt,
           _,
           a_arrayData,
           _,
           a_preExp )
      equation
        txt = Tpl.writeText(txt, a_arrayData);
      then (txt, a_preExp);
  end match;
end fun_113;

public function daeExpCrefRhsArrayBox2
  input Tpl.Text txt;
  input Tpl.Text a_arrayData;
  input DAE.Type a_ty;
  input Boolean a_isRowMajorData;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_preExp;
  input Tpl.Text a_varDecls;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_arrayData;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  (out_txt, out_a_preExp) := fun_113(txt, a_ty, a_arrayData, a_isRowMajorData, a_preExp);
  out_a_arrayData := a_arrayData;
  out_a_varDecls := a_varDecls;
  out_a_extraFuncs := a_extraFuncs;
  out_a_extraFuncsDecl := a_extraFuncsDecl;
  out_a_extraFuncsNamespace := a_extraFuncsNamespace;
end daeExpCrefRhsArrayBox2;

protected function lm_115
  input Tpl.Text in_txt;
  input list<DAE.Var> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;
  input DAE.ComponentRef in_a_cr;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_preExp, in_a_context, in_a_cr)
    local
      Tpl.Text txt;
      list<DAE.Var> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.ComponentRef a_cr;
      DAE.Var i_v;
      DAE.Exp ret_0;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           a_preExp,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);

    case ( txt,
           i_v :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp,
           a_context,
           a_cr )
      equation
        ret_0 = SimCodeFunctionUtil.makeCrefRecordExp(a_cr, i_v);
        (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(txt, ret_0, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = lm_115(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context, a_cr);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);
  end match;
end lm_115;

public function daeExpRecordCrefRhs
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;
  input DAE.ComponentRef in_a_cr;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_ty, in_a_cr, in_a_context, in_a_preExp, in_a_varDecls, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      DAE.ComponentRef a_cr;
      SimCodeFunction.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      ClassInf.State i_record__state;
      list<DAE.Var> i_var__lst;
      Tpl.Text l_ret__var;
      Tpl.Text l_ret__type;
      Absyn.Path ret_2;
      Tpl.Text l_record__type__name;
      Tpl.Text l_vars;

    case ( txt,
           DAE.T_COMPLEX(complexClassType = i_record__state, varLst = i_var__lst),
           a_cr,
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_vars = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_vars, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = lm_115(l_vars, i_var__lst, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context, a_cr);
        l_vars = Tpl.popIter(l_vars);
        ret_2 = ClassInf.getStateName(i_record__state);
        l_record__type__name = CodegenUtil.underscorePath(Tpl.emptyTxt, ret_2);
        l_ret__type = Tpl.writeText(Tpl.emptyTxt, l_record__type__name);
        l_ret__type = Tpl.writeTok(l_ret__type, Tpl.ST_STRING("RetType"));
        (l_ret__var, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(l_ret__type), a_varDecls);
        a_preExp = contextFunName(a_preExp, Tpl.textString(l_record__type__name), a_context);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("("));
        a_preExp = Tpl.writeText(a_preExp, l_vars);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(","));
        a_preExp = Tpl.writeText(a_preExp, l_ret__var);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_ret__var);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           _,
           a_preExp,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end daeExpRecordCrefRhs;

public function crefST
  input Tpl.Text in_txt;
  input DAE.ComponentRef in_a_cr;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_cr, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      DAE.ComponentRef i_cr;

    case ( txt,
           DAE.CREF_IDENT(ident = "time"),
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_simTime"));
      then txt;

    case ( txt,
           DAE.WILD(),
           _ )
      then txt;

    case ( txt,
           i_cr,
           a_useFlatArrayNotation )
      equation
        txt = crefToCStr(txt, i_cr, a_useFlatArrayNotation);
      then txt;
  end match;
end crefST;

protected function fun_118
  input Tpl.Text in_txt;
  input SimCodeFunction.Context in_a_context;
  input DAE.ComponentRef in_a_cr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_context, in_a_cr)
    local
      Tpl.Text txt;
      DAE.ComponentRef a_cr;
      SimCodeFunction.Context i_context;

    case ( txt,
           SimCodeFunction.FUNCTION_CONTEXT(cref_prefix = _),
           a_cr )
      equation
        txt = arrayCrefStr(txt, a_cr);
      then txt;

    case ( txt,
           i_context,
           a_cr )
      equation
        txt = arrayCrefCStr(txt, a_cr, i_context);
      then txt;
  end match;
end fun_118;

public function contextArrayCref
  input Tpl.Text txt;
  input DAE.ComponentRef a_cr;
  input SimCodeFunction.Context a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_118(txt, a_context, a_cr);
end contextArrayCref;

public function arrayCrefStr
  input Tpl.Text in_txt;
  input DAE.ComponentRef in_a_cr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_cr)
    local
      Tpl.Text txt;
      DAE.ComponentRef i_componentRef;
      DAE.Ident i_ident;

    case ( txt,
           DAE.CREF_IDENT(ident = "time") )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_simTime"));
      then txt;

    case ( txt,
           DAE.CREF_IDENT(ident = i_ident) )
      equation
        txt = Tpl.writeStr(txt, i_ident);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
      then txt;

    case ( txt,
           DAE.CREF_QUAL(ident = i_ident, componentRef = i_componentRef) )
      equation
        txt = Tpl.writeStr(txt, i_ident);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_."));
        txt = arrayCrefStr(txt, i_componentRef);
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("CREF_NOT_IDENT_OR_QUAL"));
      then txt;
  end match;
end arrayCrefStr;

protected function fun_121
  input Tpl.Text in_txt;
  input SimCodeFunction.Context in_a_context;
  input DAE.ComponentRef in_a_cr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_context, in_a_cr)
    local
      Tpl.Text txt;
      DAE.ComponentRef a_cr;
      Tpl.Text l_dims;

    case ( txt,
           SimCodeFunction.ALGLOOP_CONTEXT(genInitialisation = false),
           a_cr )
      equation
        l_dims = Tpl.emptyTxt;
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_system->_"));
        (txt, l_dims) = crefToCStrForArray(txt, a_cr, l_dims);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           _,
           a_cr )
      equation
        l_dims = Tpl.emptyTxt;
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        (txt, l_dims) = crefToCStrForArray(txt, a_cr, l_dims);
      then txt;
  end match;
end fun_121;

public function arrayCrefCStr
  input Tpl.Text txt;
  input DAE.ComponentRef a_cr;
  input SimCodeFunction.Context a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_121(txt, a_context, a_cr);
end arrayCrefCStr;

public function arrayCrefCStr2
  input Tpl.Text in_txt;
  input DAE.ComponentRef in_a_cr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_cr)
    local
      Tpl.Text txt;
      DAE.ComponentRef i_componentRef;
      DAE.Ident i_ident;
      String ret_1;
      String ret_0;

    case ( txt,
           DAE.CREF_IDENT(ident = i_ident) )
      equation
        ret_0 = System.unquoteIdentifier(i_ident);
        txt = Tpl.writeStr(txt, ret_0);
      then txt;

    case ( txt,
           DAE.CREF_QUAL(ident = i_ident, componentRef = i_componentRef) )
      equation
        ret_1 = System.unquoteIdentifier(i_ident);
        txt = Tpl.writeStr(txt, ret_1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_P_"));
        txt = arrayCrefCStr2(txt, i_componentRef);
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("CREF_NOT_IDENT_OR_QUAL"));
      then txt;
  end match;
end arrayCrefCStr2;

public function crefTypeST
  input Tpl.Text in_txt;
  input DAE.ComponentRef in_a_cr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_cr)
    local
      Tpl.Text txt;
      DAE.ComponentRef i_componentRef;
      DAE.Type i_identType;

    case ( txt,
           DAE.CREF_IDENT(identType = i_identType) )
      equation
        txt = expTypeShortSPS(txt, i_identType);
      then txt;

    case ( txt,
           DAE.CREF_QUAL(componentRef = i_componentRef) )
      equation
        txt = crefTypeST(txt, i_componentRef);
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("crefType:ERROR"));
      then txt;
  end match;
end crefTypeST;

public function crefTypeMLPI
  input Tpl.Text in_txt;
  input DAE.ComponentRef in_a_cr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_cr)
    local
      Tpl.Text txt;
      DAE.ComponentRef i_componentRef;
      DAE.Type i_identType;

    case ( txt,
           DAE.CREF_IDENT(identType = i_identType) )
      equation
        txt = expTypeShortMLPI(txt, i_identType);
      then txt;

    case ( txt,
           DAE.CREF_QUAL(componentRef = i_componentRef) )
      equation
        txt = crefTypeMLPI(txt, i_componentRef);
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("crefType:ERROR"));
      then txt;
  end match;
end crefTypeMLPI;

protected function fun_126
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_typeShort;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_typeShort)
    local
      Tpl.Text txt;
      Tpl.Text a_typeShort;

    case ( txt,
           false,
           a_typeShort )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("ERROR:crefStartValueType "));
        txt = Tpl.writeText(txt, a_typeShort);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
      then txt;

    case ( txt,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("ExternalObject"));
      then txt;
  end match;
end fun_126;

protected function fun_127
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_typeShort;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_typeShort)
    local
      Tpl.Text txt;
      Tpl.Text a_typeShort;
      Boolean ret_0;

    case ( txt,
           false,
           a_typeShort )
      equation
        ret_0 = stringEq(Tpl.textString(a_typeShort), "void*");
        txt = fun_126(txt, ret_0, a_typeShort);
      then txt;

    case ( txt,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("String"));
      then txt;
  end match;
end fun_127;

protected function fun_128
  input Tpl.Text in_txt;
  input String in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           "Cpp" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Bool"));
      then txt;

    case ( txt,
           "omsicpp" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Int"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_128;

protected function fun_129
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_typeShort;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_typeShort)
    local
      Tpl.Text txt;
      Tpl.Text a_typeShort;
      String ret_2;
      Tpl.Text l_booltype;
      Boolean ret_0;

    case ( txt,
           false,
           a_typeShort )
      equation
        ret_0 = stringEq(Tpl.textString(a_typeShort), "string");
        txt = fun_127(txt, ret_0, a_typeShort);
      then txt;

    case ( txt,
           _,
           _ )
      equation
        ret_2 = Config.simCodeTarget();
        l_booltype = fun_128(Tpl.emptyTxt, ret_2);
        txt = Tpl.writeText(txt, l_booltype);
      then txt;
  end match;
end fun_129;

protected function fun_130
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_typeShort;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_typeShort)
    local
      Tpl.Text txt;
      Tpl.Text a_typeShort;
      Boolean ret_0;

    case ( txt,
           false,
           a_typeShort )
      equation
        ret_0 = stringEq(Tpl.textString(a_typeShort), "bool");
        txt = fun_129(txt, ret_0, a_typeShort);
      then txt;

    case ( txt,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Int"));
      then txt;
  end match;
end fun_130;

protected function fun_131
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_typeShort;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_typeShort)
    local
      Tpl.Text txt;
      Tpl.Text a_typeShort;
      Boolean ret_0;

    case ( txt,
           false,
           a_typeShort )
      equation
        ret_0 = stringEq(Tpl.textString(a_typeShort), "int");
        txt = fun_130(txt, ret_0, a_typeShort);
      then txt;

    case ( txt,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Real"));
      then txt;
  end match;
end fun_131;

public function crefStartValueType
  input Tpl.Text in_txt;
  input DAE.ComponentRef in_a_cr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_cr)
    local
      Tpl.Text txt;
      DAE.ComponentRef i_componentRef;
      DAE.Type i_identType;
      Boolean ret_2;
      Tpl.Text l_typeString;
      Tpl.Text l_typeShort;

    case ( txt,
           DAE.CREF_IDENT(identType = i_identType) )
      equation
        l_typeShort = expTypeShort(Tpl.emptyTxt, i_identType);
        ret_2 = stringEq(Tpl.textString(l_typeShort), "double");
        l_typeString = fun_131(Tpl.emptyTxt, ret_2, l_typeShort);
        txt = Tpl.writeText(txt, l_typeString);
      then txt;

    case ( txt,
           DAE.CREF_QUAL(componentRef = i_componentRef) )
      equation
        txt = crefStartValueType(txt, i_componentRef);
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("crefStartValueType:ERROR"));
      then txt;
  end match;
end crefStartValueType;

public function dimension
  input Tpl.Text in_txt;
  input DAE.Dimension in_a_d;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_d, in_a_context)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      DAE.Exp i_e;
      Integer i_size;
      Integer i_integer;

    case ( txt,
           DAE.DIM_BOOLEAN(),
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("2"));
      then txt;

    case ( txt,
           DAE.DIM_INTEGER(integer = i_integer),
           _ )
      equation
        txt = Tpl.writeStr(txt, intString(i_integer));
      then txt;

    case ( txt,
           DAE.DIM_ENUM(size = i_size),
           _ )
      equation
        txt = Tpl.writeStr(txt, intString(i_size));
      then txt;

    case ( txt,
           DAE.DIM_EXP(exp = i_e),
           a_context )
      equation
        txt = dimensionExp(txt, i_e, a_context, false);
      then txt;

    case ( txt,
           DAE.DIM_UNKNOWN(),
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-1"));
      then txt;

    case ( txt,
           _,
           _ )
      equation
        txt = error(txt, Tpl.sourceInfo("CodegenCppCommon.tpl", 630, 14), "dimension: INVALID_DIMENSION");
      then txt;
  end match;
end dimension;

protected function lm_134
  input Tpl.Text in_txt;
  input list<Integer> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<Integer> rest;
      Integer i_dim;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_dim :: rest )
      equation
        txt = Tpl.writeStr(txt, intString(i_dim));
        txt = Tpl.nextIter(txt);
        txt = lm_134(txt, rest);
      then txt;
  end match;
end lm_134;

public function checkDimension
  input Tpl.Text txt;
  input DAE.Dimensions a_dims;

  output Tpl.Text out_txt;
protected
  list<Integer> ret_0;
algorithm
  ret_0 := Expression.dimensionsList(a_dims);
  out_txt := Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_134(out_txt, ret_0);
  out_txt := Tpl.popIter(out_txt);
end checkDimension;

protected function lm_136
  input Tpl.Text in_txt;
  input list<Integer> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<Integer> rest;
      Integer i_dim;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_dim :: rest )
      equation
        txt = Tpl.writeStr(txt, intString(i_dim));
        txt = Tpl.nextIter(txt);
        txt = lm_136(txt, rest);
      then txt;
  end match;
end lm_136;

public function checkExpDimension
  input Tpl.Text txt;
  input list<DAE.Exp> a_dims;

  output Tpl.Text out_txt;
protected
  list<Integer> ret_0;
algorithm
  ret_0 := Expression.expDimensionsList(a_dims);
  out_txt := Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_136(out_txt, ret_0);
  out_txt := Tpl.popIter(out_txt);
end checkExpDimension;

protected function fun_138
  input Tpl.Text in_txt;
  input String in_mArg;
  input Tpl.Text in_a_subdimstr;
  input Tpl.Text in_a_dimstr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_subdimstr, in_a_dimstr)
    local
      Tpl.Text txt;
      Tpl.Text a_subdimstr;
      Tpl.Text a_dimstr;

    case ( txt,
           "",
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_subdimstr,
           a_dimstr )
      equation
        txt = Tpl.writeText(txt, a_dimstr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_subdimstr);
      then txt;
  end match;
end fun_138;

protected function fun_139
  input Tpl.Text in_txt;
  input DAE.Type in_a_elty;
  input Tpl.Text in_a_dimstr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_elty, in_a_dimstr)
    local
      Tpl.Text txt;
      Tpl.Text a_dimstr;
      DAE.Type i_subty;
      DAE.Dimensions i_subdims;
      String str_1;
      Tpl.Text l_subdimstr;

    case ( txt,
           DAE.T_ARRAY(dims = i_subdims, ty = i_subty),
           a_dimstr )
      equation
        l_subdimstr = listDimsFlat(Tpl.emptyTxt, i_subdims, i_subty);
        str_1 = Tpl.textString(l_subdimstr);
        txt = fun_138(txt, str_1, l_subdimstr, a_dimstr);
      then txt;

    case ( txt,
           _,
           a_dimstr )
      equation
        txt = Tpl.writeText(txt, a_dimstr);
      then txt;
  end match;
end fun_139;

protected function fun_140
  input Tpl.Text in_txt;
  input String in_mArg;
  input Tpl.Text in_a_dimstr;
  input DAE.Type in_a_elty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_dimstr, in_a_elty)
    local
      Tpl.Text txt;
      Tpl.Text a_dimstr;
      DAE.Type a_elty;

    case ( txt,
           "",
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_dimstr,
           a_elty )
      equation
        txt = fun_139(txt, a_elty, a_dimstr);
      then txt;
  end match;
end fun_140;

public function listDimsFlat
  input Tpl.Text txt;
  input DAE.Dimensions a_dims;
  input DAE.Type a_elty;

  output Tpl.Text out_txt;
protected
  String str_1;
  Tpl.Text l_dimstr;
algorithm
  l_dimstr := checkDimension(Tpl.emptyTxt, a_dims);
  str_1 := Tpl.textString(l_dimstr);
  out_txt := fun_140(txt, str_1, l_dimstr, a_elty);
end listDimsFlat;

protected function fun_142
  input Tpl.Text in_txt;
  input DAE.Type in_a_elty;
  input DAE.Dimensions in_a_dims;
  input Integer in_a_offset;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_elty, in_a_dims, in_a_offset)
    local
      Tpl.Text txt;
      DAE.Dimensions a_dims;
      Integer a_offset;
      DAE.Dimensions i_dims;
      DAE.Type i_subty;
      DAE.Dimensions i_subdims;
      Integer ret_3;
      Integer ret_2;
      Integer ret_1;
      Integer ret_0;

    case ( txt,
           DAE.T_ARRAY(dims = (i_dims as i_subdims), ty = i_subty),
           _,
           a_offset )
      equation
        ret_0 = listLength(i_dims);
        ret_1 = intAdd(ret_0, a_offset);
        txt = nDimsFlat(txt, i_subdims, i_subty, ret_1);
      then txt;

    case ( txt,
           _,
           a_dims,
           a_offset )
      equation
        ret_2 = listLength(a_dims);
        ret_3 = intAdd(ret_2, a_offset);
        txt = Tpl.writeStr(txt, intString(ret_3));
      then txt;
  end match;
end fun_142;

public function nDimsFlat
  input Tpl.Text txt;
  input DAE.Dimensions a_dims;
  input DAE.Type a_elty;
  input Integer a_offset;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_142(txt, a_elty, a_dims, a_offset);
end nDimsFlat;

protected function fun_144
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("string"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("metatype"));
      then txt;
  end match;
end fun_144;

public function expTypeShort
  input Tpl.Text in_txt;
  input DAE.Type in_a_type;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_type)
    local
      Tpl.Text txt;
      DAE.Type i_type;
      ClassInf.State i_complexClassType;
      DAE.Type i_ty;
      DAE.Type i_complexType;
      String ret_2;
      Absyn.Path ret_1;
      Boolean ret_0;

    case ( txt,
           DAE.T_INTEGER(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("int"));
      then txt;

    case ( txt,
           DAE.T_REAL(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("double"));
      then txt;

    case ( txt,
           DAE.T_STRING(varLst = _) )
      equation
        ret_0 = Config.acceptMetaModelicaGrammar();
        txt = fun_144(txt, ret_0);
      then txt;

    case ( txt,
           DAE.T_BOOL(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("bool"));
      then txt;

    case ( txt,
           DAE.T_ENUMERATION(index = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("int"));
      then txt;

    case ( txt,
           DAE.T_UNKNOWN() )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("double /*W1*/"));
      then txt;

    case ( txt,
           DAE.T_ANYTYPE(anyClassType = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("complex2"));
      then txt;

    case ( txt,
           DAE.T_SUBTYPE_BASIC(complexType = i_complexType) )
      equation
        txt = expTypeShort(txt, i_complexType);
      then txt;

    case ( txt,
           DAE.T_ARRAY(ty = i_ty) )
      equation
        txt = expTypeShort(txt, i_ty);
      then txt;

    case ( txt,
           DAE.T_COMPLEX(complexClassType = ClassInf.EXTERNAL_OBJ(path = _)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void*"));
      then txt;

    case ( txt,
           DAE.T_COMPLEX(complexClassType = i_complexClassType) )
      equation
        ret_1 = ClassInf.getStateName(i_complexClassType);
        txt = CodegenUtil.underscorePath(txt, ret_1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Type"));
      then txt;

    case ( txt,
           DAE.T_METATYPE(ty = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("metatype"));
      then txt;

    case ( txt,
           DAE.T_METABOXED(ty = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("metatype"));
      then txt;

    case ( txt,
           DAE.T_FUNCTION_REFERENCE_VAR(functionType = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("fnptr"));
      then txt;

    case ( txt,
           i_type )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("expTypeShort:ERROR "));
        ret_2 = Types.unparseType(i_type);
        txt = Tpl.writeStr(txt, ret_2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
      then txt;
  end match;
end expTypeShort;

protected function fun_146
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty)
    local
      Tpl.Text txt;
      DAE.Type i_ty;
      ClassInf.State i_complexClassType;
      Absyn.Path ret_0;

    case ( txt,
           DAE.T_COMPLEX(complexClassType = i_complexClassType) )
      equation
        ret_0 = ClassInf.getStateName(i_complexClassType);
        txt = CodegenUtil.underscorePath(txt, ret_0);
      then txt;

    case ( txt,
           i_ty )
      equation
        txt = expTypeShort(txt, i_ty);
      then txt;
  end match;
end fun_146;

protected function fun_147
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty)
    local
      Tpl.Text txt;
      DAE.Type i_ty;
      Absyn.Path i_rname;

    case ( txt,
           DAE.T_COMPLEX(complexClassType = ClassInf.RECORD(path = i_rname)) )
      equation
        txt = CodegenUtil.underscorePath(txt, i_rname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Type"));
      then txt;

    case ( txt,
           i_ty )
      equation
        txt = fun_146(txt, i_ty);
      then txt;
  end match;
end fun_147;

protected function fun_148
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty)
    local
      Tpl.Text txt;
      DAE.Type i_ty;

    case ( txt,
           (i_ty as DAE.T_COMPLEX(complexClassType = ClassInf.EXTERNAL_OBJ(path = _))) )
      equation
        txt = expTypeShort(txt, i_ty);
      then txt;

    case ( txt,
           i_ty )
      equation
        txt = fun_147(txt, i_ty);
      then txt;
  end match;
end fun_148;

protected function fun_149
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty)
    local
      Tpl.Text txt;
      DAE.Dimensions i_dims;
      DAE.Type i_elty;

    case ( txt,
           DAE.T_ARRAY(ty = i_elty, dims = i_dims) )
      equation
        txt = expTypeArrayDims(txt, i_elty, i_dims);
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("ERROR:expTypeFlag3 no array"));
      then txt;
  end match;
end fun_149;

protected function fun_150
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty)
    local
      Tpl.Text txt;
      DAE.Type i_ty;
      DAE.Dimensions i_dims;
      DAE.Type i_elty;

    case ( txt,
           DAE.T_ARRAY(ty = i_elty, dims = i_dims) )
      equation
        txt = expTypeArrayDims(txt, i_elty, i_dims);
      then txt;

    case ( txt,
           i_ty )
      equation
        txt = expTypeFlag(txt, i_ty, 2);
      then txt;
  end match;
end fun_150;

protected function fun_151
  input Tpl.Text in_txt;
  input String in_mArg;
  input Tpl.Text in_a_dimstr;
  input DAE.Type in_a_ty;
  input DAE.Dimensions in_a_dims;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_dimstr, in_a_ty, in_a_dims)
    local
      Tpl.Text txt;
      Tpl.Text a_dimstr;
      DAE.Type a_ty;
      DAE.Dimensions a_dims;
      Integer ret_1;
      Integer ret_0;

    case ( txt,
           "",
           _,
           a_ty,
           a_dims )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("DynArrayDim"));
        ret_0 = listLength(a_dims);
        txt = Tpl.writeStr(txt, intString(ret_0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<"));
        txt = expTypeShort(txt, a_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(">"));
      then txt;

    case ( txt,
           _,
           a_dimstr,
           a_ty,
           a_dims )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("StatArrayDim"));
        ret_1 = listLength(a_dims);
        txt = Tpl.writeStr(txt, intString(ret_1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<"));
        txt = expTypeShort(txt, a_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, a_dimstr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(">&"));
      then txt;
  end match;
end fun_151;

protected function fun_152
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty)
    local
      Tpl.Text txt;
      DAE.Type i_ty;
      DAE.Dimensions i_dims;
      String str_1;
      Tpl.Text l_dimstr;

    case ( txt,
           (i_ty as DAE.T_ARRAY(dims = i_dims)) )
      equation
        l_dimstr = checkDimension(Tpl.emptyTxt, i_dims);
        str_1 = Tpl.textString(l_dimstr);
        txt = fun_151(txt, str_1, l_dimstr, i_ty, i_dims);
      then txt;

    case ( txt,
           i_ty )
      equation
        txt = expTypeFlag(txt, i_ty, 2);
      then txt;
  end match;
end fun_152;

protected function fun_153
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty)
    local
      Tpl.Text txt;
      DAE.Dimensions i_dims;
      DAE.Type i_ty;
      Integer ret_0;

    case ( txt,
           DAE.T_ARRAY(dims = i_dims, ty = i_ty) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("multi_array<"));
        txt = expTypeShort(txt, i_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        ret_0 = listLength(i_dims);
        txt = Tpl.writeStr(txt, intString(ret_0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(">"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_153;

protected function fun_154
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty)
    local
      Tpl.Text txt;
      DAE.Type i_ty;

    case ( txt,
           DAE.T_ARRAY(dims = _, ty = i_ty) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("BaseArray<"));
        txt = expTypeShort(txt, i_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(">&"));
      then txt;

    case ( txt,
           i_ty )
      equation
        txt = expTypeFlag(txt, i_ty, 9);
      then txt;
  end match;
end fun_154;

protected function fun_155
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty)
    local
      Tpl.Text txt;
      DAE.Type i_ty;
      ClassInf.State i_complexClassType;
      Absyn.Path ret_0;

    case ( txt,
           DAE.T_COMPLEX(complexClassType = i_complexClassType) )
      equation
        ret_0 = ClassInf.getStateName(i_complexClassType);
        txt = CodegenUtil.underscorePath(txt, ret_0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("&"));
      then txt;

    case ( txt,
           i_ty )
      equation
        txt = expTypeShort(txt, i_ty);
      then txt;
  end match;
end fun_155;

protected function fun_156
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty)
    local
      Tpl.Text txt;
      DAE.Type i_ty;
      Absyn.Path i_rname;

    case ( txt,
           DAE.T_COMPLEX(complexClassType = ClassInf.RECORD(path = i_rname)) )
      equation
        txt = CodegenUtil.underscorePath(txt, i_rname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Type&"));
      then txt;

    case ( txt,
           i_ty )
      equation
        txt = fun_155(txt, i_ty);
      then txt;
  end match;
end fun_156;

protected function fun_157
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty)
    local
      Tpl.Text txt;
      DAE.Type i_ty;

    case ( txt,
           (i_ty as DAE.T_COMPLEX(complexClassType = ClassInf.EXTERNAL_OBJ(path = _))) )
      equation
        txt = expTypeShort(txt, i_ty);
      then txt;

    case ( txt,
           i_ty )
      equation
        txt = fun_156(txt, i_ty);
      then txt;
  end match;
end fun_157;

protected function fun_158
  input Tpl.Text in_txt;
  input Integer in_a_flag;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_flag, in_a_ty)
    local
      Tpl.Text txt;
      DAE.Type a_ty;

    case ( txt,
           1,
           a_ty )
      equation
        txt = expTypeShort(txt, a_ty);
      then txt;

    case ( txt,
           2,
           a_ty )
      equation
        txt = fun_148(txt, a_ty);
      then txt;

    case ( txt,
           3,
           a_ty )
      equation
        txt = fun_149(txt, a_ty);
      then txt;

    case ( txt,
           4,
           a_ty )
      equation
        txt = fun_150(txt, a_ty);
      then txt;

    case ( txt,
           5,
           a_ty )
      equation
        txt = fun_152(txt, a_ty);
      then txt;

    case ( txt,
           6,
           a_ty )
      equation
        txt = expTypeFlag(txt, a_ty, 4);
      then txt;

    case ( txt,
           7,
           a_ty )
      equation
        txt = fun_153(txt, a_ty);
      then txt;

    case ( txt,
           8,
           a_ty )
      equation
        txt = fun_154(txt, a_ty);
      then txt;

    case ( txt,
           9,
           a_ty )
      equation
        txt = fun_157(txt, a_ty);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_158;

public function expTypeFlag
  input Tpl.Text txt;
  input DAE.Type a_ty;
  input Integer a_flag;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_158(txt, a_flag, a_ty);
end expTypeFlag;

public function crefType
  input Tpl.Text in_txt;
  input DAE.ComponentRef in_a_cr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_cr)
    local
      Tpl.Text txt;
      DAE.ComponentRef i_componentRef;
      DAE.Type i_identType;

    case ( txt,
           DAE.CREF_IDENT(identType = i_identType) )
      equation
        txt = expTypeArrayIf(txt, i_identType);
      then txt;

    case ( txt,
           DAE.CREF_QUAL(componentRef = i_componentRef) )
      equation
        txt = crefType(txt, i_componentRef);
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("crefType:ERROR"));
      then txt;
  end match;
end crefType;

public function expTypeFromExpShort
  input Tpl.Text txt;
  input DAE.Exp a_exp;

  output Tpl.Text out_txt;
algorithm
  out_txt := expTypeFromExpFlag(txt, a_exp, 1);
end expTypeFromExpShort;

public function expTypeFromExpModelica
  input Tpl.Text txt;
  input DAE.Exp a_exp;

  output Tpl.Text out_txt;
algorithm
  out_txt := expTypeFromExpFlag(txt, a_exp, 2);
end expTypeFromExpModelica;

public function expTypeFromExpArray
  input Tpl.Text txt;
  input DAE.Exp a_exp;

  output Tpl.Text out_txt;
algorithm
  out_txt := expTypeFromExpFlag(txt, a_exp, 4);
end expTypeFromExpArray;

protected function fun_164
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("string"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("metatype"));
      then txt;
  end match;
end fun_164;

public function expTypeShortSPS
  input Tpl.Text in_txt;
  input DAE.Type in_a_type;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_type)
    local
      Tpl.Text txt;
      ClassInf.State i_complexClassType;
      DAE.Type i_ty;
      Absyn.Path ret_1;
      Boolean ret_0;

    case ( txt,
           DAE.T_INTEGER(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("INT"));
      then txt;

    case ( txt,
           DAE.T_REAL(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("LREAL"));
      then txt;

    case ( txt,
           DAE.T_STRING(varLst = _) )
      equation
        ret_0 = Config.acceptMetaModelicaGrammar();
        txt = fun_164(txt, ret_0);
      then txt;

    case ( txt,
           DAE.T_BOOL(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("BOOL"));
      then txt;

    case ( txt,
           DAE.T_ENUMERATION(index = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("INT"));
      then txt;

    case ( txt,
           DAE.T_UNKNOWN() )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("LREAL"));
      then txt;

    case ( txt,
           DAE.T_ANYTYPE(anyClassType = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("type not supported"));
      then txt;

    case ( txt,
           DAE.T_ARRAY(ty = i_ty) )
      equation
        txt = expTypeShortSPS(txt, i_ty);
      then txt;

    case ( txt,
           DAE.T_COMPLEX(complexClassType = ClassInf.EXTERNAL_OBJ(path = _)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("type not supported"));
      then txt;

    case ( txt,
           DAE.T_COMPLEX(complexClassType = i_complexClassType) )
      equation
        ret_1 = ClassInf.getStateName(i_complexClassType);
        txt = CodegenUtil.underscorePath(txt, ret_1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Type"));
      then txt;

    case ( txt,
           DAE.T_METATYPE(ty = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("type not supported"));
      then txt;

    case ( txt,
           DAE.T_METABOXED(ty = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("type not supported"));
      then txt;

    case ( txt,
           DAE.T_FUNCTION_REFERENCE_VAR(functionType = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("type not supported"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("expTypeShort:ERROR"));
      then txt;
  end match;
end expTypeShortSPS;

protected function fun_166
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("string"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("metatype"));
      then txt;
  end match;
end fun_166;

public function expTypeShortMLPI
  input Tpl.Text in_txt;
  input DAE.Type in_a_type;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_type)
    local
      Tpl.Text txt;
      ClassInf.State i_complexClassType;
      DAE.Type i_ty;
      Absyn.Path ret_1;
      Boolean ret_0;

    case ( txt,
           DAE.T_INTEGER(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("MLPI_IEC_INT"));
      then txt;

    case ( txt,
           DAE.T_REAL(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("MLPI_IEC_LREAL"));
      then txt;

    case ( txt,
           DAE.T_STRING(varLst = _) )
      equation
        ret_0 = Config.acceptMetaModelicaGrammar();
        txt = fun_166(txt, ret_0);
      then txt;

    case ( txt,
           DAE.T_BOOL(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("MLPI_IEC_BOOL"));
      then txt;

    case ( txt,
           DAE.T_ENUMERATION(index = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("MLPI_IEC_INT"));
      then txt;

    case ( txt,
           DAE.T_UNKNOWN() )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("MLPI_IEC_LREAL"));
      then txt;

    case ( txt,
           DAE.T_ANYTYPE(anyClassType = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("type not supported"));
      then txt;

    case ( txt,
           DAE.T_ARRAY(ty = i_ty) )
      equation
        txt = expTypeShortSPS(txt, i_ty);
      then txt;

    case ( txt,
           DAE.T_COMPLEX(complexClassType = ClassInf.EXTERNAL_OBJ(path = _)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("type not supported"));
      then txt;

    case ( txt,
           DAE.T_COMPLEX(complexClassType = i_complexClassType) )
      equation
        ret_1 = ClassInf.getStateName(i_complexClassType);
        txt = CodegenUtil.underscorePath(txt, ret_1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Type"));
      then txt;

    case ( txt,
           DAE.T_METATYPE(ty = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("type not supported"));
      then txt;

    case ( txt,
           DAE.T_METABOXED(ty = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("type not supported"));
      then txt;

    case ( txt,
           DAE.T_FUNCTION_REFERENCE_VAR(functionType = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("type not supported"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("expTypeShort:ERROR"));
      then txt;
  end match;
end expTypeShortMLPI;

protected function fun_168
  input Tpl.Text in_txt;
  input Boolean in_a_isArray;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_isArray, in_a_ty)
    local
      Tpl.Text txt;
      DAE.Type a_ty;

    case ( txt,
           false,
           a_ty )
      equation
        txt = expTypeShort(txt, a_ty);
      then txt;

    case ( txt,
           _,
           a_ty )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("expType_"));
        txt = expTypeArray1(txt, a_ty, 0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_NOT_YET"));
      then txt;
  end match;
end fun_168;

public function expType
  input Tpl.Text txt;
  input DAE.Type a_ty;
  input Boolean a_isArray;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_168(txt, a_isArray, a_ty);
end expType;

public function expTypeModelica
  input Tpl.Text txt;
  input DAE.Type a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt := expTypeFlag(txt, a_ty, 2);
end expTypeModelica;

public function expTypeArray
  input Tpl.Text txt;
  input DAE.Type a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt := expTypeFlag(txt, a_ty, 3);
end expTypeArray;

public function expTypeArrayIf
  input Tpl.Text txt;
  input DAE.Type a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt := expTypeFlag(txt, a_ty, 4);
end expTypeArrayIf;

public function expTypeArray1
  input Tpl.Text txt;
  input DAE.Type a_ty;
  input Integer a_dims;

  output Tpl.Text out_txt;
algorithm
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING("SimArray"));
  out_txt := Tpl.writeStr(out_txt, intString(a_dims));
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("<"));
  out_txt := expTypeShort(out_txt, a_ty);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING(">"));
end expTypeArray1;

protected function fun_174
  input Tpl.Text in_txt;
  input String in_mArg;
  input Tpl.Text in_a_dimstr;
  input Tpl.Text in_a_typeShort;
  input DAE.Type in_a_elty;
  input DAE.Dimensions in_a_dims;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_dimstr, in_a_typeShort, in_a_elty, in_a_dims)
    local
      Tpl.Text txt;
      Tpl.Text a_dimstr;
      Tpl.Text a_typeShort;
      DAE.Type a_elty;
      DAE.Dimensions a_dims;

    case ( txt,
           "",
           _,
           a_typeShort,
           a_elty,
           a_dims )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("DynArrayDim"));
        txt = nDimsFlat(txt, a_dims, a_elty, 0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<"));
        txt = Tpl.writeText(txt, a_typeShort);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(">"));
      then txt;

    case ( txt,
           _,
           a_dimstr,
           a_typeShort,
           a_elty,
           a_dims )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("StatArrayDim"));
        txt = nDimsFlat(txt, a_dims, a_elty, 0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<"));
        txt = Tpl.writeText(txt, a_typeShort);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_dimstr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(">"));
      then txt;
  end match;
end fun_174;

public function expTypeArrayDims
  input Tpl.Text txt;
  input DAE.Type a_elty;
  input DAE.Dimensions a_dims;

  output Tpl.Text out_txt;
protected
  String str_2;
  Tpl.Text l_dimstr;
  Tpl.Text l_typeShort;
algorithm
  l_typeShort := expTypeShort(Tpl.emptyTxt, a_elty);
  l_dimstr := listDimsFlat(Tpl.emptyTxt, a_dims, a_elty);
  str_2 := Tpl.textString(l_dimstr);
  out_txt := fun_174(txt, str_2, l_dimstr, l_typeShort, a_elty, a_dims);
end expTypeArrayDims;

protected function lm_176
  input Tpl.Text in_txt;
  input DAE.Dimensions in_items;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_context)
    local
      Tpl.Text txt;
      DAE.Dimensions rest;
      SimCodeFunction.Context a_context;
      DAE.Dimension i_dim;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_dim :: rest,
           a_context )
      equation
        txt = dimension(txt, i_dim, a_context);
        txt = Tpl.nextIter(txt);
        txt = lm_176(txt, rest, a_context);
      then txt;
  end match;
end lm_176;

public function allocateDimensions
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty, in_a_context)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      DAE.Dimensions i_dims;
      Tpl.Text l_dimstr;

    case ( txt,
           DAE.T_ARRAY(dims = i_dims),
           a_context )
      equation
        l_dimstr = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_dimstr = lm_176(l_dimstr, i_dims, a_context);
        l_dimstr = Tpl.popIter(l_dimstr);
        txt = Tpl.writeText(txt, l_dimstr);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end allocateDimensions;

public function tempDecl
  input Tpl.Text txt;
  input String a_ty;
  input Tpl.Text a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
protected
  Integer ret_1;
  Tpl.Text l_newVar;
algorithm
  l_newVar := Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("tmp"));
  ret_1 := System.tmpTick();
  l_newVar := Tpl.writeStr(l_newVar, intString(ret_1));
  out_a_varDecls := Tpl.writeStr(a_varDecls, a_ty);
  out_a_varDecls := Tpl.writeTok(out_a_varDecls, Tpl.ST_STRING(" "));
  out_a_varDecls := Tpl.writeText(out_a_varDecls, l_newVar);
  out_a_varDecls := Tpl.writeTok(out_a_varDecls, Tpl.ST_STRING(";"));
  out_a_varDecls := Tpl.writeTok(out_a_varDecls, Tpl.ST_NEW_LINE());
  out_txt := Tpl.writeText(txt, l_newVar);
end tempDecl;

public function tempDeclAssign
  input Tpl.Text txt;
  input String a_ty;
  input Tpl.Text a_varDecls;
  input String a_assign;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
protected
  Integer ret_1;
  Tpl.Text l_newVar;
algorithm
  l_newVar := Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("tmp"));
  ret_1 := System.tmpTick();
  l_newVar := Tpl.writeStr(l_newVar, intString(ret_1));
  out_a_varDecls := Tpl.writeStr(a_varDecls, a_ty);
  out_a_varDecls := Tpl.writeTok(out_a_varDecls, Tpl.ST_STRING(" "));
  out_a_varDecls := Tpl.writeText(out_a_varDecls, l_newVar);
  out_a_varDecls := Tpl.writeTok(out_a_varDecls, Tpl.ST_STRING(" = "));
  out_a_varDecls := Tpl.writeStr(out_a_varDecls, a_assign);
  out_a_varDecls := Tpl.writeTok(out_a_varDecls, Tpl.ST_STRING(";"));
  out_a_varDecls := Tpl.writeTok(out_a_varDecls, Tpl.ST_NEW_LINE());
  out_txt := Tpl.writeText(txt, l_newVar);
end tempDeclAssign;

public function tempDecl1
  input Tpl.Text txt;
  input String a_ty;
  input String a_exp;
  input Tpl.Text a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
protected
  Tpl.Text l_newVar1;
  Integer ret_1;
  Tpl.Text l_newVar;
algorithm
  l_newVar := Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("tmp"));
  ret_1 := System.tmpTick();
  l_newVar := Tpl.writeStr(l_newVar, intString(ret_1));
  l_newVar1 := Tpl.writeText(Tpl.emptyTxt, l_newVar);
  l_newVar1 := Tpl.writeTok(l_newVar1, Tpl.ST_STRING("("));
  l_newVar1 := Tpl.writeStr(l_newVar1, a_exp);
  l_newVar1 := Tpl.writeTok(l_newVar1, Tpl.ST_STRING(")"));
  out_a_varDecls := Tpl.writeStr(a_varDecls, a_ty);
  out_a_varDecls := Tpl.writeTok(out_a_varDecls, Tpl.ST_STRING(" "));
  out_a_varDecls := Tpl.writeText(out_a_varDecls, l_newVar1);
  out_a_varDecls := Tpl.writeTok(out_a_varDecls, Tpl.ST_STRING(";"));
  out_a_varDecls := Tpl.writeTok(out_a_varDecls, Tpl.ST_NEW_LINE());
  out_txt := Tpl.writeText(txt, l_newVar);
end tempDecl1;

protected function fun_181
  input Tpl.Text in_txt;
  input SimCodeFunction.Context in_a_context;
  input Boolean in_a_useFlatArrayNotation;
  input DAE.ComponentRef in_a_cr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_context, in_a_useFlatArrayNotation, in_a_cr)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      DAE.ComponentRef a_cr;
      String ret_1;
      Tpl.Text txt_0;

    case ( txt,
           SimCodeFunction.FUNCTION_CONTEXT(cref_prefix = _),
           _,
           a_cr )
      equation
        txt_0 = crefStr(Tpl.emptyTxt, a_cr);
        ret_1 = System.unquoteIdentifier(Tpl.textString(txt_0));
        txt = Tpl.writeStr(txt, ret_1);
      then txt;

    case ( txt,
           _,
           a_useFlatArrayNotation,
           a_cr )
      equation
        txt = cref(txt, a_cr, a_useFlatArrayNotation);
      then txt;
  end match;
end fun_181;

public function dimensionExp
  input Tpl.Text in_txt;
  input DAE.Exp in_a_dimExp;
  input SimCodeFunction.Context in_a_context;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_dimExp, in_a_context, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Boolean a_useFlatArrayNotation;
      DAE.Exp i_dimExp;
      DAE.ComponentRef i_cr;

    case ( txt,
           DAE.CREF(componentRef = i_cr),
           a_context,
           a_useFlatArrayNotation )
      equation
        txt = fun_181(txt, a_context, a_useFlatArrayNotation, i_cr);
      then txt;

    case ( txt,
           i_dimExp,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/* fehler dimensionExp: INVALID_DIMENSION "));
        txt = ExpressionDumpTpl.dumpExp(txt, i_dimExp, "\"");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("*/"));
      then txt;
  end match;
end dimensionExp;

public function daeDimensionExp
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_exp)
    local
      Tpl.Text txt;
      Integer i_integer;

    case ( txt,
           DAE.ICONST(integer = i_integer) )
      equation
        txt = Tpl.writeStr(txt, intString(i_integer));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-1"));
      then txt;
  end match;
end daeDimensionExp;

protected function fun_184
  input Tpl.Text in_txt;
  input Boolean in_a_bool;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_bool)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("false"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("true"));
      then txt;
  end match;
end fun_184;

public function daeExp
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_exp, in_a_context, in_a_preExp, in_a_varDecls, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      DAE.Exp i_exp;
      DAE.Exp i_expElse;
      DAE.Exp i_expThen;
      DAE.Exp i_expCond;
      DAE.Exp i_exp2;
      DAE.Exp i_exp1;
      DAE.Operator i_operator;
      String i_string;
      DAE.Exp i_e;
      Integer i_index;
      Boolean i_bool;
      Real i_real;
      Integer i_integer;
      Tpl.Text txt_0;

    case ( txt,
           DAE.ICONST(integer = i_integer),
           _,
           a_preExp,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      equation
        txt = Tpl.writeStr(txt, intString(i_integer));
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.RCONST(real = i_real),
           _,
           a_preExp,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      equation
        txt = Tpl.writeStr(txt, realString(i_real));
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.BCONST(bool = i_bool),
           _,
           a_preExp,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      equation
        txt = fun_184(txt, i_bool);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.ENUM_LITERAL(index = i_index),
           _,
           a_preExp,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      equation
        txt = Tpl.writeStr(txt, intString(i_index));
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           (i_e as DAE.CREF(componentRef = _)),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExpCrefRhs(txt, i_e, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           (i_e as DAE.CAST(ty = _)),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExpCast(txt, i_e, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.CONS(car = _),
           _,
           a_preExp,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Cons not supported yet"));
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.SCONST(string = i_string),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExpSconst(txt, i_string, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           (i_e as DAE.UNARY(operator = _)),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExpUnary(txt, i_e, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           (i_e as DAE.LBINARY(exp1 = _)),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExpLbinary(txt, i_e, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           (i_e as DAE.LUNARY(operator = _)),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExpLunary(txt, i_e, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.BINARY(operator = i_operator, exp1 = i_exp1, exp2 = i_exp2),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExpBinary(txt, i_operator, i_exp1, i_exp2, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.IFEXP(expCond = i_expCond, expThen = i_expThen, expElse = i_expElse),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExpIf(txt, i_expCond, i_expThen, i_expElse, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           (i_e as DAE.RELATION(exp1 = _)),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExpRelation(txt, i_e, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           (i_e as DAE.CALL(path = _)),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExpCall(txt, i_e, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           (i_e as DAE.RECORD(path = _)),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExpRecord(txt, i_e, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           (i_e as DAE.ASUB(exp = _)),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/*t1*/"));
        (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExpAsub(txt, i_e, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           (i_e as DAE.MATRIX(ty = _)),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExpMatrix(txt, i_e, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           (i_e as DAE.RANGE(ty = _)),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/*t2*/"));
        (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExpRange(txt, i_e, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           (i_e as DAE.TSUB(exp = _)),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/*t3*/"));
        (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExpTsub(txt, i_e, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           (i_e as DAE.REDUCTION(reductionInfo = _)),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExpReduction(txt, i_e, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           (i_e as DAE.ARRAY(ty = _)),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/*t4*/"));
        (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExpArray(txt, i_e, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           (i_e as DAE.SIZE(exp = _)),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExpSize(txt, i_e, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           (i_e as DAE.SHARED_LITERAL(index = _)),
           a_context,
           a_preExp,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (txt, a_preExp, a_varDecls) = daeExpSharedLiteral(txt, i_e, a_context, a_preExp, a_varDecls, a_useFlatArrayNotation);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           (i_e as DAE.PARTEVALFUNCTION(path = _)),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExpPartEvalFunction(txt, i_e, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           (i_e as DAE.BOX(exp = _)),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExpBox(txt, i_e, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           (i_e as DAE.UNBOX(exp = _)),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExpUnbox(txt, i_e, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           (i_e as DAE.RSUB(exp = _)),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExpRSub(txt, i_e, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           i_exp,
           _,
           a_preExp,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      equation
        txt_0 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("Unknown exp:"));
        txt_0 = ExpressionDumpTpl.dumpExp(txt_0, i_exp, "\"");
        txt = error(txt, Tpl.sourceInfo("CodegenCppCommon.tpl", 993, 14), Tpl.textString(txt_0));
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end daeExp;

public function daeExpRSub
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_exp, in_a_context, in_a_preExp, in_a_varDecls, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      String i_fieldName;
      DAE.Exp i_exp;
      Tpl.Text txt_1;
      Tpl.Text l_res;

    case ( txt,
           DAE.RSUB(ix = -1, exp = i_exp, fieldName = i_fieldName),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (l_res, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_exp, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeText(txt, l_res);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("."));
        txt = Tpl.writeStr(txt, i_fieldName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.RSUB(exp = i_exp),
           _,
           a_preExp,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      equation
        txt_1 = ExpressionDumpTpl.dumpExp(Tpl.emptyTxt, i_exp, "\"");
        txt_1 = Tpl.writeTok(txt_1, Tpl.ST_STRING(": failed"));
        txt = error(txt, Tpl.sourceInfo("CodegenCppCommon.tpl", 1005, 11), Tpl.textString(txt_1));
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           a_preExp,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end daeExpRSub;

protected function fun_187
  input Tpl.Text in_txt;
  input Option<DAE.Exp> in_a_step;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_a_step, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Exp i_stepExp;

    case ( txt,
           SOME(i_stepExp),
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(txt, i_stepExp, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);

    case ( txt,
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           a_preExp,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("1"));
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);
  end match;
end fun_187;

public function daeExpRange
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_exp, in_a_context, in_a_preExp, in_a_varDecls, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      Option<DAE.Exp> i_step;
      DAE.Exp i_stop;
      DAE.Exp i_start;
      DAE.Type i_ty;
      Tpl.Text l_step__exp;
      Tpl.Text txt_4;
      Tpl.Text l_tmp;
      Tpl.Text l_stop__exp;
      Tpl.Text l_start__exp;
      Tpl.Text l_ty__str;

    case ( txt,
           DAE.RANGE(ty = i_ty, start = i_start, stop = i_stop, step = i_step),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_ty__str = expTypeShort(Tpl.emptyTxt, i_ty);
        (l_start__exp, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_start, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        (l_stop__exp, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_stop, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt_4 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("DynArrayDim1<"));
        txt_4 = Tpl.writeText(txt_4, l_ty__str);
        txt_4 = Tpl.writeTok(txt_4, Tpl.ST_STRING(">"));
        (l_tmp, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(txt_4), a_varDecls);
        (l_step__exp, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = fun_187(Tpl.emptyTxt, i_step, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("int "));
        a_preExp = Tpl.writeText(a_preExp, l_tmp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("_num_elems =("));
        a_preExp = Tpl.writeText(a_preExp, l_stop__exp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("-"));
        a_preExp = Tpl.writeText(a_preExp, l_start__exp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(")/"));
        a_preExp = Tpl.writeText(a_preExp, l_step__exp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_LINE("+1;\n"));
        a_preExp = Tpl.writeText(a_preExp, l_tmp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(".setDims("));
        a_preExp = Tpl.writeText(a_preExp, l_tmp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING_LIST({
                                              "_num_elems) /*daeExpRange*/;\n",
                                              "for (int "
                                          }, false));
        a_preExp = Tpl.writeText(a_preExp, l_tmp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("_i = 1; "));
        a_preExp = Tpl.writeText(a_preExp, l_tmp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("_i <= "));
        a_preExp = Tpl.writeText(a_preExp, l_tmp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("_num_elems; "));
        a_preExp = Tpl.writeText(a_preExp, l_tmp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_LINE("_i++)\n"));
        a_preExp = Tpl.pushBlock(a_preExp, Tpl.BT_INDENT(2));
        a_preExp = Tpl.writeText(a_preExp, l_tmp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("("));
        a_preExp = Tpl.writeText(a_preExp, l_tmp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("_i) = "));
        a_preExp = Tpl.writeText(a_preExp, l_start__exp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("+("));
        a_preExp = Tpl.writeText(a_preExp, l_tmp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("_i-1)*"));
        a_preExp = Tpl.writeText(a_preExp, l_step__exp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(";"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        a_preExp = Tpl.popBlock(a_preExp);
        txt = Tpl.writeText(txt, l_tmp);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           a_preExp,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end daeExpRange;

protected function fun_189
  input Tpl.Text in_txt;
  input Absyn.Path in_a_ri_path;
  input Tpl.Text in_a_tmpVarDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_tmpVarDecls;
algorithm
  (out_txt, out_a_tmpVarDecls) :=
  match(in_txt, in_a_ri_path, in_a_tmpVarDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_tmpVarDecls;

    case ( txt,
           Absyn.IDENT(name = "array"),
           a_tmpVarDecls )
      equation
        (txt, a_tmpVarDecls) = tempDecl(txt, "int", a_tmpVarDecls);
      then (txt, a_tmpVarDecls);

    case ( txt,
           _,
           a_tmpVarDecls )
      then (txt, a_tmpVarDecls);
  end match;
end fun_189;

protected function fun_190
  input Tpl.Text in_txt;
  input Option<Values.Value> in_a_ri_defaultValue;
  input Tpl.Text in_a_tmpVarDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_tmpVarDecls;
algorithm
  (out_txt, out_a_tmpVarDecls) :=
  match(in_txt, in_a_ri_defaultValue, in_a_tmpVarDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_tmpVarDecls;

    case ( txt,
           NONE(),
           a_tmpVarDecls )
      equation
        (txt, a_tmpVarDecls) = tempDecl(txt, "int", a_tmpVarDecls);
      then (txt, a_tmpVarDecls);

    case ( txt,
           _,
           a_tmpVarDecls )
      then (txt, a_tmpVarDecls);
  end match;
end fun_190;

protected function fun_191
  input Tpl.Text in_txt;
  input Absyn.Path in_a_ri_path;
  input Tpl.Text in_a_tmpVarDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_tmpVarDecls;
algorithm
  (out_txt, out_a_tmpVarDecls) :=
  match(in_txt, in_a_ri_path, in_a_tmpVarDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_tmpVarDecls;

    case ( txt,
           Absyn.IDENT(name = "list"),
           a_tmpVarDecls )
      equation
        (txt, a_tmpVarDecls) = tempDecl(txt, "modelica_metatype*", a_tmpVarDecls);
      then (txt, a_tmpVarDecls);

    case ( txt,
           _,
           a_tmpVarDecls )
      then (txt, a_tmpVarDecls);
  end match;
end fun_191;

protected function fun_192
  input Tpl.Text in_txt;
  input Option<Values.Value> in_a_ri_defaultValue;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_tmpVarDecls;
  input Tpl.Text in_a_preDefault;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_tmpVarDecls;
  output Tpl.Text out_a_preDefault;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_tmpVarDecls, out_a_preDefault) :=
  match(in_txt, in_a_ri_defaultValue, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_tmpVarDecls, in_a_preDefault, in_a_context)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_tmpVarDecls;
      Tpl.Text a_preDefault;
      SimCodeFunction.Context a_context;
      Values.Value i_v;
      DAE.Exp ret_0;

    case ( txt,
           SOME(i_v),
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_tmpVarDecls,
           a_preDefault,
           a_context )
      equation
        ret_0 = ValuesUtil.valueExp(i_v);
        (txt, a_preDefault, a_tmpVarDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(txt, ret_0, a_context, a_preDefault, a_tmpVarDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_tmpVarDecls, a_preDefault);

    case ( txt,
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_tmpVarDecls,
           a_preDefault,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_tmpVarDecls, a_preDefault);
  end match;
end fun_192;

protected function fun_193
  input Tpl.Text in_txt;
  input Absyn.Path in_a_ri_path;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_tmpVarDecls;
  input Tpl.Text in_a_preDefault;
  input SimCodeFunction.Context in_a_context;
  input Option<Values.Value> in_a_ri_defaultValue;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_tmpVarDecls;
  output Tpl.Text out_a_preDefault;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_tmpVarDecls, out_a_preDefault) :=
  match(in_txt, in_a_ri_path, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_tmpVarDecls, in_a_preDefault, in_a_context, in_a_ri_defaultValue)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_tmpVarDecls;
      Tpl.Text a_preDefault;
      SimCodeFunction.Context a_context;
      Option<Values.Value> a_ri_defaultValue;

    case ( txt,
           Absyn.IDENT(name = "array"),
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_tmpVarDecls,
           a_preDefault,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_tmpVarDecls, a_preDefault);

    case ( txt,
           _,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_tmpVarDecls,
           a_preDefault,
           a_context,
           a_ri_defaultValue )
      equation
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_tmpVarDecls, a_preDefault) = fun_192(txt, a_ri_defaultValue, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_tmpVarDecls, a_preDefault, a_context);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_tmpVarDecls, a_preDefault);
  end match;
end fun_193;

protected function lm_194
  input Tpl.Text in_txt;
  input DAE.Dimensions in_items;
  input Tpl.Text in_a_tmp__indeces;
  input Tpl.Text in_a_tmp__shape;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_varDecls) :=
  match(in_txt, in_items, in_a_tmp__indeces, in_a_tmp__shape, in_a_varDecls)
    local
      Tpl.Text txt;
      DAE.Dimensions rest;
      Tpl.Text a_tmp__indeces;
      Tpl.Text a_tmp__shape;
      Tpl.Text a_varDecls;
      Tpl.Text l_tmp__idx;

    case ( txt,
           {},
           _,
           _,
           a_varDecls )
      then (txt, a_varDecls);

    case ( txt,
           _ :: rest,
           a_tmp__indeces,
           a_tmp__shape,
           a_varDecls )
      equation
        (l_tmp__idx, a_varDecls) = tempDecl(Tpl.emptyTxt, "vector<size_t>", a_varDecls);
        txt = Tpl.writeText(txt, a_tmp__shape);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".push_back(1);"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(23));
        txt = Tpl.writeText(txt, a_tmp__indeces);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".push_back("));
        txt = Tpl.writeText(txt, l_tmp__idx);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.popBlock(txt);
        (txt, a_varDecls) = lm_194(txt, rest, a_tmp__indeces, a_tmp__shape, a_varDecls);
      then (txt, a_varDecls);
  end match;
end lm_194;

protected function fun_195
  input Tpl.Text in_txt;
  input DAE.Type in_mArg;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_reductionBodyExpr;
  input Tpl.Text in_a_arrIndex;
  input Tpl.Text in_a_res;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_varDecls) :=
  match(in_txt, in_mArg, in_a_varDecls, in_a_reductionBodyExpr, in_a_arrIndex, in_a_res)
    local
      Tpl.Text txt;
      Tpl.Text a_varDecls;
      Tpl.Text a_reductionBodyExpr;
      Tpl.Text a_arrIndex;
      Tpl.Text a_res;
      DAE.Dimensions i_dims;
      ClassInf.State i_record__state;
      Tpl.Text l_tmp__idx;
      Tpl.Text l_tmp__indeces;
      Tpl.Text l_tmp__shape;
      Absyn.Path ret_1;
      Tpl.Text l_rec__name;

    case ( txt,
           DAE.T_COMPLEX(complexClassType = i_record__state),
           a_varDecls,
           a_reductionBodyExpr,
           a_arrIndex,
           a_res )
      equation
        ret_1 = ClassInf.getStateName(i_record__state);
        l_rec__name = CodegenUtil.underscorePath(Tpl.emptyTxt, ret_1);
        txt = Tpl.writeText(txt, l_rec__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_array_get("));
        txt = Tpl.writeText(txt, a_res);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", 1, "));
        txt = Tpl.writeText(txt, a_arrIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("++) = "));
        txt = Tpl.writeText(txt, a_reductionBodyExpr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then (txt, a_varDecls);

    case ( txt,
           DAE.T_ARRAY(dims = i_dims),
           a_varDecls,
           a_reductionBodyExpr,
           a_arrIndex,
           a_res )
      equation
        (l_tmp__shape, a_varDecls) = tempDecl(Tpl.emptyTxt, "vector<size_t>", a_varDecls);
        (l_tmp__indeces, a_varDecls) = tempDecl(Tpl.emptyTxt, "idx_type", a_varDecls);
        (l_tmp__idx, a_varDecls) = tempDecl(Tpl.emptyTxt, "vector<size_t>", a_varDecls);
        (txt, a_varDecls) = lm_194(txt, i_dims, l_tmp__indeces, l_tmp__shape, a_varDecls);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_tmp__shape);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".push_back(0);"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tmp__idx);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".push_back("));
        txt = Tpl.writeText(txt, a_arrIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("++);"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tmp__indeces);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".push_back("));
        txt = Tpl.writeText(txt, l_tmp__idx);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "fill_array_from_shape(make_pair("
                                }, false));
        txt = Tpl.writeText(txt, l_tmp__shape);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, l_tmp__indeces);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("),"));
        txt = Tpl.writeText(txt, a_reductionBodyExpr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, a_res);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then (txt, a_varDecls);

    case ( txt,
           _,
           a_varDecls,
           a_reductionBodyExpr,
           a_arrIndex,
           a_res )
      equation
        txt = Tpl.writeText(txt, a_res);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_arrIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("++) = "));
        txt = Tpl.writeText(txt, a_reductionBodyExpr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then (txt, a_varDecls);
  end match;
end fun_195;

protected function fun_196
  input Tpl.Text in_txt;
  input Tpl.Text in_a_foundFirst;
  input Tpl.Text in_a_reductionBodyExpr;
  input Tpl.Text in_a_fExpStr;
  input Tpl.Text in_a_res;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_foundFirst, in_a_reductionBodyExpr, in_a_fExpStr, in_a_res)
    local
      Tpl.Text txt;
      Tpl.Text a_reductionBodyExpr;
      Tpl.Text a_fExpStr;
      Tpl.Text a_res;
      Tpl.Text i_foundFirst;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           _,
           a_fExpStr,
           a_res )
      equation
        txt = Tpl.writeText(txt, a_res);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, a_fExpStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           i_foundFirst,
           a_reductionBodyExpr,
           a_fExpStr,
           a_res )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if("));
        txt = Tpl.writeText(txt, i_foundFirst);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ")\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_res);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, a_fExpStr);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "else\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_res);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, a_reductionBodyExpr);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.writeText(txt, i_foundFirst);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" = 1;\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;
  end match;
end fun_196;

protected function fun_197
  input Tpl.Text in_txt;
  input Option<DAE.Exp> in_a_ri_foldExp;
  input Tpl.Text in_a_reductionBodyExpr;
  input Tpl.Text in_a_res;
  input Tpl.Text in_a_foundFirst;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_tmpVarDecls;
  input Tpl.Text in_a_bodyExpPre;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_tmpVarDecls;
  output Tpl.Text out_a_bodyExpPre;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_tmpVarDecls, out_a_bodyExpPre) :=
  match(in_txt, in_a_ri_foldExp, in_a_reductionBodyExpr, in_a_res, in_a_foundFirst, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_tmpVarDecls, in_a_bodyExpPre, in_a_context)
    local
      Tpl.Text txt;
      Tpl.Text a_reductionBodyExpr;
      Tpl.Text a_res;
      Tpl.Text a_foundFirst;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_tmpVarDecls;
      Tpl.Text a_bodyExpPre;
      SimCodeFunction.Context a_context;
      DAE.Exp i_fExp;
      Tpl.Text l_fExpStr;
      Tpl.Text l_foldExpPre;

    case ( txt,
           SOME(i_fExp),
           a_reductionBodyExpr,
           a_res,
           a_foundFirst,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_tmpVarDecls,
           a_bodyExpPre,
           a_context )
      equation
        l_foldExpPre = Tpl.emptyTxt;
        (l_fExpStr, a_bodyExpPre, a_tmpVarDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_fExp, a_context, a_bodyExpPre, a_tmpVarDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = fun_196(txt, a_foundFirst, a_reductionBodyExpr, l_fExpStr, a_res);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_tmpVarDecls, a_bodyExpPre);

    case ( txt,
           _,
           _,
           _,
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_tmpVarDecls,
           a_bodyExpPre,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_tmpVarDecls, a_bodyExpPre);
  end match;
end fun_197;

protected function fun_198
  input Tpl.Text in_txt;
  input Absyn.Path in_a_ri_path;
  input Tpl.Text in_a_foundFirst;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_tmpVarDecls;
  input Tpl.Text in_a_bodyExpPre;
  input SimCodeFunction.Context in_a_context;
  input Option<DAE.Exp> in_a_ri_foldExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_arrIndex;
  input DAE.Exp in_a_r_expr;
  input Tpl.Text in_a_res;
  input Tpl.Text in_a_reductionBodyExpr;
  input Tpl.Text in_a_resTail;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_tmpVarDecls;
  output Tpl.Text out_a_bodyExpPre;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_tmpVarDecls, out_a_bodyExpPre, out_a_varDecls) :=
  match(in_txt, in_a_ri_path, in_a_foundFirst, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_tmpVarDecls, in_a_bodyExpPre, in_a_context, in_a_ri_foldExp, in_a_varDecls, in_a_arrIndex, in_a_r_expr, in_a_res, in_a_reductionBodyExpr, in_a_resTail)
    local
      Tpl.Text txt;
      Tpl.Text a_foundFirst;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_tmpVarDecls;
      Tpl.Text a_bodyExpPre;
      SimCodeFunction.Context a_context;
      Option<DAE.Exp> a_ri_foldExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_arrIndex;
      DAE.Exp a_r_expr;
      Tpl.Text a_res;
      Tpl.Text a_reductionBodyExpr;
      Tpl.Text a_resTail;
      DAE.Type ret_0;

    case ( txt,
           Absyn.IDENT(name = "list"),
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_tmpVarDecls,
           a_bodyExpPre,
           _,
           _,
           a_varDecls,
           _,
           _,
           _,
           a_reductionBodyExpr,
           a_resTail )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("*"));
        txt = Tpl.writeText(txt, a_resTail);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = mmc_mk_cons("));
        txt = Tpl.writeText(txt, a_reductionBodyExpr);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",0);\n"));
        txt = Tpl.writeText(txt, a_resTail);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = &MMC_CDR(*"));
        txt = Tpl.writeText(txt, a_resTail);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_tmpVarDecls, a_bodyExpPre, a_varDecls);

    case ( txt,
           Absyn.IDENT(name = "listReverse"),
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_tmpVarDecls,
           a_bodyExpPre,
           _,
           _,
           a_varDecls,
           _,
           _,
           a_res,
           a_reductionBodyExpr,
           _ )
      equation
        txt = Tpl.writeText(txt, a_res);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = mmc_mk_cons("));
        txt = Tpl.writeText(txt, a_reductionBodyExpr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, a_res);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_tmpVarDecls, a_bodyExpPre, a_varDecls);

    case ( txt,
           Absyn.IDENT(name = "array"),
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_tmpVarDecls,
           a_bodyExpPre,
           _,
           _,
           a_varDecls,
           a_arrIndex,
           a_r_expr,
           a_res,
           a_reductionBodyExpr,
           _ )
      equation
        ret_0 = Expression.typeof(a_r_expr);
        (txt, a_varDecls) = fun_195(txt, ret_0, a_varDecls, a_reductionBodyExpr, a_arrIndex, a_res);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_tmpVarDecls, a_bodyExpPre, a_varDecls);

    case ( txt,
           _,
           a_foundFirst,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_tmpVarDecls,
           a_bodyExpPre,
           a_context,
           a_ri_foldExp,
           a_varDecls,
           _,
           _,
           a_res,
           a_reductionBodyExpr,
           _ )
      equation
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_tmpVarDecls, a_bodyExpPre) = fun_197(txt, a_ri_foldExp, a_reductionBodyExpr, a_res, a_foundFirst, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_tmpVarDecls, a_bodyExpPre, a_context);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_tmpVarDecls, a_bodyExpPre, a_varDecls);
  end match;
end fun_198;

protected function fun_199
  input Tpl.Text in_txt;
  input Tpl.Text in_a_firstIndex;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_firstIndex)
    local
      Tpl.Text txt;
      Tpl.Text i_firstIndex;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}) )
      then txt;

    case ( txt,
           i_firstIndex )
      equation
        txt = Tpl.writeText(txt, i_firstIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = 1;"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;
  end match;
end fun_199;

protected function fun_200
  input Tpl.Text in_txt;
  input Option<DAE.Exp> in_a_iter_guardExp;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_tmpVarDecls;
  input Tpl.Text in_a_guardExpPre;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_tmpVarDecls;
  output Tpl.Text out_a_guardExpPre;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_tmpVarDecls, out_a_guardExpPre) :=
  match(in_txt, in_a_iter_guardExp, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_tmpVarDecls, in_a_guardExpPre, in_a_context)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_tmpVarDecls;
      Tpl.Text a_guardExpPre;
      SimCodeFunction.Context a_context;
      DAE.Exp i_grd;

    case ( txt,
           SOME(i_grd),
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_tmpVarDecls,
           a_guardExpPre,
           a_context )
      equation
        (txt, a_guardExpPre, a_tmpVarDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(txt, i_grd, a_context, a_guardExpPre, a_tmpVarDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_tmpVarDecls, a_guardExpPre);

    case ( txt,
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_tmpVarDecls,
           a_guardExpPre,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("1"));
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_tmpVarDecls, a_guardExpPre);
  end match;
end fun_200;

protected function fun_201
  input Tpl.Text in_txt;
  input DAE.Type in_a_iter_ty;
  input Tpl.Text in_a_firstIndex;
  input Tpl.Text in_a_loopVar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_iter_ty, in_a_firstIndex, in_a_loopVar)
    local
      Tpl.Text txt;
      Tpl.Text a_firstIndex;
      Tpl.Text a_loopVar;
      ClassInf.State i_record__state;
      Absyn.Path ret_1;
      Tpl.Text l_rec__name;

    case ( txt,
           DAE.T_ARRAY(ty = DAE.T_COMPLEX(complexClassType = i_record__state)),
           a_firstIndex,
           a_loopVar )
      equation
        ret_1 = ClassInf.getStateName(i_record__state);
        l_rec__name = CodegenUtil.underscorePath(Tpl.emptyTxt, ret_1);
        txt = Tpl.writeText(txt, l_rec__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_array_get("));
        txt = Tpl.writeText(txt, a_loopVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", 1, "));
        txt = Tpl.writeText(txt, a_firstIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("++)"));
      then txt;

    case ( txt,
           _,
           a_firstIndex,
           a_loopVar )
      equation
        txt = Tpl.writeText(txt, a_loopVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("( "));
        txt = Tpl.writeText(txt, a_firstIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("++)"));
      then txt;
  end match;
end fun_201;

protected function lm_202
  input Tpl.Text in_txt;
  input DAE.ReductionIterators in_items;
  input Tpl.Text in_a_endLoop;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_rangeExpPre;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_tmpVarDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_rangeExpPre;
  output Tpl.Text out_a_tmpVarDecls;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_rangeExpPre, out_a_tmpVarDecls) :=
  match(in_txt, in_items, in_a_endLoop, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_rangeExpPre, in_a_context, in_a_tmpVarDecls)
    local
      Tpl.Text txt;
      DAE.ReductionIterators rest;
      Tpl.Text a_endLoop;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_rangeExpPre;
      SimCodeFunction.Context a_context;
      Tpl.Text a_tmpVarDecls;
      DAE.Type i_iter_ty;
      Option<DAE.Exp> i_iter_guardExp;
      String i_iter_id;
      DAE.Type i_ty;
      DAE.Exp i_iter_exp;
      Tpl.Text l_addr;
      Tpl.Text l_guardExp;
      Tpl.Text l_iteratorName;
      Tpl.Text l_empty;
      Tpl.Text l_guardCond;
      Tpl.Text l_rangeExp;
      Tpl.Text l_firstIndex;
      Tpl.Text l_guardExpPre;
      Tpl.Text l_loopVar;
      Tpl.Text l_arrayType;
      Tpl.Text l_ty__str;
      Tpl.Text l_identType;

    case ( txt,
           {},
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_rangeExpPre,
           _,
           a_tmpVarDecls )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_rangeExpPre, a_tmpVarDecls);

    case ( txt,
           DAE.REDUCTIONITER(exp = i_iter_exp, ty = (i_iter_ty as i_ty), id = i_iter_id, guardExp = i_iter_guardExp) :: rest,
           a_endLoop,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_rangeExpPre,
           a_context,
           a_tmpVarDecls )
      equation
        l_identType = expTypeFromExpModelica(Tpl.emptyTxt, i_iter_exp);
        l_ty__str = expTypeShort(Tpl.emptyTxt, i_ty);
        l_arrayType = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("DynArrayDim1<"));
        l_arrayType = Tpl.writeText(l_arrayType, l_identType);
        l_arrayType = Tpl.writeTok(l_arrayType, Tpl.ST_STRING(">"));
        l_loopVar = Tpl.writeStr(Tpl.emptyTxt, i_iter_id);
        l_loopVar = Tpl.writeTok(l_loopVar, Tpl.ST_STRING("_loopVar"));
        l_guardExpPre = Tpl.emptyTxt;
        a_tmpVarDecls = Tpl.writeText(a_tmpVarDecls, l_arrayType);
        a_tmpVarDecls = Tpl.writeTok(a_tmpVarDecls, Tpl.ST_STRING(" "));
        a_tmpVarDecls = Tpl.writeText(a_tmpVarDecls, l_loopVar);
        a_tmpVarDecls = Tpl.writeTok(a_tmpVarDecls, Tpl.ST_STRING(";/*testloopvar*/"));
        a_tmpVarDecls = Tpl.writeTok(a_tmpVarDecls, Tpl.ST_NEW_LINE());
        (l_firstIndex, a_tmpVarDecls) = tempDecl(Tpl.emptyTxt, "int", a_tmpVarDecls);
        (l_rangeExp, a_rangeExpPre, a_tmpVarDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_iter_exp, a_context, a_rangeExpPre, a_tmpVarDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        a_rangeExpPre = Tpl.writeText(a_rangeExpPre, l_loopVar);
        a_rangeExpPre = Tpl.writeTok(a_rangeExpPre, Tpl.ST_STRING(" = "));
        a_rangeExpPre = Tpl.writeText(a_rangeExpPre, l_rangeExp);
        a_rangeExpPre = Tpl.writeTok(a_rangeExpPre, Tpl.ST_STRING("/*testloopvar2*/;"));
        a_rangeExpPre = Tpl.writeTok(a_rangeExpPre, Tpl.ST_NEW_LINE());
        a_rangeExpPre = fun_199(a_rangeExpPre, l_firstIndex);
        (l_guardCond, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_tmpVarDecls, l_guardExpPre) = fun_200(Tpl.emptyTxt, i_iter_guardExp, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_tmpVarDecls, l_guardExpPre, a_context);
        l_empty = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("0 == ("));
        l_empty = Tpl.writeText(l_empty, l_loopVar);
        l_empty = Tpl.writeTok(l_empty, Tpl.ST_STRING(".getDim(2))"));
        l_iteratorName = contextIteratorName(Tpl.emptyTxt, i_iter_id, a_context);
        a_tmpVarDecls = Tpl.writeText(a_tmpVarDecls, l_identType);
        a_tmpVarDecls = Tpl.writeTok(a_tmpVarDecls, Tpl.ST_STRING(" "));
        a_tmpVarDecls = Tpl.writeText(a_tmpVarDecls, l_iteratorName);
        a_tmpVarDecls = Tpl.writeTok(a_tmpVarDecls, Tpl.ST_STRING(";"));
        a_tmpVarDecls = Tpl.writeTok(a_tmpVarDecls, Tpl.ST_NEW_LINE());
        l_guardExp = Tpl.writeText(Tpl.emptyTxt, l_guardExpPre);
        l_guardExp = Tpl.softNewLine(l_guardExp);
        l_guardExp = Tpl.writeTok(l_guardExp, Tpl.ST_STRING("if("));
        l_guardExp = Tpl.writeText(l_guardExp, l_guardCond);
        l_guardExp = Tpl.writeTok(l_guardExp, Tpl.ST_LINE(") { /* found non-guarded */\n"));
        l_guardExp = Tpl.pushBlock(l_guardExp, Tpl.BT_INDENT(2));
        l_guardExp = Tpl.writeText(l_guardExp, a_endLoop);
        l_guardExp = Tpl.writeTok(l_guardExp, Tpl.ST_STRING_LIST({
                                                  "--;\n",
                                                  "break;\n"
                                              }, true));
        l_guardExp = Tpl.popBlock(l_guardExp);
        l_guardExp = Tpl.writeTok(l_guardExp, Tpl.ST_STRING("}"));
        l_addr = fun_201(Tpl.emptyTxt, i_iter_ty, l_firstIndex, l_loopVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("while("));
        txt = Tpl.writeText(txt, l_firstIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" <=  "));
        txt = Tpl.writeText(txt, l_loopVar);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(".getDim(1)) {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_iteratorName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, l_addr);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.writeText(txt, l_guardExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_rangeExpPre, a_tmpVarDecls) = lm_202(txt, rest, a_endLoop, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_rangeExpPre, a_context, a_tmpVarDecls);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_rangeExpPre, a_tmpVarDecls);

    case ( txt,
           _ :: rest,
           a_endLoop,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_rangeExpPre,
           a_context,
           a_tmpVarDecls )
      equation
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_rangeExpPre, a_tmpVarDecls) = lm_202(txt, rest, a_endLoop, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_rangeExpPre, a_context, a_tmpVarDecls);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_rangeExpPre, a_tmpVarDecls);
  end match;
end lm_202;

protected function lm_203
  input Tpl.Text in_txt;
  input DAE.ReductionIterators in_items;
  input Tpl.Text in_a_length;
  input Tpl.Text in_a_rangeExpPre;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_rangeExpPre;
algorithm
  (out_txt, out_a_rangeExpPre) :=
  match(in_txt, in_items, in_a_length, in_a_rangeExpPre)
    local
      Tpl.Text txt;
      DAE.ReductionIterators rest;
      Tpl.Text a_length;
      Tpl.Text a_rangeExpPre;
      String i_iter_id;
      Tpl.Text l_loopVar;

    case ( txt,
           {},
           _,
           a_rangeExpPre )
      then (txt, a_rangeExpPre);

    case ( txt,
           DAE.REDUCTIONITER(id = i_iter_id) :: rest,
           a_length,
           a_rangeExpPre )
      equation
        l_loopVar = Tpl.writeStr(Tpl.emptyTxt, i_iter_id);
        l_loopVar = Tpl.writeTok(l_loopVar, Tpl.ST_STRING("_loopVar"));
        a_rangeExpPre = Tpl.writeText(a_rangeExpPre, a_length);
        a_rangeExpPre = Tpl.writeTok(a_rangeExpPre, Tpl.ST_STRING(" = max("));
        a_rangeExpPre = Tpl.writeText(a_rangeExpPre, a_length);
        a_rangeExpPre = Tpl.writeTok(a_rangeExpPre, Tpl.ST_STRING(", "));
        a_rangeExpPre = Tpl.writeText(a_rangeExpPre, l_loopVar);
        a_rangeExpPre = Tpl.writeTok(a_rangeExpPre, Tpl.ST_STRING(".getDim(1));"));
        a_rangeExpPre = Tpl.writeTok(a_rangeExpPre, Tpl.ST_NEW_LINE());
        (txt, a_rangeExpPre) = lm_203(txt, rest, a_length, a_rangeExpPre);
      then (txt, a_rangeExpPre);

    case ( txt,
           _ :: rest,
           a_length,
           a_rangeExpPre )
      equation
        (txt, a_rangeExpPre) = lm_203(txt, rest, a_length, a_rangeExpPre);
      then (txt, a_rangeExpPre);
  end match;
end lm_203;

protected function fun_204
  input Tpl.Text in_txt;
  input DAE.Dimension in_a_dim;
  input DAE.Exp in_a_r_expr;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_tmpVarDecls;
  input Tpl.Text in_a_rangeExpPre;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_dim__vec;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_tmpVarDecls;
  output Tpl.Text out_a_rangeExpPre;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_tmpVarDecls, out_a_rangeExpPre) :=
  match(in_txt, in_a_dim, in_a_r_expr, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_tmpVarDecls, in_a_rangeExpPre, in_a_context, in_a_dim__vec)
    local
      Tpl.Text txt;
      DAE.Exp a_r_expr;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_tmpVarDecls;
      Tpl.Text a_rangeExpPre;
      SimCodeFunction.Context a_context;
      Tpl.Text a_dim__vec;
      DAE.Exp i_exp;
      Integer i_size;
      Integer i_integer;
      Tpl.Text txt_1;
      String ret_2;
      DAE.Type ret_1;
      Tpl.Text l_val;

    case ( txt,
           DAE.DIM_INTEGER(integer = i_integer),
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_tmpVarDecls,
           a_rangeExpPre,
           _,
           a_dim__vec )
      equation
        txt = Tpl.writeText(txt, a_dim__vec);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".push_back("));
        txt = Tpl.writeStr(txt, intString(i_integer));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_tmpVarDecls, a_rangeExpPre);

    case ( txt,
           DAE.DIM_BOOLEAN(),
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_tmpVarDecls,
           a_rangeExpPre,
           _,
           a_dim__vec )
      equation
        txt = Tpl.writeText(txt, a_dim__vec);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".push_back(2)"));
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_tmpVarDecls, a_rangeExpPre);

    case ( txt,
           DAE.DIM_ENUM(size = i_size),
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_tmpVarDecls,
           a_rangeExpPre,
           _,
           a_dim__vec )
      equation
        txt = Tpl.writeText(txt, a_dim__vec);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".push_back("));
        txt = Tpl.writeStr(txt, intString(i_size));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_tmpVarDecls, a_rangeExpPre);

    case ( txt,
           DAE.DIM_EXP(exp = i_exp),
           _,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_tmpVarDecls,
           a_rangeExpPre,
           a_context,
           a_dim__vec )
      equation
        (l_val, a_rangeExpPre, a_tmpVarDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_exp, a_context, a_rangeExpPre, a_tmpVarDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeText(txt, a_dim__vec);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".push_back("));
        txt = Tpl.writeText(txt, l_val);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_tmpVarDecls, a_rangeExpPre);

    case ( txt,
           _,
           a_r_expr,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_tmpVarDecls,
           a_rangeExpPre,
           _,
           _ )
      equation
        txt_1 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("array reduction unable to generate code for element of unknown dimension sizes; type "));
        ret_1 = Expression.typeof(a_r_expr);
        ret_2 = Types.unparseType(ret_1);
        txt_1 = Tpl.writeStr(txt_1, ret_2);
        txt_1 = Tpl.writeTok(txt_1, Tpl.ST_STRING(": "));
        txt_1 = ExpressionDumpTpl.dumpExp(txt_1, a_r_expr, "\"");
        txt = error(txt, Tpl.sourceInfo("CodegenCppCommon.tpl", 1177, 24), Tpl.textString(txt_1));
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_tmpVarDecls, a_rangeExpPre);
  end match;
end fun_204;

protected function lm_205
  input Tpl.Text in_txt;
  input DAE.Dimensions in_items;
  input DAE.Exp in_a_r_expr;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_tmpVarDecls;
  input Tpl.Text in_a_rangeExpPre;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_dim__vec;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_tmpVarDecls;
  output Tpl.Text out_a_rangeExpPre;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_tmpVarDecls, out_a_rangeExpPre) :=
  match(in_txt, in_items, in_a_r_expr, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_tmpVarDecls, in_a_rangeExpPre, in_a_context, in_a_dim__vec)
    local
      Tpl.Text txt;
      DAE.Dimensions rest;
      DAE.Exp a_r_expr;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_tmpVarDecls;
      Tpl.Text a_rangeExpPre;
      SimCodeFunction.Context a_context;
      Tpl.Text a_dim__vec;
      DAE.Dimension i_dim;

    case ( txt,
           {},
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_tmpVarDecls,
           a_rangeExpPre,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_tmpVarDecls, a_rangeExpPre);

    case ( txt,
           i_dim :: rest,
           a_r_expr,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_tmpVarDecls,
           a_rangeExpPre,
           a_context,
           a_dim__vec )
      equation
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_tmpVarDecls, a_rangeExpPre) = fun_204(txt, i_dim, a_r_expr, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_tmpVarDecls, a_rangeExpPre, a_context, a_dim__vec);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_tmpVarDecls, a_rangeExpPre) = lm_205(txt, rest, a_r_expr, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_tmpVarDecls, a_rangeExpPre, a_context, a_dim__vec);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_tmpVarDecls, a_rangeExpPre);
  end match;
end lm_205;

protected function fun_206
  input Tpl.Text in_txt;
  input DAE.Type in_mArg;
  input DAE.Exp in_a_r_expr;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_rangeExpPre;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_tmpVarDecls;
  input Tpl.Text in_a_length;
  input Tpl.Text in_a_res;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_rangeExpPre;
  output Tpl.Text out_a_tmpVarDecls;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_rangeExpPre, out_a_tmpVarDecls) :=
  match(in_txt, in_mArg, in_a_r_expr, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_rangeExpPre, in_a_context, in_a_tmpVarDecls, in_a_length, in_a_res)
    local
      Tpl.Text txt;
      DAE.Exp a_r_expr;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_rangeExpPre;
      SimCodeFunction.Context a_context;
      Tpl.Text a_tmpVarDecls;
      Tpl.Text a_length;
      Tpl.Text a_res;
      DAE.Dimensions i_dims;
      ClassInf.State i_record__state;
      Tpl.Text l_dimSizes;
      Tpl.Text l_dim__vec;
      Absyn.Path ret_1;
      Tpl.Text l_rec__name;

    case ( txt,
           DAE.T_COMPLEX(complexClassType = i_record__state),
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_rangeExpPre,
           _,
           a_tmpVarDecls,
           a_length,
           a_res )
      equation
        ret_1 = ClassInf.getStateName(i_record__state);
        l_rec__name = CodegenUtil.underscorePath(Tpl.emptyTxt, ret_1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("alloc_generic_array(&"));
        txt = Tpl.writeText(txt, a_res);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(",sizeof("));
        txt = Tpl.writeText(txt, l_rec__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("),1,"));
        txt = Tpl.writeText(txt, a_length);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_rangeExpPre, a_tmpVarDecls);

    case ( txt,
           DAE.T_ARRAY(dims = i_dims),
           a_r_expr,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_rangeExpPre,
           a_context,
           a_tmpVarDecls,
           a_length,
           a_res )
      equation
        (l_dim__vec, a_tmpVarDecls) = tempDecl(Tpl.emptyTxt, "std::vector<size_t>", a_tmpVarDecls);
        l_dimSizes = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING("; ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_dimSizes, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_tmpVarDecls, a_rangeExpPre) = lm_205(l_dimSizes, i_dims, a_r_expr, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_tmpVarDecls, a_rangeExpPre, a_context, l_dim__vec);
        l_dimSizes = Tpl.popIter(l_dimSizes);
        txt = Tpl.writeText(txt, l_dim__vec);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".push_back("));
        txt = Tpl.writeText(txt, a_length);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(");\n"));
        txt = Tpl.writeText(txt, l_dimSizes);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.writeText(txt, a_res);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".setDims("));
        txt = Tpl.writeText(txt, l_dim__vec);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_rangeExpPre, a_tmpVarDecls);

    case ( txt,
           _,
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_rangeExpPre,
           _,
           a_tmpVarDecls,
           a_length,
           a_res )
      equation
        txt = Tpl.writeText(txt, a_res);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".setDims("));
        txt = Tpl.writeText(txt, a_length);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_rangeExpPre, a_tmpVarDecls);
  end match;
end fun_206;

protected function fun_207
  input Tpl.Text in_txt;
  input Tpl.Text in_a_foundFirst;
  input Absyn.Path in_a_ri_path;
  input Tpl.Text in_a_defaultValue;
  input Tpl.Text in_a_res;
  input Tpl.Text in_a_preDefault;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_foundFirst, in_a_ri_path, in_a_defaultValue, in_a_res, in_a_preDefault)
    local
      Tpl.Text txt;
      Absyn.Path a_ri_path;
      Tpl.Text a_defaultValue;
      Tpl.Text a_res;
      Tpl.Text a_preDefault;
      Tpl.Text i_foundFirst;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           _,
           a_defaultValue,
           a_res,
           a_preDefault )
      equation
        txt = Tpl.writeText(txt, a_preDefault);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, a_res);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, a_defaultValue);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("; /* defaultValue */"));
      then txt;

    case ( txt,
           i_foundFirst,
           a_ri_path,
           _,
           _,
           _ )
      equation
        txt = Tpl.writeText(txt, i_foundFirst);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = 0; /* "));
        txt = CodegenUtil.dotPath(txt, a_ri_path);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" lacks default-value */"));
      then txt;
  end match;
end fun_207;

protected function fun_208
  input Tpl.Text in_txt;
  input Absyn.Path in_a_ri_path;
  input Tpl.Text in_a_defaultValue;
  input Tpl.Text in_a_preDefault;
  input Tpl.Text in_a_foundFirst;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_res;
  input DAE.Exp in_a_r_expr;
  input Tpl.Text in_a_arrIndex;
  input DAE.ReductionIterators in_a_iterators;
  input Tpl.Text in_a_rangeExpPre;
  input Tpl.Text in_a_tmpVarDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_rangeExpPre;
  output Tpl.Text out_a_tmpVarDecls;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_rangeExpPre, out_a_tmpVarDecls) :=
  match(in_txt, in_a_ri_path, in_a_defaultValue, in_a_preDefault, in_a_foundFirst, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_context, in_a_res, in_a_r_expr, in_a_arrIndex, in_a_iterators, in_a_rangeExpPre, in_a_tmpVarDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_defaultValue;
      Tpl.Text a_preDefault;
      Tpl.Text a_foundFirst;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      SimCodeFunction.Context a_context;
      Tpl.Text a_res;
      DAE.Exp a_r_expr;
      Tpl.Text a_arrIndex;
      DAE.ReductionIterators a_iterators;
      Tpl.Text a_rangeExpPre;
      Tpl.Text a_tmpVarDecls;
      Absyn.Path i_ri_path;
      DAE.Type ret_2;
      Tpl.Text l_0__;
      Tpl.Text l_length;

    case ( txt,
           Absyn.IDENT(name = "array"),
           _,
           _,
           _,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_context,
           a_res,
           a_r_expr,
           a_arrIndex,
           a_iterators,
           a_rangeExpPre,
           a_tmpVarDecls )
      equation
        (l_length, a_tmpVarDecls) = tempDecl(Tpl.emptyTxt, "int", a_tmpVarDecls);
        a_rangeExpPre = Tpl.writeText(a_rangeExpPre, l_length);
        a_rangeExpPre = Tpl.writeTok(a_rangeExpPre, Tpl.ST_STRING(" = 0;"));
        a_rangeExpPre = Tpl.writeTok(a_rangeExpPre, Tpl.ST_NEW_LINE());
        (l_0__, a_rangeExpPre) = lm_203(Tpl.emptyTxt, a_iterators, l_length, a_rangeExpPre);
        txt = Tpl.writeText(txt, a_arrIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" = 1;\n"));
        ret_2 = Expression.typeof(a_r_expr);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_rangeExpPre, a_tmpVarDecls) = fun_206(txt, ret_2, a_r_expr, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_rangeExpPre, a_context, a_tmpVarDecls, l_length, a_res);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_rangeExpPre, a_tmpVarDecls);

    case ( txt,
           i_ri_path,
           a_defaultValue,
           a_preDefault,
           a_foundFirst,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _,
           a_res,
           _,
           _,
           _,
           a_rangeExpPre,
           a_tmpVarDecls )
      equation
        txt = fun_207(txt, a_foundFirst, i_ri_path, a_defaultValue, a_res, a_preDefault);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_rangeExpPre, a_tmpVarDecls);
  end match;
end fun_208;

protected function fun_209
  input Tpl.Text in_txt;
  input DAE.ReductionIterators in_a_iterators;
  input Tpl.Text in_a_endLoop;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_iterators, in_a_endLoop)
    local
      Tpl.Text txt;
      Tpl.Text a_endLoop;
      DAE.ReductionIterators i_iterators;
      Integer ret_0;

    case ( txt,
           (i_iterators as _ :: _),
           a_endLoop )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("else if ("));
        txt = Tpl.writeText(txt, a_endLoop);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" == "));
        ret_0 = listLength(i_iterators);
        txt = Tpl.writeStr(txt, intString(ret_0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ") {\n",
                                    "  break;\n",
                                    "} else {\n",
                                    "  throw ModelicaSimulationError(MODEL_ARRAY_FUNCTION,\"Internal error\");\n",
                                    "}"
                                }, false));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_209;

protected function fun_210
  input Tpl.Text in_txt;
  input Tpl.Text in_a_resTail;
  input Tpl.Text in_a_res;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_resTail, in_a_res)
    local
      Tpl.Text txt;
      Tpl.Text a_res;
      Tpl.Text i_resTail;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           _ )
      then txt;

    case ( txt,
           i_resTail,
           a_res )
      equation
        txt = Tpl.writeText(txt, i_resTail);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = &"));
        txt = Tpl.writeText(txt, a_res);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_210;

protected function fun_211
  input Tpl.Text in_txt;
  input Tpl.Text in_a_foundFirst;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_foundFirst)
    local
      Tpl.Text txt;
      Tpl.Text i_foundFirst;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}) )
      then txt;

    case ( txt,
           i_foundFirst )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if (!"));
        txt = Tpl.writeText(txt, i_foundFirst);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") throw ModelicaSimulationError(MODEL_ARRAY_FUNCTION,\"Internal error\");"));
      then txt;
  end match;
end fun_211;

protected function fun_212
  input Tpl.Text in_txt;
  input Tpl.Text in_a_resTail;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_resTail)
    local
      Tpl.Text txt;
      Tpl.Text i_resTail;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}) )
      then txt;

    case ( txt,
           i_resTail )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("*"));
        txt = Tpl.writeText(txt, i_resTail);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = NULL;"));
      then txt;
  end match;
end fun_212;

protected function fun_213
  input Tpl.Text in_txt;
  input Absyn.Path in_a_ri_path;
  input Tpl.Text in_a_tmpVarDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_tmpVarDecls;
algorithm
  (out_txt, out_a_tmpVarDecls) :=
  match(in_txt, in_a_ri_path, in_a_tmpVarDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_tmpVarDecls;

    case ( txt,
           Absyn.IDENT(name = "array"),
           a_tmpVarDecls )
      equation
        (txt, a_tmpVarDecls) = tempDecl(txt, "int", a_tmpVarDecls);
      then (txt, a_tmpVarDecls);

    case ( txt,
           _,
           a_tmpVarDecls )
      then (txt, a_tmpVarDecls);
  end match;
end fun_213;

protected function fun_214
  input Tpl.Text in_txt;
  input Option<Values.Value> in_a_ri_defaultValue;
  input Tpl.Text in_a_tmpVarDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_tmpVarDecls;
algorithm
  (out_txt, out_a_tmpVarDecls) :=
  match(in_txt, in_a_ri_defaultValue, in_a_tmpVarDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_tmpVarDecls;

    case ( txt,
           NONE(),
           a_tmpVarDecls )
      equation
        (txt, a_tmpVarDecls) = tempDecl(txt, "int", a_tmpVarDecls);
      then (txt, a_tmpVarDecls);

    case ( txt,
           _,
           a_tmpVarDecls )
      then (txt, a_tmpVarDecls);
  end match;
end fun_214;

protected function fun_215
  input Tpl.Text in_txt;
  input Absyn.Path in_a_ri_path;
  input Tpl.Text in_a_tmpVarDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_tmpVarDecls;
algorithm
  (out_txt, out_a_tmpVarDecls) :=
  match(in_txt, in_a_ri_path, in_a_tmpVarDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_tmpVarDecls;

    case ( txt,
           Absyn.IDENT(name = "list"),
           a_tmpVarDecls )
      equation
        (txt, a_tmpVarDecls) = tempDecl(txt, "modelica_metatype*", a_tmpVarDecls);
      then (txt, a_tmpVarDecls);

    case ( txt,
           _,
           a_tmpVarDecls )
      then (txt, a_tmpVarDecls);
  end match;
end fun_215;

protected function fun_216
  input Tpl.Text in_txt;
  input Option<Values.Value> in_a_ri_defaultValue;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_tmpVarDecls;
  input Tpl.Text in_a_preDefault;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_tmpVarDecls;
  output Tpl.Text out_a_preDefault;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_tmpVarDecls, out_a_preDefault) :=
  match(in_txt, in_a_ri_defaultValue, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_tmpVarDecls, in_a_preDefault, in_a_context)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_tmpVarDecls;
      Tpl.Text a_preDefault;
      SimCodeFunction.Context a_context;
      Values.Value i_v;
      DAE.Exp ret_0;

    case ( txt,
           SOME(i_v),
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_tmpVarDecls,
           a_preDefault,
           a_context )
      equation
        ret_0 = ValuesUtil.valueExp(i_v);
        (txt, a_preDefault, a_tmpVarDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(txt, ret_0, a_context, a_preDefault, a_tmpVarDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_tmpVarDecls, a_preDefault);

    case ( txt,
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_tmpVarDecls,
           a_preDefault,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_tmpVarDecls, a_preDefault);
  end match;
end fun_216;

protected function fun_217
  input Tpl.Text in_txt;
  input Absyn.Path in_a_ri_path;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_tmpVarDecls;
  input Tpl.Text in_a_preDefault;
  input SimCodeFunction.Context in_a_context;
  input Option<Values.Value> in_a_ri_defaultValue;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_tmpVarDecls;
  output Tpl.Text out_a_preDefault;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_tmpVarDecls, out_a_preDefault) :=
  match(in_txt, in_a_ri_path, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_tmpVarDecls, in_a_preDefault, in_a_context, in_a_ri_defaultValue)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_tmpVarDecls;
      Tpl.Text a_preDefault;
      SimCodeFunction.Context a_context;
      Option<Values.Value> a_ri_defaultValue;

    case ( txt,
           Absyn.IDENT(name = "array"),
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_tmpVarDecls,
           a_preDefault,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_tmpVarDecls, a_preDefault);

    case ( txt,
           _,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_tmpVarDecls,
           a_preDefault,
           a_context,
           a_ri_defaultValue )
      equation
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_tmpVarDecls, a_preDefault) = fun_216(txt, a_ri_defaultValue, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_tmpVarDecls, a_preDefault, a_context);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_tmpVarDecls, a_preDefault);
  end match;
end fun_217;

protected function lm_218
  input Tpl.Text in_txt;
  input DAE.Dimensions in_items;
  input Tpl.Text in_a_tmp__indeces;
  input Tpl.Text in_a_tmp__shape;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_varDecls) :=
  match(in_txt, in_items, in_a_tmp__indeces, in_a_tmp__shape, in_a_varDecls)
    local
      Tpl.Text txt;
      DAE.Dimensions rest;
      Tpl.Text a_tmp__indeces;
      Tpl.Text a_tmp__shape;
      Tpl.Text a_varDecls;
      Tpl.Text l_tmp__idx;

    case ( txt,
           {},
           _,
           _,
           a_varDecls )
      then (txt, a_varDecls);

    case ( txt,
           _ :: rest,
           a_tmp__indeces,
           a_tmp__shape,
           a_varDecls )
      equation
        (l_tmp__idx, a_varDecls) = tempDecl(Tpl.emptyTxt, "vector<size_t>", a_varDecls);
        txt = Tpl.writeText(txt, a_tmp__shape);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".push_back(1);"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(23));
        txt = Tpl.writeText(txt, a_tmp__indeces);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".push_back("));
        txt = Tpl.writeText(txt, l_tmp__idx);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.popBlock(txt);
        (txt, a_varDecls) = lm_218(txt, rest, a_tmp__indeces, a_tmp__shape, a_varDecls);
      then (txt, a_varDecls);
  end match;
end lm_218;

protected function fun_219
  input Tpl.Text in_txt;
  input DAE.Type in_mArg;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_reductionBodyExpr;
  input Tpl.Text in_a_arrIndex;
  input Tpl.Text in_a_res;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_varDecls) :=
  match(in_txt, in_mArg, in_a_varDecls, in_a_reductionBodyExpr, in_a_arrIndex, in_a_res)
    local
      Tpl.Text txt;
      Tpl.Text a_varDecls;
      Tpl.Text a_reductionBodyExpr;
      Tpl.Text a_arrIndex;
      Tpl.Text a_res;
      DAE.Dimensions i_dims;
      ClassInf.State i_record__state;
      Tpl.Text l_tmp__idx;
      Tpl.Text l_tmp__indeces;
      Tpl.Text l_tmp__shape;
      Absyn.Path ret_1;
      Tpl.Text l_rec__name;

    case ( txt,
           DAE.T_COMPLEX(complexClassType = i_record__state),
           a_varDecls,
           a_reductionBodyExpr,
           a_arrIndex,
           a_res )
      equation
        ret_1 = ClassInf.getStateName(i_record__state);
        l_rec__name = CodegenUtil.underscorePath(Tpl.emptyTxt, ret_1);
        txt = Tpl.writeText(txt, l_rec__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_array_get("));
        txt = Tpl.writeText(txt, a_res);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", 1, "));
        txt = Tpl.writeText(txt, a_arrIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("++) = "));
        txt = Tpl.writeText(txt, a_reductionBodyExpr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then (txt, a_varDecls);

    case ( txt,
           DAE.T_ARRAY(dims = i_dims),
           a_varDecls,
           a_reductionBodyExpr,
           a_arrIndex,
           a_res )
      equation
        (l_tmp__shape, a_varDecls) = tempDecl(Tpl.emptyTxt, "vector<size_t>", a_varDecls);
        (l_tmp__indeces, a_varDecls) = tempDecl(Tpl.emptyTxt, "idx_type", a_varDecls);
        (l_tmp__idx, a_varDecls) = tempDecl(Tpl.emptyTxt, "vector<size_t>", a_varDecls);
        (txt, a_varDecls) = lm_218(txt, i_dims, l_tmp__indeces, l_tmp__shape, a_varDecls);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_tmp__shape);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".push_back(0);"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tmp__idx);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".push_back("));
        txt = Tpl.writeText(txt, a_arrIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("++);"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tmp__indeces);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".push_back("));
        txt = Tpl.writeText(txt, l_tmp__idx);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "fill_array_from_shape(make_pair("
                                }, false));
        txt = Tpl.writeText(txt, l_tmp__shape);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, l_tmp__indeces);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("),"));
        txt = Tpl.writeText(txt, a_reductionBodyExpr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, a_res);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then (txt, a_varDecls);

    case ( txt,
           _,
           a_varDecls,
           a_reductionBodyExpr,
           a_arrIndex,
           a_res )
      equation
        txt = Tpl.writeText(txt, a_res);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_arrIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("++) = "));
        txt = Tpl.writeText(txt, a_reductionBodyExpr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then (txt, a_varDecls);
  end match;
end fun_219;

protected function fun_220
  input Tpl.Text in_txt;
  input Tpl.Text in_a_foundFirst;
  input Tpl.Text in_a_reductionBodyExpr;
  input Tpl.Text in_a_fExpStr;
  input Tpl.Text in_a_res;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_foundFirst, in_a_reductionBodyExpr, in_a_fExpStr, in_a_res)
    local
      Tpl.Text txt;
      Tpl.Text a_reductionBodyExpr;
      Tpl.Text a_fExpStr;
      Tpl.Text a_res;
      Tpl.Text i_foundFirst;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           _,
           a_fExpStr,
           a_res )
      equation
        txt = Tpl.writeText(txt, a_res);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, a_fExpStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           i_foundFirst,
           a_reductionBodyExpr,
           a_fExpStr,
           a_res )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if("));
        txt = Tpl.writeText(txt, i_foundFirst);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ")\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_res);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, a_fExpStr);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "else\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_res);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, a_reductionBodyExpr);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.writeText(txt, i_foundFirst);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" = 1;\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;
  end match;
end fun_220;

protected function fun_221
  input Tpl.Text in_txt;
  input Option<DAE.Exp> in_a_ri_foldExp;
  input Tpl.Text in_a_reductionBodyExpr;
  input Tpl.Text in_a_res;
  input Tpl.Text in_a_foundFirst;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_tmpVarDecls;
  input Tpl.Text in_a_bodyExpPre;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_tmpVarDecls;
  output Tpl.Text out_a_bodyExpPre;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_tmpVarDecls, out_a_bodyExpPre) :=
  match(in_txt, in_a_ri_foldExp, in_a_reductionBodyExpr, in_a_res, in_a_foundFirst, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_tmpVarDecls, in_a_bodyExpPre, in_a_context)
    local
      Tpl.Text txt;
      Tpl.Text a_reductionBodyExpr;
      Tpl.Text a_res;
      Tpl.Text a_foundFirst;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_tmpVarDecls;
      Tpl.Text a_bodyExpPre;
      SimCodeFunction.Context a_context;
      DAE.Exp i_fExp;
      Tpl.Text l_fExpStr;
      Tpl.Text l_foldExpPre;

    case ( txt,
           SOME(i_fExp),
           a_reductionBodyExpr,
           a_res,
           a_foundFirst,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_tmpVarDecls,
           a_bodyExpPre,
           a_context )
      equation
        l_foldExpPre = Tpl.emptyTxt;
        (l_fExpStr, a_bodyExpPre, a_tmpVarDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_fExp, a_context, a_bodyExpPre, a_tmpVarDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = fun_220(txt, a_foundFirst, a_reductionBodyExpr, l_fExpStr, a_res);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_tmpVarDecls, a_bodyExpPre);

    case ( txt,
           _,
           _,
           _,
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_tmpVarDecls,
           a_bodyExpPre,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_tmpVarDecls, a_bodyExpPre);
  end match;
end fun_221;

protected function fun_222
  input Tpl.Text in_txt;
  input Absyn.Path in_a_ri_path;
  input Tpl.Text in_a_foundFirst;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_tmpVarDecls;
  input Tpl.Text in_a_bodyExpPre;
  input SimCodeFunction.Context in_a_context;
  input Option<DAE.Exp> in_a_ri_foldExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_arrIndex;
  input DAE.Exp in_a_r_expr;
  input Tpl.Text in_a_res;
  input Tpl.Text in_a_reductionBodyExpr;
  input Tpl.Text in_a_resTail;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_tmpVarDecls;
  output Tpl.Text out_a_bodyExpPre;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_tmpVarDecls, out_a_bodyExpPre, out_a_varDecls) :=
  match(in_txt, in_a_ri_path, in_a_foundFirst, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_tmpVarDecls, in_a_bodyExpPre, in_a_context, in_a_ri_foldExp, in_a_varDecls, in_a_arrIndex, in_a_r_expr, in_a_res, in_a_reductionBodyExpr, in_a_resTail)
    local
      Tpl.Text txt;
      Tpl.Text a_foundFirst;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_tmpVarDecls;
      Tpl.Text a_bodyExpPre;
      SimCodeFunction.Context a_context;
      Option<DAE.Exp> a_ri_foldExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_arrIndex;
      DAE.Exp a_r_expr;
      Tpl.Text a_res;
      Tpl.Text a_reductionBodyExpr;
      Tpl.Text a_resTail;
      DAE.Type ret_0;

    case ( txt,
           Absyn.IDENT(name = "list"),
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_tmpVarDecls,
           a_bodyExpPre,
           _,
           _,
           a_varDecls,
           _,
           _,
           _,
           a_reductionBodyExpr,
           a_resTail )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("*"));
        txt = Tpl.writeText(txt, a_resTail);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = mmc_mk_cons("));
        txt = Tpl.writeText(txt, a_reductionBodyExpr);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(",0);\n"));
        txt = Tpl.writeText(txt, a_resTail);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = &MMC_CDR(*"));
        txt = Tpl.writeText(txt, a_resTail);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_tmpVarDecls, a_bodyExpPre, a_varDecls);

    case ( txt,
           Absyn.IDENT(name = "listReverse"),
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_tmpVarDecls,
           a_bodyExpPre,
           _,
           _,
           a_varDecls,
           _,
           _,
           a_res,
           a_reductionBodyExpr,
           _ )
      equation
        txt = Tpl.writeText(txt, a_res);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = mmc_mk_cons("));
        txt = Tpl.writeText(txt, a_reductionBodyExpr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, a_res);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_tmpVarDecls, a_bodyExpPre, a_varDecls);

    case ( txt,
           Absyn.IDENT(name = "array"),
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_tmpVarDecls,
           a_bodyExpPre,
           _,
           _,
           a_varDecls,
           a_arrIndex,
           a_r_expr,
           a_res,
           a_reductionBodyExpr,
           _ )
      equation
        ret_0 = Expression.typeof(a_r_expr);
        (txt, a_varDecls) = fun_219(txt, ret_0, a_varDecls, a_reductionBodyExpr, a_arrIndex, a_res);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_tmpVarDecls, a_bodyExpPre, a_varDecls);

    case ( txt,
           _,
           a_foundFirst,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_tmpVarDecls,
           a_bodyExpPre,
           a_context,
           a_ri_foldExp,
           a_varDecls,
           _,
           _,
           a_res,
           a_reductionBodyExpr,
           _ )
      equation
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_tmpVarDecls, a_bodyExpPre) = fun_221(txt, a_ri_foldExp, a_reductionBodyExpr, a_res, a_foundFirst, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_tmpVarDecls, a_bodyExpPre, a_context);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_tmpVarDecls, a_bodyExpPre, a_varDecls);
  end match;
end fun_222;

protected function fun_223
  input Tpl.Text in_txt;
  input Tpl.Text in_a_firstIndex;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_firstIndex)
    local
      Tpl.Text txt;
      Tpl.Text i_firstIndex;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}) )
      then txt;

    case ( txt,
           i_firstIndex )
      equation
        txt = Tpl.writeText(txt, i_firstIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = 1;"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;
  end match;
end fun_223;

protected function fun_224
  input Tpl.Text in_txt;
  input Option<DAE.Exp> in_a_iter_guardExp;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_tmpVarDecls;
  input Tpl.Text in_a_guardExpPre;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_tmpVarDecls;
  output Tpl.Text out_a_guardExpPre;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_tmpVarDecls, out_a_guardExpPre) :=
  match(in_txt, in_a_iter_guardExp, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_tmpVarDecls, in_a_guardExpPre, in_a_context)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_tmpVarDecls;
      Tpl.Text a_guardExpPre;
      SimCodeFunction.Context a_context;
      DAE.Exp i_grd;

    case ( txt,
           SOME(i_grd),
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_tmpVarDecls,
           a_guardExpPre,
           a_context )
      equation
        (txt, a_guardExpPre, a_tmpVarDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(txt, i_grd, a_context, a_guardExpPre, a_tmpVarDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_tmpVarDecls, a_guardExpPre);

    case ( txt,
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_tmpVarDecls,
           a_guardExpPre,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("1"));
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_tmpVarDecls, a_guardExpPre);
  end match;
end fun_224;

protected function fun_225
  input Tpl.Text in_txt;
  input DAE.Type in_a_iter_ty;
  input Tpl.Text in_a_firstIndex;
  input Tpl.Text in_a_loopVar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_iter_ty, in_a_firstIndex, in_a_loopVar)
    local
      Tpl.Text txt;
      Tpl.Text a_firstIndex;
      Tpl.Text a_loopVar;
      ClassInf.State i_record__state;
      Absyn.Path ret_1;
      Tpl.Text l_rec__name;

    case ( txt,
           DAE.T_ARRAY(ty = DAE.T_COMPLEX(complexClassType = i_record__state)),
           a_firstIndex,
           a_loopVar )
      equation
        ret_1 = ClassInf.getStateName(i_record__state);
        l_rec__name = CodegenUtil.underscorePath(Tpl.emptyTxt, ret_1);
        txt = Tpl.writeText(txt, l_rec__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_array_get("));
        txt = Tpl.writeText(txt, a_loopVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", 1, "));
        txt = Tpl.writeText(txt, a_firstIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("++)"));
      then txt;

    case ( txt,
           _,
           a_firstIndex,
           a_loopVar )
      equation
        txt = Tpl.writeText(txt, a_loopVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("( "));
        txt = Tpl.writeText(txt, a_firstIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("++)"));
      then txt;
  end match;
end fun_225;

protected function lm_226
  input Tpl.Text in_txt;
  input DAE.ReductionIterators in_items;
  input Tpl.Text in_a_endLoop;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_rangeExpPre;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_tmpVarDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_rangeExpPre;
  output Tpl.Text out_a_tmpVarDecls;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_rangeExpPre, out_a_tmpVarDecls) :=
  match(in_txt, in_items, in_a_endLoop, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_rangeExpPre, in_a_context, in_a_tmpVarDecls)
    local
      Tpl.Text txt;
      DAE.ReductionIterators rest;
      Tpl.Text a_endLoop;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_rangeExpPre;
      SimCodeFunction.Context a_context;
      Tpl.Text a_tmpVarDecls;
      DAE.Type i_iter_ty;
      Option<DAE.Exp> i_iter_guardExp;
      String i_iter_id;
      DAE.Type i_ty;
      DAE.Exp i_iter_exp;
      Tpl.Text l_addr;
      Tpl.Text l_guardExp;
      Tpl.Text l_iteratorName;
      Tpl.Text l_empty;
      Tpl.Text l_guardCond;
      Tpl.Text l_rangeExp;
      Tpl.Text l_firstIndex;
      Tpl.Text l_guardExpPre;
      Tpl.Text l_loopVar;
      Tpl.Text l_arrayType;
      Tpl.Text l_ty__str;
      Tpl.Text l_identType;

    case ( txt,
           {},
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_rangeExpPre,
           _,
           a_tmpVarDecls )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_rangeExpPre, a_tmpVarDecls);

    case ( txt,
           DAE.REDUCTIONITER(exp = i_iter_exp, ty = (i_iter_ty as i_ty), id = i_iter_id, guardExp = i_iter_guardExp) :: rest,
           a_endLoop,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_rangeExpPre,
           a_context,
           a_tmpVarDecls )
      equation
        l_identType = expTypeFromExpModelica(Tpl.emptyTxt, i_iter_exp);
        l_ty__str = expTypeShort(Tpl.emptyTxt, i_ty);
        l_arrayType = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("DynArrayDim1<"));
        l_arrayType = Tpl.writeText(l_arrayType, l_identType);
        l_arrayType = Tpl.writeTok(l_arrayType, Tpl.ST_STRING(">"));
        l_loopVar = Tpl.writeStr(Tpl.emptyTxt, i_iter_id);
        l_loopVar = Tpl.writeTok(l_loopVar, Tpl.ST_STRING("_loopVar"));
        l_guardExpPre = Tpl.emptyTxt;
        a_tmpVarDecls = Tpl.writeText(a_tmpVarDecls, l_arrayType);
        a_tmpVarDecls = Tpl.writeTok(a_tmpVarDecls, Tpl.ST_STRING(" "));
        a_tmpVarDecls = Tpl.writeText(a_tmpVarDecls, l_loopVar);
        a_tmpVarDecls = Tpl.writeTok(a_tmpVarDecls, Tpl.ST_STRING(";/*testloopvar*/"));
        a_tmpVarDecls = Tpl.writeTok(a_tmpVarDecls, Tpl.ST_NEW_LINE());
        (l_firstIndex, a_tmpVarDecls) = tempDecl(Tpl.emptyTxt, "int", a_tmpVarDecls);
        (l_rangeExp, a_rangeExpPre, a_tmpVarDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_iter_exp, a_context, a_rangeExpPre, a_tmpVarDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        a_rangeExpPre = Tpl.writeText(a_rangeExpPre, l_loopVar);
        a_rangeExpPre = Tpl.writeTok(a_rangeExpPre, Tpl.ST_STRING(" = "));
        a_rangeExpPre = Tpl.writeText(a_rangeExpPre, l_rangeExp);
        a_rangeExpPre = Tpl.writeTok(a_rangeExpPre, Tpl.ST_STRING("/*testloopvar2*/;"));
        a_rangeExpPre = Tpl.writeTok(a_rangeExpPre, Tpl.ST_NEW_LINE());
        a_rangeExpPre = fun_223(a_rangeExpPre, l_firstIndex);
        (l_guardCond, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_tmpVarDecls, l_guardExpPre) = fun_224(Tpl.emptyTxt, i_iter_guardExp, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_tmpVarDecls, l_guardExpPre, a_context);
        l_empty = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("0 == ("));
        l_empty = Tpl.writeText(l_empty, l_loopVar);
        l_empty = Tpl.writeTok(l_empty, Tpl.ST_STRING(".getDim(2))"));
        l_iteratorName = contextIteratorName(Tpl.emptyTxt, i_iter_id, a_context);
        a_tmpVarDecls = Tpl.writeText(a_tmpVarDecls, l_identType);
        a_tmpVarDecls = Tpl.writeTok(a_tmpVarDecls, Tpl.ST_STRING(" "));
        a_tmpVarDecls = Tpl.writeText(a_tmpVarDecls, l_iteratorName);
        a_tmpVarDecls = Tpl.writeTok(a_tmpVarDecls, Tpl.ST_STRING(";"));
        a_tmpVarDecls = Tpl.writeTok(a_tmpVarDecls, Tpl.ST_NEW_LINE());
        l_guardExp = Tpl.writeText(Tpl.emptyTxt, l_guardExpPre);
        l_guardExp = Tpl.softNewLine(l_guardExp);
        l_guardExp = Tpl.writeTok(l_guardExp, Tpl.ST_STRING("if("));
        l_guardExp = Tpl.writeText(l_guardExp, l_guardCond);
        l_guardExp = Tpl.writeTok(l_guardExp, Tpl.ST_LINE(") { /* found non-guarded */\n"));
        l_guardExp = Tpl.pushBlock(l_guardExp, Tpl.BT_INDENT(2));
        l_guardExp = Tpl.writeText(l_guardExp, a_endLoop);
        l_guardExp = Tpl.writeTok(l_guardExp, Tpl.ST_STRING_LIST({
                                                  "--;\n",
                                                  "break;\n"
                                              }, true));
        l_guardExp = Tpl.popBlock(l_guardExp);
        l_guardExp = Tpl.writeTok(l_guardExp, Tpl.ST_STRING("}"));
        l_addr = fun_225(Tpl.emptyTxt, i_iter_ty, l_firstIndex, l_loopVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("while("));
        txt = Tpl.writeText(txt, l_firstIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" <=  "));
        txt = Tpl.writeText(txt, l_loopVar);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(".getDim(1)) {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_iteratorName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, l_addr);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.writeText(txt, l_guardExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_rangeExpPre, a_tmpVarDecls) = lm_226(txt, rest, a_endLoop, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_rangeExpPre, a_context, a_tmpVarDecls);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_rangeExpPre, a_tmpVarDecls);

    case ( txt,
           _ :: rest,
           a_endLoop,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_rangeExpPre,
           a_context,
           a_tmpVarDecls )
      equation
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_rangeExpPre, a_tmpVarDecls) = lm_226(txt, rest, a_endLoop, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_rangeExpPre, a_context, a_tmpVarDecls);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_rangeExpPre, a_tmpVarDecls);
  end match;
end lm_226;

protected function lm_227
  input Tpl.Text in_txt;
  input DAE.ReductionIterators in_items;
  input Tpl.Text in_a_length;
  input Tpl.Text in_a_rangeExpPre;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_rangeExpPre;
algorithm
  (out_txt, out_a_rangeExpPre) :=
  match(in_txt, in_items, in_a_length, in_a_rangeExpPre)
    local
      Tpl.Text txt;
      DAE.ReductionIterators rest;
      Tpl.Text a_length;
      Tpl.Text a_rangeExpPre;
      String i_iter_id;
      Tpl.Text l_loopVar;

    case ( txt,
           {},
           _,
           a_rangeExpPre )
      then (txt, a_rangeExpPre);

    case ( txt,
           DAE.REDUCTIONITER(id = i_iter_id) :: rest,
           a_length,
           a_rangeExpPre )
      equation
        l_loopVar = Tpl.writeStr(Tpl.emptyTxt, i_iter_id);
        l_loopVar = Tpl.writeTok(l_loopVar, Tpl.ST_STRING("_loopVar"));
        a_rangeExpPre = Tpl.writeText(a_rangeExpPre, a_length);
        a_rangeExpPre = Tpl.writeTok(a_rangeExpPre, Tpl.ST_STRING(" = max("));
        a_rangeExpPre = Tpl.writeText(a_rangeExpPre, a_length);
        a_rangeExpPre = Tpl.writeTok(a_rangeExpPre, Tpl.ST_STRING(", "));
        a_rangeExpPre = Tpl.writeText(a_rangeExpPre, l_loopVar);
        a_rangeExpPre = Tpl.writeTok(a_rangeExpPre, Tpl.ST_STRING(".getDim(1));"));
        a_rangeExpPre = Tpl.writeTok(a_rangeExpPre, Tpl.ST_NEW_LINE());
        (txt, a_rangeExpPre) = lm_227(txt, rest, a_length, a_rangeExpPre);
      then (txt, a_rangeExpPre);

    case ( txt,
           _ :: rest,
           a_length,
           a_rangeExpPre )
      equation
        (txt, a_rangeExpPre) = lm_227(txt, rest, a_length, a_rangeExpPre);
      then (txt, a_rangeExpPre);
  end match;
end lm_227;

protected function fun_228
  input Tpl.Text in_txt;
  input DAE.Dimension in_a_dim;
  input DAE.Exp in_a_r_expr;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_tmpVarDecls;
  input Tpl.Text in_a_rangeExpPre;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_dim__vec;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_tmpVarDecls;
  output Tpl.Text out_a_rangeExpPre;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_tmpVarDecls, out_a_rangeExpPre) :=
  match(in_txt, in_a_dim, in_a_r_expr, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_tmpVarDecls, in_a_rangeExpPre, in_a_context, in_a_dim__vec)
    local
      Tpl.Text txt;
      DAE.Exp a_r_expr;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_tmpVarDecls;
      Tpl.Text a_rangeExpPre;
      SimCodeFunction.Context a_context;
      Tpl.Text a_dim__vec;
      DAE.Exp i_exp;
      Integer i_size;
      Integer i_integer;
      Tpl.Text txt_1;
      String ret_2;
      DAE.Type ret_1;
      Tpl.Text l_val;

    case ( txt,
           DAE.DIM_INTEGER(integer = i_integer),
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_tmpVarDecls,
           a_rangeExpPre,
           _,
           a_dim__vec )
      equation
        txt = Tpl.writeText(txt, a_dim__vec);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".push_back("));
        txt = Tpl.writeStr(txt, intString(i_integer));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_tmpVarDecls, a_rangeExpPre);

    case ( txt,
           DAE.DIM_BOOLEAN(),
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_tmpVarDecls,
           a_rangeExpPre,
           _,
           a_dim__vec )
      equation
        txt = Tpl.writeText(txt, a_dim__vec);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".push_back(2)"));
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_tmpVarDecls, a_rangeExpPre);

    case ( txt,
           DAE.DIM_ENUM(size = i_size),
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_tmpVarDecls,
           a_rangeExpPre,
           _,
           a_dim__vec )
      equation
        txt = Tpl.writeText(txt, a_dim__vec);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".push_back("));
        txt = Tpl.writeStr(txt, intString(i_size));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_tmpVarDecls, a_rangeExpPre);

    case ( txt,
           DAE.DIM_EXP(exp = i_exp),
           _,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_tmpVarDecls,
           a_rangeExpPre,
           a_context,
           a_dim__vec )
      equation
        (l_val, a_rangeExpPre, a_tmpVarDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_exp, a_context, a_rangeExpPre, a_tmpVarDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeText(txt, a_dim__vec);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".push_back("));
        txt = Tpl.writeText(txt, l_val);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_tmpVarDecls, a_rangeExpPre);

    case ( txt,
           _,
           a_r_expr,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_tmpVarDecls,
           a_rangeExpPre,
           _,
           _ )
      equation
        txt_1 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("array reduction unable to generate code for element of unknown dimension sizes; type "));
        ret_1 = Expression.typeof(a_r_expr);
        ret_2 = Types.unparseType(ret_1);
        txt_1 = Tpl.writeStr(txt_1, ret_2);
        txt_1 = Tpl.writeTok(txt_1, Tpl.ST_STRING(": "));
        txt_1 = ExpressionDumpTpl.dumpExp(txt_1, a_r_expr, "\"");
        txt = error(txt, Tpl.sourceInfo("CodegenCppCommon.tpl", 1177, 24), Tpl.textString(txt_1));
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_tmpVarDecls, a_rangeExpPre);
  end match;
end fun_228;

protected function lm_229
  input Tpl.Text in_txt;
  input DAE.Dimensions in_items;
  input DAE.Exp in_a_r_expr;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_tmpVarDecls;
  input Tpl.Text in_a_rangeExpPre;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_dim__vec;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_tmpVarDecls;
  output Tpl.Text out_a_rangeExpPre;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_tmpVarDecls, out_a_rangeExpPre) :=
  match(in_txt, in_items, in_a_r_expr, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_tmpVarDecls, in_a_rangeExpPre, in_a_context, in_a_dim__vec)
    local
      Tpl.Text txt;
      DAE.Dimensions rest;
      DAE.Exp a_r_expr;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_tmpVarDecls;
      Tpl.Text a_rangeExpPre;
      SimCodeFunction.Context a_context;
      Tpl.Text a_dim__vec;
      DAE.Dimension i_dim;

    case ( txt,
           {},
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_tmpVarDecls,
           a_rangeExpPre,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_tmpVarDecls, a_rangeExpPre);

    case ( txt,
           i_dim :: rest,
           a_r_expr,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_tmpVarDecls,
           a_rangeExpPre,
           a_context,
           a_dim__vec )
      equation
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_tmpVarDecls, a_rangeExpPre) = fun_228(txt, i_dim, a_r_expr, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_tmpVarDecls, a_rangeExpPre, a_context, a_dim__vec);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_tmpVarDecls, a_rangeExpPre) = lm_229(txt, rest, a_r_expr, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_tmpVarDecls, a_rangeExpPre, a_context, a_dim__vec);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_tmpVarDecls, a_rangeExpPre);
  end match;
end lm_229;

protected function fun_230
  input Tpl.Text in_txt;
  input DAE.Type in_mArg;
  input DAE.Exp in_a_r_expr;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_rangeExpPre;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_tmpVarDecls;
  input Tpl.Text in_a_length;
  input Tpl.Text in_a_res;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_rangeExpPre;
  output Tpl.Text out_a_tmpVarDecls;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_rangeExpPre, out_a_tmpVarDecls) :=
  match(in_txt, in_mArg, in_a_r_expr, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_rangeExpPre, in_a_context, in_a_tmpVarDecls, in_a_length, in_a_res)
    local
      Tpl.Text txt;
      DAE.Exp a_r_expr;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_rangeExpPre;
      SimCodeFunction.Context a_context;
      Tpl.Text a_tmpVarDecls;
      Tpl.Text a_length;
      Tpl.Text a_res;
      DAE.Dimensions i_dims;
      ClassInf.State i_record__state;
      Tpl.Text l_dimSizes;
      Tpl.Text l_dim__vec;
      Absyn.Path ret_1;
      Tpl.Text l_rec__name;

    case ( txt,
           DAE.T_COMPLEX(complexClassType = i_record__state),
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_rangeExpPre,
           _,
           a_tmpVarDecls,
           a_length,
           a_res )
      equation
        ret_1 = ClassInf.getStateName(i_record__state);
        l_rec__name = CodegenUtil.underscorePath(Tpl.emptyTxt, ret_1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("alloc_generic_array(&"));
        txt = Tpl.writeText(txt, a_res);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(",sizeof("));
        txt = Tpl.writeText(txt, l_rec__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("),1,"));
        txt = Tpl.writeText(txt, a_length);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_rangeExpPre, a_tmpVarDecls);

    case ( txt,
           DAE.T_ARRAY(dims = i_dims),
           a_r_expr,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_rangeExpPre,
           a_context,
           a_tmpVarDecls,
           a_length,
           a_res )
      equation
        (l_dim__vec, a_tmpVarDecls) = tempDecl(Tpl.emptyTxt, "std::vector<size_t>", a_tmpVarDecls);
        l_dimSizes = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING("; ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_dimSizes, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_tmpVarDecls, a_rangeExpPre) = lm_229(l_dimSizes, i_dims, a_r_expr, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_tmpVarDecls, a_rangeExpPre, a_context, l_dim__vec);
        l_dimSizes = Tpl.popIter(l_dimSizes);
        txt = Tpl.writeText(txt, l_dim__vec);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".push_back("));
        txt = Tpl.writeText(txt, a_length);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(");\n"));
        txt = Tpl.writeText(txt, l_dimSizes);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.writeText(txt, a_res);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".setDims("));
        txt = Tpl.writeText(txt, l_dim__vec);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_rangeExpPre, a_tmpVarDecls);

    case ( txt,
           _,
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_rangeExpPre,
           _,
           a_tmpVarDecls,
           a_length,
           a_res )
      equation
        txt = Tpl.writeText(txt, a_res);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".setDims("));
        txt = Tpl.writeText(txt, a_length);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_rangeExpPre, a_tmpVarDecls);
  end match;
end fun_230;

protected function fun_231
  input Tpl.Text in_txt;
  input Tpl.Text in_a_foundFirst;
  input Absyn.Path in_a_ri_path;
  input Tpl.Text in_a_defaultValue;
  input Tpl.Text in_a_res;
  input Tpl.Text in_a_preDefault;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_foundFirst, in_a_ri_path, in_a_defaultValue, in_a_res, in_a_preDefault)
    local
      Tpl.Text txt;
      Absyn.Path a_ri_path;
      Tpl.Text a_defaultValue;
      Tpl.Text a_res;
      Tpl.Text a_preDefault;
      Tpl.Text i_foundFirst;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           _,
           a_defaultValue,
           a_res,
           a_preDefault )
      equation
        txt = Tpl.writeText(txt, a_preDefault);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, a_res);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, a_defaultValue);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("; /* defaultValue */"));
      then txt;

    case ( txt,
           i_foundFirst,
           a_ri_path,
           _,
           _,
           _ )
      equation
        txt = Tpl.writeText(txt, i_foundFirst);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = 0; /* "));
        txt = CodegenUtil.dotPath(txt, a_ri_path);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" lacks default-value */"));
      then txt;
  end match;
end fun_231;

protected function fun_232
  input Tpl.Text in_txt;
  input Absyn.Path in_a_ri_path;
  input Tpl.Text in_a_defaultValue;
  input Tpl.Text in_a_preDefault;
  input Tpl.Text in_a_foundFirst;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_res;
  input DAE.Exp in_a_r_expr;
  input Tpl.Text in_a_arrIndex;
  input DAE.ReductionIterators in_a_iterators;
  input Tpl.Text in_a_rangeExpPre;
  input Tpl.Text in_a_tmpVarDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_rangeExpPre;
  output Tpl.Text out_a_tmpVarDecls;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_rangeExpPre, out_a_tmpVarDecls) :=
  match(in_txt, in_a_ri_path, in_a_defaultValue, in_a_preDefault, in_a_foundFirst, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_context, in_a_res, in_a_r_expr, in_a_arrIndex, in_a_iterators, in_a_rangeExpPre, in_a_tmpVarDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_defaultValue;
      Tpl.Text a_preDefault;
      Tpl.Text a_foundFirst;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      SimCodeFunction.Context a_context;
      Tpl.Text a_res;
      DAE.Exp a_r_expr;
      Tpl.Text a_arrIndex;
      DAE.ReductionIterators a_iterators;
      Tpl.Text a_rangeExpPre;
      Tpl.Text a_tmpVarDecls;
      Absyn.Path i_ri_path;
      DAE.Type ret_2;
      Tpl.Text l_0__;
      Tpl.Text l_length;

    case ( txt,
           Absyn.IDENT(name = "array"),
           _,
           _,
           _,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_context,
           a_res,
           a_r_expr,
           a_arrIndex,
           a_iterators,
           a_rangeExpPre,
           a_tmpVarDecls )
      equation
        (l_length, a_tmpVarDecls) = tempDecl(Tpl.emptyTxt, "int", a_tmpVarDecls);
        a_rangeExpPre = Tpl.writeText(a_rangeExpPre, l_length);
        a_rangeExpPre = Tpl.writeTok(a_rangeExpPre, Tpl.ST_STRING(" = 0;"));
        a_rangeExpPre = Tpl.writeTok(a_rangeExpPre, Tpl.ST_NEW_LINE());
        (l_0__, a_rangeExpPre) = lm_227(Tpl.emptyTxt, a_iterators, l_length, a_rangeExpPre);
        txt = Tpl.writeText(txt, a_arrIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" = 1;\n"));
        ret_2 = Expression.typeof(a_r_expr);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_rangeExpPre, a_tmpVarDecls) = fun_230(txt, ret_2, a_r_expr, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_rangeExpPre, a_context, a_tmpVarDecls, l_length, a_res);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_rangeExpPre, a_tmpVarDecls);

    case ( txt,
           i_ri_path,
           a_defaultValue,
           a_preDefault,
           a_foundFirst,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _,
           a_res,
           _,
           _,
           _,
           a_rangeExpPre,
           a_tmpVarDecls )
      equation
        txt = fun_231(txt, a_foundFirst, i_ri_path, a_defaultValue, a_res, a_preDefault);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_rangeExpPre, a_tmpVarDecls);
  end match;
end fun_232;

protected function fun_233
  input Tpl.Text in_txt;
  input DAE.ReductionIterators in_a_iterators;
  input Tpl.Text in_a_endLoop;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_iterators, in_a_endLoop)
    local
      Tpl.Text txt;
      Tpl.Text a_endLoop;
      DAE.ReductionIterators i_iterators;
      Integer ret_0;

    case ( txt,
           (i_iterators as _ :: _),
           a_endLoop )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("else if ("));
        txt = Tpl.writeText(txt, a_endLoop);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" == "));
        ret_0 = listLength(i_iterators);
        txt = Tpl.writeStr(txt, intString(ret_0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ") {\n",
                                    "  break;\n",
                                    "} else {\n",
                                    "  throw ModelicaSimulationError(MODEL_ARRAY_FUNCTION,\"Internal error\");\n",
                                    "}"
                                }, false));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_233;

protected function fun_234
  input Tpl.Text in_txt;
  input Tpl.Text in_a_resTail;
  input Tpl.Text in_a_res;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_resTail, in_a_res)
    local
      Tpl.Text txt;
      Tpl.Text a_res;
      Tpl.Text i_resTail;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           _ )
      then txt;

    case ( txt,
           i_resTail,
           a_res )
      equation
        txt = Tpl.writeText(txt, i_resTail);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = &"));
        txt = Tpl.writeText(txt, a_res);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_234;

protected function fun_235
  input Tpl.Text in_txt;
  input Tpl.Text in_a_foundFirst;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_foundFirst)
    local
      Tpl.Text txt;
      Tpl.Text i_foundFirst;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}) )
      then txt;

    case ( txt,
           i_foundFirst )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if (!"));
        txt = Tpl.writeText(txt, i_foundFirst);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") throw ModelicaSimulationError(MODEL_ARRAY_FUNCTION,\"Internal error\");"));
      then txt;
  end match;
end fun_235;

protected function fun_236
  input Tpl.Text in_txt;
  input Tpl.Text in_a_resTail;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_resTail)
    local
      Tpl.Text txt;
      Tpl.Text i_resTail;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}) )
      then txt;

    case ( txt,
           i_resTail )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("*"));
        txt = Tpl.writeText(txt, i_resTail);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = NULL;"));
      then txt;
  end match;
end fun_236;

public function daeExpReduction
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_exp, in_a_context, in_a_preExp, in_a_varDecls, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      DAE.Exp i_exp;
      DAE.ReductionIterators i_iterators;
      Option<DAE.Exp> i_ri_foldExp;
      DAE.Exp i_r_expr;
      String i_ri_foldName;
      String i_ri_resultName;
      Option<Values.Value> i_ri_defaultValue;
      Absyn.Path i_ri_path;
      DAE.Exp i_r;
      Tpl.Text txt_31;
      Integer ret_30;
      DAE.Type ret_29;
      DAE.ComponentRef ret_28;
      DAE.ComponentRef ret_27;
      DAE.Type ret_26;
      Integer ret_25;
      Tpl.Text l_loop;
      Tpl.Text l_firstValue;
      Tpl.Text l_loopHeadIter;
      Tpl.Text l_endLoop;
      Tpl.Text l_foldExp;
      Tpl.Text l_reductionBodyExprWork;
      DAE.Type ret_18;
      Tpl.Text l_bodyExprType;
      DAE.ComponentRef ret_16;
      Tpl.Text l_reductionBodyExpr;
      Tpl.Text l_defaultValue;
      Tpl.Text l_resTail;
      Tpl.Text l_preDefault;
      Tpl.Text l_resTmp;
      DAE.ComponentRef ret_10;
      Tpl.Text l_res;
      DAE.Type ret_8;
      Tpl.Text l_resType;
      Tpl.Text l_foundFirst;
      Tpl.Text l_arrIndex;
      Tpl.Text l_arrayTypeResult;
      Tpl.Text l_rangeExpPre;
      Tpl.Text l_bodyExpPre;
      Tpl.Text l_tmpExpPre;
      Tpl.Text l_tmpVarDecls;

    case ( txt,
           (i_r as DAE.REDUCTION(reductionInfo = DAE.REDUCTIONINFO(iterType = Absyn.THREAD(), path = i_ri_path, defaultValue = i_ri_defaultValue, resultName = i_ri_resultName, foldName = i_ri_foldName, foldExp = i_ri_foldExp), iterators = i_iterators, expr = i_r_expr)),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_tmpVarDecls = Tpl.emptyTxt;
        l_tmpExpPre = Tpl.emptyTxt;
        l_bodyExpPre = Tpl.emptyTxt;
        l_rangeExpPre = Tpl.emptyTxt;
        l_arrayTypeResult = expTypeFromExpArray(Tpl.emptyTxt, i_r);
        (l_arrIndex, l_tmpVarDecls) = fun_189(Tpl.emptyTxt, i_ri_path, l_tmpVarDecls);
        (l_foundFirst, l_tmpVarDecls) = fun_190(Tpl.emptyTxt, i_ri_defaultValue, l_tmpVarDecls);
        ret_8 = Expression.typeof(i_r);
        l_resType = expTypeArrayIf(Tpl.emptyTxt, ret_8);
        ret_10 = ComponentReference.makeUntypedCrefIdent(i_ri_resultName);
        (l_res, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = contextCref(Tpl.emptyTxt, ret_10, a_context, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        l_tmpVarDecls = Tpl.writeText(l_tmpVarDecls, l_resType);
        l_tmpVarDecls = Tpl.writeTok(l_tmpVarDecls, Tpl.ST_STRING(" "));
        l_tmpVarDecls = Tpl.writeText(l_tmpVarDecls, l_res);
        l_tmpVarDecls = Tpl.writeTok(l_tmpVarDecls, Tpl.ST_STRING(";"));
        l_tmpVarDecls = Tpl.writeTok(l_tmpVarDecls, Tpl.ST_NEW_LINE());
        (l_resTmp, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(l_resType), a_varDecls);
        l_preDefault = Tpl.emptyTxt;
        (l_resTail, l_tmpVarDecls) = fun_191(Tpl.emptyTxt, i_ri_path, l_tmpVarDecls);
        (l_defaultValue, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, l_tmpVarDecls, l_preDefault) = fun_193(Tpl.emptyTxt, i_ri_path, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, l_tmpVarDecls, l_preDefault, a_context, i_ri_defaultValue);
        ret_16 = ComponentReference.makeUntypedCrefIdent(i_ri_foldName);
        (l_reductionBodyExpr, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = contextCref(Tpl.emptyTxt, ret_16, a_context, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        ret_18 = Expression.typeof(i_r_expr);
        l_bodyExprType = expTypeArrayIf(Tpl.emptyTxt, ret_18);
        (l_reductionBodyExprWork, l_bodyExpPre, l_tmpVarDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_r_expr, a_context, l_bodyExpPre, l_tmpVarDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        l_tmpVarDecls = Tpl.writeText(l_tmpVarDecls, l_bodyExprType);
        l_tmpVarDecls = Tpl.writeTok(l_tmpVarDecls, Tpl.ST_STRING(" "));
        l_tmpVarDecls = Tpl.writeText(l_tmpVarDecls, l_reductionBodyExpr);
        l_tmpVarDecls = Tpl.writeTok(l_tmpVarDecls, Tpl.ST_STRING(";"));
        l_tmpVarDecls = Tpl.writeTok(l_tmpVarDecls, Tpl.ST_NEW_LINE());
        l_bodyExpPre = Tpl.writeText(l_bodyExpPre, l_reductionBodyExpr);
        l_bodyExpPre = Tpl.writeTok(l_bodyExpPre, Tpl.ST_STRING(" = "));
        l_bodyExpPre = Tpl.writeText(l_bodyExpPre, l_reductionBodyExprWork);
        l_bodyExpPre = Tpl.writeTok(l_bodyExpPre, Tpl.ST_STRING(";"));
        l_bodyExpPre = Tpl.writeTok(l_bodyExpPre, Tpl.ST_NEW_LINE());
        (l_foldExp, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, l_tmpVarDecls, l_bodyExpPre, a_varDecls) = fun_198(Tpl.emptyTxt, i_ri_path, l_foundFirst, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, l_tmpVarDecls, l_bodyExpPre, a_context, i_ri_foldExp, a_varDecls, l_arrIndex, i_r_expr, l_res, l_reductionBodyExpr, l_resTail);
        (l_endLoop, l_tmpVarDecls) = tempDecl(Tpl.emptyTxt, "int", l_tmpVarDecls);
        (l_loopHeadIter, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, l_rangeExpPre, l_tmpVarDecls) = lm_202(Tpl.emptyTxt, i_iterators, l_endLoop, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, l_rangeExpPre, a_context, l_tmpVarDecls);
        (l_firstValue, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, l_rangeExpPre, l_tmpVarDecls) = fun_208(Tpl.emptyTxt, i_ri_path, l_defaultValue, l_preDefault, l_foundFirst, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_context, l_res, i_r_expr, l_arrIndex, i_iterators, l_rangeExpPre, l_tmpVarDecls);
        l_loop = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_LINE("while(1) {\n"));
        l_loop = Tpl.pushBlock(l_loop, Tpl.BT_INDENT(2));
        l_loop = Tpl.writeText(l_loop, l_endLoop);
        l_loop = Tpl.writeTok(l_loop, Tpl.ST_STRING(" = "));
        ret_25 = listLength(i_iterators);
        l_loop = Tpl.writeStr(l_loop, intString(ret_25));
        l_loop = Tpl.writeTok(l_loop, Tpl.ST_LINE(";\n"));
        l_loop = Tpl.writeText(l_loop, l_loopHeadIter);
        l_loop = Tpl.softNewLine(l_loop);
        l_loop = Tpl.writeTok(l_loop, Tpl.ST_STRING("if ("));
        l_loop = Tpl.writeText(l_loop, l_endLoop);
        l_loop = Tpl.writeTok(l_loop, Tpl.ST_LINE(" == 0) {\n"));
        l_loop = Tpl.pushBlock(l_loop, Tpl.BT_INDENT(2));
        l_loop = Tpl.writeText(l_loop, l_bodyExpPre);
        l_loop = Tpl.softNewLine(l_loop);
        l_loop = Tpl.writeText(l_loop, l_foldExp);
        l_loop = Tpl.softNewLine(l_loop);
        l_loop = Tpl.popBlock(l_loop);
        l_loop = Tpl.writeTok(l_loop, Tpl.ST_STRING("} "));
        l_loop = fun_209(l_loop, i_iterators, l_endLoop);
        l_loop = Tpl.softNewLine(l_loop);
        l_loop = Tpl.popBlock(l_loop);
        l_loop = Tpl.writeTok(l_loop, Tpl.ST_STRING("}"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_LINE("{\n"));
        a_preExp = Tpl.pushBlock(a_preExp, Tpl.BT_INDENT(2));
        a_preExp = Tpl.writeText(a_preExp, l_tmpVarDecls);
        a_preExp = Tpl.softNewLine(a_preExp);
        a_preExp = Tpl.writeText(a_preExp, l_rangeExpPre);
        a_preExp = Tpl.softNewLine(a_preExp);
        a_preExp = Tpl.writeText(a_preExp, l_firstValue);
        a_preExp = Tpl.softNewLine(a_preExp);
        a_preExp = fun_210(a_preExp, l_resTail, l_res);
        a_preExp = Tpl.softNewLine(a_preExp);
        a_preExp = Tpl.writeText(a_preExp, l_loop);
        a_preExp = Tpl.softNewLine(a_preExp);
        a_preExp = fun_211(a_preExp, l_foundFirst);
        a_preExp = Tpl.softNewLine(a_preExp);
        a_preExp = fun_212(a_preExp, l_resTail);
        a_preExp = Tpl.softNewLine(a_preExp);
        a_preExp = Tpl.writeText(a_preExp, l_resTmp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = "));
        a_preExp = Tpl.writeText(a_preExp, l_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_LINE(";\n"));
        a_preExp = Tpl.popBlock(a_preExp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("}"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_resTmp);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           (i_r as DAE.REDUCTION(reductionInfo = DAE.REDUCTIONINFO(iterType = Absyn.COMBINE(), path = i_ri_path, defaultValue = i_ri_defaultValue, resultName = i_ri_resultName, foldName = i_ri_foldName, foldExp = i_ri_foldExp), iterators = (i_iterators as {_}), expr = i_r_expr)),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_tmpVarDecls = Tpl.emptyTxt;
        l_tmpExpPre = Tpl.emptyTxt;
        l_bodyExpPre = Tpl.emptyTxt;
        l_rangeExpPre = Tpl.emptyTxt;
        l_arrayTypeResult = expTypeFromExpArray(Tpl.emptyTxt, i_r);
        (l_arrIndex, l_tmpVarDecls) = fun_213(Tpl.emptyTxt, i_ri_path, l_tmpVarDecls);
        (l_foundFirst, l_tmpVarDecls) = fun_214(Tpl.emptyTxt, i_ri_defaultValue, l_tmpVarDecls);
        ret_26 = Expression.typeof(i_r);
        l_resType = expTypeArrayIf(Tpl.emptyTxt, ret_26);
        ret_27 = ComponentReference.makeUntypedCrefIdent(i_ri_resultName);
        (l_res, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = contextCref(Tpl.emptyTxt, ret_27, a_context, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        l_tmpVarDecls = Tpl.writeText(l_tmpVarDecls, l_resType);
        l_tmpVarDecls = Tpl.writeTok(l_tmpVarDecls, Tpl.ST_STRING(" "));
        l_tmpVarDecls = Tpl.writeText(l_tmpVarDecls, l_res);
        l_tmpVarDecls = Tpl.writeTok(l_tmpVarDecls, Tpl.ST_STRING(";"));
        l_tmpVarDecls = Tpl.writeTok(l_tmpVarDecls, Tpl.ST_NEW_LINE());
        (l_resTmp, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(l_resType), a_varDecls);
        l_preDefault = Tpl.emptyTxt;
        (l_resTail, l_tmpVarDecls) = fun_215(Tpl.emptyTxt, i_ri_path, l_tmpVarDecls);
        (l_defaultValue, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, l_tmpVarDecls, l_preDefault) = fun_217(Tpl.emptyTxt, i_ri_path, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, l_tmpVarDecls, l_preDefault, a_context, i_ri_defaultValue);
        ret_28 = ComponentReference.makeUntypedCrefIdent(i_ri_foldName);
        (l_reductionBodyExpr, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = contextCref(Tpl.emptyTxt, ret_28, a_context, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        ret_29 = Expression.typeof(i_r_expr);
        l_bodyExprType = expTypeArrayIf(Tpl.emptyTxt, ret_29);
        (l_reductionBodyExprWork, l_bodyExpPre, l_tmpVarDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_r_expr, a_context, l_bodyExpPre, l_tmpVarDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        l_tmpVarDecls = Tpl.writeText(l_tmpVarDecls, l_bodyExprType);
        l_tmpVarDecls = Tpl.writeTok(l_tmpVarDecls, Tpl.ST_STRING(" "));
        l_tmpVarDecls = Tpl.writeText(l_tmpVarDecls, l_reductionBodyExpr);
        l_tmpVarDecls = Tpl.writeTok(l_tmpVarDecls, Tpl.ST_STRING(";"));
        l_tmpVarDecls = Tpl.writeTok(l_tmpVarDecls, Tpl.ST_NEW_LINE());
        l_bodyExpPre = Tpl.writeText(l_bodyExpPre, l_reductionBodyExpr);
        l_bodyExpPre = Tpl.writeTok(l_bodyExpPre, Tpl.ST_STRING(" = "));
        l_bodyExpPre = Tpl.writeText(l_bodyExpPre, l_reductionBodyExprWork);
        l_bodyExpPre = Tpl.writeTok(l_bodyExpPre, Tpl.ST_STRING(";"));
        l_bodyExpPre = Tpl.writeTok(l_bodyExpPre, Tpl.ST_NEW_LINE());
        (l_foldExp, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, l_tmpVarDecls, l_bodyExpPre, a_varDecls) = fun_222(Tpl.emptyTxt, i_ri_path, l_foundFirst, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, l_tmpVarDecls, l_bodyExpPre, a_context, i_ri_foldExp, a_varDecls, l_arrIndex, i_r_expr, l_res, l_reductionBodyExpr, l_resTail);
        (l_endLoop, l_tmpVarDecls) = tempDecl(Tpl.emptyTxt, "int", l_tmpVarDecls);
        (l_loopHeadIter, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, l_rangeExpPre, l_tmpVarDecls) = lm_226(Tpl.emptyTxt, i_iterators, l_endLoop, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, l_rangeExpPre, a_context, l_tmpVarDecls);
        (l_firstValue, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, l_rangeExpPre, l_tmpVarDecls) = fun_232(Tpl.emptyTxt, i_ri_path, l_defaultValue, l_preDefault, l_foundFirst, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_context, l_res, i_r_expr, l_arrIndex, i_iterators, l_rangeExpPre, l_tmpVarDecls);
        l_loop = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_LINE("while(1) {\n"));
        l_loop = Tpl.pushBlock(l_loop, Tpl.BT_INDENT(2));
        l_loop = Tpl.writeText(l_loop, l_endLoop);
        l_loop = Tpl.writeTok(l_loop, Tpl.ST_STRING(" = "));
        ret_30 = listLength(i_iterators);
        l_loop = Tpl.writeStr(l_loop, intString(ret_30));
        l_loop = Tpl.writeTok(l_loop, Tpl.ST_LINE(";\n"));
        l_loop = Tpl.writeText(l_loop, l_loopHeadIter);
        l_loop = Tpl.softNewLine(l_loop);
        l_loop = Tpl.writeTok(l_loop, Tpl.ST_STRING("if ("));
        l_loop = Tpl.writeText(l_loop, l_endLoop);
        l_loop = Tpl.writeTok(l_loop, Tpl.ST_LINE(" == 0) {\n"));
        l_loop = Tpl.pushBlock(l_loop, Tpl.BT_INDENT(2));
        l_loop = Tpl.writeText(l_loop, l_bodyExpPre);
        l_loop = Tpl.softNewLine(l_loop);
        l_loop = Tpl.writeText(l_loop, l_foldExp);
        l_loop = Tpl.softNewLine(l_loop);
        l_loop = Tpl.popBlock(l_loop);
        l_loop = Tpl.writeTok(l_loop, Tpl.ST_STRING("} "));
        l_loop = fun_233(l_loop, i_iterators, l_endLoop);
        l_loop = Tpl.softNewLine(l_loop);
        l_loop = Tpl.popBlock(l_loop);
        l_loop = Tpl.writeTok(l_loop, Tpl.ST_STRING("}"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_LINE("{\n"));
        a_preExp = Tpl.pushBlock(a_preExp, Tpl.BT_INDENT(2));
        a_preExp = Tpl.writeText(a_preExp, l_tmpVarDecls);
        a_preExp = Tpl.softNewLine(a_preExp);
        a_preExp = Tpl.writeText(a_preExp, l_rangeExpPre);
        a_preExp = Tpl.softNewLine(a_preExp);
        a_preExp = Tpl.writeText(a_preExp, l_firstValue);
        a_preExp = Tpl.softNewLine(a_preExp);
        a_preExp = fun_234(a_preExp, l_resTail, l_res);
        a_preExp = Tpl.softNewLine(a_preExp);
        a_preExp = Tpl.writeText(a_preExp, l_loop);
        a_preExp = Tpl.softNewLine(a_preExp);
        a_preExp = fun_235(a_preExp, l_foundFirst);
        a_preExp = Tpl.softNewLine(a_preExp);
        a_preExp = fun_236(a_preExp, l_resTail);
        a_preExp = Tpl.softNewLine(a_preExp);
        a_preExp = Tpl.writeText(a_preExp, l_resTmp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = "));
        a_preExp = Tpl.writeText(a_preExp, l_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_LINE(";\n"));
        a_preExp = Tpl.popBlock(a_preExp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("}"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_resTmp);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           i_exp,
           _,
           a_preExp,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      equation
        txt_31 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("Code generation does not support multiple iterators: "));
        txt_31 = ExpressionDumpTpl.dumpExp(txt_31, i_exp, "\"");
        txt = error(txt, Tpl.sourceInfo("CodegenCppCommon.tpl", 1231, 14), Tpl.textString(txt_31));
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end daeExpReduction;

public function daeExpSize
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_exp, in_a_context, in_a_preExp, in_a_varDecls, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      DAE.Exp i_dim;
      DAE.Exp i_exp;
      Tpl.Text l_tmp;
      Tpl.Text l_dimPart;
      Tpl.Text l_expPart;

    case ( txt,
           DAE.SIZE(exp = (i_exp as DAE.CREF(componentRef = _)), sz = SOME(i_dim)),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (l_expPart, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_exp, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        (l_dimPart, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_dim, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeText(txt, l_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".getDim("));
        txt = Tpl.writeText(txt, l_dimPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.SIZE(exp = (i_exp as DAE.CREF(componentRef = _))),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (l_expPart, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_exp, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        (l_tmp, a_varDecls) = tempDecl(Tpl.emptyTxt, "vector<size_t>", a_varDecls);
        a_preExp = Tpl.writeText(a_preExp, l_tmp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = "));
        a_preExp = Tpl.writeText(a_preExp, l_expPart);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING_LIST({
                                              ".getDims();\n",
                                              "DynArrayDim1<int> "
                                          }, false));
        a_preExp = Tpl.writeText(a_preExp, l_tmp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("_size("));
        a_preExp = Tpl.writeText(a_preExp, l_tmp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING_LIST({
                                              ".size());\n",
                                              "for (size_t "
                                          }, false));
        a_preExp = Tpl.writeText(a_preExp, l_tmp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("_i = 1; "));
        a_preExp = Tpl.writeText(a_preExp, l_tmp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("_i <= "));
        a_preExp = Tpl.writeText(a_preExp, l_tmp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(".size(); "));
        a_preExp = Tpl.writeText(a_preExp, l_tmp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_LINE("_i++)\n"));
        a_preExp = Tpl.pushBlock(a_preExp, Tpl.BT_INDENT(2));
        a_preExp = Tpl.writeText(a_preExp, l_tmp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("_size("));
        a_preExp = Tpl.writeText(a_preExp, l_tmp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("_i) = (int)"));
        a_preExp = Tpl.writeText(a_preExp, l_tmp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("["));
        a_preExp = Tpl.writeText(a_preExp, l_tmp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("_i-1];"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        a_preExp = Tpl.popBlock(a_preExp);
        txt = Tpl.writeText(txt, l_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_size"));
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           a_preExp,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("size(X) not implemented"));
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end daeExpSize;

protected function lm_239
  input Tpl.Text in_txt;
  input list<list<DAE.Exp>> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_preExp, out_a_varDecls) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_preExp, in_a_varDecls, in_a_context)
    local
      Tpl.Text txt;
      list<list<DAE.Exp>> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      SimCodeFunction.Context a_context;
      list<DAE.Exp> i_row;
      Tpl.Text l_vars;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_preExp,
           a_varDecls,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_preExp, a_varDecls);

    case ( txt,
           i_row :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_preExp,
           a_varDecls,
           a_context )
      equation
        (l_vars, a_varDecls, a_preExp, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExpMatrixRow2(Tpl.emptyTxt, i_row, a_context, a_varDecls, a_preExp, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeText(txt, l_vars);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_preExp, a_varDecls) = lm_239(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_preExp, a_varDecls, a_context);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_preExp, a_varDecls);
  end match;
end lm_239;

protected function fun_240
  input Tpl.Text in_txt;
  input String in_mArg;
  input Tpl.Text in_a_vars;
  input Tpl.Text in_a_arrayTypeStr;
  input Tpl.Text in_a_arrayVar;
  input Tpl.Text in_a_StatArrayDim;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input SimCodeFunction.Context in_a_context;
  input list<list<DAE.Exp>> in_a_m_matrix;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_preExp, out_a_varDecls) :=
  match(in_txt, in_mArg, in_a_vars, in_a_arrayTypeStr, in_a_arrayVar, in_a_StatArrayDim, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_preExp, in_a_varDecls, in_a_context, in_a_m_matrix)
    local
      Tpl.Text txt;
      Tpl.Text a_vars;
      Tpl.Text a_arrayTypeStr;
      Tpl.Text a_arrayVar;
      Tpl.Text a_StatArrayDim;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      SimCodeFunction.Context a_context;
      list<list<DAE.Exp>> a_m_matrix;
      Tpl.Text l_params;

    case ( txt,
           "NO_ASSIGN",
           _,
           a_arrayTypeStr,
           a_arrayVar,
           a_StatArrayDim,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_preExp,
           a_varDecls,
           a_context,
           a_m_matrix )
      equation
        l_params = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_params, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_preExp, a_varDecls) = lm_239(l_params, a_m_matrix, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_preExp, a_varDecls, a_context);
        l_params = Tpl.popIter(l_params);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_LINE("//default matrix assign\n"));
        a_preExp = Tpl.writeText(a_preExp, a_StatArrayDim);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" "));
        a_preExp = Tpl.writeText(a_preExp, a_arrayVar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_LINE(";\n"));
        a_preExp = Tpl.writeText(a_preExp, a_arrayTypeStr);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" "));
        a_preExp = Tpl.writeText(a_preExp, a_arrayVar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("_data[] = {"));
        a_preExp = Tpl.writeText(a_preExp, l_params);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING_LIST({
                                              "};\n",
                                              "assignRowMajorData("
                                          }, false));
        a_preExp = Tpl.writeText(a_preExp, a_arrayVar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("_data, "));
        a_preExp = Tpl.writeText(a_preExp, a_arrayVar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_preExp, a_varDecls);

    case ( txt,
           _,
           a_vars,
           _,
           a_arrayVar,
           a_StatArrayDim,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_preExp,
           a_varDecls,
           _,
           _ )
      equation
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_LINE("//optimized matrix assign\n"));
        a_preExp = Tpl.writeText(a_preExp, a_StatArrayDim);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" "));
        a_preExp = Tpl.writeText(a_preExp, a_arrayVar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_LINE(";\n"));
        a_preExp = Tpl.writeText(a_preExp, a_arrayVar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(".assign( "));
        a_preExp = Tpl.writeText(a_preExp, a_vars);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" );"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_preExp, a_varDecls);
  end match;
end fun_240;

protected function fun_241
  input Tpl.Text in_txt;
  input list<list<DAE.Exp>> in_a_m_matrix;
  input Tpl.Text in_a_arrayTypeStr;
  input Tpl.Text in_a_arrayVar;
  input Tpl.Text in_a_StatArrayDim;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_preExp, out_a_varDecls) :=
  match(in_txt, in_a_m_matrix, in_a_arrayTypeStr, in_a_arrayVar, in_a_StatArrayDim, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_preExp, in_a_varDecls, in_a_context)
    local
      Tpl.Text txt;
      Tpl.Text a_arrayTypeStr;
      Tpl.Text a_arrayVar;
      Tpl.Text a_StatArrayDim;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      SimCodeFunction.Context a_context;
      list<list<DAE.Exp>> i_m_matrix;
      String str_1;
      Tpl.Text l_vars;

    case ( txt,
           (i_m_matrix as _ :: _),
           a_arrayTypeStr,
           a_arrayVar,
           a_StatArrayDim,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_preExp,
           a_varDecls,
           a_context )
      equation
        l_vars = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("NO_ASSIGN"));
        str_1 = Tpl.textString(l_vars);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_preExp, a_varDecls) = fun_240(txt, str_1, l_vars, a_arrayTypeStr, a_arrayVar, a_StatArrayDim, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_preExp, a_varDecls, a_context, i_m_matrix);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_preExp, a_varDecls);

    case ( txt,
           _,
           _,
           _,
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_preExp,
           a_varDecls,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_preExp, a_varDecls);
  end match;
end fun_241;

public function daeExpMatrix
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_exp, in_a_context, in_a_preExp, in_a_varDecls, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      list<list<DAE.Exp>> i_m_matrix;
      list<DAE.Exp> i_row1;
      DAE.Type i_ty;
      Tpl.Text l_matrixassign;
      Integer ret_7;
      Tpl.Text l_dim__cols;
      Tpl.Text l_vals;
      Tpl.Text l_arrayVar;
      Tpl.Text l_StatArrayDim;
      Tpl.Text l_tmp;
      Tpl.Text l_arrayTypeStr;
      Tpl.Text l_typestr;

    case ( txt,
           DAE.MATRIX(matrix = {{}}, ty = i_ty),
           _,
           a_preExp,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      equation
        l_typestr = expTypeShort(Tpl.emptyTxt, i_ty);
        l_arrayTypeStr = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("DynArrayDim2<"));
        l_arrayTypeStr = Tpl.writeText(l_arrayTypeStr, l_typestr);
        l_arrayTypeStr = Tpl.writeTok(l_arrayTypeStr, Tpl.ST_STRING(">"));
        (l_tmp, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(l_arrayTypeStr), a_varDecls);
        txt = Tpl.writeText(txt, l_tmp);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.MATRIX(matrix = {}, ty = i_ty),
           _,
           a_preExp,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      equation
        l_typestr = expTypeShort(Tpl.emptyTxt, i_ty);
        l_arrayTypeStr = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("DynArrayDim2<"));
        l_arrayTypeStr = Tpl.writeText(l_arrayTypeStr, l_typestr);
        l_arrayTypeStr = Tpl.writeTok(l_arrayTypeStr, Tpl.ST_STRING(">"));
        (l_tmp, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(l_arrayTypeStr), a_varDecls);
        txt = Tpl.writeText(txt, l_tmp);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.MATRIX(matrix = (i_m_matrix as i_row1 :: _), ty = i_ty),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_arrayTypeStr = expTypeShort(Tpl.emptyTxt, i_ty);
        l_StatArrayDim = expTypeArrayIf(Tpl.emptyTxt, i_ty);
        l_tmp = Tpl.emptyTxt;
        (l_arrayVar, l_tmp) = tempDecl(Tpl.emptyTxt, Tpl.textString(l_arrayTypeStr), l_tmp);
        l_vals = Tpl.emptyTxt;
        ret_7 = listLength(i_row1);
        l_dim__cols = Tpl.writeStr(Tpl.emptyTxt, intString(ret_7));
        (l_matrixassign, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_preExp, a_varDecls) = fun_241(Tpl.emptyTxt, i_m_matrix, l_arrayTypeStr, l_arrayVar, l_StatArrayDim, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_preExp, a_varDecls, a_context);
        txt = Tpl.writeText(txt, l_arrayVar);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           a_preExp,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end daeExpMatrix;

protected function lm_243
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Exp i_e;
      Tpl.Text l_expVar;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);

    case ( txt,
           i_e :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (l_expVar, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_e, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeText(txt, l_expVar);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = lm_243(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);
  end match;
end lm_243;

public function daeExpMatrixRow2
  input Tpl.Text txt;
  input list<DAE.Exp> a_row;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_preExp;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
protected
  Tpl.Text l_varLstStr;
algorithm
  l_varLstStr := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (l_varLstStr, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp) := lm_243(l_varLstStr, a_row, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context);
  l_varLstStr := Tpl.popIter(l_varLstStr);
  out_txt := Tpl.writeText(txt, l_varLstStr);
end daeExpMatrixRow2;

protected function fun_245
  input Tpl.Text in_txt;
  input list<list<DAE.Exp>> in_a_matrix;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_a_matrix, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_context)
    local
      Tpl.Text txt;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      SimCodeFunction.Context a_context;
      list<DAE.Exp> i_row;

    case ( txt,
           i_row :: _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_context )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExpMatrixName(txt, i_row, a_context, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("NO_ASSIGN"));
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_245;

protected function fun_246
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input list<list<DAE.Exp>> in_a_matrix;
  input SimCodeFunction.Context in_a_context;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_mArg, in_a_matrix, in_a_context, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName)
    local
      Tpl.Text txt;
      list<list<DAE.Exp>> a_matrix;
      SimCodeFunction.Context a_context;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;

    case ( txt,
           false,
           _,
           _,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("NO_ASSIGN"));
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           a_matrix,
           a_context,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName )
      equation
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_245(txt, a_matrix, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_context);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end fun_246;

public function daeExpMatrixRow
  input Tpl.Text txt;
  input list<list<DAE.Exp>> a_matrix;
  input SimCodeFunction.Context a_context;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_stateDerVectorName;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
protected
  Boolean ret_1;
  list<DAE.Exp> ret_0;
algorithm
  ret_0 := List.flatten(a_matrix);
  ret_1 := Expression.isCrefListWithEqualIdents(ret_0);
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) := fun_246(txt, ret_1, a_matrix, a_context, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
end daeExpMatrixRow;

protected function fun_248
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_a_row;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_a_row, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_context)
    local
      Tpl.Text txt;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      SimCodeFunction.Context a_context;
      DAE.ComponentRef i_cr;
      DAE.ComponentRef ret_0;

    case ( txt,
           DAE.CREF(componentRef = i_cr) :: _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_context )
      equation
        ret_0 = ComponentReference.crefStripLastSubs(i_cr);
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = contextCref(txt, ret_0, a_context, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, false);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_248;

public function daeExpMatrixName
  input Tpl.Text txt;
  input list<DAE.Exp> a_row;
  input SimCodeFunction.Context a_context;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_stateDerVectorName;
  input Tpl.Text a_extraFuncsNamespace;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
protected
  Tpl.Text l_preExp;
  Tpl.Text l_varDecls;
algorithm
  l_varDecls := Tpl.emptyTxt;
  l_preExp := Tpl.emptyTxt;
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) := fun_248(txt, a_row, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_context);
end daeExpMatrixName;

public function daeExpMatrixName2
  input Tpl.Text in_txt;
  input DAE.ComponentRef in_a_cr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_cr)
    local
      Tpl.Text txt;
      DAE.ComponentRef i_componentRef;
      list<DAE.Subscript> i_subscriptLst;
      DAE.Ident i_ident;

    case ( txt,
           DAE.CREF_IDENT(ident = i_ident) )
      equation
        txt = Tpl.writeStr(txt, i_ident);
      then txt;

    case ( txt,
           DAE.CREF_QUAL(ident = i_ident, subscriptLst = i_subscriptLst, componentRef = i_componentRef) )
      equation
        txt = Tpl.writeStr(txt, i_ident);
        txt = subscriptsToCStrForArray(txt, i_subscriptLst);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_P_"));
        txt = daeExpMatrixName2(txt, i_componentRef);
      then txt;

    case ( txt,
           DAE.WILD() )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("CREF_NOT_IDENT_OR_QUAL"));
      then txt;
  end match;
end daeExpMatrixName2;

protected function fun_251
  input Tpl.Text in_txt;
  input Boolean in_a_scalar;
  input Tpl.Text in_a_arrayTypeStr;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;
  input list<DAE.Exp> in_a_array;
  input Tpl.Text in_a_arrayVar;
  input Tpl.Text in_a_ArrayType;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_preExp, out_a_varDecls) :=
  match(in_txt, in_a_scalar, in_a_arrayTypeStr, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_preExp, in_a_context, in_a_array, in_a_arrayVar, in_a_ArrayType, in_a_varDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_arrayTypeStr;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      list<DAE.Exp> a_array;
      Tpl.Text a_arrayVar;
      Tpl.Text a_ArrayType;
      Tpl.Text a_varDecls;
      Tpl.Text l_params;

    case ( txt,
           false,
           _,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_preExp,
           a_context,
           a_array,
           a_arrayVar,
           a_ArrayType,
           a_varDecls )
      equation
        a_varDecls = Tpl.writeText(a_varDecls, a_ArrayType);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(" "));
        a_varDecls = Tpl.writeText(a_varDecls, a_arrayVar);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(";"));
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_NEW_LINE());
        (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExpArray3(txt, a_array, Tpl.textString(a_arrayVar), Tpl.textString(a_ArrayType), a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_preExp, a_varDecls);

    case ( txt,
           _,
           a_arrayTypeStr,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_preExp,
           a_context,
           a_array,
           a_arrayVar,
           a_ArrayType,
           a_varDecls )
      equation
        (l_params, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExpArray2(Tpl.emptyTxt, a_array, Tpl.textString(a_arrayVar), Tpl.textString(a_ArrayType), Tpl.textString(a_arrayTypeStr), a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_preExp, a_varDecls);
  end match;
end fun_251;

public function daeExpArray
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_exp, in_a_context, in_a_preExp, in_a_varDecls, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      list<DAE.Exp> i_array;
      Boolean i_scalar;
      DAE.Type i_ty;
      Tpl.Text l_tmpdecl;
      Tpl.Text l_arrayDef;
      Tpl.Text l_arrayassign;
      Tpl.Text l_arrayVar;
      Tpl.Text l_tmpVar;
      Tpl.Text l_ArrayType;
      Tpl.Text l_arrayTypeStr;

    case ( txt,
           DAE.ARRAY(array = (i_array as _ :: _), ty = i_ty, scalar = i_scalar),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_arrayTypeStr = expTypeShort(Tpl.emptyTxt, i_ty);
        l_ArrayType = expTypeArrayIf(Tpl.emptyTxt, i_ty);
        l_tmpVar = Tpl.emptyTxt;
        (l_arrayVar, l_tmpVar) = tempDecl(Tpl.emptyTxt, Tpl.textString(l_arrayTypeStr), l_tmpVar);
        (l_arrayassign, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_preExp, a_varDecls) = fun_251(Tpl.emptyTxt, i_scalar, l_arrayTypeStr, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_preExp, a_context, i_array, l_arrayVar, l_ArrayType, a_varDecls);
        txt = Tpl.writeText(txt, l_arrayVar);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.ARRAY(ty = i_ty),
           _,
           a_preExp,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      equation
        l_arrayTypeStr = expTypeShort(Tpl.emptyTxt, i_ty);
        l_arrayDef = expTypeArrayIf(Tpl.emptyTxt, i_ty);
        l_tmpdecl = Tpl.emptyTxt;
        (l_arrayVar, l_tmpdecl) = tempDecl(Tpl.emptyTxt, Tpl.textString(l_arrayTypeStr), l_tmpdecl);
        l_tmpVar = Tpl.emptyTxt;
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING_LIST({
                                              "\n",
                                              "   //tmp array\n"
                                          }, true));
        a_preExp = Tpl.pushBlock(a_preExp, Tpl.BT_INDENT(3));
        a_preExp = Tpl.writeText(a_preExp, l_arrayDef);
        a_preExp = Tpl.writeText(a_preExp, l_arrayVar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(";"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        a_preExp = Tpl.popBlock(a_preExp);
        txt = Tpl.writeText(txt, l_arrayVar);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           a_preExp,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end daeExpArray;

protected function lm_253
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input list<DAE.Exp> in_a_array;
  input String in_a_arrayVar;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_array, in_a_arrayVar, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      list<DAE.Exp> a_array;
      String a_arrayVar;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      Integer x_i0;
      DAE.Exp i_e;
      Integer ret_1;
      Tpl.Text l_subArraycall;

    case ( txt,
           {},
           _,
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);

    case ( txt,
           i_e :: rest,
           a_array,
           a_arrayVar,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        (l_subArraycall, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_e, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeStr(txt, a_arrayVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".append("));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, l_subArraycall);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        ret_1 = listLength(a_array);
        txt = Tpl.writeStr(txt, intString(ret_1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = lm_253(txt, rest, a_array, a_arrayVar, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);
  end match;
end lm_253;

public function daeExpArray3
  input Tpl.Text txt;
  input list<DAE.Exp> a_array;
  input String a_arrayVar;
  input String a_ArrayType;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_preExp;
  input Tpl.Text a_varDecls;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
protected
  Tpl.Text l_arraycreate;
algorithm
  l_arraycreate := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(1, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (l_arraycreate, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp) := lm_253(l_arraycreate, a_array, a_array, a_arrayVar, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context);
  l_arraycreate := Tpl.popIter(l_arraycreate);
  out_a_preExp := Tpl.pushBlock(out_a_preExp, Tpl.BT_INDENT(2));
  out_a_preExp := Tpl.writeText(out_a_preExp, l_arraycreate);
  out_a_preExp := Tpl.softNewLine(out_a_preExp);
  out_a_preExp := Tpl.writeTok(out_a_preExp, Tpl.ST_NEW_LINE());
  out_a_preExp := Tpl.popBlock(out_a_preExp);
  out_txt := Tpl.writeText(txt, l_arraycreate);
end daeExpArray3;

protected function lm_255
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Exp i_e;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);

    case ( txt,
           i_e :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(txt, i_e, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = lm_255(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);
  end match;
end lm_255;

public function daeExpArray2
  input Tpl.Text txt;
  input list<DAE.Exp> a_array;
  input String a_arrayVar;
  input String a_ArrayType;
  input String a_arrayTypeStr;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_preExp;
  input Tpl.Text a_varDecls;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
protected
  Tpl.Text l_params;
algorithm
  l_params := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (l_params, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp) := lm_255(l_params, a_array, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context);
  l_params := Tpl.popIter(l_params);
  out_a_preExp := Tpl.writeStr(out_a_preExp, a_arrayTypeStr);
  out_a_preExp := Tpl.writeTok(out_a_preExp, Tpl.ST_STRING(" "));
  out_a_preExp := Tpl.writeStr(out_a_preExp, a_arrayVar);
  out_a_preExp := Tpl.writeTok(out_a_preExp, Tpl.ST_STRING("_data[]={"));
  out_a_preExp := Tpl.writeText(out_a_preExp, l_params);
  out_a_preExp := Tpl.writeTok(out_a_preExp, Tpl.ST_LINE("};\n"));
  out_a_preExp := Tpl.writeStr(out_a_preExp, a_ArrayType);
  out_a_preExp := Tpl.writeTok(out_a_preExp, Tpl.ST_STRING(" "));
  out_a_preExp := Tpl.writeStr(out_a_preExp, a_arrayVar);
  out_a_preExp := Tpl.writeTok(out_a_preExp, Tpl.ST_STRING("("));
  out_a_preExp := Tpl.writeStr(out_a_preExp, a_arrayVar);
  out_a_preExp := Tpl.writeTok(out_a_preExp, Tpl.ST_STRING("_data);"));
  out_a_preExp := Tpl.writeTok(out_a_preExp, Tpl.ST_NEW_LINE());
  out_txt := Tpl.writeText(txt, l_params);
end daeExpArray2;

protected function fun_257
  input Tpl.Text in_txt;
  input DAE.Exp in_a_inExp;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_a_inExp, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Exp i_idx;
      DAE.Exp i_e;
      Tpl.Text l_idx1;
      Tpl.Text l_e1;

    case ( txt,
           DAE.ASUB(exp = i_e, sub = {i_idx}),
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (l_e1, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_e, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        (l_idx1, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_idx, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("arrayGet("));
        txt = Tpl.writeText(txt, l_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, l_idx1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") /* DAE.ASUB */"));
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);

    case ( txt,
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);
  end match;
end fun_257;

protected function lm_258
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Tpl.Text in_a_res;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_res, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Tpl.Text a_res;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      SimCodeFunction.Context a_context;
      Integer x_i1;
      DAE.Exp i_e;
      Tpl.Text l_v;
      Tpl.Text l_casePreExp;
      Tpl.Text l_caseVarDecls;

    case ( txt,
           {},
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           i_e :: rest,
           a_res,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_context )
      equation
        x_i1 = Tpl.getIteri_i0(txt);
        l_caseVarDecls = Tpl.emptyTxt;
        l_casePreExp = Tpl.emptyTxt;
        (l_v, l_casePreExp, l_caseVarDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_e, a_context, l_casePreExp, l_caseVarDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("case "));
        txt = Tpl.writeStr(txt, intString(x_i1));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(": {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_caseVarDecls);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_casePreExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, a_res);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, l_v);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "break;\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_258(txt, rest, a_res, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_context);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_258;

protected function fun_259
  input Tpl.Text in_txt;
  input SimCodeFunction.Context in_a_context;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input list<DAE.Exp> in_a_subs;
  input DAE.Type in_a_ecr_ty;
  input Tpl.Text in_a_arrName;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_a_context, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_preExp, in_a_subs, in_a_ecr_ty, in_a_arrName)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      list<DAE.Exp> a_subs;
      DAE.Type a_ecr_ty;
      Tpl.Text a_arrName;
      SimCodeFunction.Context i_context;

    case ( txt,
           SimCodeFunction.FUNCTION_CONTEXT(cref_prefix = _),
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           a_preExp,
           _,
           _,
           a_arrName )
      equation
        txt = Tpl.writeText(txt, a_arrName);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);

    case ( txt,
           i_context,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp,
           a_subs,
           a_ecr_ty,
           a_arrName )
      equation
        (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = arrayScalarRhs(txt, a_ecr_ty, a_subs, Tpl.textString(a_arrName), i_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);
  end match;
end fun_259;

protected function lm_260
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Exp i_index;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);

    case ( txt,
           i_index :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExpASubIndex(txt, i_index, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = lm_260(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);
  end match;
end lm_260;

protected function fun_261
  input Tpl.Text in_txt;
  input DAE.Exp in_a_inExp;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_preExp, out_a_varDecls) :=
  match(in_txt, in_a_inExp, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_preExp, in_a_context, in_a_varDecls)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      Tpl.Text a_varDecls;
      list<DAE.Exp> i_indexes;
      DAE.Exp i_e;
      DAE.Type i_ecr_ty;
      list<DAE.Exp> i_subs;
      DAE.Exp i_ecr;
      list<DAE.Exp> i_exp_array;
      DAE.Exp i_idx;
      DAE.Exp i_exp;
      Tpl.Text txt_10;
      Tpl.Text l_expIndexes;
      Tpl.Text l_exp;
      DAE.Exp ret_7;
      Tpl.Text l_arrName;
      Tpl.Text txt_5;
      Tpl.Text l_expl;
      Tpl.Text l_idx1;
      Tpl.Text txt_2;
      Tpl.Text l_res;
      Tpl.Text txt_0;

    case ( txt,
           DAE.ASUB(exp = (i_exp as DAE.ASUB(exp = _))),
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_preExp,
           _,
           a_varDecls )
      equation
        txt_0 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("Nested array subscripting *should* have been handled by the routine creating the asub, but for some reason it was not: "));
        txt_0 = ExpressionDumpTpl.dumpExp(txt_0, i_exp, "\"");
        txt = error(txt, Tpl.sourceInfo("CodegenCppCommon.tpl", 1574, 11), Tpl.textString(txt_0));
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_preExp, a_varDecls);

    case ( txt,
           DAE.ASUB(exp = (i_exp as DAE.ARRAY(scalar = true, array = i_exp_array)), sub = {i_idx}),
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_preExp,
           a_context,
           a_varDecls )
      equation
        txt_2 = expTypeFromExpModelica(Tpl.emptyTxt, i_exp);
        (l_res, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(txt_2), a_varDecls);
        (l_idx1, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_idx, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        l_expl = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(1, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_expl, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_258(l_expl, i_exp_array, l_res, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_context);
        l_expl = Tpl.popIter(l_expl);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("switch ("));
        a_preExp = Tpl.writeText(a_preExp, l_idx1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_LINE(") { /* ASUB */\n"));
        a_preExp = Tpl.writeText(a_preExp, l_expl);
        a_preExp = Tpl.softNewLine(a_preExp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING_LIST({
                                              "default:\n",
                                              "  assert(NULL == \"index out of bounds\");\n",
                                              "}"
                                          }, false));
        txt = Tpl.writeText(txt, l_res);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_preExp, a_varDecls);

    case ( txt,
           DAE.ASUB(exp = (i_exp as DAE.RANGE(ty = _)), sub = {_}),
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_preExp,
           _,
           a_varDecls )
      equation
        txt_5 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("ASUB_EASY_CASE "));
        txt_5 = ExpressionDumpTpl.dumpExp(txt_5, i_exp, "\"");
        txt = error(txt, Tpl.sourceInfo("CodegenCppCommon.tpl", 1603, 11), Tpl.textString(txt_5));
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_preExp, a_varDecls);

    case ( txt,
           DAE.ASUB(exp = (i_ecr as DAE.CREF(ty = i_ecr_ty)), sub = i_subs),
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_preExp,
           a_context,
           a_varDecls )
      equation
        ret_7 = SimCodeFunctionUtil.buildCrefExpFromAsub(i_ecr, i_subs);
        (l_arrName, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExpCrefRhs(Tpl.emptyTxt, ret_7, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = fun_259(txt, a_context, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, i_subs, i_ecr_ty, l_arrName);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_preExp, a_varDecls);

    case ( txt,
           DAE.ASUB(exp = i_e, sub = i_indexes),
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_preExp,
           a_context,
           a_varDecls )
      equation
        (l_exp, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_e, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        l_expIndexes = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_expIndexes, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = lm_260(l_expIndexes, i_indexes, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context);
        l_expIndexes = Tpl.popIter(l_expIndexes);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, l_exp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")("));
        txt = Tpl.writeText(txt, l_expIndexes);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_preExp, a_varDecls);

    case ( txt,
           i_exp,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_preExp,
           _,
           a_varDecls )
      equation
        txt_10 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("OTHER_ASUB "));
        txt_10 = ExpressionDumpTpl.dumpExp(txt_10, i_exp, "\"");
        txt = error(txt, Tpl.sourceInfo("CodegenCppCommon.tpl", 1618, 11), Tpl.textString(txt_10));
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_preExp, a_varDecls);
  end match;
end fun_261;

protected function fun_262
  input Tpl.Text in_txt;
  input String in_mArg;
  input DAE.Exp in_a_inExp;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_mArg, in_a_inExp, in_a_context, in_a_preExp, in_a_varDecls, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      DAE.Exp a_inExp;
      SimCodeFunction.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;

    case ( txt,
           "metatype",
           a_inExp,
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = fun_257(txt, a_inExp, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           a_inExp,
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_preExp, a_varDecls) = fun_261(txt, a_inExp, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_preExp, a_context, a_varDecls);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end fun_262;

public function daeExpAsub
  input Tpl.Text txt;
  input DAE.Exp a_inExp;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_preExp;
  input Tpl.Text a_varDecls;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
protected
  String str_1;
  Tpl.Text txt_0;
algorithm
  txt_0 := expTypeFromExpShort(Tpl.emptyTxt, a_inExp);
  str_1 := Tpl.textString(txt_0);
  (out_txt, out_a_preExp, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) := fun_262(txt, str_1, a_inExp, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
end daeExpAsub;

public function daeExpASubIndex
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_exp, in_a_context, in_a_preExp, in_a_varDecls, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      DAE.Exp i_exp;
      Integer i_index;
      Integer i_integer;

    case ( txt,
           DAE.ICONST(integer = i_integer),
           _,
           a_preExp,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      equation
        txt = Tpl.writeStr(txt, intString(i_integer));
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.ENUM_LITERAL(index = i_index),
           _,
           a_preExp,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      equation
        txt = Tpl.writeStr(txt, intString(i_index));
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           i_exp,
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(txt, i_exp, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end daeExpASubIndex;

protected function lm_265
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Exp i_exp;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);

    case ( txt,
           i_exp :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(txt, i_exp, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = lm_265(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);
  end match;
end lm_265;

protected function fun_266
  input Tpl.Text in_txt;
  input String in_mArg;
  input Tpl.Text in_a_dimsValuesStr;
  input String in_a_arrName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_dimsValuesStr, in_a_arrName)
    local
      Tpl.Text txt;
      Tpl.Text a_dimsValuesStr;
      String a_arrName;

    case ( txt,
           "metatype_array",
           a_dimsValuesStr,
           a_arrName )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("arrayGet("));
        txt = Tpl.writeStr(txt, a_arrName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, a_dimsValuesStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") /*arrayScalarRhs*/"));
      then txt;

    case ( txt,
           _,
           a_dimsValuesStr,
           a_arrName )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeStr(txt, a_arrName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_dimsValuesStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") "));
        txt = Tpl.popBlock(txt);
      then txt;
  end match;
end fun_266;

public function arrayScalarRhs
  input Tpl.Text txt;
  input DAE.Type a_ty;
  input list<DAE.Exp> a_subs;
  input String a_arrName;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_preExp;
  input Tpl.Text a_varDecls;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
protected
  String str_4;
  Tpl.Text l_dimsValuesStr;
  Integer ret_2;
  Tpl.Text l_dimsLenStr;
  Tpl.Text l_arrayType;
algorithm
  l_arrayType := expTypeShort(Tpl.emptyTxt, a_ty);
  ret_2 := listLength(a_subs);
  l_dimsLenStr := Tpl.writeStr(Tpl.emptyTxt, intString(ret_2));
  l_dimsValuesStr := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (l_dimsValuesStr, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp) := lm_265(l_dimsValuesStr, a_subs, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context);
  l_dimsValuesStr := Tpl.popIter(l_dimsValuesStr);
  str_4 := Tpl.textString(l_arrayType);
  out_txt := fun_266(txt, str_4, l_dimsValuesStr, a_arrName);
end arrayScalarRhs;

protected function fun_268
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input DAE.Exp in_a_exp;
  input Tpl.Text in_a_expVar;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls) :=
  match(in_txt, in_a_ty, in_a_preExp, in_a_varDecls, in_a_exp, in_a_expVar)
    local
      Tpl.Text txt;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      DAE.Exp a_exp;
      Tpl.Text a_expVar;
      list<DAE.Var> i_vl;
      Absyn.Path i_rec_path;
      DAE.Dimensions i_dims;
      DAE.Type i_ty;
      Tpl.Text txt_4;
      Tpl.Text txt_3;
      Tpl.Text l_tvar;
      Tpl.Text l_to;
      Tpl.Text l_from;

    case ( txt,
           DAE.T_INTEGER(varLst = _),
           a_preExp,
           a_varDecls,
           _,
           a_expVar )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("((int)"));
        txt = Tpl.writeText(txt, a_expVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.T_REAL(varLst = _),
           a_preExp,
           a_varDecls,
           _,
           a_expVar )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("((double)"));
        txt = Tpl.writeText(txt, a_expVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.T_ENUMERATION(index = _),
           a_preExp,
           a_varDecls,
           _,
           a_expVar )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("((int)"));
        txt = Tpl.writeText(txt, a_expVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.T_BOOL(varLst = _),
           a_preExp,
           a_varDecls,
           _,
           a_expVar )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("((bool)"));
        txt = Tpl.writeText(txt, a_expVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.T_ARRAY(dims = i_dims, ty = i_ty),
           a_preExp,
           a_varDecls,
           a_exp,
           a_expVar )
      equation
        l_from = expTypeFromExpShort(Tpl.emptyTxt, a_exp);
        l_to = expTypeShort(Tpl.emptyTxt, i_ty);
        txt_3 = expTypeArrayDims(Tpl.emptyTxt, i_ty, i_dims);
        (l_tvar, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(txt_3), a_varDecls);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("cast_array<"));
        a_preExp = Tpl.writeText(a_preExp, l_from);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, l_to);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(">("));
        a_preExp = Tpl.writeText(a_preExp, a_expVar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, l_tvar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tvar);
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.T_COMPLEX(varLst = i_vl, complexClassType = ClassInf.RECORD(path = i_rec_path)),
           a_preExp,
           a_varDecls,
           _,
           a_expVar )
      equation
        txt_4 = CodegenUtil.underscorePath(Tpl.emptyTxt, i_rec_path);
        txt_4 = Tpl.writeTok(txt_4, Tpl.ST_STRING("Type"));
        (l_tvar, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(txt_4), a_varDecls);
        a_preExp = structParams(a_preExp, Tpl.textString(a_expVar), Tpl.textString(l_tvar), i_vl);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tvar);
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           _,
           a_preExp,
           a_varDecls,
           _,
           a_expVar )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_expVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") /* could not cast, using the variable as it is */"));
      then (txt, a_preExp, a_varDecls);
  end match;
end fun_268;

public function daeExpCast
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_exp, in_a_context, in_a_preExp, in_a_varDecls, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      DAE.Type i_ty;
      DAE.Exp i_exp;
      Tpl.Text l_expVar;

    case ( txt,
           DAE.CAST(exp = i_exp, ty = i_ty),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (l_expVar, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_exp, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        (txt, a_preExp, a_varDecls) = fun_268(txt, i_ty, a_preExp, a_varDecls, i_exp, l_expVar);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           a_preExp,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end daeExpCast;

protected function fun_270
  input Tpl.Text in_txt;
  input DAE.Var in_a_e;
  input String in_a_structName;
  input String in_a_varName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_e, in_a_structName, in_a_varName)
    local
      Tpl.Text txt;
      String a_structName;
      String a_varName;
      DAE.Ident i_name;

    case ( txt,
           DAE.TYPES_VAR(name = i_name),
           a_structName,
           a_varName )
      equation
        txt = Tpl.writeStr(txt, a_varName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("."));
        txt = Tpl.writeStr(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_ = "));
        txt = Tpl.writeStr(txt, a_structName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("."));
        txt = Tpl.writeStr(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_;"));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_270;

protected function lm_271
  input Tpl.Text in_txt;
  input list<DAE.Var> in_items;
  input String in_a_structName;
  input String in_a_varName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_structName, in_a_varName)
    local
      Tpl.Text txt;
      list<DAE.Var> rest;
      String a_structName;
      String a_varName;
      DAE.Var i_e;

    case ( txt,
           {},
           _,
           _ )
      then txt;

    case ( txt,
           i_e :: rest,
           a_structName,
           a_varName )
      equation
        txt = fun_270(txt, i_e, a_structName, a_varName);
        txt = Tpl.nextIter(txt);
        txt = lm_271(txt, rest, a_structName, a_varName);
      then txt;
  end match;
end lm_271;

public function structParams
  input Tpl.Text txt;
  input String a_structName;
  input String a_varName;
  input list<DAE.Var> a_exps;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_params;
algorithm
  l_params := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  l_params := lm_271(l_params, a_exps, a_structName, a_varName);
  l_params := Tpl.popIter(l_params);
  out_txt := Tpl.writeText(txt, l_params);
end structParams;

protected function lm_273
  input Tpl.Text in_txt;
  input list<tuple<DAE.Exp, String>> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_name;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_preExp, in_a_context, in_a_name)
    local
      Tpl.Text txt;
      list<tuple<DAE.Exp, String>> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      Tpl.Text a_name;
      DAE.Exp i_exp;
      String i_compn;
      DAE.ComponentRef ret_1;
      Tpl.Text l_compnStr;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           a_preExp,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);

    case ( txt,
           (i_exp, i_compn) :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp,
           a_context,
           a_name )
      equation
        ret_1 = ComponentReference.makeUntypedCrefIdent(i_compn);
        l_compnStr = crefStr(Tpl.emptyTxt, ret_1);
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("."));
        txt = Tpl.writeText(txt, l_compnStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(txt, i_exp, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = lm_273(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context, a_name);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);
  end match;
end lm_273;

public function daeExpRecord
  input Tpl.Text in_txt;
  input DAE.Exp in_a_rec;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_rec, in_a_context, in_a_preExp, in_a_varDecls, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      list<String> i_comp;
      list<DAE.Exp> i_exps;
      Absyn.Path i_path;
      list<tuple<DAE.Exp, String>> ret_3;
      Tpl.Text l_ass;
      Tpl.Text txt_1;
      Tpl.Text l_name;

    case ( txt,
           DAE.RECORD(path = i_path, exps = i_exps, comp = i_comp),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        txt_1 = CodegenUtil.underscorePath(Tpl.emptyTxt, i_path);
        txt_1 = Tpl.writeTok(txt_1, Tpl.ST_STRING("Type"));
        (l_name, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(txt_1), a_varDecls);
        ret_3 = List.zip(i_exps, i_comp);
        (l_ass, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = lm_273(Tpl.emptyTxt, ret_3, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context, l_name);
        a_preExp = Tpl.writeText(a_preExp, l_ass);
        txt = Tpl.writeText(txt, l_name);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           a_preExp,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end daeExpRecord;

protected function fun_275
  input Tpl.Text in_txt;
  input SimCodeFunction.Context in_a_context;
  input Integer in_a_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_context, in_a_index)
    local
      Tpl.Text txt;
      Integer a_index;
      Integer ret_1;
      Integer ret_0;

    case ( txt,
           SimCodeFunction.ALGLOOP_CONTEXT(genInitialisation = false),
           a_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_system->_time_conditions["));
        ret_0 = intSub(a_index, 1);
        txt = Tpl.writeStr(txt, intString(ret_0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("]"));
      then txt;

    case ( txt,
           _,
           a_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_time_conditions["));
        ret_1 = intSub(a_index, 1);
        txt = Tpl.writeStr(txt, intString(ret_1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("]"));
      then txt;
  end match;
end fun_275;

protected function fun_276
  input Tpl.Text in_txt;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_context)
    local
      Tpl.Text txt;

    case ( txt,
           SimCodeFunction.ALGLOOP_CONTEXT(genInitialisation = false) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_system->_initial"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_initial"));
      then txt;
  end match;
end fun_276;

protected function fun_277
  input Tpl.Text in_txt;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_context)
    local
      Tpl.Text txt;

    case ( txt,
           SimCodeFunction.ALGLOOP_CONTEXT(genInitialisation = false) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_system->_terminal"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_terminal"));
      then txt;
  end match;
end fun_277;

protected function fun_278
  input Tpl.Text in_txt;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_var3;
  input Tpl.Text in_a_var2;
  input Tpl.Text in_a_var1;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_context, in_a_var3, in_a_var2, in_a_var1)
    local
      Tpl.Text txt;
      Tpl.Text a_var3;
      Tpl.Text a_var2;
      Tpl.Text a_var1;

    case ( txt,
           SimCodeFunction.ALGLOOP_CONTEXT(genInitialisation = false),
           a_var3,
           a_var2,
           a_var1 )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("division("));
        txt = Tpl.writeText(txt, a_var1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, a_var2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(",!_system->_initial,\""));
        txt = Tpl.writeText(txt, a_var3);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\")"));
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           _,
           a_var3,
           a_var2,
           a_var1 )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("division("));
        txt = Tpl.writeText(txt, a_var1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, a_var2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(",!_initial,\""));
        txt = Tpl.writeText(txt, a_var3);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\")"));
        txt = Tpl.popBlock(txt);
      then txt;
  end match;
end fun_278;

protected function fun_279
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty)
    local
      Tpl.Text txt;

    case ( txt,
           DAE.T_ARRAY(ty = DAE.T_INTEGER(varLst = _)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("int"));
      then txt;

    case ( txt,
           DAE.T_ARRAY(ty = DAE.T_ENUMERATION(index = _)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("int"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("double"));
      then txt;
  end match;
end fun_279;

protected function smf_280
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_it;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_it)
    local
      Tpl.Text txt;
      Integer i_i;

    case ( txt,
           SimCodeVar.SIMVAR(index = i_i) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("__zDot["));
        txt = Tpl.writeStr(txt, intString(i_i));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("]"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end smf_280;

protected function fun_281
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_var1;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_var1)
    local
      Tpl.Text txt;
      Tpl.Text a_var1;

    case ( txt,
           false,
           a_var1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("puts("));
        txt = Tpl.writeText(txt, a_var1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           _,
           a_var1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("print("));
        txt = Tpl.writeText(txt, a_var1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;
  end match;
end fun_281;

protected function lm_282
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Exp i_exp;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);

    case ( txt,
           i_exp :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(txt, i_exp, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = lm_282(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);
  end match;
end lm_282;

protected function fun_283
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input DAE.Type in_a_attr_ty;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_argStr;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input DAE.Exp in_a_e1;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls) :=
  match(in_txt, in_mArg, in_a_attr_ty, in_a_context, in_a_argStr, in_a_preExp, in_a_varDecls, in_a_e1)
    local
      Tpl.Text txt;
      DAE.Type a_attr_ty;
      SimCodeFunction.Context a_context;
      Tpl.Text a_argStr;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      DAE.Exp a_e1;
      Tpl.Text l_retVar;
      Tpl.Text l_typeStr;
      Tpl.Text txt_4;
      String ret_4;
      Tpl.Text txt_3;
      Tpl.Text l_cstr;
      Tpl.Text txt_1;
      Tpl.Text l_tmp;

    case ( txt,
           false,
           _,
           a_context,
           a_argStr,
           a_preExp,
           a_varDecls,
           a_e1 )
      equation
        txt_1 = expTypeFromExpModelica(Tpl.emptyTxt, a_e1);
        (l_tmp, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(txt_1), a_varDecls);
        l_cstr = ExpressionDumpTpl.dumpExp(Tpl.emptyTxt, a_e1, "\"");
        a_preExp = Tpl.writeText(a_preExp, l_tmp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = "));
        a_preExp = Tpl.writeText(a_preExp, a_argStr);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_LINE(";\n"));
        txt_3 = Tpl.writeText(Tpl.emptyTxt, l_tmp);
        txt_3 = Tpl.writeTok(txt_3, Tpl.ST_STRING(" >= 0.0"));
        txt_4 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("\"Model error: Argument of sqrt("));
        ret_4 = Util.escapeModelicaStringToCString(Tpl.textString(l_cstr));
        txt_4 = Tpl.writeStr(txt_4, ret_4);
        txt_4 = Tpl.writeTok(txt_4, Tpl.ST_STRING(") should be >= 0\""));
        (a_preExp, txt_3, txt_4, a_varDecls) = assertCommonVar(a_preExp, txt_3, txt_4, a_context, a_varDecls, AbsynUtil.dummyInfo);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("sqrt("));
        txt = Tpl.writeText(txt, l_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           _,
           a_attr_ty,
           _,
           a_argStr,
           a_preExp,
           a_varDecls,
           _ )
      equation
        l_typeStr = expTypeShort(Tpl.emptyTxt, a_attr_ty);
        (l_retVar, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(l_typeStr), a_varDecls);
        a_preExp = Tpl.writeText(a_preExp, l_retVar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = std::sqrt("));
        a_preExp = Tpl.writeText(a_preExp, a_argStr);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_retVar);
      then (txt, a_preExp, a_varDecls);
  end match;
end fun_283;

protected function lm_284
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Exp i_exp;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);

    case ( txt,
           i_exp :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(txt, i_exp, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = lm_284(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);
  end match;
end lm_284;

protected function lm_285
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Exp i_exp;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);

    case ( txt,
           i_exp :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(txt, i_exp, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = lm_285(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);
  end match;
end lm_285;

protected function lm_286
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Exp i_exp;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);

    case ( txt,
           i_exp :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(txt, i_exp, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = lm_286(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);
  end match;
end lm_286;

protected function lm_287
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Exp i_exp;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);

    case ( txt,
           i_exp :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(txt, i_exp, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = lm_287(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);
  end match;
end lm_287;

protected function lm_288
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Exp i_exp;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);

    case ( txt,
           i_exp :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(txt, i_exp, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = lm_288(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);
  end match;
end lm_288;

protected function lm_289
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Exp i_exp;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);

    case ( txt,
           i_exp :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(txt, i_exp, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = lm_289(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);
  end match;
end lm_289;

protected function lm_290
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Exp i_exp;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);

    case ( txt,
           i_exp :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(txt, i_exp, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = lm_290(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);
  end match;
end lm_290;

protected function lm_291
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Exp i_exp;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);

    case ( txt,
           i_exp :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(txt, i_exp, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = lm_291(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);
  end match;
end lm_291;

protected function lm_292
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Exp i_exp;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);

    case ( txt,
           i_exp :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(txt, i_exp, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = lm_292(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);
  end match;
end lm_292;

protected function lm_293
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Exp i_exp;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);

    case ( txt,
           i_exp :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(txt, i_exp, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = lm_293(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);
  end match;
end lm_293;

protected function lm_294
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Exp i_exp;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);

    case ( txt,
           i_exp :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(txt, i_exp, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = lm_294(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);
  end match;
end lm_294;

protected function lm_295
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Exp i_exp;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);

    case ( txt,
           i_exp :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(txt, i_exp, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = lm_295(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);
  end match;
end lm_295;

protected function lm_296
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Exp i_exp;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);

    case ( txt,
           i_exp :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(txt, i_exp, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = lm_296(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);
  end match;
end lm_296;

protected function fun_297
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;
  input Tpl.Text in_a_expVar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty, in_a_expVar)
    local
      Tpl.Text txt;
      Tpl.Text a_expVar;
      DAE.Type i_ty;
      DAE.Type i_elty;

    case ( txt,
           DAE.T_ARRAY(ty = i_elty),
           a_expVar )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("DynArrayDim1<"));
        txt = expTypeShort(txt, i_elty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(">("));
        txt = Tpl.writeText(txt, a_expVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".getNumElems(), ConstArray("));
        txt = Tpl.writeText(txt, a_expVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(").getData())"));
      then txt;

    case ( txt,
           i_ty,
           a_expVar )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("StatArrayDim1<"));
        txt = expTypeShort(txt, i_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", 1, true>(&"));
        txt = Tpl.writeText(txt, a_expVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;
  end match;
end fun_297;

protected function lm_298
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Exp i_dim;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);

    case ( txt,
           i_dim :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(txt, i_dim, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = lm_298(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);
  end match;
end lm_298;

protected function fun_299
  input Tpl.Text in_txt;
  input DAE.Type in_mArg;
  input Tpl.Text in_a_dimstr;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_dimstr;
algorithm
  (out_txt, out_a_dimstr) :=
  match(in_txt, in_mArg, in_a_dimstr)
    local
      Tpl.Text txt;
      Tpl.Text a_dimstr;
      DAE.Type i_ty;
      DAE.Dimensions i_dims;
      Integer ret_1;
      Integer ret_0;

    case ( txt,
           (i_ty as DAE.T_ARRAY(dims = i_dims)),
           a_dimstr )
      equation
        ret_0 = listLength(i_dims);
        a_dimstr = Tpl.writeStr(a_dimstr, intString(ret_0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("DynArrayDim"));
        ret_1 = listLength(i_dims);
        txt = Tpl.writeStr(txt, intString(ret_1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<"));
        txt = expTypeShort(txt, i_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(">"));
      then (txt, a_dimstr);

    case ( txt,
           _,
           a_dimstr )
      equation
        a_dimstr = Tpl.writeTok(a_dimstr, Tpl.ST_STRING("error array dims"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("array error"));
      then (txt, a_dimstr);
  end match;
end fun_299;

protected function lm_300
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_tvar;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_preExp, in_a_context, in_a_tvar)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      Tpl.Text a_tvar;
      DAE.Exp i_array;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           a_preExp,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);

    case ( txt,
           i_array :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp,
           a_context,
           a_tvar )
      equation
        txt = Tpl.writeText(txt, a_tvar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_list.push_back(&"));
        (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(txt, i_array, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = lm_300(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context, a_tvar);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);
  end match;
end lm_300;

protected function fun_301
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty)
    local
      Tpl.Text txt;

    case ( txt,
           DAE.T_ARRAY(ty = DAE.T_INTEGER(varLst = _)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("int"));
      then txt;

    case ( txt,
           DAE.T_ARRAY(ty = DAE.T_ENUMERATION(index = _)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("int"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("double"));
      then txt;
  end match;
end fun_301;

protected function lm_302
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Exp i_exp;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);

    case ( txt,
           i_exp :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(txt, i_exp, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = lm_302(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);
  end match;
end lm_302;

protected function lm_303
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Exp i_exp;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);

    case ( txt,
           i_exp :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(txt, i_exp, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = lm_303(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);
  end match;
end lm_303;

protected function fun_304
  input Tpl.Text in_txt;
  input Tpl.Text in_a_retVar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_retVar)
    local
      Tpl.Text txt;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}) )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
      then txt;
  end match;
end fun_304;

protected function fun_305
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_a_expLst;
  input Tpl.Text in_a_retVar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_expLst, in_a_retVar)
    local
      Tpl.Text txt;
      Tpl.Text a_retVar;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           _,
           a_retVar )
      equation
        txt = fun_304(txt, a_retVar);
      then txt;
  end match;
end fun_305;

protected function lm_306
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Exp i_exp;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);

    case ( txt,
           i_exp :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(txt, i_exp, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = lm_306(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);
  end match;
end lm_306;

protected function fun_307
  input Tpl.Text in_txt;
  input Tpl.Text in_a_retVar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_retVar)
    local
      Tpl.Text txt;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}) )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
      then txt;
  end match;
end fun_307;

protected function fun_308
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_a_explist;
  input Tpl.Text in_a_retVar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_explist, in_a_retVar)
    local
      Tpl.Text txt;
      Tpl.Text a_retVar;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           _,
           a_retVar )
      equation
        txt = fun_307(txt, a_retVar);
      then txt;
  end match;
end fun_308;

protected function fun_309
  input Tpl.Text in_txt;
  input Tpl.Text in_a_retVar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_retVar)
    local
      Tpl.Text txt;
      Tpl.Text i_retVar;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}) )
      then txt;

    case ( txt,
           i_retVar )
      equation
        txt = Tpl.writeText(txt, i_retVar);
      then txt;
  end match;
end fun_309;

protected function fun_310
  input Tpl.Text in_txt;
  input Tpl.Text in_a_retVar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_retVar)
    local
      Tpl.Text txt;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}) )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
      then txt;
  end match;
end fun_310;

protected function fun_311
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_a_explist;
  input Tpl.Text in_a_retVar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_explist, in_a_retVar)
    local
      Tpl.Text txt;
      Tpl.Text a_retVar;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           _,
           a_retVar )
      equation
        txt = fun_310(txt, a_retVar);
      then txt;
  end match;
end fun_311;

protected function fun_312
  input Tpl.Text in_txt;
  input Tpl.Text in_a_retVar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_retVar)
    local
      Tpl.Text txt;
      Tpl.Text i_retVar;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}) )
      then txt;

    case ( txt,
           i_retVar )
      equation
        txt = Tpl.writeText(txt, i_retVar);
      then txt;
  end match;
end fun_312;

protected function fun_313
  input Tpl.Text in_txt;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_retVar;
  input list<DAE.Exp> in_a_explist;
  input Tpl.Text in_a_argStr;
  input Tpl.Text in_a_funName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_context, in_a_retVar, in_a_explist, in_a_argStr, in_a_funName)
    local
      Tpl.Text txt;
      Tpl.Text a_retVar;
      list<DAE.Exp> a_explist;
      Tpl.Text a_argStr;
      Tpl.Text a_funName;
      SimCodeFunction.Context i_context;

    case ( txt,
           SimCodeFunction.FUNCTION_CONTEXT(cref_prefix = _),
           a_retVar,
           a_explist,
           a_argStr,
           a_funName )
      equation
        txt = Tpl.writeText(txt, a_funName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_argStr);
        txt = fun_308(txt, a_explist, a_retVar);
        txt = fun_309(txt, a_retVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           i_context,
           a_retVar,
           a_explist,
           a_argStr,
           a_funName )
      equation
        txt = contextFunName(txt, Tpl.textString(a_funName), i_context);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_argStr);
        txt = fun_311(txt, a_explist, a_retVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = fun_312(txt, a_retVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;
  end match;
end fun_313;

protected function fun_314
  input Tpl.Text in_txt;
  input String in_mArg;
  input Tpl.Text in_a_funName;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;
  input list<DAE.Exp> in_a_explist;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_mArg, in_a_funName, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_preExp, in_a_context, in_a_explist)
    local
      Tpl.Text txt;
      Tpl.Text a_funName;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      list<DAE.Exp> a_explist;
      Tpl.Text l_retVar;
      Tpl.Text l_retType;
      Tpl.Text l_argStr;

    case ( txt,
           "Modelica_Utilities_Files_loadResource",
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           a_preExp,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\"noName\""));
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);

    case ( txt,
           _,
           a_funName,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp,
           a_context,
           a_explist )
      equation
        l_argStr = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_argStr, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = lm_306(l_argStr, a_explist, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context);
        l_argStr = Tpl.popIter(l_argStr);
        l_retType = Tpl.writeText(Tpl.emptyTxt, a_funName);
        l_retType = Tpl.writeTok(l_retType, Tpl.ST_STRING("RetType /* undefined */"));
        (l_retVar, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(l_retType), a_varDecls);
        a_preExp = fun_313(a_preExp, a_context, l_retVar, a_explist, l_argStr, a_funName);
        txt = Tpl.writeText(txt, l_retVar);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);
  end match;
end fun_314;

public function daeExpCall
  input Tpl.Text in_txt;
  input DAE.Exp in_a_call;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_call, in_a_context, in_a_preExp, in_a_varDecls, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      DAE.Exp i_call;
      list<DAE.Exp> i_explist;
      Integer i_i;
      DAE.Exp i_s1;
      DAE.Exp i_toBeCasted;
      DAE.Exp i_delayMax;
      DAE.Exp i_d;
      DAE.Exp i_e;
      DAE.Exp i_signdig;
      DAE.Exp i_leftjust;
      DAE.Exp i_minlen;
      DAE.Exp i_format;
      DAE.Exp i_s;
      DAE.Exp i_v2;
      DAE.Exp i_v1;
      DAE.Exp i_n;
      DAE.Exp i_A;
      list<DAE.Exp> i_arrays;
      DAE.Exp i_a0;
      DAE.Exp i_dim;
      list<DAE.Exp> i_dims_1;
      DAE.Exp i_val;
      DAE.Exp i_exp;
      DAE.Exp i_array;
      DAE.Exp i_e3;
      Absyn.Path i_path;
      DAE.Type i_attr_ty;
      list<DAE.Exp> i_expLst;
      DAE.Exp i_inExp;
      DAE.Dimensions i_dims;
      DAE.Type i_ty;
      DAE.Exp i_e2;
      Integer i_index;
      DAE.Exp i_interval;
      DAE.Exp i_start;
      Integer i_arg_integer;
      DAE.ComponentRef i_arg_componentRef;
      DAE.Exp i_arg;
      DAE.Exp i_e1;
      Tpl.Text txt_55;
      String str_54;
      Tpl.Text l_expPart;
      Tpl.Text l_castedVar;
      Tpl.Text l_signdigExp;
      Tpl.Text l_leftjustExp;
      Tpl.Text l_minlenExp;
      Tpl.Text l_formatExp;
      Tpl.Text l_sExp;
      Tpl.Text l_emptybuf;
      Tpl.Text l_typeStr;
      Tpl.Text txt_43;
      Integer ret_43;
      Tpl.Text l_type__str;
      Tpl.Text l_tmp;
      Tpl.Text l_arrayType;
      Tpl.Text l_arrays__exp;
      Tpl.Text l_a0str;
      DAE.Type ret_37;
      Tpl.Text l_dimstr;
      Tpl.Text l_dim__exp;
      Integer ret_34;
      Tpl.Text l_tmp__type__str;
      Tpl.Text l_ty__str;
      Tpl.Text l_dimsExp;
      Tpl.Text l_valExp;
      Tpl.Text l_tvar;
      Tpl.Text l_arr__tp__str;
      Tpl.Text l_expVar;
      Tpl.Text l_retVar;
      Tpl.Text l_retType;
      Tpl.Text l_funName;
      Boolean ret_23;
      Tpl.Text l_argStr;
      Tpl.Text l_exp;
      Boolean ret_20;
      SimCodeVar.SimVar ret_19;
      Integer ret_18;
      String ret_17;
      Tpl.Text txt_16;
      Tpl.Text txt_14;
      Integer ret_14;
      Tpl.Text l_var;
      Tpl.Text l_type;
      String ret_11;
      Tpl.Text txt_10;
      Tpl.Text l_var3;
      Tpl.Text l_var2;
      Tpl.Text l_eInterval;
      Tpl.Text l_eStart;
      Tpl.Text l_preExp;
      Integer ret_4;
      list<SimCode.ClockedPartition> ret_3;
      DAE.Exp ret_2;
      DAE.ComponentRef ret_1;
      Tpl.Text l_var1;

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "edge"), expLst = {i_e1}),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (l_var1, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_e1, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_discrete_events.edge("));
        txt = Tpl.writeText(txt, l_var1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "pre"), expLst = {(i_arg as DAE.CREF(componentRef = _))}),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (l_var1, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_arg, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_discrete_events->pre("));
        txt = Tpl.writeText(txt, l_var1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "previous"), expLst = {DAE.CREF(componentRef = i_arg_componentRef)}),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        ret_1 = ComponentReference.crefPrefixPrevious(i_arg_componentRef);
        ret_2 = Expression.crefExp(ret_1);
        (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(txt, ret_2, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "firstTick")),
           a_context,
           a_preExp,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = contextSystem(txt, a_context);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_clockStart[clockIndex - 1] || "));
        txt = contextSystem(txt, a_context);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_clockSubactive[clockIndex - 1])"));
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "interval")),
           a_context,
           a_preExp,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      equation
        txt = contextSystem(txt, a_context);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_clockInterval[clockIndex - 1]"));
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "$_clkfire"), expLst = {DAE.ICONST(integer = i_arg_integer)}),
           _,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_time_conditions["));
        ret_3 = SimCodeUtil.getClockedPartitions(a_simCode);
        ret_4 = SimCodeUtil.absoluteClockIdxForBaseClock(i_arg_integer, ret_3);
        txt = Tpl.writeStr(txt, intString(ret_4));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" - 1 + "));
        txt = timeEventLength(txt, a_simCode);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = (_simTime > _clockTime["));
        txt = Tpl.writeStr(txt, intString(i_arg_integer));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" - 1])"));
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "$getPart"), expLst = {i_e1}),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(txt, i_e1, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "sample"), expLst = {DAE.ICONST(integer = i_index), i_start, i_interval}),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_eStart, l_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_start, SimCodeFunction.contextOther, l_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        (l_eInterval, l_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_interval, SimCodeFunction.contextOther, l_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = fun_275(txt, a_context, i_index);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "initial")),
           a_context,
           a_preExp,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      equation
        txt = fun_276(txt, a_context);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "terminal")),
           a_context,
           a_preExp,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      equation
        txt = fun_277(txt, a_context);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "DIVISION"), expLst = {i_e1, i_e2}),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (l_var1, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_e1, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        (l_var2, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_e2, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt_10 = ExpressionDumpTpl.dumpExp(Tpl.emptyTxt, i_e2, "\"");
        ret_11 = Util.escapeModelicaStringToCString(Tpl.textString(txt_10));
        l_var3 = Tpl.writeStr(Tpl.emptyTxt, ret_11);
        txt = fun_278(txt, a_context, l_var3, l_var2, l_var1);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "sign"), expLst = {i_e1}),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (l_var1, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_e1, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("sgn("));
        txt = Tpl.writeText(txt, l_var1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.CALL(attr = DAE.CALL_ATTR(ty = (i_ty as DAE.T_ARRAY(dims = i_dims))), path = Absyn.IDENT(name = "DIVISION_ARRAY_SCALAR"), expLst = {i_e1, i_e2}),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_type = fun_279(Tpl.emptyTxt, i_ty);
        txt_14 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("multi_array<"));
        txt_14 = Tpl.writeText(txt_14, l_type);
        txt_14 = Tpl.writeTok(txt_14, Tpl.ST_STRING(","));
        ret_14 = listLength(i_dims);
        txt_14 = Tpl.writeStr(txt_14, intString(ret_14));
        txt_14 = Tpl.writeTok(txt_14, Tpl.ST_STRING(">"));
        (l_var, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(txt_14), a_varDecls);
        (l_var1, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_e1, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        (l_var2, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_e2, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt_16 = ExpressionDumpTpl.dumpExp(Tpl.emptyTxt, i_e2, "\"");
        ret_17 = Util.escapeModelicaStringToCString(Tpl.textString(txt_16));
        l_var3 = Tpl.writeStr(Tpl.emptyTxt, ret_17);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("assign_array("));
        a_preExp = Tpl.writeText(a_preExp, l_var);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(",divide_array<"));
        a_preExp = Tpl.writeText(a_preExp, l_type);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(","));
        ret_18 = listLength(i_dims);
        a_preExp = Tpl.writeStr(a_preExp, intString(ret_18));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(">("));
        a_preExp = Tpl.writeText(a_preExp, l_var1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, l_var2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("));"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_var);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "der"), expLst = {DAE.CREF(componentRef = i_arg_componentRef)}),
           _,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      equation
        ret_19 = SimCodeUtil.cref2simvar(i_arg_componentRef, a_simCode);
        l_var = smf_280(Tpl.emptyTxt, ret_19);
        txt = Tpl.writeText(txt, l_var);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "print"), expLst = {i_e1}),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (l_var1, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_e1, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        ret_20 = Config.acceptMetaModelicaGrammar();
        txt = fun_281(txt, ret_20, l_var1);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "integer"), expLst = {i_inExp, _}),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (l_exp, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_inExp, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("integer("));
        txt = Tpl.writeText(txt, l_exp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "floor"), expLst = {i_inExp, _}, attr = DAE.CALL_ATTR(ty = _)),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (l_exp, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_inExp, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("std::floor("));
        txt = Tpl.writeText(txt, l_exp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "floor"), expLst = {i_inExp}, attr = DAE.CALL_ATTR(ty = _)),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (l_exp, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_inExp, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("std::floor("));
        txt = Tpl.writeText(txt, l_exp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "ceil"), expLst = {i_inExp, _}, attr = DAE.CALL_ATTR(ty = _)),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (l_exp, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_inExp, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("std::ceil("));
        txt = Tpl.writeText(txt, l_exp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "ceil"), expLst = {i_inExp}, attr = DAE.CALL_ATTR(ty = _)),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (l_exp, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_inExp, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("std::ceil("));
        txt = Tpl.writeText(txt, l_exp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "integer"), expLst = {i_inExp}),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (l_exp, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_inExp, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("integer("));
        txt = Tpl.writeText(txt, l_exp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "max"), attr = DAE.CALL_ATTR(ty = DAE.T_REAL(varLst = _)), expLst = {i_e1, i_e2}),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (l_var1, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_e1, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        (l_var2, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_e2, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("max("));
        txt = Tpl.writeText(txt, l_var1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, l_var2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "max"), expLst = {i_e1, i_e2}),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (l_var1, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_e1, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        (l_var2, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_e2, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("max("));
        txt = Tpl.writeText(txt, l_var1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, l_var2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.CALL(attr = DAE.CALL_ATTR(ty = DAE.T_REAL(varLst = _)), path = Absyn.IDENT(name = "min"), expLst = {i_e1, i_e2}),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (l_var1, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_e1, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        (l_var2, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_e2, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("min("));
        txt = Tpl.writeText(txt, l_var1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, l_var2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "min"), expLst = {i_e1, i_e2}),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (l_var1, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_e1, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        (l_var2, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_e2, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("min("));
        txt = Tpl.writeText(txt, l_var1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, l_var2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "abs"), expLst = {i_e1}, attr = DAE.CALL_ATTR(ty = DAE.T_INTEGER(varLst = _))),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (l_var1, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_e1, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("std::labs("));
        txt = Tpl.writeText(txt, l_var1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "abs"), expLst = {i_e1}),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (l_var1, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_e1, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("std::abs("));
        txt = Tpl.writeText(txt, l_var1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "sqrt"), expLst = (i_expLst as {i_e1}), attr = DAE.CALL_ATTR(ty = i_attr_ty)),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_argStr = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_argStr, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = lm_282(l_argStr, i_expLst, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context);
        l_argStr = Tpl.popIter(l_argStr);
        ret_23 = Expression.isPositiveOrZero(i_e1);
        (txt, a_preExp, a_varDecls) = fun_283(txt, ret_23, i_attr_ty, a_context, l_argStr, a_preExp, a_varDecls, i_e1);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.CALL(path = (i_path as Absyn.IDENT(name = "sin")), expLst = (i_expLst as {_})),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_argStr = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_argStr, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = lm_284(l_argStr, i_expLst, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context);
        l_argStr = Tpl.popIter(l_argStr);
        l_funName = CodegenUtil.underscorePath(Tpl.emptyTxt, i_path);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("std::"));
        txt = Tpl.writeText(txt, l_funName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, l_argStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.CALL(path = (i_path as Absyn.IDENT(name = "cos")), expLst = (i_expLst as {_})),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_argStr = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_argStr, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = lm_285(l_argStr, i_expLst, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context);
        l_argStr = Tpl.popIter(l_argStr);
        l_funName = CodegenUtil.underscorePath(Tpl.emptyTxt, i_path);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("std::"));
        txt = Tpl.writeText(txt, l_funName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, l_argStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.CALL(path = (i_path as Absyn.IDENT(name = "tan")), expLst = (i_expLst as {_})),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_argStr = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_argStr, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = lm_286(l_argStr, i_expLst, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context);
        l_argStr = Tpl.popIter(l_argStr);
        l_funName = CodegenUtil.underscorePath(Tpl.emptyTxt, i_path);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("std::"));
        txt = Tpl.writeText(txt, l_funName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, l_argStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.CALL(path = (i_path as Absyn.IDENT(name = "asin")), expLst = (i_expLst as {_})),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_argStr = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_argStr, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = lm_287(l_argStr, i_expLst, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context);
        l_argStr = Tpl.popIter(l_argStr);
        l_funName = CodegenUtil.underscorePath(Tpl.emptyTxt, i_path);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("std::"));
        txt = Tpl.writeText(txt, l_funName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, l_argStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.CALL(path = (i_path as Absyn.IDENT(name = "acos")), expLst = (i_expLst as {_})),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_argStr = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_argStr, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = lm_288(l_argStr, i_expLst, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context);
        l_argStr = Tpl.popIter(l_argStr);
        l_funName = CodegenUtil.underscorePath(Tpl.emptyTxt, i_path);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("std::"));
        txt = Tpl.writeText(txt, l_funName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, l_argStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.CALL(path = (i_path as Absyn.IDENT(name = "atan")), expLst = (i_expLst as {_})),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_argStr = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_argStr, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = lm_289(l_argStr, i_expLst, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context);
        l_argStr = Tpl.popIter(l_argStr);
        l_funName = CodegenUtil.underscorePath(Tpl.emptyTxt, i_path);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("std::"));
        txt = Tpl.writeText(txt, l_funName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, l_argStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.CALL(path = (i_path as Absyn.IDENT(name = "sinh")), expLst = (i_expLst as {_})),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_argStr = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_argStr, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = lm_290(l_argStr, i_expLst, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context);
        l_argStr = Tpl.popIter(l_argStr);
        l_funName = CodegenUtil.underscorePath(Tpl.emptyTxt, i_path);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("std::"));
        txt = Tpl.writeText(txt, l_funName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, l_argStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.CALL(path = (i_path as Absyn.IDENT(name = "cosh")), expLst = (i_expLst as {_})),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_argStr = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_argStr, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = lm_291(l_argStr, i_expLst, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context);
        l_argStr = Tpl.popIter(l_argStr);
        l_funName = CodegenUtil.underscorePath(Tpl.emptyTxt, i_path);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("std::"));
        txt = Tpl.writeText(txt, l_funName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, l_argStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.CALL(path = (i_path as Absyn.IDENT(name = "tanh")), expLst = (i_expLst as {_})),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_argStr = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_argStr, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = lm_292(l_argStr, i_expLst, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context);
        l_argStr = Tpl.popIter(l_argStr);
        l_funName = CodegenUtil.underscorePath(Tpl.emptyTxt, i_path);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("std::"));
        txt = Tpl.writeText(txt, l_funName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, l_argStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.CALL(path = (i_path as Absyn.IDENT(name = "exp")), expLst = (i_expLst as {_})),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_argStr = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_argStr, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = lm_293(l_argStr, i_expLst, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context);
        l_argStr = Tpl.popIter(l_argStr);
        l_funName = CodegenUtil.underscorePath(Tpl.emptyTxt, i_path);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("std::"));
        txt = Tpl.writeText(txt, l_funName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, l_argStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.CALL(path = (i_path as Absyn.IDENT(name = "log")), expLst = (i_expLst as {_})),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_argStr = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_argStr, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = lm_294(l_argStr, i_expLst, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context);
        l_argStr = Tpl.popIter(l_argStr);
        l_funName = CodegenUtil.underscorePath(Tpl.emptyTxt, i_path);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("std::"));
        txt = Tpl.writeText(txt, l_funName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, l_argStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.CALL(path = (i_path as Absyn.IDENT(name = "log10")), expLst = (i_expLst as {_})),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_argStr = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_argStr, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = lm_295(l_argStr, i_expLst, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context);
        l_argStr = Tpl.popIter(l_argStr);
        l_funName = CodegenUtil.underscorePath(Tpl.emptyTxt, i_path);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("std::"));
        txt = Tpl.writeText(txt, l_funName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, l_argStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "atan2"), expLst = (i_expLst as {_, _}), attr = DAE.CALL_ATTR(ty = _)),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_argStr = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_argStr, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = lm_296(l_argStr, i_expLst, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context);
        l_argStr = Tpl.popIter(l_argStr);
        l_retType = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("double"));
        (l_retVar, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(l_retType), a_varDecls);
        a_preExp = Tpl.writeText(a_preExp, l_retVar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = std::atan2("));
        a_preExp = Tpl.writeText(a_preExp, l_argStr);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_retVar);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "smooth"), expLst = {i_e1, i_e2}, attr = DAE.CALL_ATTR(ty = _)),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (l_var1, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_e1, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        (l_var2, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_e2, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeText(txt, l_var2);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "homotopy"), expLst = {i_e1, i_e2}, attr = DAE.CALL_ATTR(ty = _)),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (l_var1, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_e1, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        (l_var2, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_e2, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeText(txt, l_var1);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "homotopyParameter"), expLst = {}, attr = DAE.CALL_ATTR(ty = _)),
           _,
           a_preExp,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("1.0"));
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "div"), expLst = {i_e1, i_e2}, attr = DAE.CALL_ATTR(ty = DAE.T_INTEGER(varLst = _))),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (l_var1, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_e1, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        (l_var2, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_e2, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("ldiv("));
        txt = Tpl.writeText(txt, l_var1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, l_var2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(").quot"));
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "div"), expLst = {i_e1, i_e2}),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (l_var1, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_e1, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        (l_var2, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_e2, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("omcpp::trunc("));
        txt = Tpl.writeText(txt, l_var1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/"));
        txt = Tpl.writeText(txt, l_var2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "div"), expLst = {i_e1, i_e2, _}),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (l_var1, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_e1, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        (l_var2, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_e2, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("omcpp::trunc("));
        txt = Tpl.writeText(txt, l_var1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/"));
        txt = Tpl.writeText(txt, l_var2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "mod"), expLst = {i_e1, i_e2, _}, attr = DAE.CALL_ATTR(ty = i_attr_ty)),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (l_var1, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_e1, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        (l_var2, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_e2, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_mod_"));
        txt = expTypeShort(txt, i_attr_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, l_var1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, l_var2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "mod"), expLst = {i_e1, i_e2}, attr = DAE.CALL_ATTR(ty = i_attr_ty)),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (l_var1, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_e1, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        (l_var2, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_e2, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_mod_"));
        txt = expTypeShort(txt, i_attr_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, l_var1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, l_var2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "semiLinear"), expLst = {i_e1, i_e2, i_e3}, attr = DAE.CALL_ATTR(ty = _)),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (l_var1, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_e1, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        (l_var2, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_e2, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        (l_var3, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_e3, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("semiLinear("));
        txt = Tpl.writeText(txt, l_var1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, l_var2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, l_var3);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "max"), attr = DAE.CALL_ATTR(ty = i_ty), expLst = {i_array}),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (l_expVar, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_array, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        l_arr__tp__str = expTypeShort(Tpl.emptyTxt, i_ty);
        (l_tvar, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(l_arr__tp__str), a_varDecls);
        a_preExp = Tpl.writeText(a_preExp, l_tvar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = min_max<"));
        a_preExp = Tpl.writeText(a_preExp, l_arr__tp__str);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(">("));
        a_preExp = Tpl.writeText(a_preExp, l_expVar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(").second;"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tvar);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "sum"), attr = DAE.CALL_ATTR(ty = i_ty), expLst = {i_array}),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (l_expVar, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_array, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        l_arr__tp__str = expTypeShort(Tpl.emptyTxt, i_ty);
        (l_tvar, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(l_arr__tp__str), a_varDecls);
        a_preExp = Tpl.writeText(a_preExp, l_tvar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = sum_array<"));
        a_preExp = Tpl.writeText(a_preExp, l_arr__tp__str);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(">("));
        a_preExp = Tpl.writeText(a_preExp, l_expVar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tvar);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "min"), attr = DAE.CALL_ATTR(ty = i_ty), expLst = {i_array}),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (l_expVar, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_array, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        l_arr__tp__str = expTypeShort(Tpl.emptyTxt, i_ty);
        (l_tvar, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(l_arr__tp__str), a_varDecls);
        a_preExp = Tpl.writeText(a_preExp, l_tvar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = min_max<"));
        a_preExp = Tpl.writeText(a_preExp, l_arr__tp__str);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(">("));
        a_preExp = Tpl.writeText(a_preExp, l_expVar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(").first;"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tvar);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "vector"), expLst = {i_exp}, attr = DAE.CALL_ATTR(ty = i_ty)),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (l_expVar, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_exp, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        l_tvar = fun_297(Tpl.emptyTxt, i_ty, l_expVar);
        txt = Tpl.writeText(txt, l_tvar);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "fill"), expLst = i_val :: i_dims_1, attr = DAE.CALL_ATTR(ty = i_attr_ty)),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (l_valExp, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_val, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        l_dimsExp = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_dimsExp, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = lm_298(l_dimsExp, i_dims_1, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context);
        l_dimsExp = Tpl.popIter(l_dimsExp);
        l_ty__str = expTypeShort(Tpl.emptyTxt, i_attr_ty);
        l_tmp__type__str = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("DynArrayDim"));
        ret_34 = listLength(i_dims_1);
        l_tmp__type__str = Tpl.writeStr(l_tmp__type__str, intString(ret_34));
        l_tmp__type__str = Tpl.writeTok(l_tmp__type__str, Tpl.ST_STRING("<"));
        l_tmp__type__str = Tpl.writeText(l_tmp__type__str, l_ty__str);
        l_tmp__type__str = Tpl.writeTok(l_tmp__type__str, Tpl.ST_STRING(">"));
        (l_tvar, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(l_tmp__type__str), a_varDecls);
        a_preExp = Tpl.writeText(a_preExp, l_tvar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(".setDims("));
        a_preExp = Tpl.writeText(a_preExp, l_dimsExp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("fill_array<"));
        a_preExp = Tpl.writeText(a_preExp, l_ty__str);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(">("));
        a_preExp = Tpl.writeText(a_preExp, l_tvar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, l_valExp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tvar);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "cat"), expLst = i_dim :: i_a0 :: i_arrays, attr = DAE.CALL_ATTR(ty = i_attr_ty)),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (l_dim__exp, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_dim, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        l_dimstr = Tpl.emptyTxt;
        ret_37 = Expression.typeof(i_a0);
        (l_tmp__type__str, l_dimstr) = fun_299(Tpl.emptyTxt, ret_37, l_dimstr);
        l_ty__str = expTypeShort(Tpl.emptyTxt, i_attr_ty);
        (l_tvar, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(l_tmp__type__str), a_varDecls);
        (l_a0str, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_a0, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        l_arrays__exp = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_arrays__exp, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = lm_300(l_arrays__exp, i_arrays, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context, l_tvar);
        l_arrays__exp = Tpl.popIter(l_arrays__exp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("vector<const BaseArray<"));
        a_preExp = Tpl.writeText(a_preExp, l_ty__str);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(">*> "));
        a_preExp = Tpl.writeText(a_preExp, l_tvar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_LINE("_list;\n"));
        a_preExp = Tpl.writeText(a_preExp, l_tvar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("_list.push_back(&"));
        a_preExp = Tpl.writeText(a_preExp, l_a0str);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_LINE(");\n"));
        a_preExp = Tpl.writeText(a_preExp, l_arrays__exp);
        a_preExp = Tpl.softNewLine(a_preExp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("cat_array<"));
        a_preExp = Tpl.writeText(a_preExp, l_ty__str);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(">("));
        a_preExp = Tpl.writeText(a_preExp, l_dim__exp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, l_tvar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("_list, "));
        a_preExp = Tpl.writeText(a_preExp, l_tvar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tvar);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "promote"), expLst = {i_A, i_n}, attr = DAE.CALL_ATTR(ty = i_ty)),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (l_var1, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_A, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        (l_var2, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_n, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        l_arrayType = expTypeArrayIf(Tpl.emptyTxt, i_ty);
        (l_tmp, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(l_arrayType), a_varDecls);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("promote_array("));
        a_preExp = Tpl.writeText(a_preExp, l_var2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, l_var1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, l_tmp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "transpose"), expLst = {i_A}),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (l_var1, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_A, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        l_type__str = expTypeFromExpShort(Tpl.emptyTxt, i_A);
        l_arr__tp__str = expTypeFromExpArray(Tpl.emptyTxt, i_A);
        (l_tvar, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(l_arr__tp__str), a_varDecls);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("transpose_array<"));
        a_preExp = Tpl.writeText(a_preExp, l_type__str);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(">("));
        a_preExp = Tpl.writeText(a_preExp, l_var1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, l_tvar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tvar);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "cross"), expLst = {i_v1, i_v2}, attr = DAE.CALL_ATTR(ty = (i_ty as DAE.T_ARRAY(dims = i_dims)))),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (l_var1, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_v1, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        (l_var2, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_v2, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        l_type = fun_301(Tpl.emptyTxt, i_ty);
        txt_43 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("multi_array<"));
        txt_43 = Tpl.writeText(txt_43, l_type);
        txt_43 = Tpl.writeTok(txt_43, Tpl.ST_STRING(","));
        ret_43 = listLength(i_dims);
        txt_43 = Tpl.writeStr(txt_43, intString(ret_43));
        txt_43 = Tpl.writeTok(txt_43, Tpl.ST_STRING(">"));
        (l_tvar, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(txt_43), a_varDecls);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("assign_array("));
        a_preExp = Tpl.writeText(a_preExp, l_tvar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(",cross_array<"));
        a_preExp = Tpl.writeText(a_preExp, l_type);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(">("));
        a_preExp = Tpl.writeText(a_preExp, l_var1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(","));
        a_preExp = Tpl.writeText(a_preExp, l_var2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("));"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tvar);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "identity"), expLst = {i_A}),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (l_var1, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_A, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        (l_tvar, a_varDecls) = tempDecl(Tpl.emptyTxt, "DynArrayDim2<int>", a_varDecls);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("identity_alloc("));
        a_preExp = Tpl.writeText(a_preExp, l_var1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, l_tvar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tvar);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "rem"), expLst = {i_e1, i_e2}),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (l_var1, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_e1, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        (l_var2, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_e2, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        l_typeStr = expTypeFromExpShort(Tpl.emptyTxt, i_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_rem_"));
        txt = Tpl.writeText(txt, l_typeStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, l_var1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, l_var2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "String"), expLst = {i_s, i_format}),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_emptybuf = Tpl.emptyTxt;
        (l_tvar, a_varDecls) = tempDecl(Tpl.emptyTxt, "string", a_varDecls);
        (l_sExp, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_s, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        (l_formatExp, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_format, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        l_typeStr = expTypeFromExpModelica(Tpl.emptyTxt, i_s);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("string "));
        a_preExp = Tpl.writeText(a_preExp, l_tvar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = omcpp::to_string("));
        a_preExp = Tpl.writeText(a_preExp, l_sExp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tvar);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "String"), expLst = {i_s, i_minlen, i_leftjust}),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_emptybuf = Tpl.emptyTxt;
        (l_tvar, l_emptybuf) = tempDecl(Tpl.emptyTxt, "string", l_emptybuf);
        (l_sExp, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_s, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        (l_minlenExp, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_minlen, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        (l_leftjustExp, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_leftjust, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        l_typeStr = expTypeFromExpModelica(Tpl.emptyTxt, i_s);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("string "));
        a_preExp = Tpl.writeText(a_preExp, l_tvar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = omcpp::to_string("));
        a_preExp = Tpl.writeText(a_preExp, l_sExp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tvar);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "String"), expLst = {i_s, i_minlen, i_leftjust, i_signdig}),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_emptybuf = Tpl.emptyTxt;
        (l_tvar, l_emptybuf) = tempDecl(Tpl.emptyTxt, "string", l_emptybuf);
        (l_sExp, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_s, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        (l_minlenExp, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_minlen, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        (l_leftjustExp, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_leftjust, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        (l_signdigExp, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_signdig, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("string "));
        a_preExp = Tpl.writeText(a_preExp, l_tvar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = omcpp::to_string("));
        a_preExp = Tpl.writeText(a_preExp, l_sExp);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tvar);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "delay"), expLst = {DAE.ICONST(integer = i_index), i_e, i_d, i_delayMax}),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (l_tvar, a_varDecls) = tempDecl(Tpl.emptyTxt, "double", a_varDecls);
        (l_var1, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_e, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        (l_var2, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_d, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        (l_var3, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_delayMax, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        a_preExp = Tpl.writeText(a_preExp, l_tvar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = delay("));
        a_preExp = Tpl.writeStr(a_preExp, intString(i_index));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, l_var1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(",  "));
        a_preExp = Tpl.writeText(a_preExp, l_var2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, l_var3);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tvar);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "integer"), expLst = {i_toBeCasted}),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (l_castedVar, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_toBeCasted, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("((int)"));
        txt = Tpl.writeText(txt, l_castedVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "Integer"), expLst = {i_toBeCasted}),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (l_castedVar, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_toBeCasted, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("((int)"));
        txt = Tpl.writeText(txt, l_castedVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "clock"), expLst = {}),
           _,
           a_preExp,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("mmc_clock()"));
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "noEvent"), expLst = {i_e1}),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(txt, i_e1, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "anyString"), expLst = {i_e1}),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("mmc_anyString("));
        (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(txt, i_e1, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "mmc_get_field"), expLst = {i_s1, DAE.ICONST(integer = i_i)}),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (l_tvar, a_varDecls) = tempDecl(Tpl.emptyTxt, "modelica_metatype", a_varDecls);
        (l_expPart, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_s1, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        a_preExp = Tpl.writeText(a_preExp, l_tvar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" = MMC_FETCH(MMC_OFFSET(MMC_UNTAGPTR("));
        a_preExp = Tpl.writeText(a_preExp, l_expPart);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("), "));
        a_preExp = Tpl.writeStr(a_preExp, intString(i_i));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("));"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tvar);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.CALL(attr = DAE.CALL_ATTR(ty = DAE.T_NORETCALL()), expLst = i_expLst, path = i_path),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_argStr = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_argStr, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = lm_302(l_argStr, i_expLst, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context);
        l_argStr = Tpl.popIter(l_argStr);
        l_funName = CodegenUtil.underscorePath(Tpl.emptyTxt, i_path);
        a_preExp = contextFunName(a_preExp, Tpl.textString(l_funName), a_context);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("("));
        a_preExp = Tpl.writeText(a_preExp, l_argStr);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.CALL(attr = DAE.CALL_ATTR(ty = DAE.T_ARRAY(ty = _, dims = _)), expLst = i_expLst, path = i_path),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_argStr = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_argStr, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = lm_303(l_argStr, i_expLst, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context);
        l_argStr = Tpl.popIter(l_argStr);
        l_funName = CodegenUtil.underscorePath(Tpl.emptyTxt, i_path);
        l_retType = Tpl.writeText(Tpl.emptyTxt, l_funName);
        l_retType = Tpl.writeTok(l_retType, Tpl.ST_STRING("RetType /* undefined */"));
        (l_retVar, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(l_retType), a_varDecls);
        a_preExp = contextFunName(a_preExp, Tpl.textString(l_funName), a_context);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("("));
        a_preExp = Tpl.writeText(a_preExp, l_argStr);
        a_preExp = fun_305(a_preExp, i_expLst, l_retVar);
        a_preExp = Tpl.writeText(a_preExp, l_retVar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_retVar);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.CALL(expLst = i_explist, attr = DAE.CALL_ATTR(ty = _), path = i_path),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_funName = CodegenUtil.underscorePath(Tpl.emptyTxt, i_path);
        str_54 = Tpl.textString(l_funName);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = fun_314(txt, str_54, l_funName, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context, i_explist);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           i_call,
           _,
           a_preExp,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      equation
        txt_55 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("Code generation does not support daeExpCall("));
        txt_55 = ExpressionDumpTpl.dumpExp(txt_55, i_call, "\"");
        txt_55 = Tpl.writeTok(txt_55, Tpl.ST_STRING(")"));
        txt = error(txt, Tpl.sourceInfo("CodegenCppCommon.tpl", 2186, 11), Tpl.textString(txt_55));
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end daeExpCall;

protected function fun_316
  input Tpl.Text in_txt;
  input DAE.Operator in_a_operator;
  input Tpl.Text in_a_e;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_operator, in_a_e)
    local
      Tpl.Text txt;
      Tpl.Text a_e;

    case ( txt,
           DAE.NOT(ty = _),
           a_e )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(!"));
        txt = Tpl.writeText(txt, a_e);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_316;

public function daeExpLunary
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_exp, in_a_context, in_a_preExp, in_a_varDecls, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      DAE.Operator i_operator;
      DAE.Exp i_exp;
      Tpl.Text l_e;

    case ( txt,
           DAE.LUNARY(exp = i_exp, operator = i_operator),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (l_e, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_exp, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = fun_316(txt, i_operator, l_e);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           a_preExp,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end daeExpLunary;

protected function fun_318
  input Tpl.Text in_txt;
  input DAE.Operator in_a_operator;
  input Tpl.Text in_a_e2;
  input Tpl.Text in_a_e1;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_operator, in_a_e2, in_a_e1)
    local
      Tpl.Text txt;
      Tpl.Text a_e2;
      Tpl.Text a_e1;

    case ( txt,
           DAE.AND(ty = _),
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" && "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.OR(ty = _),
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" || "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("daeExpLbinary:ERR"));
      then txt;
  end match;
end fun_318;

public function daeExpLbinary
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_exp, in_a_context, in_a_preExp, in_a_varDecls, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      DAE.Operator i_operator;
      DAE.Exp i_exp2;
      DAE.Exp i_exp1;
      Tpl.Text l_e2;
      Tpl.Text l_e1;

    case ( txt,
           DAE.LBINARY(exp1 = i_exp1, exp2 = i_exp2, operator = i_operator),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (l_e1, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_exp1, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        (l_e2, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_exp2, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = fun_318(txt, i_operator, l_e2, l_e1);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           a_preExp,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end daeExpLbinary;

protected function fun_320
  input Tpl.Text in_txt;
  input Integer in_a_flag;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_flag)
    local
      Tpl.Text txt;

    case ( txt,
           8 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("int"));
      then txt;

    case ( txt,
           1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("int"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("int"));
      then txt;
  end match;
end fun_320;

protected function fun_321
  input Tpl.Text in_txt;
  input Integer in_a_flag;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_flag)
    local
      Tpl.Text txt;

    case ( txt,
           1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("double"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("double"));
      then txt;
  end match;
end fun_321;

protected function fun_322
  input Tpl.Text in_txt;
  input Integer in_a_flag;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_flag)
    local
      Tpl.Text txt;

    case ( txt,
           1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("string"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_string"));
      then txt;
  end match;
end fun_322;

protected function fun_323
  input Tpl.Text in_txt;
  input Integer in_a_flag;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_flag)
    local
      Tpl.Text txt;

    case ( txt,
           1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("metatype"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_metatype"));
      then txt;
  end match;
end fun_323;

protected function fun_324
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_flag;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_flag)
    local
      Tpl.Text txt;
      Integer a_flag;

    case ( txt,
           false,
           a_flag )
      equation
        txt = fun_322(txt, a_flag);
      then txt;

    case ( txt,
           _,
           a_flag )
      equation
        txt = fun_323(txt, a_flag);
      then txt;
  end match;
end fun_324;

protected function fun_325
  input Tpl.Text in_txt;
  input Integer in_a_flag;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_flag)
    local
      Tpl.Text txt;

    case ( txt,
           1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("bool"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_boolean"));
      then txt;
  end match;
end fun_325;

protected function fun_326
  input Tpl.Text in_txt;
  input Integer in_a_flag;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_flag)
    local
      Tpl.Text txt;

    case ( txt,
           8 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("int"));
      then txt;

    case ( txt,
           1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("int"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("int"));
      then txt;
  end match;
end fun_326;

protected function fun_327
  input Tpl.Text in_txt;
  input Integer in_a_flag;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_flag)
    local
      Tpl.Text txt;

    case ( txt,
           1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("metatype"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_metatype"));
      then txt;
  end match;
end fun_327;

protected function fun_328
  input Tpl.Text in_txt;
  input Integer in_a_flag;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_flag)
    local
      Tpl.Text txt;

    case ( txt,
           1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("metatype"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_metatype"));
      then txt;
  end match;
end fun_328;

protected function fun_329
  input Tpl.Text in_txt;
  input Integer in_a_flag;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_flag)
    local
      Tpl.Text txt;

    case ( txt,
           1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("metatype"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_metatype"));
      then txt;
  end match;
end fun_329;

protected function fun_330
  input Tpl.Text in_txt;
  input Integer in_a_flag;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_flag)
    local
      Tpl.Text txt;

    case ( txt,
           1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("metatype"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_metatype"));
      then txt;
  end match;
end fun_330;

protected function fun_331
  input Tpl.Text in_txt;
  input Integer in_a_flag;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_flag)
    local
      Tpl.Text txt;

    case ( txt,
           1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("metatype"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_metatype"));
      then txt;
  end match;
end fun_331;

public function expTypeFromExpFlag
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input Integer in_a_flag;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_exp, in_a_flag)
    local
      Tpl.Text txt;
      Integer a_flag;
      DAE.Exp i_c_exp;
      DAE.Exp i_e;
      DAE.Exp i_exp;
      DAE.Type i_c_ty;
      DAE.Type i_attr_ty;
      DAE.Exp i_expThen;
      DAE.Operator i_e_operator;
      DAE.Type ret_4;
      DAE.Type ret_3;
      DAE.Type ret_2;
      DAE.Type ret_1;
      Boolean ret_0;

    case ( txt,
           DAE.ICONST(integer = _),
           a_flag )
      equation
        txt = fun_320(txt, a_flag);
      then txt;

    case ( txt,
           DAE.RCONST(real = _),
           a_flag )
      equation
        txt = fun_321(txt, a_flag);
      then txt;

    case ( txt,
           DAE.SCONST(string = _),
           a_flag )
      equation
        ret_0 = Config.acceptMetaModelicaGrammar();
        txt = fun_324(txt, ret_0, a_flag);
      then txt;

    case ( txt,
           DAE.BCONST(bool = _),
           a_flag )
      equation
        txt = fun_325(txt, a_flag);
      then txt;

    case ( txt,
           DAE.ENUM_LITERAL(name = _),
           a_flag )
      equation
        txt = fun_326(txt, a_flag);
      then txt;

    case ( txt,
           DAE.BINARY(operator = i_e_operator),
           a_flag )
      equation
        txt = expTypeFromOpFlag(txt, i_e_operator, a_flag);
      then txt;

    case ( txt,
           DAE.UNARY(operator = i_e_operator),
           a_flag )
      equation
        txt = expTypeFromOpFlag(txt, i_e_operator, a_flag);
      then txt;

    case ( txt,
           DAE.LBINARY(operator = i_e_operator),
           a_flag )
      equation
        txt = expTypeFromOpFlag(txt, i_e_operator, a_flag);
      then txt;

    case ( txt,
           DAE.LUNARY(operator = i_e_operator),
           a_flag )
      equation
        txt = expTypeFromOpFlag(txt, i_e_operator, a_flag);
      then txt;

    case ( txt,
           DAE.RELATION(operator = i_e_operator),
           a_flag )
      equation
        txt = expTypeFromOpFlag(txt, i_e_operator, a_flag);
      then txt;

    case ( txt,
           DAE.IFEXP(expThen = i_expThen),
           a_flag )
      equation
        txt = expTypeFromExpFlag(txt, i_expThen, a_flag);
      then txt;

    case ( txt,
           DAE.CALL(attr = DAE.CALL_ATTR(ty = i_attr_ty)),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_attr_ty, a_flag);
      then txt;

    case ( txt,
           DAE.RECORD(ty = i_c_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_c_ty, a_flag);
      then txt;

    case ( txt,
           DAE.ARRAY(ty = i_c_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_c_ty, a_flag);
      then txt;

    case ( txt,
           DAE.MATRIX(ty = i_c_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_c_ty, a_flag);
      then txt;

    case ( txt,
           DAE.RANGE(ty = i_c_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_c_ty, a_flag);
      then txt;

    case ( txt,
           DAE.CAST(ty = i_c_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_c_ty, a_flag);
      then txt;

    case ( txt,
           DAE.CREF(ty = i_c_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_c_ty, a_flag);
      then txt;

    case ( txt,
           DAE.CODE(ty = i_c_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_c_ty, a_flag);
      then txt;

    case ( txt,
           DAE.ASUB(exp = i_exp),
           a_flag )
      equation
        txt = expTypeFromExpFlag(txt, i_exp, a_flag);
      then txt;

    case ( txt,
           (i_exp as DAE.REDUCTION(reductionInfo = _)),
           a_flag )
      equation
        ret_1 = Expression.typeof(i_exp);
        txt = expTypeFlag(txt, ret_1, a_flag);
      then txt;

    case ( txt,
           (i_e as DAE.CONS(car = _)),
           a_flag )
      equation
        ret_2 = Expression.typeof(i_e);
        txt = expTypeFlag(txt, ret_2, a_flag);
      then txt;

    case ( txt,
           (i_e as DAE.LIST(valList = _)),
           a_flag )
      equation
        ret_3 = Expression.typeof(i_e);
        txt = expTypeFlag(txt, ret_3, a_flag);
      then txt;

    case ( txt,
           (i_e as DAE.SIZE(exp = _)),
           a_flag )
      equation
        ret_4 = Expression.typeof(i_e);
        txt = expTypeFlag(txt, ret_4, a_flag);
      then txt;

    case ( txt,
           DAE.META_TUPLE(listExp = _),
           a_flag )
      equation
        txt = fun_327(txt, a_flag);
      then txt;

    case ( txt,
           DAE.META_OPTION(exp = _),
           a_flag )
      equation
        txt = fun_328(txt, a_flag);
      then txt;

    case ( txt,
           DAE.MATCHEXPRESSION(matchType = _),
           a_flag )
      equation
        txt = fun_329(txt, a_flag);
      then txt;

    case ( txt,
           DAE.METARECORDCALL(path = _),
           a_flag )
      equation
        txt = fun_330(txt, a_flag);
      then txt;

    case ( txt,
           DAE.BOX(exp = _),
           a_flag )
      equation
        txt = fun_331(txt, a_flag);
      then txt;

    case ( txt,
           DAE.UNBOX(ty = i_c_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_c_ty, a_flag);
      then txt;

    case ( txt,
           DAE.SHARED_LITERAL(exp = i_c_exp),
           a_flag )
      equation
        txt = expTypeFromExpFlag(txt, i_c_exp, a_flag);
      then txt;

    case ( txt,
           i_exp,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("ERROR:expTypeFromExpFlag "));
        txt = ExpressionDumpTpl.dumpExp(txt, i_exp, "\"");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
      then txt;
  end match;
end expTypeFromExpFlag;

protected function fun_333
  input Tpl.Text in_txt;
  input Integer in_a_flag;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_flag)
    local
      Tpl.Text txt;

    case ( txt,
           1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("bool"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_boolean"));
      then txt;
  end match;
end fun_333;

protected function fun_334
  input Tpl.Text in_txt;
  input Integer in_a_flag;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_flag)
    local
      Tpl.Text txt;

    case ( txt,
           1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("bool"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_boolean"));
      then txt;
  end match;
end fun_334;

protected function fun_335
  input Tpl.Text in_txt;
  input Integer in_a_flag;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_flag)
    local
      Tpl.Text txt;

    case ( txt,
           1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("bool"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_boolean"));
      then txt;
  end match;
end fun_335;

public function expTypeFromOpFlag
  input Tpl.Text in_txt;
  input DAE.Operator in_a_op;
  input Integer in_a_flag;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_op, in_a_flag)
    local
      Tpl.Text txt;
      Integer a_flag;
      DAE.Type i_o_ty;

    case ( txt,
           DAE.ADD(ty = i_o_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_o_ty, a_flag);
      then txt;

    case ( txt,
           DAE.SUB(ty = i_o_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_o_ty, a_flag);
      then txt;

    case ( txt,
           DAE.MUL(ty = i_o_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_o_ty, a_flag);
      then txt;

    case ( txt,
           DAE.DIV(ty = i_o_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_o_ty, a_flag);
      then txt;

    case ( txt,
           DAE.POW(ty = i_o_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_o_ty, a_flag);
      then txt;

    case ( txt,
           DAE.UMINUS(ty = i_o_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_o_ty, a_flag);
      then txt;

    case ( txt,
           DAE.UMINUS_ARR(ty = i_o_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_o_ty, a_flag);
      then txt;

    case ( txt,
           DAE.ADD_ARR(ty = i_o_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_o_ty, a_flag);
      then txt;

    case ( txt,
           DAE.SUB_ARR(ty = i_o_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_o_ty, a_flag);
      then txt;

    case ( txt,
           DAE.MUL_ARR(ty = i_o_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_o_ty, a_flag);
      then txt;

    case ( txt,
           DAE.DIV_ARR(ty = i_o_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_o_ty, a_flag);
      then txt;

    case ( txt,
           DAE.MUL_ARRAY_SCALAR(ty = i_o_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_o_ty, a_flag);
      then txt;

    case ( txt,
           DAE.ADD_ARRAY_SCALAR(ty = i_o_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_o_ty, a_flag);
      then txt;

    case ( txt,
           DAE.SUB_SCALAR_ARRAY(ty = i_o_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_o_ty, a_flag);
      then txt;

    case ( txt,
           DAE.MUL_SCALAR_PRODUCT(ty = i_o_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_o_ty, a_flag);
      then txt;

    case ( txt,
           DAE.MUL_MATRIX_PRODUCT(ty = i_o_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_o_ty, a_flag);
      then txt;

    case ( txt,
           DAE.DIV_ARRAY_SCALAR(ty = i_o_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_o_ty, a_flag);
      then txt;

    case ( txt,
           DAE.DIV_SCALAR_ARRAY(ty = i_o_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_o_ty, a_flag);
      then txt;

    case ( txt,
           DAE.POW_ARRAY_SCALAR(ty = i_o_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_o_ty, a_flag);
      then txt;

    case ( txt,
           DAE.POW_SCALAR_ARRAY(ty = i_o_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_o_ty, a_flag);
      then txt;

    case ( txt,
           DAE.POW_ARR(ty = i_o_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_o_ty, a_flag);
      then txt;

    case ( txt,
           DAE.POW_ARR2(ty = i_o_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_o_ty, a_flag);
      then txt;

    case ( txt,
           DAE.LESS(ty = i_o_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_o_ty, a_flag);
      then txt;

    case ( txt,
           DAE.LESSEQ(ty = i_o_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_o_ty, a_flag);
      then txt;

    case ( txt,
           DAE.GREATER(ty = i_o_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_o_ty, a_flag);
      then txt;

    case ( txt,
           DAE.GREATEREQ(ty = i_o_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_o_ty, a_flag);
      then txt;

    case ( txt,
           DAE.EQUAL(ty = i_o_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_o_ty, a_flag);
      then txt;

    case ( txt,
           DAE.NEQUAL(ty = i_o_ty),
           a_flag )
      equation
        txt = expTypeFlag(txt, i_o_ty, a_flag);
      then txt;

    case ( txt,
           DAE.AND(ty = _),
           a_flag )
      equation
        txt = fun_333(txt, a_flag);
      then txt;

    case ( txt,
           DAE.OR(ty = _),
           a_flag )
      equation
        txt = fun_334(txt, a_flag);
      then txt;

    case ( txt,
           DAE.NOT(ty = _),
           a_flag )
      equation
        txt = fun_335(txt, a_flag);
      then txt;

    case ( txt,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("expTypeFromOpFlag:ERROR"));
      then txt;
  end match;
end expTypeFromOpFlag;

protected function fun_337
  input Tpl.Text in_txt;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_e2str;
  input Tpl.Text in_a_e2;
  input Tpl.Text in_a_e1;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_context, in_a_e2str, in_a_e2, in_a_e1)
    local
      Tpl.Text txt;
      Tpl.Text a_e2str;
      Tpl.Text a_e2;
      Tpl.Text a_e1;

    case ( txt,
           SimCodeFunction.ALGLOOP_CONTEXT(genInitialisation = false),
           a_e2str,
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("division("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(",!_system->_initial,\""));
        txt = Tpl.writeText(txt, a_e2str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\")"));
      then txt;

    case ( txt,
           _,
           a_e2str,
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("division("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(",!_initial,\""));
        txt = Tpl.writeText(txt, a_e2str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\")"));
      then txt;
  end match;
end fun_337;

protected function fun_338
  input Tpl.Text in_txt;
  input DAE.Operator in_a_it;
  input DAE.Exp in_a_exp1;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input SimCodeFunction.Context in_a_context;
  input DAE.Exp in_a_exp2;
  input Tpl.Text in_a_e2;
  input Tpl.Text in_a_e1;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls) :=
  match(in_txt, in_a_it, in_a_exp1, in_a_preExp, in_a_varDecls, in_a_context, in_a_exp2, in_a_e2, in_a_e1)
    local
      Tpl.Text txt;
      DAE.Exp a_exp1;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      SimCodeFunction.Context a_context;
      DAE.Exp a_exp2;
      Tpl.Text a_e2;
      Tpl.Text a_e1;
      DAE.Operator i_it;
      DAE.Type i_ty;
      DAE.Dimensions i_dims;
      DAE.Type i_ty_ty;
      String ret_15;
      Tpl.Text txt_14;
      Tpl.Text txt_13;
      Tpl.Text txt_12;
      Tpl.Text txt_11;
      Tpl.Text txt_10;
      Tpl.Text txt_9;
      Tpl.Text txt_8;
      Tpl.Text txt_7;
      Tpl.Text txt_6;
      Tpl.Text txt_5;
      Tpl.Text l_tvar;
      Tpl.Text l_type;
      String ret_2;
      Tpl.Text txt_1;
      Tpl.Text l_e2str;

    case ( txt,
           DAE.ADD(ty = _),
           _,
           a_preExp,
           a_varDecls,
           _,
           _,
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" + "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.SUB(ty = _),
           _,
           a_preExp,
           a_varDecls,
           _,
           _,
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" - "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.MUL(ty = _),
           _,
           a_preExp,
           a_varDecls,
           _,
           _,
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" * "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.DIV(ty = _),
           _,
           a_preExp,
           a_varDecls,
           a_context,
           a_exp2,
           a_e2,
           a_e1 )
      equation
        txt_1 = ExpressionDumpTpl.dumpExp(Tpl.emptyTxt, a_exp2, "\"");
        ret_2 = Util.escapeModelicaStringToCString(Tpl.textString(txt_1));
        l_e2str = Tpl.writeStr(Tpl.emptyTxt, ret_2);
        txt = fun_337(txt, a_context, l_e2str, a_e2, a_e1);
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.POW(ty = _),
           _,
           a_preExp,
           a_varDecls,
           _,
           _,
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("std::pow("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.AND(ty = _),
           _,
           a_preExp,
           a_varDecls,
           _,
           _,
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" && "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.OR(ty = _),
           _,
           a_preExp,
           a_varDecls,
           _,
           _,
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" || "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.MUL_ARRAY_SCALAR(ty = DAE.T_ARRAY(dims = i_dims, ty = i_ty_ty)),
           _,
           a_preExp,
           a_varDecls,
           _,
           _,
           a_e2,
           a_e1 )
      equation
        l_type = expTypeShort(Tpl.emptyTxt, i_ty_ty);
        txt_5 = expTypeArrayDims(Tpl.emptyTxt, i_ty_ty, i_dims);
        (l_tvar, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(txt_5), a_varDecls);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("multiply_array<"));
        a_preExp = Tpl.writeText(a_preExp, l_type);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(">("));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, l_tvar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tvar);
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.MUL_MATRIX_PRODUCT(ty = DAE.T_ARRAY(dims = i_dims, ty = i_ty_ty)),
           _,
           a_preExp,
           a_varDecls,
           _,
           _,
           a_e2,
           a_e1 )
      equation
        l_type = expTypeShort(Tpl.emptyTxt, i_ty_ty);
        txt_6 = expTypeArrayDims(Tpl.emptyTxt, i_ty_ty, i_dims);
        (l_tvar, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(txt_6), a_varDecls);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("multiply_array<"));
        a_preExp = Tpl.writeText(a_preExp, l_type);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(">("));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, l_tvar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tvar);
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.DIV_ARRAY_SCALAR(ty = DAE.T_ARRAY(dims = i_dims, ty = i_ty_ty)),
           _,
           a_preExp,
           a_varDecls,
           _,
           _,
           a_e2,
           a_e1 )
      equation
        l_type = expTypeShort(Tpl.emptyTxt, i_ty_ty);
        txt_7 = expTypeArrayDims(Tpl.emptyTxt, i_ty_ty, i_dims);
        (l_tvar, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(txt_7), a_varDecls);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("divide_array<"));
        a_preExp = Tpl.writeText(a_preExp, l_type);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(">("));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, l_tvar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tvar);
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.DIV_SCALAR_ARRAY(ty = _),
           _,
           a_preExp,
           a_varDecls,
           _,
           _,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("daeExpBinary:ERR DIV_SCALAR_ARR not supported"));
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.UMINUS(ty = _),
           _,
           a_preExp,
           a_varDecls,
           _,
           _,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("daeExpBinary:ERR UMINUS not supported"));
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.UMINUS_ARR(ty = _),
           _,
           a_preExp,
           a_varDecls,
           _,
           _,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("daeExpBinary:ERR UMINUS_ARR not supported"));
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.ADD_ARR(ty = DAE.T_ARRAY(dims = i_dims, ty = i_ty_ty)),
           _,
           a_preExp,
           a_varDecls,
           _,
           _,
           a_e2,
           a_e1 )
      equation
        l_type = expTypeShort(Tpl.emptyTxt, i_ty_ty);
        txt_8 = expTypeArrayDims(Tpl.emptyTxt, i_ty_ty, i_dims);
        (l_tvar, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(txt_8), a_varDecls);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("add_array<"));
        a_preExp = Tpl.writeText(a_preExp, l_type);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(">("));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, l_tvar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tvar);
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.SUB_ARR(ty = DAE.T_ARRAY(dims = i_dims, ty = i_ty_ty)),
           _,
           a_preExp,
           a_varDecls,
           _,
           _,
           a_e2,
           a_e1 )
      equation
        l_type = expTypeShort(Tpl.emptyTxt, i_ty_ty);
        txt_9 = expTypeArrayDims(Tpl.emptyTxt, i_ty_ty, i_dims);
        (l_tvar, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(txt_9), a_varDecls);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("subtract_array<"));
        a_preExp = Tpl.writeText(a_preExp, l_type);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(">("));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, l_tvar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tvar);
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.MUL_ARR(ty = DAE.T_ARRAY(dims = i_dims, ty = i_ty_ty)),
           _,
           a_preExp,
           a_varDecls,
           _,
           _,
           a_e2,
           a_e1 )
      equation
        l_type = expTypeShort(Tpl.emptyTxt, i_ty_ty);
        txt_10 = expTypeArrayDims(Tpl.emptyTxt, i_ty_ty, i_dims);
        (l_tvar, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(txt_10), a_varDecls);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("multiply_array_elem_wise<"));
        a_preExp = Tpl.writeText(a_preExp, l_type);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(">("));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, l_tvar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tvar);
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.DIV_ARR(ty = DAE.T_ARRAY(dims = i_dims, ty = i_ty_ty)),
           _,
           a_preExp,
           a_varDecls,
           _,
           _,
           a_e2,
           a_e1 )
      equation
        l_type = expTypeShort(Tpl.emptyTxt, i_ty_ty);
        txt_11 = expTypeArrayDims(Tpl.emptyTxt, i_ty_ty, i_dims);
        (l_tvar, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(txt_11), a_varDecls);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("divide_array_elem_wise<"));
        a_preExp = Tpl.writeText(a_preExp, l_type);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(">("));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, l_tvar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tvar);
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.ADD_ARRAY_SCALAR(ty = DAE.T_ARRAY(dims = i_dims, ty = i_ty_ty)),
           _,
           a_preExp,
           a_varDecls,
           _,
           _,
           a_e2,
           a_e1 )
      equation
        l_type = expTypeShort(Tpl.emptyTxt, i_ty_ty);
        txt_12 = expTypeArrayDims(Tpl.emptyTxt, i_ty_ty, i_dims);
        (l_tvar, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(txt_12), a_varDecls);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("add_array_scalar<"));
        a_preExp = Tpl.writeText(a_preExp, l_type);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(">("));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, l_tvar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tvar);
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.SUB_SCALAR_ARRAY(ty = DAE.T_ARRAY(dims = i_dims, ty = i_ty_ty)),
           _,
           a_preExp,
           a_varDecls,
           _,
           _,
           a_e2,
           a_e1 )
      equation
        l_type = expTypeShort(Tpl.emptyTxt, i_ty_ty);
        txt_13 = expTypeArrayDims(Tpl.emptyTxt, i_ty_ty, i_dims);
        (l_tvar, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(txt_13), a_varDecls);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("subtract_array_scalar<"));
        a_preExp = Tpl.writeText(a_preExp, l_type);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(">("));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, l_tvar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tvar);
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.MUL_SCALAR_PRODUCT(ty = i_ty),
           _,
           a_preExp,
           a_varDecls,
           _,
           _,
           a_e2,
           a_e1 )
      equation
        l_type = expTypeShort(Tpl.emptyTxt, i_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("dot_array<"));
        txt = Tpl.writeText(txt, l_type);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(">("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.DIV_SCALAR_ARRAY(ty = _),
           _,
           a_preExp,
           a_varDecls,
           _,
           _,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("daeExpBinary:ERR DIV_SCALAR_ARRAY not supported"));
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.POW_ARRAY_SCALAR(ty = DAE.T_ARRAY(dims = i_dims, ty = i_ty_ty)),
           _,
           a_preExp,
           a_varDecls,
           _,
           _,
           a_e2,
           a_e1 )
      equation
        txt_14 = expTypeArrayDims(Tpl.emptyTxt, i_ty_ty, i_dims);
        (l_tvar, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(txt_14), a_varDecls);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("pow_array_scalar("));
        a_preExp = Tpl.writeText(a_preExp, a_e1);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, a_e2);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(", "));
        a_preExp = Tpl.writeText(a_preExp, l_tvar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tvar);
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.POW_SCALAR_ARRAY(ty = _),
           _,
           a_preExp,
           a_varDecls,
           _,
           _,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("daeExpBinary:ERR POW_SCALAR_ARRAY not supported"));
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.POW_ARR(ty = _),
           _,
           a_preExp,
           a_varDecls,
           _,
           _,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("daeExpBinary:ERR POW_ARR not supported"));
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.POW_ARR2(ty = _),
           _,
           a_preExp,
           a_varDecls,
           _,
           _,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("daeExpBinary:ERR POW_ARR2 not supported"));
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.NOT(ty = _),
           _,
           a_preExp,
           a_varDecls,
           _,
           _,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("daeExpBinary:ERR NOT not supported"));
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.LESS(ty = _),
           _,
           a_preExp,
           a_varDecls,
           _,
           _,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("daeExpBinary:ERR LESS not supported"));
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.LESSEQ(ty = _),
           _,
           a_preExp,
           a_varDecls,
           _,
           _,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("daeExpBinary:ERR LESSEQ not supported"));
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.GREATER(ty = _),
           _,
           a_preExp,
           a_varDecls,
           _,
           _,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("daeExpBinary:ERR GREATER not supported"));
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.GREATEREQ(ty = _),
           _,
           a_preExp,
           a_varDecls,
           _,
           _,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("daeExpBinary:ERR GREATEREQ not supported"));
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.EQUAL(ty = _),
           _,
           a_preExp,
           a_varDecls,
           _,
           _,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("daeExpBinary:ERR EQUAL not supported"));
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.NEQUAL(ty = _),
           _,
           a_preExp,
           a_varDecls,
           _,
           _,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("daeExpBinary:ERR NEQUAL not supported"));
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.USERDEFINED(fqName = _),
           _,
           a_preExp,
           a_varDecls,
           _,
           _,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("daeExpBinary:ERR POW_ARR not supported"));
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           i_it,
           a_exp1,
           a_preExp,
           a_varDecls,
           _,
           a_exp2,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("daeExpBinary:ERR "));
        txt = ExpressionDumpTpl.dumpExp(txt, a_exp1, "\"");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        ret_15 = ExpressionDump.binopSymbol(i_it);
        txt = Tpl.writeStr(txt, ret_15);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = ExpressionDumpTpl.dumpExp(txt, a_exp2, "\"");
      then (txt, a_preExp, a_varDecls);
  end match;
end fun_338;

public function daeExpBinary
  input Tpl.Text txt;
  input DAE.Operator a_it;
  input DAE.Exp a_exp1;
  input DAE.Exp a_exp2;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_preExp;
  input Tpl.Text a_varDecls;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
protected
  Tpl.Text l_e2;
  Tpl.Text l_e1;
algorithm
  (l_e1, out_a_preExp, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) := daeExp(Tpl.emptyTxt, a_exp1, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
  (l_e2, out_a_preExp, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) := daeExp(Tpl.emptyTxt, a_exp2, a_context, out_a_preExp, out_a_varDecls, a_simCode, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName, a_useFlatArrayNotation);
  (out_txt, out_a_preExp, out_a_varDecls) := fun_338(txt, a_it, a_exp1, out_a_preExp, out_a_varDecls, a_context, a_exp2, l_e2, l_e1);
end daeExpBinary;

public function daeExpSconst
  input Tpl.Text txt;
  input String a_string;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_preExp;
  input Tpl.Text a_varDecls;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
protected
  String ret_0;
algorithm
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING("\""));
  ret_0 := Util.escapeModelicaStringToCString(a_string);
  out_txt := Tpl.writeStr(out_txt, ret_0);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("\""));
  out_a_preExp := a_preExp;
  out_a_varDecls := a_varDecls;
  out_a_extraFuncs := a_extraFuncs;
  out_a_extraFuncsDecl := a_extraFuncsDecl;
  out_a_extraFuncsNamespace := a_extraFuncsNamespace;
  out_a_stateDerVectorName := a_stateDerVectorName;
end daeExpSconst;

protected function lm_341
  input Tpl.Text in_txt;
  input DAE.Dimensions in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      DAE.Dimensions rest;
      Integer i_i;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           DAE.DIM_INTEGER(integer = i_i) :: rest )
      equation
        txt = Tpl.writeStr(txt, intString(i_i));
        txt = Tpl.nextIter(txt);
        txt = lm_341(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_341(txt, rest);
      then txt;
  end match;
end lm_341;

protected function fun_342
  input Tpl.Text in_txt;
  input String in_mArg;
  input Tpl.Text in_a_dimensions;
  input Tpl.Text in_a_listlength;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_dimensions, in_a_listlength)
    local
      Tpl.Text txt;
      Tpl.Text a_dimensions;
      Tpl.Text a_listlength;

    case ( txt,
           "",
           _,
           a_listlength )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("DynArrayDim"));
        txt = Tpl.writeText(txt, a_listlength);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<double>"));
      then txt;

    case ( txt,
           _,
           a_dimensions,
           a_listlength )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("StatArrayDim"));
        txt = Tpl.writeText(txt, a_listlength);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<double, "));
        txt = Tpl.writeText(txt, a_dimensions);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(">"));
      then txt;
  end match;
end fun_342;

protected function fun_343
  input Tpl.Text in_txt;
  input DAE.Operator in_a_operator;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_e;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls) :=
  match(in_txt, in_a_operator, in_a_preExp, in_a_varDecls, in_a_e)
    local
      Tpl.Text txt;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_e;
      DAE.Dimensions i_ty_dims;
      Integer ret_6;
      Tpl.Text l_tvar;
      String str_4;
      Tpl.Text l_tmp__type__str;
      Integer ret_2;
      Tpl.Text l_listlength;
      Tpl.Text l_dimensions;

    case ( txt,
           DAE.UMINUS(ty = _),
           a_preExp,
           a_varDecls,
           a_e )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(-"));
        txt = Tpl.writeText(txt, a_e);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.UMINUS_ARR(ty = DAE.T_ARRAY(ty = DAE.T_REAL(varLst = _), dims = i_ty_dims)),
           a_preExp,
           a_varDecls,
           a_e )
      equation
        l_dimensions = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_dimensions = lm_341(l_dimensions, i_ty_dims);
        l_dimensions = Tpl.popIter(l_dimensions);
        ret_2 = listLength(i_ty_dims);
        l_listlength = Tpl.writeStr(Tpl.emptyTxt, intString(ret_2));
        str_4 = Tpl.textString(l_dimensions);
        l_tmp__type__str = fun_342(Tpl.emptyTxt, str_4, l_dimensions, l_listlength);
        (l_tvar, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(l_tmp__type__str), a_varDecls);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("usub_array<double>("));
        a_preExp = Tpl.writeText(a_preExp, a_e);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(","));
        a_preExp = Tpl.writeText(a_preExp, l_tvar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tvar);
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.UMINUS_ARR(ty = DAE.T_ARRAY(ty = DAE.T_INTEGER(varLst = _), dims = i_ty_dims)),
           a_preExp,
           a_varDecls,
           a_e )
      equation
        l_tmp__type__str = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("multi_array<int,"));
        ret_6 = listLength(i_ty_dims);
        l_tmp__type__str = Tpl.writeStr(l_tmp__type__str, intString(ret_6));
        l_tmp__type__str = Tpl.writeTok(l_tmp__type__str, Tpl.ST_STRING(">/*multi3*/"));
        (l_tvar, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(l_tmp__type__str), a_varDecls);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("usub_array<int>("));
        a_preExp = Tpl.writeText(a_preExp, a_e);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(","));
        a_preExp = Tpl.writeText(a_preExp, l_tvar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(");"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_tvar);
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           DAE.UMINUS_ARR(ty = _),
           a_preExp,
           a_varDecls,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("unary minus for non-real arrays not implemented"));
      then (txt, a_preExp, a_varDecls);

    case ( txt,
           _,
           a_preExp,
           a_varDecls,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("daeExpUnary:ERR"));
      then (txt, a_preExp, a_varDecls);
  end match;
end fun_343;

public function daeExpUnary
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_exp, in_a_context, in_a_preExp, in_a_varDecls, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      DAE.Operator i_operator;
      DAE.Exp i_exp;
      Tpl.Text l_e;

    case ( txt,
           DAE.UNARY(exp = i_exp, operator = i_operator),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (l_e, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_exp, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        (txt, a_preExp, a_varDecls) = fun_343(txt, i_operator, a_preExp, a_varDecls, l_e);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           a_preExp,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end daeExpUnary;

protected function fun_345
  input Tpl.Text in_txt;
  input DAE.Operator in_a_rel_operator;
  input Tpl.Text in_a_e2;
  input Tpl.Text in_a_e1;
  input Integer in_a_rel_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_rel_operator, in_a_e2, in_a_e1, in_a_rel_index)
    local
      Tpl.Text txt;
      Tpl.Text a_e2;
      Tpl.Text a_e1;
      Integer a_rel_index;

    case ( txt,
           DAE.LESS(ty = _),
           a_e2,
           a_e1,
           a_rel_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_system->getCondition("));
        txt = Tpl.writeStr(txt, intString(a_rel_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") && ("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" < "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.LESSEQ(ty = _),
           a_e2,
           a_e1,
           a_rel_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_system->getCondition("));
        txt = Tpl.writeStr(txt, intString(a_rel_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") && ("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" <= "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.GREATER(ty = _),
           a_e2,
           a_e1,
           a_rel_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_system->getCondition("));
        txt = Tpl.writeStr(txt, intString(a_rel_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") && ("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" > "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.GREATEREQ(ty = _),
           a_e2,
           a_e1,
           a_rel_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_system->getCondition("));
        txt = Tpl.writeStr(txt, intString(a_rel_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")  && ("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" >= "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_345;

protected function fun_346
  input Tpl.Text in_txt;
  input DAE.Operator in_a_rel_operator;
  input Tpl.Text in_a_e2;
  input Tpl.Text in_a_e1;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_rel_operator, in_a_e2, in_a_e1)
    local
      Tpl.Text txt;
      Tpl.Text a_e2;
      Tpl.Text a_e1;

    case ( txt,
           DAE.LESS(ty = _),
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" < "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.LESSEQ(ty = _),
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" <= "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.GREATER(ty = _),
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" > "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.GREATEREQ(ty = _),
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" >= "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_346;

protected function fun_347
  input Tpl.Text in_txt;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_e2;
  input Tpl.Text in_a_e1;
  input Integer in_a_rel_index;
  input DAE.Operator in_a_rel_operator;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_context, in_a_e2, in_a_e1, in_a_rel_index, in_a_rel_operator)
    local
      Tpl.Text txt;
      Tpl.Text a_e2;
      Tpl.Text a_e1;
      Integer a_rel_index;
      DAE.Operator a_rel_operator;

    case ( txt,
           SimCodeFunction.ALGLOOP_CONTEXT(genInitialisation = false),
           a_e2,
           a_e1,
           a_rel_index,
           a_rel_operator )
      equation
        txt = fun_345(txt, a_rel_operator, a_e2, a_e1, a_rel_index);
      then txt;

    case ( txt,
           _,
           a_e2,
           a_e1,
           _,
           a_rel_operator )
      equation
        txt = fun_346(txt, a_rel_operator, a_e2, a_e1);
      then txt;
  end match;
end fun_347;

protected function fun_348
  input Tpl.Text in_txt;
  input Option<tuple<DAE.Exp, Integer, Integer>> in_a_rel_optionExpisASUB;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;
  input DAE.Exp in_a_rel_exp2;
  input DAE.Exp in_a_rel_exp1;
  input Integer in_a_rel_index;
  input DAE.Operator in_a_rel_operator;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_a_rel_optionExpisASUB, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_preExp, in_a_context, in_a_rel_exp2, in_a_rel_exp1, in_a_rel_index, in_a_rel_operator)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Exp a_rel_exp2;
      DAE.Exp a_rel_exp1;
      Integer a_rel_index;
      DAE.Operator a_rel_operator;
      Tpl.Text l_e2;
      Tpl.Text l_e1;

    case ( txt,
           NONE(),
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp,
           a_context,
           a_rel_exp2,
           a_rel_exp1,
           a_rel_index,
           a_rel_operator )
      equation
        (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExpRelation2(txt, a_rel_operator, a_rel_index, a_rel_exp1, a_rel_exp2, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);

    case ( txt,
           SOME((_, _, _)),
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp,
           a_context,
           a_rel_exp2,
           a_rel_exp1,
           a_rel_index,
           a_rel_operator )
      equation
        (l_e1, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, a_rel_exp1, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        (l_e2, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, a_rel_exp2, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = fun_347(txt, a_context, l_e2, l_e1, a_rel_index, a_rel_operator);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);

    case ( txt,
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           a_preExp,
           _,
           _,
           _,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);
  end match;
end fun_348;

public function daeExpRelation
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_exp, in_a_context, in_a_preExp, in_a_varDecls, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      DAE.Exp i_rel_exp2;
      DAE.Exp i_rel_exp1;
      Integer i_rel_index;
      DAE.Operator i_rel_operator;
      Option<tuple<DAE.Exp, Integer, Integer>> i_rel_optionExpisASUB;

    case ( txt,
           DAE.RELATION(optionExpisASUB = i_rel_optionExpisASUB, operator = i_rel_operator, index = i_rel_index, exp1 = i_rel_exp1, exp2 = i_rel_exp2),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = fun_348(txt, i_rel_optionExpisASUB, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context, i_rel_exp2, i_rel_exp1, i_rel_index, i_rel_operator);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           a_preExp,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end daeExpRelation;

public function daeExpRelation3
  input Tpl.Text in_txt;
  input SimCodeFunction.Context in_a_context;
  input Integer in_a_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_context, in_a_index)
    local
      Tpl.Text txt;
      Integer a_index;

    case ( txt,
           SimCodeFunction.ALGLOOP_CONTEXT(genInitialisation = false),
           a_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_system->getCondition("));
        txt = Tpl.writeStr(txt, intString(a_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           _,
           a_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("getCondition("));
        txt = Tpl.writeStr(txt, intString(a_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;
  end match;
end daeExpRelation3;

protected function fun_351
  input Tpl.Text in_txt;
  input DAE.Operator in_a_op;
  input Tpl.Text in_a_e2;
  input Tpl.Text in_a_e1;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_op, in_a_e2, in_a_e1)
    local
      Tpl.Text txt;
      Tpl.Text a_e2;
      Tpl.Text a_e1;

    case ( txt,
           DAE.LESS(ty = DAE.T_BOOL(varLst = _)),
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(!"));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" && "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.LESS(ty = DAE.T_STRING(varLst = _)),
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("# string comparison not supported\n"));
      then txt;

    case ( txt,
           DAE.LESS(ty = DAE.T_INTEGER(varLst = _)),
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" < "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.LESS(ty = DAE.T_REAL(varLst = _)),
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" < "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.LESS(ty = DAE.T_ENUMERATION(index = _)),
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" < "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.GREATER(ty = DAE.T_BOOL(varLst = _)),
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" && !"));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.GREATER(ty = DAE.T_STRING(varLst = _)),
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("# string comparison not supported\n"));
      then txt;

    case ( txt,
           DAE.GREATER(ty = DAE.T_INTEGER(varLst = _)),
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" > "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.GREATER(ty = DAE.T_REAL(varLst = _)),
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" > "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.GREATER(ty = DAE.T_ENUMERATION(index = _)),
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" > "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.LESSEQ(ty = DAE.T_BOOL(varLst = _)),
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(!"));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" || "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.LESSEQ(ty = DAE.T_STRING(varLst = _)),
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("# string comparison not supported\n"));
      then txt;

    case ( txt,
           DAE.LESSEQ(ty = DAE.T_INTEGER(varLst = _)),
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" <= "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.LESSEQ(ty = DAE.T_REAL(varLst = _)),
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" <= "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.LESSEQ(ty = DAE.T_ENUMERATION(index = _)),
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" <= "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.GREATEREQ(ty = DAE.T_BOOL(varLst = _)),
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" || !"));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.GREATEREQ(ty = DAE.T_STRING(varLst = _)),
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("# string comparison not supported\n"));
      then txt;

    case ( txt,
           DAE.GREATEREQ(ty = DAE.T_INTEGER(varLst = _)),
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" >= "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.GREATEREQ(ty = DAE.T_REAL(varLst = _)),
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" >= "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.GREATEREQ(ty = DAE.T_ENUMERATION(index = _)),
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" >= "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.EQUAL(ty = DAE.T_BOOL(varLst = _)),
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("((!"));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" && !"));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") || ("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" && "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("))"));
      then txt;

    case ( txt,
           DAE.EQUAL(ty = DAE.T_STRING(varLst = _)),
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" == "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.EQUAL(ty = DAE.T_INTEGER(varLst = _)),
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" == "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.EQUAL(ty = DAE.T_REAL(varLst = _)),
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" == "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.EQUAL(ty = DAE.T_ENUMERATION(index = _)),
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" == "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.NEQUAL(ty = DAE.T_BOOL(varLst = _)),
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("((!"));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" && "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") || ("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" && !"));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("))"));
      then txt;

    case ( txt,
           DAE.NEQUAL(ty = DAE.T_STRING(varLst = _)),
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" != "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.NEQUAL(ty = DAE.T_INTEGER(varLst = _)),
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" != "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.NEQUAL(ty = DAE.T_REAL(varLst = _)),
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" != "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           DAE.NEQUAL(ty = DAE.T_ENUMERATION(index = _)),
           a_e2,
           a_e1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" != "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("daeExpRelation:ERR"));
      then txt;
  end match;
end fun_351;

protected function fun_352
  input Tpl.Text in_txt;
  input DAE.Operator in_a_op;
  input Integer in_a_index;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_op, in_a_index, in_a_context)
    local
      Tpl.Text txt;
      Integer a_index;
      SimCodeFunction.Context a_context;

    case ( txt,
           DAE.LESS(ty = DAE.T_BOOL(varLst = _)),
           a_index,
           a_context )
      equation
        txt = daeExpRelation3(txt, a_context, a_index);
      then txt;

    case ( txt,
           DAE.LESS(ty = DAE.T_STRING(varLst = _)),
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("# string comparison not supported\n"));
      then txt;

    case ( txt,
           DAE.LESS(ty = DAE.T_INTEGER(varLst = _)),
           a_index,
           a_context )
      equation
        txt = daeExpRelation3(txt, a_context, a_index);
      then txt;

    case ( txt,
           DAE.LESS(ty = DAE.T_REAL(varLst = _)),
           a_index,
           a_context )
      equation
        txt = daeExpRelation3(txt, a_context, a_index);
      then txt;

    case ( txt,
           DAE.GREATER(ty = DAE.T_BOOL(varLst = _)),
           a_index,
           a_context )
      equation
        txt = daeExpRelation3(txt, a_context, a_index);
      then txt;

    case ( txt,
           DAE.GREATER(ty = DAE.T_STRING(varLst = _)),
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("# string comparison not supported\n"));
      then txt;

    case ( txt,
           DAE.GREATER(ty = DAE.T_INTEGER(varLst = _)),
           a_index,
           a_context )
      equation
        txt = daeExpRelation3(txt, a_context, a_index);
      then txt;

    case ( txt,
           DAE.GREATER(ty = DAE.T_REAL(varLst = _)),
           a_index,
           a_context )
      equation
        txt = daeExpRelation3(txt, a_context, a_index);
      then txt;

    case ( txt,
           DAE.LESSEQ(ty = DAE.T_BOOL(varLst = _)),
           a_index,
           a_context )
      equation
        txt = daeExpRelation3(txt, a_context, a_index);
      then txt;

    case ( txt,
           DAE.LESSEQ(ty = DAE.T_STRING(varLst = _)),
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("# string comparison not supported\n"));
      then txt;

    case ( txt,
           DAE.LESSEQ(ty = DAE.T_INTEGER(varLst = _)),
           a_index,
           a_context )
      equation
        txt = daeExpRelation3(txt, a_context, a_index);
      then txt;

    case ( txt,
           DAE.LESSEQ(ty = DAE.T_REAL(varLst = _)),
           a_index,
           a_context )
      equation
        txt = daeExpRelation3(txt, a_context, a_index);
      then txt;

    case ( txt,
           DAE.GREATEREQ(ty = DAE.T_BOOL(varLst = _)),
           a_index,
           a_context )
      equation
        txt = daeExpRelation3(txt, a_context, a_index);
      then txt;

    case ( txt,
           DAE.GREATEREQ(ty = DAE.T_STRING(varLst = _)),
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("# string comparison not supported\n"));
      then txt;

    case ( txt,
           DAE.GREATEREQ(ty = DAE.T_INTEGER(varLst = _)),
           a_index,
           a_context )
      equation
        txt = daeExpRelation3(txt, a_context, a_index);
      then txt;

    case ( txt,
           DAE.GREATEREQ(ty = DAE.T_REAL(varLst = _)),
           a_index,
           a_context )
      equation
        txt = daeExpRelation3(txt, a_context, a_index);
      then txt;

    case ( txt,
           DAE.EQUAL(ty = DAE.T_BOOL(varLst = _)),
           a_index,
           a_context )
      equation
        txt = daeExpRelation3(txt, a_context, a_index);
      then txt;

    case ( txt,
           DAE.EQUAL(ty = DAE.T_STRING(varLst = _)),
           a_index,
           a_context )
      equation
        txt = daeExpRelation3(txt, a_context, a_index);
      then txt;

    case ( txt,
           DAE.EQUAL(ty = DAE.T_INTEGER(varLst = _)),
           a_index,
           a_context )
      equation
        txt = daeExpRelation3(txt, a_context, a_index);
      then txt;

    case ( txt,
           DAE.EQUAL(ty = DAE.T_REAL(varLst = _)),
           a_index,
           a_context )
      equation
        txt = daeExpRelation3(txt, a_context, a_index);
      then txt;

    case ( txt,
           DAE.NEQUAL(ty = DAE.T_BOOL(varLst = _)),
           a_index,
           a_context )
      equation
        txt = daeExpRelation3(txt, a_context, a_index);
      then txt;

    case ( txt,
           DAE.NEQUAL(ty = DAE.T_STRING(varLst = _)),
           a_index,
           a_context )
      equation
        txt = daeExpRelation3(txt, a_context, a_index);
      then txt;

    case ( txt,
           DAE.NEQUAL(ty = DAE.T_INTEGER(varLst = _)),
           a_index,
           a_context )
      equation
        txt = daeExpRelation3(txt, a_context, a_index);
      then txt;

    case ( txt,
           DAE.NEQUAL(ty = DAE.T_REAL(varLst = _)),
           a_index,
           a_context )
      equation
        txt = daeExpRelation3(txt, a_context, a_index);
      then txt;

    case ( txt,
           _,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("daeExpRelationCondition:ERR"));
      then txt;
  end match;
end fun_352;

protected function fun_353
  input Tpl.Text in_txt;
  input Integer in_a_index;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_e2;
  input Tpl.Text in_a_e1;
  input DAE.Operator in_a_op;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_index, in_a_context, in_a_e2, in_a_e1, in_a_op)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_e2;
      Tpl.Text a_e1;
      DAE.Operator a_op;
      Integer i_index;

    case ( txt,
           -1,
           _,
           a_e2,
           a_e1,
           a_op )
      equation
        txt = fun_351(txt, a_op, a_e2, a_e1);
      then txt;

    case ( txt,
           i_index,
           a_context,
           _,
           _,
           a_op )
      equation
        txt = fun_352(txt, a_op, i_index, a_context);
      then txt;
  end match;
end fun_353;

public function daeExpRelation2
  input Tpl.Text txt;
  input DAE.Operator a_op;
  input Integer a_index;
  input DAE.Exp a_exp1;
  input DAE.Exp a_exp2;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_preExp;
  input Tpl.Text a_varDecls;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
protected
  Tpl.Text l_e2;
  Tpl.Text l_e1;
algorithm
  (l_e1, out_a_preExp, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) := daeExp(Tpl.emptyTxt, a_exp1, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
  (l_e2, out_a_preExp, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) := daeExp(Tpl.emptyTxt, a_exp2, a_context, out_a_preExp, out_a_varDecls, a_simCode, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName, a_useFlatArrayNotation);
  out_txt := fun_353(txt, a_index, a_context, l_e2, l_e1, a_op);
end daeExpRelation2;

protected function fun_355
  input Tpl.Text in_txt;
  input DAE.Type in_mArg;
  input Tpl.Text in_a_eThen;
  input Tpl.Text in_a_resVar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_eThen, in_a_resVar)
    local
      Tpl.Text txt;
      Tpl.Text a_eThen;
      Tpl.Text a_resVar;

    case ( txt,
           DAE.T_ARRAY(dims = _),
           a_eThen,
           a_resVar )
      equation
        txt = Tpl.writeText(txt, a_resVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".assign("));
        txt = Tpl.writeText(txt, a_eThen);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;

    case ( txt,
           _,
           a_eThen,
           a_resVar )
      equation
        txt = Tpl.writeText(txt, a_resVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, a_eThen);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_355;

protected function fun_356
  input Tpl.Text in_txt;
  input DAE.Type in_mArg;
  input Tpl.Text in_a_eElse;
  input Tpl.Text in_a_resVar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_eElse, in_a_resVar)
    local
      Tpl.Text txt;
      Tpl.Text a_eElse;
      Tpl.Text a_resVar;

    case ( txt,
           DAE.T_ARRAY(dims = _),
           a_eElse,
           a_resVar )
      equation
        txt = Tpl.writeText(txt, a_resVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".assign("));
        txt = Tpl.writeText(txt, a_eElse);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;

    case ( txt,
           _,
           a_eElse,
           a_resVar )
      equation
        txt = Tpl.writeText(txt, a_resVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, a_eElse);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_356;

public function daeExpIf
  input Tpl.Text txt;
  input DAE.Exp a_cond;
  input DAE.Exp a_then__;
  input DAE.Exp a_else__;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_preExp;
  input Tpl.Text a_varDecls;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
protected
  DAE.Type ret_7;
  DAE.Type ret_6;
  Tpl.Text l_resVar;
  Tpl.Text l_eElse;
  Tpl.Text l_preExpElse;
  Tpl.Text l_eThen;
  Tpl.Text l_preExpThen;
  Tpl.Text l_condExp;
algorithm
  (l_condExp, out_a_preExp, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) := daeExp(Tpl.emptyTxt, a_cond, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
  l_preExpThen := Tpl.emptyTxt;
  (l_eThen, l_preExpThen, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) := daeExp(Tpl.emptyTxt, a_then__, a_context, l_preExpThen, out_a_varDecls, a_simCode, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName, a_useFlatArrayNotation);
  l_preExpElse := Tpl.emptyTxt;
  (l_eElse, l_preExpElse, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) := daeExp(Tpl.emptyTxt, a_else__, a_context, l_preExpElse, out_a_varDecls, a_simCode, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName, a_useFlatArrayNotation);
  (l_resVar, out_a_preExp, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) := expTypeFromExpArrayIf(Tpl.emptyTxt, a_else__, a_context, out_a_preExp, out_a_varDecls, a_simCode, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName, a_useFlatArrayNotation);
  out_a_preExp := Tpl.writeTok(out_a_preExp, Tpl.ST_STRING("if "));
  out_a_preExp := encloseInParantheses(out_a_preExp, Tpl.textString(l_condExp));
  out_a_preExp := Tpl.writeTok(out_a_preExp, Tpl.ST_LINE(" {\n"));
  out_a_preExp := Tpl.pushBlock(out_a_preExp, Tpl.BT_INDENT(2));
  out_a_preExp := Tpl.writeText(out_a_preExp, l_preExpThen);
  out_a_preExp := Tpl.softNewLine(out_a_preExp);
  ret_6 := Expression.typeof(a_then__);
  out_a_preExp := fun_355(out_a_preExp, ret_6, l_eThen, l_resVar);
  out_a_preExp := Tpl.softNewLine(out_a_preExp);
  out_a_preExp := Tpl.popBlock(out_a_preExp);
  out_a_preExp := Tpl.writeTok(out_a_preExp, Tpl.ST_LINE("} else {\n"));
  out_a_preExp := Tpl.pushBlock(out_a_preExp, Tpl.BT_INDENT(2));
  out_a_preExp := Tpl.writeText(out_a_preExp, l_preExpElse);
  out_a_preExp := Tpl.softNewLine(out_a_preExp);
  ret_7 := Expression.typeof(a_else__);
  out_a_preExp := fun_356(out_a_preExp, ret_7, l_eElse, l_resVar);
  out_a_preExp := Tpl.softNewLine(out_a_preExp);
  out_a_preExp := Tpl.popBlock(out_a_preExp);
  out_a_preExp := Tpl.writeTok(out_a_preExp, Tpl.ST_STRING("}"));
  out_a_preExp := Tpl.writeTok(out_a_preExp, Tpl.ST_NEW_LINE());
  out_txt := Tpl.writeText(txt, l_resVar);
end daeExpIf;

protected function lm_358
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Exp i_e;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);

    case ( txt,
           i_e :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(txt, i_e, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = lm_358(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);
  end match;
end lm_358;

protected function fun_359
  input Tpl.Text in_txt;
  input DAE.Type in_mArg;
  input DAE.Exp in_a_exp;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_varDecls) :=
  match(in_txt, in_mArg, in_a_exp, in_a_varDecls)
    local
      Tpl.Text txt;
      DAE.Exp a_exp;
      Tpl.Text a_varDecls;
      DAE.Type i_ty;
      DAE.Dimensions i_dims;
      DAE.Type ret_3;
      Tpl.Text l_resVar;
      Integer ret_1;
      Tpl.Text l_resVarType;

    case ( txt,
           (i_ty as DAE.T_ARRAY(dims = i_dims)),
           _,
           a_varDecls )
      equation
        l_resVarType = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("DynArrayDim"));
        ret_1 = listLength(i_dims);
        l_resVarType = Tpl.writeStr(l_resVarType, intString(ret_1));
        l_resVarType = Tpl.writeTok(l_resVarType, Tpl.ST_STRING("<"));
        l_resVarType = expTypeShort(l_resVarType, i_ty);
        l_resVarType = Tpl.writeTok(l_resVarType, Tpl.ST_STRING(">"));
        (l_resVar, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(l_resVarType), a_varDecls);
        txt = Tpl.writeText(txt, l_resVar);
      then (txt, a_varDecls);

    case ( txt,
           _,
           a_exp,
           a_varDecls )
      equation
        ret_3 = Expression.typeof(a_exp);
        l_resVarType = expTypeFlag(Tpl.emptyTxt, ret_3, 2);
        (l_resVar, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(l_resVarType), a_varDecls);
        txt = Tpl.writeText(txt, l_resVar);
      then (txt, a_varDecls);
  end match;
end fun_359;

public function expTypeFromExpArrayIf
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_exp, in_a_context, in_a_preExp, in_a_varDecls, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      DAE.Exp i_exp;
      list<DAE.Exp> i_array;
      DAE.Type i_ty;
      DAE.Type ret_6;
      Tpl.Text l_params;
      Tpl.Text l_tmpVar;
      Tpl.Text l_arrayVar;
      Tpl.Text l_tmpdecl;
      Tpl.Text l_StatArrayDim;
      Tpl.Text l_arrayTypeStr;

    case ( txt,
           DAE.ARRAY(ty = i_ty, array = i_array),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_arrayTypeStr = expTypeShort(Tpl.emptyTxt, i_ty);
        l_StatArrayDim = expTypeArrayIf(Tpl.emptyTxt, i_ty);
        l_tmpdecl = Tpl.emptyTxt;
        (l_arrayVar, l_tmpdecl) = tempDecl(Tpl.emptyTxt, Tpl.textString(l_arrayTypeStr), l_tmpdecl);
        l_tmpVar = Tpl.emptyTxt;
        l_params = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_params, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = lm_358(l_params, i_array, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context);
        l_params = Tpl.popIter(l_params);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING_LIST({
                                              "\n",
                                              "   //tmp array\n"
                                          }, true));
        a_preExp = Tpl.pushBlock(a_preExp, Tpl.BT_INDENT(3));
        a_preExp = Tpl.writeText(a_preExp, l_StatArrayDim);
        a_preExp = Tpl.writeText(a_preExp, l_arrayVar);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(";/*testarray6*/"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        a_preExp = Tpl.popBlock(a_preExp);
        txt = Tpl.writeText(txt, l_arrayVar);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           i_exp,
           _,
           a_preExp,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      equation
        ret_6 = Expression.typeof(i_exp);
        (txt, a_varDecls) = fun_359(txt, ret_6, i_exp, a_varDecls);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end expTypeFromExpArrayIf;

public function expTypeFromExp
  input Tpl.Text in_txt;
  input DAE.Exp in_a_it;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_it)
    local
      Tpl.Text txt;
      DAE.Exp i_expr;
      DAE.Exp i_exp;
      DAE.Type i_ty;
      DAE.Type i_attr_ty;
      DAE.Exp i_expThen;
      DAE.Operator i_operator;

    case ( txt,
           DAE.ICONST(integer = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("int"));
      then txt;

    case ( txt,
           DAE.ENUM_LITERAL(name = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("int"));
      then txt;

    case ( txt,
           DAE.RCONST(real = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("double"));
      then txt;

    case ( txt,
           DAE.SCONST(string = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("string"));
      then txt;

    case ( txt,
           DAE.BCONST(bool = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("bool"));
      then txt;

    case ( txt,
           DAE.BINARY(operator = i_operator) )
      equation
        txt = expTypeFromOp(txt, i_operator);
      then txt;

    case ( txt,
           DAE.UNARY(operator = i_operator) )
      equation
        txt = expTypeFromOp(txt, i_operator);
      then txt;

    case ( txt,
           DAE.LBINARY(operator = i_operator) )
      equation
        txt = expTypeFromOp(txt, i_operator);
      then txt;

    case ( txt,
           DAE.LUNARY(operator = i_operator) )
      equation
        txt = expTypeFromOp(txt, i_operator);
      then txt;

    case ( txt,
           DAE.RELATION(exp1 = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("bool"));
      then txt;

    case ( txt,
           DAE.IFEXP(expThen = i_expThen) )
      equation
        txt = expTypeFromExp(txt, i_expThen);
      then txt;

    case ( txt,
           DAE.CALL(attr = DAE.CALL_ATTR(ty = i_attr_ty)) )
      equation
        txt = expTypeShort(txt, i_attr_ty);
      then txt;

    case ( txt,
           DAE.ARRAY(ty = i_ty) )
      equation
        txt = expTypeShort(txt, i_ty);
      then txt;

    case ( txt,
           DAE.MATRIX(ty = i_ty) )
      equation
        txt = expTypeShort(txt, i_ty);
      then txt;

    case ( txt,
           DAE.RANGE(ty = i_ty) )
      equation
        txt = expTypeShort(txt, i_ty);
      then txt;

    case ( txt,
           DAE.CAST(ty = i_ty) )
      equation
        txt = expTypeShort(txt, i_ty);
      then txt;

    case ( txt,
           DAE.CREF(ty = i_ty) )
      equation
        txt = expTypeShort(txt, i_ty);
      then txt;

    case ( txt,
           DAE.CODE(ty = i_ty) )
      equation
        txt = expTypeShort(txt, i_ty);
      then txt;

    case ( txt,
           DAE.ASUB(exp = i_exp) )
      equation
        txt = expTypeFromExp(txt, i_exp);
      then txt;

    case ( txt,
           DAE.REDUCTION(expr = i_expr) )
      equation
        txt = expTypeFromExp(txt, i_expr);
      then txt;

    case ( txt,
           DAE.TUPLE(PR = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("expTypeFromExp:ERROR TUPLE unsupported"));
      then txt;

    case ( txt,
           DAE.TSUB(exp = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("expTypeFromExp:ERROR TSUB unsupported"));
      then txt;

    case ( txt,
           DAE.SIZE(exp = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("expTypeFromExp:ERROR SIZE unsupported"));
      then txt;

    case ( txt,
           DAE.LIST(valList = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("expTypeFromExp:ERROR LIST unsupported"));
      then txt;

    case ( txt,
           DAE.CONS(car = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("expTypeFromExp:ERROR CONS unsupported"));
      then txt;

    case ( txt,
           DAE.META_TUPLE(listExp = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("expTypeFromExp:ERROR META_TUPLE unsupported"));
      then txt;

    case ( txt,
           DAE.META_OPTION(exp = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("expTypeFromExp:ERROR META_OPTION unsupported"));
      then txt;

    case ( txt,
           DAE.METARECORDCALL(path = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("expTypeFromExp:ERROR METARECORDCALL unsupported"));
      then txt;

    case ( txt,
           DAE.MATCHEXPRESSION(matchType = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("expTypeFromExp:ERROR MATCHEXPRESSION unsupported"));
      then txt;

    case ( txt,
           DAE.BOX(exp = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("expTypeFromExp:ERROR BOX unsupported"));
      then txt;

    case ( txt,
           DAE.UNBOX(exp = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("expTypeFromExp:ERROR UNBOX unsupported"));
      then txt;

    case ( txt,
           DAE.SHARED_LITERAL(exp = i_exp) )
      equation
        txt = expTypeFromExp(txt, i_exp);
      then txt;

    case ( txt,
           DAE.PATTERN(pattern = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("expTypeFromExp:ERROR PATTERN unsupported"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("expTypeFromExp:ERROR"));
      then txt;
  end match;
end expTypeFromExp;

public function expTypeFromOp
  input Tpl.Text in_txt;
  input DAE.Operator in_a_it;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_it)
    local
      Tpl.Text txt;
      DAE.Type i_ty;

    case ( txt,
           DAE.ADD(ty = i_ty) )
      equation
        txt = expTypeShort(txt, i_ty);
      then txt;

    case ( txt,
           DAE.SUB(ty = i_ty) )
      equation
        txt = expTypeShort(txt, i_ty);
      then txt;

    case ( txt,
           DAE.MUL(ty = i_ty) )
      equation
        txt = expTypeShort(txt, i_ty);
      then txt;

    case ( txt,
           DAE.DIV(ty = i_ty) )
      equation
        txt = expTypeShort(txt, i_ty);
      then txt;

    case ( txt,
           DAE.POW(ty = i_ty) )
      equation
        txt = expTypeShort(txt, i_ty);
      then txt;

    case ( txt,
           DAE.UMINUS(ty = i_ty) )
      equation
        txt = expTypeShort(txt, i_ty);
      then txt;

    case ( txt,
           DAE.UMINUS_ARR(ty = i_ty) )
      equation
        txt = expTypeShort(txt, i_ty);
      then txt;

    case ( txt,
           DAE.ADD_ARR(ty = i_ty) )
      equation
        txt = expTypeShort(txt, i_ty);
      then txt;

    case ( txt,
           DAE.SUB_ARR(ty = i_ty) )
      equation
        txt = expTypeShort(txt, i_ty);
      then txt;

    case ( txt,
           DAE.MUL_ARR(ty = i_ty) )
      equation
        txt = expTypeShort(txt, i_ty);
      then txt;

    case ( txt,
           DAE.DIV_ARR(ty = i_ty) )
      equation
        txt = expTypeShort(txt, i_ty);
      then txt;

    case ( txt,
           DAE.MUL_ARRAY_SCALAR(ty = i_ty) )
      equation
        txt = expTypeShort(txt, i_ty);
      then txt;

    case ( txt,
           DAE.ADD_ARRAY_SCALAR(ty = i_ty) )
      equation
        txt = expTypeShort(txt, i_ty);
      then txt;

    case ( txt,
           DAE.SUB_SCALAR_ARRAY(ty = i_ty) )
      equation
        txt = expTypeShort(txt, i_ty);
      then txt;

    case ( txt,
           DAE.MUL_SCALAR_PRODUCT(ty = i_ty) )
      equation
        txt = expTypeShort(txt, i_ty);
      then txt;

    case ( txt,
           DAE.MUL_MATRIX_PRODUCT(ty = i_ty) )
      equation
        txt = expTypeShort(txt, i_ty);
      then txt;

    case ( txt,
           DAE.DIV_ARRAY_SCALAR(ty = i_ty) )
      equation
        txt = expTypeShort(txt, i_ty);
      then txt;

    case ( txt,
           DAE.DIV_SCALAR_ARRAY(ty = i_ty) )
      equation
        txt = expTypeShort(txt, i_ty);
      then txt;

    case ( txt,
           DAE.POW_ARRAY_SCALAR(ty = i_ty) )
      equation
        txt = expTypeShort(txt, i_ty);
      then txt;

    case ( txt,
           DAE.POW_SCALAR_ARRAY(ty = i_ty) )
      equation
        txt = expTypeShort(txt, i_ty);
      then txt;

    case ( txt,
           DAE.POW_ARR(ty = i_ty) )
      equation
        txt = expTypeShort(txt, i_ty);
      then txt;

    case ( txt,
           DAE.POW_ARR2(ty = i_ty) )
      equation
        txt = expTypeShort(txt, i_ty);
      then txt;

    case ( txt,
           DAE.LESS(ty = i_ty) )
      equation
        txt = expTypeShort(txt, i_ty);
      then txt;

    case ( txt,
           DAE.LESSEQ(ty = i_ty) )
      equation
        txt = expTypeShort(txt, i_ty);
      then txt;

    case ( txt,
           DAE.GREATER(ty = i_ty) )
      equation
        txt = expTypeShort(txt, i_ty);
      then txt;

    case ( txt,
           DAE.GREATEREQ(ty = i_ty) )
      equation
        txt = expTypeShort(txt, i_ty);
      then txt;

    case ( txt,
           DAE.EQUAL(ty = i_ty) )
      equation
        txt = expTypeShort(txt, i_ty);
      then txt;

    case ( txt,
           DAE.NEQUAL(ty = i_ty) )
      equation
        txt = expTypeShort(txt, i_ty);
      then txt;

    case ( txt,
           DAE.AND(ty = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("bool"));
      then txt;

    case ( txt,
           DAE.OR(ty = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("bool"));
      then txt;

    case ( txt,
           DAE.NOT(ty = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("bool"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("expTypeFromOp:ERROR"));
      then txt;
  end match;
end expTypeFromOp;

protected function lm_363
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      DAE.Exp i_e;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_e :: rest )
      equation
        txt = ExpressionDumpTpl.dumpExp(txt, i_e, "\"");
        txt = Tpl.nextIter(txt);
        txt = lm_363(txt, rest);
      then txt;
  end match;
end lm_363;

protected function lm_364
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_retStruct;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_preExp, in_a_context, in_a_retStruct)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      Tpl.Text a_retStruct;
      Integer x_i1;
      DAE.Exp i_cr;
      Tpl.Text l_rhsStr;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           a_preExp,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);

    case ( txt,
           i_cr :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp,
           a_context,
           a_retStruct )
      equation
        x_i1 = Tpl.getIteri_i0(txt);
        l_rhsStr = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("get<"));
        l_rhsStr = Tpl.writeStr(l_rhsStr, intString(x_i1));
        l_rhsStr = Tpl.writeTok(l_rhsStr, Tpl.ST_STRING(">("));
        l_rhsStr = Tpl.writeText(l_rhsStr, a_retStruct);
        l_rhsStr = Tpl.writeTok(l_rhsStr, Tpl.ST_STRING(".data)"));
        (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = writeLhsCref(txt, i_cr, Tpl.textString(l_rhsStr), a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = lm_364(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context, a_retStruct);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);
  end match;
end lm_364;

public function algStmtTupleAssign
  input Tpl.Text in_txt;
  input DAE.Statement in_a_stmt;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_stmt, in_a_context, in_a_varDecls, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_varDecls;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      DAE.Exp i_exp;
      list<DAE.Exp> i_expExpLst;
      Tpl.Text l_lhsCrefs;
      Tpl.Text l_retStruct;
      Tpl.Text l_marker;
      Tpl.Text l_crefs;
      Tpl.Text l_preExp;

    case ( txt,
           DAE.STMT_TUPLE_ASSIGN(exp = (i_exp as DAE.CALL(path = _)), expExpLst = i_expExpLst),
           a_context,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_preExp = Tpl.emptyTxt;
        l_crefs = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_crefs = lm_363(l_crefs, i_expExpLst);
        l_crefs = Tpl.popIter(l_crefs);
        l_marker = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("("));
        l_marker = Tpl.writeText(l_marker, l_crefs);
        l_marker = Tpl.writeTok(l_marker, Tpl.ST_STRING(") = "));
        l_marker = ExpressionDumpTpl.dumpExp(l_marker, i_exp, "\"");
        (l_retStruct, l_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_exp, a_context, l_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        l_lhsCrefs = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_lhsCrefs, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, l_preExp) = lm_364(l_lhsCrefs, i_expExpLst, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, l_preExp, a_context, l_retStruct);
        l_lhsCrefs = Tpl.popIter(l_lhsCrefs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("// algStmtTupleAssign: preExp "));
        txt = Tpl.writeText(txt, l_marker);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("// algStmtTupleAssign: writeLhsCref\n"));
        txt = Tpl.writeText(txt, l_lhsCrefs);
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      equation
        txt = error(txt, Tpl.sourceInfo("CodegenCppCommon.tpl", 2743, 12), "algStmtTupleAssign failed");
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end algStmtTupleAssign;

public function error
  input Tpl.Text txt;
  input SourceInfo a_srcInfo;
  input String a_errMessage;

  output Tpl.Text out_txt;
protected
  String ret_0;
algorithm
  Tpl.addSourceTemplateError(a_errMessage, a_srcInfo);
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING("#error \""));
  ret_0 := Error.infoStr(a_srcInfo);
  out_txt := Tpl.writeStr(out_txt, ret_0);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING(" "));
  out_txt := Tpl.writeStr(out_txt, a_errMessage);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("\""));
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_NEW_LINE());
end error;

public function errorMsg
  input Tpl.Text txt;
  input String a_errMessage;

  output Tpl.Text out_txt;
algorithm
  Tpl.addTemplateError(a_errMessage);
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING("#error \""));
  out_txt := Tpl.writeStr(out_txt, a_errMessage);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("\""));
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_NEW_LINE());
end errorMsg;

protected function fun_368
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_expStr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_expStr)
    local
      Tpl.Text txt;
      String a_expStr;

    case ( txt,
           false,
           a_expStr )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeStr(txt, a_expStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           _,
           a_expStr )
      equation
        txt = Tpl.writeStr(txt, a_expStr);
      then txt;
  end match;
end fun_368;

public function encloseInParantheses
  input Tpl.Text txt;
  input String a_expStr;

  output Tpl.Text out_txt;
protected
  Boolean ret_2;
  Integer ret_1;
  Integer ret_0;
algorithm
  ret_0 := stringGet(a_expStr, 1);
  ret_1 := stringGet("(", 1);
  ret_2 := intEq(ret_0, ret_1);
  out_txt := fun_368(txt, ret_2, a_expStr);
end encloseInParantheses;

protected function fun_370
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;
  input String in_a_lhsStr;
  input String in_a_rhsStr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty, in_a_lhsStr, in_a_rhsStr)
    local
      Tpl.Text txt;
      String a_lhsStr;
      String a_rhsStr;
      DAE.Type i_elty;
      DAE.Dimensions i_dims;
      Integer ret_2;
      Tpl.Text l_arrayWrapper;
      Tpl.Text l_dimstr;

    case ( txt,
           DAE.T_ARRAY(ty = i_elty, dims = i_dims),
           a_lhsStr,
           a_rhsStr )
      equation
        l_dimstr = listDimsFlat(Tpl.emptyTxt, i_dims, i_elty);
        l_arrayWrapper = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("tmp"));
        ret_2 = System.tmpTick();
        l_arrayWrapper = Tpl.writeStr(l_arrayWrapper, intString(ret_2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "/*assign through wrapper array*/\n",
                                    "StatArrayDim"
                                }, false));
        txt = nDimsFlat(txt, i_dims, i_elty, 0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<"));
        txt = expTypeShort(txt, i_elty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, l_dimstr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", true> "));
        txt = Tpl.writeText(txt, l_arrayWrapper);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(&"));
        txt = Tpl.writeStr(txt, a_lhsStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ");\n",
                                    "assignRowMajorData("
                                }, false));
        txt = Tpl.writeStr(txt, a_rhsStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".getData(), "));
        txt = Tpl.writeText(txt, l_arrayWrapper);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_370;

public function assignJacArray
  input Tpl.Text txt;
  input String a_lhsStr;
  input String a_rhsStr;
  input DAE.Type a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_370(txt, a_ty, a_lhsStr, a_rhsStr);
end assignJacArray;

protected function fun_372
  input Tpl.Text in_txt;
  input BackendDAE.VarKind in_a_varKind;
  input DAE.Type in_a_ty;
  input String in_a_rhsStr;
  input Tpl.Text in_a_lhsStr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_varKind, in_a_ty, in_a_rhsStr, in_a_lhsStr)
    local
      Tpl.Text txt;
      DAE.Type a_ty;
      String a_rhsStr;
      Tpl.Text a_lhsStr;

    case ( txt,
           BackendDAE.JAC_VAR(),
           a_ty,
           a_rhsStr,
           a_lhsStr )
      equation
        txt = assignJacArray(txt, Tpl.textString(a_lhsStr), a_rhsStr, a_ty);
      then txt;

    case ( txt,
           BackendDAE.JAC_DIFF_VAR(),
           a_ty,
           a_rhsStr,
           a_lhsStr )
      equation
        txt = assignJacArray(txt, Tpl.textString(a_lhsStr), a_rhsStr, a_ty);
      then txt;

    case ( txt,
           BackendDAE.SEED_VAR(),
           a_ty,
           a_rhsStr,
           a_lhsStr )
      equation
        txt = assignJacArray(txt, Tpl.textString(a_lhsStr), a_rhsStr, a_ty);
      then txt;

    case ( txt,
           _,
           _,
           a_rhsStr,
           a_lhsStr )
      equation
        txt = Tpl.writeText(txt, a_lhsStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".assign("));
        txt = Tpl.writeStr(txt, a_rhsStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;
  end match;
end fun_372;

protected function fun_373
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_mArg;
  input DAE.Type in_a_ty;
  input String in_a_rhsStr;
  input Tpl.Text in_a_lhsStr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_ty, in_a_rhsStr, in_a_lhsStr)
    local
      Tpl.Text txt;
      DAE.Type a_ty;
      String a_rhsStr;
      Tpl.Text a_lhsStr;
      BackendDAE.VarKind i_varKind;

    case ( txt,
           SimCodeVar.SIMVAR(varKind = i_varKind),
           a_ty,
           a_rhsStr,
           a_lhsStr )
      equation
        txt = fun_372(txt, i_varKind, a_ty, a_rhsStr, a_lhsStr);
      then txt;

    case ( txt,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_373;

protected function fun_374
  input Tpl.Text in_txt;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_lhsStr;
  input String in_a_rhsStr;
  input DAE.Type in_a_t;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_context, in_a_lhsStr, in_a_rhsStr, in_a_t)
    local
      Tpl.Text txt;
      Tpl.Text a_lhsStr;
      String a_rhsStr;
      DAE.Type a_t;

    case ( txt,
           SimCodeFunction.SIMULATION_CONTEXT(genDiscrete = _),
           a_lhsStr,
           a_rhsStr,
           a_t )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("usub_"));
        txt = expTypeShort(txt, a_t);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_array(&"));
        txt = Tpl.writeStr(txt, a_rhsStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "copy_"
                                }, false));
        txt = expTypeShort(txt, a_t);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_array_data_mem(&"));
        txt = Tpl.writeStr(txt, a_rhsStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", &"));
        txt = Tpl.writeText(txt, a_lhsStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;

    case ( txt,
           _,
           a_lhsStr,
           a_rhsStr,
           _ )
      equation
        txt = Tpl.writeText(txt, a_lhsStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = -"));
        txt = Tpl.writeStr(txt, a_rhsStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_374;

protected function lm_375
  input Tpl.Text in_txt;
  input list<DAE.Var> in_items;
  input String in_a_rhsStr;
  input Tpl.Text in_a_lhsStr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_rhsStr, in_a_lhsStr)
    local
      Tpl.Text txt;
      list<DAE.Var> rest;
      String a_rhsStr;
      Tpl.Text a_lhsStr;
      DAE.Ident i_var_name;

    case ( txt,
           {},
           _,
           _ )
      then txt;

    case ( txt,
           DAE.TYPES_VAR(name = i_var_name) :: rest,
           a_rhsStr,
           a_lhsStr )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeText(txt, a_lhsStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("P_"));
        txt = Tpl.writeStr(txt, i_var_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_ = "));
        txt = Tpl.writeStr(txt, a_rhsStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("."));
        txt = Tpl.writeStr(txt, i_var_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_;"));
        txt = Tpl.nextIter(txt);
        txt = lm_375(txt, rest, a_rhsStr, a_lhsStr);
      then txt;

    case ( txt,
           _ :: rest,
           a_rhsStr,
           a_lhsStr )
      equation
        txt = lm_375(txt, rest, a_rhsStr, a_lhsStr);
      then txt;
  end match;
end lm_375;

protected function fun_376
  input Tpl.Text in_txt;
  input SimCodeFunction.Context in_a_context;
  input list<DAE.Var> in_a_varLst;
  input DAE.ComponentRef in_a_cr;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input String in_a_rhsStr;
  input DAE.Exp in_a_exp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_a_context, in_a_varLst, in_a_cr, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_preExp, in_a_rhsStr, in_a_exp)
    local
      Tpl.Text txt;
      list<DAE.Var> a_varLst;
      DAE.ComponentRef a_cr;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      String a_rhsStr;
      DAE.Exp a_exp;
      SimCodeFunction.Context i_context;
      DAE.ComponentRef ret_1;
      Tpl.Text l_lhsStr;

    case ( txt,
           (i_context as SimCodeFunction.FUNCTION_CONTEXT(cref_prefix = _)),
           _,
           _,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp,
           a_rhsStr,
           a_exp )
      equation
        (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = writeLhsCref1(txt, a_exp, a_rhsStr, i_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);

    case ( txt,
           i_context,
           a_varLst,
           a_cr,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp,
           a_rhsStr,
           _ )
      equation
        ret_1 = ComponentReference.crefStripSubs(a_cr);
        (l_lhsStr, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = contextCref(Tpl.emptyTxt, ret_1, i_context, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_375(txt, a_varLst, a_rhsStr, l_lhsStr);
        txt = Tpl.popIter(txt);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);
  end match;
end fun_376;

protected function fun_377
  input Tpl.Text in_txt;
  input Integer in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;
      Integer i_i;

    case ( txt,
           1 )
      then txt;

    case ( txt,
           i_i )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeStr(txt, intString(i_i));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("D"));
      then txt;
  end match;
end fun_377;

protected function lm_378
  input Tpl.Text in_txt;
  input list<Integer> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<Integer> rest;
      Integer i_i;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_i :: rest )
      equation
        txt = Tpl.writeStr(txt, intString(i_i));
        txt = Tpl.nextIter(txt);
        txt = lm_378(txt, rest);
      then txt;
  end match;
end lm_378;

protected function lm_379
  input Tpl.Text in_txt;
  input list<tuple<DAE.Exp, list<Integer>>> in_items;
  input String in_a_rhsStr;
  input Tpl.Text in_a_fcallsuf;
  input Tpl.Text in_a_typeShort;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_rhsStr, in_a_fcallsuf, in_a_typeShort, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<tuple<DAE.Exp, list<Integer>>> rest;
      String a_rhsStr;
      Tpl.Text a_fcallsuf;
      Tpl.Text a_typeShort;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      list<Integer> i_indxs;
      DAE.Exp i_lhs;
      Tpl.Text l_indxstr;
      Tpl.Text l_lhsstr;

    case ( txt,
           {},
           _,
           _,
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);

    case ( txt,
           (i_lhs, i_indxs) :: rest,
           a_rhsStr,
           a_fcallsuf,
           a_typeShort,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (l_lhsstr, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = scalarLhsCref(Tpl.emptyTxt, i_lhs, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        l_indxstr = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_indxstr = lm_378(l_indxstr, i_indxs);
        l_indxstr = Tpl.popIter(l_indxstr);
        txt = Tpl.writeText(txt, l_lhsstr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, a_typeShort);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_get"));
        txt = Tpl.writeText(txt, a_fcallsuf);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(&"));
        txt = Tpl.writeStr(txt, a_rhsStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, l_indxstr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");/*writeLhsCref2*/"));
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = lm_379(txt, rest, a_rhsStr, a_fcallsuf, a_typeShort, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);
  end match;
end lm_379;

public function writeLhsCref
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input String in_a_rhsStr;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_exp, in_a_rhsStr, in_a_context, in_a_preExp, in_a_varDecls, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      String a_rhsStr;
      SimCodeFunction.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      list<DAE.Exp> i_expl;
      DAE.Dimensions i_dims;
      list<DAE.Var> i_varLst;
      DAE.Exp i_exp;
      DAE.Type i_t;
      DAE.Exp i_e;
      DAE.Type i_ty;
      DAE.ComponentRef i_cr;
      DAE.Exp i_ecr;
      Tpl.Text txt_9;
      Tpl.Text txt_8;
      list<tuple<DAE.Exp, list<Integer>>> ret_7;
      list<list<Integer>> ret_6;
      Tpl.Text l_body;
      Integer ret_4;
      Tpl.Text l_fcallsuf;
      Tpl.Text l_typeShort;
      SimCodeVar.SimVar ret_1;
      Tpl.Text l_lhsStr;

    case ( txt,
           DAE.CREF(componentRef = DAE.WILD()),
           _,
           _,
           a_preExp,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           (i_ecr as DAE.CREF(componentRef = i_cr, ty = (i_ty as DAE.T_ARRAY(ty = _)))),
           a_rhsStr,
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (l_lhsStr, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = scalarLhsCref(Tpl.emptyTxt, i_ecr, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        ret_1 = SimCodeUtil.cref2simvar(i_cr, a_simCode);
        txt = fun_373(txt, ret_1, i_ty, a_rhsStr, l_lhsStr);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.UNARY(exp = (i_e as DAE.CREF(ty = (i_t as DAE.T_ARRAY(ty = _))))),
           a_rhsStr,
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (l_lhsStr, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = scalarLhsCref(Tpl.emptyTxt, i_e, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = fun_374(txt, a_context, l_lhsStr, a_rhsStr, i_t);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           (i_exp as DAE.CREF(componentRef = i_cr, ty = DAE.T_COMPLEX(varLst = i_varLst, complexClassType = ClassInf.RECORD(path = _)))),
           a_rhsStr,
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = fun_376(txt, a_context, i_varLst, i_cr, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_rhsStr, i_exp);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           (i_exp as DAE.CREF(componentRef = _)),
           a_rhsStr,
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = writeLhsCref1(txt, i_exp, a_rhsStr, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.UNARY(exp = (i_e as DAE.CREF(componentRef = _))),
           a_rhsStr,
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (l_lhsStr, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = scalarLhsCref(Tpl.emptyTxt, i_e, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeText(txt, l_lhsStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = -"));
        txt = Tpl.writeStr(txt, a_rhsStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.ARRAY(array = {}),
           _,
           _,
           a_preExp,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           (i_exp as DAE.ARRAY(ty = DAE.T_ARRAY(ty = _, dims = i_dims), array = i_expl)),
           a_rhsStr,
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_typeShort = expTypeFromExpShort(Tpl.emptyTxt, i_exp);
        ret_4 = listLength(i_dims);
        l_fcallsuf = fun_377(Tpl.emptyTxt, ret_4);
        ret_6 = SimCodeUtil.dimsToAllIndexes(i_dims);
        ret_7 = List.zip(i_expl, ret_6);
        l_body = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_body, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = lm_379(l_body, ret_7, a_rhsStr, l_fcallsuf, l_typeShort, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context);
        l_body = Tpl.popIter(l_body);
        txt = Tpl.writeText(txt, l_body);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.ASUB(exp = i_exp),
           a_rhsStr,
           _,
           a_preExp,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      equation
        txt_8 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("writeLhsCref UNHANDLED ASUB (should never be part of a lhs expression): "));
        txt_8 = ExpressionDumpTpl.dumpExp(txt_8, i_exp, "\"");
        txt_8 = Tpl.writeTok(txt_8, Tpl.ST_STRING(" = "));
        txt_8 = Tpl.writeStr(txt_8, a_rhsStr);
        txt = error(txt, Tpl.sourceInfo("CodegenCppCommon.tpl", 2859, 9), Tpl.textString(txt_8));
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           i_exp,
           a_rhsStr,
           _,
           a_preExp,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      equation
        txt_9 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("writeLhsCref UNHANDLED: "));
        txt_9 = ExpressionDumpTpl.dumpExp(txt_9, i_exp, "\"");
        txt_9 = Tpl.writeTok(txt_9, Tpl.ST_STRING(" = "));
        txt_9 = Tpl.writeStr(txt_9, a_rhsStr);
        txt = error(txt, Tpl.sourceInfo("CodegenCppCommon.tpl", 2861, 9), Tpl.textString(txt_9));
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end writeLhsCref;

public function writeLhsCref1
  input Tpl.Text txt;
  input DAE.Exp a_exp;
  input String a_rhsStr;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_preExp;
  input Tpl.Text a_varDecls;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
protected
  Tpl.Text l_lhsStr;
algorithm
  (l_lhsStr, out_a_preExp, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) := scalarLhsCref(Tpl.emptyTxt, a_exp, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
  out_txt := Tpl.writeText(txt, l_lhsStr);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING(" = "));
  out_txt := Tpl.writeStr(out_txt, a_rhsStr);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING(" /*writeLhsCref1*/;"));
end writeLhsCref1;

protected function fun_382
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input DAE.ComponentRef in_a_ecr_componentRef;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;
  input DAE.Exp in_a_ecr;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_mArg, in_a_ecr_componentRef, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_preExp, in_a_context, in_a_ecr)
    local
      Tpl.Text txt;
      DAE.ComponentRef a_ecr_componentRef;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Exp a_ecr;

    case ( txt,
           false,
           _,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp,
           a_context,
           a_ecr )
      equation
        (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExpCrefRhs(txt, a_ecr, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);

    case ( txt,
           _,
           a_ecr_componentRef,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp,
           a_context,
           _ )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = contextCref(txt, a_ecr_componentRef, a_context, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);
  end match;
end fun_382;

protected function fun_383
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input DAE.ComponentRef in_a_ecr_componentRef;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input SimCodeFunction.Context in_a_context;
  input DAE.ComponentRef in_a_cr;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_varDecls, out_a_preExp, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_mArg, in_a_ecr_componentRef, in_a_varDecls, in_a_preExp, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_context, in_a_cr)
    local
      Tpl.Text txt;
      DAE.ComponentRef a_ecr_componentRef;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      SimCodeFunction.Context a_context;
      DAE.ComponentRef a_cr;
      list<DAE.Subscript> ret_3;
      list<DAE.Dimension> ret_2;
      DAE.ComponentRef ret_1;
      Tpl.Text l_arrName;

    case ( txt,
           false,
           _,
           a_varDecls,
           a_preExp,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_context,
           a_cr )
      equation
        ret_1 = ComponentReference.crefStripSubs(a_cr);
        (l_arrName, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = contextCref(Tpl.emptyTxt, ret_1, a_context, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeText(txt, l_arrName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        ret_2 = ComponentReference.crefDims(a_cr);
        ret_3 = ComponentReference.crefSubs(a_cr);
        (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = threadDimSubList(txt, ret_2, ret_3, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_varDecls, a_preExp, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           a_ecr_componentRef,
           a_varDecls,
           a_preExp,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_context,
           _ )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = contextCref(txt, a_ecr_componentRef, a_context, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_varDecls, a_preExp, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_383;

public function scalarLhsCref
  input Tpl.Text in_txt;
  input DAE.Exp in_a_ecr;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_ecr, in_a_context, in_a_preExp, in_a_varDecls, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      DAE.ComponentRef i_cr;
      DAE.Exp i_ecr;
      DAE.ComponentRef i_ecr_componentRef;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           (i_ecr as DAE.CREF(componentRef = (i_ecr_componentRef as DAE.CREF_IDENT(subscriptLst = _)))),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        ret_0 = SimCodeFunctionUtil.crefNoSub(i_ecr_componentRef);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = fun_382(txt, ret_0, i_ecr_componentRef, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context, i_ecr);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.CREF(componentRef = (i_cr as (i_ecr_componentRef as DAE.CREF_QUAL(ident = _)))),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        ret_1 = SimCodeFunctionUtil.crefIsScalar(i_cr, a_context);
        (txt, a_varDecls, a_preExp, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_383(txt, ret_1, i_ecr_componentRef, a_varDecls, a_preExp, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_context, i_cr);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.CREF(componentRef = (i_ecr_componentRef as DAE.CREF_QUAL(ident = _))),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = contextCref(txt, i_ecr_componentRef, a_context, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           a_preExp,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("ONLY_IDENT_OR_QUAL_CREF_SUPPORTED_SLHS"));
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end scalarLhsCref;

protected function fun_385
  input Tpl.Text in_txt;
  input list<DAE.Dimension> in_a_dims;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;
  input DAE.Exp in_a_sub_exp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_a_dims, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_preExp, in_a_context, in_a_sub_exp)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Exp a_sub_exp;
      Tpl.Text l_estr;

    case ( txt,
           {_},
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp,
           a_context,
           a_sub_exp )
      equation
        (l_estr, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, a_sub_exp, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeText(txt, l_estr);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);

    case ( txt,
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           a_preExp,
           _,
           _ )
      equation
        txt = error(txt, Tpl.sourceInfo("CodegenCppCommon.tpl", 2908, 16), "Less subscripts that dimensions in indexing cref? That\'s odd!");
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);
  end match;
end fun_385;

protected function fun_386
  input Tpl.Text in_txt;
  input list<DAE.Subscript> in_a_subrest;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;
  input list<DAE.Dimension> in_a_dimrest;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_a_subrest, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_preExp, in_a_context, in_a_dimrest)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      list<DAE.Dimension> a_dimrest;
      list<DAE.Subscript> i_subrest;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           a_preExp,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);

    case ( txt,
           i_subrest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp,
           a_context,
           a_dimrest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = threadDimSubList(txt, a_dimrest, i_subrest, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);
  end match;
end fun_386;

protected function fun_387
  input Tpl.Text in_txt;
  input list<DAE.Dimension> in_a_dims;
  input list<DAE.Subscript> in_a_subrest;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;
  input DAE.Exp in_a_sub_exp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_a_dims, in_a_subrest, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_preExp, in_a_context, in_a_sub_exp)
    local
      Tpl.Text txt;
      list<DAE.Subscript> a_subrest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Exp a_sub_exp;
      list<DAE.Dimension> i_dimrest;
      Tpl.Text l_estr;

    case ( txt,
           _ :: i_dimrest,
           a_subrest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp,
           a_context,
           a_sub_exp )
      equation
        (l_estr, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, a_sub_exp, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeText(txt, l_estr);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = fun_386(txt, a_subrest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context, i_dimrest);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);

    case ( txt,
           _,
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           a_preExp,
           _,
           _ )
      equation
        txt = error(txt, Tpl.sourceInfo("CodegenCppCommon.tpl", 2926, 18), "Less subscripts that dimensions in indexing cref? That\'s odd!");
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);
  end match;
end fun_387;

protected function fun_388
  input Tpl.Text in_txt;
  input list<DAE.Subscript> in_a_subs;
  input list<DAE.Dimension> in_a_dims;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_subs, in_a_dims, in_a_context, in_a_preExp, in_a_varDecls, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      list<DAE.Dimension> a_dims;
      SimCodeFunction.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      list<DAE.Subscript> i_subrest;
      DAE.Exp i_sub_exp;

    case ( txt,
           {},
           _,
           _,
           a_preExp,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      equation
        txt = error(txt, Tpl.sourceInfo("CodegenCppCommon.tpl", 2901, 22), "Empty dimensions in indexing cref?");
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           {DAE.INDEX(exp = i_sub_exp)},
           a_dims,
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = fun_385(txt, a_dims, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context, i_sub_exp);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.INDEX(exp = i_sub_exp) :: i_subrest,
           a_dims,
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = fun_387(txt, a_dims, i_subrest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context, i_sub_exp);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           _,
           a_preExp,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      equation
        txt = error(txt, Tpl.sourceInfo("CodegenCppCommon.tpl", 2927, 14), "Non-index subscript in indexing cref? That\'s odd!");
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end fun_388;

public function threadDimSubList
  input Tpl.Text txt;
  input list<DAE.Dimension> a_dims;
  input list<DAE.Subscript> a_subs;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_preExp;
  input Tpl.Text a_varDecls;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) := fun_388(txt, a_subs, a_dims, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
end threadDimSubList;

public function daeExpTsub
  input Tpl.Text in_txt;
  input DAE.Exp in_a_inExp;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_inExp, in_a_context, in_a_preExp, in_a_varDecls, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      DAE.Exp i_inExp;
      Integer i_ix;
      Absyn.Path i_p;
      DAE.Exp i_exp;
      Tpl.Text txt_5;
      Integer ret_4;
      Tpl.Text l_res;
      Tpl.Text l_retVar;
      Tpl.Text l_retType;
      Tpl.Text l_tuple__val;

    case ( txt,
           DAE.TSUB(ix = 1, exp = i_exp),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (l_tuple__val, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_exp, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("get<0>("));
        txt = Tpl.writeText(txt, l_tuple__val);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".data)"));
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.TSUB(exp = (i_exp as DAE.CALL(path = i_p, attr = DAE.CALL_ATTR(ty = DAE.T_TUPLE(types = _)))), ix = i_ix),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_retType = CodegenUtil.underscorePath(Tpl.emptyTxt, i_p);
        l_retType = Tpl.writeTok(l_retType, Tpl.ST_STRING("RetType /* undefined */"));
        (l_retVar, a_varDecls) = tempDecl(Tpl.emptyTxt, Tpl.textString(l_retType), a_varDecls);
        (l_res, l_retVar, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExpCallTuple(Tpl.emptyTxt, i_exp, l_retVar, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        a_preExp = Tpl.writeText(a_preExp, l_res);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(";"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("get<"));
        ret_4 = intAdd(-1, i_ix);
        txt = Tpl.writeStr(txt, intString(ret_4));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(">("));
        txt = Tpl.writeText(txt, l_retVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".data)"));
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           (i_inExp as DAE.TSUB(exp = _)),
           _,
           a_preExp,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      equation
        txt_5 = ExpressionDumpTpl.dumpExp(Tpl.emptyTxt, i_inExp, "\"");
        txt_5 = Tpl.writeTok(txt_5, Tpl.ST_STRING(": TSUB only makes sense if the subscripted expression is a function call of tuple type"));
        txt = error(txt, Tpl.sourceInfo("CodegenCppCommon.tpl", 2952, 11), Tpl.textString(txt_5));
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           a_preExp,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end daeExpTsub;

protected function lm_391
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Exp i_exp;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);

    case ( txt,
           i_exp :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(txt, i_exp, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = lm_391(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);
  end match;
end lm_391;

protected function lm_392
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Exp i_exp;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);

    case ( txt,
           i_exp :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(txt, i_exp, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = lm_392(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);
  end match;
end lm_392;

protected function fun_393
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;
  input list<DAE.Exp> in_a_expLst;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_mArg, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_preExp, in_a_context, in_a_expLst)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      list<DAE.Exp> a_expLst;

    case ( txt,
           false,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp,
           a_context,
           a_expLst )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = lm_391(txt, a_expLst, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context);
        txt = Tpl.popIter(txt);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);

    case ( txt,
           _,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp,
           a_context,
           a_expLst )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = lm_392(txt, a_expLst, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context);
        txt = Tpl.popIter(txt);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);
  end match;
end fun_393;

protected function lm_394
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Exp i_exp;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);

    case ( txt,
           i_exp :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(txt, i_exp, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = lm_394(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);
  end match;
end lm_394;

protected function fun_395
  input Tpl.Text in_txt;
  input Boolean in_a_attr_isFunctionPointerCall;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input list<DAE.Exp> in_a_expLst;
  input DAE.Type in_a_attr_ty;
  input Tpl.Text in_a_additionalOutputs;
  input Tpl.Text in_a_argStr;
  input SimCodeFunction.Context in_a_context;
  input Absyn.Path in_a_path;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_a_attr_isFunctionPointerCall, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_preExp, in_a_expLst, in_a_attr_ty, in_a_additionalOutputs, in_a_argStr, in_a_context, in_a_path)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      list<DAE.Exp> a_expLst;
      DAE.Type a_attr_ty;
      Tpl.Text a_additionalOutputs;
      Tpl.Text a_argStr;
      SimCodeFunction.Context a_context;
      Absyn.Path a_path;
      Tpl.Text l_argStrPointer;
      Tpl.Text l_closure;
      Tpl.Text l_func;
      Tpl.Text l_typeCast2;
      Tpl.Text l_typeCast1;
      Tpl.Text l_name;

    case ( txt,
           false,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           a_preExp,
           _,
           _,
           a_additionalOutputs,
           a_argStr,
           a_context,
           a_path )
      equation
        l_name = CodegenUtil.underscorePath(Tpl.emptyTxt, a_path);
        txt = contextFunName(txt, Tpl.textString(l_name), a_context);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_argStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, a_additionalOutputs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);

    case ( txt,
           _,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp,
           a_expLst,
           a_attr_ty,
           a_additionalOutputs,
           a_argStr,
           a_context,
           a_path )
      equation
        (l_typeCast1, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = generateTypeCast(Tpl.emptyTxt, a_attr_ty, a_expLst, true, a_preExp, a_varDecls, a_context, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        (l_typeCast2, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = generateTypeCast(Tpl.emptyTxt, a_attr_ty, a_expLst, false, a_preExp, a_varDecls, a_context, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        l_name = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("_"));
        l_name = CodegenUtil.underscorePath(l_name, a_path);
        l_func = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("(MMC_FETCH(MMC_OFFSET(MMC_UNTAGPTR("));
        l_func = Tpl.writeText(l_func, l_name);
        l_func = Tpl.writeTok(l_func, Tpl.ST_STRING("), 1)))"));
        l_closure = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("(MMC_FETCH(MMC_OFFSET(MMC_UNTAGPTR("));
        l_closure = Tpl.writeText(l_closure, l_name);
        l_closure = Tpl.writeTok(l_closure, Tpl.ST_STRING("), 2)))"));
        l_argStrPointer = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("threadData, "));
        l_argStrPointer = Tpl.writeText(l_argStrPointer, l_closure);
        (l_argStrPointer, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = lm_394(l_argStrPointer, a_expLst, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/*Closure?*/"));
        txt = Tpl.writeText(txt, l_closure);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" ? ("));
        txt = Tpl.writeText(txt, l_typeCast1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, l_func);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") ("));
        txt = Tpl.writeText(txt, l_argStrPointer);
        txt = Tpl.writeText(txt, a_additionalOutputs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") : ("));
        txt = Tpl.writeText(txt, l_typeCast2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, l_func);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") ("));
        txt = Tpl.writeText(txt, a_argStr);
        txt = Tpl.writeText(txt, a_additionalOutputs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);
  end match;
end fun_395;

protected function fun_396
  input Tpl.Text in_txt;
  input DAE.Exp in_a_call;
  input Tpl.Text in_a_additionalOutputs;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_call, in_a_additionalOutputs, in_a_context, in_a_preExp, in_a_varDecls, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      Tpl.Text a_additionalOutputs;
      SimCodeFunction.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      DAE.Type i_attr_ty;
      Absyn.Path i_path;
      Boolean i_attr_isFunctionPointerCall;
      list<DAE.Exp> i_expLst;
      Boolean i_attr_builtin;
      Boolean ret_2;
      Boolean ret_1;
      Tpl.Text l_argStr;

    case ( txt,
           DAE.CALL(attr = DAE.CALL_ATTR(builtin = i_attr_builtin, isFunctionPointerCall = i_attr_isFunctionPointerCall, ty = i_attr_ty), expLst = i_expLst, path = i_path),
           a_additionalOutputs,
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        ret_1 = SimCodeFunctionUtil.isParallelFunctionContext(a_context);
        ret_2 = boolOr(i_attr_builtin, ret_1);
        (l_argStr, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = fun_393(Tpl.emptyTxt, ret_2, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context, i_expLst);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = fun_395(txt, i_attr_isFunctionPointerCall, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, i_expLst, i_attr_ty, a_additionalOutputs, l_argStr, a_context, i_path);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           _,
           a_preExp,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end fun_396;

public function daeExpCallTuple
  input Tpl.Text txt;
  input DAE.Exp a_call;
  input Tpl.Text a_additionalOutputs;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_preExp;
  input Tpl.Text a_varDecls;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_additionalOutputs;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) := fun_396(txt, a_call, a_additionalOutputs, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
  out_a_additionalOutputs := a_additionalOutputs;
end daeExpCallTuple;

protected function fun_398
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty)
    local
      Tpl.Text txt;

    case ( txt,
           DAE.T_NORETCALL() )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_metatype"));
      then txt;
  end match;
end fun_398;

protected function lm_399
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Exp i_e;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);

    case ( txt,
           i_e :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = expTypeFromExpArrayIf(txt, i_e, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = lm_399(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);
  end match;
end lm_399;

protected function lm_400
  input Tpl.Text in_txt;
  input list<DAE.Type> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<DAE.Type> rest;
      DAE.Type i_t;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_t :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = expTypeArrayIf(txt, i_t);
        txt = lm_400(txt, rest);
      then txt;
  end match;
end lm_400;

protected function fun_401
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty)
    local
      Tpl.Text txt;
      list<DAE.Type> i_tys;

    case ( txt,
           DAE.T_TUPLE(types = _ :: i_tys) )
      equation
        txt = lm_400(txt, i_tys);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_401;

protected function fun_402
  input Tpl.Text in_txt;
  input Boolean in_a_isClosure;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_isClosure)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", modelica_metatype"));
      then txt;
  end match;
end fun_402;

public function generateTypeCast
  input Tpl.Text txt;
  input DAE.Type a_ty;
  input list<DAE.Exp> a_es;
  input Boolean a_isClosure;
  input Tpl.Text a_preExp;
  input Tpl.Text a_varDecls;
  input SimCodeFunction.Context a_context;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
protected
  Tpl.Text l_outputs;
  Tpl.Text l_inputs;
  Tpl.Text l_ret;
algorithm
  l_ret := fun_398(Tpl.emptyTxt, a_ty);
  (l_inputs, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp) := lm_399(Tpl.emptyTxt, a_es, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context);
  l_outputs := fun_401(Tpl.emptyTxt, a_ty);
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING("("));
  out_txt := Tpl.writeText(out_txt, l_ret);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("(*)(threadData_t*"));
  out_txt := fun_402(out_txt, a_isClosure);
  out_txt := Tpl.writeText(out_txt, l_inputs);
  out_txt := Tpl.writeText(out_txt, l_outputs);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("))"));
end generateTypeCast;

protected function fun_404
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_exp, in_a_context)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Integer i_exp_index;
      Tpl.Text l_lit;

    case ( txt,
           DAE.SHARED_LITERAL(index = i_exp_index),
           a_context )
      equation
        l_lit = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("_OMC_LIT"));
        l_lit = Tpl.writeStr(l_lit, intString(i_exp_index));
        txt = contextFunName(txt, Tpl.textString(l_lit), a_context);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_404;

public function daeExpSharedLiteral
  input Tpl.Text txt;
  input DAE.Exp a_exp;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_preExp;
  input Tpl.Text a_varDecls;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
algorithm
  out_txt := fun_404(txt, a_exp, a_context);
  out_a_preExp := a_preExp;
  out_a_varDecls := a_varDecls;
end daeExpSharedLiteral;

protected function lm_406
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Exp i_e;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);

    case ( txt,
           i_e :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(txt, i_e, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = lm_406(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);
  end match;
end lm_406;

public function daeExpPartEvalFunction
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_exp, in_a_context, in_a_preExp, in_a_varDecls, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      DAE.Type i_origType;
      DAE.Type i_ty;
      DAE.Exp i_exp;
      DAE.Type i_t__orig;
      DAE.Type i_t;
      list<DAE.Exp> i_expList;
      Absyn.Path i_name;
      Tpl.Text txt_2;
      String ret_3;
      String ret_2;
      Tpl.Text l_closureArgs;
      Tpl.Text l_funcName;

    case ( txt,
           DAE.PARTEVALFUNCTION(ty = DAE.T_FUNCTION_REFERENCE_VAR(functionType = i_t), origType = DAE.T_FUNCTION_REFERENCE_VAR(functionType = (i_t__orig as DAE.T_FUNCTION(path = i_name))), expList = i_expList),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_funcName = CodegenUtil.underscorePath(Tpl.emptyTxt, i_name);
        (l_closureArgs, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = lm_406(Tpl.emptyTxt, i_expList, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context);
        (txt, a_extraFuncsDecl) = functionClosure(txt, Tpl.textString(l_funcName), Tpl.textString(l_closureArgs), i_t, i_t__orig, a_context, a_extraFuncsDecl);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           (i_exp as DAE.PARTEVALFUNCTION(ty = i_ty, origType = i_origType)),
           _,
           a_preExp,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      equation
        txt_2 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("PARTEVALFUNCTION: "));
        txt_2 = ExpressionDumpTpl.dumpExp(txt_2, i_exp, "\"");
        txt_2 = Tpl.writeTok(txt_2, Tpl.ST_STRING(", ty="));
        ret_2 = Types.unparseType(i_ty);
        txt_2 = Tpl.writeStr(txt_2, ret_2);
        txt_2 = Tpl.writeTok(txt_2, Tpl.ST_STRING(", origType="));
        ret_3 = Types.unparseType(i_origType);
        txt_2 = Tpl.writeStr(txt_2, ret_3);
        txt = error(txt, Tpl.sourceInfo("CodegenCppCommon.tpl", 3008, 11), Tpl.textString(txt_2));
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           a_preExp,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end daeExpPartEvalFunction;

protected function fun_408
  input Tpl.Text in_txt;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_context)
    local
      Tpl.Text txt;

    case ( txt,
           SimCodeFunction.FUNCTION_CONTEXT(cref_prefix = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("this"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_functions"));
      then txt;
  end match;
end fun_408;

protected function lm_409
  input Tpl.Text in_txt;
  input list<DAE.FuncArg> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<DAE.FuncArg> rest;
      String i_a_name;
      DAE.Type i_a_ty;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           DAE.FUNCARG(ty = i_a_ty, name = i_a_name) :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = expTypeUnboxed(txt, i_a_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeStr(txt, i_a_name);
        txt = lm_409(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_409(txt, rest);
      then txt;
  end match;
end lm_409;

protected function lm_410
  input Tpl.Text in_txt;
  input list<DAE.FuncArg> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<DAE.FuncArg> rest;
      String i_a_name;
      DAE.Type i_a_ty;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           DAE.FUNCARG(ty = i_a_ty, name = i_a_name) :: rest )
      equation
        txt = expTypeUnboxed(txt, i_a_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeStr(txt, i_a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = lm_410(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_410(txt, rest);
      then txt;
  end match;
end lm_410;

protected function lm_411
  input Tpl.Text in_txt;
  input list<DAE.FuncArg> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<DAE.FuncArg> rest;
      String i_a_name;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           DAE.FUNCARG(name = i_a_name) :: rest )
      equation
        txt = Tpl.writeStr(txt, i_a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = lm_411(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_411(txt, rest);
      then txt;
  end match;
end lm_411;

protected function lm_412
  input Tpl.Text in_txt;
  input list<DAE.FuncArg> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<DAE.FuncArg> rest;
      String i_a_name;
      DAE.Type i_a_ty;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           DAE.FUNCARG(ty = i_a_ty, name = i_a_name) :: rest )
      equation
        txt = expTypeUnboxed(txt, i_a_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeStr(txt, i_a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = lm_412(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_412(txt, rest);
      then txt;
  end match;
end lm_412;

protected function lm_413
  input Tpl.Text in_txt;
  input list<DAE.FuncArg> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<DAE.FuncArg> rest;
      String i_a_name;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           DAE.FUNCARG(name = i_a_name) :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeStr(txt, i_a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeStr(txt, i_a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = lm_413(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_413(txt, rest);
      then txt;
  end match;
end lm_413;

protected function fun_414
  input Tpl.Text in_txt;
  input DAE.Type in_a_t__orig;
  input String in_a_closureArgs;
  input Tpl.Text in_a_extraFuncsDecl;
  input list<DAE.FuncArg> in_a_funcArgs;
  input SimCodeFunction.Context in_a_context;
  input String in_a_funcName;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsDecl;
algorithm
  (out_txt, out_a_extraFuncsDecl) :=
  match(in_txt, in_a_t__orig, in_a_closureArgs, in_a_extraFuncsDecl, in_a_funcArgs, in_a_context, in_a_funcName)
    local
      Tpl.Text txt;
      String a_closureArgs;
      Tpl.Text a_extraFuncsDecl;
      list<DAE.FuncArg> a_funcArgs;
      SimCodeFunction.Context a_context;
      String a_funcName;
      list<DAE.FuncArg> i_funcArgsOrig;
      list<DAE.FuncArg> ret_8;
      list<DAE.FuncArg> ret_7;
      Tpl.Text l_callArgsOrig;
      Tpl.Text l_callArgsDecl;
      list<DAE.FuncArg> ret_4;
      Tpl.Text l_closureArgsDecl;
      Tpl.Text l_functionsObject;
      Integer ret_1;
      Tpl.Text l_closureName;

    case ( txt,
           DAE.T_FUNCTION(funcArg = i_funcArgsOrig),
           a_closureArgs,
           a_extraFuncsDecl,
           a_funcArgs,
           a_context,
           a_funcName )
      equation
        l_closureName = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("_Closure"));
        ret_1 = System.tmpTickIndex(2);
        l_closureName = Tpl.writeStr(l_closureName, intString(ret_1));
        l_closureName = Tpl.writeTok(l_closureName, Tpl.ST_STRING("_"));
        l_closureName = Tpl.writeStr(l_closureName, a_funcName);
        l_functionsObject = fun_408(Tpl.emptyTxt, a_context);
        ret_4 = List.setDifference(i_funcArgsOrig, a_funcArgs);
        l_closureArgsDecl = lm_409(Tpl.emptyTxt, ret_4);
        l_callArgsDecl = lm_410(Tpl.emptyTxt, a_funcArgs);
        l_callArgsOrig = lm_411(Tpl.emptyTxt, i_funcArgsOrig);
        a_extraFuncsDecl = Tpl.writeTok(a_extraFuncsDecl, Tpl.ST_STRING_LIST({
                                                              "\n",
                                                              "class "
                                                          }, false));
        a_extraFuncsDecl = Tpl.writeText(a_extraFuncsDecl, l_closureName);
        a_extraFuncsDecl = Tpl.softNewLine(a_extraFuncsDecl);
        a_extraFuncsDecl = Tpl.writeTok(a_extraFuncsDecl, Tpl.ST_STRING_LIST({
                                                              "{\n",
                                                              "  Functions* _functions;\n"
                                                          }, true));
        a_extraFuncsDecl = Tpl.pushBlock(a_extraFuncsDecl, Tpl.BT_INDENT(2));
        ret_7 = List.setDifference(i_funcArgsOrig, a_funcArgs);
        a_extraFuncsDecl = lm_412(a_extraFuncsDecl, ret_7);
        a_extraFuncsDecl = Tpl.softNewLine(a_extraFuncsDecl);
        a_extraFuncsDecl = Tpl.popBlock(a_extraFuncsDecl);
        a_extraFuncsDecl = Tpl.writeTok(a_extraFuncsDecl, Tpl.ST_LINE(" public:\n"));
        a_extraFuncsDecl = Tpl.pushBlock(a_extraFuncsDecl, Tpl.BT_INDENT(2));
        a_extraFuncsDecl = Tpl.writeText(a_extraFuncsDecl, l_closureName);
        a_extraFuncsDecl = Tpl.writeTok(a_extraFuncsDecl, Tpl.ST_STRING("(Functions* functions"));
        a_extraFuncsDecl = Tpl.writeText(a_extraFuncsDecl, l_closureArgsDecl);
        a_extraFuncsDecl = Tpl.writeTok(a_extraFuncsDecl, Tpl.ST_STRING_LIST({
                                                              ")\n",
                                                              "  : _functions(functions)\n"
                                                          }, true));
        a_extraFuncsDecl = Tpl.pushBlock(a_extraFuncsDecl, Tpl.BT_INDENT(2));
        ret_8 = List.setDifference(i_funcArgsOrig, a_funcArgs);
        a_extraFuncsDecl = lm_413(a_extraFuncsDecl, ret_8);
        a_extraFuncsDecl = Tpl.softNewLine(a_extraFuncsDecl);
        a_extraFuncsDecl = Tpl.popBlock(a_extraFuncsDecl);
        a_extraFuncsDecl = Tpl.writeTok(a_extraFuncsDecl, Tpl.ST_STRING_LIST({
                                                              "{}\n",
                                                              "void operator()("
                                                          }, false));
        a_extraFuncsDecl = Tpl.writeText(a_extraFuncsDecl, l_callArgsDecl);
        a_extraFuncsDecl = Tpl.writeStr(a_extraFuncsDecl, a_funcName);
        a_extraFuncsDecl = Tpl.writeTok(a_extraFuncsDecl, Tpl.ST_LINE("RetType &output) {\n"));
        a_extraFuncsDecl = Tpl.pushBlock(a_extraFuncsDecl, Tpl.BT_INDENT(2));
        a_extraFuncsDecl = Tpl.writeTok(a_extraFuncsDecl, Tpl.ST_STRING("_functions->"));
        a_extraFuncsDecl = Tpl.writeStr(a_extraFuncsDecl, a_funcName);
        a_extraFuncsDecl = Tpl.writeTok(a_extraFuncsDecl, Tpl.ST_STRING("("));
        a_extraFuncsDecl = Tpl.writeText(a_extraFuncsDecl, l_callArgsOrig);
        a_extraFuncsDecl = Tpl.writeTok(a_extraFuncsDecl, Tpl.ST_LINE("output);\n"));
        a_extraFuncsDecl = Tpl.popBlock(a_extraFuncsDecl);
        a_extraFuncsDecl = Tpl.writeTok(a_extraFuncsDecl, Tpl.ST_LINE("}\n"));
        a_extraFuncsDecl = Tpl.popBlock(a_extraFuncsDecl);
        a_extraFuncsDecl = Tpl.writeTok(a_extraFuncsDecl, Tpl.ST_STRING("};"));
        a_extraFuncsDecl = Tpl.writeTok(a_extraFuncsDecl, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_closureName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, l_functionsObject);
        txt = Tpl.writeStr(txt, a_closureArgs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_extraFuncsDecl);

    case ( txt,
           _,
           _,
           a_extraFuncsDecl,
           _,
           _,
           _ )
      then (txt, a_extraFuncsDecl);
  end match;
end fun_414;

protected function fun_415
  input Tpl.Text in_txt;
  input DAE.Type in_a_t;
  input String in_a_funcName;
  input String in_a_closureArgs;
  input DAE.Type in_a_t__orig;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_extraFuncsDecl;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsDecl;
algorithm
  (out_txt, out_a_extraFuncsDecl) :=
  match(in_txt, in_a_t, in_a_funcName, in_a_closureArgs, in_a_t__orig, in_a_context, in_a_extraFuncsDecl)
    local
      Tpl.Text txt;
      String a_funcName;
      String a_closureArgs;
      DAE.Type a_t__orig;
      SimCodeFunction.Context a_context;
      Tpl.Text a_extraFuncsDecl;
      list<DAE.FuncArg> i_funcArgs;

    case ( txt,
           DAE.T_FUNCTION(funcArg = i_funcArgs),
           a_funcName,
           a_closureArgs,
           a_t__orig,
           a_context,
           a_extraFuncsDecl )
      equation
        (txt, a_extraFuncsDecl) = fun_414(txt, a_t__orig, a_closureArgs, a_extraFuncsDecl, i_funcArgs, a_context, a_funcName);
      then (txt, a_extraFuncsDecl);

    case ( txt,
           _,
           _,
           _,
           _,
           _,
           a_extraFuncsDecl )
      then (txt, a_extraFuncsDecl);
  end match;
end fun_415;

public function functionClosure
  input Tpl.Text txt;
  input String a_funcName;
  input String a_closureArgs;
  input DAE.Type a_t;
  input DAE.Type a_t__orig;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_extraFuncsDecl;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsDecl;
algorithm
  (out_txt, out_a_extraFuncsDecl) := fun_415(txt, a_t, a_funcName, a_closureArgs, a_t__orig, a_context, a_extraFuncsDecl);
end functionClosure;

protected function fun_417
  input Tpl.Text in_txt;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_condVar;
  input Tpl.Text in_a_msgVar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_context, in_a_condVar, in_a_msgVar)
    local
      Tpl.Text txt;
      Tpl.Text a_condVar;
      Tpl.Text a_msgVar;

    case ( txt,
           SimCodeFunction.FUNCTION_CONTEXT(is_parallel = true),
           a_condVar,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if(!("));
        txt = Tpl.writeText(txt, a_condVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "))\n",
                                    "{\n",
                                    "\n",
                                    "  throw ModelicaSimulationError(MODEL_EQ_SYSTEM, \"Common assertion failed\");\n",
                                    "\n",
                                    "}"
                                }, false));
      then txt;

    case ( txt,
           SimCodeFunction.FUNCTION_CONTEXT(cref_prefix = _),
           a_condVar,
           a_msgVar )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if(!("));
        txt = Tpl.writeText(txt, a_condVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "))\n",
                                    "{\n",
                                    "\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("throw ModelicaSimulationError(MODEL_EQ_SYSTEM,  "));
        txt = Tpl.writeText(txt, a_msgVar);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(");\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;

    case ( txt,
           _,
           a_condVar,
           a_msgVar )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if(!("));
        txt = Tpl.writeText(txt, a_condVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "))\n",
                                    "{\n",
                                    "   //string error_msg = \"The following assertion has been violated %sat time %f\", initial() ? \"during initialization \" : \"\", data->localData[0]->timeValue);\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(3));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("throw ModelicaSimulationError(MODEL_EQ_SYSTEM,"));
        txt = Tpl.writeText(txt, a_msgVar);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(");\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;
  end match;
end fun_417;

public function assertCommonVar
  input Tpl.Text txt;
  input Tpl.Text a_condVar;
  input Tpl.Text a_msgVar;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_varDecls;
  input SourceInfo a_info;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_condVar;
  output Tpl.Text out_a_msgVar;
  output Tpl.Text out_a_varDecls;
algorithm
  out_txt := fun_417(txt, a_context, a_condVar, a_msgVar);
  out_a_condVar := a_condVar;
  out_a_msgVar := a_msgVar;
  out_a_varDecls := a_varDecls;
end assertCommonVar;

public function expTypeUnboxed
  input Tpl.Text in_txt;
  input DAE.Type in_a_t;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_t)
    local
      Tpl.Text txt;
      DAE.Type i_t;
      DAE.Type ret_0;

    case ( txt,
           (i_t as DAE.T_METABOXED(ty = _)) )
      equation
        ret_0 = Types.unboxedType(i_t);
        txt = expTypeFlag(txt, ret_0, 8);
      then txt;

    case ( txt,
           i_t )
      equation
        txt = expTypeFlag(txt, i_t, 8);
      then txt;
  end match;
end expTypeUnboxed;

protected function fun_420
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_elty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_elty)
    local
      Tpl.Text txt;
      Tpl.Text a_elty;

    case ( txt,
           false,
           a_elty )
      equation
        txt = Tpl.writeText(txt, a_elty);
      then txt;

    case ( txt,
           _,
           a_elty )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("BaseArray<"));
        txt = Tpl.writeText(txt, a_elty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(">"));
      then txt;
  end match;
end fun_420;

public function daeExpBox
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_exp, in_a_context, in_a_preExp, in_a_varDecls, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      DAE.Exp i_exp;
      Tpl.Text l_res;
      Boolean ret_3;
      DAE.Type ret_2;
      Tpl.Text l_ty;
      Tpl.Text l_elty;

    case ( txt,
           DAE.BOX(exp = i_exp),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_elty = expTypeFromExpShort(Tpl.emptyTxt, i_exp);
        ret_2 = Expression.typeof(i_exp);
        ret_3 = Expression.isArrayType(ret_2);
        l_ty = fun_420(Tpl.emptyTxt, ret_3, l_elty);
        (l_res, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_exp, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/*box "));
        txt = Tpl.writeText(txt, l_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("*/"));
        txt = Tpl.writeText(txt, l_res);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           a_preExp,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end daeExpBox;

public function daeExpUnbox
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_exp, in_a_context, in_a_preExp, in_a_varDecls, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      DAE.Exp i_exp_exp;
      DAE.Type i_exp_ty;
      Tpl.Text l_res;
      Tpl.Text l_ty;

    case ( txt,
           DAE.UNBOX(ty = i_exp_ty, exp = i_exp_exp),
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_ty = expTypeShort(Tpl.emptyTxt, i_exp_ty);
        (l_res, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExp(Tpl.emptyTxt, i_exp_exp, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/*unbox "));
        txt = Tpl.writeText(txt, l_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("*/"));
        txt = Tpl.writeText(txt, l_res);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           a_preExp,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end daeExpUnbox;

public function zeroCrossLength
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      Integer i_vi_numTimeEvents;
      list<BackendDAE.ZeroCrossing> i_zeroCrossings;
      Integer ret_3;
      Integer ret_2;
      Integer ret_1;
      Tpl.Text l_size;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(varInfo = SimCode.VARINFO(numTimeEvents = i_vi_numTimeEvents)), zeroCrossings = i_zeroCrossings) )
      equation
        ret_1 = listLength(i_zeroCrossings);
        l_size = Tpl.writeStr(Tpl.emptyTxt, intString(ret_1));
        ret_2 = listLength(i_zeroCrossings);
        ret_3 = intSub(ret_2, i_vi_numTimeEvents);
        txt = Tpl.writeStr(txt, intString(ret_3));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end zeroCrossLength;

public function timeEventLength
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      Integer i_vi_numTimeEvents;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(varInfo = SimCode.VARINFO(numTimeEvents = i_vi_numTimeEvents))) )
      equation
        txt = Tpl.writeStr(txt, intString(i_vi_numTimeEvents));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end timeEventLength;

annotation(__OpenModelica_Interface="backend");
end CodegenCppCommon;