encapsulated package CodegenCppOld
"
  file:        CodegenCppOld.mo
  package:     CodegenCppOld
  description: Generated by Susan.
"

public import Tpl;

public import SimCodeVar;
public import SimCode;
public import SimCodeFunction;
public import SimCodeUtil;
public import SimCodeFunctionUtil;
public import BackendDAE;
public import System;
public import Autoconf;
public import Absyn;
public import MMath;
public import DAE;
public import ClassInf;
public import SCode;
public import Util;
public import List;
public import ComponentReference;
public import Expression;
public import ExpressionDump;
public import Config;
public import Testsuite;
public import Flags;
public import Settings;
public import Error;
public import Values;
public import ValuesUtil;
public import Algorithm;
public import ElementSource;
public import Types;
public import HashTableCrIListArray;
public import CodegenCppCommonOld;
public import CodegenUtil;
public import CodegenUtilSimulation;
public import CodegenCppInit;
protected import ExpressionDumpTpl;

protected function fun_43
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_fileNamePrefix;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_className;
  input Tpl.Text in_a_extraFuncsDeclInit;
  input Tpl.Text in_a_extraFuncsInit;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsDeclInit;
  output Tpl.Text out_a_extraFuncsInit;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsDeclInit, out_a_extraFuncsInit) :=
  match(in_txt, in_mArg, in_a_fileNamePrefix, in_a_stateDerVectorName, in_a_className, in_a_extraFuncsDeclInit, in_a_extraFuncsInit, in_a_simCode)
    local
      Tpl.Text txt;
      String a_fileNamePrefix;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_className;
      Tpl.Text a_extraFuncsDeclInit;
      Tpl.Text a_extraFuncsInit;
      SimCode.SimCode a_simCode;
      Tpl.Text txt_5;
      Tpl.Text txt_4;
      Tpl.Text txt_3;
      Tpl.Text txt_2;
      Tpl.Text txt_1;
      Tpl.Text txt_0;

    case ( txt,
           true,
           a_fileNamePrefix,
           a_stateDerVectorName,
           a_className,
           a_extraFuncsDeclInit,
           a_extraFuncsInit,
           a_simCode )
      equation
        txt_0 = Tpl.writeText(Tpl.emptyTxt, a_className);
        txt_0 = Tpl.writeTok(txt_0, Tpl.ST_STRING("Initialize"));
        (txt_1, a_extraFuncsInit, a_extraFuncsDeclInit, txt_0, a_stateDerVectorName) = simulationInitParameterCppFile(Tpl.emptyTxt, a_simCode, a_extraFuncsInit, a_extraFuncsDeclInit, txt_0, a_stateDerVectorName, false);
        txt_2 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("OMCpp"));
        txt_2 = Tpl.writeStr(txt_2, a_fileNamePrefix);
        txt_2 = Tpl.writeTok(txt_2, Tpl.ST_STRING("InitializeParameter.cpp"));
        Tpl.textFile(txt_1, Tpl.textString(txt_2));
        txt_3 = Tpl.writeText(Tpl.emptyTxt, a_className);
        txt_3 = Tpl.writeTok(txt_3, Tpl.ST_STRING("Initialize"));
        (txt_4, a_extraFuncsInit, a_extraFuncsDeclInit, txt_3, a_stateDerVectorName) = simulationInitAlgVarsCppFile(Tpl.emptyTxt, a_simCode, a_extraFuncsInit, a_extraFuncsDeclInit, txt_3, a_stateDerVectorName, false);
        txt_5 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("OMCpp"));
        txt_5 = Tpl.writeStr(txt_5, a_fileNamePrefix);
        txt_5 = Tpl.writeTok(txt_5, Tpl.ST_STRING("InitializeAlgVars.cpp"));
        Tpl.textFile(txt_4, Tpl.textString(txt_5));
      then (txt, a_stateDerVectorName, a_extraFuncsDeclInit, a_extraFuncsInit);

    case ( txt,
           _,
           _,
           a_stateDerVectorName,
           _,
           a_extraFuncsDeclInit,
           a_extraFuncsInit,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsDeclInit, a_extraFuncsInit);
  end match;
end fun_43;

protected function lm_44
  input Tpl.Text in_txt;
  input list<SimCode.JacobianColumn> in_items;
  input Tpl.Text in_a_stateDerVectorName;
  input Integer in_a_partIdx;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_stateDerVectorName, in_a_partIdx, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCode.JacobianColumn> rest;
      Tpl.Text a_stateDerVectorName;
      Integer a_partIdx;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      list<SimCode.SimEqSystem> i_eqs;

    case ( txt,
           {},
           a_stateDerVectorName,
           _,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           SimCode.JAC_COLUMN(columnEqns = i_eqs) :: rest,
           a_stateDerVectorName,
           a_partIdx,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, _, a_stateDerVectorName) = algloopfiles(txt, i_eqs, a_simCode, a_extraFuncs, a_extraFuncsDecl, Tpl.strTokText(Tpl.ST_STRING("")), SimCodeFunction.contextAlgloopJacobian, a_partIdx, a_stateDerVectorName, false);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsDecl, a_extraFuncs) = lm_44(txt, rest, a_stateDerVectorName, a_partIdx, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_stateDerVectorName, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _ :: rest,
           a_stateDerVectorName,
           a_partIdx,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_stateDerVectorName, a_extraFuncsDecl, a_extraFuncs) = lm_44(txt, rest, a_stateDerVectorName, a_partIdx, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_stateDerVectorName, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_44;

protected function lm_45
  input Tpl.Text in_txt;
  input list<SimCode.JacobianMatrix> in_items;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_stateDerVectorName, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCode.JacobianMatrix> rest;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Integer i_partIdx;
      list<SimCode.JacobianColumn> i_mat;

    case ( txt,
           {},
           a_stateDerVectorName,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           SimCode.JAC_MATRIX(columns = i_mat, partitionIndex = i_partIdx) :: rest,
           a_stateDerVectorName,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING("")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_stateDerVectorName, a_extraFuncsDecl, a_extraFuncs) = lm_44(txt, i_mat, a_stateDerVectorName, i_partIdx, a_extraFuncsDecl, a_extraFuncs, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsDecl, a_extraFuncs) = lm_45(txt, rest, a_stateDerVectorName, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_stateDerVectorName, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _ :: rest,
           a_stateDerVectorName,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_stateDerVectorName, a_extraFuncsDecl, a_extraFuncs) = lm_45(txt, rest, a_stateDerVectorName, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_stateDerVectorName, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_45;

protected function fun_46
  input Tpl.Text in_txt;
  input SimCode.SubPartition in_a_subPartition;
  input Tpl.Text in_a_stateDerVectorName;
  input Integer in_a_i;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_a_subPartition, in_a_stateDerVectorName, in_a_i, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      Tpl.Text a_stateDerVectorName;
      Integer a_i;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      list<SimCode.SimEqSystem> i_removedEquations;
      list<SimCode.SimEqSystem> i_equations;
      list<SimCode.SimEqSystem> ret_0;

    case ( txt,
           SimCode.SUBPARTITION(equations = i_equations, removedEquations = i_removedEquations),
           a_stateDerVectorName,
           a_i,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        ret_0 = listAppend(i_equations, i_removedEquations);
        (txt, a_extraFuncs, a_extraFuncsDecl, _, a_stateDerVectorName) = algloopfiles(txt, ret_0, a_simCode, a_extraFuncs, a_extraFuncsDecl, Tpl.strTokText(Tpl.ST_STRING("")), SimCodeFunction.contextAlgloop, a_i, a_stateDerVectorName, false);
      then (txt, a_stateDerVectorName, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           a_stateDerVectorName,
           _,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_46;

protected function lm_47
  input Tpl.Text in_txt;
  input list<SimCode.SubPartition> in_items;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_stateDerVectorName, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCode.SubPartition> rest;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Integer x_i;
      SimCode.SubPartition i_subPartition;

    case ( txt,
           {},
           a_stateDerVectorName,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           i_subPartition :: rest,
           a_stateDerVectorName,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        x_i = Tpl.getIteri_i0(txt);
        (txt, a_stateDerVectorName, a_extraFuncsDecl, a_extraFuncs) = fun_46(txt, i_subPartition, a_stateDerVectorName, x_i, a_extraFuncsDecl, a_extraFuncs, a_simCode);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsDecl, a_extraFuncs) = lm_47(txt, rest, a_stateDerVectorName, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_stateDerVectorName, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_47;

protected function fun_48
  input Tpl.Text in_txt;
  input String in_mArg;
  input String in_a_fileNamePrefix;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_fileNamePrefix, in_a_simCode)
    local
      Tpl.Text txt;
      String a_fileNamePrefix;
      SimCode.SimCode a_simCode;
      Tpl.Text txt_3;
      Tpl.Text txt_2;
      Tpl.Text txt_1;
      Tpl.Text txt_0;

    case ( txt,
           "vxworks69",
           a_fileNamePrefix,
           a_simCode )
      equation
        txt_0 = functionBlock(Tpl.emptyTxt, a_simCode);
        txt_1 = Tpl.writeStr(Tpl.emptyTxt, a_fileNamePrefix);
        txt_1 = Tpl.writeTok(txt_1, Tpl.ST_STRING("_PLCOPEN.xml"));
        Tpl.textFile(txt_0, Tpl.textString(txt_1));
        txt_2 = ftp_script(Tpl.emptyTxt, a_simCode);
        txt_3 = Tpl.writeStr(Tpl.emptyTxt, a_fileNamePrefix);
        txt_3 = Tpl.writeTok(txt_3, Tpl.ST_STRING("_ftp.bat"));
        Tpl.textFile(txt_2, Tpl.textString(txt_3));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_48;

protected function fun_49
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_stateDerVectorName;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_stateDerVectorName) :=
  match(in_txt, in_a_simCode, in_a_stateDerVectorName)
    local
      Tpl.Text txt;
      Tpl.Text a_stateDerVectorName;
      list<SimCode.ClockedPartition> i_clockedPartitions;
      list<SimCode.SimEqSystem> i_initialEquations;
      list<SimCode.SimEqSystem> i_allEquations;
      list<SimCode.JacobianMatrix> i_jacobianMatrixes;
      list<String> i_externalFunctionIncludes;
      list<DAE.Exp> i_literals;
      list<SimCodeFunction.Function> i_modelInfo_functions;
      HashTableCrIListArray.HashTable i_varToArrayIndexMapping;
      String i_fileNamePrefix;
      SimCode.SimCode i_simCode;
      SimCode.ModelInfo i_modelInfo;
      Absyn.Path i_modelInfo_name;
      String str_86;
      Tpl.Text txt_85;
      Tpl.Text txt_84;
      Tpl.Text txt_83;
      Tpl.Text txt_82;
      list<SimCode.SubPartition> ret_81;
      Tpl.Text l_clk;
      list<SimCode.SimEqSystem> ret_79;
      Tpl.Text l_alg;
      Tpl.Text l_jac;
      Tpl.Text txt_76;
      Tpl.Text txt_75;
      Tpl.Text txt_74;
      Tpl.Text txt_73;
      Tpl.Text txt_72;
      Tpl.Text txt_71;
      Tpl.Text txt_70;
      Tpl.Text txt_69;
      Tpl.Text txt_68;
      Tpl.Text txt_67;
      Tpl.Text txt_66;
      Tpl.Text txt_65;
      Tpl.Text txt_64;
      Tpl.Text txt_63;
      Tpl.Text txt_62;
      Tpl.Text txt_61;
      Tpl.Text txt_60;
      Tpl.Text txt_59;
      Tpl.Text txt_58;
      Tpl.Text txt_57;
      Tpl.Text txt_56;
      Boolean ret_55;
      Tpl.Text l_jacobianVarsInit;
      Tpl.Text txt_53;
      Tpl.Text txt_52;
      Tpl.Text txt_51;
      Boolean ret_50;
      Boolean ret_49;
      Boolean ret_48;
      Tpl.Text l_0__;
      Tpl.Text txt_46;
      Tpl.Text txt_45;
      Tpl.Text txt_44;
      Tpl.Text txt_43;
      Tpl.Text txt_42;
      Tpl.Text l_complexStartExpressions;
      Tpl.Text l_extraFuncsDeclInit;
      Tpl.Text l_extraFuncsInit;
      Tpl.Text txt_38;
      Tpl.Text txt_37;
      Tpl.Text txt_36;
      Tpl.Text txt_35;
      Tpl.Text l_extraFuncsDeclFun;
      Tpl.Text l_extraFuncsFun;
      Tpl.Text txt_32;
      Tpl.Text txt_31;
      Tpl.Text txt_30;
      Tpl.Text txt_29;
      Tpl.Text txt_28;
      Tpl.Text txt_27;
      Tpl.Text txt_26;
      Boolean ret_25;
      Tpl.Text txt_24;
      Tpl.Text txt_23;
      Tpl.Text txt_22;
      Tpl.Text txt_21;
      Tpl.Text txt_20;
      Tpl.Text txt_19;
      Tpl.Text txt_18;
      Tpl.Text txt_17;
      Tpl.Text txt_16;
      Tpl.Text txt_15;
      Tpl.Text txt_14;
      Tpl.Text txt_13;
      Tpl.Text txt_12;
      Tpl.Text txt_11;
      Tpl.Text l_numStringVars;
      Tpl.Text l_numBoolVars;
      Tpl.Text l_numIntVars;
      Tpl.Text l_numRealVars;
      Tpl.Text l_className;
      Tpl.Text l_dummyTypeElemCreation;
      Tpl.Text l_extraResidualsFuncsDecl;
      Tpl.Text l_extraFuncsDecl;
      Tpl.Text l_extraFuncs;
      String ret_1;
      Tpl.Text l_target;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = (i_modelInfo as SimCode.MODELINFO(name = i_modelInfo_name, functions = i_modelInfo_functions)), fileNamePrefix = i_fileNamePrefix, varToArrayIndexMapping = i_varToArrayIndexMapping, literals = i_literals, externalFunctionIncludes = i_externalFunctionIncludes, jacobianMatrixes = i_jacobianMatrixes, allEquations = i_allEquations, initialEquations = i_initialEquations, clockedPartitions = i_clockedPartitions)),
           a_stateDerVectorName )
      equation
        ret_1 = Config.simulationCodeTarget();
        l_target = Tpl.writeStr(Tpl.emptyTxt, ret_1);
        l_extraFuncs = Tpl.emptyTxt;
        l_extraFuncsDecl = Tpl.emptyTxt;
        l_extraResidualsFuncsDecl = Tpl.emptyTxt;
        l_dummyTypeElemCreation = Tpl.emptyTxt;
        l_className = lastIdentOfPath(Tpl.emptyTxt, i_modelInfo_name);
        l_numRealVars = numRealvars(Tpl.emptyTxt, i_modelInfo);
        l_numIntVars = numIntvars(Tpl.emptyTxt, i_modelInfo);
        l_numBoolVars = numBoolvars(Tpl.emptyTxt, i_modelInfo);
        l_numStringVars = numStringvars(Tpl.emptyTxt, i_modelInfo);
        txt_11 = getPreVarsCount(Tpl.emptyTxt, i_modelInfo);
        (txt_12, l_extraFuncs, l_extraFuncsDecl, _) = simulationMainFile(Tpl.emptyTxt, Tpl.textString(l_target), i_simCode, l_extraFuncs, l_extraFuncsDecl, Tpl.strTokText(Tpl.ST_STRING("")), "", "", "", Tpl.textString(l_numRealVars), Tpl.textString(l_numIntVars), Tpl.textString(l_numBoolVars), Tpl.textString(l_numStringVars), Tpl.textString(txt_11));
        txt_13 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("OMCpp"));
        txt_13 = Tpl.writeStr(txt_13, i_fileNamePrefix);
        txt_13 = Tpl.writeTok(txt_13, Tpl.ST_STRING("Main.cpp"));
        Tpl.textFile(txt_12, Tpl.textString(txt_13));
        (txt_14, l_extraFuncs, l_extraFuncsDecl, l_className, a_stateDerVectorName) = update(Tpl.emptyTxt, i_simCode, l_extraFuncs, l_extraFuncsDecl, l_className, a_stateDerVectorName, false);
        txt_15 = Tpl.writeText(Tpl.emptyTxt, l_numRealVars);
        txt_15 = Tpl.writeTok(txt_15, Tpl.ST_STRING(" - 1"));
        txt_16 = Tpl.writeText(Tpl.emptyTxt, l_numIntVars);
        txt_16 = Tpl.writeTok(txt_16, Tpl.ST_STRING(" - 1"));
        txt_17 = Tpl.writeText(Tpl.emptyTxt, l_numBoolVars);
        txt_17 = Tpl.writeTok(txt_17, Tpl.ST_STRING(" - 1"));
        txt_18 = Tpl.writeText(Tpl.emptyTxt, l_numStringVars);
        txt_18 = Tpl.writeTok(txt_18, Tpl.ST_STRING(" - 1"));
        (txt_19, txt_14, txt_15, txt_16, txt_17, txt_18, l_extraFuncs, l_extraFuncsDecl, l_className, _, _, _, a_stateDerVectorName) = simulationCppFile(Tpl.emptyTxt, i_simCode, SimCodeFunction.contextOther, txt_14, txt_15, txt_16, txt_17, txt_18, l_extraFuncs, l_extraFuncsDecl, l_className, Tpl.strTokText(Tpl.ST_STRING("")), Tpl.strTokText(Tpl.ST_STRING("")), Tpl.strTokText(Tpl.ST_STRING("")), a_stateDerVectorName, false);
        txt_20 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("OMCpp"));
        txt_20 = Tpl.writeStr(txt_20, i_fileNamePrefix);
        txt_20 = Tpl.writeTok(txt_20, Tpl.ST_STRING(".cpp"));
        Tpl.textFile(txt_19, Tpl.textString(txt_20));
        txt_21 = Tpl.writeText(Tpl.emptyTxt, l_numRealVars);
        txt_21 = Tpl.writeTok(txt_21, Tpl.ST_STRING(" - 1"));
        txt_22 = Tpl.writeText(Tpl.emptyTxt, l_numIntVars);
        txt_22 = Tpl.writeTok(txt_22, Tpl.ST_STRING(" - 1"));
        txt_23 = Tpl.writeText(Tpl.emptyTxt, l_numBoolVars);
        txt_23 = Tpl.writeTok(txt_23, Tpl.ST_STRING(" - 1"));
        txt_24 = Tpl.writeText(Tpl.emptyTxt, l_numStringVars);
        txt_24 = Tpl.writeTok(txt_24, Tpl.ST_STRING(" - 1"));
        ret_25 = Flags.isSet(Flags.GEN_DEBUG_SYMBOLS);
        (txt_26, txt_21, txt_22, txt_23, txt_24) = memberVariableDefine(Tpl.emptyTxt, i_modelInfo, i_varToArrayIndexMapping, txt_21, txt_22, txt_23, txt_24, ret_25, false);
        (txt_27, l_extraFuncs, l_extraFuncsDecl, l_className) = simulationHeaderFile(Tpl.emptyTxt, i_simCode, SimCodeFunction.contextOther, l_extraFuncs, l_extraFuncsDecl, l_className, "", "", "", Tpl.textString(txt_26), false);
        txt_28 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("OMCpp"));
        txt_28 = Tpl.writeStr(txt_28, i_fileNamePrefix);
        txt_28 = Tpl.writeTok(txt_28, Tpl.ST_STRING(".h"));
        Tpl.textFile(txt_27, Tpl.textString(txt_28));
        (txt_29, l_extraFuncs, l_extraFuncsDecl, _, l_dummyTypeElemCreation, a_stateDerVectorName) = simulationTypesHeaderFile(Tpl.emptyTxt, i_simCode, l_extraFuncs, l_extraFuncsDecl, Tpl.strTokText(Tpl.ST_STRING("")), l_dummyTypeElemCreation, i_modelInfo_functions, i_literals, a_stateDerVectorName, false);
        txt_30 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("OMCpp"));
        txt_30 = Tpl.writeStr(txt_30, i_fileNamePrefix);
        txt_30 = Tpl.writeTok(txt_30, Tpl.ST_STRING("Types.h"));
        Tpl.textFile(txt_29, Tpl.textString(txt_30));
        (txt_31, l_extraFuncs, l_extraFuncsDecl, _) = simulationMakefile(Tpl.emptyTxt, Tpl.textString(l_target), i_simCode, l_extraFuncs, l_extraFuncsDecl, Tpl.strTokText(Tpl.ST_STRING("")), "", "", "", "", false);
        txt_32 = Tpl.writeStr(Tpl.emptyTxt, i_fileNamePrefix);
        txt_32 = Tpl.writeTok(txt_32, Tpl.ST_STRING(".makefile"));
        Tpl.textFile(txt_31, Tpl.textString(txt_32));
        l_extraFuncsFun = Tpl.emptyTxt;
        l_extraFuncsDeclFun = Tpl.emptyTxt;
        (txt_35, l_extraFuncsFun, l_extraFuncsDeclFun, _, a_stateDerVectorName) = simulationFunctionsFile(Tpl.emptyTxt, i_simCode, l_extraFuncsFun, l_extraFuncsDeclFun, Tpl.strTokText(Tpl.ST_STRING("Functions")), i_modelInfo_functions, i_literals, i_externalFunctionIncludes, a_stateDerVectorName, false);
        txt_36 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("OMCpp"));
        txt_36 = Tpl.writeStr(txt_36, i_fileNamePrefix);
        txt_36 = Tpl.writeTok(txt_36, Tpl.ST_STRING("Functions.cpp"));
        Tpl.textFile(txt_35, Tpl.textString(txt_36));
        (txt_37, l_extraFuncsFun, l_extraFuncsDeclFun, _, a_stateDerVectorName) = simulationFunctionsHeaderFile(Tpl.emptyTxt, i_simCode, l_extraFuncsFun, l_extraFuncsDeclFun, Tpl.strTokText(Tpl.ST_STRING("Functions")), i_modelInfo_functions, i_literals, a_stateDerVectorName, false);
        txt_38 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("OMCpp"));
        txt_38 = Tpl.writeStr(txt_38, i_fileNamePrefix);
        txt_38 = Tpl.writeTok(txt_38, Tpl.ST_STRING("Functions.h"));
        Tpl.textFile(txt_37, Tpl.textString(txt_38));
        l_extraFuncsInit = Tpl.emptyTxt;
        l_extraFuncsDeclInit = Tpl.emptyTxt;
        l_complexStartExpressions = Tpl.emptyTxt;
        (txt_42, l_complexStartExpressions, a_stateDerVectorName) = CodegenCppInit.modelInitXMLFile(Tpl.emptyTxt, i_simCode, Tpl.textString(l_numRealVars), Tpl.textString(l_numIntVars), Tpl.textString(l_numBoolVars), Tpl.textString(l_numStringVars), "", "", "", false, "", l_complexStartExpressions, a_stateDerVectorName);
        txt_43 = Tpl.writeStr(Tpl.emptyTxt, i_fileNamePrefix);
        txt_43 = Tpl.writeTok(txt_43, Tpl.ST_STRING("_init.xml"));
        Tpl.textFile(txt_42, Tpl.textString(txt_43));
        txt_44 = Tpl.writeText(Tpl.emptyTxt, l_className);
        txt_44 = Tpl.writeTok(txt_44, Tpl.ST_STRING("Initialize"));
        (txt_45, l_extraFuncsInit, l_extraFuncsDeclInit, txt_44, l_dummyTypeElemCreation, a_stateDerVectorName, l_complexStartExpressions) = simulationInitCppFile(Tpl.emptyTxt, i_simCode, l_extraFuncsInit, l_extraFuncsDeclInit, txt_44, l_dummyTypeElemCreation, a_stateDerVectorName, false, l_complexStartExpressions);
        txt_46 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("OMCpp"));
        txt_46 = Tpl.writeStr(txt_46, i_fileNamePrefix);
        txt_46 = Tpl.writeTok(txt_46, Tpl.ST_STRING("Initialize.cpp"));
        Tpl.textFile(txt_45, Tpl.textString(txt_46));
        ret_48 = Flags.isSet(Flags.HARDCODED_START_VALUES);
        ret_49 = Flags.isSet(Flags.GEN_DEBUG_SYMBOLS);
        ret_50 = boolOr(ret_48, ret_49);
        (l_0__, a_stateDerVectorName, l_extraFuncsDeclInit, l_extraFuncsInit) = fun_43(Tpl.emptyTxt, ret_50, i_fileNamePrefix, a_stateDerVectorName, l_className, l_extraFuncsDeclInit, l_extraFuncsInit, i_simCode);
        txt_51 = Tpl.writeText(Tpl.emptyTxt, l_className);
        txt_51 = Tpl.writeTok(txt_51, Tpl.ST_STRING("Initialize"));
        (txt_52, l_extraFuncsInit, l_extraFuncsDeclInit, txt_51) = simulationInitHeaderFile(Tpl.emptyTxt, i_simCode, l_extraFuncsInit, l_extraFuncsDeclInit, txt_51);
        txt_53 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("OMCpp"));
        txt_53 = Tpl.writeStr(txt_53, i_fileNamePrefix);
        txt_53 = Tpl.writeTok(txt_53, Tpl.ST_STRING("Initialize.h"));
        Tpl.textFile(txt_52, Tpl.textString(txt_53));
        l_jacobianVarsInit = Tpl.emptyTxt;
        ret_55 = Flags.isSet(Flags.GEN_DEBUG_SYMBOLS);
        (txt_56, l_extraFuncs, l_extraFuncsDecl, _, l_jacobianVarsInit) = simulationJacobianHeaderFile(Tpl.emptyTxt, i_simCode, l_extraFuncs, l_extraFuncsDecl, Tpl.strTokText(Tpl.ST_STRING("")), l_jacobianVarsInit, ret_55);
        txt_57 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("OMCpp"));
        txt_57 = Tpl.writeStr(txt_57, i_fileNamePrefix);
        txt_57 = Tpl.writeTok(txt_57, Tpl.ST_STRING("Jacobian.h"));
        Tpl.textFile(txt_56, Tpl.textString(txt_57));
        (txt_58, l_extraFuncs, l_extraFuncsDecl, _, l_jacobianVarsInit, a_stateDerVectorName) = simulationJacobianCppFile(Tpl.emptyTxt, i_simCode, l_extraFuncs, l_extraFuncsDecl, Tpl.strTokText(Tpl.ST_STRING("")), l_jacobianVarsInit, a_stateDerVectorName, false);
        txt_59 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("OMCpp"));
        txt_59 = Tpl.writeStr(txt_59, i_fileNamePrefix);
        txt_59 = Tpl.writeTok(txt_59, Tpl.ST_STRING("Jacobian.cpp"));
        Tpl.textFile(txt_58, Tpl.textString(txt_59));
        (txt_60, l_extraFuncs, l_extraFuncsDecl, _, a_stateDerVectorName) = simulationStateSelectionCppFile(Tpl.emptyTxt, i_simCode, l_extraFuncs, l_extraFuncsDecl, Tpl.strTokText(Tpl.ST_STRING("")), a_stateDerVectorName, false);
        txt_61 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("OMCpp"));
        txt_61 = Tpl.writeStr(txt_61, i_fileNamePrefix);
        txt_61 = Tpl.writeTok(txt_61, Tpl.ST_STRING("StateSelection.cpp"));
        Tpl.textFile(txt_60, Tpl.textString(txt_61));
        (txt_62, l_extraFuncs, l_extraFuncsDecl, _) = simulationStateSelectionHeaderFile(Tpl.emptyTxt, i_simCode, l_extraFuncs, l_extraFuncsDecl, Tpl.strTokText(Tpl.ST_STRING("")));
        txt_63 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("OMCpp"));
        txt_63 = Tpl.writeStr(txt_63, i_fileNamePrefix);
        txt_63 = Tpl.writeTok(txt_63, Tpl.ST_STRING("StateSelection.h"));
        Tpl.textFile(txt_62, Tpl.textString(txt_63));
        (txt_64, l_extraFuncs, l_extraResidualsFuncsDecl, l_className, a_stateDerVectorName) = updateResiduals(Tpl.emptyTxt, i_simCode, l_extraFuncs, l_extraResidualsFuncsDecl, l_className, a_stateDerVectorName, false);
        (txt_65, txt_64, l_extraFuncs, l_extraFuncsDecl, _, a_stateDerVectorName) = simulationMixedSystemCppFile(Tpl.emptyTxt, i_simCode, txt_64, l_extraFuncs, l_extraFuncsDecl, Tpl.strTokText(Tpl.ST_STRING("")), a_stateDerVectorName, false);
        txt_66 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("OMCpp"));
        txt_66 = Tpl.writeStr(txt_66, i_fileNamePrefix);
        txt_66 = Tpl.writeTok(txt_66, Tpl.ST_STRING("Mixed.cpp"));
        Tpl.textFile(txt_65, Tpl.textString(txt_66));
        (txt_67, l_extraFuncs, l_extraResidualsFuncsDecl, _) = simulationMixedSystemHeaderFile(Tpl.emptyTxt, i_simCode, l_extraFuncs, l_extraResidualsFuncsDecl, Tpl.strTokText(Tpl.ST_STRING("")));
        txt_68 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("OMCpp"));
        txt_68 = Tpl.writeStr(txt_68, i_fileNamePrefix);
        txt_68 = Tpl.writeTok(txt_68, Tpl.ST_STRING("Mixed.h"));
        Tpl.textFile(txt_67, Tpl.textString(txt_68));
        (txt_69, l_extraFuncs, l_extraFuncsDecl, _) = simulationWriteOutputHeaderFile(Tpl.emptyTxt, i_simCode, l_extraFuncs, l_extraFuncsDecl, Tpl.strTokText(Tpl.ST_STRING("")));
        txt_70 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("OMCpp"));
        txt_70 = Tpl.writeStr(txt_70, i_fileNamePrefix);
        txt_70 = Tpl.writeTok(txt_70, Tpl.ST_STRING("WriteOutput.h"));
        Tpl.textFile(txt_69, Tpl.textString(txt_70));
        (txt_71, l_extraFuncs, l_extraFuncsDecl, _, a_stateDerVectorName) = simulationWriteOutputCppFile(Tpl.emptyTxt, i_simCode, l_extraFuncs, l_extraFuncsDecl, Tpl.strTokText(Tpl.ST_STRING("")), a_stateDerVectorName, false);
        txt_72 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("OMCpp"));
        txt_72 = Tpl.writeStr(txt_72, i_fileNamePrefix);
        txt_72 = Tpl.writeTok(txt_72, Tpl.ST_STRING("WriteOutput.cpp"));
        Tpl.textFile(txt_71, Tpl.textString(txt_72));
        (txt_73, l_extraFuncs, l_extraFuncsDecl, _) = simulationFactoryFile(Tpl.emptyTxt, i_simCode, l_extraFuncs, l_extraFuncsDecl, Tpl.strTokText(Tpl.ST_STRING("")));
        txt_74 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("OMCpp"));
        txt_74 = Tpl.writeStr(txt_74, i_fileNamePrefix);
        txt_74 = Tpl.writeTok(txt_74, Tpl.ST_STRING("FactoryExport.cpp"));
        Tpl.textFile(txt_73, Tpl.textString(txt_74));
        (txt_75, l_extraFuncs, l_extraFuncsDecl, _) = simulationMainRunScript(Tpl.emptyTxt, i_simCode, l_extraFuncs, l_extraFuncsDecl, Tpl.strTokText(Tpl.ST_STRING("")), "", "", "exec");
        txt_76 = Tpl.writeStr(Tpl.emptyTxt, i_fileNamePrefix);
        (txt_76, l_extraFuncs, l_extraFuncsDecl, _) = simulationMainRunScriptSuffix(txt_76, i_simCode, l_extraFuncs, l_extraFuncsDecl, Tpl.strTokText(Tpl.ST_STRING("")));
        Tpl.textFile(txt_75, Tpl.textString(txt_76));
        l_jac = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING("")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_jac, a_stateDerVectorName, l_extraFuncsDecl, l_extraFuncs) = lm_45(l_jac, i_jacobianMatrixes, a_stateDerVectorName, l_extraFuncsDecl, l_extraFuncs, i_simCode);
        l_jac = Tpl.popIter(l_jac);
        ret_79 = listAppend(i_allEquations, i_initialEquations);
        (l_alg, l_extraFuncs, l_extraFuncsDecl, _, a_stateDerVectorName) = algloopfiles(Tpl.emptyTxt, ret_79, i_simCode, l_extraFuncs, l_extraFuncsDecl, Tpl.strTokText(Tpl.ST_STRING("")), SimCodeFunction.contextAlgloop, 0, a_stateDerVectorName, false);
        ret_81 = SimCodeUtil.getSubPartitions(i_clockedPartitions);
        l_clk = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(1, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_clk, a_stateDerVectorName, l_extraFuncsDecl, l_extraFuncs) = lm_47(l_clk, ret_81, a_stateDerVectorName, l_extraFuncsDecl, l_extraFuncs, i_simCode);
        l_clk = Tpl.popIter(l_clk);
        (txt_82, l_extraFuncs, l_extraFuncsDecl, _) = algloopMainfile(Tpl.emptyTxt, i_simCode, l_extraFuncs, l_extraFuncsDecl, Tpl.strTokText(Tpl.ST_STRING("")), SimCodeFunction.contextAlgloop);
        txt_83 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("OMCpp"));
        txt_83 = Tpl.writeStr(txt_83, i_fileNamePrefix);
        txt_83 = Tpl.writeTok(txt_83, Tpl.ST_STRING("AlgLoopMain.cpp"));
        Tpl.textFile(txt_82, Tpl.textString(txt_83));
        (txt_84, l_extraFuncs, l_extraFuncsDecl, _) = calcHelperMainfile(Tpl.emptyTxt, i_simCode, l_extraFuncs, l_extraFuncsDecl, Tpl.strTokText(Tpl.ST_STRING("")));
        txt_85 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("OMCpp"));
        txt_85 = Tpl.writeStr(txt_85, i_fileNamePrefix);
        txt_85 = Tpl.writeTok(txt_85, Tpl.ST_STRING("CalcHelperMain.cpp"));
        Tpl.textFile(txt_84, Tpl.textString(txt_85));
        str_86 = Tpl.textString(l_target);
        txt = fun_48(txt, str_86, i_fileNamePrefix, i_simCode);
      then (txt, a_stateDerVectorName);

    case ( txt,
           _,
           a_stateDerVectorName )
      then (txt, a_stateDerVectorName);
  end match;
end fun_49;

public function translateModel
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_stateDerVectorName;
algorithm
  l_stateDerVectorName := Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("__zDot"));
  (out_txt, l_stateDerVectorName) := fun_49(txt, a_simCode, l_stateDerVectorName);
end translateModel;

public function translateFunctions
  input Tpl.Text in_txt;
  input SimCodeFunction.FunctionCode in_a_functionCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_functionCode)
    local
      Tpl.Text txt;

    case ( txt,
           SimCodeFunction.FUNCTIONCODE(name = _) )
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end translateFunctions;

public function simulationHeaderFile
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input String in_a_additionalIncludes;
  input String in_a_additionalPublicMembers;
  input String in_a_additionalProtectedMembers;
  input String in_a_memberVariableDefinitions;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace) :=
  match(in_txt, in_a_simCode, in_a_context, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_additionalIncludes, in_a_additionalPublicMembers, in_a_additionalProtectedMembers, in_a_memberVariableDefinitions, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      String a_additionalIncludes;
      String a_additionalPublicMembers;
      String a_additionalProtectedMembers;
      String a_memberVariableDefinitions;
      Boolean a_useFlatArrayNotation;
      SimCode.SimCode i_simCode;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = _)),
           a_context,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_additionalIncludes,
           a_additionalPublicMembers,
           a_additionalProtectedMembers,
           a_memberVariableDefinitions,
           a_useFlatArrayNotation )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = generateHeaderIncludeString(txt, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeStr(txt, a_additionalIncludes);
        txt = Tpl.softNewLine(txt);
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = generateClassDeclarationCode(txt, i_simCode, a_context, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_additionalPublicMembers, a_additionalProtectedMembers, a_memberVariableDefinitions, a_useFlatArrayNotation);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);

    case ( txt,
           _,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           _,
           _,
           _,
           _,
           _ )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
  end match;
end simulationHeaderFile;

protected function fun_53
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("check"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("initialize"));
      then txt;
  end match;
end fun_53;

protected function fun_54
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "virtual void checkVariables();\n",
                                    "virtual void checkParameters();"
                                }, false));
      then txt;
  end match;
end fun_54;

protected function lm_55
  input Tpl.Text in_txt;
  input list<list<SimCodeVar.SimVar>> in_items;
  input Tpl.Text in_a_functionPrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_functionPrefix)
    local
      Tpl.Text txt;
      list<list<SimCodeVar.SimVar>> rest;
      Tpl.Text a_functionPrefix;
      Integer x_idx;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           _ :: rest,
           a_functionPrefix )
      equation
        x_idx = Tpl.getIteri_i0(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = Tpl.writeText(txt, a_functionPrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("AlgVars_"));
        txt = Tpl.writeStr(txt, intString(x_idx));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("();"));
        txt = Tpl.nextIter(txt);
        txt = lm_55(txt, rest, a_functionPrefix);
      then txt;
  end match;
end lm_55;

protected function lm_56
  input Tpl.Text in_txt;
  input list<list<SimCodeVar.SimVar>> in_items;
  input Tpl.Text in_a_functionPrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_functionPrefix)
    local
      Tpl.Text txt;
      list<list<SimCodeVar.SimVar>> rest;
      Tpl.Text a_functionPrefix;
      Integer x_idx;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           _ :: rest,
           a_functionPrefix )
      equation
        x_idx = Tpl.getIteri_i0(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = Tpl.writeText(txt, a_functionPrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("IntAlgVars_"));
        txt = Tpl.writeStr(txt, intString(x_idx));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("();"));
        txt = Tpl.nextIter(txt);
        txt = lm_56(txt, rest, a_functionPrefix);
      then txt;
  end match;
end lm_56;

protected function lm_57
  input Tpl.Text in_txt;
  input list<list<SimCodeVar.SimVar>> in_items;
  input Tpl.Text in_a_functionPrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_functionPrefix)
    local
      Tpl.Text txt;
      list<list<SimCodeVar.SimVar>> rest;
      Tpl.Text a_functionPrefix;
      Integer x_idx;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           _ :: rest,
           a_functionPrefix )
      equation
        x_idx = Tpl.getIteri_i0(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = Tpl.writeText(txt, a_functionPrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("StringAlgVars_"));
        txt = Tpl.writeStr(txt, intString(x_idx));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("();"));
        txt = Tpl.nextIter(txt);
        txt = lm_57(txt, rest, a_functionPrefix);
      then txt;
  end match;
end lm_57;

protected function lm_58
  input Tpl.Text in_txt;
  input list<list<SimCodeVar.SimVar>> in_items;
  input Tpl.Text in_a_functionPrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_functionPrefix)
    local
      Tpl.Text txt;
      list<list<SimCodeVar.SimVar>> rest;
      Tpl.Text a_functionPrefix;
      Integer x_idx;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           _ :: rest,
           a_functionPrefix )
      equation
        x_idx = Tpl.getIteri_i0(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = Tpl.writeText(txt, a_functionPrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("AliasVars_"));
        txt = Tpl.writeStr(txt, intString(x_idx));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("();"));
        txt = Tpl.nextIter(txt);
        txt = lm_58(txt, rest, a_functionPrefix);
      then txt;
  end match;
end lm_58;

protected function lm_59
  input Tpl.Text in_txt;
  input list<list<SimCodeVar.SimVar>> in_items;
  input Tpl.Text in_a_functionPrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_functionPrefix)
    local
      Tpl.Text txt;
      list<list<SimCodeVar.SimVar>> rest;
      Tpl.Text a_functionPrefix;
      Integer x_idx;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           _ :: rest,
           a_functionPrefix )
      equation
        x_idx = Tpl.getIteri_i0(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = Tpl.writeText(txt, a_functionPrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("StringAliasVars_"));
        txt = Tpl.writeStr(txt, intString(x_idx));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("();"));
        txt = Tpl.nextIter(txt);
        txt = lm_59(txt, rest, a_functionPrefix);
      then txt;
  end match;
end lm_59;

protected function lm_60
  input Tpl.Text in_txt;
  input list<list<SimCodeVar.SimVar>> in_items;
  input Tpl.Text in_a_functionPrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_functionPrefix)
    local
      Tpl.Text txt;
      list<list<SimCodeVar.SimVar>> rest;
      Tpl.Text a_functionPrefix;
      Integer x_idx;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           _ :: rest,
           a_functionPrefix )
      equation
        x_idx = Tpl.getIteri_i0(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = Tpl.writeText(txt, a_functionPrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("ParameterVars_"));
        txt = Tpl.writeStr(txt, intString(x_idx));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("();"));
        txt = Tpl.nextIter(txt);
        txt = lm_60(txt, rest, a_functionPrefix);
      then txt;
  end match;
end lm_60;

protected function lm_61
  input Tpl.Text in_txt;
  input list<list<SimCodeVar.SimVar>> in_items;
  input Tpl.Text in_a_functionPrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_functionPrefix)
    local
      Tpl.Text txt;
      list<list<SimCodeVar.SimVar>> rest;
      Tpl.Text a_functionPrefix;
      Integer x_idx;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           _ :: rest,
           a_functionPrefix )
      equation
        x_idx = Tpl.getIteri_i0(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = Tpl.writeText(txt, a_functionPrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("IntParameterVars_"));
        txt = Tpl.writeStr(txt, intString(x_idx));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("();"));
        txt = Tpl.nextIter(txt);
        txt = lm_61(txt, rest, a_functionPrefix);
      then txt;
  end match;
end lm_61;

protected function lm_62
  input Tpl.Text in_txt;
  input list<list<SimCodeVar.SimVar>> in_items;
  input Tpl.Text in_a_functionPrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_functionPrefix)
    local
      Tpl.Text txt;
      list<list<SimCodeVar.SimVar>> rest;
      Tpl.Text a_functionPrefix;
      Integer x_idx;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           _ :: rest,
           a_functionPrefix )
      equation
        x_idx = Tpl.getIteri_i0(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = Tpl.writeText(txt, a_functionPrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("BoolParameterVars_"));
        txt = Tpl.writeStr(txt, intString(x_idx));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("();"));
        txt = Tpl.nextIter(txt);
        txt = lm_62(txt, rest, a_functionPrefix);
      then txt;
  end match;
end lm_62;

protected function lm_63
  input Tpl.Text in_txt;
  input list<list<SimCodeVar.SimVar>> in_items;
  input Tpl.Text in_a_functionPrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_functionPrefix)
    local
      Tpl.Text txt;
      list<list<SimCodeVar.SimVar>> rest;
      Tpl.Text a_functionPrefix;
      Integer x_idx;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           _ :: rest,
           a_functionPrefix )
      equation
        x_idx = Tpl.getIteri_i0(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = Tpl.writeText(txt, a_functionPrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("StringParameterVars_"));
        txt = Tpl.writeStr(txt, intString(x_idx));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("();"));
        txt = Tpl.nextIter(txt);
        txt = lm_63(txt, rest, a_functionPrefix);
      then txt;
  end match;
end lm_63;

protected function fun_64
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input list<SimCodeVar.SimVar> in_a_vars_stringParamVars;
  input list<SimCodeVar.SimVar> in_a_vars_boolParamVars;
  input list<SimCodeVar.SimVar> in_a_vars_intParamVars;
  input list<SimCodeVar.SimVar> in_a_vars_paramVars;
  input list<SimCodeVar.SimVar> in_a_vars_stringAliasVars;
  input list<SimCodeVar.SimVar> in_a_vars_aliasVars;
  input list<SimCodeVar.SimVar> in_a_vars_stringAlgVars;
  input list<SimCodeVar.SimVar> in_a_vars_intAlgVars;
  input Tpl.Text in_a_functionPrefix;
  input list<SimCodeVar.SimVar> in_a_vars_algVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_vars_stringParamVars, in_a_vars_boolParamVars, in_a_vars_intParamVars, in_a_vars_paramVars, in_a_vars_stringAliasVars, in_a_vars_aliasVars, in_a_vars_stringAlgVars, in_a_vars_intAlgVars, in_a_functionPrefix, in_a_vars_algVars)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> a_vars_stringParamVars;
      list<SimCodeVar.SimVar> a_vars_boolParamVars;
      list<SimCodeVar.SimVar> a_vars_intParamVars;
      list<SimCodeVar.SimVar> a_vars_paramVars;
      list<SimCodeVar.SimVar> a_vars_stringAliasVars;
      list<SimCodeVar.SimVar> a_vars_aliasVars;
      list<SimCodeVar.SimVar> a_vars_stringAlgVars;
      list<SimCodeVar.SimVar> a_vars_intAlgVars;
      Tpl.Text a_functionPrefix;
      list<SimCodeVar.SimVar> a_vars_algVars;
      list<list<SimCodeVar.SimVar>> ret_8;
      list<list<SimCodeVar.SimVar>> ret_7;
      list<list<SimCodeVar.SimVar>> ret_6;
      list<list<SimCodeVar.SimVar>> ret_5;
      list<list<SimCodeVar.SimVar>> ret_4;
      list<list<SimCodeVar.SimVar>> ret_3;
      list<list<SimCodeVar.SimVar>> ret_2;
      list<list<SimCodeVar.SimVar>> ret_1;
      list<list<SimCodeVar.SimVar>> ret_0;

    case ( txt,
           false,
           _,
           _,
           _,
           _,
           _,
           _,
           _,
           _,
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_vars_stringParamVars,
           a_vars_boolParamVars,
           a_vars_intParamVars,
           a_vars_paramVars,
           a_vars_stringAliasVars,
           a_vars_aliasVars,
           a_vars_stringAlgVars,
           a_vars_intAlgVars,
           a_functionPrefix,
           a_vars_algVars )
      equation
        ret_0 = List.partition(a_vars_algVars, 100);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_55(txt, ret_0, a_functionPrefix);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "void "
                                }, false));
        txt = Tpl.writeText(txt, a_functionPrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "AlgVars();\n",
                                    "void "
                                }, false));
        txt = Tpl.writeText(txt, a_functionPrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "DiscreteAlgVars();\n",
                                    "\n"
                                }, true));
        ret_1 = List.partition(a_vars_intAlgVars, 100);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_56(txt, ret_1, a_functionPrefix);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "void "
                                }, false));
        txt = Tpl.writeText(txt, a_functionPrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "IntAlgVars();\n",
                                    "void "
                                }, false));
        txt = Tpl.writeText(txt, a_functionPrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "BoolAlgVars();\n",
                                    "\n"
                                }, true));
        ret_2 = List.partition(a_vars_stringAlgVars, 100);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_57(txt, ret_2, a_functionPrefix);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "void "
                                }, false));
        txt = Tpl.writeText(txt, a_functionPrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "StringAlgVars();\n",
                                    "\n"
                                }, true));
        ret_3 = List.partition(a_vars_aliasVars, 100);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_58(txt, ret_3, a_functionPrefix);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        ret_4 = List.partition(a_vars_stringAliasVars, 100);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_59(txt, ret_4, a_functionPrefix);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = Tpl.writeText(txt, a_functionPrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "StringAliasVars();\n",
                                    "void "
                                }, false));
        txt = Tpl.writeText(txt, a_functionPrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "AliasVars();\n",
                                    "void "
                                }, false));
        txt = Tpl.writeText(txt, a_functionPrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "IntAliasVars();\n",
                                    "void "
                                }, false));
        txt = Tpl.writeText(txt, a_functionPrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "BoolAliasVars();\n",
                                    "\n"
                                }, true));
        ret_5 = List.partition(a_vars_paramVars, 100);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_60(txt, ret_5, a_functionPrefix);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        ret_6 = List.partition(a_vars_intParamVars, 100);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_61(txt, ret_6, a_functionPrefix);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        ret_7 = List.partition(a_vars_boolParamVars, 100);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_62(txt, ret_7, a_functionPrefix);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        ret_8 = List.partition(a_vars_stringParamVars, 100);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_63(txt, ret_8, a_functionPrefix);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = Tpl.writeText(txt, a_functionPrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "ParameterVars();\n",
                                    "void "
                                }, false));
        txt = Tpl.writeText(txt, a_functionPrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "IntParameterVars();\n",
                                    "void "
                                }, false));
        txt = Tpl.writeText(txt, a_functionPrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "BoolParameterVars();\n",
                                    "void "
                                }, false));
        txt = Tpl.writeText(txt, a_functionPrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "StringParameterVars();\n",
                                    "void "
                                }, false));
        txt = Tpl.writeText(txt, a_functionPrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "StateVars();\n",
                                    "void "
                                }, false));
        txt = Tpl.writeText(txt, a_functionPrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("DerVars();"));
      then txt;
  end match;
end fun_64;

protected function fun_65
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_initparameqs;
  input Tpl.Text in_a_initeqs;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_a_modelInfo, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_initparameqs, in_a_initeqs)
    local
      Tpl.Text txt;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_initparameqs;
      Tpl.Text a_initeqs;
      list<SimCodeVar.SimVar> i_vars_stringParamVars;
      list<SimCodeVar.SimVar> i_vars_boolParamVars;
      list<SimCodeVar.SimVar> i_vars_intParamVars;
      list<SimCodeVar.SimVar> i_vars_paramVars;
      list<SimCodeVar.SimVar> i_vars_stringAliasVars;
      list<SimCodeVar.SimVar> i_vars_aliasVars;
      list<SimCodeVar.SimVar> i_vars_stringAlgVars;
      list<SimCodeVar.SimVar> i_vars_intAlgVars;
      list<SimCodeVar.SimVar> i_vars_algVars;
      Absyn.Path i_modelInfo_name;
      Boolean ret_8;
      Boolean ret_7;
      Boolean ret_6;
      Boolean ret_5;
      Boolean ret_4;
      Boolean ret_3;
      Boolean ret_2;
      Boolean ret_1;
      Tpl.Text l_functionPrefix;

    case ( txt,
           SimCode.MODELINFO(vars = SimCodeVar.SIMVARS(algVars = i_vars_algVars, intAlgVars = i_vars_intAlgVars, stringAlgVars = i_vars_stringAlgVars, aliasVars = i_vars_aliasVars, stringAliasVars = i_vars_stringAliasVars, paramVars = i_vars_paramVars, intParamVars = i_vars_intParamVars, boolParamVars = i_vars_boolParamVars, stringParamVars = i_vars_stringParamVars), name = i_modelInfo_name),
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_initparameqs,
           a_initeqs )
      equation
        ret_1 = Flags.isSet(Flags.HARDCODED_START_VALUES);
        l_functionPrefix = fun_53(Tpl.emptyTxt, ret_1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "#pragma once\n",
                                    "\n",
                                    "/*****************************************************************************\n",
                                    "*\n",
                                    "* Simulation code to initialize the Modelica system\n",
                                    "*\n",
                                    "*****************************************************************************/\n",
                                    "\n",
                                    "class "
                                }, false));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Initialize : public ISystemInitialization, public "));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "WriteOutput\n",
                                    "{\n",
                                    " public:\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("Initialize(IGlobalSettings* globalSettings, shared_ptr<ISimObjects> simObjects);\n"));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Initialize("));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Initialize& instance);\n",
                                    "virtual ~"
                                }, false));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Initialize();\n",
                                    "virtual bool initial();\n",
                                    "virtual void setInitial(bool);\n",
                                    "virtual void initialize();\n",
                                    "virtual void initializeMemory();\n",
                                    "virtual void initializeFreeVariables();\n",
                                    "virtual void initializeBoundVariables();\n",
                                    "virtual void initParameterEquations();\n",
                                    "virtual void initEquations();\n",
                                    "virtual IMixedSystem* clone();\n"
                                }, true));
        ret_2 = Flags.isSet(Flags.HARDCODED_START_VALUES);
        ret_3 = boolNot(ret_2);
        ret_4 = Flags.isSet(Flags.GEN_DEBUG_SYMBOLS);
        ret_5 = boolAnd(ret_3, ret_4);
        txt = fun_54(txt, ret_5);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("private:\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_initeqs);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, a_initparameqs);
        txt = Tpl.softNewLine(txt);
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = destructExtObjsDecl(txt, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, false);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "void InitializeDummyTypeElems();\n",
                                    "\n"
                                }, true));
        ret_6 = Flags.isSet(Flags.HARDCODED_START_VALUES);
        ret_7 = Flags.isSet(Flags.GEN_DEBUG_SYMBOLS);
        ret_8 = boolOr(ret_6, ret_7);
        txt = fun_64(txt, ret_8, i_vars_stringParamVars, i_vars_boolParamVars, i_vars_intParamVars, i_vars_paramVars, i_vars_stringAliasVars, i_vars_aliasVars, i_vars_stringAlgVars, i_vars_intAlgVars, l_functionPrefix, i_vars_algVars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/*extraFuncs*/\n"));
        txt = Tpl.writeText(txt, a_extraFuncsDecl);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("};"));
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _,
           _ )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_65;

public function simulationInitHeaderFile
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace) :=
  match(in_txt, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace)
    local
      Tpl.Text txt;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      SimCode.SimCode i_simCode;
      SimCode.ModelInfo i_modelInfo;
      list<SimCode.SimEqSystem> i_parameterEquations;
      list<SimCode.SimEqSystem> i_initialEquations;
      Tpl.Text l_initparameqs;
      Tpl.Text l_initeqs;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = (i_modelInfo as SimCode.MODELINFO(vars = SimCodeVar.SIMVARS(stateVars = _))), fileNamePrefix = _, initialEquations = i_initialEquations, parameterEquations = i_parameterEquations)),
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace )
      equation
        (l_initeqs, _) = generateEquationMemberFuncDecls(Tpl.emptyTxt, i_initialEquations, Tpl.strTokText(Tpl.ST_STRING("initEquation")));
        (l_initparameqs, _) = generateEquationMemberFuncDecls(Tpl.emptyTxt, i_parameterEquations, Tpl.strTokText(Tpl.ST_STRING("initParameterEquation")));
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_65(txt, i_modelInfo, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, i_simCode, l_initparameqs, l_initeqs);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);

    case ( txt,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
  end match;
end simulationInitHeaderFile;

protected function fun_67
  input Tpl.Text in_txt;
  input String in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           "dense" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("matrix_t"));
      then txt;

    case ( txt,
           "sparse" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("sparsematrix_t"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("A matrix type is not supported"));
      then txt;
  end match;
end fun_67;

protected function lm_68
  input Tpl.Text in_txt;
  input list<SimCode.JacobianColumn> in_items;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCode.JacobianColumn> rest;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      list<SimCode.SimEqSystem> i_eqs;

    case ( txt,
           {},
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           SimCode.JAC_COLUMN(columnEqns = i_eqs) :: rest,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = generatefriendAlgloops(txt, i_eqs, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
        txt = Tpl.nextIter(txt);
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_68(txt, rest, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _ :: rest,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_68(txt, rest, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_68;

protected function lm_69
  input Tpl.Text in_txt;
  input list<SimCode.JacobianMatrix> in_items;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCode.JacobianMatrix> rest;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      list<SimCode.JacobianColumn> i_mat;

    case ( txt,
           {},
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           SimCode.JAC_MATRIX(columns = i_mat) :: rest,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_68(txt, i_mat, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.nextIter(txt);
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_69(txt, rest, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _ :: rest,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_69(txt, rest, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_69;

protected function lm_70
  input Tpl.Text in_txt;
  input list<SimCode.JacobianMatrix> in_items;
  input Tpl.Text in_a_matrixreturntype;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_matrixreturntype)
    local
      Tpl.Text txt;
      list<SimCode.JacobianMatrix> rest;
      Tpl.Text a_matrixreturntype;
      String i_name;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           SimCode.JAC_MATRIX(matrixName = i_name) :: rest,
           a_matrixreturntype )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "void calc"
                                }, false));
        txt = Tpl.writeStr(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("JacobianColumn();\n"));
        txt = Tpl.writeText(txt, a_matrixreturntype);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("& get"));
        txt = Tpl.writeStr(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Jacobian();"));
        txt = Tpl.nextIter(txt);
        txt = lm_70(txt, rest, a_matrixreturntype);
      then txt;

    case ( txt,
           _ :: rest,
           a_matrixreturntype )
      equation
        txt = lm_70(txt, rest, a_matrixreturntype);
      then txt;
  end match;
end lm_70;

protected function lm_71
  input Tpl.Text in_txt;
  input list<SimCode.JacobianMatrix> in_items;
  input Tpl.Text in_a_matrixreturntype;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_matrixreturntype)
    local
      Tpl.Text txt;
      list<SimCode.JacobianMatrix> rest;
      Tpl.Text a_matrixreturntype;
      String i_name;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           SimCode.JAC_MATRIX(matrixName = i_name) :: rest,
           a_matrixreturntype )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_matrixreturntype);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" _"));
        txt = Tpl.writeStr(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "jacobian;\n",
                                    "ublas::vector<double> _"
                                }, false));
        txt = Tpl.writeStr(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "jac_y;\n",
                                    "ublas::vector<double> _"
                                }, false));
        txt = Tpl.writeStr(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "jac_tmp;\n",
                                    "ublas::vector<double> _"
                                }, false));
        txt = Tpl.writeStr(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "jac_x;\n",
                                    "int* _"
                                }, false));
        txt = Tpl.writeStr(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "ColorOfColumn;\n",
                                    "int  _"
                                }, false));
        txt = Tpl.writeStr(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("MaxColors;"));
        txt = Tpl.nextIter(txt);
        txt = lm_71(txt, rest, a_matrixreturntype);
      then txt;

    case ( txt,
           _ :: rest,
           a_matrixreturntype )
      equation
        txt = lm_71(txt, rest, a_matrixreturntype);
      then txt;
  end match;
end lm_71;

public function simulationJacobianHeaderFile
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_jacobianVarsInit;
  input Boolean in_a_createDebugCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_jacobianVarsInit;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_jacobianVarsInit) :=
  match(in_txt, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_jacobianVarsInit, in_a_createDebugCode)
    local
      Tpl.Text txt;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_jacobianVarsInit;
      Boolean a_createDebugCode;
      SimCode.SimCode i_simCode;
      list<SimCode.JacobianMatrix> i_jacobianMatrixes;
      Absyn.Path i_modelInfo_name;
      Tpl.Text l_jacobianvars;
      Tpl.Text l_jacobianfunctions;
      String str_3;
      Tpl.Text l_matrixreturntype;
      String ret_1;
      Tpl.Text l_type;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = i_modelInfo_name), jacobianMatrixes = i_jacobianMatrixes)),
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_jacobianVarsInit,
           a_createDebugCode )
      equation
        ret_1 = Flags.getConfigString(Flags.MATRIX_FORMAT);
        l_type = Tpl.writeStr(Tpl.emptyTxt, ret_1);
        str_3 = Tpl.textString(l_type);
        l_matrixreturntype = fun_67(Tpl.emptyTxt, str_3);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "#pragma once\n",
                                    "\n",
                                    "/*****************************************************************************\n",
                                    "*\n",
                                    "* Simulation code to initialize the Modelica system\n",
                                    "*\n",
                                    "*****************************************************************************/\n",
                                    "\n",
                                    "class "
                                }, false));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Jacobian : public "));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("{\n"));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING("")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_69(txt, i_jacobianMatrixes, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, i_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("public:\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("Jacobian(IGlobalSettings* globalSettings, shared_ptr<ISimObjects> simObjects);\n"));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Jacobian("));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Jacobian& instance);\n",
                                    "virtual ~"
                                }, false));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Jacobian();\n",
                                    "\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "protected:\n",
                                    "  void initialize();\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        l_jacobianfunctions = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_jacobianfunctions = lm_70(l_jacobianfunctions, i_jacobianMatrixes, l_matrixreturntype);
        l_jacobianfunctions = Tpl.popIter(l_jacobianfunctions);
        txt = Tpl.writeText(txt, l_jacobianfunctions);
        txt = Tpl.softNewLine(txt);
        l_jacobianvars = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_jacobianvars = lm_71(l_jacobianvars, i_jacobianMatrixes, l_matrixreturntype);
        l_jacobianvars = Tpl.popIter(l_jacobianvars);
        txt = Tpl.writeText(txt, l_jacobianvars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_jacobianVarsInit) = variableDefinitionsJacobians_skip(txt, i_jacobianMatrixes, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_jacobianVarsInit, a_createDebugCode);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "/*testmaessig aus der Cruntime*/\n",
                                    "void initializeColoredJacobianA();\n",
                                    "\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("};"));
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_jacobianVarsInit);

    case ( txt,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_jacobianVarsInit,
           _ )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_jacobianVarsInit);
  end match;
end simulationJacobianHeaderFile;

protected function fun_73
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      Absyn.Path i_modelInfo_name;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = i_modelInfo_name)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "#pragma once\n",
                                    "\n",
                                    "/*****************************************************************************\n",
                                    "*\n",
                                    "* Simulation code to initialize the Modelica system\n",
                                    "*\n",
                                    "*****************************************************************************/\n",
                                    "class "
                                }, false));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("StateSelection: public IStateSelection, public "));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Mixed\n",
                                    "{\n",
                                    "public:\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "StateSelection(IGlobalSettings* globalSettings, shared_ptr<ISimObjects> simObjects);\n",
                                    "virtual ~"
                                }, false));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "StateSelection();\n",
                                    "int getDimStateSets() const;\n",
                                    "int getDimStates(unsigned int index) const;\n",
                                    "int getDimCanditates(unsigned int index) const;\n",
                                    "int getDimDummyStates(unsigned int index) const;\n",
                                    "void getStates(unsigned int index,double* z);\n",
                                    "void setStates(unsigned int index,const double* z);\n",
                                    "void getStateCanditates(unsigned int index,double* z);\n",
                                    "bool getAMatrix(unsigned int index, DynArrayDim2<int>& A);\n",
                                    "void setAMatrix(unsigned int index, DynArrayDim2<int>& A);\n",
                                    "bool getAMatrix(unsigned int index, DynArrayDim1<int>& A);\n",
                                    "void setAMatrix(unsigned int index, DynArrayDim1<int>& A);\n",
                                    "\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "protected:\n",
                                    "  void initialize();\n",
                                    "};"
                                }, false));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_73;

public function simulationStateSelectionHeaderFile
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  out_txt := fun_73(txt, a_simCode);
  out_a_extraFuncs := a_extraFuncs;
  out_a_extraFuncsDecl := a_extraFuncsDecl;
  out_a_extraFuncsNamespace := a_extraFuncsNamespace;
end simulationStateSelectionHeaderFile;

protected function fun_75
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      Absyn.Path i_modelInfo_name;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = i_modelInfo_name), simulationSettingsOpt = SOME(SimCode.SIMULATION_SETTINGS(startTime = _))) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "#pragma once\n",
                                    "\n",
                                    "\n",
                                    "/*****************************************************************************\n",
                                    "*\n",
                                    "* Simulation code to write simulation file\n",
                                    "*\n",
                                    "*****************************************************************************/\n",
                                    "\n",
                                    "class "
                                }, false));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("WriteOutput : public IWriteOutput,public "));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "StateSelection\n",
                                    "{\n",
                                    "public:\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("WriteOutput(IGlobalSettings* globalSettings, shared_ptr<ISimObjects> simObjects);\n"));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("WriteOutput("));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "WriteOutput& instance);\n",
                                    "virtual ~"
                                }, false));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "WriteOutput();\n",
                                    "\n",
                                    "\n",
                                    "/// Output routine (to be called by the solver after every successful integration step)\n",
                                    "virtual void writeOutput(const IWriteOutput::OUTPUT command = IWriteOutput::UNDEF_OUTPUT);\n",
                                    "virtual IHistory* getHistory();\n",
                                    "\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "protected:\n",
                                    "  void initialize();\n",
                                    " private:\n",
                                    "  shared_ptr<IHistory> _writeOutput;\n",
                                    "};"
                                }, false));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_75;

public function simulationWriteOutputHeaderFile
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  out_txt := fun_75(txt, a_simCode);
  out_a_extraFuncs := a_extraFuncs;
  out_a_extraFuncsDecl := a_extraFuncsDecl;
  out_a_extraFuncsNamespace := a_extraFuncsNamespace;
end simulationWriteOutputHeaderFile;

public function getPreVarsCount
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo)
    local
      Tpl.Text txt;
      SimCode.ModelInfo i_modelInfo;
      Integer ret_8;
      Integer ret_7;
      Integer ret_6;
      Tpl.Text txt_5;
      Integer ret_4;
      Tpl.Text txt_3;
      Integer ret_2;
      Tpl.Text txt_1;
      Tpl.Text l_allVarCount;

    case ( txt,
           (i_modelInfo as SimCode.MODELINFO(varInfo = SimCode.VARINFO(numZeroCrossings = _))) )
      equation
        txt_1 = numRealvars(Tpl.emptyTxt, i_modelInfo);
        ret_2 = stringInt(Tpl.textString(txt_1));
        txt_3 = numIntvars(Tpl.emptyTxt, i_modelInfo);
        ret_4 = stringInt(Tpl.textString(txt_3));
        txt_5 = numBoolvars(Tpl.emptyTxt, i_modelInfo);
        ret_6 = stringInt(Tpl.textString(txt_5));
        ret_7 = intAdd(ret_4, ret_6);
        ret_8 = intAdd(ret_2, ret_7);
        l_allVarCount = Tpl.writeStr(Tpl.emptyTxt, intString(ret_8));
        txt = Tpl.writeText(txt, l_allVarCount);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end getPreVarsCount;

protected function fun_78
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncsDecl;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode, in_a_extraFuncsDecl)
    local
      Tpl.Text txt;
      Tpl.Text a_extraFuncsDecl;
      SimCode.SimCode i_simCode;
      Absyn.Path i_modelInfo_name;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(vars = SimCodeVar.SIMVARS(stateVars = _), name = i_modelInfo_name))),
           a_extraFuncsDecl )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "#pragma once\n",
                                    "/*****************************************************************************\n",
                                    "*\n",
                                    "* Simulation code\n",
                                    "*\n",
                                    "*****************************************************************************/\n",
                                    "class "
                                }, false));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Mixed:  public IMixedSystem, public "));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Jacobian\n",
                                    "{\n",
                                    "public:\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(3));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("Mixed(IGlobalSettings* globalSettings, shared_ptr<ISimObjects> simObjects);\n"));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Mixed("));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("Mixed &instance);\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("virtual ~ "));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Mixed();\n",
                                    "\n",
                                    "\n",
                                    "\n",
                                    "/// Provide Jacobian\n",
                                    "virtual const matrix_t& getJacobian() ;\n",
                                    "virtual const matrix_t& getJacobian(unsigned int index) ;\n",
                                    "virtual sparsematrix_t& getSparseJacobian();\n",
                                    "virtual sparsematrix_t& getSparseJacobian(unsigned int index);\n",
                                    "\n",
                                    "\n",
                                    "virtual  const matrix_t& getStateSetJacobian(unsigned int index);\n",
                                    "virtual  sparsematrix_t& getStateSetSparseJacobian(unsigned int index);\n",
                                    "/// Called to handle all events occured at same time\n",
                                    "virtual bool handleSystemEvents(bool* events);\n",
                                    "//Saves all variables before an event is handled, is needed for the pre, edge and change operator\n",
                                    "virtual void saveAll();\n",
                                    "virtual void getAlgebraicDAEVars(double* y);\n",
                                    "virtual void setAlgebraicDAEVars(const double* y);\n",
                                    "virtual void getResidual(double* f);\n",
                                    "virtual void evaluateDAE(const UPDATETYPE command = UNDEF_UPDATE);\n",
                                    "\n",
                                    "/*colored jacobians*/\n",
                                    "virtual void getAColorOfColumn(int* aSparsePatternColorCols, int size);\n",
                                    "virtual int  getAMaxColors();\n",
                                    "\n",
                                    "virtual string getModelName();\n",
                                    "virtual bool isJacobianSparse();//true if getSparseJacobian is implemented and getJacobian is not, false if getJacobian is implemented and getSparseJacobian is not.\n",
                                    "virtual bool isAnalyticJacobianGenerated();//true if the flag --generateSymbolicJacobian is true, false if not.\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " private:\n",
                                    "   //update residual methods\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_extraFuncsDecl);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = simulationDAEMethodsDeclaration(txt, i_simCode);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("};"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_78;

public function simulationMixedSystemHeaderFile
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  out_txt := fun_78(txt, a_simCode, a_extraFuncsDecl);
  out_a_extraFuncs := a_extraFuncs;
  out_a_extraFuncsDecl := a_extraFuncsDecl;
  out_a_extraFuncsNamespace := a_extraFuncsNamespace;
end simulationMixedSystemHeaderFile;

protected function fun_80
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      Absyn.Path i_modelInfo_name;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = i_modelInfo_name)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "#if defined(__TRICORE__) || defined(__vxworks)\n",
                                    "#include <Core/System/FactoryExport.h>\n",
                                    "#include <Core/DataExchange/SimData.h>\n",
                                    "#include <Core/System/SimVars.h>\n",
                                    "extern \"C\" IMixedSystem* createModelicaSystem(IGlobalSettings* globalSettings,shared_ptr<ISimObjects> simObjects)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("return new "));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("Initialize(globalSettings, simObjects);\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n",
                                    "extern \"C\" ISimVars* createSimVars(size_t dim_real, size_t dim_int, size_t dim_bool, size_t dim_string, size_t dim_pre_vars, size_t dim_z, size_t z_i)\n",
                                    "{\n",
                                    "    return new SimVars(dim_real, dim_int, dim_bool, dim_string, dim_pre_vars, dim_z, z_i);\n",
                                    "}\n",
                                    "\n",
                                    "extern \"C\" ISimData* createSimData()\n",
                                    "{\n",
                                    "    return new SimData();\n",
                                    "}\n",
                                    "\n",
                                    "shared_ptr<ISimData> createSimDataFunction()\n",
                                    "{\n",
                                    "  shared_ptr<ISimData> data( new SimData() );\n",
                                    "  return data;\n",
                                    "}\n",
                                    "\n",
                                    "shared_ptr<ISimVars> createSimVarsFunction(size_t dim_real, size_t dim_int, size_t dim_bool, size_t dim_string, size_t dim_pre_vars, size_t dim_z, size_t z_i)\n",
                                    "{\n",
                                    "  shared_ptr<ISimVars> var( new SimVars(dim_real, dim_int, dim_bool, dim_string, dim_pre_vars, dim_z, z_i) );\n",
                                    "  return var;\n",
                                    "}\n",
                                    "\n",
                                    "#elif defined (RUNTIME_STATIC_LINKING)\n",
                                    "#include <Core/System/FactoryExport.h>\n",
                                    "#include <Core/DataExchange/SimData.h>\n",
                                    "#include <Core/System/SimVars.h>\n",
                                    "  shared_ptr<ISimData> createSimDataFunction()\n",
                                    "  {\n",
                                    "      shared_ptr<ISimData> data( new SimData() );\n",
                                    "      return data;\n",
                                    "  }\n",
                                    "\n",
                                    "  shared_ptr<ISimVars> createSimVarsFunction(size_t dim_real, size_t dim_int, size_t dim_bool, size_t dim_string, size_t dim_pre_vars, size_t dim_z, size_t z_i)\n",
                                    "  {\n",
                                    "      shared_ptr<ISimVars> var( new SimVars(dim_real, dim_int, dim_bool, dim_string, dim_pre_vars, dim_z, z_i) );\n",
                                    "      return var;\n",
                                    "  }\n",
                                    "\n",
                                    "  shared_ptr<IMixedSystem> createSystemFunction(IGlobalSettings* globalSettings, shared_ptr<ISimObjects> simObjects)\n",
                                    "  {\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(6));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("shared_ptr<IMixedSystem> system( new "));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Initialize(globalSettings, simObjects) );\n",
                                    "return system;\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "  }\n",
                                    "\n",
                                    "#else\n",
                                    "\n",
                                    "BOOST_EXTENSION_TYPE_MAP_FUNCTION\n",
                                    "{\n",
                                    "  typedef boost::extensions::factory<IMixedSystem,IGlobalSettings*, shared_ptr<ISimObjects> > system_factory;\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("types.get<std::map<std::string, system_factory> >()[\""));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("\"]\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".system_factory::set<"));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("Initialize>();\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "#endif"
                                }, false));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_80;

public function simulationFactoryFile
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  out_txt := fun_80(txt, a_simCode);
  out_a_extraFuncs := a_extraFuncs;
  out_a_extraFuncsDecl := a_extraFuncsDecl;
  out_a_extraFuncsNamespace := a_extraFuncsNamespace;
end simulationFactoryFile;

protected function fun_82
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_dummyTypeElemCreation;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_complexStartExpressions;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_complexStartExpressions;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName, out_a_complexStartExpressions) :=
  match(in_txt, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_dummyTypeElemCreation, in_a_stateDerVectorName, in_a_useFlatArrayNotation, in_a_complexStartExpressions)
    local
      Tpl.Text txt;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_dummyTypeElemCreation;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_complexStartExpressions;
      Absyn.Path i_modelInfo_name;
      SimCode.SimCode i_simCode;
      list<SimCode.ClockedPartition> i_clockedPartitions;
      list<SimCode.SimEqSystem> i_initialEquations;
      list<SimCode.SimEqSystem> i_allEquations;
      list<SimCode.SimEqSystem> ret_3;
      list<SimCode.SimEqSystem> ret_2;
      list<SimCode.SubPartition> ret_1;
      list<SimCode.SimEqSystem> ret_0;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = i_modelInfo_name), allEquations = i_allEquations, initialEquations = i_initialEquations, clockedPartitions = i_clockedPartitions)),
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_dummyTypeElemCreation,
           a_stateDerVectorName,
           a_useFlatArrayNotation,
           a_complexStartExpressions )
      equation
        ret_0 = listAppend(i_allEquations, i_initialEquations);
        ret_1 = SimCodeUtil.getSubPartitions(i_clockedPartitions);
        ret_2 = SimCodeUtil.getClockedEquations(ret_1);
        ret_3 = listAppend(ret_0, ret_2);
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = algloopfilesInclude(txt, ret_3, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Initialize::"));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Initialize(IGlobalSettings* globalSettings, shared_ptr<ISimObjects> simObjects)\n",
                                    ": "
                                }, false));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "WriteOutput(globalSettings, simObjects)\n",
                                    ", _constructedExternalObjects(false)\n",
                                    "{\n",
                                    "  InitializeDummyTypeElems();\n",
                                    "}\n",
                                    "\n"
                                }, true));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Initialize::"));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Initialize("));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Initialize& instance)\n",
                                    ": "
                                }, false));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "WriteOutput(instance)\n",
                                    "{\n",
                                    "  InitializeDummyTypeElems();\n",
                                    "}\n",
                                    "\n"
                                }, true));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Initialize::~"));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Initialize()\n",
                                    "{\n",
                                    "  if (_constructedExternalObjects)\n",
                                    "    destructExternalObjects();\n",
                                    "}\n",
                                    "\n",
                                    "void "
                                }, false));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Initialize::InitializeDummyTypeElems()\n",
                                    "{\n",
                                    "  //This is necessary to prevent linker errors that occur with GCC 4.4 if a complex type is not used in the code and contains arrays\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_dummyTypeElemCreation);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n",
                                    "IMixedSystem* "
                                }, false));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Initialize::clone()\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("return new "));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("Initialize(*this);\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n"
                                }, true));
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = getIntialStatus(txt, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = setIntialStatus(txt, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_complexStartExpressions) = init(txt, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation, a_complexStartExpressions);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = destructExtObjs(txt, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_extraFuncs);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_complexStartExpressions);

    case ( txt,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           _,
           a_stateDerVectorName,
           _,
           a_complexStartExpressions )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_complexStartExpressions);
  end match;
end fun_82;

public function simulationInitCppFile
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_dummyTypeElemCreation;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;
  input Tpl.Text a_complexStartExpressions;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_dummyTypeElemCreation;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_complexStartExpressions;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName, out_a_complexStartExpressions) := fun_82(txt, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_dummyTypeElemCreation, a_stateDerVectorName, a_useFlatArrayNotation, a_complexStartExpressions);
  out_a_dummyTypeElemCreation := a_dummyTypeElemCreation;
end simulationInitCppFile;

protected function fun_84
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("check"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("initialize"));
      then txt;
  end match;
end fun_84;

protected function fun_85
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_a_modelInfo, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      list<SimCodeVar.SimVar> i_vars_stringParamVars;
      list<SimCodeVar.SimVar> i_vars_boolParamVars;
      list<SimCodeVar.SimVar> i_vars_intParamVars;
      list<SimCodeVar.SimVar> i_vars_paramVars;
      Absyn.Path i_modelInfo_name;
      Tpl.Text txt_12;
      Tpl.Text l_init13;
      Tpl.Text txt_10;
      Tpl.Text l_init12;
      Tpl.Text txt_8;
      Tpl.Text l_init11;
      Tpl.Text txt_6;
      Tpl.Text l_init10;
      Boolean ret_4;
      Tpl.Text l_functionPrefix;
      Tpl.Text l_varDecls12;
      Tpl.Text l_varDecls11;
      Tpl.Text l_varDecls10;

    case ( txt,
           SimCode.MODELINFO(vars = SimCodeVar.SIMVARS(paramVars = i_vars_paramVars, intParamVars = i_vars_intParamVars, boolParamVars = i_vars_boolParamVars, stringParamVars = i_vars_stringParamVars), name = i_modelInfo_name),
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        l_varDecls10 = Tpl.emptyTxt;
        l_varDecls11 = Tpl.emptyTxt;
        l_varDecls12 = Tpl.emptyTxt;
        ret_4 = Flags.isSet(Flags.HARDCODED_START_VALUES);
        l_functionPrefix = fun_84(Tpl.emptyTxt, ret_4);
        txt_6 = lastIdentOfPath(Tpl.emptyTxt, i_modelInfo_name);
        txt_6 = Tpl.writeTok(txt_6, Tpl.ST_STRING("Initialize::"));
        txt_6 = Tpl.writeText(txt_6, l_functionPrefix);
        txt_6 = Tpl.writeTok(txt_6, Tpl.ST_STRING("ParameterVars"));
        (l_init10, l_varDecls10, _, txt_6, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = initValstWithSplit(Tpl.emptyTxt, l_varDecls10, Tpl.strTokText(Tpl.ST_STRING("Real")), txt_6, i_vars_paramVars, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, SimCodeFunction.contextOther, a_stateDerVectorName, a_useFlatArrayNotation);
        txt_8 = lastIdentOfPath(Tpl.emptyTxt, i_modelInfo_name);
        txt_8 = Tpl.writeTok(txt_8, Tpl.ST_STRING("Initialize::"));
        txt_8 = Tpl.writeText(txt_8, l_functionPrefix);
        txt_8 = Tpl.writeTok(txt_8, Tpl.ST_STRING("IntParameterVars"));
        (l_init11, l_varDecls11, _, txt_8, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = initValstWithSplit(Tpl.emptyTxt, l_varDecls11, Tpl.strTokText(Tpl.ST_STRING("Int")), txt_8, i_vars_intParamVars, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, SimCodeFunction.contextOther, a_stateDerVectorName, a_useFlatArrayNotation);
        txt_10 = lastIdentOfPath(Tpl.emptyTxt, i_modelInfo_name);
        txt_10 = Tpl.writeTok(txt_10, Tpl.ST_STRING("Initialize::"));
        txt_10 = Tpl.writeText(txt_10, l_functionPrefix);
        txt_10 = Tpl.writeTok(txt_10, Tpl.ST_STRING("BoolParameterVars"));
        (l_init12, l_varDecls12, _, txt_10, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = initValstWithSplit(Tpl.emptyTxt, l_varDecls12, Tpl.strTokText(Tpl.ST_STRING("Bool")), txt_10, i_vars_boolParamVars, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, SimCodeFunction.contextOther, a_stateDerVectorName, a_useFlatArrayNotation);
        txt_12 = lastIdentOfPath(Tpl.emptyTxt, i_modelInfo_name);
        txt_12 = Tpl.writeTok(txt_12, Tpl.ST_STRING("Initialize::"));
        txt_12 = Tpl.writeText(txt_12, l_functionPrefix);
        txt_12 = Tpl.writeTok(txt_12, Tpl.ST_STRING("StringParameterVars"));
        (l_init13, l_varDecls12, _, txt_12, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = initValstWithSplit(Tpl.emptyTxt, l_varDecls12, Tpl.strTokText(Tpl.ST_STRING("String")), txt_12, i_vars_stringParamVars, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, SimCodeFunction.contextOther, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeText(txt, l_varDecls10);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_varDecls11);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_varDecls12);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_init10);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_init11);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_init12);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_init13);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_85;

public function simulationInitParameterCppFile
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      SimCode.SimCode i_simCode;
      SimCode.ModelInfo i_modelInfo;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = i_modelInfo)),
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_85(txt, i_modelInfo, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, i_simCode);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end simulationInitParameterCppFile;

protected function fun_87
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("check"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("initialize"));
      then txt;
  end match;
end fun_87;

protected function fun_88
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_a_modelInfo, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      list<SimCodeVar.SimVar> i_vars_stringAlgVars;
      list<SimCodeVar.SimVar> i_vars_boolAlgVars;
      list<SimCodeVar.SimVar> i_vars_intAlgVars;
      list<SimCodeVar.SimVar> i_vars_discreteAlgVars;
      list<SimCodeVar.SimVar> i_vars_algVars;
      Absyn.Path i_modelInfo_name;
      Tpl.Text txt_14;
      Tpl.Text l_init7;
      Tpl.Text l_init6;
      Tpl.Text txt_11;
      Tpl.Text l_init5;
      Tpl.Text l_init4;
      Tpl.Text txt_8;
      Tpl.Text l_init3;
      Boolean ret_6;
      Tpl.Text l_functionPrefix;
      Tpl.Text l_varDecls7;
      Tpl.Text l_varDecls6;
      Tpl.Text l_varDecls5;
      Tpl.Text l_varDecls4;
      Tpl.Text l_varDecls3;

    case ( txt,
           SimCode.MODELINFO(vars = SimCodeVar.SIMVARS(algVars = i_vars_algVars, discreteAlgVars = i_vars_discreteAlgVars, intAlgVars = i_vars_intAlgVars, boolAlgVars = i_vars_boolAlgVars, stringAlgVars = i_vars_stringAlgVars), name = i_modelInfo_name),
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        l_varDecls3 = Tpl.emptyTxt;
        l_varDecls4 = Tpl.emptyTxt;
        l_varDecls5 = Tpl.emptyTxt;
        l_varDecls6 = Tpl.emptyTxt;
        l_varDecls7 = Tpl.emptyTxt;
        ret_6 = Flags.isSet(Flags.HARDCODED_START_VALUES);
        l_functionPrefix = fun_87(Tpl.emptyTxt, ret_6);
        txt_8 = lastIdentOfPath(Tpl.emptyTxt, i_modelInfo_name);
        txt_8 = Tpl.writeTok(txt_8, Tpl.ST_STRING("Initialize::"));
        txt_8 = Tpl.writeText(txt_8, l_functionPrefix);
        txt_8 = Tpl.writeTok(txt_8, Tpl.ST_STRING("AlgVars"));
        (l_init3, l_varDecls3, _, txt_8, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = initValstWithSplit(Tpl.emptyTxt, l_varDecls3, Tpl.strTokText(Tpl.ST_STRING("Real")), txt_8, i_vars_algVars, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, SimCodeFunction.contextOther, a_stateDerVectorName, a_useFlatArrayNotation);
        (l_init4, l_varDecls4, _, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = initValst(Tpl.emptyTxt, l_varDecls4, Tpl.strTokText(Tpl.ST_STRING("Real")), i_vars_discreteAlgVars, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, SimCodeFunction.contextOther, a_stateDerVectorName, a_useFlatArrayNotation);
        txt_11 = lastIdentOfPath(Tpl.emptyTxt, i_modelInfo_name);
        txt_11 = Tpl.writeTok(txt_11, Tpl.ST_STRING("Initialize::"));
        txt_11 = Tpl.writeText(txt_11, l_functionPrefix);
        txt_11 = Tpl.writeTok(txt_11, Tpl.ST_STRING("IntAlgVars"));
        (l_init5, l_varDecls5, _, txt_11, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = initValstWithSplit(Tpl.emptyTxt, l_varDecls5, Tpl.strTokText(Tpl.ST_STRING("Int")), txt_11, i_vars_intAlgVars, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, SimCodeFunction.contextOther, a_stateDerVectorName, a_useFlatArrayNotation);
        (l_init6, l_varDecls6, _, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = initValst(Tpl.emptyTxt, l_varDecls6, Tpl.strTokText(Tpl.ST_STRING("Bool")), i_vars_boolAlgVars, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, SimCodeFunction.contextOther, a_stateDerVectorName, a_useFlatArrayNotation);
        txt_14 = lastIdentOfPath(Tpl.emptyTxt, i_modelInfo_name);
        txt_14 = Tpl.writeTok(txt_14, Tpl.ST_STRING("Initialize::"));
        txt_14 = Tpl.writeText(txt_14, l_functionPrefix);
        txt_14 = Tpl.writeTok(txt_14, Tpl.ST_STRING("StringAlgVars"));
        (l_init7, l_varDecls7, _, txt_14, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = initValstWithSplit(Tpl.emptyTxt, l_varDecls7, Tpl.strTokText(Tpl.ST_STRING("String")), txt_14, i_vars_stringAlgVars, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, SimCodeFunction.contextOther, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_init3);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "void "
                                }, false));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Initialize::"));
        txt = Tpl.writeText(txt, l_functionPrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "DiscreteAlgVars()\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(3));
        txt = Tpl.writeText(txt, l_varDecls4);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_init4);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n"
                                }, true));
        txt = Tpl.writeText(txt, l_init5);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "void "
                                }, false));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Initialize::"));
        txt = Tpl.writeText(txt, l_functionPrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "BoolAlgVars()\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.writeText(txt, l_varDecls6);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_init6);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n"
                                }, true));
        txt = Tpl.writeText(txt, l_init7);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_88;

public function simulationInitAlgVarsCppFile
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      SimCode.SimCode i_simCode;
      SimCode.ModelInfo i_modelInfo;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = i_modelInfo)),
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_88(txt, i_modelInfo, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, i_simCode);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end simulationInitAlgVarsCppFile;

protected function lm_90
  input Tpl.Text in_txt;
  input list<SimCode.JacobianMatrix> in_items;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCode.JacobianMatrix> rest;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      list<list<Integer>> i_colorList;
      SimCode.SparsityPattern i_sparsepattern;
      String i_name;
      list<SimCodeVar.SimVar> i_vars;
      list<SimCode.JacobianColumn> i_mat;
      Integer i_jacIndex;

    case ( txt,
           {},
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           SimCode.JAC_MATRIX(columns = i_mat, seedVars = i_vars, matrixName = i_name, sparsity = i_sparsepattern, coloredCols = i_colorList, jacobianIndex = i_jacIndex) :: rest,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = initialAnalyticJacobians(txt, i_jacIndex, i_mat, i_vars, i_name, i_sparsepattern, i_colorList, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
        txt = Tpl.nextIter(txt);
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_90(txt, rest, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _ :: rest,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_90(txt, rest, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_90;

protected function lm_91
  input Tpl.Text in_txt;
  input list<SimCode.JacobianColumn> in_items;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCode.JacobianColumn> rest;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      list<SimCode.SimEqSystem> i_eqs;

    case ( txt,
           {},
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           SimCode.JAC_COLUMN(columnEqns = i_eqs) :: rest,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = algloopfilesInclude(txt, i_eqs, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
        txt = Tpl.nextIter(txt);
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_91(txt, rest, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _ :: rest,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_91(txt, rest, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_91;

protected function lm_92
  input Tpl.Text in_txt;
  input list<SimCode.JacobianMatrix> in_items;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCode.JacobianMatrix> rest;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      list<SimCode.JacobianColumn> i_mat;

    case ( txt,
           {},
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           SimCode.JAC_MATRIX(columns = i_mat) :: rest,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING("")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_91(txt, i_mat, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.nextIter(txt);
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_92(txt, rest, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _ :: rest,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_92(txt, rest, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_92;

protected function fun_93
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_jacobianVarsInit;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_jacobianVarsInit, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_jacobianVarsInit;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      SimCode.ModelInfo i_modelInfo;
      Absyn.Path i_modelInfo_name;
      SimCode.SimCode i_simCode;
      list<SimCode.JacobianMatrix> i_jacobianMatrixes;
      Tpl.Text txt_1;
      Tpl.Text l_initialjacMats;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = (i_modelInfo as SimCode.MODELINFO(name = i_modelInfo_name)), jacobianMatrixes = i_jacobianMatrixes)),
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_jacobianVarsInit,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_initialjacMats = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_initialjacMats, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_90(l_initialjacMats, i_jacobianMatrixes, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, i_simCode);
        l_initialjacMats = Tpl.popIter(l_initialjacMats);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING("")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_92(txt, i_jacobianMatrixes, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, i_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Jacobian::"));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("Jacobian(IGlobalSettings* globalSettings, shared_ptr<ISimObjects> simObjects)\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(": "));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(globalSettings,simObjects)\n",
                                    ", _AColorOfColumn(NULL)\n",
                                    ", _AMaxColors(0)\n"
                                }, true));
        txt = Tpl.writeText(txt, l_initialjacMats);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, a_jacobianVarsInit);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "{\n",
                                    "}\n",
                                    "\n"
                                }, true));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Jacobian::"));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Jacobian("));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("Jacobian& instance)\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(": "));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(instance)\n",
                                    ", _AColorOfColumn(NULL)\n",
                                    ", _AMaxColors(0)\n"
                                }, true));
        txt = Tpl.writeText(txt, l_initialjacMats);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, a_jacobianVarsInit);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "{\n",
                                    "}\n",
                                    "\n"
                                }, true));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Jacobian::~"));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Jacobian()\n",
                                    "{\n",
                                    "if(_AColorOfColumn)\n",
                                    "  delete []  _AColorOfColumn;\n",
                                    "}\n",
                                    "\n"
                                }, true));
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = functionAnalyticJacobians(txt, i_modelInfo, i_jacobianMatrixes, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "//testmaessig aus der cruntime\n",
                                    "/* Jacobians */\n",
                                    "\n",
                                    "\n",
                                    "void "
                                }, false));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Jacobian::initializeColoredJacobianA()\n",
                                    "{\n"
                                }, true));
        txt_1 = lastIdentOfPath(Tpl.emptyTxt, i_modelInfo_name);
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = functionAnalyticJacobians2(txt, i_jacobianMatrixes, Tpl.textString(txt_1), i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("}\n"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           _,
           a_stateDerVectorName,
           _ )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end fun_93;

public function simulationJacobianCppFile
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_jacobianVarsInit;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_jacobianVarsInit;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) := fun_93(txt, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_jacobianVarsInit, a_stateDerVectorName, a_useFlatArrayNotation);
  out_a_jacobianVarsInit := a_jacobianVarsInit;
end simulationJacobianCppFile;

public function simulationStateSelectionCppFile
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      SimCode.SimCode i_simCode;
      list<SimCode.StateSet> i_stateSets;
      Absyn.Path i_modelInfo_name;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = i_modelInfo_name), stateSets = i_stateSets)),
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("StateSelection::"));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("StateSelection(IGlobalSettings* globalSettings, shared_ptr<ISimObjects> simObjects)\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(": "));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("Mixed(globalSettings, simObjects)\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "{\n",
                                    "}\n",
                                    "\n"
                                }, true));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("StateSelection::~"));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "StateSelection()\n",
                                    "{\n",
                                    "}\n",
                                    "\n"
                                }, true));
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = functionDimStateSets(txt, i_stateSets, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
        txt = Tpl.softNewLine(txt);
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = functionStateSets(txt, i_stateSets, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end simulationStateSelectionCppFile;

public function simulationWriteOutputCppFile
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      SimCode.SimCode i_simCode;
      SimCode.ModelInfo i_modelInfo;
      Absyn.Path i_modelInfo_name;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = (i_modelInfo as SimCode.MODELINFO(name = i_modelInfo_name)))),
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "\n"
                                }, true));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("WriteOutput::"));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("WriteOutput(IGlobalSettings* globalSettings, shared_ptr<ISimObjects> simObjects)\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(": "));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("StateSelection(globalSettings, simObjects)\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "{\n",
                                    "\n",
                                    "\n",
                                    "\n",
                                    "}\n",
                                    "\n"
                                }, true));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("WriteOutput::"));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("WriteOutput("));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("WriteOutput& instance)\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(": "));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("StateSelection(instance.getGlobalSettings(), instance.getSimObjects())\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "{\n",
                                    "\n",
                                    "}\n",
                                    "\n"
                                }, true));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("WriteOutput::~"));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "WriteOutput()\n",
                                    "{\n",
                                    "\n",
                                    "}\n",
                                    "\n",
                                    "IHistory* "
                                }, false));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "WriteOutput::getHistory()\n",
                                    "{\n",
                                    "  return _writeOutput.get();\n",
                                    "}\n",
                                    "\n",
                                    "void "
                                }, false));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "WriteOutput::initialize()\n",
                                    "{\n",
                                    "   if(getGlobalSettings()->getOutputPointType()!= OPT_NONE)\n",
                                    "   {\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(5));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_writeOutput = getSimObjects()->LoadWriter("));
        txt = numAlgvars(txt, i_modelInfo);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" + "));
        txt = numAliasvars(txt, i_modelInfo);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" + 2*"));
        txt = numStatevars(txt, i_modelInfo);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(").lock();\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " _writeOutput->init();\n",
                                    "     _writeOutput->clear();\n",
                                    "   }\n",
                                    "}\n",
                                    "\n",
                                    "\n"
                                }, true));
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = writeoutput(txt, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end simulationWriteOutputCppFile;

protected function lm_97
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      DAE.ComponentRef i_name;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(isProtected = false, name = i_name) :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        txt = CodegenCppCommonOld.crefStrForWriteOutput(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        txt = Tpl.nextIter(txt);
        txt = lm_97(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_97(txt, rest);
      then txt;
  end match;
end lm_97;

protected function fun_98
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_mArg;
  input list<SimCodeVar.SimVar> in_a_vars_algVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_vars_algVars)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> a_vars_algVars;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           _,
           a_vars_algVars )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("names += "));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 10, 0, Tpl.ST_STRING_LIST({
                                                                                                 ";\n",
                                                                                                 " names += "
                                                                                             }, false), 0, Tpl.ST_NEW_LINE()));
        txt = lm_97(txt, a_vars_algVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_98;

protected function lm_99
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      DAE.ComponentRef i_name;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(isProtected = false, name = i_name) :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        txt = CodegenCppCommonOld.crefStrForWriteOutput(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        txt = Tpl.nextIter(txt);
        txt = lm_99(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_99(txt, rest);
      then txt;
  end match;
end lm_99;

protected function fun_100
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_mArg;
  input list<SimCodeVar.SimVar> in_a_vars_discreteAlgVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_vars_discreteAlgVars)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> a_vars_discreteAlgVars;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           _,
           a_vars_discreteAlgVars )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("names += "));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 10, 0, Tpl.ST_STRING_LIST({
                                                                                                 ";\n",
                                                                                                 " names += "
                                                                                             }, false), 0, Tpl.ST_NEW_LINE()));
        txt = lm_99(txt, a_vars_discreteAlgVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_100;

protected function lm_101
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      DAE.ComponentRef i_name;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(isProtected = false, name = i_name) :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        txt = CodegenCppCommonOld.crefStrForWriteOutput(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        txt = Tpl.nextIter(txt);
        txt = lm_101(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_101(txt, rest);
      then txt;
  end match;
end lm_101;

protected function fun_102
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_mArg;
  input list<SimCodeVar.SimVar> in_a_vars_intAlgVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_vars_intAlgVars)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> a_vars_intAlgVars;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           _,
           a_vars_intAlgVars )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("names += "));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 10, 0, Tpl.ST_STRING_LIST({
                                                                                                 ";\n",
                                                                                                 " names += "
                                                                                             }, false), 0, Tpl.ST_NEW_LINE()));
        txt = lm_101(txt, a_vars_intAlgVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_102;

protected function lm_103
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      DAE.ComponentRef i_name;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(isProtected = false, name = i_name) :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        txt = CodegenCppCommonOld.crefStrForWriteOutput(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        txt = Tpl.nextIter(txt);
        txt = lm_103(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_103(txt, rest);
      then txt;
  end match;
end lm_103;

protected function fun_104
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_mArg;
  input list<SimCodeVar.SimVar> in_a_vars_boolAlgVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_vars_boolAlgVars)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> a_vars_boolAlgVars;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           _,
           a_vars_boolAlgVars )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("names +="));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 10, 0, Tpl.ST_STRING_LIST({
                                                                                                 ";\n",
                                                                                                 " names += "
                                                                                             }, false), 0, Tpl.ST_NEW_LINE()));
        txt = lm_103(txt, a_vars_boolAlgVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_104;

protected function lm_105
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      String i_comment;
      String ret_0;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(isProtected = false, comment = i_comment) :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        ret_0 = Util.escapeModelicaStringToCString(i_comment);
        txt = Tpl.writeStr(txt, ret_0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        txt = Tpl.nextIter(txt);
        txt = lm_105(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_105(txt, rest);
      then txt;
  end match;
end lm_105;

protected function fun_106
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_mArg;
  input list<SimCodeVar.SimVar> in_a_vars_algVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_vars_algVars)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> a_vars_algVars;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           _,
           a_vars_algVars )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("description += "));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 10, 0, Tpl.ST_STRING_LIST({
                                                                                                 ";\n",
                                                                                                 " description += "
                                                                                             }, false), 0, Tpl.ST_NEW_LINE()));
        txt = lm_105(txt, a_vars_algVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_106;

protected function lm_107
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      String i_comment;
      String ret_0;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(isProtected = false, comment = i_comment) :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        ret_0 = Util.escapeModelicaStringToCString(i_comment);
        txt = Tpl.writeStr(txt, ret_0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        txt = Tpl.nextIter(txt);
        txt = lm_107(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_107(txt, rest);
      then txt;
  end match;
end lm_107;

protected function fun_108
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_mArg;
  input list<SimCodeVar.SimVar> in_a_vars_discreteAlgVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_vars_discreteAlgVars)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> a_vars_discreteAlgVars;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           _,
           a_vars_discreteAlgVars )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("description += "));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 10, 0, Tpl.ST_STRING_LIST({
                                                                                                 ";\n",
                                                                                                 " description += "
                                                                                             }, false), 0, Tpl.ST_NEW_LINE()));
        txt = lm_107(txt, a_vars_discreteAlgVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_108;

protected function lm_109
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      String i_comment;
      String ret_0;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(isProtected = false, comment = i_comment) :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        ret_0 = Util.escapeModelicaStringToCString(i_comment);
        txt = Tpl.writeStr(txt, ret_0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        txt = Tpl.nextIter(txt);
        txt = lm_109(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_109(txt, rest);
      then txt;
  end match;
end lm_109;

protected function fun_110
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_mArg;
  input list<SimCodeVar.SimVar> in_a_vars_intAlgVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_vars_intAlgVars)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> a_vars_intAlgVars;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           _,
           a_vars_intAlgVars )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("description += "));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 10, 0, Tpl.ST_STRING_LIST({
                                                                                                 ";\n",
                                                                                                 " description += "
                                                                                             }, false), 0, Tpl.ST_NEW_LINE()));
        txt = lm_109(txt, a_vars_intAlgVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_110;

protected function lm_111
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      String i_comment;
      String ret_0;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(isProtected = false, comment = i_comment) :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        ret_0 = Util.escapeModelicaStringToCString(i_comment);
        txt = Tpl.writeStr(txt, ret_0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        txt = Tpl.nextIter(txt);
        txt = lm_111(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_111(txt, rest);
      then txt;
  end match;
end lm_111;

protected function fun_112
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_mArg;
  input list<SimCodeVar.SimVar> in_a_vars_boolAlgVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_vars_boolAlgVars)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> a_vars_boolAlgVars;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           _,
           a_vars_boolAlgVars )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("description +="));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 10, 0, Tpl.ST_STRING_LIST({
                                                                                                 ";\n",
                                                                                                 " description += "
                                                                                             }, false), 0, Tpl.ST_NEW_LINE()));
        txt = lm_111(txt, a_vars_boolAlgVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_112;

protected function fun_113
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_a_modelInfo, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      list<SimCodeVar.SimVar> i_vars_boolAlgVars;
      list<SimCodeVar.SimVar> i_vars_intAlgVars;
      list<SimCodeVar.SimVar> i_vars_discreteAlgVars;
      list<SimCodeVar.SimVar> i_vars_algVars;
      SimCode.ModelInfo i_modelInfo;
      Absyn.Path i_modelInfo_name;
      Tpl.Text txt_36;
      Integer ret_35;
      list<SimCodeVar.SimVar> ret_34;
      Tpl.Text txt_33;
      Integer ret_32;
      list<SimCodeVar.SimVar> ret_31;
      Tpl.Text txt_30;
      Integer ret_29;
      list<SimCodeVar.SimVar> ret_28;
      Tpl.Text txt_27;
      Integer ret_26;
      list<SimCodeVar.SimVar> ret_25;
      list<SimCodeVar.SimVar> ret_24;
      list<SimCodeVar.SimVar> ret_23;
      list<SimCodeVar.SimVar> ret_22;
      list<SimCodeVar.SimVar> ret_21;
      list<SimCodeVar.SimVar> ret_20;
      list<SimCodeVar.SimVar> ret_19;
      list<SimCodeVar.SimVar> ret_18;
      list<SimCodeVar.SimVar> ret_17;
      Integer ret_16;
      Integer ret_15;
      Tpl.Text txt_14;
      Integer ret_13;
      Tpl.Text l_boolAlgVarsStart;
      Integer ret_11;
      Integer ret_10;
      Tpl.Text txt_9;
      Integer ret_8;
      Tpl.Text l_intAlgVarsStart;
      Integer ret_6;
      Integer ret_5;
      Tpl.Text txt_4;
      Integer ret_3;
      Tpl.Text l_discrAlgVarsStart;
      Tpl.Text l_algVarsStart;
      Tpl.Text l_className;

    case ( txt,
           (i_modelInfo as SimCode.MODELINFO(vars = SimCodeVar.SIMVARS(algVars = i_vars_algVars, discreteAlgVars = i_vars_discreteAlgVars, intAlgVars = i_vars_intAlgVars, boolAlgVars = i_vars_boolAlgVars), name = i_modelInfo_name)),
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        l_className = lastIdentOfPath(Tpl.emptyTxt, i_modelInfo_name);
        l_algVarsStart = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("1"));
        ret_3 = stringInt(Tpl.textString(l_algVarsStart));
        txt_4 = numProtectedRealAlgvars(Tpl.emptyTxt, i_modelInfo);
        ret_5 = stringInt(Tpl.textString(txt_4));
        ret_6 = intAdd(ret_3, ret_5);
        l_discrAlgVarsStart = Tpl.writeStr(Tpl.emptyTxt, intString(ret_6));
        ret_8 = stringInt(Tpl.textString(l_discrAlgVarsStart));
        txt_9 = numProtectedDiscreteAlgVars(Tpl.emptyTxt, i_modelInfo);
        ret_10 = stringInt(Tpl.textString(txt_9));
        ret_11 = intAdd(ret_8, ret_10);
        l_intAlgVarsStart = Tpl.writeStr(Tpl.emptyTxt, intString(ret_11));
        ret_13 = stringInt(Tpl.textString(l_intAlgVarsStart));
        txt_14 = numProtectedIntAlgvars(Tpl.emptyTxt, i_modelInfo);
        ret_15 = stringInt(Tpl.textString(txt_14));
        ret_16 = intAdd(ret_13, ret_15);
        l_boolAlgVarsStart = Tpl.writeStr(Tpl.emptyTxt, intString(ret_16));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = Tpl.writeText(txt, l_className);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "WriteOutput::writeAlgVarsResultNames(vector<string>& names)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        ret_17 = SimCodeFunctionUtil.protectedVars(i_vars_algVars);
        txt = fun_98(txt, ret_17, i_vars_algVars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "void "
                                }, false));
        txt = Tpl.writeText(txt, l_className);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "WriteOutput::writeDiscreteAlgVarsResultNames(vector<string>& names)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        ret_18 = SimCodeFunctionUtil.protectedVars(i_vars_discreteAlgVars);
        txt = fun_100(txt, ret_18, i_vars_discreteAlgVars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "void  "
                                }, false));
        txt = Tpl.writeText(txt, l_className);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "WriteOutput::writeIntAlgVarsResultNames(vector<string>& names)\n",
                                    " {\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        ret_19 = SimCodeFunctionUtil.protectedVars(i_vars_intAlgVars);
        txt = fun_102(txt, ret_19, i_vars_intAlgVars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" }\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = Tpl.writeText(txt, l_className);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "WriteOutput::writeBoolAlgVarsResultNames(vector<string>& names)\n",
                                    "{\n"
                                }, true));
        ret_20 = SimCodeFunctionUtil.protectedVars(i_vars_boolAlgVars);
        txt = fun_104(txt, ret_20, i_vars_boolAlgVars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("}\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = Tpl.writeText(txt, l_className);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "WriteOutput::writeAlgVarsResultDescription(vector<string>& description)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        ret_21 = SimCodeFunctionUtil.protectedVars(i_vars_algVars);
        txt = fun_106(txt, ret_21, i_vars_algVars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "void "
                                }, false));
        txt = Tpl.writeText(txt, l_className);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "WriteOutput::writeDiscreteAlgVarsResultDescription(vector<string>& description)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        ret_22 = SimCodeFunctionUtil.protectedVars(i_vars_discreteAlgVars);
        txt = fun_108(txt, ret_22, i_vars_discreteAlgVars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "void  "
                                }, false));
        txt = Tpl.writeText(txt, l_className);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "WriteOutput::writeIntAlgVarsResultDescription(vector<string>& description)\n",
                                    " {\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        ret_23 = SimCodeFunctionUtil.protectedVars(i_vars_intAlgVars);
        txt = fun_110(txt, ret_23, i_vars_intAlgVars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" }\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = Tpl.writeText(txt, l_className);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "WriteOutput::writeBoolAlgVarsResultDescription(vector<string>& description)\n",
                                    "{\n"
                                }, true));
        ret_24 = SimCodeFunctionUtil.protectedVars(i_vars_boolAlgVars);
        txt = fun_112(txt, ret_24, i_vars_boolAlgVars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("}\n"));
        ret_25 = SimCodeFunctionUtil.protectedVars(i_vars_algVars);
        ret_26 = stringInt(Tpl.textString(l_algVarsStart));
        txt_27 = Tpl.writeText(Tpl.emptyTxt, l_className);
        txt_27 = Tpl.writeTok(txt_27, Tpl.ST_STRING("WriteOutput"));
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = writeOutputVarsWithSplit(txt, "writeAlgVarsValues", ret_25, ret_26, Tpl.textString(txt_27), false, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.softNewLine(txt);
        ret_28 = SimCodeFunctionUtil.protectedVars(i_vars_discreteAlgVars);
        ret_29 = stringInt(Tpl.textString(l_discrAlgVarsStart));
        txt_30 = Tpl.writeText(Tpl.emptyTxt, l_className);
        txt_30 = Tpl.writeTok(txt_30, Tpl.ST_STRING("WriteOutput"));
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = writeOutputVarsWithSplit(txt, "writeDiscreteAlgVarsValues", ret_28, ret_29, Tpl.textString(txt_30), false, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.softNewLine(txt);
        ret_31 = SimCodeFunctionUtil.protectedVars(i_vars_intAlgVars);
        ret_32 = stringInt(Tpl.textString(l_intAlgVarsStart));
        txt_33 = Tpl.writeText(Tpl.emptyTxt, l_className);
        txt_33 = Tpl.writeTok(txt_33, Tpl.ST_STRING("WriteOutput"));
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = writeOutputVarsWithSplit(txt, "writeIntAlgVarsValues", ret_31, ret_32, Tpl.textString(txt_33), false, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.softNewLine(txt);
        ret_34 = SimCodeFunctionUtil.protectedVars(i_vars_boolAlgVars);
        ret_35 = stringInt(Tpl.textString(l_boolAlgVarsStart));
        txt_36 = Tpl.writeText(Tpl.emptyTxt, l_className);
        txt_36 = Tpl.writeTok(txt_36, Tpl.ST_STRING("WriteOutput"));
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = writeOutputVarsWithSplit(txt, "writeBoolAlgVarsValues", ret_34, ret_35, Tpl.textString(txt_36), false, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.popBlock(txt);
        txt = Tpl.popBlock(txt);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_113;

public function simulationWriteOutputAlgVarsCppFile
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      SimCode.SimCode i_simCode;
      SimCode.ModelInfo i_modelInfo;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = i_modelInfo)),
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_113(txt, i_modelInfo, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, i_simCode);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end simulationWriteOutputAlgVarsCppFile;

protected function lm_115
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      DAE.ComponentRef i_name;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(isProtected = false, name = i_name) :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        txt = CodegenCppCommonOld.crefStrForWriteOutput(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        txt = Tpl.nextIter(txt);
        txt = lm_115(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_115(txt, rest);
      then txt;
  end match;
end lm_115;

protected function fun_116
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_mArg;
  input list<SimCodeVar.SimVar> in_a_vars_paramVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_vars_paramVars)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> a_vars_paramVars;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           _,
           a_vars_paramVars )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("names += "));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 10, 0, Tpl.ST_STRING_LIST({
                                                                                                 ";\n",
                                                                                                 " names += "
                                                                                             }, false), 0, Tpl.ST_NEW_LINE()));
        txt = lm_115(txt, a_vars_paramVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_116;

protected function lm_117
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      DAE.ComponentRef i_name;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(isProtected = false, name = i_name) :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        txt = CodegenCppCommonOld.crefStrForWriteOutput(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        txt = Tpl.nextIter(txt);
        txt = lm_117(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_117(txt, rest);
      then txt;
  end match;
end lm_117;

protected function fun_118
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_mArg;
  input list<SimCodeVar.SimVar> in_a_vars_intParamVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_vars_intParamVars)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> a_vars_intParamVars;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           _,
           a_vars_intParamVars )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("names += "));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 10, 0, Tpl.ST_STRING_LIST({
                                                                                                 ";\n",
                                                                                                 " names += "
                                                                                             }, false), 0, Tpl.ST_NEW_LINE()));
        txt = lm_117(txt, a_vars_intParamVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_118;

protected function lm_119
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      DAE.ComponentRef i_name;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(isProtected = false, name = i_name) :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        txt = CodegenCppCommonOld.crefStrForWriteOutput(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        txt = Tpl.nextIter(txt);
        txt = lm_119(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_119(txt, rest);
      then txt;
  end match;
end lm_119;

protected function fun_120
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_mArg;
  input list<SimCodeVar.SimVar> in_a_vars_boolParamVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_vars_boolParamVars)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> a_vars_boolParamVars;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           _,
           a_vars_boolParamVars )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("names += "));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 10, 0, Tpl.ST_STRING_LIST({
                                                                                                 ";\n",
                                                                                                 " names += "
                                                                                             }, false), 0, Tpl.ST_NEW_LINE()));
        txt = lm_119(txt, a_vars_boolParamVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_120;

protected function lm_121
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      String i_comment;
      String ret_0;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(isProtected = false, comment = i_comment) :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        ret_0 = Util.escapeModelicaStringToCString(i_comment);
        txt = Tpl.writeStr(txt, ret_0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        txt = Tpl.nextIter(txt);
        txt = lm_121(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_121(txt, rest);
      then txt;
  end match;
end lm_121;

protected function fun_122
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_mArg;
  input list<SimCodeVar.SimVar> in_a_vars_paramVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_vars_paramVars)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> a_vars_paramVars;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           _,
           a_vars_paramVars )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("names += "));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 10, 0, Tpl.ST_STRING_LIST({
                                                                                                 ";\n",
                                                                                                 " names += "
                                                                                             }, false), 0, Tpl.ST_NEW_LINE()));
        txt = lm_121(txt, a_vars_paramVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_122;

protected function lm_123
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      String i_comment;
      String ret_0;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(isProtected = false, comment = i_comment) :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        ret_0 = Util.escapeModelicaStringToCString(i_comment);
        txt = Tpl.writeStr(txt, ret_0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        txt = Tpl.nextIter(txt);
        txt = lm_123(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_123(txt, rest);
      then txt;
  end match;
end lm_123;

protected function fun_124
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_mArg;
  input list<SimCodeVar.SimVar> in_a_vars_intParamVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_vars_intParamVars)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> a_vars_intParamVars;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           _,
           a_vars_intParamVars )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("names += "));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 10, 0, Tpl.ST_STRING_LIST({
                                                                                                 ";\n",
                                                                                                 " names += "
                                                                                             }, false), 0, Tpl.ST_NEW_LINE()));
        txt = lm_123(txt, a_vars_intParamVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_124;

protected function lm_125
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      String i_comment;
      String ret_0;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(isProtected = false, comment = i_comment) :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        ret_0 = Util.escapeModelicaStringToCString(i_comment);
        txt = Tpl.writeStr(txt, ret_0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        txt = Tpl.nextIter(txt);
        txt = lm_125(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_125(txt, rest);
      then txt;
  end match;
end lm_125;

protected function fun_126
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_mArg;
  input list<SimCodeVar.SimVar> in_a_vars_boolParamVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_vars_boolParamVars)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> a_vars_boolParamVars;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           _,
           a_vars_boolParamVars )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("names += "));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 10, 0, Tpl.ST_STRING_LIST({
                                                                                                 ";\n",
                                                                                                 " names += "
                                                                                             }, false), 0, Tpl.ST_NEW_LINE()));
        txt = lm_125(txt, a_vars_boolParamVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_126;

protected function fun_127
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_a_modelInfo, in_a_useFlatArrayNotation, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      SimCode.ModelInfo i_modelInfo;
      list<SimCodeVar.SimVar> i_vars_boolParamVars;
      list<SimCodeVar.SimVar> i_vars_intParamVars;
      list<SimCodeVar.SimVar> i_vars_paramVars;
      Absyn.Path i_modelInfo_name;
      list<SimCodeVar.SimVar> ret_5;
      list<SimCodeVar.SimVar> ret_4;
      list<SimCodeVar.SimVar> ret_3;
      list<SimCodeVar.SimVar> ret_2;
      list<SimCodeVar.SimVar> ret_1;
      list<SimCodeVar.SimVar> ret_0;

    case ( txt,
           (i_modelInfo as SimCode.MODELINFO(vars = SimCodeVar.SIMVARS(paramVars = i_vars_paramVars, intParamVars = i_vars_intParamVars, boolParamVars = i_vars_boolParamVars), name = i_modelInfo_name)),
           a_useFlatArrayNotation,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(5));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void   "));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "WriteOutput::writeParametertNames(vector<string>& names)\n",
                                    "{\n",
                                    " /*workarround ced*/\n",
                                    "\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        ret_0 = SimCodeFunctionUtil.protectedVars(i_vars_paramVars);
        txt = fun_116(txt, ret_0, i_vars_paramVars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void   "));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("WriteOutput::writeIntParameterNames(vector<string>& names)\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("{\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        ret_1 = SimCodeFunctionUtil.protectedVars(i_vars_intParamVars);
        txt = fun_118(txt, ret_1, i_vars_intParamVars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("}\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void   "));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("WriteOutput::writeBoolParameterNames(vector<string>& names)\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("{\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        ret_2 = SimCodeFunctionUtil.protectedVars(i_vars_boolParamVars);
        txt = fun_120(txt, ret_2, i_vars_boolParamVars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "void   "
                                }, false));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "WriteOutput::writeParameterDescription(vector<string>& names)\n",
                                    "{\n",
                                    " /*workarround ced*/\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        ret_3 = SimCodeFunctionUtil.protectedVars(i_vars_paramVars);
        txt = fun_122(txt, ret_3, i_vars_paramVars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void   "));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("WriteOutput::writeIntParameterDescription(vector<string>& names)\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("{\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        ret_4 = SimCodeFunctionUtil.protectedVars(i_vars_intParamVars);
        txt = fun_124(txt, ret_4, i_vars_intParamVars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void   "));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("WriteOutput::writeBoolParameterDescription(vector<string>& names)\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("{\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        ret_5 = SimCodeFunctionUtil.protectedVars(i_vars_boolParamVars);
        txt = fun_126(txt, ret_5, i_vars_boolParamVars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("}\n"));
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = writeoutputparams(txt, i_modelInfo, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, SimCodeFunction.contextOther, a_useFlatArrayNotation);
        txt = Tpl.popBlock(txt);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           _,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_127;

public function simulationWriteOutputParameterCppFile
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace) :=
  match(in_txt, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Boolean a_useFlatArrayNotation;
      SimCode.SimCode i_simCode;
      SimCode.ModelInfo i_modelInfo;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = i_modelInfo)),
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_useFlatArrayNotation )
      equation
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_127(txt, i_modelInfo, a_useFlatArrayNotation, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, i_simCode);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);

    case ( txt,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           _ )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
  end match;
end simulationWriteOutputParameterCppFile;

protected function lm_129
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      DAE.ComponentRef i_name;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(isProtected = false, name = i_name) :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        txt = CodegenCppCommonOld.crefStrForWriteOutput(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        txt = Tpl.nextIter(txt);
        txt = lm_129(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_129(txt, rest);
      then txt;
  end match;
end lm_129;

protected function fun_130
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_mArg;
  input list<SimCodeVar.SimVar> in_a_vars_boolAliasVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_vars_boolAliasVars)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> a_vars_boolAliasVars;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           _,
           a_vars_boolAliasVars )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("names += "));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 10, 0, Tpl.ST_STRING_LIST({
                                                                                                 ";\n",
                                                                                                 " names += "
                                                                                             }, false), 0, Tpl.ST_NEW_LINE()));
        txt = lm_129(txt, a_vars_boolAliasVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_130;

protected function lm_131
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      DAE.ComponentRef i_name;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(isProtected = false, name = i_name) :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        txt = CodegenCppCommonOld.crefStrForWriteOutput(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        txt = Tpl.nextIter(txt);
        txt = lm_131(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_131(txt, rest);
      then txt;
  end match;
end lm_131;

protected function fun_132
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_mArg;
  input list<SimCodeVar.SimVar> in_a_vars_aliasVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_vars_aliasVars)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> a_vars_aliasVars;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           _,
           a_vars_aliasVars )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("names +="));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 10, 0, Tpl.ST_STRING_LIST({
                                                                                                 ";\n",
                                                                                                 " names += "
                                                                                             }, false), 0, Tpl.ST_NEW_LINE()));
        txt = lm_131(txt, a_vars_aliasVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_132;

protected function lm_133
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      DAE.ComponentRef i_name;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(isProtected = false, name = i_name) :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        txt = CodegenCppCommonOld.crefStrForWriteOutput(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        txt = Tpl.nextIter(txt);
        txt = lm_133(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_133(txt, rest);
      then txt;
  end match;
end lm_133;

protected function fun_134
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_mArg;
  input list<SimCodeVar.SimVar> in_a_vars_intAliasVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_vars_intAliasVars)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> a_vars_intAliasVars;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           _,
           a_vars_intAliasVars )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("names += "));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 10, 0, Tpl.ST_STRING_LIST({
                                                                                                 ";\n",
                                                                                                 " names += "
                                                                                             }, false), 0, Tpl.ST_NEW_LINE()));
        txt = lm_133(txt, a_vars_intAliasVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_134;

protected function lm_135
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      String i_comment;
      String ret_0;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(isProtected = false, comment = i_comment) :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        ret_0 = Util.escapeModelicaStringToCString(i_comment);
        txt = Tpl.writeStr(txt, ret_0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        txt = Tpl.nextIter(txt);
        txt = lm_135(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_135(txt, rest);
      then txt;
  end match;
end lm_135;

protected function fun_136
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_mArg;
  input list<SimCodeVar.SimVar> in_a_vars_aliasVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_vars_aliasVars)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> a_vars_aliasVars;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           _,
           a_vars_aliasVars )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("description +="));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 10, 0, Tpl.ST_STRING_LIST({
                                                                                                 ";\n",
                                                                                                 " description += "
                                                                                             }, false), 0, Tpl.ST_NEW_LINE()));
        txt = lm_135(txt, a_vars_aliasVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_136;

protected function lm_137
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      String i_comment;
      String ret_0;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(isProtected = false, comment = i_comment) :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        ret_0 = Util.escapeModelicaStringToCString(i_comment);
        txt = Tpl.writeStr(txt, ret_0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        txt = Tpl.nextIter(txt);
        txt = lm_137(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_137(txt, rest);
      then txt;
  end match;
end lm_137;

protected function fun_138
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_mArg;
  input list<SimCodeVar.SimVar> in_a_vars_intAliasVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_vars_intAliasVars)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> a_vars_intAliasVars;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           _,
           a_vars_intAliasVars )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("description += "));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 10, 0, Tpl.ST_STRING_LIST({
                                                                                                 ";\n",
                                                                                                 " description += "
                                                                                             }, false), 0, Tpl.ST_NEW_LINE()));
        txt = lm_137(txt, a_vars_intAliasVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_138;

protected function lm_139
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      String i_comment;
      String ret_0;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(isProtected = false, comment = i_comment) :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        ret_0 = Util.escapeModelicaStringToCString(i_comment);
        txt = Tpl.writeStr(txt, ret_0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        txt = Tpl.nextIter(txt);
        txt = lm_139(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_139(txt, rest);
      then txt;
  end match;
end lm_139;

protected function fun_140
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_mArg;
  input list<SimCodeVar.SimVar> in_a_vars_boolAliasVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_vars_boolAliasVars)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> a_vars_boolAliasVars;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           _,
           a_vars_boolAliasVars )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("description += "));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 10, 0, Tpl.ST_STRING_LIST({
                                                                                                 ";\n",
                                                                                                 " description += "
                                                                                             }, false), 0, Tpl.ST_NEW_LINE()));
        txt = lm_139(txt, a_vars_boolAliasVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_140;

protected function fun_141
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_a_modelInfo, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      list<SimCodeVar.SimVar> i_vars_intAliasVars;
      list<SimCodeVar.SimVar> i_vars_aliasVars;
      list<SimCodeVar.SimVar> i_vars_boolAliasVars;
      SimCode.ModelInfo i_modelInfo;
      Absyn.Path i_modelInfo_name;
      Tpl.Text txt_51;
      Integer ret_50;
      list<SimCodeVar.SimVar> ret_49;
      Tpl.Text txt_48;
      Integer ret_47;
      list<SimCodeVar.SimVar> ret_46;
      Tpl.Text txt_45;
      Integer ret_44;
      list<SimCodeVar.SimVar> ret_43;
      list<SimCodeVar.SimVar> ret_42;
      list<SimCodeVar.SimVar> ret_41;
      list<SimCodeVar.SimVar> ret_40;
      list<SimCodeVar.SimVar> ret_39;
      list<SimCodeVar.SimVar> ret_38;
      list<SimCodeVar.SimVar> ret_37;
      Integer ret_36;
      Integer ret_35;
      Tpl.Text txt_34;
      Integer ret_33;
      Tpl.Text l_stateVarsStart;
      Integer ret_31;
      Integer ret_30;
      Tpl.Text txt_29;
      Integer ret_28;
      Tpl.Text l_boolAliasVarsStart;
      Integer ret_26;
      Integer ret_25;
      Tpl.Text txt_24;
      Integer ret_23;
      Tpl.Text l_intAliasVarsStart;
      Integer ret_21;
      Integer ret_20;
      Tpl.Text txt_19;
      Integer ret_18;
      Tpl.Text l_aliasVarsStart;
      Integer ret_16;
      Integer ret_15;
      Tpl.Text txt_14;
      Integer ret_13;
      Tpl.Text l_boolAlgVarsStart;
      Integer ret_11;
      Integer ret_10;
      Tpl.Text txt_9;
      Integer ret_8;
      Tpl.Text l_intAlgVarsStart;
      Integer ret_6;
      Integer ret_5;
      Tpl.Text txt_4;
      Integer ret_3;
      Tpl.Text l_discrAlgVarsStart;
      Tpl.Text l_algVarsStart;
      Tpl.Text l_className;

    case ( txt,
           (i_modelInfo as SimCode.MODELINFO(vars = SimCodeVar.SIMVARS(boolAliasVars = i_vars_boolAliasVars, aliasVars = i_vars_aliasVars, intAliasVars = i_vars_intAliasVars), name = i_modelInfo_name)),
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        l_className = lastIdentOfPath(Tpl.emptyTxt, i_modelInfo_name);
        l_algVarsStart = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("1"));
        ret_3 = stringInt(Tpl.textString(l_algVarsStart));
        txt_4 = numProtectedRealAlgvars(Tpl.emptyTxt, i_modelInfo);
        ret_5 = stringInt(Tpl.textString(txt_4));
        ret_6 = intAdd(ret_3, ret_5);
        l_discrAlgVarsStart = Tpl.writeStr(Tpl.emptyTxt, intString(ret_6));
        ret_8 = stringInt(Tpl.textString(l_discrAlgVarsStart));
        txt_9 = numProtectedDiscreteAlgVars(Tpl.emptyTxt, i_modelInfo);
        ret_10 = stringInt(Tpl.textString(txt_9));
        ret_11 = intAdd(ret_8, ret_10);
        l_intAlgVarsStart = Tpl.writeStr(Tpl.emptyTxt, intString(ret_11));
        ret_13 = stringInt(Tpl.textString(l_intAlgVarsStart));
        txt_14 = numProtectedIntAlgvars(Tpl.emptyTxt, i_modelInfo);
        ret_15 = stringInt(Tpl.textString(txt_14));
        ret_16 = intAdd(ret_13, ret_15);
        l_boolAlgVarsStart = Tpl.writeStr(Tpl.emptyTxt, intString(ret_16));
        ret_18 = stringInt(Tpl.textString(l_boolAlgVarsStart));
        txt_19 = numProtectedBoolAlgvars(Tpl.emptyTxt, i_modelInfo);
        ret_20 = stringInt(Tpl.textString(txt_19));
        ret_21 = intAdd(ret_18, ret_20);
        l_aliasVarsStart = Tpl.writeStr(Tpl.emptyTxt, intString(ret_21));
        ret_23 = stringInt(Tpl.textString(l_aliasVarsStart));
        txt_24 = numProtectedRealAliasvars(Tpl.emptyTxt, i_modelInfo);
        ret_25 = stringInt(Tpl.textString(txt_24));
        ret_26 = intAdd(ret_23, ret_25);
        l_intAliasVarsStart = Tpl.writeStr(Tpl.emptyTxt, intString(ret_26));
        ret_28 = stringInt(Tpl.textString(l_intAliasVarsStart));
        txt_29 = numProtectedIntAliasvars(Tpl.emptyTxt, i_modelInfo);
        ret_30 = stringInt(Tpl.textString(txt_29));
        ret_31 = intAdd(ret_28, ret_30);
        l_boolAliasVarsStart = Tpl.writeStr(Tpl.emptyTxt, intString(ret_31));
        ret_33 = stringInt(Tpl.textString(l_boolAliasVarsStart));
        txt_34 = numProtectedBoolAliasvars(Tpl.emptyTxt, i_modelInfo);
        ret_35 = stringInt(Tpl.textString(txt_34));
        ret_36 = intAdd(ret_33, ret_35);
        l_stateVarsStart = Tpl.writeStr(Tpl.emptyTxt, intString(ret_36));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(5));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = Tpl.writeText(txt, l_className);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "WriteOutput::writeBoolAliasVarsResultNames(vector<string>& names)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        ret_37 = SimCodeFunctionUtil.protectedVars(i_vars_boolAliasVars);
        txt = fun_130(txt, ret_37, i_vars_boolAliasVars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "void  "
                                }, false));
        txt = Tpl.writeText(txt, l_className);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "WriteOutput::writeAliasVarsResultNames(vector<string>& names)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        ret_38 = SimCodeFunctionUtil.protectedVars(i_vars_aliasVars);
        txt = fun_132(txt, ret_38, i_vars_aliasVars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n",
                                    "void   "
                                }, false));
        txt = Tpl.writeText(txt, l_className);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "WriteOutput::writeIntAliasVarsResultNames(vector<string>& names)\n",
                                    "{\n"
                                }, true));
        ret_39 = SimCodeFunctionUtil.protectedVars(i_vars_intAliasVars);
        txt = fun_134(txt, ret_39, i_vars_intAliasVars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n",
                                    "\n",
                                    "\n",
                                    "\n",
                                    "\n",
                                    "void  "
                                }, false));
        txt = Tpl.writeText(txt, l_className);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "WriteOutput::writeAliasVarsResultDescription(vector<string>& description)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        ret_40 = SimCodeFunctionUtil.protectedVars(i_vars_aliasVars);
        txt = fun_136(txt, ret_40, i_vars_aliasVars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void   "));
        txt = Tpl.writeText(txt, l_className);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "WriteOutput::writeIntAliasVarsResultDescription(vector<string>& description)\n",
                                    " {\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        ret_41 = SimCodeFunctionUtil.protectedVars(i_vars_intAliasVars);
        txt = fun_138(txt, ret_41, i_vars_intAliasVars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n",
                                    "void "
                                }, false));
        txt = Tpl.writeText(txt, l_className);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "WriteOutput::writeBoolAliasVarsResultDescription(vector<string>& description)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        ret_42 = SimCodeFunctionUtil.protectedVars(i_vars_boolAliasVars);
        txt = fun_140(txt, ret_42, i_vars_boolAliasVars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("}\n"));
        ret_43 = SimCodeFunctionUtil.protectedVars(i_vars_aliasVars);
        ret_44 = stringInt(Tpl.textString(l_aliasVarsStart));
        txt_45 = Tpl.writeText(Tpl.emptyTxt, l_className);
        txt_45 = Tpl.writeTok(txt_45, Tpl.ST_STRING("WriteOutput"));
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = writeOutputVarsWithSplit(txt, "writeAliasVarsValues", ret_43, ret_44, Tpl.textString(txt_45), true, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.softNewLine(txt);
        ret_46 = SimCodeFunctionUtil.protectedVars(i_vars_intAliasVars);
        ret_47 = stringInt(Tpl.textString(l_intAliasVarsStart));
        txt_48 = Tpl.writeText(Tpl.emptyTxt, l_className);
        txt_48 = Tpl.writeTok(txt_48, Tpl.ST_STRING("WriteOutput"));
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = writeOutputVarsWithSplit(txt, "writeIntAliasVarsValues", ret_46, ret_47, Tpl.textString(txt_48), true, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.softNewLine(txt);
        ret_49 = SimCodeFunctionUtil.protectedVars(i_vars_boolAliasVars);
        ret_50 = stringInt(Tpl.textString(l_boolAliasVarsStart));
        txt_51 = Tpl.writeText(Tpl.emptyTxt, l_className);
        txt_51 = Tpl.writeTok(txt_51, Tpl.ST_STRING("WriteOutput"));
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = writeOutputVarsWithSplit(txt, "writeBoolAliasVarsValues", ret_49, ret_50, Tpl.textString(txt_51), true, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.popBlock(txt);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_141;

public function simulationWriteOutputAliasVarsCppFile
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      SimCode.SimCode i_simCode;
      SimCode.ModelInfo i_modelInfo;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = i_modelInfo)),
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_141(txt, i_modelInfo, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, i_simCode);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end simulationWriteOutputAliasVarsCppFile;

protected function lm_143
  input Tpl.Text in_txt;
  input list<SimCode.JacobianMatrix> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCode.JacobianMatrix> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      String i_name;
      Integer i_jacIndex;
      list<list<Integer>> i_colorList;
      list<SimCode.JacobianColumn> i_mat;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           SimCode.JAC_MATRIX(columns = i_mat, matrixName = i_name, coloredCols = i_colorList, jacobianIndex = i_jacIndex) :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = generateJacobianForIndex(txt, a_simCode, i_mat, i_colorList, i_jacIndex, i_name, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_143(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _ :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_143(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_143;

protected function fun_144
  input Tpl.Text in_txt;
  input String in_mArg;
  input Tpl.Text in_a_getJacobianForIndexMethods;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_getJacobianForIndexMethods)
    local
      Tpl.Text txt;
      Tpl.Text a_getJacobianForIndexMethods;

    case ( txt,
           "dense",
           a_getJacobianForIndexMethods )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "switch (index)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.writeText(txt, a_getJacobianForIndexMethods);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "default:\n",
                                    "throw ModelicaSimulationError(MATH_FUNCTION,\"Not supported jacobian matrix index\");\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;

    case ( txt,
           "sparse",
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("throw ModelicaSimulationError(MATH_FUNCTION,\"Dense matrix is not activated\");"));
      then txt;

    case ( txt,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("A matrix type is not supported"));
      then txt;
  end match;
end fun_144;

protected function fun_145
  input Tpl.Text in_txt;
  input String in_mArg;
  input Tpl.Text in_a_getJacobianForIndexMethods;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_getJacobianForIndexMethods)
    local
      Tpl.Text txt;
      Tpl.Text a_getJacobianForIndexMethods;

    case ( txt,
           "dense",
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("throw ModelicaSimulationError(MATH_FUNCTION,\"Sparse matrix is not activated\");"));
      then txt;

    case ( txt,
           "sparse",
           a_getJacobianForIndexMethods )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "switch (index)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.writeText(txt, a_getJacobianForIndexMethods);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "default:\n",
                                    "throw ModelicaSimulationError(MATH_FUNCTION,\"Not supported jacobian matrix index\");\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;

    case ( txt,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("A matrix type is not supported"));
      then txt;
  end match;
end fun_145;

protected function fun_146
  input Tpl.Text in_txt;
  input String in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           "dense" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("    return getAJacobian();"));
      then txt;

    case ( txt,
           "sparse" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("throw ModelicaSimulationError(MATH_FUNCTION,\"Dense matrix is not activated\");"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("A matrix type is not supported"));
      then txt;
  end match;
end fun_146;

protected function fun_147
  input Tpl.Text in_txt;
  input String in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           "dense" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("throw ModelicaSimulationError(MATH_FUNCTION,\"Sparse matrix is not activated\");"));
      then txt;

    case ( txt,
           "sparse" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("    return getAJacobian();"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("A matrix type is not supported"));
      then txt;
  end match;
end fun_147;

protected function fun_148
  input Tpl.Text in_txt;
  input String in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           "dense" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("return false;"));
      then txt;

    case ( txt,
           "sparse" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("return true;"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("A matrix type is not supported"));
      then txt;
  end match;
end fun_148;

protected function fun_149
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("return false;"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("return true;"));
      then txt;
  end match;
end fun_149;

protected function fun_150
  input Tpl.Text in_txt;
  input String in_mArg;
  input String in_a_name;
  input Integer in_a_i1;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_name, in_a_i1)
    local
      Tpl.Text txt;
      String a_name;
      Integer a_i1;

    case ( txt,
           "dense",
           a_name,
           a_i1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("case "));
        txt = Tpl.writeStr(txt, intString(a_i1));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(":\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("return get"));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Jacobian();\n",
                                    "break;"
                                }, false));
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           "sparse",
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("throw ModelicaSimulationError(MATH_FUNCTION,\"Dense matrix is not activated\");"));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("A matrix type is not supported"));
      then txt;
  end match;
end fun_150;

protected function fun_151
  input Tpl.Text in_txt;
  input SimCode.JacobianMatrix in_a_jacobianMatrix;
  input Integer in_a_i1;
  input Tpl.Text in_a_type;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_jacobianMatrix, in_a_i1, in_a_type)
    local
      Tpl.Text txt;
      Integer a_i1;
      Tpl.Text a_type;
      String i_name;
      String str_0;

    case ( txt,
           SimCode.JAC_MATRIX(matrixName = i_name),
           a_i1,
           a_type )
      equation
        str_0 = Tpl.textString(a_type);
        txt = fun_150(txt, str_0, i_name, a_i1);
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_151;

protected function fun_152
  input Tpl.Text in_txt;
  input SimCode.StateSet in_a_set;
  input Integer in_a_i1;
  input Tpl.Text in_a_type;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_set, in_a_i1, in_a_type)
    local
      Tpl.Text txt;
      Integer a_i1;
      Tpl.Text a_type;
      SimCode.JacobianMatrix i_jacobianMatrix;

    case ( txt,
           SimCode.SES_STATESET(jacobianMatrix = i_jacobianMatrix),
           a_i1,
           a_type )
      equation
        txt = fun_151(txt, i_jacobianMatrix, a_i1, a_type);
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_152;

protected function lm_153
  input Tpl.Text in_txt;
  input list<SimCode.StateSet> in_items;
  input Tpl.Text in_a_type;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_type)
    local
      Tpl.Text txt;
      list<SimCode.StateSet> rest;
      Tpl.Text a_type;
      Integer x_i1;
      SimCode.StateSet i_set;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_set :: rest,
           a_type )
      equation
        x_i1 = Tpl.getIteri_i0(txt);
        txt = fun_152(txt, i_set, x_i1, a_type);
        txt = Tpl.nextIter(txt);
        txt = lm_153(txt, rest, a_type);
      then txt;
  end match;
end lm_153;

protected function fun_154
  input Tpl.Text in_txt;
  input String in_mArg;
  input String in_a_name;
  input Integer in_a_i1;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_name, in_a_i1)
    local
      Tpl.Text txt;
      String a_name;
      Integer a_i1;

    case ( txt,
           "dense",
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("throw ModelicaSimulationError(MATH_FUNCTION,\"Sparse matrix is not activated\");"));
      then txt;

    case ( txt,
           "sparse",
           a_name,
           a_i1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("case "));
        txt = Tpl.writeStr(txt, intString(a_i1));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(":\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("return get"));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Jacobian();\n",
                                    "break;"
                                }, false));
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           _,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("A matrix type is not supported"));
      then txt;
  end match;
end fun_154;

protected function fun_155
  input Tpl.Text in_txt;
  input SimCode.JacobianMatrix in_a_jacobianMatrix;
  input Integer in_a_i1;
  input Tpl.Text in_a_type;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_jacobianMatrix, in_a_i1, in_a_type)
    local
      Tpl.Text txt;
      Integer a_i1;
      Tpl.Text a_type;
      String i_name;
      String str_0;

    case ( txt,
           SimCode.JAC_MATRIX(matrixName = i_name),
           a_i1,
           a_type )
      equation
        str_0 = Tpl.textString(a_type);
        txt = fun_154(txt, str_0, i_name, a_i1);
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_155;

protected function fun_156
  input Tpl.Text in_txt;
  input SimCode.StateSet in_a_set;
  input Integer in_a_i1;
  input Tpl.Text in_a_type;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_set, in_a_i1, in_a_type)
    local
      Tpl.Text txt;
      Integer a_i1;
      Tpl.Text a_type;
      SimCode.JacobianMatrix i_jacobianMatrix;

    case ( txt,
           SimCode.SES_STATESET(jacobianMatrix = i_jacobianMatrix),
           a_i1,
           a_type )
      equation
        txt = fun_155(txt, i_jacobianMatrix, a_i1, a_type);
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_156;

protected function lm_157
  input Tpl.Text in_txt;
  input list<SimCode.StateSet> in_items;
  input Tpl.Text in_a_type;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_type)
    local
      Tpl.Text txt;
      list<SimCode.StateSet> rest;
      Tpl.Text a_type;
      Integer x_i1;
      SimCode.StateSet i_set;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_set :: rest,
           a_type )
      equation
        x_i1 = Tpl.getIteri_i0(txt);
        txt = fun_156(txt, i_set, x_i1, a_type);
        txt = Tpl.nextIter(txt);
        txt = lm_157(txt, rest, a_type);
      then txt;
  end match;
end lm_157;

protected function fun_158
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_updateResidualFunctionsCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_simCode, in_a_updateResidualFunctionsCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      Tpl.Text a_updateResidualFunctionsCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      String i_fileNamePrefix;
      list<BackendDAE.ZeroCrossing> i_zeroCrossings;
      list<SimCode.StateSet> i_stateSets;
      Absyn.Path i_modelInfo_name;
      SimCode.SimCode i_simCode;
      list<SimCode.JacobianMatrix> i_jacobianMatrixes;
      Tpl.Text l_statesetsparsejacobian;
      Tpl.Text l_statesetjacobian;
      Boolean ret_15;
      Tpl.Text l_isAnalyticJacobianGenerated;
      String str_13;
      Tpl.Text l_isJacobianSparse;
      String str_11;
      Tpl.Text l_getSparseAMatrix;
      String str_9;
      Tpl.Text l_getDenseAMatrix;
      String str_7;
      Tpl.Text l_getSparseMatrix;
      String str_5;
      Tpl.Text l_getDenseMatrix;
      String ret_3;
      Tpl.Text l_type;
      Tpl.Text l_classname;
      Tpl.Text l_getJacobianForIndexMethods;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = i_modelInfo_name), jacobianMatrixes = i_jacobianMatrixes, stateSets = i_stateSets, zeroCrossings = i_zeroCrossings, fileNamePrefix = i_fileNamePrefix)),
           a_updateResidualFunctionsCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_getJacobianForIndexMethods = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_STRING_LIST({
                                                                                                                        "\n",
                                                                                                                        "\n"
                                                                                                                    }, true)), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_getJacobianForIndexMethods, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_143(l_getJacobianForIndexMethods, i_jacobianMatrixes, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, i_simCode);
        l_getJacobianForIndexMethods = Tpl.popIter(l_getJacobianForIndexMethods);
        l_classname = lastIdentOfPath(Tpl.emptyTxt, i_modelInfo_name);
        ret_3 = Flags.getConfigString(Flags.MATRIX_FORMAT);
        l_type = Tpl.writeStr(Tpl.emptyTxt, ret_3);
        str_5 = Tpl.textString(l_type);
        l_getDenseMatrix = fun_144(Tpl.emptyTxt, str_5, l_getJacobianForIndexMethods);
        str_7 = Tpl.textString(l_type);
        l_getSparseMatrix = fun_145(Tpl.emptyTxt, str_7, l_getJacobianForIndexMethods);
        str_9 = Tpl.textString(l_type);
        l_getDenseAMatrix = fun_146(Tpl.emptyTxt, str_9);
        str_11 = Tpl.textString(l_type);
        l_getSparseAMatrix = fun_147(Tpl.emptyTxt, str_11);
        str_13 = Tpl.textString(l_type);
        l_isJacobianSparse = fun_148(Tpl.emptyTxt, str_13);
        ret_15 = Flags.getConfigBool(Flags.GENERATE_SYMBOLIC_JACOBIAN);
        l_isAnalyticJacobianGenerated = fun_149(Tpl.emptyTxt, ret_15);
        l_statesetjacobian = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_statesetjacobian = lm_153(l_statesetjacobian, i_stateSets, l_type);
        l_statesetjacobian = Tpl.popIter(l_statesetjacobian);
        l_statesetsparsejacobian = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_statesetsparsejacobian = lm_157(l_statesetsparsejacobian, i_stateSets, l_type);
        l_statesetsparsejacobian = Tpl.popIter(l_statesetsparsejacobian);
        txt = Tpl.writeText(txt, l_classname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Mixed::"));
        txt = Tpl.writeText(txt, l_classname);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("Mixed(IGlobalSettings* globalSettings, shared_ptr<ISimObjects> simObjects)\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(": "));
        txt = Tpl.writeText(txt, l_classname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Jacobian(globalSettings, simObjects)\n",
                                    "\n",
                                    "\n",
                                    "\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "{\n",
                                    "}\n",
                                    "\n"
                                }, true));
        txt = Tpl.writeText(txt, l_classname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Mixed::"));
        txt = Tpl.writeText(txt, l_classname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Mixed("));
        txt = Tpl.writeText(txt, l_classname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Mixed& instance)\n",
                                    ": "
                                }, false));
        txt = Tpl.writeText(txt, l_classname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Jacobian(instance)\n",
                                    "{\n",
                                    "}\n",
                                    "\n"
                                }, true));
        txt = Tpl.writeText(txt, l_classname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Mixed::~"));
        txt = Tpl.writeText(txt, l_classname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Mixed()\n",
                                    "{\n",
                                    "}\n",
                                    "\n",
                                    "\n",
                                    "\n",
                                    "bool "
                                }, false));
        txt = Tpl.writeText(txt, l_classname);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("Mixed::isJacobianSparse(){\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeText(txt, l_isJacobianSparse);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n",
                                    "\n",
                                    "bool "
                                }, false));
        txt = Tpl.writeText(txt, l_classname);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("Mixed::isAnalyticJacobianGenerated(){\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeText(txt, l_isAnalyticJacobianGenerated);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n",
                                    "const matrix_t& "
                                }, false));
        txt = Tpl.writeText(txt, l_classname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Mixed::getJacobian( )\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(5));
        txt = Tpl.writeText(txt, l_getDenseAMatrix);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n",
                                    "const matrix_t& "
                                }, false));
        txt = Tpl.writeText(txt, l_classname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Mixed::getJacobian(unsigned int index)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(3));
        txt = Tpl.writeText(txt, l_getDenseMatrix);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "sparsematrix_t& "
                                }, false));
        txt = Tpl.writeText(txt, l_classname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Mixed::getSparseJacobian( )\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(3));
        txt = Tpl.writeText(txt, l_getSparseAMatrix);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n",
                                    "sparsematrix_t& "
                                }, false));
        txt = Tpl.writeText(txt, l_classname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Mixed::getSparseJacobian(unsigned int index)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_getSparseMatrix);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n",
                                    "const matrix_t& "
                                }, false));
        txt = Tpl.writeText(txt, l_classname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Mixed::getStateSetJacobian(unsigned int index)\n",
                                    "{\n",
                                    "  switch (index)\n",
                                    "  {\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.writeText(txt, l_statesetjacobian);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "default:\n",
                                    "   throw ModelicaSimulationError(MATH_FUNCTION,\"Not supported statset index\");\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "   }\n",
                                    "}\n",
                                    "sparsematrix_t& "
                                }, false));
        txt = Tpl.writeText(txt, l_classname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Mixed::getStateSetSparseJacobian(unsigned int index)\n",
                                    "{\n",
                                    "  switch (index)\n",
                                    "  {\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.writeText(txt, l_statesetsparsejacobian);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "default:\n",
                                    "   throw ModelicaSimulationError(MATH_FUNCTION,\"Not supported statset index\");\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "   }\n",
                                    "}\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = handleSystemEvents(txt, i_zeroCrossings, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = Tpl.writeText(txt, l_classname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Mixed::saveAll()\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("return "));
        txt = Tpl.writeText(txt, l_classname);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("::saveAll();\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n",
                                    "\n",
                                    "/*needed for colored jacobians*/\n",
                                    "\n",
                                    "void "
                                }, false));
        txt = Tpl.writeText(txt, l_classname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Mixed::getAColorOfColumn(int* aSparsePatternColorCols, int size)\n",
                                    "{\n",
                                    " memcpy(aSparsePatternColorCols, _AColorOfColumn, size * sizeof(int));\n",
                                    "}\n",
                                    "\n",
                                    "int "
                                }, false));
        txt = Tpl.writeText(txt, l_classname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Mixed::getAMaxColors()\n",
                                    "{\n",
                                    " return _AMaxColors;\n",
                                    "}\n",
                                    "\n",
                                    "string "
                                }, false));
        txt = Tpl.writeText(txt, l_classname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Mixed::getModelName()\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("return \""));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("\";\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("}\n"));
        txt = Tpl.writeText(txt, a_updateResidualFunctionsCode);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "\n",
                                    "\n",
                                    "\n",
                                    "\n"
                                }, true));
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end fun_158;

public function simulationMixedSystemCppFile
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_updateResidualFunctionsCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_updateResidualFunctionsCode;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) := fun_158(txt, a_simCode, a_updateResidualFunctionsCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
  out_a_updateResidualFunctionsCode := a_updateResidualFunctionsCode;
end simulationMixedSystemCppFile;

protected function fun_160
  input Tpl.Text in_txt;
  input list<list<Integer>> in_a_colorList;
  input String in_a_matrixName;
  input Integer in_a_indexJacobian;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_colorList, in_a_matrixName, in_a_indexJacobian)
    local
      Tpl.Text txt;
      String a_matrixName;
      Integer a_indexJacobian;

    case ( txt,
           {},
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_matrixName,
           a_indexJacobian )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("case "));
        txt = Tpl.writeStr(txt, intString(a_indexJacobian));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ":\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("return get"));
        txt = Tpl.writeStr(txt, a_matrixName);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("Jacobian();\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
        txt = Tpl.popBlock(txt);
      then txt;
  end match;
end fun_160;

protected function fun_161
  input Tpl.Text in_txt;
  input list<SimCode.JacobianColumn> in_a_jacobianColumn;
  input String in_a_matrixName;
  input Integer in_a_indexJacobian;
  input list<list<Integer>> in_a_colorList;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_jacobianColumn, in_a_matrixName, in_a_indexJacobian, in_a_colorList)
    local
      Tpl.Text txt;
      String a_matrixName;
      Integer a_indexJacobian;
      list<list<Integer>> a_colorList;

    case ( txt,
           {},
           _,
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_matrixName,
           a_indexJacobian,
           a_colorList )
      equation
        txt = fun_160(txt, a_colorList, a_matrixName, a_indexJacobian);
      then txt;
  end match;
end fun_161;

protected function fun_162
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input list<SimCode.JacobianColumn> in_a_jacobianColumn;
  input list<list<Integer>> in_a_colorList;
  input Integer in_a_indexJacobian;
  input String in_a_matrixName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode, in_a_jacobianColumn, in_a_colorList, in_a_indexJacobian, in_a_matrixName)
    local
      Tpl.Text txt;
      list<SimCode.JacobianColumn> a_jacobianColumn;
      list<list<Integer>> a_colorList;
      Integer a_indexJacobian;
      String a_matrixName;
      Absyn.Path i_modelInfo_name;
      Tpl.Text l_classname;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = i_modelInfo_name)),
           a_jacobianColumn,
           a_colorList,
           a_indexJacobian,
           a_matrixName )
      equation
        l_classname = lastIdentOfPath(Tpl.emptyTxt, i_modelInfo_name);
        txt = fun_161(txt, a_jacobianColumn, a_matrixName, a_indexJacobian, a_colorList);
      then txt;

    case ( txt,
           _,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_162;

public function generateJacobianForIndex
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input list<SimCode.JacobianColumn> a_jacobianColumn;
  input list<list<Integer>> a_colorList;
  input Integer a_indexJacobian;
  input String a_matrixName;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  out_txt := fun_162(txt, a_simCode, a_jacobianColumn, a_colorList, a_indexJacobian, a_matrixName);
  out_a_extraFuncs := a_extraFuncs;
  out_a_extraFuncsDecl := a_extraFuncsDecl;
  out_a_extraFuncsNamespace := a_extraFuncsNamespace;
  out_a_stateDerVectorName := a_stateDerVectorName;
end generateJacobianForIndex;

protected function fun_164
  input Tpl.Text in_txt;
  input SimCode.StateSet in_a_set;
  input Integer in_a_i1;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_set, in_a_i1)
    local
      Tpl.Text txt;
      Integer a_i1;
      Integer i_nStates;

    case ( txt,
           SimCode.SES_STATESET(nStates = i_nStates),
           a_i1 )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("case "));
        txt = Tpl.writeStr(txt, intString(a_i1));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(":\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(3));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("return "));
        txt = Tpl.writeStr(txt, intString(i_nStates));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_164;

protected function lm_165
  input Tpl.Text in_txt;
  input list<SimCode.StateSet> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.StateSet> rest;
      Integer x_i1;
      SimCode.StateSet i_set;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_set :: rest )
      equation
        x_i1 = Tpl.getIteri_i0(txt);
        txt = fun_164(txt, i_set, x_i1);
        txt = Tpl.nextIter(txt);
        txt = lm_165(txt, rest);
      then txt;
  end match;
end lm_165;

protected function fun_166
  input Tpl.Text in_txt;
  input SimCode.StateSet in_a_set;
  input Integer in_a_i1;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_set, in_a_i1)
    local
      Tpl.Text txt;
      Integer a_i1;
      Integer i_nCandidates;

    case ( txt,
           SimCode.SES_STATESET(nCandidates = i_nCandidates),
           a_i1 )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("case "));
        txt = Tpl.writeStr(txt, intString(a_i1));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(":\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(3));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("return  "));
        txt = Tpl.writeStr(txt, intString(i_nCandidates));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_166;

protected function lm_167
  input Tpl.Text in_txt;
  input list<SimCode.StateSet> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.StateSet> rest;
      Integer x_i1;
      SimCode.StateSet i_set;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_set :: rest )
      equation
        x_i1 = Tpl.getIteri_i0(txt);
        txt = fun_166(txt, i_set, x_i1);
        txt = Tpl.nextIter(txt);
        txt = lm_167(txt, rest);
      then txt;
  end match;
end lm_167;

protected function fun_168
  input Tpl.Text in_txt;
  input SimCode.StateSet in_a_set;
  input Integer in_a_i1;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_set, in_a_i1)
    local
      Tpl.Text txt;
      Integer a_i1;
      Integer i_nStates;
      Integer i_nCandidates;

    case ( txt,
           SimCode.SES_STATESET(nCandidates = i_nCandidates, nStates = i_nStates),
           a_i1 )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("case "));
        txt = Tpl.writeStr(txt, intString(a_i1));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(":\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("return "));
        txt = Tpl.writeStr(txt, intString(i_nCandidates));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-"));
        txt = Tpl.writeStr(txt, intString(i_nStates));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_168;

protected function lm_169
  input Tpl.Text in_txt;
  input list<SimCode.StateSet> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.StateSet> rest;
      Integer x_i1;
      SimCode.StateSet i_set;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_set :: rest )
      equation
        x_i1 = Tpl.getIteri_i0(txt);
        txt = fun_168(txt, i_set, x_i1);
        txt = Tpl.nextIter(txt);
        txt = lm_169(txt, rest);
      then txt;
  end match;
end lm_169;

protected function fun_170
  input Tpl.Text in_txt;
  input list<SimCode.StateSet> in_a_stateSets;
  input Tpl.Text in_a_classname;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_stateSets, in_a_classname)
    local
      Tpl.Text txt;
      Tpl.Text a_classname;
      list<SimCode.StateSet> i_stateSets;
      Integer ret_0;

    case ( txt,
           {},
           a_classname )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("int "));
        txt = Tpl.writeText(txt, a_classname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "StateSelection::getDimStateSets() const\n",
                                    "{\n",
                                    "  return 0;\n",
                                    "}\n",
                                    "\n",
                                    "int "
                                }, false));
        txt = Tpl.writeText(txt, a_classname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "StateSelection::getDimStates(unsigned int index) const\n",
                                    "{\n",
                                    "  return 0;\n",
                                    "}\n",
                                    "\n",
                                    "int "
                                }, false));
        txt = Tpl.writeText(txt, a_classname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "StateSelection::getDimCanditates(unsigned int index) const\n",
                                    "{\n",
                                    "  return 0;\n",
                                    "}\n",
                                    "\n",
                                    "int "
                                }, false));
        txt = Tpl.writeText(txt, a_classname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "StateSelection::getDimDummyStates(unsigned int index) const\n",
                                    "{\n",
                                    "  return 0;\n",
                                    "}"
                                }, false));
      then txt;

    case ( txt,
           i_stateSets,
           a_classname )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("int "));
        txt = Tpl.writeText(txt, a_classname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "StateSelection::getDimStateSets() const\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("return "));
        ret_0 = listLength(i_stateSets);
        txt = Tpl.writeStr(txt, intString(ret_0));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n",
                                    "int "
                                }, false));
        txt = Tpl.writeText(txt, a_classname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "StateSelection::getDimStates(unsigned int index) const\n",
                                    "{\n",
                                    "   switch (index)\n",
                                    "   {\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(5));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_165(txt, i_stateSets);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "   default:\n",
                                    "   throw ModelicaSimulationError(MATH_FUNCTION,\"Not supported statset index\");\n",
                                    "  }\n",
                                    "\n",
                                    "}\n",
                                    "\n",
                                    "int "
                                }, false));
        txt = Tpl.writeText(txt, a_classname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "StateSelection::getDimCanditates(unsigned int index) const\n",
                                    "{\n",
                                    "   switch (index)\n",
                                    "   {\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(5));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_167(txt, i_stateSets);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "   default:\n",
                                    "  throw ModelicaSimulationError(MATH_FUNCTION,\"Not supported statset index\");\n",
                                    "  }\n",
                                    "\n",
                                    "}\n",
                                    "\n",
                                    "int "
                                }, false));
        txt = Tpl.writeText(txt, a_classname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "StateSelection::getDimDummyStates(unsigned int index) const\n",
                                    "{\n",
                                    "  switch (index)\n",
                                    "  {\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_169(txt, i_stateSets);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "  default:\n",
                                    "  throw ModelicaSimulationError(MATH_FUNCTION,\"Not supported statset index\");\n",
                                    "  }\n",
                                    "\n",
                                    "}"
                                }, false));
      then txt;
  end match;
end fun_170;

protected function fun_171
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCode.StateSet> i_stateSets;
      Absyn.Path i_modelInfo_name;
      Tpl.Text l_classname;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = i_modelInfo_name), stateSets = i_stateSets) )
      equation
        l_classname = lastIdentOfPath(Tpl.emptyTxt, i_modelInfo_name);
        txt = fun_170(txt, i_stateSets, l_classname);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_171;

public function functionDimStateSets
  input Tpl.Text txt;
  input list<SimCode.StateSet> a_stateSets;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  out_txt := fun_171(txt, a_simCode);
  out_a_extraFuncs := a_extraFuncs;
  out_a_extraFuncsDecl := a_extraFuncsDecl;
  out_a_extraFuncsNamespace := a_extraFuncsNamespace;
end functionDimStateSets;

protected function fun_173
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_mArg;
  input String in_a_sourceArrayName;
  input String in_a_targetArrayName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_sourceArrayName, in_a_targetArrayName)
    local
      Tpl.Text txt;
      String a_sourceArrayName;
      String a_targetArrayName;

    case ( txt,
           SimCodeVar.SIMVAR(numArrayElement = _),
           a_sourceArrayName,
           a_targetArrayName )
      equation
        txt = Tpl.writeStr(txt, a_targetArrayName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".assign("));
        txt = Tpl.writeStr(txt, a_sourceArrayName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_173;

public function createAssignArray
  input Tpl.Text txt;
  input DAE.ComponentRef a_sourceOrTargetArrayCref;
  input String a_sourceArrayName;
  input String a_targetArrayName;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Boolean a_useFlatArrayNotationSource;
  input Boolean a_useFlatArrayNotationTarget;
  input String a_dimsArrayName;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
protected
  SimCodeVar.SimVar ret_0;
algorithm
  ret_0 := SimCodeUtil.cref2simvar(a_sourceOrTargetArrayCref, a_simCode);
  out_txt := fun_173(txt, ret_0, a_sourceArrayName, a_targetArrayName);
  out_a_extraFuncs := a_extraFuncs;
  out_a_extraFuncsDecl := a_extraFuncsDecl;
  out_a_extraFuncsNamespace := a_extraFuncsNamespace;
end createAssignArray;

protected function fun_175
  input Tpl.Text in_txt;
  input Integer in_a_nStates;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_arrayname1;
  input DAE.ComponentRef in_a_crA;
  input Integer in_a_i1;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_a_nStates, in_a_useFlatArrayNotation, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_arrayname1, in_a_crA, in_a_i1)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_arrayname1;
      DAE.ComponentRef a_crA;
      Integer a_i1;

    case ( txt,
           1,
           a_useFlatArrayNotation,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_arrayname1,
           a_crA,
           a_i1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("case "));
        txt = Tpl.writeStr(txt, intString(a_i1));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(":\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(15));
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = createAssignArray(txt, a_crA, Tpl.textString(a_arrayname1), "A", a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_useFlatArrayNotation, false, "dims");
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("return true;\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("            "));
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           _,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _,
           _,
           _ )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_175;

protected function fun_176
  input Tpl.Text in_txt;
  input SimCode.StateSet in_a_set;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Integer in_a_i1;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_a_set, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_i1, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Integer a_i1;
      Boolean a_useFlatArrayNotation;
      Integer i_nStates;
      DAE.ComponentRef i_crA;
      Tpl.Text l_arrayname1;

    case ( txt,
           SimCode.SES_STATESET(crA = i_crA, nStates = i_nStates),
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_i1,
           a_useFlatArrayNotation )
      equation
        l_arrayname1 = CodegenCppCommonOld.arraycref(Tpl.emptyTxt, i_crA, a_useFlatArrayNotation);
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_175(txt, i_nStates, a_useFlatArrayNotation, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, l_arrayname1, i_crA, a_i1);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _,
           _ )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_176;

protected function lm_177
  input Tpl.Text in_txt;
  input list<SimCode.StateSet> in_items;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      list<SimCode.StateSet> rest;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Boolean a_useFlatArrayNotation;
      Integer x_i1;
      SimCode.StateSet i_set;

    case ( txt,
           {},
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           i_set :: rest,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_useFlatArrayNotation )
      equation
        x_i1 = Tpl.getIteri_i0(txt);
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_176(txt, i_set, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, x_i1, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_177(txt, rest, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_useFlatArrayNotation);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_177;

protected function fun_178
  input Tpl.Text in_txt;
  input Integer in_a_nStates;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_arrayname1;
  input DAE.ComponentRef in_a_crA;
  input Integer in_a_i1;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_a_nStates, in_a_useFlatArrayNotation, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_arrayname1, in_a_crA, in_a_i1)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_arrayname1;
      DAE.ComponentRef a_crA;
      Integer a_i1;

    case ( txt,
           1,
           _,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _,
           _,
           _ )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           a_useFlatArrayNotation,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_arrayname1,
           a_crA,
           a_i1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("case "));
        txt = Tpl.writeStr(txt, intString(a_i1));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(":\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(15));
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = createAssignArray(txt, a_crA, Tpl.textString(a_arrayname1), "A", a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_useFlatArrayNotation, false, "dims");
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("return true;\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("            "));
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_178;

protected function fun_179
  input Tpl.Text in_txt;
  input SimCode.StateSet in_a_set;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Integer in_a_i1;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_a_set, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_i1, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Integer a_i1;
      Boolean a_useFlatArrayNotation;
      Integer i_nStates;
      DAE.ComponentRef i_crA;
      Tpl.Text l_arrayname1;

    case ( txt,
           SimCode.SES_STATESET(crA = i_crA, nStates = i_nStates),
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_i1,
           a_useFlatArrayNotation )
      equation
        l_arrayname1 = CodegenCppCommonOld.arraycref(Tpl.emptyTxt, i_crA, a_useFlatArrayNotation);
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_178(txt, i_nStates, a_useFlatArrayNotation, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, l_arrayname1, i_crA, a_i1);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _,
           _ )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_179;

protected function lm_180
  input Tpl.Text in_txt;
  input list<SimCode.StateSet> in_items;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      list<SimCode.StateSet> rest;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Boolean a_useFlatArrayNotation;
      Integer x_i1;
      SimCode.StateSet i_set;

    case ( txt,
           {},
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           i_set :: rest,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_useFlatArrayNotation )
      equation
        x_i1 = Tpl.getIteri_i0(txt);
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_179(txt, i_set, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, x_i1, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_180(txt, rest, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_useFlatArrayNotation);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_180;

protected function fun_181
  input Tpl.Text in_txt;
  input Integer in_a_nStates;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_arrayname1;
  input DAE.ComponentRef in_a_crA;
  input Integer in_a_i1;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_a_nStates, in_a_useFlatArrayNotation, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_arrayname1, in_a_crA, in_a_i1)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_arrayname1;
      DAE.ComponentRef a_crA;
      Integer a_i1;

    case ( txt,
           1,
           a_useFlatArrayNotation,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_arrayname1,
           a_crA,
           a_i1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("case "));
        txt = Tpl.writeStr(txt, intString(a_i1));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(":\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(15));
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = createAssignArray(txt, a_crA, "A", Tpl.textString(a_arrayname1), a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, false, a_useFlatArrayNotation, "dims");
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("break;\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("            "));
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           _,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _,
           _,
           _ )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_181;

protected function fun_182
  input Tpl.Text in_txt;
  input SimCode.StateSet in_a_set;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Integer in_a_i1;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_a_set, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_i1, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Integer a_i1;
      Boolean a_useFlatArrayNotation;
      Integer i_nStates;
      DAE.ComponentRef i_crA;
      Tpl.Text l_arrayname1;

    case ( txt,
           SimCode.SES_STATESET(crA = i_crA, nStates = i_nStates),
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_i1,
           a_useFlatArrayNotation )
      equation
        l_arrayname1 = CodegenCppCommonOld.arraycref(Tpl.emptyTxt, i_crA, a_useFlatArrayNotation);
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_181(txt, i_nStates, a_useFlatArrayNotation, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, l_arrayname1, i_crA, a_i1);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _,
           _ )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_182;

protected function lm_183
  input Tpl.Text in_txt;
  input list<SimCode.StateSet> in_items;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      list<SimCode.StateSet> rest;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Boolean a_useFlatArrayNotation;
      Integer x_i1;
      SimCode.StateSet i_set;

    case ( txt,
           {},
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           i_set :: rest,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_useFlatArrayNotation )
      equation
        x_i1 = Tpl.getIteri_i0(txt);
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_182(txt, i_set, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, x_i1, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_183(txt, rest, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_useFlatArrayNotation);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_183;

protected function fun_184
  input Tpl.Text in_txt;
  input Integer in_a_nStates;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_arrayname1;
  input DAE.ComponentRef in_a_crA;
  input Integer in_a_i1;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_a_nStates, in_a_useFlatArrayNotation, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_arrayname1, in_a_crA, in_a_i1)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_arrayname1;
      DAE.ComponentRef a_crA;
      Integer a_i1;

    case ( txt,
           1,
           _,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _,
           _,
           _ )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           a_useFlatArrayNotation,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_arrayname1,
           a_crA,
           a_i1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("case "));
        txt = Tpl.writeStr(txt, intString(a_i1));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(":\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(15));
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = createAssignArray(txt, a_crA, "A", Tpl.textString(a_arrayname1), a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, false, a_useFlatArrayNotation, "dims");
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("break;\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("            "));
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_184;

protected function fun_185
  input Tpl.Text in_txt;
  input SimCode.StateSet in_a_set;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Integer in_a_i1;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_a_set, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_i1, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Integer a_i1;
      Boolean a_useFlatArrayNotation;
      Integer i_nStates;
      DAE.ComponentRef i_crA;
      Tpl.Text l_arrayname1;

    case ( txt,
           SimCode.SES_STATESET(crA = i_crA, nStates = i_nStates),
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_i1,
           a_useFlatArrayNotation )
      equation
        l_arrayname1 = CodegenCppCommonOld.arraycref(Tpl.emptyTxt, i_crA, a_useFlatArrayNotation);
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_184(txt, i_nStates, a_useFlatArrayNotation, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, l_arrayname1, i_crA, a_i1);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _,
           _ )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_185;

protected function lm_186
  input Tpl.Text in_txt;
  input list<SimCode.StateSet> in_items;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      list<SimCode.StateSet> rest;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Boolean a_useFlatArrayNotation;
      Integer x_i1;
      SimCode.StateSet i_set;

    case ( txt,
           {},
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           i_set :: rest,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_useFlatArrayNotation )
      equation
        x_i1 = Tpl.getIteri_i0(txt);
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_185(txt, i_set, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, x_i1, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_186(txt, rest, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_useFlatArrayNotation);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_186;

protected function lm_187
  input Tpl.Text in_txt;
  input list<DAE.ComponentRef> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_varDeclsCref;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_varDeclsCref;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_varDeclsCref, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_varDeclsCref, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      list<DAE.ComponentRef> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_varDeclsCref;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Integer x_i2;
      DAE.ComponentRef i_s;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_varDeclsCref,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           i_s :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_varDeclsCref,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        x_i2 = Tpl.getIteri_i0(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("z["));
        txt = Tpl.writeStr(txt, intString(x_i2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("]="));
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_varDeclsCref, a_stateDerVectorName) = CodegenCppCommonOld.cref1(txt, i_s, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, SimCodeFunction.contextOther, a_varDeclsCref, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_187(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_187;

protected function fun_188
  input Tpl.Text in_txt;
  input SimCode.StateSet in_a_set;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_varDeclsCref;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Integer in_a_i1;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_varDeclsCref;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_varDeclsCref, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_a_set, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_varDeclsCref, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_i1)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_varDeclsCref;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Integer a_i1;
      list<DAE.ComponentRef> i_states;

    case ( txt,
           SimCode.SES_STATESET(states = i_states),
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_varDeclsCref,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_i1 )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("case "));
        txt = Tpl.writeStr(txt, intString(a_i1));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(":\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_187(txt, i_states, a_useFlatArrayNotation, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("break;"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.popBlock(txt);
      then (txt, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           _,
           a_stateDerVectorName,
           a_varDeclsCref,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_188;

protected function lm_189
  input Tpl.Text in_txt;
  input list<SimCode.StateSet> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_varDeclsCref;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_varDeclsCref;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_varDeclsCref, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_varDeclsCref, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCode.StateSet> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_varDeclsCref;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Integer x_i1;
      SimCode.StateSet i_set;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_varDeclsCref,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           i_set :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_varDeclsCref,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        x_i1 = Tpl.getIteri_i0(txt);
        (txt, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_188(txt, i_set, a_useFlatArrayNotation, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, x_i1);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_189(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_189;

protected function lm_190
  input Tpl.Text in_txt;
  input list<DAE.ComponentRef> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_varDeclsCref;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_varDeclsCref;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_varDeclsCref, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_varDeclsCref, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      list<DAE.ComponentRef> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_varDeclsCref;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Integer x_i2;
      DAE.ComponentRef i_s;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_varDeclsCref,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           i_s :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_varDeclsCref,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        x_i2 = Tpl.getIteri_i0(txt);
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_varDeclsCref, a_stateDerVectorName) = CodegenCppCommonOld.cref1(txt, i_s, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, SimCodeFunction.contextOther, a_varDeclsCref, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = z["));
        txt = Tpl.writeStr(txt, intString(x_i2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("];"));
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_190(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_190;

protected function fun_191
  input Tpl.Text in_txt;
  input SimCode.StateSet in_a_set;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_varDeclsCref;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Integer in_a_i1;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_varDeclsCref;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_varDeclsCref, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_a_set, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_varDeclsCref, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_i1)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_varDeclsCref;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Integer a_i1;
      list<DAE.ComponentRef> i_states;

    case ( txt,
           SimCode.SES_STATESET(states = i_states),
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_varDeclsCref,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_i1 )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("case "));
        txt = Tpl.writeStr(txt, intString(a_i1));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(":\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_190(txt, i_states, a_useFlatArrayNotation, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("break;"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.popBlock(txt);
      then (txt, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           _,
           a_stateDerVectorName,
           a_varDeclsCref,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_191;

protected function lm_192
  input Tpl.Text in_txt;
  input list<SimCode.StateSet> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_varDeclsCref;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_varDeclsCref;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_varDeclsCref, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_varDeclsCref, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCode.StateSet> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_varDeclsCref;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Integer x_i1;
      SimCode.StateSet i_set;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_varDeclsCref,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           i_set :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_varDeclsCref,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        x_i1 = Tpl.getIteri_i0(txt);
        (txt, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_191(txt, i_set, a_useFlatArrayNotation, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, x_i1);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_192(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_192;

protected function lm_193
  input Tpl.Text in_txt;
  input list<DAE.ComponentRef> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_varDeclsCref;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_varDeclsCref;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_varDeclsCref, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_varDeclsCref, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      list<DAE.ComponentRef> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_varDeclsCref;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Integer x_i2;
      DAE.ComponentRef i_cstate;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_varDeclsCref,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           i_cstate :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_varDeclsCref,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        x_i2 = Tpl.getIteri_i0(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("z["));
        txt = Tpl.writeStr(txt, intString(x_i2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("]="));
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_varDeclsCref, a_stateDerVectorName) = CodegenCppCommonOld.cref1(txt, i_cstate, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, SimCodeFunction.contextOther, a_varDeclsCref, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_193(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_193;

protected function fun_194
  input Tpl.Text in_txt;
  input SimCode.StateSet in_a_set;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_varDeclsCref;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Integer in_a_i1;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_varDeclsCref;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_varDeclsCref, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_a_set, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_varDeclsCref, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_i1)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_varDeclsCref;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Integer a_i1;
      list<DAE.ComponentRef> i_statescandidates;

    case ( txt,
           SimCode.SES_STATESET(statescandidates = i_statescandidates),
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_varDeclsCref,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_i1 )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("case "));
        txt = Tpl.writeStr(txt, intString(a_i1));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(":\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_193(txt, i_statescandidates, a_useFlatArrayNotation, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("break;"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.popBlock(txt);
      then (txt, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           _,
           a_stateDerVectorName,
           a_varDeclsCref,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_194;

protected function lm_195
  input Tpl.Text in_txt;
  input list<SimCode.StateSet> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_varDeclsCref;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_varDeclsCref;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_varDeclsCref, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_varDeclsCref, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCode.StateSet> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_varDeclsCref;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Integer x_i1;
      SimCode.StateSet i_set;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_varDeclsCref,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           i_set :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_varDeclsCref,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        x_i1 = Tpl.getIteri_i0(txt);
        (txt, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_194(txt, i_set, a_useFlatArrayNotation, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, x_i1);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_195(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_195;

protected function fun_196
  input Tpl.Text in_txt;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("std::vector<size_t> dims;"));
      then txt;
  end match;
end fun_196;

protected function fun_197
  input Tpl.Text in_txt;
  input String in_mArg;
  input Tpl.Text in_a_getAMatrix2;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_getAMatrix2)
    local
      Tpl.Text txt;
      Tpl.Text a_getAMatrix2;

    case ( txt,
           "",
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("return false;"));
      then txt;

    case ( txt,
           _,
           a_getAMatrix2 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " switch (index)\n",
                                    "  {\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.writeText(txt, a_getAMatrix2);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "   default:\n",
                                    "  throw ModelicaSimulationError(MATH_FUNCTION,\"Not supported statset index\");\n",
                                    "  }"
                                }, false));
      then txt;
  end match;
end fun_197;

protected function fun_198
  input Tpl.Text in_txt;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("std::vector<size_t> dims;"));
      then txt;
  end match;
end fun_198;

protected function fun_199
  input Tpl.Text in_txt;
  input String in_mArg;
  input Tpl.Text in_a_getAMatrix1;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_getAMatrix1)
    local
      Tpl.Text txt;
      Tpl.Text a_getAMatrix1;

    case ( txt,
           "",
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("return false;"));
      then txt;

    case ( txt,
           _,
           a_getAMatrix1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "switch (index)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(3));
        txt = Tpl.writeText(txt, a_getAMatrix1);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" default:\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "  throw ModelicaSimulationError(MATH_FUNCTION,\"Not supported statset index\");\n",
                                    "  }"
                                }, false));
      then txt;
  end match;
end fun_199;

protected function fun_200
  input Tpl.Text in_txt;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("std::vector<size_t> dims;"));
      then txt;
  end match;
end fun_200;

protected function fun_201
  input Tpl.Text in_txt;
  input String in_mArg;
  input Tpl.Text in_a_setAMatrix2;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_setAMatrix2)
    local
      Tpl.Text txt;
      Tpl.Text a_setAMatrix2;

    case ( txt,
           "",
           _ )
      then txt;

    case ( txt,
           _,
           a_setAMatrix2 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " switch (index)\n",
                                    "  {\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.writeText(txt, a_setAMatrix2);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "   default:\n",
                                    "  throw ModelicaSimulationError(MATH_FUNCTION,\"Not supported statset index\");\n",
                                    "}"
                                }, false));
      then txt;
  end match;
end fun_201;

protected function fun_202
  input Tpl.Text in_txt;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("std::vector<size_t> dims;"));
      then txt;
  end match;
end fun_202;

protected function fun_203
  input Tpl.Text in_txt;
  input String in_mArg;
  input Tpl.Text in_a_setAMatrix1;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_setAMatrix1)
    local
      Tpl.Text txt;
      Tpl.Text a_setAMatrix1;

    case ( txt,
           "",
           _ )
      then txt;

    case ( txt,
           _,
           a_setAMatrix1 )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "switch (index)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_setAMatrix1);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "default:\n",
                                    "throw ModelicaSimulationError(MATH_FUNCTION,\"Not supported statset index\");\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;
  end match;
end fun_203;

protected function fun_204
  input Tpl.Text in_txt;
  input list<SimCode.StateSet> in_a_stateSets;
  input Tpl.Text in_a_setAMatrix1;
  input Tpl.Text in_a_setAMatrix2;
  input Tpl.Text in_a_getAMatrix1;
  input Tpl.Text in_a_getAMatrix2;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_classname;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_a_stateSets, in_a_setAMatrix1, in_a_setAMatrix2, in_a_getAMatrix1, in_a_getAMatrix2, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_classname)
    local
      Tpl.Text txt;
      Tpl.Text a_setAMatrix1;
      Tpl.Text a_setAMatrix2;
      Tpl.Text a_getAMatrix1;
      Tpl.Text a_getAMatrix2;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_classname;
      list<SimCode.StateSet> i_stateSets;
      String str_4;
      String str_3;
      String str_2;
      String str_1;
      Tpl.Text l_varDeclsCref;

    case ( txt,
           {},
           _,
           _,
           _,
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_classname )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = Tpl.writeText(txt, a_classname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "StateSelection::getStates(unsigned int index, double* z)\n",
                                    "{\n",
                                    "}\n",
                                    "\n",
                                    "void "
                                }, false));
        txt = Tpl.writeText(txt, a_classname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "StateSelection::setStates(unsigned int index, const double* z)\n",
                                    "{\n",
                                    "}\n",
                                    "\n",
                                    "void "
                                }, false));
        txt = Tpl.writeText(txt, a_classname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "StateSelection::getStateCanditates(unsigned int index, double* z)\n",
                                    "{\n",
                                    "\n",
                                    "}\n",
                                    "\n",
                                    "bool "
                                }, false));
        txt = Tpl.writeText(txt, a_classname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "StateSelection::getAMatrix(unsigned int index, DynArrayDim2<int> & A)\n",
                                    "{\n",
                                    "  return false;\n",
                                    "}\n",
                                    "\n",
                                    "bool "
                                }, false));
        txt = Tpl.writeText(txt, a_classname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "StateSelection::getAMatrix(unsigned int index, DynArrayDim1<int> & A)\n",
                                    "{\n",
                                    "  return false;\n",
                                    "}\n",
                                    "\n",
                                    "void "
                                }, false));
        txt = Tpl.writeText(txt, a_classname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "StateSelection::setAMatrix(unsigned int index, DynArrayDim2<int>& A)\n",
                                    "{\n",
                                    "}\n",
                                    "\n",
                                    "void "
                                }, false));
        txt = Tpl.writeText(txt, a_classname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "StateSelection::setAMatrix(unsigned int index, DynArrayDim1<int>& A)\n",
                                    "{\n",
                                    "}\n",
                                    "\n",
                                    "void "
                                }, false));
        txt = Tpl.writeText(txt, a_classname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "StateSelection::initialize()\n",
                                    "{\n",
                                    "}"
                                }, false));
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           i_stateSets,
           a_setAMatrix1,
           a_setAMatrix2,
           a_getAMatrix1,
           a_getAMatrix2,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_classname )
      equation
        l_varDeclsCref = Tpl.emptyTxt;
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = Tpl.writeText(txt, a_classname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "StateSelection::getStates(unsigned int index,double* z)\n",
                                    "{\n",
                                    "  switch (index)\n",
                                    "  {\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_stateDerVectorName, l_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_189(txt, i_stateSets, a_useFlatArrayNotation, a_stateDerVectorName, l_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " default:\n",
                                    " throw ModelicaSimulationError(MATH_FUNCTION,\"Not supported statset index\");\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "  }\n",
                                    "}\n",
                                    "\n",
                                    "void "
                                }, false));
        txt = Tpl.writeText(txt, a_classname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "StateSelection::setStates(unsigned int index,const double* z)\n",
                                    "{\n",
                                    "  switch (index)\n",
                                    "  {\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_stateDerVectorName, l_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_192(txt, i_stateSets, a_useFlatArrayNotation, a_stateDerVectorName, l_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "default:\n",
                                    "throw ModelicaSimulationError(MATH_FUNCTION,\"Not supported statset index\");\n",
                                    "}\n",
                                    "\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("   }\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(3));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void  "));
        txt = Tpl.writeText(txt, a_classname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "StateSelection::getStateCanditates(unsigned int index,double* z)\n",
                                    "{\n",
                                    "\n",
                                    " switch (index)\n",
                                    " {\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(3));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_stateDerVectorName, l_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_195(txt, i_stateSets, a_useFlatArrayNotation, a_stateDerVectorName, l_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " default:\n",
                                    " throw ModelicaSimulationError(MATH_FUNCTION,\"Not supported statset index\");\n",
                                    " }\n",
                                    "\n",
                                    "}\n",
                                    "\n",
                                    "\n",
                                    "bool  "
                                }, false));
        txt = Tpl.writeText(txt, a_classname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "StateSelection::getAMatrix(unsigned int index,DynArrayDim2<int> & A)\n",
                                    " {\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = fun_196(txt, a_useFlatArrayNotation);
        txt = Tpl.softNewLine(txt);
        str_1 = Tpl.textString(a_getAMatrix2);
        txt = fun_197(txt, str_1, a_getAMatrix2);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "bool  "
                                }, false));
        txt = Tpl.writeText(txt, a_classname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "StateSelection::getAMatrix(unsigned int index,DynArrayDim1<int> & A)\n",
                                    " {\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = fun_198(txt, a_useFlatArrayNotation);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        str_2 = Tpl.textString(a_getAMatrix1);
        txt = fun_199(txt, str_2, a_getAMatrix1);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n",
                                    "void  "
                                }, false));
        txt = Tpl.writeText(txt, a_classname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "StateSelection::setAMatrix(unsigned int index,DynArrayDim2<int> & A)\n",
                                    " {\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = fun_200(txt, a_useFlatArrayNotation);
        txt = Tpl.softNewLine(txt);
        str_3 = Tpl.textString(a_setAMatrix2);
        txt = fun_201(txt, str_3, a_setAMatrix2);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "void  "
                                }, false));
        txt = Tpl.writeText(txt, a_classname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "StateSelection::setAMatrix(unsigned int index,DynArrayDim1<int> & A)\n",
                                    " {\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = fun_202(txt, a_useFlatArrayNotation);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        str_4 = Tpl.textString(a_setAMatrix1);
        txt = fun_203(txt, str_4, a_setAMatrix1);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_204;

protected function fun_205
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      Absyn.Path i_modelInfo_name;
      SimCode.SimCode i_simCode;
      list<SimCode.StateSet> i_stateSets;
      Tpl.Text l_classname;
      Tpl.Text l_setAMatrix2;
      Tpl.Text l_setAMatrix1;
      Tpl.Text l_getAMatrix2;
      Tpl.Text l_getAMatrix1;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = i_modelInfo_name), stateSets = i_stateSets)),
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_getAMatrix1 = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_getAMatrix1, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_177(l_getAMatrix1, i_stateSets, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, i_simCode, a_useFlatArrayNotation);
        l_getAMatrix1 = Tpl.popIter(l_getAMatrix1);
        l_getAMatrix2 = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_getAMatrix2, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_180(l_getAMatrix2, i_stateSets, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, i_simCode, a_useFlatArrayNotation);
        l_getAMatrix2 = Tpl.popIter(l_getAMatrix2);
        l_setAMatrix1 = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_setAMatrix1, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_183(l_setAMatrix1, i_stateSets, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, i_simCode, a_useFlatArrayNotation);
        l_setAMatrix1 = Tpl.popIter(l_setAMatrix1);
        l_setAMatrix2 = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_setAMatrix2, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_186(l_setAMatrix2, i_stateSets, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, i_simCode, a_useFlatArrayNotation);
        l_setAMatrix2 = Tpl.popIter(l_setAMatrix2);
        l_classname = lastIdentOfPath(Tpl.emptyTxt, i_modelInfo_name);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_204(txt, i_stateSets, l_setAMatrix1, l_setAMatrix2, l_getAMatrix1, l_getAMatrix2, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, i_simCode, l_classname);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end fun_205;

public function functionStateSets
  input Tpl.Text txt;
  input list<SimCode.StateSet> a_stateSets;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) := fun_205(txt, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
end functionStateSets;

protected function fun_207
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input String in_a_settings_method;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode, in_a_settings_method)
    local
      Tpl.Text txt;
      String a_settings_method;

    case ( txt,
           SimCode.SIMCODE(daeModeData = NONE()),
           a_settings_method )
      equation
        txt = Tpl.writeStr(txt, a_settings_method);
      then txt;

    case ( txt,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("ida"));
      then txt;
  end match;
end fun_207;

protected function fun_208
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-O none"));
      then txt;
  end match;
end fun_208;

protected function lm_209
  input Tpl.Text in_txt;
  input list<String> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<String> rest;
      String i_path;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_path :: rest )
      equation
        txt = Tpl.writeStr(txt, i_path);
        txt = Tpl.nextIter(txt);
        txt = lm_209(txt, rest);
      then txt;
  end match;
end lm_209;

protected function fun_210
  input Tpl.Text in_txt;
  input String in_a_makefileParams_platform;
  input Tpl.Text in_a_moLib;
  input Tpl.Text in_a_libPaths;
  input Tpl.Text in_a_home;
  input Tpl.Text in_a_libFolder;
  input String in_a_preRunCommandWindows;
  input Tpl.Text in_a_outputParameter;
  input Tpl.Text in_a_execParameters;
  input Tpl.Text in_a_fileNamePrefixx;
  input String in_a_execCommandLinux;
  input String in_a_preRunCommandLinux;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_makefileParams_platform, in_a_moLib, in_a_libPaths, in_a_home, in_a_libFolder, in_a_preRunCommandWindows, in_a_outputParameter, in_a_execParameters, in_a_fileNamePrefixx, in_a_execCommandLinux, in_a_preRunCommandLinux)
    local
      Tpl.Text txt;
      Tpl.Text a_moLib;
      Tpl.Text a_libPaths;
      Tpl.Text a_home;
      Tpl.Text a_libFolder;
      String a_preRunCommandWindows;
      Tpl.Text a_outputParameter;
      Tpl.Text a_execParameters;
      Tpl.Text a_fileNamePrefixx;
      String a_execCommandLinux;
      String a_preRunCommandLinux;

    case ( txt,
           "linux32",
           _,
           _,
           _,
           _,
           _,
           a_outputParameter,
           a_execParameters,
           a_fileNamePrefixx,
           a_execCommandLinux,
           a_preRunCommandLinux )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("#!/bin/sh\n"));
        txt = Tpl.writeStr(txt, a_preRunCommandLinux);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeStr(txt, a_execCommandLinux);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" ./"));
        txt = Tpl.writeText(txt, a_fileNamePrefixx);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, a_execParameters);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, a_outputParameter);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" $*"));
      then txt;

    case ( txt,
           "linux64",
           _,
           _,
           _,
           _,
           _,
           a_outputParameter,
           a_execParameters,
           a_fileNamePrefixx,
           a_execCommandLinux,
           a_preRunCommandLinux )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("#!/bin/sh\n"));
        txt = Tpl.writeStr(txt, a_preRunCommandLinux);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeStr(txt, a_execCommandLinux);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" ./"));
        txt = Tpl.writeText(txt, a_fileNamePrefixx);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, a_execParameters);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, a_outputParameter);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" $*"));
      then txt;

    case ( txt,
           "win32",
           a_moLib,
           a_libPaths,
           a_home,
           a_libFolder,
           a_preRunCommandWindows,
           a_outputParameter,
           a_execParameters,
           a_fileNamePrefixx,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("@echo off\n"));
        txt = Tpl.writeStr(txt, a_preRunCommandWindows);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("REM ::export PATH="));
        txt = Tpl.writeText(txt, a_libFolder);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ":$PATH REPLACE C: with /C/\n",
                                    "SET PATH="
                                }, false));
        txt = Tpl.writeText(txt, a_home);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/bin;"));
        txt = Tpl.writeText(txt, a_libFolder);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeText(txt, a_libPaths);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";%PATH%\n",
                                    "\""
                                }, false));
        txt = Tpl.writeText(txt, a_moLib);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/"));
        txt = Tpl.writeText(txt, a_fileNamePrefixx);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".exe\" "));
        txt = Tpl.writeText(txt, a_execParameters);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, a_outputParameter);
      then txt;

    case ( txt,
           "win64",
           a_moLib,
           a_libPaths,
           a_home,
           a_libFolder,
           a_preRunCommandWindows,
           a_outputParameter,
           a_execParameters,
           a_fileNamePrefixx,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("@echo off\n"));
        txt = Tpl.writeStr(txt, a_preRunCommandWindows);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("REM ::export PATH="));
        txt = Tpl.writeText(txt, a_libFolder);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ":$PATH REPLACE C: with /C/\n",
                                    "SET PATH="
                                }, false));
        txt = Tpl.writeText(txt, a_home);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/bin;"));
        txt = Tpl.writeText(txt, a_libFolder);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeText(txt, a_libPaths);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";%PATH%\n",
                                    "\""
                                }, false));
        txt = Tpl.writeText(txt, a_moLib);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/"));
        txt = Tpl.writeText(txt, a_fileNamePrefixx);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".exe\" "));
        txt = Tpl.writeText(txt, a_execParameters);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, a_outputParameter);
      then txt;

    case ( txt,
           _,
           _,
           _,
           _,
           _,
           _,
           _,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_210;

public function simulationMainRunScript
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input String in_a_preRunCommandLinux;
  input String in_a_preRunCommandWindows;
  input String in_a_execCommandLinux;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace) :=
  match(in_txt, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_preRunCommandLinux, in_a_preRunCommandWindows, in_a_execCommandLinux)
    local
      Tpl.Text txt;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      String a_preRunCommandLinux;
      String a_preRunCommandWindows;
      String a_execCommandLinux;
      String i_makefileParams_platform;
      list<String> i_makefileParams_libPaths;
      String i_fileNamePrefix;
      String i_settings_outputFormat;
      String i_makefileParams_omhome;
      String i_makefileParams_compileDir;
      String i_settings_method;
      SimCode.SimCode i_simCode;
      Real i_settings_tolerance;
      Integer i_settings_numberOfIntervals;
      Real i_settings_stepSize;
      Real i_settings_stopTime;
      Real i_settings_startTime;
      Tpl.Text l_libPaths;
      String ret_16;
      Tpl.Text l_libFolder;
      Tpl.Text l_fileNamePrefixx;
      Boolean ret_13;
      Tpl.Text l_outputParameter;
      Boolean ret_11;
      String ret_10;
      Tpl.Text l_execParameters;
      Tpl.Text l_outputformat;
      Tpl.Text l_home;
      Tpl.Text l_moLib;
      Tpl.Text l_solver;
      Tpl.Text l_tol;
      Tpl.Text l_intervals;
      Tpl.Text l_stepsize;
      Tpl.Text l_end;
      Tpl.Text l_start;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = _), makefileParams = SimCodeFunction.MAKEFILE_PARAMS(compileDir = i_makefileParams_compileDir, omhome = i_makefileParams_omhome, libPaths = i_makefileParams_libPaths, platform = i_makefileParams_platform), simulationSettingsOpt = SOME(SimCode.SIMULATION_SETTINGS(startTime = i_settings_startTime, stopTime = i_settings_stopTime, stepSize = i_settings_stepSize, numberOfIntervals = i_settings_numberOfIntervals, tolerance = i_settings_tolerance, method = i_settings_method, outputFormat = i_settings_outputFormat)), fileNamePrefix = i_fileNamePrefix)),
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_preRunCommandLinux,
           a_preRunCommandWindows,
           a_execCommandLinux )
      equation
        l_start = Tpl.writeStr(Tpl.emptyTxt, realString(i_settings_startTime));
        l_end = Tpl.writeStr(Tpl.emptyTxt, realString(i_settings_stopTime));
        l_stepsize = Tpl.writeStr(Tpl.emptyTxt, realString(i_settings_stepSize));
        l_intervals = Tpl.writeStr(Tpl.emptyTxt, intString(i_settings_numberOfIntervals));
        l_tol = Tpl.writeStr(Tpl.emptyTxt, realString(i_settings_tolerance));
        l_solver = fun_207(Tpl.emptyTxt, i_simCode, i_settings_method);
        l_moLib = Tpl.writeStr(Tpl.emptyTxt, i_makefileParams_compileDir);
        l_home = Tpl.writeStr(Tpl.emptyTxt, i_makefileParams_omhome);
        l_outputformat = Tpl.writeStr(Tpl.emptyTxt, i_settings_outputFormat);
        l_execParameters = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("-S "));
        l_execParameters = Tpl.writeText(l_execParameters, l_start);
        l_execParameters = Tpl.writeTok(l_execParameters, Tpl.ST_STRING(" -E "));
        l_execParameters = Tpl.writeText(l_execParameters, l_end);
        l_execParameters = Tpl.writeTok(l_execParameters, Tpl.ST_STRING(" -H "));
        l_execParameters = Tpl.writeText(l_execParameters, l_stepsize);
        l_execParameters = Tpl.writeTok(l_execParameters, Tpl.ST_STRING(" -G "));
        l_execParameters = Tpl.writeText(l_execParameters, l_intervals);
        l_execParameters = Tpl.writeTok(l_execParameters, Tpl.ST_STRING(" -P "));
        l_execParameters = Tpl.writeText(l_execParameters, l_outputformat);
        l_execParameters = Tpl.writeTok(l_execParameters, Tpl.ST_STRING(" -T "));
        l_execParameters = Tpl.writeText(l_execParameters, l_tol);
        l_execParameters = Tpl.writeTok(l_execParameters, Tpl.ST_STRING(" -I "));
        l_execParameters = Tpl.writeText(l_execParameters, l_solver);
        l_execParameters = Tpl.writeTok(l_execParameters, Tpl.ST_STRING(" -R \""));
        ret_10 = Config.simulationCodeTarget();
        (l_execParameters, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = simulationLibDir(l_execParameters, ret_10, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
        l_execParameters = Tpl.writeTok(l_execParameters, Tpl.ST_STRING("\" -M \""));
        l_execParameters = Tpl.writeText(l_execParameters, l_moLib);
        l_execParameters = Tpl.writeTok(l_execParameters, Tpl.ST_STRING("\" -r \""));
        ret_11 = Testsuite.isRunning();
        (l_execParameters, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = simulationResults(l_execParameters, ret_11, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
        l_execParameters = Tpl.writeTok(l_execParameters, Tpl.ST_STRING("\""));
        ret_13 = stringEq(i_settings_outputFormat, "empty");
        l_outputParameter = fun_208(Tpl.emptyTxt, ret_13);
        l_fileNamePrefixx = Tpl.writeStr(Tpl.emptyTxt, i_fileNamePrefix);
        ret_16 = Config.simulationCodeTarget();
        (l_libFolder, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = simulationLibDir(Tpl.emptyTxt, ret_16, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
        l_libPaths = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(";")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_libPaths = lm_209(l_libPaths, i_makefileParams_libPaths);
        l_libPaths = Tpl.popIter(l_libPaths);
        txt = fun_210(txt, i_makefileParams_platform, l_moLib, l_libPaths, l_home, l_libFolder, a_preRunCommandWindows, l_outputParameter, l_execParameters, l_fileNamePrefixx, a_execCommandLinux, a_preRunCommandLinux);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);

    case ( txt,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           _,
           _,
           _ )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
  end match;
end simulationMainRunScript;

protected function fun_212
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      String i_makefileParams_omhome;

    case ( txt,
           SimCode.SIMCODE(makefileParams = SimCodeFunction.MAKEFILE_PARAMS(omhome = i_makefileParams_omhome)) )
      equation
        txt = Tpl.writeStr(txt, i_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/lib/"));
        txt = Tpl.writeStr(txt, Autoconf.triple);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/omc/cpp/msvc"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_212;

protected function fun_213
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      String i_makefileParams_omhome;

    case ( txt,
           SimCode.SIMCODE(makefileParams = SimCodeFunction.MAKEFILE_PARAMS(omhome = i_makefileParams_omhome)) )
      equation
        txt = Tpl.writeStr(txt, i_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/lib/"));
        txt = Tpl.writeStr(txt, Autoconf.triple);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/omc/cpp/msvc"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_213;

protected function fun_214
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      String i_makefileParams_omhome;

    case ( txt,
           SimCode.SIMCODE(makefileParams = SimCodeFunction.MAKEFILE_PARAMS(omhome = i_makefileParams_omhome)) )
      equation
        txt = Tpl.writeStr(txt, i_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/lib/"));
        txt = Tpl.writeStr(txt, Autoconf.triple);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/omc/cpp/"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_214;

protected function fun_215
  input Tpl.Text in_txt;
  input String in_mArg;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_simCode)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;

    case ( txt,
           "debugrt",
           a_simCode )
      equation
        txt = fun_212(txt, a_simCode);
      then txt;

    case ( txt,
           "msvc",
           a_simCode )
      equation
        txt = fun_213(txt, a_simCode);
      then txt;

    case ( txt,
           _,
           a_simCode )
      equation
        txt = fun_214(txt, a_simCode);
      then txt;
  end match;
end fun_215;

public function simulationLibDir
  input Tpl.Text txt;
  input String a_target;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
protected
  String str_1;
  Tpl.Text txt_0;
algorithm
  txt_0 := CodegenUtil.getGeneralTarget(Tpl.emptyTxt, a_target);
  str_1 := Tpl.textString(txt_0);
  out_txt := fun_215(txt, str_1, a_simCode);
  out_a_extraFuncs := a_extraFuncs;
  out_a_extraFuncsDecl := a_extraFuncsDecl;
  out_a_extraFuncsNamespace := a_extraFuncsNamespace;
end simulationLibDir;

protected function fun_217
  input Tpl.Text in_txt;
  input Boolean in_a_test;
  input String in_a_makefileParams_compileDir;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_test, in_a_makefileParams_compileDir)
    local
      Tpl.Text txt;
      String a_makefileParams_compileDir;

    case ( txt,
           false,
           a_makefileParams_compileDir )
      equation
        txt = Tpl.writeStr(txt, a_makefileParams_compileDir);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_217;

protected function fun_218
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Boolean in_a_test;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode, in_a_test)
    local
      Tpl.Text txt;
      Boolean a_test;
      String i_settings_outputFormat;
      String i_fileNamePrefix;
      String i_makefileParams_compileDir;
      Tpl.Text l_results;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = _), makefileParams = SimCodeFunction.MAKEFILE_PARAMS(compileDir = i_makefileParams_compileDir), simulationSettingsOpt = SOME(SimCode.SIMULATION_SETTINGS(outputFormat = i_settings_outputFormat)), fileNamePrefix = i_fileNamePrefix),
           a_test )
      equation
        l_results = fun_217(Tpl.emptyTxt, a_test, i_makefileParams_compileDir);
        txt = Tpl.writeText(txt, l_results);
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_res."));
        txt = Tpl.writeStr(txt, i_settings_outputFormat);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_218;

public function simulationResults
  input Tpl.Text txt;
  input Boolean a_test;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  out_txt := fun_218(txt, a_simCode, a_test);
  out_a_extraFuncs := a_extraFuncs;
  out_a_extraFuncsDecl := a_extraFuncsDecl;
  out_a_extraFuncsNamespace := a_extraFuncsNamespace;
end simulationResults;

protected function fun_220
  input Tpl.Text in_txt;
  input String in_a_params_platform;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_params_platform)
    local
      Tpl.Text txt;

    case ( txt,
           "win32" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".bat"));
      then txt;

    case ( txt,
           "win64" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".bat"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".sh"));
      then txt;
  end match;
end fun_220;

protected function fun_221
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      String i_params_platform;

    case ( txt,
           SimCode.SIMCODE(makefileParams = SimCodeFunction.MAKEFILE_PARAMS(platform = i_params_platform)) )
      equation
        txt = fun_220(txt, i_params_platform);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_221;

public function simulationMainRunScriptSuffix
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  out_txt := fun_221(txt, a_simCode);
  out_a_extraFuncs := a_extraFuncs;
  out_a_extraFuncsDecl := a_extraFuncsDecl;
  out_a_extraFuncsNamespace := a_extraFuncsNamespace;
end simulationMainRunScriptSuffix;

protected function fun_223
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input String in_a_numPreVars;
  input String in_a_numStringVars;
  input String in_a_numBoolVars;
  input String in_a_numIntVars;
  input String in_a_numRealVars;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_a_simCode, in_a_numPreVars, in_a_numStringVars, in_a_numBoolVars, in_a_numIntVars, in_a_numRealVars, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs)
    local
      Tpl.Text txt;
      String a_numPreVars;
      String a_numStringVars;
      String a_numBoolVars;
      String a_numIntVars;
      String a_numRealVars;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      String i_makefileParams_dllext;
      String i_fileNamePrefix;
      SimCode.ModelInfo i_modelInfo;
      SimCode.SimCode i_simCode;
      String i_makefileParams_omhome;
      String i_makefileParams_compileDir;
      String i_settings_method;
      Real i_settings_tolerance;
      Integer i_settings_numberOfIntervals;
      Real i_settings_stepSize;
      Real i_settings_stopTime;
      Real i_settings_startTime;
      Absyn.Path i_modelInfo_name;
      Boolean ret_11;
      String ret_10;
      Tpl.Text l_includeMeasure;
      Tpl.Text l_home;
      Tpl.Text l_moLib;
      Tpl.Text l_solver;
      Tpl.Text l_tol;
      Tpl.Text l_intervals;
      Tpl.Text l_stepsize;
      Tpl.Text l_end;
      Tpl.Text l_start;
      Tpl.Text l_modelname;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = (i_modelInfo as SimCode.MODELINFO(name = i_modelInfo_name)), makefileParams = SimCodeFunction.MAKEFILE_PARAMS(compileDir = i_makefileParams_compileDir, omhome = i_makefileParams_omhome, dllext = i_makefileParams_dllext), simulationSettingsOpt = SOME(SimCode.SIMULATION_SETTINGS(startTime = i_settings_startTime, stopTime = i_settings_stopTime, stepSize = i_settings_stepSize, numberOfIntervals = i_settings_numberOfIntervals, tolerance = i_settings_tolerance, method = i_settings_method)), fileNamePrefix = i_fileNamePrefix)),
           a_numPreVars,
           a_numStringVars,
           a_numBoolVars,
           a_numIntVars,
           a_numRealVars,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs )
      equation
        l_modelname = identOfPath(Tpl.emptyTxt, i_modelInfo_name);
        l_start = Tpl.writeStr(Tpl.emptyTxt, realString(i_settings_startTime));
        l_end = Tpl.writeStr(Tpl.emptyTxt, realString(i_settings_stopTime));
        l_stepsize = Tpl.writeStr(Tpl.emptyTxt, realString(i_settings_stepSize));
        l_intervals = Tpl.writeStr(Tpl.emptyTxt, intString(i_settings_numberOfIntervals));
        l_tol = Tpl.writeStr(Tpl.emptyTxt, realString(i_settings_tolerance));
        l_solver = Tpl.writeStr(Tpl.emptyTxt, i_settings_method);
        l_moLib = Tpl.writeStr(Tpl.emptyTxt, i_makefileParams_compileDir);
        l_home = Tpl.writeStr(Tpl.emptyTxt, i_makefileParams_omhome);
        l_includeMeasure = Tpl.emptyTxt;
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "//Includes\n",
                                    "\n",
                                    "#include <Core/ModelicaDefine.h>\n",
                                    "#include <Core/Modelica.h>\n",
                                    "#include <stdio.h>\n",
                                    "#include <string>\n",
                                    "\n",
                                    "#include <Core/DataExchange/SimDouble.h>\n",
                                    "#include <Core/DataExchange/SimBoolean.h>\n",
                                    "#include <Core/SimController/ISimController.h>\n",
                                    "#include <Core/System/FactoryExport.h>\n",
                                    "\n",
                                    "#define PATH string\n",
                                    "\n",
                                    "#include <tchar.h>\n",
                                    "#include <fstream>\n",
                                    "\n",
                                    "int _tmain(int argc, const _TCHAR* argv[])\n",
                                    "{\n",
                                    "\n",
                                    "  /*\n",
                                    "  =============================================================================================================\n",
                                    "  ==                 Initialization of SimCore\n",
                                    "  =============================================================================================================\n",
                                    "  */\n",
                                    "\n",
                                    "\n",
                                    "\n",
                                    "\n",
                                    "    //nur testweise\n",
                                    "    std::map<std::string, std::string> opts;\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(6));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("opts[\"-s\"] = \""));
        txt = Tpl.writeText(txt, l_start);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\";\n",
                                    "opts[\"-e\"] = \""
                                }, false));
        txt = Tpl.writeText(txt, l_end);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\";\n",
                                    "opts[\"-f\"] = \""
                                }, false));
        txt = Tpl.writeText(txt, l_stepsize);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\";\n",
                                    "opts[\"-v\"] = \""
                                }, false));
        txt = Tpl.writeText(txt, l_intervals);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\";\n",
                                    "opts[\"-y\"] = \""
                                }, false));
        txt = Tpl.writeText(txt, l_tol);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\";\n",
                                    "opts[\"-i\"] = \""
                                }, false));
        txt = Tpl.writeText(txt, l_solver);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\";\n",
                                    "opts[\"-r\"] = \""
                                }, false));
        ret_10 = Config.simulationCodeTarget();
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = simulationLibDir(txt, ret_10, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\";\n",
                                    "opts[\"-M\"] = \""
                                }, false));
        txt = Tpl.writeText(txt, l_moLib);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\";\n",
                                    "opts[\"-R\"] = \""
                                }, false));
        ret_11 = Testsuite.isRunning();
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = simulationResults(txt, ret_11, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\";\n",
                                    "\n",
                                    "\n",
                                    "\n",
                                    "\n",
                                    "\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "  shared_ptr<OMCFactory>  _factory =  shared_ptr<OMCFactory>(new OMCFactory());\n",
                                    "\n",
                                    "  //SimController to start simulation\n",
                                    "\n",
                                    "  std::pair<shared_ptr<ISimController>, SimSettings> simulation = _factory->createSimulation(argc, argv, opts);\n",
                                    "\n",
                                    "  //create Modelica system\n",
                                    "  shared_ptr<ISimObjects> simObjects= simulation.first->getSimObjects();\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("weak_ptr<ISimData> simData = simObjects->LoadSimData(\""));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\");\n",
                                    "weak_ptr<ISimVars> simVars = simObjects->LoadSimVars(\""
                                }, false));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\","));
        txt = Tpl.writeStr(txt, a_numRealVars);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeStr(txt, a_numIntVars);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeStr(txt, a_numBoolVars);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeStr(txt, a_numStringVars);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeStr(txt, a_numPreVars);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = numStatevars(txt, i_modelInfo);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = numStateVarIndex(txt, i_modelInfo);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ");\n",
                                    "weak_ptr<IMixedSystem> system = simulation.first->LoadSystem(\"OMCpp"
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeStr(txt, i_makefileParams_dllext);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("  \",\""));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\");\n",
                                    "\n",
                                    "\n",
                                    "// Declare Input specify initial_values if needed!!!\n"
                                }, true));
        txt = defineInputVars(txt, i_simCode);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "// Declare Output\n"
                                }, true));
        txt = defineOutputVars(txt, i_simCode);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "LogSettings logsetting;\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("SimSettings settings = {\"RTEuler\",\"\",\"newton\",        0.0,      100.0,  0.004,      0.0025,      10.0,         0.0001, \""));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("\",0,OPT_NONE, logsetting};\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "//                       Solver,          nonlinearsolver starttime endtime stepsize   lower limit upper limit  tolerance\n",
                                    "\n",
                                    "\n",
                                    "try\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("simulation.first->StartVxWorks(settings, \""));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("\");\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "catch(ModelicaSimulationError& ex)\n",
                                    "{\n",
                                    "  throw std::runtime_error(\"error initialize\");\n",
                                    "}\n",
                                    "  std::fstream f;\n",
                                    "  f.open(\"output_rt.csv\", ios::out);\n",
                                    "\n",
                                    "\n",
                                    "for( int i = 0; i < 1000; i++)\n",
                                    "{\n",
                                    "  try\n",
                                    "  {\n",
                                    "    simulation.first->calcOneStep();\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = streamOutputVars(txt, i_simCode);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "  }\n",
                                    "  catch(ModelicaSimulationError& ex)\n",
                                    "  {\n",
                                    "    f.close();\n",
                                    "    throw std::runtime_error(\"error inside step\");\n",
                                    "  }\n",
                                    "}\n",
                                    "f.close();\n",
                                    "return 0;\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n",
                                    "\n",
                                    "\n"
                                }, true));
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           _,
           _,
           _,
           _,
           _,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_223;

protected function fun_224
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input String in_a_numPreVars;
  input String in_a_numStringVars;
  input String in_a_numBoolVars;
  input String in_a_numIntVars;
  input String in_a_numRealVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode, in_a_numPreVars, in_a_numStringVars, in_a_numBoolVars, in_a_numIntVars, in_a_numRealVars)
    local
      Tpl.Text txt;
      String a_numPreVars;
      String a_numStringVars;
      String a_numBoolVars;
      String a_numIntVars;
      String a_numRealVars;
      SimCode.ModelInfo i_modelInfo;
      SimCode.SimCode i_simCode;
      String i_makefileParams_omhome;
      String i_makefileParams_compileDir;
      String i_settings_method;
      Real i_settings_tolerance;
      Integer i_settings_numberOfIntervals;
      Real i_settings_stepSize;
      Real i_settings_stopTime;
      Real i_settings_startTime;
      Absyn.Path i_modelInfo_name;
      Tpl.Text l_includeMeasure;
      Tpl.Text l_home;
      Tpl.Text l_moLib;
      Tpl.Text l_solver;
      Tpl.Text l_tol;
      Tpl.Text l_intervals;
      Tpl.Text l_stepsize;
      Tpl.Text l_end;
      Tpl.Text l_start;
      Tpl.Text l_modelname;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = (i_modelInfo as SimCode.MODELINFO(name = i_modelInfo_name)), makefileParams = SimCodeFunction.MAKEFILE_PARAMS(compileDir = i_makefileParams_compileDir, omhome = i_makefileParams_omhome), simulationSettingsOpt = SOME(SimCode.SIMULATION_SETTINGS(startTime = i_settings_startTime, stopTime = i_settings_stopTime, stepSize = i_settings_stepSize, numberOfIntervals = i_settings_numberOfIntervals, tolerance = i_settings_tolerance, method = i_settings_method)))),
           a_numPreVars,
           a_numStringVars,
           a_numBoolVars,
           a_numIntVars,
           a_numRealVars )
      equation
        l_modelname = identOfPath(Tpl.emptyTxt, i_modelInfo_name);
        l_start = Tpl.writeStr(Tpl.emptyTxt, realString(i_settings_startTime));
        l_end = Tpl.writeStr(Tpl.emptyTxt, realString(i_settings_stopTime));
        l_stepsize = Tpl.writeStr(Tpl.emptyTxt, realString(i_settings_stepSize));
        l_intervals = Tpl.writeStr(Tpl.emptyTxt, intString(i_settings_numberOfIntervals));
        l_tol = Tpl.writeStr(Tpl.emptyTxt, realString(i_settings_tolerance));
        l_solver = Tpl.writeStr(Tpl.emptyTxt, i_settings_method);
        l_moLib = Tpl.writeStr(Tpl.emptyTxt, i_makefileParams_compileDir);
        l_home = Tpl.writeStr(Tpl.emptyTxt, i_makefileParams_omhome);
        l_includeMeasure = Tpl.emptyTxt;
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "//Includes\n",
                                    "\n",
                                    "#include <Core/ModelicaDefine.h>\n",
                                    "#include <Core/Modelica.h>\n",
                                    "#include <stdio.h>\n",
                                    "#include <string>\n",
                                    "\n",
                                    "#include <Core/DataExchange/SimDouble.h>\n",
                                    "#include <Core/DataExchange/SimBoolean.h>\n",
                                    "#include <Core/SimController/ISimController.h>\n",
                                    "#include <Core/System/FactoryExport.h>\n",
                                    "\n",
                                    "#define PATH string\n",
                                    "\n",
                                    "#include <wvLib.h>\n",
                                    "\n",
                                    "#include <util/bundle.h>\n",
                                    "#include <util/vxwHelper.h>\n",
                                    "#include <util/wchar16.h>\n",
                                    "\n",
                                    "#include <mlpiApiLib.h>\n",
                                    "#include <mlpiSystemLib.h>\n",
                                    "#include <mlpiTaskLib.h>\n",
                                    "#include <mlpiLogicLib.h>\n",
                                    "#include <mlpiParameterLib.h>\n",
                                    "\n",
                                    "\n",
                                    "\n",
                                    "extern \"C\"  ISimController* createSimController(PATH library_path, PATH modelicasystem_path);\n",
                                    "\n",
                                    "// functions implemented in this file\n",
                                    "extern \"C\"  int initSimulation(ISimController* &controller, ISimData* &data, double cycletime);\n",
                                    "extern \"C\"  int motionTriggered(ISimController* &controller, ISimData* &data);\n",
                                    "extern \"C\"  void runSimulation(void);\n",
                                    "extern \"C\"  int getMotionCycle(double &cycletime);\n",
                                    "\n",
                                    "// Structs\n"
                                }, true));
        txt = mlpiStructs(txt, i_simCode);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "extern \"C\"  int getMotionCycle(double &cycletime)\n",
                                    "{\n",
                                    "  MLPIHANDLE connection = MLPI_INVALIDHANDLE;\n",
                                    "  MLPIRESULT result;\n",
                                    "  ULONG cycletime_us = 0;\n",
                                    "\n",
                                    "   result = mlpiApiConnect(MLPI_LOCALHOST, &connection); // replace localhost with control IP to connect to another control\n",
                                    "  if (MLPI_FAILED(result))\n",
                                    "  {\n",
                                    "    printf(\"\\nERROR: failed to connect to MLPI. ErrorCode: 0x%08x\", (unsigned) result);\n",
                                    "    return result;\n",
                                    "  }\n",
                                    "\n",
                                    "  result = mlpiParameterReadDataUlong(connection, 0, MLPI_SIDN_C(400), &cycletime_us);\n",
                                    "  if (MLPI_FAILED(result))\n",
                                    "  {\n",
                                    "    printf(\"\\nERROR: failed to connect to MLPI. ErrorCode: 0x%08x\", (unsigned) result);\n",
                                    "    return result;\n",
                                    "  }\n",
                                    "\n",
                                    "  // Convert mu_s to s\n",
                                    "  cycletime = (double)cycletime_us/(1e6);\n",
                                    "\n",
                                    "  result = mlpiApiDisconnect(&connection);\n",
                                    "  {\n",
                                    "    return result;\n",
                                    "  }\n",
                                    "  return 0;\n",
                                    "}\n",
                                    "\n",
                                    "extern \"C\"  void debugSimulation(void)\n",
                                    "{\n",
                                    "  timespec delay;\n",
                                    "  delay.tv_sec =  0;\n",
                                    "  delay.tv_nsec = 10000000;\n",
                                    "  ISimController* simController;\n",
                                    "  ISimData* simData;\n",
                                    "  double cycletime;\n",
                                    "  getMotionCycle(cycletime);\n",
                                    "\n",
                                    "  initSimulation(simController, simData, 0.004);\n",
                                    "  while(true)\n",
                                    "  {\n",
                                    "    try\n",
                                    "    {\n",
                                    "      nanosleep( &delay ,NULL);\n",
                                    "      wvEvent(1,NULL,0);\n",
                                    "      simController->calcOneStep();\n",
                                    "      wvEvent(2,NULL,0);\n",
                                    "    }\n",
                                    "    catch(ModelicaSimulationError& ex)\n",
                                    "    {\n",
                                    "      break;\n",
                                    "    }\n",
                                    "  }\n",
                                    "  delete simController;\n",
                                    "\n",
                                    "}\n",
                                    "\n",
                                    "extern \"C\"  void runSimulation(void)\n",
                                    "{\n",
                                    "  timespec delay;\n",
                                    "  delay.tv_sec =  1;\n",
                                    "  delay.tv_nsec = 0;\n",
                                    "  nanosleep( &delay ,NULL);\n",
                                    "  // Enable Telnet and Floatingpoint Unit\n",
                                    "  enableTelnetPrintf();\n",
                                    "  enableFpuSupport();\n",
                                    "\n",
                                    "  ISimController* simController;\n",
                                    "  ISimData* simData;\n",
                                    "\n",
                                    "  double cycletime;\n",
                                    "  getMotionCycle(cycletime);\n",
                                    "\n",
                                    "  initSimulation(simController, simData, cycletime);\n",
                                    "  motionTriggered(simController, simData);\n",
                                    "\n",
                                    "  delete simController;\n",
                                    "}\n",
                                    "\n",
                                    "extern \"C\"  void spawnTask(void)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("taskSpawn(\""));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\",    // name of task\n",
                                    "          200,                                      // priority of task\n",
                                    "          VX_FP_TASK,                               // options (executes with the floating-point coprocessor)\n",
                                    "          0x200000,                                 // stacksize\n",
                                    "          (FUNCPTR)& runSimulation,                 // entry point (function)\n",
                                    "          0,                                        // arguments 1\n",
                                    "          0,                                        // arguments 2\n",
                                    "          0,                                        // arguments 3\n",
                                    "          0,                                        // arguments 4\n",
                                    "          0,                                        // arguments 5\n",
                                    "          0,                                        // arguments 6\n",
                                    "          0,                                        // arguments 7\n",
                                    "          0,                                        // arguments 8\n",
                                    "          0,                                        // arguments 9\n",
                                    "          0);                                       // arguments 10\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n",
                                    "\n",
                                    "extern \"C\"  int initSimulation(ISimController* &controller, ISimData* &data, double cycletime)\n",
                                    "{\n",
                                    "  MLPIHANDLE connection = MLPI_INVALIDHANDLE;\n",
                                    "  MLPIRESULT result;\n",
                                    "\n",
                                    "  // connect to API\n",
                                    "  result = mlpiApiConnect(MLPI_LOCALHOST, &connection); // replace localhost with control IP to connect to another control\n",
                                    "  if (MLPI_FAILED(result))\n",
                                    "  {\n",
                                    "    printf(\"\\nERROR: failed to connect to MLPI. ErrorCode: 0x%08x\", (unsigned) result);\n",
                                    "    return result;\n",
                                    "  }\n",
                                    "\n",
                                    "\n",
                                    "  /*\n",
                                    "  =============================================================================================================\n",
                                    "  ==                 Initialization of SimCore\n",
                                    "  =============================================================================================================\n",
                                    "  */\n",
                                    "  wvEvent(0,NULL,0);\n",
                                    "  printf(\"runSimulation started\");\n",
                                    "\n",
                                    "  PATH libraries_path = \"\";\n",
                                    "  PATH modelicaSystem_path = \"\";\n",
                                    "  shared_ptr<VxWorksFactory> factory = shared_ptr<VxWorksFactory>(new VxWorksFactory(libraries_path, modelicaSystem_path));\n",
                                    "  ISimController* sim_controller = createSimController(libraries_path, modelicaSystem_path);\n",
                                    "  shared_ptr<ISimObjects> simObjects= sim_controller->getSimObjects();\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("weak_ptr<ISimData> simData = simObjects->LoadSimData(\""));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\");\n",
                                    "weak_ptr<ISimVars> simVars = simObjects->LoadSimVars(\""
                                }, false));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\","));
        txt = Tpl.writeStr(txt, a_numRealVars);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeStr(txt, a_numIntVars);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeStr(txt, a_numBoolVars);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeStr(txt, a_numStringVars);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeStr(txt, a_numPreVars);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = numStatevars(txt, i_modelInfo);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = numStateVarIndex(txt, i_modelInfo);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ");\n",
                                    "weak_ptr<IMixedSystem> system = sim_controller->LoadSystem(\""
                                }, false));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\",\""));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\");\n",
                                    "shared_ptr<ISimData> simData_shared = simData.lock();\n",
                                    "\n",
                                    "// Declare Input specify initial_values if needed!!!\n"
                                }, true));
        txt = defineInputVars(txt, i_simCode);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "// Declare Output\n"
                                }, true));
        txt = defineOutputVars(txt, i_simCode);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "LogSettings logsetting;\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("SimSettings settings = {\"RTEuler\",\"\",\"newton\",        0.0,      100.0,  cycletime,      0.0025,      10.0,         0.0001, \""));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("\",0,OPT_NONE, logsetting};\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "//                       Solver,          nonlinearsolver starttime endtime stepsize   lower limit upper limit  tolerance\n",
                                    "try\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("sim_controller->StartVxWorks(settings, \""));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("\");\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "catch(ModelicaSimulationError& ex)\n",
                                    "{\n",
                                    "  string arg1 = string(\"Simulation failed for \") + settings.outputfile_name;\n",
                                    "  string arg2 = ex.what();//ex.what();\n",
                                    "  SIMULATION_ERROR arg3 = ex.getErrorID();\n",
                                    "  std::string error = add_error_info(arg1,arg2,arg3);\n",
                                    "  int lengthOfString = error.length();\n",
                                    "  lengthOfString = (int) (lengthOfString / 60 ) + 1;\n",
                                    "\n",
                                    "\n",
                                    "\n",
                                    "  for (int i = 0 ; i < lengthOfString ; i++ )\n",
                                    "  {\n",
                                    "    result = mlpiSystemSetDiagnosis(connection, MLPI_DIAGNOSIS_ERROR_FATAL, 1, A2W16( error.substr(0 + i * 60 ,60 + i * 60).c_str()) );\n",
                                    "  }\n",
                                    "  return -1;\n",
                                    "}\n",
                                    "\n",
                                    "printf(\"StartVxWorks finished\");\n",
                                    "wvEvent(1,NULL,0);\n",
                                    "data = simData_shared.get();\n",
                                    "controller = sim_controller;\n",
                                    "return 0;\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n",
                                    "extern \"C\" int motionTriggered(ISimController* &controller, ISimData* &data)\n",
                                    "{\n",
                                    "  MLPIHANDLE connection = MLPI_INVALIDHANDLE;\n",
                                    "\n",
                                    "  MLPIRESULT result;\n",
                                    "\n",
                                    "  // connect to API\n",
                                    "  result = mlpiApiConnect(MLPI_LOCALHOST, &connection); // replace localhost with control IP to connect to another control\n",
                                    "  if (MLPI_FAILED(result))\n",
                                    "  {\n",
                                    "    printf(\"\\nERROR: failed to connect to MLPI. ErrorCode: 0x%08x\", (unsigned) result);\n",
                                    "    return result;\n",
                                    "  }\n",
                                    "\n",
                                    "\n",
                                    "  //WCHAR16* application = L\"Application\";\n",
                                    "  //MlpiApplicationState state = MLPI_STATE_NONE;\n",
                                    "  //result = mlpiLogicGetStateOfApplication(connection, application, &state);\n",
                                    "\n",
                                    "  // Set Priority of Task\n",
                                    "  result = mlpiTaskSetCurrentPriority(connection,  MLPI_PRIORITY_HIGH_MAX);\n",
                                    "  if (MLPI_FAILED(result))\n",
                                    "  {\n",
                                    "    printf(\"\\ncall of MLPI function failed with 0x%08x!\", (unsigned)result);\n",
                                    "    return result;\n",
                                    "  }\n",
                                    "\n",
                                    "  MlpiSystemMode mode;\n",
                                    "  // run simulation\n",
                                    "  while(true)\n",
                                    "  {\n",
                                    "   // Wait for motion interrupt\n",
                                    "    result = mlpiTaskWaitForEvent(connection, MLPI_TASKEVENT_MOTION_CYCLE, MLPI_INFINITE);\n",
                                    "\n",
                                    "    //MLPIRESULT result = mlpiLogicGetStateOfApplication(connection, application, &state);\n",
                                    "\n",
                                    "    if (MLPI_FAILED(result))\n",
                                    "    {\n",
                                    "      printf(\"\\ncall of MLPI function failed with 0x%08x!\", (unsigned)result);\n",
                                    "      return result;\n",
                                    "    }\n",
                                    "    // Get Current Mode of PLC\n",
                                    "    result = mlpiSystemGetCurrentMode(connection, &mode);\n",
                                    "    if (MLPI_FAILED(result))\n",
                                    "    {\n",
                                    "      printf(\"\\ncall of MLPI function failed with 0x%08x!\", (unsigned)result);\n",
                                    "      return result;\n",
                                    "    }\n",
                                    "    //if(state == MLPI_STATE_STOP)\n",
                                    "    //{\n",
                                    "    //  break;\n",
                                    "    //}\n",
                                    "\n",
                                    "    //if(mode == MLPI_SYSTEMMODE_BB) //\n",
                                    "    //{\n",
                                    "      //Write input\n",
                                    "      /* do something with the inputs!*/\n",
                                    "      /*\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(6));
        txt = setInputVars(txt, i_simCode);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "*/\n",
                                    "try\n",
                                    "{\n",
                                    "  controller->calcOneStep();\n",
                                    "}\n",
                                    "catch(ModelicaSimulationError& ex)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("string arg1 = string(\"Simulation failed for \") + \""));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\";\n",
                                    "string arg2 = ex.what();//ex.what();\n",
                                    "SIMULATION_ERROR arg3 = ex.getErrorID();\n",
                                    "std::string error = add_error_info(arg1,arg2,arg3);\n",
                                    "\n",
                                    "int lengthOfString = error.length();\n",
                                    "lengthOfString = (int) (lengthOfString / 60 ) + 1;\n",
                                    "\n",
                                    "for (int i = 0 ; i < lengthOfString ; i++ )\n",
                                    "{\n",
                                    "  result = mlpiSystemSetDiagnosis(connection, MLPI_DIAGNOSIS_ERROR_FATAL, 1, A2W16( error.substr(0 + i * 60 ,60 + i * 60).c_str()) );\n",
                                    "}\n",
                                    "return -1;\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "//Write output\n"
                                }, true));
        txt = getOutputVars(txt, i_simCode);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "    //}\n",
                                    "  }\n",
                                    "\n",
                                    "  result = mlpiApiDisconnect(&connection);\n",
                                    "  {\n",
                                    "    return result;\n",
                                    "  }\n",
                                    "\n",
                                    "  return 0;\n",
                                    "}\n",
                                    "\n",
                                    "extern \"C\" void "
                                }, false));
        txt = Tpl.writeText(txt, l_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("__Main("));
        txt = Tpl.writeText(txt, l_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_Main_struct* p)\n",
                                    "{\n",
                                    "\n",
                                    "  if (p->instance->controller != NULL)\n",
                                    "  {\n",
                                    "\n",
                                    "    // Eingangswerte aus IndraWorks FB lesen\n",
                                    "\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = setMainFBInputVars(txt, i_simCode);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "\n",
                                    "// Berechnung eines Controllersteps\n",
                                    "\n",
                                    "try\n",
                                    "{\n",
                                    "  p->instance->controller->calcOneStep();\n",
                                    "}\n",
                                    "catch(ModelicaSimulationError& ex)\n",
                                    "{\n",
                                    "  MLPIHANDLE connection;\n",
                                    "  MLPIRESULT result = mlpiApiConnect(MLPI_LOCALHOST, &connection); // replace localhost with control IP to connect to another control\n",
                                    "  if (MLPI_FAILED(result))\n",
                                    "  {\n",
                                    "    printf(\"\\nERROR: failed to connect to MLPI. ErrorCode: 0x%08x\", (unsigned) result);\n",
                                    "  }\n",
                                    "\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("string arg1 = string(\"Simulation failed for \") + \""));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\";\n",
                                    "string arg2 = ex.what();//ex.what();\n",
                                    "SIMULATION_ERROR arg3 = ex.getErrorID();\n",
                                    "std::string error = add_error_info(arg1,arg2,arg3);\n",
                                    "\n",
                                    "int lengthOfString = error.length();\n",
                                    "lengthOfString = (int) (lengthOfString / 60 ) + 1;\n",
                                    "\n",
                                    "for (int i = 0 ; i < lengthOfString ; i++ )\n",
                                    "{\n",
                                    "  MLPIRESULT result = mlpiSystemSetDiagnosis(connection, MLPI_DIAGNOSIS_ERROR_FATAL, 1, A2W16( error.substr(0 + i * 60 ,60 + i * 60).c_str()) );\n",
                                    "}\n",
                                    "result = mlpiApiDisconnect(&connection);\n",
                                    "p->instance->bErrorOccured = TRUE;\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n"
                                }, true));
        txt = setMainFBOutputVars(txt, i_simCode);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "  }\n",
                                    "\n",
                                    "}\n",
                                    "\n",
                                    "extern \"C\" void "
                                }, false));
        txt = Tpl.writeText(txt, l_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("__FB_Init("));
        txt = Tpl.writeText(txt, l_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_FB_Init_struct* p)\n",
                                    "{\n",
                                    "  p->instance->bErrorOccured = FALSE;\n",
                                    "  ISimController* simController;\n",
                                    "  ISimData* simData;\n",
                                    "\n",
                                    "  //double cycletime = p->instance->cycletime;\n",
                                    "  double cycletime;\n",
                                    "  getMotionCycle(cycletime);\n",
                                    "  int result = initSimulation(simController, simData, cycletime);\n",
                                    "  if (result < 0)\n",
                                    "  {\n",
                                    "    p->instance->bErrorOccured = TRUE;\n",
                                    "  }\n",
                                    "\n",
                                    "  p->instance->simdata = simData;\n",
                                    "  p->instance->controller = simController;\n",
                                    "  p->instance->bAlreadyInitialized = TRUE;\n",
                                    "  p->FB_Init = TRUE;\n",
                                    "}\n",
                                    "\n",
                                    "extern \"C\" void "
                                }, false));
        txt = Tpl.writeText(txt, l_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("__FB_Reinit("));
        txt = Tpl.writeText(txt, l_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_FB_Reinit_struct* p)\n",
                                    "{\n",
                                    "}\n",
                                    "\n",
                                    "extern \"C\" void "
                                }, false));
        txt = Tpl.writeText(txt, l_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("__FB_Exit("));
        txt = Tpl.writeText(txt, l_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_FB_Exit_struct* p)\n",
                                    "{\n",
                                    "  if (p->instance->controller)\n",
                                    "  {\n",
                                    "    delete p->instance->controller;\n",
                                    "  }\n",
                                    "}\n",
                                    "\n",
                                    "\n",
                                    "BUNDLE_INFO_BEGIN(com_boschrexroth_"
                                }, false));
        txt = Tpl.writeText(txt, l_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ")\n",
                                    "BUNDLE_INFO_NAME (L\"LoadLibraries_Bundle\")\n",
                                    "BUNDLE_INFO_VENDOR (L\"Bosch Rexroth AG\")\n",
                                    "BUNDLE_INFO_DESCRIPTION (L\"Load Libraries of SimCore Bundle\")\n",
                                    "BUNDLE_INFO_VERSION (1,0,0,0,L\"Release 20140114\")\n",
                                    "BUNDLE_INFO_END(com_boschrexroth_"
                                }, false));
        txt = Tpl.writeText(txt, l_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ")\n",
                                    "\n",
                                    "BUNDLE_EXPORT int com_boschrexroth_"
                                }, false));
        txt = Tpl.writeText(txt, l_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_create(int param1, int param2, int param3)\n",
                                    "{\n",
                                    "\n",
                                    "  MLPIHANDLE connection = MLPI_INVALIDHANDLE;\n",
                                    "\n",
                                    "  // connect to API\n",
                                    "  MLPIRESULT resultconnect = mlpiApiConnect(MLPI_LOCALHOST, &connection); // replace localhost with control IP to connect to another control\n",
                                    "  if (MLPI_FAILED(resultconnect))\n",
                                    "  {\n",
                                    "    printf(\"\\nERROR: failed to connect to MLPI. ErrorCode: 0x%08x\", (unsigned) resultconnect);\n",
                                    "    return resultconnect;\n",
                                    "  }\n",
                                    "\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("WCHAR16 name[MLPI_APPLICATION_MAX_LENGTH_OF_POU_NAME] = L\""));
        txt = Tpl.writeText(txt, l_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "__Main\";\n",
                                    "MLPIPOUFNCPTR function = (MLPIPOUFNCPTR) "
                                }, false));
        txt = Tpl.writeText(txt, l_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "__Main;\n",
                                    "MLPIRESULT result = mlpiLogicPouExtensionRegister(connection, name, function);\n",
                                    "if(MLPI_SUCCEEDED(result))\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("wcscpy16(name, L\""));
        txt = Tpl.writeText(txt, l_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "__FB_Init\");\n",
                                    "function = (MLPIPOUFNCPTR) "
                                }, false));
        txt = Tpl.writeText(txt, l_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "__FB_Init;\n",
                                    "result = mlpiLogicPouExtensionRegister(connection, name, function);\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "if(MLPI_SUCCEEDED(result))\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("wcscpy16(name, L\""));
        txt = Tpl.writeText(txt, l_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "__FB_Reinit\");\n",
                                    "function = (MLPIPOUFNCPTR) "
                                }, false));
        txt = Tpl.writeText(txt, l_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "__FB_Reinit;\n",
                                    "result = mlpiLogicPouExtensionRegister(connection, name, function);\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "if(MLPI_SUCCEEDED(result))\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("wcscpy16(name, L\""));
        txt = Tpl.writeText(txt, l_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "__FB_Exit\");\n",
                                    "function = (MLPIPOUFNCPTR) "
                                }, false));
        txt = Tpl.writeText(txt, l_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "__FB_Exit;\n",
                                    "result = mlpiLogicPouExtensionRegister(connection, name, function);\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("}\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "mlpiApiDisconnect(&connection);\n",
                                    "\n",
                                    "printf(\"\\n###################################################################\");\n",
                                    "printf(\"\\n## onCreate #######################################################\");\n",
                                    "printf(\"\\n###################################################################\");\n",
                                    "return 0;\n",
                                    "}\n",
                                    "\n",
                                    "BUNDLE_EXPORT int com_boschrexroth_"
                                }, false));
        txt = Tpl.writeText(txt, l_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_start(int param1, int param2, int param3)\n",
                                    "{\n",
                                    "//spawnTask();\n",
                                    "printf(\"\\n###################################################################\");\n",
                                    "printf(\"\\n## onStart ########################################################\");\n",
                                    "printf(\"\\n###################################################################\");\n",
                                    "return 0;\n",
                                    "}\n",
                                    "\n",
                                    "BUNDLE_EXPORT int com_boschrexroth_"
                                }, false));
        txt = Tpl.writeText(txt, l_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_stop(int param1, int param2, int param3)\n",
                                    "{\n",
                                    "printf(\"\\n###################################################################\");\n",
                                    "printf(\"\\n## onStop #########################################################\");\n",
                                    "printf(\"\\n###################################################################\");\n",
                                    "return 0;\n",
                                    "}\n",
                                    "\n",
                                    "BUNDLE_EXPORT int com_boschrexroth_"
                                }, false));
        txt = Tpl.writeText(txt, l_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_destroy(int param1, int param2, int param3)\n",
                                    "{\n",
                                    "printf(\"\\n###################################################################\");\n",
                                    "printf(\"\\n## onDestroy ######################################################\");\n",
                                    "printf(\"\\n###################################################################\");\n",
                                    "return 0;\n",
                                    "}"
                                }, false));
      then txt;

    case ( txt,
           _,
           _,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_224;

protected function fun_225
  input Tpl.Text in_txt;
  input String in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           "none" )
      then txt;

    case ( txt,
           "all_perf" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "#ifdef USE_SCOREP\n",
                                    "  #include <Core/Utils/extension/measure_time_scorep.hpp>\n",
                                    "#else\n",
                                    "  #include <Core/Utils/extension/measure_time_papi.hpp>\n",
                                    "#endif"
                                }, false));
      then txt;

    case ( txt,
           "all_stat" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "#ifdef USE_SCOREP\n",
                                    "  #include <Core/Utils/extension/measure_time_scorep.hpp>\n",
                                    "#else\n",
                                    "  #include <Core/Utils/extension/measure_time_statistic.hpp>\n",
                                    "#endif"
                                }, false));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "#ifdef USE_SCOREP\n",
                                    "  #include <Core/Utils/extension/measure_time_scorep.hpp>\n",
                                    "#else\n",
                                    "  #include <Core/Utils/extension/measure_time_rdtsc.hpp>\n",
                                    "#endif"
                                }, false));
      then txt;
  end match;
end fun_225;

protected function fun_226
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;
      Integer ret_0;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("1"));
      then txt;

    case ( txt,
           _ )
      equation
        ret_0 = Flags.getConfigInt(Flags.NUM_PROC);
        txt = Tpl.writeStr(txt, intString(ret_0));
      then txt;
  end match;
end fun_226;

protected function fun_227
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("opts[\"-O\"] = \"none\";"));
      then txt;
  end match;
end fun_227;

protected function fun_228
  input Tpl.Text in_txt;
  input String in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           "none" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("//no profiling used"));
      then txt;

    case ( txt,
           "all_perf" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "#ifdef USE_SCOREP\n",
                                    "  MeasureTimeScoreP::initialize();\n",
                                    "#else\n",
                                    "  MeasureTimePAPI::initialize(getThreadNumber);\n",
                                    "#endif"
                                }, false));
      then txt;

    case ( txt,
           "all_stat" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " #ifdef USE_SCOREP\n",
                                    "   MeasureTimeScoreP::initialize();\n",
                                    " #else\n",
                                    "   MeasureTimeStatistic::initialize();\n",
                                    " #endif"
                                }, false));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "#ifdef USE_SCOREP\n",
                                    "  MeasureTimeScoreP::initialize();\n",
                                    "#else\n",
                                    "  MeasureTimeRDTSC::initialize();\n",
                                    "#endif"
                                }, false));
      then txt;
  end match;
end fun_228;

protected function fun_229
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Absyn.Path in_a_modelInfo_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_modelInfo_name)
    local
      Tpl.Text txt;
      Absyn.Path a_modelInfo_name;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_modelInfo_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "std::vector<MeasureTimeData*> *measureTimeArraySimulation = new std::vector<MeasureTimeData*>(size_t(2), NULL); //0 all, 1 setup\n",
                                    "(*measureTimeArraySimulation)[0] = new MeasureTimeData(\"all\");\n",
                                    "(*measureTimeArraySimulation)[1] = new MeasureTimeData(\"setup\");\n",
                                    "MeasureTimeValues *measuredSimStartValues, *measuredSimEndValues, *measuredSetupStartValues, *measuredSetupEndValues;\n",
                                    "\n",
                                    "MeasureTime::addResultContentBlock(\""
                                }, false));
        txt = dotPath(txt, a_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\",\"main\",measureTimeArraySimulation);\n",
                                    "\n",
                                    "measuredSimStartValues = MeasureTime::getZeroValues();\n",
                                    "measuredSimEndValues = MeasureTime::getZeroValues();\n",
                                    "measuredSetupStartValues = MeasureTime::getZeroValues();\n",
                                    "measuredSetupEndValues = MeasureTime::getZeroValues();\n",
                                    "\n"
                                }, true));
        txt = generateMeasureTimeStartCode(txt, "measuredSimStartValues", "all", "");
        txt = Tpl.softNewLine(txt);
        txt = generateMeasureTimeStartCode(txt, "measuredSetupStartValues", "setup", "");
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;
  end match;
end fun_229;

protected function fun_230
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = generateMeasureTimeEndCode(txt, "measuredSetupStartValues", "measuredSetupEndValues", "(*measureTimeArraySimulation)[1]", "setup", "");
      then txt;
  end match;
end fun_230;

protected function fun_231
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Absyn.Path in_a_modelInfo_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_modelInfo_name)
    local
      Tpl.Text txt;
      Absyn.Path a_modelInfo_name;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           false,
           a_modelInfo_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("simulation.first->Start(simulation.second, \""));
        txt = lastIdentOfPath(txt, a_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\");"));
      then txt;

    case ( txt,
           _,
           a_modelInfo_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("simulation.first->StartReduceDAE(simulation.second,\""));
        txt = identOfPathDot(txt, a_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\", \""));
        txt = lastIdentOfPath(txt, a_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\", "));
        ret_0 = Flags.getConfigBool(Flags.LOAD_MSL_MODEL);
        txt = Tpl.writeStr(txt, Tpl.booleanString(ret_0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        ret_1 = Flags.getConfigBool(Flags.Load_PACKAGE_FILE);
        txt = Tpl.writeStr(txt, Tpl.booleanString(ret_1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;
  end match;
end fun_231;

protected function fun_232
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = generateMeasureTimeEndCode(txt, "measuredSimStartValues", "measuredSimEndValues", "(*measureTimeArraySimulation)[0]", "all", "");
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "MeasureTime::getInstance()->writeToJson();\n",
                                    "MeasureTime::deinitialize();\n",
                                    "\n",
                                    "delete measuredSimStartValues;\n",
                                    "delete measuredSimEndValues;\n",
                                    "delete measuredSetupStartValues;\n",
                                    "delete measuredSetupEndValues;"
                                }, false));
      then txt;
  end match;
end fun_232;

protected function fun_233
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input String in_a_numPreVars;
  input String in_a_numStringVars;
  input String in_a_numBoolVars;
  input String in_a_numIntVars;
  input String in_a_numRealVars;
  input String in_a_additionalPreRunCommands;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input String in_a_additionalIncludes;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_a_simCode, in_a_numPreVars, in_a_numStringVars, in_a_numBoolVars, in_a_numIntVars, in_a_numRealVars, in_a_additionalPreRunCommands, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_additionalIncludes)
    local
      Tpl.Text txt;
      String a_numPreVars;
      String a_numStringVars;
      String a_numBoolVars;
      String a_numIntVars;
      String a_numRealVars;
      String a_additionalPreRunCommands;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      String a_additionalIncludes;
      String i_makefileParams_dllext;
      SimCode.ModelInfo i_modelInfo;
      Absyn.Path i_modelInfo_name;
      SimCode.SimCode i_simCode;
      String i_fileNamePrefix;
      String i_settings_outputFormat;
      String i_makefileParams_omhome;
      String i_makefileParams_compileDir;
      String i_settings_method;
      Real i_settings_tolerance;
      Integer i_settings_numberOfIntervals;
      Real i_settings_stepSize;
      Real i_settings_stopTime;
      Real i_settings_startTime;
      Boolean ret_26;
      Boolean ret_25;
      String ret_24;
      Boolean ret_23;
      Boolean ret_22;
      Boolean ret_21;
      String ret_20;
      Boolean ret_19;
      Boolean ret_18;
      String ret_17;
      String ret_16;
      Boolean ret_15;
      Boolean ret_14;
      Integer ret_13;
      Boolean ret_12;
      String ret_11;
      String ret_10;
      Tpl.Text l_outputtype;
      Tpl.Text l_includeMeasure;
      Tpl.Text l_home;
      Tpl.Text l_moLib;
      Tpl.Text l_solver;
      Tpl.Text l_tol;
      Tpl.Text l_intervals;
      Tpl.Text l_stepsize;
      Tpl.Text l_end;
      Tpl.Text l_start;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = (i_modelInfo as SimCode.MODELINFO(name = i_modelInfo_name)), makefileParams = SimCodeFunction.MAKEFILE_PARAMS(compileDir = i_makefileParams_compileDir, omhome = i_makefileParams_omhome, dllext = i_makefileParams_dllext), simulationSettingsOpt = SOME(SimCode.SIMULATION_SETTINGS(startTime = i_settings_startTime, stopTime = i_settings_stopTime, stepSize = i_settings_stepSize, numberOfIntervals = i_settings_numberOfIntervals, tolerance = i_settings_tolerance, method = i_settings_method, outputFormat = i_settings_outputFormat)), fileNamePrefix = i_fileNamePrefix)),
           a_numPreVars,
           a_numStringVars,
           a_numBoolVars,
           a_numIntVars,
           a_numRealVars,
           a_additionalPreRunCommands,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_additionalIncludes )
      equation
        l_start = Tpl.writeStr(Tpl.emptyTxt, realString(i_settings_startTime));
        l_end = Tpl.writeStr(Tpl.emptyTxt, realString(i_settings_stopTime));
        l_stepsize = Tpl.writeStr(Tpl.emptyTxt, realString(i_settings_stepSize));
        l_intervals = Tpl.writeStr(Tpl.emptyTxt, intString(i_settings_numberOfIntervals));
        l_tol = Tpl.writeStr(Tpl.emptyTxt, realString(i_settings_tolerance));
        l_solver = Tpl.writeStr(Tpl.emptyTxt, i_settings_method);
        l_moLib = Tpl.writeStr(Tpl.emptyTxt, i_makefileParams_compileDir);
        l_home = Tpl.writeStr(Tpl.emptyTxt, i_makefileParams_omhome);
        l_includeMeasure = Tpl.emptyTxt;
        l_outputtype = Tpl.writeStr(Tpl.emptyTxt, i_settings_outputFormat);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "#include <Core/ModelicaDefine.h>\n",
                                    "#include <Core/Modelica.h>\n",
                                    "#include <Core/SimController/ISimController.h>\n",
                                    "#include <Core/System/FactoryExport.h>\n",
                                    "#include <Core/Utils/extension/logger.hpp>\n",
                                    "\n"
                                }, true));
        ret_10 = Flags.getConfigString(Flags.PROFILING_LEVEL);
        txt = fun_225(txt, ret_10);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeStr(txt, a_additionalIncludes);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("#ifdef RUNTIME_STATIC_LINKING\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#include \"OMCpp"));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "CalcHelperMain.cpp\"\n",
                                    "#include <SimCoreFactory/OMCFactory/StaticOMCFactory.h>\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "#endif\n",
                                    "\n",
                                    "#ifdef USE_BOOST_THREAD\n",
                                    "  #include <boost/thread.hpp>\n",
                                    "  static long unsigned int getThreadNumber()\n",
                                    "  {\n",
                                    "     boost::hash<std::string> string_hash;\n",
                                    "     return (long unsigned int)string_hash(boost::lexical_cast<std::string>(boost::this_thread::get_id()));\n",
                                    "  }\n",
                                    "#else\n",
                                    "  static long unsigned int getThreadNumber()\n",
                                    "  {\n",
                                    "     return 0;\n",
                                    "  }\n",
                                    "#endif\n",
                                    "\n",
                                    "#if defined(_MSC_VER) || defined(__MINGW32__)\n",
                                    "#include <tchar.h>\n",
                                    "int _tmain(int argc, const _TCHAR* argv[])\n",
                                    "#else\n",
                                    "int main(int argc, const char* argv[])\n",
                                    "#endif\n",
                                    "{\n",
                                    "    // default program options\n",
                                    "    std::map<std::string, std::string> opts;\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("opts[\"-S\"] = \""));
        txt = Tpl.writeText(txt, l_start);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\";\n",
                                    "opts[\"-E\"] = \""
                                }, false));
        txt = Tpl.writeText(txt, l_end);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\";\n",
                                    "opts[\"-H\"] = \""
                                }, false));
        txt = Tpl.writeText(txt, l_stepsize);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\";\n",
                                    "opts[\"-G\"] = \""
                                }, false));
        txt = Tpl.writeText(txt, l_intervals);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\";\n",
                                    "opts[\"-T\"] = \""
                                }, false));
        txt = Tpl.writeText(txt, l_tol);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\";\n",
                                    "opts[\"-I\"] = \""
                                }, false));
        txt = Tpl.writeText(txt, l_solver);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\";\n",
                                    "opts[\"-P\"] = \""
                                }, false));
        txt = Tpl.writeText(txt, l_outputtype);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\";\n",
                                    "opts[\"-R\"] = \""
                                }, false));
        ret_11 = Config.simulationCodeTarget();
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = simulationLibDir(txt, ret_11, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\";\n",
                                    "opts[\"-M\"] = \""
                                }, false));
        txt = Tpl.writeText(txt, l_moLib);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\";\n",
                                    "opts[\"-F\"] = \""
                                }, false));
        ret_12 = Testsuite.isRunning();
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = simulationResults(txt, ret_12, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\";\n",
                                    "opts[\"--solver-threads\"] = \""
                                }, false));
        ret_13 = Flags.getConfigInt(Flags.NUM_PROC);
        ret_14 = intGt(ret_13, 0);
        txt = fun_226(txt, ret_14);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("\";\n"));
        ret_15 = stringEq(i_settings_outputFormat, "empty");
        txt = fun_227(txt, ret_15);
        txt = Tpl.softNewLine(txt);
        ret_16 = Flags.getConfigString(Flags.PROFILING_LEVEL);
        txt = fun_228(txt, ret_16);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "try\n",
                                    "{\n",
                                    "      Logger::initialize();\n",
                                    "      Logger::setEnabled(true);\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(6));
        ret_17 = Flags.getConfigString(Flags.PROFILING_LEVEL);
        ret_18 = stringEq(ret_17, "none");
        ret_19 = boolNot(ret_18);
        txt = fun_229(txt, ret_19, i_modelInfo_name);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeStr(txt, a_additionalPreRunCommands);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "#ifdef RUNTIME_STATIC_LINKING\n",
                                    "  shared_ptr<StaticOMCFactory>  _factory =  shared_ptr<StaticOMCFactory>(new StaticOMCFactory());\n",
                                    "#else\n",
                                    "  shared_ptr<OMCFactory>  _factory =  shared_ptr<OMCFactory>(new OMCFactory());\n",
                                    "#endif //RUNTIME_STATIC_LINKING\n",
                                    "//SimController to start simulation\n",
                                    "\n",
                                    "std::pair<shared_ptr<ISimController>, SimSettings> simulation = _factory->createSimulation(argc, argv, opts);\n",
                                    "\n",
                                    "//create Modelica system\n",
                                    "shared_ptr<ISimObjects> simObjects= simulation.first->getSimObjects();\n",
                                    "weak_ptr<ISimData> simData = simObjects->LoadSimData(\""
                                }, false));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\");\n",
                                    "weak_ptr<ISimVars> simVars = simObjects->LoadSimVars(\""
                                }, false));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\","));
        txt = Tpl.writeStr(txt, a_numRealVars);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeStr(txt, a_numIntVars);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeStr(txt, a_numBoolVars);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeStr(txt, a_numStringVars);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeStr(txt, a_numPreVars);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = numStatevars(txt, i_modelInfo);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = numStateVarIndex(txt, i_modelInfo);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ");\n",
                                    "weak_ptr<IMixedSystem> system = simulation.first->LoadSystem(\"OMCpp"
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeStr(txt, i_makefileParams_dllext);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\",\""));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("\");\n"));
        ret_20 = Flags.getConfigString(Flags.PROFILING_LEVEL);
        ret_21 = stringEq(ret_20, "none");
        ret_22 = boolNot(ret_21);
        txt = fun_230(txt, ret_22);
        txt = Tpl.softNewLine(txt);
        ret_23 = Flags.getConfigBool(Flags.LABELED_REDUCTION);
        txt = fun_231(txt, ret_23, i_modelInfo_name);
        txt = Tpl.softNewLine(txt);
        ret_24 = Flags.getConfigString(Flags.PROFILING_LEVEL);
        ret_25 = stringEq(ret_24, "none");
        ret_26 = boolNot(ret_25);
        txt = fun_232(txt, ret_26);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "Logger::finalize();\n",
                                    "return 0;\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "catch(ModelicaSimulationError& ex)\n",
                                    "{\n",
                                    "    if(!ex.isSuppressed())\n",
                                    "        std::cerr << \"Simulation stopped with error in \" << error_id_string(ex.getErrorID()) << \": \"  << ex.what();\n",
                                    "    Logger::finalize();\n",
                                    "    return 1;\n",
                                    "}\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           _,
           _,
           _,
           _,
           _,
           _,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_233;

protected function fun_234
  input Tpl.Text in_txt;
  input String in_a_target;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input String in_a_additionalIncludes;
  input String in_a_additionalPreRunCommands;
  input String in_a_numRealVars;
  input String in_a_numIntVars;
  input String in_a_numBoolVars;
  input String in_a_numStringVars;
  input String in_a_numPreVars;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace) :=
  match(in_txt, in_a_target, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_additionalIncludes, in_a_additionalPreRunCommands, in_a_numRealVars, in_a_numIntVars, in_a_numBoolVars, in_a_numStringVars, in_a_numPreVars)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      String a_additionalIncludes;
      String a_additionalPreRunCommands;
      String a_numRealVars;
      String a_numIntVars;
      String a_numBoolVars;
      String a_numStringVars;
      String a_numPreVars;

    case ( txt,
           "debugrt",
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           _,
           _,
           a_numRealVars,
           a_numIntVars,
           a_numBoolVars,
           a_numStringVars,
           a_numPreVars )
      equation
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_223(txt, a_simCode, a_numPreVars, a_numStringVars, a_numBoolVars, a_numIntVars, a_numRealVars, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);

    case ( txt,
           "vxworks69",
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           _,
           _,
           a_numRealVars,
           a_numIntVars,
           a_numBoolVars,
           a_numStringVars,
           a_numPreVars )
      equation
        txt = fun_224(txt, a_simCode, a_numPreVars, a_numStringVars, a_numBoolVars, a_numIntVars, a_numRealVars);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);

    case ( txt,
           _,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_additionalIncludes,
           a_additionalPreRunCommands,
           a_numRealVars,
           a_numIntVars,
           a_numBoolVars,
           a_numStringVars,
           a_numPreVars )
      equation
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_233(txt, a_simCode, a_numPreVars, a_numStringVars, a_numBoolVars, a_numIntVars, a_numRealVars, a_additionalPreRunCommands, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_additionalIncludes);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
  end match;
end fun_234;

public function simulationMainFile
  input Tpl.Text txt;
  input String a_target;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input String a_additionalIncludes;
  input String a_additionalPreRunCommands;
  input String a_additionalPostRunCommands;
  input String a_numRealVars;
  input String a_numIntVars;
  input String a_numBoolVars;
  input String a_numStringVars;
  input String a_numPreVars;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace) := fun_234(txt, a_target, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_additionalIncludes, a_additionalPreRunCommands, a_numRealVars, a_numIntVars, a_numBoolVars, a_numStringVars, a_numPreVars);
end simulationMainFile;

protected function lm_236
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      DAE.ComponentRef i_name;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(name = i_name) :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("shared_ptr<SimDouble> sim_value_in"));
        txt = CodegenCppCommonOld.cref(txt, i_name, false);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(new SimDouble(0.0)/*set start value here*/);\n",
                                    "simData_shared->Add(\""
                                }, false));
        txt = CodegenCppCommonOld.cref(txt, i_name, false);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\", sim_value_in"));
        txt = CodegenCppCommonOld.cref(txt, i_name, false);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
        txt = Tpl.nextIter(txt);
        txt = lm_236(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_236(txt, rest);
      then txt;
  end match;
end lm_236;

protected function fun_237
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> i_vars_inputVars;
      Tpl.Text l_inputnames;
      Tpl.Text l_optpreExp;
      Tpl.Text l_varOptDecls;

    case ( txt,
           SimCode.MODELINFO(varInfo = SimCode.VARINFO(numZeroCrossings = _), vars = SimCodeVar.SIMVARS(inputVars = i_vars_inputVars)) )
      equation
        l_varOptDecls = Tpl.emptyTxt;
        l_optpreExp = Tpl.emptyTxt;
        l_inputnames = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_inputnames = lm_236(l_inputnames, i_vars_inputVars);
        l_inputnames = Tpl.popIter(l_inputnames);
        txt = Tpl.writeText(txt, l_inputnames);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_237;

protected function fun_238
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      SimCode.ModelInfo i_modelInfo;

    case ( txt,
           SimCode.SIMCODE(modelInfo = i_modelInfo) )
      equation
        txt = fun_237(txt, i_modelInfo);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_238;

protected function fun_239
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      SimCode.SimCode i_simCode;
      Tpl.Text l_inputs;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = _))) )
      equation
        l_inputs = fun_238(Tpl.emptyTxt, i_simCode);
        txt = Tpl.writeText(txt, l_inputs);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_239;

public function defineInputVars
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_varDecls;
algorithm
  l_varDecls := Tpl.emptyTxt;
  out_txt := fun_239(txt, a_simCode);
end defineInputVars;

protected function lm_241
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      DAE.ComponentRef i_name;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(name = i_name) :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("dynamic_cast<SimDouble*>(data->Get(\""));
        txt = CodegenCppCommonOld.cref(txt, i_name, false);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\"))->getValue()   = //place variable here ;"));
        txt = Tpl.nextIter(txt);
        txt = lm_241(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_241(txt, rest);
      then txt;
  end match;
end lm_241;

protected function fun_242
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> i_vars_inputVars;
      Tpl.Text l_inputnames;
      Tpl.Text l_optpreExp;
      Tpl.Text l_varOptDecls;

    case ( txt,
           SimCode.MODELINFO(varInfo = SimCode.VARINFO(numZeroCrossings = _), vars = SimCodeVar.SIMVARS(inputVars = i_vars_inputVars)) )
      equation
        l_varOptDecls = Tpl.emptyTxt;
        l_optpreExp = Tpl.emptyTxt;
        l_inputnames = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_inputnames = lm_241(l_inputnames, i_vars_inputVars);
        l_inputnames = Tpl.popIter(l_inputnames);
        txt = Tpl.writeText(txt, l_inputnames);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_242;

protected function fun_243
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      SimCode.ModelInfo i_modelInfo;

    case ( txt,
           SimCode.SIMCODE(modelInfo = i_modelInfo) )
      equation
        txt = fun_242(txt, i_modelInfo);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_243;

protected function fun_244
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      SimCode.SimCode i_simCode;
      Tpl.Text l_inputs;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = _))) )
      equation
        l_inputs = fun_243(Tpl.emptyTxt, i_simCode);
        txt = Tpl.writeText(txt, l_inputs);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_244;

public function setInputVars
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_varDecls;
algorithm
  l_varDecls := Tpl.emptyTxt;
  out_txt := fun_244(txt, a_simCode);
end setInputVars;

protected function lm_246
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      DAE.ComponentRef i_name;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(name = i_name) :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("p->instance->"));
        txt = CodegenCppCommonOld.crefST(txt, i_name, false);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = dynamic_cast<SimDouble*>(p->instance->simdata->Get(\""));
        txt = CodegenCppCommonOld.cref(txt, i_name, false);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\"))->getValue();"));
        txt = Tpl.nextIter(txt);
        txt = lm_246(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_246(txt, rest);
      then txt;
  end match;
end lm_246;

protected function fun_247
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> i_vars_outputVars;
      Tpl.Text l_outputnames;
      Tpl.Text l_optpreExp;
      Tpl.Text l_varOptDecls;

    case ( txt,
           SimCode.MODELINFO(varInfo = SimCode.VARINFO(numZeroCrossings = _), vars = SimCodeVar.SIMVARS(outputVars = i_vars_outputVars)) )
      equation
        l_varOptDecls = Tpl.emptyTxt;
        l_optpreExp = Tpl.emptyTxt;
        l_outputnames = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_outputnames = lm_246(l_outputnames, i_vars_outputVars);
        l_outputnames = Tpl.popIter(l_outputnames);
        txt = Tpl.writeText(txt, l_outputnames);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_247;

protected function fun_248
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      SimCode.ModelInfo i_modelInfo;

    case ( txt,
           SimCode.SIMCODE(modelInfo = i_modelInfo) )
      equation
        txt = fun_247(txt, i_modelInfo);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_248;

protected function fun_249
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      SimCode.SimCode i_simCode;
      Tpl.Text l_outputs;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = _))) )
      equation
        l_outputs = fun_248(Tpl.emptyTxt, i_simCode);
        txt = Tpl.writeText(txt, l_outputs);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_249;

public function setMainFBOutputVars
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_varDecls;
algorithm
  l_varDecls := Tpl.emptyTxt;
  out_txt := fun_249(txt, a_simCode);
end setMainFBOutputVars;

protected function lm_251
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      DAE.ComponentRef i_name;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(name = i_name) :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("dynamic_cast<SimDouble*>(p->instance->simdata->Get(\""));
        txt = CodegenCppCommonOld.cref(txt, i_name, false);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\"))->getValue() = p->instance->"));
        txt = CodegenCppCommonOld.crefST(txt, i_name, false);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        txt = lm_251(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_251(txt, rest);
      then txt;
  end match;
end lm_251;

protected function fun_252
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> i_vars_inputVars;
      Tpl.Text l_inputnames;
      Tpl.Text l_optpreExp;
      Tpl.Text l_varOptDecls;

    case ( txt,
           SimCode.MODELINFO(varInfo = SimCode.VARINFO(numZeroCrossings = _), vars = SimCodeVar.SIMVARS(inputVars = i_vars_inputVars)) )
      equation
        l_varOptDecls = Tpl.emptyTxt;
        l_optpreExp = Tpl.emptyTxt;
        l_inputnames = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_inputnames = lm_251(l_inputnames, i_vars_inputVars);
        l_inputnames = Tpl.popIter(l_inputnames);
        txt = Tpl.writeText(txt, l_inputnames);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_252;

protected function fun_253
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      SimCode.ModelInfo i_modelInfo;

    case ( txt,
           SimCode.SIMCODE(modelInfo = i_modelInfo) )
      equation
        txt = fun_252(txt, i_modelInfo);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_253;

protected function fun_254
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      SimCode.SimCode i_simCode;
      Tpl.Text l_inputs;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = _))) )
      equation
        l_inputs = fun_253(Tpl.emptyTxt, i_simCode);
        txt = Tpl.writeText(txt, l_inputs);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_254;

public function setMainFBInputVars
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_varDecls;
algorithm
  l_varDecls := Tpl.emptyTxt;
  out_txt := fun_254(txt, a_simCode);
end setMainFBInputVars;

protected function lm_256
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      DAE.ComponentRef i_name;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(name = i_name) :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<variable name= \""));
        txt = CodegenCppCommonOld.crefST(txt, i_name, false);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\">\n",
                                    "<type>\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<"));
        txt = CodegenCppCommonOld.crefTypeST(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/>\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "</type>\n",
                                    "</variable>"
                                }, false));
        txt = Tpl.nextIter(txt);
        txt = lm_256(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_256(txt, rest);
      then txt;
  end match;
end lm_256;

protected function fun_257
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> i_vars_outputVars;
      Tpl.Text l_outputnames;
      Tpl.Text l_optpreExp;
      Tpl.Text l_varOptDecls;

    case ( txt,
           SimCode.MODELINFO(varInfo = SimCode.VARINFO(numZeroCrossings = _), vars = SimCodeVar.SIMVARS(outputVars = i_vars_outputVars)) )
      equation
        l_varOptDecls = Tpl.emptyTxt;
        l_optpreExp = Tpl.emptyTxt;
        l_outputnames = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_outputnames = lm_256(l_outputnames, i_vars_outputVars);
        l_outputnames = Tpl.popIter(l_outputnames);
        txt = Tpl.writeText(txt, l_outputnames);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_257;

protected function fun_258
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      SimCode.ModelInfo i_modelInfo;

    case ( txt,
           SimCode.SIMCODE(modelInfo = i_modelInfo) )
      equation
        txt = fun_257(txt, i_modelInfo);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_258;

protected function fun_259
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      SimCode.SimCode i_simCode;
      Tpl.Text l_outputs;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = _))) )
      equation
        l_outputs = fun_258(Tpl.emptyTxt, i_simCode);
        txt = Tpl.writeText(txt, l_outputs);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_259;

public function spsOutputVars
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_varDecls;
algorithm
  l_varDecls := Tpl.emptyTxt;
  out_txt := fun_259(txt, a_simCode);
end spsOutputVars;

protected function lm_261
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      DAE.ComponentRef i_name;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(name = i_name) :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<variable name= \""));
        txt = CodegenCppCommonOld.crefST(txt, i_name, false);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\">\n",
                                    "  <type>\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<"));
        txt = CodegenCppCommonOld.crefTypeST(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/>\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "  </type>\n",
                                    "</variable>"
                                }, false));
        txt = Tpl.nextIter(txt);
        txt = lm_261(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_261(txt, rest);
      then txt;
  end match;
end lm_261;

protected function fun_262
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> i_vars_inputVars;
      Tpl.Text l_inputnames;
      Tpl.Text l_optpreExp;
      Tpl.Text l_varOptDecls;

    case ( txt,
           SimCode.MODELINFO(varInfo = SimCode.VARINFO(numZeroCrossings = _), vars = SimCodeVar.SIMVARS(inputVars = i_vars_inputVars)) )
      equation
        l_varOptDecls = Tpl.emptyTxt;
        l_optpreExp = Tpl.emptyTxt;
        l_inputnames = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_inputnames = lm_261(l_inputnames, i_vars_inputVars);
        l_inputnames = Tpl.popIter(l_inputnames);
        txt = Tpl.writeText(txt, l_inputnames);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_262;

protected function fun_263
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      SimCode.ModelInfo i_modelInfo;

    case ( txt,
           SimCode.SIMCODE(modelInfo = i_modelInfo) )
      equation
        txt = fun_262(txt, i_modelInfo);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_263;

protected function fun_264
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      SimCode.SimCode i_simCode;
      Tpl.Text l_inputs;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = _))) )
      equation
        l_inputs = fun_263(Tpl.emptyTxt, i_simCode);
        txt = Tpl.writeText(txt, l_inputs);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_264;

public function spsInputVars
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_varDecls;
algorithm
  l_varDecls := Tpl.emptyTxt;
  out_txt := fun_264(txt, a_simCode);
end spsInputVars;

protected function lm_266
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      DAE.ComponentRef i_name;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(name = i_name) :: rest )
      equation
        txt = CodegenCppCommonOld.crefTypeMLPI(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = CodegenCppCommonOld.crefST(txt, i_name, false);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        txt = lm_266(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_266(txt, rest);
      then txt;
  end match;
end lm_266;

protected function fun_267
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> i_vars_outputVars;
      Tpl.Text l_outputnames;
      Tpl.Text l_optpreExp;
      Tpl.Text l_varOptDecls;

    case ( txt,
           SimCode.MODELINFO(varInfo = SimCode.VARINFO(numZeroCrossings = _), vars = SimCodeVar.SIMVARS(outputVars = i_vars_outputVars)) )
      equation
        l_varOptDecls = Tpl.emptyTxt;
        l_optpreExp = Tpl.emptyTxt;
        l_outputnames = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_outputnames = lm_266(l_outputnames, i_vars_outputVars);
        l_outputnames = Tpl.popIter(l_outputnames);
        txt = Tpl.writeText(txt, l_outputnames);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_267;

protected function fun_268
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      SimCode.ModelInfo i_modelInfo;

    case ( txt,
           SimCode.SIMCODE(modelInfo = i_modelInfo) )
      equation
        txt = fun_267(txt, i_modelInfo);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_268;

protected function fun_269
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      SimCode.SimCode i_simCode;
      Tpl.Text l_outputs;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = _))) )
      equation
        l_outputs = fun_268(Tpl.emptyTxt, i_simCode);
        txt = Tpl.writeText(txt, l_outputs);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_269;

public function mlpiOutputVars
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_varDecls;
algorithm
  l_varDecls := Tpl.emptyTxt;
  out_txt := fun_269(txt, a_simCode);
end mlpiOutputVars;

protected function lm_271
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      DAE.ComponentRef i_name;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(name = i_name) :: rest )
      equation
        txt = CodegenCppCommonOld.crefTypeMLPI(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = CodegenCppCommonOld.crefST(txt, i_name, false);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        txt = lm_271(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_271(txt, rest);
      then txt;
  end match;
end lm_271;

protected function fun_272
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> i_vars_inputVars;
      Tpl.Text l_inputnames;
      Tpl.Text l_optpreExp;
      Tpl.Text l_varOptDecls;

    case ( txt,
           SimCode.MODELINFO(varInfo = SimCode.VARINFO(numZeroCrossings = _), vars = SimCodeVar.SIMVARS(inputVars = i_vars_inputVars)) )
      equation
        l_varOptDecls = Tpl.emptyTxt;
        l_optpreExp = Tpl.emptyTxt;
        l_inputnames = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_inputnames = lm_271(l_inputnames, i_vars_inputVars);
        l_inputnames = Tpl.popIter(l_inputnames);
        txt = Tpl.writeText(txt, l_inputnames);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_272;

protected function fun_273
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      SimCode.ModelInfo i_modelInfo;

    case ( txt,
           SimCode.SIMCODE(modelInfo = i_modelInfo) )
      equation
        txt = fun_272(txt, i_modelInfo);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_273;

protected function fun_274
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      SimCode.SimCode i_simCode;
      Tpl.Text l_inputs;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = _))) )
      equation
        l_inputs = fun_273(Tpl.emptyTxt, i_simCode);
        txt = Tpl.writeText(txt, l_inputs);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_274;

public function mlpiInputVars
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_varDecls;
algorithm
  l_varDecls := Tpl.emptyTxt;
  out_txt := fun_274(txt, a_simCode);
end mlpiInputVars;

protected function lm_276
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      DAE.ComponentRef i_name;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(name = i_name) :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("shared_ptr<SimDouble> sim_value_out"));
        txt = CodegenCppCommonOld.cref(txt, i_name, false);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(new SimDouble(0.0));\n",
                                    "simData_shared->Add(\""
                                }, false));
        txt = CodegenCppCommonOld.cref(txt, i_name, false);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\", sim_value_out"));
        txt = CodegenCppCommonOld.cref(txt, i_name, false);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
        txt = Tpl.nextIter(txt);
        txt = lm_276(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_276(txt, rest);
      then txt;
  end match;
end lm_276;

protected function fun_277
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> i_vars_outputVars;
      Tpl.Text l_outputnames;
      Tpl.Text l_optpreExp;
      Tpl.Text l_varOptDecls;

    case ( txt,
           SimCode.MODELINFO(varInfo = SimCode.VARINFO(numZeroCrossings = _), vars = SimCodeVar.SIMVARS(outputVars = i_vars_outputVars)) )
      equation
        l_varOptDecls = Tpl.emptyTxt;
        l_optpreExp = Tpl.emptyTxt;
        l_outputnames = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_outputnames = lm_276(l_outputnames, i_vars_outputVars);
        l_outputnames = Tpl.popIter(l_outputnames);
        txt = Tpl.writeText(txt, l_outputnames);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_277;

protected function fun_278
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      SimCode.ModelInfo i_modelInfo;

    case ( txt,
           SimCode.SIMCODE(modelInfo = i_modelInfo) )
      equation
        txt = fun_277(txt, i_modelInfo);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_278;

protected function fun_279
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      SimCode.SimCode i_simCode;
      Tpl.Text l_outputs;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = _))) )
      equation
        l_outputs = fun_278(Tpl.emptyTxt, i_simCode);
        txt = Tpl.writeText(txt, l_outputs);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_279;

public function defineOutputVars
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_varDecls;
algorithm
  l_varDecls := Tpl.emptyTxt;
  out_txt := fun_279(txt, a_simCode);
end defineOutputVars;

protected function lm_281
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      DAE.ComponentRef i_name;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(name = i_name) :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("place variable here  = dynamic_cast<SimDouble*>(data->Get(\""));
        txt = CodegenCppCommonOld.cref(txt, i_name, false);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\"))->getValue();"));
        txt = Tpl.nextIter(txt);
        txt = lm_281(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_281(txt, rest);
      then txt;
  end match;
end lm_281;

protected function fun_282
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> i_vars_outputVars;
      Tpl.Text l_outputnames;
      Tpl.Text l_optpreExp;
      Tpl.Text l_varOptDecls;

    case ( txt,
           SimCode.MODELINFO(varInfo = SimCode.VARINFO(numZeroCrossings = _), vars = SimCodeVar.SIMVARS(outputVars = i_vars_outputVars)) )
      equation
        l_varOptDecls = Tpl.emptyTxt;
        l_optpreExp = Tpl.emptyTxt;
        l_outputnames = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_outputnames = lm_281(l_outputnames, i_vars_outputVars);
        l_outputnames = Tpl.popIter(l_outputnames);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "  /* do something with the outputs!*/\n",
                                    "/*\n"
                                }, true));
        txt = Tpl.writeText(txt, l_outputnames);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("    */"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_282;

protected function fun_283
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      SimCode.ModelInfo i_modelInfo;

    case ( txt,
           SimCode.SIMCODE(modelInfo = i_modelInfo) )
      equation
        txt = fun_282(txt, i_modelInfo);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_283;

protected function fun_284
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      SimCode.SimCode i_simCode;
      Tpl.Text l_outputs;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = _))) )
      equation
        l_outputs = fun_283(Tpl.emptyTxt, i_simCode);
        txt = Tpl.writeText(txt, l_outputs);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_284;

public function getOutputVars
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_varDecls;
algorithm
  l_varDecls := Tpl.emptyTxt;
  out_txt := fun_284(txt, a_simCode);
end getOutputVars;

protected function lm_286
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      DAE.ComponentRef i_name;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(name = i_name) :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("f << dynamic_cast<SimDouble*>(data->Get(\""));
        txt = CodegenCppCommonOld.cref(txt, i_name, false);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\"))->getValue() << \";\" ;"));
        txt = Tpl.nextIter(txt);
        txt = lm_286(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_286(txt, rest);
      then txt;
  end match;
end lm_286;

protected function fun_287
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> i_vars_outputVars;
      Tpl.Text l_outputnames;
      Tpl.Text l_optpreExp;
      Tpl.Text l_varOptDecls;

    case ( txt,
           SimCode.MODELINFO(varInfo = SimCode.VARINFO(numZeroCrossings = _), vars = SimCodeVar.SIMVARS(outputVars = i_vars_outputVars)) )
      equation
        l_varOptDecls = Tpl.emptyTxt;
        l_optpreExp = Tpl.emptyTxt;
        l_outputnames = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_outputnames = lm_286(l_outputnames, i_vars_outputVars);
        l_outputnames = Tpl.popIter(l_outputnames);
        txt = Tpl.writeText(txt, l_outputnames);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "f << endl;"
                                }, false));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_287;

protected function fun_288
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      SimCode.ModelInfo i_modelInfo;

    case ( txt,
           SimCode.SIMCODE(modelInfo = i_modelInfo) )
      equation
        txt = fun_287(txt, i_modelInfo);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_288;

protected function fun_289
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      SimCode.SimCode i_simCode;
      Tpl.Text l_outputs;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = _))) )
      equation
        l_outputs = fun_288(Tpl.emptyTxt, i_simCode);
        txt = Tpl.writeText(txt, l_outputs);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_289;

public function streamOutputVars
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_varDecls;
algorithm
  l_varDecls := Tpl.emptyTxt;
  out_txt := fun_289(txt, a_simCode);
end streamOutputVars;

protected function fun_291
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_fileNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_fileNamePrefix)
    local
      Tpl.Text txt;
      String a_fileNamePrefix;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_fileNamePrefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#include \"OMCpp"));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "InitializeParameter.cpp\"\n",
                                    "#include \"OMCpp"
                                }, false));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("InitializeAlgVars.cpp\""));
      then txt;
  end match;
end fun_291;

protected function fun_292
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      String i_fileNamePrefix;
      Boolean ret_2;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = _), fileNamePrefix = i_fileNamePrefix) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "/*****************************************************************************\n",
                                    "*\n",
                                    "* Helper file that includes all generated calculation files, except the alg loops.\n",
                                    "* This file is generated by the OpenModelica Compiler and produced to speed-up the compile time.\n",
                                    "*\n",
                                    "*****************************************************************************/\n",
                                    "#include <Core/ModelicaDefine.h>\n",
                                    "#include <Core/Modelica.h>\n",
                                    "#include <Core/System/FactoryExport.h>\n",
                                    "#include <Core/System/DiscreteEvents.h>\n",
                                    "#include <Core/System/EventHandling.h>\n",
                                    "#include <Core/DataExchange/XmlPropertyReader.h>\n",
                                    "#include <Core/Utils/extension/logger.hpp>\n",
                                    "\n",
                                    "#include \"OMCpp"
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Types.h\"\n",
                                    "#include \"OMCpp"
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Functions.h\"\n",
                                    "#include \"OMCpp"
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ".h\"\n",
                                    "\n",
                                    "#include \"OMCpp"
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Jacobian.h\"\n",
                                    "#include \"OMCpp"
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Mixed.h\"\n",
                                    "#include \"OMCpp"
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "StateSelection.h\"\n",
                                    "#include \"OMCpp"
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "WriteOutput.h\"\n",
                                    "#include \"OMCpp"
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Initialize.h\"\n",
                                    "\n",
                                    "#include \"OMCpp"
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "AlgLoopMain.cpp\"\n",
                                    "#include \"OMCpp"
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "FactoryExport.cpp\"\n",
                                    "#include \"OMCpp"
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Mixed.cpp\"\n",
                                    "#include \"OMCpp"
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("Functions.cpp\"\n"));
        ret_0 = Flags.isSet(Flags.HARDCODED_START_VALUES);
        ret_1 = Flags.isSet(Flags.GEN_DEBUG_SYMBOLS);
        ret_2 = boolOr(ret_0, ret_1);
        txt = fun_291(txt, ret_2, i_fileNamePrefix);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#include \"OMCpp"));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Initialize.cpp\"\n",
                                    "#include \"OMCpp"
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "WriteOutput.cpp\"\n",
                                    "#include \"OMCpp"
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Jacobian.cpp\"\n",
                                    "#include \"OMCpp"
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "StateSelection.cpp\"\n",
                                    "#include \"OMCpp"
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".cpp\""));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_292;

public function calcHelperMainfile
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  out_txt := fun_292(txt, a_simCode);
  out_a_extraFuncs := a_extraFuncs;
  out_a_extraFuncsDecl := a_extraFuncsDecl;
  out_a_extraFuncsNamespace := a_extraFuncsNamespace;
end calcHelperMainfile;

public function algloopHeaderFile
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input SimCode.SimEqSystem in_a_eq;
  input SimCodeFunction.Context in_a_context;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace) :=
  match(in_txt, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_eq, in_a_context, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      SimCode.SimEqSystem a_eq;
      SimCodeFunction.Context a_context;
      Boolean a_useFlatArrayNotation;
      SimCode.SimCode i_simCode;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = _)),
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_eq,
           a_context,
           a_useFlatArrayNotation )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = generateAlgloopHeaderInlcudeString(txt, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_context);
        txt = Tpl.softNewLine(txt);
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = generateAlgloopClassDeclarationCode(txt, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_eq, a_context, a_useFlatArrayNotation);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);

    case ( txt,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           _,
           _,
           _ )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
  end match;
end algloopHeaderFile;

protected function lm_295
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Integer x_i0;
      DAE.Exp i_literal;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_literal :: rest )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = literalExpConstImpl(txt, i_literal, x_i0);
        txt = Tpl.nextIter(txt);
        txt = lm_295(txt, rest);
      then txt;
  end match;
end lm_295;

protected function fun_296
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input list<SimCodeFunction.Function> in_a_functions;
  input list<String> in_a_includes;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_functions, in_a_includes, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      list<SimCodeFunction.Function> a_functions;
      list<String> a_includes;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      SimCode.SimCode i_simCode;
      list<DAE.Exp> i_literals;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = _), literals = i_literals)),
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_functions,
           a_includes,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = externalFunctionIncludes(txt, a_includes);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "//external functions\n",
                                    "extern \"C\" {\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = externfunctionHeaderDefinition(txt, a_functions);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n",
                                    "Functions::Functions(double& simTime, double* z, double* zDot, bool& initial, bool& terminate)\n",
                                    "    : _simTime(simTime)\n",
                                    "    , __z(z)\n",
                                    "    , __zDot(zDot)\n",
                                    "    , _initial(initial)\n",
                                    "    , _terminate(terminate)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_295(txt, i_literals);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n",
                                    "Functions::~Functions()\n",
                                    "{\n",
                                    "}\n",
                                    "\n",
                                    "void Functions::Assert(bool cond, string msg)\n",
                                    "{\n",
                                    "  if(!cond)\n",
                                    "   throw ModelicaSimulationError(MODEL_EQ_SYSTEM,msg);\n",
                                    "}\n",
                                    "\n"
                                }, true));
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = functionBodies(txt, a_functions, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/*extraFuncs*/\n"));
        txt = Tpl.writeText(txt, a_extraFuncs);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           _,
           _,
           a_stateDerVectorName,
           _ )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end fun_296;

public function simulationFunctionsFile
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input list<SimCodeFunction.Function> a_functions;
  input list<DAE.Exp> a_literals;
  input list<String> a_includes;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) := fun_296(txt, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_functions, a_includes, a_stateDerVectorName, a_useFlatArrayNotation);
end simulationFunctionsFile;

protected function lm_298
  input Tpl.Text in_txt;
  input list<String> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<String> rest;
      String i_it;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_it :: rest )
      equation
        txt = Tpl.writeStr(txt, i_it);
        txt = Tpl.nextIter(txt);
        txt = lm_298(txt, rest);
      then txt;
  end match;
end lm_298;

public function externalFunctionIncludes
  input Tpl.Text in_txt;
  input list<String> in_a_includes;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_includes)
    local
      Tpl.Text txt;
      list<String> i_includes;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_includes )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "#ifdef __cplusplus\n",
                                    "extern \"C\" {\n",
                                    "#endif\n"
                                }, true));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_298(txt, i_includes);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "#ifdef __cplusplus\n",
                                    "}\n",
                                    "#endif"
                                }, false));
      then txt;
  end match;
end externalFunctionIncludes;

protected function fun_300
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_dummyElemTypeCreation;
  input list<SimCodeFunction.Function> in_a_functions;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_dummyElemTypeCreation;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_dummyElemTypeCreation, out_a_stateDerVectorName) :=
  match(in_txt, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_dummyElemTypeCreation, in_a_functions, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_dummyElemTypeCreation;
      list<SimCodeFunction.Function> a_functions;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      SimCode.SimCode i_simCode;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = _))),
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_dummyElemTypeCreation,
           a_functions,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "#pragma once\n",
                                    "\n",
                                    "/*****************************************************************************\n",
                                    "*\n",
                                    "* Simulation data types generated by the OpenModelica Compiler.\n",
                                    "*\n",
                                    "*****************************************************************************/\n",
                                    "\n"
                                }, true));
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_dummyElemTypeCreation, a_stateDerVectorName) = functionHeaderBodies1(txt, a_functions, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_dummyElemTypeCreation, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_dummyElemTypeCreation, a_stateDerVectorName);

    case ( txt,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_dummyElemTypeCreation,
           _,
           a_stateDerVectorName,
           _ )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_dummyElemTypeCreation, a_stateDerVectorName);
  end match;
end fun_300;

public function simulationTypesHeaderFile
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_dummyElemTypeCreation;
  input list<SimCodeFunction.Function> a_functions;
  input list<DAE.Exp> a_literals;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_dummyElemTypeCreation;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_dummyElemTypeCreation, out_a_stateDerVectorName) := fun_300(txt, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_dummyElemTypeCreation, a_functions, a_stateDerVectorName, a_useFlatArrayNotation);
end simulationTypesHeaderFile;

protected function lm_302
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Integer x_i0;
      DAE.Exp i_literal;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_literal :: rest )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = literalExpConst(txt, i_literal, x_i0);
        txt = Tpl.nextIter(txt);
        txt = lm_302(txt, rest);
      then txt;
  end match;
end lm_302;

protected function fun_303
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input list<SimCodeFunction.Function> in_a_functions;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_functions, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      list<SimCodeFunction.Function> a_functions;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      list<DAE.Exp> i_literals;
      SimCode.SimCode i_simCode;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = _), literals = i_literals)),
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_functions,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "#pragma once\n",
                                    "\n",
                                    "/*****************************************************************************\n",
                                    "*\n",
                                    "* Simulation code for FunctionCall functions generated by the OpenModelica Compiler.\n",
                                    "*\n",
                                    "*****************************************************************************/\n",
                                    "\n",
                                    "class Functions\n",
                                    "{\n",
                                    "public:\n",
                                    "  Functions(double& simTime, double* z, double* zDot, bool& initial, bool& terminate);\n",
                                    "  ~Functions();\n",
                                    "  //Modelica functions\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = functionHeaderBodies2(txt, a_functions, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "void Assert(bool cond,string msg);\n",
                                    "\n",
                                    "//Literals\n"
                                }, true));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_302(txt, i_literals);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "private:\n",
                                    "  //Function return variables\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = functionHeaderBodies3(txt, a_functions, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "double& _simTime;\n",
                                    "bool& _terminate;\n",
                                    "bool& _initial;\n",
                                    "double* __z;\n",
                                    "double* __zDot;\n",
                                    "/*extraFuncs*/\n"
                                }, true));
        txt = Tpl.writeText(txt, a_extraFuncsDecl);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("};"));
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           _,
           a_stateDerVectorName,
           _ )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end fun_303;

public function simulationFunctionsHeaderFile
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input list<SimCodeFunction.Function> a_functions;
  input list<DAE.Exp> a_literals;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) := fun_303(txt, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_functions, a_stateDerVectorName, a_useFlatArrayNotation);
end simulationFunctionsHeaderFile;

protected function lm_305
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Function> in_items;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Function> rest;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      SimCodeFunction.Function i_fn;

    case ( txt,
           {},
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           i_fn :: rest,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = declFunParams2(txt, i_fn, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_305(txt, rest, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_305;

public function declFunParams
  input Tpl.Text txt;
  input list<SimCodeFunction.Function> a_functions;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_stateDerVectorName;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
protected
  Tpl.Text l_params;
algorithm
  l_params := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (l_params, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) := lm_305(l_params, a_functions, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
  l_params := Tpl.popIter(l_params);
  out_txt := Tpl.writeText(txt, l_params);
end declFunParams;

protected function lm_307
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      SimCodeFunction.Variable i_var;

    case ( txt,
           {},
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           i_var :: rest,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = funParamDecl(txt, i_var, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_307(txt, rest, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_307;

public function declFunParams2
  input Tpl.Text in_txt;
  input SimCodeFunction.Function in_a_fn;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_fn, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      list<SimCodeFunction.Variable> i_variableDeclarations;
      Tpl.Text l_params;

    case ( txt,
           SimCodeFunction.FUNCTION(variableDeclarations = i_variableDeclarations),
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName )
      equation
        l_params = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(1, NONE(), SOME(Tpl.ST_STRING("")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_params, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_307(l_params, i_variableDeclarations, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
        l_params = Tpl.popIter(l_params);
        txt = Tpl.writeText(txt, l_params);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end declFunParams2;

protected function fun_309
  input Tpl.Text in_txt;
  input DAE.VarKind in_a_kind;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input SimCodeFunction.Variable in_a_var;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_a_kind, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_var)
    local
      Tpl.Text txt;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      SimCodeFunction.Variable a_var;

    case ( txt,
           DAE.PARAM(),
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_var )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = funParamDecl2(txt, a_var, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, false);
        txt = Tpl.popBlock(txt);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_309;

public function funParamDecl
  input Tpl.Text in_txt;
  input SimCodeFunction.Variable in_a_var;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_var, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      SimCodeFunction.Variable i_var;
      DAE.VarKind i_kind;

    case ( txt,
           (i_var as SimCodeFunction.VARIABLE(kind = i_kind)),
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName )
      equation
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_309(txt, i_kind, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, i_var);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end funParamDecl;

public function funParamDecl2
  input Tpl.Text in_txt;
  input SimCodeFunction.Variable in_a_var;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_var, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      list<DAE.Dimension> i_instDims;
      SimCodeFunction.Variable i_var;
      DAE.ComponentRef i_var_name;
      Tpl.Text l_varName;

    case ( txt,
           (i_var as SimCodeFunction.VARIABLE(name = i_var_name, instDims = i_instDims)),
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (l_varName, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.contextCref(Tpl.emptyTxt, i_var_name, SimCodeFunction.contextFunction, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = funParamDecl3(txt, i_var, Tpl.textString(l_varName), i_instDims, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end funParamDecl2;

protected function lm_312
  input Tpl.Text in_txt;
  input list<DAE.Dimension> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_varInits;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varInits;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_varInits) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_varInits)
    local
      Tpl.Text txt;
      list<DAE.Dimension> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_varInits;
      DAE.Dimension i_dim;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           a_varInits )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_varInits);

    case ( txt,
           i_dim :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_varInits )
      equation
        (txt, a_varInits, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeDimension(txt, i_dim, SimCodeFunction.contextFunction, a_varInits, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_varInits) = lm_312(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_varInits);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_varInits);
  end match;
end lm_312;

protected function lm_313
  input Tpl.Text in_txt;
  input list<DAE.Dimension> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<DAE.Dimension> rest;
      DAE.Dimension i_dim;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_dim :: rest )
      equation
        txt = testDaeDimension(txt, i_dim);
        txt = Tpl.nextIter(txt);
        txt = lm_313(txt, rest);
      then txt;
  end match;
end lm_313;

protected function lm_314
  input Tpl.Text in_txt;
  input list<DAE.Dimension> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_varInits;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varInits;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_varInits) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_varInits)
    local
      Tpl.Text txt;
      list<DAE.Dimension> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_varInits;
      DAE.Dimension i_dim;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           a_varInits )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_varInits);

    case ( txt,
           i_dim :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_varInits )
      equation
        (txt, a_varInits, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeDimension(txt, i_dim, SimCodeFunction.contextFunction, a_varInits, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_varInits) = lm_314(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_varInits);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_varInits);
  end match;
end lm_314;

protected function fun_315
  input Tpl.Text in_txt;
  input list<DAE.Dimension> in_a_instDims;
  input Tpl.Text in_a_instDimsInit;
  input DAE.Type in_a_var_ty;
  input String in_a_varName;
  input Tpl.Text in_a_type;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_instDims, in_a_instDimsInit, in_a_var_ty, in_a_varName, in_a_type)
    local
      Tpl.Text txt;
      Tpl.Text a_instDimsInit;
      DAE.Type a_var_ty;
      String a_varName;
      Tpl.Text a_type;
      list<DAE.Dimension> i_instDims;
      Integer ret_0;

    case ( txt,
           {},
           _,
           _,
           a_varName,
           a_type )
      equation
        txt = Tpl.writeText(txt, a_type);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeStr(txt, a_varName);
      then txt;

    case ( txt,
           i_instDims,
           a_instDimsInit,
           a_var_ty,
           a_varName,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("StatArrayDim"));
        ret_0 = listLength(i_instDims);
        txt = Tpl.writeStr(txt, intString(ret_0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<"));
        txt = CodegenCppCommonOld.expTypeShort(txt, a_var_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, a_instDimsInit);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("> "));
        txt = Tpl.writeStr(txt, a_varName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";/*testarray*/"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;
  end match;
end fun_315;

protected function fun_316
  input Tpl.Text in_txt;
  input list<DAE.Dimension> in_a_instDims;
  input DAE.Type in_a_var_ty;
  input String in_a_varName;
  input Tpl.Text in_a_type;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_instDims, in_a_var_ty, in_a_varName, in_a_type)
    local
      Tpl.Text txt;
      DAE.Type a_var_ty;
      String a_varName;
      Tpl.Text a_type;
      list<DAE.Dimension> i_instDims;
      Integer ret_0;

    case ( txt,
           {},
           _,
           a_varName,
           a_type )
      equation
        txt = Tpl.writeText(txt, a_type);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeStr(txt, a_varName);
      then txt;

    case ( txt,
           i_instDims,
           a_var_ty,
           a_varName,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("DynArrayDim"));
        ret_0 = listLength(i_instDims);
        txt = Tpl.writeStr(txt, intString(ret_0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<"));
        txt = CodegenCppCommonOld.expTypeShort(txt, a_var_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("> "));
        txt = Tpl.writeStr(txt, a_varName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;
  end match;
end fun_316;

protected function fun_317
  input Tpl.Text in_txt;
  input String in_mArg;
  input Tpl.Text in_a_arrayexpression2;
  input Tpl.Text in_a_arrayexpression1;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_arrayexpression2, in_a_arrayexpression1)
    local
      Tpl.Text txt;
      Tpl.Text a_arrayexpression2;
      Tpl.Text a_arrayexpression1;

    case ( txt,
           "",
           _,
           a_arrayexpression1 )
      equation
        txt = Tpl.writeText(txt, a_arrayexpression1);
      then txt;

    case ( txt,
           _,
           a_arrayexpression2,
           _ )
      equation
        txt = Tpl.writeText(txt, a_arrayexpression2);
      then txt;
  end match;
end fun_317;

protected function fun_318
  input Tpl.Text in_txt;
  input SimCodeFunction.Variable in_a_var;
  input String in_a_varName;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_varInits;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varInits;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_varInits) :=
  match(in_txt, in_a_var, in_a_varName, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_varInits)
    local
      Tpl.Text txt;
      String a_varName;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_varInits;
      DAE.Type i_var_ty;
      list<DAE.Dimension> i_instDims;
      SimCodeFunction.Variable i_var;
      String str_6;
      Tpl.Text l_paramdecl;
      Tpl.Text l_arrayexpression2;
      Tpl.Text l_arrayexpression1;
      Tpl.Text l_instDimsInit;
      Tpl.Text l_testinstDimsInit;
      Tpl.Text l_type;

    case ( txt,
           (i_var as SimCodeFunction.VARIABLE(instDims = i_instDims, ty = i_var_ty)),
           a_varName,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_varInits )
      equation
        l_type = varType(Tpl.emptyTxt, i_var);
        l_testinstDimsInit = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING("")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_testinstDimsInit = lm_313(l_testinstDimsInit, i_instDims);
        l_testinstDimsInit = Tpl.popIter(l_testinstDimsInit);
        l_instDimsInit = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_instDimsInit, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_varInits) = lm_314(l_instDimsInit, i_instDims, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_varInits);
        l_instDimsInit = Tpl.popIter(l_instDimsInit);
        l_arrayexpression1 = fun_315(Tpl.emptyTxt, i_instDims, l_instDimsInit, i_var_ty, a_varName, l_type);
        l_arrayexpression2 = fun_316(Tpl.emptyTxt, i_instDims, i_var_ty, a_varName, l_type);
        str_6 = Tpl.textString(l_testinstDimsInit);
        l_paramdecl = fun_317(Tpl.emptyTxt, str_6, l_arrayexpression2, l_arrayexpression1);
        txt = Tpl.writeText(txt, l_paramdecl);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_varInits);

    case ( txt,
           _,
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           a_varInits )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_varInits);
  end match;
end fun_318;

public function funParamDecl3
  input Tpl.Text txt;
  input SimCodeFunction.Variable a_var;
  input String a_varName;
  input list<DAE.Dimension> a_instDims;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
protected
  Tpl.Text l_instDimsInit;
  Tpl.Text l_varInits;
  Tpl.Text l_varDecls;
algorithm
  l_varDecls := Tpl.emptyTxt;
  l_varInits := Tpl.emptyTxt;
  l_instDimsInit := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (l_instDimsInit, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, l_varDecls, l_varInits) := lm_312(l_instDimsInit, a_instDims, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, l_varDecls, l_varInits);
  l_instDimsInit := Tpl.popIter(l_instDimsInit);
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, l_varDecls, l_varInits) := fun_318(txt, a_var, a_varName, a_useFlatArrayNotation, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, a_simCode, l_varDecls, l_varInits);
end funParamDecl3;

protected function lm_320
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Function> in_items;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varInits;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varInits;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varInits, out_a_varDecls) :=
  match(in_txt, in_items, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varInits, in_a_varDecls)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Function> rest;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varInits;
      Tpl.Text a_varDecls;
      SimCodeFunction.Function i_fn;

    case ( txt,
           {},
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varInits,
           a_varDecls )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varInits, a_varDecls);

    case ( txt,
           i_fn :: rest,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varInits,
           a_varDecls )
      equation
        (txt, a_varDecls, a_varInits, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = initParams2(txt, i_fn, a_varDecls, a_varInits, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varInits, a_varDecls) = lm_320(txt, rest, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varInits, a_varDecls);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varInits, a_varDecls);
  end match;
end lm_320;

public function initParams1
  input Tpl.Text txt;
  input list<SimCodeFunction.Function> a_functions;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_stateDerVectorName;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
protected
  Tpl.Text l_0__;
  Tpl.Text l_varInits;
  Tpl.Text l_varDecls;
algorithm
  l_varDecls := Tpl.emptyTxt;
  l_varInits := Tpl.emptyTxt;
  l_0__ := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (l_0__, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, l_varInits, l_varDecls) := lm_320(l_0__, a_functions, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, l_varInits, l_varDecls);
  l_0__ := Tpl.popIter(l_0__);
  out_txt := Tpl.writeText(txt, l_varDecls);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeText(out_txt, l_varInits);
end initParams1;

protected function lm_322
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varInits;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varInits;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varInits, out_a_varDecls) :=
  match(in_txt, in_items, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varInits, in_a_varDecls)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varInits;
      Tpl.Text a_varDecls;
      Integer x_i1;
      SimCodeFunction.Variable i_var;

    case ( txt,
           {},
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varInits,
           a_varDecls )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varInits, a_varDecls);

    case ( txt,
           i_var :: rest,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varInits,
           a_varDecls )
      equation
        x_i1 = Tpl.getIteri_i0(txt);
        (txt, a_varDecls, a_varInits, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = paramInit2(txt, i_var, "", x_i1, a_varDecls, a_varInits, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varInits, a_varDecls) = lm_322(txt, rest, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varInits, a_varDecls);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varInits, a_varDecls);
  end match;
end lm_322;

public function initParams2
  input Tpl.Text in_txt;
  input SimCodeFunction.Function in_a_fn;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_varInits;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varInits;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_varDecls, out_a_varInits, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_fn, in_a_varDecls, in_a_varInits, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName)
    local
      Tpl.Text txt;
      Tpl.Text a_varDecls;
      Tpl.Text a_varInits;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      list<SimCodeFunction.Variable> i_variableDeclarations;
      Tpl.Text l_0__;

    case ( txt,
           SimCodeFunction.FUNCTION(variableDeclarations = i_variableDeclarations),
           a_varDecls,
           a_varInits,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName )
      equation
        l_0__ = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(1, NONE(), SOME(Tpl.ST_STRING("")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_0__, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varInits, a_varDecls) = lm_322(l_0__, i_variableDeclarations, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varInits, a_varDecls);
        l_0__ = Tpl.popIter(l_0__);
      then (txt, a_varDecls, a_varInits, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           a_varDecls,
           a_varInits,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName )
      then (txt, a_varDecls, a_varInits, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end initParams2;

protected function fun_324
  input Tpl.Text in_txt;
  input DAE.VarKind in_a_kind;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varInits;
  input Tpl.Text in_a_varDecls;
  input Integer in_a_i;
  input SimCodeFunction.Variable in_a_var;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varInits;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varInits, out_a_varDecls) :=
  match(in_txt, in_a_kind, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varInits, in_a_varDecls, in_a_i, in_a_var)
    local
      Tpl.Text txt;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varInits;
      Tpl.Text a_varDecls;
      Integer a_i;
      SimCodeFunction.Variable a_var;

    case ( txt,
           DAE.PARAM(),
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varInits,
           a_varDecls,
           a_i,
           a_var )
      equation
        (txt, a_varDecls, a_varInits, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = paramInit3(txt, a_var, "", a_i, a_varDecls, a_varInits, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, false);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varInits, a_varDecls);

    case ( txt,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varInits,
           a_varDecls,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varInits, a_varDecls);
  end match;
end fun_324;

protected function fun_325
  input Tpl.Text in_txt;
  input SimCodeFunction.Variable in_a_var;
  input Integer in_a_i;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_varInits;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varInits;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_varDecls, out_a_varInits, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_var, in_a_i, in_a_varDecls, in_a_varInits, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName)
    local
      Tpl.Text txt;
      Integer a_i;
      Tpl.Text a_varDecls;
      Tpl.Text a_varInits;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      SimCodeFunction.Variable i_var;
      DAE.VarKind i_kind;

    case ( txt,
           (i_var as SimCodeFunction.VARIABLE(kind = i_kind)),
           a_i,
           a_varDecls,
           a_varInits,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName )
      equation
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varInits, a_varDecls) = fun_324(txt, i_kind, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varInits, a_varDecls, a_i, i_var);
      then (txt, a_varDecls, a_varInits, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           a_varDecls,
           a_varInits,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName )
      then (txt, a_varDecls, a_varInits, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end fun_325;

public function paramInit2
  input Tpl.Text txt;
  input SimCodeFunction.Variable a_var;
  input String a_outStruct;
  input Integer a_i;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_varInits;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_stateDerVectorName;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varInits;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_varDecls, out_a_varInits, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) := fun_325(txt, a_var, a_i, a_varDecls, a_varInits, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
end paramInit2;

protected function lm_327
  input Tpl.Text in_txt;
  input list<DAE.Dimension> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_varInits;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varInits;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_varInits) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_varInits)
    local
      Tpl.Text txt;
      list<DAE.Dimension> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_varInits;
      DAE.Dimension i_dim;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           a_varInits )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_varInits);

    case ( txt,
           i_dim :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_varInits )
      equation
        (txt, a_varInits, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeDimension(txt, i_dim, SimCodeFunction.contextFunction, a_varInits, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_varInits) = lm_327(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_varInits);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_varInits);
  end match;
end lm_327;

protected function fun_328
  input Tpl.Text in_txt;
  input Option<DAE.Exp> in_a_var_value;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_varInits;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input DAE.ComponentRef in_a_var_name;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varInits;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_varDecls, out_a_varInits, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_a_var_value, in_a_varDecls, in_a_varInits, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_var_name)
    local
      Tpl.Text txt;
      Tpl.Text a_varDecls;
      Tpl.Text a_varInits;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      DAE.ComponentRef a_var_name;
      DAE.Exp i_exp;
      Tpl.Text l_defaultValue;

    case ( txt,
           SOME(i_exp),
           a_varDecls,
           a_varInits,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_var_name )
      equation
        (l_defaultValue, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.contextCref(Tpl.emptyTxt, a_var_name, SimCodeFunction.contextFunction, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        l_defaultValue = Tpl.writeTok(l_defaultValue, Tpl.ST_STRING(" = "));
        (l_defaultValue, a_varInits, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.daeExp(l_defaultValue, i_exp, SimCodeFunction.contextFunction, a_varInits, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        l_defaultValue = Tpl.writeTok(l_defaultValue, Tpl.ST_STRING(";"));
        l_defaultValue = Tpl.writeTok(l_defaultValue, Tpl.ST_NEW_LINE());
        a_varInits = Tpl.writeText(a_varInits, l_defaultValue);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
      then (txt, a_varDecls, a_varInits, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           a_varDecls,
           a_varInits,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_varDecls, a_varInits, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_328;

protected function lm_329
  input Tpl.Text in_txt;
  input list<DAE.Dimension> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<DAE.Dimension> rest;
      DAE.Dimension i_dim;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_dim :: rest )
      equation
        txt = testDaeDimension(txt, i_dim);
        txt = Tpl.nextIter(txt);
        txt = lm_329(txt, rest);
      then txt;
  end match;
end lm_329;

protected function fun_330
  input Tpl.Text in_txt;
  input String in_a_outStruct;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input DAE.ComponentRef in_a_var_name;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_a_outStruct, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_var_name)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      DAE.ComponentRef a_var_name;

    case ( txt,
           "",
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_var_name )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.contextCref(txt, a_var_name, SimCodeFunction.contextFunction, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_var_name )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = extVarName(txt, a_var_name, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_330;

protected function fun_331
  input Tpl.Text in_txt;
  input Option<DAE.Exp> in_a_var_value;
  input DAE.ComponentRef in_a_var_name;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varInits;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_varName;
  input Integer in_a_i;
  input String in_a_outStruct;
  input SimCodeFunction.Variable in_a_var;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varInits;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varInits, out_a_varDecls) :=
  match(in_txt, in_a_var_value, in_a_var_name, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varInits, in_a_varDecls, in_a_varName, in_a_i, in_a_outStruct, in_a_var)
    local
      Tpl.Text txt;
      DAE.ComponentRef a_var_name;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varInits;
      Tpl.Text a_varDecls;
      Tpl.Text a_varName;
      Integer a_i;
      String a_outStruct;
      SimCodeFunction.Variable a_var;
      DAE.Exp i_exp;
      Tpl.Text l_defaultValue1;
      Tpl.Text l_var__name;
      Tpl.Text l_defaultValue;

    case ( txt,
           SOME(i_exp),
           a_var_name,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varInits,
           a_varDecls,
           a_varName,
           a_i,
           a_outStruct,
           a_var )
      equation
        (l_defaultValue, a_varDecls, a_varInits, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = varDefaultValue(Tpl.emptyTxt, a_var, a_outStruct, a_i, Tpl.textString(a_varName), a_varDecls, a_varInits, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        a_varInits = Tpl.writeText(a_varInits, l_defaultValue);
        (l_var__name, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_330(Tpl.emptyTxt, a_outStruct, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_var_name);
        l_defaultValue1 = Tpl.writeText(Tpl.emptyTxt, l_var__name);
        l_defaultValue1 = Tpl.writeTok(l_defaultValue1, Tpl.ST_STRING(".assign("));
        (l_defaultValue1, a_varInits, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_stateDerVectorName, a_extraFuncsNamespace) = CodegenCppCommonOld.daeExp(l_defaultValue1, i_exp, SimCodeFunction.contextFunction, a_varInits, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_stateDerVectorName, a_extraFuncsNamespace, a_useFlatArrayNotation);
        l_defaultValue1 = Tpl.writeTok(l_defaultValue1, Tpl.ST_STRING(");"));
        l_defaultValue1 = Tpl.writeTok(l_defaultValue1, Tpl.ST_NEW_LINE());
        a_varInits = Tpl.writeText(a_varInits, l_defaultValue1);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varInits, a_varDecls);

    case ( txt,
           _,
           _,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varInits,
           a_varDecls,
           a_varName,
           a_i,
           a_outStruct,
           a_var )
      equation
        (l_defaultValue, a_varDecls, a_varInits, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = varDefaultValue(Tpl.emptyTxt, a_var, a_outStruct, a_i, Tpl.textString(a_varName), a_varDecls, a_varInits, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        a_varInits = Tpl.writeText(a_varInits, l_defaultValue);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varInits, a_varDecls);
  end match;
end fun_331;

protected function fun_332
  input Tpl.Text in_txt;
  input list<DAE.Dimension> in_a_instDims;
  input Integer in_a_i;
  input String in_a_outStruct;
  input SimCodeFunction.Variable in_a_var;
  input Tpl.Text in_a_instDimsInit;
  input Tpl.Text in_a_varName;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_varInits;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input DAE.ComponentRef in_a_var_name;
  input Option<DAE.Exp> in_a_var_value;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varInits;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_varDecls, out_a_varInits, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_a_instDims, in_a_i, in_a_outStruct, in_a_var, in_a_instDimsInit, in_a_varName, in_a_varDecls, in_a_varInits, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_var_name, in_a_var_value)
    local
      Tpl.Text txt;
      Integer a_i;
      String a_outStruct;
      SimCodeFunction.Variable a_var;
      Tpl.Text a_instDimsInit;
      Tpl.Text a_varName;
      Tpl.Text a_varDecls;
      Tpl.Text a_varInits;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      DAE.ComponentRef a_var_name;
      Option<DAE.Exp> a_var_value;
      list<DAE.Dimension> i_instDims;
      Tpl.Text l_temp;
      Tpl.Text l_testinstDimsInit;

    case ( txt,
           {},
           _,
           _,
           _,
           _,
           _,
           a_varDecls,
           a_varInits,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_var_name,
           a_var_value )
      equation
        (txt, a_varDecls, a_varInits, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_328(txt, a_var_value, a_varDecls, a_varInits, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_var_name);
      then (txt, a_varDecls, a_varInits, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           i_instDims,
           a_i,
           a_outStruct,
           a_var,
           a_instDimsInit,
           a_varName,
           a_varDecls,
           a_varInits,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_var_name,
           a_var_value )
      equation
        l_testinstDimsInit = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING("")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_testinstDimsInit = lm_329(l_testinstDimsInit, i_instDims);
        l_testinstDimsInit = Tpl.popIter(l_testinstDimsInit);
        (l_temp, l_testinstDimsInit, a_varInits) = setDims(Tpl.emptyTxt, l_testinstDimsInit, Tpl.textString(a_varName), a_varInits, Tpl.textString(a_instDimsInit));
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varInits, a_varDecls) = fun_331(txt, a_var_value, a_var_name, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varInits, a_varDecls, a_varName, a_i, a_outStruct, a_var);
      then (txt, a_varDecls, a_varInits, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_332;

public function paramInit3
  input Tpl.Text in_txt;
  input SimCodeFunction.Variable in_a_var;
  input String in_a_outStruct;
  input Integer in_a_i;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_varInits;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varInits;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_varDecls, out_a_varInits, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_var, in_a_outStruct, in_a_i, in_a_varDecls, in_a_varInits, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      String a_outStruct;
      Integer a_i;
      Tpl.Text a_varDecls;
      Tpl.Text a_varInits;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      SimCodeFunction.Variable i_var;
      Option<DAE.Exp> i_var_value;
      list<DAE.Dimension> i_instDims;
      DAE.ComponentRef i_var_name;
      Tpl.Text l_ignore;
      Tpl.Text l_instDimsInit;
      Tpl.Text l_varName;

    case ( txt,
           (i_var as SimCodeFunction.VARIABLE(name = i_var_name, instDims = i_instDims, value = i_var_value)),
           a_outStruct,
           a_i,
           a_varDecls,
           a_varInits,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (l_varName, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.contextCref(Tpl.emptyTxt, i_var_name, SimCodeFunction.contextFunction, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        l_instDimsInit = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_instDimsInit, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_varInits) = lm_327(l_instDimsInit, i_instDims, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_varInits);
        l_instDimsInit = Tpl.popIter(l_instDimsInit);
        (txt, a_varDecls, a_varInits, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_332(txt, i_instDims, a_i, a_outStruct, i_var, l_instDimsInit, l_varName, a_varDecls, a_varInits, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, i_var_name, i_var_value);
      then (txt, a_varDecls, a_varInits, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           (i_var as SimCodeFunction.FUNCTION_PTR(name = _)),
           _,
           _,
           a_varDecls,
           a_varInits,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      equation
        l_ignore = Tpl.emptyTxt;
        (a_varDecls, l_ignore) = functionArg(a_varDecls, i_var, l_ignore);
      then (txt, a_varDecls, a_varInits, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           _,
           a_varDecls,
           a_varInits,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_varDecls, a_varInits, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end paramInit3;

protected function fun_334
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      String i_makefileParams_platform;

    case ( txt,
           SimCode.SIMCODE(makefileParams = SimCodeFunction.MAKEFILE_PARAMS(platform = i_makefileParams_platform)) )
      equation
        txt = simulationMainDLLib2(txt, i_makefileParams_platform);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_334;

public function simulationMainDLLib
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  out_txt := fun_334(txt, a_simCode);
  out_a_extraFuncs := a_extraFuncs;
  out_a_extraFuncsDecl := a_extraFuncsDecl;
  out_a_extraFuncsNamespace := a_extraFuncsNamespace;
end simulationMainDLLib;

public function simulationMainDLLib2
  input Tpl.Text in_txt;
  input String in_a_platform;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_platform)
    local
      Tpl.Text txt;

    case ( txt,
           "linux32" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\"-ldl\""));
      then txt;

    case ( txt,
           "linux64" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\"-ldl\""));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end simulationMainDLLib2;

protected function fun_337
  input Tpl.Text in_txt;
  input String in_a_modelInfo_directory;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo_directory)
    local
      Tpl.Text txt;
      String i_modelInfo_directory;

    case ( txt,
           "" )
      then txt;

    case ( txt,
           i_modelInfo_directory )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/LIBPATH:\""));
        txt = Tpl.writeStr(txt, i_modelInfo_directory);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
      then txt;
  end match;
end fun_337;

protected function lm_338
  input Tpl.Text in_txt;
  input list<String> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<String> rest;
      String i_lib;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_lib :: rest )
      equation
        txt = Tpl.writeStr(txt, i_lib);
        txt = Tpl.nextIter(txt);
        txt = lm_338(txt, rest);
      then txt;
  end match;
end lm_338;

protected function fun_339
  input Tpl.Text in_txt;
  input Tpl.Text in_a_dirExtra;
  input Tpl.Text in_a_libsStr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_dirExtra, in_a_libsStr)
    local
      Tpl.Text txt;
      Tpl.Text a_libsStr;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           a_libsStr )
      equation
        txt = Tpl.writeText(txt, a_libsStr);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_339;

protected function fun_340
  input Tpl.Text in_txt;
  input Tpl.Text in_a_dirExtra;
  input Tpl.Text in_a_libsStr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_dirExtra, in_a_libsStr)
    local
      Tpl.Text txt;
      Tpl.Text a_libsStr;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           _ )
      then txt;

    case ( txt,
           _,
           a_libsStr )
      equation
        txt = Tpl.writeText(txt, a_libsStr);
      then txt;
  end match;
end fun_340;

protected function fun_341
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-lOMOCLRuntime -lOpenCL"));
      then txt;
  end match;
end fun_341;

protected function fun_342
  input Tpl.Text in_txt;
  input String in_a_s_method;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_s_method)
    local
      Tpl.Text txt;

    case ( txt,
           "dassljac" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-D_OMC_JACOBIAN "));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_342;

protected function fun_343
  input Tpl.Text in_txt;
  input Option<SimCode.SimulationSettings> in_a_sopt;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_sopt)
    local
      Tpl.Text txt;
      String i_s_method;

    case ( txt,
           SOME(SimCode.SIMULATION_SETTINGS(method = i_s_method)) )
      equation
        txt = fun_342(txt, i_s_method);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_343;

protected function fun_344
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_makefileParams_omhome;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_makefileParams_omhome)
    local
      Tpl.Text txt;
      String a_makefileParams_omhome;

    case ( txt,
           false,
           a_makefileParams_omhome )
      equation
        txt = Tpl.writeStr(txt, a_makefileParams_omhome);
      then txt;

    case ( txt,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("$(OPENMODELICAHOME)"));
      then txt;
  end match;
end fun_344;

protected function lm_345
  input Tpl.Text in_txt;
  input list<String> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<String> rest;
      String i_it;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_it :: rest )
      equation
        txt = Tpl.writeStr(txt, i_it);
        txt = lm_345(txt, rest);
      then txt;
  end match;
end lm_345;

protected function lm_346
  input Tpl.Text in_txt;
  input list<String> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<String> rest;
      String i_it;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_it :: rest )
      equation
        txt = Tpl.writeStr(txt, i_it);
        txt = lm_346(txt, rest);
      then txt;
  end match;
end lm_346;

protected function fun_347
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".conv"));
      then txt;
  end match;
end fun_347;

protected function fun_348
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input String in_a_additionalCFlags__MSVC;
  input Tpl.Text in_a_timeMeasureLink;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_timeMeasureLink;
algorithm
  (out_txt, out_a_timeMeasureLink) :=
  match(in_txt, in_a_simCode, in_a_additionalCFlags__MSVC, in_a_timeMeasureLink)
    local
      Tpl.Text txt;
      String a_additionalCFlags__MSVC;
      Tpl.Text a_timeMeasureLink;
      String i_fileNamePrefix;
      list<String> i_makefileParams_includes;
      String i_makefileParams_omhome;
      String i_makefileParams_platform;
      Option<SimCode.SimulationSettings> i_sopt;
      list<String> i_makefileParams_libs;
      String i_modelInfo_directory;
      Boolean ret_10;
      Boolean ret_9;
      Boolean ret_8;
      Boolean ret_7;
      Tpl.Text l_extraCflags;
      Boolean ret_5;
      Tpl.Text l_ParModelicaLibs;
      Tpl.Text l_libsPos2;
      Tpl.Text l_libsPos1;
      Tpl.Text l_libsStr;
      Tpl.Text l_dirExtra;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(directory = i_modelInfo_directory), makefileParams = SimCodeFunction.MAKEFILE_PARAMS(libs = i_makefileParams_libs, platform = i_makefileParams_platform, omhome = i_makefileParams_omhome, includes = i_makefileParams_includes), simulationSettingsOpt = i_sopt, fileNamePrefix = i_fileNamePrefix),
           a_additionalCFlags__MSVC,
           a_timeMeasureLink )
      equation
        l_dirExtra = fun_337(Tpl.emptyTxt, i_modelInfo_directory);
        l_libsStr = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(" ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_libsStr = lm_338(l_libsStr, i_makefileParams_libs);
        l_libsStr = Tpl.popIter(l_libsStr);
        l_libsPos1 = fun_339(Tpl.emptyTxt, l_dirExtra, l_libsStr);
        l_libsPos2 = fun_340(Tpl.emptyTxt, l_dirExtra, l_libsStr);
        ret_5 = Config.acceptParModelicaGrammar();
        l_ParModelicaLibs = fun_341(Tpl.emptyTxt, ret_5);
        a_timeMeasureLink = Tpl.writeTok(a_timeMeasureLink, Tpl.ST_STRING("OMCppExtensionUtilities.lib"));
        l_extraCflags = fun_343(Tpl.emptyTxt, i_sopt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "# Makefile generated by OpenModelica\n",
                                    "OMHOME="
                                }, false));
        ret_7 = stringEq(i_makefileParams_platform, "win32");
        ret_8 = stringEq(i_makefileParams_platform, "win64");
        ret_9 = boolOr(ret_7, ret_8);
        txt = fun_344(txt, ret_9, i_makefileParams_omhome);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "# Simulations use -O3 by default\n",
                                    "SIM_OR_DYNLOAD_OPT_LEVEL=\n",
                                    "MODELICAUSERCFLAGS=\n",
                                    "CXX=cl\n",
                                    "EXEEXT=.exe\n",
                                    "DLLEXT=.dll\n",
                                    "include "
                                }, false));
        txt = Tpl.writeStr(txt, i_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "/include/omc/cpp/ModelicaConfig_msvc.inc\n",
                                    "include "
                                }, false));
        txt = Tpl.writeStr(txt, i_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "/include/omc/cpp/ModelicaLibraryConfig_msvc.inc\n",
                                    "# /Od - Optimization disabled\n",
                                    "# /EHa enable C++ EH (w/ SEH exceptions)\n",
                                    "# /fp:except - consider floating-point exceptions when generating code\n",
                                    "# /arch:SSE2 - enable use of instructions available with SSE2 enabled CPUs\n",
                                    "# /I - Include Directories\n",
                                    "# /DNOMINMAX - Define NOMINMAX (does what it says)\n",
                                    "# /TP - Use C++ Compiler\n",
                                    "!IF \"$(PCH_FILE)\" == \"\"\n",
                                    "\n",
                                    "CFLAGS=  $(SYSTEM_CFLAGS) /I\""
                                }, false));
        txt = Tpl.writeStr(txt, i_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/include/omc/cpp/\" /I. "));
        txt = lm_345(txt, i_makefileParams_includes);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("  /I\"$(BOOST_INCLUDE)\" /I\"$(UMFPACK_INCLUDE)\" /I\"$(SUNDIALS_INCLUDE)\" /DNOMINMAX /TP /DNO_INTERACTIVE_DEPENDENCY "));
        txt = Tpl.writeStr(txt, a_additionalCFlags__MSVC);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "!ELSE\n",
                                    "CFLAGS=  $(SYSTEM_CFLAGS) /I\""
                                }, false));
        txt = Tpl.writeStr(txt, i_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/include/omc/cpp/\" /I. "));
        txt = lm_346(txt, i_makefileParams_includes);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("  /I\"$(BOOST_INCLUDE)\" /I\"$(UMFPACK_INCLUDE)\" /I\"$(SUNDIALS_INCLUDE)\" /DNOMINMAX /TP /DNO_INTERACTIVE_DEPENDENCY  /Fp"));
        txt = Tpl.writeStr(txt, i_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/include/omc/cpp/Core/$(PCH_FILE)  /YuCore/$(H_FILE) "));
        txt = Tpl.writeStr(txt, a_additionalCFlags__MSVC);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "!ENDIF\n",
                                    "CPPFLAGS =\n",
                                    "# /ZI enable Edit and Continue debug info\n",
                                    "CDFLAGS = /ZI\n",
                                    "!IF \"$(PCH_FILE)\" == \"\"\n",
                                    "LDSYSTEMFLAGS=  /link /DLL /NOENTRY /LIBPATH:\""
                                }, false));
        txt = Tpl.writeStr(txt, i_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/lib/"));
        txt = Tpl.writeStr(txt, Autoconf.triple);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/omc/cpp/msvc\" /LIBPATH:\""));
        txt = Tpl.writeStr(txt, i_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/lib/"));
        txt = Tpl.writeStr(txt, Autoconf.triple);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/omc/msvc\" /LIBPATH:\""));
        txt = Tpl.writeStr(txt, i_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/lib/"));
        txt = Tpl.writeStr(txt, Autoconf.triple);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/omc/msvc/debug\"  /LIBPATH:\""));
        txt = Tpl.writeStr(txt, i_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/bin\" /LIBPATH:\"$(BOOST_LIBS)\" OMCppSystem.lib OMCppModelicaUtilities.lib  OMCppMath.lib OMCppDataExchange.lib  OMCppOMCFactory.lib "));
        txt = Tpl.writeText(txt, a_timeMeasureLink);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " WSock32.lib Ws2_32.lib\n",
                                    "LDMAINFLAGS=/link /LIBPATH:\""
                                }, false));
        txt = Tpl.writeStr(txt, i_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/lib/"));
        txt = Tpl.writeStr(txt, Autoconf.triple);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/omc/cpp/msvc\" /LIBPATH:\""));
        txt = Tpl.writeStr(txt, i_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/lib/"));
        txt = Tpl.writeStr(txt, Autoconf.triple);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/omc/msvc\" OMCppOMCFactory.lib OMCppModelicaUtilities.lib  "));
        txt = Tpl.writeText(txt, a_timeMeasureLink);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" /LIBPATH:\""));
        txt = Tpl.writeStr(txt, i_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "/bin\" /LIBPATH:\"$(BOOST_LIBS)\"\n",
                                    "!ELSE\n",
                                    "LDSYSTEMFLAGS=  /link /DLL /NOENTRY /LIBPATH:\""
                                }, false));
        txt = Tpl.writeStr(txt, i_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/lib/"));
        txt = Tpl.writeStr(txt, Autoconf.triple);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/omc/cpp/msvc\" /LIBPATH:\""));
        txt = Tpl.writeStr(txt, i_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/lib/"));
        txt = Tpl.writeStr(txt, Autoconf.triple);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/omc/msvc\" /LIBPATH:\""));
        txt = Tpl.writeStr(txt, i_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/lib/"));
        txt = Tpl.writeStr(txt, Autoconf.triple);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/omc/msvc/debug\"  /LIBPATH:\""));
        txt = Tpl.writeStr(txt, i_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/bin\" /LIBPATH:\"$(BOOST_LIBS)\" OMCppSystem.lib OMCppModelicaUtilities.lib  OMCppMath.lib OMCppDataExchange.lib  OMCppOMCFactory.lib $(PCH_LIB) "));
        txt = Tpl.writeText(txt, a_timeMeasureLink);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " WSock32.lib Ws2_32.lib\n",
                                    "LDMAINFLAGS=/link /LIBPATH:\""
                                }, false));
        txt = Tpl.writeStr(txt, i_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/lib/"));
        txt = Tpl.writeStr(txt, Autoconf.triple);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/omc/cpp/msvc\" /LIBPATH:\""));
        txt = Tpl.writeStr(txt, i_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/lib/"));
        txt = Tpl.writeStr(txt, Autoconf.triple);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/omc/msvc\" OMCppOMCFactory.lib OMCppModelicaUtilities.lib $(PCH_LIB) "));
        txt = Tpl.writeText(txt, a_timeMeasureLink);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" /LIBPATH:\""));
        txt = Tpl.writeStr(txt, i_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "/bin\" /LIBPATH:\"$(BOOST_LIBS)\"\n",
                                    "!ENDIF\n",
                                    "# lib names should not be appended with a d just switch to lib/omc/cpp\n",
                                    "\n",
                                    "\n",
                                    "\n",
                                    "FILEPREFIX="
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("FUNCTIONFILE=OMCpp"));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Functions.cpp\n",
                                    "INITFILE=OMCpp"
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Initialize.cpp\n",
                                    "FACTORYFILE=OMCpp"
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "FactoryExport.cpp\n",
                                    "EXTENSIONFILE=OMCpp"
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Extension.cpp\n",
                                    "JACOBIANFILE=OMCpp"
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Jacobian.cpp\n",
                                    "STATESELECTIONFILE=OMCpp"
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "StateSelection.cpp\n",
                                    "WRITEOUTPUTFILE=OMCpp"
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "WriteOutput.cpp\n",
                                    "SYSTEMFILE=OMCpp"
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        ret_10 = Config.acceptMetaModelicaGrammar();
        txt = fun_347(txt, ret_10);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ".cpp\n",
                                    "MAINFILE = OMCpp"
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Main.cpp\n",
                                    "MAINOBJ="
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "$(EXEEXT)\n",
                                    "SYSTEMOBJ=OMCpp"
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "$(DLLEXT)\n",
                                    "\n",
                                    "CALCHELPERMAINFILE=OMCpp"
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "CalcHelperMain.cpp\n",
                                    "ALGLOOPMAINFILE=OMCpp"
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "AlgLoopMain.cpp\n",
                                    "GENERATEDFILES=$(MAINFILE) $(FUNCTIONFILE) $(ALGLOOPMAINFILE)\n",
                                    "\n",
                                    "$(MODELICA_SYSTEM_LIB)$(DLLEXT):\n"
                                }, true));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("$(CXX)  /Fe$(SYSTEMOBJ) $(CALCHELPERMAINFILE) $(CFLAGS) $(LDSYSTEMFLAGS) "));
        txt = Tpl.writeText(txt, l_dirExtra);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, l_libsPos1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, l_libsPos2);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("$(CXX) $(CPPFLAGS) /Fe$(MAINOBJ)  $(MAINFILE)   $(CFLAGS) $(LDMAINFLAGS)"));
      then (txt, a_timeMeasureLink);

    case ( txt,
           _,
           _,
           a_timeMeasureLink )
      then (txt, a_timeMeasureLink);
  end match;
end fun_348;

protected function fun_349
  input Tpl.Text in_txt;
  input String in_a_modelInfo_directory;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo_directory)
    local
      Tpl.Text txt;
      String i_modelInfo_directory;

    case ( txt,
           "" )
      then txt;

    case ( txt,
           i_modelInfo_directory )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/LIBPATH:\""));
        txt = Tpl.writeStr(txt, i_modelInfo_directory);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
      then txt;
  end match;
end fun_349;

protected function lm_350
  input Tpl.Text in_txt;
  input list<String> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<String> rest;
      String i_lib;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_lib :: rest )
      equation
        txt = Tpl.writeStr(txt, i_lib);
        txt = Tpl.nextIter(txt);
        txt = lm_350(txt, rest);
      then txt;
  end match;
end lm_350;

protected function fun_351
  input Tpl.Text in_txt;
  input Tpl.Text in_a_dirExtra;
  input Tpl.Text in_a_libsStr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_dirExtra, in_a_libsStr)
    local
      Tpl.Text txt;
      Tpl.Text a_libsStr;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           a_libsStr )
      equation
        txt = Tpl.writeText(txt, a_libsStr);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_351;

protected function fun_352
  input Tpl.Text in_txt;
  input Tpl.Text in_a_dirExtra;
  input Tpl.Text in_a_libsStr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_dirExtra, in_a_libsStr)
    local
      Tpl.Text txt;
      Tpl.Text a_libsStr;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           _ )
      then txt;

    case ( txt,
           _,
           a_libsStr )
      equation
        txt = Tpl.writeText(txt, a_libsStr);
      then txt;
  end match;
end fun_352;

protected function fun_353
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-lOMOCLRuntime -lOpenCL"));
      then txt;
  end match;
end fun_353;

protected function fun_354
  input Tpl.Text in_txt;
  input String in_a_s_method;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_s_method)
    local
      Tpl.Text txt;

    case ( txt,
           "dassljac" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-D_OMC_JACOBIAN "));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_354;

protected function fun_355
  input Tpl.Text in_txt;
  input Option<SimCode.SimulationSettings> in_a_sopt;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_sopt)
    local
      Tpl.Text txt;
      String i_s_method;

    case ( txt,
           SOME(SimCode.SIMULATION_SETTINGS(method = i_s_method)) )
      equation
        txt = fun_354(txt, i_s_method);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_355;

protected function fun_356
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_makefileParams_omhome;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_makefileParams_omhome)
    local
      Tpl.Text txt;
      String a_makefileParams_omhome;

    case ( txt,
           false,
           a_makefileParams_omhome )
      equation
        txt = Tpl.writeStr(txt, a_makefileParams_omhome);
      then txt;

    case ( txt,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("$(OPENMODELICAHOME)"));
      then txt;
  end match;
end fun_356;

protected function lm_357
  input Tpl.Text in_txt;
  input list<String> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<String> rest;
      String i_it;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_it :: rest )
      equation
        txt = Tpl.writeStr(txt, i_it);
        txt = lm_357(txt, rest);
      then txt;
  end match;
end lm_357;

protected function lm_358
  input Tpl.Text in_txt;
  input list<String> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<String> rest;
      String i_it;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_it :: rest )
      equation
        txt = Tpl.writeStr(txt, i_it);
        txt = lm_358(txt, rest);
      then txt;
  end match;
end lm_358;

protected function fun_359
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".conv"));
      then txt;
  end match;
end fun_359;

protected function fun_360
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input String in_a_additionalCFlags__MSVC;
  input Tpl.Text in_a_timeMeasureLink;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_timeMeasureLink;
algorithm
  (out_txt, out_a_timeMeasureLink) :=
  match(in_txt, in_a_simCode, in_a_additionalCFlags__MSVC, in_a_timeMeasureLink)
    local
      Tpl.Text txt;
      String a_additionalCFlags__MSVC;
      Tpl.Text a_timeMeasureLink;
      String i_fileNamePrefix;
      list<String> i_makefileParams_includes;
      String i_makefileParams_omhome;
      String i_makefileParams_platform;
      Option<SimCode.SimulationSettings> i_sopt;
      list<String> i_makefileParams_libs;
      String i_modelInfo_directory;
      Boolean ret_10;
      Boolean ret_9;
      Boolean ret_8;
      Boolean ret_7;
      Tpl.Text l_extraCflags;
      Boolean ret_5;
      Tpl.Text l_ParModelicaLibs;
      Tpl.Text l_libsPos2;
      Tpl.Text l_libsPos1;
      Tpl.Text l_libsStr;
      Tpl.Text l_dirExtra;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(directory = i_modelInfo_directory), makefileParams = SimCodeFunction.MAKEFILE_PARAMS(libs = i_makefileParams_libs, platform = i_makefileParams_platform, omhome = i_makefileParams_omhome, includes = i_makefileParams_includes), simulationSettingsOpt = i_sopt, fileNamePrefix = i_fileNamePrefix),
           a_additionalCFlags__MSVC,
           a_timeMeasureLink )
      equation
        l_dirExtra = fun_349(Tpl.emptyTxt, i_modelInfo_directory);
        l_libsStr = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(" ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_libsStr = lm_350(l_libsStr, i_makefileParams_libs);
        l_libsStr = Tpl.popIter(l_libsStr);
        l_libsPos1 = fun_351(Tpl.emptyTxt, l_dirExtra, l_libsStr);
        l_libsPos2 = fun_352(Tpl.emptyTxt, l_dirExtra, l_libsStr);
        ret_5 = Config.acceptParModelicaGrammar();
        l_ParModelicaLibs = fun_353(Tpl.emptyTxt, ret_5);
        a_timeMeasureLink = Tpl.writeTok(a_timeMeasureLink, Tpl.ST_STRING("OMCppExtensionUtilities.lib"));
        l_extraCflags = fun_355(Tpl.emptyTxt, i_sopt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "# Makefile generated by OpenModelica\n",
                                    "OMHOME="
                                }, false));
        ret_7 = stringEq(i_makefileParams_platform, "win32");
        ret_8 = stringEq(i_makefileParams_platform, "win64");
        ret_9 = boolOr(ret_7, ret_8);
        txt = fun_356(txt, ret_9, i_makefileParams_omhome);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "# Simulations use -O3 by default\n",
                                    "SIM_OR_DYNLOAD_OPT_LEVEL=\n",
                                    "MODELICAUSERCFLAGS=\n",
                                    "CXX=cl\n",
                                    "EXEEXT=.exe\n",
                                    "DLLEXT=.dll\n",
                                    "include "
                                }, false));
        txt = Tpl.writeStr(txt, i_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "/include/omc/cpp/ModelicaConfig_msvc.inc\n",
                                    "include "
                                }, false));
        txt = Tpl.writeStr(txt, i_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "/include/omc/cpp/ModelicaLibraryConfig_msvc.inc\n",
                                    "# /Od - Optimization disabled\n",
                                    "# /EHa enable C++ EH (w/ SEH exceptions)\n",
                                    "# /fp:except - consider floating-point exceptions when generating code\n",
                                    "# /arch:SSE2 - enable use of instructions available with SSE2 enabled CPUs\n",
                                    "# /I - Include Directories\n",
                                    "# /DNOMINMAX - Define NOMINMAX (does what it says)\n",
                                    "# /TP - Use C++ Compiler\n",
                                    "!IF \"$(PCH_FILE)\" == \"\"\n",
                                    "\n",
                                    "CFLAGS=  $(SYSTEM_CFLAGS) /I\""
                                }, false));
        txt = Tpl.writeStr(txt, i_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/include/omc/cpp/\" /I. "));
        txt = lm_357(txt, i_makefileParams_includes);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("  /I\"$(BOOST_INCLUDE)\" /I\"$(UMFPACK_INCLUDE)\" /I\"$(SUNDIALS_INCLUDE)\" /DNOMINMAX /TP /DNO_INTERACTIVE_DEPENDENCY "));
        txt = Tpl.writeStr(txt, a_additionalCFlags__MSVC);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "!ELSE\n",
                                    "CFLAGS=  $(SYSTEM_CFLAGS) /I\""
                                }, false));
        txt = Tpl.writeStr(txt, i_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/include/omc/cpp/\" /I. "));
        txt = lm_358(txt, i_makefileParams_includes);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("  /I\"$(BOOST_INCLUDE)\" /I\"$(UMFPACK_INCLUDE)\" /I\"$(SUNDIALS_INCLUDE)\" /DNOMINMAX /TP /DNO_INTERACTIVE_DEPENDENCY  /Fp"));
        txt = Tpl.writeStr(txt, i_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/include/omc/cpp/Core/$(PCH_FILE)  /YuCore/$(H_FILE) "));
        txt = Tpl.writeStr(txt, a_additionalCFlags__MSVC);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "!ENDIF\n",
                                    "CPPFLAGS =\n",
                                    "# /ZI enable Edit and Continue debug info\n",
                                    "CDFLAGS = /ZI\n",
                                    "!IF \"$(PCH_FILE)\" == \"\"\n",
                                    "LDSYSTEMFLAGS=  /link /DLL /NOENTRY /LIBPATH:\""
                                }, false));
        txt = Tpl.writeStr(txt, i_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/lib/"));
        txt = Tpl.writeStr(txt, Autoconf.triple);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/omc/cpp/msvc\" /LIBPATH:\""));
        txt = Tpl.writeStr(txt, i_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/lib/"));
        txt = Tpl.writeStr(txt, Autoconf.triple);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/omc/msvc\" /LIBPATH:\""));
        txt = Tpl.writeStr(txt, i_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/lib/"));
        txt = Tpl.writeStr(txt, Autoconf.triple);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/omc/msvc/debug\"  /LIBPATH:\""));
        txt = Tpl.writeStr(txt, i_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/bin\" /LIBPATH:\"$(BOOST_LIBS)\" OMCppSystem.lib OMCppModelicaUtilities.lib  OMCppMath.lib OMCppDataExchange.lib  OMCppOMCFactory.lib "));
        txt = Tpl.writeText(txt, a_timeMeasureLink);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " WSock32.lib Ws2_32.lib\n",
                                    "LDMAINFLAGS=/link /LIBPATH:\""
                                }, false));
        txt = Tpl.writeStr(txt, i_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/lib/"));
        txt = Tpl.writeStr(txt, Autoconf.triple);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/omc/cpp/msvc\" /LIBPATH:\""));
        txt = Tpl.writeStr(txt, i_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/lib/"));
        txt = Tpl.writeStr(txt, Autoconf.triple);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/omc/msvc\" OMCppOMCFactory.lib OMCppModelicaUtilities.lib  "));
        txt = Tpl.writeText(txt, a_timeMeasureLink);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" /LIBPATH:\""));
        txt = Tpl.writeStr(txt, i_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "/bin\" /LIBPATH:\"$(BOOST_LIBS)\"\n",
                                    "!ELSE\n",
                                    "LDSYSTEMFLAGS=  /link /DLL /NOENTRY /LIBPATH:\""
                                }, false));
        txt = Tpl.writeStr(txt, i_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/lib/"));
        txt = Tpl.writeStr(txt, Autoconf.triple);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/omc/cpp/msvc\" /LIBPATH:\""));
        txt = Tpl.writeStr(txt, i_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/lib/"));
        txt = Tpl.writeStr(txt, Autoconf.triple);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/omc/msvc\" /LIBPATH:\""));
        txt = Tpl.writeStr(txt, i_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/lib/"));
        txt = Tpl.writeStr(txt, Autoconf.triple);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/omc/msvc/debug\"  /LIBPATH:\""));
        txt = Tpl.writeStr(txt, i_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/bin\" /LIBPATH:\"$(BOOST_LIBS)\" OMCppSystem.lib OMCppModelicaUtilities.lib  OMCppMath.lib OMCppDataExchange.lib  OMCppOMCFactory.lib $(PCH_LIB) "));
        txt = Tpl.writeText(txt, a_timeMeasureLink);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " WSock32.lib Ws2_32.lib\n",
                                    "LDMAINFLAGS=/link /LIBPATH:\""
                                }, false));
        txt = Tpl.writeStr(txt, i_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/lib/"));
        txt = Tpl.writeStr(txt, Autoconf.triple);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/omc/cpp/msvc\" /LIBPATH:\""));
        txt = Tpl.writeStr(txt, i_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/lib/"));
        txt = Tpl.writeStr(txt, Autoconf.triple);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/omc/msvc\" OMCppOMCFactory.lib OMCppModelicaUtilities.lib $(PCH_LIB) "));
        txt = Tpl.writeText(txt, a_timeMeasureLink);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" /LIBPATH:\""));
        txt = Tpl.writeStr(txt, i_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "/bin\" /LIBPATH:\"$(BOOST_LIBS)\"\n",
                                    "!ENDIF\n",
                                    "# lib names should not be appended with a d just switch to lib/omc/cpp\n",
                                    "\n",
                                    "\n",
                                    "\n",
                                    "FILEPREFIX="
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("FUNCTIONFILE=OMCpp"));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Functions.cpp\n",
                                    "INITFILE=OMCpp"
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Initialize.cpp\n",
                                    "FACTORYFILE=OMCpp"
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "FactoryExport.cpp\n",
                                    "EXTENSIONFILE=OMCpp"
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Extension.cpp\n",
                                    "JACOBIANFILE=OMCpp"
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Jacobian.cpp\n",
                                    "STATESELECTIONFILE=OMCpp"
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "StateSelection.cpp\n",
                                    "WRITEOUTPUTFILE=OMCpp"
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "WriteOutput.cpp\n",
                                    "SYSTEMFILE=OMCpp"
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        ret_10 = Config.acceptMetaModelicaGrammar();
        txt = fun_359(txt, ret_10);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ".cpp\n",
                                    "MAINFILE = OMCpp"
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Main.cpp\n",
                                    "MAINOBJ="
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "$(EXEEXT)\n",
                                    "SYSTEMOBJ=OMCpp"
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "$(DLLEXT)\n",
                                    "\n",
                                    "CALCHELPERMAINFILE=OMCpp"
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "CalcHelperMain.cpp\n",
                                    "ALGLOOPMAINFILE=OMCpp"
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "AlgLoopMain.cpp\n",
                                    "GENERATEDFILES=$(MAINFILE) $(FUNCTIONFILE) $(ALGLOOPMAINFILE)\n",
                                    "\n",
                                    "$(MODELICA_SYSTEM_LIB)$(DLLEXT):\n"
                                }, true));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("$(CXX)  /Fe$(SYSTEMOBJ) $(CALCHELPERMAINFILE) $(CFLAGS) $(LDSYSTEMFLAGS) "));
        txt = Tpl.writeText(txt, l_dirExtra);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, l_libsPos1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, l_libsPos2);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("$(CXX) $(CPPFLAGS) /Fe$(MAINOBJ)  $(MAINFILE)   $(CFLAGS) $(LDMAINFLAGS)"));
      then (txt, a_timeMeasureLink);

    case ( txt,
           _,
           _,
           a_timeMeasureLink )
      then (txt, a_timeMeasureLink);
  end match;
end fun_360;

protected function fun_361
  input Tpl.Text in_txt;
  input String in_a_modelInfo_directory;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo_directory)
    local
      Tpl.Text txt;
      String i_modelInfo_directory;

    case ( txt,
           "" )
      then txt;

    case ( txt,
           i_modelInfo_directory )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-L\""));
        txt = Tpl.writeStr(txt, i_modelInfo_directory);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
      then txt;
  end match;
end fun_361;

protected function lm_362
  input Tpl.Text in_txt;
  input list<String> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<String> rest;
      String i_lib;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_lib :: rest )
      equation
        txt = Tpl.writeStr(txt, i_lib);
        txt = Tpl.nextIter(txt);
        txt = lm_362(txt, rest);
      then txt;
  end match;
end lm_362;

protected function fun_363
  input Tpl.Text in_txt;
  input Tpl.Text in_a_dirExtra;
  input Tpl.Text in_a_libsStr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_dirExtra, in_a_libsStr)
    local
      Tpl.Text txt;
      Tpl.Text a_libsStr;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           a_libsStr )
      equation
        txt = Tpl.writeText(txt, a_libsStr);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_363;

protected function fun_364
  input Tpl.Text in_txt;
  input Tpl.Text in_a_dirExtra;
  input Tpl.Text in_a_libsStr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_dirExtra, in_a_libsStr)
    local
      Tpl.Text txt;
      Tpl.Text a_libsStr;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           _ )
      then txt;

    case ( txt,
           _,
           a_libsStr )
      equation
        txt = Tpl.writeText(txt, a_libsStr);
      then txt;
  end match;
end fun_364;

protected function fun_365
  input Tpl.Text in_txt;
  input Option<SimCode.SimulationSettings> in_a_sopt;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_sopt)
    local
      Tpl.Text txt;

    case ( txt,
           SOME(SimCode.SIMULATION_SETTINGS(startTime = _)) )
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_365;

protected function fun_366
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" -g"));
      then txt;
  end match;
end fun_366;

protected function fun_367
  input Tpl.Text in_txt;
  input Boolean in_a_compileForMPI;
  input String in_a_makefileParams_ccompiler;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_compileForMPI, in_a_makefileParams_ccompiler)
    local
      Tpl.Text txt;
      String a_makefileParams_ccompiler;

    case ( txt,
           false,
           a_makefileParams_ccompiler )
      equation
        txt = Tpl.writeStr(txt, a_makefileParams_ccompiler);
      then txt;

    case ( txt,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("mpicc"));
      then txt;
  end match;
end fun_367;

protected function fun_368
  input Tpl.Text in_txt;
  input Boolean in_a_compileForMPI;
  input String in_a_makefileParams_cxxcompiler;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_compileForMPI, in_a_makefileParams_cxxcompiler)
    local
      Tpl.Text txt;
      String a_makefileParams_cxxcompiler;

    case ( txt,
           false,
           a_makefileParams_cxxcompiler )
      equation
        txt = Tpl.writeStr(txt, a_makefileParams_cxxcompiler);
      then txt;

    case ( txt,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("mpicxx"));
      then txt;
  end match;
end fun_368;

protected function lm_369
  input Tpl.Text in_txt;
  input list<String> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<String> rest;
      String i_flag;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_flag :: rest )
      equation
        txt = Tpl.writeStr(txt, i_flag);
        txt = Tpl.nextIter(txt);
        txt = lm_369(txt, rest);
      then txt;
  end match;
end lm_369;

protected function fun_370
  input Tpl.Text in_txt;
  input Boolean in_a_compileForMPI;
  input String in_a_makefileParams_cxxcompiler;
  input String in_a_makefileParams_ccompiler;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_compileForMPI, in_a_makefileParams_cxxcompiler, in_a_makefileParams_ccompiler)
    local
      Tpl.Text txt;
      String a_makefileParams_cxxcompiler;
      String a_makefileParams_ccompiler;

    case ( txt,
           false,
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_makefileParams_cxxcompiler,
           a_makefileParams_ccompiler )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("OMPI_MPICC="));
        txt = Tpl.writeStr(txt, a_makefileParams_ccompiler);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("OMPI_MPICXX="));
        txt = Tpl.writeStr(txt, a_makefileParams_cxxcompiler);
      then txt;
  end match;
end fun_370;

protected function fun_371
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_makefileParams_omhome;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_makefileParams_omhome)
    local
      Tpl.Text txt;
      String a_makefileParams_omhome;

    case ( txt,
           false,
           a_makefileParams_omhome )
      equation
        txt = Tpl.writeStr(txt, a_makefileParams_omhome);
      then txt;

    case ( txt,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("$(OPENMODELICAHOME)"));
      then txt;
  end match;
end fun_371;

protected function fun_372
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("OFF"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("ON"));
      then txt;
  end match;
end fun_372;

protected function lm_373
  input Tpl.Text in_txt;
  input list<String> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<String> rest;
      String i_it;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_it :: rest )
      equation
        txt = Tpl.writeStr(txt, i_it);
        txt = lm_373(txt, rest);
      then txt;
  end match;
end lm_373;

protected function lm_374
  input Tpl.Text in_txt;
  input list<String> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<String> rest;
      String i_it;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_it :: rest )
      equation
        txt = Tpl.writeStr(txt, i_it);
        txt = Tpl.nextIter(txt);
        txt = lm_374(txt, rest);
      then txt;
  end match;
end lm_374;

protected function fun_375
  input Tpl.Text in_txt;
  input Option<SimCode.SimulationSettings> in_a_sopt;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_sopt)
    local
      Tpl.Text txt;
      String i_s_cflags;

    case ( txt,
           SOME(SimCode.SIMULATION_SETTINGS(cflags = i_s_cflags)) )
      equation
        txt = Tpl.writeStr(txt, i_s_cflags);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_375;

protected function fun_376
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" -lz -lhdf5 "));
      then txt;
  end match;
end fun_376;

protected function fun_377
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" -lwsock32 -lws2_32 "));
      then txt;
  end match;
end fun_377;

protected function fun_378
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".conv"));
      then txt;
  end match;
end fun_378;

protected function fun_379
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_fileNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_fileNamePrefix)
    local
      Tpl.Text txt;
      String a_fileNamePrefix;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_fileNamePrefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("chmod +x "));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".sh"));
      then txt;
  end match;
end fun_379;

protected function fun_380
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_timeMeasureLink;
  input String in_a_additionalLinkerFlags__GCC;
  input String in_a_additionalCFlags__GCC;
  input Boolean in_a_compileForMPI;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode, in_a_timeMeasureLink, in_a_additionalLinkerFlags__GCC, in_a_additionalCFlags__GCC, in_a_compileForMPI)
    local
      Tpl.Text txt;
      Tpl.Text a_timeMeasureLink;
      String a_additionalLinkerFlags__GCC;
      String a_additionalCFlags__GCC;
      Boolean a_compileForMPI;
      Absyn.Path i_modelInfo_name;
      String i_fileNamePrefix;
      list<String> i_makefileParams_includes;
      String i_makefileParams_dllext;
      String i_makefileParams_exeext;
      String i_makefileParams_omhome;
      String i_makefileParams_platform;
      String i_makefileParams_cxxcompiler;
      String i_makefileParams_ccompiler;
      Option<SimCode.SimulationSettings> i_sopt;
      list<String> i_makefileParams_libs;
      String i_modelInfo_directory;
      Boolean ret_29;
      Boolean ret_28;
      Boolean ret_27;
      Boolean ret_26;
      Boolean ret_25;
      Boolean ret_24;
      Boolean ret_23;
      Boolean ret_22;
      Boolean ret_21;
      Boolean ret_20;
      Boolean ret_19;
      Boolean ret_18;
      Boolean ret_17;
      Boolean ret_16;
      Boolean ret_15;
      Tpl.Text l_MPIEnvVars;
      list<String> ret_13;
      Tpl.Text l_extraCppFlags;
      Tpl.Text l_CXX;
      Tpl.Text l_CC;
      Tpl.Text l_papiLibs;
      Boolean ret_8;
      Tpl.Text l_extraCflags;
      Tpl.Text l_0__extraCflags;
      Tpl.Text l_staticIncludes;
      Tpl.Text l_staticLibs;
      Tpl.Text l_libsPos2;
      Tpl.Text l_libsPos1;
      Tpl.Text l_libsStr;
      Tpl.Text l_dirExtra;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(directory = i_modelInfo_directory, name = i_modelInfo_name), makefileParams = SimCodeFunction.MAKEFILE_PARAMS(libs = i_makefileParams_libs, ccompiler = i_makefileParams_ccompiler, cxxcompiler = i_makefileParams_cxxcompiler, platform = i_makefileParams_platform, omhome = i_makefileParams_omhome, exeext = i_makefileParams_exeext, dllext = i_makefileParams_dllext, includes = i_makefileParams_includes), simulationSettingsOpt = i_sopt, fileNamePrefix = i_fileNamePrefix),
           a_timeMeasureLink,
           a_additionalLinkerFlags__GCC,
           a_additionalCFlags__GCC,
           a_compileForMPI )
      equation
        l_dirExtra = fun_361(Tpl.emptyTxt, i_modelInfo_directory);
        l_libsStr = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(" ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_libsStr = lm_362(l_libsStr, i_makefileParams_libs);
        l_libsStr = Tpl.popIter(l_libsStr);
        l_libsPos1 = fun_363(Tpl.emptyTxt, l_dirExtra, l_libsStr);
        l_libsPos2 = fun_364(Tpl.emptyTxt, l_dirExtra, l_libsStr);
        l_staticLibs = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("-Wl,--start-group -lOMCppOMCFactory_static -lOMCppSystem_static -lOMCppSimController_static -Wl,--end-group -lOMCppSimulationSettings_static -lOMCppDataExchange_static -lOMCppDgesvSolver_static -lOMCppNewton_static -lOMCppLinearSolver_static -lOMCppEuler_static -lOMCppKinsol_static -lOMCppCVode_static -lOMCppIDA_static -lOMCppSolver_static -lOMCppMath_static -lOMCppModelicaUtilities_static -lOMCppExtensionUtilities_static -L$(SUNDIALS_LIBS) -L$(UMFPACK_LIBS) -L$(LAPACK_LIBS)"));
        l_staticIncludes = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("-I\"$(SUNDIALS_INCLUDE)\" -I\"$(SUNDIALS_INCLUDE)/kinsol\" -I\"$(SUNDIALS_INCLUDE)/nvector\""));
        l_0__extraCflags = fun_365(Tpl.emptyTxt, i_sopt);
        l_extraCflags = Tpl.writeText(Tpl.emptyTxt, l_0__extraCflags);
        ret_8 = Flags.isSet(Flags.GEN_DEBUG_SYMBOLS);
        l_extraCflags = fun_366(l_extraCflags, ret_8);
        l_papiLibs = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING(" -lOMCppExtensionUtilities_papi -lpapi"));
        l_CC = fun_367(Tpl.emptyTxt, a_compileForMPI, i_makefileParams_ccompiler);
        l_CXX = fun_368(Tpl.emptyTxt, a_compileForMPI, i_makefileParams_cxxcompiler);
        ret_13 = Flags.getConfigStringList(Flags.CPP_FLAGS);
        l_extraCppFlags = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(" ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_extraCppFlags = lm_369(l_extraCppFlags, ret_13);
        l_extraCppFlags = Tpl.popIter(l_extraCppFlags);
        l_MPIEnvVars = fun_370(Tpl.emptyTxt, a_compileForMPI, i_makefileParams_cxxcompiler, i_makefileParams_ccompiler);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "# Makefile generated by OpenModelica\n",
                                    "OMHOME="
                                }, false));
        ret_15 = stringEq(i_makefileParams_platform, "win32");
        ret_16 = stringEq(i_makefileParams_platform, "win64");
        ret_17 = boolOr(ret_15, ret_16);
        txt = fun_371(txt, ret_17, i_makefileParams_omhome);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "include $(OMHOME)/include/omc/cpp/ModelicaConfig_gcc.inc\n",
                                    "include $(OMHOME)/include/omc/cpp/ModelicaLibraryConfig_gcc.inc\n",
                                    "\n",
                                    "# Simulations use -O0 by default\n",
                                    "SIM_OR_DYNLOAD_OPT_LEVEL=-O0\n",
                                    "CC="
                                }, false));
        txt = Tpl.writeText(txt, l_CC);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("CXX="));
        txt = Tpl.writeText(txt, l_CXX);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " $(OPENMP_FLAGS)\n",
                                    "RUNTIME_STATIC_LINKING="
                                }, false));
        ret_18 = Flags.isSet(Flags.RUNTIME_STATIC_LINKING);
        txt = fun_372(txt, ret_18);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_MPIEnvVars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "EXEEXT="
                                }, false));
        txt = Tpl.writeStr(txt, i_makefileParams_exeext);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("DLLEXT="));
        txt = Tpl.writeStr(txt, i_makefileParams_dllext);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "CFLAGS_COMMON="
                                }, false));
        txt = Tpl.writeText(txt, l_extraCflags);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" -Winvalid-pch $(SYSTEM_CFLAGS) -I\"$(SCOREP_INCLUDE)\" -I\"$(OMHOME)/include/omc/cpp/\" -I. "));
        txt = lm_373(txt, i_makefileParams_includes);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" -I\"$(BOOST_INCLUDE)\" -I\"$(UMFPACK_INCLUDE)\" -I\"$(SUNDIALS_INCLUDE)\" "));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(" ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_374(txt, i_makefileParams_includes);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = fun_375(txt, i_sopt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeStr(txt, a_additionalCFlags__GCC);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, l_extraCppFlags);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "ifeq ($(USE_SCOREP),ON)\n",
                                    "$(eval CC=scorep --user --nocompiler $(CC))\n",
                                    "$(eval CXX=scorep --user --nocompiler $(CXX))\n",
                                    "else\n",
                                    "$(eval CFLAGS_COMMON=$(CFLAGS_COMMON) -DMEASURETIME_PROFILEBLOCKS)\n",
                                    "endif\n",
                                    "\n",
                                    "ifeq ($(USE_LOGGER),ON)\n",
                                    "$(eval CFLAGS_COMMON=$(CFLAGS_COMMON) -DUSE_LOGGER)\n",
                                    "endif\n",
                                    "\n",
                                    "CFLAGS_DYNAMIC=$(CFLAGS_COMMON)\n",
                                    "CFLAGS_STATIC=$(CFLAGS_COMMON) "
                                }, false));
        txt = Tpl.writeText(txt, l_staticIncludes);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " -DRUNTIME_STATIC_LINKING -DENABLE_SUNDIALS_STATIC\n",
                                    "\n",
                                    "MINGW_EXTRA_LIBS="
                                }, false));
        ret_19 = stringEq(i_makefileParams_platform, "win32");
        ret_20 = stringEq(i_makefileParams_platform, "win64");
        ret_21 = boolOr(ret_19, ret_20);
        txt = fun_376(txt, ret_21);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "MODELICA_EXTERNAL_LIBS=-L$(LAPACK_LIBS) $(LAPACK_LIBRARIES) $(MINGW_EXTRA_LIBS)\n",
                                    "\n",
                                    "LDSYSTEMFLAGS_COMMON=-L\"$(OMHOME)/lib/"
                                }, false));
        txt = Tpl.writeStr(txt, Autoconf.triple);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/omc/cpp\" $(BASE_LIB) "));
        txt = Tpl.writeStr(txt, a_additionalLinkerFlags__GCC);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("  -Wl,-rpath,\"$(OMHOME)/lib/"));
        txt = Tpl.writeStr(txt, Autoconf.triple);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/omc/cpp\" "));
        txt = Tpl.writeText(txt, a_timeMeasureLink);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " -L\"$(BOOST_LIBS)\" $(BOOST_LIBRARIES) $(LINUX_LIB_DL)\n",
                                    "LDMAINFLAGS_COMMON=-L\"$(OMHOME)/lib/"
                                }, false));
        txt = Tpl.writeStr(txt, Autoconf.triple);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/omc/cpp\" -L\"$(OMHOME)/bin\" -L\"$(BOOST_LIBS)\" $(BOOST_LIBRARIES) $(LINUX_LIB_DL) "));
        txt = Tpl.writeStr(txt, a_additionalLinkerFlags__GCC);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("  -Wl,-rpath,\"$(OMHOME)/lib/"));
        txt = Tpl.writeStr(txt, Autoconf.triple);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/omc/cpp\" "));
        ret_22 = stringEq(i_makefileParams_platform, "win32");
        ret_23 = stringEq(i_makefileParams_platform, "win64");
        ret_24 = boolOr(ret_22, ret_23);
        txt = fun_377(txt, ret_24);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "ifeq ($(USE_PAPI),ON)\n",
                                    "$(eval LDMAINFLAGS_COMMON=$(LDMAINFLAGS_COMMON) "
                                }, false));
        txt = Tpl.writeText(txt, l_papiLibs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ")\n",
                                    "$(eval LDSYSTEMFLAGS_COMMON=$(LDSYSTEMFLAGS_COMMON) "
                                }, false));
        txt = Tpl.writeText(txt, l_papiLibs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ")\n",
                                    "endif\n",
                                    "\n",
                                    "LDSYSTEMFLAGS_DYNAMIC=-lOMCppSystem -lOMCppModelicaUtilities -lOMCppDataExchange -lOMCppMath -lOMCppExtensionUtilities -lOMCppOMCFactory $(LDSYSTEMFLAGS_COMMON)\n",
                                    "LDSYSTEMFLAGS_STATIC=$(LDSYSTEMFLAGS_COMMON) "
                                }, false));
        txt = Tpl.writeText(txt, l_staticLibs);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "LDMAINFLAGS_DYNAMIC= -lOMCppOMCFactory -lOMCppModelicaUtilities -lOMCppExtensionUtilities $(LDMAINFLAGS_COMMON)\n",
                                    "LDMAINFLAGS_STATIC=$(LDMAINFLAGS_COMMON) "
                                }, false));
        txt = Tpl.writeText(txt, l_staticLibs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " $(SUNDIALS_LIBRARIES) $(LAPACK_LIBRARIES)\n",
                                    "\n",
                                    "ifeq ($(RUNTIME_STATIC_LINKING),ON)\n",
                                    "$(eval CFLAGS=$(CFLAGS_STATIC))\n",
                                    "$(eval LDSYSTEMFLAGS=$(LDSYSTEMFLAGS_STATIC))\n",
                                    "$(eval LDMAINFLAGS=$(LDMAINFLAGS_STATIC))\n",
                                    "else\n",
                                    "$(eval CFLAGS=$(CFLAGS_DYNAMIC))\n",
                                    "$(eval LDSYSTEMFLAGS=$(LDSYSTEMFLAGS_DYNAMIC))\n",
                                    "$(eval LDMAINFLAGS=$(LDMAINFLAGS_DYNAMIC))\n",
                                    "endif\n",
                                    "\n",
                                    "CPPFLAGS=$(CFLAGS)\n",
                                    "\n",
                                    "SYSTEMFILE=OMCpp"
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        ret_25 = Config.acceptMetaModelicaGrammar();
        txt = fun_378(txt, ret_25);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ".cpp\n",
                                    "MAINFILE = OMCpp"
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Main.cpp\n",
                                    "MAINOBJ="
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "$(EXEEXT)\n",
                                    "SYSTEMOBJ=OMCpp"
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "$(DLLEXT)\n",
                                    "\n",
                                    "CALCHELPERMAINFILE=OMCpp"
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "CalcHelperMain.cpp\n",
                                    "ALGLOOPSMAINFILE=OMCpp"
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "AlgLoopMain.cpp\n",
                                    "\n",
                                    "CPPFILES=$(CALCHELPERMAINFILE)\n",
                                    "OFILES=$(CPPFILES:.cpp=.o)\n",
                                    "\n",
                                    ".PHONY: "
                                }, false));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " $(CPPFILES)\n",
                                    "\n"
                                }, true));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ": $(MAINFILE) $(OFILES)\n",
                                    "\n",
                                    "ifeq ($(RUNTIME_STATIC_LINKING),ON)\n"
                                }, true));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "$(CXX) $(CFLAGS) -I. -o $(MAINOBJ) $(MAINFILE) $(LDMAINFLAGS) $(MODELICA_EXTERNAL_LIBS)\n",
                                    "else\n"
                                }, true));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("$(CXX) -shared -o $(SYSTEMOBJ) $(OFILES) "));
        txt = Tpl.writeText(txt, l_dirExtra);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, l_libsPos1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, l_libsPos2);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" $(LDSYSTEMFLAGS) $(MODELICA_EXTERNAL_LIBS)\n"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "$(CXX) $(CFLAGS) -I. -o $(MAINOBJ) $(MAINFILE) $(LDMAINFLAGS)\n",
                                    "endif\n",
                                    "\n"
                                }, true));
        ret_26 = stringEq(i_makefileParams_platform, "win32");
        ret_27 = stringEq(i_makefileParams_platform, "win64");
        ret_28 = boolOr(ret_26, ret_27);
        ret_29 = boolNot(ret_28);
        txt = fun_379(txt, ret_29, i_fileNamePrefix);
      then txt;

    case ( txt,
           _,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_380;

protected function fun_381
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      String i_fileNamePrefix;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = _), makefileParams = SimCodeFunction.MAKEFILE_PARAMS(ccompiler = _), simulationSettingsOpt = _, fileNamePrefix = i_fileNamePrefix) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "BUILD_SPEC=ATOMgnu\n",
                                    "DEBUG_MODE=1\n",
                                    "TRACE=1\n",
                                    "\n",
                                    "MODEL_NAME = "
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "OPENMODELICAHOME := $(subst \\,/,$(OPENMODELICAHOME))\n",
                                    "WIND_HOME := $(subst \\,/,$(WIND_HOME))\n",
                                    "WIND_BASE := $(WIND_HOME)/customBosch/vxworks-6.9\n",
                                    "export WIND_BASE\n",
                                    "MLPI_SDK_01 := $(subst \\,/,$(MLPI_SDK_01))\n",
                                    "\n",
                                    "\n",
                                    "all : clean pre_build main_all post_build\n",
                                    "\n",
                                    "_clean ::\n"
                                }, true));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "@echo \"make: removing targets and objects of `pwd`\"\n",
                                    "\n",
                                    "TRACE=0\n",
                                    "TRACEON=$(TRACE:0=@)\n",
                                    "TRACE_FLAG=$(TRACEON:1=)\n",
                                    "\n",
                                    "JOBS?=1\n",
                                    "TARGET_JOBS?=$(JOBS)\n",
                                    "\n",
                                    "MAKEFILE := Makefile\n",
                                    "\n",
                                    "FLEXIBLE_BUILD := 1\n",
                                    "\n",
                                    "BUILD_SPEC = ATOMgnu\n",
                                    "DEBUG_MODE = 1\n",
                                    "ifeq ($(DEBUG_MODE),1)\n",
                                    "MODE_DIR := Debug\n",
                                    "else\n",
                                    "MODE_DIR := NonDebug\n",
                                    "endif\n",
                                    "OBJ_DIR := .\n",
                                    "\n",
                                    "\n",
                                    "\n",
                                    "\n",
                                    "#Global Build Macros\n",
                                    "PROJECT_TYPE = DKM\n",
                                    "DEFINES =\n",
                                    "EXPAND_DBG = 0\n",
                                    "\n",
                                    "\n",
                                    "#BuildSpec specific Build Macros\n",
                                    "VX_CPU_FAMILY = pentium\n",
                                    "CPU = ATOM\n",
                                    "TOOL_FAMILY = gnu\n",
                                    "TOOL = gnu\n",
                                    "TOOL_PATH = $(WIND_HOME)/gnu/4.3.3-vxworks-6.9/x86-win32/bin/\n",
                                    "CC_ARCH_SPEC = -march=atom -nostdlib -fno-builtin -fno-defer-pop -fno-implicit-fp\n",
                                    "VSB_DIR = $(WIND_BASE)/target/lib\n",
                                    "VSB_CONFIG_FILE = $(VSB_DIR)/h/config/vsbConfig.h\n",
                                    "LIBPATH =\n",
                                    "LIBS =\n",
                                    "\n",
                                    "IDE_INCLUDES = -I$(WIND_BASE)/target/h -I$(WIND_BASE)/target/h/wrn/coreip -I$(MLPI_SDK_01)/mlpiCore/include -I$(OPENMODELICAHOME)/include/omc/cpp -I$(OPENMODELICAHOME)/include/omc/cpp/Core -I$(OPENMODELICAHOME)/include/omc/cpp\n",
                                    "\n",
                                    "IDE_LIBRARIES = $(OPENMODELICAHOME)/lib/omc/cpp/vxworks/SimCore.a\n",
                                    "\n",
                                    "IDE_DEFINES = -DCPU=_VX_$(CPU) -DTOOL_FAMILY=$(TOOL_FAMILY) -DTOOL=$(TOOL) -D_WRS_KERNEL -D_VSB_CONFIG_FILE=\\\"$(VSB_DIR)/h/config/vsbConfig.h\\\"\n",
                                    "\n",
                                    "\n",
                                    "\n",
                                    "#BuildTool flags\n",
                                    "ifeq ($(DEBUG_MODE),1)\n",
                                    "DEBUGFLAGS_C-Compiler = -g\n",
                                    "DEBUGFLAGS_C++-Compiler = -g\n",
                                    "DEBUGFLAGS_Linker = -g\n",
                                    "DEBUGFLAGS_Partial-Image-Linker =\n",
                                    "DEBUGFLAGS_Librarian =\n",
                                    "DEBUGFLAGS_Assembler = -g\n",
                                    "else\n",
                                    "DEBUGFLAGS_C-Compiler =  -O2\n",
                                    "DEBUGFLAGS_C++-Compiler =  -O2\n",
                                    "DEBUGFLAGS_Linker =  -O2\n",
                                    "DEBUGFLAGS_Partial-Image-Linker =\n",
                                    "DEBUGFLAGS_Librarian =\n",
                                    "DEBUGFLAGS_Assembler =  -O2\n",
                                    "endif\n",
                                    "\n",
                                    "\n",
                                    "#Project Targets\n",
                                    "PROJECT_TARGETS = com.boschrexroth.$(MODEL_NAME)/$(MODE_DIR)/com.boschrexroth.$(MODEL_NAME).out \\\n"
                                }, true));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "com.boschrexroth.$(MODEL_NAME)_partialImage/$(MODE_DIR)/com.boschrexroth.$(MODEL_NAME)_partialImage.o\n",
                                    "\n",
                                    "\n",
                                    "#Rules\n",
                                    "\n",
                                    "# com.boschrexroth.$(MODEL_NAME)\n",
                                    "ifeq ($(DEBUG_MODE),1)\n",
                                    "com.boschrexroth.$(MODEL_NAME)/$(MODE_DIR)/% : DEBUGFLAGS_C-Compiler = -g\n",
                                    "com.boschrexroth.$(MODEL_NAME)/$(MODE_DIR)/% : DEBUGFLAGS_C++-Compiler = -g\n",
                                    "com.boschrexroth.$(MODEL_NAME)/$(MODE_DIR)/% : DEBUGFLAGS_Linker = -g\n",
                                    "com.boschrexroth.$(MODEL_NAME)/$(MODE_DIR)/% : DEBUGFLAGS_Partial-Image-Linker =\n",
                                    "com.boschrexroth.$(MODEL_NAME)/$(MODE_DIR)/% : DEBUGFLAGS_Librarian =\n",
                                    "com.boschrexroth.$(MODEL_NAME)/$(MODE_DIR)/% : DEBUGFLAGS_Assembler = -g\n",
                                    "else\n",
                                    "com.boschrexroth.$(MODEL_NAME)/$(MODE_DIR)/% : DEBUGFLAGS_C-Compiler =  -O2\n",
                                    "com.boschrexroth.$(MODEL_NAME)/$(MODE_DIR)/% : DEBUGFLAGS_C++-Compiler =  -O2\n",
                                    "com.boschrexroth.$(MODEL_NAME)/$(MODE_DIR)/% : DEBUGFLAGS_Linker =  -O2\n",
                                    "com.boschrexroth.$(MODEL_NAME)/$(MODE_DIR)/% : DEBUGFLAGS_Partial-Image-Linker =\n",
                                    "com.boschrexroth.$(MODEL_NAME)/$(MODE_DIR)/% : DEBUGFLAGS_Librarian =\n",
                                    "com.boschrexroth.$(MODEL_NAME)/$(MODE_DIR)/% : DEBUGFLAGS_Assembler =  -O2\n",
                                    "endif\n",
                                    "com.boschrexroth.$(MODEL_NAME)/$(MODE_DIR)/% : IDE_INCLUDES = -I$(WIND_BASE)/target/h -I$(WIND_BASE)/target/h/wrn/coreip -I$(MLPI_SDK_01)/mlpiCore/include -I$(OPENMODELICAHOME)/include/omc/cpp -I$(OPENMODELICAHOME)/include/omc/cpp/Core -I$(OPENMODELICAHOME)/include/omc/cpp\n",
                                    "com.boschrexroth.$(MODEL_NAME)/$(MODE_DIR)/% : IDE_LIBRARIES = $(OPENMODELICAHOME)/lib/omc/cpp/vxworks/SimCore.a\n",
                                    "com.boschrexroth.$(MODEL_NAME)/$(MODE_DIR)/% : IDE_DEFINES = -DCPU=_VX_$(CPU) -DTOOL_FAMILY=$(TOOL_FAMILY) -DTOOL=$(TOOL) -D_WRS_KERNEL -D_VSB_CONFIG_FILE=\\\"$(VSB_DIR)/h/config/vsbConfig.h\\\"\n",
                                    "com.boschrexroth.$(MODEL_NAME)/$(MODE_DIR)/% : PROJECT_TYPE = DKM\n",
                                    "com.boschrexroth.$(MODEL_NAME)/$(MODE_DIR)/% : DEFINES =\n",
                                    "com.boschrexroth.$(MODEL_NAME)/$(MODE_DIR)/% : EXPAND_DBG = 0\n",
                                    "com.boschrexroth.$(MODEL_NAME)/$(MODE_DIR)/% : VX_CPU_FAMILY = pentium\n",
                                    "com.boschrexroth.$(MODEL_NAME)/$(MODE_DIR)/% : CPU = ATOM\n",
                                    "com.boschrexroth.$(MODEL_NAME)/$(MODE_DIR)/% : TOOL_FAMILY = gnu\n",
                                    "com.boschrexroth.$(MODEL_NAME)/$(MODE_DIR)/% : TOOL = gnu\n",
                                    "com.boschrexroth.$(MODEL_NAME)/$(MODE_DIR)/% : TOOL_PATH = $(WIND_HOME)/gnu/4.3.3-vxworks-6.9/x86-win32/bin/\n",
                                    "com.boschrexroth.$(MODEL_NAME)/$(MODE_DIR)/% : CC_ARCH_SPEC = -march=atom -nostdlib -fno-builtin -fno-defer-pop -fno-implicit-fp\n",
                                    "com.boschrexroth.$(MODEL_NAME)/$(MODE_DIR)/% : VSB_DIR = $(WIND_BASE)/target/lib\n",
                                    "com.boschrexroth.$(MODEL_NAME)/$(MODE_DIR)/% : VSB_CONFIG_FILE = $(VSB_DIR)/h/config/vsbConfig.h\n",
                                    "com.boschrexroth.$(MODEL_NAME)/$(MODE_DIR)/% : LIBPATH =\n",
                                    "com.boschrexroth.$(MODEL_NAME)/$(MODE_DIR)/% : LIBS =\n",
                                    "com.boschrexroth.$(MODEL_NAME)/$(MODE_DIR)/% : OBJ_DIR := com.boschrexroth.$(MODEL_NAME)/$(MODE_DIR)\n",
                                    "\n",
                                    "OBJECTS_com.boschrexroth.$(MODEL_NAME) = com.boschrexroth.$(MODEL_NAME)_partialImage/$(MODE_DIR)/com.boschrexroth.$(MODEL_NAME)_partialImage.o\n",
                                    "\n",
                                    "ifeq ($(TARGET_JOBS),1)\n",
                                    "com.boschrexroth.$(MODEL_NAME)/$(MODE_DIR)/com.boschrexroth.$(MODEL_NAME).out : $(OBJECTS_com.boschrexroth.$(MODEL_NAME))\n"
                                }, true));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "$(TRACE_FLAG)if [ ! -d \"`dirname \"$@\"`\" ]; then mkdir -p \"`dirname \"$@\"`\"; fi;echo \"building $@\";rm -f \"$@\";nmpentium $(OBJECTS_com.boschrexroth.$(MODEL_NAME)) | $(WIND_HOME)/workbench-3.3/foundation/x86-win32/bin/tclsh $(WIND_BASE)/host/resource/hutils/tcl/munch.tcl -c pentium -tags $(VSB_DIR)/tags/pentium/ATOM/common/dkm.tags > $(OBJ_DIR)/ctdt.c; $(TOOL_PATH)ccpentium $(DEBUGFLAGS_Linker) $(CC_ARCH_SPEC) -fdollars-in-identifiers -Wall -Wsystem-headers  $(ADDED_CFLAGS) $(IDE_INCLUDES) $(ADDED_INCLUDES)  $(IDE_DEFINES) $(DEFINES) -o $(OBJ_DIR)/ctdt.o -c $(OBJ_DIR)/ctdt.c; $(TOOL_PATH)ccpentium -r -nostdlib -Wl,-X -T $(WIND_BASE)/target/h/tool/gnu/ldscripts/link.OUT -o \"$@\" $(OBJ_DIR)/ctdt.o $(OBJECTS_com.boschrexroth.$(MODEL_NAME)) $(IDE_LIBRARIES) $(LIBPATH) $(LIBS) $(ADDED_LIBPATH) $(ADDED_LIBS) && if [ \"$(EXPAND_DBG)\" = \"1\" ]; then plink \"$@\";fi\n",
                                    "\n",
                                    "else\n",
                                    "com.boschrexroth.$(MODEL_NAME)/$(MODE_DIR)/com.boschrexroth.$(MODEL_NAME).out : com.boschrexroth.$(MODEL_NAME)/$(MODE_DIR)/com.boschrexroth.$(MODEL_NAME).out_jobs\n",
                                    "\n",
                                    "endif\n",
                                    "com.boschrexroth.$(MODEL_NAME)/$(MODE_DIR)/com.boschrexroth.$(MODEL_NAME)_compile_file : $(FILE) ;\n",
                                    "\n",
                                    "_clean :: com.boschrexroth.$(MODEL_NAME)/$(MODE_DIR)/com.boschrexroth.$(MODEL_NAME)_clean\n",
                                    "\n",
                                    "com.boschrexroth.$(MODEL_NAME)/$(MODE_DIR)/com.boschrexroth.$(MODEL_NAME)_clean :\n"
                                }, true));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "$(TRACE_FLAG)if [ -d \"com.boschrexroth.$(MODEL_NAME)\" ]; then cd \"com.boschrexroth.$(MODEL_NAME)\"; rm -rf $(MODE_DIR); fi\n",
                                    "\n",
                                    "\n",
                                    "# com.boschrexroth.$(MODEL_NAME)_partialImage\n",
                                    "ifeq ($(DEBUG_MODE),1)\n",
                                    "com.boschrexroth.$(MODEL_NAME)_partialImage/$(MODE_DIR)/% : DEBUGFLAGS_C-Compiler = -g\n",
                                    "com.boschrexroth.$(MODEL_NAME)_partialImage/$(MODE_DIR)/% : DEBUGFLAGS_C++-Compiler = -g\n",
                                    "com.boschrexroth.$(MODEL_NAME)_partialImage/$(MODE_DIR)/% : DEBUGFLAGS_Linker = -g\n",
                                    "com.boschrexroth.$(MODEL_NAME)_partialImage/$(MODE_DIR)/% : DEBUGFLAGS_Partial-Image-Linker =\n",
                                    "com.boschrexroth.$(MODEL_NAME)_partialImage/$(MODE_DIR)/% : DEBUGFLAGS_Librarian =\n",
                                    "com.boschrexroth.$(MODEL_NAME)_partialImage/$(MODE_DIR)/% : DEBUGFLAGS_Assembler = -g\n",
                                    "else\n",
                                    "com.boschrexroth.$(MODEL_NAME)_partialImage/$(MODE_DIR)/% : DEBUGFLAGS_C-Compiler =  -O2\n",
                                    "com.boschrexroth.$(MODEL_NAME)_partialImage/$(MODE_DIR)/% : DEBUGFLAGS_C++-Compiler =  -O2\n",
                                    "com.boschrexroth.$(MODEL_NAME)_partialImage/$(MODE_DIR)/% : DEBUGFLAGS_Linker =  -O2\n",
                                    "com.boschrexroth.$(MODEL_NAME)_partialImage/$(MODE_DIR)/% : DEBUGFLAGS_Partial-Image-Linker =\n",
                                    "com.boschrexroth.$(MODEL_NAME)_partialImage/$(MODE_DIR)/% : DEBUGFLAGS_Librarian =\n",
                                    "com.boschrexroth.$(MODEL_NAME)_partialImage/$(MODE_DIR)/% : DEBUGFLAGS_Assembler =  -O2\n",
                                    "endif\n",
                                    "com.boschrexroth.$(MODEL_NAME)_partialImage/$(MODE_DIR)/% : IDE_INCLUDES = -I$(WIND_BASE)/target/h -I$(WIND_BASE)/target/h/wrn/coreip -I$(MLPI_SDK_01)/mlpiCore/include -I$(OPENMODELICAHOME)/include/omc/cpp -I$(OPENMODELICAHOME)/include/omc/cpp/Core -I$(OPENMODELICAHOME)/include/omc/cpp\n",
                                    "com.boschrexroth.$(MODEL_NAME)_partialImage/$(MODE_DIR)/% : IDE_LIBRARIES = $(OPENMODELICAHOME)/lib/omc/cpp/vxworks/SimCore.a\n",
                                    "com.boschrexroth.$(MODEL_NAME)_partialImage/$(MODE_DIR)/% : IDE_DEFINES = -DCPU=_VX_$(CPU) -DTOOL_FAMILY=$(TOOL_FAMILY) -DTOOL=$(TOOL) -D_WRS_KERNEL -D_VSB_CONFIG_FILE=\\\"$(VSB_DIR)/h/config/vsbConfig.h\\\"\n",
                                    "com.boschrexroth.$(MODEL_NAME)_partialImage/$(MODE_DIR)/% : PROJECT_TYPE = DKM\n",
                                    "com.boschrexroth.$(MODEL_NAME)_partialImage/$(MODE_DIR)/% : DEFINES =\n",
                                    "com.boschrexroth.$(MODEL_NAME)_partialImage/$(MODE_DIR)/% : EXPAND_DBG = 0\n",
                                    "com.boschrexroth.$(MODEL_NAME)_partialImage/$(MODE_DIR)/% : VX_CPU_FAMILY = pentium\n",
                                    "com.boschrexroth.$(MODEL_NAME)_partialImage/$(MODE_DIR)/% : CPU = ATOM\n",
                                    "com.boschrexroth.$(MODEL_NAME)_partialImage/$(MODE_DIR)/% : TOOL_FAMILY = gnu\n",
                                    "com.boschrexroth.$(MODEL_NAME)_partialImage/$(MODE_DIR)/% : TOOL = gnu\n",
                                    "com.boschrexroth.$(MODEL_NAME)_partialImage/$(MODE_DIR)/% : TOOL_PATH = $(WIND_HOME)/gnu/4.3.3-vxworks-6.9/x86-win32/bin/\n",
                                    "com.boschrexroth.$(MODEL_NAME)_partialImage/$(MODE_DIR)/% : CC_ARCH_SPEC = -march=atom -nostdlib -fno-builtin -fno-defer-pop -fno-implicit-fp\n",
                                    "com.boschrexroth.$(MODEL_NAME)_partialImage/$(MODE_DIR)/% : VSB_DIR = $(WIND_BASE)/target/lib\n",
                                    "com.boschrexroth.$(MODEL_NAME)_partialImage/$(MODE_DIR)/% : VSB_CONFIG_FILE = $(VSB_DIR)/h/config/vsbConfig.h\n",
                                    "com.boschrexroth.$(MODEL_NAME)_partialImage/$(MODE_DIR)/% : LIBPATH =\n",
                                    "com.boschrexroth.$(MODEL_NAME)_partialImage/$(MODE_DIR)/% : LIBS =\n",
                                    "com.boschrexroth.$(MODEL_NAME)_partialImage/$(MODE_DIR)/% : OBJ_DIR := com.boschrexroth.$(MODEL_NAME)_partialImage/$(MODE_DIR)\n",
                                    "\n",
                                    "\n",
                                    "\n",
                                    "com.boschrexroth.$(MODEL_NAME)_partialImage/$(MODE_DIR)/Objects/com.boschrexroth.$(MODEL_NAME)/OMCpp$(MODEL_NAME)CalcHelperMain.o : OMCpp$(MODEL_NAME)CalcHelperMain.cpp $(FORCE_FILE_BUILD)\n"
                                }, true));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "$(TRACE_FLAG)if [ ! -d \"`dirname \"$@\"`\" ]; then mkdir -p \"`dirname \"$@\"`\"; fi;echo \"building $@\"; $(TOOL_PATH)ccpentium $(DEBUGFLAGS_C++-Compiler) $(CC_ARCH_SPEC) -ansi -fno-zero-initialized-in-bss  -Wall -Wsystem-headers   -MD -MP $(IDE_DEFINES) $(DEFINES) $(ADDED_C++FLAGS) $(IDE_INCLUDES) $(ADDED_INCLUDES) -o \"$@\" -c \"$<\"\n",
                                    "\n",
                                    "\n",
                                    "com.boschrexroth.$(MODEL_NAME)_partialImage/$(MODE_DIR)/Objects/com.boschrexroth.$(MODEL_NAME)/OMCpp$(MODEL_NAME)Main.o : OMCpp$(MODEL_NAME)Main.cpp $(FORCE_FILE_BUILD)\n"
                                }, true));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "$(TRACE_FLAG)if [ ! -d \"`dirname \"$@\"`\" ]; then mkdir -p \"`dirname \"$@\"`\"; fi;echo \"building $@\"; $(TOOL_PATH)ccpentium $(DEBUGFLAGS_C++-Compiler) $(CC_ARCH_SPEC) -ansi -fno-zero-initialized-in-bss  -Wall -Wsystem-headers   -MD -MP $(IDE_DEFINES) $(DEFINES) $(ADDED_C++FLAGS) $(IDE_INCLUDES) $(ADDED_INCLUDES) -o \"$@\" -c \"$<\"\n",
                                    "\n",
                                    "\n",
                                    "OBJECTS_com.boschrexroth.$(MODEL_NAME)_partialImage = com.boschrexroth.$(MODEL_NAME)_partialImage/$(MODE_DIR)/Objects/com.boschrexroth.$(MODEL_NAME)/OMCpp$(MODEL_NAME)CalcHelperMain.o \\\n"
                                }, true));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "com.boschrexroth.$(MODEL_NAME)_partialImage/$(MODE_DIR)/Objects/com.boschrexroth.$(MODEL_NAME)/OMCpp$(MODEL_NAME)Main.o\n",
                                    "\n",
                                    "ifeq ($(TARGET_JOBS),1)\n",
                                    "com.boschrexroth.$(MODEL_NAME)_partialImage/$(MODE_DIR)/com.boschrexroth.$(MODEL_NAME)_partialImage.o : $(OBJECTS_com.boschrexroth.$(MODEL_NAME)_partialImage)\n"
                                }, true));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "$(TRACE_FLAG)if [ ! -d \"`dirname \"$@\"`\" ]; then mkdir -p \"`dirname \"$@\"`\"; fi;echo \"building $@\"; $(TOOL_PATH)ccpentium -r -nostdlib -Wl,-X  -o \"$@\" $(OBJECTS_com.boschrexroth.$(MODEL_NAME)_partialImage) $(ADDED_OBJECTS) $(IDE_LIBRARIES) $(LIBPATH) $(LIBS) $(ADDED_LIBPATH) $(ADDED_LIBS) && if [ \"$(EXPAND_DBG)\" = \"1\" ]; then plink \"$@\";fi\n",
                                    "\n",
                                    "else\n",
                                    "com.boschrexroth.$(MODEL_NAME)_partialImage/$(MODE_DIR)/com.boschrexroth.$(MODEL_NAME)_partialImage.o : com.boschrexroth.$(MODEL_NAME)_partialImage/$(MODE_DIR)/com.boschrexroth.$(MODEL_NAME)_partialImage.o_jobs\n",
                                    "\n",
                                    "endif\n",
                                    "com.boschrexroth.$(MODEL_NAME)_partialImage/$(MODE_DIR)/com.boschrexroth.$(MODEL_NAME)_partialImage_compile_file : $(FILE) ;\n",
                                    "\n",
                                    "_clean :: com.boschrexroth.$(MODEL_NAME)_partialImage/$(MODE_DIR)/com.boschrexroth.$(MODEL_NAME)_partialImage_clean\n",
                                    "\n",
                                    "com.boschrexroth.$(MODEL_NAME)_partialImage/$(MODE_DIR)/com.boschrexroth.$(MODEL_NAME)_partialImage_clean :\n"
                                }, true));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "$(TRACE_FLAG)if [ -d \"com.boschrexroth.$(MODEL_NAME)_partialImage\" ]; then cd \"com.boschrexroth.$(MODEL_NAME)_partialImage\"; rm -rf $(MODE_DIR); fi\n",
                                    "\n",
                                    "force :\n",
                                    "\n",
                                    "TARGET_JOBS_RULE?=echo \"Update the makefile template via File > Import > Build Settings : Update makefile template\";exit 1\n",
                                    "%_jobs :\n"
                                }, true));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "$(TRACE_FLAG)$(TARGET_JOBS_RULE)\n",
                                    "\n",
                                    "DEP_FILES := com.boschrexroth.$(MODEL_NAME)_partialImage/$(MODE_DIR)/Objects/com.boschrexroth.$(MODEL_NAME)/OMCpp$(MODEL_NAME)CalcHelperMain.d com.boschrexroth.$(MODEL_NAME)_partialImage/$(MODE_DIR)/Objects/com.boschrexroth.$(MODEL_NAME)/OMCpp$(MODEL_NAME)Main.d\n",
                                    "-include $(DEP_FILES)\n",
                                    "\n",
                                    "\n",
                                    "WIND_SCOPETOOLS_BASE := $(subst \\,/,$(WIND_SCOPETOOLS_BASE))\n",
                                    "\n",
                                    "clean_scopetools :\n"
                                }, true));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "$(TRACE_FLAG)rm -rf .coveragescope/db\n",
                                    "\n",
                                    "CLEAN_STEP := clean_scopetools\n",
                                    "\n",
                                    "\n",
                                    "#-include *.makefile\n",
                                    "\n",
                                    "#-include *.makefile\n",
                                    "\n",
                                    "TARGET_JOBS_RULE=$(MAKE) -f $(MAKEFILE) --jobs $(TARGET_JOBS) $(MFLAGS) $* TARGET_JOBS=1\n",
                                    "ifeq ($(JOBS),1)\n",
                                    "main_all : external_build  $(PROJECT_TARGETS)\n"
                                }, true));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "@echo \"make: built targets of `pwd`\"\n",
                                    "else\n",
                                    "main_all : external_build\n"
                                }, true));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("@$(MAKE) -f $(MAKEFILE) --jobs $(JOBS) $(MFLAGS) $(PROJECT_TARGETS) TARGET_JOBS=1 &&\\\n"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "echo \"make: built targets of `pwd`\"\n",
                                    "endif\n",
                                    "\n",
                                    "# entry point for extending the build\n",
                                    "external_build ::\n"
                                }, true));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "@echo \"\"\n",
                                    "\n",
                                    "# main entry point for pre processing prior to the build\n",
                                    "pre_build :: $(PRE_BUILD_STEP) generate_sources\n"
                                }, true));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "@echo \"\"\n",
                                    "\n",
                                    "# entry point for generating sources prior to the build\n",
                                    "generate_sources ::\n"
                                }, true));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "@echo \"\"\n",
                                    "\n",
                                    "# main entry point for post processing after the build\n",
                                    "post_build :: $(POST_BUILD_STEP) deploy_output\n"
                                }, true));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "@echo \"\"\n",
                                    "\n",
                                    "# entry point for deploying output after the build\n",
                                    "deploy_output ::\n"
                                }, true));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "@echo \"\"\n",
                                    "\n",
                                    "clean :: external_clean $(CLEAN_STEP) _clean\n",
                                    "\n",
                                    "# entry point for extending the build clean\n",
                                    "external_clean ::\n"
                                }, true));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "@echo \"\"\n",
                                    "\n"
                                }, true));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_381;

protected function fun_382
  input Tpl.Text in_txt;
  input String in_mArg;
  input String in_a_additionalLinkerFlags__GCC;
  input String in_a_additionalCFlags__GCC;
  input Boolean in_a_compileForMPI;
  input String in_a_additionalCFlags__MSVC;
  input Tpl.Text in_a_timeMeasureLink;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_timeMeasureLink;
algorithm
  (out_txt, out_a_timeMeasureLink) :=
  match(in_txt, in_mArg, in_a_additionalLinkerFlags__GCC, in_a_additionalCFlags__GCC, in_a_compileForMPI, in_a_additionalCFlags__MSVC, in_a_timeMeasureLink, in_a_simCode)
    local
      Tpl.Text txt;
      String a_additionalLinkerFlags__GCC;
      String a_additionalCFlags__GCC;
      Boolean a_compileForMPI;
      String a_additionalCFlags__MSVC;
      Tpl.Text a_timeMeasureLink;
      SimCode.SimCode a_simCode;

    case ( txt,
           "debugrt",
           _,
           _,
           _,
           a_additionalCFlags__MSVC,
           a_timeMeasureLink,
           a_simCode )
      equation
        (txt, a_timeMeasureLink) = fun_348(txt, a_simCode, a_additionalCFlags__MSVC, a_timeMeasureLink);
      then (txt, a_timeMeasureLink);

    case ( txt,
           "msvc",
           _,
           _,
           _,
           a_additionalCFlags__MSVC,
           a_timeMeasureLink,
           a_simCode )
      equation
        (txt, a_timeMeasureLink) = fun_360(txt, a_simCode, a_additionalCFlags__MSVC, a_timeMeasureLink);
      then (txt, a_timeMeasureLink);

    case ( txt,
           "gcc",
           a_additionalLinkerFlags__GCC,
           a_additionalCFlags__GCC,
           a_compileForMPI,
           _,
           a_timeMeasureLink,
           a_simCode )
      equation
        txt = fun_380(txt, a_simCode, a_timeMeasureLink, a_additionalLinkerFlags__GCC, a_additionalCFlags__GCC, a_compileForMPI);
      then (txt, a_timeMeasureLink);

    case ( txt,
           "vxworks69",
           _,
           _,
           _,
           _,
           a_timeMeasureLink,
           a_simCode )
      equation
        txt = fun_381(txt, a_simCode);
      then (txt, a_timeMeasureLink);

    case ( txt,
           _,
           _,
           _,
           _,
           _,
           a_timeMeasureLink,
           _ )
      then (txt, a_timeMeasureLink);
  end match;
end fun_382;

public function simulationMakefile
  input Tpl.Text txt;
  input String a_target;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input String a_additionalLinkerFlags__GCC;
  input String a_additionalLinkerFlags__MSVC;
  input String a_additionalCFlags__GCC;
  input String a_additionalCFlags__MSVC;
  input Boolean a_compileForMPI;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
protected
  String str_2;
  Tpl.Text txt_1;
  Tpl.Text l_timeMeasureLink;
algorithm
  l_timeMeasureLink := Tpl.emptyTxt;
  txt_1 := CodegenUtil.getGeneralTarget(Tpl.emptyTxt, a_target);
  str_2 := Tpl.textString(txt_1);
  (out_txt, l_timeMeasureLink) := fun_382(txt, str_2, a_additionalLinkerFlags__GCC, a_additionalCFlags__GCC, a_compileForMPI, a_additionalCFlags__MSVC, l_timeMeasureLink, a_simCode);
  out_a_extraFuncs := a_extraFuncs;
  out_a_extraFuncsDecl := a_extraFuncsDecl;
  out_a_extraFuncsNamespace := a_extraFuncsNamespace;
end simulationMakefile;

protected function fun_384
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_simCode)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      Integer ret_1;
      Tpl.Text l_numOfEqs;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_simCode )
      equation
        ret_1 = SimCodeUtil.getMaxSimEqSystemIndex(a_simCode);
        l_numOfEqs = Tpl.writeStr(Tpl.emptyTxt, intString(ret_1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "#ifdef MEASURETIME_PROFILEBLOCKS\n",
                                    "delete measuredProfileBlockStartValues;\n",
                                    "delete measuredProfileBlockEndValues;\n",
                                    "#endif //MEASURETIME_PROFILEBLOCKS\n",
                                    "\n",
                                    "#ifdef MEASURETIME_MODELFUNCTIONS\n",
                                    "delete measuredFunctionStartValues;\n",
                                    "delete measuredFunctionEndValues;\n",
                                    "#endif //MEASURETIME_MODELFUNCTIONS"
                                }, false));
      then txt;
  end match;
end fun_384;

protected function fun_385
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_updateFunctionsCode;
  input Tpl.Text in_a_indexForUndefinedReferencesReal;
  input Tpl.Text in_a_indexForUndefinedReferencesInt;
  input Tpl.Text in_a_indexForUndefinedReferencesBool;
  input Tpl.Text in_a_indexForUndefinedReferencesString;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_additionalConstructorVarDefs;
  input Tpl.Text in_a_additionalConstructorBodyStatements;
  input Tpl.Text in_a_additionalDestructorBodyStatements;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_indexForUndefinedReferencesReal;
  output Tpl.Text out_a_indexForUndefinedReferencesInt;
  output Tpl.Text out_a_indexForUndefinedReferencesBool;
  output Tpl.Text out_a_indexForUndefinedReferencesString;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_indexForUndefinedReferencesReal, out_a_indexForUndefinedReferencesInt, out_a_indexForUndefinedReferencesBool, out_a_indexForUndefinedReferencesString, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_simCode, in_a_context, in_a_updateFunctionsCode, in_a_indexForUndefinedReferencesReal, in_a_indexForUndefinedReferencesInt, in_a_indexForUndefinedReferencesBool, in_a_indexForUndefinedReferencesString, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_additionalConstructorVarDefs, in_a_additionalConstructorBodyStatements, in_a_additionalDestructorBodyStatements, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_updateFunctionsCode;
      Tpl.Text a_indexForUndefinedReferencesReal;
      Tpl.Text a_indexForUndefinedReferencesInt;
      Tpl.Text a_indexForUndefinedReferencesBool;
      Tpl.Text a_indexForUndefinedReferencesString;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_additionalConstructorVarDefs;
      Tpl.Text a_additionalConstructorBodyStatements;
      Tpl.Text a_additionalDestructorBodyStatements;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      list<String> i_modelInfo_labels;
      list<BackendDAE.TimeEvent> i_timeEvents;
      list<SimCode.SimEqSystem> i_initialEquations;
      list<SimCode.SimEqSystem> i_allEquations;
      list<BackendDAE.ZeroCrossing> i_zeroCrossings;
      list<DAE.ComponentRef> i_discreteModelVars;
      SimCode.SimCode i_simCode;
      HashTableCrIListArray.HashTable i_varToArrayIndexMapping;
      SimCode.ModelInfo i_modelInfo;
      Absyn.Path i_modelInfo_name;
      list<SimCode.SimEqSystem> ret_13;
      list<SimCode.SimEqSystem> ret_12;
      list<SimCode.SimEqSystem> ret_11;
      list<SimCode.SimEqSystem> ret_10;
      list<SimCode.SimEqSystem> ret_9;
      list<SimCode.SimEqSystem> ret_8;
      Boolean ret_7;
      Boolean ret_6;
      String ret_5;
      Tpl.Text l_constVariableInitialize;
      Boolean ret_3;
      Tpl.Text l_memberVariableInitialize;
      Tpl.Text l_additionalConstructorVarDefsBuffer;
      Tpl.Text l_className;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = (i_modelInfo as SimCode.MODELINFO(name = i_modelInfo_name, labels = i_modelInfo_labels)), varToArrayIndexMapping = i_varToArrayIndexMapping, discreteModelVars = i_discreteModelVars, zeroCrossings = i_zeroCrossings, allEquations = i_allEquations, initialEquations = i_initialEquations, timeEvents = i_timeEvents)),
           a_context,
           a_updateFunctionsCode,
           a_indexForUndefinedReferencesReal,
           a_indexForUndefinedReferencesInt,
           a_indexForUndefinedReferencesBool,
           a_indexForUndefinedReferencesString,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_additionalConstructorVarDefs,
           a_additionalConstructorBodyStatements,
           a_additionalDestructorBodyStatements,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_className = lastIdentOfPath(Tpl.emptyTxt, i_modelInfo_name);
        l_additionalConstructorVarDefsBuffer = Tpl.writeText(Tpl.emptyTxt, a_additionalConstructorVarDefs);
        ret_3 = Flags.isSet(Flags.GEN_DEBUG_SYMBOLS);
        (l_memberVariableInitialize, a_indexForUndefinedReferencesReal, a_indexForUndefinedReferencesInt, a_indexForUndefinedReferencesBool, a_indexForUndefinedReferencesString, l_additionalConstructorVarDefsBuffer, a_extraFuncsDecl) = memberVariableInitialize(Tpl.emptyTxt, i_modelInfo, i_varToArrayIndexMapping, a_indexForUndefinedReferencesReal, a_indexForUndefinedReferencesInt, a_indexForUndefinedReferencesBool, a_indexForUndefinedReferencesString, ret_3, a_useFlatArrayNotation, l_additionalConstructorVarDefsBuffer, a_extraFuncsDecl);
        (l_constVariableInitialize, a_extraFuncsDecl, a_stateDerVectorName) = simulationInitFile(Tpl.emptyTxt, i_simCode, a_extraFuncsDecl, a_stateDerVectorName, false);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "#if defined(__TRICORE__) || defined(__vxworks)\n",
                                    "  #include <Core/DataExchange/SimDouble.h>\n",
                                    "#endif\n",
                                    "\n",
                                    "/* Constructor */\n"
                                }, true));
        txt = Tpl.writeText(txt, l_className);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("::"));
        txt = Tpl.writeText(txt, l_className);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("(IGlobalSettings* globalSettings, shared_ptr<ISimObjects> simObjects)\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(": SystemDefaultImplementation(globalSettings, simObjects, \""));
        txt = Tpl.writeText(txt, l_className);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\")\n",
                                    ", _algLoopSolverFactory(simObjects->getAlgLoopSolverFactory())\n",
                                    ", _pointerToRealVars(getSimVars()->getRealVarsVector())\n",
                                    ", _pointerToIntVars(getSimVars()->getIntVarsVector())\n",
                                    ", _pointerToBoolVars(getSimVars()->getBoolVarsVector())\n",
                                    ", _pointerToStringVars(getSimVars()->getStringVarsVector())\n"
                                }, true));
        txt = Tpl.writeText(txt, l_additionalConstructorVarDefsBuffer);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("{\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = generateSimulationCppConstructorContent(txt, i_simCode, a_context, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, a_additionalConstructorBodyStatements);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n"
                                }, true));
        txt = Tpl.writeText(txt, l_className);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("::"));
        txt = Tpl.writeText(txt, l_className);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, l_className);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " &instance) : SystemDefaultImplementation(instance)\n",
                                    "    , _algLoopSolverFactory(instance.getAlgLoopSolverFactory())\n",
                                    "    , _pointerToRealVars(getSimVars()->getRealVarsVector())\n",
                                    "    , _pointerToIntVars(getSimVars()->getIntVarsVector())\n",
                                    "    , _pointerToBoolVars(getSimVars()->getBoolVarsVector())\n",
                                    "    , _pointerToStringVars(getSimVars()->getStringVarsVector())\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.writeText(txt, l_additionalConstructorVarDefsBuffer);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("{\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = generateSimulationCppConstructorContent(txt, i_simCode, a_context, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, a_additionalConstructorBodyStatements);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n",
                                    "/* Destructor */\n"
                                }, true));
        txt = Tpl.writeText(txt, l_className);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("::~"));
        txt = Tpl.writeText(txt, l_className);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "()\n",
                                    "{\n",
                                    "  deleteObjects();\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        ret_5 = Flags.getConfigString(Flags.PROFILING_LEVEL);
        ret_6 = stringEq(ret_5, "none");
        ret_7 = boolNot(ret_6);
        txt = fun_384(txt, ret_7, i_simCode);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, a_additionalDestructorBodyStatements);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n",
                                    "void "
                                }, false));
        txt = Tpl.writeText(txt, l_className);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::deleteObjects()\n",
                                    "{\n",
                                    "\n",
                                    "  if(_functions != NULL)\n",
                                    "    delete _functions;\n",
                                    "\n",
                                    "\n",
                                    "}\n",
                                    "\n",
                                    "shared_ptr<IAlgLoopSolverFactory> "
                                }, false));
        txt = Tpl.writeText(txt, l_className);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::getAlgLoopSolverFactory()\n",
                                    "{\n",
                                    "    return _algLoopSolverFactory;\n",
                                    "}\n",
                                    "\n",
                                    "\n"
                                }, true));
        txt = Tpl.writeText(txt, a_updateFunctionsCode);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = DefaultImplementationCode(txt, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = checkForDiscreteEvents(txt, i_discreteModelVars, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.softNewLine(txt);
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = giveZeroFunc1(txt, i_zeroCrossings, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = setConditions(txt, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
        txt = Tpl.softNewLine(txt);
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = getConditions(txt, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
        txt = Tpl.softNewLine(txt);
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = isConsistent(txt, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        ret_8 = listAppend(i_allEquations, i_initialEquations);
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = generateStepCompleted(txt, ret_8, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.softNewLine(txt);
        ret_9 = listAppend(i_allEquations, i_initialEquations);
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = generateStepStarted(txt, ret_9, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_useFlatArrayNotation);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        ret_10 = listAppend(i_allEquations, i_initialEquations);
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = generateRestoreOldValues(txt, ret_10, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.softNewLine(txt);
        ret_11 = listAppend(i_allEquations, i_initialEquations);
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = generateRestoreNewValues(txt, ret_11, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        ret_12 = listAppend(i_allEquations, i_initialEquations);
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = generateDimTimeEvent(txt, ret_12, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
        txt = Tpl.softNewLine(txt);
        ret_13 = listAppend(i_allEquations, i_initialEquations);
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = generateGetTimeEvenData(txt, ret_13, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
        txt = Tpl.softNewLine(txt);
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = generateTimeEvent(txt, i_timeEvents, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, true);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = isODE(txt, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
        txt = Tpl.softNewLine(txt);
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = dimZeroFunc(txt, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = getCondition(txt, i_zeroCrossings, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = saveAll(txt, i_modelInfo, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "\n"
                                }, true));
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = labeledDAE(txt, i_modelInfo_labels, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.softNewLine(txt);
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = giveVariables(txt, i_modelInfo, a_context, a_useFlatArrayNotation, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_memberVariableInitialize);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_constVariableInitialize);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, a_extraFuncs);
      then (txt, a_indexForUndefinedReferencesReal, a_indexForUndefinedReferencesInt, a_indexForUndefinedReferencesBool, a_indexForUndefinedReferencesString, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           _,
           a_indexForUndefinedReferencesReal,
           a_indexForUndefinedReferencesInt,
           a_indexForUndefinedReferencesBool,
           a_indexForUndefinedReferencesString,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           _,
           _,
           _,
           a_stateDerVectorName,
           _ )
      then (txt, a_indexForUndefinedReferencesReal, a_indexForUndefinedReferencesInt, a_indexForUndefinedReferencesBool, a_indexForUndefinedReferencesString, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end fun_385;

public function simulationCppFile
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_updateFunctionsCode;
  input Tpl.Text a_indexForUndefinedReferencesReal;
  input Tpl.Text a_indexForUndefinedReferencesInt;
  input Tpl.Text a_indexForUndefinedReferencesBool;
  input Tpl.Text a_indexForUndefinedReferencesString;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_additionalConstructorVarDefs;
  input Tpl.Text a_additionalConstructorBodyStatements;
  input Tpl.Text a_additionalDestructorBodyStatements;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_updateFunctionsCode;
  output Tpl.Text out_a_indexForUndefinedReferencesReal;
  output Tpl.Text out_a_indexForUndefinedReferencesInt;
  output Tpl.Text out_a_indexForUndefinedReferencesBool;
  output Tpl.Text out_a_indexForUndefinedReferencesString;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_additionalConstructorVarDefs;
  output Tpl.Text out_a_additionalConstructorBodyStatements;
  output Tpl.Text out_a_additionalDestructorBodyStatements;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_indexForUndefinedReferencesReal, out_a_indexForUndefinedReferencesInt, out_a_indexForUndefinedReferencesBool, out_a_indexForUndefinedReferencesString, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) := fun_385(txt, a_simCode, a_context, a_updateFunctionsCode, a_indexForUndefinedReferencesReal, a_indexForUndefinedReferencesInt, a_indexForUndefinedReferencesBool, a_indexForUndefinedReferencesString, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_additionalConstructorVarDefs, a_additionalConstructorBodyStatements, a_additionalDestructorBodyStatements, a_stateDerVectorName, a_useFlatArrayNotation);
  out_a_updateFunctionsCode := a_updateFunctionsCode;
  out_a_additionalConstructorVarDefs := a_additionalConstructorVarDefs;
  out_a_additionalConstructorBodyStatements := a_additionalConstructorBodyStatements;
  out_a_additionalDestructorBodyStatements := a_additionalDestructorBodyStatements;
end simulationCppFile;

protected function lm_387
  input Tpl.Text in_txt;
  input list<Integer> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<Integer> rest;
      Integer x_i0;
      Integer i_act;
      Integer ret_0;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_act :: rest )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_stateActivator["));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = "));
        ret_0 = intSub(i_act, 1);
        txt = Tpl.writeStr(txt, intString(ret_0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        txt = lm_387(txt, rest);
      then txt;
  end match;
end lm_387;

public function partitionInfoInit
  input Tpl.Text txt;
  input Integer a_numPartitions;
  input Integer a_numStates;
  input list<Integer> a_stateActivators;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_stateActs;
algorithm
  l_stateActs := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  l_stateActs := lm_387(l_stateActs, a_stateActivators);
  l_stateActs := Tpl.popIter(l_stateActs);
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                   "//partitioning of the system, all partitions are active at t0\n",
                                   "_dimPartitions = "
                               }, false));
  out_txt := Tpl.writeStr(out_txt, intString(a_numPartitions));
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       ";\n",
                                       "_partitionActivation = new bool[_dimPartitions]();\n",
                                       "memset(_partitionActivation,true,_dimPartitions*sizeof(bool));\n",
                                       "_stateActivator = new int["
                                   }, false));
  out_txt := Tpl.writeStr(out_txt, intString(a_numStates));
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("]();\n"));
  out_txt := Tpl.writeText(out_txt, l_stateActs);
end partitionInfoInit;

protected function fun_389
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input list<Integer> in_a_partitionData_stateToActivators;
  input Integer in_a_vi_numStateVars;
  input Integer in_a_partitionData_numPartitions;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_partitionData_stateToActivators, in_a_vi_numStateVars, in_a_partitionData_numPartitions)
    local
      Tpl.Text txt;
      list<Integer> a_partitionData_stateToActivators;
      Integer a_vi_numStateVars;
      Integer a_partitionData_numPartitions;

    case ( txt,
           false,
           _,
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_partitionData_stateToActivators,
           a_vi_numStateVars,
           a_partitionData_numPartitions )
      equation
        txt = partitionInfoInit(txt, a_partitionData_numPartitions, a_vi_numStateVars, a_partitionData_stateToActivators);
      then txt;
  end match;
end fun_389;

protected function fun_390
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Absyn.Path in_a_modelInfo_name;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_modelInfo_name, in_a_simCode)
    local
      Tpl.Text txt;
      Absyn.Path a_modelInfo_name;
      SimCode.SimCode a_simCode;
      Integer ret_1;
      Tpl.Text l_numOfEqs;

    case ( txt,
           false,
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_modelInfo_name,
           a_simCode )
      equation
        ret_1 = SimCodeUtil.getMaxSimEqSystemIndex(a_simCode);
        l_numOfEqs = Tpl.writeStr(Tpl.emptyTxt, intString(ret_1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "#ifdef MEASURETIME_PROFILEBLOCKS\n",
                                    "measureTimeProfileBlocksArray = new std::vector<MeasureTimeData*>(size_t("
                                }, false));
        txt = Tpl.writeText(txt, l_numOfEqs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "), NULL);\n",
                                    "for(int i = 0; i < "
                                }, false));
        txt = Tpl.writeText(txt, l_numOfEqs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "; i++)\n",
                                    "{\n",
                                    "    ostringstream ss;\n",
                                    "    ss << (i+1);\n",
                                    "    (*measureTimeProfileBlocksArray)[i] = new MeasureTimeData(ss.str());\n",
                                    "}\n",
                                    "\n",
                                    "MeasureTime::addResultContentBlock(\""
                                }, false));
        txt = dotPath(txt, a_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\",\"profileBlocks\",measureTimeProfileBlocksArray);\n",
                                    "measuredProfileBlockStartValues = MeasureTime::getZeroValues();\n",
                                    "measuredProfileBlockEndValues = MeasureTime::getZeroValues();\n",
                                    "#endif //MEASURETIME_PROFILEBLOCKS\n",
                                    "\n",
                                    "#ifdef MEASURETIME_MODELFUNCTIONS\n",
                                    "measureTimeFunctionsArray = new std::vector<MeasureTimeData*>(size_t(5), NULL); //1 evaluateODE ; 2 evaluateAll; 3 writeOutput; 4 handleTimeEvents; 5 evaluateZeroFuncs\n",
                                    "MeasureTime::addResultContentBlock(\""
                                }, false));
        txt = dotPath(txt, a_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\",\"functions\",measureTimeFunctionsArray);\n",
                                    "(*measureTimeFunctionsArray)[0] = new MeasureTimeData(\"evaluateODE\");\n",
                                    "(*measureTimeFunctionsArray)[1] = new MeasureTimeData(\"evaluateAll\");\n",
                                    "(*measureTimeFunctionsArray)[2] = new MeasureTimeData(\"writeOutput\");\n",
                                    "(*measureTimeFunctionsArray)[3] = new MeasureTimeData(\"handleTimeEvents\");\n",
                                    "(*measureTimeFunctionsArray)[4] = new MeasureTimeData(\"evaluateZeroFuncs\");\n",
                                    "\n",
                                    "measuredFunctionStartValues = MeasureTime::getZeroValues();\n",
                                    "measuredFunctionEndValues = MeasureTime::getZeroValues();\n",
                                    "#endif //MEASURETIME_MODELFUNCTIONS"
                                }, false));
      then txt;
  end match;
end fun_390;

protected function fun_391
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace) :=
  match(in_txt, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace)
    local
      Tpl.Text txt;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      list<SimCode.ClockedPartition> i_clockedPartitions;
      SimCode.SimCode i_simCode;
      list<Integer> i_partitionData_stateToActivators;
      Integer i_vi_numStateVars;
      Integer i_partitionData_numPartitions;
      Absyn.Path i_modelInfo_name;
      Boolean ret_7;
      Boolean ret_6;
      String ret_5;
      Integer ret_4;
      list<SimCode.SubPartition> ret_3;
      Boolean ret_2;
      Tpl.Text l_partitionInit;
      Tpl.Text l_className;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(varInfo = SimCode.VARINFO(numStateVars = i_vi_numStateVars), name = i_modelInfo_name), partitionData = SimCode.PARTITIONDATA(numPartitions = i_partitionData_numPartitions, stateToActivators = i_partitionData_stateToActivators), clockedPartitions = i_clockedPartitions)),
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace )
      equation
        l_className = lastIdentOfPath(Tpl.emptyTxt, i_modelInfo_name);
        ret_2 = Flags.isSet(Flags.MULTIRATE_PARTITION);
        l_partitionInit = fun_389(Tpl.emptyTxt, ret_2, i_partitionData_stateToActivators, i_vi_numStateVars, i_partitionData_numPartitions);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "initConstVals();\n",
                                    "initStateVars();\n",
                                    "initDerivativeVars();\n",
                                    "initAlgVars();\n",
                                    "initDiscreteAlgVars();\n",
                                    "initIntAlgVars();\n",
                                    "initBoolAlgVars();\n",
                                    "initStringAlgVars();\n",
                                    "initParameterRealVars();\n",
                                    "initParameterIntVars();\n",
                                    "initParameterBoolVars();\n",
                                    "initParameterStringVars();\n",
                                    "initAliasRealVars();\n",
                                    "initAliasIntVars();\n",
                                    "initAliasBoolVars();\n",
                                    "initAliasStringVars();\n",
                                    "\n",
                                    "//Number of equations\n"
                                }, true));
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = dimension1(txt, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_dimZeroFunc = "));
        txt = CodegenCppCommonOld.zeroCrossLength(txt, i_simCode);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "_dimClock = "
                                }, false));
        ret_3 = SimCodeUtil.getSubPartitions(i_clockedPartitions);
        ret_4 = listLength(ret_3);
        txt = Tpl.writeStr(txt, intString(ret_4));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "// simplified treatment of clocks in model as time events\n",
                                    "_dimTimeEvent = "
                                }, false));
        txt = CodegenCppCommonOld.timeEventLength(txt, i_simCode);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "  + _dimClock;\n",
                                    "_timeEventData = (std::pair<double,double>*)calloc(_dimTimeEvent, sizeof(std::pair<double,double>));\n",
                                    "_currTimeEvents = (double*)malloc(_dimTimeEvent*sizeof(double));\n",
                                    "\n",
                                    "//Number of residues\n",
                                    " _event_handling= shared_ptr<EventHandling>(new EventHandling());\n"
                                }, true));
        ret_5 = Flags.getConfigString(Flags.PROFILING_LEVEL);
        ret_6 = stringEq(ret_5, "none");
        ret_7 = boolNot(ret_6);
        txt = fun_390(txt, ret_7, i_modelInfo_name, i_simCode);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_partitionInit);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "//Initialize the state vector\n",
                                    "SystemDefaultImplementation::initialize();\n",
                                    "//Instantiate auxiliary object for event handling functionality\n",
                                    "//_event_handling.getCondition =  boost::bind(&"
                                }, false));
        txt = Tpl.writeText(txt, l_className);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::getCondition, this, _1);\n",
                                    "\n",
                                    "//Todo: reindex all arrays removed  // arrayReindex(modelInfo,useFlatArrayNotation)\n",
                                    "\n",
                                    "_functions = new Functions(_simTime,__z,__zDot,_initial,_terminate);"
                                }, false));
        txt = Tpl.popBlock(txt);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);

    case ( txt,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
  end match;
end fun_391;

public function generateSimulationCppConstructorContent
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace) := fun_391(txt, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
  out_a_stateDerVectorName := a_stateDerVectorName;
end generateSimulationCppConstructorContent;

protected function fun_393
  input Tpl.Text in_txt;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_filename;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_context, in_a_filename)
    local
      Tpl.Text txt;
      Tpl.Text a_filename;

    case ( txt,
           SimCodeFunction.ALGLOOP_CONTEXT(genInitialisation = false, genJacobian = true),
           a_filename )
      equation
        txt = Tpl.writeText(txt, a_filename);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Jacobian"));
      then txt;

    case ( txt,
           _,
           a_filename )
      equation
        txt = Tpl.writeText(txt, a_filename);
      then txt;
  end match;
end fun_393;

protected function fun_394
  input Tpl.Text in_txt;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_modelname;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_context, in_a_modelname)
    local
      Tpl.Text txt;
      Tpl.Text a_modelname;

    case ( txt,
           SimCodeFunction.ALGLOOP_CONTEXT(genInitialisation = false, genJacobian = true),
           a_modelname )
      equation
        txt = Tpl.writeText(txt, a_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Jacobian"));
      then txt;

    case ( txt,
           _,
           a_modelname )
      equation
        txt = Tpl.writeText(txt, a_modelname);
      then txt;
  end match;
end fun_394;

protected function fun_395
  input Tpl.Text in_txt;
  input String in_mArg;
  input Tpl.Text in_a_nonzeros;
  input Tpl.Text in_a_varDecls;
  input SimCode.SimEqSystem in_a_eq;
  input Tpl.Text in_a_size;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_varDecls) :=
  match(in_txt, in_mArg, in_a_nonzeros, in_a_varDecls, in_a_eq, in_a_size)
    local
      Tpl.Text txt;
      Tpl.Text a_nonzeros;
      Tpl.Text a_varDecls;
      SimCode.SimEqSystem a_eq;
      Tpl.Text a_size;

    case ( txt,
           "dense",
           _,
           a_varDecls,
           a_eq,
           a_size )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(",__A(ublas::zero_matrix<double>("));
        txt = Tpl.writeText(txt, a_size);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, a_size);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "))\n",
                                    ", _conditions(conditions)\n",
                                    ", _discrete_events(discrete_events)\n",
                                    ", _functions(system->_functions)\n",
                                    "{\n",
                                    "  _useSparseFormat=false;\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        (txt, a_varDecls) = initAlgloopDimension(txt, a_eq, a_varDecls);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.popBlock(txt);
      then (txt, a_varDecls);

    case ( txt,
           "sparse",
           a_nonzeros,
           a_varDecls,
           a_eq,
           a_size )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(",__A("));
        txt = Tpl.writeText(txt, a_size);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, a_size);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, a_nonzeros);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ")\n",
                                    ", _conditions(conditions)\n",
                                    ", _discrete_events(discrete_events)\n",
                                    ", _functions(system->_functions)\n",
                                    "{\n",
                                    "  _useSparseFormat=true;\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        (txt, a_varDecls) = initAlgloopDimension(txt, a_eq, a_varDecls);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.popBlock(txt);
      then (txt, a_varDecls);

    case ( txt,
           _,
           _,
           a_varDecls,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("A matrix type is not supported"));
      then (txt, a_varDecls);
  end match;
end fun_395;

protected function fun_396
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) :=
  match(in_txt, in_a_eq, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_context, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      SimCodeFunction.Context a_context;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      SimCode.SimEqSystem i_eq;
      list<tuple<Integer, Integer, SimCode.SimEqSystem>> i_ls_simJac;
      list<SimCodeVar.SimVar> i_ls_vars;
      String str_7;
      Tpl.Text l_inits;
      String ret_5;
      Tpl.Text l_type;
      Integer ret_3;
      Tpl.Text l_nonzeros;
      Integer ret_1;
      Tpl.Text l_size;

    case ( txt,
           (i_eq as SimCode.SES_LINEAR(lSystem = SimCode.LINEARSYSTEM(vars = i_ls_vars, simJac = i_ls_simJac))),
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_context,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls )
      equation
        ret_1 = listLength(i_ls_vars);
        l_size = Tpl.writeStr(Tpl.emptyTxt, intString(ret_1));
        ret_3 = listLength(i_ls_simJac);
        l_nonzeros = Tpl.writeStr(Tpl.emptyTxt, intString(ret_3));
        ret_5 = Flags.getConfigString(Flags.MATRIX_FORMAT);
        l_type = Tpl.writeStr(Tpl.emptyTxt, ret_5);
        str_7 = Tpl.textString(l_type);
        (l_inits, a_varDecls) = fun_395(Tpl.emptyTxt, str_7, l_nonzeros, a_varDecls, i_eq, l_size);
        txt = Tpl.writeText(txt, l_inits);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(3));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_dimZeroFunc = "));
        txt = CodegenCppCommonOld.zeroCrossLength(txt, a_simCode);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = initAlgloopVarAttributes(txt, i_eq, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_context, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.popBlock(txt);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           _,
           _,
           a_stateDerVectorName,
           _,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);
  end match;
end fun_396;

protected function fun_397
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input SimCode.SimEqSystem in_a_eq;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_mArg, in_a_eq, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      SimCode.SimEqSystem a_eq;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;

    case ( txt,
           false,
           a_eq,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = algloopRHSCode(txt, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_eq);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           a_eq,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = algloopResiduals(txt, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_eq);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_397;

protected function fun_398
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input SimCode.SimEqSystem in_a_eq;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_mArg, in_a_eq, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      SimCode.SimEqSystem a_eq;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;

    case ( txt,
           false,
           a_eq,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = algloopRHSCode(txt, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_eq);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           a_eq,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = algloopResiduals(txt, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_eq);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_398;

protected function fun_399
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input Integer in_a_clockIndex;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_systemname;
  input Tpl.Text in_a_modelname;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) :=
  match(in_txt, in_a_eq, in_a_clockIndex, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_context, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_systemname, in_a_modelname)
    local
      Tpl.Text txt;
      Integer a_clockIndex;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      SimCodeFunction.Context a_context;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_systemname;
      Tpl.Text a_modelname;
      Integer i_nls_index;
      SimCode.SimEqSystem i_eq;
      Integer i_ls_index;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           (i_eq as SimCode.SES_LINEAR(lSystem = SimCode.LINEARSYSTEM(index = i_ls_index))),
           a_clockIndex,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_context,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_systemname,
           a_modelname )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "\n"
                                }, true));
        txt = Tpl.writeText(txt, a_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeStr(txt, intString(i_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("::"));
        txt = Tpl.writeText(txt, a_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeStr(txt, intString(i_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_systemname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "* system, double* z, double* zDot, bool* conditions, shared_ptr<DiscreteEvents> discrete_events)\n",
                                    "    : LinearAlgLoopDefaultImplementation()\n",
                                    "    , _system(system)\n",
                                    "    , __z(z)\n",
                                    "    , __zDot(zDot)\n",
                                    "\n"
                                }, true));
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = fun_396(txt, i_eq, a_useFlatArrayNotation, a_stateDerVectorName, a_context, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n"
                                }, true));
        txt = Tpl.writeText(txt, a_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeStr(txt, intString(i_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("::~"));
        txt = Tpl.writeText(txt, a_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeStr(txt, intString(i_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "()\n",
                                    "{\n",
                                    "\n",
                                    "}\n",
                                    "int "
                                }, false));
        txt = Tpl.writeText(txt, a_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeStr(txt, intString(i_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::getDimZeroFunc() const\n",
                                    "{\n",
                                    "   return _dimZeroFunc;\n",
                                    "}\n",
                                    "bool "
                                }, false));
        txt = Tpl.writeText(txt, a_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeStr(txt, intString(i_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::getFreeVariablesLock()\n",
                                    "{\n",
                                    "  return _system->getFreeVariablesLock();\n",
                                    "}\n",
                                    "\n",
                                    "bool "
                                }, false));
        txt = Tpl.writeText(txt, a_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeStr(txt, intString(i_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::getUseSparseFormat()\n",
                                    "{\n",
                                    "  return LinearAlgLoopDefaultImplementation::getUseSparseFormat();\n",
                                    "}\n",
                                    "\n",
                                    "void "
                                }, false));
        txt = Tpl.writeText(txt, a_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeStr(txt, intString(i_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::setUseSparseFormat(bool value)\n",
                                    "{\n",
                                    "  LinearAlgLoopDefaultImplementation::setUseSparseFormat(value);\n",
                                    "}\n",
                                    "\n"
                                }, true));
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = algloopRHSCode(txt, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, i_eq);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/*"));
        ret_0 = Flags.isSet(Flags.WRITE_TO_BUFFER);
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_397(txt, ret_0, i_eq, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("*/\n"));
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = initAlgloop(txt, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, i_eq, a_context, a_clockIndex, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.softNewLine(txt);
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = queryDensity(txt, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, i_eq, a_context, a_useFlatArrayNotation);
        txt = Tpl.softNewLine(txt);
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = updateAlgloop(txt, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, i_eq, a_context, a_clockIndex, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.softNewLine(txt);
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = updateAlgloopNonLinear(txt, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, i_eq, a_context, a_clockIndex, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = LinearalgloopDefaultImplementationCode(txt, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, i_eq, a_context, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.softNewLine(txt);
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = getAMatrixCode(txt, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, i_eq);
        txt = Tpl.softNewLine(txt);
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = isLinearTearingCode(txt, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, i_eq);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           (i_eq as SimCode.SES_NONLINEAR(nlSystem = SimCode.NONLINEARSYSTEM(index = i_nls_index))),
           a_clockIndex,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_context,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_systemname,
           a_modelname )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "\n",
                                    "\n"
                                }, true));
        txt = Tpl.writeText(txt, a_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeStr(txt, intString(i_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("::"));
        txt = Tpl.writeText(txt, a_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeStr(txt, intString(i_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_systemname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "* system, double* z, double* zDot, bool* conditions, shared_ptr<DiscreteEvents> discrete_events)\n",
                                    "    : NonLinearAlgLoopDefaultImplementation()\n",
                                    "    , _system(system)\n",
                                    "    , __z(z)\n",
                                    "    , __zDot(zDot)\n",
                                    "    , _conditions(conditions)\n",
                                    "    , _discrete_events(discrete_events)\n",
                                    "    , _functions(system->_functions)\n",
                                    "\n",
                                    "{\n",
                                    "  _useSparseFormat=false;\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        (txt, a_varDecls) = initAlgloopDimension(txt, i_eq, a_varDecls);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_dimZeroFunc = "));
        txt = CodegenCppCommonOld.zeroCrossLength(txt, a_simCode);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = initAlgloopVarAttributes(txt, i_eq, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_context, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n"
                                }, true));
        txt = Tpl.writeText(txt, a_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeStr(txt, intString(i_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("::~"));
        txt = Tpl.writeText(txt, a_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeStr(txt, intString(i_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "()\n",
                                    "{\n",
                                    "\n",
                                    "}\n",
                                    "\n",
                                    "int "
                                }, false));
        txt = Tpl.writeText(txt, a_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeStr(txt, intString(i_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::getDimZeroFunc() const\n",
                                    "{\n",
                                    "   return _dimZeroFunc;\n",
                                    "}\n",
                                    "\n",
                                    "bool "
                                }, false));
        txt = Tpl.writeText(txt, a_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeStr(txt, intString(i_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::getUseSparseFormat()\n",
                                    "{\n",
                                    "  return NonLinearAlgLoopDefaultImplementation::getUseSparseFormat();\n",
                                    "}\n",
                                    "\n",
                                    "void "
                                }, false));
        txt = Tpl.writeText(txt, a_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeStr(txt, intString(i_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::setUseSparseFormat(bool value)\n",
                                    "{\n",
                                    "  NonLinearAlgLoopDefaultImplementation::setUseSparseFormat(value);\n",
                                    "}\n"
                                }, true));
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = algloopRHSCode(txt, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, i_eq);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/*"));
        ret_1 = Flags.isSet(Flags.WRITE_TO_BUFFER);
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_398(txt, ret_1, i_eq, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("*/\n"));
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = initAlgloop(txt, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, i_eq, a_context, a_clockIndex, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = queryDensity(txt, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, i_eq, a_context, a_useFlatArrayNotation);
        txt = Tpl.softNewLine(txt);
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = updateAlgloop(txt, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, i_eq, a_context, a_clockIndex, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.softNewLine(txt);
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = updateAlgloopNonLinear(txt, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, i_eq, a_context, a_clockIndex, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = NonLinearalgloopDefaultImplementationCode(txt, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, i_eq, a_context, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.softNewLine(txt);
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = getAMatrixCode(txt, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, i_eq);
        txt = Tpl.softNewLine(txt);
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = isLinearTearingCode(txt, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, i_eq);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           _,
           _,
           _,
           a_stateDerVectorName,
           _,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);
  end match;
end fun_399;

public function algloopCppFile
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input SimCode.SimEqSystem in_a_eq;
  input SimCodeFunction.Context in_a_context;
  input Integer in_a_clockIndex;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_eq, in_a_context, in_a_clockIndex, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      SimCode.SimEqSystem a_eq;
      SimCodeFunction.Context a_context;
      Integer a_clockIndex;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      SimCode.SimCode i_simCode;
      SimCode.ModelInfo i_modelInfo;
      String i_fileNamePrefix;
      Absyn.Path i_modelInfo_name;
      Tpl.Text l_systemname;
      Tpl.Text l_iniAlgloopParamas;
      Tpl.Text l_constructorParams;
      Tpl.Text l_arrayInit;
      Tpl.Text l_varDecls;
      Tpl.Text l_modelfilename;
      Tpl.Text l_filename;
      Tpl.Text l_modelname;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = (i_modelInfo as SimCode.MODELINFO(name = i_modelInfo_name)), fileNamePrefix = i_fileNamePrefix)),
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_eq,
           a_context,
           a_clockIndex,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_modelname = lastIdentOfPath(Tpl.emptyTxt, i_modelInfo_name);
        l_filename = Tpl.writeStr(Tpl.emptyTxt, i_fileNamePrefix);
        l_modelfilename = fun_393(Tpl.emptyTxt, a_context, l_filename);
        l_varDecls = Tpl.emptyTxt;
        l_arrayInit = Tpl.emptyTxt;
        l_constructorParams = constructorParamAlgloop(Tpl.emptyTxt, i_modelInfo, a_useFlatArrayNotation);
        (l_iniAlgloopParamas, l_arrayInit) = initAlgloopParams(Tpl.emptyTxt, i_modelInfo, l_arrayInit, a_useFlatArrayNotation);
        l_systemname = fun_394(Tpl.emptyTxt, a_context, l_modelname);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, l_varDecls) = fun_399(txt, a_eq, a_clockIndex, a_useFlatArrayNotation, a_stateDerVectorName, a_context, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, i_simCode, l_varDecls, l_systemname, l_modelname);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           _,
           _,
           _,
           a_stateDerVectorName,
           _ )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end algloopCppFile;

protected function fun_401
  input Tpl.Text in_txt;
  input Option<SimCode.JacobianMatrix> in_a_ls_jacobianMatrix;
  input list<tuple<Integer, Integer, SimCode.SimEqSystem>> in_a_ls_simJac;
  input Integer in_a_ls_index;
  input Tpl.Text in_a_modelname;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ls_jacobianMatrix, in_a_ls_simJac, in_a_ls_index, in_a_modelname)
    local
      Tpl.Text txt;
      list<tuple<Integer, Integer, SimCode.SimEqSystem>> a_ls_simJac;
      Integer a_ls_index;
      Tpl.Text a_modelname;
      Integer ret_1;
      Tpl.Text l_size;

    case ( txt,
           SOME(_),
           _,
           a_ls_index,
           a_modelname )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("float "));
        txt = Tpl.writeText(txt, a_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::queryDensity()\n",
                                    "{\n",
                                    "  return -1.;\n",
                                    "}"
                                }, false));
      then txt;

    case ( txt,
           _,
           a_ls_simJac,
           a_ls_index,
           a_modelname )
      equation
        ret_1 = listLength(a_ls_simJac);
        l_size = Tpl.writeStr(Tpl.emptyTxt, intString(ret_1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("float "));
        txt = Tpl.writeText(txt, a_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::queryDensity()\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("return 100.*"));
        txt = Tpl.writeText(txt, l_size);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("./_dimAEq/_dimAEq;\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;
  end match;
end fun_401;

protected function fun_402
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eqn;
  input Tpl.Text in_a_modelname;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_eqn, in_a_modelname)
    local
      Tpl.Text txt;
      Tpl.Text a_modelname;
      list<tuple<Integer, Integer, SimCode.SimEqSystem>> i_ls_simJac;
      Integer i_ls_index;
      Option<SimCode.JacobianMatrix> i_ls_jacobianMatrix;
      Integer i_nls_index;

    case ( txt,
           SimCode.SES_NONLINEAR(nlSystem = SimCode.NONLINEARSYSTEM(index = i_nls_index)),
           a_modelname )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("float "));
        txt = Tpl.writeText(txt, a_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeStr(txt, intString(i_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::queryDensity()\n",
                                    "{\n",
                                    "  return -1.;\n",
                                    "}"
                                }, false));
      then txt;

    case ( txt,
           SimCode.SES_LINEAR(lSystem = SimCode.LINEARSYSTEM(jacobianMatrix = i_ls_jacobianMatrix, index = i_ls_index, simJac = i_ls_simJac)),
           a_modelname )
      equation
        txt = fun_401(txt, i_ls_jacobianMatrix, i_ls_simJac, i_ls_index, a_modelname);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_402;

protected function fun_403
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input SimCode.SimEqSystem in_a_eqn;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode, in_a_eqn)
    local
      Tpl.Text txt;
      SimCode.SimEqSystem a_eqn;
      Absyn.Path i_modelInfo_name;
      Tpl.Text l_modelname;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = i_modelInfo_name)),
           a_eqn )
      equation
        l_modelname = lastIdentOfPath(Tpl.emptyTxt, i_modelInfo_name);
        txt = fun_402(txt, a_eqn, l_modelname);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_403;

public function queryDensity
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input SimCode.SimEqSystem a_eqn;
  input SimCodeFunction.Context a_context;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  out_txt := fun_403(txt, a_simCode, a_eqn);
  out_a_extraFuncs := a_extraFuncs;
  out_a_extraFuncsDecl := a_extraFuncsDecl;
  out_a_extraFuncsNamespace := a_extraFuncsNamespace;
end queryDensity;

protected function lm_405
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_context, in_a_varDecls)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      SimCodeFunction.Context a_context;
      Tpl.Text a_varDecls;
      SimCode.SimEqSystem i_eq2;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _,
           a_varDecls )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           i_eq2 :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_context,
           a_varDecls )
      equation
        (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = functionExtraResidualsPreBody(txt, i_eq2, a_varDecls, a_context, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = lm_405(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_context, a_varDecls);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);
  end match;
end lm_405;

protected function lm_406
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_context)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      SimCodeFunction.Context a_context;
      Integer x_i0;
      DAE.Exp i_eq2_exp;
      Tpl.Text l_expPart;
      Tpl.Text l_preExp;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           SimCode.SES_RESIDUAL(exp = i_eq2_exp) :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_context )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        l_preExp = Tpl.emptyTxt;
        (l_expPart, l_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.daeExp(Tpl.emptyTxt, i_eq2_exp, a_context, l_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_b["));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = "));
        txt = Tpl.writeText(txt, l_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = lm_406(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_context);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           _ :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_context )
      equation
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = lm_406(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_context);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);
  end match;
end lm_406;

protected function fun_407
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_clockIndex;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_clockIndex)
    local
      Tpl.Text txt;
      Integer a_clockIndex;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_clockIndex )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("const int clockIndex = "));
        txt = Tpl.writeStr(txt, intString(a_clockIndex));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_407;

protected function fun_408
  input Tpl.Text in_txt;
  input String in_mArg;
  input Integer in_a_col;
  input Integer in_a_row;
  input Tpl.Text in_a_expPart;
  input Integer in_a_i0;
  input Tpl.Text in_a_preExp;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_col, in_a_row, in_a_expPart, in_a_i0, in_a_preExp)
    local
      Tpl.Text txt;
      Integer a_col;
      Integer a_row;
      Tpl.Text a_expPart;
      Integer a_i0;
      Tpl.Text a_preExp;

    case ( txt,
           "sparse",
           _,
           _,
           a_expPart,
           a_i0,
           a_preExp )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("//"));
        txt = Tpl.writeText(txt, a_preExp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("__A.value_data()["));
        txt = Tpl.writeStr(txt, intString(a_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = "));
        txt = Tpl.writeText(txt, a_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           _,
           a_col,
           a_row,
           a_expPart,
           _,
           a_preExp )
      equation
        txt = Tpl.writeText(txt, a_preExp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("__A("));
        txt = Tpl.writeStr(txt, intString(a_row));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeStr(txt, intString(a_col));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")="));
        txt = Tpl.writeText(txt, a_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_408;

protected function fun_409
  input Tpl.Text in_txt;
  input String in_mArg;
  input Integer in_a_col;
  input Integer in_a_row;
  input Tpl.Text in_a_expPart;
  input Integer in_a_i0;
  input Tpl.Text in_a_preExp;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_col, in_a_row, in_a_expPart, in_a_i0, in_a_preExp)
    local
      Tpl.Text txt;
      Integer a_col;
      Integer a_row;
      Tpl.Text a_expPart;
      Integer a_i0;
      Tpl.Text a_preExp;

    case ( txt,
           "sparse",
           _,
           _,
           a_expPart,
           a_i0,
           a_preExp )
      equation
        txt = Tpl.writeText(txt, a_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("__A.value_data()["));
        txt = Tpl.writeStr(txt, intString(a_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = "));
        txt = Tpl.writeText(txt, a_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           _,
           a_col,
           a_row,
           a_expPart,
           _,
           a_preExp )
      equation
        txt = Tpl.writeText(txt, a_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("__A("));
        txt = Tpl.writeStr(txt, intString(a_row));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeStr(txt, intString(a_col));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")="));
        txt = Tpl.writeText(txt, a_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_409;

protected function fun_410
  input Tpl.Text in_txt;
  input DAE.Exp in_a_eq_exp;
  input Integer in_a_col;
  input Integer in_a_row;
  input Tpl.Text in_a_expPart;
  input Integer in_a_i0;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_type;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_eq_exp, in_a_col, in_a_row, in_a_expPart, in_a_i0, in_a_preExp, in_a_type)
    local
      Tpl.Text txt;
      Integer a_col;
      Integer a_row;
      Tpl.Text a_expPart;
      Integer a_i0;
      Tpl.Text a_preExp;
      Tpl.Text a_type;
      String str_1;
      String str_0;

    case ( txt,
           DAE.RCONST(real = _),
           a_col,
           a_row,
           a_expPart,
           a_i0,
           a_preExp,
           a_type )
      equation
        str_0 = Tpl.textString(a_type);
        txt = fun_408(txt, str_0, a_col, a_row, a_expPart, a_i0, a_preExp);
      then txt;

    case ( txt,
           _,
           a_col,
           a_row,
           a_expPart,
           a_i0,
           a_preExp,
           a_type )
      equation
        str_1 = Tpl.textString(a_type);
        txt = fun_409(txt, str_1, a_col, a_row, a_expPart, a_i0, a_preExp);
      then txt;
  end match;
end fun_410;

protected function lm_411
  input Tpl.Text in_txt;
  input list<tuple<Integer, Integer, SimCode.SimEqSystem>> in_items;
  input Tpl.Text in_a_type;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) :=
  match(in_txt, in_items, in_a_type, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_context)
    local
      Tpl.Text txt;
      list<tuple<Integer, Integer, SimCode.SimEqSystem>> rest;
      Tpl.Text a_type;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      SimCodeFunction.Context a_context;
      Integer x_i0;
      Integer i_col;
      Integer i_row;
      DAE.Exp i_eq_exp;
      Tpl.Text l_expPart;
      Tpl.Text l_preExp;

    case ( txt,
           {},
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           (i_row, i_col, SimCode.SES_RESIDUAL(exp = i_eq_exp)) :: rest,
           a_type,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_context )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        l_preExp = Tpl.emptyTxt;
        (l_expPart, l_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.daeExp(Tpl.emptyTxt, i_eq_exp, a_context, l_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = fun_410(txt, i_eq_exp, i_col, i_row, l_expPart, x_i0, l_preExp, a_type);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = lm_411(txt, rest, a_type, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_context);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           _ :: rest,
           a_type,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_context )
      equation
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = lm_411(txt, rest, a_type, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_context);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);
  end match;
end lm_411;

protected function fun_412
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input Tpl.Text in_a_expPart;
  input Integer in_a_i0;
  input Tpl.Text in_a_preExp;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_exp, in_a_expPart, in_a_i0, in_a_preExp)
    local
      Tpl.Text txt;
      Tpl.Text a_expPart;
      Integer a_i0;
      Tpl.Text a_preExp;

    case ( txt,
           DAE.RCONST(real = _),
           a_expPart,
           a_i0,
           a_preExp )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("//"));
        txt = Tpl.writeText(txt, a_preExp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("__b("));
        txt = Tpl.writeStr(txt, intString(a_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")="));
        txt = Tpl.writeText(txt, a_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           _,
           a_expPart,
           a_i0,
           a_preExp )
      equation
        txt = Tpl.writeText(txt, a_preExp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("__b("));
        txt = Tpl.writeStr(txt, intString(a_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")="));
        txt = Tpl.writeText(txt, a_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_412;

protected function lm_413
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      SimCodeFunction.Context a_context;
      Integer x_i0;
      DAE.Exp i_exp;
      Tpl.Text l_expPart;
      Tpl.Text l_preExp;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           i_exp :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_context )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        l_preExp = Tpl.emptyTxt;
        (l_expPart, l_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.daeExp(Tpl.emptyTxt, i_exp, a_context, l_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = fun_412(txt, i_exp, l_expPart, x_i0, l_preExp);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = lm_413(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_context);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);
  end match;
end lm_413;

protected function fun_414
  input Tpl.Text in_txt;
  input Option<SimCode.JacobianMatrix> in_a_ls_jacobianMatrix;
  input list<DAE.Exp> in_a_ls_beqs;
  input Tpl.Text in_a_type;
  input list<tuple<Integer, Integer, SimCode.SimEqSystem>> in_a_ls_simJac;
  input list<SimCodeVar.SimVar> in_a_ls_vars;
  input Integer in_a_clockIndex;
  input Integer in_a_ls_index;
  input Tpl.Text in_a_modelname;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input SimCodeFunction.Context in_a_context;
  input list<SimCode.SimEqSystem> in_a_ls_residual;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_a_ls_jacobianMatrix, in_a_ls_beqs, in_a_type, in_a_ls_simJac, in_a_ls_vars, in_a_clockIndex, in_a_ls_index, in_a_modelname, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_context, in_a_ls_residual)
    local
      Tpl.Text txt;
      list<DAE.Exp> a_ls_beqs;
      Tpl.Text a_type;
      list<tuple<Integer, Integer, SimCode.SimEqSystem>> a_ls_simJac;
      list<SimCodeVar.SimVar> a_ls_vars;
      Integer a_clockIndex;
      Integer a_ls_index;
      Tpl.Text a_modelname;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      SimCodeFunction.Context a_context;
      list<SimCode.SimEqSystem> a_ls_residual;
      Tpl.Text l_bvector;
      Tpl.Text l_Amatrix;
      Tpl.Text l_help;
      Tpl.Text l_bname;
      Tpl.Text l_aname;
      Integer ret_7;
      Tpl.Text l_size;
      Integer ret_5;
      Tpl.Text l_uid;
      Boolean ret_3;
      Tpl.Text l_body;
      Tpl.Text l_prebody;
      Tpl.Text l_varDecls;

    case ( txt,
           SOME(_),
           _,
           _,
           _,
           _,
           a_clockIndex,
           a_ls_index,
           a_modelname,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_context,
           a_ls_residual )
      equation
        l_varDecls = Tpl.emptyTxt;
        l_prebody = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_prebody, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, l_varDecls) = lm_405(l_prebody, a_ls_residual, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_context, l_varDecls);
        l_prebody = Tpl.popIter(l_prebody);
        l_body = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_body, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, l_varDecls) = lm_406(l_body, a_ls_residual, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, l_varDecls, a_context);
        l_body = Tpl.popIter(l_body);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "void "
                                }, false));
        txt = Tpl.writeText(txt, a_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::evaluate()\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        ret_3 = intGt(a_clockIndex, 0);
        txt = fun_407(txt, ret_3, a_clockIndex);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_varDecls);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("//prebody\n"));
        txt = Tpl.writeText(txt, l_prebody);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("//body\n"));
        txt = Tpl.writeText(txt, l_body);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           a_ls_beqs,
           a_type,
           a_ls_simJac,
           a_ls_vars,
           _,
           a_ls_index,
           a_modelname,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_context,
           _ )
      equation
        ret_5 = System.tmpTick();
        l_uid = Tpl.writeStr(Tpl.emptyTxt, intString(ret_5));
        ret_7 = listLength(a_ls_vars);
        l_size = Tpl.writeStr(Tpl.emptyTxt, intString(ret_7));
        l_aname = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("A"));
        l_aname = Tpl.writeText(l_aname, l_uid);
        l_bname = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("b"));
        l_bname = Tpl.writeText(l_bname, l_uid);
        l_varDecls = Tpl.emptyTxt;
        l_help = Tpl.emptyTxt;
        l_Amatrix = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_Amatrix, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, l_varDecls) = lm_411(l_Amatrix, a_ls_simJac, a_type, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, l_varDecls, a_context);
        l_Amatrix = Tpl.popIter(l_Amatrix);
        l_bvector = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(1, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_bvector, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, l_varDecls) = lm_413(l_bvector, a_ls_beqs, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, l_varDecls, a_context);
        l_bvector = Tpl.popIter(l_bvector);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = Tpl.writeText(txt, a_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::evaluate()\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.writeText(txt, l_varDecls);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_Amatrix);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_bvector);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_414;

protected function fun_415
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eqn;
  input Integer in_a_clockIndex;
  input Tpl.Text in_a_modelname;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_a_eqn, in_a_clockIndex, in_a_modelname, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_context)
    local
      Tpl.Text txt;
      Integer a_clockIndex;
      Tpl.Text a_modelname;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      SimCodeFunction.Context a_context;
      list<DAE.Exp> i_ls_beqs;
      list<tuple<Integer, Integer, SimCode.SimEqSystem>> i_ls_simJac;
      list<SimCodeVar.SimVar> i_ls_vars;
      Integer i_ls_index;
      list<SimCode.SimEqSystem> i_ls_residual;
      Option<SimCode.JacobianMatrix> i_ls_jacobianMatrix;
      String ret_1;
      Tpl.Text l_type;

    case ( txt,
           SimCode.SES_LINEAR(lSystem = SimCode.LINEARSYSTEM(jacobianMatrix = i_ls_jacobianMatrix, residual = i_ls_residual, index = i_ls_index, vars = i_ls_vars, simJac = i_ls_simJac, beqs = i_ls_beqs)),
           a_clockIndex,
           a_modelname,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_context )
      equation
        ret_1 = Flags.getConfigString(Flags.MATRIX_FORMAT);
        l_type = Tpl.writeStr(Tpl.emptyTxt, ret_1);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_414(txt, i_ls_jacobianMatrix, i_ls_beqs, l_type, i_ls_simJac, i_ls_vars, a_clockIndex, i_ls_index, a_modelname, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_context, i_ls_residual);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           _,
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_415;

public function updateAlgloop
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input SimCode.SimEqSystem in_a_eqn;
  input SimCodeFunction.Context in_a_context;
  input Integer in_a_clockIndex;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_eqn, in_a_context, in_a_clockIndex, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      SimCode.SimEqSystem a_eqn;
      SimCodeFunction.Context a_context;
      Integer a_clockIndex;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      SimCode.SimCode i_simCode;
      Absyn.Path i_modelInfo_name;
      Tpl.Text l_modelname;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = i_modelInfo_name))),
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_eqn,
           a_context,
           a_clockIndex,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_modelname = lastIdentOfPath(Tpl.emptyTxt, i_modelInfo_name);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_415(txt, a_eqn, a_clockIndex, l_modelname, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, i_simCode, a_context);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           _,
           _,
           _,
           a_stateDerVectorName,
           _ )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end updateAlgloop;

protected function lm_417
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_context, in_a_varDecls)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      SimCodeFunction.Context a_context;
      Tpl.Text a_varDecls;
      SimCode.SimEqSystem i_eq2;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _,
           a_varDecls )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           i_eq2 :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_context,
           a_varDecls )
      equation
        (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = functionExtraResidualsPreBody(txt, i_eq2, a_varDecls, a_context, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = lm_417(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_context, a_varDecls);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);
  end match;
end lm_417;

protected function lm_418
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_context)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      SimCodeFunction.Context a_context;
      Integer x_i0;
      DAE.Exp i_eq2_exp;
      Tpl.Text l_expPart;
      Tpl.Text l_preExp;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           SimCode.SES_RESIDUAL(exp = i_eq2_exp) :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_context )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        l_preExp = Tpl.emptyTxt;
        (l_expPart, l_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.daeExp(Tpl.emptyTxt, i_eq2_exp, a_context, l_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_res["));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = "));
        txt = Tpl.writeText(txt, l_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = lm_418(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_context);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           _ :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_context )
      equation
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = lm_418(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_context);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);
  end match;
end lm_418;

protected function fun_419
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input Tpl.Text in_a_modelname;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_eq, in_a_modelname)
    local
      Tpl.Text txt;
      Tpl.Text a_modelname;
      Integer i_nls_index;

    case ( txt,
           SimCode.SES_NONLINEAR(nlSystem = SimCode.NONLINEARSYSTEM(index = i_nls_index)),
           a_modelname )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = Tpl.writeText(txt, a_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeStr(txt, intString(i_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("::evaluate()"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_419;

protected function fun_420
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_clockIndex;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_clockIndex)
    local
      Tpl.Text txt;
      Integer a_clockIndex;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_clockIndex )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("const int clockIndex = "));
        txt = Tpl.writeStr(txt, intString(a_clockIndex));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_420;

protected function fun_421
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eqn;
  input Integer in_a_clockIndex;
  input Tpl.Text in_a_modelname;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_a_eqn, in_a_clockIndex, in_a_modelname, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_context)
    local
      Tpl.Text txt;
      Integer a_clockIndex;
      Tpl.Text a_modelname;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      SimCodeFunction.Context a_context;
      SimCode.SimEqSystem i_eq;
      list<SimCode.SimEqSystem> i_nls_eqs;
      Boolean ret_3;
      Tpl.Text l_body;
      Tpl.Text l_prebody;
      Tpl.Text l_varDecls;

    case ( txt,
           (i_eq as SimCode.SES_NONLINEAR(nlSystem = SimCode.NONLINEARSYSTEM(eqs = i_nls_eqs))),
           a_clockIndex,
           a_modelname,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_context )
      equation
        l_varDecls = Tpl.emptyTxt;
        l_prebody = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_prebody, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, l_varDecls) = lm_417(l_prebody, i_nls_eqs, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_context, l_varDecls);
        l_prebody = Tpl.popIter(l_prebody);
        l_body = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_body, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, l_varDecls) = lm_418(l_body, i_nls_eqs, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, l_varDecls, a_context);
        l_body = Tpl.popIter(l_body);
        txt = fun_419(txt, i_eq, a_modelname);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("{\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        ret_3 = intGt(a_clockIndex, 0);
        txt = fun_420(txt, ret_3, a_clockIndex);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_varDecls);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("//prebody\n"));
        txt = Tpl.writeText(txt, l_prebody);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("//body\n"));
        txt = Tpl.writeText(txt, l_body);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           _,
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_421;

public function updateAlgloopNonLinear
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input SimCode.SimEqSystem in_a_eqn;
  input SimCodeFunction.Context in_a_context;
  input Integer in_a_clockIndex;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_eqn, in_a_context, in_a_clockIndex, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      SimCode.SimEqSystem a_eqn;
      SimCodeFunction.Context a_context;
      Integer a_clockIndex;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      SimCode.SimCode i_simCode;
      Absyn.Path i_modelInfo_name;
      Tpl.Text l_modelname;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = i_modelInfo_name))),
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_eqn,
           a_context,
           a_clockIndex,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_modelname = lastIdentOfPath(Tpl.emptyTxt, i_modelInfo_name);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_421(txt, a_eqn, a_clockIndex, l_modelname, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, i_simCode, a_context);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           _,
           _,
           _,
           a_stateDerVectorName,
           _ )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end updateAlgloopNonLinear;

public function functionExtraResidualsPreBody
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input Tpl.Text in_a_varDecls;
  input SimCodeFunction.Context in_a_context;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_eq, in_a_varDecls, in_a_context, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      Tpl.Text a_varDecls;
      SimCodeFunction.Context a_context;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           SimCode.SES_RESIDUAL(index = _),
           a_varDecls,
           _,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           i_eq,
           a_varDecls,
           a_context,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = equation_(txt, i_eq, a_context, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end functionExtraResidualsPreBody;

protected function lm_424
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Function> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Function> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      SimCodeFunction.Function i_fn;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           i_fn :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = functionBody(txt, i_fn, false, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_424(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_424;

public function functionBodies
  input Tpl.Text txt;
  input list<SimCodeFunction.Function> a_functions;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  out_txt := Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) := lm_424(out_txt, a_functions, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
  out_txt := Tpl.popIter(out_txt);
end functionBodies;

protected function fun_426
  input Tpl.Text in_txt;
  input SimCodeFunction.Function in_a_fn;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Boolean in_a_inFunc;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_a_fn, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_inFunc)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Boolean a_inFunc;
      SimCodeFunction.Function i_fn;

    case ( txt,
           (i_fn as SimCodeFunction.FUNCTION(name = _)),
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_inFunc )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = functionBodyRegularFunction(txt, i_fn, a_inFunc, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           (i_fn as SimCodeFunction.EXTERNAL_FUNCTION(name = _)),
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_inFunc )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = functionBodyExternalFunction(txt, i_fn, a_inFunc, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           (i_fn as SimCodeFunction.RECORD_CONSTRUCTOR(name = _)),
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           _ )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = functionBodyRecordConstructor(txt, i_fn, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_useFlatArrayNotation);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_426;

protected function fun_427
  input Tpl.Text in_txt;
  input String in_mArg;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Boolean in_a_inFunc;
  input SimCodeFunction.Function in_a_fn;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_mArg, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_inFunc, in_a_fn)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Boolean a_inFunc;
      SimCodeFunction.Function a_fn;

    case ( txt,
           "OpenModelica_Scripting_regexBool",
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           "Modelica_Utilities_Files_loadResource",
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           "OpenModelica_Scripting_directoryExists",
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           "OpenModelica_Scripting_uriToFilename",
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           "OpenModelica_Scripting_Internal_stat",
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           "OpenModelica_Scripting_realpath",
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           "OpenModelica_Scripting_regex",
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_inFunc,
           a_fn )
      equation
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_426(txt, a_fn, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_inFunc);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_427;

protected function fun_428
  input Tpl.Text in_txt;
  input SimCodeFunction.Function in_a_fn;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Boolean in_a_inFunc;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_a_fn, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_inFunc)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Boolean a_inFunc;
      SimCodeFunction.Function i_fn;

    case ( txt,
           (i_fn as SimCodeFunction.FUNCTION(name = _)),
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_inFunc )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = functionBodyRegularFunction(txt, i_fn, a_inFunc, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           (i_fn as SimCodeFunction.EXTERNAL_FUNCTION(name = _)),
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_inFunc )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = functionBodyExternalFunction(txt, i_fn, a_inFunc, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           (i_fn as SimCodeFunction.RECORD_CONSTRUCTOR(name = _)),
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           _ )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = functionBodyRecordConstructor(txt, i_fn, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_useFlatArrayNotation);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_428;

protected function fun_429
  input Tpl.Text in_txt;
  input String in_mArg;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Boolean in_a_inFunc;
  input SimCodeFunction.Function in_a_fn;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_mArg, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_inFunc, in_a_fn)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Boolean a_inFunc;
      SimCodeFunction.Function a_fn;

    case ( txt,
           "OpenModelica_Scripting_regexBool",
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           "Modelica_Utilities_Files_loadResource",
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           "OpenModelica_Scripting_directoryExists",
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           "OpenModelica_Scripting_uriToFilename",
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           "OpenModelica_Scripting_Internal_stat",
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           "OpenModelica_Scripting_realpath",
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           "OpenModelica_Scripting_regex",
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_inFunc,
           a_fn )
      equation
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_428(txt, a_fn, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_inFunc);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_429;

protected function fun_430
  input Tpl.Text in_txt;
  input SimCodeFunction.Function in_a_fn;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Boolean in_a_inFunc;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_a_fn, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_inFunc)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Boolean a_inFunc;
      SimCodeFunction.Function i_fn;

    case ( txt,
           (i_fn as SimCodeFunction.FUNCTION(name = _)),
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_inFunc )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = functionBodyRegularFunction(txt, i_fn, a_inFunc, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           (i_fn as SimCodeFunction.EXTERNAL_FUNCTION(name = _)),
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_inFunc )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = functionBodyExternalFunction(txt, i_fn, a_inFunc, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           (i_fn as SimCodeFunction.RECORD_CONSTRUCTOR(name = _)),
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           _ )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = functionBodyRecordConstructor(txt, i_fn, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_useFlatArrayNotation);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_430;

protected function fun_431
  input Tpl.Text in_txt;
  input String in_mArg;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Boolean in_a_inFunc;
  input SimCodeFunction.Function in_a_fn;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_mArg, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_inFunc, in_a_fn)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Boolean a_inFunc;
      SimCodeFunction.Function a_fn;

    case ( txt,
           "OpenModelica_Scripting_regexBool",
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           "Modelica_Utilities_Files_loadResource",
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           "OpenModelica_Scripting_directoryExists",
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           "OpenModelica_Scripting_uriToFilename",
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           "OpenModelica_Scripting_Internal_stat",
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           "OpenModelica_Scripting_realpath",
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           "OpenModelica_Scripting_regex",
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_inFunc,
           a_fn )
      equation
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_430(txt, a_fn, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_inFunc);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_431;

public function functionBody
  input Tpl.Text in_txt;
  input SimCodeFunction.Function in_a_fn;
  input Boolean in_a_inFunc;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_fn, in_a_inFunc, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      Boolean a_inFunc;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      SimCodeFunction.Function i_fn;
      Absyn.Path i_name;
      String str_3;
      String str_2;
      String str_1;
      Tpl.Text l_fname;

    case ( txt,
           (i_fn as SimCodeFunction.FUNCTION(name = i_name)),
           a_inFunc,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_fname = CodegenUtil.underscorePath(Tpl.emptyTxt, i_name);
        str_1 = Tpl.textString(l_fname);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_427(txt, str_1, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_inFunc, i_fn);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           (i_fn as SimCodeFunction.EXTERNAL_FUNCTION(name = i_name)),
           a_inFunc,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_fname = CodegenUtil.underscorePath(Tpl.emptyTxt, i_name);
        str_2 = Tpl.textString(l_fname);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_429(txt, str_2, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_inFunc, i_fn);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           (i_fn as SimCodeFunction.RECORD_CONSTRUCTOR(name = i_name)),
           a_inFunc,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_fname = CodegenUtil.underscorePath(Tpl.emptyTxt, i_name);
        str_3 = Tpl.textString(l_fname);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_431(txt, str_3, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_inFunc, i_fn);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end functionBody;

protected function lm_433
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Function> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Function> rest;
      SimCodeFunction.Function i_fn;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_fn :: rest )
      equation
        txt = extFunDef(txt, i_fn);
        txt = Tpl.nextIter(txt);
        txt = lm_433(txt, rest);
      then txt;
  end match;
end lm_433;

public function externfunctionHeaderDefinition
  input Tpl.Text txt;
  input list<SimCodeFunction.Function> a_functions;

  output Tpl.Text out_txt;
algorithm
  out_txt := Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_433(out_txt, a_functions);
  out_txt := Tpl.popIter(out_txt);
end externfunctionHeaderDefinition;

protected function lm_435
  input Tpl.Text in_txt;
  input list<SimCodeFunction.RecordDeclaration> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_dummyElemTypeCreation;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_dummyElemTypeCreation;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_dummyElemTypeCreation, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_dummyElemTypeCreation, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeFunction.RecordDeclaration> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_dummyElemTypeCreation;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      SimCodeFunction.RecordDeclaration i_rd;

    case ( txt,
           {},
           _,
           a_dummyElemTypeCreation,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_dummyElemTypeCreation, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           i_rd :: rest,
           a_useFlatArrayNotation,
           a_dummyElemTypeCreation,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_dummyElemTypeCreation) = recordDeclarationHeader(txt, i_rd, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_dummyElemTypeCreation, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_dummyElemTypeCreation, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_435(txt, rest, a_useFlatArrayNotation, a_dummyElemTypeCreation, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_dummyElemTypeCreation, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_435;

protected function lm_436
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Function> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Function> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      SimCodeFunction.Function i_fn;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           i_fn :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = functionHeaderBody1(txt, i_fn, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_436(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_436;

protected function fun_437
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input list<SimCodeFunction.Function> in_a_functions;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_dummyElemTypeCreation;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_dummyElemTypeCreation;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_dummyElemTypeCreation, out_a_stateDerVectorName) :=
  match(in_txt, in_a_simCode, in_a_functions, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_dummyElemTypeCreation, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Function> a_functions;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_dummyElemTypeCreation;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      SimCode.SimCode i_simCode;
      list<SimCodeFunction.RecordDeclaration> i_recordDecls;
      Tpl.Text l_rettypedecls;
      Tpl.Text l_recorddecls;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = _), recordDecls = i_recordDecls)),
           a_functions,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_dummyElemTypeCreation,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_recorddecls = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_recorddecls, a_dummyElemTypeCreation, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_435(l_recorddecls, i_recordDecls, a_useFlatArrayNotation, a_dummyElemTypeCreation, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, i_simCode);
        l_recorddecls = Tpl.popIter(l_recorddecls);
        l_rettypedecls = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_rettypedecls, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_436(l_rettypedecls, a_functions, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, i_simCode);
        l_rettypedecls = Tpl.popIter(l_rettypedecls);
        txt = Tpl.writeText(txt, l_recorddecls);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_rettypedecls);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_dummyElemTypeCreation, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_dummyElemTypeCreation,
           a_stateDerVectorName,
           _ )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_dummyElemTypeCreation, a_stateDerVectorName);
  end match;
end fun_437;

public function functionHeaderBodies1
  input Tpl.Text txt;
  input list<SimCodeFunction.Function> a_functions;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_dummyElemTypeCreation;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_dummyElemTypeCreation;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_dummyElemTypeCreation, out_a_stateDerVectorName) := fun_437(txt, a_simCode, a_functions, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_dummyElemTypeCreation, a_stateDerVectorName, a_useFlatArrayNotation);
end functionHeaderBodies1;

protected function fun_439
  input Tpl.Text in_txt;
  input SimCodeFunction.Function in_a_fn;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_a_fn, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      SimCodeFunction.Function i_fn;

    case ( txt,
           (i_fn as SimCodeFunction.FUNCTION(name = _)),
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = functionHeaderRegularFunction1(txt, i_fn, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           (i_fn as SimCodeFunction.EXTERNAL_FUNCTION(name = _)),
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = functionHeaderExternFunction(txt, i_fn, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           (i_fn as SimCodeFunction.RECORD_CONSTRUCTOR(name = _)),
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = functionHeaderRegularFunction1(txt, i_fn, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_439;

protected function fun_440
  input Tpl.Text in_txt;
  input String in_mArg;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input SimCodeFunction.Function in_a_fn;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_mArg, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_fn)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      SimCodeFunction.Function a_fn;

    case ( txt,
           "OpenModelica_Scripting_regexBool",
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           "Modelica_Utilities_Files_loadResource",
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           "OpenModelica_Scripting_directoryExists",
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           "OpenModelica_Scripting_uriToFilename",
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           "OpenModelica_Scripting_Internal_stat",
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           "OpenModelica_Scripting_realpath",
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           "OpenModelica_Scripting_regex",
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_fn )
      equation
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_439(txt, a_fn, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_440;

protected function fun_441
  input Tpl.Text in_txt;
  input SimCodeFunction.Function in_a_fn;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_a_fn, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      SimCodeFunction.Function i_fn;

    case ( txt,
           (i_fn as SimCodeFunction.FUNCTION(name = _)),
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = functionHeaderRegularFunction1(txt, i_fn, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           (i_fn as SimCodeFunction.EXTERNAL_FUNCTION(name = _)),
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = functionHeaderExternFunction(txt, i_fn, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           (i_fn as SimCodeFunction.RECORD_CONSTRUCTOR(name = _)),
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = functionHeaderRegularFunction1(txt, i_fn, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_441;

protected function fun_442
  input Tpl.Text in_txt;
  input String in_mArg;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input SimCodeFunction.Function in_a_fn;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_mArg, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_fn)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      SimCodeFunction.Function a_fn;

    case ( txt,
           "OpenModelica_Scripting_regexBool",
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           "Modelica_Utilities_Files_loadResource",
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           "OpenModelica_Scripting_directoryExists",
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           "OpenModelica_Scripting_uriToFilename",
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           "OpenModelica_Scripting_Internal_stat",
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           "OpenModelica_Scripting_realpath",
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           "OpenModelica_Scripting_regex",
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_fn )
      equation
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_441(txt, a_fn, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_442;

protected function fun_443
  input Tpl.Text in_txt;
  input SimCodeFunction.Function in_a_fn;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_a_fn, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      SimCodeFunction.Function i_fn;

    case ( txt,
           (i_fn as SimCodeFunction.FUNCTION(name = _)),
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = functionHeaderRegularFunction1(txt, i_fn, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           (i_fn as SimCodeFunction.EXTERNAL_FUNCTION(name = _)),
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = functionHeaderExternFunction(txt, i_fn, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           (i_fn as SimCodeFunction.RECORD_CONSTRUCTOR(name = _)),
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = functionHeaderRegularFunction1(txt, i_fn, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_443;

protected function fun_444
  input Tpl.Text in_txt;
  input String in_mArg;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input SimCodeFunction.Function in_a_fn;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_mArg, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_fn)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      SimCodeFunction.Function a_fn;

    case ( txt,
           "OpenModelica_Scripting_regexBool",
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           "Modelica_Utilities_Files_loadResource",
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           "OpenModelica_Scripting_directoryExists",
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           "OpenModelica_Scripting_uriToFilename",
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           "OpenModelica_Scripting_Internal_stat",
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           "OpenModelica_Scripting_realpath",
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           "OpenModelica_Scripting_regex",
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_fn )
      equation
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_443(txt, a_fn, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_444;

public function functionHeaderBody1
  input Tpl.Text in_txt;
  input SimCodeFunction.Function in_a_fn;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_fn, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      SimCodeFunction.Function i_fn;
      Absyn.Path i_name;
      String str_3;
      String str_2;
      String str_1;
      Tpl.Text l_fname;

    case ( txt,
           (i_fn as SimCodeFunction.FUNCTION(name = i_name)),
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_fname = CodegenUtil.underscorePath(Tpl.emptyTxt, i_name);
        str_1 = Tpl.textString(l_fname);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_440(txt, str_1, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, i_fn);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           (i_fn as SimCodeFunction.EXTERNAL_FUNCTION(name = i_name)),
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_fname = CodegenUtil.underscorePath(Tpl.emptyTxt, i_name);
        str_2 = Tpl.textString(l_fname);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_442(txt, str_2, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, i_fn);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           (i_fn as SimCodeFunction.RECORD_CONSTRUCTOR(name = i_name)),
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_fname = CodegenUtil.underscorePath(Tpl.emptyTxt, i_name);
        str_3 = Tpl.textString(l_fname);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_444(txt, str_3, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, i_fn);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end functionHeaderBody1;

protected function lm_446
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Function> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Function> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      SimCodeFunction.Function i_fn;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           i_fn :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = functionHeaderBody2(txt, i_fn, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_446(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_446;

public function functionHeaderBodies2
  input Tpl.Text txt;
  input list<SimCodeFunction.Function> a_functions;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  out_txt := Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) := lm_446(out_txt, a_functions, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
  out_txt := Tpl.popIter(out_txt);
end functionHeaderBodies2;

protected function fun_448
  input Tpl.Text in_txt;
  input SimCodeFunction.Function in_a_fn;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_a_fn, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      SimCodeFunction.Function i_fn;

    case ( txt,
           (i_fn as SimCodeFunction.FUNCTION(name = _)),
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = functionHeaderRegularFunction2(txt, i_fn, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           (i_fn as SimCodeFunction.EXTERNAL_FUNCTION(name = _)),
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = functionHeaderRegularFunction2(txt, i_fn, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           (i_fn as SimCodeFunction.RECORD_CONSTRUCTOR(name = _)),
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = functionHeaderRecordConstruct(txt, i_fn, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_useFlatArrayNotation);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_448;

protected function fun_449
  input Tpl.Text in_txt;
  input String in_mArg;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input SimCodeFunction.Function in_a_fn;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_mArg, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_fn)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      SimCodeFunction.Function a_fn;

    case ( txt,
           "OpenModelica_Scripting_regexBool",
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           "Modelica_Utilities_Files_loadResource",
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           "OpenModelica_Scripting_directoryExists",
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           "OpenModelica_Scripting_uriToFilename",
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           "OpenModelica_Scripting_Internal_stat",
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           "OpenModelica_Scripting_realpath",
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           "OpenModelica_Scripting_regex",
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_fn )
      equation
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_448(txt, a_fn, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_449;

protected function fun_450
  input Tpl.Text in_txt;
  input SimCodeFunction.Function in_a_fn;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_a_fn, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      SimCodeFunction.Function i_fn;

    case ( txt,
           (i_fn as SimCodeFunction.FUNCTION(name = _)),
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = functionHeaderRegularFunction2(txt, i_fn, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           (i_fn as SimCodeFunction.EXTERNAL_FUNCTION(name = _)),
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = functionHeaderRegularFunction2(txt, i_fn, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           (i_fn as SimCodeFunction.RECORD_CONSTRUCTOR(name = _)),
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = functionHeaderRecordConstruct(txt, i_fn, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_useFlatArrayNotation);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_450;

protected function fun_451
  input Tpl.Text in_txt;
  input String in_mArg;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input SimCodeFunction.Function in_a_fn;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_mArg, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_fn)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      SimCodeFunction.Function a_fn;

    case ( txt,
           "OpenModelica_Scripting_regexBool",
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           "Modelica_Utilities_Files_loadResource",
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           "OpenModelica_Scripting_directoryExists",
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           "OpenModelica_Scripting_uriToFilename",
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           "OpenModelica_Scripting_Internal_stat",
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           "OpenModelica_Scripting_realpath",
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           "OpenModelica_Scripting_regex",
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_fn )
      equation
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_450(txt, a_fn, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_451;

protected function fun_452
  input Tpl.Text in_txt;
  input SimCodeFunction.Function in_a_fn;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_a_fn, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      SimCodeFunction.Function i_fn;

    case ( txt,
           (i_fn as SimCodeFunction.FUNCTION(name = _)),
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = functionHeaderRegularFunction2(txt, i_fn, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           (i_fn as SimCodeFunction.EXTERNAL_FUNCTION(name = _)),
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = functionHeaderRegularFunction2(txt, i_fn, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           (i_fn as SimCodeFunction.RECORD_CONSTRUCTOR(name = _)),
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = functionHeaderRecordConstruct(txt, i_fn, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_useFlatArrayNotation);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_452;

protected function fun_453
  input Tpl.Text in_txt;
  input String in_mArg;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input SimCodeFunction.Function in_a_fn;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_mArg, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_fn)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      SimCodeFunction.Function a_fn;

    case ( txt,
           "OpenModelica_Scripting_regexBool",
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           "Modelica_Utilities_Files_loadResource",
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           "OpenModelica_Scripting_directoryExists",
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           "OpenModelica_Scripting_uriToFilename",
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           "OpenModelica_Scripting_Internal_stat",
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           "OpenModelica_Scripting_realpath",
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           "OpenModelica_Scripting_regex",
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_fn )
      equation
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_452(txt, a_fn, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_453;

public function functionHeaderBody2
  input Tpl.Text in_txt;
  input SimCodeFunction.Function in_a_fn;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_fn, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      SimCodeFunction.Function i_fn;
      Absyn.Path i_name;
      String str_3;
      String str_2;
      String str_1;
      Tpl.Text l_fname;

    case ( txt,
           (i_fn as SimCodeFunction.FUNCTION(name = i_name)),
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_fname = CodegenUtil.underscorePath(Tpl.emptyTxt, i_name);
        str_1 = Tpl.textString(l_fname);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_449(txt, str_1, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, i_fn);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           (i_fn as SimCodeFunction.EXTERNAL_FUNCTION(name = i_name)),
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_fname = CodegenUtil.underscorePath(Tpl.emptyTxt, i_name);
        str_2 = Tpl.textString(l_fname);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_451(txt, str_2, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, i_fn);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           (i_fn as SimCodeFunction.RECORD_CONSTRUCTOR(name = i_name)),
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_fname = CodegenUtil.underscorePath(Tpl.emptyTxt, i_name);
        str_3 = Tpl.textString(l_fname);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_453(txt, str_3, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, i_fn);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end functionHeaderBody2;

protected function lm_455
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Function> in_items;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Function> rest;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      SimCodeFunction.Function i_fn;

    case ( txt,
           {},
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           i_fn :: rest,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = functionHeaderBody3(txt, i_fn, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
        txt = Tpl.nextIter(txt);
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_455(txt, rest, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_455;

public function functionHeaderBodies3
  input Tpl.Text txt;
  input list<SimCodeFunction.Function> a_functions;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  out_txt := Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) := lm_455(out_txt, a_functions, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
  out_txt := Tpl.popIter(out_txt);
end functionHeaderBodies3;

protected function fun_457
  input Tpl.Text in_txt;
  input SimCodeFunction.Function in_a_fn;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_a_fn, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      SimCodeFunction.Function i_fn;

    case ( txt,
           (i_fn as SimCodeFunction.FUNCTION(name = _)),
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = functionHeaderRegularFunction3(txt, i_fn, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           (i_fn as SimCodeFunction.EXTERNAL_FUNCTION(name = _)),
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = functionHeaderRegularFunction3(txt, i_fn, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           SimCodeFunction.RECORD_CONSTRUCTOR(name = _),
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_457;

protected function fun_458
  input Tpl.Text in_txt;
  input String in_mArg;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input SimCodeFunction.Function in_a_fn;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_mArg, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_fn)
    local
      Tpl.Text txt;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      SimCodeFunction.Function a_fn;

    case ( txt,
           "OpenModelica_Scripting_regexBool",
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           "Modelica_Utilities_Files_loadResource",
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           "OpenModelica_Scripting_directoryExists",
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           "OpenModelica_Scripting_uriToFilename",
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           "OpenModelica_Scripting_Internal_stat",
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           "OpenModelica_Scripting_realpath",
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           "OpenModelica_Scripting_regex",
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_fn )
      equation
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_457(txt, a_fn, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_458;

protected function fun_459
  input Tpl.Text in_txt;
  input SimCodeFunction.Function in_a_fn;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_a_fn, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      SimCodeFunction.Function i_fn;

    case ( txt,
           (i_fn as SimCodeFunction.FUNCTION(name = _)),
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = functionHeaderRegularFunction3(txt, i_fn, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           (i_fn as SimCodeFunction.EXTERNAL_FUNCTION(name = _)),
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = functionHeaderRegularFunction3(txt, i_fn, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           SimCodeFunction.RECORD_CONSTRUCTOR(name = _),
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_459;

protected function fun_460
  input Tpl.Text in_txt;
  input String in_mArg;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input SimCodeFunction.Function in_a_fn;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_mArg, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_fn)
    local
      Tpl.Text txt;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      SimCodeFunction.Function a_fn;

    case ( txt,
           "OpenModelica_Scripting_regexBool",
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           "Modelica_Utilities_Files_loadResource",
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           "OpenModelica_Scripting_directoryExists",
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           "OpenModelica_Scripting_uriToFilename",
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           "OpenModelica_Scripting_Internal_stat",
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           "OpenModelica_Scripting_realpath",
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           "OpenModelica_Scripting_regex",
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_fn )
      equation
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_459(txt, a_fn, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_460;

protected function fun_461
  input Tpl.Text in_txt;
  input SimCodeFunction.Function in_a_fn;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_a_fn, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      SimCodeFunction.Function i_fn;

    case ( txt,
           (i_fn as SimCodeFunction.FUNCTION(name = _)),
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = functionHeaderRegularFunction3(txt, i_fn, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           (i_fn as SimCodeFunction.EXTERNAL_FUNCTION(name = _)),
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = functionHeaderRegularFunction3(txt, i_fn, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           SimCodeFunction.RECORD_CONSTRUCTOR(name = _),
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_461;

protected function fun_462
  input Tpl.Text in_txt;
  input String in_mArg;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input SimCodeFunction.Function in_a_fn;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_mArg, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_fn)
    local
      Tpl.Text txt;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      SimCodeFunction.Function a_fn;

    case ( txt,
           "OpenModelica_Scripting_regexBool",
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           "Modelica_Utilities_Files_loadResource",
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           "OpenModelica_Scripting_directoryExists",
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           "OpenModelica_Scripting_uriToFilename",
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           "OpenModelica_Scripting_Internal_stat",
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           "OpenModelica_Scripting_realpath",
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           "OpenModelica_Scripting_regex",
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_fn )
      equation
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_461(txt, a_fn, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_462;

public function functionHeaderBody3
  input Tpl.Text in_txt;
  input SimCodeFunction.Function in_a_fn;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace) :=
  match(in_txt, in_a_fn, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      SimCodeFunction.Function i_fn;
      Absyn.Path i_name;
      String str_3;
      String str_2;
      String str_1;
      Tpl.Text l_fname;

    case ( txt,
           (i_fn as SimCodeFunction.FUNCTION(name = i_name)),
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace )
      equation
        l_fname = CodegenUtil.underscorePath(Tpl.emptyTxt, i_name);
        str_1 = Tpl.textString(l_fname);
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_458(txt, str_1, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, i_fn);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);

    case ( txt,
           (i_fn as SimCodeFunction.EXTERNAL_FUNCTION(name = i_name)),
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace )
      equation
        l_fname = CodegenUtil.underscorePath(Tpl.emptyTxt, i_name);
        str_2 = Tpl.textString(l_fname);
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_460(txt, str_2, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, i_fn);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);

    case ( txt,
           (i_fn as SimCodeFunction.RECORD_CONSTRUCTOR(name = i_name)),
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace )
      equation
        l_fname = CodegenUtil.underscorePath(Tpl.emptyTxt, i_name);
        str_3 = Tpl.textString(l_fname);
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_462(txt, str_3, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, i_fn);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);

    case ( txt,
           _,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
  end match;
end functionHeaderBody3;

protected function lm_464
  input Tpl.Text in_txt;
  input list<String> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<String> rest;
      String i_i;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_i :: rest )
      equation
        txt = Tpl.writeStr(txt, i_i);
        txt = Tpl.nextIter(txt);
        txt = lm_464(txt, rest);
      then txt;
  end match;
end lm_464;

protected function fun_465
  input Tpl.Text in_txt;
  input list<String> in_a_includes;
  input Tpl.Text in_a_fargsStrEscaped;
  input SimCodeFunction.SimExtArg in_a_extReturn;
  input Tpl.Text in_a_fargsStr;
  input Tpl.Text in_a_fn__name;
  input SimCodeFunction.SimExtArg in_a_return;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_includes, in_a_fargsStrEscaped, in_a_extReturn, in_a_fargsStr, in_a_fn__name, in_a_return)
    local
      Tpl.Text txt;
      Tpl.Text a_fargsStrEscaped;
      SimCodeFunction.SimExtArg a_extReturn;
      Tpl.Text a_fargsStr;
      Tpl.Text a_fn__name;
      SimCodeFunction.SimExtArg a_return;

    case ( txt,
           {},
           _,
           _,
           a_fargsStr,
           a_fn__name,
           a_return )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("extern "));
        txt = extReturnType(txt, a_return);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, a_fn__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_fargsStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;

    case ( txt,
           _,
           a_fargsStrEscaped,
           a_extReturn,
           _,
           a_fn__name,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "/*\n",
                                    " * The function has annotation(Include=...>)\n",
                                    " * the external function definition should be present\n",
                                    " * in one of these files and have this prototype:\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("* extern "));
        txt = extReturnType(txt, a_extReturn);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, a_fn__name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_fargsStrEscaped);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ");\n",
                                    "*/"
                                }, false));
        txt = Tpl.popBlock(txt);
      then txt;
  end match;
end fun_465;

protected function fun_466
  input Tpl.Text in_txt;
  input SimCodeFunction.Function in_a_fn;
  input SimCodeFunction.SimExtArg in_a_return;
  input Tpl.Text in_a_fargsStr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fn, in_a_return, in_a_fargsStr)
    local
      Tpl.Text txt;
      SimCodeFunction.SimExtArg a_return;
      Tpl.Text a_fargsStr;
      SimCodeFunction.SimExtArg i_extReturn;
      String i_language;
      String i_extName;
      list<String> i_includes;
      Tpl.Text l_fn__name;
      Tpl.Text l_includesStr;
      Tpl.Text l_fargsStrEscaped;

    case ( txt,
           SimCodeFunction.EXTERNAL_FUNCTION(includes = i_includes, extName = i_extName, language = i_language, extReturn = i_extReturn),
           a_return,
           a_fargsStr )
      equation
        l_fargsStrEscaped = CodegenUtil.escapeCComments(Tpl.emptyTxt, Tpl.textString(a_fargsStr));
        l_includesStr = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_includesStr = lm_464(l_includesStr, i_includes);
        l_includesStr = Tpl.popIter(l_includesStr);
        l_fn__name = extFunctionName(Tpl.emptyTxt, i_extName, i_language);
        txt = fun_465(txt, i_includes, l_fargsStrEscaped, i_extReturn, a_fargsStr, l_fn__name, a_return);
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_466;

protected function fun_467
  input Tpl.Text in_txt;
  input String in_a_extName;
  input SimCodeFunction.SimExtArg in_a_return;
  input Tpl.Text in_a_fargsStr;
  input SimCodeFunction.Function in_a_fn;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_extName, in_a_return, in_a_fargsStr, in_a_fn)
    local
      Tpl.Text txt;
      SimCodeFunction.SimExtArg a_return;
      Tpl.Text a_fargsStr;
      SimCodeFunction.Function a_fn;

    case ( txt,
           "OpenModelica_regex",
           _,
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_return,
           a_fargsStr,
           a_fn )
      equation
        txt = fun_466(txt, a_fn, a_return, a_fargsStr);
      then txt;
  end match;
end fun_467;

public function extFunDef
  input Tpl.Text in_txt;
  input SimCodeFunction.Function in_a_fn;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fn)
    local
      Tpl.Text txt;
      SimCodeFunction.SimExtArg i_return;
      SimCodeFunction.Function i_func;
      String i_extName;
      String i_language;
      list<SimCodeFunction.SimExtArg> i_extArgs;
      Tpl.Text l_fargsStr;

    case ( txt,
           (i_func as SimCodeFunction.EXTERNAL_FUNCTION(extReturn = i_return, extArgs = i_extArgs, language = i_language, extName = i_extName)) )
      equation
        l_fargsStr = extFunDefArgs(Tpl.emptyTxt, i_extArgs, i_language);
        txt = fun_467(txt, i_extName, i_return, l_fargsStr, i_func);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end extFunDef;

protected function fun_469
  input Tpl.Text in_txt;
  input String in_a_language;
  input String in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_language, in_a_name)
    local
      Tpl.Text txt;
      String a_name;
      String i_language;
      Tpl.Text txt_0;

    case ( txt,
           "C",
           a_name )
      equation
        txt = Tpl.writeStr(txt, a_name);
      then txt;

    case ( txt,
           "FORTRAN 77",
           a_name )
      equation
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
      then txt;

    case ( txt,
           i_language,
           _ )
      equation
        txt_0 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("Unsupported external language: "));
        txt_0 = Tpl.writeStr(txt_0, i_language);
        txt = CodegenCppCommonOld.error(txt, Tpl.sourceInfo("CodegenCppOld.tpl", 4339, 14), Tpl.textString(txt_0));
      then txt;
  end match;
end fun_469;

public function extFunctionName
  input Tpl.Text txt;
  input String a_name;
  input String a_language;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_469(txt, a_language, a_name);
end extFunctionName;

protected function lm_471
  input Tpl.Text in_txt;
  input list<SimCodeFunction.SimExtArg> in_items;
  input String in_a_language;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_language)
    local
      Tpl.Text txt;
      list<SimCodeFunction.SimExtArg> rest;
      String a_language;
      SimCodeFunction.SimExtArg i_arg;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_arg :: rest,
           a_language )
      equation
        txt = extFunDefArg(txt, i_arg, a_language);
        txt = Tpl.nextIter(txt);
        txt = lm_471(txt, rest, a_language);
      then txt;
  end match;
end lm_471;

protected function lm_472
  input Tpl.Text in_txt;
  input list<SimCodeFunction.SimExtArg> in_items;
  input String in_a_language;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_language)
    local
      Tpl.Text txt;
      list<SimCodeFunction.SimExtArg> rest;
      String a_language;
      SimCodeFunction.SimExtArg i_arg;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_arg :: rest,
           a_language )
      equation
        txt = extFunDefArg(txt, i_arg, a_language);
        txt = Tpl.nextIter(txt);
        txt = lm_472(txt, rest, a_language);
      then txt;
  end match;
end lm_472;

protected function fun_473
  input Tpl.Text in_txt;
  input String in_a_language;
  input list<SimCodeFunction.SimExtArg> in_a_args;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_language, in_a_args)
    local
      Tpl.Text txt;
      list<SimCodeFunction.SimExtArg> a_args;
      String i_language;
      Tpl.Text txt_0;

    case ( txt,
           (i_language as "C"),
           a_args )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_471(txt, a_args, i_language);
        txt = Tpl.popIter(txt);
      then txt;

    case ( txt,
           (i_language as "FORTRAN 77"),
           a_args )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_472(txt, a_args, i_language);
        txt = Tpl.popIter(txt);
      then txt;

    case ( txt,
           i_language,
           _ )
      equation
        txt_0 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("Unsupported external language: "));
        txt_0 = Tpl.writeStr(txt_0, i_language);
        txt = CodegenCppCommonOld.error(txt, Tpl.sourceInfo("CodegenCppOld.tpl", 4348, 14), Tpl.textString(txt_0));
      then txt;
  end match;
end fun_473;

public function extFunDefArgs
  input Tpl.Text txt;
  input list<SimCodeFunction.SimExtArg> a_args;
  input String a_language;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_473(txt, a_language, a_args);
end extFunDefArgs;

protected function fun_475
  input Tpl.Text in_txt;
  input String in_a_language;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_language)
    local
      Tpl.Text txt;

    case ( txt,
           "FORTRAN 77" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("int*"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("size_t"));
      then txt;
  end match;
end fun_475;

public function extFunDefArg
  input Tpl.Text in_txt;
  input SimCodeFunction.SimExtArg in_a_extArg;
  input String in_a_language;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_extArg, in_a_language)
    local
      Tpl.Text txt;
      String a_language;
      DAE.Type i_type__;
      Boolean i_ia;
      Boolean i_ii;
      DAE.Type i_t;
      DAE.ComponentRef i_c;
      Tpl.Text l_typeStr;
      Tpl.Text l_name;

    case ( txt,
           SimCodeFunction.SIMEXTARG(cref = i_c, isInput = i_ii, isArray = i_ia, type_ = i_t),
           a_language )
      equation
        l_name = CodegenCppCommonOld.contextCref2(Tpl.emptyTxt, i_c, SimCodeFunction.contextFunction);
        l_typeStr = extType(Tpl.emptyTxt, i_t, a_language, true, i_ii, i_ia);
        txt = Tpl.writeText(txt, l_typeStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" /*"));
        txt = Tpl.writeText(txt, l_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("*/"));
      then txt;

    case ( txt,
           SimCodeFunction.SIMEXTARGEXP(type_ = i_type__),
           a_language )
      equation
        l_typeStr = extType(Tpl.emptyTxt, i_type__, a_language, true, true, false);
        txt = Tpl.writeText(txt, l_typeStr);
      then txt;

    case ( txt,
           SimCodeFunction.SIMEXTARGSIZE(cref = _),
           a_language )
      equation
        l_typeStr = fun_475(Tpl.emptyTxt, a_language);
        txt = Tpl.writeText(txt, l_typeStr);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end extFunDefArg;

protected function fun_477
  input Tpl.Text in_txt;
  input String in_a_language;
  input DAE.Type in_a_type;
  input Boolean in_a_isReference;
  input Boolean in_a_isInput;
  input Boolean in_a_isArray;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_language, in_a_type, in_a_isReference, in_a_isInput, in_a_isArray)
    local
      Tpl.Text txt;
      DAE.Type a_type;
      Boolean a_isReference;
      Boolean a_isInput;
      Boolean a_isArray;
      String i_language;
      Tpl.Text txt_0;

    case ( txt,
           "C",
           a_type,
           _,
           a_isInput,
           a_isArray )
      equation
        txt = extType2(txt, a_type, a_isInput, a_isArray);
      then txt;

    case ( txt,
           "FORTRAN 77",
           a_type,
           a_isReference,
           a_isInput,
           _ )
      equation
        txt = extTypeF77(txt, a_type, a_isInput, a_isReference);
      then txt;

    case ( txt,
           i_language,
           _,
           _,
           _,
           _ )
      equation
        txt_0 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("Unsupported external language: "));
        txt_0 = Tpl.writeStr(txt_0, i_language);
        txt = CodegenCppCommonOld.error(txt, Tpl.sourceInfo("CodegenCppOld.tpl", 4382, 14), Tpl.textString(txt_0));
      then txt;
  end match;
end fun_477;

public function extType
  input Tpl.Text txt;
  input DAE.Type a_type;
  input String a_language;
  input Boolean a_isReference;
  input Boolean a_isInput;
  input Boolean a_isArray;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_477(txt, a_language, a_type, a_isReference, a_isInput, a_isArray);
end extType;

protected function fun_479
  input Tpl.Text in_txt;
  input DAE.Type in_a_type;
  input Boolean in_a_isInput;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_type, in_a_isInput)
    local
      Tpl.Text txt;
      Boolean a_isInput;
      DAE.Type i_type;
      Absyn.Path i_rname;
      DAE.Type i_ty;
      Tpl.Text txt_0;
      String ret_0;

    case ( txt,
           DAE.T_INTEGER(varLst = _),
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("int"));
      then txt;

    case ( txt,
           DAE.T_REAL(varLst = _),
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("double"));
      then txt;

    case ( txt,
           DAE.T_STRING(varLst = _),
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("const char*"));
      then txt;

    case ( txt,
           DAE.T_BOOL(varLst = _),
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("int"));
      then txt;

    case ( txt,
           DAE.T_ENUMERATION(index = _),
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("int"));
      then txt;

    case ( txt,
           DAE.T_ARRAY(ty = i_ty),
           a_isInput )
      equation
        txt = extType2(txt, i_ty, a_isInput, true);
      then txt;

    case ( txt,
           DAE.T_COMPLEX(complexClassType = ClassInf.EXTERNAL_OBJ(path = _)),
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void*"));
      then txt;

    case ( txt,
           DAE.T_COMPLEX(complexClassType = ClassInf.RECORD(path = i_rname)),
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("struct "));
        txt = CodegenUtil.underscorePath(txt, i_rname);
      then txt;

    case ( txt,
           DAE.T_METATYPE(ty = _),
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_metatype"));
      then txt;

    case ( txt,
           DAE.T_METABOXED(ty = _),
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_metatype"));
      then txt;

    case ( txt,
           i_type,
           _ )
      equation
        txt_0 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("Unknown external C type "));
        ret_0 = Types.unparseType(i_type);
        txt_0 = Tpl.writeStr(txt_0, ret_0);
        txt = CodegenCppCommonOld.error(txt, Tpl.sourceInfo("CodegenCppOld.tpl", 4401, 14), Tpl.textString(txt_0));
      then txt;
  end match;
end fun_479;

protected function fun_480
  input Tpl.Text in_txt;
  input String in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           "const char*" )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("const "));
      then txt;
  end match;
end fun_480;

protected function fun_481
  input Tpl.Text in_txt;
  input Boolean in_a_isArray;
  input Tpl.Text in_a_s;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_isArray, in_a_s)
    local
      Tpl.Text txt;
      Tpl.Text a_s;
      String str_0;

    case ( txt,
           false,
           a_s )
      equation
        txt = Tpl.writeText(txt, a_s);
      then txt;

    case ( txt,
           _,
           a_s )
      equation
        str_0 = Tpl.textString(a_s);
        txt = fun_480(txt, str_0);
        txt = Tpl.writeText(txt, a_s);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("*"));
      then txt;
  end match;
end fun_481;

protected function fun_482
  input Tpl.Text in_txt;
  input Boolean in_a_isInput;
  input Boolean in_a_isArray;
  input Tpl.Text in_a_s;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_isInput, in_a_isArray, in_a_s)
    local
      Tpl.Text txt;
      Boolean a_isArray;
      Tpl.Text a_s;

    case ( txt,
           false,
           _,
           a_s )
      equation
        txt = Tpl.writeText(txt, a_s);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("*"));
      then txt;

    case ( txt,
           _,
           a_isArray,
           a_s )
      equation
        txt = fun_481(txt, a_isArray, a_s);
      then txt;
  end match;
end fun_482;

protected function fun_483
  input Tpl.Text in_txt;
  input DAE.Type in_a_type;
  input Boolean in_a_isArray;
  input Boolean in_a_isInput;
  input Tpl.Text in_a_s;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_type, in_a_isArray, in_a_isInput, in_a_s)
    local
      Tpl.Text txt;
      Boolean a_isArray;
      Boolean a_isInput;
      Tpl.Text a_s;

    case ( txt,
           DAE.T_ARRAY(ty = _),
           _,
           _,
           a_s )
      equation
        txt = Tpl.writeText(txt, a_s);
      then txt;

    case ( txt,
           _,
           a_isArray,
           a_isInput,
           a_s )
      equation
        txt = fun_482(txt, a_isInput, a_isArray, a_s);
      then txt;
  end match;
end fun_483;

public function extType2
  input Tpl.Text txt;
  input DAE.Type a_type;
  input Boolean a_isInput;
  input Boolean a_isArray;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_s;
algorithm
  l_s := fun_479(Tpl.emptyTxt, a_type, a_isInput);
  out_txt := fun_483(txt, a_type, a_isArray, a_isInput, l_s);
end extType2;

protected function fun_485
  input Tpl.Text in_txt;
  input DAE.Type in_a_type;
  input Boolean in_a_isInput;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_type, in_a_isInput)
    local
      Tpl.Text txt;
      Boolean a_isInput;
      DAE.Type i_type;
      Absyn.Path i_rname;
      DAE.Type i_ty;
      Tpl.Text txt_0;
      String ret_0;

    case ( txt,
           DAE.T_INTEGER(varLst = _),
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("int"));
      then txt;

    case ( txt,
           DAE.T_REAL(varLst = _),
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("double"));
      then txt;

    case ( txt,
           DAE.T_STRING(varLst = _),
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("const char*"));
      then txt;

    case ( txt,
           DAE.T_BOOL(varLst = _),
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("int"));
      then txt;

    case ( txt,
           DAE.T_ENUMERATION(index = _),
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("int"));
      then txt;

    case ( txt,
           DAE.T_ARRAY(ty = i_ty),
           a_isInput )
      equation
        txt = extTypeF77(txt, i_ty, a_isInput, true);
      then txt;

    case ( txt,
           DAE.T_COMPLEX(complexClassType = ClassInf.EXTERNAL_OBJ(path = _)),
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void*"));
      then txt;

    case ( txt,
           DAE.T_COMPLEX(complexClassType = ClassInf.RECORD(path = i_rname)),
           _ )
      equation
        txt = CodegenUtil.underscorePath(txt, i_rname);
      then txt;

    case ( txt,
           DAE.T_METATYPE(ty = _),
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void*"));
      then txt;

    case ( txt,
           DAE.T_METABOXED(ty = _),
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void*"));
      then txt;

    case ( txt,
           i_type,
           _ )
      equation
        txt_0 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("Unknown external F77 type "));
        ret_0 = Types.unparseType(i_type);
        txt_0 = Tpl.writeStr(txt_0, ret_0);
        txt = CodegenCppCommonOld.error(txt, Tpl.sourceInfo("CodegenCppOld.tpl", 4421, 14), Tpl.textString(txt_0));
      then txt;
  end match;
end fun_485;

protected function fun_486
  input Tpl.Text in_txt;
  input Boolean in_a_isInput;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_isInput)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("const "));
      then txt;
  end match;
end fun_486;

protected function fun_487
  input Tpl.Text in_txt;
  input Boolean in_a_isReference;
  input Boolean in_a_isInput;
  input Tpl.Text in_a_s;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_isReference, in_a_isInput, in_a_s)
    local
      Tpl.Text txt;
      Boolean a_isInput;
      Tpl.Text a_s;

    case ( txt,
           false,
           _,
           a_s )
      equation
        txt = Tpl.writeText(txt, a_s);
      then txt;

    case ( txt,
           _,
           a_isInput,
           a_s )
      equation
        txt = fun_486(txt, a_isInput);
        txt = Tpl.writeText(txt, a_s);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("*"));
      then txt;
  end match;
end fun_487;

protected function fun_488
  input Tpl.Text in_txt;
  input DAE.Type in_a_type;
  input Boolean in_a_isInput;
  input Boolean in_a_isReference;
  input Tpl.Text in_a_s;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_type, in_a_isInput, in_a_isReference, in_a_s)
    local
      Tpl.Text txt;
      Boolean a_isInput;
      Boolean a_isReference;
      Tpl.Text a_s;

    case ( txt,
           DAE.T_ARRAY(ty = _),
           _,
           _,
           a_s )
      equation
        txt = Tpl.writeText(txt, a_s);
      then txt;

    case ( txt,
           DAE.T_STRING(varLst = _),
           _,
           _,
           a_s )
      equation
        txt = Tpl.writeText(txt, a_s);
      then txt;

    case ( txt,
           _,
           a_isInput,
           a_isReference,
           a_s )
      equation
        txt = fun_487(txt, a_isReference, a_isInput, a_s);
      then txt;
  end match;
end fun_488;

public function extTypeF77
  input Tpl.Text txt;
  input DAE.Type a_type;
  input Boolean a_isInput;
  input Boolean a_isReference;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_s;
algorithm
  l_s := fun_485(Tpl.emptyTxt, a_type, a_isInput);
  out_txt := fun_488(txt, a_type, a_isInput, a_isReference, l_s);
end extTypeF77;

public function extReturnType
  input Tpl.Text in_txt;
  input SimCodeFunction.SimExtArg in_a_extArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_extArg)
    local
      Tpl.Text txt;
      DAE.Exp i_exp;
      DAE.Type i_type__;
      Tpl.Text txt_0;

    case ( txt,
           SimCodeFunction.SIMEXTARG(type_ = i_type__) )
      equation
        txt = extType2(txt, i_type__, true, false);
      then txt;

    case ( txt,
           SimCodeFunction.SIMNOEXTARG() )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void"));
      then txt;

    case ( txt,
           SimCodeFunction.SIMEXTARGEXP(exp = i_exp) )
      equation
        txt_0 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("Expression types are unsupported as return arguments "));
        txt_0 = ExpressionDumpTpl.dumpExp(txt_0, i_exp, "\"");
        txt = CodegenCppCommonOld.error(txt, Tpl.sourceInfo("CodegenCppOld.tpl", 4432, 36), Tpl.textString(txt_0));
      then txt;

    case ( txt,
           _ )
      equation
        txt = CodegenCppCommonOld.error(txt, Tpl.sourceInfo("CodegenCppOld.tpl", 4433, 14), "Unsupported return argument");
      then txt;
  end match;
end extReturnType;

protected function lm_491
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      SimCodeFunction.Variable i_var;

    case ( txt,
           {},
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           i_var :: rest,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = funReturnDefinition1(txt, i_var, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
        txt = Tpl.nextIter(txt);
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_491(txt, rest, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_491;

protected function lm_492
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      Integer x_i0;
      SimCodeFunction.Variable i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = tupplearrayassign(txt, i_var, x_i0);
        txt = Tpl.nextIter(txt);
        txt = lm_492(txt, rest);
      then txt;
  end match;
end lm_492;

public function functionHeaderRegularFunction1
  input Tpl.Text in_txt;
  input SimCodeFunction.Function in_a_fn;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_fn, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      list<SimCodeFunction.Variable> i_vars;
      SimCodeFunction.Variable i_var;
      Absyn.Path i_name;
      Tpl.Text l_fname;

    case ( txt,
           SimCodeFunction.FUNCTION(outVars = {i_var}, name = i_name),
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_fname = CodegenUtil.underscorePath(Tpl.emptyTxt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " /*default return type*/\n",
                                    "typedef "
                                }, false));
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = funReturnDefinition1(txt, i_var, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("  "));
        txt = Tpl.writeText(txt, l_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "RetType /* functionHeaderRegularFunction1 */;\n",
                                    "typedef "
                                }, false));
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = funReturnDefinition2(txt, i_var, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("  "));
        txt = Tpl.writeText(txt, l_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("RefRetType /* functionHeaderRegularFunction1 */;"));
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           SimCodeFunction.FUNCTION(outVars = (i_vars as _ :: _), name = i_name),
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      equation
        l_fname = CodegenUtil.underscorePath(Tpl.emptyTxt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " /*tuple return type*/\n",
                                    "struct "
                                }, false));
        txt = Tpl.writeText(txt, l_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Type/*RecordTypeTest*/\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("typedef tuple< "));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_491(txt, i_vars, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " > TUPLE_ARRAY;\n",
                                    "\n"
                                }, true));
        txt = Tpl.writeText(txt, l_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Type& operator=(const "));
        txt = Tpl.writeText(txt, l_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Type& A)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING_LIST({
                                                                     "\n",
                                                                     " "
                                                                 }, false)), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_492(txt, i_vars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("return *this;\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "TUPLE_ARRAY data;\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "};\n",
                                    "typedef "
                                }, false));
        txt = Tpl.writeText(txt, l_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Type/*RecordTypeTest*/ "));
        txt = Tpl.writeText(txt, l_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("RetType /* functionHeaderRegularFunction1 */;"));
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           SimCodeFunction.RECORD_CONSTRUCTOR(name = i_name),
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      equation
        l_fname = CodegenUtil.underscorePath(Tpl.emptyTxt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("typedef "));
        txt = Tpl.writeText(txt, l_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Type "));
        txt = Tpl.writeText(txt, l_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("RetType /* functionHeaderRegularFunction1 */;"));
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           SimCodeFunction.PARALLEL_FUNCTION(name = i_name),
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      equation
        l_fname = CodegenUtil.underscorePath(Tpl.emptyTxt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "//PARALLEL_FUNCTION\n",
                                    "//typedef "
                                }, false));
        txt = Tpl.writeText(txt, l_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Type "));
        txt = Tpl.writeText(txt, l_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("RetType out of functionHeaderRegularFunction1;"));
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           SimCodeFunction.KERNEL_FUNCTION(name = i_name),
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      equation
        l_fname = CodegenUtil.underscorePath(Tpl.emptyTxt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "//KERNEL_FUNCTION\n",
                                    "//typedef "
                                }, false));
        txt = Tpl.writeText(txt, l_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Type "));
        txt = Tpl.writeText(txt, l_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("RetType out of functionHeaderRegularFunction1;"));
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           SimCodeFunction.EXTERNAL_FUNCTION(name = i_name),
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      equation
        l_fname = CodegenUtil.underscorePath(Tpl.emptyTxt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "//EXTERNAL_FUNCTION\n",
                                    "//typedef "
                                }, false));
        txt = Tpl.writeText(txt, l_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Type "));
        txt = Tpl.writeText(txt, l_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("RetType out of functionHeaderRegularFunction1;"));
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end functionHeaderRegularFunction1;

protected function fun_494
  input Tpl.Text in_txt;
  input list<DAE.Dimension> in_a_instDims;
  input Integer in_a_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_instDims, in_a_index)
    local
      Tpl.Text txt;
      Integer a_index;

    case ( txt,
           {},
           a_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("get<"));
        txt = Tpl.writeStr(txt, intString(a_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(">(data)= get<"));
        txt = Tpl.writeStr(txt, intString(a_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(">(A.data);"));
      then txt;

    case ( txt,
           _,
           a_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(get<"));
        txt = Tpl.writeStr(txt, intString(a_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(">(data)).assign(get<"));
        txt = Tpl.writeStr(txt, intString(a_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(">(A.data));"));
      then txt;
  end match;
end fun_494;

public function tupplearrayassign
  input Tpl.Text in_txt;
  input SimCodeFunction.Variable in_a_var;
  input Integer in_a_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_var, in_a_index)
    local
      Tpl.Text txt;
      Integer a_index;
      list<DAE.Dimension> i_instDims;

    case ( txt,
           SimCodeFunction.VARIABLE(instDims = i_instDims),
           a_index )
      equation
        txt = fun_494(txt, i_instDims, a_index);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end tupplearrayassign;

protected function lm_496
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      DAE.ComponentRef i_name;
      SimCodeFunction.Variable i_var;

    case ( txt,
           {},
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           (i_var as SimCodeFunction.VARIABLE(name = i_name)) :: rest,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = varType1(txt, i_var, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = CodegenCppCommonOld.crefStr(txt, i_name);
        txt = Tpl.nextIter(txt);
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_496(txt, rest, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _ :: rest,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_496(txt, rest, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_496;

protected function fun_497
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_a_funArgs;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_funArgs)
    local
      Tpl.Text txt;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
      then txt;
  end match;
end fun_497;

protected function fun_498
  input Tpl.Text in_txt;
  input SimCodeFunction.Function in_a_fn;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace) :=
  match(in_txt, in_a_fn, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      list<SimCodeFunction.Variable> i_funArgs;
      Absyn.Path i_name;
      Tpl.Text l_funArgsStr;
      Tpl.Text l_fname;

    case ( txt,
           SimCodeFunction.RECORD_CONSTRUCTOR(name = i_name, funArgs = i_funArgs),
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace )
      equation
        l_fname = CodegenUtil.underscorePath(Tpl.emptyTxt, i_name);
        l_funArgsStr = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_funArgsStr, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_496(l_funArgsStr, i_funArgs, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
        l_funArgsStr = Tpl.popIter(l_funArgsStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void /*RecordTypetest*/ "));
        txt = Tpl.writeText(txt, l_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, l_funArgsStr);
        txt = fun_497(txt, i_funArgs);
        txt = Tpl.writeText(txt, l_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Type &output );"));
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);

    case ( txt,
           _,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
  end match;
end fun_498;

public function functionHeaderRecordConstruct
  input Tpl.Text txt;
  input SimCodeFunction.Function a_fn;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace) := fun_498(txt, a_fn, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
end functionHeaderRecordConstruct;

protected function lm_500
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      SimCodeFunction.Variable i_var;

    case ( txt,
           {},
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           i_var :: rest,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = funReturnDefinition1(txt, i_var, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
        txt = Tpl.nextIter(txt);
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_500(txt, rest, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_500;

protected function lm_501
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      Integer x_i0;
      SimCodeFunction.Variable i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = tupplearrayassign(txt, i_var, x_i0);
        txt = Tpl.nextIter(txt);
        txt = lm_501(txt, rest);
      then txt;
  end match;
end lm_501;

public function functionHeaderExternFunction
  input Tpl.Text in_txt;
  input SimCodeFunction.Function in_a_fn;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace) :=
  match(in_txt, in_a_fn, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      list<SimCodeFunction.Variable> i_outVars;
      SimCodeFunction.Variable i_var;
      Absyn.Path i_name;
      Tpl.Text l_fname;

    case ( txt,
           SimCodeFunction.EXTERNAL_FUNCTION(outVars = {i_var}, name = i_name),
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace )
      equation
        l_fname = CodegenUtil.underscorePath(Tpl.emptyTxt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("typedef  "));
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = funReturnDefinition1(txt, i_var, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, l_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("RetType /* functionHeaderExternFunction */;"));
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);

    case ( txt,
           SimCodeFunction.EXTERNAL_FUNCTION(outVars = (i_outVars as _ :: _), name = i_name),
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace )
      equation
        l_fname = CodegenUtil.underscorePath(Tpl.emptyTxt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " /*tuple return type*/\n",
                                    "struct "
                                }, false));
        txt = Tpl.writeText(txt, l_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Type\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(3));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("typedef tuple< "));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_500(txt, i_outVars, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " > TUPLE_ARRAY;\n",
                                    "\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Type& operator=(const "));
        txt = Tpl.writeText(txt, l_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Type& A)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING_LIST({
                                                                     "\n",
                                                                     " "
                                                                 }, false)), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_501(txt, i_outVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("return *this;\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "TUPLE_ARRAY data;\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "};\n",
                                    "typedef "
                                }, false));
        txt = Tpl.writeText(txt, l_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Type/*RecordTypeTest*/ "));
        txt = Tpl.writeText(txt, l_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("RetType /* functionHeaderExternFunction */;"));
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);

    case ( txt,
           SimCodeFunction.FUNCTION(outVars = _ :: _, name = i_name),
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace )
      equation
        l_fname = CodegenUtil.underscorePath(Tpl.emptyTxt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "//FUNCTION\n",
                                    "//typedef "
                                }, false));
        txt = Tpl.writeText(txt, l_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Type "));
        txt = Tpl.writeText(txt, l_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("RetType out of functionHeaderExternFunction;"));
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);

    case ( txt,
           SimCodeFunction.RECORD_CONSTRUCTOR(name = i_name),
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace )
      equation
        l_fname = CodegenUtil.underscorePath(Tpl.emptyTxt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "//RECORD_CONSTRUCTOR\n",
                                    "//typedef "
                                }, false));
        txt = Tpl.writeText(txt, l_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Type "));
        txt = Tpl.writeText(txt, l_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("RetType out of functionHeaderExternFunction;"));
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);

    case ( txt,
           SimCodeFunction.PARALLEL_FUNCTION(name = i_name),
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace )
      equation
        l_fname = CodegenUtil.underscorePath(Tpl.emptyTxt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "//PARALLEL_FUNCTION\n",
                                    "//typedef "
                                }, false));
        txt = Tpl.writeText(txt, l_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Type "));
        txt = Tpl.writeText(txt, l_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("RetType out of functionHeaderExternFunction;"));
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);

    case ( txt,
           SimCodeFunction.KERNEL_FUNCTION(name = i_name),
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace )
      equation
        l_fname = CodegenUtil.underscorePath(Tpl.emptyTxt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "//KERNEL_FUNCTION\n",
                                    "//typedef "
                                }, false));
        txt = Tpl.writeText(txt, l_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Type "));
        txt = Tpl.writeText(txt, l_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("RetType out of functionHeaderExternFunction;"));
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);

    case ( txt,
           _,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
  end match;
end functionHeaderExternFunction;

protected function lm_503
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      DAE.ComponentRef i_var_name;
      SimCodeFunction.Variable i_var;

    case ( txt,
           {},
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           (i_var as SimCodeFunction.VARIABLE(name = i_var_name)) :: rest,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = varType3(txt, i_var, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = CodegenCppCommonOld.crefStr(txt, i_var_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_503(txt, rest, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _ :: rest,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_503(txt, rest, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_503;

protected function fun_504
  input Tpl.Text in_txt;
  input Option<String> in_a_aliasName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input list<SimCodeFunction.Variable> in_a_r_variables;
  input String in_a_r_name;
  input Tpl.Text in_a_dummyElemCreation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_dummyElemCreation;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_dummyElemCreation) :=
  match(in_txt, in_a_aliasName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_r_variables, in_a_r_name, in_a_dummyElemCreation)
    local
      Tpl.Text txt;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      list<SimCodeFunction.Variable> a_r_variables;
      String a_r_name;
      Tpl.Text a_dummyElemCreation;
      String i_str;

    case ( txt,
           SOME(i_str),
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _,
           a_r_name,
           a_dummyElemCreation )
      equation
        a_dummyElemCreation = Tpl.writeStr(a_dummyElemCreation, a_r_name);
        a_dummyElemCreation = Tpl.writeTok(a_dummyElemCreation, Tpl.ST_STRING("Type dummy"));
        a_dummyElemCreation = Tpl.writeStr(a_dummyElemCreation, a_r_name);
        a_dummyElemCreation = Tpl.writeTok(a_dummyElemCreation, Tpl.ST_STRING("Type;"));
        a_dummyElemCreation = Tpl.writeTok(a_dummyElemCreation, Tpl.ST_NEW_LINE());
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("typedef "));
        txt = Tpl.writeStr(txt, i_str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Type "));
        txt = Tpl.writeStr(txt, a_r_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Type;"));
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_dummyElemCreation);

    case ( txt,
           _,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_r_variables,
           a_r_name,
           a_dummyElemCreation )
      equation
        a_dummyElemCreation = Tpl.writeStr(a_dummyElemCreation, a_r_name);
        a_dummyElemCreation = Tpl.writeTok(a_dummyElemCreation, Tpl.ST_STRING("Type dummy"));
        a_dummyElemCreation = Tpl.writeStr(a_dummyElemCreation, a_r_name);
        a_dummyElemCreation = Tpl.writeTok(a_dummyElemCreation, Tpl.ST_STRING("Type;"));
        a_dummyElemCreation = Tpl.writeTok(a_dummyElemCreation, Tpl.ST_NEW_LINE());
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("struct "));
        txt = Tpl.writeStr(txt, a_r_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Type\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_503(txt, a_r_variables, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("};"));
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_dummyElemCreation);
  end match;
end fun_504;

protected function fun_505
  input Tpl.Text in_txt;
  input SimCodeFunction.RecordDeclaration in_a_recDecl;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_dummyElemCreation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_dummyElemCreation;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_dummyElemCreation) :=
  match(in_txt, in_a_recDecl, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_dummyElemCreation)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_dummyElemCreation;
      list<SimCodeFunction.Variable> i_r_variables;
      String i_r_name;
      Option<String> i_aliasName;

    case ( txt,
           SimCodeFunction.RECORD_DECL_FULL(aliasName = i_aliasName, name = i_r_name, variables = i_r_variables),
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_dummyElemCreation )
      equation
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_dummyElemCreation) = fun_504(txt, i_aliasName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, i_r_variables, i_r_name, a_dummyElemCreation);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_dummyElemCreation);

    case ( txt,
           SimCodeFunction.RECORD_DECL_DEF(path = _),
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_dummyElemCreation )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("RECORD DECL DEF"));
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_dummyElemCreation);

    case ( txt,
           _,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_dummyElemCreation )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_dummyElemCreation);
  end match;
end fun_505;

public function recordDeclarationHeader
  input Tpl.Text txt;
  input SimCodeFunction.RecordDeclaration a_recDecl;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_dummyElemCreation;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_dummyElemCreation;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_dummyElemCreation) := fun_505(txt, a_recDecl, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_dummyElemCreation);
end recordDeclarationHeader;

protected function lm_507
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      DAE.ComponentRef i_name;
      SimCodeFunction.Variable i_var;

    case ( txt,
           {},
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           (i_var as SimCodeFunction.VARIABLE(name = i_name)) :: rest,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = varType1(txt, i_var, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = CodegenCppCommonOld.crefStr(txt, i_name);
        txt = Tpl.nextIter(txt);
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_507(txt, rest, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _ :: rest,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_507(txt, rest, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_507;

protected function fun_508
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_a_funArgs;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_funArgs)
    local
      Tpl.Text txt;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
      then txt;
  end match;
end fun_508;

protected function lm_509
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      DAE.ComponentRef i_name;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           SimCodeFunction.VARIABLE(name = i_name) :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(output."));
        txt = CodegenCppCommonOld.crefStr(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") = ("));
        txt = CodegenCppCommonOld.crefStr(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
        txt = Tpl.nextIter(txt);
        txt = lm_509(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_509(txt, rest);
      then txt;
  end match;
end lm_509;

protected function fun_510
  input Tpl.Text in_txt;
  input SimCodeFunction.Function in_a_fn;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace) :=
  match(in_txt, in_a_fn, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      list<SimCodeFunction.Variable> i_funArgs;
      Absyn.Path i_name;
      Tpl.Text l_structVar;
      Tpl.Text l_structType;
      Tpl.Text l_retVar;
      Tpl.Text l_retType;
      Tpl.Text l_fname;
      Tpl.Text l_varDecls;

    case ( txt,
           SimCodeFunction.RECORD_CONSTRUCTOR(name = i_name, funArgs = i_funArgs),
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace )
      equation
        l_varDecls = Tpl.emptyTxt;
        l_fname = CodegenUtil.underscorePath(Tpl.emptyTxt, i_name);
        l_retType = Tpl.writeText(Tpl.emptyTxt, l_fname);
        l_retType = Tpl.writeTok(l_retType, Tpl.ST_STRING("Type"));
        (l_retVar, l_varDecls) = CodegenCppCommonOld.tempDecl(Tpl.emptyTxt, Tpl.textString(l_retType), l_varDecls);
        l_structType = Tpl.writeText(Tpl.emptyTxt, l_fname);
        l_structType = Tpl.writeTok(l_structType, Tpl.ST_STRING("Type"));
        (l_structVar, l_varDecls) = CodegenCppCommonOld.tempDecl(Tpl.emptyTxt, Tpl.textString(l_structType), l_varDecls);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void /*"));
        txt = Tpl.writeText(txt, l_retType);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("*/ Functions::"));
        txt = Tpl.writeText(txt, l_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_507(txt, i_funArgs, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
        txt = Tpl.popIter(txt);
        txt = fun_508(txt, i_funArgs);
        txt = Tpl.writeText(txt, l_retType);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "& output )\n",
                                    "{\n",
                                    "\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_509(txt, i_funArgs);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("//output = "));
        txt = Tpl.writeText(txt, l_structVar);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("//return "));
        txt = Tpl.writeText(txt, l_structVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "}\n",
                                    "\n",
                                    "\n",
                                    "\n"
                                }, true));
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);

    case ( txt,
           _,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
  end match;
end fun_510;

public function functionBodyRecordConstructor
  input Tpl.Text txt;
  input SimCodeFunction.Function a_fn;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace) := fun_510(txt, a_fn, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
end functionBodyRecordConstructor;

protected function lm_512
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      SimCodeFunction.Variable i_var;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           i_var :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = funArgDefinition(txt, i_var, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_512(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_512;

protected function lm_513
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      SimCodeFunction.Variable i_var;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           i_var :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = funArgDefinition(txt, i_var, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_513(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_513;

protected function fun_514
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_a_functionArguments;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_functionArguments)
    local
      Tpl.Text txt;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
      then txt;
  end match;
end fun_514;

protected function lm_515
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      SimCodeFunction.Variable i_var;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           i_var :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = funArgDefinition(txt, i_var, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_515(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_515;

protected function fun_516
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_a_funArgs;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_funArgs)
    local
      Tpl.Text txt;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
      then txt;
  end match;
end fun_516;

protected function lm_517
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      SimCodeFunction.Variable i_var;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           i_var :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = funArgDefinition(txt, i_var, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_517(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_517;

public function functionHeaderRegularFunction2
  input Tpl.Text in_txt;
  input SimCodeFunction.Function in_a_fn;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_fn, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      list<SimCodeFunction.Variable> i_funArgs;
      list<SimCodeFunction.Variable> i_functionArguments;
      Absyn.Path i_name;
      Tpl.Text l_fname;

    case ( txt,
           SimCodeFunction.FUNCTION(outVars = {}, name = i_name, functionArguments = i_functionArguments),
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_fname = CodegenUtil.underscorePath(Tpl.emptyTxt, i_name);
        txt = functionTemplates(txt, i_functionArguments);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = Tpl.writeText(txt, l_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_512(txt, i_functionArguments, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           SimCodeFunction.FUNCTION(outVars = _, name = i_name, functionArguments = i_functionArguments),
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_fname = CodegenUtil.underscorePath(Tpl.emptyTxt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/* functionHeaderRegularFunction2 */\n"));
        txt = functionTemplates(txt, i_functionArguments);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void /*"));
        txt = Tpl.writeText(txt, l_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("RetType*/ "));
        txt = Tpl.writeText(txt, l_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_513(txt, i_functionArguments, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
        txt = Tpl.popIter(txt);
        txt = fun_514(txt, i_functionArguments);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, l_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("RetType& output);"));
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           SimCodeFunction.EXTERNAL_FUNCTION(outVars = _ :: _, name = i_name, funArgs = i_funArgs),
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_fname = CodegenUtil.underscorePath(Tpl.emptyTxt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "/* functionHeaderRegularFunction2 */\n",
                                    "void /*"
                                }, false));
        txt = Tpl.writeText(txt, l_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("RetType*/ "));
        txt = Tpl.writeText(txt, l_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_515(txt, i_funArgs, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
        txt = Tpl.popIter(txt);
        txt = fun_516(txt, i_funArgs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, l_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("RetType& output);"));
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           SimCodeFunction.EXTERNAL_FUNCTION(outVars = {}, name = i_name, funArgs = i_funArgs),
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_fname = CodegenUtil.underscorePath(Tpl.emptyTxt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = Tpl.writeText(txt, l_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_517(txt, i_funArgs, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end functionHeaderRegularFunction2;

protected function fun_519
  input Tpl.Text in_txt;
  input SimCodeFunction.Function in_a_fn;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fn)
    local
      Tpl.Text txt;
      Absyn.Path i_name;
      Tpl.Text l_fname;

    case ( txt,
           SimCodeFunction.FUNCTION(outVars = {}) )
      then txt;

    case ( txt,
           SimCodeFunction.FUNCTION(outVars = _, name = i_name) )
      equation
        l_fname = CodegenUtil.underscorePath(Tpl.emptyTxt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/* functionHeaderRegularFunction3 */\n"));
        txt = Tpl.writeText(txt, l_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("RetType _"));
        txt = Tpl.writeText(txt, l_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           SimCodeFunction.EXTERNAL_FUNCTION(outVars = _ :: _, name = i_name) )
      equation
        l_fname = CodegenUtil.underscorePath(Tpl.emptyTxt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/* functionHeaderRegularFunction3 */\n"));
        txt = Tpl.writeText(txt, l_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("RetType _"));
        txt = Tpl.writeText(txt, l_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_519;

public function functionHeaderRegularFunction3
  input Tpl.Text txt;
  input SimCodeFunction.Function a_fn;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  out_txt := fun_519(txt, a_fn);
  out_a_extraFuncs := a_extraFuncs;
  out_a_extraFuncsDecl := a_extraFuncsDecl;
  out_a_extraFuncsNamespace := a_extraFuncsNamespace;
end functionHeaderRegularFunction3;

protected function fun_521
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_a_outVars;
  input Tpl.Text in_a_fname;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_outVars, in_a_fname)
    local
      Tpl.Text txt;
      Tpl.Text a_fname;

    case ( txt,
           {},
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void"));
      then txt;

    case ( txt,
           _,
           a_fname )
      equation
        txt = Tpl.writeText(txt, a_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("RetType "));
      then txt;
  end match;
end fun_521;

protected function lm_522
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varInits;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varInits;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varInits, out_a_varDecls) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varInits, in_a_varDecls)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varInits;
      Tpl.Text a_varDecls;
      Integer x_i1;
      SimCodeFunction.Variable i_var;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varInits,
           a_varDecls )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varInits, a_varDecls);

    case ( txt,
           (i_var as SimCodeFunction.VARIABLE(name = _)) :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varInits,
           a_varDecls )
      equation
        x_i1 = Tpl.getIteri_i0(txt);
        (txt, a_varDecls, a_varInits, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = varInit(txt, i_var, "", x_i1, a_varDecls, a_varInits, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varInits, a_varDecls) = lm_522(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varInits, a_varDecls);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varInits, a_varDecls);

    case ( txt,
           _ :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varInits,
           a_varDecls )
      equation
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varInits, a_varDecls) = lm_522(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varInits, a_varDecls);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varInits, a_varDecls);
  end match;
end lm_522;

protected function lm_523
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_outVarAssign;
  input Tpl.Text in_a_outVarCopy;
  input Tpl.Text in_a_outVarInits;
  input Tpl.Text in_a_varDecls;
  input SimCodeFunction.Function in_a_fn;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_outVarAssign;
  output Tpl.Text out_a_outVarCopy;
  output Tpl.Text out_a_outVarInits;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_outVarAssign, out_a_outVarCopy, out_a_outVarInits, out_a_varDecls) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_outVarAssign, in_a_outVarCopy, in_a_outVarInits, in_a_varDecls, in_a_fn)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_outVarAssign;
      Tpl.Text a_outVarCopy;
      Tpl.Text a_outVarInits;
      Tpl.Text a_varDecls;
      SimCodeFunction.Function a_fn;
      Integer x_i1;
      SimCodeFunction.Variable i_var;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_outVarAssign,
           a_outVarCopy,
           a_outVarInits,
           a_varDecls,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_outVarAssign, a_outVarCopy, a_outVarInits, a_varDecls);

    case ( txt,
           i_var :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_outVarAssign,
           a_outVarCopy,
           a_outVarInits,
           a_varDecls,
           a_fn )
      equation
        x_i1 = Tpl.getIteri_i0(txt);
        (txt, a_varDecls, a_outVarInits, a_outVarCopy, a_outVarAssign, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = varOutput(txt, a_fn, i_var, x_i1, a_varDecls, a_outVarInits, a_outVarCopy, a_outVarAssign, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_outVarAssign, a_outVarCopy, a_outVarInits, a_varDecls) = lm_523(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_outVarAssign, a_outVarCopy, a_outVarInits, a_varDecls, a_fn);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_outVarAssign, a_outVarCopy, a_outVarInits, a_varDecls);
  end match;
end lm_523;

protected function lm_524
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_outVarAssign;
  input Tpl.Text in_a_outVarCopy;
  input Tpl.Text in_a_outVarInits;
  input Tpl.Text in_a_varDecls;
  input SimCodeFunction.Function in_a_fn;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_outVarAssign;
  output Tpl.Text out_a_outVarCopy;
  output Tpl.Text out_a_outVarInits;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_outVarAssign, out_a_outVarCopy, out_a_outVarInits, out_a_varDecls) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_outVarAssign, in_a_outVarCopy, in_a_outVarInits, in_a_varDecls, in_a_fn)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_outVarAssign;
      Tpl.Text a_outVarCopy;
      Tpl.Text a_outVarInits;
      Tpl.Text a_varDecls;
      SimCodeFunction.Function a_fn;
      Integer x_i1;
      SimCodeFunction.Variable i_var;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_outVarAssign,
           a_outVarCopy,
           a_outVarInits,
           a_varDecls,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_outVarAssign, a_outVarCopy, a_outVarInits, a_varDecls);

    case ( txt,
           i_var :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_outVarAssign,
           a_outVarCopy,
           a_outVarInits,
           a_varDecls,
           a_fn )
      equation
        x_i1 = Tpl.getIteri_i0(txt);
        (txt, a_varDecls, a_outVarInits, a_outVarCopy, a_outVarAssign, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = varOutputTuple(txt, a_fn, i_var, x_i1, a_varDecls, a_outVarInits, a_outVarCopy, a_outVarAssign, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_outVarAssign, a_outVarCopy, a_outVarInits, a_varDecls) = lm_524(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_outVarAssign, a_outVarCopy, a_outVarInits, a_varDecls, a_fn);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_outVarAssign, a_outVarCopy, a_outVarInits, a_varDecls);
  end match;
end lm_524;

protected function fun_525
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_a_outVars;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_outVarAssign;
  input Tpl.Text in_a_outVarCopy;
  input Tpl.Text in_a_outVarInits;
  input Tpl.Text in_a_varDecls;
  input SimCodeFunction.Function in_a_fn;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_outVarAssign;
  output Tpl.Text out_a_outVarCopy;
  output Tpl.Text out_a_outVarInits;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_outVarAssign, out_a_outVarCopy, out_a_outVarInits, out_a_varDecls) :=
  match(in_txt, in_a_outVars, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_outVarAssign, in_a_outVarCopy, in_a_outVarInits, in_a_varDecls, in_a_fn)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_outVarAssign;
      Tpl.Text a_outVarCopy;
      Tpl.Text a_outVarInits;
      Tpl.Text a_varDecls;
      SimCodeFunction.Function a_fn;
      list<SimCodeFunction.Variable> i_outVars;

    case ( txt,
           (i_outVars as {_}),
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_outVarAssign,
           a_outVarCopy,
           a_outVarInits,
           a_varDecls,
           a_fn )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_outVarAssign, a_outVarCopy, a_outVarInits, a_varDecls) = lm_523(txt, i_outVars, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_outVarAssign, a_outVarCopy, a_outVarInits, a_varDecls, a_fn);
        txt = Tpl.popIter(txt);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_outVarAssign, a_outVarCopy, a_outVarInits, a_varDecls);

    case ( txt,
           i_outVars,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_outVarAssign,
           a_outVarCopy,
           a_outVarInits,
           a_varDecls,
           a_fn )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_outVarAssign, a_outVarCopy, a_outVarInits, a_varDecls) = lm_524(txt, i_outVars, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_outVarAssign, a_outVarCopy, a_outVarInits, a_varDecls, a_fn);
        txt = Tpl.popIter(txt);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_outVarAssign, a_outVarCopy, a_outVarInits, a_varDecls);
  end match;
end fun_525;

protected function lm_526
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      SimCodeFunction.Variable i_var;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           i_var :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = funArgDefinition(txt, i_var, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_526(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_526;

protected function fun_527
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_a_outVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_outVars)
    local
      Tpl.Text txt;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
      then txt;
  end match;
end fun_527;

protected function fun_528
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_a_functionArguments;
  input list<SimCodeFunction.Variable> in_a_outVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_functionArguments, in_a_outVars)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> a_outVars;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           _,
           a_outVars )
      equation
        txt = fun_527(txt, a_outVars);
      then txt;
  end match;
end fun_528;

protected function fun_529
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_a_outVars;
  input Tpl.Text in_a_retType;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_outVars, in_a_retType)
    local
      Tpl.Text txt;
      Tpl.Text a_retType;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           _,
           a_retType )
      equation
        txt = Tpl.writeText(txt, a_retType);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("& output"));
      then txt;
  end match;
end fun_529;

protected function fun_530
  input Tpl.Text in_txt;
  input SimCodeFunction.Variable in_a_var;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_var)
    local
      Tpl.Text txt;
      String i_fnptrName;

    case ( txt,
           SimCodeFunction.FUNCTION_PTR(name = i_fnptrName) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("typedef double "));
        txt = Tpl.writeStr(txt, i_fnptrName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("RetType;"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_530;

protected function lm_531
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      SimCodeFunction.Variable i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = fun_530(txt, i_var);
        txt = Tpl.nextIter(txt);
        txt = lm_531(txt, rest);
      then txt;
  end match;
end lm_531;

protected function fun_532
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_a_outVars;
  input Tpl.Text in_a_fname;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_outVars, in_a_fname)
    local
      Tpl.Text txt;
      Tpl.Text a_fname;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           _,
           a_fname )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/*output = _"));
        txt = Tpl.writeText(txt, a_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";*/"));
      then txt;
  end match;
end fun_532;

protected function lm_533
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      SimCodeFunction.Variable i_var;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           i_var :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = funArgDefinition2(txt, i_var, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_533(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_533;

protected function fun_534
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_a_outVars;
  input Tpl.Text in_a_retType;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_outVars, in_a_retType)
    local
      Tpl.Text txt;
      Tpl.Text a_retType;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           _,
           a_retType )
      equation
        txt = Tpl.writeText(txt, a_retType);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" out;"));
      then txt;
  end match;
end fun_534;

protected function fun_535
  input Tpl.Text in_txt;
  input Boolean in_a_inFunc;
  input Tpl.Text in_a_retType;
  input list<SimCodeFunction.Variable> in_a_outVars;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input list<SimCodeFunction.Variable> in_a_functionArguments;
  input Tpl.Text in_a_fname;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_a_inFunc, in_a_retType, in_a_outVars, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_functionArguments, in_a_fname)
    local
      Tpl.Text txt;
      Tpl.Text a_retType;
      list<SimCodeFunction.Variable> a_outVars;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      list<SimCodeFunction.Variable> a_functionArguments;
      Tpl.Text a_fname;

    case ( txt,
           false,
           _,
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           a_retType,
           a_outVars,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_functionArguments,
           a_fname )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("int in_"));
        txt = Tpl.writeText(txt, a_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(type_description * inArgs, type_description * outVar)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_533(txt, a_functionArguments, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = fun_534(txt, a_outVars, a_retType);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "//MMC_TRY_TOP()\n",
                                    "\n",
                                    "\n",
                                    "\n",
                                    "return 0;\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_535;

public function functionBodyRegularFunction
  input Tpl.Text in_txt;
  input SimCodeFunction.Function in_a_fn;
  input Boolean in_a_inFunc;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_fn, in_a_inFunc, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      Boolean a_inFunc;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      list<SimCodeFunction.Variable> i_functionArguments;
      SimCodeFunction.Function i_fn;
      list<DAE.Statement> i_body;
      list<SimCodeFunction.Variable> i_variableDeclarations;
      list<SimCodeFunction.Variable> i_outVars;
      Absyn.Path i_name;
      Tpl.Text l_0___1;
      Tpl.Text l_outVarAssign;
      Tpl.Text l_outVarCopy;
      Tpl.Text l_outVarInits;
      Tpl.Text l_bodyPart;
      Tpl.Text l_0__;
      Tpl.Text l_varInits;
      Tpl.Text l_varDecls;
      Tpl.Text l_retType;
      Tpl.Text l_fname;

    case ( txt,
           (i_fn as SimCodeFunction.FUNCTION(name = i_name, outVars = i_outVars, variableDeclarations = i_variableDeclarations, body = i_body, functionArguments = i_functionArguments)),
           a_inFunc,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_fname = CodegenUtil.underscorePath(Tpl.emptyTxt, i_name);
        l_retType = fun_521(Tpl.emptyTxt, i_outVars, l_fname);
        l_varDecls = Tpl.emptyTxt;
        l_varInits = Tpl.emptyTxt;
        l_0__ = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(1, SOME(Tpl.ST_STRING("")), NONE(), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_0__, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, l_varInits, l_varDecls) = lm_522(l_0__, i_variableDeclarations, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, l_varInits, l_varDecls);
        l_0__ = Tpl.popIter(l_0__);
        (l_bodyPart, l_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = funStatement(Tpl.emptyTxt, i_body, l_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        l_outVarInits = Tpl.emptyTxt;
        l_outVarCopy = Tpl.emptyTxt;
        l_outVarAssign = Tpl.emptyTxt;
        (l_0___1, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, l_outVarAssign, l_outVarCopy, l_outVarInits, l_varDecls) = fun_525(Tpl.emptyTxt, i_outVars, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, l_outVarAssign, l_outVarCopy, l_outVarInits, l_varDecls, i_fn);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("//if outvars missing\n"));
        txt = functionTemplates(txt, i_functionArguments);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void /*"));
        txt = Tpl.writeText(txt, l_retType);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("*/ Functions::"));
        txt = Tpl.writeText(txt, l_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_526(txt, i_functionArguments, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
        txt = Tpl.popIter(txt);
        txt = fun_528(txt, i_functionArguments, i_outVars);
        txt = fun_529(txt, i_outVars, l_retType);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " )\n",
                                    "{\n",
                                    "  //functionBodyRegularFunction\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_531(txt, i_functionArguments);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_varDecls);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("//outvars\n"));
        txt = Tpl.writeText(txt, l_outVarInits);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_varInits);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "do\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_bodyPart);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "while(false);\n"
                                }, true));
        txt = Tpl.writeText(txt, l_outVarAssign);
        txt = Tpl.softNewLine(txt);
        txt = fun_532(txt, i_outVars, l_fname);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n"
                                }, true));
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_535(txt, a_inFunc, l_retType, i_outVars, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, i_functionArguments, l_fname);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end functionBodyRegularFunction;

protected function fun_537
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_a_outVars;
  input Tpl.Text in_a_fname;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_outVars, in_a_fname)
    local
      Tpl.Text txt;
      Tpl.Text a_fname;

    case ( txt,
           {},
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void"));
      then txt;

    case ( txt,
           _,
           a_fname )
      equation
        txt = Tpl.writeText(txt, a_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("RetType"));
      then txt;
  end match;
end fun_537;

protected function fun_538
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_a_outVars;
  input Tpl.Text in_a_fname;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_outVars, in_a_fname)
    local
      Tpl.Text txt;
      Tpl.Text a_fname;
      SimCodeFunction.Variable i_var;

    case ( txt,
           {i_var},
           _ )
      equation
        txt = funArgName(txt, i_var);
      then txt;

    case ( txt,
           _,
           a_fname )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeText(txt, a_fname);
      then txt;
  end match;
end fun_538;

protected function fun_539
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_a_outVars;
  input Tpl.Text in_a_fname;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_outVars, in_a_fname)
    local
      Tpl.Text txt;
      Tpl.Text a_fname;
      list<SimCodeFunction.Variable> i_outVars;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_outVars,
           a_fname )
      equation
        txt = fun_538(txt, i_outVars, a_fname);
      then txt;
  end match;
end fun_539;

protected function fun_540
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_a_outVars;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_outputAssign;
  input Tpl.Text in_a_inputAssign;
  input Tpl.Text in_a_varDeclsExtFunCall;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Function in_a_fn;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_outputAssign;
  output Tpl.Text out_a_inputAssign;
  output Tpl.Text out_a_varDeclsExtFunCall;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_outputAssign, out_a_inputAssign, out_a_varDeclsExtFunCall, out_a_preExp) :=
  match(in_txt, in_a_outVars, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_outputAssign, in_a_inputAssign, in_a_varDeclsExtFunCall, in_a_preExp, in_a_fn)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_outputAssign;
      Tpl.Text a_inputAssign;
      Tpl.Text a_varDeclsExtFunCall;
      Tpl.Text a_preExp;
      SimCodeFunction.Function a_fn;

    case ( txt,
           {_},
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_outputAssign,
           a_inputAssign,
           a_varDeclsExtFunCall,
           a_preExp,
           a_fn )
      equation
        (txt, a_preExp, a_varDeclsExtFunCall, a_inputAssign, a_outputAssign, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = extFunCall(txt, a_fn, a_preExp, a_varDeclsExtFunCall, a_inputAssign, a_outputAssign, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation, false);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_outputAssign, a_inputAssign, a_varDeclsExtFunCall, a_preExp);

    case ( txt,
           _,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_outputAssign,
           a_inputAssign,
           a_varDeclsExtFunCall,
           a_preExp,
           a_fn )
      equation
        (txt, a_preExp, a_varDeclsExtFunCall, a_inputAssign, a_outputAssign, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = extFunCall(txt, a_fn, a_preExp, a_varDeclsExtFunCall, a_inputAssign, a_outputAssign, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation, true);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_outputAssign, a_inputAssign, a_varDeclsExtFunCall, a_preExp);
  end match;
end fun_540;

protected function lm_541
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_outVarInits;
  input Tpl.Text in_a_varDeclsInit;
  input Tpl.Text in_a_retVar;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_outVarInits;
  output Tpl.Text out_a_varDeclsInit;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_outVarInits, out_a_varDeclsInit) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_outVarInits, in_a_varDeclsInit, in_a_retVar)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_outVarInits;
      Tpl.Text a_varDeclsInit;
      Tpl.Text a_retVar;
      Integer x_i1;
      SimCodeFunction.Variable i_var;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_outVarInits,
           a_varDeclsInit,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_outVarInits, a_varDeclsInit);

    case ( txt,
           (i_var as SimCodeFunction.VARIABLE(name = _)) :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_outVarInits,
           a_varDeclsInit,
           a_retVar )
      equation
        x_i1 = Tpl.getIteri_i0(txt);
        (txt, a_varDeclsInit, a_outVarInits, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = varInit(txt, i_var, Tpl.textString(a_retVar), x_i1, a_varDeclsInit, a_outVarInits, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_outVarInits, a_varDeclsInit) = lm_541(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_outVarInits, a_varDeclsInit, a_retVar);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_outVarInits, a_varDeclsInit);

    case ( txt,
           _ :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_outVarInits,
           a_varDeclsInit,
           a_retVar )
      equation
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_outVarInits, a_varDeclsInit) = lm_541(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_outVarInits, a_varDeclsInit, a_retVar);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_outVarInits, a_varDeclsInit);
  end match;
end lm_541;

protected function lm_542
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_outVarAssign;
  input Tpl.Text in_a_outVarCopy;
  input Tpl.Text in_a_outVarInits;
  input Tpl.Text in_a_varDeclsvOutputTuple;
  input SimCodeFunction.Function in_a_fn;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_outVarAssign;
  output Tpl.Text out_a_outVarCopy;
  output Tpl.Text out_a_outVarInits;
  output Tpl.Text out_a_varDeclsvOutputTuple;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_outVarAssign, out_a_outVarCopy, out_a_outVarInits, out_a_varDeclsvOutputTuple) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_outVarAssign, in_a_outVarCopy, in_a_outVarInits, in_a_varDeclsvOutputTuple, in_a_fn)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_outVarAssign;
      Tpl.Text a_outVarCopy;
      Tpl.Text a_outVarInits;
      Tpl.Text a_varDeclsvOutputTuple;
      SimCodeFunction.Function a_fn;
      Integer x_i1;
      SimCodeFunction.Variable i_var;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_outVarAssign,
           a_outVarCopy,
           a_outVarInits,
           a_varDeclsvOutputTuple,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_outVarAssign, a_outVarCopy, a_outVarInits, a_varDeclsvOutputTuple);

    case ( txt,
           i_var :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_outVarAssign,
           a_outVarCopy,
           a_outVarInits,
           a_varDeclsvOutputTuple,
           a_fn )
      equation
        x_i1 = Tpl.getIteri_i0(txt);
        (txt, a_varDeclsvOutputTuple, a_outVarInits, a_outVarCopy, a_outVarAssign, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = varOutputTuple(txt, a_fn, i_var, x_i1, a_varDeclsvOutputTuple, a_outVarInits, a_outVarCopy, a_outVarAssign, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_outVarAssign, a_outVarCopy, a_outVarInits, a_varDeclsvOutputTuple) = lm_542(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_outVarAssign, a_outVarCopy, a_outVarInits, a_varDeclsvOutputTuple, a_fn);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_outVarAssign, a_outVarCopy, a_outVarInits, a_varDeclsvOutputTuple);
  end match;
end lm_542;

protected function fun_543
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_a_outVars;
  input Tpl.Text in_a_varDeclsvOutputTuple;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_outVarAssign;
  input Tpl.Text in_a_outVarCopy;
  input Tpl.Text in_a_outVarInits;
  input Tpl.Text in_a_varDeclsOutput;
  input SimCodeFunction.Function in_a_fn;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDeclsvOutputTuple;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_outVarAssign;
  output Tpl.Text out_a_outVarCopy;
  output Tpl.Text out_a_outVarInits;
  output Tpl.Text out_a_varDeclsOutput;
algorithm
  (out_txt, out_a_varDeclsvOutputTuple, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_outVarAssign, out_a_outVarCopy, out_a_outVarInits, out_a_varDeclsOutput) :=
  match(in_txt, in_a_outVars, in_a_varDeclsvOutputTuple, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_outVarAssign, in_a_outVarCopy, in_a_outVarInits, in_a_varDeclsOutput, in_a_fn)
    local
      Tpl.Text txt;
      Tpl.Text a_varDeclsvOutputTuple;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_outVarAssign;
      Tpl.Text a_outVarCopy;
      Tpl.Text a_outVarInits;
      Tpl.Text a_varDeclsOutput;
      SimCodeFunction.Function a_fn;
      list<SimCodeFunction.Variable> i_outVars;
      SimCodeFunction.Variable i_var;
      list<SimCodeFunction.Variable> ret_0;

    case ( txt,
           {i_var},
           a_varDeclsvOutputTuple,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_outVarAssign,
           a_outVarCopy,
           a_outVarInits,
           a_varDeclsOutput,
           a_fn )
      equation
        (txt, a_varDeclsOutput, a_outVarInits, a_outVarCopy, a_outVarAssign, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = varOutput(txt, a_fn, i_var, 0, a_varDeclsOutput, a_outVarInits, a_outVarCopy, a_outVarAssign, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_varDeclsvOutputTuple, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_outVarAssign, a_outVarCopy, a_outVarInits, a_varDeclsOutput);

    case ( txt,
           i_outVars,
           a_varDeclsvOutputTuple,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_outVarAssign,
           a_outVarCopy,
           a_outVarInits,
           a_varDeclsOutput,
           a_fn )
      equation
        ret_0 = List.restOrEmpty(i_outVars);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(1, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_outVarAssign, a_outVarCopy, a_outVarInits, a_varDeclsvOutputTuple) = lm_542(txt, ret_0, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_outVarAssign, a_outVarCopy, a_outVarInits, a_varDeclsvOutputTuple, a_fn);
        txt = Tpl.popIter(txt);
      then (txt, a_varDeclsvOutputTuple, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_outVarAssign, a_outVarCopy, a_outVarInits, a_varDeclsOutput);
  end match;
end fun_543;

protected function lm_544
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_outVarAssign1;
  input Tpl.Text in_a_outVarCopy1;
  input Tpl.Text in_a_outVarInits;
  input Tpl.Text in_a_varDeclsvOutputTuple;
  input SimCodeFunction.Function in_a_fn;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_outVarAssign1;
  output Tpl.Text out_a_outVarCopy1;
  output Tpl.Text out_a_outVarInits;
  output Tpl.Text out_a_varDeclsvOutputTuple;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_outVarAssign1, out_a_outVarCopy1, out_a_outVarInits, out_a_varDeclsvOutputTuple) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_outVarAssign1, in_a_outVarCopy1, in_a_outVarInits, in_a_varDeclsvOutputTuple, in_a_fn)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_outVarAssign1;
      Tpl.Text a_outVarCopy1;
      Tpl.Text a_outVarInits;
      Tpl.Text a_varDeclsvOutputTuple;
      SimCodeFunction.Function a_fn;
      Integer x_i1;
      SimCodeFunction.Variable i_var;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_outVarAssign1,
           a_outVarCopy1,
           a_outVarInits,
           a_varDeclsvOutputTuple,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_outVarAssign1, a_outVarCopy1, a_outVarInits, a_varDeclsvOutputTuple);

    case ( txt,
           i_var :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_outVarAssign1,
           a_outVarCopy1,
           a_outVarInits,
           a_varDeclsvOutputTuple,
           a_fn )
      equation
        x_i1 = Tpl.getIteri_i0(txt);
        (txt, a_varDeclsvOutputTuple, a_outVarInits, a_outVarCopy1, a_outVarAssign1, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = varOutputTuple(txt, a_fn, i_var, x_i1, a_varDeclsvOutputTuple, a_outVarInits, a_outVarCopy1, a_outVarAssign1, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_outVarAssign1, a_outVarCopy1, a_outVarInits, a_varDeclsvOutputTuple) = lm_544(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_outVarAssign1, a_outVarCopy1, a_outVarInits, a_varDeclsvOutputTuple, a_fn);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_outVarAssign1, a_outVarCopy1, a_outVarInits, a_varDeclsvOutputTuple);
  end match;
end lm_544;

protected function fun_545
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_a_outVars;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_outVarAssign1;
  input Tpl.Text in_a_outVarCopy1;
  input Tpl.Text in_a_outVarInits;
  input Tpl.Text in_a_varDeclsvOutputTuple;
  input SimCodeFunction.Function in_a_fn;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_outVarAssign1;
  output Tpl.Text out_a_outVarCopy1;
  output Tpl.Text out_a_outVarInits;
  output Tpl.Text out_a_varDeclsvOutputTuple;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_outVarAssign1, out_a_outVarCopy1, out_a_outVarInits, out_a_varDeclsvOutputTuple) :=
  match(in_txt, in_a_outVars, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_outVarAssign1, in_a_outVarCopy1, in_a_outVarInits, in_a_varDeclsvOutputTuple, in_a_fn)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_outVarAssign1;
      Tpl.Text a_outVarCopy1;
      Tpl.Text a_outVarInits;
      Tpl.Text a_varDeclsvOutputTuple;
      SimCodeFunction.Function a_fn;
      list<SimCodeFunction.Variable> i_outVars;

    case ( txt,
           {_},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_outVarAssign1,
           a_outVarCopy1,
           a_outVarInits,
           a_varDeclsvOutputTuple,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("1"));
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_outVarAssign1, a_outVarCopy1, a_outVarInits, a_varDeclsvOutputTuple);

    case ( txt,
           i_outVars,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_outVarAssign1,
           a_outVarCopy1,
           a_outVarInits,
           a_varDeclsvOutputTuple,
           a_fn )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_outVarAssign1, a_outVarCopy1, a_outVarInits, a_varDeclsvOutputTuple) = lm_544(txt, i_outVars, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_outVarAssign1, a_outVarCopy1, a_outVarInits, a_varDeclsvOutputTuple, a_fn);
        txt = Tpl.popIter(txt);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_outVarAssign1, a_outVarCopy1, a_outVarInits, a_varDeclsvOutputTuple);
  end match;
end fun_545;

protected function fun_546
  input Tpl.Text in_txt;
  input Tpl.Text in_a_retVar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_retVar)
    local
      Tpl.Text txt;
      Tpl.Text i_retVar;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/*no output*/"));
      then txt;

    case ( txt,
           i_retVar )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("output = "));
        txt = Tpl.writeText(txt, i_retVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_546;

protected function fun_547
  input Tpl.Text in_txt;
  input String in_mArg;
  input Tpl.Text in_a_outVarAssign1;
  input Tpl.Text in_a_retVar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_outVarAssign1, in_a_retVar)
    local
      Tpl.Text txt;
      Tpl.Text a_outVarAssign1;
      Tpl.Text a_retVar;

    case ( txt,
           "",
           _,
           a_retVar )
      equation
        txt = fun_546(txt, a_retVar);
      then txt;

    case ( txt,
           _,
           a_outVarAssign1,
           _ )
      equation
        txt = Tpl.writeText(txt, a_outVarAssign1);
      then txt;
  end match;
end fun_547;

protected function lm_548
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      SimCodeFunction.Variable i_var;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           i_var :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = funArgDefinition(txt, i_var, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_548(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_548;

protected function fun_549
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_a_outVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_outVars)
    local
      Tpl.Text txt;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
      then txt;
  end match;
end fun_549;

protected function fun_550
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_a_funArgs;
  input list<SimCodeFunction.Variable> in_a_outVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_funArgs, in_a_outVars)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> a_outVars;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           _,
           a_outVars )
      equation
        txt = fun_549(txt, a_outVars);
      then txt;
  end match;
end fun_550;

protected function fun_551
  input Tpl.Text in_txt;
  input Tpl.Text in_a_retVar;
  input Tpl.Text in_a_retType;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_retVar, in_a_retType)
    local
      Tpl.Text txt;
      Tpl.Text a_retType;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           _ )
      then txt;

    case ( txt,
           _,
           a_retType )
      equation
        txt = Tpl.writeText(txt, a_retType);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("& output"));
      then txt;
  end match;
end fun_551;

protected function fun_552
  input Tpl.Text in_txt;
  input Boolean in_a_dynamicLoad;
  input String in_a_language;
  input String in_a_extName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_dynamicLoad, in_a_language, in_a_extName)
    local
      Tpl.Text txt;
      String a_language;
      String a_extName;

    case ( txt,
           false,
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_language,
           a_extName )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("ptrT_"));
        txt = extFunctionName(txt, a_extName, a_language);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" ptr_"));
        txt = extFunctionName(txt, a_extName, a_language);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("=NULL;"));
      then txt;
  end match;
end fun_552;

protected function lm_553
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      DAE.ComponentRef i_name;
      DAE.Type i_ty;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           SimCodeFunction.VARIABLE(ty = i_ty, name = i_name) :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        txt = CodegenCppCommonOld.expTypeArrayIf(txt, i_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.contextCref(txt, i_name, SimCodeFunction.contextFunction, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_553(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _ :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_553(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_553;

protected function lm_554
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      SimCodeFunction.Variable i_arg;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           (i_arg as SimCodeFunction.VARIABLE(name = _)) :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = readInVar(txt, i_arg, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_554(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _ :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_554(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_554;

protected function lm_555
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      DAE.ComponentRef i_name;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           SimCodeFunction.VARIABLE(name = i_name) :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.contextCref(txt, i_name, SimCodeFunction.contextFunction, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_555(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _ :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_555(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_555;

protected function lm_556
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      Integer x_i1;
      SimCodeFunction.Variable i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           (i_var as SimCodeFunction.VARIABLE(name = _)) :: rest )
      equation
        x_i1 = Tpl.getIteri_i0(txt);
        txt = writeOutVar(txt, i_var, x_i1);
        txt = Tpl.nextIter(txt);
        txt = lm_556(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_556(txt, rest);
      then txt;
  end match;
end lm_556;

protected function fun_557
  input Tpl.Text in_txt;
  input Boolean in_a_inFunc;
  input list<SimCodeFunction.Variable> in_a_outVars;
  input Tpl.Text in_a_retType;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input list<SimCodeFunction.Variable> in_a_funArgs;
  input Tpl.Text in_a_fname;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_a_inFunc, in_a_outVars, in_a_retType, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_funArgs, in_a_fname)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> a_outVars;
      Tpl.Text a_retType;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      list<SimCodeFunction.Variable> a_funArgs;
      Tpl.Text a_fname;

    case ( txt,
           false,
           _,
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           a_outVars,
           a_retType,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_funArgs,
           a_fname )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("int in_"));
        txt = Tpl.writeText(txt, a_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(type_description * inArgs, type_description * outVar)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_553(txt, a_funArgs, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, a_retType);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" out;\n"));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_554(txt, a_funArgs, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "MMC_TRY_TOP()\n",
                                    "out = _"
                                }, false));
        txt = Tpl.writeText(txt, a_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_555(txt, a_funArgs, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ");\n",
                                    "MMC_CATCH_TOP(return 1)\n"
                                }, true));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(1, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_556(txt, a_outVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("return 0;\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_557;

public function functionBodyExternalFunction
  input Tpl.Text in_txt;
  input SimCodeFunction.Function in_a_fn;
  input Boolean in_a_inFunc;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_fn, in_a_inFunc, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      Boolean a_inFunc;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      String i_language;
      String i_extName;
      Boolean i_dynamicLoad;
      list<SimCodeFunction.Variable> i_funArgs;
      SimCodeFunction.Function i_efn;
      list<SimCodeFunction.Variable> i_outVars;
      Absyn.Path i_name;
      Tpl.Text l_fnBody;
      String str_20;
      Tpl.Text l_functionBodyExternalFunctionreturn;
      Tpl.Text l_0___2;
      Tpl.Text l_outVarAssign1;
      Tpl.Text l_outVarCopy1;
      Tpl.Text l_0___1;
      Tpl.Text l_outVarCopy;
      Tpl.Text l_outVarAssign;
      Tpl.Text l_0__;
      Tpl.Text l_callPart;
      Tpl.Text l_outVarInits;
      Tpl.Text l_retVar;
      Tpl.Text l_outputAssign;
      Tpl.Text l_inputAssign;
      Tpl.Text l_varDeclsvOutputTuple;
      Tpl.Text l_varDeclsOutput;
      Tpl.Text l_varDeclsExtFunCall;
      Tpl.Text l_varDeclsInit;
      Tpl.Text l_preExp;
      Tpl.Text l_retType;
      Tpl.Text l_fname;

    case ( txt,
           (i_efn as SimCodeFunction.EXTERNAL_FUNCTION(extArgs = _, name = i_name, outVars = i_outVars, funArgs = i_funArgs, dynamicLoad = i_dynamicLoad, extName = i_extName, language = i_language)),
           a_inFunc,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_fname = CodegenUtil.underscorePath(Tpl.emptyTxt, i_name);
        l_retType = fun_537(Tpl.emptyTxt, i_outVars, l_fname);
        l_preExp = Tpl.emptyTxt;
        l_varDeclsInit = Tpl.emptyTxt;
        l_varDeclsExtFunCall = Tpl.emptyTxt;
        l_varDeclsOutput = Tpl.emptyTxt;
        l_varDeclsvOutputTuple = Tpl.emptyTxt;
        l_inputAssign = Tpl.emptyTxt;
        l_outputAssign = Tpl.emptyTxt;
        l_retVar = fun_539(Tpl.emptyTxt, i_outVars, l_fname);
        l_outVarInits = Tpl.emptyTxt;
        (l_callPart, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, l_outputAssign, l_inputAssign, l_varDeclsExtFunCall, l_preExp) = fun_540(Tpl.emptyTxt, i_outVars, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, l_outputAssign, l_inputAssign, l_varDeclsExtFunCall, l_preExp, i_efn);
        l_0__ = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(1, SOME(Tpl.ST_STRING("")), NONE(), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_0__, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, l_outVarInits, l_varDeclsInit) = lm_541(l_0__, i_outVars, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, l_outVarInits, l_varDeclsInit, l_retVar);
        l_0__ = Tpl.popIter(l_0__);
        l_outVarAssign = Tpl.emptyTxt;
        l_outVarCopy = Tpl.emptyTxt;
        (l_0___1, l_varDeclsvOutputTuple, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, l_outVarAssign, l_outVarCopy, l_outVarInits, l_varDeclsOutput) = fun_543(Tpl.emptyTxt, i_outVars, l_varDeclsvOutputTuple, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, l_outVarAssign, l_outVarCopy, l_outVarInits, l_varDeclsOutput, i_efn);
        l_outVarCopy1 = Tpl.emptyTxt;
        l_outVarAssign1 = Tpl.emptyTxt;
        (l_0___2, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, l_outVarAssign1, l_outVarCopy1, l_outVarInits, l_varDeclsvOutputTuple) = fun_545(Tpl.emptyTxt, i_outVars, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, l_outVarAssign1, l_outVarCopy1, l_outVarInits, l_varDeclsvOutputTuple, i_efn);
        str_20 = Tpl.textString(l_outVarAssign1);
        l_functionBodyExternalFunctionreturn = fun_547(Tpl.emptyTxt, str_20, l_outVarAssign1, l_retVar);
        l_fnBody = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("void /*"));
        l_fnBody = Tpl.writeText(l_fnBody, l_retType);
        l_fnBody = Tpl.writeTok(l_fnBody, Tpl.ST_STRING("*/ Functions::"));
        l_fnBody = Tpl.writeText(l_fnBody, l_fname);
        l_fnBody = Tpl.writeTok(l_fnBody, Tpl.ST_STRING("("));
        l_fnBody = Tpl.pushIter(l_fnBody, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_fnBody, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_548(l_fnBody, i_funArgs, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
        l_fnBody = Tpl.popIter(l_fnBody);
        l_fnBody = fun_550(l_fnBody, i_funArgs, i_outVars);
        l_fnBody = Tpl.writeTok(l_fnBody, Tpl.ST_STRING(" "));
        l_fnBody = fun_551(l_fnBody, l_retVar, l_retType);
        l_fnBody = Tpl.writeTok(l_fnBody, Tpl.ST_STRING_LIST({
                                              ")\n",
                                              "{\n",
                                              "  /* functionBodyExternalFunction: varDecls */\n",
                                              "  /*1*/\n"
                                          }, true));
        l_fnBody = Tpl.pushBlock(l_fnBody, Tpl.BT_INDENT(2));
        l_fnBody = Tpl.writeText(l_fnBody, l_varDeclsInit);
        l_fnBody = Tpl.softNewLine(l_fnBody);
        l_fnBody = Tpl.writeTok(l_fnBody, Tpl.ST_LINE("/*2*/\n"));
        l_fnBody = Tpl.writeText(l_fnBody, l_varDeclsExtFunCall);
        l_fnBody = Tpl.softNewLine(l_fnBody);
        l_fnBody = Tpl.writeTok(l_fnBody, Tpl.ST_LINE("/*3*/\n"));
        l_fnBody = Tpl.writeText(l_fnBody, l_varDeclsOutput);
        l_fnBody = Tpl.softNewLine(l_fnBody);
        l_fnBody = Tpl.writeTok(l_fnBody, Tpl.ST_LINE("/*4*/\n"));
        l_fnBody = Tpl.writeText(l_fnBody, l_varDeclsvOutputTuple);
        l_fnBody = Tpl.softNewLine(l_fnBody);
        l_fnBody = Tpl.writeTok(l_fnBody, Tpl.ST_LINE("/* functionBodyExternalFunction: preExp */\n"));
        l_fnBody = Tpl.writeText(l_fnBody, l_preExp);
        l_fnBody = Tpl.softNewLine(l_fnBody);
        l_fnBody = Tpl.writeTok(l_fnBody, Tpl.ST_LINE("/* functionBodyExternalFunction: outVarInits */\n"));
        l_fnBody = Tpl.writeText(l_fnBody, l_outVarInits);
        l_fnBody = Tpl.softNewLine(l_fnBody);
        l_fnBody = Tpl.writeTok(l_fnBody, Tpl.ST_LINE("/* functionBodyExternalFunction: callPart */\n"));
        l_fnBody = Tpl.writeText(l_fnBody, l_inputAssign);
        l_fnBody = Tpl.softNewLine(l_fnBody);
        l_fnBody = Tpl.writeText(l_fnBody, l_callPart);
        l_fnBody = Tpl.softNewLine(l_fnBody);
        l_fnBody = Tpl.writeText(l_fnBody, l_outputAssign);
        l_fnBody = Tpl.softNewLine(l_fnBody);
        l_fnBody = Tpl.writeTok(l_fnBody, Tpl.ST_LINE("/* functionBodyExternalFunction: return */\n"));
        l_fnBody = Tpl.writeText(l_fnBody, l_functionBodyExternalFunctionreturn);
        l_fnBody = Tpl.softNewLine(l_fnBody);
        l_fnBody = Tpl.popBlock(l_fnBody);
        l_fnBody = Tpl.writeTok(l_fnBody, Tpl.ST_STRING("}"));
        txt = fun_552(txt, i_dynamicLoad, i_language, i_extName);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_fnBody);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_557(txt, a_inFunc, i_outVars, l_retType, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, i_funArgs, l_fname);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end functionBodyExternalFunction;

protected function fun_559
  input Tpl.Text in_txt;
  input SimCodeFunction.Variable in_a_var;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_var)
    local
      Tpl.Text txt;

    case ( txt,
           SimCodeFunction.FUNCTION_PTR(name = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_fnptr"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_559;

protected function lm_560
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      SimCodeFunction.Variable i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = fun_559(txt, i_var);
        txt = Tpl.nextIter(txt);
        txt = lm_560(txt, rest);
      then txt;
  end match;
end lm_560;

protected function fun_561
  input Tpl.Text in_txt;
  input Tpl.Text in_a_funcPtrs;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_funcPtrs)
    local
      Tpl.Text txt;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}) )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("template <class modelica_fnptr>"));
      then txt;
  end match;
end fun_561;

public function functionTemplates
  input Tpl.Text txt;
  input list<SimCodeFunction.Variable> a_functionArguments;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_funcPtrs;
algorithm
  l_funcPtrs := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  l_funcPtrs := lm_560(l_funcPtrs, a_functionArguments);
  l_funcPtrs := Tpl.popIter(l_funcPtrs);
  out_txt := fun_561(txt, l_funcPtrs);
end functionTemplates;

protected function fun_563
  input Tpl.Text in_txt;
  input SimCodeFunction.Variable in_a_var;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_var)
    local
      Tpl.Text txt;
      String i_name_1;
      DAE.ComponentRef i_name;

    case ( txt,
           SimCodeFunction.VARIABLE(name = i_name) )
      equation
        txt = CodegenCppCommonOld.contextCref2(txt, i_name, SimCodeFunction.contextFunction);
      then txt;

    case ( txt,
           SimCodeFunction.FUNCTION_PTR(name = i_name_1) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeStr(txt, i_name_1);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_563;

public function funArgName
  input Tpl.Text txt;
  input SimCodeFunction.Variable a_var;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_auxFunction;
algorithm
  l_auxFunction := Tpl.emptyTxt;
  out_txt := fun_563(txt, a_var);
end funArgName;

public function writeOutVar
  input Tpl.Text in_txt;
  input SimCodeFunction.Variable in_a_var;
  input Integer in_a_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_var, in_a_index)
    local
      Tpl.Text txt;
      Integer a_index;
      SimCodeFunction.Variable i_var;
      DAE.Type i_ty;

    case ( txt,
           SimCodeFunction.VARIABLE(ty = (i_ty as DAE.T_COMPLEX(complexClassType = ClassInf.RECORD(path = _)))),
           a_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("write_modelica_record(outVar, "));
        txt = writeOutVarRecordMembers(txt, i_ty, a_index, "");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;

    case ( txt,
           (i_var as SimCodeFunction.VARIABLE(name = _)),
           a_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("write_"));
        txt = varType(txt, i_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(outVar, &out.targTest8"));
        txt = Tpl.writeStr(txt, intString(a_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end writeOutVar;

protected function fun_566
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;
  input Integer in_a_index;
  input DAE.Ident in_a_subvar_name;
  input String in_a_prefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty, in_a_index, in_a_subvar_name, in_a_prefix)
    local
      Tpl.Text txt;
      Integer a_index;
      DAE.Ident a_subvar_name;
      String a_prefix;
      DAE.Type i_ty;
      Tpl.Text l_newPrefix;

    case ( txt,
           (i_ty as DAE.T_COMPLEX(complexClassType = _)),
           a_index,
           a_subvar_name,
           a_prefix )
      equation
        l_newPrefix = Tpl.writeStr(Tpl.emptyTxt, a_prefix);
        l_newPrefix = Tpl.writeTok(l_newPrefix, Tpl.ST_STRING("."));
        l_newPrefix = Tpl.writeStr(l_newPrefix, a_subvar_name);
        txt = expTypeRW(txt, i_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = writeOutVarRecordMembers(txt, i_ty, a_index, Tpl.textString(l_newPrefix));
      then txt;

    case ( txt,
           i_ty,
           a_index,
           a_subvar_name,
           a_prefix )
      equation
        txt = expTypeRW(txt, i_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", &(out.targTest7"));
        txt = Tpl.writeStr(txt, intString(a_index));
        txt = Tpl.writeStr(txt, a_prefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("."));
        txt = Tpl.writeStr(txt, a_subvar_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;
  end match;
end fun_566;

protected function lm_567
  input Tpl.Text in_txt;
  input list<DAE.Var> in_items;
  input Integer in_a_index;
  input String in_a_prefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_index, in_a_prefix)
    local
      Tpl.Text txt;
      list<DAE.Var> rest;
      Integer a_index;
      String a_prefix;
      DAE.Ident i_subvar_name;
      DAE.Type i_ty;

    case ( txt,
           {},
           _,
           _ )
      then txt;

    case ( txt,
           DAE.TYPES_VAR(ty = i_ty, name = i_subvar_name) :: rest,
           a_index,
           a_prefix )
      equation
        txt = fun_566(txt, i_ty, a_index, i_subvar_name, a_prefix);
        txt = Tpl.nextIter(txt);
        txt = lm_567(txt, rest, a_index, a_prefix);
      then txt;

    case ( txt,
           _ :: rest,
           a_index,
           a_prefix )
      equation
        txt = lm_567(txt, rest, a_index, a_prefix);
      then txt;
  end match;
end lm_567;

protected function fun_568
  input Tpl.Text in_txt;
  input Tpl.Text in_a_args;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_args)
    local
      Tpl.Text txt;
      Tpl.Text i_args;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}) )
      then txt;

    case ( txt,
           i_args )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, i_args);
      then txt;
  end match;
end fun_568;

public function writeOutVarRecordMembers
  input Tpl.Text in_txt;
  input DAE.Type in_a_type;
  input Integer in_a_index;
  input String in_a_prefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_type, in_a_index, in_a_prefix)
    local
      Tpl.Text txt;
      Integer a_index;
      String a_prefix;
      list<DAE.Var> i_vl;
      ClassInf.State i_n;
      Tpl.Text l_args;
      Absyn.Path ret_1;
      Tpl.Text l_basename;

    case ( txt,
           DAE.T_COMPLEX(varLst = i_vl, complexClassType = i_n),
           a_index,
           a_prefix )
      equation
        ret_1 = ClassInf.getStateName(i_n);
        l_basename = CodegenUtil.underscorePath(Tpl.emptyTxt, ret_1);
        l_args = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_args = lm_567(l_args, i_vl, a_index, a_prefix);
        l_args = Tpl.popIter(l_args);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("&"));
        txt = Tpl.writeText(txt, l_basename);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("__desc"));
        txt = fun_568(txt, l_args);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", TYPE_DESC_NONE"));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end writeOutVarRecordMembers;

public function expTypeRW
  input Tpl.Text in_txt;
  input DAE.Type in_a_type;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_type)
    local
      Tpl.Text txt;
      DAE.Type i_ty;

    case ( txt,
           DAE.T_INTEGER(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("TYPE_DESC_INT"));
      then txt;

    case ( txt,
           DAE.T_REAL(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("TYPE_DESC_REAL"));
      then txt;

    case ( txt,
           DAE.T_STRING(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("TYPE_DESC_STRING"));
      then txt;

    case ( txt,
           DAE.T_BOOL(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("TYPE_DESC_BOOL"));
      then txt;

    case ( txt,
           DAE.T_ENUMERATION(index = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("TYPE_DESC_INT"));
      then txt;

    case ( txt,
           DAE.T_ARRAY(ty = i_ty) )
      equation
        txt = expTypeRW(txt, i_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_ARRAY"));
      then txt;

    case ( txt,
           DAE.T_COMPLEX(complexClassType = ClassInf.RECORD(path = _)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("TYPE_DESC_RECORD"));
      then txt;

    case ( txt,
           DAE.T_METATYPE(ty = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("TYPE_DESC_MMC"));
      then txt;

    case ( txt,
           DAE.T_METABOXED(ty = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("TYPE_DESC_MMC"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end expTypeRW;

protected function fun_571
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(char**)"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_571;

public function readInVar
  input Tpl.Text in_txt;
  input SimCodeFunction.Variable in_a_var;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_var, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      DAE.ComponentRef i_name;
      DAE.ComponentRef i_cr;
      DAE.Type i_ty;
      Boolean ret_1;
      Tpl.Text txt_0;

    case ( txt,
           SimCodeFunction.VARIABLE(name = i_cr, ty = (i_ty as DAE.T_COMPLEX(complexClassType = ClassInf.RECORD(path = _)))),
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if (read_modelica_record(&inArgs, "));
        (txt_0, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.contextCref(Tpl.emptyTxt, i_cr, SimCodeFunction.contextFunction, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = readInVarRecordMembers(txt, i_ty, Tpl.textString(txt_0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")) return 1;"));
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           SimCodeFunction.VARIABLE(name = i_name, ty = (i_ty as DAE.T_STRING(varLst = _))),
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if (read_"));
        txt = CodegenCppCommonOld.expTypeArrayIf(txt, i_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(&inArgs, "));
        ret_1 = Config.acceptMetaModelicaGrammar();
        txt = fun_571(txt, ret_1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" &"));
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.contextCref(txt, i_name, SimCodeFunction.contextFunction, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")) return 1;"));
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           SimCodeFunction.VARIABLE(ty = i_ty, name = i_name),
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if (read_"));
        txt = CodegenCppCommonOld.expTypeArrayIf(txt, i_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(&inArgs, &"));
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.contextCref(txt, i_name, SimCodeFunction.contextFunction, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")) return 1;"));
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end readInVar;

protected function fun_573
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;
  input DAE.Ident in_a_subvar_name;
  input String in_a_prefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty, in_a_subvar_name, in_a_prefix)
    local
      Tpl.Text txt;
      DAE.Ident a_subvar_name;
      String a_prefix;
      DAE.Type i_ty;
      Tpl.Text l_newPrefix;

    case ( txt,
           (i_ty as DAE.T_COMPLEX(complexClassType = _)),
           a_subvar_name,
           a_prefix )
      equation
        l_newPrefix = Tpl.writeStr(Tpl.emptyTxt, a_prefix);
        l_newPrefix = Tpl.writeTok(l_newPrefix, Tpl.ST_STRING("."));
        l_newPrefix = Tpl.writeStr(l_newPrefix, a_subvar_name);
        txt = readInVarRecordMembers(txt, i_ty, Tpl.textString(l_newPrefix));
      then txt;

    case ( txt,
           _,
           a_subvar_name,
           a_prefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("&("));
        txt = Tpl.writeStr(txt, a_prefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("."));
        txt = Tpl.writeStr(txt, a_subvar_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;
  end match;
end fun_573;

protected function lm_574
  input Tpl.Text in_txt;
  input list<DAE.Var> in_items;
  input String in_a_prefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_prefix)
    local
      Tpl.Text txt;
      list<DAE.Var> rest;
      String a_prefix;
      DAE.Ident i_subvar_name;
      DAE.Type i_ty;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           DAE.TYPES_VAR(ty = i_ty, name = i_subvar_name) :: rest,
           a_prefix )
      equation
        txt = fun_573(txt, i_ty, i_subvar_name, a_prefix);
        txt = Tpl.nextIter(txt);
        txt = lm_574(txt, rest, a_prefix);
      then txt;

    case ( txt,
           _ :: rest,
           a_prefix )
      equation
        txt = lm_574(txt, rest, a_prefix);
      then txt;
  end match;
end lm_574;

public function readInVarRecordMembers
  input Tpl.Text in_txt;
  input DAE.Type in_a_type;
  input String in_a_prefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_type, in_a_prefix)
    local
      Tpl.Text txt;
      String a_prefix;
      list<DAE.Var> i_vl;

    case ( txt,
           DAE.T_COMPLEX(varLst = i_vl),
           a_prefix )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_574(txt, i_vl, a_prefix);
        txt = Tpl.popIter(txt);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end readInVarRecordMembers;

public function outDecl
  input Tpl.Text txt;
  input String a_ty;
  input Tpl.Text a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
protected
  Tpl.Text l_newVar;
algorithm
  l_newVar := Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("out"));
  out_a_varDecls := Tpl.writeStr(a_varDecls, a_ty);
  out_a_varDecls := Tpl.writeTok(out_a_varDecls, Tpl.ST_STRING(" "));
  out_a_varDecls := Tpl.writeText(out_a_varDecls, l_newVar);
  out_a_varDecls := Tpl.writeTok(out_a_varDecls, Tpl.ST_STRING(";"));
  out_a_varDecls := Tpl.writeTok(out_a_varDecls, Tpl.ST_NEW_LINE());
  out_txt := Tpl.writeText(txt, l_newVar);
end outDecl;

protected function lm_577
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_preExp)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Variable i_bivar;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           a_preExp )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);

    case ( txt,
           i_bivar :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp )
      equation
        (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = extFunCallBiVar(txt, i_bivar, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = lm_577(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);
  end match;
end lm_577;

protected function fun_578
  input Tpl.Text in_txt;
  input String in_a_language;
  input Boolean in_a_useTuple;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_outputAssign;
  input Tpl.Text in_a_inputAssign;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Function in_a_fun;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_outputAssign;
  output Tpl.Text out_a_inputAssign;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_outputAssign, out_a_inputAssign, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_a_language, in_a_useTuple, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_outputAssign, in_a_inputAssign, in_a_varDecls, in_a_preExp, in_a_fun)
    local
      Tpl.Text txt;
      Boolean a_useTuple;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_outputAssign;
      Tpl.Text a_inputAssign;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Function a_fun;

    case ( txt,
           "C",
           a_useTuple,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_outputAssign,
           a_inputAssign,
           a_varDecls,
           a_preExp,
           a_fun )
      equation
        (txt, a_preExp, a_varDecls, a_inputAssign, a_outputAssign, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = extFunCallC(txt, a_fun, a_preExp, a_varDecls, a_inputAssign, a_outputAssign, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation, a_useTuple);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_outputAssign, a_inputAssign, a_varDecls, a_preExp);

    case ( txt,
           "FORTRAN 77",
           a_useTuple,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_outputAssign,
           a_inputAssign,
           a_varDecls,
           a_preExp,
           a_fun )
      equation
        (txt, a_preExp, a_varDecls, a_inputAssign, a_outputAssign, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = extFunCallF77(txt, a_fun, a_preExp, a_varDecls, a_inputAssign, a_outputAssign, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation, a_useTuple);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_outputAssign, a_inputAssign, a_varDecls, a_preExp);

    case ( txt,
           _,
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_outputAssign,
           a_inputAssign,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_outputAssign, a_inputAssign, a_varDecls, a_preExp);
  end match;
end fun_578;

public function extFunCall
  input Tpl.Text in_txt;
  input SimCodeFunction.Function in_a_fun;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_inputAssign;
  input Tpl.Text in_a_outputAssign;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;
  input Boolean in_a_useTuple;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_inputAssign;
  output Tpl.Text out_a_outputAssign;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_inputAssign, out_a_outputAssign, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_fun, in_a_preExp, in_a_varDecls, in_a_inputAssign, in_a_outputAssign, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation, in_a_useTuple)
    local
      Tpl.Text txt;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_inputAssign;
      Tpl.Text a_outputAssign;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      Boolean a_useTuple;
      SimCodeFunction.Function i_fun;
      String i_language;
      list<SimCodeFunction.Variable> i_biVars;
      Tpl.Text l_0__;

    case ( txt,
           (i_fun as SimCodeFunction.EXTERNAL_FUNCTION(biVars = i_biVars, language = i_language)),
           a_preExp,
           a_varDecls,
           a_inputAssign,
           a_outputAssign,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation,
           a_useTuple )
      equation
        l_0__ = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_0__, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = lm_577(l_0__, i_biVars, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp);
        l_0__ = Tpl.popIter(l_0__);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_outputAssign, a_inputAssign, a_varDecls, a_preExp) = fun_578(txt, i_language, a_useTuple, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_outputAssign, a_inputAssign, a_varDecls, a_preExp, i_fun);
      then (txt, a_preExp, a_varDecls, a_inputAssign, a_outputAssign, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           a_preExp,
           a_varDecls,
           a_inputAssign,
           a_outputAssign,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _,
           _ )
      then (txt, a_preExp, a_varDecls, a_inputAssign, a_outputAssign, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end extFunCall;

protected function lm_580
  input Tpl.Text in_txt;
  input list<SimCodeFunction.SimExtArg> in_items;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_varDecls) :=
  match(in_txt, in_items, in_a_varDecls)
    local
      Tpl.Text txt;
      list<SimCodeFunction.SimExtArg> rest;
      Tpl.Text a_varDecls;
      SimCodeFunction.SimExtArg i_arg;

    case ( txt,
           {},
           a_varDecls )
      then (txt, a_varDecls);

    case ( txt,
           i_arg :: rest,
           a_varDecls )
      equation
        (txt, a_varDecls) = extFunCallVardecl(txt, i_arg, a_varDecls);
        txt = Tpl.nextIter(txt);
        (txt, a_varDecls) = lm_580(txt, rest, a_varDecls);
      then (txt, a_varDecls);
  end match;
end lm_580;

protected function fun_581
  input Tpl.Text in_txt;
  input Boolean in_a_dynamicLoad;
  input String in_a_language;
  input String in_a_extName;
  input Tpl.Text in_a_fname;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_dynamicLoad, in_a_language, in_a_extName, in_a_fname)
    local
      Tpl.Text txt;
      String a_language;
      String a_extName;
      Tpl.Text a_fname;

    case ( txt,
           false,
           _,
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_language,
           a_extName,
           a_fname )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if ("));
        txt = Tpl.writeText(txt, a_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("==NULL) {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("MODELICA_TERMINATE(\"dynamic external function "));
        txt = extFunctionName(txt, a_extName, a_language);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" not set!\")\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("} else"));
      then txt;
  end match;
end fun_581;

protected function lm_582
  input Tpl.Text in_txt;
  input list<SimCodeFunction.SimExtArg> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_outputAssign;
  input Tpl.Text in_a_inputAssign;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_outputAssign;
  output Tpl.Text out_a_inputAssign;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_outputAssign, out_a_inputAssign, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_outputAssign, in_a_inputAssign, in_a_varDecls, in_a_preExp)
    local
      Tpl.Text txt;
      list<SimCodeFunction.SimExtArg> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_outputAssign;
      Tpl.Text a_inputAssign;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.SimExtArg i_arg;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_outputAssign,
           a_inputAssign,
           a_varDecls,
           a_preExp )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_outputAssign, a_inputAssign, a_varDecls, a_preExp);

    case ( txt,
           i_arg :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_outputAssign,
           a_inputAssign,
           a_varDecls,
           a_preExp )
      equation
        (txt, a_preExp, a_varDecls, a_inputAssign, a_outputAssign, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = extArg(txt, i_arg, a_preExp, a_varDecls, a_inputAssign, a_outputAssign, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_outputAssign, a_inputAssign, a_varDecls, a_preExp) = lm_582(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_outputAssign, a_inputAssign, a_varDecls, a_preExp);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_outputAssign, a_inputAssign, a_varDecls, a_preExp);
  end match;
end lm_582;

protected function fun_583
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;
  input Tpl.Text in_a_extName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty, in_a_extName)
    local
      Tpl.Text txt;
      Tpl.Text a_extName;

    case ( txt,
           DAE.T_STRING(varLst = _),
           a_extName )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_ModelicaFreeStringIfAllocated("));
        txt = Tpl.writeText(txt, a_extName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_583;

protected function fun_584
  input Tpl.Text in_txt;
  input SimCodeFunction.SimExtArg in_a_extReturn;
  input Tpl.Text in_a_outputAssign;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_outputAssign;
algorithm
  (out_txt, out_a_outputAssign) :=
  match(in_txt, in_a_extReturn, in_a_outputAssign)
    local
      Tpl.Text txt;
      Tpl.Text a_outputAssign;
      DAE.Type i_ty;
      DAE.ComponentRef i_c;
      Tpl.Text l_extName;

    case ( txt,
           SimCodeFunction.SIMEXTARG(cref = i_c, type_ = i_ty),
           a_outputAssign )
      equation
        l_extName = extVarName2(Tpl.emptyTxt, i_c);
        a_outputAssign = CodegenCppCommonOld.contextCref2(a_outputAssign, i_c, SimCodeFunction.contextFunction);
        a_outputAssign = Tpl.writeTok(a_outputAssign, Tpl.ST_STRING(" = "));
        a_outputAssign = Tpl.writeText(a_outputAssign, l_extName);
        a_outputAssign = Tpl.writeTok(a_outputAssign, Tpl.ST_STRING(";"));
        a_outputAssign = Tpl.writeTok(a_outputAssign, Tpl.ST_NEW_LINE());
        a_outputAssign = fun_583(a_outputAssign, i_ty, l_extName);
        txt = Tpl.writeText(txt, l_extName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
      then (txt, a_outputAssign);

    case ( txt,
           _,
           a_outputAssign )
      then (txt, a_outputAssign);
  end match;
end fun_584;

protected function fun_585
  input Tpl.Text in_txt;
  input SimCodeFunction.SimExtArg in_a_extReturn;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_varDecls) :=
  match(in_txt, in_a_extReturn, in_a_varDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_varDecls;
      SimCodeFunction.SimExtArg i_extReturn;

    case ( txt,
           (i_extReturn as SimCodeFunction.SIMEXTARG(cref = _)),
           a_varDecls )
      equation
        (txt, a_varDecls) = extFunCallVardecl(txt, i_extReturn, a_varDecls);
      then (txt, a_varDecls);

    case ( txt,
           _,
           a_varDecls )
      then (txt, a_varDecls);
  end match;
end fun_585;

protected function fun_586
  input Tpl.Text in_txt;
  input SimCodeFunction.Function in_a_fun;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_inputAssign;
  input Tpl.Text in_a_outputAssign;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_inputAssign;
  output Tpl.Text out_a_outputAssign;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_inputAssign, out_a_outputAssign, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_fun, in_a_preExp, in_a_varDecls, in_a_inputAssign, in_a_outputAssign, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_inputAssign;
      Tpl.Text a_outputAssign;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      SimCodeFunction.SimExtArg i_extReturn;
      String i_language;
      String i_extName;
      Boolean i_dynamicLoad;
      Absyn.Path i_name;
      list<SimCodeFunction.SimExtArg> i_extArgs;
      Tpl.Text l_returnAssign;
      Tpl.Text l_args;
      Tpl.Text l_dynamicCheck;
      Tpl.Text l_fname;
      list<SimCodeFunction.SimExtArg> ret_1;
      Tpl.Text l_varDecs;

    case ( txt,
           SimCodeFunction.EXTERNAL_FUNCTION(extArgs = i_extArgs, name = i_name, dynamicLoad = i_dynamicLoad, extName = i_extName, language = i_language, extReturn = i_extReturn),
           a_preExp,
           a_varDecls,
           a_inputAssign,
           a_outputAssign,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        ret_1 = List.union(i_extArgs, i_extArgs);
        l_varDecs = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_varDecs, a_varDecls) = lm_580(l_varDecs, ret_1, a_varDecls);
        l_varDecs = Tpl.popIter(l_varDecs);
        l_fname = CodegenUtil.underscorePath(Tpl.emptyTxt, i_name);
        l_dynamicCheck = fun_581(Tpl.emptyTxt, i_dynamicLoad, i_language, i_extName, l_fname);
        l_args = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_args, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_outputAssign, a_inputAssign, a_varDecls, a_preExp) = lm_582(l_args, i_extArgs, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_outputAssign, a_inputAssign, a_varDecls, a_preExp);
        l_args = Tpl.popIter(l_args);
        (l_returnAssign, a_outputAssign) = fun_584(Tpl.emptyTxt, i_extReturn, a_outputAssign);
        txt = Tpl.writeText(txt, l_varDecs);
        txt = Tpl.softNewLine(txt);
        (txt, a_varDecls) = fun_585(txt, i_extReturn, a_varDecls);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_dynamicCheck);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_returnAssign);
        txt = Tpl.writeStr(txt, i_extName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, l_args);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then (txt, a_preExp, a_varDecls, a_inputAssign, a_outputAssign, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           a_preExp,
           a_varDecls,
           a_inputAssign,
           a_outputAssign,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_preExp, a_varDecls, a_inputAssign, a_outputAssign, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end fun_586;

public function extFunCallC
  input Tpl.Text txt;
  input SimCodeFunction.Function a_fun;
  input Tpl.Text a_preExp;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_inputAssign;
  input Tpl.Text a_outputAssign;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;
  input Boolean a_useTuple;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_inputAssign;
  output Tpl.Text out_a_outputAssign;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_inputAssign, out_a_outputAssign, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) := fun_586(txt, a_fun, a_preExp, a_varDecls, a_inputAssign, a_outputAssign, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
end extFunCallC;

protected function fun_588
  input Tpl.Text in_txt;
  input Boolean in_a_useTuple;
  input String in_a_fnName;
  input Tpl.Text in_a_cr;
  input DAE.Type in_a_ty;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input DAE.ComponentRef in_a_c;
  input Integer in_a_oi;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_a_useTuple, in_a_fnName, in_a_cr, in_a_ty, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_c, in_a_oi)
    local
      Tpl.Text txt;
      String a_fnName;
      Tpl.Text a_cr;
      DAE.Type a_ty;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      DAE.ComponentRef a_c;
      Integer a_oi;
      Tpl.Text l_assginEnd;
      Integer ret_1;
      Tpl.Text l_assginBegin;

    case ( txt,
           true,
           _,
           a_cr,
           a_ty,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_c,
           a_oi )
      equation
        l_assginBegin = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("get<"));
        ret_1 = intAdd(-1, a_oi);
        l_assginBegin = Tpl.writeStr(l_assginBegin, intString(ret_1));
        l_assginBegin = Tpl.writeTok(l_assginBegin, Tpl.ST_STRING(">("));
        l_assginEnd = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING(")"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.contextCref(txt, a_c, SimCodeFunction.contextFunction, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" =("));
        txt = CodegenCppCommonOld.expTypeModelica(txt, a_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") "));
        txt = Tpl.writeText(txt, a_cr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.popBlock(txt);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           a_fnName,
           a_cr,
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _,
           _ )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeStr(txt, a_fnName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, a_cr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.popBlock(txt);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_588;

protected function fun_589
  input Tpl.Text in_txt;
  input Integer in_a_oi;
  input String in_a_fnName;
  input DAE.Type in_a_ty;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Boolean in_a_useTuple;
  input DAE.ComponentRef in_a_c;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_a_oi, in_a_fnName, in_a_ty, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_useTuple, in_a_c)
    local
      Tpl.Text txt;
      String a_fnName;
      DAE.Type a_ty;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Boolean a_useTuple;
      DAE.ComponentRef a_c;
      Integer i_oi;
      Tpl.Text l_cr;

    case ( txt,
           0,
           _,
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/*no ouput index */"));
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           i_oi,
           a_fnName,
           a_ty,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_useTuple,
           a_c )
      equation
        l_cr = CodegenCppCommonOld.contextCref2(Tpl.emptyTxt, a_c, SimCodeFunction.contextFunction);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_588(txt, a_useTuple, a_fnName, l_cr, a_ty, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_c, i_oi);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_589;

protected function fun_590
  input Tpl.Text in_txt;
  input Boolean in_a_useTuple;
  input String in_a_fnName;
  input Tpl.Text in_a_cr;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input DAE.ComponentRef in_a_c;
  input Integer in_a_oi;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_a_useTuple, in_a_fnName, in_a_cr, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_c, in_a_oi)
    local
      Tpl.Text txt;
      String a_fnName;
      Tpl.Text a_cr;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      DAE.ComponentRef a_c;
      Integer a_oi;
      Tpl.Text l_assginEnd;
      Integer ret_1;
      Tpl.Text l_assginBegin;

    case ( txt,
           true,
           _,
           a_cr,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_c,
           a_oi )
      equation
        l_assginBegin = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("get<"));
        ret_1 = intAdd(-1, a_oi);
        l_assginBegin = Tpl.writeStr(l_assginBegin, intString(ret_1));
        l_assginBegin = Tpl.writeTok(l_assginBegin, Tpl.ST_STRING(">("));
        l_assginEnd = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING(")"));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" /*array assign*/\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.contextCref(txt, a_c, SimCodeFunction.contextFunction, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".assign("));
        txt = Tpl.writeText(txt, a_cr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
        txt = Tpl.popBlock(txt);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           a_fnName,
           a_cr,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/*array assign*/\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeStr(txt, a_fnName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".assign("));
        txt = Tpl.writeText(txt, a_cr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
        txt = Tpl.popBlock(txt);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_590;

protected function fun_591
  input Tpl.Text in_txt;
  input Integer in_a_oi;
  input String in_a_fnName;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Boolean in_a_useTuple;
  input DAE.ComponentRef in_a_c;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_a_oi, in_a_fnName, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_useTuple, in_a_c)
    local
      Tpl.Text txt;
      String a_fnName;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Boolean a_useTuple;
      DAE.ComponentRef a_c;
      Integer i_oi;
      Tpl.Text l_cr;

    case ( txt,
           0,
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/*no ouput index */"));
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           i_oi,
           a_fnName,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_useTuple,
           a_c )
      equation
        l_cr = CodegenCppCommonOld.contextCref2(Tpl.emptyTxt, a_c, SimCodeFunction.contextFunction);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_590(txt, a_useTuple, a_fnName, l_cr, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_c, i_oi);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_591;

public function extFunCallVarcopy
  input Tpl.Text in_txt;
  input SimCodeFunction.SimExtArg in_a_arg;
  input String in_a_fnName;
  input Boolean in_a_useTuple;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_arg, in_a_fnName, in_a_useTuple, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      String a_fnName;
      Boolean a_useTuple;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      DAE.Type i_ty;
      DAE.ComponentRef i_c;
      Integer i_oi;

    case ( txt,
           SimCodeFunction.SIMEXTARG(outputIndex = i_oi, isArray = false, type_ = i_ty, cref = i_c),
           a_fnName,
           a_useTuple,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_589(txt, i_oi, a_fnName, i_ty, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_useTuple, i_c);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           SimCodeFunction.SIMEXTARG(outputIndex = i_oi, isArray = true, type_ = _, cref = i_c),
           a_fnName,
           a_useTuple,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_591(txt, i_oi, a_fnName, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_useTuple, i_c);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           _,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end extFunCallVarcopy;

protected function fun_593
  input Tpl.Text in_txt;
  input Integer in_a_oi;
  input String in_a_fnName;
  input DAE.ComponentRef in_a_c;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_oi, in_a_fnName, in_a_c)
    local
      Tpl.Text txt;
      String a_fnName;
      DAE.ComponentRef a_c;
      Integer i_oi;
      Tpl.Text l_assginEnd;
      Integer ret_2;
      Tpl.Text l_assginBegin;
      Tpl.Text l_cr;

    case ( txt,
           0,
           _,
           _ )
      then txt;

    case ( txt,
           i_oi,
           a_fnName,
           a_c )
      equation
        l_cr = extVarName2(Tpl.emptyTxt, a_c);
        l_assginBegin = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("get<"));
        ret_2 = intAdd(-1, i_oi);
        l_assginBegin = Tpl.writeStr(l_assginBegin, intString(ret_2));
        l_assginBegin = Tpl.writeTok(l_assginBegin, Tpl.ST_STRING(">("));
        l_assginEnd = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING(")"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeText(txt, l_assginBegin);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeStr(txt, a_fnName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".data"));
        txt = Tpl.writeText(txt, l_assginEnd);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, l_cr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" ;"));
        txt = Tpl.popBlock(txt);
      then txt;
  end match;
end fun_593;

public function extFunCallVarcopyTuple
  input Tpl.Text in_txt;
  input SimCodeFunction.SimExtArg in_a_arg;
  input String in_a_fnName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_arg, in_a_fnName)
    local
      Tpl.Text txt;
      String a_fnName;
      DAE.ComponentRef i_c;
      Integer i_oi;

    case ( txt,
           SimCodeFunction.SIMEXTARG(outputIndex = i_oi, isArray = false, type_ = _, cref = i_c),
           a_fnName )
      equation
        txt = fun_593(txt, i_oi, a_fnName, i_c);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end extFunCallVarcopyTuple;

protected function fun_595
  input Tpl.Text in_txt;
  input DAE.Type in_a_t;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_t)
    local
      Tpl.Text txt;

    case ( txt,
           DAE.T_STRING(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".c_str()"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_ext"));
      then txt;
  end match;
end fun_595;

protected function fun_596
  input Tpl.Text in_txt;
  input DAE.Type in_a_t;
  input Tpl.Text in_a_cr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_t, in_a_cr)
    local
      Tpl.Text txt;
      Tpl.Text a_cr;

    case ( txt,
           DAE.T_STRING(varLst = _),
           a_cr )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("MMC_STRINGDATA("));
        txt = Tpl.writeText(txt, a_cr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           _,
           a_cr )
      equation
        txt = Tpl.writeText(txt, a_cr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_ext"));
      then txt;
  end match;
end fun_596;

protected function fun_597
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input DAE.Type in_a_t;
  input Tpl.Text in_a_cr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_t, in_a_cr)
    local
      Tpl.Text txt;
      DAE.Type a_t;
      Tpl.Text a_cr;

    case ( txt,
           false,
           a_t,
           a_cr )
      equation
        txt = Tpl.writeText(txt, a_cr);
        txt = fun_595(txt, a_t);
      then txt;

    case ( txt,
           _,
           a_t,
           a_cr )
      equation
        txt = fun_596(txt, a_t, a_cr);
      then txt;
  end match;
end fun_597;

public function extArg
  input Tpl.Text in_txt;
  input SimCodeFunction.SimExtArg in_a_extArg;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_inputAssign;
  input Tpl.Text in_a_outputAssign;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_inputAssign;
  output Tpl.Text out_a_outputAssign;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_inputAssign, out_a_outputAssign, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_extArg, in_a_preExp, in_a_varDecls, in_a_inputAssign, in_a_outputAssign, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_inputAssign;
      Tpl.Text a_outputAssign;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      DAE.Type i_type__;
      DAE.Exp i_exp;
      DAE.Type i_t;
      DAE.ComponentRef i_c;
      SimCodeFunction.SimExtArg i_extArg;
      Tpl.Text l_dim;
      Tpl.Text l_name;
      Tpl.Text l_typeStr;
      Tpl.Text l_extName;
      Boolean ret_1;
      Tpl.Text l_cr;

    case ( txt,
           (i_extArg as SimCodeFunction.SIMEXTARG(isArray = true)),
           a_preExp,
           a_varDecls,
           a_inputAssign,
           a_outputAssign,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      equation
        (txt, a_preExp, a_varDecls, a_inputAssign, a_outputAssign) = extCArrayArg(txt, i_extArg, a_preExp, a_varDecls, a_inputAssign, a_outputAssign);
      then (txt, a_preExp, a_varDecls, a_inputAssign, a_outputAssign, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           SimCodeFunction.SIMEXTARG(cref = i_c, isInput = _, outputIndex = 0, type_ = i_t),
           a_preExp,
           a_varDecls,
           a_inputAssign,
           a_outputAssign,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      equation
        l_cr = CodegenCppCommonOld.contextCref2(Tpl.emptyTxt, i_c, SimCodeFunction.contextFunction);
        ret_1 = Config.acceptMetaModelicaGrammar();
        txt = fun_597(txt, ret_1, i_t, l_cr);
      then (txt, a_preExp, a_varDecls, a_inputAssign, a_outputAssign, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           SimCodeFunction.SIMEXTARG(cref = i_c, isInput = _, outputIndex = _, type_ = _),
           a_preExp,
           a_varDecls,
           a_inputAssign,
           a_outputAssign,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      equation
        l_extName = extVarName2(Tpl.emptyTxt, i_c);
        a_outputAssign = CodegenCppCommonOld.contextCref2(a_outputAssign, i_c, SimCodeFunction.contextFunction);
        a_outputAssign = Tpl.writeTok(a_outputAssign, Tpl.ST_STRING(" = "));
        a_outputAssign = Tpl.writeText(a_outputAssign, l_extName);
        a_outputAssign = Tpl.writeTok(a_outputAssign, Tpl.ST_STRING(";"));
        a_outputAssign = Tpl.writeTok(a_outputAssign, Tpl.ST_NEW_LINE());
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("&"));
        txt = Tpl.writeText(txt, l_extName);
      then (txt, a_preExp, a_varDecls, a_inputAssign, a_outputAssign, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           SimCodeFunction.SIMEXTARGEXP(exp = i_exp),
           a_preExp,
           a_varDecls,
           a_inputAssign,
           a_outputAssign,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeExternalCExp(txt, i_exp, SimCodeFunction.contextFunction, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_preExp, a_varDecls, a_inputAssign, a_outputAssign, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           SimCodeFunction.SIMEXTARGSIZE(cref = i_c, type_ = i_type__, exp = i_exp),
           a_preExp,
           a_varDecls,
           a_inputAssign,
           a_outputAssign,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_typeStr = CodegenCppCommonOld.expTypeShort(Tpl.emptyTxt, i_type__);
        l_name = CodegenCppCommonOld.contextCref2(Tpl.emptyTxt, i_c, SimCodeFunction.contextFunction);
        (l_dim, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.daeExp(Tpl.emptyTxt, i_exp, SimCodeFunction.contextFunction, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeText(txt, l_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".getDim("));
        txt = Tpl.writeText(txt, l_dim);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then (txt, a_preExp, a_varDecls, a_inputAssign, a_outputAssign, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           a_preExp,
           a_varDecls,
           a_inputAssign,
           a_outputAssign,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_preExp, a_varDecls, a_inputAssign, a_outputAssign, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end extArg;

protected function fun_599
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_elType;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_elType, in_a_ty)
    local
      Tpl.Text txt;
      Tpl.Text a_elType;
      DAE.Type a_ty;

    case ( txt,
           false,
           _,
           a_ty )
      equation
        txt = extType2(txt, a_ty, true, false);
      then txt;

    case ( txt,
           _,
           a_elType,
           _ )
      equation
        txt = Tpl.writeText(txt, a_elType);
      then txt;
  end match;
end fun_599;

protected function fun_600
  input Tpl.Text in_txt;
  input Boolean in_a_iI;
  input Tpl.Text in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_iI, in_a_name)
    local
      Tpl.Text txt;
      Tpl.Text a_name;

    case ( txt,
           false,
           a_name )
      equation
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".getData()"));
      then txt;

    case ( txt,
           _,
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("ConstArray("));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(").getData()"));
      then txt;
  end match;
end fun_600;

protected function fun_601
  input Tpl.Text in_txt;
  input String in_mArg;
  input Tpl.Text in_a_dimsStr;
  input Tpl.Text in_a_dimStr;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_extType;
  input DAE.Dimensions in_a_dims;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_varDecls) :=
  match(in_txt, in_mArg, in_a_dimsStr, in_a_dimStr, in_a_varDecls, in_a_extType, in_a_dims)
    local
      Tpl.Text txt;
      Tpl.Text a_dimsStr;
      Tpl.Text a_dimStr;
      Tpl.Text a_varDecls;
      Tpl.Text a_extType;
      DAE.Dimensions a_dims;
      Tpl.Text txt_2;
      Tpl.Text txt_0;
      Integer ret_0;

    case ( txt,
           "",
           _,
           _,
           a_varDecls,
           a_extType,
           a_dims )
      equation
        txt_0 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("DynArrayDim"));
        ret_0 = listLength(a_dims);
        txt_0 = Tpl.writeStr(txt_0, intString(ret_0));
        txt_0 = Tpl.writeTok(txt_0, Tpl.ST_STRING("<"));
        txt_0 = Tpl.writeText(txt_0, a_extType);
        txt_0 = Tpl.writeTok(txt_0, Tpl.ST_STRING(">"));
        (txt, a_varDecls) = CodegenCppCommonOld.tempDecl(txt, Tpl.textString(txt_0), a_varDecls);
      then (txt, a_varDecls);

    case ( txt,
           _,
           a_dimsStr,
           a_dimStr,
           a_varDecls,
           a_extType,
           _ )
      equation
        txt_2 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("StatArrayDim"));
        txt_2 = Tpl.writeText(txt_2, a_dimStr);
        txt_2 = Tpl.writeTok(txt_2, Tpl.ST_STRING("<"));
        txt_2 = Tpl.writeText(txt_2, a_extType);
        txt_2 = Tpl.writeTok(txt_2, Tpl.ST_STRING(", "));
        txt_2 = Tpl.writeText(txt_2, a_dimsStr);
        txt_2 = Tpl.writeTok(txt_2, Tpl.ST_STRING(">"));
        (txt, a_varDecls) = CodegenCppCommonOld.tempDecl(txt, Tpl.textString(txt_2), a_varDecls);
      then (txt, a_varDecls);
  end match;
end fun_601;

protected function fun_602
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_name;
  input Tpl.Text in_a_tmp;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_name, in_a_tmp)
    local
      Tpl.Text txt;
      Tpl.Text a_name;
      Tpl.Text a_tmp;

    case ( txt,
           false,
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_name,
           a_tmp )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("convertArrayLayout("));
        txt = Tpl.writeText(txt, a_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;
  end match;
end fun_602;

protected function fun_603
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_oi;
  input Tpl.Text in_a_outputAssign;
  input Tpl.Text in_a_inputAssign;
  input Tpl.Text in_a_dimStr;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_extType;
  input DAE.Dimensions in_a_dims;
  input Tpl.Text in_a_dimsStr;
  input Tpl.Text in_a_name;
  input Boolean in_a_iI;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_outputAssign;
  output Tpl.Text out_a_inputAssign;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_outputAssign, out_a_inputAssign, out_a_varDecls) :=
  match(in_txt, in_mArg, in_a_oi, in_a_outputAssign, in_a_inputAssign, in_a_dimStr, in_a_varDecls, in_a_extType, in_a_dims, in_a_dimsStr, in_a_name, in_a_iI)
    local
      Tpl.Text txt;
      Integer a_oi;
      Tpl.Text a_outputAssign;
      Tpl.Text a_inputAssign;
      Tpl.Text a_dimStr;
      Tpl.Text a_varDecls;
      Tpl.Text a_extType;
      DAE.Dimensions a_dims;
      Tpl.Text a_dimsStr;
      Tpl.Text a_name;
      Boolean a_iI;
      Boolean ret_2;
      String str_1;
      Tpl.Text l_tmp;

    case ( txt,
           false,
           _,
           a_outputAssign,
           a_inputAssign,
           _,
           a_varDecls,
           _,
           _,
           _,
           a_name,
           a_iI )
      equation
        txt = fun_600(txt, a_iI, a_name);
      then (txt, a_outputAssign, a_inputAssign, a_varDecls);

    case ( txt,
           _,
           a_oi,
           a_outputAssign,
           a_inputAssign,
           a_dimStr,
           a_varDecls,
           a_extType,
           a_dims,
           a_dimsStr,
           a_name,
           _ )
      equation
        str_1 = Tpl.textString(a_dimsStr);
        (l_tmp, a_varDecls) = fun_601(Tpl.emptyTxt, str_1, a_dimsStr, a_dimStr, a_varDecls, a_extType, a_dims);
        a_inputAssign = Tpl.writeTok(a_inputAssign, Tpl.ST_STRING("convertArrayLayout("));
        a_inputAssign = Tpl.writeText(a_inputAssign, a_name);
        a_inputAssign = Tpl.writeTok(a_inputAssign, Tpl.ST_STRING(", "));
        a_inputAssign = Tpl.writeText(a_inputAssign, l_tmp);
        a_inputAssign = Tpl.writeTok(a_inputAssign, Tpl.ST_STRING(");"));
        ret_2 = intGt(a_oi, 0);
        a_outputAssign = fun_602(a_outputAssign, ret_2, a_name, l_tmp);
        txt = Tpl.writeText(txt, l_tmp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".getData()"));
      then (txt, a_outputAssign, a_inputAssign, a_varDecls);
  end match;
end fun_603;

protected function fun_604
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_name;
  input Tpl.Text in_a_extName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_name, in_a_extName)
    local
      Tpl.Text txt;
      Tpl.Text a_name;
      Tpl.Text a_extName;

    case ( txt,
           false,
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_name,
           a_extName )
      equation
        txt = Tpl.writeText(txt, a_extName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".writeBack("));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;
  end match;
end fun_604;

protected function fun_605
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input DAE.ComponentRef in_a_c;
  input Integer in_a_oi;
  input Tpl.Text in_a_outputAssign;
  input Tpl.Text in_a_inputAssign;
  input Tpl.Text in_a_dimStr;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_extType;
  input Tpl.Text in_a_dimsStr;
  input Tpl.Text in_a_name;
  input Boolean in_a_iI;
  input Tpl.Text in_a_elType;
  input DAE.Dimensions in_a_dims;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_outputAssign;
  output Tpl.Text out_a_inputAssign;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_outputAssign, out_a_inputAssign, out_a_varDecls) :=
  match(in_txt, in_mArg, in_a_c, in_a_oi, in_a_outputAssign, in_a_inputAssign, in_a_dimStr, in_a_varDecls, in_a_extType, in_a_dimsStr, in_a_name, in_a_iI, in_a_elType, in_a_dims)
    local
      Tpl.Text txt;
      DAE.ComponentRef a_c;
      Integer a_oi;
      Tpl.Text a_outputAssign;
      Tpl.Text a_inputAssign;
      Tpl.Text a_dimStr;
      Tpl.Text a_varDecls;
      Tpl.Text a_extType;
      Tpl.Text a_dimsStr;
      Tpl.Text a_name;
      Boolean a_iI;
      Tpl.Text a_elType;
      DAE.Dimensions a_dims;
      Boolean ret_5;
      Tpl.Text l_extName;
      Boolean ret_3;
      Boolean ret_2;
      Boolean ret_1;
      Integer ret_0;

    case ( txt,
           false,
           _,
           a_oi,
           a_outputAssign,
           a_inputAssign,
           a_dimStr,
           a_varDecls,
           a_extType,
           a_dimsStr,
           a_name,
           a_iI,
           a_elType,
           a_dims )
      equation
        ret_0 = listLength(a_dims);
        ret_1 = intGt(ret_0, 1);
        ret_2 = stringEq(Tpl.textString(a_elType), "bool");
        ret_3 = boolOr(ret_1, ret_2);
        (txt, a_outputAssign, a_inputAssign, a_varDecls) = fun_603(txt, ret_3, a_oi, a_outputAssign, a_inputAssign, a_dimStr, a_varDecls, a_extType, a_dims, a_dimsStr, a_name, a_iI);
      then (txt, a_outputAssign, a_inputAssign, a_varDecls);

    case ( txt,
           _,
           a_c,
           a_oi,
           a_outputAssign,
           a_inputAssign,
           _,
           a_varDecls,
           _,
           _,
           a_name,
           _,
           _,
           _ )
      equation
        l_extName = extVarName2(Tpl.emptyTxt, a_c);
        a_inputAssign = Tpl.writeTok(a_inputAssign, Tpl.ST_STRING("CStrArray "));
        a_inputAssign = Tpl.writeText(a_inputAssign, l_extName);
        a_inputAssign = Tpl.writeTok(a_inputAssign, Tpl.ST_STRING("("));
        a_inputAssign = Tpl.writeText(a_inputAssign, a_name);
        a_inputAssign = Tpl.writeTok(a_inputAssign, Tpl.ST_STRING(");"));
        a_inputAssign = Tpl.writeTok(a_inputAssign, Tpl.ST_NEW_LINE());
        ret_5 = intGt(a_oi, 0);
        a_outputAssign = fun_604(a_outputAssign, ret_5, a_name, l_extName);
        txt = Tpl.writeText(txt, l_extName);
      then (txt, a_outputAssign, a_inputAssign, a_varDecls);
  end match;
end fun_605;

protected function fun_606
  input Tpl.Text in_txt;
  input DAE.Type in_a_type__;
  input DAE.ComponentRef in_a_c;
  input Integer in_a_oi;
  input Tpl.Text in_a_outputAssign;
  input Tpl.Text in_a_inputAssign;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_name;
  input Boolean in_a_iI;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_outputAssign;
  output Tpl.Text out_a_inputAssign;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_outputAssign, out_a_inputAssign, out_a_varDecls) :=
  match(in_txt, in_a_type__, in_a_c, in_a_oi, in_a_outputAssign, in_a_inputAssign, in_a_varDecls, in_a_name, in_a_iI)
    local
      Tpl.Text txt;
      DAE.ComponentRef a_c;
      Integer a_oi;
      Tpl.Text a_outputAssign;
      Tpl.Text a_inputAssign;
      Tpl.Text a_varDecls;
      Tpl.Text a_name;
      Boolean a_iI;
      DAE.Type i_ty;
      DAE.Dimensions i_dims;
      Boolean ret_6;
      Boolean ret_5;
      Tpl.Text l_extType;
      Tpl.Text l_elType;
      Tpl.Text l_dimsStr;
      Integer ret_1;
      Tpl.Text l_dimStr;

    case ( txt,
           DAE.T_ARRAY(dims = i_dims, ty = i_ty),
           a_c,
           a_oi,
           a_outputAssign,
           a_inputAssign,
           a_varDecls,
           a_name,
           a_iI )
      equation
        ret_1 = listLength(i_dims);
        l_dimStr = Tpl.writeStr(Tpl.emptyTxt, intString(ret_1));
        l_dimsStr = CodegenCppCommonOld.checkDimension(Tpl.emptyTxt, i_dims);
        l_elType = CodegenCppCommonOld.expTypeShort(Tpl.emptyTxt, i_ty);
        ret_5 = stringEq(Tpl.textString(l_elType), "string");
        l_extType = fun_599(Tpl.emptyTxt, ret_5, l_elType, i_ty);
        ret_6 = stringEq(Tpl.textString(l_elType), "string");
        (txt, a_outputAssign, a_inputAssign, a_varDecls) = fun_605(txt, ret_6, a_c, a_oi, a_outputAssign, a_inputAssign, l_dimStr, a_varDecls, l_extType, l_dimsStr, a_name, a_iI, l_elType, i_dims);
      then (txt, a_outputAssign, a_inputAssign, a_varDecls);

    case ( txt,
           _,
           _,
           _,
           a_outputAssign,
           a_inputAssign,
           a_varDecls,
           _,
           _ )
      then (txt, a_outputAssign, a_inputAssign, a_varDecls);
  end match;
end fun_606;

protected function fun_607
  input Tpl.Text in_txt;
  input SimCodeFunction.SimExtArg in_a_extArg;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_inputAssign;
  input Tpl.Text in_a_outputAssign;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_inputAssign;
  output Tpl.Text out_a_outputAssign;
algorithm
  (out_txt, out_a_varDecls, out_a_inputAssign, out_a_outputAssign) :=
  match(in_txt, in_a_extArg, in_a_varDecls, in_a_inputAssign, in_a_outputAssign)
    local
      Tpl.Text txt;
      Tpl.Text a_varDecls;
      Tpl.Text a_inputAssign;
      Tpl.Text a_outputAssign;
      Integer i_oi;
      Boolean i_iI;
      DAE.Type i_type__;
      DAE.ComponentRef i_c;
      Tpl.Text l_name;

    case ( txt,
           SimCodeFunction.SIMEXTARG(cref = i_c, isInput = i_iI, outputIndex = i_oi, isArray = true, type_ = i_type__),
           a_varDecls,
           a_inputAssign,
           a_outputAssign )
      equation
        l_name = CodegenCppCommonOld.contextCref2(Tpl.emptyTxt, i_c, SimCodeFunction.contextFunction);
        (txt, a_outputAssign, a_inputAssign, a_varDecls) = fun_606(txt, i_type__, i_c, i_oi, a_outputAssign, a_inputAssign, a_varDecls, l_name, i_iI);
      then (txt, a_varDecls, a_inputAssign, a_outputAssign);

    case ( txt,
           _,
           a_varDecls,
           a_inputAssign,
           a_outputAssign )
      then (txt, a_varDecls, a_inputAssign, a_outputAssign);
  end match;
end fun_607;

public function extCArrayArg
  input Tpl.Text txt;
  input SimCodeFunction.SimExtArg a_extArg;
  input Tpl.Text a_preExp;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_inputAssign;
  input Tpl.Text a_outputAssign;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_inputAssign;
  output Tpl.Text out_a_outputAssign;
algorithm
  (out_txt, out_a_varDecls, out_a_inputAssign, out_a_outputAssign) := fun_607(txt, a_extArg, a_varDecls, a_inputAssign, a_outputAssign);
  out_a_preExp := a_preExp;
end extCArrayArg;

protected function fun_609
  input Tpl.Text in_txt;
  input DAE.Type in_mArg;
  input DAE.Exp in_a_exp;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_mArg, in_a_exp, in_a_context, in_a_preExp, in_a_varDecls, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      DAE.Exp a_exp;
      SimCodeFunction.Context a_context;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      DAE.Type ret_1;
      Tpl.Text l_shortTypeStr;

    case ( txt,
           DAE.T_ARRAY(ty = _),
           a_exp,
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        ret_1 = Expression.typeof(a_exp);
        l_shortTypeStr = CodegenCppCommonOld.expTypeShort(Tpl.emptyTxt, ret_1);
        (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.daeExp(txt, a_exp, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".getData()"));
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           a_exp,
           a_context,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.daeExp(txt, a_exp, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end fun_609;

public function daeExternalCExp
  input Tpl.Text txt;
  input DAE.Exp a_exp;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_preExp;
  input Tpl.Text a_varDecls;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
protected
  DAE.Type ret_0;
algorithm
  ret_0 := Expression.typeof(a_exp);
  (out_txt, out_a_preExp, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) := fun_609(txt, ret_0, a_exp, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
end daeExternalCExp;

protected function fun_611
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;
  input DAE.ComponentRef in_a_c;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_varDecls) :=
  match(in_txt, in_a_ty, in_a_c, in_a_varDecls)
    local
      Tpl.Text txt;
      DAE.ComponentRef a_c;
      Tpl.Text a_varDecls;
      DAE.Type i_ty;

    case ( txt,
           DAE.T_STRING(varLst = _),
           _,
           a_varDecls )
      then (txt, a_varDecls);

    case ( txt,
           i_ty,
           a_c,
           a_varDecls )
      equation
        a_varDecls = extType2(a_varDecls, i_ty, true, false);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(" "));
        a_varDecls = extVarName2(a_varDecls, a_c);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(";"));
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_NEW_LINE());
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(" "));
        txt = extVarName2(txt, a_c);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = ("));
        txt = extType2(txt, i_ty, true, false);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
        txt = CodegenCppCommonOld.contextCref2(txt, a_c, SimCodeFunction.contextFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then (txt, a_varDecls);
  end match;
end fun_611;

protected function fun_612
  input Tpl.Text in_txt;
  input Integer in_a_oi;
  input DAE.ComponentRef in_a_c;
  input DAE.Type in_a_ty;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_varDecls) :=
  match(in_txt, in_a_oi, in_a_c, in_a_ty, in_a_varDecls)
    local
      Tpl.Text txt;
      DAE.ComponentRef a_c;
      DAE.Type a_ty;
      Tpl.Text a_varDecls;

    case ( txt,
           0,
           _,
           _,
           a_varDecls )
      then (txt, a_varDecls);

    case ( txt,
           _,
           a_c,
           a_ty,
           a_varDecls )
      equation
        a_varDecls = extType2(a_varDecls, a_ty, true, false);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(" "));
        a_varDecls = extVarName2(a_varDecls, a_c);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(";"));
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_NEW_LINE());
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(" "));
      then (txt, a_varDecls);
  end match;
end fun_612;

public function extFunCallVardecl
  input Tpl.Text in_txt;
  input SimCodeFunction.SimExtArg in_a_arg;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_varDecls) :=
  match(in_txt, in_a_arg, in_a_varDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_varDecls;
      Integer i_oi;
      DAE.ComponentRef i_c;
      DAE.Type i_ty;

    case ( txt,
           SimCodeFunction.SIMEXTARG(isInput = true, isArray = false, type_ = i_ty, cref = i_c),
           a_varDecls )
      equation
        (txt, a_varDecls) = fun_611(txt, i_ty, i_c, a_varDecls);
      then (txt, a_varDecls);

    case ( txt,
           SimCodeFunction.SIMEXTARG(outputIndex = i_oi, isArray = false, type_ = i_ty, cref = i_c),
           a_varDecls )
      equation
        (txt, a_varDecls) = fun_612(txt, i_oi, i_c, i_ty, a_varDecls);
      then (txt, a_varDecls);

    case ( txt,
           _,
           a_varDecls )
      then (txt, a_varDecls);
  end match;
end extFunCallVardecl;

protected function fun_614
  input Tpl.Text in_txt;
  input Option<DAE.Exp> in_a_value;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_a_value, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_preExp)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      DAE.Exp i_v;

    case ( txt,
           SOME(i_v),
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp )
      equation
        (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.daeExp(txt, i_v, SimCodeFunction.contextFunction, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);

    case ( txt,
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           a_preExp )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);
  end match;
end fun_614;

protected function fun_615
  input Tpl.Text in_txt;
  input Tpl.Text in_a_defaultValue;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_defaultValue)
    local
      Tpl.Text txt;
      Tpl.Text i_defaultValue;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}) )
      then txt;

    case ( txt,
           i_defaultValue )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("= "));
        txt = Tpl.writeText(txt, i_defaultValue);
        txt = Tpl.popBlock(txt);
      then txt;
  end match;
end fun_615;

protected function lm_616
  input Tpl.Text in_txt;
  input list<DAE.Dimension> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_preExp)
    local
      Tpl.Text txt;
      list<DAE.Dimension> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      DAE.Dimension i_dim;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           a_preExp )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);

    case ( txt,
           i_dim :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp )
      equation
        (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeDimension(txt, i_dim, SimCodeFunction.contextFunction, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = lm_616(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);
  end match;
end lm_616;

protected function fun_617
  input Tpl.Text in_txt;
  input Tpl.Text in_a_defaultValue;
  input Tpl.Text in_a_dims;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_defaultValue, in_a_dims)
    local
      Tpl.Text txt;
      Tpl.Text a_dims;
      Tpl.Text i_defaultValue;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           a_dims )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_dims);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           i_defaultValue,
           _ )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("= "));
        txt = Tpl.writeText(txt, i_defaultValue);
        txt = Tpl.popBlock(txt);
      then txt;
  end match;
end fun_617;

protected function fun_618
  input Tpl.Text in_txt;
  input list<DAE.Dimension> in_a_instDims;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_varName;
  input SimCodeFunction.Variable in_a_var;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_defaultValue;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_a_instDims, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_varName, in_a_var, in_a_preExp, in_a_defaultValue)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_varName;
      SimCodeFunction.Variable a_var;
      Tpl.Text a_preExp;
      Tpl.Text a_defaultValue;
      list<DAE.Dimension> i_instDims;
      Tpl.Text l_dims;
      Integer ret_2;
      Tpl.Text l_nDims;
      Tpl.Text l_initializer;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           a_varName,
           a_var,
           a_preExp,
           a_defaultValue )
      equation
        l_initializer = fun_615(Tpl.emptyTxt, a_defaultValue);
        a_preExp = varType(a_preExp, a_var);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(" "));
        a_preExp = Tpl.writeText(a_preExp, a_varName);
        a_preExp = Tpl.writeText(a_preExp, l_initializer);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(";"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);

    case ( txt,
           i_instDims,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_varName,
           a_var,
           a_preExp,
           a_defaultValue )
      equation
        ret_2 = listLength(i_instDims);
        l_nDims = Tpl.writeStr(Tpl.emptyTxt, intString(ret_2));
        l_dims = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_dims, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = lm_616(l_dims, i_instDims, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp);
        l_dims = Tpl.popIter(l_dims);
        l_initializer = fun_617(Tpl.emptyTxt, a_defaultValue, l_dims);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("DynArrayDim"));
        a_preExp = Tpl.writeText(a_preExp, l_nDims);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("<"));
        a_preExp = varType(a_preExp, a_var);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING("> "));
        a_preExp = Tpl.writeText(a_preExp, a_varName);
        a_preExp = Tpl.writeText(a_preExp, l_initializer);
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_STRING(";"));
        a_preExp = Tpl.writeTok(a_preExp, Tpl.ST_NEW_LINE());
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);
  end match;
end fun_618;

public function extFunCallBiVar
  input Tpl.Text in_txt;
  input SimCodeFunction.Variable in_a_var;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_var, in_a_preExp, in_a_varDecls, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      SimCodeFunction.Variable i_var;
      list<DAE.Dimension> i_instDims;
      Option<DAE.Exp> i_value;
      DAE.ComponentRef i_name;
      Tpl.Text l_defaultValue;
      Tpl.Text l_varName;

    case ( txt,
           (i_var as SimCodeFunction.VARIABLE(name = i_name, value = i_value, instDims = i_instDims)),
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_varName = CodegenCppCommonOld.contextCref2(Tpl.emptyTxt, i_name, SimCodeFunction.contextFunction);
        (l_defaultValue, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = fun_614(Tpl.emptyTxt, i_value, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = fun_618(txt, i_instDims, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, l_varName, i_var, a_preExp, l_defaultValue);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           a_preExp,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end extFunCallBiVar;

protected function lm_620
  input Tpl.Text in_txt;
  input list<SimCodeFunction.SimExtArg> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_outputAssign;
  input Tpl.Text in_a_inputAssign;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_outputAssign;
  output Tpl.Text out_a_inputAssign;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_outputAssign, out_a_inputAssign, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_outputAssign, in_a_inputAssign, in_a_varDecls, in_a_preExp)
    local
      Tpl.Text txt;
      list<SimCodeFunction.SimExtArg> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_outputAssign;
      Tpl.Text a_inputAssign;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.SimExtArg i_arg;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_outputAssign,
           a_inputAssign,
           a_varDecls,
           a_preExp )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_outputAssign, a_inputAssign, a_varDecls, a_preExp);

    case ( txt,
           i_arg :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_outputAssign,
           a_inputAssign,
           a_varDecls,
           a_preExp )
      equation
        (txt, a_preExp, a_varDecls, a_inputAssign, a_outputAssign, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = extArgF77(txt, i_arg, a_preExp, a_varDecls, a_inputAssign, a_outputAssign, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_outputAssign, a_inputAssign, a_varDecls, a_preExp) = lm_620(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_outputAssign, a_inputAssign, a_varDecls, a_preExp);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_outputAssign, a_inputAssign, a_varDecls, a_preExp);
  end match;
end lm_620;

protected function fun_621
  input Tpl.Text in_txt;
  input SimCodeFunction.SimExtArg in_a_extReturn;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_extReturn)
    local
      Tpl.Text txt;
      DAE.ComponentRef i_c;

    case ( txt,
           SimCodeFunction.SIMEXTARG(cref = i_c) )
      equation
        txt = CodegenCppCommonOld.contextCref2(txt, i_c, SimCodeFunction.contextFunction);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_621;

protected function fun_622
  input Tpl.Text in_txt;
  input Tpl.Text in_a_returnVar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_returnVar)
    local
      Tpl.Text txt;
      Tpl.Text i_returnVar;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}) )
      then txt;

    case ( txt,
           i_returnVar )
      equation
        txt = Tpl.writeText(txt, i_returnVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
      then txt;
  end match;
end fun_622;

protected function fun_623
  input Tpl.Text in_txt;
  input Boolean in_a_useTuple;
  input Tpl.Text in_a_returnVar;
  input Tpl.Text in_a_funName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_useTuple, in_a_returnVar, in_a_funName)
    local
      Tpl.Text txt;
      Tpl.Text a_returnVar;
      Tpl.Text a_funName;

    case ( txt,
           false,
           a_returnVar,
           a_funName )
      equation
        txt = Tpl.writeText(txt, a_funName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, a_returnVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_623;

public function extFunCallF77
  input Tpl.Text in_txt;
  input SimCodeFunction.Function in_a_fun;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_inputAssign;
  input Tpl.Text in_a_outputAssign;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;
  input Boolean in_a_useTuple;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_inputAssign;
  output Tpl.Text out_a_outputAssign;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_inputAssign, out_a_outputAssign, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_fun, in_a_preExp, in_a_varDecls, in_a_inputAssign, in_a_outputAssign, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation, in_a_useTuple)
    local
      Tpl.Text txt;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_inputAssign;
      Tpl.Text a_outputAssign;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      Boolean a_useTuple;
      String i_language;
      String i_extName;
      SimCodeFunction.SimExtArg i_extReturn;
      list<SimCodeFunction.SimExtArg> i_extArgs;
      Absyn.Path i_name;
      Tpl.Text l_returnAssign;
      Tpl.Text l_returnVar;
      Tpl.Text l_args;
      Tpl.Text l_funName;

    case ( txt,
           SimCodeFunction.EXTERNAL_FUNCTION(name = i_name, extArgs = i_extArgs, extReturn = i_extReturn, extName = i_extName, language = i_language),
           a_preExp,
           a_varDecls,
           a_inputAssign,
           a_outputAssign,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation,
           a_useTuple )
      equation
        l_funName = CodegenUtil.underscorePath(Tpl.emptyTxt, i_name);
        l_args = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_args, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_outputAssign, a_inputAssign, a_varDecls, a_preExp) = lm_620(l_args, i_extArgs, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_outputAssign, a_inputAssign, a_varDecls, a_preExp);
        l_args = Tpl.popIter(l_args);
        l_returnVar = fun_621(Tpl.emptyTxt, i_extReturn);
        l_returnAssign = fun_622(Tpl.emptyTxt, l_returnVar);
        txt = Tpl.writeText(txt, l_returnAssign);
        txt = extFunctionName(txt, i_extName, i_language);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, l_args);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(");\n"));
        txt = fun_623(txt, a_useTuple, l_returnVar, l_funName);
      then (txt, a_preExp, a_varDecls, a_inputAssign, a_outputAssign, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           a_preExp,
           a_varDecls,
           a_inputAssign,
           a_outputAssign,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _,
           _ )
      then (txt, a_preExp, a_varDecls, a_inputAssign, a_outputAssign, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end extFunCallF77;

protected function fun_625
  input Tpl.Text in_txt;
  input Boolean in_a_iI;
  input Tpl.Text in_a_varName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_iI, in_a_varName)
    local
      Tpl.Text txt;
      Tpl.Text a_varName;

    case ( txt,
           false,
           a_varName )
      equation
        txt = Tpl.writeText(txt, a_varName);
      then txt;

    case ( txt,
           _,
           a_varName )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("ConstArray("));
        txt = Tpl.writeText(txt, a_varName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;
  end match;
end fun_625;

protected function fun_626
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_varName;
  input Tpl.Text in_a_extName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_varName, in_a_extName)
    local
      Tpl.Text txt;
      Tpl.Text a_varName;
      Tpl.Text a_extName;

    case ( txt,
           false,
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_varName,
           a_extName )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("cast_array<int, bool>("));
        txt = Tpl.writeText(txt, a_extName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_varName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;
  end match;
end fun_626;

protected function fun_627
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_oi;
  input Tpl.Text in_a_outputAssign;
  input Tpl.Text in_a_inputAssign;
  input Tpl.Text in_a_extName;
  input Tpl.Text in_a_extType;
  input Tpl.Text in_a_nDims;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_varName;
  input Boolean in_a_iI;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_outputAssign;
  output Tpl.Text out_a_inputAssign;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_outputAssign, out_a_inputAssign, out_a_varDecls) :=
  match(in_txt, in_mArg, in_a_oi, in_a_outputAssign, in_a_inputAssign, in_a_extName, in_a_extType, in_a_nDims, in_a_varDecls, in_a_varName, in_a_iI)
    local
      Tpl.Text txt;
      Integer a_oi;
      Tpl.Text a_outputAssign;
      Tpl.Text a_inputAssign;
      Tpl.Text a_extName;
      Tpl.Text a_extType;
      Tpl.Text a_nDims;
      Tpl.Text a_varDecls;
      Tpl.Text a_varName;
      Boolean a_iI;
      Boolean ret_1;
      Tpl.Text l_extName;

    case ( txt,
           false,
           _,
           a_outputAssign,
           a_inputAssign,
           _,
           _,
           _,
           a_varDecls,
           a_varName,
           a_iI )
      equation
        l_extName = fun_625(Tpl.emptyTxt, a_iI, a_varName);
        txt = Tpl.writeText(txt, l_extName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".getData()"));
      then (txt, a_outputAssign, a_inputAssign, a_varDecls);

    case ( txt,
           _,
           a_oi,
           a_outputAssign,
           a_inputAssign,
           a_extName,
           a_extType,
           a_nDims,
           a_varDecls,
           a_varName,
           _ )
      equation
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING("DynArrayDim"));
        a_varDecls = Tpl.writeText(a_varDecls, a_nDims);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING("<"));
        a_varDecls = Tpl.writeText(a_varDecls, a_extType);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING("> "));
        a_varDecls = Tpl.writeText(a_varDecls, a_extName);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(";"));
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_NEW_LINE());
        a_inputAssign = Tpl.writeTok(a_inputAssign, Tpl.ST_STRING("cast_array<bool, int>("));
        a_inputAssign = Tpl.writeText(a_inputAssign, a_varName);
        a_inputAssign = Tpl.writeTok(a_inputAssign, Tpl.ST_STRING(", "));
        a_inputAssign = Tpl.writeText(a_inputAssign, a_extName);
        a_inputAssign = Tpl.writeTok(a_inputAssign, Tpl.ST_STRING(");"));
        a_inputAssign = Tpl.writeTok(a_inputAssign, Tpl.ST_NEW_LINE());
        ret_1 = intGt(a_oi, 0);
        a_outputAssign = fun_626(a_outputAssign, ret_1, a_varName, a_extName);
        txt = Tpl.writeText(txt, a_extName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".getData()"));
      then (txt, a_outputAssign, a_inputAssign, a_varDecls);
  end match;
end fun_627;

protected function fun_628
  input Tpl.Text in_txt;
  input DAE.Type in_a_type__;
  input Integer in_a_oi;
  input Tpl.Text in_a_outputAssign;
  input Tpl.Text in_a_inputAssign;
  input Tpl.Text in_a_varDecls;
  input Boolean in_a_iI;
  input Tpl.Text in_a_varName;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_outputAssign;
  output Tpl.Text out_a_inputAssign;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_outputAssign, out_a_inputAssign, out_a_varDecls) :=
  match(in_txt, in_a_type__, in_a_oi, in_a_outputAssign, in_a_inputAssign, in_a_varDecls, in_a_iI, in_a_varName)
    local
      Tpl.Text txt;
      Integer a_oi;
      Tpl.Text a_outputAssign;
      Tpl.Text a_inputAssign;
      Tpl.Text a_varDecls;
      Boolean a_iI;
      Tpl.Text a_varName;
      DAE.Dimensions i_dims;
      DAE.Type i_ty;
      Boolean ret_5;
      Integer ret_4;
      Tpl.Text l_nDims;
      Tpl.Text l_extName;
      Tpl.Text l_extType;
      Tpl.Text l_elType;

    case ( txt,
           DAE.T_ARRAY(ty = i_ty, dims = i_dims),
           a_oi,
           a_outputAssign,
           a_inputAssign,
           a_varDecls,
           a_iI,
           a_varName )
      equation
        l_elType = CodegenCppCommonOld.expTypeShort(Tpl.emptyTxt, i_ty);
        l_extType = extTypeF77(Tpl.emptyTxt, i_ty, false, false);
        l_extName = Tpl.writeText(Tpl.emptyTxt, a_varName);
        l_extName = Tpl.writeTok(l_extName, Tpl.ST_STRING("_ext"));
        ret_4 = listLength(i_dims);
        l_nDims = Tpl.writeStr(Tpl.emptyTxt, intString(ret_4));
        ret_5 = stringEq(Tpl.textString(l_elType), "bool");
        (txt, a_outputAssign, a_inputAssign, a_varDecls) = fun_627(txt, ret_5, a_oi, a_outputAssign, a_inputAssign, l_extName, l_extType, l_nDims, a_varDecls, a_varName, a_iI);
      then (txt, a_outputAssign, a_inputAssign, a_varDecls);

    case ( txt,
           _,
           _,
           a_outputAssign,
           a_inputAssign,
           a_varDecls,
           _,
           _ )
      then (txt, a_outputAssign, a_inputAssign, a_varDecls);
  end match;
end fun_628;

protected function fun_629
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_varName;
  input Tpl.Text in_a_inputAssign;
  input Tpl.Text in_a_extName;
  input Tpl.Text in_a_extType;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_inputAssign;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_inputAssign, out_a_varDecls) :=
  match(in_txt, in_mArg, in_a_varName, in_a_inputAssign, in_a_extName, in_a_extType, in_a_varDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_varName;
      Tpl.Text a_inputAssign;
      Tpl.Text a_extName;
      Tpl.Text a_extType;
      Tpl.Text a_varDecls;

    case ( txt,
           false,
           a_varName,
           a_inputAssign,
           a_extName,
           a_extType,
           a_varDecls )
      equation
        a_varDecls = Tpl.writeText(a_varDecls, a_extType);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(" "));
        a_varDecls = Tpl.writeText(a_varDecls, a_extName);
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_STRING(";"));
        a_varDecls = Tpl.writeTok(a_varDecls, Tpl.ST_NEW_LINE());
        a_inputAssign = Tpl.writeText(a_inputAssign, a_extName);
        a_inputAssign = Tpl.writeTok(a_inputAssign, Tpl.ST_STRING(" = "));
        a_inputAssign = Tpl.writeText(a_inputAssign, a_varName);
        a_inputAssign = Tpl.writeTok(a_inputAssign, Tpl.ST_STRING(";"));
        a_inputAssign = Tpl.writeTok(a_inputAssign, Tpl.ST_NEW_LINE());
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("&"));
        txt = Tpl.writeText(txt, a_extName);
      then (txt, a_inputAssign, a_varDecls);

    case ( txt,
           _,
           a_varName,
           a_inputAssign,
           _,
           _,
           a_varDecls )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("&"));
        txt = Tpl.writeText(txt, a_varName);
      then (txt, a_inputAssign, a_varDecls);
  end match;
end fun_629;

protected function fun_630
  input Tpl.Text in_txt;
  input DAE.Type in_a_t;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_t)
    local
      Tpl.Text txt;

    case ( txt,
           DAE.T_STRING(varLst = _) )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("&"));
      then txt;
  end match;
end fun_630;

public function extArgF77
  input Tpl.Text in_txt;
  input SimCodeFunction.SimExtArg in_a_extArg;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_inputAssign;
  input Tpl.Text in_a_outputAssign;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_inputAssign;
  output Tpl.Text out_a_outputAssign;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_inputAssign, out_a_outputAssign, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_extArg, in_a_preExp, in_a_varDecls, in_a_inputAssign, in_a_outputAssign, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text a_inputAssign;
      Tpl.Text a_outputAssign;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      DAE.Exp i_exp;
      DAE.Type i_t;
      Integer i_oi;
      Boolean i_iI;
      DAE.Type i_type__;
      DAE.ComponentRef i_c;
      Tpl.Text l_dim;
      Boolean ret_4;
      Tpl.Text l_extName;
      Tpl.Text l_extType;
      Tpl.Text l_varType;
      Tpl.Text l_varName;

    case ( txt,
           SimCodeFunction.SIMEXTARG(cref = i_c, isInput = i_iI, outputIndex = i_oi, isArray = true, type_ = i_type__),
           a_preExp,
           a_varDecls,
           a_inputAssign,
           a_outputAssign,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      equation
        l_varName = CodegenCppCommonOld.contextCref2(Tpl.emptyTxt, i_c, SimCodeFunction.contextFunction);
        (txt, a_outputAssign, a_inputAssign, a_varDecls) = fun_628(txt, i_type__, i_oi, a_outputAssign, a_inputAssign, a_varDecls, i_iI, l_varName);
      then (txt, a_preExp, a_varDecls, a_inputAssign, a_outputAssign, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           SimCodeFunction.SIMEXTARG(cref = i_c, type_ = i_t),
           a_preExp,
           a_varDecls,
           a_inputAssign,
           a_outputAssign,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      equation
        l_varName = CodegenCppCommonOld.contextCref2(Tpl.emptyTxt, i_c, SimCodeFunction.contextFunction);
        l_varType = CodegenCppCommonOld.expTypeShort(Tpl.emptyTxt, i_t);
        l_extType = extTypeF77(Tpl.emptyTxt, i_t, false, false);
        l_extName = Tpl.writeText(Tpl.emptyTxt, l_varName);
        l_extName = Tpl.writeTok(l_extName, Tpl.ST_STRING("_ext"));
        ret_4 = stringEq(Tpl.textString(l_varType), Tpl.textString(l_extType));
        (txt, a_inputAssign, a_varDecls) = fun_629(txt, ret_4, l_varName, a_inputAssign, l_extName, l_extType, a_varDecls);
      then (txt, a_preExp, a_varDecls, a_inputAssign, a_outputAssign, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           SimCodeFunction.SIMEXTARGEXP(type_ = i_t, exp = i_exp),
           a_preExp,
           a_varDecls,
           a_inputAssign,
           a_outputAssign,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_extType = extTypeF77(Tpl.emptyTxt, i_t, false, false);
        (l_extName, a_varDecls) = CodegenCppCommonOld.tempDecl(Tpl.emptyTxt, Tpl.textString(l_extType), a_varDecls);
        a_inputAssign = Tpl.writeText(a_inputAssign, l_extName);
        a_inputAssign = Tpl.writeTok(a_inputAssign, Tpl.ST_STRING(" = "));
        (a_inputAssign, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.daeExp(a_inputAssign, i_exp, SimCodeFunction.contextFunction, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        a_inputAssign = Tpl.writeTok(a_inputAssign, Tpl.ST_STRING(";"));
        a_inputAssign = Tpl.writeTok(a_inputAssign, Tpl.ST_NEW_LINE());
        txt = fun_630(txt, i_t);
        txt = Tpl.writeText(txt, l_extName);
      then (txt, a_preExp, a_varDecls, a_inputAssign, a_outputAssign, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           SimCodeFunction.SIMEXTARGSIZE(cref = i_c, exp = i_exp),
           a_preExp,
           a_varDecls,
           a_inputAssign,
           a_outputAssign,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_varName = CodegenCppCommonOld.contextCref2(Tpl.emptyTxt, i_c, SimCodeFunction.contextFunction);
        (l_extName, a_varDecls) = CodegenCppCommonOld.tempDecl(Tpl.emptyTxt, "int", a_varDecls);
        (l_dim, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.daeExp(Tpl.emptyTxt, i_exp, SimCodeFunction.contextFunction, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        a_inputAssign = Tpl.writeText(a_inputAssign, l_extName);
        a_inputAssign = Tpl.writeTok(a_inputAssign, Tpl.ST_STRING(" = "));
        a_inputAssign = Tpl.writeText(a_inputAssign, l_varName);
        a_inputAssign = Tpl.writeTok(a_inputAssign, Tpl.ST_STRING(".getDim("));
        a_inputAssign = Tpl.writeText(a_inputAssign, l_dim);
        a_inputAssign = Tpl.writeTok(a_inputAssign, Tpl.ST_STRING(");"));
        a_inputAssign = Tpl.writeTok(a_inputAssign, Tpl.ST_NEW_LINE());
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("&"));
        txt = Tpl.writeText(txt, l_extName);
      then (txt, a_preExp, a_varDecls, a_inputAssign, a_outputAssign, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           a_preExp,
           a_varDecls,
           a_inputAssign,
           a_outputAssign,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_preExp, a_varDecls, a_inputAssign, a_outputAssign, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end extArgF77;

protected function fun_632
  input Tpl.Text in_txt;
  input list<DAE.Dimension> in_a_instDims;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input DAE.ComponentRef in_a_var_name;
  input Tpl.Text in_a_varAssign;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varAssign;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varAssign) :=
  match(in_txt, in_a_instDims, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_var_name, in_a_varAssign)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      DAE.ComponentRef a_var_name;
      Tpl.Text a_varAssign;

    case ( txt,
           {},
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_var_name,
           a_varAssign )
      equation
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING("output  = "));
        (a_varAssign, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.contextCref(a_varAssign, a_var_name, SimCodeFunction.contextFunction, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING(";"));
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_NEW_LINE());
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varAssign);

    case ( txt,
           _,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_var_name,
           a_varAssign )
      equation
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING("output.assign("));
        (a_varAssign, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.contextCref(a_varAssign, a_var_name, SimCodeFunction.contextFunction, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING(");"));
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_NEW_LINE());
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varAssign);
  end match;
end fun_632;

protected function fun_633
  input Tpl.Text in_txt;
  input SimCodeFunction.Variable in_a_var;
  input Tpl.Text in_a_varAssign;
  input Tpl.Text in_a_varInits;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varAssign;
  output Tpl.Text out_a_varInits;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_varAssign, out_a_varInits, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_a_var, in_a_varAssign, in_a_varInits, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      Tpl.Text a_varAssign;
      Tpl.Text a_varInits;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      list<DAE.Dimension> i_instDims;
      DAE.ComponentRef i_var_name;
      Tpl.Text l_marker;

    case ( txt,
           SimCodeFunction.VARIABLE(name = i_var_name, instDims = i_instDims),
           a_varAssign,
           a_varInits,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (l_marker, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.contextCref(Tpl.emptyTxt, i_var_name, SimCodeFunction.contextFunction, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING("/* varOutput varInits("));
        a_varInits = Tpl.writeText(a_varInits, l_marker);
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING(") */ "));
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_NEW_LINE());
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varAssign) = fun_632(txt, i_instDims, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, i_var_name, a_varAssign);
      then (txt, a_varAssign, a_varInits, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           SimCodeFunction.FUNCTION_PTR(name = _),
           a_varAssign,
           a_varInits,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      equation
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING("ToDo: Function Ptr assign"));
      then (txt, a_varAssign, a_varInits, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           a_varAssign,
           a_varInits,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("something"));
      then (txt, a_varAssign, a_varInits, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_633;

protected function fun_634
  input Tpl.Text in_txt;
  input list<DAE.Dimension> in_a_instDims;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input DAE.ComponentRef in_a_var_name;
  input Tpl.Text in_a_varAssign;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varAssign;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varAssign) :=
  match(in_txt, in_a_instDims, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_var_name, in_a_varAssign)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      DAE.ComponentRef a_var_name;
      Tpl.Text a_varAssign;

    case ( txt,
           {},
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_var_name,
           a_varAssign )
      equation
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING("output  = "));
        (a_varAssign, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.contextCref(a_varAssign, a_var_name, SimCodeFunction.contextFunction, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING(";"));
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_NEW_LINE());
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varAssign);

    case ( txt,
           _,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_var_name,
           a_varAssign )
      equation
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING("output.assign("));
        (a_varAssign, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.contextCref(a_varAssign, a_var_name, SimCodeFunction.contextFunction, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING(");"));
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_NEW_LINE());
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varAssign);
  end match;
end fun_634;

protected function fun_635
  input Tpl.Text in_txt;
  input SimCodeFunction.Variable in_a_var;
  input Tpl.Text in_a_varAssign;
  input Tpl.Text in_a_varInits;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varAssign;
  output Tpl.Text out_a_varInits;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_varAssign, out_a_varInits, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_a_var, in_a_varAssign, in_a_varInits, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      Tpl.Text a_varAssign;
      Tpl.Text a_varInits;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      list<DAE.Dimension> i_instDims;
      DAE.ComponentRef i_var_name;
      Tpl.Text l_marker;

    case ( txt,
           SimCodeFunction.VARIABLE(name = i_var_name, instDims = i_instDims),
           a_varAssign,
           a_varInits,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (l_marker, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.contextCref(Tpl.emptyTxt, i_var_name, SimCodeFunction.contextFunction, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING("/* varOutput varInits("));
        a_varInits = Tpl.writeText(a_varInits, l_marker);
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING(") */ "));
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_NEW_LINE());
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varAssign) = fun_634(txt, i_instDims, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, i_var_name, a_varAssign);
      then (txt, a_varAssign, a_varInits, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           SimCodeFunction.FUNCTION_PTR(name = _),
           a_varAssign,
           a_varInits,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      equation
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING("ToDo: Function Ptr assign"));
      then (txt, a_varAssign, a_varInits, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           a_varAssign,
           a_varInits,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("something"));
      then (txt, a_varAssign, a_varInits, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_635;

protected function fun_636
  input Tpl.Text in_txt;
  input SimCodeFunction.Function in_a_fn;
  input SimCodeFunction.Variable in_a_var;
  input Tpl.Text in_a_varInits;
  input Tpl.Text in_a_varAssign;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varInits;
  output Tpl.Text out_a_varAssign;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_varInits, out_a_varAssign, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_fn, in_a_var, in_a_varInits, in_a_varAssign, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      SimCodeFunction.Variable a_var;
      Tpl.Text a_varInits;
      Tpl.Text a_varAssign;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      Absyn.Path i_name;
      Tpl.Text l_fname;

    case ( txt,
           SimCodeFunction.FUNCTION(name = i_name),
           a_var,
           a_varInits,
           a_varAssign,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_fname = CodegenUtil.underscorePath(Tpl.emptyTxt, i_name);
        (txt, a_varAssign, a_varInits, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_633(txt, a_var, a_varAssign, a_varInits, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_varInits, a_varAssign, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           SimCodeFunction.EXTERNAL_FUNCTION(name = i_name),
           a_var,
           a_varInits,
           a_varAssign,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_fname = CodegenUtil.underscorePath(Tpl.emptyTxt, i_name);
        (txt, a_varAssign, a_varInits, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_635(txt, a_var, a_varAssign, a_varInits, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_varInits, a_varAssign, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           a_varInits,
           a_varAssign,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_varInits, a_varAssign, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end fun_636;

public function varOutput
  input Tpl.Text txt;
  input SimCodeFunction.Function a_fn;
  input SimCodeFunction.Variable a_var;
  input Integer a_ix;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_varInits;
  input Tpl.Text a_varCopy;
  input Tpl.Text a_varAssign;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varInits;
  output Tpl.Text out_a_varCopy;
  output Tpl.Text out_a_varAssign;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_varInits, out_a_varAssign, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) := fun_636(txt, a_fn, a_var, a_varInits, a_varAssign, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
  out_a_varDecls := a_varDecls;
  out_a_varCopy := a_varCopy;
end varOutput;

protected function lm_638
  input Tpl.Text in_txt;
  input list<DAE.Dimension> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_varInits;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varInits;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_varInits) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_varInits)
    local
      Tpl.Text txt;
      list<DAE.Dimension> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_varInits;
      DAE.Dimension i_dim;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           a_varInits )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_varInits);

    case ( txt,
           i_dim :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_varInits )
      equation
        (txt, a_varInits, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeDimension(txt, i_dim, SimCodeFunction.contextFunction, a_varInits, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_varInits) = lm_638(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_varInits);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_varInits);
  end match;
end lm_638;

protected function fun_639
  input Tpl.Text in_txt;
  input list<DAE.Dimension> in_a_instDims;
  input Tpl.Text in_a_instDimsInit;
  input Tpl.Text in_a_varInits;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input DAE.ComponentRef in_a_var_name;
  input Tpl.Text in_a_fname;
  input Tpl.Text in_a_assginBegin;
  input Tpl.Text in_a_varAssign;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varInits;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varAssign;
algorithm
  (out_txt, out_a_varInits, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varAssign) :=
  match(in_txt, in_a_instDims, in_a_instDimsInit, in_a_varInits, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_var_name, in_a_fname, in_a_assginBegin, in_a_varAssign)
    local
      Tpl.Text txt;
      Tpl.Text a_instDimsInit;
      Tpl.Text a_varInits;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      DAE.ComponentRef a_var_name;
      Tpl.Text a_fname;
      Tpl.Text a_assginBegin;
      Tpl.Text a_varAssign;

    case ( txt,
           {},
           _,
           a_varInits,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_var_name,
           a_fname,
           a_assginBegin,
           a_varAssign )
      equation
        a_varAssign = Tpl.pushBlock(a_varAssign, Tpl.BT_INDENT(1));
        a_varAssign = Tpl.writeText(a_varAssign, a_assginBegin);
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING("(/*_"));
        a_varAssign = Tpl.writeText(a_varAssign, a_fname);
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING("*/output.data) = "));
        (a_varAssign, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.contextCref(a_varAssign, a_var_name, SimCodeFunction.contextFunction, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING("/*TestVarAssign5*/;"));
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_NEW_LINE());
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING(" "));
        a_varAssign = Tpl.popBlock(a_varAssign);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/*testcase1*/"));
      then (txt, a_varInits, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varAssign);

    case ( txt,
           _,
           a_instDimsInit,
           a_varInits,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_var_name,
           a_fname,
           a_assginBegin,
           a_varAssign )
      equation
        a_varInits = Tpl.writeText(a_varInits, a_assginBegin);
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING("(/*_"));
        a_varInits = Tpl.writeText(a_varInits, a_fname);
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING("*/output.data).setDims("));
        a_varInits = Tpl.writeText(a_varInits, a_instDimsInit);
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_LINE(");//todo setDims not for stat arrays\n"));
        a_varInits = Tpl.pushBlock(a_varInits, Tpl.BT_INDENT(4));
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_NEW_LINE());
        a_varInits = Tpl.popBlock(a_varInits);
        a_varAssign = Tpl.writeText(a_varAssign, a_assginBegin);
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING("(/*_"));
        a_varAssign = Tpl.writeText(a_varAssign, a_fname);
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING("*/output.data)="));
        (a_varAssign, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.contextCref(a_varAssign, a_var_name, SimCodeFunction.contextFunction, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING(";"));
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_NEW_LINE());
      then (txt, a_varInits, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varAssign);
  end match;
end fun_639;

protected function fun_640
  input Tpl.Text in_txt;
  input SimCodeFunction.Variable in_a_var;
  input Tpl.Text in_a_fname;
  input Integer in_a_ix;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_varAssign;
  input Tpl.Text in_a_varInits;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varAssign;
  output Tpl.Text out_a_varInits;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_varDecls, out_a_varAssign, out_a_varInits, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_a_var, in_a_fname, in_a_ix, in_a_varDecls, in_a_varAssign, in_a_varInits, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      Tpl.Text a_fname;
      Integer a_ix;
      Tpl.Text a_varDecls;
      Tpl.Text a_varAssign;
      Tpl.Text a_varInits;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      String i_var_name_1;
      list<DAE.Dimension> i_instDims;
      DAE.ComponentRef i_var_name;
      Tpl.Text l_assginBegin;
      Tpl.Text l_instDimsInit;
      Tpl.Text l_marker;

    case ( txt,
           SimCodeFunction.VARIABLE(name = i_var_name, instDims = i_instDims),
           a_fname,
           a_ix,
           a_varDecls,
           a_varAssign,
           a_varInits,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (l_marker, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.contextCref(Tpl.emptyTxt, i_var_name, SimCodeFunction.contextFunction, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING("/* varOutputTuple varInits("));
        a_varInits = Tpl.writeText(a_varInits, l_marker);
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING(") */ "));
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_NEW_LINE());
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING("// varOutput varAssign("));
        a_varAssign = Tpl.writeText(a_varAssign, l_marker);
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING(") "));
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_NEW_LINE());
        l_instDimsInit = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_instDimsInit, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_varInits) = lm_638(l_instDimsInit, i_instDims, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_varInits);
        l_instDimsInit = Tpl.popIter(l_instDimsInit);
        l_assginBegin = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("get<"));
        l_assginBegin = Tpl.writeStr(l_assginBegin, intString(a_ix));
        l_assginBegin = Tpl.writeTok(l_assginBegin, Tpl.ST_STRING(">"));
        (txt, a_varInits, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varAssign) = fun_639(txt, i_instDims, l_instDimsInit, a_varInits, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, i_var_name, a_fname, l_assginBegin, a_varAssign);
      then (txt, a_varDecls, a_varAssign, a_varInits, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           SimCodeFunction.FUNCTION_PTR(name = i_var_name_1),
           a_fname,
           _,
           a_varDecls,
           a_varAssign,
           a_varInits,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      equation
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING("/*_"));
        a_varAssign = Tpl.writeText(a_varAssign, a_fname);
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING("*/ output = (modelica_fnptr) _"));
        a_varAssign = Tpl.writeStr(a_varAssign, i_var_name_1);
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING(";"));
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_NEW_LINE());
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/*testcase2*/"));
      then (txt, a_varDecls, a_varAssign, a_varInits, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           _,
           _,
           a_varDecls,
           a_varAssign,
           a_varInits,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      equation
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING("/*iregendwas*/"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/*testcase3*/"));
      then (txt, a_varDecls, a_varAssign, a_varInits, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_640;

protected function lm_641
  input Tpl.Text in_txt;
  input list<DAE.Dimension> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_varInits;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varInits;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_varInits) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_varInits)
    local
      Tpl.Text txt;
      list<DAE.Dimension> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_varInits;
      DAE.Dimension i_dim;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           a_varInits )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_varInits);

    case ( txt,
           i_dim :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_varInits )
      equation
        (txt, a_varInits, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeDimension(txt, i_dim, SimCodeFunction.contextFunction, a_varInits, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_varInits) = lm_641(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_varInits);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_varInits);
  end match;
end lm_641;

protected function fun_642
  input Tpl.Text in_txt;
  input list<DAE.Dimension> in_a_instDims;
  input Tpl.Text in_a_instDimsInit;
  input Tpl.Text in_a_varInits;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input DAE.ComponentRef in_a_var_name;
  input Tpl.Text in_a_fname;
  input Tpl.Text in_a_assginBegin;
  input Tpl.Text in_a_varAssign;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varInits;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varAssign;
algorithm
  (out_txt, out_a_varInits, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varAssign) :=
  match(in_txt, in_a_instDims, in_a_instDimsInit, in_a_varInits, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_var_name, in_a_fname, in_a_assginBegin, in_a_varAssign)
    local
      Tpl.Text txt;
      Tpl.Text a_instDimsInit;
      Tpl.Text a_varInits;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      DAE.ComponentRef a_var_name;
      Tpl.Text a_fname;
      Tpl.Text a_assginBegin;
      Tpl.Text a_varAssign;

    case ( txt,
           {},
           _,
           a_varInits,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_var_name,
           a_fname,
           a_assginBegin,
           a_varAssign )
      equation
        a_varAssign = Tpl.pushBlock(a_varAssign, Tpl.BT_INDENT(1));
        a_varAssign = Tpl.writeText(a_varAssign, a_assginBegin);
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING("(/*_"));
        a_varAssign = Tpl.writeText(a_varAssign, a_fname);
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING("*/output.data) = "));
        (a_varAssign, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.contextCref(a_varAssign, a_var_name, SimCodeFunction.contextFunction, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING("/*TestVarAssign5*/;"));
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_NEW_LINE());
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING(" "));
        a_varAssign = Tpl.popBlock(a_varAssign);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/*testcase1*/"));
      then (txt, a_varInits, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varAssign);

    case ( txt,
           _,
           a_instDimsInit,
           a_varInits,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_var_name,
           a_fname,
           a_assginBegin,
           a_varAssign )
      equation
        a_varInits = Tpl.writeText(a_varInits, a_assginBegin);
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING("(/*_"));
        a_varInits = Tpl.writeText(a_varInits, a_fname);
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING("*/output.data).setDims("));
        a_varInits = Tpl.writeText(a_varInits, a_instDimsInit);
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_LINE(");//todo setDims not for stat arrays\n"));
        a_varInits = Tpl.pushBlock(a_varInits, Tpl.BT_INDENT(4));
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_NEW_LINE());
        a_varInits = Tpl.popBlock(a_varInits);
        a_varAssign = Tpl.writeText(a_varAssign, a_assginBegin);
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING("(/*_"));
        a_varAssign = Tpl.writeText(a_varAssign, a_fname);
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING("*/output.data)="));
        (a_varAssign, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.contextCref(a_varAssign, a_var_name, SimCodeFunction.contextFunction, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING(";"));
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_NEW_LINE());
      then (txt, a_varInits, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varAssign);
  end match;
end fun_642;

protected function fun_643
  input Tpl.Text in_txt;
  input SimCodeFunction.Variable in_a_var;
  input Tpl.Text in_a_fname;
  input Integer in_a_ix;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_varAssign;
  input Tpl.Text in_a_varInits;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varAssign;
  output Tpl.Text out_a_varInits;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_varDecls, out_a_varAssign, out_a_varInits, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_a_var, in_a_fname, in_a_ix, in_a_varDecls, in_a_varAssign, in_a_varInits, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      Tpl.Text a_fname;
      Integer a_ix;
      Tpl.Text a_varDecls;
      Tpl.Text a_varAssign;
      Tpl.Text a_varInits;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      String i_var_name_1;
      list<DAE.Dimension> i_instDims;
      DAE.ComponentRef i_var_name;
      Tpl.Text l_assginBegin;
      Tpl.Text l_instDimsInit;
      Tpl.Text l_marker;

    case ( txt,
           SimCodeFunction.VARIABLE(name = i_var_name, instDims = i_instDims),
           a_fname,
           a_ix,
           a_varDecls,
           a_varAssign,
           a_varInits,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (l_marker, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.contextCref(Tpl.emptyTxt, i_var_name, SimCodeFunction.contextFunction, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING("/* varOutputTuple varInits("));
        a_varInits = Tpl.writeText(a_varInits, l_marker);
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING(") */ "));
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_NEW_LINE());
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING("// varOutput varAssign("));
        a_varAssign = Tpl.writeText(a_varAssign, l_marker);
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING(") "));
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_NEW_LINE());
        l_instDimsInit = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_instDimsInit, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_varInits) = lm_641(l_instDimsInit, i_instDims, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_varInits);
        l_instDimsInit = Tpl.popIter(l_instDimsInit);
        l_assginBegin = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("get<"));
        l_assginBegin = Tpl.writeStr(l_assginBegin, intString(a_ix));
        l_assginBegin = Tpl.writeTok(l_assginBegin, Tpl.ST_STRING(">"));
        (txt, a_varInits, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varAssign) = fun_642(txt, i_instDims, l_instDimsInit, a_varInits, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, i_var_name, a_fname, l_assginBegin, a_varAssign);
      then (txt, a_varDecls, a_varAssign, a_varInits, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           SimCodeFunction.FUNCTION_PTR(name = i_var_name_1),
           a_fname,
           _,
           a_varDecls,
           a_varAssign,
           a_varInits,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      equation
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING("/*_"));
        a_varAssign = Tpl.writeText(a_varAssign, a_fname);
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING("*/ output = (modelica_fnptr) _"));
        a_varAssign = Tpl.writeStr(a_varAssign, i_var_name_1);
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING(";"));
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_NEW_LINE());
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/*testcase2*/"));
      then (txt, a_varDecls, a_varAssign, a_varInits, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           _,
           _,
           a_varDecls,
           a_varAssign,
           a_varInits,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      equation
        a_varAssign = Tpl.writeTok(a_varAssign, Tpl.ST_STRING("/*iregendwas*/"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/*testcase3*/"));
      then (txt, a_varDecls, a_varAssign, a_varInits, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_643;

protected function fun_644
  input Tpl.Text in_txt;
  input SimCodeFunction.Function in_a_fn;
  input SimCodeFunction.Variable in_a_var;
  input Integer in_a_ix;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_varInits;
  input Tpl.Text in_a_varAssign;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varInits;
  output Tpl.Text out_a_varAssign;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_varDecls, out_a_varInits, out_a_varAssign, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_fn, in_a_var, in_a_ix, in_a_varDecls, in_a_varInits, in_a_varAssign, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      SimCodeFunction.Variable a_var;
      Integer a_ix;
      Tpl.Text a_varDecls;
      Tpl.Text a_varInits;
      Tpl.Text a_varAssign;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      Absyn.Path i_name;
      Tpl.Text l_fname;

    case ( txt,
           SimCodeFunction.FUNCTION(name = i_name),
           a_var,
           a_ix,
           a_varDecls,
           a_varInits,
           a_varAssign,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_fname = CodegenUtil.underscorePath(Tpl.emptyTxt, i_name);
        (txt, a_varDecls, a_varAssign, a_varInits, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_640(txt, a_var, l_fname, a_ix, a_varDecls, a_varAssign, a_varInits, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_varDecls, a_varInits, a_varAssign, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           SimCodeFunction.EXTERNAL_FUNCTION(name = i_name),
           a_var,
           a_ix,
           a_varDecls,
           a_varInits,
           a_varAssign,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_fname = CodegenUtil.underscorePath(Tpl.emptyTxt, i_name);
        (txt, a_varDecls, a_varAssign, a_varInits, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_643(txt, a_var, l_fname, a_ix, a_varDecls, a_varAssign, a_varInits, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_varDecls, a_varInits, a_varAssign, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           _,
           a_varDecls,
           a_varInits,
           a_varAssign,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_varDecls, a_varInits, a_varAssign, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end fun_644;

public function varOutputTuple
  input Tpl.Text txt;
  input SimCodeFunction.Function a_fn;
  input SimCodeFunction.Variable a_var;
  input Integer a_ix;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_varInits;
  input Tpl.Text a_varCopy;
  input Tpl.Text a_varAssign;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varInits;
  output Tpl.Text out_a_varCopy;
  output Tpl.Text out_a_varAssign;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_varDecls, out_a_varInits, out_a_varAssign, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) := fun_644(txt, a_fn, a_var, a_ix, a_varDecls, a_varInits, a_varAssign, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
  out_a_varCopy := a_varCopy;
end varOutputTuple;

protected function fun_646
  input Tpl.Text in_txt;
  input String in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           "modelica_metatype" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = NULL"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_646;

protected function fun_647
  input Tpl.Text in_txt;
  input String in_mArg;
  input String in_a_varName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_varName)
    local
      Tpl.Text txt;
      String a_varName;

    case ( txt,
           "modelica_metatype",
           a_varName )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("mmc_GC_add_root(&"));
        txt = Tpl.writeStr(txt, a_varName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", mmc_GC_local_state, \""));
        txt = Tpl.writeStr(txt, a_varName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\");"));
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_647;

protected function fun_648
  input Tpl.Text in_txt;
  input list<DAE.Dimension> in_a_instDims;
  input Tpl.Text in_a_instDimsInit;
  input DAE.Type in_a_var_ty;
  input Tpl.Text in_a_addRoot;
  input Tpl.Text in_a_initVar;
  input String in_a_varName;
  input Tpl.Text in_a_type;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_instDims, in_a_instDimsInit, in_a_var_ty, in_a_addRoot, in_a_initVar, in_a_varName, in_a_type)
    local
      Tpl.Text txt;
      Tpl.Text a_instDimsInit;
      DAE.Type a_var_ty;
      Tpl.Text a_addRoot;
      Tpl.Text a_initVar;
      String a_varName;
      Tpl.Text a_type;
      list<DAE.Dimension> i_instDims;
      Integer ret_0;

    case ( txt,
           {},
           _,
           _,
           a_addRoot,
           a_initVar,
           a_varName,
           a_type )
      equation
        txt = Tpl.writeText(txt, a_type);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeStr(txt, a_varName);
        txt = Tpl.writeText(txt, a_initVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeText(txt, a_addRoot);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           i_instDims,
           a_instDimsInit,
           a_var_ty,
           _,
           _,
           a_varName,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("StatArrayDim"));
        ret_0 = listLength(i_instDims);
        txt = Tpl.writeStr(txt, intString(ret_0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<"));
        txt = CodegenCppCommonOld.expTypeShort(txt, a_var_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, a_instDimsInit);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("> "));
        txt = Tpl.writeStr(txt, a_varName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";/*testarray5*/"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;
  end match;
end fun_648;

protected function fun_649
  input Tpl.Text in_txt;
  input list<DAE.Dimension> in_a_instDims;
  input DAE.Type in_a_var_ty;
  input Tpl.Text in_a_addRoot;
  input Tpl.Text in_a_initVar;
  input String in_a_varName;
  input Tpl.Text in_a_type;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_instDims, in_a_var_ty, in_a_addRoot, in_a_initVar, in_a_varName, in_a_type)
    local
      Tpl.Text txt;
      DAE.Type a_var_ty;
      Tpl.Text a_addRoot;
      Tpl.Text a_initVar;
      String a_varName;
      Tpl.Text a_type;
      list<DAE.Dimension> i_instDims;
      Integer ret_0;

    case ( txt,
           {},
           _,
           a_addRoot,
           a_initVar,
           a_varName,
           a_type )
      equation
        txt = Tpl.writeText(txt, a_type);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeStr(txt, a_varName);
        txt = Tpl.writeText(txt, a_initVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeText(txt, a_addRoot);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           i_instDims,
           a_var_ty,
           _,
           _,
           a_varName,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("DynArrayDim"));
        ret_0 = listLength(i_instDims);
        txt = Tpl.writeStr(txt, intString(ret_0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<"));
        txt = CodegenCppCommonOld.expTypeShort(txt, a_var_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("> "));
        txt = Tpl.writeStr(txt, a_varName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;
  end match;
end fun_649;

protected function fun_650
  input Tpl.Text in_txt;
  input String in_mArg;
  input Tpl.Text in_a_arrayexpression1;
  input Tpl.Text in_a_arrayexpression2;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_varDecls) :=
  match(in_txt, in_mArg, in_a_arrayexpression1, in_a_arrayexpression2, in_a_varDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_arrayexpression1;
      Tpl.Text a_arrayexpression2;
      Tpl.Text a_varDecls;

    case ( txt,
           "",
           _,
           a_arrayexpression2,
           a_varDecls )
      equation
        a_varDecls = Tpl.writeText(a_varDecls, a_arrayexpression2);
      then (txt, a_varDecls);

    case ( txt,
           _,
           a_arrayexpression1,
           _,
           a_varDecls )
      equation
        a_varDecls = Tpl.writeText(a_varDecls, a_arrayexpression1);
      then (txt, a_varDecls);
  end match;
end fun_650;

protected function fun_651
  input Tpl.Text in_txt;
  input SimCodeFunction.Variable in_a_var;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_instDimsInit;
  input String in_a_varName;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_varDecls) :=
  match(in_txt, in_a_var, in_a_varDecls, in_a_instDimsInit, in_a_varName)
    local
      Tpl.Text txt;
      Tpl.Text a_varDecls;
      Tpl.Text a_instDimsInit;
      String a_varName;
      DAE.Type i_var_ty;
      list<DAE.Dimension> i_instDims;
      SimCodeFunction.Variable i_var;
      String str_7;
      Tpl.Text l_arrayexpression2;
      Tpl.Text l_arrayexpression1;
      String str_4;
      Tpl.Text l_addRoot;
      String str_2;
      Tpl.Text l_initVar;
      Tpl.Text l_type;

    case ( txt,
           (i_var as SimCodeFunction.VARIABLE(instDims = i_instDims, ty = i_var_ty)),
           a_varDecls,
           a_instDimsInit,
           a_varName )
      equation
        l_type = varType(Tpl.emptyTxt, i_var);
        str_2 = Tpl.textString(l_type);
        l_initVar = fun_646(Tpl.emptyTxt, str_2);
        str_4 = Tpl.textString(l_type);
        l_addRoot = fun_647(Tpl.emptyTxt, str_4, a_varName);
        l_arrayexpression1 = fun_648(Tpl.emptyTxt, i_instDims, a_instDimsInit, i_var_ty, l_addRoot, l_initVar, a_varName, l_type);
        l_arrayexpression2 = fun_649(Tpl.emptyTxt, i_instDims, i_var_ty, l_addRoot, l_initVar, a_varName, l_type);
        str_7 = Tpl.textString(a_instDimsInit);
        (txt, a_varDecls) = fun_650(txt, str_7, l_arrayexpression1, l_arrayexpression2, a_varDecls);
      then (txt, a_varDecls);

    case ( txt,
           _,
           a_varDecls,
           _,
           _ )
      then (txt, a_varDecls);
  end match;
end fun_651;

public function varDeclForVarInit
  input Tpl.Text txt;
  input SimCodeFunction.Variable a_var;
  input String a_varName;
  input list<DAE.Dimension> a_instDims;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_varInits;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varInits;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
protected
  Tpl.Text l_instDimsInit;
algorithm
  l_instDimsInit := CodegenCppCommonOld.checkDimension(Tpl.emptyTxt, a_instDims);
  (out_txt, out_a_varDecls) := fun_651(txt, a_var, a_varDecls, l_instDimsInit, a_varName);
  out_a_varInits := a_varInits;
  out_a_extraFuncs := a_extraFuncs;
  out_a_extraFuncsDecl := a_extraFuncsDecl;
  out_a_extraFuncsNamespace := a_extraFuncsNamespace;
  out_a_stateDerVectorName := a_stateDerVectorName;
end varDeclForVarInit;

protected function fun_653
  input Tpl.Text in_txt;
  input Tpl.Text in_a_recordInit;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_recordInit, in_a_preExp, in_a_varName)
    local
      Tpl.Text txt;
      Tpl.Text a_preExp;
      Tpl.Text a_varName;
      Tpl.Text i_recordInit;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           _,
           _ )
      then txt;

    case ( txt,
           i_recordInit,
           a_preExp,
           a_varName )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("//initRecordMembers "));
        txt = Tpl.writeText(txt, a_varName);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, a_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, i_recordInit);
      then txt;
  end match;
end fun_653;

protected function lm_654
  input Tpl.Text in_txt;
  input list<DAE.Dimension> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_varInits;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varInits;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_varInits) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_varInits)
    local
      Tpl.Text txt;
      list<DAE.Dimension> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_varInits;
      DAE.Dimension i_dim;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           a_varInits )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_varInits);

    case ( txt,
           i_dim :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_varInits )
      equation
        (txt, a_varInits, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeDimension(txt, i_dim, SimCodeFunction.contextFunction, a_varInits, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_varInits) = lm_654(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_varInits);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_varInits);
  end match;
end lm_654;

protected function fun_655
  input Tpl.Text in_txt;
  input Option<DAE.Exp> in_a_var_value;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_varInits;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input DAE.ComponentRef in_a_var_name;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varInits;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_varDecls, out_a_varInits, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_a_var_value, in_a_varDecls, in_a_varInits, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_var_name)
    local
      Tpl.Text txt;
      Tpl.Text a_varDecls;
      Tpl.Text a_varInits;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      DAE.ComponentRef a_var_name;
      DAE.Exp i_exp;
      Tpl.Text l_defaultValue;

    case ( txt,
           SOME(i_exp),
           a_varDecls,
           a_varInits,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_var_name )
      equation
        (l_defaultValue, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.contextCref(Tpl.emptyTxt, a_var_name, SimCodeFunction.contextFunction, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        l_defaultValue = Tpl.writeTok(l_defaultValue, Tpl.ST_STRING(" = "));
        (l_defaultValue, a_varInits, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.daeExp(l_defaultValue, i_exp, SimCodeFunction.contextFunction, a_varInits, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        l_defaultValue = Tpl.writeTok(l_defaultValue, Tpl.ST_STRING(";"));
        l_defaultValue = Tpl.writeTok(l_defaultValue, Tpl.ST_NEW_LINE());
        a_varInits = Tpl.writeText(a_varInits, l_defaultValue);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
      then (txt, a_varDecls, a_varInits, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           a_varDecls,
           a_varInits,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_varDecls, a_varInits, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_655;

protected function lm_656
  input Tpl.Text in_txt;
  input list<DAE.Dimension> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<DAE.Dimension> rest;
      DAE.Dimension i_dim;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_dim :: rest )
      equation
        txt = testDaeDimension(txt, i_dim);
        txt = Tpl.nextIter(txt);
        txt = lm_656(txt, rest);
      then txt;
  end match;
end lm_656;

protected function fun_657
  input Tpl.Text in_txt;
  input Option<DAE.Exp> in_a_var_value;
  input Integer in_a_i;
  input String in_a_outStruct;
  input SimCodeFunction.Variable in_a_var;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_varInits;
  input Tpl.Text in_a_varName;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varInits;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_varInits) :=
  match(in_txt, in_a_var_value, in_a_i, in_a_outStruct, in_a_var, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_varInits, in_a_varName)
    local
      Tpl.Text txt;
      Integer a_i;
      String a_outStruct;
      SimCodeFunction.Variable a_var;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_varInits;
      Tpl.Text a_varName;
      DAE.Exp i_exp;
      Tpl.Text l_defaultValue;
      Tpl.Text l_defaultValue1;

    case ( txt,
           SOME(i_exp),
           _,
           _,
           _,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_varInits,
           a_varName )
      equation
        l_defaultValue1 = Tpl.writeText(Tpl.emptyTxt, a_varName);
        l_defaultValue1 = Tpl.writeTok(l_defaultValue1, Tpl.ST_STRING(".assign("));
        (l_defaultValue1, a_varInits, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.daeExp(l_defaultValue1, i_exp, SimCodeFunction.contextFunction, a_varInits, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        l_defaultValue1 = Tpl.writeTok(l_defaultValue1, Tpl.ST_STRING(");"));
        l_defaultValue1 = Tpl.writeTok(l_defaultValue1, Tpl.ST_NEW_LINE());
        a_varInits = Tpl.writeText(a_varInits, l_defaultValue1);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_varInits);

    case ( txt,
           _,
           a_i,
           a_outStruct,
           a_var,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_varInits,
           a_varName )
      equation
        (l_defaultValue, a_varDecls, a_varInits, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = varDefaultValue(Tpl.emptyTxt, a_var, a_outStruct, a_i, Tpl.textString(a_varName), a_varDecls, a_varInits, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        a_varInits = Tpl.writeText(a_varInits, l_defaultValue);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_varInits);
  end match;
end fun_657;

protected function fun_658
  input Tpl.Text in_txt;
  input list<DAE.Dimension> in_a_instDims;
  input Integer in_a_i;
  input String in_a_outStruct;
  input SimCodeFunction.Variable in_a_var;
  input Tpl.Text in_a_instDimsInit;
  input Tpl.Text in_a_varName;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_varInits;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input DAE.ComponentRef in_a_var_name;
  input Option<DAE.Exp> in_a_var_value;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varInits;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_varDecls, out_a_varInits, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_a_instDims, in_a_i, in_a_outStruct, in_a_var, in_a_instDimsInit, in_a_varName, in_a_varDecls, in_a_varInits, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_var_name, in_a_var_value)
    local
      Tpl.Text txt;
      Integer a_i;
      String a_outStruct;
      SimCodeFunction.Variable a_var;
      Tpl.Text a_instDimsInit;
      Tpl.Text a_varName;
      Tpl.Text a_varDecls;
      Tpl.Text a_varInits;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      DAE.ComponentRef a_var_name;
      Option<DAE.Exp> a_var_value;
      list<DAE.Dimension> i_instDims;
      Tpl.Text l_temp;
      Tpl.Text l_testinstDimsInit;

    case ( txt,
           {},
           _,
           _,
           _,
           _,
           _,
           a_varDecls,
           a_varInits,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_var_name,
           a_var_value )
      equation
        (txt, a_varDecls, a_varInits, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_655(txt, a_var_value, a_varDecls, a_varInits, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_var_name);
      then (txt, a_varDecls, a_varInits, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           i_instDims,
           a_i,
           a_outStruct,
           a_var,
           a_instDimsInit,
           a_varName,
           a_varDecls,
           a_varInits,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           _,
           a_var_value )
      equation
        l_testinstDimsInit = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING("")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_testinstDimsInit = lm_656(l_testinstDimsInit, i_instDims);
        l_testinstDimsInit = Tpl.popIter(l_testinstDimsInit);
        (l_temp, l_testinstDimsInit, a_varInits) = setDims(Tpl.emptyTxt, l_testinstDimsInit, Tpl.textString(a_varName), a_varInits, Tpl.textString(a_instDimsInit));
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_varInits) = fun_657(txt, a_var_value, a_i, a_outStruct, a_var, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_varInits, a_varName);
      then (txt, a_varDecls, a_varInits, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_658;

public function varInit
  input Tpl.Text in_txt;
  input SimCodeFunction.Variable in_a_var;
  input String in_a_outStruct;
  input Integer in_a_i;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_varInits;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varInits;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_varDecls, out_a_varInits, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_var, in_a_outStruct, in_a_i, in_a_varDecls, in_a_varInits, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      String a_outStruct;
      Integer a_i;
      Tpl.Text a_varDecls;
      Tpl.Text a_varInits;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      Option<DAE.Exp> i_var_value;
      list<DAE.Dimension> i_instDims;
      SimCodeFunction.Variable i_var;
      DAE.ComponentRef i_var_name;
      Tpl.Text l_ignore;
      Tpl.Text l_0__;
      Tpl.Text l_instDimsInit;
      Tpl.Text l_recordInit;
      Tpl.Text l_preExp;
      Tpl.Text l_varName;

    case ( txt,
           (i_var as SimCodeFunction.VARIABLE(name = i_var_name, instDims = i_instDims, value = i_var_value)),
           a_outStruct,
           a_i,
           a_varDecls,
           a_varInits,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (l_varName, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.contextCref(Tpl.emptyTxt, i_var_name, SimCodeFunction.contextFunction, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        l_preExp = Tpl.emptyTxt;
        (l_recordInit, l_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = initRecordMembers(Tpl.emptyTxt, i_var, l_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        a_varInits = fun_653(a_varInits, l_recordInit, l_preExp, l_varName);
        l_instDimsInit = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_instDimsInit, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_varInits) = lm_654(l_instDimsInit, i_instDims, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_varInits);
        l_instDimsInit = Tpl.popIter(l_instDimsInit);
        (l_0__, a_varDecls, a_varInits, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = varDeclForVarInit(Tpl.emptyTxt, i_var, Tpl.textString(l_varName), i_instDims, a_varDecls, a_varInits, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        (txt, a_varDecls, a_varInits, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_658(txt, i_instDims, a_i, a_outStruct, i_var, l_instDimsInit, l_varName, a_varDecls, a_varInits, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, i_var_name, i_var_value);
      then (txt, a_varDecls, a_varInits, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           (i_var as SimCodeFunction.FUNCTION_PTR(name = _)),
           _,
           _,
           a_varDecls,
           a_varInits,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      equation
        l_ignore = Tpl.emptyTxt;
        (a_varDecls, l_ignore) = functionArg(a_varDecls, i_var, l_ignore);
      then (txt, a_varDecls, a_varInits, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           _,
           a_varDecls,
           a_varInits,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_varDecls, a_varInits, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end varInit;

protected function lm_660
  input Tpl.Text in_txt;
  input list<DAE.Var> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varName;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varName;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp, out_a_varName) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_preExp, in_a_varName)
    local
      Tpl.Text txt;
      list<DAE.Var> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      Tpl.Text a_varName;
      DAE.Var i_v;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           a_preExp,
           a_varName )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp, a_varName);

    case ( txt,
           i_v :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp,
           a_varName )
      equation
        (txt, a_varName, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = recordMemberInit(txt, i_v, a_varName, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp, a_varName) = lm_660(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_varName);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp, a_varName);
  end match;
end lm_660;

public function initRecordMembers
  input Tpl.Text in_txt;
  input SimCodeFunction.Variable in_a_var;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_var, in_a_preExp, in_a_varDecls, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      list<DAE.Var> i_ty_varLst;
      DAE.ComponentRef i_name;
      Tpl.Text l_varName;

    case ( txt,
           SimCodeFunction.VARIABLE(ty = DAE.T_COMPLEX(complexClassType = ClassInf.RECORD(path = _), varLst = i_ty_varLst), name = i_name),
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (l_varName, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.contextCref(Tpl.emptyTxt, i_name, SimCodeFunction.contextFunction, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp, l_varName) = lm_660(txt, i_ty_varLst, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, l_varName);
        txt = Tpl.popIter(txt);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           a_preExp,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end initRecordMembers;

protected function fun_662
  input Tpl.Text in_txt;
  input DAE.Binding in_a_binding;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_vn;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_a_binding, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_preExp, in_a_vn)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      Tpl.Text a_vn;
      DAE.Exp i_exp;
      Values.Value i_val;
      DAE.Exp ret_1;
      DAE.Exp ret_0;

    case ( txt,
           DAE.VALBOUND(valBound = i_val),
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp,
           a_vn )
      equation
        txt = Tpl.writeText(txt, a_vn);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        ret_0 = ValuesUtil.valueExp(i_val);
        (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.daeExp(txt, ret_0, SimCodeFunction.contextOther, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);

    case ( txt,
           DAE.EQBOUND(evaluatedExp = SOME(i_val)),
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp,
           a_vn )
      equation
        txt = Tpl.writeText(txt, a_vn);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        ret_1 = ValuesUtil.valueExp(i_val);
        (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.daeExp(txt, ret_1, SimCodeFunction.contextFunction, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);

    case ( txt,
           DAE.EQBOUND(exp = i_exp),
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp,
           a_vn )
      equation
        txt = Tpl.writeText(txt, a_vn);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.daeExp(txt, i_exp, SimCodeFunction.contextFunction, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);

    case ( txt,
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);
  end match;
end fun_662;

protected function fun_663
  input Tpl.Text in_txt;
  input DAE.Var in_a_v;
  input Tpl.Text in_a_varName;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_v, in_a_varName, in_a_preExp, in_a_varDecls, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      Tpl.Text a_varName;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      DAE.Binding i_binding;
      DAE.Ident i_name;
      Tpl.Text l_defaultValue;
      Tpl.Text l_vn;

    case ( txt,
           DAE.TYPES_VAR(name = i_name, binding = i_binding),
           a_varName,
           a_preExp,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_vn = Tpl.writeText(Tpl.emptyTxt, a_varName);
        l_vn = Tpl.writeTok(l_vn, Tpl.ST_STRING("."));
        l_vn = Tpl.writeStr(l_vn, i_name);
        l_vn = Tpl.writeTok(l_vn, Tpl.ST_STRING("_"));
        (l_defaultValue, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = fun_662(Tpl.emptyTxt, i_binding, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, l_vn);
        txt = Tpl.writeText(txt, l_defaultValue);
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           a_preExp,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end fun_663;

public function recordMemberInit
  input Tpl.Text txt;
  input DAE.Var a_v;
  input Tpl.Text a_varName;
  input Tpl.Text a_preExp;
  input Tpl.Text a_varDecls;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varName;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_preExp, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) := fun_663(txt, a_v, a_varName, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
  out_a_varName := a_varName;
end recordMemberInit;

protected function fun_665
  input Tpl.Text in_txt;
  input String in_mArg;
  input String in_a_varName;
  input Tpl.Text in_a_varInits;
  input String in_a_instDimsInit;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varInits;
algorithm
  (out_txt, out_a_varInits) :=
  match(in_txt, in_mArg, in_a_varName, in_a_varInits, in_a_instDimsInit)
    local
      Tpl.Text txt;
      String a_varName;
      Tpl.Text a_varInits;
      String a_instDimsInit;

    case ( txt,
           "",
           _,
           a_varInits,
           _ )
      then (txt, a_varInits);

    case ( txt,
           _,
           a_varName,
           a_varInits,
           a_instDimsInit )
      equation
        a_varInits = Tpl.writeStr(a_varInits, a_varName);
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING(".setDims("));
        a_varInits = Tpl.writeStr(a_varInits, a_instDimsInit);
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_STRING(");"));
        a_varInits = Tpl.writeTok(a_varInits, Tpl.ST_NEW_LINE());
      then (txt, a_varInits);
  end match;
end fun_665;

public function setDims
  input Tpl.Text txt;
  input Tpl.Text a_testinstDimsInit;
  input String a_varName;
  input Tpl.Text a_varInits;
  input String a_instDimsInit;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_testinstDimsInit;
  output Tpl.Text out_a_varInits;
protected
  String str_0;
algorithm
  str_0 := Tpl.textString(a_testinstDimsInit);
  (out_txt, out_a_varInits) := fun_665(txt, str_0, a_varName, a_varInits, a_instDimsInit);
  out_a_testinstDimsInit := a_testinstDimsInit;
end setDims;

protected function lm_667
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Variable> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Variable> rest;
      SimCodeFunction.Variable i_arg;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_arg :: rest )
      equation
        txt = mmcVarType(txt, i_arg);
        txt = Tpl.nextIter(txt);
        txt = lm_667(txt, rest);
      then txt;
  end match;
end lm_667;

protected function lm_668
  input Tpl.Text in_txt;
  input list<DAE.Type> in_items;
  input Tpl.Text in_a_rettype;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_rettype)
    local
      Tpl.Text txt;
      list<DAE.Type> rest;
      Tpl.Text a_rettype;
      Integer x_i1;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           _ :: rest,
           a_rettype )
      equation
        x_i1 = Tpl.getIteri_i0(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#define "));
        txt = Tpl.writeText(txt, a_rettype);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeStr(txt, intString(x_i1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" targTest2"));
        txt = Tpl.writeStr(txt, intString(x_i1));
        txt = Tpl.nextIter(txt);
        txt = lm_668(txt, rest, a_rettype);
      then txt;
  end match;
end lm_668;

protected function lm_669
  input Tpl.Text in_txt;
  input list<DAE.Type> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<DAE.Type> rest;
      Integer x_i1;
      DAE.Type i_ty;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_ty :: rest )
      equation
        x_i1 = Tpl.getIteri_i0(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_"));
        txt = mmcTypeShort(txt, i_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" targTest1"));
        txt = Tpl.writeStr(txt, intString(x_i1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        txt = lm_669(txt, rest);
      then txt;
  end match;
end lm_669;

protected function fun_670
  input Tpl.Text in_txt;
  input list<DAE.Type> in_a_tys;
  input Tpl.Text in_a_rettype;
  input Tpl.Text in_a_typelist;
  input String in_a_name;
  input Tpl.Text in_a_varInit;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varInit;
algorithm
  (out_txt, out_a_varInit) :=
  match(in_txt, in_a_tys, in_a_rettype, in_a_typelist, in_a_name, in_a_varInit)
    local
      Tpl.Text txt;
      Tpl.Text a_rettype;
      Tpl.Text a_typelist;
      String a_name;
      Tpl.Text a_varInit;
      list<DAE.Type> i_tys;

    case ( txt,
           {},
           _,
           a_typelist,
           a_name,
           a_varInit )
      equation
        a_varInit = Tpl.writeTok(a_varInit, Tpl.ST_STRING("_"));
        a_varInit = Tpl.writeStr(a_varInit, a_name);
        a_varInit = Tpl.writeTok(a_varInit, Tpl.ST_STRING(" = (void(*)("));
        a_varInit = Tpl.writeText(a_varInit, a_typelist);
        a_varInit = Tpl.writeTok(a_varInit, Tpl.ST_STRING(")) "));
        a_varInit = Tpl.writeStr(a_varInit, a_name);
        a_varInit = Tpl.writeTok(a_varInit, Tpl.ST_NEW_LINE());
        a_varInit = Tpl.writeTok(a_varInit, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void(*_"));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")("));
        txt = Tpl.writeText(txt, a_typelist);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then (txt, a_varInit);

    case ( txt,
           i_tys,
           a_rettype,
           a_typelist,
           a_name,
           a_varInit )
      equation
        a_varInit = Tpl.writeTok(a_varInit, Tpl.ST_STRING("_"));
        a_varInit = Tpl.writeStr(a_varInit, a_name);
        a_varInit = Tpl.writeTok(a_varInit, Tpl.ST_STRING(" = ("));
        a_varInit = Tpl.writeText(a_varInit, a_rettype);
        a_varInit = Tpl.writeTok(a_varInit, Tpl.ST_STRING("(*)("));
        a_varInit = Tpl.writeText(a_varInit, a_typelist);
        a_varInit = Tpl.writeTok(a_varInit, Tpl.ST_STRING(")) "));
        a_varInit = Tpl.writeStr(a_varInit, a_name);
        a_varInit = Tpl.writeTok(a_varInit, Tpl.ST_STRING(";"));
        a_varInit = Tpl.writeTok(a_varInit, Tpl.ST_NEW_LINE());
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(1, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_668(txt, i_tys, a_rettype);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("typedef struct "));
        txt = Tpl.writeText(txt, a_rettype);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_s\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(1, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_669(txt, i_tys);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("} "));
        txt = Tpl.writeText(txt, a_rettype);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.writeText(txt, a_rettype);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(*_"));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")("));
        txt = Tpl.writeText(txt, a_typelist);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then (txt, a_varInit);
  end match;
end fun_670;

public function functionArg
  input Tpl.Text in_txt;
  input SimCodeFunction.Variable in_a_var;
  input Tpl.Text in_a_varInit;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varInit;
algorithm
  (out_txt, out_a_varInit) :=
  match(in_txt, in_a_var, in_a_varInit)
    local
      Tpl.Text txt;
      Tpl.Text a_varInit;
      list<DAE.Type> i_tys;
      String i_name;
      list<SimCodeFunction.Variable> i_args;
      Tpl.Text l_rettype;
      Tpl.Text l_typelist;

    case ( txt,
           SimCodeFunction.FUNCTION_PTR(args = i_args, name = i_name, tys = i_tys),
           a_varInit )
      equation
        l_typelist = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_typelist = lm_667(l_typelist, i_args);
        l_typelist = Tpl.popIter(l_typelist);
        l_rettype = Tpl.writeStr(Tpl.emptyTxt, i_name);
        l_rettype = Tpl.writeTok(l_rettype, Tpl.ST_STRING("RetType /* functionArg */"));
        (txt, a_varInit) = fun_670(txt, i_tys, l_rettype, l_typelist, i_name, a_varInit);
      then (txt, a_varInit);

    case ( txt,
           _,
           a_varInit )
      then (txt, a_varInit);
  end match;
end functionArg;

public function mmcVarType
  input Tpl.Text in_txt;
  input SimCodeFunction.Variable in_a_var;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_var)
    local
      Tpl.Text txt;
      DAE.Type i_ty;

    case ( txt,
           SimCodeFunction.VARIABLE(ty = i_ty) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_"));
        txt = mmcTypeShort(txt, i_ty);
      then txt;

    case ( txt,
           SimCodeFunction.FUNCTION_PTR(name = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_fnptr"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end mmcVarType;

public function mmcTypeShort
  input Tpl.Text in_txt;
  input DAE.Type in_a_type;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_type)
    local
      Tpl.Text txt;

    case ( txt,
           DAE.T_INTEGER(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("integer"));
      then txt;

    case ( txt,
           DAE.T_REAL(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("real"));
      then txt;

    case ( txt,
           DAE.T_STRING(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("string"));
      then txt;

    case ( txt,
           DAE.T_BOOL(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("integer"));
      then txt;

    case ( txt,
           DAE.T_ENUMERATION(index = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("integer"));
      then txt;

    case ( txt,
           DAE.T_ARRAY(ty = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("array"));
      then txt;

    case ( txt,
           DAE.T_METATYPE(ty = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("metatype"));
      then txt;

    case ( txt,
           DAE.T_METABOXED(ty = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("metatype"));
      then txt;

    case ( txt,
           DAE.T_FUNCTION_REFERENCE_VAR(functionType = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("fnptr"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("mmcTypeShort:ERROR"));
      then txt;
  end match;
end mmcTypeShort;

public function extVarName
  input Tpl.Text txt;
  input DAE.ComponentRef a_cr;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) := CodegenCppCommonOld.contextCref(txt, a_cr, SimCodeFunction.contextFunction, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("_ext"));
end extVarName;

public function extVarName2
  input Tpl.Text txt;
  input DAE.ComponentRef a_cr;

  output Tpl.Text out_txt;
algorithm
  out_txt := CodegenCppCommonOld.contextCref2(txt, a_cr, SimCodeFunction.contextFunction);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("_ext"));
end extVarName2;

protected function fun_676
  input Tpl.Text in_txt;
  input Option<DAE.Exp> in_a_value;
  input String in_a_lhsVarName;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_varInits;
  input Integer in_a_i;
  input String in_a_outStruct;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varInits;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_varDecls, out_a_varInits, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_a_value, in_a_lhsVarName, in_a_varDecls, in_a_varInits, in_a_i, in_a_outStruct, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      String a_lhsVarName;
      Tpl.Text a_varDecls;
      Tpl.Text a_varInits;
      Integer a_i;
      String a_outStruct;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      DAE.Exp i_arr;
      DAE.ComponentRef i_cr;
      Tpl.Text l_arrayExp;

    case ( txt,
           SOME(DAE.CREF(componentRef = i_cr)),
           _,
           a_varDecls,
           a_varInits,
           a_i,
           a_outStruct,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.contextCref(txt, i_cr, SimCodeFunction.contextFunction, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" =  "));
        txt = Tpl.writeStr(txt, a_outStruct);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".targTest9"));
        txt = Tpl.writeStr(txt, intString(a_i));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then (txt, a_varDecls, a_varInits, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           SOME((i_arr as DAE.ARRAY(ty = _))),
           a_lhsVarName,
           a_varDecls,
           a_varInits,
           _,
           _,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (l_arrayExp, a_varInits, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.daeExp(Tpl.emptyTxt, i_arr, SimCodeFunction.contextFunction, a_varInits, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeStr(txt, a_lhsVarName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, l_arrayExp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then (txt, a_varDecls, a_varInits, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           _,
           a_varDecls,
           a_varInits,
           _,
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_varDecls, a_varInits, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_676;

public function varDefaultValue
  input Tpl.Text in_txt;
  input SimCodeFunction.Variable in_a_var;
  input String in_a_outStruct;
  input Integer in_a_i;
  input String in_a_lhsVarName;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_varInits;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varInits;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_varDecls, out_a_varInits, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_var, in_a_outStruct, in_a_i, in_a_lhsVarName, in_a_varDecls, in_a_varInits, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      String a_outStruct;
      Integer a_i;
      String a_lhsVarName;
      Tpl.Text a_varDecls;
      Tpl.Text a_varInits;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      Option<DAE.Exp> i_value;

    case ( txt,
           SimCodeFunction.VARIABLE(value = i_value),
           a_outStruct,
           a_i,
           a_lhsVarName,
           a_varDecls,
           a_varInits,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (txt, a_varDecls, a_varInits, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_676(txt, i_value, a_lhsVarName, a_varDecls, a_varInits, a_i, a_outStruct, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_varDecls, a_varInits, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           _,
           _,
           a_varDecls,
           a_varInits,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_varDecls, a_varInits, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end varDefaultValue;

public function funArgDefinition
  input Tpl.Text in_txt;
  input SimCodeFunction.Variable in_a_var;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_var, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      String i_name_1;
      DAE.ComponentRef i_name;
      SimCodeFunction.Variable i_var;

    case ( txt,
           (i_var as SimCodeFunction.VARIABLE(name = i_name)),
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = varType1(txt, i_var, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.contextCref(txt, i_name, SimCodeFunction.contextFunction, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           SimCodeFunction.FUNCTION_PTR(name = i_name_1),
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_fnptr "));
        txt = Tpl.writeStr(txt, i_name_1);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end funArgDefinition;

public function funArgDefinition2
  input Tpl.Text in_txt;
  input SimCodeFunction.Variable in_a_var;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_var, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      String i_name_1;
      DAE.ComponentRef i_name;
      SimCodeFunction.Variable i_var;

    case ( txt,
           (i_var as SimCodeFunction.VARIABLE(name = i_name)),
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = varType3(txt, i_var, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.contextCref(txt, i_name, SimCodeFunction.contextFunction, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           SimCodeFunction.FUNCTION_PTR(name = i_name_1),
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_fnptr "));
        txt = Tpl.writeStr(txt, i_name_1);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end funArgDefinition2;

public function funExtArgDefinition
  input Tpl.Text in_txt;
  input SimCodeFunction.SimExtArg in_a_extArg;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_extArg, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      DAE.Type i_type__;
      DAE.Type i_t;
      DAE.ComponentRef i_c;
      Tpl.Text l_typeStr;
      Tpl.Text l_name;

    case ( txt,
           SimCodeFunction.SIMEXTARG(cref = i_c, isInput = _, isArray = _, type_ = i_t),
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (l_name, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.contextCref(Tpl.emptyTxt, i_c, SimCodeFunction.contextFunction, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        l_typeStr = CodegenCppCommonOld.expTypeFlag(Tpl.emptyTxt, i_t, 5);
        txt = Tpl.writeText(txt, l_typeStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, l_name);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           SimCodeFunction.SIMEXTARGEXP(type_ = i_type__),
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      equation
        l_typeStr = CodegenCppCommonOld.expTypeFlag(Tpl.emptyTxt, i_type__, 5);
        txt = Tpl.writeText(txt, l_typeStr);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           SimCodeFunction.SIMEXTARGSIZE(cref = _),
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("size_t"));
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end funExtArgDefinition;

public function funReturnDefinition1
  input Tpl.Text in_txt;
  input SimCodeFunction.Variable in_a_var;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace) :=
  match(in_txt, in_a_var, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      String i_name;
      SimCodeFunction.Variable i_var;

    case ( txt,
           (i_var as SimCodeFunction.VARIABLE(name = _)),
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = varType3(txt, i_var, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);

    case ( txt,
           SimCodeFunction.FUNCTION_PTR(name = i_name),
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_fnptr "));
        txt = Tpl.writeStr(txt, i_name);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);

    case ( txt,
           _,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
  end match;
end funReturnDefinition1;

public function funReturnDefinition2
  input Tpl.Text in_txt;
  input SimCodeFunction.Variable in_a_var;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_var, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      String i_name;
      SimCodeFunction.Variable i_var;

    case ( txt,
           (i_var as SimCodeFunction.VARIABLE(name = _)),
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = varType2(txt, i_var, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           SimCodeFunction.FUNCTION_PTR(name = i_name),
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("modelica_fnptr "));
        txt = Tpl.writeStr(txt, i_name);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end funReturnDefinition2;

protected function fun_683
  input Tpl.Text in_txt;
  input list<DAE.Dimension> in_a_instDims;
  input DAE.Type in_a_var_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_instDims, in_a_var_ty)
    local
      Tpl.Text txt;
      DAE.Type a_var_ty;

    case ( txt,
           {},
           a_var_ty )
      equation
        txt = CodegenCppCommonOld.expTypeArrayIf(txt, a_var_ty);
      then txt;

    case ( txt,
           _,
           a_var_ty )
      equation
        txt = CodegenCppCommonOld.expTypeShort(txt, a_var_ty);
      then txt;
  end match;
end fun_683;

public function varType
  input Tpl.Text in_txt;
  input SimCodeFunction.Variable in_a_var;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_var)
    local
      Tpl.Text txt;
      DAE.Type i_var_ty;
      list<DAE.Dimension> i_instDims;

    case ( txt,
           SimCodeFunction.VARIABLE(instDims = i_instDims, ty = i_var_ty) )
      equation
        txt = fun_683(txt, i_instDims, i_var_ty);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end varType;

protected function fun_685
  input Tpl.Text in_txt;
  input list<DAE.Dimension> in_a_instDims;
  input DAE.Type in_a_ty;
  input DAE.Type in_a_var_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_instDims, in_a_ty, in_a_var_ty)
    local
      Tpl.Text txt;
      DAE.Type a_ty;
      DAE.Type a_var_ty;

    case ( txt,
           {},
           _,
           a_var_ty )
      equation
        txt = CodegenCppCommonOld.expTypeFlag(txt, a_var_ty, 8);
      then txt;

    case ( txt,
           _,
           a_ty,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("BaseArray<"));
        txt = CodegenCppCommonOld.expTypeShort(txt, a_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(">&"));
      then txt;
  end match;
end fun_685;

protected function fun_686
  input Tpl.Text in_txt;
  input SimCodeFunction.Variable in_a_var;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_var)
    local
      Tpl.Text txt;
      DAE.Type i_ty;
      DAE.Type i_var_ty;
      list<DAE.Dimension> i_instDims;

    case ( txt,
           SimCodeFunction.VARIABLE(instDims = i_instDims, ty = (i_ty as i_var_ty)) )
      equation
        txt = fun_685(txt, i_instDims, i_ty, i_var_ty);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_686;

public function varType1
  input Tpl.Text txt;
  input SimCodeFunction.Variable a_var;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  out_txt := fun_686(txt, a_var);
  out_a_extraFuncs := a_extraFuncs;
  out_a_extraFuncsDecl := a_extraFuncsDecl;
  out_a_extraFuncsNamespace := a_extraFuncsNamespace;
end varType1;

protected function lm_688
  input Tpl.Text in_txt;
  input list<DAE.Dimension> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<DAE.Dimension> rest;
      DAE.Dimension i_dim;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_dim :: rest )
      equation
        txt = testDaeDimension(txt, i_dim);
        txt = Tpl.nextIter(txt);
        txt = lm_688(txt, rest);
      then txt;
  end match;
end lm_688;

protected function lm_689
  input Tpl.Text in_txt;
  input list<DAE.Dimension> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_varInits;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varInits;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_varInits) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_varInits)
    local
      Tpl.Text txt;
      list<DAE.Dimension> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_varInits;
      DAE.Dimension i_dim;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           a_varInits )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_varInits);

    case ( txt,
           i_dim :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_varInits )
      equation
        (txt, a_varInits, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = daeDimension(txt, i_dim, SimCodeFunction.contextFunction, a_varInits, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_varInits) = lm_689(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_varInits);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_varInits);
  end match;
end lm_689;

protected function fun_690
  input Tpl.Text in_txt;
  input list<DAE.Dimension> in_a_instDims;
  input Tpl.Text in_a_instDimsInit;
  input DAE.Type in_a_var_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_instDims, in_a_instDimsInit, in_a_var_ty)
    local
      Tpl.Text txt;
      Tpl.Text a_instDimsInit;
      DAE.Type a_var_ty;
      list<DAE.Dimension> i_instDims;
      Integer ret_0;

    case ( txt,
           {},
           _,
           a_var_ty )
      equation
        txt = CodegenCppCommonOld.expTypeFlag(txt, a_var_ty, 5);
      then txt;

    case ( txt,
           i_instDims,
           a_instDimsInit,
           a_var_ty )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("StatArrayDim"));
        ret_0 = listLength(i_instDims);
        txt = Tpl.writeStr(txt, intString(ret_0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<"));
        txt = CodegenCppCommonOld.expTypeShort(txt, a_var_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_instDimsInit);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(">& "));
      then txt;
  end match;
end fun_690;

protected function fun_691
  input Tpl.Text in_txt;
  input list<DAE.Dimension> in_a_instDims;
  input DAE.Type in_a_var_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_instDims, in_a_var_ty)
    local
      Tpl.Text txt;
      DAE.Type a_var_ty;
      list<DAE.Dimension> i_instDims;
      Integer ret_0;

    case ( txt,
           {},
           a_var_ty )
      equation
        txt = CodegenCppCommonOld.expTypeFlag(txt, a_var_ty, 5);
      then txt;

    case ( txt,
           i_instDims,
           a_var_ty )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("DynArrayDim"));
        ret_0 = listLength(i_instDims);
        txt = Tpl.writeStr(txt, intString(ret_0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<"));
        txt = CodegenCppCommonOld.expTypeShort(txt, a_var_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(">&"));
      then txt;
  end match;
end fun_691;

protected function fun_692
  input Tpl.Text in_txt;
  input String in_mArg;
  input Tpl.Text in_a_instDimsInit;
  input DAE.Type in_a_var_ty;
  input list<DAE.Dimension> in_a_instDims;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_instDimsInit, in_a_var_ty, in_a_instDims)
    local
      Tpl.Text txt;
      Tpl.Text a_instDimsInit;
      DAE.Type a_var_ty;
      list<DAE.Dimension> a_instDims;

    case ( txt,
           "",
           a_instDimsInit,
           a_var_ty,
           a_instDims )
      equation
        txt = fun_690(txt, a_instDims, a_instDimsInit, a_var_ty);
      then txt;

    case ( txt,
           _,
           _,
           a_var_ty,
           a_instDims )
      equation
        txt = fun_691(txt, a_instDims, a_var_ty);
      then txt;
  end match;
end fun_692;

public function varType2
  input Tpl.Text in_txt;
  input SimCodeFunction.Variable in_a_var;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_var, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      DAE.Type i_var_ty;
      list<DAE.Dimension> i_instDims;
      String str_4;
      Tpl.Text l_instDimsInit;
      Tpl.Text l_DimsTest;
      Tpl.Text l_varInits;
      Tpl.Text l_varDecls;

    case ( txt,
           SimCodeFunction.VARIABLE(instDims = i_instDims, ty = i_var_ty),
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_varDecls = Tpl.emptyTxt;
        l_varInits = Tpl.emptyTxt;
        l_DimsTest = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING("")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_DimsTest = lm_688(l_DimsTest, i_instDims);
        l_DimsTest = Tpl.popIter(l_DimsTest);
        l_instDimsInit = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_instDimsInit, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, l_varDecls, l_varInits) = lm_689(l_instDimsInit, i_instDims, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, l_varDecls, l_varInits);
        l_instDimsInit = Tpl.popIter(l_instDimsInit);
        str_4 = Tpl.textString(l_DimsTest);
        txt = fun_692(txt, str_4, l_instDimsInit, i_var_ty, i_instDims);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end varType2;

protected function lm_694
  input Tpl.Text in_txt;
  input list<DAE.Dimension> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<DAE.Dimension> rest;
      DAE.Dimension i_dim;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_dim :: rest )
      equation
        txt = testDaeDimension(txt, i_dim);
        txt = Tpl.nextIter(txt);
        txt = lm_694(txt, rest);
      then txt;
  end match;
end lm_694;

protected function lm_695
  input Tpl.Text in_txt;
  input list<DAE.Dimension> in_items;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_varInits;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_varInits;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_varInits) :=
  match(in_txt, in_items, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_varInits)
    local
      Tpl.Text txt;
      list<DAE.Dimension> rest;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_varInits;
      DAE.Dimension i_dim;

    case ( txt,
           {},
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           a_varInits )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_varInits);

    case ( txt,
           i_dim :: rest,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_varInits )
      equation
        (txt, a_varInits, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, _) = daeDimension(txt, i_dim, SimCodeFunction.contextFunction, a_varInits, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, Tpl.strTokText(Tpl.ST_STRING("stateDerVectorName_not_given")), false);
        txt = Tpl.nextIter(txt);
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_varInits) = lm_695(txt, rest, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_varInits);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_varInits);
  end match;
end lm_695;

protected function fun_696
  input Tpl.Text in_txt;
  input list<DAE.Dimension> in_a_instDims;
  input Tpl.Text in_a_instDimsInit;
  input DAE.Type in_a_var_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_instDims, in_a_instDimsInit, in_a_var_ty)
    local
      Tpl.Text txt;
      Tpl.Text a_instDimsInit;
      DAE.Type a_var_ty;
      list<DAE.Dimension> i_instDims;
      Integer ret_0;

    case ( txt,
           {},
           _,
           a_var_ty )
      equation
        txt = CodegenCppCommonOld.expTypeArrayIf(txt, a_var_ty);
      then txt;

    case ( txt,
           i_instDims,
           a_instDimsInit,
           a_var_ty )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("StatArrayDim"));
        ret_0 = listLength(i_instDims);
        txt = Tpl.writeStr(txt, intString(ret_0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("< "));
        txt = CodegenCppCommonOld.expTypeShort(txt, a_var_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_instDimsInit);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("> /*testarray2*/"));
      then txt;
  end match;
end fun_696;

protected function fun_697
  input Tpl.Text in_txt;
  input list<DAE.Dimension> in_a_instDims;
  input DAE.Type in_a_var_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_instDims, in_a_var_ty)
    local
      Tpl.Text txt;
      DAE.Type a_var_ty;
      list<DAE.Dimension> i_instDims;
      Integer ret_0;

    case ( txt,
           {},
           a_var_ty )
      equation
        txt = CodegenCppCommonOld.expTypeArrayIf(txt, a_var_ty);
      then txt;

    case ( txt,
           i_instDims,
           a_var_ty )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("DynArrayDim"));
        ret_0 = listLength(i_instDims);
        txt = Tpl.writeStr(txt, intString(ret_0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<"));
        txt = CodegenCppCommonOld.expTypeShort(txt, a_var_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("> "));
      then txt;
  end match;
end fun_697;

protected function fun_698
  input Tpl.Text in_txt;
  input String in_mArg;
  input Tpl.Text in_a_instDimsInit;
  input DAE.Type in_a_var_ty;
  input list<DAE.Dimension> in_a_instDims;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_instDimsInit, in_a_var_ty, in_a_instDims)
    local
      Tpl.Text txt;
      Tpl.Text a_instDimsInit;
      DAE.Type a_var_ty;
      list<DAE.Dimension> a_instDims;

    case ( txt,
           "",
           a_instDimsInit,
           a_var_ty,
           a_instDims )
      equation
        txt = fun_696(txt, a_instDims, a_instDimsInit, a_var_ty);
      then txt;

    case ( txt,
           _,
           _,
           a_var_ty,
           a_instDims )
      equation
        txt = fun_697(txt, a_instDims, a_var_ty);
      then txt;
  end match;
end fun_698;

public function varType3
  input Tpl.Text in_txt;
  input SimCodeFunction.Variable in_a_var;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace) :=
  match(in_txt, in_a_var, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      DAE.Type i_var_ty;
      list<DAE.Dimension> i_instDims;
      String str_4;
      Tpl.Text l_instDimsInit;
      Tpl.Text l_testinstDimsInit;
      Tpl.Text l_varInits;
      Tpl.Text l_varDecls;

    case ( txt,
           SimCodeFunction.VARIABLE(instDims = i_instDims, ty = i_var_ty),
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace )
      equation
        l_varDecls = Tpl.emptyTxt;
        l_varInits = Tpl.emptyTxt;
        l_testinstDimsInit = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING("")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_testinstDimsInit = lm_694(l_testinstDimsInit, i_instDims);
        l_testinstDimsInit = Tpl.popIter(l_testinstDimsInit);
        l_instDimsInit = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_instDimsInit, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, l_varDecls, l_varInits) = lm_695(l_instDimsInit, i_instDims, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, l_varDecls, l_varInits);
        l_instDimsInit = Tpl.popIter(l_instDimsInit);
        str_4 = Tpl.textString(l_testinstDimsInit);
        txt = fun_698(txt, str_4, l_instDimsInit, i_var_ty, i_instDims);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);

    case ( txt,
           _,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
  end match;
end varType3;

protected function lm_700
  input Tpl.Text in_txt;
  input list<DAE.Statement> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls)
    local
      Tpl.Text txt;
      list<DAE.Statement> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      DAE.Statement i_stmt;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           i_stmt :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls )
      equation
        (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = algStatement(txt, i_stmt, SimCodeFunction.contextFunction, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = lm_700(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);
  end match;
end lm_700;

public function funStatement
  input Tpl.Text txt;
  input list<DAE.Statement> a_statementLst;
  input Tpl.Text a_varDecls;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  out_txt := Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) := lm_700(out_txt, a_statementLst, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls);
  out_txt := Tpl.popIter(out_txt);
end funStatement;

protected function fun_702
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace) :=
  match(in_txt, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Boolean a_useFlatArrayNotation;
      SimCode.SimCode i_simCode;
      SimCode.ExtObjInfo i_extObjInfo;
      Absyn.Path i_modelInfo_name;
      Tpl.Text txt_1;
      Tpl.Text l_externalObjsFuncs;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = i_modelInfo_name), extObjInfo = i_extObjInfo)),
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_useFlatArrayNotation )
      equation
        txt_1 = lastIdentOfPath(Tpl.emptyTxt, i_modelInfo_name);
        txt_1 = Tpl.writeTok(txt_1, Tpl.ST_STRING("Initialize"));
        (l_externalObjsFuncs, txt_1, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = functionExternalObjects(Tpl.emptyTxt, txt_1, i_extObjInfo, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_useFlatArrayNotation);
        txt = Tpl.writeText(txt, l_externalObjsFuncs);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);

    case ( txt,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           _ )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
  end match;
end fun_702;

public function destructExtObjs
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace) := fun_702(txt, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_useFlatArrayNotation);
  out_a_stateDerVectorName := a_stateDerVectorName;
end destructExtObjs;

protected function fun_704
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = _)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "void destructExternalObjects();\n",
                                    "bool _constructedExternalObjects;"
                                }, false));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_704;

public function destructExtObjsDecl
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  out_txt := fun_704(txt, a_simCode);
  out_a_extraFuncs := a_extraFuncs;
  out_a_extraFuncsDecl := a_extraFuncsDecl;
  out_a_extraFuncsNamespace := a_extraFuncsNamespace;
end destructExtObjsDecl;

protected function fun_706
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Absyn.Path in_a_modelInfo_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_modelInfo_name)
    local
      Tpl.Text txt;
      Absyn.Path a_modelInfo_name;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_modelInfo_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = lastIdentOfPath(txt, a_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Initialize::checkParameters()\n",
                                    "{\n",
                                    "   checkParameterVars();\n",
                                    "   checkIntParameterVars();\n",
                                    "   checkBoolParameterVars();\n",
                                    "   checkStringParameterVars();\n",
                                    "}\n",
                                    "\n",
                                    "void "
                                }, false));
        txt = lastIdentOfPath(txt, a_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Initialize::checkVariables()\n",
                                    "{\n",
                                    "   /*check functions are only available if genDebugSymbols was selected*/\n",
                                    "   checkAlgVars();\n",
                                    "   checkDiscreteAlgVars();\n",
                                    "   checkIntAlgVars();\n",
                                    "   checkBoolAlgVars();\n",
                                    "   checkStringAlgVars();\n",
                                    "   //checkStateVars();\n",
                                    "   //checkDerVars();\n",
                                    "}"
                                }, false));
      then txt;
  end match;
end fun_706;

protected function fun_707
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "/*initialize parameter*/\n",
                                    "initializeParameterVars();\n",
                                    "initializeIntParameterVars();\n",
                                    "initializeBoolParameterVars();\n",
                                    "initializeStringParameterVars();\n",
                                    "initializeAlgVars();\n",
                                    "initializeDiscreteAlgVars();\n",
                                    "initializeIntAlgVars();\n",
                                    "initializeBoolAlgVars();\n",
                                    "initializeStateVars();\n",
                                    "initializeDerVars();"
                                }, false));
      then txt;
  end match;
end fun_707;

protected function fun_708
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("//checkParameters();"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("checkParameters();"));
      then txt;
  end match;
end fun_708;

protected function fun_709
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("//checkVariables();"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("checkVariables();"));
      then txt;
  end match;
end fun_709;

protected function lm_710
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) :=
  match(in_txt, in_items, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           {},
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           i_eq :: rest,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls )
      equation
        (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, _) = equation_function_call(txt, i_eq, SimCodeFunction.contextOther, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, Tpl.strTokText(Tpl.ST_STRING("initEquation")));
        txt = Tpl.nextIter(txt);
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = lm_710(txt, rest, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);
  end match;
end lm_710;

protected function lm_711
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) :=
  match(in_txt, in_items, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           {},
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           i_eq :: rest,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls )
      equation
        (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, _) = equation_function_call(txt, i_eq, SimCodeFunction.contextOther, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, Tpl.strTokText(Tpl.ST_STRING("initParameterEquation")));
        txt = Tpl.nextIter(txt);
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = lm_711(txt, rest, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);
  end match;
end lm_711;

protected function fun_712
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_complexStartExpressions;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation, in_a_complexStartExpressions)
    local
      Tpl.Text txt;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_complexStartExpressions;
      SimCode.DelayedExpression i_delayedExps;
      String i_fileNamePrefix;
      SimCode.ModelInfo i_modelInfo;
      list<SimCode.SimEqSystem> i_parameterEquations;
      list<SimCode.ClockedPartition> i_clockedPartitions;
      list<SimCode.SimEqSystem> i_initialEquations;
      list<SimCode.SimEqSystem> i_allEquations;
      list<BackendDAE.ZeroCrossing> i_zeroCrossings;
      SimCode.SimCode i_simCode;
      list<SimCode.SimEqSystem> i_startValueEquations;
      Absyn.Path i_modelInfo_name;
      Boolean ret_33;
      Boolean ret_32;
      Boolean ret_31;
      Boolean ret_30;
      Boolean ret_29;
      Boolean ret_28;
      Boolean ret_27;
      Boolean ret_26;
      Boolean ret_25;
      Boolean ret_24;
      Boolean ret_23;
      Boolean ret_22;
      Boolean ret_21;
      list<SimCode.SimEqSystem> ret_20;
      list<SimCode.SimEqSystem> ret_19;
      list<SimCode.SubPartition> ret_18;
      list<SimCode.SimEqSystem> ret_17;
      list<SimCode.SimEqSystem> ret_16;
      list<SimCode.SimEqSystem> ret_15;
      list<SimCode.SubPartition> ret_14;
      list<SimCode.SimEqSystem> ret_13;
      Tpl.Text l_boundparameterequations;
      Tpl.Text l_initialequations;
      list<SimCode.SimEqSystem> ret_10;
      list<SimCode.SimEqSystem> ret_9;
      list<SimCode.SubPartition> ret_8;
      list<SimCode.SimEqSystem> ret_7;
      Tpl.Text l_initAlgloopSolvers;
      Tpl.Text l_initClockIntervals;
      Tpl.Text l_initEventHandling;
      Tpl.Text l_initZeroCrossings;
      Tpl.Text l_initFunctions;
      Tpl.Text l_modelname;
      Tpl.Text l_varDecls;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = (i_modelInfo as SimCode.MODELINFO(name = i_modelInfo_name)), makefileParams = SimCodeFunction.MAKEFILE_PARAMS(ccompiler = _), startValueEquations = i_startValueEquations, zeroCrossings = i_zeroCrossings, allEquations = i_allEquations, initialEquations = i_initialEquations, clockedPartitions = i_clockedPartitions, parameterEquations = i_parameterEquations, fileNamePrefix = i_fileNamePrefix, delayedExps = i_delayedExps)),
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation,
           a_complexStartExpressions )
      equation
        l_varDecls = Tpl.emptyTxt;
        l_modelname = identOfPathDot(Tpl.emptyTxt, i_modelInfo_name);
        (l_initFunctions, l_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = functionInitial(Tpl.emptyTxt, i_startValueEquations, l_varDecls, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        (l_initZeroCrossings, l_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = functionOnlyZeroCrossing(Tpl.emptyTxt, i_zeroCrossings, l_varDecls, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
        (l_initEventHandling, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = eventHandlingInit(Tpl.emptyTxt, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
        (l_initClockIntervals, l_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = clockIntervalsInit(Tpl.emptyTxt, i_simCode, l_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        ret_7 = listAppend(i_allEquations, i_initialEquations);
        ret_8 = SimCodeUtil.getSubPartitions(i_clockedPartitions);
        ret_9 = SimCodeUtil.getClockedEquations(ret_8);
        ret_10 = listAppend(ret_7, ret_9);
        (l_initAlgloopSolvers, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = initAlgloopsolvers(Tpl.emptyTxt, ret_10, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
        (l_initialequations, _, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = functionInitialEquations(Tpl.emptyTxt, i_initialEquations, Tpl.strTokText(Tpl.ST_STRING("initEquation")), i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation, false, true, false);
        (l_boundparameterequations, _, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = functionInitialEquations(Tpl.emptyTxt, i_parameterEquations, Tpl.strTokText(Tpl.ST_STRING("initParameterEquation")), i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation, false, true, true);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "// convenience function for full initialization\n",
                                    "void "
                                }, false));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Initialize::initialize()\n",
                                    "{\n",
                                    "   initializeMemory();\n",
                                    "   initializeFreeVariables();\n",
                                    "   initializeBoundVariables();\n",
                                    "   saveAll();\n",
                                    "}\n",
                                    "\n",
                                    "void "
                                }, false));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Initialize::initializeMemory()\n",
                                    "{\n",
                                    "   _discrete_events = _event_handling->initialize(this,getSimVars());\n",
                                    "\n",
                                    "   //create and initialize Algloopsolvers\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(3));
        ret_13 = listAppend(i_allEquations, i_initialEquations);
        ret_14 = SimCodeUtil.getSubPartitions(i_clockedPartitions);
        ret_15 = SimCodeUtil.getClockedEquations(ret_14);
        ret_16 = listAppend(ret_13, ret_15);
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = generateAlgloopSystems(txt, ret_16, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
        txt = Tpl.softNewLine(txt);
        ret_17 = listAppend(i_allEquations, i_initialEquations);
        ret_18 = SimCodeUtil.getSubPartitions(i_clockedPartitions);
        ret_19 = SimCodeUtil.getClockedEquations(ret_18);
        ret_20 = listAppend(ret_17, ret_19);
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = generateAlgloopSolvers(txt, i_modelInfo, ret_20, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("WriteOutput::initialize();\n"));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("Jacobian::initialize();\n"));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("Jacobian::initializeColoredJacobianA();\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n"
                                }, true));
        ret_21 = Flags.isSet(Flags.HARDCODED_START_VALUES);
        ret_22 = boolNot(ret_21);
        ret_23 = Flags.isSet(Flags.GEN_DEBUG_SYMBOLS);
        ret_24 = boolAnd(ret_22, ret_23);
        txt = fun_706(txt, ret_24, i_modelInfo_name);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "void "
                                }, false));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Initialize::initializeFreeVariables()\n",
                                    "{\n",
                                    "   #if !defined(FMU_BUILD)\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(5));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_reader  = shared_ptr<IPropertyReader>(new XmlPropertyReader(_global_settings, \""));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_init.xml\"));\n",
                                    "_reader->readInitialValues(*this, getSimVars());\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "   #endif\n",
                                    "\n",
                                    "   _simTime = 0.0;\n",
                                    "   _state_var_reinitialized = false;\n",
                                    "\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(3));
        ret_25 = Flags.isSet(Flags.HARDCODED_START_VALUES);
        txt = fun_707(txt, ret_25);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "#if defined(__TRICORE__) || defined(__vxworks)\n",
                                    "   //init inputs\n",
                                    "   stepStarted(0.0);\n",
                                    "#endif\n",
                                    "\n",
                                    "   /*Start complex expressions */\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(3));
        txt = Tpl.writeText(txt, a_complexStartExpressions);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/* End complex expression */\n"));
        ret_26 = Flags.isSet(Flags.HARDCODED_START_VALUES);
        ret_27 = boolNot(ret_26);
        ret_28 = Flags.isSet(Flags.GEN_DEBUG_SYMBOLS);
        ret_29 = boolAnd(ret_27, ret_28);
        txt = fun_708(txt, ret_29);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("                                                                                //delete reader;\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n",
                                    "void "
                                }, false));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Initialize::initializeBoundVariables()\n",
                                    "{\n",
                                    "   //variable decls\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(3));
        txt = Tpl.writeText(txt, l_varDecls);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "//destruct external objects if already constructed in a previous call\n",
                                    "if (_constructedExternalObjects)\n",
                                    "  destructExternalObjects();\n",
                                    "\n",
                                    "initParameterEquations();\n",
                                    "\n",
                                    "//mark external objects constructed during initParameterEquations\n",
                                    "_constructedExternalObjects = true;\n",
                                    "\n",
                                    "//bound start values\n"
                                }, true));
        txt = Tpl.writeText(txt, l_initFunctions);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "//init event handling\n"
                                }, true));
        txt = Tpl.writeText(txt, l_initEventHandling);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_initClockIntervals);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "//init equations\n",
                                    "initEquations();\n",
                                    "\n",
                                    "for(int i = 0; i < _dimZeroFunc; i++)\n",
                                    "{\n",
                                    "   getCondition(i);\n",
                                    "}\n",
                                    "\n",
                                    "//initialAnalyticJacobian();\n",
                                    "\n"
                                }, true));
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = functionInitDelay(txt, i_delayedExps, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        ret_30 = Flags.isSet(Flags.HARDCODED_START_VALUES);
        ret_31 = boolNot(ret_30);
        ret_32 = Flags.isSet(Flags.GEN_DEBUG_SYMBOLS);
        ret_33 = boolAnd(ret_31, ret_32);
        txt = fun_709(txt, ret_33);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n",
                                    "void "
                                }, false));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Initialize::initEquations()\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(3));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, l_varDecls) = lm_710(txt, i_initialEquations, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, i_simCode, l_varDecls);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("}\n"));
        txt = Tpl.writeText(txt, l_initialequations);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Initialize::initParameterEquations()\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(3));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, l_varDecls) = lm_711(txt, i_parameterEquations, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, i_simCode, l_varDecls);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("}\n"));
        txt = Tpl.writeText(txt, l_boundparameterequations);
        txt = Tpl.softNewLine(txt);
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = init2(txt, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, i_modelInfo, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _,
           _ )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end fun_712;

public function init
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;
  input Tpl.Text a_complexStartExpressions;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_complexStartExpressions;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) := fun_712(txt, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation, a_complexStartExpressions);
  out_a_complexStartExpressions := a_complexStartExpressions;
end init;

protected function fun_714
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("check"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("initialize"));
      then txt;
  end match;
end fun_714;

protected function fun_715
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_init2;
  input Tpl.Text in_a_varDecls2;
  input Tpl.Text in_a_init1;
  input Tpl.Text in_a_varDecls1;
  input Tpl.Text in_a_functionPrefix;
  input Absyn.Path in_a_modelInfo_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_init2, in_a_varDecls2, in_a_init1, in_a_varDecls1, in_a_functionPrefix, in_a_modelInfo_name)
    local
      Tpl.Text txt;
      Tpl.Text a_init2;
      Tpl.Text a_varDecls2;
      Tpl.Text a_init1;
      Tpl.Text a_varDecls1;
      Tpl.Text a_functionPrefix;
      Absyn.Path a_modelInfo_name;

    case ( txt,
           false,
           _,
           _,
           _,
           _,
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_init2,
           a_varDecls2,
           a_init1,
           a_varDecls1,
           a_functionPrefix,
           a_modelInfo_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = lastIdentOfPath(txt, a_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Initialize::"));
        txt = Tpl.writeText(txt, a_functionPrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "StateVars()\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.writeText(txt, a_varDecls1);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, a_init1);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "void "
                                }, false));
        txt = lastIdentOfPath(txt, a_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Initialize::"));
        txt = Tpl.writeText(txt, a_functionPrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "DerVars()\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.writeText(txt, a_varDecls2);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, a_init2);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;
  end match;
end fun_715;

protected function fun_716
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_modelInfo, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      Absyn.Path i_modelInfo_name;
      list<SimCodeVar.SimVar> i_vars_derivativeVars;
      list<SimCodeVar.SimVar> i_vars_stateVars;
      Boolean ret_8;
      Boolean ret_7;
      Boolean ret_6;
      Tpl.Text l_init2;
      Tpl.Text l_init1;
      Boolean ret_3;
      Tpl.Text l_functionPrefix;
      Tpl.Text l_varDecls2;
      Tpl.Text l_varDecls1;

    case ( txt,
           SimCode.MODELINFO(vars = SimCodeVar.SIMVARS(stateVars = i_vars_stateVars, derivativeVars = i_vars_derivativeVars), name = i_modelInfo_name),
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_varDecls1 = Tpl.emptyTxt;
        l_varDecls2 = Tpl.emptyTxt;
        ret_3 = Flags.isSet(Flags.HARDCODED_START_VALUES);
        l_functionPrefix = fun_714(Tpl.emptyTxt, ret_3);
        (l_init1, l_varDecls1, _, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = initValst(Tpl.emptyTxt, l_varDecls1, Tpl.strTokText(Tpl.ST_STRING("Real")), i_vars_stateVars, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, SimCodeFunction.contextOther, a_stateDerVectorName, a_useFlatArrayNotation);
        (l_init2, l_varDecls2, _, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = initValst(Tpl.emptyTxt, l_varDecls2, Tpl.strTokText(Tpl.ST_STRING("Real")), i_vars_derivativeVars, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, SimCodeFunction.contextOther, a_stateDerVectorName, a_useFlatArrayNotation);
        ret_6 = Flags.isSet(Flags.HARDCODED_START_VALUES);
        ret_7 = Flags.isSet(Flags.GEN_DEBUG_SYMBOLS);
        ret_8 = boolOr(ret_6, ret_7);
        txt = fun_715(txt, ret_8, l_init2, l_varDecls2, l_init1, l_varDecls1, l_functionPrefix, i_modelInfo_name);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end fun_716;

public function init2
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input SimCode.ModelInfo a_modelInfo;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) := fun_716(txt, a_modelInfo, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
end init2;

protected function lm_718
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Boolean a_useFlatArrayNotation;
      DAE.ComponentRef i_var_name;
      Absyn.Path i_ext_fullClassName;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(varKind = BackendDAE.EXTOBJ(fullClassName = i_ext_fullClassName), initialValue = SOME(_), name = i_var_name) :: rest,
           a_useFlatArrayNotation )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_functions->"));
        txt = CodegenUtil.underscorePath(txt, i_ext_fullClassName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_destructor("));
        txt = CodegenCppCommonOld.cref(txt, i_var_name, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
        txt = Tpl.nextIter(txt);
        txt = lm_718(txt, rest, a_useFlatArrayNotation);
      then txt;

    case ( txt,
           _ :: rest,
           a_useFlatArrayNotation )
      equation
        txt = lm_718(txt, rest, a_useFlatArrayNotation);
      then txt;
  end match;
end lm_718;

protected function fun_719
  input Tpl.Text in_txt;
  input SimCode.ExtObjInfo in_a_extObjInfo;
  input Tpl.Text in_a_className;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_extObjInfo, in_a_className, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      Tpl.Text a_className;
      Boolean a_useFlatArrayNotation;
      list<SimCodeVar.SimVar> i_vars;
      Tpl.Text l_dtorCalls;

    case ( txt,
           SimCode.EXTOBJINFO(vars = i_vars),
           a_className,
           a_useFlatArrayNotation )
      equation
        l_dtorCalls = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_dtorCalls = lm_718(l_dtorCalls, i_vars, a_useFlatArrayNotation);
        l_dtorCalls = Tpl.popIter(l_dtorCalls);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = Tpl.writeText(txt, a_className);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::destructExternalObjects()\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_dtorCalls);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_719;

public function functionExternalObjects
  input Tpl.Text txt;
  input Tpl.Text a_className;
  input SimCode.ExtObjInfo a_extObjInfo;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_className;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  out_txt := fun_719(txt, a_extObjInfo, a_className, a_useFlatArrayNotation);
  out_a_className := a_className;
  out_a_extraFuncs := a_extraFuncs;
  out_a_extraFuncsDecl := a_extraFuncsDecl;
  out_a_extraFuncsNamespace := a_extraFuncsNamespace;
end functionExternalObjects;

protected function lm_721
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input Boolean in_a_overwriteOldStartValues;
  input Boolean in_a_assignToStartValues;
  input Boolean in_a_createMeasureTime;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_methodName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_methodName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_methodName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_overwriteOldStartValues, in_a_assignToStartValues, in_a_createMeasureTime, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_methodName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      Boolean a_overwriteOldStartValues;
      Boolean a_assignToStartValues;
      Boolean a_createMeasureTime;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_methodName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           {},
           _,
           _,
           _,
           _,
           a_stateDerVectorName,
           a_methodName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_stateDerVectorName, a_methodName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           i_eq :: rest,
           a_overwriteOldStartValues,
           a_assignToStartValues,
           a_createMeasureTime,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_methodName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_methodName, _, a_stateDerVectorName) = equation_function_create_single_func(txt, i_eq, SimCodeFunction.contextOther, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_methodName, Tpl.strTokText(Tpl.ST_STRING("Initialize")), a_stateDerVectorName, a_useFlatArrayNotation, a_createMeasureTime, a_assignToStartValues, a_overwriteOldStartValues, "");
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_methodName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_721(txt, rest, a_overwriteOldStartValues, a_assignToStartValues, a_createMeasureTime, a_useFlatArrayNotation, a_stateDerVectorName, a_methodName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_stateDerVectorName, a_methodName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_721;

public function functionInitialEquations
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_initalEquations;
  input Tpl.Text a_methodName;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;
  input Boolean a_createMeasureTime;
  input Boolean a_assignToStartValues;
  input Boolean a_overwriteOldStartValues;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_methodName;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
protected
  Tpl.Text l_equation__func__calls;
algorithm
  l_equation__func__calls := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (l_equation__func__calls, out_a_stateDerVectorName, out_a_methodName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) := lm_721(l_equation__func__calls, a_initalEquations, a_overwriteOldStartValues, a_assignToStartValues, a_createMeasureTime, a_useFlatArrayNotation, a_stateDerVectorName, a_methodName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
  l_equation__func__calls := Tpl.popIter(l_equation__func__calls);
  out_txt := Tpl.writeText(txt, l_equation__func__calls);
end functionInitialEquations;

protected function fun_723
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_clockIndex;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_clockIndex)
    local
      Tpl.Text txt;
      Integer a_clockIndex;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_clockIndex )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("const int clockIndex = "));
        txt = Tpl.writeStr(txt, intString(a_clockIndex));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_723;

protected function fun_724
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_clockIndex;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_clockIndex)
    local
      Tpl.Text txt;
      Integer a_clockIndex;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_clockIndex )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("const int clockIndex = "));
        txt = Tpl.writeStr(txt, intString(a_clockIndex));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_724;

protected function fun_725
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_clockIndex;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_clockIndex)
    local
      Tpl.Text txt;
      Integer a_clockIndex;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_clockIndex )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("const int clockIndex = "));
        txt = Tpl.writeStr(txt, intString(a_clockIndex));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_725;

protected function fun_726
  input Tpl.Text in_txt;
  input Option<SimCode.JacobianMatrix> in_a_ls_jacobianMatrix;
  input Integer in_a_clockIndex;
  input Integer in_a_ls_index;
  input Tpl.Text in_a_modelname;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ls_jacobianMatrix, in_a_clockIndex, in_a_ls_index, in_a_modelname)
    local
      Tpl.Text txt;
      Integer a_clockIndex;
      Integer a_ls_index;
      Tpl.Text a_modelname;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           SOME(_),
           a_clockIndex,
           a_ls_index,
           a_modelname )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = Tpl.writeText(txt, a_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::initialize()\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        ret_0 = intGt(a_clockIndex, 0);
        txt = fun_724(txt, ret_0, a_clockIndex);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;

    case ( txt,
           _,
           a_clockIndex,
           a_ls_index,
           a_modelname )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "void "
                                }, false));
        txt = Tpl.writeText(txt, a_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::initialize()\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        ret_1 = intGt(a_clockIndex, 0);
        txt = fun_725(txt, ret_1, a_clockIndex);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;
  end match;
end fun_726;

protected function fun_727
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input Integer in_a_clockIndex;
  input Tpl.Text in_a_modelname;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_eq, in_a_clockIndex, in_a_modelname)
    local
      Tpl.Text txt;
      Integer a_clockIndex;
      Tpl.Text a_modelname;
      Integer i_ls_index;
      Option<SimCode.JacobianMatrix> i_ls_jacobianMatrix;
      Integer i_nls_index;
      Boolean ret_2;
      Tpl.Text l_preExp;
      Tpl.Text l_varDecls;

    case ( txt,
           SimCode.SES_NONLINEAR(nlSystem = SimCode.NONLINEARSYSTEM(index = i_nls_index)),
           a_clockIndex,
           a_modelname )
      equation
        l_varDecls = Tpl.emptyTxt;
        l_preExp = Tpl.emptyTxt;
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = Tpl.writeText(txt, a_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeStr(txt, intString(i_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::initialize()\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        ret_2 = intGt(a_clockIndex, 0);
        txt = fun_723(txt, ret_2, a_clockIndex);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " if(_firstcall)\n",
                                    " {\n",
                                    "    getReal(_x0);\n",
                                    "   _firstcall=false;\n",
                                    "  }\n",
                                    "\n",
                                    "}"
                                }, false));
      then txt;

    case ( txt,
           SimCode.SES_LINEAR(lSystem = SimCode.LINEARSYSTEM(jacobianMatrix = i_ls_jacobianMatrix, index = i_ls_index)),
           a_clockIndex,
           a_modelname )
      equation
        txt = fun_726(txt, i_ls_jacobianMatrix, a_clockIndex, i_ls_index, a_modelname);
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_727;

protected function fun_728
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input SimCode.SimEqSystem in_a_eq;
  input Integer in_a_clockIndex;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode, in_a_eq, in_a_clockIndex)
    local
      Tpl.Text txt;
      SimCode.SimEqSystem a_eq;
      Integer a_clockIndex;
      Absyn.Path i_modelInfo_name;
      Tpl.Text l_modelname;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = i_modelInfo_name)),
           a_eq,
           a_clockIndex )
      equation
        l_modelname = lastIdentOfPath(Tpl.emptyTxt, i_modelInfo_name);
        txt = fun_727(txt, a_eq, a_clockIndex, l_modelname);
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_728;

public function initAlgloop
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input SimCode.SimEqSystem a_eq;
  input SimCodeFunction.Context a_context;
  input Integer a_clockIndex;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  out_txt := fun_728(txt, a_simCode, a_eq, a_clockIndex);
  out_a_extraFuncs := a_extraFuncs;
  out_a_extraFuncsDecl := a_extraFuncsDecl;
  out_a_extraFuncsNamespace := a_extraFuncsNamespace;
  out_a_stateDerVectorName := a_stateDerVectorName;
end initAlgloop;

protected function fun_730
  input Tpl.Text in_txt;
  input Option<SimCode.JacobianMatrix> in_a_ls_jacobianMatrix;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input SimCode.SimEqSystem in_a_eq;
  input Integer in_a_ls_index;
  input Tpl.Text in_a_modelname;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_a_ls_jacobianMatrix, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_context, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_eq, in_a_ls_index, in_a_modelname)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      SimCodeFunction.Context a_context;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      SimCode.SimEqSystem a_eq;
      Integer a_ls_index;
      Tpl.Text a_modelname;

    case ( txt,
           SOME(_),
           _,
           a_stateDerVectorName,
           _,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_context,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_eq,
           a_ls_index,
           a_modelname )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("  template <typename T>\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = Tpl.writeText(txt, a_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::initialize(T *__A)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(3));
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = initAlgloopEquation(txt, a_eq, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_context, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "// Update the equations once before start of simulation\n",
                                    "evaluate();\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
        txt = Tpl.popBlock(txt);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_730;

protected function fun_731
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_modelname;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_a_eq, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_context, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_modelname)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      SimCodeFunction.Context a_context;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_modelname;
      SimCode.SimEqSystem i_eq;
      Integer i_ls_index;
      Option<SimCode.JacobianMatrix> i_ls_jacobianMatrix;

    case ( txt,
           (i_eq as SimCode.SES_LINEAR(lSystem = SimCode.LINEARSYSTEM(jacobianMatrix = i_ls_jacobianMatrix, index = i_ls_index))),
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_context,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_modelname )
      equation
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_730(txt, i_ls_jacobianMatrix, a_useFlatArrayNotation, a_stateDerVectorName, a_context, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, i_eq, i_ls_index, a_modelname);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           _,
           a_stateDerVectorName,
           _,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_731;

public function initAlgloopTemplate
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input SimCode.SimEqSystem in_a_eq;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_eq, in_a_context, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      SimCode.SimEqSystem a_eq;
      SimCodeFunction.Context a_context;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      SimCode.SimCode i_simCode;
      Absyn.Path i_modelInfo_name;
      Tpl.Text l_modelname;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = i_modelInfo_name))),
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_eq,
           a_context,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_modelname = lastIdentOfPath(Tpl.emptyTxt, i_modelInfo_name);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_731(txt, a_eq, a_useFlatArrayNotation, a_stateDerVectorName, a_context, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, i_simCode, l_modelname);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           _,
           _,
           a_stateDerVectorName,
           _ )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end initAlgloopTemplate;

protected function fun_733
  input Tpl.Text in_txt;
  input String in_mArg;
  input Integer in_a_index;
  input Tpl.Text in_a_modelName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_index, in_a_modelName)
    local
      Tpl.Text txt;
      Integer a_index;
      Tpl.Text a_modelName;

    case ( txt,
           "dense",
           a_index,
           a_modelName )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("return static_cast<"));
        txt = Tpl.writeText(txt, a_modelName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Mixed*>(_system)->getJacobian("));
        txt = Tpl.writeStr(txt, intString(a_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;

    case ( txt,
           "sparse",
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("throw ModelicaSimulationError(MATH_FUNCTION, \"Dense matrix is not activated\");"));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("A matrix type is not supported"));
      then txt;
  end match;
end fun_733;

protected function fun_734
  input Tpl.Text in_txt;
  input String in_mArg;
  input Integer in_a_index;
  input Tpl.Text in_a_modelName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_index, in_a_modelName)
    local
      Tpl.Text txt;
      Integer a_index;
      Tpl.Text a_modelName;

    case ( txt,
           "dense",
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("throw ModelicaSimulationError(MATH_FUNCTION, \"Sparse matrix is not activated\");"));
      then txt;

    case ( txt,
           "sparse",
           a_index,
           a_modelName )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("return static_cast<"));
        txt = Tpl.writeText(txt, a_modelName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Mixed*>(_system)->getSparseJacobian("));
        txt = Tpl.writeStr(txt, intString(a_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("A matrix type is not supported"));
      then txt;
  end match;
end fun_734;

protected function fun_735
  input Tpl.Text in_txt;
  input String in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           "dense" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("return __A;"));
      then txt;

    case ( txt,
           "sparse" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("throw ModelicaSimulationError(MATH_FUNCTION, \"Dense matrix is not activated\");"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("A matrix type is not supported"));
      then txt;
  end match;
end fun_735;

protected function fun_736
  input Tpl.Text in_txt;
  input String in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           "dense" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("throw ModelicaSimulationError(MATH_FUNCTION, \"Sparse matrix is not activated\");"));
      then txt;

    case ( txt,
           "sparse" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("return __A;"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("A matrix type is not supported"));
      then txt;
  end match;
end fun_736;

protected function fun_737
  input Tpl.Text in_txt;
  input Option<SimCode.JacobianMatrix> in_a_ls_jacobianMatrix;
  input Integer in_a_ls_index;
  input Tpl.Text in_a_modelName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ls_jacobianMatrix, in_a_ls_index, in_a_modelName)
    local
      Tpl.Text txt;
      Integer a_ls_index;
      Tpl.Text a_modelName;
      Integer i_index;
      String str_8;
      String str_7;
      String ret_6;
      String str_5;
      Tpl.Text l_getSparseMatrix;
      String str_3;
      Tpl.Text l_getDenseMatrix;
      String ret_1;
      Tpl.Text l_type;

    case ( txt,
           SOME(SimCode.JAC_MATRIX(jacobianIndex = i_index)),
           a_ls_index,
           a_modelName )
      equation
        ret_1 = Flags.getConfigString(Flags.MATRIX_FORMAT);
        l_type = Tpl.writeStr(Tpl.emptyTxt, ret_1);
        str_3 = Tpl.textString(l_type);
        l_getDenseMatrix = fun_733(Tpl.emptyTxt, str_3, i_index, a_modelName);
        str_5 = Tpl.textString(l_type);
        l_getSparseMatrix = fun_734(Tpl.emptyTxt, str_5, i_index, a_modelName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "const matrix_t& "
                                }, false));
        txt = Tpl.writeText(txt, a_modelName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::getAMatrix()\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_getDenseMatrix);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n",
                                    "sparsematrix_t& "
                                }, false));
        txt = Tpl.writeText(txt, a_modelName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::getSparseAMatrix( )\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_getSparseMatrix);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;

    case ( txt,
           _,
           a_ls_index,
           a_modelName )
      equation
        ret_6 = Flags.getConfigString(Flags.MATRIX_FORMAT);
        l_type = Tpl.writeStr(Tpl.emptyTxt, ret_6);
        str_7 = Tpl.textString(l_type);
        l_getDenseMatrix = fun_735(Tpl.emptyTxt, str_7);
        str_8 = Tpl.textString(l_type);
        l_getSparseMatrix = fun_736(Tpl.emptyTxt, str_8);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "const matrix_t& "
                                }, false));
        txt = Tpl.writeText(txt, a_modelName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::getAMatrix()\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_getDenseMatrix);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n",
                                    "sparsematrix_t& "
                                }, false));
        txt = Tpl.writeText(txt, a_modelName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::getSparseAMatrix()\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_getSparseMatrix);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;
  end match;
end fun_737;

protected function fun_738
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input Tpl.Text in_a_modelName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_eq, in_a_modelName)
    local
      Tpl.Text txt;
      Tpl.Text a_modelName;
      Integer i_ls_index;
      Option<SimCode.JacobianMatrix> i_ls_jacobianMatrix;
      Integer i_index;
      Integer i_nls_index;

    case ( txt,
           SimCode.SES_NONLINEAR(nlSystem = SimCode.NONLINEARSYSTEM(jacobianMatrix = SOME(SimCode.JAC_MATRIX(columns = {})), index = i_nls_index)),
           a_modelName )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "const matrix_t& "
                                }, false));
        txt = Tpl.writeText(txt, a_modelName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeStr(txt, intString(i_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::getSystemMatrix()\n",
                                    "{\n",
                                    "  // return empty matrix to indicate that no symbolic Jacobian is available\n",
                                    "  static matrix_t empty(0, 0);\n",
                                    "  return empty;\n",
                                    "}\n",
                                    "\n",
                                    "sparsematrix_t& "
                                }, false));
        txt = Tpl.writeText(txt, a_modelName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeStr(txt, intString(i_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::getSystemSparseMatrix()\n",
                                    "{\n",
                                    "  throw ModelicaSimulationError(MATH_FUNCTION, \"Sparse symbolic Jacobian is not suported yet\");\n",
                                    "}"
                                }, false));
      then txt;

    case ( txt,
           SimCode.SES_NONLINEAR(nlSystem = SimCode.NONLINEARSYSTEM(jacobianMatrix = SOME(SimCode.JAC_MATRIX(jacobianIndex = i_index)), index = i_nls_index)),
           a_modelName )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "const matrix_t& "
                                }, false));
        txt = Tpl.writeText(txt, a_modelName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeStr(txt, intString(i_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::getSystemMatrix()\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("return static_cast<"));
        txt = Tpl.writeText(txt, a_modelName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Mixed*>(_system)->getJacobian("));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(");\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n",
                                    "sparsematrix_t& "
                                }, false));
        txt = Tpl.writeText(txt, a_modelName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeStr(txt, intString(i_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::getSystemSparseMatrix()\n",
                                    "{\n",
                                    "  throw ModelicaSimulationError(MATH_FUNCTION, \"Sparse symbolic Jacobian is not suported yet\");\n",
                                    "}"
                                }, false));
      then txt;

    case ( txt,
           SimCode.SES_NONLINEAR(nlSystem = SimCode.NONLINEARSYSTEM(index = i_nls_index)),
           a_modelName )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "const matrix_t& "
                                }, false));
        txt = Tpl.writeText(txt, a_modelName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeStr(txt, intString(i_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::getSystemMatrix()\n",
                                    "{\n",
                                    "  // return empty matrix to indicate that no symbolic Jacobian is available\n",
                                    "  static matrix_t empty(0, 0);\n",
                                    "  return empty;\n",
                                    "}\n",
                                    "\n",
                                    "sparsematrix_t& "
                                }, false));
        txt = Tpl.writeText(txt, a_modelName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeStr(txt, intString(i_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::getSystemSparseMatrix()\n",
                                    "{\n",
                                    "  throw ModelicaSimulationError(MATH_FUNCTION, \"Sparse symbolic Jacobian is not suported yet\");\n",
                                    "}"
                                }, false));
      then txt;

    case ( txt,
           SimCode.SES_LINEAR(lSystem = SimCode.LINEARSYSTEM(jacobianMatrix = i_ls_jacobianMatrix, index = i_ls_index)),
           a_modelName )
      equation
        txt = fun_737(txt, i_ls_jacobianMatrix, i_ls_index, a_modelName);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_738;

protected function fun_739
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input SimCode.SimEqSystem in_a_eq;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode, in_a_eq)
    local
      Tpl.Text txt;
      SimCode.SimEqSystem a_eq;
      Absyn.Path i_modelInfo_name;
      Tpl.Text l_modelName;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = i_modelInfo_name)),
           a_eq )
      equation
        l_modelName = lastIdentOfPath(Tpl.emptyTxt, i_modelInfo_name);
        txt = fun_738(txt, a_eq, l_modelName);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_739;

public function getAMatrixCode
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input SimCode.SimEqSystem a_eq;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  out_txt := fun_739(txt, a_simCode, a_eq);
  out_a_extraFuncs := a_extraFuncs;
  out_a_extraFuncsDecl := a_extraFuncsDecl;
  out_a_extraFuncsNamespace := a_extraFuncsNamespace;
end getAMatrixCode;

protected function fun_741
  input Tpl.Text in_txt;
  input Option<SimCode.JacobianMatrix> in_a_ls_jacobianMatrix;
  input Integer in_a_ls_index;
  input Tpl.Text in_a_modelname;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ls_jacobianMatrix, in_a_ls_index, in_a_modelname)
    local
      Tpl.Text txt;
      Integer a_ls_index;
      Tpl.Text a_modelname;

    case ( txt,
           SOME(_),
           a_ls_index,
           a_modelname )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = Tpl.writeText(txt, a_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::getb(double* residuals) const\n",
                                    "{\n",
                                    "   LinearAlgLoopDefaultImplementation::getb(residuals);\n",
                                    "}\n",
                                    "\n"
                                }, true));
      then txt;

    case ( txt,
           _,
           a_ls_index,
           a_modelname )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = Tpl.writeText(txt, a_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::getb(double* residuals) const\n",
                                    "{\n",
                                    "  memcpy(residuals,__b.getData(),sizeof(double)* _dimAEq);\n",
                                    "}"
                                }, false));
      then txt;
  end match;
end fun_741;

protected function fun_742
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input Tpl.Text in_a_modelname;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_eq, in_a_modelname)
    local
      Tpl.Text txt;
      Tpl.Text a_modelname;
      Integer i_ls_index;
      Option<SimCode.JacobianMatrix> i_ls_jacobianMatrix;
      Integer i_nls_index;

    case ( txt,
           SimCode.SES_NONLINEAR(nlSystem = SimCode.NONLINEARSYSTEM(index = i_nls_index)),
           a_modelname )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = Tpl.writeText(txt, a_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeStr(txt, intString(i_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::getRHS(double* residuals) const\n",
                                    "{\n",
                                    "     NonLinearAlgLoopDefaultImplementation::getRHS(residuals);\n",
                                    "}\n",
                                    "\n"
                                }, true));
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           SimCode.SES_LINEAR(lSystem = SimCode.LINEARSYSTEM(jacobianMatrix = i_ls_jacobianMatrix, index = i_ls_index)),
           a_modelname )
      equation
        txt = fun_741(txt, i_ls_jacobianMatrix, i_ls_index, a_modelname);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_742;

protected function fun_743
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input SimCode.SimEqSystem in_a_eq;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode, in_a_eq)
    local
      Tpl.Text txt;
      SimCode.SimEqSystem a_eq;
      Absyn.Path i_modelInfo_name;
      Tpl.Text l_preExp;
      Tpl.Text l_varDecls;
      Tpl.Text l_modelname;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = i_modelInfo_name)),
           a_eq )
      equation
        l_modelname = lastIdentOfPath(Tpl.emptyTxt, i_modelInfo_name);
        l_varDecls = Tpl.emptyTxt;
        l_preExp = Tpl.emptyTxt;
        txt = fun_742(txt, a_eq, l_modelname);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_743;

public function algloopRHSCode
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input SimCode.SimEqSystem a_eq;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  out_txt := fun_743(txt, a_simCode, a_eq);
  out_a_extraFuncs := a_extraFuncs;
  out_a_extraFuncsDecl := a_extraFuncsDecl;
  out_a_extraFuncsNamespace := a_extraFuncsNamespace;
end algloopRHSCode;

protected function fun_745
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_modelname;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_a_eq, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_modelname)
    local
      Tpl.Text txt;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_modelname;
      SimCode.SimEqSystem i_cont;
      Integer i_nls_index;
      Integer i_ls_index;

    case ( txt,
           SimCode.SES_LINEAR(lSystem = SimCode.LINEARSYSTEM(index = i_ls_index)),
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_modelname )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = Tpl.writeText(txt, a_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeStr(txt, intString(i_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::getb(double* vars) const\n",
                                    "{\n",
                                    "  LinearAlgLoopDefaultImplementation::getb(vars);\n",
                                    "}"
                                }, false));
        txt = Tpl.popBlock(txt);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           SimCode.SES_NONLINEAR(nlSystem = SimCode.NONLINEARSYSTEM(index = i_nls_index)),
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_modelname )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "void "
                                }, false));
        txt = Tpl.writeText(txt, a_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeStr(txt, intString(i_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::getRHS(double* vars) const\n",
                                    "{\n",
                                    "  NonLinearAlgLoopDefaultImplementation::getRHS(vars);\n",
                                    "}"
                                }, false));
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           SimCode.SES_MIXED(cont = i_cont),
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           _ )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = algloopResiduals(txt, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, i_cont);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_745;

public function algloopResiduals
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input SimCode.SimEqSystem in_a_eq;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace) :=
  match(in_txt, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_eq)
    local
      Tpl.Text txt;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      SimCode.SimEqSystem a_eq;
      SimCode.SimCode i_simCode;
      Absyn.Path i_modelInfo_name;
      Tpl.Text l_modelname;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = i_modelInfo_name))),
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_eq )
      equation
        l_modelname = lastIdentOfPath(Tpl.emptyTxt, i_modelInfo_name);
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_745(txt, a_eq, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, i_simCode, l_modelname);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);

    case ( txt,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           _ )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
  end match;
end algloopResiduals;

protected function fun_747
  input Tpl.Text in_txt;
  input Option<SimCode.JacobianMatrix> in_a_ls_jacobianMatrix;
  input Integer in_a_ls_index;
  input Tpl.Text in_a_modelname;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ls_jacobianMatrix, in_a_ls_index, in_a_modelname)
    local
      Tpl.Text txt;
      Integer a_ls_index;
      Tpl.Text a_modelname;

    case ( txt,
           SOME(_),
           a_ls_index,
           a_modelname )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "bool "
                                }, false));
        txt = Tpl.writeText(txt, a_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::isLinearTearing()\n",
                                    "{\n",
                                    "  return true;\n",
                                    "}"
                                }, false));
      then txt;

    case ( txt,
           _,
           a_ls_index,
           a_modelname )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "bool "
                                }, false));
        txt = Tpl.writeText(txt, a_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::isLinearTearing()\n",
                                    "{\n",
                                    "  return false;\n",
                                    "}"
                                }, false));
      then txt;
  end match;
end fun_747;

protected function fun_748
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input Tpl.Text in_a_modelname;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_eq, in_a_modelname)
    local
      Tpl.Text txt;
      Tpl.Text a_modelname;
      Integer i_ls_index;
      Option<SimCode.JacobianMatrix> i_ls_jacobianMatrix;
      Integer i_nls_index;

    case ( txt,
           SimCode.SES_NONLINEAR(nlSystem = SimCode.NONLINEARSYSTEM(index = i_nls_index)),
           a_modelname )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "bool "
                                }, false));
        txt = Tpl.writeText(txt, a_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeStr(txt, intString(i_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::isLinearTearing()\n",
                                    "{\n",
                                    "  return false;\n",
                                    "}"
                                }, false));
      then txt;

    case ( txt,
           SimCode.SES_LINEAR(lSystem = SimCode.LINEARSYSTEM(jacobianMatrix = i_ls_jacobianMatrix, index = i_ls_index)),
           a_modelname )
      equation
        txt = fun_747(txt, i_ls_jacobianMatrix, i_ls_index, a_modelname);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_748;

protected function fun_749
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input SimCode.SimEqSystem in_a_eq;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode, in_a_eq)
    local
      Tpl.Text txt;
      SimCode.SimEqSystem a_eq;
      Absyn.Path i_modelInfo_name;
      Tpl.Text l_preExp;
      Tpl.Text l_varDecls;
      Tpl.Text l_modelname;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = i_modelInfo_name)),
           a_eq )
      equation
        l_modelname = lastIdentOfPath(Tpl.emptyTxt, i_modelInfo_name);
        l_varDecls = Tpl.emptyTxt;
        l_preExp = Tpl.emptyTxt;
        txt = fun_748(txt, a_eq, l_modelname);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_749;

public function isLinearTearingCode
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input SimCode.SimEqSystem a_eq;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  out_txt := fun_749(txt, a_simCode, a_eq);
  out_a_extraFuncs := a_extraFuncs;
  out_a_extraFuncsDecl := a_extraFuncsDecl;
  out_a_extraFuncsNamespace := a_extraFuncsNamespace;
end isLinearTearingCode;

protected function lm_751
  input Tpl.Text in_txt;
  input list<DAE.ComponentRef> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.ComponentRef> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      SimCodeFunction.Context a_context;
      Integer x_i0;
      DAE.ComponentRef i_name;
      Tpl.Text l_namestr;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           i_name :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_context )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        (l_namestr, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.contextCref(Tpl.emptyTxt, i_name, a_context, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_res["));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = "));
        txt = Tpl.writeText(txt, l_namestr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_751(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_context);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_751;

protected function lm_752
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_context, in_a_varDecls)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      SimCodeFunction.Context a_context;
      Tpl.Text a_varDecls;
      SimCode.SimEqSystem i_eq2;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _,
           a_varDecls )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           i_eq2 :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_context,
           a_varDecls )
      equation
        (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = functionExtraResidualsPreBody(txt, i_eq2, a_varDecls, a_context, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = lm_752(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_context, a_varDecls);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);
  end match;
end lm_752;

protected function lm_753
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_context)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      SimCodeFunction.Context a_context;
      Integer x_i0;
      DAE.Exp i_eq2_exp;
      Tpl.Text l_expPart;
      Tpl.Text l_preExp;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           SimCode.SES_RESIDUAL(exp = i_eq2_exp) :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_context )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        l_preExp = Tpl.emptyTxt;
        (l_expPart, l_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.daeExp(Tpl.emptyTxt, i_eq2_exp, a_context, l_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_b["));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = "));
        txt = Tpl.writeText(txt, l_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = lm_753(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_context);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           _ :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_context )
      equation
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = lm_753(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_context);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);
  end match;
end lm_753;

protected function lm_754
  input Tpl.Text in_txt;
  input list<tuple<Integer, Integer, SimCode.SimEqSystem>> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_context)
    local
      Tpl.Text txt;
      list<tuple<Integer, Integer, SimCode.SimEqSystem>> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      SimCodeFunction.Context a_context;
      Integer i_col;
      Integer i_row;
      DAE.Exp i_eq_exp;
      Tpl.Text l_expPart;
      Tpl.Text l_preExp;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           (i_row, i_col, SimCode.SES_RESIDUAL(exp = i_eq_exp)) :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_context )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_expPart, l_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.daeExp(Tpl.emptyTxt, i_eq_exp, a_context, l_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("__A("));
        txt = Tpl.writeStr(txt, intString(i_row));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeStr(txt, intString(i_col));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")="));
        txt = Tpl.writeText(txt, l_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = lm_754(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_context);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           _ :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_context )
      equation
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = lm_754(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_context);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);
  end match;
end lm_754;

protected function lm_755
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      SimCodeFunction.Context a_context;
      Integer x_i0;
      DAE.Exp i_exp;
      Tpl.Text l_expPart;
      Tpl.Text l_preExp;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           i_exp :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_context )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        l_preExp = Tpl.emptyTxt;
        (l_expPart, l_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.daeExp(Tpl.emptyTxt, i_exp, a_context, l_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("__b("));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")="));
        txt = Tpl.writeText(txt, l_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = lm_755(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_context);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);
  end match;
end lm_755;

protected function fun_756
  input Tpl.Text in_txt;
  input Option<SimCode.JacobianMatrix> in_a_ls_jacobianMatrix;
  input list<DAE.Exp> in_a_ls_beqs;
  input list<tuple<Integer, Integer, SimCode.SimEqSystem>> in_a_ls_simJac;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input SimCodeFunction.Context in_a_context;
  input list<SimCode.SimEqSystem> in_a_ls_residual;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_a_ls_jacobianMatrix, in_a_ls_beqs, in_a_ls_simJac, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_context, in_a_ls_residual)
    local
      Tpl.Text txt;
      list<DAE.Exp> a_ls_beqs;
      list<tuple<Integer, Integer, SimCode.SimEqSystem>> a_ls_simJac;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      SimCodeFunction.Context a_context;
      list<SimCode.SimEqSystem> a_ls_residual;
      Tpl.Text l_bvector;
      Tpl.Text l_Amatrix;
      Tpl.Text l_body;
      Tpl.Text l_prebody;
      Tpl.Text l_varDecls;

    case ( txt,
           SOME(_),
           _,
           _,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_context,
           a_ls_residual )
      equation
        l_varDecls = Tpl.emptyTxt;
        l_prebody = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_prebody, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, l_varDecls) = lm_752(l_prebody, a_ls_residual, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_context, l_varDecls);
        l_prebody = Tpl.popIter(l_prebody);
        l_body = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_body, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, l_varDecls) = lm_753(l_body, a_ls_residual, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, l_varDecls, a_context);
        l_body = Tpl.popIter(l_body);
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_varDecls);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("//prebody\n"));
        txt = Tpl.writeText(txt, l_prebody);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("//body\n"));
        txt = Tpl.writeText(txt, l_body);
        txt = Tpl.popBlock(txt);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           a_ls_beqs,
           a_ls_simJac,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_context,
           _ )
      equation
        l_varDecls = Tpl.emptyTxt;
        l_Amatrix = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_Amatrix, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, l_varDecls) = lm_754(l_Amatrix, a_ls_simJac, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, l_varDecls, a_context);
        l_Amatrix = Tpl.popIter(l_Amatrix);
        l_bvector = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(1, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_bvector, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, l_varDecls) = lm_755(l_bvector, a_ls_beqs, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, l_varDecls, a_context);
        l_bvector = Tpl.popIter(l_bvector);
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.writeText(txt, l_varDecls);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeText(txt, l_Amatrix);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_bvector);
        txt = Tpl.popBlock(txt);
        txt = Tpl.popBlock(txt);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_756;

protected function fun_757
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_a_eq, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_context)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      SimCodeFunction.Context a_context;
      list<DAE.Exp> i_ls_beqs;
      list<tuple<Integer, Integer, SimCode.SimEqSystem>> i_ls_simJac;
      list<SimCode.SimEqSystem> i_ls_residual;
      Option<SimCode.JacobianMatrix> i_ls_jacobianMatrix;
      list<DAE.ComponentRef> i_nls_crefs;
      Integer ret_1;
      Tpl.Text l_size;

    case ( txt,
           SimCode.SES_NONLINEAR(nlSystem = SimCode.NONLINEARSYSTEM(crefs = i_nls_crefs)),
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_context )
      equation
        ret_1 = listLength(i_nls_crefs);
        l_size = Tpl.writeStr(Tpl.emptyTxt, intString(ret_1));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_751(txt, i_nls_crefs, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_context);
        txt = Tpl.popIter(txt);
        txt = Tpl.popBlock(txt);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           SimCode.SES_LINEAR(lSystem = SimCode.LINEARSYSTEM(jacobianMatrix = i_ls_jacobianMatrix, residual = i_ls_residual, simJac = i_ls_simJac, beqs = i_ls_beqs)),
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_context )
      equation
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_756(txt, i_ls_jacobianMatrix, i_ls_beqs, i_ls_simJac, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_context, i_ls_residual);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_757;

public function initAlgloopEquation
  input Tpl.Text txt;
  input SimCode.SimEqSystem a_eq;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
protected
  String ret_2;
  Tpl.Text l_type;
  Tpl.Text l_varDeclsCref;
algorithm
  l_varDeclsCref := Tpl.emptyTxt;
  ret_2 := Flags.getConfigString(Flags.MATRIX_FORMAT);
  l_type := Tpl.writeStr(Tpl.emptyTxt, ret_2);
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) := fun_757(txt, a_eq, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_context);
end initAlgloopEquation;

protected function lm_759
  input Tpl.Text in_txt;
  input list<DAE.ComponentRef> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.ComponentRef> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      SimCodeFunction.Context a_context;
      Integer x_i0;
      DAE.ComponentRef i_name;
      Tpl.Text l_namestr;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           i_name :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_context )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        (l_namestr, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.contextCref(Tpl.emptyTxt, i_name, a_context, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("vars["));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = "));
        txt = Tpl.writeText(txt, l_namestr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_759(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_context);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_759;

protected function lm_760
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_varDeclsCref;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_varDeclsCref;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_varDeclsCref, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_varDeclsCref, in_a_context, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_varDeclsCref;
      SimCodeFunction.Context a_context;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Integer x_i0;
      DAE.ComponentRef i_name;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_varDeclsCref,
           _,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           SimCodeVar.SIMVAR(name = i_name) :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_varDeclsCref,
           a_context,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("vars["));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = "));
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_varDeclsCref, a_stateDerVectorName) = CodegenCppCommonOld.cref1(txt, i_name, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_context, a_varDeclsCref, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_760(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_varDeclsCref, a_context, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _ :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_varDeclsCref,
           a_context,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_760(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_varDeclsCref, a_context, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_760;

protected function fun_761
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input Tpl.Text in_a_varDeclsCref;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDeclsCref;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_varDeclsCref, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_a_eq, in_a_varDeclsCref, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_context)
    local
      Tpl.Text txt;
      Tpl.Text a_varDeclsCref;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      SimCodeFunction.Context a_context;
      list<SimCodeVar.SimVar> i_ls_vars;
      list<DAE.ComponentRef> i_nls_crefs;
      Integer ret_1;
      Tpl.Text l_size;

    case ( txt,
           SimCode.SES_NONLINEAR(nlSystem = SimCode.NONLINEARSYSTEM(crefs = i_nls_crefs)),
           a_varDeclsCref,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_context )
      equation
        ret_1 = listLength(i_nls_crefs);
        l_size = Tpl.writeStr(Tpl.emptyTxt, intString(ret_1));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_759(txt, i_nls_crefs, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_context);
        txt = Tpl.popIter(txt);
        txt = Tpl.popBlock(txt);
      then (txt, a_varDeclsCref, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           SimCode.SES_LINEAR(lSystem = SimCode.LINEARSYSTEM(vars = i_ls_vars)),
           a_varDeclsCref,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_context )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_760(txt, i_ls_vars, a_useFlatArrayNotation, a_stateDerVectorName, a_varDeclsCref, a_context, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
        txt = Tpl.popIter(txt);
      then (txt, a_varDeclsCref, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           a_varDeclsCref,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_varDeclsCref, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_761;

public function getAlgloopVars
  input Tpl.Text txt;
  input SimCode.SimEqSystem a_eq;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
protected
  Tpl.Text l_varDeclsCref;
algorithm
  l_varDeclsCref := Tpl.emptyTxt;
  (out_txt, l_varDeclsCref, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) := fun_761(txt, a_eq, l_varDeclsCref, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_context);
end getAlgloopVars;

protected function lm_763
  input Tpl.Text in_txt;
  input list<DAE.ComponentRef> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_context, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_varDecls, in_a_preExp, in_a_simCode)
    local
      Tpl.Text txt;
      list<DAE.ComponentRef> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      SimCodeFunction.Context a_context;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCode.SimCode a_simCode;
      Integer x_i0;
      DAE.ComponentRef i_cref;
      SimCodeVar.SimVar ret_1;
      Tpl.Text l_initializer;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           _,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);

    case ( txt,
           i_cref :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_context,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_varDecls,
           a_preExp,
           a_simCode )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        ret_1 = SimCodeUtil.cref2simvar(i_cref, a_simCode);
        (l_initializer, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = createAlgloopVarAttributes(Tpl.emptyTxt, ret_1, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_context, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_vars["));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = "));
        txt = Tpl.writeText(txt, l_initializer);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = lm_763(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_context, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp, a_simCode);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);
  end match;
end lm_763;

protected function lm_764
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_context, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_preExp)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      SimCodeFunction.Context a_context;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      Integer x_i0;
      SimCodeVar.SimVar i_var;
      Tpl.Text l_initializer;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           _,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           a_preExp )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);

    case ( txt,
           i_var :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_context,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        (l_initializer, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = createAlgloopVarAttributes(Tpl.emptyTxt, i_var, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_context, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_vars["));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = "));
        txt = Tpl.writeText(txt, l_initializer);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = lm_764(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_context, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);
  end match;
end lm_764;

protected function fun_765
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_a_eq, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_context, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_varDecls, in_a_preExp, in_a_simCode)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      SimCodeFunction.Context a_context;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCode.SimCode a_simCode;
      list<SimCodeVar.SimVar> i_ls_vars;
      list<DAE.ComponentRef> i_nls_crefs;

    case ( txt,
           SimCode.SES_NONLINEAR(nlSystem = SimCode.NONLINEARSYSTEM(crefs = i_nls_crefs)),
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_context,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_varDecls,
           a_preExp,
           a_simCode )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = lm_763(txt, i_nls_crefs, a_useFlatArrayNotation, a_stateDerVectorName, a_context, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp, a_simCode);
        txt = Tpl.popIter(txt);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);

    case ( txt,
           SimCode.SES_LINEAR(lSystem = SimCode.LINEARSYSTEM(vars = i_ls_vars)),
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_context,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_varDecls,
           a_preExp,
           a_simCode )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = lm_764(txt, i_ls_vars, a_useFlatArrayNotation, a_stateDerVectorName, a_context, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp);
        txt = Tpl.popIter(txt);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);

    case ( txt,
           _,
           _,
           a_stateDerVectorName,
           _,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);
  end match;
end fun_765;

public function initAlgloopVarAttributes
  input Tpl.Text txt;
  input SimCode.SimEqSystem a_eq;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
protected
  Tpl.Text l_vars;
  Tpl.Text l_varDecls;
  Tpl.Text l_preExp;
algorithm
  l_preExp := Tpl.emptyTxt;
  l_varDecls := Tpl.emptyTxt;
  (l_vars, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, l_varDecls, l_preExp) := fun_765(Tpl.emptyTxt, a_eq, a_useFlatArrayNotation, a_stateDerVectorName, a_context, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, l_varDecls, l_preExp, a_simCode);
  out_txt := Tpl.writeText(txt, l_varDecls);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeText(out_txt, l_preExp);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeText(out_txt, l_vars);
end initAlgloopVarAttributes;

protected function fun_767
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_a_var;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_var)
    local
      Tpl.Text txt;
      DAE.ComponentRef i_cref;

    case ( txt,
           SimCodeVar.SIMVAR(name = i_cref) )
      equation
        txt = CodegenCppCommonOld.crefStrForWriteOutput(txt, i_cref);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_767;

protected function fun_768
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_a_var;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_a_var, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Exp i_exp;
      Tpl.Text l_expPart;

    case ( txt,
           SimCodeVar.SIMVAR(nominalValue = SOME(i_exp)),
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (l_expPart, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.daeExp(Tpl.emptyTxt, i_exp, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeText(txt, l_expPart);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);

    case ( txt,
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           a_preExp,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("1.0"));
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);
  end match;
end fun_768;

protected function fun_769
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_a_var;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_a_var, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Exp i_exp;
      Tpl.Text l_expPart;

    case ( txt,
           SimCodeVar.SIMVAR(varKind = BackendDAE.STATE_DER()),
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           a_preExp,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-HUGE_VAL"));
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);

    case ( txt,
           SimCodeVar.SIMVAR(minValue = SOME(i_exp)),
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (l_expPart, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.daeExp(Tpl.emptyTxt, i_exp, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeText(txt, l_expPart);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);

    case ( txt,
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           a_preExp,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-HUGE_VAL"));
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);
  end match;
end fun_769;

protected function fun_770
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_a_var;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_a_var, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Exp i_exp;
      Tpl.Text l_expPart;

    case ( txt,
           SimCodeVar.SIMVAR(varKind = BackendDAE.STATE_DER()),
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           a_preExp,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("HUGE_VAL"));
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);

    case ( txt,
           SimCodeVar.SIMVAR(maxValue = SOME(i_exp)),
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (l_expPart, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.daeExp(Tpl.emptyTxt, i_exp, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeText(txt, l_expPart);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);

    case ( txt,
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           a_preExp,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("HUGE_VAL"));
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);
  end match;
end fun_770;

public function createAlgloopVarAttributes
  input Tpl.Text txt;
  input SimCodeVar.SimVar a_var;
  input Tpl.Text a_preExp;
  input Tpl.Text a_varDecls;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
protected
  Tpl.Text l_maxStr;
  Tpl.Text l_minStr;
  Tpl.Text l_nominalStr;
  Tpl.Text l_nameStr;
algorithm
  l_nameStr := fun_767(Tpl.emptyTxt, a_var);
  (l_nominalStr, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp) := fun_768(Tpl.emptyTxt, a_var, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context);
  (l_minStr, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp) := fun_769(Tpl.emptyTxt, a_var, a_useFlatArrayNotation, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, a_simCode, out_a_varDecls, out_a_preExp, a_context);
  (l_maxStr, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp) := fun_770(Tpl.emptyTxt, a_var, a_useFlatArrayNotation, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, a_simCode, out_a_varDecls, out_a_preExp, a_context);
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING("AlgloopVarAttributes(\""));
  out_txt := Tpl.writeText(out_txt, l_nameStr);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("\", "));
  out_txt := Tpl.writeText(out_txt, l_nominalStr);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING(", "));
  out_txt := Tpl.writeText(out_txt, l_minStr);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING(", "));
  out_txt := Tpl.writeText(out_txt, l_maxStr);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING(")"));
end createAlgloopVarAttributes;

protected function lm_772
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_context)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      SimCodeFunction.Context a_context;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           i_eq :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_context )
      equation
        (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = writeAlgloopvars2(txt, i_eq, a_context, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = lm_772(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_context);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);
  end match;
end lm_772;

protected function lm_773
  input Tpl.Text in_txt;
  input list<list<SimCode.SimEqSystem>> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_context)
    local
      Tpl.Text txt;
      list<list<SimCode.SimEqSystem>> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      SimCodeFunction.Context a_context;
      list<SimCode.SimEqSystem> i_eqs;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           i_eqs :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_context )
      equation
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = lm_772(txt, i_eqs, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_context);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = lm_773(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_context);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);
  end match;
end lm_773;

public function writeAlgloopvars
  input Tpl.Text txt;
  input list<list<SimCode.SimEqSystem>> a_continousEquations;
  input list<SimCode.SimEqSystem> a_discreteEquations;
  input list<SimCode.SimEqSystem> a_parameterEquations;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
protected
  Tpl.Text l_algloopsolver;
  Tpl.Text l_varDecls;
algorithm
  l_varDecls := Tpl.emptyTxt;
  l_algloopsolver := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(" ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (l_algloopsolver, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, l_varDecls) := lm_773(l_algloopsolver, a_continousEquations, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, l_varDecls, a_context);
  l_algloopsolver := Tpl.popIter(l_algloopsolver);
  out_txt := Tpl.writeText(txt, l_algloopsolver);
end writeAlgloopvars;

protected function lm_775
  input Tpl.Text in_txt;
  input list<DAE.ComponentRef> in_items;
  input Integer in_a_nls_index;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_nls_index, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      list<DAE.ComponentRef> rest;
      Integer a_nls_index;
      Boolean a_useFlatArrayNotation;
      Integer x_i0;
      DAE.ComponentRef i_name;
      Tpl.Text l_namestr;

    case ( txt,
           {},
           _,
           _ )
      then txt;

    case ( txt,
           i_name :: rest,
           a_nls_index,
           a_useFlatArrayNotation )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        l_namestr = CodegenCppCommonOld.cref(Tpl.emptyTxt, i_name, a_useFlatArrayNotation);
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeText(txt, l_namestr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = algloopvars"));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("["));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("];"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.nextIter(txt);
        txt = lm_775(txt, rest, a_nls_index, a_useFlatArrayNotation);
      then txt;
  end match;
end lm_775;

protected function lm_776
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Tpl.Text in_a_algloopid;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_varDeclsCref;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_varDeclsCref;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_varDeclsCref, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_algloopid, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_varDeclsCref, in_a_context, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Tpl.Text a_algloopid;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_varDeclsCref;
      SimCodeFunction.Context a_context;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Integer x_i0;
      DAE.ComponentRef i_name;

    case ( txt,
           {},
           _,
           _,
           a_stateDerVectorName,
           a_varDeclsCref,
           _,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           SimCodeVar.SIMVAR(name = i_name) :: rest,
           a_algloopid,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_varDeclsCref,
           a_context,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_varDeclsCref, a_stateDerVectorName) = CodegenCppCommonOld.cref1(txt, i_name, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_context, a_varDeclsCref, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = algloopvars"));
        txt = Tpl.writeText(txt, a_algloopid);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("["));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("];"));
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_776(txt, rest, a_algloopid, a_useFlatArrayNotation, a_stateDerVectorName, a_varDeclsCref, a_context, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _ :: rest,
           a_algloopid,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_varDeclsCref,
           a_context,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_776(txt, rest, a_algloopid, a_useFlatArrayNotation, a_stateDerVectorName, a_varDeclsCref, a_context, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_776;

protected function fun_777
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input SimCodeFunction.Context in_a_context;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_eq, in_a_context, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      Integer i_ls_index;
      list<SimCodeVar.SimVar> i_ls_vars;
      Integer i_nls_index;
      list<DAE.ComponentRef> i_nls_crefs;
      Tpl.Text l_varDeclsCref;
      Tpl.Text l_algloopid;
      Integer ret_2;
      Integer ret_1;
      Tpl.Text l_size;

    case ( txt,
           SimCode.SES_NONLINEAR(nlSystem = SimCode.NONLINEARSYSTEM(crefs = i_nls_crefs, index = i_nls_index)),
           _,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        ret_1 = listLength(i_nls_crefs);
        l_size = Tpl.writeStr(Tpl.emptyTxt, intString(ret_1));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("double algloopvars"));
        txt = Tpl.writeStr(txt, intString(i_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("["));
        txt = Tpl.writeText(txt, l_size);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "];\n",
                                    "_algLoop"
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("->getReal(algloopvars"));
        txt = Tpl.writeStr(txt, intString(i_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(");\n"));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_775(txt, i_nls_crefs, i_nls_index, a_useFlatArrayNotation);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.popBlock(txt);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           SimCode.SES_LINEAR(lSystem = SimCode.LINEARSYSTEM(vars = i_ls_vars, index = i_ls_index)),
           a_context,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        ret_2 = listLength(i_ls_vars);
        l_size = Tpl.writeStr(Tpl.emptyTxt, intString(ret_2));
        l_algloopid = Tpl.writeStr(Tpl.emptyTxt, intString(i_ls_index));
        l_varDeclsCref = Tpl.emptyTxt;
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("double algloopvars"));
        txt = Tpl.writeText(txt, l_algloopid);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("["));
        txt = Tpl.writeText(txt, l_size);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "];\n",
                                    "_algLoop"
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("->getReal(algloopvars"));
        txt = Tpl.writeText(txt, l_algloopid);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ",NULL,NULL);\n",
                                    "\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_stateDerVectorName, l_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_776(txt, i_ls_vars, l_algloopid, a_useFlatArrayNotation, a_stateDerVectorName, l_varDeclsCref, a_context, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.popBlock(txt);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end fun_777;

public function writeAlgloopvars2
  input Tpl.Text txt;
  input SimCode.SimEqSystem a_eq;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_varDecls;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) := fun_777(txt, a_eq, a_context, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
  out_a_varDecls := a_varDecls;
end writeAlgloopvars2;

protected function fun_779
  input Tpl.Text in_txt;
  input DAE.ComponentRef in_a_name;
  input Tpl.Text in_a_namestr;
  input Integer in_a_i0;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_name, in_a_namestr, in_a_i0, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      Tpl.Text a_namestr;
      Integer a_i0;
      Boolean a_useFlatArrayNotation;
      DAE.ComponentRef i_componentRef;
      Tpl.Text l_varname;

    case ( txt,
           DAE.CREF_QUAL(ident = "$PRE", componentRef = i_componentRef),
           _,
           a_i0,
           a_useFlatArrayNotation )
      equation
        l_varname = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("_system->"));
        l_varname = CodegenCppCommonOld.cref(l_varname, i_componentRef, a_useFlatArrayNotation);
        txt = Tpl.writeText(txt, l_varname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = vars["));
        txt = Tpl.writeStr(txt, intString(a_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "];\n",
                                    "_discrete_events->save("
                                }, false));
        txt = Tpl.writeText(txt, l_varname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, l_varname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;

    case ( txt,
           _,
           a_namestr,
           a_i0,
           _ )
      equation
        txt = Tpl.writeText(txt, a_namestr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = vars["));
        txt = Tpl.writeStr(txt, intString(a_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("];"));
      then txt;
  end match;
end fun_779;

protected function lm_780
  input Tpl.Text in_txt;
  input list<DAE.ComponentRef> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_varDeclsCref;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_varDeclsCref;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_varDeclsCref, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_varDeclsCref, in_a_context, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      list<DAE.ComponentRef> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_varDeclsCref;
      SimCodeFunction.Context a_context;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Integer x_i0;
      DAE.ComponentRef i_name;
      Tpl.Text l_namestr;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_varDeclsCref,
           _,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           i_name :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_varDeclsCref,
           a_context,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        (l_namestr, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_varDeclsCref, a_stateDerVectorName) = CodegenCppCommonOld.cref1(Tpl.emptyTxt, i_name, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_context, a_varDeclsCref, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = fun_779(txt, i_name, l_namestr, x_i0, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_780(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_varDeclsCref, a_context, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_780;

protected function lm_781
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_varDeclsCref;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_varDeclsCref;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_varDeclsCref, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_varDeclsCref, in_a_context, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_varDeclsCref;
      SimCodeFunction.Context a_context;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Integer x_i0;
      DAE.ComponentRef i_name;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_varDeclsCref,
           _,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           SimCodeVar.SIMVAR(name = i_name) :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_varDeclsCref,
           a_context,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_varDeclsCref, a_stateDerVectorName) = CodegenCppCommonOld.cref1(txt, i_name, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_context, a_varDeclsCref, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = vars["));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("];"));
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_781(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_varDeclsCref, a_context, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _ :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_varDeclsCref,
           a_context,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_781(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_varDeclsCref, a_context, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_781;

protected function fun_782
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_varDeclsCref;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_varDeclsCref;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_varDeclsCref, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_a_eq, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_varDeclsCref, in_a_context, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_varDeclsCref;
      SimCodeFunction.Context a_context;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      list<SimCodeVar.SimVar> i_ls_vars;
      list<DAE.ComponentRef> i_nls_crefs;
      Integer ret_1;
      Tpl.Text l_size;

    case ( txt,
           SimCode.SES_NONLINEAR(nlSystem = SimCode.NONLINEARSYSTEM(crefs = i_nls_crefs)),
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_varDeclsCref,
           a_context,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        ret_1 = listLength(i_nls_crefs);
        l_size = Tpl.writeStr(Tpl.emptyTxt, intString(ret_1));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_780(txt, i_nls_crefs, a_useFlatArrayNotation, a_stateDerVectorName, a_varDeclsCref, a_context, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.popBlock(txt);
      then (txt, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           SimCode.SES_LINEAR(lSystem = SimCode.LINEARSYSTEM(vars = i_ls_vars)),
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_varDeclsCref,
           a_context,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_781(txt, i_ls_vars, a_useFlatArrayNotation, a_stateDerVectorName, a_varDeclsCref, a_context, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
        txt = Tpl.popIter(txt);
      then (txt, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           _,
           a_stateDerVectorName,
           a_varDeclsCref,
           _,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_782;

public function setAlgloopVars
  input Tpl.Text txt;
  input SimCode.SimEqSystem a_eq;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
protected
  Tpl.Text l_varDeclsCref;
algorithm
  l_varDeclsCref := Tpl.emptyTxt;
  (out_txt, out_a_stateDerVectorName, l_varDeclsCref, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) := fun_782(txt, a_eq, a_useFlatArrayNotation, a_stateDerVectorName, l_varDeclsCref, a_context, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
end setAlgloopVars;

protected function fun_784
  input Tpl.Text in_txt;
  input Option<SimCode.JacobianMatrix> in_a_ls_jacobianMatrix;
  input list<SimCodeVar.SimVar> in_a_ls_vars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ls_jacobianMatrix, in_a_ls_vars)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> a_ls_vars;
      Integer ret_2;
      Integer ret_1;
      Tpl.Text l_size;

    case ( txt,
           SOME(_),
           a_ls_vars )
      equation
        ret_1 = listLength(a_ls_vars);
        l_size = Tpl.writeStr(Tpl.emptyTxt, intString(ret_1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "// Number of unknowns equations\n",
                                    "_dimAEq = "
                                }, false));
        txt = Tpl.writeText(txt, l_size);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "LinearAlgLoopDefaultImplementation::initialize();"
                                }, false));
      then txt;

    case ( txt,
           _,
           a_ls_vars )
      equation
        ret_2 = listLength(a_ls_vars);
        l_size = Tpl.writeStr(Tpl.emptyTxt, intString(ret_2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "// Number of unknowns/equations according to type (0: double, 1: int, 2: bool)\n",
                                    "_dimAEq = "
                                }, false));
        txt = Tpl.writeText(txt, l_size);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "LinearAlgLoopDefaultImplementation::initialize();\n",
                                    "fill_array(__b, 0.0);"
                                }, false));
      then txt;
  end match;
end fun_784;

protected function fun_785
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_eq)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> i_ls_vars;
      Option<SimCode.JacobianMatrix> i_ls_jacobianMatrix;
      list<DAE.ComponentRef> i_nls_crefs;
      Integer ret_1;
      Tpl.Text l_size;

    case ( txt,
           SimCode.SES_NONLINEAR(nlSystem = SimCode.NONLINEARSYSTEM(crefs = i_nls_crefs)) )
      equation
        ret_1 = listLength(i_nls_crefs);
        l_size = Tpl.writeStr(Tpl.emptyTxt, intString(ret_1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_dimAEq = "));
        txt = Tpl.writeText(txt, l_size);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "NonLinearAlgLoopDefaultImplementation::initialize();"
                                }, false));
      then txt;

    case ( txt,
           SimCode.SES_LINEAR(lSystem = SimCode.LINEARSYSTEM(jacobianMatrix = i_ls_jacobianMatrix, vars = i_ls_vars)) )
      equation
        txt = fun_784(txt, i_ls_jacobianMatrix, i_ls_vars);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_785;

public function initAlgloopDimension
  input Tpl.Text txt;
  input SimCode.SimEqSystem a_eq;
  input Tpl.Text a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
algorithm
  out_txt := fun_785(txt, a_eq);
  out_a_varDecls := a_varDecls;
end initAlgloopDimension;

public function alocateLinearSystem
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_eq)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> i_ls_vars;
      Integer ret_1;
      Tpl.Text l_size;

    case ( txt,
           SimCode.SES_LINEAR(lSystem = SimCode.LINEARSYSTEM(vars = i_ls_vars)) )
      equation
        ret_1 = listLength(i_ls_vars);
        l_size = Tpl.writeStr(Tpl.emptyTxt, intString(ret_1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " if(_useSparseFormat)\n",
                                    "   __Asparse = shared_ptr<matrix_t> (new matrix_t);\n",
                                    " else\n",
                                    "   __A = shared_ptr<AMATRIX>( new AMATRIX());"
                                }, false));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end alocateLinearSystem;

protected function fun_788
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_eq)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> i_ls_vars;
      Integer ret_1;
      Tpl.Text l_size;

    case ( txt,
           SimCode.SES_LINEAR(lSystem = SimCode.LINEARSYSTEM(vars = i_ls_vars)) )
      equation
        ret_1 = listLength(i_ls_vars);
        l_size = Tpl.writeStr(Tpl.emptyTxt, intString(ret_1));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(",__b(boost::extents["));
        txt = Tpl.writeText(txt, l_size);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("])"));
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_788;

public function alocateLinearSystemConstructor
  input Tpl.Text txt;
  input SimCode.SimEqSystem a_eq;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_788(txt, a_eq);
end alocateLinearSystemConstructor;

public function update
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      list<SimCode.SimEqSystem> i_equationsForZeroCrossings;
      list<list<SimCode.SimEqSystem>> i_odeEquations;
      list<SimCode.ClockedPartition> i_clockedPartitions;
      SimCode.SimCode i_simCode;
      list<SimCode.SimEqSystem> i_allEquations;
      Boolean ret_12;
      Boolean ret_11;
      String ret_10;
      Boolean ret_9;
      Boolean ret_8;
      String ret_7;
      Boolean ret_6;
      Boolean ret_5;
      String ret_4;
      list<SimCode.SubPartition> ret_3;
      Boolean ret_2;
      Boolean ret_1;
      String ret_0;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(allEquations = i_allEquations, clockedPartitions = i_clockedPartitions, odeEquations = i_odeEquations, equationsForZeroCrossings = i_equationsForZeroCrossings)),
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        ret_0 = Flags.getConfigString(Flags.PROFILING_LEVEL);
        ret_1 = stringEq(ret_0, "none");
        ret_2 = boolNot(ret_1);
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = equationFunctions(txt, i_allEquations, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, SimCodeFunction.contextSimulationDiscrete, a_stateDerVectorName, a_useFlatArrayNotation, ret_2);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        ret_3 = SimCodeUtil.getSubPartitions(i_clockedPartitions);
        ret_4 = Flags.getConfigString(Flags.PROFILING_LEVEL);
        ret_5 = stringEq(ret_4, "none");
        ret_6 = boolNot(ret_5);
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = clockedFunctions(txt, ret_3, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, SimCodeFunction.contextSimulationDiscrete, a_stateDerVectorName, a_useFlatArrayNotation, ret_6);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        ret_7 = Flags.getConfigString(Flags.PROFILING_LEVEL);
        ret_8 = stringEq(ret_7, "none");
        ret_9 = boolNot(ret_8);
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = createEvaluateAll(txt, i_allEquations, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, SimCodeFunction.contextOther, a_stateDerVectorName, a_useFlatArrayNotation, ret_9);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        ret_10 = Flags.getConfigString(Flags.PROFILING_LEVEL);
        ret_11 = stringEq(ret_10, "none");
        ret_12 = boolNot(ret_11);
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = createEvaluate(txt, i_odeEquations, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, SimCodeFunction.contextOther, ret_12);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = createEvaluateZeroFuncs(txt, i_equationsForZeroCrossings, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, SimCodeFunction.contextOther);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = createEvaluateConditions(txt, i_allEquations, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, SimCodeFunction.contextOther, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end update;

protected function fun_791
  input Tpl.Text in_txt;
  input String in_a_settings_outputFormat;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_settings_outputFormat)
    local
      Tpl.Text txt;

    case ( txt,
           "mat" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " const all_names_t parameterVarNames =  make_tuple(outputRealVars.parameterNames,outputIntVars.parameterNames,outputBoolVars.parameterNames,outputDerVars.ourputVarNames,outputResVars.ourputVarNames);\n",
                                    " const all_description_t parameterVarDescription =  make_tuple(outputRealVars.parameterDescription,outputIntVars.parameterDescription,outputBoolVars.parameterDescription,outputDerVars.ourputVarDescription,outputResVars.ourputVarDescription);"
                                }, false));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "const all_names_t parameterVarNames;\n",
                                    "const all_description_t parameterVarDescription;"
                                }, false));
      then txt;
  end match;
end fun_791;

protected function fun_792
  input Tpl.Text in_txt;
  input String in_a_settings_outputFormat;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_settings_outputFormat)
    local
      Tpl.Text txt;

    case ( txt,
           "mat" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("const all_vars_t params = make_tuple(outputRealVars.outputParams,outputIntVars.outputParams,outputBoolVars.outputParams,outputDerVars.outputParams,outputResVars.outputParams);"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("const all_vars_t params;"));
      then txt;
  end match;
end fun_792;

protected function smf_793
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_it;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_it, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           i_eq,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = writeoutputAlgloopsolvers(txt, i_eq, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end smf_793;

protected function lm_794
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      SimCode.SimEqSystem i_eqs;

    case ( txt,
           {},
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           i_eqs :: rest,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = smf_793(txt, i_eqs, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
        txt = Tpl.nextIter(txt);
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_794(txt, rest, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_794;

protected function lm_795
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      SimCode.SimEqSystem i_eqn;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           i_eqn :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = writeoutput3(txt, i_eqn, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_795(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_795;

protected function fun_796
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input SimCode.ModelInfo in_a_modelInfo;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input list<SimCode.SimEqSystem> in_a_allEquations;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_mArg, in_a_modelInfo, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_allEquations)
    local
      Tpl.Text txt;
      SimCode.ModelInfo a_modelInfo;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      list<SimCode.SimEqSystem> a_allEquations;

    case ( txt,
           false,
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = generateMeasureTimeEndCode(txt, "measuredFunctionStartValues", "measuredFunctionEndValues", "(*measureTimeFunctionsArray)[2]", "writeOutput", "MEASURETIME_MODELFUNCTIONS");
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " write_data_t& container = _writeOutput->getFreeContainer();\n",
                                    " all_vars_time_t all_vars = make_tuple(outputRealVars.outputVars,outputIntVars.outputVars,outputBoolVars.outputVars,_simTime,outputDerVars.outputVars,outputResVars.outputVars);\n",
                                    " neg_all_vars_t neg_all_vars =      make_tuple(outputRealVars.negateOutputVars,outputIntVars.negateOutputVars,outputBoolVars.negateOutputVars,outputDerVars.negateOutputVars,outputResVars.negateOutputVars);\n",
                                    "_writeOutput->addContainerToWriteQueue(make_tuple(all_vars,neg_all_vars));"
                                }, false));
        txt = Tpl.popBlock(txt);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           a_modelInfo,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_allEquations )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_794(txt, a_allEquations, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("double residues [] = {"));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_795(txt, a_allEquations, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "};\n",
                                    "output_res_vars_t _resVars;\n",
                                    "for(int i=0;i<"
                                }, false));
        txt = numResidues(txt, a_allEquations, a_modelInfo);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";i++)\n",
                                    "{\n",
                                    "  double* realVarPtr = &residues[i];\n",
                                    "  string str;\n",
                                    " _resVars.addOutputVar(str, str,realVarPtr, false);\n",
                                    "\n",
                                    "}\n",
                                    "\n"
                                }, true));
        txt = generateMeasureTimeEndCode(txt, "measuredFunctionStartValues", "measuredFunctionEndValues", "(*measureTimeFunctionsArray)[2]", "writeOutput", "MEASURETIME_MODELFUNCTIONS");
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "write_data_t& container = _writeOutput->getFreeContainer();\n",
                                    "  all_vars_time_t all_vars = make_tuple(outputRealVars.outputVars,outputIntVars.outputVars,outputBoolVars.outputVars,_simTime,outputDerVars.outputVars,_resVars.outputVars);\n",
                                    "  neg_all_vars_t neg_all_vars =      make_tuple(outputRealVars.negateOutputVars,outputIntVars.negateOutputVars,outputBoolVars.negateOutputVars,outputDerVars.negateOutputVars,_resVars.negateOutputVars);\n",
                                    " _writeOutput->addContainerToWriteQueue(make_tuple(all_vars,neg_all_vars));\n",
                                    "\n"
                                }, true));
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_796;

public function writeoutput
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      SimCode.SimCode i_simCode;
      list<SimCode.SimEqSystem> i_allEquations;
      String i_settings_outputFormat;
      Absyn.Path i_modelInfo_name;
      SimCode.ModelInfo i_modelInfo;
      Boolean ret_1;
      Tpl.Text l_numParamvars;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = (i_modelInfo as SimCode.MODELINFO(name = i_modelInfo_name)), simulationSettingsOpt = SOME(SimCode.SIMULATION_SETTINGS(outputFormat = i_settings_outputFormat)), allEquations = i_allEquations)),
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_numParamvars = numProtectedParamVars(Tpl.emptyTxt, i_modelInfo);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "WriteOutput::writeOutput(const IWriteOutput::OUTPUT command)\n",
                                    "{\n",
                                    "\n",
                                    "  const output_int_vars_t& outputIntVars = _reader->getIntOutVars();\n",
                                    "  const output_real_vars_t&  outputRealVars= _reader->getRealOutVars();\n",
                                    "  const output_bool_vars_t& outputBoolVars = _reader->getBoolOutVars();\n",
                                    "  const output_der_vars_t& outputDerVars = _reader->getDerOutVars();\n",
                                    "  const output_res_vars_t& outputResVars= _reader->getResOutVars();;\n",
                                    "\n",
                                    " //Write head line\n",
                                    " if (command & IWriteOutput::HEAD_LINE)\n",
                                    " {\n",
                                    "   const all_names_t outputVarNames = make_tuple(outputRealVars.ourputVarNames,outputIntVars.ourputVarNames,outputBoolVars.ourputVarNames,outputDerVars.ourputVarNames,outputResVars.ourputVarNames);\n",
                                    "   const all_description_t outputVarDescription = make_tuple(outputRealVars.ourputVarDescription,outputIntVars.ourputVarDescription,outputBoolVars.ourputVarDescription,outputDerVars.ourputVarDescription,outputResVars.ourputVarDescription);\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(3));
        txt = fun_791(txt, i_settings_outputFormat);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_writeOutput->write(outputVarNames,outputVarDescription,parameterVarNames,parameterVarDescription);\n"));
        txt = fun_792(txt, i_settings_outputFormat);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_writeOutput->write(params,_global_settings->getStartTime(),_global_settings->getEndTime());\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " }\n",
                                    " //Write the current values\n",
                                    "  else\n",
                                    " {\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(3));
        txt = generateMeasureTimeStartCode(txt, "measuredFunctionStartValues", "writeOutput", "MEASURETIME_MODELFUNCTIONS");
        txt = Tpl.softNewLine(txt);
        ret_1 = Flags.isSet(Flags.WRITE_TO_BUFFER);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_796(txt, ret_1, i_modelInfo, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, i_simCode, i_allEquations);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " }\n",
                                    "}"
                                }, false));
        txt = Tpl.popBlock(txt);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end writeoutput;

protected function fun_798
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_num;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode, in_a_num)
    local
      Tpl.Text txt;
      Tpl.Text a_num;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = _)),
           a_num )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("double* doubleResiduals"));
        txt = Tpl.writeText(txt, a_num);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = new double[_algLoop"));
        txt = Tpl.writeText(txt, a_num);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("->getDimReal()];\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_algLoop"));
        txt = Tpl.writeText(txt, a_num);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("->getb(doubleResiduals"));
        txt = Tpl.writeText(txt, a_num);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_798;

protected function fun_799
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_num;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode, in_a_num)
    local
      Tpl.Text txt;
      Tpl.Text a_num;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = _)),
           a_num )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("double* doubleResiduals"));
        txt = Tpl.writeText(txt, a_num);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = new double[_algLoop"));
        txt = Tpl.writeText(txt, a_num);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "->getDimReal()];\n",
                                    "_algLoop"
                                }, false));
        txt = Tpl.writeText(txt, a_num);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("->getRHS(doubleResiduals"));
        txt = Tpl.writeText(txt, a_num);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_799;

protected function fun_800
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_num;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode, in_a_num)
    local
      Tpl.Text txt;
      Tpl.Text a_num;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = _)),
           a_num )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("double* doubleResiduals"));
        txt = Tpl.writeText(txt, a_num);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = new double[_algLoop"));
        txt = Tpl.writeText(txt, a_num);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "->getDimReal()];\n",
                                    "_algLoop"
                                }, false));
        txt = Tpl.writeText(txt, a_num);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("->getb(doubleResiduals"));
        txt = Tpl.writeText(txt, a_num);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ");\n",
                                    "\n"
                                }, true));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_800;

protected function fun_801
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_eq, in_a_simCode)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      Integer i_index;
      Integer i_nls_index;
      Integer i_ls_index;
      Tpl.Text l_num;

    case ( txt,
           SimCode.SES_LINEAR(lSystem = SimCode.LINEARSYSTEM(index = i_ls_index)),
           a_simCode )
      equation
        l_num = Tpl.writeStr(Tpl.emptyTxt, intString(i_ls_index));
        txt = fun_798(txt, a_simCode, l_num);
      then txt;

    case ( txt,
           SimCode.SES_NONLINEAR(nlSystem = SimCode.NONLINEARSYSTEM(index = i_nls_index)),
           a_simCode )
      equation
        l_num = Tpl.writeStr(Tpl.emptyTxt, intString(i_nls_index));
        txt = fun_799(txt, a_simCode, l_num);
      then txt;

    case ( txt,
           SimCode.SES_MIXED(index = i_index),
           a_simCode )
      equation
        l_num = Tpl.writeStr(Tpl.emptyTxt, intString(i_index));
        txt = fun_800(txt, a_simCode, l_num);
      then txt;

    case ( txt,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
      then txt;
  end match;
end fun_801;

public function writeoutputAlgloopsolvers
  input Tpl.Text txt;
  input SimCode.SimEqSystem a_eq;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  out_txt := fun_801(txt, a_eq, a_simCode);
  out_a_extraFuncs := a_extraFuncs;
  out_a_extraFuncsDecl := a_extraFuncsDecl;
  out_a_extraFuncsNamespace := a_extraFuncsNamespace;
end writeoutputAlgloopsolvers;

protected function lm_803
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Integer in_a_ls_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_ls_index)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Integer a_ls_index;
      Integer x_myindex2;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           _ :: rest,
           a_ls_index )
      equation
        x_myindex2 = Tpl.getIteri_i0(txt);
        txt = writeoutput4(txt, a_ls_index, x_myindex2);
        txt = Tpl.nextIter(txt);
        txt = lm_803(txt, rest, a_ls_index);
      then txt;
  end match;
end lm_803;

protected function lm_804
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input Integer in_a_nls_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_nls_index)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      Integer a_nls_index;
      Integer x_myindex2;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           _ :: rest,
           a_nls_index )
      equation
        x_myindex2 = Tpl.getIteri_i0(txt);
        txt = writeoutput4(txt, a_nls_index, x_myindex2);
        txt = Tpl.nextIter(txt);
        txt = lm_804(txt, rest, a_nls_index);
      then txt;
  end match;
end lm_804;

public function writeoutput3
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eqn;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_eqn, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      SimCode.SimEqSystem i_cont;
      Integer i_nls_index;
      list<SimCode.SimEqSystem> i_nls_eqs;
      Integer i_ls_index;
      list<SimCodeVar.SimVar> i_ls_vars;
      DAE.ComponentRef i_cref;
      Tpl.Text l_varDeclsCref;

    case ( txt,
           SimCode.SES_RESIDUAL(index = _),
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           SimCode.SES_SIMPLE_ASSIGN(cref = i_cref),
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_varDeclsCref = Tpl.emptyTxt;
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, l_varDeclsCref, a_stateDerVectorName) = CodegenCppCommonOld.cref1(txt, i_cref, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, SimCodeFunction.contextOther, l_varDeclsCref, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           SimCode.SES_ARRAY_CALL_ASSIGN(index = _),
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           SimCode.SES_ALGORITHM(index = _),
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           SimCode.SES_LINEAR(lSystem = SimCode.LINEARSYSTEM(vars = i_ls_vars, index = i_ls_index)),
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_STRING(",")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_803(txt, i_ls_vars, i_ls_index);
        txt = Tpl.popIter(txt);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           SimCode.SES_NONLINEAR(nlSystem = SimCode.NONLINEARSYSTEM(eqs = i_nls_eqs, index = i_nls_index)),
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_STRING(",")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_804(txt, i_nls_eqs, i_nls_index);
        txt = Tpl.popIter(txt);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           SimCode.SES_MIXED(cont = i_cont),
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = writeoutput3(txt, i_cont, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           SimCode.SES_WHEN(index = _),
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end writeoutput3;

public function writeoutput4
  input Tpl.Text txt;
  input Integer a_index;
  input Integer a_myindex2;

  output Tpl.Text out_txt;
algorithm
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING("*(doubleResiduals"));
  out_txt := Tpl.writeStr(out_txt, intString(a_index));
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("+"));
  out_txt := Tpl.writeStr(out_txt, intString(a_myindex2));
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING(")"));
end writeoutput4;

protected function fun_807
  input Tpl.Text in_txt;
  input String in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           "none" )
      then txt;

    case ( txt,
           "all_perf" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "#ifdef USE_SCOREP\n",
                                    "  #include <Core/Utils/extension/measure_time_scorep.hpp>\n",
                                    "#else\n",
                                    "  #include <Core/Utils/extension/measure_time_papi.hpp>\n",
                                    "#endif"
                                }, false));
      then txt;

    case ( txt,
           "all_stat" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "#ifdef USE_SCOREP\n",
                                    "  #include <Core/Utils/extension/measure_time_scorep.hpp>\n",
                                    "#else\n",
                                    "  #include <Core/Utils/extension/measure_time_statistic.hpp>\n",
                                    "#endif"
                                }, false));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "#ifdef USE_SCOREP\n",
                                    "  #include <Core/Utils/extension/measure_time_scorep.hpp>\n",
                                    "#else\n",
                                    "  #include <Core/Utils/extension/measure_time_rdtsc.hpp>\n",
                                    "#endif"
                                }, false));
      then txt;
  end match;
end fun_807;

public function generateHeaderIncludeString
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace) :=
  match(in_txt, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace)
    local
      Tpl.Text txt;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Absyn.Path i_modelInfo_name;
      SimCode.SimCode i_simCode;
      list<SimCode.ClockedPartition> i_clockedPartitions;
      list<SimCode.SimEqSystem> i_initialEquations;
      list<SimCode.SimEqSystem> i_allEquations;
      list<SimCode.SimEqSystem> ret_4;
      list<SimCode.SimEqSystem> ret_3;
      list<SimCode.SubPartition> ret_2;
      list<SimCode.SimEqSystem> ret_1;
      String ret_0;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = i_modelInfo_name), extObjInfo = SimCode.EXTOBJINFO(vars = _), allEquations = i_allEquations, initialEquations = i_initialEquations, clockedPartitions = i_clockedPartitions)),
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "#pragma once\n",
                                    "#if defined(__TRICORE__) || defined(__vxworks)\n",
                                    "  #define BOOST_EXTENSION_SYSTEM_DECL\n",
                                    "  #define BOOST_EXTENSION_EVENTHANDLING_DECL\n",
                                    "#endif\n",
                                    "\n"
                                }, true));
        ret_0 = Flags.getConfigString(Flags.PROFILING_LEVEL);
        txt = fun_807(txt, ret_0);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "#include <Core/System/SystemDefaultImplementation.h>\n",
                                    "\n",
                                    "//Forward declaration to speed-up the compilation process\n",
                                    "class Functions;\n",
                                    "class EventHandling;\n",
                                    "class DiscreteEvents;\n"
                                }, true));
        ret_1 = listAppend(i_allEquations, i_initialEquations);
        ret_2 = SimCodeUtil.getSubPartitions(i_clockedPartitions);
        ret_3 = SimCodeUtil.getClockedEquations(ret_2);
        ret_4 = listAppend(ret_1, ret_3);
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = algloopForwardDeclaration(txt, ret_4, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "/*****************************************************************************\n",
                                    "*\n",
                                    "* Simulation code for "
                                }, false));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " generated by the OpenModelica Compiler.\n",
                                    "* System class "
                                }, false));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " implements the Interface IMixedSystem\n",
                                    "*\n",
                                    "*****************************************************************************/"
                                }, false));
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);

    case ( txt,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
  end match;
end generateHeaderIncludeString;

protected function fun_809
  input Tpl.Text in_txt;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_modelname;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_context, in_a_modelname)
    local
      Tpl.Text txt;
      Tpl.Text a_modelname;

    case ( txt,
           SimCodeFunction.ALGLOOP_CONTEXT(genInitialisation = false, genJacobian = true),
           a_modelname )
      equation
        txt = Tpl.writeText(txt, a_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Jacobian"));
      then txt;

    case ( txt,
           _,
           a_modelname )
      equation
        txt = Tpl.writeText(txt, a_modelname);
      then txt;
  end match;
end fun_809;

protected function fun_810
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode, in_a_context)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Absyn.Path i_modelInfo_name;
      Tpl.Text l_systemname;
      Tpl.Text l_modelname;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = i_modelInfo_name), extObjInfo = SimCode.EXTOBJINFO(vars = _)),
           a_context )
      equation
        l_modelname = lastIdentOfPath(Tpl.emptyTxt, i_modelInfo_name);
        l_systemname = fun_809(Tpl.emptyTxt, a_context, l_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "#pragma once\n",
                                    "#if defined(__TRICORE__)\n",
                                    "  #define BOOST_EXTENSION_ALGLOOPDEFAULTIMPL_DECL\n",
                                    "  #define BOOST_EXTENSION_EVENTHANDLING_DECL\n",
                                    "#endif\n",
                                    "\n",
                                    "//class EventHandling;\n",
                                    "class "
                                }, false));
        txt = Tpl.writeText(txt, l_systemname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "class Functions;"
                                }, false));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_810;

public function generateAlgloopHeaderInlcudeString
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input SimCodeFunction.Context a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  out_txt := fun_810(txt, a_simCode, a_context);
  out_a_extraFuncs := a_extraFuncs;
  out_a_extraFuncsDecl := a_extraFuncsDecl;
  out_a_extraFuncsNamespace := a_extraFuncsNamespace;
end generateAlgloopHeaderInlcudeString;

protected function lm_812
  input Tpl.Text in_txt;
  input list<SimCode.JacobianColumn> in_items;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCode.JacobianColumn> rest;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      list<SimCode.SimEqSystem> i_eqs;

    case ( txt,
           {},
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           SimCode.JAC_COLUMN(columnEqns = i_eqs) :: rest,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = generateAlgloopsSystemVariables(txt, i_eqs, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
        txt = Tpl.nextIter(txt);
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_812(txt, rest, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _ :: rest,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_812(txt, rest, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_812;

protected function lm_813
  input Tpl.Text in_txt;
  input list<SimCode.JacobianMatrix> in_items;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCode.JacobianMatrix> rest;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      list<SimCode.JacobianColumn> i_mat;

    case ( txt,
           {},
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           SimCode.JAC_MATRIX(columns = i_mat) :: rest,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_812(txt, i_mat, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.nextIter(txt);
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_813(txt, rest, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _ :: rest,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_813(txt, rest, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_813;

protected function lm_814
  input Tpl.Text in_txt;
  input list<list<SimCodeVar.SimVar>> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<list<SimCodeVar.SimVar>> rest;
      Integer x_idx;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           _ :: rest )
      equation
        x_idx = Tpl.getIteri_i0(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void getString_"));
        txt = Tpl.writeStr(txt, intString(x_idx));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(string* z);"));
        txt = Tpl.nextIter(txt);
        txt = lm_814(txt, rest);
      then txt;
  end match;
end lm_814;

protected function fun_815
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#define MEASURETIME_MODELFUNCTIONS"));
      then txt;
  end match;
end fun_815;

protected function fun_816
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", public IReduceDAE"));
      then txt;
  end match;
end fun_816;

protected function fun_817
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "#ifdef MEASURETIME_PROFILEBLOCKS\n",
                                    "std::vector<MeasureTimeData*> *measureTimeProfileBlocksArray;\n",
                                    "MeasureTimeValues *measuredProfileBlockStartValues, *measuredProfileBlockEndValues;\n",
                                    "#endif //MEASURETIME_PROFILEBLOCKS\n",
                                    "#ifdef MEASURETIME_MODELFUNCTIONS\n",
                                    "std::vector<MeasureTimeData*> *measureTimeFunctionsArray;\n",
                                    "MeasureTimeValues *measuredFunctionStartValues, *measuredFunctionEndValues;\n",
                                    "#endif //MEASURETIME_MODELFUNCTIONS"
                                }, false));
      then txt;
  end match;
end fun_817;

protected function fun_818
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;
  input String in_a_additionalProtectedMembers;
  input Tpl.Text in_a_clockedfuncs;
  input Tpl.Text in_a_memberfuncs;
  input Tpl.Text in_a_jacalgloopsystems;
  input Tpl.Text in_a_algloopsystems;
  input Tpl.Text in_a_algloopsolvers;
  input Tpl.Text in_a_conditionvariables;
  input String in_a_memberVariableDefinitions;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input String in_a_additionalPublicMembers;
  input Tpl.Text in_a_friendclasses;
  input Absyn.Path in_a_modelInfo_name;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_a_modelInfo, in_a_additionalProtectedMembers, in_a_clockedfuncs, in_a_memberfuncs, in_a_jacalgloopsystems, in_a_algloopsystems, in_a_algloopsolvers, in_a_conditionvariables, in_a_memberVariableDefinitions, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_additionalPublicMembers, in_a_friendclasses, in_a_modelInfo_name)
    local
      Tpl.Text txt;
      String a_additionalProtectedMembers;
      Tpl.Text a_clockedfuncs;
      Tpl.Text a_memberfuncs;
      Tpl.Text a_jacalgloopsystems;
      Tpl.Text a_algloopsystems;
      Tpl.Text a_algloopsolvers;
      Tpl.Text a_conditionvariables;
      String a_memberVariableDefinitions;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      String a_additionalPublicMembers;
      Tpl.Text a_friendclasses;
      Absyn.Path a_modelInfo_name;
      list<SimCodeVar.SimVar> i_vars_stringAliasVars;
      list<SimCodeVar.SimVar> i_vars_stringParamVars;
      list<SimCodeVar.SimVar> i_vars_stringAlgVars;
      Boolean ret_10;
      Boolean ret_9;
      String ret_8;
      Boolean ret_7;
      Boolean ret_6;
      Boolean ret_5;
      String ret_4;
      list<list<SimCodeVar.SimVar>> ret_3;
      list<SimCodeVar.SimVar> ret_2;
      list<SimCodeVar.SimVar> ret_1;
      Tpl.Text l_getstringvars;

    case ( txt,
           SimCode.MODELINFO(vars = SimCodeVar.SIMVARS(stringAlgVars = i_vars_stringAlgVars, stringParamVars = i_vars_stringParamVars, stringAliasVars = i_vars_stringAliasVars)),
           a_additionalProtectedMembers,
           a_clockedfuncs,
           a_memberfuncs,
           a_jacalgloopsystems,
           a_algloopsystems,
           a_algloopsolvers,
           a_conditionvariables,
           a_memberVariableDefinitions,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_additionalPublicMembers,
           a_friendclasses,
           a_modelInfo_name )
      equation
        ret_1 = listAppend(i_vars_stringAlgVars, i_vars_stringParamVars);
        ret_2 = listAppend(ret_1, i_vars_stringAliasVars);
        ret_3 = List.partition(ret_2, 100);
        l_getstringvars = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_getstringvars = lm_814(l_getstringvars, ret_3);
        l_getstringvars = Tpl.popIter(l_getstringvars);
        ret_4 = Flags.getConfigString(Flags.PROFILING_LEVEL);
        ret_5 = stringEq(ret_4, "none");
        ret_6 = boolNot(ret_5);
        txt = fun_815(txt, ret_6);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "class "
                                }, false));
        txt = lastIdentOfPath(txt, a_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(": public IContinuous, public IEvent, public IStepEvent, public ITime, public ISystemProperties "));
        ret_7 = Flags.isSet(Flags.WRITE_TO_BUFFER);
        txt = fun_816(txt, ret_7);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ", public SystemDefaultImplementation\n",
                                    "{\n"
                                }, true));
        txt = Tpl.writeText(txt, a_friendclasses);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("public:\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.writeStr(txt, a_additionalPublicMembers);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = lastIdentOfPath(txt, a_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("(IGlobalSettings* globalSettings, shared_ptr<ISimObjects> simObjects );\n"));
        txt = lastIdentOfPath(txt, a_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = lastIdentOfPath(txt, a_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " &instance);\n",
                                    "\n",
                                    "virtual ~"
                                }, false));
        txt = lastIdentOfPath(txt, a_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "();\n",
                                    "\n"
                                }, true));
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = generateMethodDeclarationCode(txt, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "virtual bool getCondition(unsigned int index);\n",
                                    "\n",
                                    "shared_ptr<IAlgLoopSolverFactory> getAlgLoopSolverFactory();\n",
                                    "\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "protected:\n",
                                    "    //Methods:\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.writeText(txt, l_getstringvars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "bool isConsistent();\n",
                                    "\n",
                                    "//Saves all variables before an event is handled, is needed for the pre, edge and change operator\n",
                                    "void saveAll();\n",
                                    "\n",
                                    "void initStateVars();\n",
                                    "void initDerivativeVars();\n",
                                    "void initAlgVars();\n",
                                    "void initDiscreteAlgVars();\n",
                                    "void initIntAlgVars();\n",
                                    "void initBoolAlgVars();\n",
                                    "void initStringAlgVars();\n",
                                    "void initParameterRealVars();\n",
                                    "void initParameterIntVars();\n",
                                    "void initParameterBoolVars();\n",
                                    "void initParameterStringVars();\n",
                                    "void initAliasRealVars();\n",
                                    "void initAliasIntVars();\n",
                                    "void initAliasBoolVars();\n",
                                    "void initAliasStringVars();\n",
                                    "\n",
                                    "void deleteObjects();\n",
                                    "\n",
                                    "//Variables:\n",
                                    "shared_ptr<EventHandling> _event_handling;\n",
                                    "shared_ptr<DiscreteEvents> _discrete_events;\n",
                                    "bool _state_var_reinitialized;\n",
                                    "\n",
                                    "//pointer to simVars-array to speedup simulation and compile time\n",
                                    "double* _pointerToRealVars;\n",
                                    "int* _pointerToIntVars;\n",
                                    "bool* _pointerToBoolVars;\n",
                                    "string* _pointerToStringVars;\n",
                                    "\n",
                                    "int _dimPartitions;\n",
                                    "bool* _partitionActivation;\n",
                                    "int* _stateActivator;\n",
                                    "\n"
                                }, true));
        txt = Tpl.writeStr(txt, a_memberVariableDefinitions);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, a_conditionvariables);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Functions* _functions;\n",
                                    "\n",
                                    "shared_ptr<IPropertyReader> _reader;\n",
                                    "shared_ptr<IAlgLoopSolverFactory> _algLoopSolverFactory;    ///< Factory that provides an appropriate solver\n"
                                }, true));
        txt = Tpl.writeText(txt, a_algloopsolvers);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, a_algloopsystems);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, a_jacalgloopsystems);
        txt = Tpl.softNewLine(txt);
        ret_8 = Flags.getConfigString(Flags.PROFILING_LEVEL);
        ret_9 = stringEq(ret_8, "none");
        ret_10 = boolNot(ret_9);
        txt = fun_817(txt, ret_10);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/// Equations\n"));
        txt = Tpl.writeText(txt, a_memberfuncs);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "/// Clocked synchronous equations\n",
                                    "void evaluateClocked(int index);\n"
                                }, true));
        txt = Tpl.writeText(txt, a_clockedfuncs);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeStr(txt, a_additionalProtectedMembers);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/*Additional member functions*/\n"));
        txt = Tpl.writeText(txt, a_extraFuncsDecl);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" };"));
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           _,
           _,
           _,
           _,
           _,
           _,
           _,
           _,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _,
           _,
           _ )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_818;

protected function fun_819
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input String in_a_additionalPublicMembers;
  input String in_a_additionalProtectedMembers;
  input String in_a_memberVariableDefinitions;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace) :=
  match(in_txt, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_additionalPublicMembers, in_a_additionalProtectedMembers, in_a_memberVariableDefinitions)
    local
      Tpl.Text txt;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      String a_additionalPublicMembers;
      String a_additionalProtectedMembers;
      String a_memberVariableDefinitions;
      Absyn.Path i_modelInfo_name;
      list<BackendDAE.ZeroCrossing> i_zeroCrossings;
      list<SimCode.JacobianMatrix> i_jacobianMatrixes;
      SimCode.ModelInfo i_modelInfo;
      SimCode.SimCode i_simCode;
      list<SimCode.ClockedPartition> i_clockedPartitions;
      list<SimCode.SimEqSystem> i_initialEquations;
      list<SimCode.SimEqSystem> i_allEquations;
      Tpl.Text l_conditionvariables;
      list<SimCode.SubPartition> ret_14;
      Tpl.Text l_clockedfuncs;
      Tpl.Text l_memberfuncs;
      Tpl.Text l_jacalgloopsystems;
      list<SimCode.SimEqSystem> ret_10;
      list<SimCode.SimEqSystem> ret_9;
      list<SimCode.SubPartition> ret_8;
      list<SimCode.SimEqSystem> ret_7;
      Tpl.Text l_algloopsystems;
      Tpl.Text l_algloopsolvers;
      list<SimCode.SimEqSystem> ret_4;
      list<SimCode.SimEqSystem> ret_3;
      list<SimCode.SubPartition> ret_2;
      list<SimCode.SimEqSystem> ret_1;
      Tpl.Text l_friendclasses;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = (i_modelInfo as SimCode.MODELINFO(name = i_modelInfo_name)), allEquations = i_allEquations, initialEquations = i_initialEquations, clockedPartitions = i_clockedPartitions, jacobianMatrixes = i_jacobianMatrixes, zeroCrossings = i_zeroCrossings)),
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_additionalPublicMembers,
           a_additionalProtectedMembers,
           a_memberVariableDefinitions )
      equation
        ret_1 = listAppend(i_allEquations, i_initialEquations);
        ret_2 = SimCodeUtil.getSubPartitions(i_clockedPartitions);
        ret_3 = SimCodeUtil.getClockedEquations(ret_2);
        ret_4 = listAppend(ret_1, ret_3);
        (l_friendclasses, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = generatefriendAlgloops(Tpl.emptyTxt, ret_4, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
        (l_algloopsolvers, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = generateAlgloopsolverVariables(Tpl.emptyTxt, i_modelInfo, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
        ret_7 = listAppend(i_allEquations, i_initialEquations);
        ret_8 = SimCodeUtil.getSubPartitions(i_clockedPartitions);
        ret_9 = SimCodeUtil.getClockedEquations(ret_8);
        ret_10 = listAppend(ret_7, ret_9);
        (l_algloopsystems, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = generateAlgloopsSystemVariables(Tpl.emptyTxt, ret_10, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
        l_jacalgloopsystems = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING("")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_jacalgloopsystems, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_813(l_jacalgloopsystems, i_jacobianMatrixes, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, i_simCode);
        l_jacalgloopsystems = Tpl.popIter(l_jacalgloopsystems);
        (l_memberfuncs, _) = generateEquationMemberFuncDecls(Tpl.emptyTxt, i_allEquations, Tpl.strTokText(Tpl.ST_STRING("evaluate")));
        ret_14 = SimCodeUtil.getSubPartitions(i_clockedPartitions);
        (l_clockedfuncs, _) = generateClockedFuncDecls(Tpl.emptyTxt, ret_14, Tpl.strTokText(Tpl.ST_STRING("evaluate")));
        (l_conditionvariables, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = conditionvariable(Tpl.emptyTxt, i_zeroCrossings, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_818(txt, i_modelInfo, a_additionalProtectedMembers, l_clockedfuncs, l_memberfuncs, l_jacalgloopsystems, l_algloopsystems, l_algloopsolvers, l_conditionvariables, a_memberVariableDefinitions, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, i_simCode, a_additionalPublicMembers, l_friendclasses, i_modelInfo_name);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);

    case ( txt,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           _,
           _,
           _ )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
  end match;
end fun_819;

public function generateClassDeclarationCode
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input String a_additionalPublicMembers;
  input String a_additionalProtectedMembers;
  input String a_memberVariableDefinitions;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace) := fun_819(txt, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_additionalPublicMembers, a_additionalProtectedMembers, a_memberVariableDefinitions);
end generateClassDeclarationCode;

protected function fun_821
  input Tpl.Text in_txt;
  input SimCode.SubPartition in_a_subPartition;
  input Tpl.Text in_a_method;
  input Integer in_a_i;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_method;
algorithm
  (out_txt, out_a_method) :=
  match(in_txt, in_a_subPartition, in_a_method, in_a_i)
    local
      Tpl.Text txt;
      Tpl.Text a_method;
      Integer a_i;
      list<SimCode.SimEqSystem> i_removedEquations;
      list<SimCode.SimEqSystem> i_equations;
      list<SimCode.SimEqSystem> ret_0;

    case ( txt,
           SimCode.SUBPARTITION(equations = i_equations, removedEquations = i_removedEquations),
           a_method,
           a_i )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/// Clocked partition "));
        txt = Tpl.writeStr(txt, intString(a_i));
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void evaluateClocked"));
        txt = Tpl.writeStr(txt, intString(a_i));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(const UPDATETYPE command);\n",
                                    "\n",
                                    "\n"
                                }, true));
        ret_0 = listAppend(i_equations, i_removedEquations);
        (txt, a_method) = generateEquationMemberFuncDecls(txt, ret_0, a_method);
      then (txt, a_method);

    case ( txt,
           _,
           a_method,
           _ )
      then (txt, a_method);
  end match;
end fun_821;

protected function lm_822
  input Tpl.Text in_txt;
  input list<SimCode.SubPartition> in_items;
  input Tpl.Text in_a_method;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_method;
algorithm
  (out_txt, out_a_method) :=
  match(in_txt, in_items, in_a_method)
    local
      Tpl.Text txt;
      list<SimCode.SubPartition> rest;
      Tpl.Text a_method;
      Integer x_i;
      SimCode.SubPartition i_subPartition;

    case ( txt,
           {},
           a_method )
      then (txt, a_method);

    case ( txt,
           i_subPartition :: rest,
           a_method )
      equation
        x_i = Tpl.getIteri_i0(txt);
        (txt, a_method) = fun_821(txt, i_subPartition, a_method, x_i);
        txt = Tpl.nextIter(txt);
        (txt, a_method) = lm_822(txt, rest, a_method);
      then (txt, a_method);
  end match;
end lm_822;

public function generateClockedFuncDecls
  input Tpl.Text txt;
  input list<SimCode.SubPartition> a_subPartitions;
  input Tpl.Text a_method;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_method;
protected
  Tpl.Text l_decls;
algorithm
  l_decls := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(1, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (l_decls, out_a_method) := lm_822(l_decls, a_subPartitions, a_method);
  l_decls := Tpl.popIter(l_decls);
  out_txt := Tpl.writeText(txt, l_decls);
end generateClockedFuncDecls;

protected function lm_824
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input Tpl.Text in_a_method;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_method;
algorithm
  (out_txt, out_a_method) :=
  match(in_txt, in_items, in_a_method)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      Tpl.Text a_method;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           {},
           a_method )
      then (txt, a_method);

    case ( txt,
           i_eq :: rest,
           a_method )
      equation
        (txt, a_method) = generateEquationMemberFuncDecls2(txt, i_eq, a_method);
        txt = Tpl.nextIter(txt);
        (txt, a_method) = lm_824(txt, rest, a_method);
      then (txt, a_method);
  end match;
end lm_824;

public function generateEquationMemberFuncDecls
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_a_allEquations;
  input Tpl.Text in_a_method;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_method;
algorithm
  (out_txt, out_a_method) :=
  match(in_txt, in_a_allEquations, in_a_method)
    local
      Tpl.Text txt;
      Tpl.Text a_method;
      list<SimCode.SimEqSystem> i_allEquations;
      Tpl.Text l_equation__func__decls;

    case ( txt,
           i_allEquations,
           a_method )
      equation
        l_equation__func__decls = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_equation__func__decls, a_method) = lm_824(l_equation__func__decls, i_allEquations, a_method);
        l_equation__func__decls = Tpl.popIter(l_equation__func__decls);
        txt = Tpl.writeText(txt, l_equation__func__decls);
      then (txt, a_method);
  end match;
end generateEquationMemberFuncDecls;

protected function fun_826
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input Tpl.Text in_a_method;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_eq, in_a_method)
    local
      Tpl.Text txt;
      Tpl.Text a_method;
      SimCode.SimEqSystem i_eq;
      SimCode.SimEqSystem i_e;
      SimCode.SimEqSystem i_e_cont;

    case ( txt,
           (i_e as SimCode.SES_MIXED(cont = i_e_cont)),
           a_method )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = Tpl.writeText(txt, a_method);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = CodegenUtilSimulation.equationIndex(txt, i_e_cont);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "();\n",
                                    "void "
                                }, false));
        txt = Tpl.writeText(txt, a_method);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = CodegenUtilSimulation.equationIndex(txt, i_e);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("();"));
      then txt;

    case ( txt,
           i_eq,
           a_method )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("FORCE_INLINE void "));
        txt = Tpl.writeText(txt, a_method);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = CodegenUtilSimulation.equationIndex(txt, i_eq);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("();"));
      then txt;
  end match;
end fun_826;

public function generateEquationMemberFuncDecls2
  input Tpl.Text txt;
  input SimCode.SimEqSystem a_eq;
  input Tpl.Text a_method;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_method;
algorithm
  out_txt := fun_826(txt, a_eq, a_method);
  out_a_method := a_method;
end generateEquationMemberFuncDecls2;

protected function fun_828
  input Tpl.Text in_txt;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_modelname;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_context, in_a_modelname)
    local
      Tpl.Text txt;
      Tpl.Text a_modelname;

    case ( txt,
           SimCodeFunction.ALGLOOP_CONTEXT(genInitialisation = false, genJacobian = true),
           a_modelname )
      equation
        txt = Tpl.writeText(txt, a_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Jacobian"));
      then txt;

    case ( txt,
           _,
           a_modelname )
      equation
        txt = Tpl.writeText(txt, a_modelname);
      then txt;
  end match;
end fun_828;

protected function fun_829
  input Tpl.Text in_txt;
  input String in_mArg;
  input Tpl.Text in_a_size;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_size)
    local
      Tpl.Text txt;
      Tpl.Text a_size;

    case ( txt,
           "dense",
           a_size )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " matrix_t __A; //dense\n",
                                    "\n",
                                    " //b vector\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("StatArrayDim1<double,"));
        txt = Tpl.writeText(txt, a_size);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("> __b;"));
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           "sparse",
           a_size )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " sparsematrix_t __A; //sparse\n",
                                    "\n",
                                    " //b vector\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("StatArrayDim1<double,"));
        txt = Tpl.writeText(txt, a_size);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("> __b;"));
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("A matrix type is not supported"));
      then txt;
  end match;
end fun_829;

protected function fun_830
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_eq)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> i_ls_vars;
      String str_4;
      String ret_3;
      Tpl.Text l_type;
      Integer ret_1;
      Tpl.Text l_size;

    case ( txt,
           SimCode.SES_LINEAR(lSystem = SimCode.LINEARSYSTEM(vars = i_ls_vars)) )
      equation
        ret_1 = listLength(i_ls_vars);
        l_size = Tpl.writeStr(Tpl.emptyTxt, intString(ret_1));
        ret_3 = Flags.getConfigString(Flags.MATRIX_FORMAT);
        l_type = Tpl.writeStr(Tpl.emptyTxt, ret_3);
        str_4 = Tpl.textString(l_type);
        txt = fun_829(txt, str_4, l_size);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_830;

protected function fun_831
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input Tpl.Text in_a_amatrix;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_systemname;
  input Tpl.Text in_a_modelname;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_a_eq, in_a_amatrix, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_systemname, in_a_modelname)
    local
      Tpl.Text txt;
      Tpl.Text a_amatrix;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_systemname;
      Tpl.Text a_modelname;
      list<DAE.ComponentRef> i_nls_crefs;
      Integer i_nls_index;
      list<SimCodeVar.SimVar> i_ls_vars;
      Integer i_ls_index;
      Integer ret_3;
      Integer ret_2;
      String ret_1;
      Tpl.Text l_type;

    case ( txt,
           SimCode.SES_LINEAR(lSystem = SimCode.LINEARSYSTEM(index = i_ls_index, vars = i_ls_vars)),
           a_amatrix,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_systemname,
           a_modelname )
      equation
        ret_1 = Flags.getConfigString(Flags.MATRIX_FORMAT);
        l_type = Tpl.writeStr(Tpl.emptyTxt, ret_1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("class "));
        txt = Tpl.writeText(txt, a_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeStr(txt, intString(i_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ": public ILinearAlgLoop, public LinearAlgLoopDefaultImplementation\n",
                                    "{\n",
                                    " public:\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeStr(txt, intString(i_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_systemname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "* system,\n",
                                    "                                 double* z, double* zDot, bool* conditions,\n",
                                    "                                 shared_ptr<DiscreteEvents> discrete_events);\n",
                                    "virtual ~"
                                }, false));
        txt = Tpl.writeText(txt, a_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeStr(txt, intString(i_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "();\n",
                                    "\n"
                                }, true));
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = generateAlgloopMethodDeclarationCode(txt, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "/// Provide the right hand side (residuals)\n",
                                    "virtual void getb(double* vars) const;\n",
                                    "virtual const matrix_t& getAMatrix() ;\n",
                                    "virtual sparsematrix_t& getSparseAMatrix() ;\n",
                                    "\n",
                                    "bool getFreeVariablesLock();\n",
                                    "bool getUseSparseFormat();\n",
                                    "\n",
                                    "void setUseSparseFormat(bool value);\n",
                                    "float queryDensity();\n",
                                    "virtual int getDimZeroFunc() const;\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" private:\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("AlgloopVarAttributes _vars["));
        ret_2 = listLength(i_ls_vars);
        txt = Tpl.writeStr(txt, intString(ret_2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "];\n",
                                    "Functions* _functions;\n",
                                    "//states\n",
                                    "double* __z;\n",
                                    "//state derivatives\n",
                                    "double* __zDot;\n",
                                    "// A matrix\n"
                                }, true));
        txt = Tpl.writeText(txt, a_amatrix);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "bool* _conditions;\n",
                                    "shared_ptr<DiscreteEvents> _discrete_events;\n"
                                }, true));
        txt = Tpl.writeText(txt, a_systemname);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("* _system;\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("};"));
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           SimCode.SES_NONLINEAR(nlSystem = SimCode.NONLINEARSYSTEM(index = i_nls_index, crefs = i_nls_crefs)),
           _,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_systemname,
           a_modelname )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("class "));
        txt = Tpl.writeText(txt, a_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeStr(txt, intString(i_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ": public INonLinearAlgLoop, public NonLinearAlgLoopDefaultImplementation\n",
                                    "{\n",
                                    " public:\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeStr(txt, intString(i_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_systemname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "* system,\n",
                                    "                                  double* z,double* zDot, bool* conditions,\n",
                                    "                                  shared_ptr<DiscreteEvents> discrete_events);\n",
                                    "virtual ~"
                                }, false));
        txt = Tpl.writeText(txt, a_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeStr(txt, intString(i_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "();\n",
                                    "\n"
                                }, true));
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = generateAlgloopMethodDeclarationCode(txt, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "/// Provide the right hand side (residuals)\n",
                                    "virtual void getRHS(double* vars) const;\n",
                                    "virtual const matrix_t& getSystemMatrix() ;\n",
                                    "virtual sparsematrix_t& getSystemSparseMatrix() ;\n",
                                    "\n",
                                    "bool getUseSparseFormat();\n",
                                    "void setUseSparseFormat(bool value);\n",
                                    "float queryDensity();\n",
                                    "virtual int getDimZeroFunc() const;\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("private:\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("AlgloopVarAttributes _vars["));
        ret_3 = listLength(i_nls_crefs);
        txt = Tpl.writeStr(txt, intString(ret_3));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "];\n",
                                    "Functions* _functions;\n",
                                    "//states\n",
                                    "double* __z;\n",
                                    "//state derivatives\n",
                                    "double* __zDot;\n",
                                    "bool* _conditions;\n",
                                    "shared_ptr<DiscreteEvents> _discrete_events;\n"
                                }, true));
        txt = Tpl.writeText(txt, a_systemname);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("* _system;\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" };"));
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           _,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _,
           _ )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_831;

public function generateAlgloopClassDeclarationCode
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input SimCode.SimEqSystem in_a_eq;
  input SimCodeFunction.Context in_a_context;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace) :=
  match(in_txt, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_eq, in_a_context, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      SimCode.SimEqSystem a_eq;
      SimCodeFunction.Context a_context;
      Boolean a_useFlatArrayNotation;
      SimCode.SimCode i_simCode;
      SimCode.ModelInfo i_modelInfo;
      Absyn.Path i_modelInfo_name;
      Tpl.Text l_constructorParams;
      Tpl.Text l_algvars;
      Tpl.Text l_amatrix;
      Tpl.Text l_systemname;
      Tpl.Text l_modelname;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = (i_modelInfo as SimCode.MODELINFO(name = i_modelInfo_name)))),
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_eq,
           a_context,
           a_useFlatArrayNotation )
      equation
        l_modelname = lastIdentOfPath(Tpl.emptyTxt, i_modelInfo_name);
        l_systemname = fun_828(Tpl.emptyTxt, a_context, l_modelname);
        l_amatrix = fun_830(Tpl.emptyTxt, a_eq);
        l_algvars = memberVariableAlgloop(Tpl.emptyTxt, i_modelInfo, a_useFlatArrayNotation);
        l_constructorParams = constructorParamAlgloop(Tpl.emptyTxt, i_modelInfo, a_useFlatArrayNotation);
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_831(txt, a_eq, l_amatrix, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, i_simCode, l_systemname, l_modelname);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);

    case ( txt,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           _,
           _,
           _ )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
  end match;
end generateAlgloopClassDeclarationCode;

protected function smf_833
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_it;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_it, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           i_eq,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = writeoutputAlgloopsolvers(txt, i_eq, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end smf_833;

protected function lm_834
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      SimCode.SimEqSystem i_eqs;

    case ( txt,
           {},
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           i_eqs :: rest,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = smf_833(txt, i_eqs, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
        txt = Tpl.nextIter(txt);
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_834(txt, rest, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_834;

protected function lm_835
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      SimCode.SimEqSystem i_eqn;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           i_eqn :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = writeoutput3(txt, i_eqn, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_835(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_835;

protected function fun_836
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input SimCode.ModelInfo in_a_modelInfo;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input list<SimCode.SimEqSystem> in_a_allEquations;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_mArg, in_a_modelInfo, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_allEquations)
    local
      Tpl.Text txt;
      SimCode.ModelInfo a_modelInfo;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      list<SimCode.SimEqSystem> a_allEquations;

    case ( txt,
           false,
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("  SystemDefaultImplementation::getRHS(f);"));
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           a_modelInfo,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_allEquations )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "if(_callType & IContinuous::RANKING)\n",
                                    "{\n",
                                    "\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_834(txt, a_allEquations, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("double residues [] = {"));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_835(txt, a_allEquations, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "};\n",
                                    "for(int i=0;i<"
                                }, false));
        txt = numResidues(txt, a_allEquations, a_modelInfo);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";i++) *(f+i) = residues[i];\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "else SystemDefaultImplementation::getRHS(f);"
                                }, false));
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_836;

public function DefaultImplementationCode
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      SimCode.SimCode i_simCode;
      list<SimCodeVar.SimVar> i_states;
      SimCode.ModelInfo i_modelInfo;
      list<SimCode.SimEqSystem> i_allEquations;
      Absyn.Path i_modelInfo_name;
      Boolean ret_0;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = (i_modelInfo as SimCode.MODELINFO(vars = SimCodeVar.SIMVARS(stateVars = i_states), name = i_modelInfo_name)), allEquations = i_allEquations)),
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "// Release instance\n",
                                    "void "
                                }, false));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::destroy()\n",
                                    "{\n",
                                    "  delete this;\n",
                                    "}\n",
                                    "\n",
                                    "// Set current integration time\n",
                                    "void "
                                }, false));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::setTime(const double& t)\n",
                                    "{\n",
                                    "  SystemDefaultImplementation::setTime(t);\n",
                                    "}\n",
                                    "// Computes the conditions of time event samplers for the current time\n",
                                    "double "
                                }, false));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::computeNextTimeEvents(double currTime)\n",
                                    "{\n",
                                    "  return SystemDefaultImplementation::computeNextTimeEvents(currTime, getTimeEventData());\n",
                                    "}\n",
                                    "// Computes the conditions of time event samplers for the current time\n",
                                    "void "
                                }, false));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::computeTimeEventConditions(double currTime)\n",
                                    "{\n",
                                    "  SystemDefaultImplementation::computeTimeEventConditions(currTime);\n",
                                    "}\n",
                                    "// Resets the conditions of time event samplers to false\n",
                                    "void "
                                }, false));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::resetTimeConditions()\n",
                                    "{\n",
                                    "  SystemDefaultImplementation::resetTimeConditions();\n",
                                    "}\n",
                                    "// Provide number (dimension) of variables according to the index\n",
                                    "int "
                                }, false));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::getDimContinuousStates() const\n",
                                    "{\n",
                                    "  return(SystemDefaultImplementation::getDimContinuousStates());\n",
                                    "}\n",
                                    "int "
                                }, false));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::getDimAE() const\n",
                                    "{\n",
                                    "  return(SystemDefaultImplementation::getDimAE());\n",
                                    "}\n",
                                    "// Provide number (dimension) of variables according to the index\n",
                                    "int "
                                }, false));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::getDimBoolean() const\n",
                                    "{\n",
                                    "  return(SystemDefaultImplementation::getDimBoolean());\n",
                                    "}\n",
                                    "\n",
                                    "// Provide number (dimension) of variables according to the index\n",
                                    "int "
                                }, false));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::getDimInteger() const\n",
                                    "{\n",
                                    "  return(SystemDefaultImplementation::getDimInteger());\n",
                                    "}\n",
                                    "\n",
                                    "// Provide number (dimension) of variables according to the index\n",
                                    "int "
                                }, false));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::getDimReal() const\n",
                                    "{\n",
                                    "  return(SystemDefaultImplementation::getDimReal());\n",
                                    "}\n",
                                    "\n",
                                    "// Provide number (dimension) of variables according to the index\n",
                                    "int "
                                }, false));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::getDimString() const\n",
                                    "{\n",
                                    "  return(SystemDefaultImplementation::getDimString());\n",
                                    "}\n",
                                    "\n",
                                    "// Provide number (dimension) of right hand sides (equations and/or residuals) according to the index\n",
                                    "int "
                                }, false));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::getDimRHS() const\n",
                                    "{\n",
                                    " if(_callType & IContinuous::RANKING)\n",
                                    "  {\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("return "));
        txt = numResidues(txt, i_allEquations, i_modelInfo);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "}\n",
                                    "else\n",
                                    "return(SystemDefaultImplementation::getDimRHS());\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n",
                                    "void "
                                }, false));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::getContinuousStates(double* z)\n",
                                    "{\n",
                                    "  SystemDefaultImplementation::getContinuousStates(z);\n",
                                    "}\n",
                                    "void "
                                }, false));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::getNominalStates(double* z)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = getNominalStateValues(txt, i_states, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n",
                                    "// Set variables with given index to the system\n",
                                    "void "
                                }, false));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::setContinuousStates(const double* z)\n",
                                    "{\n",
                                    "  SystemDefaultImplementation::setContinuousStates(z);\n",
                                    "}\n",
                                    "\n",
                                    "double& "
                                }, false));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::getRealStartValue(double& var)\n",
                                    "{\n",
                                    "   return SystemDefaultImplementation::getRealStartValue(var);\n",
                                    " }\n",
                                    "\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("bool& "));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::getBoolStartValue(bool& var)\n",
                                    "{\n",
                                    "  return SystemDefaultImplementation::getBoolStartValue(var);\n",
                                    "}\n",
                                    "\n",
                                    "int& "
                                }, false));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::getIntStartValue(int& var)\n",
                                    "{\n",
                                    "  return SystemDefaultImplementation::getIntStartValue(var);\n",
                                    "}\n",
                                    "\n",
                                    "string& "
                                }, false));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::getStringStartValue(string& var)\n",
                                    "{\n",
                                    "  return SystemDefaultImplementation::getStringStartValue(var);\n",
                                    "}\n",
                                    "\n",
                                    "void "
                                }, false));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::setRealStartValue(double& var,double val)\n",
                                    "{\n",
                                    "  SystemDefaultImplementation::setRealStartValue(var, val);\n",
                                    "}\n",
                                    "\n",
                                    "void "
                                }, false));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::setBoolStartValue(bool& var,bool val)\n",
                                    "{\n",
                                    "  SystemDefaultImplementation::setBoolStartValue(var, val);\n",
                                    "}\n",
                                    "\n",
                                    "void "
                                }, false));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::setIntStartValue(int& var,int val)\n",
                                    "{\n",
                                    "  SystemDefaultImplementation::setIntStartValue(var, val);\n",
                                    "}\n",
                                    "\n",
                                    "void "
                                }, false));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::setStringStartValue(string& var,string val)\n",
                                    "{\n",
                                    "  SystemDefaultImplementation::setStringStartValue(var, val);\n",
                                    "}\n",
                                    "\n",
                                    "void "
                                }, false));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::setNumPartitions(int numPartitions)\n",
                                    "{\n",
                                    "  _dimPartitions = numPartitions;\n",
                                    "}\n",
                                    "\n",
                                    "int "
                                }, false));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::getNumPartitions()\n",
                                    "{\n",
                                    "  return _dimPartitions;\n",
                                    "}\n",
                                    "void "
                                }, false));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::setPartitionActivation(bool* partitions)\n",
                                    "{\n",
                                    "  _partitionActivation = partitions;\n",
                                    "}\n",
                                    "\n",
                                    "void "
                                }, false));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::getPartitionActivation(bool* partitions)\n",
                                    "{\n",
                                    "  partitions = _partitionActivation;\n",
                                    "}\n",
                                    "\n",
                                    "int "
                                }, false));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::getActivator(int state)\n",
                                    "{\n",
                                    "  return (int)_stateActivator[state];\n",
                                    "}\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "// Provide the right hand side\n",
                                    "void "
                                }, false));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::getRHS(double* f)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        ret_0 = Flags.isSet(Flags.WRITE_TO_BUFFER);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_836(txt, ret_0, i_modelInfo, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, i_simCode, i_allEquations);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n",
                                    "void "
                                }, false));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::setStateDerivatives(const double* f)\n",
                                    "{\n",
                                    "  SystemDefaultImplementation::setStateDerivatives(f);\n",
                                    "}\n",
                                    "bool "
                                }, false));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::isStepEvent()\n",
                                    "{\n",
                                    " throw ModelicaSimulationError(MODEL_EQ_SYSTEM,\"isStepEvent is not yet implemented\");\n",
                                    "}\n",
                                    "void "
                                }, false));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::setTerminal(bool terminal)\n",
                                    "{\n",
                                    "  _terminal=terminal;\n",
                                    "}\n",
                                    "bool "
                                }, false));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::terminal()\n",
                                    "{\n",
                                    "  return _terminal;\n",
                                    "}\n",
                                    "bool "
                                }, false));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::isAlgebraic()\n",
                                    "{\n",
                                    "  return false; // Indexreduction is enabled\n",
                                    "}\n",
                                    "bool "
                                }, false));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::provideSymbolicJacobian()\n",
                                    "{\n",
                                    "  throw ModelicaSimulationError(MODEL_EQ_SYSTEM,\"provideSymbolicJacobian is not yet implemented\");\n",
                                    "}\n",
                                    "void "
                                }, false));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::handleEvent(const bool* events)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = handleEvent(txt, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end DefaultImplementationCode;

protected function fun_838
  input Tpl.Text in_txt;
  input Option<DAE.Exp> in_a_nominalValue;
  input Integer in_a_i0;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_a_nominalValue, in_a_i0, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      Integer a_i0;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      DAE.Exp i_val;
      Tpl.Text l_value;
      Tpl.Text l_varDecls;
      Tpl.Text l_preExp;

    case ( txt,
           SOME(i_val),
           a_i0,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        l_preExp = Tpl.emptyTxt;
        l_varDecls = Tpl.emptyTxt;
        (l_value, l_preExp, l_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.daeExp(Tpl.emptyTxt, i_val, SimCodeFunction.contextOther, l_preExp, l_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeText(txt, l_varDecls);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("z["));
        txt = Tpl.writeStr(txt, intString(a_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("]="));
        txt = Tpl.writeText(txt, l_value);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.popBlock(txt);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           a_i0,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("z["));
        txt = Tpl.writeStr(txt, intString(a_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = 1.0;"));
        txt = Tpl.popBlock(txt);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_838;

protected function lm_839
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Integer x_i0;
      Option<DAE.Exp> i_nominalValue;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           SimCodeVar.SIMVAR(nominalValue = i_nominalValue) :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_838(txt, i_nominalValue, x_i0, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_839(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _ :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_839(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_839;

public function getNominalStateValues
  input Tpl.Text txt;
  input list<SimCodeVar.SimVar> a_stateVars;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
protected
  Tpl.Text l_nominalVars;
algorithm
  l_nominalVars := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (l_nominalVars, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) := lm_839(l_nominalVars, a_stateVars, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
  l_nominalVars := Tpl.popIter(l_nominalVars);
  out_txt := Tpl.writeText(txt, l_nominalVars);
end getNominalStateValues;

protected function fun_841
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_modelname;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_a_eq, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_context, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_modelname)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      SimCodeFunction.Context a_context;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_modelname;
      SimCode.SimEqSystem i_eq;
      Integer i_ls_index;
      Tpl.Text l_index;

    case ( txt,
           (i_eq as SimCode.SES_LINEAR(lSystem = SimCode.LINEARSYSTEM(index = i_ls_index))),
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_context,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_modelname )
      equation
        l_index = Tpl.writeStr(Tpl.emptyTxt, intString(i_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "/// Provide index of equation\n",
                                    "int "
                                }, false));
        txt = Tpl.writeText(txt, a_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeText(txt, l_index);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::getEquationIndex() const\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("return "));
        txt = Tpl.writeText(txt, l_index);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n",
                                    "/// Provide number (dimension) of variables according to data type\n",
                                    "int "
                                }, false));
        txt = Tpl.writeText(txt, a_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeText(txt, l_index);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::getDimReal() const\n",
                                    "{\n",
                                    "  return LinearAlgLoopDefaultImplementation::getDimReal();\n",
                                    "}\n",
                                    "\n",
                                    "bool "
                                }, false));
        txt = Tpl.writeText(txt, a_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeText(txt, l_index);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::isConsistent()\n",
                                    "{\n",
                                    "  return _system->isConsistent();\n",
                                    "}\n",
                                    "\n",
                                    "/// Provide names of alg loop variables\n",
                                    "void "
                                }, false));
        txt = Tpl.writeText(txt, a_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeText(txt, l_index);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::getNamesReal(const char** names) const\n",
                                    "{\n",
                                    "  for (int i = 0; i < _dimAEq; i++)\n",
                                    "    names[i] = _vars[i].name;\n",
                                    "}\n",
                                    "\n",
                                    "/// Provide nominal values for alg loop variables\n",
                                    "void "
                                }, false));
        txt = Tpl.writeText(txt, a_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeText(txt, l_index);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::getNominalReal(double* nominals) const\n",
                                    "{\n",
                                    "  for (int i = 0; i < _dimAEq; i++)\n",
                                    "    nominals[i] = _vars[i].nominal;\n",
                                    "}\n",
                                    "\n",
                                    "/// Provide min values for alg loop variables\n",
                                    "void "
                                }, false));
        txt = Tpl.writeText(txt, a_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeText(txt, l_index);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::getMinReal(double* mins) const\n",
                                    "{\n",
                                    "  for (int i = 0; i < _dimAEq; i++)\n",
                                    "    mins[i] = _vars[i].minValue;\n",
                                    "}\n",
                                    "\n",
                                    "/// Provide max values for alg loop variables\n",
                                    "void "
                                }, false));
        txt = Tpl.writeText(txt, a_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeText(txt, l_index);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::getMaxReal(double* maxs) const\n",
                                    "{\n",
                                    "  for (int i = 0; i < _dimAEq; i++)\n",
                                    "    maxs[i] = _vars[i].maxValue;\n",
                                    "}\n",
                                    "\n",
                                    "/// Return simulation time\n",
                                    "double "
                                }, false));
        txt = Tpl.writeText(txt, a_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeText(txt, l_index);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::getSimTime() const\n",
                                    "{\n",
                                    "  return _system->_simTime;\n",
                                    "}\n",
                                    "\n",
                                    "/// Provide variables with given index to the system\n",
                                    "void "
                                }, false));
        txt = Tpl.writeText(txt, a_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeText(txt, l_index);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::getReal(double* vars) const\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = getAlgloopVars(txt, i_eq, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_context, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n",
                                    "/// Set variables with given index to the system\n",
                                    "void "
                                }, false));
        txt = Tpl.writeText(txt, a_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeText(txt, l_index);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::setReal(const double* vars)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = setAlgloopVars(txt, i_eq, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_context, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    " /// Set start values\n",
                                    "void "
                                }, false));
        txt = Tpl.writeText(txt, a_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeText(txt, l_index);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::setRealStartValues()\n",
                                    "{\n",
                                    "   getReal(_x0);\n",
                                    "}\n",
                                    "void "
                                }, false));
        txt = Tpl.writeText(txt, a_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeText(txt, l_index);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::getRealStartValues(double* vars) const\n",
                                    "{\n",
                                    "   LinearAlgLoopDefaultImplementation::getRealStartValues(vars);\n",
                                    "}"
                                }, false));
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           _,
           a_stateDerVectorName,
           _,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      equation
        txt = CodegenCppCommonOld.error(txt, Tpl.sourceInfo("CodegenCppOld.tpl", 7454, 9), "Unsupported equation system type");
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_841;

public function LinearalgloopDefaultImplementationCode
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input SimCode.SimEqSystem in_a_eq;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_eq, in_a_context, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      SimCode.SimEqSystem a_eq;
      SimCodeFunction.Context a_context;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      SimCode.SimCode i_simCode;
      Absyn.Path i_modelInfo_name;
      Tpl.Text l_modelname;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = i_modelInfo_name))),
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_eq,
           a_context,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_modelname = lastIdentOfPath(Tpl.emptyTxt, i_modelInfo_name);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_841(txt, a_eq, a_useFlatArrayNotation, a_stateDerVectorName, a_context, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, i_simCode, l_modelname);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           _,
           _,
           a_stateDerVectorName,
           _ )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end LinearalgloopDefaultImplementationCode;

protected function fun_843
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_modelname;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_a_eq, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_context, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_modelname)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      SimCodeFunction.Context a_context;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_modelname;
      SimCode.SimEqSystem i_eq;
      Integer i_nls_index;
      Tpl.Text l_index;

    case ( txt,
           (i_eq as SimCode.SES_NONLINEAR(nlSystem = SimCode.NONLINEARSYSTEM(index = i_nls_index))),
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_context,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_modelname )
      equation
        l_index = Tpl.writeStr(Tpl.emptyTxt, intString(i_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "/// Provide index of equation\n",
                                    "int "
                                }, false));
        txt = Tpl.writeText(txt, a_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeText(txt, l_index);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::getEquationIndex() const\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("return "));
        txt = Tpl.writeText(txt, l_index);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n",
                                    "/// Provide number (dimension) of variables according to data type\n",
                                    "int "
                                }, false));
        txt = Tpl.writeText(txt, a_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeText(txt, l_index);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::getDimReal() const\n",
                                    "{\n",
                                    "  return NonLinearAlgLoopDefaultImplementation::getDimReal();\n",
                                    "}\n",
                                    "\n",
                                    "bool "
                                }, false));
        txt = Tpl.writeText(txt, a_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeText(txt, l_index);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::isConsistent()\n",
                                    "{\n",
                                    "  return _system->isConsistent();\n",
                                    "}\n",
                                    "\n",
                                    "/// Provide names of alg loop variables\n",
                                    "void "
                                }, false));
        txt = Tpl.writeText(txt, a_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeText(txt, l_index);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::getNamesReal(const char** names) const\n",
                                    "{\n",
                                    "  for (int i = 0; i < _dimAEq; i++)\n",
                                    "    names[i] = _vars[i].name;\n",
                                    "}\n",
                                    "\n",
                                    "/// Provide nominal values for alg loop variables\n",
                                    "void "
                                }, false));
        txt = Tpl.writeText(txt, a_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeText(txt, l_index);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::getNominalReal(double* nominals) const\n",
                                    "{\n",
                                    "  for (int i = 0; i < _dimAEq; i++)\n",
                                    "    nominals[i] = _vars[i].nominal;\n",
                                    "}\n",
                                    "\n",
                                    "/// Provide min values for alg loop variables\n",
                                    "void "
                                }, false));
        txt = Tpl.writeText(txt, a_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeText(txt, l_index);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::getMinReal(double* mins) const\n",
                                    "{\n",
                                    "  for (int i = 0; i < _dimAEq; i++)\n",
                                    "    mins[i] = _vars[i].minValue;\n",
                                    "}\n",
                                    "\n",
                                    "/// Provide max values for alg loop variables\n",
                                    "void "
                                }, false));
        txt = Tpl.writeText(txt, a_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeText(txt, l_index);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::getMaxReal(double* maxs) const\n",
                                    "{\n",
                                    "  for (int i = 0; i < _dimAEq; i++)\n",
                                    "    maxs[i] = _vars[i].maxValue;\n",
                                    "}\n",
                                    "\n",
                                    "/// Return simulation time\n",
                                    "double "
                                }, false));
        txt = Tpl.writeText(txt, a_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeText(txt, l_index);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::getSimTime() const\n",
                                    "{\n",
                                    "  return _system->_simTime;\n",
                                    "}\n",
                                    "\n",
                                    "/// Provide variables with given index to the system\n",
                                    "void "
                                }, false));
        txt = Tpl.writeText(txt, a_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeText(txt, l_index);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::getReal(double* vars) const\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = getAlgloopVars(txt, i_eq, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_context, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n",
                                    "/// Set variables with given index to the system\n",
                                    "void "
                                }, false));
        txt = Tpl.writeText(txt, a_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeText(txt, l_index);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::setReal(const double* vars)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = setAlgloopVars(txt, i_eq, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_context, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    " /// Set start values\n",
                                    "void "
                                }, false));
        txt = Tpl.writeText(txt, a_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeText(txt, l_index);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::setRealStartValues()\n",
                                    "{\n",
                                    "   getReal(_x0);\n",
                                    "}\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = Tpl.writeText(txt, a_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeText(txt, l_index);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("::getRealStartValues(double* vars) const\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "{\n",
                                    "    NonLinearAlgLoopDefaultImplementation::getRealStartValues(vars);\n",
                                    "}"
                                }, false));
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           _,
           a_stateDerVectorName,
           _,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      equation
        txt = CodegenCppCommonOld.error(txt, Tpl.sourceInfo("CodegenCppOld.tpl", 7541, 9), "Unsupported equation system type");
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_843;

public function NonLinearalgloopDefaultImplementationCode
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input SimCode.SimEqSystem in_a_eq;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_eq, in_a_context, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      SimCode.SimEqSystem a_eq;
      SimCodeFunction.Context a_context;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      SimCode.SimCode i_simCode;
      Absyn.Path i_modelInfo_name;
      Tpl.Text l_modelname;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = i_modelInfo_name))),
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_eq,
           a_context,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_modelname = lastIdentOfPath(Tpl.emptyTxt, i_modelInfo_name);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_843(txt, a_eq, a_useFlatArrayNotation, a_stateDerVectorName, a_context, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, i_simCode, l_modelname);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           _,
           _,
           a_stateDerVectorName,
           _ )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end NonLinearalgloopDefaultImplementationCode;

protected function fun_845
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "// Returns labels for a labeled DAE\n",
                                    "virtual label_list_type getLabels();\n",
                                    "// Sets all algebraic and state varibales for current time\n",
                                    "virtual void setVariables(const ublas::vector<double>& variables, const ublas::vector<double>& variables2);"
                                }, false));
      then txt;
  end match;
end fun_845;

protected function fun_846
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      Boolean ret_0;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(vars = SimCodeVar.SIMVARS(stateVars = _))) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "/// Releases the Modelica System\n",
                                    "virtual void destroy();\n",
                                    "/// Provide number (dimension) of variables according to the index\n",
                                    "virtual int getDimContinuousStates() const;\n",
                                    "virtual int getDimAE() const;\n",
                                    "/// Provide number (dimension) of boolean variables\n",
                                    "virtual int getDimBoolean() const;\n",
                                    "/// Provide number (dimension) of integer variables\n",
                                    "virtual int getDimInteger() const;\n",
                                    "/// Provide number (dimension) of real variables\n",
                                    "virtual int getDimReal() const;\n",
                                    "/// Provide number (dimension) of string variables\n",
                                    "virtual int getDimString() const;\n",
                                    "// Provide number (dimension) of right hand sides (equations and/or residuals)\n",
                                    "virtual int getDimRHS()const;\n",
                                    "virtual double& getRealStartValue(double& var);\n",
                                    "virtual bool& getBoolStartValue(bool& var);\n",
                                    "virtual int& getIntStartValue(int& var);\n",
                                    "virtual string& getStringStartValue(string& var);\n",
                                    "virtual void setRealStartValue(double& var,double val);\n",
                                    "virtual void setBoolStartValue(bool& var,bool val);\n",
                                    "virtual void setIntStartValue(int& var,int val);\n",
                                    "virtual void setStringStartValue(string& var,string val);\n",
                                    "\n",
                                    "virtual void setNumPartitions(int numPartitions);\n",
                                    "virtual int getNumPartitions();\n",
                                    "virtual void setPartitionActivation(bool* partitions);\n",
                                    "virtual void getPartitionActivation(bool* partitions);\n",
                                    "virtual int getActivator(int state);\n",
                                    "\n",
                                    "//Resets all time events\n",
                                    "\n",
                                    "// Provide variables with given index to the system\n",
                                    "virtual void getContinuousStates(double* z);\n",
                                    "virtual void getNominalStates(double* z);\n",
                                    "// Set variables with given index to the system\n",
                                    "virtual void setContinuousStates(const double* z);\n",
                                    "\n",
                                    "// Update transfer behavior of the system of equations according to command given by solver\n",
                                    "virtual bool evaluateAll(const UPDATETYPE command = IContinuous::UNDEF_UPDATE);\n",
                                    "virtual void evaluateODE(const UPDATETYPE command = IContinuous::UNDEF_UPDATE);\n",
                                    "virtual void evaluateZeroFuncs(const UPDATETYPE command = IContinuous::UNDEF_UPDATE);\n",
                                    "virtual bool evaluateConditions(const UPDATETYPE command);\n",
                                    "\n",
                                    "// Provide the right hand side (according to the index)\n",
                                    "virtual void getRHS(double* f);\n",
                                    "virtual void setStateDerivatives(const double* f);\n",
                                    "\n",
                                    "//Provide number (dimension) of zero functions\n",
                                    "virtual int getDimZeroFunc();\n",
                                    "//Provide number (dimension) of zero functions\n",
                                    "virtual int getDimClock();\n",
                                    "//Provides current values of root/zero functions\n",
                                    "virtual void getZeroFunc(double* f);\n",
                                    "virtual void setConditions(bool* c);\n",
                                    "virtual void getConditions(bool* c);\n",
                                    "virtual void getClockConditions(bool* c);\n",
                                    "\n",
                                    "//Called to handle an event\n",
                                    "virtual void handleEvent(const bool* events);\n",
                                    "//Checks if a discrete variable has changed and triggers an event\n",
                                    "virtual bool checkForDiscreteEvents();\n",
                                    "virtual bool isStepEvent();\n",
                                    "//sets the terminal status\n",
                                    "virtual void setTerminal(bool);\n",
                                    "//returns the terminal status\n",
                                    "virtual bool terminal();\n",
                                    "\n",
                                    "\n",
                                    "\n",
                                    "// M is regular\n",
                                    "virtual bool isODE();\n",
                                    "// M is singular\n",
                                    "virtual bool isAlgebraic();\n",
                                    "\n",
                                    "virtual int getDimTimeEvent() const;\n",
                                    "virtual std::pair<double,double>* getTimeEventData() const;\n",
                                    "virtual double computeNextTimeEvents(double currTime);\n",
                                    "virtual void computeTimeEventConditions(double currTime);\n",
                                    "virtual void resetTimeConditions();\n",
                                    "//initializes the definition of time event samplers (i.e. starttime and frequency)\n",
                                    "virtual void initTimeEventData();\n",
                                    "\n",
                                    "/// Set current integration time\n",
                                    "virtual void setTime(const double& time);\n",
                                    "\n",
                                    "// System is able to provide the Jacobian symbolically\n",
                                    "virtual bool provideSymbolicJacobian();\n",
                                    "\n",
                                    "virtual void restoreOldValues();\n",
                                    "virtual void restoreNewValues();\n",
                                    "virtual bool stepCompleted(double time);\n",
                                    "virtual bool stepStarted(double time);\n",
                                    "\n"
                                }, true));
        ret_0 = Flags.isSet(Flags.WRITE_TO_BUFFER);
        txt = fun_845(txt, ret_0);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "/// Provide boolean variables\n",
                                    "virtual void getBoolean(bool* z);\n",
                                    "/// Provide integer variables\n",
                                    "virtual void getInteger(int* z);\n",
                                    "/// Provide real variables\n",
                                    "virtual void getReal(double* z);\n",
                                    "/// Provide real variables\n",
                                    "virtual void getString(std::string* z);\n",
                                    "/// Provide boolean variables\n",
                                    "virtual void setBoolean(const bool* z);\n",
                                    "/// Provide integer variables\n",
                                    "virtual void setInteger(const int* z);\n",
                                    "/// Provide real variables\n",
                                    "virtual void setReal(const double* z);\n",
                                    "/// Provide real variables\n",
                                    "virtual void setString(const std::string* z);"
                                }, false));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_846;

public function generateMethodDeclarationCode
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  out_txt := fun_846(txt, a_simCode);
  out_a_extraFuncs := a_extraFuncs;
  out_a_extraFuncsDecl := a_extraFuncsDecl;
  out_a_extraFuncsNamespace := a_extraFuncsNamespace;
end generateMethodDeclarationCode;

protected function fun_848
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = _)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "/// Provide index of equation\n",
                                    "virtual int getEquationIndex() const;\n",
                                    "/// Provide number (dimension) of variables according to data type\n",
                                    "virtual int getDimReal() const;\n",
                                    "/*/// Provide number (dimension) of residuals according to data type\n",
                                    "virtual int getDimRHS() const;test*/\n",
                                    " /// (Re-) initialize the system of equations\n",
                                    "virtual void initialize();\n",
                                    "\n",
                                    "/// Provide names of alg loop variables\n",
                                    "virtual void getNamesReal(const char** names) const;\n",
                                    "/// Provide nominal values for alg loop variables\n",
                                    "virtual void getNominalReal(double* nominals) const;\n",
                                    "/// Provide min values for alg loop variables\n",
                                    "virtual void getMinReal(double* mins) const;\n",
                                    "/// Provide max values for alg loop variables\n",
                                    "virtual void getMaxReal(double* maxs) const;\n",
                                    "\n",
                                    "/// Return simulation time\n",
                                    "virtual double getSimTime() const;\n",
                                    "/// Provide variables with given index to the system\n",
                                    "virtual void getReal(double* vars) const;\n",
                                    "/// Set variables with given index to the system\n",
                                    "virtual void setReal(const double* vars);\n",
                                    "virtual void getRealStartValues(double* vars) const;\n",
                                    "virtual void setRealStartValues();\n",
                                    "/// Evaluate equations for given variables\n",
                                    "virtual void evaluate();\n",
                                    "virtual bool isLinearTearing();\n",
                                    "virtual bool isConsistent();"
                                }, false));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_848;

public function generateAlgloopMethodDeclarationCode
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  out_txt := fun_848(txt, a_simCode);
  out_a_extraFuncs := a_extraFuncs;
  out_a_extraFuncsDecl := a_extraFuncsDecl;
  out_a_extraFuncsNamespace := a_extraFuncsNamespace;
end generateAlgloopMethodDeclarationCode;

protected function lm_850
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Boolean in_a_createDebugCode;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_indexForUndefinedReferencesReal;
  input HashTableCrIListArray.HashTable in_a_varToArrayIndexMapping;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_indexForUndefinedReferencesReal;
algorithm
  (out_txt, out_a_indexForUndefinedReferencesReal) :=
  match(in_txt, in_items, in_a_createDebugCode, in_a_useFlatArrayNotation, in_a_indexForUndefinedReferencesReal, in_a_varToArrayIndexMapping)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Boolean a_createDebugCode;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_indexForUndefinedReferencesReal;
      HashTableCrIListArray.HashTable a_varToArrayIndexMapping;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _,
           _,
           a_indexForUndefinedReferencesReal,
           _ )
      then (txt, a_indexForUndefinedReferencesReal);

    case ( txt,
           i_var :: rest,
           a_createDebugCode,
           a_useFlatArrayNotation,
           a_indexForUndefinedReferencesReal,
           a_varToArrayIndexMapping )
      equation
        (txt, a_indexForUndefinedReferencesReal) = memberVariableDefine2(txt, i_var, a_varToArrayIndexMapping, a_indexForUndefinedReferencesReal, a_useFlatArrayNotation, a_createDebugCode, "Real", true);
        txt = Tpl.nextIter(txt);
        (txt, a_indexForUndefinedReferencesReal) = lm_850(txt, rest, a_createDebugCode, a_useFlatArrayNotation, a_indexForUndefinedReferencesReal, a_varToArrayIndexMapping);
      then (txt, a_indexForUndefinedReferencesReal);
  end match;
end lm_850;

protected function lm_851
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Boolean in_a_createDebugCode;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_indexForUndefinedReferencesReal;
  input HashTableCrIListArray.HashTable in_a_varToArrayIndexMapping;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_indexForUndefinedReferencesReal;
algorithm
  (out_txt, out_a_indexForUndefinedReferencesReal) :=
  match(in_txt, in_items, in_a_createDebugCode, in_a_useFlatArrayNotation, in_a_indexForUndefinedReferencesReal, in_a_varToArrayIndexMapping)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Boolean a_createDebugCode;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_indexForUndefinedReferencesReal;
      HashTableCrIListArray.HashTable a_varToArrayIndexMapping;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _,
           _,
           a_indexForUndefinedReferencesReal,
           _ )
      then (txt, a_indexForUndefinedReferencesReal);

    case ( txt,
           i_var :: rest,
           a_createDebugCode,
           a_useFlatArrayNotation,
           a_indexForUndefinedReferencesReal,
           a_varToArrayIndexMapping )
      equation
        (txt, a_indexForUndefinedReferencesReal) = memberVariableDefine2(txt, i_var, a_varToArrayIndexMapping, a_indexForUndefinedReferencesReal, a_useFlatArrayNotation, a_createDebugCode, "Real", true);
        txt = Tpl.nextIter(txt);
        (txt, a_indexForUndefinedReferencesReal) = lm_851(txt, rest, a_createDebugCode, a_useFlatArrayNotation, a_indexForUndefinedReferencesReal, a_varToArrayIndexMapping);
      then (txt, a_indexForUndefinedReferencesReal);
  end match;
end lm_851;

protected function lm_852
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Boolean in_a_createDebugCode;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_indexForUndefinedReferencesReal;
  input HashTableCrIListArray.HashTable in_a_varToArrayIndexMapping;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_indexForUndefinedReferencesReal;
algorithm
  (out_txt, out_a_indexForUndefinedReferencesReal) :=
  match(in_txt, in_items, in_a_createDebugCode, in_a_useFlatArrayNotation, in_a_indexForUndefinedReferencesReal, in_a_varToArrayIndexMapping)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Boolean a_createDebugCode;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_indexForUndefinedReferencesReal;
      HashTableCrIListArray.HashTable a_varToArrayIndexMapping;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _,
           _,
           a_indexForUndefinedReferencesReal,
           _ )
      then (txt, a_indexForUndefinedReferencesReal);

    case ( txt,
           i_var :: rest,
           a_createDebugCode,
           a_useFlatArrayNotation,
           a_indexForUndefinedReferencesReal,
           a_varToArrayIndexMapping )
      equation
        (txt, a_indexForUndefinedReferencesReal) = memberVariableDefine2(txt, i_var, a_varToArrayIndexMapping, a_indexForUndefinedReferencesReal, a_useFlatArrayNotation, a_createDebugCode, "Real", true);
        txt = Tpl.nextIter(txt);
        (txt, a_indexForUndefinedReferencesReal) = lm_852(txt, rest, a_createDebugCode, a_useFlatArrayNotation, a_indexForUndefinedReferencesReal, a_varToArrayIndexMapping);
      then (txt, a_indexForUndefinedReferencesReal);
  end match;
end lm_852;

protected function lm_853
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Boolean in_a_createDebugCode;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_indexForUndefinedReferencesReal;
  input HashTableCrIListArray.HashTable in_a_varToArrayIndexMapping;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_indexForUndefinedReferencesReal;
algorithm
  (out_txt, out_a_indexForUndefinedReferencesReal) :=
  match(in_txt, in_items, in_a_createDebugCode, in_a_useFlatArrayNotation, in_a_indexForUndefinedReferencesReal, in_a_varToArrayIndexMapping)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Boolean a_createDebugCode;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_indexForUndefinedReferencesReal;
      HashTableCrIListArray.HashTable a_varToArrayIndexMapping;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _,
           _,
           a_indexForUndefinedReferencesReal,
           _ )
      then (txt, a_indexForUndefinedReferencesReal);

    case ( txt,
           i_var :: rest,
           a_createDebugCode,
           a_useFlatArrayNotation,
           a_indexForUndefinedReferencesReal,
           a_varToArrayIndexMapping )
      equation
        (txt, a_indexForUndefinedReferencesReal) = memberVariableDefine2(txt, i_var, a_varToArrayIndexMapping, a_indexForUndefinedReferencesReal, a_useFlatArrayNotation, a_createDebugCode, "Real", true);
        txt = Tpl.nextIter(txt);
        (txt, a_indexForUndefinedReferencesReal) = lm_853(txt, rest, a_createDebugCode, a_useFlatArrayNotation, a_indexForUndefinedReferencesReal, a_varToArrayIndexMapping);
      then (txt, a_indexForUndefinedReferencesReal);
  end match;
end lm_853;

protected function lm_854
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Boolean in_a_createDebugCode;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_indexForUndefinedReferencesInt;
  input HashTableCrIListArray.HashTable in_a_varToArrayIndexMapping;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_indexForUndefinedReferencesInt;
algorithm
  (out_txt, out_a_indexForUndefinedReferencesInt) :=
  match(in_txt, in_items, in_a_createDebugCode, in_a_useFlatArrayNotation, in_a_indexForUndefinedReferencesInt, in_a_varToArrayIndexMapping)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Boolean a_createDebugCode;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_indexForUndefinedReferencesInt;
      HashTableCrIListArray.HashTable a_varToArrayIndexMapping;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _,
           _,
           a_indexForUndefinedReferencesInt,
           _ )
      then (txt, a_indexForUndefinedReferencesInt);

    case ( txt,
           i_var :: rest,
           a_createDebugCode,
           a_useFlatArrayNotation,
           a_indexForUndefinedReferencesInt,
           a_varToArrayIndexMapping )
      equation
        (txt, a_indexForUndefinedReferencesInt) = memberVariableDefine2(txt, i_var, a_varToArrayIndexMapping, a_indexForUndefinedReferencesInt, a_useFlatArrayNotation, a_createDebugCode, "Int", true);
        txt = Tpl.nextIter(txt);
        (txt, a_indexForUndefinedReferencesInt) = lm_854(txt, rest, a_createDebugCode, a_useFlatArrayNotation, a_indexForUndefinedReferencesInt, a_varToArrayIndexMapping);
      then (txt, a_indexForUndefinedReferencesInt);
  end match;
end lm_854;

protected function lm_855
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Boolean in_a_createDebugCode;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_indexForUndefinedReferencesBool;
  input HashTableCrIListArray.HashTable in_a_varToArrayIndexMapping;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_indexForUndefinedReferencesBool;
algorithm
  (out_txt, out_a_indexForUndefinedReferencesBool) :=
  match(in_txt, in_items, in_a_createDebugCode, in_a_useFlatArrayNotation, in_a_indexForUndefinedReferencesBool, in_a_varToArrayIndexMapping)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Boolean a_createDebugCode;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_indexForUndefinedReferencesBool;
      HashTableCrIListArray.HashTable a_varToArrayIndexMapping;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _,
           _,
           a_indexForUndefinedReferencesBool,
           _ )
      then (txt, a_indexForUndefinedReferencesBool);

    case ( txt,
           i_var :: rest,
           a_createDebugCode,
           a_useFlatArrayNotation,
           a_indexForUndefinedReferencesBool,
           a_varToArrayIndexMapping )
      equation
        (txt, a_indexForUndefinedReferencesBool) = memberVariableDefine2(txt, i_var, a_varToArrayIndexMapping, a_indexForUndefinedReferencesBool, a_useFlatArrayNotation, a_createDebugCode, "Bool", true);
        txt = Tpl.nextIter(txt);
        (txt, a_indexForUndefinedReferencesBool) = lm_855(txt, rest, a_createDebugCode, a_useFlatArrayNotation, a_indexForUndefinedReferencesBool, a_varToArrayIndexMapping);
      then (txt, a_indexForUndefinedReferencesBool);
  end match;
end lm_855;

protected function lm_856
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Boolean in_a_createDebugCode;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_indexForUndefinedReferencesString;
  input HashTableCrIListArray.HashTable in_a_varToArrayIndexMapping;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_indexForUndefinedReferencesString;
algorithm
  (out_txt, out_a_indexForUndefinedReferencesString) :=
  match(in_txt, in_items, in_a_createDebugCode, in_a_useFlatArrayNotation, in_a_indexForUndefinedReferencesString, in_a_varToArrayIndexMapping)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Boolean a_createDebugCode;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_indexForUndefinedReferencesString;
      HashTableCrIListArray.HashTable a_varToArrayIndexMapping;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _,
           _,
           a_indexForUndefinedReferencesString,
           _ )
      then (txt, a_indexForUndefinedReferencesString);

    case ( txt,
           i_var :: rest,
           a_createDebugCode,
           a_useFlatArrayNotation,
           a_indexForUndefinedReferencesString,
           a_varToArrayIndexMapping )
      equation
        (txt, a_indexForUndefinedReferencesString) = memberVariableDefine2(txt, i_var, a_varToArrayIndexMapping, a_indexForUndefinedReferencesString, a_useFlatArrayNotation, a_createDebugCode, "String", true);
        txt = Tpl.nextIter(txt);
        (txt, a_indexForUndefinedReferencesString) = lm_856(txt, rest, a_createDebugCode, a_useFlatArrayNotation, a_indexForUndefinedReferencesString, a_varToArrayIndexMapping);
      then (txt, a_indexForUndefinedReferencesString);
  end match;
end lm_856;

protected function lm_857
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Boolean in_a_createDebugCode;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_indexForUndefinedReferencesReal;
  input HashTableCrIListArray.HashTable in_a_varToArrayIndexMapping;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_indexForUndefinedReferencesReal;
algorithm
  (out_txt, out_a_indexForUndefinedReferencesReal) :=
  match(in_txt, in_items, in_a_createDebugCode, in_a_useFlatArrayNotation, in_a_indexForUndefinedReferencesReal, in_a_varToArrayIndexMapping)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Boolean a_createDebugCode;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_indexForUndefinedReferencesReal;
      HashTableCrIListArray.HashTable a_varToArrayIndexMapping;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _,
           _,
           a_indexForUndefinedReferencesReal,
           _ )
      then (txt, a_indexForUndefinedReferencesReal);

    case ( txt,
           i_var :: rest,
           a_createDebugCode,
           a_useFlatArrayNotation,
           a_indexForUndefinedReferencesReal,
           a_varToArrayIndexMapping )
      equation
        (txt, a_indexForUndefinedReferencesReal) = memberVariableDefine2(txt, i_var, a_varToArrayIndexMapping, a_indexForUndefinedReferencesReal, a_useFlatArrayNotation, a_createDebugCode, "Real", true);
        txt = Tpl.nextIter(txt);
        (txt, a_indexForUndefinedReferencesReal) = lm_857(txt, rest, a_createDebugCode, a_useFlatArrayNotation, a_indexForUndefinedReferencesReal, a_varToArrayIndexMapping);
      then (txt, a_indexForUndefinedReferencesReal);
  end match;
end lm_857;

protected function lm_858
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Boolean in_a_createDebugCode;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_indexForUndefinedReferencesInt;
  input HashTableCrIListArray.HashTable in_a_varToArrayIndexMapping;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_indexForUndefinedReferencesInt;
algorithm
  (out_txt, out_a_indexForUndefinedReferencesInt) :=
  match(in_txt, in_items, in_a_createDebugCode, in_a_useFlatArrayNotation, in_a_indexForUndefinedReferencesInt, in_a_varToArrayIndexMapping)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Boolean a_createDebugCode;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_indexForUndefinedReferencesInt;
      HashTableCrIListArray.HashTable a_varToArrayIndexMapping;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _,
           _,
           a_indexForUndefinedReferencesInt,
           _ )
      then (txt, a_indexForUndefinedReferencesInt);

    case ( txt,
           i_var :: rest,
           a_createDebugCode,
           a_useFlatArrayNotation,
           a_indexForUndefinedReferencesInt,
           a_varToArrayIndexMapping )
      equation
        (txt, a_indexForUndefinedReferencesInt) = memberVariableDefine2(txt, i_var, a_varToArrayIndexMapping, a_indexForUndefinedReferencesInt, a_useFlatArrayNotation, a_createDebugCode, "Int", true);
        txt = Tpl.nextIter(txt);
        (txt, a_indexForUndefinedReferencesInt) = lm_858(txt, rest, a_createDebugCode, a_useFlatArrayNotation, a_indexForUndefinedReferencesInt, a_varToArrayIndexMapping);
      then (txt, a_indexForUndefinedReferencesInt);
  end match;
end lm_858;

protected function lm_859
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Boolean in_a_createDebugCode;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_indexForUndefinedReferencesBool;
  input HashTableCrIListArray.HashTable in_a_varToArrayIndexMapping;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_indexForUndefinedReferencesBool;
algorithm
  (out_txt, out_a_indexForUndefinedReferencesBool) :=
  match(in_txt, in_items, in_a_createDebugCode, in_a_useFlatArrayNotation, in_a_indexForUndefinedReferencesBool, in_a_varToArrayIndexMapping)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Boolean a_createDebugCode;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_indexForUndefinedReferencesBool;
      HashTableCrIListArray.HashTable a_varToArrayIndexMapping;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _,
           _,
           a_indexForUndefinedReferencesBool,
           _ )
      then (txt, a_indexForUndefinedReferencesBool);

    case ( txt,
           i_var :: rest,
           a_createDebugCode,
           a_useFlatArrayNotation,
           a_indexForUndefinedReferencesBool,
           a_varToArrayIndexMapping )
      equation
        (txt, a_indexForUndefinedReferencesBool) = memberVariableDefine2(txt, i_var, a_varToArrayIndexMapping, a_indexForUndefinedReferencesBool, a_useFlatArrayNotation, a_createDebugCode, "Bool", true);
        txt = Tpl.nextIter(txt);
        (txt, a_indexForUndefinedReferencesBool) = lm_859(txt, rest, a_createDebugCode, a_useFlatArrayNotation, a_indexForUndefinedReferencesBool, a_varToArrayIndexMapping);
      then (txt, a_indexForUndefinedReferencesBool);
  end match;
end lm_859;

protected function lm_860
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Boolean in_a_createDebugCode;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_indexForUndefinedReferencesString;
  input HashTableCrIListArray.HashTable in_a_varToArrayIndexMapping;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_indexForUndefinedReferencesString;
algorithm
  (out_txt, out_a_indexForUndefinedReferencesString) :=
  match(in_txt, in_items, in_a_createDebugCode, in_a_useFlatArrayNotation, in_a_indexForUndefinedReferencesString, in_a_varToArrayIndexMapping)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Boolean a_createDebugCode;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_indexForUndefinedReferencesString;
      HashTableCrIListArray.HashTable a_varToArrayIndexMapping;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _,
           _,
           a_indexForUndefinedReferencesString,
           _ )
      then (txt, a_indexForUndefinedReferencesString);

    case ( txt,
           i_var :: rest,
           a_createDebugCode,
           a_useFlatArrayNotation,
           a_indexForUndefinedReferencesString,
           a_varToArrayIndexMapping )
      equation
        (txt, a_indexForUndefinedReferencesString) = memberVariableDefine2(txt, i_var, a_varToArrayIndexMapping, a_indexForUndefinedReferencesString, a_useFlatArrayNotation, a_createDebugCode, "String", true);
        txt = Tpl.nextIter(txt);
        (txt, a_indexForUndefinedReferencesString) = lm_860(txt, rest, a_createDebugCode, a_useFlatArrayNotation, a_indexForUndefinedReferencesString, a_varToArrayIndexMapping);
      then (txt, a_indexForUndefinedReferencesString);
  end match;
end lm_860;

protected function lm_861
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Boolean in_a_createDebugCode;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_indexForUndefinedReferencesReal;
  input HashTableCrIListArray.HashTable in_a_varToArrayIndexMapping;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_indexForUndefinedReferencesReal;
algorithm
  (out_txt, out_a_indexForUndefinedReferencesReal) :=
  match(in_txt, in_items, in_a_createDebugCode, in_a_useFlatArrayNotation, in_a_indexForUndefinedReferencesReal, in_a_varToArrayIndexMapping)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Boolean a_createDebugCode;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_indexForUndefinedReferencesReal;
      HashTableCrIListArray.HashTable a_varToArrayIndexMapping;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _,
           _,
           a_indexForUndefinedReferencesReal,
           _ )
      then (txt, a_indexForUndefinedReferencesReal);

    case ( txt,
           i_var :: rest,
           a_createDebugCode,
           a_useFlatArrayNotation,
           a_indexForUndefinedReferencesReal,
           a_varToArrayIndexMapping )
      equation
        (txt, a_indexForUndefinedReferencesReal) = memberVariableDefine2(txt, i_var, a_varToArrayIndexMapping, a_indexForUndefinedReferencesReal, a_useFlatArrayNotation, a_createDebugCode, "Real", true);
        txt = Tpl.nextIter(txt);
        (txt, a_indexForUndefinedReferencesReal) = lm_861(txt, rest, a_createDebugCode, a_useFlatArrayNotation, a_indexForUndefinedReferencesReal, a_varToArrayIndexMapping);
      then (txt, a_indexForUndefinedReferencesReal);
  end match;
end lm_861;

protected function lm_862
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Boolean in_a_createDebugCode;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_indexForUndefinedReferencesInt;
  input HashTableCrIListArray.HashTable in_a_varToArrayIndexMapping;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_indexForUndefinedReferencesInt;
algorithm
  (out_txt, out_a_indexForUndefinedReferencesInt) :=
  match(in_txt, in_items, in_a_createDebugCode, in_a_useFlatArrayNotation, in_a_indexForUndefinedReferencesInt, in_a_varToArrayIndexMapping)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Boolean a_createDebugCode;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_indexForUndefinedReferencesInt;
      HashTableCrIListArray.HashTable a_varToArrayIndexMapping;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _,
           _,
           a_indexForUndefinedReferencesInt,
           _ )
      then (txt, a_indexForUndefinedReferencesInt);

    case ( txt,
           i_var :: rest,
           a_createDebugCode,
           a_useFlatArrayNotation,
           a_indexForUndefinedReferencesInt,
           a_varToArrayIndexMapping )
      equation
        (txt, a_indexForUndefinedReferencesInt) = memberVariableDefine2(txt, i_var, a_varToArrayIndexMapping, a_indexForUndefinedReferencesInt, a_useFlatArrayNotation, a_createDebugCode, "Int", true);
        txt = Tpl.nextIter(txt);
        (txt, a_indexForUndefinedReferencesInt) = lm_862(txt, rest, a_createDebugCode, a_useFlatArrayNotation, a_indexForUndefinedReferencesInt, a_varToArrayIndexMapping);
      then (txt, a_indexForUndefinedReferencesInt);
  end match;
end lm_862;

protected function lm_863
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Boolean in_a_createDebugCode;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_indexForUndefinedReferencesBool;
  input HashTableCrIListArray.HashTable in_a_varToArrayIndexMapping;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_indexForUndefinedReferencesBool;
algorithm
  (out_txt, out_a_indexForUndefinedReferencesBool) :=
  match(in_txt, in_items, in_a_createDebugCode, in_a_useFlatArrayNotation, in_a_indexForUndefinedReferencesBool, in_a_varToArrayIndexMapping)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Boolean a_createDebugCode;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_indexForUndefinedReferencesBool;
      HashTableCrIListArray.HashTable a_varToArrayIndexMapping;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _,
           _,
           a_indexForUndefinedReferencesBool,
           _ )
      then (txt, a_indexForUndefinedReferencesBool);

    case ( txt,
           i_var :: rest,
           a_createDebugCode,
           a_useFlatArrayNotation,
           a_indexForUndefinedReferencesBool,
           a_varToArrayIndexMapping )
      equation
        (txt, a_indexForUndefinedReferencesBool) = memberVariableDefine2(txt, i_var, a_varToArrayIndexMapping, a_indexForUndefinedReferencesBool, a_useFlatArrayNotation, a_createDebugCode, "Bool", true);
        txt = Tpl.nextIter(txt);
        (txt, a_indexForUndefinedReferencesBool) = lm_863(txt, rest, a_createDebugCode, a_useFlatArrayNotation, a_indexForUndefinedReferencesBool, a_varToArrayIndexMapping);
      then (txt, a_indexForUndefinedReferencesBool);
  end match;
end lm_863;

protected function lm_864
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Boolean in_a_createDebugCode;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_indexForUndefinedReferencesString;
  input HashTableCrIListArray.HashTable in_a_varToArrayIndexMapping;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_indexForUndefinedReferencesString;
algorithm
  (out_txt, out_a_indexForUndefinedReferencesString) :=
  match(in_txt, in_items, in_a_createDebugCode, in_a_useFlatArrayNotation, in_a_indexForUndefinedReferencesString, in_a_varToArrayIndexMapping)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Boolean a_createDebugCode;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_indexForUndefinedReferencesString;
      HashTableCrIListArray.HashTable a_varToArrayIndexMapping;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _,
           _,
           a_indexForUndefinedReferencesString,
           _ )
      then (txt, a_indexForUndefinedReferencesString);

    case ( txt,
           i_var :: rest,
           a_createDebugCode,
           a_useFlatArrayNotation,
           a_indexForUndefinedReferencesString,
           a_varToArrayIndexMapping )
      equation
        (txt, a_indexForUndefinedReferencesString) = memberVariableDefine2(txt, i_var, a_varToArrayIndexMapping, a_indexForUndefinedReferencesString, a_useFlatArrayNotation, a_createDebugCode, "String", true);
        txt = Tpl.nextIter(txt);
        (txt, a_indexForUndefinedReferencesString) = lm_864(txt, rest, a_createDebugCode, a_useFlatArrayNotation, a_indexForUndefinedReferencesString, a_varToArrayIndexMapping);
      then (txt, a_indexForUndefinedReferencesString);
  end match;
end lm_864;

protected function lm_865
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Boolean in_a_createDebugCode;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_indexForUndefinedReferencesReal;
  input HashTableCrIListArray.HashTable in_a_varToArrayIndexMapping;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_indexForUndefinedReferencesReal;
algorithm
  (out_txt, out_a_indexForUndefinedReferencesReal) :=
  match(in_txt, in_items, in_a_createDebugCode, in_a_useFlatArrayNotation, in_a_indexForUndefinedReferencesReal, in_a_varToArrayIndexMapping)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Boolean a_createDebugCode;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_indexForUndefinedReferencesReal;
      HashTableCrIListArray.HashTable a_varToArrayIndexMapping;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _,
           _,
           a_indexForUndefinedReferencesReal,
           _ )
      then (txt, a_indexForUndefinedReferencesReal);

    case ( txt,
           i_var :: rest,
           a_createDebugCode,
           a_useFlatArrayNotation,
           a_indexForUndefinedReferencesReal,
           a_varToArrayIndexMapping )
      equation
        (txt, a_indexForUndefinedReferencesReal) = memberVariableDefine2(txt, i_var, a_varToArrayIndexMapping, a_indexForUndefinedReferencesReal, a_useFlatArrayNotation, a_createDebugCode, "Real", false);
        txt = Tpl.nextIter(txt);
        (txt, a_indexForUndefinedReferencesReal) = lm_865(txt, rest, a_createDebugCode, a_useFlatArrayNotation, a_indexForUndefinedReferencesReal, a_varToArrayIndexMapping);
      then (txt, a_indexForUndefinedReferencesReal);
  end match;
end lm_865;

public function memberVariableDefine
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;
  input HashTableCrIListArray.HashTable in_a_varToArrayIndexMapping;
  input Tpl.Text in_a_indexForUndefinedReferencesReal;
  input Tpl.Text in_a_indexForUndefinedReferencesInt;
  input Tpl.Text in_a_indexForUndefinedReferencesBool;
  input Tpl.Text in_a_indexForUndefinedReferencesString;
  input Boolean in_a_createDebugCode;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_indexForUndefinedReferencesReal;
  output Tpl.Text out_a_indexForUndefinedReferencesInt;
  output Tpl.Text out_a_indexForUndefinedReferencesBool;
  output Tpl.Text out_a_indexForUndefinedReferencesString;
algorithm
  (out_txt, out_a_indexForUndefinedReferencesReal, out_a_indexForUndefinedReferencesInt, out_a_indexForUndefinedReferencesBool, out_a_indexForUndefinedReferencesString) :=
  match(in_txt, in_a_modelInfo, in_a_varToArrayIndexMapping, in_a_indexForUndefinedReferencesReal, in_a_indexForUndefinedReferencesInt, in_a_indexForUndefinedReferencesBool, in_a_indexForUndefinedReferencesString, in_a_createDebugCode, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      HashTableCrIListArray.HashTable a_varToArrayIndexMapping;
      Tpl.Text a_indexForUndefinedReferencesReal;
      Tpl.Text a_indexForUndefinedReferencesInt;
      Tpl.Text a_indexForUndefinedReferencesBool;
      Tpl.Text a_indexForUndefinedReferencesString;
      Boolean a_createDebugCode;
      Boolean a_useFlatArrayNotation;
      list<SimCodeVar.SimVar> i_vars_extObjVars;
      list<SimCodeVar.SimVar> i_vars_stringAliasVars;
      list<SimCodeVar.SimVar> i_vars_boolAliasVars;
      list<SimCodeVar.SimVar> i_vars_intAliasVars;
      list<SimCodeVar.SimVar> i_vars_aliasVars;
      list<SimCodeVar.SimVar> i_vars_stringParamVars;
      list<SimCodeVar.SimVar> i_vars_boolParamVars;
      list<SimCodeVar.SimVar> i_vars_intParamVars;
      list<SimCodeVar.SimVar> i_vars_paramVars;
      list<SimCodeVar.SimVar> i_vars_stringAlgVars;
      list<SimCodeVar.SimVar> i_vars_boolAlgVars;
      list<SimCodeVar.SimVar> i_vars_intAlgVars;
      list<SimCodeVar.SimVar> i_vars_discreteAlgVars;
      list<SimCodeVar.SimVar> i_vars_algVars;
      list<SimCodeVar.SimVar> i_vars_derivativeVars;
      list<SimCodeVar.SimVar> i_vars_stateVars;

    case ( txt,
           SimCode.MODELINFO(vars = SimCodeVar.SIMVARS(stateVars = i_vars_stateVars, derivativeVars = i_vars_derivativeVars, algVars = i_vars_algVars, discreteAlgVars = i_vars_discreteAlgVars, intAlgVars = i_vars_intAlgVars, boolAlgVars = i_vars_boolAlgVars, stringAlgVars = i_vars_stringAlgVars, paramVars = i_vars_paramVars, intParamVars = i_vars_intParamVars, boolParamVars = i_vars_boolParamVars, stringParamVars = i_vars_stringParamVars, aliasVars = i_vars_aliasVars, intAliasVars = i_vars_intAliasVars, boolAliasVars = i_vars_boolAliasVars, stringAliasVars = i_vars_stringAliasVars, extObjVars = i_vars_extObjVars)),
           a_varToArrayIndexMapping,
           a_indexForUndefinedReferencesReal,
           a_indexForUndefinedReferencesInt,
           a_indexForUndefinedReferencesBool,
           a_indexForUndefinedReferencesString,
           a_createDebugCode,
           a_useFlatArrayNotation )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/*state vars*/\n"));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_indexForUndefinedReferencesReal) = lm_850(txt, i_vars_stateVars, a_createDebugCode, a_useFlatArrayNotation, a_indexForUndefinedReferencesReal, a_varToArrayIndexMapping);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/*derivative vars*/\n"));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_indexForUndefinedReferencesReal) = lm_851(txt, i_vars_derivativeVars, a_createDebugCode, a_useFlatArrayNotation, a_indexForUndefinedReferencesReal, a_varToArrayIndexMapping);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/*real algvars*/\n"));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_indexForUndefinedReferencesReal) = lm_852(txt, i_vars_algVars, a_createDebugCode, a_useFlatArrayNotation, a_indexForUndefinedReferencesReal, a_varToArrayIndexMapping);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/*discrete algvars*/\n"));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_indexForUndefinedReferencesReal) = lm_853(txt, i_vars_discreteAlgVars, a_createDebugCode, a_useFlatArrayNotation, a_indexForUndefinedReferencesReal, a_varToArrayIndexMapping);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/*int algvars*/\n"));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_indexForUndefinedReferencesInt) = lm_854(txt, i_vars_intAlgVars, a_createDebugCode, a_useFlatArrayNotation, a_indexForUndefinedReferencesInt, a_varToArrayIndexMapping);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/*bool algvars*/\n"));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_indexForUndefinedReferencesBool) = lm_855(txt, i_vars_boolAlgVars, a_createDebugCode, a_useFlatArrayNotation, a_indexForUndefinedReferencesBool, a_varToArrayIndexMapping);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/*string algvars*/\n"));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_indexForUndefinedReferencesString) = lm_856(txt, i_vars_stringAlgVars, a_createDebugCode, a_useFlatArrayNotation, a_indexForUndefinedReferencesString, a_varToArrayIndexMapping);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/*parameter real vars*/\n"));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_indexForUndefinedReferencesReal) = lm_857(txt, i_vars_paramVars, a_createDebugCode, a_useFlatArrayNotation, a_indexForUndefinedReferencesReal, a_varToArrayIndexMapping);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/*parameter int vars*/\n"));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_indexForUndefinedReferencesInt) = lm_858(txt, i_vars_intParamVars, a_createDebugCode, a_useFlatArrayNotation, a_indexForUndefinedReferencesInt, a_varToArrayIndexMapping);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/*parameter bool vars*/\n"));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_indexForUndefinedReferencesBool) = lm_859(txt, i_vars_boolParamVars, a_createDebugCode, a_useFlatArrayNotation, a_indexForUndefinedReferencesBool, a_varToArrayIndexMapping);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/*string parameter variables*/\n"));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_indexForUndefinedReferencesString) = lm_860(txt, i_vars_stringParamVars, a_createDebugCode, a_useFlatArrayNotation, a_indexForUndefinedReferencesString, a_varToArrayIndexMapping);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/*alias real vars*/\n"));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_indexForUndefinedReferencesReal) = lm_861(txt, i_vars_aliasVars, a_createDebugCode, a_useFlatArrayNotation, a_indexForUndefinedReferencesReal, a_varToArrayIndexMapping);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/*alias int vars*/\n"));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_indexForUndefinedReferencesInt) = lm_862(txt, i_vars_intAliasVars, a_createDebugCode, a_useFlatArrayNotation, a_indexForUndefinedReferencesInt, a_varToArrayIndexMapping);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/*alias bool vars*/\n"));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_indexForUndefinedReferencesBool) = lm_863(txt, i_vars_boolAliasVars, a_createDebugCode, a_useFlatArrayNotation, a_indexForUndefinedReferencesBool, a_varToArrayIndexMapping);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/*string alias variables*/\n"));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_indexForUndefinedReferencesString) = lm_864(txt, i_vars_stringAliasVars, a_createDebugCode, a_useFlatArrayNotation, a_indexForUndefinedReferencesString, a_varToArrayIndexMapping);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/*external variables*/\n"));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_indexForUndefinedReferencesReal) = lm_865(txt, i_vars_extObjVars, a_createDebugCode, a_useFlatArrayNotation, a_indexForUndefinedReferencesReal, a_varToArrayIndexMapping);
        txt = Tpl.popIter(txt);
      then (txt, a_indexForUndefinedReferencesReal, a_indexForUndefinedReferencesInt, a_indexForUndefinedReferencesBool, a_indexForUndefinedReferencesString);

    case ( txt,
           _,
           _,
           a_indexForUndefinedReferencesReal,
           a_indexForUndefinedReferencesInt,
           a_indexForUndefinedReferencesBool,
           a_indexForUndefinedReferencesString,
           _,
           _ )
      then (txt, a_indexForUndefinedReferencesReal, a_indexForUndefinedReferencesInt, a_indexForUndefinedReferencesBool, a_indexForUndefinedReferencesString);
  end match;
end memberVariableDefine;

protected function lm_867
  input Tpl.Text in_txt;
  input list<list<SimCodeVar.SimVar>> in_items;
  input Tpl.Text in_a_additionalFunctionDefinitions;
  input Tpl.Text in_a_additionalConstructorVariables;
  input Tpl.Text in_a_additionalStateVarFunctionCalls;
  input Boolean in_a_createDebugCode;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_indexForUndefinedReferencesReal;
  input HashTableCrIListArray.HashTable in_a_varToArrayIndexMapping;
  input Tpl.Text in_a_classname;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_additionalFunctionDefinitions;
  output Tpl.Text out_a_additionalConstructorVariables;
  output Tpl.Text out_a_additionalStateVarFunctionCalls;
  output Tpl.Text out_a_indexForUndefinedReferencesReal;
  output Tpl.Text out_a_classname;
algorithm
  (out_txt, out_a_additionalFunctionDefinitions, out_a_additionalConstructorVariables, out_a_additionalStateVarFunctionCalls, out_a_indexForUndefinedReferencesReal, out_a_classname) :=
  match(in_txt, in_items, in_a_additionalFunctionDefinitions, in_a_additionalConstructorVariables, in_a_additionalStateVarFunctionCalls, in_a_createDebugCode, in_a_useFlatArrayNotation, in_a_indexForUndefinedReferencesReal, in_a_varToArrayIndexMapping, in_a_classname)
    local
      Tpl.Text txt;
      list<list<SimCodeVar.SimVar>> rest;
      Tpl.Text a_additionalFunctionDefinitions;
      Tpl.Text a_additionalConstructorVariables;
      Tpl.Text a_additionalStateVarFunctionCalls;
      Boolean a_createDebugCode;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_indexForUndefinedReferencesReal;
      HashTableCrIListArray.HashTable a_varToArrayIndexMapping;
      Tpl.Text a_classname;
      Integer x_i0;
      list<SimCodeVar.SimVar> i_varPartition;

    case ( txt,
           {},
           a_additionalFunctionDefinitions,
           a_additionalConstructorVariables,
           a_additionalStateVarFunctionCalls,
           _,
           _,
           a_indexForUndefinedReferencesReal,
           _,
           a_classname )
      then (txt, a_additionalFunctionDefinitions, a_additionalConstructorVariables, a_additionalStateVarFunctionCalls, a_indexForUndefinedReferencesReal, a_classname);

    case ( txt,
           i_varPartition :: rest,
           a_additionalFunctionDefinitions,
           a_additionalConstructorVariables,
           a_additionalStateVarFunctionCalls,
           a_createDebugCode,
           a_useFlatArrayNotation,
           a_indexForUndefinedReferencesReal,
           a_varToArrayIndexMapping,
           a_classname )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        (txt, _, _, a_classname, a_indexForUndefinedReferencesReal, a_additionalStateVarFunctionCalls, a_additionalConstructorVariables, a_additionalFunctionDefinitions) = memberVariableInitializeWithSplit(txt, i_varPartition, Tpl.stringText(intString(x_i0)), Tpl.strTokText(Tpl.ST_STRING("initStateVars")), a_classname, a_varToArrayIndexMapping, a_indexForUndefinedReferencesReal, a_useFlatArrayNotation, a_createDebugCode, "Real", a_additionalStateVarFunctionCalls, a_additionalConstructorVariables, a_additionalFunctionDefinitions);
        txt = Tpl.nextIter(txt);
        (txt, a_additionalFunctionDefinitions, a_additionalConstructorVariables, a_additionalStateVarFunctionCalls, a_indexForUndefinedReferencesReal, a_classname) = lm_867(txt, rest, a_additionalFunctionDefinitions, a_additionalConstructorVariables, a_additionalStateVarFunctionCalls, a_createDebugCode, a_useFlatArrayNotation, a_indexForUndefinedReferencesReal, a_varToArrayIndexMapping, a_classname);
      then (txt, a_additionalFunctionDefinitions, a_additionalConstructorVariables, a_additionalStateVarFunctionCalls, a_indexForUndefinedReferencesReal, a_classname);
  end match;
end lm_867;

protected function lm_868
  input Tpl.Text in_txt;
  input list<list<SimCodeVar.SimVar>> in_items;
  input Tpl.Text in_a_additionalFunctionDefinitions;
  input Tpl.Text in_a_additionalConstructorVariables;
  input Tpl.Text in_a_additionalDerivativeVarFunctionCalls;
  input Boolean in_a_createDebugCode;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_indexForUndefinedReferencesReal;
  input HashTableCrIListArray.HashTable in_a_varToArrayIndexMapping;
  input Tpl.Text in_a_classname;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_additionalFunctionDefinitions;
  output Tpl.Text out_a_additionalConstructorVariables;
  output Tpl.Text out_a_additionalDerivativeVarFunctionCalls;
  output Tpl.Text out_a_indexForUndefinedReferencesReal;
  output Tpl.Text out_a_classname;
algorithm
  (out_txt, out_a_additionalFunctionDefinitions, out_a_additionalConstructorVariables, out_a_additionalDerivativeVarFunctionCalls, out_a_indexForUndefinedReferencesReal, out_a_classname) :=
  match(in_txt, in_items, in_a_additionalFunctionDefinitions, in_a_additionalConstructorVariables, in_a_additionalDerivativeVarFunctionCalls, in_a_createDebugCode, in_a_useFlatArrayNotation, in_a_indexForUndefinedReferencesReal, in_a_varToArrayIndexMapping, in_a_classname)
    local
      Tpl.Text txt;
      list<list<SimCodeVar.SimVar>> rest;
      Tpl.Text a_additionalFunctionDefinitions;
      Tpl.Text a_additionalConstructorVariables;
      Tpl.Text a_additionalDerivativeVarFunctionCalls;
      Boolean a_createDebugCode;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_indexForUndefinedReferencesReal;
      HashTableCrIListArray.HashTable a_varToArrayIndexMapping;
      Tpl.Text a_classname;
      Integer x_i0;
      list<SimCodeVar.SimVar> i_varPartition;

    case ( txt,
           {},
           a_additionalFunctionDefinitions,
           a_additionalConstructorVariables,
           a_additionalDerivativeVarFunctionCalls,
           _,
           _,
           a_indexForUndefinedReferencesReal,
           _,
           a_classname )
      then (txt, a_additionalFunctionDefinitions, a_additionalConstructorVariables, a_additionalDerivativeVarFunctionCalls, a_indexForUndefinedReferencesReal, a_classname);

    case ( txt,
           i_varPartition :: rest,
           a_additionalFunctionDefinitions,
           a_additionalConstructorVariables,
           a_additionalDerivativeVarFunctionCalls,
           a_createDebugCode,
           a_useFlatArrayNotation,
           a_indexForUndefinedReferencesReal,
           a_varToArrayIndexMapping,
           a_classname )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        (txt, _, _, a_classname, a_indexForUndefinedReferencesReal, a_additionalDerivativeVarFunctionCalls, a_additionalConstructorVariables, a_additionalFunctionDefinitions) = memberVariableInitializeWithSplit(txt, i_varPartition, Tpl.stringText(intString(x_i0)), Tpl.strTokText(Tpl.ST_STRING("initDerivativeVars")), a_classname, a_varToArrayIndexMapping, a_indexForUndefinedReferencesReal, a_useFlatArrayNotation, a_createDebugCode, "Real", a_additionalDerivativeVarFunctionCalls, a_additionalConstructorVariables, a_additionalFunctionDefinitions);
        txt = Tpl.nextIter(txt);
        (txt, a_additionalFunctionDefinitions, a_additionalConstructorVariables, a_additionalDerivativeVarFunctionCalls, a_indexForUndefinedReferencesReal, a_classname) = lm_868(txt, rest, a_additionalFunctionDefinitions, a_additionalConstructorVariables, a_additionalDerivativeVarFunctionCalls, a_createDebugCode, a_useFlatArrayNotation, a_indexForUndefinedReferencesReal, a_varToArrayIndexMapping, a_classname);
      then (txt, a_additionalFunctionDefinitions, a_additionalConstructorVariables, a_additionalDerivativeVarFunctionCalls, a_indexForUndefinedReferencesReal, a_classname);
  end match;
end lm_868;

protected function lm_869
  input Tpl.Text in_txt;
  input list<list<SimCodeVar.SimVar>> in_items;
  input Tpl.Text in_a_additionalFunctionDefinitions;
  input Tpl.Text in_a_additionalConstructorVariables;
  input Tpl.Text in_a_additionalAlgVarFunctionCalls;
  input Boolean in_a_createDebugCode;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_indexForUndefinedReferencesReal;
  input HashTableCrIListArray.HashTable in_a_varToArrayIndexMapping;
  input Tpl.Text in_a_classname;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_additionalFunctionDefinitions;
  output Tpl.Text out_a_additionalConstructorVariables;
  output Tpl.Text out_a_additionalAlgVarFunctionCalls;
  output Tpl.Text out_a_indexForUndefinedReferencesReal;
  output Tpl.Text out_a_classname;
algorithm
  (out_txt, out_a_additionalFunctionDefinitions, out_a_additionalConstructorVariables, out_a_additionalAlgVarFunctionCalls, out_a_indexForUndefinedReferencesReal, out_a_classname) :=
  match(in_txt, in_items, in_a_additionalFunctionDefinitions, in_a_additionalConstructorVariables, in_a_additionalAlgVarFunctionCalls, in_a_createDebugCode, in_a_useFlatArrayNotation, in_a_indexForUndefinedReferencesReal, in_a_varToArrayIndexMapping, in_a_classname)
    local
      Tpl.Text txt;
      list<list<SimCodeVar.SimVar>> rest;
      Tpl.Text a_additionalFunctionDefinitions;
      Tpl.Text a_additionalConstructorVariables;
      Tpl.Text a_additionalAlgVarFunctionCalls;
      Boolean a_createDebugCode;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_indexForUndefinedReferencesReal;
      HashTableCrIListArray.HashTable a_varToArrayIndexMapping;
      Tpl.Text a_classname;
      Integer x_i0;
      list<SimCodeVar.SimVar> i_varPartition;

    case ( txt,
           {},
           a_additionalFunctionDefinitions,
           a_additionalConstructorVariables,
           a_additionalAlgVarFunctionCalls,
           _,
           _,
           a_indexForUndefinedReferencesReal,
           _,
           a_classname )
      then (txt, a_additionalFunctionDefinitions, a_additionalConstructorVariables, a_additionalAlgVarFunctionCalls, a_indexForUndefinedReferencesReal, a_classname);

    case ( txt,
           i_varPartition :: rest,
           a_additionalFunctionDefinitions,
           a_additionalConstructorVariables,
           a_additionalAlgVarFunctionCalls,
           a_createDebugCode,
           a_useFlatArrayNotation,
           a_indexForUndefinedReferencesReal,
           a_varToArrayIndexMapping,
           a_classname )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        (txt, _, _, a_classname, a_indexForUndefinedReferencesReal, a_additionalAlgVarFunctionCalls, a_additionalConstructorVariables, a_additionalFunctionDefinitions) = memberVariableInitializeWithSplit(txt, i_varPartition, Tpl.stringText(intString(x_i0)), Tpl.strTokText(Tpl.ST_STRING("initAlgVars")), a_classname, a_varToArrayIndexMapping, a_indexForUndefinedReferencesReal, a_useFlatArrayNotation, a_createDebugCode, "Real", a_additionalAlgVarFunctionCalls, a_additionalConstructorVariables, a_additionalFunctionDefinitions);
        txt = Tpl.nextIter(txt);
        (txt, a_additionalFunctionDefinitions, a_additionalConstructorVariables, a_additionalAlgVarFunctionCalls, a_indexForUndefinedReferencesReal, a_classname) = lm_869(txt, rest, a_additionalFunctionDefinitions, a_additionalConstructorVariables, a_additionalAlgVarFunctionCalls, a_createDebugCode, a_useFlatArrayNotation, a_indexForUndefinedReferencesReal, a_varToArrayIndexMapping, a_classname);
      then (txt, a_additionalFunctionDefinitions, a_additionalConstructorVariables, a_additionalAlgVarFunctionCalls, a_indexForUndefinedReferencesReal, a_classname);
  end match;
end lm_869;

protected function lm_870
  input Tpl.Text in_txt;
  input list<list<SimCodeVar.SimVar>> in_items;
  input Tpl.Text in_a_additionalFunctionDefinitions;
  input Tpl.Text in_a_additionalConstructorVariables;
  input Tpl.Text in_a_additionalDiscreteAlgVarFunctionCalls;
  input Boolean in_a_createDebugCode;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_indexForUndefinedReferencesReal;
  input HashTableCrIListArray.HashTable in_a_varToArrayIndexMapping;
  input Tpl.Text in_a_classname;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_additionalFunctionDefinitions;
  output Tpl.Text out_a_additionalConstructorVariables;
  output Tpl.Text out_a_additionalDiscreteAlgVarFunctionCalls;
  output Tpl.Text out_a_indexForUndefinedReferencesReal;
  output Tpl.Text out_a_classname;
algorithm
  (out_txt, out_a_additionalFunctionDefinitions, out_a_additionalConstructorVariables, out_a_additionalDiscreteAlgVarFunctionCalls, out_a_indexForUndefinedReferencesReal, out_a_classname) :=
  match(in_txt, in_items, in_a_additionalFunctionDefinitions, in_a_additionalConstructorVariables, in_a_additionalDiscreteAlgVarFunctionCalls, in_a_createDebugCode, in_a_useFlatArrayNotation, in_a_indexForUndefinedReferencesReal, in_a_varToArrayIndexMapping, in_a_classname)
    local
      Tpl.Text txt;
      list<list<SimCodeVar.SimVar>> rest;
      Tpl.Text a_additionalFunctionDefinitions;
      Tpl.Text a_additionalConstructorVariables;
      Tpl.Text a_additionalDiscreteAlgVarFunctionCalls;
      Boolean a_createDebugCode;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_indexForUndefinedReferencesReal;
      HashTableCrIListArray.HashTable a_varToArrayIndexMapping;
      Tpl.Text a_classname;
      Integer x_i0;
      list<SimCodeVar.SimVar> i_varPartition;

    case ( txt,
           {},
           a_additionalFunctionDefinitions,
           a_additionalConstructorVariables,
           a_additionalDiscreteAlgVarFunctionCalls,
           _,
           _,
           a_indexForUndefinedReferencesReal,
           _,
           a_classname )
      then (txt, a_additionalFunctionDefinitions, a_additionalConstructorVariables, a_additionalDiscreteAlgVarFunctionCalls, a_indexForUndefinedReferencesReal, a_classname);

    case ( txt,
           i_varPartition :: rest,
           a_additionalFunctionDefinitions,
           a_additionalConstructorVariables,
           a_additionalDiscreteAlgVarFunctionCalls,
           a_createDebugCode,
           a_useFlatArrayNotation,
           a_indexForUndefinedReferencesReal,
           a_varToArrayIndexMapping,
           a_classname )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        (txt, _, _, a_classname, a_indexForUndefinedReferencesReal, a_additionalDiscreteAlgVarFunctionCalls, a_additionalConstructorVariables, a_additionalFunctionDefinitions) = memberVariableInitializeWithSplit(txt, i_varPartition, Tpl.stringText(intString(x_i0)), Tpl.strTokText(Tpl.ST_STRING("initDiscreteAlgVars")), a_classname, a_varToArrayIndexMapping, a_indexForUndefinedReferencesReal, a_useFlatArrayNotation, a_createDebugCode, "Real", a_additionalDiscreteAlgVarFunctionCalls, a_additionalConstructorVariables, a_additionalFunctionDefinitions);
        txt = Tpl.nextIter(txt);
        (txt, a_additionalFunctionDefinitions, a_additionalConstructorVariables, a_additionalDiscreteAlgVarFunctionCalls, a_indexForUndefinedReferencesReal, a_classname) = lm_870(txt, rest, a_additionalFunctionDefinitions, a_additionalConstructorVariables, a_additionalDiscreteAlgVarFunctionCalls, a_createDebugCode, a_useFlatArrayNotation, a_indexForUndefinedReferencesReal, a_varToArrayIndexMapping, a_classname);
      then (txt, a_additionalFunctionDefinitions, a_additionalConstructorVariables, a_additionalDiscreteAlgVarFunctionCalls, a_indexForUndefinedReferencesReal, a_classname);
  end match;
end lm_870;

protected function lm_871
  input Tpl.Text in_txt;
  input list<list<SimCodeVar.SimVar>> in_items;
  input Tpl.Text in_a_additionalFunctionDefinitions;
  input Tpl.Text in_a_additionalConstructorVariables;
  input Tpl.Text in_a_additionalIntAlgVarFunctionCalls;
  input Boolean in_a_createDebugCode;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_indexForUndefinedReferencesInt;
  input HashTableCrIListArray.HashTable in_a_varToArrayIndexMapping;
  input Tpl.Text in_a_classname;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_additionalFunctionDefinitions;
  output Tpl.Text out_a_additionalConstructorVariables;
  output Tpl.Text out_a_additionalIntAlgVarFunctionCalls;
  output Tpl.Text out_a_indexForUndefinedReferencesInt;
  output Tpl.Text out_a_classname;
algorithm
  (out_txt, out_a_additionalFunctionDefinitions, out_a_additionalConstructorVariables, out_a_additionalIntAlgVarFunctionCalls, out_a_indexForUndefinedReferencesInt, out_a_classname) :=
  match(in_txt, in_items, in_a_additionalFunctionDefinitions, in_a_additionalConstructorVariables, in_a_additionalIntAlgVarFunctionCalls, in_a_createDebugCode, in_a_useFlatArrayNotation, in_a_indexForUndefinedReferencesInt, in_a_varToArrayIndexMapping, in_a_classname)
    local
      Tpl.Text txt;
      list<list<SimCodeVar.SimVar>> rest;
      Tpl.Text a_additionalFunctionDefinitions;
      Tpl.Text a_additionalConstructorVariables;
      Tpl.Text a_additionalIntAlgVarFunctionCalls;
      Boolean a_createDebugCode;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_indexForUndefinedReferencesInt;
      HashTableCrIListArray.HashTable a_varToArrayIndexMapping;
      Tpl.Text a_classname;
      Integer x_i0;
      list<SimCodeVar.SimVar> i_varPartition;

    case ( txt,
           {},
           a_additionalFunctionDefinitions,
           a_additionalConstructorVariables,
           a_additionalIntAlgVarFunctionCalls,
           _,
           _,
           a_indexForUndefinedReferencesInt,
           _,
           a_classname )
      then (txt, a_additionalFunctionDefinitions, a_additionalConstructorVariables, a_additionalIntAlgVarFunctionCalls, a_indexForUndefinedReferencesInt, a_classname);

    case ( txt,
           i_varPartition :: rest,
           a_additionalFunctionDefinitions,
           a_additionalConstructorVariables,
           a_additionalIntAlgVarFunctionCalls,
           a_createDebugCode,
           a_useFlatArrayNotation,
           a_indexForUndefinedReferencesInt,
           a_varToArrayIndexMapping,
           a_classname )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        (txt, _, _, a_classname, a_indexForUndefinedReferencesInt, a_additionalIntAlgVarFunctionCalls, a_additionalConstructorVariables, a_additionalFunctionDefinitions) = memberVariableInitializeWithSplit(txt, i_varPartition, Tpl.stringText(intString(x_i0)), Tpl.strTokText(Tpl.ST_STRING("initIntAlgVars")), a_classname, a_varToArrayIndexMapping, a_indexForUndefinedReferencesInt, a_useFlatArrayNotation, a_createDebugCode, "Int", a_additionalIntAlgVarFunctionCalls, a_additionalConstructorVariables, a_additionalFunctionDefinitions);
        txt = Tpl.nextIter(txt);
        (txt, a_additionalFunctionDefinitions, a_additionalConstructorVariables, a_additionalIntAlgVarFunctionCalls, a_indexForUndefinedReferencesInt, a_classname) = lm_871(txt, rest, a_additionalFunctionDefinitions, a_additionalConstructorVariables, a_additionalIntAlgVarFunctionCalls, a_createDebugCode, a_useFlatArrayNotation, a_indexForUndefinedReferencesInt, a_varToArrayIndexMapping, a_classname);
      then (txt, a_additionalFunctionDefinitions, a_additionalConstructorVariables, a_additionalIntAlgVarFunctionCalls, a_indexForUndefinedReferencesInt, a_classname);
  end match;
end lm_871;

protected function lm_872
  input Tpl.Text in_txt;
  input list<list<SimCodeVar.SimVar>> in_items;
  input Tpl.Text in_a_additionalFunctionDefinitions;
  input Tpl.Text in_a_additionalConstructorVariables;
  input Tpl.Text in_a_additionalBoolAlgVarFunctionCalls;
  input Boolean in_a_createDebugCode;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_indexForUndefinedReferencesBool;
  input HashTableCrIListArray.HashTable in_a_varToArrayIndexMapping;
  input Tpl.Text in_a_classname;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_additionalFunctionDefinitions;
  output Tpl.Text out_a_additionalConstructorVariables;
  output Tpl.Text out_a_additionalBoolAlgVarFunctionCalls;
  output Tpl.Text out_a_indexForUndefinedReferencesBool;
  output Tpl.Text out_a_classname;
algorithm
  (out_txt, out_a_additionalFunctionDefinitions, out_a_additionalConstructorVariables, out_a_additionalBoolAlgVarFunctionCalls, out_a_indexForUndefinedReferencesBool, out_a_classname) :=
  match(in_txt, in_items, in_a_additionalFunctionDefinitions, in_a_additionalConstructorVariables, in_a_additionalBoolAlgVarFunctionCalls, in_a_createDebugCode, in_a_useFlatArrayNotation, in_a_indexForUndefinedReferencesBool, in_a_varToArrayIndexMapping, in_a_classname)
    local
      Tpl.Text txt;
      list<list<SimCodeVar.SimVar>> rest;
      Tpl.Text a_additionalFunctionDefinitions;
      Tpl.Text a_additionalConstructorVariables;
      Tpl.Text a_additionalBoolAlgVarFunctionCalls;
      Boolean a_createDebugCode;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_indexForUndefinedReferencesBool;
      HashTableCrIListArray.HashTable a_varToArrayIndexMapping;
      Tpl.Text a_classname;
      Integer x_i0;
      list<SimCodeVar.SimVar> i_varPartition;

    case ( txt,
           {},
           a_additionalFunctionDefinitions,
           a_additionalConstructorVariables,
           a_additionalBoolAlgVarFunctionCalls,
           _,
           _,
           a_indexForUndefinedReferencesBool,
           _,
           a_classname )
      then (txt, a_additionalFunctionDefinitions, a_additionalConstructorVariables, a_additionalBoolAlgVarFunctionCalls, a_indexForUndefinedReferencesBool, a_classname);

    case ( txt,
           i_varPartition :: rest,
           a_additionalFunctionDefinitions,
           a_additionalConstructorVariables,
           a_additionalBoolAlgVarFunctionCalls,
           a_createDebugCode,
           a_useFlatArrayNotation,
           a_indexForUndefinedReferencesBool,
           a_varToArrayIndexMapping,
           a_classname )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        (txt, _, _, a_classname, a_indexForUndefinedReferencesBool, a_additionalBoolAlgVarFunctionCalls, a_additionalConstructorVariables, a_additionalFunctionDefinitions) = memberVariableInitializeWithSplit(txt, i_varPartition, Tpl.stringText(intString(x_i0)), Tpl.strTokText(Tpl.ST_STRING("initBoolAlgVars")), a_classname, a_varToArrayIndexMapping, a_indexForUndefinedReferencesBool, a_useFlatArrayNotation, a_createDebugCode, "Bool", a_additionalBoolAlgVarFunctionCalls, a_additionalConstructorVariables, a_additionalFunctionDefinitions);
        txt = Tpl.nextIter(txt);
        (txt, a_additionalFunctionDefinitions, a_additionalConstructorVariables, a_additionalBoolAlgVarFunctionCalls, a_indexForUndefinedReferencesBool, a_classname) = lm_872(txt, rest, a_additionalFunctionDefinitions, a_additionalConstructorVariables, a_additionalBoolAlgVarFunctionCalls, a_createDebugCode, a_useFlatArrayNotation, a_indexForUndefinedReferencesBool, a_varToArrayIndexMapping, a_classname);
      then (txt, a_additionalFunctionDefinitions, a_additionalConstructorVariables, a_additionalBoolAlgVarFunctionCalls, a_indexForUndefinedReferencesBool, a_classname);
  end match;
end lm_872;

protected function lm_873
  input Tpl.Text in_txt;
  input list<list<SimCodeVar.SimVar>> in_items;
  input Tpl.Text in_a_additionalFunctionDefinitions;
  input Tpl.Text in_a_additionalConstructorVariables;
  input Tpl.Text in_a_additionalStringAlgVarFunctionCalls;
  input Boolean in_a_createDebugCode;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_indexForUndefinedReferencesString;
  input HashTableCrIListArray.HashTable in_a_varToArrayIndexMapping;
  input Tpl.Text in_a_classname;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_additionalFunctionDefinitions;
  output Tpl.Text out_a_additionalConstructorVariables;
  output Tpl.Text out_a_additionalStringAlgVarFunctionCalls;
  output Tpl.Text out_a_indexForUndefinedReferencesString;
  output Tpl.Text out_a_classname;
algorithm
  (out_txt, out_a_additionalFunctionDefinitions, out_a_additionalConstructorVariables, out_a_additionalStringAlgVarFunctionCalls, out_a_indexForUndefinedReferencesString, out_a_classname) :=
  match(in_txt, in_items, in_a_additionalFunctionDefinitions, in_a_additionalConstructorVariables, in_a_additionalStringAlgVarFunctionCalls, in_a_createDebugCode, in_a_useFlatArrayNotation, in_a_indexForUndefinedReferencesString, in_a_varToArrayIndexMapping, in_a_classname)
    local
      Tpl.Text txt;
      list<list<SimCodeVar.SimVar>> rest;
      Tpl.Text a_additionalFunctionDefinitions;
      Tpl.Text a_additionalConstructorVariables;
      Tpl.Text a_additionalStringAlgVarFunctionCalls;
      Boolean a_createDebugCode;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_indexForUndefinedReferencesString;
      HashTableCrIListArray.HashTable a_varToArrayIndexMapping;
      Tpl.Text a_classname;
      Integer x_i0;
      list<SimCodeVar.SimVar> i_varPartition;

    case ( txt,
           {},
           a_additionalFunctionDefinitions,
           a_additionalConstructorVariables,
           a_additionalStringAlgVarFunctionCalls,
           _,
           _,
           a_indexForUndefinedReferencesString,
           _,
           a_classname )
      then (txt, a_additionalFunctionDefinitions, a_additionalConstructorVariables, a_additionalStringAlgVarFunctionCalls, a_indexForUndefinedReferencesString, a_classname);

    case ( txt,
           i_varPartition :: rest,
           a_additionalFunctionDefinitions,
           a_additionalConstructorVariables,
           a_additionalStringAlgVarFunctionCalls,
           a_createDebugCode,
           a_useFlatArrayNotation,
           a_indexForUndefinedReferencesString,
           a_varToArrayIndexMapping,
           a_classname )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        (txt, _, _, a_classname, a_indexForUndefinedReferencesString, a_additionalStringAlgVarFunctionCalls, a_additionalConstructorVariables, a_additionalFunctionDefinitions) = memberVariableInitializeWithSplit(txt, i_varPartition, Tpl.stringText(intString(x_i0)), Tpl.strTokText(Tpl.ST_STRING("initStringAlgVars")), a_classname, a_varToArrayIndexMapping, a_indexForUndefinedReferencesString, a_useFlatArrayNotation, a_createDebugCode, "String", a_additionalStringAlgVarFunctionCalls, a_additionalConstructorVariables, a_additionalFunctionDefinitions);
        txt = Tpl.nextIter(txt);
        (txt, a_additionalFunctionDefinitions, a_additionalConstructorVariables, a_additionalStringAlgVarFunctionCalls, a_indexForUndefinedReferencesString, a_classname) = lm_873(txt, rest, a_additionalFunctionDefinitions, a_additionalConstructorVariables, a_additionalStringAlgVarFunctionCalls, a_createDebugCode, a_useFlatArrayNotation, a_indexForUndefinedReferencesString, a_varToArrayIndexMapping, a_classname);
      then (txt, a_additionalFunctionDefinitions, a_additionalConstructorVariables, a_additionalStringAlgVarFunctionCalls, a_indexForUndefinedReferencesString, a_classname);
  end match;
end lm_873;

protected function lm_874
  input Tpl.Text in_txt;
  input list<list<SimCodeVar.SimVar>> in_items;
  input Tpl.Text in_a_additionalFunctionDefinitions;
  input Tpl.Text in_a_additionalConstructorVariables;
  input Tpl.Text in_a_additionalParameterRealVarFunctionCalls;
  input Boolean in_a_createDebugCode;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_indexForUndefinedReferencesReal;
  input HashTableCrIListArray.HashTable in_a_varToArrayIndexMapping;
  input Tpl.Text in_a_classname;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_additionalFunctionDefinitions;
  output Tpl.Text out_a_additionalConstructorVariables;
  output Tpl.Text out_a_additionalParameterRealVarFunctionCalls;
  output Tpl.Text out_a_indexForUndefinedReferencesReal;
  output Tpl.Text out_a_classname;
algorithm
  (out_txt, out_a_additionalFunctionDefinitions, out_a_additionalConstructorVariables, out_a_additionalParameterRealVarFunctionCalls, out_a_indexForUndefinedReferencesReal, out_a_classname) :=
  match(in_txt, in_items, in_a_additionalFunctionDefinitions, in_a_additionalConstructorVariables, in_a_additionalParameterRealVarFunctionCalls, in_a_createDebugCode, in_a_useFlatArrayNotation, in_a_indexForUndefinedReferencesReal, in_a_varToArrayIndexMapping, in_a_classname)
    local
      Tpl.Text txt;
      list<list<SimCodeVar.SimVar>> rest;
      Tpl.Text a_additionalFunctionDefinitions;
      Tpl.Text a_additionalConstructorVariables;
      Tpl.Text a_additionalParameterRealVarFunctionCalls;
      Boolean a_createDebugCode;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_indexForUndefinedReferencesReal;
      HashTableCrIListArray.HashTable a_varToArrayIndexMapping;
      Tpl.Text a_classname;
      Integer x_i0;
      list<SimCodeVar.SimVar> i_varPartition;

    case ( txt,
           {},
           a_additionalFunctionDefinitions,
           a_additionalConstructorVariables,
           a_additionalParameterRealVarFunctionCalls,
           _,
           _,
           a_indexForUndefinedReferencesReal,
           _,
           a_classname )
      then (txt, a_additionalFunctionDefinitions, a_additionalConstructorVariables, a_additionalParameterRealVarFunctionCalls, a_indexForUndefinedReferencesReal, a_classname);

    case ( txt,
           i_varPartition :: rest,
           a_additionalFunctionDefinitions,
           a_additionalConstructorVariables,
           a_additionalParameterRealVarFunctionCalls,
           a_createDebugCode,
           a_useFlatArrayNotation,
           a_indexForUndefinedReferencesReal,
           a_varToArrayIndexMapping,
           a_classname )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        (txt, _, _, a_classname, a_indexForUndefinedReferencesReal, a_additionalParameterRealVarFunctionCalls, a_additionalConstructorVariables, a_additionalFunctionDefinitions) = memberVariableInitializeWithSplit(txt, i_varPartition, Tpl.stringText(intString(x_i0)), Tpl.strTokText(Tpl.ST_STRING("initParameterRealVars")), a_classname, a_varToArrayIndexMapping, a_indexForUndefinedReferencesReal, a_useFlatArrayNotation, a_createDebugCode, "Real", a_additionalParameterRealVarFunctionCalls, a_additionalConstructorVariables, a_additionalFunctionDefinitions);
        txt = Tpl.nextIter(txt);
        (txt, a_additionalFunctionDefinitions, a_additionalConstructorVariables, a_additionalParameterRealVarFunctionCalls, a_indexForUndefinedReferencesReal, a_classname) = lm_874(txt, rest, a_additionalFunctionDefinitions, a_additionalConstructorVariables, a_additionalParameterRealVarFunctionCalls, a_createDebugCode, a_useFlatArrayNotation, a_indexForUndefinedReferencesReal, a_varToArrayIndexMapping, a_classname);
      then (txt, a_additionalFunctionDefinitions, a_additionalConstructorVariables, a_additionalParameterRealVarFunctionCalls, a_indexForUndefinedReferencesReal, a_classname);
  end match;
end lm_874;

protected function lm_875
  input Tpl.Text in_txt;
  input list<list<SimCodeVar.SimVar>> in_items;
  input Tpl.Text in_a_additionalFunctionDefinitions;
  input Tpl.Text in_a_additionalConstructorVariables;
  input Tpl.Text in_a_additionalParameterIntVarFunctionCalls;
  input Boolean in_a_createDebugCode;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_indexForUndefinedReferencesInt;
  input HashTableCrIListArray.HashTable in_a_varToArrayIndexMapping;
  input Tpl.Text in_a_classname;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_additionalFunctionDefinitions;
  output Tpl.Text out_a_additionalConstructorVariables;
  output Tpl.Text out_a_additionalParameterIntVarFunctionCalls;
  output Tpl.Text out_a_indexForUndefinedReferencesInt;
  output Tpl.Text out_a_classname;
algorithm
  (out_txt, out_a_additionalFunctionDefinitions, out_a_additionalConstructorVariables, out_a_additionalParameterIntVarFunctionCalls, out_a_indexForUndefinedReferencesInt, out_a_classname) :=
  match(in_txt, in_items, in_a_additionalFunctionDefinitions, in_a_additionalConstructorVariables, in_a_additionalParameterIntVarFunctionCalls, in_a_createDebugCode, in_a_useFlatArrayNotation, in_a_indexForUndefinedReferencesInt, in_a_varToArrayIndexMapping, in_a_classname)
    local
      Tpl.Text txt;
      list<list<SimCodeVar.SimVar>> rest;
      Tpl.Text a_additionalFunctionDefinitions;
      Tpl.Text a_additionalConstructorVariables;
      Tpl.Text a_additionalParameterIntVarFunctionCalls;
      Boolean a_createDebugCode;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_indexForUndefinedReferencesInt;
      HashTableCrIListArray.HashTable a_varToArrayIndexMapping;
      Tpl.Text a_classname;
      Integer x_i0;
      list<SimCodeVar.SimVar> i_varPartition;

    case ( txt,
           {},
           a_additionalFunctionDefinitions,
           a_additionalConstructorVariables,
           a_additionalParameterIntVarFunctionCalls,
           _,
           _,
           a_indexForUndefinedReferencesInt,
           _,
           a_classname )
      then (txt, a_additionalFunctionDefinitions, a_additionalConstructorVariables, a_additionalParameterIntVarFunctionCalls, a_indexForUndefinedReferencesInt, a_classname);

    case ( txt,
           i_varPartition :: rest,
           a_additionalFunctionDefinitions,
           a_additionalConstructorVariables,
           a_additionalParameterIntVarFunctionCalls,
           a_createDebugCode,
           a_useFlatArrayNotation,
           a_indexForUndefinedReferencesInt,
           a_varToArrayIndexMapping,
           a_classname )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        (txt, _, _, a_classname, a_indexForUndefinedReferencesInt, a_additionalParameterIntVarFunctionCalls, a_additionalConstructorVariables, a_additionalFunctionDefinitions) = memberVariableInitializeWithSplit(txt, i_varPartition, Tpl.stringText(intString(x_i0)), Tpl.strTokText(Tpl.ST_STRING("initParameterIntVars")), a_classname, a_varToArrayIndexMapping, a_indexForUndefinedReferencesInt, a_useFlatArrayNotation, a_createDebugCode, "Int", a_additionalParameterIntVarFunctionCalls, a_additionalConstructorVariables, a_additionalFunctionDefinitions);
        txt = Tpl.nextIter(txt);
        (txt, a_additionalFunctionDefinitions, a_additionalConstructorVariables, a_additionalParameterIntVarFunctionCalls, a_indexForUndefinedReferencesInt, a_classname) = lm_875(txt, rest, a_additionalFunctionDefinitions, a_additionalConstructorVariables, a_additionalParameterIntVarFunctionCalls, a_createDebugCode, a_useFlatArrayNotation, a_indexForUndefinedReferencesInt, a_varToArrayIndexMapping, a_classname);
      then (txt, a_additionalFunctionDefinitions, a_additionalConstructorVariables, a_additionalParameterIntVarFunctionCalls, a_indexForUndefinedReferencesInt, a_classname);
  end match;
end lm_875;

protected function lm_876
  input Tpl.Text in_txt;
  input list<list<SimCodeVar.SimVar>> in_items;
  input Tpl.Text in_a_additionalFunctionDefinitions;
  input Tpl.Text in_a_additionalConstructorVariables;
  input Tpl.Text in_a_additionalParameterBoolVarFunctionCalls;
  input Boolean in_a_createDebugCode;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_indexForUndefinedReferencesBool;
  input HashTableCrIListArray.HashTable in_a_varToArrayIndexMapping;
  input Tpl.Text in_a_classname;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_additionalFunctionDefinitions;
  output Tpl.Text out_a_additionalConstructorVariables;
  output Tpl.Text out_a_additionalParameterBoolVarFunctionCalls;
  output Tpl.Text out_a_indexForUndefinedReferencesBool;
  output Tpl.Text out_a_classname;
algorithm
  (out_txt, out_a_additionalFunctionDefinitions, out_a_additionalConstructorVariables, out_a_additionalParameterBoolVarFunctionCalls, out_a_indexForUndefinedReferencesBool, out_a_classname) :=
  match(in_txt, in_items, in_a_additionalFunctionDefinitions, in_a_additionalConstructorVariables, in_a_additionalParameterBoolVarFunctionCalls, in_a_createDebugCode, in_a_useFlatArrayNotation, in_a_indexForUndefinedReferencesBool, in_a_varToArrayIndexMapping, in_a_classname)
    local
      Tpl.Text txt;
      list<list<SimCodeVar.SimVar>> rest;
      Tpl.Text a_additionalFunctionDefinitions;
      Tpl.Text a_additionalConstructorVariables;
      Tpl.Text a_additionalParameterBoolVarFunctionCalls;
      Boolean a_createDebugCode;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_indexForUndefinedReferencesBool;
      HashTableCrIListArray.HashTable a_varToArrayIndexMapping;
      Tpl.Text a_classname;
      Integer x_i0;
      list<SimCodeVar.SimVar> i_varPartition;

    case ( txt,
           {},
           a_additionalFunctionDefinitions,
           a_additionalConstructorVariables,
           a_additionalParameterBoolVarFunctionCalls,
           _,
           _,
           a_indexForUndefinedReferencesBool,
           _,
           a_classname )
      then (txt, a_additionalFunctionDefinitions, a_additionalConstructorVariables, a_additionalParameterBoolVarFunctionCalls, a_indexForUndefinedReferencesBool, a_classname);

    case ( txt,
           i_varPartition :: rest,
           a_additionalFunctionDefinitions,
           a_additionalConstructorVariables,
           a_additionalParameterBoolVarFunctionCalls,
           a_createDebugCode,
           a_useFlatArrayNotation,
           a_indexForUndefinedReferencesBool,
           a_varToArrayIndexMapping,
           a_classname )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        (txt, _, _, a_classname, a_indexForUndefinedReferencesBool, a_additionalParameterBoolVarFunctionCalls, a_additionalConstructorVariables, a_additionalFunctionDefinitions) = memberVariableInitializeWithSplit(txt, i_varPartition, Tpl.stringText(intString(x_i0)), Tpl.strTokText(Tpl.ST_STRING("initParameterBoolVars")), a_classname, a_varToArrayIndexMapping, a_indexForUndefinedReferencesBool, a_useFlatArrayNotation, a_createDebugCode, "Bool", a_additionalParameterBoolVarFunctionCalls, a_additionalConstructorVariables, a_additionalFunctionDefinitions);
        txt = Tpl.nextIter(txt);
        (txt, a_additionalFunctionDefinitions, a_additionalConstructorVariables, a_additionalParameterBoolVarFunctionCalls, a_indexForUndefinedReferencesBool, a_classname) = lm_876(txt, rest, a_additionalFunctionDefinitions, a_additionalConstructorVariables, a_additionalParameterBoolVarFunctionCalls, a_createDebugCode, a_useFlatArrayNotation, a_indexForUndefinedReferencesBool, a_varToArrayIndexMapping, a_classname);
      then (txt, a_additionalFunctionDefinitions, a_additionalConstructorVariables, a_additionalParameterBoolVarFunctionCalls, a_indexForUndefinedReferencesBool, a_classname);
  end match;
end lm_876;

protected function lm_877
  input Tpl.Text in_txt;
  input list<list<SimCodeVar.SimVar>> in_items;
  input Tpl.Text in_a_additionalFunctionDefinitions;
  input Tpl.Text in_a_additionalConstructorVariables;
  input Tpl.Text in_a_additionalParameterStringVarFunctionCalls;
  input Boolean in_a_createDebugCode;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_indexForUndefinedReferencesString;
  input HashTableCrIListArray.HashTable in_a_varToArrayIndexMapping;
  input Tpl.Text in_a_classname;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_additionalFunctionDefinitions;
  output Tpl.Text out_a_additionalConstructorVariables;
  output Tpl.Text out_a_additionalParameterStringVarFunctionCalls;
  output Tpl.Text out_a_indexForUndefinedReferencesString;
  output Tpl.Text out_a_classname;
algorithm
  (out_txt, out_a_additionalFunctionDefinitions, out_a_additionalConstructorVariables, out_a_additionalParameterStringVarFunctionCalls, out_a_indexForUndefinedReferencesString, out_a_classname) :=
  match(in_txt, in_items, in_a_additionalFunctionDefinitions, in_a_additionalConstructorVariables, in_a_additionalParameterStringVarFunctionCalls, in_a_createDebugCode, in_a_useFlatArrayNotation, in_a_indexForUndefinedReferencesString, in_a_varToArrayIndexMapping, in_a_classname)
    local
      Tpl.Text txt;
      list<list<SimCodeVar.SimVar>> rest;
      Tpl.Text a_additionalFunctionDefinitions;
      Tpl.Text a_additionalConstructorVariables;
      Tpl.Text a_additionalParameterStringVarFunctionCalls;
      Boolean a_createDebugCode;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_indexForUndefinedReferencesString;
      HashTableCrIListArray.HashTable a_varToArrayIndexMapping;
      Tpl.Text a_classname;
      Integer x_i0;
      list<SimCodeVar.SimVar> i_varPartition;

    case ( txt,
           {},
           a_additionalFunctionDefinitions,
           a_additionalConstructorVariables,
           a_additionalParameterStringVarFunctionCalls,
           _,
           _,
           a_indexForUndefinedReferencesString,
           _,
           a_classname )
      then (txt, a_additionalFunctionDefinitions, a_additionalConstructorVariables, a_additionalParameterStringVarFunctionCalls, a_indexForUndefinedReferencesString, a_classname);

    case ( txt,
           i_varPartition :: rest,
           a_additionalFunctionDefinitions,
           a_additionalConstructorVariables,
           a_additionalParameterStringVarFunctionCalls,
           a_createDebugCode,
           a_useFlatArrayNotation,
           a_indexForUndefinedReferencesString,
           a_varToArrayIndexMapping,
           a_classname )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        (txt, _, _, a_classname, a_indexForUndefinedReferencesString, a_additionalParameterStringVarFunctionCalls, a_additionalConstructorVariables, a_additionalFunctionDefinitions) = memberVariableInitializeWithSplit(txt, i_varPartition, Tpl.stringText(intString(x_i0)), Tpl.strTokText(Tpl.ST_STRING("initParameterStringVars")), a_classname, a_varToArrayIndexMapping, a_indexForUndefinedReferencesString, a_useFlatArrayNotation, a_createDebugCode, "String", a_additionalParameterStringVarFunctionCalls, a_additionalConstructorVariables, a_additionalFunctionDefinitions);
        txt = Tpl.nextIter(txt);
        (txt, a_additionalFunctionDefinitions, a_additionalConstructorVariables, a_additionalParameterStringVarFunctionCalls, a_indexForUndefinedReferencesString, a_classname) = lm_877(txt, rest, a_additionalFunctionDefinitions, a_additionalConstructorVariables, a_additionalParameterStringVarFunctionCalls, a_createDebugCode, a_useFlatArrayNotation, a_indexForUndefinedReferencesString, a_varToArrayIndexMapping, a_classname);
      then (txt, a_additionalFunctionDefinitions, a_additionalConstructorVariables, a_additionalParameterStringVarFunctionCalls, a_indexForUndefinedReferencesString, a_classname);
  end match;
end lm_877;

protected function lm_878
  input Tpl.Text in_txt;
  input list<list<SimCodeVar.SimVar>> in_items;
  input Tpl.Text in_a_additionalFunctionDefinitions;
  input Tpl.Text in_a_additionalConstructorVariables;
  input Tpl.Text in_a_additionalAliasRealVarFunctionCalls;
  input Boolean in_a_createDebugCode;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_indexForUndefinedReferencesReal;
  input HashTableCrIListArray.HashTable in_a_varToArrayIndexMapping;
  input Tpl.Text in_a_classname;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_additionalFunctionDefinitions;
  output Tpl.Text out_a_additionalConstructorVariables;
  output Tpl.Text out_a_additionalAliasRealVarFunctionCalls;
  output Tpl.Text out_a_indexForUndefinedReferencesReal;
  output Tpl.Text out_a_classname;
algorithm
  (out_txt, out_a_additionalFunctionDefinitions, out_a_additionalConstructorVariables, out_a_additionalAliasRealVarFunctionCalls, out_a_indexForUndefinedReferencesReal, out_a_classname) :=
  match(in_txt, in_items, in_a_additionalFunctionDefinitions, in_a_additionalConstructorVariables, in_a_additionalAliasRealVarFunctionCalls, in_a_createDebugCode, in_a_useFlatArrayNotation, in_a_indexForUndefinedReferencesReal, in_a_varToArrayIndexMapping, in_a_classname)
    local
      Tpl.Text txt;
      list<list<SimCodeVar.SimVar>> rest;
      Tpl.Text a_additionalFunctionDefinitions;
      Tpl.Text a_additionalConstructorVariables;
      Tpl.Text a_additionalAliasRealVarFunctionCalls;
      Boolean a_createDebugCode;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_indexForUndefinedReferencesReal;
      HashTableCrIListArray.HashTable a_varToArrayIndexMapping;
      Tpl.Text a_classname;
      Integer x_i0;
      list<SimCodeVar.SimVar> i_varPartition;

    case ( txt,
           {},
           a_additionalFunctionDefinitions,
           a_additionalConstructorVariables,
           a_additionalAliasRealVarFunctionCalls,
           _,
           _,
           a_indexForUndefinedReferencesReal,
           _,
           a_classname )
      then (txt, a_additionalFunctionDefinitions, a_additionalConstructorVariables, a_additionalAliasRealVarFunctionCalls, a_indexForUndefinedReferencesReal, a_classname);

    case ( txt,
           i_varPartition :: rest,
           a_additionalFunctionDefinitions,
           a_additionalConstructorVariables,
           a_additionalAliasRealVarFunctionCalls,
           a_createDebugCode,
           a_useFlatArrayNotation,
           a_indexForUndefinedReferencesReal,
           a_varToArrayIndexMapping,
           a_classname )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        (txt, _, _, a_classname, a_indexForUndefinedReferencesReal, a_additionalAliasRealVarFunctionCalls, a_additionalConstructorVariables, a_additionalFunctionDefinitions) = memberVariableInitializeWithSplit(txt, i_varPartition, Tpl.stringText(intString(x_i0)), Tpl.strTokText(Tpl.ST_STRING("initAliasRealVars")), a_classname, a_varToArrayIndexMapping, a_indexForUndefinedReferencesReal, a_useFlatArrayNotation, a_createDebugCode, "Real", a_additionalAliasRealVarFunctionCalls, a_additionalConstructorVariables, a_additionalFunctionDefinitions);
        txt = Tpl.nextIter(txt);
        (txt, a_additionalFunctionDefinitions, a_additionalConstructorVariables, a_additionalAliasRealVarFunctionCalls, a_indexForUndefinedReferencesReal, a_classname) = lm_878(txt, rest, a_additionalFunctionDefinitions, a_additionalConstructorVariables, a_additionalAliasRealVarFunctionCalls, a_createDebugCode, a_useFlatArrayNotation, a_indexForUndefinedReferencesReal, a_varToArrayIndexMapping, a_classname);
      then (txt, a_additionalFunctionDefinitions, a_additionalConstructorVariables, a_additionalAliasRealVarFunctionCalls, a_indexForUndefinedReferencesReal, a_classname);
  end match;
end lm_878;

protected function lm_879
  input Tpl.Text in_txt;
  input list<list<SimCodeVar.SimVar>> in_items;
  input Tpl.Text in_a_additionalFunctionDefinitions;
  input Tpl.Text in_a_additionalConstructorVariables;
  input Tpl.Text in_a_additionalAliasIntVarFunctionCalls;
  input Boolean in_a_createDebugCode;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_indexForUndefinedReferencesInt;
  input HashTableCrIListArray.HashTable in_a_varToArrayIndexMapping;
  input Tpl.Text in_a_classname;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_additionalFunctionDefinitions;
  output Tpl.Text out_a_additionalConstructorVariables;
  output Tpl.Text out_a_additionalAliasIntVarFunctionCalls;
  output Tpl.Text out_a_indexForUndefinedReferencesInt;
  output Tpl.Text out_a_classname;
algorithm
  (out_txt, out_a_additionalFunctionDefinitions, out_a_additionalConstructorVariables, out_a_additionalAliasIntVarFunctionCalls, out_a_indexForUndefinedReferencesInt, out_a_classname) :=
  match(in_txt, in_items, in_a_additionalFunctionDefinitions, in_a_additionalConstructorVariables, in_a_additionalAliasIntVarFunctionCalls, in_a_createDebugCode, in_a_useFlatArrayNotation, in_a_indexForUndefinedReferencesInt, in_a_varToArrayIndexMapping, in_a_classname)
    local
      Tpl.Text txt;
      list<list<SimCodeVar.SimVar>> rest;
      Tpl.Text a_additionalFunctionDefinitions;
      Tpl.Text a_additionalConstructorVariables;
      Tpl.Text a_additionalAliasIntVarFunctionCalls;
      Boolean a_createDebugCode;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_indexForUndefinedReferencesInt;
      HashTableCrIListArray.HashTable a_varToArrayIndexMapping;
      Tpl.Text a_classname;
      Integer x_i0;
      list<SimCodeVar.SimVar> i_varPartition;

    case ( txt,
           {},
           a_additionalFunctionDefinitions,
           a_additionalConstructorVariables,
           a_additionalAliasIntVarFunctionCalls,
           _,
           _,
           a_indexForUndefinedReferencesInt,
           _,
           a_classname )
      then (txt, a_additionalFunctionDefinitions, a_additionalConstructorVariables, a_additionalAliasIntVarFunctionCalls, a_indexForUndefinedReferencesInt, a_classname);

    case ( txt,
           i_varPartition :: rest,
           a_additionalFunctionDefinitions,
           a_additionalConstructorVariables,
           a_additionalAliasIntVarFunctionCalls,
           a_createDebugCode,
           a_useFlatArrayNotation,
           a_indexForUndefinedReferencesInt,
           a_varToArrayIndexMapping,
           a_classname )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        (txt, _, _, a_classname, a_indexForUndefinedReferencesInt, a_additionalAliasIntVarFunctionCalls, a_additionalConstructorVariables, a_additionalFunctionDefinitions) = memberVariableInitializeWithSplit(txt, i_varPartition, Tpl.stringText(intString(x_i0)), Tpl.strTokText(Tpl.ST_STRING("initAliasIntVars")), a_classname, a_varToArrayIndexMapping, a_indexForUndefinedReferencesInt, a_useFlatArrayNotation, a_createDebugCode, "Int", a_additionalAliasIntVarFunctionCalls, a_additionalConstructorVariables, a_additionalFunctionDefinitions);
        txt = Tpl.nextIter(txt);
        (txt, a_additionalFunctionDefinitions, a_additionalConstructorVariables, a_additionalAliasIntVarFunctionCalls, a_indexForUndefinedReferencesInt, a_classname) = lm_879(txt, rest, a_additionalFunctionDefinitions, a_additionalConstructorVariables, a_additionalAliasIntVarFunctionCalls, a_createDebugCode, a_useFlatArrayNotation, a_indexForUndefinedReferencesInt, a_varToArrayIndexMapping, a_classname);
      then (txt, a_additionalFunctionDefinitions, a_additionalConstructorVariables, a_additionalAliasIntVarFunctionCalls, a_indexForUndefinedReferencesInt, a_classname);
  end match;
end lm_879;

protected function lm_880
  input Tpl.Text in_txt;
  input list<list<SimCodeVar.SimVar>> in_items;
  input Tpl.Text in_a_additionalFunctionDefinitions;
  input Tpl.Text in_a_additionalConstructorVariables;
  input Tpl.Text in_a_additionalAliasBoolVarFunctionCalls;
  input Boolean in_a_createDebugCode;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_indexForUndefinedReferencesBool;
  input HashTableCrIListArray.HashTable in_a_varToArrayIndexMapping;
  input Tpl.Text in_a_classname;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_additionalFunctionDefinitions;
  output Tpl.Text out_a_additionalConstructorVariables;
  output Tpl.Text out_a_additionalAliasBoolVarFunctionCalls;
  output Tpl.Text out_a_indexForUndefinedReferencesBool;
  output Tpl.Text out_a_classname;
algorithm
  (out_txt, out_a_additionalFunctionDefinitions, out_a_additionalConstructorVariables, out_a_additionalAliasBoolVarFunctionCalls, out_a_indexForUndefinedReferencesBool, out_a_classname) :=
  match(in_txt, in_items, in_a_additionalFunctionDefinitions, in_a_additionalConstructorVariables, in_a_additionalAliasBoolVarFunctionCalls, in_a_createDebugCode, in_a_useFlatArrayNotation, in_a_indexForUndefinedReferencesBool, in_a_varToArrayIndexMapping, in_a_classname)
    local
      Tpl.Text txt;
      list<list<SimCodeVar.SimVar>> rest;
      Tpl.Text a_additionalFunctionDefinitions;
      Tpl.Text a_additionalConstructorVariables;
      Tpl.Text a_additionalAliasBoolVarFunctionCalls;
      Boolean a_createDebugCode;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_indexForUndefinedReferencesBool;
      HashTableCrIListArray.HashTable a_varToArrayIndexMapping;
      Tpl.Text a_classname;
      Integer x_i0;
      list<SimCodeVar.SimVar> i_varPartition;

    case ( txt,
           {},
           a_additionalFunctionDefinitions,
           a_additionalConstructorVariables,
           a_additionalAliasBoolVarFunctionCalls,
           _,
           _,
           a_indexForUndefinedReferencesBool,
           _,
           a_classname )
      then (txt, a_additionalFunctionDefinitions, a_additionalConstructorVariables, a_additionalAliasBoolVarFunctionCalls, a_indexForUndefinedReferencesBool, a_classname);

    case ( txt,
           i_varPartition :: rest,
           a_additionalFunctionDefinitions,
           a_additionalConstructorVariables,
           a_additionalAliasBoolVarFunctionCalls,
           a_createDebugCode,
           a_useFlatArrayNotation,
           a_indexForUndefinedReferencesBool,
           a_varToArrayIndexMapping,
           a_classname )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        (txt, _, _, a_classname, a_indexForUndefinedReferencesBool, a_additionalAliasBoolVarFunctionCalls, a_additionalConstructorVariables, a_additionalFunctionDefinitions) = memberVariableInitializeWithSplit(txt, i_varPartition, Tpl.stringText(intString(x_i0)), Tpl.strTokText(Tpl.ST_STRING("initAliasBoolVars")), a_classname, a_varToArrayIndexMapping, a_indexForUndefinedReferencesBool, a_useFlatArrayNotation, a_createDebugCode, "Bool", a_additionalAliasBoolVarFunctionCalls, a_additionalConstructorVariables, a_additionalFunctionDefinitions);
        txt = Tpl.nextIter(txt);
        (txt, a_additionalFunctionDefinitions, a_additionalConstructorVariables, a_additionalAliasBoolVarFunctionCalls, a_indexForUndefinedReferencesBool, a_classname) = lm_880(txt, rest, a_additionalFunctionDefinitions, a_additionalConstructorVariables, a_additionalAliasBoolVarFunctionCalls, a_createDebugCode, a_useFlatArrayNotation, a_indexForUndefinedReferencesBool, a_varToArrayIndexMapping, a_classname);
      then (txt, a_additionalFunctionDefinitions, a_additionalConstructorVariables, a_additionalAliasBoolVarFunctionCalls, a_indexForUndefinedReferencesBool, a_classname);
  end match;
end lm_880;

protected function lm_881
  input Tpl.Text in_txt;
  input list<list<SimCodeVar.SimVar>> in_items;
  input Tpl.Text in_a_additionalFunctionDefinitions;
  input Tpl.Text in_a_additionalConstructorVariables;
  input Tpl.Text in_a_additionalAliasStringVarFunctionCalls;
  input Boolean in_a_createDebugCode;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_indexForUndefinedReferencesString;
  input HashTableCrIListArray.HashTable in_a_varToArrayIndexMapping;
  input Tpl.Text in_a_classname;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_additionalFunctionDefinitions;
  output Tpl.Text out_a_additionalConstructorVariables;
  output Tpl.Text out_a_additionalAliasStringVarFunctionCalls;
  output Tpl.Text out_a_indexForUndefinedReferencesString;
  output Tpl.Text out_a_classname;
algorithm
  (out_txt, out_a_additionalFunctionDefinitions, out_a_additionalConstructorVariables, out_a_additionalAliasStringVarFunctionCalls, out_a_indexForUndefinedReferencesString, out_a_classname) :=
  match(in_txt, in_items, in_a_additionalFunctionDefinitions, in_a_additionalConstructorVariables, in_a_additionalAliasStringVarFunctionCalls, in_a_createDebugCode, in_a_useFlatArrayNotation, in_a_indexForUndefinedReferencesString, in_a_varToArrayIndexMapping, in_a_classname)
    local
      Tpl.Text txt;
      list<list<SimCodeVar.SimVar>> rest;
      Tpl.Text a_additionalFunctionDefinitions;
      Tpl.Text a_additionalConstructorVariables;
      Tpl.Text a_additionalAliasStringVarFunctionCalls;
      Boolean a_createDebugCode;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_indexForUndefinedReferencesString;
      HashTableCrIListArray.HashTable a_varToArrayIndexMapping;
      Tpl.Text a_classname;
      Integer x_i0;
      list<SimCodeVar.SimVar> i_varPartition;

    case ( txt,
           {},
           a_additionalFunctionDefinitions,
           a_additionalConstructorVariables,
           a_additionalAliasStringVarFunctionCalls,
           _,
           _,
           a_indexForUndefinedReferencesString,
           _,
           a_classname )
      then (txt, a_additionalFunctionDefinitions, a_additionalConstructorVariables, a_additionalAliasStringVarFunctionCalls, a_indexForUndefinedReferencesString, a_classname);

    case ( txt,
           i_varPartition :: rest,
           a_additionalFunctionDefinitions,
           a_additionalConstructorVariables,
           a_additionalAliasStringVarFunctionCalls,
           a_createDebugCode,
           a_useFlatArrayNotation,
           a_indexForUndefinedReferencesString,
           a_varToArrayIndexMapping,
           a_classname )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        (txt, _, _, a_classname, a_indexForUndefinedReferencesString, a_additionalAliasStringVarFunctionCalls, a_additionalConstructorVariables, a_additionalFunctionDefinitions) = memberVariableInitializeWithSplit(txt, i_varPartition, Tpl.stringText(intString(x_i0)), Tpl.strTokText(Tpl.ST_STRING("initAliasStringVars")), a_classname, a_varToArrayIndexMapping, a_indexForUndefinedReferencesString, a_useFlatArrayNotation, a_createDebugCode, "String", a_additionalAliasStringVarFunctionCalls, a_additionalConstructorVariables, a_additionalFunctionDefinitions);
        txt = Tpl.nextIter(txt);
        (txt, a_additionalFunctionDefinitions, a_additionalConstructorVariables, a_additionalAliasStringVarFunctionCalls, a_indexForUndefinedReferencesString, a_classname) = lm_881(txt, rest, a_additionalFunctionDefinitions, a_additionalConstructorVariables, a_additionalAliasStringVarFunctionCalls, a_createDebugCode, a_useFlatArrayNotation, a_indexForUndefinedReferencesString, a_varToArrayIndexMapping, a_classname);
      then (txt, a_additionalFunctionDefinitions, a_additionalConstructorVariables, a_additionalAliasStringVarFunctionCalls, a_indexForUndefinedReferencesString, a_classname);
  end match;
end lm_881;

public function memberVariableInitialize
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;
  input HashTableCrIListArray.HashTable in_a_varToArrayIndexMapping;
  input Tpl.Text in_a_indexForUndefinedReferencesReal;
  input Tpl.Text in_a_indexForUndefinedReferencesInt;
  input Tpl.Text in_a_indexForUndefinedReferencesBool;
  input Tpl.Text in_a_indexForUndefinedReferencesString;
  input Boolean in_a_createDebugCode;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_additionalConstructorVariables;
  input Tpl.Text in_a_additionalFunctionDefinitions;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_indexForUndefinedReferencesReal;
  output Tpl.Text out_a_indexForUndefinedReferencesInt;
  output Tpl.Text out_a_indexForUndefinedReferencesBool;
  output Tpl.Text out_a_indexForUndefinedReferencesString;
  output Tpl.Text out_a_additionalConstructorVariables;
  output Tpl.Text out_a_additionalFunctionDefinitions;
algorithm
  (out_txt, out_a_indexForUndefinedReferencesReal, out_a_indexForUndefinedReferencesInt, out_a_indexForUndefinedReferencesBool, out_a_indexForUndefinedReferencesString, out_a_additionalConstructorVariables, out_a_additionalFunctionDefinitions) :=
  match(in_txt, in_a_modelInfo, in_a_varToArrayIndexMapping, in_a_indexForUndefinedReferencesReal, in_a_indexForUndefinedReferencesInt, in_a_indexForUndefinedReferencesBool, in_a_indexForUndefinedReferencesString, in_a_createDebugCode, in_a_useFlatArrayNotation, in_a_additionalConstructorVariables, in_a_additionalFunctionDefinitions)
    local
      Tpl.Text txt;
      HashTableCrIListArray.HashTable a_varToArrayIndexMapping;
      Tpl.Text a_indexForUndefinedReferencesReal;
      Tpl.Text a_indexForUndefinedReferencesInt;
      Tpl.Text a_indexForUndefinedReferencesBool;
      Tpl.Text a_indexForUndefinedReferencesString;
      Boolean a_createDebugCode;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_additionalConstructorVariables;
      Tpl.Text a_additionalFunctionDefinitions;
      list<SimCodeVar.SimVar> i_vars_stringAliasVars;
      list<SimCodeVar.SimVar> i_vars_boolAliasVars;
      list<SimCodeVar.SimVar> i_vars_intAliasVars;
      list<SimCodeVar.SimVar> i_vars_aliasVars;
      list<SimCodeVar.SimVar> i_vars_stringParamVars;
      list<SimCodeVar.SimVar> i_vars_boolParamVars;
      list<SimCodeVar.SimVar> i_vars_intParamVars;
      list<SimCodeVar.SimVar> i_vars_paramVars;
      list<SimCodeVar.SimVar> i_vars_stringAlgVars;
      list<SimCodeVar.SimVar> i_vars_boolAlgVars;
      list<SimCodeVar.SimVar> i_vars_intAlgVars;
      list<SimCodeVar.SimVar> i_vars_discreteAlgVars;
      list<SimCodeVar.SimVar> i_vars_algVars;
      list<SimCodeVar.SimVar> i_vars_derivativeVars;
      list<SimCodeVar.SimVar> i_vars_stateVars;
      Absyn.Path i_name;
      list<list<SimCodeVar.SimVar>> ret_31;
      list<list<SimCodeVar.SimVar>> ret_30;
      list<list<SimCodeVar.SimVar>> ret_29;
      list<list<SimCodeVar.SimVar>> ret_28;
      list<list<SimCodeVar.SimVar>> ret_27;
      list<list<SimCodeVar.SimVar>> ret_26;
      list<list<SimCodeVar.SimVar>> ret_25;
      list<list<SimCodeVar.SimVar>> ret_24;
      list<list<SimCodeVar.SimVar>> ret_23;
      list<list<SimCodeVar.SimVar>> ret_22;
      list<list<SimCodeVar.SimVar>> ret_21;
      list<list<SimCodeVar.SimVar>> ret_20;
      list<list<SimCodeVar.SimVar>> ret_19;
      list<list<SimCodeVar.SimVar>> ret_18;
      list<list<SimCodeVar.SimVar>> ret_17;
      Tpl.Text l_returnValue;
      Tpl.Text l_additionalAliasStringVarFunctionCalls;
      Tpl.Text l_additionalAliasBoolVarFunctionCalls;
      Tpl.Text l_additionalAliasIntVarFunctionCalls;
      Tpl.Text l_additionalAliasRealVarFunctionCalls;
      Tpl.Text l_additionalParameterStringVarFunctionCalls;
      Tpl.Text l_additionalParameterBoolVarFunctionCalls;
      Tpl.Text l_additionalParameterIntVarFunctionCalls;
      Tpl.Text l_additionalParameterRealVarFunctionCalls;
      Tpl.Text l_additionalStringAlgVarFunctionCalls;
      Tpl.Text l_additionalBoolAlgVarFunctionCalls;
      Tpl.Text l_additionalIntAlgVarFunctionCalls;
      Tpl.Text l_additionalDiscreteAlgVarFunctionCalls;
      Tpl.Text l_additionalAlgVarFunctionCalls;
      Tpl.Text l_additionalDerivativeVarFunctionCalls;
      Tpl.Text l_additionalStateVarFunctionCalls;
      Tpl.Text l_classname;

    case ( txt,
           SimCode.MODELINFO(vars = SimCodeVar.SIMVARS(stateVars = i_vars_stateVars, derivativeVars = i_vars_derivativeVars, algVars = i_vars_algVars, discreteAlgVars = i_vars_discreteAlgVars, intAlgVars = i_vars_intAlgVars, boolAlgVars = i_vars_boolAlgVars, stringAlgVars = i_vars_stringAlgVars, paramVars = i_vars_paramVars, intParamVars = i_vars_intParamVars, boolParamVars = i_vars_boolParamVars, stringParamVars = i_vars_stringParamVars, aliasVars = i_vars_aliasVars, intAliasVars = i_vars_intAliasVars, boolAliasVars = i_vars_boolAliasVars, stringAliasVars = i_vars_stringAliasVars), name = i_name),
           a_varToArrayIndexMapping,
           a_indexForUndefinedReferencesReal,
           a_indexForUndefinedReferencesInt,
           a_indexForUndefinedReferencesBool,
           a_indexForUndefinedReferencesString,
           a_createDebugCode,
           a_useFlatArrayNotation,
           a_additionalConstructorVariables,
           a_additionalFunctionDefinitions )
      equation
        l_classname = lastIdentOfPath(Tpl.emptyTxt, i_name);
        l_additionalStateVarFunctionCalls = Tpl.emptyTxt;
        l_additionalDerivativeVarFunctionCalls = Tpl.emptyTxt;
        l_additionalAlgVarFunctionCalls = Tpl.emptyTxt;
        l_additionalDiscreteAlgVarFunctionCalls = Tpl.emptyTxt;
        l_additionalIntAlgVarFunctionCalls = Tpl.emptyTxt;
        l_additionalBoolAlgVarFunctionCalls = Tpl.emptyTxt;
        l_additionalStringAlgVarFunctionCalls = Tpl.emptyTxt;
        l_additionalParameterRealVarFunctionCalls = Tpl.emptyTxt;
        l_additionalParameterIntVarFunctionCalls = Tpl.emptyTxt;
        l_additionalParameterBoolVarFunctionCalls = Tpl.emptyTxt;
        l_additionalParameterStringVarFunctionCalls = Tpl.emptyTxt;
        l_additionalAliasRealVarFunctionCalls = Tpl.emptyTxt;
        l_additionalAliasIntVarFunctionCalls = Tpl.emptyTxt;
        l_additionalAliasBoolVarFunctionCalls = Tpl.emptyTxt;
        l_additionalAliasStringVarFunctionCalls = Tpl.emptyTxt;
        l_returnValue = Tpl.emptyTxt;
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("//StateVars\n"));
        ret_17 = List.partition(i_vars_stateVars, 100);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_additionalFunctionDefinitions, a_additionalConstructorVariables, l_additionalStateVarFunctionCalls, a_indexForUndefinedReferencesReal, l_classname) = lm_867(txt, ret_17, a_additionalFunctionDefinitions, a_additionalConstructorVariables, l_additionalStateVarFunctionCalls, a_createDebugCode, a_useFlatArrayNotation, a_indexForUndefinedReferencesReal, a_varToArrayIndexMapping, l_classname);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "void "
                                }, false));
        txt = Tpl.writeText(txt, l_classname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::initStateVars()\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_additionalStateVarFunctionCalls);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n",
                                    "//DerivativeVars\n"
                                }, true));
        ret_18 = List.partition(i_vars_derivativeVars, 100);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_additionalFunctionDefinitions, a_additionalConstructorVariables, l_additionalDerivativeVarFunctionCalls, a_indexForUndefinedReferencesReal, l_classname) = lm_868(txt, ret_18, a_additionalFunctionDefinitions, a_additionalConstructorVariables, l_additionalDerivativeVarFunctionCalls, a_createDebugCode, a_useFlatArrayNotation, a_indexForUndefinedReferencesReal, a_varToArrayIndexMapping, l_classname);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "void "
                                }, false));
        txt = Tpl.writeText(txt, l_classname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::initDerivativeVars()\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_additionalDerivativeVarFunctionCalls);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n",
                                    "//AlgVars\n"
                                }, true));
        ret_19 = List.partition(i_vars_algVars, 100);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_additionalFunctionDefinitions, a_additionalConstructorVariables, l_additionalAlgVarFunctionCalls, a_indexForUndefinedReferencesReal, l_classname) = lm_869(txt, ret_19, a_additionalFunctionDefinitions, a_additionalConstructorVariables, l_additionalAlgVarFunctionCalls, a_createDebugCode, a_useFlatArrayNotation, a_indexForUndefinedReferencesReal, a_varToArrayIndexMapping, l_classname);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "void "
                                }, false));
        txt = Tpl.writeText(txt, l_classname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::initAlgVars()\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_additionalAlgVarFunctionCalls);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n",
                                    "//DiscreteAlgVars\n"
                                }, true));
        ret_20 = List.partition(i_vars_discreteAlgVars, 100);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_additionalFunctionDefinitions, a_additionalConstructorVariables, l_additionalDiscreteAlgVarFunctionCalls, a_indexForUndefinedReferencesReal, l_classname) = lm_870(txt, ret_20, a_additionalFunctionDefinitions, a_additionalConstructorVariables, l_additionalDiscreteAlgVarFunctionCalls, a_createDebugCode, a_useFlatArrayNotation, a_indexForUndefinedReferencesReal, a_varToArrayIndexMapping, l_classname);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "void "
                                }, false));
        txt = Tpl.writeText(txt, l_classname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::initDiscreteAlgVars()\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_additionalDiscreteAlgVarFunctionCalls);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n",
                                    "//IntAlgVars\n"
                                }, true));
        ret_21 = List.partition(i_vars_intAlgVars, 100);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_additionalFunctionDefinitions, a_additionalConstructorVariables, l_additionalIntAlgVarFunctionCalls, a_indexForUndefinedReferencesInt, l_classname) = lm_871(txt, ret_21, a_additionalFunctionDefinitions, a_additionalConstructorVariables, l_additionalIntAlgVarFunctionCalls, a_createDebugCode, a_useFlatArrayNotation, a_indexForUndefinedReferencesInt, a_varToArrayIndexMapping, l_classname);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = Tpl.writeText(txt, l_classname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::initIntAlgVars()\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_additionalIntAlgVarFunctionCalls);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n",
                                    "//BoolAlgVars\n"
                                }, true));
        ret_22 = List.partition(i_vars_boolAlgVars, 100);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_additionalFunctionDefinitions, a_additionalConstructorVariables, l_additionalBoolAlgVarFunctionCalls, a_indexForUndefinedReferencesBool, l_classname) = lm_872(txt, ret_22, a_additionalFunctionDefinitions, a_additionalConstructorVariables, l_additionalBoolAlgVarFunctionCalls, a_createDebugCode, a_useFlatArrayNotation, a_indexForUndefinedReferencesBool, a_varToArrayIndexMapping, l_classname);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = Tpl.writeText(txt, l_classname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::initBoolAlgVars()\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_additionalBoolAlgVarFunctionCalls);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n",
                                    "//StringAlgVars\n"
                                }, true));
        ret_23 = List.partition(i_vars_stringAlgVars, 100);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_additionalFunctionDefinitions, a_additionalConstructorVariables, l_additionalStringAlgVarFunctionCalls, a_indexForUndefinedReferencesString, l_classname) = lm_873(txt, ret_23, a_additionalFunctionDefinitions, a_additionalConstructorVariables, l_additionalStringAlgVarFunctionCalls, a_createDebugCode, a_useFlatArrayNotation, a_indexForUndefinedReferencesString, a_varToArrayIndexMapping, l_classname);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = Tpl.writeText(txt, l_classname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::initStringAlgVars()\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_additionalStringAlgVarFunctionCalls);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n",
                                    "//ParameterRealVars\n"
                                }, true));
        ret_24 = List.partition(i_vars_paramVars, 100);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_additionalFunctionDefinitions, a_additionalConstructorVariables, l_additionalParameterRealVarFunctionCalls, a_indexForUndefinedReferencesReal, l_classname) = lm_874(txt, ret_24, a_additionalFunctionDefinitions, a_additionalConstructorVariables, l_additionalParameterRealVarFunctionCalls, a_createDebugCode, a_useFlatArrayNotation, a_indexForUndefinedReferencesReal, a_varToArrayIndexMapping, l_classname);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = Tpl.writeText(txt, l_classname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::initParameterRealVars()\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_additionalParameterRealVarFunctionCalls);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n",
                                    "//ParameterIntVars\n"
                                }, true));
        ret_25 = List.partition(i_vars_intParamVars, 100);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_additionalFunctionDefinitions, a_additionalConstructorVariables, l_additionalParameterIntVarFunctionCalls, a_indexForUndefinedReferencesInt, l_classname) = lm_875(txt, ret_25, a_additionalFunctionDefinitions, a_additionalConstructorVariables, l_additionalParameterIntVarFunctionCalls, a_createDebugCode, a_useFlatArrayNotation, a_indexForUndefinedReferencesInt, a_varToArrayIndexMapping, l_classname);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = Tpl.writeText(txt, l_classname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::initParameterIntVars()\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_additionalParameterIntVarFunctionCalls);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n",
                                    "//ParameterBoolVars\n"
                                }, true));
        ret_26 = List.partition(i_vars_boolParamVars, 100);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_additionalFunctionDefinitions, a_additionalConstructorVariables, l_additionalParameterBoolVarFunctionCalls, a_indexForUndefinedReferencesBool, l_classname) = lm_876(txt, ret_26, a_additionalFunctionDefinitions, a_additionalConstructorVariables, l_additionalParameterBoolVarFunctionCalls, a_createDebugCode, a_useFlatArrayNotation, a_indexForUndefinedReferencesBool, a_varToArrayIndexMapping, l_classname);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = Tpl.writeText(txt, l_classname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::initParameterBoolVars()\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_additionalParameterBoolVarFunctionCalls);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n",
                                    "//ParameterStringVars\n"
                                }, true));
        ret_27 = List.partition(i_vars_stringParamVars, 100);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_additionalFunctionDefinitions, a_additionalConstructorVariables, l_additionalParameterStringVarFunctionCalls, a_indexForUndefinedReferencesString, l_classname) = lm_877(txt, ret_27, a_additionalFunctionDefinitions, a_additionalConstructorVariables, l_additionalParameterStringVarFunctionCalls, a_createDebugCode, a_useFlatArrayNotation, a_indexForUndefinedReferencesString, a_varToArrayIndexMapping, l_classname);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = Tpl.writeText(txt, l_classname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::initParameterStringVars()\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_additionalParameterStringVarFunctionCalls);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n",
                                    "//AliasRealVars\n"
                                }, true));
        ret_28 = List.partition(i_vars_aliasVars, 100);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_additionalFunctionDefinitions, a_additionalConstructorVariables, l_additionalAliasRealVarFunctionCalls, a_indexForUndefinedReferencesReal, l_classname) = lm_878(txt, ret_28, a_additionalFunctionDefinitions, a_additionalConstructorVariables, l_additionalAliasRealVarFunctionCalls, a_createDebugCode, a_useFlatArrayNotation, a_indexForUndefinedReferencesReal, a_varToArrayIndexMapping, l_classname);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = Tpl.writeText(txt, l_classname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::initAliasRealVars()\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_additionalAliasRealVarFunctionCalls);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n",
                                    "//AliasIntVars\n"
                                }, true));
        ret_29 = List.partition(i_vars_intAliasVars, 100);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_additionalFunctionDefinitions, a_additionalConstructorVariables, l_additionalAliasIntVarFunctionCalls, a_indexForUndefinedReferencesInt, l_classname) = lm_879(txt, ret_29, a_additionalFunctionDefinitions, a_additionalConstructorVariables, l_additionalAliasIntVarFunctionCalls, a_createDebugCode, a_useFlatArrayNotation, a_indexForUndefinedReferencesInt, a_varToArrayIndexMapping, l_classname);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = Tpl.writeText(txt, l_classname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::initAliasIntVars()\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_additionalAliasIntVarFunctionCalls);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n",
                                    "//AliasBoolVars\n"
                                }, true));
        ret_30 = List.partition(i_vars_boolAliasVars, 100);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_additionalFunctionDefinitions, a_additionalConstructorVariables, l_additionalAliasBoolVarFunctionCalls, a_indexForUndefinedReferencesBool, l_classname) = lm_880(txt, ret_30, a_additionalFunctionDefinitions, a_additionalConstructorVariables, l_additionalAliasBoolVarFunctionCalls, a_createDebugCode, a_useFlatArrayNotation, a_indexForUndefinedReferencesBool, a_varToArrayIndexMapping, l_classname);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = Tpl.writeText(txt, l_classname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::initAliasBoolVars()\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_additionalAliasBoolVarFunctionCalls);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n",
                                    "//AliasStringVars\n"
                                }, true));
        ret_31 = List.partition(i_vars_stringAliasVars, 100);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_additionalFunctionDefinitions, a_additionalConstructorVariables, l_additionalAliasStringVarFunctionCalls, a_indexForUndefinedReferencesString, l_classname) = lm_881(txt, ret_31, a_additionalFunctionDefinitions, a_additionalConstructorVariables, l_additionalAliasStringVarFunctionCalls, a_createDebugCode, a_useFlatArrayNotation, a_indexForUndefinedReferencesString, a_varToArrayIndexMapping, l_classname);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = Tpl.writeText(txt, l_classname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::initAliasStringVars()\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_additionalAliasStringVarFunctionCalls);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then (txt, a_indexForUndefinedReferencesReal, a_indexForUndefinedReferencesInt, a_indexForUndefinedReferencesBool, a_indexForUndefinedReferencesString, a_additionalConstructorVariables, a_additionalFunctionDefinitions);

    case ( txt,
           _,
           _,
           a_indexForUndefinedReferencesReal,
           a_indexForUndefinedReferencesInt,
           a_indexForUndefinedReferencesBool,
           a_indexForUndefinedReferencesString,
           _,
           _,
           a_additionalConstructorVariables,
           a_additionalFunctionDefinitions )
      then (txt, a_indexForUndefinedReferencesReal, a_indexForUndefinedReferencesInt, a_indexForUndefinedReferencesBool, a_indexForUndefinedReferencesString, a_additionalConstructorVariables, a_additionalFunctionDefinitions);
  end match;
end memberVariableInitialize;

protected function lm_883
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Tpl.Text in_a_additionalConstructorVariables;
  input String in_a_type;
  input Boolean in_a_createDebugCode;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_indexForUndefinedReferences;
  input HashTableCrIListArray.HashTable in_a_varToArrayIndexMapping;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_additionalConstructorVariables;
  output Tpl.Text out_a_indexForUndefinedReferences;
algorithm
  (out_txt, out_a_additionalConstructorVariables, out_a_indexForUndefinedReferences) :=
  match(in_txt, in_items, in_a_additionalConstructorVariables, in_a_type, in_a_createDebugCode, in_a_useFlatArrayNotation, in_a_indexForUndefinedReferences, in_a_varToArrayIndexMapping)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Tpl.Text a_additionalConstructorVariables;
      String a_type;
      Boolean a_createDebugCode;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_indexForUndefinedReferences;
      HashTableCrIListArray.HashTable a_varToArrayIndexMapping;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           a_additionalConstructorVariables,
           _,
           _,
           _,
           a_indexForUndefinedReferences,
           _ )
      then (txt, a_additionalConstructorVariables, a_indexForUndefinedReferences);

    case ( txt,
           i_var :: rest,
           a_additionalConstructorVariables,
           a_type,
           a_createDebugCode,
           a_useFlatArrayNotation,
           a_indexForUndefinedReferences,
           a_varToArrayIndexMapping )
      equation
        (txt, a_indexForUndefinedReferences, a_additionalConstructorVariables) = memberVariableInitialize2(txt, i_var, a_varToArrayIndexMapping, a_indexForUndefinedReferences, a_useFlatArrayNotation, a_createDebugCode, a_type, a_additionalConstructorVariables);
        txt = Tpl.nextIter(txt);
        (txt, a_additionalConstructorVariables, a_indexForUndefinedReferences) = lm_883(txt, rest, a_additionalConstructorVariables, a_type, a_createDebugCode, a_useFlatArrayNotation, a_indexForUndefinedReferences, a_varToArrayIndexMapping);
      then (txt, a_additionalConstructorVariables, a_indexForUndefinedReferences);
  end match;
end lm_883;

public function memberVariableInitializeWithSplit
  input Tpl.Text txt;
  input list<SimCodeVar.SimVar> a_simVars;
  input Tpl.Text a_idx;
  input Tpl.Text a_functionPrefix;
  input Tpl.Text a_className;
  input HashTableCrIListArray.HashTable a_varToArrayIndexMapping;
  input Tpl.Text a_indexForUndefinedReferences;
  input Boolean a_useFlatArrayNotation;
  input Boolean a_createDebugCode;
  input String a_type;
  input Tpl.Text a_additionalFunctionCalls;
  input Tpl.Text a_additionalConstructorVariables;
  input Tpl.Text a_additionalFunctionDefinitions;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_idx;
  output Tpl.Text out_a_functionPrefix;
  output Tpl.Text out_a_className;
  output Tpl.Text out_a_indexForUndefinedReferences;
  output Tpl.Text out_a_additionalFunctionCalls;
  output Tpl.Text out_a_additionalConstructorVariables;
  output Tpl.Text out_a_additionalFunctionDefinitions;
algorithm
  out_a_additionalFunctionCalls := Tpl.pushBlock(a_additionalFunctionCalls, Tpl.BT_INDENT(2));
  out_a_additionalFunctionCalls := Tpl.writeText(out_a_additionalFunctionCalls, a_functionPrefix);
  out_a_additionalFunctionCalls := Tpl.writeTok(out_a_additionalFunctionCalls, Tpl.ST_STRING("_"));
  out_a_additionalFunctionCalls := Tpl.writeText(out_a_additionalFunctionCalls, a_idx);
  out_a_additionalFunctionCalls := Tpl.writeTok(out_a_additionalFunctionCalls, Tpl.ST_STRING("();"));
  out_a_additionalFunctionCalls := Tpl.writeTok(out_a_additionalFunctionCalls, Tpl.ST_NEW_LINE());
  out_a_additionalFunctionCalls := Tpl.popBlock(out_a_additionalFunctionCalls);
  out_a_additionalFunctionDefinitions := Tpl.writeTok(a_additionalFunctionDefinitions, Tpl.ST_STRING("void "));
  out_a_additionalFunctionDefinitions := Tpl.writeText(out_a_additionalFunctionDefinitions, a_functionPrefix);
  out_a_additionalFunctionDefinitions := Tpl.writeTok(out_a_additionalFunctionDefinitions, Tpl.ST_STRING("_"));
  out_a_additionalFunctionDefinitions := Tpl.writeText(out_a_additionalFunctionDefinitions, a_idx);
  out_a_additionalFunctionDefinitions := Tpl.writeTok(out_a_additionalFunctionDefinitions, Tpl.ST_STRING("();"));
  out_a_additionalFunctionDefinitions := Tpl.writeTok(out_a_additionalFunctionDefinitions, Tpl.ST_NEW_LINE());
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING("void "));
  out_txt := Tpl.writeText(out_txt, a_className);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("::"));
  out_txt := Tpl.writeText(out_txt, a_functionPrefix);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("_"));
  out_txt := Tpl.writeText(out_txt, a_idx);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "()\n",
                                       "{\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.pushIter(out_txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (out_txt, out_a_additionalConstructorVariables, out_a_indexForUndefinedReferences) := lm_883(out_txt, a_simVars, a_additionalConstructorVariables, a_type, a_createDebugCode, a_useFlatArrayNotation, a_indexForUndefinedReferences, a_varToArrayIndexMapping);
  out_txt := Tpl.popIter(out_txt);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("}"));
  out_a_idx := a_idx;
  out_a_functionPrefix := a_functionPrefix;
  out_a_className := a_className;
end memberVariableInitializeWithSplit;

protected function fun_885
  input Tpl.Text in_txt;
  input Boolean in_a_createDebugCode;
  input String in_a_type;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_additionalConstructorVariables;
  input Tpl.Text in_a_indexForUndefinedReferences;
  input DAE.ComponentRef in_a_name;
  input HashTableCrIListArray.HashTable in_a_varToArrayIndexMapping;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_additionalConstructorVariables;
algorithm
  (out_txt, out_a_additionalConstructorVariables) :=
  match(in_txt, in_a_createDebugCode, in_a_type, in_a_useFlatArrayNotation, in_a_additionalConstructorVariables, in_a_indexForUndefinedReferences, in_a_name, in_a_varToArrayIndexMapping)
    local
      Tpl.Text txt;
      String a_type;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_additionalConstructorVariables;
      Tpl.Text a_indexForUndefinedReferences;
      DAE.ComponentRef a_name;
      HashTableCrIListArray.HashTable a_varToArrayIndexMapping;
      String ret_2;
      list<String> ret_1;
      Tpl.Text l_index;

    case ( txt,
           true,
           a_type,
           a_useFlatArrayNotation,
           a_additionalConstructorVariables,
           a_indexForUndefinedReferences,
           a_name,
           a_varToArrayIndexMapping )
      equation
        ret_1 = SimCodeUtil.getVarIndexListByMapping(a_varToArrayIndexMapping, a_name, true, Tpl.textString(a_indexForUndefinedReferences));
        ret_2 = listHead(ret_1);
        l_index = Tpl.writeStr(Tpl.emptyTxt, ret_2);
        a_additionalConstructorVariables = Tpl.writeTok(a_additionalConstructorVariables, Tpl.ST_STRING(","));
        a_additionalConstructorVariables = CodegenCppCommonOld.cref(a_additionalConstructorVariables, a_name, a_useFlatArrayNotation);
        a_additionalConstructorVariables = Tpl.writeTok(a_additionalConstructorVariables, Tpl.ST_STRING("(getSimVars()->init"));
        a_additionalConstructorVariables = Tpl.writeStr(a_additionalConstructorVariables, a_type);
        a_additionalConstructorVariables = Tpl.writeTok(a_additionalConstructorVariables, Tpl.ST_STRING("Var("));
        a_additionalConstructorVariables = Tpl.writeText(a_additionalConstructorVariables, l_index);
        a_additionalConstructorVariables = Tpl.writeTok(a_additionalConstructorVariables, Tpl.ST_STRING("))"));
        a_additionalConstructorVariables = Tpl.writeTok(a_additionalConstructorVariables, Tpl.ST_NEW_LINE());
      then (txt, a_additionalConstructorVariables);

    case ( txt,
           _,
           _,
           _,
           a_additionalConstructorVariables,
           _,
           _,
           _ )
      then (txt, a_additionalConstructorVariables);
  end match;
end fun_885;

protected function fun_886
  input Tpl.Text in_txt;
  input Boolean in_a_createDebugCode;
  input String in_a_type;
  input Tpl.Text in_a_arrayName;
  input Tpl.Text in_a_additionalConstructorVariables;
  input Tpl.Text in_a_indexForUndefinedReferences;
  input DAE.ComponentRef in_a_name;
  input HashTableCrIListArray.HashTable in_a_varToArrayIndexMapping;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_additionalConstructorVariables;
algorithm
  (out_txt, out_a_additionalConstructorVariables) :=
  match(in_txt, in_a_createDebugCode, in_a_type, in_a_arrayName, in_a_additionalConstructorVariables, in_a_indexForUndefinedReferences, in_a_name, in_a_varToArrayIndexMapping)
    local
      Tpl.Text txt;
      String a_type;
      Tpl.Text a_arrayName;
      Tpl.Text a_additionalConstructorVariables;
      Tpl.Text a_indexForUndefinedReferences;
      DAE.ComponentRef a_name;
      HashTableCrIListArray.HashTable a_varToArrayIndexMapping;
      String ret_2;
      list<String> ret_1;
      Tpl.Text l_index;

    case ( txt,
           true,
           a_type,
           a_arrayName,
           a_additionalConstructorVariables,
           a_indexForUndefinedReferences,
           a_name,
           a_varToArrayIndexMapping )
      equation
        ret_1 = SimCodeUtil.getVarIndexListByMapping(a_varToArrayIndexMapping, a_name, true, Tpl.textString(a_indexForUndefinedReferences));
        ret_2 = listHead(ret_1);
        l_index = Tpl.writeStr(Tpl.emptyTxt, ret_2);
        a_additionalConstructorVariables = Tpl.writeTok(a_additionalConstructorVariables, Tpl.ST_STRING(","));
        a_additionalConstructorVariables = Tpl.writeText(a_additionalConstructorVariables, a_arrayName);
        a_additionalConstructorVariables = Tpl.writeTok(a_additionalConstructorVariables, Tpl.ST_STRING("(getSimVars()->init"));
        a_additionalConstructorVariables = Tpl.writeStr(a_additionalConstructorVariables, a_type);
        a_additionalConstructorVariables = Tpl.writeTok(a_additionalConstructorVariables, Tpl.ST_STRING("Var("));
        a_additionalConstructorVariables = Tpl.writeText(a_additionalConstructorVariables, l_index);
        a_additionalConstructorVariables = Tpl.writeTok(a_additionalConstructorVariables, Tpl.ST_STRING("))"));
      then (txt, a_additionalConstructorVariables);

    case ( txt,
           _,
           _,
           _,
           a_additionalConstructorVariables,
           _,
           _,
           _ )
      then (txt, a_additionalConstructorVariables);
  end match;
end fun_886;

protected function lm_887
  input Tpl.Text in_txt;
  input list<String> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<String> rest;
      String i_idx;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_idx :: rest )
      equation
        txt = Tpl.writeStr(txt, i_idx);
        txt = Tpl.nextIter(txt);
        txt = lm_887(txt, rest);
      then txt;
  end match;
end lm_887;

protected function fun_888
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input list<String> in_a_v_numArrayElement;
  input Tpl.Text in_a_dims;
  input String in_a_type;
  input Tpl.Text in_a_size;
  input Tpl.Text in_a_arrayName;
  input Tpl.Text in_a_typeString;
  input Tpl.Text in_a_indexForUndefinedReferences;
  input DAE.ComponentRef in_a_name;
  input HashTableCrIListArray.HashTable in_a_varToArrayIndexMapping;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_v_numArrayElement, in_a_dims, in_a_type, in_a_size, in_a_arrayName, in_a_typeString, in_a_indexForUndefinedReferences, in_a_name, in_a_varToArrayIndexMapping)
    local
      Tpl.Text txt;
      list<String> a_v_numArrayElement;
      Tpl.Text a_dims;
      String a_type;
      Tpl.Text a_size;
      Tpl.Text a_arrayName;
      Tpl.Text a_typeString;
      Tpl.Text a_indexForUndefinedReferences;
      DAE.ComponentRef a_name;
      HashTableCrIListArray.HashTable a_varToArrayIndexMapping;
      String ret_4;
      list<String> ret_3;
      Tpl.Text l_arrayHeadIdx;
      list<String> ret_1;
      Tpl.Text l_arrayIndices;

    case ( txt,
           false,
           a_v_numArrayElement,
           a_dims,
           a_type,
           a_size,
           a_arrayName,
           a_typeString,
           a_indexForUndefinedReferences,
           a_name,
           a_varToArrayIndexMapping )
      equation
        ret_1 = SimCodeUtil.getVarIndexListByMapping(a_varToArrayIndexMapping, a_name, true, Tpl.textString(a_indexForUndefinedReferences));
        l_arrayIndices = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(" LIST_SEP ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_arrayIndices = lm_887(l_arrayIndices, ret_1);
        l_arrayIndices = Tpl.popIter(l_arrayIndices);
        txt = Tpl.writeText(txt, a_typeString);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("* "));
        txt = Tpl.writeText(txt, a_arrayName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_ref_data["));
        txt = Tpl.writeText(txt, a_size);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "];\n",
                                    "getSimVars()->init"
                                }, false));
        txt = Tpl.writeStr(txt, a_type);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("AliasArray(LIST_OF "));
        txt = Tpl.writeText(txt, l_arrayIndices);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" LIST_END, "));
        txt = Tpl.writeText(txt, a_arrayName);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_ref_data);\n"));
        txt = Tpl.writeText(txt, a_arrayName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = RefArrayDim"));
        txt = Tpl.writeText(txt, a_dims);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<"));
        txt = Tpl.writeText(txt, a_typeString);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = arrayextentDims(txt, a_name, a_v_numArrayElement);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(">("));
        txt = Tpl.writeText(txt, a_arrayName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_ref_data);"));
      then txt;

    case ( txt,
           _,
           _,
           _,
           a_type,
           _,
           a_arrayName,
           _,
           a_indexForUndefinedReferences,
           a_name,
           a_varToArrayIndexMapping )
      equation
        ret_3 = SimCodeUtil.getVarIndexListByMapping(a_varToArrayIndexMapping, a_name, true, Tpl.textString(a_indexForUndefinedReferences));
        ret_4 = listHead(ret_3);
        l_arrayHeadIdx = Tpl.writeStr(Tpl.emptyTxt, ret_4);
        txt = Tpl.writeText(txt, a_arrayName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".init(&_pointerTo"));
        txt = Tpl.writeStr(txt, a_type);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Vars["));
        txt = Tpl.writeText(txt, l_arrayHeadIdx);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("]);"));
      then txt;
  end match;
end fun_888;

protected function fun_889
  input Tpl.Text in_txt;
  input String in_mArg;
  input list<String> in_a_v_numArrayElement;
  input Tpl.Text in_a_dims;
  input Tpl.Text in_a_typeString;
  input Tpl.Text in_a_array__num__elem;
  input String in_a_type;
  input Tpl.Text in_a_arrayName;
  input Tpl.Text in_a_additionalConstructorVariables;
  input Tpl.Text in_a_indexForUndefinedReferences;
  input DAE.ComponentRef in_a_name;
  input HashTableCrIListArray.HashTable in_a_varToArrayIndexMapping;
  input Boolean in_a_createDebugCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_additionalConstructorVariables;
algorithm
  (out_txt, out_a_additionalConstructorVariables) :=
  match(in_txt, in_mArg, in_a_v_numArrayElement, in_a_dims, in_a_typeString, in_a_array__num__elem, in_a_type, in_a_arrayName, in_a_additionalConstructorVariables, in_a_indexForUndefinedReferences, in_a_name, in_a_varToArrayIndexMapping, in_a_createDebugCode)
    local
      Tpl.Text txt;
      list<String> a_v_numArrayElement;
      Tpl.Text a_dims;
      Tpl.Text a_typeString;
      Tpl.Text a_array__num__elem;
      String a_type;
      Tpl.Text a_arrayName;
      Tpl.Text a_additionalConstructorVariables;
      Tpl.Text a_indexForUndefinedReferences;
      DAE.ComponentRef a_name;
      HashTableCrIListArray.HashTable a_varToArrayIndexMapping;
      Boolean a_createDebugCode;
      Boolean ret_2;
      Integer ret_1;
      Tpl.Text l_size;

    case ( txt,
           "0",
           _,
           _,
           _,
           _,
           a_type,
           a_arrayName,
           a_additionalConstructorVariables,
           a_indexForUndefinedReferences,
           a_name,
           a_varToArrayIndexMapping,
           a_createDebugCode )
      equation
        (txt, a_additionalConstructorVariables) = fun_886(txt, a_createDebugCode, a_type, a_arrayName, a_additionalConstructorVariables, a_indexForUndefinedReferences, a_name, a_varToArrayIndexMapping);
      then (txt, a_additionalConstructorVariables);

    case ( txt,
           _,
           a_v_numArrayElement,
           a_dims,
           a_typeString,
           a_array__num__elem,
           a_type,
           a_arrayName,
           a_additionalConstructorVariables,
           a_indexForUndefinedReferences,
           a_name,
           a_varToArrayIndexMapping,
           _ )
      equation
        ret_1 = Util.mulStringDelimit2Int(Tpl.textString(a_array__num__elem), ",");
        l_size = Tpl.writeStr(Tpl.emptyTxt, intString(ret_1));
        ret_2 = SimCodeUtil.isVarIndexListConsecutive(a_varToArrayIndexMapping, a_name);
        txt = fun_888(txt, ret_2, a_v_numArrayElement, a_dims, a_type, l_size, a_arrayName, a_typeString, a_indexForUndefinedReferences, a_name, a_varToArrayIndexMapping);
      then (txt, a_additionalConstructorVariables);
  end match;
end fun_889;

protected function fun_890
  input Tpl.Text in_txt;
  input Boolean in_a_useFlatArrayNotation;
  input list<String> in_a_v_numArrayElement;
  input Tpl.Text in_a_typeString;
  input Tpl.Text in_a_array__num__elem;
  input String in_a_type;
  input Tpl.Text in_a_arrayName;
  input Tpl.Text in_a_additionalConstructorVariables;
  input Tpl.Text in_a_indexForUndefinedReferences;
  input DAE.ComponentRef in_a_name;
  input HashTableCrIListArray.HashTable in_a_varToArrayIndexMapping;
  input Boolean in_a_createDebugCode;
  input Tpl.Text in_a_dims;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_additionalConstructorVariables;
algorithm
  (out_txt, out_a_additionalConstructorVariables) :=
  match(in_txt, in_a_useFlatArrayNotation, in_a_v_numArrayElement, in_a_typeString, in_a_array__num__elem, in_a_type, in_a_arrayName, in_a_additionalConstructorVariables, in_a_indexForUndefinedReferences, in_a_name, in_a_varToArrayIndexMapping, in_a_createDebugCode, in_a_dims)
    local
      Tpl.Text txt;
      list<String> a_v_numArrayElement;
      Tpl.Text a_typeString;
      Tpl.Text a_array__num__elem;
      String a_type;
      Tpl.Text a_arrayName;
      Tpl.Text a_additionalConstructorVariables;
      Tpl.Text a_indexForUndefinedReferences;
      DAE.ComponentRef a_name;
      HashTableCrIListArray.HashTable a_varToArrayIndexMapping;
      Boolean a_createDebugCode;
      Tpl.Text a_dims;
      String str_0;

    case ( txt,
           false,
           a_v_numArrayElement,
           a_typeString,
           a_array__num__elem,
           a_type,
           a_arrayName,
           a_additionalConstructorVariables,
           a_indexForUndefinedReferences,
           a_name,
           a_varToArrayIndexMapping,
           a_createDebugCode,
           a_dims )
      equation
        str_0 = Tpl.textString(a_dims);
        (txt, a_additionalConstructorVariables) = fun_889(txt, str_0, a_v_numArrayElement, a_dims, a_typeString, a_array__num__elem, a_type, a_arrayName, a_additionalConstructorVariables, a_indexForUndefinedReferences, a_name, a_varToArrayIndexMapping, a_createDebugCode);
      then (txt, a_additionalConstructorVariables);

    case ( txt,
           _,
           _,
           _,
           _,
           _,
           _,
           a_additionalConstructorVariables,
           _,
           _,
           _,
           _,
           _ )
      equation
        a_additionalConstructorVariables = Tpl.writeTok(a_additionalConstructorVariables, Tpl.ST_STRING("\"not implemented\""));
        a_additionalConstructorVariables = Tpl.writeTok(a_additionalConstructorVariables, Tpl.ST_NEW_LINE());
      then (txt, a_additionalConstructorVariables);
  end match;
end fun_890;

protected function fun_891
  input Tpl.Text in_txt;
  input Boolean in_a_createDebugCode;
  input String in_a_type;
  input Tpl.Text in_a_arrayName;
  input Tpl.Text in_a_additionalConstructorVariables;
  input Tpl.Text in_a_indexForUndefinedReferences;
  input DAE.ComponentRef in_a_name;
  input HashTableCrIListArray.HashTable in_a_varToArrayIndexMapping;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_additionalConstructorVariables;
algorithm
  (out_txt, out_a_additionalConstructorVariables) :=
  match(in_txt, in_a_createDebugCode, in_a_type, in_a_arrayName, in_a_additionalConstructorVariables, in_a_indexForUndefinedReferences, in_a_name, in_a_varToArrayIndexMapping)
    local
      Tpl.Text txt;
      String a_type;
      Tpl.Text a_arrayName;
      Tpl.Text a_additionalConstructorVariables;
      Tpl.Text a_indexForUndefinedReferences;
      DAE.ComponentRef a_name;
      HashTableCrIListArray.HashTable a_varToArrayIndexMapping;
      String ret_2;
      list<String> ret_1;
      Tpl.Text l_index;

    case ( txt,
           true,
           a_type,
           a_arrayName,
           a_additionalConstructorVariables,
           a_indexForUndefinedReferences,
           a_name,
           a_varToArrayIndexMapping )
      equation
        ret_1 = SimCodeUtil.getVarIndexListByMapping(a_varToArrayIndexMapping, a_name, true, Tpl.textString(a_indexForUndefinedReferences));
        ret_2 = listHead(ret_1);
        l_index = Tpl.writeStr(Tpl.emptyTxt, ret_2);
        a_additionalConstructorVariables = Tpl.writeTok(a_additionalConstructorVariables, Tpl.ST_STRING(","));
        a_additionalConstructorVariables = Tpl.writeText(a_additionalConstructorVariables, a_arrayName);
        a_additionalConstructorVariables = Tpl.writeTok(a_additionalConstructorVariables, Tpl.ST_STRING("(getSimVars()->init"));
        a_additionalConstructorVariables = Tpl.writeStr(a_additionalConstructorVariables, a_type);
        a_additionalConstructorVariables = Tpl.writeTok(a_additionalConstructorVariables, Tpl.ST_STRING("Var("));
        a_additionalConstructorVariables = Tpl.writeText(a_additionalConstructorVariables, l_index);
        a_additionalConstructorVariables = Tpl.writeTok(a_additionalConstructorVariables, Tpl.ST_STRING("))"));
      then (txt, a_additionalConstructorVariables);

    case ( txt,
           _,
           _,
           _,
           a_additionalConstructorVariables,
           _,
           _,
           _ )
      then (txt, a_additionalConstructorVariables);
  end match;
end fun_891;

protected function lm_892
  input Tpl.Text in_txt;
  input list<String> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<String> rest;
      String i_idx;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_idx :: rest )
      equation
        txt = Tpl.writeStr(txt, i_idx);
        txt = Tpl.nextIter(txt);
        txt = lm_892(txt, rest);
      then txt;
  end match;
end lm_892;

protected function fun_893
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input list<String> in_a_v_numArrayElement;
  input Tpl.Text in_a_dims;
  input String in_a_type;
  input Tpl.Text in_a_size;
  input Tpl.Text in_a_arrayName;
  input Tpl.Text in_a_typeString;
  input Tpl.Text in_a_indexForUndefinedReferences;
  input DAE.ComponentRef in_a_name;
  input HashTableCrIListArray.HashTable in_a_varToArrayIndexMapping;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_v_numArrayElement, in_a_dims, in_a_type, in_a_size, in_a_arrayName, in_a_typeString, in_a_indexForUndefinedReferences, in_a_name, in_a_varToArrayIndexMapping)
    local
      Tpl.Text txt;
      list<String> a_v_numArrayElement;
      Tpl.Text a_dims;
      String a_type;
      Tpl.Text a_size;
      Tpl.Text a_arrayName;
      Tpl.Text a_typeString;
      Tpl.Text a_indexForUndefinedReferences;
      DAE.ComponentRef a_name;
      HashTableCrIListArray.HashTable a_varToArrayIndexMapping;
      String ret_4;
      list<String> ret_3;
      Tpl.Text l_arrayHeadIdx;
      list<String> ret_1;
      Tpl.Text l_arrayIndices;

    case ( txt,
           false,
           a_v_numArrayElement,
           a_dims,
           a_type,
           a_size,
           a_arrayName,
           a_typeString,
           a_indexForUndefinedReferences,
           a_name,
           a_varToArrayIndexMapping )
      equation
        ret_1 = SimCodeUtil.getVarIndexListByMapping(a_varToArrayIndexMapping, a_name, true, Tpl.textString(a_indexForUndefinedReferences));
        l_arrayIndices = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(" LIST_SEP ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_arrayIndices = lm_892(l_arrayIndices, ret_1);
        l_arrayIndices = Tpl.popIter(l_arrayIndices);
        txt = Tpl.writeText(txt, a_typeString);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("* "));
        txt = Tpl.writeText(txt, a_arrayName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_ref_data["));
        txt = Tpl.writeText(txt, a_size);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "];\n",
                                    "getSimVars()->init"
                                }, false));
        txt = Tpl.writeStr(txt, a_type);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("AliasArray(LIST_OF "));
        txt = Tpl.writeText(txt, l_arrayIndices);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" LIST_END, "));
        txt = Tpl.writeText(txt, a_arrayName);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_ref_data);\n"));
        txt = Tpl.writeText(txt, a_arrayName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = RefArrayDim"));
        txt = Tpl.writeText(txt, a_dims);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<"));
        txt = Tpl.writeText(txt, a_typeString);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = arrayextentDims(txt, a_name, a_v_numArrayElement);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(">("));
        txt = Tpl.writeText(txt, a_arrayName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_ref_data);"));
      then txt;

    case ( txt,
           _,
           _,
           _,
           a_type,
           _,
           a_arrayName,
           _,
           a_indexForUndefinedReferences,
           a_name,
           a_varToArrayIndexMapping )
      equation
        ret_3 = SimCodeUtil.getVarIndexListByMapping(a_varToArrayIndexMapping, a_name, true, Tpl.textString(a_indexForUndefinedReferences));
        ret_4 = listHead(ret_3);
        l_arrayHeadIdx = Tpl.writeStr(Tpl.emptyTxt, ret_4);
        txt = Tpl.writeText(txt, a_arrayName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".init(&_pointerTo"));
        txt = Tpl.writeStr(txt, a_type);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Vars["));
        txt = Tpl.writeText(txt, l_arrayHeadIdx);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("]);"));
      then txt;
  end match;
end fun_893;

protected function fun_894
  input Tpl.Text in_txt;
  input String in_mArg;
  input list<String> in_a_v_numArrayElement;
  input Tpl.Text in_a_dims;
  input Tpl.Text in_a_typeString;
  input Tpl.Text in_a_array__num__elem;
  input String in_a_type;
  input Tpl.Text in_a_arrayName;
  input Tpl.Text in_a_additionalConstructorVariables;
  input Tpl.Text in_a_indexForUndefinedReferences;
  input DAE.ComponentRef in_a_name;
  input HashTableCrIListArray.HashTable in_a_varToArrayIndexMapping;
  input Boolean in_a_createDebugCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_additionalConstructorVariables;
algorithm
  (out_txt, out_a_additionalConstructorVariables) :=
  match(in_txt, in_mArg, in_a_v_numArrayElement, in_a_dims, in_a_typeString, in_a_array__num__elem, in_a_type, in_a_arrayName, in_a_additionalConstructorVariables, in_a_indexForUndefinedReferences, in_a_name, in_a_varToArrayIndexMapping, in_a_createDebugCode)
    local
      Tpl.Text txt;
      list<String> a_v_numArrayElement;
      Tpl.Text a_dims;
      Tpl.Text a_typeString;
      Tpl.Text a_array__num__elem;
      String a_type;
      Tpl.Text a_arrayName;
      Tpl.Text a_additionalConstructorVariables;
      Tpl.Text a_indexForUndefinedReferences;
      DAE.ComponentRef a_name;
      HashTableCrIListArray.HashTable a_varToArrayIndexMapping;
      Boolean a_createDebugCode;
      Boolean ret_2;
      Integer ret_1;
      Tpl.Text l_size;

    case ( txt,
           "0",
           _,
           _,
           _,
           _,
           a_type,
           a_arrayName,
           a_additionalConstructorVariables,
           a_indexForUndefinedReferences,
           a_name,
           a_varToArrayIndexMapping,
           a_createDebugCode )
      equation
        (txt, a_additionalConstructorVariables) = fun_891(txt, a_createDebugCode, a_type, a_arrayName, a_additionalConstructorVariables, a_indexForUndefinedReferences, a_name, a_varToArrayIndexMapping);
      then (txt, a_additionalConstructorVariables);

    case ( txt,
           _,
           a_v_numArrayElement,
           a_dims,
           a_typeString,
           a_array__num__elem,
           a_type,
           a_arrayName,
           a_additionalConstructorVariables,
           a_indexForUndefinedReferences,
           a_name,
           a_varToArrayIndexMapping,
           _ )
      equation
        ret_1 = Util.mulStringDelimit2Int(Tpl.textString(a_array__num__elem), ",");
        l_size = Tpl.writeStr(Tpl.emptyTxt, intString(ret_1));
        ret_2 = SimCodeUtil.isVarIndexListConsecutive(a_varToArrayIndexMapping, a_name);
        txt = fun_893(txt, ret_2, a_v_numArrayElement, a_dims, a_type, l_size, a_arrayName, a_typeString, a_indexForUndefinedReferences, a_name, a_varToArrayIndexMapping);
      then (txt, a_additionalConstructorVariables);
  end match;
end fun_894;

protected function fun_895
  input Tpl.Text in_txt;
  input Boolean in_a_useFlatArrayNotation;
  input list<String> in_a_v_numArrayElement;
  input Tpl.Text in_a_typeString;
  input Tpl.Text in_a_array__num__elem;
  input String in_a_type;
  input Tpl.Text in_a_arrayName;
  input Tpl.Text in_a_additionalConstructorVariables;
  input Tpl.Text in_a_indexForUndefinedReferences;
  input DAE.ComponentRef in_a_name;
  input HashTableCrIListArray.HashTable in_a_varToArrayIndexMapping;
  input Boolean in_a_createDebugCode;
  input Tpl.Text in_a_dims;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_additionalConstructorVariables;
algorithm
  (out_txt, out_a_additionalConstructorVariables) :=
  match(in_txt, in_a_useFlatArrayNotation, in_a_v_numArrayElement, in_a_typeString, in_a_array__num__elem, in_a_type, in_a_arrayName, in_a_additionalConstructorVariables, in_a_indexForUndefinedReferences, in_a_name, in_a_varToArrayIndexMapping, in_a_createDebugCode, in_a_dims)
    local
      Tpl.Text txt;
      list<String> a_v_numArrayElement;
      Tpl.Text a_typeString;
      Tpl.Text a_array__num__elem;
      String a_type;
      Tpl.Text a_arrayName;
      Tpl.Text a_additionalConstructorVariables;
      Tpl.Text a_indexForUndefinedReferences;
      DAE.ComponentRef a_name;
      HashTableCrIListArray.HashTable a_varToArrayIndexMapping;
      Boolean a_createDebugCode;
      Tpl.Text a_dims;
      String str_0;

    case ( txt,
           false,
           a_v_numArrayElement,
           a_typeString,
           a_array__num__elem,
           a_type,
           a_arrayName,
           a_additionalConstructorVariables,
           a_indexForUndefinedReferences,
           a_name,
           a_varToArrayIndexMapping,
           a_createDebugCode,
           a_dims )
      equation
        str_0 = Tpl.textString(a_dims);
        (txt, a_additionalConstructorVariables) = fun_894(txt, str_0, a_v_numArrayElement, a_dims, a_typeString, a_array__num__elem, a_type, a_arrayName, a_additionalConstructorVariables, a_indexForUndefinedReferences, a_name, a_varToArrayIndexMapping, a_createDebugCode);
      then (txt, a_additionalConstructorVariables);

    case ( txt,
           _,
           _,
           _,
           _,
           _,
           _,
           a_additionalConstructorVariables,
           _,
           _,
           _,
           _,
           _ )
      equation
        a_additionalConstructorVariables = Tpl.writeTok(a_additionalConstructorVariables, Tpl.ST_STRING("\"not implemented\""));
        a_additionalConstructorVariables = Tpl.writeTok(a_additionalConstructorVariables, Tpl.ST_NEW_LINE());
      then (txt, a_additionalConstructorVariables);
  end match;
end fun_895;

protected function fun_896
  input Tpl.Text in_txt;
  input Boolean in_a_createDebugCode;
  input String in_a_type;
  input Tpl.Text in_a_varName;
  input Tpl.Text in_a_additionalConstructorVariables;
  input Tpl.Text in_a_indexForUndefinedReferences;
  input DAE.ComponentRef in_a_name;
  input HashTableCrIListArray.HashTable in_a_varToArrayIndexMapping;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_additionalConstructorVariables;
algorithm
  (out_txt, out_a_additionalConstructorVariables) :=
  match(in_txt, in_a_createDebugCode, in_a_type, in_a_varName, in_a_additionalConstructorVariables, in_a_indexForUndefinedReferences, in_a_name, in_a_varToArrayIndexMapping)
    local
      Tpl.Text txt;
      String a_type;
      Tpl.Text a_varName;
      Tpl.Text a_additionalConstructorVariables;
      Tpl.Text a_indexForUndefinedReferences;
      DAE.ComponentRef a_name;
      HashTableCrIListArray.HashTable a_varToArrayIndexMapping;
      String ret_2;
      list<String> ret_1;
      Tpl.Text l_index;

    case ( txt,
           true,
           a_type,
           a_varName,
           a_additionalConstructorVariables,
           a_indexForUndefinedReferences,
           a_name,
           a_varToArrayIndexMapping )
      equation
        ret_1 = SimCodeUtil.getVarIndexListByMapping(a_varToArrayIndexMapping, a_name, true, Tpl.textString(a_indexForUndefinedReferences));
        ret_2 = listHead(ret_1);
        l_index = Tpl.writeStr(Tpl.emptyTxt, ret_2);
        a_additionalConstructorVariables = Tpl.writeTok(a_additionalConstructorVariables, Tpl.ST_STRING(","));
        a_additionalConstructorVariables = Tpl.writeText(a_additionalConstructorVariables, a_varName);
        a_additionalConstructorVariables = Tpl.writeTok(a_additionalConstructorVariables, Tpl.ST_STRING("(getSimVars()->init"));
        a_additionalConstructorVariables = Tpl.writeStr(a_additionalConstructorVariables, a_type);
        a_additionalConstructorVariables = Tpl.writeTok(a_additionalConstructorVariables, Tpl.ST_STRING("Var("));
        a_additionalConstructorVariables = Tpl.writeText(a_additionalConstructorVariables, l_index);
        a_additionalConstructorVariables = Tpl.writeTok(a_additionalConstructorVariables, Tpl.ST_STRING("))"));
      then (txt, a_additionalConstructorVariables);

    case ( txt,
           _,
           _,
           _,
           a_additionalConstructorVariables,
           _,
           _,
           _ )
      then (txt, a_additionalConstructorVariables);
  end match;
end fun_896;

protected function fun_897
  input Tpl.Text in_txt;
  input String in_mArg;
  input String in_a_type;
  input Tpl.Text in_a_varName;
  input Tpl.Text in_a_additionalConstructorVariables;
  input Tpl.Text in_a_indexForUndefinedReferences;
  input DAE.ComponentRef in_a_name;
  input HashTableCrIListArray.HashTable in_a_varToArrayIndexMapping;
  input Boolean in_a_createDebugCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_additionalConstructorVariables;
algorithm
  (out_txt, out_a_additionalConstructorVariables) :=
  match(in_txt, in_mArg, in_a_type, in_a_varName, in_a_additionalConstructorVariables, in_a_indexForUndefinedReferences, in_a_name, in_a_varToArrayIndexMapping, in_a_createDebugCode)
    local
      Tpl.Text txt;
      String a_type;
      Tpl.Text a_varName;
      Tpl.Text a_additionalConstructorVariables;
      Tpl.Text a_indexForUndefinedReferences;
      DAE.ComponentRef a_name;
      HashTableCrIListArray.HashTable a_varToArrayIndexMapping;
      Boolean a_createDebugCode;

    case ( txt,
           "0",
           a_type,
           a_varName,
           a_additionalConstructorVariables,
           a_indexForUndefinedReferences,
           a_name,
           a_varToArrayIndexMapping,
           a_createDebugCode )
      equation
        (txt, a_additionalConstructorVariables) = fun_896(txt, a_createDebugCode, a_type, a_varName, a_additionalConstructorVariables, a_indexForUndefinedReferences, a_name, a_varToArrayIndexMapping);
      then (txt, a_additionalConstructorVariables);

    case ( txt,
           _,
           _,
           _,
           a_additionalConstructorVariables,
           _,
           _,
           _,
           _ )
      then (txt, a_additionalConstructorVariables);
  end match;
end fun_897;

protected function fun_898
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_a_simVar;
  input HashTableCrIListArray.HashTable in_a_varToArrayIndexMapping;
  input Tpl.Text in_a_indexForUndefinedReferences;
  input Boolean in_a_useFlatArrayNotation;
  input Boolean in_a_createDebugCode;
  input String in_a_type;
  input Tpl.Text in_a_additionalConstructorVariables;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_additionalConstructorVariables;
algorithm
  (out_txt, out_a_additionalConstructorVariables) :=
  match(in_txt, in_a_simVar, in_a_varToArrayIndexMapping, in_a_indexForUndefinedReferences, in_a_useFlatArrayNotation, in_a_createDebugCode, in_a_type, in_a_additionalConstructorVariables)
    local
      Tpl.Text txt;
      HashTableCrIListArray.HashTable a_varToArrayIndexMapping;
      Tpl.Text a_indexForUndefinedReferences;
      Boolean a_useFlatArrayNotation;
      Boolean a_createDebugCode;
      String a_type;
      Tpl.Text a_additionalConstructorVariables;
      list<String> i_v_numArrayElement;
      DAE.Type i_type__;
      DAE.ComponentRef i_name;
      String str_9;
      Tpl.Text l_varType;
      String ret_7;
      list<String> ret_6;
      Tpl.Text l_arrayHeadIdx;
      Tpl.Text l_varName;
      Tpl.Text l_array__num__elem;
      Tpl.Text l_typeString;
      Tpl.Text l_arrayName;
      Tpl.Text l_dims;

    case ( txt,
           SimCodeVar.SIMVAR(numArrayElement = {}, arrayCref = NONE(), name = DAE.CREF_IDENT(subscriptLst = _ :: _)),
           _,
           _,
           _,
           _,
           _,
           a_additionalConstructorVariables )
      then (txt, a_additionalConstructorVariables);

    case ( txt,
           SimCodeVar.SIMVAR(numArrayElement = {}, arrayCref = NONE(), name = i_name),
           a_varToArrayIndexMapping,
           a_indexForUndefinedReferences,
           a_useFlatArrayNotation,
           a_createDebugCode,
           a_type,
           a_additionalConstructorVariables )
      equation
        (txt, a_additionalConstructorVariables) = fun_885(txt, a_createDebugCode, a_type, a_useFlatArrayNotation, a_additionalConstructorVariables, a_indexForUndefinedReferences, i_name, a_varToArrayIndexMapping);
      then (txt, a_additionalConstructorVariables);

    case ( txt,
           SimCodeVar.SIMVAR(name = (i_name as DAE.CREF_IDENT(ident = _)), arrayCref = SOME(_), numArrayElement = i_v_numArrayElement, type_ = i_type__),
           a_varToArrayIndexMapping,
           a_indexForUndefinedReferences,
           a_useFlatArrayNotation,
           a_createDebugCode,
           a_type,
           a_additionalConstructorVariables )
      equation
        l_dims = Tpl.emptyTxt;
        (l_arrayName, l_dims) = CodegenCppCommonOld.arraycref2(Tpl.emptyTxt, i_name, l_dims);
        l_typeString = variableType(Tpl.emptyTxt, i_type__);
        l_array__num__elem = arrayNumElements(Tpl.emptyTxt, i_name, i_v_numArrayElement);
        (txt, a_additionalConstructorVariables) = fun_890(txt, a_useFlatArrayNotation, i_v_numArrayElement, l_typeString, l_array__num__elem, a_type, l_arrayName, a_additionalConstructorVariables, a_indexForUndefinedReferences, i_name, a_varToArrayIndexMapping, a_createDebugCode, l_dims);
      then (txt, a_additionalConstructorVariables);

    case ( txt,
           SimCodeVar.SIMVAR(name = (i_name as DAE.CREF_QUAL(ident = _)), arrayCref = SOME(_), numArrayElement = i_v_numArrayElement, type_ = i_type__),
           a_varToArrayIndexMapping,
           a_indexForUndefinedReferences,
           a_useFlatArrayNotation,
           a_createDebugCode,
           a_type,
           a_additionalConstructorVariables )
      equation
        l_dims = Tpl.emptyTxt;
        (l_arrayName, l_dims) = CodegenCppCommonOld.arraycref2(Tpl.emptyTxt, i_name, l_dims);
        l_typeString = variableType(Tpl.emptyTxt, i_type__);
        l_array__num__elem = arrayNumElements(Tpl.emptyTxt, i_name, i_v_numArrayElement);
        (txt, a_additionalConstructorVariables) = fun_895(txt, a_useFlatArrayNotation, i_v_numArrayElement, l_typeString, l_array__num__elem, a_type, l_arrayName, a_additionalConstructorVariables, a_indexForUndefinedReferences, i_name, a_varToArrayIndexMapping, a_createDebugCode, l_dims);
      then (txt, a_additionalConstructorVariables);

    case ( txt,
           SimCodeVar.SIMVAR(type_ = (i_type__ as DAE.T_ARRAY(ty = _)), name = i_name),
           a_varToArrayIndexMapping,
           a_indexForUndefinedReferences,
           _,
           _,
           a_type,
           a_additionalConstructorVariables )
      equation
        l_dims = Tpl.emptyTxt;
        (l_varName, l_dims) = CodegenCppCommonOld.arraycref2(Tpl.emptyTxt, i_name, l_dims);
        l_typeString = CodegenCppCommonOld.expTypeShort(Tpl.emptyTxt, i_type__);
        ret_6 = SimCodeUtil.getVarIndexListByMapping(a_varToArrayIndexMapping, i_name, true, Tpl.textString(a_indexForUndefinedReferences));
        ret_7 = listHead(ret_6);
        l_arrayHeadIdx = Tpl.writeStr(Tpl.emptyTxt, ret_7);
        txt = Tpl.writeText(txt, l_varName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".init(&_pointerTo"));
        txt = Tpl.writeStr(txt, a_type);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Vars["));
        txt = Tpl.writeText(txt, l_arrayHeadIdx);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("]);"));
      then (txt, a_additionalConstructorVariables);

    case ( txt,
           SimCodeVar.SIMVAR(numArrayElement = _ :: _, name = i_name, type_ = i_type__),
           a_varToArrayIndexMapping,
           a_indexForUndefinedReferences,
           _,
           a_createDebugCode,
           a_type,
           a_additionalConstructorVariables )
      equation
        l_dims = Tpl.emptyTxt;
        (l_varName, l_dims) = CodegenCppCommonOld.arraycref2(Tpl.emptyTxt, i_name, l_dims);
        l_varType = variableType(Tpl.emptyTxt, i_type__);
        str_9 = Tpl.textString(l_dims);
        (txt, a_additionalConstructorVariables) = fun_897(txt, str_9, a_type, l_varName, a_additionalConstructorVariables, a_indexForUndefinedReferences, i_name, a_varToArrayIndexMapping, a_createDebugCode);
      then (txt, a_additionalConstructorVariables);

    case ( txt,
           _,
           _,
           _,
           _,
           _,
           _,
           a_additionalConstructorVariables )
      then (txt, a_additionalConstructorVariables);
  end match;
end fun_898;

public function memberVariableInitialize2
  input Tpl.Text txt;
  input SimCodeVar.SimVar a_simVar;
  input HashTableCrIListArray.HashTable a_varToArrayIndexMapping;
  input Tpl.Text a_indexForUndefinedReferences;
  input Boolean a_useFlatArrayNotation;
  input Boolean a_createDebugCode;
  input String a_type;
  input Tpl.Text a_additionalConstructorVariables;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_indexForUndefinedReferences;
  output Tpl.Text out_a_additionalConstructorVariables;
algorithm
  (out_txt, out_a_additionalConstructorVariables) := fun_898(txt, a_simVar, a_varToArrayIndexMapping, a_indexForUndefinedReferences, a_useFlatArrayNotation, a_createDebugCode, a_type, a_additionalConstructorVariables);
  out_a_indexForUndefinedReferences := a_indexForUndefinedReferences;
end memberVariableInitialize2;

protected function lm_900
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Boolean a_useFlatArrayNotation;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_useFlatArrayNotation )
      equation
        txt = memberVariableDefineReference2(txt, i_var, "algebraics", "", a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        txt = lm_900(txt, rest, a_useFlatArrayNotation);
      then txt;
  end match;
end lm_900;

protected function fun_901
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_a_vars_algVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_vars_algVars)
    local
      Tpl.Text txt;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_901;

protected function lm_902
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Boolean a_useFlatArrayNotation;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_useFlatArrayNotation )
      equation
        txt = memberVariableDefineReference2(txt, i_var, "algebraics", "", a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        txt = lm_902(txt, rest, a_useFlatArrayNotation);
      then txt;
  end match;
end lm_902;

protected function fun_903
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_a_vars_discreteAlgVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_vars_discreteAlgVars)
    local
      Tpl.Text txt;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_903;

protected function lm_904
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Boolean a_useFlatArrayNotation;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_useFlatArrayNotation )
      equation
        txt = memberVariableDefineReference2(txt, i_var, "parameters", "", a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        txt = lm_904(txt, rest, a_useFlatArrayNotation);
      then txt;
  end match;
end lm_904;

protected function fun_905
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_a_vars_paramVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_vars_paramVars)
    local
      Tpl.Text txt;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_905;

protected function lm_906
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Boolean a_useFlatArrayNotation;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_useFlatArrayNotation )
      equation
        txt = memberVariableDefineReference2(txt, i_var, "aliasVars", "", a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        txt = lm_906(txt, rest, a_useFlatArrayNotation);
      then txt;
  end match;
end lm_906;

protected function fun_907
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_a_vars_aliasVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_vars_aliasVars)
    local
      Tpl.Text txt;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_907;

protected function lm_908
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Boolean a_useFlatArrayNotation;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_useFlatArrayNotation )
      equation
        txt = memberVariableDefineReference(txt, "int", i_var, "intVariables.algebraics", "", a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        txt = lm_908(txt, rest, a_useFlatArrayNotation);
      then txt;
  end match;
end lm_908;

protected function fun_909
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_a_vars_intAlgVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_vars_intAlgVars)
    local
      Tpl.Text txt;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_909;

protected function lm_910
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Boolean a_useFlatArrayNotation;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_useFlatArrayNotation )
      equation
        txt = memberVariableDefineReference(txt, "int", i_var, "intVariables.parameters", "", a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        txt = lm_910(txt, rest, a_useFlatArrayNotation);
      then txt;
  end match;
end lm_910;

protected function fun_911
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_a_vars_intParamVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_vars_intParamVars)
    local
      Tpl.Text txt;

    case ( txt,
           {} )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_911;

protected function lm_912
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Boolean a_useFlatArrayNotation;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_useFlatArrayNotation )
      equation
        txt = memberVariableDefineReference(txt, "int", i_var, "intVariables.AliasVars", "", a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        txt = lm_912(txt, rest, a_useFlatArrayNotation);
      then txt;
  end match;
end lm_912;

protected function fun_913
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_a_vars_intAliasVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_vars_intAliasVars)
    local
      Tpl.Text txt;

    case ( txt,
           {} )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_913;

protected function lm_914
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Boolean a_useFlatArrayNotation;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_useFlatArrayNotation )
      equation
        txt = memberVariableDefineReference(txt, "bool", i_var, "boolVariables.algebraics", "", a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        txt = lm_914(txt, rest, a_useFlatArrayNotation);
      then txt;
  end match;
end lm_914;

protected function fun_915
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_a_vars_boolAlgVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_vars_boolAlgVars)
    local
      Tpl.Text txt;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_915;

protected function lm_916
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Boolean a_useFlatArrayNotation;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_useFlatArrayNotation )
      equation
        txt = memberVariableDefineReference(txt, "bool", i_var, "boolVariables.parameters", "", a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        txt = lm_916(txt, rest, a_useFlatArrayNotation);
      then txt;
  end match;
end lm_916;

protected function fun_917
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_a_vars_boolParamVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_vars_boolParamVars)
    local
      Tpl.Text txt;

    case ( txt,
           {} )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_917;

protected function lm_918
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Boolean a_useFlatArrayNotation;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_useFlatArrayNotation )
      equation
        txt = memberVariableDefineReference(txt, "bool ", i_var, "boolVariables.AliasVars", "", a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        txt = lm_918(txt, rest, a_useFlatArrayNotation);
      then txt;
  end match;
end lm_918;

protected function fun_919
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_a_vars_boolAliasVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_vars_boolAliasVars)
    local
      Tpl.Text txt;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_919;

protected function lm_920
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Boolean a_useFlatArrayNotation;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_useFlatArrayNotation )
      equation
        txt = memberVariableDefineReference(txt, "string", i_var, "stringVariables.algebraics", "", a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        txt = lm_920(txt, rest, a_useFlatArrayNotation);
      then txt;
  end match;
end lm_920;

protected function fun_921
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_a_vars_stringAlgVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_vars_stringAlgVars)
    local
      Tpl.Text txt;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_921;

protected function lm_922
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Boolean a_useFlatArrayNotation;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_useFlatArrayNotation )
      equation
        txt = memberVariableDefineReference(txt, "string", i_var, "stringVariables.parameters", "", a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        txt = lm_922(txt, rest, a_useFlatArrayNotation);
      then txt;
  end match;
end lm_922;

protected function fun_923
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_a_vars_stringParamVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_vars_stringParamVars)
    local
      Tpl.Text txt;

    case ( txt,
           {} )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_923;

protected function lm_924
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Boolean a_useFlatArrayNotation;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_useFlatArrayNotation )
      equation
        txt = memberVariableDefineReference(txt, "string", i_var, "stringVariables.AliasVars", "", a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        txt = lm_924(txt, rest, a_useFlatArrayNotation);
      then txt;
  end match;
end lm_924;

protected function fun_925
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_a_vars_stringAliasVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_vars_stringAliasVars)
    local
      Tpl.Text txt;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_925;

public function memberVariableAlgloop
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      list<SimCodeVar.SimVar> i_vars_stringAliasVars;
      list<SimCodeVar.SimVar> i_vars_stringParamVars;
      list<SimCodeVar.SimVar> i_vars_stringAlgVars;
      list<SimCodeVar.SimVar> i_vars_boolAliasVars;
      list<SimCodeVar.SimVar> i_vars_boolParamVars;
      list<SimCodeVar.SimVar> i_vars_boolAlgVars;
      list<SimCodeVar.SimVar> i_vars_intAliasVars;
      list<SimCodeVar.SimVar> i_vars_intParamVars;
      list<SimCodeVar.SimVar> i_vars_intAlgVars;
      list<SimCodeVar.SimVar> i_vars_aliasVars;
      list<SimCodeVar.SimVar> i_vars_paramVars;
      list<SimCodeVar.SimVar> i_vars_discreteAlgVars;
      list<SimCodeVar.SimVar> i_vars_algVars;

    case ( txt,
           SimCode.MODELINFO(vars = SimCodeVar.SIMVARS(algVars = i_vars_algVars, discreteAlgVars = i_vars_discreteAlgVars, paramVars = i_vars_paramVars, aliasVars = i_vars_aliasVars, intAlgVars = i_vars_intAlgVars, intParamVars = i_vars_intParamVars, intAliasVars = i_vars_intAliasVars, boolAlgVars = i_vars_boolAlgVars, boolParamVars = i_vars_boolParamVars, boolAliasVars = i_vars_boolAliasVars, stringAlgVars = i_vars_stringAlgVars, stringParamVars = i_vars_stringParamVars, stringAliasVars = i_vars_stringAliasVars)),
           a_useFlatArrayNotation )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_LINE(";\n")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_900(txt, i_vars_algVars, a_useFlatArrayNotation);
        txt = Tpl.popIter(txt);
        txt = fun_901(txt, i_vars_algVars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_LINE(";\n")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_902(txt, i_vars_discreteAlgVars, a_useFlatArrayNotation);
        txt = Tpl.popIter(txt);
        txt = fun_903(txt, i_vars_discreteAlgVars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_LINE(";\n")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_904(txt, i_vars_paramVars, a_useFlatArrayNotation);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = fun_905(txt, i_vars_paramVars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_LINE(";\n")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_906(txt, i_vars_aliasVars, a_useFlatArrayNotation);
        txt = Tpl.popIter(txt);
        txt = fun_907(txt, i_vars_aliasVars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_LINE(";\n")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_908(txt, i_vars_intAlgVars, a_useFlatArrayNotation);
        txt = Tpl.popIter(txt);
        txt = fun_909(txt, i_vars_intAlgVars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_LINE(";\n")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_910(txt, i_vars_intParamVars, a_useFlatArrayNotation);
        txt = Tpl.popIter(txt);
        txt = fun_911(txt, i_vars_intParamVars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_LINE(";\n")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_912(txt, i_vars_intAliasVars, a_useFlatArrayNotation);
        txt = Tpl.popIter(txt);
        txt = fun_913(txt, i_vars_intAliasVars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_LINE(";\n")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_914(txt, i_vars_boolAlgVars, a_useFlatArrayNotation);
        txt = Tpl.popIter(txt);
        txt = fun_915(txt, i_vars_boolAlgVars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_LINE(";\n")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_916(txt, i_vars_boolParamVars, a_useFlatArrayNotation);
        txt = Tpl.popIter(txt);
        txt = fun_917(txt, i_vars_boolParamVars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_LINE(";\n")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_918(txt, i_vars_boolAliasVars, a_useFlatArrayNotation);
        txt = Tpl.popIter(txt);
        txt = fun_919(txt, i_vars_boolAliasVars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_LINE(";\n")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_920(txt, i_vars_stringAlgVars, a_useFlatArrayNotation);
        txt = Tpl.popIter(txt);
        txt = fun_921(txt, i_vars_stringAlgVars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_LINE(";\n")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_922(txt, i_vars_stringParamVars, a_useFlatArrayNotation);
        txt = Tpl.popIter(txt);
        txt = fun_923(txt, i_vars_stringParamVars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_LINE(";\n")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_924(txt, i_vars_stringAliasVars, a_useFlatArrayNotation);
        txt = Tpl.popIter(txt);
        txt = fun_925(txt, i_vars_stringAliasVars);
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end memberVariableAlgloop;

protected function lm_927
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Boolean a_useFlatArrayNotation;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_useFlatArrayNotation )
      equation
        txt = memberVariableDefineReference2(txt, i_var, "algebraics", "_", a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        txt = lm_927(txt, rest, a_useFlatArrayNotation);
      then txt;
  end match;
end lm_927;

protected function fun_928
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_a_vars_algVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_vars_algVars)
    local
      Tpl.Text txt;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
      then txt;
  end match;
end fun_928;

protected function lm_929
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Boolean a_useFlatArrayNotation;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_useFlatArrayNotation )
      equation
        txt = memberVariableDefineReference2(txt, i_var, "algebraics", "_", a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        txt = lm_929(txt, rest, a_useFlatArrayNotation);
      then txt;
  end match;
end lm_929;

protected function fun_930
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_a_vars_discreteAlgVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_vars_discreteAlgVars)
    local
      Tpl.Text txt;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
      then txt;
  end match;
end fun_930;

protected function lm_931
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Boolean a_useFlatArrayNotation;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_useFlatArrayNotation )
      equation
        txt = memberVariableDefineReference2(txt, i_var, "parameters", "_", a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        txt = lm_931(txt, rest, a_useFlatArrayNotation);
      then txt;
  end match;
end lm_931;

protected function fun_932
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_a_vars_paramVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_vars_paramVars)
    local
      Tpl.Text txt;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
      then txt;
  end match;
end fun_932;

protected function lm_933
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Boolean a_useFlatArrayNotation;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_useFlatArrayNotation )
      equation
        txt = memberVariableDefineReference2(txt, i_var, "aliasVars", "_", a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        txt = lm_933(txt, rest, a_useFlatArrayNotation);
      then txt;
  end match;
end lm_933;

protected function fun_934
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_a_vars_aliasVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_vars_aliasVars)
    local
      Tpl.Text txt;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
      then txt;
  end match;
end fun_934;

protected function lm_935
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Boolean a_useFlatArrayNotation;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_useFlatArrayNotation )
      equation
        txt = memberVariableDefineReference(txt, "int", i_var, "intVariables.algebraics", "_", a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        txt = lm_935(txt, rest, a_useFlatArrayNotation);
      then txt;
  end match;
end lm_935;

protected function fun_936
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_a_vars_intAlgVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_vars_intAlgVars)
    local
      Tpl.Text txt;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
      then txt;
  end match;
end fun_936;

protected function lm_937
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Boolean a_useFlatArrayNotation;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_useFlatArrayNotation )
      equation
        txt = memberVariableDefineReference(txt, "int", i_var, "intVariables.parameters", "_", a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        txt = lm_937(txt, rest, a_useFlatArrayNotation);
      then txt;
  end match;
end lm_937;

protected function fun_938
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_a_vars_intParamVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_vars_intParamVars)
    local
      Tpl.Text txt;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
      then txt;
  end match;
end fun_938;

protected function lm_939
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Boolean a_useFlatArrayNotation;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_useFlatArrayNotation )
      equation
        txt = memberVariableDefineReference(txt, "int", i_var, "intVariables.AliasVars", "_", a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        txt = lm_939(txt, rest, a_useFlatArrayNotation);
      then txt;
  end match;
end lm_939;

protected function fun_940
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_a_vars_intAliasVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_vars_intAliasVars)
    local
      Tpl.Text txt;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
      then txt;
  end match;
end fun_940;

protected function lm_941
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Boolean a_useFlatArrayNotation;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_useFlatArrayNotation )
      equation
        txt = memberVariableDefineReference(txt, "bool", i_var, "boolVariables.algebraics", "_", a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        txt = lm_941(txt, rest, a_useFlatArrayNotation);
      then txt;
  end match;
end lm_941;

protected function fun_942
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_a_vars_boolAlgVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_vars_boolAlgVars)
    local
      Tpl.Text txt;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
      then txt;
  end match;
end fun_942;

protected function lm_943
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Boolean a_useFlatArrayNotation;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_useFlatArrayNotation )
      equation
        txt = memberVariableDefineReference(txt, "bool", i_var, "boolVariables.parameters", "_", a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        txt = lm_943(txt, rest, a_useFlatArrayNotation);
      then txt;
  end match;
end lm_943;

protected function fun_944
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_a_vars_boolParamVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_vars_boolParamVars)
    local
      Tpl.Text txt;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
      then txt;
  end match;
end fun_944;

protected function lm_945
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Boolean a_useFlatArrayNotation;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_useFlatArrayNotation )
      equation
        txt = memberVariableDefineReference(txt, "bool ", i_var, "boolVariables.AliasVars", "_", a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        txt = lm_945(txt, rest, a_useFlatArrayNotation);
      then txt;
  end match;
end lm_945;

protected function fun_946
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_a_vars_boolAliasVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_vars_boolAliasVars)
    local
      Tpl.Text txt;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
      then txt;
  end match;
end fun_946;

protected function lm_947
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Boolean a_useFlatArrayNotation;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_useFlatArrayNotation )
      equation
        txt = memberVariableDefineReference(txt, "string", i_var, "stringVariables.algebraics", "_", a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        txt = lm_947(txt, rest, a_useFlatArrayNotation);
      then txt;
  end match;
end lm_947;

protected function fun_948
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_a_vars_stringAlgVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_vars_stringAlgVars)
    local
      Tpl.Text txt;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
      then txt;
  end match;
end fun_948;

protected function lm_949
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Boolean a_useFlatArrayNotation;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_useFlatArrayNotation )
      equation
        txt = memberVariableDefineReference(txt, "string", i_var, "stringVariables.parameters", "_", a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        txt = lm_949(txt, rest, a_useFlatArrayNotation);
      then txt;
  end match;
end lm_949;

protected function fun_950
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_a_vars_stringParamVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_vars_stringParamVars)
    local
      Tpl.Text txt;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
      then txt;
  end match;
end fun_950;

protected function lm_951
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Boolean a_useFlatArrayNotation;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_useFlatArrayNotation )
      equation
        txt = memberVariableDefineReference(txt, "string", i_var, "stringVariables.AliasVars", "_", a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        txt = lm_951(txt, rest, a_useFlatArrayNotation);
      then txt;
  end match;
end lm_951;

protected function fun_952
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_a_vars_stringAliasVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_vars_stringAliasVars)
    local
      Tpl.Text txt;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
      then txt;
  end match;
end fun_952;

public function constructorParamAlgloop
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      list<SimCodeVar.SimVar> i_vars_stringAliasVars;
      list<SimCodeVar.SimVar> i_vars_stringParamVars;
      list<SimCodeVar.SimVar> i_vars_stringAlgVars;
      list<SimCodeVar.SimVar> i_vars_boolAliasVars;
      list<SimCodeVar.SimVar> i_vars_boolParamVars;
      list<SimCodeVar.SimVar> i_vars_boolAlgVars;
      list<SimCodeVar.SimVar> i_vars_intAliasVars;
      list<SimCodeVar.SimVar> i_vars_intParamVars;
      list<SimCodeVar.SimVar> i_vars_intAlgVars;
      list<SimCodeVar.SimVar> i_vars_aliasVars;
      list<SimCodeVar.SimVar> i_vars_paramVars;
      list<SimCodeVar.SimVar> i_vars_discreteAlgVars;
      list<SimCodeVar.SimVar> i_vars_algVars;

    case ( txt,
           SimCode.MODELINFO(vars = SimCodeVar.SIMVARS(algVars = i_vars_algVars, discreteAlgVars = i_vars_discreteAlgVars, paramVars = i_vars_paramVars, aliasVars = i_vars_aliasVars, intAlgVars = i_vars_intAlgVars, intParamVars = i_vars_intParamVars, intAliasVars = i_vars_intAliasVars, boolAlgVars = i_vars_boolAlgVars, boolParamVars = i_vars_boolParamVars, boolAliasVars = i_vars_boolAliasVars, stringAlgVars = i_vars_stringAlgVars, stringParamVars = i_vars_stringParamVars, stringAliasVars = i_vars_stringAliasVars)),
           a_useFlatArrayNotation )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_927(txt, i_vars_algVars, a_useFlatArrayNotation);
        txt = Tpl.popIter(txt);
        txt = fun_928(txt, i_vars_algVars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_929(txt, i_vars_discreteAlgVars, a_useFlatArrayNotation);
        txt = Tpl.popIter(txt);
        txt = fun_930(txt, i_vars_discreteAlgVars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_931(txt, i_vars_paramVars, a_useFlatArrayNotation);
        txt = Tpl.popIter(txt);
        txt = fun_932(txt, i_vars_paramVars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_933(txt, i_vars_aliasVars, a_useFlatArrayNotation);
        txt = Tpl.popIter(txt);
        txt = fun_934(txt, i_vars_aliasVars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_935(txt, i_vars_intAlgVars, a_useFlatArrayNotation);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = fun_936(txt, i_vars_intAlgVars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_937(txt, i_vars_intParamVars, a_useFlatArrayNotation);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = fun_938(txt, i_vars_intParamVars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_939(txt, i_vars_intAliasVars, a_useFlatArrayNotation);
        txt = Tpl.popIter(txt);
        txt = fun_940(txt, i_vars_intAliasVars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_941(txt, i_vars_boolAlgVars, a_useFlatArrayNotation);
        txt = Tpl.popIter(txt);
        txt = fun_942(txt, i_vars_boolAlgVars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_943(txt, i_vars_boolParamVars, a_useFlatArrayNotation);
        txt = Tpl.popIter(txt);
        txt = fun_944(txt, i_vars_boolParamVars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_945(txt, i_vars_boolAliasVars, a_useFlatArrayNotation);
        txt = Tpl.popIter(txt);
        txt = fun_946(txt, i_vars_boolAliasVars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_947(txt, i_vars_stringAlgVars, a_useFlatArrayNotation);
        txt = Tpl.popIter(txt);
        txt = fun_948(txt, i_vars_stringAlgVars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_949(txt, i_vars_stringParamVars, a_useFlatArrayNotation);
        txt = Tpl.popIter(txt);
        txt = fun_950(txt, i_vars_stringParamVars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_951(txt, i_vars_stringAliasVars, a_useFlatArrayNotation);
        txt = Tpl.popIter(txt);
        txt = fun_952(txt, i_vars_stringAliasVars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end constructorParamAlgloop;

protected function lm_954
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_arrayInit;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_arrayInit;
algorithm
  (out_txt, out_a_arrayInit) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_arrayInit)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_arrayInit;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _,
           a_arrayInit )
      then (txt, a_arrayInit);

    case ( txt,
           i_var :: rest,
           a_useFlatArrayNotation,
           a_arrayInit )
      equation
        (txt, a_arrayInit) = initAlgloopParam(txt, i_var, "algebraics", a_arrayInit, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_arrayInit) = lm_954(txt, rest, a_useFlatArrayNotation, a_arrayInit);
      then (txt, a_arrayInit);
  end match;
end lm_954;

protected function fun_955
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_a_vars_algVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_vars_algVars)
    local
      Tpl.Text txt;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
      then txt;
  end match;
end fun_955;

protected function lm_956
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_arrayInit;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_arrayInit;
algorithm
  (out_txt, out_a_arrayInit) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_arrayInit)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_arrayInit;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _,
           a_arrayInit )
      then (txt, a_arrayInit);

    case ( txt,
           i_var :: rest,
           a_useFlatArrayNotation,
           a_arrayInit )
      equation
        (txt, a_arrayInit) = initAlgloopParam(txt, i_var, "algebraics", a_arrayInit, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_arrayInit) = lm_956(txt, rest, a_useFlatArrayNotation, a_arrayInit);
      then (txt, a_arrayInit);
  end match;
end lm_956;

protected function fun_957
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_a_vars_discreteAlgVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_vars_discreteAlgVars)
    local
      Tpl.Text txt;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
      then txt;
  end match;
end fun_957;

protected function lm_958
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_arrayInit;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_arrayInit;
algorithm
  (out_txt, out_a_arrayInit) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_arrayInit)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_arrayInit;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _,
           a_arrayInit )
      then (txt, a_arrayInit);

    case ( txt,
           i_var :: rest,
           a_useFlatArrayNotation,
           a_arrayInit )
      equation
        (txt, a_arrayInit) = initAlgloopParam(txt, i_var, "parameters", a_arrayInit, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_arrayInit) = lm_958(txt, rest, a_useFlatArrayNotation, a_arrayInit);
      then (txt, a_arrayInit);
  end match;
end lm_958;

protected function fun_959
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_a_vars_paramVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_vars_paramVars)
    local
      Tpl.Text txt;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
      then txt;
  end match;
end fun_959;

protected function lm_960
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_arrayInit;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_arrayInit;
algorithm
  (out_txt, out_a_arrayInit) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_arrayInit)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_arrayInit;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _,
           a_arrayInit )
      then (txt, a_arrayInit);

    case ( txt,
           i_var :: rest,
           a_useFlatArrayNotation,
           a_arrayInit )
      equation
        (txt, a_arrayInit) = initAlgloopParam(txt, i_var, "aliasVars", a_arrayInit, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_arrayInit) = lm_960(txt, rest, a_useFlatArrayNotation, a_arrayInit);
      then (txt, a_arrayInit);
  end match;
end lm_960;

protected function fun_961
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_a_vars_aliasVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_vars_aliasVars)
    local
      Tpl.Text txt;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
      then txt;
  end match;
end fun_961;

protected function lm_962
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_arrayInit;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_arrayInit;
algorithm
  (out_txt, out_a_arrayInit) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_arrayInit)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_arrayInit;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _,
           a_arrayInit )
      then (txt, a_arrayInit);

    case ( txt,
           i_var :: rest,
           a_useFlatArrayNotation,
           a_arrayInit )
      equation
        (txt, a_arrayInit) = initAlgloopParam(txt, i_var, "intVariables.algebraics", a_arrayInit, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_arrayInit) = lm_962(txt, rest, a_useFlatArrayNotation, a_arrayInit);
      then (txt, a_arrayInit);
  end match;
end lm_962;

protected function fun_963
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_a_vars_intAlgVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_vars_intAlgVars)
    local
      Tpl.Text txt;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
      then txt;
  end match;
end fun_963;

protected function lm_964
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_arrayInit;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_arrayInit;
algorithm
  (out_txt, out_a_arrayInit) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_arrayInit)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_arrayInit;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _,
           a_arrayInit )
      then (txt, a_arrayInit);

    case ( txt,
           i_var :: rest,
           a_useFlatArrayNotation,
           a_arrayInit )
      equation
        (txt, a_arrayInit) = initAlgloopParam(txt, i_var, "intVariables.parameters", a_arrayInit, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_arrayInit) = lm_964(txt, rest, a_useFlatArrayNotation, a_arrayInit);
      then (txt, a_arrayInit);
  end match;
end lm_964;

protected function fun_965
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_a_vars_intParamVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_vars_intParamVars)
    local
      Tpl.Text txt;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
      then txt;
  end match;
end fun_965;

protected function lm_966
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_arrayInit;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_arrayInit;
algorithm
  (out_txt, out_a_arrayInit) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_arrayInit)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_arrayInit;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _,
           a_arrayInit )
      then (txt, a_arrayInit);

    case ( txt,
           i_var :: rest,
           a_useFlatArrayNotation,
           a_arrayInit )
      equation
        (txt, a_arrayInit) = initAlgloopParam(txt, i_var, "intVariables.AliasVars", a_arrayInit, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_arrayInit) = lm_966(txt, rest, a_useFlatArrayNotation, a_arrayInit);
      then (txt, a_arrayInit);
  end match;
end lm_966;

protected function fun_967
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_a_vars_intAliasVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_vars_intAliasVars)
    local
      Tpl.Text txt;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
      then txt;
  end match;
end fun_967;

protected function lm_968
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_arrayInit;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_arrayInit;
algorithm
  (out_txt, out_a_arrayInit) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_arrayInit)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_arrayInit;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _,
           a_arrayInit )
      then (txt, a_arrayInit);

    case ( txt,
           i_var :: rest,
           a_useFlatArrayNotation,
           a_arrayInit )
      equation
        (txt, a_arrayInit) = initAlgloopParam(txt, i_var, "boolVariables.algebraics", a_arrayInit, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_arrayInit) = lm_968(txt, rest, a_useFlatArrayNotation, a_arrayInit);
      then (txt, a_arrayInit);
  end match;
end lm_968;

protected function fun_969
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_a_vars_boolAlgVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_vars_boolAlgVars)
    local
      Tpl.Text txt;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
      then txt;
  end match;
end fun_969;

protected function lm_970
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_arrayInit;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_arrayInit;
algorithm
  (out_txt, out_a_arrayInit) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_arrayInit)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_arrayInit;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _,
           a_arrayInit )
      then (txt, a_arrayInit);

    case ( txt,
           i_var :: rest,
           a_useFlatArrayNotation,
           a_arrayInit )
      equation
        (txt, a_arrayInit) = initAlgloopParam(txt, i_var, "boolVariables.parameters", a_arrayInit, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_arrayInit) = lm_970(txt, rest, a_useFlatArrayNotation, a_arrayInit);
      then (txt, a_arrayInit);
  end match;
end lm_970;

protected function fun_971
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_a_vars_boolParamVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_vars_boolParamVars)
    local
      Tpl.Text txt;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
      then txt;
  end match;
end fun_971;

protected function lm_972
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_arrayInit;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_arrayInit;
algorithm
  (out_txt, out_a_arrayInit) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_arrayInit)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_arrayInit;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _,
           a_arrayInit )
      then (txt, a_arrayInit);

    case ( txt,
           i_var :: rest,
           a_useFlatArrayNotation,
           a_arrayInit )
      equation
        (txt, a_arrayInit) = initAlgloopParam(txt, i_var, "boolVariables.AliasVars", a_arrayInit, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_arrayInit) = lm_972(txt, rest, a_useFlatArrayNotation, a_arrayInit);
      then (txt, a_arrayInit);
  end match;
end lm_972;

protected function fun_973
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_a_vars_boolAliasVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_vars_boolAliasVars)
    local
      Tpl.Text txt;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
      then txt;
  end match;
end fun_973;

protected function fun_974
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_a_vars_stringAlgVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_vars_stringAlgVars)
    local
      Tpl.Text txt;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
      then txt;
  end match;
end fun_974;

protected function lm_975
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_arrayInit;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_arrayInit;
algorithm
  (out_txt, out_a_arrayInit) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_arrayInit)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_arrayInit;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _,
           a_arrayInit )
      then (txt, a_arrayInit);

    case ( txt,
           i_var :: rest,
           a_useFlatArrayNotation,
           a_arrayInit )
      equation
        (txt, a_arrayInit) = initAlgloopParam(txt, i_var, "stringVariables.algebraics", a_arrayInit, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_arrayInit) = lm_975(txt, rest, a_useFlatArrayNotation, a_arrayInit);
      then (txt, a_arrayInit);
  end match;
end lm_975;

protected function fun_976
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_a_vars_stringAlgVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_vars_stringAlgVars)
    local
      Tpl.Text txt;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
      then txt;
  end match;
end fun_976;

protected function lm_977
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_arrayInit;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_arrayInit;
algorithm
  (out_txt, out_a_arrayInit) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_arrayInit)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_arrayInit;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _,
           a_arrayInit )
      then (txt, a_arrayInit);

    case ( txt,
           i_var :: rest,
           a_useFlatArrayNotation,
           a_arrayInit )
      equation
        (txt, a_arrayInit) = initAlgloopParam(txt, i_var, "stringVariables.parameters", a_arrayInit, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_arrayInit) = lm_977(txt, rest, a_useFlatArrayNotation, a_arrayInit);
      then (txt, a_arrayInit);
  end match;
end lm_977;

protected function fun_978
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_a_vars_stringParamVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_vars_stringParamVars)
    local
      Tpl.Text txt;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
      then txt;
  end match;
end fun_978;

protected function lm_979
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_arrayInit;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_arrayInit;
algorithm
  (out_txt, out_a_arrayInit) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_arrayInit)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_arrayInit;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _,
           a_arrayInit )
      then (txt, a_arrayInit);

    case ( txt,
           i_var :: rest,
           a_useFlatArrayNotation,
           a_arrayInit )
      equation
        (txt, a_arrayInit) = initAlgloopParam(txt, i_var, "stringVariables.AliasVars", a_arrayInit, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_arrayInit) = lm_979(txt, rest, a_useFlatArrayNotation, a_arrayInit);
      then (txt, a_arrayInit);
  end match;
end lm_979;

protected function fun_980
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_a_vars_stringAliasVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_vars_stringAliasVars)
    local
      Tpl.Text txt;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
      then txt;
  end match;
end fun_980;

public function initAlgloopParams
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;
  input Tpl.Text in_a_arrayInit;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_arrayInit;
algorithm
  (out_txt, out_a_arrayInit) :=
  match(in_txt, in_a_modelInfo, in_a_arrayInit, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      Tpl.Text a_arrayInit;
      Boolean a_useFlatArrayNotation;
      list<SimCodeVar.SimVar> i_vars_stringAliasVars;
      list<SimCodeVar.SimVar> i_vars_stringParamVars;
      list<SimCodeVar.SimVar> i_vars_stringAlgVars;
      list<SimCodeVar.SimVar> i_vars_boolAliasVars;
      list<SimCodeVar.SimVar> i_vars_boolParamVars;
      list<SimCodeVar.SimVar> i_vars_boolAlgVars;
      list<SimCodeVar.SimVar> i_vars_intAliasVars;
      list<SimCodeVar.SimVar> i_vars_intParamVars;
      list<SimCodeVar.SimVar> i_vars_intAlgVars;
      list<SimCodeVar.SimVar> i_vars_aliasVars;
      list<SimCodeVar.SimVar> i_vars_paramVars;
      list<SimCodeVar.SimVar> i_vars_discreteAlgVars;
      list<SimCodeVar.SimVar> i_vars_algVars;

    case ( txt,
           SimCode.MODELINFO(vars = SimCodeVar.SIMVARS(algVars = i_vars_algVars, discreteAlgVars = i_vars_discreteAlgVars, paramVars = i_vars_paramVars, aliasVars = i_vars_aliasVars, intAlgVars = i_vars_intAlgVars, intParamVars = i_vars_intParamVars, intAliasVars = i_vars_intAliasVars, boolAlgVars = i_vars_boolAlgVars, boolParamVars = i_vars_boolParamVars, boolAliasVars = i_vars_boolAliasVars, stringAlgVars = i_vars_stringAlgVars, stringParamVars = i_vars_stringParamVars, stringAliasVars = i_vars_stringAliasVars)),
           a_arrayInit,
           a_useFlatArrayNotation )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("  /* vars.algVars */\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_arrayInit) = lm_954(txt, i_vars_algVars, a_useFlatArrayNotation, a_arrayInit);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = fun_955(txt, i_vars_algVars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/* vars.discreteAlgVars */\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_arrayInit) = lm_956(txt, i_vars_discreteAlgVars, a_useFlatArrayNotation, a_arrayInit);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = fun_957(txt, i_vars_discreteAlgVars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" /* vars.paramVars */\n"));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_arrayInit) = lm_958(txt, i_vars_paramVars, a_useFlatArrayNotation, a_arrayInit);
        txt = Tpl.popIter(txt);
        txt = fun_959(txt, i_vars_paramVars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" /* vars.aliasVars */\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_arrayInit) = lm_960(txt, i_vars_aliasVars, a_useFlatArrayNotation, a_arrayInit);
        txt = Tpl.popIter(txt);
        txt = fun_961(txt, i_vars_aliasVars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/* vars.intAlgVars */\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_arrayInit) = lm_962(txt, i_vars_intAlgVars, a_useFlatArrayNotation, a_arrayInit);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = fun_963(txt, i_vars_intAlgVars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" /* vars.intParamVars */\n"));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_arrayInit) = lm_964(txt, i_vars_intParamVars, a_useFlatArrayNotation, a_arrayInit);
        txt = Tpl.popIter(txt);
        txt = fun_965(txt, i_vars_intParamVars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" /* vars.intAliasVars */\n"));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_arrayInit) = lm_966(txt, i_vars_intAliasVars, a_useFlatArrayNotation, a_arrayInit);
        txt = Tpl.popIter(txt);
        txt = fun_967(txt, i_vars_intAliasVars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" /* vars.boolAlgVars */\n"));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_arrayInit) = lm_968(txt, i_vars_boolAlgVars, a_useFlatArrayNotation, a_arrayInit);
        txt = Tpl.popIter(txt);
        txt = fun_969(txt, i_vars_boolAlgVars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" /* vars.boolParamVars */\n"));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_arrayInit) = lm_970(txt, i_vars_boolParamVars, a_useFlatArrayNotation, a_arrayInit);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = fun_971(txt, i_vars_boolParamVars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" /* vars.boolAliasVars */\n"));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_arrayInit) = lm_972(txt, i_vars_boolAliasVars, a_useFlatArrayNotation, a_arrayInit);
        txt = Tpl.popIter(txt);
        txt = fun_973(txt, i_vars_boolAliasVars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" /* vars.stringAlgVars */\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = fun_974(txt, i_vars_stringAlgVars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_arrayInit) = lm_975(txt, i_vars_stringAlgVars, a_useFlatArrayNotation, a_arrayInit);
        txt = Tpl.popIter(txt);
        txt = fun_976(txt, i_vars_stringAlgVars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" /* vars.stringParamVars */\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_arrayInit) = lm_977(txt, i_vars_stringParamVars, a_useFlatArrayNotation, a_arrayInit);
        txt = Tpl.popIter(txt);
        txt = fun_978(txt, i_vars_stringParamVars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/* vars.stringAliasVars */\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_arrayInit) = lm_979(txt, i_vars_stringAliasVars, a_useFlatArrayNotation, a_arrayInit);
        txt = Tpl.popIter(txt);
        txt = fun_980(txt, i_vars_stringAliasVars);
        txt = Tpl.popBlock(txt);
      then (txt, a_arrayInit);

    case ( txt,
           _,
           a_arrayInit,
           _ )
      then (txt, a_arrayInit);
  end match;
end initAlgloopParams;

protected function fun_982
  input Tpl.Text in_txt;
  input String in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           "0" )
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_982;

protected function fun_983
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_a_simVar;
  input String in_a_type;
  input String in_a_pre;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simVar, in_a_type, in_a_pre, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      String a_type;
      String a_pre;
      Boolean a_useFlatArrayNotation;
      list<String> i_num;
      DAE.Type i_type__;
      DAE.ComponentRef i_name;
      String str_5;
      Tpl.Text l_varType;
      Tpl.Text l_varName;
      Tpl.Text l_dims;
      Integer ret_1;
      Integer ret_0;

    case ( txt,
           SimCodeVar.SIMVAR(numArrayElement = {}, arrayCref = NONE(), name = DAE.CREF_IDENT(subscriptLst = _ :: _)),
           _,
           _,
           _ )
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(numArrayElement = {}, name = i_name),
           a_type,
           a_pre,
           a_useFlatArrayNotation )
      equation
        txt = Tpl.writeStr(txt, a_type);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("& "));
        txt = Tpl.writeStr(txt, a_pre);
        txt = CodegenCppCommonOld.cref(txt, i_name, a_useFlatArrayNotation);
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(name = (i_name as DAE.CREF_IDENT(ident = _)), arrayCref = SOME(_), numArrayElement = i_num, type_ = i_type__),
           _,
           a_pre,
           a_useFlatArrayNotation )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("multi_array<"));
        txt = variableType(txt, i_type__);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        ret_0 = listLength(i_num);
        txt = Tpl.writeStr(txt, intString(ret_0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(">& "));
        txt = Tpl.writeStr(txt, a_pre);
        txt = CodegenCppCommonOld.arraycref(txt, i_name, a_useFlatArrayNotation);
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(name = (i_name as DAE.CREF_QUAL(ident = _)), arrayCref = SOME(_), numArrayElement = i_num, type_ = i_type__),
           _,
           a_pre,
           a_useFlatArrayNotation )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("multi_array<"));
        txt = variableType(txt, i_type__);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        ret_1 = listLength(i_num);
        txt = Tpl.writeStr(txt, intString(ret_1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(">& "));
        txt = Tpl.writeStr(txt, a_pre);
        txt = CodegenCppCommonOld.arraycref(txt, i_name, a_useFlatArrayNotation);
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(numArrayElement = _ :: _, name = i_name, type_ = i_type__),
           _,
           _,
           _ )
      equation
        l_dims = Tpl.emptyTxt;
        (l_varName, l_dims) = CodegenCppCommonOld.arraycref2(Tpl.emptyTxt, i_name, l_dims);
        l_varType = variableType(Tpl.emptyTxt, i_type__);
        str_5 = Tpl.textString(l_dims);
        txt = fun_982(txt, str_5);
      then txt;

    case ( txt,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_983;

public function memberVariableDefineReference
  input Tpl.Text txt;
  input String a_type;
  input SimCodeVar.SimVar a_simVar;
  input String a_arrayName;
  input String a_pre;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_983(txt, a_simVar, a_type, a_pre, a_useFlatArrayNotation);
end memberVariableDefineReference;

protected function fun_985
  input Tpl.Text in_txt;
  input Boolean in_a_createRefVar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_createRefVar)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("&"));
      then txt;
  end match;
end fun_985;

protected function fun_986
  input Tpl.Text in_txt;
  input Boolean in_a_createRefVar;
  input String in_a_type;
  input Tpl.Text in_a_indexForUndefinedReferences;
  input HashTableCrIListArray.HashTable in_a_varToArrayIndexMapping;
  input Boolean in_a_useFlatArrayNotation;
  input DAE.ComponentRef in_a_name;
  input DAE.Type in_a_type__;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_createRefVar, in_a_type, in_a_indexForUndefinedReferences, in_a_varToArrayIndexMapping, in_a_useFlatArrayNotation, in_a_name, in_a_type__)
    local
      Tpl.Text txt;
      String a_type;
      Tpl.Text a_indexForUndefinedReferences;
      HashTableCrIListArray.HashTable a_varToArrayIndexMapping;
      Boolean a_useFlatArrayNotation;
      DAE.ComponentRef a_name;
      DAE.Type a_type__;
      String ret_2;
      list<String> ret_1;
      Tpl.Text l_index;

    case ( txt,
           false,
           _,
           _,
           _,
           a_useFlatArrayNotation,
           a_name,
           a_type__ )
      equation
        txt = variableType(txt, a_type__);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = CodegenCppCommonOld.cref(txt, a_name, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           _,
           a_type,
           a_indexForUndefinedReferences,
           a_varToArrayIndexMapping,
           a_useFlatArrayNotation,
           a_name,
           _ )
      equation
        ret_1 = SimCodeUtil.getVarIndexListByMapping(a_varToArrayIndexMapping, a_name, true, Tpl.textString(a_indexForUndefinedReferences));
        ret_2 = listHead(ret_1);
        l_index = Tpl.writeStr(Tpl.emptyTxt, ret_2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#define "));
        txt = CodegenCppCommonOld.cref(txt, a_name, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" _pointerTo"));
        txt = Tpl.writeStr(txt, a_type);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Vars["));
        txt = Tpl.writeText(txt, l_index);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("]"));
      then txt;
  end match;
end fun_986;

protected function fun_987
  input Tpl.Text in_txt;
  input Boolean in_a_createDebugCode;
  input String in_a_type;
  input Tpl.Text in_a_indexForUndefinedReferences;
  input HashTableCrIListArray.HashTable in_a_varToArrayIndexMapping;
  input Boolean in_a_useFlatArrayNotation;
  input DAE.ComponentRef in_a_name;
  input Boolean in_a_createRefVar;
  input DAE.Type in_a_type__;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_createDebugCode, in_a_type, in_a_indexForUndefinedReferences, in_a_varToArrayIndexMapping, in_a_useFlatArrayNotation, in_a_name, in_a_createRefVar, in_a_type__)
    local
      Tpl.Text txt;
      String a_type;
      Tpl.Text a_indexForUndefinedReferences;
      HashTableCrIListArray.HashTable a_varToArrayIndexMapping;
      Boolean a_useFlatArrayNotation;
      DAE.ComponentRef a_name;
      Boolean a_createRefVar;
      DAE.Type a_type__;

    case ( txt,
           true,
           _,
           _,
           _,
           a_useFlatArrayNotation,
           a_name,
           a_createRefVar,
           a_type__ )
      equation
        txt = variableType(txt, a_type__);
        txt = fun_985(txt, a_createRefVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = CodegenCppCommonOld.cref(txt, a_name, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           _,
           a_type,
           a_indexForUndefinedReferences,
           a_varToArrayIndexMapping,
           a_useFlatArrayNotation,
           a_name,
           a_createRefVar,
           a_type__ )
      equation
        txt = fun_986(txt, a_createRefVar, a_type, a_indexForUndefinedReferences, a_varToArrayIndexMapping, a_useFlatArrayNotation, a_name, a_type__);
      then txt;
  end match;
end fun_987;

protected function fun_988
  input Tpl.Text in_txt;
  input Boolean in_a_createRefVar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_createRefVar)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("&"));
      then txt;
  end match;
end fun_988;

protected function fun_989
  input Tpl.Text in_txt;
  input Boolean in_a_createRefVar;
  input String in_a_type;
  input Tpl.Text in_a_indexForUndefinedReferences;
  input DAE.ComponentRef in_a_name;
  input HashTableCrIListArray.HashTable in_a_varToArrayIndexMapping;
  input Tpl.Text in_a_arrayName;
  input Tpl.Text in_a_typeString;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_createRefVar, in_a_type, in_a_indexForUndefinedReferences, in_a_name, in_a_varToArrayIndexMapping, in_a_arrayName, in_a_typeString)
    local
      Tpl.Text txt;
      String a_type;
      Tpl.Text a_indexForUndefinedReferences;
      DAE.ComponentRef a_name;
      HashTableCrIListArray.HashTable a_varToArrayIndexMapping;
      Tpl.Text a_arrayName;
      Tpl.Text a_typeString;
      String ret_2;
      list<String> ret_1;
      Tpl.Text l_index;

    case ( txt,
           false,
           _,
           _,
           _,
           _,
           a_arrayName,
           a_typeString )
      equation
        txt = Tpl.writeText(txt, a_typeString);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, a_arrayName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           _,
           a_type,
           a_indexForUndefinedReferences,
           a_name,
           a_varToArrayIndexMapping,
           a_arrayName,
           _ )
      equation
        ret_1 = SimCodeUtil.getVarIndexListByMapping(a_varToArrayIndexMapping, a_name, true, Tpl.textString(a_indexForUndefinedReferences));
        ret_2 = listHead(ret_1);
        l_index = Tpl.writeStr(Tpl.emptyTxt, ret_2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#define "));
        txt = Tpl.writeText(txt, a_arrayName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" _pointerTo"));
        txt = Tpl.writeStr(txt, a_type);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Vars["));
        txt = Tpl.writeText(txt, l_index);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("]"));
      then txt;
  end match;
end fun_989;

protected function fun_990
  input Tpl.Text in_txt;
  input Boolean in_a_createDebugCode;
  input String in_a_type;
  input Tpl.Text in_a_indexForUndefinedReferences;
  input DAE.ComponentRef in_a_name;
  input HashTableCrIListArray.HashTable in_a_varToArrayIndexMapping;
  input Tpl.Text in_a_arrayName;
  input Boolean in_a_createRefVar;
  input Tpl.Text in_a_typeString;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_createDebugCode, in_a_type, in_a_indexForUndefinedReferences, in_a_name, in_a_varToArrayIndexMapping, in_a_arrayName, in_a_createRefVar, in_a_typeString)
    local
      Tpl.Text txt;
      String a_type;
      Tpl.Text a_indexForUndefinedReferences;
      DAE.ComponentRef a_name;
      HashTableCrIListArray.HashTable a_varToArrayIndexMapping;
      Tpl.Text a_arrayName;
      Boolean a_createRefVar;
      Tpl.Text a_typeString;

    case ( txt,
           true,
           _,
           _,
           _,
           _,
           a_arrayName,
           a_createRefVar,
           a_typeString )
      equation
        txt = Tpl.writeText(txt, a_typeString);
        txt = fun_988(txt, a_createRefVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, a_arrayName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           _,
           a_type,
           a_indexForUndefinedReferences,
           a_name,
           a_varToArrayIndexMapping,
           a_arrayName,
           a_createRefVar,
           a_typeString )
      equation
        txt = fun_989(txt, a_createRefVar, a_type, a_indexForUndefinedReferences, a_name, a_varToArrayIndexMapping, a_arrayName, a_typeString);
      then txt;
  end match;
end fun_990;

protected function fun_991
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Boolean in_a_createRefVar;
  input Tpl.Text in_a_arrayName;
  input Tpl.Text in_a_array__dimensions;
  input Tpl.Text in_a_typeString;
  input Tpl.Text in_a_dims;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_createRefVar, in_a_arrayName, in_a_array__dimensions, in_a_typeString, in_a_dims)
    local
      Tpl.Text txt;
      Boolean a_createRefVar;
      Tpl.Text a_arrayName;
      Tpl.Text a_array__dimensions;
      Tpl.Text a_typeString;
      Tpl.Text a_dims;

    case ( txt,
           false,
           _,
           a_arrayName,
           a_array__dimensions,
           a_typeString,
           a_dims )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("RefArrayDim"));
        txt = Tpl.writeText(txt, a_dims);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<"));
        txt = Tpl.writeText(txt, a_typeString);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_array__dimensions);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("> "));
        txt = Tpl.writeText(txt, a_arrayName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           _,
           a_createRefVar,
           a_arrayName,
           a_array__dimensions,
           a_typeString,
           a_dims )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("StatArrayDim"));
        txt = Tpl.writeText(txt, a_dims);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<"));
        txt = Tpl.writeText(txt, a_typeString);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_array__dimensions);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeStr(txt, Tpl.booleanString(a_createRefVar));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("> "));
        txt = Tpl.writeText(txt, a_arrayName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_991;

protected function fun_992
  input Tpl.Text in_txt;
  input String in_mArg;
  input Tpl.Text in_a_array__dimensions;
  input Tpl.Text in_a_dims;
  input String in_a_type;
  input Tpl.Text in_a_indexForUndefinedReferences;
  input DAE.ComponentRef in_a_name;
  input HashTableCrIListArray.HashTable in_a_varToArrayIndexMapping;
  input Tpl.Text in_a_arrayName;
  input Boolean in_a_createRefVar;
  input Tpl.Text in_a_typeString;
  input Boolean in_a_createDebugCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_array__dimensions, in_a_dims, in_a_type, in_a_indexForUndefinedReferences, in_a_name, in_a_varToArrayIndexMapping, in_a_arrayName, in_a_createRefVar, in_a_typeString, in_a_createDebugCode)
    local
      Tpl.Text txt;
      Tpl.Text a_array__dimensions;
      Tpl.Text a_dims;
      String a_type;
      Tpl.Text a_indexForUndefinedReferences;
      DAE.ComponentRef a_name;
      HashTableCrIListArray.HashTable a_varToArrayIndexMapping;
      Tpl.Text a_arrayName;
      Boolean a_createRefVar;
      Tpl.Text a_typeString;
      Boolean a_createDebugCode;
      Boolean ret_0;

    case ( txt,
           "0",
           _,
           _,
           a_type,
           a_indexForUndefinedReferences,
           a_name,
           a_varToArrayIndexMapping,
           a_arrayName,
           a_createRefVar,
           a_typeString,
           a_createDebugCode )
      equation
        txt = fun_990(txt, a_createDebugCode, a_type, a_indexForUndefinedReferences, a_name, a_varToArrayIndexMapping, a_arrayName, a_createRefVar, a_typeString);
      then txt;

    case ( txt,
           _,
           a_array__dimensions,
           a_dims,
           _,
           _,
           a_name,
           a_varToArrayIndexMapping,
           a_arrayName,
           a_createRefVar,
           a_typeString,
           _ )
      equation
        ret_0 = SimCodeUtil.isVarIndexListConsecutive(a_varToArrayIndexMapping, a_name);
        txt = fun_991(txt, ret_0, a_createRefVar, a_arrayName, a_array__dimensions, a_typeString, a_dims);
      then txt;
  end match;
end fun_992;

protected function fun_993
  input Tpl.Text in_txt;
  input Boolean in_a_createRefVar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_createRefVar)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("&"));
      then txt;
  end match;
end fun_993;

protected function fun_994
  input Tpl.Text in_txt;
  input Boolean in_a_createRefVar;
  input String in_a_type;
  input Tpl.Text in_a_indexForUndefinedReferences;
  input DAE.ComponentRef in_a_name;
  input HashTableCrIListArray.HashTable in_a_varToArrayIndexMapping;
  input Tpl.Text in_a_arrayName;
  input Tpl.Text in_a_typeString;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_createRefVar, in_a_type, in_a_indexForUndefinedReferences, in_a_name, in_a_varToArrayIndexMapping, in_a_arrayName, in_a_typeString)
    local
      Tpl.Text txt;
      String a_type;
      Tpl.Text a_indexForUndefinedReferences;
      DAE.ComponentRef a_name;
      HashTableCrIListArray.HashTable a_varToArrayIndexMapping;
      Tpl.Text a_arrayName;
      Tpl.Text a_typeString;
      String ret_2;
      list<String> ret_1;
      Tpl.Text l_index;

    case ( txt,
           false,
           _,
           _,
           _,
           _,
           a_arrayName,
           a_typeString )
      equation
        txt = Tpl.writeText(txt, a_typeString);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, a_arrayName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           _,
           a_type,
           a_indexForUndefinedReferences,
           a_name,
           a_varToArrayIndexMapping,
           a_arrayName,
           _ )
      equation
        ret_1 = SimCodeUtil.getVarIndexListByMapping(a_varToArrayIndexMapping, a_name, true, Tpl.textString(a_indexForUndefinedReferences));
        ret_2 = listHead(ret_1);
        l_index = Tpl.writeStr(Tpl.emptyTxt, ret_2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#define "));
        txt = Tpl.writeText(txt, a_arrayName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" _pointerTo"));
        txt = Tpl.writeStr(txt, a_type);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Vars["));
        txt = Tpl.writeText(txt, l_index);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("]"));
      then txt;
  end match;
end fun_994;

protected function fun_995
  input Tpl.Text in_txt;
  input Boolean in_a_createDebugCode;
  input String in_a_type;
  input Tpl.Text in_a_indexForUndefinedReferences;
  input DAE.ComponentRef in_a_name;
  input HashTableCrIListArray.HashTable in_a_varToArrayIndexMapping;
  input Tpl.Text in_a_arrayName;
  input Boolean in_a_createRefVar;
  input Tpl.Text in_a_typeString;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_createDebugCode, in_a_type, in_a_indexForUndefinedReferences, in_a_name, in_a_varToArrayIndexMapping, in_a_arrayName, in_a_createRefVar, in_a_typeString)
    local
      Tpl.Text txt;
      String a_type;
      Tpl.Text a_indexForUndefinedReferences;
      DAE.ComponentRef a_name;
      HashTableCrIListArray.HashTable a_varToArrayIndexMapping;
      Tpl.Text a_arrayName;
      Boolean a_createRefVar;
      Tpl.Text a_typeString;

    case ( txt,
           true,
           _,
           _,
           _,
           _,
           a_arrayName,
           a_createRefVar,
           a_typeString )
      equation
        txt = Tpl.writeText(txt, a_typeString);
        txt = fun_993(txt, a_createRefVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, a_arrayName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           _,
           a_type,
           a_indexForUndefinedReferences,
           a_name,
           a_varToArrayIndexMapping,
           a_arrayName,
           a_createRefVar,
           a_typeString )
      equation
        txt = fun_994(txt, a_createRefVar, a_type, a_indexForUndefinedReferences, a_name, a_varToArrayIndexMapping, a_arrayName, a_typeString);
      then txt;
  end match;
end fun_995;

protected function fun_996
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Boolean in_a_createRefVar;
  input Tpl.Text in_a_arrayName;
  input Tpl.Text in_a_array__dimensions;
  input Tpl.Text in_a_typeString;
  input Tpl.Text in_a_dims;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_createRefVar, in_a_arrayName, in_a_array__dimensions, in_a_typeString, in_a_dims)
    local
      Tpl.Text txt;
      Boolean a_createRefVar;
      Tpl.Text a_arrayName;
      Tpl.Text a_array__dimensions;
      Tpl.Text a_typeString;
      Tpl.Text a_dims;

    case ( txt,
           false,
           _,
           a_arrayName,
           a_array__dimensions,
           a_typeString,
           a_dims )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("RefArrayDim"));
        txt = Tpl.writeText(txt, a_dims);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<"));
        txt = Tpl.writeText(txt, a_typeString);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_array__dimensions);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("> "));
        txt = Tpl.writeText(txt, a_arrayName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           _,
           a_createRefVar,
           a_arrayName,
           a_array__dimensions,
           a_typeString,
           a_dims )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("StatArrayDim"));
        txt = Tpl.writeText(txt, a_dims);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<"));
        txt = Tpl.writeText(txt, a_typeString);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_array__dimensions);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeStr(txt, Tpl.booleanString(a_createRefVar));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("> "));
        txt = Tpl.writeText(txt, a_arrayName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_996;

protected function fun_997
  input Tpl.Text in_txt;
  input String in_mArg;
  input Tpl.Text in_a_array__dimensions;
  input Tpl.Text in_a_dims;
  input String in_a_type;
  input Tpl.Text in_a_indexForUndefinedReferences;
  input DAE.ComponentRef in_a_name;
  input HashTableCrIListArray.HashTable in_a_varToArrayIndexMapping;
  input Tpl.Text in_a_arrayName;
  input Boolean in_a_createRefVar;
  input Tpl.Text in_a_typeString;
  input Boolean in_a_createDebugCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_array__dimensions, in_a_dims, in_a_type, in_a_indexForUndefinedReferences, in_a_name, in_a_varToArrayIndexMapping, in_a_arrayName, in_a_createRefVar, in_a_typeString, in_a_createDebugCode)
    local
      Tpl.Text txt;
      Tpl.Text a_array__dimensions;
      Tpl.Text a_dims;
      String a_type;
      Tpl.Text a_indexForUndefinedReferences;
      DAE.ComponentRef a_name;
      HashTableCrIListArray.HashTable a_varToArrayIndexMapping;
      Tpl.Text a_arrayName;
      Boolean a_createRefVar;
      Tpl.Text a_typeString;
      Boolean a_createDebugCode;
      Boolean ret_0;

    case ( txt,
           "0",
           _,
           _,
           a_type,
           a_indexForUndefinedReferences,
           a_name,
           a_varToArrayIndexMapping,
           a_arrayName,
           a_createRefVar,
           a_typeString,
           a_createDebugCode )
      equation
        txt = fun_995(txt, a_createDebugCode, a_type, a_indexForUndefinedReferences, a_name, a_varToArrayIndexMapping, a_arrayName, a_createRefVar, a_typeString);
      then txt;

    case ( txt,
           _,
           a_array__dimensions,
           a_dims,
           _,
           _,
           a_name,
           a_varToArrayIndexMapping,
           a_arrayName,
           a_createRefVar,
           a_typeString,
           _ )
      equation
        ret_0 = SimCodeUtil.isVarIndexListConsecutive(a_varToArrayIndexMapping, a_name);
        txt = fun_996(txt, ret_0, a_createRefVar, a_arrayName, a_array__dimensions, a_typeString, a_dims);
      then txt;
  end match;
end fun_997;

protected function lm_998
  input Tpl.Text in_txt;
  input list<String> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<String> rest;
      String i_it;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_it :: rest )
      equation
        txt = Tpl.writeStr(txt, i_it);
        txt = Tpl.nextIter(txt);
        txt = lm_998(txt, rest);
      then txt;
  end match;
end lm_998;

protected function fun_999
  input Tpl.Text in_txt;
  input Boolean in_a_createRefVar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_createRefVar)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("&"));
      then txt;
  end match;
end fun_999;

protected function fun_1000
  input Tpl.Text in_txt;
  input Boolean in_a_createRefVar;
  input String in_a_type;
  input Tpl.Text in_a_indexForUndefinedReferences;
  input DAE.ComponentRef in_a_name;
  input HashTableCrIListArray.HashTable in_a_varToArrayIndexMapping;
  input Tpl.Text in_a_varName;
  input Tpl.Text in_a_varType;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_createRefVar, in_a_type, in_a_indexForUndefinedReferences, in_a_name, in_a_varToArrayIndexMapping, in_a_varName, in_a_varType)
    local
      Tpl.Text txt;
      String a_type;
      Tpl.Text a_indexForUndefinedReferences;
      DAE.ComponentRef a_name;
      HashTableCrIListArray.HashTable a_varToArrayIndexMapping;
      Tpl.Text a_varName;
      Tpl.Text a_varType;
      String ret_2;
      list<String> ret_1;
      Tpl.Text l_index;

    case ( txt,
           false,
           _,
           _,
           _,
           _,
           a_varName,
           a_varType )
      equation
        txt = Tpl.writeText(txt, a_varType);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, a_varName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           _,
           a_type,
           a_indexForUndefinedReferences,
           a_name,
           a_varToArrayIndexMapping,
           a_varName,
           _ )
      equation
        ret_1 = SimCodeUtil.getVarIndexListByMapping(a_varToArrayIndexMapping, a_name, true, Tpl.textString(a_indexForUndefinedReferences));
        ret_2 = listHead(ret_1);
        l_index = Tpl.writeStr(Tpl.emptyTxt, ret_2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#define "));
        txt = Tpl.writeText(txt, a_varName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" _pointerTo"));
        txt = Tpl.writeStr(txt, a_type);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Vars["));
        txt = Tpl.writeText(txt, l_index);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("]"));
      then txt;
  end match;
end fun_1000;

protected function fun_1001
  input Tpl.Text in_txt;
  input Boolean in_a_createDebugCode;
  input String in_a_type;
  input Tpl.Text in_a_indexForUndefinedReferences;
  input DAE.ComponentRef in_a_name;
  input HashTableCrIListArray.HashTable in_a_varToArrayIndexMapping;
  input Tpl.Text in_a_varName;
  input Boolean in_a_createRefVar;
  input Tpl.Text in_a_varType;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_createDebugCode, in_a_type, in_a_indexForUndefinedReferences, in_a_name, in_a_varToArrayIndexMapping, in_a_varName, in_a_createRefVar, in_a_varType)
    local
      Tpl.Text txt;
      String a_type;
      Tpl.Text a_indexForUndefinedReferences;
      DAE.ComponentRef a_name;
      HashTableCrIListArray.HashTable a_varToArrayIndexMapping;
      Tpl.Text a_varName;
      Boolean a_createRefVar;
      Tpl.Text a_varType;

    case ( txt,
           true,
           _,
           _,
           _,
           _,
           a_varName,
           a_createRefVar,
           a_varType )
      equation
        txt = Tpl.writeText(txt, a_varType);
        txt = fun_999(txt, a_createRefVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, a_varName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           _,
           a_type,
           a_indexForUndefinedReferences,
           a_name,
           a_varToArrayIndexMapping,
           a_varName,
           a_createRefVar,
           a_varType )
      equation
        txt = fun_1000(txt, a_createRefVar, a_type, a_indexForUndefinedReferences, a_name, a_varToArrayIndexMapping, a_varName, a_varType);
      then txt;
  end match;
end fun_1001;

protected function fun_1002
  input Tpl.Text in_txt;
  input String in_mArg;
  input String in_a_type;
  input Tpl.Text in_a_indexForUndefinedReferences;
  input DAE.ComponentRef in_a_name;
  input HashTableCrIListArray.HashTable in_a_varToArrayIndexMapping;
  input Tpl.Text in_a_varName;
  input Boolean in_a_createRefVar;
  input Tpl.Text in_a_varType;
  input Boolean in_a_createDebugCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_type, in_a_indexForUndefinedReferences, in_a_name, in_a_varToArrayIndexMapping, in_a_varName, in_a_createRefVar, in_a_varType, in_a_createDebugCode)
    local
      Tpl.Text txt;
      String a_type;
      Tpl.Text a_indexForUndefinedReferences;
      DAE.ComponentRef a_name;
      HashTableCrIListArray.HashTable a_varToArrayIndexMapping;
      Tpl.Text a_varName;
      Boolean a_createRefVar;
      Tpl.Text a_varType;
      Boolean a_createDebugCode;

    case ( txt,
           "0",
           a_type,
           a_indexForUndefinedReferences,
           a_name,
           a_varToArrayIndexMapping,
           a_varName,
           a_createRefVar,
           a_varType,
           a_createDebugCode )
      equation
        txt = fun_1001(txt, a_createDebugCode, a_type, a_indexForUndefinedReferences, a_name, a_varToArrayIndexMapping, a_varName, a_createRefVar, a_varType);
      then txt;

    case ( txt,
           _,
           _,
           _,
           _,
           _,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_1002;

protected function fun_1003
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_a_simVar;
  input HashTableCrIListArray.HashTable in_a_varToArrayIndexMapping;
  input Tpl.Text in_a_indexForUndefinedReferences;
  input Boolean in_a_useFlatArrayNotation;
  input Boolean in_a_createDebugCode;
  input String in_a_type;
  input Boolean in_a_createRefVar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simVar, in_a_varToArrayIndexMapping, in_a_indexForUndefinedReferences, in_a_useFlatArrayNotation, in_a_createDebugCode, in_a_type, in_a_createRefVar)
    local
      Tpl.Text txt;
      HashTableCrIListArray.HashTable a_varToArrayIndexMapping;
      Tpl.Text a_indexForUndefinedReferences;
      Boolean a_useFlatArrayNotation;
      Boolean a_createDebugCode;
      String a_type;
      Boolean a_createRefVar;
      list<String> i_v_numArrayElement;
      DAE.ComponentRef i_name;
      DAE.Type i_type__;
      String str_11;
      Tpl.Text l_varType;
      list<String> ret_9;
      Integer ret_8;
      Integer ret_7;
      Tpl.Text l_varName;
      String str_5;
      String str_4;
      Tpl.Text l_array__dimensions;
      Tpl.Text l_typeString;
      Tpl.Text l_arrayName;
      Tpl.Text l_dims;

    case ( txt,
           SimCodeVar.SIMVAR(numArrayElement = {}, arrayCref = NONE(), name = DAE.CREF_IDENT(subscriptLst = _ :: _)),
           _,
           _,
           _,
           _,
           _,
           _ )
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(numArrayElement = {}, arrayCref = NONE(), name = i_name, type_ = i_type__),
           a_varToArrayIndexMapping,
           a_indexForUndefinedReferences,
           a_useFlatArrayNotation,
           a_createDebugCode,
           a_type,
           a_createRefVar )
      equation
        txt = fun_987(txt, a_createDebugCode, a_type, a_indexForUndefinedReferences, a_varToArrayIndexMapping, a_useFlatArrayNotation, i_name, a_createRefVar, i_type__);
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(name = (i_name as DAE.CREF_IDENT(ident = _)), arrayCref = SOME(_), numArrayElement = i_v_numArrayElement, type_ = i_type__),
           a_varToArrayIndexMapping,
           a_indexForUndefinedReferences,
           _,
           a_createDebugCode,
           a_type,
           a_createRefVar )
      equation
        l_dims = Tpl.emptyTxt;
        (l_arrayName, l_dims) = CodegenCppCommonOld.arraycref2(Tpl.emptyTxt, i_name, l_dims);
        l_typeString = variableType(Tpl.emptyTxt, i_type__);
        l_array__dimensions = arrayextentDims(Tpl.emptyTxt, i_name, i_v_numArrayElement);
        str_4 = Tpl.textString(l_dims);
        txt = fun_992(txt, str_4, l_array__dimensions, l_dims, a_type, a_indexForUndefinedReferences, i_name, a_varToArrayIndexMapping, l_arrayName, a_createRefVar, l_typeString, a_createDebugCode);
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(name = (i_name as DAE.CREF_QUAL(ident = _)), arrayCref = SOME(_), numArrayElement = i_v_numArrayElement, type_ = i_type__),
           a_varToArrayIndexMapping,
           a_indexForUndefinedReferences,
           _,
           a_createDebugCode,
           a_type,
           a_createRefVar )
      equation
        l_dims = Tpl.emptyTxt;
        (l_arrayName, l_dims) = CodegenCppCommonOld.arraycref2(Tpl.emptyTxt, i_name, l_dims);
        l_typeString = variableType(Tpl.emptyTxt, i_type__);
        l_array__dimensions = arrayextentDims(Tpl.emptyTxt, i_name, i_v_numArrayElement);
        str_5 = Tpl.textString(l_dims);
        txt = fun_997(txt, str_5, l_array__dimensions, l_dims, a_type, a_indexForUndefinedReferences, i_name, a_varToArrayIndexMapping, l_arrayName, a_createRefVar, l_typeString, a_createDebugCode);
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(type_ = (i_type__ as DAE.T_ARRAY(ty = _)), name = i_name, numArrayElement = i_v_numArrayElement),
           _,
           _,
           _,
           _,
           _,
           a_createRefVar )
      equation
        l_dims = Tpl.emptyTxt;
        (l_varName, l_dims) = CodegenCppCommonOld.arraycref2(Tpl.emptyTxt, i_name, l_dims);
        l_typeString = CodegenCppCommonOld.expTypeShort(Tpl.emptyTxt, i_type__);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("StatArrayDim"));
        ret_7 = listLength(i_v_numArrayElement);
        txt = Tpl.writeStr(txt, intString(ret_7));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<"));
        txt = Tpl.writeText(txt, l_typeString);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        ret_8 = listLength(i_v_numArrayElement);
        ret_9 = List.lastN(i_v_numArrayElement, ret_8);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_998(txt, ret_9);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeStr(txt, Tpl.booleanString(a_createRefVar));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("> "));
        txt = Tpl.writeText(txt, l_varName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(numArrayElement = _ :: _, name = i_name, type_ = i_type__),
           a_varToArrayIndexMapping,
           a_indexForUndefinedReferences,
           _,
           a_createDebugCode,
           a_type,
           a_createRefVar )
      equation
        l_dims = Tpl.emptyTxt;
        (l_varName, l_dims) = CodegenCppCommonOld.arraycref2(Tpl.emptyTxt, i_name, l_dims);
        l_varType = variableType(Tpl.emptyTxt, i_type__);
        str_11 = Tpl.textString(l_dims);
        txt = fun_1002(txt, str_11, a_type, a_indexForUndefinedReferences, i_name, a_varToArrayIndexMapping, l_varName, a_createRefVar, l_varType, a_createDebugCode);
      then txt;

    case ( txt,
           _,
           _,
           _,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_1003;

public function memberVariableDefine2
  input Tpl.Text txt;
  input SimCodeVar.SimVar a_simVar;
  input HashTableCrIListArray.HashTable a_varToArrayIndexMapping;
  input Tpl.Text a_indexForUndefinedReferences;
  input Boolean a_useFlatArrayNotation;
  input Boolean a_createDebugCode;
  input String a_type;
  input Boolean a_createRefVar;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_indexForUndefinedReferences;
algorithm
  out_txt := fun_1003(txt, a_simVar, a_varToArrayIndexMapping, a_indexForUndefinedReferences, a_useFlatArrayNotation, a_createDebugCode, a_type, a_createRefVar);
  out_a_indexForUndefinedReferences := a_indexForUndefinedReferences;
end memberVariableDefine2;

protected function fun_1005
  input Tpl.Text in_txt;
  input String in_mArg;
  input Tpl.Text in_a_varName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_varName)
    local
      Tpl.Text txt;
      Tpl.Text a_varName;

    case ( txt,
           "0",
           a_varName )
      equation
        txt = Tpl.writeText(txt, a_varName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(_"));
        txt = Tpl.writeText(txt, a_varName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_1005;

protected function fun_1006
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_a_simVar;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simVar, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      DAE.ComponentRef i_name;
      String str_2;
      Tpl.Text l_varName;
      Tpl.Text l_dims;

    case ( txt,
           SimCodeVar.SIMVAR(numArrayElement = {}, name = i_name),
           a_useFlatArrayNotation )
      equation
        txt = CodegenCppCommonOld.cref(txt, i_name, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(_"));
        txt = CodegenCppCommonOld.cref(txt, i_name, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(name = (i_name as DAE.CREF_IDENT(ident = _)), arrayCref = SOME(_), numArrayElement = _),
           a_useFlatArrayNotation )
      equation
        txt = CodegenCppCommonOld.arraycref(txt, i_name, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(_"));
        txt = CodegenCppCommonOld.arraycref(txt, i_name, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(name = (i_name as DAE.CREF_QUAL(ident = _)), arrayCref = SOME(_), numArrayElement = _),
           a_useFlatArrayNotation )
      equation
        txt = CodegenCppCommonOld.arraycref(txt, i_name, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("( _"));
        txt = CodegenCppCommonOld.arraycref(txt, i_name, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(numArrayElement = _ :: _, name = i_name),
           _ )
      equation
        l_dims = Tpl.emptyTxt;
        (l_varName, l_dims) = CodegenCppCommonOld.arraycref2(Tpl.emptyTxt, i_name, l_dims);
        str_2 = Tpl.textString(l_dims);
        txt = fun_1005(txt, str_2, l_varName);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_1006;

public function initAlgloopParam
  input Tpl.Text txt;
  input SimCodeVar.SimVar a_simVar;
  input String a_arrayName;
  input Tpl.Text a_arrayInit;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_arrayInit;
algorithm
  out_txt := fun_1006(txt, a_simVar, a_useFlatArrayNotation);
  out_a_arrayInit := a_arrayInit;
end initAlgloopParam;

protected function fun_1008
  input Tpl.Text in_txt;
  input String in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           "0" )
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_1008;

protected function fun_1009
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_a_simVar;
  input String in_a_pre;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simVar, in_a_pre, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      String a_pre;
      Boolean a_useFlatArrayNotation;
      list<String> i_num;
      DAE.ComponentRef i_name;
      DAE.Type i_type__;
      String str_5;
      Tpl.Text l_varType;
      Tpl.Text l_varName;
      Tpl.Text l_dims;
      Integer ret_1;
      Integer ret_0;

    case ( txt,
           SimCodeVar.SIMVAR(numArrayElement = {}, type_ = i_type__, name = i_name),
           a_pre,
           a_useFlatArrayNotation )
      equation
        txt = variableType(txt, i_type__);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("& "));
        txt = Tpl.writeStr(txt, a_pre);
        txt = CodegenCppCommonOld.cref(txt, i_name, a_useFlatArrayNotation);
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(name = (i_name as DAE.CREF_IDENT(ident = _)), arrayCref = SOME(_), numArrayElement = i_num, type_ = i_type__),
           a_pre,
           a_useFlatArrayNotation )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("multi_array<"));
        txt = variableType(txt, i_type__);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        ret_0 = listLength(i_num);
        txt = Tpl.writeStr(txt, intString(ret_0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(">& "));
        txt = Tpl.writeStr(txt, a_pre);
        txt = CodegenCppCommonOld.arraycref(txt, i_name, a_useFlatArrayNotation);
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(name = (i_name as DAE.CREF_QUAL(ident = _)), arrayCref = SOME(_), numArrayElement = i_num, type_ = i_type__),
           a_pre,
           a_useFlatArrayNotation )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("multi_array<"));
        txt = variableType(txt, i_type__);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        ret_1 = listLength(i_num);
        txt = Tpl.writeStr(txt, intString(ret_1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(">& "));
        txt = Tpl.writeStr(txt, a_pre);
        txt = CodegenCppCommonOld.arraycref(txt, i_name, a_useFlatArrayNotation);
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(numArrayElement = _ :: _, name = i_name, type_ = i_type__),
           _,
           _ )
      equation
        l_dims = Tpl.emptyTxt;
        (l_varName, l_dims) = CodegenCppCommonOld.arraycref2(Tpl.emptyTxt, i_name, l_dims);
        l_varType = variableType(Tpl.emptyTxt, i_type__);
        str_5 = Tpl.textString(l_dims);
        txt = fun_1008(txt, str_5);
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_1009;

public function memberVariableDefineReference2
  input Tpl.Text txt;
  input SimCodeVar.SimVar a_simVar;
  input String a_arrayName;
  input String a_pre;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_1009(txt, a_simVar, a_pre, a_useFlatArrayNotation);
end memberVariableDefineReference2;

public function arrayConstruct
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      list<SimCodeVar.SimVar> i_vars_stringAliasVars;
      list<SimCodeVar.SimVar> i_vars_boolAliasVars;
      list<SimCodeVar.SimVar> i_vars_intAliasVars;
      list<SimCodeVar.SimVar> i_vars_aliasVars;
      list<SimCodeVar.SimVar> i_vars_stringParamVars;
      list<SimCodeVar.SimVar> i_vars_boolParamVars;
      list<SimCodeVar.SimVar> i_vars_intParamVars;
      list<SimCodeVar.SimVar> i_vars_paramVars;
      list<SimCodeVar.SimVar> i_vars_stringAlgVars;
      list<SimCodeVar.SimVar> i_vars_boolAlgVars;
      list<SimCodeVar.SimVar> i_vars_intAlgVars;
      list<SimCodeVar.SimVar> i_vars_discreteAlgVars;
      list<SimCodeVar.SimVar> i_vars_algVars;

    case ( txt,
           SimCode.MODELINFO(vars = SimCodeVar.SIMVARS(algVars = i_vars_algVars, discreteAlgVars = i_vars_discreteAlgVars, intAlgVars = i_vars_intAlgVars, boolAlgVars = i_vars_boolAlgVars, stringAlgVars = i_vars_stringAlgVars, paramVars = i_vars_paramVars, intParamVars = i_vars_intParamVars, boolParamVars = i_vars_boolParamVars, stringParamVars = i_vars_stringParamVars, aliasVars = i_vars_aliasVars, intAliasVars = i_vars_intAliasVars, boolAliasVars = i_vars_boolAliasVars, stringAliasVars = i_vars_stringAliasVars)),
           a_useFlatArrayNotation )
      equation
        txt = arrayConstruct1(txt, i_vars_algVars, a_useFlatArrayNotation);
        txt = Tpl.softNewLine(txt);
        txt = arrayConstruct1(txt, i_vars_discreteAlgVars, a_useFlatArrayNotation);
        txt = Tpl.softNewLine(txt);
        txt = arrayConstruct1(txt, i_vars_intAlgVars, a_useFlatArrayNotation);
        txt = Tpl.softNewLine(txt);
        txt = arrayConstruct1(txt, i_vars_boolAlgVars, a_useFlatArrayNotation);
        txt = Tpl.softNewLine(txt);
        txt = arrayConstruct1(txt, i_vars_stringAlgVars, a_useFlatArrayNotation);
        txt = Tpl.softNewLine(txt);
        txt = arrayConstruct1(txt, i_vars_paramVars, a_useFlatArrayNotation);
        txt = Tpl.softNewLine(txt);
        txt = arrayConstruct1(txt, i_vars_intParamVars, a_useFlatArrayNotation);
        txt = Tpl.softNewLine(txt);
        txt = arrayConstruct1(txt, i_vars_boolParamVars, a_useFlatArrayNotation);
        txt = Tpl.softNewLine(txt);
        txt = arrayConstruct1(txt, i_vars_stringParamVars, a_useFlatArrayNotation);
        txt = Tpl.softNewLine(txt);
        txt = arrayConstruct1(txt, i_vars_aliasVars, a_useFlatArrayNotation);
        txt = Tpl.softNewLine(txt);
        txt = arrayConstruct1(txt, i_vars_intAliasVars, a_useFlatArrayNotation);
        txt = Tpl.softNewLine(txt);
        txt = arrayConstruct1(txt, i_vars_boolAliasVars, a_useFlatArrayNotation);
        txt = Tpl.softNewLine(txt);
        txt = arrayConstruct1(txt, i_vars_stringAliasVars, a_useFlatArrayNotation);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end arrayConstruct;

protected function lm_1012
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(arrayCref = SOME(_), numArrayElement = _ :: _) :: rest )
      equation
        txt = Tpl.nextIter(txt);
        txt = lm_1012(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_1012(txt, rest);
      then txt;
  end match;
end lm_1012;

public function arrayConstruct1
  input Tpl.Text txt;
  input list<SimCodeVar.SimVar> a_varsLst;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
algorithm
  out_txt := Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_1012(out_txt, a_varsLst);
  out_txt := Tpl.popIter(out_txt);
end arrayConstruct1;

public function variableType
  input Tpl.Text in_txt;
  input DAE.Type in_a_type;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_type)
    local
      Tpl.Text txt;

    case ( txt,
           DAE.T_REAL(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("double"));
      then txt;

    case ( txt,
           DAE.T_STRING(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("string"));
      then txt;

    case ( txt,
           DAE.T_INTEGER(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("int"));
      then txt;

    case ( txt,
           DAE.T_BOOL(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("bool"));
      then txt;

    case ( txt,
           DAE.T_ENUMERATION(index = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("int"));
      then txt;

    case ( txt,
           DAE.T_COMPLEX(complexClassType = ClassInf.EXTERNAL_OBJ(path = _)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void*"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end variableType;

public function lastIdentOfPath
  input Tpl.Text in_txt;
  input Absyn.Path in_a_modelName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelName)
    local
      Tpl.Text txt;
      String i_name;
      Absyn.Path i_path;

    case ( txt,
           Absyn.QUALIFIED(path = i_path) )
      equation
        txt = lastIdentOfPath(txt, i_path);
      then txt;

    case ( txt,
           Absyn.IDENT(name = i_name) )
      equation
        txt = Tpl.writeStr(txt, i_name);
      then txt;

    case ( txt,
           Absyn.FULLYQUALIFIED(path = i_path) )
      equation
        txt = lastIdentOfPath(txt, i_path);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end lastIdentOfPath;

public function identOfPath
  input Tpl.Text in_txt;
  input Absyn.Path in_a_modelName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelName)
    local
      Tpl.Text txt;
      String i_name_1;
      Absyn.Path i_path;
      Absyn.Ident i_name;

    case ( txt,
           Absyn.QUALIFIED(name = i_name, path = i_path) )
      equation
        txt = Tpl.writeStr(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = lastIdentOfPath(txt, i_path);
      then txt;

    case ( txt,
           Absyn.IDENT(name = i_name_1) )
      equation
        txt = Tpl.writeStr(txt, i_name_1);
      then txt;

    case ( txt,
           Absyn.FULLYQUALIFIED(path = i_path) )
      equation
        txt = lastIdentOfPath(txt, i_path);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end identOfPath;

public function identOfPathDot
  input Tpl.Text in_txt;
  input Absyn.Path in_a_modelName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelName)
    local
      Tpl.Text txt;
      String i_name_1;
      Absyn.Path i_path;
      Absyn.Ident i_name;

    case ( txt,
           Absyn.QUALIFIED(name = i_name, path = i_path) )
      equation
        txt = Tpl.writeStr(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("."));
        txt = lastIdentOfPath(txt, i_path);
      then txt;

    case ( txt,
           Absyn.IDENT(name = i_name_1) )
      equation
        txt = Tpl.writeStr(txt, i_name_1);
      then txt;

    case ( txt,
           Absyn.FULLYQUALIFIED(path = i_path) )
      equation
        txt = lastIdentOfPath(txt, i_path);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end identOfPathDot;

protected function fun_1018
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      Absyn.Path i_modelInfo_name;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = i_modelInfo_name)) )
      equation
        txt = lastIdentOfPath(txt, i_modelInfo_name);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_1018;

public function lastIdentOfPathFromSimCode
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  out_txt := fun_1018(txt, a_simCode);
  out_a_extraFuncs := a_extraFuncs;
  out_a_extraFuncsDecl := a_extraFuncsDecl;
  out_a_extraFuncsNamespace := a_extraFuncsNamespace;
end lastIdentOfPathFromSimCode;

protected function lm_1020
  input Tpl.Text in_txt;
  input list<String> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<String> rest;
      String i_it;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_it :: rest )
      equation
        txt = Tpl.writeStr(txt, i_it);
        txt = Tpl.nextIter(txt);
        txt = lm_1020(txt, rest);
      then txt;
  end match;
end lm_1020;

public function boostextentDims
  input Tpl.Text in_txt;
  input DAE.ComponentRef in_a_cr;
  input list<String> in_a_StatArrayDims;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_cr, in_a_StatArrayDims)
    local
      Tpl.Text txt;
      list<String> a_StatArrayDims;
      DAE.ComponentRef i_c;
      list<DAE.Subscript> i_dims;
      DAE.Ident i_ident;
      list<String> ret_1;
      Integer ret_0;

    case ( txt,
           DAE.CREF_IDENT(subscriptLst = {}, ident = i_ident),
           _ )
      equation
        txt = Tpl.writeStr(txt, i_ident);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_NO_SUBS"));
      then txt;

    case ( txt,
           DAE.CREF_IDENT(subscriptLst = i_dims),
           a_StatArrayDims )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("["));
        ret_0 = listLength(i_dims);
        ret_1 = List.lastN(a_StatArrayDims, ret_0);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING("][")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_1020(txt, ret_1);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("]"));
      then txt;

    case ( txt,
           DAE.CREF_QUAL(componentRef = i_c),
           a_StatArrayDims )
      equation
        txt = boostextentDims(txt, i_c, a_StatArrayDims);
      then txt;

    case ( txt,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("CREF_NOT_IDENT_OR_QUAL"));
      then txt;
  end match;
end boostextentDims;

protected function lm_1022
  input Tpl.Text in_txt;
  input list<String> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<String> rest;
      String i_it;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_it :: rest )
      equation
        txt = Tpl.writeStr(txt, i_it);
        txt = Tpl.nextIter(txt);
        txt = lm_1022(txt, rest);
      then txt;
  end match;
end lm_1022;

public function arrayextentDims
  input Tpl.Text in_txt;
  input DAE.ComponentRef in_a_cr;
  input list<String> in_a_array;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_cr, in_a_array)
    local
      Tpl.Text txt;
      list<String> a_array;
      DAE.ComponentRef i_c;
      list<DAE.Subscript> i_dims;
      DAE.Ident i_ident;
      list<String> ret_1;
      Integer ret_0;

    case ( txt,
           DAE.CREF_IDENT(subscriptLst = {}, ident = i_ident),
           _ )
      equation
        txt = Tpl.writeStr(txt, i_ident);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_NO_SUBS"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/*hier1*/"));
      then txt;

    case ( txt,
           DAE.CREF_IDENT(subscriptLst = i_dims),
           a_array )
      equation
        ret_0 = listLength(i_dims);
        ret_1 = List.lastN(a_array, ret_0);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_1022(txt, ret_1);
        txt = Tpl.popIter(txt);
      then txt;

    case ( txt,
           DAE.CREF_QUAL(componentRef = i_c),
           a_array )
      equation
        txt = arrayextentDims(txt, i_c, a_array);
      then txt;

    case ( txt,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("CREF_NOT_IDENT_OR_QUAL"));
      then txt;
  end match;
end arrayextentDims;

protected function lm_1024
  input Tpl.Text in_txt;
  input list<String> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<String> rest;
      String i_it;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_it :: rest )
      equation
        txt = Tpl.writeStr(txt, i_it);
        txt = Tpl.nextIter(txt);
        txt = lm_1024(txt, rest);
      then txt;
  end match;
end lm_1024;

public function arrayNumElements
  input Tpl.Text in_txt;
  input DAE.ComponentRef in_a_cr;
  input list<String> in_a_array;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_cr, in_a_array)
    local
      Tpl.Text txt;
      list<String> a_array;
      DAE.ComponentRef i_c;
      list<DAE.Subscript> i_dims;
      DAE.Ident i_ident;
      list<String> ret_1;
      Integer ret_0;

    case ( txt,
           DAE.CREF_IDENT(subscriptLst = {}, ident = i_ident),
           _ )
      equation
        txt = Tpl.writeStr(txt, i_ident);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_NO_SUBS"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/*hier1*/"));
      then txt;

    case ( txt,
           DAE.CREF_IDENT(subscriptLst = i_dims),
           a_array )
      equation
        ret_0 = listLength(i_dims);
        ret_1 = List.lastN(a_array, ret_0);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_1024(txt, ret_1);
        txt = Tpl.popIter(txt);
      then txt;

    case ( txt,
           DAE.CREF_QUAL(componentRef = i_c),
           a_array )
      equation
        txt = arrayNumElements(txt, i_c, a_array);
      then txt;

    case ( txt,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("CREF_NOT_IDENT_OR_QUAL"));
      then txt;
  end match;
end arrayNumElements;

protected function lm_1026
  input Tpl.Text in_txt;
  input list<list<SimCodeVar.SimVar>> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_additionalConstVarFunctionCalls;
  input Tpl.Text in_a_className;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_additionalConstVarFunctionCalls;
  output Tpl.Text out_a_className;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsDecl, out_a_additionalConstVarFunctionCalls, out_a_className) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsDecl, in_a_additionalConstVarFunctionCalls, in_a_className, in_a_simCode)
    local
      Tpl.Text txt;
      list<list<SimCodeVar.SimVar>> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_additionalConstVarFunctionCalls;
      Tpl.Text a_className;
      SimCode.SimCode a_simCode;
      Integer x_i0;
      list<SimCodeVar.SimVar> i_varPartition;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsDecl,
           a_additionalConstVarFunctionCalls,
           a_className,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsDecl, a_additionalConstVarFunctionCalls, a_className);

    case ( txt,
           i_varPartition :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsDecl,
           a_additionalConstVarFunctionCalls,
           a_className,
           a_simCode )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        (txt, _, a_className, a_additionalConstVarFunctionCalls, a_extraFuncsDecl, a_stateDerVectorName) = initConstValsWithSplit(txt, i_varPartition, a_simCode, Tpl.stringText(intString(x_i0)), a_className, a_additionalConstVarFunctionCalls, a_extraFuncsDecl, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsDecl, a_additionalConstVarFunctionCalls, a_className) = lm_1026(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsDecl, a_additionalConstVarFunctionCalls, a_className, a_simCode);
      then (txt, a_stateDerVectorName, a_extraFuncsDecl, a_additionalConstVarFunctionCalls, a_className);
  end match;
end lm_1026;

public function simulationInitFile
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_extraFuncsDecl, out_a_stateDerVectorName) :=
  match(in_txt, in_a_simCode, in_a_extraFuncsDecl, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      SimCode.SimCode i_simCode;
      list<SimCodeVar.SimVar> i_vars_stringParamVars;
      Absyn.Path i_name;
      list<list<SimCodeVar.SimVar>> ret_3;
      Integer ret_2;
      Tpl.Text l_additionalConstVarFunctionCalls;
      Tpl.Text l_className;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(varInfo = SimCode.VARINFO(numZeroCrossings = _), vars = SimCodeVar.SIMVARS(stringParamVars = i_vars_stringParamVars), name = i_name))),
           a_extraFuncsDecl,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_className = lastIdentOfPath(Tpl.emptyTxt, i_name);
        l_additionalConstVarFunctionCalls = Tpl.emptyTxt;
        a_extraFuncsDecl = Tpl.writeTok(a_extraFuncsDecl, Tpl.ST_STRING("void initConstVals();"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "//String parameter "
                                }, false));
        ret_2 = listLength(i_vars_stringParamVars);
        txt = Tpl.writeStr(txt, intString(ret_2));
        txt = Tpl.softNewLine(txt);
        ret_3 = List.partition(i_vars_stringParamVars, 100);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_stateDerVectorName, a_extraFuncsDecl, l_additionalConstVarFunctionCalls, l_className) = lm_1026(txt, ret_3, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsDecl, l_additionalConstVarFunctionCalls, l_className, i_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "void "
                                }, false));
        txt = Tpl.writeText(txt, l_className);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::initConstVals()\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_additionalConstVarFunctionCalls);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then (txt, a_extraFuncsDecl, a_stateDerVectorName);

    case ( txt,
           _,
           a_extraFuncsDecl,
           a_stateDerVectorName,
           _ )
      then (txt, a_extraFuncsDecl, a_stateDerVectorName);
  end match;
end simulationInitFile;

protected function lm_1028
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_stateDerVectorName) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      SimCode.SimCode a_simCode;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           _ )
      then (txt, a_stateDerVectorName);

    case ( txt,
           i_var :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_simCode )
      equation
        (txt, a_stateDerVectorName) = initConstValue(txt, i_var, a_simCode, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName) = lm_1028(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_simCode);
      then (txt, a_stateDerVectorName);
  end match;
end lm_1028;

public function initConstValsWithSplit
  input Tpl.Text txt;
  input list<SimCodeVar.SimVar> a_simVars;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_idx;
  input Tpl.Text a_className;
  input Tpl.Text a_additionalFunctionCalls;
  input Tpl.Text a_additionalFunctionDefinitions;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_idx;
  output Tpl.Text out_a_className;
  output Tpl.Text out_a_additionalFunctionCalls;
  output Tpl.Text out_a_additionalFunctionDefinitions;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  out_a_additionalFunctionCalls := Tpl.pushBlock(a_additionalFunctionCalls, Tpl.BT_INDENT(2));
  out_a_additionalFunctionCalls := Tpl.writeTok(out_a_additionalFunctionCalls, Tpl.ST_STRING("initConstVals_"));
  out_a_additionalFunctionCalls := Tpl.writeText(out_a_additionalFunctionCalls, a_idx);
  out_a_additionalFunctionCalls := Tpl.writeTok(out_a_additionalFunctionCalls, Tpl.ST_STRING("();"));
  out_a_additionalFunctionCalls := Tpl.writeTok(out_a_additionalFunctionCalls, Tpl.ST_NEW_LINE());
  out_a_additionalFunctionCalls := Tpl.popBlock(out_a_additionalFunctionCalls);
  out_a_additionalFunctionDefinitions := Tpl.writeTok(a_additionalFunctionDefinitions, Tpl.ST_STRING("void initConstVals_"));
  out_a_additionalFunctionDefinitions := Tpl.writeText(out_a_additionalFunctionDefinitions, a_idx);
  out_a_additionalFunctionDefinitions := Tpl.writeTok(out_a_additionalFunctionDefinitions, Tpl.ST_STRING("();"));
  out_a_additionalFunctionDefinitions := Tpl.writeTok(out_a_additionalFunctionDefinitions, Tpl.ST_NEW_LINE());
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING("void "));
  out_txt := Tpl.writeText(out_txt, a_className);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("::initConstVals_"));
  out_txt := Tpl.writeText(out_txt, a_idx);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "()\n",
                                       "{\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.pushIter(out_txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (out_txt, out_a_stateDerVectorName) := lm_1028(out_txt, a_simVars, a_useFlatArrayNotation, a_stateDerVectorName, a_simCode);
  out_txt := Tpl.popIter(out_txt);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("}"));
  out_a_idx := a_idx;
  out_a_className := a_className;
end initConstValsWithSplit;

protected function fun_1030
  input Tpl.Text in_txt;
  input DAE.Type in_a_type;
  input Boolean in_a_useFlatArrayNotation;
  input DAE.ComponentRef in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_type, in_a_useFlatArrayNotation, in_a_name)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      DAE.ComponentRef a_name;

    case ( txt,
           DAE.T_STRING(varLst = _),
           a_useFlatArrayNotation,
           a_name )
      equation
        txt = CodegenCppCommonOld.cref(txt, a_name, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = \"\";"));
      then txt;

    case ( txt,
           _,
           a_useFlatArrayNotation,
           a_name )
      equation
        txt = CodegenCppCommonOld.cref(txt, a_name, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = 0;"));
      then txt;
  end match;
end fun_1030;

protected function fun_1031
  input Tpl.Text in_txt;
  input Option<DAE.Exp> in_a_initialValue;
  input DAE.Type in_a_type;
  input Tpl.Text in_a_stateDerVectorName;
  input SimCode.SimCode in_a_simCode;
  input Boolean in_a_useFlatArrayNotation;
  input DAE.ComponentRef in_a_name;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_stateDerVectorName) :=
  match(in_txt, in_a_initialValue, in_a_type, in_a_stateDerVectorName, in_a_simCode, in_a_useFlatArrayNotation, in_a_name)
    local
      Tpl.Text txt;
      DAE.Type a_type;
      Tpl.Text a_stateDerVectorName;
      SimCode.SimCode a_simCode;
      Boolean a_useFlatArrayNotation;
      DAE.ComponentRef a_name;
      DAE.Exp i_v;

    case ( txt,
           SOME(i_v),
           _,
           a_stateDerVectorName,
           a_simCode,
           a_useFlatArrayNotation,
           a_name )
      equation
        txt = CodegenCppCommonOld.cref(txt, a_name, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        (txt, a_stateDerVectorName) = initConstValue2(txt, i_v, a_simCode, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then (txt, a_stateDerVectorName);

    case ( txt,
           _,
           a_type,
           a_stateDerVectorName,
           _,
           a_useFlatArrayNotation,
           a_name )
      equation
        txt = fun_1030(txt, a_type, a_useFlatArrayNotation, a_name);
      then (txt, a_stateDerVectorName);
  end match;
end fun_1031;

public function initConstValue
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_a_var;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_stateDerVectorName) :=
  match(in_txt, in_a_var, in_a_simCode, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      DAE.Type i_type;
      DAE.ComponentRef i_name;
      Option<DAE.Exp> i_initialValue;

    case ( txt,
           SimCodeVar.SIMVAR(numArrayElement = _ :: _),
           _,
           a_stateDerVectorName,
           _ )
      then (txt, a_stateDerVectorName);

    case ( txt,
           SimCodeVar.SIMVAR(type_ = i_type, name = i_name, initialValue = i_initialValue),
           a_simCode,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (txt, a_stateDerVectorName) = fun_1031(txt, i_initialValue, i_type, a_stateDerVectorName, a_simCode, a_useFlatArrayNotation, i_name);
      then (txt, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           a_stateDerVectorName,
           _ )
      then (txt, a_stateDerVectorName);
  end match;
end initConstValue;

protected function fun_1033
  input Tpl.Text in_txt;
  input String in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;
      String i_vStr;

    case ( txt,
           (i_vStr as "0") )
      equation
        txt = Tpl.writeStr(txt, i_vStr);
      then txt;

    case ( txt,
           (i_vStr as "0.0") )
      equation
        txt = Tpl.writeStr(txt, i_vStr);
      then txt;

    case ( txt,
           (i_vStr as "(0)") )
      equation
        txt = Tpl.writeStr(txt, i_vStr);
      then txt;

    case ( txt,
           (i_vStr as "") )
      equation
        txt = Tpl.writeStr(txt, i_vStr);
      then txt;

    case ( txt,
           i_vStr )
      equation
        txt = Tpl.writeStr(txt, i_vStr);
      then txt;
  end match;
end fun_1033;

public function initConstValue2
  input Tpl.Text in_txt;
  input DAE.Exp in_a_initialValue;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_stateDerVectorName) :=
  match(in_txt, in_a_initialValue, in_a_simCode, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      DAE.Exp i_v;
      String str_6;
      Tpl.Text txt_5;
      Tpl.Text l_extraFuncsNamespace;
      Tpl.Text l_extraFuncsDecl;
      Tpl.Text l_extraFuncs;
      Tpl.Text l_varDecls;
      Tpl.Text l_preExp;

    case ( txt,
           i_v,
           a_simCode,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_preExp = Tpl.emptyTxt;
        l_varDecls = Tpl.emptyTxt;
        l_extraFuncs = Tpl.emptyTxt;
        l_extraFuncsDecl = Tpl.emptyTxt;
        l_extraFuncsNamespace = Tpl.emptyTxt;
        (txt_5, l_preExp, l_varDecls, l_extraFuncs, l_extraFuncsDecl, l_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.daeExp(Tpl.emptyTxt, i_v, SimCodeFunction.contextOther, l_preExp, l_varDecls, a_simCode, l_extraFuncs, l_extraFuncsDecl, l_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        str_6 = Tpl.textString(txt_5);
        txt = fun_1033(txt, str_6);
      then (txt, a_stateDerVectorName);
  end match;
end initConstValue2;

public function initializeArrayElements
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace) :=
  match(in_txt, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Boolean a_useFlatArrayNotation;
      list<SimCodeVar.SimVar> i_vars_stringConstVars;
      list<SimCodeVar.SimVar> i_vars_boolConstVars;
      list<SimCodeVar.SimVar> i_vars_intConstVars;
      SimCode.SimCode i_simCode;
      list<SimCodeVar.SimVar> i_vars_constVars;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(varInfo = SimCode.VARINFO(numZeroCrossings = _), vars = SimCodeVar.SIMVARS(constVars = i_vars_constVars, intConstVars = i_vars_intConstVars, boolConstVars = i_vars_boolConstVars, stringConstVars = i_vars_stringConstVars)))),
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_useFlatArrayNotation )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = initValsArray(txt, i_vars_constVars, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_useFlatArrayNotation);
        txt = Tpl.softNewLine(txt);
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = initValsArray(txt, i_vars_intConstVars, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_useFlatArrayNotation);
        txt = Tpl.softNewLine(txt);
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = initValsArray(txt, i_vars_boolConstVars, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_useFlatArrayNotation);
        txt = Tpl.softNewLine(txt);
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = initValsArray(txt, i_vars_stringConstVars, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_useFlatArrayNotation);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);

    case ( txt,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           _ )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
  end match;
end initializeArrayElements;

protected function lm_1036
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Boolean a_useFlatArrayNotation;
      DAE.Exp i_v;
      DAE.ComponentRef i_name;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(numArrayElement = _ :: _, initialValue = SOME(i_v), name = i_name) :: rest,
           a_useFlatArrayNotation )
      equation
        txt = CodegenCppCommonOld.cref(txt, i_name, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = initVal(txt, i_v);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        txt = lm_1036(txt, rest, a_useFlatArrayNotation);
      then txt;

    case ( txt,
           _ :: rest,
           a_useFlatArrayNotation )
      equation
        txt = lm_1036(txt, rest, a_useFlatArrayNotation);
      then txt;
  end match;
end lm_1036;

public function initValsArray
  input Tpl.Text txt;
  input list<SimCodeVar.SimVar> a_varsLst;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  out_txt := Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_1036(out_txt, a_varsLst, a_useFlatArrayNotation);
  out_txt := Tpl.popIter(out_txt);
  out_a_extraFuncs := a_extraFuncs;
  out_a_extraFuncsDecl := a_extraFuncsDecl;
  out_a_extraFuncsNamespace := a_extraFuncsNamespace;
end initValsArray;

public function arrayInit
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace) :=
  match(in_txt, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Boolean a_useFlatArrayNotation;
      list<SimCodeVar.SimVar> i_vars_stringParamVars;
      list<SimCodeVar.SimVar> i_vars_boolParamVars;
      list<SimCodeVar.SimVar> i_vars_intParamVars;
      SimCode.SimCode i_simCode;
      list<SimCodeVar.SimVar> i_vars_paramVars;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(varInfo = SimCode.VARINFO(numZeroCrossings = _), vars = SimCodeVar.SIMVARS(paramVars = i_vars_paramVars, intParamVars = i_vars_intParamVars, boolParamVars = i_vars_boolParamVars, stringParamVars = i_vars_stringParamVars)))),
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_useFlatArrayNotation )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = initVals1(txt, i_vars_paramVars, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_useFlatArrayNotation);
        txt = Tpl.softNewLine(txt);
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = initVals1(txt, i_vars_intParamVars, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_useFlatArrayNotation);
        txt = Tpl.softNewLine(txt);
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = initVals1(txt, i_vars_boolParamVars, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_useFlatArrayNotation);
        txt = Tpl.softNewLine(txt);
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = initVals1(txt, i_vars_stringParamVars, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_useFlatArrayNotation);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);

    case ( txt,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           _ )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
  end match;
end arrayInit;

protected function lm_1039
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           (i_var as SimCodeVar.SIMVAR(name = _)) :: rest,
           a_useFlatArrayNotation,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = initVals2(txt, i_var, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1039(txt, rest, a_useFlatArrayNotation, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _ :: rest,
           a_useFlatArrayNotation,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1039(txt, rest, a_useFlatArrayNotation, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_1039;

public function initVals1
  input Tpl.Text txt;
  input list<SimCodeVar.SimVar> a_varsLst;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  out_txt := Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) := lm_1039(out_txt, a_varsLst, a_useFlatArrayNotation, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
  out_txt := Tpl.popIter(out_txt);
end initVals1;

protected function fun_1041
  input Tpl.Text in_txt;
  input Option<DAE.Exp> in_a_initialValue;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_initialValue)
    local
      Tpl.Text txt;
      DAE.Exp i_v;

    case ( txt,
           SOME(i_v) )
      equation
        txt = initVal(txt, i_v);
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("0"));
      then txt;
  end match;
end fun_1041;

protected function fun_1042
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_a_var;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_var, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      Option<DAE.Exp> i_initialValue;
      DAE.ComponentRef i_name;

    case ( txt,
           SimCodeVar.SIMVAR(numArrayElement = {}),
           _ )
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(name = i_name, initialValue = i_initialValue),
           a_useFlatArrayNotation )
      equation
        txt = CodegenCppCommonOld.cref(txt, i_name, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("="));
        txt = fun_1041(txt, i_initialValue);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_1042;

public function initVals2
  input Tpl.Text txt;
  input SimCodeVar.SimVar a_var;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  out_txt := fun_1042(txt, a_var, a_useFlatArrayNotation);
  out_a_extraFuncs := a_extraFuncs;
  out_a_extraFuncsDecl := a_extraFuncsDecl;
  out_a_extraFuncsNamespace := a_extraFuncsNamespace;
end initVals2;

protected function fun_1044
  input Tpl.Text in_txt;
  input Boolean in_a_bool;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_bool)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("false"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("true"));
      then txt;
  end match;
end fun_1044;

public function initVal
  input Tpl.Text in_txt;
  input DAE.Exp in_a_initialValue;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_initialValue)
    local
      Tpl.Text txt;
      Absyn.Path i_name;
      Integer i_index;
      Boolean i_bool;
      String i_string;
      Real i_real;
      Integer i_integer;
      String ret_0;

    case ( txt,
           DAE.ICONST(integer = i_integer) )
      equation
        txt = Tpl.writeStr(txt, intString(i_integer));
      then txt;

    case ( txt,
           DAE.RCONST(real = i_real) )
      equation
        txt = Tpl.writeStr(txt, realString(i_real));
      then txt;

    case ( txt,
           DAE.SCONST(string = i_string) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        ret_0 = Util.escapeModelicaStringToCString(i_string);
        txt = Tpl.writeStr(txt, ret_0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
      then txt;

    case ( txt,
           DAE.BCONST(bool = i_bool) )
      equation
        txt = fun_1044(txt, i_bool);
      then txt;

    case ( txt,
           DAE.ENUM_LITERAL(index = i_index, name = i_name) )
      equation
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/*ENUM:"));
        txt = dotPath(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("*/"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("*ERROR* initial value of unknown type"));
      then txt;
  end match;
end initVal;

public function dotPath
  input Tpl.Text in_txt;
  input Absyn.Path in_a_path;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_path)
    local
      Tpl.Text txt;
      String i_name_1;
      Absyn.Path i_path;
      Absyn.Ident i_name;

    case ( txt,
           Absyn.QUALIFIED(name = i_name, path = i_path) )
      equation
        txt = Tpl.writeStr(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("."));
        txt = dotPath(txt, i_path);
      then txt;

    case ( txt,
           Absyn.IDENT(name = i_name_1) )
      equation
        txt = Tpl.writeStr(txt, i_name_1);
      then txt;

    case ( txt,
           Absyn.FULLYQUALIFIED(path = i_path) )
      equation
        txt = dotPath(txt, i_path);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end dotPath;

protected function lm_1047
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      DAE.ComponentRef i_name;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(name = i_name) :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        txt = CodegenCppCommonOld.crefStrForWriteOutput(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        txt = Tpl.nextIter(txt);
        txt = lm_1047(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_1047(txt, rest);
      then txt;
  end match;
end lm_1047;

protected function fun_1048
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_a_vars_stateVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_vars_stateVars)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> i_vars_stateVars;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_vars_stateVars )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("names += "));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 10, 0, Tpl.ST_STRING_LIST({
                                                                                                 ";\n",
                                                                                                 " names += "
                                                                                             }, false), 0, Tpl.ST_NEW_LINE()));
        txt = lm_1047(txt, i_vars_stateVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_1048;

protected function lm_1049
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      DAE.ComponentRef i_name;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(name = i_name) :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        txt = CodegenCppCommonOld.crefStrForWriteOutput(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        txt = Tpl.nextIter(txt);
        txt = lm_1049(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_1049(txt, rest);
      then txt;
  end match;
end lm_1049;

protected function fun_1050
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_a_vars_derivativeVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_vars_derivativeVars)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> i_vars_derivativeVars;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_vars_derivativeVars )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("names += "));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 10, 0, Tpl.ST_STRING_LIST({
                                                                                                 ";\n",
                                                                                                 " names += "
                                                                                             }, false), 0, Tpl.ST_NEW_LINE()));
        txt = lm_1049(txt, i_vars_derivativeVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_1050;

protected function lm_1051
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      String i_comment;
      String ret_0;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(comment = i_comment) :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        ret_0 = Util.escapeModelicaStringToCString(i_comment);
        txt = Tpl.writeStr(txt, ret_0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        txt = Tpl.nextIter(txt);
        txt = lm_1051(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_1051(txt, rest);
      then txt;
  end match;
end lm_1051;

protected function fun_1052
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_a_vars_stateVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_vars_stateVars)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> i_vars_stateVars;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_vars_stateVars )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("description += "));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 10, 0, Tpl.ST_STRING_LIST({
                                                                                                 ";\n",
                                                                                                 " description += "
                                                                                             }, false), 0, Tpl.ST_NEW_LINE()));
        txt = lm_1051(txt, i_vars_stateVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_1052;

protected function lm_1053
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      String i_comment;
      String ret_0;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(comment = i_comment) :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        ret_0 = Util.escapeModelicaStringToCString(i_comment);
        txt = Tpl.writeStr(txt, ret_0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        txt = Tpl.nextIter(txt);
        txt = lm_1053(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_1053(txt, rest);
      then txt;
  end match;
end lm_1053;

protected function fun_1054
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_a_vars_derivativeVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_vars_derivativeVars)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> i_vars_derivativeVars;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_vars_derivativeVars )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("description += "));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 10, 0, Tpl.ST_STRING_LIST({
                                                                                                 ";\n",
                                                                                                 " description += "
                                                                                             }, false), 0, Tpl.ST_NEW_LINE()));
        txt = lm_1053(txt, i_vars_derivativeVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_1054;

public function writeoutput1
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> i_vars_derivativeVars;
      list<SimCodeVar.SimVar> i_vars_stateVars;
      Absyn.Path i_modelInfo_name;

    case ( txt,
           SimCode.MODELINFO(vars = SimCodeVar.SIMVARS(stateVars = i_vars_stateVars, derivativeVars = i_vars_derivativeVars), name = i_modelInfo_name) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "\n",
                                    "\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(6));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void  "));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "WriteOutput::writeStateVarsResultNames(vector<string>& names)\n",
                                    "{\n"
                                }, true));
        txt = fun_1048(txt, i_vars_stateVars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n",
                                    "void   "
                                }, false));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "WriteOutput::writeDerivativeVarsResultNames(vector<string>& names)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = fun_1050(txt, i_vars_derivativeVars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n",
                                    "\n",
                                    "\n",
                                    "\n",
                                    "void  "
                                }, false));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "WriteOutput::writeStateVarsResultDescription(vector<string>& description)\n",
                                    "{\n"
                                }, true));
        txt = fun_1052(txt, i_vars_stateVars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n",
                                    "void   "
                                }, false));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "WriteOutput::writeDerivativeVarsResultDescription(vector<string>& description)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = fun_1054(txt, i_vars_derivativeVars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n",
                                    "\n"
                                }, true));
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end writeoutput1;

protected function fun_1056
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;
  input list<SimCode.SimEqSystem> in_a_allEquations;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo, in_a_allEquations)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> a_allEquations;
      Integer i_nStates;
      Integer ret_1;
      Tpl.Text l_n;

    case ( txt,
           SimCode.MODELINFO(varInfo = SimCode.VARINFO(numStateVars = i_nStates)),
           a_allEquations )
      equation
        ret_1 = SimCodeUtil.getNumContinuousEquations(a_allEquations, i_nStates);
        l_n = Tpl.writeStr(Tpl.emptyTxt, intString(ret_1));
        txt = Tpl.writeText(txt, l_n);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_1056;

public function numResidues
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_allEquations;
  input SimCode.ModelInfo a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_1056(txt, a_modelInfo, a_allEquations);
end numResidues;

protected function lm_1058
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("1"));
        txt = Tpl.nextIter(txt);
        txt = lm_1058(txt, rest);
      then txt;
  end match;
end lm_1058;

protected function lm_1059
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("1"));
        txt = Tpl.nextIter(txt);
        txt = lm_1059(txt, rest);
      then txt;
  end match;
end lm_1059;

public function numResidues2
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eqn;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_eqn)
    local
      Tpl.Text txt;
      SimCode.SimEqSystem i_cont;
      list<SimCode.SimEqSystem> i_nls_eqs;
      list<SimCodeVar.SimVar> i_ls_vars;

    case ( txt,
           SimCode.SES_RESIDUAL(index = _) )
      then txt;

    case ( txt,
           SimCode.SES_SIMPLE_ASSIGN(index = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("1"));
      then txt;

    case ( txt,
           SimCode.SES_ARRAY_CALL_ASSIGN(index = _) )
      then txt;

    case ( txt,
           SimCode.SES_ALGORITHM(index = _) )
      then txt;

    case ( txt,
           SimCode.SES_LINEAR(lSystem = SimCode.LINEARSYSTEM(vars = i_ls_vars)) )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING("+")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_1058(txt, i_ls_vars);
        txt = Tpl.popIter(txt);
      then txt;

    case ( txt,
           SimCode.SES_NONLINEAR(nlSystem = SimCode.NONLINEARSYSTEM(eqs = i_nls_eqs)) )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING("+")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_1059(txt, i_nls_eqs);
        txt = Tpl.popIter(txt);
      then txt;

    case ( txt,
           SimCode.SES_MIXED(cont = i_cont) )
      equation
        txt = numResidues2(txt, i_cont);
      then txt;

    case ( txt,
           SimCode.SES_WHEN(index = _) )
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end numResidues2;

public function numStatevars
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo)
    local
      Tpl.Text txt;
      Integer i_varInfo_numStateVars;

    case ( txt,
           SimCode.MODELINFO(varInfo = SimCode.VARINFO(numStateVars = i_varInfo_numStateVars)) )
      equation
        txt = Tpl.writeStr(txt, intString(i_varInfo_numStateVars));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end numStatevars;

public function numAlgvars
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo)
    local
      Tpl.Text txt;
      Integer i_varInfo_numBoolAlgVars;
      Integer i_varInfo_numIntAlgVars;
      Integer i_varInfo_numDiscreteReal;
      Integer i_varInfo_numAlgVars;

    case ( txt,
           SimCode.MODELINFO(varInfo = SimCode.VARINFO(numAlgVars = i_varInfo_numAlgVars, numDiscreteReal = i_varInfo_numDiscreteReal, numIntAlgVars = i_varInfo_numIntAlgVars, numBoolAlgVars = i_varInfo_numBoolAlgVars)) )
      equation
        txt = Tpl.writeStr(txt, intString(i_varInfo_numAlgVars));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("+"));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numDiscreteReal));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("+"));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numIntAlgVars));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("+"));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numBoolAlgVars));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end numAlgvars;

public function numRealvars
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo)
    local
      Tpl.Text txt;
      Integer i_varInfo_numDiscreteReal;
      Integer i_varInfo_numParams;
      Integer i_varInfo_numAlgVars;
      Integer i_varInfo_numStateVars;
      Integer ret_3;
      Integer ret_2;
      Integer ret_1;
      Integer ret_0;

    case ( txt,
           SimCode.MODELINFO(varInfo = SimCode.VARINFO(numStateVars = i_varInfo_numStateVars, numAlgVars = i_varInfo_numAlgVars, numParams = i_varInfo_numParams, numDiscreteReal = i_varInfo_numDiscreteReal)) )
      equation
        ret_0 = intMul(2, i_varInfo_numStateVars);
        ret_1 = intAdd(i_varInfo_numParams, i_varInfo_numDiscreteReal);
        ret_2 = intAdd(i_varInfo_numAlgVars, ret_1);
        ret_3 = intAdd(ret_0, ret_2);
        txt = Tpl.writeStr(txt, intString(ret_3));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end numRealvars;

public function numStateVarIndex
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo)
    local
      Tpl.Text txt;

    case ( txt,
           SimCode.MODELINFO(varInfo = SimCode.VARINFO(numZeroCrossings = _)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("0"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end numStateVarIndex;

public function numIntvars
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo)
    local
      Tpl.Text txt;
      Integer i_varInfo_numIntParams;
      Integer i_varInfo_numIntAlgVars;
      Integer ret_0;

    case ( txt,
           SimCode.MODELINFO(varInfo = SimCode.VARINFO(numIntAlgVars = i_varInfo_numIntAlgVars, numIntParams = i_varInfo_numIntParams)) )
      equation
        ret_0 = intAdd(i_varInfo_numIntAlgVars, i_varInfo_numIntParams);
        txt = Tpl.writeStr(txt, intString(ret_0));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end numIntvars;

public function numBoolvars
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo)
    local
      Tpl.Text txt;
      Integer i_varInfo_numBoolParams;
      Integer i_varInfo_numBoolAlgVars;
      Integer ret_0;

    case ( txt,
           SimCode.MODELINFO(varInfo = SimCode.VARINFO(numBoolAlgVars = i_varInfo_numBoolAlgVars, numBoolParams = i_varInfo_numBoolParams)) )
      equation
        ret_0 = intAdd(i_varInfo_numBoolAlgVars, i_varInfo_numBoolParams);
        txt = Tpl.writeStr(txt, intString(ret_0));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end numBoolvars;

public function numStringvars
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo)
    local
      Tpl.Text txt;
      Integer i_varInfo_numStringParamVars;
      Integer i_varInfo_numStringAlgVars;
      Integer ret_0;

    case ( txt,
           SimCode.MODELINFO(varInfo = SimCode.VARINFO(numStringAlgVars = i_varInfo_numStringAlgVars, numStringParamVars = i_varInfo_numStringParamVars)) )
      equation
        ret_0 = intAdd(i_varInfo_numStringAlgVars, i_varInfo_numStringParamVars);
        txt = Tpl.writeStr(txt, intString(ret_0));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end numStringvars;

public function numProtectedAlgvars
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> i_vars_boolAlgVars;
      list<SimCodeVar.SimVar> i_vars_intAlgVars;
      list<SimCodeVar.SimVar> i_vars_discreteAlgVars;
      list<SimCodeVar.SimVar> i_vars_algVars;
      Integer ret_7;
      list<SimCodeVar.SimVar> ret_6;
      Integer ret_5;
      list<SimCodeVar.SimVar> ret_4;
      Integer ret_3;
      list<SimCodeVar.SimVar> ret_2;
      Integer ret_1;
      list<SimCodeVar.SimVar> ret_0;

    case ( txt,
           SimCode.MODELINFO(vars = SimCodeVar.SIMVARS(algVars = i_vars_algVars, discreteAlgVars = i_vars_discreteAlgVars, intAlgVars = i_vars_intAlgVars, boolAlgVars = i_vars_boolAlgVars)) )
      equation
        ret_0 = SimCodeFunctionUtil.protectedVars(i_vars_algVars);
        ret_1 = listLength(ret_0);
        txt = Tpl.writeStr(txt, intString(ret_1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("+"));
        ret_2 = SimCodeFunctionUtil.protectedVars(i_vars_discreteAlgVars);
        ret_3 = listLength(ret_2);
        txt = Tpl.writeStr(txt, intString(ret_3));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("+"));
        ret_4 = SimCodeFunctionUtil.protectedVars(i_vars_intAlgVars);
        ret_5 = listLength(ret_4);
        txt = Tpl.writeStr(txt, intString(ret_5));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("+"));
        ret_6 = SimCodeFunctionUtil.protectedVars(i_vars_boolAlgVars);
        ret_7 = listLength(ret_6);
        txt = Tpl.writeStr(txt, intString(ret_7));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end numProtectedAlgvars;

public function numParamVars
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo)
    local
      Tpl.Text txt;
      Integer i_varInfo_numBoolParams;
      Integer i_varInfo_numIntParams;
      Integer i_varInfo_numParams;
      Integer ret_2;
      Integer ret_1;
      Tpl.Text l_n__vars;

    case ( txt,
           SimCode.MODELINFO(varInfo = SimCode.VARINFO(numParams = i_varInfo_numParams, numIntParams = i_varInfo_numIntParams, numBoolParams = i_varInfo_numBoolParams)) )
      equation
        ret_1 = intAdd(i_varInfo_numIntParams, i_varInfo_numBoolParams);
        ret_2 = intAdd(i_varInfo_numParams, ret_1);
        l_n__vars = Tpl.writeStr(Tpl.emptyTxt, intString(ret_2));
        txt = Tpl.writeText(txt, l_n__vars);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end numParamVars;

public function numProtectedParamVars
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> i_vars_boolParamVars;
      list<SimCodeVar.SimVar> i_vars_intParamVars;
      list<SimCodeVar.SimVar> i_vars_paramVars;
      Integer ret_8;
      Integer ret_7;
      Integer ret_6;
      list<SimCodeVar.SimVar> ret_5;
      Integer ret_4;
      list<SimCodeVar.SimVar> ret_3;
      Integer ret_2;
      list<SimCodeVar.SimVar> ret_1;
      Tpl.Text l_n__vars;

    case ( txt,
           SimCode.MODELINFO(vars = SimCodeVar.SIMVARS(paramVars = i_vars_paramVars, intParamVars = i_vars_intParamVars, boolParamVars = i_vars_boolParamVars)) )
      equation
        ret_1 = SimCodeFunctionUtil.protectedVars(i_vars_paramVars);
        ret_2 = listLength(ret_1);
        ret_3 = SimCodeFunctionUtil.protectedVars(i_vars_intParamVars);
        ret_4 = listLength(ret_3);
        ret_5 = SimCodeFunctionUtil.protectedVars(i_vars_boolParamVars);
        ret_6 = listLength(ret_5);
        ret_7 = intAdd(ret_4, ret_6);
        ret_8 = intAdd(ret_2, ret_7);
        l_n__vars = Tpl.writeStr(Tpl.emptyTxt, intString(ret_8));
        txt = Tpl.writeText(txt, l_n__vars);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end numProtectedParamVars;

public function numProtectedRealParamVars
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> i_vars_paramVars;
      Integer ret_2;
      list<SimCodeVar.SimVar> ret_1;
      Tpl.Text l_n__vars;

    case ( txt,
           SimCode.MODELINFO(vars = SimCodeVar.SIMVARS(paramVars = i_vars_paramVars)) )
      equation
        ret_1 = SimCodeFunctionUtil.protectedVars(i_vars_paramVars);
        ret_2 = listLength(ret_1);
        l_n__vars = Tpl.writeStr(Tpl.emptyTxt, intString(ret_2));
        txt = Tpl.writeText(txt, l_n__vars);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end numProtectedRealParamVars;

public function numProtectedIntParamVars
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> i_vars_intParamVars;
      Integer ret_2;
      list<SimCodeVar.SimVar> ret_1;
      Tpl.Text l_n__vars;

    case ( txt,
           SimCode.MODELINFO(vars = SimCodeVar.SIMVARS(intParamVars = i_vars_intParamVars)) )
      equation
        ret_1 = SimCodeFunctionUtil.protectedVars(i_vars_intParamVars);
        ret_2 = listLength(ret_1);
        l_n__vars = Tpl.writeStr(Tpl.emptyTxt, intString(ret_2));
        txt = Tpl.writeText(txt, l_n__vars);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end numProtectedIntParamVars;

public function numInOutvars
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo)
    local
      Tpl.Text txt;
      Integer i_varInfo_numOutVars;
      Integer i_varInfo_numInVars;

    case ( txt,
           SimCode.MODELINFO(varInfo = SimCode.VARINFO(numInVars = i_varInfo_numInVars, numOutVars = i_varInfo_numOutVars)) )
      equation
        txt = Tpl.writeStr(txt, intString(i_varInfo_numInVars));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("+"));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numOutVars));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end numInOutvars;

public function numAliasvars
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo)
    local
      Tpl.Text txt;
      Integer i_varInfo_numBoolAliasVars;
      Integer i_varInfo_numIntAliasVars;
      Integer i_varInfo_numAlgAliasVars;

    case ( txt,
           SimCode.MODELINFO(varInfo = SimCode.VARINFO(numAlgAliasVars = i_varInfo_numAlgAliasVars, numIntAliasVars = i_varInfo_numIntAliasVars, numBoolAliasVars = i_varInfo_numBoolAliasVars)) )
      equation
        txt = Tpl.writeStr(txt, intString(i_varInfo_numAlgAliasVars));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("+"));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numIntAliasVars));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("+"));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numBoolAliasVars));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end numAliasvars;

public function numProtectedAliasvars
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> i_vars_boolAliasVars;
      list<SimCodeVar.SimVar> i_vars_intAliasVars;
      list<SimCodeVar.SimVar> i_vars_aliasVars;
      Integer ret_5;
      list<SimCodeVar.SimVar> ret_4;
      Integer ret_3;
      list<SimCodeVar.SimVar> ret_2;
      Integer ret_1;
      list<SimCodeVar.SimVar> ret_0;

    case ( txt,
           SimCode.MODELINFO(vars = SimCodeVar.SIMVARS(aliasVars = i_vars_aliasVars, intAliasVars = i_vars_intAliasVars, boolAliasVars = i_vars_boolAliasVars)) )
      equation
        ret_0 = SimCodeFunctionUtil.protectedVars(i_vars_aliasVars);
        ret_1 = listLength(ret_0);
        txt = Tpl.writeStr(txt, intString(ret_1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("+"));
        ret_2 = SimCodeFunctionUtil.protectedVars(i_vars_intAliasVars);
        ret_3 = listLength(ret_2);
        txt = Tpl.writeStr(txt, intString(ret_3));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("+"));
        ret_4 = SimCodeFunctionUtil.protectedVars(i_vars_boolAliasVars);
        ret_5 = listLength(ret_4);
        txt = Tpl.writeStr(txt, intString(ret_5));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end numProtectedAliasvars;

public function numAlgvar
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo)
    local
      Tpl.Text txt;
      Integer i_varInfo_numAlgVars;

    case ( txt,
           SimCode.MODELINFO(varInfo = SimCode.VARINFO(numAlgVars = i_varInfo_numAlgVars)) )
      equation
        txt = Tpl.writeStr(txt, intString(i_varInfo_numAlgVars));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end numAlgvar;

public function numProtectedRealAlgvars
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> i_vars_algVars;
      Integer ret_1;
      list<SimCodeVar.SimVar> ret_0;

    case ( txt,
           SimCode.MODELINFO(vars = SimCodeVar.SIMVARS(algVars = i_vars_algVars)) )
      equation
        ret_0 = SimCodeFunctionUtil.protectedVars(i_vars_algVars);
        ret_1 = listLength(ret_0);
        txt = Tpl.writeStr(txt, intString(ret_1));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end numProtectedRealAlgvars;

public function numDiscreteAlgVar
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo)
    local
      Tpl.Text txt;
      Integer i_varInfo_numDiscreteReal;

    case ( txt,
           SimCode.MODELINFO(varInfo = SimCode.VARINFO(numDiscreteReal = i_varInfo_numDiscreteReal)) )
      equation
        txt = Tpl.writeStr(txt, intString(i_varInfo_numDiscreteReal));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end numDiscreteAlgVar;

public function numProtectedDiscreteAlgVars
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> i_vars_discreteAlgVars;
      Integer ret_1;
      list<SimCodeVar.SimVar> ret_0;

    case ( txt,
           SimCode.MODELINFO(vars = SimCodeVar.SIMVARS(discreteAlgVars = i_vars_discreteAlgVars)) )
      equation
        ret_0 = SimCodeFunctionUtil.protectedVars(i_vars_discreteAlgVars);
        ret_1 = listLength(ret_0);
        txt = Tpl.writeStr(txt, intString(ret_1));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end numProtectedDiscreteAlgVars;

public function numIntAlgvar
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo)
    local
      Tpl.Text txt;
      Integer i_varInfo_numIntAlgVars;

    case ( txt,
           SimCode.MODELINFO(varInfo = SimCode.VARINFO(numIntAlgVars = i_varInfo_numIntAlgVars)) )
      equation
        txt = Tpl.writeStr(txt, intString(i_varInfo_numIntAlgVars));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end numIntAlgvar;

public function numProtectedIntAlgvars
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> i_vars_intAlgVars;
      Integer ret_1;
      list<SimCodeVar.SimVar> ret_0;

    case ( txt,
           SimCode.MODELINFO(vars = SimCodeVar.SIMVARS(intAlgVars = i_vars_intAlgVars)) )
      equation
        ret_0 = SimCodeFunctionUtil.protectedVars(i_vars_intAlgVars);
        ret_1 = listLength(ret_0);
        txt = Tpl.writeStr(txt, intString(ret_1));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end numProtectedIntAlgvars;

public function numBoolAlgvars
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo)
    local
      Tpl.Text txt;
      Integer i_varInfo_numBoolAlgVars;

    case ( txt,
           SimCode.MODELINFO(varInfo = SimCode.VARINFO(numBoolAlgVars = i_varInfo_numBoolAlgVars)) )
      equation
        txt = Tpl.writeStr(txt, intString(i_varInfo_numBoolAlgVars));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end numBoolAlgvars;

public function numProtectedBoolAlgvars
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> i_vars_boolAlgVars;
      Integer ret_1;
      list<SimCodeVar.SimVar> ret_0;

    case ( txt,
           SimCode.MODELINFO(vars = SimCodeVar.SIMVARS(boolAlgVars = i_vars_boolAlgVars)) )
      equation
        ret_0 = SimCodeFunctionUtil.protectedVars(i_vars_boolAlgVars);
        ret_1 = listLength(ret_0);
        txt = Tpl.writeStr(txt, intString(ret_1));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end numProtectedBoolAlgvars;

public function numInputvar
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo)
    local
      Tpl.Text txt;
      Integer i_varInfo_numInVars;

    case ( txt,
           SimCode.MODELINFO(varInfo = SimCode.VARINFO(numInVars = i_varInfo_numInVars)) )
      equation
        txt = Tpl.writeStr(txt, intString(i_varInfo_numInVars));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end numInputvar;

public function numOutputvar
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo)
    local
      Tpl.Text txt;
      Integer i_varInfo_numOutVars;

    case ( txt,
           SimCode.MODELINFO(varInfo = SimCode.VARINFO(numOutVars = i_varInfo_numOutVars)) )
      equation
        txt = Tpl.writeStr(txt, intString(i_varInfo_numOutVars));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end numOutputvar;

public function numAliasvar
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo)
    local
      Tpl.Text txt;
      Integer i_varInfo_numAlgAliasVars;

    case ( txt,
           SimCode.MODELINFO(varInfo = SimCode.VARINFO(numAlgAliasVars = i_varInfo_numAlgAliasVars)) )
      equation
        txt = Tpl.writeStr(txt, intString(i_varInfo_numAlgAliasVars));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end numAliasvar;

public function numProtectedRealAliasvars
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> i_vars_aliasVars;
      Integer ret_1;
      list<SimCodeVar.SimVar> ret_0;

    case ( txt,
           SimCode.MODELINFO(vars = SimCodeVar.SIMVARS(aliasVars = i_vars_aliasVars)) )
      equation
        ret_0 = SimCodeFunctionUtil.protectedVars(i_vars_aliasVars);
        ret_1 = listLength(ret_0);
        txt = Tpl.writeStr(txt, intString(ret_1));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end numProtectedRealAliasvars;

public function numIntAliasvar
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo)
    local
      Tpl.Text txt;
      Integer i_varInfo_numIntAliasVars;

    case ( txt,
           SimCode.MODELINFO(varInfo = SimCode.VARINFO(numIntAliasVars = i_varInfo_numIntAliasVars)) )
      equation
        txt = Tpl.writeStr(txt, intString(i_varInfo_numIntAliasVars));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end numIntAliasvar;

public function numProtectedIntAliasvars
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> i_vars_intAliasVars;
      Integer ret_1;
      list<SimCodeVar.SimVar> ret_0;

    case ( txt,
           SimCode.MODELINFO(vars = SimCodeVar.SIMVARS(intAliasVars = i_vars_intAliasVars)) )
      equation
        ret_0 = SimCodeFunctionUtil.protectedVars(i_vars_intAliasVars);
        ret_1 = listLength(ret_0);
        txt = Tpl.writeStr(txt, intString(ret_1));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end numProtectedIntAliasvars;

public function numBoolAliasvar
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo)
    local
      Tpl.Text txt;
      Integer i_varInfo_numBoolAliasVars;

    case ( txt,
           SimCode.MODELINFO(varInfo = SimCode.VARINFO(numBoolAliasVars = i_varInfo_numBoolAliasVars)) )
      equation
        txt = Tpl.writeStr(txt, intString(i_varInfo_numBoolAliasVars));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end numBoolAliasvar;

public function numProtectedBoolAliasvars
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> i_vars_boolAliasVars;
      Integer ret_1;
      list<SimCodeVar.SimVar> ret_0;

    case ( txt,
           SimCode.MODELINFO(vars = SimCodeVar.SIMVARS(boolAliasVars = i_vars_boolAliasVars)) )
      equation
        ret_0 = SimCodeFunctionUtil.protectedVars(i_vars_boolAliasVars);
        ret_1 = listLength(ret_0);
        txt = Tpl.writeStr(txt, intString(ret_1));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end numProtectedBoolAliasvars;

public function numDerivativevars
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo)
    local
      Tpl.Text txt;
      Integer i_varInfo_numStateVars;

    case ( txt,
           SimCode.MODELINFO(varInfo = SimCode.VARINFO(numStateVars = i_varInfo_numStateVars)) )
      equation
        txt = Tpl.writeStr(txt, intString(i_varInfo_numStateVars));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end numDerivativevars;

protected function fun_1093
  input Tpl.Text in_txt;
  input DAE.Type in_a_type__;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_type__)
    local
      Tpl.Text txt;

    case ( txt,
           DAE.T_BOOL(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("!"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-"));
      then txt;
  end match;
end fun_1093;

protected function fun_1094
  input Tpl.Text in_txt;
  input SimCodeVar.AliasVariable in_a_aliasvar;
  input DAE.Type in_a_type__;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_aliasvar, in_a_type__)
    local
      Tpl.Text txt;
      DAE.Type a_type__;

    case ( txt,
           SimCodeVar.NEGATEDALIAS(varName = _),
           a_type__ )
      equation
        txt = fun_1093(txt, a_type__);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_1094;

public function getAliasSign
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_a_simVar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simVar)
    local
      Tpl.Text txt;
      DAE.Type i_type__;
      SimCodeVar.AliasVariable i_aliasvar;

    case ( txt,
           SimCodeVar.SIMVAR(type_ = i_type__, aliasvar = i_aliasvar) )
      equation
        txt = fun_1094(txt, i_aliasvar, i_type__);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end getAliasSign;

protected function fun_1096
  input Tpl.Text in_txt;
  input SimCodeVar.AliasVariable in_a_aliasvar;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_varDeclsCref;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_varDeclsCref;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_varDeclsCref, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_a_aliasvar, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_varDeclsCref, in_a_context, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_varDeclsCref;
      SimCodeFunction.Context a_context;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      DAE.ComponentRef i_varName;

    case ( txt,
           SimCodeVar.ALIAS(varName = i_varName),
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_varDeclsCref,
           a_context,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_varDeclsCref, a_stateDerVectorName) = CodegenCppCommonOld.cref1(txt, i_varName, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_context, a_varDeclsCref, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           SimCodeVar.NEGATEDALIAS(varName = i_varName),
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_varDeclsCref,
           a_context,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_varDeclsCref, a_stateDerVectorName) = CodegenCppCommonOld.cref1(txt, i_varName, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_context, a_varDeclsCref, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           _,
           a_stateDerVectorName,
           a_varDeclsCref,
           _,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("noAlias"));
      then (txt, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_1096;

public function getAliasCRef
  input Tpl.Text txt;
  input SimCodeVar.AliasVariable a_aliasvar;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
protected
  Tpl.Text l_varDeclsCref;
algorithm
  l_varDeclsCref := Tpl.emptyTxt;
  (out_txt, out_a_stateDerVectorName, l_varDeclsCref, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) := fun_1096(txt, a_aliasvar, a_useFlatArrayNotation, a_stateDerVectorName, l_varDeclsCref, a_context, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
end getAliasCRef;

protected function lm_1098
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Tpl.Text in_a_stateVarsStart;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_stateVarsStart)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Tpl.Text a_stateVarsStart;
      Integer x_i8;
      Integer i_index;
      Integer ret_2;
      Integer ret_1;
      Integer ret_0;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(index = i_index) :: rest,
           a_stateVarsStart )
      equation
        x_i8 = Tpl.getIteri_i0(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(*v)("));
        ret_0 = stringInt(Tpl.textString(a_stateVarsStart));
        ret_1 = stringInt(intString(x_i8));
        ret_2 = intAdd(ret_0, ret_1);
        txt = Tpl.writeStr(txt, intString(ret_2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")=__z["));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("];"));
        txt = Tpl.nextIter(txt);
        txt = lm_1098(txt, rest, a_stateVarsStart);
      then txt;

    case ( txt,
           _ :: rest,
           a_stateVarsStart )
      equation
        txt = lm_1098(txt, rest, a_stateVarsStart);
      then txt;
  end match;
end lm_1098;

protected function lm_1099
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Integer x_i9;
      Integer i_index;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(index = i_index) :: rest )
      equation
        x_i9 = Tpl.getIteri_i0(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(*v2)("));
        txt = Tpl.writeStr(txt, intString(x_i9));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")=__zDot["));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("]; "));
        txt = Tpl.nextIter(txt);
        txt = lm_1099(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_1099(txt, rest);
      then txt;
  end match;
end lm_1099;

protected function fun_1100
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;
  input String in_a_className;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo, in_a_className)
    local
      Tpl.Text txt;
      String a_className;
      list<SimCodeVar.SimVar> i_vars_derivativeVars;
      list<SimCodeVar.SimVar> i_vars_stateVars;
      SimCode.ModelInfo i_modelInfo;
      Integer ret_36;
      Integer ret_35;
      Tpl.Text txt_34;
      Integer ret_33;
      Tpl.Text l_stateVarsStart;
      Integer ret_31;
      Integer ret_30;
      Tpl.Text txt_29;
      Integer ret_28;
      Tpl.Text l_boolAliasVarsStart;
      Integer ret_26;
      Integer ret_25;
      Tpl.Text txt_24;
      Integer ret_23;
      Tpl.Text l_intAliasVarsStart;
      Integer ret_21;
      Integer ret_20;
      Tpl.Text txt_19;
      Integer ret_18;
      Tpl.Text l_aliasVarsStart;
      Integer ret_16;
      Integer ret_15;
      Tpl.Text txt_14;
      Integer ret_13;
      Tpl.Text l_boolAlgVarsStart;
      Integer ret_11;
      Integer ret_10;
      Tpl.Text txt_9;
      Integer ret_8;
      Tpl.Text l_intAlgVarsStart;
      Integer ret_6;
      Integer ret_5;
      Tpl.Text txt_4;
      Integer ret_3;
      Tpl.Text l_discrAlgVarsStart;
      Tpl.Text l_algVarsStart;
      Tpl.Text l_varDeclsCref;

    case ( txt,
           (i_modelInfo as SimCode.MODELINFO(vars = SimCodeVar.SIMVARS(stateVars = i_vars_stateVars, derivativeVars = i_vars_derivativeVars))),
           a_className )
      equation
        l_varDeclsCref = Tpl.emptyTxt;
        l_algVarsStart = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("1"));
        ret_3 = stringInt(Tpl.textString(l_algVarsStart));
        txt_4 = numProtectedRealAlgvars(Tpl.emptyTxt, i_modelInfo);
        ret_5 = stringInt(Tpl.textString(txt_4));
        ret_6 = intAdd(ret_3, ret_5);
        l_discrAlgVarsStart = Tpl.writeStr(Tpl.emptyTxt, intString(ret_6));
        ret_8 = stringInt(Tpl.textString(l_discrAlgVarsStart));
        txt_9 = numProtectedDiscreteAlgVars(Tpl.emptyTxt, i_modelInfo);
        ret_10 = stringInt(Tpl.textString(txt_9));
        ret_11 = intAdd(ret_8, ret_10);
        l_intAlgVarsStart = Tpl.writeStr(Tpl.emptyTxt, intString(ret_11));
        ret_13 = stringInt(Tpl.textString(l_intAlgVarsStart));
        txt_14 = numProtectedIntAlgvars(Tpl.emptyTxt, i_modelInfo);
        ret_15 = stringInt(Tpl.textString(txt_14));
        ret_16 = intAdd(ret_13, ret_15);
        l_boolAlgVarsStart = Tpl.writeStr(Tpl.emptyTxt, intString(ret_16));
        ret_18 = stringInt(Tpl.textString(l_boolAlgVarsStart));
        txt_19 = numProtectedBoolAlgvars(Tpl.emptyTxt, i_modelInfo);
        ret_20 = stringInt(Tpl.textString(txt_19));
        ret_21 = intAdd(ret_18, ret_20);
        l_aliasVarsStart = Tpl.writeStr(Tpl.emptyTxt, intString(ret_21));
        ret_23 = stringInt(Tpl.textString(l_aliasVarsStart));
        txt_24 = numProtectedRealAliasvars(Tpl.emptyTxt, i_modelInfo);
        ret_25 = stringInt(Tpl.textString(txt_24));
        ret_26 = intAdd(ret_23, ret_25);
        l_intAliasVarsStart = Tpl.writeStr(Tpl.emptyTxt, intString(ret_26));
        ret_28 = stringInt(Tpl.textString(l_intAliasVarsStart));
        txt_29 = numProtectedIntAliasvars(Tpl.emptyTxt, i_modelInfo);
        ret_30 = stringInt(Tpl.textString(txt_29));
        ret_31 = intAdd(ret_28, ret_30);
        l_boolAliasVarsStart = Tpl.writeStr(Tpl.emptyTxt, intString(ret_31));
        ret_33 = stringInt(Tpl.textString(l_boolAliasVarsStart));
        txt_34 = numProtectedBoolAliasvars(Tpl.emptyTxt, i_modelInfo);
        ret_35 = stringInt(Tpl.textString(txt_34));
        ret_36 = intAdd(ret_33, ret_35);
        l_stateVarsStart = Tpl.writeStr(Tpl.emptyTxt, intString(ret_36));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "void "
                                }, false));
        txt = Tpl.writeStr(txt, a_className);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::writeStateValues(HistoryImplType::value_type_v *v, HistoryImplType::value_type_dv *v2)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_1098(txt, i_vars_stateVars, l_stateVarsStart);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(1, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_1099(txt, i_vars_derivativeVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_1100;

public function generateWriteOutputFunctionsForVars
  input Tpl.Text txt;
  input SimCode.ModelInfo a_modelInfo;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input String a_className;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  out_txt := fun_1100(txt, a_modelInfo, a_className);
  out_a_extraFuncs := a_extraFuncs;
  out_a_extraFuncsDecl := a_extraFuncsDecl;
  out_a_extraFuncsNamespace := a_extraFuncsNamespace;
end generateWriteOutputFunctionsForVars;

protected function lm_1102
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Integer in_a_startIndex;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_startIndex)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Boolean a_useFlatArrayNotation;
      Integer a_startIndex;
      Integer x_i0;
      DAE.ComponentRef i_name;
      Integer ret_1;
      Integer ret_0;

    case ( txt,
           {},
           _,
           _ )
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(isProtected = false, name = i_name) :: rest,
           a_useFlatArrayNotation,
           a_startIndex )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(*v)("));
        ret_0 = stringInt(intString(x_i0));
        ret_1 = intAdd(a_startIndex, ret_0);
        txt = Tpl.writeStr(txt, intString(ret_1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")="));
        txt = CodegenCppCommonOld.cref(txt, i_name, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        txt = lm_1102(txt, rest, a_useFlatArrayNotation, a_startIndex);
      then txt;

    case ( txt,
           _ :: rest,
           a_useFlatArrayNotation,
           a_startIndex )
      equation
        txt = lm_1102(txt, rest, a_useFlatArrayNotation, a_startIndex);
      then txt;
  end match;
end lm_1102;

protected function lm_1103
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Integer in_a_startIndex;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_startIndex)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Integer a_startIndex;
      Integer x_i1;
      SimCodeVar.AliasVariable i_aliasvar;
      SimCodeVar.SimVar i_simVar;
      Integer ret_1;
      Integer ret_0;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           (i_simVar as SimCodeVar.SIMVAR(isProtected = false, aliasvar = i_aliasvar)) :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_startIndex )
      equation
        x_i1 = Tpl.getIteri_i0(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(*v)("));
        ret_0 = stringInt(intString(x_i1));
        ret_1 = intAdd(a_startIndex, ret_0);
        txt = Tpl.writeStr(txt, intString(ret_1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") = "));
        txt = getAliasSign(txt, i_simVar);
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = getAliasCRef(txt, i_aliasvar, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, SimCodeFunction.contextOther, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1103(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_startIndex);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _ :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_startIndex )
      equation
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1103(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_startIndex);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_1103;

protected function fun_1104
  input Tpl.Text in_txt;
  input Boolean in_a_areAliasVars;
  input list<SimCodeVar.SimVar> in_a_vars;
  input Integer in_a_startIndex;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_areAliasVars, in_a_vars, in_a_startIndex, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> a_vars;
      Integer a_startIndex;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;

    case ( txt,
           false,
           a_vars,
           a_startIndex,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_1102(txt, a_vars, a_useFlatArrayNotation, a_startIndex);
        txt = Tpl.popIter(txt);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           a_vars,
           a_startIndex,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1103(txt, a_vars, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_startIndex);
        txt = Tpl.popIter(txt);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end fun_1104;

public function writeOutputVars
  input Tpl.Text txt;
  input String a_functionName;
  input list<SimCodeVar.SimVar> a_vars;
  input Integer a_startIndex;
  input String a_className;
  input Boolean a_areAliasVars;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING("void "));
  out_txt := Tpl.writeStr(out_txt, a_className);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("::"));
  out_txt := Tpl.writeStr(out_txt, a_functionName);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "(HistoryImplType::value_type_v *v)\n",
                                       "{\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) := fun_1104(out_txt, a_areAliasVars, a_vars, a_startIndex, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("}"));
end writeOutputVars;

protected function lm_1106
  input Tpl.Text in_txt;
  input list<list<SimCodeVar.SimVar>> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Boolean in_a_areAliasVars;
  input Integer in_a_startIndex;
  input String in_a_functionName;
  input String in_a_className;
  input Tpl.Text in_a_funcCalls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_funcCalls;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_funcCalls) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_areAliasVars, in_a_startIndex, in_a_functionName, in_a_className, in_a_funcCalls)
    local
      Tpl.Text txt;
      list<list<SimCodeVar.SimVar>> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Boolean a_areAliasVars;
      Integer a_startIndex;
      String a_functionName;
      String a_className;
      Tpl.Text a_funcCalls;
      Integer x_idx;
      list<SimCodeVar.SimVar> i_ls;
      Tpl.Text l_init;
      Tpl.Text l_varDecls;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _,
           _,
           _,
           _,
           a_funcCalls )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_funcCalls);

    case ( txt,
           i_ls :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_areAliasVars,
           a_startIndex,
           a_functionName,
           a_className,
           a_funcCalls )
      equation
        x_idx = Tpl.getIteri_i0(txt);
        l_varDecls = Tpl.emptyTxt;
        a_funcCalls = Tpl.writeStr(a_funcCalls, a_className);
        a_funcCalls = Tpl.writeTok(a_funcCalls, Tpl.ST_STRING("::"));
        a_funcCalls = Tpl.writeStr(a_funcCalls, a_functionName);
        a_funcCalls = Tpl.writeTok(a_funcCalls, Tpl.ST_STRING("_"));
        a_funcCalls = Tpl.writeStr(a_funcCalls, intString(x_idx));
        a_funcCalls = Tpl.writeTok(a_funcCalls, Tpl.ST_STRING("(v);"));
        (l_init, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = writeValueValst(Tpl.emptyTxt, i_ls, a_startIndex, x_idx, 100, a_areAliasVars, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = Tpl.writeStr(txt, a_className);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("::"));
        txt = Tpl.writeStr(txt, a_functionName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeStr(txt, intString(x_idx));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(HistoryImplType::value_type_v *v)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(3));
        txt = Tpl.writeText(txt, l_varDecls);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_init);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_funcCalls) = lm_1106(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_areAliasVars, a_startIndex, a_functionName, a_className, a_funcCalls);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_funcCalls);
  end match;
end lm_1106;

public function writeOutputVarsWithSplit
  input Tpl.Text txt;
  input String a_functionName;
  input list<SimCodeVar.SimVar> a_vars;
  input Integer a_startIndex;
  input String a_className;
  input Boolean a_areAliasVars;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
protected
  Integer ret_3;
  list<list<SimCodeVar.SimVar>> ret_2;
  Tpl.Text l_funcs;
  Tpl.Text l_funcCalls;
algorithm
  l_funcCalls := Tpl.emptyTxt;
  ret_2 := List.partition(a_vars, 100);
  l_funcs := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (l_funcs, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, l_funcCalls) := lm_1106(l_funcs, ret_2, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_areAliasVars, a_startIndex, a_functionName, a_className, l_funcCalls);
  l_funcs := Tpl.popIter(l_funcs);
  out_txt := Tpl.writeText(txt, l_funcs);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "void "
                                   }, false));
  out_txt := Tpl.writeStr(out_txt, a_className);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("::"));
  out_txt := Tpl.writeStr(out_txt, a_functionName);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "(HistoryImplType::value_type_v *v)\n",
                                       "{\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("//number of vars: "));
  ret_3 := listLength(a_vars);
  out_txt := Tpl.writeStr(out_txt, intString(ret_3));
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeText(out_txt, l_funcCalls);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("}"));
end writeOutputVarsWithSplit;

protected function lm_1108
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Integer in_a_startIndex;
  input Integer in_a_multiplicator;
  input Integer in_a_idx;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_startIndex, in_a_multiplicator, in_a_idx)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Boolean a_useFlatArrayNotation;
      Integer a_startIndex;
      Integer a_multiplicator;
      Integer a_idx;
      Integer x_i0;
      DAE.ComponentRef i_name;
      Integer ret_3;
      Integer ret_2;
      Integer ret_1;
      Integer ret_0;

    case ( txt,
           {},
           _,
           _,
           _,
           _ )
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(isProtected = false, name = i_name) :: rest,
           a_useFlatArrayNotation,
           a_startIndex,
           a_multiplicator,
           a_idx )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(*v)("));
        ret_0 = intMul(a_idx, a_multiplicator);
        ret_1 = stringInt(intString(x_i0));
        ret_2 = intAdd(a_startIndex, ret_1);
        ret_3 = intAdd(ret_0, ret_2);
        txt = Tpl.writeStr(txt, intString(ret_3));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")="));
        txt = CodegenCppCommonOld.cref(txt, i_name, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        txt = lm_1108(txt, rest, a_useFlatArrayNotation, a_startIndex, a_multiplicator, a_idx);
      then txt;

    case ( txt,
           _ :: rest,
           a_useFlatArrayNotation,
           a_startIndex,
           a_multiplicator,
           a_idx )
      equation
        txt = lm_1108(txt, rest, a_useFlatArrayNotation, a_startIndex, a_multiplicator, a_idx);
      then txt;
  end match;
end lm_1108;

protected function lm_1109
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Integer in_a_startIndex;
  input Integer in_a_multiplicator;
  input Integer in_a_idx;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_startIndex, in_a_multiplicator, in_a_idx)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Integer a_startIndex;
      Integer a_multiplicator;
      Integer a_idx;
      Integer x_i1;
      SimCodeVar.AliasVariable i_aliasvar;
      SimCodeVar.SimVar i_simVar;
      Integer ret_3;
      Integer ret_2;
      Integer ret_1;
      Integer ret_0;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           (i_simVar as SimCodeVar.SIMVAR(isProtected = false, aliasvar = i_aliasvar)) :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_startIndex,
           a_multiplicator,
           a_idx )
      equation
        x_i1 = Tpl.getIteri_i0(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(*v)("));
        ret_0 = intMul(a_idx, a_multiplicator);
        ret_1 = stringInt(intString(x_i1));
        ret_2 = intAdd(a_startIndex, ret_1);
        ret_3 = intAdd(ret_0, ret_2);
        txt = Tpl.writeStr(txt, intString(ret_3));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") = "));
        txt = getAliasSign(txt, i_simVar);
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = getAliasCRef(txt, i_aliasvar, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, SimCodeFunction.contextOther, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1109(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_startIndex, a_multiplicator, a_idx);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _ :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_startIndex,
           a_multiplicator,
           a_idx )
      equation
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1109(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_startIndex, a_multiplicator, a_idx);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_1109;

protected function fun_1110
  input Tpl.Text in_txt;
  input Boolean in_a_areAliasVars;
  input list<SimCodeVar.SimVar> in_a_vars;
  input Integer in_a_startIndex;
  input Integer in_a_idx;
  input Integer in_a_multiplicator;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_areAliasVars, in_a_vars, in_a_startIndex, in_a_idx, in_a_multiplicator, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> a_vars;
      Integer a_startIndex;
      Integer a_idx;
      Integer a_multiplicator;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;

    case ( txt,
           false,
           a_vars,
           a_startIndex,
           a_idx,
           a_multiplicator,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_1108(txt, a_vars, a_useFlatArrayNotation, a_startIndex, a_multiplicator, a_idx);
        txt = Tpl.popIter(txt);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           a_vars,
           a_startIndex,
           a_idx,
           a_multiplicator,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1109(txt, a_vars, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_startIndex, a_multiplicator, a_idx);
        txt = Tpl.popIter(txt);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end fun_1110;

public function writeValueValst
  input Tpl.Text txt;
  input list<SimCodeVar.SimVar> a_vars;
  input Integer a_startIndex;
  input Integer a_idx;
  input Integer a_multiplicator;
  input Boolean a_areAliasVars;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) := fun_1110(txt, a_areAliasVars, a_vars, a_startIndex, a_idx, a_multiplicator, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
end writeValueValst;

public function writeoutputparams
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input SimCodeFunction.Context in_a_context;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace) :=
  match(in_txt, in_a_modelInfo, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_context, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      SimCodeFunction.Context a_context;
      Boolean a_useFlatArrayNotation;
      list<SimCodeVar.SimVar> i_vars_boolParamVars;
      list<SimCodeVar.SimVar> i_vars_intParamVars;
      list<SimCodeVar.SimVar> i_vars_paramVars;
      Absyn.Path i_name;
      SimCode.ModelInfo i_modelInfo;
      Integer ret_16;
      Tpl.Text txt_15;
      Integer ret_14;
      Tpl.Text txt_13;
      Integer ret_12;
      Tpl.Text txt_11;
      Integer ret_10;
      Integer ret_9;
      Tpl.Text txt_8;
      Integer ret_7;
      Tpl.Text l_boolparamVarsStart;
      Integer ret_5;
      Integer ret_4;
      Tpl.Text txt_3;
      Tpl.Text l_intParamVarsStart;
      Tpl.Text l_paramVarsStart;
      Tpl.Text l_varDeclsCref;

    case ( txt,
           (i_modelInfo as SimCode.MODELINFO(vars = SimCodeVar.SIMVARS(paramVars = i_vars_paramVars, intParamVars = i_vars_intParamVars, boolParamVars = i_vars_boolParamVars), varInfo = SimCode.VARINFO(numZeroCrossings = _), name = i_name)),
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_context,
           a_useFlatArrayNotation )
      equation
        l_varDeclsCref = Tpl.emptyTxt;
        l_paramVarsStart = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("1"));
        txt_3 = numProtectedRealParamVars(Tpl.emptyTxt, i_modelInfo);
        ret_4 = stringInt(Tpl.textString(txt_3));
        ret_5 = intAdd(1, ret_4);
        l_intParamVarsStart = Tpl.writeStr(Tpl.emptyTxt, intString(ret_5));
        ret_7 = stringInt(Tpl.textString(l_intParamVarsStart));
        txt_8 = numProtectedIntParamVars(Tpl.emptyTxt, i_modelInfo);
        ret_9 = stringInt(Tpl.textString(txt_8));
        ret_10 = intAdd(ret_7, ret_9);
        l_boolparamVarsStart = Tpl.writeStr(Tpl.emptyTxt, intString(ret_10));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = lastIdentOfPath(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "WriteOutput::writeParams(HistoryImplType::value_type_p& params)\n",
                                    "{\n",
                                    " /*const int paramVarsStart = 1;\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("const int intParamVarsStart  = paramVarsStart       + "));
        txt = numProtectedRealParamVars(txt, i_modelInfo);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "const int boolparamVarsStart    = intParamVarsStart  + "
                                }, false));
        txt = numProtectedIntParamVars(txt, i_modelInfo);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "*/\n",
                                    "writeParamsReal(params);\n",
                                    "writeParamsInt(params);\n",
                                    "writeParamsBool(params);\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("}\n"));
        txt_11 = lastIdentOfPath(Tpl.emptyTxt, i_name);
        txt_11 = Tpl.writeTok(txt_11, Tpl.ST_STRING("WriteOutput::writeParams"));
        ret_12 = stringInt(Tpl.textString(l_paramVarsStart));
        (txt, txt_11, _, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = writeoutputparamsWithSplit(txt, txt_11, ret_12, Tpl.strTokText(Tpl.ST_STRING("Real")), i_vars_paramVars, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_context, a_useFlatArrayNotation);
        txt = Tpl.softNewLine(txt);
        txt_13 = lastIdentOfPath(Tpl.emptyTxt, i_name);
        txt_13 = Tpl.writeTok(txt_13, Tpl.ST_STRING("WriteOutput::writeParams"));
        ret_14 = stringInt(Tpl.textString(l_intParamVarsStart));
        (txt, txt_13, _, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = writeoutputparamsWithSplit(txt, txt_13, ret_14, Tpl.strTokText(Tpl.ST_STRING("Int")), i_vars_intParamVars, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_context, a_useFlatArrayNotation);
        txt = Tpl.softNewLine(txt);
        txt_15 = lastIdentOfPath(Tpl.emptyTxt, i_name);
        txt_15 = Tpl.writeTok(txt_15, Tpl.ST_STRING("WriteOutput::writeParams"));
        ret_16 = stringInt(Tpl.textString(l_boolparamVarsStart));
        (txt, txt_15, _, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = writeoutputparamsWithSplit(txt, txt_15, ret_16, Tpl.strTokText(Tpl.ST_STRING("Bool")), i_vars_boolParamVars, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_context, a_useFlatArrayNotation);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);

    case ( txt,
           _,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           _,
           _ )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
  end match;
end writeoutputparams;

protected function lm_1113
  input Tpl.Text in_txt;
  input list<list<SimCodeVar.SimVar>> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Integer in_a_startindex;
  input Tpl.Text in_a_type;
  input Tpl.Text in_a_funcNamePrefix;
  input Tpl.Text in_a_funcCalls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_funcCalls;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_funcCalls) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_context, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_startindex, in_a_type, in_a_funcNamePrefix, in_a_funcCalls)
    local
      Tpl.Text txt;
      list<list<SimCodeVar.SimVar>> rest;
      Boolean a_useFlatArrayNotation;
      SimCodeFunction.Context a_context;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Integer a_startindex;
      Tpl.Text a_type;
      Tpl.Text a_funcNamePrefix;
      Tpl.Text a_funcCalls;
      Integer x_idx;
      list<SimCodeVar.SimVar> i_ls;
      Tpl.Text l_init;
      Tpl.Text l_varDecls;

    case ( txt,
           {},
           _,
           _,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _,
           _,
           _,
           a_funcCalls )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_funcCalls);

    case ( txt,
           i_ls :: rest,
           a_useFlatArrayNotation,
           a_context,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_startindex,
           a_type,
           a_funcNamePrefix,
           a_funcCalls )
      equation
        x_idx = Tpl.getIteri_i0(txt);
        l_varDecls = Tpl.emptyTxt;
        a_funcCalls = Tpl.writeText(a_funcCalls, a_funcNamePrefix);
        a_funcCalls = Tpl.writeText(a_funcCalls, a_type);
        a_funcCalls = Tpl.writeTok(a_funcCalls, Tpl.ST_STRING("_"));
        a_funcCalls = Tpl.writeStr(a_funcCalls, intString(x_idx));
        a_funcCalls = Tpl.writeTok(a_funcCalls, Tpl.ST_STRING("(params);"));
        (l_init, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = writeParamValst(Tpl.emptyTxt, i_ls, a_startindex, x_idx, 100, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_context, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = Tpl.writeText(txt, a_funcNamePrefix);
        txt = Tpl.writeText(txt, a_type);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeStr(txt, intString(x_idx));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "( HistoryImplType::value_type_p& params  )\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(3));
        txt = Tpl.writeText(txt, l_varDecls);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_init);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
        txt = Tpl.nextIter(txt);
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_funcCalls) = lm_1113(txt, rest, a_useFlatArrayNotation, a_context, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_startindex, a_type, a_funcNamePrefix, a_funcCalls);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_funcCalls);
  end match;
end lm_1113;

public function writeoutputparamsWithSplit
  input Tpl.Text txt;
  input Tpl.Text a_funcNamePrefix;
  input Integer a_startindex;
  input Tpl.Text a_type;
  input list<SimCodeVar.SimVar> a_varsLst;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input SimCodeFunction.Context a_context;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_funcNamePrefix;
  output Tpl.Text out_a_type;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
protected
  Integer ret_4;
  list<list<SimCodeVar.SimVar>> ret_3;
  list<SimCodeVar.SimVar> ret_2;
  Tpl.Text l_funcs;
  Tpl.Text l_funcCalls;
algorithm
  l_funcCalls := Tpl.emptyTxt;
  ret_2 := SimCodeFunctionUtil.protectedVars(a_varsLst);
  ret_3 := List.partition(ret_2, 100);
  l_funcs := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (l_funcs, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, l_funcCalls) := lm_1113(l_funcs, ret_3, a_useFlatArrayNotation, a_context, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_startindex, a_type, a_funcNamePrefix, l_funcCalls);
  l_funcs := Tpl.popIter(l_funcs);
  out_txt := Tpl.writeText(txt, l_funcs);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "void "
                                   }, false));
  out_txt := Tpl.writeText(out_txt, a_funcNamePrefix);
  out_txt := Tpl.writeText(out_txt, a_type);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "(HistoryImplType::value_type_p& params  )\n",
                                       "{\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("//number of vars: "));
  ret_4 := listLength(a_varsLst);
  out_txt := Tpl.writeStr(out_txt, intString(ret_4));
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeText(out_txt, l_funcCalls);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("}"));
  out_a_funcNamePrefix := a_funcNamePrefix;
  out_a_type := a_type;
end writeoutputparamsWithSplit;

protected function lm_1115
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Boolean a_useFlatArrayNotation;
      Integer x_i0;
      DAE.ComponentRef i_name;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(isProtected = false, name = i_name) :: rest,
           a_useFlatArrayNotation )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("params("));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")="));
        txt = CodegenCppCommonOld.cref(txt, i_name, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        txt = lm_1115(txt, rest, a_useFlatArrayNotation);
      then txt;

    case ( txt,
           _ :: rest,
           a_useFlatArrayNotation )
      equation
        txt = lm_1115(txt, rest, a_useFlatArrayNotation);
      then txt;
  end match;
end lm_1115;

public function writeParamValst
  input Tpl.Text txt;
  input list<SimCodeVar.SimVar> a_varsLst;
  input Integer a_startindex;
  input Integer a_idx;
  input Integer a_multiplicator;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input SimCodeFunction.Context a_context;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
protected
  Integer ret_1;
  Integer ret_0;
algorithm
  ret_0 := intMul(a_idx, a_multiplicator);
  ret_1 := intAdd(a_startindex, ret_0);
  out_txt := Tpl.pushIter(txt, Tpl.ITER_OPTIONS(ret_1, NONE(), NONE(), 8, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_1115(out_txt, a_varsLst, a_useFlatArrayNotation);
  out_txt := Tpl.popIter(out_txt);
  out_a_extraFuncs := a_extraFuncs;
  out_a_extraFuncsDecl := a_extraFuncsDecl;
  out_a_extraFuncsNamespace := a_extraFuncsNamespace;
end writeParamValst;

protected function fun_1117
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      Absyn.Path i_modelInfo_name;
      Tpl.Text l_className;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(vars = SimCodeVar.SIMVARS(stateVars = _), name = i_modelInfo_name)) )
      equation
        l_className = lastIdentOfPath(Tpl.emptyTxt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = Tpl.writeText(txt, l_className);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::saveAll()\n",
                                    "{\n",
                                    "     getSimVars()->savePreVariables();\n",
                                    "}"
                                }, false));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_1117;

public function saveAll
  input Tpl.Text txt;
  input SimCode.ModelInfo a_modelInfo;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  out_txt := fun_1117(txt, a_simCode);
  out_a_extraFuncs := a_extraFuncs;
  out_a_extraFuncsDecl := a_extraFuncsDecl;
  out_a_extraFuncsNamespace := a_extraFuncsNamespace;
  out_a_stateDerVectorName := a_stateDerVectorName;
end saveAll;

protected function lm_1119
  input Tpl.Text in_txt;
  input list<list<SimCodeVar.SimVar>> in_items;
  input Tpl.Text in_a_className;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_funcCalls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_className;
  output Tpl.Text out_a_funcCalls;
algorithm
  (out_txt, out_a_className, out_a_funcCalls) :=
  match(in_txt, in_items, in_a_className, in_a_useFlatArrayNotation, in_a_funcCalls)
    local
      Tpl.Text txt;
      list<list<SimCodeVar.SimVar>> rest;
      Tpl.Text a_className;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_funcCalls;
      Integer x_i0;
      list<SimCodeVar.SimVar> i_part;

    case ( txt,
           {},
           a_className,
           _,
           a_funcCalls )
      then (txt, a_className, a_funcCalls);

    case ( txt,
           i_part :: rest,
           a_className,
           a_useFlatArrayNotation,
           a_funcCalls )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        (txt, a_funcCalls, a_className) = saveDiscreteVars1(txt, i_part, x_i0, 100, a_funcCalls, a_useFlatArrayNotation, a_className);
        txt = Tpl.nextIter(txt);
        (txt, a_className, a_funcCalls) = lm_1119(txt, rest, a_className, a_useFlatArrayNotation, a_funcCalls);
      then (txt, a_className, a_funcCalls);
  end match;
end lm_1119;

protected function fun_1120
  input Tpl.Text in_txt;
  input String in_mArg;
  input Tpl.Text in_a_n__vars;
  input Boolean in_a_useFlatArrayNotation;
  input list<SimCodeVar.SimVar> in_a_vars_boolAlgVars;
  input list<SimCodeVar.SimVar> in_a_vars_intAlgVars;
  input list<SimCodeVar.SimVar> in_a_vars_discreteAlgVars;
  input list<SimCodeVar.SimVar> in_a_vars_algVars;
  input Tpl.Text in_a_className;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_className;
algorithm
  (out_txt, out_a_className) :=
  match(in_txt, in_mArg, in_a_n__vars, in_a_useFlatArrayNotation, in_a_vars_boolAlgVars, in_a_vars_intAlgVars, in_a_vars_discreteAlgVars, in_a_vars_algVars, in_a_className)
    local
      Tpl.Text txt;
      Tpl.Text a_n__vars;
      Boolean a_useFlatArrayNotation;
      list<SimCodeVar.SimVar> a_vars_boolAlgVars;
      list<SimCodeVar.SimVar> a_vars_intAlgVars;
      list<SimCodeVar.SimVar> a_vars_discreteAlgVars;
      list<SimCodeVar.SimVar> a_vars_algVars;
      Tpl.Text a_className;
      list<list<SimCodeVar.SimVar>> ret_5;
      list<SimCodeVar.SimVar> ret_4;
      list<SimCodeVar.SimVar> ret_3;
      list<SimCodeVar.SimVar> ret_2;
      Tpl.Text l_saveDiscreteVarFuncs;
      Tpl.Text l_funcCalls;

    case ( txt,
           "0",
           _,
           _,
           _,
           _,
           _,
           _,
           a_className )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = Tpl.writeText(txt, a_className);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::saveDiscreteVars()\n",
                                    "{\n",
                                    "}"
                                }, false));
      then (txt, a_className);

    case ( txt,
           _,
           a_n__vars,
           a_useFlatArrayNotation,
           a_vars_boolAlgVars,
           a_vars_intAlgVars,
           a_vars_discreteAlgVars,
           a_vars_algVars,
           a_className )
      equation
        l_funcCalls = Tpl.emptyTxt;
        ret_2 = listAppend(a_vars_intAlgVars, a_vars_boolAlgVars);
        ret_3 = listAppend(a_vars_discreteAlgVars, ret_2);
        ret_4 = listAppend(a_vars_algVars, ret_3);
        ret_5 = List.partition(ret_4, 100);
        l_saveDiscreteVarFuncs = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_saveDiscreteVarFuncs, a_className, l_funcCalls) = lm_1119(l_saveDiscreteVarFuncs, ret_5, a_className, a_useFlatArrayNotation, l_funcCalls);
        l_saveDiscreteVarFuncs = Tpl.popIter(l_saveDiscreteVarFuncs);
        txt = Tpl.writeText(txt, l_saveDiscreteVarFuncs);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "void "
                                }, false));
        txt = Tpl.writeText(txt, a_className);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::saveDiscreteVars()\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(3));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("double discreteVars["));
        txt = Tpl.writeText(txt, a_n__vars);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "];\n",
                                    "\n"
                                }, true));
        txt = Tpl.writeText(txt, l_funcCalls);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.popBlock(txt);
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_event_handling->saveDiscretPreVars(discreteVars,"));
        txt = Tpl.writeText(txt, a_n__vars);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(");\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n"
                                }, true));
      then (txt, a_className);
  end match;
end fun_1120;

protected function fun_1121
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      Absyn.Path i_modelInfo_name;
      list<SimCodeVar.SimVar> i_vars_boolAlgVars;
      list<SimCodeVar.SimVar> i_vars_intAlgVars;
      list<SimCodeVar.SimVar> i_vars_discreteAlgVars;
      list<SimCodeVar.SimVar> i_vars_algVars;
      String str_9;
      Tpl.Text l_className;
      Integer ret_7;
      Integer ret_6;
      Integer ret_5;
      Integer ret_4;
      Integer ret_3;
      Integer ret_2;
      Integer ret_1;
      Tpl.Text l_n__vars;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(vars = SimCodeVar.SIMVARS(algVars = i_vars_algVars, discreteAlgVars = i_vars_discreteAlgVars, intAlgVars = i_vars_intAlgVars, boolAlgVars = i_vars_boolAlgVars), name = i_modelInfo_name)),
           a_useFlatArrayNotation )
      equation
        ret_1 = listLength(i_vars_algVars);
        ret_2 = listLength(i_vars_discreteAlgVars);
        ret_3 = intAdd(ret_1, ret_2);
        ret_4 = listLength(i_vars_intAlgVars);
        ret_5 = listLength(i_vars_boolAlgVars);
        ret_6 = intAdd(ret_4, ret_5);
        ret_7 = intAdd(ret_3, ret_6);
        l_n__vars = Tpl.writeStr(Tpl.emptyTxt, intString(ret_7));
        l_className = lastIdentOfPath(Tpl.emptyTxt, i_modelInfo_name);
        str_9 = Tpl.textString(l_n__vars);
        (txt, l_className) = fun_1120(txt, str_9, l_n__vars, a_useFlatArrayNotation, i_vars_boolAlgVars, i_vars_intAlgVars, i_vars_discreteAlgVars, i_vars_algVars, l_className);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_1121;

public function saveDiscreteVars
  input Tpl.Text txt;
  input SimCode.ModelInfo a_modelInfo;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  out_txt := fun_1121(txt, a_simCode, a_useFlatArrayNotation);
  out_a_extraFuncs := a_extraFuncs;
  out_a_extraFuncsDecl := a_extraFuncsDecl;
  out_a_extraFuncsNamespace := a_extraFuncsNamespace;
end saveDiscreteVars;

public function saveDiscreteVars1
  input Tpl.Text txt;
  input list<SimCodeVar.SimVar> a_partVars;
  input Integer a_partIdx;
  input Integer a_multiplicator;
  input Tpl.Text a_funcCalls;
  input Boolean a_useFlatArrayNotation;
  input Tpl.Text a_className;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_funcCalls;
  output Tpl.Text out_a_className;
algorithm
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING("void "));
  out_txt := Tpl.writeText(out_txt, a_className);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("::saveDiscreteVars_"));
  out_txt := Tpl.writeStr(out_txt, intString(a_partIdx));
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "(double* discreteVars)\n",
                                       "{\n",
                                       "\n",
                                       "}"
                                   }, false));
  out_a_funcCalls := a_funcCalls;
  out_a_className := a_className;
end saveDiscreteVars1;

protected function fun_1124
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_modelInfo, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_context, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      SimCodeFunction.Context a_context;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      list<SimCodeVar.SimVar> i_vars_boolAlgVars;
      list<SimCodeVar.SimVar> i_vars_intAlgVars;
      list<SimCodeVar.SimVar> i_vars_discreteAlgVars;
      list<SimCodeVar.SimVar> i_vars_algVars;
      Tpl.Text l_boolvars;
      Tpl.Text l_intvars;
      Tpl.Text l_discretealgvars;
      Tpl.Text l_algvars;
      Tpl.Text l_text;
      Tpl.Text l_varDecls;

    case ( txt,
           SimCode.MODELINFO(vars = SimCodeVar.SIMVARS(algVars = i_vars_algVars, discreteAlgVars = i_vars_discreteAlgVars, intAlgVars = i_vars_intAlgVars, boolAlgVars = i_vars_boolAlgVars)),
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_context,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_varDecls = Tpl.emptyTxt;
        l_text = Tpl.emptyTxt;
        (l_algvars, l_varDecls, _, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = initValst(Tpl.emptyTxt, l_varDecls, Tpl.strTokText(Tpl.ST_STRING("Real")), i_vars_algVars, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_context, a_stateDerVectorName, a_useFlatArrayNotation);
        (l_discretealgvars, l_varDecls, _, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = initValst(Tpl.emptyTxt, l_varDecls, Tpl.strTokText(Tpl.ST_STRING("Real")), i_vars_discreteAlgVars, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_context, a_stateDerVectorName, a_useFlatArrayNotation);
        (l_intvars, l_varDecls, _, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = initValst(Tpl.emptyTxt, l_varDecls, Tpl.strTokText(Tpl.ST_STRING("Int")), i_vars_intAlgVars, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_context, a_stateDerVectorName, a_useFlatArrayNotation);
        (l_boolvars, l_varDecls, _, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = initValst(Tpl.emptyTxt, l_varDecls, Tpl.strTokText(Tpl.ST_STRING("Bool")), i_vars_boolAlgVars, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_context, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeText(txt, l_varDecls);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_algvars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_discretealgvars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_intvars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_boolvars);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           _,
           a_stateDerVectorName,
           _ )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end fun_1124;

public function initAlgloopvars
  input Tpl.Text txt;
  input Tpl.Text a_preExp;
  input Tpl.Text a_varDecls;
  input SimCode.ModelInfo a_modelInfo;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) := fun_1124(txt, a_modelInfo, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_context, a_stateDerVectorName, a_useFlatArrayNotation);
  out_a_preExp := a_preExp;
  out_a_varDecls := a_varDecls;
end initAlgloopvars;

protected function lm_1126
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           (i_eq as SimCode.SES_SIMPLE_ASSIGN(index = _)) :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls )
      equation
        (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = equation_(txt, i_eq, SimCodeFunction.contextSimulationDiscrete, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = lm_1126(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           _ :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls )
      equation
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = lm_1126(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);
  end match;
end lm_1126;

protected function lm_1127
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           (i_eq as SimCode.SES_ALGORITHM(index = _)) :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls )
      equation
        (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = equation_(txt, i_eq, SimCodeFunction.contextSimulationDiscrete, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = lm_1127(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           _ :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls )
      equation
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = lm_1127(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);
  end match;
end lm_1127;

public function boundParameters
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_parameterEquations;
  input Tpl.Text a_varDecls;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
protected
  Tpl.Text l_divbody;
  Tpl.Text l_body;
  Tpl.Text l_tmp;
algorithm
  l_tmp := Tpl.emptyTxt;
  l_body := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (l_body, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) := lm_1126(l_body, a_parameterEquations, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls);
  l_body := Tpl.popIter(l_body);
  l_divbody := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (l_divbody, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) := lm_1127(l_divbody, a_parameterEquations, a_useFlatArrayNotation, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, a_simCode, out_a_varDecls);
  l_divbody := Tpl.popIter(l_divbody);
  out_txt := Tpl.writeText(txt, l_body);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeText(out_txt, l_divbody);
end boundParameters;

protected function lm_1129
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      DAE.ComponentRef i_name;
      Integer i_index;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(index = i_index, name = i_name) :: rest )
      equation
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(",\""));
        txt = CodegenCppCommonOld.crefStr(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        txt = Tpl.nextIter(txt);
        txt = lm_1129(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_1129(txt, rest);
      then txt;
  end match;
end lm_1129;

protected function smf_1130
  input Tpl.Text in_txt;
  input Tpl.Text in_it;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_it)
    local
      Tpl.Text txt;
      Tpl.Text i_it;

    case ( txt,
           i_it )
      equation
        txt = Tpl.writeText(txt, i_it);
      then txt;
  end match;
end smf_1130;

protected function fun_1131
  input Tpl.Text in_txt;
  input Integer in_a_varInfo_numOutVars;
  input list<SimCodeVar.SimVar> in_a_vars_outputVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_varInfo_numOutVars, in_a_vars_outputVars)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> a_vars_outputVars;
      Tpl.Text txt_0;

    case ( txt,
           0,
           _ )
      then txt;

    case ( txt,
           _,
           a_vars_outputVars )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("var_ouputs_idx = MAP_LIST_OF "));
        txt_0 = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt_0 = lm_1129(txt_0, a_vars_outputVars);
        txt_0 = Tpl.popIter(txt_0);
        txt = smf_1130(txt, txt_0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" MAP_LIST_END;"));
      then txt;
  end match;
end fun_1131;

public function outputIndices
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> i_vars_outputVars;
      Integer i_varInfo_numOutVars;

    case ( txt,
           SimCode.MODELINFO(varInfo = SimCode.VARINFO(numOutVars = i_varInfo_numOutVars), vars = SimCodeVar.SIMVARS(outputVars = i_vars_outputVars)) )
      equation
        txt = fun_1131(txt, i_varInfo_numOutVars, i_vars_outputVars);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end outputIndices;

protected function fun_1133
  input Tpl.Text in_txt;
  input SimCodeVar.Causality in_a_c;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_c)
    local
      Tpl.Text txt;

    case ( txt,
           SimCodeVar.OUTPUT() )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("output"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_1133;

public function isOutput
  input Tpl.Text txt;
  input SimCodeVar.Causality a_c;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_1133(txt, a_c);
end isOutput;

protected function lm_1135
  input Tpl.Text in_txt;
  input list<list<SimCodeVar.SimVar>> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_type;
  input Tpl.Text in_a_funcNamePrefix;
  input Tpl.Text in_a_funcCalls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_type;
  output Tpl.Text out_a_funcCalls;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_type, out_a_funcCalls) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_context, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_type, in_a_funcNamePrefix, in_a_funcCalls)
    local
      Tpl.Text txt;
      list<list<SimCodeVar.SimVar>> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      SimCodeFunction.Context a_context;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_type;
      Tpl.Text a_funcNamePrefix;
      Tpl.Text a_funcCalls;
      Integer x_idx;
      list<SimCodeVar.SimVar> i_ls;
      Tpl.Text l_init;
      Tpl.Text l_varDecls;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           _,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_type,
           _,
           a_funcCalls )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_type, a_funcCalls);

    case ( txt,
           i_ls :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_context,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_type,
           a_funcNamePrefix,
           a_funcCalls )
      equation
        x_idx = Tpl.getIteri_i0(txt);
        l_varDecls = Tpl.emptyTxt;
        a_funcCalls = Tpl.writeText(a_funcCalls, a_funcNamePrefix);
        a_funcCalls = Tpl.writeTok(a_funcCalls, Tpl.ST_STRING("_"));
        a_funcCalls = Tpl.writeStr(a_funcCalls, intString(x_idx));
        a_funcCalls = Tpl.writeTok(a_funcCalls, Tpl.ST_STRING("();"));
        (l_init, l_varDecls, a_type, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = initValst(Tpl.emptyTxt, l_varDecls, a_type, i_ls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_context, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = Tpl.writeText(txt, a_funcNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeStr(txt, intString(x_idx));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "()\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(3));
        txt = Tpl.writeText(txt, l_varDecls);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_init);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_type, a_funcCalls) = lm_1135(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_context, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_type, a_funcNamePrefix, a_funcCalls);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_type, a_funcCalls);
  end match;
end lm_1135;

public function initValstWithSplit
  input Tpl.Text txt;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_type;
  input Tpl.Text a_funcNamePrefix;
  input list<SimCodeVar.SimVar> a_varsLst;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_type;
  output Tpl.Text out_a_funcNamePrefix;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
protected
  list<list<SimCodeVar.SimVar>> ret_2;
  Tpl.Text l_funcs;
  Tpl.Text l_funcCalls;
algorithm
  l_funcCalls := Tpl.emptyTxt;
  ret_2 := List.partition(a_varsLst, 100);
  l_funcs := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (l_funcs, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_type, l_funcCalls) := lm_1135(l_funcs, ret_2, a_useFlatArrayNotation, a_stateDerVectorName, a_context, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_type, a_funcNamePrefix, l_funcCalls);
  l_funcs := Tpl.popIter(l_funcs);
  out_txt := Tpl.writeText(txt, l_funcs);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "void "
                                   }, false));
  out_txt := Tpl.writeText(out_txt, a_funcNamePrefix);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "()\n",
                                       "{\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeText(out_txt, l_funcCalls);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("}"));
  out_a_varDecls := a_varDecls;
  out_a_funcNamePrefix := a_funcNamePrefix;
end initValstWithSplit;

protected function fun_1137
  input Tpl.Text in_txt;
  input Option<DAE.Exp> in_a_initialValue;
  input DAE.Type in_a_sv_type__;
  input Tpl.Text in_a_crefStr;
  input Tpl.Text in_a_type;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_startValue;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_startValue;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp, out_a_startValue) :=
  match(in_txt, in_a_initialValue, in_a_sv_type__, in_a_crefStr, in_a_type, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_preExp, in_a_startValue)
    local
      Tpl.Text txt;
      DAE.Type a_sv_type__;
      Tpl.Text a_crefStr;
      Tpl.Text a_type;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      Tpl.Text a_startValue;
      DAE.Exp i_v;

    case ( txt,
           SOME(i_v),
           _,
           a_crefStr,
           a_type,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp,
           a_startValue )
      equation
        (a_startValue, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.daeExp(a_startValue, i_v, SimCodeFunction.contextOther, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeText(txt, a_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(8));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if(!IsEqual(SystemDefaultImplementation::get"));
        txt = Tpl.writeText(txt, a_type);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("StartValue("));
        txt = Tpl.writeText(txt, a_crefStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("), "));
        txt = Tpl.writeText(txt, a_startValue);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("))\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("std::cerr << \"Wrong start value for variable "));
        txt = Tpl.writeText(txt, a_crefStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" detected. Got \" << SystemDefaultImplementation::get"));
        txt = Tpl.writeText(txt, a_type);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("StartValue("));
        txt = Tpl.writeText(txt, a_crefStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") << \" Expected: \" << "));
        txt = Tpl.writeText(txt, a_startValue);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" << std::endl;"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.popBlock(txt);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp, a_startValue);

    case ( txt,
           _,
           a_sv_type__,
           _,
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           a_preExp,
           a_startValue )
      equation
        a_startValue = startValue(a_startValue, a_sv_type__);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp, a_startValue);
  end match;
end fun_1137;

protected function lm_1138
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Tpl.Text in_a_type;
  input Tpl.Text in_a_varDecls;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_varDecls, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_type, in_a_varDecls, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_context, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Tpl.Text a_type;
      Tpl.Text a_varDecls;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      SimCodeFunction.Context a_context;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      DAE.Type i_sv_type__;
      Option<DAE.Exp> i_initialValue;
      DAE.ComponentRef i_sv_name;
      Tpl.Text l_checkStr;
      Tpl.Text l_crefStr;
      Tpl.Text l_startValue;
      Tpl.Text l_varDeclsCref;
      Tpl.Text l_preExp;

    case ( txt,
           {},
           _,
           a_varDecls,
           _,
           a_stateDerVectorName,
           _,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_varDecls, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           SimCodeVar.SIMVAR(name = i_sv_name, initialValue = i_initialValue, type_ = i_sv_type__) :: rest,
           a_type,
           a_varDecls,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_context,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        l_preExp = Tpl.emptyTxt;
        l_varDeclsCref = Tpl.emptyTxt;
        l_startValue = Tpl.emptyTxt;
        (l_crefStr, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, l_varDeclsCref, a_stateDerVectorName) = CodegenCppCommonOld.cref1(Tpl.emptyTxt, i_sv_name, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_context, l_varDeclsCref, a_stateDerVectorName, a_useFlatArrayNotation);
        (l_checkStr, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, l_preExp, l_startValue) = fun_1137(Tpl.emptyTxt, i_initialValue, i_sv_type__, l_crefStr, a_type, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, l_preExp, l_startValue);
        txt = Tpl.writeText(txt, l_checkStr);
        txt = Tpl.nextIter(txt);
        (txt, a_varDecls, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1138(txt, rest, a_type, a_varDecls, a_useFlatArrayNotation, a_stateDerVectorName, a_context, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_varDecls, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _ :: rest,
           a_type,
           a_varDecls,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_context,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_varDecls, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1138(txt, rest, a_type, a_varDecls, a_useFlatArrayNotation, a_stateDerVectorName, a_context, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_varDecls, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_1138;

protected function fun_1139
  input Tpl.Text in_txt;
  input Option<DAE.Exp> in_a_initialValue;
  input DAE.Type in_a_sv_type__;
  input Tpl.Text in_a_crefStr;
  input Tpl.Text in_a_type;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_a_initialValue, in_a_sv_type__, in_a_crefStr, in_a_type, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_preExp)
    local
      Tpl.Text txt;
      DAE.Type a_sv_type__;
      Tpl.Text a_crefStr;
      Tpl.Text a_type;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      DAE.Exp i_v;
      Tpl.Text l_vStr;

    case ( txt,
           SOME(i_v),
           _,
           a_crefStr,
           a_type,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp )
      equation
        (l_vStr, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.daeExp(Tpl.emptyTxt, i_v, SimCodeFunction.contextOther, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeText(txt, a_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("SystemDefaultImplementation::set"));
        txt = Tpl.writeText(txt, a_type);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("StartValue("));
        txt = Tpl.writeText(txt, a_crefStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, l_vStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);

    case ( txt,
           _,
           a_sv_type__,
           a_crefStr,
           a_type,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           a_preExp )
      equation
        txt = Tpl.writeText(txt, a_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("SystemDefaultImplementation::set"));
        txt = Tpl.writeText(txt, a_type);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("StartValue("));
        txt = Tpl.writeText(txt, a_crefStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = startValue(txt, a_sv_type__);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);
  end match;
end fun_1139;

protected function lm_1140
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Tpl.Text in_a_type;
  input Tpl.Text in_a_varDecls;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_varDecls, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_type, in_a_varDecls, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_context, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Tpl.Text a_type;
      Tpl.Text a_varDecls;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      SimCodeFunction.Context a_context;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      DAE.Type i_sv_type__;
      Option<DAE.Exp> i_initialValue;
      DAE.ComponentRef i_sv_name;
      Tpl.Text l_crefStr;
      Tpl.Text l_startValue;
      Tpl.Text l_varDeclsCref;
      Tpl.Text l_preExp;

    case ( txt,
           {},
           _,
           a_varDecls,
           _,
           a_stateDerVectorName,
           _,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_varDecls, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           SimCodeVar.SIMVAR(name = i_sv_name, initialValue = i_initialValue, type_ = i_sv_type__) :: rest,
           a_type,
           a_varDecls,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_context,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        l_preExp = Tpl.emptyTxt;
        l_varDeclsCref = Tpl.emptyTxt;
        l_startValue = Tpl.emptyTxt;
        (l_crefStr, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, l_varDeclsCref, a_stateDerVectorName) = CodegenCppCommonOld.cref1(Tpl.emptyTxt, i_sv_name, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_context, l_varDeclsCref, a_stateDerVectorName, a_useFlatArrayNotation);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, l_preExp) = fun_1139(txt, i_initialValue, i_sv_type__, l_crefStr, a_type, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, l_preExp);
        txt = Tpl.nextIter(txt);
        (txt, a_varDecls, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1140(txt, rest, a_type, a_varDecls, a_useFlatArrayNotation, a_stateDerVectorName, a_context, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_varDecls, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _ :: rest,
           a_type,
           a_varDecls,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_context,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_varDecls, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1140(txt, rest, a_type, a_varDecls, a_useFlatArrayNotation, a_stateDerVectorName, a_context, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_varDecls, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_1140;

protected function fun_1141
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_type;
  input list<SimCodeVar.SimVar> in_a_varsLst;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_mArg, in_a_varDecls, in_a_type, in_a_varsLst, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_context, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      Tpl.Text a_varDecls;
      Tpl.Text a_type;
      list<SimCodeVar.SimVar> a_varsLst;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      SimCodeFunction.Context a_context;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;

    case ( txt,
           false,
           a_varDecls,
           a_type,
           a_varsLst,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_context,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_varDecls, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1138(txt, a_varsLst, a_type, a_varDecls, a_useFlatArrayNotation, a_stateDerVectorName, a_context, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
        txt = Tpl.popIter(txt);
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           a_varDecls,
           a_type,
           a_varsLst,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_context,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_varDecls, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1140(txt, a_varsLst, a_type, a_varDecls, a_useFlatArrayNotation, a_stateDerVectorName, a_context, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
        txt = Tpl.popIter(txt);
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end fun_1141;

public function initValst
  input Tpl.Text txt;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_type;
  input list<SimCodeVar.SimVar> a_varsLst;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_type;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
protected
  Boolean ret_0;
algorithm
  ret_0 := Flags.isSet(Flags.HARDCODED_START_VALUES);
  (out_txt, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) := fun_1141(txt, ret_0, a_varDecls, a_type, a_varsLst, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_context, a_stateDerVectorName, a_useFlatArrayNotation);
  out_a_type := a_type;
end initValst;

public function startValue
  input Tpl.Text in_txt;
  input DAE.Type in_a_ty;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_ty)
    local
      Tpl.Text txt;
      DAE.Type i_elty;

    case ( txt,
           DAE.T_INTEGER(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("0"));
      then txt;

    case ( txt,
           DAE.T_REAL(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("0.0"));
      then txt;

    case ( txt,
           DAE.T_BOOL(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("false"));
      then txt;

    case ( txt,
           DAE.T_STRING(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\"empty\""));
      then txt;

    case ( txt,
           DAE.T_ENUMERATION(index = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("0"));
      then txt;

    case ( txt,
           DAE.T_ARRAY(ty = i_elty) )
      equation
        txt = startValue(txt, i_elty);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end startValue;

protected function fun_1144
  input Tpl.Text in_txt;
  input Integer in_a_vi_numZeroCrossings;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_vi_numZeroCrossings)
    local
      Tpl.Text txt;
      Integer i_vi_numZeroCrossings;

    case ( txt,
           0 )
      then txt;

    case ( txt,
           i_vi_numZeroCrossings )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("bool events["));
        txt = Tpl.writeStr(txt, intString(i_vi_numZeroCrossings));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "];\n",
                                    "memset(events,true,"
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_vi_numZeroCrossings));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ");\n",
                                    "for(int i=0;i<="
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_vi_numZeroCrossings));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";++i) { handleEvent(events); }"));
      then txt;
  end match;
end fun_1144;

protected function fun_1145
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      Integer i_vi_numZeroCrossings;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(varInfo = SimCode.VARINFO(numZeroCrossings = i_vi_numZeroCrossings))) )
      equation
        txt = fun_1144(txt, i_vi_numZeroCrossings);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_1145;

public function eventHandlingInit
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  out_txt := fun_1145(txt, a_simCode);
  out_a_extraFuncs := a_extraFuncs;
  out_a_extraFuncsDecl := a_extraFuncsDecl;
  out_a_extraFuncsNamespace := a_extraFuncsNamespace;
end eventHandlingInit;

protected function fun_1147
  input Tpl.Text in_txt;
  input DAE.ClockKind in_a_baseClock;
  input Tpl.Text in_a_spec;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_baseClock, in_a_spec)
    local
      Tpl.Text txt;
      Tpl.Text a_spec;

    case ( txt,
           DAE.REAL_CLOCK(interval = _),
           a_spec )
      equation
        txt = Tpl.writeText(txt, a_spec);
      then txt;

    case ( txt,
           DAE.INTEGER_CLOCK(intervalCounter = _),
           a_spec )
      equation
        txt = Tpl.writeText(txt, a_spec);
      then txt;

    case ( txt,
           DAE.BOOLEAN_CLOCK(condition = _),
           a_spec )
      equation
        txt = Tpl.writeText(txt, a_spec);
      then txt;

    case ( txt,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("unspecified"));
      then txt;
  end match;
end fun_1147;

protected function fun_1148
  input Tpl.Text in_txt;
  input Option<SimCode.FmiModelStructure> in_a_fmims;
  input DAE.ClockKind in_a_baseClock;
  input Tpl.Text in_a_spec;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fmims, in_a_baseClock, in_a_spec)
    local
      Tpl.Text txt;
      DAE.ClockKind a_baseClock;
      Tpl.Text a_spec;

    case ( txt,
           SOME(_),
           _,
           a_spec )
      equation
        txt = Tpl.writeText(txt, a_spec);
      then txt;

    case ( txt,
           _,
           a_baseClock,
           a_spec )
      equation
        txt = fun_1147(txt, a_baseClock, a_spec);
      then txt;
  end match;
end fun_1148;

protected function fun_1149
  input Tpl.Text in_txt;
  input String in_mArg;
  input Tpl.Text in_a_intvl;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_intvl)
    local
      Tpl.Text txt;
      Tpl.Text a_intvl;

    case ( txt,
           "unspecified",
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("1.0"));
      then txt;

    case ( txt,
           _,
           a_intvl )
      equation
        txt = Tpl.writeText(txt, a_intvl);
      then txt;
  end match;
end fun_1149;

protected function fun_1150
  input Tpl.Text in_txt;
  input String in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           "unspecified" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("ModelicaMessage(\"Using default Clock(1.0)!\");"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_1150;

protected function fun_1151
  input Tpl.Text in_txt;
  input SimCode.SubPartition in_a_subPartition;
  input Tpl.Text in_a_interval;
  input Tpl.Text in_a_i;
  input Tpl.Text in_a_preExp;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_subPartition, in_a_interval, in_a_i, in_a_preExp)
    local
      Tpl.Text txt;
      Tpl.Text a_interval;
      Tpl.Text a_i;
      Tpl.Text a_preExp;
      Integer i_sres;
      Integer i_snom;
      Integer i_fres;
      Integer i_fnom;

    case ( txt,
           SimCode.SUBPARTITION(subClock = BackendDAE.SUBCLOCK(factor = MMath.RATIONAL(nom = i_fnom, denom = i_fres), shift = MMath.RATIONAL(nom = i_snom, denom = i_sres))),
           a_interval,
           a_i,
           a_preExp )
      equation
        txt = Tpl.writeText(txt, a_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_clockInterval["));
        txt = Tpl.writeText(txt, a_i);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = "));
        txt = Tpl.writeText(txt, a_interval);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" * "));
        txt = Tpl.writeStr(txt, intString(i_fnom));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".0 / "));
        txt = Tpl.writeStr(txt, intString(i_fres));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ".0;\n",
                                    "_clockShift["
                                }, false));
        txt = Tpl.writeText(txt, a_i);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = "));
        txt = Tpl.writeStr(txt, intString(i_snom));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".0 / "));
        txt = Tpl.writeStr(txt, intString(i_sres));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ".0;\n",
                                    "_clockTime["
                                }, false));
        txt = Tpl.writeText(txt, a_i);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = _simTime + _clockShift["));
        txt = Tpl.writeText(txt, a_i);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] * _clockInterval["));
        txt = Tpl.writeText(txt, a_i);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "];\n",
                                    "_clockStart["
                                }, false));
        txt = Tpl.writeText(txt, a_i);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "] = true;\n",
                                    "_clockSubactive["
                                }, false));
        txt = Tpl.writeText(txt, a_i);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("] = false;\n"));
        txt = Tpl.writeText(txt, a_i);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" ++;"));
      then txt;

    case ( txt,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_1151;

protected function lm_1152
  input Tpl.Text in_txt;
  input list<SimCode.SubPartition> in_items;
  input Tpl.Text in_a_interval;
  input Tpl.Text in_a_i;
  input Tpl.Text in_a_preExp;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_interval, in_a_i, in_a_preExp)
    local
      Tpl.Text txt;
      list<SimCode.SubPartition> rest;
      Tpl.Text a_interval;
      Tpl.Text a_i;
      Tpl.Text a_preExp;
      SimCode.SubPartition i_subPartition;

    case ( txt,
           {},
           _,
           _,
           _ )
      then txt;

    case ( txt,
           i_subPartition :: rest,
           a_interval,
           a_i,
           a_preExp )
      equation
        txt = fun_1151(txt, i_subPartition, a_interval, a_i, a_preExp);
        txt = Tpl.nextIter(txt);
        txt = lm_1152(txt, rest, a_interval, a_i, a_preExp);
      then txt;
  end match;
end lm_1152;

protected function fun_1153
  input Tpl.Text in_txt;
  input SimCode.ClockedPartition in_a_partition;
  input Tpl.Text in_a_i;
  input Option<SimCode.FmiModelStructure> in_a_fmims;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) :=
  match(in_txt, in_a_partition, in_a_i, in_a_fmims, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_i;
      Option<SimCode.FmiModelStructure> a_fmims;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      list<SimCode.SubPartition> i_subPartitions;
      DAE.ClockKind i_baseClock;
      Tpl.Text l_subClocks;
      String str_7;
      Tpl.Text l_warning;
      String str_5;
      Tpl.Text l_interval;
      Tpl.Text l_intvl;
      DAE.Exp ret_2;
      Tpl.Text l_spec;
      Tpl.Text l_preExp;

    case ( txt,
           SimCode.CLOCKED_PARTITION(baseClock = i_baseClock, subPartitions = i_subPartitions),
           a_i,
           a_fmims,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls )
      equation
        l_preExp = Tpl.emptyTxt;
        ret_2 = Expression.getClockInterval(i_baseClock);
        (l_spec, l_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.daeExp(Tpl.emptyTxt, ret_2, SimCodeFunction.contextOther, l_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        l_intvl = fun_1148(Tpl.emptyTxt, a_fmims, i_baseClock, l_spec);
        str_5 = Tpl.textString(l_intvl);
        l_interval = fun_1149(Tpl.emptyTxt, str_5, l_intvl);
        str_7 = Tpl.textString(l_intvl);
        l_warning = fun_1150(Tpl.emptyTxt, str_7);
        l_subClocks = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_subClocks = lm_1152(l_subClocks, i_subPartitions, l_interval, a_i, l_preExp);
        l_subClocks = Tpl.popIter(l_subClocks);
        txt = Tpl.writeText(txt, l_subClocks);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_warning);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           _,
           _,
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);
  end match;
end fun_1153;

protected function lm_1154
  input Tpl.Text in_txt;
  input list<SimCode.ClockedPartition> in_items;
  input Tpl.Text in_a_i;
  input Option<SimCode.FmiModelStructure> in_a_fmims;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) :=
  match(in_txt, in_items, in_a_i, in_a_fmims, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls)
    local
      Tpl.Text txt;
      list<SimCode.ClockedPartition> rest;
      Tpl.Text a_i;
      Option<SimCode.FmiModelStructure> a_fmims;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      SimCode.ClockedPartition i_partition;

    case ( txt,
           {},
           _,
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           i_partition :: rest,
           a_i,
           a_fmims,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls )
      equation
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = fun_1153(txt, i_partition, a_i, a_fmims, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = lm_1154(txt, rest, a_i, a_fmims, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);
  end match;
end lm_1154;

public function clockIntervalsInit
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_simCode, in_a_varDecls, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      Tpl.Text a_varDecls;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      Option<SimCode.FmiModelStructure> i_fmims;
      SimCode.SimCode i_simCode;
      list<SimCode.ClockedPartition> i_clockedPartitions;
      Tpl.Text l_i;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = _), modelStructure = i_fmims, clockedPartitions = i_clockedPartitions)),
           a_varDecls,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (l_i, a_varDecls) = CodegenCppCommonOld.tempDecl(Tpl.emptyTxt, "int", a_varDecls);
        txt = Tpl.writeText(txt, l_i);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" = 0;\n"));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = lm_1154(txt, i_clockedPartitions, l_i, i_fmims, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, i_simCode, a_varDecls);
        txt = Tpl.popIter(txt);
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           a_varDecls,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end clockIntervalsInit;

protected function fun_1156
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      Integer i_partitionData_numPartitions;
      list<SimCodeVar.SimVar> i_algebraicVars;
      Integer i_vi_numStateVars;
      SimCode.ModelInfo i_modelInfo;
      Integer ret_6;
      Integer ret_5;
      Integer ret_4;
      Tpl.Text l_numStringVars;
      Tpl.Text l_numBoolVars;
      Tpl.Text l_numIntVars;
      Tpl.Text l_numRealVars;

    case ( txt,
           SimCode.SIMCODE(modelInfo = (i_modelInfo as SimCode.MODELINFO(varInfo = SimCode.VARINFO(numStateVars = i_vi_numStateVars))), daeModeData = SOME(SimCode.DAEMODEDATA(algebraicVars = i_algebraicVars, residualVars = _)), partitionData = SimCode.PARTITIONDATA(numPartitions = i_partitionData_numPartitions)) )
      equation
        l_numRealVars = numRealvars(Tpl.emptyTxt, i_modelInfo);
        l_numIntVars = numIntvars(Tpl.emptyTxt, i_modelInfo);
        l_numBoolVars = numBoolvars(Tpl.emptyTxt, i_modelInfo);
        l_numStringVars = numStringvars(Tpl.emptyTxt, i_modelInfo);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_dimContinuousStates = "));
        txt = Tpl.writeStr(txt, intString(i_vi_numStateVars));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "_dimAE = "
                                }, false));
        ret_4 = listLength(i_algebraicVars);
        txt = Tpl.writeStr(txt, intString(ret_4));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "_dimRHS =  "
                                }, false));
        ret_5 = listLength(i_algebraicVars);
        ret_6 = intAdd(i_vi_numStateVars, ret_5);
        txt = Tpl.writeStr(txt, intString(ret_6));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "_dimBoolean = "
                                }, false));
        txt = Tpl.writeText(txt, l_numBoolVars);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "_dimInteger = "
                                }, false));
        txt = Tpl.writeText(txt, l_numIntVars);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "_dimString = "
                                }, false));
        txt = Tpl.writeText(txt, l_numStringVars);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "_dimReal = "
                                }, false));
        txt = Tpl.writeText(txt, l_numRealVars);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "_dimPartitions = "
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_partitionData_numPartitions));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           SimCode.SIMCODE(modelInfo = (i_modelInfo as SimCode.MODELINFO(varInfo = SimCode.VARINFO(numStateVars = i_vi_numStateVars))), daeModeData = NONE(), partitionData = SimCode.PARTITIONDATA(numPartitions = i_partitionData_numPartitions)) )
      equation
        l_numRealVars = numRealvars(Tpl.emptyTxt, i_modelInfo);
        l_numIntVars = numIntvars(Tpl.emptyTxt, i_modelInfo);
        l_numBoolVars = numBoolvars(Tpl.emptyTxt, i_modelInfo);
        l_numStringVars = numStringvars(Tpl.emptyTxt, i_modelInfo);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_dimContinuousStates = "));
        txt = Tpl.writeStr(txt, intString(i_vi_numStateVars));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "_dimRHS =  "
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_vi_numStateVars));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "_dimBoolean = "
                                }, false));
        txt = Tpl.writeText(txt, l_numBoolVars);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "_dimInteger = "
                                }, false));
        txt = Tpl.writeText(txt, l_numIntVars);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "_dimString = "
                                }, false));
        txt = Tpl.writeText(txt, l_numStringVars);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "_dimReal = "
                                }, false));
        txt = Tpl.writeText(txt, l_numRealVars);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "_dimPartitions = "
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_partitionData_numPartitions));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_1156;

public function dimension1
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  out_txt := fun_1156(txt, a_simCode);
  out_a_extraFuncs := a_extraFuncs;
  out_a_extraFuncsDecl := a_extraFuncsDecl;
  out_a_extraFuncsNamespace := a_extraFuncsNamespace;
end dimension1;

protected function fun_1158
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      Integer i_vi_numStateVars;
      Absyn.Path i_modelInfo_name;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(varInfo = SimCode.VARINFO(numStateVars = i_vi_numStateVars), name = i_modelInfo_name)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("bool "));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::isODE()\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("return "));
        txt = Tpl.writeStr(txt, intString(i_vi_numStateVars));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(">0 ;\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_1158;

public function isODE
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  out_txt := fun_1158(txt, a_simCode);
  out_a_extraFuncs := a_extraFuncs;
  out_a_extraFuncsDecl := a_extraFuncsDecl;
  out_a_extraFuncsNamespace := a_extraFuncsNamespace;
end isODE;

protected function fun_1160
  input Tpl.Text in_txt;
  input DAE.Exp in_a_e;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_e)
    local
      Tpl.Text txt;

    case ( txt,
           DAE.CREF(componentRef = _) )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-1"));
      then txt;
  end match;
end fun_1160;

public function testdimension
  input Tpl.Text in_txt;
  input DAE.Dimension in_a_d;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_d)
    local
      Tpl.Text txt;
      DAE.Exp i_e;

    case ( txt,
           DAE.DIM_BOOLEAN() )
      then txt;

    case ( txt,
           DAE.DIM_INTEGER(integer = _) )
      then txt;

    case ( txt,
           DAE.DIM_ENUM(enumTypeName = _) )
      then txt;

    case ( txt,
           DAE.DIM_EXP(exp = i_e) )
      equation
        txt = fun_1160(txt, i_e);
      then txt;

    case ( txt,
           DAE.DIM_UNKNOWN() )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-1"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-1"));
      then txt;
  end match;
end testdimension;

protected function lm_1162
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           (i_eq as SimCode.SES_SIMPLE_ASSIGN(index = _)) :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls )
      equation
        (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = equationInitialization_(txt, i_eq, SimCodeFunction.contextSimulationDiscrete, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = lm_1162(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           _ :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls )
      equation
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = lm_1162(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);
  end match;
end lm_1162;

public function functionInitial
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_startValueEquations;
  input Tpl.Text a_varDecls;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
protected
  Tpl.Text l_eqPart;
algorithm
  l_eqPart := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (l_eqPart, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) := lm_1162(l_eqPart, a_startValueEquations, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls);
  l_eqPart := Tpl.popIter(l_eqPart);
  out_txt := Tpl.writeText(txt, l_eqPart);
end functionInitial;

public function equationInitialization_
  input Tpl.Text txt;
  input SimCode.SimEqSystem a_eq;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_varDecls;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) := equationString(txt, a_eq, a_context, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation, true, true);
end equationInitialization_;

public function equation_
  input Tpl.Text txt;
  input SimCode.SimEqSystem a_eq;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_varDecls;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) := equationString(txt, a_eq, a_context, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation, false, false);
end equation_;

protected function fun_1166
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_ls_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_ls_index)
    local
      Tpl.Text txt;
      Integer a_ls_index;

    case ( txt,
           false,
           a_ls_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_algLoopLinearSolver->solve(_algLoop"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(",true);"));
      then txt;

    case ( txt,
           _,
           a_ls_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_algLoopLinearSolver"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("->solve();"));
      then txt;
  end match;
end fun_1166;

protected function fun_1167
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_ls_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_ls_index)
    local
      Tpl.Text txt;
      Integer a_ls_index;

    case ( txt,
           false,
           a_ls_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("double* algloop"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("Vars = _algLoopLinearSolver->getVariableWorkArray();\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(19));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("bool* conditions0"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " = _algLoopLinearSolver->getConditionsWorkArray();\n",
                                    "bool* conditions1"
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = _algLoopLinearSolver->getConditions2WorkArray();"));
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           _,
           a_ls_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("double* algloop"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Vars = _algLoopLinearSolver"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("->getVariableWorkArray();\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(19));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("bool* conditions0"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = _algLoopLinearSolver"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("->getConditionsWorkArray();\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(18));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("bool* conditions1"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = _algLoopLinearSolver"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("->getConditions2WorkArray();"));
        txt = Tpl.popBlock(txt);
      then txt;
  end match;
end fun_1167;

protected function fun_1168
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_ls_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_ls_index)
    local
      Tpl.Text txt;
      Integer a_ls_index;

    case ( txt,
           false,
           a_ls_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_algLoopLinearSolver->solve(_algLoop"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(",(iterations"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("==1));"));
      then txt;

    case ( txt,
           _,
           a_ls_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_algLoopLinearSolver"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("->solve();"));
      then txt;
  end match;
end fun_1168;

protected function fun_1169
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_ls_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_ls_index)
    local
      Tpl.Text txt;
      Integer a_ls_index;

    case ( txt,
           false,
           a_ls_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_algLoopLinearSolver->solve(_algLoop"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(",true);"));
      then txt;

    case ( txt,
           _,
           a_ls_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_algLoopLinearSolver"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("->solve();"));
      then txt;
  end match;
end fun_1169;

protected function fun_1170
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_ls_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_ls_index)
    local
      Tpl.Text txt;
      Integer a_ls_index;

    case ( txt,
           false,
           a_ls_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_algLoopLinearSolver->solve(_algLoop"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;

    case ( txt,
           _,
           a_ls_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_algLoopLinearSolver"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("->solve();"));
      then txt;
  end match;
end fun_1170;

protected function fun_1171
  input Tpl.Text in_txt;
  input SimCodeFunction.Context in_a_context;
  input Integer in_a_ls_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_context, in_a_ls_index)
    local
      Tpl.Text txt;
      Integer a_ls_index;
      Boolean ret_19;
      Boolean ret_18;
      Boolean ret_17;
      Boolean ret_16;
      Boolean ret_15;
      Boolean ret_14;
      Boolean ret_13;
      Boolean ret_12;
      Boolean ret_11;
      Boolean ret_10;
      Boolean ret_9;
      Boolean ret_8;
      Boolean ret_7;
      Boolean ret_6;
      Boolean ret_5;
      Boolean ret_4;
      Boolean ret_3;
      Boolean ret_2;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           SimCodeFunction.ALGLOOP_CONTEXT(genInitialisation = true),
           a_ls_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "try\n",
                                    "{\n",
                                    "\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_algLoop"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "->evaluate();\n",
                                    "for(int i=0; i<_dimZeroFunc; i++)\n",
                                    "{\n",
                                    "  getCondition(i);\n",
                                    "}\n",
                                    "IContinuous::UPDATETYPE calltype = _callType;\n",
                                    "_callType = IContinuous::CONTINUOUS;\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        ret_0 = Flags.isSet(Flags.HPCOM);
        ret_1 = Flags.getConfigBool(Flags.SINGLE_INSTANCE_AGLSOLVER);
        ret_2 = boolNot(ret_1);
        ret_3 = boolOr(ret_0, ret_2);
        txt = fun_1166(txt, ret_3, a_ls_index);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" _callType = calltype;\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "catch (ModelicaSimulationError& ex)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("string error = add_error_info(\"Linear solver "));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\", ex.what(), ex.getErrorID(), _simTime);\n",
                                    "throw ModelicaSimulationError(ALGLOOP_EQ_SYSTEM, error);\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;

    case ( txt,
           _,
           a_ls_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("bool restart"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " = true;\n",
                                    "\n",
                                    "unsigned int iterations"
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" = 0;\n"));
        ret_4 = Flags.isSet(Flags.HPCOM);
        ret_5 = Flags.getConfigBool(Flags.SINGLE_INSTANCE_AGLSOLVER);
        ret_6 = boolNot(ret_5);
        ret_7 = boolOr(ret_4, ret_6);
        txt = fun_1167(txt, ret_7, a_ls_index);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "\n",
                                    "\n",
                                    "_algLoop"
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("->getReal(algloop"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Vars);\n",
                                    "bool restatDiscrete"
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " = false;\n",
                                    "try\n",
                                    "  {\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(5));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_algLoop"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "->evaluate();\n",
                                    " if( _callType == IContinuous::DISCRETE )\n",
                                    " {\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("while(restart"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" && !(iterations"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "++>500))\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("getConditions(conditions0"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ");\n",
                                    "_callType = IContinuous::CONTINUOUS;\n",
                                    "\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        ret_8 = Flags.isSet(Flags.HPCOM);
        ret_9 = Flags.getConfigBool(Flags.SINGLE_INSTANCE_AGLSOLVER);
        ret_10 = boolNot(ret_9);
        ret_11 = boolOr(ret_8, ret_10);
        txt = fun_1168(txt, ret_11, a_ls_index);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_callType = IContinuous::DISCRETE;\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "for(int i=0;i<_dimZeroFunc;i++)\n",
                                    "{\n",
                                    "  getCondition(i);\n",
                                    "}\n",
                                    "getConditions(conditions1"
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ");\n",
                                    "restart"
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = !std::equal (conditions1"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", conditions1"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("+_dimZeroFunc,conditions0"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(");\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("}\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " }\n",
                                    " else\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(5));
        ret_12 = Flags.isSet(Flags.HPCOM);
        ret_13 = Flags.getConfigBool(Flags.SINGLE_INSTANCE_AGLSOLVER);
        ret_14 = boolNot(ret_13);
        ret_15 = boolOr(ret_12, ret_14);
        txt = fun_1169(txt, ret_15, a_ls_index);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "  }\n",
                                    "  catch(ModelicaSimulationError &ex)\n",
                                    "  {\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("restatDiscrete"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("=true;\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "  }\n",
                                    "\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if((restart"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("&& iterations"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" > 0)|| restatDiscrete"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ")\n",
                                    "{\n",
                                    "      try\n",
                                    "       {  //workaround: try to solve algoop discrete (evaluate all zero crossing conditions) since we do not have the information which zercrossing contains a algloop var\n",
                                    "          IContinuous::UPDATETYPE calltype = _callType;\n",
                                    "         _callType = IContinuous::DISCRETE;\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(11));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_algLoop"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("->setReal(algloop"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("Vars );\n"));
        ret_16 = Flags.isSet(Flags.HPCOM);
        ret_17 = Flags.getConfigBool(Flags.SINGLE_INSTANCE_AGLSOLVER);
        ret_18 = boolNot(ret_17);
        ret_19 = boolOr(ret_16, ret_18);
        txt = fun_1170(txt, ret_19, a_ls_index);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "         _callType = calltype;\n",
                                    "       }\n",
                                    "       catch (ModelicaSimulationError& ex)\n",
                                    "       {\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(9));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("string error = add_error_info(\"Linear solver "));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\", ex.what(), ex.getErrorID(), _simTime);\n",
                                    "throw ModelicaSimulationError(ALGLOOP_EQ_SYSTEM,error);\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "       }\n",
                                    "}"
                                }, false));
        txt = Tpl.popBlock(txt);
      then txt;
  end match;
end fun_1171;

protected function fun_1172
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_nls_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_nls_index)
    local
      Tpl.Text txt;
      Integer a_nls_index;

    case ( txt,
           false,
           a_nls_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_algLoopNonLinearSolver->solve(_algLoop"));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(",true);"));
      then txt;

    case ( txt,
           _,
           a_nls_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_algLoopNonLinearSolver"));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("->solve();"));
      then txt;
  end match;
end fun_1172;

protected function fun_1173
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_nls_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_nls_index)
    local
      Tpl.Text txt;
      Integer a_nls_index;

    case ( txt,
           false,
           a_nls_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("double* algloop"));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("Vars = _algLoopLinearSolver->getVariableWorkArray();\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(19));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("bool* conditions0"));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " = _algLoopLinearSolver->getConditionsWorkArray();\n",
                                    "bool* conditions1"
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = _algLoopLinearSolver->getConditions2WorkArray();"));
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           _,
           a_nls_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("double* algloop"));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Vars = _algLoopLinearSolver"));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("->getVariableWorkArray();\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(19));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("bool* conditions0"));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = _algLoopLinearSolver"));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("->getConditionsWorkArray();\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(18));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("bool* conditions1"));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = _algLoopLinearSolver"));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("->getConditions2WorkArray();"));
        txt = Tpl.popBlock(txt);
      then txt;
  end match;
end fun_1173;

protected function fun_1174
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_nls_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_nls_index)
    local
      Tpl.Text txt;
      Integer a_nls_index;

    case ( txt,
           false,
           a_nls_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_algLoopNonLinearSolver->solve(_algLoop"));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(",(iterations"));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("==1));"));
      then txt;

    case ( txt,
           _,
           a_nls_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_algLoopNonLinearSolver"));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("->solve();"));
      then txt;
  end match;
end fun_1174;

protected function fun_1175
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_nls_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_nls_index)
    local
      Tpl.Text txt;
      Integer a_nls_index;

    case ( txt,
           false,
           a_nls_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_algLoopNonLinearSolver->solve(_algLoop"));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(",true);"));
      then txt;

    case ( txt,
           _,
           a_nls_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_algLoopNonLinearSolver"));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("->solve();"));
      then txt;
  end match;
end fun_1175;

protected function fun_1176
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_nls_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_nls_index)
    local
      Tpl.Text txt;
      Integer a_nls_index;

    case ( txt,
           false,
           a_nls_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_algLoopNonLinearSolver->solve(_algLoop"));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;

    case ( txt,
           _,
           a_nls_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_algLoopNonLinearSolver"));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("->solve();"));
      then txt;
  end match;
end fun_1176;

protected function fun_1177
  input Tpl.Text in_txt;
  input SimCodeFunction.Context in_a_context;
  input Integer in_a_nls_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_context, in_a_nls_index)
    local
      Tpl.Text txt;
      Integer a_nls_index;
      Boolean ret_19;
      Boolean ret_18;
      Boolean ret_17;
      Boolean ret_16;
      Boolean ret_15;
      Boolean ret_14;
      Boolean ret_13;
      Boolean ret_12;
      Boolean ret_11;
      Boolean ret_10;
      Boolean ret_9;
      Boolean ret_8;
      Boolean ret_7;
      Boolean ret_6;
      Boolean ret_5;
      Boolean ret_4;
      Boolean ret_3;
      Boolean ret_2;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           SimCodeFunction.ALGLOOP_CONTEXT(genInitialisation = true),
           a_nls_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "try\n",
                                    "{\n",
                                    "\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_algLoop"));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "->evaluate();\n",
                                    "for(int i=0; i<_dimZeroFunc; i++)\n",
                                    "{\n",
                                    "  getCondition(i);\n",
                                    "}\n",
                                    "IContinuous::UPDATETYPE calltype = _callType;\n",
                                    "_callType = IContinuous::CONTINUOUS;\n",
                                    "\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        ret_0 = Flags.isSet(Flags.HPCOM);
        ret_1 = Flags.getConfigBool(Flags.SINGLE_INSTANCE_AGLSOLVER);
        ret_2 = boolNot(ret_1);
        ret_3 = boolOr(ret_0, ret_2);
        txt = fun_1172(txt, ret_3, a_nls_index);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_callType = calltype;\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "catch(ModelicaSimulationError& ex)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("string error = add_error_info(\"Nonlinear solver "));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\", ex.what(), ex.getErrorID(), _simTime);\n",
                                    "throw ModelicaSimulationError(ALGLOOP_EQ_SYSTEM,error);\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;

    case ( txt,
           _,
           a_nls_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("bool restart"));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " = true;\n",
                                    "\n",
                                    "unsigned int iterations"
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" = 0;\n"));
        ret_4 = Flags.isSet(Flags.HPCOM);
        ret_5 = Flags.getConfigBool(Flags.SINGLE_INSTANCE_AGLSOLVER);
        ret_6 = boolNot(ret_5);
        ret_7 = boolOr(ret_4, ret_6);
        txt = fun_1173(txt, ret_7, a_nls_index);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_algLoop"));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("->getReal(algloop"));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Vars);\n",
                                    "bool restatDiscrete"
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " = false;\n",
                                    "try\n",
                                    "  {\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(5));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_algLoop"));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "->evaluate();\n",
                                    " if( _callType == IContinuous::DISCRETE )\n",
                                    " {\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("while(restart"));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" && !(iterations"));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "++>500))\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("getConditions(conditions0"));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ");\n",
                                    "_callType = IContinuous::CONTINUOUS;\n",
                                    "\n"
                                }, true));
        ret_8 = Flags.isSet(Flags.HPCOM);
        ret_9 = Flags.getConfigBool(Flags.SINGLE_INSTANCE_AGLSOLVER);
        ret_10 = boolNot(ret_9);
        ret_11 = boolOr(ret_8, ret_10);
        txt = fun_1174(txt, ret_11, a_nls_index);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "_callType = IContinuous::DISCRETE;\n",
                                    "for(int i=0;i<_dimZeroFunc;i++)\n",
                                    "{\n",
                                    "  getCondition(i);\n",
                                    "}\n",
                                    "getConditions(conditions1"
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ");\n",
                                    "restart"
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = !std::equal (_conditions1"));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", _conditions1"));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("+_dimZeroFunc,_conditions0"));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(");\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("}\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " }\n",
                                    " else\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(3));
        ret_12 = Flags.isSet(Flags.HPCOM);
        ret_13 = Flags.getConfigBool(Flags.SINGLE_INSTANCE_AGLSOLVER);
        ret_14 = boolNot(ret_13);
        ret_15 = boolOr(ret_12, ret_14);
        txt = fun_1175(txt, ret_15, a_nls_index);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "  }\n",
                                    "  catch(ModelicaSimulationError &ex)\n",
                                    "  {\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("restatDiscrete"));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("=true;\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "  }\n",
                                    "\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if((restart"));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("&& iterations"));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" > 0)|| restatDiscrete"));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ")\n",
                                    "{\n",
                                    "      try\n",
                                    "       {  //workaround: try to solve algoop discrete (evaluate all zero crossing conditions) since we do not have the information which zercrossing contains a algloop var\n",
                                    "          IContinuous::UPDATETYPE calltype = _callType;\n",
                                    "         _callType = IContinuous::DISCRETE;\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(11));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_algLoop"));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("->setReal(algloop"));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("Vars );\n"));
        ret_16 = Flags.isSet(Flags.HPCOM);
        ret_17 = Flags.getConfigBool(Flags.SINGLE_INSTANCE_AGLSOLVER);
        ret_18 = boolNot(ret_17);
        ret_19 = boolOr(ret_16, ret_18);
        txt = fun_1176(txt, ret_19, a_nls_index);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "         _callType = calltype;\n",
                                    "       }\n",
                                    "       catch(ModelicaSimulationError& ex)\n",
                                    "       {\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(9));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("string error = add_error_info(\"Nonlinear solver "));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\", ex.what(), ex.getErrorID(), _simTime);\n",
                                    "throw ModelicaSimulationError(ALGLOOP_EQ_SYSTEM,error);\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "       }\n",
                                    "}"
                                }, false));
        txt = Tpl.popBlock(txt);
      then txt;
  end match;
end fun_1177;

public function equationString
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;
  input Boolean in_a_assignToStartValues;
  input Boolean in_a_overwriteOldStartValue;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_eq, in_a_context, in_a_varDecls, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation, in_a_assignToStartValues, in_a_overwriteOldStartValue)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_varDecls;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      Boolean a_assignToStartValues;
      Boolean a_overwriteOldStartValue;
      Integer i_nls_index;
      Integer i_ls_index;
      SimCode.SimEqSystem i_e;
      Tpl.Text l_i;

    case ( txt,
           (i_e as SimCode.SES_SIMPLE_ASSIGN(index = _)),
           a_context,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation,
           a_assignToStartValues,
           a_overwriteOldStartValue )
      equation
        (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = equationSimpleAssign(txt, i_e, a_context, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation, a_assignToStartValues, a_overwriteOldStartValue);
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           (i_e as SimCode.SES_ALGORITHM(index = _)),
           a_context,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation,
           _,
           _ )
      equation
        (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = equationAlgorithm(txt, i_e, a_context, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           (i_e as SimCode.SES_INVERSE_ALGORITHM(index = _)),
           a_context,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation,
           _,
           _ )
      equation
        (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = equationAlgorithm(txt, i_e, a_context, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           (i_e as SimCode.SES_WHEN(index = _)),
           a_context,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation,
           _,
           _ )
      equation
        (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = equationWhen(txt, i_e, a_context, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           (i_e as SimCode.SES_ARRAY_CALL_ASSIGN(index = _)),
           a_context,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation,
           a_assignToStartValues,
           _ )
      equation
        (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = equationArrayCallAssign(txt, i_e, a_context, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation, a_assignToStartValues);
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           SimCode.SES_LINEAR(lSystem = SimCode.LINEARSYSTEM(index = i_ls_index)),
           a_context,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _,
           _,
           _ )
      equation
        l_i = Tpl.writeStr(Tpl.emptyTxt, intString(i_ls_index));
        txt = fun_1171(txt, a_context, i_ls_index);
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           SimCode.SES_NONLINEAR(nlSystem = SimCode.NONLINEARSYSTEM(index = i_nls_index)),
           a_context,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _,
           _,
           _ )
      equation
        l_i = Tpl.writeStr(Tpl.emptyTxt, intString(i_nls_index));
        txt = fun_1177(txt, a_context, i_nls_index);
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           SimCode.SES_MIXED(index = _),
           _,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" throw ModelicaSimulationError(ALGLOOP_EQ_SYSTEM,\"Mixed systems are not supported yet\");"));
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           SimCode.SES_FOR_LOOP(index = _),
           _,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("FOR LOOPS ARE NOT IMPLEMENTED"));
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           SimCode.SES_IFEQUATION(index = _),
           _,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("IF EQUATIONS ARE NOT IMPLEMENTED"));
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _,
           _,
           _ )
      equation
        txt = CodegenCppCommonOld.error(txt, Tpl.sourceInfo("CodegenCppOld.tpl", 9886, 11), "NOT IMPLEMENTED EQUATION 2");
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end equationString;

public function equation_function_call
  input Tpl.Text txt;
  input SimCode.SimEqSystem a_eq;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_varDecls;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_method;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_method;
protected
  Tpl.Text l_ix__str;
algorithm
  l_ix__str := CodegenUtilSimulation.equationIndex(Tpl.emptyTxt, a_eq);
  out_txt := Tpl.writeText(txt, a_method);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("_"));
  out_txt := Tpl.writeText(out_txt, l_ix__str);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("();"));
  out_a_varDecls := a_varDecls;
  out_a_extraFuncs := a_extraFuncs;
  out_a_extraFuncsDecl := a_extraFuncsDecl;
  out_a_extraFuncsNamespace := a_extraFuncsNamespace;
  out_a_method := a_method;
end equation_function_call;

protected function fun_1180
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input Boolean in_a_createMeasureTime;
  input Tpl.Text in_a_classnameext;
  input Tpl.Text in_a_method;
  input Tpl.Text in_a_additionalFuncs;
  input Boolean in_a_overwriteOldStartValue;
  input Boolean in_a_assignToStartValues;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDeclsLocal;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_classnameext;
  output Tpl.Text out_a_method;
  output Tpl.Text out_a_additionalFuncs;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDeclsLocal;
algorithm
  (out_txt, out_a_classnameext, out_a_method, out_a_additionalFuncs, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDeclsLocal) :=
  match(in_txt, in_a_eq, in_a_createMeasureTime, in_a_classnameext, in_a_method, in_a_additionalFuncs, in_a_overwriteOldStartValue, in_a_assignToStartValues, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDeclsLocal, in_a_context)
    local
      Tpl.Text txt;
      Boolean a_createMeasureTime;
      Tpl.Text a_classnameext;
      Tpl.Text a_method;
      Tpl.Text a_additionalFuncs;
      Boolean a_overwriteOldStartValue;
      Boolean a_assignToStartValues;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDeclsLocal;
      SimCodeFunction.Context a_context;
      SimCode.SimEqSystem i_e_cont;
      SimCode.SimEqSystem i_e;

    case ( txt,
           (i_e as SimCode.SES_SIMPLE_ASSIGN(index = _)),
           _,
           a_classnameext,
           a_method,
           a_additionalFuncs,
           a_overwriteOldStartValue,
           a_assignToStartValues,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDeclsLocal,
           a_context )
      equation
        (txt, a_varDeclsLocal, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = equationSimpleAssign(txt, i_e, a_context, a_varDeclsLocal, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation, a_assignToStartValues, a_overwriteOldStartValue);
      then (txt, a_classnameext, a_method, a_additionalFuncs, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDeclsLocal);

    case ( txt,
           (i_e as SimCode.SES_IFEQUATION(index = _)),
           _,
           a_classnameext,
           a_method,
           a_additionalFuncs,
           _,
           _,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDeclsLocal,
           a_context )
      equation
        (txt, a_varDeclsLocal, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = equationIfEquation(txt, i_e, a_context, a_varDeclsLocal, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_classnameext, a_method, a_additionalFuncs, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDeclsLocal);

    case ( txt,
           (i_e as SimCode.SES_ALGORITHM(index = _)),
           _,
           a_classnameext,
           a_method,
           a_additionalFuncs,
           _,
           _,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDeclsLocal,
           a_context )
      equation
        (txt, a_varDeclsLocal, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = equationAlgorithm(txt, i_e, a_context, a_varDeclsLocal, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_classnameext, a_method, a_additionalFuncs, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDeclsLocal);

    case ( txt,
           (i_e as SimCode.SES_WHEN(index = _)),
           _,
           a_classnameext,
           a_method,
           a_additionalFuncs,
           _,
           _,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDeclsLocal,
           a_context )
      equation
        (txt, a_varDeclsLocal, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = equationWhen(txt, i_e, a_context, a_varDeclsLocal, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_classnameext, a_method, a_additionalFuncs, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDeclsLocal);

    case ( txt,
           (i_e as SimCode.SES_ARRAY_CALL_ASSIGN(index = _)),
           _,
           a_classnameext,
           a_method,
           a_additionalFuncs,
           _,
           a_assignToStartValues,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDeclsLocal,
           a_context )
      equation
        (txt, a_varDeclsLocal, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = equationArrayCallAssign(txt, i_e, a_context, a_varDeclsLocal, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation, a_assignToStartValues);
      then (txt, a_classnameext, a_method, a_additionalFuncs, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDeclsLocal);

    case ( txt,
           (i_e as SimCode.SES_LINEAR(lSystem = _)),
           _,
           a_classnameext,
           a_method,
           a_additionalFuncs,
           _,
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDeclsLocal,
           a_context )
      equation
        (txt, a_varDeclsLocal, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = equationLinearOrNonLinear(txt, i_e, a_context, a_varDeclsLocal, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
      then (txt, a_classnameext, a_method, a_additionalFuncs, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDeclsLocal);

    case ( txt,
           (i_e as SimCode.SES_NONLINEAR(nlSystem = _)),
           _,
           a_classnameext,
           a_method,
           a_additionalFuncs,
           _,
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDeclsLocal,
           a_context )
      equation
        (txt, a_varDeclsLocal, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = equationLinearOrNonLinear(txt, i_e, a_context, a_varDeclsLocal, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
      then (txt, a_classnameext, a_method, a_additionalFuncs, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDeclsLocal);

    case ( txt,
           SimCode.SES_MIXED(cont = i_e_cont),
           a_createMeasureTime,
           a_classnameext,
           a_method,
           a_additionalFuncs,
           a_overwriteOldStartValue,
           a_assignToStartValues,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDeclsLocal,
           a_context )
      equation
        (a_additionalFuncs, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_method, a_classnameext, a_stateDerVectorName) = equation_function_create_single_func(a_additionalFuncs, i_e_cont, a_context, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_method, a_classnameext, a_stateDerVectorName, a_useFlatArrayNotation, a_createMeasureTime, a_assignToStartValues, a_overwriteOldStartValue, "");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("throw ModelicaSimulationError(MODEL_ARRAY_FUNCTION,\"Mixed systems are not supported yet\");"));
      then (txt, a_classnameext, a_method, a_additionalFuncs, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDeclsLocal);

    case ( txt,
           (i_e as SimCode.SES_FOR_LOOP(index = _)),
           _,
           a_classnameext,
           a_method,
           a_additionalFuncs,
           _,
           a_assignToStartValues,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDeclsLocal,
           a_context )
      equation
        (txt, a_varDeclsLocal, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = equationForLoop(txt, i_e, a_context, a_varDeclsLocal, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation, a_assignToStartValues);
      then (txt, a_classnameext, a_method, a_additionalFuncs, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDeclsLocal);

    case ( txt,
           _,
           _,
           a_classnameext,
           a_method,
           a_additionalFuncs,
           _,
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDeclsLocal,
           _ )
      equation
        txt = CodegenCppCommonOld.error(txt, Tpl.sourceInfo("CodegenCppOld.tpl", 9942, 13), "NOT IMPLEMENTED EQUATION");
      then (txt, a_classnameext, a_method, a_additionalFuncs, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDeclsLocal);
  end match;
end fun_1180;

protected function fun_1181
  input Tpl.Text in_txt;
  input Boolean in_a_createMeasureTime;
  input Tpl.Text in_a_ix__str;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_createMeasureTime, in_a_ix__str)
    local
      Tpl.Text txt;
      Tpl.Text a_ix__str;
      Tpl.Text txt_0;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_ix__str )
      equation
        txt_0 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("evaluate"));
        txt_0 = Tpl.writeText(txt_0, a_ix__str);
        txt = generateMeasureTimeStartCode(txt, "measuredProfileBlockStartValues", Tpl.textString(txt_0), "MEASURETIME_PROFILEBLOCKS");
      then txt;
  end match;
end fun_1181;

protected function fun_1182
  input Tpl.Text in_txt;
  input Boolean in_a_createMeasureTime;
  input Tpl.Text in_a_ix__str;
  input Tpl.Text in_a_ix__str__array;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_createMeasureTime, in_a_ix__str, in_a_ix__str__array)
    local
      Tpl.Text txt;
      Tpl.Text a_ix__str;
      Tpl.Text a_ix__str__array;
      Tpl.Text txt_1;
      Tpl.Text txt_0;

    case ( txt,
           false,
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_ix__str,
           a_ix__str__array )
      equation
        txt_0 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("(*measureTimeProfileBlocksArray)["));
        txt_0 = Tpl.writeText(txt_0, a_ix__str__array);
        txt_0 = Tpl.writeTok(txt_0, Tpl.ST_STRING("]"));
        txt_1 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("evaluate"));
        txt_1 = Tpl.writeText(txt_1, a_ix__str);
        txt = generateMeasureTimeEndCode(txt, "measuredProfileBlockStartValues", "measuredProfileBlockEndValues", Tpl.textString(txt_0), Tpl.textString(txt_1), "MEASURETIME_PROFILEBLOCKS");
      then txt;
  end match;
end fun_1182;

protected function fun_1183
  input Tpl.Text in_txt;
  input Boolean in_a_createMeasureTime;
  input Tpl.Text in_a_measureTimeStartVar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_createMeasureTime, in_a_measureTimeStartVar)
    local
      Tpl.Text txt;
      Tpl.Text a_measureTimeStartVar;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_measureTimeStartVar )
      equation
        txt = Tpl.writeText(txt, a_measureTimeStartVar);
      then txt;
  end match;
end fun_1183;

protected function fun_1184
  input Tpl.Text in_txt;
  input Boolean in_a_createMeasureTime;
  input Tpl.Text in_a_measureTimeEndVar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_createMeasureTime, in_a_measureTimeEndVar)
    local
      Tpl.Text txt;
      Tpl.Text a_measureTimeEndVar;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_measureTimeEndVar )
      equation
        txt = Tpl.writeText(txt, a_measureTimeEndVar);
      then txt;
  end match;
end fun_1184;

public function equation_function_create_single_func
  input Tpl.Text txt;
  input SimCode.SimEqSystem a_eq;
  input SimCodeFunction.Context a_context;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_method;
  input Tpl.Text a_classnameext;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;
  input Boolean a_createMeasureTime;
  input Boolean a_assignToStartValues;
  input Boolean a_overwriteOldStartValue;
  input String a_defaultVarDeclsLocal;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_method;
  output Tpl.Text out_a_classnameext;
  output Tpl.Text out_a_stateDerVectorName;
protected
  list<SimCode.SimEqSystem> ret_9;
  Tpl.Text l_body;
  Tpl.Text l_measureTimeEndVar;
  Tpl.Text l_measureTimeStartVar;
  Tpl.Text l_additionalFuncs;
  Tpl.Text l_varDeclsLocal;
  Integer ret_3;
  Integer ret_2;
  Tpl.Text l_ix__str__array;
  Tpl.Text l_ix__str;
algorithm
  l_ix__str := CodegenUtilSimulation.equationIndex(Tpl.emptyTxt, a_eq);
  ret_2 := stringInt(Tpl.textString(l_ix__str));
  ret_3 := intSub(ret_2, 1);
  l_ix__str__array := Tpl.writeStr(Tpl.emptyTxt, intString(ret_3));
  l_varDeclsLocal := Tpl.writeStr(Tpl.emptyTxt, a_defaultVarDeclsLocal);
  l_additionalFuncs := Tpl.emptyTxt;
  l_measureTimeStartVar := Tpl.emptyTxt;
  l_measureTimeEndVar := Tpl.emptyTxt;
  (l_body, out_a_classnameext, out_a_method, l_additionalFuncs, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, l_varDeclsLocal) := fun_1180(Tpl.emptyTxt, a_eq, a_createMeasureTime, a_classnameext, a_method, l_additionalFuncs, a_overwriteOldStartValue, a_assignToStartValues, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, l_varDeclsLocal, a_context);
  l_measureTimeStartVar := fun_1181(l_measureTimeStartVar, a_createMeasureTime, l_ix__str);
  l_measureTimeEndVar := fun_1182(l_measureTimeEndVar, a_createMeasureTime, l_ix__str, l_ix__str__array);
  out_txt := Tpl.writeText(txt, l_additionalFuncs);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("/*\n"));
  ret_9 := List.fill(a_eq, 1);
  out_txt := CodegenUtilSimulation.dumpEqs(out_txt, ret_9);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "*/\n",
                                       "void "
                                   }, false));
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace) := lastIdentOfPathFromSimCode(out_txt, a_simCode, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace);
  out_txt := Tpl.writeText(out_txt, out_a_classnameext);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("::"));
  out_txt := Tpl.writeText(out_txt, out_a_method);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("_"));
  out_txt := Tpl.writeText(out_txt, l_ix__str);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "()\n",
                                       "{\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeText(out_txt, l_varDeclsLocal);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := fun_1183(out_txt, a_createMeasureTime, l_measureTimeStartVar);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeText(out_txt, l_body);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := fun_1184(out_txt, a_createMeasureTime, l_measureTimeEndVar);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("}"));
end equation_function_create_single_func;

protected function lm_1186
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input Tpl.Text in_a_num;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preDisc;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preDisc;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preDisc) :=
  match(in_txt, in_items, in_a_num, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_preDisc, in_a_context)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      Tpl.Text a_num;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_preDisc;
      SimCodeFunction.Context a_context;
      Integer x_i0;
      DAE.ComponentRef i_cref;
      DAE.Exp i_exp;
      Tpl.Text l_expPart;

    case ( txt,
           {},
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           a_preDisc,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preDisc);

    case ( txt,
           SimCode.SES_SIMPLE_ASSIGN(exp = i_exp, cref = i_cref) :: rest,
           a_num,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preDisc,
           a_context )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        (l_expPart, a_preDisc, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.daeExp(Tpl.emptyTxt, i_exp, a_context, a_preDisc, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = CodegenCppCommonOld.cref(txt, i_cref, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, l_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "new_disc_vars"
                                }, false));
        txt = Tpl.writeText(txt, a_num);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("["));
        txt = Tpl.writeStr(txt, intString(x_i0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = "));
        txt = CodegenCppCommonOld.cref(txt, i_cref, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preDisc) = lm_1186(txt, rest, a_num, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preDisc, a_context);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preDisc);

    case ( txt,
           _ :: rest,
           a_num,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preDisc,
           a_context )
      equation
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preDisc) = lm_1186(txt, rest, a_num, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preDisc, a_context);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preDisc);
  end match;
end lm_1186;

public function equationMixed
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_eq, in_a_context, in_a_varDecls, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_varDecls;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      list<SimCode.SimEqSystem> i_discEqs;
      Integer i_index;
      list<SimCodeVar.SimVar> i_discVars;
      SimCode.SimEqSystem i_cont;
      Tpl.Text l_discvars2;
      Tpl.Text l_num;
      Tpl.Text l_preDisc;
      Integer ret_2;
      Tpl.Text l_numDiscVarsStr;
      Tpl.Text l_contEqs;

    case ( txt,
           SimCode.SES_MIXED(cont = i_cont, discVars = i_discVars, index = i_index, discEqs = i_discEqs),
           a_context,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (l_contEqs, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = equation_(Tpl.emptyTxt, i_cont, a_context, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        ret_2 = listLength(i_discVars);
        l_numDiscVarsStr = Tpl.writeStr(Tpl.emptyTxt, intString(ret_2));
        l_preDisc = Tpl.emptyTxt;
        l_num = Tpl.writeStr(Tpl.emptyTxt, intString(i_index));
        l_discvars2 = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_discvars2, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, l_preDisc) = lm_1186(l_discvars2, i_discEqs, l_num, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, l_preDisc, a_context);
        l_discvars2 = Tpl.popIter(l_discvars2);
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end equationMixed;

protected function lm_1188
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Boolean a_useFlatArrayNotation;
      DAE.ComponentRef i_name;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(name = i_name) :: rest,
           a_useFlatArrayNotation )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("dynamic_cast<SimDouble*>( _simObjects->getSimData(_modelName)->Get(\""));
        txt = CodegenCppCommonOld.cref(txt, i_name, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\"))->getValue() = "));
        txt = CodegenCppCommonOld.cref(txt, i_name, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        txt = lm_1188(txt, rest, a_useFlatArrayNotation);
      then txt;

    case ( txt,
           _ :: rest,
           a_useFlatArrayNotation )
      equation
        txt = lm_1188(txt, rest, a_useFlatArrayNotation);
      then txt;
  end match;
end lm_1188;

protected function fun_1189
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      list<SimCodeVar.SimVar> i_vars_outputVars;
      Tpl.Text l_outputnames;
      Tpl.Text l_optpreExp;
      Tpl.Text l_varOptDecls;

    case ( txt,
           SimCode.MODELINFO(varInfo = SimCode.VARINFO(numZeroCrossings = _), vars = SimCodeVar.SIMVARS(outputVars = i_vars_outputVars)),
           a_useFlatArrayNotation )
      equation
        l_varOptDecls = Tpl.emptyTxt;
        l_optpreExp = Tpl.emptyTxt;
        l_outputnames = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_outputnames = lm_1188(l_outputnames, i_vars_outputVars, a_useFlatArrayNotation);
        l_outputnames = Tpl.popIter(l_outputnames);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("#if defined(__TRICORE__) || defined(__vxworks)\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.writeText(txt, l_outputnames);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#endif"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_1189;

protected function fun_1190
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      SimCode.ModelInfo i_modelInfo;

    case ( txt,
           SimCode.SIMCODE(modelInfo = i_modelInfo),
           a_useFlatArrayNotation )
      equation
        txt = fun_1189(txt, i_modelInfo, a_useFlatArrayNotation);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_1190;

protected function fun_1191
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_save__algloop__start__values;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_a_simCode, in_a_save__algloop__start__values, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs)
    local
      Tpl.Text txt;
      Tpl.Text a_save__algloop__start__values;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      Absyn.Path i_modelInfo_name;
      SimCode.SimCode i_simCode;
      SimCode.DelayedExpression i_delayedExps;
      Tpl.Text l_outputBounds;
      Tpl.Text l_store__delay__expr;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = i_modelInfo_name), delayedExps = i_delayedExps)),
           a_save__algloop__start__values,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs )
      equation
        (l_store__delay__expr, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = functionStoreDelay(Tpl.emptyTxt, i_delayedExps, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        l_outputBounds = fun_1190(Tpl.emptyTxt, i_simCode, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("bool "));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::stepCompleted(double time)\n",
                                    "{\n",
                                    "\n"
                                }, true));
        txt = Tpl.writeText(txt, l_store__delay__expr);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, a_save__algloop__start__values);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_outputBounds);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "saveAll();\n",
                                    "return _terminate;\n",
                                    "}"
                                }, false));
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_1191;

public function generateStepCompleted
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_allEquations;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
protected
  Tpl.Text l_save__algloop__start__values;
  Tpl.Text l_varDecls;
algorithm
  l_varDecls := Tpl.emptyTxt;
  (l_save__algloop__start__values, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace) := generateStepCompleted2(Tpl.emptyTxt, a_allEquations, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) := fun_1191(txt, a_simCode, l_save__algloop__start__values, a_useFlatArrayNotation, a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs);
end generateStepCompleted;

protected function fun_1193
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      Absyn.Path i_modelInfo_name;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = i_modelInfo_name)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::restoreOldValues()\n",
                                    "{\n",
                                    "\n",
                                    "}"
                                }, false));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_1193;

public function generateRestoreOldValues
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_allEquations;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
protected
  Tpl.Text l_algloopsolver;
  Tpl.Text l_varDecls;
algorithm
  l_varDecls := Tpl.emptyTxt;
  (l_algloopsolver, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace) := generateRestoreOldValues2(Tpl.emptyTxt, a_allEquations, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
  out_txt := fun_1193(txt, a_simCode);
  out_a_stateDerVectorName := a_stateDerVectorName;
end generateRestoreOldValues;

protected function smf_1195
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_it;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) :=
  match(in_txt, in_it, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           i_eq,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls )
      equation
        (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = generateRestoreOldValues3(txt, i_eq, SimCodeFunction.contextOther, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);
  end match;
end smf_1195;

protected function lm_1196
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) :=
  match(in_txt, in_items, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      SimCode.SimEqSystem i_eqs;

    case ( txt,
           {},
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           i_eqs :: rest,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls )
      equation
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = smf_1195(txt, i_eqs, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls);
        txt = Tpl.nextIter(txt);
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = lm_1196(txt, rest, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);
  end match;
end lm_1196;

public function generateRestoreOldValues2
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_allEquations;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
protected
  Tpl.Text l_algloopsolver;
  Tpl.Text l_varDecls;
algorithm
  l_varDecls := Tpl.emptyTxt;
  l_algloopsolver := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (l_algloopsolver, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, l_varDecls) := lm_1196(l_algloopsolver, a_allEquations, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, l_varDecls);
  l_algloopsolver := Tpl.popIter(l_algloopsolver);
  out_txt := Tpl.writeText(txt, l_algloopsolver);
end generateRestoreOldValues2;

protected function fun_1198
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_num;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode, in_a_num)
    local
      Tpl.Text txt;
      Tpl.Text a_num;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = _)),
           a_num )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_algLoopSolver"));
        txt = Tpl.writeText(txt, a_num);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("->restoreOldValues();"));
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_1198;

protected function fun_1199
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_num;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode, in_a_num)
    local
      Tpl.Text txt;
      Tpl.Text a_num;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = _)),
           a_num )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_algLoopSolver"));
        txt = Tpl.writeText(txt, a_num);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("->restoreOldValues();"));
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_1199;

public function generateRestoreOldValues3
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  (out_txt, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace) :=
  match(in_txt, in_a_eq, in_a_context, in_a_varDecls, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_varDecls;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      SimCode.SimEqSystem i_eq__sys;
      Integer i_nls_index;
      Integer i_ls_index;
      Tpl.Text l_num;

    case ( txt,
           SimCode.SES_LINEAR(lSystem = SimCode.LINEARSYSTEM(index = i_ls_index)),
           _,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace )
      equation
        l_num = Tpl.writeStr(Tpl.emptyTxt, intString(i_ls_index));
        txt = fun_1198(txt, a_simCode, l_num);
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);

    case ( txt,
           SimCode.SES_NONLINEAR(nlSystem = SimCode.NONLINEARSYSTEM(index = i_nls_index)),
           _,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace )
      equation
        l_num = Tpl.writeStr(Tpl.emptyTxt, intString(i_nls_index));
        txt = fun_1199(txt, a_simCode, l_num);
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);

    case ( txt,
           SimCode.SES_MIXED(cont = i_eq__sys),
           a_context,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace )
      equation
        (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = generateRestoreOldValues3(txt, i_eq__sys, a_context, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);

    case ( txt,
           _,
           _,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace )
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
  end match;
end generateRestoreOldValues3;

protected function fun_1201
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      Absyn.Path i_modelInfo_name;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = i_modelInfo_name)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::restoreNewValues()\n",
                                    "{\n",
                                    "\n",
                                    "}"
                                }, false));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_1201;

public function generateRestoreNewValues
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_allEquations;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
protected
  Tpl.Text l_algloopsolver;
  Tpl.Text l_varDecls;
algorithm
  l_varDecls := Tpl.emptyTxt;
  (l_algloopsolver, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace) := generateRestoreOldValues2(Tpl.emptyTxt, a_allEquations, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
  out_txt := fun_1201(txt, a_simCode);
  out_a_stateDerVectorName := a_stateDerVectorName;
end generateRestoreNewValues;

protected function fun_1203
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_num;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode, in_a_num)
    local
      Tpl.Text txt;
      Tpl.Text a_num;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = _)),
           a_num )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_algLoopSolver"));
        txt = Tpl.writeText(txt, a_num);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("->restoreNewValues();"));
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_1203;

protected function fun_1204
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_num;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode, in_a_num)
    local
      Tpl.Text txt;
      Tpl.Text a_num;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = _)),
           a_num )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_algLoopSolver"));
        txt = Tpl.writeText(txt, a_num);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("->restoreNewValues();"));
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_1204;

public function generateRestoreNewValues3
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  (out_txt, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace) :=
  match(in_txt, in_a_eq, in_a_context, in_a_varDecls, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_varDecls;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      SimCode.SimEqSystem i_eq__sys;
      Integer i_nls_index;
      Integer i_ls_index;
      Tpl.Text l_num;

    case ( txt,
           SimCode.SES_LINEAR(lSystem = SimCode.LINEARSYSTEM(index = i_ls_index)),
           _,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace )
      equation
        l_num = Tpl.writeStr(Tpl.emptyTxt, intString(i_ls_index));
        txt = fun_1203(txt, a_simCode, l_num);
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);

    case ( txt,
           SimCode.SES_NONLINEAR(nlSystem = SimCode.NONLINEARSYSTEM(index = i_nls_index)),
           _,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace )
      equation
        l_num = Tpl.writeStr(Tpl.emptyTxt, intString(i_nls_index));
        txt = fun_1204(txt, a_simCode, l_num);
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);

    case ( txt,
           SimCode.SES_MIXED(cont = i_eq__sys),
           a_context,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace )
      equation
        (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = generateRestoreNewValues3(txt, i_eq__sys, a_context, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);

    case ( txt,
           _,
           _,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace )
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
  end match;
end generateRestoreNewValues3;

protected function lm_1206
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Boolean a_useFlatArrayNotation;
      DAE.ComponentRef i_name;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(name = i_name) :: rest,
           a_useFlatArrayNotation )
      equation
        txt = CodegenCppCommonOld.cref(txt, i_name, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = dynamic_cast<SimDouble*>(_simObjects->getSimData(_modelName)->Get(\""));
        txt = CodegenCppCommonOld.cref(txt, i_name, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\"))->getValue();"));
        txt = Tpl.nextIter(txt);
        txt = lm_1206(txt, rest, a_useFlatArrayNotation);
      then txt;

    case ( txt,
           _ :: rest,
           a_useFlatArrayNotation )
      equation
        txt = lm_1206(txt, rest, a_useFlatArrayNotation);
      then txt;
  end match;
end lm_1206;

protected function fun_1207
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      list<SimCodeVar.SimVar> i_vars_inputVars;
      Tpl.Text l_inputnames;
      Tpl.Text l_optpreExp;
      Tpl.Text l_varOptDecls;

    case ( txt,
           SimCode.MODELINFO(varInfo = SimCode.VARINFO(numZeroCrossings = _), vars = SimCodeVar.SIMVARS(inputVars = i_vars_inputVars)),
           a_useFlatArrayNotation )
      equation
        l_varOptDecls = Tpl.emptyTxt;
        l_optpreExp = Tpl.emptyTxt;
        l_inputnames = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_inputnames = lm_1206(l_inputnames, i_vars_inputVars, a_useFlatArrayNotation);
        l_inputnames = Tpl.popIter(l_inputnames);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("#if defined(__TRICORE__) || defined(__vxworks)\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.writeText(txt, l_inputnames);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#endif"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_1207;

protected function fun_1208
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      SimCode.ModelInfo i_modelInfo;

    case ( txt,
           SimCode.SIMCODE(modelInfo = i_modelInfo),
           a_useFlatArrayNotation )
      equation
        txt = fun_1207(txt, i_modelInfo, a_useFlatArrayNotation);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_1208;

protected function fun_1209
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      Absyn.Path i_modelInfo_name;
      SimCode.SimCode i_simCode;
      Tpl.Text l_inputBounds;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = i_modelInfo_name))),
           a_useFlatArrayNotation )
      equation
        l_inputBounds = fun_1208(Tpl.emptyTxt, i_simCode, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("bool "));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::stepStarted(double time)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.writeText(txt, l_inputBounds);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "return true;\n",
                                    "}"
                                }, false));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_1209;

public function generateStepStarted
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_allEquations;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
protected
  Tpl.Text l_varDecls;
algorithm
  l_varDecls := Tpl.emptyTxt;
  out_txt := fun_1209(txt, a_simCode, a_useFlatArrayNotation);
  out_a_extraFuncs := a_extraFuncs;
  out_a_extraFuncsDecl := a_extraFuncsDecl;
  out_a_extraFuncsNamespace := a_extraFuncsNamespace;
end generateStepStarted;

protected function fun_1211
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      Absyn.Path i_modelInfo_name;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = i_modelInfo_name)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("int "));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::getDimTimeEvent() const\n",
                                    "{\n",
                                    "  return _dimTimeEvent;\n",
                                    "}"
                                }, false));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_1211;

public function generateDimTimeEvent
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_allEquations;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  out_txt := fun_1211(txt, a_simCode);
  out_a_extraFuncs := a_extraFuncs;
  out_a_extraFuncsDecl := a_extraFuncsDecl;
  out_a_extraFuncsNamespace := a_extraFuncsNamespace;
end generateDimTimeEvent;

protected function fun_1213
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      Absyn.Path i_modelInfo_name;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = i_modelInfo_name)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("std::pair<double,double>* "));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::getTimeEventData() const\n",
                                    "{\n",
                                    "  return _timeEventData;\n",
                                    "}"
                                }, false));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_1213;

public function generateGetTimeEvenData
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_allEquations;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  out_txt := fun_1213(txt, a_simCode);
  out_a_extraFuncs := a_extraFuncs;
  out_a_extraFuncsDecl := a_extraFuncsDecl;
  out_a_extraFuncsNamespace := a_extraFuncsNamespace;
end generateGetTimeEvenData;

protected function fun_1215
  input Tpl.Text in_txt;
  input BackendDAE.TimeEvent in_a_timeEvent;
  input Integer in_a_i1;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) :=
  match(in_txt, in_a_timeEvent, in_a_i1, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls)
    local
      Tpl.Text txt;
      Integer a_i1;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      DAE.Exp i_intervalExp;
      DAE.Exp i_startExp;
      Tpl.Text l_e2;
      Tpl.Text l_e1;
      Tpl.Text l_preExp;

    case ( txt,
           BackendDAE.SAMPLE_TIME_EVENT(startExp = i_startExp, intervalExp = i_intervalExp),
           a_i1,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_e1, l_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.daeExp(Tpl.emptyTxt, i_startExp, SimCodeFunction.contextOther, l_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        (l_e2, l_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.daeExp(Tpl.emptyTxt, i_intervalExp, SimCodeFunction.contextOther, l_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_timeEventData["));
        txt = Tpl.writeStr(txt, intString(a_i1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = std::make_pair("));
        txt = Tpl.writeText(txt, l_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, l_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           _,
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);
  end match;
end fun_1215;

protected function lm_1216
  input Tpl.Text in_txt;
  input list<BackendDAE.TimeEvent> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls)
    local
      Tpl.Text txt;
      list<BackendDAE.TimeEvent> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Integer x_i1;
      BackendDAE.TimeEvent i_timeEvent;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           i_timeEvent :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls )
      equation
        x_i1 = Tpl.getIteri_i0(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = fun_1215(txt, i_timeEvent, x_i1, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = lm_1216(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);
  end match;
end lm_1216;

protected function fun_1217
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      SimCode.SimCode i_simCode;
      list<BackendDAE.TimeEvent> i_timeEvents;
      Absyn.Path i_modelInfo_name;
      Tpl.Text l_varDecls;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = i_modelInfo_name), timeEvents = i_timeEvents)),
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_varDecls = Tpl.emptyTxt;
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::initTimeEventData()\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING_LIST({
                                                                     "\n",
                                                                     "\n"
                                                                 }, true)), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, l_varDecls) = lm_1216(txt, i_timeEvents, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, i_simCode, l_varDecls);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " // simplified treatment of clocks in model as time events\n",
                                    "for (int i = 0; i < _dimClock; i++)\n",
                                    "{\n",
                                    "  _timeEventData[_dimTimeEvent-_dimClock+i] = std::make_pair(_clockShift[i] * _clockInterval[i], _clockInterval[i]);\n",
                                    "}\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end fun_1217;

public function generateTimeEvent
  input Tpl.Text txt;
  input list<BackendDAE.TimeEvent> a_timeEvents;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) := fun_1217(txt, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
end generateTimeEvent;

protected function smf_1219
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_it;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) :=
  match(in_txt, in_it, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           i_eq,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls )
      equation
        (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = generateStepCompleted3(txt, i_eq, SimCodeFunction.contextOther, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);
  end match;
end smf_1219;

protected function lm_1220
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) :=
  match(in_txt, in_items, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      SimCode.SimEqSystem i_eqs;

    case ( txt,
           {},
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           i_eqs :: rest,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls )
      equation
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = smf_1219(txt, i_eqs, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls);
        txt = Tpl.nextIter(txt);
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = lm_1220(txt, rest, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);
  end match;
end lm_1220;

public function generateStepCompleted2
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_allEquations;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
protected
  Tpl.Text l_save__algloop__start__values;
  Tpl.Text l_varDecls;
algorithm
  l_varDecls := Tpl.emptyTxt;
  l_save__algloop__start__values := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (l_save__algloop__start__values, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, l_varDecls) := lm_1220(l_save__algloop__start__values, a_allEquations, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, l_varDecls);
  l_save__algloop__start__values := Tpl.popIter(l_save__algloop__start__values);
  out_txt := Tpl.writeText(txt, l_save__algloop__start__values);
end generateStepCompleted2;

protected function fun_1222
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_num;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode, in_a_num)
    local
      Tpl.Text txt;
      Tpl.Text a_num;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = _)),
           a_num )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_algLoop"));
        txt = Tpl.writeText(txt, a_num);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("->setRealStartValues();"));
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_1222;

protected function fun_1223
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_num;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode, in_a_num)
    local
      Tpl.Text txt;
      Tpl.Text a_num;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = _)),
           a_num )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_algLoop"));
        txt = Tpl.writeText(txt, a_num);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("->setRealStartValues();"));
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_1223;

public function generateStepCompleted3
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  (out_txt, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace) :=
  match(in_txt, in_a_eq, in_a_context, in_a_varDecls, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_varDecls;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      SimCode.SimEqSystem i_eq__sys;
      Integer i_nls_index;
      Integer i_ls_index;
      Tpl.Text l_num;

    case ( txt,
           SimCode.SES_LINEAR(lSystem = SimCode.LINEARSYSTEM(index = i_ls_index)),
           _,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace )
      equation
        l_num = Tpl.writeStr(Tpl.emptyTxt, intString(i_ls_index));
        txt = fun_1222(txt, a_simCode, l_num);
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);

    case ( txt,
           SimCode.SES_NONLINEAR(nlSystem = SimCode.NONLINEARSYSTEM(index = i_nls_index)),
           _,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace )
      equation
        l_num = Tpl.writeStr(Tpl.emptyTxt, intString(i_nls_index));
        txt = fun_1223(txt, a_simCode, l_num);
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);

    case ( txt,
           SimCode.SES_MIXED(cont = i_eq__sys),
           a_context,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace )
      equation
        (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = generateStepCompleted3(txt, i_eq__sys, a_context, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);

    case ( txt,
           _,
           _,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace )
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
  end match;
end generateStepCompleted3;

protected function smf_1225
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_it;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) :=
  match(in_txt, in_it, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           i_eq,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls )
      equation
        (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = generateAlgloopSolvers2(txt, i_eq, SimCodeFunction.contextOther, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);
  end match;
end smf_1225;

protected function lm_1226
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) :=
  match(in_txt, in_items, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      SimCode.SimEqSystem i_eqs;

    case ( txt,
           {},
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           i_eqs :: rest,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls )
      equation
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = smf_1225(txt, i_eqs, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls);
        txt = Tpl.nextIter(txt);
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = lm_1226(txt, rest, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);
  end match;
end lm_1226;

protected function fun_1227
  input Tpl.Text in_txt;
  input Integer in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           0 )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_algLoopLinearSolver= shared_ptr<ILinearAlgLoopSolver>(_algLoopSolverFactory->createLinearAlgLoopSolver());"));
      then txt;
  end match;
end fun_1227;

protected function fun_1228
  input Tpl.Text in_txt;
  input Integer in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           0 )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_algLoopNonLinearSolver= shared_ptr<INonLinearAlgLoopSolver>(_algLoopSolverFactory->createNonLinearAlgLoopSolver());"));
      then txt;
  end match;
end fun_1228;

protected function fun_1229
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> i_nls;
      list<SimCode.SimEqSystem> i_ls;
      Integer ret_3;
      Tpl.Text l_nonlinearSolver;
      Integer ret_1;
      Tpl.Text l_linearSolver;

    case ( txt,
           SimCode.MODELINFO(linearSystems = i_ls, nonLinearSystems = i_nls) )
      equation
        ret_1 = listLength(i_ls);
        l_linearSolver = fun_1227(Tpl.emptyTxt, ret_1);
        ret_3 = listLength(i_nls);
        l_nonlinearSolver = fun_1228(Tpl.emptyTxt, ret_3);
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_linearSolver);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_nonlinearSolver);
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_1229;

protected function fun_1230
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input SimCode.ModelInfo in_a_modelInfo;
  input list<SimCode.SimEqSystem> in_a_allEquationsPlusWhen;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace) :=
  match(in_txt, in_mArg, in_a_modelInfo, in_a_allEquationsPlusWhen, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace)
    local
      Tpl.Text txt;
      SimCode.ModelInfo a_modelInfo;
      list<SimCode.SimEqSystem> a_allEquationsPlusWhen;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text l_algloopsolver;
      Tpl.Text l_varDecls;

    case ( txt,
           true,
           _,
           a_allEquationsPlusWhen,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace )
      equation
        l_varDecls = Tpl.emptyTxt;
        l_algloopsolver = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_algloopsolver, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, l_varDecls) = lm_1226(l_algloopsolver, a_allEquationsPlusWhen, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, l_varDecls);
        l_algloopsolver = Tpl.popIter(l_algloopsolver);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_algloopsolver);
        txt = Tpl.popBlock(txt);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);

    case ( txt,
           false,
           a_modelInfo,
           _,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace )
      equation
        txt = fun_1229(txt, a_modelInfo);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);

    case ( txt,
           _,
           _,
           _,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
  end match;
end fun_1230;

public function generateAlgloopSolvers
  input Tpl.Text txt;
  input SimCode.ModelInfo a_modelInfo;
  input list<SimCode.SimEqSystem> a_allEquationsPlusWhen;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
protected
  Boolean ret_3;
  Boolean ret_2;
  Boolean ret_1;
  Boolean ret_0;
algorithm
  ret_0 := Flags.isSet(Flags.HPCOM);
  ret_1 := Flags.getConfigBool(Flags.SINGLE_INSTANCE_AGLSOLVER);
  ret_2 := boolNot(ret_1);
  ret_3 := boolOr(ret_0, ret_2);
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace) := fun_1230(txt, ret_3, a_modelInfo, a_allEquationsPlusWhen, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
end generateAlgloopSolvers;

protected function fun_1232
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_num;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode, in_a_num)
    local
      Tpl.Text txt;
      Tpl.Text a_num;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = _)),
           a_num )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_algLoopLinearSolver"));
        txt = Tpl.writeText(txt, a_num);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("= shared_ptr<ILinearAlgLoopSolver>(_algLoopSolverFactory->createLinearAlgLoopSolver( _algLoop"));
        txt = Tpl.writeText(txt, a_num);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("));"));
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_1232;

protected function fun_1233
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_num;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode, in_a_num)
    local
      Tpl.Text txt;
      Tpl.Text a_num;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = _)),
           a_num )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_algLoopNonLinearSolver"));
        txt = Tpl.writeText(txt, a_num);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("= shared_ptr<INonLinearAlgLoopSolver>(_algLoopSolverFactory->createNonLinearAlgLoopSolver( _algLoop"));
        txt = Tpl.writeText(txt, a_num);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "));\n",
                                    "\n"
                                }, true));
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_1233;

protected function fun_1234
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_eq, in_a_simCode)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      Integer i_nls_index;
      Integer i_ls_index;
      Tpl.Text l_num;

    case ( txt,
           SimCode.SES_LINEAR(lSystem = SimCode.LINEARSYSTEM(index = i_ls_index)),
           a_simCode )
      equation
        l_num = Tpl.writeStr(Tpl.emptyTxt, intString(i_ls_index));
        txt = fun_1232(txt, a_simCode, l_num);
      then txt;

    case ( txt,
           SimCode.SES_NONLINEAR(nlSystem = SimCode.NONLINEARSYSTEM(index = i_nls_index)),
           a_simCode )
      equation
        l_num = Tpl.writeStr(Tpl.emptyTxt, intString(i_nls_index));
        txt = fun_1233(txt, a_simCode, l_num);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_1234;

public function generateAlgloopSolvers2
  input Tpl.Text txt;
  input SimCode.SimEqSystem a_eq;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_varDecls;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  out_txt := fun_1234(txt, a_eq, a_simCode);
  out_a_varDecls := a_varDecls;
  out_a_extraFuncs := a_extraFuncs;
  out_a_extraFuncsDecl := a_extraFuncsDecl;
  out_a_extraFuncsNamespace := a_extraFuncsNamespace;
end generateAlgloopSolvers2;

protected function smf_1236
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_it;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) :=
  match(in_txt, in_it, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           i_eq,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls )
      equation
        (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = generateAlgloopSystems2(txt, i_eq, SimCodeFunction.contextOther, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);
  end match;
end smf_1236;

protected function lm_1237
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) :=
  match(in_txt, in_items, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      SimCode.SimEqSystem i_eqs;

    case ( txt,
           {},
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           i_eqs :: rest,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls )
      equation
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = smf_1236(txt, i_eqs, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls);
        txt = Tpl.nextIter(txt);
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = lm_1237(txt, rest, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);
  end match;
end lm_1237;

public function generateAlgloopSystems
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_allEquations;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
protected
  Tpl.Text l_algloopsolver;
  Tpl.Text l_varDecls;
algorithm
  l_varDecls := Tpl.emptyTxt;
  l_algloopsolver := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (l_algloopsolver, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, l_varDecls) := lm_1237(l_algloopsolver, a_allEquations, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, l_varDecls);
  l_algloopsolver := Tpl.popIter(l_algloopsolver);
  out_txt := Tpl.writeText(txt, l_algloopsolver);
end generateAlgloopSystems;

protected function smf_1239
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_it;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_it, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           i_eq,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = generatefriendAlgloops2(txt, i_eq, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end smf_1239;

protected function lm_1240
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      SimCode.SimEqSystem i_eqs;

    case ( txt,
           {},
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           i_eqs :: rest,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = smf_1239(txt, i_eqs, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
        txt = Tpl.nextIter(txt);
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1240(txt, rest, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_1240;

public function generatefriendAlgloops
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_allEquations;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
protected
  Tpl.Text l_friendalgloops;
algorithm
  l_friendalgloops := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (l_friendalgloops, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) := lm_1240(l_friendalgloops, a_allEquations, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
  l_friendalgloops := Tpl.popIter(l_friendalgloops);
  out_txt := Tpl.writeText(txt, l_friendalgloops);
end generatefriendAlgloops;

protected function fun_1242
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_num;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode, in_a_num)
    local
      Tpl.Text txt;
      Tpl.Text a_num;
      Absyn.Path i_modelInfo_name;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = i_modelInfo_name)),
           a_num )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("friend class "));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeText(txt, a_num);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_1242;

protected function fun_1243
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_num;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode, in_a_num)
    local
      Tpl.Text txt;
      Tpl.Text a_num;
      Absyn.Path i_modelInfo_name;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = i_modelInfo_name)),
           a_num )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("friend class "));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeText(txt, a_num);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_1243;

public function generatefriendAlgloops2
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace) :=
  match(in_txt, in_a_eq, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      SimCode.SimEqSystem i_eq__sys;
      Integer i_nls_index;
      Integer i_ls_index;
      Tpl.Text l_num;

    case ( txt,
           SimCode.SES_LINEAR(lSystem = SimCode.LINEARSYSTEM(index = i_ls_index)),
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace )
      equation
        l_num = Tpl.writeStr(Tpl.emptyTxt, intString(i_ls_index));
        txt = fun_1242(txt, a_simCode, l_num);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);

    case ( txt,
           SimCode.SES_NONLINEAR(nlSystem = SimCode.NONLINEARSYSTEM(index = i_nls_index)),
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace )
      equation
        l_num = Tpl.writeStr(Tpl.emptyTxt, intString(i_nls_index));
        txt = fun_1243(txt, a_simCode, l_num);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);

    case ( txt,
           SimCode.SES_MIXED(cont = i_eq__sys),
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = generatefriendAlgloops2(txt, i_eq__sys, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);

    case ( txt,
           _,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
  end match;
end generatefriendAlgloops2;

protected function fun_1245
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_num;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode, in_a_num)
    local
      Tpl.Text txt;
      Tpl.Text a_num;
      Absyn.Path i_modelInfo_name;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = i_modelInfo_name)),
           a_num )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_algLoop"));
        txt = Tpl.writeText(txt, a_num);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" =  shared_ptr<ILinearAlgLoop>(new "));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeText(txt, a_num);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(this,__z,__zDot,_conditions,_discrete_events));"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_1245;

protected function fun_1246
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_num;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode, in_a_num)
    local
      Tpl.Text txt;
      Tpl.Text a_num;
      Absyn.Path i_modelInfo_name;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = i_modelInfo_name)),
           a_num )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_algLoop"));
        txt = Tpl.writeText(txt, a_num);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" =  shared_ptr<INonLinearAlgLoop>(new "));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeText(txt, a_num);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(this,__z,__zDot,_conditions,_discrete_events));"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_1246;

public function generateAlgloopSystems2
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  (out_txt, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace) :=
  match(in_txt, in_a_eq, in_a_context, in_a_varDecls, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_varDecls;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      SimCode.SimEqSystem i_eq__sys;
      Integer i_nls_index;
      Integer i_ls_index;
      Tpl.Text l_num;

    case ( txt,
           SimCode.SES_LINEAR(lSystem = SimCode.LINEARSYSTEM(index = i_ls_index)),
           _,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace )
      equation
        l_num = Tpl.writeStr(Tpl.emptyTxt, intString(i_ls_index));
        txt = fun_1245(txt, a_simCode, l_num);
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);

    case ( txt,
           SimCode.SES_NONLINEAR(nlSystem = SimCode.NONLINEARSYSTEM(index = i_nls_index)),
           _,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace )
      equation
        l_num = Tpl.writeStr(Tpl.emptyTxt, intString(i_nls_index));
        txt = fun_1246(txt, a_simCode, l_num);
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);

    case ( txt,
           SimCode.SES_MIXED(cont = i_eq__sys),
           a_context,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace )
      equation
        (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = generateAlgloopSystems2(txt, i_eq__sys, a_context, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);

    case ( txt,
           _,
           _,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace )
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
  end match;
end generateAlgloopSystems2;

protected function fun_1248
  input Tpl.Text in_txt;
  input Integer in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           0 )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("shared_ptr<ILinearAlgLoopSolver>   _algLoopLinearSolver;        ///< Solver for linear algebraic loop */"));
      then txt;
  end match;
end fun_1248;

protected function fun_1249
  input Tpl.Text in_txt;
  input Integer in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           0 )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("shared_ptr<INonLinearAlgLoopSolver>   _algLoopNonLinearSolver;        ///< Solver for nonlinear algebraic loop */"));
      then txt;
  end match;
end fun_1249;

protected function fun_1250
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> i_nls;
      list<SimCode.SimEqSystem> i_ls;
      Integer ret_3;
      Tpl.Text l_nonlinearSolver;
      Integer ret_1;
      Tpl.Text l_linearSolver;

    case ( txt,
           SimCode.MODELINFO(linearSystems = i_ls, nonLinearSystems = i_nls) )
      equation
        ret_1 = listLength(i_ls);
        l_linearSolver = fun_1248(Tpl.emptyTxt, ret_1);
        ret_3 = listLength(i_nls);
        l_nonlinearSolver = fun_1249(Tpl.emptyTxt, ret_3);
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeText(txt, l_linearSolver);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_nonlinearSolver);
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_1250;

protected function fun_1251
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input SimCode.ModelInfo in_a_modelInfo;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace) :=
  match(in_txt, in_mArg, in_a_modelInfo, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace)
    local
      Tpl.Text txt;
      SimCode.ModelInfo a_modelInfo;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;

    case ( txt,
           true,
           _,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = generateAlgloopsolverVariables2(txt, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);

    case ( txt,
           false,
           a_modelInfo,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace )
      equation
        txt = fun_1250(txt, a_modelInfo);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);

    case ( txt,
           _,
           _,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
  end match;
end fun_1251;

public function generateAlgloopsolverVariables
  input Tpl.Text txt;
  input SimCode.ModelInfo a_modelInfo;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
protected
  Boolean ret_3;
  Boolean ret_2;
  Boolean ret_1;
  Boolean ret_0;
algorithm
  ret_0 := Flags.isSet(Flags.HPCOM);
  ret_1 := Flags.getConfigBool(Flags.SINGLE_INSTANCE_AGLSOLVER);
  ret_2 := boolNot(ret_1);
  ret_3 := boolOr(ret_0, ret_2);
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace) := fun_1251(txt, ret_3, a_modelInfo, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
end generateAlgloopsolverVariables;

protected function lm_1253
  input Tpl.Text in_txt;
  input list<SimCode.JacobianColumn> in_items;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input SimCode.ModelInfo in_a_modelInfo;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_modelInfo)
    local
      Tpl.Text txt;
      list<SimCode.JacobianColumn> rest;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      SimCode.ModelInfo a_modelInfo;
      list<SimCode.SimEqSystem> i_eqs;

    case ( txt,
           {},
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           SimCode.JAC_COLUMN(columnEqns = i_eqs) :: rest,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_modelInfo )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = generateAlgloopsolverVariables3(txt, a_modelInfo, i_eqs, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
        txt = Tpl.nextIter(txt);
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1253(txt, rest, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_modelInfo);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _ :: rest,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_modelInfo )
      equation
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1253(txt, rest, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_modelInfo);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_1253;

protected function lm_1254
  input Tpl.Text in_txt;
  input list<SimCode.JacobianMatrix> in_items;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input SimCode.ModelInfo in_a_modelInfo;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_modelInfo)
    local
      Tpl.Text txt;
      list<SimCode.JacobianMatrix> rest;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      SimCode.ModelInfo a_modelInfo;
      list<SimCode.JacobianColumn> i_mat;

    case ( txt,
           {},
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           SimCode.JAC_MATRIX(columns = i_mat) :: rest,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_modelInfo )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1253(txt, i_mat, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_modelInfo);
        txt = Tpl.popIter(txt);
        txt = Tpl.nextIter(txt);
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1254(txt, rest, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_modelInfo);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _ :: rest,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_modelInfo )
      equation
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1254(txt, rest, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_modelInfo);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_1254;

public function generateAlgloopsolverVariables2
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace) :=
  match(in_txt, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace)
    local
      Tpl.Text txt;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      list<SimCode.JacobianMatrix> i_jacobianMatrixes;
      SimCode.SimCode i_simCode;
      list<SimCode.ClockedPartition> i_clockedPartitions;
      list<SimCode.SimEqSystem> i_initialEquations;
      list<SimCode.SimEqSystem> i_allEquations;
      SimCode.ModelInfo i_modelInfo;
      Tpl.Text l_jacalgloopsolver;
      list<SimCode.SimEqSystem> ret_4;
      list<SimCode.SimEqSystem> ret_3;
      list<SimCode.SubPartition> ret_2;
      list<SimCode.SimEqSystem> ret_1;
      Tpl.Text l_algloopsolvers;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = i_modelInfo, allEquations = i_allEquations, initialEquations = i_initialEquations, clockedPartitions = i_clockedPartitions, jacobianMatrixes = i_jacobianMatrixes)),
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace )
      equation
        ret_1 = listAppend(i_allEquations, i_initialEquations);
        ret_2 = SimCodeUtil.getSubPartitions(i_clockedPartitions);
        ret_3 = SimCodeUtil.getClockedEquations(ret_2);
        ret_4 = listAppend(ret_1, ret_3);
        (l_algloopsolvers, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = generateAlgloopsolverVariables3(Tpl.emptyTxt, i_modelInfo, ret_4, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
        l_jacalgloopsolver = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING("")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_jacalgloopsolver, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1254(l_jacalgloopsolver, i_jacobianMatrixes, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, i_simCode, i_modelInfo);
        l_jacalgloopsolver = Tpl.popIter(l_jacalgloopsolver);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_algloopsolvers);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_jacalgloopsolver);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "\n"
                                }, true));
        txt = Tpl.popBlock(txt);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);

    case ( txt,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
  end match;
end generateAlgloopsolverVariables2;

protected function smf_1256
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_it;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) :=
  match(in_txt, in_it, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           i_eq,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls )
      equation
        (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = generateAlgloopsolverVariables4(txt, i_eq, SimCodeFunction.contextOther, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);
  end match;
end smf_1256;

protected function lm_1257
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) :=
  match(in_txt, in_items, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      SimCode.SimEqSystem i_eqs;

    case ( txt,
           {},
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           i_eqs :: rest,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls )
      equation
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = smf_1256(txt, i_eqs, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls);
        txt = Tpl.nextIter(txt);
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = lm_1257(txt, rest, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);
  end match;
end lm_1257;

protected function fun_1258
  input Tpl.Text in_txt;
  input Integer in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           0 )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("shared_ptr<ILinearAlgLoopSolver>   _algLoopLinearSolver;        ///< Solver for linear algebraic loop */"));
      then txt;
  end match;
end fun_1258;

protected function fun_1259
  input Tpl.Text in_txt;
  input Integer in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           0 )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("shared_ptr<INonLinearAlgLoopSolver>   _algLoopNonLinearSolver;        ///< Solver for nonlinear algebraic loop */"));
      then txt;
  end match;
end fun_1259;

protected function fun_1260
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> i_nls;
      list<SimCode.SimEqSystem> i_ls;
      Integer ret_3;
      Tpl.Text l_nonlinearSolver;
      Integer ret_1;
      Tpl.Text l_linearSolver;

    case ( txt,
           SimCode.MODELINFO(linearSystems = i_ls, nonLinearSystems = i_nls) )
      equation
        ret_1 = listLength(i_ls);
        l_linearSolver = fun_1258(Tpl.emptyTxt, ret_1);
        ret_3 = listLength(i_nls);
        l_nonlinearSolver = fun_1259(Tpl.emptyTxt, ret_3);
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeText(txt, l_linearSolver);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_nonlinearSolver);
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_1260;

protected function fun_1261
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input SimCode.ModelInfo in_a_modelInfo;
  input list<SimCode.SimEqSystem> in_a_allEquationsPlusWhen;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace) :=
  match(in_txt, in_mArg, in_a_modelInfo, in_a_allEquationsPlusWhen, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace)
    local
      Tpl.Text txt;
      SimCode.ModelInfo a_modelInfo;
      list<SimCode.SimEqSystem> a_allEquationsPlusWhen;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text l_algloopsolver;
      Tpl.Text l_varDecls;

    case ( txt,
           true,
           _,
           a_allEquationsPlusWhen,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace )
      equation
        l_varDecls = Tpl.emptyTxt;
        l_algloopsolver = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_algloopsolver, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, l_varDecls) = lm_1257(l_algloopsolver, a_allEquationsPlusWhen, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, l_varDecls);
        l_algloopsolver = Tpl.popIter(l_algloopsolver);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_algloopsolver);
        txt = Tpl.popBlock(txt);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);

    case ( txt,
           false,
           a_modelInfo,
           _,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace )
      equation
        txt = fun_1260(txt, a_modelInfo);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);

    case ( txt,
           _,
           _,
           _,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
  end match;
end fun_1261;

public function generateAlgloopsolverVariables3
  input Tpl.Text txt;
  input SimCode.ModelInfo a_modelInfo;
  input list<SimCode.SimEqSystem> a_allEquationsPlusWhen;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
protected
  Boolean ret_3;
  Boolean ret_2;
  Boolean ret_1;
  Boolean ret_0;
algorithm
  ret_0 := Flags.isSet(Flags.HPCOM);
  ret_1 := Flags.getConfigBool(Flags.SINGLE_INSTANCE_AGLSOLVER);
  ret_2 := boolNot(ret_1);
  ret_3 := boolOr(ret_0, ret_2);
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace) := fun_1261(txt, ret_3, a_modelInfo, a_allEquationsPlusWhen, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
end generateAlgloopsolverVariables3;

protected function fun_1263
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_num;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode, in_a_num)
    local
      Tpl.Text txt;
      Tpl.Text a_num;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = _)),
           a_num )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("  shared_ptr<ILinearAlgLoopSolver>\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(5));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_algLoopLinearSolver"));
        txt = Tpl.writeText(txt, a_num);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";        ///< Solver for algebraic loop */\n",
                                    "\n"
                                }, true));
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_1263;

protected function fun_1264
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_num;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode, in_a_num)
    local
      Tpl.Text txt;
      Tpl.Text a_num;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = _)),
           a_num )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" shared_ptr<INonLinearAlgLoopSolver>\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(5));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_algLoopNonLinearSolver"));
        txt = Tpl.writeText(txt, a_num);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";        ///< Solver for algebraic loop */"));
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_1264;

protected function fun_1265
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_eq, in_a_simCode)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      Integer i_nls_index;
      Integer i_ls_index;
      Tpl.Text l_num;

    case ( txt,
           SimCode.SES_LINEAR(lSystem = SimCode.LINEARSYSTEM(index = i_ls_index)),
           a_simCode )
      equation
        l_num = Tpl.writeStr(Tpl.emptyTxt, intString(i_ls_index));
        txt = fun_1263(txt, a_simCode, l_num);
      then txt;

    case ( txt,
           SimCode.SES_NONLINEAR(nlSystem = SimCode.NONLINEARSYSTEM(index = i_nls_index)),
           a_simCode )
      equation
        l_num = Tpl.writeStr(Tpl.emptyTxt, intString(i_nls_index));
        txt = fun_1264(txt, a_simCode, l_num);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_1265;

public function generateAlgloopsolverVariables4
  input Tpl.Text txt;
  input SimCode.SimEqSystem a_eq;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_varDecls;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  out_txt := fun_1265(txt, a_eq, a_simCode);
  out_a_varDecls := a_varDecls;
  out_a_extraFuncs := a_extraFuncs;
  out_a_extraFuncsDecl := a_extraFuncsDecl;
  out_a_extraFuncsNamespace := a_extraFuncsNamespace;
end generateAlgloopsolverVariables4;

protected function smf_1267
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_it;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) :=
  match(in_txt, in_it, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           i_eq,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls )
      equation
        (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = generateAlgloopsSystemVariables2(txt, i_eq, SimCodeFunction.contextOther, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);
  end match;
end smf_1267;

protected function lm_1268
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) :=
  match(in_txt, in_items, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      SimCode.SimEqSystem i_eqs;

    case ( txt,
           {},
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           i_eqs :: rest,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls )
      equation
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = smf_1267(txt, i_eqs, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls);
        txt = Tpl.nextIter(txt);
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = lm_1268(txt, rest, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);
  end match;
end lm_1268;

public function generateAlgloopsSystemVariables
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_allEquationsPlusWhen;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
protected
  Tpl.Text l_algloopsystems;
  Tpl.Text l_varDecls;
algorithm
  l_varDecls := Tpl.emptyTxt;
  l_algloopsystems := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (l_algloopsystems, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, l_varDecls) := lm_1268(l_algloopsystems, a_allEquationsPlusWhen, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, l_varDecls);
  l_algloopsystems := Tpl.popIter(l_algloopsystems);
  out_txt := Tpl.writeText(txt, l_algloopsystems);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_NEW_LINE());
end generateAlgloopsSystemVariables;

protected function fun_1270
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_num;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode, in_a_num)
    local
      Tpl.Text txt;
      Tpl.Text a_num;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = _)),
           a_num )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("shared_ptr<ILinearAlgLoop>  //Algloop  which holds equation system\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(5));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_algLoop"));
        txt = Tpl.writeText(txt, a_num);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "\n"
                                }, true));
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_1270;

protected function fun_1271
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_num;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode, in_a_num)
    local
      Tpl.Text txt;
      Tpl.Text a_num;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = _)),
           a_num )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("shared_ptr<INonLinearAlgLoop>  //Algloop  which holds equation system\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(5));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_algLoop"));
        txt = Tpl.writeText(txt, a_num);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "\n",
                                    "\n"
                                }, true));
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_1271;

public function generateAlgloopsSystemVariables2
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  (out_txt, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace) :=
  match(in_txt, in_a_eq, in_a_context, in_a_varDecls, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_varDecls;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      SimCode.SimEqSystem i_eq__sys;
      Integer i_nls_index;
      Integer i_ls_index;
      Tpl.Text l_num;

    case ( txt,
           SimCode.SES_LINEAR(lSystem = SimCode.LINEARSYSTEM(index = i_ls_index)),
           _,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace )
      equation
        l_num = Tpl.writeStr(Tpl.emptyTxt, intString(i_ls_index));
        txt = fun_1270(txt, a_simCode, l_num);
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);

    case ( txt,
           SimCode.SES_NONLINEAR(nlSystem = SimCode.NONLINEARSYSTEM(index = i_nls_index)),
           _,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace )
      equation
        l_num = Tpl.writeStr(Tpl.emptyTxt, intString(i_nls_index));
        txt = fun_1271(txt, a_simCode, l_num);
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);

    case ( txt,
           SimCode.SES_MIXED(cont = i_eq__sys),
           a_context,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace )
      equation
        (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = generateAlgloopsSystemVariables2(txt, i_eq__sys, a_context, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);

    case ( txt,
           _,
           _,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace )
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
  end match;
end generateAlgloopsSystemVariables2;

protected function smf_1273
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_it;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) :=
  match(in_txt, in_it, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           i_eq,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls )
      equation
        (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = initAlgloopsolvers2(txt, i_eq, SimCodeFunction.contextOther, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);
  end match;
end smf_1273;

protected function lm_1274
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) :=
  match(in_txt, in_items, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      SimCode.SimEqSystem i_eqs;

    case ( txt,
           {},
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           i_eqs :: rest,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls )
      equation
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = smf_1273(txt, i_eqs, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls);
        txt = Tpl.nextIter(txt);
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = lm_1274(txt, rest, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);
  end match;
end lm_1274;

public function initAlgloopsolvers
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_allEquationsPlusWhen;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
protected
  Tpl.Text l_algloopsolver;
  Tpl.Text l_varDecls;
algorithm
  l_varDecls := Tpl.emptyTxt;
  l_algloopsolver := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING("")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (l_algloopsolver, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, l_varDecls) := lm_1274(l_algloopsolver, a_allEquationsPlusWhen, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, l_varDecls);
  l_algloopsolver := Tpl.popIter(l_algloopsolver);
  out_txt := Tpl.writeText(txt, l_algloopsolver);
end initAlgloopsolvers;

protected function lm_1276
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) :=
  match(in_txt, in_items, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           {},
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           i_eq :: rest,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls )
      equation
        (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = initAlgloopsolvers2(txt, i_eq, SimCodeFunction.contextOther, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
        txt = Tpl.nextIter(txt);
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = lm_1276(txt, rest, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);
  end match;
end lm_1276;

public function initAlgloopsolver
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_equations;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
protected
  Tpl.Text l_algloopsolver;
  Tpl.Text l_varDecls;
algorithm
  l_varDecls := Tpl.emptyTxt;
  l_algloopsolver := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING("")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (l_algloopsolver, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, l_varDecls) := lm_1276(l_algloopsolver, a_equations, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, l_varDecls);
  l_algloopsolver := Tpl.popIter(l_algloopsolver);
  out_txt := Tpl.writeText(txt, l_algloopsolver);
end initAlgloopsolver;

protected function fun_1278
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_num;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode, in_a_num)
    local
      Tpl.Text txt;
      Tpl.Text a_num;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = _)),
           a_num )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if(_algLoopSolver"));
        txt = Tpl.writeText(txt, a_num);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(")\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_algLoopSolver"));
        txt = Tpl.writeText(txt, a_num);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("->initialize();"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_1278;

protected function fun_1279
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_num;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode, in_a_num)
    local
      Tpl.Text txt;
      Tpl.Text a_num;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = _)),
           a_num )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if(_algLoopSolver"));
        txt = Tpl.writeText(txt, a_num);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(")\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_algLoopSolver"));
        txt = Tpl.writeText(txt, a_num);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("->initialize();"));
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_1279;

public function initAlgloopsolvers2
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  (out_txt, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace) :=
  match(in_txt, in_a_eq, in_a_context, in_a_varDecls, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_varDecls;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      SimCode.SimEqSystem i_eq__sys;
      Integer i_nls_index;
      Integer i_ls_index;
      Tpl.Text l_num;

    case ( txt,
           SimCode.SES_LINEAR(lSystem = SimCode.LINEARSYSTEM(index = i_ls_index)),
           _,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace )
      equation
        l_num = Tpl.writeStr(Tpl.emptyTxt, intString(i_ls_index));
        txt = fun_1278(txt, a_simCode, l_num);
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);

    case ( txt,
           SimCode.SES_NONLINEAR(nlSystem = SimCode.NONLINEARSYSTEM(index = i_nls_index)),
           _,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace )
      equation
        l_num = Tpl.writeStr(Tpl.emptyTxt, intString(i_nls_index));
        txt = fun_1279(txt, a_simCode, l_num);
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);

    case ( txt,
           SimCode.SES_MIXED(cont = i_eq__sys),
           a_context,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace )
      equation
        (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = initAlgloopsolvers2(txt, i_eq__sys, a_context, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);

    case ( txt,
           _,
           _,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace )
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
  end match;
end initAlgloopsolvers2;

protected function smf_1281
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_it;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) :=
  match(in_txt, in_it, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           i_eq,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls )
      equation
        (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = algloopForwardDeclaration2(txt, i_eq, SimCodeFunction.contextOther, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);
  end match;
end smf_1281;

protected function lm_1282
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) :=
  match(in_txt, in_items, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      SimCode.SimEqSystem i_eqs;

    case ( txt,
           {},
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           i_eqs :: rest,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls )
      equation
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = smf_1281(txt, i_eqs, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls);
        txt = Tpl.nextIter(txt);
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = lm_1282(txt, rest, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);
  end match;
end lm_1282;

public function algloopForwardDeclaration
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_allEquations;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
protected
  Tpl.Text l_varDecls;
algorithm
  l_varDecls := Tpl.emptyTxt;
  out_txt := Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, l_varDecls) := lm_1282(out_txt, a_allEquations, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, l_varDecls);
  out_txt := Tpl.popIter(out_txt);
end algloopForwardDeclaration;

protected function fun_1284
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_num;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode, in_a_num)
    local
      Tpl.Text txt;
      Tpl.Text a_num;
      Absyn.Path i_modelInfo_name;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = i_modelInfo_name)),
           a_num )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("class "));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeText(txt, a_num);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_1284;

protected function fun_1285
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_num;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode, in_a_num)
    local
      Tpl.Text txt;
      Tpl.Text a_num;
      Absyn.Path i_modelInfo_name;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = i_modelInfo_name)),
           a_num )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("class "));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeText(txt, a_num);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_1285;

public function algloopForwardDeclaration2
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  (out_txt, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace) :=
  match(in_txt, in_a_eq, in_a_context, in_a_varDecls, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_varDecls;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      SimCode.SimEqSystem i_eq__sys;
      Integer i_nls_index;
      Integer i_ls_index;
      Tpl.Text l_num;

    case ( txt,
           SimCode.SES_LINEAR(lSystem = SimCode.LINEARSYSTEM(index = i_ls_index)),
           _,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace )
      equation
        l_num = Tpl.writeStr(Tpl.emptyTxt, intString(i_ls_index));
        txt = fun_1284(txt, a_simCode, l_num);
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);

    case ( txt,
           SimCode.SES_NONLINEAR(nlSystem = SimCode.NONLINEARSYSTEM(index = i_nls_index)),
           _,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace )
      equation
        l_num = Tpl.writeStr(Tpl.emptyTxt, intString(i_nls_index));
        txt = fun_1285(txt, a_simCode, l_num);
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);

    case ( txt,
           SimCode.SES_MIXED(cont = i_eq__sys),
           a_context,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace )
      equation
        (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = algloopForwardDeclaration2(txt, i_eq__sys, a_context, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);

    case ( txt,
           _,
           _,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace )
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
  end match;
end algloopForwardDeclaration2;

protected function smf_1287
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_it;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) :=
  match(in_txt, in_it, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           i_eq,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls )
      equation
        (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = algloopfilesInclude2(txt, i_eq, SimCodeFunction.contextOther, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);
  end match;
end smf_1287;

protected function lm_1288
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) :=
  match(in_txt, in_items, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      SimCode.SimEqSystem i_eqs;

    case ( txt,
           {},
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           i_eqs :: rest,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls )
      equation
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = smf_1287(txt, i_eqs, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls);
        txt = Tpl.nextIter(txt);
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = lm_1288(txt, rest, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);
  end match;
end lm_1288;

public function algloopfilesInclude
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_allEquations;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
protected
  Tpl.Text l_varDecls;
algorithm
  l_varDecls := Tpl.emptyTxt;
  out_txt := Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, l_varDecls) := lm_1288(out_txt, a_allEquations, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, l_varDecls);
  out_txt := Tpl.popIter(out_txt);
end algloopfilesInclude;

protected function fun_1290
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_num;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode, in_a_num)
    local
      Tpl.Text txt;
      Tpl.Text a_num;
      String i_fileNamePrefix;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = _), fileNamePrefix = i_fileNamePrefix),
           a_num )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#include \"OMCpp"));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeText(txt, a_num);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".h\""));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_1290;

protected function fun_1291
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_num;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode, in_a_num)
    local
      Tpl.Text txt;
      Tpl.Text a_num;
      String i_fileNamePrefix;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = _), fileNamePrefix = i_fileNamePrefix),
           a_num )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#include \"OMCpp"));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeText(txt, a_num);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".h\""));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_1291;

public function algloopfilesInclude2
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  (out_txt, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace) :=
  match(in_txt, in_a_eq, in_a_context, in_a_varDecls, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_varDecls;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      SimCode.SimEqSystem i_eq__sys;
      Integer i_nls_index;
      Integer i_ls_index;
      Tpl.Text l_num;

    case ( txt,
           SimCode.SES_LINEAR(lSystem = SimCode.LINEARSYSTEM(index = i_ls_index)),
           _,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace )
      equation
        l_num = Tpl.writeStr(Tpl.emptyTxt, intString(i_ls_index));
        txt = fun_1290(txt, a_simCode, l_num);
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);

    case ( txt,
           SimCode.SES_NONLINEAR(nlSystem = SimCode.NONLINEARSYSTEM(index = i_nls_index)),
           _,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace )
      equation
        l_num = Tpl.writeStr(Tpl.emptyTxt, intString(i_nls_index));
        txt = fun_1291(txt, a_simCode, l_num);
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);

    case ( txt,
           SimCode.SES_MIXED(cont = i_eq__sys),
           a_context,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace )
      equation
        (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = algloopfilesInclude2(txt, i_eq__sys, a_context, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);

    case ( txt,
           _,
           _,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace )
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
  end match;
end algloopfilesInclude2;

protected function lm_1293
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Integer in_a_clockIndex;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_clockIndex, in_a_context)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Integer a_clockIndex;
      SimCodeFunction.Context a_context;
      SimCode.SimEqSystem i_eqs;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           i_eqs :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_clockIndex,
           a_context )
      equation
        (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = algloopfiles2(txt, i_eqs, a_context, a_clockIndex, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = lm_1293(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_clockIndex, a_context);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);
  end match;
end lm_1293;

public function algloopfiles
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_allEquations;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input SimCodeFunction.Context a_context;
  input Integer a_clockIndex;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
protected
  Tpl.Text l_algloopsolver;
  Tpl.Text l_varDecls;
algorithm
  l_varDecls := Tpl.emptyTxt;
  l_algloopsolver := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (l_algloopsolver, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, l_varDecls) := lm_1293(l_algloopsolver, a_allEquations, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, l_varDecls, a_clockIndex, a_context);
  l_algloopsolver := Tpl.popIter(l_algloopsolver);
  out_txt := Tpl.writeText(txt, l_algloopsolver);
end algloopfiles;

protected function fun_1295
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_stateDerVectorName;
  input Integer in_a_clockIndex;
  input Tpl.Text in_a_num;
  input Boolean in_a_useFlatArrayNotation;
  input SimCodeFunction.Context in_a_context;
  input SimCode.SimEqSystem in_a_eq;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_a_simCode, in_a_stateDerVectorName, in_a_clockIndex, in_a_num, in_a_useFlatArrayNotation, in_a_context, in_a_eq, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs)
    local
      Tpl.Text txt;
      Tpl.Text a_stateDerVectorName;
      Integer a_clockIndex;
      Tpl.Text a_num;
      Boolean a_useFlatArrayNotation;
      SimCodeFunction.Context a_context;
      SimCode.SimEqSystem a_eq;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      String i_fileNamePrefix;
      SimCode.SimCode i_simCode;
      Tpl.Text txt_3;
      Tpl.Text txt_2;
      Tpl.Text txt_1;
      Tpl.Text txt_0;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = _), fileNamePrefix = i_fileNamePrefix)),
           a_stateDerVectorName,
           a_clockIndex,
           a_num,
           a_useFlatArrayNotation,
           a_context,
           a_eq,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs )
      equation
        (txt_0, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = algloopHeaderFile(Tpl.emptyTxt, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_eq, a_context, a_useFlatArrayNotation);
        txt_1 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("OMCpp"));
        txt_1 = Tpl.writeStr(txt_1, i_fileNamePrefix);
        txt_1 = Tpl.writeTok(txt_1, Tpl.ST_STRING("Algloop"));
        txt_1 = Tpl.writeText(txt_1, a_num);
        txt_1 = Tpl.writeTok(txt_1, Tpl.ST_STRING(".h"));
        Tpl.textFile(txt_0, Tpl.textString(txt_1));
        (txt_2, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = algloopCppFile(Tpl.emptyTxt, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_eq, a_context, a_clockIndex, a_stateDerVectorName, a_useFlatArrayNotation);
        txt_3 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("OMCpp"));
        txt_3 = Tpl.writeStr(txt_3, i_fileNamePrefix);
        txt_3 = Tpl.writeTok(txt_3, Tpl.ST_STRING("Algloop"));
        txt_3 = Tpl.writeText(txt_3, a_num);
        txt_3 = Tpl.writeTok(txt_3, Tpl.ST_STRING(".cpp"));
        Tpl.textFile(txt_2, Tpl.textString(txt_3));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           a_stateDerVectorName,
           _,
           _,
           _,
           _,
           _,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_1295;

protected function fun_1296
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_stateDerVectorName;
  input Integer in_a_clockIndex;
  input Tpl.Text in_a_num;
  input Boolean in_a_useFlatArrayNotation;
  input SimCodeFunction.Context in_a_context;
  input SimCode.SimEqSystem in_a_eq;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_a_simCode, in_a_stateDerVectorName, in_a_clockIndex, in_a_num, in_a_useFlatArrayNotation, in_a_context, in_a_eq, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs)
    local
      Tpl.Text txt;
      Tpl.Text a_stateDerVectorName;
      Integer a_clockIndex;
      Tpl.Text a_num;
      Boolean a_useFlatArrayNotation;
      SimCodeFunction.Context a_context;
      SimCode.SimEqSystem a_eq;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      String i_fileNamePrefix;
      SimCode.SimCode i_simCode;
      Tpl.Text txt_3;
      Tpl.Text txt_2;
      Tpl.Text txt_1;
      Tpl.Text txt_0;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = _), fileNamePrefix = i_fileNamePrefix)),
           a_stateDerVectorName,
           a_clockIndex,
           a_num,
           a_useFlatArrayNotation,
           a_context,
           a_eq,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs )
      equation
        (txt_0, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = algloopHeaderFile(Tpl.emptyTxt, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_eq, a_context, a_useFlatArrayNotation);
        txt_1 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("OMCpp"));
        txt_1 = Tpl.writeStr(txt_1, i_fileNamePrefix);
        txt_1 = Tpl.writeTok(txt_1, Tpl.ST_STRING("Algloop"));
        txt_1 = Tpl.writeText(txt_1, a_num);
        txt_1 = Tpl.writeTok(txt_1, Tpl.ST_STRING(".h"));
        Tpl.textFile(txt_0, Tpl.textString(txt_1));
        (txt_2, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = algloopCppFile(Tpl.emptyTxt, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_eq, a_context, a_clockIndex, a_stateDerVectorName, a_useFlatArrayNotation);
        txt_3 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("OMCpp"));
        txt_3 = Tpl.writeStr(txt_3, i_fileNamePrefix);
        txt_3 = Tpl.writeTok(txt_3, Tpl.ST_STRING("Algloop"));
        txt_3 = Tpl.writeText(txt_3, a_num);
        txt_3 = Tpl.writeTok(txt_3, Tpl.ST_STRING(".cpp"));
        Tpl.textFile(txt_2, Tpl.textString(txt_3));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           a_stateDerVectorName,
           _,
           _,
           _,
           _,
           _,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_1296;

protected function fun_1297
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_stateDerVectorName;
  input Integer in_a_clockIndex;
  input Boolean in_a_useFlatArrayNotation;
  input SimCodeFunction.Context in_a_context;
  input SimCode.SimEqSystem in_a_eq__sys;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_a_simCode, in_a_stateDerVectorName, in_a_clockIndex, in_a_useFlatArrayNotation, in_a_context, in_a_eq__sys, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs)
    local
      Tpl.Text txt;
      Tpl.Text a_stateDerVectorName;
      Integer a_clockIndex;
      Boolean a_useFlatArrayNotation;
      SimCodeFunction.Context a_context;
      SimCode.SimEqSystem a_eq__sys;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      String i_fileNamePrefix;
      SimCode.SimCode i_simCode;
      Tpl.Text txt_3;
      Tpl.Text txt_2;
      Tpl.Text txt_1;
      Tpl.Text txt_0;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = _), fileNamePrefix = i_fileNamePrefix)),
           a_stateDerVectorName,
           a_clockIndex,
           a_useFlatArrayNotation,
           a_context,
           a_eq__sys,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs )
      equation
        (txt_0, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = algloopHeaderFile(Tpl.emptyTxt, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_eq__sys, a_context, a_useFlatArrayNotation);
        txt_1 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("OMCpp"));
        txt_1 = Tpl.writeStr(txt_1, i_fileNamePrefix);
        txt_1 = Tpl.writeTok(txt_1, Tpl.ST_STRING("Algloop"));
        txt_1 = algloopfilesindex(txt_1, a_eq__sys);
        txt_1 = Tpl.writeTok(txt_1, Tpl.ST_STRING(".h"));
        Tpl.textFile(txt_0, Tpl.textString(txt_1));
        (txt_2, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = algloopCppFile(Tpl.emptyTxt, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_eq__sys, a_context, a_clockIndex, a_stateDerVectorName, a_useFlatArrayNotation);
        txt_3 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("OMCpp"));
        txt_3 = Tpl.writeStr(txt_3, i_fileNamePrefix);
        txt_3 = Tpl.writeTok(txt_3, Tpl.ST_STRING("Algloop"));
        txt_3 = algloopfilesindex(txt_3, a_eq__sys);
        txt_3 = Tpl.writeTok(txt_3, Tpl.ST_STRING(".cpp"));
        Tpl.textFile(txt_2, Tpl.textString(txt_3));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           a_stateDerVectorName,
           _,
           _,
           _,
           _,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_1297;

protected function fun_1298
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input SimCodeFunction.Context in_a_context;
  input Integer in_a_clockIndex;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_eq, in_a_context, in_a_clockIndex, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Integer a_clockIndex;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      SimCode.SimEqSystem i_eq__sys;
      SimCode.SimEqSystem i_e;
      Integer i_nls_index;
      SimCode.SimEqSystem i_eq;
      Integer i_ls_index;
      Tpl.Text l_num;

    case ( txt,
           (i_eq as SimCode.SES_LINEAR(lSystem = SimCode.LINEARSYSTEM(index = i_ls_index))),
           a_context,
           a_clockIndex,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_num = Tpl.writeStr(Tpl.emptyTxt, intString(i_ls_index));
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_1295(txt, a_simCode, a_stateDerVectorName, a_clockIndex, l_num, a_useFlatArrayNotation, a_context, i_eq, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           (i_e as SimCode.SES_NONLINEAR(nlSystem = SimCode.NONLINEARSYSTEM(index = i_nls_index))),
           a_context,
           a_clockIndex,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_num = Tpl.writeStr(Tpl.emptyTxt, intString(i_nls_index));
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_1296(txt, a_simCode, a_stateDerVectorName, a_clockIndex, l_num, a_useFlatArrayNotation, a_context, i_e, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           SimCode.SES_MIXED(cont = i_eq__sys),
           a_context,
           a_clockIndex,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_1297(txt, a_simCode, a_stateDerVectorName, a_clockIndex, a_useFlatArrayNotation, a_context, i_eq__sys, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           _,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end fun_1298;

public function algloopfiles2
  input Tpl.Text txt;
  input SimCode.SimEqSystem a_eq;
  input SimCodeFunction.Context a_context;
  input Integer a_clockIndex;
  input Tpl.Text a_varDecls;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) := fun_1298(txt, a_eq, a_context, a_clockIndex, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
  out_a_varDecls := a_varDecls;
end algloopfiles2;

protected function fun_1300
  input Tpl.Text in_txt;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_filename;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_context, in_a_filename)
    local
      Tpl.Text txt;
      Tpl.Text a_filename;

    case ( txt,
           SimCodeFunction.ALGLOOP_CONTEXT(genInitialisation = false, genJacobian = true),
           a_filename )
      equation
        txt = Tpl.writeText(txt, a_filename);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Jacobian"));
      then txt;

    case ( txt,
           _,
           a_filename )
      equation
        txt = Tpl.writeText(txt, a_filename);
      then txt;
  end match;
end fun_1300;

protected function lm_1301
  input Tpl.Text in_txt;
  input list<SimCode.JacobianColumn> in_items;
  input Tpl.Text in_a_filename;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_filename, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCode.JacobianColumn> rest;
      Tpl.Text a_filename;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      list<SimCode.SimEqSystem> i_eqs;

    case ( txt,
           {},
           _,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           SimCode.JAC_COLUMN(columnEqns = i_eqs) :: rest,
           a_filename,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = algloopMainfile1(txt, i_eqs, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, Tpl.textString(a_filename));
        txt = Tpl.nextIter(txt);
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1301(txt, rest, a_filename, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _ :: rest,
           a_filename,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1301(txt, rest, a_filename, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_1301;

protected function lm_1302
  input Tpl.Text in_txt;
  input list<SimCode.JacobianMatrix> in_items;
  input Tpl.Text in_a_filename;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_filename, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCode.JacobianMatrix> rest;
      Tpl.Text a_filename;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      list<SimCode.JacobianColumn> i_mat;

    case ( txt,
           {},
           _,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           SimCode.JAC_MATRIX(columns = i_mat) :: rest,
           a_filename,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING("")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1301(txt, i_mat, a_filename, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.nextIter(txt);
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1302(txt, rest, a_filename, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _ :: rest,
           a_filename,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1302(txt, rest, a_filename, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_1302;

protected function lm_1303
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input Tpl.Text in_a_filename;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_filename, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      Tpl.Text a_filename;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      SimCode.SimEqSystem i_eqs;

    case ( txt,
           {},
           _,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           i_eqs :: rest,
           a_filename,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = algloopMainfile2(txt, i_eqs, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, Tpl.textString(a_filename));
        txt = Tpl.nextIter(txt);
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1303(txt, rest, a_filename, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_1303;

public function algloopMainfile
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace) :=
  match(in_txt, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_context)
    local
      Tpl.Text txt;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      SimCodeFunction.Context a_context;
      list<SimCode.ClockedPartition> i_clockedPartitions;
      list<SimCode.SimEqSystem> i_initialEquations;
      list<SimCode.SimEqSystem> i_allEquations;
      SimCode.SimCode i_simCode;
      list<SimCode.JacobianMatrix> i_jacobianMatrixes;
      String i_fileNamePrefix;
      Absyn.Path i_modelInfo_name;
      list<SimCode.SimEqSystem> ret_8;
      list<SimCode.SimEqSystem> ret_7;
      list<SimCode.SubPartition> ret_6;
      list<SimCode.SimEqSystem> ret_5;
      Tpl.Text l_algloopfiles;
      Tpl.Text l_jacfiles;
      Tpl.Text l_modelfilename;
      Tpl.Text l_filename;
      Tpl.Text l_modelname;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = i_modelInfo_name), fileNamePrefix = i_fileNamePrefix, jacobianMatrixes = i_jacobianMatrixes, allEquations = i_allEquations, initialEquations = i_initialEquations, clockedPartitions = i_clockedPartitions)),
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_context )
      equation
        l_modelname = lastIdentOfPath(Tpl.emptyTxt, i_modelInfo_name);
        l_filename = Tpl.writeStr(Tpl.emptyTxt, i_fileNamePrefix);
        l_modelfilename = fun_1300(Tpl.emptyTxt, a_context, l_filename);
        l_jacfiles = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING("")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_jacfiles, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1302(l_jacfiles, i_jacobianMatrixes, l_filename, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, i_simCode);
        l_jacfiles = Tpl.popIter(l_jacfiles);
        ret_5 = listAppend(i_allEquations, i_initialEquations);
        ret_6 = SimCodeUtil.getSubPartitions(i_clockedPartitions);
        ret_7 = SimCodeUtil.getClockedEquations(ret_6);
        ret_8 = listAppend(ret_5, ret_7);
        l_algloopfiles = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_algloopfiles, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1303(l_algloopfiles, ret_8, l_filename, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, i_simCode);
        l_algloopfiles = Tpl.popIter(l_algloopfiles);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "/*****************************************************************************\n",
                                    "*\n",
                                    "* Helper file that includes all alg-loop files.\n",
                                    "* This file is generated by the OpenModelica Compiler and produced to speed-up the compile time.\n",
                                    "*\n",
                                    "*****************************************************************************/\n",
                                    "#include <Core/System/LinearAlgLoopDefaultImplementation.h>\n",
                                    "#include <Core/System/NonLinearAlgLoopDefaultImplementation.h>\n",
                                    "//jac files\n"
                                }, true));
        txt = Tpl.writeText(txt, l_jacfiles);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("//alg loop files\n"));
        txt = Tpl.writeText(txt, l_algloopfiles);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);

    case ( txt,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           _ )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
  end match;
end algloopMainfile;

protected function lm_1305
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input String in_a_filename;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_filename, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      String a_filename;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      SimCode.SimEqSystem i_eqs;

    case ( txt,
           {},
           _,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           i_eqs :: rest,
           a_filename,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = algloopMainfile2(txt, i_eqs, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_filename);
        txt = Tpl.nextIter(txt);
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1305(txt, rest, a_filename, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_1305;

public function algloopMainfile1
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_allEquations;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input String a_filename;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
protected
  Tpl.Text l_algloopfiles;
algorithm
  l_algloopfiles := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (l_algloopfiles, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) := lm_1305(l_algloopfiles, a_allEquations, a_filename, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
  l_algloopfiles := Tpl.popIter(l_algloopfiles);
  out_txt := Tpl.writeText(txt, l_algloopfiles);
end algloopMainfile1;

protected function fun_1307
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input String in_a_filename;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_eq, in_a_filename)
    local
      Tpl.Text txt;
      String a_filename;
      Integer i_nls_index;
      Integer i_ls_index;
      Tpl.Text l_num;

    case ( txt,
           SimCode.SES_LINEAR(lSystem = SimCode.LINEARSYSTEM(index = i_ls_index)),
           a_filename )
      equation
        l_num = Tpl.writeStr(Tpl.emptyTxt, intString(i_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#include \"OMCpp"));
        txt = Tpl.writeStr(txt, a_filename);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeStr(txt, intString(i_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ".h\"\n",
                                    "#include \"OMCpp"
                                }, false));
        txt = Tpl.writeStr(txt, a_filename);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeStr(txt, intString(i_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".cpp\""));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           SimCode.SES_NONLINEAR(nlSystem = SimCode.NONLINEARSYSTEM(index = i_nls_index)),
           a_filename )
      equation
        l_num = Tpl.writeStr(Tpl.emptyTxt, intString(i_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#include \"OMCpp"));
        txt = Tpl.writeStr(txt, a_filename);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeStr(txt, intString(i_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ".h\"\n",
                                    "#include \"OMCpp"
                                }, false));
        txt = Tpl.writeStr(txt, a_filename);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeStr(txt, intString(i_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".cpp\""));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_1307;

public function algloopMainfile2
  input Tpl.Text txt;
  input SimCode.SimEqSystem a_eq;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input String a_filename;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  out_txt := fun_1307(txt, a_eq, a_filename);
  out_a_extraFuncs := a_extraFuncs;
  out_a_extraFuncsDecl := a_extraFuncsDecl;
  out_a_extraFuncsNamespace := a_extraFuncsNamespace;
end algloopMainfile2;

public function algloopfilesindex
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_eq)
    local
      Tpl.Text txt;
      Integer i_index;
      Integer i_nls_index;
      Integer i_ls_index;

    case ( txt,
           SimCode.SES_LINEAR(lSystem = SimCode.LINEARSYSTEM(index = i_ls_index)) )
      equation
        txt = Tpl.writeStr(txt, intString(i_ls_index));
      then txt;

    case ( txt,
           SimCode.SES_NONLINEAR(nlSystem = SimCode.NONLINEARSYSTEM(index = i_nls_index)) )
      equation
        txt = Tpl.writeStr(txt, intString(i_nls_index));
      then txt;

    case ( txt,
           SimCode.SES_MIXED(index = i_index) )
      equation
        txt = Tpl.writeStr(txt, intString(i_index));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
      then txt;
  end match;
end algloopfilesindex;

protected function smf_1310
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_it;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) :=
  match(in_txt, in_it, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           i_eq,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls )
      equation
        (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = algloopcppfilenames2(txt, i_eq, SimCodeFunction.contextOther, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);
  end match;
end smf_1310;

protected function lm_1311
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) :=
  match(in_txt, in_items, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      SimCode.SimEqSystem i_eqs;

    case ( txt,
           {},
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           i_eqs :: rest,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls )
      equation
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = smf_1310(txt, i_eqs, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls);
        txt = Tpl.nextIter(txt);
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = lm_1311(txt, rest, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);
  end match;
end lm_1311;

public function algloopcppfilenames
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_allEquations;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
protected
  Tpl.Text l_algloopsolver;
  Tpl.Text l_varDecls;
algorithm
  l_varDecls := Tpl.emptyTxt;
  l_algloopsolver := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING("\t")), 10, 0, Tpl.ST_STRING_LIST({
                                                                                                                  "\\\n",
                                                                                                                  "\t"
                                                                                                              }, false), 0, Tpl.ST_NEW_LINE()));
  (l_algloopsolver, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, l_varDecls) := lm_1311(l_algloopsolver, a_allEquations, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, l_varDecls);
  l_algloopsolver := Tpl.popIter(l_algloopsolver);
  out_txt := Tpl.writeText(txt, l_algloopsolver);
end algloopcppfilenames;

protected function fun_1313
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_num;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode, in_a_num)
    local
      Tpl.Text txt;
      Tpl.Text a_num;
      String i_fileNamePrefix;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = _), fileNamePrefix = i_fileNamePrefix),
           a_num )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("OMCpp"));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeText(txt, a_num);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".cpp"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_1313;

protected function fun_1314
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_num;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode, in_a_num)
    local
      Tpl.Text txt;
      Tpl.Text a_num;
      String i_fileNamePrefix;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = _), fileNamePrefix = i_fileNamePrefix),
           a_num )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("OMCpp"));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Algloop"));
        txt = Tpl.writeText(txt, a_num);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".cpp"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_1314;

public function algloopcppfilenames2
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  (out_txt, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace) :=
  match(in_txt, in_a_eq, in_a_context, in_a_varDecls, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_varDecls;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      SimCode.SimEqSystem i_eq__sys;
      Integer i_nls_index;
      Integer i_ls_index;
      Tpl.Text l_num;

    case ( txt,
           SimCode.SES_LINEAR(lSystem = SimCode.LINEARSYSTEM(index = i_ls_index)),
           _,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace )
      equation
        l_num = Tpl.writeStr(Tpl.emptyTxt, intString(i_ls_index));
        txt = fun_1313(txt, a_simCode, l_num);
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);

    case ( txt,
           SimCode.SES_NONLINEAR(nlSystem = SimCode.NONLINEARSYSTEM(index = i_nls_index)),
           _,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace )
      equation
        l_num = Tpl.writeStr(Tpl.emptyTxt, intString(i_nls_index));
        txt = fun_1314(txt, a_simCode, l_num);
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);

    case ( txt,
           SimCode.SES_MIXED(cont = i_eq__sys),
           a_context,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace )
      equation
        (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = algloopcppfilenames2(txt, i_eq__sys, a_context, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);

    case ( txt,
           _,
           _,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace )
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
  end match;
end algloopcppfilenames2;

protected function fun_1316
  input Tpl.Text in_txt;
  input Boolean in_a_isStartFixed;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_isStartFixed)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_clockStart[clockIndex - 1] || "));
      then txt;
  end match;
end fun_1316;

protected function fun_1317
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;
      Boolean i_isStartFixed;

    case ( txt,
           SimCodeVar.SIMVAR(varKind = BackendDAE.CLOCKED_STATE(isStartFixed = i_isStartFixed)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if ("));
        txt = fun_1316(txt, i_isStartFixed);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_clockSubactive[clockIndex - 1]) return;"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_1317;

protected function fun_1318
  input Tpl.Text in_txt;
  input Boolean in_a_assignToStartValues;
  input Tpl.Text in_a_startFixedExp;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_assignToStartValues, in_a_startFixedExp)
    local
      Tpl.Text txt;
      Tpl.Text a_startFixedExp;

    case ( txt,
           false,
           a_startFixedExp )
      equation
        txt = Tpl.writeText(txt, a_startFixedExp);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_1318;

protected function fun_1319
  input Tpl.Text in_txt;
  input Boolean in_a_assignToStartValues;
  input Tpl.Text in_a_startFixedExp;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_assignToStartValues, in_a_startFixedExp)
    local
      Tpl.Text txt;
      Tpl.Text a_startFixedExp;

    case ( txt,
           false,
           a_startFixedExp )
      equation
        txt = Tpl.writeText(txt, a_startFixedExp);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_1319;

protected function fun_1320
  input Tpl.Text in_txt;
  input Boolean in_a_assignToStartValues;
  input Tpl.Text in_a_startFixedExp;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_assignToStartValues, in_a_startFixedExp)
    local
      Tpl.Text txt;
      Tpl.Text a_startFixedExp;

    case ( txt,
           false,
           a_startFixedExp )
      equation
        txt = Tpl.writeText(txt, a_startFixedExp);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_1320;

protected function fun_1321
  input Tpl.Text in_txt;
  input String in_mArg;
  input DAE.Exp in_a_eqn_exp;
  input DAE.Exp in_a_lhs;
  input Tpl.Text in_a_expPart;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_startFixedExp;
  input Boolean in_a_assignToStartValues;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_varDeclsCref;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input DAE.ComponentRef in_a_lhs_componentRef;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_varDeclsCref;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_varDeclsCref, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_mArg, in_a_eqn_exp, in_a_lhs, in_a_expPart, in_a_preExp, in_a_startFixedExp, in_a_assignToStartValues, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_varDeclsCref, in_a_context, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_lhs_componentRef)
    local
      Tpl.Text txt;
      DAE.Exp a_eqn_exp;
      DAE.Exp a_lhs;
      Tpl.Text a_expPart;
      Tpl.Text a_preExp;
      Tpl.Text a_startFixedExp;
      Boolean a_assignToStartValues;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_varDeclsCref;
      SimCodeFunction.Context a_context;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      DAE.ComponentRef a_lhs_componentRef;
      Tpl.Text txt_1;
      Tpl.Text l_lhsStr;

    case ( txt,
           "bool",
           _,
           _,
           a_expPart,
           a_preExp,
           a_startFixedExp,
           a_assignToStartValues,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_varDeclsCref,
           a_context,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_lhs_componentRef )
      equation
        (l_lhsStr, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_varDeclsCref, a_stateDerVectorName) = CodegenCppCommonOld.cref1(Tpl.emptyTxt, a_lhs_componentRef, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_context, a_varDeclsCref, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = fun_1318(txt, a_assignToStartValues, a_startFixedExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, a_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_lhsStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".assign("));
        txt = Tpl.writeText(txt, a_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then (txt, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           "int",
           _,
           _,
           a_expPart,
           a_preExp,
           a_startFixedExp,
           a_assignToStartValues,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_varDeclsCref,
           a_context,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_lhs_componentRef )
      equation
        (l_lhsStr, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_varDeclsCref, a_stateDerVectorName) = CodegenCppCommonOld.cref1(Tpl.emptyTxt, a_lhs_componentRef, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_context, a_varDeclsCref, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = fun_1319(txt, a_assignToStartValues, a_startFixedExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, a_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_lhsStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".assign("));
        txt = Tpl.writeText(txt, a_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then (txt, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           "double",
           _,
           a_lhs,
           a_expPart,
           a_preExp,
           a_startFixedExp,
           a_assignToStartValues,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_varDeclsCref,
           a_context,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           _ )
      equation
        txt = fun_1320(txt, a_assignToStartValues, a_startFixedExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, a_preExp);
        txt = Tpl.softNewLine(txt);
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = assignDerArray(txt, a_context, Tpl.textString(a_expPart), a_lhs, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           a_eqn_exp,
           _,
           _,
           _,
           _,
           _,
           _,
           a_stateDerVectorName,
           a_varDeclsCref,
           _,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      equation
        txt_1 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("Unsupported type of array call assign: "));
        txt_1 = CodegenCppCommonOld.expTypeFromExpShort(txt_1, a_eqn_exp);
        txt = CodegenCppCommonOld.error(txt, Tpl.sourceInfo("CodegenCppOld.tpl", 10995, 11), Tpl.textString(txt_1));
      then (txt, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_1321;

protected function fun_1322
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input Boolean in_a_assignToStartValues;
  input Tpl.Text in_a_varDeclsCref;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_varDecls;
  input SimCodeFunction.Context in_a_context;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDeclsCref;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_varDeclsCref, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) :=
  match(in_txt, in_a_eq, in_a_assignToStartValues, in_a_varDeclsCref, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_varDecls, in_a_context, in_a_simCode)
    local
      Tpl.Text txt;
      Boolean a_assignToStartValues;
      Tpl.Text a_varDeclsCref;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_varDecls;
      SimCodeFunction.Context a_context;
      SimCode.SimCode a_simCode;
      DAE.Exp i_lhs;
      DAE.Exp i_eqn_exp;
      DAE.Exp i_exp;
      DAE.ComponentRef i_lhs_componentRef;
      String str_5;
      Tpl.Text txt_4;
      Tpl.Text l_expPart;
      Tpl.Text l_preExp;
      SimCodeVar.SimVar ret_1;
      Tpl.Text l_startFixedExp;

    case ( txt,
           SimCode.SES_ARRAY_CALL_ASSIGN(lhs = (i_lhs as DAE.CREF(componentRef = i_lhs_componentRef)), exp = (i_eqn_exp as i_exp)),
           a_assignToStartValues,
           a_varDeclsCref,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_varDecls,
           a_context,
           a_simCode )
      equation
        ret_1 = SimCodeUtil.cref2simvar(i_lhs_componentRef, a_simCode);
        l_startFixedExp = fun_1317(Tpl.emptyTxt, ret_1);
        l_preExp = Tpl.emptyTxt;
        (l_expPart, l_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.daeExp(Tpl.emptyTxt, i_exp, a_context, l_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt_4 = CodegenCppCommonOld.expTypeFromExpShort(Tpl.emptyTxt, i_eqn_exp);
        str_5 = Tpl.textString(txt_4);
        (txt, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_1321(txt, str_5, i_eqn_exp, i_lhs, l_expPart, l_preExp, l_startFixedExp, a_assignToStartValues, a_useFlatArrayNotation, a_stateDerVectorName, a_varDeclsCref, a_context, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, i_lhs_componentRef);
      then (txt, a_varDeclsCref, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           _,
           _,
           a_varDeclsCref,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_varDecls,
           _,
           _ )
      then (txt, a_varDeclsCref, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);
  end match;
end fun_1322;

public function equationArrayCallAssign
  input Tpl.Text txt;
  input SimCode.SimEqSystem a_eq;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_varDecls;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;
  input Boolean a_assignToStartValues;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
protected
  Tpl.Text l_varDeclsCref;
algorithm
  l_varDeclsCref := Tpl.emptyTxt;
  (out_txt, l_varDeclsCref, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) := fun_1322(txt, a_eq, a_assignToStartValues, l_varDeclsCref, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_context, a_simCode);
end equationArrayCallAssign;

protected function fun_1324
  input Tpl.Text in_txt;
  input BackendDAE.VarKind in_a_varKind;
  input DAE.Type in_a_ty;
  input String in_a_arr;
  input Tpl.Text in_a_lhsStr;
  input Boolean in_a_useFlatArrayNotation;
  input DAE.ComponentRef in_a_c;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_varKind, in_a_ty, in_a_arr, in_a_lhsStr, in_a_useFlatArrayNotation, in_a_c)
    local
      Tpl.Text txt;
      DAE.Type a_ty;
      String a_arr;
      Tpl.Text a_lhsStr;
      Boolean a_useFlatArrayNotation;
      DAE.ComponentRef a_c;

    case ( txt,
           BackendDAE.STATE(index = _),
           _,
           a_arr,
           a_lhsStr,
           a_useFlatArrayNotation,
           a_c )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/*assign to "));
        txt = CodegenCppCommonOld.cref(txt, a_c, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "*/\n",
                                    "memcpy(&"
                                }, false));
        txt = Tpl.writeText(txt, a_lhsStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeStr(txt, a_arr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".getData(), "));
        txt = Tpl.writeStr(txt, a_arr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".getNumElems()*sizeof(double));"));
      then txt;

    case ( txt,
           BackendDAE.STATE_DER(),
           _,
           a_arr,
           a_lhsStr,
           a_useFlatArrayNotation,
           a_c )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/*assign to "));
        txt = CodegenCppCommonOld.cref(txt, a_c, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "*/\n",
                                    "memcpy(&"
                                }, false));
        txt = Tpl.writeText(txt, a_lhsStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeStr(txt, a_arr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".getData(), "));
        txt = Tpl.writeStr(txt, a_arr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".getNumElems()*sizeof(double));"));
      then txt;

    case ( txt,
           BackendDAE.JAC_VAR(),
           a_ty,
           a_arr,
           a_lhsStr,
           _,
           _ )
      equation
        txt = CodegenCppCommonOld.assignJacArray(txt, Tpl.textString(a_lhsStr), a_arr, a_ty);
      then txt;

    case ( txt,
           BackendDAE.JAC_DIFF_VAR(),
           a_ty,
           a_arr,
           a_lhsStr,
           _,
           _ )
      equation
        txt = CodegenCppCommonOld.assignJacArray(txt, Tpl.textString(a_lhsStr), a_arr, a_ty);
      then txt;

    case ( txt,
           BackendDAE.SEED_VAR(),
           a_ty,
           a_arr,
           a_lhsStr,
           _,
           _ )
      equation
        txt = CodegenCppCommonOld.assignJacArray(txt, Tpl.textString(a_lhsStr), a_arr, a_ty);
      then txt;

    case ( txt,
           _,
           _,
           a_arr,
           a_lhsStr,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/*default array assign*/\n"));
        txt = Tpl.writeText(txt, a_lhsStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".assign("));
        txt = Tpl.writeStr(txt, a_arr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;
  end match;
end fun_1324;

protected function fun_1325
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_mArg;
  input DAE.Type in_a_ty;
  input String in_a_arr;
  input Tpl.Text in_a_lhsStr;
  input Boolean in_a_useFlatArrayNotation;
  input DAE.ComponentRef in_a_c;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_ty, in_a_arr, in_a_lhsStr, in_a_useFlatArrayNotation, in_a_c)
    local
      Tpl.Text txt;
      DAE.Type a_ty;
      String a_arr;
      Tpl.Text a_lhsStr;
      Boolean a_useFlatArrayNotation;
      DAE.ComponentRef a_c;
      BackendDAE.VarKind i_varKind;

    case ( txt,
           SimCodeVar.SIMVAR(varKind = i_varKind),
           a_ty,
           a_arr,
           a_lhsStr,
           a_useFlatArrayNotation,
           a_c )
      equation
        txt = fun_1324(txt, i_varKind, a_ty, a_arr, a_lhsStr, a_useFlatArrayNotation, a_c);
      then txt;

    case ( txt,
           _,
           _,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_1325;

protected function fun_1326
  input Tpl.Text in_txt;
  input DAE.Exp in_a_lhs__ecr;
  input SimCodeFunction.Context in_a_context;
  input String in_a_arr;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_lhs__ecr, in_a_context, in_a_arr, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      String a_arr;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      DAE.Type i_ty;
      DAE.ComponentRef i_c;
      SimCodeVar.SimVar ret_2;
      Tpl.Text l_lhsStr;
      Tpl.Text l_varDeclsCref;

    case ( txt,
           DAE.CREF(componentRef = i_c, ty = i_ty),
           a_context,
           a_arr,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_varDeclsCref = Tpl.emptyTxt;
        (l_lhsStr, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, l_varDeclsCref, a_stateDerVectorName) = CodegenCppCommonOld.cref1(Tpl.emptyTxt, i_c, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_context, l_varDeclsCref, a_stateDerVectorName, a_useFlatArrayNotation);
        ret_2 = SimCodeUtil.cref2simvar(i_c, a_simCode);
        txt = fun_1325(txt, ret_2, i_ty, a_arr, l_lhsStr, a_useFlatArrayNotation, i_c);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           _,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end fun_1326;

public function assignDerArray
  input Tpl.Text txt;
  input SimCodeFunction.Context a_context;
  input String a_arr;
  input DAE.Exp a_lhs__ecr;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) := fun_1326(txt, a_lhs__ecr, a_context, a_arr, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
end assignDerArray;

protected function fun_1328
  input Tpl.Text in_txt;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_context)
    local
      Tpl.Text txt;

    case ( txt,
           SimCodeFunction.ALGLOOP_CONTEXT(genInitialisation = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_system->"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_1328;

protected function lm_1329
  input Tpl.Text in_txt;
  input list<DAE.ComponentRef> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_varDeclsCref;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_varDeclsCref;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_varDeclsCref, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_varDeclsCref, in_a_context, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      list<DAE.ComponentRef> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_varDeclsCref;
      SimCodeFunction.Context a_context;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      DAE.ComponentRef i_e;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_varDeclsCref,
           _,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           i_e :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_varDeclsCref,
           a_context,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("|| ("));
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_varDeclsCref, a_stateDerVectorName) = CodegenCppCommonOld.cref1(txt, i_e, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_context, a_varDeclsCref, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" && !_discrete_events->pre("));
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_varDeclsCref, a_stateDerVectorName) = CodegenCppCommonOld.cref1(txt, i_e, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_context, a_varDeclsCref, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("))"));
        txt = Tpl.popBlock(txt);
        (txt, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1329(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_varDeclsCref, a_context, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_1329;

protected function lm_1330
  input Tpl.Text in_txt;
  input list<DAE.ComponentRef> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_varDeclsCref;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_varDeclsCref;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_varDeclsCref, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_varDeclsCref, in_a_context, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      list<DAE.ComponentRef> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_varDeclsCref;
      SimCodeFunction.Context a_context;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      DAE.ComponentRef i_e;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_varDeclsCref,
           _,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           i_e :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_varDeclsCref,
           a_context,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("|| ("));
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_varDeclsCref, a_stateDerVectorName) = CodegenCppCommonOld.cref1(txt, i_e, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_context, a_varDeclsCref, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" && !_discrete_events->pre("));
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_varDeclsCref, a_stateDerVectorName) = CodegenCppCommonOld.cref1(txt, i_e, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_context, a_varDeclsCref, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("))"));
        txt = Tpl.popBlock(txt);
        (txt, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1330(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_varDeclsCref, a_context, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_1330;

protected function fun_1331
  input Tpl.Text in_txt;
  input Boolean in_a_initialCall;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input SimCodeFunction.Context in_a_context;
  input list<BackendDAE.WhenOperator> in_a_whenStmtLst;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) :=
  match(in_txt, in_a_initialCall, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_context, in_a_whenStmtLst)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      SimCodeFunction.Context a_context;
      list<BackendDAE.WhenOperator> a_whenStmtLst;

    case ( txt,
           false,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_context,
           a_whenStmtLst )
      equation
        (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = preCall(txt, a_whenStmtLst, a_context, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           _,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_context,
           a_whenStmtLst )
      equation
        (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = whenOperators(txt, a_whenStmtLst, a_context, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);
  end match;
end fun_1331;

protected function fun_1332
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input Tpl.Text in_a_sysderef;
  input Tpl.Text in_a_varDecls;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_varDeclsCref;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_varDeclsCref;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_varDecls, out_a_stateDerVectorName, out_a_varDeclsCref, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_a_eq, in_a_sysderef, in_a_varDecls, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_varDeclsCref, in_a_context, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      Tpl.Text a_sysderef;
      Tpl.Text a_varDecls;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_varDeclsCref;
      SimCodeFunction.Context a_context;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      SimCode.SimEqSystem i_elseWhenEq;
      Boolean i_initialCall;
      list<BackendDAE.WhenOperator> i_whenStmtLst;
      list<DAE.ComponentRef> i_conditions;
      Tpl.Text l_elseWhen;
      Tpl.Text l_initial__assign;
      Tpl.Text l_pre__call;
      Tpl.Text l_body;
      Tpl.Text l_helpIf;

    case ( txt,
           SimCode.SES_WHEN(whenStmtLst = i_whenStmtLst, conditions = i_conditions, elseWhen = NONE()),
           a_sysderef,
           a_varDecls,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_varDeclsCref,
           a_context,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (l_helpIf, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1329(Tpl.emptyTxt, i_conditions, a_useFlatArrayNotation, a_stateDerVectorName, a_varDeclsCref, a_context, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
        (l_body, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = whenOperators(Tpl.emptyTxt, i_whenStmtLst, a_context, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        (l_pre__call, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = preCall(Tpl.emptyTxt, i_whenStmtLst, a_context, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if ("));
        txt = Tpl.writeText(txt, a_sysderef);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_initial)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_pre__call);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "else if (0"
                                }, false));
        txt = Tpl.writeText(txt, l_helpIf);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ")\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_body);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "else\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_pre__call);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then (txt, a_varDecls, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           SimCode.SES_WHEN(whenStmtLst = i_whenStmtLst, conditions = i_conditions, elseWhen = SOME(i_elseWhenEq), initialCall = i_initialCall),
           a_sysderef,
           a_varDecls,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_varDeclsCref,
           a_context,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (l_helpIf, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1330(Tpl.emptyTxt, i_conditions, a_useFlatArrayNotation, a_stateDerVectorName, a_varDeclsCref, a_context, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
        (l_initial__assign, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = fun_1331(Tpl.emptyTxt, i_initialCall, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_context, i_whenStmtLst);
        (l_body, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = whenOperators(Tpl.emptyTxt, i_whenStmtLst, a_context, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        (l_elseWhen, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = equationElseWhen(Tpl.emptyTxt, i_elseWhenEq, a_context, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        (l_pre__call, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = preCall(Tpl.emptyTxt, i_whenStmtLst, a_context, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if ("));
        txt = Tpl.writeText(txt, a_sysderef);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_initial)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_initial__assign);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "else if(0"
                                }, false));
        txt = Tpl.writeText(txt, l_helpIf);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ")\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_body);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("}\n"));
        txt = Tpl.writeText(txt, l_elseWhen);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "else\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeText(txt, l_pre__call);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then (txt, a_varDecls, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           _,
           a_varDecls,
           _,
           a_stateDerVectorName,
           a_varDeclsCref,
           _,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_varDecls, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_1332;

public function equationWhen
  input Tpl.Text txt;
  input SimCode.SimEqSystem a_eq;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_varDecls;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
protected
  Tpl.Text l_sysderef;
  Tpl.Text l_varDeclsCref;
algorithm
  l_varDeclsCref := Tpl.emptyTxt;
  l_sysderef := fun_1328(Tpl.emptyTxt, a_context);
  (out_txt, out_a_varDecls, out_a_stateDerVectorName, l_varDeclsCref, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) := fun_1332(txt, a_eq, l_sysderef, a_varDecls, a_useFlatArrayNotation, a_stateDerVectorName, l_varDeclsCref, a_context, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
end equationWhen;

protected function fun_1334
  input Tpl.Text in_txt;
  input BackendDAE.WhenOperator in_a_whenOp;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) :=
  match(in_txt, in_a_whenOp, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_context)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      SimCodeFunction.Context a_context;
      DAE.Exp i_right;
      DAE.Exp i_left;

    case ( txt,
           BackendDAE.ASSIGN(left = i_left, right = i_right),
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_context )
      equation
        (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = preCallExp(txt, i_left, i_right, a_context, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("; // nothing to do"));
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);
  end match;
end fun_1334;

protected function lm_1335
  input Tpl.Text in_txt;
  input list<BackendDAE.WhenOperator> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_context)
    local
      Tpl.Text txt;
      list<BackendDAE.WhenOperator> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      SimCodeFunction.Context a_context;
      BackendDAE.WhenOperator i_whenOp;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           i_whenOp :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_context )
      equation
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = fun_1334(txt, i_whenOp, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_context);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = lm_1335(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_context);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);
  end match;
end lm_1335;

public function preCall
  input Tpl.Text txt;
  input list<BackendDAE.WhenOperator> a_whenOps;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_varDecls;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
protected
  Tpl.Text l_body;
algorithm
  l_body := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (l_body, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) := lm_1335(l_body, a_whenOps, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_context);
  l_body := Tpl.popIter(l_body);
  out_txt := Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeText(out_txt, l_body);
  out_txt := Tpl.popBlock(out_txt);
end preCall;

protected function lm_1337
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input SimCodeFunction.Context in_a_context;
  input DAE.Exp in_a_right;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_context, in_a_right)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      SimCodeFunction.Context a_context;
      DAE.Exp a_right;
      DAE.Exp i_e;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           i_e :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_context,
           a_right )
      equation
        (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = preCallExp(txt, i_e, a_right, a_context, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = lm_1337(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_context, a_right);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);
  end match;
end lm_1337;

protected function lm_1338
  input Tpl.Text in_txt;
  input list<String> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<String> rest;
      Integer x_i1;
      String i_num;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_num :: rest )
      equation
        x_i1 = Tpl.getIteri_i0(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("for (int i"));
        txt = Tpl.writeStr(txt, intString(x_i1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = 1; i"));
        txt = Tpl.writeStr(txt, intString(x_i1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" <= "));
        txt = Tpl.writeStr(txt, i_num);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("; i"));
        txt = Tpl.writeStr(txt, intString(x_i1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("++)"));
        txt = Tpl.nextIter(txt);
        txt = lm_1338(txt, rest);
      then txt;
  end match;
end lm_1338;

protected function lm_1339
  input Tpl.Text in_txt;
  input list<String> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<String> rest;
      Integer x_i1;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           _ :: rest )
      equation
        x_i1 = Tpl.getIteri_i0(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("i"));
        txt = Tpl.writeStr(txt, intString(x_i1));
        txt = Tpl.nextIter(txt);
        txt = lm_1339(txt, rest);
      then txt;
  end match;
end lm_1339;

protected function fun_1340
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_mArg;
  input Tpl.Text in_a_var;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_var)
    local
      Tpl.Text txt;
      Tpl.Text a_var;
      list<String> i_nums;
      Tpl.Text l_indices;
      Tpl.Text l_forLoops;

    case ( txt,
           SimCodeVar.SIMVAR(arrayCref = NONE()),
           a_var )
      equation
        txt = Tpl.writeText(txt, a_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = _discrete_events->pre("));
        txt = Tpl.writeText(txt, a_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(numArrayElement = i_nums),
           a_var )
      equation
        l_forLoops = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(1, NONE(), SOME(Tpl.ST_STRING(" ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_forLoops = lm_1338(l_forLoops, i_nums);
        l_forLoops = Tpl.popIter(l_forLoops);
        l_indices = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(1, NONE(), SOME(Tpl.ST_STRING(",")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_indices = lm_1339(l_indices, i_nums);
        l_indices = Tpl.popIter(l_indices);
        txt = Tpl.writeText(txt, l_forLoops);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, l_indices);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") = _discrete_events->pre("));
        txt = Tpl.writeText(txt, a_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, l_indices);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("));"));
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_1340;

protected function fun_1341
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_var;
  input SimCode.SimCode in_a_simCode;
  input DAE.ComponentRef in_a_cr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_var, in_a_simCode, in_a_cr)
    local
      Tpl.Text txt;
      Tpl.Text a_var;
      SimCode.SimCode a_simCode;
      DAE.ComponentRef a_cr;
      SimCodeVar.SimVar ret_0;

    case ( txt,
           false,
           a_var,
           a_simCode,
           a_cr )
      equation
        ret_0 = SimCodeUtil.cref2simvar(a_cr, a_simCode);
        txt = fun_1340(txt, ret_0, a_var);
      then txt;

    case ( txt,
           _,
           a_var,
           _,
           _ )
      equation
        txt = Tpl.writeText(txt, a_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = _discrete_events->pre("));
        txt = Tpl.writeText(txt, a_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;
  end match;
end fun_1341;

public function preCallExp
  input Tpl.Text in_txt;
  input DAE.Exp in_a_left;
  input DAE.Exp in_a_right;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_left, in_a_right, in_a_context, in_a_varDecls, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      DAE.Exp a_right;
      SimCodeFunction.Context a_context;
      Tpl.Text a_varDecls;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      DAE.Exp i_left;
      DAE.ComponentRef i_cr;
      list<DAE.Exp> i_eLst;
      Boolean ret_3;
      Integer ret_2;
      Integer ret_1;
      Tpl.Text l_var;

    case ( txt,
           DAE.TUPLE(PR = i_eLst),
           a_right,
           a_context,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = lm_1337(txt, i_eLst, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_context, a_right);
        txt = Tpl.popIter(txt);
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.CREF(componentRef = i_cr),
           _,
           a_context,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (l_var, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_varDecls, a_stateDerVectorName) = CodegenCppCommonOld.cref1(Tpl.emptyTxt, i_cr, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_context, a_varDecls, a_stateDerVectorName, a_useFlatArrayNotation);
        ret_1 = stringLength(Tpl.textString(l_var));
        ret_2 = stringGet(Tpl.textString(l_var), ret_1);
        ret_3 = intEq(ret_2, 41);
        txt = fun_1341(txt, ret_3, l_var, a_simCode, i_cr);
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           i_left,
           _,
           _,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#error unknown preCallExp "));
        txt = ExpressionDumpTpl.dumpExp(txt, i_left, "\"");
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end preCallExp;

protected function lm_1343
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      DAE.Exp i_e;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_e :: rest )
      equation
        txt = ExpressionDumpTpl.dumpExp(txt, i_e, "\"");
        txt = Tpl.nextIter(txt);
        txt = lm_1343(txt, rest);
      then txt;
  end match;
end lm_1343;

protected function lm_1344
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_retStruct;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_preExp, in_a_context, in_a_retStruct)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      Tpl.Text a_retStruct;
      Integer x_i1;
      DAE.Exp i_cr;
      Tpl.Text l_rhsStr;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           a_preExp,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);

    case ( txt,
           i_cr :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp,
           a_context,
           a_retStruct )
      equation
        x_i1 = Tpl.getIteri_i0(txt);
        l_rhsStr = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("get<"));
        l_rhsStr = Tpl.writeStr(l_rhsStr, intString(x_i1));
        l_rhsStr = Tpl.writeTok(l_rhsStr, Tpl.ST_STRING(">("));
        l_rhsStr = Tpl.writeText(l_rhsStr, a_retStruct);
        l_rhsStr = Tpl.writeTok(l_rhsStr, Tpl.ST_STRING(".data)"));
        (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.writeLhsCref(txt, i_cr, Tpl.textString(l_rhsStr), a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = lm_1344(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context, a_retStruct);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);
  end match;
end lm_1344;

protected function fun_1345
  input Tpl.Text in_txt;
  input DAE.Exp in_a_left;
  input DAE.Exp in_a_right;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_left, in_a_right, in_a_context, in_a_varDecls, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      DAE.Exp a_right;
      SimCodeFunction.Context a_context;
      Tpl.Text a_varDecls;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      list<DAE.Exp> i_expLst;
      DAE.ComponentRef i_cr;
      Tpl.Text l_lhsCrefs;
      Tpl.Text l_retStruct;
      Tpl.Text l_marker;
      Tpl.Text l_crefs;
      Tpl.Text l_lhs;
      Tpl.Text l_exp;
      Tpl.Text l_preExp;

    case ( txt,
           DAE.CREF(componentRef = i_cr),
           a_right,
           a_context,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_exp, l_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.daeExp(Tpl.emptyTxt, a_right, a_context, l_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        (l_lhs, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_varDecls, a_stateDerVectorName) = CodegenCppCommonOld.cref1(Tpl.emptyTxt, i_cr, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_context, a_varDecls, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_lhs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, l_exp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.TUPLE(PR = i_expLst),
           a_right,
           a_context,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_preExp = Tpl.emptyTxt;
        l_crefs = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_crefs = lm_1343(l_crefs, i_expLst);
        l_crefs = Tpl.popIter(l_crefs);
        l_marker = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("("));
        l_marker = Tpl.writeText(l_marker, l_crefs);
        l_marker = Tpl.writeTok(l_marker, Tpl.ST_STRING(") = "));
        l_marker = ExpressionDumpTpl.dumpExp(l_marker, a_right, "\"");
        (l_retStruct, l_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.daeExp(Tpl.emptyTxt, a_right, a_context, l_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        l_lhsCrefs = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_lhsCrefs, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, l_preExp) = lm_1344(l_lhsCrefs, i_expLst, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, l_preExp, a_context, l_retStruct);
        l_lhsCrefs = Tpl.popIter(l_lhsCrefs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("// whenAssign: preExp "));
        txt = Tpl.writeText(txt, l_marker);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("// whenAssign: writeLhsCref\n"));
        txt = Tpl.writeText(txt, l_lhsCrefs);
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           _,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("dont know whenAssign lhs-type"));
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end fun_1345;

public function whenAssign
  input Tpl.Text txt;
  input DAE.Exp a_left;
  input DAE.Type a_ty;
  input DAE.Exp a_right;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_varDecls;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) := fun_1345(txt, a_left, a_right, a_context, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
end whenAssign;

protected function lm_1347
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_context)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      SimCodeFunction.Context a_context;
      SimCode.SimEqSystem i_eqn;
      Tpl.Text l_eqnStr;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           i_eqn :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_context )
      equation
        (l_eqnStr, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = equation_(Tpl.emptyTxt, i_eqn, a_context, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeText(txt, l_eqnStr);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = lm_1347(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_context);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);
  end match;
end lm_1347;

protected function fun_1348
  input Tpl.Text in_txt;
  input Integer in_a_index0;
  input Tpl.Text in_a_condition;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_index0, in_a_condition)
    local
      Tpl.Text txt;
      Tpl.Text a_condition;

    case ( txt,
           0,
           a_condition )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if("));
        txt = Tpl.writeText(txt, a_condition);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           _,
           a_condition )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("else if("));
        txt = Tpl.writeText(txt, a_condition);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;
  end match;
end fun_1348;

protected function lm_1349
  input Tpl.Text in_txt;
  input list<tuple<DAE.Exp, list<SimCode.SimEqSystem>>> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      list<tuple<DAE.Exp, list<SimCode.SimEqSystem>>> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      Integer x_index0;
      list<SimCode.SimEqSystem> i_eqns;
      DAE.Exp i_e;
      Tpl.Text l_conditionline;
      Tpl.Text l_ifequations;
      Tpl.Text l_condition;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           a_preExp,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);

    case ( txt,
           (i_e, i_eqns) :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        x_index0 = Tpl.getIteri_i0(txt);
        (l_condition, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.daeExp(Tpl.emptyTxt, i_e, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        l_ifequations = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_ifequations, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = lm_1347(l_ifequations, i_eqns, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_context);
        l_ifequations = Tpl.popIter(l_ifequations);
        l_conditionline = fun_1348(Tpl.emptyTxt, x_index0, l_condition);
        txt = Tpl.writeText(txt, l_conditionline);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("{\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_ifequations);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = lm_1349(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);
  end match;
end lm_1349;

protected function lm_1350
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_context)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      SimCodeFunction.Context a_context;
      SimCode.SimEqSystem i_eqn;
      Tpl.Text l_eqnStr;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           i_eqn :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_context )
      equation
        (l_eqnStr, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = equation_(Tpl.emptyTxt, i_eqn, a_context, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeText(txt, l_eqnStr);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = lm_1350(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_context);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);
  end match;
end lm_1350;

public function equationIfEquation
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_eq, in_a_context, in_a_varDecls, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_varDecls;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      list<SimCode.SimEqSystem> i_elsebranch;
      list<tuple<DAE.Exp, list<SimCode.SimEqSystem>>> i_ifbranches;
      Tpl.Text l_elseequations;
      Tpl.Text l_IfEquation;
      Tpl.Text l_preExp;

    case ( txt,
           SimCode.SES_IFEQUATION(ifbranches = i_ifbranches, elsebranch = i_elsebranch),
           a_context,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_preExp = Tpl.emptyTxt;
        l_IfEquation = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_IfEquation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, l_preExp) = lm_1349(l_IfEquation, i_ifbranches, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, l_preExp, a_context);
        l_IfEquation = Tpl.popIter(l_IfEquation);
        l_elseequations = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_elseequations, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = lm_1350(l_elseequations, i_elsebranch, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_context);
        l_elseequations = Tpl.popIter(l_elseequations);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_IfEquation);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "else\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_elseequations);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end equationIfEquation;

protected function lm_1352
  input Tpl.Text in_txt;
  input list<DAE.ComponentRef> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_varDeclsCref;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_varDeclsCref;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_varDeclsCref, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_varDeclsCref, in_a_context, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      list<DAE.ComponentRef> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_varDeclsCref;
      SimCodeFunction.Context a_context;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      DAE.ComponentRef i_e;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_varDeclsCref,
           _,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           i_e :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_varDeclsCref,
           a_context,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("|| ("));
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_varDeclsCref, a_stateDerVectorName) = CodegenCppCommonOld.cref1(txt, i_e, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_context, a_varDeclsCref, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" && !_discrete_events->pre("));
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_varDeclsCref, a_stateDerVectorName) = CodegenCppCommonOld.cref1(txt, i_e, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_context, a_varDeclsCref, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("))"));
        txt = Tpl.popBlock(txt);
        (txt, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1352(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_varDeclsCref, a_context, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_1352;

protected function lm_1353
  input Tpl.Text in_txt;
  input list<DAE.ComponentRef> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_varDeclsCref;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_varDeclsCref;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_varDeclsCref, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_varDeclsCref, in_a_context, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      list<DAE.ComponentRef> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_varDeclsCref;
      SimCodeFunction.Context a_context;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      DAE.ComponentRef i_e;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_varDeclsCref,
           _,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           i_e :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_varDeclsCref,
           a_context,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("|| ("));
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_varDeclsCref, a_stateDerVectorName) = CodegenCppCommonOld.cref1(txt, i_e, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_context, a_varDeclsCref, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" && !_discrete_events->pre("));
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_varDeclsCref, a_stateDerVectorName) = CodegenCppCommonOld.cref1(txt, i_e, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_context, a_varDeclsCref, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("))"));
        txt = Tpl.popBlock(txt);
        (txt, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1353(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_varDeclsCref, a_context, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_1353;

protected function fun_1354
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input Tpl.Text in_a_varDecls;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_varDeclsCref;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_varDeclsCref;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_varDecls, out_a_stateDerVectorName, out_a_varDeclsCref, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_a_eq, in_a_varDecls, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_varDeclsCref, in_a_context, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      Tpl.Text a_varDecls;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_varDeclsCref;
      SimCodeFunction.Context a_context;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      SimCode.SimEqSystem i_elseWhenEq;
      list<BackendDAE.WhenOperator> i_whenStmtLst;
      list<DAE.ComponentRef> i_conditions;
      Tpl.Text l_elseWhen;
      Tpl.Text l_body;
      Tpl.Text l_helpIf;

    case ( txt,
           SimCode.SES_WHEN(whenStmtLst = i_whenStmtLst, conditions = i_conditions, elseWhen = NONE()),
           a_varDecls,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_varDeclsCref,
           a_context,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (l_helpIf, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1352(Tpl.emptyTxt, i_conditions, a_useFlatArrayNotation, a_stateDerVectorName, a_varDeclsCref, a_context, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
        (l_body, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = whenOperators(Tpl.emptyTxt, i_whenStmtLst, a_context, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("else if(0"));
        txt = Tpl.writeText(txt, l_helpIf);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ")\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_body);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then (txt, a_varDecls, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           SimCode.SES_WHEN(whenStmtLst = i_whenStmtLst, conditions = i_conditions, elseWhen = SOME(i_elseWhenEq)),
           a_varDecls,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_varDeclsCref,
           a_context,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (l_helpIf, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1353(Tpl.emptyTxt, i_conditions, a_useFlatArrayNotation, a_stateDerVectorName, a_varDeclsCref, a_context, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
        (l_body, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = whenOperators(Tpl.emptyTxt, i_whenStmtLst, a_context, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        (l_elseWhen, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = equationElseWhen(Tpl.emptyTxt, i_elseWhenEq, a_context, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("else if(0"));
        txt = Tpl.writeText(txt, l_helpIf);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ")\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_body);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("}\n"));
        txt = Tpl.writeText(txt, l_elseWhen);
      then (txt, a_varDecls, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           a_varDecls,
           _,
           a_stateDerVectorName,
           a_varDeclsCref,
           _,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_varDecls, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_1354;

public function equationElseWhen
  input Tpl.Text txt;
  input SimCode.SimEqSystem a_eq;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_varDecls;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
protected
  Tpl.Text l_varDeclsCref;
algorithm
  l_varDeclsCref := Tpl.emptyTxt;
  (out_txt, out_a_varDecls, out_a_stateDerVectorName, l_varDeclsCref, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) := fun_1354(txt, a_eq, a_varDecls, a_useFlatArrayNotation, a_stateDerVectorName, l_varDeclsCref, a_context, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
end equationElseWhen;

protected function fun_1356
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_expPart;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_expPart)
    local
      Tpl.Text txt;
      Tpl.Text a_expPart;

    case ( txt,
           false,
           a_expPart )
      equation
        txt = Tpl.writeText(txt, a_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_1356;

protected function fun_1357
  input Tpl.Text in_txt;
  input BackendDAE.WhenOperator in_a_whenOp;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) :=
  match(in_txt, in_a_whenOp, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_context)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      SimCodeFunction.Context a_context;
      DAE.Exp i_exp;
      SourceInfo i_info;
      DAE.Exp i_level;
      DAE.Exp i_condition;
      DAE.Exp i_message;
      DAE.ComponentRef i_stateVar;
      DAE.Exp i_value;
      DAE.Exp i_right;
      DAE.Exp i_lhs;
      Boolean ret_6;
      Tpl.Text l_expPart;
      Tpl.Text l_msgVar;
      Tpl.Text l_val;
      Tpl.Text l_varDeclsCref;
      Tpl.Text l_preExp;
      DAE.Type ret_0;

    case ( txt,
           BackendDAE.ASSIGN(left = i_lhs, right = i_right),
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_context )
      equation
        ret_0 = Expression.typeof(i_right);
        (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = whenAssign(txt, i_lhs, ret_0, i_right, a_context, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           BackendDAE.REINIT(value = i_value, stateVar = i_stateVar),
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           _ )
      equation
        l_preExp = Tpl.emptyTxt;
        l_varDeclsCref = Tpl.emptyTxt;
        (l_val, l_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.daeExp(Tpl.emptyTxt, i_value, SimCodeFunction.contextSimulationDiscrete, l_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_state_var_reinitialized = true;\n"));
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, l_varDeclsCref, a_stateDerVectorName) = CodegenCppCommonOld.cref1(txt, i_stateVar, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, SimCodeFunction.contextOther, l_varDeclsCref, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, l_val);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           BackendDAE.TERMINATE(message = i_message),
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           _ )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_msgVar, l_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.daeExp(Tpl.emptyTxt, i_message, SimCodeFunction.contextSimulationDiscrete, l_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("MODELICA_TERMINATE("));
        txt = Tpl.writeText(txt, l_msgVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           BackendDAE.ASSERT(source = DAE.SOURCE(info = i_info), condition = i_condition, message = i_message, level = i_level),
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           _ )
      equation
        (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = assertCommon(txt, i_condition, i_message, i_level, SimCodeFunction.contextSimulationDiscrete, a_varDecls, i_info, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           BackendDAE.NORETCALL(exp = i_exp),
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           _ )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_expPart, l_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.daeExp(Tpl.emptyTxt, i_exp, SimCodeFunction.contextSimulationDiscrete, l_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        ret_6 = Util.isCIdentifier(Tpl.textString(l_expPart));
        txt = fun_1356(txt, ret_6, l_expPart);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);
  end match;
end fun_1357;

protected function lm_1358
  input Tpl.Text in_txt;
  input list<BackendDAE.WhenOperator> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_context)
    local
      Tpl.Text txt;
      list<BackendDAE.WhenOperator> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      SimCodeFunction.Context a_context;
      BackendDAE.WhenOperator i_whenOp;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           i_whenOp :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_context )
      equation
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = fun_1357(txt, i_whenOp, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_context);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = lm_1358(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_context);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);
  end match;
end lm_1358;

public function whenOperators
  input Tpl.Text txt;
  input list<BackendDAE.WhenOperator> a_whenOps;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_varDecls;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
protected
  Tpl.Text l_body;
algorithm
  l_body := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (l_body, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) := lm_1358(l_body, a_whenOps, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_context);
  l_body := Tpl.popIter(l_body);
  out_txt := Tpl.writeText(txt, l_body);
end whenOperators;

public function preCref
  input Tpl.Text txt;
  input DAE.ComponentRef a_cr;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
protected
  Tpl.Text l_varDeclsCref;
algorithm
  l_varDeclsCref := Tpl.emptyTxt;
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING("pre"));
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, l_varDeclsCref, out_a_stateDerVectorName) := CodegenCppCommonOld.representationCref(out_txt, a_cr, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_context, l_varDeclsCref, a_stateDerVectorName, a_useFlatArrayNotation);
end preCref;

protected function fun_1361
  input Tpl.Text in_txt;
  input Boolean in_a_isStartFixed;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_isStartFixed)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_clockStart[clockIndex - 1] || "));
      then txt;
  end match;
end fun_1361;

protected function fun_1362
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;
      Boolean i_isStartFixed;

    case ( txt,
           SimCodeVar.SIMVAR(varKind = BackendDAE.CLOCKED_STATE(isStartFixed = i_isStartFixed)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if ("));
        txt = fun_1361(txt, i_isStartFixed);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_clockSubactive[clockIndex - 1]) return;"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_1362;

protected function fun_1363
  input Tpl.Text in_txt;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_context)
    local
      Tpl.Text txt;

    case ( txt,
           SimCodeFunction.ALGLOOP_CONTEXT(genInitialisation = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_system->"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_1363;

protected function fun_1364
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Boolean in_a_overwriteOldStartValue;
  input Tpl.Text in_a_startValueType;
  input Tpl.Text in_a_expPart;
  input Tpl.Text in_a_lvalue;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_overwriteOldStartValue, in_a_startValueType, in_a_expPart, in_a_lvalue)
    local
      Tpl.Text txt;
      Boolean a_overwriteOldStartValue;
      Tpl.Text a_startValueType;
      Tpl.Text a_expPart;
      Tpl.Text a_lvalue;

    case ( txt,
           false,
           _,
           _,
           a_expPart,
           a_lvalue )
      equation
        txt = Tpl.writeText(txt, a_lvalue);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, a_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           _,
           a_overwriteOldStartValue,
           a_startValueType,
           a_expPart,
           a_lvalue )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("SystemDefaultImplementation::set"));
        txt = Tpl.writeText(txt, a_startValueType);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("StartValue("));
        txt = Tpl.writeText(txt, a_lvalue);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeStr(txt, Tpl.booleanString(a_overwriteOldStartValue));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;
  end match;
end fun_1364;

protected function fun_1365
  input Tpl.Text in_txt;
  input Boolean in_a_assignToStartValues;
  input Tpl.Text in_a_startFixedExp;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_assignToStartValues, in_a_startFixedExp)
    local
      Tpl.Text txt;
      Tpl.Text a_startFixedExp;

    case ( txt,
           false,
           a_startFixedExp )
      equation
        txt = Tpl.writeText(txt, a_startFixedExp);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_1365;

protected function fun_1366
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_startFixedExp;
  input Boolean in_a_overwriteOldStartValue;
  input Boolean in_a_assignToStartValues;
  input Tpl.Text in_a_expPart;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_varDecls;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input DAE.ComponentRef in_a_cref;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_varDecls, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_a_exp, in_a_preExp, in_a_startFixedExp, in_a_overwriteOldStartValue, in_a_assignToStartValues, in_a_expPart, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_varDecls, in_a_context, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_cref)
    local
      Tpl.Text txt;
      Tpl.Text a_preExp;
      Tpl.Text a_startFixedExp;
      Boolean a_overwriteOldStartValue;
      Boolean a_assignToStartValues;
      Tpl.Text a_expPart;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_varDecls;
      SimCodeFunction.Context a_context;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      DAE.ComponentRef a_cref;
      Boolean ret_5;
      Boolean ret_4;
      Boolean ret_3;
      Tpl.Text l_assignExp;
      Tpl.Text l_lvalue;
      Tpl.Text l_startValueType;

    case ( txt,
           DAE.CREF(ty = DAE.T_ARRAY(ty = _)),
           _,
           _,
           _,
           _,
           a_expPart,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_varDecls,
           a_context,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_cref )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("//Array assign\n"));
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_varDecls, a_stateDerVectorName) = CodegenCppCommonOld.cref1(txt, a_cref, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_context, a_varDecls, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, a_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then (txt, a_stateDerVectorName, a_varDecls, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           a_preExp,
           a_startFixedExp,
           a_overwriteOldStartValue,
           a_assignToStartValues,
           a_expPart,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_varDecls,
           a_context,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_cref )
      equation
        l_startValueType = CodegenCppCommonOld.crefStartValueType(Tpl.emptyTxt, a_cref);
        (l_lvalue, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_varDecls, a_stateDerVectorName) = CodegenCppCommonOld.cref1(Tpl.emptyTxt, a_cref, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_context, a_varDecls, a_stateDerVectorName, a_useFlatArrayNotation);
        ret_3 = stringEq(Tpl.textString(l_startValueType), "ExternalObject");
        ret_4 = boolNot(ret_3);
        ret_5 = boolAnd(a_assignToStartValues, ret_4);
        l_assignExp = fun_1364(Tpl.emptyTxt, ret_5, a_overwriteOldStartValue, l_startValueType, a_expPart, l_lvalue);
        txt = fun_1365(txt, a_assignToStartValues, a_startFixedExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, a_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_assignExp);
      then (txt, a_stateDerVectorName, a_varDecls, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_1366;

protected function fun_1367
  input Tpl.Text in_txt;
  input DAE.ComponentRef in_a_cref;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_startFixedExp;
  input Boolean in_a_overwriteOldStartValue;
  input Boolean in_a_assignToStartValues;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input DAE.Exp in_a_exp;
  input Tpl.Text in_a_expPart;
  input Boolean in_a_useFlatArrayNotation;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_varDecls, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_a_cref, in_a_preExp, in_a_startFixedExp, in_a_overwriteOldStartValue, in_a_assignToStartValues, in_a_stateDerVectorName, in_a_varDecls, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_exp, in_a_expPart, in_a_useFlatArrayNotation, in_a_context)
    local
      Tpl.Text txt;
      Tpl.Text a_preExp;
      Tpl.Text a_startFixedExp;
      Boolean a_overwriteOldStartValue;
      Boolean a_assignToStartValues;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_varDecls;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      DAE.Exp a_exp;
      Tpl.Text a_expPart;
      Boolean a_useFlatArrayNotation;
      SimCodeFunction.Context a_context;
      DAE.ComponentRef i_cref;
      DAE.ComponentRef i_componentRef;
      Tpl.Text l_sysderef;

    case ( txt,
           DAE.CREF_QUAL(ident = "$PRE", componentRef = i_componentRef),
           _,
           _,
           _,
           _,
           a_stateDerVectorName,
           a_varDecls,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _,
           a_expPart,
           a_useFlatArrayNotation,
           a_context )
      equation
        l_sysderef = fun_1363(Tpl.emptyTxt, a_context);
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_discrete_events->save("));
        txt = Tpl.writeText(txt, l_sysderef);
        txt = CodegenCppCommonOld.cref(txt, i_componentRef, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, a_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(");\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("//_discrete_events->pre("));
        txt = CodegenCppCommonOld.cref(txt, i_componentRef, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")="));
        txt = Tpl.writeText(txt, a_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then (txt, a_stateDerVectorName, a_varDecls, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           i_cref,
           a_preExp,
           a_startFixedExp,
           a_overwriteOldStartValue,
           a_assignToStartValues,
           a_stateDerVectorName,
           a_varDecls,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_exp,
           a_expPart,
           a_useFlatArrayNotation,
           a_context )
      equation
        (txt, a_stateDerVectorName, a_varDecls, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_1366(txt, a_exp, a_preExp, a_startFixedExp, a_overwriteOldStartValue, a_assignToStartValues, a_expPart, a_useFlatArrayNotation, a_stateDerVectorName, a_varDecls, a_context, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, i_cref);
      then (txt, a_stateDerVectorName, a_varDecls, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_1367;

public function equationSimpleAssign
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;
  input Boolean in_a_assignToStartValues;
  input Boolean in_a_overwriteOldStartValue;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_eq, in_a_context, in_a_varDecls, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation, in_a_assignToStartValues, in_a_overwriteOldStartValue)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_varDecls;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      Boolean a_assignToStartValues;
      Boolean a_overwriteOldStartValue;
      DAE.Exp i_exp;
      DAE.ComponentRef i_cref;
      Tpl.Text l_expPart;
      Tpl.Text l_preExp;
      SimCodeVar.SimVar ret_1;
      Tpl.Text l_startFixedExp;

    case ( txt,
           SimCode.SES_SIMPLE_ASSIGN(cref = i_cref, exp = i_exp),
           a_context,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation,
           a_assignToStartValues,
           a_overwriteOldStartValue )
      equation
        ret_1 = SimCodeUtil.cref2simvar(i_cref, a_simCode);
        l_startFixedExp = fun_1362(Tpl.emptyTxt, ret_1);
        l_preExp = Tpl.emptyTxt;
        (l_expPart, l_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.daeExp(Tpl.emptyTxt, i_exp, a_context, l_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        (txt, a_stateDerVectorName, a_varDecls, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_1367(txt, i_cref, l_preExp, l_startFixedExp, a_overwriteOldStartValue, a_assignToStartValues, a_stateDerVectorName, a_varDecls, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, i_exp, l_expPart, a_useFlatArrayNotation, a_context);
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _,
           _,
           _ )
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end equationSimpleAssign;

protected function fun_1369
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_ls_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_ls_index)
    local
      Tpl.Text txt;
      Integer a_ls_index;

    case ( txt,
           false,
           a_ls_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_algLoopLinearSolver->solve(_algLoop"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(",true);"));
      then txt;

    case ( txt,
           _,
           a_ls_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_algLoopLinearSolver"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("->solve();"));
      then txt;
  end match;
end fun_1369;

protected function fun_1370
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_ls_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_ls_index)
    local
      Tpl.Text txt;
      Integer a_ls_index;

    case ( txt,
           false,
           a_ls_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("double* algloop"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("Vars = _algLoopLinearSolver->getVariableWorkArray();\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(19));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("bool* conditions0"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " = _algLoopLinearSolver->getConditionsWorkArray();\n",
                                    "bool* conditions1"
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = _algLoopLinearSolver->getConditions2WorkArray();"));
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           _,
           a_ls_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("double* algloop"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Vars = _algLoopLinearSolver"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("->getVariableWorkArray();\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(19));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("bool* conditions0"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = _algLoopLinearSolver"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("->getConditionsWorkArray();\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(18));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("bool* conditions1"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = _algLoopLinearSolver"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("->getConditions2WorkArray();"));
        txt = Tpl.popBlock(txt);
      then txt;
  end match;
end fun_1370;

protected function fun_1371
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_ls_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_ls_index)
    local
      Tpl.Text txt;
      Integer a_ls_index;

    case ( txt,
           false,
           a_ls_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_algLoopLinearSolver->solve(_algLoop"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(",(iterations"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("==1));"));
      then txt;

    case ( txt,
           _,
           a_ls_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_algLoopLinearSolver"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("->solve();"));
      then txt;
  end match;
end fun_1371;

protected function fun_1372
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_ls_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_ls_index)
    local
      Tpl.Text txt;
      Integer a_ls_index;

    case ( txt,
           false,
           a_ls_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_algLoopLinearSolver->solve(_algLoop"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(",true);"));
      then txt;

    case ( txt,
           _,
           a_ls_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_algLoopLinearSolver"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("->solve();"));
      then txt;
  end match;
end fun_1372;

protected function fun_1373
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_ls_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_ls_index)
    local
      Tpl.Text txt;
      Integer a_ls_index;

    case ( txt,
           false,
           a_ls_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_algLoopLinearSolver->solve(_algLoop"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;

    case ( txt,
           _,
           a_ls_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_algLoopLinearSolver"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("->solve();"));
      then txt;
  end match;
end fun_1373;

protected function fun_1374
  input Tpl.Text in_txt;
  input SimCodeFunction.Context in_a_context;
  input Integer in_a_ls_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_context, in_a_ls_index)
    local
      Tpl.Text txt;
      Integer a_ls_index;
      Boolean ret_19;
      Boolean ret_18;
      Boolean ret_17;
      Boolean ret_16;
      Boolean ret_15;
      Boolean ret_14;
      Boolean ret_13;
      Boolean ret_12;
      Boolean ret_11;
      Boolean ret_10;
      Boolean ret_9;
      Boolean ret_8;
      Boolean ret_7;
      Boolean ret_6;
      Boolean ret_5;
      Boolean ret_4;
      Boolean ret_3;
      Boolean ret_2;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           SimCodeFunction.ALGLOOP_CONTEXT(genInitialisation = true),
           a_ls_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "try\n",
                                    "{\n",
                                    "\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_algLoop"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "->evaluate();\n",
                                    "for(int i=0; i<_dimZeroFunc; i++) {\n",
                                    "    getCondition(i);\n",
                                    "}\n",
                                    "IContinuous::UPDATETYPE calltype = _callType;\n",
                                    "_callType = IContinuous::CONTINUOUS;\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        ret_0 = Flags.isSet(Flags.HPCOM);
        ret_1 = Flags.getConfigBool(Flags.SINGLE_INSTANCE_AGLSOLVER);
        ret_2 = boolNot(ret_1);
        ret_3 = boolOr(ret_0, ret_2);
        txt = fun_1369(txt, ret_3, a_ls_index);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_callType = calltype;\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "catch(ModelicaSimulationError&  ex)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("string error = add_error_info(\"Linear solver "));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\", ex.what(), ex.getErrorID(), _simTime);\n",
                                    "throw ModelicaSimulationError(ALGLOOP_EQ_SYSTEM,error);\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;

    case ( txt,
           _,
           a_ls_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("bool restart"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " = true;\n",
                                    "unsigned int iterations"
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" = 0;\n"));
        ret_4 = Flags.isSet(Flags.HPCOM);
        ret_5 = Flags.getConfigBool(Flags.SINGLE_INSTANCE_AGLSOLVER);
        ret_6 = boolNot(ret_5);
        ret_7 = boolOr(ret_4, ret_6);
        txt = fun_1370(txt, ret_7, a_ls_index);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_algLoop"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("->getReal(algloop"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Vars );\n",
                                    "bool restatDiscrete"
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "= false;\n",
                                    "IContinuous::UPDATETYPE calltype = _callType;\n",
                                    "try\n",
                                    "{\n",
                                    " if( _callType == IContinuous::DISCRETE )\n",
                                    "    {\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(8));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_algLoop"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "->evaluate();\n",
                                    "while(restart"
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" && !(iterations"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "++>500))\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("getConditions(conditions0"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ");\n",
                                    "_callType = IContinuous::CONTINUOUS;\n",
                                    "\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        ret_8 = Flags.isSet(Flags.HPCOM);
        ret_9 = Flags.getConfigBool(Flags.SINGLE_INSTANCE_AGLSOLVER);
        ret_10 = boolNot(ret_9);
        ret_11 = boolOr(ret_8, ret_10);
        txt = fun_1371(txt, ret_11, a_ls_index);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_callType = IContinuous::DISCRETE;\n",
                                    "for(int i=0;i<_dimZeroFunc;i++)\n",
                                    "{\n",
                                    "    getCondition(i);\n",
                                    "}\n",
                                    "\n",
                                    "getConditions(conditions1"
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ");\n",
                                    "restart"
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = !std::equal (conditions1"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", conditions1"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("+_dimZeroFunc,conditions0"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(");\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("}\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "    }\n",
                                    "    else\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(8));
        ret_12 = Flags.isSet(Flags.HPCOM);
        ret_13 = Flags.getConfigBool(Flags.SINGLE_INSTANCE_AGLSOLVER);
        ret_14 = boolNot(ret_13);
        ret_15 = boolOr(ret_12, ret_14);
        txt = fun_1372(txt, ret_15, a_ls_index);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "catch(ModelicaSimulationError &ex)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(5));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("restatDiscrete"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("=true;\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n",
                                    "if((restart"
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("&& iterations"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" > 0)|| restatDiscrete"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ")\n",
                                    "{\n",
                                    "    try\n",
                                    "    {  //workaround: try to solve algoop discrete (evaluate all zero crossing conditions) since we do not have the information which zercrossing contains a algloop var\n",
                                    "        _callType = IContinuous::DISCRETE;\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(8));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_algLoop"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("->setReal(algloop"));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("Vars );\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        ret_16 = Flags.isSet(Flags.HPCOM);
        ret_17 = Flags.getConfigBool(Flags.SINGLE_INSTANCE_AGLSOLVER);
        ret_18 = boolNot(ret_17);
        ret_19 = boolOr(ret_16, ret_18);
        txt = fun_1373(txt, ret_19, a_ls_index);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_callType = calltype;\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "    }\n",
                                    "    catch(ModelicaSimulationError& ex)\n",
                                    "    {\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(6));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("string error = add_error_info(\"Linear solver "));
        txt = Tpl.writeStr(txt, intString(a_ls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\", ex.what(), ex.getErrorID(), _simTime);\n",
                                    "throw ModelicaSimulationError(ALGLOOP_EQ_SYSTEM,error);\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "    }\n",
                                    "}"
                                }, false));
      then txt;
  end match;
end fun_1374;

protected function fun_1375
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_nls_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_nls_index)
    local
      Tpl.Text txt;
      Integer a_nls_index;

    case ( txt,
           false,
           a_nls_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_algLoopNonLinearSolver->solve(_algLoop"));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(",true);"));
      then txt;

    case ( txt,
           _,
           a_nls_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_algLoopNonLinearSolver"));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("->solve();"));
      then txt;
  end match;
end fun_1375;

protected function fun_1376
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_nls_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_nls_index)
    local
      Tpl.Text txt;
      Integer a_nls_index;

    case ( txt,
           false,
           a_nls_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("double* algloop"));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("Vars = _algLoopNonLinearSolver->getVariableWorkArray();\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(19));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("bool* conditions0"));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " = _algLoopNonLinearSolver->getConditionsWorkArray();\n",
                                    "bool* conditions1"
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = _algLoopNonLinearSolver->getConditions2WorkArray();"));
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           _,
           a_nls_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("double* algloop"));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Vars = _algLoopNonLinearSolver"));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("->getVariableWorkArray();\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(19));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("bool* conditions0"));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = _algLoopNonLinearSolver"));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("->getConditionsWorkArray();\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(18));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("bool* conditions1"));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = _algLoopNonLinearSolver"));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("->getConditions2WorkArray();"));
        txt = Tpl.popBlock(txt);
      then txt;
  end match;
end fun_1376;

protected function fun_1377
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_nls_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_nls_index)
    local
      Tpl.Text txt;
      Integer a_nls_index;

    case ( txt,
           false,
           a_nls_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_algLoopNonLinearSolver->solve(_algLoop"));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(",(iterations"));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("==1));"));
      then txt;

    case ( txt,
           _,
           a_nls_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_algLoopNonLinearSolver"));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("->solve();"));
      then txt;
  end match;
end fun_1377;

protected function fun_1378
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_nls_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_nls_index)
    local
      Tpl.Text txt;
      Integer a_nls_index;

    case ( txt,
           false,
           a_nls_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_algLoopNonLinearSolver->solve(_algLoop"));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(",true);"));
      then txt;

    case ( txt,
           _,
           a_nls_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_algLoopNonLinearSolver"));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("->solve();"));
      then txt;
  end match;
end fun_1378;

protected function fun_1379
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_nls_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_nls_index)
    local
      Tpl.Text txt;
      Integer a_nls_index;

    case ( txt,
           false,
           a_nls_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_algLoopNonLinearSolver->solve(algLoop"));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;

    case ( txt,
           _,
           a_nls_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_algLoopNonLinearSolver"));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("->solve();"));
      then txt;
  end match;
end fun_1379;

protected function fun_1380
  input Tpl.Text in_txt;
  input SimCodeFunction.Context in_a_context;
  input Integer in_a_nls_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_context, in_a_nls_index)
    local
      Tpl.Text txt;
      Integer a_nls_index;
      Boolean ret_19;
      Boolean ret_18;
      Boolean ret_17;
      Boolean ret_16;
      Boolean ret_15;
      Boolean ret_14;
      Boolean ret_13;
      Boolean ret_12;
      Boolean ret_11;
      Boolean ret_10;
      Boolean ret_9;
      Boolean ret_8;
      Boolean ret_7;
      Boolean ret_6;
      Boolean ret_5;
      Boolean ret_4;
      Boolean ret_3;
      Boolean ret_2;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           SimCodeFunction.ALGLOOP_CONTEXT(genInitialisation = true),
           a_nls_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "try\n",
                                    "{\n",
                                    "\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_algLoop"));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "->evaluate();\n",
                                    "for(int i=0; i<_dimZeroFunc; i++) {\n",
                                    "    getCondition(i);\n",
                                    "}\n",
                                    "IContinuous::UPDATETYPE calltype = _callType;\n",
                                    "_callType = IContinuous::CONTINUOUS;\n",
                                    "\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        ret_0 = Flags.isSet(Flags.HPCOM);
        ret_1 = Flags.getConfigBool(Flags.SINGLE_INSTANCE_AGLSOLVER);
        ret_2 = boolNot(ret_1);
        ret_3 = boolOr(ret_0, ret_2);
        txt = fun_1375(txt, ret_3, a_nls_index);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.popBlock(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "   _callType = calltype;\n",
                                    "}\n",
                                    "catch(ModelicaSimulationError&  ex)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("string error = add_error_info(\"Nonlinear solver "));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\", ex.what(), ex.getErrorID(), _simTime);\n",
                                    "throw ModelicaSimulationError(ALGLOOP_EQ_SYSTEM,error);\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;

    case ( txt,
           _,
           a_nls_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("bool restart"));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " = true;\n",
                                    "unsigned int iterations"
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" = 0;\n"));
        ret_4 = Flags.isSet(Flags.HPCOM);
        ret_5 = Flags.getConfigBool(Flags.SINGLE_INSTANCE_AGLSOLVER);
        ret_6 = boolNot(ret_5);
        ret_7 = boolOr(ret_4, ret_6);
        txt = fun_1376(txt, ret_7, a_nls_index);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_algLoop"));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("->getReal(algloop"));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Vars );\n",
                                    "bool restatDiscrete"
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "= false;\n",
                                    "IContinuous::UPDATETYPE calltype = _callType;\n",
                                    "try\n",
                                    "{\n",
                                    " if( _callType == IContinuous::DISCRETE )\n",
                                    "    {\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(8));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_algLoop"));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "->evaluate();\n",
                                    "while(restart"
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" && !(iterations"));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "++>500))\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("getConditions(conditions0"));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ");\n",
                                    "_callType = IContinuous::CONTINUOUS;\n",
                                    "\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        ret_8 = Flags.isSet(Flags.HPCOM);
        ret_9 = Flags.getConfigBool(Flags.SINGLE_INSTANCE_AGLSOLVER);
        ret_10 = boolNot(ret_9);
        ret_11 = boolOr(ret_8, ret_10);
        txt = fun_1377(txt, ret_11, a_nls_index);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_callType = IContinuous::DISCRETE;\n",
                                    "for(int i=0;i<_dimZeroFunc;i++)\n",
                                    "{\n",
                                    "    getCondition(i);\n",
                                    "}\n",
                                    "\n",
                                    "getConditions(conditions1"
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ");\n",
                                    "restart"
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = !std::equal (conditions1"));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", conditions1"));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("+_dimZeroFunc,conditions0"));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(");\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("}\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "    }\n",
                                    "    else\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(5));
        ret_12 = Flags.isSet(Flags.HPCOM);
        ret_13 = Flags.getConfigBool(Flags.SINGLE_INSTANCE_AGLSOLVER);
        ret_14 = boolNot(ret_13);
        ret_15 = boolOr(ret_12, ret_14);
        txt = fun_1378(txt, ret_15, a_nls_index);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "catch(ModelicaSimulationError &ex)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(5));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("restatDiscrete"));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("=true;\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n",
                                    "if((restart"
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("&& iterations"));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" > 0)|| restatDiscrete"));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ")\n",
                                    "{\n",
                                    "    try\n",
                                    "    {  //workaround: try to solve algoop discrete (evaluate all zero crossing conditions) since we do not have the information which zercrossing contains a algloop var\n",
                                    "        _callType = IContinuous::DISCRETE;\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(8));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_algLoop"));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("->setReal(algloop"));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Vars );\n",
                                    "\n"
                                }, true));
        ret_16 = Flags.isSet(Flags.HPCOM);
        ret_17 = Flags.getConfigBool(Flags.SINGLE_INSTANCE_AGLSOLVER);
        ret_18 = boolNot(ret_17);
        ret_19 = boolOr(ret_16, ret_18);
        txt = fun_1379(txt, ret_19, a_nls_index);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_callType = calltype;\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "    }\n",
                                    "    catch(ModelicaSimulationError& ex)\n",
                                    "    {\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(6));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("string error = add_error_info(\"Nonlinear solver "));
        txt = Tpl.writeStr(txt, intString(a_nls_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\", ex.what(), ex.getErrorID(), _simTime);\n",
                                    "throw ModelicaSimulationError(ALGLOOP_EQ_SYSTEM,error);\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "    }\n",
                                    "}"
                                }, false));
      then txt;
  end match;
end fun_1380;

protected function fun_1381
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_eq, in_a_context)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Integer i_nls_index;
      Integer i_ls_index;
      Tpl.Text l_i;

    case ( txt,
           SimCode.SES_LINEAR(lSystem = SimCode.LINEARSYSTEM(index = i_ls_index)),
           a_context )
      equation
        l_i = Tpl.writeStr(Tpl.emptyTxt, intString(i_ls_index));
        txt = fun_1374(txt, a_context, i_ls_index);
      then txt;

    case ( txt,
           SimCode.SES_NONLINEAR(nlSystem = SimCode.NONLINEARSYSTEM(index = i_nls_index)),
           a_context )
      equation
        l_i = Tpl.writeStr(Tpl.emptyTxt, intString(i_nls_index));
        txt = fun_1380(txt, a_context, i_nls_index);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_1381;

public function equationLinearOrNonLinear
  input Tpl.Text txt;
  input SimCode.SimEqSystem a_eq;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_varDecls;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_stateDerVectorName;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  out_txt := fun_1381(txt, a_eq, a_context);
  out_a_varDecls := a_varDecls;
  out_a_extraFuncs := a_extraFuncs;
  out_a_extraFuncsDecl := a_extraFuncsDecl;
  out_a_extraFuncsNamespace := a_extraFuncsNamespace;
  out_a_stateDerVectorName := a_stateDerVectorName;
end equationLinearOrNonLinear;

protected function fun_1383
  input Tpl.Text in_txt;
  input Boolean in_a_isStartFixed;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_isStartFixed)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_clockStart[clockIndex - 1] || "));
      then txt;
  end match;
end fun_1383;

protected function fun_1384
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;
      Boolean i_isStartFixed;

    case ( txt,
           SimCodeVar.SIMVAR(varKind = BackendDAE.CLOCKED_STATE(isStartFixed = i_isStartFixed)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if ("));
        txt = fun_1383(txt, i_isStartFixed);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_clockSubactive[clockIndex - 1]) return;"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_1384;

protected function fun_1385
  input Tpl.Text in_txt;
  input Boolean in_a_assignToStartValues;
  input Tpl.Text in_a_startFixedExp;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_assignToStartValues, in_a_startFixedExp)
    local
      Tpl.Text txt;
      Tpl.Text a_startFixedExp;

    case ( txt,
           false,
           a_startFixedExp )
      equation
        txt = Tpl.writeText(txt, a_startFixedExp);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_1385;

protected function fun_1386
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_expPart;
  input Tpl.Text in_a_crefPart;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_expPart, in_a_crefPart)
    local
      Tpl.Text txt;
      Tpl.Text a_expPart;
      Tpl.Text a_crefPart;

    case ( txt,
           false,
           a_expPart,
           a_crefPart )
      equation
        txt = Tpl.writeText(txt, a_crefPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, a_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           _,
           a_expPart,
           a_crefPart )
      equation
        txt = Tpl.writeText(txt, a_crefPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".assign("));
        txt = Tpl.writeText(txt, a_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;
  end match;
end fun_1386;

protected function fun_1387
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_assignToStartValues;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_eq, in_a_context, in_a_varDecls, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_assignToStartValues)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_varDecls;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_assignToStartValues;
      DAE.Exp i_exp;
      DAE.Exp i_endIt;
      DAE.Exp i_startIt;
      DAE.Exp i_iter;
      DAE.ComponentRef i_cref;
      Boolean ret_10;
      DAE.Type ret_9;
      DAE.Exp ret_8;
      Tpl.Text l_crefPart;
      Tpl.Text l_expPart;
      Tpl.Text l_endExp;
      Tpl.Text l_startExp;
      Tpl.Text l_iterExp;
      Tpl.Text l_preExp;
      SimCodeVar.SimVar ret_1;
      Tpl.Text l_startFixedExp;

    case ( txt,
           SimCode.SES_FOR_LOOP(cref = i_cref, iter = i_iter, startIt = i_startIt, endIt = i_endIt, exp = i_exp),
           a_context,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_assignToStartValues )
      equation
        ret_1 = SimCodeUtil.cref2simvar(i_cref, a_simCode);
        l_startFixedExp = fun_1384(Tpl.emptyTxt, ret_1);
        l_preExp = Tpl.emptyTxt;
        (l_iterExp, l_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.daeExp(Tpl.emptyTxt, i_iter, a_context, l_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, false);
        (l_startExp, l_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.daeExp(Tpl.emptyTxt, i_startIt, a_context, l_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, false);
        (l_endExp, l_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.daeExp(Tpl.emptyTxt, i_endIt, a_context, l_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, false);
        (l_expPart, l_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.daeExp(Tpl.emptyTxt, i_exp, a_context, l_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, false);
        ret_8 = Expression.crefExp(i_cref);
        (l_crefPart, l_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.daeExp(Tpl.emptyTxt, ret_8, a_context, l_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, false);
        txt = fun_1385(txt, a_assignToStartValues, l_startFixedExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("for (int "));
        txt = Tpl.writeText(txt, l_iterExp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, l_startExp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("; "));
        txt = Tpl.writeText(txt, l_iterExp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" <= "));
        txt = Tpl.writeText(txt, l_endExp);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("; "));
        txt = Tpl.writeText(txt, l_iterExp);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("++) {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        ret_9 = ComponentReference.crefTypeFull(i_cref);
        ret_10 = Expression.isArrayType(ret_9);
        txt = fun_1386(txt, ret_10, l_expPart, l_crefPart);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end fun_1387;

public function equationForLoop
  input Tpl.Text txt;
  input SimCode.SimEqSystem a_eq;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_varDecls;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;
  input Boolean a_assignToStartValues;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) := fun_1387(txt, a_eq, a_context, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_assignToStartValues);
end equationForLoop;

public function testDaeDimension
  input Tpl.Text txt;
  input DAE.Dimension a_dim;

  output Tpl.Text out_txt;
protected
  DAE.Exp ret_0;
algorithm
  ret_0 := Expression.dimensionSizeExpHandleUnkown(a_dim);
  out_txt := testDaeDimensionExp(txt, ret_0);
end testDaeDimension;

public function testDaeDimensionExp
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_exp)
    local
      Tpl.Text txt;

    case ( txt,
           DAE.ICONST(integer = _) )
      then txt;

    case ( txt,
           DAE.RCONST(real = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-1"));
      then txt;

    case ( txt,
           DAE.BCONST(bool = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-1"));
      then txt;

    case ( txt,
           DAE.ENUM_LITERAL(name = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-1"));
      then txt;

    case ( txt,
           DAE.CREF(componentRef = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-1"));
      then txt;

    case ( txt,
           DAE.CAST(ty = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-1"));
      then txt;

    case ( txt,
           DAE.CONS(car = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-1"));
      then txt;

    case ( txt,
           DAE.SCONST(string = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-1"));
      then txt;

    case ( txt,
           DAE.UNARY(operator = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-1"));
      then txt;

    case ( txt,
           DAE.LBINARY(exp1 = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-1"));
      then txt;

    case ( txt,
           DAE.LUNARY(operator = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-1"));
      then txt;

    case ( txt,
           DAE.BINARY(exp1 = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-1"));
      then txt;

    case ( txt,
           DAE.IFEXP(expCond = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-1"));
      then txt;

    case ( txt,
           DAE.RELATION(exp1 = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-1"));
      then txt;

    case ( txt,
           DAE.CALL(path = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-1"));
      then txt;

    case ( txt,
           DAE.RECORD(path = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-1"));
      then txt;

    case ( txt,
           DAE.ASUB(exp = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-1"));
      then txt;

    case ( txt,
           DAE.MATRIX(ty = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-1"));
      then txt;

    case ( txt,
           DAE.RANGE(ty = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-1"));
      then txt;

    case ( txt,
           DAE.ASUB(exp = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-1"));
      then txt;

    case ( txt,
           DAE.TSUB(exp = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-1"));
      then txt;

    case ( txt,
           DAE.REDUCTION(reductionInfo = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-1"));
      then txt;

    case ( txt,
           DAE.ARRAY(ty = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-1"));
      then txt;

    case ( txt,
           DAE.SIZE(exp = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-1"));
      then txt;

    case ( txt,
           DAE.SHARED_LITERAL(index = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-1"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-1"));
      then txt;
  end match;
end testDaeDimensionExp;

public function daeDimension
  input Tpl.Text txt;
  input DAE.Dimension a_dim;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_preExp;
  input Tpl.Text a_varDecls;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
protected
  DAE.Exp ret_0;
algorithm
  ret_0 := Expression.dimensionSizeExpHandleUnkown(a_dim);
  (out_txt, out_a_preExp, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) := CodegenCppCommonOld.daeExp(txt, ret_0, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
end daeDimension;

protected function fun_1392
  input Tpl.Text in_txt;
  input DAE.Exp in_a_level;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_level)
    local
      Tpl.Text txt;

    case ( txt,
           DAE.ENUM_LITERAL(index = 2) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("LOGGER_WRITE(\"Assert in model equation\", LC_MODEL, LL_WARNING);"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("throw ModelicaSimulationError() << error_id(MODEL_EQ_SYSTEM);"));
      then txt;
  end match;
end fun_1392;

protected function fun_1393
  input Tpl.Text in_txt;
  input DAE.Exp in_a_level;
  input Tpl.Text in_a_msgVar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_level, in_a_msgVar)
    local
      Tpl.Text txt;
      Tpl.Text a_msgVar;

    case ( txt,
           DAE.ENUM_LITERAL(index = 2),
           a_msgVar )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("LOGGER_WRITE("));
        txt = Tpl.writeText(txt, a_msgVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", LC_MODEL, LL_WARNING);"));
      then txt;

    case ( txt,
           _,
           a_msgVar )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("throw ModelicaSimulationError(MODEL_EQ_SYSTEM, "));
        txt = Tpl.writeText(txt, a_msgVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;
  end match;
end fun_1393;

protected function fun_1394
  input Tpl.Text in_txt;
  input Tpl.Text in_a_msgVar;
  input DAE.Exp in_a_level;
  input Tpl.Text in_a_preExpMsg;
  input Tpl.Text in_a_preExpCond;
  input Tpl.Text in_a_condVar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_msgVar, in_a_level, in_a_preExpMsg, in_a_preExpCond, in_a_condVar)
    local
      Tpl.Text txt;
      DAE.Exp a_level;
      Tpl.Text a_preExpMsg;
      Tpl.Text a_preExpCond;
      Tpl.Text a_condVar;
      Tpl.Text i_msgVar;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           a_level,
           a_preExpMsg,
           a_preExpCond,
           a_condVar )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if (!"));
        txt = Tpl.writeText(txt, a_condVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ")\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_preExpCond);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, a_preExpMsg);
        txt = Tpl.softNewLine(txt);
        txt = fun_1392(txt, a_level);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;

    case ( txt,
           i_msgVar,
           a_level,
           a_preExpMsg,
           a_preExpCond,
           a_condVar )
      equation
        txt = Tpl.writeText(txt, a_preExpCond);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if (!"));
        txt = Tpl.writeText(txt, a_condVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ")\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_preExpMsg);
        txt = Tpl.softNewLine(txt);
        txt = fun_1393(txt, a_level, i_msgVar);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;
  end match;
end fun_1394;

public function assertCommon
  input Tpl.Text txt;
  input DAE.Exp a_condition;
  input DAE.Exp a_message;
  input DAE.Exp a_level;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_varDecls;
  input SourceInfo a_info;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
protected
  Tpl.Text l_msgVar;
  Tpl.Text l_condVar;
  Tpl.Text l_preExpMsg;
  Tpl.Text l_preExpCond;
algorithm
  l_preExpCond := Tpl.emptyTxt;
  l_preExpMsg := Tpl.emptyTxt;
  (l_condVar, l_preExpCond, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) := CodegenCppCommonOld.daeExp(Tpl.emptyTxt, a_condition, a_context, l_preExpCond, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
  (l_msgVar, l_preExpMsg, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) := CodegenCppCommonOld.daeExp(Tpl.emptyTxt, a_message, a_context, l_preExpMsg, out_a_varDecls, a_simCode, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName, a_useFlatArrayNotation);
  out_txt := Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
  out_txt := fun_1394(out_txt, l_msgVar, a_level, l_preExpMsg, l_preExpCond, l_condVar);
end assertCommon;

public function infoArgs
  input Tpl.Text in_txt;
  input SourceInfo in_a_info;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_info)
    local
      Tpl.Text txt;
      Boolean i_isReadOnly;
      Integer i_columnNumberEnd;
      Integer i_lineNumberEnd;
      Integer i_columnNumberStart;
      Integer i_lineNumberStart;
      String i_fileName;

    case ( txt,
           SOURCEINFO(fileName = i_fileName, lineNumberStart = i_lineNumberStart, columnNumberStart = i_columnNumberStart, lineNumberEnd = i_lineNumberEnd, columnNumberEnd = i_columnNumberEnd, isReadOnly = i_isReadOnly) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        txt = Tpl.writeStr(txt, i_fileName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\","));
        txt = Tpl.writeStr(txt, intString(i_lineNumberStart));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeStr(txt, intString(i_columnNumberStart));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeStr(txt, intString(i_lineNumberEnd));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeStr(txt, intString(i_columnNumberEnd));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeStr(txt, Tpl.booleanString(i_isReadOnly));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end infoArgs;

public function underscorePrefix
  input Tpl.Text in_txt;
  input Boolean in_a_builtin;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_builtin)
    local
      Tpl.Text txt;

    case ( txt,
           true )
      then txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end underscorePrefix;

protected function fun_1398
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_outputVars;
  input Tpl.Text in_a_inputVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode, in_a_outputVars, in_a_inputVars)
    local
      Tpl.Text txt;
      Tpl.Text a_outputVars;
      Tpl.Text a_inputVars;
      Absyn.Path i_modelInfo_name;
      Tpl.Text l_modelname;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = i_modelInfo_name)),
           a_outputVars,
           a_inputVars )
      equation
        l_modelname = identOfPath(Tpl.emptyTxt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "<?xml version=\"1.0\" encoding=\"utf-8\"?>\n",
                                    "<project xmlns=\"http://www.plcopen.org/xml/tc6_0200\">\n",
                                    "  <fileHeader companyName=\"\" productName=\"IndraLogic\" productVersion=\"indralogic\" creationDateTime=\"2015-11-19T11:21:48.0837805\" />\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<contentHeader name=\""));
        txt = Tpl.writeText(txt, l_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\">\n",
                                    "  <coordinateInfo>\n",
                                    "    <fbd>\n",
                                    "      <scaling x=\"1\" y=\"1\" />\n",
                                    "    </fbd>\n",
                                    "    <ld>\n",
                                    "      <scaling x=\"1\" y=\"1\" />\n",
                                    "    </ld>\n",
                                    "    <sfc>\n",
                                    "      <scaling x=\"1\" y=\"1\" />\n",
                                    "    </sfc>\n",
                                    "  </coordinateInfo>\n",
                                    "  <addData>\n",
                                    "    <data name=\"http://www.3s-software.com/plcopenxml/projectinformation\" handleUnknown=\"implementation\">\n",
                                    "      <ProjectInformation />\n",
                                    "    </data>\n",
                                    "  </addData>\n",
                                    "</contentHeader>\n",
                                    "<types>\n",
                                    "  <dataTypes />\n",
                                    "  <pous>\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<pou name=\""));
        txt = Tpl.writeText(txt, l_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\" pouType=\"functionBlock\">\n",
                                    "  <interface>\n",
                                    "    <inputVars>\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(6));
        txt = Tpl.writeText(txt, a_inputVars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "    </inputVars>\n",
                                    "    <outputVars>\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(6));
        txt = Tpl.writeText(txt, a_outputVars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "    </outputVars>\n",
                                    "    <localVars>\n",
                                    "      <variable name=\"cycletime\">\n",
                                    "        <type>\n",
                                    "          <LREAL />\n",
                                    "        </type>\n",
                                    "        <initialValue>\n",
                                    "          <simpleValue value=\"0.004\" />\n",
                                    "        </initialValue>\n",
                                    "      </variable>\n",
                                    "      <variable name=\"bAlreadyInitialized\">\n",
                                    "        <type>\n",
                                    "          <BOOL />\n",
                                    "        </type>\n",
                                    "      </variable>\n",
                                    "      <variable name=\"bErrorOccured\">\n",
                                    "        <type>\n",
                                    "          <BOOL />\n",
                                    "        </type>\n",
                                    "      </variable>\n",
                                    "      <variable name=\"controller\">\n",
                                    "        <type>\n",
                                    "          <DWORD />\n",
                                    "        </type>\n",
                                    "      </variable>\n",
                                    "      <variable name=\"simdata\">\n",
                                    "        <type>\n",
                                    "          <DWORD />\n",
                                    "        </type>\n",
                                    "      </variable>\n",
                                    "    </localVars>\n",
                                    "  </interface>\n",
                                    "  <body>\n",
                                    "    <ST>\n",
                                    "      <xhtml xmlns=\"http://www.w3.org/1999/xhtml\" />\n",
                                    "    </ST>\n",
                                    "  </body>\n",
                                    "  <addData>\n",
                                    "    <data name=\"http://www.3s-software.com/plcopenxml/method\" handleUnknown=\"implementation\">\n",
                                    "      <Method name=\"FB_Init\" ObjectId=\"102788a9-c3a0-4650-9ee8-e340b376c772\">\n",
                                    "        <interface>\n",
                                    "          <returnType>\n",
                                    "            <BOOL />\n",
                                    "          </returnType>\n",
                                    "          <inputVars>\n",
                                    "            <variable name=\"bInitRetains\">\n",
                                    "              <type>\n",
                                    "                <BOOL />\n",
                                    "              </type>\n",
                                    "            </variable>\n",
                                    "            <variable name=\"bInCopyCode\">\n",
                                    "              <type>\n",
                                    "                <BOOL />\n",
                                    "              </type>\n",
                                    "            </variable>\n",
                                    "          </inputVars>\n",
                                    "          <addData>\n",
                                    "            <data name=\"http://www.3s-software.com/plcopenxml/attributes\" handleUnknown=\"implementation\">\n",
                                    "              <Attributes>\n",
                                    "                <Attribute Name=\"object_name\" Value=\"FB_Init\" />\n",
                                    "              </Attributes>\n",
                                    "            </data>\n",
                                    "          </addData>\n",
                                    "        </interface>\n",
                                    "        <body>\n",
                                    "          <ST>\n",
                                    "            <xhtml xmlns=\"http://www.w3.org/1999/xhtml\" />\n",
                                    "          </ST>\n",
                                    "        </body>\n",
                                    "        <BuildProperties>\n",
                                    "          <ExternalImplementation>true</ExternalImplementation>\n",
                                    "        </BuildProperties>\n",
                                    "        <addData />\n",
                                    "      </Method>\n",
                                    "    </data>\n",
                                    "    <data name=\"http://www.3s-software.com/plcopenxml/method\" handleUnknown=\"implementation\">\n",
                                    "      <Method name=\"FB_Reinit\" ObjectId=\"a9db0581-3a33-4426-9a31-453930d13eb7\">\n",
                                    "        <interface>\n",
                                    "          <returnType>\n",
                                    "            <BOOL />\n",
                                    "          </returnType>\n",
                                    "          <addData>\n",
                                    "            <data name=\"http://www.3s-software.com/plcopenxml/attributes\" handleUnknown=\"implementation\">\n",
                                    "              <Attributes>\n",
                                    "                <Attribute Name=\"object_name\" Value=\"FB_Reinit\" />\n",
                                    "              </Attributes>\n",
                                    "            </data>\n",
                                    "          </addData>\n",
                                    "        </interface>\n",
                                    "        <body>\n",
                                    "          <ST>\n",
                                    "            <xhtml xmlns=\"http://www.w3.org/1999/xhtml\" />\n",
                                    "          </ST>\n",
                                    "        </body>\n",
                                    "        <BuildProperties>\n",
                                    "          <ExternalImplementation>true</ExternalImplementation>\n",
                                    "        </BuildProperties>\n",
                                    "        <addData />\n",
                                    "      </Method>\n",
                                    "    </data>\n",
                                    "    <data name=\"http://www.3s-software.com/plcopenxml/method\" handleUnknown=\"implementation\">\n",
                                    "      <Method name=\"FB_Exit\" ObjectId=\"c3ba1a8d-f305-4c9b-a3bf-e0c31a544d79\">\n",
                                    "        <interface>\n",
                                    "          <returnType>\n",
                                    "            <BOOL />\n",
                                    "          </returnType>\n",
                                    "          <inputVars>\n",
                                    "            <variable name=\"bInCopyCode\">\n",
                                    "              <type>\n",
                                    "                <BOOL />\n",
                                    "              </type>\n",
                                    "            </variable>\n",
                                    "          </inputVars>\n",
                                    "          <addData>\n",
                                    "            <data name=\"http://www.3s-software.com/plcopenxml/attributes\" handleUnknown=\"implementation\">\n",
                                    "              <Attributes>\n",
                                    "                <Attribute Name=\"object_name\" Value=\"FB_Exit\" />\n",
                                    "              </Attributes>\n",
                                    "            </data>\n",
                                    "          </addData>\n",
                                    "        </interface>\n",
                                    "        <body>\n",
                                    "          <ST>\n",
                                    "            <xhtml xmlns=\"http://www.w3.org/1999/xhtml\" />\n",
                                    "          </ST>\n",
                                    "        </body>\n",
                                    "        <BuildProperties>\n",
                                    "          <ExternalImplementation>true</ExternalImplementation>\n",
                                    "        </BuildProperties>\n",
                                    "        <addData />\n",
                                    "      </Method>\n",
                                    "    </data>\n",
                                    "    <data name=\"http://www.3s-software.com/plcopenxml/buildproperties\" handleUnknown=\"implementation\">\n",
                                    "      <BuildProperties>\n",
                                    "        <ExternalImplementation>true</ExternalImplementation>\n",
                                    "      </BuildProperties>\n",
                                    "    </data>\n",
                                    "    <data name=\"http://www.3s-software.com/plcopenxml/objectid\" handleUnknown=\"discard\">\n",
                                    "      <ObjectId>33609c54-38cc-4f33-9fa0-93f0a8b3a3b3</ObjectId>\n",
                                    "    </data>\n",
                                    "  </addData>\n",
                                    "</pou>\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "  </pous>\n",
                                    "</types>\n",
                                    "<instances>\n",
                                    "  <configurations />\n",
                                    "</instances>\n",
                                    "<addData>\n",
                                    "  <data name=\"http://www.3s-software.com/plcopenxml/projectstructure\" handleUnknown=\"discard\">\n",
                                    "    <ProjectStructure>\n",
                                    "      <Object Name=\"PController\" ObjectId=\"33609c54-38cc-4f33-9fa0-93f0a8b3a3b3\">\n",
                                    "        <Object Name=\"FB_Init\" ObjectId=\"102788a9-c3a0-4650-9ee8-e340b376c772\" />\n",
                                    "        <Object Name=\"FB_Reinit\" ObjectId=\"a9db0581-3a33-4426-9a31-453930d13eb7\" />\n",
                                    "        <Object Name=\"FB_Exit\" s=\"c3ba1a8d-f305-4c9b-a3bf-e0c31a544d79\" />\n",
                                    "      </Object>\n",
                                    "    </ProjectStructure>\n",
                                    "  </data>\n",
                                    "</addData>\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("</project>\n"));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_1398;

public function functionBlock
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_outputVars;
  Tpl.Text l_inputVars;
algorithm
  l_inputVars := spsInputVars(Tpl.emptyTxt, a_simCode);
  l_outputVars := spsOutputVars(Tpl.emptyTxt, a_simCode);
  out_txt := fun_1398(txt, a_simCode, l_outputVars, l_inputVars);
end functionBlock;

protected function fun_1400
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_outputVars;
  input Tpl.Text in_a_inputVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode, in_a_outputVars, in_a_inputVars)
    local
      Tpl.Text txt;
      Tpl.Text a_outputVars;
      Tpl.Text a_inputVars;
      Absyn.Path i_modelInfo_name;
      Tpl.Text l_modelname;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = i_modelInfo_name)),
           a_outputVars,
           a_inputVars )
      equation
        l_modelname = identOfPath(Tpl.emptyTxt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "typedef struct "
                                }, false));
        txt = Tpl.writeText(txt, l_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_struct\n",
                                    "{\n",
                                    "  void* __VFTABLEPOINTER;\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_inputVars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, a_outputVars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "MLPI_IEC_LREAL cycletime;\n",
                                    "MLPI_IEC_BOOL bAlreadyInitialized;\n",
                                    "MLPI_IEC_BOOL bErrorOccured;\n",
                                    "ISimController* controller;\n",
                                    "ISimData* simdata;\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
        txt = Tpl.writeText(txt, l_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_struct;\n",
                                    "\n",
                                    "typedef struct "
                                }, false));
        txt = Tpl.writeText(txt, l_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_Main_struct\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_struct* instance; // Declaration of instance pointer\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
        txt = Tpl.writeText(txt, l_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_Main_struct;\n",
                                    "\n",
                                    "typedef struct "
                                }, false));
        txt = Tpl.writeText(txt, l_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_FB_Init_struct\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_struct* instance; // Declaration of instance pointer\n",
                                    "MLPI_IEC_BOOL bInitRetains; // Declaration of predefined method input (no matter if using BOOL8)\n",
                                    "MLPI_IEC_BOOL bInCopyCode; // Declaration of predefined method input (no matter if using BOOL8)\n",
                                    "MLPI_IEC_BOOL FB_Init; // Declaration of implicit method output (no matter if using BOOL8)\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
        txt = Tpl.writeText(txt, l_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_FB_Init_struct;\n",
                                    "\n",
                                    "typedef struct "
                                }, false));
        txt = Tpl.writeText(txt, l_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_FB_Reinit_struct\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_struct* instance; // Declaration of instance pointer\n",
                                    "MLPI_IEC_BOOL FB_Reinit; // Declaration of implicit method output (no matter if using BOOL8)\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
        txt = Tpl.writeText(txt, l_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_FB_Reinit_struct;\n",
                                    "\n",
                                    "\n",
                                    "typedef struct "
                                }, false));
        txt = Tpl.writeText(txt, l_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_FB_Exit_struct\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_struct* instance; // Declaration of instance pointer\n",
                                    "MLPI_IEC_BOOL bInCopyCode; // Declaration of predefined method input (no matter if using BOOL8)\n",
                                    "MLPI_IEC_BOOL FB_Exit; // Declaration of implicit method output (no matter if using BOOL8)\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
        txt = Tpl.writeText(txt, l_modelname);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_FB_Exit_struct;\n"));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_1400;

public function mlpiStructs
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_outputVars;
  Tpl.Text l_inputVars;
algorithm
  l_inputVars := mlpiInputVars(Tpl.emptyTxt, a_simCode);
  l_outputVars := mlpiOutputVars(Tpl.emptyTxt, a_simCode);
  out_txt := fun_1400(txt, a_simCode, l_outputVars, l_inputVars);
end mlpiStructs;

public function ftp_script
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      String i_fileNamePrefix;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = _), fileNamePrefix = i_fileNamePrefix) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "echo option confirm off >> script.tmp\n",
                                    "echo open ftp:username:password@ip_address >> script.tmp\n",
                                    "echo cd \"SYSTEM/bundles\"  >> script.tmp\n",
                                    "echo rm com.boschrexroth."
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " >> script.tmp\n",
                                    "echo mkdir com.boschrexroth."
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " >> script.tmp\n",
                                    "echo cd com.boschrexroth."
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " >> script.tmp\n",
                                    "echo put \"com.boschrexroth."
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\\Debug\\com.boschrexroth."));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ".out\" >> script.tmp\n",
                                    "echo exit >> script.tmp\n",
                                    "\"C:\\Program Files (x86)\\WINSCP\\WinSCP.com\" /script=script.tmp\n",
                                    "del script.tmp\n"
                                }, true));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end ftp_script;

protected function fun_1403
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;

    case ( txt,
           SimCode.SIMCODE(modelInfo = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("0"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_1403;

public function helpvarlength
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  out_txt := fun_1403(txt, a_simCode);
  out_a_extraFuncs := a_extraFuncs;
  out_a_extraFuncsDecl := a_extraFuncsDecl;
  out_a_extraFuncsNamespace := a_extraFuncsNamespace;
end helpvarlength;

protected function fun_1405
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      Absyn.Path i_modelInfo_name;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = i_modelInfo_name)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("int "));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::getDimZeroFunc()\n",
                                    "{\n",
                                    "  return _dimZeroFunc;\n",
                                    "}\n",
                                    "int "
                                }, false));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::getDimClock()\n",
                                    "{\n",
                                    "  return _dimClock;\n",
                                    "}"
                                }, false));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_1405;

public function dimZeroFunc
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  out_txt := fun_1405(txt, a_simCode);
  out_a_extraFuncs := a_extraFuncs;
  out_a_extraFuncsDecl := a_extraFuncsDecl;
  out_a_extraFuncsNamespace := a_extraFuncsNamespace;
end dimZeroFunc;

protected function fun_1407
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      Absyn.Path i_modelInfo_name;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = i_modelInfo_name)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Initialize::setInitial(bool status)\n",
                                    "{\n",
                                    "  _initial = status;\n",
                                    "  if(_initial)\n",
                                    "    _callType = IContinuous::DISCRETE;\n",
                                    "  else\n",
                                    "    _callType = IContinuous::CONTINUOUS;\n",
                                    "}"
                                }, false));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_1407;

public function setIntialStatus
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  out_txt := fun_1407(txt, a_simCode);
  out_a_extraFuncs := a_extraFuncs;
  out_a_extraFuncsDecl := a_extraFuncsDecl;
  out_a_extraFuncsNamespace := a_extraFuncsNamespace;
end setIntialStatus;

protected function fun_1409
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      Absyn.Path i_modelInfo_name;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = i_modelInfo_name)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("bool "));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Initialize::initial()\n",
                                    "{\n",
                                    "  return _initial;\n",
                                    "}"
                                }, false));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_1409;

public function getIntialStatus
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  out_txt := fun_1409(txt, a_simCode);
  out_a_extraFuncs := a_extraFuncs;
  out_a_extraFuncsDecl := a_extraFuncsDecl;
  out_a_extraFuncsNamespace := a_extraFuncsNamespace;
end getIntialStatus;

public function functionOnlyZeroCrossing
  input Tpl.Text txt;
  input list<BackendDAE.ZeroCrossing> a_zeroCrossings;
  input Tpl.Text a_varDecls;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
protected
  Tpl.Text l_zeroCrossingsCode;
algorithm
  (l_zeroCrossingsCode, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace) := zeroCrossingsTpl2(Tpl.emptyTxt, a_zeroCrossings, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
  out_txt := Tpl.writeText(txt, l_zeroCrossingsCode);
end functionOnlyZeroCrossing;

protected function lm_1412
  input Tpl.Text in_txt;
  input list<BackendDAE.ZeroCrossing> in_items;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) :=
  match(in_txt, in_items, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls)
    local
      Tpl.Text txt;
      list<BackendDAE.ZeroCrossing> rest;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Integer x_i0;
      DAE.Exp i_relation__;

    case ( txt,
           {},
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           BackendDAE.ZERO_CROSSING(relation_ = i_relation__) :: rest,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = zeroCrossingTpl2(txt, x_i0, i_relation__, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
        txt = Tpl.nextIter(txt);
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = lm_1412(txt, rest, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           _ :: rest,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls )
      equation
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = lm_1412(txt, rest, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);
  end match;
end lm_1412;

public function zeroCrossingsTpl2
  input Tpl.Text txt;
  input list<BackendDAE.ZeroCrossing> a_zeroCrossings;
  input Tpl.Text a_varDecls;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  out_txt := Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) := lm_1412(out_txt, a_zeroCrossings, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls);
  out_txt := Tpl.popIter(out_txt);
end zeroCrossingsTpl2;

protected function fun_1414
  input Tpl.Text in_txt;
  input DAE.Exp in_a_relation;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_relation)
    local
      Tpl.Text txt;
      Integer i_zerocrossingIndex;

    case ( txt,
           DAE.RELATION(index = i_zerocrossingIndex) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("checkConditions("));
        txt = Tpl.writeStr(txt, intString(i_zerocrossingIndex));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(",false);"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_1414;

public function zeroCrossingTpl2
  input Tpl.Text txt;
  input Integer a_index1;
  input DAE.Exp a_relation;
  input Tpl.Text a_varDecls;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  out_txt := fun_1414(txt, a_relation);
  out_a_varDecls := a_varDecls;
  out_a_extraFuncs := a_extraFuncs;
  out_a_extraFuncsDecl := a_extraFuncsDecl;
  out_a_extraFuncsNamespace := a_extraFuncsNamespace;
end zeroCrossingTpl2;

protected function lm_1416
  input Tpl.Text in_txt;
  input DAE.Dimensions in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      DAE.Dimensions rest;
      Integer i_i;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           DAE.DIM_INTEGER(integer = i_i) :: rest )
      equation
        txt = Tpl.writeStr(txt, intString(i_i));
        txt = Tpl.nextIter(txt);
        txt = lm_1416(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_1416(txt, rest);
      then txt;
  end match;
end lm_1416;

protected function lm_1417
  input Tpl.Text in_txt;
  input DAE.Dimensions in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      DAE.Dimensions rest;
      Integer i_i;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           DAE.DIM_INTEGER(integer = i_i) :: rest )
      equation
        txt = Tpl.writeStr(txt, intString(i_i));
        txt = Tpl.nextIter(txt);
        txt = lm_1417(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_1417(txt, rest);
      then txt;
  end match;
end lm_1417;

protected function fun_1418
  input Tpl.Text in_txt;
  input DAE.Exp in_a_lit;
  input Tpl.Text in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_lit, in_a_name)
    local
      Tpl.Text txt;
      Tpl.Text a_name;
      DAE.Exp i_lit;
      DAE.Type i_ty;
      DAE.Dimensions i_ty_dims;
      Tpl.Text txt_2;
      Integer ret_1;
      Integer ret_0;

    case ( txt,
           DAE.SCONST(string = _),
           a_name )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("string "));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           DAE.MATRIX(ty = (i_ty as DAE.T_ARRAY(dims = i_ty_dims))),
           a_name )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("StatArrayDim"));
        ret_0 = listLength(i_ty_dims);
        txt = Tpl.writeStr(txt, intString(ret_0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<"));
        txt = CodegenCppCommonOld.expTypeShort(txt, i_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_1416(txt, i_ty_dims);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" > "));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           DAE.ARRAY(ty = (i_ty as DAE.T_ARRAY(dims = i_ty_dims))),
           a_name )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("StatArrayDim"));
        ret_1 = listLength(i_ty_dims);
        txt = Tpl.writeStr(txt, intString(ret_1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<"));
        txt = CodegenCppCommonOld.expTypeShort(txt, i_ty);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(",")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_1417(txt, i_ty_dims);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" > "));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           DAE.BOX(exp = DAE.RCONST(real = _)),
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("double "));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           i_lit,
           _ )
      equation
        txt_2 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("literalExpConst failed: "));
        txt_2 = ExpressionDumpTpl.dumpExp(txt_2, i_lit, "\"");
        txt = CodegenCppCommonOld.error(txt, Tpl.sourceInfo("CodegenCppOld.tpl", 12075, 14), Tpl.textString(txt_2));
      then txt;
  end match;
end fun_1418;

public function literalExpConst
  input Tpl.Text txt;
  input DAE.Exp a_lit;
  input Integer a_index;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_meta;
  Tpl.Text l_tmp;
  Tpl.Text l_name;
algorithm
  l_name := Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("_OMC_LIT"));
  l_name := Tpl.writeStr(l_name, intString(a_index));
  l_tmp := Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("_OMC_LIT_STRUCT"));
  l_tmp := Tpl.writeStr(l_tmp, intString(a_index));
  l_meta := Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("static modelica_metatype const "));
  l_meta := Tpl.writeText(l_meta, l_name);
  out_txt := fun_1418(txt, a_lit, l_name);
end literalExpConst;

protected function fun_1420
  input Tpl.Text in_txt;
  input Boolean in_a_lit_bool;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_lit_bool)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("0"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("1"));
      then txt;
  end match;
end fun_1420;

public function literalExpConstArrayVal
  input Tpl.Text in_txt;
  input DAE.Exp in_a_lit;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_lit)
    local
      Tpl.Text txt;
      DAE.Exp i_lit;
      Integer i_lit_index;
      Integer i_index;
      Real i_real;
      Boolean i_lit_bool;
      Integer i_integer;
      Tpl.Text txt_0;

    case ( txt,
           DAE.ICONST(integer = i_integer) )
      equation
        txt = Tpl.writeStr(txt, intString(i_integer));
      then txt;

    case ( txt,
           DAE.BCONST(bool = i_lit_bool) )
      equation
        txt = fun_1420(txt, i_lit_bool);
      then txt;

    case ( txt,
           DAE.RCONST(real = i_real) )
      equation
        txt = Tpl.writeStr(txt, realString(i_real));
      then txt;

    case ( txt,
           DAE.ENUM_LITERAL(index = i_index) )
      equation
        txt = Tpl.writeStr(txt, intString(i_index));
      then txt;

    case ( txt,
           DAE.SHARED_LITERAL(index = i_lit_index) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_OMC_LIT"));
        txt = Tpl.writeStr(txt, intString(i_lit_index));
      then txt;

    case ( txt,
           i_lit )
      equation
        txt_0 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("literalExpConstArrayVal failed: "));
        txt_0 = ExpressionDumpTpl.dumpExp(txt_0, i_lit, "\"");
        txt = CodegenCppCommonOld.error(txt, Tpl.sourceInfo("CodegenCppOld.tpl", 12086, 14), Tpl.textString(txt_0));
      then txt;
  end match;
end literalExpConstArrayVal;

protected function lm_1422
  input Tpl.Text in_txt;
  input DAE.Dimensions in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      DAE.Dimensions rest;
      DAE.Dimension i_dim;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_dim :: rest )
      equation
        txt = CodegenCppCommonOld.dimension(txt, i_dim, SimCodeFunction.contextOther);
        txt = Tpl.nextIter(txt);
        txt = lm_1422(txt, rest);
      then txt;
  end match;
end lm_1422;

protected function lm_1423
  input Tpl.Text in_txt;
  input DAE.Dimensions in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      DAE.Dimensions rest;
      DAE.Dimension i_exp;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_exp :: rest )
      equation
        txt = CodegenCppCommonOld.dimension(txt, i_exp, SimCodeFunction.contextOther);
        txt = Tpl.nextIter(txt);
        txt = lm_1423(txt, rest);
      then txt;
  end match;
end lm_1423;

protected function lm_1424
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      DAE.Exp i_exp;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_exp :: rest )
      equation
        txt = literalExpConstArrayVal(txt, i_exp);
        txt = Tpl.nextIter(txt);
        txt = lm_1424(txt, rest);
      then txt;
  end match;
end lm_1424;

protected function fun_1425
  input Tpl.Text in_txt;
  input Integer in_mArg;
  input Tpl.Text in_a_data;
  input Tpl.Text in_a_name;
  input Tpl.Text in_a_arrayTypeStr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_data, in_a_name, in_a_arrayTypeStr)
    local
      Tpl.Text txt;
      Tpl.Text a_data;
      Tpl.Text a_name;
      Tpl.Text a_arrayTypeStr;

    case ( txt,
           0,
           _,
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_data,
           a_name,
           a_arrayTypeStr )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("//arrayflats\n"));
        txt = Tpl.writeText(txt, a_arrayTypeStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_data[] = {"));
        txt = Tpl.writeText(txt, a_data);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "};\n",
                                    "assignRowMajorData("
                                }, false));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_data, "));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;
  end match;
end fun_1425;

protected function lm_1426
  input Tpl.Text in_txt;
  input DAE.Dimensions in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      DAE.Dimensions rest;
      DAE.Dimension i_dim;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_dim :: rest )
      equation
        txt = CodegenCppCommonOld.dimension(txt, i_dim, SimCodeFunction.contextOther);
        txt = Tpl.nextIter(txt);
        txt = lm_1426(txt, rest);
      then txt;
  end match;
end lm_1426;

protected function lm_1427
  input Tpl.Text in_txt;
  input DAE.Dimensions in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      DAE.Dimensions rest;
      DAE.Dimension i_exp;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_exp :: rest )
      equation
        txt = CodegenCppCommonOld.dimension(txt, i_exp, SimCodeFunction.contextOther);
        txt = Tpl.nextIter(txt);
        txt = lm_1427(txt, rest);
      then txt;
  end match;
end lm_1427;

protected function lm_1428
  input Tpl.Text in_txt;
  input list<DAE.Exp> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<DAE.Exp> rest;
      DAE.Exp i_exp;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_exp :: rest )
      equation
        txt = literalExpConstArrayVal(txt, i_exp);
        txt = Tpl.nextIter(txt);
        txt = lm_1428(txt, rest);
      then txt;
  end match;
end lm_1428;

protected function fun_1429
  input Tpl.Text in_txt;
  input Integer in_mArg;
  input Tpl.Text in_a_data;
  input Tpl.Text in_a_name;
  input Tpl.Text in_a_arrayTypeStr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_data, in_a_name, in_a_arrayTypeStr)
    local
      Tpl.Text txt;
      Tpl.Text a_data;
      Tpl.Text a_name;
      Tpl.Text a_arrayTypeStr;

    case ( txt,
           0,
           _,
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_data,
           a_name,
           a_arrayTypeStr )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("//arrayflats\n"));
        txt = Tpl.writeText(txt, a_arrayTypeStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_data[] = {"));
        txt = Tpl.writeText(txt, a_data);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "};\n",
                                    "assignRowMajorData("
                                }, false));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_data, "));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;
  end match;
end fun_1429;

protected function fun_1430
  input Tpl.Text in_txt;
  input DAE.Exp in_a_lit;
  input Tpl.Text in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_lit, in_a_name)
    local
      Tpl.Text txt;
      Tpl.Text a_name;
      Real i_exp_real;
      DAE.Type i_ty;
      DAE.Dimensions i_ty_dims;
      DAE.Exp i_lit;
      String i_string;
      Tpl.Text txt_20;
      Integer ret_19;
      list<DAE.Exp> ret_18;
      list<DAE.Exp> ret_17;
      Integer ret_16;
      Integer ret_15;
      list<DAE.Exp> ret_14;
      Integer ret_13;
      list<DAE.Exp> ret_12;
      list<DAE.Exp> ret_11;
      Tpl.Text l_data;
      Tpl.Text l_instDimsInit;
      Tpl.Text l_dims;
      Tpl.Text l_arrayTypeStr;
      Integer ret_6;
      Tpl.Text l_ndim;
      Integer ret_4;
      list<DAE.Exp> ret_3;
      Tpl.Text l_size;
      String ret_1;
      Tpl.Text l_escstr;

    case ( txt,
           DAE.SCONST(string = i_string),
           a_name )
      equation
        ret_1 = Util.escapeModelicaStringToCString(i_string);
        l_escstr = Tpl.writeStr(Tpl.emptyTxt, ret_1);
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = \""));
        txt = Tpl.writeText(txt, l_escstr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\";"));
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           (i_lit as DAE.MATRIX(ty = (i_ty as DAE.T_ARRAY(dims = i_ty_dims)))),
           a_name )
      equation
        ret_3 = Expression.flattenArrayExpToList(i_lit);
        ret_4 = listLength(ret_3);
        l_size = Tpl.writeStr(Tpl.emptyTxt, intString(ret_4));
        ret_6 = listLength(i_ty_dims);
        l_ndim = Tpl.writeStr(Tpl.emptyTxt, intString(ret_6));
        l_arrayTypeStr = CodegenCppCommonOld.expTypeShort(Tpl.emptyTxt, i_ty);
        l_dims = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_dims = lm_1422(l_dims, i_ty_dims);
        l_dims = Tpl.popIter(l_dims);
        l_instDimsInit = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING("][")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_instDimsInit = lm_1423(l_instDimsInit, i_ty_dims);
        l_instDimsInit = Tpl.popIter(l_instDimsInit);
        ret_11 = Expression.flattenArrayExpToList(i_lit);
        l_data = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_data = lm_1424(l_data, ret_11);
        l_data = Tpl.popIter(l_data);
        ret_12 = Expression.flattenArrayExpToList(i_lit);
        ret_13 = listLength(ret_12);
        txt = fun_1425(txt, ret_13, l_data, a_name, l_arrayTypeStr);
      then txt;

    case ( txt,
           (i_lit as DAE.ARRAY(ty = (i_ty as DAE.T_ARRAY(dims = i_ty_dims)))),
           a_name )
      equation
        ret_14 = Expression.flattenArrayExpToList(i_lit);
        ret_15 = listLength(ret_14);
        l_size = Tpl.writeStr(Tpl.emptyTxt, intString(ret_15));
        ret_16 = listLength(i_ty_dims);
        l_ndim = Tpl.writeStr(Tpl.emptyTxt, intString(ret_16));
        l_arrayTypeStr = CodegenCppCommonOld.expTypeShort(Tpl.emptyTxt, i_ty);
        l_dims = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_dims = lm_1426(l_dims, i_ty_dims);
        l_dims = Tpl.popIter(l_dims);
        l_instDimsInit = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING("][")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_instDimsInit = lm_1427(l_instDimsInit, i_ty_dims);
        l_instDimsInit = Tpl.popIter(l_instDimsInit);
        ret_17 = Expression.flattenArrayExpToList(i_lit);
        l_data = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_data = lm_1428(l_data, ret_17);
        l_data = Tpl.popIter(l_data);
        ret_18 = Expression.flattenArrayExpToList(i_lit);
        ret_19 = listLength(ret_18);
        txt = fun_1429(txt, ret_19, l_data, a_name, l_arrayTypeStr);
      then txt;

    case ( txt,
           DAE.BOX(exp = DAE.RCONST(real = i_exp_real)),
           a_name )
      equation
        txt = Tpl.writeText(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeStr(txt, realString(i_exp_real));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           i_lit,
           _ )
      equation
        txt_20 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("literalExpConst failed: "));
        txt_20 = ExpressionDumpTpl.dumpExp(txt_20, i_lit, "\"");
        txt = CodegenCppCommonOld.error(txt, Tpl.sourceInfo("CodegenCppOld.tpl", 12129, 14), Tpl.textString(txt_20));
      then txt;
  end match;
end fun_1430;

public function literalExpConstImpl
  input Tpl.Text txt;
  input DAE.Exp a_lit;
  input Integer a_index;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_meta;
  Tpl.Text l_tmp;
  Tpl.Text l_name;
algorithm
  l_name := Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("_OMC_LIT"));
  l_name := Tpl.writeStr(l_name, intString(a_index));
  l_tmp := Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("_OMC_LIT_STRUCT"));
  l_tmp := Tpl.writeStr(l_tmp, intString(a_index));
  l_meta := Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("static modelica_metatype const "));
  l_meta := Tpl.writeText(l_meta, l_name);
  out_txt := fun_1430(txt, a_lit, l_name);
end literalExpConstImpl;

protected function fun_1432
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;

    case ( txt,
           SimCode.SIMCODE(modelInfo = _) )
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_1432;

public function handleEvent
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  out_txt := fun_1432(txt, a_simCode);
  out_a_extraFuncs := a_extraFuncs;
  out_a_extraFuncsDecl := a_extraFuncsDecl;
  out_a_extraFuncsNamespace := a_extraFuncsNamespace;
end handleEvent;

protected function fun_1434
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      Absyn.Path i_modelInfo_name;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = i_modelInfo_name)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("bool "));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::checkConditions()\n",
                                    "{\n",
                                    "  _callType = IContinuous::DISCRETE;\n",
                                    "   return _event_handling->checkConditions(0,true);\n",
                                    "  _callType = IContinuous::CONTINUOUS;\n",
                                    "}"
                                }, false));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_1434;

public function checkConditions
  input Tpl.Text txt;
  input list<BackendDAE.ZeroCrossing> a_zeroCrossings;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
protected
  Tpl.Text l_zeroCrossingsCode;
  Tpl.Text l_varDecls;
algorithm
  l_varDecls := Tpl.emptyTxt;
  (l_zeroCrossingsCode, l_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) := checkConditions1(Tpl.emptyTxt, a_zeroCrossings, l_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
  out_txt := fun_1434(txt, a_simCode);
end checkConditions;

protected function fun_1436
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      Absyn.Path i_modelInfo_name;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = i_modelInfo_name)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("bool "));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::getCondition(unsigned int index)\n",
                                    "{\n",
                                    "  return false;\n",
                                    "}"
                                }, false));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_1436;

protected function fun_1437
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_zeroCrossingsCode;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode, in_a_zeroCrossingsCode, in_a_varDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_zeroCrossingsCode;
      Tpl.Text a_varDecls;
      Absyn.Path i_modelInfo_name;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = i_modelInfo_name)),
           a_zeroCrossingsCode,
           a_varDecls )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("bool "));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::getCondition(unsigned int index)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_varDecls);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "switch(index)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_zeroCrossingsCode);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "default:\n",
                                    "{\n",
                                    "  string error = string(\"Wrong condition index \") + to_string(index);\n",
                                    "  throw ModelicaSimulationError(EVENT_HANDLING, error);\n",
                                    "}\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("};\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_1437;

protected function fun_1438
  input Tpl.Text in_txt;
  input list<BackendDAE.ZeroCrossing> in_a_zeroCrossings;
  input Tpl.Text in_a_zeroCrossingsCode;
  input Tpl.Text in_a_varDecls;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_zeroCrossings, in_a_zeroCrossingsCode, in_a_varDecls, in_a_simCode)
    local
      Tpl.Text txt;
      Tpl.Text a_zeroCrossingsCode;
      Tpl.Text a_varDecls;
      SimCode.SimCode a_simCode;

    case ( txt,
           {},
           _,
           _,
           a_simCode )
      equation
        txt = fun_1436(txt, a_simCode);
      then txt;

    case ( txt,
           _,
           a_zeroCrossingsCode,
           a_varDecls,
           a_simCode )
      equation
        txt = fun_1437(txt, a_simCode, a_zeroCrossingsCode, a_varDecls);
      then txt;
  end match;
end fun_1438;

public function getCondition
  input Tpl.Text txt;
  input list<BackendDAE.ZeroCrossing> a_zeroCrossings;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
protected
  Tpl.Text l_zeroCrossingsCode;
  Tpl.Text l_varDecls;
algorithm
  l_varDecls := Tpl.emptyTxt;
  (l_zeroCrossingsCode, l_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) := checkConditions1(Tpl.emptyTxt, a_zeroCrossings, l_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
  out_txt := fun_1438(txt, a_zeroCrossings, l_zeroCrossingsCode, l_varDecls, a_simCode);
end getCondition;

protected function lm_1440
  input Tpl.Text in_txt;
  input list<BackendDAE.ZeroCrossing> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls)
    local
      Tpl.Text txt;
      list<BackendDAE.ZeroCrossing> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Integer x_i0;
      DAE.Exp i_relation__;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           BackendDAE.ZERO_CROSSING(relation_ = i_relation__) :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = checkConditions2(txt, x_i0, i_relation__, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = lm_1440(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           _ :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls )
      equation
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = lm_1440(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);
  end match;
end lm_1440;

public function checkConditions1
  input Tpl.Text txt;
  input list<BackendDAE.ZeroCrossing> a_zeroCrossings;
  input Tpl.Text a_varDecls;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  out_txt := Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) := lm_1440(out_txt, a_zeroCrossings, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls);
  out_txt := Tpl.popIter(out_txt);
end checkConditions1;

protected function fun_1442
  input Tpl.Text in_txt;
  input DAE.Exp in_a_relation;
  input Tpl.Text in_a_varDecls;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_relation, in_a_varDecls, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      Tpl.Text a_varDecls;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      Integer i_zerocrossingIndex;
      DAE.Exp i_exp2;
      DAE.Operator i_operator;
      DAE.Exp i_exp1;
      Tpl.Text l_res;
      Tpl.Text l_e2;
      Tpl.Text l_op;
      Tpl.Text l_e1;
      Tpl.Text l_preExp;

    case ( txt,
           DAE.RELATION(index = i_zerocrossingIndex, exp1 = i_exp1, operator = i_operator, exp2 = i_exp2),
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_e1, l_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.daeExp(Tpl.emptyTxt, i_exp1, SimCodeFunction.contextOther, l_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        l_op = zeroCrossingOpFunc(Tpl.emptyTxt, i_operator);
        (l_e2, l_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.daeExp(Tpl.emptyTxt, i_exp2, SimCodeFunction.contextOther, l_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        (l_res, a_varDecls) = CodegenCppCommonOld.tempDecl(Tpl.emptyTxt, "bool", a_varDecls);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("case "));
        txt = Tpl.writeStr(txt, intString(i_zerocrossingIndex));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ":\n",
                                    "{\n",
                                    "   if(_callType & IContinuous::DISCRETE)\n",
                                    "   {\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(7));
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_res);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("=("));
        txt = Tpl.writeText(txt, l_e1);
        txt = Tpl.writeText(txt, l_op);
        txt = Tpl.writeText(txt, l_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ");\n",
                                    "_conditions["
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_zerocrossingIndex));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("]="));
        txt = Tpl.writeText(txt, l_res);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "return "
                                }, false));
        txt = Tpl.writeText(txt, l_res);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "   }\n",
                                    "   else\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(7));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("return _conditions["));
        txt = Tpl.writeStr(txt, intString(i_zerocrossingIndex));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("];\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end fun_1442;

public function checkConditions2
  input Tpl.Text txt;
  input Integer a_index1;
  input DAE.Exp a_relation;
  input Tpl.Text a_varDecls;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) := fun_1442(txt, a_relation, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
end checkConditions2;

protected function fun_1444
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      Absyn.Path i_modelInfo_name;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = i_modelInfo_name)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("bool "));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Mixed::handleSystemEvents(bool* events)\n",
                                    "{\n",
                                    "  _callType = IContinuous::DISCRETE;\n",
                                    "\n",
                                    "  bool restart = true;\n",
                                    "  bool state_vars_reinitialized = false;\n",
                                    "  bool clock_event_detected = false;\n",
                                    "\n",
                                    "  int iter = 0;\n",
                                    "  while(restart && !(iter++ > 100))\n",
                                    "  {\n",
                                    "      bool st_vars_reinit = false;\n",
                                    "      //iterate and handle all events inside the eventqueue\n",
                                    "      restart = _event_handling->startEventIteration(st_vars_reinit);\n",
                                    "      state_vars_reinitialized = state_vars_reinitialized || st_vars_reinit;\n",
                                    "\n",
                                    "      saveAll();\n",
                                    "  }\n",
                                    "\n",
                                    "  if (iter > 100 && restart) {\n",
                                    "    string error = string(\"Number of event iteration steps exceeded at time: \") + to_string(_simTime);\n",
                                    "    throw ModelicaSimulationError(EVENT_HANDLING, error);\n",
                                    "  }\n",
                                    "  _callType = IContinuous::CONTINUOUS;\n",
                                    "\n",
                                    "  return state_vars_reinitialized;\n",
                                    "}"
                                }, false));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_1444;

public function handleSystemEvents
  input Tpl.Text txt;
  input list<BackendDAE.ZeroCrossing> a_zeroCrossings;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  out_txt := fun_1444(txt, a_simCode);
  out_a_extraFuncs := a_extraFuncs;
  out_a_extraFuncsDecl := a_extraFuncsDecl;
  out_a_extraFuncsNamespace := a_extraFuncsNamespace;
end handleSystemEvents;

public function zeroCrossingOpFunc
  input Tpl.Text in_txt;
  input DAE.Operator in_a_op;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_op)
    local
      Tpl.Text txt;

    case ( txt,
           DAE.LESS(ty = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<"));
      then txt;

    case ( txt,
           DAE.GREATER(ty = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(">"));
      then txt;

    case ( txt,
           DAE.LESSEQ(ty = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("<="));
      then txt;

    case ( txt,
           DAE.GREATEREQ(ty = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(">="));
      then txt;

    case ( txt,
           DAE.EQUAL(ty = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("=="));
      then txt;

    case ( txt,
           DAE.NEQUAL(ty = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("!="));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end zeroCrossingOpFunc;

protected function fun_1447
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_zeroCrossingsCode;
  input Tpl.Text in_a_prexp;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode, in_a_zeroCrossingsCode, in_a_prexp, in_a_varDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_zeroCrossingsCode;
      Tpl.Text a_prexp;
      Tpl.Text a_varDecls;
      Absyn.Path i_modelInfo_name;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = i_modelInfo_name)),
           a_zeroCrossingsCode,
           a_prexp,
           a_varDecls )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::getZeroFunc(double* f)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_varDecls);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, a_prexp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, a_zeroCrossingsCode);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;

    case ( txt,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_1447;

public function giveZeroFunc1
  input Tpl.Text txt;
  input list<BackendDAE.ZeroCrossing> a_zeroCrossings;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
protected
  Tpl.Text l_zeroCrossingsCode;
  Tpl.Text l_prexp;
  Tpl.Text l_varDecls;
algorithm
  l_varDecls := Tpl.emptyTxt;
  l_prexp := Tpl.emptyTxt;
  (l_zeroCrossingsCode, l_varDecls, l_prexp, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) := giveZeroFunc2(Tpl.emptyTxt, a_zeroCrossings, l_varDecls, l_prexp, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
  out_txt := fun_1447(txt, a_simCode, l_zeroCrossingsCode, l_prexp, l_varDecls);
end giveZeroFunc1;

protected function fun_1449
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      Absyn.Path i_modelInfo_name;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = i_modelInfo_name)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::setConditions(bool* c)\n",
                                    "{\n",
                                    "  SystemDefaultImplementation::setConditions(c);\n",
                                    "}"
                                }, false));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_1449;

public function setConditions
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  out_txt := fun_1449(txt, a_simCode);
  out_a_extraFuncs := a_extraFuncs;
  out_a_extraFuncsDecl := a_extraFuncsDecl;
  out_a_extraFuncsNamespace := a_extraFuncsNamespace;
end setConditions;

protected function fun_1451
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      Absyn.Path i_modelInfo_name;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = i_modelInfo_name)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::getConditions(bool* c)\n",
                                    "{\n",
                                    "    SystemDefaultImplementation::getConditions(c);\n",
                                    "}\n",
                                    "void "
                                }, false));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::getClockConditions(bool* c)\n",
                                    "{\n",
                                    "    SystemDefaultImplementation::getClockConditions(c);\n",
                                    "}"
                                }, false));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_1451;

public function getConditions
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  out_txt := fun_1451(txt, a_simCode);
  out_a_extraFuncs := a_extraFuncs;
  out_a_extraFuncsDecl := a_extraFuncsDecl;
  out_a_extraFuncsNamespace := a_extraFuncsNamespace;
end getConditions;

protected function fun_1453
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      Absyn.Path i_modelInfo_name;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = i_modelInfo_name)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("bool "));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::isConsistent()\n",
                                    "{\n",
                                    "  return SystemDefaultImplementation::isConsistent();\n",
                                    "}"
                                }, false));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_1453;

public function isConsistent
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  out_txt := fun_1453(txt, a_simCode);
  out_a_extraFuncs := a_extraFuncs;
  out_a_extraFuncsDecl := a_extraFuncsDecl;
  out_a_extraFuncsNamespace := a_extraFuncsNamespace;
end isConsistent;

protected function fun_1455
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      Absyn.Path i_modelInfo_name;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = i_modelInfo_name)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::saveConditions()\n",
                                    "{\n",
                                    "  SystemDefaultImplementation::saveConditions();\n",
                                    "}"
                                }, false));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_1455;

public function saveConditions
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  out_txt := fun_1455(txt, a_simCode);
  out_a_extraFuncs := a_extraFuncs;
  out_a_extraFuncsDecl := a_extraFuncsDecl;
  out_a_extraFuncsNamespace := a_extraFuncsNamespace;
end saveConditions;

protected function lm_1457
  input Tpl.Text in_txt;
  input list<BackendDAE.ZeroCrossing> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_preExp, out_a_varDecls) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_preExp, in_a_varDecls)
    local
      Tpl.Text txt;
      list<BackendDAE.ZeroCrossing> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Integer x_i0;
      DAE.Exp i_relation__;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_preExp,
           a_varDecls )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_preExp, a_varDecls);

    case ( txt,
           BackendDAE.ZERO_CROSSING(relation_ = i_relation__) :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_preExp,
           a_varDecls )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        (txt, a_varDecls, a_preExp, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = giveZeroFunc3(txt, x_i0, i_relation__, a_varDecls, a_preExp, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_preExp, a_varDecls) = lm_1457(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_preExp, a_varDecls);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_preExp, a_varDecls);

    case ( txt,
           _ :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_preExp,
           a_varDecls )
      equation
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_preExp, a_varDecls) = lm_1457(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_preExp, a_varDecls);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_preExp, a_varDecls);
  end match;
end lm_1457;

public function giveZeroFunc2
  input Tpl.Text txt;
  input list<BackendDAE.ZeroCrossing> a_zeroCrossings;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_preExp;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  out_txt := Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_preExp, out_a_varDecls) := lm_1457(out_txt, a_zeroCrossings, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_preExp, a_varDecls);
  out_txt := Tpl.popIter(out_txt);
end giveZeroFunc2;

protected function fun_1459
  input Tpl.Text in_txt;
  input DAE.Operator in_a_rel_operator;
  input DAE.Exp in_a_rel;
  input Tpl.Text in_a_e2;
  input Tpl.Text in_a_e1;
  input Integer in_a_index1;
  input Integer in_a_zerocrossingIndex;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_rel_operator, in_a_rel, in_a_e2, in_a_e1, in_a_index1, in_a_zerocrossingIndex)
    local
      Tpl.Text txt;
      DAE.Exp a_rel;
      Tpl.Text a_e2;
      Tpl.Text a_e1;
      Integer a_index1;
      Integer a_zerocrossingIndex;

    case ( txt,
           DAE.LESS(ty = _),
           _,
           a_e2,
           a_e1,
           a_index1,
           a_zerocrossingIndex )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if(_conditions["));
        txt = Tpl.writeStr(txt, intString(a_zerocrossingIndex));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("])\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("f["));
        txt = Tpl.writeStr(txt, intString(a_index1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("]=("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" - 1e-6 - "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(");\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("else\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("f["));
        txt = Tpl.writeStr(txt, intString(a_index1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("]=("));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" - "));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" -  1e-6);"));
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           DAE.LESSEQ(ty = _),
           _,
           a_e2,
           a_e1,
           a_index1,
           a_zerocrossingIndex )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if(_conditions["));
        txt = Tpl.writeStr(txt, intString(a_zerocrossingIndex));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("])\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("f["));
        txt = Tpl.writeStr(txt, intString(a_index1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = ("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" - 1e-6 - "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(");\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("else\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("f["));
        txt = Tpl.writeStr(txt, intString(a_index1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = ("));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" - "));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" - 1e-6);"));
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           DAE.GREATER(ty = _),
           _,
           a_e2,
           a_e1,
           a_index1,
           a_zerocrossingIndex )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if(_conditions["));
        txt = Tpl.writeStr(txt, intString(a_zerocrossingIndex));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("])\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("f["));
        txt = Tpl.writeStr(txt, intString(a_index1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = ("));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" - "));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" - 1e-6);\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("else\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("f["));
        txt = Tpl.writeStr(txt, intString(a_index1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = ("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" - 1e-6 - "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           DAE.GREATEREQ(ty = _),
           _,
           a_e2,
           a_e1,
           a_index1,
           a_zerocrossingIndex )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if(_conditions["));
        txt = Tpl.writeStr(txt, intString(a_zerocrossingIndex));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("])\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("f["));
        txt = Tpl.writeStr(txt, intString(a_index1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = ("));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" - "));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" - 1e-6);\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("else\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("f["));
        txt = Tpl.writeStr(txt, intString(a_index1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = ("));
        txt = Tpl.writeText(txt, a_e1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" - 1e-6 - "));
        txt = Tpl.writeText(txt, a_e2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           _,
           a_rel,
           _,
           _,
           a_index1,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("f["));
        txt = Tpl.writeStr(txt, intString(a_index1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "] = -1;\n",
                                    "/*error(sourceInfo(), \'Unknown relation: "
                                }, false));
        txt = ExpressionDumpTpl.dumpExp(txt, a_rel, "\"");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" for "));
        txt = Tpl.writeStr(txt, intString(a_index1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\')*/"));
      then txt;
  end match;
end fun_1459;

protected function fun_1460
  input Tpl.Text in_txt;
  input DAE.Exp in_a_relation;
  input Integer in_a_index1;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_varDecls, out_a_preExp, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_relation, in_a_index1, in_a_varDecls, in_a_preExp, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      Integer a_index1;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      DAE.Exp i_rel;
      Integer i_zerocrossingIndex;
      DAE.Operator i_rel_operator;
      DAE.Exp i_exp2;
      DAE.Exp i_exp1;
      Tpl.Text txt_2;
      Tpl.Text l_e2;
      Tpl.Text l_e1;

    case ( txt,
           (i_rel as DAE.RELATION(index = i_zerocrossingIndex, exp1 = i_exp1, exp2 = i_exp2, operator = i_rel_operator)),
           a_index1,
           a_varDecls,
           a_preExp,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (l_e1, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.daeExp(Tpl.emptyTxt, i_exp1, SimCodeFunction.contextOther, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        (l_e2, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.daeExp(Tpl.emptyTxt, i_exp2, SimCodeFunction.contextOther, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = fun_1459(txt, i_rel_operator, i_rel, l_e2, l_e1, a_index1, i_zerocrossingIndex);
      then (txt, a_varDecls, a_preExp, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "sample"), expLst = {_, _, _}),
           a_index1,
           a_varDecls,
           a_preExp,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("//sample for "));
        txt = Tpl.writeStr(txt, intString(a_index1));
      then (txt, a_varDecls, a_preExp, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           a_index1,
           a_varDecls,
           a_preExp,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      equation
        txt_2 = Tpl.pushBlock(Tpl.emptyTxt, Tpl.BT_INDENT(1));
        txt_2 = Tpl.writeTok(txt_2, Tpl.ST_STRING("UNKNOWN ZERO CROSSING for "));
        txt_2 = Tpl.writeStr(txt_2, intString(a_index1));
        txt_2 = Tpl.writeTok(txt_2, Tpl.ST_STRING(" "));
        txt_2 = Tpl.popBlock(txt_2);
        txt = CodegenCppCommonOld.error(txt, Tpl.sourceInfo("CodegenCppOld.tpl", 12401, 11), Tpl.textString(txt_2));
      then (txt, a_varDecls, a_preExp, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end fun_1460;

public function giveZeroFunc3
  input Tpl.Text txt;
  input Integer a_index1;
  input DAE.Exp a_relation;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_preExp;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_varDecls, out_a_preExp, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) := fun_1460(txt, a_relation, a_index1, a_varDecls, a_preExp, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
end giveZeroFunc3;

protected function lm_1462
  input Tpl.Text in_txt;
  input list<BackendDAE.ZeroCrossing> in_items;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      list<BackendDAE.ZeroCrossing> rest;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Integer x_i0;
      DAE.Exp i_relation__;

    case ( txt,
           {},
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           BackendDAE.ZERO_CROSSING(relation_ = i_relation__) :: rest,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = conditionvarZero1(txt, x_i0, i_relation__, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
        txt = Tpl.nextIter(txt);
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1462(txt, rest, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _ :: rest,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1462(txt, rest, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_1462;

public function conditionvarZero
  input Tpl.Text txt;
  input list<BackendDAE.ZeroCrossing> a_zeroCrossings;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  out_txt := Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) := lm_1462(out_txt, a_zeroCrossings, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
  out_txt := Tpl.popIter(out_txt);
end conditionvarZero;

protected function fun_1464
  input Tpl.Text in_txt;
  input DAE.Exp in_a_relation;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_relation)
    local
      Tpl.Text txt;
      Integer i_zerocrossingIndex;

    case ( txt,
           DAE.RELATION(index = i_zerocrossingIndex) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("bool _condition"));
        txt = Tpl.writeStr(txt, intString(i_zerocrossingIndex));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_1464;

public function conditionvarZero1
  input Tpl.Text txt;
  input Integer a_index1;
  input DAE.Exp a_relation;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  out_txt := fun_1464(txt, a_relation);
  out_a_extraFuncs := a_extraFuncs;
  out_a_extraFuncsDecl := a_extraFuncsDecl;
  out_a_extraFuncsNamespace := a_extraFuncsNamespace;
end conditionvarZero1;

protected function lm_1466
  input Tpl.Text in_txt;
  input list<BackendDAE.ZeroCrossing> in_items;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      list<BackendDAE.ZeroCrossing> rest;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Integer x_i0;
      DAE.Exp i_relation__;

    case ( txt,
           {},
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           BackendDAE.ZERO_CROSSING(relation_ = i_relation__) :: rest,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = saveconditionvar1(txt, x_i0, i_relation__, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
        txt = Tpl.nextIter(txt);
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1466(txt, rest, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _ :: rest,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1466(txt, rest, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_1466;

public function saveconditionvar
  input Tpl.Text txt;
  input list<BackendDAE.ZeroCrossing> a_zeroCrossings;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  out_txt := Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) := lm_1466(out_txt, a_zeroCrossings, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
  out_txt := Tpl.popIter(out_txt);
end saveconditionvar;

protected function fun_1468
  input Tpl.Text in_txt;
  input DAE.Exp in_a_relation;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_relation)
    local
      Tpl.Text txt;
      Integer i_zerocrossingIndex;

    case ( txt,
           DAE.RELATION(index = i_zerocrossingIndex) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_discrete_events->save(_condition"));
        txt = Tpl.writeStr(txt, intString(i_zerocrossingIndex));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(",_condition"));
        txt = Tpl.writeStr(txt, intString(i_zerocrossingIndex));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_1468;

public function saveconditionvar1
  input Tpl.Text txt;
  input Integer a_index1;
  input DAE.Exp a_relation;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  out_txt := fun_1468(txt, a_relation);
  out_a_extraFuncs := a_extraFuncs;
  out_a_extraFuncsDecl := a_extraFuncsDecl;
  out_a_extraFuncsNamespace := a_extraFuncsNamespace;
end saveconditionvar1;

protected function fun_1470
  input Tpl.Text in_txt;
  input DAE.Exp in_a_relation;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_relation)
    local
      Tpl.Text txt;
      Integer i_index;
      Integer ret_1;
      Tpl.Text l_preExp;

    case ( txt,
           DAE.CALL(path = Absyn.IDENT(name = "sample"), expLst = {DAE.ICONST(integer = i_index), _, _}) )
      equation
        l_preExp = Tpl.emptyTxt;
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("bool _condition"));
        ret_1 = intSub(i_index, 1);
        txt = Tpl.writeStr(txt, intString(ret_1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_1470;

public function conditionvarSample1
  input Tpl.Text txt;
  input Integer a_index1;
  input DAE.Exp a_relation;
  input Tpl.Text a_varDecls;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  out_txt := fun_1470(txt, a_relation);
  out_a_varDecls := a_varDecls;
  out_a_extraFuncs := a_extraFuncs;
  out_a_extraFuncsDecl := a_extraFuncsDecl;
  out_a_extraFuncsNamespace := a_extraFuncsNamespace;
end conditionvarSample1;

public function conditionvariable
  input Tpl.Text txt;
  input list<BackendDAE.ZeroCrossing> a_zeroCrossings;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
protected
  Tpl.Text l_conditionvariable;
algorithm
  (l_conditionvariable, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace) := conditionvarZero(Tpl.emptyTxt, a_zeroCrossings, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
  out_txt := txt;
end conditionvariable;

protected function fun_1473
  input Tpl.Text in_txt;
  input DAE.ComponentRef in_a_var;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_var, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      DAE.ComponentRef i_var;

    case ( txt,
           (i_var as DAE.CREF_QUAL(ident = _)),
           a_useFlatArrayNotation )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if (_discrete_events->changeDiscreteVar("));
        txt = CodegenCppCommonOld.cref(txt, i_var, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")) {  return true; }"));
      then txt;

    case ( txt,
           (i_var as DAE.CREF_IDENT(ident = _)),
           a_useFlatArrayNotation )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if (_discrete_events->changeDiscreteVar("));
        txt = CodegenCppCommonOld.cref(txt, i_var, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")) {  return true; }"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_1473;

protected function lm_1474
  input Tpl.Text in_txt;
  input list<DAE.ComponentRef> in_items;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      list<DAE.ComponentRef> rest;
      Boolean a_useFlatArrayNotation;
      DAE.ComponentRef i_var;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_useFlatArrayNotation )
      equation
        txt = fun_1473(txt, i_var, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        txt = lm_1474(txt, rest, a_useFlatArrayNotation);
      then txt;
  end match;
end lm_1474;

protected function fun_1475
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_changediscreteVars;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode, in_a_changediscreteVars, in_a_preExp, in_a_varDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_changediscreteVars;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Absyn.Path i_modelInfo_name;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = i_modelInfo_name)),
           a_changediscreteVars,
           a_preExp,
           a_varDecls )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("bool "));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::checkForDiscreteEvents()\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, a_varDecls);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, a_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, a_changediscreteVars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("return false;\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;

    case ( txt,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_1475;

public function checkForDiscreteEvents
  input Tpl.Text txt;
  input list<DAE.ComponentRef> a_discreteModelVars;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
protected
  Tpl.Text l_changediscreteVars;
  Tpl.Text l_varDecls;
  Tpl.Text l_preExp;
algorithm
  l_preExp := Tpl.emptyTxt;
  l_varDecls := Tpl.emptyTxt;
  l_changediscreteVars := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  l_changediscreteVars := lm_1474(l_changediscreteVars, a_discreteModelVars, a_useFlatArrayNotation);
  l_changediscreteVars := Tpl.popIter(l_changediscreteVars);
  out_txt := fun_1475(txt, a_simCode, l_changediscreteVars, l_preExp, l_varDecls);
  out_a_extraFuncs := a_extraFuncs;
  out_a_extraFuncsDecl := a_extraFuncsDecl;
  out_a_extraFuncsNamespace := a_extraFuncsNamespace;
  out_a_stateDerVectorName := a_stateDerVectorName;
end checkForDiscreteEvents;

protected function lm_1477
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input Boolean in_a_enableMeasureTime;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_enableMeasureTime, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_context)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      Boolean a_enableMeasureTime;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      SimCodeFunction.Context a_context;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           {},
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           i_eq :: rest,
           a_enableMeasureTime,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_context )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, _, _, a_stateDerVectorName) = equation_function_create_single_func(txt, i_eq, a_context, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, Tpl.strTokText(Tpl.ST_STRING("evaluate")), Tpl.strTokText(Tpl.ST_STRING("")), a_stateDerVectorName, a_useFlatArrayNotation, a_enableMeasureTime, false, false, "");
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1477(txt, rest, a_enableMeasureTime, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_context);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_1477;

public function equationFunctions
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_allEquationsPlusWhen;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;
  input Boolean a_enableMeasureTime;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
protected
  Tpl.Text l_equation__func__calls;
algorithm
  l_equation__func__calls := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (l_equation__func__calls, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) := lm_1477(l_equation__func__calls, a_allEquationsPlusWhen, a_enableMeasureTime, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_context);
  l_equation__func__calls := Tpl.popIter(l_equation__func__calls);
  out_txt := Tpl.writeText(txt, l_equation__func__calls);
end equationFunctions;

protected function fun_1479
  input Tpl.Text in_txt;
  input SimCode.SubPartition in_a_subPartition;
  input Boolean in_a_enableMeasureTime;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Integer in_a_i;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_a_subPartition, in_a_enableMeasureTime, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_i)
    local
      Tpl.Text txt;
      Boolean a_enableMeasureTime;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Integer a_i;
      list<SimCode.SimEqSystem> i_removedEquations;
      list<SimCode.SimEqSystem> i_equations;
      list<tuple<SimCodeVar.SimVar, Boolean>> i_vars;
      list<SimCode.SimEqSystem> ret_0;

    case ( txt,
           SimCode.SUBPARTITION(vars = i_vars, equations = i_equations, removedEquations = i_removedEquations),
           a_enableMeasureTime,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_i )
      equation
        ret_0 = listAppend(i_equations, i_removedEquations);
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = clockedPartFunctions(txt, a_i, i_vars, ret_0, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, SimCodeFunction.contextSimulationDiscrete, a_stateDerVectorName, a_useFlatArrayNotation, a_enableMeasureTime);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_1479;

protected function lm_1480
  input Tpl.Text in_txt;
  input list<SimCode.SubPartition> in_items;
  input Boolean in_a_enableMeasureTime;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_enableMeasureTime, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCode.SubPartition> rest;
      Boolean a_enableMeasureTime;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Integer x_i;
      SimCode.SubPartition i_subPartition;

    case ( txt,
           {},
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           i_subPartition :: rest,
           a_enableMeasureTime,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        x_i = Tpl.getIteri_i0(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_1479(txt, i_subPartition, a_enableMeasureTime, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, x_i);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1480(txt, rest, a_enableMeasureTime, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_1480;

protected function lm_1481
  input Tpl.Text in_txt;
  input list<SimCode.SubPartition> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.SubPartition> rest;
      Integer x_i;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           _ :: rest )
      equation
        x_i = Tpl.getIteri_i0(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("case "));
        txt = Tpl.writeStr(txt, intString(x_i));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(":\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("evaluateClocked"));
        txt = Tpl.writeStr(txt, intString(x_i));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(IContinuous::UNDEF_UPDATE);\n",
                                    "break;"
                                }, false));
        txt = Tpl.popBlock(txt);
        txt = Tpl.nextIter(txt);
        txt = lm_1481(txt, rest);
      then txt;
  end match;
end lm_1481;

public function clockedFunctions
  input Tpl.Text txt;
  input list<SimCode.SubPartition> a_subPartitions;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;
  input Boolean a_enableMeasureTime;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
protected
  Tpl.Text l_cases;
  Tpl.Text l_parts;
  Tpl.Text l_className;
algorithm
  (l_className, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace) := lastIdentOfPathFromSimCode(Tpl.emptyTxt, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
  l_parts := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(1, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (l_parts, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) := lm_1480(l_parts, a_subPartitions, a_enableMeasureTime, a_useFlatArrayNotation, a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, a_simCode);
  l_parts := Tpl.popIter(l_parts);
  l_cases := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(1, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  l_cases := lm_1481(l_cases, a_subPartitions);
  l_cases := Tpl.popIter(l_cases);
  out_txt := Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
  out_txt := Tpl.writeText(out_txt, l_parts);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "/* Clocked synchronous equations */\n",
                                       "void "
                                   }, false));
  out_txt := Tpl.writeText(out_txt, l_className);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "::evaluateClocked(int index)\n",
                                       "{\n",
                                       "  switch (index) {\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(4));
  out_txt := Tpl.writeText(out_txt, l_cases);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "default:\n",
                                       "  throw ModelicaSimulationError(MODEL_EQ_SYSTEM, \"Unknown partition\");\n",
                                       "  break;\n"
                                   }, true));
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "  }\n",
                                       "}"
                                   }, false));
end clockedFunctions;

protected function lm_1483
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input Integer in_a_i;
  input Boolean in_a_enableMeasureTime;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_i, in_a_enableMeasureTime, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_context)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      Integer a_i;
      Boolean a_enableMeasureTime;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      SimCodeFunction.Context a_context;
      SimCode.SimEqSystem i_eq;
      Tpl.Text txt_0;

    case ( txt,
           {},
           _,
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           i_eq :: rest,
           a_i,
           a_enableMeasureTime,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_context )
      equation
        txt_0 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("const int clockIndex = "));
        txt_0 = Tpl.writeStr(txt_0, intString(a_i));
        txt_0 = Tpl.writeTok(txt_0, Tpl.ST_STRING(";"));
        txt_0 = Tpl.writeTok(txt_0, Tpl.ST_NEW_LINE());
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, _, _, a_stateDerVectorName) = equation_function_create_single_func(txt, i_eq, a_context, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, Tpl.strTokText(Tpl.ST_STRING("evaluate")), Tpl.strTokText(Tpl.ST_STRING("")), a_stateDerVectorName, a_useFlatArrayNotation, a_enableMeasureTime, false, false, Tpl.textString(txt_0));
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1483(txt, rest, a_i, a_enableMeasureTime, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_context);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_1483;

protected function lm_1484
  input Tpl.Text in_txt;
  input list<list<SimCode.SimEqSystem>> in_items;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_className;
  input Tpl.Text in_a_funcName;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_className, in_a_funcName, in_a_context)
    local
      Tpl.Text txt;
      list<list<SimCode.SimEqSystem>> rest;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_className;
      Tpl.Text a_funcName;
      SimCodeFunction.Context a_context;
      Integer x_i0;
      list<SimCode.SimEqSystem> i_eqs;

    case ( txt,
           {},
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _,
           _,
           _ )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           i_eqs :: rest,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_className,
           a_funcName,
           a_context )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = createEvaluateWithSplit(txt, x_i0, a_context, i_eqs, Tpl.textString(a_funcName), "evaluate", Tpl.textString(a_className), a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
        txt = Tpl.nextIter(txt);
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1484(txt, rest, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_className, a_funcName, a_context);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_1484;

public function clockedPartFunctions
  input Tpl.Text txt;
  input Integer a_i;
  input list<tuple<SimCodeVar.SimVar, Boolean>> a_vars;
  input list<SimCode.SimEqSystem> a_equations;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;
  input Boolean a_enableMeasureTime;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
protected
  Integer ret_6;
  Tpl.Text l_idx;
  list<list<SimCode.SimEqSystem>> ret_4;
  Tpl.Text l_funcCalls;
  Tpl.Text l_funcName;
  Tpl.Text l_funcs;
  Tpl.Text l_className;
algorithm
  (l_className, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace) := lastIdentOfPathFromSimCode(Tpl.emptyTxt, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
  l_funcs := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (l_funcs, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) := lm_1483(l_funcs, a_equations, a_i, a_enableMeasureTime, a_useFlatArrayNotation, a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, a_simCode, a_context);
  l_funcs := Tpl.popIter(l_funcs);
  l_funcName := Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("evaluateClocked"));
  l_funcName := Tpl.writeStr(l_funcName, intString(a_i));
  ret_4 := List.partition(a_equations, 100);
  l_funcCalls := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (l_funcCalls, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) := lm_1484(l_funcCalls, ret_4, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, a_simCode, l_className, l_funcName, a_context);
  l_funcCalls := Tpl.popIter(l_funcCalls);
  ret_6 := intAdd(a_i, -1);
  l_idx := Tpl.writeStr(Tpl.emptyTxt, intString(ret_6));
  out_txt := Tpl.writeText(txt, l_funcs);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "void "
                                   }, false));
  out_txt := Tpl.writeText(out_txt, l_className);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("::"));
  out_txt := Tpl.writeText(out_txt, l_funcName);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "(const UPDATETYPE command)\n",
                                       "{\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("if (_simTime > _clockTime["));
  out_txt := Tpl.writeText(out_txt, l_idx);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("]) {\n"));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("_clockStart["));
  out_txt := Tpl.writeText(out_txt, l_idx);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("] = false;\n"));
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("}\n"));
  out_txt := Tpl.writeText(out_txt, l_funcCalls);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("if (_simTime > _clockTime["));
  out_txt := Tpl.writeText(out_txt, l_idx);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("]) {\n"));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("_clockInterval["));
  out_txt := Tpl.writeText(out_txt, l_idx);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("] = _simTime - _clockTime["));
  out_txt := Tpl.writeText(out_txt, l_idx);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "];\n",
                                       "_clockTime["
                                   }, false));
  out_txt := Tpl.writeText(out_txt, l_idx);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("] = _simTime;\n"));
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("}\n"));
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("}"));
end clockedPartFunctions;

protected function lm_1486
  input Tpl.Text in_txt;
  input list<list<SimCode.SimEqSystem>> in_items;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_className;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_className, in_a_context)
    local
      Tpl.Text txt;
      list<list<SimCode.SimEqSystem>> rest;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_className;
      SimCodeFunction.Context a_context;
      Integer x_i0;
      list<SimCode.SimEqSystem> i_eqs;

    case ( txt,
           {},
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _,
           _ )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           i_eqs :: rest,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_className,
           a_context )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = createEvaluateWithSplit(txt, x_i0, a_context, i_eqs, "evaluateAll", "evaluate", Tpl.textString(a_className), a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
        txt = Tpl.nextIter(txt);
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1486(txt, rest, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_className, a_context);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_1486;

protected function fun_1487
  input Tpl.Text in_txt;
  input Boolean in_a_createMeasureTime;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_createMeasureTime)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = generateMeasureTimeStartCode(txt, "measuredFunctionStartValues", "evaluateAll", "MEASURETIME_MODELFUNCTIONS");
      then txt;
  end match;
end fun_1487;

protected function fun_1488
  input Tpl.Text in_txt;
  input Boolean in_a_createMeasureTime;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_createMeasureTime)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = generateMeasureTimeEndCode(txt, "measuredFunctionStartValues", "measuredFunctionEndValues", "(*measureTimeFunctionsArray)[1]", "evaluateAll", "MEASURETIME_MODELFUNCTIONS");
      then txt;
  end match;
end fun_1488;

protected function fun_1489
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input list<SimCode.SimEqSystem> in_a_allEquationsPlusWhen;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input SimCodeFunction.Context in_a_context;
  input Boolean in_a_createMeasureTime;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace) :=
  match(in_txt, in_a_simCode, in_a_allEquationsPlusWhen, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_context, in_a_createMeasureTime)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> a_allEquationsPlusWhen;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      SimCodeFunction.Context a_context;
      Boolean a_createMeasureTime;
      list<SimCode.ClockedPartition> i_clockedPartitions;
      SimCode.SimCode i_simCode;
      Tpl.Text txt_3;
      list<list<SimCode.SimEqSystem>> ret_2;
      Tpl.Text l_equation__all__func__calls;
      Tpl.Text l_className;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = _), clockedPartitions = i_clockedPartitions)),
           a_allEquationsPlusWhen,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_context,
           a_createMeasureTime )
      equation
        (l_className, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = lastIdentOfPathFromSimCode(Tpl.emptyTxt, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
        ret_2 = List.partition(a_allEquationsPlusWhen, 100);
        l_equation__all__func__calls = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_equation__all__func__calls, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1486(l_equation__all__func__calls, ret_2, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, i_simCode, l_className, a_context);
        l_equation__all__func__calls = Tpl.popIter(l_equation__all__func__calls);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("bool "));
        txt = Tpl.writeText(txt, l_className);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::evaluateAll(const UPDATETYPE command)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = fun_1487(txt, a_createMeasureTime);
        txt = Tpl.softNewLine(txt);
        txt_3 = CodegenCppCommonOld.timeEventLength(Tpl.emptyTxt, i_simCode);
        txt = createTimeConditionTreatments(txt, Tpl.textString(txt_3), i_clockedPartitions);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "// Evaluate Equations\n"
                                }, true));
        txt = Tpl.writeText(txt, l_equation__all__func__calls);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = fun_1488(txt, a_createMeasureTime);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "return _state_var_reinitialized;\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);

    case ( txt,
           _,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           _,
           _ )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
  end match;
end fun_1489;

public function createEvaluateAll
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_allEquationsPlusWhen;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;
  input Boolean a_createMeasureTime;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace) := fun_1489(txt, a_simCode, a_allEquationsPlusWhen, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_context, a_createMeasureTime);
  out_a_stateDerVectorName := a_stateDerVectorName;
end createEvaluateAll;

protected function lm_1491
  input Tpl.Text in_txt;
  input list<SimCode.ClockedPartition> in_items;
  input String in_a_numberOfTimeEvents;
  input list<SimCode.ClockedPartition> in_a_clockPartitions;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_numberOfTimeEvents, in_a_clockPartitions)
    local
      Tpl.Text txt;
      list<SimCode.ClockedPartition> rest;
      String a_numberOfTimeEvents;
      list<SimCode.ClockedPartition> a_clockPartitions;
      Integer x_i0;
      SimCode.ClockedPartition i_baseClock;
      Integer ret_1;
      Integer ret_0;

    case ( txt,
           {},
           _,
           _ )
      then txt;

    case ( txt,
           i_baseClock :: rest,
           a_numberOfTimeEvents,
           a_clockPartitions )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        ret_0 = intAdd(x_i0, 1);
        ret_1 = SimCodeUtil.absoluteClockIdxForBaseClock(ret_0, a_clockPartitions);
        txt = booleanSubClockActivation1(txt, ret_1, i_baseClock, a_numberOfTimeEvents);
        txt = Tpl.nextIter(txt);
        txt = lm_1491(txt, rest, a_numberOfTimeEvents, a_clockPartitions);
      then txt;
  end match;
end lm_1491;

public function createTimeConditionTreatments
  input Tpl.Text txt;
  input String a_numberOfTimeEvents;
  input list<SimCode.ClockedPartition> a_clockPartitions;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_booleanSubClocks;
algorithm
  l_booleanSubClocks := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  l_booleanSubClocks := lm_1491(l_booleanSubClocks, a_clockPartitions, a_numberOfTimeEvents, a_clockPartitions);
  l_booleanSubClocks := Tpl.popIter(l_booleanSubClocks);
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                   "// treatment of clocks in model as time events\n",
                                   "for (int i = "
                               }, false));
  out_txt := Tpl.writeStr(out_txt, a_numberOfTimeEvents);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "; i < _dimTimeEvent; i++) {\n",
                                       "  if (_time_conditions[i]) {\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(4));
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("evaluateClocked(i - "));
  out_txt := Tpl.writeStr(out_txt, a_numberOfTimeEvents);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE(" + 1);\n"));
  out_txt := Tpl.writeText(out_txt, l_booleanSubClocks);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "_time_conditions[i] = false; // reset clock after one evaluation\n",
                                       "_clockSubactive[i - "
                                   }, false));
  out_txt := Tpl.writeStr(out_txt, a_numberOfTimeEvents);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("] = false;\n"));
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "  }\n",
                                       "}"
                                   }, false));
end createTimeConditionTreatments;

protected function lm_1493
  input Tpl.Text in_txt;
  input list<SimCode.SubPartition> in_items;
  input String in_a_numberOfTimeEvents;
  input Integer in_a_absBaseClockIdx;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_numberOfTimeEvents, in_a_absBaseClockIdx)
    local
      Tpl.Text txt;
      list<SimCode.SubPartition> rest;
      String a_numberOfTimeEvents;
      Integer a_absBaseClockIdx;
      Integer x_i0;
      SimCode.SubPartition i_subClock;

    case ( txt,
           {},
           _,
           _ )
      then txt;

    case ( txt,
           i_subClock :: rest,
           a_numberOfTimeEvents,
           a_absBaseClockIdx )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = booleanSubClockActivation2(txt, a_absBaseClockIdx, x_i0, i_subClock, a_numberOfTimeEvents);
        txt = Tpl.nextIter(txt);
        txt = lm_1493(txt, rest, a_numberOfTimeEvents, a_absBaseClockIdx);
      then txt;
  end match;
end lm_1493;

protected function fun_1494
  input Tpl.Text in_txt;
  input SimCode.ClockedPartition in_a_baseClock;
  input Integer in_a_absBaseClockIdx;
  input String in_a_numberOfTimeEvents;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_baseClock, in_a_absBaseClockIdx, in_a_numberOfTimeEvents)
    local
      Tpl.Text txt;
      Integer a_absBaseClockIdx;
      String a_numberOfTimeEvents;
      list<SimCode.SubPartition> i_subPartitions;
      Tpl.Text l_subClocks;

    case ( txt,
           SimCode.CLOCKED_PARTITION(baseClock = DAE.BOOLEAN_CLOCK(condition = _), subPartitions = i_subPartitions),
           a_absBaseClockIdx,
           a_numberOfTimeEvents )
      equation
        l_subClocks = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_subClocks = lm_1493(l_subClocks, i_subPartitions, a_numberOfTimeEvents, a_absBaseClockIdx);
        l_subClocks = Tpl.popIter(l_subClocks);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("//the subclocks "));
        txt = Tpl.writeStr(txt, intString(a_absBaseClockIdx));
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_subClocks);
      then txt;

    case ( txt,
           _,
           a_absBaseClockIdx,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("//no subclock "));
        txt = Tpl.writeStr(txt, intString(a_absBaseClockIdx));
      then txt;
  end match;
end fun_1494;

public function booleanSubClockActivation1
  input Tpl.Text txt;
  input Integer a_absBaseClockIdx;
  input SimCode.ClockedPartition a_baseClock;
  input String a_numberOfTimeEvents;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_1494(txt, a_baseClock, a_absBaseClockIdx, a_numberOfTimeEvents);
end booleanSubClockActivation1;

protected function fun_1496
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_absClockIdx;
  input Integer in_a_subClockIdx;
  input String in_a_numberOfTimeEvents;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_absClockIdx, in_a_subClockIdx, in_a_numberOfTimeEvents)
    local
      Tpl.Text txt;
      Integer a_absClockIdx;
      Integer a_subClockIdx;
      String a_numberOfTimeEvents;
      Integer ret_1;
      Tpl.Text l_absSubClockIdx;

    case ( txt,
           false,
           _,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _,
           a_absClockIdx,
           a_subClockIdx,
           a_numberOfTimeEvents )
      equation
        ret_1 = intAdd(a_absClockIdx, a_subClockIdx);
        l_absSubClockIdx = Tpl.writeStr(Tpl.emptyTxt, intString(ret_1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("//activate boolean triggered subclock "));
        txt = Tpl.writeText(txt, l_absSubClockIdx);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" of the base sub-clock "));
        txt = Tpl.writeStr(txt, intString(a_absClockIdx));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " is triggered\n",
                                    "if (_time_conditions["
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_absClockIdx));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" -1+"));
        txt = Tpl.writeStr(txt, a_numberOfTimeEvents);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] && (_simTime >= _clockShift["));
        txt = Tpl.writeText(txt, l_absSubClockIdx);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" -1]*_clockInterval["));
        txt = Tpl.writeStr(txt, intString(a_absClockIdx));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " -1])) {\n",
                                    "_time_conditions["
                                }, false));
        txt = Tpl.writeText(txt, l_absSubClockIdx);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" -1+"));
        txt = Tpl.writeStr(txt, a_numberOfTimeEvents);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = (_simTime >= _clockShift["));
        txt = Tpl.writeText(txt, l_absSubClockIdx);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" -1]*_clockInterval["));
        txt = Tpl.writeStr(txt, intString(a_absClockIdx));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " -1]);\n",
                                    "}"
                                }, false));
      then txt;
  end match;
end fun_1496;

public function booleanSubClockActivation2
  input Tpl.Text txt;
  input Integer a_absClockIdx;
  input Integer a_subClockIdx;
  input SimCode.SubPartition a_subPartition;
  input String a_numberOfTimeEvents;

  output Tpl.Text out_txt;
protected
  Boolean ret_0;
algorithm
  ret_0 := intNe(a_subClockIdx, 0);
  out_txt := fun_1496(txt, ret_0, a_absClockIdx, a_subClockIdx, a_numberOfTimeEvents);
end booleanSubClockActivation2;

protected function lm_1498
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) :=
  match(in_txt, in_items, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_context)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      SimCodeFunction.Context a_context;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           {},
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           _ )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           i_eq :: rest,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_context )
      equation
        (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, _) = equation_function_call(txt, i_eq, a_context, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, Tpl.strTokText(Tpl.ST_STRING("evaluate")));
        txt = Tpl.nextIter(txt);
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = lm_1498(txt, rest, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_context);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);
  end match;
end lm_1498;

public function createEvaluateConditions
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_allEquationsPlusWhen;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
protected
  Tpl.Text l_equation__all__func__calls;
  Tpl.Text l_eqfuncs;
  Tpl.Text l_varDecls;
  Tpl.Text l_className;
algorithm
  (l_className, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace) := lastIdentOfPathFromSimCode(Tpl.emptyTxt, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
  l_varDecls := Tpl.emptyTxt;
  l_eqfuncs := Tpl.emptyTxt;
  l_equation__all__func__calls := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (l_equation__all__func__calls, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, l_varDecls) := lm_1498(l_equation__all__func__calls, a_allEquationsPlusWhen, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, a_simCode, l_varDecls, a_context);
  l_equation__all__func__calls := Tpl.popIter(l_equation__all__func__calls);
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING("bool "));
  out_txt := Tpl.writeText(out_txt, l_className);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "::evaluateConditions(const UPDATETYPE command)\n",
                                       "{\n",
                                       "  return evaluateAll(command);\n",
                                       "}"
                                   }, false));
  out_a_stateDerVectorName := a_stateDerVectorName;
end createEvaluateConditions;

protected function lm_1500
  input Tpl.Text in_txt;
  input list<list<SimCode.SimEqSystem>> in_items;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_className;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_className, in_a_context)
    local
      Tpl.Text txt;
      list<list<SimCode.SimEqSystem>> rest;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_className;
      SimCodeFunction.Context a_context;
      Integer x_i0;
      list<SimCode.SimEqSystem> i_eqs;

    case ( txt,
           {},
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _,
           _ )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           i_eqs :: rest,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_className,
           a_context )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = createEvaluateWithSplit(txt, x_i0, a_context, i_eqs, "evaluateODE", "evaluate", Tpl.textString(a_className), a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
        txt = Tpl.nextIter(txt);
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1500(txt, rest, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_className, a_context);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_1500;

protected function lm_1501
  input Tpl.Text in_txt;
  input list<Integer> in_items;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_className;
  input list<list<Integer>> in_a_activatorsForPartitions;
  input list<list<Integer>> in_a_partitions;
  input list<list<SimCode.SimEqSystem>> in_a_odeEquations;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_className, in_a_activatorsForPartitions, in_a_partitions, in_a_odeEquations, in_a_context)
    local
      Tpl.Text txt;
      list<Integer> rest;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_className;
      list<list<Integer>> a_activatorsForPartitions;
      list<list<Integer>> a_partitions;
      list<list<SimCode.SimEqSystem>> a_odeEquations;
      SimCodeFunction.Context a_context;
      Integer i_partIdx;
      list<Integer> ret_2;
      list<Integer> ret_1;
      list<SimCode.SimEqSystem> ret_0;

    case ( txt,
           {},
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _,
           _,
           _,
           _,
           _ )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           i_partIdx :: rest,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_className,
           a_activatorsForPartitions,
           a_partitions,
           a_odeEquations,
           a_context )
      equation
        ret_0 = List.flatten(a_odeEquations);
        ret_1 = listGet(a_partitions, i_partIdx);
        ret_2 = listGet(a_activatorsForPartitions, i_partIdx);
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = createEvaluatePartitions(txt, i_partIdx, a_context, ret_0, ret_1, ret_2, Tpl.textString(a_className), a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
        txt = Tpl.nextIter(txt);
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1501(txt, rest, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_className, a_activatorsForPartitions, a_partitions, a_odeEquations, a_context);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_1501;

protected function fun_1502
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input list<list<Integer>> in_a_activatorsForPartitions;
  input list<list<Integer>> in_a_partitions;
  input Integer in_a_partitionData_numPartitions;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_className;
  input SimCodeFunction.Context in_a_context;
  input list<list<SimCode.SimEqSystem>> in_a_odeEquations;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_mArg, in_a_activatorsForPartitions, in_a_partitions, in_a_partitionData_numPartitions, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_className, in_a_context, in_a_odeEquations)
    local
      Tpl.Text txt;
      list<list<Integer>> a_activatorsForPartitions;
      list<list<Integer>> a_partitions;
      Integer a_partitionData_numPartitions;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_className;
      SimCodeFunction.Context a_context;
      list<list<SimCode.SimEqSystem>> a_odeEquations;
      list<Integer> ret_2;
      list<list<SimCode.SimEqSystem>> ret_1;
      list<SimCode.SimEqSystem> ret_0;

    case ( txt,
           false,
           _,
           _,
           _,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_className,
           a_context,
           a_odeEquations )
      equation
        ret_0 = List.flatten(a_odeEquations);
        ret_1 = List.partition(ret_0, 100);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1500(txt, ret_1, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_className, a_context);
        txt = Tpl.popIter(txt);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           a_activatorsForPartitions,
           a_partitions,
           a_partitionData_numPartitions,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_className,
           a_context,
           a_odeEquations )
      equation
        ret_2 = List.intRange(a_partitionData_numPartitions);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1501(txt, ret_2, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_className, a_activatorsForPartitions, a_partitions, a_odeEquations, a_context);
        txt = Tpl.popIter(txt);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_1502;

protected function fun_1503
  input Tpl.Text in_txt;
  input Boolean in_a_createMeasureTime;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_createMeasureTime)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = generateMeasureTimeStartCode(txt, "measuredFunctionStartValues", "evaluateODE", "MEASURETIME_MODELFUNCTIONS");
      then txt;
  end match;
end fun_1503;

protected function fun_1504
  input Tpl.Text in_txt;
  input Boolean in_a_createMeasureTime;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_createMeasureTime)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = generateMeasureTimeEndCode(txt, "measuredFunctionStartValues", "measuredFunctionEndValues", "(*measureTimeFunctionsArray)[0]", "evaluateODE", "MEASURETIME_MODELFUNCTIONS");
      then txt;
  end match;
end fun_1504;

protected function fun_1505
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input SimCodeFunction.Context in_a_context;
  input Boolean in_a_createMeasureTime;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace) :=
  match(in_txt, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_context, in_a_createMeasureTime)
    local
      Tpl.Text txt;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      SimCodeFunction.Context a_context;
      Boolean a_createMeasureTime;
      list<list<Integer>> i_activatorsForPartitions;
      list<list<Integer>> i_partitions;
      Integer i_partitionData_numPartitions;
      list<list<SimCode.SimEqSystem>> i_odeEquations;
      SimCode.SimCode i_simCode;
      Boolean ret_3;
      Tpl.Text l_equation__ode__func__calls;
      Tpl.Text l_varDecls;
      Tpl.Text l_className;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(partitionData = SimCode.PARTITIONDATA(partitions = i_partitions, activatorsForPartitions = i_activatorsForPartitions, numPartitions = i_partitionData_numPartitions), odeEquations = i_odeEquations)),
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_context,
           a_createMeasureTime )
      equation
        (l_className, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = lastIdentOfPathFromSimCode(Tpl.emptyTxt, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
        l_varDecls = Tpl.emptyTxt;
        ret_3 = Flags.isSet(Flags.MULTIRATE_PARTITION);
        (l_equation__ode__func__calls, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_1502(Tpl.emptyTxt, ret_3, i_activatorsForPartitions, i_partitions, i_partitionData_numPartitions, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, i_simCode, l_className, a_context, i_odeEquations);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = Tpl.writeText(txt, l_className);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::evaluateODE(const UPDATETYPE command)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = fun_1503(txt, a_createMeasureTime);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_varDecls);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("// Evaluate Equations\n"));
        txt = Tpl.writeText(txt, l_equation__ode__func__calls);
        txt = Tpl.softNewLine(txt);
        txt = fun_1504(txt, a_createMeasureTime);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);

    case ( txt,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           _,
           _ )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
  end match;
end fun_1505;

public function createEvaluate
  input Tpl.Text txt;
  input list<list<SimCode.SimEqSystem>> a_odeEquations;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input SimCodeFunction.Context a_context;
  input Boolean a_createMeasureTime;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace) := fun_1505(txt, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_context, a_createMeasureTime);
end createEvaluate;

protected function lm_1507
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) :=
  match(in_txt, in_items, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_context)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      SimCodeFunction.Context a_context;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           {},
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           _ )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           i_eq :: rest,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_context )
      equation
        (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, _) = equation_function_call(txt, i_eq, a_context, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, Tpl.strTokText(Tpl.ST_STRING("evaluate")));
        txt = Tpl.nextIter(txt);
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = lm_1507(txt, rest, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_context);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);
  end match;
end lm_1507;

public function createEvaluatePartitions
  input Tpl.Text txt;
  input Integer a_partIdx;
  input SimCodeFunction.Context a_context;
  input list<SimCode.SimEqSystem> a_odeEquations;
  input list<Integer> a_partition;
  input list<Integer> a_activators;
  input String a_className;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
protected
  list<SimCode.SimEqSystem> ret_3;
  Tpl.Text l_equation__func__calls;
  Tpl.Text l_condition;
  Tpl.Text l_varDecls;
algorithm
  l_varDecls := Tpl.emptyTxt;
  l_condition := partitionCondition(Tpl.emptyTxt, a_activators);
  ret_3 := SimCodeUtil.getSimEqSystemsByIndexLst(a_partition, a_odeEquations);
  l_equation__func__calls := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (l_equation__func__calls, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, l_varDecls) := lm_1507(l_equation__func__calls, ret_3, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, l_varDecls, a_context);
  l_equation__func__calls := Tpl.popIter(l_equation__func__calls);
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING("// Partition "));
  out_txt := Tpl.writeStr(out_txt, intString(a_partIdx));
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("if ("));
  out_txt := Tpl.writeText(out_txt, l_condition);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       ")\n",
                                       "{\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(4));
  out_txt := Tpl.writeText(out_txt, l_varDecls);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeText(out_txt, l_equation__func__calls);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("}"));
end createEvaluatePartitions;

protected function lm_1509
  input Tpl.Text in_txt;
  input list<Integer> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<Integer> rest;
      Integer i_part;
      Integer ret_0;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_part :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_partitionActivation["));
        ret_0 = intSub(i_part, 1);
        txt = Tpl.writeStr(txt, intString(ret_0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("]"));
        txt = Tpl.nextIter(txt);
        txt = lm_1509(txt, rest);
      then txt;
  end match;
end lm_1509;

public function partitionCondition
  input Tpl.Text txt;
  input list<Integer> a_partitions;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_bVec;
algorithm
  l_bVec := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(" || ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  l_bVec := lm_1509(l_bVec, a_partitions);
  l_bVec := Tpl.popIter(l_bVec);
  out_txt := Tpl.writeText(txt, l_bVec);
end partitionCondition;

protected function lm_1511
  input Tpl.Text in_txt;
  input list<list<SimCode.SimEqSystem>> in_items;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_className;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_className, in_a_context)
    local
      Tpl.Text txt;
      list<list<SimCode.SimEqSystem>> rest;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_className;
      SimCodeFunction.Context a_context;
      Integer x_i0;
      list<SimCode.SimEqSystem> i_eqs;

    case ( txt,
           {},
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _,
           _ )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           i_eqs :: rest,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_className,
           a_context )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = createEvaluateWithSplit(txt, x_i0, a_context, i_eqs, "evaluateZeroFuncs", "evaluate", Tpl.textString(a_className), a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
        txt = Tpl.nextIter(txt);
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1511(txt, rest, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_className, a_context);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_1511;

public function createEvaluateZeroFuncs
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_equationsForZeroCrossings;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input SimCodeFunction.Context a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
protected
  list<list<SimCode.SimEqSystem>> ret_4;
  Tpl.Text l_equation__zero__func__calls;
  Tpl.Text l_eqfuncs;
  Tpl.Text l_varDecls;
  Tpl.Text l_className;
algorithm
  (l_className, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace) := lastIdentOfPathFromSimCode(Tpl.emptyTxt, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
  l_varDecls := Tpl.emptyTxt;
  l_eqfuncs := Tpl.emptyTxt;
  ret_4 := List.partition(a_equationsForZeroCrossings, 100);
  l_equation__zero__func__calls := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (l_equation__zero__func__calls, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) := lm_1511(l_equation__zero__func__calls, ret_4, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, a_simCode, l_className, a_context);
  l_equation__zero__func__calls := Tpl.popIter(l_equation__zero__func__calls);
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING("void "));
  out_txt := Tpl.writeText(out_txt, l_className);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "::evaluateZeroFuncs(const UPDATETYPE command)\n",
                                       "{\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeText(out_txt, l_varDecls);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("// Evaluate Equations\n"));
  out_txt := Tpl.writeText(out_txt, l_equation__zero__func__calls);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("}"));
end createEvaluateZeroFuncs;

protected function lm_1513
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input String in_a_functionCallName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) :=
  match(in_txt, in_items, in_a_functionCallName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_context)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      String a_functionCallName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      SimCodeFunction.Context a_context;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           {},
           _,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           _ )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           i_eq :: rest,
           a_functionCallName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_context )
      equation
        (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, _) = equation_function_call(txt, i_eq, a_context, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, Tpl.stringText(a_functionCallName));
        txt = Tpl.nextIter(txt);
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = lm_1513(txt, rest, a_functionCallName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_context);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);
  end match;
end lm_1513;

public function createEvaluateWithSplit
  input Tpl.Text txt;
  input Integer a_sectionIndex;
  input SimCodeFunction.Context a_context;
  input list<SimCode.SimEqSystem> a_sectionEquations;
  input String a_functionName;
  input String a_functionCallName;
  input String a_className;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
protected
  Tpl.Text l_equation__func__calls;
  Tpl.Text l_varDecls;
algorithm
  l_varDecls := Tpl.emptyTxt;
  l_equation__func__calls := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (l_equation__func__calls, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, l_varDecls) := lm_1513(l_equation__func__calls, a_sectionEquations, a_functionCallName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, l_varDecls, a_context);
  l_equation__func__calls := Tpl.popIter(l_equation__func__calls);
  out_a_extraFuncs := Tpl.writeTok(out_a_extraFuncs, Tpl.ST_NEW_LINE());
  out_a_extraFuncs := Tpl.writeTok(out_a_extraFuncs, Tpl.ST_STRING("void "));
  out_a_extraFuncs := Tpl.writeStr(out_a_extraFuncs, a_className);
  out_a_extraFuncs := Tpl.writeTok(out_a_extraFuncs, Tpl.ST_STRING("::"));
  out_a_extraFuncs := Tpl.writeStr(out_a_extraFuncs, a_functionName);
  out_a_extraFuncs := Tpl.writeTok(out_a_extraFuncs, Tpl.ST_STRING("_"));
  out_a_extraFuncs := Tpl.writeStr(out_a_extraFuncs, intString(a_sectionIndex));
  out_a_extraFuncs := Tpl.writeTok(out_a_extraFuncs, Tpl.ST_STRING_LIST({
                                                         "(const UPDATETYPE command)\n",
                                                         "{\n"
                                                     }, true));
  out_a_extraFuncs := Tpl.pushBlock(out_a_extraFuncs, Tpl.BT_INDENT(2));
  out_a_extraFuncs := Tpl.writeText(out_a_extraFuncs, l_varDecls);
  out_a_extraFuncs := Tpl.softNewLine(out_a_extraFuncs);
  out_a_extraFuncs := Tpl.writeTok(out_a_extraFuncs, Tpl.ST_NEW_LINE());
  out_a_extraFuncs := Tpl.writeText(out_a_extraFuncs, l_equation__func__calls);
  out_a_extraFuncs := Tpl.softNewLine(out_a_extraFuncs);
  out_a_extraFuncs := Tpl.popBlock(out_a_extraFuncs);
  out_a_extraFuncs := Tpl.writeTok(out_a_extraFuncs, Tpl.ST_STRING("}"));
  out_a_extraFuncsDecl := Tpl.writeTok(out_a_extraFuncsDecl, Tpl.ST_STRING("void "));
  out_a_extraFuncsDecl := Tpl.writeStr(out_a_extraFuncsDecl, a_functionName);
  out_a_extraFuncsDecl := Tpl.writeTok(out_a_extraFuncsDecl, Tpl.ST_STRING("_"));
  out_a_extraFuncsDecl := Tpl.writeStr(out_a_extraFuncsDecl, intString(a_sectionIndex));
  out_a_extraFuncsDecl := Tpl.writeTok(out_a_extraFuncsDecl, Tpl.ST_STRING("(const UPDATETYPE command);"));
  out_a_extraFuncsDecl := Tpl.writeTok(out_a_extraFuncsDecl, Tpl.ST_NEW_LINE());
  out_txt := Tpl.writeStr(txt, a_functionName);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("_"));
  out_txt := Tpl.writeStr(out_txt, intString(a_sectionIndex));
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("(command);"));
end createEvaluateWithSplit;

protected function lm_1515
  input Tpl.Text in_txt;
  input list<String> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<String> rest;
      Integer x_index0;
      String i_label;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_label :: rest )
      equation
        x_index0 = Tpl.getIteri_i0(txt);
        txt = Tpl.writeStr(txt, intString(x_index0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(",&_"));
        txt = Tpl.writeStr(txt, i_label);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_1_,&_"));
        txt = Tpl.writeStr(txt, i_label);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_2_"));
        txt = Tpl.nextIter(txt);
        txt = lm_1515(txt, rest);
      then txt;
  end match;
end lm_1515;

protected function fun_1516
  input Tpl.Text in_txt;
  input list<String> in_a_labels;
  input Absyn.Path in_a_modelInfo_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_labels, in_a_modelInfo_name)
    local
      Tpl.Text txt;
      Absyn.Path a_modelInfo_name;
      list<String> i_labels;

    case ( txt,
           {},
           a_modelInfo_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("label_list_type "));
        txt = lastIdentOfPath(txt, a_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::getLabels()\n",
                                    "{\n",
                                    "   return label_list_type();\n",
                                    "}"
                                }, false));
      then txt;

    case ( txt,
           i_labels,
           a_modelInfo_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("label_list_type "));
        txt = lastIdentOfPath(txt, a_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::getLabels()\n",
                                    "{\n",
                                    "   label_list_type labels = TUPLE_LIST_OF\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(3));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(" TUPLE_LIST_SEP ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_1515(txt, i_labels);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " TUPLE_LIST_END;\n",
                                    "return labels;\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;
  end match;
end fun_1516;

protected function fun_1517
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Boolean in_a_useFlatArrayNotation;
  input list<String> in_a_labels;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode, in_a_useFlatArrayNotation, in_a_labels)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      list<String> a_labels;
      SimCode.ModelInfo i_modelInfo;
      Absyn.Path i_modelInfo_name;

    case ( txt,
           SimCode.SIMCODE(modelInfo = (i_modelInfo as SimCode.MODELINFO(name = i_modelInfo_name))),
           a_useFlatArrayNotation,
           a_labels )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "\n"
                                }, true));
        txt = fun_1516(txt, a_labels, i_modelInfo_name);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "void "
                                }, false));
        txt = lastIdentOfPath(txt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::setVariables(const ublas::vector<double>& variables,const ublas::vector<double>& variables2)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(3));
        txt = setVariables(txt, i_modelInfo, a_useFlatArrayNotation);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_1517;

protected function fun_1518
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input list<String> in_a_labels;
  input SimCode.SimCode in_a_simCode;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_labels, in_a_simCode, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      list<String> a_labels;
      SimCode.SimCode a_simCode;
      Boolean a_useFlatArrayNotation;

    case ( txt,
           false,
           _,
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_labels,
           a_simCode,
           a_useFlatArrayNotation )
      equation
        txt = fun_1517(txt, a_simCode, a_useFlatArrayNotation, a_labels);
      then txt;
  end match;
end fun_1518;

public function labeledDAE
  input Tpl.Text txt;
  input list<String> a_labels;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
protected
  Boolean ret_0;
algorithm
  ret_0 := Flags.isSet(Flags.WRITE_TO_BUFFER);
  out_txt := fun_1518(txt, ret_0, a_labels, a_simCode, a_useFlatArrayNotation);
  out_a_extraFuncs := a_extraFuncs;
  out_a_extraFuncsDecl := a_extraFuncsDecl;
  out_a_extraFuncsNamespace := a_extraFuncsNamespace;
  out_a_stateDerVectorName := a_stateDerVectorName;
end labeledDAE;

protected function lm_1520
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Integer x_myindex;
      Integer i_index;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(index = i_index) :: rest )
      equation
        x_myindex = Tpl.getIteri_i0(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("__z["));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("]=variables("));
        txt = Tpl.writeStr(txt, intString(x_myindex));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
        txt = Tpl.nextIter(txt);
        txt = lm_1520(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_1520(txt, rest);
      then txt;
  end match;
end lm_1520;

protected function fun_1521
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_myindex;
  input SimCode.ModelInfo in_a_modelInfo;
  input Boolean in_a_useFlatArrayNotation;
  input DAE.ComponentRef in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_myindex, in_a_modelInfo, in_a_useFlatArrayNotation, in_a_name)
    local
      Tpl.Text txt;
      Integer a_myindex;
      SimCode.ModelInfo a_modelInfo;
      Boolean a_useFlatArrayNotation;
      DAE.ComponentRef a_name;

    case ( txt,
           false,
           a_myindex,
           a_modelInfo,
           a_useFlatArrayNotation,
           a_name )
      equation
        txt = CodegenCppCommonOld.crefStrForSetVariables(txt, a_name, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("=variables("));
        txt = numStatevars(txt, a_modelInfo);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("+"));
        txt = Tpl.writeStr(txt, intString(a_myindex));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("); "));
      then txt;

    case ( txt,
           _,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_1521;

protected function lm_1522
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input SimCode.ModelInfo in_a_modelInfo;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelInfo, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCode.ModelInfo a_modelInfo;
      Boolean a_useFlatArrayNotation;
      Integer x_myindex;
      DAE.ComponentRef i_name;
      Boolean ret_1;
      Tpl.Text txt_0;

    case ( txt,
           {},
           _,
           _ )
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(name = i_name) :: rest,
           a_modelInfo,
           a_useFlatArrayNotation )
      equation
        x_myindex = Tpl.getIteri_i0(txt);
        txt_0 = CodegenCppCommonOld.crefStrForSetVariables(Tpl.emptyTxt, i_name, a_useFlatArrayNotation);
        ret_1 = stringEq(Tpl.textString(txt_0), "");
        txt = fun_1521(txt, ret_1, x_myindex, a_modelInfo, a_useFlatArrayNotation, i_name);
        txt = Tpl.nextIter(txt);
        txt = lm_1522(txt, rest, a_modelInfo, a_useFlatArrayNotation);
      then txt;

    case ( txt,
           _ :: rest,
           a_modelInfo,
           a_useFlatArrayNotation )
      equation
        txt = lm_1522(txt, rest, a_modelInfo, a_useFlatArrayNotation);
      then txt;
  end match;
end lm_1522;

protected function lm_1523
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Integer x_myindex;
      Integer i_index;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(index = i_index) :: rest )
      equation
        x_myindex = Tpl.getIteri_i0(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("__zDot["));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("]=variables2("));
        txt = Tpl.writeStr(txt, intString(x_myindex));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
        txt = Tpl.nextIter(txt);
        txt = lm_1523(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_1523(txt, rest);
      then txt;
  end match;
end lm_1523;

protected function smf_1524
  input Tpl.Text in_txt;
  input Tpl.Text in_it;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_it)
    local
      Tpl.Text txt;
      Tpl.Text i_it;

    case ( txt,
           i_it )
      equation
        txt = Tpl.writeText(txt, i_it);
        txt = Tpl.nextIter(txt);
      then txt;
  end match;
end smf_1524;

protected function smf_1525
  input Tpl.Text in_txt;
  input Tpl.Text in_it;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_it)
    local
      Tpl.Text txt;
      Tpl.Text i_it;

    case ( txt,
           i_it )
      equation
        txt = Tpl.writeText(txt, i_it);
        txt = Tpl.nextIter(txt);
      then txt;
  end match;
end smf_1525;

protected function smf_1526
  input Tpl.Text in_txt;
  input Tpl.Text in_it;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_it)
    local
      Tpl.Text txt;
      Tpl.Text i_it;

    case ( txt,
           i_it )
      equation
        txt = Tpl.writeText(txt, i_it);
        txt = Tpl.nextIter(txt);
      then txt;
  end match;
end smf_1526;

public function setVariables
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      list<SimCodeVar.SimVar> i_vars_derivativeVars;
      SimCode.ModelInfo i_modelInfo;
      list<SimCodeVar.SimVar> i_vars_algVars;
      list<SimCodeVar.SimVar> i_vars_stateVars;
      Tpl.Text txt_2;
      Tpl.Text txt_1;
      Tpl.Text txt_0;

    case ( txt,
           (i_modelInfo as SimCode.MODELINFO(vars = SimCodeVar.SIMVARS(stateVars = i_vars_stateVars, algVars = i_vars_algVars, derivativeVars = i_vars_derivativeVars))),
           a_useFlatArrayNotation )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt_0 = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt_0 = lm_1520(txt_0, i_vars_stateVars);
        txt_0 = Tpl.popIter(txt_0);
        txt_1 = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt_1 = lm_1522(txt_1, i_vars_algVars, i_modelInfo, a_useFlatArrayNotation);
        txt_1 = Tpl.popIter(txt_1);
        txt_2 = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt_2 = lm_1523(txt_2, i_vars_derivativeVars);
        txt_2 = Tpl.popIter(txt_2);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = smf_1524(txt, txt_0);
        txt = smf_1525(txt, txt_1);
        txt = smf_1526(txt, txt_2);
        txt = Tpl.popIter(txt);
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end setVariables;

protected function lm_1528
  input Tpl.Text in_txt;
  input list<SimCode.JacobianMatrix> in_items;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      list<SimCode.JacobianMatrix> rest;
      String a_modelNamePrefix;
      Integer i_maxColor;
      list<list<Integer>> i_colorList;
      SimCode.SparsityPattern i_sparsepattern;
      String i_name;
      list<SimCodeVar.SimVar> i_vars;
      list<SimCode.JacobianColumn> i_mat;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           SimCode.JAC_MATRIX(columns = i_mat, seedVars = i_vars, matrixName = i_name, sparsity = i_sparsepattern, coloredCols = i_colorList, maxColorCols = i_maxColor, jacobianIndex = _) :: rest,
           a_modelNamePrefix )
      equation
        txt = initialAnalyticJacobians2(txt, i_mat, i_vars, i_name, i_sparsepattern, i_colorList, i_maxColor, a_modelNamePrefix);
        txt = Tpl.nextIter(txt);
        txt = lm_1528(txt, rest, a_modelNamePrefix);
      then txt;

    case ( txt,
           _ :: rest,
           a_modelNamePrefix )
      equation
        txt = lm_1528(txt, rest, a_modelNamePrefix);
      then txt;
  end match;
end lm_1528;

public function functionAnalyticJacobians2
  input Tpl.Text txt;
  input list<SimCode.JacobianMatrix> a_JacobianMatrixes;
  input String a_modelNamePrefix;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
protected
  Tpl.Text l_initialjacMats;
  Tpl.Text l_varDecls;
algorithm
  l_varDecls := Tpl.emptyTxt;
  l_initialjacMats := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  l_initialjacMats := lm_1528(l_initialjacMats, a_JacobianMatrixes, a_modelNamePrefix);
  l_initialjacMats := Tpl.popIter(l_initialjacMats);
  out_txt := Tpl.writeText(txt, l_initialjacMats);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_NEW_LINE());
  out_a_extraFuncs := a_extraFuncs;
  out_a_extraFuncsDecl := a_extraFuncsDecl;
  out_a_extraFuncsNamespace := a_extraFuncsNamespace;
  out_a_stateDerVectorName := a_stateDerVectorName;
end functionAnalyticJacobians2;

protected function lm_1530
  input Tpl.Text in_txt;
  input list<Integer> in_items;
  input Integer in_a_index0;
  input String in_a_matrixname;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_index0, in_a_matrixname)
    local
      Tpl.Text txt;
      list<Integer> rest;
      Integer a_index0;
      String a_matrixname;
      Integer i_i__index;
      Integer ret_0;

    case ( txt,
           {},
           _,
           _ )
      then txt;

    case ( txt,
           i_i__index :: rest,
           a_index0,
           a_matrixname )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeStr(txt, a_matrixname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("ColorOfColumn["));
        txt = Tpl.writeStr(txt, intString(i_i__index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = "));
        ret_0 = intAdd(a_index0, 1);
        txt = Tpl.writeStr(txt, intString(ret_0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("; "));
        txt = Tpl.nextIter(txt);
        txt = lm_1530(txt, rest, a_index0, a_matrixname);
      then txt;
  end match;
end lm_1530;

protected function lm_1531
  input Tpl.Text in_txt;
  input list<list<Integer>> in_items;
  input String in_a_matrixname;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_matrixname)
    local
      Tpl.Text txt;
      list<list<Integer>> rest;
      String a_matrixname;
      Integer x_index0;
      list<Integer> i_indexes;
      Tpl.Text l_colorCol;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_indexes :: rest,
           a_matrixname )
      equation
        x_index0 = Tpl.getIteri_i0(txt);
        l_colorCol = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_colorCol = lm_1530(l_colorCol, i_indexes, x_index0, a_matrixname);
        l_colorCol = Tpl.popIter(l_colorCol);
        txt = Tpl.writeText(txt, l_colorCol);
        txt = Tpl.nextIter(txt);
        txt = lm_1531(txt, rest, a_matrixname);
      then txt;
  end match;
end lm_1531;

protected function fun_1532
  input Tpl.Text in_txt;
  input String in_a_matrixname;
  input Integer in_a_maxColor;
  input list<SimCodeVar.SimVar> in_a_seedVars;
  input list<list<Integer>> in_a_colorList;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_matrixname, in_a_maxColor, in_a_seedVars, in_a_colorList)
    local
      Tpl.Text txt;
      Integer a_maxColor;
      list<SimCodeVar.SimVar> a_seedVars;
      list<list<Integer>> a_colorList;
      String i_matrixname;
      Integer ret_2;
      Tpl.Text l_index__;
      Tpl.Text l_colorArray;

    case ( txt,
           (i_matrixname as "A"),
           a_maxColor,
           a_seedVars,
           a_colorList )
      equation
        l_colorArray = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_colorArray = lm_1531(l_colorArray, a_colorList, i_matrixname);
        l_colorArray = Tpl.popIter(l_colorArray);
        ret_2 = listLength(a_seedVars);
        l_index__ = Tpl.writeStr(Tpl.emptyTxt, intString(ret_2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "  if(_AColorOfColumn)\n",
                                    "    delete [] _AColorOfColumn;\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_AColorOfColumn = new int["));
        txt = Tpl.writeText(txt, l_index__);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "];\n",
                                    "_AMaxColors = "
                                }, false));
        txt = Tpl.writeStr(txt, intString(a_maxColor));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "\n",
                                    "/* write color array */\n"
                                }, true));
        txt = Tpl.writeText(txt, l_colorArray);
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_1532;

protected function fun_1533
  input Tpl.Text in_txt;
  input list<tuple<Integer, list<Integer>>> in_a_sparsepattern;
  input Integer in_a_maxColor;
  input list<SimCodeVar.SimVar> in_a_seedVars;
  input list<list<Integer>> in_a_colorList;
  input String in_a_matrixname;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_sparsepattern, in_a_maxColor, in_a_seedVars, in_a_colorList, in_a_matrixname)
    local
      Tpl.Text txt;
      Integer a_maxColor;
      list<SimCodeVar.SimVar> a_seedVars;
      list<list<Integer>> a_colorList;
      String a_matrixname;

    case ( txt,
           _,
           a_maxColor,
           a_seedVars,
           a_colorList,
           a_matrixname )
      equation
        txt = fun_1532(txt, a_matrixname, a_maxColor, a_seedVars, a_colorList);
      then txt;
  end match;
end fun_1533;

protected function fun_1534
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_a_seedVars;
  input String in_a_matrixname;
  input list<tuple<Integer, list<Integer>>> in_a_sparsepattern;
  input list<list<Integer>> in_a_colorList;
  input Integer in_a_maxColor;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_seedVars, in_a_matrixname, in_a_sparsepattern, in_a_colorList, in_a_maxColor)
    local
      Tpl.Text txt;
      String a_matrixname;
      list<tuple<Integer, list<Integer>>> a_sparsepattern;
      list<list<Integer>> a_colorList;
      Integer a_maxColor;
      list<SimCodeVar.SimVar> i_seedVars;

    case ( txt,
           {},
           _,
           _,
           _,
           _ )
      then txt;

    case ( txt,
           i_seedVars,
           a_matrixname,
           a_sparsepattern,
           a_colorList,
           a_maxColor )
      equation
        txt = fun_1533(txt, a_sparsepattern, a_maxColor, i_seedVars, a_colorList, a_matrixname);
      then txt;
  end match;
end fun_1534;

public function initialAnalyticJacobians2
  input Tpl.Text txt;
  input list<SimCode.JacobianColumn> a_jacobianColumn;
  input list<SimCodeVar.SimVar> a_seedVars;
  input String a_matrixname;
  input list<tuple<Integer, list<Integer>>> a_sparsepattern;
  input list<list<Integer>> a_colorList;
  input Integer a_maxColor;
  input String a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_1534(txt, a_seedVars, a_matrixname, a_sparsepattern, a_colorList, a_maxColor);
end initialAnalyticJacobians2;

public function symbolName
  input Tpl.Text txt;
  input String a_modelNamePrefix;
  input String a_symbolName;

  output Tpl.Text out_txt;
algorithm
  out_txt := Tpl.writeStr(txt, a_modelNamePrefix);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("_"));
  out_txt := Tpl.writeStr(out_txt, a_symbolName);
end symbolName;

protected function lm_1537
  input Tpl.Text in_txt;
  input list<SimCode.JacobianMatrix> in_items;
  input String in_a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_modelNamePrefix)
    local
      Tpl.Text txt;
      list<SimCode.JacobianMatrix> rest;
      String a_modelNamePrefix;
      Integer i_maxColor;
      list<list<Integer>> i_colorList;
      SimCode.SparsityPattern i_sparsepattern;
      String i_name;
      list<SimCodeVar.SimVar> i_vars;
      list<SimCode.JacobianColumn> i_mat;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           SimCode.JAC_MATRIX(columns = i_mat, seedVars = i_vars, matrixName = i_name, sparsity = i_sparsepattern, coloredCols = i_colorList, maxColorCols = i_maxColor, jacobianIndex = _) :: rest,
           a_modelNamePrefix )
      equation
        txt = initialAnalyticJacobiansHeader(txt, i_mat, i_vars, i_name, i_sparsepattern, i_colorList, i_maxColor, a_modelNamePrefix);
        txt = Tpl.nextIter(txt);
        txt = lm_1537(txt, rest, a_modelNamePrefix);
      then txt;

    case ( txt,
           _ :: rest,
           a_modelNamePrefix )
      equation
        txt = lm_1537(txt, rest, a_modelNamePrefix);
      then txt;
  end match;
end lm_1537;

public function functionAnalyticJacobiansHeader
  input Tpl.Text txt;
  input list<SimCode.JacobianMatrix> a_JacobianMatrixes;
  input String a_modelNamePrefix;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_initialjacMats;
algorithm
  l_initialjacMats := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  l_initialjacMats := lm_1537(l_initialjacMats, a_JacobianMatrixes, a_modelNamePrefix);
  l_initialjacMats := Tpl.popIter(l_initialjacMats);
  out_txt := Tpl.writeText(txt, l_initialjacMats);
end functionAnalyticJacobiansHeader;

protected function fun_1539
  input Tpl.Text in_txt;
  input String in_a_matrixname;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_matrixname)
    local
      Tpl.Text txt;
      String i_matrixname;

    case ( txt,
           (i_matrixname as "A") )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("public:\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void initializeColoredJacobian"));
        txt = Tpl.writeStr(txt, i_matrixname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("();"));
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_1539;

protected function fun_1540
  input Tpl.Text in_txt;
  input list<tuple<Integer, list<Integer>>> in_a_sparsepattern;
  input String in_a_matrixname;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_sparsepattern, in_a_matrixname)
    local
      Tpl.Text txt;
      String a_matrixname;

    case ( txt,
           _,
           a_matrixname )
      equation
        txt = fun_1539(txt, a_matrixname);
      then txt;
  end match;
end fun_1540;

protected function fun_1541
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_a_seedVars;
  input String in_a_matrixname;
  input list<tuple<Integer, list<Integer>>> in_a_sparsepattern;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_seedVars, in_a_matrixname, in_a_sparsepattern)
    local
      Tpl.Text txt;
      String a_matrixname;
      list<tuple<Integer, list<Integer>>> a_sparsepattern;
      Tpl.Text l_help;

    case ( txt,
           {},
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_matrixname,
           a_sparsepattern )
      equation
        l_help = fun_1540(Tpl.emptyTxt, a_sparsepattern, a_matrixname);
        txt = Tpl.writeText(txt, l_help);
      then txt;
  end match;
end fun_1541;

public function initialAnalyticJacobiansHeader
  input Tpl.Text txt;
  input list<SimCode.JacobianColumn> a_jacobianColumn;
  input list<SimCodeVar.SimVar> a_seedVars;
  input String a_matrixname;
  input list<tuple<Integer, list<Integer>>> a_sparsepattern;
  input list<list<Integer>> a_colorList;
  input Integer a_maxColor;
  input String a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_1541(txt, a_seedVars, a_matrixname, a_sparsepattern);
end initialAnalyticJacobiansHeader;

protected function fun_1543
  input Tpl.Text in_txt;
  input String in_a_matrixname;
  input String in_a_matrixIndex;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_matrixname, in_a_matrixIndex)
    local
      Tpl.Text txt;
      String a_matrixIndex;
      String i_matrixname;

    case ( txt,
           (i_matrixname as "A"),
           a_matrixIndex )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void initializeColumnsColoredJacobian"));
        txt = Tpl.writeStr(txt, i_matrixname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeStr(txt, a_matrixIndex);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("();"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_1543;

public function mkSparseFunctionHeader
  input Tpl.Text txt;
  input String a_matrixname;
  input String a_matrixIndex;
  input Integer a_cref;
  input list<Integer> a_indexes;
  input String a_modelNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_1543(txt, a_matrixname, a_matrixIndex);
end mkSparseFunctionHeader;

protected function lm_1545
  input Tpl.Text in_txt;
  input list<SimCode.JacobianColumn> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.JacobianColumn> rest;
      Integer i_nRows;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           SimCode.JAC_COLUMN(numberOfResultVars = i_nRows) :: rest )
      equation
        txt = Tpl.writeStr(txt, intString(i_nRows));
        txt = Tpl.nextIter(txt);
        txt = lm_1545(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_1545(txt, rest);
      then txt;
  end match;
end lm_1545;

protected function lm_1546
  input Tpl.Text in_txt;
  input list<SimCode.JacobianColumn> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.JacobianColumn> rest;
      list<SimCodeVar.SimVar> i_vars;
      Integer ret_0;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           SimCode.JAC_COLUMN(columnVars = i_vars) :: rest )
      equation
        ret_0 = listLength(i_vars);
        txt = Tpl.writeStr(txt, intString(ret_0));
        txt = Tpl.nextIter(txt);
        txt = lm_1546(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_1546(txt, rest);
      then txt;
  end match;
end lm_1546;

protected function fun_1547
  input Tpl.Text in_txt;
  input String in_mArg;
  input Tpl.Text in_a_sp__size__index;
  input Tpl.Text in_a_index__;
  input Tpl.Text in_a_indexColumn;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_sp__size__index, in_a_index__, in_a_indexColumn)
    local
      Tpl.Text txt;
      Tpl.Text a_sp__size__index;
      Tpl.Text a_index__;
      Tpl.Text a_indexColumn;

    case ( txt,
           "dense",
           _,
           a_index__,
           a_indexColumn )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("ublas::zero_matrix<double> ("));
        txt = Tpl.writeText(txt, a_indexColumn);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, a_index__);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           "sparse",
           a_sp__size__index,
           a_index__,
           a_indexColumn )
      equation
        txt = Tpl.writeText(txt, a_indexColumn);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, a_index__);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, a_sp__size__index);
      then txt;

    case ( txt,
           _,
           _,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("A matrix type is not supported"));
      then txt;
  end match;
end fun_1547;

protected function fun_1548
  input Tpl.Text in_txt;
  input list<list<Integer>> in_a_colorList;
  input String in_a_matrixName;
  input list<SimCodeVar.SimVar> in_a_seedVars;
  input list<SimCode.JacobianColumn> in_a_jacobianColumn;
  input list<tuple<Integer, list<Integer>>> in_a_sparsepattern;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_colorList, in_a_matrixName, in_a_seedVars, in_a_jacobianColumn, in_a_sparsepattern)
    local
      Tpl.Text txt;
      String a_matrixName;
      list<SimCodeVar.SimVar> a_seedVars;
      list<SimCode.JacobianColumn> a_jacobianColumn;
      list<tuple<Integer, list<Integer>>> a_sparsepattern;
      String str_10;
      Tpl.Text l_matrixinit;
      String ret_8;
      Tpl.Text l_type;
      Integer ret_6;
      Tpl.Text l_index__;
      Tpl.Text l_tmpvarsSize;
      Tpl.Text l_indexColumn;
      Integer ret_2;
      list<list<Integer>> ret_1;
      Tpl.Text l_sp__size__index;

    case ( txt,
           {},
           _,
           _,
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_matrixName,
           a_seedVars,
           a_jacobianColumn,
           a_sparsepattern )
      equation
        ret_1 = List.unzipSecond(a_sparsepattern);
        ret_2 = List.lengthListElements(ret_1);
        l_sp__size__index = Tpl.writeStr(Tpl.emptyTxt, intString(ret_2));
        l_indexColumn = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_indexColumn = lm_1545(l_indexColumn, a_jacobianColumn);
        l_indexColumn = Tpl.popIter(l_indexColumn);
        l_tmpvarsSize = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_tmpvarsSize = lm_1546(l_tmpvarsSize, a_jacobianColumn);
        l_tmpvarsSize = Tpl.popIter(l_tmpvarsSize);
        ret_6 = listLength(a_seedVars);
        l_index__ = Tpl.writeStr(Tpl.emptyTxt, intString(ret_6));
        ret_8 = Flags.getConfigString(Flags.MATRIX_FORMAT);
        l_type = Tpl.writeStr(Tpl.emptyTxt, ret_8);
        str_10 = Tpl.textString(l_type);
        l_matrixinit = fun_1547(Tpl.emptyTxt, str_10, l_sp__size__index, l_index__, l_indexColumn);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", _"));
        txt = Tpl.writeStr(txt, a_matrixName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("jacobian("));
        txt = Tpl.writeText(txt, l_matrixinit);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ")\n",
                                    ", _"
                                }, false));
        txt = Tpl.writeStr(txt, a_matrixName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("jac_y(ublas::zero_vector<double>("));
        txt = Tpl.writeText(txt, l_indexColumn);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "))\n",
                                    ", _"
                                }, false));
        txt = Tpl.writeStr(txt, a_matrixName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("jac_tmp(ublas::zero_vector<double>("));
        txt = Tpl.writeText(txt, l_tmpvarsSize);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "))\n",
                                    ", _"
                                }, false));
        txt = Tpl.writeStr(txt, a_matrixName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("jac_x(ublas::zero_vector<double>("));
        txt = Tpl.writeText(txt, l_index__);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("))"));
      then txt;
  end match;
end fun_1548;

protected function fun_1549
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_a_seedVars;
  input String in_a_matrixName;
  input list<SimCode.JacobianColumn> in_a_jacobianColumn;
  input list<tuple<Integer, list<Integer>>> in_a_sparsepattern;
  input list<list<Integer>> in_a_colorList;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_seedVars, in_a_matrixName, in_a_jacobianColumn, in_a_sparsepattern, in_a_colorList)
    local
      Tpl.Text txt;
      String a_matrixName;
      list<SimCode.JacobianColumn> a_jacobianColumn;
      list<tuple<Integer, list<Integer>>> a_sparsepattern;
      list<list<Integer>> a_colorList;
      list<SimCodeVar.SimVar> i_seedVars;

    case ( txt,
           {},
           _,
           _,
           _,
           _ )
      then txt;

    case ( txt,
           i_seedVars,
           a_matrixName,
           a_jacobianColumn,
           a_sparsepattern,
           a_colorList )
      equation
        txt = fun_1548(txt, a_colorList, a_matrixName, i_seedVars, a_jacobianColumn, a_sparsepattern);
      then txt;
  end match;
end fun_1549;

protected function fun_1550
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input list<SimCode.JacobianColumn> in_a_jacobianColumn;
  input list<SimCodeVar.SimVar> in_a_seedVars;
  input String in_a_matrixName;
  input list<tuple<Integer, list<Integer>>> in_a_sparsepattern;
  input list<list<Integer>> in_a_colorList;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode, in_a_jacobianColumn, in_a_seedVars, in_a_matrixName, in_a_sparsepattern, in_a_colorList)
    local
      Tpl.Text txt;
      list<SimCode.JacobianColumn> a_jacobianColumn;
      list<SimCodeVar.SimVar> a_seedVars;
      String a_matrixName;
      list<tuple<Integer, list<Integer>>> a_sparsepattern;
      list<list<Integer>> a_colorList;
      Absyn.Path i_modelInfo_name;
      Tpl.Text l_classname;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = i_modelInfo_name)),
           a_jacobianColumn,
           a_seedVars,
           a_matrixName,
           a_sparsepattern,
           a_colorList )
      equation
        l_classname = lastIdentOfPath(Tpl.emptyTxt, i_modelInfo_name);
        txt = fun_1549(txt, a_seedVars, a_matrixName, a_jacobianColumn, a_sparsepattern, a_colorList);
      then txt;

    case ( txt,
           _,
           _,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_1550;

public function initialAnalyticJacobians
  input Tpl.Text txt;
  input Integer a_indexJacobian;
  input list<SimCode.JacobianColumn> a_jacobianColumn;
  input list<SimCodeVar.SimVar> a_seedVars;
  input String a_matrixName;
  input list<tuple<Integer, list<Integer>>> a_sparsepattern;
  input list<list<Integer>> a_colorList;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  out_txt := fun_1550(txt, a_simCode, a_jacobianColumn, a_seedVars, a_matrixName, a_sparsepattern, a_colorList);
  out_a_extraFuncs := a_extraFuncs;
  out_a_extraFuncsDecl := a_extraFuncsDecl;
  out_a_extraFuncsNamespace := a_extraFuncsNamespace;
end initialAnalyticJacobians;

protected function lm_1552
  input Tpl.Text in_txt;
  input list<SimCode.JacobianMatrix> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCode.JacobianMatrix> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Integer i_partIdx;
      Integer i_maxColor;
      list<list<Integer>> i_colorList;
      SimCode.SparsityPattern i_sparsepattern;
      String i_name;
      list<SimCodeVar.SimVar> i_vars;
      list<SimCode.JacobianColumn> i_mat;
      Integer i_jacIndex;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           SimCode.JAC_MATRIX(columns = i_mat, seedVars = i_vars, matrixName = i_name, sparsity = i_sparsepattern, coloredCols = i_colorList, maxColorCols = i_maxColor, jacobianIndex = i_jacIndex, partitionIndex = i_partIdx) :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = generateMatrix(txt, i_jacIndex, i_mat, i_vars, i_name, i_sparsepattern, i_colorList, i_maxColor, i_partIdx, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1552(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _ :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1552(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_1552;

protected function lm_1553
  input Tpl.Text in_txt;
  input list<SimCode.JacobianColumn> in_items;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCode.JacobianColumn> rest;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      list<SimCode.SimEqSystem> i_eqs;

    case ( txt,
           {},
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           SimCode.JAC_COLUMN(columnEqns = i_eqs) :: rest,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = generateAlgloopSystems(txt, i_eqs, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
        txt = Tpl.nextIter(txt);
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1553(txt, rest, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _ :: rest,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1553(txt, rest, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_1553;

protected function lm_1554
  input Tpl.Text in_txt;
  input list<SimCode.JacobianMatrix> in_items;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCode.JacobianMatrix> rest;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      list<SimCode.JacobianColumn> i_mat;

    case ( txt,
           {},
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           SimCode.JAC_MATRIX(columns = i_mat) :: rest,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING("")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1553(txt, i_mat, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.nextIter(txt);
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1554(txt, rest, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _ :: rest,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1554(txt, rest, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_1554;

protected function lm_1555
  input Tpl.Text in_txt;
  input list<SimCode.JacobianColumn> in_items;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input SimCode.ModelInfo in_a_modelInfo;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_modelInfo)
    local
      Tpl.Text txt;
      list<SimCode.JacobianColumn> rest;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      SimCode.ModelInfo a_modelInfo;
      list<SimCode.SimEqSystem> i_eqs;

    case ( txt,
           {},
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           SimCode.JAC_COLUMN(columnEqns = i_eqs) :: rest,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_modelInfo )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = generateAlgloopSolvers(txt, a_modelInfo, i_eqs, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
        txt = Tpl.nextIter(txt);
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1555(txt, rest, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_modelInfo);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _ :: rest,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_modelInfo )
      equation
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1555(txt, rest, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_modelInfo);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_1555;

protected function lm_1556
  input Tpl.Text in_txt;
  input list<SimCode.JacobianMatrix> in_items;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input SimCode.ModelInfo in_a_modelInfo;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_modelInfo)
    local
      Tpl.Text txt;
      list<SimCode.JacobianMatrix> rest;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      SimCode.ModelInfo a_modelInfo;
      list<SimCode.JacobianColumn> i_mat;

    case ( txt,
           {},
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           SimCode.JAC_MATRIX(columns = i_mat) :: rest,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_modelInfo )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING("")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1555(txt, i_mat, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_modelInfo);
        txt = Tpl.popIter(txt);
        txt = Tpl.nextIter(txt);
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1556(txt, rest, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_modelInfo);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _ :: rest,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_modelInfo )
      equation
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1556(txt, rest, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_modelInfo);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_1556;

public function functionAnalyticJacobians
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;
  input list<SimCode.JacobianMatrix> in_a_JacobianMatrixes;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_modelInfo, in_a_JacobianMatrixes, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      list<SimCode.JacobianMatrix> a_JacobianMatrixes;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      SimCode.ModelInfo i_modelInfo;
      Absyn.Path i_name;
      Tpl.Text l_jacalgloopsolvers;
      Tpl.Text l_jacalgloopsystems;
      Tpl.Text l_jacMats;
      Tpl.Text l_varDecls;
      Tpl.Text l_classname;

    case ( txt,
           (i_modelInfo as SimCode.MODELINFO(name = i_name)),
           a_JacobianMatrixes,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_classname = lastIdentOfPath(Tpl.emptyTxt, i_name);
        l_varDecls = Tpl.emptyTxt;
        l_jacMats = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_STRING_LIST({
                                                                                                     "\n",
                                                                                                     "\n"
                                                                                                 }, true)), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_jacMats, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1552(l_jacMats, a_JacobianMatrixes, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
        l_jacMats = Tpl.popIter(l_jacMats);
        l_jacalgloopsystems = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING("")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_jacalgloopsystems, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1554(l_jacalgloopsystems, a_JacobianMatrixes, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
        l_jacalgloopsystems = Tpl.popIter(l_jacalgloopsystems);
        l_jacalgloopsolvers = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING("")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_jacalgloopsolvers, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1556(l_jacalgloopsolvers, a_JacobianMatrixes, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, i_modelInfo);
        l_jacalgloopsolvers = Tpl.popIter(l_jacalgloopsolvers);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_jacMats);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "void "
                                }, false));
        txt = Tpl.writeText(txt, l_classname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Jacobian::initialize()\n",
                                    "{\n",
                                    "   //create Algloopsolver for analytical Jacobians\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(3));
        txt = Tpl.writeText(txt, l_jacalgloopsystems);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_jacalgloopsolvers);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "\n",
                                    "\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end functionAnalyticJacobians;

protected function lm_1558
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           i_eq :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls )
      equation
        (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = equation_(txt, i_eq, SimCodeFunction.contextJacobian, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = lm_1558(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);
  end match;
end lm_1558;

protected function fun_1559
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_partIdx;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_partIdx)
    local
      Tpl.Text txt;
      Integer a_partIdx;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_partIdx )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("const int clockIndex = "));
        txt = Tpl.writeStr(txt, intString(a_partIdx));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_1559;

protected function fun_1560
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input list<SimCode.SimEqSystem> in_a_jacEquations;
  input String in_a_matrixName;
  input Integer in_a_partIdx;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_simCode, in_a_jacEquations, in_a_matrixName, in_a_partIdx, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> a_jacEquations;
      String a_matrixName;
      Integer a_partIdx;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      SimCode.SimCode i_simCode;
      Absyn.Path i_modelInfo_name;
      Boolean ret_3;
      Tpl.Text l_eqns__;
      Tpl.Text l_varDecls;
      Tpl.Text l_classname;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = i_modelInfo_name))),
           a_jacEquations,
           a_matrixName,
           a_partIdx,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_classname = lastIdentOfPath(Tpl.emptyTxt, i_modelInfo_name);
        l_varDecls = Tpl.emptyTxt;
        l_eqns__ = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_eqns__, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, l_varDecls) = lm_1558(l_eqns__, a_jacEquations, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, i_simCode, l_varDecls);
        l_eqns__ = Tpl.popIter(l_eqns__);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = Tpl.writeText(txt, l_classname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Jacobian::calc"));
        txt = Tpl.writeStr(txt, a_matrixName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "JacobianColumn()\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        ret_3 = intGt(a_partIdx, 0);
        txt = fun_1559(txt, ret_3, a_partIdx);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_varDecls);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_eqns__);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           _,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end fun_1560;

public function functionJac
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_jacEquations;
  input String a_matrixName;
  input Integer a_partIdx;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) := fun_1560(txt, a_simCode, a_jacEquations, a_matrixName, a_partIdx, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
end functionJac;

protected function fun_1562
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Integer in_a_indexJacobian;
  input list<SimCode.JacobianColumn> in_a_jacobianColumn;
  input list<SimCodeVar.SimVar> in_a_seedVars;
  input String in_a_matrixname;
  input SimCode.SparsityPattern in_a_sparsepattern;
  input list<list<Integer>> in_a_colorList;
  input Integer in_a_maxColor;
  input Integer in_a_partIdx;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_simCode, in_a_indexJacobian, in_a_jacobianColumn, in_a_seedVars, in_a_matrixname, in_a_sparsepattern, in_a_colorList, in_a_maxColor, in_a_partIdx, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      Integer a_indexJacobian;
      list<SimCode.JacobianColumn> a_jacobianColumn;
      list<SimCodeVar.SimVar> a_seedVars;
      String a_matrixname;
      SimCode.SparsityPattern a_sparsepattern;
      list<list<Integer>> a_colorList;
      Integer a_maxColor;
      Integer a_partIdx;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      SimCode.SimCode i_simCode;
      SimCode.ModelInfo i_modelInfo;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = (i_modelInfo as SimCode.MODELINFO(name = _)))),
           a_indexJacobian,
           a_jacobianColumn,
           a_seedVars,
           a_matrixname,
           a_sparsepattern,
           a_colorList,
           a_maxColor,
           a_partIdx,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = generateJacobianMatrix(txt, i_modelInfo, a_indexJacobian, a_jacobianColumn, a_seedVars, a_matrixname, a_sparsepattern, a_colorList, a_partIdx, a_maxColor, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           _,
           _,
           _,
           _,
           _,
           _,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end fun_1562;

public function generateMatrix
  input Tpl.Text txt;
  input Integer a_indexJacobian;
  input list<SimCode.JacobianColumn> a_jacobianColumn;
  input list<SimCodeVar.SimVar> a_seedVars;
  input String a_matrixname;
  input SimCode.SparsityPattern a_sparsepattern;
  input list<list<Integer>> a_colorList;
  input Integer a_maxColor;
  input Integer a_partIdx;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) := fun_1562(txt, a_simCode, a_indexJacobian, a_jacobianColumn, a_seedVars, a_matrixname, a_sparsepattern, a_colorList, a_maxColor, a_partIdx, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
end generateMatrix;

protected function fun_1564
  input Tpl.Text in_txt;
  input String in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           "dense" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("matrix_t"));
      then txt;

    case ( txt,
           "sparse" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("sparsematrix_t"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("A matrix type is not supported"));
      then txt;
  end match;
end fun_1564;

protected function lm_1565
  input Tpl.Text in_txt;
  input list<SimCode.JacobianColumn> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Integer in_a_partIdx;
  input String in_a_matrixName;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_partIdx, in_a_matrixName)
    local
      Tpl.Text txt;
      list<SimCode.JacobianColumn> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Integer a_partIdx;
      String a_matrixName;
      list<SimCode.SimEqSystem> i_eqs;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           SimCode.JAC_COLUMN(columnEqns = i_eqs) :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_partIdx,
           a_matrixName )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = functionJac(txt, i_eqs, a_matrixName, a_partIdx, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1565(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_partIdx, a_matrixName);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _ :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_partIdx,
           a_matrixName )
      equation
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1565(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_partIdx, a_matrixName);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_1565;

protected function lm_1566
  input Tpl.Text in_txt;
  input list<SimCode.JacobianColumn> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.JacobianColumn> rest;
      Integer i_nRows;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           SimCode.JAC_COLUMN(numberOfResultVars = i_nRows) :: rest )
      equation
        txt = Tpl.writeStr(txt, intString(i_nRows));
        txt = Tpl.nextIter(txt);
        txt = lm_1566(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_1566(txt, rest);
      then txt;
  end match;
end lm_1566;

protected function lm_1567
  input Tpl.Text in_txt;
  input list<SimCode.JacobianColumn> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.JacobianColumn> rest;
      list<SimCode.SimEqSystem> i_eqs;
      Integer ret_0;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           SimCode.JAC_COLUMN(columnEqns = i_eqs) :: rest )
      equation
        ret_0 = listLength(i_eqs);
        txt = Tpl.writeStr(txt, intString(ret_0));
        txt = Tpl.nextIter(txt);
        txt = lm_1567(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_1567(txt, rest);
      then txt;
  end match;
end lm_1567;

protected function fun_1568
  input Tpl.Text in_txt;
  input String in_mArg;
  input Integer in_a_i__index;
  input Integer in_a_index;
  input String in_a_matrixName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_i__index, in_a_index, in_a_matrixName)
    local
      Tpl.Text txt;
      Integer a_i__index;
      Integer a_index;
      String a_matrixName;

    case ( txt,
           "1",
           _,
           a_index,
           a_matrixName )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeStr(txt, a_matrixName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("jacobian(0,"));
        txt = Tpl.writeStr(txt, intString(a_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") = _"));
        txt = Tpl.writeStr(txt, a_matrixName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("jac_y(0);"));
      then txt;

    case ( txt,
           _,
           a_i__index,
           a_index,
           a_matrixName )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeStr(txt, a_matrixName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("jacobian("));
        txt = Tpl.writeStr(txt, intString(a_i__index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeStr(txt, intString(a_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") = _"));
        txt = Tpl.writeStr(txt, a_matrixName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("jac_y("));
        txt = Tpl.writeStr(txt, intString(a_i__index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then txt;
  end match;
end fun_1568;

protected function lm_1569
  input Tpl.Text in_txt;
  input list<Integer> in_items;
  input Integer in_a_index;
  input String in_a_matrixName;
  input Tpl.Text in_a_indexColumn;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_index, in_a_matrixName, in_a_indexColumn)
    local
      Tpl.Text txt;
      list<Integer> rest;
      Integer a_index;
      String a_matrixName;
      Tpl.Text a_indexColumn;
      Integer i_i__index;
      String str_0;

    case ( txt,
           {},
           _,
           _,
           _ )
      then txt;

    case ( txt,
           i_i__index :: rest,
           a_index,
           a_matrixName,
           a_indexColumn )
      equation
        str_0 = Tpl.textString(a_indexColumn);
        txt = fun_1568(txt, str_0, i_i__index, a_index, a_matrixName);
        txt = Tpl.nextIter(txt);
        txt = lm_1569(txt, rest, a_index, a_matrixName, a_indexColumn);
      then txt;
  end match;
end lm_1569;

protected function fun_1570
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("SystemLockFreeVariables slfv(this);"));
      then txt;
  end match;
end fun_1570;

protected function lm_1571
  input Tpl.Text in_txt;
  input SimCode.SparsityPattern in_items;
  input String in_a_matrixName;
  input Tpl.Text in_a_indexColumn;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_matrixName, in_a_indexColumn)
    local
      Tpl.Text txt;
      SimCode.SparsityPattern rest;
      String a_matrixName;
      Tpl.Text a_indexColumn;
      Integer x_index0;
      Integer i_index;
      list<Integer> i_indexes;
      Boolean ret_1;
      Tpl.Text l_jaccol;

    case ( txt,
           {},
           _,
           _ )
      then txt;

    case ( txt,
           (i_index, i_indexes) :: rest,
           a_matrixName,
           a_indexColumn )
      equation
        x_index0 = Tpl.getIteri_i0(txt);
        l_jaccol = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_jaccol = lm_1569(l_jaccol, i_indexes, i_index, a_matrixName, a_indexColumn);
        l_jaccol = Tpl.popIter(l_jaccol);
        ret_1 = intEq(x_index0, 1);
        txt = fun_1570(txt, ret_1);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeStr(txt, a_matrixName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("jac_x("));
        txt = Tpl.writeStr(txt, intString(x_index0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ") = 1;\n",
                                    "calc"
                                }, false));
        txt = Tpl.writeStr(txt, a_matrixName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "JacobianColumn();\n",
                                    "_"
                                }, false));
        txt = Tpl.writeStr(txt, a_matrixName);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("jac_x.clear();\n"));
        txt = Tpl.writeText(txt, l_jaccol);
        txt = Tpl.nextIter(txt);
        txt = lm_1571(txt, rest, a_matrixName, a_indexColumn);
      then txt;
  end match;
end lm_1571;

protected function fun_1572
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_matrixName;
  input Tpl.Text in_a_indexColumn;
  input SimCode.SparsityPattern in_a_sparsepattern;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_matrixName, in_a_indexColumn, in_a_sparsepattern)
    local
      Tpl.Text txt;
      String a_matrixName;
      Tpl.Text a_indexColumn;
      SimCode.SparsityPattern a_sparsepattern;

    case ( txt,
           false,
           a_matrixName,
           a_indexColumn,
           a_sparsepattern )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_1571(txt, a_sparsepattern, a_matrixName, a_indexColumn);
        txt = Tpl.popIter(txt);
      then txt;

    case ( txt,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_1572;

protected function fun_1573
  input Tpl.Text in_txt;
  input list<list<Integer>> in_a_colorList;
  input Integer in_a_indexJacobian;
  input SimCode.SparsityPattern in_a_sparsepattern;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Integer in_a_partIdx;
  input list<SimCode.JacobianColumn> in_a_jacobianColumn;
  input Tpl.Text in_a_matrixreturntype;
  input String in_a_matrixName;
  input Tpl.Text in_a_classname;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_a_colorList, in_a_indexJacobian, in_a_sparsepattern, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_partIdx, in_a_jacobianColumn, in_a_matrixreturntype, in_a_matrixName, in_a_classname)
    local
      Tpl.Text txt;
      Integer a_indexJacobian;
      SimCode.SparsityPattern a_sparsepattern;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Integer a_partIdx;
      list<SimCode.JacobianColumn> a_jacobianColumn;
      Tpl.Text a_matrixreturntype;
      String a_matrixName;
      Tpl.Text a_classname;
      Boolean ret_4;
      Tpl.Text l_jacvals;
      Tpl.Text l_eqsCount;
      Tpl.Text l_indexColumn;
      Tpl.Text l_jacMats;

    case ( txt,
           {},
           _,
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _,
           _,
           a_matrixreturntype,
           a_matrixName,
           a_classname )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = Tpl.writeText(txt, a_classname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Jacobian::calc"));
        txt = Tpl.writeStr(txt, a_matrixName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "JacobianColumn()\n",
                                    "{\n",
                                    "  throw ModelicaSimulationError(MATH_FUNCTION, \"Symbolic jacobians not is activated\");\n",
                                    "}\n",
                                    "\n"
                                }, true));
        txt = Tpl.writeText(txt, a_matrixreturntype);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("&  "));
        txt = Tpl.writeText(txt, a_classname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Jacobian::get"));
        txt = Tpl.writeStr(txt, a_matrixName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Jacobian()\n",
                                    "{\n",
                                    "  throw ModelicaSimulationError(MATH_FUNCTION, \"Symbolic jacobians not is activated\");\n",
                                    "}"
                                }, false));
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           a_indexJacobian,
           a_sparsepattern,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_partIdx,
           a_jacobianColumn,
           a_matrixreturntype,
           a_matrixName,
           a_classname )
      equation
        l_jacMats = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_jacMats, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1565(l_jacMats, a_jacobianColumn, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_partIdx, a_matrixName);
        l_jacMats = Tpl.popIter(l_jacMats);
        l_indexColumn = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_indexColumn = lm_1566(l_indexColumn, a_jacobianColumn);
        l_indexColumn = Tpl.popIter(l_indexColumn);
        l_eqsCount = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING("+")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_eqsCount = lm_1567(l_eqsCount, a_jacobianColumn);
        l_eqsCount = Tpl.popIter(l_eqsCount);
        ret_4 = stringEq(Tpl.textString(l_eqsCount), "0");
        l_jacvals = fun_1572(Tpl.emptyTxt, ret_4, a_matrixName, l_indexColumn, a_sparsepattern);
        txt = Tpl.writeText(txt, l_jacMats);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_matrixreturntype);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("&  "));
        txt = Tpl.writeText(txt, a_classname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Jacobian::get"));
        txt = Tpl.writeStr(txt, a_matrixName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Jacobian()\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/*Index "));
        txt = Tpl.writeStr(txt, intString(a_indexJacobian));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("*/\n"));
        txt = Tpl.writeText(txt, l_jacvals);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("return _"));
        txt = Tpl.writeStr(txt, a_matrixName);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("jacobian;\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_1573;

protected function fun_1574
  input Tpl.Text in_txt;
  input list<SimCode.JacobianColumn> in_a_jacobianColumn;
  input Integer in_a_indexJacobian;
  input SimCode.SparsityPattern in_a_sparsepattern;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Integer in_a_partIdx;
  input list<list<Integer>> in_a_colorList;
  input Tpl.Text in_a_matrixreturntype;
  input String in_a_matrixName;
  input Tpl.Text in_a_classname;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_a_jacobianColumn, in_a_indexJacobian, in_a_sparsepattern, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_partIdx, in_a_colorList, in_a_matrixreturntype, in_a_matrixName, in_a_classname)
    local
      Tpl.Text txt;
      Integer a_indexJacobian;
      SimCode.SparsityPattern a_sparsepattern;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Integer a_partIdx;
      list<list<Integer>> a_colorList;
      Tpl.Text a_matrixreturntype;
      String a_matrixName;
      Tpl.Text a_classname;
      list<SimCode.JacobianColumn> i_jacobianColumn;

    case ( txt,
           {},
           _,
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _,
           _,
           a_matrixreturntype,
           a_matrixName,
           a_classname )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = Tpl.writeText(txt, a_classname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Jacobian::calc"));
        txt = Tpl.writeStr(txt, a_matrixName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "JacobianColumn()\n",
                                    "{\n",
                                    "  throw ModelicaSimulationError(MATH_FUNCTION, \"Symbolic jacobians not is activated\");\n",
                                    "\n",
                                    "}\n",
                                    "\n"
                                }, true));
        txt = Tpl.writeText(txt, a_matrixreturntype);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("&  "));
        txt = Tpl.writeText(txt, a_classname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Jacobian::get"));
        txt = Tpl.writeStr(txt, a_matrixName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Jacobian()\n",
                                    "{\n",
                                    "  throw ModelicaSimulationError(MATH_FUNCTION, \"Symbolic jacobians not is activated\");\n",
                                    "}"
                                }, false));
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           i_jacobianColumn,
           a_indexJacobian,
           a_sparsepattern,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_partIdx,
           a_colorList,
           a_matrixreturntype,
           a_matrixName,
           a_classname )
      equation
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_1573(txt, a_colorList, a_indexJacobian, a_sparsepattern, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_partIdx, i_jacobianColumn, a_matrixreturntype, a_matrixName, a_classname);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_1574;

protected function fun_1575
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Integer in_a_indexJacobian;
  input list<SimCode.JacobianColumn> in_a_jacobianColumn;
  input String in_a_matrixName;
  input SimCode.SparsityPattern in_a_sparsepattern;
  input list<list<Integer>> in_a_colorList;
  input Integer in_a_partIdx;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_simCode, in_a_indexJacobian, in_a_jacobianColumn, in_a_matrixName, in_a_sparsepattern, in_a_colorList, in_a_partIdx, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      Integer a_indexJacobian;
      list<SimCode.JacobianColumn> a_jacobianColumn;
      String a_matrixName;
      SimCode.SparsityPattern a_sparsepattern;
      list<list<Integer>> a_colorList;
      Integer a_partIdx;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      SimCode.SimCode i_simCode;
      Absyn.Path i_modelInfo_name;
      Tpl.Text l_classname;
      String str_3;
      Tpl.Text l_matrixreturntype;
      String ret_1;
      Tpl.Text l_type;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = i_modelInfo_name))),
           a_indexJacobian,
           a_jacobianColumn,
           a_matrixName,
           a_sparsepattern,
           a_colorList,
           a_partIdx,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        ret_1 = Flags.getConfigString(Flags.MATRIX_FORMAT);
        l_type = Tpl.writeStr(Tpl.emptyTxt, ret_1);
        str_3 = Tpl.textString(l_type);
        l_matrixreturntype = fun_1564(Tpl.emptyTxt, str_3);
        l_classname = lastIdentOfPath(Tpl.emptyTxt, i_modelInfo_name);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_1574(txt, a_jacobianColumn, a_indexJacobian, a_sparsepattern, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, i_simCode, a_partIdx, a_colorList, l_matrixreturntype, a_matrixName, l_classname);
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           _,
           _,
           _,
           _,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end fun_1575;

public function generateJacobianMatrix
  input Tpl.Text txt;
  input SimCode.ModelInfo a_modelInfo;
  input Integer a_indexJacobian;
  input list<SimCode.JacobianColumn> a_jacobianColumn;
  input list<SimCodeVar.SimVar> a_seedVars;
  input String a_matrixName;
  input SimCode.SparsityPattern a_sparsepattern;
  input list<list<Integer>> a_colorList;
  input Integer a_partIdx;
  input Integer a_maxColor;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) := fun_1575(txt, a_simCode, a_indexJacobian, a_jacobianColumn, a_matrixName, a_sparsepattern, a_colorList, a_partIdx, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
end generateJacobianMatrix;

public function variableDefinitionsJacobians_skip
  input Tpl.Text txt;
  input list<SimCode.JacobianMatrix> a_JacobianMatrixes;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_jacobianVarsInit;
  input Boolean a_createDebugCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_jacobianVarsInit;
algorithm
  out_txt := txt;
  out_a_extraFuncs := a_extraFuncs;
  out_a_extraFuncsDecl := a_extraFuncsDecl;
  out_a_extraFuncsNamespace := a_extraFuncsNamespace;
  out_a_jacobianVarsInit := a_jacobianVarsInit;
end variableDefinitionsJacobians_skip;

protected function lm_1578
  input Tpl.Text in_txt;
  input list<SimCode.JacobianMatrix> in_items;
  input Boolean in_a_createDebugCode;
  input Tpl.Text in_a_jacobianVarsInit;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_jacobianVarsInit;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_jacobianVarsInit, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_createDebugCode, in_a_jacobianVarsInit, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCode.JacobianMatrix> rest;
      Boolean a_createDebugCode;
      Tpl.Text a_jacobianVarsInit;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      String i_name;
      list<SimCodeVar.SimVar> i_seedVars;
      list<SimCode.JacobianColumn> i_jacColumn;
      Integer i_jacIndex;
      Tpl.Text l_varsDef;

    case ( txt,
           {},
           _,
           a_jacobianVarsInit,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_jacobianVarsInit, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           SimCode.JAC_MATRIX(columns = i_jacColumn, seedVars = i_seedVars, matrixName = i_name, jacobianIndex = i_jacIndex) :: rest,
           a_createDebugCode,
           a_jacobianVarsInit,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (l_varsDef, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_jacobianVarsInit) = variableDefinitionsJacobians2(Tpl.emptyTxt, i_jacIndex, i_jacColumn, i_seedVars, i_name, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_jacobianVarsInit, a_createDebugCode);
        txt = Tpl.writeText(txt, l_varsDef);
        txt = Tpl.nextIter(txt);
        (txt, a_jacobianVarsInit, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1578(txt, rest, a_createDebugCode, a_jacobianVarsInit, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_jacobianVarsInit, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _ :: rest,
           a_createDebugCode,
           a_jacobianVarsInit,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_jacobianVarsInit, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1578(txt, rest, a_createDebugCode, a_jacobianVarsInit, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_jacobianVarsInit, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_1578;

public function variableDefinitionsJacobians
  input Tpl.Text txt;
  input list<SimCode.JacobianMatrix> a_JacobianMatrixes;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_jacobianVarsInit;
  input Boolean a_createDebugCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_jacobianVarsInit;
protected
  Tpl.Text l_analyticVars;
algorithm
  l_analyticVars := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (l_analyticVars, out_a_jacobianVarsInit, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) := lm_1578(l_analyticVars, a_JacobianMatrixes, a_createDebugCode, a_jacobianVarsInit, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
  l_analyticVars := Tpl.popIter(l_analyticVars);
  out_txt := Tpl.writeTok(txt, Tpl.ST_LINE("/* Jacobian Variables */\n"));
  out_txt := Tpl.writeText(out_txt, l_analyticVars);
end variableDefinitionsJacobians;

protected function lm_1580
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Boolean in_a_createDebugCode;
  input Tpl.Text in_a_jacobianVarsInit;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input String in_a_name;
  input Integer in_a_indexJacobian;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_jacobianVarsInit;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_jacobianVarsInit, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_createDebugCode, in_a_jacobianVarsInit, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_name, in_a_indexJacobian)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Boolean a_createDebugCode;
      Tpl.Text a_jacobianVarsInit;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      String a_name;
      Integer a_indexJacobian;
      Integer x_index0;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _,
           a_jacobianVarsInit,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _,
           _ )
      then (txt, a_jacobianVarsInit, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           i_var :: rest,
           a_createDebugCode,
           a_jacobianVarsInit,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_name,
           a_indexJacobian )
      equation
        x_index0 = Tpl.getIteri_i0(txt);
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_jacobianVarsInit) = jacobianVarDefine(txt, i_var, a_indexJacobian, x_index0, a_name, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_jacobianVarsInit, a_createDebugCode);
        txt = Tpl.nextIter(txt);
        (txt, a_jacobianVarsInit, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1580(txt, rest, a_createDebugCode, a_jacobianVarsInit, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_name, a_indexJacobian);
      then (txt, a_jacobianVarsInit, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_1580;

protected function lm_1581
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Boolean in_a_createDebugCode;
  input Tpl.Text in_a_jacobianVarsInit;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input String in_a_name;
  input Integer in_a_indexJacobian;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_jacobianVarsInit;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_jacobianVarsInit, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_createDebugCode, in_a_jacobianVarsInit, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_name, in_a_indexJacobian)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Boolean a_createDebugCode;
      Tpl.Text a_jacobianVarsInit;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      String a_name;
      Integer a_indexJacobian;
      Integer x_index0;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _,
           a_jacobianVarsInit,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _,
           _ )
      then (txt, a_jacobianVarsInit, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           i_var :: rest,
           a_createDebugCode,
           a_jacobianVarsInit,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_name,
           a_indexJacobian )
      equation
        x_index0 = Tpl.getIteri_i0(txt);
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_jacobianVarsInit) = jacobianVarDefine(txt, i_var, a_indexJacobian, x_index0, a_name, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_jacobianVarsInit, a_createDebugCode);
        txt = Tpl.nextIter(txt);
        (txt, a_jacobianVarsInit, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1581(txt, rest, a_createDebugCode, a_jacobianVarsInit, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_name, a_indexJacobian);
      then (txt, a_jacobianVarsInit, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_1581;

protected function lm_1582
  input Tpl.Text in_txt;
  input list<SimCode.JacobianColumn> in_items;
  input Boolean in_a_createDebugCode;
  input Tpl.Text in_a_jacobianVarsInit;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input String in_a_name;
  input Integer in_a_indexJacobian;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_jacobianVarsInit;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_jacobianVarsInit, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_createDebugCode, in_a_jacobianVarsInit, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_name, in_a_indexJacobian)
    local
      Tpl.Text txt;
      list<SimCode.JacobianColumn> rest;
      Boolean a_createDebugCode;
      Tpl.Text a_jacobianVarsInit;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      String a_name;
      Integer a_indexJacobian;
      list<SimCodeVar.SimVar> i_vars;

    case ( txt,
           {},
           _,
           a_jacobianVarsInit,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _,
           _ )
      then (txt, a_jacobianVarsInit, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           SimCode.JAC_COLUMN(columnVars = i_vars) :: rest,
           a_createDebugCode,
           a_jacobianVarsInit,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_name,
           a_indexJacobian )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_jacobianVarsInit, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1581(txt, i_vars, a_createDebugCode, a_jacobianVarsInit, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_name, a_indexJacobian);
        txt = Tpl.popIter(txt);
        txt = Tpl.nextIter(txt);
        (txt, a_jacobianVarsInit, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1582(txt, rest, a_createDebugCode, a_jacobianVarsInit, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_name, a_indexJacobian);
      then (txt, a_jacobianVarsInit, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _ :: rest,
           a_createDebugCode,
           a_jacobianVarsInit,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_name,
           a_indexJacobian )
      equation
        (txt, a_jacobianVarsInit, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1582(txt, rest, a_createDebugCode, a_jacobianVarsInit, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_name, a_indexJacobian);
      then (txt, a_jacobianVarsInit, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_1582;

public function variableDefinitionsJacobians2
  input Tpl.Text txt;
  input Integer a_indexJacobian;
  input list<SimCode.JacobianColumn> a_jacobianColumn;
  input list<SimCodeVar.SimVar> a_seedVars;
  input String a_name;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_jacobianVarsInit;
  input Boolean a_createDebugCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_jacobianVarsInit;
protected
  Tpl.Text l_columnVarsResult;
  Tpl.Text l_seedVarsResult;
algorithm
  l_seedVarsResult := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (l_seedVarsResult, out_a_jacobianVarsInit, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) := lm_1580(l_seedVarsResult, a_seedVars, a_createDebugCode, a_jacobianVarsInit, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_name, a_indexJacobian);
  l_seedVarsResult := Tpl.popIter(l_seedVarsResult);
  l_columnVarsResult := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING_LIST({
                                                                                        "\n",
                                                                                        "\n"
                                                                                    }, true)), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (l_columnVarsResult, out_a_jacobianVarsInit, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) := lm_1582(l_columnVarsResult, a_jacobianColumn, a_createDebugCode, out_a_jacobianVarsInit, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, a_simCode, a_name, a_indexJacobian);
  l_columnVarsResult := Tpl.popIter(l_columnVarsResult);
  out_txt := Tpl.writeText(txt, l_seedVarsResult);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeText(out_txt, l_columnVarsResult);
end variableDefinitionsJacobians2;

protected function fun_1584
  input Tpl.Text in_txt;
  input BackendDAE.VarKind in_a_varKind;
  input Integer in_a_index0;
  input Integer in_a_index;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_varKind, in_a_index0, in_a_index)
    local
      Tpl.Text txt;
      Integer a_index0;
      Integer a_index;

    case ( txt,
           BackendDAE.JAC_VAR(),
           _,
           a_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("jac_y("));
        txt = Tpl.writeStr(txt, intString(a_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           BackendDAE.JAC_DIFF_VAR(),
           _,
           a_index )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("jac_tmp("));
        txt = Tpl.writeStr(txt, intString(a_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           BackendDAE.SEED_VAR(),
           a_index0,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("jac_x("));
        txt = Tpl.writeStr(txt, intString(a_index0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("UNKNOWN KIND"));
      then txt;
  end match;
end fun_1584;

protected function fun_1585
  input Tpl.Text in_txt;
  input Option<String> in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;
      String i_val;

    case ( txt,
           SOME(i_val) )
      equation
        txt = Tpl.writeStr(txt, i_val);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_1585;

protected function fun_1586
  input Tpl.Text in_txt;
  input Boolean in_a_createDebugCode;
  input Tpl.Text in_a_typeName;
  input Option<String> in_a_matrixName;
  input Tpl.Text in_a_jacobianVar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_createDebugCode, in_a_typeName, in_a_matrixName, in_a_jacobianVar)
    local
      Tpl.Text txt;
      Tpl.Text a_typeName;
      Option<String> a_matrixName;
      Tpl.Text a_jacobianVar;

    case ( txt,
           false,
           _,
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_typeName,
           a_matrixName,
           a_jacobianVar )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, a_jacobianVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(_"));
        txt = fun_1585(txt, a_matrixName);
        txt = Tpl.writeText(txt, a_typeName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;
  end match;
end fun_1586;

protected function fun_1587
  input Tpl.Text in_txt;
  input Option<String> in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;
      String i_val;

    case ( txt,
           SOME(i_val) )
      equation
        txt = Tpl.writeStr(txt, i_val);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_1587;

protected function fun_1588
  input Tpl.Text in_txt;
  input Boolean in_a_createDebugCode;
  input Tpl.Text in_a_typeName;
  input Option<String> in_a_matrixName;
  input Tpl.Text in_a_jacobianVar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_createDebugCode, in_a_typeName, in_a_matrixName, in_a_jacobianVar)
    local
      Tpl.Text txt;
      Tpl.Text a_typeName;
      Option<String> a_matrixName;
      Tpl.Text a_jacobianVar;

    case ( txt,
           false,
           a_typeName,
           a_matrixName,
           a_jacobianVar )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#define "));
        txt = Tpl.writeText(txt, a_jacobianVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" _"));
        txt = fun_1587(txt, a_matrixName);
        txt = Tpl.writeText(txt, a_typeName);
      then txt;

    case ( txt,
           _,
           _,
           _,
           a_jacobianVar )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("double& "));
        txt = Tpl.writeText(txt, a_jacobianVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_1588;

protected function fun_1589
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_a_simVar;
  input Integer in_a_index0;
  input Tpl.Text in_a_jacobianVarsInit;
  input Boolean in_a_createDebugCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_jacobianVarsInit;
algorithm
  (out_txt, out_a_jacobianVarsInit) :=
  match(in_txt, in_a_simVar, in_a_index0, in_a_jacobianVarsInit, in_a_createDebugCode)
    local
      Tpl.Text txt;
      Integer a_index0;
      Tpl.Text a_jacobianVarsInit;
      Boolean a_createDebugCode;
      Option<String> i_matrixName;
      Integer i_index;
      BackendDAE.VarKind i_varKind;
      DAE.ComponentRef i_name;
      Tpl.Text l_typeName;
      Tpl.Text l_jacobianVar;

    case ( txt,
           SimCodeVar.SIMVAR(aliasvar = SimCodeVar.NOALIAS(), name = i_name, index = i_index, varKind = i_varKind, matrixName = i_matrixName),
           a_index0,
           a_jacobianVarsInit,
           a_createDebugCode )
      equation
        l_jacobianVar = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("_"));
        l_jacobianVar = CodegenCppCommonOld.crefToCStr(l_jacobianVar, i_name, false);
        l_typeName = fun_1584(Tpl.emptyTxt, i_varKind, a_index0, i_index);
        a_jacobianVarsInit = fun_1586(a_jacobianVarsInit, a_createDebugCode, l_typeName, i_matrixName, l_jacobianVar);
        txt = fun_1588(txt, a_createDebugCode, l_typeName, i_matrixName, l_jacobianVar);
      then (txt, a_jacobianVarsInit);

    case ( txt,
           _,
           _,
           a_jacobianVarsInit,
           _ )
      then (txt, a_jacobianVarsInit);
  end match;
end fun_1589;

public function jacobianVarDefine
  input Tpl.Text txt;
  input SimCodeVar.SimVar a_simVar;
  input Integer a_indexJac;
  input Integer a_index0;
  input String a_matrixName;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_jacobianVarsInit;
  input Boolean a_createDebugCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_jacobianVarsInit;
algorithm
  (out_txt, out_a_jacobianVarsInit) := fun_1589(txt, a_simVar, a_index0, a_jacobianVarsInit, a_createDebugCode);
  out_a_extraFuncs := a_extraFuncs;
  out_a_extraFuncsDecl := a_extraFuncsDecl;
  out_a_extraFuncsNamespace := a_extraFuncsNamespace;
end jacobianVarDefine;

protected function lm_1591
  input Tpl.Text in_txt;
  input list<DAE.Statement> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Statement> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      SimCodeFunction.Context a_context;
      DAE.Statement i_stmt;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           i_stmt :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_context )
      equation
        (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = algStatement(txt, i_stmt, a_context, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = lm_1591(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_context);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);
  end match;
end lm_1591;

protected function lm_1592
  input Tpl.Text in_txt;
  input list<DAE.Statement> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Statement> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      SimCodeFunction.Context a_context;
      DAE.Statement i_stmt;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           i_stmt :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_context )
      equation
        (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = algStatement(txt, i_stmt, a_context, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = lm_1592(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_context);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);
  end match;
end lm_1592;

public function equationAlgorithm
  input Tpl.Text in_txt;
  input SimCode.SimEqSystem in_a_eq;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_eq, in_a_context, in_a_varDecls, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_varDecls;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      list<DAE.Statement> i_statements;

    case ( txt,
           SimCode.SES_ALGORITHM(statements = i_statements),
           a_context,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = lm_1591(txt, i_statements, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_context);
        txt = Tpl.popIter(txt);
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           SimCode.SES_INVERSE_ALGORITHM(statements = i_statements),
           a_context,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = lm_1592(txt, i_statements, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_context);
        txt = Tpl.popIter(txt);
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end equationAlgorithm;

protected function fun_1594
  input Tpl.Text in_txt;
  input DAE.Statement in_a_stmt;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) :=
  match(in_txt, in_a_stmt, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_context)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      SimCodeFunction.Context a_context;
      DAE.Statement i_s;

    case ( txt,
           DAE.STMT_ASSIGN(exp1 = DAE.PATTERN(pattern = _)),
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("STMT_ASSIGN Pattern not supported yet"));
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           (i_s as DAE.STMT_ASSIGN(type_ = _)),
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_context )
      equation
        (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = algStmtAssign(txt, i_s, a_context, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           (i_s as DAE.STMT_ASSIGN_ARR(type_ = _)),
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_context )
      equation
        (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = algStmtAssignArr(txt, i_s, a_context, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           (i_s as DAE.STMT_TUPLE_ASSIGN(type_ = _)),
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_context )
      equation
        (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.algStmtTupleAssign(txt, i_s, a_context, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           (i_s as DAE.STMT_IF(exp = _)),
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_context )
      equation
        (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = algStmtIf(txt, i_s, a_context, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           (i_s as DAE.STMT_FOR(type_ = _)),
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_context )
      equation
        (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = algStmtFor(txt, i_s, a_context, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           (i_s as DAE.STMT_WHILE(exp = _)),
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_context )
      equation
        (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = algStmtWhile(txt, i_s, a_context, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           (i_s as DAE.STMT_ASSERT(cond = _)),
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_context )
      equation
        (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = algStmtAssert(txt, i_s, a_context, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           (i_s as DAE.STMT_TERMINATE(msg = _)),
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_context )
      equation
        (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = algStmtTerminate(txt, i_s, a_context, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           (i_s as DAE.STMT_WHEN(exp = _)),
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_context )
      equation
        (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = algStmtWhen(txt, i_s, a_context, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           DAE.STMT_BREAK(source = _),
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("break;"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           DAE.STMT_FAILURE(body = _),
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("STMT FAILURE"));
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           DAE.STMT_RETURN(source = _),
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("break;/*Todo stmt return*/"));
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           (i_s as DAE.STMT_NORETCALL(exp = _)),
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_context )
      equation
        (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = algStmtNoretcall(txt, i_s, a_context, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           (i_s as DAE.STMT_REINIT(var = _)),
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_context )
      equation
        (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = algStmtReinit(txt, i_s, a_context, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           _ )
      equation
        txt = CodegenCppCommonOld.error(txt, Tpl.sourceInfo("CodegenCppOld.tpl", 13255, 14), "ALG_STATEMENT NYI");
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);
  end match;
end fun_1594;

public function algStatement
  input Tpl.Text txt;
  input DAE.Statement a_stmt;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_varDecls;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
protected
  SourceInfo ret_2;
  DAE.ElementSource ret_1;
  Tpl.Text l_res;
algorithm
  (l_res, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) := fun_1594(Tpl.emptyTxt, a_stmt, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_context);
  ret_1 := Algorithm.getStatementSource(a_stmt);
  ret_2 := ElementSource.getElementSourceFileInfo(ret_1);
  out_txt := modelicaLine(txt, ret_2);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeText(out_txt, l_res);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := endModelicaLine(out_txt);
end algStatement;

protected function lm_1596
  input Tpl.Text in_txt;
  input list<DAE.Statement> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Statement> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      SimCodeFunction.Context a_context;
      DAE.Statement i_stmt;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           i_stmt :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_context )
      equation
        (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = algStatement(txt, i_stmt, a_context, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = lm_1596(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_context);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);
  end match;
end lm_1596;

public function algStmtWhile
  input Tpl.Text in_txt;
  input DAE.Statement in_a_stmt;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_stmt, in_a_context, in_a_varDecls, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_varDecls;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      list<DAE.Statement> i_statementLst;
      DAE.Exp i_exp;
      Tpl.Text l_var;
      Tpl.Text l_preExp;

    case ( txt,
           DAE.STMT_WHILE(exp = i_exp, statementLst = i_statementLst),
           a_context,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_var, l_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.daeExp(Tpl.emptyTxt, i_exp, a_context, l_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("while (1) {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if (!"));
        txt = Tpl.writeText(txt, l_var);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(") break;\n"));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = lm_1596(txt, i_statementLst, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_context);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end algStmtWhile;

public function algStmtTerminate
  input Tpl.Text in_txt;
  input DAE.Statement in_a_stmt;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_stmt, in_a_context, in_a_varDecls, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_varDecls;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      DAE.Exp i_msg;
      Tpl.Text l_msgVar;
      Tpl.Text l_preExp;

    case ( txt,
           DAE.STMT_TERMINATE(msg = i_msg),
           a_context,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_msgVar, l_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.daeExp(Tpl.emptyTxt, i_msg, a_context, l_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_terminate=true;"));
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end algStmtTerminate;

protected function fun_1599
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input SourceInfo in_a_info;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_info)
    local
      Tpl.Text txt;
      SourceInfo a_info;
      String ret_0;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_info )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/*#modelicaLine "));
        ret_0 = Error.infoStr(a_info);
        txt = Tpl.writeStr(txt, ret_0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("*/"));
      then txt;
  end match;
end fun_1599;

public function modelicaLine
  input Tpl.Text in_txt;
  input SourceInfo in_a_info;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_info)
    local
      Tpl.Text txt;
      SourceInfo i_info;
      Boolean ret_2;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           SOURCEINFO(columnNumberStart = 0) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/* Dummy Line */"));
      then txt;

    case ( txt,
           i_info )
      equation
        ret_0 = Config.acceptMetaModelicaGrammar();
        ret_1 = Flags.isSet(Flags.GEN_DEBUG_SYMBOLS);
        ret_2 = boolOr(ret_0, ret_1);
        txt = fun_1599(txt, ret_2, i_info);
      then txt;
  end match;
end modelicaLine;

protected function fun_1601
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/*#endModelicaLine*/"));
      then txt;
  end match;
end fun_1601;

public function endModelicaLine
  input Tpl.Text txt;

  output Tpl.Text out_txt;
protected
  Boolean ret_2;
  Boolean ret_1;
  Boolean ret_0;
algorithm
  ret_0 := Config.acceptMetaModelicaGrammar();
  ret_1 := Flags.isSet(Flags.GEN_DEBUG_SYMBOLS);
  ret_2 := boolOr(ret_0, ret_1);
  out_txt := fun_1601(txt, ret_2);
end endModelicaLine;

protected function fun_1603
  input Tpl.Text in_txt;
  input DAE.Type in_a_var_ty;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input SimCodeFunction.Context in_a_context;
  input DAE.ComponentRef in_a_cr;
  input DAE.Ident in_a_var_name;
  input Tpl.Text in_a_varNameStr;
  input Tpl.Text in_a_rec;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_a_var_ty, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_context, in_a_cr, in_a_var_name, in_a_varNameStr, in_a_rec)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      SimCodeFunction.Context a_context;
      DAE.ComponentRef a_cr;
      DAE.Ident a_var_name;
      Tpl.Text a_varNameStr;
      Tpl.Text a_rec;
      DAE.Type i_var_ty;
      DAE.ComponentRef ret_3;
      Tpl.Text l_varPart;
      DAE.ComponentRef ret_1;
      Tpl.Text txt_0;

    case ( txt,
           (i_var_ty as DAE.T_ARRAY(ty = _)),
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_context,
           a_cr,
           a_var_name,
           a_varNameStr,
           a_rec )
      equation
        txt_0 = Tpl.writeText(Tpl.emptyTxt, a_rec);
        txt_0 = Tpl.writeTok(txt_0, Tpl.ST_STRING("."));
        txt_0 = Tpl.writeText(txt_0, a_varNameStr);
        ret_1 = ComponentReference.appendStringCref(a_var_name, a_cr);
        txt = copyArrayData(txt, i_var_ty, Tpl.textString(txt_0), ret_1, a_context);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_context,
           a_cr,
           a_var_name,
           a_varNameStr,
           a_rec )
      equation
        ret_3 = ComponentReference.appendStringCref(a_var_name, a_cr);
        (l_varPart, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.contextCref(Tpl.emptyTxt, ret_3, a_context, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeText(txt, l_varPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, a_rec);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("."));
        txt = Tpl.writeText(txt, a_varNameStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_1603;

protected function lm_1604
  input Tpl.Text in_txt;
  input list<DAE.Var> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input SimCodeFunction.Context in_a_context;
  input DAE.ComponentRef in_a_cr;
  input Tpl.Text in_a_rec;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_context, in_a_cr, in_a_rec)
    local
      Tpl.Text txt;
      list<DAE.Var> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      SimCodeFunction.Context a_context;
      DAE.ComponentRef a_cr;
      Tpl.Text a_rec;
      DAE.Type i_var_ty;
      DAE.Ident i_var_name;
      DAE.ComponentRef ret_1;
      Tpl.Text l_varNameStr;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           DAE.TYPES_VAR(name = i_var_name, ty = i_var_ty) :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_context,
           a_cr,
           a_rec )
      equation
        ret_1 = ComponentReference.makeUntypedCrefIdent(i_var_name);
        l_varNameStr = CodegenCppCommonOld.crefStr(Tpl.emptyTxt, ret_1);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_1603(txt, i_var_ty, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_context, a_cr, i_var_name, l_varNameStr, a_rec);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1604(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_context, a_cr, a_rec);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _ :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_context,
           a_cr,
           a_rec )
      equation
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1604(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_context, a_cr, a_rec);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_1604;

protected function lm_1605
  input Tpl.Text in_txt;
  input list<DAE.Var> in_items;
  input Tpl.Text in_a_rec;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;
  input list<DAE.Exp> in_a_expLst;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_rec, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_preExp, in_a_context, in_a_expLst)
    local
      Tpl.Text txt;
      list<DAE.Var> rest;
      Tpl.Text a_rec;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      list<DAE.Exp> a_expLst;
      Integer x_i1;
      DAE.Ident i_var_name;
      DAE.ComponentRef ret_2;
      DAE.Exp ret_1;
      Tpl.Text l_re;

    case ( txt,
           {},
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           a_preExp,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);

    case ( txt,
           DAE.TYPES_VAR(name = i_var_name) :: rest,
           a_rec,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp,
           a_context,
           a_expLst )
      equation
        x_i1 = Tpl.getIteri_i0(txt);
        ret_1 = listGet(a_expLst, x_i1);
        (l_re, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.daeExp(Tpl.emptyTxt, ret_1, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeText(txt, l_re);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, a_rec);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("."));
        ret_2 = ComponentReference.makeUntypedCrefIdent(i_var_name);
        txt = CodegenCppCommonOld.crefStr(txt, ret_2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = lm_1605(txt, rest, a_rec, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context, a_expLst);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);

    case ( txt,
           _ :: rest,
           a_rec,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp,
           a_context,
           a_expLst )
      equation
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = lm_1605(txt, rest, a_rec, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp, a_context, a_expLst);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);
  end match;
end lm_1605;

protected function fun_1606
  input Tpl.Text in_txt;
  input DAE.Exp in_a_exp;
  input DAE.Exp in_a_val;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) :=
  match(in_txt, in_a_exp, in_a_val, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_context)
    local
      Tpl.Text txt;
      DAE.Exp a_val;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      SimCodeFunction.Context a_context;
      DAE.Exp i_idx;
      DAE.Exp i_arr;
      Tpl.Text l_val1;
      Tpl.Text l_idx1;
      Tpl.Text l_arr1;
      Tpl.Text l_preExp;

    case ( txt,
           DAE.ASUB(exp = i_arr, sub = {i_idx}),
           a_val,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_context )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_arr1, l_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.daeExp(Tpl.emptyTxt, i_arr, a_context, l_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        (l_idx1, l_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.daeExp(Tpl.emptyTxt, i_idx, a_context, l_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        (l_val1, l_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.daeExp(Tpl.emptyTxt, a_val, a_context, l_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("arrayUpdate("));
        txt = Tpl.writeText(txt, l_arr1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, l_idx1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, l_val1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           _,
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);
  end match;
end fun_1606;

protected function fun_1607
  input Tpl.Text in_txt;
  input String in_mArg;
  input DAE.Exp in_a_exp1;
  input DAE.Exp in_a_val;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input SimCodeFunction.Context in_a_context;
  input DAE.Exp in_a_exp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) :=
  match(in_txt, in_mArg, in_a_exp1, in_a_val, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_context, in_a_exp)
    local
      Tpl.Text txt;
      DAE.Exp a_exp1;
      DAE.Exp a_val;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      SimCodeFunction.Context a_context;
      DAE.Exp a_exp;
      Tpl.Text l_expPart;
      Tpl.Text l_varPart;
      Tpl.Text l_preExp;

    case ( txt,
           "metatype",
           _,
           a_val,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_context,
           a_exp )
      equation
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = fun_1606(txt, a_exp, a_val, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_context);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           _,
           a_exp1,
           a_val,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_context,
           _ )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_varPart, l_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.daeExpAsub(Tpl.emptyTxt, a_exp1, a_context, l_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        (l_expPart, l_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.daeExp(Tpl.emptyTxt, a_val, a_context, l_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_varPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, l_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);
  end match;
end fun_1607;

public function algStmtAssign
  input Tpl.Text in_txt;
  input DAE.Statement in_a_stmt;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_stmt, in_a_context, in_a_varDecls, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_varDecls;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      DAE.Exp i_val;
      list<DAE.Exp> i_expLst;
      DAE.ComponentRef i_cr;
      list<DAE.Var> i_varLst;
      DAE.Exp i_exp;
      DAE.Exp i_exp1;
      DAE.Exp i_e;
      Tpl.Text l_expPart2;
      Tpl.Text l_expPart1;
      String str_5;
      Tpl.Text txt_4;
      Tpl.Text l_rec;
      Tpl.Text l_varPart;
      Tpl.Text l_expPart;
      Tpl.Text l_preExp;

    case ( txt,
           DAE.STMT_ASSIGN(exp1 = DAE.CREF(componentRef = DAE.WILD()), exp = i_e),
           a_context,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_expPart, l_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.daeExp(Tpl.emptyTxt, i_e, a_context, l_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_preExp);
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.STMT_ASSIGN(exp1 = (i_exp1 as DAE.CREF(ty = DAE.T_FUNCTION_REFERENCE_VAR(functionType = _))), exp = i_exp),
           a_context,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_varPart, l_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.scalarLhsCref(Tpl.emptyTxt, i_exp1, a_context, l_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        (l_expPart, l_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.daeExp(Tpl.emptyTxt, i_exp, a_context, l_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_varPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = (modelica_fnptr) "));
        txt = Tpl.writeText(txt, l_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.STMT_ASSIGN(exp1 = (i_exp1 as DAE.CREF(ty = DAE.T_FUNCTION_REFERENCE_FUNC(builtin = _))), exp = i_exp),
           a_context,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_varPart, l_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.scalarLhsCref(Tpl.emptyTxt, i_exp1, a_context, l_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        (l_expPart, l_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.daeExp(Tpl.emptyTxt, i_exp, a_context, l_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_varPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = (modelica_fnptr) "));
        txt = Tpl.writeText(txt, l_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.STMT_ASSIGN(exp1 = DAE.CREF(componentRef = i_cr, ty = DAE.T_COMPLEX(varLst = i_varLst, complexClassType = ClassInf.RECORD(path = _))), exp = i_exp),
           a_context,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_rec, l_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.daeExp(Tpl.emptyTxt, i_exp, a_context, l_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1604(txt, i_varLst, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_context, i_cr, l_rec);
        txt = Tpl.popIter(txt);
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.STMT_ASSIGN(exp1 = DAE.CALL(path = _, expLst = i_expLst, attr = DAE.CALL_ATTR(ty = DAE.T_COMPLEX(varLst = i_varLst, complexClassType = ClassInf.RECORD(path = _)))), exp = i_exp),
           a_context,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_rec, l_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.daeExp(Tpl.emptyTxt, i_exp, a_context, l_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(1, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, l_preExp) = lm_1605(txt, i_varLst, l_rec, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, l_preExp, a_context, i_expLst);
        txt = Tpl.popIter(txt);
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.STMT_ASSIGN(exp1 = (i_exp1 as DAE.CREF(componentRef = _)), exp = i_exp),
           a_context,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_varPart, l_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.scalarLhsCref(Tpl.emptyTxt, i_exp1, a_context, l_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        (l_expPart, l_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.daeExp(Tpl.emptyTxt, i_exp, a_context, l_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_varPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, l_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " /*stmtAssign*/;\n",
                                    "\n"
                                }, true));
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.STMT_ASSIGN(exp1 = (i_exp1 as DAE.ASUB(exp = _)), exp = (i_exp as i_val)),
           a_context,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        txt_4 = CodegenCppCommonOld.expTypeFromExpShort(Tpl.emptyTxt, i_exp);
        str_5 = Tpl.textString(txt_4);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = fun_1607(txt, str_5, i_exp1, i_val, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_context, i_exp);
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.STMT_ASSIGN(exp1 = i_exp1, exp = i_exp),
           a_context,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_expPart1, l_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.daeExp(Tpl.emptyTxt, i_exp1, a_context, l_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        (l_expPart2, l_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.daeExp(Tpl.emptyTxt, i_exp, a_context, l_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/*assign8*/\n"));
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_expPart1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, l_expPart2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end algStmtAssign;

public function copyArrayData
  input Tpl.Text txt;
  input DAE.Type a_ty;
  input String a_exp;
  input DAE.ComponentRef a_cr;
  input SimCodeFunction.Context a_context;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_cref;
  Tpl.Text l_type;
algorithm
  l_type := CodegenCppCommonOld.expTypeShort(Tpl.emptyTxt, a_ty);
  l_cref := CodegenCppCommonOld.contextArrayCref(Tpl.emptyTxt, a_cr, a_context);
  out_txt := Tpl.writeText(txt, l_cref);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING(".assign("));
  out_txt := Tpl.writeStr(out_txt, a_exp);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING(");"));
end copyArrayData;

protected function lm_1610
  input Tpl.Text in_txt;
  input list<DAE.ComponentRef> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_varDeclsCref;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_varDeclsCref;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_varDeclsCref, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_varDeclsCref, in_a_context, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      list<DAE.ComponentRef> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_varDeclsCref;
      SimCodeFunction.Context a_context;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      DAE.ComponentRef i_e;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_varDeclsCref,
           _,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           i_e :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_varDeclsCref,
           a_context,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("|| ("));
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_varDeclsCref, a_stateDerVectorName) = CodegenCppCommonOld.cref1(txt, i_e, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_context, a_varDeclsCref, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" && !_discrete_events->pre("));
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_varDeclsCref, a_stateDerVectorName) = CodegenCppCommonOld.cref1(txt, i_e, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_context, a_varDeclsCref, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("))"));
        txt = Tpl.popBlock(txt);
        (txt, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1610(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_varDeclsCref, a_context, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_1610;

protected function lm_1611
  input Tpl.Text in_txt;
  input list<DAE.Statement> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Statement> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      SimCodeFunction.Context a_context;
      DAE.Statement i_stmt;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           i_stmt :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_context )
      equation
        (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = algStatement(txt, i_stmt, a_context, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = lm_1611(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_context);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);
  end match;
end lm_1611;

protected function fun_1612
  input Tpl.Text in_txt;
  input DAE.Statement in_a_when;
  input Tpl.Text in_a_varDecls;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_varDecls, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_a_when, in_a_varDecls, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_context, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      Tpl.Text a_varDecls;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      SimCodeFunction.Context a_context;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Option<DAE.Statement> i_elseWhen;
      list<DAE.Statement> i_statementLst;
      list<DAE.ComponentRef> i_conditions;
      Tpl.Text l_else;
      Tpl.Text l_statements;
      Tpl.Text l_helpIf;
      Tpl.Text l_varDeclsCref;

    case ( txt,
           DAE.STMT_WHEN(conditions = i_conditions, statementLst = i_statementLst, elseWhen = i_elseWhen),
           a_varDecls,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_context,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        l_varDeclsCref = Tpl.emptyTxt;
        (l_helpIf, a_stateDerVectorName, l_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1610(Tpl.emptyTxt, i_conditions, a_useFlatArrayNotation, a_stateDerVectorName, l_varDeclsCref, a_context, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
        l_statements = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_statements, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = lm_1611(l_statements, i_statementLst, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_context);
        l_statements = Tpl.popIter(l_statements);
        (l_else, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = algStatementWhenElse(Tpl.emptyTxt, i_elseWhen, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_context, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if (0"));
        txt = Tpl.writeText(txt, l_helpIf);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(") {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_statements);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("}\n"));
        txt = Tpl.writeText(txt, l_else);
      then (txt, a_varDecls, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           a_varDecls,
           _,
           a_stateDerVectorName,
           _,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_varDecls, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_1612;

protected function fun_1613
  input Tpl.Text in_txt;
  input SimCodeFunction.Context in_a_context;
  input DAE.Statement in_a_when;
  input Tpl.Text in_a_varDecls;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_context, in_a_when, in_a_varDecls, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      DAE.Statement a_when;
      Tpl.Text a_varDecls;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      SimCodeFunction.Context i_context;

    case ( txt,
           (i_context as SimCodeFunction.SIMULATION_CONTEXT(genDiscrete = _)),
           a_when,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (txt, a_varDecls, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_1612(txt, a_when, a_varDecls, a_useFlatArrayNotation, a_stateDerVectorName, i_context, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end fun_1613;

public function algStmtWhen
  input Tpl.Text txt;
  input DAE.Statement a_when;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_varDecls;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) := fun_1613(txt, a_context, a_when, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
end algStmtWhen;

protected function lm_1615
  input Tpl.Text in_txt;
  input list<DAE.ComponentRef> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_varDeclsCref;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_varDeclsCref;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_varDeclsCref, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_varDeclsCref, in_a_context, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      list<DAE.ComponentRef> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_varDeclsCref;
      SimCodeFunction.Context a_context;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      DAE.ComponentRef i_e;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_varDeclsCref,
           _,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      then (txt, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           i_e :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_varDeclsCref,
           a_context,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("|| ("));
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_varDeclsCref, a_stateDerVectorName) = CodegenCppCommonOld.cref1(txt, i_e, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_context, a_varDeclsCref, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" && !_discrete_events->pre("));
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_varDeclsCref, a_stateDerVectorName) = CodegenCppCommonOld.cref1(txt, i_e, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_context, a_varDeclsCref, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("))"));
        txt = Tpl.popBlock(txt);
        (txt, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1615(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_varDeclsCref, a_context, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_stateDerVectorName, a_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_1615;

protected function lm_1616
  input Tpl.Text in_txt;
  input list<DAE.Statement> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls)
    local
      Tpl.Text txt;
      list<DAE.Statement> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      DAE.Statement i_stmt;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           i_stmt :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls )
      equation
        (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = algStatement(txt, i_stmt, SimCodeFunction.contextSimulationDiscrete, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = lm_1616(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);
  end match;
end lm_1616;

public function algStatementWhenElse
  input Tpl.Text in_txt;
  input Option<DAE.Statement> in_a_stmt;
  input Tpl.Text in_a_varDecls;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_stmt, in_a_varDecls, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_context, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      Tpl.Text a_varDecls;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      SimCodeFunction.Context a_context;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      Option<DAE.Statement> i_when_elseWhen;
      list<DAE.Statement> i_when_statementLst;
      list<DAE.ComponentRef> i_when_conditions;
      Tpl.Text l_elseCondStr;
      Tpl.Text l_varDeclsCref;

    case ( txt,
           SOME(DAE.STMT_WHEN(conditions = i_when_conditions, statementLst = i_when_statementLst, elseWhen = i_when_elseWhen)),
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_context,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_varDeclsCref = Tpl.emptyTxt;
        (l_elseCondStr, a_stateDerVectorName, l_varDeclsCref, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1615(Tpl.emptyTxt, i_when_conditions, a_useFlatArrayNotation, a_stateDerVectorName, l_varDeclsCref, a_context, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("else if (0"));
        txt = Tpl.writeText(txt, l_elseCondStr);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(") {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = lm_1616(txt, i_when_statementLst, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("}\n"));
        (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = algStatementWhenElse(txt, i_when_elseWhen, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_context, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           _,
           a_stateDerVectorName,
           _ )
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end algStatementWhenElse;

public function algStmtAssert
  input Tpl.Text in_txt;
  input DAE.Statement in_a_stmt;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_stmt, in_a_context, in_a_varDecls, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_varDecls;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      SourceInfo i_info;
      DAE.Exp i_level;
      DAE.Exp i_msg;
      DAE.Exp i_cond;

    case ( txt,
           DAE.STMT_ASSERT(source = DAE.SOURCE(info = i_info), cond = i_cond, msg = i_msg, level = i_level),
           a_context,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = assertCommon(txt, i_cond, i_msg, i_level, a_context, a_varDecls, i_info, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end algStmtAssert;

public function algStmtReinit
  input Tpl.Text in_txt;
  input DAE.Statement in_a_stmt;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_stmt, in_a_context, in_a_varDecls, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_varDecls;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      DAE.Exp i_value;
      DAE.Exp i_var;
      Tpl.Text l_expPart2;
      Tpl.Text l_expPart1;
      Tpl.Text l_preExp;

    case ( txt,
           DAE.STMT_REINIT(var = i_var, value = i_value),
           a_context,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_expPart1, l_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.daeExp(Tpl.emptyTxt, i_var, a_context, l_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        (l_expPart2, l_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.daeExp(Tpl.emptyTxt, i_value, a_context, l_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_discrete_events->save("));
        txt = Tpl.writeText(txt, l_expPart1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeText(txt, l_expPart1);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(");\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeText(txt, l_expPart1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, l_expPart2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end algStmtReinit;

protected function lm_1620
  input Tpl.Text in_txt;
  input list<DAE.Statement> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Statement> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      SimCodeFunction.Context a_context;
      DAE.Statement i_stmt;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           i_stmt :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_context )
      equation
        (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = algStatement(txt, i_stmt, a_context, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = lm_1620(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_context);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);
  end match;
end lm_1620;

public function algStmtIf
  input Tpl.Text in_txt;
  input DAE.Statement in_a_stmt;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_stmt, in_a_context, in_a_varDecls, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_varDecls;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      DAE.Else i_else__;
      list<DAE.Statement> i_statementLst;
      DAE.Exp i_exp;
      Tpl.Text l_condExp;
      Tpl.Text l_preExp;

    case ( txt,
           DAE.STMT_IF(exp = i_exp, statementLst = i_statementLst, else_ = i_else__),
           a_context,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_condExp, l_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.daeExp(Tpl.emptyTxt, i_exp, a_context, l_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if "));
        txt = CodegenCppCommonOld.encloseInParantheses(txt, Tpl.textString(l_condExp));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = lm_1620(txt, i_statementLst, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_context);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("}\n"));
        (txt, l_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = elseExpr(txt, i_else__, a_context, l_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end algStmtIf;

protected function lm_1622
  input Tpl.Text in_txt;
  input list<DAE.Statement> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Statement> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      SimCodeFunction.Context a_context;
      DAE.Statement i_it;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           i_it :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_context )
      equation
        (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = algStatement(txt, i_it, a_context, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = lm_1622(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_context);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);
  end match;
end lm_1622;

protected function lm_1623
  input Tpl.Text in_txt;
  input list<DAE.Statement> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Statement> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      SimCodeFunction.Context a_context;
      DAE.Statement i_it;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           i_it :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_context )
      equation
        (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = algStatement(txt, i_it, a_context, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = lm_1623(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_context);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);
  end match;
end lm_1623;

protected function fun_1624
  input Tpl.Text in_txt;
  input DAE.Else in_a_it;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_it, in_a_context, in_a_varDecls, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_varDecls;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      DAE.Else i_else__;
      list<DAE.Statement> i_statementLst;
      DAE.Exp i_exp;
      Tpl.Text l_condExp;
      Tpl.Text l_preExp;

    case ( txt,
           DAE.NOELSE(),
           _,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.ELSEIF(exp = i_exp, statementLst = i_statementLst, else_ = i_else__),
           a_context,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_condExp, l_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.daeExp(Tpl.emptyTxt, i_exp, a_context, l_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("else {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if "));
        txt = CodegenCppCommonOld.encloseInParantheses(txt, Tpl.textString(l_condExp));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = lm_1622(txt, i_statementLst, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_context);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("}\n"));
        (txt, l_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = elseExpr(txt, i_else__, a_context, l_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           DAE.ELSE(statementLst = i_statementLst),
           a_context,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("else {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = lm_1623(txt, i_statementLst, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_context);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end fun_1624;

public function elseExpr
  input Tpl.Text txt;
  input DAE.Else a_it;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_preExp;
  input Tpl.Text a_varDecls;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_preExp;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) := fun_1624(txt, a_it, a_context, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
  out_a_preExp := a_preExp;
end elseExpr;

public function algStmtFor
  input Tpl.Text in_txt;
  input DAE.Statement in_a_stmt;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_stmt, in_a_context, in_a_varDecls, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_varDecls;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      DAE.Statement i_s;

    case ( txt,
           (i_s as DAE.STMT_FOR(range = DAE.RANGE(ty = _))),
           a_context,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = algStmtForRange(txt, i_s, a_context, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           (i_s as DAE.STMT_FOR(type_ = _)),
           a_context,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = algStmtForGeneric(txt, i_s, a_context, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end algStmtFor;

protected function lm_1627
  input Tpl.Text in_txt;
  input list<DAE.Statement> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Statement> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      SimCodeFunction.Context a_context;
      DAE.Statement i_stmt;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           i_stmt :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_context )
      equation
        (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = algStatement(txt, i_stmt, a_context, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = lm_1627(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_context);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);
  end match;
end lm_1627;

public function algStmtForGeneric
  input Tpl.Text in_txt;
  input DAE.Statement in_a_stmt;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_stmt, in_a_context, in_a_varDecls, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_varDecls;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      DAE.Ident i_iter;
      DAE.Exp i_range;
      list<DAE.Statement> i_statementLst;
      Boolean i_iterIsArray;
      DAE.Type i_type__;
      Tpl.Text l_stmtStr;
      Tpl.Text l_arrayType;
      Tpl.Text l_iterType;

    case ( txt,
           DAE.STMT_FOR(type_ = i_type__, iterIsArray = i_iterIsArray, statementLst = i_statementLst, range = i_range, iter = i_iter),
           a_context,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_iterType = CodegenCppCommonOld.expType(Tpl.emptyTxt, i_type__, i_iterIsArray);
        l_arrayType = CodegenCppCommonOld.expTypeShort(Tpl.emptyTxt, i_type__);
        l_stmtStr = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_stmtStr, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = lm_1627(l_stmtStr, i_statementLst, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_context);
        l_stmtStr = Tpl.popIter(l_stmtStr);
        (txt, l_stmtStr, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = algStmtForGeneric_impl(txt, i_range, i_iter, Tpl.textString(l_iterType), Tpl.textString(l_arrayType), i_iterIsArray, l_stmtStr, a_context, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end algStmtForGeneric;

public function algStmtForGeneric_impl
  input Tpl.Text txt;
  input DAE.Exp a_exp;
  input Absyn.Ident a_iterator;
  input String a_type;
  input String a_arrayType;
  input Boolean a_iterIsArray;
  input Tpl.Text a_body;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_varDecls;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_body;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
protected
  Tpl.Text l_evar;
  Tpl.Text l_tmpVar;
  Tpl.Text l_preExp;
  Tpl.Text l_iterName;
algorithm
  l_iterName := CodegenCppCommonOld.contextIteratorName(Tpl.emptyTxt, a_iterator, a_context);
  l_preExp := Tpl.emptyTxt;
  l_tmpVar := Tpl.emptyTxt;
  (l_evar, l_preExp, l_tmpVar, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) := CodegenCppCommonOld.daeExp(Tpl.emptyTxt, a_exp, a_context, l_preExp, l_tmpVar, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
  out_txt := Tpl.writeText(txt, l_preExp);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("FOREACH("));
  out_txt := Tpl.writeStr(out_txt, a_type);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING(" "));
  out_txt := Tpl.writeText(out_txt, l_iterName);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING(", "));
  out_txt := Tpl.writeText(out_txt, l_evar);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE(") {\n"));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeText(out_txt, a_body);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("}"));
  out_a_body := a_body;
  out_a_varDecls := a_varDecls;
end algStmtForGeneric_impl;

public function algStmtNoretcall
  input Tpl.Text in_txt;
  input DAE.Statement in_a_stmt;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_stmt, in_a_context, in_a_varDecls, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_varDecls;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      DAE.Exp i_exp;
      Tpl.Text l_expPart;
      Tpl.Text l_preExp;

    case ( txt,
           DAE.STMT_NORETCALL(exp = i_exp),
           a_context,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_expPart, l_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.daeExp(Tpl.emptyTxt, i_exp, a_context, l_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("//No retcall\n"));
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "  //No retcall"
                                }, false));
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end algStmtNoretcall;

protected function lm_1631
  input Tpl.Text in_txt;
  input list<DAE.Statement> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_context)
    local
      Tpl.Text txt;
      list<DAE.Statement> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      SimCodeFunction.Context a_context;
      DAE.Statement i_stmt;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           i_stmt :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_context )
      equation
        (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = algStatement(txt, i_stmt, a_context, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = lm_1631(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_context);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);
  end match;
end lm_1631;

public function algStmtForRange
  input Tpl.Text in_txt;
  input DAE.Statement in_a_stmt;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_stmt, in_a_context, in_a_varDecls, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_varDecls;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      DAE.Ident i_iter;
      DAE.Exp i_rng;
      list<DAE.Statement> i_statementLst;
      Boolean i_iterIsArray;
      DAE.Type i_type__;
      Tpl.Text l_stmtStr;
      Tpl.Text l_identTypeShort;
      Tpl.Text l_identType;

    case ( txt,
           DAE.STMT_FOR(range = (i_rng as DAE.RANGE(ty = _)), type_ = i_type__, iterIsArray = i_iterIsArray, statementLst = i_statementLst, iter = i_iter),
           a_context,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_identType = CodegenCppCommonOld.expType(Tpl.emptyTxt, i_type__, i_iterIsArray);
        l_identTypeShort = CodegenCppCommonOld.expTypeShort(Tpl.emptyTxt, i_type__);
        l_stmtStr = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_stmtStr, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = lm_1631(l_stmtStr, i_statementLst, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_context);
        l_stmtStr = Tpl.popIter(l_stmtStr);
        (txt, l_stmtStr, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = algStmtForRange_impl(txt, i_rng, i_iter, Tpl.textString(l_identType), Tpl.textString(l_identTypeShort), l_stmtStr, a_context, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end algStmtForRange;

protected function fun_1633
  input Tpl.Text in_txt;
  input Option<DAE.Exp> in_a_step;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_a_step, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_preExp, in_a_context)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      SimCodeFunction.Context a_context;
      DAE.Exp i_eo;

    case ( txt,
           SOME(i_eo),
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp,
           a_context )
      equation
        (txt, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.daeExp(txt, i_eo, a_context, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);

    case ( txt,
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           a_preExp,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("1"));
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);
  end match;
end fun_1633;

protected function fun_1634
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_stepVar;
  input Tpl.Text in_a_startVar;
  input Tpl.Text in_a_stopVar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_stepVar, in_a_startVar, in_a_stopVar)
    local
      Tpl.Text txt;
      Tpl.Text a_stepVar;
      Tpl.Text a_startVar;
      Tpl.Text a_stopVar;

    case ( txt,
           false,
           a_stepVar,
           a_startVar,
           a_stopVar )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(int)(("));
        txt = Tpl.writeText(txt, a_stopVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" - "));
        txt = Tpl.writeText(txt, a_startVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") / "));
        txt = Tpl.writeText(txt, a_stepVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" + 1e-10);"));
      then txt;

    case ( txt,
           _,
           a_stepVar,
           a_startVar,
           a_stopVar )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_stopVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" - "));
        txt = Tpl.writeText(txt, a_startVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(") / "));
        txt = Tpl.writeText(txt, a_stepVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_1634;

protected function fun_1635
  input Tpl.Text in_txt;
  input DAE.Exp in_a_range;
  input Absyn.Ident in_a_iterator;
  input Tpl.Text in_a_body;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_range, in_a_iterator, in_a_body, in_a_context, in_a_varDecls, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      Absyn.Ident a_iterator;
      Tpl.Text a_body;
      SimCodeFunction.Context a_context;
      Tpl.Text a_varDecls;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      DAE.Exp i_stop;
      Option<DAE.Exp> i_step;
      DAE.Exp i_start;
      DAE.Type i_ty;
      Boolean ret_10;
      Tpl.Text l_stopValue;
      Tpl.Text l_stepValue;
      Tpl.Text l_startValue;
      Tpl.Text l_preExp;
      Tpl.Text l_stopVar;
      Tpl.Text l_stepVar;
      Tpl.Text l_startVar;
      Tpl.Text l_iterName;
      Tpl.Text l_iterVar;
      Tpl.Text l_type;

    case ( txt,
           DAE.RANGE(ty = i_ty, start = i_start, step = i_step, stop = i_stop),
           a_iterator,
           a_body,
           a_context,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_type = CodegenCppCommonOld.expTypeShort(Tpl.emptyTxt, i_ty);
        (l_iterVar, a_varDecls) = CodegenCppCommonOld.tempDecl(Tpl.emptyTxt, "int", a_varDecls);
        l_iterName = CodegenCppCommonOld.contextIteratorName(Tpl.emptyTxt, a_iterator, a_context);
        (l_startVar, a_varDecls) = CodegenCppCommonOld.tempDecl(Tpl.emptyTxt, Tpl.textString(l_type), a_varDecls);
        (l_stepVar, a_varDecls) = CodegenCppCommonOld.tempDecl(Tpl.emptyTxt, Tpl.textString(l_type), a_varDecls);
        (l_stopVar, a_varDecls) = CodegenCppCommonOld.tempDecl(Tpl.emptyTxt, Tpl.textString(l_type), a_varDecls);
        l_preExp = Tpl.emptyTxt;
        (l_startValue, l_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.daeExp(Tpl.emptyTxt, i_start, a_context, l_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        (l_stepValue, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, l_preExp) = fun_1633(Tpl.emptyTxt, i_step, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, l_preExp, a_context);
        (l_stopValue, l_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.daeExp(Tpl.emptyTxt, i_stop, a_context, l_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_startVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, l_startValue);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("; "));
        txt = Tpl.writeText(txt, l_stepVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, l_stepValue);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("; "));
        txt = Tpl.writeText(txt, l_stopVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, l_stopValue);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "if(!"
                                }, false));
        txt = Tpl.writeText(txt, l_stepVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ")\n",
                                    "{\n",
                                    "\n",
                                    "\n",
                                    "}\n",
                                    "else if(!((("
                                }, false));
        txt = Tpl.writeText(txt, l_stepVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" > 0) && ("));
        txt = Tpl.writeText(txt, l_startVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" > "));
        txt = Tpl.writeText(txt, l_stopVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")) || (("));
        txt = Tpl.writeText(txt, l_stepVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" < 0) && ("));
        txt = Tpl.writeText(txt, l_startVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" < "));
        txt = Tpl.writeText(txt, l_stopVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "))))\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_type);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, l_iterName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "int "
                                }, false));
        txt = Tpl.writeText(txt, l_iterVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_end = "));
        ret_10 = stringEq(Tpl.textString(l_type), "int");
        txt = fun_1634(txt, ret_10, l_stepVar, l_startVar, l_stopVar);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("for ("));
        txt = Tpl.writeText(txt, l_iterVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = 0; "));
        txt = Tpl.writeText(txt, l_iterVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" <= "));
        txt = Tpl.writeText(txt, l_iterVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_end; "));
        txt = Tpl.writeText(txt, l_iterVar);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("++) {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_iterName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeText(txt, l_startVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" + "));
        txt = Tpl.writeText(txt, l_iterVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" * "));
        txt = Tpl.writeText(txt, l_stepVar);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.writeText(txt, a_body);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("}\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           _,
           _,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end fun_1635;

public function algStmtForRange_impl
  input Tpl.Text txt;
  input DAE.Exp a_range;
  input Absyn.Ident a_iterator;
  input String a_type;
  input String a_shortType;
  input Tpl.Text a_body;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_varDecls;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_body;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) := fun_1635(txt, a_range, a_iterator, a_body, a_context, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
  out_a_body := a_body;
end algStmtForRange_impl;

public function algStmtAssignArr
  input Tpl.Text in_txt;
  input DAE.Statement in_a_stmt;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_varDecls;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_stmt, in_a_context, in_a_varDecls, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Tpl.Text a_varDecls;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      DAE.Exp i_lhsexp;
      DAE.Exp i_e;
      Tpl.Text l_dest;
      Tpl.Text l_expPart;
      Tpl.Text l_preExp;

    case ( txt,
           DAE.STMT_ASSIGN_ARR(exp = i_e, lhs = (i_lhsexp as DAE.CREF(componentRef = _)), type_ = _),
           a_context,
           a_varDecls,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_expPart, l_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.daeExp(Tpl.emptyTxt, i_e, a_context, l_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        (l_dest, l_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.daeExp(Tpl.emptyTxt, i_lhsexp, a_context, l_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_dest);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".assign("));
        txt = Tpl.writeText(txt, l_expPart);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           a_varDecls,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName,
           _ )
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end algStmtAssignArr;

protected function lm_1638
  input Tpl.Text in_txt;
  input list<tuple<Integer, tuple<DAE.Exp, DAE.Exp, DAE.Exp>>> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<tuple<Integer, tuple<DAE.Exp, DAE.Exp, DAE.Exp>>> rest;
      Integer i_id;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           (i_id, (_, _, _)) :: rest )
      equation
        txt = Tpl.writeStr(txt, intString(i_id));
        txt = Tpl.nextIter(txt);
        txt = lm_1638(txt, rest);
      then txt;
  end match;
end lm_1638;

protected function fun_1639
  input Tpl.Text in_txt;
  input SimCode.DelayedExpression in_a_delayed;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_delayed)
    local
      Tpl.Text txt;
      list<tuple<Integer, tuple<DAE.Exp, DAE.Exp, DAE.Exp>>> i_delayedExps;

    case ( txt,
           SimCode.DELAYED_EXPRESSIONS(delayedExps = i_delayedExps) )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(" LIST_SEP ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_1638(txt, i_delayedExps);
        txt = Tpl.popIter(txt);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_1639;

protected function lm_1640
  input Tpl.Text in_txt;
  input list<tuple<Integer, tuple<DAE.Exp, DAE.Exp, DAE.Exp>>> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_preExp)
    local
      Tpl.Text txt;
      list<tuple<Integer, tuple<DAE.Exp, DAE.Exp, DAE.Exp>>> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      DAE.Exp i_delayMax;
      Tpl.Text l_delayExpMax;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           a_preExp )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);

    case ( txt,
           (_, (_, _, i_delayMax)) :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp )
      equation
        (l_delayExpMax, a_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.daeExp(Tpl.emptyTxt, i_delayMax, SimCodeFunction.contextSimulationNonDiscrete, a_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeText(txt, l_delayExpMax);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = lm_1640(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);
  end match;
end lm_1640;

protected function fun_1641
  input Tpl.Text in_txt;
  input SimCode.DelayedExpression in_a_delayed;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_preExp;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_preExp;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls, out_a_preExp) :=
  match(in_txt, in_a_delayed, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls, in_a_preExp)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_preExp;
      list<tuple<Integer, tuple<DAE.Exp, DAE.Exp, DAE.Exp>>> i_delayedExps;

    case ( txt,
           SimCode.DELAYED_EXPRESSIONS(delayedExps = i_delayedExps),
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls,
           a_preExp )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(" LIST_SEP ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp) = lm_1640(txt, i_delayedExps, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls, a_preExp);
        txt = Tpl.popIter(txt);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);

    case ( txt,
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls,
           a_preExp )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_preExp);
  end match;
end fun_1641;

protected function fun_1642
  input Tpl.Text in_txt;
  input Tpl.Text in_a_delay__id;
  input Tpl.Text in_a_delay__max;
  input Tpl.Text in_a_preExp;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_delay__id, in_a_delay__max, in_a_preExp, in_a_varDecls)
    local
      Tpl.Text txt;
      Tpl.Text a_delay__max;
      Tpl.Text a_preExp;
      Tpl.Text a_varDecls;
      Tpl.Text i_delay__id;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           _,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
      then txt;

    case ( txt,
           i_delay__id,
           a_delay__max,
           a_preExp,
           a_varDecls )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("//init delay expressions\n"));
        txt = Tpl.writeText(txt, a_varDecls);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, a_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("vector<double> delay_max = LIST_OF "));
        txt = Tpl.writeText(txt, a_delay__max);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " LIST_END;\n",
                                    "vector<unsigned int> delay_ids = LIST_OF "
                                }, false));
        txt = Tpl.writeText(txt, i_delay__id);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " LIST_END;\n",
                                    "intDelay(delay_ids, delay_max);"
                                }, false));
      then txt;
  end match;
end fun_1642;

public function functionInitDelay
  input Tpl.Text txt;
  input SimCode.DelayedExpression a_delayed;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
protected
  Tpl.Text l_delay__max;
  Tpl.Text l_delay__id;
  Tpl.Text l_preExp;
  Tpl.Text l_varDecls;
algorithm
  l_varDecls := Tpl.emptyTxt;
  l_preExp := Tpl.emptyTxt;
  l_delay__id := fun_1639(Tpl.emptyTxt, a_delayed);
  (l_delay__max, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, l_varDecls, l_preExp) := fun_1641(Tpl.emptyTxt, a_delayed, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, l_varDecls, l_preExp);
  out_txt := fun_1642(txt, l_delay__id, l_delay__max, l_preExp, l_varDecls);
end functionInitDelay;

protected function lm_1644
  input Tpl.Text in_txt;
  input list<tuple<Integer, tuple<DAE.Exp, DAE.Exp, DAE.Exp>>> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls)
    local
      Tpl.Text txt;
      list<tuple<Integer, tuple<DAE.Exp, DAE.Exp, DAE.Exp>>> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Integer i_id;
      DAE.Exp i_e;
      Tpl.Text l_eRes;
      Tpl.Text l_preExp;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           (i_id, (i_e, _, _)) :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls )
      equation
        l_preExp = Tpl.emptyTxt;
        (l_eRes, l_preExp, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = CodegenCppCommonOld.daeExp(Tpl.emptyTxt, i_e, SimCodeFunction.contextSimulationNonDiscrete, l_preExp, a_varDecls, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeText(txt, l_preExp);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("storeDelay("));
        txt = Tpl.writeStr(txt, intString(i_id));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeText(txt, l_eRes);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(",time);"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.popBlock(txt);
        txt = Tpl.popBlock(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = lm_1644(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);
  end match;
end lm_1644;

protected function fun_1645
  input Tpl.Text in_txt;
  input SimCode.DelayedExpression in_a_delayed;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) :=
  match(in_txt, in_a_delayed, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_varDecls)
    local
      Tpl.Text txt;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      list<tuple<Integer, tuple<DAE.Exp, DAE.Exp, DAE.Exp>>> i_delayedExps;

    case ( txt,
           SimCode.DELAYED_EXPRESSIONS(delayedExps = i_delayedExps),
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_varDecls )
      equation
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = lm_1644(txt, i_delayedExps, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_varDecls);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           a_varDecls )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);
  end match;
end fun_1645;

public function functionStoreDelay
  input Tpl.Text txt;
  input SimCode.DelayedExpression a_delayed;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
protected
  Tpl.Text l_storePart;
  Tpl.Text l_varDecls;
algorithm
  l_varDecls := Tpl.emptyTxt;
  (l_storePart, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, l_varDecls) := fun_1645(Tpl.emptyTxt, a_delayed, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, l_varDecls);
  out_txt := Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeText(out_txt, l_varDecls);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_LINE("storeTime(time);\n"));
  out_txt := Tpl.writeText(out_txt, l_storePart);
  out_txt := Tpl.popBlock(out_txt);
end functionStoreDelay;

protected function lm_1647
  input Tpl.Text in_txt;
  input list<list<SimCodeVar.SimVar>> in_items;
  input Tpl.Text in_a_funcArgs;
  input Integer in_a_indexOffset;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_funcParams;
  input Tpl.Text in_a_funcNamePrefix;
  input Tpl.Text in_a_funcCalls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_funcCalls;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_funcCalls) :=
  match(in_txt, in_items, in_a_funcArgs, in_a_indexOffset, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_context, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_funcParams, in_a_funcNamePrefix, in_a_funcCalls)
    local
      Tpl.Text txt;
      list<list<SimCodeVar.SimVar>> rest;
      Tpl.Text a_funcArgs;
      Integer a_indexOffset;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      SimCodeFunction.Context a_context;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_funcParams;
      Tpl.Text a_funcNamePrefix;
      Tpl.Text a_funcCalls;
      Integer x_idx;
      list<SimCodeVar.SimVar> i_ls;
      Tpl.Text l_init;
      Tpl.Text l_varDecls;

    case ( txt,
           {},
           _,
           _,
           _,
           a_stateDerVectorName,
           _,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _,
           _,
           a_funcCalls )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_funcCalls);

    case ( txt,
           i_ls :: rest,
           a_funcArgs,
           a_indexOffset,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_context,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_funcParams,
           a_funcNamePrefix,
           a_funcCalls )
      equation
        x_idx = Tpl.getIteri_i0(txt);
        l_varDecls = Tpl.emptyTxt;
        a_funcCalls = Tpl.writeText(a_funcCalls, a_funcNamePrefix);
        a_funcCalls = Tpl.writeTok(a_funcCalls, Tpl.ST_STRING("_"));
        a_funcCalls = Tpl.writeStr(a_funcCalls, intString(x_idx));
        a_funcCalls = Tpl.writeTok(a_funcCalls, Tpl.ST_STRING("("));
        a_funcCalls = Tpl.writeText(a_funcCalls, a_funcParams);
        a_funcCalls = Tpl.writeTok(a_funcCalls, Tpl.ST_STRING(");"));
        (l_init, l_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = getVariablesWithSplit2(Tpl.emptyTxt, i_ls, a_simCode, l_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_context, a_stateDerVectorName, a_useFlatArrayNotation, x_idx, 100, a_indexOffset);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = Tpl.writeText(txt, a_funcNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeStr(txt, intString(x_idx));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_funcArgs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ")\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(3));
        txt = Tpl.writeText(txt, l_varDecls);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_init);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_funcCalls) = lm_1647(txt, rest, a_funcArgs, a_indexOffset, a_useFlatArrayNotation, a_stateDerVectorName, a_context, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_funcParams, a_funcNamePrefix, a_funcCalls);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_funcCalls);
  end match;
end lm_1647;

public function getVariablesWithSplit
  input Tpl.Text txt;
  input Tpl.Text a_funcNamePrefix;
  input Tpl.Text a_funcArgs;
  input Tpl.Text a_funcParams;
  input list<SimCodeVar.SimVar> a_varsLst;
  input Integer a_indexOffset;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_funcCalls;
  input Tpl.Text a_extraFuncsNamespace;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_funcNamePrefix;
  output Tpl.Text out_a_funcArgs;
  output Tpl.Text out_a_funcParams;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_funcCalls;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
protected
  list<list<SimCodeVar.SimVar>> ret_1;
  Tpl.Text l_funcs;
algorithm
  ret_1 := List.partition(a_varsLst, 100);
  l_funcs := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (l_funcs, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_funcCalls) := lm_1647(l_funcs, ret_1, a_funcArgs, a_indexOffset, a_useFlatArrayNotation, a_stateDerVectorName, a_context, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_funcParams, a_funcNamePrefix, a_funcCalls);
  l_funcs := Tpl.popIter(l_funcs);
  out_txt := Tpl.writeText(txt, l_funcs);
  out_a_funcNamePrefix := a_funcNamePrefix;
  out_a_funcArgs := a_funcArgs;
  out_a_funcParams := a_funcParams;
end getVariablesWithSplit;

protected function lm_1649
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_varDecls;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_context, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_varDecls, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      SimCodeFunction.Context a_context;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_varDecls;
      SimCode.SimCode a_simCode;
      Integer x_i0;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           _,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_varDecls,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           i_var :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_context,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_varDecls,
           a_simCode )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = giveVariablesDefault(txt, i_var, x_i0, a_simCode, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_context, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = lm_1649(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_context, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_simCode);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);
  end match;
end lm_1649;

public function getVariablesWithSplit2
  input Tpl.Text txt;
  input list<SimCodeVar.SimVar> a_varsLst;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;
  input Integer a_multiplicator;
  input Integer a_partitionSize;
  input Integer a_indexOffset;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
protected
  Integer ret_1;
  Integer ret_0;
algorithm
  out_txt := Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
  ret_0 := intMul(a_multiplicator, a_partitionSize);
  ret_1 := intAdd(a_indexOffset, ret_0);
  out_txt := Tpl.pushIter(out_txt, Tpl.ITER_OPTIONS(ret_1, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) := lm_1649(out_txt, a_varsLst, a_useFlatArrayNotation, a_stateDerVectorName, a_context, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_simCode);
  out_txt := Tpl.popIter(out_txt);
  out_txt := Tpl.popBlock(out_txt);
end getVariablesWithSplit2;

protected function lm_1651
  input Tpl.Text in_txt;
  input list<list<SimCodeVar.SimVar>> in_items;
  input Tpl.Text in_a_funcArgs;
  input Integer in_a_indexOffset;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_funcParams;
  input Tpl.Text in_a_funcNamePrefix;
  input Tpl.Text in_a_funcCalls;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_funcCalls;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_funcCalls) :=
  match(in_txt, in_items, in_a_funcArgs, in_a_indexOffset, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_context, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_funcParams, in_a_funcNamePrefix, in_a_funcCalls)
    local
      Tpl.Text txt;
      list<list<SimCodeVar.SimVar>> rest;
      Tpl.Text a_funcArgs;
      Integer a_indexOffset;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      SimCodeFunction.Context a_context;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_funcParams;
      Tpl.Text a_funcNamePrefix;
      Tpl.Text a_funcCalls;
      Integer x_idx;
      list<SimCodeVar.SimVar> i_ls;
      Tpl.Text l_init;
      Tpl.Text l_varDecls;

    case ( txt,
           {},
           _,
           _,
           _,
           a_stateDerVectorName,
           _,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _,
           _,
           a_funcCalls )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_funcCalls);

    case ( txt,
           i_ls :: rest,
           a_funcArgs,
           a_indexOffset,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_context,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_funcParams,
           a_funcNamePrefix,
           a_funcCalls )
      equation
        x_idx = Tpl.getIteri_i0(txt);
        l_varDecls = Tpl.emptyTxt;
        a_funcCalls = Tpl.writeText(a_funcCalls, a_funcNamePrefix);
        a_funcCalls = Tpl.writeTok(a_funcCalls, Tpl.ST_STRING("_"));
        a_funcCalls = Tpl.writeStr(a_funcCalls, intString(x_idx));
        a_funcCalls = Tpl.writeTok(a_funcCalls, Tpl.ST_STRING("("));
        a_funcCalls = Tpl.writeText(a_funcCalls, a_funcParams);
        a_funcCalls = Tpl.writeTok(a_funcCalls, Tpl.ST_STRING(");"));
        (l_init, l_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = setVariablesWithSplit2(Tpl.emptyTxt, i_ls, a_simCode, l_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_context, a_stateDerVectorName, a_useFlatArrayNotation, x_idx, 100, a_indexOffset);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = Tpl.writeText(txt, a_funcNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        txt = Tpl.writeStr(txt, intString(x_idx));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeText(txt, a_funcArgs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ")\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(3));
        txt = Tpl.writeText(txt, l_varDecls);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_init);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_funcCalls) = lm_1651(txt, rest, a_funcArgs, a_indexOffset, a_useFlatArrayNotation, a_stateDerVectorName, a_context, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_funcParams, a_funcNamePrefix, a_funcCalls);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_funcCalls);
  end match;
end lm_1651;

public function setVariablesWithSplit
  input Tpl.Text txt;
  input Tpl.Text a_funcNamePrefix;
  input Tpl.Text a_funcArgs;
  input Tpl.Text a_funcParams;
  input list<SimCodeVar.SimVar> a_varsLst;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_funcCalls;
  input Integer a_indexOffset;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_funcNamePrefix;
  output Tpl.Text out_a_funcArgs;
  output Tpl.Text out_a_funcParams;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_funcCalls;
  output Tpl.Text out_a_stateDerVectorName;
protected
  list<list<SimCodeVar.SimVar>> ret_1;
  Tpl.Text l_funcs;
algorithm
  ret_1 := List.partition(a_varsLst, 100);
  l_funcs := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (l_funcs, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_funcCalls) := lm_1651(l_funcs, ret_1, a_funcArgs, a_indexOffset, a_useFlatArrayNotation, a_stateDerVectorName, a_context, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_funcParams, a_funcNamePrefix, a_funcCalls);
  l_funcs := Tpl.popIter(l_funcs);
  out_txt := Tpl.writeText(txt, l_funcs);
  out_a_funcNamePrefix := a_funcNamePrefix;
  out_a_funcArgs := a_funcArgs;
  out_a_funcParams := a_funcParams;
end setVariablesWithSplit;

protected function lm_1653
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_varDecls;
  input SimCode.SimCode in_a_simCode;
  input Integer in_a_indexOffset;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDecls;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_context, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_varDecls, in_a_simCode, in_a_indexOffset)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      SimCodeFunction.Context a_context;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_varDecls;
      SimCode.SimCode a_simCode;
      Integer a_indexOffset;
      Integer x_i0;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           _,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_varDecls,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);

    case ( txt,
           i_var :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_context,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_varDecls,
           a_simCode,
           a_indexOffset )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = setVariablesDefault(txt, i_var, x_i0, a_indexOffset, a_simCode, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_context, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls) = lm_1653(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_context, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_simCode, a_indexOffset);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls);
  end match;
end lm_1653;

public function setVariablesWithSplit2
  input Tpl.Text txt;
  input list<SimCodeVar.SimVar> a_varsLst;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_varDecls;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;
  input Integer a_multiplicator;
  input Integer a_partitionSize;
  input Integer a_indexOffset;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
protected
  Integer ret_0;
algorithm
  out_txt := Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
  ret_0 := intMul(a_multiplicator, a_partitionSize);
  out_txt := Tpl.pushIter(out_txt, Tpl.ITER_OPTIONS(ret_0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDecls) := lm_1653(out_txt, a_varsLst, a_useFlatArrayNotation, a_stateDerVectorName, a_context, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDecls, a_simCode, a_indexOffset);
  out_txt := Tpl.popIter(out_txt);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_NEW_LINE());
  out_txt := Tpl.popBlock(out_txt);
end setVariablesWithSplit2;

protected function lm_1655
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_varDeclsString;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_varDeclsString;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs, out_a_varDeclsString) :=
  match(in_txt, in_items, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_context, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_varDeclsString, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      SimCodeFunction.Context a_context;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_varDeclsString;
      SimCode.SimCode a_simCode;
      Integer x_i0;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _,
           a_stateDerVectorName,
           _,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_varDeclsString,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDeclsString);

    case ( txt,
           i_var :: rest,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_context,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_varDeclsString,
           a_simCode )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        (txt, a_varDeclsString, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = setVariablesDefault(txt, i_var, x_i0, 0, a_simCode, a_varDeclsString, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_context, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDeclsString) = lm_1655(txt, rest, a_useFlatArrayNotation, a_stateDerVectorName, a_context, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDeclsString, a_simCode);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_varDeclsString);
  end match;
end lm_1655;

public function giveVariables
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;
  input SimCodeFunction.Context in_a_context;
  input Boolean in_a_useFlatArrayNotation;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_stateDerVectorName;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_modelInfo, in_a_context, in_a_useFlatArrayNotation, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_stateDerVectorName)
    local
      Tpl.Text txt;
      SimCodeFunction.Context a_context;
      Boolean a_useFlatArrayNotation;
      SimCode.SimCode a_simCode;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_stateDerVectorName;
      SimCode.ModelInfo i_modelInfo;
      Absyn.Path i_name;
      list<SimCodeVar.SimVar> i_vars_stringAliasVars;
      list<SimCodeVar.SimVar> i_vars_stringParamVars;
      list<SimCodeVar.SimVar> i_vars_stringAlgVars;
      list<SimCodeVar.SimVar> ret_9;
      list<SimCodeVar.SimVar> ret_8;
      Tpl.Text l_setStringVariables;
      Tpl.Text l_varDeclsString;
      Tpl.Text l_varDeclsInt;
      Tpl.Text l_stringFuncCalls;
      Tpl.Text l_boolFuncCalls;
      Tpl.Text l_intFuncCalls;
      Tpl.Text l_setRealFuncCalls;
      Tpl.Text l_realFuncCalls;

    case ( txt,
           (i_modelInfo as SimCode.MODELINFO(vars = SimCodeVar.SIMVARS(stringAlgVars = i_vars_stringAlgVars, stringParamVars = i_vars_stringParamVars, stringAliasVars = i_vars_stringAliasVars), name = i_name)),
           a_context,
           a_useFlatArrayNotation,
           a_simCode,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName )
      equation
        l_realFuncCalls = Tpl.emptyTxt;
        l_setRealFuncCalls = Tpl.emptyTxt;
        l_intFuncCalls = Tpl.emptyTxt;
        l_boolFuncCalls = Tpl.emptyTxt;
        l_stringFuncCalls = Tpl.emptyTxt;
        l_varDeclsInt = Tpl.emptyTxt;
        l_varDeclsString = Tpl.emptyTxt;
        ret_8 = listAppend(i_vars_stringAlgVars, i_vars_stringParamVars);
        ret_9 = listAppend(ret_8, i_vars_stringAliasVars);
        l_setStringVariables = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (l_setStringVariables, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, l_varDeclsString) = lm_1655(l_setStringVariables, ret_9, a_useFlatArrayNotation, a_stateDerVectorName, a_context, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, l_varDeclsString, a_simCode);
        l_setStringVariables = Tpl.popIter(l_setStringVariables);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "void "
                                }, false));
        txt = lastIdentOfPath(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::getReal(double* z)\n",
                                    "{\n",
                                    "  const double* real_vars = getSimVars()->getRealVarsVector();\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("memcpy(z,real_vars,"));
        txt = numRealvars(txt, i_modelInfo);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("*sizeof(double));\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n",
                                    "void "
                                }, false));
        txt = lastIdentOfPath(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::setReal(const double* z)\n",
                                    "{\n",
                                    "  getSimVars()->setRealVarsVector(z);\n",
                                    "}\n",
                                    "\n",
                                    "void "
                                }, false));
        txt = lastIdentOfPath(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::getInteger(int* z)\n",
                                    "{\n",
                                    "  const int* int_vars = getSimVars()->getIntVarsVector();\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("memcpy(z,int_vars,"));
        txt = numIntvars(txt, i_modelInfo);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("*sizeof(int));\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n",
                                    "void "
                                }, false));
        txt = lastIdentOfPath(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::getBoolean(bool* z)\n",
                                    "{\n",
                                    "  const bool* bool_vars = getSimVars()->getBoolVarsVector();\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("memcpy(z,bool_vars,"));
        txt = numBoolvars(txt, i_modelInfo);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("*sizeof(bool));\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n",
                                    "void "
                                }, false));
        txt = lastIdentOfPath(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::getString(string* z)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_stringFuncCalls);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n",
                                    "void "
                                }, false));
        txt = lastIdentOfPath(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::setInteger(const int* z)\n",
                                    "{\n",
                                    "   getSimVars()->setIntVarsVector(z);\n",
                                    "}\n",
                                    "\n",
                                    "void "
                                }, false));
        txt = lastIdentOfPath(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::setBoolean(const bool* z)\n",
                                    "{\n",
                                    "  getSimVars()->setBoolVarsVector(z);\n",
                                    "}\n",
                                    "\n",
                                    "void "
                                }, false));
        txt = lastIdentOfPath(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::setString(const string* z)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_setStringVariables);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           _,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_stateDerVectorName )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end giveVariables;

protected function fun_1657
  input Tpl.Text in_txt;
  input String in_a_comment;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_comment)
    local
      Tpl.Text txt;
      String i_comment;

    case ( txt,
           "" )
      then txt;

    case ( txt,
           i_comment )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("// \""));
        txt = Tpl.writeStr(txt, i_comment);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
      then txt;
  end match;
end fun_1657;

protected function fun_1658
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_a_simVar;
  input Integer in_a_valueReference;
  input String in_a_arrayName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simVar, in_a_valueReference, in_a_arrayName)
    local
      Tpl.Text txt;
      Integer a_valueReference;
      String a_arrayName;
      Integer i_index;
      String i_comment;
      Tpl.Text l_description;

    case ( txt,
           SimCodeVar.SIMVAR(comment = i_comment, index = i_index),
           a_valueReference,
           a_arrayName )
      equation
        l_description = fun_1657(Tpl.emptyTxt, i_comment);
        txt = Tpl.writeStr(txt, a_arrayName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("["));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = this->__z["));
        txt = Tpl.writeStr(txt, intString(a_valueReference));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("]; "));
        txt = Tpl.writeText(txt, l_description);
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_1658;

public function getStateVariables
  input Tpl.Text txt;
  input SimCodeVar.SimVar a_simVar;
  input Integer a_valueReference;
  input String a_arrayName;
  input Integer a_index;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_1658(txt, a_simVar, a_valueReference, a_arrayName);
end getStateVariables;

protected function fun_1660
  input Tpl.Text in_txt;
  input String in_a_comment;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_comment)
    local
      Tpl.Text txt;
      String i_comment;

    case ( txt,
           "" )
      then txt;

    case ( txt,
           i_comment )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("// \""));
        txt = Tpl.writeStr(txt, i_comment);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
      then txt;
  end match;
end fun_1660;

protected function fun_1661
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_a_simVar;
  input Integer in_a_valueReference;
  input String in_a_arrayName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simVar, in_a_valueReference, in_a_arrayName)
    local
      Tpl.Text txt;
      Integer a_valueReference;
      String a_arrayName;
      Integer i_index;
      String i_comment;
      Tpl.Text l_description;

    case ( txt,
           SimCodeVar.SIMVAR(comment = i_comment, index = i_index),
           a_valueReference,
           a_arrayName )
      equation
        l_description = fun_1660(Tpl.emptyTxt, i_comment);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("this->__z["));
        txt = Tpl.writeStr(txt, intString(a_valueReference));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = "));
        txt = Tpl.writeStr(txt, a_arrayName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("["));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("]; "));
        txt = Tpl.writeText(txt, l_description);
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_1661;

public function setStateVariables
  input Tpl.Text txt;
  input SimCodeVar.SimVar a_simVar;
  input Integer a_valueReference;
  input String a_arrayName;
  input Integer a_index;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_1661(txt, a_simVar, a_valueReference, a_arrayName);
end setStateVariables;

protected function fun_1663
  input Tpl.Text in_txt;
  input String in_a_comment;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_comment)
    local
      Tpl.Text txt;
      String i_comment;

    case ( txt,
           "" )
      then txt;

    case ( txt,
           i_comment )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("// \""));
        txt = Tpl.writeStr(txt, i_comment);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
      then txt;
  end match;
end fun_1663;

protected function fun_1664
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_a_simVar;
  input Integer in_a_valueReference;
  input String in_a_arrayName;
  input Integer in_a_indexOffset;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simVar, in_a_valueReference, in_a_arrayName, in_a_indexOffset)
    local
      Tpl.Text txt;
      Integer a_valueReference;
      String a_arrayName;
      Integer a_indexOffset;
      Integer i_index;
      String i_comment;
      Integer ret_1;
      Tpl.Text l_description;

    case ( txt,
           SimCodeVar.SIMVAR(comment = i_comment, index = i_index),
           a_valueReference,
           a_arrayName,
           a_indexOffset )
      equation
        l_description = fun_1663(Tpl.emptyTxt, i_comment);
        txt = Tpl.writeStr(txt, a_arrayName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("["));
        ret_1 = intAdd(i_index, a_indexOffset);
        txt = Tpl.writeStr(txt, intString(ret_1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = this->__zDot["));
        txt = Tpl.writeStr(txt, intString(a_valueReference));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("]; "));
        txt = Tpl.writeText(txt, l_description);
      then txt;

    case ( txt,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_1664;

public function getStateDerivativeVariables
  input Tpl.Text txt;
  input SimCodeVar.SimVar a_simVar;
  input Integer a_valueReference;
  input String a_arrayName;
  input Integer a_index;
  input Integer a_indexOffset;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_1664(txt, a_simVar, a_valueReference, a_arrayName, a_indexOffset);
end getStateDerivativeVariables;

protected function fun_1666
  input Tpl.Text in_txt;
  input String in_a_comment;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_comment)
    local
      Tpl.Text txt;
      String i_comment;

    case ( txt,
           "" )
      then txt;

    case ( txt,
           i_comment )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("// \""));
        txt = Tpl.writeStr(txt, i_comment);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
      then txt;
  end match;
end fun_1666;

protected function fun_1667
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_a_simVar;
  input Integer in_a_valueReference;
  input String in_a_arrayName;
  input Integer in_a_indexOffset;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simVar, in_a_valueReference, in_a_arrayName, in_a_indexOffset)
    local
      Tpl.Text txt;
      Integer a_valueReference;
      String a_arrayName;
      Integer a_indexOffset;
      Integer i_index;
      String i_comment;
      Integer ret_1;
      Tpl.Text l_description;

    case ( txt,
           SimCodeVar.SIMVAR(comment = i_comment, index = i_index),
           a_valueReference,
           a_arrayName,
           a_indexOffset )
      equation
        l_description = fun_1666(Tpl.emptyTxt, i_comment);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("this->__zDot["));
        txt = Tpl.writeStr(txt, intString(a_valueReference));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = "));
        txt = Tpl.writeStr(txt, a_arrayName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("["));
        ret_1 = intAdd(i_index, a_indexOffset);
        txt = Tpl.writeStr(txt, intString(ret_1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("]; "));
        txt = Tpl.writeText(txt, l_description);
      then txt;

    case ( txt,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_1667;

public function setStateDerivativeVariables
  input Tpl.Text txt;
  input SimCodeVar.SimVar a_simVar;
  input Integer a_valueReference;
  input String a_arrayName;
  input Integer a_index;
  input Integer a_indexOffset;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_1667(txt, a_simVar, a_valueReference, a_arrayName, a_indexOffset);
end setStateDerivativeVariables;

protected function fun_1669
  input Tpl.Text in_txt;
  input String in_a_comment;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_comment)
    local
      Tpl.Text txt;
      String i_comment;

    case ( txt,
           "" )
      then txt;

    case ( txt,
           i_comment )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/* "));
        txt = Tpl.writeStr(txt, i_comment);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" */"));
      then txt;
  end match;
end fun_1669;

protected function fun_1670
  input Tpl.Text in_txt;
  input SimCodeVar.AliasVariable in_a_aliasvar;
  input Tpl.Text in_a_varname;
  input Tpl.Text in_a_description;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_varDecls;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input SimCodeVar.SimVar in_a_simVar;
  input Integer in_a_valueReference;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_varDecls, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_a_aliasvar, in_a_varname, in_a_description, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_varDecls, in_a_context, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_simVar, in_a_valueReference)
    local
      Tpl.Text txt;
      Tpl.Text a_varname;
      Tpl.Text a_description;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_varDecls;
      SimCodeFunction.Context a_context;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      SimCodeVar.SimVar a_simVar;
      Integer a_valueReference;
      DAE.ComponentRef i_varName;

    case ( txt,
           SimCodeVar.ALIAS(varName = i_varName),
           _,
           a_description,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_varDecls,
           a_context,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_simVar,
           a_valueReference )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("z["));
        txt = Tpl.writeStr(txt, intString(a_valueReference));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = "));
        txt = getAliasSign(txt, a_simVar);
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_varDecls, a_stateDerVectorName) = CodegenCppCommonOld.cref1(txt, i_varName, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_context, a_varDecls, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("; "));
        txt = Tpl.writeText(txt, a_description);
      then (txt, a_stateDerVectorName, a_varDecls, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           SimCodeVar.NEGATEDALIAS(varName = i_varName),
           _,
           a_description,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_varDecls,
           a_context,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_simVar,
           a_valueReference )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("z["));
        txt = Tpl.writeStr(txt, intString(a_valueReference));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = "));
        txt = getAliasSign(txt, a_simVar);
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_varDecls, a_stateDerVectorName) = CodegenCppCommonOld.cref1(txt, i_varName, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_context, a_varDecls, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("; "));
        txt = Tpl.writeText(txt, a_description);
      then (txt, a_stateDerVectorName, a_varDecls, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           a_varname,
           a_description,
           _,
           a_stateDerVectorName,
           a_varDecls,
           _,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _,
           a_valueReference )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("z["));
        txt = Tpl.writeStr(txt, intString(a_valueReference));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = "));
        txt = Tpl.writeText(txt, a_varname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("; "));
        txt = Tpl.writeText(txt, a_description);
      then (txt, a_stateDerVectorName, a_varDecls, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_1670;

public function giveVariablesDefault
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_a_simVar;
  input Integer in_a_valueReference;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_simVar, in_a_valueReference, in_a_simCode, in_a_varDecls, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_context, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      Integer a_valueReference;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      SimCodeFunction.Context a_context;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      SimCodeVar.SimVar i_simVar;
      SimCodeVar.AliasVariable i_aliasvar;
      DAE.ComponentRef i_name;
      String i_comment;
      Tpl.Text l_varname;
      Tpl.Text l_description;

    case ( txt,
           (i_simVar as SimCodeVar.SIMVAR(comment = i_comment, name = i_name, aliasvar = i_aliasvar)),
           a_valueReference,
           a_simCode,
           a_varDecls,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_context,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_description = fun_1669(Tpl.emptyTxt, i_comment);
        (l_varname, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_varDecls, a_stateDerVectorName) = CodegenCppCommonOld.cref1(Tpl.emptyTxt, i_name, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_context, a_varDecls, a_stateDerVectorName, a_useFlatArrayNotation);
        (txt, a_stateDerVectorName, a_varDecls, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_1670(txt, i_aliasvar, l_varname, l_description, a_useFlatArrayNotation, a_stateDerVectorName, a_varDecls, a_context, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, i_simVar, a_valueReference);
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           _,
           a_varDecls,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           _,
           a_stateDerVectorName,
           _ )
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end giveVariablesDefault;

protected function fun_1672
  input Tpl.Text in_txt;
  input String in_a_comment;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_comment)
    local
      Tpl.Text txt;
      String i_comment;

    case ( txt,
           "" )
      then txt;

    case ( txt,
           i_comment )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/* \""));
        txt = Tpl.writeStr(txt, i_comment);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\" */"));
      then txt;
  end match;
end fun_1672;

protected function fun_1673
  input Tpl.Text in_txt;
  input SimCodeVar.AliasVariable in_a_aliasvar;
  input Tpl.Text in_a_variablename;
  input Tpl.Text in_a_description;
  input Integer in_a_valueReference;
  input Integer in_a_indexOffset;
  input SimCodeVar.SimVar in_a_simVar;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_varDecls;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_varDecls, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_a_aliasvar, in_a_variablename, in_a_description, in_a_valueReference, in_a_indexOffset, in_a_simVar, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_varDecls, in_a_context, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode)
    local
      Tpl.Text txt;
      Tpl.Text a_variablename;
      Tpl.Text a_description;
      Integer a_valueReference;
      Integer a_indexOffset;
      SimCodeVar.SimVar a_simVar;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_varDecls;
      SimCodeFunction.Context a_context;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      DAE.ComponentRef i_varName;
      Integer ret_2;
      Integer ret_1;
      Integer ret_0;

    case ( txt,
           SimCodeVar.ALIAS(varName = i_varName),
           _,
           a_description,
           a_valueReference,
           a_indexOffset,
           a_simVar,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_varDecls,
           a_context,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_varDecls, a_stateDerVectorName) = CodegenCppCommonOld.cref1(txt, i_varName, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_context, a_varDecls, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = getAliasSign(txt, a_simVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("z["));
        ret_0 = intAdd(a_indexOffset, a_valueReference);
        txt = Tpl.writeStr(txt, intString(ret_0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("]; "));
        txt = Tpl.writeText(txt, a_description);
      then (txt, a_stateDerVectorName, a_varDecls, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           SimCodeVar.NEGATEDALIAS(varName = i_varName),
           _,
           a_description,
           a_valueReference,
           a_indexOffset,
           a_simVar,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_varDecls,
           a_context,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_varDecls, a_stateDerVectorName) = CodegenCppCommonOld.cref1(txt, i_varName, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_context, a_varDecls, a_stateDerVectorName, a_useFlatArrayNotation);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = getAliasSign(txt, a_simVar);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("z["));
        ret_1 = intAdd(a_indexOffset, a_valueReference);
        txt = Tpl.writeStr(txt, intString(ret_1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("]; "));
        txt = Tpl.writeText(txt, a_description);
      then (txt, a_stateDerVectorName, a_varDecls, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           a_variablename,
           a_description,
           a_valueReference,
           a_indexOffset,
           _,
           _,
           a_stateDerVectorName,
           a_varDecls,
           _,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _ )
      equation
        txt = Tpl.writeText(txt, a_variablename);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = z["));
        ret_2 = intAdd(a_indexOffset, a_valueReference);
        txt = Tpl.writeStr(txt, intString(ret_2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("]; "));
        txt = Tpl.writeText(txt, a_description);
      then (txt, a_stateDerVectorName, a_varDecls, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_1673;

public function setVariablesDefault
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_a_simVar;
  input Integer in_a_valueReference;
  input Integer in_a_indexOffset;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_varDecls;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_varDecls;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_varDecls, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_simVar, in_a_valueReference, in_a_indexOffset, in_a_simCode, in_a_varDecls, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_context, in_a_stateDerVectorName, in_a_useFlatArrayNotation)
    local
      Tpl.Text txt;
      Integer a_valueReference;
      Integer a_indexOffset;
      SimCode.SimCode a_simCode;
      Tpl.Text a_varDecls;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      SimCodeFunction.Context a_context;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      SimCodeVar.SimVar i_simVar;
      SimCodeVar.AliasVariable i_aliasvar;
      DAE.ComponentRef i_name;
      String i_comment;
      Tpl.Text l_variablename;
      Tpl.Text l_description;

    case ( txt,
           (i_simVar as SimCodeVar.SIMVAR(comment = i_comment, name = i_name, aliasvar = i_aliasvar)),
           a_valueReference,
           a_indexOffset,
           a_simCode,
           a_varDecls,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_context,
           a_stateDerVectorName,
           a_useFlatArrayNotation )
      equation
        l_description = fun_1672(Tpl.emptyTxt, i_comment);
        (l_variablename, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_varDecls, a_stateDerVectorName) = CodegenCppCommonOld.cref1(Tpl.emptyTxt, i_name, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, SimCodeFunction.contextOther, a_varDecls, a_stateDerVectorName, a_useFlatArrayNotation);
        (txt, a_stateDerVectorName, a_varDecls, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_1673(txt, i_aliasvar, l_variablename, l_description, a_valueReference, a_indexOffset, i_simVar, a_useFlatArrayNotation, a_stateDerVectorName, a_varDecls, a_context, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode);
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           _,
           _,
           _,
           a_varDecls,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           _,
           a_stateDerVectorName,
           _ )
      then (txt, a_varDecls, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end setVariablesDefault;

protected function fun_1675
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_defineName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_defineName)
    local
      Tpl.Text txt;
      String a_defineName;

    case ( txt,
           false,
           a_defineName )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#ifdef "));
        txt = Tpl.writeStr(txt, a_defineName);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_1675;

protected function fun_1676
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#endif"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_1676;

protected function fun_1677
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_varNameStartValues;
  input String in_a_sectionName;
  input String in_a_defineName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_varNameStartValues, in_a_sectionName, in_a_defineName)
    local
      Tpl.Text txt;
      String a_varNameStartValues;
      String a_sectionName;
      String a_defineName;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           false,
           _,
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_varNameStartValues,
           a_sectionName,
           a_defineName )
      equation
        ret_0 = stringEq(a_defineName, "");
        txt = fun_1675(txt, ret_0, a_defineName);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("MEASURETIME_REGION_DEFINE("));
        txt = Tpl.writeStr(txt, a_sectionName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", \""));
        txt = Tpl.writeStr(txt, a_sectionName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\");\n",
                                    "MEASURETIME_START("
                                }, false));
        txt = Tpl.writeStr(txt, a_varNameStartValues);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeStr(txt, a_sectionName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", \""));
        txt = Tpl.writeStr(txt, a_sectionName);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("\");\n"));
        txt = Tpl.popBlock(txt);
        ret_1 = stringEq(a_defineName, "");
        txt = fun_1676(txt, ret_1);
      then txt;
  end match;
end fun_1677;

public function generateMeasureTimeStartCode
  input Tpl.Text txt;
  input String a_varNameStartValues;
  input String a_sectionName;
  input String a_defineName;

  output Tpl.Text out_txt;
protected
  Boolean ret_2;
  Boolean ret_1;
  String ret_0;
algorithm
  ret_0 := Flags.getConfigString(Flags.PROFILING_LEVEL);
  ret_1 := stringEq(ret_0, "none");
  ret_2 := boolNot(ret_1);
  out_txt := fun_1677(txt, ret_2, a_varNameStartValues, a_sectionName, a_defineName);
end generateMeasureTimeStartCode;

protected function fun_1679
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_defineName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_defineName)
    local
      Tpl.Text txt;
      String a_defineName;

    case ( txt,
           false,
           a_defineName )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#ifdef "));
        txt = Tpl.writeStr(txt, a_defineName);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_1679;

protected function fun_1680
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#endif"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_1680;

protected function fun_1681
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_varNameStartValues;
  input String in_a_varNameEndValues;
  input String in_a_varNameTargetValues;
  input String in_a_sectionName;
  input String in_a_defineName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_varNameStartValues, in_a_varNameEndValues, in_a_varNameTargetValues, in_a_sectionName, in_a_defineName)
    local
      Tpl.Text txt;
      String a_varNameStartValues;
      String a_varNameEndValues;
      String a_varNameTargetValues;
      String a_sectionName;
      String a_defineName;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           false,
           _,
           _,
           _,
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_varNameStartValues,
           a_varNameEndValues,
           a_varNameTargetValues,
           a_sectionName,
           a_defineName )
      equation
        ret_0 = stringEq(a_defineName, "");
        txt = fun_1679(txt, ret_0, a_defineName);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("MEASURETIME_END("));
        txt = Tpl.writeStr(txt, a_varNameStartValues);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeStr(txt, a_varNameEndValues);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeStr(txt, a_varNameTargetValues);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", "));
        txt = Tpl.writeStr(txt, a_sectionName);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(");\n"));
        txt = Tpl.popBlock(txt);
        ret_1 = stringEq(a_defineName, "");
        txt = fun_1680(txt, ret_1);
      then txt;
  end match;
end fun_1681;

public function generateMeasureTimeEndCode
  input Tpl.Text txt;
  input String a_varNameStartValues;
  input String a_varNameEndValues;
  input String a_varNameTargetValues;
  input String a_sectionName;
  input String a_defineName;

  output Tpl.Text out_txt;
protected
  Boolean ret_2;
  Boolean ret_1;
  String ret_0;
algorithm
  ret_0 := Flags.getConfigString(Flags.PROFILING_LEVEL);
  ret_1 := stringEq(ret_0, "none");
  ret_2 := boolNot(ret_1);
  out_txt := fun_1681(txt, ret_2, a_varNameStartValues, a_varNameEndValues, a_varNameTargetValues, a_sectionName, a_defineName);
end generateMeasureTimeEndCode;

public function simulationDAEMethodsDeclaration
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      list<list<SimCode.SimEqSystem>> i_daeEquations;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(vars = SimCodeVar.SIMVARS(stateVars = _)), daeModeData = SOME(SimCode.DAEMODEDATA(daeEquations = i_daeEquations, sparsityPattern = _, algebraicVars = _, residualVars = _))) )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(1));
        (txt, _) = generateDAEEquationMemberFuncDecls(txt, i_daeEquations, Tpl.strTokText(Tpl.ST_STRING("evaluateDAE")));
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end simulationDAEMethodsDeclaration;

public function updateResiduals
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
protected
  Boolean ret_3;
  Boolean ret_2;
  String ret_1;
  Tpl.Text l_extraFuncsResidual;
algorithm
  l_extraFuncsResidual := Tpl.emptyTxt;
  ret_1 := Flags.getConfigString(Flags.PROFILING_LEVEL);
  ret_2 := stringEq(ret_1, "none");
  ret_3 := boolNot(ret_2);
  (out_txt, l_extraFuncsResidual, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) := simulationDAEMethods(txt, a_simCode, l_extraFuncsResidual, a_extraFuncsDecl, a_extraFuncsNamespace, SimCodeFunction.contextOther, a_stateDerVectorName, a_useFlatArrayNotation, ret_3);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_NEW_LINE());
  out_txt := Tpl.writeText(out_txt, l_extraFuncsResidual);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "\n",
                                       "\n",
                                       "\n",
                                       "\n"
                                   }, true));
  out_a_extraFuncs := a_extraFuncs;
end updateResiduals;

protected function lm_1685
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input Tpl.Text in_a_method;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_method;
algorithm
  (out_txt, out_a_method) :=
  match(in_txt, in_items, in_a_method)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      Tpl.Text a_method;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           {},
           a_method )
      then (txt, a_method);

    case ( txt,
           i_eq :: rest,
           a_method )
      equation
        (txt, a_method) = generateEquationMemberFuncDecls2(txt, i_eq, a_method);
        txt = Tpl.nextIter(txt);
        (txt, a_method) = lm_1685(txt, rest, a_method);
      then (txt, a_method);
  end match;
end lm_1685;

protected function lm_1686
  input Tpl.Text in_txt;
  input list<list<SimCode.SimEqSystem>> in_items;
  input Tpl.Text in_a_method;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_method;
algorithm
  (out_txt, out_a_method) :=
  match(in_txt, in_items, in_a_method)
    local
      Tpl.Text txt;
      list<list<SimCode.SimEqSystem>> rest;
      Tpl.Text a_method;
      list<SimCode.SimEqSystem> i_eqsys;

    case ( txt,
           {},
           a_method )
      then (txt, a_method);

    case ( txt,
           i_eqsys :: rest,
           a_method )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_method) = lm_1685(txt, i_eqsys, a_method);
        txt = Tpl.popIter(txt);
        (txt, a_method) = lm_1686(txt, rest, a_method);
      then (txt, a_method);
  end match;
end lm_1686;

public function generateDAEEquationMemberFuncDecls
  input Tpl.Text in_txt;
  input list<list<SimCode.SimEqSystem>> in_a_DAEEquations;
  input Tpl.Text in_a_method;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_method;
algorithm
  (out_txt, out_a_method) :=
  match(in_txt, in_a_DAEEquations, in_a_method)
    local
      Tpl.Text txt;
      Tpl.Text a_method;
      list<list<SimCode.SimEqSystem>> i_DAEEquations;
      Tpl.Text l_equation__func__decls;

    case ( txt,
           i_DAEEquations,
           a_method )
      equation
        (l_equation__func__decls, a_method) = lm_1686(Tpl.emptyTxt, i_DAEEquations, a_method);
        txt = Tpl.writeText(txt, l_equation__func__decls);
      then (txt, a_method);
  end match;
end generateDAEEquationMemberFuncDecls;

public function simulationDAEMethods
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input SimCodeFunction.Context in_a_context;
  input Tpl.Text in_a_stateDerVectorName;
  input Boolean in_a_useFlatArrayNotation;
  input Boolean in_a_enableMeasureTime;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace, out_a_stateDerVectorName) :=
  match(in_txt, in_a_simCode, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_context, in_a_stateDerVectorName, in_a_useFlatArrayNotation, in_a_enableMeasureTime)
    local
      Tpl.Text txt;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      SimCodeFunction.Context a_context;
      Tpl.Text a_stateDerVectorName;
      Boolean a_useFlatArrayNotation;
      Boolean a_enableMeasureTime;
      SimCode.SimCode i_simCode;
      list<list<SimCode.SimEqSystem>> i_daeEquations;
      list<SimCodeVar.SimVar> i_algebraicDAEVars;
      Absyn.Path i_modelInfo_name;
      Tpl.Text l_modelNamePrefixStr;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(vars = SimCodeVar.SIMVARS(stateVars = _), name = i_modelInfo_name), daeModeData = SOME(SimCode.DAEMODEDATA(daeEquations = i_daeEquations, sparsityPattern = _, algebraicVars = i_algebraicDAEVars, residualVars = _)))),
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_context,
           a_stateDerVectorName,
           a_useFlatArrayNotation,
           a_enableMeasureTime )
      equation
        l_modelNamePrefixStr = lastIdentOfPath(Tpl.emptyTxt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "\n",
                                    "\n"
                                }, true));
        txt = algebraicDAEVar(txt, i_algebraicDAEVars, Tpl.textString(l_modelNamePrefixStr));
        txt = Tpl.softNewLine(txt);
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = evaluateDAEResiduals(txt, i_daeEquations, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_context, a_enableMeasureTime);
        txt = Tpl.softNewLine(txt);
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName) = equationResidualFunctions(txt, i_daeEquations, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_context, a_stateDerVectorName, a_useFlatArrayNotation, a_enableMeasureTime);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = Tpl.writeText(txt, l_modelNamePrefixStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Mixed::getResidual(double* f)\n",
                                    "{\n",
                                    "   SystemDefaultImplementation::getResidual(f);\n",
                                    "}"
                                }, false));
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = i_modelInfo_name), daeModeData = NONE()),
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           _,
           a_stateDerVectorName,
           _,
           _ )
      equation
        l_modelNamePrefixStr = lastIdentOfPath(Tpl.emptyTxt, i_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "/* DAE residuals is empty */\n",
                                    "void "
                                }, false));
        txt = Tpl.writeText(txt, l_modelNamePrefixStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Mixed::getResidual(double* f)\n",
                                    "{\n",
                                    "\n",
                                    "}\n",
                                    "void "
                                }, false));
        txt = Tpl.writeText(txt, l_modelNamePrefixStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Mixed::setAlgebraicDAEVars(const double* y)\n",
                                    "{\n",
                                    "}\n",
                                    "/* get algebraic variables */\n",
                                    "void "
                                }, false));
        txt = Tpl.writeText(txt, l_modelNamePrefixStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Mixed::getAlgebraicDAEVars( double* y)\n",
                                    "{\n",
                                    "}\n",
                                    "void "
                                }, false));
        txt = Tpl.writeText(txt, l_modelNamePrefixStr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Mixed::evaluateDAE(const UPDATETYPE command )\n",
                                    "{\n",
                                    "\n",
                                    "}"
                                }, false));
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);

    case ( txt,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           _,
           a_stateDerVectorName,
           _,
           _ )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_stateDerVectorName);
  end match;
end simulationDAEMethods;

protected function fun_1689
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_a_var;
  input Integer in_a_i;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_var, in_a_i)
    local
      Tpl.Text txt;
      Integer a_i;
      DAE.ComponentRef i_name;

    case ( txt,
           SimCodeVar.SIMVAR(name = i_name),
           a_i )
      equation
        txt = CodegenCppCommonOld.cref(txt, i_name, false);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = y["));
        txt = Tpl.writeStr(txt, intString(a_i));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("];"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_1689;

protected function lm_1690
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Integer x_i;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        x_i = Tpl.getIteri_i0(txt);
        txt = fun_1689(txt, i_var, x_i);
        txt = Tpl.nextIter(txt);
        txt = lm_1690(txt, rest);
      then txt;
  end match;
end lm_1690;

protected function fun_1691
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_a_var;
  input Integer in_a_i;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_var, in_a_i)
    local
      Tpl.Text txt;
      Integer a_i;
      DAE.ComponentRef i_name;

    case ( txt,
           SimCodeVar.SIMVAR(name = i_name),
           a_i )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("y["));
        txt = Tpl.writeStr(txt, intString(a_i));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = "));
        txt = CodegenCppCommonOld.cref(txt, i_name, false);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_1691;

protected function lm_1692
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      Integer x_i;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        x_i = Tpl.getIteri_i0(txt);
        txt = fun_1691(txt, i_var, x_i);
        txt = Tpl.nextIter(txt);
        txt = lm_1692(txt, rest);
      then txt;
  end match;
end lm_1692;

public function algebraicDAEVar
  input Tpl.Text txt;
  input list<SimCodeVar.SimVar> a_algVars;
  input String a_className;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_getVars;
  Tpl.Text l_setVars;
algorithm
  l_setVars := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  l_setVars := lm_1690(l_setVars, a_algVars);
  l_setVars := Tpl.popIter(l_setVars);
  l_getVars := Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  l_getVars := lm_1692(l_getVars, a_algVars);
  l_getVars := Tpl.popIter(l_getVars);
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                   "\n",
                                   "\n",
                                   "void "
                               }, false));
  out_txt := Tpl.writeStr(out_txt, a_className);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "Mixed::setAlgebraicDAEVars(const double* y)\n",
                                       "{\n",
                                       "\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeText(out_txt, l_setVars);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_NEW_LINE());
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "}\n",
                                       "/* get algebraic variables */\n",
                                       "void "
                                   }, false));
  out_txt := Tpl.writeStr(out_txt, a_className);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING_LIST({
                                       "Mixed::getAlgebraicDAEVars( double* y)\n",
                                       "{\n",
                                       "\n"
                                   }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeText(out_txt, l_getVars);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_NEW_LINE());
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("}"));
end algebraicDAEVar;

protected function lm_1694
  input Tpl.Text in_txt;
  input list<list<SimCode.SimEqSystem>> in_items;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_className;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_className, in_a_context)
    local
      Tpl.Text txt;
      list<list<SimCode.SimEqSystem>> rest;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_className;
      SimCodeFunction.Context a_context;
      Integer x_i0;
      list<SimCode.SimEqSystem> i_eqs;

    case ( txt,
           {},
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _,
           _ )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           i_eqs :: rest,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_className,
           a_context )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = createEvaluateWithSplit(txt, x_i0, a_context, i_eqs, "evaluateDAE", "evaluateDAE", Tpl.textString(a_className), a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
        txt = Tpl.nextIter(txt);
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1694(txt, rest, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_className, a_context);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_1694;

protected function lm_1695
  input Tpl.Text in_txt;
  input list<Integer> in_items;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_className;
  input list<list<Integer>> in_a_activatorsForPartitions;
  input list<list<Integer>> in_a_partitions;
  input list<list<SimCode.SimEqSystem>> in_a_resEquations;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_className, in_a_activatorsForPartitions, in_a_partitions, in_a_resEquations, in_a_context)
    local
      Tpl.Text txt;
      list<Integer> rest;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_className;
      list<list<Integer>> a_activatorsForPartitions;
      list<list<Integer>> a_partitions;
      list<list<SimCode.SimEqSystem>> a_resEquations;
      SimCodeFunction.Context a_context;
      Integer i_partIdx;
      list<Integer> ret_2;
      list<Integer> ret_1;
      list<SimCode.SimEqSystem> ret_0;

    case ( txt,
           {},
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _,
           _,
           _,
           _,
           _ )
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           i_partIdx :: rest,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_className,
           a_activatorsForPartitions,
           a_partitions,
           a_resEquations,
           a_context )
      equation
        ret_0 = List.flatten(a_resEquations);
        ret_1 = listGet(a_partitions, i_partIdx);
        ret_2 = listGet(a_activatorsForPartitions, i_partIdx);
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = createEvaluatePartitions(txt, i_partIdx, a_context, ret_0, ret_1, ret_2, Tpl.textString(a_className), a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
        txt = Tpl.nextIter(txt);
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1695(txt, rest, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_className, a_activatorsForPartitions, a_partitions, a_resEquations, a_context);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_1695;

protected function fun_1696
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input list<list<Integer>> in_a_activatorsForPartitions;
  input list<list<Integer>> in_a_partitions;
  input Integer in_a_partitionData_numPartitions;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_className;
  input SimCodeFunction.Context in_a_context;
  input list<list<SimCode.SimEqSystem>> in_a_resEquations;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_mArg, in_a_activatorsForPartitions, in_a_partitions, in_a_partitionData_numPartitions, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_className, in_a_context, in_a_resEquations)
    local
      Tpl.Text txt;
      list<list<Integer>> a_activatorsForPartitions;
      list<list<Integer>> a_partitions;
      Integer a_partitionData_numPartitions;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      Tpl.Text a_className;
      SimCodeFunction.Context a_context;
      list<list<SimCode.SimEqSystem>> a_resEquations;
      list<Integer> ret_2;
      list<list<SimCode.SimEqSystem>> ret_1;
      list<SimCode.SimEqSystem> ret_0;

    case ( txt,
           false,
           _,
           _,
           _,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_className,
           a_context,
           a_resEquations )
      equation
        ret_0 = List.flatten(a_resEquations);
        ret_1 = List.partition(ret_0, 100);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1694(txt, ret_1, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_className, a_context);
        txt = Tpl.popIter(txt);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           _,
           a_activatorsForPartitions,
           a_partitions,
           a_partitionData_numPartitions,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_className,
           a_context,
           a_resEquations )
      equation
        ret_2 = List.intRange(a_partitionData_numPartitions);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1695(txt, ret_2, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_className, a_activatorsForPartitions, a_partitions, a_resEquations, a_context);
        txt = Tpl.popIter(txt);
      then (txt, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end fun_1696;

protected function fun_1697
  input Tpl.Text in_txt;
  input Boolean in_a_createMeasureTime;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_createMeasureTime)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = generateMeasureTimeStartCode(txt, "measuredFunctionStartValues", "evaluateDAE", "MEASURETIME_MODELFUNCTIONS");
      then txt;
  end match;
end fun_1697;

protected function fun_1698
  input Tpl.Text in_txt;
  input Boolean in_a_createMeasureTime;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_createMeasureTime)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = generateMeasureTimeEndCode(txt, "measuredFunctionStartValues", "measuredFunctionEndValues", "(*measureTimeFunctionsArray)[0]", "evaluateDAE", "MEASURETIME_MODELFUNCTIONS");
      then txt;
  end match;
end fun_1698;

protected function fun_1699
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input list<list<SimCode.SimEqSystem>> in_a_resEquations;
  input Tpl.Text in_a_extraFuncs;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncsNamespace;
  input SimCodeFunction.Context in_a_context;
  input Boolean in_a_createMeasureTime;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace) :=
  match(in_txt, in_a_simCode, in_a_resEquations, in_a_extraFuncs, in_a_extraFuncsDecl, in_a_extraFuncsNamespace, in_a_context, in_a_createMeasureTime)
    local
      Tpl.Text txt;
      list<list<SimCode.SimEqSystem>> a_resEquations;
      Tpl.Text a_extraFuncs;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncsNamespace;
      SimCodeFunction.Context a_context;
      Boolean a_createMeasureTime;
      list<list<Integer>> i_activatorsForPartitions;
      list<list<Integer>> i_partitions;
      Integer i_partitionData_numPartitions;
      SimCode.SimCode i_simCode;
      Boolean ret_3;
      Tpl.Text l_equation__dae__func__calls;
      Tpl.Text l_varDecls;
      Tpl.Text l_className;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(partitionData = SimCode.PARTITIONDATA(partitions = i_partitions, activatorsForPartitions = i_activatorsForPartitions, numPartitions = i_partitionData_numPartitions))),
           a_resEquations,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           a_context,
           a_createMeasureTime )
      equation
        (l_className, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace) = lastIdentOfPathFromSimCode(Tpl.emptyTxt, i_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
        l_className = Tpl.writeTok(l_className, Tpl.ST_STRING("Mixed"));
        l_varDecls = Tpl.emptyTxt;
        ret_3 = Flags.isSet(Flags.MULTIRATE_PARTITION);
        (l_equation__dae__func__calls, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = fun_1696(Tpl.emptyTxt, ret_3, i_activatorsForPartitions, i_partitions, i_partitionData_numPartitions, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, i_simCode, l_className, a_context, a_resEquations);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("void "));
        txt = Tpl.writeText(txt, l_className);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "::evaluateDAE(const UPDATETYPE command )\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = fun_1697(txt, a_createMeasureTime);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeText(txt, l_varDecls);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("// Evaluate Equations\n"));
        txt = Tpl.writeText(txt, l_equation__dae__func__calls);
        txt = Tpl.softNewLine(txt);
        txt = fun_1698(txt, a_createMeasureTime);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);

    case ( txt,
           _,
           _,
           a_extraFuncs,
           a_extraFuncsDecl,
           a_extraFuncsNamespace,
           _,
           _ )
      then (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace);
  end match;
end fun_1699;

public function evaluateDAEResiduals
  input Tpl.Text txt;
  input list<list<SimCode.SimEqSystem>> a_resEquations;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input SimCodeFunction.Context a_context;
  input Boolean a_createMeasureTime;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
algorithm
  (out_txt, out_a_extraFuncs, out_a_extraFuncsDecl, out_a_extraFuncsNamespace) := fun_1699(txt, a_simCode, a_resEquations, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, a_context, a_createMeasureTime);
end evaluateDAEResiduals;

protected function lm_1701
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;
  input Boolean in_a_enableMeasureTime;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_enableMeasureTime, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_context)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      Boolean a_enableMeasureTime;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      SimCodeFunction.Context a_context;
      SimCode.SimEqSystem i_eq;

    case ( txt,
           {},
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           i_eq :: rest,
           a_enableMeasureTime,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_context )
      equation
        (txt, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, _, _, a_stateDerVectorName) = equation_function_create_single_func(txt, i_eq, a_context, a_simCode, a_extraFuncs, a_extraFuncsDecl, a_extraFuncsNamespace, Tpl.strTokText(Tpl.ST_STRING("evaluateDAE")), Tpl.strTokText(Tpl.ST_STRING("Mixed")), a_stateDerVectorName, a_useFlatArrayNotation, a_enableMeasureTime, false, false, "");
        txt = Tpl.nextIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1701(txt, rest, a_enableMeasureTime, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_context);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_1701;

protected function lm_1702
  input Tpl.Text in_txt;
  input list<list<SimCode.SimEqSystem>> in_items;
  input Boolean in_a_enableMeasureTime;
  input Boolean in_a_useFlatArrayNotation;
  input Tpl.Text in_a_stateDerVectorName;
  input Tpl.Text in_a_extraFuncsNamespace;
  input Tpl.Text in_a_extraFuncsDecl;
  input Tpl.Text in_a_extraFuncs;
  input SimCode.SimCode in_a_simCode;
  input SimCodeFunction.Context in_a_context;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_stateDerVectorName;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncs;
algorithm
  (out_txt, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) :=
  match(in_txt, in_items, in_a_enableMeasureTime, in_a_useFlatArrayNotation, in_a_stateDerVectorName, in_a_extraFuncsNamespace, in_a_extraFuncsDecl, in_a_extraFuncs, in_a_simCode, in_a_context)
    local
      Tpl.Text txt;
      list<list<SimCode.SimEqSystem>> rest;
      Boolean a_enableMeasureTime;
      Boolean a_useFlatArrayNotation;
      Tpl.Text a_stateDerVectorName;
      Tpl.Text a_extraFuncsNamespace;
      Tpl.Text a_extraFuncsDecl;
      Tpl.Text a_extraFuncs;
      SimCode.SimCode a_simCode;
      SimCodeFunction.Context a_context;
      list<SimCode.SimEqSystem> i_eqsys;

    case ( txt,
           {},
           _,
           _,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           _,
           _ )
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);

    case ( txt,
           i_eqsys :: rest,
           a_enableMeasureTime,
           a_useFlatArrayNotation,
           a_stateDerVectorName,
           a_extraFuncsNamespace,
           a_extraFuncsDecl,
           a_extraFuncs,
           a_simCode,
           a_context )
      equation
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1701(txt, i_eqsys, a_enableMeasureTime, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_context);
        txt = Tpl.popIter(txt);
        (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs) = lm_1702(txt, rest, a_enableMeasureTime, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_context);
      then (txt, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs);
  end match;
end lm_1702;

public function equationResidualFunctions
  input Tpl.Text txt;
  input list<list<SimCode.SimEqSystem>> a_daeEquations;
  input SimCode.SimCode a_simCode;
  input Tpl.Text a_extraFuncs;
  input Tpl.Text a_extraFuncsDecl;
  input Tpl.Text a_extraFuncsNamespace;
  input SimCodeFunction.Context a_context;
  input Tpl.Text a_stateDerVectorName;
  input Boolean a_useFlatArrayNotation;
  input Boolean a_enableMeasureTime;

  output Tpl.Text out_txt;
  output Tpl.Text out_a_extraFuncs;
  output Tpl.Text out_a_extraFuncsDecl;
  output Tpl.Text out_a_extraFuncsNamespace;
  output Tpl.Text out_a_stateDerVectorName;
protected
  Tpl.Text l_equation__func__calls;
algorithm
  (l_equation__func__calls, out_a_stateDerVectorName, out_a_extraFuncsNamespace, out_a_extraFuncsDecl, out_a_extraFuncs) := lm_1702(Tpl.emptyTxt, a_daeEquations, a_enableMeasureTime, a_useFlatArrayNotation, a_stateDerVectorName, a_extraFuncsNamespace, a_extraFuncsDecl, a_extraFuncs, a_simCode, a_context);
  out_txt := Tpl.writeText(txt, l_equation__func__calls);
end equationResidualFunctions;

public function defineSimVarArray
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_a_simVar;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simVar)
    local
      Tpl.Text txt;
      DAE.ComponentRef i_name;
      Integer i_index;
      DAE.ComponentRef i_c;

    case ( txt,
           SimCodeVar.SIMVAR(arrayCref = SOME(i_c), aliasvar = SimCodeVar.NOALIAS(), index = i_index, name = i_name) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/* "));
        txt = CodegenUtil.crefStrNoUnderscore(txt, i_c);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " */\n",
                                    "#define "
                                }, false));
        txt = CodegenCppCommonOld.crefStr(txt, i_c);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" __daeResidual"));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "]\n",
                                    "\n",
                                    "/* "
                                }, false));
        txt = CodegenUtil.crefStrNoUnderscore(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " */\n",
                                    "#define "
                                }, false));
        txt = CodegenCppCommonOld.crefStr(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" __daeResidual["));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "]\n",
                                    "\n"
                                }, true));
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(aliasvar = SimCodeVar.NOALIAS(), name = i_name, index = i_index) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/* "));
        txt = CodegenUtil.crefStrNoUnderscore(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " */\n",
                                    "#define "
                                }, false));
        txt = CodegenCppCommonOld.crefStr(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" __daeResidual["));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "]\n",
                                    "\n"
                                }, true));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end defineSimVarArray;

protected function lm_1705
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = defineSimVarArray(txt, i_var);
        txt = Tpl.nextIter(txt);
        txt = lm_1705(txt, rest);
      then txt;
  end match;
end lm_1705;

public function simulationFile_dae_header
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      String i_fileNamePrefix;
      list<SimCodeVar.SimVar> i_residualVars;

    case ( txt,
           SimCode.SIMCODE(daeModeData = SOME(SimCode.DAEMODEDATA(residualVars = i_residualVars))) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/* residual variable define for daeMode */\n"));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_1705(txt, i_residualVars);
        txt = Tpl.popIter(txt);
      then txt;

    case ( txt,
           SimCode.SIMCODE(fileNamePrefix = i_fileNamePrefix) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#ifndef "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_16DAE_H\n",
                                    "#define "
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_16DAE_H\n",
                                    "#endif\n"
                                }, true));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end simulationFile_dae_header;

annotation(__OpenModelica_Interface="backend");
end CodegenCppOld;