encapsulated package CodegenFMU
"
  file:        CodegenFMU.mo
  package:     CodegenFMU
  description: Generated by Susan.
"

public import Tpl;

public import SimCodeVar;
public import SimCode;
public import SimCodeFunction;
public import SimCodeUtil;
public import System;
public import Autoconf;
public import Absyn;
public import DAE;
public import Util;
public import List;
public import Expression;
public import ExpressionDump;
public import Config;
public import Flags;
public import Settings;
public import Error;
public import Values;
public import Types;
public import FMI;
public import CodegenUtil;
public import CodegenUtilSimulation;
public import CodegenC;
public import CodegenCFunctions;
public import CodegenFMUCommon;
protected import CodegenFMU1;
protected import CodegenFMU2;

protected function fun_50
  input Tpl.Text in_txt;
  input Option<SimCode.FmiSimulationFlags> in_a_sc_fmiSimulationFlags;
  input String in_a_fileNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_sc_fmiSimulationFlags, in_a_fileNamePrefix)
    local
      Tpl.Text txt;
      String a_fileNamePrefix;
      SimCode.FmiSimulationFlags i_fmiSimFlags;
      Tpl.Text txt_1;
      Tpl.Text txt_0;

    case ( txt,
           SOME((i_fmiSimFlags as SimCode.FMI_SIMULATION_FLAGS(nameValueTuples = _))),
           a_fileNamePrefix )
      equation
        txt_0 = fmuSimulationFlagsFile(Tpl.emptyTxt, i_fmiSimFlags);
        txt_1 = Tpl.writeStr(Tpl.emptyTxt, a_fileNamePrefix);
        txt_1 = Tpl.writeTok(txt_1, Tpl.ST_STRING(".fmutmp/resources/"));
        txt_1 = Tpl.writeStr(txt_1, a_fileNamePrefix);
        txt_1 = Tpl.writeTok(txt_1, Tpl.ST_STRING("_flags.json"));
        Tpl.textFile(txt_0, Tpl.textString(txt_1));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_50;

public function translateModel
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input String in_a_FMUVersion;
  input String in_a_FMUType;
  input list<String> in_a_sourceFiles;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode, in_a_FMUVersion, in_a_FMUType, in_a_sourceFiles)
    local
      Tpl.Text txt;
      String a_FMUVersion;
      String a_FMUType;
      list<String> a_sourceFiles;
      Option<SimCode.FmiSimulationFlags> i_sc_fmiSimulationFlags;
      SimCode.SimCode i_sc;
      list<String> i_sc_externalFunctionIncludes;
      list<SimCodeFunction.RecordDeclaration> i_recordDecls;
      list<SimCodeFunction.Function> i_modelInfo_functions;
      list<DAE.Exp> i_literals;
      String i_fileNamePrefix;
      Tpl.Text txt_30;
      Tpl.Text txt_29;
      Tpl.Text txt_28;
      Tpl.Text txt_27;
      Tpl.Text txt_26;
      Tpl.Text txt_25;
      Tpl.Text l_0___1;
      Tpl.Text txt_23;
      Tpl.Text txt_22;
      Tpl.Text txt_21;
      Tpl.Text txt_20;
      Tpl.Text txt_19;
      Tpl.Text txt_18;
      Tpl.Text l_0__;
      Tpl.Text txt_16;
      Tpl.Text txt_15;
      Tpl.Text txt_14;
      Tpl.Text txt_13;
      Tpl.Text txt_12;
      Tpl.Text txt_11;
      Tpl.Text txt_10;
      Tpl.Text txt_9;
      Tpl.Text txt_8;
      Tpl.Text txt_7;
      Tpl.Text txt_6;
      Tpl.Text txt_5;
      Tpl.Text l_fileNamePrefixTmpDir;
      String ret_3;
      Tpl.Text l_target;
      String ret_1;
      Tpl.Text l_guid;

    case ( txt,
           (i_sc as SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(functions = i_modelInfo_functions), fileNamePrefix = i_fileNamePrefix, literals = i_literals, recordDecls = i_recordDecls, externalFunctionIncludes = i_sc_externalFunctionIncludes, fmiSimulationFlags = i_sc_fmiSimulationFlags)),
           a_FMUVersion,
           a_FMUType,
           a_sourceFiles )
      equation
        ret_1 = System.getUUIDStr();
        l_guid = Tpl.writeStr(Tpl.emptyTxt, ret_1);
        ret_3 = Config.simulationCodeTarget();
        l_target = Tpl.writeStr(Tpl.emptyTxt, ret_3);
        l_fileNamePrefixTmpDir = Tpl.writeStr(Tpl.emptyTxt, i_fileNamePrefix);
        l_fileNamePrefixTmpDir = Tpl.writeTok(l_fileNamePrefixTmpDir, Tpl.ST_STRING(".fmutmp/sources/"));
        l_fileNamePrefixTmpDir = Tpl.writeStr(l_fileNamePrefixTmpDir, i_fileNamePrefix);
        txt_5 = CodegenC.simulationLiteralsFile(Tpl.emptyTxt, i_fileNamePrefix, i_literals);
        txt_6 = Tpl.writeText(Tpl.emptyTxt, l_fileNamePrefixTmpDir);
        txt_6 = Tpl.writeTok(txt_6, Tpl.ST_STRING("_literals.h"));
        Tpl.textFile(txt_5, Tpl.textString(txt_6));
        txt_7 = CodegenC.simulationFunctionsHeaderFile(Tpl.emptyTxt, i_fileNamePrefix, i_modelInfo_functions, i_recordDecls);
        txt_8 = Tpl.writeText(Tpl.emptyTxt, l_fileNamePrefixTmpDir);
        txt_8 = Tpl.writeTok(txt_8, Tpl.ST_STRING("_functions.h"));
        Tpl.textFile(txt_7, Tpl.textString(txt_8));
        txt_9 = CodegenC.simulationFunctionsFile(Tpl.emptyTxt, i_fileNamePrefix, i_modelInfo_functions);
        txt_10 = Tpl.writeText(Tpl.emptyTxt, l_fileNamePrefixTmpDir);
        txt_10 = Tpl.writeTok(txt_10, Tpl.ST_STRING("_functions.c"));
        Tpl.textFile(txt_9, Tpl.textString(txt_10));
        txt_11 = CodegenCFunctions.externalFunctionIncludes(Tpl.emptyTxt, i_sc_externalFunctionIncludes);
        txt_12 = Tpl.writeText(Tpl.emptyTxt, l_fileNamePrefixTmpDir);
        txt_12 = Tpl.writeTok(txt_12, Tpl.ST_STRING("_includes.h"));
        Tpl.textFile(txt_11, Tpl.textString(txt_12));
        txt_13 = CodegenCFunctions.recordsFile(Tpl.emptyTxt, i_fileNamePrefix, i_recordDecls, true);
        txt_14 = Tpl.writeText(Tpl.emptyTxt, l_fileNamePrefixTmpDir);
        txt_14 = Tpl.writeTok(txt_14, Tpl.ST_STRING("_records.c"));
        Tpl.textFile(txt_13, Tpl.textString(txt_14));
        txt_15 = CodegenC.simulationHeaderFile(Tpl.emptyTxt, i_sc);
        txt_16 = Tpl.writeText(Tpl.emptyTxt, l_fileNamePrefixTmpDir);
        txt_16 = Tpl.writeTok(txt_16, Tpl.ST_STRING("_model.h"));
        Tpl.textFile(txt_15, Tpl.textString(txt_16));
        l_0__ = generateSimulationFiles(Tpl.emptyTxt, i_sc, Tpl.textString(l_guid), Tpl.textString(l_fileNamePrefixTmpDir), a_FMUVersion);
        txt_18 = simulationInitFunction(Tpl.emptyTxt, i_sc, Tpl.textString(l_guid));
        txt_19 = Tpl.writeText(Tpl.emptyTxt, l_fileNamePrefixTmpDir);
        txt_19 = Tpl.writeTok(txt_19, Tpl.ST_STRING("_init_fmu.c"));
        Tpl.textFile(txt_18, Tpl.textString(txt_19));
        txt_20 = fmumodel_identifierFile(Tpl.emptyTxt, i_sc, Tpl.textString(l_guid), a_FMUVersion);
        txt_21 = Tpl.writeText(Tpl.emptyTxt, l_fileNamePrefixTmpDir);
        txt_21 = Tpl.writeTok(txt_21, Tpl.ST_STRING("_FMU.c"));
        Tpl.textFile(txt_20, Tpl.textString(txt_21));
        txt_22 = fmuModelDescriptionFile(Tpl.emptyTxt, i_sc, Tpl.textString(l_guid), a_FMUVersion, a_FMUType, a_sourceFiles);
        txt_23 = Tpl.writeStr(Tpl.emptyTxt, i_fileNamePrefix);
        txt_23 = Tpl.writeTok(txt_23, Tpl.ST_STRING(".fmutmp/modelDescription.xml"));
        Tpl.textFile(txt_22, Tpl.textString(txt_23));
        l_0___1 = fun_50(Tpl.emptyTxt, i_sc_fmiSimulationFlags, i_fileNamePrefix);
        txt_25 = fmudeffile(Tpl.emptyTxt, i_sc, a_FMUVersion);
        txt_26 = Tpl.writeStr(Tpl.emptyTxt, i_fileNamePrefix);
        txt_26 = Tpl.writeTok(txt_26, Tpl.ST_STRING(".fmutmp/sources/"));
        txt_26 = Tpl.writeStr(txt_26, i_fileNamePrefix);
        txt_26 = Tpl.writeTok(txt_26, Tpl.ST_STRING(".def"));
        Tpl.textFile(txt_25, Tpl.textString(txt_26));
        txt_27 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("# Dummy file so OMDEV Compile.bat works"));
        txt_27 = Tpl.writeTok(txt_27, Tpl.ST_NEW_LINE());
        txt_27 = Tpl.writeTok(txt_27, Tpl.ST_STRING("include Makefile"));
        txt_27 = Tpl.writeTok(txt_27, Tpl.ST_NEW_LINE());
        txt_28 = Tpl.writeStr(Tpl.emptyTxt, i_fileNamePrefix);
        txt_28 = Tpl.writeTok(txt_28, Tpl.ST_STRING(".fmutmp/sources/"));
        txt_28 = Tpl.writeStr(txt_28, i_fileNamePrefix);
        txt_28 = Tpl.writeTok(txt_28, Tpl.ST_STRING(".makefile"));
        Tpl.textFile(txt_27, Tpl.textString(txt_28));
        txt_29 = fmuSourceMakefile(Tpl.emptyTxt, i_sc, a_FMUVersion);
        txt_30 = Tpl.writeStr(Tpl.emptyTxt, i_fileNamePrefix);
        txt_30 = Tpl.writeTok(txt_30, Tpl.ST_STRING("_FMU.makefile"));
        Tpl.textFile(txt_29, Tpl.textString(txt_30));
      then txt;

    case ( txt,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end translateModel;

public function generateSimulationFiles
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input String in_a_guid;
  input String in_a_modelNamePrefix;
  input String in_a_fmuVersion;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode, in_a_guid, in_a_modelNamePrefix, in_a_fmuVersion)
    local
      Tpl.Text txt;
      String a_guid;
      String a_modelNamePrefix;
      String a_fmuVersion;
      SimCode.SimCode i_simCode;
      Tpl.Text txt_41;
      Tpl.Text txt_40;
      Tpl.Text txt_39;
      Tpl.Text txt_38;
      Tpl.Text txt_37;
      Tpl.Text txt_36;
      Tpl.Text txt_35;
      Tpl.Text txt_34;
      Tpl.Text txt_33;
      Tpl.Text txt_32;
      Tpl.Text txt_31;
      Tpl.Text txt_30;
      Tpl.Text txt_29;
      Tpl.Text txt_28;
      Tpl.Text txt_27;
      Tpl.Text txt_26;
      Tpl.Text txt_25;
      Tpl.Text txt_24;
      Tpl.Text txt_23;
      Tpl.Text txt_22;
      Tpl.Text txt_21;
      Tpl.Text l_mixheader;
      Tpl.Text txt_19;
      Tpl.Text txt_18;
      Tpl.Text txt_17;
      Tpl.Text txt_16;
      Tpl.Text txt_15;
      Tpl.Text txt_14;
      Tpl.Text txt_13;
      Tpl.Text txt_12;
      Tpl.Text txt_11;
      Tpl.Text txt_10;
      Tpl.Text txt_9;
      Tpl.Text txt_8;
      Tpl.Text txt_7;
      Tpl.Text txt_6;
      Tpl.Text txt_5;
      Tpl.Text txt_4;
      Tpl.Text txt_3;
      Tpl.Text txt_2;
      Tpl.Text txt_1;
      Tpl.Text txt_0;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = _)),
           a_guid,
           a_modelNamePrefix,
           a_fmuVersion )
      equation
        System.tmpTickResetIndex(0, 0);
        System.tmpTickResetIndex(0, 1);
        txt_0 = CodegenC.simulationFile_exo(Tpl.emptyTxt, i_simCode);
        txt_1 = Tpl.writeStr(Tpl.emptyTxt, a_modelNamePrefix);
        txt_1 = Tpl.writeTok(txt_1, Tpl.ST_STRING("_01exo.c"));
        Tpl.textFileConvertLines(txt_0, Tpl.textString(txt_1));
        System.tmpTickResetIndex(0, 0);
        System.tmpTickResetIndex(0, 1);
        txt_2 = CodegenC.simulationFile_nls(Tpl.emptyTxt, i_simCode);
        txt_3 = Tpl.writeStr(Tpl.emptyTxt, a_modelNamePrefix);
        txt_3 = Tpl.writeTok(txt_3, Tpl.ST_STRING("_02nls.c"));
        Tpl.textFileConvertLines(txt_2, Tpl.textString(txt_3));
        System.tmpTickResetIndex(0, 0);
        System.tmpTickResetIndex(0, 1);
        txt_4 = CodegenC.simulationFile_lsy(Tpl.emptyTxt, i_simCode);
        txt_5 = Tpl.writeStr(Tpl.emptyTxt, a_modelNamePrefix);
        txt_5 = Tpl.writeTok(txt_5, Tpl.ST_STRING("_03lsy.c"));
        Tpl.textFileConvertLines(txt_4, Tpl.textString(txt_5));
        System.tmpTickResetIndex(0, 0);
        System.tmpTickResetIndex(0, 1);
        txt_6 = CodegenC.simulationFile_set(Tpl.emptyTxt, i_simCode);
        txt_7 = Tpl.writeStr(Tpl.emptyTxt, a_modelNamePrefix);
        txt_7 = Tpl.writeTok(txt_7, Tpl.ST_STRING("_04set.c"));
        Tpl.textFileConvertLines(txt_6, Tpl.textString(txt_7));
        System.tmpTickResetIndex(0, 0);
        System.tmpTickResetIndex(0, 1);
        txt_8 = CodegenC.simulationFile_evt(Tpl.emptyTxt, i_simCode);
        txt_9 = Tpl.writeStr(Tpl.emptyTxt, a_modelNamePrefix);
        txt_9 = Tpl.writeTok(txt_9, Tpl.ST_STRING("_05evt.c"));
        Tpl.textFileConvertLines(txt_8, Tpl.textString(txt_9));
        System.tmpTickResetIndex(0, 0);
        System.tmpTickResetIndex(0, 1);
        txt_10 = CodegenC.simulationFile_inz(Tpl.emptyTxt, i_simCode);
        txt_11 = Tpl.writeStr(Tpl.emptyTxt, a_modelNamePrefix);
        txt_11 = Tpl.writeTok(txt_11, Tpl.ST_STRING("_06inz.c"));
        Tpl.textFileConvertLines(txt_10, Tpl.textString(txt_11));
        txt_12 = CodegenC.simulationFile_dly(Tpl.emptyTxt, i_simCode);
        txt_13 = Tpl.writeStr(Tpl.emptyTxt, a_modelNamePrefix);
        txt_13 = Tpl.writeTok(txt_13, Tpl.ST_STRING("_07dly.c"));
        Tpl.textFileConvertLines(txt_12, Tpl.textString(txt_13));
        System.tmpTickResetIndex(0, 0);
        System.tmpTickResetIndex(0, 1);
        txt_14 = CodegenC.simulationFile_bnd(Tpl.emptyTxt, i_simCode);
        txt_15 = Tpl.writeStr(Tpl.emptyTxt, a_modelNamePrefix);
        txt_15 = Tpl.writeTok(txt_15, Tpl.ST_STRING("_08bnd.c"));
        Tpl.textFileConvertLines(txt_14, Tpl.textString(txt_15));
        System.tmpTickResetIndex(0, 0);
        System.tmpTickResetIndex(0, 1);
        txt_16 = CodegenC.simulationFile_alg(Tpl.emptyTxt, i_simCode);
        txt_17 = Tpl.writeStr(Tpl.emptyTxt, a_modelNamePrefix);
        txt_17 = Tpl.writeTok(txt_17, Tpl.ST_STRING("_09alg.c"));
        Tpl.textFileConvertLines(txt_16, Tpl.textString(txt_17));
        System.tmpTickResetIndex(0, 0);
        System.tmpTickResetIndex(0, 1);
        txt_18 = CodegenC.simulationFile_asr(Tpl.emptyTxt, i_simCode);
        txt_19 = Tpl.writeStr(Tpl.emptyTxt, a_modelNamePrefix);
        txt_19 = Tpl.writeTok(txt_19, Tpl.ST_STRING("_10asr.c"));
        Tpl.textFileConvertLines(txt_18, Tpl.textString(txt_19));
        System.tmpTickResetIndex(0, 0);
        System.tmpTickResetIndex(0, 1);
        l_mixheader = Tpl.emptyTxt;
        (txt_21, l_mixheader) = CodegenC.simulationFile_mix(Tpl.emptyTxt, i_simCode, l_mixheader);
        txt_22 = Tpl.writeStr(Tpl.emptyTxt, a_modelNamePrefix);
        txt_22 = Tpl.writeTok(txt_22, Tpl.ST_STRING("_11mix.c"));
        Tpl.textFileConvertLines(txt_21, Tpl.textString(txt_22));
        txt_23 = Tpl.writeStr(Tpl.emptyTxt, a_modelNamePrefix);
        txt_23 = Tpl.writeTok(txt_23, Tpl.ST_STRING("_11mix.h"));
        Tpl.textFile(l_mixheader, Tpl.textString(txt_23));
        System.tmpTickResetIndex(0, 0);
        System.tmpTickResetIndex(0, 1);
        txt_24 = CodegenC.simulationFile_jac(Tpl.emptyTxt, i_simCode);
        txt_25 = Tpl.writeStr(Tpl.emptyTxt, a_modelNamePrefix);
        txt_25 = Tpl.writeTok(txt_25, Tpl.ST_STRING("_12jac.c"));
        Tpl.textFileConvertLines(txt_24, Tpl.textString(txt_25));
        txt_26 = CodegenC.simulationFile_jac_header(Tpl.emptyTxt, i_simCode);
        txt_27 = Tpl.writeStr(Tpl.emptyTxt, a_modelNamePrefix);
        txt_27 = Tpl.writeTok(txt_27, Tpl.ST_STRING("_12jac.h"));
        Tpl.textFile(txt_26, Tpl.textString(txt_27));
        System.tmpTickResetIndex(0, 0);
        System.tmpTickResetIndex(0, 1);
        txt_28 = CodegenC.simulationFile_opt(Tpl.emptyTxt, i_simCode);
        txt_29 = Tpl.writeStr(Tpl.emptyTxt, a_modelNamePrefix);
        txt_29 = Tpl.writeTok(txt_29, Tpl.ST_STRING("_13opt.c"));
        Tpl.textFileConvertLines(txt_28, Tpl.textString(txt_29));
        txt_30 = CodegenC.simulationFile_opt_header(Tpl.emptyTxt, i_simCode);
        txt_31 = Tpl.writeStr(Tpl.emptyTxt, a_modelNamePrefix);
        txt_31 = Tpl.writeTok(txt_31, Tpl.ST_STRING("_13opt.h"));
        Tpl.textFile(txt_30, Tpl.textString(txt_31));
        System.tmpTickResetIndex(0, 0);
        System.tmpTickResetIndex(0, 1);
        txt_32 = CodegenC.simulationFile_lnz(Tpl.emptyTxt, i_simCode);
        txt_33 = Tpl.writeStr(Tpl.emptyTxt, a_modelNamePrefix);
        txt_33 = Tpl.writeTok(txt_33, Tpl.ST_STRING("_14lnz.c"));
        Tpl.textFileConvertLines(txt_32, Tpl.textString(txt_33));
        System.tmpTickResetIndex(0, 0);
        System.tmpTickResetIndex(0, 1);
        txt_34 = CodegenC.simulationFile_syn(Tpl.emptyTxt, i_simCode);
        txt_35 = Tpl.writeStr(Tpl.emptyTxt, a_modelNamePrefix);
        txt_35 = Tpl.writeTok(txt_35, Tpl.ST_STRING("_15syn.c"));
        Tpl.textFileConvertLines(txt_34, Tpl.textString(txt_35));
        System.tmpTickResetIndex(0, 0);
        System.tmpTickResetIndex(0, 1);
        txt_36 = CodegenC.simulationFile_dae(Tpl.emptyTxt, i_simCode);
        txt_37 = Tpl.writeStr(Tpl.emptyTxt, a_modelNamePrefix);
        txt_37 = Tpl.writeTok(txt_37, Tpl.ST_STRING("_16dae.c"));
        Tpl.textFileConvertLines(txt_36, Tpl.textString(txt_37));
        System.tmpTickResetIndex(0, 0);
        System.tmpTickResetIndex(0, 1);
        txt_38 = CodegenC.simulationFile_inl(Tpl.emptyTxt, i_simCode);
        txt_39 = Tpl.writeStr(Tpl.emptyTxt, a_modelNamePrefix);
        txt_39 = Tpl.writeTok(txt_39, Tpl.ST_STRING("_17inl.c"));
        Tpl.textFileConvertLines(txt_38, Tpl.textString(txt_39));
        System.tmpTickResetIndex(0, 0);
        System.tmpTickResetIndex(0, 1);
        txt_40 = CodegenC.simulationFile(Tpl.emptyTxt, i_simCode, a_guid, a_fmuVersion);
        txt_41 = Tpl.writeStr(Tpl.emptyTxt, a_modelNamePrefix);
        txt_41 = Tpl.writeTok(txt_41, Tpl.ST_STRING(".c"));
        Tpl.textFileConvertLines(txt_40, Tpl.textString(txt_41));
      then txt;

    case ( txt,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end generateSimulationFiles;

protected function fun_53
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input list<String> in_a_sourceFiles;
  input String in_a_FMUType;
  input String in_a_guid;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_sourceFiles, in_a_FMUType, in_a_guid, in_a_simCode)
    local
      Tpl.Text txt;
      list<String> a_sourceFiles;
      String a_FMUType;
      String a_guid;
      SimCode.SimCode a_simCode;

    case ( txt,
           false,
           _,
           a_FMUType,
           a_guid,
           a_simCode )
      equation
        txt = CodegenFMU1.fmiModelDescription(txt, a_simCode, a_guid, a_FMUType);
      then txt;

    case ( txt,
           _,
           a_sourceFiles,
           a_FMUType,
           a_guid,
           a_simCode )
      equation
        txt = CodegenFMU2.fmiModelDescription(txt, a_simCode, a_guid, a_FMUType, a_sourceFiles);
      then txt;
  end match;
end fun_53;

public function fmuModelDescriptionFile
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input String in_a_guid;
  input String in_a_FMUVersion;
  input String in_a_FMUType;
  input list<String> in_a_sourceFiles;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode, in_a_guid, in_a_FMUVersion, in_a_FMUType, in_a_sourceFiles)
    local
      Tpl.Text txt;
      String a_guid;
      String a_FMUVersion;
      String a_FMUType;
      list<String> a_sourceFiles;
      SimCode.SimCode i_simCode;
      Boolean ret_0;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = _)),
           a_guid,
           a_FMUVersion,
           a_FMUType,
           a_sourceFiles )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n"));
        ret_0 = FMI.isFMIVersion20(a_FMUVersion);
        txt = fun_53(txt, ret_0, a_sourceFiles, a_FMUType, a_guid, i_simCode);
      then txt;

    case ( txt,
           _,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fmuModelDescriptionFile;

protected function lm_55
  input Tpl.Text in_txt;
  input list<tuple<String, String>> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<tuple<String, String>> rest;
      String i_value;
      String i_name;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           (i_name, i_value) :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        txt = Tpl.writeStr(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\" : \""));
        txt = Tpl.writeStr(txt, i_value);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        txt = Tpl.nextIter(txt);
        txt = lm_55(txt, rest);
      then txt;
  end match;
end lm_55;

public function fmuSimulationFlagsFile
  input Tpl.Text in_txt;
  input SimCode.FmiSimulationFlags in_a_fmiSimulationFlags;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fmiSimulationFlags)
    local
      Tpl.Text txt;
      list<tuple<String, String>> i_flags_nameValueTuples;
      Tpl.Text l_fileContent;

    case ( txt,
           SimCode.FMI_SIMULATION_FLAGS(nameValueTuples = i_flags_nameValueTuples) )
      equation
        l_fileContent = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_LINE(",\n")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_fileContent = lm_55(l_fileContent, i_flags_nameValueTuples);
        l_fileContent = Tpl.popIter(l_fileContent);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("{\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeText(txt, l_fileContent);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fmuSimulationFlagsFile;

public function VendorAnnotations
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;

    case ( txt,
           SimCode.SIMCODE(modelInfo = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "<VendorAnnotations>\n",
                                    "</VendorAnnotations>"
                                }, false));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end VendorAnnotations;

protected function fun_58
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#include \"fmi-export/fmu1_model_interface.h\""));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "#include \"fmi-export/fmu2_model_interface.h\"\n",
                                    "#include \"fmi-export/fmu_read_flags.h\""
                                }, false));
      then txt;
  end match;
end fun_58;

protected function fun_59
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "void eventUpdate(ModelInstance* comp, fmiEventInfo* eventInfo);\n",
                                    "fmiReal getReal(ModelInstance* comp, const fmiValueReference vr);\n",
                                    "fmiStatus setReal(ModelInstance* comp, const fmiValueReference vr, const fmiReal value);\n",
                                    "fmiInteger getInteger(ModelInstance* comp, const fmiValueReference vr);\n",
                                    "fmiStatus setInteger(ModelInstance* comp, const fmiValueReference vr, const fmiInteger value);\n",
                                    "fmiBoolean getBoolean(ModelInstance* comp, const fmiValueReference vr);\n",
                                    "fmiStatus setBoolean(ModelInstance* comp, const fmiValueReference vr, const fmiBoolean value);\n",
                                    "fmiString getString(ModelInstance* comp, const fmiValueReference vr);\n",
                                    "fmiStatus setString(ModelInstance* comp, const fmiValueReference vr, fmiString value);\n",
                                    "fmiStatus setExternalFunction(ModelInstance* c, const fmiValueReference vr, const void* value);"
                                }, false));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "void eventUpdate(ModelInstance* comp, fmi2EventInfo* eventInfo);\n",
                                    "fmi2Real getReal(ModelInstance* comp, const fmi2ValueReference vr);\n",
                                    "fmi2Status setReal(ModelInstance* comp, const fmi2ValueReference vr, const fmi2Real value);\n",
                                    "fmi2Integer getInteger(ModelInstance* comp, const fmi2ValueReference vr);\n",
                                    "fmi2Status setInteger(ModelInstance* comp, const fmi2ValueReference vr, const fmi2Integer value);\n",
                                    "fmi2Boolean getBoolean(ModelInstance* comp, const fmi2ValueReference vr);\n",
                                    "fmi2Status setBoolean(ModelInstance* comp, const fmi2ValueReference vr, const fmi2Boolean value);\n",
                                    "fmi2String getString(ModelInstance* comp, const fmi2ValueReference vr);\n",
                                    "fmi2Status setString(ModelInstance* comp, const fmi2ValueReference vr, fmi2String value);\n",
                                    "fmi2Status setExternalFunction(ModelInstance* c, const fmi2ValueReference vr, const void* value);\n",
                                    "fmi2ValueReference mapInputReference2InputNumber(const fmi2ValueReference vr);\n",
                                    "fmi2ValueReference mapOutputReference2OutputNumber(const fmi2ValueReference vr);"
                                }, false));
      then txt;
  end match;
end fun_59;

protected function fun_60
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_simCode)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      Tpl.Text txt_3;
      Tpl.Text txt_2;
      Tpl.Text txt_1;
      Tpl.Text txt_0;

    case ( txt,
           false,
           a_simCode )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("extern void "));
        txt_0 = CodegenUtilSimulation.modelNamePrefix(Tpl.emptyTxt, a_simCode);
        txt = CodegenUtil.symbolName(txt, Tpl.textString(txt_0), "setupDataStruc");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA *data, threadData_t *threadData);\n",
                                    "#define fmu1_model_interface_setupDataStruc "
                                }, false));
        txt_1 = CodegenUtilSimulation.modelNamePrefix(Tpl.emptyTxt, a_simCode);
        txt = CodegenUtil.symbolName(txt, Tpl.textString(txt_1), "setupDataStruc");
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#include \"fmi-export/fmu1_model_interface.c.inc\""));
      then txt;

    case ( txt,
           _,
           a_simCode )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("extern void "));
        txt_2 = CodegenUtilSimulation.modelNamePrefix(Tpl.emptyTxt, a_simCode);
        txt = CodegenUtil.symbolName(txt, Tpl.textString(txt_2), "setupDataStruc");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(DATA *data, threadData_t *threadData);\n",
                                    "#define fmu2_model_interface_setupDataStruc "
                                }, false));
        txt_3 = CodegenUtilSimulation.modelNamePrefix(Tpl.emptyTxt, a_simCode);
        txt = CodegenUtil.symbolName(txt, Tpl.textString(txt_3), "setupDataStruc");
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "#include \"fmi-export/fmu2_model_interface.c.inc\"\n",
                                    "#include \"fmi-export/fmu_read_flags.c.inc\""
                                }, false));
      then txt;
  end match;
end fun_60;

protected function fun_61
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input SimCode.ModelInfo in_a_modelInfo;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_modelInfo, in_a_simCode)
    local
      Tpl.Text txt;
      SimCode.ModelInfo a_modelInfo;
      SimCode.SimCode a_simCode;

    case ( txt,
           false,
           a_modelInfo,
           a_simCode )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = eventUpdateFunction(txt, a_simCode);
        txt = Tpl.softNewLine(txt);
        txt = getRealFunction(txt, a_simCode, a_modelInfo);
        txt = Tpl.softNewLine(txt);
        txt = setRealFunction(txt, a_simCode, a_modelInfo);
        txt = Tpl.softNewLine(txt);
        txt = getIntegerFunction(txt, a_simCode, a_modelInfo);
        txt = Tpl.softNewLine(txt);
        txt = setIntegerFunction(txt, a_simCode, a_modelInfo);
        txt = Tpl.softNewLine(txt);
        txt = getBooleanFunction(txt, a_simCode, a_modelInfo);
        txt = Tpl.softNewLine(txt);
        txt = setBooleanFunction(txt, a_simCode, a_modelInfo);
        txt = Tpl.softNewLine(txt);
        txt = getStringFunction(txt, a_simCode, a_modelInfo);
        txt = Tpl.softNewLine(txt);
        txt = setStringFunction(txt, a_simCode, a_modelInfo);
        txt = Tpl.softNewLine(txt);
        txt = setExternalFunction(txt, a_modelInfo);
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           _,
           a_modelInfo,
           a_simCode )
      equation
        txt = eventUpdateFunction2(txt, a_simCode);
        txt = Tpl.softNewLine(txt);
        txt = getRealFunction2(txt, a_simCode, a_modelInfo);
        txt = Tpl.softNewLine(txt);
        txt = setRealFunction2(txt, a_simCode, a_modelInfo);
        txt = Tpl.softNewLine(txt);
        txt = getIntegerFunction2(txt, a_simCode, a_modelInfo);
        txt = Tpl.softNewLine(txt);
        txt = setIntegerFunction2(txt, a_simCode, a_modelInfo);
        txt = Tpl.softNewLine(txt);
        txt = getBooleanFunction2(txt, a_simCode, a_modelInfo);
        txt = Tpl.softNewLine(txt);
        txt = setBooleanFunction2(txt, a_simCode, a_modelInfo);
        txt = Tpl.softNewLine(txt);
        txt = getStringFunction2(txt, a_simCode, a_modelInfo);
        txt = Tpl.softNewLine(txt);
        txt = setStringFunction2(txt, a_simCode, a_modelInfo);
        txt = Tpl.softNewLine(txt);
        txt = setExternalFunction2(txt, a_modelInfo);
        txt = Tpl.softNewLine(txt);
        txt = mapInputAndOutputs(txt, a_simCode);
      then txt;
  end match;
end fun_61;

public function fmumodel_identifierFile
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input String in_a_guid;
  input String in_a_FMUVersion;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode, in_a_guid, in_a_FMUVersion)
    local
      Tpl.Text txt;
      String a_guid;
      String a_FMUVersion;
      SimCode.ModelInfo i_modelInfo;
      String i_fileNamePrefix;
      SimCode.SimCode i_simCode;
      Boolean ret_3;
      Boolean ret_2;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(fileNamePrefix = i_fileNamePrefix, modelInfo = i_modelInfo)),
           a_guid,
           a_FMUVersion )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "// define class name and unique id\n",
                                    "#define MODEL_IDENTIFIER "
                                }, false));
        txt = CodegenUtilSimulation.modelNamePrefix(txt, i_simCode);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#define MODEL_GUID \"{"));
        txt = Tpl.writeStr(txt, a_guid);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\"\n",
                                    "\n",
                                    "// include fmu header files, typedefs and macros\n",
                                    "#include <stdio.h>\n",
                                    "#include <string.h>\n",
                                    "#include <assert.h>\n",
                                    "#include \"openmodelica.h\"\n",
                                    "#include \"openmodelica_func.h\"\n",
                                    "#include \"simulation_data.h\"\n",
                                    "#include \"util/omc_error.h\"\n",
                                    "#include \""
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_functions.h\"\n",
                                    "#include \"simulation/solver/initialization/initialization.h\"\n",
                                    "#include \"simulation/solver/events.h\"\n"
                                }, true));
        ret_0 = FMI.isFMIVersion20(a_FMUVersion);
        txt = fun_58(txt, ret_0);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "#ifdef __cplusplus\n",
                                    "extern \"C\" {\n",
                                    "#endif\n",
                                    "\n",
                                    "void setStartValues(ModelInstance *comp);\n",
                                    "void setDefaultStartValues(ModelInstance *comp);\n"
                                }, true));
        ret_1 = FMI.isFMIVersion20(a_FMUVersion);
        txt = fun_59(txt, ret_1);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = ModelDefineData(txt, i_simCode, i_modelInfo);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "// implementation of the Model Exchange functions\n"
                                }, true));
        ret_2 = FMI.isFMIVersion20(a_FMUVersion);
        txt = fun_60(txt, ret_2, i_simCode);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = setDefaultStartValues(txt, i_modelInfo);
        txt = Tpl.softNewLine(txt);
        txt = setStartValues(txt, i_modelInfo);
        txt = Tpl.softNewLine(txt);
        ret_3 = FMI.isFMIVersion20(a_FMUVersion);
        txt = fun_61(txt, ret_3, i_modelInfo, i_simCode);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "#ifdef __cplusplus\n",
                                    "}\n",
                                    "#endif\n",
                                    "\n"
                                }, true));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fmumodel_identifierFile;

protected function fun_63
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input list<SimCodeVar.SimVar> in_a_listStates;
  input Integer in_a_varInfo_numStateVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_listStates, in_a_varInfo_numStateVars)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> a_listStates;
      Integer a_varInfo_numStateVars;

    case ( txt,
           false,
           _,
           a_varInfo_numStateVars )
      equation
        txt = Tpl.writeStr(txt, intString(a_varInfo_numStateVars));
      then txt;

    case ( txt,
           _,
           a_listStates,
           _ )
      equation
        txt = CodegenFMUCommon.statesnumwithDummy(txt, a_listStates);
      then txt;
  end match;
end fun_63;

protected function fun_64
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input SimCode.SimCode in_a_simCode;
  input DAE.ComponentRef in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_simCode, in_a_name)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      DAE.ComponentRef a_name;
      Integer ret_0;

    case ( txt,
           false,
           a_simCode,
           a_name )
      equation
        ret_0 = SimCodeUtil.lookupVR(a_name, a_simCode);
        txt = Tpl.writeStr(txt, intString(ret_0));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_64;

protected function lm_65
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCode.SimCode a_simCode;
      DAE.ComponentRef i_name;
      Boolean ret_1;
      Tpl.Text txt_0;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(name = i_name) :: rest,
           a_simCode )
      equation
        txt_0 = CodegenUtil.crefStr(Tpl.emptyTxt, i_name);
        ret_1 = stringEq(Tpl.textString(txt_0), "$dummy");
        txt = fun_64(txt, ret_1, a_simCode, i_name);
        txt = Tpl.nextIter(txt);
        txt = lm_65(txt, rest, a_simCode);
      then txt;

    case ( txt,
           _ :: rest,
           a_simCode )
      equation
        txt = lm_65(txt, rest, a_simCode);
      then txt;
  end match;
end lm_65;

protected function fun_66
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input SimCode.SimCode in_a_simCode;
  input DAE.ComponentRef in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_simCode, in_a_name)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      DAE.ComponentRef a_name;
      Integer ret_0;

    case ( txt,
           false,
           a_simCode,
           a_name )
      equation
        ret_0 = SimCodeUtil.lookupVR(a_name, a_simCode);
        txt = Tpl.writeStr(txt, intString(ret_0));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_66;

protected function lm_67
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCode.SimCode a_simCode;
      DAE.ComponentRef i_name;
      Boolean ret_1;
      Tpl.Text txt_0;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(name = i_name) :: rest,
           a_simCode )
      equation
        txt_0 = CodegenUtil.crefStr(Tpl.emptyTxt, i_name);
        ret_1 = stringEq(Tpl.textString(txt_0), "der($dummy)");
        txt = fun_66(txt, ret_1, a_simCode, i_name);
        txt = Tpl.nextIter(txt);
        txt = lm_67(txt, rest, a_simCode);
      then txt;

    case ( txt,
           _ :: rest,
           a_simCode )
      equation
        txt = lm_67(txt, rest, a_simCode);
      then txt;
  end match;
end lm_67;

protected function lm_68
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Function> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Function> rest;
      SimCodeFunction.Function i_fn;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_fn :: rest )
      equation
        txt = defineExternalFunction(txt, i_fn);
        txt = Tpl.nextIter(txt);
        txt = lm_68(txt, rest);
      then txt;
  end match;
end lm_68;

protected function fun_69
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo, in_a_simCode)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      list<SimCodeVar.SimVar> i_vars_derivativeVars;
      list<SimCodeVar.SimVar> i_vars_stateVars;
      list<SimCodeFunction.Function> i_functions;
      Integer i_varInfo_numZeroCrossings;
      list<SimCodeVar.SimVar> i_listStates;
      Integer i_varInfo_numBoolAliasVars;
      Integer i_varInfo_numBoolParams;
      Integer i_varInfo_numBoolAlgVars;
      Integer i_varInfo_numStringAliasVars;
      Integer i_varInfo_numStringParamVars;
      Integer i_varInfo_numStringAlgVars;
      Integer i_varInfo_numIntAliasVars;
      Integer i_varInfo_numIntParams;
      Integer i_varInfo_numIntAlgVars;
      Integer i_varInfo_numAlgAliasVars;
      Integer i_varInfo_numParams;
      Integer i_varInfo_numAlgVars;
      Integer i_varInfo_numDiscreteReal;
      Integer i_varInfo_numStateVars;
      Integer ret_16;
      Boolean ret_15;
      Integer ret_14;
      Integer ret_13;
      Tpl.Text l_numberOfBooleans;
      Integer ret_11;
      Integer ret_10;
      Tpl.Text l_numberOfStrings;
      Integer ret_8;
      Integer ret_7;
      Tpl.Text l_numberOfIntegers;
      Integer ret_5;
      Integer ret_4;
      Integer ret_3;
      Integer ret_2;
      Integer ret_1;
      Tpl.Text l_numberOfReals;

    case ( txt,
           SimCode.MODELINFO(varInfo = SimCode.VARINFO(numStateVars = i_varInfo_numStateVars, numDiscreteReal = i_varInfo_numDiscreteReal, numAlgVars = i_varInfo_numAlgVars, numParams = i_varInfo_numParams, numAlgAliasVars = i_varInfo_numAlgAliasVars, numIntAlgVars = i_varInfo_numIntAlgVars, numIntParams = i_varInfo_numIntParams, numIntAliasVars = i_varInfo_numIntAliasVars, numStringAlgVars = i_varInfo_numStringAlgVars, numStringParamVars = i_varInfo_numStringParamVars, numStringAliasVars = i_varInfo_numStringAliasVars, numBoolAlgVars = i_varInfo_numBoolAlgVars, numBoolParams = i_varInfo_numBoolParams, numBoolAliasVars = i_varInfo_numBoolAliasVars, numZeroCrossings = i_varInfo_numZeroCrossings), vars = SimCodeVar.SIMVARS(stateVars = (i_vars_stateVars as i_listStates), derivativeVars = i_vars_derivativeVars), functions = i_functions),
           a_simCode )
      equation
        ret_1 = intMul(i_varInfo_numStateVars, 2);
        ret_2 = intAdd(i_varInfo_numParams, i_varInfo_numAlgAliasVars);
        ret_3 = intAdd(i_varInfo_numAlgVars, ret_2);
        ret_4 = intAdd(i_varInfo_numDiscreteReal, ret_3);
        ret_5 = intAdd(ret_1, ret_4);
        l_numberOfReals = Tpl.writeStr(Tpl.emptyTxt, intString(ret_5));
        ret_7 = intAdd(i_varInfo_numIntParams, i_varInfo_numIntAliasVars);
        ret_8 = intAdd(i_varInfo_numIntAlgVars, ret_7);
        l_numberOfIntegers = Tpl.writeStr(Tpl.emptyTxt, intString(ret_8));
        ret_10 = intAdd(i_varInfo_numStringParamVars, i_varInfo_numStringAliasVars);
        ret_11 = intAdd(i_varInfo_numStringAlgVars, ret_10);
        l_numberOfStrings = Tpl.writeStr(Tpl.emptyTxt, intString(ret_11));
        ret_13 = intAdd(i_varInfo_numBoolParams, i_varInfo_numBoolAliasVars);
        ret_14 = intAdd(i_varInfo_numBoolAlgVars, ret_13);
        l_numberOfBooleans = Tpl.writeStr(Tpl.emptyTxt, intString(ret_14));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "// define model size\n",
                                    "#define NUMBER_OF_STATES "
                                }, false));
        ret_15 = intEq(i_varInfo_numStateVars, 1);
        txt = fun_63(txt, ret_15, i_listStates, i_varInfo_numStateVars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#define NUMBER_OF_EVENT_INDICATORS "));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numZeroCrossings));
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#define NUMBER_OF_REALS "));
        txt = Tpl.writeText(txt, l_numberOfReals);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#define NUMBER_OF_INTEGERS "));
        txt = Tpl.writeText(txt, l_numberOfIntegers);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#define NUMBER_OF_STRINGS "));
        txt = Tpl.writeText(txt, l_numberOfStrings);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#define NUMBER_OF_BOOLEANS "));
        txt = Tpl.writeText(txt, l_numberOfBooleans);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#define NUMBER_OF_EXTERNALFUNCTIONS "));
        ret_16 = SimCodeUtil.countDynamicExternalFunctions(i_functions);
        txt = Tpl.writeStr(txt, intString(ret_16));
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "// define initial state vector as vector of value references\n",
                                    "#define STATES { "
                                }, false));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_65(txt, i_vars_stateVars, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " }\n",
                                    "#define STATESDERIVATIVES { "
                                }, false));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_67(txt, i_vars_derivativeVars, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " }\n",
                                    "\n"
                                }, true));
        System.tmpTickReset(0);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_68(txt, i_functions);
        txt = Tpl.popIter(txt);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_69;

public function ModelDefineData
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input SimCode.ModelInfo a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_69(txt, a_modelInfo, a_simCode);
end ModelDefineData;

public function dervativeNameCStyle
  input Tpl.Text in_txt;
  input DAE.ComponentRef in_a_cr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_cr)
    local
      Tpl.Text txt;
      DAE.ComponentRef i_componentRef;

    case ( txt,
           DAE.CREF_QUAL(ident = "$DER", componentRef = i_componentRef) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("der_"));
        txt = CodegenUtil.crefStr(txt, i_componentRef);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end dervativeNameCStyle;

public function defineExternalFunction
  input Tpl.Text in_txt;
  input SimCodeFunction.Function in_a_fn;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fn)
    local
      Tpl.Text txt;
      String i_language;
      String i_extName;
      Integer ret_1;
      Tpl.Text l_fname;

    case ( txt,
           SimCodeFunction.EXTERNAL_FUNCTION(dynamicLoad = true, extName = i_extName, language = i_language) )
      equation
        l_fname = CodegenCFunctions.extFunctionName(Tpl.emptyTxt, i_extName, i_language);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#define $P"));
        txt = Tpl.writeText(txt, l_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        ret_1 = System.tmpTick();
        txt = Tpl.writeStr(txt, intString(ret_1));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end defineExternalFunction;

protected function lm_73
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = initValsDefault(txt, i_var, "realVars");
        txt = Tpl.nextIter(txt);
        txt = lm_73(txt, rest);
      then txt;
  end match;
end lm_73;

protected function lm_74
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = initValsDefault(txt, i_var, "realVars");
        txt = Tpl.nextIter(txt);
        txt = lm_74(txt, rest);
      then txt;
  end match;
end lm_74;

protected function lm_75
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = initValsDefault(txt, i_var, "realVars");
        txt = Tpl.nextIter(txt);
        txt = lm_75(txt, rest);
      then txt;
  end match;
end lm_75;

protected function lm_76
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = initValsDefault(txt, i_var, "realVars");
        txt = Tpl.nextIter(txt);
        txt = lm_76(txt, rest);
      then txt;
  end match;
end lm_76;

protected function lm_77
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = initValsDefault(txt, i_var, "integerVars");
        txt = Tpl.nextIter(txt);
        txt = lm_77(txt, rest);
      then txt;
  end match;
end lm_77;

protected function lm_78
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = initValsDefault(txt, i_var, "booleanVars");
        txt = Tpl.nextIter(txt);
        txt = lm_78(txt, rest);
      then txt;
  end match;
end lm_78;

protected function lm_79
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = initValsDefault(txt, i_var, "stringVars");
        txt = Tpl.nextIter(txt);
        txt = lm_79(txt, rest);
      then txt;
  end match;
end lm_79;

protected function lm_80
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = initParamsDefault(txt, i_var, "realParameter");
        txt = Tpl.nextIter(txt);
        txt = lm_80(txt, rest);
      then txt;
  end match;
end lm_80;

protected function lm_81
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = initParamsDefault(txt, i_var, "integerParameter");
        txt = Tpl.nextIter(txt);
        txt = lm_81(txt, rest);
      then txt;
  end match;
end lm_81;

protected function lm_82
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = initParamsDefault(txt, i_var, "booleanParameter");
        txt = Tpl.nextIter(txt);
        txt = lm_82(txt, rest);
      then txt;
  end match;
end lm_82;

protected function lm_83
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = initParamsDefault(txt, i_var, "stringParameter");
        txt = Tpl.nextIter(txt);
        txt = lm_83(txt, rest);
      then txt;
  end match;
end lm_83;

public function setDefaultStartValues
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> i_vars_stringParamVars;
      list<SimCodeVar.SimVar> i_vars_boolParamVars;
      list<SimCodeVar.SimVar> i_vars_intParamVars;
      list<SimCodeVar.SimVar> i_vars_paramVars;
      list<SimCodeVar.SimVar> i_vars_stringAlgVars;
      list<SimCodeVar.SimVar> i_vars_boolAlgVars;
      list<SimCodeVar.SimVar> i_vars_intAlgVars;
      list<SimCodeVar.SimVar> i_vars_discreteAlgVars;
      list<SimCodeVar.SimVar> i_vars_algVars;
      list<SimCodeVar.SimVar> i_vars_derivativeVars;
      list<SimCodeVar.SimVar> i_vars_stateVars;

    case ( txt,
           SimCode.MODELINFO(varInfo = SimCode.VARINFO(numStateVars = _, numAlgVars = _), vars = SimCodeVar.SIMVARS(stateVars = i_vars_stateVars, derivativeVars = i_vars_derivativeVars, algVars = i_vars_algVars, discreteAlgVars = i_vars_discreteAlgVars, intAlgVars = i_vars_intAlgVars, boolAlgVars = i_vars_boolAlgVars, stringAlgVars = i_vars_stringAlgVars, paramVars = i_vars_paramVars, intParamVars = i_vars_intParamVars, boolParamVars = i_vars_boolParamVars, stringParamVars = i_vars_stringParamVars)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "// Set values for all variables that define a start value\n",
                                    "OMC_DISABLE_OPT\n",
                                    "void setDefaultStartValues(ModelInstance *comp) {\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_73(txt, i_vars_stateVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_74(txt, i_vars_derivativeVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_75(txt, i_vars_algVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_76(txt, i_vars_discreteAlgVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_77(txt, i_vars_intAlgVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_78(txt, i_vars_boolAlgVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_79(txt, i_vars_stringAlgVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_80(txt, i_vars_paramVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_81(txt, i_vars_intParamVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_82(txt, i_vars_boolParamVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_83(txt, i_vars_stringParamVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end setDefaultStartValues;

protected function lm_85
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = initVals(txt, i_var, "realVars");
        txt = Tpl.nextIter(txt);
        txt = lm_85(txt, rest);
      then txt;
  end match;
end lm_85;

protected function lm_86
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = initVals(txt, i_var, "realVars");
        txt = Tpl.nextIter(txt);
        txt = lm_86(txt, rest);
      then txt;
  end match;
end lm_86;

protected function lm_87
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = initVals(txt, i_var, "realVars");
        txt = Tpl.nextIter(txt);
        txt = lm_87(txt, rest);
      then txt;
  end match;
end lm_87;

protected function lm_88
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = initVals(txt, i_var, "realVars");
        txt = Tpl.nextIter(txt);
        txt = lm_88(txt, rest);
      then txt;
  end match;
end lm_88;

protected function lm_89
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = initVals(txt, i_var, "integerVars");
        txt = Tpl.nextIter(txt);
        txt = lm_89(txt, rest);
      then txt;
  end match;
end lm_89;

protected function lm_90
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = initVals(txt, i_var, "booleanVars");
        txt = Tpl.nextIter(txt);
        txt = lm_90(txt, rest);
      then txt;
  end match;
end lm_90;

protected function lm_91
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = initVals(txt, i_var, "stringVars");
        txt = Tpl.nextIter(txt);
        txt = lm_91(txt, rest);
      then txt;
  end match;
end lm_91;

protected function lm_92
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = initParams(txt, i_var, "realParameter");
        txt = Tpl.nextIter(txt);
        txt = lm_92(txt, rest);
      then txt;
  end match;
end lm_92;

protected function lm_93
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = initParams(txt, i_var, "integerParameter");
        txt = Tpl.nextIter(txt);
        txt = lm_93(txt, rest);
      then txt;
  end match;
end lm_93;

protected function lm_94
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = initParams(txt, i_var, "booleanParameter");
        txt = Tpl.nextIter(txt);
        txt = lm_94(txt, rest);
      then txt;
  end match;
end lm_94;

protected function lm_95
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = initParams(txt, i_var, "stringParameter");
        txt = Tpl.nextIter(txt);
        txt = lm_95(txt, rest);
      then txt;
  end match;
end lm_95;

public function setStartValues
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> i_vars_stringParamVars;
      list<SimCodeVar.SimVar> i_vars_boolParamVars;
      list<SimCodeVar.SimVar> i_vars_intParamVars;
      list<SimCodeVar.SimVar> i_vars_paramVars;
      list<SimCodeVar.SimVar> i_vars_stringAlgVars;
      list<SimCodeVar.SimVar> i_vars_boolAlgVars;
      list<SimCodeVar.SimVar> i_vars_intAlgVars;
      list<SimCodeVar.SimVar> i_vars_discreteAlgVars;
      list<SimCodeVar.SimVar> i_vars_algVars;
      list<SimCodeVar.SimVar> i_vars_derivativeVars;
      list<SimCodeVar.SimVar> i_vars_stateVars;

    case ( txt,
           SimCode.MODELINFO(varInfo = SimCode.VARINFO(numStateVars = _, numAlgVars = _), vars = SimCodeVar.SIMVARS(stateVars = i_vars_stateVars, derivativeVars = i_vars_derivativeVars, algVars = i_vars_algVars, discreteAlgVars = i_vars_discreteAlgVars, intAlgVars = i_vars_intAlgVars, boolAlgVars = i_vars_boolAlgVars, stringAlgVars = i_vars_stringAlgVars, paramVars = i_vars_paramVars, intParamVars = i_vars_intParamVars, boolParamVars = i_vars_boolParamVars, stringParamVars = i_vars_stringParamVars)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "// Set values for all variables that define a start value\n",
                                    "OMC_DISABLE_OPT\n",
                                    "void setStartValues(ModelInstance *comp) {\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_85(txt, i_vars_stateVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_86(txt, i_vars_derivativeVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_87(txt, i_vars_algVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_88(txt, i_vars_discreteAlgVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_89(txt, i_vars_intAlgVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_90(txt, i_vars_boolAlgVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_91(txt, i_vars_stringAlgVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_92(txt, i_vars_paramVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_93(txt, i_vars_intParamVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_94(txt, i_vars_boolParamVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_95(txt, i_vars_stringParamVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n"
                                }, true));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end setStartValues;

protected function lm_97
  input Tpl.Text in_txt;
  input list<SimCode.SimEqSystem> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCode.SimEqSystem> rest;
      DAE.ComponentRef i_cref;
      String ret_1;
      Tpl.Text txt_0;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           SimCode.SES_SIMPLE_ASSIGN(cref = i_cref) :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if (sim_verbose) { printf(\"Setting variable start value: %s(start=%f)\\n\", \""));
        txt_0 = CodegenUtil.crefStrNoUnderscore(Tpl.emptyTxt, i_cref);
        ret_1 = Util.escapeModelicaStringToCString(Tpl.textString(txt_0));
        txt = Tpl.writeStr(txt, ret_1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\", "));
        txt = CodegenCFunctions.cref(txt, i_cref);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("); }"));
        txt = Tpl.nextIter(txt);
        txt = lm_97(txt, rest);
      then txt;

    case ( txt,
           _ :: rest )
      equation
        txt = lm_97(txt, rest);
      then txt;
  end match;
end lm_97;

public function initializeFunction
  input Tpl.Text txt;
  input list<SimCode.SimEqSystem> a_allEquations;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_eqPart;
  Tpl.Text l_varDecls;
algorithm
  l_varDecls := Tpl.emptyTxt;
  l_eqPart := Tpl.emptyTxt;
  out_txt := Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                   "// Used to set the first time event, if any.\n",
                                   "void initialize(ModelInstance* comp, fmiEventInfo* eventInfo) {\n",
                                   "\n"
                               }, true));
  out_txt := Tpl.pushBlock(out_txt, Tpl.BT_INDENT(2));
  out_txt := Tpl.writeText(out_txt, l_varDecls);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_NEW_LINE());
  out_txt := Tpl.writeText(out_txt, l_eqPart);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.pushIter(out_txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_97(out_txt, a_allEquations);
  out_txt := Tpl.popIter(out_txt);
  out_txt := Tpl.softNewLine(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_NEW_LINE());
  out_txt := Tpl.popBlock(out_txt);
  out_txt := Tpl.writeTok(out_txt, Tpl.ST_STRING("}"));
end initializeFunction;

protected function fun_99
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_index;
  input String in_a_arrayName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_index, in_a_arrayName)
    local
      Tpl.Text txt;
      Integer a_index;
      String a_arrayName;
      Tpl.Text l_str;

    case ( txt,
           false,
           a_index,
           a_arrayName )
      equation
        l_str = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("comp->fmuData->modelData->"));
        l_str = Tpl.writeStr(l_str, a_arrayName);
        l_str = Tpl.writeTok(l_str, Tpl.ST_STRING("Data["));
        l_str = Tpl.writeStr(l_str, intString(a_index));
        l_str = Tpl.writeTok(l_str, Tpl.ST_STRING("].attribute.start"));
        txt = Tpl.writeText(txt, l_str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" =  comp->fmuData->localData[0]->"));
        txt = Tpl.writeStr(txt, a_arrayName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("["));
        txt = Tpl.writeStr(txt, intString(a_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("];"));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_99;

protected function fun_100
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_index;
  input String in_a_arrayName;
  input DAE.ComponentRef in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_index, in_a_arrayName, in_a_name)
    local
      Tpl.Text txt;
      Integer a_index;
      String a_arrayName;
      DAE.ComponentRef a_name;
      Boolean ret_1;
      Tpl.Text txt_0;

    case ( txt,
           false,
           a_index,
           a_arrayName,
           a_name )
      equation
        txt_0 = CodegenUtil.crefStr(Tpl.emptyTxt, a_name);
        ret_1 = stringEq(Tpl.textString(txt_0), "der($dummy)");
        txt = fun_99(txt, ret_1, a_index, a_arrayName);
      then txt;

    case ( txt,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_100;

public function initVals
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_a_var;
  input String in_a_arrayName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_var, in_a_arrayName)
    local
      Tpl.Text txt;
      String a_arrayName;
      Integer i_index;
      DAE.ComponentRef i_name;
      Boolean ret_1;
      Tpl.Text txt_0;

    case ( txt,
           SimCodeVar.SIMVAR(name = i_name, index = i_index),
           a_arrayName )
      equation
        txt_0 = CodegenUtil.crefStr(Tpl.emptyTxt, i_name);
        ret_1 = stringEq(Tpl.textString(txt_0), "$dummy");
        txt = fun_100(txt, ret_1, i_index, a_arrayName, i_name);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end initVals;

public function initParams
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_a_var;
  input String in_a_arrayName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_var, in_a_arrayName)
    local
      Tpl.Text txt;
      String a_arrayName;
      Integer i_index;
      Tpl.Text l_str;

    case ( txt,
           SimCodeVar.SIMVAR(index = i_index),
           a_arrayName )
      equation
        l_str = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("comp->fmuData->modelData->"));
        l_str = Tpl.writeStr(l_str, a_arrayName);
        l_str = Tpl.writeTok(l_str, Tpl.ST_STRING("Data["));
        l_str = Tpl.writeStr(l_str, intString(i_index));
        l_str = Tpl.writeTok(l_str, Tpl.ST_STRING("].attribute.start"));
        txt = Tpl.writeText(txt, l_str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = comp->fmuData->simulationInfo->"));
        txt = Tpl.writeStr(txt, a_arrayName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("["));
        txt = Tpl.writeStr(txt, intString(i_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("];"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end initParams;

public function initValsDefault
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_a_var;
  input String in_a_arrayName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_var, in_a_arrayName)
    local
      Tpl.Text txt;
      String a_arrayName;
      SimCodeVar.SimVar i_var;
      Integer i_index;
      Tpl.Text l_str;

    case ( txt,
           (i_var as SimCodeVar.SIMVAR(index = i_index, type_ = _)),
           a_arrayName )
      equation
        l_str = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("comp->fmuData->modelData->"));
        l_str = Tpl.writeStr(l_str, a_arrayName);
        l_str = Tpl.writeTok(l_str, Tpl.ST_STRING("Data["));
        l_str = Tpl.writeStr(l_str, intString(i_index));
        l_str = Tpl.writeTok(l_str, Tpl.ST_STRING("].attribute.start"));
        txt = Tpl.writeText(txt, l_str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = initValDefault(txt, i_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end initValsDefault;

protected function fun_104
  input Tpl.Text in_txt;
  input Option<DAE.Exp> in_a_initialValue;
  input SimCodeVar.SimVar in_a_var;
  input Tpl.Text in_a_str;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_initialValue, in_a_var, in_a_str)
    local
      Tpl.Text txt;
      SimCodeVar.SimVar a_var;
      Tpl.Text a_str;
      DAE.Exp i_v;

    case ( txt,
           SOME((i_v as DAE.SCONST(string = _))),
           _,
           a_str )
      equation
        txt = Tpl.writeText(txt, a_str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = mmc_mk_scon_persist("));
        txt = initVal(txt, i_v);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("); /* TODO: these are not freed currently, see #6161 */"));
      then txt;

    case ( txt,
           _,
           a_var,
           a_str )
      equation
        txt = Tpl.writeText(txt, a_str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = initValDefault(txt, a_var);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_104;

public function initParamsDefault
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_a_var;
  input String in_a_arrayName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_var, in_a_arrayName)
    local
      Tpl.Text txt;
      String a_arrayName;
      SimCodeVar.SimVar i_var;
      Option<DAE.Exp> i_initialValue;
      Integer i_index;
      Tpl.Text l_str;

    case ( txt,
           (i_var as SimCodeVar.SIMVAR(index = i_index, initialValue = i_initialValue)),
           a_arrayName )
      equation
        l_str = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("comp->fmuData->modelData->"));
        l_str = Tpl.writeStr(l_str, a_arrayName);
        l_str = Tpl.writeTok(l_str, Tpl.ST_STRING("Data["));
        l_str = Tpl.writeStr(l_str, intString(i_index));
        l_str = Tpl.writeTok(l_str, Tpl.ST_STRING("].attribute.start"));
        txt = fun_104(txt, i_initialValue, i_var, l_str);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end initParamsDefault;

protected function fun_106
  input Tpl.Text in_txt;
  input DAE.Type in_a_var_type__;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_var_type__)
    local
      Tpl.Text txt;
      DAE.Type i_var_type__;
      Tpl.Text txt_0;
      String ret_0;

    case ( txt,
           DAE.T_INTEGER(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("0"));
      then txt;

    case ( txt,
           DAE.T_REAL(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("0"));
      then txt;

    case ( txt,
           DAE.T_ENUMERATION(index = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("0"));
      then txt;

    case ( txt,
           DAE.T_BOOL(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("0"));
      then txt;

    case ( txt,
           DAE.T_STRING(varLst = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("mmc_mk_scon(\"\")"));
      then txt;

    case ( txt,
           i_var_type__ )
      equation
        txt_0 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("Unknown type for initValDefault: "));
        ret_0 = Types.unparseType(i_var_type__);
        txt_0 = Tpl.writeStr(txt_0, ret_0);
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenFMU.tpl", 522, 22), Tpl.textString(txt_0));
      then txt;
  end match;
end fun_106;

protected function fun_107
  input Tpl.Text in_txt;
  input Option<DAE.Exp> in_a_var_initialValue;
  input DAE.Type in_a_var_type__;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_var_initialValue, in_a_var_type__)
    local
      Tpl.Text txt;
      DAE.Type a_var_type__;
      DAE.Exp i_v;

    case ( txt,
           SOME((i_v as DAE.ICONST(integer = _))),
           _ )
      equation
        txt = initVal(txt, i_v);
      then txt;

    case ( txt,
           SOME((i_v as DAE.RCONST(real = _))),
           _ )
      equation
        txt = initVal(txt, i_v);
      then txt;

    case ( txt,
           SOME((i_v as DAE.SCONST(string = _))),
           _ )
      equation
        txt = initVal(txt, i_v);
      then txt;

    case ( txt,
           SOME((i_v as DAE.BCONST(bool = _))),
           _ )
      equation
        txt = initVal(txt, i_v);
      then txt;

    case ( txt,
           SOME((i_v as DAE.ENUM_LITERAL(name = _))),
           _ )
      equation
        txt = initVal(txt, i_v);
      then txt;

    case ( txt,
           _,
           a_var_type__ )
      equation
        txt = fun_106(txt, a_var_type__);
      then txt;
  end match;
end fun_107;

public function initValDefault
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_a_var;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_var)
    local
      Tpl.Text txt;
      DAE.Type i_var_type__;
      Option<DAE.Exp> i_var_initialValue;

    case ( txt,
           SimCodeVar.SIMVAR(initialValue = i_var_initialValue, type_ = i_var_type__) )
      equation
        txt = fun_107(txt, i_var_initialValue, i_var_type__);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end initValDefault;

protected function fun_109
  input Tpl.Text in_txt;
  input Boolean in_a_bool;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_bool)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("0"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("1"));
      then txt;
  end match;
end fun_109;

public function initVal
  input Tpl.Text in_txt;
  input DAE.Exp in_a_initialValue;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_initialValue)
    local
      Tpl.Text txt;
      DAE.Exp i_initialValue;
      Integer i_index;
      Boolean i_bool;
      String i_string;
      Real i_real;
      Integer i_integer;
      Tpl.Text txt_1;
      String ret_1;
      String ret_0;

    case ( txt,
           DAE.ICONST(integer = i_integer) )
      equation
        txt = Tpl.writeStr(txt, intString(i_integer));
      then txt;

    case ( txt,
           DAE.RCONST(real = i_real) )
      equation
        txt = Tpl.writeStr(txt, realString(i_real));
      then txt;

    case ( txt,
           DAE.SCONST(string = i_string) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
        ret_0 = Util.escapeModelicaStringToXmlString(i_string);
        txt = Tpl.writeStr(txt, ret_0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
      then txt;

    case ( txt,
           DAE.BCONST(bool = i_bool) )
      equation
        txt = fun_109(txt, i_bool);
      then txt;

    case ( txt,
           DAE.ENUM_LITERAL(index = i_index) )
      equation
        txt = Tpl.writeStr(txt, intString(i_index));
      then txt;

    case ( txt,
           i_initialValue )
      equation
        txt_1 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("initial value of unknown type: "));
        ret_1 = ExpressionDump.printExpStr(i_initialValue);
        txt_1 = Tpl.writeStr(txt_1, ret_1);
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenFMU.tpl", 533, 14), Tpl.textString(txt_1));
      then txt;
  end match;
end initVal;

public function eventUpdateFunction
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;

    case ( txt,
           SimCode.SIMCODE(modelInfo = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "// Used to set the next time event, if any.\n",
                                    "void eventUpdate(ModelInstance* comp, fmiEventInfo* eventInfo) {\n",
                                    "}\n",
                                    "\n"
                                }, true));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end eventUpdateFunction;

protected function lm_112
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCode.SimCode a_simCode;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_simCode )
      equation
        txt = SwitchVars(txt, a_simCode, i_var, "realVars");
        txt = Tpl.nextIter(txt);
        txt = lm_112(txt, rest, a_simCode);
      then txt;
  end match;
end lm_112;

protected function lm_113
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCode.SimCode a_simCode;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_simCode )
      equation
        txt = SwitchVars(txt, a_simCode, i_var, "realVars");
        txt = Tpl.nextIter(txt);
        txt = lm_113(txt, rest, a_simCode);
      then txt;
  end match;
end lm_113;

protected function lm_114
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCode.SimCode a_simCode;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_simCode )
      equation
        txt = SwitchVars(txt, a_simCode, i_var, "realVars");
        txt = Tpl.nextIter(txt);
        txt = lm_114(txt, rest, a_simCode);
      then txt;
  end match;
end lm_114;

protected function lm_115
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCode.SimCode a_simCode;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_simCode )
      equation
        txt = SwitchVars(txt, a_simCode, i_var, "realVars");
        txt = Tpl.nextIter(txt);
        txt = lm_115(txt, rest, a_simCode);
      then txt;
  end match;
end lm_115;

protected function lm_116
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCode.SimCode a_simCode;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_simCode )
      equation
        txt = SwitchParameters(txt, a_simCode, i_var, "realParameter");
        txt = Tpl.nextIter(txt);
        txt = lm_116(txt, rest, a_simCode);
      then txt;
  end match;
end lm_116;

protected function lm_117
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCode.SimCode a_simCode;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_simCode )
      equation
        txt = SwitchAliasVars(txt, a_simCode, i_var, "Real", "-");
        txt = Tpl.nextIter(txt);
        txt = lm_117(txt, rest, a_simCode);
      then txt;
  end match;
end lm_117;

protected function fun_118
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo, in_a_simCode)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      list<SimCodeVar.SimVar> i_vars_aliasVars;
      list<SimCodeVar.SimVar> i_vars_paramVars;
      list<SimCodeVar.SimVar> i_vars_discreteAlgVars;
      list<SimCodeVar.SimVar> i_vars_algVars;
      list<SimCodeVar.SimVar> i_vars_derivativeVars;
      list<SimCodeVar.SimVar> i_vars_stateVars;

    case ( txt,
           SimCode.MODELINFO(vars = SimCodeVar.SIMVARS(stateVars = i_vars_stateVars, derivativeVars = i_vars_derivativeVars, algVars = i_vars_algVars, discreteAlgVars = i_vars_discreteAlgVars, paramVars = i_vars_paramVars, aliasVars = i_vars_aliasVars), varInfo = SimCode.VARINFO(numStateVars = _, numAlgVars = _)),
           a_simCode )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "fmiReal getReal(ModelInstance* comp, const fmiValueReference vr) {\n",
                                    "  switch (vr) {\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_112(txt, i_vars_stateVars, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_113(txt, i_vars_derivativeVars, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_114(txt, i_vars_algVars, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_115(txt, i_vars_discreteAlgVars, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_116(txt, i_vars_paramVars, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_117(txt, i_vars_aliasVars, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "default:\n",
                                    "  return 0;\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "  }\n",
                                    "}\n",
                                    "\n"
                                }, true));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_118;

public function getRealFunction
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input SimCode.ModelInfo a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_118(txt, a_modelInfo, a_simCode);
end getRealFunction;

protected function lm_120
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCode.SimCode a_simCode;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_simCode )
      equation
        txt = SwitchVarsSet(txt, a_simCode, i_var, "realVars");
        txt = Tpl.nextIter(txt);
        txt = lm_120(txt, rest, a_simCode);
      then txt;
  end match;
end lm_120;

protected function lm_121
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCode.SimCode a_simCode;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_simCode )
      equation
        txt = SwitchVarsSet(txt, a_simCode, i_var, "realVars");
        txt = Tpl.nextIter(txt);
        txt = lm_121(txt, rest, a_simCode);
      then txt;
  end match;
end lm_121;

protected function lm_122
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCode.SimCode a_simCode;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_simCode )
      equation
        txt = SwitchVarsSet(txt, a_simCode, i_var, "realVars");
        txt = Tpl.nextIter(txt);
        txt = lm_122(txt, rest, a_simCode);
      then txt;
  end match;
end lm_122;

protected function lm_123
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCode.SimCode a_simCode;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_simCode )
      equation
        txt = SwitchVarsSet(txt, a_simCode, i_var, "realVars");
        txt = Tpl.nextIter(txt);
        txt = lm_123(txt, rest, a_simCode);
      then txt;
  end match;
end lm_123;

protected function lm_124
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCode.SimCode a_simCode;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_simCode )
      equation
        txt = SwitchParametersSet(txt, a_simCode, i_var, "realParameter");
        txt = Tpl.nextIter(txt);
        txt = lm_124(txt, rest, a_simCode);
      then txt;
  end match;
end lm_124;

protected function lm_125
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCode.SimCode a_simCode;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_simCode )
      equation
        txt = SwitchAliasVarsSet(txt, a_simCode, i_var, "Real", "-");
        txt = Tpl.nextIter(txt);
        txt = lm_125(txt, rest, a_simCode);
      then txt;
  end match;
end lm_125;

protected function fun_126
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo, in_a_simCode)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      list<SimCodeVar.SimVar> i_vars_aliasVars;
      list<SimCodeVar.SimVar> i_vars_paramVars;
      list<SimCodeVar.SimVar> i_vars_discreteAlgVars;
      list<SimCodeVar.SimVar> i_vars_algVars;
      list<SimCodeVar.SimVar> i_vars_derivativeVars;
      list<SimCodeVar.SimVar> i_vars_stateVars;

    case ( txt,
           SimCode.MODELINFO(vars = SimCodeVar.SIMVARS(stateVars = i_vars_stateVars, derivativeVars = i_vars_derivativeVars, algVars = i_vars_algVars, discreteAlgVars = i_vars_discreteAlgVars, paramVars = i_vars_paramVars, aliasVars = i_vars_aliasVars), varInfo = SimCode.VARINFO(numStateVars = _, numAlgVars = _)),
           a_simCode )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "fmiStatus setReal(ModelInstance* comp, const fmiValueReference vr, const fmiReal value) {\n",
                                    "  switch (vr) {\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_120(txt, i_vars_stateVars, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_121(txt, i_vars_derivativeVars, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_122(txt, i_vars_algVars, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_123(txt, i_vars_discreteAlgVars, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_124(txt, i_vars_paramVars, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_125(txt, i_vars_aliasVars, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "default:\n",
                                    "  return fmiError;\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "  }\n",
                                    "  return fmiOK;\n",
                                    "}\n",
                                    "\n"
                                }, true));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_126;

public function setRealFunction
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input SimCode.ModelInfo a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_126(txt, a_modelInfo, a_simCode);
end setRealFunction;

protected function lm_128
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCode.SimCode a_simCode;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_simCode )
      equation
        txt = SwitchVars(txt, a_simCode, i_var, "integerVars");
        txt = Tpl.nextIter(txt);
        txt = lm_128(txt, rest, a_simCode);
      then txt;
  end match;
end lm_128;

protected function lm_129
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCode.SimCode a_simCode;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_simCode )
      equation
        txt = SwitchParameters(txt, a_simCode, i_var, "integerParameter");
        txt = Tpl.nextIter(txt);
        txt = lm_129(txt, rest, a_simCode);
      then txt;
  end match;
end lm_129;

protected function lm_130
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCode.SimCode a_simCode;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_simCode )
      equation
        txt = SwitchAliasVars(txt, a_simCode, i_var, "Integer", "-");
        txt = Tpl.nextIter(txt);
        txt = lm_130(txt, rest, a_simCode);
      then txt;
  end match;
end lm_130;

protected function fun_131
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo, in_a_simCode)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      list<SimCodeVar.SimVar> i_vars_intAliasVars;
      list<SimCodeVar.SimVar> i_vars_intParamVars;
      list<SimCodeVar.SimVar> i_vars_intAlgVars;

    case ( txt,
           SimCode.MODELINFO(vars = SimCodeVar.SIMVARS(intAlgVars = i_vars_intAlgVars, intParamVars = i_vars_intParamVars, intAliasVars = i_vars_intAliasVars)),
           a_simCode )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "fmiInteger getInteger(ModelInstance* comp, const fmiValueReference vr) {\n",
                                    "  switch (vr) {\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_128(txt, i_vars_intAlgVars, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_129(txt, i_vars_intParamVars, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_130(txt, i_vars_intAliasVars, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "default:\n",
                                    "  return 0;\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "  }\n",
                                    "}"
                                }, false));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_131;

public function getIntegerFunction
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input SimCode.ModelInfo a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_131(txt, a_modelInfo, a_simCode);
end getIntegerFunction;

protected function lm_133
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCode.SimCode a_simCode;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_simCode )
      equation
        txt = SwitchVarsSet(txt, a_simCode, i_var, "integerVars");
        txt = Tpl.nextIter(txt);
        txt = lm_133(txt, rest, a_simCode);
      then txt;
  end match;
end lm_133;

protected function lm_134
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCode.SimCode a_simCode;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_simCode )
      equation
        txt = SwitchParametersSet(txt, a_simCode, i_var, "integerParameter");
        txt = Tpl.nextIter(txt);
        txt = lm_134(txt, rest, a_simCode);
      then txt;
  end match;
end lm_134;

protected function lm_135
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCode.SimCode a_simCode;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_simCode )
      equation
        txt = SwitchAliasVarsSet(txt, a_simCode, i_var, "Integer", "-");
        txt = Tpl.nextIter(txt);
        txt = lm_135(txt, rest, a_simCode);
      then txt;
  end match;
end lm_135;

protected function fun_136
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo, in_a_simCode)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      list<SimCodeVar.SimVar> i_vars_intAliasVars;
      list<SimCodeVar.SimVar> i_vars_intParamVars;
      list<SimCodeVar.SimVar> i_vars_intAlgVars;

    case ( txt,
           SimCode.MODELINFO(vars = SimCodeVar.SIMVARS(intAlgVars = i_vars_intAlgVars, intParamVars = i_vars_intParamVars, intAliasVars = i_vars_intAliasVars)),
           a_simCode )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "fmiStatus setInteger(ModelInstance* comp, const fmiValueReference vr, const fmiInteger value) {\n",
                                    "  switch (vr) {\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_133(txt, i_vars_intAlgVars, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_134(txt, i_vars_intParamVars, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_135(txt, i_vars_intAliasVars, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "default:\n",
                                    "  return fmiError;\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "  }\n",
                                    "  return fmiOK;\n",
                                    "}"
                                }, false));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_136;

public function setIntegerFunction
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input SimCode.ModelInfo a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_136(txt, a_modelInfo, a_simCode);
end setIntegerFunction;

protected function lm_138
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCode.SimCode a_simCode;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_simCode )
      equation
        txt = SwitchVars(txt, a_simCode, i_var, "booleanVars");
        txt = Tpl.nextIter(txt);
        txt = lm_138(txt, rest, a_simCode);
      then txt;
  end match;
end lm_138;

protected function lm_139
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCode.SimCode a_simCode;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_simCode )
      equation
        txt = SwitchParameters(txt, a_simCode, i_var, "booleanParameter");
        txt = Tpl.nextIter(txt);
        txt = lm_139(txt, rest, a_simCode);
      then txt;
  end match;
end lm_139;

protected function lm_140
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCode.SimCode a_simCode;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_simCode )
      equation
        txt = SwitchAliasVars(txt, a_simCode, i_var, "Boolean", "!");
        txt = Tpl.nextIter(txt);
        txt = lm_140(txt, rest, a_simCode);
      then txt;
  end match;
end lm_140;

protected function fun_141
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo, in_a_simCode)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      list<SimCodeVar.SimVar> i_vars_boolAliasVars;
      list<SimCodeVar.SimVar> i_vars_boolParamVars;
      list<SimCodeVar.SimVar> i_vars_boolAlgVars;

    case ( txt,
           SimCode.MODELINFO(vars = SimCodeVar.SIMVARS(boolAlgVars = i_vars_boolAlgVars, boolParamVars = i_vars_boolParamVars, boolAliasVars = i_vars_boolAliasVars)),
           a_simCode )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "fmiBoolean getBoolean(ModelInstance* comp, const fmiValueReference vr) {\n",
                                    "  switch (vr) {\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_138(txt, i_vars_boolAlgVars, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_139(txt, i_vars_boolParamVars, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_140(txt, i_vars_boolAliasVars, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "default:\n",
                                    "  return fmiFalse;\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "  }\n",
                                    "}\n",
                                    "\n"
                                }, true));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_141;

public function getBooleanFunction
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input SimCode.ModelInfo a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_141(txt, a_modelInfo, a_simCode);
end getBooleanFunction;

protected function lm_143
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCode.SimCode a_simCode;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_simCode )
      equation
        txt = SwitchVarsSet(txt, a_simCode, i_var, "booleanVars");
        txt = Tpl.nextIter(txt);
        txt = lm_143(txt, rest, a_simCode);
      then txt;
  end match;
end lm_143;

protected function lm_144
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCode.SimCode a_simCode;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_simCode )
      equation
        txt = SwitchParametersSet(txt, a_simCode, i_var, "booleanParameter");
        txt = Tpl.nextIter(txt);
        txt = lm_144(txt, rest, a_simCode);
      then txt;
  end match;
end lm_144;

protected function lm_145
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCode.SimCode a_simCode;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_simCode )
      equation
        txt = SwitchAliasVarsSet(txt, a_simCode, i_var, "Boolean", "!");
        txt = Tpl.nextIter(txt);
        txt = lm_145(txt, rest, a_simCode);
      then txt;
  end match;
end lm_145;

protected function fun_146
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo, in_a_simCode)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      list<SimCodeVar.SimVar> i_vars_boolAliasVars;
      list<SimCodeVar.SimVar> i_vars_boolParamVars;
      list<SimCodeVar.SimVar> i_vars_boolAlgVars;

    case ( txt,
           SimCode.MODELINFO(vars = SimCodeVar.SIMVARS(boolAlgVars = i_vars_boolAlgVars, boolParamVars = i_vars_boolParamVars, boolAliasVars = i_vars_boolAliasVars)),
           a_simCode )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "fmiStatus setBoolean(ModelInstance* comp, const fmiValueReference vr, const fmiBoolean value) {\n",
                                    "  switch (vr) {\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_143(txt, i_vars_boolAlgVars, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_144(txt, i_vars_boolParamVars, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_145(txt, i_vars_boolAliasVars, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "default:\n",
                                    "  return fmiError;\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "  }\n",
                                    "  return fmiOK;\n",
                                    "}\n",
                                    "\n"
                                }, true));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_146;

public function setBooleanFunction
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input SimCode.ModelInfo a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_146(txt, a_modelInfo, a_simCode);
end setBooleanFunction;

protected function lm_148
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCode.SimCode a_simCode;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_simCode )
      equation
        txt = SwitchVars(txt, a_simCode, i_var, "stringVars");
        txt = Tpl.nextIter(txt);
        txt = lm_148(txt, rest, a_simCode);
      then txt;
  end match;
end lm_148;

protected function lm_149
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCode.SimCode a_simCode;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_simCode )
      equation
        txt = SwitchParameters(txt, a_simCode, i_var, "stringParameter");
        txt = Tpl.nextIter(txt);
        txt = lm_149(txt, rest, a_simCode);
      then txt;
  end match;
end lm_149;

protected function lm_150
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCode.SimCode a_simCode;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_simCode )
      equation
        txt = SwitchAliasVars(txt, a_simCode, i_var, "String", "");
        txt = Tpl.nextIter(txt);
        txt = lm_150(txt, rest, a_simCode);
      then txt;
  end match;
end lm_150;

protected function fun_151
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo, in_a_simCode)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      list<SimCodeVar.SimVar> i_vars_stringAliasVars;
      list<SimCodeVar.SimVar> i_vars_stringParamVars;
      list<SimCodeVar.SimVar> i_vars_stringAlgVars;

    case ( txt,
           SimCode.MODELINFO(vars = SimCodeVar.SIMVARS(stringAlgVars = i_vars_stringAlgVars, stringParamVars = i_vars_stringParamVars, stringAliasVars = i_vars_stringAliasVars)),
           a_simCode )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "fmiString getString(ModelInstance* comp, const fmiValueReference vr) {\n",
                                    "  switch (vr) {\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_148(txt, i_vars_stringAlgVars, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_149(txt, i_vars_stringParamVars, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_150(txt, i_vars_stringAliasVars, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "default:\n",
                                    "  return \"\";\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "  }\n",
                                    "}\n",
                                    "\n"
                                }, true));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_151;

public function getStringFunction
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input SimCode.ModelInfo a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_151(txt, a_modelInfo, a_simCode);
end getStringFunction;

protected function lm_153
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCode.SimCode a_simCode;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_simCode )
      equation
        txt = SwitchVarsSet(txt, a_simCode, i_var, "stringVars");
        txt = Tpl.nextIter(txt);
        txt = lm_153(txt, rest, a_simCode);
      then txt;
  end match;
end lm_153;

protected function lm_154
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCode.SimCode a_simCode;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_simCode )
      equation
        txt = SwitchParametersSet(txt, a_simCode, i_var, "stringParameter");
        txt = Tpl.nextIter(txt);
        txt = lm_154(txt, rest, a_simCode);
      then txt;
  end match;
end lm_154;

protected function lm_155
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCode.SimCode a_simCode;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_simCode )
      equation
        txt = SwitchAliasVarsSet(txt, a_simCode, i_var, "String", "");
        txt = Tpl.nextIter(txt);
        txt = lm_155(txt, rest, a_simCode);
      then txt;
  end match;
end lm_155;

protected function fun_156
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo, in_a_simCode)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      list<SimCodeVar.SimVar> i_vars_stringAliasVars;
      list<SimCodeVar.SimVar> i_vars_stringParamVars;
      list<SimCodeVar.SimVar> i_vars_stringAlgVars;

    case ( txt,
           SimCode.MODELINFO(vars = SimCodeVar.SIMVARS(stringAlgVars = i_vars_stringAlgVars, stringParamVars = i_vars_stringParamVars, stringAliasVars = i_vars_stringAliasVars)),
           a_simCode )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "fmiStatus setString(ModelInstance* comp, const fmiValueReference vr, fmiString value) {\n",
                                    "  switch (vr) {\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_153(txt, i_vars_stringAlgVars, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_154(txt, i_vars_stringParamVars, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_155(txt, i_vars_stringAliasVars, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "default:\n",
                                    "  return fmiError;\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "  }\n",
                                    "  return fmiOK;\n",
                                    "}\n",
                                    "\n"
                                }, true));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_156;

public function setStringFunction
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input SimCode.ModelInfo a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_156(txt, a_modelInfo, a_simCode);
end setStringFunction;

public function setExternalFunction
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Function> i_functions;
      Tpl.Text l_externalFuncs;

    case ( txt,
           SimCode.MODELINFO(vars = SimCodeVar.SIMVARS(stateVars = _), functions = i_functions) )
      equation
        l_externalFuncs = setExternalFunctionsSwitch(Tpl.emptyTxt, i_functions);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "fmiStatus setExternalFunction(ModelInstance* c, const fmiValueReference vr, const void* value){\n",
                                    "  switch (vr) {\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.writeText(txt, l_externalFuncs);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "default:\n",
                                    "  return fmiError;\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "  }\n",
                                    "  return fmiOK;\n",
                                    "}\n",
                                    "\n"
                                }, true));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end setExternalFunction;

public function eventUpdateFunction2
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;

    case ( txt,
           SimCode.SIMCODE(modelInfo = _) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "// Used to set the next time event, if any.\n",
                                    "void eventUpdate(ModelInstance* comp, fmi2EventInfo* eventInfo) {\n",
                                    "}\n",
                                    "\n"
                                }, true));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end eventUpdateFunction2;

protected function lm_160
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCode.SimCode a_simCode;
      SimCodeVar.AliasVariable i_aliasvar;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(aliasvar = i_aliasvar) :: rest,
           a_simCode )
      equation
        txt = aliasSetVR(txt, a_simCode, i_aliasvar);
        txt = Tpl.nextIter(txt);
        txt = lm_160(txt, rest, a_simCode);
      then txt;

    case ( txt,
           _ :: rest,
           a_simCode )
      equation
        txt = lm_160(txt, rest, a_simCode);
      then txt;
  end match;
end lm_160;

protected function fun_161
  input Tpl.Text in_txt;
  input Integer in_a_numAlgAliasVars;
  input SimCode.SimCode in_a_simCode;
  input list<SimCodeVar.SimVar> in_a_vars_aliasVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_numAlgAliasVars, in_a_simCode, in_a_vars_aliasVars)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      list<SimCodeVar.SimVar> a_vars_aliasVars;
      Integer i_numAlgAliasVars;

    case ( txt,
           0,
           _,
           _ )
      then txt;

    case ( txt,
           i_numAlgAliasVars,
           a_simCode,
           a_vars_aliasVars )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("static const int realAliasIndexes["));
        txt = Tpl.writeStr(txt, intString(i_numAlgAliasVars));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("] = {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 20, 0, Tpl.ST_LINE(",\n"), 0, Tpl.ST_NEW_LINE()));
        txt = lm_160(txt, a_vars_aliasVars, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "};\n",
                                    "\n"
                                }, true));
      then txt;
  end match;
end fun_161;

protected function fun_162
  input Tpl.Text in_txt;
  input Integer in_a_numAlgAliasVars;
  input Tpl.Text in_a_ixFirstAlias;
  input Tpl.Text in_a_ixEnd;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_numAlgAliasVars, in_a_ixFirstAlias, in_a_ixEnd)
    local
      Tpl.Text txt;
      Tpl.Text a_ixFirstAlias;
      Tpl.Text a_ixEnd;

    case ( txt,
           0,
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_ixFirstAlias,
           a_ixEnd )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if (vr < "));
        txt = Tpl.writeText(txt, a_ixEnd);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(") {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("int ix = realAliasIndexes[vr-"));
        txt = Tpl.writeText(txt, a_ixFirstAlias);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "];\n",
                                    "return ix>=0 ? getReal(comp, ix) : -getReal(comp, -(ix+1));\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;
  end match;
end fun_162;

protected function fun_163
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo, in_a_simCode)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      list<SimCodeVar.SimVar> i_vars_aliasVars;
      Integer i_numAlgAliasVars;
      Integer i_numParams;
      Integer i_numDiscreteReal;
      Integer i_numAlgVars;
      Integer i_numStateVars;
      Integer ret_14;
      Integer ret_13;
      Integer ret_12;
      Integer ret_11;
      Integer ret_10;
      Tpl.Text l_ixEnd;
      Integer ret_8;
      Integer ret_7;
      Integer ret_6;
      Integer ret_5;
      Tpl.Text l_ixFirstAlias;
      Integer ret_3;
      Integer ret_2;
      Integer ret_1;
      Tpl.Text l_ixFirstParam;

    case ( txt,
           SimCode.MODELINFO(vars = SimCodeVar.SIMVARS(aliasVars = i_vars_aliasVars), varInfo = SimCode.VARINFO(numAlgAliasVars = i_numAlgAliasVars, numParams = i_numParams, numStateVars = i_numStateVars, numAlgVars = i_numAlgVars, numDiscreteReal = i_numDiscreteReal)),
           a_simCode )
      equation
        ret_1 = intMul(2, i_numStateVars);
        ret_2 = intAdd(i_numAlgVars, i_numDiscreteReal);
        ret_3 = intAdd(ret_1, ret_2);
        l_ixFirstParam = Tpl.writeStr(Tpl.emptyTxt, intString(ret_3));
        ret_5 = intMul(2, i_numStateVars);
        ret_6 = intAdd(i_numAlgVars, i_numDiscreteReal);
        ret_7 = intAdd(ret_5, ret_6);
        ret_8 = intAdd(i_numParams, ret_7);
        l_ixFirstAlias = Tpl.writeStr(Tpl.emptyTxt, intString(ret_8));
        ret_10 = intMul(2, i_numStateVars);
        ret_11 = intAdd(i_numAlgVars, i_numDiscreteReal);
        ret_12 = intAdd(ret_10, ret_11);
        ret_13 = intAdd(i_numParams, ret_12);
        ret_14 = intAdd(i_numAlgAliasVars, ret_13);
        l_ixEnd = Tpl.writeStr(Tpl.emptyTxt, intString(ret_14));
        txt = fun_161(txt, i_numAlgAliasVars, a_simCode, i_vars_aliasVars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("fmi2Real getReal(ModelInstance* comp, const fmi2ValueReference vr) {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if (vr < "));
        txt = Tpl.writeText(txt, l_ixFirstParam);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ") {\n",
                                    "  return comp->fmuData->localData[0]->realVars[vr];\n",
                                    "}\n",
                                    "if (vr < "
                                }, false));
        txt = Tpl.writeText(txt, l_ixFirstAlias);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(") {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("return comp->fmuData->simulationInfo->realParameter[vr-"));
        txt = Tpl.writeText(txt, l_ixFirstParam);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("];\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("}\n"));
        txt = fun_162(txt, i_numAlgAliasVars, l_ixFirstAlias, l_ixEnd);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("return NAN;\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n"
                                }, true));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_163;

public function getRealFunction2
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input SimCode.ModelInfo a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_163(txt, a_modelInfo, a_simCode);
end getRealFunction2;

protected function fun_165
  input Tpl.Text in_txt;
  input Integer in_a_numAlgAliasVars;
  input Tpl.Text in_a_ixFirstAlias;
  input Tpl.Text in_a_ixEnd;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_numAlgAliasVars, in_a_ixFirstAlias, in_a_ixEnd)
    local
      Tpl.Text txt;
      Tpl.Text a_ixFirstAlias;
      Tpl.Text a_ixEnd;

    case ( txt,
           0,
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_ixFirstAlias,
           a_ixEnd )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if (vr < "));
        txt = Tpl.writeText(txt, a_ixEnd);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(") {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("int ix = realAliasIndexes[vr-"));
        txt = Tpl.writeText(txt, a_ixFirstAlias);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "];\n",
                                    "return ix >= 0 ? setReal(comp, ix, value) : setReal(comp, -(ix+1), -value);\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;
  end match;
end fun_165;

protected function fun_166
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo)
    local
      Tpl.Text txt;
      Integer i_numAlgAliasVars;
      Integer i_numParams;
      Integer i_numDiscreteReal;
      Integer i_numAlgVars;
      Integer i_numStateVars;
      Integer ret_14;
      Integer ret_13;
      Integer ret_12;
      Integer ret_11;
      Integer ret_10;
      Tpl.Text l_ixEnd;
      Integer ret_8;
      Integer ret_7;
      Integer ret_6;
      Integer ret_5;
      Tpl.Text l_ixFirstAlias;
      Integer ret_3;
      Integer ret_2;
      Integer ret_1;
      Tpl.Text l_ixFirstParam;

    case ( txt,
           SimCode.MODELINFO(vars = SimCodeVar.SIMVARS(stateVars = _), varInfo = SimCode.VARINFO(numAlgAliasVars = i_numAlgAliasVars, numParams = i_numParams, numStateVars = i_numStateVars, numAlgVars = i_numAlgVars, numDiscreteReal = i_numDiscreteReal)) )
      equation
        ret_1 = intMul(2, i_numStateVars);
        ret_2 = intAdd(i_numAlgVars, i_numDiscreteReal);
        ret_3 = intAdd(ret_1, ret_2);
        l_ixFirstParam = Tpl.writeStr(Tpl.emptyTxt, intString(ret_3));
        ret_5 = intMul(2, i_numStateVars);
        ret_6 = intAdd(i_numAlgVars, i_numDiscreteReal);
        ret_7 = intAdd(ret_5, ret_6);
        ret_8 = intAdd(i_numParams, ret_7);
        l_ixFirstAlias = Tpl.writeStr(Tpl.emptyTxt, intString(ret_8));
        ret_10 = intMul(2, i_numStateVars);
        ret_11 = intAdd(i_numAlgVars, i_numDiscreteReal);
        ret_12 = intAdd(ret_10, ret_11);
        ret_13 = intAdd(i_numParams, ret_12);
        ret_14 = intAdd(i_numAlgAliasVars, ret_13);
        l_ixEnd = Tpl.writeStr(Tpl.emptyTxt, intString(ret_14));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("fmi2Status setReal(ModelInstance* comp, const fmi2ValueReference vr, const fmi2Real value) {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if (vr < "));
        txt = Tpl.writeText(txt, l_ixFirstParam);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ") {\n",
                                    "  comp->fmuData->localData[0]->realVars[vr] = value;\n",
                                    "  return fmi2OK;\n",
                                    "}\n",
                                    "if (vr < "
                                }, false));
        txt = Tpl.writeText(txt, l_ixFirstAlias);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(") {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("comp->fmuData->simulationInfo->realParameter[vr-"));
        txt = Tpl.writeText(txt, l_ixFirstParam);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "] = value;\n",
                                    "return fmi2OK;\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("}\n"));
        txt = fun_165(txt, i_numAlgAliasVars, l_ixFirstAlias, l_ixEnd);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("return fmi2Error;\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n"
                                }, true));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_166;

public function setRealFunction2
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input SimCode.ModelInfo a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_166(txt, a_modelInfo);
end setRealFunction2;

protected function fun_168
  input Tpl.Text in_txt;
  input SimCodeVar.AliasVariable in_a_v;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_v, in_a_simCode)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      DAE.ComponentRef i_varName;
      Integer ret_2;
      Integer ret_1;
      Integer ret_0;

    case ( txt,
           SimCodeVar.NOALIAS(),
           _ )
      equation
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenFMU.tpl", 814, 31), "aliasSetVR expected an alias");
      then txt;

    case ( txt,
           SimCodeVar.ALIAS(varName = i_varName),
           a_simCode )
      equation
        ret_0 = SimCodeUtil.lookupVR(i_varName, a_simCode);
        txt = Tpl.writeStr(txt, intString(ret_0));
      then txt;

    case ( txt,
           SimCodeVar.NEGATEDALIAS(varName = i_varName),
           a_simCode )
      equation
        ret_1 = SimCodeUtil.lookupVR(i_varName, a_simCode);
        ret_2 = intSub(-1, ret_1);
        txt = Tpl.writeStr(txt, intString(ret_2));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_168;

public function aliasSetVR
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input SimCodeVar.AliasVariable a_v;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_168(txt, a_v, a_simCode);
end aliasSetVR;

protected function lm_170
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCode.SimCode a_simCode;
      SimCodeVar.AliasVariable i_aliasvar;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           SimCodeVar.SIMVAR(aliasvar = i_aliasvar) :: rest,
           a_simCode )
      equation
        txt = aliasSetVR(txt, a_simCode, i_aliasvar);
        txt = Tpl.nextIter(txt);
        txt = lm_170(txt, rest, a_simCode);
      then txt;

    case ( txt,
           _ :: rest,
           a_simCode )
      equation
        txt = lm_170(txt, rest, a_simCode);
      then txt;
  end match;
end lm_170;

protected function fun_171
  input Tpl.Text in_txt;
  input Integer in_a_numAliasVars;
  input SimCode.SimCode in_a_simCode;
  input list<SimCodeVar.SimVar> in_a_vars_intAliasVars;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_numAliasVars, in_a_simCode, in_a_vars_intAliasVars)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      list<SimCodeVar.SimVar> a_vars_intAliasVars;
      Integer i_numAliasVars;

    case ( txt,
           0,
           _,
           _ )
      then txt;

    case ( txt,
           i_numAliasVars,
           a_simCode,
           a_vars_intAliasVars )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("static const int intAliasIndexes["));
        txt = Tpl.writeStr(txt, intString(i_numAliasVars));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("] = {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 20, 0, Tpl.ST_LINE(",\n"), 0, Tpl.ST_NEW_LINE()));
        txt = lm_170(txt, a_vars_intAliasVars, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "};\n",
                                    "\n"
                                }, true));
      then txt;
  end match;
end fun_171;

protected function fun_172
  input Tpl.Text in_txt;
  input Integer in_a_numAliasVars;
  input Tpl.Text in_a_ixFirstAlias;
  input Tpl.Text in_a_ixEnd;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_numAliasVars, in_a_ixFirstAlias, in_a_ixEnd)
    local
      Tpl.Text txt;
      Tpl.Text a_ixFirstAlias;
      Tpl.Text a_ixEnd;

    case ( txt,
           0,
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_ixFirstAlias,
           a_ixEnd )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if (vr < "));
        txt = Tpl.writeText(txt, a_ixEnd);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(") {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("int ix = intAliasIndexes[vr-"));
        txt = Tpl.writeText(txt, a_ixFirstAlias);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "];\n",
                                    "return ix>=0 ? getInteger(comp, ix) : -getInteger(comp, -(ix+1));\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;
  end match;
end fun_172;

protected function fun_173
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo, in_a_simCode)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      list<SimCodeVar.SimVar> i_vars_intAliasVars;
      Integer i_numAliasVars;
      Integer i_numParams;
      Integer i_numAlgVars;
      Integer ret_5;
      Integer ret_4;
      Tpl.Text l_ixEnd;
      Integer ret_2;
      Tpl.Text l_ixFirstAlias;
      Tpl.Text l_ixFirstParam;

    case ( txt,
           SimCode.MODELINFO(vars = SimCodeVar.SIMVARS(intAliasVars = i_vars_intAliasVars), varInfo = SimCode.VARINFO(numIntAliasVars = i_numAliasVars, numIntParams = i_numParams, numIntAlgVars = i_numAlgVars)),
           a_simCode )
      equation
        l_ixFirstParam = Tpl.writeStr(Tpl.emptyTxt, intString(i_numAlgVars));
        ret_2 = intAdd(i_numParams, i_numAlgVars);
        l_ixFirstAlias = Tpl.writeStr(Tpl.emptyTxt, intString(ret_2));
        ret_4 = intAdd(i_numParams, i_numAlgVars);
        ret_5 = intAdd(i_numAliasVars, ret_4);
        l_ixEnd = Tpl.writeStr(Tpl.emptyTxt, intString(ret_5));
        txt = fun_171(txt, i_numAliasVars, a_simCode, i_vars_intAliasVars);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("fmi2Integer getInteger(ModelInstance* comp, const fmi2ValueReference vr) {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if (vr < "));
        txt = Tpl.writeText(txt, l_ixFirstParam);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ") {\n",
                                    "  return comp->fmuData->localData[0]->integerVars[vr];\n",
                                    "}\n",
                                    "if (vr < "
                                }, false));
        txt = Tpl.writeText(txt, l_ixFirstAlias);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(") {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("return comp->fmuData->simulationInfo->integerParameter[vr-"));
        txt = Tpl.writeText(txt, l_ixFirstParam);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("];\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("}\n"));
        txt = fun_172(txt, i_numAliasVars, l_ixFirstAlias, l_ixEnd);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("return 0;\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "}\n",
                                    "\n"
                                }, true));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_173;

public function getIntegerFunction2
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input SimCode.ModelInfo a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_173(txt, a_modelInfo, a_simCode);
end getIntegerFunction2;

protected function fun_175
  input Tpl.Text in_txt;
  input Integer in_a_numAliasVars;
  input Tpl.Text in_a_ixFirstAlias;
  input Tpl.Text in_a_ixEnd;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_numAliasVars, in_a_ixFirstAlias, in_a_ixEnd)
    local
      Tpl.Text txt;
      Tpl.Text a_ixFirstAlias;
      Tpl.Text a_ixEnd;

    case ( txt,
           0,
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_ixFirstAlias,
           a_ixEnd )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if (vr < "));
        txt = Tpl.writeText(txt, a_ixEnd);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(") {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("int ix = intAliasIndexes[vr-"));
        txt = Tpl.writeText(txt, a_ixFirstAlias);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "];\n",
                                    "return ix >= 0 ? setInteger(comp, ix, value) : setInteger(comp, -(ix+1), -value);\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;
  end match;
end fun_175;

protected function fun_176
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo)
    local
      Tpl.Text txt;
      Integer i_numAliasVars;
      Integer i_numParams;
      Integer i_numAlgVars;
      Integer ret_5;
      Integer ret_4;
      Tpl.Text l_ixEnd;
      Integer ret_2;
      Tpl.Text l_ixFirstAlias;
      Tpl.Text l_ixFirstParam;

    case ( txt,
           SimCode.MODELINFO(vars = SimCodeVar.SIMVARS(stateVars = _), varInfo = SimCode.VARINFO(numIntAliasVars = i_numAliasVars, numIntParams = i_numParams, numIntAlgVars = i_numAlgVars)) )
      equation
        l_ixFirstParam = Tpl.writeStr(Tpl.emptyTxt, intString(i_numAlgVars));
        ret_2 = intAdd(i_numParams, i_numAlgVars);
        l_ixFirstAlias = Tpl.writeStr(Tpl.emptyTxt, intString(ret_2));
        ret_4 = intAdd(i_numParams, i_numAlgVars);
        ret_5 = intAdd(i_numAliasVars, ret_4);
        l_ixEnd = Tpl.writeStr(Tpl.emptyTxt, intString(ret_5));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("fmi2Status setInteger(ModelInstance* comp, const fmi2ValueReference vr, const fmi2Integer value) {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if (vr < "));
        txt = Tpl.writeText(txt, l_ixFirstParam);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ") {\n",
                                    "  comp->fmuData->localData[0]->integerVars[vr] = value;\n",
                                    "  return fmi2OK;\n",
                                    "}\n",
                                    "if (vr < "
                                }, false));
        txt = Tpl.writeText(txt, l_ixFirstAlias);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(") {\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("comp->fmuData->simulationInfo->integerParameter[vr-"));
        txt = Tpl.writeText(txt, l_ixFirstParam);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "] = value;\n",
                                    "return fmi2OK;\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("}\n"));
        txt = fun_175(txt, i_numAliasVars, l_ixFirstAlias, l_ixEnd);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("return fmi2Error;\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_176;

public function setIntegerFunction2
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input SimCode.ModelInfo a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_176(txt, a_modelInfo);
end setIntegerFunction2;

protected function lm_178
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCode.SimCode a_simCode;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_simCode )
      equation
        txt = SwitchVars(txt, a_simCode, i_var, "booleanVars");
        txt = Tpl.nextIter(txt);
        txt = lm_178(txt, rest, a_simCode);
      then txt;
  end match;
end lm_178;

protected function lm_179
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCode.SimCode a_simCode;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_simCode )
      equation
        txt = SwitchParameters(txt, a_simCode, i_var, "booleanParameter");
        txt = Tpl.nextIter(txt);
        txt = lm_179(txt, rest, a_simCode);
      then txt;
  end match;
end lm_179;

protected function lm_180
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCode.SimCode a_simCode;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_simCode )
      equation
        txt = SwitchAliasVars(txt, a_simCode, i_var, "Boolean", "!");
        txt = Tpl.nextIter(txt);
        txt = lm_180(txt, rest, a_simCode);
      then txt;
  end match;
end lm_180;

protected function fun_181
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo, in_a_simCode)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      list<SimCodeVar.SimVar> i_vars_boolAliasVars;
      list<SimCodeVar.SimVar> i_vars_boolParamVars;
      list<SimCodeVar.SimVar> i_vars_boolAlgVars;

    case ( txt,
           SimCode.MODELINFO(vars = SimCodeVar.SIMVARS(boolAlgVars = i_vars_boolAlgVars, boolParamVars = i_vars_boolParamVars, boolAliasVars = i_vars_boolAliasVars)),
           a_simCode )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "fmi2Boolean getBoolean(ModelInstance* comp, const fmi2ValueReference vr) {\n",
                                    "  switch (vr) {\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_178(txt, i_vars_boolAlgVars, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_179(txt, i_vars_boolParamVars, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_180(txt, i_vars_boolAliasVars, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "default:\n",
                                    "  return fmi2False;\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "  }\n",
                                    "}\n",
                                    "\n"
                                }, true));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_181;

public function getBooleanFunction2
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input SimCode.ModelInfo a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_181(txt, a_modelInfo, a_simCode);
end getBooleanFunction2;

protected function lm_183
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCode.SimCode a_simCode;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_simCode )
      equation
        txt = SwitchVarsSet(txt, a_simCode, i_var, "booleanVars");
        txt = Tpl.nextIter(txt);
        txt = lm_183(txt, rest, a_simCode);
      then txt;
  end match;
end lm_183;

protected function lm_184
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCode.SimCode a_simCode;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_simCode )
      equation
        txt = SwitchParametersSet(txt, a_simCode, i_var, "booleanParameter");
        txt = Tpl.nextIter(txt);
        txt = lm_184(txt, rest, a_simCode);
      then txt;
  end match;
end lm_184;

protected function lm_185
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCode.SimCode a_simCode;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_simCode )
      equation
        txt = SwitchAliasVarsSet(txt, a_simCode, i_var, "Boolean", "!");
        txt = Tpl.nextIter(txt);
        txt = lm_185(txt, rest, a_simCode);
      then txt;
  end match;
end lm_185;

protected function fun_186
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo, in_a_simCode)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      list<SimCodeVar.SimVar> i_vars_boolAliasVars;
      list<SimCodeVar.SimVar> i_vars_boolParamVars;
      list<SimCodeVar.SimVar> i_vars_boolAlgVars;

    case ( txt,
           SimCode.MODELINFO(vars = SimCodeVar.SIMVARS(boolAlgVars = i_vars_boolAlgVars, boolParamVars = i_vars_boolParamVars, boolAliasVars = i_vars_boolAliasVars)),
           a_simCode )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "fmi2Status setBoolean(ModelInstance* comp, const fmi2ValueReference vr, const fmi2Boolean value) {\n",
                                    "  switch (vr) {\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_183(txt, i_vars_boolAlgVars, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_184(txt, i_vars_boolParamVars, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_185(txt, i_vars_boolAliasVars, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "default:\n",
                                    "  return fmi2Error;\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "  }\n",
                                    "  return fmi2OK;\n",
                                    "}\n",
                                    "\n"
                                }, true));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_186;

public function setBooleanFunction2
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input SimCode.ModelInfo a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_186(txt, a_modelInfo, a_simCode);
end setBooleanFunction2;

protected function lm_188
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCode.SimCode a_simCode;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_simCode )
      equation
        txt = SwitchVars(txt, a_simCode, i_var, "stringVars");
        txt = Tpl.nextIter(txt);
        txt = lm_188(txt, rest, a_simCode);
      then txt;
  end match;
end lm_188;

protected function lm_189
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCode.SimCode a_simCode;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_simCode )
      equation
        txt = SwitchParameters(txt, a_simCode, i_var, "stringParameter");
        txt = Tpl.nextIter(txt);
        txt = lm_189(txt, rest, a_simCode);
      then txt;
  end match;
end lm_189;

protected function lm_190
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCode.SimCode a_simCode;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_simCode )
      equation
        txt = SwitchAliasVars(txt, a_simCode, i_var, "String", "");
        txt = Tpl.nextIter(txt);
        txt = lm_190(txt, rest, a_simCode);
      then txt;
  end match;
end lm_190;

protected function fun_191
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo, in_a_simCode)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      list<SimCodeVar.SimVar> i_vars_stringAliasVars;
      list<SimCodeVar.SimVar> i_vars_stringParamVars;
      list<SimCodeVar.SimVar> i_vars_stringAlgVars;

    case ( txt,
           SimCode.MODELINFO(vars = SimCodeVar.SIMVARS(stringAlgVars = i_vars_stringAlgVars, stringParamVars = i_vars_stringParamVars, stringAliasVars = i_vars_stringAliasVars)),
           a_simCode )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "fmi2String getString(ModelInstance* comp, const fmi2ValueReference vr) {\n",
                                    "  switch (vr) {\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_188(txt, i_vars_stringAlgVars, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_189(txt, i_vars_stringParamVars, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_190(txt, i_vars_stringAliasVars, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "default:\n",
                                    "  return \"\";\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "  }\n",
                                    "}\n",
                                    "\n"
                                }, true));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_191;

public function getStringFunction2
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input SimCode.ModelInfo a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_191(txt, a_modelInfo, a_simCode);
end getStringFunction2;

protected function lm_193
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCode.SimCode a_simCode;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_simCode )
      equation
        txt = SwitchVarsSet(txt, a_simCode, i_var, "stringVars");
        txt = Tpl.nextIter(txt);
        txt = lm_193(txt, rest, a_simCode);
      then txt;
  end match;
end lm_193;

protected function lm_194
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCode.SimCode a_simCode;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_simCode )
      equation
        txt = SwitchParametersSet(txt, a_simCode, i_var, "stringParameter");
        txt = Tpl.nextIter(txt);
        txt = lm_194(txt, rest, a_simCode);
      then txt;
  end match;
end lm_194;

protected function lm_195
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCode.SimCode a_simCode;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_simCode )
      equation
        txt = SwitchAliasVarsSet(txt, a_simCode, i_var, "String", "");
        txt = Tpl.nextIter(txt);
        txt = lm_195(txt, rest, a_simCode);
      then txt;
  end match;
end lm_195;

protected function fun_196
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo, in_a_simCode)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      list<SimCodeVar.SimVar> i_vars_stringAliasVars;
      list<SimCodeVar.SimVar> i_vars_stringParamVars;
      list<SimCodeVar.SimVar> i_vars_stringAlgVars;

    case ( txt,
           SimCode.MODELINFO(vars = SimCodeVar.SIMVARS(stringAlgVars = i_vars_stringAlgVars, stringParamVars = i_vars_stringParamVars, stringAliasVars = i_vars_stringAliasVars)),
           a_simCode )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "fmi2Status setString(ModelInstance* comp, const fmi2ValueReference vr, fmi2String value) {\n",
                                    "  switch (vr) {\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_193(txt, i_vars_stringAlgVars, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_194(txt, i_vars_stringParamVars, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_195(txt, i_vars_stringAliasVars, a_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "default:\n",
                                    "  return fmi2Error;\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "  }\n",
                                    "  return fmi2OK;\n",
                                    "}\n",
                                    "\n"
                                }, true));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_196;

public function setStringFunction2
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input SimCode.ModelInfo a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_196(txt, a_modelInfo, a_simCode);
end setStringFunction2;

public function setExternalFunction2
  input Tpl.Text in_txt;
  input SimCode.ModelInfo in_a_modelInfo;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Function> i_functions;
      Tpl.Text l_externalFuncs;

    case ( txt,
           SimCode.MODELINFO(vars = SimCodeVar.SIMVARS(stateVars = _), functions = i_functions) )
      equation
        l_externalFuncs = setExternalFunctionsSwitch(Tpl.emptyTxt, i_functions);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "fmi2Status setExternalFunction(ModelInstance* c, const fmi2ValueReference vr, const void* value){\n",
                                    "  switch (vr) {\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.writeText(txt, l_externalFuncs);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "default:\n",
                                    "  return fmi2Error;\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "  }\n",
                                    "  return fmi2OK;\n",
                                    "}\n",
                                    "\n"
                                }, true));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end setExternalFunction2;

protected function lm_199
  input Tpl.Text in_txt;
  input list<SimCodeFunction.Function> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeFunction.Function> rest;
      SimCodeFunction.Function i_fn;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_fn :: rest )
      equation
        txt = setExternalFunctionSwitch(txt, i_fn);
        txt = Tpl.nextIter(txt);
        txt = lm_199(txt, rest);
      then txt;
  end match;
end lm_199;

public function setExternalFunctionsSwitch
  input Tpl.Text txt;
  input list<SimCodeFunction.Function> a_functions;

  output Tpl.Text out_txt;
algorithm
  out_txt := Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_199(out_txt, a_functions);
  out_txt := Tpl.popIter(out_txt);
end setExternalFunctionsSwitch;

public function setExternalFunctionSwitch
  input Tpl.Text in_txt;
  input SimCodeFunction.Function in_a_fn;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fn)
    local
      Tpl.Text txt;
      String i_language;
      String i_extName;
      Tpl.Text l_fname;

    case ( txt,
           SimCodeFunction.EXTERNAL_FUNCTION(dynamicLoad = true, extName = i_extName, language = i_language) )
      equation
        l_fname = CodegenCFunctions.extFunctionName(Tpl.emptyTxt, i_extName, i_language);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("case $P"));
        txt = Tpl.writeText(txt, l_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" : ptr_"));
        txt = Tpl.writeText(txt, l_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("=(ptrT_"));
        txt = Tpl.writeText(txt, l_fname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")value; break;"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end setExternalFunctionSwitch;

protected function fun_202
  input Tpl.Text in_txt;
  input String in_a_comment;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_comment)
    local
      Tpl.Text txt;
      String i_comment;

    case ( txt,
           "" )
      then txt;

    case ( txt,
           i_comment )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("// \""));
        txt = Tpl.writeStr(txt, i_comment);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
      then txt;
  end match;
end fun_202;

protected function fun_203
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_index;
  input String in_a_arrayName;
  input SimCode.SimCode in_a_simCode;
  input DAE.ComponentRef in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_index, in_a_arrayName, in_a_simCode, in_a_name)
    local
      Tpl.Text txt;
      Integer a_index;
      String a_arrayName;
      SimCode.SimCode a_simCode;
      DAE.ComponentRef a_name;
      Integer ret_1;
      Integer ret_0;

    case ( txt,
           false,
           a_index,
           a_arrayName,
           a_simCode,
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("case "));
        ret_0 = SimCodeUtil.lookupVR(a_name, a_simCode);
        txt = Tpl.writeStr(txt, intString(ret_0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" : return comp->fmuData->localData[0]->"));
        txt = Tpl.writeStr(txt, a_arrayName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("["));
        txt = Tpl.writeStr(txt, intString(a_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("]; break;"));
      then txt;

    case ( txt,
           _,
           a_index,
           a_arrayName,
           a_simCode,
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("case "));
        ret_1 = SimCodeUtil.lookupVR(a_name, a_simCode);
        txt = Tpl.writeStr(txt, intString(ret_1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" : return MMC_STRINGDATA(comp->fmuData->localData[0]->"));
        txt = Tpl.writeStr(txt, a_arrayName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("["));
        txt = Tpl.writeStr(txt, intString(a_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("]); break;"));
      then txt;
  end match;
end fun_203;

protected function fun_204
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_index;
  input SimCode.SimCode in_a_simCode;
  input DAE.ComponentRef in_a_name;
  input String in_a_arrayName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_index, in_a_simCode, in_a_name, in_a_arrayName)
    local
      Tpl.Text txt;
      Integer a_index;
      SimCode.SimCode a_simCode;
      DAE.ComponentRef a_name;
      String a_arrayName;
      Boolean ret_0;

    case ( txt,
           false,
           a_index,
           a_simCode,
           a_name,
           a_arrayName )
      equation
        ret_0 = stringEq(a_arrayName, "stringVars");
        txt = fun_203(txt, ret_0, a_index, a_arrayName, a_simCode, a_name);
      then txt;

    case ( txt,
           _,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_204;

protected function fun_205
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_index;
  input SimCode.SimCode in_a_simCode;
  input String in_a_arrayName;
  input DAE.ComponentRef in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_index, in_a_simCode, in_a_arrayName, in_a_name)
    local
      Tpl.Text txt;
      Integer a_index;
      SimCode.SimCode a_simCode;
      String a_arrayName;
      DAE.ComponentRef a_name;
      Boolean ret_1;
      Tpl.Text txt_0;

    case ( txt,
           false,
           a_index,
           a_simCode,
           a_arrayName,
           a_name )
      equation
        txt_0 = CodegenUtil.crefStr(Tpl.emptyTxt, a_name);
        ret_1 = stringEq(Tpl.textString(txt_0), "der($dummy)");
        txt = fun_204(txt, ret_1, a_index, a_simCode, a_name, a_arrayName);
      then txt;

    case ( txt,
           _,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_205;

protected function fun_206
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_a_simVar;
  input SimCode.SimCode in_a_simCode;
  input String in_a_arrayName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simVar, in_a_simCode, in_a_arrayName)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      String a_arrayName;
      Integer i_index;
      DAE.ComponentRef i_name;
      String i_comment;
      Boolean ret_2;
      Tpl.Text txt_1;
      Tpl.Text l_description;

    case ( txt,
           SimCodeVar.SIMVAR(comment = i_comment, name = i_name, index = i_index),
           a_simCode,
           a_arrayName )
      equation
        l_description = fun_202(Tpl.emptyTxt, i_comment);
        txt_1 = CodegenUtil.crefStr(Tpl.emptyTxt, i_name);
        ret_2 = stringEq(Tpl.textString(txt_1), "$dummy");
        txt = fun_205(txt, ret_2, i_index, a_simCode, a_arrayName, i_name);
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_206;

public function SwitchVars
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input SimCodeVar.SimVar a_simVar;
  input String a_arrayName;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_206(txt, a_simVar, a_simCode, a_arrayName);
end SwitchVars;

protected function fun_208
  input Tpl.Text in_txt;
  input String in_a_comment;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_comment)
    local
      Tpl.Text txt;
      String i_comment;

    case ( txt,
           "" )
      then txt;

    case ( txt,
           i_comment )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("// \""));
        txt = Tpl.writeStr(txt, i_comment);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
      then txt;
  end match;
end fun_208;

protected function fun_209
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_index;
  input String in_a_arrayName;
  input SimCode.SimCode in_a_simCode;
  input DAE.ComponentRef in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_index, in_a_arrayName, in_a_simCode, in_a_name)
    local
      Tpl.Text txt;
      Integer a_index;
      String a_arrayName;
      SimCode.SimCode a_simCode;
      DAE.ComponentRef a_name;
      Integer ret_1;
      Integer ret_0;

    case ( txt,
           false,
           a_index,
           a_arrayName,
           a_simCode,
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("case "));
        ret_0 = SimCodeUtil.lookupVR(a_name, a_simCode);
        txt = Tpl.writeStr(txt, intString(ret_0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" : return comp->fmuData->simulationInfo->"));
        txt = Tpl.writeStr(txt, a_arrayName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("["));
        txt = Tpl.writeStr(txt, intString(a_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("]; break;"));
      then txt;

    case ( txt,
           _,
           a_index,
           a_arrayName,
           a_simCode,
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("case "));
        ret_1 = SimCodeUtil.lookupVR(a_name, a_simCode);
        txt = Tpl.writeStr(txt, intString(ret_1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" : return MMC_STRINGDATA(comp->fmuData->simulationInfo->"));
        txt = Tpl.writeStr(txt, a_arrayName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("["));
        txt = Tpl.writeStr(txt, intString(a_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("]); break;"));
      then txt;
  end match;
end fun_209;

protected function fun_210
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_a_simVar;
  input SimCode.SimCode in_a_simCode;
  input String in_a_arrayName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simVar, in_a_simCode, in_a_arrayName)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      String a_arrayName;
      Integer i_index;
      DAE.ComponentRef i_name;
      String i_comment;
      Boolean ret_1;
      Tpl.Text l_description;

    case ( txt,
           SimCodeVar.SIMVAR(comment = i_comment, name = i_name, index = i_index),
           a_simCode,
           a_arrayName )
      equation
        l_description = fun_208(Tpl.emptyTxt, i_comment);
        ret_1 = stringEq(a_arrayName, "stringParameter");
        txt = fun_209(txt, ret_1, i_index, a_arrayName, a_simCode, i_name);
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_210;

public function SwitchParameters
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input SimCodeVar.SimVar a_simVar;
  input String a_arrayName;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_210(txt, a_simVar, a_simCode, a_arrayName);
end SwitchParameters;

protected function fun_212
  input Tpl.Text in_txt;
  input String in_a_comment;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_comment)
    local
      Tpl.Text txt;
      String i_comment;

    case ( txt,
           "" )
      then txt;

    case ( txt,
           i_comment )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("// \""));
        txt = Tpl.writeStr(txt, i_comment);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
      then txt;
  end match;
end fun_212;

protected function fun_213
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input SimCode.SimCode in_a_simCode;
  input DAE.ComponentRef in_a_varName;
  input String in_a_arrayName;
  input Tpl.Text in_a_crefName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_simCode, in_a_varName, in_a_arrayName, in_a_crefName)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      DAE.ComponentRef a_varName;
      String a_arrayName;
      Tpl.Text a_crefName;
      Integer ret_0;

    case ( txt,
           false,
           a_simCode,
           a_varName,
           a_arrayName,
           a_crefName )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("case "));
        txt = Tpl.writeText(txt, a_crefName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" : return get"));
        txt = Tpl.writeStr(txt, a_arrayName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(comp, "));
        ret_0 = SimCodeUtil.lookupVR(a_varName, a_simCode);
        txt = Tpl.writeStr(txt, intString(ret_0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("); break;"));
      then txt;

    case ( txt,
           _,
           _,
           _,
           _,
           a_crefName )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("case "));
        txt = Tpl.writeText(txt, a_crefName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" : return comp->fmuData->localData[0]->timeValue; break;"));
      then txt;
  end match;
end fun_213;

protected function fun_214
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input SimCode.SimCode in_a_simCode;
  input DAE.ComponentRef in_a_varName;
  input String in_a_arrayName;
  input String in_a_negate;
  input Tpl.Text in_a_crefName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_simCode, in_a_varName, in_a_arrayName, in_a_negate, in_a_crefName)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      DAE.ComponentRef a_varName;
      String a_arrayName;
      String a_negate;
      Tpl.Text a_crefName;
      Integer ret_0;

    case ( txt,
           false,
           a_simCode,
           a_varName,
           a_arrayName,
           a_negate,
           a_crefName )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("case "));
        txt = Tpl.writeText(txt, a_crefName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" : return ("));
        txt = Tpl.writeStr(txt, a_negate);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" get"));
        txt = Tpl.writeStr(txt, a_arrayName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(comp, "));
        ret_0 = SimCodeUtil.lookupVR(a_varName, a_simCode);
        txt = Tpl.writeStr(txt, intString(ret_0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")); break;"));
      then txt;

    case ( txt,
           _,
           _,
           _,
           _,
           _,
           a_crefName )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("case "));
        txt = Tpl.writeText(txt, a_crefName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" : return comp->fmuData->localData[0]->timeValue; break;"));
      then txt;
  end match;
end fun_214;

protected function fun_215
  input Tpl.Text in_txt;
  input SimCodeVar.AliasVariable in_a_aliasvar;
  input String in_a_negate;
  input SimCode.SimCode in_a_simCode;
  input String in_a_arrayName;
  input Tpl.Text in_a_crefName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_aliasvar, in_a_negate, in_a_simCode, in_a_arrayName, in_a_crefName)
    local
      Tpl.Text txt;
      String a_negate;
      SimCode.SimCode a_simCode;
      String a_arrayName;
      Tpl.Text a_crefName;
      DAE.ComponentRef i_varName;
      Boolean ret_3;
      Tpl.Text txt_2;
      Boolean ret_1;
      Tpl.Text txt_0;

    case ( txt,
           SimCodeVar.ALIAS(varName = i_varName),
           _,
           a_simCode,
           a_arrayName,
           a_crefName )
      equation
        txt_0 = CodegenUtil.crefStr(Tpl.emptyTxt, i_varName);
        ret_1 = stringEq(Tpl.textString(txt_0), "time");
        txt = fun_213(txt, ret_1, a_simCode, i_varName, a_arrayName, a_crefName);
      then txt;

    case ( txt,
           SimCodeVar.NEGATEDALIAS(varName = i_varName),
           a_negate,
           a_simCode,
           a_arrayName,
           a_crefName )
      equation
        txt_2 = CodegenUtil.crefStr(Tpl.emptyTxt, i_varName);
        ret_3 = stringEq(Tpl.textString(txt_2), "time");
        txt = fun_214(txt, ret_3, a_simCode, i_varName, a_arrayName, a_negate, a_crefName);
      then txt;

    case ( txt,
           _,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_215;

protected function fun_216
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_a_simVar;
  input SimCode.SimCode in_a_simCode;
  input String in_a_arrayName;
  input String in_a_negate;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simVar, in_a_simCode, in_a_arrayName, in_a_negate)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      String a_arrayName;
      String a_negate;
      SimCodeVar.AliasVariable i_aliasvar;
      DAE.ComponentRef i_name;
      String i_comment;
      Integer ret_2;
      Tpl.Text l_crefName;
      Tpl.Text l_description;

    case ( txt,
           SimCodeVar.SIMVAR(comment = i_comment, name = i_name, aliasvar = i_aliasvar),
           a_simCode,
           a_arrayName,
           a_negate )
      equation
        l_description = fun_212(Tpl.emptyTxt, i_comment);
        ret_2 = SimCodeUtil.lookupVR(i_name, a_simCode);
        l_crefName = Tpl.writeStr(Tpl.emptyTxt, intString(ret_2));
        txt = fun_215(txt, i_aliasvar, a_negate, a_simCode, a_arrayName, l_crefName);
      then txt;

    case ( txt,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_216;

public function SwitchAliasVars
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input SimCodeVar.SimVar a_simVar;
  input String a_arrayName;
  input String a_negate;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_216(txt, a_simVar, a_simCode, a_arrayName, a_negate);
end SwitchAliasVars;

protected function fun_218
  input Tpl.Text in_txt;
  input String in_a_comment;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_comment)
    local
      Tpl.Text txt;
      String i_comment;

    case ( txt,
           "" )
      then txt;

    case ( txt,
           i_comment )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("// \""));
        txt = Tpl.writeStr(txt, i_comment);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
      then txt;
  end match;
end fun_218;

protected function fun_219
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_index;
  input String in_a_arrayName;
  input SimCode.SimCode in_a_simCode;
  input DAE.ComponentRef in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_index, in_a_arrayName, in_a_simCode, in_a_name)
    local
      Tpl.Text txt;
      Integer a_index;
      String a_arrayName;
      SimCode.SimCode a_simCode;
      DAE.ComponentRef a_name;
      Integer ret_1;
      Integer ret_0;

    case ( txt,
           false,
           a_index,
           a_arrayName,
           a_simCode,
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("case "));
        ret_0 = SimCodeUtil.lookupVR(a_name, a_simCode);
        txt = Tpl.writeStr(txt, intString(ret_0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" : comp->fmuData->localData[0]->"));
        txt = Tpl.writeStr(txt, a_arrayName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("["));
        txt = Tpl.writeStr(txt, intString(a_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = value; break;"));
      then txt;

    case ( txt,
           _,
           a_index,
           a_arrayName,
           a_simCode,
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("case "));
        ret_1 = SimCodeUtil.lookupVR(a_name, a_simCode);
        txt = Tpl.writeStr(txt, intString(ret_1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" : comp->fmuData->localData[0]->"));
        txt = Tpl.writeStr(txt, a_arrayName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("["));
        txt = Tpl.writeStr(txt, intString(a_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = mmc_mk_scon(value); break;"));
      then txt;
  end match;
end fun_219;

protected function fun_220
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_index;
  input SimCode.SimCode in_a_simCode;
  input DAE.ComponentRef in_a_name;
  input String in_a_arrayName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_index, in_a_simCode, in_a_name, in_a_arrayName)
    local
      Tpl.Text txt;
      Integer a_index;
      SimCode.SimCode a_simCode;
      DAE.ComponentRef a_name;
      String a_arrayName;
      Boolean ret_0;

    case ( txt,
           false,
           a_index,
           a_simCode,
           a_name,
           a_arrayName )
      equation
        ret_0 = stringEq(a_arrayName, "stringVars");
        txt = fun_219(txt, ret_0, a_index, a_arrayName, a_simCode, a_name);
      then txt;

    case ( txt,
           _,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_220;

protected function fun_221
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_index;
  input SimCode.SimCode in_a_simCode;
  input String in_a_arrayName;
  input DAE.ComponentRef in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_index, in_a_simCode, in_a_arrayName, in_a_name)
    local
      Tpl.Text txt;
      Integer a_index;
      SimCode.SimCode a_simCode;
      String a_arrayName;
      DAE.ComponentRef a_name;
      Boolean ret_1;
      Tpl.Text txt_0;

    case ( txt,
           false,
           a_index,
           a_simCode,
           a_arrayName,
           a_name )
      equation
        txt_0 = CodegenUtil.crefStr(Tpl.emptyTxt, a_name);
        ret_1 = stringEq(Tpl.textString(txt_0), "der($dummy)");
        txt = fun_220(txt, ret_1, a_index, a_simCode, a_name, a_arrayName);
      then txt;

    case ( txt,
           _,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_221;

protected function fun_222
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_a_simVar;
  input SimCode.SimCode in_a_simCode;
  input String in_a_arrayName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simVar, in_a_simCode, in_a_arrayName)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      String a_arrayName;
      Integer i_index;
      DAE.ComponentRef i_name;
      String i_comment;
      Boolean ret_2;
      Tpl.Text txt_1;
      Tpl.Text l_description;

    case ( txt,
           SimCodeVar.SIMVAR(comment = i_comment, name = i_name, index = i_index),
           a_simCode,
           a_arrayName )
      equation
        l_description = fun_218(Tpl.emptyTxt, i_comment);
        txt_1 = CodegenUtil.crefStr(Tpl.emptyTxt, i_name);
        ret_2 = stringEq(Tpl.textString(txt_1), "$dummy");
        txt = fun_221(txt, ret_2, i_index, a_simCode, a_arrayName, i_name);
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_222;

public function SwitchVarsSet
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input SimCodeVar.SimVar a_simVar;
  input String a_arrayName;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_222(txt, a_simVar, a_simCode, a_arrayName);
end SwitchVarsSet;

protected function fun_224
  input Tpl.Text in_txt;
  input String in_a_comment;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_comment)
    local
      Tpl.Text txt;
      String i_comment;

    case ( txt,
           "" )
      then txt;

    case ( txt,
           i_comment )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("// \""));
        txt = Tpl.writeStr(txt, i_comment);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
      then txt;
  end match;
end fun_224;

protected function fun_225
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_index;
  input String in_a_arrayName;
  input SimCode.SimCode in_a_simCode;
  input DAE.ComponentRef in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_index, in_a_arrayName, in_a_simCode, in_a_name)
    local
      Tpl.Text txt;
      Integer a_index;
      String a_arrayName;
      SimCode.SimCode a_simCode;
      DAE.ComponentRef a_name;
      Integer ret_1;
      Integer ret_0;

    case ( txt,
           false,
           a_index,
           a_arrayName,
           a_simCode,
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("case "));
        ret_0 = SimCodeUtil.lookupVR(a_name, a_simCode);
        txt = Tpl.writeStr(txt, intString(ret_0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" : comp->fmuData->simulationInfo->"));
        txt = Tpl.writeStr(txt, a_arrayName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("["));
        txt = Tpl.writeStr(txt, intString(a_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = value; break;"));
      then txt;

    case ( txt,
           _,
           a_index,
           a_arrayName,
           a_simCode,
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("case "));
        ret_1 = SimCodeUtil.lookupVR(a_name, a_simCode);
        txt = Tpl.writeStr(txt, intString(ret_1));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" : comp->fmuData->simulationInfo->"));
        txt = Tpl.writeStr(txt, a_arrayName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("["));
        txt = Tpl.writeStr(txt, intString(a_index));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("] = mmc_mk_scon(value); break;"));
      then txt;
  end match;
end fun_225;

protected function fun_226
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_a_simVar;
  input SimCode.SimCode in_a_simCode;
  input String in_a_arrayName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simVar, in_a_simCode, in_a_arrayName)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      String a_arrayName;
      Integer i_index;
      DAE.ComponentRef i_name;
      String i_comment;
      Boolean ret_1;
      Tpl.Text l_description;

    case ( txt,
           SimCodeVar.SIMVAR(comment = i_comment, name = i_name, index = i_index),
           a_simCode,
           a_arrayName )
      equation
        l_description = fun_224(Tpl.emptyTxt, i_comment);
        ret_1 = stringEq(a_arrayName, "stringParameter");
        txt = fun_225(txt, ret_1, i_index, a_arrayName, a_simCode, i_name);
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_226;

public function SwitchParametersSet
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input SimCodeVar.SimVar a_simVar;
  input String a_arrayName;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_226(txt, a_simVar, a_simCode, a_arrayName);
end SwitchParametersSet;

protected function fun_228
  input Tpl.Text in_txt;
  input String in_a_comment;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_comment)
    local
      Tpl.Text txt;
      String i_comment;

    case ( txt,
           "" )
      then txt;

    case ( txt,
           i_comment )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("// \""));
        txt = Tpl.writeStr(txt, i_comment);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
      then txt;
  end match;
end fun_228;

protected function fun_229
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input SimCode.SimCode in_a_simCode;
  input DAE.ComponentRef in_a_varName;
  input String in_a_arrayName;
  input Tpl.Text in_a_crefName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_simCode, in_a_varName, in_a_arrayName, in_a_crefName)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      DAE.ComponentRef a_varName;
      String a_arrayName;
      Tpl.Text a_crefName;
      Integer ret_0;

    case ( txt,
           false,
           a_simCode,
           a_varName,
           a_arrayName,
           a_crefName )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("case "));
        txt = Tpl.writeText(txt, a_crefName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" : return set"));
        txt = Tpl.writeStr(txt, a_arrayName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(comp, "));
        ret_0 = SimCodeUtil.lookupVR(a_varName, a_simCode);
        txt = Tpl.writeStr(txt, intString(ret_0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", value); break;"));
      then txt;

    case ( txt,
           _,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_229;

protected function fun_230
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_negate;
  input SimCode.SimCode in_a_simCode;
  input DAE.ComponentRef in_a_varName;
  input String in_a_arrayName;
  input Tpl.Text in_a_crefName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_negate, in_a_simCode, in_a_varName, in_a_arrayName, in_a_crefName)
    local
      Tpl.Text txt;
      String a_negate;
      SimCode.SimCode a_simCode;
      DAE.ComponentRef a_varName;
      String a_arrayName;
      Tpl.Text a_crefName;
      Integer ret_0;

    case ( txt,
           false,
           a_negate,
           a_simCode,
           a_varName,
           a_arrayName,
           a_crefName )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("case "));
        txt = Tpl.writeText(txt, a_crefName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" : return set"));
        txt = Tpl.writeStr(txt, a_arrayName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(comp, "));
        ret_0 = SimCodeUtil.lookupVR(a_varName, a_simCode);
        txt = Tpl.writeStr(txt, intString(ret_0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", ("));
        txt = Tpl.writeStr(txt, a_negate);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" value)); break;"));
      then txt;

    case ( txt,
           _,
           _,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_230;

protected function fun_231
  input Tpl.Text in_txt;
  input SimCodeVar.AliasVariable in_a_aliasvar;
  input String in_a_negate;
  input SimCode.SimCode in_a_simCode;
  input String in_a_arrayName;
  input Tpl.Text in_a_crefName;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_aliasvar, in_a_negate, in_a_simCode, in_a_arrayName, in_a_crefName)
    local
      Tpl.Text txt;
      String a_negate;
      SimCode.SimCode a_simCode;
      String a_arrayName;
      Tpl.Text a_crefName;
      DAE.ComponentRef i_varName;
      Boolean ret_3;
      Tpl.Text txt_2;
      Boolean ret_1;
      Tpl.Text txt_0;

    case ( txt,
           SimCodeVar.ALIAS(varName = i_varName),
           _,
           a_simCode,
           a_arrayName,
           a_crefName )
      equation
        txt_0 = CodegenUtil.crefStr(Tpl.emptyTxt, i_varName);
        ret_1 = stringEq(Tpl.textString(txt_0), "time");
        txt = fun_229(txt, ret_1, a_simCode, i_varName, a_arrayName, a_crefName);
      then txt;

    case ( txt,
           SimCodeVar.NEGATEDALIAS(varName = i_varName),
           a_negate,
           a_simCode,
           a_arrayName,
           a_crefName )
      equation
        txt_2 = CodegenUtil.crefStr(Tpl.emptyTxt, i_varName);
        ret_3 = stringEq(Tpl.textString(txt_2), "time");
        txt = fun_230(txt, ret_3, a_negate, a_simCode, i_varName, a_arrayName, a_crefName);
      then txt;

    case ( txt,
           _,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_231;

protected function fun_232
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_a_simVar;
  input SimCode.SimCode in_a_simCode;
  input String in_a_arrayName;
  input String in_a_negate;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simVar, in_a_simCode, in_a_arrayName, in_a_negate)
    local
      Tpl.Text txt;
      SimCode.SimCode a_simCode;
      String a_arrayName;
      String a_negate;
      SimCodeVar.AliasVariable i_aliasvar;
      DAE.ComponentRef i_name;
      String i_comment;
      Integer ret_2;
      Tpl.Text l_crefName;
      Tpl.Text l_description;

    case ( txt,
           SimCodeVar.SIMVAR(comment = i_comment, name = i_name, aliasvar = i_aliasvar),
           a_simCode,
           a_arrayName,
           a_negate )
      equation
        l_description = fun_228(Tpl.emptyTxt, i_comment);
        ret_2 = SimCodeUtil.lookupVR(i_name, a_simCode);
        l_crefName = Tpl.writeStr(Tpl.emptyTxt, intString(ret_2));
        txt = fun_231(txt, i_aliasvar, a_negate, a_simCode, a_arrayName, l_crefName);
      then txt;

    case ( txt,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_232;

public function SwitchAliasVarsSet
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input SimCodeVar.SimVar a_simVar;
  input String a_arrayName;
  input String a_negate;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_232(txt, a_simVar, a_simCode, a_arrayName, a_negate);
end SwitchAliasVarsSet;

protected function fun_234
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_a_var;
  input Integer in_a_index0;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_var, in_a_index0, in_a_simCode)
    local
      Tpl.Text txt;
      Integer a_index0;
      SimCode.SimCode a_simCode;
      DAE.ComponentRef i_name;
      Integer ret_0;

    case ( txt,
           SimCodeVar.SIMVAR(name = i_name, type_ = DAE.T_REAL(varLst = _)),
           a_index0,
           a_simCode )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("case "));
        ret_0 = SimCodeUtil.lookupVR(i_name, a_simCode);
        txt = Tpl.writeStr(txt, intString(ret_0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(": return "));
        txt = Tpl.writeStr(txt, intString(a_index0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("; break;"));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_234;

protected function lm_235
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCode.SimCode a_simCode;
      Integer x_index0;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_simCode )
      equation
        x_index0 = Tpl.getIteri_i0(txt);
        txt = fun_234(txt, i_var, x_index0, a_simCode);
        txt = Tpl.nextIter(txt);
        txt = lm_235(txt, rest, a_simCode);
      then txt;
  end match;
end lm_235;

protected function fun_236
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_a_var;
  input Integer in_a_index0;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_var, in_a_index0, in_a_simCode)
    local
      Tpl.Text txt;
      Integer a_index0;
      SimCode.SimCode a_simCode;
      DAE.ComponentRef i_name;
      Integer ret_0;

    case ( txt,
           SimCodeVar.SIMVAR(name = i_name, type_ = DAE.T_REAL(varLst = _)),
           a_index0,
           a_simCode )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("case "));
        ret_0 = SimCodeUtil.lookupVR(i_name, a_simCode);
        txt = Tpl.writeStr(txt, intString(ret_0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(": return "));
        txt = Tpl.writeStr(txt, intString(a_index0));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("; break;"));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_236;

protected function lm_237
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCode.SimCode a_simCode;
      Integer x_index0;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_var :: rest,
           a_simCode )
      equation
        x_index0 = Tpl.getIteri_i0(txt);
        txt = fun_236(txt, i_var, x_index0, a_simCode);
        txt = Tpl.nextIter(txt);
        txt = lm_237(txt, rest, a_simCode);
      then txt;
  end match;
end lm_237;

public function mapInputAndOutputs
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> i_outputVars;
      SimCode.SimCode i_simCode;
      list<SimCodeVar.SimVar> i_inputVars;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(vars = SimCodeVar.SIMVARS(inputVars = i_inputVars, outputVars = i_outputVars)))) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "/* function maps input references to a input index used in partialDerivatives */\n",
                                    "fmi2ValueReference mapInputReference2InputNumber(const fmi2ValueReference vr) {\n",
                                    "    switch (vr) {\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(6));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_235(txt, i_inputVars, i_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "default:\n",
                                    "  return -1;\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "    }\n",
                                    "}\n",
                                    "/* function maps output references to a input index used in partialDerivatives */\n",
                                    "fmi2ValueReference mapOutputReference2OutputNumber(const fmi2ValueReference vr) {\n",
                                    "    switch (vr) {\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(6));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_237(txt, i_outputVars, i_simCode);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "default:\n",
                                    "  return -1;\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "    }\n",
                                    "}"
                                }, false));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end mapInputAndOutputs;

protected function fun_239
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("head -n20 Makefile > ../resources/$(FMIPLATFORM).summary"));
      then txt;
  end match;
end fun_239;

protected function fun_240
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t$(MAKE) distclean"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_240;

protected function fun_241
  input Tpl.Text in_txt;
  input String in_a_platform;
  input String in_a_libsPos2;
  input String in_a_libsPos1;
  input String in_a_dirExtra;
  input String in_a_modelNamePrefix;
  input String in_a_fmuTargetName;
  input String in_a_fileNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_platform, in_a_libsPos2, in_a_libsPos1, in_a_dirExtra, in_a_modelNamePrefix, in_a_fmuTargetName, in_a_fileNamePrefix)
    local
      Tpl.Text txt;
      String a_libsPos2;
      String a_libsPos1;
      String a_dirExtra;
      String a_modelNamePrefix;
      String a_fmuTargetName;
      String a_fileNamePrefix;
      String i_platform;
      Boolean ret_2;
      Boolean ret_1;
      Integer ret_0;

    case ( txt,
           (i_platform as "win32"),
           a_libsPos2,
           a_libsPos1,
           a_dirExtra,
           a_modelNamePrefix,
           a_fmuTargetName,
           a_fileNamePrefix )
      equation
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_FMU: nozip\n"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("cd .. && rm -f ../"));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".fmu && zip -r ../"));
        txt = Tpl.writeStr(txt, a_fmuTargetName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ".fmu *\n",
                                    "nozip: "
                                }, false));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_functions.h "));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_literals.h $(OFILES) $(RUNTIMEFILES) $(FMISUNDIALSFILES)\n"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("$(CXX) -shared -I. -o "));
        txt = Tpl.writeStr(txt, a_modelNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("$(DLLEXT) $(RUNTIMEFILES) $(FMISUNDIALSFILES) $(OFILES) $(CPPFLAGS) "));
        txt = Tpl.writeStr(txt, a_dirExtra);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeStr(txt, a_libsPos1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeStr(txt, a_libsPos2);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" $(CFLAGS) $(LDFLAGS) -llis -Wl,--kill-at\n"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("mkdir.exe -p ../binaries/"));
        txt = Tpl.writeStr(txt, i_platform);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("dlltool -d "));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".def --dllname "));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("$(DLLEXT) --output-lib "));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(".lib --kill-at\n"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("cp "));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("$(DLLEXT) "));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".lib "));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_FMU.libs ../binaries/"));
        txt = Tpl.writeStr(txt, i_platform);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/\n"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("rm -f *.o "));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("$(DLLEXT) $(OFILES) $(RUNTIMEFILES) $(FMISUNDIALSFILES)\n"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("cd .. && rm -f ../"));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".fmu && zip -r ../"));
        txt = Tpl.writeStr(txt, a_fmuTargetName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ".fmu *\n",
                                    "\n"
                                }, true));
      then txt;

    case ( txt,
           (i_platform as "win64"),
           a_libsPos2,
           a_libsPos1,
           a_dirExtra,
           a_modelNamePrefix,
           a_fmuTargetName,
           a_fileNamePrefix )
      equation
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_FMU: nozip\n"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("cd .. && rm -f ../"));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".fmu && zip -r ../"));
        txt = Tpl.writeStr(txt, a_fmuTargetName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ".fmu *\n",
                                    "nozip: "
                                }, false));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_functions.h "));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_literals.h $(OFILES) $(RUNTIMEFILES) $(FMISUNDIALSFILES)\n"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("$(CXX) -shared -I. -o "));
        txt = Tpl.writeStr(txt, a_modelNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("$(DLLEXT) $(RUNTIMEFILES) $(FMISUNDIALSFILES) $(OFILES) $(CPPFLAGS) "));
        txt = Tpl.writeStr(txt, a_dirExtra);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeStr(txt, a_libsPos1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeStr(txt, a_libsPos2);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" $(CFLAGS) $(LDFLAGS) -llis -Wl,--kill-at\n"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("mkdir.exe -p ../binaries/"));
        txt = Tpl.writeStr(txt, i_platform);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("dlltool -d "));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".def --dllname "));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("$(DLLEXT) --output-lib "));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(".lib --kill-at\n"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("cp "));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("$(DLLEXT) "));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".lib "));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_FMU.libs ../binaries/"));
        txt = Tpl.writeStr(txt, i_platform);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("/\n"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("rm -f *.o "));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("$(DLLEXT) $(OFILES) $(RUNTIMEFILES) $(FMISUNDIALSFILES)\n"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("cd .. && rm -f ../"));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".fmu && zip -r ../"));
        txt = Tpl.writeStr(txt, a_fmuTargetName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ".fmu *\n",
                                    "\n"
                                }, true));
      then txt;

    case ( txt,
           _,
           a_libsPos2,
           a_libsPos1,
           a_dirExtra,
           a_modelNamePrefix,
           a_fmuTargetName,
           a_fileNamePrefix )
      equation
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_FMU: nozip\n"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("cd .. && rm -f ../"));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".fmu && zip -r ../"));
        txt = Tpl.writeStr(txt, a_fmuTargetName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ".fmu *\n",
                                    "nozip: "
                                }, false));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_functions.h "));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_literals.h $(OFILES) $(RUNTIMEFILES) $(FMISUNDIALSFILES)\n"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "mkdir -p ../binaries/$(FMIPLATFORM)\n",
                                    "ifeq (@LIBTYPE_DYNAMIC@,1)\n"
                                }, true));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("$(LD) -o "));
        txt = Tpl.writeStr(txt, a_modelNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("$(DLLEXT) $(OFILES) $(RUNTIMEFILES) $(FMISUNDIALSFILES) "));
        txt = Tpl.writeStr(txt, a_dirExtra);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeStr(txt, a_libsPos1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" @BSTATIC@ "));
        txt = Tpl.writeStr(txt, a_libsPos2);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" @BDYNAMIC@ $(LDFLAGS)\n"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("cp "));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("$(DLLEXT) "));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_FMU.libs ../binaries/$(FMIPLATFORM)/\n",
                                    "endif\n"
                                }, true));
        ret_0 = Flags.getConfigEnum(Flags.FMI_FILTER);
        ret_1 = intLt(ret_0, 4);
        txt = fun_239(txt, ret_1);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("ifeq (@LIBTYPE_STATIC@,1)\n"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("rm -f "));
        txt = Tpl.writeStr(txt, a_modelNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(".a\n"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("$(AR) -rsu "));
        txt = Tpl.writeStr(txt, a_modelNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(".a $(OFILES) $(RUNTIMEFILES) $(FMISUNDIALSFILES)\n"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("cp "));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".a "));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_FMU.libs ../binaries/$(FMIPLATFORM)/\n",
                                    "endif\n"
                                }, true));
        ret_2 = Flags.isSet(Flags.GEN_DEBUG_SYMBOLS);
        txt = fun_240(txt, ret_2);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("distclean: clean\n"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "rm -f Makefile config.status config.log\n",
                                    "clean:\n"
                                }, true));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("rm -f "));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".def "));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".o "));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".a "));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("$(DLLEXT) $(MAINOBJ) $(OFILES) $(RUNTIMEFILES) $(FMISUNDIALSFILES)"));
      then txt;
  end match;
end fun_241;

public function getPlatformString2
  input Tpl.Text txt;
  input String a_modelNamePrefix;
  input String a_platform;
  input String a_fileNamePrefix;
  input String a_fmuTargetName;
  input String a_dirExtra;
  input String a_libsPos1;
  input String a_libsPos2;
  input String a_omhome;
  input String a_FMUVersion;

  output Tpl.Text out_txt;
protected
  Tpl.Text l_fmudirname;
algorithm
  l_fmudirname := Tpl.writeStr(Tpl.emptyTxt, a_fileNamePrefix);
  l_fmudirname := Tpl.writeTok(l_fmudirname, Tpl.ST_STRING(".fmutmp"));
  out_txt := fun_241(txt, a_platform, a_libsPos2, a_libsPos1, a_dirExtra, a_modelNamePrefix, a_fmuTargetName, a_fileNamePrefix);
end getPlatformString2;

protected function fun_243
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#define FMU_EXPERIMENTAL 1"));
      then txt;
  end match;
end fun_243;

protected function fun_244
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#define WITH_SUNDIALS 1"));
      then txt;
  end match;
end fun_244;

public function settingsfile
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      Option<SimCode.FmiSimulationFlags> i_fmiSimulationFlags;
      SimCode.SimCode i_simCode;
      Integer i_varInfo_numStringAlgVars;
      Integer i_maxDelayedIndex;
      Integer i_varInfo_numMixedSystems;
      Integer i_varInfo_numNonLinearSystems;
      Integer i_varInfo_numLinearSystems;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(varInfo = SimCode.VARINFO(numLinearSystems = i_varInfo_numLinearSystems, numNonLinearSystems = i_varInfo_numNonLinearSystems, numMixedSystems = i_varInfo_numMixedSystems, numStringAlgVars = i_varInfo_numStringAlgVars)), delayedExps = SimCode.DELAYED_EXPRESSIONS(maxDelayedIndex = i_maxDelayedIndex), fmiSimulationFlags = i_fmiSimulationFlags)) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "#if !defined(OMC_SIM_SETTINGS_CMDLINE)\n",
                                    "#define OMC_SIM_SETTINGS_CMDLINE\n",
                                    "#define OMC_NUM_LINEAR_SYSTEMS "
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numLinearSystems));
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#define OMC_NUM_NONLINEAR_SYSTEMS "));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numNonLinearSystems));
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#define OMC_NUM_MIXED_SYSTEMS "));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numMixedSystems));
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#define OMC_NDELAY_EXPRESSIONS "));
        txt = Tpl.writeStr(txt, intString(i_maxDelayedIndex));
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#define OMC_NVAR_STRING "));
        txt = Tpl.writeStr(txt, intString(i_varInfo_numStringAlgVars));
        txt = Tpl.softNewLine(txt);
        ret_0 = Flags.isSet(Flags.FMU_EXPERIMENTAL);
        txt = fun_243(txt, ret_0);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#define OMC_MODEL_PREFIX \""));
        txt = CodegenUtilSimulation.modelNamePrefix(txt, i_simCode);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\"\n",
                                    "#define OMC_MINIMAL_RUNTIME 1\n",
                                    "#define OMC_FMI_RUNTIME 1\n"
                                }, true));
        ret_1 = Util.isSome(i_fmiSimulationFlags);
        txt = fun_244(txt, ret_1);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("#endif"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end settingsfile;

protected function lm_246
  input Tpl.Text in_txt;
  input list<String> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<String> rest;
      String i_it;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_it :: rest )
      equation
        txt = Tpl.writeStr(txt, i_it);
        txt = Tpl.nextIter(txt);
        txt = lm_246(txt, rest);
      then txt;
  end match;
end lm_246;

protected function lm_247
  input Tpl.Text in_txt;
  input list<String> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<String> rest;
      String i_it;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_it :: rest )
      equation
        txt = Tpl.writeStr(txt, i_it);
        txt = Tpl.nextIter(txt);
        txt = lm_247(txt, rest);
      then txt;
  end match;
end lm_247;

protected function lm_248
  input Tpl.Text in_txt;
  input list<String> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<String> rest;
      String i_it;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_it :: rest )
      equation
        txt = Tpl.writeStr(txt, i_it);
        txt = Tpl.nextIter(txt);
        txt = lm_248(txt, rest);
      then txt;
  end match;
end lm_248;

protected function lm_249
  input Tpl.Text in_txt;
  input list<String> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<String> rest;
      String i_it;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_it :: rest )
      equation
        txt = Tpl.writeStr(txt, i_it);
        txt = Tpl.nextIter(txt);
        txt = lm_249(txt, rest);
      then txt;
  end match;
end lm_249;

protected function fun_250
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input list<String> in_a_sundialsObjectFiles;
  input list<String> in_a_runtimeObjectFiles;
  input list<String> in_a_dgesvObjectFiles;
  input list<String> in_a_sourceFiles;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode, in_a_sundialsObjectFiles, in_a_runtimeObjectFiles, in_a_dgesvObjectFiles, in_a_sourceFiles)
    local
      Tpl.Text txt;
      list<String> a_sundialsObjectFiles;
      list<String> a_runtimeObjectFiles;
      list<String> a_dgesvObjectFiles;
      list<String> a_sourceFiles;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = _), makefileParams = SimCodeFunction.MAKEFILE_PARAMS(ccompiler = _), simulationSettingsOpt = _),
           a_sundialsObjectFiles,
           a_runtimeObjectFiles,
           a_dgesvObjectFiles,
           a_sourceFiles )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("CFILES = "));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING_LIST({
                                                                     " \\\n",
                                                                     "         "
                                                                 }, false)), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_246(txt, a_sourceFiles);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "OFILES=$(CFILES:.c=.o)\n",
                                    "\n",
                                    "RUNTIMEDIR=.\n",
                                    "ifneq ($(NEED_DGESV),)\n",
                                    "DGESV_OBJS = "
                                }, false));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(" ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_247(txt, a_dgesvObjectFiles);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "endif\n",
                                    "ifneq ($(NEED_RUNTIME),)\n",
                                    "RUNTIMEFILES="
                                }, false));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(" ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_248(txt, a_runtimeObjectFiles);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " $(DGESV_OBJS)\n",
                                    "endif\n",
                                    "ifneq ($(NEED_SUNDIALS),)\n",
                                    "FMISUNDIALSFILES="
                                }, false));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(" ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_249(txt, a_sundialsObjectFiles);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "LDFLAGS+=-lsundials_cvode -lsundials_nvecserial\n",
                                    "endif"
                                }, false));
      then txt;

    case ( txt,
           _,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_250;

protected function fun_251
  input Tpl.Text in_txt;
  input String in_a_modelInfo_directory;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo_directory)
    local
      Tpl.Text txt;
      String i_modelInfo_directory;

    case ( txt,
           "" )
      then txt;

    case ( txt,
           i_modelInfo_directory )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/LIBPATH:\""));
        txt = Tpl.writeStr(txt, i_modelInfo_directory);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
      then txt;
  end match;
end fun_251;

protected function lm_252
  input Tpl.Text in_txt;
  input list<String> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<String> rest;
      String i_lib;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_lib :: rest )
      equation
        txt = Tpl.writeStr(txt, i_lib);
        txt = Tpl.nextIter(txt);
        txt = lm_252(txt, rest);
      then txt;
  end match;
end lm_252;

protected function fun_253
  input Tpl.Text in_txt;
  input Tpl.Text in_a_dirExtra;
  input Tpl.Text in_a_libsStr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_dirExtra, in_a_libsStr)
    local
      Tpl.Text txt;
      Tpl.Text a_libsStr;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           a_libsStr )
      equation
        txt = Tpl.writeText(txt, a_libsStr);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_253;

protected function fun_254
  input Tpl.Text in_txt;
  input Tpl.Text in_a_dirExtra;
  input Tpl.Text in_a_libsStr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_dirExtra, in_a_libsStr)
    local
      Tpl.Text txt;
      Tpl.Text a_libsStr;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           _ )
      then txt;

    case ( txt,
           _,
           a_libsStr )
      equation
        txt = Tpl.writeText(txt, a_libsStr);
      then txt;
  end match;
end fun_254;

protected function fun_255
  input Tpl.Text in_txt;
  input String in_a_makefileParams_platform;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_makefileParams_platform)
    local
      Tpl.Text txt;

    case ( txt,
           "win32" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\"mkdir.exe\""));
      then txt;

    case ( txt,
           "win64" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\"mkdir.exe\""));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("mkdir"));
      then txt;
  end match;
end fun_255;

protected function fun_256
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_makefileParams_omhome;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_makefileParams_omhome)
    local
      Tpl.Text txt;
      String a_makefileParams_omhome;

    case ( txt,
           false,
           a_makefileParams_omhome )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/I\""));
        txt = Tpl.writeStr(txt, a_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/include/omc/c/fmi1\""));
      then txt;

    case ( txt,
           _,
           a_makefileParams_omhome )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/I\""));
        txt = Tpl.writeStr(txt, a_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/include/omc/c/fmi2\""));
      then txt;
  end match;
end fun_256;

protected function fun_257
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/DFMU_EXPERIMENTAL"));
      then txt;
  end match;
end fun_257;

protected function fun_258
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_common;
  input String in_a_FMUVersion;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode, in_a_common, in_a_FMUVersion)
    local
      Tpl.Text txt;
      Tpl.Text a_common;
      String a_FMUVersion;
      String i_makefileParams_omhome;
      String i_fmuTargetName;
      String i_makefileParams_platform;
      SimCode.SimCode i_simCode;
      String i_fileNamePrefix;
      list<String> i_makefileParams_libs;
      String i_modelInfo_directory;
      String ret_14;
      String ret_13;
      String ret_12;
      String ret_11;
      String ret_10;
      Boolean ret_9;
      Boolean ret_8;
      Tpl.Text l_mkdir;
      Tpl.Text txt_6;
      Tpl.Text l_compilecmds;
      Tpl.Text l_fmudirname;
      Tpl.Text l_libsPos2;
      Tpl.Text l_libsPos1;
      Tpl.Text l_libsStr;
      Tpl.Text l_dirExtra;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(directory = i_modelInfo_directory), makefileParams = SimCodeFunction.MAKEFILE_PARAMS(libs = i_makefileParams_libs, platform = i_makefileParams_platform, omhome = i_makefileParams_omhome), simulationSettingsOpt = _, fileNamePrefix = i_fileNamePrefix, fmuTargetName = i_fmuTargetName)),
           a_common,
           a_FMUVersion )
      equation
        l_dirExtra = fun_251(Tpl.emptyTxt, i_modelInfo_directory);
        l_libsStr = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(" ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_libsStr = lm_252(l_libsStr, i_makefileParams_libs);
        l_libsStr = Tpl.popIter(l_libsStr);
        l_libsPos1 = fun_253(Tpl.emptyTxt, l_dirExtra, l_libsStr);
        l_libsPos2 = fun_254(Tpl.emptyTxt, l_dirExtra, l_libsStr);
        l_fmudirname = Tpl.writeStr(Tpl.emptyTxt, i_fileNamePrefix);
        l_fmudirname = Tpl.writeTok(l_fmudirname, Tpl.ST_STRING(".fmutmp"));
        txt_6 = CodegenUtilSimulation.modelNamePrefix(Tpl.emptyTxt, i_simCode);
        l_compilecmds = getPlatformString2(Tpl.emptyTxt, Tpl.textString(txt_6), i_makefileParams_platform, i_fileNamePrefix, i_fmuTargetName, Tpl.textString(l_dirExtra), Tpl.textString(l_libsPos1), Tpl.textString(l_libsPos2), i_makefileParams_omhome, a_FMUVersion);
        l_mkdir = fun_255(Tpl.emptyTxt, i_makefileParams_platform);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "# Makefile generated by OpenModelica\n",
                                    "\n",
                                    "# Simulations use -O3 by default\n",
                                    "SIM_OR_DYNLOAD_OPT_LEVEL=\n",
                                    "MODELICAUSERCFLAGS=\n",
                                    "CXX=cl\n",
                                    "EXEEXT=.exe\n",
                                    "DLLEXT=.dll\n",
                                    "FMUEXT=.fmu\n",
                                    "PLATWIN32 = win32\n",
                                    "\n",
                                    "# /Od - Optimization disabled\n",
                                    "# /EHa enable C++ EH (w/ SEH exceptions)\n",
                                    "# /fp:except - consider floating-point exceptions when generating code\n",
                                    "# /arch:SSE2 - enable use of instructions available with SSE2 enabled CPUs\n",
                                    "# /I - Include Directories\n",
                                    "# /DNOMINMAX - Define NOMINMAX (does what it says)\n",
                                    "# /TP - Use C++ Compiler\n",
                                    "CFLAGS=/MP /Od /ZI /EHa /fp:except /I\""
                                }, false));
        txt = Tpl.writeStr(txt, i_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/include/omc/c\" /I\""));
        txt = Tpl.writeStr(txt, i_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/include/omc/msvc/\" "));
        ret_8 = FMI.isFMIVersion20(a_FMUVersion);
        txt = fun_256(txt, ret_8, i_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" /I. /DNOMINMAX /TP /DNO_INTERACTIVE_DEPENDENCY  "));
        ret_9 = Flags.isSet(Flags.FMU_EXPERIMENTAL);
        txt = fun_257(txt, ret_9);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "# /ZI enable Edit and Continue debug info\n",
                                    "CDFLAGS=/ZI\n",
                                    "\n",
                                    "# /MD - link with MSVCRT.LIB\n",
                                    "# /link - [linker options and libraries]\n",
                                    "# /LIBPATH: - Directories where libs can be found\n",
                                    "LDFLAGS=/MD /link /dll /debug /pdb:\""
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".pdb\" /LIBPATH:\""));
        txt = Tpl.writeStr(txt, i_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/lib/"));
        txt = Tpl.writeStr(txt, Autoconf.triple);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/omc/msvc/\" /LIBPATH:\""));
        txt = Tpl.writeStr(txt, i_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/lib/"));
        txt = Tpl.writeStr(txt, Autoconf.triple);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/omc/msvc/release/\" "));
        txt = Tpl.writeText(txt, l_dirExtra);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, l_libsPos1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, l_libsPos2);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " f2c.lib initialization.lib libexpat.lib math-support.lib meta.lib results.lib simulation.lib solver.lib sundials_kinsol.lib sundials_nvecserial.lib util.lib lapack_win32_MT.lib lis.lib  omcgc.lib user32.lib pthreadVC2.lib wsock32.lib cminpack.lib umfpack.lib amd.lib\n",
                                    "\n",
                                    "# /MDd link with MSVCRTD.LIB debug lib\n",
                                    "# lib names should not be appended with a d just switch to lib/omc/msvc/debug\n",
                                    "\n",
                                    "\n"
                                }, true));
        txt = Tpl.writeText(txt, a_common);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("$(FMUEXT): "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("$(DLLEXT) modelDescription.xml\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if not exist "));
        txt = Tpl.writeText(txt, l_fmudirname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\\binaries\\$(PLATWIN32) "));
        txt = Tpl.writeText(txt, l_mkdir);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, l_fmudirname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\\binaries\\$(PLATWIN32)\n",
                                    "if not exist "
                                }, false));
        txt = Tpl.writeText(txt, l_fmudirname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\\sources "));
        txt = Tpl.writeText(txt, l_mkdir);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeText(txt, l_fmudirname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\\sources\n",
                                    "\n",
                                    "copy "
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".dll "));
        txt = Tpl.writeText(txt, l_fmudirname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\\binaries\\$(PLATWIN32)\n",
                                    "copy "
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".lib "));
        txt = Tpl.writeText(txt, l_fmudirname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\\binaries\\$(PLATWIN32)\n",
                                    "copy "
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".pdb "));
        txt = Tpl.writeText(txt, l_fmudirname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\\binaries\\$(PLATWIN32)\n",
                                    "copy "
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".c "));
        txt = Tpl.writeText(txt, l_fmudirname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\\sources\\"));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ".c\n",
                                    "copy "
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_model.h "));
        txt = Tpl.writeText(txt, l_fmudirname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\\sources\\"));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_model.h\n",
                                    "copy "
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_FMU.c "));
        txt = Tpl.writeText(txt, l_fmudirname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\\sources\\"));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_FMU.c\n",
                                    "copy "
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_info.c "));
        txt = Tpl.writeText(txt, l_fmudirname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\\sources\\"));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_info.c\n",
                                    "copy "
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_init_fmu.c "));
        txt = Tpl.writeText(txt, l_fmudirname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\\sources\\"));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_init_fmu.c\n",
                                    "copy "
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_functions.c "));
        txt = Tpl.writeText(txt, l_fmudirname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\\sources\\"));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_functions.c\n",
                                    "copy "
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_functions.h "));
        txt = Tpl.writeText(txt, l_fmudirname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\\sources\\"));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_functions.h\n",
                                    "copy "
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_records.c "));
        txt = Tpl.writeText(txt, l_fmudirname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\\sources\\"));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_records.c\n",
                                    "copy modelDescription.xml "
                                }, false));
        txt = Tpl.writeText(txt, l_fmudirname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\\modelDescription.xml\n",
                                    "copy "
                                }, false));
        ret_10 = System.stringReplace(i_makefileParams_omhome, "/", "\\");
        txt = Tpl.writeStr(txt, ret_10);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\\bin\\SUNDIALS_CVODE.DLL "));
        txt = Tpl.writeText(txt, l_fmudirname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\\binaries\\$(PLATWIN32)\n",
                                    "copy "
                                }, false));
        ret_11 = System.stringReplace(i_makefileParams_omhome, "/", "\\");
        txt = Tpl.writeStr(txt, ret_11);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\\bin\\SUNDIALS_KINSOL.DLL "));
        txt = Tpl.writeText(txt, l_fmudirname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\\binaries\\$(PLATWIN32)\n",
                                    "copy "
                                }, false));
        ret_12 = System.stringReplace(i_makefileParams_omhome, "/", "\\");
        txt = Tpl.writeStr(txt, ret_12);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\\bin\\SUNDIALS_NVECSERIAL.DLL "));
        txt = Tpl.writeText(txt, l_fmudirname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\\binaries\\$(PLATWIN32)\n",
                                    "copy "
                                }, false));
        ret_13 = System.stringReplace(i_makefileParams_omhome, "/", "\\");
        txt = Tpl.writeStr(txt, ret_13);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\\bin\\LAPACK_WIN32_MT.DLL "));
        txt = Tpl.writeText(txt, l_fmudirname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\\binaries\\$(PLATWIN32)\n",
                                    "copy "
                                }, false));
        ret_14 = System.stringReplace(i_makefileParams_omhome, "/", "\\");
        txt = Tpl.writeStr(txt, ret_14);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\\bin\\pthreadVC2.dll "));
        txt = Tpl.writeText(txt, l_fmudirname);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\\binaries\\$(PLATWIN32)\n",
                                    "cd "
                                }, false));
        txt = Tpl.writeText(txt, l_fmudirname);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\"zip.exe\" -r ../"));
        txt = Tpl.writeStr(txt, i_fmuTargetName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ".fmu *\n",
                                    "cd ..\n",
                                    "rm -rf "
                                }, false));
        txt = Tpl.writeText(txt, l_fmudirname);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("$(DLLEXT): $(MAINOBJ) $(CFILES)\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("$(CXX) /Fe"));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("$(DLLEXT) "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_FMU.c "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_FMU.c $(CFILES) $(CFLAGS) $(LDFLAGS)"));
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_258;

protected function fun_259
  input Tpl.Text in_txt;
  input String in_a_modelInfo_directory;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_modelInfo_directory)
    local
      Tpl.Text txt;
      String i_modelInfo_directory;

    case ( txt,
           "" )
      then txt;

    case ( txt,
           i_modelInfo_directory )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-L\""));
        txt = Tpl.writeStr(txt, i_modelInfo_directory);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
      then txt;
  end match;
end fun_259;

protected function lm_260
  input Tpl.Text in_txt;
  input list<String> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<String> rest;
      String i_lib;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_lib :: rest )
      equation
        txt = Tpl.writeStr(txt, i_lib);
        txt = Tpl.nextIter(txt);
        txt = lm_260(txt, rest);
      then txt;
  end match;
end lm_260;

protected function fun_261
  input Tpl.Text in_txt;
  input Tpl.Text in_a_dirExtra;
  input Tpl.Text in_a_libsStr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_dirExtra, in_a_libsStr)
    local
      Tpl.Text txt;
      Tpl.Text a_libsStr;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           a_libsStr )
      equation
        txt = Tpl.writeText(txt, a_libsStr);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_261;

protected function fun_262
  input Tpl.Text in_txt;
  input Tpl.Text in_a_dirExtra;
  input Tpl.Text in_a_libsStr;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_dirExtra, in_a_libsStr)
    local
      Tpl.Text txt;
      Tpl.Text a_libsStr;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           _ )
      then txt;

    case ( txt,
           _,
           a_libsStr )
      equation
        txt = Tpl.writeText(txt, a_libsStr);
      then txt;
  end match;
end fun_262;

protected function fun_263
  input Tpl.Text in_txt;
  input Option<SimCode.FmiSimulationFlags> in_a_fmiSimulationFlags;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fmiSimulationFlags)
    local
      Tpl.Text txt;

    case ( txt,
           SOME(_) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("-Isundials/ -I/util"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_263;

protected function lm_264
  input Tpl.Text in_txt;
  input list<String> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<String> rest;
      String i_it;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_it :: rest )
      equation
        txt = Tpl.writeStr(txt, i_it);
        txt = Tpl.nextIter(txt);
        txt = lm_264(txt, rest);
      then txt;
  end match;
end lm_264;

protected function fun_265
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input Tpl.Text in_a_common;
  input String in_a_FMUVersion;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode, in_a_common, in_a_FMUVersion)
    local
      Tpl.Text txt;
      Tpl.Text a_common;
      String a_FMUVersion;
      list<String> i_makefileParams_includes;
      Option<SimCode.FmiSimulationFlags> i_fmiSimulationFlags;
      String i_makefileParams_omhome;
      String i_fmuTargetName;
      String i_fileNamePrefix;
      String i_makefileParams_platform;
      SimCode.SimCode i_simCode;
      list<String> i_makefileParams_libs;
      String i_modelInfo_directory;
      Tpl.Text l_thirdPartyInclude;
      Tpl.Text l_platformstr;
      Tpl.Text txt_5;
      Tpl.Text l_compilecmds;
      Tpl.Text l_libsPos2;
      Tpl.Text l_libsPos1;
      Tpl.Text l_libsStr;
      Tpl.Text l_dirExtra;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(varInfo = SimCode.VARINFO(numZeroCrossings = _), directory = i_modelInfo_directory), delayedExps = SimCode.DELAYED_EXPRESSIONS(maxDelayedIndex = _), makefileParams = SimCodeFunction.MAKEFILE_PARAMS(libs = i_makefileParams_libs, platform = i_makefileParams_platform, omhome = i_makefileParams_omhome, includes = i_makefileParams_includes), simulationSettingsOpt = _, fmiSimulationFlags = i_fmiSimulationFlags, fileNamePrefix = i_fileNamePrefix, fmuTargetName = i_fmuTargetName)),
           a_common,
           a_FMUVersion )
      equation
        l_dirExtra = fun_259(Tpl.emptyTxt, i_modelInfo_directory);
        l_libsStr = Tpl.pushIter(Tpl.emptyTxt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(" ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        l_libsStr = lm_260(l_libsStr, i_makefileParams_libs);
        l_libsStr = Tpl.popIter(l_libsStr);
        l_libsPos1 = fun_261(Tpl.emptyTxt, l_dirExtra, l_libsStr);
        l_libsPos2 = fun_262(Tpl.emptyTxt, l_dirExtra, l_libsStr);
        txt_5 = CodegenUtilSimulation.modelNamePrefix(Tpl.emptyTxt, i_simCode);
        l_compilecmds = getPlatformString2(Tpl.emptyTxt, Tpl.textString(txt_5), i_makefileParams_platform, i_fileNamePrefix, i_fmuTargetName, Tpl.textString(l_dirExtra), Tpl.textString(l_libsPos1), Tpl.textString(l_libsPos2), i_makefileParams_omhome, a_FMUVersion);
        l_platformstr = Tpl.writeStr(Tpl.emptyTxt, i_makefileParams_platform);
        l_thirdPartyInclude = fun_263(Tpl.emptyTxt, i_fmiSimulationFlags);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "# Makefile generated by OpenModelica\n",
                                    "CC=@CC@\n",
                                    "AR=@AR@\n",
                                    "CFLAGS=@CFLAGS@\n",
                                    "LD=$(CC) -shared\n",
                                    "# define OMC_LDFLAGS_LINK_TYPE env variable to override this\n",
                                    "OMC_LDFLAGS_LINK_TYPE=static\n",
                                    "LDFLAGS=@LDFLAGS@ @LIBS@\n",
                                    "DLLEXT=@DLLEXT@\n",
                                    "NEED_RUNTIME=@NEED_RUNTIME@\n",
                                    "NEED_DGESV=@NEED_DGESV@\n",
                                    "NEED_SUNDIALS=@NEED_SUNDIALS@\n",
                                    "FMIPLATFORM=@FMIPLATFORM@\n",
                                    "# Note: Simulation of the fmu with dymola does not work with -finline-small-functions (enabled by most optimization levels)\n",
                                    "CPPFLAGS=@CPPFLAGS@\n",
                                    "\n",
                                    "override CPPFLAGS += "
                                }, false));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(" ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_264(txt, i_makefileParams_includes);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = Tpl.writeText(txt, a_common);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "PHONY: "
                                }, false));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_FMU\n"));
        txt = Tpl.writeText(txt, l_compilecmds);
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_265;

protected function fun_266
  input Tpl.Text in_txt;
  input String in_mArg;
  input String in_a_target;
  input Tpl.Text in_a_common;
  input String in_a_FMUVersion;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_target, in_a_common, in_a_FMUVersion, in_a_simCode)
    local
      Tpl.Text txt;
      String a_target;
      Tpl.Text a_common;
      String a_FMUVersion;
      SimCode.SimCode a_simCode;
      Tpl.Text txt_0;

    case ( txt,
           "msvc",
           _,
           a_common,
           a_FMUVersion,
           a_simCode )
      equation
        txt = fun_258(txt, a_simCode, a_common, a_FMUVersion);
      then txt;

    case ( txt,
           "gcc",
           _,
           a_common,
           a_FMUVersion,
           a_simCode )
      equation
        txt = fun_265(txt, a_simCode, a_common, a_FMUVersion);
      then txt;

    case ( txt,
           _,
           a_target,
           _,
           _,
           _ )
      equation
        txt_0 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("target "));
        txt_0 = Tpl.writeStr(txt_0, a_target);
        txt_0 = Tpl.writeTok(txt_0, Tpl.ST_STRING(" is not handled!"));
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenFMU.tpl", 1370, 11), Tpl.textString(txt_0));
      then txt;
  end match;
end fun_266;

public function fmuMakefile
  input Tpl.Text txt;
  input String a_target;
  input SimCode.SimCode a_simCode;
  input String a_FMUVersion;
  input list<String> a_sourceFiles;
  input list<String> a_runtimeObjectFiles;
  input list<String> a_dgesvObjectFiles;
  input list<String> a_sundialsObjectFiles;

  output Tpl.Text out_txt;
protected
  String str_2;
  Tpl.Text txt_1;
  Tpl.Text l_common;
algorithm
  l_common := fun_250(Tpl.emptyTxt, a_simCode, a_sundialsObjectFiles, a_runtimeObjectFiles, a_dgesvObjectFiles, a_sourceFiles);
  txt_1 := CodegenUtil.getGeneralTarget(Tpl.emptyTxt, a_target);
  str_2 := Tpl.textString(txt_1);
  out_txt := fun_266(txt, str_2, a_target, l_common, a_FMUVersion, a_simCode);
end fmuMakefile;

protected function fun_268
  input Tpl.Text in_txt;
  input String in_a_makefileParams_platform;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_makefileParams_platform)
    local
      Tpl.Text txt;

    case ( txt,
           "win32" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\"mkdir.exe\""));
      then txt;

    case ( txt,
           "win64" )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\"mkdir.exe\""));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("mkdir"));
      then txt;
  end match;
end fun_268;

protected function fun_269
  input Tpl.Text in_txt;
  input String in_mArg;
  input Absyn.Path in_a_modelInfo_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_modelInfo_name)
    local
      Tpl.Text txt;
      Absyn.Path a_modelInfo_name;

    case ( txt,
           "omsicpp",
           a_modelInfo_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("chmod +x "));
        txt = CodegenUtil.dotPath(txt, a_modelInfo_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".sh"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_269;

protected function fun_270
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Absyn.Path in_a_modelInfo_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_modelInfo_name)
    local
      Tpl.Text txt;
      Absyn.Path a_modelInfo_name;
      String ret_0;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_modelInfo_name )
      equation
        ret_0 = Config.simCodeTarget();
        txt = fun_269(txt, ret_0, a_modelInfo_name);
      then txt;
  end match;
end fun_270;

protected function fun_271
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      Absyn.Path i_modelInfo_name;
      String i_makefileParams_omhome;
      String i_makefileParams_platform;
      String i_fileNamePrefix;
      Boolean ret_5;
      Boolean ret_4;
      Boolean ret_3;
      Boolean ret_2;
      Tpl.Text l_mkdir;
      Tpl.Text l_includedir;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = i_modelInfo_name), makefileParams = SimCodeFunction.MAKEFILE_PARAMS(platform = i_makefileParams_platform, omhome = i_makefileParams_omhome), simulationSettingsOpt = _, fileNamePrefix = i_fileNamePrefix) )
      equation
        l_includedir = Tpl.writeStr(Tpl.emptyTxt, i_fileNamePrefix);
        l_includedir = Tpl.writeTok(l_includedir, Tpl.ST_STRING(".fmutmp/sources/"));
        l_mkdir = fun_268(Tpl.emptyTxt, i_makefileParams_platform);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "# FIXME: before you push into master...\n",
                                    "RUNTIMEDIR="
                                }, false));
        txt = Tpl.writeStr(txt, i_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "/include/omc/c/\n",
                                    "#COPY_RUNTIMEFILES=$(FMI_ME_OBJS:%= && (OMCFILE=% && cp $(RUNTIMEDIR)/$$OMCFILE.c $$OMCFILE.c))\n",
                                    "\n",
                                    "fmu:\n"
                                }, true));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("rm -f "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".fmutmp/sources/"));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_init.xml\n"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("cp -a \""));
        txt = Tpl.writeStr(txt, i_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("/share/omc/runtime/c/fmi/buildproject/\"* "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(".fmutmp/sources\n"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\t"));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("cp -a "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_FMU.libs "));
        txt = Tpl.writeStr(txt, i_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(".fmutmp/sources/\n"));
        ret_2 = stringEq(i_makefileParams_platform, "win32");
        ret_3 = stringEq(i_makefileParams_platform, "win64");
        ret_4 = boolOr(ret_2, ret_3);
        ret_5 = boolNot(ret_4);
        txt = fun_270(txt, ret_5, i_modelInfo_name);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_271;

public function fmuSourceMakefile
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input String a_FMUVersion;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_271(txt, a_simCode);
end fmuSourceMakefile;

protected function fun_273
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_fileNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_fileNamePrefix)
    local
      Tpl.Text txt;
      String a_fileNamePrefix;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_fileNamePrefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";***************************************************\n",
                                    "; Experimetnal function for FMI for ModelExchange\n",
                                    ";****************************************************\n"
                                }, true));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_fmiGetSpecificDerivatives @45"));
      then txt;
  end match;
end fun_273;

protected function fun_274
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_fileNamePrefix;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_fileNamePrefix)
    local
      Tpl.Text txt;
      String a_fileNamePrefix;
      Boolean ret_0;

    case ( txt,
           false,
           a_fileNamePrefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("EXPORTS\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_fmiCompletedIntegratorStep @1\n"));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_fmiEventUpdate @2\n"));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_fmiFreeModelInstance @3\n"));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_fmiGetBoolean @4\n"));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_fmiGetContinuousStates @5\n"));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_fmiGetDerivatives @6\n"));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_fmiGetEventIndicators @7\n"));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_fmiGetInteger @8\n"));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_fmiGetModelTypesPlatform @9\n"));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_fmiGetNominalContinuousStates @10\n"));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_fmiGetReal @11\n"));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_fmiGetStateValueReferences @12\n"));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_fmiGetString @13\n"));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_fmiGetVersion @14\n"));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_fmiInitialize @15\n"));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_fmiInstantiateModel @16\n"));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_fmiSetBoolean @17\n"));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_fmiSetContinuousStates @18\n"));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_fmiSetDebugLogging @19\n"));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_fmiSetExternalFunction @20\n"));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_fmiSetInteger @21\n"));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_fmiSetReal @22\n"));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_fmiSetString @23\n"));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_fmiSetTime @24\n"));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_fmiTerminate @25"));
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           _,
           a_fileNamePrefix )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "EXPORTS\n",
                                    "  ;***************************************************\n",
                                    "  ;Common Functions\n",
                                    "  ;****************************************************\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_fmiGetTypesPlatform @1\n"));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_fmiGetVersion @2\n"));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_fmiSetDebugLogging @3\n"));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_fmiInstantiate @4\n"));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_fmiFreeInstance @5\n"));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_fmiSetupExperiment @6\n"));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_fmiEnterInitializationMode @7\n"));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_fmiExitInitializationMode @8\n"));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_fmiTerminate @9\n"));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_fmiReset @10\n"));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_fmiGetReal @11\n"));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_fmiGetInteger @12\n"));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_fmiGetBoolean @13\n"));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_fmiGetString @14\n"));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_fmiSetReal @15\n"));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_fmiSetInteger @16\n"));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_fmiSetBoolean @17\n"));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_fmiSetString @18\n"));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_fmiGetFMUstate @19\n"));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_fmiSetFMUstate @20\n"));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_fmiFreeFMUstate @21\n"));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_fmiSerializedFMUstateSize @22\n"));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_fmiSerializeFMUstate @23\n"));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_fmiDeSerializeFMUstate @24\n"));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_fmiGetDirectionalDerivative @25\n",
                                    ";***************************************************\n",
                                    ";Functions for FMI for Model Exchange\n",
                                    ";****************************************************\n"
                                }, true));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_fmiEnterEventMode @26\n"));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_fmiNewDiscreteStates @27\n"));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_fmiEnterContinuousTimeMode @28\n"));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_fmiCompletedIntegratorStep @29\n"));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_fmiSetTime @30\n"));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_fmiSetContinuousStates @31\n"));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_fmiGetDerivatives @32\n"));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_fmiGetEventIndicators @33\n"));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_fmiGetContinuousStates @34\n"));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_fmiGetNominalsOfContinuousStates @35\n",
                                    ";***************************************************\n",
                                    ";Functions for FMI for Co-Simulation\n",
                                    ";****************************************************\n"
                                }, true));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_fmiSetRealInputDerivatives @36\n"));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_fmiGetRealOutputDerivatives @37\n"));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_fmiDoStep @38\n"));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_fmiCancelStep @39\n"));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_fmiGetStatus @40\n"));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_fmiGetRealStatus @41\n"));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_fmiGetIntegerStatus @42\n"));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_fmiGetBooleanStatus @43\n"));
        txt = Tpl.writeStr(txt, a_fileNamePrefix);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_fmiGetStringStatus @44\n"));
        ret_0 = Flags.isSet(Flags.FMU_EXPERIMENTAL);
        txt = fun_273(txt, ret_0, a_fileNamePrefix);
        txt = Tpl.popBlock(txt);
      then txt;
  end match;
end fun_274;

public function fmudeffile
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;
  input String in_a_FMUVersion;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode, in_a_FMUVersion)
    local
      Tpl.Text txt;
      String a_FMUVersion;
      String i_fileNamePrefix;
      Boolean ret_0;

    case ( txt,
           SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(name = _), makefileParams = SimCodeFunction.MAKEFILE_PARAMS(ccompiler = _), simulationSettingsOpt = _, fileNamePrefix = i_fileNamePrefix),
           a_FMUVersion )
      equation
        ret_0 = FMI.isFMIVersion20(a_FMUVersion);
        txt = fun_274(txt, ret_0, i_fileNamePrefix);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fmudeffile;

protected function fun_276
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_fmiInfo_fmiDescription;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_fmiInfo_fmiDescription)
    local
      Tpl.Text txt;
      String a_fmiInfo_fmiDescription;

    case ( txt,
           false,
           a_fmiInfo_fmiDescription )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" \""));
        txt = Tpl.writeStr(txt, a_fmiInfo_fmiDescription);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_276;

public function importFMUModelDescription
  input Tpl.Text in_txt;
  input FMI.FmiImport in_a_fmi;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fmi)
    local
      Tpl.Text txt;
      Boolean i_generateOutputConnectors;
      Boolean i_generateInputConnectors;
      list<FMI.ModelVariables> i_fmiModelVariablesList;
      list<FMI.TypeDefinitions> i_fmiTypeDefinitionsList;
      String i_fmiInfo_fmiDescription;
      String i_fmiInfo_fmiModelIdentifier;
      Boolean ret_0;

    case ( txt,
           FMI.FMIIMPORT(fmiInfo = FMI.INFO(fmiModelIdentifier = i_fmiInfo_fmiModelIdentifier, fmiDescription = i_fmiInfo_fmiDescription), fmiExperimentAnnotation = FMI.EXPERIMENTANNOTATION(fmiExperimentStartTime = _), fmiTypeDefinitionsList = i_fmiTypeDefinitionsList, fmiModelVariablesList = i_fmiModelVariablesList, generateInputConnectors = i_generateInputConnectors, generateOutputConnectors = i_generateOutputConnectors) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("model "));
        txt = Tpl.writeStr(txt, i_fmiInfo_fmiModelIdentifier);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_Input_Output_FMU"));
        ret_0 = stringEq(i_fmiInfo_fmiDescription, "");
        txt = fun_276(txt, ret_0, i_fmiInfo_fmiDescription);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = dumpFMITypeDefinitions(txt, i_fmiTypeDefinitionsList);
        txt = Tpl.softNewLine(txt);
        txt = dumpFMUModelDescriptionVariablesList(txt, "1.0", i_fmiModelVariablesList, i_fmiTypeDefinitionsList, i_generateInputConnectors, i_generateOutputConnectors);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("end "));
        txt = Tpl.writeStr(txt, i_fmiInfo_fmiModelIdentifier);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_Input_Output_FMU;"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end importFMUModelDescription;

protected function lm_278
  input Tpl.Text in_txt;
  input list<FMI.ModelVariables> in_items;
  input Boolean in_a_generateOutputConnectors;
  input Boolean in_a_generateInputConnectors;
  input list<FMI.TypeDefinitions> in_a_fmiTypeDefinitionsList;
  input String in_a_FMUVersion;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_generateOutputConnectors, in_a_generateInputConnectors, in_a_fmiTypeDefinitionsList, in_a_FMUVersion)
    local
      Tpl.Text txt;
      list<FMI.ModelVariables> rest;
      Boolean a_generateOutputConnectors;
      Boolean a_generateInputConnectors;
      list<FMI.TypeDefinitions> a_fmiTypeDefinitionsList;
      String a_FMUVersion;
      FMI.ModelVariables i_fmiModelVariable;

    case ( txt,
           {},
           _,
           _,
           _,
           _ )
      then txt;

    case ( txt,
           i_fmiModelVariable :: rest,
           a_generateOutputConnectors,
           a_generateInputConnectors,
           a_fmiTypeDefinitionsList,
           a_FMUVersion )
      equation
        txt = dumpFMUModelDescriptionVariable(txt, a_FMUVersion, i_fmiModelVariable, a_fmiTypeDefinitionsList, a_generateInputConnectors, a_generateOutputConnectors);
        txt = Tpl.nextIter(txt);
        txt = lm_278(txt, rest, a_generateOutputConnectors, a_generateInputConnectors, a_fmiTypeDefinitionsList, a_FMUVersion);
      then txt;
  end match;
end lm_278;

public function dumpFMUModelDescriptionVariablesList
  input Tpl.Text txt;
  input String a_FMUVersion;
  input list<FMI.ModelVariables> a_fmiModelVariablesList;
  input list<FMI.TypeDefinitions> a_fmiTypeDefinitionsList;
  input Boolean a_generateInputConnectors;
  input Boolean a_generateOutputConnectors;

  output Tpl.Text out_txt;
algorithm
  out_txt := Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_278(out_txt, a_fmiModelVariablesList, a_generateOutputConnectors, a_generateInputConnectors, a_fmiTypeDefinitionsList, a_FMUVersion);
  out_txt := Tpl.popIter(out_txt);
end dumpFMUModelDescriptionVariablesList;

protected function fun_280
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("true"));
      then txt;
  end match;
end fun_280;

protected function fun_281
  input Tpl.Text in_txt;
  input Tpl.Text in_a_isInputOrOutput;
  input Integer in_a_y2Placement;
  input Integer in_a_y1Placement;
  input Integer in_a_x2Placement;
  input Integer in_a_x1Placement;
  input String in_a_description;
  input Boolean in_a_generateOutputConnectors;
  input Boolean in_a_generateInputConnectors;
  input String in_a_baseType;
  input String in_a_causality;
  input String in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_isInputOrOutput, in_a_y2Placement, in_a_y1Placement, in_a_x2Placement, in_a_x1Placement, in_a_description, in_a_generateOutputConnectors, in_a_generateInputConnectors, in_a_baseType, in_a_causality, in_a_name)
    local
      Tpl.Text txt;
      Integer a_y2Placement;
      Integer a_y1Placement;
      Integer a_x2Placement;
      Integer a_x1Placement;
      String a_description;
      Boolean a_generateOutputConnectors;
      Boolean a_generateInputConnectors;
      String a_baseType;
      String a_causality;
      String a_name;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           _,
           _,
           _,
           _,
           _,
           _,
           _,
           _,
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_y2Placement,
           a_y1Placement,
           a_x2Placement,
           a_x1Placement,
           a_description,
           a_generateOutputConnectors,
           a_generateInputConnectors,
           a_baseType,
           a_causality,
           a_name )
      equation
        txt = dumpFMUModelDescriptionInputOutputVariable(txt, a_name, a_causality, a_baseType, a_generateInputConnectors, a_generateOutputConnectors);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = dumpFMIModelVariableDescription(txt, a_description);
        txt = dumpFMIModelVariablePlacementAnnotation(txt, a_x1Placement, a_x2Placement, a_y1Placement, a_y2Placement, a_generateInputConnectors, a_generateOutputConnectors, a_causality);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_281;

protected function fun_282
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("true"));
      then txt;
  end match;
end fun_282;

protected function fun_283
  input Tpl.Text in_txt;
  input Tpl.Text in_a_isInputOrOutput;
  input Integer in_a_y2Placement;
  input Integer in_a_y1Placement;
  input Integer in_a_x2Placement;
  input Integer in_a_x1Placement;
  input String in_a_description;
  input Boolean in_a_generateOutputConnectors;
  input Boolean in_a_generateInputConnectors;
  input String in_a_baseType;
  input String in_a_causality;
  input String in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_isInputOrOutput, in_a_y2Placement, in_a_y1Placement, in_a_x2Placement, in_a_x1Placement, in_a_description, in_a_generateOutputConnectors, in_a_generateInputConnectors, in_a_baseType, in_a_causality, in_a_name)
    local
      Tpl.Text txt;
      Integer a_y2Placement;
      Integer a_y1Placement;
      Integer a_x2Placement;
      Integer a_x1Placement;
      String a_description;
      Boolean a_generateOutputConnectors;
      Boolean a_generateInputConnectors;
      String a_baseType;
      String a_causality;
      String a_name;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           _,
           _,
           _,
           _,
           _,
           _,
           _,
           _,
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_y2Placement,
           a_y1Placement,
           a_x2Placement,
           a_x1Placement,
           a_description,
           a_generateOutputConnectors,
           a_generateInputConnectors,
           a_baseType,
           a_causality,
           a_name )
      equation
        txt = dumpFMUModelDescriptionInputOutputVariable(txt, a_name, a_causality, a_baseType, a_generateInputConnectors, a_generateOutputConnectors);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = dumpFMIModelVariableDescription(txt, a_description);
        txt = dumpFMIModelVariablePlacementAnnotation(txt, a_x1Placement, a_x2Placement, a_y1Placement, a_y2Placement, a_generateInputConnectors, a_generateOutputConnectors, a_causality);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_283;

protected function fun_284
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("true"));
      then txt;
  end match;
end fun_284;

protected function fun_285
  input Tpl.Text in_txt;
  input Tpl.Text in_a_isInputOrOutput;
  input Integer in_a_y2Placement;
  input Integer in_a_y1Placement;
  input Integer in_a_x2Placement;
  input Integer in_a_x1Placement;
  input String in_a_description;
  input Boolean in_a_generateOutputConnectors;
  input Boolean in_a_generateInputConnectors;
  input String in_a_baseType;
  input String in_a_causality;
  input String in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_isInputOrOutput, in_a_y2Placement, in_a_y1Placement, in_a_x2Placement, in_a_x1Placement, in_a_description, in_a_generateOutputConnectors, in_a_generateInputConnectors, in_a_baseType, in_a_causality, in_a_name)
    local
      Tpl.Text txt;
      Integer a_y2Placement;
      Integer a_y1Placement;
      Integer a_x2Placement;
      Integer a_x1Placement;
      String a_description;
      Boolean a_generateOutputConnectors;
      Boolean a_generateInputConnectors;
      String a_baseType;
      String a_causality;
      String a_name;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           _,
           _,
           _,
           _,
           _,
           _,
           _,
           _,
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_y2Placement,
           a_y1Placement,
           a_x2Placement,
           a_x1Placement,
           a_description,
           a_generateOutputConnectors,
           a_generateInputConnectors,
           a_baseType,
           a_causality,
           a_name )
      equation
        txt = dumpFMUModelDescriptionInputOutputVariable(txt, a_name, a_causality, a_baseType, a_generateInputConnectors, a_generateOutputConnectors);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = dumpFMIModelVariableDescription(txt, a_description);
        txt = dumpFMIModelVariablePlacementAnnotation(txt, a_x1Placement, a_x2Placement, a_y1Placement, a_y2Placement, a_generateInputConnectors, a_generateOutputConnectors, a_causality);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_285;

protected function fun_286
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("true"));
      then txt;
  end match;
end fun_286;

protected function fun_287
  input Tpl.Text in_txt;
  input Tpl.Text in_a_isInputOrOutput;
  input Integer in_a_y2Placement;
  input Integer in_a_y1Placement;
  input Integer in_a_x2Placement;
  input Integer in_a_x1Placement;
  input String in_a_description;
  input Boolean in_a_generateOutputConnectors;
  input Boolean in_a_generateInputConnectors;
  input String in_a_baseType;
  input String in_a_causality;
  input String in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_isInputOrOutput, in_a_y2Placement, in_a_y1Placement, in_a_x2Placement, in_a_x1Placement, in_a_description, in_a_generateOutputConnectors, in_a_generateInputConnectors, in_a_baseType, in_a_causality, in_a_name)
    local
      Tpl.Text txt;
      Integer a_y2Placement;
      Integer a_y1Placement;
      Integer a_x2Placement;
      Integer a_x1Placement;
      String a_description;
      Boolean a_generateOutputConnectors;
      Boolean a_generateInputConnectors;
      String a_baseType;
      String a_causality;
      String a_name;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           _,
           _,
           _,
           _,
           _,
           _,
           _,
           _,
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_y2Placement,
           a_y1Placement,
           a_x2Placement,
           a_x1Placement,
           a_description,
           a_generateOutputConnectors,
           a_generateInputConnectors,
           a_baseType,
           a_causality,
           a_name )
      equation
        txt = dumpFMUModelDescriptionInputOutputVariable(txt, a_name, a_causality, a_baseType, a_generateInputConnectors, a_generateOutputConnectors);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = dumpFMIModelVariableDescription(txt, a_description);
        txt = dumpFMIModelVariablePlacementAnnotation(txt, a_x1Placement, a_x2Placement, a_y1Placement, a_y2Placement, a_generateInputConnectors, a_generateOutputConnectors, a_causality);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_287;

protected function fun_288
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("true"));
      then txt;
  end match;
end fun_288;

protected function fun_289
  input Tpl.Text in_txt;
  input Tpl.Text in_a_isInputOrOutput;
  input Integer in_a_y2Placement;
  input Integer in_a_y1Placement;
  input Integer in_a_x2Placement;
  input Integer in_a_x1Placement;
  input String in_a_description;
  input Boolean in_a_generateOutputConnectors;
  input Boolean in_a_generateInputConnectors;
  input String in_a_baseType;
  input String in_a_causality;
  input String in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_isInputOrOutput, in_a_y2Placement, in_a_y1Placement, in_a_x2Placement, in_a_x1Placement, in_a_description, in_a_generateOutputConnectors, in_a_generateInputConnectors, in_a_baseType, in_a_causality, in_a_name)
    local
      Tpl.Text txt;
      Integer a_y2Placement;
      Integer a_y1Placement;
      Integer a_x2Placement;
      Integer a_x1Placement;
      String a_description;
      Boolean a_generateOutputConnectors;
      Boolean a_generateInputConnectors;
      String a_baseType;
      String a_causality;
      String a_name;

    case ( txt,
           Tpl.MEM_TEXT(tokens = {}),
           _,
           _,
           _,
           _,
           _,
           _,
           _,
           _,
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_y2Placement,
           a_y1Placement,
           a_x2Placement,
           a_x1Placement,
           a_description,
           a_generateOutputConnectors,
           a_generateInputConnectors,
           a_baseType,
           a_causality,
           a_name )
      equation
        txt = dumpFMUModelDescriptionInputOutputVariable(txt, a_name, a_causality, a_baseType, a_generateInputConnectors, a_generateOutputConnectors);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = dumpFMIModelVariableDescription(txt, a_description);
        txt = dumpFMIModelVariablePlacementAnnotation(txt, a_x1Placement, a_x2Placement, a_y1Placement, a_y2Placement, a_generateInputConnectors, a_generateOutputConnectors, a_causality);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_289;

protected function fun_290
  input Tpl.Text in_txt;
  input FMI.ModelVariables in_a_fmiModelVariable;
  input Boolean in_a_generateOutputConnectors;
  input Boolean in_a_generateInputConnectors;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fmiModelVariable, in_a_generateOutputConnectors, in_a_generateInputConnectors)
    local
      Tpl.Text txt;
      Boolean a_generateOutputConnectors;
      Boolean a_generateInputConnectors;
      Integer i_y2Placement;
      Integer i_y1Placement;
      Integer i_x2Placement;
      Integer i_x1Placement;
      String i_description;
      String i_baseType;
      String i_name;
      String i_causality;
      Boolean ret_15;
      Boolean ret_14;
      Boolean ret_13;
      Boolean ret_12;
      Boolean ret_11;
      Boolean ret_10;
      Boolean ret_9;
      Boolean ret_8;
      Boolean ret_7;
      Boolean ret_6;
      Boolean ret_5;
      Boolean ret_4;
      Boolean ret_3;
      Boolean ret_2;
      Boolean ret_1;
      Tpl.Text l_isInputOrOutput;

    case ( txt,
           FMI.REALVARIABLE(causality = i_causality, name = i_name, baseType = i_baseType, description = i_description, x1Placement = i_x1Placement, x2Placement = i_x2Placement, y1Placement = i_y1Placement, y2Placement = i_y2Placement),
           a_generateOutputConnectors,
           a_generateInputConnectors )
      equation
        ret_1 = stringEq(i_causality, "input");
        ret_2 = stringEq(i_causality, "output");
        ret_3 = boolOr(ret_1, ret_2);
        l_isInputOrOutput = fun_280(Tpl.emptyTxt, ret_3);
        txt = fun_281(txt, l_isInputOrOutput, i_y2Placement, i_y1Placement, i_x2Placement, i_x1Placement, i_description, a_generateOutputConnectors, a_generateInputConnectors, i_baseType, i_causality, i_name);
      then txt;

    case ( txt,
           FMI.INTEGERVARIABLE(causality = i_causality, name = i_name, baseType = i_baseType, description = i_description, x1Placement = i_x1Placement, x2Placement = i_x2Placement, y1Placement = i_y1Placement, y2Placement = i_y2Placement),
           a_generateOutputConnectors,
           a_generateInputConnectors )
      equation
        ret_4 = stringEq(i_causality, "input");
        ret_5 = stringEq(i_causality, "output");
        ret_6 = boolOr(ret_4, ret_5);
        l_isInputOrOutput = fun_282(Tpl.emptyTxt, ret_6);
        txt = fun_283(txt, l_isInputOrOutput, i_y2Placement, i_y1Placement, i_x2Placement, i_x1Placement, i_description, a_generateOutputConnectors, a_generateInputConnectors, i_baseType, i_causality, i_name);
      then txt;

    case ( txt,
           FMI.BOOLEANVARIABLE(causality = i_causality, name = i_name, baseType = i_baseType, description = i_description, x1Placement = i_x1Placement, x2Placement = i_x2Placement, y1Placement = i_y1Placement, y2Placement = i_y2Placement),
           a_generateOutputConnectors,
           a_generateInputConnectors )
      equation
        ret_7 = stringEq(i_causality, "input");
        ret_8 = stringEq(i_causality, "output");
        ret_9 = boolOr(ret_7, ret_8);
        l_isInputOrOutput = fun_284(Tpl.emptyTxt, ret_9);
        txt = fun_285(txt, l_isInputOrOutput, i_y2Placement, i_y1Placement, i_x2Placement, i_x1Placement, i_description, a_generateOutputConnectors, a_generateInputConnectors, i_baseType, i_causality, i_name);
      then txt;

    case ( txt,
           FMI.STRINGVARIABLE(causality = i_causality, name = i_name, baseType = i_baseType, description = i_description, x1Placement = i_x1Placement, x2Placement = i_x2Placement, y1Placement = i_y1Placement, y2Placement = i_y2Placement),
           a_generateOutputConnectors,
           a_generateInputConnectors )
      equation
        ret_10 = stringEq(i_causality, "input");
        ret_11 = stringEq(i_causality, "output");
        ret_12 = boolOr(ret_10, ret_11);
        l_isInputOrOutput = fun_286(Tpl.emptyTxt, ret_12);
        txt = fun_287(txt, l_isInputOrOutput, i_y2Placement, i_y1Placement, i_x2Placement, i_x1Placement, i_description, a_generateOutputConnectors, a_generateInputConnectors, i_baseType, i_causality, i_name);
      then txt;

    case ( txt,
           FMI.ENUMERATIONVARIABLE(causality = i_causality, name = i_name, baseType = i_baseType, description = i_description, x1Placement = i_x1Placement, x2Placement = i_x2Placement, y1Placement = i_y1Placement, y2Placement = i_y2Placement),
           a_generateOutputConnectors,
           a_generateInputConnectors )
      equation
        ret_13 = stringEq(i_causality, "input");
        ret_14 = stringEq(i_causality, "output");
        ret_15 = boolOr(ret_13, ret_14);
        l_isInputOrOutput = fun_288(Tpl.emptyTxt, ret_15);
        txt = fun_289(txt, l_isInputOrOutput, i_y2Placement, i_y1Placement, i_x2Placement, i_x1Placement, i_description, a_generateOutputConnectors, a_generateInputConnectors, i_baseType, i_causality, i_name);
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_290;

protected function fun_291
  input Tpl.Text in_txt;
  input String in_a_FMUVersion;
  input FMI.ModelVariables in_a_fmiModelVariable;
  input Boolean in_a_generateInputConnectors;
  input Boolean in_a_generateOutputConnectors;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_FMUVersion, in_a_fmiModelVariable, in_a_generateInputConnectors, in_a_generateOutputConnectors)
    local
      Tpl.Text txt;
      FMI.ModelVariables a_fmiModelVariable;
      Boolean a_generateInputConnectors;
      Boolean a_generateOutputConnectors;

    case ( txt,
           "1.0",
           a_fmiModelVariable,
           a_generateInputConnectors,
           a_generateOutputConnectors )
      equation
        txt = fun_290(txt, a_fmiModelVariable, a_generateOutputConnectors, a_generateInputConnectors);
      then txt;

    case ( txt,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_291;

public function dumpFMUModelDescriptionVariable
  input Tpl.Text txt;
  input String a_FMUVersion;
  input FMI.ModelVariables a_fmiModelVariable;
  input list<FMI.TypeDefinitions> a_fmiTypeDefinitionsList;
  input Boolean a_generateInputConnectors;
  input Boolean a_generateOutputConnectors;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_291(txt, a_FMUVersion, a_fmiModelVariable, a_generateInputConnectors, a_generateOutputConnectors);
end dumpFMUModelDescriptionVariable;

protected function fun_293
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_name)
    local
      Tpl.Text txt;
      String a_name;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Modelica.Blocks.Interfaces.BooleanOutput "));
        txt = Tpl.writeStr(txt, a_name);
      then txt;
  end match;
end fun_293;

protected function fun_294
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_name;
  input String in_a_baseType;
  input String in_a_causality;
  input Boolean in_a_generateOutputConnectors;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_name, in_a_baseType, in_a_causality, in_a_generateOutputConnectors)
    local
      Tpl.Text txt;
      String a_name;
      String a_baseType;
      String a_causality;
      Boolean a_generateOutputConnectors;
      Boolean ret_3;
      Boolean ret_2;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           false,
           a_name,
           a_baseType,
           a_causality,
           a_generateOutputConnectors )
      equation
        ret_0 = stringEq(a_causality, "output");
        ret_1 = stringEq(a_baseType, "Boolean");
        ret_2 = boolAnd(ret_0, ret_1);
        ret_3 = boolAnd(a_generateOutputConnectors, ret_2);
        txt = fun_293(txt, ret_3, a_name);
      then txt;

    case ( txt,
           _,
           a_name,
           _,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Modelica.Blocks.Interfaces.IntegerOutput "));
        txt = Tpl.writeStr(txt, a_name);
      then txt;
  end match;
end fun_294;

protected function fun_295
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_name;
  input String in_a_baseType;
  input String in_a_causality;
  input Boolean in_a_generateOutputConnectors;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_name, in_a_baseType, in_a_causality, in_a_generateOutputConnectors)
    local
      Tpl.Text txt;
      String a_name;
      String a_baseType;
      String a_causality;
      Boolean a_generateOutputConnectors;
      Boolean ret_3;
      Boolean ret_2;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           false,
           a_name,
           a_baseType,
           a_causality,
           a_generateOutputConnectors )
      equation
        ret_0 = stringEq(a_causality, "output");
        ret_1 = stringEq(a_baseType, "Integer");
        ret_2 = boolAnd(ret_0, ret_1);
        ret_3 = boolAnd(a_generateOutputConnectors, ret_2);
        txt = fun_294(txt, ret_3, a_name, a_baseType, a_causality, a_generateOutputConnectors);
      then txt;

    case ( txt,
           _,
           a_name,
           _,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Modelica.Blocks.Interfaces.RealOutput "));
        txt = Tpl.writeStr(txt, a_name);
      then txt;
  end match;
end fun_295;

protected function fun_296
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_name;
  input String in_a_baseType;
  input String in_a_causality;
  input Boolean in_a_generateOutputConnectors;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_name, in_a_baseType, in_a_causality, in_a_generateOutputConnectors)
    local
      Tpl.Text txt;
      String a_name;
      String a_baseType;
      String a_causality;
      Boolean a_generateOutputConnectors;
      Boolean ret_3;
      Boolean ret_2;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           false,
           a_name,
           a_baseType,
           a_causality,
           a_generateOutputConnectors )
      equation
        ret_0 = stringEq(a_causality, "output");
        ret_1 = stringEq(a_baseType, "Real");
        ret_2 = boolAnd(ret_0, ret_1);
        ret_3 = boolAnd(a_generateOutputConnectors, ret_2);
        txt = fun_295(txt, ret_3, a_name, a_baseType, a_causality, a_generateOutputConnectors);
      then txt;

    case ( txt,
           _,
           a_name,
           _,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Modelica.Blocks.Interfaces.BooleanInput "));
        txt = Tpl.writeStr(txt, a_name);
      then txt;
  end match;
end fun_296;

protected function fun_297
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_name;
  input Boolean in_a_generateOutputConnectors;
  input String in_a_baseType;
  input String in_a_causality;
  input Boolean in_a_generateInputConnectors;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_name, in_a_generateOutputConnectors, in_a_baseType, in_a_causality, in_a_generateInputConnectors)
    local
      Tpl.Text txt;
      String a_name;
      Boolean a_generateOutputConnectors;
      String a_baseType;
      String a_causality;
      Boolean a_generateInputConnectors;
      Boolean ret_3;
      Boolean ret_2;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           false,
           a_name,
           a_generateOutputConnectors,
           a_baseType,
           a_causality,
           a_generateInputConnectors )
      equation
        ret_0 = stringEq(a_causality, "input");
        ret_1 = stringEq(a_baseType, "Boolean");
        ret_2 = boolAnd(ret_0, ret_1);
        ret_3 = boolAnd(a_generateInputConnectors, ret_2);
        txt = fun_296(txt, ret_3, a_name, a_baseType, a_causality, a_generateOutputConnectors);
      then txt;

    case ( txt,
           _,
           a_name,
           _,
           _,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Modelica.Blocks.Interfaces.IntegerInput "));
        txt = Tpl.writeStr(txt, a_name);
      then txt;
  end match;
end fun_297;

protected function fun_298
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_name;
  input String in_a_causality;
  input String in_a_baseType;
  input Boolean in_a_generateInputConnectors;
  input Boolean in_a_generateOutputConnectors;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_name, in_a_causality, in_a_baseType, in_a_generateInputConnectors, in_a_generateOutputConnectors)
    local
      Tpl.Text txt;
      String a_name;
      String a_causality;
      String a_baseType;
      Boolean a_generateInputConnectors;
      Boolean a_generateOutputConnectors;
      Boolean ret_3;
      Boolean ret_2;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           false,
           a_name,
           a_causality,
           a_baseType,
           a_generateInputConnectors,
           a_generateOutputConnectors )
      equation
        ret_0 = stringEq(a_causality, "input");
        ret_1 = stringEq(a_baseType, "Integer");
        ret_2 = boolAnd(ret_0, ret_1);
        ret_3 = boolAnd(a_generateInputConnectors, ret_2);
        txt = fun_297(txt, ret_3, a_name, a_generateOutputConnectors, a_baseType, a_causality, a_generateInputConnectors);
      then txt;

    case ( txt,
           _,
           a_name,
           _,
           _,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Modelica.Blocks.Interfaces.RealInput "));
        txt = Tpl.writeStr(txt, a_name);
      then txt;
  end match;
end fun_298;

public function dumpFMUModelDescriptionInputOutputVariable
  input Tpl.Text txt;
  input String a_name;
  input String a_causality;
  input String a_baseType;
  input Boolean a_generateInputConnectors;
  input Boolean a_generateOutputConnectors;

  output Tpl.Text out_txt;
protected
  Boolean ret_3;
  Boolean ret_2;
  Boolean ret_1;
  Boolean ret_0;
algorithm
  ret_0 := stringEq(a_causality, "input");
  ret_1 := stringEq(a_baseType, "Real");
  ret_2 := boolAnd(ret_0, ret_1);
  ret_3 := boolAnd(a_generateInputConnectors, ret_2);
  out_txt := fun_298(txt, ret_3, a_name, a_causality, a_baseType, a_generateInputConnectors, a_generateOutputConnectors);
end dumpFMUModelDescriptionInputOutputVariable;

protected function fun_300
  input Tpl.Text in_txt;
  input FMI.Info in_a_fmiInfo;
  input FMI.FmiImport in_a_fmi;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fmiInfo, in_a_fmi)
    local
      Tpl.Text txt;
      FMI.FmiImport a_fmi;

    case ( txt,
           FMI.INFO(fmiVersion = "1.0", fmiType = 0),
           a_fmi )
      equation
        txt = importFMU1ModelExchange(txt, a_fmi);
      then txt;

    case ( txt,
           FMI.INFO(fmiVersion = "1.0", fmiType = 1),
           a_fmi )
      equation
        txt = importFMU1CoSimulationStandAlone(txt, a_fmi);
      then txt;

    case ( txt,
           FMI.INFO(fmiVersion = "2.0", fmiType = 1),
           a_fmi )
      equation
        txt = importFMU2ModelExchange(txt, a_fmi);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_300;

public function importFMUModelica
  input Tpl.Text in_txt;
  input FMI.FmiImport in_a_fmi;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fmi)
    local
      Tpl.Text txt;
      FMI.FmiImport i_fmi;
      FMI.Info i_fmiInfo;

    case ( txt,
           (i_fmi as FMI.FMIIMPORT(fmiInfo = i_fmiInfo)) )
      equation
        txt = fun_300(txt, i_fmiInfo, i_fmi);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end importFMUModelica;

protected function fun_302
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_fmiInfo_fmiDescription;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_fmiInfo_fmiDescription)
    local
      Tpl.Text txt;
      String a_fmiInfo_fmiDescription;

    case ( txt,
           false,
           a_fmiInfo_fmiDescription )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" \""));
        txt = Tpl.writeStr(txt, a_fmiInfo_fmiDescription);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_302;

protected function fun_303
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_realInputVariablesReturnNames;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_realInputVariablesReturnNames)
    local
      Tpl.Text txt;
      Tpl.Text a_realInputVariablesReturnNames;

    case ( txt,
           false,
           a_realInputVariablesReturnNames )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Real "));
        txt = Tpl.writeText(txt, a_realInputVariablesReturnNames);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_303;

protected function fun_304
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_integerInputVariablesReturnNames;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_integerInputVariablesReturnNames)
    local
      Tpl.Text txt;
      Tpl.Text a_integerInputVariablesReturnNames;

    case ( txt,
           false,
           a_integerInputVariablesReturnNames )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Integer "));
        txt = Tpl.writeText(txt, a_integerInputVariablesReturnNames);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_304;

protected function fun_305
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_booleanInputVariablesReturnNames;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_booleanInputVariablesReturnNames)
    local
      Tpl.Text txt;
      Tpl.Text a_booleanInputVariablesReturnNames;

    case ( txt,
           false,
           a_booleanInputVariablesReturnNames )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Boolean "));
        txt = Tpl.writeText(txt, a_booleanInputVariablesReturnNames);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_305;

protected function fun_306
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_stringInputVariablesReturnNames;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_stringInputVariablesReturnNames)
    local
      Tpl.Text txt;
      Tpl.Text a_stringInputVariablesReturnNames;

    case ( txt,
           false,
           a_stringInputVariablesReturnNames )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("String "));
        txt = Tpl.writeText(txt, a_stringInputVariablesReturnNames);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_306;

protected function fun_307
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("fmi_x = fmi1Functions.fmi1GetContinuousStates(fmi1me, numberOfContinuousStates, flowParamsStart+flowInitialized);"));
      then txt;
  end match;
end fun_307;

protected function fun_308
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_realParametersNames;
  input Tpl.Text in_a_realParametersVRs;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_realParametersNames, in_a_realParametersVRs)
    local
      Tpl.Text txt;
      Tpl.Text a_realParametersNames;
      Tpl.Text a_realParametersVRs;

    case ( txt,
           false,
           a_realParametersNames,
           a_realParametersVRs )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("flowParamsStart := fmi1Functions.fmi1SetRealParameter(fmi1me, {"));
        txt = Tpl.writeText(txt, a_realParametersVRs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}, {"));
        txt = Tpl.writeText(txt, a_realParametersNames);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("});"));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_308;

protected function fun_309
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_integerParametersNames;
  input Tpl.Text in_a_integerParametersVRs;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_integerParametersNames, in_a_integerParametersVRs)
    local
      Tpl.Text txt;
      Tpl.Text a_integerParametersNames;
      Tpl.Text a_integerParametersVRs;

    case ( txt,
           false,
           a_integerParametersNames,
           a_integerParametersVRs )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("flowParamsStart := fmi1Functions.fmi1SetIntegerParameter(fmi1me, {"));
        txt = Tpl.writeText(txt, a_integerParametersVRs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}, {"));
        txt = Tpl.writeText(txt, a_integerParametersNames);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("});"));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_309;

protected function fun_310
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_booleanParametersNames;
  input Tpl.Text in_a_booleanParametersVRs;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_booleanParametersNames, in_a_booleanParametersVRs)
    local
      Tpl.Text txt;
      Tpl.Text a_booleanParametersNames;
      Tpl.Text a_booleanParametersVRs;

    case ( txt,
           false,
           a_booleanParametersNames,
           a_booleanParametersVRs )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("flowParamsStart := fmi1Functions.fmi1SetBooleanParameter(fmi1me, {"));
        txt = Tpl.writeText(txt, a_booleanParametersVRs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}, {"));
        txt = Tpl.writeText(txt, a_booleanParametersNames);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("});"));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_310;

protected function fun_311
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_stringParametersNames;
  input Tpl.Text in_a_stringParametersVRs;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_stringParametersNames, in_a_stringParametersVRs)
    local
      Tpl.Text txt;
      Tpl.Text a_stringParametersNames;
      Tpl.Text a_stringParametersVRs;

    case ( txt,
           false,
           a_stringParametersNames,
           a_stringParametersVRs )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("flowParamsStart := fmi1Functions.fmi1SetStringParameter(fmi1me, {"));
        txt = Tpl.writeText(txt, a_stringParametersVRs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}, {"));
        txt = Tpl.writeText(txt, a_stringParametersNames);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("});"));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_311;

protected function fun_312
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_realDependentParametersVRs;
  input Tpl.Text in_a_realDependentParametersNames;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_realDependentParametersVRs, in_a_realDependentParametersNames)
    local
      Tpl.Text txt;
      Tpl.Text a_realDependentParametersVRs;
      Tpl.Text a_realDependentParametersNames;

    case ( txt,
           false,
           a_realDependentParametersVRs,
           a_realDependentParametersNames )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("{"));
        txt = Tpl.writeText(txt, a_realDependentParametersNames);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("} = fmi1Functions.fmi1GetReal(fmi1me, {"));
        txt = Tpl.writeText(txt, a_realDependentParametersVRs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}, flowInitialized);"));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_312;

protected function fun_313
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_integerDependentParametersVRs;
  input Tpl.Text in_a_integerDependentParametersNames;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_integerDependentParametersVRs, in_a_integerDependentParametersNames)
    local
      Tpl.Text txt;
      Tpl.Text a_integerDependentParametersVRs;
      Tpl.Text a_integerDependentParametersNames;

    case ( txt,
           false,
           a_integerDependentParametersVRs,
           a_integerDependentParametersNames )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("{"));
        txt = Tpl.writeText(txt, a_integerDependentParametersNames);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("} = fmi1Functions.fmi1GetInteger(fmi1me, {"));
        txt = Tpl.writeText(txt, a_integerDependentParametersVRs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}, flowInitialized);"));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_313;

protected function fun_314
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_booleanDependentParametersVRs;
  input Tpl.Text in_a_booleanDependentParametersNames;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_booleanDependentParametersVRs, in_a_booleanDependentParametersNames)
    local
      Tpl.Text txt;
      Tpl.Text a_booleanDependentParametersVRs;
      Tpl.Text a_booleanDependentParametersNames;

    case ( txt,
           false,
           a_booleanDependentParametersVRs,
           a_booleanDependentParametersNames )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("{"));
        txt = Tpl.writeText(txt, a_booleanDependentParametersNames);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("} = fmi1Functions.fmi1GetBoolean(fmi1me, {"));
        txt = Tpl.writeText(txt, a_booleanDependentParametersVRs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}, flowInitialized);"));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_314;

protected function fun_315
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_stringDependentParametersVRs;
  input Tpl.Text in_a_stringDependentParametersNames;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_stringDependentParametersVRs, in_a_stringDependentParametersNames)
    local
      Tpl.Text txt;
      Tpl.Text a_stringDependentParametersVRs;
      Tpl.Text a_stringDependentParametersNames;

    case ( txt,
           false,
           a_stringDependentParametersVRs,
           a_stringDependentParametersNames )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("{"));
        txt = Tpl.writeText(txt, a_stringDependentParametersNames);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("} = fmi1Functions.fmi1GetString(fmi1me, {"));
        txt = Tpl.writeText(txt, a_stringDependentParametersVRs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}, flowInitialized);"));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_315;

protected function fun_316
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_realInputVariablesNames;
  input Tpl.Text in_a_realInputVariablesVRs;
  input Tpl.Text in_a_realInputVariablesReturnNames;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_realInputVariablesNames, in_a_realInputVariablesVRs, in_a_realInputVariablesReturnNames)
    local
      Tpl.Text txt;
      Tpl.Text a_realInputVariablesNames;
      Tpl.Text a_realInputVariablesVRs;
      Tpl.Text a_realInputVariablesReturnNames;

    case ( txt,
           false,
           a_realInputVariablesNames,
           a_realInputVariablesVRs,
           a_realInputVariablesReturnNames )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("{"));
        txt = Tpl.writeText(txt, a_realInputVariablesReturnNames);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("} = fmi1Functions.fmi1SetReal(fmi1me, {"));
        txt = Tpl.writeText(txt, a_realInputVariablesVRs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}, {"));
        txt = Tpl.writeText(txt, a_realInputVariablesNames);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("});"));
      then txt;

    case ( txt,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_316;

protected function fun_317
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_integerInputVariablesNames;
  input Tpl.Text in_a_integerInputVariablesVRs;
  input Tpl.Text in_a_integerInputVariablesReturnNames;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_integerInputVariablesNames, in_a_integerInputVariablesVRs, in_a_integerInputVariablesReturnNames)
    local
      Tpl.Text txt;
      Tpl.Text a_integerInputVariablesNames;
      Tpl.Text a_integerInputVariablesVRs;
      Tpl.Text a_integerInputVariablesReturnNames;

    case ( txt,
           false,
           a_integerInputVariablesNames,
           a_integerInputVariablesVRs,
           a_integerInputVariablesReturnNames )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("{"));
        txt = Tpl.writeText(txt, a_integerInputVariablesReturnNames);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("} = fmi1Functions.fmi1SetInteger(fmi1me, {"));
        txt = Tpl.writeText(txt, a_integerInputVariablesVRs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}, {"));
        txt = Tpl.writeText(txt, a_integerInputVariablesNames);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("});"));
      then txt;

    case ( txt,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_317;

protected function fun_318
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_booleanInputVariablesNames;
  input Tpl.Text in_a_booleanInputVariablesVRs;
  input Tpl.Text in_a_booleanInputVariablesReturnNames;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_booleanInputVariablesNames, in_a_booleanInputVariablesVRs, in_a_booleanInputVariablesReturnNames)
    local
      Tpl.Text txt;
      Tpl.Text a_booleanInputVariablesNames;
      Tpl.Text a_booleanInputVariablesVRs;
      Tpl.Text a_booleanInputVariablesReturnNames;

    case ( txt,
           false,
           a_booleanInputVariablesNames,
           a_booleanInputVariablesVRs,
           a_booleanInputVariablesReturnNames )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("{"));
        txt = Tpl.writeText(txt, a_booleanInputVariablesReturnNames);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("} = fmi1Functions.fmi1SetBoolean(fmi1me, {"));
        txt = Tpl.writeText(txt, a_booleanInputVariablesVRs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}, {"));
        txt = Tpl.writeText(txt, a_booleanInputVariablesNames);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("});"));
      then txt;

    case ( txt,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_318;

protected function fun_319
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_stringStartVariablesNames;
  input Tpl.Text in_a_stringInputVariablesVRs;
  input Tpl.Text in_a_stringInputVariablesReturnNames;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_stringStartVariablesNames, in_a_stringInputVariablesVRs, in_a_stringInputVariablesReturnNames)
    local
      Tpl.Text txt;
      Tpl.Text a_stringStartVariablesNames;
      Tpl.Text a_stringInputVariablesVRs;
      Tpl.Text a_stringInputVariablesReturnNames;

    case ( txt,
           false,
           a_stringStartVariablesNames,
           a_stringInputVariablesVRs,
           a_stringInputVariablesReturnNames )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("{"));
        txt = Tpl.writeText(txt, a_stringInputVariablesReturnNames);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("} = fmi1Functions.fmi1SetString(fmi1me, {"));
        txt = Tpl.writeText(txt, a_stringInputVariablesVRs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}, {"));
        txt = Tpl.writeText(txt, a_stringStartVariablesNames);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("});"));
      then txt;

    case ( txt,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_319;

protected function fun_320
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_realOutputVariablesVRs;
  input Tpl.Text in_a_realOutputVariablesNames;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_realOutputVariablesVRs, in_a_realOutputVariablesNames)
    local
      Tpl.Text txt;
      Tpl.Text a_realOutputVariablesVRs;
      Tpl.Text a_realOutputVariablesNames;

    case ( txt,
           false,
           a_realOutputVariablesVRs,
           a_realOutputVariablesNames )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("{"));
        txt = Tpl.writeText(txt, a_realOutputVariablesNames);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("} = fmi1Functions.fmi1GetReal(fmi1me, {"));
        txt = Tpl.writeText(txt, a_realOutputVariablesVRs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}, flowStatesInputs);"));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_320;

protected function fun_321
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_integerOutputVariablesVRs;
  input Tpl.Text in_a_integerOutputVariablesNames;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_integerOutputVariablesVRs, in_a_integerOutputVariablesNames)
    local
      Tpl.Text txt;
      Tpl.Text a_integerOutputVariablesVRs;
      Tpl.Text a_integerOutputVariablesNames;

    case ( txt,
           false,
           a_integerOutputVariablesVRs,
           a_integerOutputVariablesNames )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("{"));
        txt = Tpl.writeText(txt, a_integerOutputVariablesNames);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("} = fmi1Functions.fmi1GetInteger(fmi1me, {"));
        txt = Tpl.writeText(txt, a_integerOutputVariablesVRs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}, flowStatesInputs);"));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_321;

protected function fun_322
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_booleanOutputVariablesVRs;
  input Tpl.Text in_a_booleanOutputVariablesNames;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_booleanOutputVariablesVRs, in_a_booleanOutputVariablesNames)
    local
      Tpl.Text txt;
      Tpl.Text a_booleanOutputVariablesVRs;
      Tpl.Text a_booleanOutputVariablesNames;

    case ( txt,
           false,
           a_booleanOutputVariablesVRs,
           a_booleanOutputVariablesNames )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("{"));
        txt = Tpl.writeText(txt, a_booleanOutputVariablesNames);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("} = fmi1Functions.fmi1GetBoolean(fmi1me, {"));
        txt = Tpl.writeText(txt, a_booleanOutputVariablesVRs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}, flowStatesInputs);"));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_322;

protected function fun_323
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_stringOutputVariablesVRs;
  input Tpl.Text in_a_stringOutputVariablesNames;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_stringOutputVariablesVRs, in_a_stringOutputVariablesNames)
    local
      Tpl.Text txt;
      Tpl.Text a_stringOutputVariablesVRs;
      Tpl.Text a_stringOutputVariablesNames;

    case ( txt,
           false,
           a_stringOutputVariablesVRs,
           a_stringOutputVariablesNames )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("{"));
        txt = Tpl.writeText(txt, a_stringOutputVariablesNames);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("} = fmi1Functions.fmi1GetString(fmi1me, {"));
        txt = Tpl.writeText(txt, a_stringOutputVariablesVRs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}, flowStatesInputs);"));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_323;

protected function lm_324
  input Tpl.Text in_txt;
  input list<Integer> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<Integer> rest;
      Integer i_eventIndicator;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_eventIndicator :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("change(fmi_z_positive["));
        txt = Tpl.writeStr(txt, intString(i_eventIndicator));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("])"));
        txt = Tpl.nextIter(txt);
        txt = lm_324(txt, rest);
      then txt;
  end match;
end lm_324;

protected function fun_325
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input list<Integer> in_a_fmiInfo_fmiNumberOfEventIndicators;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_fmiInfo_fmiNumberOfEventIndicators)
    local
      Tpl.Text txt;
      list<Integer> a_fmiInfo_fmiNumberOfEventIndicators;

    case ( txt,
           false,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("  when {triggerDSSEvent > flowStatesInputs, nextEventTime < time, terminal()} then"));
      then txt;

    case ( txt,
           _,
           a_fmiInfo_fmiNumberOfEventIndicators )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("when {"));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(" or ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_324(txt, a_fmiInfo_fmiNumberOfEventIndicators);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", triggerDSSEvent > flowStatesInputs, nextEventTime < time, terminal()} then"));
        txt = Tpl.popBlock(txt);
      then txt;
  end match;
end fun_325;

protected function lm_326
  input Tpl.Text in_txt;
  input list<Integer> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<Integer> rest;
      Integer i_continuousStates;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_continuousStates :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("reinit(fmi_x["));
        txt = Tpl.writeStr(txt, intString(i_continuousStates));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("], fmi_x_new["));
        txt = Tpl.writeStr(txt, intString(i_continuousStates));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("]);"));
        txt = Tpl.nextIter(txt);
        txt = lm_326(txt, rest);
      then txt;
  end match;
end lm_326;

protected function fun_327
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input list<Integer> in_a_fmiInfo_fmiNumberOfContinuousStates;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_fmiInfo_fmiNumberOfContinuousStates)
    local
      Tpl.Text txt;
      list<Integer> a_fmiInfo_fmiNumberOfContinuousStates;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_fmiInfo_fmiNumberOfContinuousStates )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "    if newStatesAvailable then\n",
                                    "      fmi_x_new := fmi1Functions.fmi1GetContinuousStates(fmi1me, numberOfContinuousStates, flowStatesInputs);\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(6));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_326(txt, a_fmiInfo_fmiNumberOfContinuousStates);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("    end if;"));
      then txt;
  end match;
end fun_327;

public function importFMU1ModelExchange
  input Tpl.Text in_txt;
  input FMI.FmiImport in_a_fmi;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fmi)
    local
      Tpl.Text txt;
      Real i_fmiExperimentAnnotation_fmiExperimentTolerance;
      Real i_fmiExperimentAnnotation_fmiExperimentStopTime;
      Real i_fmiExperimentAnnotation_fmiExperimentStartTime;
      list<Integer> i_fmiInfo_fmiNumberOfEventIndicators;
      list<Integer> i_fmiInfo_fmiNumberOfContinuousStates;
      Boolean i_generateOutputConnectors;
      Boolean i_generateInputConnectors;
      Boolean i_fmiDebugOutput;
      Integer i_fmiLogLevel;
      String i_fmuWorkingDirectory;
      list<FMI.TypeDefinitions> i_fmiTypeDefinitionsList;
      String i_fmiInfo_fmiDescription;
      FMI.Info i_fmiInfo;
      String i_fmiInfo_fmiModelIdentifier;
      list<FMI.ModelVariables> i_fmiModelVariablesList;
      String ret_74;
      Boolean ret_73;
      Integer ret_72;
      Boolean ret_71;
      Integer ret_70;
      Boolean ret_69;
      Boolean ret_68;
      Boolean ret_67;
      Boolean ret_66;
      Boolean ret_65;
      Boolean ret_64;
      Boolean ret_63;
      Boolean ret_62;
      Boolean ret_61;
      Boolean ret_60;
      Boolean ret_59;
      Boolean ret_58;
      Boolean ret_57;
      Boolean ret_56;
      Boolean ret_55;
      Boolean ret_54;
      Boolean ret_53;
      Boolean ret_52;
      Boolean ret_51;
      Boolean ret_50;
      Boolean ret_49;
      Boolean ret_48;
      Boolean ret_47;
      Boolean ret_46;
      Boolean ret_45;
      Integer ret_44;
      Boolean ret_43;
      Boolean ret_42;
      Boolean ret_41;
      Boolean ret_40;
      Integer ret_39;
      Integer ret_38;
      Boolean ret_37;
      String ret_36;
      Tpl.Text l_stringOutputVariablesNames;
      Tpl.Text l_stringOutputVariablesVRs;
      Tpl.Text l_booleanOutputVariablesNames;
      Tpl.Text l_booleanOutputVariablesVRs;
      Tpl.Text l_integerOutputVariablesNames;
      Tpl.Text l_integerOutputVariablesVRs;
      Tpl.Text l_realOutputVariablesNames;
      Tpl.Text l_realOutputVariablesVRs;
      Tpl.Text l_stringInputVariablesReturnNames;
      Tpl.Text l_stringStartVariablesNames;
      Tpl.Text l_stringInputVariablesVRs;
      Tpl.Text l_booleanInputVariablesReturnNames;
      Tpl.Text l_booleanInputVariablesNames;
      Tpl.Text l_booleanInputVariablesVRs;
      Tpl.Text l_integerInputVariablesReturnNames;
      Tpl.Text l_integerInputVariablesNames;
      Tpl.Text l_integerInputVariablesVRs;
      Tpl.Text l_realInputVariablesReturnNames;
      Tpl.Text l_realInputVariablesNames;
      Tpl.Text l_realInputVariablesVRs;
      Tpl.Text l_stringDependentParametersNames;
      Tpl.Text l_stringDependentParametersVRs;
      Tpl.Text l_booleanDependentParametersNames;
      Tpl.Text l_booleanDependentParametersVRs;
      Tpl.Text l_integerDependentParametersNames;
      Tpl.Text l_integerDependentParametersVRs;
      Tpl.Text l_realDependentParametersNames;
      Tpl.Text l_realDependentParametersVRs;
      Tpl.Text l_stringParametersNames;
      Tpl.Text l_stringParametersVRs;
      Tpl.Text l_booleanParametersNames;
      Tpl.Text l_booleanParametersVRs;
      Tpl.Text l_integerParametersNames;
      Tpl.Text l_integerParametersVRs;
      Tpl.Text l_realParametersNames;
      Tpl.Text l_realParametersVRs;

    case ( txt,
           FMI.FMIIMPORT(fmiInfo = (i_fmiInfo as FMI.INFO(fmiModelIdentifier = i_fmiInfo_fmiModelIdentifier, fmiDescription = i_fmiInfo_fmiDescription, fmiNumberOfContinuousStates = i_fmiInfo_fmiNumberOfContinuousStates, fmiNumberOfEventIndicators = i_fmiInfo_fmiNumberOfEventIndicators)), fmiExperimentAnnotation = FMI.EXPERIMENTANNOTATION(fmiExperimentStartTime = i_fmiExperimentAnnotation_fmiExperimentStartTime, fmiExperimentStopTime = i_fmiExperimentAnnotation_fmiExperimentStopTime, fmiExperimentTolerance = i_fmiExperimentAnnotation_fmiExperimentTolerance), fmiModelVariablesList = i_fmiModelVariablesList, fmiTypeDefinitionsList = i_fmiTypeDefinitionsList, fmuWorkingDirectory = i_fmuWorkingDirectory, fmiLogLevel = i_fmiLogLevel, fmiDebugOutput = i_fmiDebugOutput, generateInputConnectors = i_generateInputConnectors, generateOutputConnectors = i_generateOutputConnectors) )
      equation
        l_realParametersVRs = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "real", "parameter", false, 1, "1.0");
        l_realParametersNames = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "real", "parameter", false, 2, "1.0");
        l_integerParametersVRs = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "integer", "parameter", false, 1, "1.0");
        l_integerParametersNames = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "integer", "parameter", false, 2, "1.0");
        l_booleanParametersVRs = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "boolean", "parameter", false, 1, "1.0");
        l_booleanParametersNames = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "boolean", "parameter", false, 2, "1.0");
        l_stringParametersVRs = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "string", "parameter", false, 1, "1.0");
        l_stringParametersNames = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "string", "parameter", false, 2, "1.0");
        l_realDependentParametersVRs = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "real", "parameter", true, 1, "1.0");
        l_realDependentParametersNames = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "real", "parameter", true, 2, "1.0");
        l_integerDependentParametersVRs = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "integer", "parameter", true, 1, "1.0");
        l_integerDependentParametersNames = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "integer", "parameter", true, 2, "1.0");
        l_booleanDependentParametersVRs = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "boolean", "parameter", true, 1, "1.0");
        l_booleanDependentParametersNames = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "boolean", "parameter", true, 2, "1.0");
        l_stringDependentParametersVRs = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "string", "parameter", true, 1, "1.0");
        l_stringDependentParametersNames = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "string", "parameter", true, 2, "1.0");
        l_realInputVariablesVRs = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "real", "input", false, 1, "1.0");
        l_realInputVariablesNames = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "real", "input", false, 2, "1.0");
        l_realInputVariablesReturnNames = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "real", "input", false, 3, "1.0");
        l_integerInputVariablesVRs = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "integer", "input", false, 1, "1.0");
        l_integerInputVariablesNames = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "integer", "input", false, 2, "1.0");
        l_integerInputVariablesReturnNames = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "integer", "input", false, 3, "1.0");
        l_booleanInputVariablesVRs = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "boolean", "input", false, 1, "1.0");
        l_booleanInputVariablesNames = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "boolean", "input", false, 2, "1.0");
        l_booleanInputVariablesReturnNames = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "boolean", "input", false, 3, "1.0");
        l_stringInputVariablesVRs = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "string", "input", false, 1, "1.0");
        l_stringStartVariablesNames = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "string", "input", false, 2, "1.0");
        l_stringInputVariablesReturnNames = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "string", "input", false, 3, "1.0");
        l_realOutputVariablesVRs = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "real", "output", false, 1, "1.0");
        l_realOutputVariablesNames = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "real", "output", false, 2, "1.0");
        l_integerOutputVariablesVRs = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "integer", "output", false, 1, "1.0");
        l_integerOutputVariablesNames = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "integer", "output", false, 2, "1.0");
        l_booleanOutputVariablesVRs = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "boolean", "output", false, 1, "1.0");
        l_booleanOutputVariablesNames = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "boolean", "output", false, 2, "1.0");
        l_stringOutputVariablesVRs = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "string", "output", false, 1, "1.0");
        l_stringOutputVariablesNames = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "string", "output", false, 2, "1.0");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("model "));
        txt = Tpl.writeStr(txt, i_fmiInfo_fmiModelIdentifier);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        ret_36 = FMI.getFMIType(i_fmiInfo);
        txt = Tpl.writeStr(txt, ret_36);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_FMU"));
        ret_37 = stringEq(i_fmiInfo_fmiDescription, "");
        txt = fun_302(txt, ret_37, i_fmiInfo_fmiDescription);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = dumpFMITypeDefinitions(txt, i_fmiTypeDefinitionsList);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("constant String fmuWorkingDir = \""));
        txt = Tpl.writeStr(txt, i_fmuWorkingDirectory);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\";\n",
                                    "parameter Integer logLevel = "
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_fmiLogLevel));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " \"log level used during the loading of FMU\" annotation (Dialog(tab=\"FMI\", group=\"Enable logging\"));\n",
                                    "parameter Boolean debugLogging = "
                                }, false));
        txt = Tpl.writeStr(txt, Tpl.booleanString(i_fmiDebugOutput));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" \"enables the FMU simulation logging\" annotation (Dialog(tab=\"FMI\", group=\"Enable logging\"));\n"));
        txt = dumpFMIModelVariablesList(txt, "1.0", i_fmiModelVariablesList, i_fmiTypeDefinitionsList, i_generateInputConnectors, i_generateOutputConnectors);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("protected\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("FMI1ModelExchange fmi1me = FMI1ModelExchange(logLevel, fmuWorkingDir, \""));
        txt = Tpl.writeStr(txt, i_fmiInfo_fmiModelIdentifier);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\", debugLogging);\n",
                                    "constant Integer numberOfContinuousStates = "
                                }, false));
        ret_38 = listLength(i_fmiInfo_fmiNumberOfContinuousStates);
        txt = Tpl.writeStr(txt, intString(ret_38));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "Real fmi_x[numberOfContinuousStates] \"States\";\n",
                                    "Real fmi_x_new[numberOfContinuousStates](each fixed = true) \"New States\";\n",
                                    "constant Integer numberOfEventIndicators = "
                                }, false));
        ret_39 = listLength(i_fmiInfo_fmiNumberOfEventIndicators);
        txt = Tpl.writeStr(txt, intString(ret_39));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "Real fmi_z[numberOfEventIndicators] \"Events Indicators\";\n",
                                    "Boolean fmi_z_positive[numberOfEventIndicators](each fixed = true);\n",
                                    "parameter Real flowStartTime(fixed=false);\n",
                                    "Real flowTime;\n",
                                    "parameter Real flowInitialized(fixed=false);\n",
                                    "parameter Real flowParamsStart(fixed=false);\n",
                                    "parameter Real flowInitInputs(fixed=false);\n",
                                    "Real flowStatesInputs;\n"
                                }, true));
        ret_40 = stringEq(Tpl.textString(l_realInputVariablesVRs), "");
        txt = fun_303(txt, ret_40, l_realInputVariablesReturnNames);
        txt = Tpl.softNewLine(txt);
        ret_41 = stringEq(Tpl.textString(l_integerInputVariablesVRs), "");
        txt = fun_304(txt, ret_41, l_integerInputVariablesReturnNames);
        txt = Tpl.softNewLine(txt);
        ret_42 = stringEq(Tpl.textString(l_booleanInputVariablesVRs), "");
        txt = fun_305(txt, ret_42, l_booleanInputVariablesReturnNames);
        txt = Tpl.softNewLine(txt);
        ret_43 = stringEq(Tpl.textString(l_stringInputVariablesVRs), "");
        txt = fun_306(txt, ret_43, l_stringInputVariablesReturnNames);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Boolean callEventUpdate;\n",
                                    "constant Boolean intermediateResults = false;\n",
                                    "Boolean newStatesAvailable(fixed = true);\n",
                                    "Real triggerDSSEvent;\n",
                                    "Real nextEventTime;\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "initial equation\n",
                                    "  flowStartTime = fmi1Functions.fmi1SetTime(fmi1me, time, 1);\n",
                                    "  flowInitialized = fmi1Functions.fmi1Initialize(fmi1me, flowParamsStart+flowInitInputs+flowStartTime);\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        ret_44 = listLength(i_fmiInfo_fmiNumberOfContinuousStates);
        ret_45 = intGt(ret_44, 0);
        txt = fun_307(txt, ret_45);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "initial algorithm\n",
                                    "  flowParamsStart := 1;\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        ret_46 = stringEq(Tpl.textString(l_realParametersVRs), "");
        txt = fun_308(txt, ret_46, l_realParametersNames, l_realParametersVRs);
        txt = Tpl.softNewLine(txt);
        ret_47 = stringEq(Tpl.textString(l_integerParametersVRs), "");
        txt = fun_309(txt, ret_47, l_integerParametersNames, l_integerParametersVRs);
        txt = Tpl.softNewLine(txt);
        ret_48 = stringEq(Tpl.textString(l_booleanParametersVRs), "");
        txt = fun_310(txt, ret_48, l_booleanParametersNames, l_booleanParametersVRs);
        txt = Tpl.softNewLine(txt);
        ret_49 = stringEq(Tpl.textString(l_stringParametersVRs), "");
        txt = fun_311(txt, ret_49, l_stringParametersNames, l_stringParametersVRs);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("flowInitInputs := 1;\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("initial equation\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        ret_50 = stringEq(Tpl.textString(l_realDependentParametersVRs), "");
        txt = fun_312(txt, ret_50, l_realDependentParametersVRs, l_realDependentParametersNames);
        txt = Tpl.softNewLine(txt);
        ret_51 = stringEq(Tpl.textString(l_integerDependentParametersVRs), "");
        txt = fun_313(txt, ret_51, l_integerDependentParametersVRs, l_integerDependentParametersNames);
        txt = Tpl.softNewLine(txt);
        ret_52 = stringEq(Tpl.textString(l_booleanDependentParametersVRs), "");
        txt = fun_314(txt, ret_52, l_booleanDependentParametersVRs, l_booleanDependentParametersNames);
        txt = Tpl.softNewLine(txt);
        ret_53 = stringEq(Tpl.textString(l_stringDependentParametersVRs), "");
        txt = fun_315(txt, ret_53, l_stringDependentParametersVRs, l_stringDependentParametersNames);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "equation\n",
                                    "  flowTime = fmi1Functions.fmi1SetTime(fmi1me, time, flowInitialized);\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        ret_54 = stringEq(Tpl.textString(l_realInputVariablesVRs), "");
        txt = fun_316(txt, ret_54, l_realInputVariablesNames, l_realInputVariablesVRs, l_realInputVariablesReturnNames);
        txt = Tpl.softNewLine(txt);
        ret_55 = stringEq(Tpl.textString(l_integerInputVariablesVRs), "");
        txt = fun_317(txt, ret_55, l_integerInputVariablesNames, l_integerInputVariablesVRs, l_integerInputVariablesReturnNames);
        txt = Tpl.softNewLine(txt);
        ret_56 = stringEq(Tpl.textString(l_booleanInputVariablesVRs), "");
        txt = fun_318(txt, ret_56, l_booleanInputVariablesNames, l_booleanInputVariablesVRs, l_booleanInputVariablesReturnNames);
        txt = Tpl.softNewLine(txt);
        ret_57 = stringEq(Tpl.textString(l_stringInputVariablesVRs), "");
        txt = fun_319(txt, ret_57, l_stringStartVariablesNames, l_stringInputVariablesVRs, l_stringInputVariablesReturnNames);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "flowStatesInputs = fmi1Functions.fmi1SetContinuousStates(fmi1me, fmi_x, flowParamsStart + flowTime);\n",
                                    "der(fmi_x) = fmi1Functions.fmi1GetDerivatives(fmi1me, numberOfContinuousStates, flowStatesInputs);\n",
                                    "fmi_z  = fmi1Functions.fmi1GetEventIndicators(fmi1me, numberOfEventIndicators, flowStatesInputs);\n",
                                    "for i in 1:size(fmi_z,1) loop\n",
                                    "  fmi_z_positive[i] = if not terminal() then fmi_z[i] > 0 else pre(fmi_z_positive[i]);\n",
                                    "end for;\n",
                                    "callEventUpdate = fmi1Functions.fmi1CompletedIntegratorStep(fmi1me, flowStatesInputs);\n",
                                    "triggerDSSEvent = noEvent(if callEventUpdate then flowStatesInputs+1.0 else flowStatesInputs-1.0);\n",
                                    "nextEventTime = fmi1Functions.fmi1nextEventTime(fmi1me, flowStatesInputs);\n"
                                }, true));
        ret_58 = stringEq(Tpl.textString(l_realOutputVariablesNames), "");
        ret_59 = stringEq(Tpl.textString(l_realOutputVariablesVRs), "");
        ret_60 = boolAnd(ret_58, ret_59);
        txt = fun_320(txt, ret_60, l_realOutputVariablesVRs, l_realOutputVariablesNames);
        txt = Tpl.softNewLine(txt);
        ret_61 = stringEq(Tpl.textString(l_integerOutputVariablesNames), "");
        ret_62 = stringEq(Tpl.textString(l_integerOutputVariablesVRs), "");
        ret_63 = boolAnd(ret_61, ret_62);
        txt = fun_321(txt, ret_63, l_integerOutputVariablesVRs, l_integerOutputVariablesNames);
        txt = Tpl.softNewLine(txt);
        ret_64 = stringEq(Tpl.textString(l_booleanOutputVariablesNames), "");
        ret_65 = stringEq(Tpl.textString(l_booleanOutputVariablesVRs), "");
        ret_66 = boolAnd(ret_64, ret_65);
        txt = fun_322(txt, ret_66, l_booleanOutputVariablesVRs, l_booleanOutputVariablesNames);
        txt = Tpl.softNewLine(txt);
        ret_67 = stringEq(Tpl.textString(l_stringOutputVariablesNames), "");
        ret_68 = stringEq(Tpl.textString(l_stringOutputVariablesVRs), "");
        ret_69 = boolAnd(ret_67, ret_68);
        txt = fun_323(txt, ret_69, l_stringOutputVariablesVRs, l_stringOutputVariablesNames);
        txt = Tpl.softNewLine(txt);
        txt = dumpOutputGetEnumerationVariables(txt, i_fmiModelVariablesList, i_fmiTypeDefinitionsList, "fmi1Functions.fmi1GetInteger", "fmi1me");
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("algorithm\n"));
        ret_70 = listLength(i_fmiInfo_fmiNumberOfEventIndicators);
        ret_71 = intGt(ret_70, 0);
        txt = fun_325(txt, ret_71, i_fmiInfo_fmiNumberOfEventIndicators);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("    newStatesAvailable := fmi1Functions.fmi1EventUpdate(fmi1me, intermediateResults);\n"));
        ret_72 = listLength(i_fmiInfo_fmiNumberOfContinuousStates);
        ret_73 = intGt(ret_72, 0);
        txt = fun_327(txt, ret_73, i_fmiInfo_fmiNumberOfContinuousStates);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("  end when;\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("annotation(experiment(StartTime="));
        txt = Tpl.writeStr(txt, realString(i_fmiExperimentAnnotation_fmiExperimentStartTime));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", StopTime="));
        txt = Tpl.writeStr(txt, realString(i_fmiExperimentAnnotation_fmiExperimentStopTime));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", Tolerance="));
        txt = Tpl.writeStr(txt, realString(i_fmiExperimentAnnotation_fmiExperimentTolerance));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "));\n",
                                    "annotation (Icon(graphics={\n",
                                    "    Rectangle(\n",
                                    "      extent={{-100,100},{100,-100}},\n",
                                    "      lineColor={0,0,0},\n",
                                    "      fillColor={240,240,240},\n",
                                    "      fillPattern=FillPattern.Solid,\n",
                                    "      lineThickness=0.5),\n",
                                    "    Text(\n",
                                    "      extent={{-100,40},{100,0}},\n",
                                    "      lineColor={0,0,0},\n",
                                    "      textString=\"%name\"),\n",
                                    "    Text(\n",
                                    "      extent={{-100,-50},{100,-90}},\n",
                                    "      lineColor={0,0,0},\n",
                                    "      textString=\"V1.0\")}));\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "protected\n",
                                    "  class FMI1ModelExchange\n",
                                    "    extends ExternalObject;\n",
                                    "      function constructor\n",
                                    "        input Integer logLevel;\n",
                                    "        input String workingDirectory;\n",
                                    "        input String instanceName;\n",
                                    "        input Boolean debugLogging;\n",
                                    "        output FMI1ModelExchange fmi1me;\n",
                                    "        external \"C\" fmi1me = FMI1ModelExchangeConstructor_OMC(logLevel, workingDirectory, instanceName, debugLogging) annotation(Library = {\"OpenModelicaFMIRuntimeC\", \"fmilib\"});\n",
                                    "      end constructor;\n",
                                    "\n",
                                    "      function destructor\n",
                                    "        input FMI1ModelExchange fmi1me;\n",
                                    "        external \"C\" FMI1ModelExchangeDestructor_OMC(fmi1me) annotation(Library = {\"OpenModelicaFMIRuntimeC\", \"fmilib\"});\n",
                                    "      end destructor;\n",
                                    "  end FMI1ModelExchange;\n",
                                    "\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = dumpFMITypeDefinitionsMappingFunctions(txt, i_fmiTypeDefinitionsList);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = dumpFMITypeDefinitionsArrayMappingFunctions(txt, i_fmiTypeDefinitionsList);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "package fmi1Functions\n",
                                    "  function fmi1Initialize\n",
                                    "    input FMI1ModelExchange fmi1me;\n",
                                    "    input Real preInitialized;\n",
                                    "    output Real postInitialized=preInitialized;\n",
                                    "    external \"C\" fmi1Initialize_OMC(fmi1me) annotation(Library = {\"OpenModelicaFMIRuntimeC\", \"fmilib\"});\n",
                                    "  end fmi1Initialize;\n",
                                    "\n",
                                    "  function fmi1SetTime\n",
                                    "    input FMI1ModelExchange fmi1me;\n",
                                    "    input Real inTime;\n",
                                    "    input Real inFlow;\n",
                                    "    output Real outFlow = inFlow;\n",
                                    "    external \"C\" fmi1SetTime_OMC(fmi1me, inTime) annotation(Library = {\"OpenModelicaFMIRuntimeC\", \"fmilib\"});\n",
                                    "  end fmi1SetTime;\n",
                                    "\n",
                                    "  function fmi1GetContinuousStates\n",
                                    "    input FMI1ModelExchange fmi1me;\n",
                                    "    input Integer numberOfContinuousStates;\n",
                                    "    input Real inFlowParams;\n",
                                    "    output Real fmi_x[numberOfContinuousStates];\n",
                                    "    external \"C\" fmi1GetContinuousStates_OMC(fmi1me, numberOfContinuousStates, inFlowParams, fmi_x) annotation(Library = {\"OpenModelicaFMIRuntimeC\", \"fmilib\"});\n",
                                    "  end fmi1GetContinuousStates;\n",
                                    "\n",
                                    "  function fmi1SetContinuousStates\n",
                                    "    input FMI1ModelExchange fmi1me;\n",
                                    "    input Real fmi_x[:];\n",
                                    "    input Real inFlowParams;\n",
                                    "    output Real outFlowStates;\n",
                                    "    external \"C\" outFlowStates = fmi1SetContinuousStates_OMC(fmi1me, size(fmi_x, 1), inFlowParams, fmi_x) annotation(Library = {\"OpenModelicaFMIRuntimeC\", \"fmilib\"});\n",
                                    "  end fmi1SetContinuousStates;\n",
                                    "\n",
                                    "  function fmi1GetDerivatives\n",
                                    "    input FMI1ModelExchange fmi1me;\n",
                                    "    input Integer numberOfContinuousStates;\n",
                                    "    input Real inFlowStates;\n",
                                    "    output Real fmi_x[numberOfContinuousStates];\n",
                                    "    external \"C\" fmi1GetDerivatives_OMC(fmi1me, numberOfContinuousStates, inFlowStates, fmi_x) annotation(Library = {\"OpenModelicaFMIRuntimeC\", \"fmilib\"});\n",
                                    "  end fmi1GetDerivatives;\n",
                                    "\n",
                                    "  function fmi1GetEventIndicators\n",
                                    "    input FMI1ModelExchange fmi1me;\n",
                                    "    input Integer numberOfEventIndicators;\n",
                                    "    input Real inFlowStates;\n",
                                    "    output Real fmi_z[numberOfEventIndicators];\n",
                                    "    external \"C\" fmi1GetEventIndicators_OMC(fmi1me, numberOfEventIndicators, inFlowStates, fmi_z) annotation(Library = {\"OpenModelicaFMIRuntimeC\", \"fmilib\"});\n",
                                    "  end fmi1GetEventIndicators;\n",
                                    "\n",
                                    "  function fmi1GetReal\n",
                                    "    input FMI1ModelExchange fmi1me;\n",
                                    "    input Real realValuesReferences[:];\n",
                                    "    input Real inFlowStatesInput;\n",
                                    "    output Real realValues[size(realValuesReferences, 1)];\n",
                                    "    external \"C\" fmi1GetReal_OMC(fmi1me, size(realValuesReferences, 1), realValuesReferences, inFlowStatesInput, realValues, 1) annotation(Library = {\"OpenModelicaFMIRuntimeC\", \"fmilib\"});\n",
                                    "  end fmi1GetReal;\n",
                                    "\n",
                                    "  function fmi1SetReal\n",
                                    "    input FMI1ModelExchange fmi1me;\n",
                                    "    input Real realValueReferences[:];\n",
                                    "    input Real realValues[size(realValueReferences, 1)];\n",
                                    "    output Real outValues[size(realValueReferences, 1)] = realValues;\n",
                                    "    external \"C\" fmi1SetReal_OMC(fmi1me, size(realValueReferences, 1), realValueReferences, realValues, 1) annotation(Library = {\"OpenModelicaFMIRuntimeC\", \"fmilib\"});\n",
                                    "  end fmi1SetReal;\n",
                                    "\n",
                                    "  function fmi1SetRealParameter\n",
                                    "    input FMI1ModelExchange fmi1me;\n",
                                    "    input Real realValueReferences[:];\n",
                                    "    input Real realValues[size(realValueReferences, 1)];\n",
                                    "    output Real out_Value = 1;\n",
                                    "    external \"C\" fmi1SetReal_OMC(fmi1me, size(realValueReferences, 1), realValueReferences, realValues, 1) annotation(Library = {\"OpenModelicaFMIRuntimeC\", \"fmilib\"});\n",
                                    "  end fmi1SetRealParameter;\n",
                                    "\n",
                                    "  function fmi1GetInteger\n",
                                    "    input FMI1ModelExchange fmi1me;\n",
                                    "    input Real integerValueReferences[:];\n",
                                    "    input Real inFlowStatesInput;\n",
                                    "    output Integer integerValues[size(integerValueReferences, 1)];\n",
                                    "    external \"C\" fmi1GetInteger_OMC(fmi1me, size(integerValueReferences, 1), integerValueReferences, inFlowStatesInput, integerValues, 1) annotation(Library = {\"OpenModelicaFMIRuntimeC\", \"fmilib\"});\n",
                                    "  end fmi1GetInteger;\n",
                                    "\n",
                                    "  function fmi1SetInteger\n",
                                    "    input FMI1ModelExchange fmi1me;\n",
                                    "    input Real integerValuesReferences[:];\n",
                                    "    input Integer integerValues[size(integerValuesReferences, 1)];\n",
                                    "    output Integer outValues[size(integerValuesReferences, 1)] = integerValues;\n",
                                    "    external \"C\" fmi1SetInteger_OMC(fmi1me, size(integerValuesReferences, 1), integerValuesReferences, integerValues, 1) annotation(Library = {\"OpenModelicaFMIRuntimeC\", \"fmilib\"});\n",
                                    "  end fmi1SetInteger;\n",
                                    "\n",
                                    "  function fmi1SetIntegerParameter\n",
                                    "    input FMI1ModelExchange fmi1me;\n",
                                    "    input Real integerValuesReferences[:];\n",
                                    "    input Integer integerValues[size(integerValuesReferences, 1)];\n",
                                    "    output Real out_Value = 1;\n",
                                    "    external \"C\" fmi1SetInteger_OMC(fmi1me, size(integerValuesReferences, 1), integerValuesReferences, integerValues, 1) annotation(Library = {\"OpenModelicaFMIRuntimeC\", \"fmilib\"});\n",
                                    "  end fmi1SetIntegerParameter;\n",
                                    "\n",
                                    "  function fmi1GetBoolean\n",
                                    "    input FMI1ModelExchange fmi1me;\n",
                                    "    input Real booleanValuesReferences[:];\n",
                                    "    input Real inFlowStatesInput;\n",
                                    "    output Boolean booleanValues[size(booleanValuesReferences, 1)];\n",
                                    "    external \"C\" fmi1GetBoolean_OMC(fmi1me, size(booleanValuesReferences, 1), booleanValuesReferences, inFlowStatesInput, booleanValues, 1) annotation(Library = {\"OpenModelicaFMIRuntimeC\", \"fmilib\"});\n",
                                    "  end fmi1GetBoolean;\n",
                                    "\n",
                                    "  function fmi1SetBoolean\n",
                                    "    input FMI1ModelExchange fmi1me;\n",
                                    "    input Real booleanValueReferences[:];\n",
                                    "    input Boolean booleanValues[size(booleanValueReferences, 1)];\n",
                                    "    output Boolean outValues[size(booleanValueReferences, 1)] = booleanValues;\n",
                                    "    external \"C\" fmi1SetBoolean_OMC(fmi1me, size(booleanValueReferences, 1), booleanValueReferences, booleanValues, 1) annotation(Library = {\"OpenModelicaFMIRuntimeC\", \"fmilib\"});\n",
                                    "  end fmi1SetBoolean;\n",
                                    "\n",
                                    "  function fmi1SetBooleanParameter\n",
                                    "    input FMI1ModelExchange fmi1me;\n",
                                    "    input Real booleanValueReferences[:];\n",
                                    "    input Boolean booleanValues[size(booleanValueReferences, 1)];\n",
                                    "    output Real out_Value = 1;\n",
                                    "    external \"C\" fmi1SetBoolean_OMC(fmi1me, size(booleanValueReferences, 1), booleanValueReferences, booleanValues, 1) annotation(Library = {\"OpenModelicaFMIRuntimeC\", \"fmilib\"});\n",
                                    "  end fmi1SetBooleanParameter;\n",
                                    "\n",
                                    "  function fmi1GetString\n",
                                    "    input FMI1ModelExchange fmi1me;\n",
                                    "    input Real stringValuesReferences[:];\n",
                                    "    input Real inFlowStatesInput;\n",
                                    "    output String stringValues[size(stringValuesReferences, 1)];\n",
                                    "    external \"C\" fmi1GetString_OMC(fmi1me, size(stringValuesReferences, 1), stringValuesReferences, inFlowStatesInput, stringValues, 1) annotation(Library = {\"OpenModelicaFMIRuntimeC\", \"fmilib\"});\n",
                                    "  end fmi1GetString;\n",
                                    "\n",
                                    "  function fmi1SetString\n",
                                    "    input FMI1ModelExchange fmi1me;\n",
                                    "    input Real stringValueReferences[:];\n",
                                    "    input String stringValues[size(stringValueReferences, 1)];\n",
                                    "    output String outValues[size(stringValueReferences, 1)] = stringValues;\n",
                                    "    external \"C\" fmi1SetString_OMC(fmi1me, size(stringValueReferences, 1), stringValueReferences, stringValues, 1) annotation(Library = {\"OpenModelicaFMIRuntimeC\", \"fmilib\"});\n",
                                    "  end fmi1SetString;\n",
                                    "\n",
                                    "  function fmi1SetStringParameter\n",
                                    "    input FMI1ModelExchange fmi1me;\n",
                                    "    input Real stringValueReferences[:];\n",
                                    "    input String stringValues[size(stringValueReferences, 1)];\n",
                                    "    output Real out_Value = 1;\n",
                                    "    external \"C\" fmi1SetString_OMC(fmi1me, size(stringValueReferences, 1), stringValueReferences, stringValues, 1) annotation(Library = {\"OpenModelicaFMIRuntimeC\", \"fmilib\"});\n",
                                    "  end fmi1SetStringParameter;\n",
                                    "\n",
                                    "  function fmi1EventUpdate\n",
                                    "    input FMI1ModelExchange fmi1me;\n",
                                    "    input Boolean intermediateResults;\n",
                                    "    output Boolean outNewStatesAvailable;\n",
                                    "    external \"C\" outNewStatesAvailable = fmi1EventUpdate_OMC(fmi1me, intermediateResults) annotation(Library = {\"OpenModelicaFMIRuntimeC\", \"fmilib\"});\n",
                                    "  end fmi1EventUpdate;\n",
                                    "\n",
                                    "  function fmi1nextEventTime\n",
                                    "    input FMI1ModelExchange fmi1me;\n",
                                    "    input Real inFlowStates;\n",
                                    "    output Real outNewnextTime;\n",
                                    "    external \"C\" outNewnextTime = fmi1nextEventTime_OMC(fmi1me, inFlowStates) annotation(Library = {\"OpenModelicaFMIRuntimeC\", \"fmilib\"});\n",
                                    "  end fmi1nextEventTime;\n",
                                    "\n",
                                    "  function fmi1CompletedIntegratorStep\n",
                                    "    input FMI1ModelExchange fmi1me;\n",
                                    "    input Real inFlowStates;\n",
                                    "    output Boolean outCallEventUpdate;\n",
                                    "    external \"C\" outCallEventUpdate = fmi1CompletedIntegratorStep_OMC(fmi1me, inFlowStates) annotation(Library = {\"OpenModelicaFMIRuntimeC\", \"fmilib\"});\n",
                                    "  end fmi1CompletedIntegratorStep;\n",
                                    "end fmi1Functions;\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("end "));
        txt = Tpl.writeStr(txt, i_fmiInfo_fmiModelIdentifier);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        ret_74 = FMI.getFMIType(i_fmiInfo);
        txt = Tpl.writeStr(txt, ret_74);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_FMU;"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end importFMU1ModelExchange;

protected function fun_329
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_fmiInfo_fmiDescription;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_fmiInfo_fmiDescription)
    local
      Tpl.Text txt;
      String a_fmiInfo_fmiDescription;

    case ( txt,
           false,
           a_fmiInfo_fmiDescription )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" \""));
        txt = Tpl.writeStr(txt, a_fmiInfo_fmiDescription);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_329;

protected function fun_330
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_nRealInputVariables;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_nRealInputVariables)
    local
      Tpl.Text txt;
      Tpl.Text a_nRealInputVariables;

    case ( txt,
           false,
           a_nRealInputVariables )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Real realInputVariables["));
        txt = Tpl.writeText(txt, a_nRealInputVariables);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("];"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_330;

protected function fun_331
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_realInputVariablesReturnNames;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_realInputVariablesReturnNames)
    local
      Tpl.Text txt;
      Tpl.Text a_realInputVariablesReturnNames;

    case ( txt,
           false,
           a_realInputVariablesReturnNames )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Real "));
        txt = Tpl.writeText(txt, a_realInputVariablesReturnNames);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_331;

protected function fun_332
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_nIntegerInputVariables;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_nIntegerInputVariables)
    local
      Tpl.Text txt;
      Tpl.Text a_nIntegerInputVariables;

    case ( txt,
           false,
           a_nIntegerInputVariables )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Integer integerInputVariables["));
        txt = Tpl.writeText(txt, a_nIntegerInputVariables);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("];"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_332;

protected function fun_333
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_integerInputVariablesReturnNames;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_integerInputVariablesReturnNames)
    local
      Tpl.Text txt;
      Tpl.Text a_integerInputVariablesReturnNames;

    case ( txt,
           false,
           a_integerInputVariablesReturnNames )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Integer "));
        txt = Tpl.writeText(txt, a_integerInputVariablesReturnNames);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_333;

protected function fun_334
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_nBooleanInputVariables;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_nBooleanInputVariables)
    local
      Tpl.Text txt;
      Tpl.Text a_nBooleanInputVariables;

    case ( txt,
           false,
           a_nBooleanInputVariables )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Boolean booleanInputVariables["));
        txt = Tpl.writeText(txt, a_nBooleanInputVariables);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("];"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_334;

protected function fun_335
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_booleanInputVariablesReturnNames;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_booleanInputVariablesReturnNames)
    local
      Tpl.Text txt;
      Tpl.Text a_booleanInputVariablesReturnNames;

    case ( txt,
           false,
           a_booleanInputVariablesReturnNames )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Boolean "));
        txt = Tpl.writeText(txt, a_booleanInputVariablesReturnNames);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_335;

protected function fun_336
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_nStringInputVariables;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_nStringInputVariables)
    local
      Tpl.Text txt;
      Tpl.Text a_nStringInputVariables;

    case ( txt,
           false,
           a_nStringInputVariables )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("String stringInputVariables["));
        txt = Tpl.writeText(txt, a_nStringInputVariables);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("];"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_336;

protected function fun_337
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_stringInputVariablesReturnNames;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_stringInputVariablesReturnNames)
    local
      Tpl.Text txt;
      Tpl.Text a_stringInputVariablesReturnNames;

    case ( txt,
           false,
           a_stringInputVariablesReturnNames )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("String "));
        txt = Tpl.writeText(txt, a_stringInputVariablesReturnNames);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_337;

protected function fun_338
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("fmi_x = fmi2Functions.fmi2GetContinuousStates(fmi2me, numberOfContinuousStates, flowParamsStart+flowInitialized);"));
      then txt;
  end match;
end fun_338;

protected function fun_339
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_realParametersNames;
  input Tpl.Text in_a_realParametersVRs;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_realParametersNames, in_a_realParametersVRs)
    local
      Tpl.Text txt;
      Tpl.Text a_realParametersNames;
      Tpl.Text a_realParametersVRs;

    case ( txt,
           false,
           a_realParametersNames,
           a_realParametersVRs )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("flowParamsStart := fmi2Functions.fmi2SetRealParameter(fmi2me, {"));
        txt = Tpl.writeText(txt, a_realParametersVRs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}, {"));
        txt = Tpl.writeText(txt, a_realParametersNames);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("});"));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_339;

protected function fun_340
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_integerParametersNames;
  input Tpl.Text in_a_integerParametersVRs;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_integerParametersNames, in_a_integerParametersVRs)
    local
      Tpl.Text txt;
      Tpl.Text a_integerParametersNames;
      Tpl.Text a_integerParametersVRs;

    case ( txt,
           false,
           a_integerParametersNames,
           a_integerParametersVRs )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("flowParamsStart := fmi2Functions.fmi2SetIntegerParameter(fmi2me, {"));
        txt = Tpl.writeText(txt, a_integerParametersVRs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}, {"));
        txt = Tpl.writeText(txt, a_integerParametersNames);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("});"));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_340;

protected function fun_341
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_booleanParametersNames;
  input Tpl.Text in_a_booleanParametersVRs;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_booleanParametersNames, in_a_booleanParametersVRs)
    local
      Tpl.Text txt;
      Tpl.Text a_booleanParametersNames;
      Tpl.Text a_booleanParametersVRs;

    case ( txt,
           false,
           a_booleanParametersNames,
           a_booleanParametersVRs )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("flowParamsStart := fmi2Functions.fmi2SetBooleanParameter(fmi2me, {"));
        txt = Tpl.writeText(txt, a_booleanParametersVRs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}, {"));
        txt = Tpl.writeText(txt, a_booleanParametersNames);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("});"));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_341;

protected function fun_342
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_stringParametersNames;
  input Tpl.Text in_a_stringParametersVRs;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_stringParametersNames, in_a_stringParametersVRs)
    local
      Tpl.Text txt;
      Tpl.Text a_stringParametersNames;
      Tpl.Text a_stringParametersVRs;

    case ( txt,
           false,
           a_stringParametersNames,
           a_stringParametersVRs )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("flowParamsStart := fmi2Functions.fmi2SetStringParameter(fmi2me, {"));
        txt = Tpl.writeText(txt, a_stringParametersVRs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}, {"));
        txt = Tpl.writeText(txt, a_stringParametersNames);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("});"));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_342;

protected function fun_343
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_realDependentParametersVRs;
  input Tpl.Text in_a_realDependentParametersNames;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_realDependentParametersVRs, in_a_realDependentParametersNames)
    local
      Tpl.Text txt;
      Tpl.Text a_realDependentParametersVRs;
      Tpl.Text a_realDependentParametersNames;

    case ( txt,
           false,
           a_realDependentParametersVRs,
           a_realDependentParametersNames )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("{"));
        txt = Tpl.writeText(txt, a_realDependentParametersNames);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("} = fmi2Functions.fmi2GetReal(fmi2me, {"));
        txt = Tpl.writeText(txt, a_realDependentParametersVRs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}, flowInitialized);"));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_343;

protected function fun_344
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_integerDependentParametersVRs;
  input Tpl.Text in_a_integerDependentParametersNames;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_integerDependentParametersVRs, in_a_integerDependentParametersNames)
    local
      Tpl.Text txt;
      Tpl.Text a_integerDependentParametersVRs;
      Tpl.Text a_integerDependentParametersNames;

    case ( txt,
           false,
           a_integerDependentParametersVRs,
           a_integerDependentParametersNames )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("{"));
        txt = Tpl.writeText(txt, a_integerDependentParametersNames);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("} = fmi2Functions.fmi2GetInteger(fmi2me, {"));
        txt = Tpl.writeText(txt, a_integerDependentParametersVRs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}, flowInitialized);"));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_344;

protected function fun_345
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_booleanDependentParametersVRs;
  input Tpl.Text in_a_booleanDependentParametersNames;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_booleanDependentParametersVRs, in_a_booleanDependentParametersNames)
    local
      Tpl.Text txt;
      Tpl.Text a_booleanDependentParametersVRs;
      Tpl.Text a_booleanDependentParametersNames;

    case ( txt,
           false,
           a_booleanDependentParametersVRs,
           a_booleanDependentParametersNames )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("{"));
        txt = Tpl.writeText(txt, a_booleanDependentParametersNames);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("} = fmi2Functions.fmi2GetBoolean(fmi2me, {"));
        txt = Tpl.writeText(txt, a_booleanDependentParametersVRs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}, flowInitialized);"));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_345;

protected function fun_346
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_stringDependentParametersVRs;
  input Tpl.Text in_a_stringDependentParametersNames;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_stringDependentParametersVRs, in_a_stringDependentParametersNames)
    local
      Tpl.Text txt;
      Tpl.Text a_stringDependentParametersVRs;
      Tpl.Text a_stringDependentParametersNames;

    case ( txt,
           false,
           a_stringDependentParametersVRs,
           a_stringDependentParametersNames )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("{"));
        txt = Tpl.writeText(txt, a_stringDependentParametersNames);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("} = fmi2Functions.fmi2GetString(fmi2me, {"));
        txt = Tpl.writeText(txt, a_stringDependentParametersVRs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}, flowInitialized);"));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_346;

protected function fun_347
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_realInputVariablesNames;
  input Tpl.Text in_a_realInputVariablesVRs;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_realInputVariablesNames, in_a_realInputVariablesVRs)
    local
      Tpl.Text txt;
      Tpl.Text a_realInputVariablesNames;
      Tpl.Text a_realInputVariablesVRs;

    case ( txt,
           false,
           a_realInputVariablesNames,
           a_realInputVariablesVRs )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("realInputVariables := fmi2Functions.fmi2SetReal(fmi2me, {"));
        txt = Tpl.writeText(txt, a_realInputVariablesVRs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}, {"));
        txt = Tpl.writeText(txt, a_realInputVariablesNames);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("});"));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_347;

protected function fun_348
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_integerInputVariablesNames;
  input Tpl.Text in_a_integerInputVariablesVRs;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_integerInputVariablesNames, in_a_integerInputVariablesVRs)
    local
      Tpl.Text txt;
      Tpl.Text a_integerInputVariablesNames;
      Tpl.Text a_integerInputVariablesVRs;

    case ( txt,
           false,
           a_integerInputVariablesNames,
           a_integerInputVariablesVRs )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("integerInputVariables := fmi2Functions.fmi2SetInteger(fmi2me, {"));
        txt = Tpl.writeText(txt, a_integerInputVariablesVRs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}, {"));
        txt = Tpl.writeText(txt, a_integerInputVariablesNames);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("});"));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_348;

protected function fun_349
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_booleanInputVariablesNames;
  input Tpl.Text in_a_booleanInputVariablesVRs;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_booleanInputVariablesNames, in_a_booleanInputVariablesVRs)
    local
      Tpl.Text txt;
      Tpl.Text a_booleanInputVariablesNames;
      Tpl.Text a_booleanInputVariablesVRs;

    case ( txt,
           false,
           a_booleanInputVariablesNames,
           a_booleanInputVariablesVRs )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("booleanInputVariables := fmi2Functions.fmi2SetBoolean(fmi2me, {"));
        txt = Tpl.writeText(txt, a_booleanInputVariablesVRs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}, {"));
        txt = Tpl.writeText(txt, a_booleanInputVariablesNames);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("});"));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_349;

protected function fun_350
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_stringStartVariablesNames;
  input Tpl.Text in_a_stringInputVariablesVRs;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_stringStartVariablesNames, in_a_stringInputVariablesVRs)
    local
      Tpl.Text txt;
      Tpl.Text a_stringStartVariablesNames;
      Tpl.Text a_stringInputVariablesVRs;

    case ( txt,
           false,
           a_stringStartVariablesNames,
           a_stringInputVariablesVRs )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("stringInputVariables := fmi2Functions.fmi2SetString(fmi2me, {"));
        txt = Tpl.writeText(txt, a_stringInputVariablesVRs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}, {"));
        txt = Tpl.writeText(txt, a_stringStartVariablesNames);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("});"));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_350;

protected function fun_351
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_realInputVariablesReturnNames;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_realInputVariablesReturnNames)
    local
      Tpl.Text txt;
      Tpl.Text a_realInputVariablesReturnNames;

    case ( txt,
           false,
           a_realInputVariablesReturnNames )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("{"));
        txt = Tpl.writeText(txt, a_realInputVariablesReturnNames);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("} = realInputVariables;"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_351;

protected function fun_352
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_integerInputVariablesReturnNames;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_integerInputVariablesReturnNames)
    local
      Tpl.Text txt;
      Tpl.Text a_integerInputVariablesReturnNames;

    case ( txt,
           false,
           a_integerInputVariablesReturnNames )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("{"));
        txt = Tpl.writeText(txt, a_integerInputVariablesReturnNames);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("} = integerInputVariables;"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_352;

protected function fun_353
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_booleanInputVariablesReturnNames;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_booleanInputVariablesReturnNames)
    local
      Tpl.Text txt;
      Tpl.Text a_booleanInputVariablesReturnNames;

    case ( txt,
           false,
           a_booleanInputVariablesReturnNames )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("{"));
        txt = Tpl.writeText(txt, a_booleanInputVariablesReturnNames);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("} = booleanInputVariables;"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_353;

protected function fun_354
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_stringInputVariablesReturnNames;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_stringInputVariablesReturnNames)
    local
      Tpl.Text txt;
      Tpl.Text a_stringInputVariablesReturnNames;

    case ( txt,
           false,
           a_stringInputVariablesReturnNames )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("{"));
        txt = Tpl.writeText(txt, a_stringInputVariablesReturnNames);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("} = stringInputVariables;"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_354;

protected function fun_355
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_realOutputVariablesVRs;
  input Tpl.Text in_a_realOutputVariablesNames;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_realOutputVariablesVRs, in_a_realOutputVariablesNames)
    local
      Tpl.Text txt;
      Tpl.Text a_realOutputVariablesVRs;
      Tpl.Text a_realOutputVariablesNames;

    case ( txt,
           false,
           a_realOutputVariablesVRs,
           a_realOutputVariablesNames )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("{"));
        txt = Tpl.writeText(txt, a_realOutputVariablesNames);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("} = fmi2Functions.fmi2GetReal(fmi2me, {"));
        txt = Tpl.writeText(txt, a_realOutputVariablesVRs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}, flowStatesInputs);"));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_355;

protected function fun_356
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_integerOutputVariablesVRs;
  input Tpl.Text in_a_integerOutputVariablesNames;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_integerOutputVariablesVRs, in_a_integerOutputVariablesNames)
    local
      Tpl.Text txt;
      Tpl.Text a_integerOutputVariablesVRs;
      Tpl.Text a_integerOutputVariablesNames;

    case ( txt,
           false,
           a_integerOutputVariablesVRs,
           a_integerOutputVariablesNames )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("{"));
        txt = Tpl.writeText(txt, a_integerOutputVariablesNames);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("} = fmi2Functions.fmi2GetInteger(fmi2me, {"));
        txt = Tpl.writeText(txt, a_integerOutputVariablesVRs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}, flowStatesInputs);"));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_356;

protected function fun_357
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_booleanOutputVariablesVRs;
  input Tpl.Text in_a_booleanOutputVariablesNames;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_booleanOutputVariablesVRs, in_a_booleanOutputVariablesNames)
    local
      Tpl.Text txt;
      Tpl.Text a_booleanOutputVariablesVRs;
      Tpl.Text a_booleanOutputVariablesNames;

    case ( txt,
           false,
           a_booleanOutputVariablesVRs,
           a_booleanOutputVariablesNames )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("{"));
        txt = Tpl.writeText(txt, a_booleanOutputVariablesNames);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("} = fmi2Functions.fmi2GetBoolean(fmi2me, {"));
        txt = Tpl.writeText(txt, a_booleanOutputVariablesVRs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}, flowStatesInputs);"));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_357;

protected function fun_358
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_stringOutputVariablesVRs;
  input Tpl.Text in_a_stringOutputVariablesNames;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_stringOutputVariablesVRs, in_a_stringOutputVariablesNames)
    local
      Tpl.Text txt;
      Tpl.Text a_stringOutputVariablesVRs;
      Tpl.Text a_stringOutputVariablesNames;

    case ( txt,
           false,
           a_stringOutputVariablesVRs,
           a_stringOutputVariablesNames )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("{"));
        txt = Tpl.writeText(txt, a_stringOutputVariablesNames);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("} = fmi2Functions.fmi2GetString(fmi2me, {"));
        txt = Tpl.writeText(txt, a_stringOutputVariablesVRs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}, flowStatesInputs);"));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_358;

protected function lm_359
  input Tpl.Text in_txt;
  input list<Integer> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<Integer> rest;
      Integer i_eventIndicator;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_eventIndicator :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("change(fmi_z_positive["));
        txt = Tpl.writeStr(txt, intString(i_eventIndicator));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("])"));
        txt = Tpl.nextIter(txt);
        txt = lm_359(txt, rest);
      then txt;
  end match;
end lm_359;

protected function fun_360
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input list<Integer> in_a_fmiInfo_fmiNumberOfEventIndicators;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_fmiInfo_fmiNumberOfEventIndicators)
    local
      Tpl.Text txt;
      list<Integer> a_fmiInfo_fmiNumberOfEventIndicators;

    case ( txt,
           false,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("  when {triggerDSSEvent > flowStatesInputs, pre(nextEventTime) < time, terminal()} then"));
      then txt;

    case ( txt,
           _,
           a_fmiInfo_fmiNumberOfEventIndicators )
      equation
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("when {"));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(" or ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_359(txt, a_fmiInfo_fmiNumberOfEventIndicators);
        txt = Tpl.popIter(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", triggerDSSEvent > flowStatesInputs, pre(nextEventTime) < time, terminal()} then"));
        txt = Tpl.popBlock(txt);
      then txt;
  end match;
end fun_360;

protected function lm_361
  input Tpl.Text in_txt;
  input list<Integer> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<Integer> rest;
      Integer i_continuousStates;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_continuousStates :: rest )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("reinit(fmi_x["));
        txt = Tpl.writeStr(txt, intString(i_continuousStates));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("], fmi_x_new["));
        txt = Tpl.writeStr(txt, intString(i_continuousStates));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("]);"));
        txt = Tpl.nextIter(txt);
        txt = lm_361(txt, rest);
      then txt;
  end match;
end lm_361;

protected function fun_362
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input list<Integer> in_a_fmiInfo_fmiNumberOfContinuousStates;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_fmiInfo_fmiNumberOfContinuousStates)
    local
      Tpl.Text txt;
      list<Integer> a_fmiInfo_fmiNumberOfContinuousStates;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_fmiInfo_fmiNumberOfContinuousStates )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "    if newStatesAvailable then\n",
                                    "      fmi_x_new := fmi2Functions.fmi2GetContinuousStates(fmi2me, numberOfContinuousStates, flowStatesInputs);\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(6));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_361(txt, a_fmiInfo_fmiNumberOfContinuousStates);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("    end if;"));
      then txt;
  end match;
end fun_362;

public function importFMU2ModelExchange
  input Tpl.Text in_txt;
  input FMI.FmiImport in_a_fmi;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fmi)
    local
      Tpl.Text txt;
      Real i_fmiExperimentAnnotation_fmiExperimentTolerance;
      Real i_fmiExperimentAnnotation_fmiExperimentStopTime;
      Real i_fmiExperimentAnnotation_fmiExperimentStartTime;
      list<Integer> i_fmiInfo_fmiNumberOfEventIndicators;
      list<Integer> i_fmiInfo_fmiNumberOfContinuousStates;
      Boolean i_generateOutputConnectors;
      Boolean i_generateInputConnectors;
      Boolean i_fmiDebugOutput;
      Integer i_fmiLogLevel;
      String i_fmuWorkingDirectory;
      list<FMI.TypeDefinitions> i_fmiTypeDefinitionsList;
      String i_fmiInfo_fmiDescription;
      FMI.Info i_fmiInfo;
      String i_fmiInfo_fmiModelIdentifier;
      list<FMI.ModelVariables> i_fmiModelVariablesList;
      String ret_94;
      Boolean ret_93;
      Integer ret_92;
      Boolean ret_91;
      Integer ret_90;
      Boolean ret_89;
      Boolean ret_88;
      Boolean ret_87;
      Boolean ret_86;
      Boolean ret_85;
      Boolean ret_84;
      Boolean ret_83;
      Boolean ret_82;
      Boolean ret_81;
      Boolean ret_80;
      Boolean ret_79;
      Boolean ret_78;
      Boolean ret_77;
      Boolean ret_76;
      Boolean ret_75;
      Boolean ret_74;
      Boolean ret_73;
      Boolean ret_72;
      Boolean ret_71;
      Boolean ret_70;
      Boolean ret_69;
      Boolean ret_68;
      Boolean ret_67;
      Boolean ret_66;
      Boolean ret_65;
      Boolean ret_64;
      Boolean ret_63;
      Boolean ret_62;
      Boolean ret_61;
      Integer ret_60;
      Boolean ret_59;
      Boolean ret_58;
      Boolean ret_57;
      Boolean ret_56;
      Boolean ret_55;
      Boolean ret_54;
      Boolean ret_53;
      Boolean ret_52;
      Integer ret_51;
      Integer ret_50;
      Boolean ret_49;
      String ret_48;
      Tpl.Text l_stringOutputVariablesNames;
      Tpl.Text l_stringOutputVariablesVRs;
      Tpl.Text l_booleanOutputVariablesNames;
      Tpl.Text l_booleanOutputVariablesVRs;
      Tpl.Text l_integerOutputVariablesNames;
      Tpl.Text l_integerOutputVariablesVRs;
      Tpl.Text l_realOutputVariablesNames;
      Tpl.Text l_realOutputVariablesVRs;
      Tpl.Text l_stringInputVariablesReturnNames;
      Tpl.Text l_stringStartVariablesNames;
      Tpl.Text l_stringInputVariablesVRs;
      Integer ret_36;
      list<FMI.ModelVariables> ret_35;
      Tpl.Text l_nStringInputVariables;
      Tpl.Text l_booleanInputVariablesReturnNames;
      Tpl.Text l_booleanInputVariablesNames;
      Tpl.Text l_booleanInputVariablesVRs;
      Integer ret_30;
      list<FMI.ModelVariables> ret_29;
      Tpl.Text l_nBooleanInputVariables;
      Tpl.Text l_integerInputVariablesReturnNames;
      Tpl.Text l_integerInputVariablesNames;
      Tpl.Text l_integerInputVariablesVRs;
      Integer ret_24;
      list<FMI.ModelVariables> ret_23;
      Tpl.Text l_nIntegerInputVariables;
      Tpl.Text l_realInputVariablesReturnNames;
      Tpl.Text l_realInputVariablesNames;
      Tpl.Text l_realInputVariablesVRs;
      Integer ret_18;
      list<FMI.ModelVariables> ret_17;
      Tpl.Text l_nRealInputVariables;
      Tpl.Text l_stringDependentParametersNames;
      Tpl.Text l_stringDependentParametersVRs;
      Tpl.Text l_booleanDependentParametersNames;
      Tpl.Text l_booleanDependentParametersVRs;
      Tpl.Text l_integerDependentParametersNames;
      Tpl.Text l_integerDependentParametersVRs;
      Tpl.Text l_realDependentParametersNames;
      Tpl.Text l_realDependentParametersVRs;
      Tpl.Text l_stringParametersNames;
      Tpl.Text l_stringParametersVRs;
      Tpl.Text l_booleanParametersNames;
      Tpl.Text l_booleanParametersVRs;
      Tpl.Text l_integerParametersNames;
      Tpl.Text l_integerParametersVRs;
      Tpl.Text l_realParametersNames;
      Tpl.Text l_realParametersVRs;

    case ( txt,
           FMI.FMIIMPORT(fmiInfo = (i_fmiInfo as FMI.INFO(fmiModelIdentifier = i_fmiInfo_fmiModelIdentifier, fmiDescription = i_fmiInfo_fmiDescription, fmiNumberOfContinuousStates = i_fmiInfo_fmiNumberOfContinuousStates, fmiNumberOfEventIndicators = i_fmiInfo_fmiNumberOfEventIndicators)), fmiExperimentAnnotation = FMI.EXPERIMENTANNOTATION(fmiExperimentStartTime = i_fmiExperimentAnnotation_fmiExperimentStartTime, fmiExperimentStopTime = i_fmiExperimentAnnotation_fmiExperimentStopTime, fmiExperimentTolerance = i_fmiExperimentAnnotation_fmiExperimentTolerance), fmiModelVariablesList = i_fmiModelVariablesList, fmiTypeDefinitionsList = i_fmiTypeDefinitionsList, fmuWorkingDirectory = i_fmuWorkingDirectory, fmiLogLevel = i_fmiLogLevel, fmiDebugOutput = i_fmiDebugOutput, generateInputConnectors = i_generateInputConnectors, generateOutputConnectors = i_generateOutputConnectors) )
      equation
        l_realParametersVRs = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "real", "parameter", false, 1, "2.0");
        l_realParametersNames = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "real", "parameter", false, 2, "2.0");
        l_integerParametersVRs = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "integer", "parameter", false, 1, "2.0");
        l_integerParametersNames = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "integer", "parameter", false, 2, "2.0");
        l_booleanParametersVRs = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "boolean", "parameter", false, 1, "2.0");
        l_booleanParametersNames = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "boolean", "parameter", false, 2, "2.0");
        l_stringParametersVRs = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "string", "parameter", false, 1, "2.0");
        l_stringParametersNames = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "string", "parameter", false, 2, "2.0");
        l_realDependentParametersVRs = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "real", "parameter", true, 1, "2.0");
        l_realDependentParametersNames = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "real", "parameter", true, 2, "2.0");
        l_integerDependentParametersVRs = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "integer", "parameter", true, 1, "2.0");
        l_integerDependentParametersNames = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "integer", "parameter", true, 2, "2.0");
        l_booleanDependentParametersVRs = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "boolean", "parameter", true, 1, "2.0");
        l_booleanDependentParametersNames = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "boolean", "parameter", true, 2, "2.0");
        l_stringDependentParametersVRs = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "string", "parameter", true, 1, "2.0");
        l_stringDependentParametersNames = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "string", "parameter", true, 2, "2.0");
        ret_17 = FMI.filterModelVariables(i_fmiModelVariablesList, "real", "input");
        ret_18 = listLength(ret_17);
        l_nRealInputVariables = Tpl.writeStr(Tpl.emptyTxt, intString(ret_18));
        l_realInputVariablesVRs = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "real", "input", false, 1, "2.0");
        l_realInputVariablesNames = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "real", "input", false, 2, "2.0");
        l_realInputVariablesReturnNames = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "real", "input", false, 3, "2.0");
        ret_23 = FMI.filterModelVariables(i_fmiModelVariablesList, "integer", "input");
        ret_24 = listLength(ret_23);
        l_nIntegerInputVariables = Tpl.writeStr(Tpl.emptyTxt, intString(ret_24));
        l_integerInputVariablesVRs = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "integer", "input", false, 1, "2.0");
        l_integerInputVariablesNames = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "integer", "input", false, 2, "2.0");
        l_integerInputVariablesReturnNames = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "integer", "input", false, 3, "2.0");
        ret_29 = FMI.filterModelVariables(i_fmiModelVariablesList, "boolean", "input");
        ret_30 = listLength(ret_29);
        l_nBooleanInputVariables = Tpl.writeStr(Tpl.emptyTxt, intString(ret_30));
        l_booleanInputVariablesVRs = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "boolean", "input", false, 1, "2.0");
        l_booleanInputVariablesNames = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "boolean", "input", false, 2, "2.0");
        l_booleanInputVariablesReturnNames = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "boolean", "input", false, 3, "2.0");
        ret_35 = FMI.filterModelVariables(i_fmiModelVariablesList, "string", "input");
        ret_36 = listLength(ret_35);
        l_nStringInputVariables = Tpl.writeStr(Tpl.emptyTxt, intString(ret_36));
        l_stringInputVariablesVRs = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "string", "input", false, 1, "2.0");
        l_stringStartVariablesNames = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "string", "input", false, 2, "2.0");
        l_stringInputVariablesReturnNames = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "string", "input", false, 3, "2.0");
        l_realOutputVariablesVRs = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "real", "output", false, 1, "2.0");
        l_realOutputVariablesNames = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "real", "output", false, 2, "2.0");
        l_integerOutputVariablesVRs = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "integer", "output", false, 1, "2.0");
        l_integerOutputVariablesNames = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "integer", "output", false, 2, "2.0");
        l_booleanOutputVariablesVRs = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "boolean", "output", false, 1, "2.0");
        l_booleanOutputVariablesNames = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "boolean", "output", false, 2, "2.0");
        l_stringOutputVariablesVRs = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "string", "output", false, 1, "2.0");
        l_stringOutputVariablesNames = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "string", "output", false, 2, "2.0");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("model "));
        txt = Tpl.writeStr(txt, i_fmiInfo_fmiModelIdentifier);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        ret_48 = FMI.getFMIType(i_fmiInfo);
        txt = Tpl.writeStr(txt, ret_48);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_FMU"));
        ret_49 = stringEq(i_fmiInfo_fmiDescription, "");
        txt = fun_329(txt, ret_49, i_fmiInfo_fmiDescription);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = dumpFMITypeDefinitions(txt, i_fmiTypeDefinitionsList);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("constant String fmuWorkingDir = \""));
        txt = Tpl.writeStr(txt, i_fmuWorkingDirectory);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\";\n",
                                    "parameter Integer logLevel = "
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_fmiLogLevel));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " \"log level used during the loading of FMU\" annotation (Dialog(tab=\"FMI\", group=\"Enable logging\"));\n",
                                    "parameter Boolean debugLogging = "
                                }, false));
        txt = Tpl.writeStr(txt, Tpl.booleanString(i_fmiDebugOutput));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" \"enables the FMU simulation logging\" annotation (Dialog(tab=\"FMI\", group=\"Enable logging\"));\n"));
        txt = dumpFMIModelVariablesList(txt, "2.0", i_fmiModelVariablesList, i_fmiTypeDefinitionsList, i_generateInputConnectors, i_generateOutputConnectors);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("protected\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("FMI2ModelExchange fmi2me = FMI2ModelExchange(logLevel, fmuWorkingDir, \""));
        txt = Tpl.writeStr(txt, i_fmiInfo_fmiModelIdentifier);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\", debugLogging);\n",
                                    "constant Integer numberOfContinuousStates = "
                                }, false));
        ret_50 = listLength(i_fmiInfo_fmiNumberOfContinuousStates);
        txt = Tpl.writeStr(txt, intString(ret_50));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "Real fmi_x[numberOfContinuousStates] \"States\";\n",
                                    "Real fmi_x_new[numberOfContinuousStates](each fixed=true) \"New States\";\n",
                                    "constant Integer numberOfEventIndicators = "
                                }, false));
        ret_51 = listLength(i_fmiInfo_fmiNumberOfEventIndicators);
        txt = Tpl.writeStr(txt, intString(ret_51));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "Real fmi_z[numberOfEventIndicators] \"Events Indicators\";\n",
                                    "Boolean fmi_z_positive[numberOfEventIndicators](each fixed=true);\n",
                                    "parameter Real flowStartTime(fixed=false);\n",
                                    "Real flowTime;\n",
                                    "parameter Real flowEnterInitialization(fixed=false);\n",
                                    "parameter Real flowInitialized(fixed=false);\n",
                                    "parameter Real flowParamsStart(fixed=false);\n",
                                    "parameter Real flowInitInputs(fixed=false);\n",
                                    "Real flowStatesInputs;\n"
                                }, true));
        ret_52 = stringEq(Tpl.textString(l_realInputVariablesVRs), "");
        txt = fun_330(txt, ret_52, l_nRealInputVariables);
        txt = Tpl.softNewLine(txt);
        ret_53 = stringEq(Tpl.textString(l_realInputVariablesVRs), "");
        txt = fun_331(txt, ret_53, l_realInputVariablesReturnNames);
        txt = Tpl.softNewLine(txt);
        ret_54 = stringEq(Tpl.textString(l_integerInputVariablesVRs), "");
        txt = fun_332(txt, ret_54, l_nIntegerInputVariables);
        txt = Tpl.softNewLine(txt);
        ret_55 = stringEq(Tpl.textString(l_integerInputVariablesVRs), "");
        txt = fun_333(txt, ret_55, l_integerInputVariablesReturnNames);
        txt = Tpl.softNewLine(txt);
        ret_56 = stringEq(Tpl.textString(l_booleanInputVariablesVRs), "");
        txt = fun_334(txt, ret_56, l_nBooleanInputVariables);
        txt = Tpl.softNewLine(txt);
        ret_57 = stringEq(Tpl.textString(l_booleanInputVariablesVRs), "");
        txt = fun_335(txt, ret_57, l_booleanInputVariablesReturnNames);
        txt = Tpl.softNewLine(txt);
        ret_58 = stringEq(Tpl.textString(l_stringInputVariablesVRs), "");
        txt = fun_336(txt, ret_58, l_nStringInputVariables);
        txt = Tpl.softNewLine(txt);
        ret_59 = stringEq(Tpl.textString(l_stringInputVariablesVRs), "");
        txt = fun_337(txt, ret_59, l_stringInputVariablesReturnNames);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "Boolean callEventUpdate;\n",
                                    "Boolean newStatesAvailable(fixed = true);\n",
                                    "Real triggerDSSEvent;\n",
                                    "Real nextEventTime(fixed = true);\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "initial equation\n",
                                    "  flowStartTime = fmi2Functions.fmi2SetTime(fmi2me, time, 1);\n",
                                    "  flowEnterInitialization = fmi2Functions.fmi2EnterInitialization(fmi2me, flowParamsStart+flowInitInputs+flowStartTime);\n",
                                    "  flowInitialized = fmi2Functions.fmi2ExitInitialization(fmi2me, flowParamsStart+flowInitInputs+flowStartTime+flowEnterInitialization);\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        ret_60 = listLength(i_fmiInfo_fmiNumberOfContinuousStates);
        ret_61 = intGt(ret_60, 0);
        txt = fun_338(txt, ret_61);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "initial algorithm\n",
                                    "  flowParamsStart := 1;\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        ret_62 = stringEq(Tpl.textString(l_realParametersVRs), "");
        txt = fun_339(txt, ret_62, l_realParametersNames, l_realParametersVRs);
        txt = Tpl.softNewLine(txt);
        ret_63 = stringEq(Tpl.textString(l_integerParametersVRs), "");
        txt = fun_340(txt, ret_63, l_integerParametersNames, l_integerParametersVRs);
        txt = Tpl.softNewLine(txt);
        ret_64 = stringEq(Tpl.textString(l_booleanParametersVRs), "");
        txt = fun_341(txt, ret_64, l_booleanParametersNames, l_booleanParametersVRs);
        txt = Tpl.softNewLine(txt);
        ret_65 = stringEq(Tpl.textString(l_stringParametersVRs), "");
        txt = fun_342(txt, ret_65, l_stringParametersNames, l_stringParametersVRs);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("flowInitInputs := 1;\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("initial equation\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        ret_66 = stringEq(Tpl.textString(l_realDependentParametersVRs), "");
        txt = fun_343(txt, ret_66, l_realDependentParametersVRs, l_realDependentParametersNames);
        txt = Tpl.softNewLine(txt);
        ret_67 = stringEq(Tpl.textString(l_integerDependentParametersVRs), "");
        txt = fun_344(txt, ret_67, l_integerDependentParametersVRs, l_integerDependentParametersNames);
        txt = Tpl.softNewLine(txt);
        ret_68 = stringEq(Tpl.textString(l_booleanDependentParametersVRs), "");
        txt = fun_345(txt, ret_68, l_booleanDependentParametersVRs, l_booleanDependentParametersNames);
        txt = Tpl.softNewLine(txt);
        ret_69 = stringEq(Tpl.textString(l_stringDependentParametersVRs), "");
        txt = fun_346(txt, ret_69, l_stringDependentParametersVRs, l_stringDependentParametersNames);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "algorithm\n",
                                    "  flowTime := fmi2Functions.fmi2SetTime(fmi2me, time, flowInitialized);\n",
                                    "  /* algorithm section ensures that inputs to fmi (if any) are set directly after the new time is set */\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        ret_70 = stringEq(Tpl.textString(l_realInputVariablesVRs), "");
        txt = fun_347(txt, ret_70, l_realInputVariablesNames, l_realInputVariablesVRs);
        txt = Tpl.softNewLine(txt);
        ret_71 = stringEq(Tpl.textString(l_integerInputVariablesVRs), "");
        txt = fun_348(txt, ret_71, l_integerInputVariablesNames, l_integerInputVariablesVRs);
        txt = Tpl.softNewLine(txt);
        ret_72 = stringEq(Tpl.textString(l_booleanInputVariablesVRs), "");
        txt = fun_349(txt, ret_72, l_booleanInputVariablesNames, l_booleanInputVariablesVRs);
        txt = Tpl.softNewLine(txt);
        ret_73 = stringEq(Tpl.textString(l_stringInputVariablesVRs), "");
        txt = fun_350(txt, ret_73, l_stringStartVariablesNames, l_stringInputVariablesVRs);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("equation\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        ret_74 = stringEq(Tpl.textString(l_realInputVariablesVRs), "");
        txt = fun_351(txt, ret_74, l_realInputVariablesReturnNames);
        txt = Tpl.softNewLine(txt);
        ret_75 = stringEq(Tpl.textString(l_integerInputVariablesVRs), "");
        txt = fun_352(txt, ret_75, l_integerInputVariablesReturnNames);
        txt = Tpl.softNewLine(txt);
        ret_76 = stringEq(Tpl.textString(l_booleanInputVariablesVRs), "");
        txt = fun_353(txt, ret_76, l_booleanInputVariablesReturnNames);
        txt = Tpl.softNewLine(txt);
        ret_77 = stringEq(Tpl.textString(l_stringInputVariablesVRs), "");
        txt = fun_354(txt, ret_77, l_stringInputVariablesReturnNames);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "flowStatesInputs = fmi2Functions.fmi2SetContinuousStates(fmi2me, fmi_x, flowParamsStart + flowTime);\n",
                                    "der(fmi_x) = fmi2Functions.fmi2GetDerivatives(fmi2me, numberOfContinuousStates, flowStatesInputs);\n",
                                    "fmi_z  = fmi2Functions.fmi2GetEventIndicators(fmi2me, numberOfEventIndicators, flowStatesInputs);\n",
                                    "for i in 1:size(fmi_z,1) loop\n",
                                    "  fmi_z_positive[i] = if not terminal() then fmi_z[i] > 0 else pre(fmi_z_positive[i]);\n",
                                    "end for;\n",
                                    "\n",
                                    "triggerDSSEvent = noEvent(if callEventUpdate then flowStatesInputs+1.0 else flowStatesInputs-1.0);\n",
                                    "\n"
                                }, true));
        ret_78 = stringEq(Tpl.textString(l_realOutputVariablesNames), "");
        ret_79 = stringEq(Tpl.textString(l_realOutputVariablesVRs), "");
        ret_80 = boolAnd(ret_78, ret_79);
        txt = fun_355(txt, ret_80, l_realOutputVariablesVRs, l_realOutputVariablesNames);
        txt = Tpl.softNewLine(txt);
        ret_81 = stringEq(Tpl.textString(l_integerOutputVariablesNames), "");
        ret_82 = stringEq(Tpl.textString(l_integerOutputVariablesVRs), "");
        ret_83 = boolAnd(ret_81, ret_82);
        txt = fun_356(txt, ret_83, l_integerOutputVariablesVRs, l_integerOutputVariablesNames);
        txt = Tpl.softNewLine(txt);
        ret_84 = stringEq(Tpl.textString(l_booleanOutputVariablesNames), "");
        ret_85 = stringEq(Tpl.textString(l_booleanOutputVariablesVRs), "");
        ret_86 = boolAnd(ret_84, ret_85);
        txt = fun_357(txt, ret_86, l_booleanOutputVariablesVRs, l_booleanOutputVariablesNames);
        txt = Tpl.softNewLine(txt);
        ret_87 = stringEq(Tpl.textString(l_stringOutputVariablesNames), "");
        ret_88 = stringEq(Tpl.textString(l_stringOutputVariablesVRs), "");
        ret_89 = boolAnd(ret_87, ret_88);
        txt = fun_358(txt, ret_89, l_stringOutputVariablesVRs, l_stringOutputVariablesNames);
        txt = Tpl.softNewLine(txt);
        txt = dumpOutputGetEnumerationVariables(txt, i_fmiModelVariablesList, i_fmiTypeDefinitionsList, "fmi2Functions.fmi2GetInteger", "fmi2me");
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("callEventUpdate = fmi2Functions.fmi2CompletedIntegratorStep(fmi2me, flowStatesInputs+flowTime);\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("algorithm\n"));
        ret_90 = listLength(i_fmiInfo_fmiNumberOfEventIndicators);
        ret_91 = intGt(ret_90, 0);
        txt = fun_360(txt, ret_91, i_fmiInfo_fmiNumberOfEventIndicators);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "    newStatesAvailable := fmi2Functions.fmi2EventUpdate(fmi2me);\n",
                                    "    nextEventTime := fmi2Functions.fmi2nextEventTime(fmi2me, flowStatesInputs);\n"
                                }, true));
        ret_92 = listLength(i_fmiInfo_fmiNumberOfContinuousStates);
        ret_93 = intGt(ret_92, 0);
        txt = fun_362(txt, ret_93, i_fmiInfo_fmiNumberOfContinuousStates);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("  end when;\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("annotation(experiment(StartTime="));
        txt = Tpl.writeStr(txt, realString(i_fmiExperimentAnnotation_fmiExperimentStartTime));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", StopTime="));
        txt = Tpl.writeStr(txt, realString(i_fmiExperimentAnnotation_fmiExperimentStopTime));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", Tolerance="));
        txt = Tpl.writeStr(txt, realString(i_fmiExperimentAnnotation_fmiExperimentTolerance));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "));\n",
                                    "annotation (Icon(graphics={\n",
                                    "    Rectangle(\n",
                                    "      extent={{-100,100},{100,-100}},\n",
                                    "      lineColor={0,0,0},\n",
                                    "      fillColor={240,240,240},\n",
                                    "      fillPattern=FillPattern.Solid,\n",
                                    "      lineThickness=0.5),\n",
                                    "    Text(\n",
                                    "      extent={{-100,40},{100,0}},\n",
                                    "      lineColor={0,0,0},\n",
                                    "      textString=\"%name\"),\n",
                                    "    Text(\n",
                                    "      extent={{-100,-50},{100,-90}},\n",
                                    "      lineColor={0,0,0},\n",
                                    "      textString=\"V2.0\")}));\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "protected\n",
                                    "  class FMI2ModelExchange\n",
                                    "    extends ExternalObject;\n",
                                    "      function constructor\n",
                                    "        input Integer logLevel;\n",
                                    "        input String workingDirectory;\n",
                                    "        input String instanceName;\n",
                                    "        input Boolean debugLogging;\n",
                                    "        output FMI2ModelExchange fmi2me;\n",
                                    "        external \"C\" fmi2me = FMI2ModelExchangeConstructor_OMC(logLevel, workingDirectory, instanceName, debugLogging) annotation(Library = {\"OpenModelicaFMIRuntimeC\", \"fmilib\"});\n",
                                    "      end constructor;\n",
                                    "\n",
                                    "      function destructor\n",
                                    "        input FMI2ModelExchange fmi2me;\n",
                                    "        external \"C\" FMI2ModelExchangeDestructor_OMC(fmi2me) annotation(Library = {\"OpenModelicaFMIRuntimeC\", \"fmilib\"});\n",
                                    "      end destructor;\n",
                                    "  end FMI2ModelExchange;\n",
                                    "\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = dumpFMITypeDefinitionsMappingFunctions(txt, i_fmiTypeDefinitionsList);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = dumpFMITypeDefinitionsArrayMappingFunctions(txt, i_fmiTypeDefinitionsList);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "package fmi2Functions\n",
                                    "  function fmi2SetTime\n",
                                    "    input FMI2ModelExchange fmi2me;\n",
                                    "    input Real inTime;\n",
                                    "    input Real inFlow;\n",
                                    "    output Real outFlow = inFlow;\n",
                                    "    external \"C\" fmi2SetTime_OMC(fmi2me, inTime) annotation(Library = {\"OpenModelicaFMIRuntimeC\", \"fmilib\"});\n",
                                    "  end fmi2SetTime;\n",
                                    "\n",
                                    "  function fmi2EnterInitialization\n",
                                    "    input FMI2ModelExchange fmi2me;\n",
                                    "    input Real inFlowVariable;\n",
                                    "    output Real outFlowVariable = inFlowVariable;\n",
                                    "    external \"C\" fmi2EnterInitializationModel_OMC(fmi2me) annotation(Library = {\"OpenModelicaFMIRuntimeC\", \"fmilib\"});\n",
                                    "  end fmi2EnterInitialization;\n",
                                    "\n",
                                    "  function fmi2ExitInitialization\n",
                                    "    input FMI2ModelExchange fmi2me;\n",
                                    "    input Real inFlowVariable;\n",
                                    "    output Real outFlowVariable = inFlowVariable;\n",
                                    "    external \"C\" fmi2ExitInitializationModel_OMC(fmi2me) annotation(Library = {\"OpenModelicaFMIRuntimeC\", \"fmilib\"});\n",
                                    "  end fmi2ExitInitialization;\n",
                                    "\n",
                                    "  function fmi2GetContinuousStates\n",
                                    "    input FMI2ModelExchange fmi2me;\n",
                                    "    input Integer numberOfContinuousStates;\n",
                                    "    input Real inFlowParams;\n",
                                    "    output Real fmi_x[numberOfContinuousStates];\n",
                                    "    external \"C\" fmi2GetContinuousStates_OMC(fmi2me, numberOfContinuousStates, inFlowParams, fmi_x) annotation(Library = {\"OpenModelicaFMIRuntimeC\", \"fmilib\"});\n",
                                    "  end fmi2GetContinuousStates;\n",
                                    "\n",
                                    "  function fmi2SetContinuousStates\n",
                                    "    input FMI2ModelExchange fmi2me;\n",
                                    "    input Real fmi_x[:];\n",
                                    "    input Real inFlowParams;\n",
                                    "    output Real outFlowStates;\n",
                                    "    external \"C\" outFlowStates = fmi2SetContinuousStates_OMC(fmi2me, size(fmi_x, 1), inFlowParams, fmi_x) annotation(Library = {\"OpenModelicaFMIRuntimeC\", \"fmilib\"});\n",
                                    "  end fmi2SetContinuousStates;\n",
                                    "\n",
                                    "  function fmi2GetDerivatives\n",
                                    "    input FMI2ModelExchange fmi2me;\n",
                                    "    input Integer numberOfContinuousStates;\n",
                                    "    input Real inFlowStates;\n",
                                    "    output Real fmi_x[numberOfContinuousStates];\n",
                                    "    external \"C\" fmi2GetDerivatives_OMC(fmi2me, numberOfContinuousStates, inFlowStates, fmi_x) annotation(Library = {\"OpenModelicaFMIRuntimeC\", \"fmilib\"});\n",
                                    "  end fmi2GetDerivatives;\n",
                                    "\n",
                                    "  function fmi2GetEventIndicators\n",
                                    "    input FMI2ModelExchange fmi2me;\n",
                                    "    input Integer numberOfEventIndicators;\n",
                                    "    input Real inFlowStates;\n",
                                    "    output Real fmi_z[numberOfEventIndicators];\n",
                                    "    external \"C\" fmi2GetEventIndicators_OMC(fmi2me, numberOfEventIndicators, inFlowStates, fmi_z) annotation(Library = {\"OpenModelicaFMIRuntimeC\", \"fmilib\"});\n",
                                    "  end fmi2GetEventIndicators;\n",
                                    "\n",
                                    "  function fmi2GetReal\n",
                                    "    input FMI2ModelExchange fmi2me;\n",
                                    "    input Real realValuesReferences[:];\n",
                                    "    input Real inFlowStatesInput;\n",
                                    "    output Real realValues[size(realValuesReferences, 1)];\n",
                                    "    external \"C\" fmi2GetReal_OMC(fmi2me, size(realValuesReferences, 1), realValuesReferences, inFlowStatesInput, realValues, 1) annotation(Library = {\"OpenModelicaFMIRuntimeC\", \"fmilib\"});\n",
                                    "  end fmi2GetReal;\n",
                                    "\n",
                                    "  function fmi2SetReal\n",
                                    "    input FMI2ModelExchange fmi2me;\n",
                                    "    input Real realValueReferences[:];\n",
                                    "    input Real realValues[size(realValueReferences, 1)];\n",
                                    "    output Real outValues[size(realValueReferences, 1)] = realValues;\n",
                                    "    external \"C\" fmi2SetReal_OMC(fmi2me, size(realValueReferences, 1), realValueReferences, realValues, 1) annotation(Library = {\"OpenModelicaFMIRuntimeC\", \"fmilib\"});\n",
                                    "  end fmi2SetReal;\n",
                                    "\n",
                                    "  function fmi2SetRealParameter\n",
                                    "    input FMI2ModelExchange fmi2me;\n",
                                    "    input Real realValueReferences[:];\n",
                                    "    input Real realValues[size(realValueReferences, 1)];\n",
                                    "    output Real out_Value = 1;\n",
                                    "    external \"C\" fmi2SetReal_OMC(fmi2me, size(realValueReferences, 1), realValueReferences, realValues, 1) annotation(Library = {\"OpenModelicaFMIRuntimeC\", \"fmilib\"});\n",
                                    "  end fmi2SetRealParameter;\n",
                                    "\n",
                                    "  function fmi2GetInteger\n",
                                    "    input FMI2ModelExchange fmi2me;\n",
                                    "    input Real integerValueReferences[:];\n",
                                    "    input Real inFlowStatesInput;\n",
                                    "    output Integer integerValues[size(integerValueReferences, 1)];\n",
                                    "    external \"C\" fmi2GetInteger_OMC(fmi2me, size(integerValueReferences, 1), integerValueReferences, inFlowStatesInput, integerValues, 1) annotation(Library = {\"OpenModelicaFMIRuntimeC\", \"fmilib\"});\n",
                                    "  end fmi2GetInteger;\n",
                                    "\n",
                                    "  function fmi2SetInteger\n",
                                    "    input FMI2ModelExchange fmi2me;\n",
                                    "    input Real integerValuesReferences[:];\n",
                                    "    input Integer integerValues[size(integerValuesReferences, 1)];\n",
                                    "    output Integer outValues[size(integerValuesReferences, 1)] = integerValues;\n",
                                    "    external \"C\" fmi2SetInteger_OMC(fmi2me, size(integerValuesReferences, 1), integerValuesReferences, integerValues, 1) annotation(Library = {\"OpenModelicaFMIRuntimeC\", \"fmilib\"});\n",
                                    "  end fmi2SetInteger;\n",
                                    "\n",
                                    "  function fmi2SetIntegerParameter\n",
                                    "    input FMI2ModelExchange fmi2me;\n",
                                    "    input Real integerValuesReferences[:];\n",
                                    "    input Integer integerValues[size(integerValuesReferences, 1)];\n",
                                    "    output Real out_Value = 1;\n",
                                    "    external \"C\" fmi2SetInteger_OMC(fmi2me, size(integerValuesReferences, 1), integerValuesReferences, integerValues, 1) annotation(Library = {\"OpenModelicaFMIRuntimeC\", \"fmilib\"});\n",
                                    "  end fmi2SetIntegerParameter;\n",
                                    "\n",
                                    "  function fmi2GetBoolean\n",
                                    "    input FMI2ModelExchange fmi2me;\n",
                                    "    input Real booleanValuesReferences[:];\n",
                                    "    input Real inFlowStatesInput;\n",
                                    "    output Boolean booleanValues[size(booleanValuesReferences, 1)];\n",
                                    "    external \"C\" fmi2GetBoolean_OMC(fmi2me, size(booleanValuesReferences, 1), booleanValuesReferences, inFlowStatesInput, booleanValues, 1) annotation(Library = {\"OpenModelicaFMIRuntimeC\", \"fmilib\"});\n",
                                    "  end fmi2GetBoolean;\n",
                                    "\n",
                                    "  function fmi2SetBoolean\n",
                                    "    input FMI2ModelExchange fmi2me;\n",
                                    "    input Real booleanValueReferences[:];\n",
                                    "    input Boolean booleanValues[size(booleanValueReferences, 1)];\n",
                                    "    output Boolean outValues[size(booleanValueReferences, 1)] = booleanValues;\n",
                                    "    external \"C\" fmi2SetBoolean_OMC(fmi2me, size(booleanValueReferences, 1), booleanValueReferences, booleanValues, 1) annotation(Library = {\"OpenModelicaFMIRuntimeC\", \"fmilib\"});\n",
                                    "  end fmi2SetBoolean;\n",
                                    "\n",
                                    "  function fmi2SetBooleanParameter\n",
                                    "    input FMI2ModelExchange fmi2me;\n",
                                    "    input Real booleanValueReferences[:];\n",
                                    "    input Boolean booleanValues[size(booleanValueReferences, 1)];\n",
                                    "    output Real out_Value = 1;\n",
                                    "    external \"C\" fmi2SetBoolean_OMC(fmi2me, size(booleanValueReferences, 1), booleanValueReferences, booleanValues, 1) annotation(Library = {\"OpenModelicaFMIRuntimeC\", \"fmilib\"});\n",
                                    "  end fmi2SetBooleanParameter;\n",
                                    "\n",
                                    "  function fmi2GetString\n",
                                    "    input FMI2ModelExchange fmi2me;\n",
                                    "    input Real stringValuesReferences[:];\n",
                                    "    input Real inFlowStatesInput;\n",
                                    "    output String stringValues[size(stringValuesReferences, 1)];\n",
                                    "    external \"C\" fmi2GetString_OMC(fmi2me, size(stringValuesReferences, 1), stringValuesReferences, inFlowStatesInput, stringValues, 1) annotation(Library = {\"OpenModelicaFMIRuntimeC\", \"fmilib\"});\n",
                                    "  end fmi2GetString;\n",
                                    "\n",
                                    "  function fmi2SetString\n",
                                    "    input FMI2ModelExchange fmi2me;\n",
                                    "    input Real stringValueReferences[:];\n",
                                    "    input String stringValues[size(stringValueReferences, 1)];\n",
                                    "    output String outValues[size(stringValueReferences, 1)] = stringValues;\n",
                                    "    external \"C\" fmi2SetString_OMC(fmi2me, size(stringValueReferences, 1), stringValueReferences, stringValues, 1) annotation(Library = {\"OpenModelicaFMIRuntimeC\", \"fmilib\"});\n",
                                    "  end fmi2SetString;\n",
                                    "\n",
                                    "  function fmi2SetStringParameter\n",
                                    "    input FMI2ModelExchange fmi2me;\n",
                                    "    input Real stringValueReferences[:];\n",
                                    "    input String stringValues[size(stringValueReferences, 1)];\n",
                                    "    output Real out_Value = 1;\n",
                                    "    external \"C\" fmi2SetString_OMC(fmi2me, size(stringValueReferences, 1), stringValueReferences, stringValues, 1) annotation(Library = {\"OpenModelicaFMIRuntimeC\", \"fmilib\"});\n",
                                    "  end fmi2SetStringParameter;\n",
                                    "\n",
                                    "  function fmi2EventUpdate\n",
                                    "    input FMI2ModelExchange fmi2me;\n",
                                    "    output Boolean outNewStatesAvailable;\n",
                                    "    external \"C\" outNewStatesAvailable = fmi2EventUpdate_OMC(fmi2me) annotation(Library = {\"OpenModelicaFMIRuntimeC\", \"fmilib\"});\n",
                                    "  end fmi2EventUpdate;\n",
                                    "\n",
                                    "  function fmi2nextEventTime\n",
                                    "    input FMI2ModelExchange fmi2me;\n",
                                    "    input Real inFlowStates;\n",
                                    "    output Real outNewnextTime;\n",
                                    "    external \"C\" outNewnextTime = fmi2nextEventTime_OMC(fmi2me, inFlowStates) annotation(Library = {\"OpenModelicaFMIRuntimeC\", \"fmilib\"});\n",
                                    "  end fmi2nextEventTime;\n",
                                    "\n",
                                    "  function fmi2CompletedIntegratorStep\n",
                                    "    input FMI2ModelExchange fmi2me;\n",
                                    "    input Real inFlowStates;\n",
                                    "    output Boolean outCallEventUpdate;\n",
                                    "    external \"C\" outCallEventUpdate = fmi2CompletedIntegratorStep_OMC(fmi2me, inFlowStates) annotation(Library = {\"OpenModelicaFMIRuntimeC\", \"fmilib\"});\n",
                                    "  end fmi2CompletedIntegratorStep;\n",
                                    "end fmi2Functions;\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("end "));
        txt = Tpl.writeStr(txt, i_fmiInfo_fmiModelIdentifier);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        ret_94 = FMI.getFMIType(i_fmiInfo);
        txt = Tpl.writeStr(txt, ret_94);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_FMU;"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end importFMU2ModelExchange;

protected function fun_364
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_fmiInfo_fmiDescription;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_fmiInfo_fmiDescription)
    local
      Tpl.Text txt;
      String a_fmiInfo_fmiDescription;

    case ( txt,
           false,
           a_fmiInfo_fmiDescription )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" \""));
        txt = Tpl.writeStr(txt, a_fmiInfo_fmiDescription);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_364;

protected function fun_365
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_realInputVariablesReturnNames;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_realInputVariablesReturnNames)
    local
      Tpl.Text txt;
      Tpl.Text a_realInputVariablesReturnNames;

    case ( txt,
           false,
           a_realInputVariablesReturnNames )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Real "));
        txt = Tpl.writeText(txt, a_realInputVariablesReturnNames);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_365;

protected function fun_366
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_integerInputVariablesReturnNames;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_integerInputVariablesReturnNames)
    local
      Tpl.Text txt;
      Tpl.Text a_integerInputVariablesReturnNames;

    case ( txt,
           false,
           a_integerInputVariablesReturnNames )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Integer "));
        txt = Tpl.writeText(txt, a_integerInputVariablesReturnNames);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_366;

protected function fun_367
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_booleanInputVariablesReturnNames;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_booleanInputVariablesReturnNames)
    local
      Tpl.Text txt;
      Tpl.Text a_booleanInputVariablesReturnNames;

    case ( txt,
           false,
           a_booleanInputVariablesReturnNames )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Boolean "));
        txt = Tpl.writeText(txt, a_booleanInputVariablesReturnNames);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_367;

protected function fun_368
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_stringInputVariablesReturnNames;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_stringInputVariablesReturnNames)
    local
      Tpl.Text txt;
      Tpl.Text a_stringInputVariablesReturnNames;

    case ( txt,
           false,
           a_stringInputVariablesReturnNames )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("String "));
        txt = Tpl.writeText(txt, a_stringInputVariablesReturnNames);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_368;

protected function fun_369
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_realOutputVariablesVRs;
  input Tpl.Text in_a_realOutputVariablesNames;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_realOutputVariablesVRs, in_a_realOutputVariablesNames)
    local
      Tpl.Text txt;
      Tpl.Text a_realOutputVariablesVRs;
      Tpl.Text a_realOutputVariablesNames;

    case ( txt,
           false,
           a_realOutputVariablesVRs,
           a_realOutputVariablesNames )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("{"));
        txt = Tpl.writeText(txt, a_realOutputVariablesNames);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("} = fmi1Functions.fmi1GetReal(fmi1cs, {"));
        txt = Tpl.writeText(txt, a_realOutputVariablesVRs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}, flowInitialized);"));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_369;

protected function fun_370
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_integerOutputVariablesVRs;
  input Tpl.Text in_a_integerOutputVariablesNames;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_integerOutputVariablesVRs, in_a_integerOutputVariablesNames)
    local
      Tpl.Text txt;
      Tpl.Text a_integerOutputVariablesVRs;
      Tpl.Text a_integerOutputVariablesNames;

    case ( txt,
           false,
           a_integerOutputVariablesVRs,
           a_integerOutputVariablesNames )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("{"));
        txt = Tpl.writeText(txt, a_integerOutputVariablesNames);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("} = fmi1Functions.fmi1GetInteger(fmi1cs, {"));
        txt = Tpl.writeText(txt, a_integerOutputVariablesVRs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}, flowInitialized);"));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_370;

protected function fun_371
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_booleanOutputVariablesVRs;
  input Tpl.Text in_a_booleanOutputVariablesNames;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_booleanOutputVariablesVRs, in_a_booleanOutputVariablesNames)
    local
      Tpl.Text txt;
      Tpl.Text a_booleanOutputVariablesVRs;
      Tpl.Text a_booleanOutputVariablesNames;

    case ( txt,
           false,
           a_booleanOutputVariablesVRs,
           a_booleanOutputVariablesNames )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("{"));
        txt = Tpl.writeText(txt, a_booleanOutputVariablesNames);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("} = fmi1Functions.fmi1GetBoolean(fmi1cs, {"));
        txt = Tpl.writeText(txt, a_booleanOutputVariablesVRs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}, flowInitialized);"));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_371;

protected function fun_372
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_stringOutputVariablesVRs;
  input Tpl.Text in_a_stringOutputVariablesNames;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_stringOutputVariablesVRs, in_a_stringOutputVariablesNames)
    local
      Tpl.Text txt;
      Tpl.Text a_stringOutputVariablesVRs;
      Tpl.Text a_stringOutputVariablesNames;

    case ( txt,
           false,
           a_stringOutputVariablesVRs,
           a_stringOutputVariablesNames )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("{"));
        txt = Tpl.writeText(txt, a_stringOutputVariablesNames);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("} = fmi1Functions.fmi1GetString(fmi1cs, {"));
        txt = Tpl.writeText(txt, a_stringOutputVariablesVRs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}, flowInitialized);"));
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_372;

protected function fun_373
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_realInputVariablesNames;
  input Tpl.Text in_a_realInputVariablesVRs;
  input Tpl.Text in_a_realInputVariablesReturnNames;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_realInputVariablesNames, in_a_realInputVariablesVRs, in_a_realInputVariablesReturnNames)
    local
      Tpl.Text txt;
      Tpl.Text a_realInputVariablesNames;
      Tpl.Text a_realInputVariablesVRs;
      Tpl.Text a_realInputVariablesReturnNames;

    case ( txt,
           false,
           a_realInputVariablesNames,
           a_realInputVariablesVRs,
           a_realInputVariablesReturnNames )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("{"));
        txt = Tpl.writeText(txt, a_realInputVariablesReturnNames);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("} = fmi1Functions.fmi1SetReal(fmi1cs, {"));
        txt = Tpl.writeText(txt, a_realInputVariablesVRs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}, {"));
        txt = Tpl.writeText(txt, a_realInputVariablesNames);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("});"));
      then txt;

    case ( txt,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_373;

protected function fun_374
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_integerInputVariablesNames;
  input Tpl.Text in_a_integerInputVariablesVRs;
  input Tpl.Text in_a_integerInputVariablesReturnNames;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_integerInputVariablesNames, in_a_integerInputVariablesVRs, in_a_integerInputVariablesReturnNames)
    local
      Tpl.Text txt;
      Tpl.Text a_integerInputVariablesNames;
      Tpl.Text a_integerInputVariablesVRs;
      Tpl.Text a_integerInputVariablesReturnNames;

    case ( txt,
           false,
           a_integerInputVariablesNames,
           a_integerInputVariablesVRs,
           a_integerInputVariablesReturnNames )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("{"));
        txt = Tpl.writeText(txt, a_integerInputVariablesReturnNames);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("} = fmi1Functions.fmi1SetInteger(fmi1cs, {"));
        txt = Tpl.writeText(txt, a_integerInputVariablesVRs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}, {"));
        txt = Tpl.writeText(txt, a_integerInputVariablesNames);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("});"));
      then txt;

    case ( txt,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_374;

protected function fun_375
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_booleanInputVariablesNames;
  input Tpl.Text in_a_booleanInputVariablesVRs;
  input Tpl.Text in_a_booleanInputVariablesReturnNames;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_booleanInputVariablesNames, in_a_booleanInputVariablesVRs, in_a_booleanInputVariablesReturnNames)
    local
      Tpl.Text txt;
      Tpl.Text a_booleanInputVariablesNames;
      Tpl.Text a_booleanInputVariablesVRs;
      Tpl.Text a_booleanInputVariablesReturnNames;

    case ( txt,
           false,
           a_booleanInputVariablesNames,
           a_booleanInputVariablesVRs,
           a_booleanInputVariablesReturnNames )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("{"));
        txt = Tpl.writeText(txt, a_booleanInputVariablesReturnNames);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("} = fmi1Functions.fmi1SetBoolean(fmi1cs, {"));
        txt = Tpl.writeText(txt, a_booleanInputVariablesVRs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}, {"));
        txt = Tpl.writeText(txt, a_booleanInputVariablesNames);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("});"));
      then txt;

    case ( txt,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_375;

protected function fun_376
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Tpl.Text in_a_stringStartVariablesNames;
  input Tpl.Text in_a_stringInputVariablesVRs;
  input Tpl.Text in_a_stringInputVariablesReturnNames;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_stringStartVariablesNames, in_a_stringInputVariablesVRs, in_a_stringInputVariablesReturnNames)
    local
      Tpl.Text txt;
      Tpl.Text a_stringStartVariablesNames;
      Tpl.Text a_stringInputVariablesVRs;
      Tpl.Text a_stringInputVariablesReturnNames;

    case ( txt,
           false,
           a_stringStartVariablesNames,
           a_stringInputVariablesVRs,
           a_stringInputVariablesReturnNames )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("{"));
        txt = Tpl.writeText(txt, a_stringInputVariablesReturnNames);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("} = fmi1Functions.fmi1SetString(fmi1cs, {"));
        txt = Tpl.writeText(txt, a_stringInputVariablesVRs);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}, {"));
        txt = Tpl.writeText(txt, a_stringStartVariablesNames);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("});"));
      then txt;

    case ( txt,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_376;

public function importFMU1CoSimulationStandAlone
  input Tpl.Text in_txt;
  input FMI.FmiImport in_a_fmi;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fmi)
    local
      Tpl.Text txt;
      Real i_fmiExperimentAnnotation_fmiExperimentTolerance;
      Boolean i_generateOutputConnectors;
      Boolean i_generateInputConnectors;
      Real i_fmiExperimentAnnotation_fmiExperimentStopTime;
      Real i_fmiExperimentAnnotation_fmiExperimentStartTime;
      Boolean i_fmiDebugOutput;
      Integer i_fmiLogLevel;
      String i_fmuWorkingDirectory;
      list<FMI.TypeDefinitions> i_fmiTypeDefinitionsList;
      String i_fmiInfo_fmiDescription;
      FMI.Info i_fmiInfo;
      String i_fmiInfo_fmiModelIdentifier;
      list<FMI.ModelVariables> i_fmiModelVariablesList;
      String ret_58;
      Boolean ret_57;
      Boolean ret_56;
      Boolean ret_55;
      Boolean ret_54;
      Boolean ret_53;
      Boolean ret_52;
      Boolean ret_51;
      Boolean ret_50;
      Boolean ret_49;
      Boolean ret_48;
      Boolean ret_47;
      Boolean ret_46;
      Boolean ret_45;
      Boolean ret_44;
      Boolean ret_43;
      Boolean ret_42;
      Boolean ret_41;
      Boolean ret_40;
      Boolean ret_39;
      Boolean ret_38;
      Boolean ret_37;
      String ret_36;
      Tpl.Text l_stringOutputVariablesNames;
      Tpl.Text l_stringOutputVariablesVRs;
      Tpl.Text l_booleanOutputVariablesNames;
      Tpl.Text l_booleanOutputVariablesVRs;
      Tpl.Text l_integerOutputVariablesNames;
      Tpl.Text l_integerOutputVariablesVRs;
      Tpl.Text l_realOutputVariablesNames;
      Tpl.Text l_realOutputVariablesVRs;
      Tpl.Text l_stringInputVariablesReturnNames;
      Tpl.Text l_stringStartVariablesNames;
      Tpl.Text l_stringInputVariablesVRs;
      Tpl.Text l_booleanInputVariablesReturnNames;
      Tpl.Text l_booleanInputVariablesNames;
      Tpl.Text l_booleanInputVariablesVRs;
      Tpl.Text l_integerInputVariablesReturnNames;
      Tpl.Text l_integerInputVariablesNames;
      Tpl.Text l_integerInputVariablesVRs;
      Tpl.Text l_realInputVariablesReturnNames;
      Tpl.Text l_realInputVariablesNames;
      Tpl.Text l_realInputVariablesVRs;
      Tpl.Text l_stringDependentParametersNames;
      Tpl.Text l_stringDependentParametersVRs;
      Tpl.Text l_booleanDependentParametersNames;
      Tpl.Text l_booleanDependentParametersVRs;
      Tpl.Text l_integerDependentParametersNames;
      Tpl.Text l_integerDependentParametersVRs;
      Tpl.Text l_realDependentParametersNames;
      Tpl.Text l_realDependentParametersVRs;
      Tpl.Text l_stringParametersNames;
      Tpl.Text l_stringParametersVRs;
      Tpl.Text l_booleanParametersNames;
      Tpl.Text l_booleanParametersVRs;
      Tpl.Text l_integerParametersNames;
      Tpl.Text l_integerParametersVRs;
      Tpl.Text l_realParametersNames;
      Tpl.Text l_realParametersVRs;

    case ( txt,
           FMI.FMIIMPORT(fmiInfo = (i_fmiInfo as FMI.INFO(fmiModelIdentifier = i_fmiInfo_fmiModelIdentifier, fmiDescription = i_fmiInfo_fmiDescription)), fmiExperimentAnnotation = FMI.EXPERIMENTANNOTATION(fmiExperimentStartTime = i_fmiExperimentAnnotation_fmiExperimentStartTime, fmiExperimentStopTime = i_fmiExperimentAnnotation_fmiExperimentStopTime, fmiExperimentTolerance = i_fmiExperimentAnnotation_fmiExperimentTolerance), fmiModelVariablesList = i_fmiModelVariablesList, fmiTypeDefinitionsList = i_fmiTypeDefinitionsList, fmuWorkingDirectory = i_fmuWorkingDirectory, fmiLogLevel = i_fmiLogLevel, fmiDebugOutput = i_fmiDebugOutput, generateInputConnectors = i_generateInputConnectors, generateOutputConnectors = i_generateOutputConnectors) )
      equation
        l_realParametersVRs = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "real", "parameter", false, 1, "1.0");
        l_realParametersNames = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "real", "parameter", false, 2, "1.0");
        l_integerParametersVRs = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "integer", "parameter", false, 1, "1.0");
        l_integerParametersNames = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "integer", "parameter", false, 2, "1.0");
        l_booleanParametersVRs = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "boolean", "parameter", false, 1, "1.0");
        l_booleanParametersNames = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "boolean", "parameter", false, 2, "1.0");
        l_stringParametersVRs = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "string", "parameter", false, 1, "1.0");
        l_stringParametersNames = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "string", "parameter", false, 2, "1.0");
        l_realDependentParametersVRs = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "real", "parameter", true, 1, "1.0");
        l_realDependentParametersNames = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "real", "parameter", true, 2, "1.0");
        l_integerDependentParametersVRs = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "integer", "parameter", true, 1, "1.0");
        l_integerDependentParametersNames = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "integer", "parameter", true, 2, "1.0");
        l_booleanDependentParametersVRs = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "boolean", "parameter", true, 1, "1.0");
        l_booleanDependentParametersNames = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "boolean", "parameter", true, 2, "1.0");
        l_stringDependentParametersVRs = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "string", "parameter", true, 1, "1.0");
        l_stringDependentParametersNames = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "string", "parameter", true, 2, "1.0");
        l_realInputVariablesVRs = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "real", "input", false, 1, "1.0");
        l_realInputVariablesNames = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "real", "input", false, 2, "1.0");
        l_realInputVariablesReturnNames = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "real", "input", false, 3, "1.0");
        l_integerInputVariablesVRs = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "integer", "input", false, 1, "1.0");
        l_integerInputVariablesNames = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "integer", "input", false, 2, "1.0");
        l_integerInputVariablesReturnNames = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "integer", "input", false, 3, "1.0");
        l_booleanInputVariablesVRs = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "boolean", "input", false, 1, "1.0");
        l_booleanInputVariablesNames = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "boolean", "input", false, 2, "1.0");
        l_booleanInputVariablesReturnNames = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "boolean", "input", false, 3, "1.0");
        l_stringInputVariablesVRs = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "string", "input", false, 1, "1.0");
        l_stringStartVariablesNames = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "string", "input", false, 2, "1.0");
        l_stringInputVariablesReturnNames = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "string", "input", false, 3, "1.0");
        l_realOutputVariablesVRs = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "real", "output", false, 1, "1.0");
        l_realOutputVariablesNames = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "real", "output", false, 2, "1.0");
        l_integerOutputVariablesVRs = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "integer", "output", false, 1, "1.0");
        l_integerOutputVariablesNames = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "integer", "output", false, 2, "1.0");
        l_booleanOutputVariablesVRs = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "boolean", "output", false, 1, "1.0");
        l_booleanOutputVariablesNames = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "boolean", "output", false, 2, "1.0");
        l_stringOutputVariablesVRs = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "string", "output", false, 1, "1.0");
        l_stringOutputVariablesNames = dumpVariables(Tpl.emptyTxt, i_fmiModelVariablesList, "string", "output", false, 2, "1.0");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("model "));
        txt = Tpl.writeStr(txt, i_fmiInfo_fmiModelIdentifier);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        ret_36 = FMI.getFMIType(i_fmiInfo);
        txt = Tpl.writeStr(txt, ret_36);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_FMU"));
        ret_37 = stringEq(i_fmiInfo_fmiDescription, "");
        txt = fun_364(txt, ret_37, i_fmiInfo_fmiDescription);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = dumpFMITypeDefinitions(txt, i_fmiTypeDefinitionsList);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("constant String fmuLocation = \"file://"));
        txt = Tpl.writeStr(txt, i_fmuWorkingDirectory);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "/resources\";\n",
                                    "constant String fmuWorkingDir = \""
                                }, false));
        txt = Tpl.writeStr(txt, i_fmuWorkingDirectory);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\";\n",
                                    "parameter Integer logLevel = "
                                }, false));
        txt = Tpl.writeStr(txt, intString(i_fmiLogLevel));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " \"log level used during the loading of FMU\" annotation (Dialog(tab=\"FMI\", group=\"Enable logging\"));\n",
                                    "parameter Boolean debugLogging = "
                                }, false));
        txt = Tpl.writeStr(txt, Tpl.booleanString(i_fmiDebugOutput));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " \"enables the FMU simulation logging\" annotation (Dialog(tab=\"FMI\", group=\"Enable logging\"));\n",
                                    "constant String mimeType = \"\";\n",
                                    "constant Real timeout = 0.0;\n",
                                    "constant Boolean visible = false;\n",
                                    "constant Boolean interactive = false;\n",
                                    "parameter Real startTime = "
                                }, false));
        txt = Tpl.writeStr(txt, realString(i_fmiExperimentAnnotation_fmiExperimentStartTime));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " \"start time used to initialize the slave\" annotation (Dialog(tab=\"FMI\", group=\"Step time\"));\n",
                                    "parameter Real stopTime = "
                                }, false));
        txt = Tpl.writeStr(txt, realString(i_fmiExperimentAnnotation_fmiExperimentStopTime));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    " \"stop time used to initialize the slave\" annotation (Dialog(tab=\"FMI\", group=\"Step time\"));\n",
                                    "parameter Real numberOfSteps = 500 annotation (Dialog(tab=\"FMI\", group=\"Step time\"));\n",
                                    "parameter Real communicationStepSize = (stopTime-startTime)/numberOfSteps \"step size used by fmiDoStep\" annotation (Dialog(tab=\"FMI\", group=\"Step time\"));\n",
                                    "constant Boolean stopTimeDefined = true;\n"
                                }, true));
        txt = dumpFMIModelVariablesList(txt, "1.0", i_fmiModelVariablesList, i_fmiTypeDefinitionsList, i_generateInputConnectors, i_generateOutputConnectors);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("protected\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("FMI1CoSimulation fmi1cs = FMI1CoSimulation(logLevel, fmuWorkingDir, \""));
        txt = Tpl.writeStr(txt, i_fmiInfo_fmiModelIdentifier);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\", debugLogging, fmuLocation, mimeType, timeout, visible, interactive, startTime, stopTimeDefined, stopTime);\n",
                                    "parameter Real flowInitialized(fixed=false);\n",
                                    "Real flowStep;\n"
                                }, true));
        ret_38 = stringEq(Tpl.textString(l_realInputVariablesVRs), "");
        txt = fun_365(txt, ret_38, l_realInputVariablesReturnNames);
        txt = Tpl.softNewLine(txt);
        ret_39 = stringEq(Tpl.textString(l_integerInputVariablesVRs), "");
        txt = fun_366(txt, ret_39, l_integerInputVariablesReturnNames);
        txt = Tpl.softNewLine(txt);
        ret_40 = stringEq(Tpl.textString(l_booleanInputVariablesVRs), "");
        txt = fun_367(txt, ret_40, l_booleanInputVariablesReturnNames);
        txt = Tpl.softNewLine(txt);
        ret_41 = stringEq(Tpl.textString(l_stringInputVariablesVRs), "");
        txt = fun_368(txt, ret_41, l_stringInputVariablesReturnNames);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "initial equation\n",
                                    "  flowInitialized = fmi1Functions.fmi1InitializeSlave(fmi1cs, 1);\n",
                                    "equation\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        ret_42 = stringEq(Tpl.textString(l_realOutputVariablesNames), "");
        ret_43 = stringEq(Tpl.textString(l_realOutputVariablesVRs), "");
        ret_44 = boolAnd(ret_42, ret_43);
        txt = fun_369(txt, ret_44, l_realOutputVariablesVRs, l_realOutputVariablesNames);
        txt = Tpl.softNewLine(txt);
        ret_45 = stringEq(Tpl.textString(l_integerOutputVariablesNames), "");
        ret_46 = stringEq(Tpl.textString(l_integerOutputVariablesVRs), "");
        ret_47 = boolAnd(ret_45, ret_46);
        txt = fun_370(txt, ret_47, l_integerOutputVariablesVRs, l_integerOutputVariablesNames);
        txt = Tpl.softNewLine(txt);
        ret_48 = stringEq(Tpl.textString(l_booleanOutputVariablesNames), "");
        ret_49 = stringEq(Tpl.textString(l_booleanOutputVariablesVRs), "");
        ret_50 = boolAnd(ret_48, ret_49);
        txt = fun_371(txt, ret_50, l_booleanOutputVariablesVRs, l_booleanOutputVariablesNames);
        txt = Tpl.softNewLine(txt);
        ret_51 = stringEq(Tpl.textString(l_stringOutputVariablesNames), "");
        ret_52 = stringEq(Tpl.textString(l_stringOutputVariablesVRs), "");
        ret_53 = boolAnd(ret_51, ret_52);
        txt = fun_372(txt, ret_53, l_stringOutputVariablesVRs, l_stringOutputVariablesNames);
        txt = Tpl.softNewLine(txt);
        ret_54 = stringEq(Tpl.textString(l_realInputVariablesVRs), "");
        txt = fun_373(txt, ret_54, l_realInputVariablesNames, l_realInputVariablesVRs, l_realInputVariablesReturnNames);
        txt = Tpl.softNewLine(txt);
        ret_55 = stringEq(Tpl.textString(l_integerInputVariablesVRs), "");
        txt = fun_374(txt, ret_55, l_integerInputVariablesNames, l_integerInputVariablesVRs, l_integerInputVariablesReturnNames);
        txt = Tpl.softNewLine(txt);
        ret_56 = stringEq(Tpl.textString(l_booleanInputVariablesVRs), "");
        txt = fun_375(txt, ret_56, l_booleanInputVariablesNames, l_booleanInputVariablesVRs, l_booleanInputVariablesReturnNames);
        txt = Tpl.softNewLine(txt);
        ret_57 = stringEq(Tpl.textString(l_stringInputVariablesVRs), "");
        txt = fun_376(txt, ret_57, l_stringStartVariablesNames, l_stringInputVariablesVRs, l_stringInputVariablesReturnNames);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "flowStep = fmi1Functions.fmi1DoStep(fmi1cs, time, communicationStepSize, true, flowInitialized);\n",
                                    "annotation(experiment(StartTime="
                                }, false));
        txt = Tpl.writeStr(txt, realString(i_fmiExperimentAnnotation_fmiExperimentStartTime));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", StopTime="));
        txt = Tpl.writeStr(txt, realString(i_fmiExperimentAnnotation_fmiExperimentStopTime));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", Tolerance="));
        txt = Tpl.writeStr(txt, realString(i_fmiExperimentAnnotation_fmiExperimentTolerance));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "));\n",
                                    "annotation (Icon(graphics={\n",
                                    "    Rectangle(\n",
                                    "      extent={{-100,100},{100,-100}},\n",
                                    "      lineColor={0,0,0},\n",
                                    "      fillColor={240,240,240},\n",
                                    "      fillPattern=FillPattern.Solid,\n",
                                    "      lineThickness=0.5),\n",
                                    "    Text(\n",
                                    "      extent={{-100,40},{100,0}},\n",
                                    "      lineColor={0,0,0},\n",
                                    "      textString=\"%name\"),\n",
                                    "    Text(\n",
                                    "      extent={{-100,-50},{100,-90}},\n",
                                    "      lineColor={0,0,0},\n",
                                    "      textString=\"V1.0\")}));\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "protected\n",
                                    "  class FMI1CoSimulation\n",
                                    "    extends ExternalObject;\n",
                                    "      function constructor\n",
                                    "        input Integer fmiLogLevel;\n",
                                    "        input String workingDirectory;\n",
                                    "        input String instanceName;\n",
                                    "        input Boolean debugLogging;\n",
                                    "        input String fmuLocation;\n",
                                    "        input String mimeType;\n",
                                    "        input Real timeOut;\n",
                                    "        input Boolean visible;\n",
                                    "        input Boolean interactive;\n",
                                    "        input Real tStart;\n",
                                    "        input Boolean stopTimeDefined;\n",
                                    "        input Real tStop;\n",
                                    "        output FMI1CoSimulation fmi1cs;\n",
                                    "        external \"C\" fmi1cs = FMI1CoSimulationConstructor_OMC(fmiLogLevel, workingDirectory, instanceName, debugLogging, fmuLocation, mimeType, timeOut, visible, interactive, tStart, stopTimeDefined, tStop) annotation(Library = {\"OpenModelicaFMIRuntimeC\", \"fmilib\"});\n",
                                    "      end constructor;\n",
                                    "\n",
                                    "      function destructor\n",
                                    "        input FMI1CoSimulation fmi1cs;\n",
                                    "        external \"C\" FMI1CoSimulationDestructor_OMC(fmi1cs) annotation(Library = {\"OpenModelicaFMIRuntimeC\", \"fmilib\"});\n",
                                    "      end destructor;\n",
                                    "  end FMI1CoSimulation;\n",
                                    "\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = dumpFMITypeDefinitionsMappingFunctions(txt, i_fmiTypeDefinitionsList);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
        txt = dumpFMITypeDefinitionsArrayMappingFunctions(txt, i_fmiTypeDefinitionsList);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\n",
                                    "package fmi1Functions\n",
                                    "  function fmi1InitializeSlave\n",
                                    "    input FMI1CoSimulation fmi1cs;\n",
                                    "    input Real preInitialized;\n",
                                    "    output Real postInitialized=preInitialized;\n",
                                    "    external \"C\" fmi1InitializeSlave_OMC(fmi1cs) annotation(Library = {\"OpenModelicaFMIRuntimeC\", \"fmilib\"});\n",
                                    "  end fmi1InitializeSlave;\n",
                                    "\n",
                                    "  function fmi1DoStep\n",
                                    "    input FMI1CoSimulation fmi1cs;\n",
                                    "    input Real currentCommunicationPoint;\n",
                                    "    input Real communicationStepSize;\n",
                                    "    input Boolean newStep;\n",
                                    "    input Real preInitialized;\n",
                                    "    output Real postInitialized=preInitialized;\n",
                                    "    external \"C\" fmi1DoStep_OMC(fmi1cs, currentCommunicationPoint, communicationStepSize, newStep) annotation(Library = {\"OpenModelicaFMIRuntimeC\", \"fmilib\"});\n",
                                    "  end fmi1DoStep;\n",
                                    "\n",
                                    "  function fmi1GetReal\n",
                                    "    input FMI1CoSimulation fmi1cs;\n",
                                    "    input Real realValuesReferences[:];\n",
                                    "    input Real inFlowStatesInput;\n",
                                    "    output Real realValues[size(realValuesReferences, 1)];\n",
                                    "    external \"C\" fmi1GetReal_OMC(fmi1cs, size(realValuesReferences, 1), realValuesReferences, inFlowStatesInput, realValues, 2) annotation(Library = {\"OpenModelicaFMIRuntimeC\", \"fmilib\"});\n",
                                    "  end fmi1GetReal;\n",
                                    "\n",
                                    "  function fmi1SetReal\n",
                                    "    input FMI1CoSimulation fmi1cs;\n",
                                    "    input Real realValuesReferences[:];\n",
                                    "    input Real realValues[size(realValuesReferences, 1)];\n",
                                    "    output Real out_Values[size(realValuesReferences, 1)];\n",
                                    "    external \"C\" fmi1SetReal_OMC(fmi1cs, size(realValuesReferences, 1), realValuesReferences, realValues, out_Values, 2) annotation(Library = {\"OpenModelicaFMIRuntimeC\", \"fmilib\"});\n",
                                    "  end fmi1SetReal;\n",
                                    "\n",
                                    "  function fmi1GetInteger\n",
                                    "    input FMI1CoSimulation fmi1cs;\n",
                                    "    input Real integerValuesReferences[:];\n",
                                    "    input Real inFlowStatesInput;\n",
                                    "    output Integer integerValues[size(integerValuesReferences, 1)];\n",
                                    "    external \"C\" fmi1GetInteger_OMC(fmi1cs, size(integerValuesReferences, 1), integerValuesReferences, inFlowStatesInput, integerValues, 2) annotation(Library = {\"OpenModelicaFMIRuntimeC\", \"fmilib\"});\n",
                                    "  end fmi1GetInteger;\n",
                                    "\n",
                                    "  function fmi1SetInteger\n",
                                    "    input FMI1CoSimulation fmi1cs;\n",
                                    "    input Real integerValuesReferences[:];\n",
                                    "    input Integer integerValues[size(integerValuesReferences, 1)];\n",
                                    "    output Real out_Values[size(integerValuesReferences, 1)];\n",
                                    "    external \"C\" fmi1SetInteger_OMC(fmi1cs, size(integerValuesReferences, 1), integerValuesReferences, integerValues, out_Values, 2) annotation(Library = {\"OpenModelicaFMIRuntimeC\", \"fmilib\"});\n",
                                    "  end fmi1SetInteger;\n",
                                    "\n",
                                    "  function fmi1GetBoolean\n",
                                    "    input FMI1CoSimulation fmi1cs;\n",
                                    "    input Real booleanValuesReferences[:];\n",
                                    "    input Real inFlowStatesInput;\n",
                                    "    output Boolean booleanValues[size(booleanValuesReferences, 1)];\n",
                                    "    external \"C\" fmi1GetBoolean_OMC(fmi1cs, size(booleanValuesReferences, 1), booleanValuesReferences, inFlowStatesInput, booleanValues, 2) annotation(Library = {\"OpenModelicaFMIRuntimeC\", \"fmilib\"});\n",
                                    "  end fmi1GetBoolean;\n",
                                    "\n",
                                    "  function fmi1SetBoolean\n",
                                    "    input FMI1CoSimulation fmi1cs;\n",
                                    "    input Real booleanValuesReferences[:];\n",
                                    "    input Boolean booleanValues[size(booleanValuesReferences, 1)];\n",
                                    "    output Boolean out_Values[size(booleanValuesReferences, 1)];\n",
                                    "    external \"C\" fmi1SetBoolean_OMC(fmi1cs, size(booleanValuesReferences, 1), booleanValuesReferences, booleanValues, out_Values, 2) annotation(Library = {\"OpenModelicaFMIRuntimeC\", \"fmilib\"});\n",
                                    "  end fmi1SetBoolean;\n",
                                    "\n",
                                    "  function fmi1GetString\n",
                                    "    input FMI1CoSimulation fmi1cs;\n",
                                    "    input Real stringValuesReferences[:];\n",
                                    "    input Real inFlowStatesInput;\n",
                                    "    output String stringValues[size(stringValuesReferences, 1)];\n",
                                    "    external \"C\" fmi1GetString_OMC(fmi1cs, size(stringValuesReferences, 1), stringValuesReferences, inFlowStatesInput, stringValues, 2) annotation(Library = {\"OpenModelicaFMIRuntimeC\", \"fmilib\"});\n",
                                    "  end fmi1GetString;\n",
                                    "\n",
                                    "  function fmi1SetString\n",
                                    "    input FMI1CoSimulation fmi1cs;\n",
                                    "    input Real stringValuesReferences[:];\n",
                                    "    input String stringValues[size(stringValuesReferences, 1)];\n",
                                    "    output String out_Values[size(stringValuesReferences, 1)];\n",
                                    "    external \"C\" fmi1SetString_OMC(fmi1cs, size(stringValuesReferences, 1), stringValuesReferences, stringValues, out_Values, 2) annotation(Library = {\"OpenModelicaFMIRuntimeC\", \"fmilib\"});\n",
                                    "  end fmi1SetString;\n",
                                    "end fmi1Functions;\n"
                                }, true));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("end "));
        txt = Tpl.writeStr(txt, i_fmiInfo_fmiModelIdentifier);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_"));
        ret_58 = FMI.getFMIType(i_fmiInfo);
        txt = Tpl.writeStr(txt, ret_58);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_FMU;"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end importFMU1CoSimulationStandAlone;

protected function lm_378
  input Tpl.Text in_txt;
  input list<FMI.TypeDefinitions> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<FMI.TypeDefinitions> rest;
      FMI.TypeDefinitions i_fmiTypeDefinition;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_fmiTypeDefinition :: rest )
      equation
        txt = dumpFMITypeDefinition(txt, i_fmiTypeDefinition);
        txt = Tpl.nextIter(txt);
        txt = lm_378(txt, rest);
      then txt;
  end match;
end lm_378;

public function dumpFMITypeDefinitions
  input Tpl.Text txt;
  input list<FMI.TypeDefinitions> a_fmiTypeDefinitionsList;

  output Tpl.Text out_txt;
algorithm
  out_txt := Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_378(out_txt, a_fmiTypeDefinitionsList);
  out_txt := Tpl.popIter(out_txt);
end dumpFMITypeDefinitions;

public function dumpFMITypeDefinition
  input Tpl.Text in_txt;
  input FMI.TypeDefinitions in_a_fmiTypeDefinition;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fmiTypeDefinition)
    local
      Tpl.Text txt;
      list<FMI.EnumerationItem> i_items;
      String i_name;

    case ( txt,
           FMI.ENUMERATIONTYPE(name = i_name, items = i_items) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("type "));
        txt = Tpl.writeStr(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" = enumeration(\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = dumpFMITypeDefinitionsItems(txt, i_items);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(");"));
        txt = Tpl.popBlock(txt);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end dumpFMITypeDefinition;

protected function lm_381
  input Tpl.Text in_txt;
  input list<FMI.EnumerationItem> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<FMI.EnumerationItem> rest;
      FMI.EnumerationItem i_item;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_item :: rest )
      equation
        txt = dumpFMITypeDefinitionsItem(txt, i_item);
        txt = Tpl.nextIter(txt);
        txt = lm_381(txt, rest);
      then txt;
  end match;
end lm_381;

public function dumpFMITypeDefinitionsItems
  input Tpl.Text txt;
  input list<FMI.EnumerationItem> a_items;

  output Tpl.Text out_txt;
algorithm
  out_txt := Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_LINE(",\n")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_381(out_txt, a_items);
  out_txt := Tpl.popIter(out_txt);
end dumpFMITypeDefinitionsItems;

public function dumpFMITypeDefinitionsItem
  input Tpl.Text in_txt;
  input FMI.EnumerationItem in_a_item;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_item)
    local
      Tpl.Text txt;
      String i_name;

    case ( txt,
           FMI.ENUMERATIONITEM(name = i_name) )
      equation
        txt = Tpl.writeStr(txt, i_name);
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end dumpFMITypeDefinitionsItem;

protected function lm_384
  input Tpl.Text in_txt;
  input list<FMI.TypeDefinitions> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<FMI.TypeDefinitions> rest;
      FMI.TypeDefinitions i_fmiTypeDefinition;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_fmiTypeDefinition :: rest )
      equation
        txt = dumpFMITypeDefinitionMappingFunction(txt, i_fmiTypeDefinition);
        txt = Tpl.nextIter(txt);
        txt = lm_384(txt, rest);
      then txt;
  end match;
end lm_384;

public function dumpFMITypeDefinitionsMappingFunctions
  input Tpl.Text txt;
  input list<FMI.TypeDefinitions> a_fmiTypeDefinitionsList;

  output Tpl.Text out_txt;
algorithm
  out_txt := Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_384(out_txt, a_fmiTypeDefinitionsList);
  out_txt := Tpl.popIter(out_txt);
end dumpFMITypeDefinitionsMappingFunctions;

protected function lm_386
  input Tpl.Text in_txt;
  input list<FMI.EnumerationItem> in_items;
  input String in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_name)
    local
      Tpl.Text txt;
      list<FMI.EnumerationItem> rest;
      String a_name;
      Integer x_i0;
      FMI.EnumerationItem i_item;

    case ( txt,
           {},
           _ )
      then txt;

    case ( txt,
           i_item :: rest,
           a_name )
      equation
        x_i0 = Tpl.getIteri_i0(txt);
        txt = dumpFMITypeDefinitionMappingFunctionItems(txt, i_item, a_name, x_i0);
        txt = Tpl.nextIter(txt);
        txt = lm_386(txt, rest, a_name);
      then txt;
  end match;
end lm_386;

protected function fun_387
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("end if;"));
      then txt;
  end match;
end fun_387;

public function dumpFMITypeDefinitionMappingFunction
  input Tpl.Text in_txt;
  input FMI.TypeDefinitions in_a_fmiTypeDefinition;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fmiTypeDefinition)
    local
      Tpl.Text txt;
      list<FMI.EnumerationItem> i_items;
      String i_name;
      Boolean ret_1;
      Integer ret_0;

    case ( txt,
           FMI.ENUMERATIONTYPE(name = i_name, items = i_items) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("function map_"));
        txt = Tpl.writeStr(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_from_integer\n",
                                    "  input Integer i;\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("output "));
        txt = Tpl.writeStr(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" outType;\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("algorithm\n"));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(1, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_386(txt, i_items, i_name);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        ret_0 = listLength(i_items);
        ret_1 = intGt(ret_0, 1);
        txt = fun_387(txt, ret_1);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("end map_"));
        txt = Tpl.writeStr(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_from_integer;"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end dumpFMITypeDefinitionMappingFunction;

protected function fun_389
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_name;
  input String in_a_typeName;
  input Integer in_a_i;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_name, in_a_typeName, in_a_i)
    local
      Tpl.Text txt;
      String a_name;
      String a_typeName;
      Integer a_i;

    case ( txt,
           false,
           a_name,
           a_typeName,
           a_i )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("elseif i == "));
        txt = Tpl.writeStr(txt, intString(a_i));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" then outType := "));
        txt = Tpl.writeStr(txt, a_typeName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("."));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           _,
           a_name,
           a_typeName,
           a_i )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("if i == "));
        txt = Tpl.writeStr(txt, intString(a_i));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" then outType := "));
        txt = Tpl.writeStr(txt, a_typeName);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("."));
        txt = Tpl.writeStr(txt, a_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;
  end match;
end fun_389;

public function dumpFMITypeDefinitionMappingFunctionItems
  input Tpl.Text in_txt;
  input FMI.EnumerationItem in_a_item;
  input String in_a_typeName;
  input Integer in_a_i;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_item, in_a_typeName, in_a_i)
    local
      Tpl.Text txt;
      String a_typeName;
      Integer a_i;
      String i_name;
      Boolean ret_0;

    case ( txt,
           FMI.ENUMERATIONITEM(name = i_name),
           a_typeName,
           a_i )
      equation
        ret_0 = intEq(a_i, 1);
        txt = fun_389(txt, ret_0, i_name, a_typeName, a_i);
      then txt;

    case ( txt,
           _,
           _,
           _ )
      then txt;
  end match;
end dumpFMITypeDefinitionMappingFunctionItems;

protected function lm_391
  input Tpl.Text in_txt;
  input list<FMI.TypeDefinitions> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<FMI.TypeDefinitions> rest;
      FMI.TypeDefinitions i_fmiTypeDefinition;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_fmiTypeDefinition :: rest )
      equation
        txt = dumpFMITypeDefinitionsArrayMappingFunction(txt, i_fmiTypeDefinition);
        txt = Tpl.nextIter(txt);
        txt = lm_391(txt, rest);
      then txt;
  end match;
end lm_391;

public function dumpFMITypeDefinitionsArrayMappingFunctions
  input Tpl.Text txt;
  input list<FMI.TypeDefinitions> a_fmiTypeDefinitionsList;

  output Tpl.Text out_txt;
algorithm
  out_txt := Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_391(out_txt, a_fmiTypeDefinitionsList);
  out_txt := Tpl.popIter(out_txt);
end dumpFMITypeDefinitionsArrayMappingFunctions;

public function dumpFMITypeDefinitionsArrayMappingFunction
  input Tpl.Text in_txt;
  input FMI.TypeDefinitions in_a_fmiTypeDefinition;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fmiTypeDefinition)
    local
      Tpl.Text txt;
      String i_name;

    case ( txt,
           FMI.ENUMERATIONTYPE(name = i_name) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("function map_"));
        txt = Tpl.writeStr(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "_from_integers\n",
                                    "  input Integer fromInt[size(fromInt, 1)];\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("output "));
        txt = Tpl.writeStr(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(" toEnum[size(fromInt, 1)];\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "protected\n",
                                    "  Integer n = size(fromInt, 1);\n",
                                    "algorithm\n",
                                    "  for i in 1:n loop\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(4));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("toEnum[i] := map_"));
        txt = Tpl.writeStr(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("_from_integer(fromInt[i]);\n"));
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "  end for;\n",
                                    "end map_"
                                }, false));
        txt = Tpl.writeStr(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_from_integers;"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end dumpFMITypeDefinitionsArrayMappingFunction;

protected function lm_394
  input Tpl.Text in_txt;
  input list<FMI.ModelVariables> in_items;
  input Boolean in_a_generateOutputConnectors;
  input Boolean in_a_generateInputConnectors;
  input list<FMI.TypeDefinitions> in_a_fmiTypeDefinitionsList;
  input String in_a_FMUVersion;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_generateOutputConnectors, in_a_generateInputConnectors, in_a_fmiTypeDefinitionsList, in_a_FMUVersion)
    local
      Tpl.Text txt;
      list<FMI.ModelVariables> rest;
      Boolean a_generateOutputConnectors;
      Boolean a_generateInputConnectors;
      list<FMI.TypeDefinitions> a_fmiTypeDefinitionsList;
      String a_FMUVersion;
      FMI.ModelVariables i_fmiModelVariable;

    case ( txt,
           {},
           _,
           _,
           _,
           _ )
      then txt;

    case ( txt,
           i_fmiModelVariable :: rest,
           a_generateOutputConnectors,
           a_generateInputConnectors,
           a_fmiTypeDefinitionsList,
           a_FMUVersion )
      equation
        txt = dumpFMIModelVariable(txt, a_FMUVersion, i_fmiModelVariable, a_fmiTypeDefinitionsList, a_generateInputConnectors, a_generateOutputConnectors);
        txt = Tpl.nextIter(txt);
        txt = lm_394(txt, rest, a_generateOutputConnectors, a_generateInputConnectors, a_fmiTypeDefinitionsList, a_FMUVersion);
      then txt;
  end match;
end lm_394;

public function dumpFMIModelVariablesList
  input Tpl.Text txt;
  input String a_FMUVersion;
  input list<FMI.ModelVariables> a_fmiModelVariablesList;
  input list<FMI.TypeDefinitions> a_fmiTypeDefinitionsList;
  input Boolean a_generateInputConnectors;
  input Boolean a_generateOutputConnectors;

  output Tpl.Text out_txt;
algorithm
  out_txt := Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_394(out_txt, a_fmiModelVariablesList, a_generateOutputConnectors, a_generateInputConnectors, a_fmiTypeDefinitionsList, a_FMUVersion);
  out_txt := Tpl.popIter(out_txt);
end dumpFMIModelVariablesList;

protected function fun_396
  input Tpl.Text in_txt;
  input FMI.ModelVariables in_a_fmiModelVariable;
  input list<FMI.TypeDefinitions> in_a_fmiTypeDefinitionsList;
  input String in_a_FMUVersion;
  input Boolean in_a_generateOutputConnectors;
  input Boolean in_a_generateInputConnectors;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fmiModelVariable, in_a_fmiTypeDefinitionsList, in_a_FMUVersion, in_a_generateOutputConnectors, in_a_generateInputConnectors)
    local
      Tpl.Text txt;
      list<FMI.TypeDefinitions> a_fmiTypeDefinitionsList;
      String a_FMUVersion;
      Boolean a_generateOutputConnectors;
      Boolean a_generateInputConnectors;
      String i_startValue_3;
      Boolean i_startValue_2;
      Integer i_startValue_1;
      Integer i_y2Placement;
      Integer i_y1Placement;
      Integer i_x2Placement;
      Integer i_x1Placement;
      String i_description;
      Boolean i_isFixed;
      Real i_startValue;
      Boolean i_hasStartValue;
      String i_name;
      String i_baseType;
      String i_causality;
      String i_variability;

    case ( txt,
           FMI.REALVARIABLE(variability = i_variability, causality = i_causality, baseType = i_baseType, name = i_name, hasStartValue = i_hasStartValue, startValue = i_startValue, isFixed = i_isFixed, description = i_description, x1Placement = i_x1Placement, x2Placement = i_x2Placement, y1Placement = i_y1Placement, y2Placement = i_y2Placement),
           _,
           a_FMUVersion,
           a_generateOutputConnectors,
           a_generateInputConnectors )
      equation
        txt = dumpFMIModelVariableVariability(txt, i_variability);
        txt = dumpFMIModelVariableCausalityAndBaseType(txt, i_causality, i_baseType, a_generateInputConnectors, a_generateOutputConnectors);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeStr(txt, i_name);
        txt = dumpFMIRealModelVariableStartValue(txt, a_FMUVersion, i_variability, i_hasStartValue, i_startValue, i_isFixed);
        txt = dumpFMIModelVariableDescription(txt, i_description);
        txt = dumpFMIModelVariablePlacementAnnotation(txt, i_x1Placement, i_x2Placement, i_y1Placement, i_y2Placement, a_generateInputConnectors, a_generateOutputConnectors, i_causality);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           FMI.INTEGERVARIABLE(variability = i_variability, causality = i_causality, baseType = i_baseType, name = i_name, hasStartValue = i_hasStartValue, startValue = i_startValue_1, isFixed = i_isFixed, description = i_description, x1Placement = i_x1Placement, x2Placement = i_x2Placement, y1Placement = i_y1Placement, y2Placement = i_y2Placement),
           _,
           a_FMUVersion,
           a_generateOutputConnectors,
           a_generateInputConnectors )
      equation
        txt = dumpFMIModelVariableVariability(txt, i_variability);
        txt = dumpFMIModelVariableCausalityAndBaseType(txt, i_causality, i_baseType, a_generateInputConnectors, a_generateOutputConnectors);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeStr(txt, i_name);
        txt = dumpFMIIntegerModelVariableStartValue(txt, a_FMUVersion, i_variability, i_hasStartValue, i_startValue_1, i_isFixed);
        txt = dumpFMIModelVariableDescription(txt, i_description);
        txt = dumpFMIModelVariablePlacementAnnotation(txt, i_x1Placement, i_x2Placement, i_y1Placement, i_y2Placement, a_generateInputConnectors, a_generateOutputConnectors, i_causality);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           FMI.BOOLEANVARIABLE(variability = i_variability, causality = i_causality, baseType = i_baseType, name = i_name, hasStartValue = i_hasStartValue, startValue = i_startValue_2, isFixed = i_isFixed, description = i_description, x1Placement = i_x1Placement, x2Placement = i_x2Placement, y1Placement = i_y1Placement, y2Placement = i_y2Placement),
           _,
           a_FMUVersion,
           a_generateOutputConnectors,
           a_generateInputConnectors )
      equation
        txt = dumpFMIModelVariableVariability(txt, i_variability);
        txt = dumpFMIModelVariableCausalityAndBaseType(txt, i_causality, i_baseType, a_generateInputConnectors, a_generateOutputConnectors);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeStr(txt, i_name);
        txt = dumpFMIBooleanModelVariableStartValue(txt, a_FMUVersion, i_variability, i_hasStartValue, i_startValue_2, i_isFixed);
        txt = dumpFMIModelVariableDescription(txt, i_description);
        txt = dumpFMIModelVariablePlacementAnnotation(txt, i_x1Placement, i_x2Placement, i_y1Placement, i_y2Placement, a_generateInputConnectors, a_generateOutputConnectors, i_causality);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           FMI.STRINGVARIABLE(variability = i_variability, causality = i_causality, baseType = i_baseType, name = i_name, hasStartValue = i_hasStartValue, startValue = i_startValue_3, isFixed = i_isFixed, description = i_description, x1Placement = i_x1Placement, x2Placement = i_x2Placement, y1Placement = i_y1Placement, y2Placement = i_y2Placement),
           _,
           a_FMUVersion,
           a_generateOutputConnectors,
           a_generateInputConnectors )
      equation
        txt = dumpFMIModelVariableVariability(txt, i_variability);
        txt = dumpFMIModelVariableCausalityAndBaseType(txt, i_causality, i_baseType, a_generateInputConnectors, a_generateOutputConnectors);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeStr(txt, i_name);
        txt = dumpFMIStringModelVariableStartValue(txt, a_FMUVersion, i_variability, i_hasStartValue, i_startValue_3, i_isFixed);
        txt = dumpFMIModelVariableDescription(txt, i_description);
        txt = dumpFMIModelVariablePlacementAnnotation(txt, i_x1Placement, i_x2Placement, i_y1Placement, i_y2Placement, a_generateInputConnectors, a_generateOutputConnectors, i_causality);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           FMI.ENUMERATIONVARIABLE(variability = i_variability, causality = i_causality, baseType = i_baseType, name = i_name, hasStartValue = i_hasStartValue, startValue = i_startValue_1, isFixed = i_isFixed, description = i_description, x1Placement = i_x1Placement, x2Placement = i_x2Placement, y1Placement = i_y1Placement, y2Placement = i_y2Placement),
           a_fmiTypeDefinitionsList,
           _,
           a_generateOutputConnectors,
           a_generateInputConnectors )
      equation
        txt = dumpFMIModelVariableVariability(txt, i_variability);
        txt = dumpFMIModelVariableCausalityAndBaseType(txt, i_causality, i_baseType, a_generateInputConnectors, a_generateOutputConnectors);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeStr(txt, i_name);
        txt = dumpFMIEnumerationModelVariableStartValue(txt, a_fmiTypeDefinitionsList, i_baseType, i_hasStartValue, i_startValue_1, i_isFixed);
        txt = dumpFMIModelVariableDescription(txt, i_description);
        txt = dumpFMIModelVariablePlacementAnnotation(txt, i_x1Placement, i_x2Placement, i_y1Placement, i_y2Placement, a_generateInputConnectors, a_generateOutputConnectors, i_causality);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           _,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_396;

protected function fun_397
  input Tpl.Text in_txt;
  input FMI.ModelVariables in_a_fmiModelVariable;
  input list<FMI.TypeDefinitions> in_a_fmiTypeDefinitionsList;
  input String in_a_FMUVersion;
  input Boolean in_a_generateOutputConnectors;
  input Boolean in_a_generateInputConnectors;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fmiModelVariable, in_a_fmiTypeDefinitionsList, in_a_FMUVersion, in_a_generateOutputConnectors, in_a_generateInputConnectors)
    local
      Tpl.Text txt;
      list<FMI.TypeDefinitions> a_fmiTypeDefinitionsList;
      String a_FMUVersion;
      Boolean a_generateOutputConnectors;
      Boolean a_generateInputConnectors;
      String i_startValue_3;
      Boolean i_startValue_2;
      Integer i_startValue_1;
      Integer i_y2Placement;
      Integer i_y1Placement;
      Integer i_x2Placement;
      Integer i_x1Placement;
      String i_description;
      Boolean i_isFixed;
      Real i_startValue;
      Boolean i_hasStartValue;
      String i_name;
      String i_baseType;
      String i_causality;
      String i_variability;

    case ( txt,
           FMI.REALVARIABLE(variability = i_variability, causality = i_causality, baseType = i_baseType, name = i_name, hasStartValue = i_hasStartValue, startValue = i_startValue, isFixed = i_isFixed, description = i_description, x1Placement = i_x1Placement, x2Placement = i_x2Placement, y1Placement = i_y1Placement, y2Placement = i_y2Placement),
           _,
           a_FMUVersion,
           a_generateOutputConnectors,
           a_generateInputConnectors )
      equation
        txt = dumpFMIModelVariableVariability(txt, i_variability);
        txt = dumpFMIModelVariableCausalityAndBaseType(txt, i_causality, i_baseType, a_generateInputConnectors, a_generateOutputConnectors);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeStr(txt, i_name);
        txt = dumpFMIRealModelVariableStartValue(txt, a_FMUVersion, i_causality, i_hasStartValue, i_startValue, i_isFixed);
        txt = dumpFMIModelVariableDescription(txt, i_description);
        txt = dumpFMIModelVariablePlacementAnnotation(txt, i_x1Placement, i_x2Placement, i_y1Placement, i_y2Placement, a_generateInputConnectors, a_generateOutputConnectors, i_causality);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           FMI.INTEGERVARIABLE(variability = i_variability, causality = i_causality, baseType = i_baseType, name = i_name, hasStartValue = i_hasStartValue, startValue = i_startValue_1, isFixed = i_isFixed, description = i_description, x1Placement = i_x1Placement, x2Placement = i_x2Placement, y1Placement = i_y1Placement, y2Placement = i_y2Placement),
           _,
           a_FMUVersion,
           a_generateOutputConnectors,
           a_generateInputConnectors )
      equation
        txt = dumpFMIModelVariableVariability(txt, i_variability);
        txt = dumpFMIModelVariableCausalityAndBaseType(txt, i_causality, i_baseType, a_generateInputConnectors, a_generateOutputConnectors);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeStr(txt, i_name);
        txt = dumpFMIIntegerModelVariableStartValue(txt, a_FMUVersion, i_causality, i_hasStartValue, i_startValue_1, i_isFixed);
        txt = dumpFMIModelVariableDescription(txt, i_description);
        txt = dumpFMIModelVariablePlacementAnnotation(txt, i_x1Placement, i_x2Placement, i_y1Placement, i_y2Placement, a_generateInputConnectors, a_generateOutputConnectors, i_causality);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           FMI.BOOLEANVARIABLE(variability = i_variability, causality = i_causality, baseType = i_baseType, name = i_name, hasStartValue = i_hasStartValue, startValue = i_startValue_2, isFixed = i_isFixed, description = i_description, x1Placement = i_x1Placement, x2Placement = i_x2Placement, y1Placement = i_y1Placement, y2Placement = i_y2Placement),
           _,
           a_FMUVersion,
           a_generateOutputConnectors,
           a_generateInputConnectors )
      equation
        txt = dumpFMIModelVariableVariability(txt, i_variability);
        txt = dumpFMIModelVariableCausalityAndBaseType(txt, i_causality, i_baseType, a_generateInputConnectors, a_generateOutputConnectors);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeStr(txt, i_name);
        txt = dumpFMIBooleanModelVariableStartValue(txt, a_FMUVersion, i_causality, i_hasStartValue, i_startValue_2, i_isFixed);
        txt = dumpFMIModelVariableDescription(txt, i_description);
        txt = dumpFMIModelVariablePlacementAnnotation(txt, i_x1Placement, i_x2Placement, i_y1Placement, i_y2Placement, a_generateInputConnectors, a_generateOutputConnectors, i_causality);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           FMI.STRINGVARIABLE(variability = i_variability, causality = i_causality, baseType = i_baseType, name = i_name, hasStartValue = i_hasStartValue, startValue = i_startValue_3, isFixed = i_isFixed, description = i_description, x1Placement = i_x1Placement, x2Placement = i_x2Placement, y1Placement = i_y1Placement, y2Placement = i_y2Placement),
           _,
           a_FMUVersion,
           a_generateOutputConnectors,
           a_generateInputConnectors )
      equation
        txt = dumpFMIModelVariableVariability(txt, i_variability);
        txt = dumpFMIModelVariableCausalityAndBaseType(txt, i_causality, i_baseType, a_generateInputConnectors, a_generateOutputConnectors);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeStr(txt, i_name);
        txt = dumpFMIStringModelVariableStartValue(txt, a_FMUVersion, i_causality, i_hasStartValue, i_startValue_3, i_isFixed);
        txt = dumpFMIModelVariableDescription(txt, i_description);
        txt = dumpFMIModelVariablePlacementAnnotation(txt, i_x1Placement, i_x2Placement, i_y1Placement, i_y2Placement, a_generateInputConnectors, a_generateOutputConnectors, i_causality);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           FMI.ENUMERATIONVARIABLE(variability = i_variability, causality = i_causality, baseType = i_baseType, name = i_name, hasStartValue = i_hasStartValue, startValue = i_startValue_1, isFixed = i_isFixed, description = i_description, x1Placement = i_x1Placement, x2Placement = i_x2Placement, y1Placement = i_y1Placement, y2Placement = i_y2Placement),
           a_fmiTypeDefinitionsList,
           _,
           a_generateOutputConnectors,
           a_generateInputConnectors )
      equation
        txt = dumpFMIModelVariableVariability(txt, i_variability);
        txt = dumpFMIModelVariableCausalityAndBaseType(txt, i_causality, i_baseType, a_generateInputConnectors, a_generateOutputConnectors);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeStr(txt, i_name);
        txt = dumpFMIEnumerationModelVariableStartValue(txt, a_fmiTypeDefinitionsList, i_baseType, i_hasStartValue, i_startValue_1, i_isFixed);
        txt = dumpFMIModelVariableDescription(txt, i_description);
        txt = dumpFMIModelVariablePlacementAnnotation(txt, i_x1Placement, i_x2Placement, i_y1Placement, i_y2Placement, a_generateInputConnectors, a_generateOutputConnectors, i_causality);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           _,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_397;

public function dumpFMIModelVariable
  input Tpl.Text in_txt;
  input String in_a_FMUVersion;
  input FMI.ModelVariables in_a_fmiModelVariable;
  input list<FMI.TypeDefinitions> in_a_fmiTypeDefinitionsList;
  input Boolean in_a_generateInputConnectors;
  input Boolean in_a_generateOutputConnectors;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_FMUVersion, in_a_fmiModelVariable, in_a_fmiTypeDefinitionsList, in_a_generateInputConnectors, in_a_generateOutputConnectors)
    local
      Tpl.Text txt;
      FMI.ModelVariables a_fmiModelVariable;
      list<FMI.TypeDefinitions> a_fmiTypeDefinitionsList;
      Boolean a_generateInputConnectors;
      Boolean a_generateOutputConnectors;
      String i_FMUVersion;

    case ( txt,
           (i_FMUVersion as "1.0"),
           a_fmiModelVariable,
           a_fmiTypeDefinitionsList,
           a_generateInputConnectors,
           a_generateOutputConnectors )
      equation
        txt = fun_396(txt, a_fmiModelVariable, a_fmiTypeDefinitionsList, i_FMUVersion, a_generateOutputConnectors, a_generateInputConnectors);
      then txt;

    case ( txt,
           (i_FMUVersion as "2.0"),
           a_fmiModelVariable,
           a_fmiTypeDefinitionsList,
           a_generateInputConnectors,
           a_generateOutputConnectors )
      equation
        txt = fun_397(txt, a_fmiModelVariable, a_fmiTypeDefinitionsList, i_FMUVersion, a_generateOutputConnectors, a_generateInputConnectors);
      then txt;

    case ( txt,
           _,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end dumpFMIModelVariable;

protected function fun_399
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_variability;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_variability)
    local
      Tpl.Text txt;
      String a_variability;

    case ( txt,
           false,
           a_variability )
      equation
        txt = Tpl.writeStr(txt, a_variability);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_399;

public function dumpFMIModelVariableVariability
  input Tpl.Text txt;
  input String a_variability;

  output Tpl.Text out_txt;
protected
  Boolean ret_0;
algorithm
  ret_0 := stringEq(a_variability, "");
  out_txt := fun_399(txt, ret_0, a_variability);
end dumpFMIModelVariableVariability;

protected function fun_401
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_baseType;
  input String in_a_causality;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_baseType, in_a_causality)
    local
      Tpl.Text txt;
      String a_baseType;
      String a_causality;

    case ( txt,
           false,
           a_baseType,
           a_causality )
      equation
        txt = Tpl.writeStr(txt, a_causality);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
        txt = Tpl.writeStr(txt, a_baseType);
      then txt;

    case ( txt,
           _,
           a_baseType,
           _ )
      equation
        txt = Tpl.writeStr(txt, a_baseType);
      then txt;
  end match;
end fun_401;

protected function fun_402
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_baseType;
  input String in_a_causality;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_baseType, in_a_causality)
    local
      Tpl.Text txt;
      String a_baseType;
      String a_causality;
      Boolean ret_0;

    case ( txt,
           false,
           a_baseType,
           a_causality )
      equation
        ret_0 = stringEq(a_causality, "");
        txt = fun_401(txt, ret_0, a_baseType, a_causality);
      then txt;

    case ( txt,
           _,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Modelica.Blocks.Interfaces.BooleanOutput"));
      then txt;
  end match;
end fun_402;

protected function fun_403
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_baseType;
  input String in_a_causality;
  input Boolean in_a_generateOutputConnectors;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_baseType, in_a_causality, in_a_generateOutputConnectors)
    local
      Tpl.Text txt;
      String a_baseType;
      String a_causality;
      Boolean a_generateOutputConnectors;
      Boolean ret_3;
      Boolean ret_2;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           false,
           a_baseType,
           a_causality,
           a_generateOutputConnectors )
      equation
        ret_0 = stringEq(a_causality, "output");
        ret_1 = stringEq(a_baseType, "Boolean");
        ret_2 = boolAnd(ret_0, ret_1);
        ret_3 = boolAnd(a_generateOutputConnectors, ret_2);
        txt = fun_402(txt, ret_3, a_baseType, a_causality);
      then txt;

    case ( txt,
           _,
           _,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Modelica.Blocks.Interfaces.IntegerOutput"));
      then txt;
  end match;
end fun_403;

protected function fun_404
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_baseType;
  input String in_a_causality;
  input Boolean in_a_generateOutputConnectors;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_baseType, in_a_causality, in_a_generateOutputConnectors)
    local
      Tpl.Text txt;
      String a_baseType;
      String a_causality;
      Boolean a_generateOutputConnectors;
      Boolean ret_3;
      Boolean ret_2;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           false,
           a_baseType,
           a_causality,
           a_generateOutputConnectors )
      equation
        ret_0 = stringEq(a_causality, "output");
        ret_1 = stringEq(a_baseType, "Integer");
        ret_2 = boolAnd(ret_0, ret_1);
        ret_3 = boolAnd(a_generateOutputConnectors, ret_2);
        txt = fun_403(txt, ret_3, a_baseType, a_causality, a_generateOutputConnectors);
      then txt;

    case ( txt,
           _,
           _,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Modelica.Blocks.Interfaces.RealOutput"));
      then txt;
  end match;
end fun_404;

protected function fun_405
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_baseType;
  input String in_a_causality;
  input Boolean in_a_generateOutputConnectors;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_baseType, in_a_causality, in_a_generateOutputConnectors)
    local
      Tpl.Text txt;
      String a_baseType;
      String a_causality;
      Boolean a_generateOutputConnectors;
      Boolean ret_3;
      Boolean ret_2;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           false,
           a_baseType,
           a_causality,
           a_generateOutputConnectors )
      equation
        ret_0 = stringEq(a_causality, "output");
        ret_1 = stringEq(a_baseType, "Real");
        ret_2 = boolAnd(ret_0, ret_1);
        ret_3 = boolAnd(a_generateOutputConnectors, ret_2);
        txt = fun_404(txt, ret_3, a_baseType, a_causality, a_generateOutputConnectors);
      then txt;

    case ( txt,
           _,
           _,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Modelica.Blocks.Interfaces.BooleanInput"));
      then txt;
  end match;
end fun_405;

protected function fun_406
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Boolean in_a_generateOutputConnectors;
  input String in_a_baseType;
  input String in_a_causality;
  input Boolean in_a_generateInputConnectors;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_generateOutputConnectors, in_a_baseType, in_a_causality, in_a_generateInputConnectors)
    local
      Tpl.Text txt;
      Boolean a_generateOutputConnectors;
      String a_baseType;
      String a_causality;
      Boolean a_generateInputConnectors;
      Boolean ret_3;
      Boolean ret_2;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           false,
           a_generateOutputConnectors,
           a_baseType,
           a_causality,
           a_generateInputConnectors )
      equation
        ret_0 = stringEq(a_causality, "input");
        ret_1 = stringEq(a_baseType, "Boolean");
        ret_2 = boolAnd(ret_0, ret_1);
        ret_3 = boolAnd(a_generateInputConnectors, ret_2);
        txt = fun_405(txt, ret_3, a_baseType, a_causality, a_generateOutputConnectors);
      then txt;

    case ( txt,
           _,
           _,
           _,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Modelica.Blocks.Interfaces.IntegerInput"));
      then txt;
  end match;
end fun_406;

protected function fun_407
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_causality;
  input String in_a_baseType;
  input Boolean in_a_generateInputConnectors;
  input Boolean in_a_generateOutputConnectors;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_causality, in_a_baseType, in_a_generateInputConnectors, in_a_generateOutputConnectors)
    local
      Tpl.Text txt;
      String a_causality;
      String a_baseType;
      Boolean a_generateInputConnectors;
      Boolean a_generateOutputConnectors;
      Boolean ret_3;
      Boolean ret_2;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           false,
           a_causality,
           a_baseType,
           a_generateInputConnectors,
           a_generateOutputConnectors )
      equation
        ret_0 = stringEq(a_causality, "input");
        ret_1 = stringEq(a_baseType, "Integer");
        ret_2 = boolAnd(ret_0, ret_1);
        ret_3 = boolAnd(a_generateInputConnectors, ret_2);
        txt = fun_406(txt, ret_3, a_generateOutputConnectors, a_baseType, a_causality, a_generateInputConnectors);
      then txt;

    case ( txt,
           _,
           _,
           _,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("Modelica.Blocks.Interfaces.RealInput"));
      then txt;
  end match;
end fun_407;

public function dumpFMIModelVariableCausalityAndBaseType
  input Tpl.Text txt;
  input String a_causality;
  input String a_baseType;
  input Boolean a_generateInputConnectors;
  input Boolean a_generateOutputConnectors;

  output Tpl.Text out_txt;
protected
  Boolean ret_3;
  Boolean ret_2;
  Boolean ret_1;
  Boolean ret_0;
algorithm
  ret_0 := stringEq(a_causality, "input");
  ret_1 := stringEq(a_baseType, "Real");
  ret_2 := boolAnd(ret_0, ret_1);
  ret_3 := boolAnd(a_generateInputConnectors, ret_2);
  out_txt := fun_407(txt, ret_3, a_causality, a_baseType, a_generateInputConnectors, a_generateOutputConnectors);
end dumpFMIModelVariableCausalityAndBaseType;

protected function fun_409
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_causality;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_causality)
    local
      Tpl.Text txt;
      String a_causality;

    case ( txt,
           false,
           a_causality )
      equation
        txt = Tpl.writeStr(txt, a_causality);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" "));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_409;

public function dumpFMIModelVariableCausality
  input Tpl.Text txt;
  input String a_causality;

  output Tpl.Text out_txt;
protected
  Boolean ret_0;
algorithm
  ret_0 := stringEq(a_causality, "");
  out_txt := fun_409(txt, ret_0, a_causality);
end dumpFMIModelVariableCausality;

protected function fun_411
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(fixed=false)"));
      then txt;
  end match;
end fun_411;

protected function fun_412
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Boolean in_a_isFixed;
  input Boolean in_a_hasStartValue;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_isFixed, in_a_hasStartValue)
    local
      Tpl.Text txt;
      Boolean a_isFixed;
      Boolean a_hasStartValue;
      Boolean ret_2;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           false,
           a_isFixed,
           a_hasStartValue )
      equation
        ret_0 = boolNot(a_hasStartValue);
        ret_1 = boolNot(a_isFixed);
        ret_2 = boolAnd(ret_0, ret_1);
        txt = fun_411(txt, ret_2);
      then txt;

    case ( txt,
           _,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(fixed=true)"));
      then txt;
  end match;
end fun_412;

protected function fun_413
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Real in_a_startValue;
  input Boolean in_a_isFixed;
  input Boolean in_a_hasStartValue;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_startValue, in_a_isFixed, in_a_hasStartValue)
    local
      Tpl.Text txt;
      Real a_startValue;
      Boolean a_isFixed;
      Boolean a_hasStartValue;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           false,
           _,
           a_isFixed,
           a_hasStartValue )
      equation
        ret_0 = boolNot(a_hasStartValue);
        ret_1 = boolAnd(ret_0, a_isFixed);
        txt = fun_412(txt, ret_1, a_isFixed, a_hasStartValue);
      then txt;

    case ( txt,
           _,
           a_startValue,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(start="));
        txt = Tpl.writeStr(txt, realString(a_startValue));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(",fixed=false)"));
      then txt;
  end match;
end fun_413;

protected function fun_414
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Real in_a_startValue;
  input Boolean in_a_isFixed;
  input Boolean in_a_hasStartValue;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_startValue, in_a_isFixed, in_a_hasStartValue)
    local
      Tpl.Text txt;
      Real a_startValue;
      Boolean a_isFixed;
      Boolean a_hasStartValue;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           false,
           a_startValue,
           a_isFixed,
           a_hasStartValue )
      equation
        ret_0 = boolNot(a_isFixed);
        ret_1 = boolAnd(a_hasStartValue, ret_0);
        txt = fun_413(txt, ret_1, a_startValue, a_isFixed, a_hasStartValue);
      then txt;

    case ( txt,
           _,
           a_startValue,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeStr(txt, realString(a_startValue));
      then txt;
  end match;
end fun_414;

protected function fun_415
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Real in_a_startValue;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_startValue)
    local
      Tpl.Text txt;
      Real a_startValue;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_startValue )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(start="));
        txt = Tpl.writeStr(txt, realString(a_startValue));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(",fixed=false)"));
      then txt;
  end match;
end fun_415;

protected function fun_416
  input Tpl.Text in_txt;
  input String in_a_variabilityCausality;
  input Real in_a_startValue;
  input Boolean in_a_isFixed;
  input Boolean in_a_hasStartValue;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_variabilityCausality, in_a_startValue, in_a_isFixed, in_a_hasStartValue)
    local
      Tpl.Text txt;
      Real a_startValue;
      Boolean a_isFixed;
      Boolean a_hasStartValue;
      Boolean ret_2;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           "parameter",
           a_startValue,
           a_isFixed,
           a_hasStartValue )
      equation
        ret_0 = boolAnd(a_hasStartValue, a_isFixed);
        txt = fun_414(txt, ret_0, a_startValue, a_isFixed, a_hasStartValue);
      then txt;

    case ( txt,
           "",
           a_startValue,
           a_isFixed,
           a_hasStartValue )
      equation
        ret_1 = boolNot(a_isFixed);
        ret_2 = boolAnd(a_hasStartValue, ret_1);
        txt = fun_415(txt, ret_2, a_startValue);
      then txt;

    case ( txt,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_416;

protected function fun_417
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Real in_a_startValue;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_startValue)
    local
      Tpl.Text txt;
      Real a_startValue;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_startValue )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(start="));
        txt = Tpl.writeStr(txt, realString(a_startValue));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(",fixed=false)"));
      then txt;
  end match;
end fun_417;

protected function fun_418
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Real in_a_startValue;
  input Boolean in_a_isFixed;
  input Boolean in_a_hasStartValue;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_startValue, in_a_isFixed, in_a_hasStartValue)
    local
      Tpl.Text txt;
      Real a_startValue;
      Boolean a_isFixed;
      Boolean a_hasStartValue;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           false,
           a_startValue,
           a_isFixed,
           a_hasStartValue )
      equation
        ret_0 = boolNot(a_isFixed);
        ret_1 = boolAnd(a_hasStartValue, ret_0);
        txt = fun_417(txt, ret_1, a_startValue);
      then txt;

    case ( txt,
           _,
           _,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(fixed=false)"));
      then txt;
  end match;
end fun_418;

protected function fun_419
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Real in_a_startValue;
  input Boolean in_a_isFixed;
  input Boolean in_a_hasStartValue;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_startValue, in_a_isFixed, in_a_hasStartValue)
    local
      Tpl.Text txt;
      Real a_startValue;
      Boolean a_isFixed;
      Boolean a_hasStartValue;
      Boolean ret_2;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           false,
           a_startValue,
           a_isFixed,
           a_hasStartValue )
      equation
        ret_0 = boolNot(a_hasStartValue);
        ret_1 = boolNot(a_isFixed);
        ret_2 = boolAnd(ret_0, ret_1);
        txt = fun_418(txt, ret_2, a_startValue, a_isFixed, a_hasStartValue);
      then txt;

    case ( txt,
           _,
           _,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(fixed=true)"));
      then txt;
  end match;
end fun_419;

protected function fun_420
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Real in_a_startValue;
  input Boolean in_a_isFixed;
  input Boolean in_a_hasStartValue;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_startValue, in_a_isFixed, in_a_hasStartValue)
    local
      Tpl.Text txt;
      Real a_startValue;
      Boolean a_isFixed;
      Boolean a_hasStartValue;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           false,
           a_startValue,
           a_isFixed,
           a_hasStartValue )
      equation
        ret_0 = boolNot(a_hasStartValue);
        ret_1 = boolAnd(ret_0, a_isFixed);
        txt = fun_419(txt, ret_1, a_startValue, a_isFixed, a_hasStartValue);
      then txt;

    case ( txt,
           _,
           a_startValue,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(start="));
        txt = Tpl.writeStr(txt, realString(a_startValue));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(",fixed=false)"));
      then txt;
  end match;
end fun_420;

protected function fun_421
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Real in_a_startValue;
  input Boolean in_a_isFixed;
  input Boolean in_a_hasStartValue;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_startValue, in_a_isFixed, in_a_hasStartValue)
    local
      Tpl.Text txt;
      Real a_startValue;
      Boolean a_isFixed;
      Boolean a_hasStartValue;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           false,
           a_startValue,
           a_isFixed,
           a_hasStartValue )
      equation
        ret_0 = boolNot(a_isFixed);
        ret_1 = boolAnd(a_hasStartValue, ret_0);
        txt = fun_420(txt, ret_1, a_startValue, a_isFixed, a_hasStartValue);
      then txt;

    case ( txt,
           _,
           a_startValue,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeStr(txt, realString(a_startValue));
      then txt;
  end match;
end fun_421;

protected function fun_422
  input Tpl.Text in_txt;
  input String in_a_variabilityCausality;
  input Real in_a_startValue;
  input Boolean in_a_isFixed;
  input Boolean in_a_hasStartValue;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_variabilityCausality, in_a_startValue, in_a_isFixed, in_a_hasStartValue)
    local
      Tpl.Text txt;
      Real a_startValue;
      Boolean a_isFixed;
      Boolean a_hasStartValue;
      Boolean ret_0;

    case ( txt,
           "parameter",
           a_startValue,
           a_isFixed,
           a_hasStartValue )
      equation
        ret_0 = boolAnd(a_hasStartValue, a_isFixed);
        txt = fun_421(txt, ret_0, a_startValue, a_isFixed, a_hasStartValue);
      then txt;

    case ( txt,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_422;

public function dumpFMIRealModelVariableStartValue
  input Tpl.Text in_txt;
  input String in_a_FMUVersion;
  input String in_a_variabilityCausality;
  input Boolean in_a_hasStartValue;
  input Real in_a_startValue;
  input Boolean in_a_isFixed;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_FMUVersion, in_a_variabilityCausality, in_a_hasStartValue, in_a_startValue, in_a_isFixed)
    local
      Tpl.Text txt;
      String a_variabilityCausality;
      Boolean a_hasStartValue;
      Real a_startValue;
      Boolean a_isFixed;

    case ( txt,
           "1.0",
           a_variabilityCausality,
           a_hasStartValue,
           a_startValue,
           a_isFixed )
      equation
        txt = fun_416(txt, a_variabilityCausality, a_startValue, a_isFixed, a_hasStartValue);
      then txt;

    case ( txt,
           "2.0",
           a_variabilityCausality,
           a_hasStartValue,
           a_startValue,
           a_isFixed )
      equation
        txt = fun_422(txt, a_variabilityCausality, a_startValue, a_isFixed, a_hasStartValue);
      then txt;

    case ( txt,
           _,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end dumpFMIRealModelVariableStartValue;

protected function fun_424
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(fixed=false)"));
      then txt;
  end match;
end fun_424;

protected function fun_425
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Boolean in_a_isFixed;
  input Boolean in_a_hasStartValue;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_isFixed, in_a_hasStartValue)
    local
      Tpl.Text txt;
      Boolean a_isFixed;
      Boolean a_hasStartValue;
      Boolean ret_2;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           false,
           a_isFixed,
           a_hasStartValue )
      equation
        ret_0 = boolNot(a_hasStartValue);
        ret_1 = boolNot(a_isFixed);
        ret_2 = boolAnd(ret_0, ret_1);
        txt = fun_424(txt, ret_2);
      then txt;

    case ( txt,
           _,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(fixed=true)"));
      then txt;
  end match;
end fun_425;

protected function fun_426
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_startValue;
  input Boolean in_a_isFixed;
  input Boolean in_a_hasStartValue;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_startValue, in_a_isFixed, in_a_hasStartValue)
    local
      Tpl.Text txt;
      Integer a_startValue;
      Boolean a_isFixed;
      Boolean a_hasStartValue;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           false,
           _,
           a_isFixed,
           a_hasStartValue )
      equation
        ret_0 = boolNot(a_hasStartValue);
        ret_1 = boolAnd(ret_0, a_isFixed);
        txt = fun_425(txt, ret_1, a_isFixed, a_hasStartValue);
      then txt;

    case ( txt,
           _,
           a_startValue,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(start="));
        txt = Tpl.writeStr(txt, intString(a_startValue));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(",fixed=false)"));
      then txt;
  end match;
end fun_426;

protected function fun_427
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_startValue;
  input Boolean in_a_isFixed;
  input Boolean in_a_hasStartValue;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_startValue, in_a_isFixed, in_a_hasStartValue)
    local
      Tpl.Text txt;
      Integer a_startValue;
      Boolean a_isFixed;
      Boolean a_hasStartValue;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           false,
           a_startValue,
           a_isFixed,
           a_hasStartValue )
      equation
        ret_0 = boolNot(a_isFixed);
        ret_1 = boolAnd(a_hasStartValue, ret_0);
        txt = fun_426(txt, ret_1, a_startValue, a_isFixed, a_hasStartValue);
      then txt;

    case ( txt,
           _,
           a_startValue,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeStr(txt, intString(a_startValue));
      then txt;
  end match;
end fun_427;

protected function fun_428
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_startValue;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_startValue)
    local
      Tpl.Text txt;
      Integer a_startValue;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_startValue )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(start="));
        txt = Tpl.writeStr(txt, intString(a_startValue));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(",fixed=false)"));
      then txt;
  end match;
end fun_428;

protected function fun_429
  input Tpl.Text in_txt;
  input String in_a_variabilityCausality;
  input Integer in_a_startValue;
  input Boolean in_a_isFixed;
  input Boolean in_a_hasStartValue;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_variabilityCausality, in_a_startValue, in_a_isFixed, in_a_hasStartValue)
    local
      Tpl.Text txt;
      Integer a_startValue;
      Boolean a_isFixed;
      Boolean a_hasStartValue;
      Boolean ret_2;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           "parameter",
           a_startValue,
           a_isFixed,
           a_hasStartValue )
      equation
        ret_0 = boolAnd(a_hasStartValue, a_isFixed);
        txt = fun_427(txt, ret_0, a_startValue, a_isFixed, a_hasStartValue);
      then txt;

    case ( txt,
           "",
           a_startValue,
           a_isFixed,
           a_hasStartValue )
      equation
        ret_1 = boolNot(a_isFixed);
        ret_2 = boolAnd(a_hasStartValue, ret_1);
        txt = fun_428(txt, ret_2, a_startValue);
      then txt;

    case ( txt,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_429;

protected function fun_430
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_startValue;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_startValue)
    local
      Tpl.Text txt;
      Integer a_startValue;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_startValue )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(start="));
        txt = Tpl.writeStr(txt, intString(a_startValue));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(",fixed=false)"));
      then txt;
  end match;
end fun_430;

protected function fun_431
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_startValue;
  input Boolean in_a_isFixed;
  input Boolean in_a_hasStartValue;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_startValue, in_a_isFixed, in_a_hasStartValue)
    local
      Tpl.Text txt;
      Integer a_startValue;
      Boolean a_isFixed;
      Boolean a_hasStartValue;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           false,
           a_startValue,
           a_isFixed,
           a_hasStartValue )
      equation
        ret_0 = boolNot(a_isFixed);
        ret_1 = boolAnd(a_hasStartValue, ret_0);
        txt = fun_430(txt, ret_1, a_startValue);
      then txt;

    case ( txt,
           _,
           _,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(fixed=false)"));
      then txt;
  end match;
end fun_431;

protected function fun_432
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_startValue;
  input Boolean in_a_isFixed;
  input Boolean in_a_hasStartValue;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_startValue, in_a_isFixed, in_a_hasStartValue)
    local
      Tpl.Text txt;
      Integer a_startValue;
      Boolean a_isFixed;
      Boolean a_hasStartValue;
      Boolean ret_2;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           false,
           a_startValue,
           a_isFixed,
           a_hasStartValue )
      equation
        ret_0 = boolNot(a_hasStartValue);
        ret_1 = boolNot(a_isFixed);
        ret_2 = boolAnd(ret_0, ret_1);
        txt = fun_431(txt, ret_2, a_startValue, a_isFixed, a_hasStartValue);
      then txt;

    case ( txt,
           _,
           _,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(fixed=true)"));
      then txt;
  end match;
end fun_432;

protected function fun_433
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_startValue;
  input Boolean in_a_isFixed;
  input Boolean in_a_hasStartValue;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_startValue, in_a_isFixed, in_a_hasStartValue)
    local
      Tpl.Text txt;
      Integer a_startValue;
      Boolean a_isFixed;
      Boolean a_hasStartValue;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           false,
           a_startValue,
           a_isFixed,
           a_hasStartValue )
      equation
        ret_0 = boolNot(a_hasStartValue);
        ret_1 = boolAnd(ret_0, a_isFixed);
        txt = fun_432(txt, ret_1, a_startValue, a_isFixed, a_hasStartValue);
      then txt;

    case ( txt,
           _,
           a_startValue,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(start="));
        txt = Tpl.writeStr(txt, intString(a_startValue));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(",fixed=false)"));
      then txt;
  end match;
end fun_433;

protected function fun_434
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_startValue;
  input Boolean in_a_isFixed;
  input Boolean in_a_hasStartValue;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_startValue, in_a_isFixed, in_a_hasStartValue)
    local
      Tpl.Text txt;
      Integer a_startValue;
      Boolean a_isFixed;
      Boolean a_hasStartValue;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           false,
           a_startValue,
           a_isFixed,
           a_hasStartValue )
      equation
        ret_0 = boolNot(a_isFixed);
        ret_1 = boolAnd(a_hasStartValue, ret_0);
        txt = fun_433(txt, ret_1, a_startValue, a_isFixed, a_hasStartValue);
      then txt;

    case ( txt,
           _,
           a_startValue,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeStr(txt, intString(a_startValue));
      then txt;
  end match;
end fun_434;

protected function fun_435
  input Tpl.Text in_txt;
  input String in_a_variabilityCausality;
  input Integer in_a_startValue;
  input Boolean in_a_isFixed;
  input Boolean in_a_hasStartValue;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_variabilityCausality, in_a_startValue, in_a_isFixed, in_a_hasStartValue)
    local
      Tpl.Text txt;
      Integer a_startValue;
      Boolean a_isFixed;
      Boolean a_hasStartValue;
      Boolean ret_0;

    case ( txt,
           "parameter",
           a_startValue,
           a_isFixed,
           a_hasStartValue )
      equation
        ret_0 = boolAnd(a_hasStartValue, a_isFixed);
        txt = fun_434(txt, ret_0, a_startValue, a_isFixed, a_hasStartValue);
      then txt;

    case ( txt,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_435;

public function dumpFMIIntegerModelVariableStartValue
  input Tpl.Text in_txt;
  input String in_a_FMUVersion;
  input String in_a_variabilityCausality;
  input Boolean in_a_hasStartValue;
  input Integer in_a_startValue;
  input Boolean in_a_isFixed;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_FMUVersion, in_a_variabilityCausality, in_a_hasStartValue, in_a_startValue, in_a_isFixed)
    local
      Tpl.Text txt;
      String a_variabilityCausality;
      Boolean a_hasStartValue;
      Integer a_startValue;
      Boolean a_isFixed;

    case ( txt,
           "1.0",
           a_variabilityCausality,
           a_hasStartValue,
           a_startValue,
           a_isFixed )
      equation
        txt = fun_429(txt, a_variabilityCausality, a_startValue, a_isFixed, a_hasStartValue);
      then txt;

    case ( txt,
           "2.0",
           a_variabilityCausality,
           a_hasStartValue,
           a_startValue,
           a_isFixed )
      equation
        txt = fun_435(txt, a_variabilityCausality, a_startValue, a_isFixed, a_hasStartValue);
      then txt;

    case ( txt,
           _,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end dumpFMIIntegerModelVariableStartValue;

protected function fun_437
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(fixed=false)"));
      then txt;
  end match;
end fun_437;

protected function fun_438
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Boolean in_a_isFixed;
  input Boolean in_a_hasStartValue;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_isFixed, in_a_hasStartValue)
    local
      Tpl.Text txt;
      Boolean a_isFixed;
      Boolean a_hasStartValue;
      Boolean ret_2;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           false,
           a_isFixed,
           a_hasStartValue )
      equation
        ret_0 = boolNot(a_hasStartValue);
        ret_1 = boolNot(a_isFixed);
        ret_2 = boolAnd(ret_0, ret_1);
        txt = fun_437(txt, ret_2);
      then txt;

    case ( txt,
           _,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(fixed=true)"));
      then txt;
  end match;
end fun_438;

protected function fun_439
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Boolean in_a_startValue;
  input Boolean in_a_isFixed;
  input Boolean in_a_hasStartValue;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_startValue, in_a_isFixed, in_a_hasStartValue)
    local
      Tpl.Text txt;
      Boolean a_startValue;
      Boolean a_isFixed;
      Boolean a_hasStartValue;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           false,
           _,
           a_isFixed,
           a_hasStartValue )
      equation
        ret_0 = boolNot(a_hasStartValue);
        ret_1 = boolAnd(ret_0, a_isFixed);
        txt = fun_438(txt, ret_1, a_isFixed, a_hasStartValue);
      then txt;

    case ( txt,
           _,
           a_startValue,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(start="));
        txt = Tpl.writeStr(txt, Tpl.booleanString(a_startValue));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(",fixed=false)"));
      then txt;
  end match;
end fun_439;

protected function fun_440
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Boolean in_a_startValue;
  input Boolean in_a_isFixed;
  input Boolean in_a_hasStartValue;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_startValue, in_a_isFixed, in_a_hasStartValue)
    local
      Tpl.Text txt;
      Boolean a_startValue;
      Boolean a_isFixed;
      Boolean a_hasStartValue;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           false,
           a_startValue,
           a_isFixed,
           a_hasStartValue )
      equation
        ret_0 = boolNot(a_isFixed);
        ret_1 = boolAnd(a_hasStartValue, ret_0);
        txt = fun_439(txt, ret_1, a_startValue, a_isFixed, a_hasStartValue);
      then txt;

    case ( txt,
           _,
           a_startValue,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeStr(txt, Tpl.booleanString(a_startValue));
      then txt;
  end match;
end fun_440;

protected function fun_441
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Boolean in_a_startValue;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_startValue)
    local
      Tpl.Text txt;
      Boolean a_startValue;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_startValue )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(start="));
        txt = Tpl.writeStr(txt, Tpl.booleanString(a_startValue));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(",fixed=false)"));
      then txt;
  end match;
end fun_441;

protected function fun_442
  input Tpl.Text in_txt;
  input String in_a_variabilityCausality;
  input Boolean in_a_startValue;
  input Boolean in_a_isFixed;
  input Boolean in_a_hasStartValue;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_variabilityCausality, in_a_startValue, in_a_isFixed, in_a_hasStartValue)
    local
      Tpl.Text txt;
      Boolean a_startValue;
      Boolean a_isFixed;
      Boolean a_hasStartValue;
      Boolean ret_2;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           "parameter",
           a_startValue,
           a_isFixed,
           a_hasStartValue )
      equation
        ret_0 = boolAnd(a_hasStartValue, a_isFixed);
        txt = fun_440(txt, ret_0, a_startValue, a_isFixed, a_hasStartValue);
      then txt;

    case ( txt,
           "",
           a_startValue,
           a_isFixed,
           a_hasStartValue )
      equation
        ret_1 = boolNot(a_isFixed);
        ret_2 = boolAnd(a_hasStartValue, ret_1);
        txt = fun_441(txt, ret_2, a_startValue);
      then txt;

    case ( txt,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_442;

protected function fun_443
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Boolean in_a_startValue;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_startValue)
    local
      Tpl.Text txt;
      Boolean a_startValue;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_startValue )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(start="));
        txt = Tpl.writeStr(txt, Tpl.booleanString(a_startValue));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(",fixed=false)"));
      then txt;
  end match;
end fun_443;

protected function fun_444
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Boolean in_a_startValue;
  input Boolean in_a_isFixed;
  input Boolean in_a_hasStartValue;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_startValue, in_a_isFixed, in_a_hasStartValue)
    local
      Tpl.Text txt;
      Boolean a_startValue;
      Boolean a_isFixed;
      Boolean a_hasStartValue;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           false,
           a_startValue,
           a_isFixed,
           a_hasStartValue )
      equation
        ret_0 = boolNot(a_isFixed);
        ret_1 = boolAnd(a_hasStartValue, ret_0);
        txt = fun_443(txt, ret_1, a_startValue);
      then txt;

    case ( txt,
           _,
           _,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(fixed=false)"));
      then txt;
  end match;
end fun_444;

protected function fun_445
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Boolean in_a_startValue;
  input Boolean in_a_isFixed;
  input Boolean in_a_hasStartValue;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_startValue, in_a_isFixed, in_a_hasStartValue)
    local
      Tpl.Text txt;
      Boolean a_startValue;
      Boolean a_isFixed;
      Boolean a_hasStartValue;
      Boolean ret_2;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           false,
           a_startValue,
           a_isFixed,
           a_hasStartValue )
      equation
        ret_0 = boolNot(a_hasStartValue);
        ret_1 = boolNot(a_isFixed);
        ret_2 = boolAnd(ret_0, ret_1);
        txt = fun_444(txt, ret_2, a_startValue, a_isFixed, a_hasStartValue);
      then txt;

    case ( txt,
           _,
           _,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(fixed=true)"));
      then txt;
  end match;
end fun_445;

protected function fun_446
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Boolean in_a_startValue;
  input Boolean in_a_isFixed;
  input Boolean in_a_hasStartValue;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_startValue, in_a_isFixed, in_a_hasStartValue)
    local
      Tpl.Text txt;
      Boolean a_startValue;
      Boolean a_isFixed;
      Boolean a_hasStartValue;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           false,
           a_startValue,
           a_isFixed,
           a_hasStartValue )
      equation
        ret_0 = boolNot(a_hasStartValue);
        ret_1 = boolAnd(ret_0, a_isFixed);
        txt = fun_445(txt, ret_1, a_startValue, a_isFixed, a_hasStartValue);
      then txt;

    case ( txt,
           _,
           a_startValue,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(start="));
        txt = Tpl.writeStr(txt, Tpl.booleanString(a_startValue));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(",fixed=false)"));
      then txt;
  end match;
end fun_446;

protected function fun_447
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Boolean in_a_startValue;
  input Boolean in_a_isFixed;
  input Boolean in_a_hasStartValue;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_startValue, in_a_isFixed, in_a_hasStartValue)
    local
      Tpl.Text txt;
      Boolean a_startValue;
      Boolean a_isFixed;
      Boolean a_hasStartValue;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           false,
           a_startValue,
           a_isFixed,
           a_hasStartValue )
      equation
        ret_0 = boolNot(a_isFixed);
        ret_1 = boolAnd(a_hasStartValue, ret_0);
        txt = fun_446(txt, ret_1, a_startValue, a_isFixed, a_hasStartValue);
      then txt;

    case ( txt,
           _,
           a_startValue,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = "));
        txt = Tpl.writeStr(txt, Tpl.booleanString(a_startValue));
      then txt;
  end match;
end fun_447;

protected function fun_448
  input Tpl.Text in_txt;
  input String in_a_variabilityCausality;
  input Boolean in_a_startValue;
  input Boolean in_a_isFixed;
  input Boolean in_a_hasStartValue;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_variabilityCausality, in_a_startValue, in_a_isFixed, in_a_hasStartValue)
    local
      Tpl.Text txt;
      Boolean a_startValue;
      Boolean a_isFixed;
      Boolean a_hasStartValue;
      Boolean ret_0;

    case ( txt,
           "parameter",
           a_startValue,
           a_isFixed,
           a_hasStartValue )
      equation
        ret_0 = boolAnd(a_hasStartValue, a_isFixed);
        txt = fun_447(txt, ret_0, a_startValue, a_isFixed, a_hasStartValue);
      then txt;

    case ( txt,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_448;

public function dumpFMIBooleanModelVariableStartValue
  input Tpl.Text in_txt;
  input String in_a_FMUVersion;
  input String in_a_variabilityCausality;
  input Boolean in_a_hasStartValue;
  input Boolean in_a_startValue;
  input Boolean in_a_isFixed;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_FMUVersion, in_a_variabilityCausality, in_a_hasStartValue, in_a_startValue, in_a_isFixed)
    local
      Tpl.Text txt;
      String a_variabilityCausality;
      Boolean a_hasStartValue;
      Boolean a_startValue;
      Boolean a_isFixed;

    case ( txt,
           "1.0",
           a_variabilityCausality,
           a_hasStartValue,
           a_startValue,
           a_isFixed )
      equation
        txt = fun_442(txt, a_variabilityCausality, a_startValue, a_isFixed, a_hasStartValue);
      then txt;

    case ( txt,
           "2.0",
           a_variabilityCausality,
           a_hasStartValue,
           a_startValue,
           a_isFixed )
      equation
        txt = fun_448(txt, a_variabilityCausality, a_startValue, a_isFixed, a_hasStartValue);
      then txt;

    case ( txt,
           _,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end dumpFMIBooleanModelVariableStartValue;

protected function fun_450
  input Tpl.Text in_txt;
  input Boolean in_mArg;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(fixed=false)"));
      then txt;
  end match;
end fun_450;

protected function fun_451
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Boolean in_a_isFixed;
  input Boolean in_a_hasStartValue;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_isFixed, in_a_hasStartValue)
    local
      Tpl.Text txt;
      Boolean a_isFixed;
      Boolean a_hasStartValue;
      Boolean ret_2;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           false,
           a_isFixed,
           a_hasStartValue )
      equation
        ret_0 = boolNot(a_hasStartValue);
        ret_1 = boolNot(a_isFixed);
        ret_2 = boolAnd(ret_0, ret_1);
        txt = fun_450(txt, ret_2);
      then txt;

    case ( txt,
           _,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(fixed=true)"));
      then txt;
  end match;
end fun_451;

protected function fun_452
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_startValue;
  input Boolean in_a_isFixed;
  input Boolean in_a_hasStartValue;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_startValue, in_a_isFixed, in_a_hasStartValue)
    local
      Tpl.Text txt;
      String a_startValue;
      Boolean a_isFixed;
      Boolean a_hasStartValue;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           false,
           _,
           a_isFixed,
           a_hasStartValue )
      equation
        ret_0 = boolNot(a_hasStartValue);
        ret_1 = boolAnd(ret_0, a_isFixed);
        txt = fun_451(txt, ret_1, a_isFixed, a_hasStartValue);
      then txt;

    case ( txt,
           _,
           a_startValue,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(start=\""));
        txt = Tpl.writeStr(txt, a_startValue);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\")"));
      then txt;
  end match;
end fun_452;

protected function fun_453
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_startValue;
  input Boolean in_a_isFixed;
  input Boolean in_a_hasStartValue;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_startValue, in_a_isFixed, in_a_hasStartValue)
    local
      Tpl.Text txt;
      String a_startValue;
      Boolean a_isFixed;
      Boolean a_hasStartValue;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           false,
           a_startValue,
           a_isFixed,
           a_hasStartValue )
      equation
        ret_0 = boolNot(a_isFixed);
        ret_1 = boolAnd(a_hasStartValue, ret_0);
        txt = fun_452(txt, ret_1, a_startValue, a_isFixed, a_hasStartValue);
      then txt;

    case ( txt,
           _,
           a_startValue,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = \""));
        txt = Tpl.writeStr(txt, a_startValue);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
      then txt;
  end match;
end fun_453;

protected function fun_454
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_startValue;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_startValue)
    local
      Tpl.Text txt;
      String a_startValue;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_startValue )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(start=\""));
        txt = Tpl.writeStr(txt, a_startValue);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\",fixed=false)"));
      then txt;
  end match;
end fun_454;

protected function fun_455
  input Tpl.Text in_txt;
  input String in_a_variabilityCausality;
  input String in_a_startValue;
  input Boolean in_a_isFixed;
  input Boolean in_a_hasStartValue;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_variabilityCausality, in_a_startValue, in_a_isFixed, in_a_hasStartValue)
    local
      Tpl.Text txt;
      String a_startValue;
      Boolean a_isFixed;
      Boolean a_hasStartValue;
      Boolean ret_2;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           "parameter",
           a_startValue,
           a_isFixed,
           a_hasStartValue )
      equation
        ret_0 = boolAnd(a_hasStartValue, a_isFixed);
        txt = fun_453(txt, ret_0, a_startValue, a_isFixed, a_hasStartValue);
      then txt;

    case ( txt,
           "",
           a_startValue,
           a_isFixed,
           a_hasStartValue )
      equation
        ret_1 = boolNot(a_isFixed);
        ret_2 = boolAnd(a_hasStartValue, ret_1);
        txt = fun_454(txt, ret_2, a_startValue);
      then txt;

    case ( txt,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_455;

protected function fun_456
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_startValue;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_startValue)
    local
      Tpl.Text txt;
      String a_startValue;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_startValue )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(start=\""));
        txt = Tpl.writeStr(txt, a_startValue);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\",fixed=false)"));
      then txt;
  end match;
end fun_456;

protected function fun_457
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_startValue;
  input Boolean in_a_isFixed;
  input Boolean in_a_hasStartValue;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_startValue, in_a_isFixed, in_a_hasStartValue)
    local
      Tpl.Text txt;
      String a_startValue;
      Boolean a_isFixed;
      Boolean a_hasStartValue;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           false,
           a_startValue,
           a_isFixed,
           a_hasStartValue )
      equation
        ret_0 = boolNot(a_isFixed);
        ret_1 = boolAnd(a_hasStartValue, ret_0);
        txt = fun_456(txt, ret_1, a_startValue);
      then txt;

    case ( txt,
           _,
           _,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(fixed=false)"));
      then txt;
  end match;
end fun_457;

protected function fun_458
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_startValue;
  input Boolean in_a_isFixed;
  input Boolean in_a_hasStartValue;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_startValue, in_a_isFixed, in_a_hasStartValue)
    local
      Tpl.Text txt;
      String a_startValue;
      Boolean a_isFixed;
      Boolean a_hasStartValue;
      Boolean ret_2;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           false,
           a_startValue,
           a_isFixed,
           a_hasStartValue )
      equation
        ret_0 = boolNot(a_hasStartValue);
        ret_1 = boolNot(a_isFixed);
        ret_2 = boolAnd(ret_0, ret_1);
        txt = fun_457(txt, ret_2, a_startValue, a_isFixed, a_hasStartValue);
      then txt;

    case ( txt,
           _,
           _,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(fixed=true)"));
      then txt;
  end match;
end fun_458;

protected function fun_459
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_startValue;
  input Boolean in_a_isFixed;
  input Boolean in_a_hasStartValue;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_startValue, in_a_isFixed, in_a_hasStartValue)
    local
      Tpl.Text txt;
      String a_startValue;
      Boolean a_isFixed;
      Boolean a_hasStartValue;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           false,
           a_startValue,
           a_isFixed,
           a_hasStartValue )
      equation
        ret_0 = boolNot(a_hasStartValue);
        ret_1 = boolAnd(ret_0, a_isFixed);
        txt = fun_458(txt, ret_1, a_startValue, a_isFixed, a_hasStartValue);
      then txt;

    case ( txt,
           _,
           a_startValue,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("(start=\""));
        txt = Tpl.writeStr(txt, a_startValue);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\",fixed=false)"));
      then txt;
  end match;
end fun_459;

protected function fun_460
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_startValue;
  input Boolean in_a_isFixed;
  input Boolean in_a_hasStartValue;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_startValue, in_a_isFixed, in_a_hasStartValue)
    local
      Tpl.Text txt;
      String a_startValue;
      Boolean a_isFixed;
      Boolean a_hasStartValue;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           false,
           a_startValue,
           a_isFixed,
           a_hasStartValue )
      equation
        ret_0 = boolNot(a_isFixed);
        ret_1 = boolAnd(a_hasStartValue, ret_0);
        txt = fun_459(txt, ret_1, a_startValue, a_isFixed, a_hasStartValue);
      then txt;

    case ( txt,
           _,
           a_startValue,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = \""));
        txt = Tpl.writeStr(txt, a_startValue);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
      then txt;
  end match;
end fun_460;

protected function fun_461
  input Tpl.Text in_txt;
  input String in_a_variabilityCausality;
  input String in_a_startValue;
  input Boolean in_a_isFixed;
  input Boolean in_a_hasStartValue;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_variabilityCausality, in_a_startValue, in_a_isFixed, in_a_hasStartValue)
    local
      Tpl.Text txt;
      String a_startValue;
      Boolean a_isFixed;
      Boolean a_hasStartValue;
      Boolean ret_0;

    case ( txt,
           "parameter",
           a_startValue,
           a_isFixed,
           a_hasStartValue )
      equation
        ret_0 = boolAnd(a_hasStartValue, a_isFixed);
        txt = fun_460(txt, ret_0, a_startValue, a_isFixed, a_hasStartValue);
      then txt;

    case ( txt,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end fun_461;

public function dumpFMIStringModelVariableStartValue
  input Tpl.Text in_txt;
  input String in_a_FMUVersion;
  input String in_a_variabilityCausality;
  input Boolean in_a_hasStartValue;
  input String in_a_startValue;
  input Boolean in_a_isFixed;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_FMUVersion, in_a_variabilityCausality, in_a_hasStartValue, in_a_startValue, in_a_isFixed)
    local
      Tpl.Text txt;
      String a_variabilityCausality;
      Boolean a_hasStartValue;
      String a_startValue;
      Boolean a_isFixed;

    case ( txt,
           "1.0",
           a_variabilityCausality,
           a_hasStartValue,
           a_startValue,
           a_isFixed )
      equation
        txt = fun_455(txt, a_variabilityCausality, a_startValue, a_isFixed, a_hasStartValue);
      then txt;

    case ( txt,
           "2.0",
           a_variabilityCausality,
           a_hasStartValue,
           a_startValue,
           a_isFixed )
      equation
        txt = fun_461(txt, a_variabilityCausality, a_startValue, a_isFixed, a_hasStartValue);
      then txt;

    case ( txt,
           _,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end dumpFMIStringModelVariableStartValue;

protected function fun_463
  input Tpl.Text in_txt;
  input Boolean in_a_hasStartValue;
  input list<FMI.TypeDefinitions> in_a_fmiTypeDefinitionsList;
  input String in_a_baseType;
  input Integer in_a_startValue;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_hasStartValue, in_a_fmiTypeDefinitionsList, in_a_baseType, in_a_startValue)
    local
      Tpl.Text txt;
      list<FMI.TypeDefinitions> a_fmiTypeDefinitionsList;
      String a_baseType;
      Integer a_startValue;
      String ret_0;

    case ( txt,
           false,
           _,
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_fmiTypeDefinitionsList,
           a_baseType,
           a_startValue )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" = map_"));
        ret_0 = FMI.getEnumerationTypeFromTypes(a_fmiTypeDefinitionsList, a_baseType);
        txt = Tpl.writeStr(txt, ret_0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_from_integer("));
        txt = Tpl.writeStr(txt, intString(a_startValue));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(")"));
      then txt;
  end match;
end fun_463;

public function dumpFMIEnumerationModelVariableStartValue
  input Tpl.Text txt;
  input list<FMI.TypeDefinitions> a_fmiTypeDefinitionsList;
  input String a_baseType;
  input Boolean a_hasStartValue;
  input Integer a_startValue;
  input Boolean a_isFixed;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_463(txt, a_hasStartValue, a_fmiTypeDefinitionsList, a_baseType, a_startValue);
end dumpFMIEnumerationModelVariableStartValue;

protected function fun_465
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_description;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_description)
    local
      Tpl.Text txt;
      String a_description;

    case ( txt,
           false,
           a_description )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" \""));
        txt = Tpl.writeStr(txt, a_description);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\""));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_465;

public function dumpFMIModelVariableDescription
  input Tpl.Text txt;
  input String a_description;

  output Tpl.Text out_txt;
protected
  Boolean ret_0;
algorithm
  ret_0 := stringEq(a_description, "");
  out_txt := fun_465(txt, ret_0, a_description);
end dumpFMIModelVariableDescription;

protected function fun_467
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_y2Placement;
  input Integer in_a_x2Placement;
  input Integer in_a_y1Placement;
  input Integer in_a_x1Placement;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_y2Placement, in_a_x2Placement, in_a_y1Placement, in_a_x1Placement)
    local
      Tpl.Text txt;
      Integer a_y2Placement;
      Integer a_x2Placement;
      Integer a_y1Placement;
      Integer a_x1Placement;

    case ( txt,
           false,
           _,
           _,
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_y2Placement,
           a_x2Placement,
           a_y1Placement,
           a_x1Placement )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" annotation(Placement(transformation(extent={{"));
        txt = Tpl.writeStr(txt, intString(a_x1Placement));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeStr(txt, intString(a_y1Placement));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("},{"));
        txt = Tpl.writeStr(txt, intString(a_x2Placement));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeStr(txt, intString(a_y2Placement));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}})))"));
      then txt;
  end match;
end fun_467;

protected function fun_468
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_x1Placement;
  input Integer in_a_x2Placement;
  input Integer in_a_y1Placement;
  input Integer in_a_y2Placement;
  input Boolean in_a_generateOutputConnectors;
  input String in_a_causality;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_x1Placement, in_a_x2Placement, in_a_y1Placement, in_a_y2Placement, in_a_generateOutputConnectors, in_a_causality)
    local
      Tpl.Text txt;
      Integer a_x1Placement;
      Integer a_x2Placement;
      Integer a_y1Placement;
      Integer a_y2Placement;
      Boolean a_generateOutputConnectors;
      String a_causality;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           false,
           a_x1Placement,
           a_x2Placement,
           a_y1Placement,
           a_y2Placement,
           a_generateOutputConnectors,
           a_causality )
      equation
        ret_0 = stringEq(a_causality, "output");
        ret_1 = boolAnd(a_generateOutputConnectors, ret_0);
        txt = fun_467(txt, ret_1, a_y2Placement, a_x2Placement, a_y1Placement, a_x1Placement);
      then txt;

    case ( txt,
           _,
           a_x1Placement,
           a_x2Placement,
           a_y1Placement,
           a_y2Placement,
           _,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(" annotation(Placement(transformation(extent={{"));
        txt = Tpl.writeStr(txt, intString(a_x1Placement));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeStr(txt, intString(a_y1Placement));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("},{"));
        txt = Tpl.writeStr(txt, intString(a_x2Placement));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(","));
        txt = Tpl.writeStr(txt, intString(a_y2Placement));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}})))"));
      then txt;
  end match;
end fun_468;

public function dumpFMIModelVariablePlacementAnnotation
  input Tpl.Text txt;
  input Integer a_x1Placement;
  input Integer a_x2Placement;
  input Integer a_y1Placement;
  input Integer a_y2Placement;
  input Boolean a_generateInputConnectors;
  input Boolean a_generateOutputConnectors;
  input String a_causality;

  output Tpl.Text out_txt;
protected
  Boolean ret_1;
  Boolean ret_0;
algorithm
  ret_0 := stringEq(a_causality, "input");
  ret_1 := boolAnd(a_generateInputConnectors, ret_0);
  out_txt := fun_468(txt, ret_1, a_x1Placement, a_x2Placement, a_y1Placement, a_y2Placement, a_generateOutputConnectors, a_causality);
end dumpFMIModelVariablePlacementAnnotation;

protected function lm_470
  input Tpl.Text in_txt;
  input list<FMI.ModelVariables> in_items;
  input String in_a_fmiVersion;
  input Integer in_a_what;
  input Boolean in_a_dependent;
  input String in_a_variabilityCausality;
  input String in_a_type;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_fmiVersion, in_a_what, in_a_dependent, in_a_variabilityCausality, in_a_type)
    local
      Tpl.Text txt;
      list<FMI.ModelVariables> rest;
      String a_fmiVersion;
      Integer a_what;
      Boolean a_dependent;
      String a_variabilityCausality;
      String a_type;
      FMI.ModelVariables i_fmiModelVariable;

    case ( txt,
           {},
           _,
           _,
           _,
           _,
           _ )
      then txt;

    case ( txt,
           i_fmiModelVariable :: rest,
           a_fmiVersion,
           a_what,
           a_dependent,
           a_variabilityCausality,
           a_type )
      equation
        txt = dumpVariable(txt, i_fmiModelVariable, a_type, a_variabilityCausality, a_dependent, a_what, a_fmiVersion);
        txt = Tpl.nextIter(txt);
        txt = lm_470(txt, rest, a_fmiVersion, a_what, a_dependent, a_variabilityCausality, a_type);
      then txt;
  end match;
end lm_470;

public function dumpVariables
  input Tpl.Text txt;
  input list<FMI.ModelVariables> a_fmiModelVariablesList;
  input String a_type;
  input String a_variabilityCausality;
  input Boolean a_dependent;
  input Integer a_what;
  input String a_fmiVersion;

  output Tpl.Text out_txt;
algorithm
  out_txt := Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, NONE(), SOME(Tpl.ST_STRING(", ")), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
  out_txt := lm_470(out_txt, a_fmiModelVariablesList, a_fmiVersion, a_what, a_dependent, a_variabilityCausality, a_type);
  out_txt := Tpl.popIter(out_txt);
end dumpVariables;

protected function fun_472
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_name)
    local
      Tpl.Text txt;
      String a_name;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_name )
      equation
        txt = Tpl.writeStr(txt, a_name);
      then txt;
  end match;
end fun_472;

protected function fun_473
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Real in_a_valueReference;
  input String in_a_name;
  input Integer in_a_what;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_valueReference, in_a_name, in_a_what)
    local
      Tpl.Text txt;
      Real a_valueReference;
      String a_name;
      Integer a_what;
      Boolean ret_0;

    case ( txt,
           false,
           _,
           a_name,
           a_what )
      equation
        ret_0 = intEq(a_what, 2);
        txt = fun_472(txt, ret_0, a_name);
      then txt;

    case ( txt,
           _,
           a_valueReference,
           _,
           _ )
      equation
        txt = Tpl.writeStr(txt, realString(a_valueReference));
      then txt;
  end match;
end fun_473;

protected function fun_474
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_name)
    local
      Tpl.Text txt;
      String a_name;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_name )
      equation
        txt = Tpl.writeStr(txt, a_name);
      then txt;
  end match;
end fun_474;

protected function fun_475
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Real in_a_valueReference;
  input String in_a_name;
  input Integer in_a_what;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_valueReference, in_a_name, in_a_what)
    local
      Tpl.Text txt;
      Real a_valueReference;
      String a_name;
      Integer a_what;
      Boolean ret_0;

    case ( txt,
           false,
           _,
           a_name,
           a_what )
      equation
        ret_0 = intEq(a_what, 2);
        txt = fun_474(txt, ret_0, a_name);
      then txt;

    case ( txt,
           _,
           a_valueReference,
           _,
           _ )
      equation
        txt = Tpl.writeStr(txt, realString(a_valueReference));
      then txt;
  end match;
end fun_475;

protected function fun_476
  input Tpl.Text in_txt;
  input FMI.ModelVariables in_a_fmiModelVariable;
  input Integer in_a_what;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fmiModelVariable, in_a_what)
    local
      Tpl.Text txt;
      Integer a_what;
      Real i_valueReference;
      String i_name;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           FMI.STRINGVARIABLE(variability = "", causality = "", name = i_name, valueReference = i_valueReference),
           a_what )
      equation
        ret_0 = intEq(a_what, 1);
        txt = fun_473(txt, ret_0, i_valueReference, i_name, a_what);
      then txt;

    case ( txt,
           FMI.STRINGVARIABLE(variability = "", causality = "output", name = i_name, valueReference = i_valueReference),
           a_what )
      equation
        ret_1 = intEq(a_what, 1);
        txt = fun_475(txt, ret_1, i_valueReference, i_name, a_what);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_476;

protected function fun_477
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_what;
  input FMI.ModelVariables in_a_fmiModelVariable;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_what, in_a_fmiModelVariable)
    local
      Tpl.Text txt;
      Integer a_what;
      FMI.ModelVariables a_fmiModelVariable;

    case ( txt,
           false,
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_what,
           a_fmiModelVariable )
      equation
        txt = fun_476(txt, a_fmiModelVariable, a_what);
      then txt;
  end match;
end fun_477;

protected function fun_478
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_name)
    local
      Tpl.Text txt;
      String a_name;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_name )
      equation
        txt = Tpl.writeStr(txt, a_name);
      then txt;
  end match;
end fun_478;

protected function fun_479
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Real in_a_valueReference;
  input String in_a_name;
  input Integer in_a_what;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_valueReference, in_a_name, in_a_what)
    local
      Tpl.Text txt;
      Real a_valueReference;
      String a_name;
      Integer a_what;
      Boolean ret_0;

    case ( txt,
           false,
           _,
           a_name,
           a_what )
      equation
        ret_0 = intEq(a_what, 2);
        txt = fun_478(txt, ret_0, a_name);
      then txt;

    case ( txt,
           _,
           a_valueReference,
           _,
           _ )
      equation
        txt = Tpl.writeStr(txt, realString(a_valueReference));
      then txt;
  end match;
end fun_479;

protected function fun_480
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_name)
    local
      Tpl.Text txt;
      String a_name;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_name )
      equation
        txt = Tpl.writeStr(txt, a_name);
      then txt;
  end match;
end fun_480;

protected function fun_481
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Real in_a_valueReference;
  input String in_a_name;
  input Integer in_a_what;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_valueReference, in_a_name, in_a_what)
    local
      Tpl.Text txt;
      Real a_valueReference;
      String a_name;
      Integer a_what;
      Boolean ret_0;

    case ( txt,
           false,
           _,
           a_name,
           a_what )
      equation
        ret_0 = intEq(a_what, 2);
        txt = fun_480(txt, ret_0, a_name);
      then txt;

    case ( txt,
           _,
           a_valueReference,
           _,
           _ )
      equation
        txt = Tpl.writeStr(txt, realString(a_valueReference));
      then txt;
  end match;
end fun_481;

protected function fun_482
  input Tpl.Text in_txt;
  input FMI.ModelVariables in_a_fmiModelVariable;
  input Integer in_a_what;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fmiModelVariable, in_a_what)
    local
      Tpl.Text txt;
      Integer a_what;
      Real i_valueReference;
      String i_name;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           FMI.BOOLEANVARIABLE(variability = "", causality = "", name = i_name, valueReference = i_valueReference),
           a_what )
      equation
        ret_0 = intEq(a_what, 1);
        txt = fun_479(txt, ret_0, i_valueReference, i_name, a_what);
      then txt;

    case ( txt,
           FMI.BOOLEANVARIABLE(variability = "", causality = "output", name = i_name, valueReference = i_valueReference),
           a_what )
      equation
        ret_1 = intEq(a_what, 1);
        txt = fun_481(txt, ret_1, i_valueReference, i_name, a_what);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_482;

protected function fun_483
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_what;
  input FMI.ModelVariables in_a_fmiModelVariable;
  input String in_a_variabilityCausality;
  input String in_a_type;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_what, in_a_fmiModelVariable, in_a_variabilityCausality, in_a_type)
    local
      Tpl.Text txt;
      Integer a_what;
      FMI.ModelVariables a_fmiModelVariable;
      String a_variabilityCausality;
      String a_type;
      Boolean ret_2;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           false,
           a_what,
           a_fmiModelVariable,
           a_variabilityCausality,
           a_type )
      equation
        ret_0 = stringEq(a_type, "string");
        ret_1 = stringEq(a_variabilityCausality, "output");
        ret_2 = boolAnd(ret_0, ret_1);
        txt = fun_477(txt, ret_2, a_what, a_fmiModelVariable);
      then txt;

    case ( txt,
           _,
           a_what,
           a_fmiModelVariable,
           _,
           _ )
      equation
        txt = fun_482(txt, a_fmiModelVariable, a_what);
      then txt;
  end match;
end fun_483;

protected function fun_484
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_name)
    local
      Tpl.Text txt;
      String a_name;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_name )
      equation
        txt = Tpl.writeStr(txt, a_name);
      then txt;
  end match;
end fun_484;

protected function fun_485
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Real in_a_valueReference;
  input String in_a_name;
  input Integer in_a_what;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_valueReference, in_a_name, in_a_what)
    local
      Tpl.Text txt;
      Real a_valueReference;
      String a_name;
      Integer a_what;
      Boolean ret_0;

    case ( txt,
           false,
           _,
           a_name,
           a_what )
      equation
        ret_0 = intEq(a_what, 2);
        txt = fun_484(txt, ret_0, a_name);
      then txt;

    case ( txt,
           _,
           a_valueReference,
           _,
           _ )
      equation
        txt = Tpl.writeStr(txt, realString(a_valueReference));
      then txt;
  end match;
end fun_485;

protected function fun_486
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_name)
    local
      Tpl.Text txt;
      String a_name;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_name )
      equation
        txt = Tpl.writeStr(txt, a_name);
      then txt;
  end match;
end fun_486;

protected function fun_487
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Real in_a_valueReference;
  input String in_a_name;
  input Integer in_a_what;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_valueReference, in_a_name, in_a_what)
    local
      Tpl.Text txt;
      Real a_valueReference;
      String a_name;
      Integer a_what;
      Boolean ret_0;

    case ( txt,
           false,
           _,
           a_name,
           a_what )
      equation
        ret_0 = intEq(a_what, 2);
        txt = fun_486(txt, ret_0, a_name);
      then txt;

    case ( txt,
           _,
           a_valueReference,
           _,
           _ )
      equation
        txt = Tpl.writeStr(txt, realString(a_valueReference));
      then txt;
  end match;
end fun_487;

protected function fun_488
  input Tpl.Text in_txt;
  input FMI.ModelVariables in_a_fmiModelVariable;
  input Integer in_a_what;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fmiModelVariable, in_a_what)
    local
      Tpl.Text txt;
      Integer a_what;
      Real i_valueReference;
      String i_name;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           FMI.INTEGERVARIABLE(variability = "", causality = "", name = i_name, valueReference = i_valueReference),
           a_what )
      equation
        ret_0 = intEq(a_what, 1);
        txt = fun_485(txt, ret_0, i_valueReference, i_name, a_what);
      then txt;

    case ( txt,
           FMI.INTEGERVARIABLE(variability = "", causality = "output", name = i_name, valueReference = i_valueReference),
           a_what )
      equation
        ret_1 = intEq(a_what, 1);
        txt = fun_487(txt, ret_1, i_valueReference, i_name, a_what);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_488;

protected function fun_489
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_what;
  input FMI.ModelVariables in_a_fmiModelVariable;
  input String in_a_variabilityCausality;
  input String in_a_type;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_what, in_a_fmiModelVariable, in_a_variabilityCausality, in_a_type)
    local
      Tpl.Text txt;
      Integer a_what;
      FMI.ModelVariables a_fmiModelVariable;
      String a_variabilityCausality;
      String a_type;
      Boolean ret_2;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           false,
           a_what,
           a_fmiModelVariable,
           a_variabilityCausality,
           a_type )
      equation
        ret_0 = stringEq(a_type, "boolean");
        ret_1 = stringEq(a_variabilityCausality, "output");
        ret_2 = boolAnd(ret_0, ret_1);
        txt = fun_483(txt, ret_2, a_what, a_fmiModelVariable, a_variabilityCausality, a_type);
      then txt;

    case ( txt,
           _,
           a_what,
           a_fmiModelVariable,
           _,
           _ )
      equation
        txt = fun_488(txt, a_fmiModelVariable, a_what);
      then txt;
  end match;
end fun_489;

protected function fun_490
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_name)
    local
      Tpl.Text txt;
      String a_name;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_name )
      equation
        txt = Tpl.writeStr(txt, a_name);
      then txt;
  end match;
end fun_490;

protected function fun_491
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Real in_a_valueReference;
  input String in_a_name;
  input Integer in_a_what;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_valueReference, in_a_name, in_a_what)
    local
      Tpl.Text txt;
      Real a_valueReference;
      String a_name;
      Integer a_what;
      Boolean ret_0;

    case ( txt,
           false,
           _,
           a_name,
           a_what )
      equation
        ret_0 = intEq(a_what, 2);
        txt = fun_490(txt, ret_0, a_name);
      then txt;

    case ( txt,
           _,
           a_valueReference,
           _,
           _ )
      equation
        txt = Tpl.writeStr(txt, realString(a_valueReference));
      then txt;
  end match;
end fun_491;

protected function fun_492
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_name)
    local
      Tpl.Text txt;
      String a_name;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_name )
      equation
        txt = Tpl.writeStr(txt, a_name);
      then txt;
  end match;
end fun_492;

protected function fun_493
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Real in_a_valueReference;
  input String in_a_name;
  input Integer in_a_what;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_valueReference, in_a_name, in_a_what)
    local
      Tpl.Text txt;
      Real a_valueReference;
      String a_name;
      Integer a_what;
      Boolean ret_0;

    case ( txt,
           false,
           _,
           a_name,
           a_what )
      equation
        ret_0 = intEq(a_what, 2);
        txt = fun_492(txt, ret_0, a_name);
      then txt;

    case ( txt,
           _,
           a_valueReference,
           _,
           _ )
      equation
        txt = Tpl.writeStr(txt, realString(a_valueReference));
      then txt;
  end match;
end fun_493;

protected function fun_494
  input Tpl.Text in_txt;
  input FMI.ModelVariables in_a_fmiModelVariable;
  input Integer in_a_what;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fmiModelVariable, in_a_what)
    local
      Tpl.Text txt;
      Integer a_what;
      Real i_valueReference;
      String i_name;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           FMI.REALVARIABLE(variability = "", causality = "", name = i_name, valueReference = i_valueReference),
           a_what )
      equation
        ret_0 = intEq(a_what, 1);
        txt = fun_491(txt, ret_0, i_valueReference, i_name, a_what);
      then txt;

    case ( txt,
           FMI.REALVARIABLE(variability = "", causality = "output", name = i_name, valueReference = i_valueReference),
           a_what )
      equation
        ret_1 = intEq(a_what, 1);
        txt = fun_493(txt, ret_1, i_valueReference, i_name, a_what);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_494;

protected function fun_495
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_what;
  input FMI.ModelVariables in_a_fmiModelVariable;
  input String in_a_variabilityCausality;
  input String in_a_type;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_what, in_a_fmiModelVariable, in_a_variabilityCausality, in_a_type)
    local
      Tpl.Text txt;
      Integer a_what;
      FMI.ModelVariables a_fmiModelVariable;
      String a_variabilityCausality;
      String a_type;
      Boolean ret_2;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           false,
           a_what,
           a_fmiModelVariable,
           a_variabilityCausality,
           a_type )
      equation
        ret_0 = stringEq(a_type, "integer");
        ret_1 = stringEq(a_variabilityCausality, "output");
        ret_2 = boolAnd(ret_0, ret_1);
        txt = fun_489(txt, ret_2, a_what, a_fmiModelVariable, a_variabilityCausality, a_type);
      then txt;

    case ( txt,
           _,
           a_what,
           a_fmiModelVariable,
           _,
           _ )
      equation
        txt = fun_494(txt, a_fmiModelVariable, a_what);
      then txt;
  end match;
end fun_495;

protected function fun_496
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_name)
    local
      Tpl.Text txt;
      String a_name;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("fmi_input_"));
        txt = Tpl.writeStr(txt, a_name);
      then txt;
  end match;
end fun_496;

protected function fun_497
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_name;
  input Integer in_a_what;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_name, in_a_what)
    local
      Tpl.Text txt;
      String a_name;
      Integer a_what;
      Boolean ret_0;

    case ( txt,
           false,
           a_name,
           a_what )
      equation
        ret_0 = intEq(a_what, 3);
        txt = fun_496(txt, ret_0, a_name);
      then txt;

    case ( txt,
           _,
           a_name,
           _ )
      equation
        txt = Tpl.writeStr(txt, a_name);
      then txt;
  end match;
end fun_497;

protected function fun_498
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Real in_a_valueReference;
  input String in_a_name;
  input Integer in_a_what;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_valueReference, in_a_name, in_a_what)
    local
      Tpl.Text txt;
      Real a_valueReference;
      String a_name;
      Integer a_what;
      Boolean ret_0;

    case ( txt,
           false,
           _,
           a_name,
           a_what )
      equation
        ret_0 = intEq(a_what, 2);
        txt = fun_497(txt, ret_0, a_name, a_what);
      then txt;

    case ( txt,
           _,
           a_valueReference,
           _,
           _ )
      equation
        txt = Tpl.writeStr(txt, realString(a_valueReference));
      then txt;
  end match;
end fun_498;

protected function fun_499
  input Tpl.Text in_txt;
  input FMI.ModelVariables in_a_fmiModelVariable;
  input Integer in_a_what;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fmiModelVariable, in_a_what)
    local
      Tpl.Text txt;
      Integer a_what;
      Real i_valueReference;
      String i_name;
      Boolean ret_0;

    case ( txt,
           FMI.STRINGVARIABLE(causality = "input", name = i_name, valueReference = i_valueReference),
           a_what )
      equation
        ret_0 = intEq(a_what, 1);
        txt = fun_498(txt, ret_0, i_valueReference, i_name, a_what);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_499;

protected function fun_500
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_what;
  input FMI.ModelVariables in_a_fmiModelVariable;
  input String in_a_variabilityCausality;
  input String in_a_type;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_what, in_a_fmiModelVariable, in_a_variabilityCausality, in_a_type)
    local
      Tpl.Text txt;
      Integer a_what;
      FMI.ModelVariables a_fmiModelVariable;
      String a_variabilityCausality;
      String a_type;
      Boolean ret_2;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           false,
           a_what,
           a_fmiModelVariable,
           a_variabilityCausality,
           a_type )
      equation
        ret_0 = stringEq(a_type, "real");
        ret_1 = stringEq(a_variabilityCausality, "output");
        ret_2 = boolAnd(ret_0, ret_1);
        txt = fun_495(txt, ret_2, a_what, a_fmiModelVariable, a_variabilityCausality, a_type);
      then txt;

    case ( txt,
           _,
           a_what,
           a_fmiModelVariable,
           _,
           _ )
      equation
        txt = fun_499(txt, a_fmiModelVariable, a_what);
      then txt;
  end match;
end fun_500;

protected function fun_501
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_name)
    local
      Tpl.Text txt;
      String a_name;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("fmi_input_"));
        txt = Tpl.writeStr(txt, a_name);
      then txt;
  end match;
end fun_501;

protected function fun_502
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_name;
  input Integer in_a_what;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_name, in_a_what)
    local
      Tpl.Text txt;
      String a_name;
      Integer a_what;
      Boolean ret_0;

    case ( txt,
           false,
           a_name,
           a_what )
      equation
        ret_0 = intEq(a_what, 3);
        txt = fun_501(txt, ret_0, a_name);
      then txt;

    case ( txt,
           _,
           a_name,
           _ )
      equation
        txt = Tpl.writeStr(txt, a_name);
      then txt;
  end match;
end fun_502;

protected function fun_503
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Real in_a_valueReference;
  input String in_a_name;
  input Integer in_a_what;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_valueReference, in_a_name, in_a_what)
    local
      Tpl.Text txt;
      Real a_valueReference;
      String a_name;
      Integer a_what;
      Boolean ret_0;

    case ( txt,
           false,
           _,
           a_name,
           a_what )
      equation
        ret_0 = intEq(a_what, 2);
        txt = fun_502(txt, ret_0, a_name, a_what);
      then txt;

    case ( txt,
           _,
           a_valueReference,
           _,
           _ )
      equation
        txt = Tpl.writeStr(txt, realString(a_valueReference));
      then txt;
  end match;
end fun_503;

protected function fun_504
  input Tpl.Text in_txt;
  input FMI.ModelVariables in_a_fmiModelVariable;
  input Integer in_a_what;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fmiModelVariable, in_a_what)
    local
      Tpl.Text txt;
      Integer a_what;
      Real i_valueReference;
      String i_name;
      Boolean ret_0;

    case ( txt,
           FMI.BOOLEANVARIABLE(causality = "input", name = i_name, valueReference = i_valueReference),
           a_what )
      equation
        ret_0 = intEq(a_what, 1);
        txt = fun_503(txt, ret_0, i_valueReference, i_name, a_what);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_504;

protected function fun_505
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_what;
  input FMI.ModelVariables in_a_fmiModelVariable;
  input String in_a_variabilityCausality;
  input String in_a_type;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_what, in_a_fmiModelVariable, in_a_variabilityCausality, in_a_type)
    local
      Tpl.Text txt;
      Integer a_what;
      FMI.ModelVariables a_fmiModelVariable;
      String a_variabilityCausality;
      String a_type;
      Boolean ret_2;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           false,
           a_what,
           a_fmiModelVariable,
           a_variabilityCausality,
           a_type )
      equation
        ret_0 = stringEq(a_type, "string");
        ret_1 = stringEq(a_variabilityCausality, "input");
        ret_2 = boolAnd(ret_0, ret_1);
        txt = fun_500(txt, ret_2, a_what, a_fmiModelVariable, a_variabilityCausality, a_type);
      then txt;

    case ( txt,
           _,
           a_what,
           a_fmiModelVariable,
           _,
           _ )
      equation
        txt = fun_504(txt, a_fmiModelVariable, a_what);
      then txt;
  end match;
end fun_505;

protected function fun_506
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_name)
    local
      Tpl.Text txt;
      String a_name;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("fmi_input_"));
        txt = Tpl.writeStr(txt, a_name);
      then txt;
  end match;
end fun_506;

protected function fun_507
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_name;
  input Integer in_a_what;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_name, in_a_what)
    local
      Tpl.Text txt;
      String a_name;
      Integer a_what;
      Boolean ret_0;

    case ( txt,
           false,
           a_name,
           a_what )
      equation
        ret_0 = intEq(a_what, 3);
        txt = fun_506(txt, ret_0, a_name);
      then txt;

    case ( txt,
           _,
           a_name,
           _ )
      equation
        txt = Tpl.writeStr(txt, a_name);
      then txt;
  end match;
end fun_507;

protected function fun_508
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Real in_a_valueReference;
  input String in_a_name;
  input Integer in_a_what;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_valueReference, in_a_name, in_a_what)
    local
      Tpl.Text txt;
      Real a_valueReference;
      String a_name;
      Integer a_what;
      Boolean ret_0;

    case ( txt,
           false,
           _,
           a_name,
           a_what )
      equation
        ret_0 = intEq(a_what, 2);
        txt = fun_507(txt, ret_0, a_name, a_what);
      then txt;

    case ( txt,
           _,
           a_valueReference,
           _,
           _ )
      equation
        txt = Tpl.writeStr(txt, realString(a_valueReference));
      then txt;
  end match;
end fun_508;

protected function fun_509
  input Tpl.Text in_txt;
  input FMI.ModelVariables in_a_fmiModelVariable;
  input Integer in_a_what;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fmiModelVariable, in_a_what)
    local
      Tpl.Text txt;
      Integer a_what;
      Real i_valueReference;
      String i_name;
      Boolean ret_0;

    case ( txt,
           FMI.INTEGERVARIABLE(causality = "input", name = i_name, valueReference = i_valueReference),
           a_what )
      equation
        ret_0 = intEq(a_what, 1);
        txt = fun_508(txt, ret_0, i_valueReference, i_name, a_what);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_509;

protected function fun_510
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_what;
  input FMI.ModelVariables in_a_fmiModelVariable;
  input String in_a_variabilityCausality;
  input String in_a_type;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_what, in_a_fmiModelVariable, in_a_variabilityCausality, in_a_type)
    local
      Tpl.Text txt;
      Integer a_what;
      FMI.ModelVariables a_fmiModelVariable;
      String a_variabilityCausality;
      String a_type;
      Boolean ret_2;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           false,
           a_what,
           a_fmiModelVariable,
           a_variabilityCausality,
           a_type )
      equation
        ret_0 = stringEq(a_type, "boolean");
        ret_1 = stringEq(a_variabilityCausality, "input");
        ret_2 = boolAnd(ret_0, ret_1);
        txt = fun_505(txt, ret_2, a_what, a_fmiModelVariable, a_variabilityCausality, a_type);
      then txt;

    case ( txt,
           _,
           a_what,
           a_fmiModelVariable,
           _,
           _ )
      equation
        txt = fun_509(txt, a_fmiModelVariable, a_what);
      then txt;
  end match;
end fun_510;

protected function fun_511
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_name)
    local
      Tpl.Text txt;
      String a_name;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_name )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("fmi_input_"));
        txt = Tpl.writeStr(txt, a_name);
      then txt;
  end match;
end fun_511;

protected function fun_512
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_name;
  input Integer in_a_what;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_name, in_a_what)
    local
      Tpl.Text txt;
      String a_name;
      Integer a_what;
      Boolean ret_0;

    case ( txt,
           false,
           a_name,
           a_what )
      equation
        ret_0 = intEq(a_what, 3);
        txt = fun_511(txt, ret_0, a_name);
      then txt;

    case ( txt,
           _,
           a_name,
           _ )
      equation
        txt = Tpl.writeStr(txt, a_name);
      then txt;
  end match;
end fun_512;

protected function fun_513
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Real in_a_valueReference;
  input String in_a_name;
  input Integer in_a_what;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_valueReference, in_a_name, in_a_what)
    local
      Tpl.Text txt;
      Real a_valueReference;
      String a_name;
      Integer a_what;
      Boolean ret_0;

    case ( txt,
           false,
           _,
           a_name,
           a_what )
      equation
        ret_0 = intEq(a_what, 2);
        txt = fun_512(txt, ret_0, a_name, a_what);
      then txt;

    case ( txt,
           _,
           a_valueReference,
           _,
           _ )
      equation
        txt = Tpl.writeStr(txt, realString(a_valueReference));
      then txt;
  end match;
end fun_513;

protected function fun_514
  input Tpl.Text in_txt;
  input FMI.ModelVariables in_a_fmiModelVariable;
  input Integer in_a_what;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fmiModelVariable, in_a_what)
    local
      Tpl.Text txt;
      Integer a_what;
      Real i_valueReference;
      String i_name;
      Boolean ret_0;

    case ( txt,
           FMI.REALVARIABLE(causality = "input", name = i_name, valueReference = i_valueReference),
           a_what )
      equation
        ret_0 = intEq(a_what, 1);
        txt = fun_513(txt, ret_0, i_valueReference, i_name, a_what);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_514;

protected function fun_515
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_what;
  input FMI.ModelVariables in_a_fmiModelVariable;
  input String in_a_variabilityCausality;
  input String in_a_type;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_what, in_a_fmiModelVariable, in_a_variabilityCausality, in_a_type)
    local
      Tpl.Text txt;
      Integer a_what;
      FMI.ModelVariables a_fmiModelVariable;
      String a_variabilityCausality;
      String a_type;
      Boolean ret_2;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           false,
           a_what,
           a_fmiModelVariable,
           a_variabilityCausality,
           a_type )
      equation
        ret_0 = stringEq(a_type, "integer");
        ret_1 = stringEq(a_variabilityCausality, "input");
        ret_2 = boolAnd(ret_0, ret_1);
        txt = fun_510(txt, ret_2, a_what, a_fmiModelVariable, a_variabilityCausality, a_type);
      then txt;

    case ( txt,
           _,
           a_what,
           a_fmiModelVariable,
           _,
           _ )
      equation
        txt = fun_514(txt, a_fmiModelVariable, a_what);
      then txt;
  end match;
end fun_515;

protected function fun_516
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_name)
    local
      Tpl.Text txt;
      String a_name;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_name )
      equation
        txt = Tpl.writeStr(txt, a_name);
      then txt;
  end match;
end fun_516;

protected function fun_517
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Real in_a_valueReference;
  input String in_a_name;
  input Integer in_a_what;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_valueReference, in_a_name, in_a_what)
    local
      Tpl.Text txt;
      Real a_valueReference;
      String a_name;
      Integer a_what;
      Boolean ret_0;

    case ( txt,
           false,
           _,
           a_name,
           a_what )
      equation
        ret_0 = intEq(a_what, 2);
        txt = fun_516(txt, ret_0, a_name);
      then txt;

    case ( txt,
           _,
           a_valueReference,
           _,
           _ )
      equation
        txt = Tpl.writeStr(txt, realString(a_valueReference));
      then txt;
  end match;
end fun_517;

protected function fun_518
  input Tpl.Text in_txt;
  input FMI.ModelVariables in_a_fmiModelVariable;
  input Integer in_a_what;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fmiModelVariable, in_a_what)
    local
      Tpl.Text txt;
      Integer a_what;
      Real i_valueReference;
      String i_name;
      Boolean ret_0;

    case ( txt,
           FMI.STRINGVARIABLE(causality = "parameter", hasStartValue = false, isFixed = false, name = i_name, valueReference = i_valueReference),
           a_what )
      equation
        ret_0 = intEq(a_what, 1);
        txt = fun_517(txt, ret_0, i_valueReference, i_name, a_what);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_518;

protected function fun_519
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_what;
  input FMI.ModelVariables in_a_fmiModelVariable;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_what, in_a_fmiModelVariable)
    local
      Tpl.Text txt;
      Integer a_what;
      FMI.ModelVariables a_fmiModelVariable;

    case ( txt,
           false,
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_what,
           a_fmiModelVariable )
      equation
        txt = fun_518(txt, a_fmiModelVariable, a_what);
      then txt;
  end match;
end fun_519;

protected function fun_520
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_name)
    local
      Tpl.Text txt;
      String a_name;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_name )
      equation
        txt = Tpl.writeStr(txt, a_name);
      then txt;
  end match;
end fun_520;

protected function fun_521
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Real in_a_valueReference;
  input String in_a_name;
  input Integer in_a_what;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_valueReference, in_a_name, in_a_what)
    local
      Tpl.Text txt;
      Real a_valueReference;
      String a_name;
      Integer a_what;
      Boolean ret_0;

    case ( txt,
           false,
           _,
           a_name,
           a_what )
      equation
        ret_0 = intEq(a_what, 2);
        txt = fun_520(txt, ret_0, a_name);
      then txt;

    case ( txt,
           _,
           a_valueReference,
           _,
           _ )
      equation
        txt = Tpl.writeStr(txt, realString(a_valueReference));
      then txt;
  end match;
end fun_521;

protected function fun_522
  input Tpl.Text in_txt;
  input FMI.ModelVariables in_a_fmiModelVariable;
  input Integer in_a_what;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fmiModelVariable, in_a_what)
    local
      Tpl.Text txt;
      Integer a_what;
      Real i_valueReference;
      String i_name;
      Boolean ret_0;

    case ( txt,
           FMI.STRINGVARIABLE(variability = "parameter", hasStartValue = false, isFixed = false, name = i_name, valueReference = i_valueReference),
           a_what )
      equation
        ret_0 = intEq(a_what, 1);
        txt = fun_521(txt, ret_0, i_valueReference, i_name, a_what);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_522;

protected function fun_523
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_what;
  input FMI.ModelVariables in_a_fmiModelVariable;
  input String in_a_fmiVersion;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_what, in_a_fmiModelVariable, in_a_fmiVersion)
    local
      Tpl.Text txt;
      Integer a_what;
      FMI.ModelVariables a_fmiModelVariable;
      String a_fmiVersion;
      Boolean ret_0;

    case ( txt,
           false,
           a_what,
           a_fmiModelVariable,
           a_fmiVersion )
      equation
        ret_0 = stringEq(a_fmiVersion, "2.0");
        txt = fun_519(txt, ret_0, a_what, a_fmiModelVariable);
      then txt;

    case ( txt,
           _,
           a_what,
           a_fmiModelVariable,
           _ )
      equation
        txt = fun_522(txt, a_fmiModelVariable, a_what);
      then txt;
  end match;
end fun_523;

protected function fun_524
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_fmiVersion;
  input Integer in_a_what;
  input FMI.ModelVariables in_a_fmiModelVariable;
  input String in_a_variabilityCausality;
  input String in_a_type;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_fmiVersion, in_a_what, in_a_fmiModelVariable, in_a_variabilityCausality, in_a_type)
    local
      Tpl.Text txt;
      String a_fmiVersion;
      Integer a_what;
      FMI.ModelVariables a_fmiModelVariable;
      String a_variabilityCausality;
      String a_type;
      Boolean ret_3;
      Boolean ret_2;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           false,
           _,
           a_what,
           a_fmiModelVariable,
           a_variabilityCausality,
           a_type )
      equation
        ret_0 = stringEq(a_type, "real");
        ret_1 = stringEq(a_variabilityCausality, "input");
        ret_2 = boolAnd(ret_0, ret_1);
        txt = fun_515(txt, ret_2, a_what, a_fmiModelVariable, a_variabilityCausality, a_type);
      then txt;

    case ( txt,
           _,
           a_fmiVersion,
           a_what,
           a_fmiModelVariable,
           _,
           _ )
      equation
        ret_3 = stringEq(a_fmiVersion, "1.0");
        txt = fun_523(txt, ret_3, a_what, a_fmiModelVariable, a_fmiVersion);
      then txt;
  end match;
end fun_524;

protected function fun_525
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_name)
    local
      Tpl.Text txt;
      String a_name;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_name )
      equation
        txt = Tpl.writeStr(txt, a_name);
      then txt;
  end match;
end fun_525;

protected function fun_526
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Real in_a_valueReference;
  input String in_a_name;
  input Integer in_a_what;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_valueReference, in_a_name, in_a_what)
    local
      Tpl.Text txt;
      Real a_valueReference;
      String a_name;
      Integer a_what;
      Boolean ret_0;

    case ( txt,
           false,
           _,
           a_name,
           a_what )
      equation
        ret_0 = intEq(a_what, 2);
        txt = fun_525(txt, ret_0, a_name);
      then txt;

    case ( txt,
           _,
           a_valueReference,
           _,
           _ )
      equation
        txt = Tpl.writeStr(txt, realString(a_valueReference));
      then txt;
  end match;
end fun_526;

protected function fun_527
  input Tpl.Text in_txt;
  input FMI.ModelVariables in_a_fmiModelVariable;
  input Integer in_a_what;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fmiModelVariable, in_a_what)
    local
      Tpl.Text txt;
      Integer a_what;
      Real i_valueReference;
      String i_name;
      Boolean ret_0;

    case ( txt,
           FMI.BOOLEANVARIABLE(causality = "parameter", hasStartValue = false, isFixed = false, name = i_name, valueReference = i_valueReference),
           a_what )
      equation
        ret_0 = intEq(a_what, 1);
        txt = fun_526(txt, ret_0, i_valueReference, i_name, a_what);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_527;

protected function fun_528
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_what;
  input FMI.ModelVariables in_a_fmiModelVariable;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_what, in_a_fmiModelVariable)
    local
      Tpl.Text txt;
      Integer a_what;
      FMI.ModelVariables a_fmiModelVariable;

    case ( txt,
           false,
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_what,
           a_fmiModelVariable )
      equation
        txt = fun_527(txt, a_fmiModelVariable, a_what);
      then txt;
  end match;
end fun_528;

protected function fun_529
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_name)
    local
      Tpl.Text txt;
      String a_name;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_name )
      equation
        txt = Tpl.writeStr(txt, a_name);
      then txt;
  end match;
end fun_529;

protected function fun_530
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Real in_a_valueReference;
  input String in_a_name;
  input Integer in_a_what;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_valueReference, in_a_name, in_a_what)
    local
      Tpl.Text txt;
      Real a_valueReference;
      String a_name;
      Integer a_what;
      Boolean ret_0;

    case ( txt,
           false,
           _,
           a_name,
           a_what )
      equation
        ret_0 = intEq(a_what, 2);
        txt = fun_529(txt, ret_0, a_name);
      then txt;

    case ( txt,
           _,
           a_valueReference,
           _,
           _ )
      equation
        txt = Tpl.writeStr(txt, realString(a_valueReference));
      then txt;
  end match;
end fun_530;

protected function fun_531
  input Tpl.Text in_txt;
  input FMI.ModelVariables in_a_fmiModelVariable;
  input Integer in_a_what;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fmiModelVariable, in_a_what)
    local
      Tpl.Text txt;
      Integer a_what;
      Real i_valueReference;
      String i_name;
      Boolean ret_0;

    case ( txt,
           FMI.BOOLEANVARIABLE(variability = "parameter", hasStartValue = false, isFixed = false, name = i_name, valueReference = i_valueReference),
           a_what )
      equation
        ret_0 = intEq(a_what, 1);
        txt = fun_530(txt, ret_0, i_valueReference, i_name, a_what);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_531;

protected function fun_532
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_what;
  input FMI.ModelVariables in_a_fmiModelVariable;
  input String in_a_fmiVersion;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_what, in_a_fmiModelVariable, in_a_fmiVersion)
    local
      Tpl.Text txt;
      Integer a_what;
      FMI.ModelVariables a_fmiModelVariable;
      String a_fmiVersion;
      Boolean ret_0;

    case ( txt,
           false,
           a_what,
           a_fmiModelVariable,
           a_fmiVersion )
      equation
        ret_0 = stringEq(a_fmiVersion, "2.0");
        txt = fun_528(txt, ret_0, a_what, a_fmiModelVariable);
      then txt;

    case ( txt,
           _,
           a_what,
           a_fmiModelVariable,
           _ )
      equation
        txt = fun_531(txt, a_fmiModelVariable, a_what);
      then txt;
  end match;
end fun_532;

protected function fun_533
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_fmiVersion;
  input Integer in_a_what;
  input FMI.ModelVariables in_a_fmiModelVariable;
  input Boolean in_a_dependent;
  input String in_a_variabilityCausality;
  input String in_a_type;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_fmiVersion, in_a_what, in_a_fmiModelVariable, in_a_dependent, in_a_variabilityCausality, in_a_type)
    local
      Tpl.Text txt;
      String a_fmiVersion;
      Integer a_what;
      FMI.ModelVariables a_fmiModelVariable;
      Boolean a_dependent;
      String a_variabilityCausality;
      String a_type;
      Boolean ret_4;
      Boolean ret_3;
      Boolean ret_2;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           false,
           a_fmiVersion,
           a_what,
           a_fmiModelVariable,
           a_dependent,
           a_variabilityCausality,
           a_type )
      equation
        ret_0 = stringEq(a_type, "string");
        ret_1 = stringEq(a_variabilityCausality, "parameter");
        ret_2 = boolAnd(ret_1, a_dependent);
        ret_3 = boolAnd(ret_0, ret_2);
        txt = fun_524(txt, ret_3, a_fmiVersion, a_what, a_fmiModelVariable, a_variabilityCausality, a_type);
      then txt;

    case ( txt,
           _,
           a_fmiVersion,
           a_what,
           a_fmiModelVariable,
           _,
           _,
           _ )
      equation
        ret_4 = stringEq(a_fmiVersion, "1.0");
        txt = fun_532(txt, ret_4, a_what, a_fmiModelVariable, a_fmiVersion);
      then txt;
  end match;
end fun_533;

protected function fun_534
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_name)
    local
      Tpl.Text txt;
      String a_name;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_name )
      equation
        txt = Tpl.writeStr(txt, a_name);
      then txt;
  end match;
end fun_534;

protected function fun_535
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Real in_a_valueReference;
  input String in_a_name;
  input Integer in_a_what;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_valueReference, in_a_name, in_a_what)
    local
      Tpl.Text txt;
      Real a_valueReference;
      String a_name;
      Integer a_what;
      Boolean ret_0;

    case ( txt,
           false,
           _,
           a_name,
           a_what )
      equation
        ret_0 = intEq(a_what, 2);
        txt = fun_534(txt, ret_0, a_name);
      then txt;

    case ( txt,
           _,
           a_valueReference,
           _,
           _ )
      equation
        txt = Tpl.writeStr(txt, realString(a_valueReference));
      then txt;
  end match;
end fun_535;

protected function fun_536
  input Tpl.Text in_txt;
  input FMI.ModelVariables in_a_fmiModelVariable;
  input Integer in_a_what;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fmiModelVariable, in_a_what)
    local
      Tpl.Text txt;
      Integer a_what;
      Real i_valueReference;
      String i_name;
      Boolean ret_0;

    case ( txt,
           FMI.INTEGERVARIABLE(causality = "parameter", hasStartValue = false, isFixed = false, name = i_name, valueReference = i_valueReference),
           a_what )
      equation
        ret_0 = intEq(a_what, 1);
        txt = fun_535(txt, ret_0, i_valueReference, i_name, a_what);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_536;

protected function fun_537
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_what;
  input FMI.ModelVariables in_a_fmiModelVariable;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_what, in_a_fmiModelVariable)
    local
      Tpl.Text txt;
      Integer a_what;
      FMI.ModelVariables a_fmiModelVariable;

    case ( txt,
           false,
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_what,
           a_fmiModelVariable )
      equation
        txt = fun_536(txt, a_fmiModelVariable, a_what);
      then txt;
  end match;
end fun_537;

protected function fun_538
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_name)
    local
      Tpl.Text txt;
      String a_name;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_name )
      equation
        txt = Tpl.writeStr(txt, a_name);
      then txt;
  end match;
end fun_538;

protected function fun_539
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Real in_a_valueReference;
  input String in_a_name;
  input Integer in_a_what;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_valueReference, in_a_name, in_a_what)
    local
      Tpl.Text txt;
      Real a_valueReference;
      String a_name;
      Integer a_what;
      Boolean ret_0;

    case ( txt,
           false,
           _,
           a_name,
           a_what )
      equation
        ret_0 = intEq(a_what, 2);
        txt = fun_538(txt, ret_0, a_name);
      then txt;

    case ( txt,
           _,
           a_valueReference,
           _,
           _ )
      equation
        txt = Tpl.writeStr(txt, realString(a_valueReference));
      then txt;
  end match;
end fun_539;

protected function fun_540
  input Tpl.Text in_txt;
  input FMI.ModelVariables in_a_fmiModelVariable;
  input Integer in_a_what;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fmiModelVariable, in_a_what)
    local
      Tpl.Text txt;
      Integer a_what;
      Real i_valueReference;
      String i_name;
      Boolean ret_0;

    case ( txt,
           FMI.INTEGERVARIABLE(variability = "parameter", hasStartValue = false, isFixed = false, name = i_name, valueReference = i_valueReference),
           a_what )
      equation
        ret_0 = intEq(a_what, 1);
        txt = fun_539(txt, ret_0, i_valueReference, i_name, a_what);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_540;

protected function fun_541
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_what;
  input FMI.ModelVariables in_a_fmiModelVariable;
  input String in_a_fmiVersion;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_what, in_a_fmiModelVariable, in_a_fmiVersion)
    local
      Tpl.Text txt;
      Integer a_what;
      FMI.ModelVariables a_fmiModelVariable;
      String a_fmiVersion;
      Boolean ret_0;

    case ( txt,
           false,
           a_what,
           a_fmiModelVariable,
           a_fmiVersion )
      equation
        ret_0 = stringEq(a_fmiVersion, "2.0");
        txt = fun_537(txt, ret_0, a_what, a_fmiModelVariable);
      then txt;

    case ( txt,
           _,
           a_what,
           a_fmiModelVariable,
           _ )
      equation
        txt = fun_540(txt, a_fmiModelVariable, a_what);
      then txt;
  end match;
end fun_541;

protected function fun_542
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_fmiVersion;
  input Integer in_a_what;
  input FMI.ModelVariables in_a_fmiModelVariable;
  input Boolean in_a_dependent;
  input String in_a_variabilityCausality;
  input String in_a_type;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_fmiVersion, in_a_what, in_a_fmiModelVariable, in_a_dependent, in_a_variabilityCausality, in_a_type)
    local
      Tpl.Text txt;
      String a_fmiVersion;
      Integer a_what;
      FMI.ModelVariables a_fmiModelVariable;
      Boolean a_dependent;
      String a_variabilityCausality;
      String a_type;
      Boolean ret_4;
      Boolean ret_3;
      Boolean ret_2;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           false,
           a_fmiVersion,
           a_what,
           a_fmiModelVariable,
           a_dependent,
           a_variabilityCausality,
           a_type )
      equation
        ret_0 = stringEq(a_type, "boolean");
        ret_1 = stringEq(a_variabilityCausality, "parameter");
        ret_2 = boolAnd(ret_1, a_dependent);
        ret_3 = boolAnd(ret_0, ret_2);
        txt = fun_533(txt, ret_3, a_fmiVersion, a_what, a_fmiModelVariable, a_dependent, a_variabilityCausality, a_type);
      then txt;

    case ( txt,
           _,
           a_fmiVersion,
           a_what,
           a_fmiModelVariable,
           _,
           _,
           _ )
      equation
        ret_4 = stringEq(a_fmiVersion, "1.0");
        txt = fun_541(txt, ret_4, a_what, a_fmiModelVariable, a_fmiVersion);
      then txt;
  end match;
end fun_542;

protected function fun_543
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_name)
    local
      Tpl.Text txt;
      String a_name;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_name )
      equation
        txt = Tpl.writeStr(txt, a_name);
      then txt;
  end match;
end fun_543;

protected function fun_544
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Real in_a_valueReference;
  input String in_a_name;
  input Integer in_a_what;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_valueReference, in_a_name, in_a_what)
    local
      Tpl.Text txt;
      Real a_valueReference;
      String a_name;
      Integer a_what;
      Boolean ret_0;

    case ( txt,
           false,
           _,
           a_name,
           a_what )
      equation
        ret_0 = intEq(a_what, 2);
        txt = fun_543(txt, ret_0, a_name);
      then txt;

    case ( txt,
           _,
           a_valueReference,
           _,
           _ )
      equation
        txt = Tpl.writeStr(txt, realString(a_valueReference));
      then txt;
  end match;
end fun_544;

protected function fun_545
  input Tpl.Text in_txt;
  input FMI.ModelVariables in_a_fmiModelVariable;
  input Integer in_a_what;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fmiModelVariable, in_a_what)
    local
      Tpl.Text txt;
      Integer a_what;
      Real i_valueReference;
      String i_name;
      Boolean ret_0;

    case ( txt,
           FMI.REALVARIABLE(causality = "parameter", hasStartValue = false, isFixed = false, name = i_name, valueReference = i_valueReference),
           a_what )
      equation
        ret_0 = intEq(a_what, 1);
        txt = fun_544(txt, ret_0, i_valueReference, i_name, a_what);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_545;

protected function fun_546
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_what;
  input FMI.ModelVariables in_a_fmiModelVariable;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_what, in_a_fmiModelVariable)
    local
      Tpl.Text txt;
      Integer a_what;
      FMI.ModelVariables a_fmiModelVariable;

    case ( txt,
           false,
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_what,
           a_fmiModelVariable )
      equation
        txt = fun_545(txt, a_fmiModelVariable, a_what);
      then txt;
  end match;
end fun_546;

protected function fun_547
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_name)
    local
      Tpl.Text txt;
      String a_name;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_name )
      equation
        txt = Tpl.writeStr(txt, a_name);
      then txt;
  end match;
end fun_547;

protected function fun_548
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Real in_a_valueReference;
  input String in_a_name;
  input Integer in_a_what;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_valueReference, in_a_name, in_a_what)
    local
      Tpl.Text txt;
      Real a_valueReference;
      String a_name;
      Integer a_what;
      Boolean ret_0;

    case ( txt,
           false,
           _,
           a_name,
           a_what )
      equation
        ret_0 = intEq(a_what, 2);
        txt = fun_547(txt, ret_0, a_name);
      then txt;

    case ( txt,
           _,
           a_valueReference,
           _,
           _ )
      equation
        txt = Tpl.writeStr(txt, realString(a_valueReference));
      then txt;
  end match;
end fun_548;

protected function fun_549
  input Tpl.Text in_txt;
  input FMI.ModelVariables in_a_fmiModelVariable;
  input Integer in_a_what;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fmiModelVariable, in_a_what)
    local
      Tpl.Text txt;
      Integer a_what;
      Real i_valueReference;
      String i_name;
      Boolean ret_0;

    case ( txt,
           FMI.REALVARIABLE(variability = "parameter", hasStartValue = false, isFixed = false, name = i_name, valueReference = i_valueReference),
           a_what )
      equation
        ret_0 = intEq(a_what, 1);
        txt = fun_548(txt, ret_0, i_valueReference, i_name, a_what);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_549;

protected function fun_550
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_what;
  input FMI.ModelVariables in_a_fmiModelVariable;
  input String in_a_fmiVersion;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_what, in_a_fmiModelVariable, in_a_fmiVersion)
    local
      Tpl.Text txt;
      Integer a_what;
      FMI.ModelVariables a_fmiModelVariable;
      String a_fmiVersion;
      Boolean ret_0;

    case ( txt,
           false,
           a_what,
           a_fmiModelVariable,
           a_fmiVersion )
      equation
        ret_0 = stringEq(a_fmiVersion, "2.0");
        txt = fun_546(txt, ret_0, a_what, a_fmiModelVariable);
      then txt;

    case ( txt,
           _,
           a_what,
           a_fmiModelVariable,
           _ )
      equation
        txt = fun_549(txt, a_fmiModelVariable, a_what);
      then txt;
  end match;
end fun_550;

protected function fun_551
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_fmiVersion;
  input Integer in_a_what;
  input FMI.ModelVariables in_a_fmiModelVariable;
  input Boolean in_a_dependent;
  input String in_a_variabilityCausality;
  input String in_a_type;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_fmiVersion, in_a_what, in_a_fmiModelVariable, in_a_dependent, in_a_variabilityCausality, in_a_type)
    local
      Tpl.Text txt;
      String a_fmiVersion;
      Integer a_what;
      FMI.ModelVariables a_fmiModelVariable;
      Boolean a_dependent;
      String a_variabilityCausality;
      String a_type;
      Boolean ret_4;
      Boolean ret_3;
      Boolean ret_2;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           false,
           a_fmiVersion,
           a_what,
           a_fmiModelVariable,
           a_dependent,
           a_variabilityCausality,
           a_type )
      equation
        ret_0 = stringEq(a_type, "integer");
        ret_1 = stringEq(a_variabilityCausality, "parameter");
        ret_2 = boolAnd(ret_1, a_dependent);
        ret_3 = boolAnd(ret_0, ret_2);
        txt = fun_542(txt, ret_3, a_fmiVersion, a_what, a_fmiModelVariable, a_dependent, a_variabilityCausality, a_type);
      then txt;

    case ( txt,
           _,
           a_fmiVersion,
           a_what,
           a_fmiModelVariable,
           _,
           _,
           _ )
      equation
        ret_4 = stringEq(a_fmiVersion, "1.0");
        txt = fun_550(txt, ret_4, a_what, a_fmiModelVariable, a_fmiVersion);
      then txt;
  end match;
end fun_551;

protected function fun_552
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_name)
    local
      Tpl.Text txt;
      String a_name;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_name )
      equation
        txt = Tpl.writeStr(txt, a_name);
      then txt;
  end match;
end fun_552;

protected function fun_553
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Real in_a_valueReference;
  input String in_a_name;
  input Integer in_a_what;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_valueReference, in_a_name, in_a_what)
    local
      Tpl.Text txt;
      Real a_valueReference;
      String a_name;
      Integer a_what;
      Boolean ret_0;

    case ( txt,
           false,
           _,
           a_name,
           a_what )
      equation
        ret_0 = intEq(a_what, 2);
        txt = fun_552(txt, ret_0, a_name);
      then txt;

    case ( txt,
           _,
           a_valueReference,
           _,
           _ )
      equation
        txt = Tpl.writeStr(txt, realString(a_valueReference));
      then txt;
  end match;
end fun_553;

protected function fun_554
  input Tpl.Text in_txt;
  input FMI.ModelVariables in_a_fmiModelVariable;
  input Integer in_a_what;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fmiModelVariable, in_a_what)
    local
      Tpl.Text txt;
      Integer a_what;
      Real i_valueReference;
      String i_name;
      Boolean ret_0;

    case ( txt,
           FMI.STRINGVARIABLE(causality = "parameter", hasStartValue = true, name = i_name, valueReference = i_valueReference),
           a_what )
      equation
        ret_0 = intEq(a_what, 1);
        txt = fun_553(txt, ret_0, i_valueReference, i_name, a_what);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_554;

protected function fun_555
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_what;
  input FMI.ModelVariables in_a_fmiModelVariable;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_what, in_a_fmiModelVariable)
    local
      Tpl.Text txt;
      Integer a_what;
      FMI.ModelVariables a_fmiModelVariable;

    case ( txt,
           false,
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_what,
           a_fmiModelVariable )
      equation
        txt = fun_554(txt, a_fmiModelVariable, a_what);
      then txt;
  end match;
end fun_555;

protected function fun_556
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_name)
    local
      Tpl.Text txt;
      String a_name;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_name )
      equation
        txt = Tpl.writeStr(txt, a_name);
      then txt;
  end match;
end fun_556;

protected function fun_557
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Real in_a_valueReference;
  input String in_a_name;
  input Integer in_a_what;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_valueReference, in_a_name, in_a_what)
    local
      Tpl.Text txt;
      Real a_valueReference;
      String a_name;
      Integer a_what;
      Boolean ret_0;

    case ( txt,
           false,
           _,
           a_name,
           a_what )
      equation
        ret_0 = intEq(a_what, 2);
        txt = fun_556(txt, ret_0, a_name);
      then txt;

    case ( txt,
           _,
           a_valueReference,
           _,
           _ )
      equation
        txt = Tpl.writeStr(txt, realString(a_valueReference));
      then txt;
  end match;
end fun_557;

protected function fun_558
  input Tpl.Text in_txt;
  input FMI.ModelVariables in_a_fmiModelVariable;
  input Integer in_a_what;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fmiModelVariable, in_a_what)
    local
      Tpl.Text txt;
      Integer a_what;
      Real i_valueReference;
      String i_name;
      Boolean ret_0;

    case ( txt,
           FMI.STRINGVARIABLE(variability = "parameter", hasStartValue = true, name = i_name, valueReference = i_valueReference),
           a_what )
      equation
        ret_0 = intEq(a_what, 1);
        txt = fun_557(txt, ret_0, i_valueReference, i_name, a_what);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_558;

protected function fun_559
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_what;
  input FMI.ModelVariables in_a_fmiModelVariable;
  input String in_a_fmiVersion;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_what, in_a_fmiModelVariable, in_a_fmiVersion)
    local
      Tpl.Text txt;
      Integer a_what;
      FMI.ModelVariables a_fmiModelVariable;
      String a_fmiVersion;
      Boolean ret_0;

    case ( txt,
           false,
           a_what,
           a_fmiModelVariable,
           a_fmiVersion )
      equation
        ret_0 = stringEq(a_fmiVersion, "2.0");
        txt = fun_555(txt, ret_0, a_what, a_fmiModelVariable);
      then txt;

    case ( txt,
           _,
           a_what,
           a_fmiModelVariable,
           _ )
      equation
        txt = fun_558(txt, a_fmiModelVariable, a_what);
      then txt;
  end match;
end fun_559;

protected function fun_560
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_fmiVersion;
  input Integer in_a_what;
  input FMI.ModelVariables in_a_fmiModelVariable;
  input Boolean in_a_dependent;
  input String in_a_variabilityCausality;
  input String in_a_type;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_fmiVersion, in_a_what, in_a_fmiModelVariable, in_a_dependent, in_a_variabilityCausality, in_a_type)
    local
      Tpl.Text txt;
      String a_fmiVersion;
      Integer a_what;
      FMI.ModelVariables a_fmiModelVariable;
      Boolean a_dependent;
      String a_variabilityCausality;
      String a_type;
      Boolean ret_4;
      Boolean ret_3;
      Boolean ret_2;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           false,
           a_fmiVersion,
           a_what,
           a_fmiModelVariable,
           a_dependent,
           a_variabilityCausality,
           a_type )
      equation
        ret_0 = stringEq(a_type, "real");
        ret_1 = stringEq(a_variabilityCausality, "parameter");
        ret_2 = boolAnd(ret_1, a_dependent);
        ret_3 = boolAnd(ret_0, ret_2);
        txt = fun_551(txt, ret_3, a_fmiVersion, a_what, a_fmiModelVariable, a_dependent, a_variabilityCausality, a_type);
      then txt;

    case ( txt,
           _,
           a_fmiVersion,
           a_what,
           a_fmiModelVariable,
           _,
           _,
           _ )
      equation
        ret_4 = stringEq(a_fmiVersion, "1.0");
        txt = fun_559(txt, ret_4, a_what, a_fmiModelVariable, a_fmiVersion);
      then txt;
  end match;
end fun_560;

protected function fun_561
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_name)
    local
      Tpl.Text txt;
      String a_name;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_name )
      equation
        txt = Tpl.writeStr(txt, a_name);
      then txt;
  end match;
end fun_561;

protected function fun_562
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Real in_a_valueReference;
  input String in_a_name;
  input Integer in_a_what;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_valueReference, in_a_name, in_a_what)
    local
      Tpl.Text txt;
      Real a_valueReference;
      String a_name;
      Integer a_what;
      Boolean ret_0;

    case ( txt,
           false,
           _,
           a_name,
           a_what )
      equation
        ret_0 = intEq(a_what, 2);
        txt = fun_561(txt, ret_0, a_name);
      then txt;

    case ( txt,
           _,
           a_valueReference,
           _,
           _ )
      equation
        txt = Tpl.writeStr(txt, realString(a_valueReference));
      then txt;
  end match;
end fun_562;

protected function fun_563
  input Tpl.Text in_txt;
  input FMI.ModelVariables in_a_fmiModelVariable;
  input Integer in_a_what;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fmiModelVariable, in_a_what)
    local
      Tpl.Text txt;
      Integer a_what;
      Real i_valueReference;
      String i_name;
      Boolean ret_0;

    case ( txt,
           FMI.BOOLEANVARIABLE(causality = "parameter", hasStartValue = true, name = i_name, valueReference = i_valueReference),
           a_what )
      equation
        ret_0 = intEq(a_what, 1);
        txt = fun_562(txt, ret_0, i_valueReference, i_name, a_what);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_563;

protected function fun_564
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_what;
  input FMI.ModelVariables in_a_fmiModelVariable;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_what, in_a_fmiModelVariable)
    local
      Tpl.Text txt;
      Integer a_what;
      FMI.ModelVariables a_fmiModelVariable;

    case ( txt,
           false,
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_what,
           a_fmiModelVariable )
      equation
        txt = fun_563(txt, a_fmiModelVariable, a_what);
      then txt;
  end match;
end fun_564;

protected function fun_565
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_name)
    local
      Tpl.Text txt;
      String a_name;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_name )
      equation
        txt = Tpl.writeStr(txt, a_name);
      then txt;
  end match;
end fun_565;

protected function fun_566
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Real in_a_valueReference;
  input String in_a_name;
  input Integer in_a_what;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_valueReference, in_a_name, in_a_what)
    local
      Tpl.Text txt;
      Real a_valueReference;
      String a_name;
      Integer a_what;
      Boolean ret_0;

    case ( txt,
           false,
           _,
           a_name,
           a_what )
      equation
        ret_0 = intEq(a_what, 2);
        txt = fun_565(txt, ret_0, a_name);
      then txt;

    case ( txt,
           _,
           a_valueReference,
           _,
           _ )
      equation
        txt = Tpl.writeStr(txt, realString(a_valueReference));
      then txt;
  end match;
end fun_566;

protected function fun_567
  input Tpl.Text in_txt;
  input FMI.ModelVariables in_a_fmiModelVariable;
  input Integer in_a_what;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fmiModelVariable, in_a_what)
    local
      Tpl.Text txt;
      Integer a_what;
      Real i_valueReference;
      String i_name;
      Boolean ret_0;

    case ( txt,
           FMI.BOOLEANVARIABLE(variability = "parameter", hasStartValue = true, name = i_name, valueReference = i_valueReference),
           a_what )
      equation
        ret_0 = intEq(a_what, 1);
        txt = fun_566(txt, ret_0, i_valueReference, i_name, a_what);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_567;

protected function fun_568
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_what;
  input FMI.ModelVariables in_a_fmiModelVariable;
  input String in_a_fmiVersion;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_what, in_a_fmiModelVariable, in_a_fmiVersion)
    local
      Tpl.Text txt;
      Integer a_what;
      FMI.ModelVariables a_fmiModelVariable;
      String a_fmiVersion;
      Boolean ret_0;

    case ( txt,
           false,
           a_what,
           a_fmiModelVariable,
           a_fmiVersion )
      equation
        ret_0 = stringEq(a_fmiVersion, "2.0");
        txt = fun_564(txt, ret_0, a_what, a_fmiModelVariable);
      then txt;

    case ( txt,
           _,
           a_what,
           a_fmiModelVariable,
           _ )
      equation
        txt = fun_567(txt, a_fmiModelVariable, a_what);
      then txt;
  end match;
end fun_568;

protected function fun_569
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_fmiVersion;
  input Integer in_a_what;
  input FMI.ModelVariables in_a_fmiModelVariable;
  input Boolean in_a_dependent;
  input String in_a_variabilityCausality;
  input String in_a_type;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_fmiVersion, in_a_what, in_a_fmiModelVariable, in_a_dependent, in_a_variabilityCausality, in_a_type)
    local
      Tpl.Text txt;
      String a_fmiVersion;
      Integer a_what;
      FMI.ModelVariables a_fmiModelVariable;
      Boolean a_dependent;
      String a_variabilityCausality;
      String a_type;
      Boolean ret_5;
      Boolean ret_4;
      Boolean ret_3;
      Boolean ret_2;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           false,
           a_fmiVersion,
           a_what,
           a_fmiModelVariable,
           a_dependent,
           a_variabilityCausality,
           a_type )
      equation
        ret_0 = stringEq(a_type, "string");
        ret_1 = stringEq(a_variabilityCausality, "parameter");
        ret_2 = boolNot(a_dependent);
        ret_3 = boolAnd(ret_1, ret_2);
        ret_4 = boolAnd(ret_0, ret_3);
        txt = fun_560(txt, ret_4, a_fmiVersion, a_what, a_fmiModelVariable, a_dependent, a_variabilityCausality, a_type);
      then txt;

    case ( txt,
           _,
           a_fmiVersion,
           a_what,
           a_fmiModelVariable,
           _,
           _,
           _ )
      equation
        ret_5 = stringEq(a_fmiVersion, "1.0");
        txt = fun_568(txt, ret_5, a_what, a_fmiModelVariable, a_fmiVersion);
      then txt;
  end match;
end fun_569;

protected function fun_570
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_name)
    local
      Tpl.Text txt;
      String a_name;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_name )
      equation
        txt = Tpl.writeStr(txt, a_name);
      then txt;
  end match;
end fun_570;

protected function fun_571
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Real in_a_valueReference;
  input String in_a_name;
  input Integer in_a_what;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_valueReference, in_a_name, in_a_what)
    local
      Tpl.Text txt;
      Real a_valueReference;
      String a_name;
      Integer a_what;
      Boolean ret_0;

    case ( txt,
           false,
           _,
           a_name,
           a_what )
      equation
        ret_0 = intEq(a_what, 2);
        txt = fun_570(txt, ret_0, a_name);
      then txt;

    case ( txt,
           _,
           a_valueReference,
           _,
           _ )
      equation
        txt = Tpl.writeStr(txt, realString(a_valueReference));
      then txt;
  end match;
end fun_571;

protected function fun_572
  input Tpl.Text in_txt;
  input FMI.ModelVariables in_a_fmiModelVariable;
  input Integer in_a_what;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fmiModelVariable, in_a_what)
    local
      Tpl.Text txt;
      Integer a_what;
      Real i_valueReference;
      String i_name;
      Boolean ret_0;

    case ( txt,
           FMI.INTEGERVARIABLE(causality = "parameter", hasStartValue = true, name = i_name, valueReference = i_valueReference),
           a_what )
      equation
        ret_0 = intEq(a_what, 1);
        txt = fun_571(txt, ret_0, i_valueReference, i_name, a_what);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_572;

protected function fun_573
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_what;
  input FMI.ModelVariables in_a_fmiModelVariable;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_what, in_a_fmiModelVariable)
    local
      Tpl.Text txt;
      Integer a_what;
      FMI.ModelVariables a_fmiModelVariable;

    case ( txt,
           false,
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_what,
           a_fmiModelVariable )
      equation
        txt = fun_572(txt, a_fmiModelVariable, a_what);
      then txt;
  end match;
end fun_573;

protected function fun_574
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_name)
    local
      Tpl.Text txt;
      String a_name;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_name )
      equation
        txt = Tpl.writeStr(txt, a_name);
      then txt;
  end match;
end fun_574;

protected function fun_575
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Real in_a_valueReference;
  input String in_a_name;
  input Integer in_a_what;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_valueReference, in_a_name, in_a_what)
    local
      Tpl.Text txt;
      Real a_valueReference;
      String a_name;
      Integer a_what;
      Boolean ret_0;

    case ( txt,
           false,
           _,
           a_name,
           a_what )
      equation
        ret_0 = intEq(a_what, 2);
        txt = fun_574(txt, ret_0, a_name);
      then txt;

    case ( txt,
           _,
           a_valueReference,
           _,
           _ )
      equation
        txt = Tpl.writeStr(txt, realString(a_valueReference));
      then txt;
  end match;
end fun_575;

protected function fun_576
  input Tpl.Text in_txt;
  input FMI.ModelVariables in_a_fmiModelVariable;
  input Integer in_a_what;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fmiModelVariable, in_a_what)
    local
      Tpl.Text txt;
      Integer a_what;
      Real i_valueReference;
      String i_name;
      Boolean ret_0;

    case ( txt,
           FMI.INTEGERVARIABLE(variability = "parameter", hasStartValue = true, name = i_name, valueReference = i_valueReference),
           a_what )
      equation
        ret_0 = intEq(a_what, 1);
        txt = fun_575(txt, ret_0, i_valueReference, i_name, a_what);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_576;

protected function fun_577
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_what;
  input FMI.ModelVariables in_a_fmiModelVariable;
  input String in_a_fmiVersion;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_what, in_a_fmiModelVariable, in_a_fmiVersion)
    local
      Tpl.Text txt;
      Integer a_what;
      FMI.ModelVariables a_fmiModelVariable;
      String a_fmiVersion;
      Boolean ret_0;

    case ( txt,
           false,
           a_what,
           a_fmiModelVariable,
           a_fmiVersion )
      equation
        ret_0 = stringEq(a_fmiVersion, "2.0");
        txt = fun_573(txt, ret_0, a_what, a_fmiModelVariable);
      then txt;

    case ( txt,
           _,
           a_what,
           a_fmiModelVariable,
           _ )
      equation
        txt = fun_576(txt, a_fmiModelVariable, a_what);
      then txt;
  end match;
end fun_577;

protected function fun_578
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_fmiVersion;
  input Integer in_a_what;
  input FMI.ModelVariables in_a_fmiModelVariable;
  input Boolean in_a_dependent;
  input String in_a_variabilityCausality;
  input String in_a_type;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_fmiVersion, in_a_what, in_a_fmiModelVariable, in_a_dependent, in_a_variabilityCausality, in_a_type)
    local
      Tpl.Text txt;
      String a_fmiVersion;
      Integer a_what;
      FMI.ModelVariables a_fmiModelVariable;
      Boolean a_dependent;
      String a_variabilityCausality;
      String a_type;
      Boolean ret_5;
      Boolean ret_4;
      Boolean ret_3;
      Boolean ret_2;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           false,
           a_fmiVersion,
           a_what,
           a_fmiModelVariable,
           a_dependent,
           a_variabilityCausality,
           a_type )
      equation
        ret_0 = stringEq(a_type, "boolean");
        ret_1 = stringEq(a_variabilityCausality, "parameter");
        ret_2 = boolNot(a_dependent);
        ret_3 = boolAnd(ret_1, ret_2);
        ret_4 = boolAnd(ret_0, ret_3);
        txt = fun_569(txt, ret_4, a_fmiVersion, a_what, a_fmiModelVariable, a_dependent, a_variabilityCausality, a_type);
      then txt;

    case ( txt,
           _,
           a_fmiVersion,
           a_what,
           a_fmiModelVariable,
           _,
           _,
           _ )
      equation
        ret_5 = stringEq(a_fmiVersion, "1.0");
        txt = fun_577(txt, ret_5, a_what, a_fmiModelVariable, a_fmiVersion);
      then txt;
  end match;
end fun_578;

protected function fun_579
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_name)
    local
      Tpl.Text txt;
      String a_name;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_name )
      equation
        txt = Tpl.writeStr(txt, a_name);
      then txt;
  end match;
end fun_579;

protected function fun_580
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Real in_a_valueReference;
  input String in_a_name;
  input Integer in_a_what;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_valueReference, in_a_name, in_a_what)
    local
      Tpl.Text txt;
      Real a_valueReference;
      String a_name;
      Integer a_what;
      Boolean ret_0;

    case ( txt,
           false,
           _,
           a_name,
           a_what )
      equation
        ret_0 = intEq(a_what, 2);
        txt = fun_579(txt, ret_0, a_name);
      then txt;

    case ( txt,
           _,
           a_valueReference,
           _,
           _ )
      equation
        txt = Tpl.writeStr(txt, realString(a_valueReference));
      then txt;
  end match;
end fun_580;

protected function fun_581
  input Tpl.Text in_txt;
  input FMI.ModelVariables in_a_fmiModelVariable;
  input Integer in_a_what;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fmiModelVariable, in_a_what)
    local
      Tpl.Text txt;
      Integer a_what;
      Real i_valueReference;
      String i_name;
      Boolean ret_0;

    case ( txt,
           FMI.REALVARIABLE(causality = "parameter", hasStartValue = true, name = i_name, valueReference = i_valueReference),
           a_what )
      equation
        ret_0 = intEq(a_what, 1);
        txt = fun_580(txt, ret_0, i_valueReference, i_name, a_what);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_581;

protected function fun_582
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_what;
  input FMI.ModelVariables in_a_fmiModelVariable;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_what, in_a_fmiModelVariable)
    local
      Tpl.Text txt;
      Integer a_what;
      FMI.ModelVariables a_fmiModelVariable;

    case ( txt,
           false,
           _,
           _ )
      then txt;

    case ( txt,
           _,
           a_what,
           a_fmiModelVariable )
      equation
        txt = fun_581(txt, a_fmiModelVariable, a_what);
      then txt;
  end match;
end fun_582;

protected function fun_583
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input String in_a_name;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_name)
    local
      Tpl.Text txt;
      String a_name;

    case ( txt,
           false,
           _ )
      then txt;

    case ( txt,
           _,
           a_name )
      equation
        txt = Tpl.writeStr(txt, a_name);
      then txt;
  end match;
end fun_583;

protected function fun_584
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Real in_a_valueReference;
  input String in_a_name;
  input Integer in_a_what;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_valueReference, in_a_name, in_a_what)
    local
      Tpl.Text txt;
      Real a_valueReference;
      String a_name;
      Integer a_what;
      Boolean ret_0;

    case ( txt,
           false,
           _,
           a_name,
           a_what )
      equation
        ret_0 = intEq(a_what, 2);
        txt = fun_583(txt, ret_0, a_name);
      then txt;

    case ( txt,
           _,
           a_valueReference,
           _,
           _ )
      equation
        txt = Tpl.writeStr(txt, realString(a_valueReference));
      then txt;
  end match;
end fun_584;

protected function fun_585
  input Tpl.Text in_txt;
  input FMI.ModelVariables in_a_fmiModelVariable;
  input Integer in_a_what;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fmiModelVariable, in_a_what)
    local
      Tpl.Text txt;
      Integer a_what;
      Real i_valueReference;
      String i_name;
      Boolean ret_0;

    case ( txt,
           FMI.REALVARIABLE(variability = "parameter", hasStartValue = true, name = i_name, valueReference = i_valueReference),
           a_what )
      equation
        ret_0 = intEq(a_what, 1);
        txt = fun_584(txt, ret_0, i_valueReference, i_name, a_what);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_585;

protected function fun_586
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input Integer in_a_what;
  input FMI.ModelVariables in_a_fmiModelVariable;
  input String in_a_fmiVersion;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_what, in_a_fmiModelVariable, in_a_fmiVersion)
    local
      Tpl.Text txt;
      Integer a_what;
      FMI.ModelVariables a_fmiModelVariable;
      String a_fmiVersion;
      Boolean ret_0;

    case ( txt,
           false,
           a_what,
           a_fmiModelVariable,
           a_fmiVersion )
      equation
        ret_0 = stringEq(a_fmiVersion, "2.0");
        txt = fun_582(txt, ret_0, a_what, a_fmiModelVariable);
      then txt;

    case ( txt,
           _,
           a_what,
           a_fmiModelVariable,
           _ )
      equation
        txt = fun_585(txt, a_fmiModelVariable, a_what);
      then txt;
  end match;
end fun_586;

protected function fun_587
  input Tpl.Text in_txt;
  input Boolean in_mArg;
  input FMI.ModelVariables in_a_fmiModelVariable;
  input String in_a_type;
  input String in_a_variabilityCausality;
  input Boolean in_a_dependent;
  input Integer in_a_what;
  input String in_a_fmiVersion;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_mArg, in_a_fmiModelVariable, in_a_type, in_a_variabilityCausality, in_a_dependent, in_a_what, in_a_fmiVersion)
    local
      Tpl.Text txt;
      FMI.ModelVariables a_fmiModelVariable;
      String a_type;
      String a_variabilityCausality;
      Boolean a_dependent;
      Integer a_what;
      String a_fmiVersion;
      Boolean ret_5;
      Boolean ret_4;
      Boolean ret_3;
      Boolean ret_2;
      Boolean ret_1;
      Boolean ret_0;

    case ( txt,
           false,
           a_fmiModelVariable,
           a_type,
           a_variabilityCausality,
           a_dependent,
           a_what,
           a_fmiVersion )
      equation
        ret_0 = stringEq(a_type, "integer");
        ret_1 = stringEq(a_variabilityCausality, "parameter");
        ret_2 = boolNot(a_dependent);
        ret_3 = boolAnd(ret_1, ret_2);
        ret_4 = boolAnd(ret_0, ret_3);
        txt = fun_578(txt, ret_4, a_fmiVersion, a_what, a_fmiModelVariable, a_dependent, a_variabilityCausality, a_type);
      then txt;

    case ( txt,
           _,
           a_fmiModelVariable,
           _,
           _,
           _,
           a_what,
           a_fmiVersion )
      equation
        ret_5 = stringEq(a_fmiVersion, "1.0");
        txt = fun_586(txt, ret_5, a_what, a_fmiModelVariable, a_fmiVersion);
      then txt;
  end match;
end fun_587;

public function dumpVariable
  input Tpl.Text txt;
  input FMI.ModelVariables a_fmiModelVariable;
  input String a_type;
  input String a_variabilityCausality;
  input Boolean a_dependent;
  input Integer a_what;
  input String a_fmiVersion;

  output Tpl.Text out_txt;
protected
  Boolean ret_4;
  Boolean ret_3;
  Boolean ret_2;
  Boolean ret_1;
  Boolean ret_0;
algorithm
  ret_0 := stringEq(a_type, "real");
  ret_1 := stringEq(a_variabilityCausality, "parameter");
  ret_2 := boolNot(a_dependent);
  ret_3 := boolAnd(ret_1, ret_2);
  ret_4 := boolAnd(ret_0, ret_3);
  out_txt := fun_587(txt, ret_4, a_fmiModelVariable, a_type, a_variabilityCausality, a_dependent, a_what, a_fmiVersion);
end dumpVariable;

protected function lm_589
  input Tpl.Text in_txt;
  input list<FMI.ModelVariables> in_items;
  input String in_a_fmiType;
  input String in_a_fmiGetFunction;
  input list<FMI.TypeDefinitions> in_a_fmiTypeDefinitionsList;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items, in_a_fmiType, in_a_fmiGetFunction, in_a_fmiTypeDefinitionsList)
    local
      Tpl.Text txt;
      list<FMI.ModelVariables> rest;
      String a_fmiType;
      String a_fmiGetFunction;
      list<FMI.TypeDefinitions> a_fmiTypeDefinitionsList;
      FMI.ModelVariables i_fmiModelVariable;

    case ( txt,
           {},
           _,
           _,
           _ )
      then txt;

    case ( txt,
           i_fmiModelVariable :: rest,
           a_fmiType,
           a_fmiGetFunction,
           a_fmiTypeDefinitionsList )
      equation
        txt = dumpOutputGetEnumerationVariable(txt, i_fmiModelVariable, a_fmiTypeDefinitionsList, a_fmiGetFunction, a_fmiType);
        txt = lm_589(txt, rest, a_fmiType, a_fmiGetFunction, a_fmiTypeDefinitionsList);
      then txt;
  end match;
end lm_589;

public function dumpOutputGetEnumerationVariables
  input Tpl.Text txt;
  input list<FMI.ModelVariables> a_fmiModelVariablesList;
  input list<FMI.TypeDefinitions> a_fmiTypeDefinitionsList;
  input String a_fmiGetFunction;
  input String a_fmiType;

  output Tpl.Text out_txt;
algorithm
  out_txt := lm_589(txt, a_fmiModelVariablesList, a_fmiType, a_fmiGetFunction, a_fmiTypeDefinitionsList);
end dumpOutputGetEnumerationVariables;

public function dumpOutputGetEnumerationVariable
  input Tpl.Text in_txt;
  input FMI.ModelVariables in_a_fmiModelVariable;
  input list<FMI.TypeDefinitions> in_a_fmiTypeDefinitionsList;
  input String in_a_fmiGetFunction;
  input String in_a_fmiType;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_fmiModelVariable, in_a_fmiTypeDefinitionsList, in_a_fmiGetFunction, in_a_fmiType)
    local
      Tpl.Text txt;
      list<FMI.TypeDefinitions> a_fmiTypeDefinitionsList;
      String a_fmiGetFunction;
      String a_fmiType;
      Real i_valueReference;
      String i_baseType;
      String i_name;
      String ret_1;
      String ret_0;

    case ( txt,
           FMI.ENUMERATIONVARIABLE(variability = "", causality = "", name = i_name, baseType = i_baseType, valueReference = i_valueReference),
           a_fmiTypeDefinitionsList,
           a_fmiGetFunction,
           a_fmiType )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("{"));
        txt = Tpl.writeStr(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("} = map_"));
        ret_0 = FMI.getEnumerationTypeFromTypes(a_fmiTypeDefinitionsList, i_baseType);
        txt = Tpl.writeStr(txt, ret_0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_from_integers("));
        txt = Tpl.writeStr(txt, a_fmiGetFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeStr(txt, a_fmiType);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", {"));
        txt = Tpl.writeStr(txt, realString(i_valueReference));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}, flowStatesInputs));"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           FMI.ENUMERATIONVARIABLE(variability = "", causality = "output", name = i_name, baseType = i_baseType, valueReference = i_valueReference),
           a_fmiTypeDefinitionsList,
           a_fmiGetFunction,
           a_fmiType )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("{"));
        txt = Tpl.writeStr(txt, i_name);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("} = map_"));
        ret_1 = FMI.getEnumerationTypeFromTypes(a_fmiTypeDefinitionsList, i_baseType);
        txt = Tpl.writeStr(txt, ret_1);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("_from_integers("));
        txt = Tpl.writeStr(txt, a_fmiGetFunction);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("("));
        txt = Tpl.writeStr(txt, a_fmiType);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(", {"));
        txt = Tpl.writeStr(txt, realString(i_valueReference));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}, flowStatesInputs));"));
        txt = Tpl.writeTok(txt, Tpl.ST_NEW_LINE());
      then txt;

    case ( txt,
           _,
           _,
           _,
           _ )
      then txt;
  end match;
end dumpOutputGetEnumerationVariable;

protected function lm_592
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = ScalarVariableFMU(txt, i_var, "realVarsData");
        txt = Tpl.nextIter(txt);
        txt = lm_592(txt, rest);
      then txt;
  end match;
end lm_592;

protected function lm_593
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = ScalarVariableFMU(txt, i_var, "realVarsData");
        txt = Tpl.nextIter(txt);
        txt = lm_593(txt, rest);
      then txt;
  end match;
end lm_593;

protected function lm_594
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = ScalarVariableFMU(txt, i_var, "realVarsData");
        txt = Tpl.nextIter(txt);
        txt = lm_594(txt, rest);
      then txt;
  end match;
end lm_594;

protected function lm_595
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = ScalarVariableFMU(txt, i_var, "realVarsData");
        txt = Tpl.nextIter(txt);
        txt = lm_595(txt, rest);
      then txt;
  end match;
end lm_595;

protected function lm_596
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = ScalarVariableFMU(txt, i_var, "realVarsData");
        txt = Tpl.nextIter(txt);
        txt = lm_596(txt, rest);
      then txt;
  end match;
end lm_596;

protected function lm_597
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = ScalarVariableFMU(txt, i_var, "realVarsData");
        txt = Tpl.nextIter(txt);
        txt = lm_597(txt, rest);
      then txt;
  end match;
end lm_597;

protected function lm_598
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = ScalarVariableFMU(txt, i_var, "realParameterData");
        txt = Tpl.nextIter(txt);
        txt = lm_598(txt, rest);
      then txt;
  end match;
end lm_598;

protected function lm_599
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = ScalarVariableFMU(txt, i_var, "integerVarsData");
        txt = Tpl.nextIter(txt);
        txt = lm_599(txt, rest);
      then txt;
  end match;
end lm_599;

protected function lm_600
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = ScalarVariableFMU(txt, i_var, "integerParameterData");
        txt = Tpl.nextIter(txt);
        txt = lm_600(txt, rest);
      then txt;
  end match;
end lm_600;

protected function lm_601
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = ScalarVariableFMU(txt, i_var, "booleanVarsData");
        txt = Tpl.nextIter(txt);
        txt = lm_601(txt, rest);
      then txt;
  end match;
end lm_601;

protected function lm_602
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = ScalarVariableFMU(txt, i_var, "booleanParameterData");
        txt = Tpl.nextIter(txt);
        txt = lm_602(txt, rest);
      then txt;
  end match;
end lm_602;

protected function lm_603
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = ScalarVariableFMU(txt, i_var, "stringVarsData");
        txt = Tpl.nextIter(txt);
        txt = lm_603(txt, rest);
      then txt;
  end match;
end lm_603;

protected function lm_604
  input Tpl.Text in_txt;
  input list<SimCodeVar.SimVar> in_items;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_items)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> rest;
      SimCodeVar.SimVar i_var;

    case ( txt,
           {} )
      then txt;

    case ( txt,
           i_var :: rest )
      equation
        txt = ScalarVariableFMU(txt, i_var, "stringParameterData");
        txt = Tpl.nextIter(txt);
        txt = lm_604(txt, rest);
      then txt;
  end match;
end lm_604;

protected function fun_605
  input Tpl.Text in_txt;
  input SimCode.SimCode in_a_simCode;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simCode)
    local
      Tpl.Text txt;
      list<SimCodeVar.SimVar> i_vars_stringParamVars;
      list<SimCodeVar.SimVar> i_vars_stringAlgVars;
      list<SimCodeVar.SimVar> i_vars_boolParamVars;
      list<SimCodeVar.SimVar> i_vars_boolAlgVars;
      list<SimCodeVar.SimVar> i_vars_intParamVars;
      list<SimCodeVar.SimVar> i_vars_intAlgVars;
      list<SimCodeVar.SimVar> i_vars_paramVars;
      list<SimCodeVar.SimVar> i_vars_realOptimizeFinalConstraintsVars;
      list<SimCodeVar.SimVar> i_vars_realOptimizeConstraintsVars;
      list<SimCodeVar.SimVar> i_vars_discreteAlgVars;
      list<SimCodeVar.SimVar> i_vars_algVars;
      list<SimCodeVar.SimVar> i_vars_derivativeVars;
      list<SimCodeVar.SimVar> i_vars_stateVars;
      String i_makefileParams_omhome;
      String i_s_variableFilter;
      String i_s_outputFormat;
      String i_s_method;
      Real i_s_tolerance;
      Real i_s_stepSize;
      Real i_s_stopTime;
      Real i_s_startTime;
      SimCode.SimCode i_simCode;
      Tpl.Text txt_0;

    case ( txt,
           (i_simCode as SimCode.SIMCODE(modelInfo = SimCode.MODELINFO(functions = _, varInfo = SimCode.VARINFO(numZeroCrossings = _), vars = SimCodeVar.SIMVARS(stateVars = i_vars_stateVars, derivativeVars = i_vars_derivativeVars, algVars = i_vars_algVars, discreteAlgVars = i_vars_discreteAlgVars, realOptimizeConstraintsVars = i_vars_realOptimizeConstraintsVars, realOptimizeFinalConstraintsVars = i_vars_realOptimizeFinalConstraintsVars, paramVars = i_vars_paramVars, intAlgVars = i_vars_intAlgVars, intParamVars = i_vars_intParamVars, boolAlgVars = i_vars_boolAlgVars, boolParamVars = i_vars_boolParamVars, stringAlgVars = i_vars_stringAlgVars, stringParamVars = i_vars_stringParamVars)), simulationSettingsOpt = SOME(SimCode.SIMULATION_SETTINGS(startTime = i_s_startTime, stopTime = i_s_stopTime, stepSize = i_s_stepSize, tolerance = i_s_tolerance, method = i_s_method, outputFormat = i_s_outputFormat, variableFilter = i_s_variableFilter)), makefileParams = SimCodeFunction.MAKEFILE_PARAMS(omhome = i_makefileParams_omhome))) )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "#include \"simulation_data.h\"\n",
                                    "\n",
                                    "OMC_DISABLE_OPT\n",
                                    "void "
                                }, false));
        txt_0 = CodegenUtilSimulation.modelNamePrefix(Tpl.emptyTxt, i_simCode);
        txt = CodegenUtil.symbolName(txt, Tpl.textString(txt_0), "read_input_fmu");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "(MODEL_DATA* modelData, SIMULATION_INFO* simulationInfo)\n",
                                    "{\n"
                                }, true));
        txt = Tpl.pushBlock(txt, Tpl.BT_INDENT(2));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("simulationInfo->startTime = "));
        txt = Tpl.writeStr(txt, realString(i_s_startTime));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "simulationInfo->stopTime = "
                                }, false));
        txt = Tpl.writeStr(txt, realString(i_s_stopTime));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "simulationInfo->stepSize = "
                                }, false));
        txt = Tpl.writeStr(txt, realString(i_s_stepSize));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "simulationInfo->tolerance = "
                                }, false));
        txt = Tpl.writeStr(txt, realString(i_s_tolerance));
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    ";\n",
                                    "simulationInfo->solverMethod = \""
                                }, false));
        txt = Tpl.writeStr(txt, i_s_method);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\";\n",
                                    "simulationInfo->outputFormat = \""
                                }, false));
        txt = Tpl.writeStr(txt, i_s_outputFormat);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\";\n",
                                    "simulationInfo->variableFilter = \""
                                }, false));
        txt = Tpl.writeStr(txt, i_s_variableFilter);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING_LIST({
                                    "\";\n",
                                    "simulationInfo->OPENMODELICAHOME = \""
                                }, false));
        txt = Tpl.writeStr(txt, i_makefileParams_omhome);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("\";\n"));
        System.tmpTickReset(1000);
        txt = Tpl.softNewLine(txt);
        System.tmpTickResetIndex(0, 2);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_592(txt, i_vars_stateVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_593(txt, i_vars_derivativeVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_594(txt, i_vars_algVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_595(txt, i_vars_discreteAlgVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_596(txt, i_vars_realOptimizeConstraintsVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_597(txt, i_vars_realOptimizeFinalConstraintsVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        System.tmpTickResetIndex(0, 2);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_598(txt, i_vars_paramVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        System.tmpTickResetIndex(0, 2);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_599(txt, i_vars_intAlgVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        System.tmpTickResetIndex(0, 2);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_600(txt, i_vars_intParamVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        System.tmpTickResetIndex(0, 2);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_601(txt, i_vars_boolAlgVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        System.tmpTickResetIndex(0, 2);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_602(txt, i_vars_boolParamVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        System.tmpTickResetIndex(0, 2);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_603(txt, i_vars_stringAlgVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        System.tmpTickResetIndex(0, 2);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.pushIter(txt, Tpl.ITER_OPTIONS(0, SOME(Tpl.ST_STRING("")), SOME(Tpl.ST_NEW_LINE()), 0, 0, Tpl.ST_NEW_LINE(), 0, Tpl.ST_NEW_LINE()));
        txt = lm_604(txt, i_vars_stringParamVars);
        txt = Tpl.popIter(txt);
        txt = Tpl.softNewLine(txt);
        System.tmpTickResetIndex(0, 2);
        txt = Tpl.softNewLine(txt);
        txt = Tpl.popBlock(txt);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("}"));
      then txt;

    case ( txt,
           _ )
      then txt;
  end match;
end fun_605;

public function simulationInitFunction
  input Tpl.Text txt;
  input SimCode.SimCode a_simCode;
  input String a_guid;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_605(txt, a_simCode);
end simulationInitFunction;

protected function fun_607
  input Tpl.Text in_txt;
  input Boolean in_a_isReadOnly;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_isReadOnly)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("0"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("1"));
      then txt;
  end match;
end fun_607;

protected function fun_608
  input Tpl.Text in_txt;
  input SourceInfo in_a_info;
  input String in_a_str;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_info, in_a_str)
    local
      Tpl.Text txt;
      String a_str;
      Boolean i_isReadOnly;
      Integer i_columnNumberEnd;
      Integer i_lineNumberEnd;
      Integer i_columnNumberStart;
      Integer i_lineNumberStart;
      String i_fileName;
      String ret_0;

    case ( txt,
           SOURCEINFO(fileName = i_fileName, lineNumberStart = i_lineNumberStart, columnNumberStart = i_columnNumberStart, lineNumberEnd = i_lineNumberEnd, columnNumberEnd = i_columnNumberEnd, isReadOnly = i_isReadOnly),
           a_str )
      equation
        txt = Tpl.writeStr(txt, a_str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".filename = \""));
        ret_0 = Util.escapeModelicaStringToCString(i_fileName);
        txt = Tpl.writeStr(txt, ret_0);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("\";\n"));
        txt = Tpl.writeStr(txt, a_str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".lineStart = "));
        txt = Tpl.writeStr(txt, intString(i_lineNumberStart));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.writeStr(txt, a_str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".colStart = "));
        txt = Tpl.writeStr(txt, intString(i_columnNumberStart));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.writeStr(txt, a_str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".lineEnd = "));
        txt = Tpl.writeStr(txt, intString(i_lineNumberEnd));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.writeStr(txt, a_str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".colEnd = "));
        txt = Tpl.writeStr(txt, intString(i_columnNumberEnd));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.writeStr(txt, a_str);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".readonly = "));
        txt = fun_607(txt, i_isReadOnly);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end fun_608;

public function getInfoArgsFMU
  input Tpl.Text txt;
  input String a_str;
  input SourceInfo a_info;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_608(txt, a_info, a_str);
end getInfoArgsFMU;

protected function fun_610
  input Tpl.Text in_txt;
  input String in_a_comment;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_comment)
    local
      Tpl.Text txt;
      String i_comment;
      String ret_0;

    case ( txt,
           "" )
      then txt;

    case ( txt,
           i_comment )
      equation
        ret_0 = Util.escapeModelicaStringToCString(i_comment);
        txt = Tpl.writeStr(txt, ret_0);
      then txt;
  end match;
end fun_610;

public function ScalarVariableFMU
  input Tpl.Text in_txt;
  input SimCodeVar.SimVar in_a_simVar;
  input String in_a_classType;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_simVar, in_a_classType)
    local
      Tpl.Text txt;
      String a_classType;
      DAE.Type i_type__;
      Boolean i_isFixed;
      Option<DAE.Exp> i_nominalValue;
      Option<DAE.Exp> i_initialValue;
      Option<DAE.Exp> i_maxValue;
      Option<DAE.Exp> i_minValue;
      String i_displayUnit;
      String i_unit;
      SourceInfo i_info;
      DAE.ComponentRef i_name;
      String i_comment;
      Tpl.Text txt_9;
      String ret_8;
      Tpl.Text txt_7;
      Tpl.Text l_attrstr;
      Tpl.Text l_infostr;
      Tpl.Text l_description;
      Integer ret_3;
      Tpl.Text l_ci;
      Integer ret_1;
      Tpl.Text l_valueReference;

    case ( txt,
           SimCodeVar.SIMVAR(source = DAE.SOURCE(info = i_info), comment = i_comment, name = i_name, unit = i_unit, displayUnit = i_displayUnit, minValue = i_minValue, maxValue = i_maxValue, initialValue = i_initialValue, nominalValue = i_nominalValue, isFixed = i_isFixed, type_ = i_type__),
           a_classType )
      equation
        ret_1 = System.tmpTick();
        l_valueReference = Tpl.writeStr(Tpl.emptyTxt, intString(ret_1));
        ret_3 = System.tmpTickIndex(2);
        l_ci = Tpl.writeStr(Tpl.emptyTxt, intString(ret_3));
        l_description = fun_610(Tpl.emptyTxt, i_comment);
        l_infostr = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("modelData->"));
        l_infostr = Tpl.writeStr(l_infostr, a_classType);
        l_infostr = Tpl.writeTok(l_infostr, Tpl.ST_STRING("["));
        l_infostr = Tpl.writeText(l_infostr, l_ci);
        l_infostr = Tpl.writeTok(l_infostr, Tpl.ST_STRING("].info"));
        l_attrstr = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("modelData->"));
        l_attrstr = Tpl.writeStr(l_attrstr, a_classType);
        l_attrstr = Tpl.writeTok(l_attrstr, Tpl.ST_STRING("["));
        l_attrstr = Tpl.writeText(l_attrstr, l_ci);
        l_attrstr = Tpl.writeTok(l_attrstr, Tpl.ST_STRING("].attribute"));
        txt = Tpl.writeText(txt, l_infostr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".id = "));
        txt = Tpl.writeText(txt, l_valueReference);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.writeText(txt, l_infostr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".name = \""));
        txt_7 = CodegenUtil.crefStrNoUnderscore(Tpl.emptyTxt, i_name);
        ret_8 = Util.escapeModelicaStringToCString(Tpl.textString(txt_7));
        txt = Tpl.writeStr(txt, ret_8);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("\";\n"));
        txt = Tpl.writeText(txt, l_infostr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".comment = \""));
        txt = Tpl.writeText(txt, l_description);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("\";\n"));
        txt_9 = Tpl.writeText(Tpl.emptyTxt, l_infostr);
        txt_9 = Tpl.writeTok(txt_9, Tpl.ST_STRING(".info"));
        txt = getInfoArgsFMU(txt, Tpl.textString(txt_9), i_info);
        txt = Tpl.softNewLine(txt);
        txt = ScalarVariableTypeFMU(txt, Tpl.textString(l_attrstr), i_unit, i_displayUnit, i_minValue, i_maxValue, i_initialValue, i_nominalValue, i_isFixed, i_type__);
      then txt;

    case ( txt,
           _,
           _ )
      then txt;
  end match;
end ScalarVariableFMU;

protected function fun_612
  input Tpl.Text in_txt;
  input Boolean in_a_bool;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_bool)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("0"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("1"));
      then txt;
  end match;
end fun_612;

protected function fun_613
  input Tpl.Text in_txt;
  input DAE.Exp in_a_e;
  input String in_a_default;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_e, in_a_default)
    local
      Tpl.Text txt;
      String a_default;
      Integer i_index;
      Boolean i_bool;
      String i_string;
      Real i_real;
      Integer i_integer;
      String ret_0;

    case ( txt,
           DAE.ICONST(integer = i_integer),
           _ )
      equation
        txt = Tpl.writeStr(txt, intString(i_integer));
      then txt;

    case ( txt,
           DAE.RCONST(real = i_real),
           _ )
      equation
        txt = Tpl.writeStr(txt, realString(i_real));
      then txt;

    case ( txt,
           DAE.SCONST(string = i_string),
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("mmc_mk_scon(\""));
        ret_0 = Util.escapeModelicaStringToCString(i_string);
        txt = Tpl.writeStr(txt, ret_0);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("\")"));
      then txt;

    case ( txt,
           DAE.BCONST(bool = i_bool),
           _ )
      equation
        txt = fun_612(txt, i_bool);
      then txt;

    case ( txt,
           DAE.ENUM_LITERAL(index = i_index),
           _ )
      equation
        txt = Tpl.writeStr(txt, intString(i_index));
      then txt;

    case ( txt,
           _,
           a_default )
      equation
        txt = Tpl.writeStr(txt, a_default);
      then txt;
  end match;
end fun_613;

public function optInitValFMU
  input Tpl.Text in_txt;
  input Option<DAE.Exp> in_a_exp;
  input String in_a_default;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_exp, in_a_default)
    local
      Tpl.Text txt;
      String a_default;
      DAE.Exp i_e;

    case ( txt,
           SOME(i_e),
           a_default )
      equation
        txt = fun_613(txt, i_e, a_default);
      then txt;

    case ( txt,
           _,
           a_default )
      equation
        txt = Tpl.writeStr(txt, a_default);
      then txt;
  end match;
end optInitValFMU;

protected function fun_615
  input Tpl.Text in_txt;
  input Boolean in_a_isFixed;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_isFixed)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("0"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("1"));
      then txt;
  end match;
end fun_615;

protected function fun_616
  input Tpl.Text in_txt;
  input Boolean in_a_isFixed;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_isFixed)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("0"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("1"));
      then txt;
  end match;
end fun_616;

protected function fun_617
  input Tpl.Text in_txt;
  input Option<DAE.Exp> in_a_nominalValue;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_nominalValue)
    local
      Tpl.Text txt;

    case ( txt,
           NONE() )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("0"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("1"));
      then txt;
  end match;
end fun_617;

protected function fun_618
  input Tpl.Text in_txt;
  input Boolean in_a_isFixed;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_isFixed)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("0"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("1"));
      then txt;
  end match;
end fun_618;

protected function fun_619
  input Tpl.Text in_txt;
  input Boolean in_a_isFixed;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_isFixed)
    local
      Tpl.Text txt;

    case ( txt,
           false )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("0"));
      then txt;

    case ( txt,
           _ )
      equation
        txt = Tpl.writeTok(txt, Tpl.ST_STRING("1"));
      then txt;
  end match;
end fun_619;

protected function fun_620
  input Tpl.Text in_txt;
  input DAE.Type in_a_type__;
  input String in_a_attrstr;
  input String in_a_unit;
  input String in_a_displayUnit;
  input Option<DAE.Exp> in_a_minValue;
  input Option<DAE.Exp> in_a_maxValue;
  input Option<DAE.Exp> in_a_startValue;
  input Option<DAE.Exp> in_a_nominalValue;
  input Boolean in_a_isFixed;

  output Tpl.Text out_txt;
algorithm
  out_txt :=
  match(in_txt, in_a_type__, in_a_attrstr, in_a_unit, in_a_displayUnit, in_a_minValue, in_a_maxValue, in_a_startValue, in_a_nominalValue, in_a_isFixed)
    local
      Tpl.Text txt;
      String a_attrstr;
      String a_unit;
      String a_displayUnit;
      Option<DAE.Exp> a_minValue;
      Option<DAE.Exp> a_maxValue;
      Option<DAE.Exp> a_startValue;
      Option<DAE.Exp> a_nominalValue;
      Boolean a_isFixed;
      DAE.Type i_type__;
      list<String> i_names;
      Tpl.Text txt_3;
      String ret_3;
      Integer ret_2;
      String ret_1;
      String ret_0;

    case ( txt,
           DAE.T_INTEGER(varLst = _),
           a_attrstr,
           _,
           _,
           a_minValue,
           a_maxValue,
           a_startValue,
           _,
           a_isFixed )
      equation
        txt = Tpl.writeStr(txt, a_attrstr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".min = "));
        txt = optInitValFMU(txt, a_minValue, "-LONG_MAX");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.writeStr(txt, a_attrstr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".max = "));
        txt = optInitValFMU(txt, a_maxValue, "LONG_MAX");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.writeStr(txt, a_attrstr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".fixed = "));
        txt = fun_615(txt, a_isFixed);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.writeStr(txt, a_attrstr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".start = "));
        txt = optInitValFMU(txt, a_startValue, "0");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           DAE.T_REAL(varLst = _),
           a_attrstr,
           a_unit,
           a_displayUnit,
           a_minValue,
           a_maxValue,
           a_startValue,
           a_nominalValue,
           a_isFixed )
      equation
        txt = Tpl.writeStr(txt, a_attrstr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".unit = \""));
        ret_0 = Util.escapeModelicaStringToCString(a_unit);
        txt = Tpl.writeStr(txt, ret_0);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("\";\n"));
        txt = Tpl.writeStr(txt, a_attrstr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".displayUnit = \""));
        ret_1 = Util.escapeModelicaStringToCString(a_displayUnit);
        txt = Tpl.writeStr(txt, ret_1);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE("\";\n"));
        txt = Tpl.writeStr(txt, a_attrstr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".min = "));
        txt = optInitValFMU(txt, a_minValue, "-DBL_MAX");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.writeStr(txt, a_attrstr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".max = "));
        txt = optInitValFMU(txt, a_maxValue, "DBL_MAX");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.writeStr(txt, a_attrstr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".fixed = "));
        txt = fun_616(txt, a_isFixed);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.writeStr(txt, a_attrstr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".useNominal = "));
        txt = fun_617(txt, a_nominalValue);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.writeStr(txt, a_attrstr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".nominal = "));
        txt = optInitValFMU(txt, a_nominalValue, "1.0");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.writeStr(txt, a_attrstr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".start = "));
        txt = optInitValFMU(txt, a_startValue, "0.0");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           DAE.T_BOOL(varLst = _),
           a_attrstr,
           _,
           _,
           _,
           _,
           a_startValue,
           _,
           a_isFixed )
      equation
        txt = Tpl.writeStr(txt, a_attrstr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".fixed = "));
        txt = fun_618(txt, a_isFixed);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.writeStr(txt, a_attrstr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".start = "));
        txt = optInitValFMU(txt, a_startValue, "0");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           DAE.T_STRING(varLst = _),
           a_attrstr,
           _,
           _,
           _,
           _,
           a_startValue,
           _,
           _ )
      equation
        txt = Tpl.writeStr(txt, a_attrstr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".start = "));
        txt = optInitValFMU(txt, a_startValue, "mmc_mk_scon(\"\")");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           DAE.T_ENUMERATION(names = i_names),
           a_attrstr,
           _,
           _,
           a_minValue,
           a_maxValue,
           a_startValue,
           _,
           a_isFixed )
      equation
        txt = Tpl.writeStr(txt, a_attrstr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".min = "));
        txt = optInitValFMU(txt, a_minValue, "1");
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.writeStr(txt, a_attrstr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".max = "));
        ret_2 = listLength(i_names);
        txt = optInitValFMU(txt, a_maxValue, intString(ret_2));
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.writeStr(txt, a_attrstr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".fixed = "));
        txt = fun_619(txt, a_isFixed);
        txt = Tpl.writeTok(txt, Tpl.ST_LINE(";\n"));
        txt = Tpl.writeStr(txt, a_attrstr);
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(".start = "));
        txt = optInitValFMU(txt, a_startValue, "0");
        txt = Tpl.writeTok(txt, Tpl.ST_STRING(";"));
      then txt;

    case ( txt,
           i_type__,
           _,
           _,
           _,
           _,
           _,
           _,
           _,
           _ )
      equation
        txt_3 = Tpl.writeTok(Tpl.emptyTxt, Tpl.ST_STRING("ScalarVariableTypeFMU: "));
        ret_3 = Types.unparseType(i_type__);
        txt_3 = Tpl.writeStr(txt_3, ret_3);
        txt = CodegenUtil.error(txt, Tpl.sourceInfo("CodegenFMU.tpl", 3211, 16), Tpl.textString(txt_3));
      then txt;
  end match;
end fun_620;

public function ScalarVariableTypeFMU
  input Tpl.Text txt;
  input String a_attrstr;
  input String a_unit;
  input String a_displayUnit;
  input Option<DAE.Exp> a_minValue;
  input Option<DAE.Exp> a_maxValue;
  input Option<DAE.Exp> a_startValue;
  input Option<DAE.Exp> a_nominalValue;
  input Boolean a_isFixed;
  input DAE.Type a_type__;

  output Tpl.Text out_txt;
algorithm
  out_txt := fun_620(txt, a_type__, a_attrstr, a_unit, a_displayUnit, a_minValue, a_maxValue, a_startValue, a_nominalValue, a_isFixed);
end ScalarVariableTypeFMU;

annotation(__OpenModelica_Interface="backend");
end CodegenFMU;